/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(Q){for(var e=[],i=0,R=Q.length;i<R;i++)e[i]=oe[Q[i]];return e};define(oe[136],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=i,e.$gb=R,e.$hb=S,e.$ib=M,e.$jb=P,e.$kb=E,e.$lb=h,e.$nb=g,e.$ob=y,e.$pb=k,e.$qb=w,e.$rb=m;function i(v,p,$){const f=R(v,p);if(f!==-1)return v[f]}function R(v,p,$=v.length-1){for(let f=$;f>=0;f--){const l=v[f];if(p(l))return f}return-1}function S(v,p){const $=M(v,p);return $===-1?void 0:v[$]}function M(v,p,$=0,f=v.length){let l=$,d=f;for(;l<d;){const a=Math.floor((l+d)/2);p(v[a])?l=a+1:d=a}return l-1}function P(v,p){const $=E(v,p);return $===v.length?void 0:v[$]}function E(v,p,$=0,f=v.length){let l=$,d=f;for(;l<d;){const a=Math.floor((l+d)/2);p(v[a])?d=a:l=a+1}return l}function h(v,p,$=0,f=v.length){const l=E(v,p,$,f);return l===v.length?-1:l}class u{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(u.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const $=M(this.e,p,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=u;function g(v,p){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const l=v[f];p(l,$)>0&&($=l)}return $}function y(v,p){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const l=v[f];p(l,$)>=0&&($=l)}return $}function k(v,p){return g(v,($,f)=>-p($,f))}function w(v,p){if(v.length===0)return-1;let $=0;for(let f=1;f<v.length;f++){const l=v[f];p(l,v[$])>0&&($=f)}return $}function m(v,p){for(const $ of v){const f=p($);if(f!==void 0)return f}}}),define(oe[137],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=i,e.$L=R,e.$M=S,e.$N=M;function i(P,E){const h=Object.create(null);for(const u of P){const g=E(u);let y=h[g];y||(y=h[g]=[]),y.push(u)}return h}function R(P,E){const h=[],u=[];for(const g of P)E.has(g)||h.push(g);for(const g of E)P.has(g)||u.push(g);return{removed:h,added:u}}function S(P,E){const h=[],u=[];for(const[g,y]of P)E.has(g)||h.push(y);for(const[g,y]of E)P.has(g)||u.push(y);return{removed:h,added:u}}function M(P,E){const h=new Set;for(const u of E)P.has(u)&&h.add(u);return h}}),define(oe[138],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=e.$At=e.$zt=void 0;function i(E,h){const u=Math.pow(10,h);return Math.round(E*u)/u}class R{constructor(h,u,g,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=i(Math.max(Math.min(1,y),0),3)}static equals(h,u){return h.r===u.r&&h.g===u.g&&h.b===u.b&&h.a===u.a}}e.$zt=R;class S{constructor(h,u,g,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,g),0),3),this.a=i(Math.max(Math.min(1,y),0),3)}static equals(h,u){return h.h===u.h&&h.s===u.s&&h.l===u.l&&h.a===u.a}static fromRGBA(h){const u=h.r/255,g=h.g/255,y=h.b/255,k=h.a,w=Math.max(u,g,y),m=Math.min(u,g,y);let v=0,p=0;const $=(m+w)/2,f=w-m;if(f>0){switch(p=Math.min($<=.5?f/(2*$):f/(2-2*$),1),w){case u:v=(g-y)/f+(g<y?6:0);break;case g:v=(y-u)/f+2;break;case y:v=(u-g)/f+4;break}v*=60,v=Math.round(v)}return new S(v,p,$,k)}static i(h,u,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?h+(u-h)*6*g:g<1/2?u:g<2/3?h+(u-h)*(2/3-g)*6:h}static toRGBA(h){const u=h.h/360,{s:g,l:y,a:k}=h;let w,m,v;if(g===0)w=m=v=y;else{const p=y<.5?y*(1+g):y+g-y*g,$=2*y-p;w=S.i($,p,u+1/3),m=S.i($,p,u),v=S.i($,p,u-1/3)}return new R(Math.round(w*255),Math.round(m*255),Math.round(v*255),k)}}e.$At=S;class M{constructor(h,u,g,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,g),0),3),this.a=i(Math.max(Math.min(1,y),0),3)}static equals(h,u){return h.h===u.h&&h.s===u.s&&h.v===u.v&&h.a===u.a}static fromRGBA(h){const u=h.r/255,g=h.g/255,y=h.b/255,k=Math.max(u,g,y),w=Math.min(u,g,y),m=k-w,v=k===0?0:m/k;let p;return m===0?p=0:k===u?p=((g-y)/m%6+6)%6:k===g?p=(y-u)/m+2:p=(u-g)/m+4,new M(Math.round(p*60),v,k,h.a)}static toRGBA(h){const{h:u,s:g,v:y,a:k}=h,w=y*g,m=w*(1-Math.abs(u/60%2-1)),v=y-w;let[p,$,f]=[0,0,0];return u<60?(p=w,$=m):u<120?(p=m,$=w):u<180?($=w,f=m):u<240?($=m,f=w):u<300?(p=m,f=w):u<=360&&(p=w,f=m),p=Math.round((p+v)*255),$=Math.round(($+v)*255),f=Math.round((f+v)*255),new R(p,$,f,k)}}e.$Bt=M;class P{static fromHex(h){return P.Format.CSS.parseHex(h)||P.red}static equals(h,u){return!h&&!u?!0:!h||!u?!1:h.equals(u)}get hsla(){return this.i?this.i:S.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof R)this.rgba=h;else if(h instanceof S)this.i=h,this.rgba=S.toRGBA(h);else if(h instanceof M)this.j=h,this.rgba=M.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&R.equals(this.rgba,h.rgba)&&S.equals(this.hsla,h.hsla)&&M.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=P.k(this.rgba.r),u=P.k(this.rgba.g),g=P.k(this.rgba.b),y=.2126*h+.7152*u+.0722*g;return i(y,4)}static k(h){const u=h/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(h){const u=this.getRelativeLuminance(),g=h.getRelativeLuminance();return u>g?(u+.05)/(g+.05):(g+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const u=this.getRelativeLuminance(),g=h.getRelativeLuminance();return u>g}isDarkerThan(h){const u=this.getRelativeLuminance(),g=h.getRelativeLuminance();return u<g}lighten(h){return new P(new S(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new P(new S(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:u,g,b:y,a:k}=this.rgba;return new P(new R(u,g,y,k*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new P(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const u=h.rgba,g=this.rgba.a,y=u.a,k=g+y*(1-g);if(k<1e-6)return P.transparent;const w=this.rgba.r*g/k+u.r*y*(1-g)/k,m=this.rgba.g*g/k+u.g*y*(1-g)/k,v=this.rgba.b*g/k+u.b*y*(1-g)/k;return new P(new R(w,m,v,k))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:u,g,b:y,a:k}=this.rgba;return new P(new R(h.rgba.r-k*(h.rgba.r-u),h.rgba.g-k*(h.rgba.g-g),h.rgba.b-k*(h.rgba.b-y),1))}flatten(...h){const u=h.reduceRight((g,y)=>P.o(y,g));return P.o(this,u)}static o(h,u){const g=1-h.rgba.a;return new P(new R(g*u.rgba.r+h.rgba.a*h.rgba.r,g*u.rgba.g+h.rgba.a*h.rgba.g,g*u.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=P.Format.CSS.format(this)),this.u}static getLighterColor(h,u,g){if(h.isLighterThan(u))return h;g=g||.5;const y=h.getRelativeLuminance(),k=u.getRelativeLuminance();return g=g*(k-y)/k,h.lighten(g)}static getDarkerColor(h,u,g){if(h.isDarkerThan(u))return h;g=g||.5;const y=h.getRelativeLuminance(),k=u.getRelativeLuminance();return g=g*(y-k)/y,h.darken(g)}static{this.white=new P(new R(255,255,255,1))}static{this.black=new P(new R(0,0,0,1))}static{this.red=new P(new R(255,0,0,1))}static{this.blue=new P(new R(0,0,255,1))}static{this.green=new P(new R(0,255,0,1))}static{this.cyan=new P(new R(0,255,255,1))}static{this.lightgrey=new P(new R(211,211,211,1))}static{this.transparent=new P(new R(0,0,0,0))}}e.$Ct=P,function(E){let h;(function(u){let g;(function(y){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}y.formatRGB=k;function w(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=w;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}y.formatHSL=m;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function p(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}y.formatHex=$;function f(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function l(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}y.format=l;function d(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),n=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),r=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new R(s,n,r,1))}if(o===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),n=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),r=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),c=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new R(s,n,r,c/255))}if(o===4){const s=a(t.charCodeAt(1)),n=a(t.charCodeAt(2)),r=a(t.charCodeAt(3));return new E(new R(16*s+s,16*n+n,16*r+r))}if(o===5){const s=a(t.charCodeAt(1)),n=a(t.charCodeAt(2)),r=a(t.charCodeAt(3)),c=a(t.charCodeAt(4));return new E(new R(16*s+s,16*n+n,16*r+r,(16*c+c)/255))}return null}y.parseHex=d;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=u.CSS||(u.CSS={}))})(h=E.Format||(E.Format={}))}(P||(e.$Ct=P={}))}),define(oe[51],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=R,e.$Sh=S,e.$Th=M;function i(P){return(E,h,u)=>{let g=null,y=null;if(typeof u.value=="function"?(g="value",y=u.value):typeof u.get=="function"&&(g="get",y=u.get),!y)throw new Error("not supported");u[g]=P(y,h)}}function R(P,E,h){let u=null,g=null;if(typeof h.value=="function"?(u="value",g=h.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(u="get",g=h.get),!g)throw new Error("not supported");const y=`$memoize$${E}`;h[u]=function(...k){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,k)}),this[y]}}function S(P,E,h){return i((u,g)=>{const y=`$debounce$${g}`,k=`$debounce$result$${g}`;return function(...w){this[k]||(this[k]=h?h():void 0),clearTimeout(this[y]),E&&(this[k]=E(this[k],...w),w=[this[k]]),this[y]=setTimeout(()=>{u.apply(this,w),this[k]=h?h():void 0},P)}})}function M(P,E,h){return i((u,g)=>{const y=`$throttle$timer$${g}`,k=`$throttle$result$${g}`,w=`$throttle$lastRun$${g}`,m=`$throttle$pending$${g}`;return function(...v){if(this[k]||(this[k]=h?h():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...v)),this[m])return;const p=this[w]+P;p<=Date.now()?(this[w]=Date.now(),u.apply(this,[this[k]]),this[k]=h?h():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),u.apply(this,[this[k]]),this[k]=h?h():void 0},p-Date.now()))}})}}),define(oe[15],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=R,e.$Z=S,e.$1=M,e.$2=P,e.$3=E,e.$4=u,e.$6=y,e.$7=k,e.$8=w,e.$0=v;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?l.isErrorNoTelemetry(t)?new l(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=i,e.$X=new i;function R(a){e.$X.setUnexpectedErrorHandler(a)}function S(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(a){u(a)||e.$X.onUnexpectedError(a)}function P(a){u(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:o}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:l.isErrorNoTelemetry(a)}}return a}const h="Canceled";function u(a){return a instanceof g?!0:a instanceof Error&&a.name===h&&a.message===h}class g extends Error{constructor(){super(h),this.name=this.message}}e.$5=g;function y(){const a=new Error(h);return a.name=a.message,a}function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function w(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class l extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof l)return t;const o=new l;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=l;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(oe[22],ae([0,1,15,136]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=S,e.$tb=M,e.$ub=P,e.$vb=E,e.$wb=h,e.$xb=u,e.$yb=g,e.$zb=y,e.$Ab=k,e.$Bb=w,e.$Cb=m,e.$Db=v,e.$Eb=p,e.top=$,e.$Gb=f,e.$Hb=d,e.$Ib=a,e.$Jb=t,e.$Kb=o,e.$Lb=s,e.$Mb=n,e.$Nb=r,e.$Ob=c,e.$Pb=b,e.$Qb=I,e.$Rb=D,e.$Sb=j,e.$Tb=A,e.$Ub=C,e.$Vb=W,e.$Wb=T,e.$Xb=N,e.$Yb=U,e.$Zb=ue,e.$1b=ie,e.$2b=le,e.$3b=Y,e.$4b=K,e.$5b=B,e.$6b=L,e.$7b=z,e.$8b=ce,e.$$b=O;function S(J,x=0){return J[J.length-(1+x)]}function M(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function P(J,x,V=(q,re)=>q===re){if(J===x)return!0;if(!J||!x||J.length!==x.length)return!1;for(let q=0,re=J.length;q<re;q++)if(!V(J[q],x[q]))return!1;return!0}function E(J,x){const V=J.length-1;x<V&&(J[x]=J[V]),J.pop()}function h(J,x,V){return u(J.length,q=>V(J[q],x))}function u(J,x){let V=0,q=J-1;for(;V<=q;){const re=(V+q)/2|0,ee=x(re);if(ee<0)V=re+1;else if(ee>0)q=re-1;else return re}return-(V+1)}function g(J,x,V){if(J=J|0,J>=x.length)throw new TypeError("invalid index");const q=x[Math.floor(x.length*Math.random())],re=[],ee=[],fe=[];for(const me of x){const ve=V(me,q);ve<0?re.push(me):ve>0?ee.push(me):fe.push(me)}return J<re.length?g(J,re,V):J<re.length+fe.length?fe[0]:g(J-(re.length+fe.length),ee,V)}function y(J,x){const V=[];let q;for(const re of J.slice(0).sort(x))!q||x(q[0],re)!==0?(q=[re],V.push(q)):q.push(re);return V}function*k(J,x){let V,q;for(const re of J)q!==void 0&&x(q,re)?V.push(re):(V&&(yield V),V=[re]),q=re;V&&(yield V)}function w(J,x){for(let V=0;V<=J.length;V++)x(V===0?void 0:J[V-1],V===J.length?void 0:J[V])}function m(J,x){for(let V=0;V<J.length;V++)x(V===0?void 0:J[V-1],J[V],V+1===J.length?void 0:J[V+1])}function v(J,x,V){const q=[];function re(me,ve,ke){if(ve===0&&ke.length===0)return;const Ie=q[q.length-1];Ie&&Ie.start+Ie.deleteCount===me?(Ie.deleteCount+=ve,Ie.toInsert.push(...ke)):q.push({start:me,deleteCount:ve,toInsert:ke})}let ee=0,fe=0;for(;;){if(ee===J.length){re(ee,0,x.slice(fe));break}if(fe===x.length){re(ee,J.length-ee,[]);break}const me=J[ee],ve=x[fe],ke=V(me,ve);ke===0?(ee+=1,fe+=1):ke<0?(re(ee,1,[]),ee+=1):ke>0&&(re(ee,0,[ve]),fe+=1)}return q}function p(J,x,V){const q=v(J,x,V),re=[],ee=[];for(const fe of q)re.push(...J.slice(fe.start,fe.start+fe.deleteCount)),ee.push(...fe.toInsert);return{removed:re,added:ee}}function $(J,x,V){if(V===0)return[];const q=J.slice(0,V).sort(x);return l(J,x,q,V,J.length),q}function f(J,x,V,q,re){return V===0?Promise.resolve([]):new Promise((ee,fe)=>{(async()=>{const me=J.length,ve=J.slice(0,V).sort(x);for(let ke=V,Ie=Math.min(V+q,me);ke<me;ke=Ie,Ie=Math.min(Ie+q,me)){if(ke>V&&await new Promise(Fe=>setTimeout(Fe)),re&&re.isCancellationRequested)throw new i.$5;l(J,x,ve,ke,Ie)}return ve})().then(ee,fe)})}function l(J,x,V,q,re){for(const ee=V.length;q<re;q++){const fe=J[q];if(x(fe,V[ee-1])<0){V.pop();const me=(0,R.$kb)(V,ve=>x(fe,ve)<0);V.splice(me,0,fe)}}}function d(J){return J.filter(x=>!!x)}function a(J){let x=0;for(let V=0;V<J.length;V++)J[V]&&(J[x]=J[V],x+=1);J.length=x}function t(J,x,V){J.splice(V,0,J.splice(x,1)[0])}function o(J){return!Array.isArray(J)||J.length===0}function s(J){return Array.isArray(J)&&J.length>0}function n(J,x=V=>V){const V=new Set;return J.filter(q=>{const re=x(q);return V.has(re)?!1:(V.add(re),!0)})}function r(J){const x=new Set;return V=>{const q=J(V);return x.has(q)?!1:(x.add(q),!0)}}function c(J,x){return J.length>0?J[0]:x}function b(J,x){return J.length>0?J[J.length-1]:x}function I(J,x,V=(q,re)=>q===re){let q=0;for(let re=0,ee=Math.min(J.length,x.length);re<ee&&V(J[re],x[re]);re++)q++;return q}function D(J){return[].concat(...J)}function j(J,x){let V=typeof x=="number"?J:0;typeof x=="number"?V=J:(V=0,x=J);const q=[];if(V<=x)for(let re=V;re<x;re++)q.push(re);else for(let re=V;re>x;re--)q.push(re);return q}function A(J,x,V){return J.reduce((q,re)=>(q[x(re)]=V?V(re):re,q),Object.create(null))}function C(J,x){return J.push(x),()=>W(J,x)}function W(J,x){const V=J.indexOf(x);if(V>-1)return J.splice(V,1),x}function T(J,x,V){const q=J.slice(0,x),re=J.slice(x);return q.concat(V,re)}function N(J,x){let V;if(typeof x=="number"){let q=x;V=()=>{const re=Math.sin(q++)*179426549;return re-Math.floor(re)}}else V=Math.random;for(let q=J.length-1;q>0;q-=1){const re=Math.floor(V()*(q+1)),ee=J[q];J[q]=J[re],J[re]=ee}}function U(J,x){const V=J.indexOf(x);V>-1&&(J.splice(V,1),J.unshift(x))}function ue(J,x){const V=J.indexOf(x);V>-1&&(J.splice(V,1),J.push(x))}function ie(J,x){for(const V of x)J.push(V)}function le(J,x){return Array.isArray(J)?J.map(x):x(J)}function Y(J){return Array.isArray(J)?J:[J]}function K(J){return J[Math.floor(Math.random()*J.length)]}function B(J,x,V){const q=H(J,x),re=J.length,ee=V.length;J.length=re+ee;for(let fe=re-1;fe>=q;fe--)J[fe+ee]=J[fe];for(let fe=0;fe<ee;fe++)J[fe+q]=V[fe]}function L(J,x,V,q){const re=H(J,x);let ee=J.splice(re,V);return ee===void 0&&(ee=[]),B(J,re,q),ee}function H(J,x){return x<0?Math.max(x+J.length,0):Math.min(x,J.length)}var G;(function(J){function x(ee){return ee<0}J.isLessThan=x;function V(ee){return ee<=0}J.isLessThanOrEqual=V;function q(ee){return ee>0}J.isGreaterThan=q;function re(ee){return ee===0}J.isNeitherLessOrGreaterThan=re,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function z(J,x){return(V,q)=>x(J(V),J(q))}function ce(...J){return(x,V)=>{for(const q of J){const re=q(x,V);if(!G.isNeitherLessOrGreaterThan(re))return re}return G.neitherLessOrGreaterThan}}const he=(J,x)=>J-x;e.$9b=he;const X=(J,x)=>(0,e.$9b)(J?1:0,x?1:0);e.$0b=X;function O(J){return(x,V)=>-J(x,V)}class F{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let V=this.c;for(;V<this.g.length&&x(this.g[V]);)V++;const q=V===this.c?null:this.g.slice(this.c,V);return this.c=V,q}takeFromEndWhile(x){let V=this.d;for(;V>=0&&x(this.g[V]);)V--;const q=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const V=this.g.slice(this.c,this.c+x);return this.c+=x,V}}e.$_b=F;class _{static{this.empty=new _(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(V=>(x(V),!0))}toArray(){const x=[];return this.iterate(V=>(x.push(V),!0)),x}filter(x){return new _(V=>this.iterate(q=>x(q)?V(q):!0))}map(x){return new _(V=>this.iterate(q=>V(x(q))))}some(x){let V=!1;return this.iterate(q=>(V=x(q),!V)),V}findFirst(x){let V;return this.iterate(q=>x(q)?(V=q,!1):!0),V}findLast(x){let V;return this.iterate(q=>(x(q)&&(V=q),!0)),V}findLastMaxBy(x){let V,q=!0;return this.iterate(re=>((q||G.isGreaterThan(x(re,V)))&&(q=!1,V=re),!0)),V}}e.$ac=_;class se{constructor(x){this.c=x}static createSortPermutation(x,V){const q=Array.from(x.keys()).sort((re,ee)=>V(x[re],x[ee]));return new se(q)}apply(x){return x.map((V,q)=>x[this.c[q]])}inverse(){const x=this.c.slice();for(let V=0;V<this.c.length;V++)x[this.c[V]]=V;return new se(x)}}e.$bc=se}),define(oe[139],ae([0,1,15]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.$cd=S,e.$dd=M,e.$ed=P,e.$fd=E,e.$gd=h;function R(u,g){if(!u)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function S(u,g="Unreachable"){throw new Error(g)}function M(u){if(!u)throw new i.$cb("Assertion Failed")}function P(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function E(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function h(u,g){let y=0;for(;y<u.length-1;){const k=u[y],w=u[y+1];if(!g(k,w))return!1;y++}return!0}}),define(oe[86],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=i;function i(R,S){const M=this;let P=!1,E;return function(){if(P)return E;if(P=!0,S)try{E=R.apply(M,arguments)}finally{S()}else E=R.apply(M,arguments);return E}}}),define(oe[71],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(R){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=S;const M=Object.freeze([]);function P(){return M}R.empty=P;function*E(t){yield t}R.single=E;function h(t){return S(t)?t:E(t)}R.wrap=h;function u(t){return t||M}R.from=u;function*g(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=g;function y(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=y;function k(t){return t[Symbol.iterator]().next().value}R.first=k;function w(t,o){for(const s of t)if(o(s))return!0;return!1}R.some=w;function m(t,o){for(const s of t)if(o(s))return s}R.find=m;function*v(t,o){for(const s of t)o(s)&&(yield s)}R.filter=v;function*p(t,o){let s=0;for(const n of t)yield o(n,s++)}R.map=p;function*$(...t){for(const o of t)yield*o}R.concat=$;function f(t,o,s){let n=s;for(const r of t)n=o(n,r);return n}R.reduce=f;function*l(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}R.slice=l;function d(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const n=t[Symbol.iterator]();for(let r=0;r<o;r++){const c=n.next();if(c.done)return[s,R.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}R.consume=d;async function a(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}R.asyncToArray=a})(i||(e.Iterable=i={}))}),define(oe[42],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=P,e.$zn=y,e.$An=k,e.$Bn=w,e.$Cn=m,e.$Dn=v,e.$En=p,e.$Fn=$,e.$Gn=f,e.$Hn=l,e.$In=d,e.$Jn=a;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function P(t,o=!1){let s=0;const n=t.length;let r="",c=0,b=16,I=0;function D(U){let ue=0,ie=0;for(;ue<U;){const le=t.charCodeAt(s);if(le>=48&&le<=57)ie=ie*16+le-48;else if(le>=65&&le<=70)ie=ie*16+le-65+10;else if(le>=97&&le<=102)ie=ie*16+le-97+10;else break;s++,ue++}return ue<U&&(ie=-1),ie}function j(U){s=U,r="",c=0,b=16,I=0}function A(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&u(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&u(t.charCodeAt(s)))for(s++;s<t.length&&u(t.charCodeAt(s));)s++;else return I=3,t.substring(U,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&u(t.charCodeAt(s))){for(s++;s<t.length&&u(t.charCodeAt(s));)s++;ue=s}else I=3;return t.substring(U,ue)}function C(){let U="",ue=s;for(;;){if(s>=n){U+=t.substring(ue,s),I=2;break}const ie=t.charCodeAt(s);if(ie===34){U+=t.substring(ue,s),s++;break}if(ie===92){if(U+=t.substring(ue,s),s++,s>=n){I=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const Y=D(4);Y>=0?U+=String.fromCharCode(Y):I=4;break}default:I=5}ue=s;continue}if(ie>=0&&ie<=31)if(h(ie)){U+=t.substring(ue,s),I=2;break}else I=6;s++}return U}function W(){if(r="",I=0,c=s,s>=n)return c=n,b=17;let U=t.charCodeAt(s);if(E(U)){do s++,r+=String.fromCharCode(U),U=t.charCodeAt(s);while(E(U));return b=15}if(h(U))return s++,r+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),b=14;switch(U){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,r=C(),b=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!h(t.charCodeAt(s));)s++;return r=t.substring(ue,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const ie=n-1;let le=!1;for(;s<ie;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,le=!0;break}s++}return le||(s++,I=1),r=t.substring(ue,s),b=13}return r+=String.fromCharCode(U),s++,b=16}case 45:if(r+=String.fromCharCode(U),s++,s===n||!u(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=A(),b=11;default:for(;s<n&&T(U);)s++,U=t.charCodeAt(s);if(c!==s){switch(r=t.substring(c,s),r){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return r+=String.fromCharCode(U),s++,b=16}}function T(U){if(E(U)||h(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:j,getPosition:()=>s,scan:o?N:W,getToken:()=>b,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>I}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function y(t,o){const s=[],n=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function I(D,j,A,C){c.value=D,c.offset=j,c.length=A,c.type=C,c.colonOffset=void 0,r=c}try{l(t,{onObjectBegin:(D,j)=>{if(o<=D)throw n;r=void 0,b=o>D,s.push("")},onObjectProperty:(D,j,A)=>{if(o<j||(I(D,j,A,"property"),s[s.length-1]=D,o<=j+A))throw n},onObjectEnd:(D,j)=>{if(o<=D)throw n;r=void 0,s.pop()},onArrayBegin:(D,j)=>{if(o<=D)throw n;r=void 0,s.push(0)},onArrayEnd:(D,j)=>{if(o<=D)throw n;r=void 0,s.pop()},onLiteralValue:(D,j,A)=>{if(o<j||(I(D,j,A,a(D)),o<=j+A))throw n},onSeparator:(D,j,A)=>{if(o<=j)throw n;if(D===":"&&r&&r.type==="property")r.colonOffset=j,b=!1,r=void 0;else if(D===","){const C=s[s.length-1];typeof C=="number"?s[s.length-1]=C+1:(b=!0,s[s.length-1]=""),r=void 0}}})}catch(D){if(D!==n)throw D}return{path:s,previousNode:r,isAtPropertyKey:b,matches:D=>{let j=0;for(let A=0;j<D.length&&A<s.length;A++)if(D[j]===s[A]||D[j]==="*")j++;else if(D[j]!=="**")return!1;return j===D.length}}}function k(t,o=[],s=M.DEFAULT){let n=null,r=[];const c=[];function b(D){Array.isArray(r)?r.push(D):n!==null&&(r[n]=D)}return l(t,{onObjectBegin:()=>{const D={};b(D),c.push(r),r=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const D=[];b(D),c.push(r),r=D,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:b,onError:(D,j,A)=>{o.push({error:D,offset:j,length:A})}},s),r[0]}function w(t,o=[],s=M.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function c(D){return n.children.push(D),D}l(t,{onObjectBegin:D=>{n=c({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,j,A)=>{n=c({type:"property",offset:j,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:j,length:A,parent:n})},onObjectEnd:(D,j)=>{n.length=D+j-n.offset,n=n.parent,r(D+j)},onArrayBegin:(D,j)=>{n=c({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,j)=>{n.length=D+j-n.offset,n=n.parent,r(D+j)},onLiteralValue:(D,j,A)=>{c({type:a(D),offset:j,length:A,parent:n,value:D}),r(j+A)},onSeparator:(D,j,A)=>{n.type==="property"&&(D===":"?n.colonOffset=j:D===","&&r(j))},onError:(D,j,A)=>{o.push({error:D,offset:j,length:A})}},s);const I=n.children[0];return I&&delete I.parent,I}function m(t,o){if(!t)return;let s=t;for(const n of o)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===n){s=c.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const o=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(o[s.children[0].value]=p(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}function f(t,o,s=!1){if($(t,o,s)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=o;r++){const c=f(n[r],o,s);if(c)return c}return t}}function l(t,o,s=M.DEFAULT){const n=P(t,!1);function r(z){return z?()=>z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(z){return z?ce=>z(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const b=r(o.onObjectBegin),I=c(o.onObjectProperty),D=r(o.onObjectEnd),j=r(o.onArrayBegin),A=r(o.onArrayEnd),C=c(o.onLiteralValue),W=c(o.onSeparator),T=r(o.onComment),N=c(o.onError),U=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function ie(){for(;;){const z=n.scan();switch(n.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:U||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(z){case 12:case 13:U?le(10):T();break;case 16:le(1);break;case 15:case 14:break;default:return z}}}function le(z,ce=[],he=[]){if(N(z),ce.length+he.length>0){let X=n.getToken();for(;X!==17;){if(ce.indexOf(X)!==-1){ie();break}else if(he.indexOf(X)!==-1)break;X=ie()}}}function Y(z){const ce=n.getTokenValue();return z?C(ce):I(ce),ie(),!0}function K(){switch(n.getToken()){case 11:{let z=0;try{z=JSON.parse(n.getTokenValue()),typeof z!="number"&&(le(2),z=0)}catch{le(2)}C(z);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return ie(),!0}function B(){return n.getToken()!==10?(le(3,[],[2,5]),!1):(Y(!1),n.getToken()===6?(W(":"),ie(),G()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function L(){b(),ie();let z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(z||le(4,[],[]),W(","),ie(),n.getToken()===2&&ue)break}else z&&le(6,[],[]);B()||le(4,[],[2,5]),z=!0}return D(),n.getToken()!==2?le(7,[2],[]):ie(),!0}function H(){j(),ie();let z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(z||le(4,[],[]),W(","),ie(),n.getToken()===4&&ue)break}else z&&le(6,[],[]);G()||le(4,[],[4,5]),z=!0}return A(),n.getToken()!==4?le(8,[4],[]):ie(),!0}function G(){switch(n.getToken()){case 3:return H();case 1:return L();case 10:return Y(!0);default:return K()}}return ie(),n.getToken()===17?s.allowEmptyContent?!0:(le(4,[],[]),!1):G()?(n.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}function d(t,o){const s=P(t),n=[];let r,c=0,b;do switch(b=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:c!==b&&n.push(t.substring(c,b)),o!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,o)),c=s.getPosition();break}while(r!==17);return n.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[140],ae([0,1,42]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=R,e.$Ln=S,e.$Mn=E,e.$Nn=h;function R(u,g,y){let k,w,m,v,p;if(g){for(v=g.offset,p=v+g.length,m=v;m>0&&!h(u,m-1);)m--;let b=p;for(;b<u.length&&!h(u,b);)b++;w=u.substring(m,b),k=P(w,y)}else w=u,k=0,m=0,v=0,p=u.length;const $=E(y,u);let f=!1,l=0,d;y.insertSpaces?d=M(" ",y.tabSize||4):d="	";const a=(0,i.$yn)(w,!1);let t=!1;function o(){return $+M(d,k+l)}function s(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const n=[];function r(b,I,D){!t&&I<p&&D>v&&u.substring(I,D)!==b&&n.push({offset:I,length:D-I,content:b})}let c=s();if(c!==17){const b=a.getTokenOffset()+m,I=M(d,k);r(I,m,b)}for(;c!==17;){let b=a.getTokenOffset()+a.getTokenLength()+m,I=s(),D="";for(;!f&&(I===12||I===13);){const A=a.getTokenOffset()+m;r(" ",b,A),b=a.getTokenOffset()+a.getTokenLength()+m,D=I===12?o():"",I=s()}if(I===2)c!==1&&(l--,D=o());else if(I===4)c!==3&&(l--,D=o());else{switch(c){case 3:case 1:l++,D=o();break;case 5:case 12:D=o();break;case 13:f?D=o():D=" ";break;case 6:D=" ";break;case 10:if(I===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?D=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}f&&(I===12||I===13)&&(D=o())}const j=a.getTokenOffset()+m;r(D,b,j),c=I}return n}function S(u,g){const y=JSON.stringify(u,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?y.replace(/\r\n|\r|\n/g,g.eol):y}function M(u,g){let y="";for(let k=0;k<g;k++)y+=u;return y}function P(u,g){let y=0,k=0;const w=g.tabSize||4;for(;y<u.length;){const m=u.charAt(y);if(m===" ")k++;else if(m==="	")k+=w;else break;y++}return Math.floor(k/w)}function E(u,g){for(let y=0;y<g.length;y++){const k=g.charAt(y);if(k==="\r")return y+1<g.length&&g.charAt(y+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return u&&u.eol||`
`}function h(u,g){return`\r
`.indexOf(u.charAt(g))!==-1}}),define(oe[103],ae([0,1,42,140]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=S,e.$Pn=M,e.$Qn=P,e.$Rn=E,e.$Sn=h;function S(u,g,y){return M(u,g,void 0,y)}function M(u,g,y,k,w){const m=g.slice(),v=[],p=(0,i.$Bn)(u,v);let $,f;for(;m.length>0&&(f=m.pop(),$=(0,i.$Cn)(p,m),$===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if($)if($.type==="object"&&typeof f=="string"&&Array.isArray($.children)){const l=(0,i.$Cn)($,[f]);if(l!==void 0)if(y===void 0){if(!l.parent)throw new Error("Malformed AST");const d=$.children.indexOf(l.parent);let a,t=l.parent.offset+l.parent.length;if(d>0){const o=$.children[d-1];a=o.offset+o.length}else a=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return P(u,{offset:a,length:t-a,content:""},k)}else return P(u,{offset:l.offset,length:l.length,content:JSON.stringify(y)},k);else{if(y===void 0)return[];const d=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=w?w($.children.map(o=>o.children[0].value)):$.children.length;let t;if(a>0){const o=$.children[a-1];t={offset:o.offset+o.length,length:0,content:","+d}}else $.children.length===0?t={offset:$.offset+1,length:0,content:d}:t={offset:$.offset+1,length:0,content:d+","};return P(u,t,k)}}else if($.type==="array"&&typeof f=="number"&&Array.isArray($.children))if(y!==void 0){const l=`${JSON.stringify(y)}`;let d;if($.children.length===0||f===0)d={offset:$.offset+1,length:0,content:$.children.length===0?l:l+","};else{const a=f===-1||f>$.children.length?$.children.length:f,t=$.children[a-1];d={offset:t.offset+t.length,length:0,content:","+l}}return P(u,d,k)}else{const l=f,d=$.children[l];let a;if($.children.length===1)a={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===l){const t=$.children[l-1],o=t.offset+t.length,s=$.offset+$.length;a={offset:o,length:s-2-o,content:""}}else a={offset:d.offset,length:$.children[l+1].offset-d.offset,content:""};return P(u,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${$.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return P(u,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(y)},k)}}function P(u,g,y){let k=E(u,g),w=g.offset,m=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;w>0&&!(0,R.$Nn)(k,w-1);)w--;for(;m<k.length&&!(0,R.$Nn)(k,m);)m++}const v=(0,R.$Kn)(k,{offset:w,length:m-w},y);for(let $=v.length-1;$>=0;$--){const f=v[$];k=E(k,f),w=Math.min(w,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const p=u.length-(k.length-m)-w;return[{offset:w,length:p,content:k.substring(w,m)}]}function E(u,g){return u.substring(0,g.offset)+g.content+u.substring(g.offset+g.length)}function h(u,g){const y=g.slice(0).sort((w,m)=>{const v=w.offset-m.offset;return v===0?w.length-m.length:v});let k=u.length;for(let w=y.length-1;w>=0;w--){const m=y[w];if(m.offset+m.length<=k)u=E(u,m);else throw new Error("Overlapping edit");k=m.offset}return u}}),define(oe[62],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(oe[104],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(M){this.element=M,this.next=i.Undefined,this.prev=i.Undefined}}class R{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let M=this.a;for(;M!==i.Undefined;){const P=M.next;M.prev=i.Undefined,M.next=i.Undefined,M=P}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,P){const E=new i(M);if(this.a===i.Undefined)this.a=E,this.b=E;else if(P){const u=this.b;this.b=E,E.prev=u,u.next=E}else{const u=this.a;this.a=E,E.next=u,u.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==i.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==i.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==i.Undefined&&M.next!==i.Undefined){const P=M.prev;P.next=M.next,M.next.prev=P}else M.prev===i.Undefined&&M.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):M.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):M.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==i.Undefined;)yield M.element,M=M.next}}e.$5c=R}),define(oe[32],ae([0,1]),function(Q,e){"use strict";var i,R,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=P,e.$Ac=E,e.$Ic=f;function M(l,d,a){let t=l.get(d);return t===void 0&&(t=a,l.set(d,t)),t}function P(l){const d=[];return l.forEach((a,t)=>{d.push(`${t} => ${a}`)}),`Map(${l.size}) {${d.join(", ")}}`}function E(l){const d=[];return l.forEach(a=>{d.push(a)}),`Set(${l.size}) {${d.join(", ")}}`}class h{constructor(d,a){this.uri=d,this.value=a}}function u(l){return Array.isArray(l)}class g{static{this.c=d=>d.toString()}constructor(d,a){if(this[i]="ResourceMap",d instanceof g)this.d=new Map(d.d),this.e=a??g.c;else if(u(d)){this.d=new Map,this.e=a??g.c;for(const[t,o]of d)this.set(t,o)}else this.d=new Map,this.e=d??g.c}set(d,a){return this.d.set(this.e(d),new h(d,a)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,a){typeof a<"u"&&(d=d.bind(a));for(const[t,o]of this.d)d(o.value,o.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}e.$Bc=g;class y{constructor(d,a){this[R]="ResourceSet",!d||typeof d=="function"?this.c=new g(d):(this.c=new g(a),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,a){this.c.forEach((t,o)=>d.call(a,o,o,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var k;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class w{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,a=0){const t=this.c.get(d);if(t)return a!==0&&this.l(t,a),t.value}set(d,a,t=0){let o=this.c.get(d);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:d,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(d,o),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const a=this.c.get(d);if(a)return this.c.delete(d),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.k(d),this.f--,d.value}forEach(d,a){const t=this.g;let o=this.d;for(;o;){if(a?d.bind(a)(o.value,o.key,this):d(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}values(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}entries(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>d;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}j(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}k(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const a=d.next,t=d.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}d.next=void 0,d.previous=void 0,this.g++}l(d,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(d===this.d)return;const t=d.next,o=d.previous;d===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(a===2){if(d===this.e)return;const t=d.next,o=d.previous;d===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((a,t)=>{d.push([t,a])}),d}fromJSON(d){this.clear();for(const[a,t]of d)this.set(a,t)}}e.$Dc=w;class m extends w{constructor(d,a=1){super(),this.m=d,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(d){this.m=d,this.o()}get ratio(){return this.n}set ratio(d){this.n=Math.min(Math.max(0,d),1),this.o()}get(d,a=2){return super.get(d,a)}peek(d){return super.get(d,0)}set(d,a){return super.set(d,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=m;class v{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let a=this.c.get(d)||0;return a===0?!1:(a--,a===0?this.c.delete(d):this.c.set(d,a),!0)}has(d){return this.c.has(d)}}e.$Fc=v;class p{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[a,t]of d)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(d,a){this.c.set(d,a),this.d.set(a,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const a=this.c.get(d);return a===void 0?!1:(this.c.delete(d),this.d.delete(a),!0)}forEach(d,a){this.c.forEach((t,o)=>{d.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class ${constructor(){this.c=new Map}add(d,a){let t=this.c.get(d);t||(t=new Set,this.c.set(d,t)),t.add(a)}delete(d,a){const t=this.c.get(d);t&&(t.delete(a),t.size===0&&this.c.delete(d))}forEach(d,a){const t=this.c.get(d);t&&t.forEach(a)}get(d){const a=this.c.get(d);return a||new Set}}e.$Hc=$;function f(l,d){if(l===d)return!0;if(l.size!==d.size)return!1;for(const[a,t]of l)if(!d.has(a)||d.get(a)!==t)return!1;for(const[a]of d)if(!l.has(a))return!1;return!0}}),define(oe[2],ae([0,1,22,137,32,86,71]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=g,e.$Lc=y,e.$Mc=k,e.$Nc=v,e.$Oc=p,e.$Pc=$,e.$Qc=f,e.$Rc=l,e.$Sc=d,e.$3c=D;const E=!1;let h=null;class u{constructor(){this.b=new Map}static{this.a=0}c(C){let W=this.b.get(C);return W||(W={parent:null,source:null,isSingleton:!1,value:C,idx:u.a++},this.b.set(C,W)),W}trackDisposable(C){const W=this.c(C);W.source||(W.source=new Error().stack)}setParent(C,W){const T=this.c(C);T.parent=W}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,W){const T=W.get(C);if(T)return T;const N=C.parent?this.f(this.c(C.parent),W):C;return W.set(C,N),N}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,C).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(C=10,W){let T;if(W)T=W;else{const le=new Map,Y=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,le).isSingleton);if(Y.length===0)return;const K=new Set(Y.map(B=>B.value));if(T=Y.filter(B=>!(B.parent&&K.has(B.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function N(le){function Y(B,L){for(;B.length>0&&L.some(H=>typeof H=="string"?H===B[0]:B[0].match(H));)B.shift()}const K=le.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return Y(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const U=new S.$Hc;for(const le of T){const Y=N(le);for(let K=0;K<=Y.length;K++)U.add(Y.slice(0,K).join(`
`),le)}T.sort((0,i.$7b)(le=>le.idx,i.$9b));let ue="",ie=0;for(const le of T.slice(0,C)){ie++;const Y=N(le),K=[];for(let B=0;B<Y.length;B++){let L=Y[B];L=`(shared with ${U.get(Y.slice(0,B+1).join(`
`)).size}/${T.length} leaks) at ${L}`;const G=U.get(Y.slice(0,B).join(`
`)),z=(0,R.$K)([...G].map(ce=>N(ce)[B]),ce=>ce);delete z[Y[B]];for(const[ce,he]of Object.entries(z))K.unshift(`    - stacktraces of ${he.length} other leaks continue with ${ce}`);K.unshift(L)}ue+=`


==================== Leaking disposable ${ie}/${T.length}: ${le.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return T.length>C&&(ue+=`


... and ${T.length-C} more leaking disposables

`),{leaks:T,details:ue}}}e.$Jc=u;function g(A){h=A}if(E){const A="__is_disposable_tracked__";g(new class{trackDisposable(C){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[A]||console.log(W)},3e3)}setParent(C,W){if(C&&C!==t.None)try{C[A]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[A]=!0}catch{}}markAsSingleton(C){}})}function y(A){return h?.trackDisposable(A),A}function k(A){h?.markAsDisposed(A)}function w(A,C){h?.setParent(A,C)}function m(A,C){if(h)for(const W of A)h.setParent(W,C)}function v(A){return h?.markAsSingleton(A),A}function p(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function $(A){if(P.Iterable.is(A)){const C=[];for(const W of A)if(W)try{W.dispose()}catch(T){C.push(T)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function f(A){for(const C of A)p(C)&&C.dispose();return[]}function l(...A){const C=d(()=>$(A));return m(A,C),C}function d(A){const C=y({dispose:(0,M.$db)(()=>{k(C),A()})});return C}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return w(C,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),w(C,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),w(this.q,this)}dispose(){k(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&w(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&w(C,null),C}}e.$Vc=o;class s{constructor(C){this.a=new o,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class n{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=n;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(C){let W=C;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,k(this))},this}}e.$Yc=r;class c{constructor(){this.a=new Map}acquire(C,...W){let T=this.a.get(C);T||(T={counter:0,object:this.b(C,...W)},this.a.set(C,T));const{object:N}=T,U=(0,M.$db)(()=>{--T.counter===0&&(this.c(C,T.object),this.a.delete(C))});return T.counter++,{object:N,dispose:U}}}e.$Zc=c;class b{constructor(C){this.a=C}async acquire(C,...W){const T=this.a.acquire(C,...W);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(N){throw T.dispose(),N}}}e.$1c=b;class I{constructor(C){this.object=C}dispose(){}}e.$2c=I;function D(A){const C=new a;try{A(C)}finally{C.dispose()}}class j{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,W,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(C)?.dispose(),this.a.set(C,W)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=j}),define(oe[72],ae([0,1,32]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0,e.$5l=S,e.$6l=P;const R=new i.$Ec(1e4);function S(u){return h(u,"NFC",R)}const M=new i.$Ec(1e4);function P(u){return h(u,"NFD",M)}const E=/[^\u0000-\u0080]/;function h(u,g,y){if(!u)return u;const k=y.get(u);if(k)return k;let w;return E.test(u)?w=u.normalize(g):w=u,y.set(u,w),w}e.$7l=function(){const u=/[\u0300-\u036f]/g;return function(g){return P(g).replace(u,"")}}()}),define(oe[141],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0,e.$sm=i,e.rot=R;function i(E,h,u){return Math.min(Math.max(E,h),u)}function R(E,h){return(h+E%h)%h}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$um=S;class M{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$vm=M;class P{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const u=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$wm=P}),function(){function Q(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function P(h){M.push(h,Date.now())}function E(){const h=[];for(let u=0;u<M.length;u+=2)h.push({name:M[u],startTime:M[u+1]});return h}return{mark:P,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(S+P.startTime)});return M}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=i(R))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var R in i)(typeof exports=="object"?exports:Q)[R]=i[R]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function i(R){if(e[R])return e[R].exports;var S=e[R]={i:R,l:!1,exports:{}};return Q[R].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=Q,i.c=e,i.d=function(R,S,M){i.o(R,S)||Object.defineProperty(R,S,{enumerable:!0,get:M})},i.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},i.t=function(R,S){if(1&S&&(R=i(R)),8&S||4&S&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&S&&typeof R!="string")for(var P in R)i.d(M,P,function(E){return R[E]}.bind(null,P));return M},i.n=function(R){var S=R&&R.__esModule?function(){return R.default}:function(){return R};return i.d(S,"a",S),S},i.o=function(R,S){return Object.prototype.hasOwnProperty.call(R,S)},i.p="",i(i.s=0)}([function(Q,e,i){(function(R){var S;e=Q.exports=he,S=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],u=0,g=u++;h[g]="0|[1-9]\\d*";var y=u++;h[y]="[0-9]+";var k=u++;h[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=u++;h[w]="("+h[g]+")\\.("+h[g]+")\\.("+h[g]+")";var m=u++;h[m]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var v=u++;h[v]="(?:"+h[g]+"|"+h[k]+")";var p=u++;h[p]="(?:"+h[y]+"|"+h[k]+")";var $=u++;h[$]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var f=u++;h[f]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var l=u++;h[l]="[0-9A-Za-z-]+";var d=u++;h[d]="(?:\\+("+h[l]+"(?:\\."+h[l]+")*))";var a=u++,t="v?"+h[w]+h[$]+"?"+h[d]+"?";h[a]="^"+t+"$";var o="[v=\\s]*"+h[m]+h[f]+"?"+h[d]+"?",s=u++;h[s]="^"+o+"$";var n=u++;h[n]="((?:<|>)?=?)";var r=u++;h[r]=h[y]+"|x|X|\\*";var c=u++;h[c]=h[g]+"|x|X|\\*";var b=u++;h[b]="[v=\\s]*("+h[c]+")(?:\\.("+h[c]+")(?:\\.("+h[c]+")(?:"+h[$]+")?"+h[d]+"?)?)?";var I=u++;h[I]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[f]+")?"+h[d]+"?)?)?";var D=u++;h[D]="^"+h[n]+"\\s*"+h[b]+"$";var j=u++;h[j]="^"+h[n]+"\\s*"+h[I]+"$";var A=u++;h[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=u++;h[C]="(?:~>?)";var W=u++;h[W]="(\\s*)"+h[C]+"\\s+",E[W]=new RegExp(h[W],"g");var T=u++;h[T]="^"+h[C]+h[b]+"$";var N=u++;h[N]="^"+h[C]+h[I]+"$";var U=u++;h[U]="(?:\\^)";var ue=u++;h[ue]="(\\s*)"+h[U]+"\\s+",E[ue]=new RegExp(h[ue],"g");var ie=u++;h[ie]="^"+h[U]+h[b]+"$";var le=u++;h[le]="^"+h[U]+h[I]+"$";var Y=u++;h[Y]="^"+h[n]+"\\s*("+o+")$|^$";var K=u++;h[K]="^"+h[n]+"\\s*("+t+")$|^$";var B=u++;h[B]="(\\s*)"+h[n]+"\\s*("+o+"|"+h[b]+")",E[B]=new RegExp(h[B],"g");var L=u++;h[L]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var H=u++;h[H]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var G=u++;h[G]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)S(z,h[z]),E[z]||(E[z]=new RegExp(h[z]));function ce(Z,de){if(Z instanceof he)return Z;if(typeof Z!="string"||Z.length>M||!(de?E[s]:E[a]).test(Z))return null;try{return new he(Z,de)}catch{return null}}function he(Z,de){if(Z instanceof he){if(Z.loose===de)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(Z,de);S("SemVer",Z,de),this.loose=de;var $e=Z.trim().match(de?E[s]:E[a]);if(!$e)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ae=+Pe;if(Ae>=0&&Ae<P)return Ae}return Pe}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,de){var $e=ce(Z,de);return $e?$e.version:null},e.clean=function(Z,de){var $e=ce(Z.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Z){return S("SemVer.compare",this.version,this.loose,Z),Z instanceof he||(Z=new he(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},he.prototype.compareMain=function(Z){return Z instanceof he||(Z=new he(Z,this.loose)),O(this.major,Z.major)||O(this.minor,Z.minor)||O(this.patch,Z.patch)},he.prototype.comparePre=function(Z){if(Z instanceof he||(Z=new he(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Pe=Z.prerelease[de];if(S("prerelease compare",de,$e,Pe),$e===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if($e===void 0)return-1;if($e!==Pe)return O($e,Pe)}while(++de)},he.prototype.inc=function(Z,de){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,de,$e,Pe){typeof $e=="string"&&(Pe=$e,$e=void 0);try{return new he(Z,$e).inc(de,Pe).version}catch{return null}},e.diff=function(Z,de){if(J(Z,de))return null;var $e=ce(Z),Pe=ce(de);if($e.prerelease.length||Pe.prerelease.length){for(var Ae in $e)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&$e[Ae]!==Pe[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in $e)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&$e[Ae]!==Pe[Ae])return Ae},e.compareIdentifiers=O;var X=/^[0-9]+$/;function O(Z,de){var $e=X.test(Z),Pe=X.test(de);return $e&&Pe&&(Z=+Z,de=+de),$e&&!Pe?-1:Pe&&!$e?1:Z<de?-1:Z>de?1:0}function F(Z,de,$e){return new he(Z,$e).compare(new he(de,$e))}function _(Z,de,$e){return F(Z,de,$e)>0}function se(Z,de,$e){return F(Z,de,$e)<0}function J(Z,de,$e){return F(Z,de,$e)===0}function x(Z,de,$e){return F(Z,de,$e)!==0}function V(Z,de,$e){return F(Z,de,$e)>=0}function q(Z,de,$e){return F(Z,de,$e)<=0}function re(Z,de,$e,Pe){var Ae;switch(de){case"===":typeof Z=="object"&&(Z=Z.version),typeof $e=="object"&&($e=$e.version),Ae=Z===$e;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof $e=="object"&&($e=$e.version),Ae=Z!==$e;break;case"":case"=":case"==":Ae=J(Z,$e,Pe);break;case"!=":Ae=x(Z,$e,Pe);break;case">":Ae=_(Z,$e,Pe);break;case">=":Ae=V(Z,$e,Pe);break;case"<":Ae=se(Z,$e,Pe);break;case"<=":Ae=q(Z,$e,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Ae}function ee(Z,de){if(Z instanceof ee){if(Z.loose===de)return Z;Z=Z.value}if(!(this instanceof ee))return new ee(Z,de);S("comparator",Z,de),this.loose=de,this.parse(Z),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Z,de){return O(de,Z)},e.major=function(Z,de){return new he(Z,de).major},e.minor=function(Z,de){return new he(Z,de).minor},e.patch=function(Z,de){return new he(Z,de).patch},e.compare=F,e.compareLoose=function(Z,de){return F(Z,de,!0)},e.rcompare=function(Z,de,$e){return F(de,Z,$e)},e.sort=function(Z,de){return Z.sort(function($e,Pe){return e.compare($e,Pe,de)})},e.rsort=function(Z,de){return Z.sort(function($e,Pe){return e.rcompare($e,Pe,de)})},e.gt=_,e.lt=se,e.eq=J,e.neq=x,e.gte=V,e.lte=q,e.cmp=re,e.Comparator=ee;var fe={};function me(Z,de){if(Z instanceof me)return Z.loose===de?Z:new me(Z.raw,de);if(Z instanceof ee)return new me(Z.value,de);if(!(this instanceof me))return new me(Z,de);if(this.loose=de,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function ve(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ke(Z,de,$e,Pe,Ae,Be,Me,Le,Ue,Ve,Xe,He,te){return((de=ve($e)?"":ve(Pe)?">="+$e+".0.0":ve(Ae)?">="+$e+"."+Pe+".0":">="+de)+" "+(Le=ve(Ue)?"":ve(Ve)?"<"+(+Ue+1)+".0.0":ve(Xe)?"<"+Ue+"."+(+Ve+1)+".0":He?"<="+Ue+"."+Ve+"."+Xe+"-"+He:"<="+Le)).trim()}function Ie(Z,de){for(var $e=0;$e<Z.length;$e++)if(!Z[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<Z.length;$e++)if(S(Z[$e].semver),Z[$e].semver!==fe&&Z[$e].semver.prerelease.length>0){var Pe=Z[$e].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Fe(Z,de,$e){try{de=new me(de,$e)}catch{return!1}return de.test(Z)}function ye(Z,de,$e,Pe){var Ae,Be,Me,Le,Ue;switch(Z=new he(Z,Pe),de=new me(de,Pe),$e){case">":Ae=_,Be=q,Me=se,Le=">",Ue=">=";break;case"<":Ae=se,Be=V,Me=_,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(Z,de,Pe))return!1;for(var Ve=0;Ve<de.set.length;++Ve){var Xe=de.set[Ve],He=null,te=null;if(Xe.forEach(function(ge){ge.semver===fe&&(ge=new ee(">=0.0.0")),He=He||ge,te=te||ge,Ae(ge.semver,He.semver,Pe)?He=ge:Me(ge.semver,te.semver,Pe)&&(te=ge)}),He.operator===Le||He.operator===Ue||(!te.operator||te.operator===Le)&&Be(Z,te.semver)||te.operator===Ue&&Me(Z,te.semver))return!1}return!0}ee.prototype.parse=function(Z){var de=this.loose?E[Y]:E[K],$e=Z.match(de);if(!$e)throw new TypeError("Invalid comparator: "+Z);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=fe},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Z){return S("Comparator.test",Z,this.loose),this.semver===fe||(typeof Z=="string"&&(Z=new he(Z,this.loose)),re(Z,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Z,de){if(!(Z instanceof ee))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(Z.value,de),Fe(this.value,$e,de);if(Z.operator==="")return $e=new me(this.value,de),Fe(Z.semver,$e,de);var Pe=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Be=this.semver.version===Z.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Le=re(this.semver,"<",Z.semver,de)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ue=re(this.semver,">",Z.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Pe||Ae||Be&&Me||Le||Ue},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(Z){var de=this.loose;Z=Z.trim(),S("range",Z,de);var $e=de?E[H]:E[L];Z=Z.replace($e,ke),S("hyphen replace",Z),Z=Z.replace(E[B],"$1$2$3"),S("comparator trim",Z,E[B]),Z=(Z=(Z=Z.replace(E[W],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var Pe=de?E[Y]:E[K],Ae=Z.split(" ").map(function(Be){return function(Me,Le){return S("comp",Me),Me=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Xe){return function(He,te){S("caret",He,te);var ge=te?E[le]:E[ie];return He.replace(ge,function(we,be,Se,Oe,Ne){var Je;return S("caret",He,we,be,Se,Oe,Ne),ve(be)?Je="":ve(Se)?Je=">="+be+".0.0 <"+(+be+1)+".0.0":ve(Oe)?Je=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Ne?(S("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Je=be==="0"?Se==="0"?">="+be+"."+Se+"."+Oe+Ne+" <"+be+"."+Se+"."+(+Oe+1):">="+be+"."+Se+"."+Oe+Ne+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Oe+Ne+" <"+(+be+1)+".0.0"):(S("no pr"),Je=be==="0"?Se==="0"?">="+be+"."+Se+"."+Oe+" <"+be+"."+Se+"."+(+Oe+1):">="+be+"."+Se+"."+Oe+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Oe+" <"+(+be+1)+".0.0"),S("caret return",Je),Je})}(Xe,Ve)}).join(" ")}(Me,Le),S("caret",Me),Me=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Xe){return function(He,te){var ge=te?E[N]:E[T];return He.replace(ge,function(we,be,Se,Oe,Ne){var Je;return S("tilde",He,we,be,Se,Oe,Ne),ve(be)?Je="":ve(Se)?Je=">="+be+".0.0 <"+(+be+1)+".0.0":ve(Oe)?Je=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Ne?(S("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Je=">="+be+"."+Se+"."+Oe+Ne+" <"+be+"."+(+Se+1)+".0"):Je=">="+be+"."+Se+"."+Oe+" <"+be+"."+(+Se+1)+".0",S("tilde return",Je),Je})}(Xe,Ve)}).join(" ")}(Me,Le),S("tildes",Me),Me=function(Ue,Ve){return S("replaceXRanges",Ue,Ve),Ue.split(/\s+/).map(function(Xe){return function(He,te){He=He.trim();var ge=te?E[j]:E[D];return He.replace(ge,function(we,be,Se,Oe,Ne,Je){S("xRange",He,we,be,Se,Oe,Ne,Je);var Ze=ve(Se),Ye=Ze||ve(Oe),Ke=Ye||ve(Ne);return be==="="&&Ke&&(be=""),Ze?we=be===">"||be==="<"?"<0.0.0":"*":be&&Ke?(Ye&&(Oe=0),Ke&&(Ne=0),be===">"?(be=">=",Ye?(Se=+Se+1,Oe=0,Ne=0):Ke&&(Oe=+Oe+1,Ne=0)):be==="<="&&(be="<",Ye?Se=+Se+1:Oe=+Oe+1),we=be+Se+"."+Oe+"."+Ne):Ye?we=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ke&&(we=">="+Se+"."+Oe+".0 <"+Se+"."+(+Oe+1)+".0"),S("xRange return",we),we})}(Xe,Ve)}).join(" ")}(Me,Le),S("xrange",Me),Me=function(Ue,Ve){return S("replaceStars",Ue,Ve),Ue.trim().replace(E[G],"")}(Me,Le),S("stars",Me),Me}(Be,de)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Be){return!!Be.match(Pe)})),Ae=Ae.map(function(Be){return new ee(Be,de)})},me.prototype.intersects=function(Z,de){if(!(Z instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Pe){return Z.set.some(function(Ae){return Ae.every(function(Be){return Pe.intersects(Be,de)})})})})},e.toComparators=function(Z,de){return new me(Z,de).set.map(function($e){return $e.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new he(Z,this.loose));for(var de=0;de<this.set.length;de++)if(Ie(this.set[de],Z))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(Z,de,$e){var Pe=null,Ae=null;try{var Be=new me(de,$e)}catch{return null}return Z.forEach(function(Me){Be.test(Me)&&(Pe&&Ae.compare(Me)!==-1||(Ae=new he(Pe=Me,$e)))}),Pe},e.minSatisfying=function(Z,de,$e){var Pe=null,Ae=null;try{var Be=new me(de,$e)}catch{return null}return Z.forEach(function(Me){Be.test(Me)&&(Pe&&Ae.compare(Me)!==1||(Ae=new he(Pe=Me,$e)))}),Pe},e.validRange=function(Z,de){try{return new me(Z,de).range||"*"}catch{return null}},e.ltr=function(Z,de,$e){return ye(Z,de,"<",$e)},e.gtr=function(Z,de,$e){return ye(Z,de,">",$e)},e.outside=ye,e.prerelease=function(Z,de){var $e=ce(Z,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(Z,de,$e){return Z=new me(Z,$e),de=new me(de,$e),Z.intersects(de)},e.coerce=function(Z){if(Z instanceof he)return Z;if(typeof Z!="string")return null;var de=Z.match(E[A]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,i(1))},function(Q,e){var i,R,S=Q.exports={};function M(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function E(p){if(i===setTimeout)return setTimeout(p,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(p,0);try{return i(p,0)}catch{try{return i.call(null,p,0)}catch{return i.call(this,p,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{R=typeof clearTimeout=="function"?clearTimeout:P}catch{R=P}})();var h,u=[],g=!1,y=-1;function k(){g&&h&&(g=!1,h.length?u=h.concat(u):y=-1,u.length&&w())}function w(){if(!g){var p=E(k);g=!0;for(var $=u.length;$;){for(h=u,u=[];++y<$;)h&&h[y].run();y=-1,$=u.length}h=null,g=!1,function(f){if(R===clearTimeout)return clearTimeout(f);if((R===P||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(f);try{R(f)}catch{try{return R.call(null,f)}catch{return R.call(this,f)}}}(p)}}function m(p,$){this.fun=p,this.array=$}function v(){}S.nextTick=function(p){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];u.push(new m(p,$)),u.length!==1||g||E(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=v,S.addListener=v,S.once=v,S.off=v,S.removeListener=v,S.removeAllListeners=v,S.emit=v,S.prependListener=v,S.prependOnceListener=v,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(oe[142],ae([0,1]),function(Q,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class R{constructor(E,h,u){this.level=E,this.key=h,this.value=u,this.forward=[]}}const S=void 0;class M{constructor(E,h=2**16){this.comparator=E,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new R(this.c,S,S)}get size(){return this.f}clear(){this.e=new R(this.c,S,S),this.f=0}has(E){return!!M.g(this,E,this.comparator)}get(E){return M.g(this,E,this.comparator)?.value}set(E,h){return M.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=M.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let u=this.e.forward[0];for(;u;)E.call(h,u.value,u.key,this),u=u.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,u){let g=E.e;for(let y=E.d-1;y>=0;y--)for(;g.forward[y]&&u(g.forward[y].key,h)<0;)g=g.forward[y];if(g=g.forward[0],g&&u(g.key,h)===0)return g}static h(E,h,u,g){const y=[];let k=E.e;for(let w=E.d-1;w>=0;w--){for(;k.forward[w]&&g(k.forward[w].key,h)<0;)k=k.forward[w];y[w]=k}if(k=k.forward[0],k&&g(k.key,h)===0)return k.value=u,!1;{const w=M.j(E);if(w>E.d){for(let m=E.d;m<w;m++)y[m]=E.e;E.d=w}k=new R(w,h,u);for(let m=0;m<w;m++)k.forward[m]=y[m].forward[m],y[m].forward[m]=k;return!0}}static j(E,h=.5){let u=1;for(;Math.random()<h&&u<E.c;)u+=1;return u}static k(E,h,u){const g=[];let y=E.e;for(let k=E.d-1;k>=0;k--){for(;y.forward[k]&&u(y.forward[k].key,h)<0;)y=y.forward[k];g[k]=y}if(y=y.forward[0],!y||u(y.key,h)!==0)return!1;for(let k=0;k<E.d&&g[k].forward[k]===y;k++)g[k].forward[k]=y.forward[k];for(;E.d>0&&E.e.forward[E.d-1]===S;)E.d-=1;return!0}}e.$ns=M}),define(oe[73],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=i&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$8d=R}),define(oe[3],ae([0,1,15,86,2,104,73]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$0d=e.Event=void 0,e.$$d=w;const E=!1,h=!1,u=!1;var g;(function(A){A.None=()=>S.$Uc.None;function C(ee){if(u){const{onDidAddListener:fe}=ee,me=v.create();let ve=0;ee.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),fe?.()}}}function W(ee,fe){return L(ee,()=>{},0,void 0,!0,void 0,fe)}A.defer=W;function T(ee){return(fe,me=null,ve)=>{let ke=!1,Ie;return Ie=ee(Fe=>{if(!ke)return Ie?Ie.dispose():ke=!0,fe.call(me,Fe)},null,ve),ke&&Ie.dispose(),Ie}}A.once=T;function N(ee,fe,me){return K((ve,ke=null,Ie)=>ee(Fe=>ve.call(ke,fe(Fe)),null,Ie),me)}A.map=N;function U(ee,fe,me){return K((ve,ke=null,Ie)=>ee(Fe=>{fe(Fe),ve.call(ke,Fe)},null,Ie),me)}A.forEach=U;function ue(ee,fe,me){return K((ve,ke=null,Ie)=>ee(Fe=>fe(Fe)&&ve.call(ke,Fe),null,Ie),me)}A.filter=ue;function ie(ee){return ee}A.signal=ie;function le(...ee){return(fe,me=null,ve)=>{const ke=(0,S.$Rc)(...ee.map(Ie=>Ie(Fe=>fe.call(me,Fe))));return B(ke,ve)}}A.any=le;function Y(ee,fe,me,ve){let ke=me;return N(ee,Ie=>(ke=fe(ke,Ie),ke),ve)}A.reduce=Y;function K(ee,fe){let me;const ve={onWillAddFirstListener(){me=ee(ke.fire,ke)},onDidRemoveLastListener(){me?.dispose()}};fe||C(ve);const ke=new a(ve);return fe?.add(ke),ke.event}function B(ee,fe){return fe instanceof Array?fe.push(ee):fe&&fe.add(ee),ee}function L(ee,fe,me=100,ve=!1,ke=!1,Ie,Fe){let ye,Z,de,$e=0,Pe;const Ae={leakWarningThreshold:Ie,onWillAddFirstListener(){ye=ee(Me=>{$e++,Z=fe(Z,Me),ve&&!de&&(Be.fire(Z),Z=void 0),Pe=()=>{const Le=Z;Z=void 0,de=void 0,(!ve||$e>1)&&Be.fire(Le),$e=0},typeof me=="number"?(clearTimeout(de),de=setTimeout(Pe,me)):de===void 0&&(de=0,queueMicrotask(Pe))})},onWillRemoveListener(){ke&&$e>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,ye.dispose()}};Fe||C(Ae);const Be=new a(Ae);return Fe?.add(Be),Be.event}A.debounce=L;function H(ee,fe=0,me){return A.debounce(ee,(ve,ke)=>ve?(ve.push(ke),ve):[ke],fe,void 0,!0,void 0,me)}A.accumulate=H;function G(ee,fe=(ve,ke)=>ve===ke,me){let ve=!0,ke;return ue(ee,Ie=>{const Fe=ve||!fe(Ie,ke);return ve=!1,ke=Ie,Fe},me)}A.latch=G;function z(ee,fe,me){return[A.filter(ee,fe,me),A.filter(ee,ve=>!fe(ve),me)]}A.split=z;function ce(ee,fe=!1,me=[],ve){let ke=me.slice(),Ie=ee(Z=>{ke?ke.push(Z):ye.fire(Z)});ve&&ve.add(Ie);const Fe=()=>{ke?.forEach(Z=>ye.fire(Z)),ke=null},ye=new a({onWillAddFirstListener(){Ie||(Ie=ee(Z=>ye.fire(Z)),ve&&ve.add(Ie))},onDidAddFirstListener(){ke&&(fe?setTimeout(Fe):Fe())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return ve&&ve.add(ye),ye.event}A.buffer=ce;function he(ee,fe){return(ve,ke,Ie)=>{const Fe=fe(new O);return ee(function(ye){const Z=Fe.evaluate(ye);Z!==X&&ve.call(ke,Z)},void 0,Ie)}}A.chain=he;const X=Symbol("HaltChainable");class O{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(me=>(fe(me),me)),this}filter(fe){return this.f.push(me=>fe(me)?me:X),this}reduce(fe,me){let ve=me;return this.f.push(ke=>(ve=fe(ve,ke),ve)),this}latch(fe=(me,ve)=>me===ve){let me=!0,ve;return this.f.push(ke=>{const Ie=me||!fe(ke,ve);return me=!1,ve=ke,Ie?ke:X}),this}evaluate(fe){for(const me of this.f)if(fe=me(fe),fe===X)break;return fe}}function F(ee,fe,me=ve=>ve){const ve=(...ye)=>Fe.fire(me(...ye)),ke=()=>ee.on(fe,ve),Ie=()=>ee.removeListener(fe,ve),Fe=new a({onWillAddFirstListener:ke,onDidRemoveLastListener:Ie});return Fe.event}A.fromNodeEventEmitter=F;function _(ee,fe,me=ve=>ve){const ve=(...ye)=>Fe.fire(me(...ye)),ke=()=>ee.addEventListener(fe,ve),Ie=()=>ee.removeEventListener(fe,ve),Fe=new a({onWillAddFirstListener:ke,onDidRemoveLastListener:Ie});return Fe.event}A.fromDOMEventEmitter=_;function se(ee){return new Promise(fe=>T(ee)(fe))}A.toPromise=se;function J(ee){const fe=new a;return ee.then(me=>{fe.fire(me)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}A.fromPromise=J;function x(ee,fe,me){return fe(me),ee(ve=>fe(ve))}A.runAndSubscribe=x;class V{constructor(fe,me){this._observable=fe,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};me||C(ve),this.emitter=new a(ve),me&&me.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,me){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function q(ee,fe){return new V(ee,fe).emitter.event}A.fromObservable=q;function re(ee){return(fe,me,ve)=>{let ke=0,Ie=!1;const Fe={beginUpdate(){ke++},endUpdate(){ke--,ke===0&&(ee.reportChanges(),Ie&&(Ie=!1,fe.call(me)))},handlePossibleChange(){},handleChange(){Ie=!0}};ee.addObserver(Fe),ee.reportChanges();const ye={dispose(){ee.removeObserver(Fe)}};return ve instanceof S.$Tc?ve.add(ye):Array.isArray(ve)&&ve.push(ye),ye}}A.fromObservableLight=re})(g||(e.Event=g={}));class y{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${y.f++}`,y.all.add(this)}start(C){this.g=new P.$8d,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}e.$0d=y;let k=-1;function w(A){const C=k;return k=A,{dispose(){k=C}}}class m{constructor(C,W=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=W,this.g=0}dispose(){this.f?.clear()}check(C,W){const T=this.threshold;if(T<=0||W<T)return;this.f||(this.f=new Map);const N=this.f.get(C.value)||0;if(this.f.set(C.value,N+1),this.g-=1,this.g<=0){this.g=T*.5;let U,ue=0;for(const[ie,le]of this.f)(!U||ue<le)&&(U=ie,ue=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${W} listeners already. MOST frequent listener (${ue}):`),console.warn(U)}return()=>{const U=this.f.get(C.value)||0;this.f.set(C.value,U-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class ${constructor(C){this.value=C,this.id=p++}}const f=2,l=(A,C)=>{if(A instanceof $)C(A);else for(let W=0;W<A.length;W++){const T=A[W];T&&C(T)}},d=E?new FinalizationRegistry(A=>{typeof A=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(A))}):void 0;class a{constructor(C){this.w=0,this.f=C,this.g=k>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const C=this.t;queueMicrotask(()=>{l(C,W=>W.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,W,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Uc.None;if(this.m)return S.$Uc.None;W&&(C=C.bind(W));const N=new $(C);let U,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=v.create(),U=this.g.check(N.stack,this.w+1)),h&&(N.stack=ue??v.create()),this.t?this.t instanceof $?(this.u??=new o,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const ie=(0,S.$Sc)(()=>{d?.unregister(ie),U?.(),this.x(N)});if(T instanceof S.$Tc?T.add(ie):Array.isArray(T)&&T.push(ie),d){const le=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(ie,le,ie)}return ie},this.q}x(C){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const W=this.t,T=W.indexOf(C);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,W[T]=void 0;const N=this.u.current===this;if(this.w*f<=W.length){let U=0;for(let ue=0;ue<W.length;ue++)W[ue]?W[U++]=W[ue]:N&&(this.u.end--,U<this.u.i&&this.u.i--);W.length=U}}y(C,W){if(!C)return;const T=this.f?.onListenerError||i.$1;if(!T){C.value(W);return}try{C.value(W)}catch(N){T(N)}}z(C){const W=C.current.t;for(;C.i<C.end;)this.y(W[C.i++],C.value);C.reset()}fire(C){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,C);else{const W=this.u;W.enqueue(this,C,this.t.length),this.z(W)}this.j?.stop()}hasListeners(){return this.w>0}}e.$_d=a;const t=()=>new o;e.$ae=t;class o{constructor(){this.i=-1,this.end=0}enqueue(C,W,T){this.i=0,this.end=T,this.current=C,this.value=W}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(C,W,T){if(this.t)for(this.h||(this.h=new M.$5c),l(this.t,N=>this.h.push([N.value,C]));this.h.size>0&&!W.isCancellationRequested;){const[N,U]=this.h.shift(),ue=[],ie={...U,token:W,waitUntil:le=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");T&&(le=T(le,N)),ue.push(le)}};try{N(ie)}catch(le){(0,i.$1)(le);continue}Object.freeze(ue),await Promise.allSettled(ue).then(le=>{for(const Y of le)Y.status==="rejected"&&(0,i.$1)(Y.reason)})}}}e.$be=s;class n extends a{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new M.$5c,this.A=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.A(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.w&&(this.h!==0?this.s.push(C):super.fire(C))}}e.$ce=n;class r extends n{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}e.$de=r;class c extends a{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(W=>super.fire(W)),this.h=[]}))}}e.$ee=c;class b{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const W={event:C,listener:null};this.h.push(W),this.g&&this.m(W);const T=()=>{this.g&&this.o(W);const N=this.h.indexOf(W);this.h.splice(N,1)};return(0,S.$Sc)((0,R.$db)(T))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(W=>this.f.fire(W))}o(C){C.listener?.dispose(),C.listener=null}dispose(){this.f.dispose();for(const C of this.h)C.listener?.dispose();this.h=[]}}e.$fe=b;class I{constructor(C,W,T,N){this.f=new S.$Tc;const U=this.f.add(new b),ue=this.f.add(new S.$4c);function ie(le){ue.set(le,U.add(N(le)))}for(const le of C)ie(le);this.f.add(W(le=>{ie(le)})),this.f.add(T(le=>{ue.deleteAndDispose(le)})),this.event=U.event}dispose(){this.f.dispose()}}e.$ge=I;class D{constructor(){this.f=[]}wrapEvent(C){return(W,T,N)=>C(U=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>W.call(T,U)):W.call(T,U)},void 0,N)}bufferEvents(C){const W=[];this.f.push(W);const T=C();return this.f.pop(),W.forEach(N=>N()),T}}e.$he=D;class j{constructor(){this.f=!1,this.g=g.None,this.h=S.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ie=j}),define(oe[23],ae([0,1,3]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.CancellationToken=void 0;const R=Object.freeze(function(E,h){const u=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(u)}}});var S;(function(E){function h(u){return u===E.None||u===E.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(S||(e.CancellationToken=S={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new i.$_d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=S.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=S.None}}e.$je=P}),define(oe[143],ae([0,1,23]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$We=e.$Ve=e.$Ue=void 0;class R{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new i.$je,h=this.b(E.token);return this.a={promise:h,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Ue=R;class S{constructor(E,h=JSON.stringify){this.c=E,this.d=h,this.a=void 0,this.b=void 0}get(E){const h=this.d(E);return this.b!==h&&(this.b=h,this.a=this.c(E)),this.a}}e.$Ve=S;class M{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const h=this.b(E);return this.a.set(E,h),h}}e.$We=M}),define(oe[63],ae([0,1,15,2]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=S,e.$le=M,e.$me=P,e.$ne=E,e.$oe=u,e.$pe=g,e.$qe=y,e.$re=k,e.$se=w,e.$te=m,e.$ue=v,e.$ve=p,e.$we=$,e.$xe=f,e.$ye=l;function S(d){const a=d;return a?typeof a.read=="function":!1}function M(d){const a=d;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function P(d){const a=d;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(d,a){return new h(d,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,i.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(d,a){const t=[];let o;for(;(o=d.read())!==null;)t.push(o);return a(t)}function g(d,a,t){const o=[];let s;for(;(s=d.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return d.read()}}}function y(d,a){return new Promise((t,o)=>{const s=[];k(d,{onData:n=>{a&&s.push(n)},onError:n=>{a?o(n):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function k(d,a,t){d.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),d.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),d.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function w(d,a){return new Promise((t,o)=>{const s=new R.$Tc,n=[],r=I=>{if(n.push(I),n.length>a)return s.dispose(),d.pause(),t({stream:d,buffer:n,ended:!1})},c=I=>(s.dispose(),o(I)),b=()=>(s.dispose(),t({stream:d,buffer:n,ended:!0}));s.add((0,R.$Sc)(()=>d.removeListener("error",c))),d.on("error",c),s.add((0,R.$Sc)(()=>d.removeListener("end",b))),d.on("end",b),s.add((0,R.$Sc)(()=>d.removeListener("data",r))),d.on("data",r)})}function m(d,a){const t=E(a);return t.end(d),t}function v(){const d=E(()=>{throw new Error("not supported")});return d.end(),d}function p(d){let a=!1;return{read:()=>a?null:(a=!0,d)}}function $(d,a,t){const o=E(t);return k(d,{onData:s=>o.write(a.data(s)),onError:s=>o.error(a.error?a.error(s):s),onEnd:()=>o.end()}),o}function f(d,a,t){let o=!1;return{read:()=>{const s=a.read();return o?s:(o=!0,s!==null?t([d,s]):d)}}}function l(d,a,t){let o=!1;const s=E(t);return k(a,{onData:n=>o?s.write(n):(o=!0,s.write(t([d,n]))),onError:n=>s.error(n),onEnd:()=>{o||(o=!0,s.write(d)),s.end()}}),s}}),define(oe[17],ae([0,1,62,63]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=u,e.$Be=g,e.$Ce=y,e.$De=k,e.$Ee=w,e.$Fe=m,e.$Ge=v,e.$He=p,e.$Ie=$,e.$Je=f,e.$Ke=l,e.$Le=d,e.$Me=a,e.$Ne=t,e.$Oe=o,e.$Pe=s,e.$Qe=n,e.$Re=r,e.$Se=c,e.$Te=D;const S=typeof Buffer<"u",M=new i.$V(()=>new Uint8Array(256));let P,E;class h{static alloc(A){return S?new h(Buffer.allocUnsafe(A)):new h(new Uint8Array(A))}static wrap(A){return S&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new h(A)}static fromString(A,C){return!(C?.dontUseNodeBuffer||!1)&&S?new h(Buffer.from(A)):(P||(P=new TextEncoder),new h(P.encode(A)))}static fromByteArray(A){const C=h.alloc(A.length);for(let W=0,T=A.length;W<T;W++)C.buffer[W]=A[W];return C}static concat(A,C){if(typeof C>"u"){C=0;for(let N=0,U=A.length;N<U;N++)C+=A[N].byteLength}const W=h.alloc(C);let T=0;for(let N=0,U=A.length;N<U;N++){const ue=A[N];W.set(ue,T),T+=ue.byteLength}return W}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=h.alloc(this.byteLength);return A.set(this),A}toString(){return S?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(A,C){return new h(this.buffer.subarray(A,C))}set(A,C){if(A instanceof h)this.buffer.set(A.buffer,C);else if(A instanceof Uint8Array)this.buffer.set(A,C);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),C);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return k(this.buffer,A)}writeUInt32BE(A,C){w(this.buffer,A,C)}readUInt32LE(A){return m(this.buffer,A)}writeUInt32LE(A,C){v(this.buffer,A,C)}readUInt8(A){return p(this.buffer,A)}writeUInt8(A,C){$(this.buffer,A,C)}indexOf(A,C=0){return u(this.buffer,A instanceof h?A.buffer:A,C)}}e.$ze=h;function u(j,A,C=0){const W=A.byteLength,T=j.byteLength;if(W===0)return 0;if(W===1)return j.indexOf(A[0]);if(W>T-C)return-1;const N=M.value;N.fill(A.length);for(let le=0;le<A.length;le++)N[A[le]]=A.length-le-1;let U=C+A.length-1,ue=U,ie=-1;for(;U<T;)if(j[U]===A[ue]){if(ue===0){ie=U;break}U--,ue--}else U+=Math.max(A.length-ue,N[j[U]]),ue=A.length-1;return ie}function g(j,A){return j[A+0]<<0>>>0|j[A+1]<<8>>>0}function y(j,A,C){j[C+0]=A&255,A=A>>>8,j[C+1]=A&255}function k(j,A){return j[A]*2**24+j[A+1]*2**16+j[A+2]*2**8+j[A+3]}function w(j,A,C){j[C+3]=A,A=A>>>8,j[C+2]=A,A=A>>>8,j[C+1]=A,A=A>>>8,j[C]=A}function m(j,A){return j[A+0]<<0>>>0|j[A+1]<<8>>>0|j[A+2]<<16>>>0|j[A+3]<<24>>>0}function v(j,A,C){j[C+0]=A&255,A=A>>>8,j[C+1]=A&255,A=A>>>8,j[C+2]=A&255,A=A>>>8,j[C+3]=A&255}function p(j,A){return j[A]}function $(j,A,C){j[C]=A}function f(j){return R.$oe(j,A=>h.concat(A))}function l(j){return R.$ve(j)}function d(j){return R.$qe(j,A=>h.concat(A))}async function a(j){return j.ended?h.concat(j.buffer):h.concat([...j.buffer,await d(j.stream)])}function t(j){return R.$te(j,A=>h.concat(A))}function o(j){return R.$we(j,{data:A=>typeof A=="string"?h.fromString(A):h.wrap(A)},A=>h.concat(A))}function s(j){return R.$ne(A=>h.concat(A),j)}function n(j,A){return R.$xe(j,A,C=>h.concat(C))}function r(j,A){return R.$ye(j,A,C=>h.concat(C))}function c(j){let A=0,C=0,W=0;const T=new Uint8Array(Math.floor(j.length/4*3)),N=ue=>{switch(C){case 3:T[W++]=A|ue,C=0;break;case 2:T[W++]=A|ue>>>2,A=ue<<6,C=3;break;case 1:T[W++]=A|ue>>>4,A=ue<<4,C=2;break;default:A=ue<<2,C=1}};for(let ue=0;ue<j.length;ue++){const ie=j.charCodeAt(ue);if(ie>=65&&ie<=90)N(ie-65);else if(ie>=97&&ie<=122)N(ie-97+26);else if(ie>=48&&ie<=57)N(ie-48+52);else if(ie===43||ie===45)N(62);else if(ie===47||ie===95)N(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${j[ue]}`)}}const U=W;for(;C>0;)N(0);return h.wrap(T).slice(0,U)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:j},A=!0,C=!1){const W=C?I:b;let T="";const N=j.byteLength%3;let U=0;for(;U<j.byteLength-N;U+=3){const ue=j[U+0],ie=j[U+1],le=j[U+2];T+=W[ue>>>2],T+=W[(ue<<4|ie>>>4)&63],T+=W[(ie<<2|le>>>6)&63],T+=W[le&63]}if(N===1){const ue=j[U+0];T+=W[ue>>>2],T+=W[ue<<4&63],A&&(T+="==")}else if(N===2){const ue=j[U+0],ie=j[U+1];T+=W[ue>>>2],T+=W[(ue<<4|ie>>>4)&63],T+=W[ie<<2&63],A&&(T+="=")}return T}}),define(oe[25],ae([0,1,143,62]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.GraphemeBreakType=e.$Nf=e.$Gf=e.$zf=e.$yf=void 0,e.$Ze=S,e.$1e=P,e.$2e=h,e.$3e=u,e.$4e=g,e.$5e=y,e.$6e=k,e.$7e=w,e.$8e=m,e.$9e=v,e.$0e=p,e.$$e=$,e.$_e=f,e.$af=l,e.$bf=d,e.$cf=a,e.$df=t,e.$ef=o,e.$ff=s,e.$gf=n,e.$hf=r,e.$if=c,e.$jf=b,e.$kf=I,e.$lf=D,e.$mf=j,e.$nf=A,e.$of=C,e.$pf=W,e.$qf=T,e.$rf=N,e.$sf=U,e.$tf=ue,e.$uf=ie,e.$vf=le,e.$wf=Y,e.$xf=K,e.$Af=G,e.$Bf=z,e.$Cf=ce,e.$Df=he,e.$Ef=F,e.$Ff=se,e.$Hf=J,e.$If=x,e.$Jf=V,e.$Kf=q,e.$Lf=ee,e.$Mf=fe,e.$Of=me,e.$Pf=ve,e.$Qf=ke,e.$Rf=Ie,e.$Sf=Fe,e.$Tf=ye,e.$Uf=Z,e.$Vf=de,e.$Wf=Me;function S(te){return!te||typeof te!="string"?!0:te.trim().length===0}const M=/{(\d+)}/g;function P(te,...ge){return ge.length===0?te:te.replace(M,function(we,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=ge.length?we:ge[Se]})}const E=/{([^}]+)}/g;function h(te,ge){return Object.keys(ge).length===0?te:te.replace(E,(we,be)=>ge[be]??we)}function u(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(te,ge){let we=0;const be=ge.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===be&&we++;return we}function w(te,ge,we="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${we}`}function m(te,ge,we="\u2026"){if(te.length<=ge)return te;const be=Math.ceil(ge/2)-we.length/2,Se=Math.floor(ge/2)-we.length/2;return`${te.substr(0,be)}${we}${te.substr(te.length-Se)}`}function v(te,ge=" "){const we=p(te,ge);return $(we,ge)}function p(te,ge){if(!te||!ge)return te;const we=ge.length;if(we===0||te.length===0)return te;let be=0;for(;te.indexOf(ge,be)===be;)be=be+we;return te.substring(be)}function $(te,ge){if(!te||!ge)return te;const we=ge.length,be=te.length;if(we===0||be===0)return te;let Se=be,Oe=-1;for(;Oe=te.lastIndexOf(ge,Se-1),!(Oe===-1||Oe+we!==Se);){if(Oe===0)return"";Se=Oe}return te.substring(0,Se)}function f(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(te){return te.replace(/\*/g,"")}function d(te,ge,we={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=y(te)),we.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let be="";return we.global&&(be+="g"),we.matchCase||(be+="i"),we.multiline&&(be+="m"),we.unicode&&(be+="u"),new RegExp(te,be)}function a(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function t(te){return te.split(/\r\n|\r|\n/)}function o(te){const ge=[],we=te.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(we.length/2);be++)ge.push(we[2*be]+(we[2*be+1]??""));return ge}function s(te){for(let ge=0,we=te.length;ge<we;ge++){const be=te.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}function n(te,ge=0,we=te.length){for(let be=ge;be<we;be++){const Se=te.charCodeAt(be);if(Se!==32&&Se!==9)return te.substring(ge,be)}return te.substring(ge,we)}function r(te,ge=te.length-1){for(let we=ge;we>=0;we--){const be=te.charCodeAt(we);if(be!==32&&be!==9)return we}return-1}function c(te,ge,we){const be=[];let Se=0;for(const Oe of te.matchAll(ge)){if(be.push(te.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,be.push(we(Oe[0],...Oe.slice(1),Oe.index,te,Oe.groups))}return be.push(te.slice(Se)),Promise.all(be).then(Oe=>Oe.join(""))}function b(te,ge){return te<ge?-1:te>ge?1:0}function I(te,ge,we=0,be=te.length,Se=0,Oe=ge.length){for(;we<be&&Se<Oe;we++,Se++){const Ze=te.charCodeAt(we),Ye=ge.charCodeAt(Se);if(Ze<Ye)return-1;if(Ze>Ye)return 1}const Ne=be-we,Je=Oe-Se;return Ne<Je?-1:Ne>Je?1:0}function D(te,ge){return j(te,ge,0,te.length,0,ge.length)}function j(te,ge,we=0,be=te.length,Se=0,Oe=ge.length){for(;we<be&&Se<Oe;we++,Se++){let Ze=te.charCodeAt(we),Ye=ge.charCodeAt(Se);if(Ze===Ye)continue;if(Ze>=128||Ye>=128)return I(te.toLowerCase(),ge.toLowerCase(),we,be,Se,Oe);C(Ze)&&(Ze-=32),C(Ye)&&(Ye-=32);const Ke=Ze-Ye;if(Ke!==0)return Ke}const Ne=be-we,Je=Oe-Se;return Ne<Je?-1:Ne>Je?1:0}function A(te){return te>=48&&te<=57}function C(te){return te>=97&&te<=122}function W(te){return te>=65&&te<=90}function T(te,ge){return te.length===ge.length&&j(te,ge)===0}function N(te,ge){const we=ge.length;return ge.length>te.length?!1:j(te,ge,0,we)===0}function U(te,ge){const we=Math.min(te.length,ge.length);let be;for(be=0;be<we;be++)if(te.charCodeAt(be)!==ge.charCodeAt(be))return be;return we}function ue(te,ge){const we=Math.min(te.length,ge.length);let be;const Se=te.length-1,Oe=ge.length-1;for(be=0;be<we;be++)if(te.charCodeAt(Se-be)!==ge.charCodeAt(Oe-be))return be;return we}function ie(te){return 55296<=te&&te<=56319}function le(te){return 56320<=te&&te<=57343}function Y(te,ge){return(te-55296<<10)+(ge-56320)+65536}function K(te,ge,we){const be=te.charCodeAt(we);if(ie(be)&&we+1<ge){const Se=te.charCodeAt(we+1);if(le(Se))return Y(be,Se)}return be}function B(te,ge){const we=te.charCodeAt(ge-1);if(le(we)&&ge>1){const be=te.charCodeAt(ge-2);if(ie(be))return Y(be,we)}return we}class L{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=B(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=K(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$yf=L;class H{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new L(ge,we)}nextGraphemeLength(){const ge=Ae.getInstance(),we=this.c,be=we.offset;let Se=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Oe=we.offset,Ne=ge.getGraphemeBreakType(we.nextCodePoint());if($e(Se,Ne)){we.setOffset(Oe);break}Se=Ne}return we.offset-be}prevGraphemeLength(){const ge=Ae.getInstance(),we=this.c,be=we.offset;let Se=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Oe=we.offset,Ne=ge.getGraphemeBreakType(we.prevCodePoint());if($e(Ne,Se)){we.setOffset(Oe);break}Se=Ne}return be-we.offset}eol(){return this.c.eol()}}e.$zf=H;function G(te,ge){return new H(te,ge).nextGraphemeLength()}function z(te,ge){return new H(te,ge).prevGraphemeLength()}function ce(te,ge){ge>0&&le(te.charCodeAt(ge))&&ge--;const we=ge+G(te,ge);return[we-z(te,we),we]}function he(te){const ge=new H(te);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let X;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(te){return X||(X=O()),X.test(te)}const _=/^[\t\n\r\x20-\x7E]*$/;function se(te){return _.test(te)}e.$Gf=/[\u2028\u2029]/;function J(te){return e.$Gf.test(te)}function x(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function V(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function q(te,ge,we=""){const be=te.trimStart();if(be.length<ge)return be;const Se=/\b/g;let Oe=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<ge);)Oe=Se.lastIndex,Se.lastIndex+=1;return Oe===0?be:we+be.substring(Oe).trimStart()}const re=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ee(te){let ge=0;for(const we of te.matchAll(re))ge!==we.index&&(yield{isCode:!1,str:te.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function fe(te){return te&&(te=te.replace(re,"")),te}e.$Nf="\uFEFF";function me(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}function ve(te){return me(te)?te.substr(1):te}function ke(te,ge){if(!te||!ge||te.length<ge.length)return!1;const we=ge.length,be=te.toLowerCase();let Se=0,Oe=-1;for(;Se<we;){const Ne=be.indexOf(ge[Se],Oe+1);if(Ne<0)return!1;Oe=Ne,Se++}return!0}function Ie(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function Fe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function ye(te,ge=1){if(ge===0)return"";let we=-1;do we=te.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?te:(te[we-1]==="\r"&&we--,te.substr(0,we))}function Z(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}function de(te){return Ae.getInstance().getGraphemeBreakType(te)}function $e(te,ge){return te===0?ge!==5&&ge!==7:te===2&&ge===3?!1:te===4||te===2||te===3||ge===4||ge===2||ge===3?!0:!(te===8&&(ge===8||ge===9||ge===11||ge===12)||(te===11||te===9)&&(ge===9||ge===10)||(te===12||te===10)&&ge===10||ge===5||ge===13||ge===7||te===1||te===13&&ge===14||te===6&&ge===6)}var Pe;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Be()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const we=this.d,be=we.length/3;let Se=1;for(;Se<=be;)if(ge<we[3*Se])Se=2*Se;else if(ge>we[3*Se+1])Se=2*Se+1;else return we[3*Se+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(te,ge){if(te===0)return 0;const we=Le(te,ge);if(we!==void 0)return we;const be=new L(ge,te);return be.prevCodePoint(),be.offset}function Le(te,ge){const we=new L(ge,te);let be=we.prevCodePoint();for(;Ue(be)||be===65039||be===8419;){if(we.offset===0)return;be=we.prevCodePoint()}if(!V(be))return;let Se=we.offset;return Se>0&&we.prevCodePoint()===8205&&(Se=we.offset),Se}function Ue(te){return 127995<=te&&te<=127999}var Ve;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),e.$Xf="\xA0";class Xe{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Ve(ge=>{function we(Ke){const st=new Map;for(let it=0;it<Ke.length;it+=2)st.set(Ke[it],Ke[it+1]);return st}function be(Ke,st){const it=new Map(Ke);for(const[ot,at]of st)it.set(ot,at);return it}function Se(Ke,st){if(!Ke)return st;const it=new Map;for(const[ot,at]of Ke)st.has(ot)&&it.set(ot,at);return it}const Oe=this.c.value;let Ne=ge.filter(Ke=>!Ke.startsWith("_")&&Ke in Oe);Ne.length===0&&(Ne=["_default"]);let Je;for(const Ke of Ne){const st=we(Oe[Ke]);Je=Se(Je,st)}const Ze=we(Oe._common),Ye=be(Ze,Je);return new Xe(Ye)})}static getInstance(ge){return Xe.d.get(Array.from(ge))}static{this.e=new R.$V(()=>Object.keys(Xe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Yf=Xe;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ge){return He.e().has(ge)}static get codePoints(){return He.e()}}e.$Zf=He}),define(oe[46],ae([0,1,25]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$fj=void 0,e.$bj=R,e.$cj=S,e.$dj=M,e.$ej=E,e.$gj=v;function R($){return S($,0)}function S($,f){switch(typeof $){case"object":return $===null?M(349,f):Array.isArray($)?h($,f):u($,f);case"string":return E($,f);case"boolean":return P($,f);case"number":return M($,f);case"undefined":return M(937,f);default:return M(617,f)}}function M($,f){return(f<<5)-f+$|0}function P($,f){return M($?433:863,f)}function E($,f){f=M(149417,f);for(let l=0,d=$.length;l<d;l++)f=M($.charCodeAt(l),f);return f}function h($,f){return f=M(104579,f),$.reduce((l,d)=>S(d,l),f)}function u($,f){return f=M(181387,f),Object.keys($).sort().reduce((l,d)=>(l=E(d,l),S($[d],l)),f)}class g{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=S(f,this.g),this.g}}e.$fj=g;var y;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function k($,f,l=32){const d=l-f,a=~((1<<d)-1);return($<<f|(a&$)>>>d)>>>0}function w($,f=0,l=$.byteLength,d=0){for(let a=0;a<l;a++)$[f+a]=d}function m($,f,l="0"){for(;$.length<f;)$=l+$;return $}function v($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(l=>l.toString(16).padStart(2,"0")).join(""):m(($>>>0).toString(16),f/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const l=f.length;if(l===0)return;const d=this.p;let a=this.r,t=this.u,o,s;for(t!==0?(o=t,s=-1,t=0):(o=f.charCodeAt(0),s=0);;){let n=o;if(i.$uf(o))if(s+1<l){const r=f.charCodeAt(s+1);i.$vf(r)?(s++,n=i.$wf(o,r)):n=65533}else{t=o;break}else i.$vf(o)&&(n=65533);if(a=this.w(d,a,n),s++,s<l)o=f.charCodeAt(s);else break}this.r=a,this.u=t}w(f,l,d){return d<128?f[l++]=d:d<2048?(f[l++]=192|(d&1984)>>>6,f[l++]=128|(d&63)>>>0):d<65536?(f[l++]=224|(d&61440)>>>12,f[l++]=128|(d&4032)>>>6,f[l++]=128|(d&63)>>>0):(f[l++]=240|(d&1835008)>>>18,f[l++]=128|(d&258048)>>>12,f[l++]=128|(d&4032)>>>6,f[l++]=128|(d&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,l=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,k(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let d=this.h,a=this.l,t=this.m,o=this.n,s=this.o,n,r,c;for(let b=0;b<80;b++)b<20?(n=a&t|~a&o,r=1518500249):b<40?(n=a^t^o,r=1859775393):b<60?(n=a&t|a&o|t&o,r=2400959708):(n=a^t^o,r=3395469782),c=k(d,5)+n+s+r+f.getUint32(b*4,!1)&4294967295,s=o,o=t,t=k(a,30),a=d,d=c;this.h=this.h+d&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}e.$hj=p}),define(oe[74],ae([0,1,25]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(R||(R={})),function(S){const M="error",P="warning",E="warn",h="info",u="ignore";function g(k){return k?i.$qf(M,k)?S.Error:i.$qf(P,k)||i.$qf(E,k)?S.Warning:i.$qf(h,k)?S.Info:S.Ignore:S.Ignore}S.fromValue=g;function y(k){switch(k){case S.Error:return M;case S.Warning:return P;case S.Info:return h;default:return u}}S.toString=y}(R||(R={})),e.default=R}),define(oe[144],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(oe[59],ae([0,1,22,25]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;class S{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),v=this.b.charCodeAt(this.c);return m-v}value(){return this.b[this.c]}}e.$pi=S;class M{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,R.$kf)(w,this.b,0,w.length,this.c,this.d):(0,R.$mf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qi=M;class P{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const v=this.b.charCodeAt(m);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,R.$kf)(w,this.b,0,w.length,this.d,this.e):(0,R.$mf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ri=P;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,R.$lf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,R.$lf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,R.$jf)(w,this.c.query);if(this.d[this.e]===5)return(0,R.$jf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$si=h;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(g||(g={}));class y{static forUris(w=()=>!1,m=()=>!1){return new y(new h(w,m))}static forPaths(w=!1){return new y(new P(void 0,!w))}static forStrings(){return new y(new S)}static forConfigKeys(){return new y(new M)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const v=m.slice(0);(0,i.$Xb)(v);for(const p of v)this.set(p,w)}else{const v=w.slice(0);(0,i.$Xb)(v);for(const p of v)this.set(p[0],p[1])}}set(w,m){const v=this.b.reset(w);let p;this.c||(this.c=new u,this.c.segment=v.value());const $=[];for(p=this.c;;){const l=v.cmp(p.segment);if(l>0)p.left||(p.left=new u,p.left.segment=v.value()),$.push([-1,p]),p=p.left;else if(l<0)p.right||(p.right=new u,p.right.segment=v.value()),$.push([1,p]),p=p.right;else if(v.hasNext())v.next(),p.mid||(p.mid=new u,p.mid.segment=v.value()),$.push([0,p]),p=p.mid;else break}const f=p.value;p.value=m,p.key=w;for(let l=$.length-1;l>=0;l--){const d=$[l][1];d.updateHeight();const a=d.balanceFactor();if(a<-1||a>1){const t=$[l][0],o=$[l+1][0];if(t===1&&o===1)$[l][1]=d.rotateLeft();else if(t===-1&&o===-1)$[l][1]=d.rotateRight();else if(t===1&&o===-1)d.right=$[l+1][1]=$[l+1][1].rotateRight(),$[l][1]=d.rotateLeft();else if(t===-1&&o===1)d.left=$[l+1][1]=$[l+1][1].rotateLeft(),$[l][1]=d.rotateRight();else throw new Error;if(l>0)switch($[l-1][0]){case-1:$[l-1][1].left=$[l][1];break;case 1:$[l-1][1].right=$[l][1];break;case 0:$[l-1][1].mid=$[l][1];break}else this.c=$[0][1]}}return f}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let v=this.c;for(;v;){const p=m.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(m.hasNext())m.next(),v=v.mid;else break}return v}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const v=this.b.reset(w),p=[];let $=this.c;for(;$;){const f=v.cmp($.segment);if(f>0)p.push([-1,$]),$=$.left;else if(f<0)p.push([1,$]),$=$.right;else if(v.hasNext())v.next(),p.push([0,$]),$=$.mid;else break}if($){if(m?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const f=this.f($.right);if(f.key){const{key:l,value:d,segment:a}=f;this.e(f.key,!1),$.key=l,$.value=d,$.segment=a}}else{const f=$.left??$.right;if(p.length>0){const[l,d]=p[p.length-1];switch(l){case-1:d.left=f;break;case 0:d.mid=f;break;case 1:d.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const l=p[f][1];l.updateHeight();const d=l.balanceFactor();if(d>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),p[f][1]=l.rotateLeft()):d<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),p[f][1]=l.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let v=this.c,p;for(;v;){const $=m.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(m.hasNext())m.next(),p=v.value||p,v=v.mid;else break}return v&&v.value||p}findSuperstr(w){return this.g(w,!1)}g(w,m){const v=this.b.reset(w);let p=this.c;for(;p;){const $=v.cmp(p.segment);if($>0)p=p.left;else if($<0)p=p.right;else if(v.hasNext())v.next(),p=p.mid;else return p.mid?this.h(p.mid):m?p.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[m,v]of this)w(v,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const m=[];return this.j(w,m),m[Symbol.iterator]()}j(w,m){w&&(w.left&&this.j(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.j(w.mid,m),w.right&&this.j(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const v=m.balanceFactor();return v<-1||v>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.$ti=y}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=i,e.$2f=R,e.$3f=S,e.$4f=M,e.$5f=P,e.$6f=E,e.$7f=h,e.$8f=u,e.$9f=g,e.$0f=y,e.$$f=k,e.$_f=w,e.$ag=m,e.$bg=p,e.$cg=$,e.$dg=f,e.$eg=l,e.$fg=d;function i(a){return typeof a=="string"}function R(a){return Array.isArray(a)&&a.every(t=>i(t))}function S(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function M(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function P(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function u(a){return typeof a>"u"}function g(a){return!y(a)}function y(a){return u(a)||a===null}function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function w(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function m(...a){const t=[];for(let o=0;o<a.length;o++){const s=a[o];if(y(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}const v=Object.prototype.hasOwnProperty;function p(a){if(!S(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function $(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every($)}function l(a,t){const o=Math.min(a.length,t.length);for(let s=0;s<o;s++)d(a[s],t[s])}function d(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[105],ae([0,1,12]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=S,e.$Ij=M;const R=Object.create(null);function S(P,E){if((0,i.$1f)(E)){const h=R[E];if(h===void 0)throw new Error(`${P} references an unknown codicon: ${E}`);E=h}return R[P]=E,{id:P}}function M(){return R}}),define(oe[145],ae([0,1,105]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=void 0,e.$Jj={add:(0,i.$Hj)("add",6e4),plus:(0,i.$Hj)("plus",6e4),gistNew:(0,i.$Hj)("gist-new",6e4),repoCreate:(0,i.$Hj)("repo-create",6e4),lightbulb:(0,i.$Hj)("lightbulb",60001),lightBulb:(0,i.$Hj)("light-bulb",60001),repo:(0,i.$Hj)("repo",60002),repoDelete:(0,i.$Hj)("repo-delete",60002),gistFork:(0,i.$Hj)("gist-fork",60003),repoForked:(0,i.$Hj)("repo-forked",60003),gitPullRequest:(0,i.$Hj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Hj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Hj)("record-keys",60005),keyboard:(0,i.$Hj)("keyboard",60005),tag:(0,i.$Hj)("tag",60006),gitPullRequestLabel:(0,i.$Hj)("git-pull-request-label",60006),tagAdd:(0,i.$Hj)("tag-add",60006),tagRemove:(0,i.$Hj)("tag-remove",60006),person:(0,i.$Hj)("person",60007),personFollow:(0,i.$Hj)("person-follow",60007),personOutline:(0,i.$Hj)("person-outline",60007),personFilled:(0,i.$Hj)("person-filled",60007),gitBranch:(0,i.$Hj)("git-branch",60008),gitBranchCreate:(0,i.$Hj)("git-branch-create",60008),gitBranchDelete:(0,i.$Hj)("git-branch-delete",60008),sourceControl:(0,i.$Hj)("source-control",60008),mirror:(0,i.$Hj)("mirror",60009),mirrorPublic:(0,i.$Hj)("mirror-public",60009),star:(0,i.$Hj)("star",60010),starAdd:(0,i.$Hj)("star-add",60010),starDelete:(0,i.$Hj)("star-delete",60010),starEmpty:(0,i.$Hj)("star-empty",60010),comment:(0,i.$Hj)("comment",60011),commentAdd:(0,i.$Hj)("comment-add",60011),alert:(0,i.$Hj)("alert",60012),warning:(0,i.$Hj)("warning",60012),search:(0,i.$Hj)("search",60013),searchSave:(0,i.$Hj)("search-save",60013),logOut:(0,i.$Hj)("log-out",60014),signOut:(0,i.$Hj)("sign-out",60014),logIn:(0,i.$Hj)("log-in",60015),signIn:(0,i.$Hj)("sign-in",60015),eye:(0,i.$Hj)("eye",60016),eyeUnwatch:(0,i.$Hj)("eye-unwatch",60016),eyeWatch:(0,i.$Hj)("eye-watch",60016),circleFilled:(0,i.$Hj)("circle-filled",60017),primitiveDot:(0,i.$Hj)("primitive-dot",60017),closeDirty:(0,i.$Hj)("close-dirty",60017),debugBreakpoint:(0,i.$Hj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Hj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Hj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Hj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Hj)("primitive-square",60018),edit:(0,i.$Hj)("edit",60019),pencil:(0,i.$Hj)("pencil",60019),info:(0,i.$Hj)("info",60020),issueOpened:(0,i.$Hj)("issue-opened",60020),gistPrivate:(0,i.$Hj)("gist-private",60021),gitForkPrivate:(0,i.$Hj)("git-fork-private",60021),lock:(0,i.$Hj)("lock",60021),mirrorPrivate:(0,i.$Hj)("mirror-private",60021),close:(0,i.$Hj)("close",60022),removeClose:(0,i.$Hj)("remove-close",60022),x:(0,i.$Hj)("x",60022),repoSync:(0,i.$Hj)("repo-sync",60023),sync:(0,i.$Hj)("sync",60023),clone:(0,i.$Hj)("clone",60024),desktopDownload:(0,i.$Hj)("desktop-download",60024),beaker:(0,i.$Hj)("beaker",60025),microscope:(0,i.$Hj)("microscope",60025),vm:(0,i.$Hj)("vm",60026),deviceDesktop:(0,i.$Hj)("device-desktop",60026),file:(0,i.$Hj)("file",60027),fileText:(0,i.$Hj)("file-text",60027),more:(0,i.$Hj)("more",60028),ellipsis:(0,i.$Hj)("ellipsis",60028),kebabHorizontal:(0,i.$Hj)("kebab-horizontal",60028),mailReply:(0,i.$Hj)("mail-reply",60029),reply:(0,i.$Hj)("reply",60029),organization:(0,i.$Hj)("organization",60030),organizationFilled:(0,i.$Hj)("organization-filled",60030),organizationOutline:(0,i.$Hj)("organization-outline",60030),newFile:(0,i.$Hj)("new-file",60031),fileAdd:(0,i.$Hj)("file-add",60031),newFolder:(0,i.$Hj)("new-folder",60032),fileDirectoryCreate:(0,i.$Hj)("file-directory-create",60032),trash:(0,i.$Hj)("trash",60033),trashcan:(0,i.$Hj)("trashcan",60033),history:(0,i.$Hj)("history",60034),clock:(0,i.$Hj)("clock",60034),folder:(0,i.$Hj)("folder",60035),fileDirectory:(0,i.$Hj)("file-directory",60035),symbolFolder:(0,i.$Hj)("symbol-folder",60035),logoGithub:(0,i.$Hj)("logo-github",60036),markGithub:(0,i.$Hj)("mark-github",60036),github:(0,i.$Hj)("github",60036),terminal:(0,i.$Hj)("terminal",60037),console:(0,i.$Hj)("console",60037),repl:(0,i.$Hj)("repl",60037),zap:(0,i.$Hj)("zap",60038),symbolEvent:(0,i.$Hj)("symbol-event",60038),error:(0,i.$Hj)("error",60039),stop:(0,i.$Hj)("stop",60039),variable:(0,i.$Hj)("variable",60040),symbolVariable:(0,i.$Hj)("symbol-variable",60040),array:(0,i.$Hj)("array",60042),symbolArray:(0,i.$Hj)("symbol-array",60042),symbolModule:(0,i.$Hj)("symbol-module",60043),symbolPackage:(0,i.$Hj)("symbol-package",60043),symbolNamespace:(0,i.$Hj)("symbol-namespace",60043),symbolObject:(0,i.$Hj)("symbol-object",60043),symbolMethod:(0,i.$Hj)("symbol-method",60044),symbolFunction:(0,i.$Hj)("symbol-function",60044),symbolConstructor:(0,i.$Hj)("symbol-constructor",60044),symbolBoolean:(0,i.$Hj)("symbol-boolean",60047),symbolNull:(0,i.$Hj)("symbol-null",60047),symbolNumeric:(0,i.$Hj)("symbol-numeric",60048),symbolNumber:(0,i.$Hj)("symbol-number",60048),symbolStructure:(0,i.$Hj)("symbol-structure",60049),symbolStruct:(0,i.$Hj)("symbol-struct",60049),symbolParameter:(0,i.$Hj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Hj)("symbol-type-parameter",60050),symbolKey:(0,i.$Hj)("symbol-key",60051),symbolText:(0,i.$Hj)("symbol-text",60051),symbolReference:(0,i.$Hj)("symbol-reference",60052),goToFile:(0,i.$Hj)("go-to-file",60052),symbolEnum:(0,i.$Hj)("symbol-enum",60053),symbolValue:(0,i.$Hj)("symbol-value",60053),symbolRuler:(0,i.$Hj)("symbol-ruler",60054),symbolUnit:(0,i.$Hj)("symbol-unit",60054),activateBreakpoints:(0,i.$Hj)("activate-breakpoints",60055),archive:(0,i.$Hj)("archive",60056),arrowBoth:(0,i.$Hj)("arrow-both",60057),arrowDown:(0,i.$Hj)("arrow-down",60058),arrowLeft:(0,i.$Hj)("arrow-left",60059),arrowRight:(0,i.$Hj)("arrow-right",60060),arrowSmallDown:(0,i.$Hj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Hj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Hj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Hj)("arrow-small-up",60064),arrowUp:(0,i.$Hj)("arrow-up",60065),bell:(0,i.$Hj)("bell",60066),bold:(0,i.$Hj)("bold",60067),book:(0,i.$Hj)("book",60068),bookmark:(0,i.$Hj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Hj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Hj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Hj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Hj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Hj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Hj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Hj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Hj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Hj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Hj)("briefcase",60076),broadcast:(0,i.$Hj)("broadcast",60077),browser:(0,i.$Hj)("browser",60078),bug:(0,i.$Hj)("bug",60079),calendar:(0,i.$Hj)("calendar",60080),caseSensitive:(0,i.$Hj)("case-sensitive",60081),check:(0,i.$Hj)("check",60082),checklist:(0,i.$Hj)("checklist",60083),chevronDown:(0,i.$Hj)("chevron-down",60084),chevronLeft:(0,i.$Hj)("chevron-left",60085),chevronRight:(0,i.$Hj)("chevron-right",60086),chevronUp:(0,i.$Hj)("chevron-up",60087),chromeClose:(0,i.$Hj)("chrome-close",60088),chromeMaximize:(0,i.$Hj)("chrome-maximize",60089),chromeMinimize:(0,i.$Hj)("chrome-minimize",60090),chromeRestore:(0,i.$Hj)("chrome-restore",60091),circleOutline:(0,i.$Hj)("circle-outline",60092),circle:(0,i.$Hj)("circle",60092),debugBreakpointUnverified:(0,i.$Hj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Hj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Hj)("circle-slash",60093),circuitBoard:(0,i.$Hj)("circuit-board",60094),clearAll:(0,i.$Hj)("clear-all",60095),clippy:(0,i.$Hj)("clippy",60096),closeAll:(0,i.$Hj)("close-all",60097),cloudDownload:(0,i.$Hj)("cloud-download",60098),cloudUpload:(0,i.$Hj)("cloud-upload",60099),code:(0,i.$Hj)("code",60100),collapseAll:(0,i.$Hj)("collapse-all",60101),colorMode:(0,i.$Hj)("color-mode",60102),commentDiscussion:(0,i.$Hj)("comment-discussion",60103),creditCard:(0,i.$Hj)("credit-card",60105),dash:(0,i.$Hj)("dash",60108),dashboard:(0,i.$Hj)("dashboard",60109),database:(0,i.$Hj)("database",60110),debugContinue:(0,i.$Hj)("debug-continue",60111),debugDisconnect:(0,i.$Hj)("debug-disconnect",60112),debugPause:(0,i.$Hj)("debug-pause",60113),debugRestart:(0,i.$Hj)("debug-restart",60114),debugStart:(0,i.$Hj)("debug-start",60115),debugStepInto:(0,i.$Hj)("debug-step-into",60116),debugStepOut:(0,i.$Hj)("debug-step-out",60117),debugStepOver:(0,i.$Hj)("debug-step-over",60118),debugStop:(0,i.$Hj)("debug-stop",60119),debug:(0,i.$Hj)("debug",60120),deviceCameraVideo:(0,i.$Hj)("device-camera-video",60121),deviceCamera:(0,i.$Hj)("device-camera",60122),deviceMobile:(0,i.$Hj)("device-mobile",60123),diffAdded:(0,i.$Hj)("diff-added",60124),diffIgnored:(0,i.$Hj)("diff-ignored",60125),diffModified:(0,i.$Hj)("diff-modified",60126),diffRemoved:(0,i.$Hj)("diff-removed",60127),diffRenamed:(0,i.$Hj)("diff-renamed",60128),diff:(0,i.$Hj)("diff",60129),diffSidebyside:(0,i.$Hj)("diff-sidebyside",60129),discard:(0,i.$Hj)("discard",60130),editorLayout:(0,i.$Hj)("editor-layout",60131),emptyWindow:(0,i.$Hj)("empty-window",60132),exclude:(0,i.$Hj)("exclude",60133),extensions:(0,i.$Hj)("extensions",60134),eyeClosed:(0,i.$Hj)("eye-closed",60135),fileBinary:(0,i.$Hj)("file-binary",60136),fileCode:(0,i.$Hj)("file-code",60137),fileMedia:(0,i.$Hj)("file-media",60138),filePdf:(0,i.$Hj)("file-pdf",60139),fileSubmodule:(0,i.$Hj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Hj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Hj)("file-symlink-file",60142),fileZip:(0,i.$Hj)("file-zip",60143),files:(0,i.$Hj)("files",60144),filter:(0,i.$Hj)("filter",60145),flame:(0,i.$Hj)("flame",60146),foldDown:(0,i.$Hj)("fold-down",60147),foldUp:(0,i.$Hj)("fold-up",60148),fold:(0,i.$Hj)("fold",60149),folderActive:(0,i.$Hj)("folder-active",60150),folderOpened:(0,i.$Hj)("folder-opened",60151),gear:(0,i.$Hj)("gear",60152),gift:(0,i.$Hj)("gift",60153),gistSecret:(0,i.$Hj)("gist-secret",60154),gist:(0,i.$Hj)("gist",60155),gitCommit:(0,i.$Hj)("git-commit",60156),gitCompare:(0,i.$Hj)("git-compare",60157),compareChanges:(0,i.$Hj)("compare-changes",60157),gitMerge:(0,i.$Hj)("git-merge",60158),githubAction:(0,i.$Hj)("github-action",60159),githubAlt:(0,i.$Hj)("github-alt",60160),globe:(0,i.$Hj)("globe",60161),grabber:(0,i.$Hj)("grabber",60162),graph:(0,i.$Hj)("graph",60163),gripper:(0,i.$Hj)("gripper",60164),heart:(0,i.$Hj)("heart",60165),home:(0,i.$Hj)("home",60166),horizontalRule:(0,i.$Hj)("horizontal-rule",60167),hubot:(0,i.$Hj)("hubot",60168),inbox:(0,i.$Hj)("inbox",60169),issueReopened:(0,i.$Hj)("issue-reopened",60171),issues:(0,i.$Hj)("issues",60172),italic:(0,i.$Hj)("italic",60173),jersey:(0,i.$Hj)("jersey",60174),json:(0,i.$Hj)("json",60175),kebabVertical:(0,i.$Hj)("kebab-vertical",60176),key:(0,i.$Hj)("key",60177),law:(0,i.$Hj)("law",60178),lightbulbAutofix:(0,i.$Hj)("lightbulb-autofix",60179),linkExternal:(0,i.$Hj)("link-external",60180),link:(0,i.$Hj)("link",60181),listOrdered:(0,i.$Hj)("list-ordered",60182),listUnordered:(0,i.$Hj)("list-unordered",60183),liveShare:(0,i.$Hj)("live-share",60184),loading:(0,i.$Hj)("loading",60185),location:(0,i.$Hj)("location",60186),mailRead:(0,i.$Hj)("mail-read",60187),mail:(0,i.$Hj)("mail",60188),markdown:(0,i.$Hj)("markdown",60189),megaphone:(0,i.$Hj)("megaphone",60190),mention:(0,i.$Hj)("mention",60191),milestone:(0,i.$Hj)("milestone",60192),gitPullRequestMilestone:(0,i.$Hj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Hj)("mortar-board",60193),move:(0,i.$Hj)("move",60194),multipleWindows:(0,i.$Hj)("multiple-windows",60195),mute:(0,i.$Hj)("mute",60196),noNewline:(0,i.$Hj)("no-newline",60197),note:(0,i.$Hj)("note",60198),octoface:(0,i.$Hj)("octoface",60199),openPreview:(0,i.$Hj)("open-preview",60200),package:(0,i.$Hj)("package",60201),paintcan:(0,i.$Hj)("paintcan",60202),pin:(0,i.$Hj)("pin",60203),play:(0,i.$Hj)("play",60204),run:(0,i.$Hj)("run",60204),plug:(0,i.$Hj)("plug",60205),preserveCase:(0,i.$Hj)("preserve-case",60206),preview:(0,i.$Hj)("preview",60207),project:(0,i.$Hj)("project",60208),pulse:(0,i.$Hj)("pulse",60209),question:(0,i.$Hj)("question",60210),quote:(0,i.$Hj)("quote",60211),radioTower:(0,i.$Hj)("radio-tower",60212),reactions:(0,i.$Hj)("reactions",60213),references:(0,i.$Hj)("references",60214),refresh:(0,i.$Hj)("refresh",60215),regex:(0,i.$Hj)("regex",60216),remoteExplorer:(0,i.$Hj)("remote-explorer",60217),remote:(0,i.$Hj)("remote",60218),remove:(0,i.$Hj)("remove",60219),replaceAll:(0,i.$Hj)("replace-all",60220),replace:(0,i.$Hj)("replace",60221),repoClone:(0,i.$Hj)("repo-clone",60222),repoForcePush:(0,i.$Hj)("repo-force-push",60223),repoPull:(0,i.$Hj)("repo-pull",60224),repoPush:(0,i.$Hj)("repo-push",60225),report:(0,i.$Hj)("report",60226),requestChanges:(0,i.$Hj)("request-changes",60227),rocket:(0,i.$Hj)("rocket",60228),rootFolderOpened:(0,i.$Hj)("root-folder-opened",60229),rootFolder:(0,i.$Hj)("root-folder",60230),rss:(0,i.$Hj)("rss",60231),ruby:(0,i.$Hj)("ruby",60232),saveAll:(0,i.$Hj)("save-all",60233),saveAs:(0,i.$Hj)("save-as",60234),save:(0,i.$Hj)("save",60235),screenFull:(0,i.$Hj)("screen-full",60236),screenNormal:(0,i.$Hj)("screen-normal",60237),searchStop:(0,i.$Hj)("search-stop",60238),server:(0,i.$Hj)("server",60240),settingsGear:(0,i.$Hj)("settings-gear",60241),settings:(0,i.$Hj)("settings",60242),shield:(0,i.$Hj)("shield",60243),smiley:(0,i.$Hj)("smiley",60244),sortPrecedence:(0,i.$Hj)("sort-precedence",60245),splitHorizontal:(0,i.$Hj)("split-horizontal",60246),splitVertical:(0,i.$Hj)("split-vertical",60247),squirrel:(0,i.$Hj)("squirrel",60248),starFull:(0,i.$Hj)("star-full",60249),starHalf:(0,i.$Hj)("star-half",60250),symbolClass:(0,i.$Hj)("symbol-class",60251),symbolColor:(0,i.$Hj)("symbol-color",60252),symbolConstant:(0,i.$Hj)("symbol-constant",60253),symbolEnumMember:(0,i.$Hj)("symbol-enum-member",60254),symbolField:(0,i.$Hj)("symbol-field",60255),symbolFile:(0,i.$Hj)("symbol-file",60256),symbolInterface:(0,i.$Hj)("symbol-interface",60257),symbolKeyword:(0,i.$Hj)("symbol-keyword",60258),symbolMisc:(0,i.$Hj)("symbol-misc",60259),symbolOperator:(0,i.$Hj)("symbol-operator",60260),symbolProperty:(0,i.$Hj)("symbol-property",60261),wrench:(0,i.$Hj)("wrench",60261),wrenchSubaction:(0,i.$Hj)("wrench-subaction",60261),symbolSnippet:(0,i.$Hj)("symbol-snippet",60262),tasklist:(0,i.$Hj)("tasklist",60263),telescope:(0,i.$Hj)("telescope",60264),textSize:(0,i.$Hj)("text-size",60265),threeBars:(0,i.$Hj)("three-bars",60266),thumbsdown:(0,i.$Hj)("thumbsdown",60267),thumbsup:(0,i.$Hj)("thumbsup",60268),tools:(0,i.$Hj)("tools",60269),triangleDown:(0,i.$Hj)("triangle-down",60270),triangleLeft:(0,i.$Hj)("triangle-left",60271),triangleRight:(0,i.$Hj)("triangle-right",60272),triangleUp:(0,i.$Hj)("triangle-up",60273),twitter:(0,i.$Hj)("twitter",60274),unfold:(0,i.$Hj)("unfold",60275),unlock:(0,i.$Hj)("unlock",60276),unmute:(0,i.$Hj)("unmute",60277),unverified:(0,i.$Hj)("unverified",60278),verified:(0,i.$Hj)("verified",60279),versions:(0,i.$Hj)("versions",60280),vmActive:(0,i.$Hj)("vm-active",60281),vmOutline:(0,i.$Hj)("vm-outline",60282),vmRunning:(0,i.$Hj)("vm-running",60283),watch:(0,i.$Hj)("watch",60284),whitespace:(0,i.$Hj)("whitespace",60285),wholeWord:(0,i.$Hj)("whole-word",60286),window:(0,i.$Hj)("window",60287),wordWrap:(0,i.$Hj)("word-wrap",60288),zoomIn:(0,i.$Hj)("zoom-in",60289),zoomOut:(0,i.$Hj)("zoom-out",60290),listFilter:(0,i.$Hj)("list-filter",60291),listFlat:(0,i.$Hj)("list-flat",60292),listSelection:(0,i.$Hj)("list-selection",60293),selection:(0,i.$Hj)("selection",60293),listTree:(0,i.$Hj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Hj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Hj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Hj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Hj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Hj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Hj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Hj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Hj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Hj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Hj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Hj)("symbol-string",60301),debugReverseContinue:(0,i.$Hj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Hj)("debug-step-back",60303),debugRestartFrame:(0,i.$Hj)("debug-restart-frame",60304),debugAlt:(0,i.$Hj)("debug-alt",60305),callIncoming:(0,i.$Hj)("call-incoming",60306),callOutgoing:(0,i.$Hj)("call-outgoing",60307),menu:(0,i.$Hj)("menu",60308),expandAll:(0,i.$Hj)("expand-all",60309),feedback:(0,i.$Hj)("feedback",60310),gitPullRequestReviewer:(0,i.$Hj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Hj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Hj)("ungroup-by-ref-type",60312),account:(0,i.$Hj)("account",60313),gitPullRequestAssignee:(0,i.$Hj)("git-pull-request-assignee",60313),bellDot:(0,i.$Hj)("bell-dot",60314),debugConsole:(0,i.$Hj)("debug-console",60315),library:(0,i.$Hj)("library",60316),output:(0,i.$Hj)("output",60317),runAll:(0,i.$Hj)("run-all",60318),syncIgnored:(0,i.$Hj)("sync-ignored",60319),pinned:(0,i.$Hj)("pinned",60320),githubInverted:(0,i.$Hj)("github-inverted",60321),serverProcess:(0,i.$Hj)("server-process",60322),serverEnvironment:(0,i.$Hj)("server-environment",60323),pass:(0,i.$Hj)("pass",60324),issueClosed:(0,i.$Hj)("issue-closed",60324),stopCircle:(0,i.$Hj)("stop-circle",60325),playCircle:(0,i.$Hj)("play-circle",60326),record:(0,i.$Hj)("record",60327),debugAltSmall:(0,i.$Hj)("debug-alt-small",60328),vmConnect:(0,i.$Hj)("vm-connect",60329),cloud:(0,i.$Hj)("cloud",60330),merge:(0,i.$Hj)("merge",60331),export:(0,i.$Hj)("export",60332),graphLeft:(0,i.$Hj)("graph-left",60333),magnet:(0,i.$Hj)("magnet",60334),notebook:(0,i.$Hj)("notebook",60335),redo:(0,i.$Hj)("redo",60336),checkAll:(0,i.$Hj)("check-all",60337),pinnedDirty:(0,i.$Hj)("pinned-dirty",60338),passFilled:(0,i.$Hj)("pass-filled",60339),circleLargeFilled:(0,i.$Hj)("circle-large-filled",60340),circleLarge:(0,i.$Hj)("circle-large",60341),circleLargeOutline:(0,i.$Hj)("circle-large-outline",60341),combine:(0,i.$Hj)("combine",60342),gather:(0,i.$Hj)("gather",60342),table:(0,i.$Hj)("table",60343),variableGroup:(0,i.$Hj)("variable-group",60344),typeHierarchy:(0,i.$Hj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Hj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Hj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Hj)("git-pull-request-create",60348),runAbove:(0,i.$Hj)("run-above",60349),runBelow:(0,i.$Hj)("run-below",60350),notebookTemplate:(0,i.$Hj)("notebook-template",60351),debugRerun:(0,i.$Hj)("debug-rerun",60352),workspaceTrusted:(0,i.$Hj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Hj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Hj)("workspace-unknown",60355),terminalCmd:(0,i.$Hj)("terminal-cmd",60356),terminalDebian:(0,i.$Hj)("terminal-debian",60357),terminalLinux:(0,i.$Hj)("terminal-linux",60358),terminalPowershell:(0,i.$Hj)("terminal-powershell",60359),terminalTmux:(0,i.$Hj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Hj)("terminal-ubuntu",60361),terminalBash:(0,i.$Hj)("terminal-bash",60362),arrowSwap:(0,i.$Hj)("arrow-swap",60363),copy:(0,i.$Hj)("copy",60364),personAdd:(0,i.$Hj)("person-add",60365),filterFilled:(0,i.$Hj)("filter-filled",60366),wand:(0,i.$Hj)("wand",60367),debugLineByLine:(0,i.$Hj)("debug-line-by-line",60368),inspect:(0,i.$Hj)("inspect",60369),layers:(0,i.$Hj)("layers",60370),layersDot:(0,i.$Hj)("layers-dot",60371),layersActive:(0,i.$Hj)("layers-active",60372),compass:(0,i.$Hj)("compass",60373),compassDot:(0,i.$Hj)("compass-dot",60374),compassActive:(0,i.$Hj)("compass-active",60375),azure:(0,i.$Hj)("azure",60376),issueDraft:(0,i.$Hj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Hj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Hj)("git-pull-request-draft",60379),debugAll:(0,i.$Hj)("debug-all",60380),debugCoverage:(0,i.$Hj)("debug-coverage",60381),runErrors:(0,i.$Hj)("run-errors",60382),folderLibrary:(0,i.$Hj)("folder-library",60383),debugContinueSmall:(0,i.$Hj)("debug-continue-small",60384),beakerStop:(0,i.$Hj)("beaker-stop",60385),graphLine:(0,i.$Hj)("graph-line",60386),graphScatter:(0,i.$Hj)("graph-scatter",60387),pieChart:(0,i.$Hj)("pie-chart",60388),bracket:(0,i.$Hj)("bracket",60175),bracketDot:(0,i.$Hj)("bracket-dot",60389),bracketError:(0,i.$Hj)("bracket-error",60390),lockSmall:(0,i.$Hj)("lock-small",60391),azureDevops:(0,i.$Hj)("azure-devops",60392),verifiedFilled:(0,i.$Hj)("verified-filled",60393),newline:(0,i.$Hj)("newline",60394),layout:(0,i.$Hj)("layout",60395),layoutActivitybarLeft:(0,i.$Hj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Hj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Hj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Hj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Hj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Hj)("layout-panel-right",60401),layoutPanel:(0,i.$Hj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Hj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Hj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Hj)("layout-statusbar",60405),layoutMenubar:(0,i.$Hj)("layout-menubar",60406),layoutCentered:(0,i.$Hj)("layout-centered",60407),target:(0,i.$Hj)("target",60408),indent:(0,i.$Hj)("indent",60409),recordSmall:(0,i.$Hj)("record-small",60410),errorSmall:(0,i.$Hj)("error-small",60411),terminalDecorationError:(0,i.$Hj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Hj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Hj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Hj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Hj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Hj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Hj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Hj)("layout-sidebar-left-off",60418),blank:(0,i.$Hj)("blank",60419),heartFilled:(0,i.$Hj)("heart-filled",60420),map:(0,i.$Hj)("map",60421),mapHorizontal:(0,i.$Hj)("map-horizontal",60421),foldHorizontal:(0,i.$Hj)("fold-horizontal",60421),mapFilled:(0,i.$Hj)("map-filled",60422),mapHorizontalFilled:(0,i.$Hj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Hj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Hj)("circle-small",60423),bellSlash:(0,i.$Hj)("bell-slash",60424),bellSlashDot:(0,i.$Hj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Hj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Hj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Hj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Hj)("search-fuzzy",60429),commentDraft:(0,i.$Hj)("comment-draft",60430),send:(0,i.$Hj)("send",60431),sparkle:(0,i.$Hj)("sparkle",60432),insert:(0,i.$Hj)("insert",60433),mic:(0,i.$Hj)("mic",60434),thumbsdownFilled:(0,i.$Hj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Hj)("thumbsup-filled",60436),coffee:(0,i.$Hj)("coffee",60437),snake:(0,i.$Hj)("snake",60438),game:(0,i.$Hj)("game",60439),vr:(0,i.$Hj)("vr",60440),chip:(0,i.$Hj)("chip",60441),piano:(0,i.$Hj)("piano",60442),music:(0,i.$Hj)("music",60443),micFilled:(0,i.$Hj)("mic-filled",60444),repoFetch:(0,i.$Hj)("repo-fetch",60445),copilot:(0,i.$Hj)("copilot",60446),lightbulbSparkle:(0,i.$Hj)("lightbulb-sparkle",60447),robot:(0,i.$Hj)("robot",60448),sparkleFilled:(0,i.$Hj)("sparkle-filled",60449),diffSingle:(0,i.$Hj)("diff-single",60450),diffMultiple:(0,i.$Hj)("diff-multiple",60451),surroundWith:(0,i.$Hj)("surround-with",60452),share:(0,i.$Hj)("share",60453),gitStash:(0,i.$Hj)("git-stash",60454),gitStashApply:(0,i.$Hj)("git-stash-apply",60455),gitStashPop:(0,i.$Hj)("git-stash-pop",60456),vscode:(0,i.$Hj)("vscode",60457),vscodeInsiders:(0,i.$Hj)("vscode-insiders",60458),codeOss:(0,i.$Hj)("code-oss",60459),runCoverage:(0,i.$Hj)("run-coverage",60460),runAllCoverage:(0,i.$Hj)("run-all-coverage",60461),coverage:(0,i.$Hj)("coverage",60462),githubProject:(0,i.$Hj)("github-project",60463),mapVertical:(0,i.$Hj)("map-vertical",60464),foldVertical:(0,i.$Hj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Hj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Hj)("fold-vertical-filled",60465)}}),define(oe[75],ae([0,1,105,145]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=void 0,e.$Kj=S;function S(){return Object.values(e.$Mj)}e.$Lj={dialogError:(0,i.$Hj)("dialog-error","error"),dialogWarning:(0,i.$Hj)("dialog-warning","warning"),dialogInfo:(0,i.$Hj)("dialog-info","info"),dialogClose:(0,i.$Hj)("dialog-close","close"),treeItemExpanded:(0,i.$Hj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Hj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Hj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Hj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Hj)("tree-item-loading","loading"),menuSelection:(0,i.$Hj)("menu-selection","check"),menuSubmenu:(0,i.$Hj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Hj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Hj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Hj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Hj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Hj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Hj)("toolbar-more","more"),quickInputBack:(0,i.$Hj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Hj)("drop-down-button",60084),symbolCustomColor:(0,i.$Hj)("symbol-customcolor",60252),exportIcon:(0,i.$Hj)("export",60332),workspaceUnspecified:(0,i.$Hj)("workspace-unspecified",60355),newLine:(0,i.$Hj)("newline",60394),thumbsDownFilled:(0,i.$Hj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Hj)("thumbsup-filled",60436),gitFetch:(0,i.$Hj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Hj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Hj)("debug-breakpoint-pending",60377)},e.$Mj={...R.$Jj,...e.$Lj}}),define(oe[35],ae([0,1,12]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=R,e.$Un=S,e.$Vn=P,e.$Wn=h,e.$Xn=u,e.$Yn=g,e.$Zn=y,e.$1n=k,e.$2n=w,e.$3n=m,e.$4n=v,e.$5n=p;function R($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const f=Array.isArray($)?[]:{};return Object.entries($).forEach(([l,d])=>{f[l]=d&&typeof d=="object"?R(d):d}),f}function S($){if(!$||typeof $!="object")return $;const f=[$];for(;f.length>0;){const l=f.shift();Object.freeze(l);for(const d in l)if(M.call(l,d)){const a=l[d];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.$4f)(a)&&f.push(a)}}return $}const M=Object.prototype.hasOwnProperty;function P($,f){return E($,f,new Set)}function E($,f,l){if((0,i.$0f)($))return $;const d=f($);if(typeof d<"u")return d;if(Array.isArray($)){const a=[];for(const t of $)a.push(E(t,f,l));return a}if((0,i.$3f)($)){if(l.has($))throw new Error("Cannot clone recursive data-structure");l.add($);const a={};for(const t in $)M.call($,t)&&(a[t]=E($[t],f,l));return l.delete($),a}return $}function h($,f,l=!0){return(0,i.$3f)($)?((0,i.$3f)(f)&&Object.keys(f).forEach(d=>{d in $?l&&((0,i.$3f)($[d])&&(0,i.$3f)(f[d])?h($[d],f[d],l):$[d]=f[d]):$[d]=f[d]}),$):f}function u($,f){if($===f)return!0;if($==null||f===null||f===void 0||typeof $!=typeof f||typeof $!="object"||Array.isArray($)!==Array.isArray(f))return!1;let l,d;if(Array.isArray($)){if($.length!==f.length)return!1;for(l=0;l<$.length;l++)if(!u($[l],f[l]))return!1}else{const a=[];for(d in $)a.push(d);a.sort();const t=[];for(d in f)t.push(d);if(t.sort(),!u(a,t))return!1;for(l=0;l<a.length;l++)if(!u($[a[l]],f[a[l]]))return!1}return!0}function g($){const f=new Set;return JSON.stringify($,(l,d)=>{if((0,i.$3f)(d)||Array.isArray(d)){if(f.has(d))return"[Circular]";f.add(d)}return d})}function y($,f){const l=Object.create(null);return!$||!f||Object.keys(f).forEach(a=>{const t=$[a],o=f[a];u(t,o)||(l[a]=o)}),l}function k($,f){const l=f.toLowerCase(),d=Object.keys($).find(a=>a.toLowerCase()===l);return d?$[d]:$[f]}function w($,f){const l=Object.create(null);for(const[d,a]of Object.entries($))f(d,a)&&(l[d]=a);return l}function m($){let f=[];for(;Object.prototype!==$;)f=f.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return f}function v($){const f=[];for(const l of m($))typeof $[l]=="function"&&f.push(l);return f}function p($,f){const l=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},d={};for(const a of $)d[a]=l(a);return d}}),define(oe[106],ae([0,1,75]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Nj=S;var R;(function(P){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}P.isThemeColor=E})(R||(e.ThemeColor=R={}));function S(P){return{id:P}}var M;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function h(f){const l=E.exec(f.id);if(!l)return h(i.$Mj.error);const[,d,a]=l,t=["codicon","codicon-"+d];return a&&t.push("codicon-modifier-"+a.substring(1)),t}P.asClassNameArray=h;function u(f){return h(f).join(" ")}P.asClassName=u;function g(f){return"."+h(f).join(".")}P.asCSSSelector=g;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||R.isThemeColor(f.color))}P.isThemeIcon=y;const k=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function w(f){const l=k.exec(f);if(!l)return;const[,d]=l;return{id:d}}P.fromString=w;function m(f){return{id:f}}P.fromId=m;function v(f,l){let d=f.id;const a=d.lastIndexOf("~");return a!==-1&&(d=d.substring(0,a)),l&&(d=`${d}~${l}`),{id:d}}P.modify=v;function p(f){const l=f.id.lastIndexOf("~");if(l!==-1)return f.id.substring(l+1)}P.getModifier=p;function $(f,l){return f.id===l.id&&f.color?.id===l.color?.id}P.isEqual=$})(M||(e.ThemeIcon=M={}))}),define(oe[33],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=R;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(S){return i.test(S)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const M=new Uint8Array(16),P=[];for(let E=0;E<256;E++)P.push(E.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,u="";return u+=P[M[h++]],u+=P[M[h++]],u+=P[M[h++]],u+=P[M[h++]],u+="-",u+=P[M[h++]],u+=P[M[h++]],u+="-",u+=P[M[h++]],u+=P[M[h++]],u+="-",u+=P[M[h++]],u+=P[M[h++]],u+="-",u+=P[M[h++]],u+=P[M[h++]],u+=P[M[h++]],u+=P[M[h++]],u+=P[M[h++]],u+=P[M[h++]],u}}()}),define(oe[146],ae([0,1,87,43,86]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cW=M;async function M(P,E){if(await new Promise((g,y)=>{const k=R.createReadStream(P),w=i.createHash("sha256");k.pipe(w);const m=(0,S.$db)((v,p)=>{k.removeAllListeners(),w.removeAllListeners(),v?y(v):g(p)});k.once("error",m),k.once("end",m),w.once("error",m),w.once("data",v=>m(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(oe[147],ae([0,1,26]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=M;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(P){const E=P.replace(/\-/g,":").toLowerCase();return!R.has(E)}function M(){const P=(0,i.networkInterfaces)();for(const E in P){const h=P[E];if(h){for(const{mac:u}of h)if(S(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[107],ae([0,1,88]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=R,e.$Ng=M;function R(E,h,u,g=1){let y=!1;return new Promise(k=>{const w=setTimeout(()=>{if(!y)return y=!0,k(0)},u);S(E,h,g,m=>{if(!y)return y=!0,clearTimeout(w),k(m)})})}function S(E,h,u,g){if(h===0)return g(0);const y=new i.Socket;y.once("connect",()=>(P(y),S(E+u,h-1,u,g))),y.once("data",()=>{}),y.once("error",k=>(P(y),k.code!=="ECONNREFUSED"?S(E+u,h-1,u,g):g(E))),y.connect(E,"127.0.0.1")}e.$Mg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(E,h,u,g="127.0.0.1"){let y=!1,k,w=1;const m=i.createServer({pauseOnConnect:!0});function v(p,$){y||(y=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),$(p))}return new Promise(p=>{k=setTimeout(()=>{v(0,p)},u),m.on("listening",()=>{v(E,p)}),m.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&w<h?(E++,w++,m.listen(E,g)):v(0,p)}),m.on("close",()=>{v(0,p)}),m.listen(E,g)})}function P(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function i(h){const u=new Set;if(Array.isArray(h))for(const g of h)typeof g=="string"&&u.add(g);return Array.from(u)}function R(){const h=e();return h?Array.from(h):[]}function S(h){if(process.platform!=="win32")return;const u=e();if(u)if(typeof h=="string")u.add(h.toLowerCase());else for(const g of i(h))S(g)}function M(h){if(typeof h!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const y of u){if(h.indexOf(y)!==0)continue;const w=h.indexOf("\\",y.length);if(w===-1)continue;const m=h.substring(y.length,w);if(m){g=m;break}}return g}function P(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:S,getUNCHost:M,disableUNCAccessRestrictions:P,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[148],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iW=e.$hW=void 0,e.$hW="vscode:contextmenu",e.$iW="vscode:onCloseContextMenu"}),define(oe[149],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pW=void 0;class i{constructor(S,M){this.a=S,this.onMessage=M}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$pW=i}),define(oe[150],ae([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[151],ae([0,1,150]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=u,e.$Tm=g,e.$Um=y;const R=60,S=R*60,M=S*24,P=M*7,E=M*30,h=M*365;function u(k,w,m,v){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,i.localize)(0,null,u(new Date().getTime()+p*1e3,!1));if(!v&&p<30)return(0,i.localize)(1,null);let $;return p<R?($=p,w?$===1?m?(0,i.localize)(2,null,$):(0,i.localize)(3,null,$):m?(0,i.localize)(4,null,$):(0,i.localize)(5,null,$):$===1?m?(0,i.localize)(6,null,$):(0,i.localize)(7,null,$):m?(0,i.localize)(8,null,$):(0,i.localize)(9,null,$)):p<S?($=Math.floor(p/R),w?$===1?m?(0,i.localize)(10,null,$):(0,i.localize)(11,null,$):m?(0,i.localize)(12,null,$):(0,i.localize)(13,null,$):$===1?m?(0,i.localize)(14,null,$):(0,i.localize)(15,null,$):m?(0,i.localize)(16,null,$):(0,i.localize)(17,null,$)):p<M?($=Math.floor(p/S),w?$===1?m?(0,i.localize)(18,null,$):(0,i.localize)(19,null,$):m?(0,i.localize)(20,null,$):(0,i.localize)(21,null,$):$===1?m?(0,i.localize)(22,null,$):(0,i.localize)(23,null,$):m?(0,i.localize)(24,null,$):(0,i.localize)(25,null,$)):p<P?($=Math.floor(p/M),w?$===1?(0,i.localize)(26,null,$):(0,i.localize)(27,null,$):$===1?(0,i.localize)(28,null,$):(0,i.localize)(29,null,$)):p<E?($=Math.floor(p/P),w?$===1?m?(0,i.localize)(30,null,$):(0,i.localize)(31,null,$):m?(0,i.localize)(32,null,$):(0,i.localize)(33,null,$):$===1?m?(0,i.localize)(34,null,$):(0,i.localize)(35,null,$):m?(0,i.localize)(36,null,$):(0,i.localize)(37,null,$)):p<h?($=Math.floor(p/E),w?$===1?m?(0,i.localize)(38,null,$):(0,i.localize)(39,null,$):m?(0,i.localize)(40,null,$):(0,i.localize)(41,null,$):$===1?m?(0,i.localize)(42,null,$):(0,i.localize)(43,null,$):m?(0,i.localize)(44,null,$):(0,i.localize)(45,null,$)):($=Math.floor(p/h),w?$===1?m?(0,i.localize)(46,null,$):(0,i.localize)(47,null,$):m?(0,i.localize)(48,null,$):(0,i.localize)(49,null,$):$===1?m?(0,i.localize)(50,null,$):(0,i.localize)(51,null,$):m?(0,i.localize)(52,null,$):(0,i.localize)(53,null,$))}function g(k,w){const m=Math.abs(k/1e3);return m<1?w?(0,i.localize)(54,null,k):(0,i.localize)(55,null,k):m<R?w?(0,i.localize)(56,null,Math.round(k)/1e3):(0,i.localize)(57,null,Math.round(k)/1e3):m<S?w?(0,i.localize)(58,null,Math.round(k/(1e3*R))):(0,i.localize)(59,null,Math.round(k/(1e3*R))):m<M?w?(0,i.localize)(60,null,Math.round(k/(1e3*S))):(0,i.localize)(61,null,Math.round(k/(1e3*S))):(0,i.localize)(62,null,Math.round(k/(1e3*M)))}function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[152],ae([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[47],ae([0,1,22,12,152]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=h,e.$_i=u,e.$aj=g;function M(y,k){return k&&(y.stack||y.stacktrace)?S.localize(0,null,E(y),P(y.stack)||P(y.stacktrace)):E(y)}function P(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?S.localize(1,null,y.message):y.message||S.localize(2,null)}function h(y=null,k=!1){if(!y)return S.localize(3,null);if(Array.isArray(y)){const w=i.$Hb(y),m=h(w[0],k);return w.length>1?S.localize(4,null,m,w.length):m}if(R.$1f(y))return y;if(y.detail){const w=y.detail;if(w.error)return M(w.error,k);if(w.exception)return M(w.exception,k)}return y.stack?M(y,k):y.message?y.message:S.localize(5,null)}function u(y){const k=y;return k instanceof Error&&Array.isArray(k.actions)}function g(y,k){let w;return typeof y=="string"?w=new Error(y):w=y,w.actions=k,w}}),define(oe[153],ae([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[154],ae([0,1,153]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=R;function R(S){switch(S){case 1:return(0,i.localize)(0,null);case 2:return(0,i.localize)(1,null);case 3:return(0,i.localize)(2,null);case 4:return(0,i.localize)(3,null);case 5:return(0,i.localize)(4,null);case 6:return(0,i.localize)(5,null);case 7:return(0,i.localize)(6,null);case 8:return(0,i.localize)(7,null);case 9:return(0,i.localize)(8,null);default:return""}}}),define(oe[155],ae([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,155]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=I,e.$J=D,e.$g="en";let R=!1,S=!1,M=!1,P=!1,E=!1,h=!1,u=!1,g=!1,y=!1,k=!1,w,m=e.$g,v=e.$g,p,$;const f=globalThis;let l;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?l=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const d=typeof l?.versions?.electron=="string",a=d&&l?.type==="renderer";if(typeof l=="object"){R=l.platform==="win32",S=l.platform==="darwin",M=l.platform==="linux",P=M&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,u=d,y=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,m=e.$g;const j=l.env.VSCODE_NLS_CONFIG;if(j)try{const A=JSON.parse(j),C=A.availableLanguages["*"];w=A.locale,v=A.osLocale,m=C||e.$g,p=A._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?($=navigator.userAgent,R=$.indexOf("Windows")>=0,S=$.indexOf("Macintosh")>=0,g=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=$.indexOf("Linux")>=0,k=$?.indexOf("Mobi")>=0,h=!0,w=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,m=w,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(j){switch(j){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;S?s=1:R?s=3:M&&(s=2),e.$i=R,e.$j=S,e.$k=M,e.$l=P,e.$m=E,e.$n=u,e.$o=h,e.$p=h&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=g,e.$s=k,e.$t=y,e.$u=s,e.$v=$,e.$w=m;var n;(function(j){function A(){return e.$w}j.value=A;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}j.isDefaultVariant=C;function W(){return e.$w==="en"}j.isDefault=W})(n||(e.Language=n={})),e.$x=w,e.$y=v,e.$z=p,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const j=[];f.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let W=0,T=j.length;W<T;W++){const N=j[W];if(N.id===C.data.vscodeScheduleAsyncWork){j.splice(W,1),N.callback();return}}});let A=0;return C=>{const W=++A;j.push({id:W,callback:C}),f.postMessage({vscodeScheduleAsyncWork:W},"*")}}return j=>setTimeout(j)})();var r;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=S||g?2:R?1:3;let c=!0,b=!1;function I(){if(!b){b=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,c=new Uint16Array(j.buffer)[0]===513}return c}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(j){return parseFloat(j)>=20}}),define(oe[36],ae([0,1,4]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let R;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const M=S.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$ec=R.platform,e.$fc=R.arch}),define(oe[9],ae([0,1,36]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const R=65,S=97,M=90,P=122,E=46,h=47,u=92,g=58,y=63;class k extends Error{constructor(o,s,n){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const c=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${c} ${r} of type ${s}`;b+=`. Received type ${typeof n}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const v=i.$ec==="win32";function p(t){return t===h||t===u}function $(t){return t===h}function f(t){return t>=R&&t<=M||t>=S&&t<=P}function l(t,o,s,n){let r="",c=0,b=-1,I=0,D=0;for(let j=0;j<=t.length;++j){if(j<t.length)D=t.charCodeAt(j);else{if(n(D))break;D=h}if(n(D)){if(!(b===j-1||I===1))if(I===2){if(r.length<2||c!==2||r.charCodeAt(r.length-1)!==E||r.charCodeAt(r.length-2)!==E){if(r.length>2){const A=r.lastIndexOf(s);A===-1?(r="",c=0):(r=r.slice(0,A),c=r.length-1-r.lastIndexOf(s)),b=j,I=0;continue}else if(r.length!==0){r="",c=0,b=j,I=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",c=2)}else r.length>0?r+=`${s}${t.slice(b+1,j)}`:r=t.slice(b+1,j),c=j-b-1;b=j,I=0}else D===E&&I!==-1?++I:I=-1}return r}function d(t,o){w(o,"pathObject");const s=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${n}`:`${s}${t}${n}`:n}e.$gc={resolve(...t){let o="",s="",n=!1;for(let r=t.length-1;r>=-1;r--){let c;if(r>=0){if(c=t[r],m(c,"path"),c.length===0)continue}else o.length===0?c=i.cwd():(c=i.env[`=${o}`]||i.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${o}\\`));const b=c.length;let I=0,D="",j=!1;const A=c.charCodeAt(0);if(b===1)p(A)&&(I=1,j=!0);else if(p(A))if(j=!0,p(c.charCodeAt(1))){let C=2,W=C;for(;C<b&&!p(c.charCodeAt(C));)C++;if(C<b&&C!==W){const T=c.slice(W,C);for(W=C;C<b&&p(c.charCodeAt(C));)C++;if(C<b&&C!==W){for(W=C;C<b&&!p(c.charCodeAt(C));)C++;(C===b||C!==W)&&(D=`\\\\${T}\\${c.slice(W,C)}`,I=C)}}}else I=1;else f(A)&&c.charCodeAt(1)===g&&(D=c.slice(0,2),I=2,b>2&&p(c.charCodeAt(2))&&(j=!0,I=3));if(D.length>0)if(o.length>0){if(D.toLowerCase()!==o.toLowerCase())continue}else o=D;if(n){if(o.length>0)break}else if(s=`${c.slice(I)}\\${s}`,n=j,j&&o.length>0)break}return s=l(s,!n,"\\",p),n?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let s=0,n,r=!1;const c=t.charCodeAt(0);if(o===1)return $(c)?"\\":t;if(p(c))if(r=!0,p(t.charCodeAt(1))){let I=2,D=I;for(;I<o&&!p(t.charCodeAt(I));)I++;if(I<o&&I!==D){const j=t.slice(D,I);for(D=I;I<o&&p(t.charCodeAt(I));)I++;if(I<o&&I!==D){for(D=I;I<o&&!p(t.charCodeAt(I));)I++;if(I===o)return`\\\\${j}\\${t.slice(D)}\\`;I!==D&&(n=`\\\\${j}\\${t.slice(D,I)}`,s=I)}}}else s=1;else f(c)&&t.charCodeAt(1)===g&&(n=t.slice(0,2),s=2,o>2&&p(t.charCodeAt(2))&&(r=!0,s=3));let b=s<o?l(t.slice(s),!r,"\\",p):"";return b.length===0&&!r&&(b="."),b.length>0&&p(t.charCodeAt(o-1))&&(b+="\\"),n===void 0?r?`\\${b}`:b:r?`${n}\\${b}`:`${n}${b}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return p(s)||o>2&&f(s)&&t.charCodeAt(1)===g&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let c=0;c<t.length;++c){const b=t[c];m(b,"path"),b.length>0&&(o===void 0?o=s=b:o+=`\\${b}`)}if(o===void 0)return".";let n=!0,r=0;if(typeof s=="string"&&p(s.charCodeAt(0))){++r;const c=s.length;c>1&&p(s.charCodeAt(1))&&(++r,c>2&&(p(s.charCodeAt(2))?++r:n=!1))}if(n){for(;r<o.length&&p(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const s=e.$gc.resolve(t),n=e.$gc.resolve(o);if(s===n||(t=s.toLowerCase(),o=n.toLowerCase(),t===o))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===u;)r++;let c=t.length;for(;c-1>r&&t.charCodeAt(c-1)===u;)c--;const b=c-r;let I=0;for(;I<o.length&&o.charCodeAt(I)===u;)I++;let D=o.length;for(;D-1>I&&o.charCodeAt(D-1)===u;)D--;const j=D-I,A=b<j?b:j;let C=-1,W=0;for(;W<A;W++){const N=t.charCodeAt(r+W);if(N!==o.charCodeAt(I+W))break;N===u&&(C=W)}if(W!==A){if(C===-1)return n}else{if(j>A){if(o.charCodeAt(I+W)===u)return n.slice(I+W+1);if(W===2)return n.slice(I+W)}b>A&&(t.charCodeAt(r+W)===u?C=W:W===2&&(C=3)),C===-1&&(C=0)}let T="";for(W=r+C+1;W<=c;++W)(W===c||t.charCodeAt(W)===u)&&(T+=T.length===0?"..":"\\..");return I+=C,T.length>0?`${T}${n.slice(I,D)}`:(n.charCodeAt(I)===u&&++I,n.slice(I,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const s=o.charCodeAt(2);if(s!==y&&s!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let s=-1,n=0;const r=t.charCodeAt(0);if(o===1)return p(r)?t:".";if(p(r)){if(s=n=1,p(t.charCodeAt(1))){let I=2,D=I;for(;I<o&&!p(t.charCodeAt(I));)I++;if(I<o&&I!==D){for(D=I;I<o&&p(t.charCodeAt(I));)I++;if(I<o&&I!==D){for(D=I;I<o&&!p(t.charCodeAt(I));)I++;if(I===o)return t;I!==D&&(s=n=I+1)}}}}else f(r)&&t.charCodeAt(1)===g&&(s=o>2&&p(t.charCodeAt(2))?3:2,n=s);let c=-1,b=!0;for(let I=o-1;I>=n;--I)if(p(t.charCodeAt(I))){if(!b){c=I;break}}else b=!1;if(c===-1){if(s===-1)return".";c=s}return t.slice(0,c)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let s=0,n=-1,r=!0,c;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,I=-1;for(c=t.length-1;c>=s;--c){const D=t.charCodeAt(c);if(p(D)){if(!r){s=c+1;break}}else I===-1&&(r=!1,I=c+1),b>=0&&(D===o.charCodeAt(b)?--b===-1&&(n=c):(b=-1,n=I))}return s===n?n=I:n===-1&&(n=t.length),t.slice(s,n)}for(c=t.length-1;c>=s;--c)if(p(t.charCodeAt(c))){if(!r){s=c+1;break}}else n===-1&&(r=!1,n=c+1);return n===-1?"":t.slice(s,n)},extname(t){m(t,"path");let o=0,s=-1,n=0,r=-1,c=!0,b=0;t.length>=2&&t.charCodeAt(1)===g&&f(t.charCodeAt(0))&&(o=n=2);for(let I=t.length-1;I>=o;--I){const D=t.charCodeAt(I);if(p(D)){if(!c){n=I+1;break}continue}r===-1&&(c=!1,r=I+1),D===E?s===-1?s=I:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||r===-1||b===0||b===1&&s===r-1&&s===n+1?"":t.slice(s,r)},format:d.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let n=0,r=t.charCodeAt(0);if(s===1)return p(r)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(p(r)){if(n=1,p(t.charCodeAt(1))){let C=2,W=C;for(;C<s&&!p(t.charCodeAt(C));)C++;if(C<s&&C!==W){for(W=C;C<s&&p(t.charCodeAt(C));)C++;if(C<s&&C!==W){for(W=C;C<s&&!p(t.charCodeAt(C));)C++;C===s?n=C:C!==W&&(n=C+1)}}}}else if(f(r)&&t.charCodeAt(1)===g){if(s<=2)return o.root=o.dir=t,o;if(n=2,p(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let c=-1,b=n,I=-1,D=!0,j=t.length-1,A=0;for(;j>=n;--j){if(r=t.charCodeAt(j),p(r)){if(!D){b=j+1;break}continue}I===-1&&(D=!1,I=j+1),r===E?c===-1?c=j:A!==1&&(A=1):c!==-1&&(A=-1)}return I!==-1&&(c===-1||A===0||A===1&&c===I-1&&c===b+1?o.base=o.name=t.slice(b,I):(o.name=t.slice(b,c),o.base=t.slice(b,I),o.ext=t.slice(c,I))),b>0&&b!==n?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=i.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>i.cwd()})();e.$hc={resolve(...t){let o="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const r=n>=0?t[n]:a();m(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===h)}return o=l(o,!s,"/",$),s?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=l(t,!o,"/",$),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const n=t[s];m(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const s=1,n=t.length,r=n-s,c=1,b=o.length-c,I=r<b?r:b;let D=-1,j=0;for(;j<I;j++){const C=t.charCodeAt(s+j);if(C!==o.charCodeAt(c+j))break;C===h&&(D=j)}if(j===I)if(b>I){if(o.charCodeAt(c+j)===h)return o.slice(c+j+1);if(j===0)return o.slice(c+j)}else r>I&&(t.charCodeAt(s+j)===h?D=j:j===0&&(D=0));let A="";for(j=s+D+1;j<=n;++j)(j===n||t.charCodeAt(j)===h)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(c+D)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let s=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===h){if(!n){s=r;break}}else n=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let s=0,n=-1,r=!0,c;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,I=-1;for(c=t.length-1;c>=0;--c){const D=t.charCodeAt(c);if(D===h){if(!r){s=c+1;break}}else I===-1&&(r=!1,I=c+1),b>=0&&(D===o.charCodeAt(b)?--b===-1&&(n=c):(b=-1,n=I))}return s===n?n=I:n===-1&&(n=t.length),t.slice(s,n)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===h){if(!r){s=c+1;break}}else n===-1&&(r=!1,n=c+1);return n===-1?"":t.slice(s,n)},extname(t){m(t,"path");let o=-1,s=0,n=-1,r=!0,c=0;for(let b=t.length-1;b>=0;--b){const I=t.charCodeAt(b);if(I===h){if(!r){s=b+1;break}continue}n===-1&&(r=!1,n=b+1),I===E?o===-1?o=b:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||n===-1||c===0||c===1&&o===n-1&&o===s+1?"":t.slice(o,n)},format:d.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===h;let n;s?(o.root="/",n=1):n=0;let r=-1,c=0,b=-1,I=!0,D=t.length-1,j=0;for(;D>=n;--D){const A=t.charCodeAt(D);if(A===h){if(!I){c=D+1;break}continue}b===-1&&(I=!1,b=D+1),A===E?r===-1?r=D:j!==1&&(j=1):r!==-1&&(j=-1)}if(b!==-1){const A=c===0&&s?1:c;r===-1||j===0||j===1&&r===b-1&&r===c+1?o.base=o.name=t.slice(A,b):(o.name=t.slice(A,r),o.base=t.slice(A,b),o.ext=t.slice(r,b))}return c>0?o.dir=t.slice(0,c-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=v?e.$gc.normalize:e.$hc.normalize,e.$jc=v?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=v?e.$gc.join:e.$hc.join,e.$lc=v?e.$gc.resolve:e.$hc.resolve,e.$mc=v?e.$gc.relative:e.$hc.relative,e.$nc=v?e.$gc.dirname:e.$hc.dirname,e.$oc=v?e.$gc.basename:e.$hc.basename,e.$pc=v?e.$gc.extname:e.$hc.extname,e.$qc=v?e.$gc.format:e.$hc.format,e.$rc=v?e.$gc.parse:e.$hc.parse,e.$sc=v?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=v?e.$gc.sep:e.$hc.sep,e.$uc=v?e.$gc.delimiter:e.$hc.delimiter}),define(oe[31],ae([0,1,9,4,25,12]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=P,e.$hg=E,e.$ig=h,e.$jg=u,e.$kg=g,e.$lg=m,e.$mg=v,e.$ng=p,e.$og=$,e.$pg=f,e.$qg=l,e.$rg=d,e.$sg=a,e.$tg=t,e.$ug=o,e.$vg=r;function P(c){return c===47||c===92}function E(c){return c.replace(/[\\/]/g,i.$hc.sep)}function h(c){return c.indexOf("/")===-1&&(c=E(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}function u(c,b=i.$hc.sep){if(!c)return"";const I=c.length,D=c.charCodeAt(0);if(P(D)){if(P(c.charCodeAt(1))&&!P(c.charCodeAt(2))){let A=3;const C=A;for(;A<I&&!P(c.charCodeAt(A));A++);if(C!==A&&!P(c.charCodeAt(A+1))){for(A+=1;A<I;A++)if(P(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,b)}}return b}else if($(D)&&c.charCodeAt(1)===58)return P(c.charCodeAt(2))?c.slice(0,2)+b:c.slice(0,2);let j=c.indexOf("://");if(j!==-1){for(j+=3;j<I;j++)if(P(c.charCodeAt(j)))return c.slice(0,j+1)}return""}function g(c){if(!R.$i||!c||c.length<5)return!1;let b=c.charCodeAt(0);if(b!==92||(b=c.charCodeAt(1),b!==92))return!1;let I=2;const D=I;for(;I<c.length&&(b=c.charCodeAt(I),b!==92);I++);return!(D===I||(b=c.charCodeAt(I+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,b=R.$i){const I=b?y:k;return!(!c||c.length===0||/^\s+$/.test(c)||(I.lastIndex=0,I.test(c))||b&&w.test(c)||c==="."||c===".."||b&&c[c.length-1]==="."||b&&c.length!==c.trim().length||c.length>255)}function v(c,b,I){const D=c===b;return!I||D?D:!c||!b?!1:(0,S.$qf)(c,b)}function p(c,b,I,D=i.sep){if(c===b)return!0;if(!c||!b||b.length>c.length)return!1;if(I){if(!(0,S.$rf)(c,b))return!1;if(b.length===c.length)return!0;let A=b.length;return b.charAt(b.length-1)===D&&A--,c.charAt(A)===D}return b.charAt(b.length-1)!==D&&(b+=D),c.indexOf(b)===0}function $(c){return c>=65&&c<=90||c>=97&&c<=122}function f(c,b){return R.$i&&c.endsWith(":")&&(c+=i.sep),(0,i.$jc)(c)||(c=(0,i.$kc)(b,c)),c=(0,i.$ic)(c),R.$i?(c=(0,S.$$e)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,S.$$e)(c,i.sep),c||(c=i.sep)),c}function l(c){const b=(0,i.$ic)(c);return R.$i?c.length>3?!1:d(b)&&(c.length===2||b.charCodeAt(2)===92):b===i.$hc.sep}function d(c,b=R.$i){return b?$(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}function a(c,b=R.$i){return d(c,b)?c[0]:void 0}function t(c,b,I){return b.length>c.length?-1:c===b?0:(I&&(c=c.toLowerCase(),b=b.toLowerCase()),c.indexOf(b))}function o(c){const b=c.split(":");let I,D,j;for(const A of b){const C=Number(A);(0,M.$5f)(C)?D===void 0?D=C:j===void 0&&(j=C):I=I?[I,A].join(":"):A}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:D!==void 0?D:void 0,column:j!==void 0?j:D!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(c,b,I=8){let D="";for(let A=0;A<I;A++){let C;A===0&&R.$i&&!b&&(I===3||I===4)?C=n:C=s,D+=C.charAt(Math.floor(Math.random()*C.length))}let j;return b?j=`${b}-${D}`:j=D,c?(0,i.$kc)(c,j):j}}),define(oe[76],ae([0,1,4]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$dm=M,e.$em=P;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var S;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function M(E,...h){const u=h.reduce((k,w)=>(k[w]=!0,k),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!u[k]).forEach(k=>{for(let w=0;w<g.length;w++)if(k.search(g[w])!==-1){delete E[k];break}})}function P(E){E&&(delete E.DEBUG,i.$j&&delete E.DYLD_LIBRARY_PATH,i.$k&&delete E.LD_PRELOAD)}}),define(oe[7],ae([0,1,9,4]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=m,e.$xc=d;const S=/^\w[\w\d+.-]*$/,M=/^\//,P=/^\/\//;function E(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!S.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!M.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(n,r){return!n&&!r?"file":n}function u(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==y&&(r=y+r):r=y;break}return r}const g="",y="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(r){return r instanceof w?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,c,b,I,D,j=!1){typeof r=="object"?(this.scheme=r.scheme||g,this.authority=r.authority||g,this.path=r.path||g,this.query=r.query||g,this.fragment=r.fragment||g):(this.scheme=h(r,j),this.authority=c||g,this.path=u(this.scheme,b||g),this.query=I||g,this.fragment=D||g,E(this,j))}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:b,path:I,query:D,fragment:j}=r;return c===void 0?c=this.scheme:c===null&&(c=g),b===void 0?b=this.authority:b===null&&(b=g),I===void 0?I=this.path:I===null&&(I=g),D===void 0?D=this.query:D===null&&(D=g),j===void 0?j=this.fragment:j===null&&(j=g),c===this.scheme&&b===this.authority&&I===this.path&&D===this.query&&j===this.fragment?this:new p(c,b,I,D,j)}static parse(r,c=!1){const b=k.exec(r);return b?new p(b[2]||g,s(b[4]||g),s(b[5]||g),s(b[7]||g),s(b[9]||g),c):new p(g,g,g,g,g)}static file(r){let c=g;if(R.$i&&(r=r.replace(/\\/g,y)),r[0]===y&&r[1]===y){const b=r.indexOf(y,2);b===-1?(c=r.substring(2),r=y):(c=r.substring(2,b),r=r.substring(b)||y)}return new p("file",c,r,g,g)}static from(r,c){return new p(r.scheme,r.authority,r.path,r.query,r.fragment,c)}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return R.$i&&r.scheme==="file"?b=w.file(i.$gc.join(d(r,!0),...c)).path:b=i.$hc.join(r.path,...c),r.with({path:b})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof w)return r;{const c=new p(r);return c._formatted=r.external??null,c._fsPath=r._sep===v?r.fsPath??null:null,c}}else return r}}e.URI=w;function m(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}const v=R.$i?1:void 0;class p extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=v),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const $={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(n,r,c){let b,I=-1;for(let D=0;D<n.length;D++){const j=n.charCodeAt(D);if(j>=97&&j<=122||j>=65&&j<=90||j>=48&&j<=57||j===45||j===46||j===95||j===126||r&&j===47||c&&j===91||c&&j===93||c&&j===58)I!==-1&&(b+=encodeURIComponent(n.substring(I,D)),I=-1),b!==void 0&&(b+=n.charAt(D));else{b===void 0&&(b=n.substr(0,D));const A=$[j];A!==void 0?(I!==-1&&(b+=encodeURIComponent(n.substring(I,D)),I=-1),b+=A):I===-1&&(I=D)}}return I!==-1&&(b+=encodeURIComponent(n.substring(I))),b!==void 0?b:n}function l(n){let r;for(let c=0;c<n.length;c++){const b=n.charCodeAt(c);b===35||b===63?(r===void 0&&(r=n.substr(0,c)),r+=$[b]):r!==void 0&&(r+=n[c])}return r!==void 0?r:n}function d(n,r){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,R.$i&&(c=c.replace(/\//g,"\\")),c}function a(n,r){const c=r?l:f;let b="",{scheme:I,authority:D,path:j,query:A,fragment:C}=n;if(I&&(b+=I,b+=":"),(D||I==="file")&&(b+=y,b+=y),D){let W=D.indexOf("@");if(W!==-1){const T=D.substr(0,W);D=D.substr(W+1),W=T.lastIndexOf(":"),W===-1?b+=c(T,!1,!1):(b+=c(T.substr(0,W),!1,!1),b+=":",b+=c(T.substr(W+1),!1,!0)),b+="@"}D=D.toLowerCase(),W=D.lastIndexOf(":"),W===-1?b+=c(D,!1,!0):(b+=c(D.substr(0,W),!1,!0),b+=D.substr(W))}if(j){if(j.length>=3&&j.charCodeAt(0)===47&&j.charCodeAt(2)===58){const W=j.charCodeAt(1);W>=65&&W<=90&&(j=`/${String.fromCharCode(W+32)}:${j.substr(3)}`)}else if(j.length>=2&&j.charCodeAt(1)===58){const W=j.charCodeAt(0);W>=65&&W<=90&&(j=`${String.fromCharCode(W+32)}:${j.substr(2)}`)}b+=c(j,!0,!1)}return A&&(b+="?",b+=c(A,!1,!1)),C&&(b+="#",b+=r?C:f(C,!1,!1)),b}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(o)?n.replace(o,r=>t(r)):n}}),define(oe[156],ae([0,1,7]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=R,e.$Lq=S,e.$Mq=M,e.log=E;function R(u){const g=u;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function S(u){const g=[];let y;try{const k=JSON.parse(u.arguments),w=k[k.length-1];w&&w.__$stack&&(k.pop(),y=w.__$stack),g.push(...k)}catch{g.push("Unable to log remote console arguments",u.arguments)}return{args:g,stack:y}}function M(u){if(typeof u!="string")return M(S(u).stack);const g=u;if(g){const y=P(g),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(k&&k.length===4)return{uri:i.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function P(u){if(!u)return u;const g=u.indexOf(`
`);return g===-1?u:u.substring(0,g)}function E(u,g){const{args:y,stack:k}=S(u),w=typeof y[0]=="string"&&y.length===1;let m=P(k);m&&(m=`(${m.trim()})`);let v=[];if(typeof y[0]=="string"?m&&w?v=[`%c[${g}] %c${y[0]} %c${m}`,h("blue"),h(""),h("grey")]:v=[`%c[${g}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:v=[`%c[${g}]%`,h("blue"),...y],m&&!w&&v.push(m),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,v)}function h(u){return`color: ${u}`}}),define(oe[77],ae([0,1,17,7]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=S,e.$Vh=M,e.$Wh=E;function S(h){return JSON.stringify(h,P)}function M(h){let u=JSON.parse(h);return u=E(u),u}function P(h,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function E(h,u=0){if(!h||u>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return R.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof i.$ze||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let g=0;g<h.length;++g)h[g]=E(h[g],u+1);else for(const g in h)Object.hasOwnProperty.call(h,g)&&(h[g]=E(h[g],u+1))}return h}}),define(oe[13],ae([0,1,15,4,25,7,9]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=h,e.$xg=u,e.$Bg=y;var E;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(m,v){return M.URI.isUri(m)?(0,S.$qf)(m.scheme,v):(0,S.$rf)(m,v+":")}function u(m,...v){return v.some(p=>h(m,p))}e.$yg="vscode-tkn",e.$zg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,p){this.f=y(v,p)}getServerRootPath(){return this.f}get g(){return P.$hc.join(this.f,E.vscodeRemoteResource)}set(v,p,$){this.a[v]=p,this.b[v]=$}setConnectionToken(v,p){this.c[v]=p}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return i.$1(a),v}const p=v.authority;let $=this.a[p];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[p],l=this.c[p];let d=`path=${encodeURIComponent(v.path)}`;return typeof l=="string"&&(d+=`&${e.$zg}=${encodeURIComponent(l)}`),M.URI.from({scheme:R.$o?this.d:E.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:d})}}e.$Ag=new g;function y(m,v){return P.$hc.join(v??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class k{static{this.a=e.$Gg}asBrowserUri(v){const p=this.b(v,Q);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===E.vscodeRemote?e.$Ag.rewrite(v):v.scheme===E.file&&(R.$m||R.$q===`${E.vscodeFileResource}://${k.a}`)?v.with({scheme:E.vscodeFileResource,authority:v.authority||k.a,query:null,fragment:null}):v}asFileUri(v){const p=this.b(v,Q);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===E.vscodeFileResource?v.with({scheme:E.file,authority:v.authority!==k.a?v.authority:null,query:null,fragment:null}):v}b(v,p){return M.URI.isUri(v)?v:M.URI.parse(p.toUrl(v))}}e.$Hg=new k;var w;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function $(l){let d;typeof l=="string"?d=new URL(l).searchParams:l instanceof URL?d=l.searchParams:M.URI.isUri(l)&&(d=new URL(l.toString(!0)).searchParams);const a=d?.get(p);if(a)return v.get(a)}m.getHeadersFromQuery=$;function f(l,d,a){if(!globalThis.crossOriginIsolated)return;const t=d&&a?"3":a?"2":"1";l instanceof URLSearchParams?l.set(p,t):l[p]=t}m.addSearchParam=f})(w||(e.COI=w={}))}),define(oe[19],ae([0,1,31,13,9,4,25,7]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=h,e.$0g=g,e.$$g=k;function h(w){return(0,E.$xc)(w,!0)}class u{constructor(m){this.a=m}compare(m,v,p=!1){return m===v?0:(0,P.$jf)(this.getComparisonKey(m,p),this.getComparisonKey(v,p))}isEqual(m,v,p=!1){return m===v?!0:!m||!v?!1:this.getComparisonKey(m,p)===this.getComparisonKey(v,p)}getComparisonKey(m,v=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,v,p=!1){if(m.scheme===v.scheme){if(m.scheme===R.Schemas.file)return i.$ng(h(m),h(v),this.a(m))&&m.query===v.query&&(p||m.fragment===v.fragment);if((0,e.$6g)(m.authority,v.authority))return i.$ng(m.path,v.path,this.a(m),"/")&&m.query===v.query&&(p||m.fragment===v.fragment)}return!1}joinPath(m,...v){return E.URI.joinPath(m,...v)}basenameOrAuthority(m){return(0,e.$Xg)(m)||m.authority}basename(m){return S.$hc.basename(m.path)}extname(m){return S.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let v;return m.scheme===R.Schemas.file?v=E.URI.file(S.$nc(h(m))).path:(v=S.$hc.dirname(m.path),m.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),v="/")),m.with({path:v})}normalizePath(m){if(!m.path.length)return m;let v;return m.scheme===R.Schemas.file?v=E.URI.file(S.$ic(h(m))).path:v=S.$hc.normalize(m.path),m.with({path:v})}relativePath(m,v){if(m.scheme!==v.scheme||!(0,e.$6g)(m.authority,v.authority))return;if(m.scheme===R.Schemas.file){const f=S.$mc(h(m),h(v));return M.$i?i.$hg(f):f}let p=m.path||"/";const $=v.path||"/";if(this.a(m)){let f=0;for(const l=Math.min(p.length,$.length);f<l&&!(p.charCodeAt(f)!==$.charCodeAt(f)&&p.charAt(f).toLowerCase()!==$.charAt(f).toLowerCase());f++);p=$.substr(0,f)+p.substr(f)}return S.$hc.relative(p,$)}resolvePath(m,v){if(m.scheme===R.Schemas.file){const p=E.URI.file(S.$lc(h(m),v));return m.with({authority:p.authority,path:p.path})}return v=i.$ig(v),m.with({path:S.$hc.resolve(m.path,v)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,v){return m===v||m!==void 0&&v!==void 0&&(0,P.$qf)(m,v)}hasTrailingPathSeparator(m,v=S.sep){if(m.scheme===R.Schemas.file){const p=h(m);return p.length>i.$jg(p).length&&p[p.length-1]===v}else{const p=m.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,v=S.sep){return(0,e.$7g)(m,v)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,v=S.sep){let p=!1;if(m.scheme===R.Schemas.file){const $=h(m);p=$!==void 0&&$.length===i.$jg($).length&&$[$.length-1]===v}else{v="/";const $=m.path;p=$.length===1&&$.charCodeAt($.length-1)===47}return!p&&!(0,e.$7g)(m,v)?m.with({path:m.path+"/"}):m}}e.$Pg=u,e.$Qg=new u(()=>!1),e.$Rg=new u(w=>w.scheme===R.Schemas.file?!M.$k:!0),e.$Sg=new u(w=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function g(w,m){const v=[];for(let p=0;p<w.length;p++){const $=m(w[p]);w.some((f,l)=>l===p?!1:(0,e.$Ug)($,m(f)))||v.push(w[p])}return v}var y;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(v){const p=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[d,a]=l.split(":");d&&a&&p.set(d,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&p.set(w.META_DATA_MIME,f),p}w.parseMetaData=m})(y||(e.DataUri=y={}));function k(w,m,v){if(m){let p=w.path;return p&&p[0]!==S.$hc.sep&&(p=S.$hc.sep+p),w.with({scheme:v,authority:m,path:p})}return w.with({scheme:v})}}),define(oe[8],ae([0,1,23,15,3,2,19,4,144,62]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=g,e.$ah=y,e.$bh=k,e.$ch=w,e.$dh=m,e.$eh=v,e.$fh=p,e.$gh=$,e.$oh=c,e.$ph=b,e.$qh=I,e.$rh=D,e.$sh=j,e.$Hh=L,e.$Ph=J;function g(V){return!!V&&typeof V.then=="function"}function y(V){const q=new i.$je,re=V(q.token),ee=new Promise((fe,me)=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),me(new R.$5)});Promise.resolve(re).then(ke=>{ve.dispose(),q.dispose(),fe(ke)},ke=>{ve.dispose(),q.dispose(),me(ke)})});return new class{cancel(){q.cancel(),q.dispose()}then(fe,me){return ee.then(fe,me)}catch(fe){return this.then(void 0,fe)}finally(fe){return ee.finally(fe)}}}function k(V,q,re){return new Promise((ee,fe)=>{const me=q.onCancellationRequested(()=>{me.dispose(),ee(re)});V.then(ee,fe).finally(()=>me.dispose())})}function w(V,q){return new Promise((re,ee)=>{const fe=q.onCancellationRequested(()=>{fe.dispose(),ee(new R.$5)});V.then(re,ee).finally(()=>fe.dispose())})}async function m(V){let q=-1;const re=V.map((ee,fe)=>ee.then(me=>(q=fe,me)));try{return await Promise.race(re)}finally{V.forEach((ee,fe)=>{fe!==q&&ee.cancel()})}}function v(V,q,re){let ee;const fe=setTimeout(()=>{ee?.(void 0),re?.()},q);return Promise.race([V.finally(()=>clearTimeout(fe)),new Promise(me=>ee=me)])}function p(V){return new Promise((q,re)=>{const ee=V();g(ee)?ee.then(q,re):q(ee)})}function $(){let V,q;return{promise:new Promise((ee,fe)=>{V=ee,q=fe}),resolve:V,reject:q}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const re=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(re,re).then(ee)})}return new Promise((re,ee)=>{this.b.then(re,ee)})}return this.a=q(),new Promise((re,ee)=>{this.a.then(fe=>{this.a=null,re(fe)},fe=>{this.a=null,ee(fe)})})}dispose(){this.f=!0}}e.$hh=f;class l{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$ih=l;class d{constructor(){this.a=new Map}queue(q,re){const fe=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(q)===fe&&this.a.delete(q)});return this.a.set(q,fe),fe}}e.$jh=d;const a=(V,q)=>{let re=!0;const ee=setTimeout(()=>{re=!1,q()},V);return{isTriggered:()=>re,dispose:()=>{clearTimeout(ee),re=!1}}},t=V=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,V())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class o{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,re=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((fe,me)=>{this.d=fe,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=re===h.$9d?t(ee):a(re,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=o;class s{constructor(q){this.a=new o(q),this.b=new f}trigger(q,re){return this.a.trigger(()=>this.b.queue(q),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=s;class n{constructor(){this.a=!1,this.b=new Promise((q,re)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=n;class r extends n{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$nh=r;function c(V,q){return q?new Promise((re,ee)=>{const fe=setTimeout(()=>{me.dispose(),re()},V),me=q.onCancellationRequested(()=>{clearTimeout(fe),me.dispose(),ee(new R.$5)})}):y(re=>c(V,re))}function b(V,q=0,re){const ee=setTimeout(()=>{V(),re&&fe.dispose()},q),fe=(0,M.$Sc)(()=>{clearTimeout(ee),re?.deleteAndLeak(fe)});return re?.add(fe),fe}function I(V){const q=[];let re=0;const ee=V.length;function fe(){return re<ee?V[re++]():null}function me(ve){ve!=null&&q.push(ve);const ke=fe();return ke?ke.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}function D(V,q=ee=>!!ee,re=null){let ee=0;const fe=V.length,me=()=>{if(ee>=fe)return Promise.resolve(re);const ve=V[ee++];return Promise.resolve(ve()).then(Ie=>q(Ie)?Promise.resolve(Ie):me())};return me()}function j(V,q=ee=>!!ee,re=null){if(V.length===0)return Promise.resolve(re);let ee=V.length;const fe=()=>{ee=-1;for(const me of V)me.cancel?.()};return new Promise((me,ve)=>{for(const ke of V)ke.then(Ie=>{--ee>=0&&q(Ie)?(fe(),me(Ie)):ee===0&&me(re)}).catch(Ie=>{--ee>=0&&(fe(),ve(Ie))})})}class A{constructor(q){this.a=0,this.b=!1,this.f=q,this.g=[],this.d=0,this.h=new S.$_d}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,ee)=>{this.g.push({factory:q,c:re,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const q=this.g.shift();this.d++;const re=q.factory();re.then(q.c,q.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=A;class C extends A{constructor(){super(1)}}e.$uh=C;class W{constructor(){this.a=new H,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$vh=W;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new ce;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueSize(q,re=P.$Qg){const ee=re.getComparisonKey(q);return this.a.get(ee)?.size??0}queueFor(q,re,ee=P.$Qg){const fe=ee.getComparisonKey(q);let me=this.a.get(fe);if(!me){me=new C;const ve=this.f++,ke=S.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(ve,ke),this.a.set(fe,me)}return me.queue(re)}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=T;class N{constructor(q,re){this.a=-1,typeof q=="function"&&typeof re=="number"&&this.setIfNotSet(q,re)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,re){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},re)}setIfNotSet(q,re){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},re))}}e.$xh=N;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(q,re,ee=globalThis){this.cancel();const fe=ee.setInterval(()=>{q()},re);this.d=(0,M.$Sc)(()=>{ee.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$yh=U;class ue{constructor(q,re){this.b=-1,this.a=q,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=ue;class ie{constructor(q,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=q,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=ie;class le extends ue{constructor(q,re){super(q,re),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Bh=le;class Y extends M.$Uc{constructor(q,re){super(),this.g=q,this.h=re,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of q)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(V,q)=>{(0,E.$B)(()=>{if(re)return;const ee=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Eh=(V,q,re)=>{const ee=V.requestIdleCallback(q,typeof re=="number"?{timeout:re}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,V.cancelIdleCallback(ee))}}},e.$Dh=V=>(0,e.$Eh)(globalThis,V)}();class K{constructor(q,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$Eh)(q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=K;class B extends K{constructor(q){super(globalThis,q)}}e.$Gh=B;async function L(V,q,re){let ee;for(let fe=0;fe<re;fe++)try{return await V()}catch(me){ee=me,await c(q)}throw ee}class H{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,re,ee){return this.a={taskId:q,cancel:()=>ee?.(),promise:re},re.then(()=>this.d(q),()=>this.d(q)),re}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{const{promise:re,resolve:ee,reject:fe}=$();this.b={run:q,promise:re,promiseResolve:ee,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=H;class G{constructor(q,re=()=>Date.now()){this.d=q,this.f=re,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Jh=G;var z;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(z||(z={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,re)=>{this.a=q,this.b=re})}complete(q){return new Promise(re=>{this.a(q),this.d={outcome:0,value:q},re()})}error(q){return new Promise(re=>{this.b(q),this.d={outcome:1,value:q},re()})}cancel(){return this.error(new R.$5)}}e.$Kh=ce;var he;(function(V){async function q(ee){let fe;const me=await Promise.all(ee.map(ve=>ve.then(ke=>ke,ke=>{fe||(fe=ke)})));if(typeof fe<"u")throw fe;return me}V.settled=q;function re(ee){return new Promise(async(fe,me)=>{try{await ee(fe,me)}catch(ve){me(ve)}})}V.withAsyncBody=re})(he||(e.Promises=he={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=q.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=X;class O{constructor(q){this.b=q,this.a=new u.$V(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=O;var F;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(F||(F={}));class _{static fromArray(q){return new _(re=>{re.emitMany(q)})}static fromPromise(q){return new _(async re=>{re.emitMany(await q)})}static fromPromises(q){return new _(async re=>{await Promise.all(q.map(async ee=>re.emitOne(await ee)))})}static merge(q){return new _(async re=>{await Promise.all(q.map(async ee=>{for await(const fe of ee)re.emitOne(fe)}))})}static{this.EMPTY=_.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new S.$_d,queueMicrotask(async()=>{const re={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(q(re)),this.j()}catch(ee){this.k(ee)}finally{re.emitOne=void 0,re.emitMany=void 0,re.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(q,re){return new _(async ee=>{for await(const fe of q)ee.emitOne(re(fe))})}map(q){return _.map(this,q)}static filter(q,re){return new _(async ee=>{for await(const fe of q)re(fe)&&ee.emitOne(fe)})}filter(q){return _.filter(this,q)}static coalesce(q){return _.filter(q,re=>!!re)}coalesce(){return _.coalesce(this)}static async toPromise(q){const re=[];for await(const ee of q)re.push(ee);return re}toPromise(){return _.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$Nh=_;class se extends _{constructor(q,re){super(re),this.l=q}cancel(){this.l.cancel()}}e.$Oh=se;function J(V){const q=new i.$je,re=V(q.token);return new se(q,async ee=>{const fe=q.token.onCancellationRequested(()=>{fe.dispose(),q.dispose(),ee.reject(new R.$5)});try{for await(const me of re){if(q.token.isCancellationRequested)return;ee.emitOne(me)}fe.dispose(),q.dispose()}catch(me){fe.dispose(),q.dispose(),ee.reject(me)}})}class x{constructor(){this.a=new ce,this.b=new _(ee=>{if(q){ee.reject(q);return}return re&&ee.emitMany(re),this.d=fe=>ee.reject(fe),this.f=fe=>ee.emitOne(fe),this.a.p});let q,re;this.f=ee=>{re||(re=[]),re.push(ee)},this.d=ee=>{q||(q=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(q){this.d(q),this.a.complete()}emitOne(q){this.f(q)}}e.$Qh=x}),define(oe[108],ae([0,1,22,8,31,32,9,4,25]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$ck=u,e.$fk=m,e.$gk=C,e.$hk=W,e.$ik=T,e.$jk=N,e.$kk=U,e.$lk=Y;function u(){return Object.create(null)}e.$dk="**",e.$ek="/";const g="[/\\\\]",y="[^/\\\\]",k=/\//g;function w(K,B){switch(K){case 0:return"";case 1:return`${y}*?`;default:return`(?:${g}|${y}+${g}${B?`|${g}${y}+`:""})*?`}}function m(K,B){if(!K)return[];const L=[];let H=!1,G=!1,z="";for(const ce of K){switch(ce){case B:if(!H&&!G){L.push(z),z="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":G=!0;break;case"]":G=!1;break}z+=ce}return z&&L.push(z),L}function v(K){if(!K)return"";let B="";const L=m(K,e.$ek);if(L.every(H=>H===e.$dk))B=".*";else{let H=!1;L.forEach((G,z)=>{if(G===e.$dk){if(H)return;B+=w(2,z===L.length-1)}else{let ce=!1,he="",X=!1,O="";for(const F of G){if(F!=="}"&&ce){he+=F;continue}if(X&&(F!=="]"||!O)){let _;F==="-"?_=F:(F==="^"||F==="!")&&!O?_="^":F===e.$ek?_="":_=(0,h.$5e)(F),O+=_;continue}switch(F){case"{":ce=!0;continue;case"[":X=!0;continue;case"}":{const se=`(?:${m(he,",").map(J=>v(J)).join("|")})`;B+=se,ce=!1,he="";break}case"]":{B+="["+O+"]",X=!1,O="";break}case"?":B+=y;continue;case"*":B+=w(1);continue;default:B+=(0,h.$5e)(F)}}z<L.length-1&&(L[z+1]!==e.$dk||z+2<L.length)&&(B+=g)}H=G===e.$dk})}return B}const p=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ec(1e4),o=function(){return!1},s=function(){return null};function n(K,B){if(!K)return s;let L;typeof K!="string"?L=K.pattern:L=K,L=L.trim();const H=`${L}_${!!B.trimForExclusions}`;let G=t.get(H);if(G)return r(G,K);let z;return p.test(L)?G=b(L.substr(4),L):(z=$.exec(c(L,B)))?G=I(z[1],L):(B.trimForExclusions?l:f).test(L)?G=D(L,B):(z=d.exec(c(L,B)))?G=j(z[1].substr(1),L,!0):(z=a.exec(c(L,B)))?G=j(z[1],L,!1):G=A(L),t.set(H,G),r(G,K)}function r(K,B){if(typeof B=="string")return K;const L=function(H,G){return(0,S.$ng)(H,B.base,!E.$k)?K((0,h.$0e)(H.substr(B.base.length),P.sep),G):null};return L.allBasenames=K.allBasenames,L.allPaths=K.allPaths,L.basenames=K.basenames,L.patterns=K.patterns,L}function c(K,B){return B.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function b(K,B){return function(L,H){return typeof L=="string"&&L.endsWith(K)?B:null}}function I(K,B){const L=`/${K}`,H=`\\${K}`,G=function(ce,he){return typeof ce!="string"?null:he?he===K?B:null:ce===K||ce.endsWith(L)||ce.endsWith(H)?B:null},z=[K];return G.basenames=z,G.patterns=[B],G.allBasenames=z,G}function D(K,B){const L=le(K.slice(1,-1).split(",").map(he=>n(he,B)).filter(he=>he!==s),K),H=L.length;if(!H)return s;if(H===1)return L[0];const G=function(he,X){for(let O=0,F=L.length;O<F;O++)if(L[O](he,X))return K;return null},z=L.find(he=>!!he.allBasenames);z&&(G.allBasenames=z.allBasenames);const ce=L.reduce((he,X)=>X.allPaths?he.concat(X.allPaths):he,[]);return ce.length&&(G.allPaths=ce),G}function j(K,B,L){const H=P.sep===P.$hc.sep,G=H?K:K.replace(k,P.sep),z=P.sep+G,ce=P.$hc.sep+K;let he;return L?he=function(X,O){return typeof X=="string"&&(X===G||X.endsWith(z)||!H&&(X===K||X.endsWith(ce)))?B:null}:he=function(X,O){return typeof X=="string"&&(X===G||!H&&X===K)?B:null},he.allPaths=[(L?"*/":"./")+K],he}function A(K){try{const B=new RegExp(`^${v(K)}$`);return function(L){return B.lastIndex=0,typeof L=="string"&&B.test(L)?K:null}}catch{return s}}function C(K,B,L){return!K||typeof B!="string"?!1:W(K)(B,void 0,L)}function W(K,B={}){if(!K)return o;if(typeof K=="string"||T(K)){const L=n(K,B);if(L===s)return o;const H=function(G,z){return!!L(G,z)};return L.allBasenames&&(H.allBasenames=L.allBasenames),L.allPaths&&(H.allPaths=L.allPaths),H}return ue(K,B)}function T(K){const B=K;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function N(K){return K.allBasenames||[]}function U(K){return K.allPaths||[]}function ue(K,B){const L=le(Object.getOwnPropertyNames(K).map(he=>ie(he,K[he],B)).filter(he=>he!==s)),H=L.length;if(!H)return s;if(!L.some(he=>!!he.requiresSiblings)){if(H===1)return L[0];const he=function(F,_){let se;for(let J=0,x=L.length;J<x;J++){const V=L[J](F,_);if(typeof V=="string")return V;(0,R.$_g)(V)&&(se||(se=[]),se.push(V))}return se?(async()=>{for(const J of se){const x=await J;if(typeof x=="string")return x}return null})():null},X=L.find(F=>!!F.allBasenames);X&&(he.allBasenames=X.allBasenames);const O=L.reduce((F,_)=>_.allPaths?F.concat(_.allPaths):F,[]);return O.length&&(he.allPaths=O),he}const G=function(he,X,O){let F,_;for(let se=0,J=L.length;se<J;se++){const x=L[se];x.requiresSiblings&&O&&(X||(X=(0,P.$oc)(he)),F||(F=X.substr(0,X.length-(0,P.$pc)(he).length)));const V=x(he,X,F,O);if(typeof V=="string")return V;(0,R.$_g)(V)&&(_||(_=[]),_.push(V))}return _?(async()=>{for(const se of _){const J=await se;if(typeof J=="string")return J}return null})():null},z=L.find(he=>!!he.allBasenames);z&&(G.allBasenames=z.allBasenames);const ce=L.reduce((he,X)=>X.allPaths?he.concat(X.allPaths):he,[]);return ce.length&&(G.allPaths=ce),G}function ie(K,B,L){if(B===!1)return s;const H=n(K,L);if(H===s)return s;if(typeof B=="boolean")return H;if(B){const G=B.when;if(typeof G=="string"){const z=(ce,he,X,O)=>{if(!O||!H(ce,he))return null;const F=G.replace("$(basename)",()=>X),_=O(F);return(0,R.$_g)(_)?_.then(se=>se?K:null):_?K:null};return z.requiresSiblings=!0,z}}return H}function le(K,B){const L=K.filter(he=>!!he.basenames);if(L.length<2)return K;const H=L.reduce((he,X)=>{const O=X.basenames;return O?he.concat(O):he},[]);let G;if(B){G=[];for(let he=0,X=H.length;he<X;he++)G.push(B)}else G=L.reduce((he,X)=>{const O=X.patterns;return O?he.concat(O):he},[]);const z=function(he,X){if(typeof he!="string")return null;if(!X){let F;for(F=he.length;F>0;F--){const _=he.charCodeAt(F-1);if(_===47||_===92)break}X=he.substr(F)}const O=H.indexOf(X);return O!==-1?G[O]:null};z.basenames=H,z.patterns=G,z.allBasenames=H;const ce=K.filter(he=>!he.basenames);return ce.push(z),ce}function Y(K,B){return(0,i.$ub)(K,B,(L,H)=>typeof L=="string"&&typeof H=="string"?L===H:typeof L!="string"&&typeof H!="string"?L.base===H.base&&L.pattern===H.pattern:!1)}}),define(oe[48],ae([0,1,22,31,9,4,19,25]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=h,e.$mw=g,e.$nw=k,e.$ow=w,e.$pw=$,e.$qw=l,e.$rw=d,e.$sw=a,e.$tw=t,e.$uw=o;function h(n,r){const{os:c,tildify:b,relative:I}=r;if(I){const A=u(n,I,c);if(typeof A=="string")return A}let D=n.fsPath;if(c===1&&!M.$i?D=D.replace(/\//g,"\\"):c!==1&&M.$i&&(D=D.replace(/\\/g,"/")),c!==1&&b?.userHome){const A=b.userHome.fsPath;let C;n.scheme!==b.userHome.scheme&&n.path[0]===S.$hc.sep&&n.path[1]!==S.$hc.sep?C=b.userHome.with({path:n.path}).fsPath:C=D,D=k(C,A,c)}return(c===1?S.$gc:S.$hc).normalize(g(D,c===1))}function u(n,r,c){const b=c===1?S.$gc:S.$hc,I=c===3?P.$Qg:P.$Sg,D=r.getWorkspace(),j=(0,i.$Ob)(D.folders);if(!j)return;n.scheme!==j.uri.scheme&&n.path[0]===S.$hc.sep&&n.path[1]!==S.$hc.sep&&(n=j.uri.with({path:n.path}));const A=r.getWorkspaceFolder(n);if(!A)return;let C;if(I.isEqual(A.uri,n)?C="":C=I.relativePath(A.uri,n)??"",C&&(C=b.normalize(C)),D.folders.length>1&&!r.noPrefix){const W=A.name?A.name:I.basenameOrAuthority(A.uri);C=C?`${W} \u2022 ${C}`:W}return C}function g(n,r=M.$i){return(0,R.$rg)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}let y=Object.create(null);function k(n,r,c=M.OS){if(c===1||!n||!r)return n;let b=y.original===r?y.normalized:void 0;b||(b=r,M.$i&&(b=(0,R.$hg)(b)),b=`${(0,E.$$e)(b,S.$hc.sep)}${S.$hc.sep}`,y={original:r,normalized:b});let I=n;return M.$i&&(I=(0,R.$hg)(I)),(c===3?I.startsWith(b):(0,E.$rf)(I,b))?`~/${I.substr(b.length)}`:n}function w(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}const m="\u2026",v="\\\\",p="~";function $(n,r=S.sep){const c=new Array(n.length);let b=!1;for(let I=0;I<n.length;I++){const D=n[I];if(D===""){c[I]=`.${r}`;continue}if(!D){c[I]=D;continue}b=!0;let j="",A=D;A.indexOf(v)===0?(j=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length)):A.indexOf(r)===0?(j=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length)):A.indexOf(p)===0&&(j=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length));const C=A.split(r);for(let W=1;b&&W<=C.length;W++)for(let T=C.length-W;b&&T>=0;T--){b=!1;let N=C.slice(T,T+W).join(r);for(let U=0;!b&&U<n.length;U++)if(U!==I&&n[U]&&n[U].indexOf(N)>-1){const ue=T+W===C.length,ie=T>0&&n[U].indexOf(r)>-1?r+N:N,le=n[U].endsWith(ie);b=!ue||le}if(!b){let U="";(C[0].endsWith(":")||j!=="")&&(T===1&&(T=0,W++,N=C[0]+r+N),T>0&&(U=C[0]+r),U=j+U),T>0&&(U=U+m+r),U=U+N,T+W<C.length&&(U=U+r+m),c[I]=U}}b&&(c[I]=D)}return c}var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(n,r=Object.create(null)){const c=[];let b=!1,I="";for(const D of n)if(D==="$"||b&&D==="{")I&&c.push({value:I,type:f.TEXT}),I="",b=!0;else if(D==="}"&&b){const j=r[I];if(typeof j=="string")j.length&&c.push({value:j,type:f.VARIABLE});else if(j){const A=c[c.length-1];(!A||A.type!==f.SEPARATOR)&&c.push({value:j.label,type:f.SEPARATOR})}I="",b=!1}else I+=D;return I&&!b&&c.push({value:I,type:f.TEXT}),c.filter((D,j)=>{if(D.type===f.SEPARATOR){const A=c[j-1],C=c[j+1];return[A,C].every(W=>W&&(W.type===f.VARIABLE||W.type===f.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function d(n,r){return M.$j||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):n.replace(/&&|&/g,c=>c==="&"?"&&":"&")}function a(n,r){return M.$j||r?n.replace(/\(&&\w\)|&&/g,""):M.$i?n.replace(/&&|&/g,c=>c==="&"?"&&":"&"):n.replace(/&&/g,"_")}function t(n){return n.replace(/&/g,"&&")}function o(n){if(n.endsWith("]")){const r=n.lastIndexOf(" [",n.length-2);if(r!==-1){const c=s(n.substring(0,r)),b=n.substring(r);return{name:c.name+b,parentPath:c.parentPath}}}return s(n)}function s(n){const r=n.indexOf("/")!==-1?S.$hc:S.$gc,c=r.basename(n),b=r.dirname(n);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}}),define(oe[157],ae([0,1,17,7]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0,e.$rn=E,e.$sn=u,e.$tn=g;function S(y){return y.toJSON()}class M{constructor(k){this.a=k}transformIncoming(k){const w=this.a.transformIncoming(k);return w===k?k:S(R.URI.from(w))}transformOutgoing(k){const w=this.a.transformOutgoing(k);return w===k?k:S(R.URI.from(w))}transformOutgoingURI(k){const w=this.a.transformOutgoing(k);return w===k?k:R.URI.from(w)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$pn=M,e.$qn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function P(y,k,w){if(!y||w>200)return null;if(typeof y=="object"){if(y instanceof R.URI)return k.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const v=P(y[m],k,w+1);v!==null&&(y[m]=v)}}return null}function E(y,k){const w=P(y,k,0);return w===null?y:w}function h(y,k,w,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return w?R.URI.revive(k.transformIncoming(y)):k.transformIncoming(y);if(y instanceof i.$ze)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const p=h(y[v],k,w,m+1);p!==null&&(y[v]=p)}}return null}function u(y,k){const w=h(y,k,!1,0);return w===null?y:w}function g(y,k){const w=h(y,k,!0,0);return w===null?y:w}}),define(oe[89],ae([0,1,26,59,33,147,4]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$wn=h,e.$xn=y,e.$vn=new class{c(k){return this.a||(this.a=R.$ti.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,w=0;const m=(0,i.networkInterfaces)();for(const v in m){const p=m[v];if(p)for(const{mac:$,internal:f}of p)f||(w+=1,this.c($.toUpperCase())&&(k+=1))}this.b=w>0?k/w:0}return this.b}};let E;async function h(k){return E||(E=(async()=>await u(k)||S.$Jg())()),E}async function u(k){try{const w=await new Promise((v,p)=>{Q(["crypto"],v,p)}),m=(0,M.$un)();return w.createHash("sha256").update(m,"utf8").digest("hex")}catch(w){k(w);return}}const g="Software\\Microsoft\\SQMClient";async function y(k){if(P.$i){const w=await new Promise((m,v)=>{Q(["@vscode/windows-registry"],m,v)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(m){return k(m),""}}return""}}),define(oe[21],ae([0,1,43,26,158,8,31,72,9,4,19,7]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=l,e.whenDeleted=t,e.configureFlushOnWrite=c,e.writeFileSync=I;var k;(function(ie){ie[ie.UNLINK=0]="UNLINK",ie[ie.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function w(ie,le=k.UNLINK,Y){if((0,P.$qg)(ie))throw new Error("rimraf - will refuse to recursively delete root");return le===k.UNLINK?v(ie):m(ie,Y)}async function m(ie,le=(0,P.$vg)((0,R.tmpdir)())){try{try{await i.promises.rename(ie,le)}catch(Y){return Y.code==="ENOENT"?void 0:v(ie)}v(le).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function v(ie){return(0,S.promisify)(i.rm)(ie,{recursive:!0,force:!0,maxRetries:3})}function p(ie){if((0,P.$qg)(ie))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(ie,{recursive:!0,force:!0,maxRetries:3})}async function $(ie,le){return d(await(le?f(ie):(0,S.promisify)(i.readdir)(ie)))}async function f(ie){try{return await(0,S.promisify)(i.readdir)(ie,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const le=[],Y=await $(ie);for(const K of Y){let B=!1,L=!1,H=!1;try{const G=await e.Promises.lstat((0,h.$kc)(ie,K));B=G.isFile(),L=G.isDirectory(),H=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}le.push({name:K,isFile:()=>B,isDirectory:()=>L,isSymbolicLink:()=>H})}return le}function l(ie){return d(i.readdirSync(ie))}function d(ie){return ie.map(le=>typeof le=="string"?u.$j?(0,E.$5l)(le):le:(le.name=u.$j?(0,E.$5l)(le.name):le.name,le))}async function a(ie){const le=await $(ie),Y=[];for(const K of le)await o.existsDirectory((0,h.$kc)(ie,K))&&Y.push(K);return Y}function t(ie,le=1e3){return new Promise(Y=>{let K=!1;const B=setInterval(()=>{K||(K=!0,i.access(ie,L=>{K=!1,L&&(clearInterval(B),Y(void 0))}))},le)})}var o;(function(ie){async function le(B){let L;try{if(L=await e.Promises.lstat(B),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(u.$i&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw H}}ie.stat=le;async function Y(B){try{const{stat:L,symbolicLink:H}=await ie.stat(B);return L.isFile()&&H?.dangling!==!0}catch{}return!1}ie.existsFile=Y;async function K(B){try{const{stat:L,symbolicLink:H}=await ie.stat(B);return L.isDirectory()&&H?.dangling!==!0}catch{}return!1}ie.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const s=new M.$wh;function n(ie,le,Y){return s.queueFor(y.URI.file(ie),()=>{const K=D(Y);return new Promise((B,L)=>b(ie,le,K,H=>H?L(H):B()))},g.$Rg)}let r=!0;function c(ie){r=ie}function b(ie,le,Y,K){if(!r)return i.writeFile(ie,le,{mode:Y.mode,flag:Y.flag},K);i.open(ie,Y.flag,Y.mode,(B,L)=>{if(B)return K(B);i.writeFile(L,le,H=>{if(H)return i.close(L,()=>K(H));i.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),c(!1)),i.close(L,z=>K(z))))})})}function I(ie,le,Y){const K=D(Y);if(!r)return i.writeFileSync(ie,le,{mode:K.mode,flag:K.flag});const B=i.openSync(ie,K.flag,K.mode);try{i.writeFileSync(B,le);try{i.fdatasyncSync(B)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),c(!1)}}finally{i.closeSync(B)}}function D(ie){return ie?{mode:typeof ie.mode=="number"?ie.mode:438,flag:typeof ie.flag=="string"?ie.flag:"w"}:{mode:438,flag:"w"}}async function j(ie,le,Y=6e4){if(ie!==le)try{u.$i&&typeof Y=="number"?await A(ie,le,Date.now(),Y):await(0,S.promisify)(i.rename)(ie,le)}catch(K){if(ie.toLowerCase()!==le.toLowerCase()&&K.code==="EXDEV"||ie.endsWith("."))await C(ie,le,{preserveSymlinks:!1}),await w(ie,k.MOVE);else throw K}}async function A(ie,le,Y,K,B=0){try{return await(0,S.promisify)(i.rename)(ie,le)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Y>=K)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${L}`),L;if(B===0){let H=!1;try{const{stat:G}=await o.stat(le);G.isFile()||(H=!0)}catch{}if(H)throw L}return await(0,M.$oh)(Math.min(100,B*10)),A(ie,le,Y,K,B+1)}}async function C(ie,le,Y){return T(ie,le,{root:{source:ie,target:le},options:Y,handledSourcePaths:new Set})}const W=511;async function T(ie,le,Y){if(Y.handledSourcePaths.has(ie))return;Y.handledSourcePaths.add(ie);const{stat:K,symbolicLink:B}=await o.stat(ie);if(B){if(Y.options.preserveSymlinks)try{return await ue(ie,le,Y)}catch{}if(B.dangling)return}return K.isDirectory()?N(ie,le,K.mode&W,Y):U(ie,le,K.mode&W)}async function N(ie,le,Y,K){await e.Promises.mkdir(le,{recursive:!0,mode:Y});const B=await $(ie);for(const L of B)await T((0,h.$kc)(ie,L),(0,h.$kc)(le,L),K)}async function U(ie,le,Y){await e.Promises.copyFile(ie,le),await e.Promises.chmod(le,Y)}async function ue(ie,le,Y){let K=await e.Promises.readlink(ie);(0,P.$ng)(K,Y.root.source,!u.$k)&&(K=(0,h.$kc)(Y.root.target,K.substr(Y.root.source.length+1))),await e.Promises.symlink(K,le)}e.Promises=new class{get access(){return(0,S.promisify)(i.access)}get stat(){return(0,S.promisify)(i.stat)}get lstat(){return(0,S.promisify)(i.lstat)}get utimes(){return(0,S.promisify)(i.utimes)}get read(){return(ie,le,Y,K,B)=>new Promise((L,H)=>{i.read(ie,le,Y,K,B,(G,z,ce)=>G?H(G):L({bytesRead:z,buffer:ce}))})}get readFile(){return(0,S.promisify)(i.readFile)}get write(){return(ie,le,Y,K,B)=>new Promise((L,H)=>{i.write(ie,le,Y,K,B,(G,z,ce)=>G?H(G):L({bytesWritten:z,buffer:ce}))})}get appendFile(){return(0,S.promisify)(i.appendFile)}get fdatasync(){return(0,S.promisify)(i.fdatasync)}get truncate(){return(0,S.promisify)(i.truncate)}get copyFile(){return(0,S.promisify)(i.copyFile)}get open(){return(0,S.promisify)(i.open)}get close(){return(0,S.promisify)(i.close)}get symlink(){return(0,S.promisify)(i.symlink)}get readlink(){return(0,S.promisify)(i.readlink)}get chmod(){return(0,S.promisify)(i.chmod)}get mkdir(){return(0,S.promisify)(i.mkdir)}get unlink(){return(0,S.promisify)(i.unlink)}get rmdir(){return(0,S.promisify)(i.rmdir)}get realpath(){return(0,S.promisify)(i.realpath)}async exists(ie){try{return await e.Promises.access(ie),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return w}get rename(){return j}get copy(){return C}}}),define(oe[109],ae([0,1,43,9,4,25,21]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=E,e.$Tq=h,e.$Uq=u,e.$Vq=g;function E(k){if(S.$k)return k;const w=(0,R.$nc)(k);if(k===w)return k;const m=((0,R.$oc)(k)||k).toLowerCase();try{const p=(0,P.readdirSync)(w).filter($=>$.toLowerCase()===m);if(p.length===1){const $=E(w);if($)return(0,R.$kc)($,p[0])}else if(p.length>1){const $=p.indexOf(m);if($>=0){const f=E(w);if(f)return(0,R.$kc)(f,p[$])}}}catch{}return null}async function h(k,w){if(S.$k)return k;const m=(0,R.$nc)(k);if(k===m)return k;const v=((0,R.$oc)(k)||k).toLowerCase();try{if(w?.isCancellationRequested)return null;const $=(await P.Promises.readdir(m)).filter(f=>f.toLowerCase()===v);if($.length===1){const f=await h(m,w);if(f)return(0,R.$kc)(f,$[0])}else if($.length>1){const f=$.indexOf(v);if(f>=0){const l=await h(m,w);if(l)return(0,R.$kc)(l,$[f])}}}catch{}return null}async function u(k){try{return await P.Promises.realpath(k)}catch{const m=y(k);return await P.Promises.access(m,i.constants.R_OK),m}}function g(k){try{return i.realpathSync(k)}catch{const m=y(k);return i.accessSync(m,i.constants.R_OK),m}}function y(k){return(0,M.$$e)((0,R.$ic)(k),R.sep)}}),define(oe[110],ae([0,1,26,9,21]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=f,e.$cm=l;const M=/^\d+$/,P=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(h||(h={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:d=!1}={}){return d?u===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:d=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:d});if(!t)return null;const o=R.$kc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let s=-1,n=null;for(const b of await S.Promises.readdir(o)){let I=-1;if(a){const j=b.indexOf("-");if(j<0)continue;const A=b.substring(0,j);if(!M.test(A)||b.substring(j+1)!=="preview")continue;I=parseInt(A,10)}else{if(!M.test(b))continue;I=parseInt(b,10)}if(I<=s)continue;const D=R.$kc(o,b,"pwsh.exe");await S.SymlinkSupport.existsFile(D)&&(n=D,s=I)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new y(n,`PowerShell${c}${r}`,!0)}async function m({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=d?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await S.Promises.readdir(a))if(t.test(s)){const n=R.$kc(a,s,"pwsh.exe");return new y(n,o)}return null}function v(){const d=R.$kc(i.homedir(),".dotnet","tools","pwsh.exe");return new y(d,".NET Core PowerShell Global Tool")}function p(){const d=R.$kc(process.env.windir,u===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(d,"Windows PowerShell",!0)}async function*$(){let d=await w();d&&(yield d),d=await w({useAlternateBitness:!0}),d&&(yield d),d=await m(),d&&(yield d),d=v(),d&&(yield d),d=await w({findPreview:!0}),d&&(yield d),d=await m({findPreview:!0}),d&&(yield d),d=await w({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=p(),d&&(yield d)}async function*f(){for await(const d of $())await d.exists()&&(yield d)}async function l(){for await(const d of f())return d;return null}}),define(oe[90],ae([0,1,9,4,36,76,12,21]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$fm=h,e.$gm=u,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h(y=S.env){return y.comspec||"cmd.exe"}function u(y){let k=[],w=!1;const m=function(v){if(w){k.push(v);return}(!y.send(v,$=>{if($&&console.error($),w=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(l=>m(l))}})||R.$i)&&(w=!0)};return{send:m}}var g;(function(y){async function k(w,m,v){if(i.$jc(w))return w;if(m===void 0&&(m=S.cwd()),i.$nc(w)!=="."||(v===void 0&&P.$1f(S.env.PATH)&&(v=S.env.PATH.split(i.$uc)),v===void 0||v.length===0))return i.$kc(m,w);async function $(f){if(await E.Promises.exists(f)){let l;try{l=await E.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(l=await E.Promises.lstat(f))}return l?!l.isDirectory():!1}return!1}for(const f of v){let l;if(i.$jc(f)?l=i.$kc(f,w):l=i.$kc(m,f,w),await $(l))return l;let d=l+".com";if(await $(d)||(d=l+".exe",await $(d)))return d}return i.$kc(m,w)}y.findExecutable=k})(g||(e.win32=g={}))}),define(oe[111],ae([0,1,49,13]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=S;function S(P){return new Promise((E,h)=>{let u;const g=new Map;function y(w,m,v,p,$){const f=g.get(m);if(w===P||f){const l={name:k(v),cmd:v,pid:w,ppid:m,load:p,mem:$};g.set(w,l),w===P&&(u=l),f&&(f.children||(f.children=[]),f.children.push(l),f.children.length>1&&(f.children=f.children.sort((d,a)=>d.pid-a.pid)))}}function k(w){const m=/--utility-sub-type=network/i,v=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec(w))return"electron-crash-reporter";if(p.exec(w))return"winpty-agent";if($.exec(w))return"conpty-agent";let l=f.exec(w);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?m.exec(w)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const d=/[a-zA-Z-]+\.js/g;let a="";do l=d.exec(w),l&&(a+=l+" ");while(l);return a&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${a})`:w}if(process.platform==="win32"){const w=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,v)=>{Q(["@vscode/windows-process-tree"],m,v)}).then(m=>{m.getProcessList(P,v=>{if(!v){h(new Error(`Root process ${P} not found`));return}m.getProcessCpuUsage(v,p=>{const $=new Map;p.forEach(f=>{const l=w(f.commandLine||"");$.set(f.pid,{name:k(l),cmd:l,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),u=$.get(P),u?($.forEach(f=>{const l=$.get(f.ppid);l&&(l.children||(l.children=[]),l.children.push(f))}),$.forEach(f=>{f.children&&(f.children=f.children.sort((l,d)=>l.pid-d.pid))}),E(u)):h(new Error(`Root process ${P} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let w=function(){let m=[u];const v=[];for(;m.length;){const $=m.shift();$&&(v.push($.pid),$.children&&(m=m.concat($.children)))}let p=JSON.stringify(R.$Hg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+v.join(" "),(0,i.exec)(p,{},($,f,l)=>{if($||l)h($||new Error(l.toString()));else{const d=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=g.get(v[a]);t.load=parseFloat(d[a])}if(!u){h(new Error(`Root process ${P} not found`));return}E(u)}})};(0,i.exec)("which ps",{},(m,v,p)=>{if(m||p)if(process.platform!=="linux")h(m||new Error(p.toString()));else{const $=JSON.stringify(R.$Hg.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)($,{},(f,l,d)=>{f||d?h(f||new Error(d.toString())):(M(l,y),w())})}else{const $=v.toString().trim();(0,i.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,d,a)=>{l||a&&!a.includes("screen size is bogus")?h(l||new Error(a.toString())):(M(d,y),process.platform==="linux"?w():u?E(u):h(new Error(`Root process ${P} not found`)))})}})}})}function M(P,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=P.toString().split(`
`);for(const g of u){const y=h.exec(g.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(oe[112],ae([0,1,26,4,110,90]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=P;async function P(y,k){return y===1?R.$i?g():M.$fm(k):h(y,k)}let E=null;function h(y,k){if(R.$k&&y===2||R.$j&&y===3)return"/bin/bash";if(!E){let w;if(R.$i)w="/bin/bash";else{if(w=k.SHELL,!w)try{w=(0,i.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}E=w}return E}let u=null;async function g(){return u||(u=(await(0,S.$cm)()).exePath),u}});var Ee=this&&this.__decorate||function(Q,e,i,R){var S=arguments.length,M=S<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,i):R,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Q,e,i,R);else for(var E=Q.length-1;E>=0;E--)(P=Q[E])&&(M=(S<3?P(M):S>3?P(e,i,M):P(e,i))||M);return S>3&&M&&Object.defineProperty(e,i,M),M};define(oe[44],ae([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.ProxyChannel=e.$8h=e.$5h=e.$4h=e.$3h=e.RequestInitiator=e.$2h=e.$Yh=e.$Xh=void 0,e.$Zh=c,e.$1h=b,e.$6h=W,e.$7h=T;var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function m(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v||(v={}));function p(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})($||($={}));function f(B){let L=0;for(let H=0;;H+=7){const G=B.read(1);if(L|=(G.buffer[0]&127)<<H,!(G.buffer[0]&128))return L}}const l=s(0);function d(B,L){if(L===0){B.write(l);return}let H=0;for(let z=L;z!==0;z=z>>>7)H++;const G=S.$ze.alloc(H);for(let z=0;L!==0;z++)G.buffer[z]=L&127,L=L>>>7,L>0&&(G.buffer[z]|=128);B.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const H=this.b.slice(this.a,this.a+L);return this.a+=H.byteLength,H}}e.$Xh=a;class t{constructor(){this.a=[]}get buffer(){return S.$ze.concat(this.a)}write(L){this.a.push(L)}}e.$Yh=t;var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(o||(o={}));function s(B){const L=S.$ze.alloc(1);return L.writeUInt8(B,0),L}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function c(B,L){if(typeof L>"u")B.write(n.Undefined);else if(typeof L=="string"){const H=S.$ze.fromString(L);B.write(n.String),d(B,H.byteLength),B.write(H)}else if(r&&Buffer.isBuffer(L)){const H=S.$ze.wrap(L);B.write(n.Buffer),d(B,H.byteLength),B.write(H)}else if(L instanceof S.$ze)B.write(n.VSBuffer),d(B,L.byteLength),B.write(L);else if(Array.isArray(L)){B.write(n.Array),d(B,L.length);for(const H of L)c(B,H)}else if(typeof L=="number"&&(L|0)===L)B.write(n.Uint),d(B,L);else{const H=S.$ze.fromString(JSON.stringify(L));B.write(n.Object),d(B,H.byteLength),B.write(H)}}function b(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(f(B)).toString();case o.Buffer:return B.read(f(B)).buffer;case o.VSBuffer:return B.read(f(B));case o.Array:{const H=f(B),G=[];for(let z=0;z<H;z++)G.push(b(B));return G}case o.Object:return JSON.parse(B.read(f(B)).toString());case o.Int:return f(B)}}class I{constructor(L,H,G=null,z=1e3){this.h=L,this.j=H,this.k=G,this.l=z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(L,H){this.b.set(L,H),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const H=this.o([L.type]);this.k?.logOutgoing(H,0,1,p(L.type));return}case 201:case 202:case 204:case 203:{const H=this.o([L.type,L.id],L.data);this.k?.logOutgoing(H,L.id,1,p(L.type),L.data);return}}}o(L,H=void 0){const G=new t;return c(G,L),c(G,H),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const H=new a(L),G=b(H),z=b(H),ce=G[0];switch(ce){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}: ${G[2]}.${G[3]}`,z),this.s({type:ce,id:G[1],channelName:G[2],name:G[3],arg:z});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}: ${G[2]}.${G[3]}`,z),this.t({type:ce,id:G[1],channelName:G[2],name:G[3],arg:z});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}`),this.u({type:ce,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}`),this.u({type:ce,id:G[1]})}}s(L){const H=this.b.get(L.channelName);if(!H){this.v(L);return}const G=new M.$je;let z;try{z=H.call(this.j,L.name,L.arg,G.token)}catch(X){z=Promise.reject(X)}const ce=L.id;z.then(X=>{this.m({id:ce,data:X,type:201})},X=>{X instanceof Error?this.m({id:ce,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.m({id:ce,data:X,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,u.$Sc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const H=this.b.get(L.channelName);if(!H){this.v(L);return}const G=L.id,ce=H.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,ce)}u(L){const H=this.d.get(L.id);H&&(H.dispose(),this.d.delete(L.id))}v(L){let H=this.g.get(L.channelName);H||(H=[],this.g.set(L.channelName,H));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:L,timeoutTimer:G})}w(L){const H=this.g.get(L);if(H){for(const G of H)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Pc)(this.d.values()),this.d.clear()}}e.$2h=I;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class j{constructor(L,H=null){this.l=L,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$_d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=H}getChannel(L){const H=this;return{call(G,z,ce){return H.a?Promise.reject(new E.$5):H.m(L,G,z,ce)},listen(G,z){return H.a?h.Event.None:H.o(L,G,z)}}}m(L,H,G,z=M.CancellationToken.None){const ce=this.g++,X={id:ce,type:100,channelName:L,name:H,arg:G};if(z.isCancellationRequested)return Promise.reject(new E.$5);let O;return new Promise((_,se)=>{if(z.isCancellationRequested)return se(new E.$5);const J=()=>{const re=ee=>{switch(ee.type){case 201:this.f.delete(ce),_(ee.data);break;case 202:{this.f.delete(ce);const fe=new Error(ee.data.message);fe.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,fe.name=ee.data.name,se(fe);break}case 203:this.f.delete(ce),se(ee.data);break}};this.f.set(ce,re),this.p(X)};let x=null;this.b===$.Idle?J():(x=(0,R.$ah)(re=>this.u()),x.then(()=>{x=null,J()}));const V=()=>{x?(x.cancel(),x=null):this.p({id:ce,type:101}),se(new E.$5)},q=z.onCancellationRequested(V);O=(0,u.$Rc)((0,u.$Sc)(V),q),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,H,G){const z=this.g++,he={id:z,type:102,channelName:L,name:H,arg:G};let X=null;const O=new h.$_d({onWillAddFirstListener:()=>{X=(0,R.$ah)(_=>this.u()),X.then(()=>{X=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(O),this.p({id:z,type:103}))}}),F=_=>O.fire(_.data);return this.f.set(z,F),O.event}p(L){switch(L.type){case 100:case 102:{const H=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(H,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const H=this.q([L.type,L.id]);this.j?.logOutgoing(H,L.id,0,m(L.type));return}}}q(L,H=void 0){const G=new t;return c(G,L),c(G,H),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const H=new a(L),G=b(H),z=b(H),ce=G[0];switch(ce){case 200:return this.j?.logIncoming(L.byteLength,0,0,p(ce)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,p(ce),z),this.t({type:G[0],id:G[1],data:z})}}t(L){if(L.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Pc)(this.d.values()),this.d.clear()}}e.$3h=j,Ee([P.$Rh],j.prototype,"onDidInitializePromise",null);class A{get connections(){const L=[];return this.f.forEach(H=>L.push(H)),L}constructor(L,H,G){this.a=new Map,this.f=new Set,this.g=new h.$_d,this.onDidAddConnection=this.g.event,this.h=new h.$_d,this.onDidRemoveConnection=this.h.event,this.j=new u.$Tc,this.j.add(L(({protocol:z,onDidClientDisconnect:ce})=>{const he=h.Event.once(z.onMessage);this.j.add(he(X=>{const O=new a(X),F=b(O),_=new I(z,F,H,G),se=new j(z,H);this.a.forEach((x,V)=>_.registerChannel(V,x));const J={channelServer:_,channelClient:se,ctx:F};this.f.add(J),this.g.fire(J),this.j.add(ce(()=>{_.dispose(),se.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(L,H){const G=this;return{call(z,ce,he){let X;if((0,k.$cg)(H)){const F=(0,i.$4b)(G.connections.filter(H));X=F?Promise.resolve(F):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,H))}else X=H.routeCall(G,z,ce);const O=X.then(F=>F.channelClient.getChannel(L));return W(O).call(z,ce,he)},listen(z,ce){if((0,k.$cg)(H))return G.k(L,H,z,ce);const he=H.routeEvent(G,z,ce).then(X=>X.channelClient.getChannel(L));return W(he).listen(z,ce)}}}k(L,H,G,z){const ce=this;let he;const X=new h.$_d({onWillAddFirstListener:()=>{he=new u.$Tc;const O=new h.$fe,F=new Map,_=J=>{const V=J.channelClient.getChannel(L).listen(G,z),q=O.add(V);F.set(J,q)},se=J=>{const x=F.get(J);x&&(x.dispose(),F.delete(J))};ce.connections.filter(H).forEach(_),h.Event.filter(ce.onDidAddConnection,H)(_,void 0,he),ce.onDidRemoveConnection(se,void 0,he),O.event(X.fire,X,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return X.event}registerChannel(L,H){this.a.set(L,H);for(const G of this.f)G.channelServer.registerChannel(L,H)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$4h=A;class C{constructor(L,H,G=null){const z=new t;c(z,H),L.send(z.buffer),this.a=new j(L,G),this.d=new I(L,H,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,H){this.d.registerChannel(L,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5h=C;function W(B){return{call(L,H,G){return B.then(z=>z.call(L,H,G))},listen(L,H){const G=new h.$ie;return B.then(z=>G.input=z.listen(L,H)),G.event}}}function T(B){let L=!1;return{call(H,G,z){return L?B.call(H,G,z):(0,R.$oh)(0).then(()=>L=!0).then(()=>B.call(H,G,z))},listen(H,G){if(L)return B.listen(H,G);const z=new h.$ie;return(0,R.$oh)(0).then(()=>L=!0).then(()=>z.input=B.listen(H,G)),z.event}}}class N{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const H of L.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await h.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$8h=N;var U;(function(B){function L(ce,he,X){const O=ce,F=X&&X.disableMarshalling,_=new Map;for(const se in O)G(se)&&_.set(se,h.Event.buffer(O[se],!0,void 0,he));return new class{listen(se,J,x){const V=_.get(J);if(V)return V;const q=O[J];if(typeof q=="function"){if(z(J))return q.call(O,x);if(G(J))return _.set(J,h.Event.buffer(O[J],!0,void 0,he)),_.get(J)}throw new E.$bb(`Event not found: ${J}`)}call(se,J,x){const V=O[J];if(typeof V=="function"){if(!F&&Array.isArray(x))for(let re=0;re<x.length;re++)x[re]=(0,g.$Wh)(x[re]);let q=V.apply(O,x);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new E.$bb(`Method not found: ${J}`)}}}B.fromService=L;function H(ce,he){const X=he&&he.disableMarshalling;return new Proxy({},{get(O,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):z(F)?function(_){return ce.listen(F,_)}:G(F)?ce.listen(F):async function(..._){let se;he&&!(0,k.$0f)(he.context)?se=[he.context,..._]:se=_;const J=await ce.call(F,se);return X?J:(0,g.$Wh)(J)};throw new E.$bb(`Property not found: ${String(F)}`)}})}B.toService=H;function G(ce){return ce[0]==="o"&&ce[1]==="n"&&y.$pf(ce.charCodeAt(2))}function z(ce){return/^onDynamic/.test(ce)&&y.$pf(ce.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ie(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const L=B.toString();if(L!=="[object Object]")return L}return B}function le(B){return Array.isArray(B)?B.map(ie):ie(B)}function Y(B,L,H,G,z,ce,he){he=le(he);const X=ue[z],O=X[G%X.length];let F=[`%c[${B}]%c[${String(L).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ce)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class K{constructor(L,H){this.d=L,this.f=H,this.a=0,this.b=0}logOutgoing(L,H,G,z,ce){this.b+=L,Y(this.d,this.b,L,H,G,z,ce)}logIncoming(L,H,G,z,ce){this.a+=L,Y(this.f,this.a,L,H,G,z,ce)}}e.$9h=K}),define(oe[159],ae([0,1,17,3,44]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nW=e.$mW=void 0;class M{constructor(h){this.a=h,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",u=>u.data?i.$ze.wrap(u.data):i.$ze.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$mW=M;class P extends S.$5h{constructor(h,u){const g=new M(h);super(g,u),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$nW=P}),define(oe[113],ae([0,1,17,3,2,44]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.ProtocolConstants=e.$0h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var E;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let c=0;function b(D,j){if(!r.has(D)){const A=String(++c);r.set(D,A)}return r.get(D)}function I(D,j,A,C){if(!n.enableDiagnostics)return;const W=b(D,j);if(C instanceof i.$ze||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const T=i.$ze.alloc(C.byteLength);T.set(C),n.records.push({timestamp:Date.now(),id:W,label:j,type:A,buff:T})}else n.records.push({timestamp:Date.now(),id:W,label:j,type:A,data:C})}n.traceSocketEvent=I})(E||(e.SocketDiagnostics=E={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let u=null;function g(){return u||(u=i.$ze.alloc(0)),u}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,c){if(r===0)return g();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const j=this.a[0];return c&&(this.a.shift(),this.b-=r),j}if(this.a[0].byteLength>r){const j=this.a[0].slice(0,r);return c&&(this.a[0]=this.a[0].slice(r),this.b-=r),j}const b=i.$ze.alloc(r);let I=0,D=0;for(;r>0;){const j=this.a[D];if(j.byteLength>r){const A=j.slice(0,r);b.set(A,I),I+=r,c&&(this.a[D]=j.slice(r),this.b-=r),r-=r}else b.set(j,I),I+=j.byteLength,c?(this.a.shift(),this.b-=j.byteLength):D++,r-=j.byteLength}return b}}e.$0h=y;var k;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(k||(k={}));function w(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class v{constructor(r,c,b,I){this.type=r,this.id=c,this.ack=b,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.$Uc{constructor(r){super(),this.f=this.B(new R.$_d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new y,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,I=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new v(b,I,D,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=i.$ze.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(c,r.data)}g(r,c){const b=this.f===0;return this.d.push(r,c),this.f+=r.byteLength+c.byteLength,b}h(){const r=i.$ze.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,c){this.g(r,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class f extends S.$Uc{constructor(r){super(),this.f=new R.$_d,this.onMessage=this.f.event,this.g=new R.$_d,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new $(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new v(1,0,0,r))}}e.$$h=f;class l extends M.$5h{static fromSocket(r,c){return new l(new f(r),c)}get onDidDispose(){return this.b.onDidDispose}constructor(r,c,b=null){super(r,c,b),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$_h=l;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$_d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$ai=d;class a{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,c=this.a;for(;c;)c=c.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let c=0,b=this.a;for(;b;)r[c++]=b.data,b=b.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const c=new a(r);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const r=Date.now();for(let c=0;c<o.a;c++)this.c[c]=r-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),c=(1+o.a)*1e3;let b=0;for(let I=0;I<o.a;I++)r-this.c[I]<=c&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??o.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=r.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new v(5,0,0,g());this.p.write(r),this.p.flush()}sendPause(){const r=new v(7,0,0,g());this.p.write(r)}sendResume(){const r=new v(8,0,0,g());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,c){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new v(3,0,this.h,g());this.p.write(r);const c=this.b.toArray();for(let b=0,I=c.length;b<I;b++)this.p.write(c[b]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const c=this.b.peek();if(c&&c.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new v(6,0,0,g())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let b=0,I=c.length;b<I;b++)this.p.write(c[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const c=++this.c;this.h=this.g;const b=new v(1,c,this.h,r);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(r){const c=new v(2,0,0,r);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),c=Date.now()-r.writtenTime,b=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(c>=2e4&&b>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:b});return}const D=Math.max(2e4-c,2e4-b,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new v(3,0,this.h,g());this.p.write(r)}D(){this.h=this.g;const r=new v(9,0,this.h,g());this.p.write(r)}}e.$bi=s}),define(oe[37],ae([0,1,14,15,13]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jW=void 0;class M{constructor(){this.a=new WeakMap}on(E,h){const u=(g,...y)=>{this.b(E,g)&&h(g,...y)};return this.a.set(h,u),i.ipcMain.on(E,u),this}once(E,h){return i.ipcMain.once(E,(u,...g)=>{this.b(E,u)&&h(u,...g)}),this}handle(E,h){return i.ipcMain.handle(E,(u,...g)=>this.b(E,u)?h(u,...g):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return i.ipcMain.removeHandler(E),this}removeListener(E,h){const u=this.a.get(h);return u&&(i.ipcMain.removeListener(E,u),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const u=h.senderFrame,g=u.url;if(!g||g==="about:blank")return!0;let y="unknown";try{y=new URL(g).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${g}'.`),!1}return y!==S.$Gg?((0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${y}'.`),!1):u.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$jW=new M}),define(oe[160],ae([0,1,14,37,148]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kW=M;function M(){R.$jW.on(S.$hW,(E,h,u,g,y)=>{const k=P(E,g,u);k.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{k&&E.sender.send(S.$iW,h)}})})}function P(E,h,u){const g=new i.Menu;return u.forEach(y=>{let k;y.type==="separator"?k=new i.MenuItem({type:y.type}):Array.isArray(y.submenu)?k=new i.MenuItem({submenu:P(E,h,y.submenu),label:y.label}):k=new i.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(w,m,v)=>E.sender.send(h,y.id,v)}),g.append(k)}),g}}),define(oe[161],ae([0,1,37,17,3,2,44,149]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qW=void 0;function h(g,y){const k=S.Event.fromNodeEventEmitter(i.$jW,y,(m,v)=>({event:m,message:v})),w=S.Event.filter(k,({event:m})=>m.sender.id===g);return S.Event.map(w,({message:m})=>m&&R.$ze.wrap(m))}class u extends P.$4h{static{this.b=new Map}static d(){const y=S.Event.fromNodeEventEmitter(i.$jW,"vscode:hello",({sender:k})=>k);return S.Event.map(y,k=>{const w=k.id;u.b.get(w)?.dispose();const v=new S.$_d;u.b.set(w,(0,M.$Sc)(()=>v.fire()));const p=h(w,"vscode:message"),$=S.Event.any(S.Event.signal(h(w,"vscode:disconnect")),v.event);return{protocol:new E.$pW(k,p),onDidClientDisconnect:$}})}constructor(){super(u.d())}}e.$qW=u}),define(oe[114],ae([0,1,37,3,33,159]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rW=void 0,e.$sW=E;class P extends M.$nW{constructor(u,g){super({addEventListener:(y,k)=>u.addListener(y,k),removeEventListener:(y,k)=>u.removeListener(y,k),postMessage:y=>u.postMessage(y),start:()=>u.start(),close:()=>u.close()},g)}}e.$rW=P;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,S.$Jg)();h.webContents.send("vscode:createMessageChannel",u);const g=R.Event.fromNodeEventEmitter(i.$jW,"vscode:createMessageChannelResult",(k,w)=>({nonce:w,port:k.ports[0]})),{port:y}=await R.Event.toPromise(R.Event.once(R.Event.filter(g,k=>k.nonce===u)));return y}}),define(oe[162],ae([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class m extends w.$2h{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>S.$ze.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Oq=m;class v{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new h.$_d,this.onDidProcessExit=this.h.event;const l=f&&f.timeout?f.timeout:6e4;this.b=new R.$kh(l),this.d=null,this.f=null}getChannel($){const f=this;return{call(l,d,a){return f.k($,l,d,a)},listen(l,d){return f.l($,l,d)}}}k($,f,l,d=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n($),t=(0,R.$ah)(n=>a.call(f,l,n)),o=d.onCancellationRequested(()=>t.cancel()),s=(0,u.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,f,l){if(!this.b)return h.Event.None;this.b.cancel();let d;const a=new h.$_d({onWillAddFirstListener:()=>{d=this.n($).listen(f,l)(a.fire,a),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,g.$Tn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,k.$em)(f.env),this.d=(0,i.fork)(this.i,$,f);const l=new h.$_d,a=h.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,P.$Kq)(c)){(0,P.log)(c,`IPC Library: ${this.j.serverName}`);return}l.fire(S.$ze.wrap(Buffer.from(c,"base64")))}),t=this.j.useQueue?(0,y.$gm)(this.d):this.d,o=c=>this.d&&this.d.connected&&t.send(c.buffer.toString("base64")),s=l.event,n={send:o,onMessage:s};this.f=new w.$3h(n);const r=()=>this.o();process.once("exit",r),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,b)=>{process.removeListener("exit",r),a.dispose(),this.c.forEach(I=>(0,u.$Pc)(I)),this.c.clear(),c!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:b})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pq=v}),define(oe[115],ae([0,1,8,3,2,77,12]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.StorageState=e.StorageHint=void 0,e.$Mp=h;var E;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(k){const w=k;return w?.changed instanceof Map||w?.deleted instanceof Set}var u;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(u||(e.StorageState=u={}));class g extends S.$Uc{static{this.a=100}constructor(w,m=Object.create(null)){super(),this.r=w,this.s=m,this.b=this.B(new R.$ce),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=this.B(new i.$lh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((m,v)=>this.w(v,m)),w.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(w,m){if(this.c===u.Closed)return;let v=!1;(0,P.$0f)(m)?v=this.f.delete(w):this.f.get(w)!==m&&(this.f.set(w,m),v=!0),v&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,m){const v=this.f.get(w);return(0,P.$0f)(v)?m:v}getBoolean(w,m){const v=this.get(w);return(0,P.$0f)(v)?m:v==="true"}getNumber(w,m){const v=this.get(w);return(0,P.$0f)(v)?m:parseInt(v,10)}getObject(w,m){const v=this.get(w);return(0,P.$0f)(v)?m:(0,M.$Vh)(v)}async set(w,m,v=!1){if(this.c===u.Closed)return;if((0,P.$0f)(m))return this.delete(w,v);const p=(0,P.$3f)(m)||Array.isArray(m)?(0,M.$Uh)(m):String(m);if(this.f.get(w)!==p)return this.f.set(w,p),this.j.set(w,p),this.h.delete(w),this.b.fire({key:w,external:v}),this.D()}async delete(w,m=!1){if(!(this.c===u.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:m}),this.D()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=u.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(this.z)return this.D(w)}async D(w){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Np=g;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((m,v)=>this.a.set(v,m)),w.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Op=y}),define(oe[163],ae([0,1,8,3,32,9,21]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,y=Object.create(null)){this.g=g,this.h=y,this.c=(0,M.$oc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,y=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(w=>y.set(w.key,w.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(g){const y=await this.f;return this.j(y,g)}j(g,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,S.$zc)(y.insert):"0"}), delete(${y.delete?(0,S.$Ac)(y.delete):"0"})`),this.t(g,()=>{const k=y.insert,w=y.delete;if(k&&k.size>0){const m=[];m.push([]);let v=0;k.forEach((p,$)=>{let f=m[v];f.length>E.b&&(v++,f=[],m.push(f)),f.push($,p)}),m.forEach(p=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,$=>$.run(p),()=>{const $=[];let f=0;return k.forEach((l,d)=>{$.push(d),f+=l.length}),`Keys: ${$.join(", ")} Length: ${f}`})})}if(w&&w.size){const m=[];m.push([]);let v=0;w.forEach(p=>{let $=m[v];$.length>E.b&&(v++,$=[],m.push($)),$.push(p)}),m.forEach(p=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,$=>$.run(p),()=>{const $=[];return w.forEach(f=>{$.push(f)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,g)}k(g,y){return new Promise((k,w)=>{g.db.close(m=>(m&&this.o(g,`[storage ${this.c}] close(): ${m}`),this.g===E.IN_MEMORY_PATH?k():!g.isErroneous&&!g.isInMemory?this.l().then(k,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),k())):typeof y=="function"?P.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const p=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>p(),$=>(p(),Promise.reject($)))})).then(k,w):w(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return P.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const y=await this.f,k=await this.r(y,g?"PRAGMA integrity_check":"PRAGMA quick_check"),w=g?k.integrity_check:k.quick_check;return y.isErroneous?`${w} (last error: ${y.lastError})`:y.isInMemory?`${w} (in-memory!)`:w}async n(g,y=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${y})`);try{return await this.p(g)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&y)return await(0,i.$oh)(E.a),this.n(g,!1);try{await P.Promises.unlink(g);try{await P.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(w){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${w}`),this.p(E.IN_MEMORY_PATH)}}}o(g,y){g.isErroneous=!0,g.lastError=y,this.d.error(y)}p(g){return new Promise((y,k)=>{new Promise((w,m)=>{Q(["@vscode/sqlite3"],w,m)}).then(w=>{const m={db:new(this.d.isTracing?w.verbose().Database:w.Database)(g,v=>v?m.db&&v.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(v)):k(v):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(m),p=>m.db.close(()=>k(p)))),isInMemory:g===E.IN_MEMORY_PATH};m.db.on("error",v=>this.o(m,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&m.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},k)})}q(g,y){return new Promise((k,w)=>{g.db.exec(y,m=>m?(this.o(g,`[storage ${this.c}] exec(): ${m}`),w(m)):k())})}r(g,y){return new Promise((k,w)=>{g.db.get(y,(m,v)=>m?(this.o(g,`[storage ${this.c}] get(): ${m}`),w(m)):k(v))})}s(g,y){return new Promise((k,w)=>{g.db.all(y,(m,v)=>m?(this.o(g,`[storage ${this.c}] all(): ${m}`),w(m)):k(v))})}t(g,y){return new Promise((k,w)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),y(),g.db.run("END TRANSACTION",m=>m?(this.o(g,`[storage ${this.c}] transaction(): ${m}`),w(m)):k())})})}u(g,y,k,w){const m=g.db.prepare(y),v=p=>{this.o(g,`[storage ${this.c}] prepare(): ${p} (${y}). Details: ${w()}`)};m.on("error",v),k(m),m.finalize(p=>{p&&v(p),m.removeListener("error",v)})}}e.$OW=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[h.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(oe[164],ae([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(oe[165],ae([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[166],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[167],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(oe[168],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[169],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[170],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[171],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[172],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[173],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[174],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[175],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[176],ae([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[177],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[178],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[179],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[180],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[181],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[182],ae([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[183],ae([11,10]),function(Q,e){return Q.create("vs/platform/log/common/log",e)}),define(oe[184],ae([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[185],ae([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[186],ae([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[187],ae([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[188],ae([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[189],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[190],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[191],ae([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[192],ae([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[193],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[194],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[195],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[196],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[197],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[198],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7eb=i,e.$8eb=R;function i(S){return S&&S.hasOwnProperty("folderUri")}function R(S){return S&&S.hasOwnProperty("workspace")}}),define(oe[199],ae([0,1,7]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=R,e.$uac=S,e.$vac=M;function R(P){return typeof P?.backupFolder=="string"}function S(P){let E=[];try{Array.isArray(P.workspaces)&&(E=P.workspaces.map(h=>({workspace:{id:h.id,configPath:i.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function M(P){let E=[];try{Array.isArray(P.folders)&&(E=P.folders.map(h=>({folderUri:i.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(oe[200],ae([0,1,15,167]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var S;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(S||(e.TokenType=S={}));function M(...u){switch(u.length){case 1:return(0,R.localize)(0,null,u[0]);case 2:return(0,R.localize)(1,null,u[0],u[1]);case 3:return(0,R.localize)(2,null,u[0],u[1],u[2]);default:return}}const P=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,i.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const y=this.d,k=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:k};this.g.push({offset:y,lexeme:k,additionalInfo:g}),this.f.push(w)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const y=this.c.substring(this.d,this.e),k=h.b.get(y);k?this.k(k):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,y=!1,k=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(E);return}const m=this.c.charCodeAt(g);if(y)y=!1;else if(m===47&&!k){g++;break}else m===91?k=!0:m===92?y=!0:m===93&&(k=!1);g++}for(;g<this.c.length&&h.a.has(this.c.charCodeAt(g));)g++;this.e=g;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=h}),define(oe[201],ae([0,1,3,2]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=void 0;class S{constructor(){this.a=new i.$_d,this.b=new i.$_d,this.c=new i.$_d,this.d=new i.$_d}static{this.ChannelName="extensionhostdebugservice"}call(E,h,u){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(E,h,u){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$zo=S;class M extends R.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,u){this.b.call("attach",[E,h,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$Ao=M}),define(oe[202],ae([0,1,151,51,13,9,36,19,7]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Xm=g,e.$Ym=y,e.$Vm=/^([^.]+\..+)[:=](.+)$/;class u{get appRoot(){return(0,M.$nc)(S.$Hg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$1g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$1g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,i.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$kc)(this.userDataPath,"logs",w)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$1g)(h.URI.file((0,M.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$1g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$1g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$1g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=P.env.VSCODE_PORTABLE;return w?h.URI.file((0,M.$kc)(w,"argv.json")):(0,E.$1g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,M.$lc)(w):(0,M.$ic)((0,M.$kc)(S.$Hg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?h.URI.file((0,M.$lc)(w)):h.URI.file((0,M.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,M.$lc)(w);const m=P.env.VSCODE_EXTENSIONS;if(m)return m;const v=P.env.VSCODE_PORTABLE;return v?(0,M.$kc)(v,"extensions"):(0,E.$1g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(m=>/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,M.$ic)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?h.URI.parse(w):h.URI.file((0,M.$ic)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$Vm.test(w))}get extensionLogLevel(){const w=[];for(const m of this.args.log||[]){const v=e.$Vm.exec(m);v&&v[1]&&v[2]&&w.push([v[1],v[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,E.$1g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=P.env.VSCODE_PORTABLE;return w?h.URI.file((0,M.$kc)(w,"policy.json")):(0,E.$1g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,m,v){this.a=w,this.b=m,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Wm=u,Ee([R.$Rh],u.prototype,"appRoot",null),Ee([R.$Rh],u.prototype,"userHome",null),Ee([R.$Rh],u.prototype,"userDataPath",null),Ee([R.$Rh],u.prototype,"appSettingsHome",null),Ee([R.$Rh],u.prototype,"tmpDir",null),Ee([R.$Rh],u.prototype,"cacheHome",null),Ee([R.$Rh],u.prototype,"stateResource",null),Ee([R.$Rh],u.prototype,"userRoamingDataHome",null),Ee([R.$Rh],u.prototype,"userDataSyncHome",null),Ee([R.$Rh],u.prototype,"sync",null),Ee([R.$Rh],u.prototype,"machineSettingsResource",null),Ee([R.$Rh],u.prototype,"workspaceStorageHome",null),Ee([R.$Rh],u.prototype,"localHistoryHome",null),Ee([R.$Rh],u.prototype,"keyboardLayoutResource",null),Ee([R.$Rh],u.prototype,"argvResource",null),Ee([R.$Rh],u.prototype,"isExtensionDevelopment",null),Ee([R.$Rh],u.prototype,"untitledWorkspacesHome",null),Ee([R.$Rh],u.prototype,"builtinExtensionsPath",null),Ee([R.$Rh],u.prototype,"extensionsPath",null),Ee([R.$Rh],u.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$Rh],u.prototype,"extensionDevelopmentKind",null),Ee([R.$Rh],u.prototype,"extensionTestsLocationURI",null),Ee([R.$Rh],u.prototype,"debugExtensionHost",null),Ee([R.$Rh],u.prototype,"logLevel",null),Ee([R.$Rh],u.prototype,"extensionLogLevel",null),Ee([R.$Rh],u.prototype,"serviceMachineIdResource",null),Ee([R.$Rh],u.prototype,"disableTelemetry",null),Ee([R.$Rh],u.prototype,"disableWorkspaceTrust",null),Ee([R.$Rh],u.prototype,"useInMemorySecretStorage",null),Ee([R.$Rh],u.prototype,"policyFile",null);function g(k,w){return y(k["inspect-extensions"],k["inspect-brk-extensions"],5870,w,k.debugId,k.extensionEnvironment)}function y(k,w,m,v,p,$){const l=Number(w||k)||(v?null:m),d=l?!!w:!1;let a;if($)try{a=JSON.parse($)}catch{}return{port:l,break:d,debugId:p,env:a}}}),define(oe[116],ae([0,1,313,4,170]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0,e.$km=E,e.$lm=u,e.$mm=w,e.$nm=m;const M={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$im=["tunnel","serve-web"],e.$jm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,p,$=P){const f=v.find(c=>c.length>0&&c[0]!=="-"),l={},d=["_"],a=[],t={};let o;for(const c in p){const b=p[c];b.type==="subcommand"?c===f&&(o=b):(b.alias&&(l[c]=b.alias),b.type==="string"||b.type==="string[]"?(d.push(c),b.deprecates&&d.push(...b.deprecates)):b.type==="boolean"&&(a.push(c),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[c]=b))}if(o&&f){const c=t;for(const j in o.options)c[j]=o.options[j];const b=v.filter(j=>j!==f),I=$.getSubcommandReporter?$.getSubcommandReporter(f):void 0,D=E(b,c,I);return{[f]:D,_:[]}}const s=i(v,{string:d,boolean:a,alias:l}),n={},r=s;n._=s._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in p){const b=p[c];if(b.type==="subcommand")continue;b.alias&&delete r[b.alias];let I=r[c];if(b.deprecates)for(const D of b.deprecates)r.hasOwnProperty(D)&&(I||(I=r[D],I&&$.onDeprecatedOption(D,b.deprecationMessage||(0,S.localize)(38,null,c))),delete r[D]);if(typeof I<"u"){if(b.type==="string[]"){if(Array.isArray(I)||(I=[I]),!b.allowEmptyValue){const D=I.filter(j=>j.length>0);D.length!==I.length&&($.onEmptyValue(c),I=D.length>0?D:void 0)}}else b.type==="string"&&(Array.isArray(I)?(I=I.pop(),$.onMultipleValues(c,I)):!I&&!b.allowEmptyValue&&($.onEmptyValue(c),I=void 0));n[c]=I,b.deprecationMessage&&$.onDeprecatedOption(c,b.deprecationMessage)}delete r[c]}for(const c in r)$.onUnknownOption(c);return n}function h(v,p){let $="";return p.args&&(Array.isArray(p.args)?$=` <${p.args.join("> <")}>`:$=` <${p.args}>`),p.alias?`-${p.alias} --${v}${$}`:`--${v}${$}`}function u(v,p){const $=[];for(const f in v){const l=v[f],d=h(f,l);$.push([d,l.description])}return g($,p)}function g(v,p){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const l=p-f-1,d=[];for(const a of v){const t=a[0],o=k(a[1],l),s=y(f-t.length-2);d.push("  "+t+s+o[0]);for(let n=1;n<o.length;n++)d.push(y(f)+o[n])}return d}function y(v){return" ".repeat(v)}function k(v,p){const $=[];for(;v.length;){const f=v.length<p?v.length:v.lastIndexOf(" ",p),l=v.slice(0,f).trim();v=v.slice(f),$.push(l)}return $}function w(v,p,$,f,l){const d=process.stdout.isTTY&&process.stdout.columns||80,a=l?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${v} ${$}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${p} [${(0,S.localize)(41,null)}]${a}`),t.push(""),l?.noPipe!==!0&&(R.$i?t.push((0,S.localize)(42,null,p)):t.push((0,S.localize)(43,null,p)),t.push(""));const o={},s=[];for(const n in f){const r=f[n];if(r.type==="subcommand")r.description&&s.push({command:n,description:r.description});else if(r.description&&r.cat){let c=o[r.cat];c||(o[r.cat]=c={}),c[n]=r}}for(const n in o){const r=n,c=o[r];c&&(t.push(M[r]),t.push(...u(c,d)),t.push(""))}return s.length&&(t.push((0,S.localize)(44,null)),t.push(...g(s.map(n=>[n.command,n.description]),d)),t.push("")),t.join(`
`)}function m(v,p){return`${v||(0,S.localize)(45,null)}
${p||(0,S.localize)(46,null)}
${process.arch}`}}),define(oe[203],ae([0,1,88,201,116]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=void 0;class M extends R.$zo{constructor(E){super(),this.f=E}call(E,h,u){return h==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(E,h,u)}async g(E,h){const u=(0,S.$km)(E,S.$jm);u.debugRenderer=h;const g=u.extensionDevelopmentPath;if(!g)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!h)return{success:!0};const k=y.win;if(!k)return{success:!0};const w=k.webContents.debugger;let m=w.isAttached()?1/0:0;const v=(0,i.createServer)(p=>{m++===0&&w.attach();let $=!1;const f=a=>{$||p.write(JSON.stringify(a)+"\0")},l=(a,t,o,s)=>f({method:t,params:o,sessionId:s});k.on("close",()=>{w.removeListener("message",l),p.end(),$=!0}),w.addListener("message",l);let d=Buffer.alloc(0);p.on("data",a=>{d=Buffer.concat([d,a]);for(let t=d.indexOf(0);t!==-1;t=d.indexOf(0)){let o;try{const s=d.slice(0,t).toString("utf8");d=d.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}w.sendCommand(o.method,o.params,o.sessionId).then(s=>f({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{$=!0,--m===0&&w.detach()})});return await new Promise(p=>v.listen(0,p)),k.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$8ac=M}),define(oe[64],ae([0,1,314,171,116]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=E,e.$pm=h,e.$qm=u,e.$rm=g;function M(y,k){const w=(l,d)=>{console.warn((0,R.localize)(0,null,l,d))},m=l=>{console.warn((0,R.localize)(1,null,l))},v=(l,d)=>{console.warn((0,R.localize)(2,null,l,d))},p=l=>({onUnknownOption:d=>{S.$im.includes(l)||console.warn((0,R.localize)(3,null,d,l))},onMultipleValues:w,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:S.$im.includes(l)?p:void 0}),$={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:w,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:p},f=(0,S.$km)(y,S.$jm,k?$:void 0);return f.goto&&f._.forEach(l=>i(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),f}function P(y){const k=y.findIndex(w=>!/^-/.test(w));if(k>-1)return[...y.slice(0,k),...y.slice(k+1)]}function E(y){let[,...k]=y;process.env.VSCODE_DEV&&(k=P(k)||[]);const w=!g(process.env);return M(k,w)}function h(y){let[,,...k]=y;return process.env.VSCODE_DEV&&(k=P(k)||[]),M(k,!0)}function u(y,...k){const w=y.indexOf("--");return w===-1?y.push(...k):y.splice(w,0,...k),y}function g(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function Q(e,i,R){function S(P,E){const h=M(P,E),u=[h];return e.isAbsolute(h)||u.unshift(R),e.resolve(...u)}function M(P,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,E);const g=P["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(i.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,E)}return{getUserDataPath:S}}if(typeof define=="function")define(oe[204],ae([117,26,36]),function(e,i,R){return Q(e,i,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=Q(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[91],ae([0,1,26,202,204]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=void 0,e.$1m=P,e.$2m=E;class M extends R.$Wm{constructor(u,g){super(u,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,S.getUserDataPath)(u,g.nameShort)},g)}}e.$Zm=M;function P(h,u){return(0,R.$Ym)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,u,h.extensionEnvironment)}function E(h,u){return(0,R.$Ym)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,u,h.extensionEnvironment)}}),define(oe[205],ae([0,1,43,26,31]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=M;function M(P){const E=(0,S.$vg)((0,R.tmpdir)());try{return(0,i.writeFileSync)(E,""),P&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){P&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(oe[206],ae([0,1,12,173]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=S;function S(P,E,h,u){try{M(P,E,h,u)}catch(g){P.error(g?.message??g)}return E}function M(P,E,h,u){const g=(y,k,w)=>{const m=y[k];if((0,i.$1f)(m)){const v=m,p=v.length;if(p>1&&v[0]==="%"&&v[p-1]==="%"){const $=v.substr(1,p-2);let f=h[$];f===void 0&&u&&(f=u[$]);const l=typeof f=="string"?f:f?.message,d=u?.[$],a=typeof d=="string"?d:d?.message;if(!l){a||P.warn(`[${E.name}]: ${(0,R.localize)(0,null,$)}`);return}if(w&&(k==="title"||k==="category")&&a&&a!==l){const t={value:l,original:a};y[k]=t}else y[k]=l}}else if((0,i.$3f)(m))for(const v in m)m.hasOwnProperty(v)&&(v==="commands"?g(m,v,!0):g(m,v,w));else if(Array.isArray(m))for(let v=0;v<m.length;v++)g(m,v,w)};for(const y in E)E.hasOwnProperty(y)&&g(E,y)}}),define(oe[207],ae([0,1,19,74,175,208]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=h,e.$yp=u,e.$zp=g,e.$Ap=y,e.$Bp=k,e.$Cp=w,e.$Dp=m;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h($){return $=$.trim(),$==="*"||P.test($)}function u($){if(!h($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=$.match(P);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function g($){if(!$)return null;const f=$.majorBase,l=$.majorMustEqual,d=$.minorBase;let a=$.minorMustEqual;const t=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(f===0||(a=!1),o=!1);let s=0;if($.preRelease){const n=E.exec($.preRelease);if(n){const[,r,c,b]=n;s=Date.UTC(Number(r),Number(c)-1,Number(b))}}return{majorBase:f,majorMustEqual:l,minorBase:d,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:s}}function y($,f,l){let d;typeof $=="string"?d=g(u($)):d=$;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof l=="string"?t=g(u(l)):t=l,!d||!t)return!1;const o=d.majorBase,s=d.minorBase,n=d.patchBase;let r=t.majorBase,c=t.minorBase,b=t.patchBase;const I=t.notBefore;let D=t.majorMustEqual,j=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?o>r?!0:o<r?!1:s>c?!0:s<c||a&&a<I?!1:n>=b:(o===1&&r===0&&(!D||!j||!A)&&(r=1,c=0,b=0,D=!0,j=!1,A=!1),o<r?!1:o>r?!D:s<c?!1:s>c?!j:n<b?!1:n>b?!A:!(a&&a<I))}function k($,f,l,d,a){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([R.default.Error,S.localize(0,null)]),t;if(typeof d.name!="string")return t.push([R.default.Error,S.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([R.default.Error,S.localize(2,null,"version")]),t;if(!d.engines)return t.push([R.default.Error,S.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([R.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!p(d.extensionDependencies))return t.push([R.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!p(d.activationEvents))return t.push([R.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([R.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([R.default.Warning,S.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([R.default.Error,S.localize(9,null,"main")]),t;{const n=(0,i.$1g)(l,d.main);(0,i.$Ug)(n,l)||t.push([R.default.Warning,S.localize(10,null,n.path,l.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([R.default.Error,S.localize(11,null,"browser")]),t;{const n=(0,i.$1g)(l,d.browser);(0,i.$Ug)(n,l)||t.push([R.default.Warning,S.localize(12,null,n.path,l.path)])}}if(!M.valid(d.version))return t.push([R.default.Error,S.localize(13,null)]),t;const o=[];if(!w($,f,d,a,o))for(const n of o)t.push([R.default.Error,n]);return t}function w($,f,l,d,a){return d||typeof l.main>"u"&&typeof l.browser>"u"?!0:v($,f,l.engines.vscode,a)}function m($,f,l){return $==="*"||v(f,l,$)}function v($,f,l,d=[]){const a=g(u(l));if(!a)return d.push(S.localize(14,null,l)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return d.push(S.localize(15,null,l)),!1}else if(!a.majorMustEqual)return d.push(S.localize(16,null,l)),!1;return y($,f,a)?!0:(d.push(S.localize(17,null,$,l)),!1)}function p($){if(!Array.isArray($))return!1;for(let f=0,l=$.length;f<l;f++)if(typeof $[f]!="string")return!1;return!0}}),define(oe[209],ae([0,1,17,33]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=S;async function S(M,P,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const g=(await P.readFile(M.serviceMachineIdResource)).value.toString();h=(0,R.$Ig)(g)?g:null}catch{h=null}if(!h){h=(0,R.$Jg)();try{await P.writeFile(M.serviceMachineIdResource,i.$ze.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(oe[78],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class i{constructor(S,M=[],P=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.$ki=i}),define(oe[210],ae([0,1,78]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=M,e.$ms=P;const R=[];var S;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function M(E,h,u){h instanceof i.$ki||(h=new i.$ki(h,[],!!u)),R.push([E,h])}function P(){return R}}),define(oe[211],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class i{constructor(M,P){this.key=M,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$2q=i;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const P of this.a.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const E=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(P);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(M){const P=this.b(M);this.a.delete(P);for(const E of this.a.values())E.outgoing.delete(P),E.incoming.delete(P)}lookupOrInsertNode(M){const P=this.b(M);let E=this.a.get(P);return E||(E=new i(P,M),this.a.set(P,E)),E}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[P,E]of this.a)M.push(`${P}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,P]of this.a){const E=new Set([M]),h=this.c(P,E);if(h)return h}}c(M,P){for(const[E,h]of M.outgoing){if(P.has(E))return[...P,E].join(" -> ");P.add(E);const u=this.c(h,P);if(u)return u;P.delete(E)}}}e.$3q=R}),define(oe[6],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e._util=void 0,e.$ni=S,e.$oi=M;var i;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=E})(i||(e._util=i={})),e.$mi=S("instantiationService");function R(P,E,h){E[i.DI_TARGET]===E?E[i.DI_DEPENDENCIES].push({id:P,index:h}):(E[i.DI_DEPENDENCIES]=[{id:P,index:h}],E[i.DI_TARGET]=E)}function S(P){if(i.serviceIds.has(P))return i.serviceIds.get(P);const E=function(h,u,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,h,g)};return E.toString=()=>P,i.serviceIds.set(P,E),E}function M(P){return P}}),define(oe[79],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0,e.$nbc=(0,i.$ni)("auxiliaryWindowsMainService")}),define(oe[65],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0,e.$wac=(0,i.$ni)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=M,e.$Vi=P,e.$Wi=h,e.$Xi=u,e.$Yi=g,e.$Zi=y,e.$1i=k,e.$2i=m,e.$3i=v,e.$4i=p,e.$Ti=(0,S.$ni)("configurationService");function M($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof R.URI)}function P($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof R.URI)}var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function u($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function g($,f){const l=Object.create(null);for(const d in $)y(l,d,$[d],f);return l}function y($,f,l,d){const a=f.split("."),t=a.pop();let o=$;for(let s=0;s<a.length;s++){const n=a[s];let r=o[n];switch(typeof r){case"undefined":r=o[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[t]=l}catch{d(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}function k($,f){const l=f.split(".");w($,l)}function w($,f){const l=f.shift();if(f.length===0){delete $[l];return}if(Object.keys($).indexOf(l)!==-1){const d=$[l];typeof d=="object"&&!Array.isArray(d)&&(w(d,f),Object.keys(d).length===0&&delete $[l])}}function m($,f,l){function d(o,s){let n=o;for(const r of s){if(typeof n!="object"||n===null)return;n=n[r]}return n}const a=f.split("."),t=d($,a);return typeof t>"u"?l:t}function v($,f,l){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in $?i.$3f($[d])&&i.$3f(f[d])?v($[d],f[d],l):l&&($[d]=f[d]):$[d]=f[d])})}function p($){return $.replace(/[\[\]]/g,"")}}),define(oe[118],ae([0,1,4,25,200,6,166,15]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=u,e.$mj=o,e.$nj=s,e.$Gj=z;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",i.$j),h.set("isLinux",i.$k),h.set("isWindows",i.$i),h.set("isWeb",i.$o),h.set("isMacNative",i.$j&&!i.$o),h.set("isEdge",i.$H),h.set("isFirefox",i.$F),h.set("isChrome",i.$E),h.set("isSafari",i.$G);function u(X,O){if(h.get(X)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(X,O)}const g=Object.prototype.hasOwnProperty;var y;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const k={regexParsingWithErrorRecovery:!0},w=(0,P.localize)(0,null),m=(0,P.localize)(1,null),v=(0,P.localize)(2,null),p=(0,P.localize)(3,null),$=(0,P.localize)(4,null),f=(0,P.localize)(5,null),l=(0,P.localize)(6,null),d=(0,P.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=k){this.k=O,this.d=new S.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const _=this.D(),se=_.type===17?f:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:S.$ij.getLexeme(_),additionalInfo:se}),a.c}return F}catch(F){if(F!==a.c)throw F;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const F=this.o();O.push(F)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const F=this.s();O.push(F)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,p),F?.negate()}case 17:return this.z(),C.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,p),F}case 17:{const F=O.lexeme;if(this.z(),this.y(9)){const se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),se.type!==10)throw this.B("REGEX",se);const J=se.lexeme,x=J.lastIndexOf("/"),V=x===J.length-1?void 0:this.w(J.substring(x+1));let q;try{q=new RegExp(J.substring(1,x),V)}catch{throw this.B("REGEX",se)}return ie.create(F,q)}switch(se.type){case 10:case 19:{const J=[se.lexeme];this.z();let x=this.D(),V=0;for(let me=0;me<se.lexeme.length;me++)se.lexeme.charCodeAt(me)===40?V++:se.lexeme.charCodeAt(me)===41&&V--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let me=0;me<x.lexeme.length;me++)x.lexeme.charCodeAt(me)===40?V++:se.lexeme.charCodeAt(me)===41&&V--}if(V<0)break;J.push(S.$ij.getLexeme(x)),this.z(),x=this.D()}const q=J.join(""),re=q.lastIndexOf("/"),ee=re===q.length-1?void 0:this.w(q.substring(re+1));let fe;try{fe=new RegExp(q.substring(1,re),ee)}catch{throw this.B("REGEX",se)}return t.regex(F,fe)}case 18:{const J=se.lexeme;this.z();let x=null;if(!(0,R.$Ze)(J)){const V=J.indexOf("/"),q=J.lastIndexOf("/");if(V!==q&&V>=0){const re=J.slice(V+1,q),ee=J[q+1]==="i"?"i":"";try{x=new RegExp(re,ee)}catch{throw this.B("REGEX",se)}}}if(x===null)throw this.B("REGEX",se);return ie.create(F,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const se=this.u();return t.notIn(F,se)}switch(this.D().type){case 3:{this.z();const se=this.u();if(this.x().type===18)return t.equals(F,se);switch(se){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,se)}}case 4:{this.z();const se=this.u();if(this.x().type===18)return t.notEquals(F,se);switch(se){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,se)}}case 5:return this.z(),U.create(F,this.u());case 6:return this.z(),ue.create(F,this.u());case 7:return this.z(),T.create(F,this.u());case 8:return this.z(),N.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:d}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,F){if(this.C(O))return this.z();throw this.B(F,this.D())}B(O,F,_){const se=(0,P.localize)(8,null,O,S.$ij.getLexeme(F)),J=F.offset,x=S.$ij.getLexeme(F);return this.h.push({message:se,offset:J,lexeme:x,additionalInfo:_}),a.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=a;class t{static false(){return r.INSTANCE}static true(){return c.INSTANCE}static has(O){return b.create(O)}static equals(O,F){return I.create(O,F)}static notEquals(O,F){return A.create(O,F)}static regex(O,F){return ie.create(O,F)}static in(O,F){return D.create(O,F)}static notIn(O,F){return j.create(O,F)}static not(O){return C.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return B.create(O,null,!0)}static greater(O,F){return T.create(O,F)}static greaterEquals(O,F){return N.create(O,F)}static smaller(O,F){return U.create(O,F)}static smallerEquals(O,F){return ue.create(O,F)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$lj=t;function o(X){const O=new a({regexParsingWithErrorRecovery:!1});return X.map(F=>(O.parse(F),O.lexingErrors.length>0?O.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,P.localize)(9,null,_.additionalInfo):(0,P.localize)(10,null),offset:_.offset,length:_.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(X,O){const F=X?X.substituteConstants():void 0,_=O?O.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}function n(X,O){return X.cmp(O)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return c.INSTANCE}}e.$oj=r;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return r.INSTANCE}}e.$pj=c;class b{static create(O,F=null){const _=h.get(O);return typeof _=="boolean"?_?c.INSTANCE:r.INSTANCE:new b(O,F)}constructor(O,F){this.key=O,this.c=F,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:H(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=h.get(this.key);return typeof O=="boolean"?O?c.INSTANCE:r.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$qj=b;class I{static create(O,F,_=null){if(typeof F=="boolean")return F?b.create(O,_):C.create(O,_);const se=h.get(O);return typeof se=="boolean"?F===(se?"true":"false")?c.INSTANCE:r.INSTANCE:new I(O,F,_)}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=h.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?c.INSTANCE:r.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$rj=I;class D{static create(O,F){return new D(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.f),_=O.getValue(this.d);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?g.call(F,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=j.create(this.d,this.f)),this.c}}e.$sj=D;class j{static create(O,F){return new j(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=11,this.c=D.create(O,F)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=j;class A{static create(O,F,_=null){if(typeof F=="boolean")return F?C.create(O,_):b.create(O,_);const se=h.get(O);return typeof se=="boolean"?F===(se?"true":"false")?r.INSTANCE:c.INSTANCE:new A(O,F,_)}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=h.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?r.INSTANCE:c.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$uj=A;class C{static create(O,F=null){const _=h.get(O);return typeof _=="boolean"?_?r.INSTANCE:c.INSTANCE:new C(O,F)}constructor(O,F){this.c=O,this.d=F,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=h.get(this.c);return typeof O=="boolean"?O?r.INSTANCE:c.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$vj=C;function W(X,O){if(typeof X=="string"){const F=parseFloat(X);isNaN(F)||(X=F)}return typeof X=="string"||typeof X=="number"?O(X):r.INSTANCE}class T{static create(O,F,_=null){return W(F,se=>new T(O,se,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$wj=T;class N{static create(O,F,_=null){return W(F,se=>new N(O,se,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$xj=N;class U{static create(O,F,_=null){return W(F,se=>new U(O,se,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$yj=U;class ue{static create(O,F,_=null){return W(F,se=>new ue(O,se,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$zj=ue;class ie{static create(O,F){return new ie(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const F=this.f?this.f.source:"",_=O.f?O.f.source:"";return F<_?-1:F>_?1:0}equals(O){if(O.type===this.type){const F=this.f?this.f.source:"",_=O.f?O.f.source:"";return this.d===O.d&&F===_}return!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=le.create(this)),this.c}}e.$Aj=ie;class le{static create(O){return new le(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new le(this.c.map(O))}negate(){return this.c}}e.$Bj=le;function Y(X){let O=null;for(let F=0,_=X.length;F<_;F++){const se=X[F].substituteConstants();if(X[F]!==se&&O===null){O=[];for(let J=0;J<F;J++)O[J]=X[J]}O!==null&&(O[F]=se)}return O===null?X:O}class K{static create(O,F,_){return K.d(O,F,_)}constructor(O,F){this.expr=O,this.c=F,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const se=n(this.expr[F],O.expr[F]);if(se!==0)return se}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(O))return!1;return!0}static d(O,F,_){const se=[];let J=!1;for(const x of O)if(x){if(x.type===1){J=!0;continue}if(x.type===0)return r.INSTANCE;if(x.type===6){se.push(...x.expr);continue}se.push(x)}if(se.length===0&&J)return c.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(n);for(let x=1;x<se.length;x++)se[x-1].equals(se[x])&&(se.splice(x,1),x--);if(se.length===1)return se[0];for(;se.length>1;){const x=se[se.length-1];if(x.type!==9)break;se.pop();const V=se.pop(),q=se.length===0,re=B.create(x.expr.map(ee=>K.create([ee,V],null,_)),null,q);re&&(se.push(re),se.sort(n))}if(se.length===1)return se[0];if(_){for(let x=0;x<se.length;x++)for(let V=x+1;V<se.length;V++)if(se[x].negate().equals(se[V]))return r.INSTANCE;if(se.length===1)return se[0]}return new K(se,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new K(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());this.c=B.create(O,this,!0)}return this.c}}e.$Cj=K;class B{static create(O,F,_){return B.d(O,F,_)}constructor(O,F){this.expr=O,this.c=F,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const se=n(this.expr[F],O.expr[F]);if(se!==0)return se}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:B.create(O,this.c,!1)}evaluate(O){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(O))return!0;return!1}static d(O,F,_){let se=[],J=!1;if(O){for(let x=0,V=O.length;x<V;x++){const q=O[x];if(q){if(q.type===0){J=!0;continue}if(q.type===1)return c.INSTANCE;if(q.type===9){se=se.concat(q.expr);continue}se.push(q)}}if(se.length===0&&J)return r.INSTANCE;se.sort(n)}if(se.length!==0){if(se.length===1)return se[0];for(let x=1;x<se.length;x++)se[x-1].equals(se[x])&&(se.splice(x,1),x--);if(se.length===1)return se[0];if(_){for(let x=0;x<se.length;x++)for(let V=x+1;V<se.length;V++)if(se[x].negate().equals(se[V]))return c.INSTANCE;if(se.length===1)return se[0]}return new B(se,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new B(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());for(;O.length>1;){const F=O.shift(),_=O.shift(),se=[];for(const J of he(F))for(const x of he(_))se.push(K.create([J,x],null,!1));O.unshift(B.create(se,null,!1))}this.c=B.create(O,this,!0)}return this.c}}e.$Dj=B;class L extends b{static{this.d=[]}static all(){return L.d.values()}constructor(O,F,_){super(O,null),this.f=F,typeof _=="object"?L.d.push({..._,key:O}):_!==!0&&L.d.push({key:O,description:_,type:F!=null?typeof F:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return I.create(this.key,O)}notEqualsTo(O){return A.create(this.key,O)}}e.$Ej=L,e.$Fj=(0,M.$ni)("contextKeyService");function H(X,O){return X<O?-1:X>O?1:0}function G(X,O,F,_){return X<F?-1:X>F?1:O<_?-1:O>_?1:0}function z(X,O){if(X.type===0||O.type===1)return!0;if(X.type===9)return O.type===9?ce(X.expr,O.expr):!1;if(O.type===9){for(const F of O.expr)if(z(X,F))return!0;return!1}if(X.type===6){if(O.type===6)return ce(O.expr,X.expr);for(const F of X.expr)if(z(F,O))return!0;return!1}return X.equals(O)}function ce(X,O){let F=0,_=0;for(;F<X.length&&_<O.length;){const se=X[F].cmp(O[_]);if(se<0)return!1;se===0&&F++,_++}return F===X.length}function he(X){return X.type===9?X.expr:[X]}}),define(oe[92],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$7m=e.ID=void 0,e.$8m=R,e.ID="diagnosticsService",e.$7m=(0,i.$ni)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}class S{async getPerformanceInfo(P,E){return{}}async getSystemInfo(P,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(P,E){return""}async getWorkspaceFileExtensions(P){return{extensions:[]}}async reportWorkspaceStats(P){}}e.$9m=S}),define(oe[119],ae([0,1,19,74,168,6,48,4,35]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$xw=e.$ww=e.$vw=void 0,e.$yw=w,e.$zw=m,e.$vw=(0,M.$ni)("dialogService");var u;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(u||(u={}));class g{a(p){return this.d(p,u.Confirmation)}b(p){return this.d(p,u.Prompt)}c(p){return this.d(p,u.Input)}d(p,$){const f=[];switch($){case u.Confirmation:{const l=p;l.primaryButton?f.push(l.primaryButton):f.push((0,S.localize)(0,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,S.localize)(1,null));break}case u.Prompt:{const l=p;Array.isArray(l.buttons)&&l.buttons.length>0&&f.push(...l.buttons.map(d=>d.label)),l.cancelButton&&(l.cancelButton===!0?f.push((0,S.localize)(2,null)):typeof l.cancelButton=="string"?f.push(l.cancelButton):l.cancelButton.label?f.push(l.cancelButton.label):f.push((0,S.localize)(3,null))),f.length===0&&f.push((0,S.localize)(4,null));break}case u.Input:{const l=p;l.primaryButton?f.push(l.primaryButton):f.push((0,S.localize)(5,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,S.localize)(6,null));break}}return f}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===R.default.Info?"info":p===R.default.Error?"error":p===R.default.Warning?"warning":"none"}f(p,$,f){const l=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&l.push(p.cancelButton);let d=l[$]?.run({checkboxChecked:f});return d instanceof Promise||(d=Promise.resolve(d)),{result:d,checkboxChecked:f}}}e.$ww=g,e.$xw=(0,M.$ni)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const k=10;function w(v){const p=[];return p.push(...v.slice(0,k).map($=>typeof $=="string"?$:(0,i.$Xg)($))),v.length>k&&(v.length-k===1?p.push((0,S.localize)(7,null)):p.push((0,S.localize)(8,null,v.length-k))),p.push(""),p.join(`
`)}function m(v,p){const $=(0,h.$Tn)(v);let f=($.buttons??[]).map(t=>(0,P.$sw)(t)),l=(v.buttons||[]).map((t,o)=>o),d=0,a=$.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=l[a];l.splice(a,1),l.splice(1,0,o),a=1}E.$k&&f.length>1&&(f=f.reverse(),l=l.reverse(),d=f.length-1,typeof t=="string"&&(a=d-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=l[a];l.splice(a,1),l.push(o),a=f.length-1}}return $.buttons=f,$.defaultId=d,$.cancelId=a,$.noLink=!0,$.title=$.title||p.nameLong,{options:$,buttonIndeces:l}}}),define(oe[120],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$5W=e.$4W=void 0,e.$6W=M,e.$7W=P,e.$4W=(0,i.$ni)("encryptionService"),e.$5W=(0,i.$ni)("encryptionMainService");var R;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var S;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function M(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function P(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(oe[38],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,i.$ni)("environmentService"),e.$vi=(0,i.$oi)(e.$ui)}),define(oe[121],ae([0,1,172,6]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=S,e.$Ro=M,e.$So=P,e.$To=E,e.$Uo=h,e.$Vo=u,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function S(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(l,d){return d==="web"&&!l.includes("web")}function h(l,d,a){return E(d,a)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===a}function u(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var g;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var k;(function(l){l.Install="install",l.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var w;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Wo=(0,R.$ni)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var v;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class p extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.$Xo=p;var $;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.$Yo=f,e.$Zo=(0,R.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,R.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,R.$ni)("IExtensionTipsService"),e.$5o=(0,i.localize2)(0,"Extensions"),e.$6o=(0,i.localize2)(1,"Preferences")}),define(oe[212],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0,e.$cbc=(0,i.$ni)("extensionHostStarter"),e.$dbc="extensionHostStarter"}),define(oe[213],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=e.$$5b=void 0,e.$$5b=(0,i.$ni)("externalTerminal"),e.$_5b="Terminal.app"}),define(oe[214],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0,e.$fbc=(0,i.$ni)("externalTerminal")}),define(oe[215],ae([0,1,49,51,13,9,4,76,21,90,176,213]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=e.$gbc=void 0;const k=g.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends w{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(i,a,u.$fm(),t)}spawnTerminal(a,t,o,s){const n=t.windowsExec||m.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const r=M.$oc(n,".exe").toLowerCase();if(r==="cmder")return a.spawn(n,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return n.indexOf(" ")>=0&&c.push('""'),c.push(n),r==="wt"&&c.push("-d ."),new Promise((b,I)=>{const D=$(process),j=a.spawn(o,c,{cwd:s,env:D,detached:!0});j.on("error",I),j.on("exit",()=>b())})}async runInTerminal(a,t,o,s,n){const r="windowsExec"in n&&n.windowsExec?n.windowsExec:m.getDefaultTerminalWindows(),c=await m.f();return new Promise((b,I)=>{const D=`"${t} - ${k}"`,j=`"${o.join('" "')}" & pause`,A=Object.assign({},$(process),s);Object.keys(A).filter(U=>A[U]===null).forEach(U=>delete A[U]);const C={cwd:t,env:A,windowsVerbatimArguments:!0};let W,T;M.$oc(r,".exe")==="wt"?(W=r,T=["-d",".",m.b,"/c",j]):c?(W=c,T=["-d",".",r,"/c",j]):(W=m.b,T=["/c","start",D,"/wait",r,"/c",`"${j}"`]),i.spawn(W,T,C).on("error",U=>{I(f(U))}),b(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await u.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$gbc=m,Ee([R.$Rh],m,"f",null);class v extends w{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(i,a,t)}runInTerminal(a,t,o,s,n){const r=n.osxExec||y.$_5b;return new Promise((c,b)=>{if(r===y.$_5b||r==="iTerm.app"){const I=r===y.$_5b?"TerminalHelper":"iTermHelper",j=[S.$Hg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",a||k,"-w",t];for(const W of o)j.push("-a"),j.push(W);if(s){const W=Object.assign({},$(process),s);for(const T in W){const N=W[T];N===null?(j.push("-u"),j.push(T)):(j.push("-e"),j.push(`${T}=${N}`))}}let A="";const C=i.spawn(v.b,j);C.on("error",W=>{b(f(W))}),C.stderr.on("data",W=>{A+=W.toString()}),C.on("exit",W=>{if(W===0)c(void 0);else if(A){const T=A.split(`
`,1);b(new Error(T[0]))}else b(new Error(g.localize(1,null,I,W)))})}else b(new Error(g.localize(2,null,r)))})}spawnTerminal(a,t,o){const s=t.osxExec||y.$_5b;return new Promise((n,r)=>{const c=["-a",s];o&&c.push(o);const b=$(process),I=a.spawn("/usr/bin/open",c,{cwd:o,env:b});I.on("error",r),I.on("exit",()=>n())})}}e.$hbc=v;class p extends w{static{this.b=g.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(i,a,t)}runInTerminal(a,t,o,s,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,b)=>{const I=[];r.then(D=>{D.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const j=`${l(o)}; echo; read -p "${p.b}" -n1;`;I.push(`''${j}''`);const A=Object.assign({},$(process),s);Object.keys(A).filter(N=>A[N]===null).forEach(N=>delete A[N]);const C={cwd:t,env:A};let W="";const T=i.spawn(D,I,C);T.on("error",N=>{b(f(N))}),T.stderr.on("data",N=>{W+=N.toString()}),T.on("exit",N=>{if(N===0)c(void 0);else if(W){const U=W.split(`
`,1);b(new Error(U[0]))}else b(new Error(g.localize(4,null,D,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!P.$k)p.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,o){const s=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{s.then(c=>{const b=$(process),I=a.spawn(c,[],{cwd:o,env:b});I.on("error",r),I.on("exit",()=>n())})})}}e.$ibc=p;function $(d){const a={...d.env};return(0,E.$dm)(a),a}function f(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(g.localize(5,null,d.path)):d}function l(d){let a="";for(const t of d)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(oe[16],ae([0,1,59,9,25,12,7,178,6,4,13,62]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ml=e.FileKind=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.FileOperationResult=e.$el=e.$dl=e.$cl=e.$al=e.FileChangeType=e.$_k=e.FileOperation=e.$6k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tk=void 0,e.$Uk=k,e.$Vk=v,e.$Wk=$,e.$Xk=f,e.$Yk=l,e.$Zk=d,e.$1k=a,e.$2k=t,e.$3k=o,e.$4k=s,e.$5k=n,e.$7k=b,e.$8k=I,e.$9k=D,e.$0k=j,e.$$k=A,e.$bl=U,e.$nl=B,e.$ol=L,e.$ql=G,e.$Tk=(0,h.$ni)("fileService");function k(z){return z.create===!0}var w;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var m;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function v(z){const ce=z;return!!ce&&typeof ce.onDidChange=="function"}var p;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function $(z){return!!(z.capabilities&2)}function f(z){return!!(z.capabilities&8)}function l(z){return!!(z.capabilities&131072)}function d(z){return!!(z.capabilities&4)}function a(z){return!!(z.capabilities&16)}function t(z){return $(z)?!!(z.capabilities&16384):!1}function o(z){return $(z)?!!(z.capabilities&32768):!1}function s(z){return!!(z.capabilities&65536)}function n(z){return!!(z.capabilities&2048)}var r;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class c extends Error{static create(ce,he){const X=new c(ce.toString(),he);return D(X,he),X}constructor(ce,he){super(ce),this.code=he}}e.$6k=c;function b(z,ce){return c.create(z,ce)}function I(z){return z||b((0,E.localize)(0,null),r.Unknown)}function D(z,ce){return z.name=ce?`${ce} (FileSystemError)`:"FileSystemError",z}function j(z){if(!z)return r.Unknown;if(z instanceof c)return z.code;const ce=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ce)return r.Unknown;switch(ce[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function A(z){if(z instanceof ue)return z.fileOperationResult;switch(j(z)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}var C;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class W{constructor(ce,he,X){this.resource=ce,this.operation=he,this.target=X}isOperation(ce){return this.operation===ce}}e.$_k=W;var T;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class N{static{this.a=null}constructor(ce,he){this.c=he,this.b=void 0,this.d=new y.$V(()=>{const X=i.$ti.forUris(()=>this.c);return X.fill(this.rawAdded.map(O=>[O,!0])),X}),this.f=new y.$V(()=>{const X=i.$ti.forUris(()=>this.c);return X.fill(this.rawUpdated.map(O=>[O,!0])),X}),this.g=new y.$V(()=>{const X=i.$ti.forUris(()=>this.c);return X.fill(this.rawDeleted.map(O=>[O,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of ce){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==N.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(ce,...he){return this.h(ce,{includeChildren:!1},...he)}affects(ce,...he){return this.h(ce,{includeChildren:!0},...he)}h(ce,he,...X){if(!ce)return!1;const O=X.length>0;return!!((!O||X.includes(1))&&(this.d.value.get(ce)||he.includeChildren&&this.d.value.findSuperstr(ce))||(!O||X.includes(0))&&(this.f.value.get(ce)||he.includeChildren&&this.f.value.findSuperstr(ce))||(!O||X.includes(2))&&(this.g.value.findSubstr(ce)||he.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$al=N;function U(z,ce,he){return!z||!ce||z===ce||ce.length>z.length?!1:(ce.charAt(ce.length-1)!==R.sep&&(ce+=R.sep),he?(0,S.$rf)(z,ce):z.indexOf(ce)===0)}class ue extends Error{constructor(ce,he,X){super(ce),this.fileOperationResult=he,this.options=X}}e.$cl=ue;class ie extends ue{constructor(ce,he,X,O){super(ce,he,O),this.fileOperationResult=he,this.size=X}}e.$dl=ie;class le extends ue{constructor(ce,he,X){super(ce,2,X),this.stat=he}}e.$el=le;var Y;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$hl="files.associations",e.$il="files.exclude",e.$jl="files.readonlyInclude",e.$kl="files.readonlyExclude",e.$ll="files.readonlyFromPermissions";var K;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$ml="";function B(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}async function L(z,ce){if(!ce.hasProvider(P.URI.from({scheme:z.scheme})))return new Promise(he=>{const X=ce.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===z.scheme&&O.added&&(X.dispose(),he())})})}class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ce){return(0,M.$5f)(ce)||(ce=0),ce<H.KB?(0,E.localize)(1,null,ce.toFixed(0)):ce<H.MB?(0,E.localize)(2,null,(ce/H.KB).toFixed(2)):ce<H.GB?(0,E.localize)(3,null,(ce/H.MB).toFixed(2)):ce<H.TB?(0,E.localize)(4,null,(ce/H.GB).toFixed(2)):(0,E.localize)(5,null,(ce/H.TB).toFixed(2))}}e.$pl=H;function G(z){const ce=typeof z=="string"||z?.scheme===g.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===g.Schemas.file?1024*H.MB:ce?10*H.MB:u.$o?50*H.MB:1024*H.MB}}),define(oe[122],ae([0,1,17,15,179,16]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=P;async function P(g,y,k,w,m,v){let p;try{await E(g,y,k,w,m,v)}catch($){p=$}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&k.error(p),k.end()}}async function E(g,y,k,w,m,v){h(v);const p=await g.open(y,{create:!1});try{h(v);let $=0,f=0,l=m&&typeof m.length=="number"?m.length:void 0,d=i.$ze.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await g.read(p,a,d.buffer,t,d.byteLength-t),a+=f,t+=f,$+=f,typeof l=="number"&&(l-=f),t===d.byteLength&&(await k.write(w(d)),d=i.$ze.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),t=0);while(f>0&&(typeof l!="number"||l>0)&&h(v)&&u($,m));if(t>0){let o=t;typeof l=="number"&&(o=Math.min(t,l)),k.write(w(d.slice(0,o)))}}catch($){throw(0,M.$8k)($)}finally{await g.close(p)}}function h(g){if(g.isCancellationRequested)throw(0,R.$6)();return!0}function u(g,y){if(typeof y?.limits?.size=="number"&&g>y.limits.size)throw(0,M.$7k)((0,S.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[60],ae([0,1,108,2,9,4,7,16]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=void 0,e.$Aq=h,e.$Bq=u,e.$Fq=w,e.$Gq=m,e.$Hq=v,e.$Iq=p;function h(f){return typeof f.correlationId=="number"}function u(f){return f.recursive===!0}class g extends R.$Uc{static{this.a=5}constructor(l,d,a,t){super(),this.h=l,this.j=d,this.m=a,this.n=t,this.c=this.B(new R.$Vc),this.f=void 0,this.g=0}s(){const l=new R.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(d=>this.h(d))),l.add(this.b.onDidLogMessage(d=>this.j(d))),l.add(this.b.onDidError(d=>this.t(d)))}t(l){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cq=g;class y extends g{constructor(l,d,a){super(l,d,a,{type:"node.js",restartOnError:!1})}}e.$Dq=y;class k extends g{constructor(l,d,a){super(l,d,a,{type:"universal",restartOnError:!0})}}e.$Eq=k;function w(f){return f.map(l=>({type:l.type,resource:P.URI.revive(l.resource),cId:l.cId}))}function m(f){const l=new $;for(const d of f)l.processEvent(d);return l.coalesce()}function v(f,l){return typeof l=="string"&&!l.startsWith(i.$dk)&&!(0,S.$jc)(l)?{base:f,pattern:l}:l}function p(f,l){const d=[];for(const a of l)d.push((0,i.$hk)(v(f,a)));return d}class ${constructor(){this.a=new Set,this.b=new Map}c(l){return M.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const d=this.b.get(this.c(l));let a=!1;if(d){const t=d.type,o=l.type;d.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?a=!0:t===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(d)):t===2&&o===1?d.type=0:t===1&&o===0||(d.type=o)}else a=!0;a&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],d=[];return Array.from(this.a).filter(a=>a.type!==2?(l.push(a),!1):!0).sort((a,t)=>a.resource.fsPath.length-t.resource.fsPath.length).filter(a=>d.some(t=>(0,E.$bl)(a.resource.fsPath,t,!M.$k))?!1:(d.push(a.resource.fsPath),!0)).concat(l)}}}),define(oe[216],ae([0,1,17,47,15,3,2,63,33,16,60]),function(Q,e,i,R,S,M,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P="localFilesystem";class y extends P.$Uc{constructor(w,m){super(),this.a=w,this.b=m,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$_d),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$_d),this.onDidWatchError=this.g.event,this.h=(0,h.$Jg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,m){const{buffer:v}=await this.a.call("readFile",[w,m]);return v}readFileStream(w,m,v){const p=(0,E.$ne)(f=>i.$ze.concat(f.map(l=>i.$ze.wrap(l))).buffer),$=new P.$Tc;return $.add(this.a.listen("readFileStream",[w,m])(f=>{if(f instanceof i.$ze)p.write(f.buffer);else{if(f==="end")p.end();else{let l;if(f instanceof Error)l=f;else{const d=f;l=(0,u.$7k)(d.message??(0,R.$$i)(d),d.code??u.FileSystemProviderErrorCode.Unknown)}p.error(l),p.end()}$.dispose()}})),$.add(v.onCancellationRequested(()=>{p.error((0,S.$6)()),p.end(),$.dispose()})),p}writeFile(w,m,v){return this.a.call("writeFile",[w,i.$ze.wrap(m),v])}open(w,m){return this.a.call("open",[w,m])}close(w){return this.a.call("close",[w])}async read(w,m,v,p,$){const[f,l]=await this.a.call("read",[w,m,$]);return v.set(f.buffer.slice(0,l),p),l}write(w,m,v,p,$){return this.a.call("write",[w,m,i.$ze.wrap(v),p,$])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,m){return this.a.call("delete",[w,m])}rename(w,m,v){return this.a.call("rename",[w,m,v])}copy(w,m,v){return this.a.call("copy",[w,m,v])}cloneFile(w,m){return this.a.call("cloneFile",[w,m])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const m=w;this.f.fire((0,g.$Fq)(m))}else{const m=w;this.g.fire(m)}}))}watch(w,m){const v=(0,h.$Jg)();return this.a.call("watch",[this.h,v,w,m]),(0,P.$Sc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$2P=y}),define(oe[217],ae([0,1,43,2,60,3,7,8]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class h extends R.$Uc{constructor(){super(),this.a=this.B(new M.$_d),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$_d),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$_d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new R.$4c),this.m=new Set,this.n=5007,this.r=new E.$Kh,this.B(this.f(g=>this.s(g)))}s(g){this.t(g)&&this.w(g)}t(g){return(0,S.$Aq)(g)}async watch(g){this.r.isSettled||this.r.complete(),this.r=new E.$Kh;try{this.h.clear(),this.g.clear();for(const y of g)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))])}isSuspended(g){return typeof g.correlationId!="number"?!1:this.m.has(g.correlationId)?"polling":this.j.has(g.correlationId)}async w(g){if(this.j.has(g.correlationId))return;const y=new R.$Tc;this.j.set(g.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(g,y),this.u())}y(g){this.j.deleteAndDispose(g.correlationId),this.m.delete(g.correlationId),this.u()}z(g,y){this.C(g,y)?(this.M(`reusing an existing recursive watcher to monitor ${g.path}`),this.m.delete(g.correlationId)):(this.D(g,y),this.m.add(g.correlationId))}C(g,y){const k=this.L?.subscribe(g.path,(w,m)=>{y.isDisposed||(w?this.z(g,y):m?.type===1&&this.F(g))});return k?(y.add(k),!0):!1}D(g,y){let k=!1;const w=(m,v)=>{if(y.isDisposed)return;const p=this.G(m),$=this.G(v),f=k;k=p,!p&&($||f)&&this.F(g)};this.M(`starting fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,i.watchFile)(g.path,{persistent:!1,interval:this.n},w)}catch(m){this.N(`fs.watchFile() failed with error ${m} on path ${g.path} (correlationId: ${g.correlationId})`)}y.add((0,R.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,i.unwatchFile)(g.path,w)}catch(m){this.N(`fs.unwatchFile() failed with error ${m} on path ${g.path} (correlationId: ${g.correlationId})`)}}))}F(g){this.M(`detected ${g.path} exists again, resuming watcher (correlationId: ${g.correlationId})`);const y={resource:P.URI.file(g.path),type:1,cId:g.correlationId};this.a.fire([y]),this.H(y,g),this.y(g)}G(g){return g.ctimeMs===0&&g.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(g,y){const k=` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`;this.M(typeof y.correlationId=="number"?`${k} (correlationId: ${y.correlationId})`:k)}I(g){return`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`}}e.$Rq=h}),define(oe[218],ae([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,e.$Xq=p;class v extends P.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(f,l,d,a,t,o){super(),this.r=f,this.s=l,this.t=d,this.u=a,this.w=t,this.y=o,this.c=this.B(new R.$Ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.t(s))),this.f=this.B(new R.$Bh(s=>this.L(s),v.b)),this.g=(0,m.$Iq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,m.$Iq)(this.r.path,this.r.includes):void 0,this.j=new S.$je,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const f=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const l=await w.Promises.stat(f);if(this.j.token.isCancellationRequested)return;this.B(await this.F(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.N(f):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${f})`),this.C()}}C(){this.n=!0,this.u?.()}async D(f){let l=f.path;try{l=await w.Promises.realpath(f.path),f.path===l&&(l=await(0,k.$Tq)(f.path,this.j.token)??f.path),f.path!==l&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async F(f,l){const d=new P.$Tc;return this.G(f,l,d)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(f,l,d)),d}G(f,l,d){if(l)return!1;const a=y.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(o,s)=>{if(!d.isDisposed)if(o){const n=await this.F(f,l);d.isDisposed?n.dispose():d.add(n)}else s&&(typeof s.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:a,type:s.type,cId:this.r.correlationId}])});return t?(d.add(t),!0):!1}async H(f,l,d){if(u.$j&&(0,M.$ng)(f,"/Volumes/",!0)){this.N(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new S.$je(this.j.token);d.add((0,P.$Sc)(()=>a.dispose(!0)));const t=new P.$Tc;d.add(t);try{const o=y.URI.file(this.r.path),s=(0,h.$oc)(f),n=(0,i.watch)(f);t.add((0,P.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.P(`Started watching: '${f}'`);const r=new Set;if(l)try{for(const b of await w.Promises.readdir(f))r.add(b)}catch(b){this.N(b)}if(a.token.isCancellationRequested)return;const c=new Map;t.add((0,P.$Sc)(()=>{for(const[,b]of c)b.dispose();c.clear()})),n.on("error",(b,I)=>{a.token.isCancellationRequested||(this.N(`Failed to watch ${f} for changes using fs.watch() (${b}, ${I})`),this.C())}),n.on("change",(b,I)=>{if(a.token.isCancellationRequested)return;this.P(`[raw] ["${b}"] ${I}`);let D="";if(I&&(D=I.toString(),u.$j&&(D=(0,E.$5l)(D))),!(!D||b!=="change"&&b!=="rename"))if(l)if(b==="rename"){c.get(D)?.dispose();const j=setTimeout(async()=>{if(c.delete(D),D===s&&!await w.Promises.exists(f)){this.I(o);return}if(a.token.isCancellationRequested)return;const A=await this.M((0,h.$kc)(f,D));if(a.token.isCancellationRequested)return;let C;A?r.has(D)?C=0:(C=1,r.add(D)):(r.delete(D),C=2),this.J({resource:(0,g.$1g)(o,D),type:C,cId:this.r.correlationId})},v.a);c.set(D,(0,P.$Sc)(()=>clearTimeout(j)))}else{let j;r.has(D)?j=0:(j=1,r.add(D)),this.J({resource:(0,g.$1g)(o,D),type:j,cId:this.r.correlationId})}else if(b==="rename"||D!==s){const j=setTimeout(async()=>{const A=await w.Promises.exists(f);a.token.isCancellationRequested||(A?(this.J({resource:o,type:0,cId:this.r.correlationId},!0),t.add(await this.F(f,!1))):this.I(o))},v.a);t.clear(),t.add((0,P.$Sc)(()=>clearTimeout(j)))}else this.J({resource:o,type:0,cId:this.r.correlationId},!0)})}catch(o){a.token.isCancellationRequested||this.N(`Failed to watch ${f} for changes using fs.watch() (${o.toString()})`),this.C()}}I(f){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:f,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(f,l=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!l&&this.g.some(d=>d(f.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${f.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}L(f){const l=(0,m.$Gq)(f);if(l.length>0){if(this.y)for(const a of l)this.P(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(f){if(u.$k)return w.Promises.exists(f);try{const l=(0,h.$oc)(f);return(await w.Promises.readdir((0,h.$nc)(f))).some(a=>a===l)}catch(l){return this.P(l),!1}}setVerboseLogging(f){this.y=f}N(f){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}O(f){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}P(f){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Wq=v;async function p($,f,l,d,a=512){const t=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(a),s=new S.$je(d);let n,r=!1;const c={path:$,excludes:[],recursive:!1},b=new v(c,void 0,I=>{(async()=>{for(const{type:D}of I)if(D===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:j}=await w.Promises.read(t,o,0,a,null);if(!j||s.token.isCancellationRequested)break;f(o.slice(0,j))}}catch(j){n=new Error(j),s.dispose(!0)}finally{r=!1}}})()});return await b.ready,l(),new Promise((I,D)=>{s.token.onCancellationRequested(async()=>{b.dispose();try{await w.Promises.close(t)}catch(j){n=new Error(j)}n?D(n):I()})})}}),define(oe[219],ae([0,1,3,108,217,4,218,31]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class h extends S.$Rq{constructor(g){super(),this.L=g,this.onDidError=i.Event.None,this.watchers=new Set,this.O=!1}async J(g){g=this.W(g);const y=[],k=new Set(Array.from(this.watchers));for(const w of g){const m=this.R(w);m&&(0,R.$lk)(m.request.excludes,w.excludes)&&(0,R.$lk)(m.request.includes,w.includes)?k.delete(m):y.push(w)}y.length&&this.M(`Request to start watching: ${y.map(w=>this.I(w)).join(",")}`),k.size&&this.M(`Request to stop watching: ${Array.from(k).map(w=>this.I(w.request)).join(",")}`);for(const w of k)this.U(w);for(const w of y)this.S(w)}R(g){for(const y of this.watchers)if(typeof g.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===g.correlationId)return y}else if((0,E.$mg)(y.request.path,g.path,!M.$k))return y}S(g){const y=new P.$Wq(g,this.L,w=>this.a.fire(w),()=>this.c.fire(g),w=>this.b.fire(w),this.O),k={request:g,instance:y};this.watchers.add(k)}async stop(){await super.stop();for(const g of this.watchers)this.U(g)}U(g){this.M("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}W(g){const y=new Map;for(const k of g){const w=M.$k?k.path:k.path.toLowerCase();let m=y.get(k.correlationId);m||(m=new Map,y.set(k.correlationId,m)),m.has(w)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(k)}`),m.set(w,k)}return Array.from(y.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(g){this.O=g;for(const y of this.watchers)y.instance.setVerboseLogging(g)}M(g,y){this.O&&this.b.fire({type:"trace",message:this.Z(g,y)})}N(g){this.b.fire({type:"warn",message:this.Z(g)})}Z(g,y){return y?`[File Watcher (node.js)] ${g} (${this.I(y.request)})`:`[File Watcher (node.js)] ${g}`}}e.$Yq=h}),define(oe[220],ae([0,1,60,219]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class S extends i.$Dq{constructor(P,E,h){super(P,E,h),this.s()}r(P){return P.add(new R.$Yq(void 0))}}e.$Zq=S}),define(oe[221],ae([0,1,13,44,162,60]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class P extends M.$Eq{constructor(h,u,g){super(h,u,g),this.s()}r(h){const u=h.add(new S.$Pq(i.$Hg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(u.onDidProcessExit(({code:g,signal:y})=>this.t(`terminated by itself with code ${g}, signal: ${y}`))),R.ProxyChannel.toService((0,R.$7h)(u.getChannel("watcher")))}}e.$Qq=P}),define(oe[93],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class i{constructor(...S){this.a=new Map;for(const[M,P]of S)this.set(M,P)}set(S,M){const P=this.a.get(S);return this.a.set(S,M),P}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$li=i}),define(oe[222],ae([0,1,8,15,2,78,211,6,93,104]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const g=!1;class y extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class k{constructor(p=new h.$li,$=!1,f,l=g){this.i=p,this.j=$,this.k=f,this.l=l,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$mi,this),this._globalGraph=l?f?._globalGraph??new P.$3q(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Pc)(this.h),this.h.clear();for(const p of this.g)(0,S.$Oc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p){this.m();const $=new class extends k{dispose(){this.h.delete($),super.dispose()}}(p,this.j,this,this.l);return this.h.add($),$}invokeFunction(p,...$){this.m();const f=m.traceInvocation(this.l,p);let l=!1;try{return p({get:a=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...$)}finally{l=!0,f.stop()}}createInstance(p,...$){this.m();let f,l;return p instanceof M.$ki?(f=m.traceCreation(this.l,p.ctor),l=this.o(p.ctor,p.staticArguments.concat($),f)):(f=m.traceCreation(this.l,p),l=this.o(p,$,f)),f.stop(),l}o(p,$=[],f){const l=E._util.getServiceDependencies(p).sort((t,o)=>t.index-o.index),d=[];for(const t of l){const o=this.s(t.id,f);o||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(o)}const a=l.length>0?l[0].index:$.length;if($.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${$.length} static arguments`);const t=a-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,a)}return Reflect.construct(p,$.concat(d))}q(p,$){if(this.i.get(p)instanceof M.$ki)this.i.set(p,$);else if(this.k)this.k.q(p,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const $=this.i.get(p);return!$&&this.k?this.k.r(p):$}s(p,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.r(p);return f instanceof M.$ki?this.u(p,f,$.branch(p,!0)):($.branch(p,!1),f)}u(p,$,f){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,$,f)}finally{this.t.delete(p)}}v(p,$,f){const l=new P.$3q(t=>t.id.toString());let d=0;const a=[{id:p,desc:$,_trace:f}];for(;a.length;){const t=a.pop();if(l.lookupOrInsertNode(t),d++>1e3)throw new y(l);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof M.$ki){const n={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};l.insertEdge(t,n),a.push(n)}}}for(;;){const t=l.roots();if(t.length===0){if(!l.isEmpty())throw new y(l);break}for(const{data:o}of t){if(this.r(o.id)instanceof M.$ki){const n=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,n)}l.removeNode(o)}}return this.r(p)}w(p,$,f=[],l,d){if(this.i.get(p)instanceof M.$ki)return this.x(p,$,f,l,d,this.g);if(this.k)return this.k.w(p,$,f,l,d);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(p,$,f=[],l,d,a){if(l){const t=new k(void 0,this.j,this,this.l);t.c=String(p);const o=new Map,s=new i.$Gh(()=>{const n=t.o($,f,d);for(const[r,c]of o){const b=n[r];if(typeof b=="function")for(const I of c)I.disposable=b.apply(n,I.listener)}return o.clear(),a.add(n),n});return new Proxy(Object.create(null),{get(n,r){if(!s.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let I=o.get(r);return I||(I=new u.$5c,o.set(r,I)),(j,A,C)=>{if(s.isInitialized)return s.value[r](j,A,C);{const W={listener:[j,A,C],disposable:void 0},T=I.push(W);return(0,S.$Sc)(()=>{T(),W.disposable?.dispose()})}}}if(r in n)return n[r];const c=s.value;let b=c[r];return typeof b!="function"||(b=b.bind(c),n[r]=b),b},set(n,r,c){return s.value[r]=c,!0},getPrototypeOf(n){return $.prototype}})}else{const t=this.o($,f,d);return a.add(t),t}}y(p,$){if($&&console.warn(p),this.j)throw new Error(p)}}e.$4q=k;var w;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(w||(w={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,$){return p?new m(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,$){return p?new m(1,$.name):m.c}static{this.f=0}constructor(p,$){this.type=p,this.name=$,this.g=Date.now(),this.h=[]}branch(p,$){const f=new m(3,p.toString());return this.h.push([p,$,f]),f}stop(){const p=Date.now()-this.g;m.f+=p;let $=!1;function f(d,a){const t=[],o=new Array(d+1).join("	");for(const[s,n,r]of a.h)if(n&&r){$=!0,t.push(`${o}CREATES -> ${s}`);const c=f(d+1,r);c&&t.push(c)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||$)&&m.all.add(l.join(`
`))}}e.$5q=m}),define(oe[223],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UIb=e.IssueSource=e.IssueType=void 0;var R;(function(M){M[M.Bug=0]="Bug",M[M.PerformanceIssue=1]="PerformanceIssue",M[M.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={}));var S;(function(M){M.VSCode="vscode",M.Extension="extension",M.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$UIb=(0,i.$ni)("issueService")}),define(oe[5],ae([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=v,e.log=$,e.$8j=b,e.$9j=I,e.$0j=D,e.$$j=j,e.$Tj=(0,w.$ni)("logService"),e.$Uj=(0,w.$ni)("loggerService");function m(){return new Date().toISOString()}function v(A){return(0,g.$5f)(A)}var p;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Wj=p.Info;function $(A,C,W){switch(C){case p.Trace:A.trace(W);break;case p.Debug:A.debug(W);break;case p.Info:A.info(W);break;case p.Warning:A.warn(W);break;case p.Error:A.error(W);break;case p.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function f(A,C=!1){let W="";for(let T=0;T<A.length;T++){let N=A[T];if(N instanceof Error&&(N=(0,R.$$i)(N,C)),typeof N=="object")try{N=JSON.stringify(N)}catch{}W+=(T>0?" ":"")+N}return W}class l extends P.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new S.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==p.Off&&this.b<=C}}e.$Yj=l;class d extends l{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...W){this.f(p.Trace)&&this.g(p.Trace,f([C,...W],!0))}debug(C,...W){this.f(p.Debug)&&this.g(p.Debug,f([C,...W]))}info(C,...W){this.f(p.Info)&&this.g(p.Info,f([C,...W]))}warn(C,...W){this.f(p.Warning)&&this.g(p.Warning,f([C,...W]))}error(C,...W){if(this.f(p.Error))if(C instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=C.stack,this.g(p.Error,f(T))}else this.g(p.Error,f([C,...W]))}flush(){}}e.$Zj=d;class a extends l{constructor(C=e.$Wj){super(),this.setLevel(C),this.g=!h.$i}trace(C,...W){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...W):console.log(`[main ${m()}]`,C,...W))}debug(C,...W){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...W):console.log(`[main ${m()}]`,C,...W))}info(C,...W){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...W):console.log(`[main ${m()}]`,C,...W))}warn(C,...W){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,C,...W):console.warn(`[main ${m()}]`,C,...W))}error(C,...W){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,C,...W):console.error(`[main ${m()}]`,C,...W))}flush(){}}e.$1j=a;class t extends l{constructor(C=e.$Wj,W=!0){super(),this.g=W,this.setLevel(C)}trace(C,...W){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...W):console.log(C,...W))}debug(C,...W){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...W):console.log(C,...W))}info(C,...W){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...W):console.log(C,...W))}warn(C,...W){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...W):console.log(C,...W))}error(C,...W){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...W):console.error(C,...W))}flush(){}}e.$2j=t;class o extends l{constructor(C,W=e.$Wj){super(),this.g=C,this.setLevel(W)}trace(C,...W){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(C),...W])}debug(C,...W){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(C),...W])}info(C,...W){this.f(p.Info)&&this.g.log(p.Info,[this.h(C),...W])}warn(C,...W){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(C),...W])}error(C,...W){this.f(p.Error)&&this.g.log(p.Error,[this.h(C),...W])}h(C){return typeof C=="string"?C:(0,R.$$i)(C,this.f(p.Trace))}flush(){}}e.$3j=o;class s extends l{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const W of this.g)W.setLevel(C);super.setLevel(C)}trace(C,...W){for(const T of this.g)T.trace(C,...W)}debug(C,...W){for(const T of this.g)T.debug(C,...W)}info(C,...W){for(const T of this.g)T.info(C,...W)}warn(C,...W){for(const T of this.g)T.warn(C,...W)}error(C,...W){for(const T of this.g)T.error(C,...W)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$4j=s;class n extends P.$Uc{constructor(C,W,T){if(super(),this.h=C,this.j=W,this.b=new E.$Bc,this.c=this.B(new S.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$_d),this.onDidChangeVisibility=this.g.event,T)for(const N of T)this.b.set(N.resource,{logger:void 0,info:N})}m(C){return(0,g.$1f)(C)?[...this.b.values()].find(W=>W.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,W){const T=this.n(C),N=(0,g.$1f)(C)?C:W?.id??(0,M.$bj)(T.toString()).toString(16);let U=this.b.get(T)?.logger;const ue=W?.logLevel==="always"?p.Trace:W?.logLevel;U||(U=this.s(T,ue??this.getLogLevel(T)??this.h,{...W,id:N}));const ie={logger:U,info:{resource:T,id:N,logLevel:ue,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(ie.info),this.b.set(T,ie),U}n(C){return(0,g.$1f)(C)?(0,u.$1g)(this.j,`${C}.log`):C}setLogLevel(C,W){if(y.URI.isUri(C)){const T=C,N=W,U=this.b.get(T);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.h?void 0:N,U.logger?.setLevel(N),this.b.set(U.info.resource,U),this.f.fire([T,N]))}else{this.h=C;for(const[T,N]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,W){const T=this.m(C);T&&W!==!T.info.hidden&&(T.info.hidden=!W,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,W]))}getLogLevel(C){let W;return C&&(W=this.b.get(C)?.info.logLevel),W??this.h}registerLogger(C){const W=this.b.get(C.resource);W?W.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const W=this.b.get(C);W&&(W.logger&&W.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=n;class r{constructor(){this.onDidChangeLogLevel=new S.$_d().event}setLevel(C){}getLevel(){return p.Info}trace(C,...W){}debug(C,...W){}info(C,...W){}warn(C,...W){}error(C,...W){}critical(C,...W){}dispose(){}flush(){}}e.$6j=r;class c extends r{}e.$7j=c;function b(A){if(A.verbose)return p.Trace;if(typeof A.logLevel=="string"){const C=j(A.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Wj}function I(A){switch(A){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function D(A){switch(A){case p.Trace:return{original:"Trace",value:i.localize(0,null)};case p.Debug:return{original:"Debug",value:i.localize(1,null)};case p.Info:return{original:"Info",value:i.localize(2,null)};case p.Warning:return{original:"Warning",value:i.localize(3,null)};case p.Error:return{original:"Error",value:i.localize(4,null)};case p.Off:return{original:"Off",value:i.localize(5,null)}}}function j(A){switch(A){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$_j=new k.$Ej("logLevel",I(p.Info))});var ne=this&&this.__param||function(Q,e){return function(i,R){e(i,R,Q)}};define(oe[224],ae([0,1,14,4,5]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0;const M=i.safeStorage;let P=class{constructor(h){this.a=h,i.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(M.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(h){let u;try{if(u=JSON.parse(h),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const g=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=M.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const h=M.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$bbc=P,e.$bbc=P=Ee([ne(0,S.$Tj)],P)}),define(oe[225],ae([0,1,22,8,15,3,2,9,60,5]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class g extends P.$Uc{constructor(k,w){super(),this.a=k,this.b=w,this.c=this.B(new M.$_d),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$_d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$lh(0)),this.w=[],this.y=this.B(new R.$lh(0))}watch(k,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(k,w):this.z(k,w)}n(k,w){const m={path:this.I(k),excludes:w.excludes,includes:w.includes,recursive:w.recursive,correlationId:w.correlationId},v=(0,i.$Ub)(this.j,m);return this.r(),(0,P.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,S.$1)(k))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,h.$Fq)(w)),w=>this.G(w),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const w of this.j)(0,h.$Bq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const w of this.j)(0,h.$Bq)(w)&&k.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,w){const m={path:this.I(k),excludes:w.excludes,includes:w.includes,recursive:!1,correlationId:w.correlationId},v=(0,i.$Ub)(this.w,m);return this.C(),(0,P.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,S.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,h.$Fq)(k)),k=>this.G(k),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,E.$ic)(k.fsPath)}}e.$Jq=g}),define(oe[226],ae([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let a=class extends u.$Uc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new P.$_d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new P.$_d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new P.$_d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new P.$_d),this.onDidRunOperation=this.r.event,this.X=this.B(new P.$_d),this.Y=this.B(new P.$_d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new P.$_d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$wh)}registerProvider(o,s){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const n=new u.$Tc;return this.h.set(o,s),this.c.fire({added:!0,scheme:o,provider:s}),n.add(s.onDidChangeFile(r=>{const c=new p.$al(r,!this.S(s));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof s.onDidWatchError=="function"&&n.add(s.onDidWatchError(r=>this.Z.fire(new Error(r)))),n.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:o}))),(0,u.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:s}),this.h.delete(o),(0,u.$Pc)(n)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const s=[];this.f.fire({scheme:o,join(n){s.push(n)}}),!this.h.has(o)&&await R.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,s){const n=this.h.get(o.scheme);return!!(n&&n.capabilities&s)}listCapabilities(){return h.Iterable.map(this.h,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async j(o){if(!(0,w.$5g)(o))throw new p.$cl((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const s=this.h.get(o.scheme);if(!s){const n=new l.$bb;throw n.message=(0,v.localize)(1,null,o.toString()),n}return s}async m(o){const s=await this.j(o);if((0,p.$Zk)(s)||(0,p.$Wk)(s)||(0,p.$1k)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const s=await this.j(o);if((0,p.$Zk)(s)||(0,p.$Wk)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.s(o,s)}catch(n){throw(0,p.$0k)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.$cl((0,v.localize)(2,null,this.sb(o)),1):(0,p.$8k)(n)}}async s(o,s){const n=await this.j(o),r=this.S(n),c=s?.resolveTo,b=s?.resolveSingleChildDescendants,I=s?.resolveMetadata,D=await n.stat(o);let j;return this.t(n,o,D,void 0,!!I,(A,C)=>(j||(j=g.$ti.forUris(()=>!r),j.set(o,!0),c&&j.fill(!0,c)),j.get(A.resource)||j.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&b?C===1:!1))}async t(o,s,n,r,c,b){const{providerExtUri:I}=this.R(o),D={resource:s,name:I.basename(s),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((n.permissions??0)&p.FilePermission.Locked),etag:(0,p.$nl)({mtime:n.mtime,size:n.size}),children:void 0};if(D.isDirectory&&b(D,r)){try{const j=await o.readdir(s),A=await R.Promises.settled(j.map(async([C,W])=>{try{const T=I.joinPath(s,C),N=c?await o.stat(T):{type:W};return await this.t(o,T,N,j.length,c,b)}catch(T){return this.b.trace(T),null}}));D.children=(0,i.$Hb)(A)}catch(j){this.b.trace(j),D.children=[]}return D}return D}async resolveAll(o){return R.Promises.settled(o.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.j(o),n=await s.stat(o);return this.t(s,o,n,void 0,!0,()=>!1)}async exists(o){const s=await this.j(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.u(o,s)}catch(n){return n}return!0}async u(o,s){if(!s?.overwrite&&await this.exists(o))throw new p.$cl((0,v.localize)(3,null,this.sb(o)),3,s)}async createFile(o,s=S.$ze.fromString(""),n){await this.u(o,n);const r=await this.writeFile(o,s);return this.r.fire(new p.$_k(o,0,r)),r}async writeFile(o,s,n){const r=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(r);let b=n;if((0,p.$3k)(r)&&!b?.atomic){const I=r.enforceAtomicWriteFile?.(o);I&&(b={...n,atomic:I})}try{await this.w(r,o,b)||await this.U(r,c.dirname(o));let D;if((0,p.$Wk)(r)&&!(s instanceof S.$ze))if((0,m.$le)(s)){const j=await(0,m.$se)(s,3);j.ended?D=S.$ze.concat(j.buffer):D=j}else D=(0,m.$pe)(s,j=>S.$ze.concat(j),3);else D=s;!(0,p.$Zk)(r)||(0,p.$Wk)(r)&&D instanceof S.$ze||(0,p.$Wk)(r)&&(0,p.$3k)(r)&&b?.atomic?await this.hb(r,o,b,D):await this.db(r,o,b,D instanceof S.$ze?(0,S.$Ke)(D):D),this.r.fire(new p.$_k(o,4))}catch(I){throw new p.$cl((0,v.localize)(4,null,this.sb(o),(0,p.$8k)(I).toString()),(0,p.$$k)(I),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,s,n){const r=!!n?.unlock;if(r&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(s)));if(!!n?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(s)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(s)));if(r)throw new Error((0,v.localize)(8,null,this.sb(s)))}let b;try{b=await o.stat(s)}catch{return}if(b.type&p.FileType.Directory)throw new p.$cl((0,v.localize)(9,null,this.sb(s)),0,n);if(this.rb(s,b),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.$ml&&typeof b.mtime=="number"&&typeof b.size=="number"&&n.mtime<b.mtime&&n.etag!==(0,p.$nl)({mtime:n.mtime,size:b.size}))throw new p.$cl((0,v.localize)(10,null),3,n);return b}async readFile(o,s,n){const r=await this.m(o);return s?.atomic?this.z(r,o,s,n):this.C(r,o,s,n)}async z(o,s,n,r){return new Promise((c,b)=>{this.cb.queueFor(s,async()=>{try{const I=await this.C(o,s,n,r);c(I)}catch(I){b(I)}},this.R(o).providerExtUri)})}async C(o,s,n,r){const c=await this.D(o,s,{...n,preferUnbuffered:!0},r);return{...c,value:await(0,S.$Le)(c.value)}}async readFileStream(o,s,n){const r=await this.m(o);return this.D(r,o,s,n)}async D(o,s,n,r){const c=new M.$je(r);let b=n;(0,p.$2k)(o)&&o.enforceAtomicReadFile?.(s)&&(b={...n,atomic:!0});const I=this.J(s,b).then(j=>j,j=>{throw c.dispose(!0),j});let D;try{return typeof b?.etag=="string"&&b.etag!==p.$ml&&await I,b?.atomic&&(0,p.$2k)(o)||!((0,p.$Zk)(o)||(0,p.$1k)(o))||(0,p.$Wk)(o)&&b?.preferUnbuffered?D=this.I(o,s,b):(0,p.$1k)(o)?D=this.G(o,s,c.token,b):D=this.H(o,s,c.token,b),D.on("end",()=>c.dispose()),D.on("error",()=>c.dispose()),{...await I,value:D}}catch(j){throw D&&await(0,m.$qe)(D),this.F(j,s,b)}}F(o,s,n){const r=(0,v.localize)(11,null,this.sb(s),(0,p.$8k)(o).toString());return o instanceof p.$el?new p.$el(r,o.stat,n):o instanceof p.$dl?new p.$dl(r,o.fileOperationResult,o.size,o.options):new p.$cl(r,(0,p.$$k)(o),n)}G(o,s,n,r=Object.create(null)){const c=o.readFileStream(s,r,n);return(0,m.$we)(c,{data:b=>b instanceof S.$ze?b:S.$ze.wrap(b),error:b=>this.F(b,s,r)},b=>S.$ze.concat(b))}H(o,s,n,r=Object.create(null)){const c=(0,S.$Pe)();return(0,$.$yq)(o,s,c,b=>b,{...r,bufferSize:this.a,errorTransformer:b=>this.F(b,s,r)},n),c}I(o,s,n){const r=(0,m.$ne)(c=>S.$ze.concat(c));return(async()=>{try{let c;n?.atomic&&(0,p.$2k)(o)?c=await o.readFile(s,{atomic:!0}):c=await o.readFile(s),typeof n?.position=="number"&&(c=c.slice(n.position)),typeof n?.length=="number"&&(c=c.slice(0,n.length)),this.L(s,c.byteLength,n),r.end(S.$ze.wrap(c))}catch(c){r.error(c),r.end()}})(),r}async J(o,s){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new p.$cl((0,v.localize)(12,null,this.sb(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==p.$ml&&s.etag===n.etag)throw new p.$el((0,v.localize)(13,null),n,s);return this.L(o,n.size,s),n}L(o,s,n){if(typeof n?.limits?.size=="number"&&s>n.limits.size)throw new p.$dl((0,v.localize)(14,null,this.sb(o)),7,s,n)}async canMove(o,s,n){return this.M(o,s,"move",n)}async canCopy(o,s,n){return this.M(o,s,"copy",n)}async M(o,s,n,r){if(o.toString()!==s.toString())try{const c=n==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(s),s);await this.Q(c,o,b,s,n,r)}catch(c){return c}return!0}async move(o,s,n){const r=this.qb(await this.n(o),o),c=this.qb(await this.n(s),s),b=await this.N(r,o,c,s,"move",!!n),I=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$_k(o,b==="move"?2:3,I)),I}async copy(o,s,n){const r=await this.m(o),c=this.qb(await this.n(s),s),b=await this.N(r,o,c,s,"copy",!!n),I=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$_k(o,b==="copy"?3:2,I)),I}async N(o,s,n,r,c,b){if(s.toString()===r.toString())return c;const{exists:I,isSameResourceWithDifferentPathCase:D}=await this.Q(o,s,n,r,c,b);if(I&&!D&&b&&await this.del(r,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(r)),c==="copy"){if(o===n&&(0,p.$Xk)(o))await o.copy(s,r,{overwrite:b});else{const j=await this.resolve(s);j.isDirectory?await this.P(o,j,n,r):await this.O(o,s,n,r)}return c}else return o===n?(await o.rename(s,r,{overwrite:b}),c):(await this.N(o,s,n,r,"copy",b),await this.del(s,{recursive:!0}),"copy")}async O(o,s,n,r){if((0,p.$Zk)(o)&&(0,p.$Zk)(n))return this.jb(o,s,n,r);if((0,p.$Zk)(o)&&(0,p.$Wk)(n))return this.pb(o,s,n,r);if((0,p.$Wk)(o)&&(0,p.$Zk)(n))return this.nb(o,s,n,r);if((0,p.$Wk)(o)&&(0,p.$Wk)(n))return this.lb(o,s,n,r)}async P(o,s,n,r){await n.mkdir(r),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async c=>{const b=this.R(n).providerExtUri.joinPath(r,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),n,b):this.O(o,c.resource,n,b)}))}async Q(o,s,n,r,c,b){let I=!1;if(o===n){const{providerExtUri:j,isPathCaseSensitive:A}=this.R(o);if(A||(I=j.isEqual(s,r)),I&&c==="copy")throw new Error((0,v.localize)(15,null,this.sb(s),this.sb(r)));if(!I&&j.isEqualOrParent(r,s))throw new Error((0,v.localize)(16,null,this.sb(s),this.sb(r)))}const D=await this.exists(r);if(D&&!I){if(!b)throw new p.$cl((0,v.localize)(17,null,this.sb(s),this.sb(r)),4);if(o===n){const{providerExtUri:j}=this.R(o);if(j.isEqualOrParent(s,r))throw new Error((0,v.localize)(18,null,this.sb(s),this.sb(r)))}}return{exists:D,isSameResourceWithDifferentPathCase:I}}R(o){const s=this.S(o);return{providerExtUri:s?w.$Qg:w.$Sg,isPathCaseSensitive:s}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.qb(await this.j(o),o);await this.U(s,o);const n=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$_k(o,0,n)),n}async U(o,s){const n=[],{providerExtUri:r}=this.R(o);for(;!r.isEqual(s,r.dirname(s));)try{if(!((await o.stat(s)).type&p.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(s)));break}catch(c){if((0,p.$0k)(c)!==p.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(r.basename(s)),s=r.dirname(s)}for(let c=n.length-1;c>=0;c--){s=r.joinPath(s,n[c]);try{await o.mkdir(s)}catch(b){if((0,p.$0k)(b)!==p.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,s){try{await this.W(o,s)}catch(n){return n}return!0}async W(o,s){const n=this.qb(await this.j(o),o),r=!!s?.useTrash;if(r&&!(n.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const c=s?.atomic;if(c&&!(n.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(r&&c)throw new Error((0,v.localize)(22,null,this.sb(o)));let b;try{b=await n.stat(o)}catch{}if(b)this.rb(o,b);else throw new p.$cl((0,v.localize)(23,null,this.sb(o)),1);if(!!!s?.recursive){const D=await this.resolve(o);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return n}async del(o,s){const n=await this.W(o,s);let r=s;if((0,p.$4k)(n)&&!r?.atomic){const D=n.enforceAtomicDelete?.(o);D&&(r={...s,atomic:D})}const c=!!r?.useTrash,b=!!r?.recursive,I=r?.atomic??!1;await n.delete(o,{recursive:b,useTrash:c,atomic:I}),this.r.fire(new p.$_k(o,1))}async cloneFile(o,s){const n=await this.j(o),r=this.qb(await this.n(s),s);if(!(n===r&&this.R(n).providerExtUri.isEqual(o,s)))return n===r&&(0,p.$Yk)(n)?n.cloneFile(o,s):(await this.U(r,this.R(r).providerExtUri.dirname(s)),n===r&&(0,p.$Xk)(n)?this.cb.queueFor(o,()=>n.copy(o,s,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(o,()=>this.O(n,o,r,s),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:d.ab++})}watch(o,s={recursive:!1,excludes:[]}){const n=new u.$Tc;let r=!1,c=()=>{r=!0};n.add((0,u.$Sc)(()=>c())),(async()=>{try{const I=await this.bb(o,s);r?(0,u.$Pc)(I):c=()=>(0,u.$Pc)(I)}catch(I){this.b.error(I)}})();const b=s.correlationId;if(typeof b=="number"){const I=n.add(new P.$_d);return n.add(this.X.event(j=>{j.correlates(b)&&I.fire(j)})),{onDidChange:I.event,dispose:()=>n.dispose()}}return n}async bb(o,s){const n=await this.j(o),r=(0,E.$bj)([this.R(n).providerExtUri.getComparisonKey(o),s]);let c=this.$.get(r);return c||(c={count:0,disposable:n.watch(o,s)},this.$.set(r,c)),c.count+=1,(0,u.$Sc)(()=>{c&&(c.count--,c.count===0&&((0,u.$Pc)(c.disposable),this.$.delete(r)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,u.$Pc)(o.disposable);this.$.clear()}async db(o,s,n,r){return this.cb.queueFor(s,async()=>{const c=await o.open(s,{create:!0,unlock:n?.unlock??!1});try{(0,m.$le)(r)||(0,m.$me)(r)?await this.eb(o,c,r):await this.fb(o,c,r)}catch(b){throw(0,p.$8k)(b)}finally{await o.close(c)}},this.R(o).providerExtUri)}async eb(o,s,n){let r=0,c;if((0,m.$me)(n)){if(n.buffer.length>0){const b=S.$ze.concat(n.buffer);await this.gb(o,s,b,b.byteLength,r,0),r+=b.byteLength}if(n.ended)return;c=n.stream}else c=n;return new Promise((b,I)=>{(0,m.$re)(c,{onData:async D=>{c.pause();try{await this.gb(o,s,D,D.byteLength,r,0)}catch(j){return I(j)}r+=D.byteLength,setTimeout(()=>c.resume())},onError:D=>I(D),onEnd:()=>b()})})}async fb(o,s,n){let r=0,c;for(;(c=n.read())!==null;)await this.gb(o,s,c,c.byteLength,r,0),r+=c.byteLength}async gb(o,s,n,r,c,b){let I=0;for(;I<r;){const D=await o.write(s,c+I,n.buffer,b+I,r-I);I+=D}}async hb(o,s,n,r){return this.cb.queueFor(s,()=>this.ib(o,s,n,r),this.R(o).providerExtUri)}async ib(o,s,n,r){let c;r instanceof S.$ze?c=r:(0,m.$le)(r)?c=await(0,S.$Le)(r):(0,m.$me)(r)?c=await(0,S.$Me)(r):c=(0,S.$Je)(r),await o.writeFile(s,c.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(o,s,n,r){return this.cb.queueFor(r,()=>this.kb(o,s,n,r),this.R(n).providerExtUri)}async kb(o,s,n,r){let c,b;try{c=await o.open(s,{create:!1}),b=await n.open(r,{create:!0,unlock:!1});const I=S.$ze.alloc(this.a);let D=0,j=0,A=0;do A=await o.read(c,D,I.buffer,j,I.byteLength-j),await this.gb(n,b,I,A,D,j),D+=A,j+=A,j===I.byteLength&&(j=0);while(A>0)}catch(I){throw(0,p.$8k)(I)}finally{await R.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof b=="number"?n.close(b):Promise.resolve()])}}async lb(o,s,n,r){return this.cb.queueFor(r,()=>this.mb(o,s,n,r),this.R(n).providerExtUri)}async mb(o,s,n,r){return n.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,s,n,r){return this.cb.queueFor(r,()=>this.ob(o,s,n,r),this.R(n).providerExtUri)}async ob(o,s,n,r){const c=await n.open(r,{create:!0,unlock:!1});try{const b=await o.readFile(s);await this.gb(n,c,S.$ze.wrap(b),b.byteLength,0,0)}catch(b){throw(0,p.$8k)(b)}finally{await n.close(c)}}async pb(o,s,n,r){const c=await(0,S.$Le)(this.H(o,s,M.CancellationToken.None));await this.hb(n,r,void 0,c)}qb(o,s){if(o.capabilities&2048)throw new p.$cl((0,v.localize)(25,null,this.sb(s)),6);return o}rb(o,s){if((s.permissions??0)&p.FilePermission.Readonly)throw new p.$cl((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$zq=a,e.$zq=a=d=Ee([ne(0,f.$Tj)],a)}),define(oe[94],ae([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,(()=>{try{(0,R.gracefulify)(i)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$$i)(o)}`)}})();class t extends f.$Jq{static{this.J=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=E.Event.None,this.O=new M.$Bc(r=>k.$Rg.getComparisonKey(r)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,y.$k&&(this.L|=1024)),this.L}async stat(s){try{const{stat:n,symbolicLink:r}=await m.SymlinkSupport.stat(this.I(s));return{type:this.N(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.gb(n)}}async M(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await m.Promises.readdir(this.I(s),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async c=>{try{let b;c.isSymbolicLink()?b=(await this.stat((0,k.$1g)(s,c.name))).type:b=this.N(c),r.push([c.name,b])}catch(b){this.a.trace(b)}})),r}catch(n){throw this.gb(n)}}N(s,n){let r;return n?.dangling?r=p.FileType.Unknown:s.isFile()?r=p.FileType.File:s.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,n&&(r|=p.FileType.SymbolicLink),r}async P(s){const n=this.I(s);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.O.get(s);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const c=new S.$mh;return this.O.set(s,c),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.O.get(s)===c&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.O.delete(s)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(s,n){let r;try{n?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),r=await this.P(s));const c=this.I(s);return await m.Promises.readFile(c)}catch(c){throw this.gb(c)}finally{r?.dispose()}}Q(s){t.J&&this.a.trace(s)}readFileStream(s,n,r){const c=(0,w.$ne)(b=>P.$ze.concat(b.map(I=>P.$ze.wrap(I))).buffer);return(0,$.$yq)(this,s,c,b=>b.buffer,{...n,bufferSize:256*1024},r),c}async writeFile(s,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.R(s)?this.S(s,(0,k.$1g)((0,k.$Zg)(s),`${(0,k.$Xg)(s)}${r.atomic.postfix}`),n,r):this.U(s,n,r)}async R(s){try{const n=this.I(s),{symbolicLink:r}=await m.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async S(s,n,r,c){const b=new u.$Tc;try{b.add(await this.P(s)),b.add(await this.P(n)),await this.U(n,r,c,!0);try{await this.rename(n,s,{overwrite:!0})}catch(I){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{b.dispose()}}async U(s,n,r,c){let b;try{const I=this.I(s);if(!r.create||!r.overwrite){if(await m.Promises.exists(I)){if(!r.overwrite)throw(0,p.$7k)((0,v.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.$7k)((0,v.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(s,{create:!0,unlock:r.unlock},c),await this.write(b,0,n,0,n.byteLength)}catch(I){throw await this.hb(s,I)}finally{typeof b=="number"&&await this.close(b)}}static{this.Z=!0}static configureFlushOnWrite(s){t.Z=s}async open(s,n,r){const c=this.I(s);let b;(0,p.$Uk)(n)&&!r&&(b=await this.P(s));let I;try{if((0,p.$Uk)(n)&&n.unlock)try{const{stat:j}=await m.SymlinkSupport.stat(c);j.mode&128||await m.Promises.chmod(c,j.mode|128)}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}let D;if((0,p.$Uk)(n)){if(y.$i)try{await m.Promises.truncate(c,0),D="r+"}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}D||(D="w")}else D="r";I=await m.Promises.open(c,D)}catch(D){throw b?.dispose(),(0,p.$Uk)(n)?await this.hb(s,D):this.gb(D)}if(this.W.set(I,0),(0,p.$Uk)(n)&&this.Y.set(I,s),b){const D=this.X.get(I);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${c})`),this.X.set(I,b),D&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${c})`),D.dispose())}return I}async close(s){const n=this.X.get(s);try{if(this.W.delete(s),this.Y.delete(s)&&t.Z)try{await m.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await m.Promises.close(s)}catch(r){throw this.gb(r)}finally{n&&(this.X.get(s)===n&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.X.delete(s)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,r,c,b){const I=this.$(s,n);let D=null;try{D=(await m.Promises.read(s,r,c,b,I)).bytesRead}catch(j){throw this.gb(j)}finally{this.ab(s,I,D)}return D}$(s,n){return n===this.W.get(s)?null:n}ab(s,n,r){const c=this.W.get(s);typeof c=="number"&&(typeof n=="number"||(typeof r=="number"?this.W.set(s,c+r):this.W.delete(s)))}async write(s,n,r,c,b){return(0,S.$Hh)(()=>this.bb(s,n,r,c,b),100,3)}async bb(s,n,r,c,b){const I=this.$(s,n);let D=null;try{D=(await m.Promises.write(s,r,c,b,I)).bytesWritten}catch(j){throw await this.hb(this.Y.get(s),j)}finally{this.ab(s,I,D)}return D}async mkdir(s){try{await m.Promises.mkdir(this.I(s))}catch(n){throw this.gb(n)}}async delete(s,n){try{const r=this.I(s);if(n.recursive){let c;n?.atomic!==!1&&n.atomic.postfix&&(c=(0,g.$kc)((0,g.$nc)(r),`${(0,g.$oc)(r)}${n.atomic.postfix}`)),await m.Promises.rm(r,m.RimRafMode.MOVE,c)}else try{await m.Promises.unlink(r)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let b=!1;try{const{stat:I,symbolicLink:D}=await m.SymlinkSupport.stat(r);b=I.isDirectory()&&!D}catch{}if(b)await m.Promises.rmdir(r);else throw c}else throw c}}catch(r){throw this.gb(r)}}async rename(s,n,r){const c=this.I(s),b=this.I(n);if(c!==b)try{await this.cb(s,n,"move",r.overwrite),await m.Promises.rename(c,b)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(2,null,(0,g.$oc)(c),(0,g.$oc)((0,g.$nc)(b)),I.toString()))),this.gb(I)}}async copy(s,n,r){const c=this.I(s),b=this.I(n);if(c!==b)try{await this.cb(s,n,"copy",r.overwrite),await m.Promises.copy(c,b,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(3,null,(0,g.$oc)(c),(0,g.$oc)((0,g.$nc)(b)),I.toString()))),this.gb(I)}}async cb(s,n,r,c){const b=this.I(s),I=this.I(n);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$mg)(b,I,!0)),D){if(r==="copy")throw(0,p.$7k)((0,v.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const A=await this.M(s);if(!A)throw(0,p.$7k)((0,v.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const C=await this.M(n);if(C){if(!c)throw(0,p.$7k)((0,v.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);A.type&p.FileType.File&&C.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.db(s,n,!1)}async db(s,n,r){const c=this.I(s),b=this.I(n),I=!!(this.capabilities&1024);if((0,h.$mg)(c,b,!I))return;const D=new u.$Tc;try{D.add(await this.P(s)),D.add(await this.P(n)),r&&await m.Promises.mkdir((0,g.$nc)(b),{recursive:!0}),await m.Promises.copyFile(c,b)}catch(j){if(j.code==="ENOENT"&&!r)return this.db(s,n,!0);throw this.gb(j)}finally{D.dispose()}}t(s,n,r){return new d.$Qq(c=>s(c),c=>n(c),r)}F(s,n,r){return new a.$Zq(c=>s(c),c=>n(c),r)}gb(s){if(s instanceof p.$6k)return s;let n=s,r;switch(s.code){case"ENOENT":r=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=p.FileSystemProviderErrorCode.Unknown;break;default:r=p.FileSystemProviderErrorCode.Unknown}return(0,p.$7k)(n,r)}async hb(s,n){let r=this.gb(n);if(s&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await m.SymlinkSupport.stat(this.I(s));c.mode&128||(r=(0,p.$7k)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return r}}e.$1q=t}),define(oe[227],ae([0,1,3,94,2,17,63,23]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=void 0;class h extends S.$Uc{constructor(y,k){super(),this.a=y,this.b=k,this.F=new Map,this.G=new Map}call(y,k,w){const m=this.c(y);switch(k){case"stat":return this.g(m,w[0]);case"readdir":return this.h(m,w[0]);case"open":return this.r(m,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(m,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(m,w[0],w[1],w[2]);case"rename":return this.z(m,w[0],w[1],w[2]);case"copy":return this.C(m,w[0],w[1],w[2]);case"cloneFile":return this.D(m,w[0],w[1]);case"mkdir":return this.w(m,w[0]);case"delete":return this.y(m,w[0],w[1]);case"watch":return this.I(m,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${k} not found`)}listen(y,k,w){const m=this.c(y);switch(k){case"fileChange":return this.H(m,w[0]);case"readFileStream":return this.m(m,w[0],w[1])}throw new Error(`Unknown event ${k}`)}g(y,k){const w=this.f(y,k,!0);return this.a.stat(w)}h(y,k){const w=this.f(y,k);return this.a.readdir(w)}async j(y,k,w){const m=this.f(y,k,!0),v=await this.a.readFile(m,w);return M.$ze.wrap(v)}m(y,k,w){const m=this.f(y,k,!0),v=new E.$je,p=new i.$_d({onDidRemoveLastListener:()=>{v.cancel()}}),$=this.a.readFileStream(m,w,v.token);return(0,P.$re)($,{onData:f=>p.fire(M.$ze.wrap(f)),onError:f=>p.fire(f),onEnd:()=>{p.fire("end"),p.dispose(),v.dispose()}}),p.event}n(y,k,w,m){const v=this.f(y,k);return this.a.writeFile(v,w.buffer,m)}r(y,k,w){const m=this.f(y,k,!0);return this.a.open(m,w)}s(y){return this.a.close(y)}async t(y,k,w){const m=M.$ze.alloc(w),p=await this.a.read(y,k,m.buffer,0,w);return[m,p]}u(y,k,w,m,v){return this.a.write(y,k,w.buffer,m,v)}w(y,k){const w=this.f(y,k);return this.a.mkdir(w)}y(y,k,w){const m=this.f(y,k);return this.a.delete(m,w)}z(y,k,w,m){const v=this.f(y,k),p=this.f(y,w);return this.a.rename(v,p,m)}C(y,k,w,m){const v=this.f(y,k),p=this.f(y,w);return this.a.copy(v,p,m)}D(y,k,w){const m=this.f(y,k),v=this.f(y,w);return this.a.cloneFile(m,v)}H(y,k){const w=new i.$_d({onWillAddFirstListener:()=>{this.F.set(k,this.L(y,w))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get(k)),this.F.delete(k)}});return w.event}async I(y,k,w,m,v){const p=this.F.get(k);if(p){const $=this.f(y,m),f=p.watch(w,$,v);this.G.set(k+w,f)}}async J(y,k){const w=y+k,m=this.G.get(w);m&&((0,S.$Pc)(m),this.G.delete(w))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$xs=h;class u extends S.$Uc{constructor(y,k,w,m){super(),this.c=y,this.f=w,this.g=m,this.a=new Map,this.b=this.B(new R.$1q(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(y){const k=this.B(new i.$_d);this.B(k.event(w=>{y.fire(w.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(w=>k.fire(w))),this.B(this.b.onDidWatchError(w=>y.fire(w)))}j(y){}m(y){}watch(y,k,w){const m=this.m(this.g);return Array.isArray(m)&&(w.excludes=[...w.excludes,...m]),this.a.set(y,this.b.watch(k,w)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$ys=u}),define(oe[228],ae([0,1,14,180,4,7,16,9,227,157,47]),function(Q,e,i,R,S,M,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class y extends h.$xs{constructor(m,v,p){super(m,v),this.M=p}c(m){return u.$qn}f(m,v){return M.URI.revive(v)}async y(m,v,p){if(!p.useTrash)return super.y(m,v,p);const $=this.f(m,v),f=(0,E.$ic)($.fsPath);try{await i.shell.trashItem(f)}catch(l){throw(0,P.$7k)(S.$i?(0,R.localize)(0,null,(0,E.$oc)(f),(0,g.$$i)(l)):(0,R.localize)(1,null,(0,E.$oc)(f),(0,g.$$i)(l)),P.FileSystemProviderErrorCode.Unknown)}}L(m,v){return new k(m,v,this.b,this.M)}}e.$jbc=y;class k extends h.$ys{watch(m,v,p){if(p.recursive)throw(0,P.$7k)("Recursive file watching is not supported from main process for performance reasons.",P.FileSystemProviderErrorCode.Unavailable);return super.watch(m,v,p)}}}),define(oe[229],ae([0,1,5]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=void 0;class R extends i.$Zj{constructor(M=i.$Wj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(P=>{this.n?.setLevel(P)}))}set logger(M){this.n=M;for(const{level:P,message:E}of this.m)(0,i.log)(M,P,E);this.m=[]}g(M,P){this.n?(0,i.log)(this.n,M,P):this.getLevel()<=M&&this.m.push({level:M,message:P})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$00b=R}),define(oe[230],ae([0,1,7,3,5,2]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=void 0;class P extends S.$5j{constructor(y,k,w,m,v){super(k,w,m),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(p=>{(0,S.$Vj)(p)?super.setLogLevel(p):super.setLogLevel(i.URI.revive(p[0]),p[1])})),this.B(v.listen("onDidChangeVisibility",y)(([p,$])=>super.setVisibility(i.URI.revive(p),$))),this.B(v.listen("onDidChangeLoggers",y)(({added:p,removed:$})=>{for(const f of p)super.registerLogger({...f,resource:i.URI.revive(f.resource)});for(const f of $)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new S.$3j({log:(y,k)=>{this.t.call("consoleLog",[y,k])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,k){super.setLogLevel(y,k),this.t.call("setLogLevel",[y,k])}setVisibility(y,k){super.setVisibility(y,k),this.t.call("setVisibility",[this.n(y),k])}s(y,k,w){return new E(this.t,y,k,w,this.r)}static setLogLevel(y,k,w){return y.call("setLogLevel",[k,w])}}e.$Zr=P;class E extends S.$Zj{constructor(y,k,w,m,v){super(m?.logLevel==="always"),this.r=y,this.s=k,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[k,m,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,k){const w=[[y,k]];this.m?this.u(w):this.n.push(...w)}u(y){this.r.call("log",[this.s,y])}}class h{constructor(y,k){this.a=y,this.b=k}listen(y,k){const w=this.b(y);switch(k){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(v=>this.c(v,w)),removed:[...m.removed].map(v=>this.c(v,w))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,m=>[w.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,m=>(0,S.$Vj)(m)?m:[w.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(y,k,w){const m=this.b(y);switch(k){case"setLogLevel":return(0,S.$Vj)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(i.URI.revive(m.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,m)))}throw new Error(`Call not found: ${k}`)}c(y,k){return{...y,resource:k.transformOutgoingURI(y.resource)}}}e.$1r=h;class u extends M.$Uc{constructor(y,k){super(),k.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(w=>k.call("setLogLevel",[w]))),k.call("getRegisteredLoggers").then(w=>{for(const m of w)y.registerLogger({...m,resource:i.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([w,m])=>y.setVisibility(i.URI.revive(w),m))),this.B(k.listen("onDidChangeLoggers")(({added:w,removed:m})=>{for(const v of w)y.registerLogger({...v,resource:i.URI.revive(v.resource)});for(const v of m)y.deregisterLogger(v.resource)}))}}e.$2r=u}),define(oe[231],ae([0,1,2,5]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=void 0;class S extends i.$Uc{constructor(P,E=[]){super(),this.a=new R.$4j([P,...E]),this.B(P.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...E){this.a.trace(P,...E)}debug(P,...E){this.a.debug(P,...E)}info(P,...E){this.a.info(P,...E)}warn(P,...E){this.a.warn(P,...E)}error(P,...E){this.a.error(P,...E)}flush(){this.a.flush()}}e.$gQ=S}),define(oe[232],ae([0,1,32,7,5]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class M{constructor(E){this.b=E,this.a=new i.$Bc}listen(E,h,u){switch(h){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,u){switch(h){case"createLogger":this.c(R.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(R.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,S.$Vj)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(R.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:R.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(u[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,u){this.a.set(E,this.b.createLogger(E,h,u))}d(E,h){let u=console.log;switch(E){case S.LogLevel.Error:u=console.error;break;case S.LogLevel.Warning:u=console.warn;break;case S.LogLevel.Info:u=console.info;break}u.call(console,...h)}e(E,h){const u=this.a.get(E);if(!u)throw new Error("Create the logger before logging");for(const[g,y]of h)(0,S.log)(u,g,y)}}e.$ecc=M}),define(oe[233],ae([0,1,16,5]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;var S;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(S||(S={}));async function M(u,g,y,k,w){try{const m=await new Promise((p,$)=>{Q(["@vscode/spdlog"],p,$)});m.setFlushOn(S.Trace);const v=await m.createAsyncRotatingLogger(u,g,y,k);return w?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(m){console.error(m)}return null}function P(u,g,y){switch(g){case R.LogLevel.Trace:u.trace(y);break;case R.LogLevel.Debug:u.debug(y);break;case R.LogLevel.Info:u.info(y);break;case R.LogLevel.Warning:u.warn(y);break;case R.LogLevel.Error:u.error(y);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function E(u,g){switch(g){case R.LogLevel.Trace:u.setLevel(S.Trace);break;case R.LogLevel.Debug:u.setLevel(S.Debug);break;case R.LogLevel.Info:u.setLevel(S.Info);break;case R.LogLevel.Warning:u.setLevel(S.Warning);break;case R.LogLevel.Error:u.setLevel(S.Error);break;case R.LogLevel.Off:u.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class h extends R.$Zj{constructor(g,y,k,w,m){super(),this.m=[],this.setLevel(m),this.n=this.s(g,y,k,w),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(g,y,k,w){const m=k?6:1,v=30/m*i.$pl.MB,p=await M(g,y,v,m,w);if(p){this.r=p,E(this.r,this.getLevel());for(const{level:$,message:f}of this.m)P(this.r,$,f);this.m=[]}}g(g,y){this.r?P(this.r,g,y):this.getLevel()<=g&&this.m.push({level:g,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$8P=h}),define(oe[234],ae([0,1,33,5,233]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=void 0;class M extends R.$5j{s(E,h,u){return new S.$8P((0,i.$Jg)(),E.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,h)}}e.$9P=M}),define(oe[67],ae([0,1,32,3,6,5,234]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=e.$Qac=void 0,e.$Qac=(0,S.$oi)(M.$Uj);class E extends P.$9P{constructor(){super(...arguments),this.u=new i.$Bc}createLogger(u,g,y){y!==void 0&&this.u.set(this.n(u),y);try{return super.createLogger(u,g)}catch(k){throw this.u.delete(this.n(u)),k}}registerLogger(u,g){g!==void 0&&this.u.set(u.resource,g),super.registerLogger(u)}deregisterLogger(u){this.u.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const g=[];for(const y of super.getRegisteredLoggers())u===this.u.get(y.resource)&&g.push(y);return g}getOnDidChangeLogLevelEvent(u){return R.Event.filter(this.onDidChangeLogLevel,g=>(0,M.$Vj)(g)||this.w(g[0],u))}getOnDidChangeVisibilityEvent(u){return R.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,u))}getOnDidChangeLoggersEvent(u){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(k=>this.w(k.resource,u)),removed:[...g.removed].filter(k=>this.w(k.resource,u))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(u){for(const[g,y]of this.u)y===u&&this.deregisterLogger(g)}w(u,g){const y=this.u.get(u);return y===void 0||y===g}dispose(){super.dispose(),this.u.clear()}}e.$Rac=E}),define(oe[235],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=i,e.$xbc=R,e.$ybc=S,e.$zbc=M;function i(P){return P.submenu!==void 0}function R(P){return P.id==="vscode.menubar.separator"}function S(P){return P.uri!==void 0}function M(P){return!i(P)&&!R(P)&&!S(P)}}),define(oe[39],ae([0,1,3,71,2,6]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=void 0,e.$8n=(0,M.$ni)("policy");class P extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$_d),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const g=Object.keys(this.f).length;return this.f={...u,...this.f},g!==Object.keys(this.f).length&&await this.j(u),R.Iterable.reduce(this.g.entries(),(y,[k,w])=>({...y,[k]:w}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(u,[g,y])=>({...u,[g]:{definition:y,value:this.g.get(g)}}),{})}}e.$9n=P;class E{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$0n=E}),define(oe[236],ae([0,1,8,3,71,12,16,5,39]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;function u(y,k){const w=[];for(const m of new Set(S.Iterable.concat(y.keys(),k.keys())))y.get(m)!==k.get(m)&&w.push(m);return w}let g=class extends h.$9n{constructor(k,w,m){super(),this.m=k,this.n=w,this.s=m,this.c=this.B(new i.$lh(500));const v=R.Event.filter(w.onDidFilesChange,p=>p.affects(k));this.B(w.watch(k)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const w=await this.n.readFile(this.m),m=JSON.parse(w.value.toString());if(!(0,M.$3f)(m))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(m))this.f[v]&&k.set(v,m[v])}catch(w){w.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",w)}return k}async w(){const k=await this.u(),w=u(this.g,k);this.g=k,w.length>0&&this.h.fire(w)}};e.$xcc=g,e.$xcc=g=Ee([ne(1,P.$Tk),ne(2,E.$Tj)],g)}),define(oe[237],ae([0,1,3,2,39]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=void 0;class M{constructor(h){this.b=h,this.a=new R.$Tc}listen(h,u){switch(u){case"onDidChange":return i.Event.map(this.b.onDidChange,g=>g.reduce((y,k)=>({...y,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(h,u,g){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$8bc=M;class P extends S.$9n{constructor(h,u){super(),this.a=u;for(const g in h){const{definition:y,value:k}=h[g];this.f[g]=y,k!==void 0&&this.g.set(g,k)}this.a.listen("onDidChange")(g=>{for(const y in g){const k=g[y];k===null?this.g.delete(y):this.g.set(y,k)}this.h.fire(Object.keys(g))})}async j(h){const u=await this.a.call("updatePolicyDefinitions",h);for(const g in u)this.g.set(g,u[g])}}e.$9bc=P}),define(oe[238],ae([0,1,39,8,2,5]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;let P=class extends i.$9n{constructor(h,u){super(),this.m=h,this.n=u,this.a=new R.$hh,this.b=this.B(new S.$Vc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:u}=await new Promise((g,y)=>{Q(["@vscode/policy-watcher"],g,y)});await this.a.queue(()=>new Promise((g,y)=>{try{this.b.value=u(this.n,h,k=>{this.t(k),g()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),y(k)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const u in h){const g=h[u];g===void 0?this.g.delete(u):this.g.set(u,g)}this.h.fire(Object.keys(h))}};e.$wcc=P,e.$wcc=P=Ee([ne(0,M.$Tj)],P)}),define(oe[80],ae([0,1,36]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const M=S.context.configuration();if(M)R=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:M.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(oe[27],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,i.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"}),define(oe[239],ae([0,1,8,5]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;let S=class{constructor(P,E,h){this.a=P,this.b=E,this.c=h}async inspect(P){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$oh)(P);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const P=this.a.webContents.debugger;P.attach(),await P.sendCommand("Profiler.enable")}async e(){const P=this.a.webContents.debugger;await P.sendCommand("Profiler.disable"),P.detach()}};e.$mbc=S,e.$mbc=S=Ee([ne(2,R.$Tj)],S)}),define(oe[81],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0,e.$zac=(0,i.$ni)("protocolMainService")}),define(oe[45],ae([0,1,139,12]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class S{constructor(){this.a=new Map}add(P,E){i.ok(R.$1f(P)),i.ok(R.$3f(E)),i.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,E)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$6n=new S}),define(oe[240],ae([0,1,3,45]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function S(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this.b=new i.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,u){this.a[S(h)]=u,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const P=new M;R.$6n.add(e.$7n.JSONContribution,P)}),define(oe[52],ae([0,1,22,3,12,165,18,240,45]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=v,e.$ko=p,e.$lo=$,e.$mo=l,e.$no=d;var u;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$$n={Configuration:"base.contributions.configuration"};var g;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const y=h.$6n.as(E.$7n.JSONContribution);class k{constructor(){this.h=new Set,this.i=new R.$_d,this.onDidSchemaChange=this.i.event,this.j=new R.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.n(t,o,s),y.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.o(o,s),this.n(t,!1,s),y.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const s=[];for(const{overrides:n,source:r}of t)for(const c in n)if(o.add(c),e.$io.test(c)){const b=this.a.get(c),I=b?.valuesSources??new Map;if(r)for(const C of Object.keys(n[c]))I.set(C,r);const D={...b?.value||{},...n[c]};this.a.set(c,{source:r,value:D,valuesSources:I});const j=(0,P.$4i)(c),A={type:"object",default:D,description:M.localize(1,null,j),$ref:e.$fo,defaultDefaultValue:D,source:S.$1f(r)?void 0:r,defaultValueSource:r};s.push(...v(c)),this.d[c]=A,this.b.properties[c]=A}else{this.a.set(c,{value:n[c],source:r});const b=this.d[c];b&&(this.w(c,b),this.r(c,b))}this.m(s)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:s,source:n}of t)for(const r in s){const c=this.a.get(r),b=S.$1f(n)?n:n?.id,I=S.$1f(c?.source)?c?.source:c?.source?.id;if(b===I)if(o.add(r),this.a.delete(r),e.$io.test(r))delete this.d[r],delete this.b.properties[r];else{const D=this.d[r];D&&(this.w(r,D),this.r(r,D))}}this.u()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,s){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,o){const s=n=>{if(n.properties)for(const r in n.properties){o.add(r);const c=this.d[r];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>s(r))};for(const n of t){s(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,o=!0,s,n,r=3,c){r=S.$0f(t.scope)?r:t.scope;const b=t.properties;if(b)for(const D in b){const j=b[D];if(o&&l(D,j)){delete b[D];continue}if(j.source=s,j.defaultDefaultValue=b[D].default,this.w(D,j),e.$io.test(D)?j.scope=void 0:(j.scope=S.$0f(j.scope)?r:j.scope,j.restricted=S.$0f(j.restricted)?!!n?.includes(D):j.restricted),b[D].hasOwnProperty("included")&&!b[D].included){this.f[D]=b[D],delete b[D];continue}else this.d[D]=b[D],b[D].policy?.name&&this.e.set(b[D].policy.name,D);!b[D].deprecationMessage&&b[D].markdownDeprecationMessage&&(b[D].deprecationMessage=b[D].markdownDeprecationMessage),c.add(D)}const I=t.allOf;if(I)for(const D of I)this.p(D,o,s,n,r,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=s=>{const n=s.properties;if(n)for(const c in n)this.r(c,n[c]);s.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$_n.properties[t]=o,o.scope){case 1:e.$ao.properties[t]=o;break;case 2:e.$bo.properties[t]=o;break;case 6:e.$co.properties[t]=o;break;case 3:e.$do.properties[t]=o;break;case 4:e.$eo.properties[t]=o;break;case 5:e.$eo.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$_n.properties[t],o.scope){case 1:delete e.$ao.properties[t];break;case 2:delete e.$bo.properties[t];break;case 6:delete e.$co.properties[t];break;case 3:delete e.$do.properties[t];break;case 4:case 5:delete e.$eo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,s={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$fo};this.w(o,s),e.$_n.properties[o]=s,e.$ao.properties[o]=s,e.$bo.properties[o]=s,e.$co.properties[o]=s,e.$do.properties[o]=s,e.$eo.properties[o]=s}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=t,e.$ao.patternProperties[e.$ho]=t,e.$bo.patternProperties[e.$ho]=t,e.$co.patternProperties[e.$ho]=t,e.$do.patternProperties[e.$ho]=t,e.$eo.patternProperties[e.$ho]=t,this.i.fire()}w(t,o){const s=this.a.get(t);let n=s?.value,r=s?.source;S.$8f(n)&&(n=o.defaultDefaultValue,r=void 0),S.$8f(n)&&(n=$(o.type)),o.default=n,o.defaultValueSource=r}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$ho=`^(${w})+$`,e.$io=new RegExp(e.$ho);function v(a){const t=[];if(e.$io.test(a)){let o=m.exec(a);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=m.exec(a)}}return(0,i.$Mb)(t)}function p(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function $(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new k;h.$6n.add(e.$$n.Configuration,f);function l(a,t){return a.trim()?e.$io.test(a)?M.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?M.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function d(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(oe[123],ae([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=l;function w(o){return Object.isFrozen(o)?o:E.$Un(o)}class m{constructor(s={},n=[],r=[],c){this.b=s,this.c=n,this.d=r,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof m)return n;const r=new v("");return r.parseRaw(n),r.configurationModel});this.f=s.reduce((n,r)=>r===n?r:n.merge(r),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,g.$2i)(this.contents,s):this.contents}inspect(s,n){const r=this;return{get value(){return w(r.rawConfiguration.getValue(s))},get override(){return n?w(r.rawConfiguration.getOverrideValue(s,n)):void 0},get merged(){return w(n?r.rawConfiguration.override(n).getValue(s):r.rawConfiguration.getValue(s))},get overrides(){const c=[];for(const{contents:b,identifiers:I,keys:D}of r.rawConfiguration.overrides){const j=new m(b,D).getValue(s);j!==void 0&&c.push({identifiers:I,value:j})}return c.length?w(c):void 0}}}getOverrideValue(s,n){const r=this.i(n);return r?s?(0,g.$2i)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return i.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return i.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=E.$Tn(this.contents),r=E.$Tn(this.overrides),c=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const I of s)if(b.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(n,I.contents);for(const D of I.overrides){const[j]=r.filter(A=>i.$ub(A.identifiers,D.identifiers));j?(this.h(j.contents,D.contents),j.keys.push(...D.keys),j.keys=i.$Mb(j.keys)):r.push(E.$Tn(D))}for(const D of I.keys)c.indexOf(D)===-1&&c.push(D)}return new m(n,c,r,b.every(I=>I instanceof m)?void 0:b)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const c of i.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let b=this.contents[c];const I=n[c];I&&(typeof b=="object"&&typeof I=="object"?(b=E.$Tn(b),this.h(b,I)):b=I),r[c]=b}return new m(r,this.keys,this.overrides)}h(s,n){for(const r of Object.keys(n)){if(r in s&&h.$3f(s[r])&&h.$3f(n[r])){this.h(s[r],n[r]);continue}s[r]=E.$Tn(n[r])}}i(s){let n=null,r=null;const c=b=>{b&&(r?this.h(r,b):r=E.$Tn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===s?n=b.contents:b.identifiers.includes(s)&&c(b.contents);return c(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,g.$1i)(this.contents,s),y.$io.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>i.$ub(r.identifiers,(0,y.$jo)(s))),1))}j(s,n,r){(0,g.$Zi)(this.contents,s,n,c=>console.error(c)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),y.$io.test(s)&&this.overrides.push({identifiers:(0,y.$jo)(s),keys:Object.keys(this.contents[s]),contents:(0,g.$Yi)(this.contents[s],c=>console.error(c))})}}e.$oo=m;class v{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!h.$0f(s)){const r=this.g(s);this.parseRaw(r,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:r,keys:c,overrides:b,restricted:I,hasExcludedProperties:D}=this.h(s,n);this.b=new m(r,c,b,D?[s]:void 0),this.c=I||[]}g(s){let n={},r=null,c=[];const b=[],I=[];function D(A){Array.isArray(c)?c.push(A):r!==null&&(c[r]=A)}const j={onObjectBegin:()=>{const A={};D(A),b.push(c),c=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{c=b.pop()},onArrayBegin:()=>{const A=[];D(A),b.push(c),c=A,r=null},onArrayEnd:()=>{c=b.pop()},onLiteralValue:D,onError:(A,C,W)=>{I.push({error:A,offset:C,length:W})}};if(s)try{S.$Hn(s,j),n=c[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return n}h(s,n){const r=k.$6n.as(y.$$n.Configuration).getConfigurationProperties(),c=this.i(s,r,!0,n);s=c.raw;const b=(0,g.$Yi)(s,j=>console.error(`Conflict in settings file ${this.f}: ${j}`)),I=Object.keys(s),D=this.j(s,j=>console.error(`Conflict in settings file ${this.f}: ${j}`));return{contents:b,keys:I,overrides:D,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(s,n,r,c){let b=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:b};const I={},D=[];for(const j in s)if(y.$io.test(j)&&r){const A=this.i(s[j],n,!1,c);I[j]=A.raw,b=b||A.hasExcludedProperties,D.push(...A.restricted)}else{const A=n[j],C=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&D.push(j),!c.exclude?.includes(j)&&(c.include?.includes(j)||(C===void 0||c.scopes===void 0||c.scopes.includes(C))&&!(c.skipRestricted&&A?.restricted))?I[j]=s[j]:b=!0}return{raw:I,restricted:D,hasExcludedProperties:b}}j(s,n){const r=[];for(const c of Object.keys(s))if(y.$io.test(c)){const b={};for(const I in s[c])b[I]=s[c][I];r.push({identifiers:(0,y.$jo)(c),keys:Object.keys(b),contents:(0,g.$Yi)(b,n)})}return r}}e.$po=v;class p extends M.$Uc{constructor(s,n,r,c){super(),this.c=s,this.f=n,this.g=c,this.b=this.B(new R.$_d),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&r.isEqual(b.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=p;class ${constructor(s,n,r,c,b,I,D,j,A,C,W,T,N){this.a=s,this.b=n,this.c=r,this.overrideIdentifiers=c,this.d=b,this.f=I,this.g=D,this.h=j,this.i=A,this.j=C,this.k=W,this.l=T,this.m=N}get value(){return w(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(s,n,r,c,b=new m,I=new m,D=new P.$Bc,j=new m,A=new P.$Bc){this.c=s,this.d=n,this.f=r,this.g=c,this.h=b,this.i=I,this.j=D,this.l=j,this.m=A,this.a=null,this.b=new P.$Bc,this.n=null}getValue(s,n,r){return this.p(s,n,r).getValue(s)}updateValue(s,n,r={}){let c;r.resource?(c=this.m.get(r.resource),c||(c=new m,this.m.set(r.resource,c))):c=this.l,n===void 0?c.removeValue(s):c.setValue(s,n),r.resource||(this.a=null)}inspect(s,n,r){const c=this.p(s,n,r),b=this.t(n.resource,r),I=n.resource?this.m.get(n.resource)||this.l:this.l,D=new Set;for(const j of c.overrides)for(const A of j.identifiers)c.getOverrideValue(s,A)!==void 0&&D.add(A);return new $(s,n,c.getValue(s),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,b||void 0,I)}keys(s){const n=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:c,updated:b,removed:I}=a(this.c,s);n=[...c,...b,...I]}for(const c of n)for(const b of(0,y.$jo)(c)){const I=this.c.getKeysForOverrideIdentifier(b),D=s.getKeysForOverrideIdentifier(b),j=[...D.filter(A=>I.indexOf(A)===-1),...I.filter(A=>D.indexOf(A)===-1),...I.filter(A=>!E.$Xn(this.c.override(b).getValue(A),s.override(b).getValue(A)))];r.push([b,j])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:r,removed:c}=a(this.d,s),b=[...n,...r,...c];return b.length&&this.updatePolicyConfiguration(s),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.applicationConfiguration,s),I=[...n,...r,...c];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:b}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.localUserConfiguration,s),I=[...n,...r,...c];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:b}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.remoteUserConfiguration,s),I=[...n,...r,...c];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:b}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.workspaceConfiguration,s),I=[...n,...r,...c];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:b}}compareAndUpdateFolderConfiguration(s,n){const r=this.folderConfigurations.get(s),{added:c,updated:b,removed:I,overrides:D}=a(r,n),j=[...c,...b,...I];return(j.length||!r)&&this.updateFolderConfiguration(s,n),{keys:j,overrides:D}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:c,removed:b,overrides:I}=a(n,void 0);return{keys:[...r,...c,...b],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,n,r){let c=this.q(n,r);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(c=c.merge(this.d)),c}q({resource:s},n){let r=this.r();if(n&&s){const c=n.getFolder(s);c&&(r=this.s(c.uri)||r);const b=this.m.get(s);b&&(r=r.merge(b))}return r}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let n=this.b.get(s);if(!n){const r=this.r(),c=this.j.get(s);c?(n=r.merge(c),this.b.set(s,n)):n=r}return n}t(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:r,overrides:c,keys:b}=this.j.get(n);return s.push([n,{contents:r,overrides:c,keys:b}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(r=>s.add(r))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}v(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(c=>n.add(c))),[...n.values()]}static parse(s){const n=this.w(s.defaults),r=this.w(s.policy),c=this.w(s.application),b=this.w(s.user),I=this.w(s.workspace),D=s.folders.reduce((j,A)=>(j.set(u.URI.revive(A[0]),this.w(A[1])),j),new P.$Bc);return new f(n,r,c,b,new m,I,D,new m,new P.$Bc)}static w(s){return new m(s.contents,s.keys,s.overrides)}}e.$ro=f;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,n=new Map;for(const c of o)c.keys.forEach(b=>s.add(b)),c.overrides.forEach(([b,I])=>{const D=(0,P.$yc)(n,b,new Set);I.forEach(j=>D.add(j))});const r=[];return n.forEach((c,b)=>r.push([b,[...c.values()]])),{keys:[...s.values()],overrides:r}}class d{constructor(s,n,r,c){this.change=s,this.f=n,this.g=r,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of s.keys)this.affectedKeys.add(b);for(const[,b]of s.overrides)for(const I of b)this.affectedKeys.add(I);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,n){const r=this.a+s,c=this.d.indexOf(r);if(c<0)return!1;const b=c+r.length;if(b>=this.d.length)return!1;const I=this.d.charCodeAt(b);if(I!==this.b&&I!==this.c)return!1;if(n){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,j=this.g.getValue(s,n,this.h);return!E.$Xn(D,j)}return!0}}e.$to=d;function a(o,s){const{added:n,removed:r,updated:c}=t(s?.rawConfiguration,o?.rawConfiguration),b=[],I=o?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const j=D.filter(A=>!I.includes(A));for(const A of j)b.push([A,s.getKeysForOverrideIdentifier(A)])}if(o){const j=I.filter(A=>!D.includes(A));for(const A of j)b.push([A,o.getKeysForOverrideIdentifier(A)])}if(s&&o){for(const j of I)if(D.includes(j)){const A=t({contents:o.getOverrideValue(void 0,j)||{},keys:o.getKeysForOverrideIdentifier(j)},{contents:s.getOverrideValue(void 0,j)||{},keys:s.getKeysForOverrideIdentifier(j)});b.push([j,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:r,updated:c,overrides:b}}function t(o,s){const n=o?s?o.keys.filter(b=>s.keys.indexOf(b)===-1):[...o.keys]:[],r=s?o?s.keys.filter(b=>o.keys.indexOf(b)===-1):[...s.keys]:[],c=[];if(o&&s){for(const b of s.keys)if(o.keys.indexOf(b)!==-1){const I=(0,g.$2i)(s.contents,b),D=(0,g.$2i)(o.contents,b);E.$Xn(I,D)||c.push(b)}}return{added:n,removed:r,updated:c}}}),define(oe[241],ae([0,1,22,3,2,35,12,123,52,5,39,45]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0;class k extends S.$Uc{constructor(){super(...arguments),this.a=this.B(new R.$_d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$oo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$6n.as(h.$$n.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:$})=>this.c(Array.from(p),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,$){this.h(p,y.$6n.as(h.$$n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new E.$oo;const p=y.$6n.as(h.$$n.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,$){const f=this.f();for(const l of p){const d=f[l],a=$[l];d!==void 0?this.b.addValue(l,d):a?this.b.addValue(l,a.default):this.b.removeValue(l)}}}e.$uo=k;class w{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new E.$oo}async initialize(){return this.configurationModel}}e.$vo=w;let m=class extends S.$Uc{get configurationModel(){return this.b}constructor(p,$,f){super(),this.c=p,this.f=$,this.g=f,this.a=this.B(new R.$_d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$oo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const $={},f=[],l=y.$6n.as(h.$$n.Configuration).getConfigurationProperties();for(const d of p){const a=l[d];if(!a){f.push(d);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(d),$[a.policy.name]={type:a.type}}}return(0,P.$bg)($)||await this.f.updatePolicyDefinitions($),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const $=y.$6n.as(h.$$n.Configuration).getPolicyConfigurations(),f=(0,i.$Hb)(p.map(l=>$.get(l)));this.m(f,!0)}m(p,$){this.g.trace("PolicyConfiguration#update",p);const f=y.$6n.as(h.$$n.Configuration).getConfigurationProperties(),l=[],d=this.b.isEmpty();for(const a of p){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(d?o!==void 0:!(0,M.$Xn)(this.b.getValue(a),o))&&l.push([a,o])}else this.b.getValue(a)!==void 0&&l.push([a,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const a=this.b;this.b=new E.$oo;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of l)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);$&&this.a.fire(this.b)}}};e.$wo=m,e.$wo=m=Ee([ne(1,g.$8n),ne(2,u.$Tj)],m)}),define(oe[242],ae([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,241,39]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0;class $ extends h.$Uc{constructor(d,a,t,o){super(),this.m=d,this.h=this.B(new M.$_d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$uo),this.c=t instanceof p.$0n?new v.$vo:this.B(new v.$wo(this.b,t,o)),this.f=this.B(new w.$qo(this.m,{},y.$Rg,a)),this.a=new w.$ro(this.b.configurationModel,this.c.configurationModel,new w.$oo,new w.$oo),this.j=new f(d,a,this),this.g=this.B(new R.$zh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:n})=>this.r(s,n))),this.B(this.c.onDidChangeConfiguration(s=>this.s(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new w.$ro(d,a,new w.$oo,t)}getConfigurationData(){return this.a.toData()}getValue(d,a){const t=typeof d=="string"?d:void 0,o=(0,k.$Ui)(d)?d:(0,k.$Ui)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue(d,a,t,o,s){const n=(0,k.$Vi)(t)?t:(0,k.$Ui)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,r=n?o:t;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${d} to target ${r}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,i.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const c=this.inspect(d,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(c.policyValue!==void 0)throw new Error(`Unable to write ${d} because it is configured in system policy.`);if((0,u.$Xn)(a,c.defaultValue)&&(a=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const I=n.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(j=>(0,i.$ub)([...j.identifiers].sort(),I));D&&(n.overrideIdentifiers=D.identifiers)}const b=n?.overrideIdentifiers?.length?[(0,m.$ko)(n.overrideIdentifiers),d]:[d];await this.j.write(b,a),await this.reloadConfiguration()}inspect(d,a={}){return this.a.inspect(d,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.n(d)}n(d){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(d);this.t(t,a,2)}r(d,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(d,a);this.t(o,t,7)}s(d){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(d);this.t(t,a,7)}t(d,a,t){const o=new w.$to(d,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$xo=$;class f{constructor(d,a,t){this.b=d,this.c=a,this.d=t,this.a=new R.$uh}write(d,a){return this.a.queue(()=>this.e(d,a))}async e(d,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)t="{}";else throw n}const o=[];if((0,P.$An)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(t,d,a);t=(0,E.$Sn)(t,s),await this.c.writeFile(this.b,S.$ze.fromString(t))}f(d,a,t){const{tabSize:o,insertSpaces:s,eol:n}=this.h;if(!a.length){const r=JSON.stringify(t,null,s?" ".repeat(o):"	");return[{content:r,length:r.length,offset:0}]}return(0,E.$Pn)(d,a,t,{tabSize:o,insertSpaces:s,eol:n})}get h(){if(!this.g){let d=g.OS===3||g.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(d=a),this.g={eol:d,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[243],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=void 0,e.$jcc="request",e.$kcc="remoteResourceHandler";class i{async routeCall(S,M,P){if(M!==e.$jcc)throw new Error(`Call not found: ${M}`);const E=P[0];if(E?.authority){const h=S.connections.find(u=>u.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(S,M){throw new Error(`Event not found: ${M}`)}}e.$lcc=i}),define(oe[244],ae([0,1,15,6]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.RemoteAuthorityResolverErrorCode=e.$Al=e.$zl=e.RemoteConnectionType=e.$yl=void 0,e.$Cl=u,e.$yl=(0,R.$ni)("remoteAuthorityResolverService");var S;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class M{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$zl=M;class P{constructor(y,k){this.host=y,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Al=P;var E;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends i.$bb{static isNotAvailable(y){return y instanceof h&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof h&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof h&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof h&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof h&&y.isHandled}constructor(y,k=E.Unknown,w){super(y),this._message=y,this._code=k,this._detail=w,this.isHandled=k===E.NotAvailable&&w===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Bl=h;function u(g){const y=g.indexOf("+");return y===-1?g:g.substring(0,y)}}),define(oe[245],ae([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Hl=I,e.$Il=D,e.$Jl=A;const m=30*1e3;var v;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function p(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(X){const O=new S.$je;return setTimeout(()=>O.cancel(),X),O.token}function f(X,O){if(X.isCancellationRequested||O.isCancellationRequested)return S.CancellationToken.Cancelled;const F=new S.$je;return X.onCancellationRequested(()=>F.cancel()),O.onCancellationRequested(()=>F.cancel()),F.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$gh)(),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function d(X,O){const F=new l(O);return F.registerDisposable(X.onControlMessage(_=>{const se=JSON.parse(_.toString()),J=L(se);J?F.reject(J):F.resolve(se)})),F.promise}function a(X,O,F,_,se,J,x,V){const q=new l(V),re=g.$8d.create(!1);return X.info(`Creating a socket (${x})...`),u.mark(`code/willCreateSocket/${J}`),O.connect(F,_,se,x).then(ee=>{q.didTimeout?(u.mark(`code/didCreateSocketError/${J}`),X.info(`Creating a socket (${x}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(u.mark(`code/didCreateSocketOK/${J}`),X.info(`Creating a socket (${x}) was successful after ${re.elapsed()} ms.`),q.resolve(ee))},ee=>{u.mark(`code/didCreateSocketError/${J}`),X.info(`Creating a socket (${x}) returned an error after ${re.elapsed()} ms.`),X.error(ee),q.reject(ee)}),q.promise}function t(X,O){const F=new l(O);return X.then(_=>{F.didTimeout||F.resolve(_)},_=>{F.didTimeout||F.reject(_)}),F.promise}async function o(X,O,F,_){const se=ce(X,O);X.logService.trace(`${se} 1/6. invoking socketFactory.connect().`);let J;try{J=await a(X.logService,X.remoteSocketFactoryService,X.connectTo,h.$Ag.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,p(O),`renderer-${p(O)}-${X.reconnectionToken}`,_)}catch(ee){throw X.logService.error(`${se} socketFactory.connect() failed or timed out. Error:`),X.logService.error(ee),ee}X.logService.trace(`${se} 2/6. socketFactory.connect() was successful.`);let x,V;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(J,null),x=X.reconnectionProtocol,V=!1):(x=new k.$bi({socket:J}),V=!0),X.logService.trace(`${se} 3/6. sending AuthRequest control message.`);const q=await t(X.signService.createNewMessage((0,y.$Jg)()),_),re={type:"auth",auth:X.connectionToken||"00000000000000000000",data:q.data};x.sendControl(R.$ze.fromString(JSON.stringify(re)));try{const ee=await d(x,f(_,$(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(X.logService.trace(`${se} 4/6. received SignRequest control message.`),!await t(X.signService.validate(q,ee.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const me=await t(X.signService.sign(ee.data),_),ve={type:"connectionType",commit:X.commit,signedData:me,desiredConnectionType:O};return F&&(ve.args=F),X.logService.trace(`${se} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(R.$ze.fromString(JSON.stringify(ve))),{protocol:x,ownsProtocol:V}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(X.logService.error(`${se} the handshake timed out. Error:`),X.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${se} received error control message when negotiating connection. Error:`),X.logService.error(ee)),V&&B(x),ee}}async function s(X,O,F,_){const se=Date.now(),J=ce(X,O),{protocol:x,ownsProtocol:V}=await o(X,O,F,_),q=new l(_);return q.registerDisposable(x.onControlMessage(re=>{const ee=JSON.parse(re.toString()),fe=L(ee);fe?(X.logService.error(`${J} received error control message when negotiating connection. Error:`),X.logService.error(fe),V&&B(x),q.reject(fe)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${he(se)}!`),q.resolve({protocol:x,firstMessage:ee}))})),q.promise}async function n(X,O){const{protocol:F}=await s(X,1,void 0,O);return{protocol:F}}async function r(X,O,F){const{protocol:_,firstMessage:se}=await s(X,2,O,F),J=se&&se.debugPort;return{protocol:_,debugPort:J}}async function c(X,O,F){const _=Date.now(),se=ce(X,3),{protocol:J}=await o(X,3,O,F);return X.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${he(_)}!`),J}async function b(X,O,F){const{connectTo:_,connectionToken:se}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:_,connectionToken:se,reconnectionToken:O,reconnectionProtocol:F,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function I(X,O,F){return j(X,async _=>{const{protocol:se}=await n(_,S.CancellationToken.None);return new Y(X,O,F,_.reconnectionToken,se)})}async function D(X,O){return j(X,async F=>{const{protocol:_,debugPort:se}=await r(F,O,S.CancellationToken.None);return new K(X,O,F.reconnectionToken,_,se)})}async function j(X,O){for(let _=1;;_++)try{const se=(0,y.$Jg)(),J=await b(X,se,null);return await O(J)}catch(se){if(_<5)X.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(se);else throw X.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(se),le.triggerPermanentFailure(0,0,w.$Bl.isHandled(se)),se}}async function A(X,O,F){const _=await b(X,(0,y.$Jg)(),null);return await c(_,{host:O,port:F},S.CancellationToken.None)}function C(X){return(0,i.$ah)(O=>new Promise((F,_)=>{const se=setTimeout(F,X*1e3);O.onCancellationRequested(()=>{clearTimeout(se),F()})}))}var W;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class T{constructor(O,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.type=0}}e.$Kl=T;class N{constructor(O,F,_,se){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.durationSeconds=_,this.c=se,this.type=1}skipWait(){this.c.cancel()}}e.$Ll=N;class U{constructor(O,F,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=2}}e.$Ml=U;class ue{constructor(O,F,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=4}}e.$Nl=ue;class ie{constructor(O,F,_,se){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=_,this.handled=se,this.type=3}}e.$Ol=ie;class le extends E.$Uc{static triggerPermanentFailure(O,F,_){this._permanentFailure=!0,this.f=O,this.g=F,this.h=_,this.j.forEach(se=>se.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||le._permanentFailure}constructor(O,F,_,se,J){super(),this.t=O,this.u=F,this.reconnectionToken=_,this.protocol=se,this.w=J,this.m=this.B(new P.$_d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ue(this.reconnectionToken,0,0)),this.B(se.onSocketClose(x=>{const V=z(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${V} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${V} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${V} received socket close event.`),this.y()})),this.B(se.onSocketTimeout(x=>{const V=z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,E.$Sc)(()=>{const x=le.j.indexOf(this);x>=0&&le.j.splice(x,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const se=_<F.length?F[_]:F[F.length-1];try{if(se>0){const x=C(se);this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se,x)),this.u.logService.info(`${O} waiting for ${se} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${O} resolving connection...`);const J=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${J.connectTo}...`),await this.G(J,$(m)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(w.$Bl.isTemporarilyNotAvailable(J)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,M.$4)(J)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof w.$Bl){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,w.$Bl.isHandled(J));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(O,F,_){this.w?le.triggerPermanentFailure(O,F,_):this.D(O,F,_)}D(O,F,_){this.m.fire(new ie(this.reconnectionToken,O,F,_)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Pl=le;class Y extends le{constructor(O,F,_,se,J){super(1,O,se,J,!0),this.client=this.B(new k.$_h(J,{remoteAuthority:F,clientId:_},O.ipcLogger))}async G(O,F){await n(O,F)}}e.$Ql=Y;class K extends le{constructor(O,F,_,se,J){super(2,O,_,se,!1),this.H=F,this.debugPort=J}async G(O,F){await r(O,this.H,F)}}e.$Rl=K;function B(X){try{X.acceptDisconnect();const O=X.getSocket();X.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function L(X){if(X&&X.type==="error"){const O=new Error(`Connection error: ${X.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function H(X,O){for(;X.length<O;)X+=" ";return X}function G(X,O){return`[remote-connection][${H(p(X),13)}][${O.substr(0,5)}\u2026]`}function z(X,O,F){return`${G(X,O)}[${F?"reconnect":"initial"}]`}function ce(X,O){return`${z(O,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function he(X){return`${Date.now()-X} ms`}}),define(oe[68],ae([0,1,13]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=R,e.$zm=S,e.$Am=M,e.$Bm=P;function R(h){return h.scheme===i.Schemas.vscodeRemote?h.authority:void 0}function S(h){if(!h)return;const u=h.indexOf("+");return u<0?h:h.substr(0,u)}function M(h){const{host:u,port:g}=E(h);if(typeof g>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:u,port:g}}function P(h,u){let{host:g,port:y}=E(h);return typeof y>"u"&&(y=u),{host:g,port:y}}function E(h){const u=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(u)return{host:u[1],port:parseInt(u[2],10)};const g=h.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(oe[124],ae([0,1,25,6,68]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=M,e.$Lm=y,e.$Mm=k,e.$Nm=w,e.$Om=m,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function M(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P||(e.ExtensionType=P={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,$){if(typeof p>"u"||p===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof p=="string"||typeof $=="string"){const f=typeof p=="string"?p:p.value,l=typeof $=="string"?$:$.value;return i.$qf(f,l)}return p._lower===$._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Im=h;class u{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const $ of p)this.add($)}add(p){this.c.add(h.toKey(p))}delete(p){return this.c.delete(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}}e.$Jm=u;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(h.toKey(p))}get(p){return this.c.get(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}set(p,$){this.c.set(h.toKey(p),$)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=g;function y(v){return k(v)}function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function w(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function m(v,p){if(p){const $=`onResolveRemoteAuthority:${(0,S.$zm)(p)}`;return!!v.activationEvents?.includes($)}return!1}e.$Pm=(0,R.$ni)("IBuiltinExtensionsScannerService")}),define(oe[246],ae([0,1,2,6]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=void 0,e.$Dl=(0,R.$ni)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(P,E){return this.a[P]??=[],this.a[P].push(E),(0,i.$Sc)(()=>{const h=this.a[P]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[P]?.splice(h,1)})}b(P){return(this.a[P.type]||[]).find(h=>h.supports(P))}connect(P,E,h,u){const g=this.b(P);if(!g)throw new Error(`No socket factory found for ${P}`);return g.connect(P,E,h,u)}}e.$El=S}),define(oe[247],ae([0,1,26,49,21,117]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=E;let P;async function E(w=!1){return(P===void 0||w)&&(P=h()),P}async function h(){const w=u();if(w===void 0)return!1;if(w>=22e3){const m=y();if(m)return new Promise(v=>{R.execFile(m,["--status"],p=>v(!p))})}else{const m=k();if(m)try{if((await S.Promises.stat(m)).isFile())return!0}catch{}}return!1}function u(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if(w)return parseInt(w[3])}function g(w){const m=process.env.SystemRoot;if(m){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(m,v?"Sysnative":"System32",w)}}function y(){return g("wsl.exe")}function k(){return g("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,15,2,186,52,6,5,45]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0,e.$Gp=k,e.$Hp=w,e.$Ip=m,e.$Jp=v,e.$Kp=p,e.$Lp=$,e.$Ep=(0,E.$ni)("requestService");class g{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends S.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,M.localize)(0,null),when:h.$_j.isEqualTo((0,h.$9j)(h.LogLevel.Trace)).serialize()})}async c(a,t,o){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new g(t.headers??{}));try{const n=await o();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,R.$0)(n)),n}}}e.$Fp=y;function k(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function w(d){return d.res.statusCode===204}async function m(d){return w(d)?null:(await(0,i.$Le)(d.stream)).toString()}async function v(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);return m(d)}async function p(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);if(w(d))return null;const t=(await(0,i.$Le)(d.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function $(d){l(d)}let f;function l(d){const a=u.$6n.as(P.$$n.Configuration),t=f;f={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}l(1)}),define(oe[248],ae([0,1,17,23]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=void 0;class S{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,u,g=R.CancellationToken.None){switch(h){case"request":return this.a.request(u[0],g).then(async({res:y,stream:k})=>{const w=await(0,i.$Le)(k);return[{statusCode:y.statusCode,headers:y.headers},w]});case"resolveProxy":return this.a.resolveProxy(u[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Jr=S;class M{constructor(E){this.a=E}async request(E,h){const[u,g]=await this.a.call("request",[E],h);return{res:u,stream:(0,i.$Ne)(g)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Kr=M}),define(oe[249],ae([0,1,250,12]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=M;function S(P,E){return P.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:P.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(P,E,h={}){const u=(0,i.parse)(P),g=h.proxyUrl||S(u,E);if(!g)return null;const y=(0,i.parse)(g);if(!/^https?:$/.test(y.protocol||""))return null;const k={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,R.$7f)(h.strictSSL)?h.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((w,m)=>{Q(["http-proxy-agent"],w,m)})).HttpProxyAgent(g,k):new(await new Promise((w,m)=>{Q(["https-proxy-agent"],w,m)})).HttpsProxyAgent(g,k)}}),define(oe[251],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=void 0,e.$Fbc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Gbc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Hbc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[95],ae([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=v;let m;async function v($,f,l,d){return l["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$rm)(d)&&!l["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$rm)(d)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new M.$je;let s=1e4;const n=$.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(s=(0,w.$sm)(n,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),t(new Error((0,S.localize)(0,null)))},s);try{a(await p(f,o.token))}catch(c){!(0,E.$4)(c)&&!o.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,P.$$i)(c)))):a({})}finally{clearTimeout(r),o.dispose()}})),m)}async function p($,f){const l=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",l);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",d);const a=(0,u.$Jg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const s=await(0,g.$hm)(h.OS,o);return $.trace("getUnixShellEnvironment#shell",s),new Promise((n,r)=>{if(f.isCancellationRequested)return r(new E.$5);const c=(0,R.$oc)(s);let b,I;const D="";/^pwsh(-preview)?$/.test(c)?(b=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,I=["-Login","-Command"]):c==="nu"?(b=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,I=["-i","-l","-c"]):c==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,I=["-i","-l","-c"]):(b=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"||c==="csh"?I=["-ic"]:I=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),b);const j=(0,i.spawn)(s,[...I,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(j.kill(),r(new E.$5))),j.on("error",W=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,P.$$i)(W)),r(W)});const A=[];j.stdout.on("data",W=>A.push(W));const C=[];j.stderr.on("data",W=>C.push(W)),j.on("close",(W,T)=>{const N=Buffer.concat(A).toString("utf8");$.trace("getUnixShellEnvironment#raw",N);const U=Buffer.concat(C).toString("utf8");if(U.trim()&&$.trace("getUnixShellEnvironment#stderr",U),W||T)return r(new Error((0,S.localize)(2,null,W,T)));const ue=t.exec(N),ie=ue?ue[1]:"{}";try{const le=JSON.parse(ie);l?le.ELECTRON_RUN_AS_NODE=l:delete le.ELECTRON_RUN_AS_NODE,d?le.ELECTRON_NO_ATTACH_CONSOLE=d:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",le),n(le)}catch(le){$.error("getUnixShellEnvironment#errorCaught",(0,P.$$i)(le)),r(le)}})})}}),define(oe[252],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const M=await this.c();if(M){const P=String(i.a++);return this.b.set(P,M),{id:P,data:M.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,M){if(!S.id)return!0;const P=this.b.get(S.id);if(!P)return!1;this.b.delete(S.id);try{return P.validate(M)==="ok"}catch{return!1}finally{P.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$z0b=i}),define(oe[96],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=void 0,e.$Fl="signService",e.$Gl=(0,i.$ni)(e.$Fl)}),define(oe[253],ae([0,1,252]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class R extends i.$z0b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(P=>new P.signer().sign(M))}h(){return new Promise((M,P)=>Q(["vsda"],M,P))}}e.$vcc=R}),define(oe[34],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=void 0,e.$0P=(0,i.$ni)("stateReadService"),e.$$P=(0,i.$ni)("stateService")}),define(oe[125],ae([0,1,8,17,2,12,38,16,5]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.$aQ=e.$_P=e.SaveStrategy=void 0;var u;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class g extends S.$Uc{constructor(m,v,p,$){super(),this.h=m,this.j=v,this.m=p,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new i.$lh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,v){const p=this.a[m];return(0,M.$0f)(p)?v:p}setItem(m,v){this.setItems([{key:m,data:v}])}setItems(m){let v=!1;for(const{key:p,data:$}of m)this.a[p]!==$&&((0,M.$0f)($)?(0,M.$8f)(this.a[p])||(this.a[p]=void 0,v=!0):(this.a[p]=$,v=!0));v&&this.s()}removeItem(m){(0,M.$8f)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,R.$ze.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$_P=g;let y=class extends S.$Uc{constructor(m,v,p,$){super(),this.a=this.B(new g(v.stateResource,m,p,$))}async init(){await this.a.init()}getItem(m,v){return this.a.getItem(m,v)}};e.$aQ=y,e.$aQ=y=Ee([ne(1,P.$ui),ne(2,h.$Tj),ne(3,E.$Tk)],y);class k extends y{setItem(m,v){this.a.setItem(m,v)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$bQ=k}),define(oe[126],ae([0,1,4,36,33]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=P,e.$8o=E;function M(h){if(i.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function P(h,u,g,y,k,w,m,v,p){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=m,$.sessionID=(0,S.$Jg)()+Date.now(),$.commitHash=y,$.version=k,$["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,i.$h)(i.$u),$["common.nodePlatform"]=R.$ec,$["common.nodeArch"]=g,$["common.product"]=p||"desktop",v&&($["common.msftInternal"]=v);let f=0;const l=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),i.$l&&($["common.snap"]="true");const d=M(u);return d&&($["common.platformDetail"]=d),$}function E(h){const u=R.env.USERDNSDOMAIN;if(!u)return!1;const g=u.toLowerCase();return h.some(y=>g===y)}}),define(oe[28],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,i.$ni)("telemetryService"),e.$Tl=(0,i.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var S;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(oe[254],ae([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0,e.$ss=$,e.$ts=l,e.$us=d;const p=new Map;async function $(t,o){const s=`${t}::${o.join(":")}`,n=p.get(s);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,b=new Map,I=2e4;function D(A,C,W,T){const N=C.substring(A.length+1);return R.Promises.withAsyncBody(async U=>{let ue;try{ue=await g.Promises.readdir(C,{withFileTypes:!0})}catch{U();return}if(T.count>=I){T.count+=ue.length,T.maxReached=!0,U();return}let ie=ue.length;if(ie===0){U();return}let le=ue;T.count+ue.length>I&&(T.maxReached=!0,ie=I-T.count,le=ue.slice(0,ie)),T.count+=ue.length;for(const Y of le)if(Y.isDirectory()){if(W.includes(Y.name)||await D(A,(0,P.$kc)(C,Y.name),W,T),--ie===0){U();return}}else{const K=Y.name.lastIndexOf(".");if(K>=0){const B=Y.name.substring(K+1);B&&c.set(B,(c.get(B)??0)+1)}for(const B of r)B.relativePathPattern?.test(N)!==!1&&B.filePattern.test(Y.name)&&b.set(B.tag,(b.get(B.tag)??0)+1);if(--ie===0){U();return}}})}const j=R.Promises.withAsyncBody(async A=>{const C={count:0,maxReached:!1};await D(t,t,o,C);const W=await d(t);A({configFiles:f(b),fileTypes:f(c),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:W})});return p.set(s,j),j}function f(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function l(){const t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/w.$pl.GB).toFixed(2)}GB (${(i.freemem()/w.$pl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$vn.value()*100)}%`},o=i.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function d(t){try{const o=new Map,s=(0,P.$kc)(t,".vscode","launch.json"),n=await g.Promises.readFile(s),r=[],c=(0,S.$An)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$Jn)(c)==="object"&&c.configurations)for(const b of c.configurations){const I=b.type;I&&(o.has(I)?o.set(I,o.get(I)+1):o.set(I,1))}return f(o)}catch{return[]}}let a=class{constructor(o,s){this.c=o,this.d=s}f(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}g(o){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const n=i.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(i.totalmem()/w.$pl.GB).toFixed(2)}GB (${(i.freemem()/w.$pl.GB).toFixed(2)}GB free)`),E.$i||s.push(`Load (avg):       ${i.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(u.$vn.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,y.$rs)(o.mainPID),this.k(o)]).then(async n=>{let[r,c]=n,b=this.m(o,r);return s.forEach(I=>{if((0,k.$8m)(I))b+=`
${I.errorMessage}`,c+=`
${I.errorMessage}`;else if(b+=`

Remote: ${I.hostName}`,I.processes&&(b+=`
${this.m(o,I.processes)}`),I.workspaceMetadata){c+=`
|  Remote: ${I.hostName}`;for(const D of Object.keys(I.workspaceMetadata)){const j=I.workspaceMetadata[D];let A=`${j.fileCount} files`;j.maxFilesReached&&(A=`more than ${A}`),c+=`|    Folder (${D}): ${A}`,c+=this.h(j)}}}),{processInfo:b,workspaceInfo:c}})}async getSystemInfo(o,s){const{memory:n,vmHint:r,os:c,cpus:b}=l(),I={os:c,memory:n,cpus:b,vmHint:r,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return E.$i||(I.load=`${i.loadavg().map(D=>Math.round(D)).join(", ")}`),E.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(o,s){const n=[];return(0,y.$rs)(o.mainPID).then(async r=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,r)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),s.forEach(c=>{if((0,k.$8m)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.f(c.machineInfo)),c.processes&&n.push(this.m(o,c.processes)),c.workspaceMetadata)for(const b of Object.keys(c.workspaceMetadata)){const I=c.workspaceMetadata[b];let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),n.push(`Folder (${b}): ${D}`),n.push(this.h(I))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const s=[];let r=0;const c=(j,A)=>{const C=` ${j}(${A})`;r+C.length>60?(s.push(b),b="|                 ",r=b.length):r+=C.length,b+=C};let b="|      File types:";const I=10,D=o.fileTypes.length>I?I:o.fileTypes.length;for(let j=0;j<D;j++){const A=o.fileTypes[j];c(A.name,A.count)}if(s.push(b),o.configFiles.length>=0&&(b="|      Conf files:",r=0,o.configFiles.forEach(j=>{c(j.name,j.count)}),s.push(b)),o.launchConfigFiles.length>0){let j="|      Launch Configs:";o.launchConfigFiles.forEach(A=>{const C=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;j+=C}),s.push(j)}return s.join(`
`)}j(o){const s=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const s=[],n=[];return o.windows.forEach(r=>{r.folderURIs.length===0||r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const b=h.URI.revive(c);if(b.scheme===M.Schemas.file){const I=b.fsPath;n.push($(I,["node_modules",".git"]).then(D=>{let j=`${D.fileCount} files`;D.maxFilesReached&&(j=`more than ${j}`),s.push(`|    Folder (${(0,P.$oc)(I)}): ${j}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${I} (${D.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(o,s){const n=new Map;o.windows.forEach(c=>n.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:b})=>n.set(c,b));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.n(o.mainPID,n,r,s,0),r.join(`
`)}n(o,s,n,r,c){const b=c===0;let I;b?I=r.pid===o?`${this.d.applicationName} main`:"remote agent":s.has(r.pid)?I=s.get(r.pid):I=`${"  ".repeat(c)} ${r.name}`;const D=process.platform==="win32"?r.mem:i.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(D/w.$pl.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(r.children)&&r.children.forEach(j=>this.n(o,s,n,j,c+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:n}of o.folders){const r=h.URI.revive(n);if(r.scheme!==M.Schemas.file)continue;const c=r.fsPath;try{(await $(c,["node_modules",".git"])).fileTypes.forEach(I=>s.add(I.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const n=h.URI.revive(s);if(n.scheme!==M.Schemas.file)continue;const r=n.fsPath;try{const c=await $(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),c.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),c.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$vs=a,e.$vs=a=Ee([ne(0,v.$Sl),ne(1,m.$ak)],a)}),define(oe[255],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;class i{constructor(M){this.b=M}listen(M,P){throw new Error(`Event not found: ${P}`)}call(M,P,{eventName:E,data:h}){return this.b.forEach(u=>u.log(E,h)),Promise.resolve(null)}}e.$Kbc=i;class R{constructor(M){this.b=M}log(M,P){return this.b.call("log",{eventName:M,data:P}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Lbc=R}),define(oe[54],ae([0,1,35,12,68,126,28]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=g,e.$ep=y,e.$fp=k,e.$gp=w,e.$hp=v,e.$ip=$,e.$jp=f,e.$kp=a;class E{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$9o=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=h,e.$$o=new h;class u{async publicLog(o,s,n){}async publicLogError(o,s,n){}}e.$_o=u,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function g(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function k(t){const o=t.getValue(P.$1l),s=t.getValue(P.$2l);if(t.getValue(P.$3l)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const o={},s={},n={};p(t,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const c=n[r];typeof c=="number"?s[r]=c:typeof c=="boolean"?s[r]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${c.length}`),o[r]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(o[r]=c)}return{properties:o,measurements:s}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,S.$zm)(t);return m.has(o)?o:"other"}function p(t,o,s=0,n){if(t)for(const r of Object.getOwnPropertyNames(t)){const c=t[r],b=n?n+r:r;Array.isArray(c)?o[b]=(0,i.$Yn)(c):c instanceof Date?o[b]=c.toISOString():(0,R.$3f)(c)?s<2?p(c,o,s+1,b+"."):o[b]=(0,i.$Yn)(c):o[b]=c}}function $(t,o){const s=t.msftInternalDomains||[],n=o.getValue("telemetry.internalTesting");return(0,M.$8o)(s)||n}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function l(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const n=[];for(const I of o)for(;;){const D=I.exec(t);if(!D)break;n.push([D.index,I.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(s="";;){const I=c.exec(t);if(!I)break;const D=n.some(([j,A])=>I.index<A&&j<c.lastIndex);!r.test(I[0])&&!D&&(s+=t.substring(b,I.index)+"<REDACTED: user-file-path>",b=c.lastIndex)}return b<t.length&&(s+=t.substr(b)),s}function d(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,o){return(0,i.$Vn)(t,s=>{if(s instanceof E||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let n=s.replaceAll("%20"," ");n=l(n,o);for(const r of o)n=n.replace(r,"");return n=d(n),n}})}}),define(oe[127],ae([0,1,25,121,124,4,7,15,36,54]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=g,e.$np=m,e.$op=v,e.$pp=p,e.$qp=$,e.$rp=f,e.$sp=l,e.$tp=d,e.$vp=a,e.$wp=o;function g(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,i.$lf)(s.id,n.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(n){const r=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new k(n.identifier,r,c)}static parse(n){const r=y.exec(n);return r&&r[1]&&r[2]?new k({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,c="undefined"){this.version=r,this.targetPlatform=c,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof k?g(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$mp=k;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(s){const n=w.exec(s);return n&&n[1]?[p(n[1]),n[2]]:[p(s),void 0]}function v(s,n){return`${s}.${n}`}function p(s){return s.toLowerCase()}function $(s,n){return p(v(s??S.$Em,n))}function f(s,n){const r=[],c=b=>{for(const I of r)if(I.some(D=>g(n(D),n(b))))return I;return null};for(const b of s){const I=c(b);I?I.push(b):r.push([b])}return r}function l(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function d(s){return{id:new u.$9o(s.identifier.id),name:new u.$9o(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$up=new S.$Im("pprice.better-merge");function a(s,n){const r=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const b=c.shift();if(b&&r.every(I=>!g(I.identifier,{id:b}))){const I=s.filter(D=>g(D.identifier,{id:b}));I.length===1&&(r.push(I[0]),c.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function t(s,n){if(!M.$k)return!1;let r;try{r=(await s.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){n.debug("Error while getting the os-release file.",(0,E.$0)(b))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,n){const r=await t(s,n),c=(0,R.$So)(r?"alpine":M.$u,h.$fc);return n.debug("ComputeTargetPlatform:",c),c}}),define(oe[256],ae([0,1,209,54]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=S;async function S(M,P,E,h,u,g,y){const k={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${P.nameShort})`};if((0,R.$dp)(P,E)&&(0,R.$fp)(h)===3){const w=await(0,i.$Xp)(E,u,g);k["X-Market-User-Id"]=w,k["VSCode-SessionId"]=y.machineId||w}return k}}),define(oe[257],ae([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,f,l){this.k=f,this.l=l,this.d={},this.i=new i.$Tc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,M.$5e)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$5e)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(k.$1l)||d.affectsConfiguration(k.$3l)||d.affectsConfiguration(k.$2l))&&this.m()}))}setExperimentProperty($,f){this.d[$]=f}m(){let $=(0,w.$fp)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const l=f.usage?3:f.error?2:0;$=Math.min($,l)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,f,l){this.g<f||(l=(0,R.$Wn)(l,this.d),l=(0,w.$kp)(l,this.j),l=(0,R.$Wn)(l,this.c),this.b.forEach(d=>d.log($,l)))}publicLog($,f){this.n($,3,f)}publicLog2($,f){this.publicLog($,f)}publicLogError($,f){this.h&&this.n($,2,f)}publicLogError2($,f){this.publicLogError($,f)}};e.$Or=m,e.$Or=m=Ee([ne(1,E.$Ti),ne(2,g.$ak)],m);function v(){const p=(0,P.localize)(0,null,u.default.nameLong),$=u.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=S.$o?"":(0,P.localize)(3,null),l=(0,P.localize)(4,null),d=(0,P.localize)(5,null),a=(0,P.localize)(6,null),t=(0,P.localize)(7,null),o=`
|       | ${l} | ${d} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,P.localize)(8,null);return`
${p} ${$} ${f}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}y.$6n.as(h.$$n.Configuration).registerConfiguration({id:k.$Zl,order:1,type:"object",title:(0,P.localize)(9,null),properties:{[k.$1l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$6n.as(h.$$n.Configuration).registerConfiguration({id:k.$Zl,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[k.$3l]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,P.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,P.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${k.$1l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[258],ae([0,1,4,89,28]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=M,e.$bcc=P;async function M(E,h){let u=E.getItem(S.$Xl);return(typeof u!="string"||i.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,R.$wn)(h.error.bind(h))),u}async function P(E,h){let u=E.getItem(S.$Yl);return typeof u!="string"&&(u=await(0,R.$xn)(h.error.bind(h))),u}}),define(oe[259],ae([0,1,28,258]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=S,e.$dcc=M;async function S(P,E){const h=await(0,R.$acc)(P,E);return P.setItem(i.$Xl,h),h}async function M(P,E){const h=await(0,R.$bcc)(P,E);return P.setItem(i.$Yl,h),h}}),define(oe[128],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(oe[260],ae([0,1,4,128]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;const S=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((y,k)=>{this.d(y,k);const w=y.map.entries();let m=w.next();for(;!m.done;){const v=m.value[1],p=m.value[0];let $=this.a.get(p);if($||($=[],this.a.set(p,$)),$.length>0&&$[0].type===R.EnvironmentVariableMutatorType.Replace){m=w.next();continue}const f={extensionIdentifier:k,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,$.unshift(f),m=w.next()}})}async applyToProcessEnvironment(g,y,k){let w;i.$i&&(w={},Object.keys(g).forEach(m=>w[m.toLowerCase()]=m));for(const[m,v]of this.getVariableMap(y)){const p=i.$i&&w[m.toLowerCase()]||m;for(const $ of v){const f=k?await k($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case R.EnvironmentVariableMutatorType.Append:g[p]=(g[p]||"")+f;break;case R.EnvironmentVariableMutatorType.Prepend:g[p]=f+(g[p]||"");break;case R.EnvironmentVariableMutatorType.Replace:g[p]=f;break}if($.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${S.get($.type)}`;g[l]=(g[l]?g[l]+":":"")+m+"="+this.c(f)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,y){const k=new Map,w=new Map,m=new Map;if(g.getVariableMap(y).forEach((v,p)=>{const $=this.getVariableMap(y).get(p),f=E(v,$);f&&k.set(p,f)}),this.getVariableMap(y).forEach((v,p)=>{const $=g.getVariableMap(y).get(p),f=E(v,$);f&&m.set(p,f)}),this.getVariableMap(y).forEach((v,p)=>{const $=g.getVariableMap(y).get(p),f=h(v,$);f&&w.set(p,f)}),!(k.size===0&&w.size===0&&m.size===0))return{added:k,changed:w,removed:m}}getVariableMap(g){const y=new Map;for(const k of this.a.values()){const w=k.filter(m=>P(m,g));w.length>0&&y.set(w[0].variable,w)}return y}getDescriptionMap(g){const y=new Map;for(const k of this.b.values()){const w=k.filter(m=>P(m,g,!0));for(const m of w)y.set(m.extensionIdentifier,m.description)}return y}d(g,y){if(!g.descriptionMap)return;const k=g.descriptionMap.entries();let w=k.next();for(;!w.done;){const m=w.value[1],v=w.value[0];let p=this.b.get(v);p||(p=[],this.b.set(v,p));const $={extensionIdentifier:y,scope:m.scope,description:m.description};$.scope||delete $.scope,p.push($),w=k.next()}}}e.$fs=M;function P(u,g,y=!1){return u.scope?!!(u.scope.workspaceFolder&&g?.workspaceFolder&&u.scope.workspaceFolder.index===g.workspaceFolder.index):y?g===u.scope:!0}function E(u,g){if(!g)return u;const y=new Set;g.forEach(w=>y.add(w.extensionIdentifier));const k=[];return u.forEach(w=>{y.has(w.extensionIdentifier)||k.push(w)}),k.length===0?void 0:k}function h(u,g){if(!g)return;const y=new Map;g.forEach(w=>y.set(w.extensionIdentifier,w));const k=[];return u.forEach(w=>{const m=y.get(w.extensionIdentifier);m&&(w.type!==m.type||w.value!==m.value||w.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(oe[261],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=i,e.$as=R,e.$bs=S,e.$cs=M,e.$ds=P,e.$es=E;function i(h){return[...h.entries()]}function R(h){return h?[...h.entries()]:[]}function S(h){return new Map(h)}function M(h){return new Map(h??[])}function P(h){return Array.from(h.entries()).map(u=>[u[0],i(u[1].map),R(u[1].descriptionMap)])}function E(h){return new Map(h.map(u=>[u[0],{map:S(u[1]),descriptionMap:M(u[2])}]))}}),define(oe[262],ae([0,1,8,23,3,2,5]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;let E=class extends M.$Uc{constructor(u,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$_d),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,M.$Sc)(()=>{for(const y of this.f.values())(0,M.$Pc)(y)}))}createRequest(u){return new Promise((g,y)=>{const k=++this.a;this.c.set(k,g),this.g.fire({requestId:k,...u});const w=new R.$je;(0,i.$oh)(this.b,w.token).then(()=>y(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,M.$Sc)(()=>w.cancel())])})}acceptReply(u,g){const y=this.c.get(u);y?(this.c.delete(u),(0,M.$Pc)(this.f.get(u)||[]),this.f.delete(u),y(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$3r=E,e.$3r=E=Ee([ne(1,P.$Tj)],E)}),define(oe[129],ae([0,1,6,118,45]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.$Wr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Vr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Ur=void 0,e.$Ur=new R.$Ej("terminalTabFocusMode",!1,!0);var M;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var P;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(P||(e.TerminalSettingId=P={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var u;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var g;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Vr=(0,i.$ni)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var w;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var $;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var l;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$Wr={Backend:"workbench.contributions.terminal.processBackend"};class d{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$6n.add(e.$Wr.Backend,new d),e.$Xr=(0,i.$ni)("localPtyService"),e.$Yr=(0,i.$ni)("terminalLogService")}),define(oe[263],ae([0,1,75,7,190,106]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=P,e.$5r=u,e.$6r=g,e.$7r=y;function P(k,w){const m=[{name:null,description:(0,S.localize)(0,null)}];return m.push(...k.map(v=>({name:v.profileName,description:E(v)}))),w&&m.push(...w.map(v=>({name:v.title,description:h(v)}))),{values:m.map(v=>v.name),markdownDescriptions:m.map(v=>v.description)}}function E(k){let w=`$(${M.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:i.$Mj.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?w+=`
- args: "${k.args}"`:w+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&(w+=`
- overrideName: ${k.overrideName}`),k.color&&(w+=`
- color: ${k.color}`),k.env&&(w+=`
- env: ${JSON.stringify(k.env)}`),w}function h(k){return`$(${M.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:i.$Mj.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function u(k,w){if(!k&&!w)return!0;if(typeof k=="string"&&typeof w=="string")return k===w;if(Array.isArray(k)&&Array.isArray(w)){if(k.length!==w.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==w[m])return!1;return!0}return!1}function g(k,w){if(!k&&!w)return!0;if(!k||!w)return!1;if(M.ThemeIcon.isThemeIcon(k)&&M.ThemeIcon.isThemeIcon(w))return k.id===w.id&&k.color===w.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof w=="object"&&"light"in w&&"dark"in w){const m=k,v=w;if((R.URI.isUri(m.light)||y(m.light))&&(R.URI.isUri(m.dark)||y(m.dark))&&(R.URI.isUri(v.light)||y(v.light))&&(R.URI.isUri(v.dark)||y(v.dark)))return m.light.path===v.light.path&&m.dark.path===v.dark.path}if(R.URI.isUri(k)&&R.URI.isUri(w)||y(k)||y(w)){const m=k,v=w;return m.path===v.path&&m.scheme===v.scheme}return!1}function y(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}}),define(oe[264],ae([0,1,75,4,189,52,45,263]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0,e.$0r=w,e.$$r=v,e.$8r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$9r={type:"string",enum:Array.from((0,i.$Kj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,i.$Kj)(),p=>`$(${p.id})`)};const h={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$9r},color:{description:(0,S.localize)(3,null),...e.$8r},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},g={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function y(p){const $=p===2?"linux":p===1?"osx":"windows";return(0,S.localize)(7,null,(0,R.$h)(p),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...h}},{type:"null"},u]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...h}},{type:"null"},u]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...h}},{type:"null"},u]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function w(){P.$6n.as(M.$$n.Configuration).registerConfiguration(k),v()}let m;function v(p,$){const f=P.$6n.as(M.$$n.Configuration);let l;p&&(l=(0,E.$4r)(p?.profiles,$));const d=m;m={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?l?.values:void 0,markdownEnumDescriptions:p?.os===3?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?l?.values:void 0,markdownEnumDescriptions:p?.os===2?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?l?.values:void 0,markdownEnumDescriptions:p?.os===1?l?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:d?[d]:[]})}}),define(oe[265],ae([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=m,e.$hs=v,e.$is=p;function m(){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let b=0;return c&&c.length===4&&(b=parseInt(c[3])),b}async function v(c,b,I,D=E.env,j=g.Promises.exists){if(M.$jc(c))return await j(c)?c:void 0;if(b===void 0&&(b=E.cwd()),M.$nc(c)!=="."){const T=M.$kc(b,c);return await j(T)?T:void 0}const C=(0,S.$1n)(D,"PATH");if(I===void 0&&(0,u.$1f)(C)&&(I=C.split(M.$uc)),I===void 0||I.length===0){const T=M.$kc(b,c);return await j(T)?T:void 0}for(const T of I){let N;if(M.$jc(T)?N=M.$kc(T,c):N=M.$kc(b,T,c),await j(N))return N;if(P.$i){let U=N+".com";if(await j(U)||(U=N+".exe",await j(U)))return U}}const W=M.$kc(b,c);return await j(W)?W:void 0}function p(c,b,I,D,j){const A=P.$i&&(!b.windowsEnableConpty||m()<18309);if(!b.shellIntegration.enabled||!c.executable||c.isFeatureTerminal&&!c.forceShellIntegration||c.ignoreShellIntegration||A)return;const C=c.args,W=E.$ec==="win32"?M.$oc(c.executable).toLowerCase():M.$oc(c.executable),T=M.$nc(R.$Hg.asFileUri("").fsPath);let N;const U={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(U.VSCODE_NONCE=b.shellIntegration.nonce),P.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!C||n(C)?N=l.get(f.WindowsPwsh):s(C)&&(N=l.get(f.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,h.$1e)(N[N.length-1],T,""),b.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),{newArgs:N,envMixin:U}):void 0;if(W==="bash.exe")return!C||C.length===0?N=l.get(f.Bash):r(C)&&(U.VSCODE_SHELL_LOGIN="1",$(b,U),N=l.get(f.Bash)),N?(N=[...N],N[N.length-1]=(0,h.$1e)(N[N.length-1],T),{newArgs:N,envMixin:U}):void 0;D.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args);return}switch(W){case"bash":return!C||C.length===0?N=l.get(f.Bash):r(C)&&(U.VSCODE_SHELL_LOGIN="1",$(b,U),N=l.get(f.Bash)),N?(N=[...N],N[N.length-1]=(0,h.$1e)(N[N.length-1],T),{newArgs:N,envMixin:U}):void 0;case"fish":{const ue=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=M.$kc(T,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${ue}:${ie}`,$(b,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!C||n(C)?N=l.get(f.Pwsh):s(C)&&(N=l.get(f.PwshLogin)),N?(b.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),N=[...N],N[N.length-1]=(0,h.$1e)(N[N.length-1],T,""),{newArgs:N,envMixin:U}):void 0;case"zsh":{if(!C||C.length===0?N=l.get(f.Zsh):r(C)?(N=l.get(f.ZshLogin),$(b,U)):(C===l.get(f.Zsh)||C===l.get(f.ZshLogin))&&(N=C),!N)return;N=[...N],N[N.length-1]=(0,h.$1e)(N[N.length-1],T);let ue;try{ue=i.userInfo().username}catch{ue="unknown"}const ie=M.$kc(i.tmpdir(),`${ue}-${j.applicationName}-zsh`);U.ZDOTDIR=ie;const le=I?.ZDOTDIR??i.homedir()??"~";U.USER_ZDOTDIR=le;const Y=[];return Y.push({source:M.$kc(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$kc(ie,".zshrc")}),Y.push({source:M.$kc(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$kc(ie,".zprofile")}),Y.push({source:M.$kc(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$kc(ie,".zshenv")}),Y.push({source:M.$kc(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$kc(ie,".zlogin")}),{newArgs:N,envMixin:U,filesToCopy:Y}}}D.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args)}function $(c,b){if(P.$j&&c.environmentVariableCollections){const I=(0,k.$es)(c.environmentVariableCollections),j=new w.$fs(I).getVariableMap({workspaceFolder:c.workspaceFolder}).get("PATH"),A=[];if(j)for(const C of j)C.type===y.EnvironmentVariableMutatorType.Prepend&&A.push(C.value);A.length>0&&(b.VSCODE_PATH_PREFIX=A.join(""))}}var f;(function(c){c.WindowsPwsh="windows-pwsh",c.WindowsPwshLogin="windows-pwsh-login",c.Pwsh="pwsh",c.PwshLogin="pwsh-login",c.Zsh="zsh",c.ZshLogin="zsh-login",c.Bash="bash"})(f||(f={}));const l=new Map;l.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(f.Zsh,["-i"]),l.set(f.ZshLogin,["-il"]),l.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const d=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function s(c){return typeof c=="string"?d.includes(c.toLowerCase()):c.length===1&&d.includes(c[0].toLowerCase())||c.length===2&&(d.includes(c[0].toLowerCase())||d.includes(c[1].toLowerCase()))&&(o.includes(c[0].toLowerCase())||o.includes(c[1].toLowerCase()))}function n(c){return typeof c=="string"?o.includes(c.toLowerCase()):c.length===0||c?.length===1&&o.includes(c[0].toLowerCase())}function r(c){return typeof c!="string"&&(c=c.filter(b=>!t.includes(b.toLowerCase()))),c==="string"&&a.includes(c.toLowerCase())||typeof c!="string"&&c.length===1&&a.includes(c[0].toLowerCase())}}),define(oe[266],ae([0,1,49,75,9,4,12,21,110,265,117]),function(Q,e,i,R,S,M,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=m;var y;(function(c){c.UnixShellsPath="/etc/shells"})(y||(y={}));let k,w=!0;function m(c,b,I,D,j=process.env,A,C,W,T){return A=A||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},M.$i?v(I,A,j,C,D.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:D.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:D.getValue("terminal.integrated.defaultProfile.windows"),T,W):s(A,C,I,c&&typeof c=="object"?{...c}:D.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:D.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,W,j)}async function v(c,b,I,D,j,A,C,W,T){const N=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${N?"Sysnative":"System32"}`;let ue=!1;(0,u.$gs)()>=16299&&(ue=!0),await l(W);const ie=new Map;if(c){ie.set("PowerShell",{source:"PowerShell",icon:R.$Mj.terminalPowershell,isAutoDetected:!0}),ie.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Mj.terminalPowershell,isAutoDetected:!0}),ie.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ie.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:R.$Mj.terminalCmd,isAutoDetected:!0}),ie.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ie.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:R.$Mj.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ie.set("Cmder",{path:`${U}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}n(A,ie);const le=await p(ie.entries(),C,b,I,D,T);if(c&&j)try{const Y=await t(`${U}\\${ue?"wsl":"bash"}.exe`,C);for(const K of Y)(!A||!(K.profileName in A))&&le.push(K)}catch{w&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),w=!1)}return le}async function p(c,b,I,D=process.env,j,A){const C=[];for(const[W,T]of c)C.push($(W,T,b,I,D,j,A));return(await Promise.all(C)).filter(W=>!!W)}async function $(c,b,I,D,j=process.env,A,C){if(b===null)return;let W,T,N;if("source"in b&&!("path"in b)){const le=k?.get(b.source);if(!le)return;W=le.paths,T=b.args||le.args,b.icon?N=f(b.icon):le.icon&&(N=le.icon)}else W=Array.isArray(b.path)?b.path:[b.path],T=M.$i||Array.isArray(b.args)?b.args:void 0,N=f(b.icon);let U;if(C){const le=W.map(K=>typeof K=="string"?K:K.path),Y=await C(le);U=new Array(W.length);for(let K=0;K<W.length;K++)typeof W[K]=="string"?U[K]=Y[K]:U[K]={path:Y[K],isUnsafe:!0}}else U=W.slice();let ue;if(b.requiresPath){let le;if((0,P.$1f)(b.requiresPath)?le=b.requiresPath:(le=b.requiresPath.path,b.requiresPath.isUnsafe&&(ue=le)),!await D.existsFile(le))return}const ie=await r(c,I,U,D,j,T,b.env,b.overrideName,b.isAutoDetected,ue);if(!ie){A?.debug("Terminal profile not validated",c,W);return}return ie.isAutoDetected=b.isAutoDetected,ie.icon=N,ie.color=b.color,ie}function f(c){return typeof c=="string"?{id:c}:c}async function l(c){if(k&&!c)return;const[b,I]=await Promise.all([d(),c||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:I,icon:R.$Mj.terminalPowershell})}async function d(){const c=new Set,b=await(0,u.$hs)("git.exe");if(b){const j=(0,g.dirname)(b);c.add((0,g.resolve)(j,"../.."))}function I(j,A){A&&j.add(A)}I(c,process.env.ProgramW6432),I(c,process.env.ProgramFiles),I(c,process.env["ProgramFiles(X86)"]),I(c,`${process.env.LocalAppData}\\Program`);const D=[];for(const j of c)D.push(`${j}\\Git\\bin\\bash.exe`,`${j}\\Git\\usr\\bin\\bash.exe`,`${j}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const c=[];for await(const b of(0,h.$bm)())c.push(b.exePath);return c}async function t(c,b){const I=[],D=await new Promise((C,W)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,N)=>{if(T)return W("Problem occurred when getting wsl distros");C(N)})});if(!D)return[];const j=new RegExp(/[\r?\n]/),A=D.split(j).filter(C=>C.trim().length>0&&C!=="");for(const C of A){if(C===""||C.startsWith("docker-desktop"))continue;const W=`${C} (WSL)`,T={profileName:W,path:c,args:["-d",`${C}`],isDefault:W===b,icon:o(C),isAutoDetected:!1};I.push(T)}return I}function o(c){return c.includes("Ubuntu")?R.$Mj.terminalUbuntu:c.includes("Debian")?R.$Mj.terminalDebian:R.$Mj.terminalLinux}async function s(c,b,I,D,j,A,C,W){const T=new Map;if(I&&await c.existsFile("/etc/shells")){const N=(await c.readFile("/etc/shells")).toString(),U=(A||N.split(`
`)).map(ie=>{const le=ie.indexOf("#");return le===-1?ie:ie.substring(0,le)}).filter(ie=>ie.trim().length>0),ue=new Map;for(const ie of U){let le=(0,S.$oc)(ie),Y=ue.get(le)||0;Y++,Y>1&&(le=`${le} (${Y})`),ue.set(le,Y),T.set(le,{path:ie,isAutoDetected:!0})}}return n(D,T),await p(T.entries(),j,c,W,b,C)}function n(c,b){if(c)for(const[I,D]of Object.entries(c))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?b.delete(I):(D.icon=D.icon||b.get(I)?.icon,b.set(I,D))}async function r(c,b,I,D,j,A,C,W,T,N){if(I.length===0)return Promise.resolve(void 0);const U=I.shift();if(U==="")return r(c,b,I,D,j,A,C,W,T);const ue=typeof U!="string"&&U.isUnsafe,ie=typeof U=="string"?U:U.path,le={profileName:c,path:ie,args:A,env:C,overrideName:W,isAutoDetected:T,isDefault:c===b,isUnsafePath:ue,requiresUnsafePath:N};if((0,S.$oc)(ie)===ie){const K=j.PATH?j.PATH.split(S.$uc):void 0,B=await(0,u.$hs)(ie,void 0,K,void 0,D.existsFile);return B?(le.path=B,le.isFromPath=!0,le):r(c,b,I,D,j,A)}return await D.existsFile((0,S.$ic)(ie))?le:r(c,b,I,D,j,A,C,W,T)}}),define(oe[267],ae([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;var p;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let $=class extends R.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,d,a,t){super(),this.M=l,this.N=d,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$_d),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$_d),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$_d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$_d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$_d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$_d),this.onProcessData=this.D.event,this.F=this.B(new i.$_d),this.onProcessReady=this.F.event,this.G=this.B(new i.$_d),this.onProcessReplay=this.G.event,this.H=this.B(new i.$_d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$_d),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$_d),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$_d),this.onProcessExit=this.L.event,(0,k.$0r)(),this.B(this.M),this.B((0,R.$Sc)(()=>this.W())),this.j=this.B(new g.$3r(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&i.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,u.$xm)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),d=l.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(d.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService(d.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new h.$2r(this.P,d.getChannel(y.TerminalIpcChannels.Logger))),this.a=l,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,t]}async createProcess(l,d,a,t,o,s,n,r,c,b,I){const D=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),j=await this.f.createProcess(l,d,a,t,o,s,n,r,c,b,I);return clearTimeout(D),j}updateTitle(l,d,a){return this.f.updateTitle(l,d,a)}updateIcon(l,d,a,t){return this.f.updateIcon(l,d,a,t)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,d){return this.f.detachFromProcess(l,d)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,d){return this.f.shutdown(l,d)}input(l,d){return this.f.input(l,d)}processBinary(l,d){return this.f.processBinary(l,d)}resize(l,d,a){return this.f.resize(l,d,a)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,d){return this.f.acknowledgeDataEvent(l,d)}setUnicodeVersion(l,d){return this.f.setUnicodeVersion(l,d)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new v.$8d,d=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...d]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,d){return this.f.installAutoReply(l,d)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,m.$hm)(l??S.OS,process.env)}async getProfiles(l,d,a,t=!1){const o=await this.S();return(0,w.$js)(d,a,t,this.N,o,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,d){return this.f.getWslPath(l,d)}getRevivedPtyNewId(l,d){return this.f.getRevivedPtyNewId(l,d)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,d){return this.f.requestDetachInstance(l,d)}async acceptDetachInstanceReply(l,d){return this.f.acceptDetachInstanceReply(l,d)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,d,a){return this.f.reviveTerminalProcesses(l,d,a)}async refreshProperty(l,d){return this.f.refreshProperty(l,d)}async updateProperty(l,d,a){return this.f.updateProperty(l,d,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,d){return this.j.createRequest({workspaceId:l,originalText:d})}async acceptPtyHostResolvedVariables(l,d){this.j.acceptReply(l,d)}};e.$ks=$,e.$ks=$=Ee([ne(1,P.$Ti),ne(2,E.$Tj),ne(3,E.$Uj)],$)}),define(oe[69],ae([0,1,14,3,2,4,18,6,34]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=e.$Aac=void 0;const u="#FFFFFF",g="#1E1E1E",y="#000000",k="#FFFFFF",w="theme",m="themeBackground",v="windowSplash";e.$Aac=(0,E.$ni)("themeMainService");let p=class extends S.$Uc{constructor(f,l){super(),this.b=f,this.c=l,this.a=this.B(new R.$_d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(d=>{d.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:k;let l=this.b.getItem(m,null);if(!l)switch(this.g()){case"vs":l=u;break;case"hc-black":l=y;break;case"hc-light":l=k;break;default:l=g}return M.$j&&l.toUpperCase()===g&&(l="#171717"),l}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,l){this.b.setItems([{key:w,data:l.baseTheme},{key:m,data:l.colorInfo.background},{key:v,data:l}]),typeof f=="number"&&this.h(f,l),this.f()}h(f,l){for(const d of i.BrowserWindow.getAllWindows())if(d.id===f){d.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$Bac=p,e.$Bac=p=Ee([ne(0,h.$$P),ne(1,P.$Ti)],p)}),define(oe[130],ae([0,1,3,7,18,6,5]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$9v=e.$7v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$3v=e.$2v=void 0,e.$4v=u,e.$5v=y,e.$6v=k,e.$8v=w,e.$0v=m,e.$$v=v,e.$2v=(0,M.$ni)("tunnelService"),e.$3v=(0,M.$ni)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(h||(e.TunnelPrivacyId=h={}));function u(f){return!!f.forwardPort}var g;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(l)return{address:l[1],port:+l[2]}}function k(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const l=f.query.split("&");for(const d of l){const a=d.split("=")[1];if(/^https?:/.exec(a)){const t=y(R.URI.parse(a));if(t)return t}}}e.$7v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(f){return e.$7v.indexOf(f)>=0}e.$9v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$9v.indexOf(f)>=0}function v(f,l,d,a){if(d===1)return!1;if(d===2&&m(l)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class p{constructor(l,d,a){this.remoteAddress=l,this.localAddress=d,this.b=a,this.a=new i.$_d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_v=p;let $=class{constructor(l,d){this.k=l,this.l=d,this.a=new i.$_d,this.onTunnelOpened=this.a.event,this.b=new i.$_d,this.onTunnelClosed=this.b.event,this.c=new i.$_d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],d=Array.from(this.e.values());for(const a of d){const t=Array.from(a.values());for(const o of t){const s=await o.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:d}of l.values())await d.then(a=>typeof a!="string"?a?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,d,a,t,o){this.q(l,d,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:d,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,d){(m(l)||w(l))&&(l=e.$7v[0]);const a=this.s(l,d);if(a)return++a.refcount,a.value}openTunnel(l,d,a,t,o,s=!1,n,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${a} on local port ${o}.`);const c=this.f??l;if(!c)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(c,d,a,t,o,s,n,r);return b?b.then(I=>{if(I){if(typeof I=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,a),I}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(I);return(I.tunnelRemoteHost!==d||I.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&I.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const d=this.e.get(l.tunnelRemoteHost);if(d){const a=d.get(l.tunnelRemotePort);a&&(a.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,a))}}}}async p(l,d,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${d}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(d),t}}async closeTunnel(l,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${d} `);const a=this.e.get(l);if(a&&a.has(d)){const t=a.get(d);t.refcount=0,await this.p(l,d,t)}}q(l,d,a){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(d,{refcount:1,value:a})}async r(l,d){const a=this.e.get(l);if(a){const t=a.get(d),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete(d),a.size===0&&this.e.delete(l)}}s(l,d){const a=[l];w(l)?(a.push(...e.$7v),a.push(...e.$9v)):m(l)&&a.push(...e.$9v);const t=a.map(o=>this.e.get(o));for(const o of t){const s=o?.get(d);if(s)return s}}canTunnel(l){return!!y(l)}u(l,d,a,t,o,s,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${a} on local port ${t}.`);const r=a;this.j.add(r);const c=t===void 0?a:t,b={elevationRequired:o?this.isPortPrivileged(c):!1},I={remoteAddress:{host:d,port:a},localAddressPort:t,privacy:s,public:s?s!==h.Private:void 0,protocol:n},D=l.forwardPort(I,b);return D?(this.q(d,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),D}};e.$aw=$,e.$aw=$=Ee([ne(0,P.$Tj),ne(1,S.$Ti)],$)}),define(oe[50],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iX=e.$hX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(P){P.Uninitialized="uninitialized",P.Idle="idle",P.Disabled="disabled",P.CheckingForUpdates="checking for updates",P.AvailableForDownload="available for download",P.Downloading="downloading",P.Downloaded="downloaded",P.Updating="updating",P.Ready="ready"})(R||(e.StateType=R={}));var S;(function(P){P[P.Setup=0]="Setup",P[P.Archive=1]="Archive",P[P.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var M;(function(P){P[P.NotBuilt=0]="NotBuilt",P[P.DisabledByEnvironment=1]="DisabledByEnvironment",P[P.ManuallyDisabled=2]="ManuallyDisabled",P[P.MissingConfiguration=3]="MissingConfiguration",P[P.InvalidConfiguration=4]="InvalidConfiguration",P[P.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$hX={Uninitialized:{type:"uninitialized"},Disabled:P=>({type:"disabled",reason:P}),Idle:(P,E)=>({type:"idle",updateType:P,error:E}),CheckingForUpdates:P=>({type:"checking for updates",explicit:P}),AvailableForDownload:P=>({type:"available for download",update:P}),Downloading:{type:"downloading"},Downloaded:P=>({type:"downloaded",update:P}),Updating:P=>({type:"updating",update:P}),Ready:P=>({type:"ready",update:P})},e.$iX=(0,i.$ni)("updateService")}),define(oe[268],ae([0,1,4,191,52,45]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$6n.as(S.$$n.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:i.$i&&!i.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[269],ae([0,1,3,50]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=void 0;class S{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,u){switch(h){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${h}`)}}e.$Mbc=S;class M{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new i.$_d,this.onStateChange=this.a.event,this.b=R.$hX.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$Nbc=M}),define(oe[40],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=void 0,e.$rl=(0,i.$ni)("IUriIdentityService")}),define(oe[270],ae([0,1,40,210,16,19,142,3,2]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0;class u{static{this._clock=0}constructor(k){this.uri=k,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let g=class{constructor(k){this.g=k,this.c=new h.$Tc,this.f=2**16;const w=new Map,m=v=>{let p=w.get(v.scheme);return p===void 0&&(p=k.hasProvider(v)&&!this.g.hasCapability(v,1024),w.set(v.scheme,p)),p};this.c.add(E.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(v=>{w.delete(v.scheme)})),this.extUri=new M.$Pg(m),this.d=new P.$ns((v,p)=>this.extUri.compare(v,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,M.$2g)(k));const w=this.d.get(k);return w?w.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new u(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,v)=>m[1].time<v[1].time?1:m[1].time>v[1].time?-1:0);u._clock=0,this.d.clear();const w=this.f*.5;for(let m=0;m<w;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$os=g,e.$os=g=Ee([ne(0,S.$Tk)],g),(0,R.$ls)(i.$rl,g,1)}),define(oe[131],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$W=void 0,e.$$W=(0,i.$ni)("urlService")}),define(oe[271],ae([0,1,7]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=e.$Ubc=void 0;class R{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,u){switch(h){case"handleURL":return this.a.handleURL(i.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${h}`)}}e.$Ubc=R;class S{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$Vbc=S;class M{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,u,g){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(u)&&u.length>0){const y=i.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const k=/\bwindowId=(\d+)/.exec(y.query);if(k){const w=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,y.toString(!0));const m=new RegExp(`window:${w}`),v=E.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),m.test(p.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,u,g)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$Wbc=M}),define(oe[272],ae([0,1,8,2,7,27]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aX=e.$_W=void 0;class P extends R.$Uc{constructor(){super(...arguments),this.a=new Set}open(u,g){const y=[...this.a.values()];return(0,i.$rh)(y.map(k=>()=>k.handleURL(u,g)),void 0,!1).then(k=>k||!1)}registerHandler(u){return this.a.add(u),(0,R.$Sc)(()=>this.a.delete(u))}}e.$_W=P;let E=class extends P{constructor(u){super(),this.b=u}create(u){let{authority:g,path:y,query:k,fragment:w}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&y&&y.indexOf("/")!==0&&(y=`/${y}`),S.URI.from({scheme:this.b.urlProtocol,authority:g,path:y,query:k,fragment:w})}};e.$aX=E,e.$aX=E=Ee([ne(0,M.$ak)],E)}),define(oe[273],ae([0,1,14,8,3,2,4,7]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class h extends M.$Uc{constructor(g,y,k,w,m,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,g&&(v.trace("ElectronURLListener initialUrisToHandle:",g.map(f=>f.originalUrl)),this.a=g),P.$i){const f=w.isBuilt?[]:[`"${w.appRoot}"`];f.push("--open-url","--"),i.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const p=S.Event.map(S.Event.fromNodeEventEmitter(i.app,"open-url",(f,l)=>({event:f,url:l})),({event:f,url:l})=>(f.preventDefault(),l));this.B(p(f=>{const l=this.g(f);l&&this.c.open(l,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return E.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),g.push(y));g.length!==0&&(this.a=g,(0,R.$ph)(()=>this.h(),500,this.q))}}e.$Xbc=h}),define(oe[274],ae([0,1,3,2,16,59,32]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class E extends R.$Uc{constructor(u,g,y,k,w,m){super(),this.f=u,this.g=g,this.h=y,this.j=k,this.m=w,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$_d),this.onDidChangeFile=this.a.event,this.b=M.$ti.forUris(()=>!(this.capabilities&1024)),this.c=new P.$Cc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const u of this.j.profiles)this.c.add(u.settingsResource),this.c.add(u.keybindingsResource),this.c.add(u.tasksResource),this.c.add(u.extensionsResource)}open(u,g){return this.g.open(this.t(u),g)}close(u){return this.g.close(u)}read(u,g,y,k,w){return this.g.read(u,g,y,k,w)}write(u,g,y,k,w){return this.g.write(u,g,y,k,w)}watch(u,g){this.b.set(u,u);const y=this.g.watch(this.t(u),g);return(0,R.$Sc)(()=>{this.b.delete(u),y.dispose()})}stat(u){return this.g.stat(this.t(u))}mkdir(u){return this.g.mkdir(this.t(u))}rename(u,g,y){return this.g.rename(this.t(u),this.t(g),y)}readFile(u,g){return this.g.readFile(this.t(u),g)}readFileStream(u,g,y){return this.g.readFileStream(this.t(u),g,y)}readdir(u){return this.g.readdir(this.t(u))}enforceAtomicReadFile(u){return this.c.has(u)}writeFile(u,g,y){return this.g.writeFile(this.t(u),g,y)}enforceAtomicWriteFile(u){return this.c.has(u)?{postfix:".vsctmp"}:!1}delete(u,g){return this.g.delete(this.t(u),g)}copy(u,g,y){if((0,S.$Xk)(this.g))return this.g.copy(this.t(u),this.t(g),y);throw new Error("copy not supported")}cloneFile(u,g){if((0,S.$Yk)(this.g))return this.g.cloneFile(this.t(u),this.t(g));throw new Error("clone not supported")}s(u){const g=[];for(const y of u){if(y.resource.scheme!==this.f)continue;const k=this.u(y.resource);this.b.findSubstr(k)&&g.push({resource:k,type:y.type,cId:y.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(u){return u.with({scheme:this.f})}u(u){return u.with({scheme:this.h})}}e.$ycc=E}),define(oe[275],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0,e.$fcc="utilityProcessWorker"}),define(oe[276],ae([0,1,6]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0,e.$Ybc=(0,i.$ni)("webviewManagerService")}),define(oe[277],ae([0,1,14,2,13,7]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;class P extends R.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);i.protocol.registerFileProtocol(S.Schemas.vscodeWebview,h)}b(h,u){try{const g=M.URI.parse(h.url),y=P.a.get(g.path);if(typeof y=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${y}`,w=S.$Hg.asFileUri(k);return u({path:w.fsPath,headers:{...S.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$Zbc=P}),define(oe[55],ae([0,1,4]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$iD=void 0,e.$jD=R,e.$kD=S,e.$lD=M,e.$mD=P,e.$nD=E,e.$oD=y,e.$pD=k,e.$qD=w,e.$rD=m,e.$sD=v,e.$tD=p,e.$iD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R($){return typeof $.parentId=="number"}function S($){return!!$.workspaceUri}function M($){return!!$.folderUri}function P($){return!!$.fileUri}function E($){const f=k($),l=$.getValue("window.menuBarVisibility");return l==="default"||f&&l==="compact"||i.$j&&i.$m?"classic":l}var h;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var u;(function($){$.NATIVE="native",$.CUSTOM="custom"})(u||(e.TitlebarStyle=u={}));var g;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(g||(e.CustomTitleBarVisibility=g={}));function y($,f){return!0}function k($,f){return f||(f=w($)),f==="native"}function w($){if(i.$o)return"custom";const f=$.getValue("window");if(f){if(i.$j&&f.nativeTabs===!0||i.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return i.$k?"native":"custom"}function m($){return!(!i.$i||i.$o||k($))}function v($){const f=$.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function p($=0){return Math.pow(1.2,$)}}),define(oe[82],ae([0,1,14]),function(Q,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$qac=e.$pac=e.UnloadReason=e.LoadReason=void 0;var R;(function(u){u[u.INITIAL=1]="INITIAL",u[u.LOAD=2]="LOAD",u[u.RELOAD=3]="RELOAD"})(R||(e.LoadReason=R={}));var S;(function(u){u[u.CLOSE=1]="CLOSE",u[u.QUIT=2]="QUIT",u[u.RELOAD=3]="RELOAD",u[u.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const M=function(u=1){return{width:1024,height:768,mode:u}};e.$pac=M;const P=function(){const y=i.screen.getPrimaryDisplay().workArea,k=Math.max(y.x+y.width/2-800/2,0),w=Math.max(y.y+y.height/2-600/2,0);return{x:k,y:w,width:800,height:600,mode:1}};e.$qac=P;var E;(function(u){u[u.Maximized=0]="Maximized",u[u.Normal=1]="Normal",u[u.Minimized=2]="Minimized",u[u.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(u){u[u.UNRESPONSIVE=1]="UNRESPONSIVE",u[u.PROCESS_GONE=2]="PROCESS_GONE",u[u.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(oe[278],ae([0,1,8,3,2]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class M extends S.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:u}){super(),this.a=this.B(new S.$Tc),R.Event.latch(R.Event.any(E,h))(this.f,this,this.a),this.b=(0,i.$ah)(()=>u()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$6bc=M}),define(oe[30],ae([0,1,195,9,59,19,7,6,13]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=u,e.$yi=g,e.$Bi=y,e.$Ci=k,e.$Di=w,e.$Ei=v,e.$Fi=p,e.$Ii=l,e.$Ni=d,e.$Oi=a,e.$Qi=t,e.$Ri=o,e.$Si=s,e.$wi=(0,E.$ni)("contextService");function u(n){const r=n;return typeof r?.id=="string"&&P.URI.isUri(r.uri)}function g(n){return typeof n?.id=="string"&&!u(n)&&!k(n)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function y(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,R.$oc)(n)}:r?e.$zi:e.$Ai;const c=n;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}function k(n){const r=n;return typeof r?.id=="string"&&P.URI.isUri(r.configPath)}function w(n){const r=n;if(r?.uri)return{id:r.id,uri:P.URI.revive(r.uri)};const c=n;if(c?.configPath)return{id:c.id,configPath:P.URI.revive(c.configPath)};if(n?.id)return{id:n.id}}var m;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function v(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function p(n){const r=n;return!!(r&&typeof r=="object"&&P.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class ${constructor(r,c,b,I,D){this.h=r,this.j=b,this.k=I,this.l=D,this.c=S.$ti.forUris(this.l,()=>!0),this.folders=c}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=S.$ti.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=$;class f{constructor(r,c){this.raw=c,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,M.$1g)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=f;function l(n){return new f({uri:n,index:0,name:(0,M.$Wg)(n)},{uri:n.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,i.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function d(n,r){return M.$Rg.isEqualOrParent(n,r.untitledWorkspacesHome)}function a(n){let r;return P.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===h.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Pi}function o(n,r){return!d(n,r)&&!a(n)}function s(n){return(typeof n=="string"?(0,R.$pc)(n):(0,M.$Yg)(n))===e.$Ki}}),define(oe[56],ae([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=void 0,e.$xac=(0,k.$ni)("dialogMainService");let p=class{constructor(f,l){this.d=f,this.e=l,this.a=new Map,this.b=new Map,this.c=new R.$uh}pickFileFolder(f,l){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},l)}pickFolder(f,l){return this.f({...f,pickFolders:!0,title:(0,g.localize)(1,null)},l)}pickFile(f,l){return this.f({...f,pickFiles:!0,title:(0,g.localize)(2,null)},l)}pickWorkspace(f,l){const d=(0,g.localize)(3,null),a=(0,M.$sw)((0,g.localize)(4,null)),t=v.$Li;return this.f({...f,pickFiles:!0,title:d,filters:t,buttonLabel:a},l)}async f(f,l){const d={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(d.properties=void 0,f.pickFiles&&f.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&d.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(d,(l||i.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let l=this.b.get(f.id);return l||(l=new R.$uh,this.b.set(f.id,l)),l}else return this.c}showMessageBox(f,l){return this.g(l).queue(async()=>{const{options:d,buttonIndeces:a}=(0,y.$zw)(f,this.e);let t;return l?t=await i.dialog.showMessageBox(l,d):t=await i.dialog.showMessageBox(d),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,l){const d=this.j(f,l);if(!d)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let a;return l?a=await i.dialog.showSaveDialog(l,f):a=await i.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,P.$Pc)(d)}}h(f){return f&&h.$j&&(f=(0,E.$5l)(f)),f}i(f){return f.map(l=>this.h(l))}async showOpenDialog(f,l){f.defaultPath&&(await u.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const d=this.j(f,l);if(!d)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let a;return l?a=await i.dialog.showOpenDialog(l,f):a=await i.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,P.$Pc)(d)}}j(f,l){if(!l)return P.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let d=this.a.get(l.id);d||(d=new Set,this.a.set(l.id,d));const a=(0,S.$bj)(f);if(!d.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),d.add(a),(0,P.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),d?.delete(a),d?.size===0&&this.a.delete(l.id)})}};e.$yac=p,e.$yac=p=Ee([ne(0,w.$Tj),ne(1,m.$ak)],p)}),define(oe[279],ae([0,1,3,2,77,30]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class P extends R.$Uc{static{this.a=100}constructor(h,u){super(),this.f=h,this.g=u,this.b=this.B(new i.$_d),this.c=new Map,this.h(u.applicationStorage,this.b)}h(h,u){this.B(i.Event.debounce(h.onDidChangeStorage,(g,y)=>(g?g.push(y):g=[y],g),P.a)(g=>{g.length&&u.fire(this.j(g,h))}))}j(h,u){const g=new Map,y=new Set;return h.forEach(k=>{const w=u.get(k.key);typeof w=="string"?g.set(k.key,w):y.add(k.key)}),{changed:Array.from(g.entries()),deleted:Array.from(y.values())}}listen(h,u,g){switch(u){case"onDidChangeStorage":{const y=g.profile?(0,S.$Wh)(g.profile):void 0;if(!y)return this.b.event;let k=this.c.get(y.id);return k||(k=this.B(new i.$_d),this.h(this.g.profileStorage(y),k),this.c.set(y.id,k)),k.event}}throw new Error(`Event not found: ${u}`)}async call(h,u,g){const y=g.profile?(0,S.$Wh)(g.profile):void 0,k=(0,M.$Di)(g.workspace),w=await this.m(y,k);switch(u){case"getItems":return Array.from(w.items.entries());case"updateItems":{const m=g;if(m.insert)for(const[v,p]of m.insert)w.set(v,p);m.delete?.forEach(v=>w.delete(v));break}case"optimize":return w.optimize();case"isUsed":{const m=g.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${u}`)}}async m(h,u){let g;u?g=this.g.workspaceStorage(u):h?g=this.g.profileStorage(h):g=this.g.applicationStorage;try{await g.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":h?"profile":"application"} storage due to ${y}`)}return g}}e.$Jbc=P}),define(oe[41],ae([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$tl=e.ProfileResourceType=void 0,e.$sl=d,e.$ul=a,e.$vl=t;var l;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function d(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&P.URI.isUri(r.location)&&P.URI.isUri(r.globalStorageHome)&&P.URI.isUri(r.settingsResource)&&P.URI.isUri(r.keybindingsResource)&&P.URI.isUri(r.tasksResource)&&P.URI.isUri(r.snippetsHome)&&P.URI.isUri(r.extensionsResource))}e.$tl=(0,g.$ni)("IUserDataProfilesService");function a(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:P.URI.revive(n.location).with({scheme:r}),globalStorageHome:P.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:P.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:P.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:P.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:P.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:P.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:P.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,r,c,b,I,D){return{id:n,name:r,location:c,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:D&&I?.useDefaultFlags?.globalState?D.globalStorageHome:(0,M.$1g)(c,"globalStorage"),settingsResource:D&&I?.useDefaultFlags?.settings?D.settingsResource:(0,M.$1g)(c,"settings.json"),keybindingsResource:D&&I?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,M.$1g)(c,"keybindings.json"),tasksResource:D&&I?.useDefaultFlags?.tasks?D.tasksResource:(0,M.$1g)(c,"tasks.json"),snippetsHome:D&&I?.useDefaultFlags?.snippets?D.snippetsHome:(0,M.$1g)(c,"snippets"),extensionsResource:D&&I?.useDefaultFlags?.extensions?D.extensionsResource:(0,M.$1g)(c,"extensions.json"),cacheHome:(0,M.$1g)(b,n),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let o=class extends S.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,c,b,I){super(),this.t=r,this.u=c,this.w=b,this.y=I,this.f=!0,this.h=this.B(new R.$_d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$_d),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$_d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$_d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Bc,emptyWindows:new Map},this.profilesHome=(0,M.$1g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$1g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),c=[r];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,f.$1f)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}c.push(t((0,M.$Xg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},r))}}catch(D){this.y.error(D)}const b=new w.$Bc,I=new Map;if(c.length)try{const D=this.Q();if(D.workspaces)for(const[j,A]of Object.entries(D.workspaces)){const C=P.URI.parse(j),W=c.find(T=>T.id===A);W&&b.set(C,W)}if(D.emptyWindows)for(const[j,A]of Object.entries(D.emptyWindows)){const C=c.find(W=>W.id===A);C&&I.set(j,C)}}catch(D){this.y.error(D)}this.z={profiles:c,workspaces:b,emptyWindows:I}}return this.z}D(){const r=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const c="Temp",b=new RegExp(`${(0,$.$5e)(c)}\\s(\\d+)`);let I=0;for(const j of this.profiles){const A=b.exec(j.name),C=A?parseInt(A[1]):0;I=C>I?C:I}const D=`${c} ${I+1}`;return this.createProfile((0,i.$bj)((0,p.$Jg)()).toString(16),D,{transient:!0},r)}async createNamedProfile(r,c,b){return this.createProfile((0,i.$bj)((0,p.$Jg)()).toString(16),r,c,b)}async createProfile(r,c,b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(r,c,b);return I&&await this.setProfileForWorkspace(I,D),D}async F(r,c,b){if(!(0,f.$1f)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(c);return I||(I=(async()=>{try{if(this.profiles.find(C=>C.name===c||C.id===r))throw new Error(`Profile with ${c} name already exists`);const j=t(r,c,(0,M.$1g)(this.profilesHome,r),this.g,b,this.defaultProfile);await this.u.createFolder(j.location);const A=[];return this.j.fire({profile:j,join(C){A.push(C)}}),await v.Promises.settled(A),this.I([j],[],[]),j}finally{this.r.delete(c)}})(),this.r.set(c,I)),I}async updateProfile(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(I=>I.id===r.id);if(!b)throw new Error(`Profile '${r.name}' does not exist`);return b=t(b.id,c.name??b.name,b.location,this.g,{shortName:c.shortName??b.shortName,icon:c.icon===null?void 0:c.icon??b.icon,transient:c.transient??b.isTransient,useDefaultFlags:c.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(I=>I.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);const b=[];this.m.fire({profile:c,join(I){b.push(I)}});try{await Promise.allSettled(b)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(I){(0,u.$$k)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(I=>I.id===c.id);if(!b)throw new Error(`Profile '${c.name}' does not exist`);this.L(r,b)}unsetWorkspace(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(c=>c.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(r.map(c=>this.removeProfile(c)))}getProfileForWorkspace(r){const c=this.G(r);return P.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(r){return(0,k.$xi)(r)?r.uri:(0,k.$Ci)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,r.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,r.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,r.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,r.location)))}I(r,c,b){const I=[...this.profiles,...r],D=[];this.s.profiles=[];for(let j of I)j.isDefault||c.some(A=>j.id===A.id)||(j=b.find(A=>j.id===A.id)??j,j.isTransient?this.s.profiles.push(j):D.push({location:j.location,name:j.name,shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags}));this.P(D),this.z=void 0,this.J(r,c,b)}J(r,c,b){this.h.fire({added:r,removed:c,updated:b,all:this.profiles})}L(r,c,b){b=c?.isTransient?!0:b,b||this.L(r,void 0,!0);const I=this.G(r),D=b?this.s:this.C;P.URI.isUri(I)?(D.workspaces.delete(I),c&&D.workspaces.set(I,c)):(D.emptyWindows.delete(I),c&&D.emptyWindows.set(I,c)),b||this.M()}M(){const r={};for(const[b,I]of this.C.workspaces.entries())r[b.toString()]=I.id;const c={};for(const[b,I]of this.C.emptyWindows.entries())c[b.toString()]=I.id;this.R({workspaces:r,emptyWindows:c}),this.z=void 0}N(r){const c={},b=this.D();if(r.workspaces)for(const[D,j]of Object.entries(r.workspaces)){const A=P.URI.parse(j);c[D]=this.w.extUri.isEqual(A,b.location)?b.id:this.w.extUri.basename(A)}const I={};if(r.emptyWindows)for(const[D,j]of Object.entries(r.emptyWindows)){const A=P.URI.parse(j);I[D]=this.w.extUri.isEqual(A,b.location)?b.id:this.w.extUri.basename(A)}return{workspaces:c,emptyWindows:I}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$wl=o,e.$wl=o=Ee([ne(0,h.$ui),ne(1,u.$Tk),ne(2,m.$rl),ne(3,y.$Tj)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$xl=s}),define(oe[83],ae([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class l extends Error{constructor(s,n){super(s),this.code=n}}e.$fq=l,e.$gq=(0,y.$ni)("IExtensionsProfileScannerService");let d=class extends S.$Uc{constructor(s,n,r,c,b,I){super(),this.j=s,this.m=n,this.n=r,this.r=c,this.s=b,this.t=I,this.b=this.B(new M.$_d),this.onAddExtensions=this.b.event,this.c=this.B(new M.$_d),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$_d),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$_d),this.onDidRemoveExtensions=this.g.event,this.h=new P.$Bc}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n,r){const c=[],b=[];try{return await this.u(n,I=>{const D=[];if(r)D.push(...I);else for(const j of I)s.some(([A])=>(0,u.$lp)(A.identifier,j.identifier)&&A.manifest.version!==j.version)?c.push(j):D.push(j);for(const[j,A]of s){const C=D.findIndex(T=>(0,u.$lp)(T.identifier,j.identifier)&&T.version===j.manifest.version),W={identifier:j.identifier,version:j.manifest.version,location:j.location,metadata:A};C===-1?(b.push(W),D.push(W)):D.splice(C,1,W)}return b.length&&this.b.fire({extensions:b,profileLocation:n}),c.length&&this.f.fire({extensions:c,profileLocation:n}),D}),b.length&&this.c.fire({extensions:b,profileLocation:n}),c.length&&this.g.fire({extensions:c,profileLocation:n}),b}catch(I){throw b.length&&this.c.fire({extensions:b,error:I,profileLocation:n}),c.length&&this.g.fire({extensions:c,error:I,profileLocation:n}),I}}async updateMetadata(s,n){const r=[];return await this.u(n,c=>{const b=[];for(const I of c){const D=s.find(([j])=>(0,u.$lp)(j.identifier,I.identifier)&&j.manifest.version===I.version);D&&(I.metadata={...I.metadata,...D[1]},r.push(I)),b.push(I)}return b}),r}async removeExtensionFromProfile(s,n){const r=[];try{await this.u(n,c=>{const b=[];for(const I of c)(0,u.$lp)(I.identifier,s.identifier)?r.push(I):b.push(I);return r.length&&this.f.fire({extensions:r,profileLocation:n}),b}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(c){throw r.length&&this.g.fire({extensions:r,error:c,profileLocation:n}),c}}async u(s,n,r){return this.F(s).queue(async()=>{let c=[],b;try{const I=await this.m.readFile(s);b=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,g.$$k)(I)!==1)throw I;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&r?.bailOutWhenFileNotFound)throw new l((0,p.$0)(I),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(s);let I=!1;for(const D of b){a(D)||this.w(s);let j;if((0,v.$1f)(D.relativeLocation)&&D.relativeLocation)j=this.z(D.relativeLocation);else if((0,v.$1f)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{j=E.URI.revive(D.location);const A=this.y(j);A&&(I=!0,D.relativeLocation=A)}(0,v.$8f)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(I=!0,D.metadata.hasPreReleaseVersion=!0),c.push({identifier:D.identifier,location:j,version:D.version,metadata:D.metadata})}I&&await this.m.writeFile(s,R.$ze.fromString(JSON.stringify(b)))}if(n){c=n(c);const I=c.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,R.$ze.fromString(JSON.stringify(I)))}return c})}w(s){const n=new l(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let r;try{r=(await this.m.readFile(s)).value.toString()}catch(b){if((0,g.$$k)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",s.toString());let c;try{const b=JSON.parse(r);Array.isArray(b)&&b.every(I=>a(I))?c=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ze.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,g.$$k)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(s)}catch(b){(0,g.$$k)(b)!==1&&this.t.error(b)}try{await this.m.del(n)}catch(b){(0,g.$$k)(b)!==1&&this.t.error(b)}return c})()),this.C}F(s){let n=this.h.get(s);return n||(n=new i.$uh,this.h.set(s,n)),n}};e.$hq=d,e.$hq=d=Ee([ne(1,g.$Tk),ne(2,w.$tl),ne(3,m.$rl),ne(4,$.$Sl),ne(5,k.$Tj)],d);function a(o){return(0,v.$3f)(o)&&(0,h.$Vo)(o.identifier)&&(t(o.location)||(0,v.$1f)(o.location)&&o.location)&&((0,v.$8f)(o.relativeLocation)||(0,v.$1f)(o.relativeLocation))&&o.version&&(0,v.$1f)(o.version)}function t(o){return o?(0,v.$1f)(o.path)&&(0,v.$1f)(o.scheme):!1}}),define(oe[132],ae([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n,r,c,b,I,D,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$mq=e.$lq=e.$kq=e.Translations=void 0,e.$nq=ue;var C;(function(le){function Y(K,B){if(K===B)return!0;const L=Object.keys(K),H=new Set;for(const G of Object.keys(B))H.add(G);if(L.length!==H.size)return!1;for(const G of L){if(K[G]!==B[G])return!1;H.delete(G)}return H.size===0}le.equals=Y})(C||(e.Translations=C={})),e.$kq=(0,s.$ni)("IExtensionsScannerService");let W=class extends u.$Uc{constructor(Y,K,B,L,H,G,z,ce,he,X,O,F){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=K,this.r=B,this.s=L,this.t=H,this.u=G,this.w=z,this.y=ce,this.z=he,this.C=X,this.D=O,this.F=F,this.g=this.B(new c.$_d),this.onDidChangeCache=this.g.event,this.h=(0,w.$1g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(N,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$wp)(this.w,this.y)),this.G}async scanAllExtensions(Y,K,B){const[L,H]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(K)]),G=B?await this.scanExtensionsUnderDevelopment(Y,[...L,...H]):[];return this.L(L,H,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const K=[];K.push(this.M(!!Y.useCache,Y.language)),K.push(this.N(Y.language,!!Y.checkControlFile));const[B,L]=await Promise.all(K);return this.J([...B,...L],0,Y,!1)}async scanUserExtensions(Y){const K=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const B=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(K,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,B,Y.productVersion??this.R()),H=Y.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await H.scanExtensions(L)}catch(z){if(z instanceof I.$fq&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await H.scanExtensions(L);else throw z}return G=await this.J(G,1,Y,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Y,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===g.Schemas.file).map(async L=>{const H=await this.P(L,!1,1,!0,Y.language,!1,void 0,Y.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(z=>(z.type=K.find(ce=>(0,d.$lp)(ce.identifier,z.identifier))?.type??z.type,this.n.validate(z,H)))}))).flat();return this.J(B,"development",Y,!0)}return[]}async scanExistingExtension(Y,K,B){const L=await this.P(Y,!1,K,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanExtension(L);return!H||!B.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(Y,K,B){const L=await this.P(Y,!1,K,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(L);return this.J(H,K,B,!0)}async scanMultipleExtensions(Y,K,B){const L=[];return await Promise.all(Y.map(async H=>{const G=await this.scanOneOrMultipleExtensions(H,K,B);L.push(...G)})),this.J(L,K,B,!0)}async scanMetadata(Y){const K=(0,w.$1g)(Y,"package.json"),B=(await this.w.readFile(K)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(Y,K){const B=(0,w.$1g)(Y,"package.json"),L=(await this.w.readFile(B)).value.toString(),H=JSON.parse(L);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,H.__metadata={...H.__metadata,...K},await this.w.writeFile((0,w.$1g)(Y,"package.json"),M.$ze.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof I.$fq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ze.fromString(JSON.stringify([])))}catch(K){(0,o.$$k)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,P.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,K,B,L){return B.includeAllVersions||(Y=this.L(K===0?Y:void 0,K===1?Y:void 0,K==="development"?Y:void 0,await this.getTargetPlatform(),L)),B.includeInvalid||(Y=Y.filter(H=>H.isValid)),Y.sort((H,G)=>{const z=y.$oc(H.location.fsPath),ce=y.$oc(G.location.fsPath);return z<ce?-1:z>ce?1:0})}L(Y,K,B,L,H){const G=(ce,he,X)=>{if(ce.isValid&&!he.isValid)return!1;if(ce.isValid===he.isValid){if(H&&m.gt(ce.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(m.eq(ce.manifest.version,he.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${ce.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${he.location.path}.`),!0},z=new a.$Km;return Y?.forEach(ce=>{const he=z.get(ce.identifier.id);(!he||G(he,ce,!1))&&z.set(ce.identifier.id,ce)}),K?.forEach(ce=>{const he=z.get(ce.identifier.id);if(!he&&Y&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!he||G(he,ce,!1))&&z.set(ce.identifier.id,ce)}),B?.forEach(ce=>{const he=z.get(ce.identifier.id);(!he||G(he,ce,!0))&&z.set(ce.identifier.id,ce),z.set(ce.identifier.id,ce)}),[...z.values()]}async M(Y,K){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),H=await(Y&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",H.length),H}async N(Y,K){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const L=K?await this.O():{},H=[],G=$.URI.file(y.$ic(y.$kc(g.$Hg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of B){const he=L[ce.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":H.push((0,w.$1g)(G,ce.name));break;default:H.push($.URI.file(he));break}}const z=await Promise.all(H.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,Y,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",z.length),(0,i.$Hb)(z)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,K,B,L,H,G,z,ce){const he=await this.f(H??k.$w),X=await this.Q(Y),O=K&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=O?await this.Q(O):void 0;return new T(Y,X,O,F,K,z,B,L,G,ce.version,ce.date,this.C.commit,!this.z.isBuilt,H,he)}async Q(Y){try{const K=await this.w.stat(Y);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$lq=W,e.$lq=W=Ee([ne(4,D.$tl),ne(5,I.$gq),ne(6,o.$Tk),ne(7,n.$Tj),ne(8,l.$ui),ne(9,r.$ak),ne(10,j.$rl),ne(11,s.$mi)],W);class T{constructor(Y,K,B,L,H,G,z,ce,he,X,O,F,_,se,J){this.location=Y,this.mtime=K,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=L,this.profile=H,this.profileScanOptions=G,this.type=z,this.excludeObsolete=ce,this.validate=he,this.productVersion=X,this.productDate=O,this.productCommit=F,this.devMode=_,this.language=se,this.translations=J}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,K){return(0,w.$Tg)(Y.location,K.location)&&Y.mtime===K.mtime&&(0,w.$Tg)(Y.applicationExtensionslocation,K.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Y.profile===K.profile&&S.$Xn(Y.profileScanOptions,K.profileScanOptions)&&Y.type===K.type&&Y.excludeObsolete===K.excludeObsolete&&Y.validate===K.validate&&Y.productVersion===K.productVersion&&Y.productDate===K.productDate&&Y.productCommit===K.productCommit&&Y.devMode===K.devMode&&Y.language===K.language&&C.equals(Y.translations,K.translations)}}e.$mq=T;let N=class extends u.$Uc{constructor(Y,K,B,L,H){super(),this.f=Y,this.g=K,this.h=B,this.j=L,this.m=H}async scanExtensions(Y){const K=Y.profile?await this.r(Y):await this.n(Y);let B={};if(Y.excludeObsolete&&Y.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(L)}catch{}return(0,p.$bg)(B)?K:K.filter(L=>!B[d.$mp.create(L).toString()])}async n(Y){const K=await this.j.resolve(Y.location);if(!K.children?.length)return[];const B=await Promise.all(K.children.map(async L=>{if(!L.isDirectory||Y.type===1&&(0,w.$Xg)(L.resource).indexOf(".")===0)return null;const H=new T(L.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(H)}));return(0,i.$Hb)(B).sort((L,H)=>L.location.path<H.location.path?-1:1)}async r(Y){let K=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){K=K.filter(L=>!L.metadata?.isApplicationScoped);const B=await this.s(Y.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Y);K.push(...B)}return K}async s(Y,K,B){const L=await this.g.scanProfileExtensions(Y,B.profileScanOptions);if(!L.length)return[];const H=await Promise.all(L.map(async G=>{if(K(G)){const z=new T(G.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(z,G.metadata)}return null}));return(0,i.$Hb)(H)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,w.$1g)(Y.location,"package.json"))){const K=await this.scanExtension(Y);return K?[K]:[]}else return await this.scanExtensions(Y)}catch(K){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,P.$0)(K)),[]}}async scanExtension(Y,K){try{let B=await this.scanExtensionManifest(Y.location);if(B){B.publisher||(B.publisher=a.$Em),K=K??B.__metadata,delete B.__metadata;const L=(0,d.$qp)(B.publisher,B.name),H=K?.id?{id:L,uuid:K.id}:{id:L},G=K?.isSystem?0:Y.type,z=G===0||!!K?.isBuiltin;B=await this.t(Y.location,B,T.createNlsConfiguration(Y));const ce={type:G,identifier:H,manifest:B,location:Y.location,isBuiltin:z,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Y.validate?this.validate(ce,Y):ce}}catch(B){Y.type!==0&&this.m.error(B)}return null}validate(Y,K){let B=!0;const L=(0,t.$Bp)(K.productVersion,K.productDate,K.location,Y.manifest,Y.isBuiltin);for(const[H,G]of L)H===v.default.Error&&(B=!1,this.m.error(this.z(K.location,G)));return Y.isValid=B,Y.validations=L,Y}async scanExtensionManifest(Y){const K=(0,w.$1g)(Y,"package.json");let B;try{B=(await this.j.readFile(K)).value.toString()}catch(H){return(0,o.$$k)(H)!==1&&this.m.error(this.z(Y,(0,f.localize)(0,null,K.path,H.message))),null}let L;try{L=JSON.parse(B)}catch{const G=[];(0,E.$An)(B,G);for(const z of G)this.m.error(this.z(Y,(0,f.localize)(1,null,K.path,z.offset,z.length,(0,h.$iq)(z.error))));return null}return(0,E.$Jn)(L)!=="object"?(this.m.error(this.z(Y,(0,f.localize)(2,null,K.path))),null):L}async t(Y,K,B){const L=await this.u(Y,K,B);if(L)try{const H=[],G=await this.w(L.default,H);if(H.length>0)return H.forEach(ce=>{this.m.error(this.z(Y,(0,f.localize)(3,null,L.default?.path,(0,h.$iq)(ce.error))))}),K;if((0,E.$Jn)(L)!=="object")return this.m.error(this.z(Y,(0,f.localize)(4,null,L.default?.path))),K;const z=L.values||Object.create(null);return(0,A.$jq)(this.m,K,z,G)}catch{}return K}async u(Y,K,B){const L=(0,w.$1g)(Y,"package.nls.json"),H=(he,X)=>{X.forEach(O=>{this.m.error(this.z(Y,(0,f.localize)(5,null,he?.path,(0,h.$iq)(O.error))))})},G=he=>{this.m.error(this.z(Y,(0,f.localize)(6,null,he?.path)))},z=`${K.publisher}.${K.name}`,ce=B.translations[z];if(ce)try{const he=$.URI.file(ce),X=(await this.j.readFile(he)).value.toString(),O=[],F=(0,E.$An)(X,O);return O.length>0?(H(he,O),{values:void 0,default:L}):(0,E.$Jn)(F)!=="object"?(G(he),{values:void 0,default:L}):{values:F.contents?F.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let X;try{X=await this.y(Y,B)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const O=(await this.j.readFile(X.localized)).value.toString(),F=[],_=(0,E.$An)(O,F);return F.length>0?(H(X.localized,F),{values:void 0,default:X.original}):(0,E.$Jn)(_)!=="object"?(G(X.localized),{values:void 0,default:X.original}):{values:_,default:X.original}}catch{return{values:void 0,default:X.original}}}}async w(Y,K){if(Y)try{const B=(await this.j.readFile(Y)).value.toString();return(0,E.$An)(B,K)}catch{}}y(Y,K){return new Promise((B,L)=>{const H=G=>{const z=(0,w.$1g)(Y,`package.nls.${G}.json`);this.j.exists(z).then(ce=>{ce&&B({localized:z,original:(0,w.$1g)(Y,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?B({localized:(0,w.$1g)(Y,"package.nls.json"),original:null}):(G=G.substring(0,he),H(G))})};if(K.devMode||K.pseudo||!K.language)return B({localized:(0,w.$1g)(Y,"package.nls.json"),original:null});H(K.language)})}z(Y,K){return`[${Y.path}]: ${K}`}};N=Ee([ne(1,I.$gq),ne(2,j.$rl),ne(3,o.$Tk),ne(4,n.$Tj)],N);let U=class extends N{constructor(Y,K,B,L,H,G,z){super(K,L,H,G,z),this.G=Y,this.H=B,this.D=this.B(new R.$lh(3e3)),this.F=this.B(new c.$_d),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const K=this.M(Y),B=await this.I(K);if(this.C=Y,B&&B.input&&T.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),B.result.map(H=>(H.location=$.URI.revive(H.location),H));const L=await super.scanExtensions(Y);return await this.J(K,{input:Y,result:L}),L}async I(Y){try{const K=await this.j.readFile(Y),B=JSON.parse(K.value.toString());return{result:B.result,input:(0,b.$Wh)(B.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Y.path,(0,P.$0)(K))}return null}async J(Y,K){try{await this.j.writeFile(Y,M.$ze.fromString(JSON.stringify(K)))}catch(B){this.m.debug("Error while writing the extension cache file:",Y.path,(0,P.$0)(B))}}async L(){if(!this.C)return;const Y=this.M(this.C),K=await this.I(Y);if(!K)return;const B=K.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$Xn(L,B))try{this.m.info("Invalidating Cache",B,L),await this.j.del(Y),this.F.fire()}catch(H){this.m.error(H)}}M(Y){const K=this.N(Y);return this.h.extUri.joinPath(K.cacheHome,Y.type===0?a.$Dm:a.$Cm)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Y.location,K.extensionsResource))??this.G:this.H.defaultProfile}};U=Ee([ne(2,D.$tl),ne(3,I.$gq),ne(4,j.$rl),ne(5,o.$Tk),ne(6,n.$Tj)],U);function ue(le,Y){const K=(0,d.$op)(le.manifest.publisher,le.manifest.name);return{id:K,identifier:new a.$Im(K),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:Y,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}class ie extends W{constructor(Y,K,B,L,H,G,z,ce,he,X,O,F){super(Y,K,(0,w.$1g)(B,".vscode-oss-dev","extensions","control.json"),L,H,G,z,ce,he,X,O,F),this.S=(async()=>{if(k.$z)try{const _=await this.w.readFile($.URI.file(k.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.S}}e.$oq=ie}),define(oe[280],ae([0,1,5,41,40,28,83,16,38,7]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;let g=class extends P.$hq{constructor(k,w,m,v,p,$){super(u.URI.file(k.extensionsPath),w,m,v,p,$)}};e.$fQ=g,e.$fQ=g=Ee([ne(0,h.$vi),ne(1,E.$Tk),ne(2,R.$tl),ne(3,S.$rl),ne(4,M.$Sl),ne(5,i.$Tj)],g)}),define(oe[281],ae([0,1,7,38,83,132,16,6,5,27,40,41]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;let k=class extends M.$oq{constructor(m,v,p,$,f,l,d,a){super(i.URI.file(f.builtinExtensionsPath),i.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,v,p,$,f,l,d,a)}};e.$0bc=k,e.$0bc=k=Ee([ne(0,y.$tl),ne(1,S.$gq),ne(2,P.$Tk),ne(3,h.$Tj),ne(4,R.$vi),ne(5,u.$ak),ne(6,g.$rl),ne(7,E.$mi)],k)}),define(oe[282],ae([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;let m=class extends R.$Uc{constructor(p,$,f){super(),this.c=p,this.f=f,this.a=E.$ti.forPaths(!P.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=i.session;p.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,($,f)=>this.j($,f)),p.protocol.interceptFileProtocol(S.Schemas.file,($,f)=>this.h($,f)),this.B((0,R.$Sc)(()=>{p.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(p){const $=(0,M.$ic)(p);return this.a.get($)?R.$Uc.None:(this.a.set($,!0),(0,R.$Sc)(()=>this.a.delete($)))}h(p,$){const f=h.URI.parse(p.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${S.Schemas.file}: protocol (original URL: ${p.url})`),$({error:-3})}j(p,$){const f=this.m(p);let l;return this.c.crossOriginIsolated&&((0,M.$oc)(f)==="workbench.html"||(0,M.$oc)(f)==="workbench-dev.html"?l=S.COI.CoopAndCoep:l=S.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(f)?$({path:f,headers:l}):this.b.has((0,M.$pc)(f).toLowerCase())?$({path:f}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),$({error:-3}))}m(p){const $=h.URI.parse(p.url),f=S.$Hg.uriToFileUri($);return(0,M.$ic)(f.fsPath)}createIPCObjectUrl(){let p;const $=h.URI.from({scheme:"vscode",path:(0,u.$Jg)()}),f=$.toString(),l=async()=>p;return g.$jW.handle(f,l),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:$,update:d=>p=d,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),g.$jW.removeHandler(f)}}}};e.$pcc=m,e.$pcc=m=Ee([ne(0,y.$vi),ne(1,w.$tl),ne(2,k.$Tj)],m)}),define(oe[97],ae([0,1,8,3,2,66,12,115,6,41]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Tp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Rp=e.$Qp=e.$Pp=void 0,e.$Sp=w,e.$Up=v,e.$Wp=$,e.$Pp="__$__isNewStorageMarker",e.$Qp="__$__targetStorageMarker",e.$Rp=(0,h.$ni)("storageService");var g;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function w(f){const l=f.get(e.$Qp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class m extends S.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:m.a}){super(),this.m=l,this.b=this.B(new R.$ce),this.c=this.B(new R.$ce),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$_d),this.onWillSaveState=this.f.event,this.h=this.B(new i.$zh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,d,a){return R.Event.filter(this.b.event,t=>t.scope===l&&(d===void 0||t.key===d),a)}n(){this.j.value=(0,i.$Dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,d){const{key:a,external:t}=d;if(a===e.$Qp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:a,target:this.J(l)[a],external:t})}w(l){this.f.fire({reason:l})}get(l,d,a){return this.P(d)?.get(l,a)}getBoolean(l,d,a){return this.P(d)?.getBoolean(l,a)}getNumber(l,d,a){return this.P(d)?.getNumber(l,a)}getObject(l,d,a){return this.P(d)?.getObject(l,a)}storeAll(l,d){this.y(()=>{for(const a of l)this.store(a.key,a.value,a.scope,a.target,d)})}store(l,d,a,t,o=!1){if((0,P.$0f)(d)){this.remove(l,a,o);return}this.y(()=>{this.z(l,a,t),this.P(a)?.set(l,d,o)})}remove(l,d,a=!1){this.y(()=>{this.z(l,d,void 0),this.P(d)?.delete(l,a)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,d){const a=[],t=this.J(l);for(const o of Object.keys(t))t[o]===d&&a.push(o);return a}z(l,d,a,t=!1){const o=this.J(d);typeof a=="number"?o[l]!==a&&(o[l]=a,this.P(d)?.set(e.$Qp,JSON.stringify(o),t)):typeof o[l]=="number"&&(delete o[l],this.P(d)?.set(e.$Qp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const d=this.P(l);return d?w(d):Object.create(null)}isNew(l){return this.getBoolean(e.$Pp,l)===!0}async flush(l=g.NONE){this.f.fire({reason:l});const d=this.P(-1),a=this.P(0),t=this.P(1);switch(l){case g.NONE:await i.Promises.settled([d?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await i.Promises.settled([d?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return $(l,d,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,d){return this.w(g.NONE),(0,u.$sl)(l)?this.R(l,d):this.S(l,d)}M(l,d){return!(l.id===d.id||v(d)&&v(l))}N(l,d,a){this.y(()=>{const t=new Set;for(const[o,s]of l)t.add(o),d.get(o)!==s&&this.u(a,{key:o,external:!0});for(const[o]of d.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Tp=m;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class p extends m{constructor(){super(),this.U=this.B(new E.$Np(new E.$Op,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Np(new E.$Op,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Np(new E.$Op,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Vp=p;async function $(f,l,d,a,t,o){const s=C=>{try{return JSON.parse(C)}catch{return C}},n=new Map,r=new Map;f.forEach((C,W)=>{n.set(W,C),r.set(W,s(C))});const c=new Map,b=new Map;l.forEach((C,W)=>{c.set(W,C),b.set(W,s(C))});const I=new Map,D=new Map;d.forEach((C,W)=>{I.set(W,C),D.set(W,s(C))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const j=[];if(n.forEach((C,W)=>{j.push({key:W,value:C})}),console.table(j),console.groupEnd(),console.log(r),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];c.forEach((W,T)=>{C.push({key:T,value:W})}),console.table(C),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const A=[];I.forEach((C,W)=>{A.push({key:W,value:C})}),console.table(A),console.groupEnd(),console.log(D)}}),define(oe[283],ae([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=e.$Zac=e.$Yac=e.$Xac=void 0;class $ extends M.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,n){super(),this.m=s,this.n=n,this.b=this.B(new S.$_d),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$_d),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$Np(new g.$Op,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$Kh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(r=>this.b.fire(r))),await this.s(s);const n=s.getBoolean(w.$Pp);n===void 0?s.set(w.$Pp,!0):n&&s.set(w.$Pp,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,n){return this.f.get(s,n)}set(s,n){return this.f.set(s,n)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new E.$8d(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const n=(0,i.top)(Array.from(this.f.items.entries()).map(([c,b])=>({key:c,length:b.length})),(c,b)=>b.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),r=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${r}b, Large Keys: ${n}`)}catch(n){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class f extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,P.$kc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,f.y)}constructor(s,n,r,c){super(r,c),this.z=s,this.C=n}async t(){return new g.$Np(new y.$OW(this.path??y.$OW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class l extends f{constructor(s,n,r,c){super(s,n,r,c)}}e.$Xac=l;class d extends f{constructor(s,n,r,c){super(n.defaultProfile,s,r,c)}async s(s){await super.s(s),this.G(s)}G(s){s.get(m.$Vl,void 0)===void 0&&s.set(m.$Vl,new Date().toUTCString());const r=s.get(m.$Ul,void 0),c=new Date().toUTCString();s.set(m.$Wl,typeof r>"u"?null:r),s.set(m.$Ul,c)}}e.$Yac=d;class a extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,P.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,n,r,c,b){super(r,b),this.C=s,this.D=n,this.F=c}async t(){const{storageFilePath:s,wasCreated:n}=await this.H();return new g.$Np(new y.$OW(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:n?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$OW.IN_MEMORY_PATH,wasCreated:!0};const s=(0,P.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),n=(0,P.$kc)(s,a.y);return await u.Promises.exists(s)?{storageFilePath:n,wasCreated:!1}:(await u.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:n,wasCreated:!0})}async I(s){let n;if((0,v.$xi)(this.C)?n={folder:this.C.uri.toString()}:(0,v.$Ci)(this.C)&&(n={workspace:this.C.configPath.toString()}),n)try{const r=(0,P.$kc)(s,a.z);await u.Promises.exists(r)||await u.Promises.writeFile(r,JSON.stringify(n,void 0,2))}catch(r){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.$Zac=a;class t extends ${get path(){}async t(){return new g.$Np(new g.$Op,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$1ac=t}),define(oe[284],ae([0,1,3,2,97]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class M extends R.$Uc{constructor(E,h,u){super(),this.b=E,this.c=h,this.f=u;const g=this.B(new R.$Vc);this.a=this.B(new i.$_d({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new R.$Tc;return E.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,u)=>(h?h.push(u.key):h=[u.key],h),100)(h=>this.h(h))),E.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(h,u)=>{h||(h=new Map);let g=h.get(u.profile.id);return g||h.set(u.profile.id,g={profile:u.profile,keys:[],storage:u.storage}),g.keys.push(u.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(S.$Qp)?[this.c.defaultProfile]:[],u=[];if(E=E.filter(g=>g!==S.$Qp),E.length){const g=(0,S.$Sp)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:g[y]}))})}this.m(h,u)}j(E){const h=[],u=new Map;for(const[g,y]of E.entries()){y.keys.includes(S.$Qp)&&h.push(y.profile);const k=y.keys.filter(w=>w!==S.$Qp);if(k.length){const w=(0,S.$Sp)(y.storage.storage);u.set(g,{profile:y.profile,changes:k.map(m=>({key:m,scope:0,target:w[m]}))})}}this.m(h,[...u.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,u){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$_bc=M}),define(oe[285],ae([0,1,7,38,16,5,34,40,41,12,125]),function(Q,e,i,R,S,M,P,E,h,u,g){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=void 0;let w=class extends h.$wl{static{y=this}static{this.a="profileAssociationsMigration"}constructor($,f,l,d,a){super(l,d,f,a),this.U=$,this.W=l}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,u.$1f)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):i.URI.revive(f.location)}))}Q(){const $=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$cQ=w,e.$cQ=w=y=Ee([ne(0,P.$0P),ne(1,E.$rl),ne(2,R.$vi),ne(3,S.$Tk),ne(4,M.$Tj)],w);let m=k=class extends w{constructor($,f,l,d,a){super($,f,l,d,a),this.$=$}P($){$.length?this.$.setItem(k.b,$.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(k.c,$):this.$.removeItem(k.c)}Q(){const $="workspaceAndProfileInfo",f=this.$.getItem($,void 0);if(f){this.$.removeItem($);const d=f.reduce((a,{workspace:t,profile:o})=>(a[i.URI.revive(t).toString()]=i.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:d})}const l=super.Q();return this.$.getItem(k.a,!1)||(this.R(l),this.$.setItem(k.a,!0)),l}};e.$dQ=m,e.$dQ=m=k=Ee([ne(0,P.$$P),ne(1,E.$rl),ne(2,R.$vi),ne(3,S.$Tk),ne(4,M.$Tj)],m);let v=class extends m{constructor($,f,l,d){super(new g.$bQ(0,f,d,l),$,f,l,d)}async init(){return await this.$.init(),super.init()}};e.$eQ=v,e.$eQ=v=Ee([ne(0,E.$rl),ne(1,R.$vi),ne(2,S.$Tk),ne(3,M.$Tj)],v)}),define(oe[57],ae([0,1,38,16,6,5,40,41,285,34]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=void 0,e.$Fac=(0,S.$oi)(E.$tl);let g=class extends h.$dQ{constructor(k,w,m,v,p){super(k,w,m,v,p)}getAssociatedEmptyWindows(){const k=[];for(const w of this.C.emptyWindows.keys())k.push({id:w});return k}};e.$Gac=g,e.$Gac=g=Ee([ne(0,u.$$P),ne(1,P.$rl),ne(2,i.$vi),ne(3,R.$Tk),ne(4,M.$Tj)],g)}),define(oe[133],ae([0,1,19,7,30]),function(Q,e,i,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=M,e.$Iac=P,e.$Jac=E;async function M(h,u,g){for(const k of h){const w=k.openedWorkspace;if((0,S.$Ci)(w)){const m=await g(w);if(m){if(m.folders.some(v=>i.$Rg.isEqualOrParent(u,v.uri)))return k}else if(i.$Rg.isEqualOrParent(u,w.configPath))return k}}const y=h.filter(k=>(0,S.$xi)(k.openedWorkspace)&&i.$Rg.isEqualOrParent(u,k.openedWorkspace.uri));if(y.length)return y.sort((k,w)=>-(k.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function P(h,u){for(const g of h)if((0,S.$Ci)(g.openedWorkspace)&&i.$Rg.isEqual(g.openedWorkspace.configPath,u)||(0,S.$xi)(g.openedWorkspace)&&i.$Rg.isEqual(g.openedWorkspace.uri,u))return g}function E(h,u){const g=y=>u.some(k=>i.$Rg.isEqual(R.URI.file(k),R.URI.file(y)));for(const y of h)if(y.config?.extensionDevelopmentPath?.some(k=>g(k)))return y}}),define(oe[98],ae([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9eb=void 0,e.$0eb=m,e.$$eb=v,e.$_eb=p,e.$afb=$,e.$bfb=d,e.$cfb=t,e.$dfb=o,e.$efb=b,e.$ffb=I,e.$9eb=(0,y.$ni)("workspacesService");function m(D){return D.hasOwnProperty("workspace")}function v(D){return D.hasOwnProperty("folderUri")}function p(D){return D.hasOwnProperty("fileUri")}function $(D){return f(D)||l(D)}function f(D){const j=D;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}function l(D){const j=D;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}function d(D,j,A,C,W){if(D.scheme!==C.scheme)return{name:A,uri:D.toString(!0)};let T=j?void 0:W.relativePath(C,D);if(T!==void 0)T.length===0?T=".":h.$i&&(T=a(T));else if(D.scheme===P.Schemas.file)T=D.fsPath,h.$i&&(T=a(T));else if(W.isEqualAuthority(D.authority,C.authority))T=D.path;else return{name:A,uri:D.toString(!0)};return{name:A,path:T}}function a(D){return D=(0,M.$mw)(D),(0,i.$kg)(D)||(D=(0,i.$hg)(D)),D}function t(D,j,A){const C=[],W=new Set,T=A.dirname(j);for(const N of D){let U;if(f(N))N.path&&(U=A.resolvePath(T,N.path));else if(l(N))try{U=g.URI.parse(N.uri),U.path[0]!==E.$hc.sep&&(U=U.with({path:E.$hc.sep+U.path}))}catch(ue){console.warn(ue)}if(U){const ue=A.getComparisonKey(U);if(!W.has(ue)){W.add(ue);const ie=N.name||A.basenameOrAuthority(U);C.push(new w.$Hi({uri:U,name:ie,index:C.length},N))}}}return C}function o(D,j,A,C,W){const T=s(j,D),N=W.dirname(j),U=W.dirname(C),ue=[];for(const K of T.folders){const B=f(K)?W.resolvePath(N,K.path):g.URI.parse(K.uri);let L;A?L=!1:L=!f(K)||(0,E.$jc)(K.path),ue.push(d(B,L,K.name,U,W))}const ie={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},le=S.$Pn(D,["folders"],ue,ie);let Y=S.$Sn(D,le);return(0,u.$6g)(T.remoteAuthority,(0,k.$ym)(C))&&(Y=S.$Sn(Y,S.$On(Y,["remoteAuthority"],ie))),Y}function s(D,j){const A=R.$An(j);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(C=>$(C));else throw new Error(`${D} looks like an invalid workspace file.`);return A}function n(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function r(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function b(D,j){const A={workspaces:[],files:[]};if(D){const C=function(T,N){for(let U=0;U<T.length;U++)try{N(T[U],U)}catch(ue){j.warn(`Error restoring recent entry ${JSON.stringify(T[U])}: ${ue.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&C(W.entries,T=>{const N=T.label,U=T.remoteAuthority;n(T)?A.workspaces.push({label:N,remoteAuthority:U,workspace:{id:T.workspace.id,configPath:g.URI.parse(T.workspace.configPath)}}):r(T)?A.workspaces.push({label:N,remoteAuthority:U,folderUri:g.URI.parse(T.folderUri)}):c(T)&&A.files.push({label:N,remoteAuthority:U,fileUri:g.URI.parse(T.fileUri)})})}return A}function I(D){const j={entries:[]};for(const A of D.workspaces)v(A)?j.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):j.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of D.files)j.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return j}}),define(oe[99],ae([0,1,87,13,4,19]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0,e.$Lac=P,e.$Mac=E,e.$Nac=h,e.$Kac=128/4;function P(u){function g(){let y=u.scheme===R.Schemas.file?(0,M.$Og)(u):u.toString();return S.$k||(y=y.toLowerCase()),(0,i.createHash)("md5").update(y).digest("hex")}return{id:g(),configPath:u}}function E(u,g){function y(){if(u.scheme!==R.Schemas.file)return(0,i.createHash)("md5").update(u.toString()).digest("hex");if(!g)return;let w;return S.$k?w=g.ino:S.$j?w=g.birthtime.getTime():S.$i&&(typeof g.birthtimeMs=="number"?w=Math.floor(g.birthtimeMs):w=g.birthtime.getTime()),(0,i.createHash)("md5").update(u.fsPath).update(w?String(w):"").digest("hex")}const k=y();if(typeof k=="string")return{id:k,uri:u}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[100],ae([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$ei=e.$di=e.$ci=void 0,e.$fi=s,e.$gi=n,e.$ii=b,e.$ji=I;class v{traceSocketEvent(j,A){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,j,A)}constructor(j,A=""){this.f=!0,this.debugLabel=A,this.socket=j,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,E.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(j){const A=C=>{this.traceSocketEvent("read",C),j(P.$ze.wrap(C))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(j){const A=C=>{j({type:0,hadError:C,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(j){const A=()=>{j()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(j){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",j),this.socket.write(j.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,E.$1)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,E.$1)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((j,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),j();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),j()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ci=v;var p;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var $;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})($||($={}));class f extends u.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(j,A){this.socket.traceSocketEvent(j,A)}constructor(j,A,C,W){super(),this.f=this.B(new h.$_d),this.g=this.B(new h.$_d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=j,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:C?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new l(this,A,C,W,this.f,(T,N)=>this.m(T,N))),this.B(this.a.onError(T=>{console.error(T),(0,E.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new m.$0h,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(j){return this.f.event(j)}onClose(j){return this.g.event(j)}onEnd(j){return this.socket.onEnd(j)}write(j){let A=0;for(;A<j.byteLength;)this.a.writeMessage(j.slice(A,Math.min(A+262144,j.byteLength)),{compressed:!0,opcode:2}),A+=262144}m(j,{compressed:A,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",j);let W=2;j.byteLength<126?W+=0:j.byteLength<2**16?W+=2:W+=8;const T=P.$ze.alloc(W),N=A?64:0,U=C&15;if(T.writeUInt8(128|N|U,0),j.byteLength<126)T.writeUInt8(j.byteLength,1);else if(j.byteLength<2**16){T.writeUInt8(126,1);let ue=1;T.writeUInt8(j.byteLength>>>8&255,++ue),T.writeUInt8(j.byteLength>>>0&255,++ue)}else{T.writeUInt8(127,1);let ue=1;T.writeUInt8(0,++ue),T.writeUInt8(0,++ue),T.writeUInt8(0,++ue),T.writeUInt8(0,++ue),T.writeUInt8(j.byteLength>>>24&255,++ue),T.writeUInt8(j.byteLength>>>16&255,++ue),T.writeUInt8(j.byteLength>>>8&255,++ue),T.writeUInt8(j.byteLength>>>0&255,++ue)}this.socket.write(P.$ze.concat([T,j]))}end(){this.h=!0,this.socket.end()}n(j){if(j.byteLength!==0){for(this.b.acceptChunk(j);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),C=A.readUInt8(0),W=(C&128)>>>7,T=(C&64)>>>6,N=C&15,U=A.readUInt8(1),ue=(U&128)>>>7,ie=U&127;this.j.state=2,this.j.readLen=2+(ue?4:0)+(ie===126?2:0)+(ie===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),C=A.readUInt8(1),W=(C&128)>>>7;let T=C&127,N=1;T===126?T=A.readUInt8(++N)*2**8+A.readUInt8(++N):T===127&&(T=A.readUInt8(++N)*0+A.readUInt8(++N)*0+A.readUInt8(++N)*0+A.readUInt8(++N)*0+A.readUInt8(++N)*2**24+A.readUInt8(++N)*2**16+A.readUInt8(++N)*2**8+A.readUInt8(++N));let U=0;W&&(U=A.readUInt8(++N)*2**24+A.readUInt8(++N)*2**16+A.readUInt8(++N)*2**8+A.readUInt8(++N)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$di=f;class l extends u.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.$ze.alloc(0)}constructor(j,A,C,W,T,N){super(),this.n=j,this.r=T,this.s=N,this.a=this.B(new h.$_d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$_d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$_d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new d(this.n,W,C,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(j,A){this.g.push({data:j,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:j,options:A}=this.g.shift();if(this.f&&A.compressed){const C=await this.w(this.f,j);this.s(C,A)}else this.s(j,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(j,A){return new Promise((C,W)=>{j.write(A),j.flush(T=>C(T))})}acceptFrame(j,A,C){this.h.push({data:j,isCompressed:A,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const j=this.h.shift();if(this.b&&j.isCompressed){const A=await this.C(this.b,j.data,j.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(j.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(j,A,C){return new Promise((W,T)=>{j.write(A),C&&j.write(P.$ze.fromByteArray([0,0,255,255])),j.flush(N=>W(N))})}}class d extends u.$Uc{get recordedInflateBytes(){return this.j?P.$ze.concat(this.f):P.$ze.alloc(0)}constructor(j,A,C,W){super(),this.h=j,this.j=A,this.a=this.B(new h.$_d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(W),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(P.$ze.wrap(T))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(j){this.j&&this.f.push(j.clone()),this.h.traceSocketEvent("zlibInflateWrite",j),this.b.write(j.buffer)}flush(j){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=P.$ze.concat(this.g);this.g.length=0,j(A)})}}class a extends u.$Uc{constructor(j,A){super(),this.g=j,this.a=this.B(new h.$_d),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(P.$ze.wrap(C))})}write(j){this.g.traceSocketEvent("zlibDeflateWrite",j.buffer),this.b.write(j.buffer)}flush(j){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=P.$ze.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),j(A)})}}function t(D,j){if(j===0)return;const A=D.byteLength>>>2;for(let ue=0;ue<A;ue++){const ie=D.readUInt32BE(ue*4);D.writeUInt32BE(ie^j,ue*4)}const C=A*4,W=D.byteLength-C,T=j>>>24&255,N=j>>>16&255,U=j>>>8&255;W>=1&&D.writeUInt8(D.readUInt8(C)^T,C),W>=2&&D.writeUInt8(D.readUInt8(C+1)^N,C+1),W>=3&&D.writeUInt8(D.readUInt8(C+2)^U,C+2)}e.$ei=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function s(){const D=(0,k.$Jg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const j=process.platform!=="darwin"&&e.$ei?e.$ei:(0,S.tmpdir)(),A=(0,g.$kc)(j,`vscode-ipc-${D}.sock`);return r(A),A}function n(D,j,A){const W=(0,i.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${A}-${j}-sock`;const T=A.substr(0,4),N=j.substr(0,6);let U;return process.platform!=="darwin"&&e.$ei&&!process.env.VSCODE_PORTABLE?U=(0,g.$kc)(e.$ei,`vscode-${W}-${T}-${N}.sock`):U=(0,g.$kc)(D,`${T}-${N}.sock`),r(U),U}function r(D){const j=o[y.$u];typeof j=="number"&&D.length>=j&&console.warn(`WARNING: IPC handle "${D}" is longer than ${j} chars, try a shorter --user-data-dir`)}class c extends w.$4h{static b(j){const A=h.Event.fromNodeEventEmitter(j,"connection");return h.Event.map(A,C=>({protocol:new m.$$h(new v(C,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(C,"close"))}))}constructor(j){super(c.b(j)),this.d=j}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hi=c;function b(D){return new Promise((j,A)=>{const C=(0,R.createServer)();C.on("error",A),C.listen(D,()=>{C.removeListener("error",A),j(new c(C))})})}function I(D,j){return new Promise((A,C)=>{const W=(0,R.createConnection)(D,()=>{W.removeListener("error",C),A(m.$_h.fromSocket(new v(W,`ipc-client${j}`),j))});W.once("error",C)})}}),define(oe[24],ae([0,1,51,9,4,100,38,91,6]),function(Q,e,i,R,S,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=e.$rac=void 0,e.$rac=(0,h.$oi)(P.$ui);class u extends E.$Zm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$gi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const k=y.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[y]?process.env[k]=process.env[y]:delete process.env[k]}}}restoreSnapExportedVariables(){if(S.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$sac=u,Ee([i.$Rh],u.prototype,"cachedLanguagesPath",null),Ee([i.$Rh],u.prototype,"backupHome",null),Ee([i.$Rh],u.prototype,"mainIPCHandle",null),Ee([i.$Rh],u.prototype,"mainLockfile",null),Ee([i.$Rh],u.prototype,"disableUpdates",null),Ee([i.$Rh],u.prototype,"crossOriginIsolated",null),Ee([i.$Rh],u.prototype,"codeCachePath",null),Ee([i.$Rh],u.prototype,"useCodeCache",null)}),define(oe[287],ae([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;let l=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,s){this.j=a,this.k=t,this.l=o,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Rg,this.i={isEqual:(n,r)=>(0,R.$mg)(n,r,!P.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,u.$uac)(a)),this.e=await this.v((0,u.$vac)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$gl.OFF}q(){return this.s()===w.$gl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$gl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const o=(0,M.$kc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,M.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,M.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const s of a){const n=s.workspace;if(!(0,p.$Ci)(n))return[];if(!t.has(n.id)){t.add(n.id);const r=(0,M.$kc)(this.c,n.id);await this.B(r)?n.configPath.scheme!==S.Schemas.file||await h.Promises.exists(n.configPath.fsPath)?o.push(s):await this.z(r):await this.x(r)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const n=s.folderUri,r=this.h.getComparisonKey(n);if(!o.has(r)){o.add(r);const c=(0,M.$kc)(this.c,this.D(s));await this.B(c)?n.scheme!==S.Schemas.file||await h.Promises.exists(n.fsPath)?t.push(s):await this.z(c):await this.x(c)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const n=s.backupFolder;if(typeof n!="string")return[];if(!o.has(n)){o.add(n);const r=(0,M.$kc)(this.c,n);await this.B(r)?t.push(s):await this.x(r)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,$.$Nac)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,$.$Nac)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,M.$kc)(this.c,t.backupFolder);try{await h.Promises.rename(a,o,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,u.$tac)(a)?t=(0,M.$kc)(this.c,a.backupFolder):(0,v.$7eb)(a)?t=(0,M.$kc)(this.c,this.D(a)):t=(0,M.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const o of t)try{if((await h.Promises.readdir((0,M.$kc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const s={folderUri:t.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const s={backupFolder:t};return o&&(s.remoteAuthority=o),s})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===S.Schemas.file?o=P.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,i.createHash)("md5").update(o).digest("hex")}};e.$7ac=l,e.$7ac=l=f=Ee([ne(0,y.$rac),ne(1,g.$Ti),ne(2,m.$Tj),ne(3,k.$$P)],l)}),define(oe[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.LifecycleMainPhase=e.ShutdownReason=e.$Vac=void 0,e.$Vac=(0,g.$ni)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var p;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let $=class extends P.$Uc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,d,a){super(),this.F=l,this.G=d,this.H=a,this.c=this.B(new M.$_d),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$_d),this.onWillShutdown=this.f.event,this.g=this.B(new M.$_d),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$_d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};i.app.addListener("before-quit",l);const d=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&i.app.quit()};i.app.addListener("window-all-closed",d),i.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.app.removeListener("before-quit",l),i.app.removeListener("window-all-closed",d),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}L(l){if(this.y)return this.y;const d=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:l,join(t,o){d.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{d.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const d=this.C.get(this.n);d&&(d.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let d=this.C.get(l);d||(d=new S.$mh,this.C.set(l,d)),await d.wait()}registerWindow(l){const d=new P.$Tc;this.t++,d.add(l.onWillLoad(t=>this.g.fire({window:l,workspace:t.workspace,reason:t.reason})));const a=(0,u.$_f)(l.win);a.on("close",t=>{const o=l.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),t.preventDefault(),this.unload(l,1).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(l),l.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,d.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}registerAuxWindow(l){const d=(0,u.$_f)(l.win);d.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${l.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),d.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${l.id}`)})}async reload(l,d){await this.unload(l,3)||l.reload(d)}unload(l,d){const a=this.z.get(l.id);if(a)return a;const t=this.M(l,d).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,t),t}async M(l,d){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const a=this.j?2:d,t=await this.P(l,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(t)):(await this.Q(l,a),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,d){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;R.$jW.once(o,()=>{a(!1)}),R.$jW.once(s,()=>{a(!0)}),l.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:d})})}Q(l,d){return new Promise(a=>{const o=`vscode:reply${this.s++}`;R.$jW.once(o,()=>a()),l.send("vscode:onWillUnload",{replyChannel:o,reason:d})})}quit(l){return this.R(l).then(d=>{if(!d&&l)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return d})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(m.b,!0),this.u=new Promise(d=>{this.w=d,this.S("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const d=process.argv.slice(1);if(l?.addArgs&&d.push(...l.addArgs),l?.removeArgs)for(const o of l.removeArgs){const s=d.indexOf(o);s>=0&&d.splice(s,1)}const a=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:d}))};i.app.once("quit",a),await this.quit(!0)&&i.app.removeListener("quit",a)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,S.$oh)(1e3),(async()=>{for(const d of i.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let a;d.webContents&&!d.webContents.isDestroyed()?a=new Promise(t=>d.once("closed",t)):a=Promise.resolve(),d.destroy(),await a}})()]),i.app.exit(l)}};e.$Wac=$,e.$Wac=$=m=Ee([ne(0,y.$Tj),ne(1,k.$$P),ne(2,w.$rac)],$)}),define(oe[288],ae([0,1,4,3,2,6,20]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=e.$rbc=void 0,e.$rbc=(0,M.$ni)("keyboardLayoutMainService");let E=class extends S.$Uc{constructor(g){super(),this.a=this.B(new R.$_d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((y,k)=>{Q(["native-keymap"],y,k)});this.c=h(g),i.$t||g.onDidChangeKeyboardLayout(()=>{this.c=h(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$sbc=E,e.$sbc=E=Ee([ne(0,P.$Vac)],E);function h(u){const g=u.getKeyMap(),y=u.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:y}}}),define(oe[289],ae([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0,e.$Nr=p;let m=class extends y.$Fp{constructor(f,l,d,a){super(a),this.m=f,this.n=l,this.r=d,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,l){const{f:d,g:a}=this;let t;try{t=await(0,u.$xm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(n)))}const o={...process.env,...t},s=f.agent?f.agent:await(0,k.$Lr)(f.url||"",o,{proxyUrl:d,strictSSL:a});return f.agent=s,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>p(f,l))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((l,d)=>{Q(["@vscode/proxy-agent"],l,d)})).loadSystemCertificates({log:this.r})}};e.$Mr=m,e.$Mr=m=Ee([ne(0,E.$Ti),ne(1,h.$vi),ne(2,g.$Tj),ne(3,g.$Uj)],m);async function v($){return((0,i.parse)($.url).protocol==="https:"?await new Promise((d,a)=>{Q(["https"],d,a)}):await new Promise((d,a)=>{Q(["http"],d,a)})).request}async function p($,f){return R.Promises.withAsyncBody(async(l,d)=>{const a=(0,i.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await v($),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,P.$7f)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const s=t(o,n=>{const r=(0,P.$5f)($.followRedirects)?$.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)p({...$,url:n.headers.location,followRedirects:r-1},f).then(l,d);else{let c=n;!$.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(c=n.pipe((0,w.createGunzip)())),l({res:n,stream:(0,S.$Oe)(c)})}});s.on("error",d),$.timeout&&s.setTimeout($.timeout),$.isChromiumNetwork&&s.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&s.write($.data),s.end(),f.onCancellationRequested(()=>{s.abort(),d(new M.$5)})})}}),define(oe[290],ae([0,1,14,289]),function(Q,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;function S(P){return i.net.request}class M extends R.$Mr{request(E,h){return super.request({...E||{},getRawRequest:S,isChromiumNetwork:!0},h)}}e.$ucc=M}),define(oe[84],ae([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=e.$3ac=e.$2ac=void 0,e.$2ac=(0,E.$ni)("storageMainService");let p=class extends S.$Uc{constructor(l,d,a,t,o,s){super(),this.c=l,this.f=d,this.g=a,this.h=t,this.j=o,this.m=s,this.a=void 0,this.b=this.B(new R.$_d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,d]of this.t)l.join("profileStorage",d.close());for(const[,d]of this.w)l.join("workspaceStorage",d.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const d=this.t.get(l.profile.id);d&&l.join(d.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new y.$Yac(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,g.$Up)(l))return this.applicationStorage;let d=this.t.get(l.id);if(!d){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),d=this.B(this.u(l)),this.t.set(l.id,d);const a=this.B(d.onDidChangeStorage(t=>this.b.fire({...t,storage:d,profile:l})));this.B(R.Event.once(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),a.dispose()}))}return d}u(l){return this.a===2?new y.$1ac(this.c,this.j):new y.$Xac(l,this.n(),this.c,this.j)}workspaceStorage(l){let d=this.w.get(l.id);return d||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),d=this.B(this.y(l)),this.w.set(l.id,d),this.B(R.Event.once(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),d}y(l){return this.a===2?new y.$1ac(this.c,this.j):new y.$Zac(l,this.n(),this.c,this.f,this.j)}isUsed(l){const d=i.URI.file(l);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(i.URI.file(a.path),d))return!0;return!1}};e.$3ac=p,e.$3ac=p=Ee([ne(0,u.$Tj),ne(1,M.$ui),ne(2,w.$Fac),ne(3,h.$Vac),ne(4,P.$Tk),ne(5,m.$rl)],p),e.$4ac=(0,E.$ni)("applicationStorageMainService");let $=class extends g.$Tp{constructor(l,d){super(),this.s=l,this.U=d,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$5ac=$,e.$5ac=$=Ee([ne(0,k.$tl),ne(1,e.$2ac)],$)}),define(oe[291],ae([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=e.$rcc=e.$qcc=void 0;async function $(t,o,s,n,r){let c;for(let b=3;b&&(c?.dispose(),c=await new f(t,o,s,n,r).waitForReady(),!(r&&S.$Mg[r]||!S.$Mg[c.tunnelLocalPort]));b--);return c}class f extends E.$Uc{constructor(o,s,n,r,c){super(),this.m=s,this.n=c,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=i.createServer(),this.c=new P.$mh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,s=(0,v.$0v)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,S.$Ng)(o,2,1e3,s),r=null;return this.b.listen(n,this.m),await this.c.wait(),r=this.b.address(),r||(n=0,this.b.listen(n,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(o){o.pause();const s=(0,v.$8v)(this.tunnelRemoteHost)||(0,v.$0v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,k.$Jl)(this.a,s,this.tunnelRemotePort),r=n.getSocket(),c=n.readEntireBuffer();n.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),r.end()}),o.on("close",()=>r.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),r instanceof M.$ci?r.socket.destroy():r.end()}),r instanceof M.$ci?this.t(o,r):this.s(o,r),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),r.end()})}s(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(n=>o.write(n.buffer)),o.on("data",n=>s.write(p.$ze.wrap(n))),o.resume()}t(o,s){const n=s.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.$qcc=f;let l=class extends v.$aw{constructor(o,s,n,r,c){super(s,c),this.v=o,this.w=n,this.y=r}isPortPrivileged(o){return(0,v.$$v)(o,this.m,h.OS,R.release())}t(o,s,n,r,c,b,I,D){const j=this.s(s,n);if(j)return++j.refcount,j.value;if((0,v.$4v)(o))return this.u(o,s,n,c,b,I,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${c}.`);const A={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=$(A,r,s,n,c);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,n,C),C}}};e.$rcc=l,e.$rcc=l=Ee([ne(0,w.$Dl),ne(1,g.$Tj),ne(2,m.$Gl),ne(3,y.$ak),ne(4,u.$Ti)],l);let d=class extends l{constructor(o,s,n,r,c){super(o,s,n,r,c)}};e.$scc=d,e.$scc=d=Ee([ne(0,w.$Dl),ne(1,g.$Tj),ne(2,m.$Gl),ne(3,y.$ak),ne(4,u.$Ti)],d);let a=class extends E.$Uc{constructor(o,s,n,r,c){super(),this.b=o,this.c=s,this.f=n,this.g=r,this.h=c,this.a=new Map}async openTunnel(o,s,n,r,c,b,I,D,j){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${b}.`),!this.a.has(o)){const A=new d(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(o,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(s,n,r,c,b,I,D,j)}};e.$tcc=a,e.$tcc=a=Ee([ne(0,w.$Dl),ne(1,g.$Tj),ne(2,y.$ak),ne(3,m.$Gl),ne(4,u.$Ti)],a)}),define(oe[101],ae([0,1,8,23,3,18,24,20,5,27,53,50]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0,e.$Obc=k;function k(m,v,p){return`${p.updateUrl}/api/update/${m}/${v}/${p.commit}`}let w=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,p,$,f,l,d){this.f=v,this.g=p,this.h=$,this.i=f,this.j=l,this.k=d,this.b=y.$hX.Uninitialized,this.c=new S.$_d,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$hX.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$hX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$hX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),p=this.m(v);if(!p){this.d(y.$hX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(y.$hX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(y.$hX.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,i.$oh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$Pbc=w,e.$Pbc=w=Ee([ne(0,E.$Vac),ne(1,M.$Ti),ne(2,P.$rac),ne(3,g.$Ep),ne(4,h.$Tj),ne(5,u.$ak)],w)}),define(oe[292],ae([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;let p=class extends v.$Pbc{get v(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"error",(f,l)=>l)}get w(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(f,l,d,a)=>({version:d,productVersion:d,timestamp:a}))}constructor(f,l,d,a,t,o,s){super(f,l,a,t,o,s),this.z=d,this.u=new P.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,M.$bj)(String(f)))}),this.j.error("UpdateService error:",f);const l=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$hX.Idle(1,l))}s(f){let l;this.k.darwinUniversalAssetId?l=this.k.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,v.$Obc)(l,f,this.k);try{i.autoUpdater.setFeedURL({url:d})}catch(a){this.j.error("Failed to set update feed URL",a);return}return d}t(f){this.d(m.$hX.CheckingForUpdates(f)),i.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(m.$hX.Downloading)}F(f){this.state.type==="downloading"&&(this.d(m.$hX.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$hX.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$hX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Qbc=p,Ee([R.$Rh],p.prototype,"v",null),Ee([R.$Rh],p.prototype,"w",null),Ee([R.$Rh],p.prototype,"x",null),Ee([R.$Rh],p.prototype,"y",null),e.$Qbc=p=Ee([ne(0,u.$Vac),ne(1,E.$Ti),ne(2,w.$Sl),ne(3,h.$rac),ne(4,k.$Ep),ne(5,g.$Tj),ne(6,y.$ak)],p)}),define(oe[293],ae([0,1,49,43,8,3,9,24,20,5,28,50]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;let k=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,p,$){if(this.f=v,this.g=$,this.a=y.$hX.Uninitialized,this.b=new M.$_d,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$hX.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,S.$oh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};k=Ee([ne(0,h.$Vac),ne(1,E.$rac),ne(2,u.$Tj)],k);let w=class extends k{constructor(v,p,$,f,l,d){super($,f,l),this.o=v,this.p=p,this.q=d;const a=(0,R.watch)(P.$nc(this.o)),t=M.Event.fromNodeEventEmitter(a,"change",(r,c)=>c),o=M.Event.filter(t,r=>r==="current"),n=M.Event.debounce(o,(r,c)=>c,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{n.dispose(),a.close()})}m(){this.d(y.$hX.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$hX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$hX.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$hX.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+P.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise(($,f)=>(0,R.realpath)(`${P.$nc(this.o)}/current`,(l,d)=>l?f(l):$(d))),p=P.$oc(v);return this.p!==p}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Sbc=w,e.$Sbc=w=Ee([ne(2,h.$Vac),ne(3,E.$rac),ne(4,u.$Tj),ne(5,g.$Sl)],w)}),define(oe[29],ae([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Cac=void 0,e.$Dac=m,e.$Eac=v,e.$Cac=(0,S.$ni)("windowsMainService");var w;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(w||(e.OpenContext=w={}));function m($,f,l){const d=$.get(E.$Aac),a=$.get(h.$ak),t=$.get(u.$Ti),o=$.get(g.$rac),s=t.getValue("window"),n={backgroundColor:d.getBackgroundColor(),minWidth:P.$iD.WIDTH,minHeight:P.$iD.HEIGHT,title:a.nameLong,...l,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.$tD)(f.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...l?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(R.$k?n.icon=(0,y.$kc)(o.appRoot,"resources/linux/code.png"):R.$i&&!o.isBuilt&&(n.icon=(0,y.$kc)(o.appRoot,"resources/win32/code_150x150.png")),R.$j&&(n.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(n.acceptFirstMouse=!1)),R.$j&&!(0,P.$sD)(t)&&(n.fullscreenable=!1),R.$j&&s?.nativeTabs===!0&&(n.tabbingIdentifier=a.nameShort),!(0,P.$pD)(t)&&(n.titleBarStyle="hidden",R.$j||(n.frame=!1),(0,P.$rD)(t))){const b=d.getWindowSplash()?.colorInfo.titleBarBackground??d.getBackgroundColor(),I=k.$Ct.fromHex(b).isDarker()?"#FFFFFF":"#000000";n.titleBarOverlay={height:29,color:b,symbolColor:I}}return n}function v($){let f,l=Number.MIN_VALUE;for(const d of $)d.lastFocusTime>l&&(l=d.lastFocusTime,f=d);return f}var p;(function($){function f(d,a,t=i.screen.getAllDisplays()){if(d.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){d.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){d.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const n=l(t[0]);if(d.trace("window#validateWindowState: single monitor working area",n),n){let r=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!n||(a.x<n.x&&(a.x=n.x),a.y<n.y&&(a.y=n.y))};r(),a.width>n.width&&(a.width=n.width),a.height>n.height&&(a.height=n.height),a.x>n.x+n.width-128&&(a.x=n.x+n.width-a.width),a.y>n.y+n.height-128&&(a.y=n.y+n.height-a.height),r()}return a}if(a.display&&a.mode===3){const n=t.find(r=>r.id===a.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){d.trace("window#validateWindowState: restoring fullscreen to previous display");const r=(0,M.$pac)(3);return r.x=n.bounds.x,r.y=n.bounds.y,r}}let o,s;try{o=i.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=l(o),d.trace("window#validateWindowState: multi-monitor working area",s)}catch(n){d.error("window#validateWindowState: error finding display for window state",n)}if(o&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;d.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=f;function l(d){if(d.workArea.width>0&&d.workArea.height>0)return d.workArea;if(d.bounds.width>0&&d.bounds.height>0)return d.bounds}})(p||(e.WindowStateValidator=p={}))}),define(oe[294],ae([0,1,14,23,3,46,2,33,120,5,84,29]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let w=class extends P.$Uc{constructor(v,p,$,f){super(),this.g=v,this.h=p,this.j=$,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const v=S.Event.fromNodeEventEmitter(i.app,"login",(p,$,f,l,d)=>({event:p,webContents:$,req:f,authInfo:l,callback:d}));this.B(v(this.r,this))}async r({event:v,authInfo:p,req:$,callback:f}){if(!p.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{l=await this.b}finally{this.b=void 0}}f(l?.username,l?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(v);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const p=String((0,M.$bj)({scheme:v.scheme,host:v.host,port:v.port}));let $,f;try{const t=this.m.get(this.a+p,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));$=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof $=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:$,password:f};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const d={authInfo:v,username:this.f?.username??$,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Jg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,d),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(s,n,r)=>{if(n===d.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",o),r){const c={username:r.username,password:r.password};try{if(r.remember){const b=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+p,b,-1,1)}else this.m.remove(this.a+p,-1)}catch(b){this.g.error(b)}t({username:c.username,password:c.password})}else t(void 0)};l.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$6ac=w,e.$6ac=w=Ee([ne(0,u.$Tj),ne(1,y.$Cac),ne(2,h.$5W),ne(3,g.$4ac)],w)}),define(oe[295],ae([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=e.ID=void 0,e.ID="launchMainService",e.$ubc=(0,u.$ni)(e.ID);let w=class{constructor(v,p,$,f){this.a=v,this.b=p,this.c=$,this.d=f}async start(v,p){this.a.trace("Received data from other instance: ",v,p),S.$j&&i.app.focus({steal:!0});const $=this.e(v);if($.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(f=l.ready())}f.then(()=>{for(const{uri:l,originalUrl:d}of $)this.c.open(l,{originalUrl:d})})}else return this.f(v,p)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,R.$Hb)(v._urls.map(p=>{try{return{uri:M.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(v,p){const $=(0,h.$rm)(p)?0:4;let f=[];const l=v.wait&&v.waitMarkerFilePath?M.URI.file(v.waitMarkerFilePath):void 0,d=v.remote||void 0,a={context:$,cli:v,userEnv:v["preserve-env"]||$===0?p:void 0,waitMarkerFileURI:l,remoteAuthority:d,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!S.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(l&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,P.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$vbc=w,e.$vbc=w=Ee([ne(0,g.$Tj),ne(1,k.$Cac),ne(2,y.$$W),ne(3,E.$Ti)],w)}),define(oe[296],ae([0,1,2,20,57,30,8,29]),function(Q,e,i,R,S,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;let h=class extends i.$Uc{constructor(g,y,k){super(),this.a=y,this.b=k,this.B(g.onWillLoadWindow(w=>{w.reason===2&&this.c(w.window)})),this.B(g.onBeforeCloseWindow(w=>this.c(w))),this.B(new P.$zh(()=>this.g(),30*1e3)).schedule()}async c(g){const y=this.f(g),k=this.a.getProfileForWorkspace(y);k?.isTransient&&(this.a.unsetWorkspace(y,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,M.$Bi)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const y=this.b.getWindows().map(k=>this.f(k));for(const k of g)y.some(w=>w.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$$bc=h,e.$$bc=h=Ee([ne(0,R.$Vac),ne(1,S.$Fac),ne(2,E.$Cac)],h)}),define(oe[61],ae([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=void 0;function f(a){return typeof a.responseWindowId=="number"}let l=class extends R.$Uc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,s){super(),this.u=t,this.w=o,this.y=s,this.c=String(++$.a),this.f=this.B(new S.$_d),this.onStdout=this.f.event,this.g=this.B(new S.$_d),this.onStderr=this.g.event,this.h=this.B(new S.$_d),this.onMessage=this.h.event,this.j=this.B(new S.$_d),this.onSpawn=this.j.event,this.m=this.B(new S.$_d),this.onExit=this.m.event,this.n=this.B(new S.$_d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case g.default.Error:this.u.error(s);break;case g.default.Warning:this.u.warn(s);break;case g.default.Info:this.u.trace(s);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",g.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,s=h.$Hg.asFileUri("bootstrap-fork.js").fsPath,n=this.t.args??[],r=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,I="pipe",D=this.F(t);return this.z("creating new...",g.default.Info),this.r=i.utilityProcess.fork(s,n,{serviceName:o,env:D,execArgv:r,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:b,stdio:I}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Tn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,w.$em)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}G(t,o,s){if(t.stdout){const n=new P.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stdout,"data")(r=>this.f.fire(typeof r=="string"?r:n.write(r))))}if(t.stderr){const n=new P.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stderr,"data")(r=>this.g.fire(typeof r=="string"?r:n.write(r))))}this.B(S.Event.fromNodeEventEmitter(t,"message")(n=>this.h.fire(n))),this.B(S.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",g.default.Info),this.j.fire(t.pid)})),this.B(S.Event.fromNodeEventEmitter(t,"exit")(n=>{this.z(`received exit event with code ${n}`,g.default.Info),this.m.fire({pid:this.s,code:n,signal:"unknown"}),this.H()})),this.B(S.Event.fromNodeEventEmitter(i.app,"child-process-gone",(n,r)=>({event:n,details:r}))(({details:n})=>{n.type==="Utility"&&n.name===s&&(this.z(`crashed with code ${n.exitCode} and reason '${n.reason}'`,g.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:n.reason,code:n.exitCode}),this.n.fire({pid:this.s,code:n.exitCode,reason:n.reason}),this.H())}))}once(t,o){const s=this.B(this.h.event(n=>{n===t&&(s.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:s}=new i.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",g.default.Info),this.r.kill()?(this.z("successfully killed the process",g.default.Info),this.H()):this.z("unable to kill the process",g.default.Warning)}H(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",g.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,E.$oh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$9ac=l,e.$9ac=l=$=Ee([ne(0,M.$Tj),ne(1,y.$Sl),ne(2,k.$Vac)],l);let d=class extends l{constructor(t,o,s,n){super(t,s,n),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const n=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[n]),!0}J(t,o){o.windowLifecycleBound&&(this.B(S.Event.filter(this.y.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$0ac=d,e.$0ac=d=Ee([ne(0,M.$Tj),ne(1,u.$Cac),ne(2,y.$Sl),ne(3,k.$Vac)],d)}),define(oe[297],ae([0,1,15,3,5,20,8,61,29,28]),function(Q,e,i,R,S,M,P,E,h,u){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;let y=class{static{g=this}static{this.a=0}constructor(w,m,v,p){this.d=w,this.f=m,this.g=v,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(w){const m=this.b.get(w);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(w){return this.i(w).onStdout}onDynamicStderr(w){return this.i(w).onStderr}onDynamicMessage(w){return this.i(w).onMessage}onDynamicExit(w){return this.i(w).onExit}async createExtensionHost(){if(this.c)throw(0,i.$6)();const w=String(++g.a),m=new E.$0ac(this.d,this.g,this.h,this.f);return this.b.set(w,m),m.onExit(({pid:v,code:p,signal:$})=>{this.d.info(`Extension host with pid ${v} exited with code: ${p}, signal: ${$}.`),setTimeout(()=>{m.dispose(),this.b.delete(w)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:w}}async start(w,m){if(this.c)throw(0,i.$6)();const v=this.i(w);return v.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:w}),{pid:await R.Event.toPromise(v.onSpawn)}}async enableInspectPort(w){if(this.c)throw(0,i.$6)();const m=this.b.get(w);return m?m.enableInspectPort():!1}async kill(w){if(this.c)throw(0,i.$6)();const m=this.b.get(w);m&&m.kill()}async _killAllNow(){for(const[,w]of this.b)w.kill()}async _waitForAllExit(w){const m=[];for(const[,v]of this.b)m.push(v.waitForExit(w));return P.Promises.settled(m).then(()=>{})}};e.$ebc=y,e.$ebc=y=g=Ee([ne(0,S.$Tj),ne(1,M.$Vac),ne(2,h.$Cac),ne(3,u.$Sl)],y)}),define(oe[298],ae([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;let p=class extends S.$Uc{constructor(f,l,d,a,t,o,s,n){super(),this.f=f,this.g=l,this.h=d,this.j=a,this.m=t,this.n=o,this.r=s,this.s=n,this.a=new R.$mh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){i.$jW.on(v.$Gbc.request,(f,l)=>this.u(f,l,v.$Gbc.response)),i.$jW.on(v.$Hbc.request,(f,l)=>this.u(f,l,v.$Hbc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,l,d){this.n.trace(`[SharedProcess] onWindowConnection for: ${d}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(d);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(d,l,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$Fbc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new R.$Kh;this.b?.once(v.$Fbc.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new R.$Kh;this.b?.once(v.$Fbc.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$9ac(this.n,k.$$o,this.m)),this.c=this.b.onMessage(d=>{typeof d.warning=="string"?this.n.warn(d.warning):typeof d.error=="string"&&this.n.error(d.error)});const f=(0,w.$2m)(this.h.args,this.h.isBuilt);let l;f.port&&(l=["--nolazy"],f.break?l.push(`--inspect-brk=${f.port}`):l.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:l})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,m.$_f)(this.b).connect(f)}};e.$Ibc=p,e.$Ibc=p=Ee([ne(2,M.$rac),ne(3,h.$tl),ne(4,P.$Vac),ne(5,E.$Tj),ne(6,g.$Qac),ne(7,u.$8n)],p)}),define(oe[299],ae([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;let v=class extends g.$Uc{constructor($,f,l,d,a){super(),this.f=$,this.g=f,this.h=l,this.j=d,this.m=a,this.a=void 0,this.b=new y.$_d,this.onRequestConnection=this.b.event,this.c=new y.$_d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),u.$jW.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,g.$Sc)(()=>{u.$jW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$9ac(this.m,P.$$o,this.j);const $=(0,R.$1m)(this.h.args,this.h.isBuilt),f=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),d=new h.$rW(l,"ptyHost"),a=new g.$Tc;return a.add(d),a.add((0,g.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:d,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,k.$Tn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&($.VSCODE_LATENCY=String(f));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&($.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),$}r($,f){this.b.fire();const l=this.a.connect();if($.sender.isDestroyed()){l.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[l])}};e.$icc=v,e.$icc=v=Ee([ne(1,w.$Ti),ne(2,i.$rac),ne(3,S.$Vac),ne(4,M.$Tj)],v)}),define(oe[300],ae([0,1,2,6,5,29,61,28,46,3,8,20]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0,e.$gcc=(0,R.$ni)("utilityProcessWorker");let k=class extends i.$Uc{constructor(v,p,$,f){super(),this.b=v,this.c=p,this.f=$,this.g=f,this.a=new Map}async createWorker(v){const p=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const $=this.h(v);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(v));const f=new w(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,f);const l=new g.$Kh;return u.Event.once(f.onDidTerminate)(d=>{d.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${d.code}, signal: ${d.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${d.code}, signal: ${d.signal}`),this.a.delete($),l.complete({reason:d})}),l.p}h(v){return(0,h.$bj)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const p=this.h(v),$=this.a.get(p);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),$.kill(),this.a.delete(p))}};e.$hcc=k,e.$hcc=k=Ee([ne(0,S.$Tj),ne(1,M.$Cac),ne(2,E.$Sl),ne(3,y.$Vac)],k);let w=class extends i.$Uc{constructor(v,p,$,f,l){super(),this.c=v,this.f=p,this.g=$,this.h=f,this.j=l,this.a=this.B(new u.$_d),this.onDidTerminate=this.a.event,this.b=new P.$0ac(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Ee([ne(0,S.$Tj),ne(1,M.$Cac),ne(2,E.$Sl),ne(3,y.$Vac)],w)}),define(oe[301],ae([0,1,14,3,2,277,29]),function(Q,e,i,R,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;let E=class extends S.$Uc{constructor(u){super(),this.b=u,this.a=this.B(new R.$_d),this.onFoundInFrame=this.a.event,this.B(new M.$Zbc)}async setIgnoreMenuShortcuts(u,g){let y;if(typeof u.windowId=="number"){const{windowId:k}=u,w=this.b.getWindowById(k);if(!w?.win)throw new Error(`Invalid windowId: ${k}`);y=w.win.webContents}else{const{webContentsId:k}=u;if(y=i.webContents.fromId(k),!y)throw new Error(`Invalid webContentsId: ${k}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(g)}async findInFrame(u,g,y,k){const m=this.c(u,g);if(typeof m.findInFrame=="function"){m.findInFrame(y,{findNext:k.findNext,forward:k.forward});const v=(p,$)=>{$.finalUpdate&&(this.a.fire($),m.removeListener("found-in-frame",v))};m.on("found-in-frame",v)}}async stopFindInFrame(u,g,y){const w=this.c(u,g);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(u,g){const y=this.b.getWindowById(u.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${u}`);const k=y.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===g);if(!k)throw new Error(`Unknown frame: ${g}`);return k}};e.$1bc=E,e.$1bc=E=Ee([ne(0,P.$Cac)],E)}),define(oe[302],ae([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0,e.$3bc=p,e.$4bc=f;let v=class extends R.$Uc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,s,n){super(),this.g=a,this.h=t,this.j=o,this.m=s,this.n=n,this.b=p(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){i.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(r=>!r.isExtensionDevelopmentHost)),n&&(t.lastActiveWindow=this.w(n),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const r=this.w(n);return r.uiState.mode===3&&(a.has(r.uiState.display)?S.$j&&r.windowId!==t.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(r.uiState.mode=1):a.add(r.uiState.display)),r}));const s=f(t);this.h.setItem(m.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const s=(0,w.$Ci)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,n=(0,w.$xi)(a.openedWorkspace)&&o.folderUri&&M.$Rg.isEqual(o.folderUri,a.openedWorkspace.uri);(s||n)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,w.$Ci)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,w.$xi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||o?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,w.$Ci)(b)){const D=this.state.openedWindows.filter(j=>j.workspace&&j.workspace.id===b.id).map(j=>j.uiState);if(D.length)return D[0]}if((0,w.$xi)(b)){const D=this.state.openedWindows.filter(j=>j.folderUri&&M.$Rg.isEqual(j.folderUri,b.uri)).map(j=>j.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(j=>j.backupPath===a.backupPath).map(j=>j.uiState);if(D.length)return D[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let o;const s=i.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(S.$j){const b=i.screen.getCursorScreenPoint();o=i.screen.getDisplayNearestPoint(b)}!o&&t&&(o=i.screen.getDisplayMatching(t.getBounds())),o||(o=i.screen.getPrimaryDisplay()||s[0])}let n=(0,k.$pac)();n.x=Math.round(o.bounds.x+o.bounds.width/2-n.width/2),n.y=Math.round(o.bounds.y+o.bounds.height/2-n.height/2);const r=this.n.getValue("window");let c=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")n.mode=0,c=!1;else if(r.newWindowDimensions==="fullscreen")n.mode=3,c=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?n.mode=3:n={...b,zoomLevel:void 0},c=n.mode!==3&&r.newWindowDimensions==="offset"}}return c&&(n=this.C(n)),n.hasDefaultState=!0,n}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$2bc=v,e.$2bc=v=m=Ee([ne(0,y.$Cac),ne(1,g.$$P),ne(2,h.$Vac),ne(3,u.$Tj),ne(4,E.$Ti)],v);function p(d){const a={openedWindows:[]},t=d||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>$(o))),a}function $(d){const a={uiState:d.uiState};return d.backupPath&&(a.backupPath=d.backupPath),d.remoteAuthority&&(a.remoteAuthority=d.remoteAuthority),d.folder&&(a.folderUri=P.URI.parse(d.folder)),d.workspaceIdentifier&&(a.workspace={id:d.workspaceIdentifier.id,configPath:P.URI.parse(d.workspaceIdentifier.configURIPath)}),a}function f(d){return{lastActiveWindow:d.lastActiveWindow&&l(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&l(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(a=>l(a))}}function l(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(oe[58],ae([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0,e.$Oac=(0,m.$ni)("workspacesManagementMainService");let a=class extends M.$Uc{constructor(o,s,n,r,c){super(),this.g=o,this.h=s,this.j=n,this.m=r,this.n=c,this.a=this.B(new R.$_d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$_d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await u.Promises.readdir(this.c.with({scheme:P.Schemas.file}).fsPath)).map(s=>(0,h.$1g)(this.c,s,f.$Mi));for(const s of o){const n=(0,d.$Lac)(s),r=await this.resolveLocalWorkspace(s);r?this.f.push({workspace:n,remoteAuthority:r.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>u.Promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===P.Schemas.file)try{const n=s(o.fsPath);return n instanceof Promise?n.then(r=>this.t(o,r),r=>{}):this.t(o,n)}catch{return}}s(o){return(0,f.$Ni)(o,this.g)||(0,f.$Si)(o)}t(o,s){try{const n=this.u(o,s),r=(0,d.$Lac)(o);return{id:r.id,configPath:r.configPath,folders:(0,l.$cfb)(n.folders,r.configPath,h.$Rg),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.h.warn(n.toString())}}u(o,s){const n=(0,S.$An)(s);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(r=>(0,l.$afb)(r));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(o,s){const{workspace:n,storedWorkspace:r}=this.w(o,s),c=n.configPath.fsPath;return await u.Promises.mkdir((0,E.$nc)(c),{recursive:!0}),await u.Promises.writeFile(c,JSON.stringify(r,null,"	")),this.f.push({workspace:n,remoteAuthority:s}),n}w(o=[],s){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),r=(0,h.$1g)(this.c,n),c=(0,h.$1g)(r,f.$Mi),b=[];for(const I of o)b.push((0,l.$bfb)(I.uri,!0,I.name,r,h.$Rg));return{workspace:(0,d.$Lac)(c),storedWorkspace:{folders:b,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,d.$Lac)(o)}isUntitledWorkspace(o){return(0,f.$Ni)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,h.$Og)(o.configPath);try{await u.Promises.rm((0,E.$nc)(s));const n=(0,E.$kc)(this.g.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath,o.id);await u.Promises.exists(n)&&await u.Promises.writeFile((0,E.$kc)(n,"obsolete"),""),this.f=this.f.filter(r=>r.workspace.id!==o.id)}catch(n){this.h.warn(`Unable to delete untitled workspace ${s} (${n}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,n){if(!o||!o.win||!o.isReady||!await this.z(o,s,n))return;const c=await this.C(o,(0,d.$Lac)(n));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,s,n){return n?(0,f.$Ci)(o.openedWorkspace)&&h.$Rg.isEqual(o.openedWorkspace.configPath,n)?!1:(0,$.$Iac)(s,n)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,h.$Xg)(n)),detail:(0,g.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let n;return o.config.extensionDevelopmentPath||(o.config.backupPath?n=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):n=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,f.$Ci)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=n,{workspace:s,backupPath:n}}};e.$Pac=a,e.$Pac=a=Ee([ne(0,w.$rac),ne(1,v.$Tj),ne(2,p.$Fac),ne(3,y.$wac),ne(4,k.$xac)],a)}),define(oe[134],ae([0,1,14,37,23,6,29,30,58,12,5,61]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=e.ID=void 0,e.ID="diagnosticsMainService",e.$_ac=(0,M.$ni)(e.ID);let k=class{constructor(m,v,p){this.a=m,this.b=v,this.c=p}async getRemoteDiagnostics(m){const v=this.a.getWindows();return(await Promise.all(v.map(async $=>{const f=$.remoteAuthority;if(!f)return;const l=`vscode:getDiagnosticInfoResponse${$.id}`,d={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(a=>{$.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:l,args:d}),R.$jW.once(l,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const p of i.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(p.id);$?m.push(await this.d($)):m.push(this.e(p))}const v=[];for(const{pid:p,name:$}of y.$9ac.getAll())v.push({pid:p,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:v,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(m){const v=await this.f(m),p=(0,u.$_f)(m.win);return this.e(p,v,m.remoteAuthority)}e(m,v=[],p){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:v,remoteAuthority:p}}async f(m){const v=[],p=m.openedWorkspace;if((0,E.$xi)(p))v.push(p.uri);else if((0,E.$Ci)(p)){const $=await this.b.resolveLocalWorkspace(p.configPath);$&&$.folders.forEach(l=>{v.push(l.uri)})}return v}};e.$abc=k,e.$abc=k=Ee([ne(0,P.$Cac),ne(1,h.$Oac),ne(2,g.$Tj)],k)}),define(oe[70],ae([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n,r,c,b,I,D,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=void 0,e.$obc=(0,d.$ni)("nativeHostMainService");let C=class extends h.$Uc{constructor(T,N,U,ue,ie,le,Y,K,B){super(),this.a=T,this.b=N,this.c=U,this.f=ue,this.g=ie,this.h=le,this.j=Y,this.m=K,this.n=B,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:H,y:G})=>({windowId:L.id,x:H,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:H,y:G})=>({windowId:L.id,x:H,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,H)=>H.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,H)=>H.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,H)=>H.id),L=>!!this.b.getWindowById(L))),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,H)=>H.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$_d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(L,H,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(R.screen,"display-added"),E.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(T,N){const U=this.a.getWindows().map(ie=>({id:ie.id,workspace:ie.openedWorkspace??(0,r.$Bi)(ie.backupPath,ie.isExtensionDevelopmentHost),title:ie.win?.getTitle()??"",filename:ie.getRepresentedFilename(),dirty:ie.isDocumentEdited()})),ue=[];return N.includeAuxiliaryWindows&&ue.push(...this.b.getWindows().map(ie=>({id:ie.id,parentId:ie.parentId,title:ie.win?.getTitle()??"",filename:ie.getRepresentedFilename()}))),[...U,...ue]}async getWindowCount(T){return this.a.getWindowCount()}async getActiveWindowId(T){const N=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(T,N,U){return Array.isArray(N)?this.s(T,N,U):this.t(T,N)}async s(T,N,U=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:T,urisToOpen:N,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async t(T,N){await this.a.openEmptyWindow({context:5,contextWindowId:T},N)}async toggleFullScreen(T,N){this.C(N?.targetWindowId,T)?.toggleFullScreen()}async handleTitleDoubleClick(T,N){this.C(N?.targetWindowId,T)?.handleTitleDoubleClick()}async getCursorScreenPoint(T){const N=R.screen.getCursorScreenPoint(),U=R.screen.getDisplayNearestPoint(N);return{point:N,display:U.bounds}}async isMaximized(T,N){return this.C(N?.targetWindowId,T)?.win?.isMaximized()??!1}async maximizeWindow(T,N){this.C(N?.targetWindowId,T)?.win?.maximize()}async unmaximizeWindow(T,N){this.C(N?.targetWindowId,T)?.win?.unmaximize()}async minimizeWindow(T,N){this.C(N?.targetWindowId,T)?.win?.minimize()}async moveWindowTop(T,N){this.C(N?.targetWindowId,T)?.win?.moveTop()}async positionWindow(T,N,U){const ue=this.C(U?.targetWindowId,T);if(ue?.win){if(ue.win.isFullScreen()){const ie=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(ue.win,"leave-full-screen")));ue.win.setFullScreen(!1),await ie}ue.win.setBounds(N)}}async updateWindowControls(T,N){this.C(N?.targetWindowId,T)?.updateWindowControls(N)}async focusWindow(T,N){this.C(N?.targetWindowId,T)?.focus({force:N?.force??!1})}async setMinimumSize(T,N,U){const ue=this.D(T);if(ue?.win){const[ie,le]=ue.win.getSize(),[Y,K]=ue.win.getMinimumSize(),[B,L]=[N??Y,U??K],[H,G]=[Math.max(ie,B),Math.max(le,L)];(Y!==B||K!==L)&&ue.win.setMinimumSize(B,L),(ie!==H||le!==G)&&ue.win.setSize(H,G)}}async saveWindowSplash(T,N){this.m.saveWindowSplash(T,N)}async installShellCommand(T){const{source:N,target:U}=await this.u();try{const{symbolicLink:ue}=await v.SymlinkSupport.stat(N);if(ue&&!ue.dangling){const ie=await(0,w.$Uq)(N);if(U===ie)return}await v.Promises.unlink(N)}catch(ue){if(ue.code!=="ENOENT")throw ue}try{await v.Promises.symlink(U,N)}catch(ue){if(ue.code!=="EACCES"&&ue.code!=="ENOENT")throw ue;const{response:ie}=await this.showMessageBox(T,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(ie===1)throw new A.$5;try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${N}'\\" with administrator privileges"`;await(0,M.promisify)(i.exec)(le)}catch{throw new Error((0,$.localize)(3,null,N))}}}async uninstallShellCommand(T){const{source:N}=await this.u();try{await v.Promises.unlink(N)}catch(U){switch(U.code){case"EACCES":{const{response:ue}=await this.showMessageBox(T,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(ue===1)throw new A.$5;try{const ie=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,M.promisify)(i.exec)(ie)}catch{throw new Error((0,$.localize)(7,null,N))}break}case"ENOENT":break;default:throw U}}}async u(){const T=(0,g.$lc)(this.g.appRoot,"bin","code"),N=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(T))throw new Error((0,$.localize)(8,null,T));return{source:N,target:T}}async showMessageBox(T,N){const U=this.C(N?.targetWindowId,T);return this.c.showMessageBox(N,U?.win??void 0)}async showSaveDialog(T,N){const U=this.C(N?.targetWindowId,T);return this.c.showSaveDialog(N,U?.win??void 0)}async showOpenDialog(T,N){const U=this.C(N?.targetWindowId,T);return this.c.showOpenDialog(N,U?.win??void 0)}async pickFileFolderAndOpen(T,N){const U=await this.c.pickFileFolder(N);U&&await this.w(await Promise.all(U.map(async ue=>await v.SymlinkSupport.existsDirectory(ue)?{folderUri:k.URI.file(ue)}:{fileUri:k.URI.file(ue)})),N,T)}async pickFolderAndOpen(T,N){const U=await this.c.pickFolder(N);U&&await this.w(U.map(ue=>({folderUri:k.URI.file(ue)})),N,T)}async pickFileAndOpen(T,N){const U=await this.c.pickFile(N);U&&await this.w(U.map(ue=>({fileUri:k.URI.file(ue)})),N,T)}async pickWorkspaceAndOpen(T,N){const U=await this.c.pickWorkspace(N);U&&await this.w(U.map(ue=>({workspaceUri:k.URI.file(ue)})),N,T)}async w(T,N,U){await this.a.open({context:3,contextWindowId:U,cli:this.g.args,urisToOpen:T,forceNewWindow:N.forceNewWindow})}async showItemInFolder(T,N){R.shell.showItemInFolder(N)}async setRepresentedFilename(T,N,U){this.C(U?.targetWindowId,T)?.setRepresentedFilename(N)}async setDocumentEdited(T,N,U){this.C(U?.targetWindowId,T)?.setDocumentEdited(N)}async openExternal(T,N){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(N),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(T,N){return R.shell.trashItem(N)}async isAdmin(){let T;return y.$i?T=(await new Promise((N,U)=>{Q(["native-is-elevated"],N,U)}))():T=process.getuid?.()===0,T}async writeElevated(T,N,U,ue){const ie=await new Promise((le,Y)=>{Q(["@vscode/sudo-prompt"],le,Y)});return new Promise((le,Y)=>{const K=[`"${this.z}"`];ue?.unlock&&K.push("--file-chmod"),K.push("--file-write",`"${N.fsPath}"`,`"${U.fsPath}"`);const B={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,g.$kc)((0,g.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ie.exec(K.join(" "),B,(L,H,G)=>{H&&this.h.trace(`[sudo-prompt] received stdout: ${H}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Y(L):le(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:R.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,g.$kc)((0,g.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,g.$kc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,g.$kc)((0,g.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,g.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,g.$kc)(this.g.appRoot,"bin","code"):(0,g.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return m.$vn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,I.$lbc)()}async killProcess(T,N,U){process.kill(N,U)}async readClipboardText(T,N){return R.clipboard.readText(N)}async writeClipboardText(T,N,U){return R.clipboard.writeText(N,U)}async readClipboardFindText(T){return R.clipboard.readFindText()}async writeClipboardFindText(T,N){return R.clipboard.writeFindText(N)}async writeClipboardBuffer(T,N,U,ue){return R.clipboard.writeBuffer(N,Buffer.from(U.buffer),ue)}async readClipboardBuffer(T,N){return b.$ze.wrap(R.clipboard.readBuffer(N))}async hasClipboard(T,N,U){return R.clipboard.has(N,U)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,N){this.D(T)?.updateTouchBar(N)}async notifyReady(T){this.D(T)?.setReady()}async relaunch(T,N){return this.f.relaunch(N)}async reload(T,N){const U=this.D(T);if(U){if((0,r.$Ci)(U.openedWorkspace)){const ue=U.openedWorkspace.configPath;if(ue.scheme===u.Schemas.file&&(await this.n.resolveLocalWorkspace(ue))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(T,N){return this.C(N?.targetWindowId,T)?.win?.close()}async quit(T){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.f.quit()}async exit(T,N){await this.f.kill(N)}async resolveProxy(T,N){return this.D(T)?.win?.webContents?.session?.resolveProxy(N)}async loadCertificates(T){return(await new Promise((U,ue)=>{Q(["@vscode/proxy-agent"],U,ue)})).loadSystemCertificates({log:this.h})}findFreePort(T,N,U,ue,ie=1){return(0,p.$Lg)(N,U,ue,ie)}async openDevTools(T,N){this.C(N?.targetWindowId,T)?.win?.webContents.openDevTools(N?.mode?{mode:N.mode,activate:N.activate}:void 0)}async toggleDevTools(T,N){this.C(N?.targetWindowId,T)?.win?.webContents.toggleDevTools()}async profileRenderer(T,N,U){const ue=this.D(T);if(!ue||!ue.win)throw new Error;return await new D.$mbc(ue.win,N,this.h).inspect(U)}async windowsGetStringRegKey(T,N,U,ue){if(!y.$i)return;const ie=await new Promise((le,Y)=>{Q(["@vscode/windows-registry"],le,Y)});try{return ie.GetStringRegKey(N,U,ue)}catch{return}}C(T,N){return this.D(T)??this.F(T)??this.D(N)}D(T){if(typeof T=="number")return this.a.getWindowById(T)}F(T){if(typeof T=="number")return this.b.getWindowById(T)}};e.$pbc=C,Ee([P.$Rh],C.prototype,"z",null),e.$pbc=C=Ee([ne(0,n.$Cac),ne(1,j.$nbc),ne(2,f.$xac),ne(3,a.$Vac),ne(4,l.$rac),ne(5,t.$Tj),ne(6,o.$ak),ne(7,s.$Aac),ne(8,c.$Oac)],C)}),define(oe[303],ae([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;const c="issue.processExplorerWindowState";let b=class{static{r=this}static{this.a="#1E1E1E"}constructor(j,A,C,W,T,N,U,ue,ie,le,Y){this.g=j,this.h=A,this.i=C,this.j=W,this.k=T,this.l=N,this.m=U,this.n=ue,this.o=ie,this.p=le,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$jW.on("vscode:listProcesses",async j=>{const A=[];try{A.push({name:(0,k.localize)(0,null),rootProcess:await(0,g.$rs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,w.$8m)(W)?A.push({name:W.hostName,rootProcess:W}):W.processes&&A.push({name:W.hostName,rootProcess:W.processes})})}catch(C){this.i.error(`Listing processes failed: ${C}`)}this.t(j,"vscode:listProcessesResponse",A)}),y.$jW.on("vscode:workbenchCommand",(j,A)=>{const{id:C,from:W,args:T}=A;let N;switch(W){case"processExplorer":N=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}N?.webContents.send("vscode:runAction",{id:C,from:W,args:T})}),y.$jW.on("vscode:closeProcessExplorer",j=>{this.d?.close()}),y.$jW.on("vscode:pidToNameRequest",async j=>{const A=await this.k.getMainDiagnostics(),C=[];for(const W of A.windows)C.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:T}of o.$9ac.getAll())C.push([W,T]);this.t(j,"vscode:pidToNameResponse",C)})}async openReporter(j){if(this.b)this.b&&this.s(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const A=new E.$Tc,C=A.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,C,{backgroundColor:j.styles.backgroundColor,title:(0,k.localize)(1,null),zoomLevel:j.zoomLevel,alwaysOnTop:!1},"issue-reporter"),C.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:j,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:l.default}),this.b.loadURL(h.$Hg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,A.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,A.dispose())})}}async openProcessExplorer(j){if(!this.d&&(this.f=i.BrowserWindow.getFocusedWindow(),this.f)){const A=new E.$Tc,C=A.add(this.n.createIPCObjectUrl()),W=this.p.getItem(c,void 0),T=I(W)?W:this.v(this.f,800,500);this.d=this.u(T,C,{backgroundColor:j.styles.backgroundColor,title:(0,k.localize)(2,null),zoomLevel:j.zoomLevel,alwaysOnTop:!0},"process-explorer"),C.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:j,product:l.default}),this.d.loadURL(h.$Hg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,A.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,A.dispose())});const N=()=>{if(!this.d)return;const U=this.d.getSize(),ue=this.d.getPosition();if(!U||!ue)return;const ie={width:U[0],height:U[1],x:ue[0],y:ue[1]};this.p.setItem(c,ie)};this.d.on("moved",N),this.d.on("resized",N)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const j=await i.contentTracing.stopRecording(`${(0,P.$vg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null,j),buttons:[(0,k.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,j)}async getSystemStatus(){const[j,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(j,A)}async $getSystemInfo(){const[j,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(j,A)}async $getPerformanceInfo(){try{const[j,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(j,A)}catch(j){throw this.i.warn("issueService#getPerformanceInfo ",j.message),j}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(j){this.i.error(j)}}async $showConfirmCloseDialog(){if(this.b){const{response:j}=await this.l.showMessageBox({type:"warning",message:(0,k.localize)(6,null),buttons:[(0,k.localize)(7,null),(0,k.localize)(8,null)]},this.b);j===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:j}=await this.l.showMessageBox({type:"warning",message:(0,k.localize)(9,null),buttons:[(0,k.localize)(10,null),(0,k.localize)(11,null)]},this.b);return j===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");return j}async $sendReporterMenu(j,A){const C=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",T=new M.$je;return C.sendWhenReady(W,T.token,{replyChannel:W,extensionId:j,extensionName:A}),await(0,S.$eh)(new Promise(U=>y.$jW.once(`vscode:triggerReporterMenuResponse:${j}`,(ue,ie)=>U(ie))),5e3,()=>{this.i.error(`Error: Extension ${j} timed out waiting for menu response`),T.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(j){j.isMinimized()&&j.restore(),j.focus()}t(j,A,...C){j.sender.isDestroyed()||j.sender.send(A,...C)}u(j,A,C,W){const T=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:j.width,height:j.height,minWidth:300,minHeight:200,x:j.x,y:j.y,title:C.title,backgroundColor:C.backgroundColor||r.a,webPreferences:{preload:h.$Hg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${A.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$tD)(C.zoomLevel),sandbox:!0},alwaysOnTop:C.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}v(j,A,C){let W;const T=i.screen.getAllDisplays();if(T.length===1)W=T[0];else{if(u.$j){const ue=i.screen.getCursorScreenPoint();W=i.screen.getDisplayNearestPoint(ue)}!W&&j&&(W=i.screen.getDisplayMatching(j.getBounds())),W||(W=i.screen.getPrimaryDisplay()||T[0])}const N=W.bounds,U={width:A,height:C,x:N.x+N.width/2-A/2,y:N.y+N.height/2-C/2};return N.width>0&&N.height>0&&(U.x<N.x&&(U.x=N.x),U.y<N.y&&(U.y=N.y),U.x>N.x+N.width&&(U.x=N.x),U.y>N.y+N.height&&(U.y=N.y),U.width>N.width&&(U.width=N.width),U.height>N.height&&(U.height=N.height)),U}};e.$qbc=b,e.$qbc=b=r=Ee([ne(1,p.$rac),ne(2,$.$Tj),ne(3,w.$7m),ne(4,m.$_ac),ne(5,v.$xac),ne(6,f.$obc),ne(7,a.$zac),ne(8,d.$ak),ne(9,t.$$P),ne(10,n.$Cac)],b);function I(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(oe[304],ae([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;let w=class extends k.$Pbc{constructor(v,p,$,f,l,d,a,t){super(v,p,f,l,d,t),this.e=$,this.u=a}s(v){return(0,k.$Obc)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$hX.CheckingForUpdates(v)),this.i.request({url:this.a},i.CancellationToken.None).then(u.$Kp).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$hX.Idle(1))):this.d(y.$hX.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const $=v?p.message||p:void 0;this.d(y.$hX.Idle(1,$))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$hX.Idle(1))}};e.$Rbc=w,e.$Rbc=w=Ee([ne(0,M.$Vac),ne(1,R.$Ti),ne(2,g.$Sl),ne(3,S.$rac),ne(4,u.$Ep),ne(5,P.$Tj),ne(6,E.$obc),ne(7,h.$ak)],w)}),define(oe[305],ae([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;async function s(b,I=1e3){for(;!b();)await(0,M.$oh)(I)}let n;function r(){return typeof n>"u"&&(n=R.existsSync(u.$kc(u.$nc(process.execPath),"unins000.exe"))?0:1),n}let c=class extends o.$Pbc{get cachePath(){const I=u.$kc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(I,{recursive:!0}).then(()=>I)}constructor(I,D,j,A,C,W,T,N,U){super(I,D,A,C,W,U),this.u=j,this.v=T,this.w=N,I.setRelaunchHandler(this)}handleRelaunch(I){return I?.addArgs||I?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$hX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(I){let D=`win32-${process.arch}`;return r()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,o.$Obc)(D,I,this.k)}t(I){this.a&&(this.d(t.$hX.CheckingForUpdates(I)),this.i.request({url:this.a},P.CancellationToken.None).then(d.$Kp).then(D=>{const j=r();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!I}),this.d(t.$hX.Idle(j)),Promise.resolve(null)):j===1?(this.d(t.$hX.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$hX.Downloading),this.C(D.version).then(()=>this.B(D.version).then(A=>k.Promises.exists(A).then(C=>{if(C)return Promise.resolve(A);const W=`${A}.tmp`;return this.i.request({url:D.url},P.CancellationToken.None).then(T=>this.v.writeFile(g.URI.file(W),T.stream)).then(D.sha256hash?()=>(0,y.$cW)(W,D.sha256hash):()=>{}).then(()=>k.Promises.rename(W,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(t.$hX.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$hX.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$bj)(String(D)))}),this.j.error(D);const j=I?D.message||D:void 0;this.d(t.$hX.Idle(r(),j))}))}async o(I){I.update.url&&this.w.openExternal(void 0,I.update.url),this.d(t.$hX.Idle(r()))}async B(I){const D=await this.cachePath;return u.$kc(D,`CodeSetup-${this.k.quality}-${I}.exe`)}async C(I=null){const D=I?W=>!new RegExp(`${this.k.quality}-${I}\\.exe$`).test(W):()=>!0,j=await this.cachePath,C=(await k.Promises.readdir(j)).filter(D).map(async W=>{try{await k.Promises.unlink(u.$kc(j,W))}catch{}});await Promise.all(C)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const I=this.state.update;this.d(t.$hX.Updating(I));const D=await this.cachePath;this.e.updateFilePath=u.$kc(D,`CodeSetup-${this.k.quality}-${I.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$hX.Idle(r()))});const A=`${this.k.win32MutexName}-ready`,C=await new Promise((W,T)=>{Q(["@vscode/windows-mutex"],W,T)});s(()=>C.isActive(A)).then(()=>this.d(t.$hX.Ready(I)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return r()}async _applySpecificUpdate(I){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),j={version:"unknown",productVersion:"unknown"};this.d(t.$hX.Downloading),this.e={packagePath:I},this.d(t.$hX.Downloaded(j)),D?this.k.target==="user"&&this.p():this.d(t.$hX.Ready(j))}};e.$Tbc=c,Ee([E.$Rh],c.prototype,"cachePath",null),e.$Tbc=c=Ee([ne(0,p.$Vac),ne(1,w.$Ti),ne(2,a.$Sl),ne(3,m.$rac),ne(4,d.$Ep),ne(5,$.$Tj),ne(6,v.$Tk),ne(7,f.$obc),ne(8,l.$ak)],c)}),define(oe[135],ae([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n,r,c,b,I,D,j,A,C,W,T,N,U,ue,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=void 0;var le;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(le||(le={}));class Y extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(P.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(P.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(P.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(P.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(P.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(P.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const H=!(0,I.$pD)(this.r);if(g.$j&&H&&L.setSheetOffset((0,g.$J)((0,w.release)())?28:22),H&&(g.$i&&(0,I.$rD)(this.r)||g.$j)){const G=this.s.getItem(Y.C);G&&this.updateWindowControls({height:G})}g.$i&&H&&L.hookWindowMessage(278,()=>{const[z,ce]=L.getPosition(),he=i.screen.getCursorScreenPoint(),X=he.x-z,O=he.y-ce;return!(X>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:X,y:O})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),g.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,H,G,z){super(),this.r=L,this.s=H,this.t=G,this.u=z,this.a=this.B(new P.$_d),this.onDidClose=this.a.event,this.b=this.B(new P.$_d),this.onDidMaximize=this.b.event,this.c=this.B(new P.$_d),this.onDidUnmaximize=this.c.event,this.f=this.B(new P.$_d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new P.$_d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new P.$_d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,I.$rD)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){g.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return g.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){g.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return g.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){g.$j&&L?.force&&i.app.focus({steal:!0});const H=this.win;H&&(H.isMinimized()&&H.restore(),H.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(g.$j)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const H=this.win;if(H){if(L.height&&this.s.setItem(K.C,L.height),g.$i&&this.D)H.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(g.$j&&L.height!==void 0){const G=(L.height-15)/2;G?H.setWindowButtonPosition({x:G,y:G}):H.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,H){(0,I.$sD)(this.r)?this.I(L,H):this.L(L)}get isFullScreen(){if(g.$j&&typeof this.F=="boolean")return this.F;const L=this.win,H=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(H||G)}I(L,H){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,H)}J(L,H){if(g.$j){this.F=L;const z=this.G=new R.$Kh;(async()=>{const ce=await Promise.race([z.p,(0,R.$oh)(1e4).then(()=>!1)]);this.G===z&&(this.F=void 0,this.G=void 0,!ce&&L&&H&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const H=this.win;H?.isFullScreen()&&this.J(!1,!1),H?.setSimpleFullScreen(L),H?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Sac=Y;let K=class extends Y{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(H=>H.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,j.$Bi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,H,G,z,ce,he,X,O,F,_,se,J,x,V,q,re,ee,fe,me,ve,ke){super(_,ve,z,H),this.eb=G,this.fb=ce,this.gb=he,this.hb=X,this.ib=O,this.jb=F,this.kb=se,this.lb=J,this.mb=x,this.nb=V,this.ob=q,this.pb=re,this.qb=ee,this.rb=fe,this.sb=me,this.M=this.B(new P.$_d),this.onWillLoad=this.M.event,this.N=this.B(new P.$_d),this.onDidSignalReady=this.N.event,this.O=this.B(new P.$_d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Ie,Fe]=this.Db(L.state);this.S=Ie,this.u.trace("window#ctor: using window state",Ie);const ye=this.S.mode===0||this.S.mode===3,Z=ke.invokeFunction(D.$Dac,this.S,{show:!ye,webPreferences:{preload:h.$Hg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,u.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.BrowserWindow(Z),(0,u.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const de=this.r.getValue("window"),$e=g.$j&&de?.nativeTabs===!0;(g.$j||g.$i)&&Fe&&(!$e||i.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,u.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,u.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function H(){G.dispose(),z.dispose(),L()}const G=this.onDidClose(()=>H()),z=this.onWillLoad(()=>H())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(H,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(H,G,z)=>this.xb(3,{reason:z,exitCode:G})),this.m.webContents.on("will-prevent-unload",H=>{H.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(H=>this.Ab(H))),this.B(this.lb.onDidDeleteUntitledWorkspace(H=>this.zb(H)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(H,G)=>{const z=await this.wb();G({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,z)})})}wb(){return this.vb||(this.vb=(0,s.$Yp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,H){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:H?.reason,code:H?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:z}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const ce=G===0;await this.yb(ce,z)}}else if(L===2){let G;H?G=(0,k.localize)(7,null,H.reason,H.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:z,checkboxChecked:ce}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=z===0;await this.yb(he,ce)}break}}async yb(L,H){const G=this.R?.workspace;if(H&&G)try{const z=this.jb.workspaceStorage(G);await z.init(),z.delete("memento/workbench.parts.editor"),await z.close()}catch(z){this.u.error(z)}this.O.fire();try{if(L&&this.R){let z,ce;(0,j.$xi)(G)?z={folderUri:G.uri}:(0,j.$Ci)(G)?z={workspaceUri:G.configPath}:ce=!0,(0,ue.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:z?[z]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const H=this.Fb();H!==this.U&&(this.U=H,this.Gb(H))}if(!L||L.affectsConfiguration("http.proxy")){let H=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;H?.endsWith("/")&&(H=H.substr(0,H.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((H||"").indexOf("@")===-1&&(H!==this.Y||G!==this.Z)){this.Y=H,this.Z=G;const z=H||"",ce=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${z}', bypassing '${ce}'`),this.m.webContents.session.setProxy({proxyRules:z,proxyBypassRules:ce,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:z,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(L){g.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,H=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!H.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,H),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(h.$Hg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new R.$zh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:H.isReload?3:G?2:1})}Bb(L,H){const G=(this.R??this.bb)?.userEnv;if(G){const z=(0,f.$rm)(G)&&!(0,f.$rm)(L.userEnv),ce=this.isExtensionDevelopmentHost;(z||ce)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(L["disable-extensions"]=H.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,u.mark)("code/willOpenNewWindow"),L.perfMarks=(0,u.getMarks)(),this.ab.update(L)}async reload(L){const H=Object.assign({},this.R);H.workspace=await this.Cb(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&L&&(H.verbose=L.verbose,H.debugId=L.debugId,H.extensionEnvironment=L.extensionEnvironment,H["inspect-extensions"]=L["inspect-extensions"],H["inspect-brk-extensions"]=L["inspect-brk-extensions"],H["extensions-dir"]=L["extensions-dir"]),H.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),H.isInitialStartup=!1,H.policiesData=this.fb.serialize(),H.continueOn=this.t.continueOn,H.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},H.logLevel=this.eb.getLogLevel(),H.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(H,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,j.$Ci)(L.workspace)){const H=L.workspace.configPath;if(H.scheme===h.Schemas.file&&!await this.hb.exists(H))return}else if((0,j.$xi)(L.workspace)){const H=L.workspace.uri;if(H.scheme===h.Schemas.file&&!await this.hb.exists(H))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,C.$pac)();if(this.isFullScreen){let G;try{G=i.screen.getDisplayMatching(this.getBounds())}catch{}const z=(0,C.$pac)();return{mode:3,display:G?G.id:void 0,width:this.S.width||z.width,height:this.S.height||z.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let H;if(!g.$j&&this.m.isMaximized()?H=0:H=1,H===0?L.mode=0:L.mode=1,H===1||H===0){let G;H===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,u.mark)("code/willRestoreCodeWindowState");let H=!1;if(L){this.$=L.zoomLevel;try{const G=i.screen.getAllDisplays();H=G.length>1,L=D.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,u.mark)("code/didRestoreCodeWindowState"),[L||(0,C.$pac)(),H]}getBounds(){const[L,H]=this.m.getPosition(),[G,z]=this.m.getSize();return{x:L,y:H,width:G,height:z}}H(L,H){super.H(L,H),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,I.$nD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,H=!0){g.$j||(L==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const H=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!H),this.m.autoHideMenuBar=H;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,H,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{H.isCancellationRequested||this.send(L,...G)})}send(L,...H){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...H)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,M.$$i)(G)}`)}}}updateTouchBar(L){g.$j&&this.X.forEach((H,G)=>{const z=L[G];H.segments=this.Lb(z)})}Jb(){if(g.$j){for(let L=0;L<10;L++){const H=this.Kb();this.X.push(H)}this.m.setTouchBar(new i.TouchBar({items:this.X}))}}Kb(L=[]){const H=this.Lb(L),G=new i.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:z=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:G.segments[z].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let z;G.icon&&!c.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===h.Schemas.file&&(z=i.nativeImage.createFromPath(y.URI.revive(G.icon.dark).fsPath),z.isEmpty()&&(z=void 0));let ce;return typeof G.title=="string"?ce=G.title:ce=G.title.value,{id:G.id,label:z?void 0:ce,icon:z}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$Tac=K,e.$Tac=K=Ee([ne(1,a.$Tj),ne(2,U.$Qac),ne(3,$.$rac),ne(4,W.$8n),ne(5,N.$Fac),ne(6,l.$Tk),ne(7,n.$4ac),ne(8,n.$2ac),ne(9,v.$Ti),ne(10,b.$Aac),ne(11,A.$Oac),ne(12,m.$wac),ne(13,r.$Sl),ne(14,p.$xac),ne(15,d.$Vac),ne(16,t.$ak),ne(17,o.$zac),ne(18,D.$Cac),ne(19,T.$$P),ne(20,ie.$mi)],K)}),define(oe[306],ae([0,1,14,4,18,24,20,5,34,55,135]),function(Q,e,i,R,S,M,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;let y=class extends g.$Sac{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(w,m,v,p,$,f){super(p,$,m,v),this.M=w,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const w=i.BrowserWindow.fromWebContents(this.M);w&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(w),w.setMenu(null),(R.$i||R.$k)&&(0,u.$pD)(this.r)&&w.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$Uac=y,e.$Uac=y=Ee([ne(1,M.$rac),ne(2,E.$Tj),ne(3,S.$Ti),ne(4,h.$$P),ne(5,P.$Vac)],y)}),define(oe[307],ae([0,1,14,3,2,13,37,306,6,5,82,29]),function(Q,e,i,R,S,M,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;let k=class extends S.$Uc{constructor(m,v){super(),this.h=m,this.j=v,this.a=this.B(new R.$_d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$_d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$_d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new R.$_d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(m,v)=>{const p=this.getWindowById(v.id);p&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow())}),P.$jW.handle("vscode:registerAuxiliaryWindow",async(m,v)=>{const p=this.getWindowById(m.sender.id);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=v),m.sender.id})}createWindow(m){return this.h.invokeFunction(y.$Dac,this.n(m),{webPreferences:{preload:M.$Hg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const v={},p=m.features.split(",");for(const f of p){const[l,d]=f.split("=");switch(l){case"width":v.width=parseInt(d,10);break;case"height":v.height=parseInt(d,10);break;case"left":v.x=parseInt(d,10);break;case"top":v.y=parseInt(d,10);break}}const $=y.WindowStateValidator.validateWindowState(this.j,v)??(0,g.$qac)();return this.j.trace("[aux window] using window state",$),$}registerWindow(m){const v=new S.$Tc,p=this.h.createInstance(E.$Uac,m);this.g.set(p.id,p),v.add((0,S.$Sc)(()=>this.g.delete(p.id))),v.add(p.onDidMaximize(()=>this.a.fire(p))),v.add(p.onDidUnmaximize(()=>this.b.fire(p))),v.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),v.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),v.add(p.onDidTriggerSystemContextMenu(({x:$,y:f})=>this.f.fire({window:p,x:$,y:f}))),R.Event.once(p.onDidClose)(()=>v.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=i.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,y.$Eac)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$mcc=k,e.$mcc=k=Ee([ne(0,h.$mi),ne(1,u.$Tj)],k)}),define(oe[85],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=void 0,e.$Abc=(0,m.$ni)("workspacesHistoryMainService");let s=class extends E.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(r,c,b,I,D){super(),this.f=r,this.g=c,this.h=b,this.j=I,this.m=D,this.c=this.B(new M.$_d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$lh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let c=[],b=[];for(const D of r)if((0,f.$0eb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(c,D.workspace)&&c.push(D);else if((0,f.$$eb)(D))this.y(c,D.folderUri)||c.push(D);else{const j=this.z(b,D.fileUri),A=D.fileUri.scheme===h.Schemas.file&&o.G.indexOf((0,g.$Xg)(D.fileUri))>=0;!j&&!A&&(b.push(D),u.$i&&D.fileUri.scheme===h.Schemas.file&&i.app.addRecentDocument(D.fileUri.fsPath))}const I=await this.r({workspaces:c,files:b});c=I.workspaces,b=I.files,c.length>o.a&&(c.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:c,files:b}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(r){const c=j=>{const A=this.u(j);for(const C of r)if(g.$Rg.isEqual(C,A))return!1;return!0},b=await this.getRecentlyOpened(),I=b.workspaces.filter(c),D=b.files.filter(c);(I.length!==b.workspaces.length||D.length!==b.files.length)&&(await this.t({files:D,workspaces:I}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(r){if(r?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null)],message:(0,w.localize)(2,null),detail:(0,w.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(r){const c=new a.$Bc(D=>g.$Rg.getComparisonKey(D));if(r?.workspaces)for(const D of r.workspaces)c.set(this.u(D),D);const b=new a.$Bc(D=>g.$Rg.getComparisonKey(D));if(r?.files)for(const D of r.files)b.set(this.u(D),D);const I=await this.s();for(const D of I.workspaces){const j=c.get(this.u(D));j?j.label=j.label??D.label:c.set(this.u(D),D)}for(const D of I.files){const j=b.get(this.u(D));j?j.label=j.label??D.label:b.set(this.u(D),D)}return{workspaces:[...c.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let r;const c=this.j.get(o.b,-1);if(typeof c=="string")try{r=JSON.parse(c)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$efb)(r,this.f)}async t(r){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$ffb)(r)),-1,1)}u(r){return(0,f.$$eb)(r)?r.folderUri:(0,f.$_eb)(r)?r.fileUri:r.workspace.configPath}w(r,c){return!!r.find(b=>(0,f.$0eb)(b)&&b.workspace.id===c.id)}y(r,c){return!!r.find(b=>(0,f.$$eb)(b)&&g.$Rg.isEqual(b.folderUri,c))}z(r,c){return!!r.find(b=>g.$Rg.isEqual(b.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){u.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!u.$i)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(4,null),description:(0,w.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const D of i.app.getJumpListSettings().removedItems){const j=D.args;if(j){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(j);A&&c.push(y.URI.parse(A[2]))}}await this.removeRecentlyOpened(c);let b=!1;const I=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(D=>{const j=(0,f.$0eb)(D)?D.workspace:D.folderUri,{title:A,description:C}=this.L(j,D.label);let W;return y.URI.isUri(j)?W=`--folder-uri "${j.toString()}"`:(b=!0,W=`--file-uri "${j.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:C.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));I.length>0&&r.push({type:"custom",name:b?(0,w.localize)(6,null):(0,w.localize)(7,null),items:I})}r.push({type:"recent"});try{const c=i.app.setJumpList(r);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(r,c){if(c)return{title:(0,P.$uw)(c).name,description:c};if(y.URI.isUri(r))return{title:(0,g.$Xg)(r),description:this.M(r)};if(this.g.isUntitledWorkspace(r))return{title:(0,w.localize)(8,null),description:""};let b=(0,g.$Xg)(r.configPath);return b.endsWith(l.$Ji)&&(b=b.substr(0,b.length-l.$Ji.length-1)),{title:(0,w.localize)(9,null,b),description:this.M(r.configPath)}}M(r){return r.scheme==="file"?(0,P.$mw)(r.fsPath):r.toString()}async N(){if(!u.$j)return;i.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),c=[];let b=0;for(let D=0;D<r.workspaces.length&&b<o.C;D++){const j=this.u(r.workspaces[D]);if(j.scheme===h.Schemas.file){const A=(0,g.$Og)(j);await k.Promises.exists(A)&&(c.push(A),b++)}}const I=[];for(let D=0;D<r.files.length&&b<o.D;D++){const j=this.u(r.files[D]);if(j.scheme===h.Schemas.file){const A=(0,g.$Og)(j);if(o.G.includes((0,g.$Xg)(j))||c.includes(A))continue;await k.Promises.exists(A)&&(I.push(A),b++)}}I.reverse().forEach(D=>i.app.addRecentDocument(D)),c.reverse().forEach(D=>i.app.addRecentDocument(D))}};e.$Bbc=s,e.$Bbc=s=o=Ee([ne(0,p.$Tj),ne(1,d.$Oac),ne(2,v.$Vac),ne(3,$.$4ac),ne(4,t.$xac)],s)}),define(oe[308],ae([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0;const s="menu";let n=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,I,D,j,A,C,W,T,N,U,ue,ie){this.n=b,this.o=I,this.p=D,this.q=j,this.r=A,this.s=C,this.t=W,this.u=T,this.v=N,this.w=U,this.x=ue,this.y=ie,this.m=Object.create(null),this.g=new R.$zh(()=>this.F(),0),this.h=new R.$zh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(P.$j||(0,d.$pD)(I))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(C,W,T)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(C,W,T)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(C,W,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(C,W,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(C,W,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const I=this.x.requestFeatureUrl;I&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(I,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const j=this.x.licenseUrl;j&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(P.$w){const C=j.indexOf("?")>0?"&":"?";this.ab(`${j}${C}lang=${P.$w}`,"openLicenseUrl")}else this.ab(j,"openLicenseUrl")});const A=this.x.privacyStatementUrl;A&&j&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(A,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!P.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,I){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){P.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!P.$j)return;const b=i.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=i.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(P.$j?new i.Menu:null);return}const I=new i.Menu;let D;if(P.$j){const A=new i.Menu;D=new i.MenuItem({label:this.x.nameShort,submenu:A}),this.K(A),I.append(D)}if(P.$j&&!this.c){this.c=!0;const A=new i.Menu;A.append(new i.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),i.app.dock.setMenu(A)}if(this.M("File")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(1,null)),submenu:A});this.O(A,"File"),I.append(C)}if(this.M("Edit")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(2,null)),submenu:A});this.O(A,"Edit"),I.append(C)}if(this.M("Selection")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(3,null)),submenu:A});this.O(A,"Selection"),I.append(C)}if(this.M("View")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(4,null)),submenu:A});this.O(A,"View"),I.append(C)}if(this.M("Go")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(5,null)),submenu:A});this.O(A,"Go"),I.append(C)}if(this.M("Run")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(6,null)),submenu:A});this.O(A,"Run"),I.append(C)}if(this.M("Terminal")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(7,null)),submenu:A});this.O(A,"Terminal"),I.append(C)}let j;if(this.M("Window")){const A=new i.Menu;j=new i.MenuItem({label:this.cb(h.localize(8,null)),submenu:A,role:"window"}),this.U(A)}if(j&&I.append(j),this.M("Help")){const A=new i.Menu,C=new i.MenuItem({label:this.cb(h.localize(9,null)),submenu:A,role:"help"});this.O(A,"Help"),I.append(C)}I.items&&I.items.length>0?this.J(I):this.J(null),this.h.schedule()}J(b){if(i.Menu.setApplicationMenu(b),b)for(const I of this.y.getWindows())I.win?.setMenu(null)}K(b){const I=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let j;if(this.M("Preferences")){const ie=new i.Menu;this.O(ie,"Preferences"),j=new i.MenuItem({label:this.cb(h.localize(11,null)),submenu:ie})}const A=new i.Menu,C=new i.MenuItem({label:h.localize(12,null),role:"services",submenu:A}),W=new i.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new i.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),N=new i.MenuItem({label:h.localize(15,null),role:"unhide"}),U=new i.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ie,le,Y)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||K?.win?.isMinimized())&&await this.L(Y)&&this.w.quit(void 0)}})),ue=[I];ue.push(...D),j&&ue.push(r(),j),ue.push(r(),C,r(),W,T,N,r(),U),ue.forEach(ie=>b.append(ie))}async L(b){if(this.p.getWindowCount()===0)return!0;const I=this.o.getValue("window.confirmBeforeClose");if(I==="always"||I==="keyboardOnly"&&this.S(b)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return D===0}return!0}M(b){if(!P.$j&&!(0,d.$pD)(this.o))return!1;switch(b){case"File":case"Help":if(P.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(P.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,I){I.forEach(D=>{if((0,m.$xbc)(D))b.append(r());else if((0,m.$wbc)(D)){const j=new i.Menu,A=new i.MenuItem({label:this.cb(D.label),submenu:j});this.N(j,D.submenu.items),b.append(A)}else(0,m.$ybc)(D)?b.append(this.Q(D)):(0,m.$zbc)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P(b),P.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?b.append(new i.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):b.append(this.W(D.label,D.id,!1,D.checked)):b.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):b.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O(b,I){this.k&&this.k[I]&&this.N(b,this.k[I].items)}P(b){const I=this.V();I.length&&(I.forEach(D=>b.append(D)),b.append(r()))}Q(b){const I=E.URI.revive(b.uri),D=b.id,j=D==="openRecentFile"?{fileUri:I}:D==="openRecentWorkspace"?{workspaceUri:I}:{folderUri:I};return new i.MenuItem(this.$(D,{label:b.label,click:async(A,C,W)=>{const T=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[j],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([I])}},!1))}R(b){return!!(b&&(!P.$j&&(b.ctrlKey||b.shiftKey)||P.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,I,D){const j={label:this.cb(b),role:D,enabled:!0};return new i.MenuItem(this.Z(I,j))}U(b){const I=new i.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new i.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),j=new i.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),A=this.W(h.localize(23,null),"workbench.action.switchWindow"),C=[];this.D&&(C.push(r()),C.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),C.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[I,D,r(),A,...C,r(),j].forEach(W=>b.append(W))}V(){switch(this.n.state.type){case"idle":return[new i.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new i.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new i.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new i.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return P.$j?[]:[new i.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new i.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new i.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,I,D,j){const A=this.cb(b),C=typeof I=="function"?I:(ue,ie,le)=>{const Y=ue?ue.userSettingsLabel:null;let K=I;Array.isArray(I)&&(K=this.R(le)?I[1]:I[0]),Y&&le.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Y}):this.Y({type:"commandId",commandId:K})},W=typeof D=="boolean"?D:this.p.getWindowCount()>0,T=typeof j=="boolean"?j:!1,N={label:A,click:C,enabled:W};T&&(N.type="checkbox",N.checked=T);let U;return typeof I=="string"?U=I:Array.isArray(I)&&(U=I[0]),P.$j&&(U==="editor.action.clipboardCutAction"?N.role="cut":U==="editor.action.clipboardCopyAction"?N.role="copy":U==="editor.action.clipboardPasteAction"&&(N.role="paste"),U==="undo"?N.click=this.X(C,{inDevTools:ue=>ue.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):U==="redo"?N.click=this.X(C,{inDevTools:ue=>ue.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):U==="editor.action.selectAll"&&(N.click=this.X(C,{inDevTools:ue=>ue.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.Z(U,N))}X(b,I){return(D,j,A)=>{const C=i.BrowserWindow.getFocusedWindow();if(!C)return I.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return I.inDevTools(C.webContents.devToolsWebContents);b(D,j||C,A)}}Y(b){let I=i.BrowserWindow.getFocusedWindow();if(I){const j=this.y.getWindowById(I.id);j&&(I=this.p.getWindowById(j.parentId)?.win??null)}if(!I){const j=this.p.getLastActiveWindow();j?.win?.isMinimized()&&(I=j.win)}const D=I?this.p.getWindowById(I.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",b),P.$j&&!this.q.isBuilt&&!D.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const j={id:b.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",S.CancellationToken.None,j)}else{const j={userSettingsLabel:b.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,j)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,I){const D=typeof b=="string"?this.l[b]:void 0;if(D?.label){if(D.isNative!==!1)I.accelerator=D.label,I.userSettingsLabel=D.userSettingsLabel;else if(typeof I.label=="string"){const j=I.label.indexOf("[");j>=0?I.label=`${I.label.substr(0,j)} [${D.label}]`:I.label=`${I.label} [${D.label}]`}}else I.accelerator=void 0;return I}$(b,I,D=!I.accelerator){D&&(I=this.Z(b,I));const j=I.click;return I.click=(A,C,W)=>{this.bb(b),j?.(A,C,W)},I}ab(b,I){this.w.openExternal(void 0,b),this.bb(I)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:s})}cb(b){return(0,M.$rw)(b,!this.C)}};e.$Cbc=n,e.$Cbc=n=o=Ee([ne(0,l.$iX),ne(1,g.$Ti),ne(2,a.$Cac),ne(3,y.$rac),ne(4,f.$Sl),ne(5,t.$Abc),ne(6,$.$$P),ne(7,k.$Vac),ne(8,w.$Tj),ne(9,v.$obc),ne(10,p.$ak),ne(11,u.$nbc)],n);function r(){return new i.MenuItem({type:"separator"})}}),define(oe[309],ae([0,1,6,20,5,308]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,i.$ni)("menubarMainService");let P=class{constructor(h,u,g){this.b=h,this.c=u,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$Cbc)}async updateMenubar(h,u){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(u,h)}};e.$Ebc=P,e.$Ebc=P=Ee([ne(0,i.$mi),ne(1,R.$Vac),ne(2,S.$Tj)],P)}),define(oe[310],ae([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n,r,c,b,I,D,j,A,C,W,T,N,U,ue,ie,le,Y,K,B,L,H,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;function z(X){return(0,ue.$Ci)(X?.workspace)}function ce(X){return(0,ue.$xi)(X?.workspace)}let he=class extends y.$Uc{constructor(O,F,_,se,J,x,V,q,re,ee,fe,me,ve,ke,Ie,Fe,ye,Z,de,$e){super(),this.s=O,this.t=F,this.u=_,this.w=se,this.z=J,this.C=x,this.D=V,this.F=q,this.G=re,this.H=ee,this.I=fe,this.J=me,this.L=ve,this.M=ke,this.N=Ie,this.O=Fe,this.P=ye,this.Q=Z,this.R=de,this.S=$e,this.a=this.B(new h.$_d),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$_d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$_d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$_d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$_d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$_d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$_d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$_d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new U.$2bc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const F=new y.$Tc;if(F.add(h.Event.any(O.onDidClose,O.onDidDestroy)(()=>F.dispose())),O.config.extensionDevelopmentPath)for(const _ of O.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(_));O.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,F){const _=this.F.args,se=F?.remoteAuthority||void 0,J=!0,x=F?.forceReuseWindow,V=!x;return this.open({...O,cli:_,forceEmpty:J,forceNewWindow:V,forceReuseWindow:x,remoteAuthority:se})}openExistingWindow(O,F){O.focus(),this.W(F,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const F=[],_=[],se=[],J=[],x=[];let V,q=0;const re=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",re);for(const ke of re)ce(ke)?O.addMode?F.push(ke):_.push(ke):z(ke)?se.push(ke):ke.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),V.filesToOpenOrCreate.push(ke)):ke.backupPath?x.push({backupFolder:(0,w.$oc)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):q++;O.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),O.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&O.waitMarkerFileURI&&(V.filesToWait={paths:(0,P.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(J.push(...this.M.getUntitledWorkspaces()),se.push(...J),x.push(...this.I.getEmptyWindowBackups())):x.length=0;const{windows:ee,filesOpenedInWindow:fe}=await this.X(O,se,_,x,q,V,F);if(this.w.trace(`windowsManager#open used window count ${ee.length} (workspacesToOpen: ${se.length}, foldersToOpen: ${_.length}, emptyToRestore: ${x.length}, emptyToOpen: ${q})`),ee.length>1)if(fe)fe.focus();else{const ke=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Ie=!0,Fe=!0;if(ke){const ye=ee.filter(Z=>this.r.state.lastActiveWindow&&Z.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Ie=!1,Fe=!1)}if(Ie)for(let ye=ee.length-1;ye>=0;ye--){const Z=ee[ye];if(!(Z.openedWorkspace&&J.some(de=>Z.openedWorkspace&&de.workspace.id===Z.openedWorkspace.id)||Z.backupPath&&x.some(de=>Z.backupPath&&de.backupFolder===(0,w.$oc)(Z.backupPath)))){Z.focus(),Fe=!1;break}}Fe&&ee[ee.length-1].focus()}const me=V&&V.filesToDiff.length>0,ve=V&&V.filesToMerge.length>0;if(!ee.some(ke=>ke.isExtensionDevelopmentHost)&&!me&&!ve&&!O.noRecentEntry){const ke=[];for(const Ie of re)z(Ie)&&!Ie.transient?ke.push({label:Ie.label,workspace:Ie.workspace,remoteAuthority:Ie.remoteAuthority}):ce(Ie)?ke.push({label:Ie.label,folderUri:Ie.workspace.uri,remoteAuthority:Ie.remoteAuthority}):Ie.fileUri&&ke.push({label:Ie.label,fileUri:Ie.fileUri,remoteAuthority:Ie.remoteAuthority});this.L.addRecentlyOpened(ke)}return this.W(O,ee),ee}W(O,F){const _=O.waitMarkerFileURI;O.context===0&&_&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(O,F,_,se,J,x,V){const q=[];let re;function ee(ye,Z){q.push(ye),Z&&(re=ye,x=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:me}=this.ob(O);if(!O.initialStartup&&V.length>0){const ye=V[0].remoteAuthority,Z=this.ub(ye);Z&&ee(this.$(Z,V.map(de=>de.workspace.uri)))}const ve=_.length+F.length+se.length;if(x&&ve===0){const ye=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],Z=this.getWindows().filter($e=>x&&(0,$.$6g)($e.remoteAuthority,x.remoteAuthority));let de;ye?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(de=await(0,N.$Hac)(Z,ye.fileUri,async $e=>$e.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),de||(de=this.vb(Z))),de?(0,ue.$Ci)(de.openedWorkspace)?F.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):(0,ue.$xi)(de.openedWorkspace)?_.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):ee(this.Y(O,de,x),!0):ee(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const ke=(0,P.$Mb)(F,ye=>ye.workspace.id);if(ke.length>0){const ye=(0,P.$Hb)(ke.map(Z=>(0,N.$Iac)(this.getWindows(),Z.workspace.configPath)));if(ye.length>0){const Z=ye[0],de=(0,$.$6g)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;ee(this.Y(O,Z,de),!!de),fe=!0}for(const Z of ke){if(ye.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===Z.workspace.id))continue;const de=Z.remoteAuthority,$e=(0,$.$6g)(x?.remoteAuthority,de)?x:void 0;ee(await this.bb(O,Z,fe,$e),!!$e),fe=!0}}const Ie=(0,P.$Mb)(_,ye=>$.$Rg.getComparisonKey(ye.workspace.uri));if(Ie.length>0){const ye=(0,P.$Hb)(Ie.map(Z=>(0,N.$Iac)(this.getWindows(),Z.workspace.uri)));if(ye.length>0){const Z=ye[0],de=(0,$.$6g)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;ee(this.Y(O,Z,de),!!de),fe=!0}for(const Z of Ie){if(ye.some(Pe=>(0,ue.$xi)(Pe.openedWorkspace)&&$.$Rg.isEqual(Pe.openedWorkspace.uri,Z.workspace.uri)))continue;const de=Z.remoteAuthority,$e=(0,$.$6g)(x?.remoteAuthority,de)?x:void 0;ee(await this.bb(O,Z,fe,$e),!!$e),fe=!0}}const Fe=(0,P.$Mb)(se,ye=>ye.backupFolder);if(Fe.length>0)for(const ye of Fe){const Z=ye.remoteAuthority,de=(0,$.$6g)(x?.remoteAuthority,Z)?x:void 0;ee(await this.ab(O,!0,Z,de,ye),!!de),fe=!0}if(q.length===0||x){x&&!J&&J++;const ye=x?x.remoteAuthority:O.remoteAuthority;for(let Z=0;Z<J;Z++)ee(await this.ab(O,fe,ye,x),!!x),fe=!0}return{windows:(0,P.$Mb)(q),filesOpenedInWindow:re}}Y(O,F,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(F);const se={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",E.CancellationToken.None,se),F}Z(O){let F=O;const _=i.BrowserWindow.getFocusedWindow();if(_&&_.id!==O.id){const se=this.S.getWindowById(_.id);se&&se.parentId===O.id&&(F=se)}F.focus()}$(O,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),O.focus();const _={foldersToAdd:F};return O.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),O}ab(O,F,_,se,J){this.w.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:_,filesToOpen:se,forceNewWindow:F});let x;return!F&&typeof O.contextWindowId=="number"&&(x=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:_,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:se,windowToUse:x,emptyWindowBackupInfo:J,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,F,_,se,J){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:se}),!_&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.pb({workspace:F.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:se,windowToUse:J,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let F,_=!1,se=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(F=await this.db(O),_=!0):O.forceEmpty?F=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(F=await this.eb(O.cli),F.length===0&&F.push(Object.create(null)),_=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),se=!0),!O.addMode&&_){const J=F.filter(x=>ce(x));if(J.length>1){const x=J[0].remoteAuthority;if(J.every(V=>(0,$.$6g)(V.remoteAuthority,x))){const V=await this.M.createUntitledWorkspace(J.map(q=>({uri:q.workspace.uri})));F.push({workspace:V,remoteAuthority:x}),F=F.filter(q=>!ce(q))}}}if(O.initialStartup&&!se&&this.J.getValue("window")?.restoreWindows==="preserve"){const J=await this.gb();F.unshift(...J.filter(x=>z(x)||ce(x)||x.backupPath))}return F}async db(O){const F={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},_=await Promise.all((0,P.$Hb)(O.urisToOpen||[]).map(async se=>{const J=await this.ib(se,F);if(J)return J.label=se.label,J;const x=this.kb(se);this.O.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:x.scheme===k.Schemas.file?(0,d.localize)(1,null):(0,d.localize)(2,null),detail:x.scheme===k.Schemas.file?(0,d.localize)(3,null,(0,g.$lw)(x,{os:v.OS,tildify:this.F})):(0,d.localize)(4,null,x.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,P.$Hb)(_)}async eb(O){const F=[],_={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},se=O["folder-uri"];if(se){const V=await Promise.all(se.map(q=>{const re=this.fb(q);if(re)return this.ib({folderUri:re},_)}));F.push(...(0,P.$Hb)(V))}const J=O["file-uri"];if(J){const V=await Promise.all(J.map(q=>{const re=this.fb(q);if(re)return this.ib((0,ue.$Si)(q)?{workspaceUri:re}:{fileUri:re},_)}));F.push(...(0,P.$Hb)(V))}const x=await Promise.all(O._.map(V=>_.remoteAuthority?this.nb(V,_):this.lb(V,_)));return F.push(...(0,P.$Hb)(x)),F}fb(O){try{const F=l.URI.parse(O);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${O}, ${F.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];O!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const _=await Promise.all(F.map(async se=>{if(se.workspace){const J=await this.ib({workspaceUri:se.workspace.configPath},{remoteAuthority:se.remoteAuthority,rejectTransientWorkspaces:!0});if(z(J))return J}else if(se.folderUri){const J=await this.ib({folderUri:se.folderUri},{remoteAuthority:se.remoteAuthority});if(ce(J))return J}else if(O!=="folders"&&se.backupPath)return{backupPath:se.backupPath,remoteAuthority:se.remoteAuthority}}));return(0,P.$Hb)(_)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,F=Object.create(null)){const _=this.kb(O);return _.scheme===k.Schemas.file?((0,C.$mD)(O)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,F)):this.jb(O,F)}jb(O,F){let _=this.kb(O);const se=(0,j.$ym)(_)||F.remoteAuthority;if(_=(0,$.$8g)((0,$.$2g)(_)),(0,C.$mD)(O)){if(F.gotoLineMode){const{path:J,line:x,column:V}=(0,u.$ug)(_.path);return{fileUri:_.with({path:J}),options:{selection:x?{startLineNumber:x,startColumn:V||1}:void 0},remoteAuthority:se}}return{fileUri:_,remoteAuthority:se}}else if((0,C.$kD)(O))return{workspace:(0,ie.$Lac)(_),remoteAuthority:se};return{workspace:(0,ie.$Mac)(_),remoteAuthority:se}}kb(O){return(0,C.$kD)(O)?O.workspaceUri:(0,C.$lD)(O)?O.folderUri:O.fileUri}async lb(O,F,_){let se,J;F.gotoLineMode&&({path:O,line:se,column:J}=(0,u.$ug)(O)),O=(0,u.$pg)((0,w.$ic)(O),(0,p.cwd)());try{const x=await R.Promises.stat(O);if(x.isFile()){if(!F.forceOpenWorkspaceAsFile){const V=await this.M.resolveLocalWorkspace(l.URI.file(O));if(V)return V.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:n.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:l.URI.file(O),type:n.FileType.File,exists:!0,options:{selection:se?{startLineNumber:se,startColumn:J||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,ie.$Mac)(l.URI.file(O),x),type:n.FileType.Directory,exists:!0};if(!v.$i&&O==="/dev/null")return{fileUri:l.URI.file(O),type:n.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(O,F);const V=l.URI.file(O);if(this.L.removeRecentlyOpened([V]),F.ignoreFileNotFound)return{fileUri:V,type:n.FileType.File,exists:!1}}}async mb(O,F){const _=l.URI.file(O),{response:se,checkboxChecked:J}=await this.O.showMessageBox({type:"warning",buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null),(0,d.localize)(7,null)],message:(0,d.localize)(8,null,_.authority),detail:(0,d.localize)(9,null,(0,g.$lw)(_,{os:v.OS,tildify:this.F})),checkboxLabel:(0,d.localize)(10,null,_.authority),cancelId:1});if(se===0){if((0,S.addUNCHostToAllowlist)(_.authority),J){const x={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.lb(O,F,!0)}if(se===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,F)}nb(O,F){const _=O.charCodeAt(0),se=F.remoteAuthority;let J,x;F.gotoLineMode&&({path:O,line:J,column:x}=(0,u.$ug)(O)),_!==47&&((0,u.$og)(_)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,u.$hg)(O)),O=`/${O}`);const V=l.URI.from({scheme:k.Schemas.vscodeRemote,authority:se,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ue.$Si)(O))return F.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:J?{startLineNumber:J,startColumn:x||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ie.$Lac)(V),remoteAuthority:se};if(F.gotoLineMode||w.$hc.basename(O).indexOf(".")!==-1)return{fileUri:V,options:{selection:J?{startLineNumber:J,startColumn:x||1}:void 0},remoteAuthority:se}}return{workspace:(0,ie.$Mac)(V),remoteAuthority:se}}ob(O){const F=this.J.getValue("window"),_=F?.openFoldersInNewWindow||"default",se=F?.openFilesInNewWindow||"off";let J=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(_==="on"||_==="off")&&(J=_==="on");let x=!1;return O.forceNewWindow||O.forceReuseWindow?x=!!O.forceNewWindow&&!O.forceReuseWindow:(v.$j?O.context===1&&(x=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!O.cli.extensionDevelopmentPath&&(se==="on"||se==="off")&&(x=se==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(O,F){const _=(0,N.$Jac)(this.getWindows(),O);if(_)return this.H.reload(_,F.cli),_.focus(),[_];let se=F.cli["folder-uri"]||[],J=F.cli["file-uri"]||[],x=F.cli._;if(!x.length&&!se.length&&!J.length&&!F.cli.extensionTestsPath){const re=this.r.state.lastPluginDevelopmentHostWindow,ee=re?.workspace??re?.folderUri;ee&&(l.URI.isUri(ee)?ee.scheme===k.Schemas.file?x=[ee.fsPath]:se=[ee.toString()]:ee.configPath.scheme===k.Schemas.file?x=[(0,$.$Og)(ee.configPath)]:J=[ee.configPath.toString()])}let V=F.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=l.URI.parse(re),fe=(0,j.$ym)(ee);fe&&(V?(0,$.$6g)(fe,V)||this.w.error("more than one extension development path authority"):V=fe)}x=x.filter(re=>{const ee=l.URI.file(re);return(0,N.$Iac)(this.getWindows(),ee)?!1:(0,$.$6g)((0,j.$ym)(ee),V)}),se=se.filter(re=>{const ee=this.fb(re);return ee&&(0,N.$Iac)(this.getWindows(),ee)?!1:ee?(0,$.$6g)((0,j.$ym)(ee),V):!1}),J=J.filter(re=>{const ee=this.fb(re);return ee&&(0,N.$Iac)(this.getWindows(),ee)?!1:ee?(0,$.$6g)((0,j.$ym)(ee),V):!1}),F.cli._=x,F.cli["folder-uri"]=se,F.cli["file-uri"]=J;const q={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!x.length&&!se.length&&!J.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:V,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(q)}async pb(O){const F=this.J.getValue("window"),_=this.getLastActiveWindow(),se=_?.profile??this.G.defaultProfile;let J;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(J=O.windowToUse||_,J&&J.focus());const x={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,w.$kc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:se},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:I.default,isInitialStartup:O.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(J){const V=J.config;!x.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(x.extensionDevelopmentPath=V.extensionDevelopmentPath,x.extensionDevelopmentKind=V.extensionDevelopmentKind,x["enable-proposed-api"]=V["enable-proposed-api"],x.verbose=V.verbose,x["inspect-extensions"]=V["inspect-extensions"],x["inspect-brk-extensions"]=V["inspect-brk-extensions"],x.debugId=V.debugId,x.extensionEnvironment=V.extensionEnvironment,x["extensions-dir"]=V["extensions-dir"],x["disable-extensions"]=V["disable-extensions"]),x.loggers={global:x.loggers.global,window:V?.loggers.window??x.loggers.window}}else{const V=this.r.getNewWindowState(x);(0,m.mark)("code/willCreateCodeWindow");const q=J=this.N.createInstance(W.$Tac,{state:V,extensionDevelopmentPath:x.extensionDevelopmentPath,isExtensionTestHost:!!x.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(q),this.n.set(q.id,q),this.a.fire(q),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const re=new y.$Tc;re.add(q.onDidSignalReady(()=>this.b.fire(q))),re.add(h.Event.once(q.onDidClose)(()=>this.sb(q,re))),re.add(h.Event.once(q.onDidDestroy)(()=>this.tb(q))),re.add(q.onDidMaximize(()=>this.g.fire(q))),re.add(q.onDidUnmaximize(()=>this.h.fire(q))),re.add(q.onDidEnterFullScreen(()=>this.j.fire({window:q,fullscreen:!0}))),re.add(q.onDidLeaveFullScreen(()=>this.j.fire({window:q,fullscreen:!1}))),re.add(q.onDidTriggerSystemContextMenu(({x:fe,y:me})=>this.m.fire({window:q,x:fe,y:me})));const ee=(0,f.$_f)(q.win?.webContents);ee.removeAllListeners("devtools-reload-page"),ee.on("devtools-reload-page",()=>this.H.reload(q)),this.H.registerWindow(q)}return x.windowId=J.id,J.isReady?this.H.unload(J,4).then(async V=>{V||await this.qb(J,x,O,se)}):await this.qb(J,x,O,se),J}async qb(O,F,_,se){if(F.extensionDevelopmentPath||((0,ue.$Ci)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,ue.$xi)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,ie.$Nac)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const J=F.workspace??(0,ue.$Bi)(F.backupPath,!1),x=this.rb(_,J,se),V=x instanceof Promise?await x:x;F.profiles.profile=V,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(J,V)}O.load(F)}rb(O,F,_){return O.forceProfile?this.G.profiles.find(se=>se.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??_}sb(O,F){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=i.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(F=>(0,$.$6g)(F.remoteAuthority,O)))}vb(O){return(0,T.$Eac)(O)}sendToFocused(O,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,E.CancellationToken.None,...F)}sendToOpeningWindow(O,...F){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(O,E.CancellationToken.None,...F)}))}sendToAll(O,F,_){for(const se of this.getWindows())_&&_.indexOf(se.id)>=0||se.sendWhenReady(O,E.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const F=i.BrowserWindow.fromWebContents(O);if(F)return this.getWindowById(F.id)}};e.$5bc=he,e.$5bc=he=Ee([ne(3,b.$Tj),ne(4,H.$Qac),ne(5,A.$$P),ne(6,B.$8n),ne(7,s.$rac),ne(8,L.$Fac),ne(9,c.$Vac),ne(10,a.$wac),ne(11,t.$Ti),ne(12,le.$Abc),ne(13,Y.$Oac),ne(14,r.$mi),ne(15,o.$xac),ne(16,n.$Tk),ne(17,D.$zac),ne(18,K.$Aac),ne(19,G.$nbc)],he)}),define(oe[311],ae([0,1,65,29,85,58]),function(Q,e,i,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;let P=class{constructor(h,u,g,y){this.a=h,this.b=u,this.c=g,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,u){const g=this.b.getWindowById(h);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),u)}createUntitledWorkspace(h,u,g){return this.a.createUntitledWorkspace(u,g)}deleteUntitledWorkspace(h,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(h,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(h,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$7bc=P,e.$7bc=P=Ee([ne(0,M.$Oac),ne(1,R.$Cac),ne(2,S.$Abc),ne(3,i.$wac)],P)}),define(oe[312],ae([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n,r,c,b,I,D,j,A,C,W,T,N,U,ue,ie,le,Y,K,B,L,H,G,z,ce,he,X,O,F,_,se,J,x,V,q,re,ee,fe,me,ve,ke,Ie,Fe,ye,Z,de,$e,Pe,Ae,Be,Me,Le,Ue,Ve,Xe,He,te,ge,we,be,Se,Oe,Ne,Je,Ze,Ye,Ke,st,it,ot,at,vt,kt,Et,St,Pt,ct,gt,jt,It,Dt,lt,Rt,$t,ut,Ct,At,ht,Ot,mt,Mt,wt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;let dt=class extends w.$Uc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(je,De,Ce,pe,Re,ze,qe,Ge,We,Te,xe,Qe){super(),this.g=je,this.h=De,this.j=Ce,this.m=pe,this.n=Re,this.s=ze,this.t=qe,this.u=Ge,this.w=We,this.y=Te,this.z=xe,this.C=Qe,this.D(),this.F()}D(){const je=We=>We?.startsWith(`${m.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((We,Te,xe,Qe)=>je(Qe.requestingUrl)?xe(De.has(Te)):xe(!1)),i.session.defaultSession.setPermissionCheckHandler((We,Te,xe,Qe)=>je(Qe.requestingUrl)?De.has(Te):!1);const Ce=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=We=>{for(let Te=We;Te;Te=Te.parent)if(Te.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Re=We=>We.resourceType==="xhr"||pe(We.frame),ze=We=>{const Te=We.frame;if(!Te||!this.b)return!1;const xe=i.BrowserWindow.getAllWindows();for(const Qe of xe)if(Te.processId===Qe.webContents.mainFrame.processId)return!0;return!1},qe=(We,Te)=>{if(We.path!=="/index.html")return!0;const xe=Te.frame;if(!xe||!this.b)return!1;for(const Qe of this.b.getWindows())if(Qe.win&&xe.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((We,Te)=>{const xe=f.URI.parse(We.url);return xe.scheme===m.Schemas.vscodeWebview&&!qe(xe,We)?(this.m.error("Blocked vscode-webview request",We.url),Te({cancel:!0})):xe.scheme===m.Schemas.vscodeFileResource&&!ze(We)?(this.m.error("Blocked vscode-file request",We.url),Te({cancel:!0})):xe.path.endsWith(".svg")&&!Ce.has(xe.scheme)?Te({cancel:!Re(We)}):Te({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((We,Te)=>{const xe=We.responseHeaders,Qe=xe["content-type"]||xe["Content-Type"];if(Qe&&Array.isArray(Qe)){const _e=f.URI.parse(We.url);if(_e.path.endsWith(".svg")&&Ce.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Te({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Qe.some(nt=>nt.toLowerCase().includes("image/svg")))return Te({cancel:!Re(We)})}return Te({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((We,Te)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const xe=We.responseHeaders??Object.create(null);if(xe["Access-Control-Allow-Origin"]===void 0)return xe["Access-Control-Allow-Origin"]=["*"],Te({cancel:!1,responseHeaders:xe})}return Te({cancel:!1})});const Ge=i.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,v.$kc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Ce=>this.H(Ce)),process.on("uncaughtException",Ce=>{(0,h.$Z)(Ce)||(0,h.$1)(Ce)}),process.on("unhandledRejection",Ce=>(0,h.$1)(Ce)),this.t.onWillShutdown(()=>this.dispose()),(0,d.$kW)(),i.app.on("accessibility-support-changed",(Ce,pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",pe)}),i.app.on("activate",async(Ce,pe)=>{this.m.trace("app#activate"),pe||await this.b?.openEmptyWindow({context:1})}),i.app.on("web-contents-created",(Ce,pe)=>{pe?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$Gg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(pe)),pe.on("will-navigate",Re=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),pe.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Re)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.f?.openExternal(void 0,Re.url),{action:"deny"}))});let je=[],De;i.app.on("open-file",(Ce,pe)=>{pe=(0,wt.$5l)(pe),this.m.trace("app#open-file: ",pe),Ce.preventDefault(),je.push((0,Oe.$Si)(pe)?{workspaceUri:f.URI.file(pe)}:{fileUri:f.URI.file(pe)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:je,gotoLineMode:!1,preferNewWindow:!0}),je=[],De=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),S.$jW.handle("vscode:fetchShellEnv",Ce=>{const pe=this.b?.getWindowByWebContents(Ce.sender);let Re,ze;return pe?.config?(Re=pe.config,ze={...process.env,...pe.config.userEnv}):(Re=this.s.args,ze=process.env),this.X(Re,ze,!1)}),S.$jW.handle("vscode:writeNlsFile",(Ce,pe,Re)=>{const ze=this.G([pe]);if(!ze||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,P.$ze.fromString(Re))}),S.$jW.handle("vscode:readNlsFile",async(Ce,...pe)=>{const Re=this.G(pe);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Re)).value.toString()}),S.$jW.on("vscode:toggleDevTools",Ce=>Ce.sender.toggleDevTools()),S.$jW.on("vscode:openDevTools",Ce=>Ce.sender.openDevTools()),S.$jW.on("vscode:reloadWindow",Ce=>Ce.sender.reload()),S.$jW.handle("vscode:notifyZoomLevel",async(Ce,pe)=>{const Re=this.b?.getWindowById(Ce.sender.id);Re&&Re.notifyZoomLevel(pe)})}G(je){let De;for(const Ce of je)typeof Ce=="string"&&(typeof De!="string"?De=Ce:De=(0,v.$kc)(De,Ce));if(!(typeof De!="string"||!(0,v.$jc)(De)||!(0,u.$ng)(De,this.s.cachedLanguagesPath,!p.$k)))return f.URI.file(De)}H(je){if(je){const De={message:`[uncaught exception in main]: ${je.message}`,stack:je.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${je}`),je.stack&&this.m.error(je.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const je=this.z.win32AppUserModelId;p.$i&&je&&i.app.setAppUserModelId(je);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.m.error(Te)}const De=new t.$qW;this.t.onWillShutdown(Te=>{Te.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Ce,pe]=await Promise.all([(0,gt.$ccc)(this.w,this.m),(0,gt.$dcc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ce}`);const{sharedProcessReady:Re,sharedProcessClient:ze}=this.P(Ce,pe),qe=await this.Q(Ce,pe,Re);this.B(qe.createInstance(s.$6ac)),this.B(qe.createInstance(St.$$bc)),qe.invokeFunction(Te=>this.R(Te,De,ze));const Ge=await qe.invokeFunction(Te=>this.I(Te,De));this.J(De),this.t.phase=2,await qe.invokeFunction(Te=>this.S(Te,Ge)),this.t.phase=3,this.U(),this.B(new ct.$zh(()=>{this.B((0,ct.$Dh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(je,De){const Ce=this.b=je.get(we.$Cac),pe=je.get(Le.$$W),Re=this.f=je.get(x.$obc),ze=je.get(A.$xac),qe=this;pe.registerHandler({async handleURL(_e,nt){return qe.O(Ce,ze,pe,_e,nt)}});const Ge=this.B(new Se.$6bc({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),We=new a.$8h(_e=>Ge.getActiveClientId().then(nt=>_e===nt)),Te=new Ue.$Wbc(We,this.m),xe=De.getChannel("urlHandler",Te);pe.registerHandler(new Ue.$Vbc(xe));const Qe=await this.L(Ce,ze);return this.B(new Xe.$Xbc(Qe?.urls,pe,Ce,this.s,this.z,this.m)),Qe}J(je){const De=()=>({statusCode:404,data:"Not found"}),Ce=new Ot.$V(()=>je.getChannel(ht.$kcc,new ht.$lcc));i.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(pe,Re)=>{const ze=f.URI.parse(pe.url);if(!ze.authority.startsWith("window:"))return Re(De());Ce.value.call(ht.$jcc,[ze]).then(qe=>Re({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.m.warn("error dispatching remote resource call",qe),Re({statusCode:500,data:String(qe)})})})}async L(je,De){const Ce=this.s.args["open-url"]?this.s.args._urls||[]:[];Ce.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),Ce.length+pe.length===0)return;const Re=[...Ce,...pe].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),ze=[],qe=[];for(const Ge of Re){if(!Ge)continue;const We=this.N(Ge.uri);if(We)if(await this.M(We,je,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),We),ze.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),qe.push(Ge)}return{urls:qe,openables:ze}}async M(je,De,Ce){let pe,Re;if((0,ge.$kD)(je)?(pe=je.workspaceUri,Re=(0,n.localize)(0,null,pe.scheme===m.Schemas.file?(0,k.$lw)(pe,{os:p.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)):(0,ge.$lD)(je)?(pe=je.folderUri,Re=(0,n.localize)(1,null,pe.scheme===m.Schemas.file?(0,k.$lw)(pe,{os:p.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)):(pe=je.fileUri,Re=(0,n.localize)(2,null,pe.scheme===m.Schemas.file?(0,k.$lw)(pe,{os:p.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)),pe.scheme!==m.Schemas.file&&pe.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[pe.scheme])===!1)return!1;const{response:qe,checkboxChecked:Ge}=await Ce.showMessageBox({type:"warning",buttons:[(0,n.localize)(3,null),(0,n.localize)(4,null)],message:Re,detail:(0,n.localize)(5,null),checkboxLabel:pe.scheme===m.Schemas.file?(0,n.localize)(6,null):(0,n.localize)(7,null),cancelId:1});if(qe!==0)return!0;if(Ge){const We={channel:"vscode:disablePromptForProtocolHandling",args:pe.scheme===m.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(je){if(je.path){if(je.authority===m.Schemas.file){const De=f.URI.file(je.fsPath);return(0,Oe.$Si)(De)?{workspaceUri:De}:{fileUri:De}}else if(je.authority===m.Schemas.vscodeRemote){const De=je.path.indexOf(v.$hc.sep,1);if(De!==-1){const Ce=je.path.substring(1,De),pe=je.path.substring(De);let Re=je.query;const ze=new URLSearchParams(je.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Re=ze.toString());const qe=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:Ce,path:pe,query:Re,fragment:je.fragment});return(0,Oe.$Si)(pe)?{workspaceUri:qe}:/:[\d]+$/.test(pe)?{fileUri:qe}:{folderUri:qe}}}}}async O(je,De,Ce,pe,Re){this.m.trace("app#handleProtocolUrl():",pe.toString(!0),Re),pe.scheme===this.z.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:f.URI.parse(pe.query).path,query:""}));let ze=!1;const qe=new URLSearchParams(pe.query);qe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),qe.delete("windowId"),pe=pe.with({query:qe.toString()}),ze=!0):p.$j&&je.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),ze=!0);const Ge=qe.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),qe.delete("continueOn"),pe=pe.with({query:qe.toString()}),this.s.continueOn=Ge??void 0);const We=this.N(pe);return We?await this.M(We,je,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,pe.toString(!0)),(0,$t.$Ob)(await je.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,$t.$Ob)(await je.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,q.$ym)(pe)}))?.ready(),Ce.open(pe,Re)):(this.m.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Re),!1)}P(je,De){const Ce=this.B(this.j.createInstance(re.$Ibc,je,De)),pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Ce.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$rW(ze,"main")})();return{sharedProcessReady:(async()=>(await Ce.whenReady(),pe))(),sharedProcessClient:pe}}async Q(je,De,Ce){const pe=new ce.$li;switch(process.platform){case"win32":pe.set(de.$iX,new G.$ki(Me.$Tbc));break;case"linux":p.$l?pe.set(de.$iX,new G.$ki(Be.$Sbc,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(de.$iX,new G.$ki(Ae.$Rbc));break;case"darwin":pe.set(de.$iX,new G.$ki(Pe.$Qbc));break}pe.set(we.$Cac,new G.$ki(be.$5bc,[je,De,this.h],!1)),pe.set(mt.$nbc,new G.$ki(Mt.$mcc,void 0,!1));const Re=new A.$yac(this.m,this.z);pe.set(A.$xac,Re),pe.set(F.$ubc,new G.$ki(F.$vbc,void 0,!1)),pe.set(j.$_ac,new G.$ki(j.$abc,void 0,!1)),pe.set(D.$7m,a.ProxyChannel.toService((0,a.$6h)(Ce.then(Te=>Te.getChannel("diagnostics"))))),pe.set(he.$UIb,new G.$ki(X.$qbc,[this.h])),pe.set(C.$5W,new G.$ki(W.$bbc)),pe.set(O.$rbc,new G.$ki(O.$sbc)),pe.set(x.$obc,new G.$ki(x.$pbc,void 0,!1)),pe.set(He.$Ybc,new G.$ki(te.$1bc)),pe.set(J.$Dbc,new G.$ki(J.$Ebc)),pe.set(ue.$cbc,new G.$ki(ie.$ebc)),pe.set(ve.$2ac,new G.$ki(ve.$3ac)),pe.set(ve.$4ac,new G.$ki(ve.$5ac));const ze=new Ct.$icc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),qe=new At.$ks(ze,this.u,this.m,this.n);pe.set(ut.$Xr,qe),p.$i?pe.set(le.$fbc,new G.$ki(Y.$gbc)):p.$j?pe.set(le.$fbc,new G.$ki(Y.$hbc)):p.$k&&pe.set(le.$fbc,new G.$ki(Y.$ibc));const Ge=new c.$7ac(this.s,this.u,this.m,this.w);pe.set(r.$wac,Ge);const We=new Ye.$Pac(this.s,this.m,this.C,Ge,Re);if(pe.set(Ye.$Oac,We),pe.set(Ne.$9eb,new G.$ki(Ze.$7bc,void 0,!1)),pe.set(Je.$Abc,new G.$ki(Je.$Bbc,void 0,!1)),pe.set(Le.$$W,new G.$ki(Ve.$aX,void 0,!1)),(0,Z.$dp)(this.z,this.s)){const Te=(0,Z.$ip)(this.z,this.u),xe=(0,a.$6h)(Ce.then(rt=>rt.getChannel("telemetryAppender"))),Qe=new Fe.$Lbc(xe),_e=(0,ke.$7o)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,je,De,Te),nt=(0,Z.$jp)(this.s),et={appenders:[Qe],commonProperties:_e,piiPaths:nt,sendErrorTelemetry:!0};pe.set(Ie.$Sl,new G.$ki(ye.$Or,[et],!1))}else pe.set(Ie.$Sl,Z.$$o);return pe.set(vt.$gq,new G.$ki(jt.$fQ,void 0,!0)),pe.set(kt.$kq,new G.$ki(Et.$0bc,void 0,!0)),pe.set(lt.$gcc,new G.$ki(lt.$hcc,void 0,!0)),await ct.Promises.settled([Ge.initialize(),We.initialize()]),this.j.createChild(pe)}R(je,De,Ce){const pe=this.B(new w.$Tc),Re=a.ProxyChannel.fromService(je.get(F.$ubc),pe,{disableMarshalling:!0});this.g.registerChannel("launch",Re);const ze=a.ProxyChannel.fromService(je.get(j.$_ac),pe,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const qe=new st.$8bc(je.get(Ke.$8n));De.registerChannel("policy",qe),Ce.then(tt=>tt.registerChannel("policy",qe));const Ge=this.y.getProvider(m.Schemas.file);(0,$.$$f)(Ge instanceof H.$1q);const We=new L.$jbc(Ge,this.m,this.s);De.registerChannel(K.$1P,We),Ce.then(tt=>tt.registerChannel(K.$1P,We));const Te=a.ProxyChannel.fromService(je.get(it.$Fac),pe);De.registerChannel("userDataProfiles",Te),Ce.then(tt=>tt.registerChannel("userDataProfiles",Te));const xe=new ot.$Jr(je.get(at.$Ep));Ce.then(tt=>tt.registerChannel("request",xe));const Qe=new $e.$Mbc(je.get(de.$iX));De.registerChannel("update",Qe);const _e=a.ProxyChannel.fromService(je.get(he.$UIb),pe);De.registerChannel("issue",_e);const nt=a.ProxyChannel.fromService(je.get(C.$5W),pe);De.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(je.get(ee.$Gl),pe);De.registerChannel("sign",et);const rt=a.ProxyChannel.fromService(je.get(O.$rbc),pe);De.registerChannel("keyboardLayout",rt),this.f=je.get(x.$obc);const pt=a.ProxyChannel.fromService(this.f,pe);De.registerChannel("nativeHost",pt),Ce.then(tt=>tt.registerChannel("nativeHost",pt));const Lt=a.ProxyChannel.fromService(je.get(Ne.$9eb),pe);De.registerChannel("workspaces",Lt);const Wt=a.ProxyChannel.fromService(je.get(J.$Dbc),pe);De.registerChannel("menubar",Wt);const Ft=a.ProxyChannel.fromService(je.get(Le.$$W),pe);De.registerChannel("url",Ft);const Tt=a.ProxyChannel.fromService(je.get(He.$Ybc),pe);De.registerChannel("webview",Tt);const bt=this.B(new me.$Jbc(this.m,je.get(ve.$2ac)));De.registerChannel("storage",bt),Ce.then(tt=>tt.registerChannel("storage",bt));const Ht=this.B(new Pt.$_bc(je.get(ve.$2ac),je.get(it.$Fac),this.m));Ce.then(tt=>tt.registerChannel("profileStorageListener",Ht));const Nt=a.ProxyChannel.fromService(je.get(ut.$Xr),pe);De.registerChannel(ut.TerminalIpcChannels.LocalPty,Nt);const zt=a.ProxyChannel.fromService(je.get(le.$fbc),pe);De.registerChannel("externalTerminal",zt);const yt=new It.$ecc(je.get(Dt.$Qac));De.registerChannel("logger",yt),Ce.then(tt=>tt.registerChannel("logger",yt));const Bt=new I.$8ac(je.get(we.$Cac));De.registerChannel("extensionhostdebugservice",Bt);const qt=a.ProxyChannel.fromService(je.get(ue.$cbc),pe);De.registerChannel(ue.$dbc,qt);const Ut=a.ProxyChannel.fromService(je.get(lt.$gcc),pe);De.registerChannel(Rt.$fcc,Ut)}async S(je,De){const Ce=this.b=je.get(we.$Cac);this.c=je.get(mt.$nbc);const pe=(0,N.$rm)(process.env)?0:4,Re=this.s.args;if(De){if(De.openables.length>0)return Ce.open({context:pe,cli:Re,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const et of De.urls){const rt=new URLSearchParams(et.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:rt.toString()}),Ce.open({context:pe,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,qe=Re._.length,Ge=!!Re["folder-uri"],We=!!Re["file-uri"],Te=Re["skip-add-to-recently-opened"]===!0,xe=Re.wait&&Re.waitMarkerFilePath?f.URI.file(Re.waitMarkerFilePath):void 0,Qe=Re.remote||void 0,_e=Re.profile,nt=Re["profile-temp"];if(!qe&&!Ge&&!We){if(Re["new-window"]||_e||nt)return Ce.open({context:pe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Te,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Qe,forceProfile:_e,forceTempProfile:nt});if(ze.length)return Ce.open({context:1,cli:Re,urisToOpen:ze.map(et=>(et=(0,wt.$5l)(et),(0,Oe.$Si)(et)?{workspaceUri:f.URI.file(et)}:{fileUri:f.URI.file(et)})),noRecentEntry:Te,waitMarkerFileURI:xe,initialStartup:!0})}return Ce.open({context:pe,cli:Re,forceNewWindow:Re["new-window"]||!qe&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Te,waitMarkerFileURI:xe,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:_e,forceTempProfile:nt})}U(){this.W(),i.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(je,De)=>{De({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const je=this.z.win32MutexName;if(p.$i&&je)try{const De=await new Promise((pe,Re)=>{Q(["@vscode/windows-mutex"],pe,Re)}),Ce=new De.Mutex(je);g.Event.once(this.t.onWillShutdown)(()=>Ce.release())}catch(De){this.m.error(De)}}async X(je,De,Ce){try{return await(0,U.$xm)(this.u,this.m,je,De)}catch(pe){const Re=(0,E.$$i)(pe);Ce?this.b?.sendToFocused("vscode:showResolveShellEnvError",Re):this.m.error(Re)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Ce=JSON.parse((0,y.$In)(De)),Re=(0,Z.$fp)(this.u)>=1;if(Ce["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$Jg)()}"`,"}"],qe=De.substring(0,De.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,P.$ze.fromString(qe))}else{const ze=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);ze!==De&&await this.y.writeFile(this.s.argvResource,P.$ze.fromString(ze))}}catch(je){this.m.error(je)}}};e.$ncc=dt,e.$ncc=dt=ft=Ee([ne(2,z.$mi),ne(3,se.$Tj),ne(4,se.$Uj),ne(5,T.$rac),ne(6,_.$Vac),ne(7,b.$Ti),ne(8,fe.$$P),ne(9,B.$Tk),ne(10,V.$ak),ne(11,it.$Fac)],dt)}),define(oe[317],ae([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(Q,e,i,R,S,M,P,E,h,u,g,y,k,w,m,v,p,$,f,l,d,a,t,o,s,n,r,c,b,I,D,j,A,C,W,T,N,U,ue,ie,le,Y,K,B,L,H,G,z,ce,he,X,O,F,_,se,J,x,V,q,re,ee,fe,me,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.a()}catch(ye){console.error(ye.message),i.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Le=>console.error(Le));const[ye,Z,de,$e,Pe,Ae,Be,Me]=this.b();try{try{await this.d(de,Me,$e,Pe,Be)}catch(Le){throw this.g(de,Be,Le),Le}await ye.invokeFunction(async Le=>{const Ue=Le.get(U.$Tj),Ve=Le.get(T.$Vac),Xe=Le.get(I.$Tk),He=Le.get(U.$Uj),te=await this.f(Ue,de,Ve,ye,Be,!0);return f.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(ge=>{Ue.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Ae.logger=He.createLogger("main",{name:(0,t.localize)(0,null)}),g.Event.once(Ve.onWillShutdown)(ge=>{Xe.dispose(),$e.dispose(),ge.join("instanceLockfile",f.Promises.unlink(de.mainLockfile).catch(()=>{}))}),ye.createInstance(a.$ncc,te,Z).startup()})}catch(Le){ye.invokeFunction(this.j,Le)}}b(){const ye=new W.$li,Z=new J.$Tc;process.once("exit",()=>Z.dispose());const de={_serviceBrand:void 0,...ue.default};ye.set(ie.$ak,de);const $e=new r.$sac(this.k(),de),Pe=this.c($e);ye.set(r.$rac,$e);const Ae=new q.$Rac((0,U.$8j)($e),$e.logsHome);ye.set(q.$Qac,Ae);const Be=new N.$00b(Ae.getLogLevel()),Me=Z.add(new re.$gQ(Be,[new U.$1j(Ae.getLogLevel())]));ye.set(U.$Tj,Me);const Le=new D.$zq(Me);ye.set(I.$Tk,Le);const Ue=new j.$1q(Me);Le.registerProvider(k.Schemas.file,Ue);const Ve=new V.$os(Le);ye.set(x.$rl,Ve);const Xe=new fe.$bQ(1,$e,Me,Le);ye.set(ce.$0P,Xe),ye.set(ce.$$P,Xe);const He=new O.$Gac(Xe,Ve,$e,Le,Me);ye.set(O.$Fac,He),Le.registerProvider(k.Schemas.vscodeUserData,new me.$ycc(k.Schemas.file,Ue,k.Schemas.vscodeUserData,He,Ve,Me));const te=v.$i&&de.win32RegValueName?Z.add(new _.$wcc(Me,de.win32RegValueName)):$e.policyFile?Z.add(new se.$xcc($e.policyFile,Le,Me)):new F.$0n;ye.set(F.$8n,te);const ge=new s.$xo(He.defaultProfile.settingsResource,Le,te,Me);return ye.set(o.$Ti,ge),ye.set(T.$Vac,new A.$ki(T.$Wac,void 0,!1)),ye.set(L.$Ep,new A.$ki(H.$ucc,void 0,!0)),ye.set(X.$Aac,new A.$ki(X.$Bac)),ye.set(G.$Gl,new A.$ki(z.$vcc,void 0,!1)),ye.set(K.$2v,new A.$ki(B.$scc)),ye.set(le.$zac,new Y.$pcc($e,He,Me)),[new C.$4q(ye,!0),Pe,$e,ge,Xe,Be,de,He]}c(ye){const Z={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const $e=process.env[de];typeof $e=="string"&&(Z[de]=$e)}),Object.assign(process.env,Z),Z}async d(ye,Z,de,$e,Pe){await P.Promises.settled([Promise.all([this.e(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:k.Schemas.file}).fsPath,Z.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ye.backupHome].map(Ae=>Ae?f.Promises.mkdir(Ae,{recursive:!0}):void 0)),$e.init(),de.initialize()]),Z.init()}e(ye){if(v.$i){const Z=(0,ve.getUNCHost)(ye);Z&&(0,ve.addUNCHostToAllowlist)(Z)}return ye}async f(ye,Z,de,$e,Pe,Ae){let Be;try{(0,m.mark)("code/willStartMainServer"),Be=await(0,d.$ii)(Z.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),g.Event.once(de.onWillShutdown)(()=>Be.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(Z,Pe,Me),Me;let Le;try{Le=await(0,d.$ji)(Z.mainIPCHandle,"main")}catch(He){if(!Ae||v.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.h((0,t.localize)(1,null,Pe.nameShort),(0,t.localize)(2,null),Pe),He;try{(0,R.unlinkSync)(Z.mainIPCHandle)}catch(te){throw ye.warn("Could not delete obsolete instance handle",te),te}return this.f(ye,Z,de,$e,Pe,!1)}if(Z.extensionTestsLocationURI&&!Z.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${Pe.nameShort} is running.`;throw ye.error(He),Le.dispose(),new Error(He)}let Ue;!Z.args.wait&&!Z.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,Pe.nameShort),(0,t.localize)(4,null),Pe)},1e4));const Ve=l.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Xe=l.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(Z.args.status)return $e.invokeFunction(async()=>{const He=new n.$vs(he.$$o,Pe),te=await Xe.getMainDiagnostics(),ge=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),we=await He.getDiagnostics(te,ge);throw console.log(we),new h.$ab});throw v.$i&&await this.i(Ve,ye),ye.trace("Sending env to running instance..."),await Ve.start(Z.args,process.env),Le.dispose(),Ue&&clearTimeout(Ue),new h.$ab("Sent env to running instance. Terminating...")}if(Z.args.status)throw console.log((0,t.localize)(5,null,Pe.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Be}g(ye,Z,de){if(de.code==="EACCES"||de.code==="EPERM"){const $e=(0,M.$Hb)([ye.userDataPath,ye.extensionsPath,d.$ei]).map(Pe=>(0,y.$lw)(S.URI.file(Pe),{os:v.OS,tildify:ye}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$$i)(de),$e.join(`
`)),Z)}}h(ye,Z,de){i.dialog.showMessageBoxSync((0,ee.$zw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:Z},de).options)}async i(ye,Z){if(v.$i){const de=await ye.getMainProcessId();Z.trace("Sending some foreground love to the running instance:",de);try{(await new Promise(($e,Pe)=>{Q(["windows-foreground-love"],$e,Pe)})).allowSetForegroundWindow(de)}catch($e){Z.error($e)}}}j(ye,Z){const de=ye.get(U.$Tj),$e=ye.get(T.$Vac);let Pe=0;Z&&(Z.isExpected?Z.message&&de.trace(Z.message):(Pe=1,Z.stack?de.error(Z.stack):de.error(`Startup error: ${Z.toString()}`))),$e.kill(Pe)}k(){const ye=this.l((0,c.$om)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const Z=(0,b.$occ)(ye.verbose);Z&&((0,c.$qm)(process.argv,"--waitMarkerFilePath",Z),ye.waitMarkerFilePath=Z)}return ye}l(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const Z=this.m(ye._,ye.goto);ye._=Z}return ye}m(ye,Z){const de=(0,p.cwd)(),$e=ye.map(Be=>{let Me=String(Be),Le;Z&&(Le=(0,u.$ug)(Me),Me=Le.path),Me&&(Me=this.n(de,Me));const Ue=(0,u.$pg)(Me,de),Ve=(0,w.$oc)(Ue);return Ve&&!(0,u.$lg)(Ve)?null:Z&&Le?(Le.path=Ue,this.o(Le)):Ue}),Pe=v.$i||v.$j,Ae=(0,M.$Mb)($e,Be=>Be&&Pe?Be.toLowerCase():Be||"");return(0,M.$Hb)(Ae)}n(ye,Z){return v.$i&&(Z=(0,$.$$e)(Z,'"')),Z=(0,$.$9e)((0,$.$9e)(Z," "),"	"),v.$i&&(Z=(0,w.$lc)(ye,Z),Z=(0,$.$$e)(Z,".")),Z}o(ye){const Z=[ye.path];return typeof ye.line=="number"&&Z.push(String(ye.line)),typeof ye.column=="number"&&Z.push(String(ye.column)),Z.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/code/electron-main/main.js.map
