/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/utils","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(ne){for(var t=[],i=0,F=ne.length;i<F;i++)t[i]=ge[ne[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Pt,setPrototypeOf:Bt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Rt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,i,F){return t.apply(i,F)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Rt||(Rt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),xt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),It=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(ne){return function(t){for(var i=arguments.length,F=new Array(i>1?i-1:0),P=1;P<i;P++)F[P-1]=arguments[P];return Nt(ne,t,F)}}function ui(ne){return function(){for(var t=arguments.length,i=new Array(t),F=0;F<t;F++)i[F]=arguments[F];return Rt(ne,i)}}function ze(ne,t,i){var F;i=(F=i)!==null&&F!==void 0?F:Dt,Bt&&Bt(ne,null);let P=t.length;for(;P--;){let W=t[P];if(typeof W=="string"){const S=i(W);S!==W&&(ii(t)||(t[P]=S),W=S)}ne[W]=!0}return ne}function bt(ne){const t=ri(null);for(const[i,F]of Pt(ne))t[i]=F;return t}function Et(ne,t){for(;ne!==null;){const F=si(ne,t);if(F){if(F.get)return ct(F.get);if(typeof F.value=="function")return ct(F.value)}ne=ni(ne)}function i(F){return console.warn("fallback value for",F),null}return i}const zt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,yi=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let F=null;const P="data-tt-policy-suffix";i&&i.hasAttribute(P)&&(F=i.getAttribute(P));const W="dompurify"+(F?"#"+F:"");try{return t.createPolicy(W,{createHTML(S){return S},createScriptURL(S){return S}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Yt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Pe=>Yt(Pe);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const i=ne.document,F=i.currentScript;let{document:P}=ne;const{DocumentFragment:W,HTMLTemplateElement:S,Node:A,Element:m,NodeFilter:b,NamedNodeMap:w=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:B,DOMParser:c,trustedTypes:f}=ne,e=m.prototype,n=Et(e,"cloneNode"),r=Et(e,"nextSibling"),h=Et(e,"childNodes"),g=Et(e,"parentNode");if(typeof S=="function"){const Pe=P.createElement("template");Pe.content&&Pe.content.ownerDocument&&(P=Pe.content.ownerDocument)}let D,o="";const{implementation:d,createNodeIterator:l,createDocumentFragment:T,getElementsByTagName:N}=P,{importNode:R}=i;let I={};t.isSupported=typeof Pt=="function"&&typeof g=="function"&&d&&d.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:j,ERB_EXPR:$,TMPLIT_EXPR:O,DATA_ATTR:V,ARIA_ATTR:M,IS_SCRIPT_OR_DATA:H,ATTR_WHITESPACE:C}=Gt;let{IS_ALLOWED_URI:G}=Gt,Z=null;const ce=ze({},[...zt,...Lt,...Mt,...jt,...Wt]);let re=null;const te=ze({},[...Vt,...Ot,...qt,...St]);let $e=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),De=null,Fe=null,He=!0,he=!0,_=!1,ae=!0,le=!1,J=!1,Q=!1,se=!1,fe=!1,ve=!1,Ne=!1,Ae=!0,Le=!1;const x="user-content-";let u=!0,y=!1,a={},p=null;const k=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const E=ze({},["audio","video","img","source","image","track"]);let v=null;const L=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),z="http://www.w3.org/1998/Math/MathML",X="http://www.w3.org/2000/svg",U="http://www.w3.org/1999/xhtml";let oe=U,we=!1,me=null;const Ie=ze({},[z,X,U],It);let ke;const je=["application/xhtml+xml","text/html"],Ee="text/html";let Te,We=null;const Ue=P.createElement("form"),Ye=function(ue){return ue instanceof RegExp||ue instanceof Function},_e=function(ue){if(!(We&&We===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),ke=je.indexOf(ue.PARSER_MEDIA_TYPE)===-1?ke=Ee:ke=ue.PARSER_MEDIA_TYPE,Te=ke==="application/xhtml+xml"?It:Dt,Z="ALLOWED_TAGS"in ue?ze({},ue.ALLOWED_TAGS,Te):ce,re="ALLOWED_ATTR"in ue?ze({},ue.ALLOWED_ATTR,Te):te,me="ALLOWED_NAMESPACES"in ue?ze({},ue.ALLOWED_NAMESPACES,It):Ie,v="ADD_URI_SAFE_ATTR"in ue?ze(bt(L),ue.ADD_URI_SAFE_ATTR,Te):L,s="ADD_DATA_URI_TAGS"in ue?ze(bt(E),ue.ADD_DATA_URI_TAGS,Te):E,p="FORBID_CONTENTS"in ue?ze({},ue.FORBID_CONTENTS,Te):k,De="FORBID_TAGS"in ue?ze({},ue.FORBID_TAGS,Te):{},Fe="FORBID_ATTR"in ue?ze({},ue.FORBID_ATTR,Te):{},a="USE_PROFILES"in ue?ue.USE_PROFILES:!1,He=ue.ALLOW_ARIA_ATTR!==!1,he=ue.ALLOW_DATA_ATTR!==!1,_=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,le=ue.SAFE_FOR_TEMPLATES||!1,J=ue.WHOLE_DOCUMENT||!1,fe=ue.RETURN_DOM||!1,ve=ue.RETURN_DOM_FRAGMENT||!1,Ne=ue.RETURN_TRUSTED_TYPE||!1,se=ue.FORCE_BODY||!1,Ae=ue.SANITIZE_DOM!==!1,Le=ue.SANITIZE_NAMED_PROPS||!1,u=ue.KEEP_CONTENT!==!1,y=ue.IN_PLACE||!1,G=ue.ALLOWED_URI_REGEXP||Kt,oe=ue.NAMESPACE||U,$e=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&($e.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&($e.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&($e.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),le&&(he=!1),ve&&(fe=!0),a&&(Z=ze({},[...Wt]),re=[],a.html===!0&&(ze(Z,zt),ze(re,Vt)),a.svg===!0&&(ze(Z,Lt),ze(re,Ot),ze(re,St)),a.svgFilters===!0&&(ze(Z,Mt),ze(re,Ot),ze(re,St)),a.mathMl===!0&&(ze(Z,jt),ze(re,qt),ze(re,St))),ue.ADD_TAGS&&(Z===ce&&(Z=bt(Z)),ze(Z,ue.ADD_TAGS,Te)),ue.ADD_ATTR&&(re===te&&(re=bt(re)),ze(re,ue.ADD_ATTR,Te)),ue.ADD_URI_SAFE_ATTR&&ze(v,ue.ADD_URI_SAFE_ATTR,Te),ue.FORBID_CONTENTS&&(p===k&&(p=bt(p)),ze(p,ue.FORBID_CONTENTS,Te)),u&&(Z["#text"]=!0),J&&ze(Z,["html","head","body"]),Z.table&&(ze(Z,["tbody"]),delete De.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');D=ue.TRUSTED_TYPES_POLICY,o=D.createHTML("")}else D===void 0&&(D=yi(f,F)),D!==null&&typeof o=="string"&&(o=D.createHTML(""));ot&&ot(ue),We=ue}},Y=ze({},["mi","mo","mn","ms","mtext"]),ie=ze({},["foreignobject","desc","title","annotation-xml"]),pe=ze({},["title","style","font","a","script"]),ye=ze({},Lt);ze(ye,Mt),ze(ye,ci);const Re=ze({},jt);ze(Re,fi);const xe=function(ue){let Ce=g(ue);(!Ce||!Ce.tagName)&&(Ce={namespaceURI:oe,tagName:"template"});const Me=Dt(ue.tagName),Qe=Dt(Ce.tagName);return me[ue.namespaceURI]?ue.namespaceURI===X?Ce.namespaceURI===U?Me==="svg":Ce.namespaceURI===z?Me==="svg"&&(Qe==="annotation-xml"||Y[Qe]):!!ye[Me]:ue.namespaceURI===z?Ce.namespaceURI===U?Me==="math":Ce.namespaceURI===X?Me==="math"&&ie[Qe]:!!Re[Me]:ue.namespaceURI===U?Ce.namespaceURI===X&&!ie[Qe]||Ce.namespaceURI===z&&!Y[Qe]?!1:!Re[Me]&&(pe[Me]||!ye[Me]):!!(ke==="application/xhtml+xml"&&me[ue.namespaceURI]):!1},Ve=function(ue){wt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},et=function(ue,Ce){try{wt(t.removed,{attribute:Ce.getAttributeNode(ue),from:Ce})}catch{wt(t.removed,{attribute:null,from:Ce})}if(Ce.removeAttribute(ue),ue==="is"&&!re[ue])if(fe||ve)try{Ve(Ce)}catch{}else try{Ce.setAttribute(ue,"")}catch{}},it=function(ue){let Ce,Me;if(se)ue="<remove></remove>"+ue;else{const at=li(ue,/^[\r\n\t ]+/);Me=at&&at[0]}ke==="application/xhtml+xml"&&oe===U&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Qe=D?D.createHTML(ue):ue;if(oe===U)try{Ce=new c().parseFromString(Qe,ke)}catch{}if(!Ce||!Ce.documentElement){Ce=d.createDocument(oe,"template",null);try{Ce.documentElement.innerHTML=we?o:Qe}catch{}}const nt=Ce.body||Ce.documentElement;return ue&&Me&&nt.insertBefore(P.createTextNode(Me),nt.childNodes[0]||null),oe===U?N.call(Ce,J?"html":"body")[0]:J?Ce.documentElement:nt},st=function(ue){return l.call(ue.ownerDocument||ue,ue,b.SHOW_ELEMENT|b.SHOW_COMMENT|b.SHOW_TEXT,null,!1)},Je=function(ue){return ue instanceof B&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof w)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof A=="object"?ue instanceof A:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},tt=function(ue,Ce,Me){I[ue]&&oi(I[ue],Qe=>{Qe.call(t,Ce,Me,We)})},mt=function(ue){let Ce;if(tt("beforeSanitizeElements",ue,null),Je(ue))return Ve(ue),!0;const Me=Te(ue.nodeName);if(tt("uponSanitizeElement",ue,{tagName:Me,allowedTags:Z}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ht(/<[/\w]/g,ue.innerHTML)&&ht(/<[/\w]/g,ue.textContent))return Ve(ue),!0;if(!Z[Me]||De[Me]){if(!De[Me]&&At(Me)&&($e.tagNameCheck instanceof RegExp&&ht($e.tagNameCheck,Me)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(Me)))return!1;if(u&&!p[Me]){const Qe=g(ue)||ue.parentNode,nt=h(ue)||ue.childNodes;if(nt&&Qe){const at=nt.length;for(let Xe=at-1;Xe>=0;--Xe)Qe.insertBefore(n(nt[Xe],!0),r(ue))}}return Ve(ue),!0}return ue instanceof m&&!xe(ue)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&ht(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ve(ue),!0):(le&&ue.nodeType===3&&(Ce=ue.textContent,Ce=dt(Ce,j," "),Ce=dt(Ce,$," "),Ce=dt(Ce,O," "),ue.textContent!==Ce&&(wt(t.removed,{element:ue.cloneNode()}),ue.textContent=Ce)),tt("afterSanitizeElements",ue,null),!1)},gt=function(ue,Ce,Me){if(Ae&&(Ce==="id"||Ce==="name")&&(Me in P||Me in Ue))return!1;if(!(he&&!Fe[Ce]&&ht(V,Ce))){if(!(He&&ht(M,Ce))){if(!re[Ce]||Fe[Ce]){if(!(At(ue)&&($e.tagNameCheck instanceof RegExp&&ht($e.tagNameCheck,ue)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(ue))&&($e.attributeNameCheck instanceof RegExp&&ht($e.attributeNameCheck,Ce)||$e.attributeNameCheck instanceof Function&&$e.attributeNameCheck(Ce))||Ce==="is"&&$e.allowCustomizedBuiltInElements&&($e.tagNameCheck instanceof RegExp&&ht($e.tagNameCheck,Me)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(Me))))return!1}else if(!v[Ce]){if(!ht(G,dt(Me,C,""))){if(!((Ce==="src"||Ce==="xlink:href"||Ce==="href")&&ue!=="script"&&ai(Me,"data:")===0&&s[ue])){if(!(_&&!ht(H,dt(Me,C,"")))){if(Me)return!1}}}}}}return!0},At=function(ue){return ue.indexOf("-")>0},kt=function(ue){let Ce,Me,Qe,nt;tt("beforeSanitizeAttributes",ue,null);const{attributes:at}=ue;if(!at)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:re};for(nt=at.length;nt--;){Ce=at[nt];const{name:ut,namespaceURI:$t}=Ce;if(Me=ut==="value"?Ce.value:hi(Ce.value),Qe=Te(ut),Xe.attrName=Qe,Xe.attrValue=Me,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,tt("uponSanitizeAttribute",ue,Xe),Me=Xe.attrValue,Xe.forceKeepAttr||(et(ut,ue),!Xe.keepAttr))continue;if(!ae&&ht(/\/>/i,Me)){et(ut,ue);continue}le&&(Me=dt(Me,j," "),Me=dt(Me,$," "),Me=dt(Me,O," "));const Ft=Te(ue.nodeName);if(gt(Ft,Qe,Me)){if(Le&&(Qe==="id"||Qe==="name")&&(et(ut,ue),Me=x+Me),D&&typeof f=="object"&&typeof f.getAttributeType=="function"&&!$t)switch(f.getAttributeType(Ft,Qe)){case"TrustedHTML":{Me=D.createHTML(Me);break}case"TrustedScriptURL":{Me=D.createScriptURL(Me);break}}try{$t?ue.setAttributeNS($t,ut,Me):ue.setAttribute(ut,Me),xt(t.removed)}catch{}}}tt("afterSanitizeAttributes",ue,null)},Tt=function Pe(ue){let Ce;const Me=st(ue);for(tt("beforeSanitizeShadowDOM",ue,null);Ce=Me.nextNode();)tt("uponSanitizeShadowNode",Ce,null),!mt(Ce)&&(Ce.content instanceof W&&Pe(Ce.content),kt(Ce));tt("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Pe){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ce,Me,Qe,nt;if(we=!Pe,we&&(Pe="<!-->"),typeof Pe!="string"&&!rt(Pe))if(typeof Pe.toString=="function"){if(Pe=Pe.toString(),typeof Pe!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Pe;if(Q||_e(ue),t.removed=[],typeof Pe=="string"&&(y=!1),y){if(Pe.nodeName){const ut=Te(Pe.nodeName);if(!Z[ut]||De[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Pe instanceof A)Ce=it("<!---->"),Me=Ce.ownerDocument.importNode(Pe,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Ce=Me:Ce.appendChild(Me);else{if(!fe&&!le&&!J&&Pe.indexOf("<")===-1)return D&&Ne?D.createHTML(Pe):Pe;if(Ce=it(Pe),!Ce)return fe?null:Ne?o:""}Ce&&se&&Ve(Ce.firstChild);const at=st(y?Pe:Ce);for(;Qe=at.nextNode();)mt(Qe)||(Qe.content instanceof W&&Tt(Qe.content),kt(Qe));if(y)return Pe;if(fe){if(ve)for(nt=T.call(Ce.ownerDocument);Ce.firstChild;)nt.appendChild(Ce.firstChild);else nt=Ce;return(re.shadowroot||re.shadowrootmode)&&(nt=R.call(i,nt,!0)),nt}let Xe=J?Ce.outerHTML:Ce.innerHTML;return J&&Z["!doctype"]&&Ce.ownerDocument&&Ce.ownerDocument.doctype&&Ce.ownerDocument.doctype.name&&ht(Qt,Ce.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Ce.ownerDocument.doctype.name+`>
`+Xe),le&&(Xe=dt(Xe,j," "),Xe=dt(Xe,$," "),Xe=dt(Xe,O," ")),D&&Ne?D.createHTML(Xe):Xe},t.setConfig=function(Pe){_e(Pe),Q=!0},t.clearConfig=function(){We=null,Q=!1},t.isValidAttribute=function(Pe,ue,Ce){We||_e({});const Me=Te(Pe),Qe=Te(ue);return gt(Me,Qe,Ce)},t.addHook=function(Pe,ue){typeof ue=="function"&&(I[Pe]=I[Pe]||[],wt(I[Pe],ue))},t.removeHook=function(Pe){if(I[Pe])return xt(I[Pe])},t.removeHooks=function(Pe){I[Pe]&&(I[Pe]=[])},t.removeAllHooks=function(){I={}},t}var Di=Yt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(ge[51],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VS=void 0,t.$WS=P;class i{constructor(S){this.domNode=S,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(S){const A=F(S);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(S){const A=F(S);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(S){const A=F(S);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(S){const A=F(S);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(S){const A=F(S);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(S){const A=F(S);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(S){const A=F(S);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(S){const A=F(S);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(S){const A=F(S);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(S){const A=F(S);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(S){const A=F(S);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(S){this.l!==S&&(this.l=S,this.domNode.style.fontFamily=this.l)}setFontWeight(S){this.m!==S&&(this.m=S,this.domNode.style.fontWeight=this.m)}setFontSize(S){const A=F(S);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(S){this.o!==S&&(this.o=S,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(S){this.p!==S&&(this.p=S,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(S){this.q!==S&&(this.q=S,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(S){this.r!==S&&(this.r=S,this.domNode.style.textDecoration=this.r)}setLineHeight(S){const A=F(S);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(S){const A=F(S);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(S){this.u!==S&&(this.u=S,this.domNode.className=this.u)}toggleClassName(S,A){this.domNode.classList.toggle(S,A),this.u=this.domNode.className}setDisplay(S){this.v!==S&&(this.v=S,this.domNode.style.display=this.v)}setPosition(S){this.w!==S&&(this.w=S,this.domNode.style.position=this.w)}setVisibility(S){this.x!==S&&(this.x=S,this.domNode.style.visibility=this.x)}setColor(S){this.y!==S&&(this.y=S,this.domNode.style.color=this.y)}setBackgroundColor(S){this.z!==S&&(this.z=S,this.domNode.style.backgroundColor=this.z)}setLayerHinting(S){this.A!==S&&(this.A=S,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(S){this.C!==S&&(this.C=S,this.domNode.style.boxShadow=S)}setContain(S){this.B!==S&&(this.B=S,this.domNode.style.contain=this.B)}setAttribute(S,A){this.domNode.setAttribute(S,A)}removeAttribute(S){this.domNode.removeAttribute(S)}appendChild(S){this.domNode.appendChild(S.domNode)}removeChild(S){this.domNode.removeChild(S.domNode)}}t.$VS=i;function F(W){return typeof W=="number"?`${W}px`:W}function P(W){return new i(W)}}),define(ge[79],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bR=void 0,t.$cR=W;const i=new WeakMap;function F(A){if(!A.parent||A.parent===A)return null;try{const m=A.location,b=A.parent.location;if(m.origin!=="null"&&b.origin!=="null"&&m.origin!==b.origin)return null}catch{return null}return A.parent}class P{static a(m){let b=i.get(m);if(!b){b=[],i.set(m,b);let w=m,B;do B=F(w),B?b.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):b.push({window:new WeakRef(w),iframeElement:null}),w=B;while(w)}return b.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,b){if(!b||m===b)return{top:0,left:0};let w=0,B=0;const c=this.a(m);for(const f of c){const e=f.window.deref();if(w+=e?.scrollY??0,B+=e?.scrollX??0,e===b||!f.iframeElement)break;const n=f.iframeElement.getBoundingClientRect();w+=n.top,B+=n.left}return{top:w,left:B}}}t.$bR=P;async function W(A,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const b=JSON.stringify({parentOrigin:A,salt:m}),B=new TextEncoder().encode(b),c=await crypto.subtle.digest("sha-256",B);return S(c)}function S(A){const b=Array.from(new Uint8Array(A)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${b}`).toString(32).padStart(52,"0")}}),define(ge[29],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1T=F,t.$2T=P;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function F(W){i=W}function P(){return i}}),define(ge[80],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DT=t.$CT=t.$BT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(S){S[S.Copy=0]="Copy",S[S.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var F;(function(S){S.Over="drop-target",S.Before="drop-target-before",S.After="drop-target-after"})(F||(t.ListDragOverEffectPosition=F={})),t.$BT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(A,m){super(`ListError [${A}] ${m}`)}}t.$CT=P;class W{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,m){m>0&&this.c.set(A,m)}}t.$DT=W}),define(ge[81],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rT=void 0;class i{constructor(P){this.a=P}splice(P,W,S){this.a.forEach(A=>A.splice(P,W,S))}}t.$rT=i}),define(ge[52],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2S=void 0;const i=20;class F{constructor(W,S,A,m,b,w){this.a=Math.round(S),this.b=Math.round(A),this.c=Math.round(W),this.d=m,this.e=b,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new F(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const S=Math.round(W);return this.d!==S?(this.d=S,this.m(),!0):!1}setScrollSize(W){const S=Math.round(W);return this.e!==S?(this.e=S,this.m(),!0):!1}setScrollPosition(W){const S=Math.round(W);return this.f!==S?(this.f=S,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,S,A,m,b){const w=Math.max(0,A-W),B=Math.max(0,w-2*S),c=m>0&&m>A;if(!c)return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(B),computedSliderRatio:0,computedSliderPosition:0};const f=Math.round(Math.max(i,Math.floor(A*B/m))),e=(B-f)/(m-A),n=b*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(f),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const W=F.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const S=W-this.c-this.i/2;return Math.round(S/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const S=W-this.c;let A=this.f;return S<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const S=this.k+W;return Math.round(S/this.j)}}t.$2S=F}),define(ge[30],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yV=t.$xV=t.$wV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var F;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(F||(t.ObjectTreeElementCollapseState=F={}));var P;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(P||(t.TreeMouseEventTarget=P={}));var W;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.$wV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class S extends Error{constructor(b,w){super(`TreeError [${b}] ${w}`)}}t.$xV=S;class A{constructor(b){this.a=b,this.b=new WeakMap}map(b){let w=this.b.get(b);return w||(w=this.a(b),this.b.set(b,w)),w}}t.$yV=A}),define(ge[22],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=void 0,t.$QQ=i,t.$SQ=F;function i(P,W){const S=P;typeof S.vscodeWindowId!="number"&&Object.defineProperty(S,"vscodeWindowId",{get:()=>W})}t.$RQ=window;function F(P){return P===t.$RQ?!1:typeof P?.vscodeWindowId=="number"}}),define(ge[82],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=F,t.$hb=P,t.$ib=W,t.$jb=S,t.$kb=A,t.$lb=m,t.$nb=w,t.$ob=B,t.$pb=c,t.$qb=f,t.$rb=e;function i(n,r,h){const g=F(n,r);if(g!==-1)return n[g]}function F(n,r,h=n.length-1){for(let g=h;g>=0;g--){const D=n[g];if(r(D))return g}return-1}function P(n,r){const h=W(n,r);return h===-1?void 0:n[h]}function W(n,r,h=0,g=n.length){let D=h,o=g;for(;D<o;){const d=Math.floor((D+o)/2);r(n[d])?D=d+1:o=d}return D-1}function S(n,r){const h=A(n,r);return h===n.length?void 0:n[h]}function A(n,r,h=0,g=n.length){let D=h,o=g;for(;D<o;){const d=Math.floor((D+o)/2);r(n[d])?o=d:D=d+1}return D}function m(n,r,h=0,g=n.length){const D=A(n,r,h,g);return D===n.length?-1:D}class b{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(b.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!r(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=W(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$mb=b;function w(n,r){if(n.length===0)return;let h=n[0];for(let g=1;g<n.length;g++){const D=n[g];r(D,h)>0&&(h=D)}return h}function B(n,r){if(n.length===0)return;let h=n[0];for(let g=1;g<n.length;g++){const D=n[g];r(D,h)>=0&&(h=D)}return h}function c(n,r){return w(n,(h,g)=>-r(h,g))}function f(n,r){if(n.length===0)return-1;let h=0;for(let g=1;g<n.length;g++){const D=n[g];r(D,n[h])>0&&(h=g)}return h}function e(n,r){for(const h of n){const g=r(h);if(g!==void 0)return g}}}),define(ge[83],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=F,t.$M=P,t.$N=W;function i(S,A){const m=Object.create(null);for(const b of S){const w=A(b);let B=m[w];B||(B=m[w]=[]),B.push(b)}return m}function F(S,A){const m=[],b=[];for(const w of S)A.has(w)||m.push(w);for(const w of A)S.has(w)||b.push(w);return{removed:m,added:b}}function P(S,A){const m=[],b=[];for(const[w,B]of S)A.has(w)||m.push(B);for(const[w,B]of A)S.has(w)||b.push(B);return{removed:m,added:b}}function W(S,A){const m=new Set;for(const b of A)S.has(b)&&m.add(b);return m}}),define(ge[84],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ct=t.$Bt=t.$At=t.$zt=void 0;function i(A,m){const b=Math.pow(10,m);return Math.round(A*b)/b}class F{constructor(m,b,w,B=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=i(Math.max(Math.min(1,B),0),3)}static equals(m,b){return m.r===b.r&&m.g===b.g&&m.b===b.b&&m.a===b.a}}t.$zt=F;class P{constructor(m,b,w,B){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.l=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(m,b){return m.h===b.h&&m.s===b.s&&m.l===b.l&&m.a===b.a}static fromRGBA(m){const b=m.r/255,w=m.g/255,B=m.b/255,c=m.a,f=Math.max(b,w,B),e=Math.min(b,w,B);let n=0,r=0;const h=(e+f)/2,g=f-e;if(g>0){switch(r=Math.min(h<=.5?g/(2*h):g/(2-2*h),1),f){case b:n=(w-B)/g+(w<B?6:0);break;case w:n=(B-b)/g+2;break;case B:n=(b-w)/g+4;break}n*=60,n=Math.round(n)}return new P(n,r,h,c)}static i(m,b,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?m+(b-m)*6*w:w<1/2?b:w<2/3?m+(b-m)*(2/3-w)*6:m}static toRGBA(m){const b=m.h/360,{s:w,l:B,a:c}=m;let f,e,n;if(w===0)f=e=n=B;else{const r=B<.5?B*(1+w):B+w-B*w,h=2*B-r;f=P.i(h,r,b+1/3),e=P.i(h,r,b),n=P.i(h,r,b-1/3)}return new F(Math.round(f*255),Math.round(e*255),Math.round(n*255),c)}}t.$At=P;class W{constructor(m,b,w,B){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.v=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(m,b){return m.h===b.h&&m.s===b.s&&m.v===b.v&&m.a===b.a}static fromRGBA(m){const b=m.r/255,w=m.g/255,B=m.b/255,c=Math.max(b,w,B),f=Math.min(b,w,B),e=c-f,n=c===0?0:e/c;let r;return e===0?r=0:c===b?r=((w-B)/e%6+6)%6:c===w?r=(B-b)/e+2:r=(b-w)/e+4,new W(Math.round(r*60),n,c,m.a)}static toRGBA(m){const{h:b,s:w,v:B,a:c}=m,f=B*w,e=f*(1-Math.abs(b/60%2-1)),n=B-f;let[r,h,g]=[0,0,0];return b<60?(r=f,h=e):b<120?(r=e,h=f):b<180?(h=f,g=e):b<240?(h=e,g=f):b<300?(r=e,g=f):b<=360&&(r=f,g=e),r=Math.round((r+n)*255),h=Math.round((h+n)*255),g=Math.round((g+n)*255),new F(r,h,g,c)}}t.$Bt=W;class S{static fromHex(m){return S.Format.CSS.parseHex(m)||S.red}static equals(m,b){return!m&&!b?!0:!m||!b?!1:m.equals(b)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof F)this.rgba=m;else if(m instanceof P)this.i=m,this.rgba=P.toRGBA(m);else if(m instanceof W)this.j=m,this.rgba=W.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&F.equals(this.rgba,m.rgba)&&P.equals(this.hsla,m.hsla)&&W.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=S.k(this.rgba.r),b=S.k(this.rgba.g),w=S.k(this.rgba.b),B=.2126*m+.7152*b+.0722*w;return i(B,4)}static k(m){const b=m/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(m){const b=this.getRelativeLuminance(),w=m.getRelativeLuminance();return b>w?(b+.05)/(w+.05):(w+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const b=this.getRelativeLuminance(),w=m.getRelativeLuminance();return b>w}isDarkerThan(m){const b=this.getRelativeLuminance(),w=m.getRelativeLuminance();return b<w}lighten(m){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:b,g:w,b:B,a:c}=this.rgba;return new S(new F(b,w,B,c*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new S(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const b=m.rgba,w=this.rgba.a,B=b.a,c=w+B*(1-w);if(c<1e-6)return S.transparent;const f=this.rgba.r*w/c+b.r*B*(1-w)/c,e=this.rgba.g*w/c+b.g*B*(1-w)/c,n=this.rgba.b*w/c+b.b*B*(1-w)/c;return new S(new F(f,e,n,c))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:b,g:w,b:B,a:c}=this.rgba;return new S(new F(m.rgba.r-c*(m.rgba.r-b),m.rgba.g-c*(m.rgba.g-w),m.rgba.b-c*(m.rgba.b-B),1))}flatten(...m){const b=m.reduceRight((w,B)=>S.o(B,w));return S.o(this,b)}static o(m,b){const w=1-m.rgba.a;return new S(new F(w*b.rgba.r+m.rgba.a*m.rgba.r,w*b.rgba.g+m.rgba.a*m.rgba.g,w*b.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=S.Format.CSS.format(this)),this.u}static getLighterColor(m,b,w){if(m.isLighterThan(b))return m;w=w||.5;const B=m.getRelativeLuminance(),c=b.getRelativeLuminance();return w=w*(c-B)/c,m.lighten(w)}static getDarkerColor(m,b,w){if(m.isDarkerThan(b))return m;w=w||.5;const B=m.getRelativeLuminance(),c=b.getRelativeLuminance();return w=w*(B-c)/B,m.darken(w)}static{this.white=new S(new F(255,255,255,1))}static{this.black=new S(new F(0,0,0,1))}static{this.red=new S(new F(255,0,0,1))}static{this.blue=new S(new F(0,0,255,1))}static{this.green=new S(new F(0,255,0,1))}static{this.cyan=new S(new F(0,255,255,1))}static{this.lightgrey=new S(new F(211,211,211,1))}static{this.transparent=new S(new F(0,0,0,0))}}t.$Ct=S,function(A){let m;(function(b){let w;(function(B){function c(l){return l.rgba.a===1?`rgb(${l.rgba.r}, ${l.rgba.g}, ${l.rgba.b})`:A.Format.CSS.formatRGBA(l)}B.formatRGB=c;function f(l){return`rgba(${l.rgba.r}, ${l.rgba.g}, ${l.rgba.b}, ${+l.rgba.a.toFixed(2)})`}B.formatRGBA=f;function e(l){return l.hsla.a===1?`hsl(${l.hsla.h}, ${(l.hsla.s*100).toFixed(2)}%, ${(l.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(l)}B.formatHSL=e;function n(l){return`hsla(${l.hsla.h}, ${(l.hsla.s*100).toFixed(2)}%, ${(l.hsla.l*100).toFixed(2)}%, ${l.hsla.a.toFixed(2)})`}B.formatHSLA=n;function r(l){const T=l.toString(16);return T.length!==2?"0"+T:T}function h(l){return`#${r(l.rgba.r)}${r(l.rgba.g)}${r(l.rgba.b)}`}B.formatHex=h;function g(l,T=!1){return T&&l.rgba.a===1?A.Format.CSS.formatHex(l):`#${r(l.rgba.r)}${r(l.rgba.g)}${r(l.rgba.b)}${r(Math.round(l.rgba.a*255))}`}B.formatHexA=g;function D(l){return l.isOpaque()?A.Format.CSS.formatHex(l):A.Format.CSS.formatRGBA(l)}B.format=D;function o(l){const T=l.length;if(T===0||l.charCodeAt(0)!==35)return null;if(T===7){const N=16*d(l.charCodeAt(1))+d(l.charCodeAt(2)),R=16*d(l.charCodeAt(3))+d(l.charCodeAt(4)),I=16*d(l.charCodeAt(5))+d(l.charCodeAt(6));return new A(new F(N,R,I,1))}if(T===9){const N=16*d(l.charCodeAt(1))+d(l.charCodeAt(2)),R=16*d(l.charCodeAt(3))+d(l.charCodeAt(4)),I=16*d(l.charCodeAt(5))+d(l.charCodeAt(6)),j=16*d(l.charCodeAt(7))+d(l.charCodeAt(8));return new A(new F(N,R,I,j/255))}if(T===4){const N=d(l.charCodeAt(1)),R=d(l.charCodeAt(2)),I=d(l.charCodeAt(3));return new A(new F(16*N+N,16*R+R,16*I+I))}if(T===5){const N=d(l.charCodeAt(1)),R=d(l.charCodeAt(2)),I=d(l.charCodeAt(3)),j=d(l.charCodeAt(4));return new A(new F(16*N+N,16*R+R,16*I+I,(16*j+j)/255))}return null}B.parseHex=o;function d(l){switch(l){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=b.CSS||(b.CSS={}))})(m=A.Format||(A.Format={}))}(S||(t.$Ct=S={}))}),define(ge[31],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rh=F,t.$Sh=P,t.$Th=W;function i(S){return(A,m,b)=>{let w=null,B=null;if(typeof b.value=="function"?(w="value",B=b.value):typeof b.get=="function"&&(w="get",B=b.get),!B)throw new Error("not supported");b[w]=S(B,m)}}function F(S,A,m){let b=null,w=null;if(typeof m.value=="function"?(b="value",w=m.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(b="get",w=m.get),!w)throw new Error("not supported");const B=`$memoize$${A}`;m[b]=function(...c){return this.hasOwnProperty(B)||Object.defineProperty(this,B,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,c)}),this[B]}}function P(S,A,m){return i((b,w)=>{const B=`$debounce$${w}`,c=`$debounce$result$${w}`;return function(...f){this[c]||(this[c]=m?m():void 0),clearTimeout(this[B]),A&&(this[c]=A(this[c],...f),f=[this[c]]),this[B]=setTimeout(()=>{b.apply(this,f),this[c]=m?m():void 0},S)}})}function W(S,A,m){return i((b,w)=>{const B=`$throttle$timer$${w}`,c=`$throttle$result$${w}`,f=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...n){if(this[c]||(this[c]=m?m():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...n)),this[e])return;const r=this[f]+S;r<=Date.now()?(this[f]=Date.now(),b.apply(this,[this[c]]),this[c]=m?m():void 0):(this[e]=!0,this[B]=setTimeout(()=>{this[e]=!1,this[f]=Date.now(),b.apply(this,[this[c]]),this[c]=m?m():void 0},r-Date.now()))}})}}),define(ge[85],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=void 0;class i{constructor(P,W,S,A){this.originalStart=P,this.originalLength=W,this.modifiedStart=S,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$kt=i}),define(ge[6],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=F,t.$Z=P,t.$1=W,t.$2=S,t.$3=A,t.$4=b,t.$6=B,t.$7=c,t.$8=f,t.$0=n;class i{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?D.isErrorNoTelemetry(l)?new D(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(T=>{T(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}t.$W=i,t.$X=new i;function F(d){t.$X.setUnexpectedErrorHandler(d)}function P(d){if(!d||typeof d!="object")return!1;const l=d;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}function W(d){b(d)||t.$X.onUnexpectedError(d)}function S(d){b(d)||t.$X.onUnexpectedExternalError(d)}function A(d){if(d instanceof Error){const{name:l,message:T}=d,N=d.stacktrace||d.stack;return{$isError:!0,name:l,message:T,stack:N,noTelemetry:D.isErrorNoTelemetry(d)}}return d}const m="Canceled";function b(d){return d instanceof w?!0:d instanceof Error&&d.name===m&&d.message===m}class w extends Error{constructor(){super(m),this.name=this.message}}t.$5=w;function B(){const d=new Error(m);return d.name=d.message,d}function c(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function f(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class e extends TypeError{constructor(l){super(l?`${l} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class r extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.$$=r;class h extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=g;class D extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof D)return l;const T=new D;return T.message=l.message,T.stack=l.stack,T}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.$bb=D;class o extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),define(ge[8],be([1,0,6,82]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=P,t.$tb=W,t.$ub=S,t.$vb=A,t.$wb=m,t.$xb=b,t.$yb=w,t.$zb=B,t.$Ab=c,t.$Bb=f,t.$Cb=e,t.$Db=n,t.$Eb=r,t.top=h,t.$Gb=g,t.$Hb=o,t.$Ib=d,t.$Jb=l,t.$Kb=T,t.$Lb=N,t.$Mb=R,t.$Nb=I,t.$Ob=j,t.$Pb=$,t.$Qb=O,t.$Rb=V,t.$Sb=M,t.$Tb=H,t.$Ub=C,t.$Vb=G,t.$Wb=Z,t.$Xb=ce,t.$Yb=re,t.$Zb=te,t.$1b=$e,t.$2b=De,t.$3b=Fe,t.$4b=He,t.$5b=he,t.$6b=_,t.$7b=J,t.$8b=Q,t.$$b=ve;function P(x,u=0){return x[x.length-(1+u)]}function W(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function S(x,u,y=(a,p)=>a===p){if(x===u)return!0;if(!x||!u||x.length!==u.length)return!1;for(let a=0,p=x.length;a<p;a++)if(!y(x[a],u[a]))return!1;return!0}function A(x,u){const y=x.length-1;u<y&&(x[u]=x[y]),x.pop()}function m(x,u,y){return b(x.length,a=>y(x[a],u))}function b(x,u){let y=0,a=x-1;for(;y<=a;){const p=(y+a)/2|0,k=u(p);if(k<0)y=p+1;else if(k>0)a=p-1;else return p}return-(y+1)}function w(x,u,y){if(x=x|0,x>=u.length)throw new TypeError("invalid index");const a=u[Math.floor(u.length*Math.random())],p=[],k=[],s=[];for(const E of u){const v=y(E,a);v<0?p.push(E):v>0?k.push(E):s.push(E)}return x<p.length?w(x,p,y):x<p.length+s.length?s[0]:w(x-(p.length+s.length),k,y)}function B(x,u){const y=[];let a;for(const p of x.slice(0).sort(u))!a||u(a[0],p)!==0?(a=[p],y.push(a)):a.push(p);return y}function*c(x,u){let y,a;for(const p of x)a!==void 0&&u(a,p)?y.push(p):(y&&(yield y),y=[p]),a=p;y&&(yield y)}function f(x,u){for(let y=0;y<=x.length;y++)u(y===0?void 0:x[y-1],y===x.length?void 0:x[y])}function e(x,u){for(let y=0;y<x.length;y++)u(y===0?void 0:x[y-1],x[y],y+1===x.length?void 0:x[y+1])}function n(x,u,y){const a=[];function p(E,v,L){if(v===0&&L.length===0)return;const z=a[a.length-1];z&&z.start+z.deleteCount===E?(z.deleteCount+=v,z.toInsert.push(...L)):a.push({start:E,deleteCount:v,toInsert:L})}let k=0,s=0;for(;;){if(k===x.length){p(k,0,u.slice(s));break}if(s===u.length){p(k,x.length-k,[]);break}const E=x[k],v=u[s],L=y(E,v);L===0?(k+=1,s+=1):L<0?(p(k,1,[]),k+=1):L>0&&(p(k,0,[v]),s+=1)}return a}function r(x,u,y){const a=n(x,u,y),p=[],k=[];for(const s of a)p.push(...x.slice(s.start,s.start+s.deleteCount)),k.push(...s.toInsert);return{removed:p,added:k}}function h(x,u,y){if(y===0)return[];const a=x.slice(0,y).sort(u);return D(x,u,a,y,x.length),a}function g(x,u,y,a,p){return y===0?Promise.resolve([]):new Promise((k,s)=>{(async()=>{const E=x.length,v=x.slice(0,y).sort(u);for(let L=y,z=Math.min(y+a,E);L<E;L=z,z=Math.min(z+a,E)){if(L>y&&await new Promise(X=>setTimeout(X)),p&&p.isCancellationRequested)throw new i.$5;D(x,u,v,L,z)}return v})().then(k,s)})}function D(x,u,y,a,p){for(const k=y.length;a<p;a++){const s=x[a];if(u(s,y[k-1])<0){y.pop();const E=(0,F.$kb)(y,v=>u(s,v)<0);y.splice(E,0,s)}}}function o(x){return x.filter(u=>!!u)}function d(x){let u=0;for(let y=0;y<x.length;y++)x[y]&&(x[u]=x[y],u+=1);x.length=u}function l(x,u,y){x.splice(y,0,x.splice(u,1)[0])}function T(x){return!Array.isArray(x)||x.length===0}function N(x){return Array.isArray(x)&&x.length>0}function R(x,u=y=>y){const y=new Set;return x.filter(a=>{const p=u(a);return y.has(p)?!1:(y.add(p),!0)})}function I(x){const u=new Set;return y=>{const a=x(y);return u.has(a)?!1:(u.add(a),!0)}}function j(x,u){return x.length>0?x[0]:u}function $(x,u){return x.length>0?x[x.length-1]:u}function O(x,u,y=(a,p)=>a===p){let a=0;for(let p=0,k=Math.min(x.length,u.length);p<k&&y(x[p],u[p]);p++)a++;return a}function V(x){return[].concat(...x)}function M(x,u){let y=typeof u=="number"?x:0;typeof u=="number"?y=x:(y=0,u=x);const a=[];if(y<=u)for(let p=y;p<u;p++)a.push(p);else for(let p=y;p>u;p--)a.push(p);return a}function H(x,u,y){return x.reduce((a,p)=>(a[u(p)]=y?y(p):p,a),Object.create(null))}function C(x,u){return x.push(u),()=>G(x,u)}function G(x,u){const y=x.indexOf(u);if(y>-1)return x.splice(y,1),u}function Z(x,u,y){const a=x.slice(0,u),p=x.slice(u);return a.concat(y,p)}function ce(x,u){let y;if(typeof u=="number"){let a=u;y=()=>{const p=Math.sin(a++)*179426549;return p-Math.floor(p)}}else y=Math.random;for(let a=x.length-1;a>0;a-=1){const p=Math.floor(y()*(a+1)),k=x[a];x[a]=x[p],x[p]=k}}function re(x,u){const y=x.indexOf(u);y>-1&&(x.splice(y,1),x.unshift(u))}function te(x,u){const y=x.indexOf(u);y>-1&&(x.splice(y,1),x.push(u))}function $e(x,u){for(const y of u)x.push(y)}function De(x,u){return Array.isArray(x)?x.map(u):u(x)}function Fe(x){return Array.isArray(x)?x:[x]}function He(x){return x[Math.floor(Math.random()*x.length)]}function he(x,u,y){const a=ae(x,u),p=x.length,k=y.length;x.length=p+k;for(let s=p-1;s>=a;s--)x[s+k]=x[s];for(let s=0;s<k;s++)x[s+a]=y[s]}function _(x,u,y,a){const p=ae(x,u);let k=x.splice(p,y);return k===void 0&&(k=[]),he(x,p,a),k}function ae(x,u){return u<0?Math.max(u+x.length,0):Math.min(u,x.length)}var le;(function(x){function u(k){return k<0}x.isLessThan=u;function y(k){return k<=0}x.isLessThanOrEqual=y;function a(k){return k>0}x.isGreaterThan=a;function p(k){return k===0}x.isNeitherLessOrGreaterThan=p,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(le||(t.CompareResult=le={}));function J(x,u){return(y,a)=>u(x(y),x(a))}function Q(...x){return(u,y)=>{for(const a of x){const p=a(u,y);if(!le.isNeitherLessOrGreaterThan(p))return p}return le.neitherLessOrGreaterThan}}const se=(x,u)=>x-u;t.$9b=se;const fe=(x,u)=>(0,t.$9b)(x?1:0,u?1:0);t.$0b=fe;function ve(x){return(u,y)=>-x(u,y)}class Ne{constructor(u){this.g=u,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(u){let y=this.c;for(;y<this.g.length&&u(this.g[y]);)y++;const a=y===this.c?null:this.g.slice(this.c,y);return this.c=y,a}takeFromEndWhile(u){let y=this.d;for(;y>=0&&u(this.g[y]);)y--;const a=y===this.d?null:this.g.slice(y+1,this.d+1);return this.d=y,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const u=this.g[this.c];return this.c++,u}removeLast(){const u=this.g[this.d];return this.d--,u}takeCount(u){const y=this.g.slice(this.c,this.c+u);return this.c+=u,y}}t.$_b=Ne;class Ae{static{this.empty=new Ae(u=>{})}constructor(u){this.iterate=u}forEach(u){this.iterate(y=>(u(y),!0))}toArray(){const u=[];return this.iterate(y=>(u.push(y),!0)),u}filter(u){return new Ae(y=>this.iterate(a=>u(a)?y(a):!0))}map(u){return new Ae(y=>this.iterate(a=>y(u(a))))}some(u){let y=!1;return this.iterate(a=>(y=u(a),!y)),y}findFirst(u){let y;return this.iterate(a=>u(a)?(y=a,!1):!0),y}findLast(u){let y;return this.iterate(a=>(u(a)&&(y=a),!0)),y}findLastMaxBy(u){let y,a=!0;return this.iterate(p=>((a||le.isGreaterThan(u(p,y)))&&(a=!1,y=p),!0)),y}}t.$ac=Ae;class Le{constructor(u){this.c=u}static createSortPermutation(u,y){const a=Array.from(u.keys()).sort((p,k)=>y(u[p],u[k]));return new Le(a)}apply(u){return u.map((y,a)=>u[this.c[a]])}inverse(){const u=this.c.slice();for(let y=0;y<this.c.length;y++)u[this.c[y]]=y;return new Le(u)}}t.$bc=Le}),define(ge[37],be([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.$cd=P,t.$dd=W,t.$ed=S,t.$fd=A,t.$gd=m;function F(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function P(b,w="Unreachable"){throw new Error(w)}function W(b){if(!b)throw new i.$cb("Assertion Failed")}function S(b){b||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function A(b){if(!b()){debugger;b(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function m(b,w){let B=0;for(;B<b.length-1;){const c=b[B],f=b[B+1];if(!w(c,f))return!1;B++}return!0}}),define(ge[38],be([1,0,8]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0,t.$7c=P,t.$8c=W,t.$9c=S,t.$0c=A;const F=(m,b)=>m===b;t.$6c=F;function P(m=t.$6c){return(b,w)=>i.$ub(b,w,m)}function W(){return(m,b)=>JSON.stringify(m)===JSON.stringify(b)}function S(){return(m,b)=>m.equals(b)}function A(m,b,w){return!m||!b?m===b:w(m,b)}}),define(ge[53],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(F,P){const W=this;let S=!1,A;return function(){if(S)return A;if(S=!0,P)try{A=F.apply(W,arguments)}finally{P()}else A=F.apply(W,arguments);return A}}}),define(ge[86],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1O=t.$ZO=void 0;class i{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}t.$ZO=i,t.$1O=new i("id#")}),define(ge[32],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(F){function P(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}F.is=P;const W=Object.freeze([]);function S(){return W}F.empty=S;function*A(l){yield l}F.single=A;function m(l){return P(l)?l:A(l)}F.wrap=m;function b(l){return l||W}F.from=b;function*w(l){for(let T=l.length-1;T>=0;T--)yield l[T]}F.reverse=w;function B(l){return!l||l[Symbol.iterator]().next().done===!0}F.isEmpty=B;function c(l){return l[Symbol.iterator]().next().value}F.first=c;function f(l,T){for(const N of l)if(T(N))return!0;return!1}F.some=f;function e(l,T){for(const N of l)if(T(N))return N}F.find=e;function*n(l,T){for(const N of l)T(N)&&(yield N)}F.filter=n;function*r(l,T){let N=0;for(const R of l)yield T(R,N++)}F.map=r;function*h(...l){for(const T of l)yield*T}F.concat=h;function g(l,T,N){let R=N;for(const I of l)R=T(R,I);return R}F.reduce=g;function*D(l,T,N=l.length){for(T<0&&(T+=l.length),N<0?N+=l.length:N>l.length&&(N=l.length);T<N;T++)yield l[T]}F.slice=D;function o(l,T=Number.POSITIVE_INFINITY){const N=[];if(T===0)return[N,l];const R=l[Symbol.iterator]();for(let I=0;I<T;I++){const j=R.next();if(j.done)return[N,F.empty()];N.push(j.value)}return[N,{[Symbol.iterator](){return R}}]}F.consume=o;async function d(l){const T=[];for await(const N of l)T.push(N);return Promise.resolve(T)}F.asyncToArray=d})(i||(t.Iterable=i={}))}),define(ge[54],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$sr=t.$rr=t.$qr=t.$pr=t.$or=t.ScanCode=t.KeyCode=void 0,t.$tr=f;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,r){this._keyCodeToStr[n]=r,this._strToKeyCode[r.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const W=new P,S=new P,A=new P;t.$or=new Array(230),t.$pr={};const m=[],b=Object.create(null),w=Object.create(null);t.$qr={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>b[e]||0,toString:e=>m[e]||"None"},t.$rr=[],t.$sr=[];for(let e=0;e<=193;e++)t.$rr[e]=-1;for(let e=0;e<=132;e++)t.$sr[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const g of n){const[D,o,d,l,T,N,R,I,j]=g;if(h[o]||(h[o]=!0,m[o]=d,b[d]=o,w[d.toLowerCase()]=o,D&&(t.$rr[o]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(t.$sr[l]=o))),!r[l]){if(r[l]=!0,!T)throw new Error(`String representation missing for key code ${l} around scan code ${d}`);W.define(l,T),S.define(l,I||T),A.define(l,j||I||T)}N&&(t.$or[N]=l),R&&(t.$pr[R]=l)}t.$sr[3]=46})();var B;(function(e){function n(d){return W.keyCodeToStr(d)}e.toString=n;function r(d){return W.strToKeyCode(d)}e.fromString=r;function h(d){return S.keyCodeToStr(d)}e.toUserSettingsUS=h;function g(d){return A.keyCodeToStr(d)}e.toUserSettingsGeneral=g;function D(d){return S.strToKeyCode(d)||A.strToKeyCode(d)}e.fromUserSettings=D;function o(d){if(d>=98&&d<=113)return null;switch(d){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(d)}e.toElectronAccelerator=o})(B||(t.KeyCodeUtils=B={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function f(e,n){const r=(n&65535)<<16>>>0;return(e|r)>>>0}}),define(ge[87],be([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ar=t.$zr=t.$yr=t.$xr=t.$wr=void 0,t.$ur=P,t.$vr=W;var F;(function(B){B[B.CtrlCmd=2048]="CtrlCmd",B[B.Shift=1024]="Shift",B[B.Alt=512]="Alt",B[B.WinCtrl=256]="WinCtrl",B[B.KeyCode=255]="KeyCode"})(F||(F={}));function P(B,c){if(typeof B=="number"){if(B===0)return null;const f=(B&65535)>>>0,e=(B&4294901760)>>>16;return e!==0?new m([W(f,c),W(e,c)]):new m([W(f,c)])}else{const f=[];for(let e=0;e<B.length;e++)f.push(W(B[e],c));return new m(f)}}function W(B,c){const f=!!(B&2048),e=!!(B&256),n=c===2?e:f,r=!!(B&1024),h=!!(B&512),g=c===2?f:e,D=B&255;return new S(n,r,h,g,D)}class S{constructor(c,f,e,n,r){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyCode=r}equals(c){return c instanceof S&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${c}${f}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$wr=S;class A{constructor(c,f,e,n,r){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.scanCode=r}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${c}${f}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$xr=A;class m{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let f=0,e=this.chords.length;f<e;f++)f!==0&&(c+=";"),c+=this.chords[f].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let f=0;f<this.chords.length;f++)if(!this.chords[f].equals(c.chords[f]))return!1;return!0}}t.$yr=m;class b{constructor(c,f,e,n,r,h){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyLabel=r,this.keyAriaLabel=h}}t.$zr=b;class w{}t.$Ar=w}),define(ge[23],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(ge[14],be([1,0,23]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cT=A,t.$dT=m,t.$eT=b;let P=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const W=new i.$V(()=>P("mouse",!1)),S=new i.$V(()=>P("element",!1));function A(w){P=w}function m(w){return w==="element"?S.value:W.value}function b(){return P("element",!0)}}),define(ge[55],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(W){this.element=W,this.next=i.Undefined,this.prev=i.Undefined}}class F{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let W=this.a;for(;W!==i.Undefined;){const S=W.next;W.prev=i.Undefined,W.next=i.Undefined,W=S}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,S){const A=new i(W);if(this.a===i.Undefined)this.a=A,this.b=A;else if(S){const b=this.b;this.b=A,A.prev=b,b.next=A}else{const b=this.a;this.a=A,A.next=b,b.prev=A}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(A))}}shift(){if(this.a!==i.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==i.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==i.Undefined&&W.next!==i.Undefined){const S=W.prev;S.next=W.next,W.next.prev=S}else W.prev===i.Undefined&&W.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):W.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):W.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==i.Undefined;)yield W.element,W=W.next}}t.$5c=F}),define(ge[39],be([1,0]),function(ne,t){"use strict";var i,F,P;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=W,t.$zc=S,t.$Ac=A,t.$Ic=g;function W(D,o,d){let l=D.get(o);return l===void 0&&(l=d,D.set(o,l)),l}function S(D){const o=[];return D.forEach((d,l)=>{o.push(`${l} => ${d}`)}),`Map(${D.size}) {${o.join(", ")}}`}function A(D){const o=[];return D.forEach(d=>{o.push(d)}),`Set(${D.size}) {${o.join(", ")}}`}class m{constructor(o,d){this.uri=o,this.value=d}}function b(D){return Array.isArray(D)}class w{static{this.c=o=>o.toString()}constructor(o,d){if(this[i]="ResourceMap",o instanceof w)this.d=new Map(o.d),this.e=d??w.c;else if(b(o)){this.d=new Map,this.e=d??w.c;for(const[l,T]of o)this.set(l,T)}else this.d=new Map,this.e=o??w.c}set(o,d){return this.d.set(this.e(o),new m(o,d)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,d){typeof d<"u"&&(o=o.bind(d));for(const[l,T]of this.d)o(T.value,T.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Bc=w;class B{constructor(o,d){this[F]="ResourceSet",!o||typeof o=="function"?this.c=new w(o):(this.c=new w(d),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,d){this.c.forEach((l,T)=>o.call(d,T,T,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=B;var c;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class f{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,d=0){const l=this.c.get(o);if(l)return d!==0&&this.l(l,d),l.value}set(o,d,l=0){let T=this.c.get(o);if(T)T.value=d,l!==0&&this.l(T,l);else{switch(T={key:o,value:d,next:void 0,previous:void 0},l){case 0:this.j(T);break;case 1:this.i(T);break;case 2:this.j(T);break;default:this.j(T);break}this.c.set(o,T),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const d=this.c.get(o);if(d)return this.c.delete(o),this.k(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,d){const l=this.g;let T=this.d;for(;T;){if(d?o.bind(d)(T.value,T.key,this):o(T.value,T.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");T=T.next}}keys(){const o=this,d=this.g;let l=this.d;const T={[Symbol.iterator](){return T},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const N={value:l.key,done:!1};return l=l.next,N}else return{value:void 0,done:!0}}};return T}values(){const o=this,d=this.g;let l=this.d;const T={[Symbol.iterator](){return T},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const N={value:l.value,done:!1};return l=l.next,N}else return{value:void 0,done:!0}}};return T}entries(){const o=this,d=this.g;let l=this.d;const T={[Symbol.iterator](){return T},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const N={value:[l.key,l.value],done:!1};return l=l.next,N}else return{value:void 0,done:!0}}};return T}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let d=this.d,l=this.size;for(;d&&l>o;)this.c.delete(d.key),d=d.next,l--;this.d=d,this.f=l,d&&(d.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const d=o.next,l=o.previous;if(!d||!l)throw new Error("Invalid list");d.previous=l,l.next=d}o.next=void 0,o.previous=void 0,this.g++}l(o,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(o===this.d)return;const l=o.next,T=o.previous;o===this.e?(T.next=void 0,this.e=T):(l.previous=T,T.next=l),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(d===2){if(o===this.e)return;const l=o.next,T=o.previous;o===this.d?(l.previous=void 0,this.d=l):(l.previous=T,T.next=l),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((d,l)=>{o.push([l,d])}),o}fromJSON(o){this.clear();for(const[d,l]of o)this.set(d,l)}}t.$Dc=f;class e extends f{constructor(o,d=1){super(),this.m=o,this.n=Math.min(Math.max(0,d),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,d=2){return super.get(o,d)}peek(o){return super.get(o,0)}set(o,d){return super.set(o,d,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class n{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let d=this.c.get(o)||0;return d===0?!1:(d--,d===0?this.c.delete(o):this.c.set(o,d),!0)}has(o){return this.c.has(o)}}t.$Fc=n;class r{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[d,l]of o)this.set(d,l)}clear(){this.c.clear(),this.d.clear()}set(o,d){this.c.set(o,d),this.d.set(d,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const d=this.c.get(o);return d===void 0?!1:(this.c.delete(o),this.d.delete(d),!0)}forEach(o,d){this.c.forEach((l,T)=>{o.call(d,l,T,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=r;class h{constructor(){this.c=new Map}add(o,d){let l=this.c.get(o);l||(l=new Set,this.c.set(o,l)),l.add(d)}delete(o,d){const l=this.c.get(o);l&&(l.delete(d),l.size===0&&this.c.delete(o))}forEach(o,d){const l=this.c.get(o);l&&l.forEach(d)}get(o){const d=this.c.get(o);return d||new Set}}t.$Hc=h;function g(D,o){if(D===o)return!0;if(D.size!==o.size)return!1;for(const[d,l]of D)if(!o.has(d)||o.get(d)!==l)return!1;for(const[d]of o)if(!D.has(d))return!1;return!0}}),define(ge[2],be([1,0,8,83,39,53,32]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=w,t.$Lc=B,t.$Mc=c,t.$Nc=n,t.$Oc=r,t.$Pc=h,t.$Qc=g,t.$Rc=D,t.$Sc=o,t.$3c=V;const A=!1;let m=null;class b{constructor(){this.b=new Map}static{this.a=0}c(C){let G=this.b.get(C);return G||(G={parent:null,source:null,isSingleton:!1,value:C,idx:b.a++},this.b.set(C,G)),G}trackDisposable(C){const G=this.c(C);G.source||(G.source=new Error().stack)}setParent(C,G){const Z=this.c(C);Z.parent=G}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,G){const Z=G.get(C);if(Z)return Z;const ce=C.parent?this.f(this.c(C.parent),G):C;return G.set(C,ce),ce}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,C).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(C=10,G){let Z;if(G)Z=G;else{const De=new Map,Fe=[...this.b.values()].filter(he=>he.source!==null&&!this.f(he,De).isSingleton);if(Fe.length===0)return;const He=new Set(Fe.map(he=>he.value));if(Z=Fe.filter(he=>!(he.parent&&He.has(he.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function ce(De){function Fe(he,_){for(;he.length>0&&_.some(ae=>typeof ae=="string"?ae===he[0]:he[0].match(ae));)he.shift()}const He=De.source.split(`
`).map(he=>he.trim().replace("at ","")).filter(he=>he!=="");return Fe(He,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),He.reverse()}const re=new P.$Hc;for(const De of Z){const Fe=ce(De);for(let He=0;He<=Fe.length;He++)re.add(Fe.slice(0,He).join(`
`),De)}Z.sort((0,i.$7b)(De=>De.idx,i.$9b));let te="",$e=0;for(const De of Z.slice(0,C)){$e++;const Fe=ce(De),He=[];for(let he=0;he<Fe.length;he++){let _=Fe[he];_=`(shared with ${re.get(Fe.slice(0,he+1).join(`
`)).size}/${Z.length} leaks) at ${_}`;const le=re.get(Fe.slice(0,he).join(`
`)),J=(0,F.$K)([...le].map(Q=>ce(Q)[he]),Q=>Q);delete J[Fe[he]];for(const[Q,se]of Object.entries(J))He.unshift(`    - stacktraces of ${se.length} other leaks continue with ${Q}`);He.unshift(_)}te+=`


==================== Leaking disposable ${$e}/${Z.length}: ${De.value.constructor.name} ====================
${He.join(`
`)}
============================================================

`}return Z.length>C&&(te+=`


... and ${Z.length-C} more leaking disposables

`),{leaks:Z,details:te}}}t.$Jc=b;function w(H){m=H}if(A){const H="__is_disposable_tracked__";w(new class{trackDisposable(C){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[H]||console.log(G)},3e3)}setParent(C,G){if(C&&C!==l.None)try{C[H]=!0}catch{}}markAsDisposed(C){if(C&&C!==l.None)try{C[H]=!0}catch{}}markAsSingleton(C){}})}function B(H){return m?.trackDisposable(H),H}function c(H){m?.markAsDisposed(H)}function f(H,C){m?.setParent(H,C)}function e(H,C){if(m)for(const G of H)m.setParent(G,C)}function n(H){return m?.markAsSingleton(H),H}function r(H){return typeof H=="object"&&H!==null&&typeof H.dispose=="function"&&H.dispose.length===0}function h(H){if(S.Iterable.is(H)){const C=[];for(const G of H)if(G)try{G.dispose()}catch(Z){C.push(Z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(H)?[]:H}else if(H)return H.dispose(),H}function g(H){for(const C of H)r(C)&&C.dispose();return[]}function D(...H){const C=o(()=>h(H));return e(H,C),C}function o(H){const C=B({dispose:(0,W.$db)(()=>{c(C),H()})});return C}class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,B(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return f(C,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),f(C,null))}}t.$Tc=d;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,B(this),f(this.q,this)}dispose(){c(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}t.$Uc=l;class T{constructor(){this.b=!1,B(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&f(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&f(C,null),C}}t.$Vc=T;class N{constructor(C){this.a=new T,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=N;class R{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=R;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(C){let G=C;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,c(this))},this}}t.$Yc=I;class j{constructor(){this.a=new Map}acquire(C,...G){let Z=this.a.get(C);Z||(Z={counter:0,object:this.b(C,...G)},this.a.set(C,Z));const{object:ce}=Z,re=(0,W.$db)(()=>{--Z.counter===0&&(this.c(C,Z.object),this.a.delete(C))});return Z.counter++,{object:ce,dispose:re}}}t.$Zc=j;class ${constructor(C){this.a=C}async acquire(C,...G){const Z=this.a.acquire(C,...G);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(ce){throw Z.dispose(),ce}}}t.$1c=$;class O{constructor(C){this.object=C}dispose(){}}t.$2c=O;function V(H){const C=new d;try{H(C)}finally{C.dispose()}}class M{constructor(){this.a=new Map,this.b=!1,B(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,G,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(C)?.dispose(),this.a.set(C,G)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=M}),function(ne,t){typeof define=="function"&&define.amd?define(ge[88],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(x,u){for(var y=0;y<u.length;y++){var a=u[y];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(x,a.key,a)}}function i(x,u,y){return u&&t(x.prototype,u),y&&t(x,y),Object.defineProperty(x,"prototype",{writable:!1}),x}function F(x,u){if(x){if(typeof x=="string")return P(x,u);var y=Object.prototype.toString.call(x).slice(8,-1);if(y==="Object"&&x.constructor&&(y=x.constructor.name),y==="Map"||y==="Set")return Array.from(x);if(y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y))return P(x,u)}}function P(x,u){(u==null||u>x.length)&&(u=x.length);for(var y=0,a=new Array(u);y<u;y++)a[y]=x[y];return a}function W(x,u){var y=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if(y)return(y=y.call(x)).next.bind(y);if(Array.isArray(x)||(y=F(x))||u&&x&&typeof x.length=="number"){y&&(x=y);var a=0;return function(){return a>=x.length?{done:!0}:{done:!1,value:x[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=S();function A(x){ne.defaults=x}var m=/[&<>"']/,b=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,B=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(u){return c[u]};function e(x,u){if(u){if(m.test(x))return x.replace(b,f)}else if(w.test(x))return x.replace(B,f);return x}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(x){return x.replace(n,function(u,y){return y=y.toLowerCase(),y==="colon"?":":y.charAt(0)==="#"?y.charAt(1)==="x"?String.fromCharCode(parseInt(y.substring(2),16)):String.fromCharCode(+y.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(x,u){x=typeof x=="string"?x:x.source,u=u||"";var y={replace:function(p,k){return k=k.source||k,k=k.replace(h,"$1"),x=x.replace(p,k),y},getRegex:function(){return new RegExp(x,u)}};return y}var D=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(x,u,y){if(x){var a;try{a=decodeURIComponent(r(y)).replace(D,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}u&&!o.test(y)&&(y=I(u,y));try{y=encodeURI(y).replace(/%25/g,"%")}catch{return null}return y}var l={},T=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function I(x,u){l[" "+x]||(T.test(x)?l[" "+x]=x+"/":l[" "+x]=V(x,"/",!0)),x=l[" "+x];var y=x.indexOf(":")===-1;return u.substring(0,2)==="//"?y?u:x.replace(N,"$1")+u:u.charAt(0)==="/"?y?u:x.replace(R,"$1")+u:x+u}var j={exec:function(){}};function $(x){for(var u=1,y,a;u<arguments.length;u++){y=arguments[u];for(a in y)Object.prototype.hasOwnProperty.call(y,a)&&(x[a]=y[a])}return x}function O(x,u){var y=x.replace(/\|/g,function(k,s,E){for(var v=!1,L=s;--L>=0&&E[L]==="\\";)v=!v;return v?"|":" |"}),a=y.split(/ \|/),p=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>u)a.splice(u);else for(;a.length<u;)a.push("");for(;p<a.length;p++)a[p]=a[p].trim().replace(/\\\|/g,"|");return a}function V(x,u,y){var a=x.length;if(a===0)return"";for(var p=0;p<a;){var k=x.charAt(a-p-1);if(k===u&&!y)p++;else if(k!==u&&y)p++;else break}return x.slice(0,a-p)}function M(x,u){if(x.indexOf(u[1])===-1)return-1;for(var y=x.length,a=0,p=0;p<y;p++)if(x[p]==="\\")p++;else if(x[p]===u[0])a++;else if(x[p]===u[1]&&(a--,a<0))return p;return-1}function H(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(x,u){if(u<1)return"";for(var y="";u>1;)u&1&&(y+=x),u>>=1,x+=x;return y+x}function G(x,u,y,a){var p=u.href,k=u.title?e(u.title):null,s=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){a.state.inLink=!0;var E={type:"link",raw:y,href:p,title:k,text:s,tokens:a.inlineTokens(s)};return a.state.inLink=!1,E}return{type:"image",raw:y,href:p,title:k,text:e(s)}}function Z(x,u){var y=x.match(/^(\s+)(?:```)/);if(y===null)return u;var a=y[1];return u.split(`
`).map(function(p){var k=p.match(/^\s+/);if(k===null)return p;var s=k[0];return s.length>=a.length?p.slice(a.length):p}).join(`
`)}var ce=function(){function x(y){this.options=y||ne.defaults}var u=x.prototype;return u.space=function(a){var p=this.rules.block.newline.exec(a);if(p&&p[0].length>0)return{type:"space",raw:p[0]}},u.code=function(a){var p=this.rules.block.code.exec(a);if(p){var k=p[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:p[0],codeBlockStyle:"indented",text:this.options.pedantic?k:V(k,`
`)}}},u.fences=function(a){var p=this.rules.block.fences.exec(a);if(p){var k=p[0],s=Z(k,p[3]||"");return{type:"code",raw:k,lang:p[2]?p[2].trim():p[2],text:s}}},u.heading=function(a){var p=this.rules.block.heading.exec(a);if(p){var k=p[2].trim();if(/#$/.test(k)){var s=V(k,"#");(this.options.pedantic||!s||/ $/.test(s))&&(k=s.trim())}return{type:"heading",raw:p[0],depth:p[1].length,text:k,tokens:this.lexer.inline(k)}}},u.hr=function(a){var p=this.rules.block.hr.exec(a);if(p)return{type:"hr",raw:p[0]}},u.blockquote=function(a){var p=this.rules.block.blockquote.exec(a);if(p){var k=p[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:p[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},u.list=function(a){var p=this.rules.block.list.exec(a);if(p){var k,s,E,v,L,z,X,U,oe,we,me,Ie,ke=p[1].trim(),je=ke.length>1,Ee={type:"list",raw:"",ordered:je,start:je?+ke.slice(0,-1):"",loose:!1,items:[]};ke=je?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=je?ke:"[*+-]");for(var Te=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(Ie=!1,!(!(p=Te.exec(a))||this.rules.block.hr.test(a)));){if(k=p[0],a=a.substring(k.length),U=p[2].split(`
`,1)[0],oe=a.split(`
`,1)[0],this.options.pedantic?(v=2,me=U.trimLeft()):(v=p[2].search(/[^ ]/),v=v>4?1:v,me=U.slice(v),v+=p[1].length),z=!1,!U&&/^ *$/.test(oe)&&(k+=oe+`
`,a=a.substring(oe.length+1),Ie=!0),!Ie)for(var We=new RegExp("^ {0,"+Math.min(3,v-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,v-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,v-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,v-1)+"}#");a&&(we=a.split(`
`,1)[0],U=we,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(U)||_e.test(U)||We.test(U)||Ue.test(a)));){if(U.search(/[^ ]/)>=v||!U.trim())me+=`
`+U.slice(v);else if(!z)me+=`
`+U;else break;!z&&!U.trim()&&(z=!0),k+=we+`
`,a=a.substring(we.length+1)}Ee.loose||(X?Ee.loose=!0:/\n *\n *$/.test(k)&&(X=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(me),s&&(E=s[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),Ee.items.push({type:"list_item",raw:k,task:!!s,checked:E,loose:!1,text:me}),Ee.raw+=k}Ee.items[Ee.items.length-1].raw=k.trimRight(),Ee.items[Ee.items.length-1].text=me.trimRight(),Ee.raw=Ee.raw.trimRight();var Y=Ee.items.length;for(L=0;L<Y;L++){this.lexer.state.top=!1,Ee.items[L].tokens=this.lexer.blockTokens(Ee.items[L].text,[]);var ie=Ee.items[L].tokens.filter(function(ye){return ye.type==="space"}),pe=ie.every(function(ye){for(var Re=ye.raw.split(""),xe=0,Ve=W(Re),et;!(et=Ve()).done;){var it=et.value;if(it===`
`&&(xe+=1),xe>1)return!0}return!1});!Ee.loose&&ie.length&&pe&&(Ee.loose=!0,Ee.items[L].loose=!0)}return Ee}},u.html=function(a){var p=this.rules.block.html.exec(a);if(p){var k={type:"html",raw:p[0],pre:!this.options.sanitizer&&(p[1]==="pre"||p[1]==="script"||p[1]==="style"),text:p[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(p[0]):e(p[0]);k.type="paragraph",k.text=s,k.tokens=this.lexer.inline(s)}return k}},u.def=function(a){var p=this.rules.block.def.exec(a);if(p){p[3]&&(p[3]=p[3].substring(1,p[3].length-1));var k=p[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:p[0],href:p[2],title:p[3]}}},u.table=function(a){var p=this.rules.block.table.exec(a);if(p){var k={type:"table",header:O(p[1]).map(function(X){return{text:X}}),align:p[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:p[3]&&p[3].trim()?p[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=p[0];var s=k.align.length,E,v,L,z;for(E=0;E<s;E++)/^ *-+: *$/.test(k.align[E])?k.align[E]="right":/^ *:-+: *$/.test(k.align[E])?k.align[E]="center":/^ *:-+ *$/.test(k.align[E])?k.align[E]="left":k.align[E]=null;for(s=k.rows.length,E=0;E<s;E++)k.rows[E]=O(k.rows[E],k.header.length).map(function(X){return{text:X}});for(s=k.header.length,v=0;v<s;v++)k.header[v].tokens=this.lexer.inline(k.header[v].text);for(s=k.rows.length,v=0;v<s;v++)for(z=k.rows[v],L=0;L<z.length;L++)z[L].tokens=this.lexer.inline(z[L].text);return k}}},u.lheading=function(a){var p=this.rules.block.lheading.exec(a);if(p)return{type:"heading",raw:p[0],depth:p[2].charAt(0)==="="?1:2,text:p[1],tokens:this.lexer.inline(p[1])}},u.paragraph=function(a){var p=this.rules.block.paragraph.exec(a);if(p){var k=p[1].charAt(p[1].length-1)===`
`?p[1].slice(0,-1):p[1];return{type:"paragraph",raw:p[0],text:k,tokens:this.lexer.inline(k)}}},u.text=function(a){var p=this.rules.block.text.exec(a);if(p)return{type:"text",raw:p[0],text:p[0],tokens:this.lexer.inline(p[0])}},u.escape=function(a){var p=this.rules.inline.escape.exec(a);if(p)return{type:"escape",raw:p[0],text:e(p[1])}},u.tag=function(a){var p=this.rules.inline.tag.exec(a);if(p)return!this.lexer.state.inLink&&/^<a /i.test(p[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(p[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(p[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(p[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:p[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(p[0]):e(p[0]):p[0]}},u.link=function(a){var p=this.rules.inline.link.exec(a);if(p){var k=p[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var s=V(k.slice(0,-1),"\\");if((k.length-s.length)%2===0)return}else{var E=M(p[2],"()");if(E>-1){var v=p[0].indexOf("!")===0?5:4,L=v+p[1].length+E;p[2]=p[2].substring(0,E),p[0]=p[0].substring(0,L).trim(),p[3]=""}}var z=p[2],X="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);U&&(z=U[1],X=U[3])}else X=p[3]?p[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(k)?z=z.slice(1):z=z.slice(1,-1)),G(p,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},p[0],this.lexer)}},u.reflink=function(a,p){var k;if((k=this.rules.inline.reflink.exec(a))||(k=this.rules.inline.nolink.exec(a))){var s=(k[2]||k[1]).replace(/\s+/g," ");if(s=p[s.toLowerCase()],!s||!s.href){var E=k[0].charAt(0);return{type:"text",raw:E,text:E}}return G(k,s,k[0],this.lexer)}},u.emStrong=function(a,p,k){k===void 0&&(k="");var s=this.rules.inline.emStrong.lDelim.exec(a);if(s&&!(s[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var E=s[1]||s[2]||"";if(!E||E&&(k===""||this.rules.inline.punctuation.exec(k))){var v=s[0].length-1,L,z,X=v,U=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,p=p.slice(-1*a.length+v);(s=oe.exec(p))!=null;)if(L=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!L){if(z=L.length,s[3]||s[4]){X+=z;continue}else if((s[5]||s[6])&&v%3&&!((v+z)%3)){U+=z;continue}if(X-=z,!(X>0)){if(z=Math.min(z,z+X+U),Math.min(v,z)%2){var we=a.slice(1,v+s.index+z);return{type:"em",raw:a.slice(0,v+s.index+z+1),text:we,tokens:this.lexer.inlineTokens(we)}}var me=a.slice(2,v+s.index+z-1);return{type:"strong",raw:a.slice(0,v+s.index+z+1),text:me,tokens:this.lexer.inlineTokens(me)}}}}}},u.codespan=function(a){var p=this.rules.inline.code.exec(a);if(p){var k=p[2].replace(/\n/g," "),s=/[^ ]/.test(k),E=/^ /.test(k)&&/ $/.test(k);return s&&E&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:p[0],text:k}}},u.br=function(a){var p=this.rules.inline.br.exec(a);if(p)return{type:"br",raw:p[0]}},u.del=function(a){var p=this.rules.inline.del.exec(a);if(p)return{type:"del",raw:p[0],text:p[2],tokens:this.lexer.inlineTokens(p[2])}},u.autolink=function(a,p){var k=this.rules.inline.autolink.exec(a);if(k){var s,E;return k[2]==="@"?(s=e(this.options.mangle?p(k[1]):k[1]),E="mailto:"+s):(s=e(k[1]),E=s),{type:"link",raw:k[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},u.url=function(a,p){var k;if(k=this.rules.inline.url.exec(a)){var s,E;if(k[2]==="@")s=e(this.options.mangle?p(k[0]):k[0]),E="mailto:"+s;else{var v;do v=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(v!==k[0]);s=e(k[0]),k[1]==="www."?E="http://"+s:E=s}return{type:"link",raw:k[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},u.inlineText=function(a,p){var k=this.rules.inline.text.exec(a);if(k){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:s=e(this.options.smartypants?p(k[0]):k[0]),{type:"text",raw:k[0],text:s}}},x}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=g(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=g(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=g(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=g(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=g(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=$({},re),re.gfm=$({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=g(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=$({},re.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:g(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=g(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=g(re._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=g(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=g(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=g(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=g(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=g(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=g(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=g(te.reflink).replace("label",te._label).replace("ref",re._label).getRegex(),te.nolink=g(te.nolink).replace("ref",re._label).getRegex(),te.reflinkSearch=g(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=$({},te),te.pedantic=$({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=$({},te.normal,{escape:g(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=g(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=$({},te.gfm,{br:g(te.br).replace("{2,}","*").getRegex(),text:g(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $e(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function De(x){var u="",y,a,p=x.length;for(y=0;y<p;y++)a=x.charCodeAt(y),Math.random()>.5&&(a="x"+a.toString(16)),u+="&#"+a+";";return u}var Fe=function(){function x(y){this.tokens=[],this.tokens.links=Object.create(null),this.options=y||ne.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:re.normal,inline:te.normal};this.options.pedantic?(a.block=re.pedantic,a.inline=te.pedantic):this.options.gfm&&(a.block=re.gfm,this.options.breaks?a.inline=te.breaks:a.inline=te.gfm),this.tokenizer.rules=a}x.lex=function(a,p){var k=new x(p);return k.lex(a)},x.lexInline=function(a,p){var k=new x(p);return k.inlineTokens(a)};var u=x.prototype;return u.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var p;p=this.inlineQueue.shift();)this.inlineTokens(p.src,p.tokens);return this.tokens},u.blockTokens=function(a,p){var k=this;p===void 0&&(p=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(X,U,oe){return U+"    ".repeat(oe.length)});for(var s,E,v,L;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(s=X.call({lexer:k},a,p))?(a=a.substring(s.raw.length),p.push(s),!0):!1}))){if(s=this.tokenizer.space(a)){a=a.substring(s.raw.length),s.raw.length===1&&p.length>0?p[p.length-1].raw+=`
`:p.push(s);continue}if(s=this.tokenizer.code(a)){a=a.substring(s.raw.length),E=p[p.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=E.text):p.push(s);continue}if(s=this.tokenizer.fences(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.heading(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.hr(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.blockquote(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.list(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.html(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.def(a)){a=a.substring(s.raw.length),E=p[p.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=E.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.lheading(a)){a=a.substring(s.raw.length),p.push(s);continue}if(v=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,U=a.slice(1),oe=void 0;k.options.extensions.startBlock.forEach(function(we){oe=we.call({lexer:this},U),typeof oe=="number"&&oe>=0&&(X=Math.min(X,oe))}),X<1/0&&X>=0&&(v=a.substring(0,X+1))}(),this.state.top&&(s=this.tokenizer.paragraph(v))){E=p[p.length-1],L&&E.type==="paragraph"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):p.push(s),L=v.length!==a.length,a=a.substring(s.raw.length);continue}if(s=this.tokenizer.text(a)){a=a.substring(s.raw.length),E=p[p.length-1],E&&E.type==="text"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):p.push(s);continue}if(a){var z="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,p},u.inline=function(a,p){return p===void 0&&(p=[]),this.inlineQueue.push({src:a,tokens:p}),p},u.inlineTokens=function(a,p){var k=this;p===void 0&&(p=[]);var s,E,v,L=a,z,X,U;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)oe.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,z.index)+"["+C("a",z[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,z.index)+"["+C("a",z[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,z.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(X||(U=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(me){return(s=me.call({lexer:k},a,p))?(a=a.substring(s.raw.length),p.push(s),!0):!1}))){if(s=this.tokenizer.escape(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.tag(a)){a=a.substring(s.raw.length),E=p[p.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):p.push(s);continue}if(s=this.tokenizer.link(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(s.raw.length),E=p[p.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):p.push(s);continue}if(s=this.tokenizer.emStrong(a,L,U)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.codespan(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.br(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.del(a)){a=a.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.autolink(a,De)){a=a.substring(s.raw.length),p.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(a,De))){a=a.substring(s.raw.length),p.push(s);continue}if(v=a,this.options.extensions&&this.options.extensions.startInline&&function(){var me=1/0,Ie=a.slice(1),ke=void 0;k.options.extensions.startInline.forEach(function(je){ke=je.call({lexer:this},Ie),typeof ke=="number"&&ke>=0&&(me=Math.min(me,ke))}),me<1/0&&me>=0&&(v=a.substring(0,me+1))}(),s=this.tokenizer.inlineText(v,$e)){a=a.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(U=s.raw.slice(-1)),X=!0,E=p[p.length-1],E&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):p.push(s);continue}if(a){var we="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return p},i(x,null,[{key:"rules",get:function(){return{block:re,inline:te}}}]),x}(),He=function(){function x(y){this.options=y||ne.defaults}var u=x.prototype;return u.code=function(a,p,k){var s=(p||"").match(/\S*/)[0];if(this.options.highlight){var E=this.options.highlight(a,s);E!=null&&E!==a&&(k=!0,a=E)}return a=a.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(k?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(k?a:e(a,!0))+`</code></pre>
`},u.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},u.html=function(a){return a},u.heading=function(a,p,k,s){if(this.options.headerIds){var E=this.options.headerPrefix+s.slug(k);return"<h"+p+' id="'+E+'">'+a+"</h"+p+`>
`}return"<h"+p+">"+a+"</h"+p+`>
`},u.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},u.list=function(a,p,k){var s=p?"ol":"ul",E=p&&k!==1?' start="'+k+'"':"";return"<"+s+E+`>
`+a+"</"+s+`>
`},u.listitem=function(a){return"<li>"+a+`</li>
`},u.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},u.paragraph=function(a){return"<p>"+a+`</p>
`},u.table=function(a,p){return p&&(p="<tbody>"+p+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+p+`</table>
`},u.tablerow=function(a){return`<tr>
`+a+`</tr>
`},u.tablecell=function(a,p){var k=p.header?"th":"td",s=p.align?"<"+k+' align="'+p.align+'">':"<"+k+">";return s+a+("</"+k+`>
`)},u.strong=function(a){return"<strong>"+a+"</strong>"},u.em=function(a){return"<em>"+a+"</em>"},u.codespan=function(a){return"<code>"+a+"</code>"},u.br=function(){return this.options.xhtml?"<br/>":"<br>"},u.del=function(a){return"<del>"+a+"</del>"},u.link=function(a,p,k){if(a=d(this.options.sanitize,this.options.baseUrl,a),a===null)return k;var s='<a href="'+e(a)+'"';return p&&(s+=' title="'+p+'"'),s+=">"+k+"</a>",s},u.image=function(a,p,k){if(a=d(this.options.sanitize,this.options.baseUrl,a),a===null)return k;var s='<img src="'+a+'" alt="'+k+'"';return p&&(s+=' title="'+p+'"'),s+=this.options.xhtml?"/>":">",s},u.text=function(a){return a},x}(),he=function(){function x(){}var u=x.prototype;return u.strong=function(a){return a},u.em=function(a){return a},u.codespan=function(a){return a},u.del=function(a){return a},u.html=function(a){return a},u.text=function(a){return a},u.link=function(a,p,k){return""+k},u.image=function(a,p,k){return""+k},u.br=function(){return""},x}(),_=function(){function x(){this.seen={}}var u=x.prototype;return u.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},u.getNextSafeSlug=function(a,p){var k=a,s=0;if(this.seen.hasOwnProperty(k)){s=this.seen[a];do s++,k=a+"-"+s;while(this.seen.hasOwnProperty(k))}return p||(this.seen[a]=s,this.seen[k]=0),k},u.slug=function(a,p){p===void 0&&(p={});var k=this.serialize(a);return this.getNextSafeSlug(k,p.dryrun)},x}(),ae=function(){function x(y){this.options=y||ne.defaults,this.options.renderer=this.options.renderer||new He,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new _}x.parse=function(a,p){var k=new x(p);return k.parse(a)},x.parseInline=function(a,p){var k=new x(p);return k.parseInline(a)};var u=x.prototype;return u.parse=function(a,p){p===void 0&&(p=!0);var k="",s,E,v,L,z,X,U,oe,we,me,Ie,ke,je,Ee,Te,We,Ue,Ye,_e,Y=a.length;for(s=0;s<Y;s++){if(me=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(_e=this.options.extensions.renderers[me.type].call({parser:this},me),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(me.type))){k+=_e||"";continue}switch(me.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(me.tokens),me.depth,r(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(oe="",U="",L=me.header.length,E=0;E<L;E++)U+=this.renderer.tablecell(this.parseInline(me.header[E].tokens),{header:!0,align:me.align[E]});for(oe+=this.renderer.tablerow(U),we="",L=me.rows.length,E=0;E<L;E++){for(X=me.rows[E],U="",z=X.length,v=0;v<z;v++)U+=this.renderer.tablecell(this.parseInline(X[v].tokens),{header:!1,align:me.align[v]});we+=this.renderer.tablerow(U)}k+=this.renderer.table(oe,we);continue}case"blockquote":{we=this.parse(me.tokens),k+=this.renderer.blockquote(we);continue}case"list":{for(Ie=me.ordered,ke=me.start,je=me.loose,L=me.items.length,we="",E=0;E<L;E++)Te=me.items[E],We=Te.checked,Ue=Te.task,Ee="",Te.task&&(Ye=this.renderer.checkbox(We),je?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=Ye+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=Ye+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:Ye}):Ee+=Ye),Ee+=this.parse(Te.tokens,je),we+=this.renderer.listitem(Ee,Ue,We);k+=this.renderer.list(we,Ie,ke);continue}case"html":{k+=this.renderer.html(me.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(we=me.tokens?this.parseInline(me.tokens):me.text;s+1<Y&&a[s+1].type==="text";)me=a[++s],we+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);k+=p?this.renderer.paragraph(we):we;continue}default:{var ie='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(ie);return}else throw new Error(ie)}}}return k},u.parseInline=function(a,p){p=p||this.renderer;var k="",s,E,v,L=a.length;for(s=0;s<L;s++){if(E=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[E.type]&&(v=this.options.extensions.renderers[E.type].call({parser:this},E),v!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(E.type))){k+=v||"";continue}switch(E.type){case"escape":{k+=p.text(E.text);break}case"html":{k+=p.html(E.text);break}case"link":{k+=p.link(E.href,E.title,this.parseInline(E.tokens,p));break}case"image":{k+=p.image(E.href,E.title,E.text);break}case"strong":{k+=p.strong(this.parseInline(E.tokens,p));break}case"em":{k+=p.em(this.parseInline(E.tokens,p));break}case"codespan":{k+=p.codespan(E.text);break}case"br":{k+=p.br();break}case"del":{k+=p.del(this.parseInline(E.tokens,p));break}case"text":{k+=p.text(E.text);break}default:{var z='Token with "'+E.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return k},x}();function le(x,u,y){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof u=="function"&&(y=u,u=null),u=$({},le.defaults,u||{}),H(u),y){var a=u.highlight,p;try{p=Fe.lex(x,u)}catch(L){return y(L)}var k=function(z){var X;if(!z)try{u.walkTokens&&le.walkTokens(p,u.walkTokens),X=ae.parse(p,u)}catch(U){z=U}return u.highlight=a,z?y(z):y(null,X)};if(!a||a.length<3||(delete u.highlight,!p.length))return k();var s=0;le.walkTokens(p,function(L){L.type==="code"&&(s++,setTimeout(function(){a(L.text,L.lang,function(z,X){if(z)return k(z);X!=null&&X!==L.text&&(L.text=X,L.escaped=!0),s--,s===0&&k()})},0))}),s===0&&k();return}function E(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}try{var v=Fe.lex(x,u);if(u.walkTokens){if(u.async)return Promise.all(le.walkTokens(v,u.walkTokens)).then(function(){return ae.parse(v,u)}).catch(E);le.walkTokens(v,u.walkTokens)}return ae.parse(v,u)}catch(L){E(L)}}le.options=le.setOptions=function(x){return $(le.defaults,x),A(le.defaults),le},le.getDefaults=S,le.defaults=ne.defaults,le.use=function(){for(var x=arguments.length,u=new Array(x),y=0;y<x;y++)u[y]=arguments[y];var a=$.apply(void 0,[{}].concat(u)),p=le.defaults.extensions||{renderers:{},childTokens:{}},k;u.forEach(function(s){if(s.extensions&&(k=!0,s.extensions.forEach(function(v){if(!v.name)throw new Error("extension name required");if(v.renderer){var L=p.renderers?p.renderers[v.name]:null;L?p.renderers[v.name]=function(){for(var z=arguments.length,X=new Array(z),U=0;U<z;U++)X[U]=arguments[U];var oe=v.renderer.apply(this,X);return oe===!1&&(oe=L.apply(this,X)),oe}:p.renderers[v.name]=v.renderer}if(v.tokenizer){if(!v.level||v.level!=="block"&&v.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");p[v.level]?p[v.level].unshift(v.tokenizer):p[v.level]=[v.tokenizer],v.start&&(v.level==="block"?p.startBlock?p.startBlock.push(v.start):p.startBlock=[v.start]:v.level==="inline"&&(p.startInline?p.startInline.push(v.start):p.startInline=[v.start]))}v.childTokens&&(p.childTokens[v.name]=v.childTokens)})),s.renderer&&function(){var v=le.defaults.renderer||new He,L=function(U){var oe=v[U];v[U]=function(){for(var we=arguments.length,me=new Array(we),Ie=0;Ie<we;Ie++)me[Ie]=arguments[Ie];var ke=s.renderer[U].apply(v,me);return ke===!1&&(ke=oe.apply(v,me)),ke}};for(var z in s.renderer)L(z);a.renderer=v}(),s.tokenizer&&function(){var v=le.defaults.tokenizer||new ce,L=function(U){var oe=v[U];v[U]=function(){for(var we=arguments.length,me=new Array(we),Ie=0;Ie<we;Ie++)me[Ie]=arguments[Ie];var ke=s.tokenizer[U].apply(v,me);return ke===!1&&(ke=oe.apply(v,me)),ke}};for(var z in s.tokenizer)L(z);a.tokenizer=v}(),s.walkTokens){var E=le.defaults.walkTokens;a.walkTokens=function(v){var L=[];return L.push(s.walkTokens.call(this,v)),E&&(L=L.concat(E.call(this,v))),L}}k&&(a.extensions=p),le.setOptions(a)})},le.walkTokens=function(x,u){for(var y=[],a=function(){var E=k.value;switch(y=y.concat(u.call(le,E)),E.type){case"table":{for(var v=W(E.header),L;!(L=v()).done;){var z=L.value;y=y.concat(le.walkTokens(z.tokens,u))}for(var X=W(E.rows),U;!(U=X()).done;)for(var oe=U.value,we=W(oe),me;!(me=we()).done;){var Ie=me.value;y=y.concat(le.walkTokens(Ie.tokens,u))}break}case"list":{y=y.concat(le.walkTokens(E.items,u));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[E.type]?le.defaults.extensions.childTokens[E.type].forEach(function(ke){y=y.concat(le.walkTokens(E[ke],u))}):E.tokens&&(y=y.concat(le.walkTokens(E.tokens,u)))}},p=W(x),k;!(k=p()).done;)a();return y},le.parseInline=function(x,u){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");u=$({},le.defaults,u||{}),H(u);try{var y=Fe.lexInline(x,u);return u.walkTokens&&le.walkTokens(y,u.walkTokens),ae.parseInline(y,u)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},le.Parser=ae,le.parser=ae.parse,le.Renderer=He,le.TextRenderer=he,le.Lexer=Fe,le.lexer=Fe.lex,le.Tokenizer=ce,le.Slugger=_,le.parse=le;var J=le.options,Q=le.setOptions,se=le.use,fe=le.walkTokens,ve=le.parseInline,Ne=le,Ae=ae.parse,Le=Fe.lex;ne.Lexer=Fe,ne.Parser=ae,ne.Renderer=He,ne.Slugger=_,ne.TextRenderer=he,ne.Tokenizer=ce,ne.getDefaults=S,ne.lexer=Le,ne.marked=le,ne.options=J,ne.parse=Ne,ne.parseInline=ve,ne.parser=Ae,ne.setOptions=Q,ne.use=se,ne.walkTokens=fe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ge[89],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mk=i;function i(n){const r=W(n);if(r&&r.length>0)return new Uint32Array(r)}let F=0;const P=new Uint32Array(10);function W(n){if(F=0,S(n,B,4352),F>0||(S(n,c,4449),F>0)||(S(n,f,4520),F>0)||(S(n,e,12593),F))return P.subarray(0,F);if(n>=44032&&n<=55203){const r=n-44032,h=r%588,g=Math.floor(r/588),D=Math.floor(h/28),o=h%28-1;if(g<B.length?S(g,B,0):4352+g-12593<e.length&&S(4352+g,e,12593),D<c.length?S(D,c,0):4449+D-12593<e.length&&S(4449+D-12593,e,12593),o>=0&&(o<f.length?S(o,f,0):4520+o-12593<e.length&&S(4520+o-12593,e,12593)),F>0)return P.subarray(0,F)}}function S(n,r,h){n>=h&&n<h+r.length&&A(r[n-h])}function A(n){n!==0&&(P[F++]=n&255,n>>8&&(P[F++]=n>>8&255),n>>16&&(P[F++]=n>>16&255))}var m;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var b;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(b||(b={}));var w;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(w||(w={}));const B=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ge[90],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PU=void 0;class i{constructor(P,W=0,S=P.length,A=W-1){this.a=P,this.b=W,this.c=S,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$PU=i}),define(ge[91],be([1,0,90]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RU=t.$QU=void 0;class F{constructor(S=[],A=10){this.h(S),this.b=A,this.d()}getHistory(){return this.j}add(S){this.a.delete(S),this.a.add(S),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(S){return this.a.has(S)}clear(){this.h([]),this.d()}d(){this.f();const S=this.j;this.c=new i.$PU(S,0,S.length,S.length)}f(){const S=this.j;S.length>this.b&&this.h(S.slice(S.length-this.b))}g(){const S=this.c.current();return S?this.j.indexOf(S):-1}h(S){this.a=new Set;for(const A of S)this.a.add(A)}get j(){const S=[];return this.a.forEach(A=>S.push(A)),S}}t.$QU=F;class P{get size(){return this.f}constructor(S,A=10){if(this.g=A,S.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:S[0],previous:void 0,next:void 0},this.a=new Set([S[0]]);for(let m=1;m<S.length;m++)this.add(S[m])}add(S){const A={value:S,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(S)?this.h(S):this.a.add(S);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(S){if(this.c.value===S)return S;const A=this.c.value;return this.a.delete(A),this.c.value=S,this.a.has(S)?this.h(S):this.a.add(S),A}prepend(S){if(this.f===this.g||this.a.has(S))return;const A={value:S,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(S)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(S){return this.a.has(S)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let S=this.b;for(;S;)yield S.value,S=S.next}h(S){let A=this.b;for(;A!==this.c;)A.value===S&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$RU=P}),define(ge[40],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wm=t.$vm=t.$um=void 0,t.$sm=i,t.rot=F;function i(A,m,b){return Math.min(Math.max(A,m),b)}function F(A,m){return(m+A%m)%m}class P{constructor(){this.a=0}getNext(){return this.a++}}t.$um=P;class W{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$vm=W;class S{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const b=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$wm=S}),define(ge[26],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$c=void 0,t.$_c=W,t.$ad=c;class i{constructor(e,n,r){this.owner=e,this.debugNameSource=n,this.referenceFn=r}getDebugName(e){return W(e,this)}}t.$$c=i;const F=new Map,P=new WeakMap;function W(f,e){const n=P.get(f);if(n)return n;const r=S(f,e);if(r){let h=F.get(r)??0;h++,F.set(r,h);const g=h===1?r:`${r}#${h}`;return P.set(f,g),g}}function S(f,e){const n=P.get(f);if(n)return n;const r=e.owner?w(e.owner)+".":"";let h;const g=e.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(h=g(),h!==void 0)return r+h}else return r+g;const D=e.referenceFn;if(D!==void 0&&(h=c(D),h!==void 0))return r+h;if(e.owner!==void 0){const o=A(e.owner,f);if(o!==void 0)return r+o}}function A(f,e){for(const n in f)if(f[n]===e)return n}const m=new Map,b=new WeakMap;function w(f){const e=b.get(f);if(e)return e;const n=B(f);let r=m.get(n)??0;r++,m.set(n,r);const h=r===1?n:`${n}#${r}`;return b.set(f,h),h}function B(f){const e=f.constructor;return e?e.name:"Object"}function c(f){const e=f.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(ge[27],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fd=void 0,t.$Dd=F,t.$Ed=P;let i;function F(n){i=n}function P(){return i}class W{constructor(){this.a=0,this.d=new WeakMap}b(r){return S([A(f("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[A(" "),b(w(r.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),b(w(r.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),b(w(r.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([m("observable value changed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return b(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(g,D)=>(this.d.get(r).add(g),h.apply(r,[g,D]))}handleDerivedRecomputed(r,h){const g=this.d.get(r);console.log(...this.b([m("derived recomputed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(g),{data:[{fn:r._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([m("observable from event triggered"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(g,D)=>(this.d.get(r).add(g),h.apply(r,[g,D]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([m("autorun"),b(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([m("transaction"),b(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Fd=W;function S(n){const r=new Array,h=[];let g="";function D(d){if("length"in d)for(const l of d)l&&D(l);else"text"in d?(g+=`%c${d.text}`,r.push(d.style),d.data&&h.push(...d.data)):"data"in d&&h.push(...d.data)}D(n);const o=[g,...r];return o.push(...h),o}function A(n){return b(n,{color:"black"})}function m(n){return b(e(`${n}: `,10),{color:"black",bold:!0})}function b(n,r={color:"black"}){function h(D){return Object.entries(D).reduce((o,[d,l])=>`${o}${d}:${l};`,"")}const g={color:r.color};return r.strikeThrough&&(g["text-decoration"]="line-through"),r.bold&&(g["font-weight"]="bold"),{text:n,style:h(g)}}function w(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?B(n,r):c(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function B(n,r){let h="[ ",g=!0;for(const D of n){if(g||(h+=", "),h.length-5>r){h+="...";break}g=!1,h+=`${w(D,r-h.length)}`}return h+=" ]",h}function c(n,r){let h="{ ",g=!0;for(const[D,o]of Object.entries(n)){if(g||(h+=", "),h.length-5>r){h+="...";break}g=!1,h+=`${D}: ${w(o,r-h.length)}`}return h+=" }",h}function f(n,r){let h="";for(let g=1;g<=r;g++)h+=n;return h}function e(n,r){for(;n.length<r;)n+=" ";return n}}),define(ge[41],be([1,0,37,2,26,27]),function(ne,t,i,F,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nd=void 0,t.$hd=S,t.$id=A,t.$jd=m,t.$kd=b,t.$ld=w,t.$md=B;function S(e){return new f(new P.$$c(void 0,void 0,e),e,void 0,void 0)}function A(e,n){return new f(new P.$$c(e.owner,e.debugName,e.debugReferenceFn??n),n,void 0,void 0)}function m(e,n){return new f(new P.$$c(e.owner,e.debugName,e.debugReferenceFn??n),n,e.createEmptyChangeSummary,e.handleChange)}function b(e,n){const r=new F.$Tc,h=m({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(g,D)=>{r.clear(),n(g,D,r)});return(0,F.$Sc)(()=>{h.dispose(),r.dispose()})}function w(e){const n=new F.$Tc,r=A({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{n.clear(),e(h,n)});return(0,F.$Sc)(()=>{r.dispose(),n.dispose()})}function B(e,n){let r;return A({debugReferenceFn:n},h=>{const g=e.read(h),D=r;r=g,n({lastValue:D,newValue:g})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class f{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,r,h,g){this.h=n,this._runFn=r,this.i=h,this.j=g,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,W.$Ed)()?.handleAutorunCreated(this),this.k(),(0,F.$Lc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,F.$Mc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,W.$Ed)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.i?.(),this._runFn(this,h)}}finally{r||(0,W.$Ed)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,i.$fd)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:g=>g===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}t.$nd=f,function(e){e.Observer=f}(S||(t.$hd=S={}))}),define(ge[33],be([1,0,38,26,27]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=t.$Yd=t.$Vd=t.$Qd=t.$Pd=void 0,t.$Md=S,t.$Nd=m,t.$Od=w,t.$Rd=f,t.$Sd=n,t.$Td=r,t.$Ud=h,t.$Wd=D,t.$Xd=o,t.$Zd=l;let W;function S(N){W=N}let A;function m(N){A=N}let b;function w(N){b=N}class B{get TChange(){return null}reportChanges(){this.get()}read(R){return R?R.readObservable(this):this.get()}map(R,I){const j=I===void 0?void 0:R,$=I===void 0?R:I;return b({owner:j,debugName:()=>{const O=(0,F.$ad)($);if(O!==void 0)return O;const M=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec($.toString());if(M)return`${this.debugName}.${M[2]}`;if(!j)return`${this.debugName} (mapped)`},debugReferenceFn:$},O=>$(this.read(O),O))}recomputeInitiallyAndOnChange(R,I){return R.add(W(this,I)),this}keepObserved(R){return R.add(A(this)),this}}t.$Pd=B;class c extends B{constructor(){super(...arguments),this.a=new Set}addObserver(R){const I=this.a.size;this.a.add(R),I===0&&this.b()}removeObserver(R){this.a.delete(R)&&this.a.size===0&&this.c()}b(){}c(){}}t.$Qd=c;function f(N,R){const I=new g(N,R);try{N(I)}finally{I.finish()}}let e;function n(N){if(e)N(e);else{const R=new g(N,void 0);e=R;try{N(R)}finally{R.finish(),e=void 0}}}async function r(N,R){const I=new g(N,R);try{await N(I)}finally{I.finish()}}function h(N,R,I){N?R(N):f(R,I)}class g{constructor(R,I){this._fn=R,this.b=I,this.a=[],(0,P.$Ed)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,F.$ad)(this._fn)}updateObserver(R,I){this.a.push({observer:R,observable:I}),R.beginUpdate(I)}finish(){const R=this.a;for(let I=0;I<R.length;I++){const{observer:j,observable:$}=R[I];j.endUpdate($)}this.a=null,(0,P.$Ed)()?.handleEndTransaction()}}t.$Vd=g;function D(N,R){let I;return typeof N=="string"?I=new F.$$c(void 0,N,void 0):I=new F.$$c(N,void 0,void 0),new d(I,R,i.$6c)}function o(N,R){return new d(new F.$$c(N.owner,N.debugName,void 0),R,N.equalsFn??i.$6c)}class d extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(R,I,j){super(),this.e=R,this.f=j,this.d=I}get(){return this.d}set(R,I,j){if(this.f(this.d,R))return;let $;I||(I=$=new g(()=>{},()=>`Setting ${this.debugName}`));try{const O=this.d;this.g(R),(0,P.$Ed)()?.handleObservableChanged(this,{oldValue:O,newValue:R,change:j,didChange:!0,hadValue:!0});for(const V of this.a)I.updateObserver(V,this),V.handleChange(this,j)}finally{$&&$.finish()}}toString(){return`${this.debugName}: ${this.d}`}g(R){this.d=R}}t.$Yd=d;function l(N,R){let I;return typeof N=="string"?I=new F.$$c(void 0,N,void 0):I=new F.$$c(N,void 0,void 0),new T(I,R,i.$6c)}class T extends d{g(R){this.d!==R&&(this.d&&this.d.dispose(),this.d=R)}dispose(){this.d?.dispose()}}t.$1d=T}),define(ge[42],be([1,0,37,38,2,33,26,27]),function(ne,t,i,F,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ld=void 0,t.$Gd=m,t.$Hd=b,t.$Id=w,t.$Jd=B,t.$Kd=c;function m(n,r){return r!==void 0?new e(new S.$$c(n,void 0,r),r,void 0,void 0,void 0,F.$6c):new e(new S.$$c(void 0,void 0,n),n,void 0,void 0,void 0,F.$6c)}function b(n,r){return new e(new S.$$c(n.owner,n.debugName,n.debugReferenceFn),r,void 0,void 0,n.onLastObserverRemoved,n.equalsFn??F.$6c)}(0,W.$Od)(b);function w(n,r){return new e(new S.$$c(n.owner,n.debugName,void 0),r,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??F.$6c)}function B(n,r){let h,g;r===void 0?(h=n,g=void 0):(g=n,h=r);const D=new P.$Tc;return new e(new S.$$c(g,void 0,h),o=>(D.clear(),h(o,D)),void 0,void 0,()=>D.dispose(),F.$6c)}function c(n,r){let h,g;r===void 0?(h=n,g=void 0):(g=n,h=r);const D=new P.$Tc;return new e(new S.$$c(g,void 0,h),o=>{D.clear();const d=h(o);return d&&D.add(d),d},void 0,void 0,()=>D.dispose(),F.$6c)}var f;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(f||(f={}));class e extends W.$Qd{get debugName(){return this.l.getDebugName(this)??"(anonymous)"}constructor(r,h,g,D,o=void 0,d){super(),this.l=r,this._computeFn=h,this.m=g,this.n=D,this.p=o,this.q=d,this.e=0,this.f=void 0,this.g=0,this.h=new Set,this.j=new Set,this.k=void 0,this.k=this.m?.(),(0,A.$Ed)()?.handleDerivedCreated(this)}c(){this.e=0,this.f=void 0;for(const r of this.h)r.removeObserver(this);this.h.clear(),this.p?.()}get(){if(this.a.size===0){const r=this._computeFn(this,this.m?.());return this.c(),r}else{do{if(this.e===1){for(const r of this.h)if(r.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.t()}while(this.e!==3);return this.f}}t(){if(this.e===3)return;const r=this.j;this.j=this.h,this.h=r;const h=this.e!==0,g=this.f;this.e=3;const D=this.k;this.k=this.m?.();try{this.f=this._computeFn(this,D)}finally{for(const d of this.j)d.removeObserver(this);this.j.clear()}const o=h&&!this.q(g,this.f);if((0,A.$Ed)()?.handleDerivedRecomputed(this,{oldValue:g,newValue:this.f,change:void 0,didChange:o,hadValue:h}),o)for(const d of this.a)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.g++;const h=this.g===1;if(this.e===3&&(this.e=1,!h))for(const g of this.a)g.handlePossibleChange(this);if(h)for(const g of this.a)g.beginUpdate(this)}endUpdate(r){if(this.g--,this.g===0){const h=[...this.a];for(const g of h)g.endUpdate(this)}(0,i.$fd)(()=>this.g>=0)}handlePossibleChange(r){if(this.e===3&&this.h.has(r)&&!this.j.has(r)){this.e=1;for(const h of this.a)h.handlePossibleChange(this)}}handleChange(r,h){if(this.h.has(r)&&!this.j.has(r)){const g=this.n?this.n({changedObservable:r,change:h,didChange:o=>o===r},this.k):!0,D=this.e===3;if(g&&(this.e===1||D)&&(this.e=2,D))for(const o of this.a)o.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const h=r.get();return this.h.add(r),this.j.delete(r),h}addObserver(r){const h=!this.a.has(r)&&this.g>0;super.addObserver(r),h&&r.beginUpdate(this)}removeObserver(r){const h=this.a.has(r)&&this.g>0;super.removeObserver(r),h&&r.endUpdate(this)}}t.$Ld=e}),define(ge[92],be([1,0,2,41,33,26,42,27]),function(ne,t,i,F,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zd=t.$rd=void 0,t.$od=m,t.$pd=w,t.$qd=B,t.$sd=f,t.$td=n,t.$ud=h,t.$vd=g,t.$wd=D,t.$xd=o,t.$yd=d,t.$Ad=T,t.$Bd=N,t.$Cd=R;function m(j){return new b(j)}class b extends P.$Pd{constructor($){super(),this.a=$}get debugName(){return this.toString()}get(){return this.a}addObserver($){}removeObserver($){}toString(){return`Const: ${this.a}`}}function w(j){const $=(0,P.$Wd)("promiseValue",{});return j.then(O=>{$.set({value:O},void 0)}),$}function B(j,$){return new c(j,$)}class c extends P.$Qd{constructor($,O){super(),this.h=$,this._getValue=O,this.f=!1,this.l=V=>{const M=this._getValue(V),H=this.e,C=!this.f||H!==M;let G=!1;C&&(this.e=M,this.f&&(G=!0,(0,P.$Ud)(c.globalTransaction,Z=>{(0,A.$Ed)()?.handleFromEventObservableTriggered(this,{oldValue:H,newValue:M,change:void 0,didChange:C,hadValue:this.f});for(const ce of this.a)Z.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const Z=this.j();return"Event fired"+(Z?`: ${Z}`:"")})),this.f=!0),G||(0,A.$Ed)()?.handleFromEventObservableTriggered(this,{oldValue:H,newValue:M,change:void 0,didChange:C,hadValue:this.f})}}j(){return(0,W.$ad)(this._getValue)}get debugName(){const $=this.j();return"From Event"+($?`: ${$}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this._getValue(void 0)}}t.$rd=c,function(j){j.Observer=c;function $(O,V){let M=!1;c.globalTransaction===void 0&&(c.globalTransaction=O,M=!0);try{V()}finally{M&&(c.globalTransaction=void 0)}}j.batchEventsGlobally=$}(B||(t.$qd=B={}));function f(j,$){return new e(j,$)}class e extends P.$Qd{constructor($,O){super(),this.debugName=$,this.f=O,this.h=()=>{(0,P.$Rd)(V=>{for(const M of this.a)V.updateObserver(M,this),M.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function n(j){return typeof j=="string"?new r(j):new r(void 0,j)}class r extends P.$Qd{get debugName(){return new W.$$c(this.f,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor($,O){super(),this.e=$,this.f=O}trigger($,O){if(!$){(0,P.$Rd)(V=>{this.trigger(V,O)},()=>`Trigger signal ${this.debugName}`);return}for(const V of this.a)$.updateObserver(V,this),V.handleChange(this,O)}get(){}}function h(j,$,O){const V=(0,P.$Wd)("debounced",void 0);let M;return O.add((0,F.$hd)(H=>{const C=j.read(H);M&&clearTimeout(M),M=setTimeout(()=>{(0,P.$Rd)(G=>{V.set(C,G)})},$)})),V}function g(j,$){let O=!1,V,M;return B(H=>{const C=(0,F.$hd)(G=>{const Z=j.read(G);O?(M&&clearTimeout(M),M=setTimeout(()=>{V=Z,H()},$)):(O=!0,V=Z)});return{dispose(){C.dispose(),O=!1,V=void 0}}},()=>O?V:j.get())}function D(j,$,O){const V=(0,P.$Wd)("triggeredRecently",!1);let M;return O.add(j(()=>{V.set(!0,void 0),M&&clearTimeout(M),M=setTimeout(()=>{V.set(!1,void 0)},$)})),V}function o(j){const $=new l(!1,void 0);return j.addObserver($),(0,i.$Sc)(()=>{j.removeObserver($)})}(0,P.$Nd)(o);function d(j,$){const O=new l(!0,$);return j.addObserver(O),$?$(j.get()):j.reportChanges(),(0,i.$Sc)(()=>{j.removeObserver(O)})}(0,P.$Md)(d);class l{constructor($,O){this.b=$,this.c=O,this.a=0}beginUpdate($){this.a++}endUpdate($){this.a--,this.a===0&&this.b&&(this.c?this.c($.get()):$.reportChanges())}handlePossibleChange($){}handleChange($,O){}}t.$zd=l;function T(j,$){let O;return(0,S.$Gd)(j,M=>(O=$(M,O),O))}function N(j,$){let O;const V=(0,P.$Wd)("derivedObservableWithWritableCache.counter",0),M=(0,S.$Gd)(j,H=>(V.read(H),O=$(H,O),O));return Object.assign(M,{clearCache:H=>{O=void 0,V.set(V.get()+1,H)}})}function R(j,$,O,V){let M=new I(O,V);return(0,S.$Hd)({debugReferenceFn:O,owner:j,onLastObserverRemoved:()=>{M.dispose(),M=new I(O)}},C=>(M.setItems($.read(C)),M.getItems()))}class I{constructor($,O){this.c=$,this.e=O,this.a=new Map,this.b=[]}dispose(){this.a.forEach($=>$.store.dispose()),this.a.clear()}setItems($){const O=[],V=new Set(this.a.keys());for(const M of $){const H=this.e?this.e(M):M;let C=this.a.get(H);if(C)V.delete(H);else{const G=new i.$Tc;C={out:this.c(M,G),store:G},this.a.set(H,C)}O.push(C.out)}for(const M of V)this.a.get(M).store.dispose(),this.a.delete(M);this.b=O}getItems(){return this.b}}}),define(ge[56],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(F){function P(m,b){if(m.start>=b.end||b.start>=m.end)return{start:0,end:0};const w=Math.max(m.start,b.start),B=Math.min(m.end,b.end);return B-w<=0?{start:0,end:0}:{start:w,end:B}}F.intersect=P;function W(m){return m.end-m.start<=0}F.isEmpty=W;function S(m,b){return!W(P(m,b))}F.intersects=S;function A(m,b){const w=[],B={start:m.start,end:Math.min(b.start,m.end)},c={start:Math.max(b.end,m.start),end:m.end};return W(B)||w.push(B),W(c)||w.push(c),w}F.relativeComplement=A})(i||(t.Range=i={}))}),define(ge[93],be([1,0,56]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vT=void 0,t.$sT=F,t.$tT=P,t.$uT=W;function F(m,b){const w=[];for(const B of b){if(m.start>=B.range.end)continue;if(m.end<B.range.start)break;const c=i.Range.intersect(m,B.range);i.Range.isEmpty(c)||w.push({range:c,size:B.size})}return w}function P({start:m,end:b},w){return{start:m+w,end:b+w}}function W(m){const b=[];let w=null;for(const B of m){const c=B.range.start,f=B.range.end,e=B.size;if(w&&e===w.size){w.range.end=f;continue}w={range:{start:c,end:f},size:e},b.push(w)}return b}function S(...m){return W(m.reduce((b,w)=>b.concat(w),[]))}class A{get paddingTop(){return this.c}set paddingTop(b){this.b=this.b+b-this.c,this.c=b}constructor(b){this.a=[],this.b=0,this.c=0,this.c=b??0,this.b=this.c}splice(b,w,B=[]){const c=B.length-w,f=F({start:0,end:b},this.a),e=F({start:b+w,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:P(r.range,c),size:r.size})),n=B.map((r,h)=>({range:{start:b+h,end:b+h+1},size:r.size}));this.a=S(f,n,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const b=this.a.length;return b?this.a[b-1].range.end:0}get size(){return this.b}indexAt(b){if(b<0)return-1;if(b<this.c)return 0;let w=0,B=this.c;for(const c of this.a){const f=c.range.end-c.range.start,e=B+f*c.size;if(b<e)return w+Math.floor((b-B)/c.size);w+=f,B=e}return w}indexAfter(b){return Math.min(this.indexAt(b)+1,this.count)}positionAt(b){if(b<0)return-1;let w=0,B=0;for(const c of this.a){const f=c.range.end-c.range.start,e=B+f;if(b<e)return this.c+w+(b-B)*c.size;w+=f*c.size,B=e}return-1}}t.$vT=A}),define(ge[94],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(W){return new F(W)}constructor(W){this.c=i&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$8d=F}),define(ge[3],be([1,0,6,53,2,55,94]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$0d=t.Event=void 0,t.$$d=f;const A=!1,m=!1,b=!1;var w;(function(H){H.None=()=>P.$Uc.None;function C(k){if(b){const{onDidAddListener:s}=k,E=n.create();let v=0;k.onDidAddListener=()=>{++v===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),E.print()),s?.()}}}function G(k,s){return _(k,()=>{},0,void 0,!0,void 0,s)}H.defer=G;function Z(k){return(s,E=null,v)=>{let L=!1,z;return z=k(X=>{if(!L)return z?z.dispose():L=!0,s.call(E,X)},null,v),L&&z.dispose(),z}}H.once=Z;function ce(k,s,E){return He((v,L=null,z)=>k(X=>v.call(L,s(X)),null,z),E)}H.map=ce;function re(k,s,E){return He((v,L=null,z)=>k(X=>{s(X),v.call(L,X)},null,z),E)}H.forEach=re;function te(k,s,E){return He((v,L=null,z)=>k(X=>s(X)&&v.call(L,X),null,z),E)}H.filter=te;function $e(k){return k}H.signal=$e;function De(...k){return(s,E=null,v)=>{const L=(0,P.$Rc)(...k.map(z=>z(X=>s.call(E,X))));return he(L,v)}}H.any=De;function Fe(k,s,E,v){let L=E;return ce(k,z=>(L=s(L,z),L),v)}H.reduce=Fe;function He(k,s){let E;const v={onWillAddFirstListener(){E=k(L.fire,L)},onDidRemoveLastListener(){E?.dispose()}};s||C(v);const L=new d(v);return s?.add(L),L.event}function he(k,s){return s instanceof Array?s.push(k):s&&s.add(k),k}function _(k,s,E=100,v=!1,L=!1,z,X){let U,oe,we,me=0,Ie;const ke={leakWarningThreshold:z,onWillAddFirstListener(){U=k(Ee=>{me++,oe=s(oe,Ee),v&&!we&&(je.fire(oe),oe=void 0),Ie=()=>{const Te=oe;oe=void 0,we=void 0,(!v||me>1)&&je.fire(Te),me=0},typeof E=="number"?(clearTimeout(we),we=setTimeout(Ie,E)):we===void 0&&(we=0,queueMicrotask(Ie))})},onWillRemoveListener(){L&&me>0&&Ie?.()},onDidRemoveLastListener(){Ie=void 0,U.dispose()}};X||C(ke);const je=new d(ke);return X?.add(je),je.event}H.debounce=_;function ae(k,s=0,E){return H.debounce(k,(v,L)=>v?(v.push(L),v):[L],s,void 0,!0,void 0,E)}H.accumulate=ae;function le(k,s=(v,L)=>v===L,E){let v=!0,L;return te(k,z=>{const X=v||!s(z,L);return v=!1,L=z,X},E)}H.latch=le;function J(k,s,E){return[H.filter(k,s,E),H.filter(k,v=>!s(v),E)]}H.split=J;function Q(k,s=!1,E=[],v){let L=E.slice(),z=k(oe=>{L?L.push(oe):U.fire(oe)});v&&v.add(z);const X=()=>{L?.forEach(oe=>U.fire(oe)),L=null},U=new d({onWillAddFirstListener(){z||(z=k(oe=>U.fire(oe)),v&&v.add(z))},onDidAddFirstListener(){L&&(s?setTimeout(X):X())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return v&&v.add(U),U.event}H.buffer=Q;function se(k,s){return(v,L,z)=>{const X=s(new ve);return k(function(U){const oe=X.evaluate(U);oe!==fe&&v.call(L,oe)},void 0,z)}}H.chain=se;const fe=Symbol("HaltChainable");class ve{constructor(){this.f=[]}map(s){return this.f.push(s),this}forEach(s){return this.f.push(E=>(s(E),E)),this}filter(s){return this.f.push(E=>s(E)?E:fe),this}reduce(s,E){let v=E;return this.f.push(L=>(v=s(v,L),v)),this}latch(s=(E,v)=>E===v){let E=!0,v;return this.f.push(L=>{const z=E||!s(L,v);return E=!1,v=L,z?L:fe}),this}evaluate(s){for(const E of this.f)if(s=E(s),s===fe)break;return s}}function Ne(k,s,E=v=>v){const v=(...U)=>X.fire(E(...U)),L=()=>k.on(s,v),z=()=>k.removeListener(s,v),X=new d({onWillAddFirstListener:L,onDidRemoveLastListener:z});return X.event}H.fromNodeEventEmitter=Ne;function Ae(k,s,E=v=>v){const v=(...U)=>X.fire(E(...U)),L=()=>k.addEventListener(s,v),z=()=>k.removeEventListener(s,v),X=new d({onWillAddFirstListener:L,onDidRemoveLastListener:z});return X.event}H.fromDOMEventEmitter=Ae;function Le(k){return new Promise(s=>Z(k)(s))}H.toPromise=Le;function x(k){const s=new d;return k.then(E=>{s.fire(E)},()=>{s.fire(void 0)}).finally(()=>{s.dispose()}),s.event}H.fromPromise=x;function u(k,s,E){return s(E),k(v=>s(v))}H.runAndSubscribe=u;class y{constructor(s,E){this._observable=s,this.f=0,this.g=!1;const v={onWillAddFirstListener:()=>{s.addObserver(this)},onDidRemoveLastListener:()=>{s.removeObserver(this)}};E||C(v),this.emitter=new d(v),E&&E.add(this.emitter)}beginUpdate(s){this.f++}handlePossibleChange(s){}handleChange(s,E){this.g=!0}endUpdate(s){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function a(k,s){return new y(k,s).emitter.event}H.fromObservable=a;function p(k){return(s,E,v)=>{let L=0,z=!1;const X={beginUpdate(){L++},endUpdate(){L--,L===0&&(k.reportChanges(),z&&(z=!1,s.call(E)))},handlePossibleChange(){},handleChange(){z=!0}};k.addObserver(X),k.reportChanges();const U={dispose(){k.removeObserver(X)}};return v instanceof P.$Tc?v.add(U):Array.isArray(v)&&v.push(U),U}}H.fromObservableLight=p})(w||(t.Event=w={}));class B{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${B.f++}`,B.all.add(this)}start(C){this.g=new S.$8d,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}t.$0d=B;let c=-1;function f(H){const C=c;return c=H,{dispose(){c=C}}}class e{constructor(C,G=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=G,this.g=0}dispose(){this.f?.clear()}check(C,G){const Z=this.threshold;if(Z<=0||G<Z)return;this.f||(this.f=new Map);const ce=this.f.get(C.value)||0;if(this.f.set(C.value,ce+1),this.g-=1,this.g<=0){this.g=Z*.5;let re,te=0;for(const[$e,De]of this.f)(!re||te<De)&&(re=$e,te=De);console.warn(`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${te}):`),console.warn(re)}return()=>{const re=this.f.get(C.value)||0;this.f.set(C.value,re-1)}}}class n{static create(){return new n(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class h{constructor(C){this.value=C,this.id=r++}}const g=2,D=(H,C)=>{if(H instanceof h)C(H);else for(let G=0;G<H.length;G++){const Z=H[G];Z&&C(Z)}},o=A?new FinalizationRegistry(H=>{typeof H=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(H))}):void 0;class d{constructor(C){this.w=0,this.f=C,this.g=c>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new B(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const C=this.t;queueMicrotask(()=>{D(C,G=>G.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,G,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Uc.None;if(this.m)return P.$Uc.None;G&&(C=C.bind(G));const ce=new h(C);let re,te;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ce.stack=n.create(),re=this.g.check(ce.stack,this.w+1)),m&&(ce.stack=te??n.create()),this.t?this.t instanceof h?(this.u??=new T,this.t=[this.t,ce]):this.t.push(ce):(this.f?.onWillAddFirstListener?.(this),this.t=ce,this.f?.onDidAddFirstListener?.(this)),this.w++;const $e=(0,P.$Sc)(()=>{o?.unregister($e),re?.(),this.x(ce)});if(Z instanceof P.$Tc?Z.add($e):Array.isArray(Z)&&Z.push($e),o){const De=new Error().stack.split(`
`).slice(2).join(`
`).trim();o.register($e,De,$e)}return $e},this.q}x(C){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const G=this.t,Z=G.indexOf(C);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,G[Z]=void 0;const ce=this.u.current===this;if(this.w*g<=G.length){let re=0;for(let te=0;te<G.length;te++)G[te]?G[re++]=G[te]:ce&&(this.u.end--,re<this.u.i&&this.u.i--);G.length=re}}y(C,G){if(!C)return;const Z=this.f?.onListenerError||i.$1;if(!Z){C.value(G);return}try{C.value(G)}catch(ce){Z(ce)}}z(C){const G=C.current.t;for(;C.i<C.end;)this.y(G[C.i++],C.value);C.reset()}fire(C){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,C);else{const G=this.u;G.enqueue(this,C,this.t.length),this.z(G)}this.j?.stop()}hasListeners(){return this.w>0}}t.$_d=d;const l=()=>new T;t.$ae=l;class T{constructor(){this.i=-1,this.end=0}enqueue(C,G,Z){this.i=0,this.end=Z,this.current=C,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends d{async fireAsync(C,G,Z){if(this.t)for(this.h||(this.h=new W.$5c),D(this.t,ce=>this.h.push([ce.value,C]));this.h.size>0&&!G.isCancellationRequested;){const[ce,re]=this.h.shift(),te=[],$e={...re,token:G,waitUntil:De=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");Z&&(De=Z(De,ce)),te.push(De)}};try{ce($e)}catch(De){(0,i.$1)(De);continue}Object.freeze(te),await Promise.allSettled(te).then(De=>{for(const Fe of De)Fe.status==="rejected"&&(0,i.$1)(Fe.reason)})}}}t.$be=N;class R extends d{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new W.$5c,this.A=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.A(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.w&&(this.h!==0?this.s.push(C):super.fire(C))}}t.$ce=R;class I extends R{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}t.$de=I;class j extends d{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}t.$ee=j;class ${constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const G={event:C,listener:null};this.h.push(G),this.g&&this.m(G);const Z=()=>{this.g&&this.o(G);const ce=this.h.indexOf(G);this.h.splice(ce,1)};return(0,P.$Sc)((0,F.$db)(Z))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(G=>this.f.fire(G))}o(C){C.listener?.dispose(),C.listener=null}dispose(){this.f.dispose();for(const C of this.h)C.listener?.dispose();this.h=[]}}t.$fe=$;class O{constructor(C,G,Z,ce){this.f=new P.$Tc;const re=this.f.add(new $),te=this.f.add(new P.$4c);function $e(De){te.set(De,re.add(ce(De)))}for(const De of C)$e(De);this.f.add(G(De=>{$e(De)})),this.f.add(Z(De=>{te.deleteAndDispose(De)})),this.event=re.event}dispose(){this.f.dispose()}}t.$ge=O;class V{constructor(){this.f=[]}wrapEvent(C){return(G,Z,ce)=>C(re=>{const te=this.f[this.f.length-1];te?te.push(()=>G.call(Z,re)):G.call(Z,re)},void 0,ce)}bufferEvents(C){const G=[];this.f.push(G);const Z=C();return this.f.pop(),G.forEach(ce=>ce()),Z}}t.$he=V;class M{constructor(){this.f=!1,this.g=w.None,this.h=P.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ie=M}),define(ge[17],be([1,0,22,3]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=t.$9Q=t.$8Q=t.$7Q=t.$6Q=t.$5Q=t.$4Q=t.$3Q=t.$XQ=void 0,t.$UQ=W,t.$VQ=S,t.$WQ=A,t.$YQ=m,t.$ZQ=b,t.$1Q=w,t.$2Q=B,t.$$Q=e,t.$_Q=n;class P{constructor(){this.a=new Map,this.b=new F.$_d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new F.$_d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new P}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,g){if(this.getZoomLevel(g)===h)return;const D=this.f(g);this.a.set(D,h),this.b.fire(D)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,g){this.c.set(this.f(g),h)}setFullscreen(h,g){if(this.isFullscreen(g)===h)return;const D=this.f(g);this.e.set(D,h),this.d.fire(D)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function W(r,h,g){typeof h=="string"&&(h=r.matchMedia(h)),h.addEventListener("change",g)}function S(r,h){P.INSTANCE.setZoomLevel(r,h)}function A(r){return P.INSTANCE.getZoomLevel(r)}t.$XQ=P.INSTANCE.onDidChangeZoomLevel;function m(r){return P.INSTANCE.getZoomFactor(r)}function b(r,h){P.INSTANCE.setZoomFactor(r,h)}function w(r,h){P.INSTANCE.setFullscreen(r,h)}function B(r){return P.INSTANCE.isFullscreen(r)}t.$3Q=P.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$4Q=c.indexOf("Firefox")>=0,t.$5Q=c.indexOf("AppleWebKit")>=0,t.$6Q=c.indexOf("Chrome")>=0,t.$7Q=!t.$6Q&&c.indexOf("Safari")>=0,t.$8Q=!t.$6Q&&!t.$7Q&&t.$5Q,t.$9Q=c.indexOf("Electron/")>=0,t.$0Q=c.indexOf("Android")>=0;let f=!1;if(typeof i.$RQ.matchMedia=="function"){const r=i.$RQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=i.$RQ.matchMedia("(display-mode: fullscreen)");f=r.matches,W(i.$RQ,r,({matches:g})=>{f&&h.matches||(f=g)})}function e(){return f}function n(){return navigator?.windowControlsOverlay?.visible}}),define(ge[24],be([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=void 0;class F{get event(){return this.a.event}constructor(W,S,A){const m=b=>this.a.fire(b);this.a=new i.$_d({onWillAddFirstListener:()=>W.addEventListener(S,m,A),onDidRemoveLastListener:()=>W.removeEventListener(S,m,A)})}dispose(){this.a.dispose()}}t.$nT=F}),define(ge[34],be([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$je=t.CancellationToken=void 0;const F=Object.freeze(function(A,m){const b=setTimeout(A.bind(m),0);return{dispose(){clearTimeout(b)}}});var P;(function(A){function m(b){return b===A.None||b===A.Cancelled||b instanceof W?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}A.isCancellationToken=m,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(P||(t.CancellationToken=P={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new i.$_d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=P.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=P.None}}t.$je=S}),define(ge[95],be([1,0,34]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$We=t.$Ve=t.$Ue=void 0;class F{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new i.$je,m=this.b(A.token);return this.a={promise:m,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$Ue=F;class P{constructor(A,m=JSON.stringify){this.c=A,this.d=m,this.a=void 0,this.b=void 0}get(A){const m=this.d(A);return this.b!==m&&(this.b=m,this.a=this.c(A)),this.a}}t.$Ve=P;class W{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const m=this.b(A);return this.a.set(A,m),m}}t.$We=W}),define(ge[96],be([1,0,41,33,42,34,26,38]),function(ne,t,i,F,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5d=t.$4d=t.$3d=t.$2d=void 0,t.$6d=c,t.$7d=f;class m{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,F.$Wd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}t.$2d=m;class b{constructor(n){this.a=(0,F.$Wd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(r=>((0,F.$Rd)(h=>{this.a.set(new w(r,void 0),h)}),r),r=>{throw(0,F.$Rd)(h=>{this.a.set(new w(void 0,r),h)}),r})}}t.$3d=b;class w{constructor(n,r){this.data=n,this.error=r}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$4d=w;class B{constructor(n){this.b=n,this.a=new m(()=>new b(this.b())),this.cachedPromiseResult=(0,P.$Gd)(this,r=>this.a.cachedValue.read(r)?.promiseResult.read(r))}getPromise(){return this.a.getValue().promise}}t.$5d=B;function c(e,n,r){return new Promise((h,g)=>{let D=!0,o=!1;const d=e.map(T=>({isFinished:n(T),error:r?r(T):!1,state:T})),l=(0,i.$hd)(T=>{const{isFinished:N,error:R,state:I}=d.read(T);(N||R)&&(D?o=!0:l.dispose(),R?g(R===!0?I:R):h(I))});D=!1,o&&l.dispose()})}function f(e,n){let r,h;n===void 0?(r=e,h=void 0):(h=e,r=n);let g;return new P.$Ld(new S.$$c(h,void 0,r),D=>(g&&g.dispose(!0),g=new W.$je,r(D,g.token)),void 0,void 0,()=>g?.dispose(),A.$6c)}}),define(ge[57],be([1,0,33,42,41,92,96,27]),function(ne,t,i,F,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$Wd}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$Zd}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Rd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$Ud}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return F.$Gd}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return F.$Hd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return F.$Id}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return F.$Jd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return P.$hd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return P.$md}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return P.$jd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return P.$ld}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return P.$id}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return P.$kd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return W.$od}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return W.$ud}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return W.$Ad}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return W.$Bd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return W.$xd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return W.$yd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return W.$qd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return W.$pd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return W.$td}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return W.$sd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return W.$wd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return S.$2d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return S.$5d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return S.$3d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return S.$4d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return S.$6d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return S.$7d}}),!1&&(0,A.$Dd)(new A.$Fd)}),define(ge[58],be([1,0,3,2]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=t.$Ks=t.$Js=t.ScrollbarVisibility=void 0;var P;(function(f){f[f.Auto=1]="Auto",f[f.Hidden=2]="Hidden",f[f.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));class W{constructor(e,n,r,h,g,D,o){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,r=r|0,h=h|0,g=g|0,D=D|0,o=o|0),this.rawScrollLeft=h,this.rawScrollTop=o,n<0&&(n=0),h+n>r&&(h=r-n),h<0&&(h=0),g<0&&(g=0),o+g>D&&(o=D-g),o<0&&(o=0),this.width=n,this.scrollWidth=r,this.scrollLeft=h,this.height=g,this.scrollHeight=D,this.scrollTop=o}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,g=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,o=this.scrollHeight!==e.scrollHeight,d=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:g,heightChanged:D,scrollHeightChanged:o,scrollTopChanged:d}}}t.$Js=W;class S extends F.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$_d),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const r=this.g.withScrollDimensions(e,n);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;n?h=new w(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=w.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,n)))}}t.$Ks=S;class A{constructor(e,n,r){this.scrollLeft=e,this.scrollTop=n,this.isDone=r}}t.$Ls=A;function m(f,e){const n=e-f;return function(r){return f+n*c(r)}}function b(f,e,n){return function(r){return r<n?f(r/n):e((r-n)/(1-n))}}class w{constructor(e,n,r,h){this.from=e,this.to=n,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,r){if(Math.abs(e-n)>2.5*r){let g,D;return e<n?(g=e+.75*r,D=n-.75*r):(g=e-.75*r,D=n+.75*r),b(m(e,g),m(D,n),.33)}return m(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const r=this.c(n),h=this.d(n);return new A(r,h,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,r){return w.start(e,n,r)}static start(e,n,r){r=r+10;const h=Date.now()-10;return new w(e,n,h,r)}}t.$Ms=w;function B(f){return Math.pow(f,3)}function c(f){return 1-B(1-f)}}),define(ge[97],be([1,0,6,2]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ke=P,t.$le=W,t.$me=S,t.$ne=A,t.$oe=b,t.$pe=w,t.$qe=B,t.$re=c,t.$se=f,t.$te=e,t.$ue=n,t.$ve=r,t.$we=h,t.$xe=g,t.$ye=D;function P(o){const d=o;return d?typeof d.read=="function":!1}function W(o){const d=o;return d?[d.on,d.pause,d.resume,d.destroy].every(l=>typeof l=="function"):!1}function S(o){const d=o;return d?W(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function A(o,d){return new m(o,d)}class m{constructor(d,l){this.e=d,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(l=>l(d))}h(d){this.c.error.length===0?(0,i.$1)(d):this.c.error.slice(0).forEach(l=>l(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,l){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(d,l){if(this.a.destroyed)return;let T;switch(d){case"data":T=this.c.data;break;case"end":T=this.c.end;break;case"error":T=this.c.error;break}if(T){const N=T.indexOf(l);N>=0&&T.splice(N,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(T=>T())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(o,d){const l=[];let T;for(;(T=o.read())!==null;)l.push(T);return d(l)}function w(o,d,l){const T=[];let N;for(;(N=o.read())!==null&&T.length<l;)T.push(N);return N===null&&T.length>0?d(T):{read:()=>{if(T.length>0)return T.shift();if(typeof N<"u"){const R=N;return N=void 0,R}return o.read()}}}function B(o,d){return new Promise((l,T)=>{const N=[];c(o,{onData:R=>{d&&N.push(R)},onError:R=>{d?T(R):l(void 0)},onEnd:()=>{l(d?d(N):void 0)}})})}function c(o,d,l){o.on("error",T=>{l?.isCancellationRequested||d.onError(T)}),o.on("end",()=>{l?.isCancellationRequested||d.onEnd()}),o.on("data",T=>{l?.isCancellationRequested||d.onData(T)})}function f(o,d){return new Promise((l,T)=>{const N=new F.$Tc,R=[],I=O=>{if(R.push(O),R.length>d)return N.dispose(),o.pause(),l({stream:o,buffer:R,ended:!1})},j=O=>(N.dispose(),T(O)),$=()=>(N.dispose(),l({stream:o,buffer:R,ended:!0}));N.add((0,F.$Sc)(()=>o.removeListener("error",j))),o.on("error",j),N.add((0,F.$Sc)(()=>o.removeListener("end",$))),o.on("end",$),N.add((0,F.$Sc)(()=>o.removeListener("data",I))),o.on("data",I)})}function e(o,d){const l=A(d);return l.end(o),l}function n(){const o=A(()=>{throw new Error("not supported")});return o.end(),o}function r(o){let d=!1;return{read:()=>d?null:(d=!0,o)}}function h(o,d,l){const T=A(l);return c(o,{onData:N=>T.write(d.data(N)),onError:N=>T.error(d.error?d.error(N):N),onEnd:()=>T.end()}),T}function g(o,d,l){let T=!1;return{read:()=>{const N=d.read();return T?N:(T=!0,N!==null?l([o,N]):o)}}}function D(o,d,l){let T=!1;const N=A(l);return c(d,{onData:R=>T?N.write(R):(T=!0,N.write(l([o,R]))),onError:R=>N.error(R),onEnd:()=>{T||(T=!0,N.write(o)),N.end()}}),N}}),define(ge[43],be([1,0,23,97]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=void 0,t.$Ae=b,t.$Be=w,t.$Ce=B,t.$De=c,t.$Ee=f,t.$Fe=e,t.$Ge=n,t.$He=r,t.$Ie=h,t.$Je=g,t.$Ke=D,t.$Le=o,t.$Me=d,t.$Ne=l,t.$Oe=T,t.$Pe=N,t.$Qe=R,t.$Re=I,t.$Se=j,t.$Te=V;const P=typeof Buffer<"u",W=new i.$V(()=>new Uint8Array(256));let S,A;class m{static alloc(H){return P?new m(Buffer.allocUnsafe(H)):new m(new Uint8Array(H))}static wrap(H){return P&&!Buffer.isBuffer(H)&&(H=Buffer.from(H.buffer,H.byteOffset,H.byteLength)),new m(H)}static fromString(H,C){return!(C?.dontUseNodeBuffer||!1)&&P?new m(Buffer.from(H)):(S||(S=new TextEncoder),new m(S.encode(H)))}static fromByteArray(H){const C=m.alloc(H.length);for(let G=0,Z=H.length;G<Z;G++)C.buffer[G]=H[G];return C}static concat(H,C){if(typeof C>"u"){C=0;for(let ce=0,re=H.length;ce<re;ce++)C+=H[ce].byteLength}const G=m.alloc(C);let Z=0;for(let ce=0,re=H.length;ce<re;ce++){const te=H[ce];G.set(te,Z),Z+=te.byteLength}return G}constructor(H){this.buffer=H,this.byteLength=this.buffer.byteLength}clone(){const H=m.alloc(this.byteLength);return H.set(this),H}toString(){return P?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(H,C){return new m(this.buffer.subarray(H,C))}set(H,C){if(H instanceof m)this.buffer.set(H.buffer,C);else if(H instanceof Uint8Array)this.buffer.set(H,C);else if(H instanceof ArrayBuffer)this.buffer.set(new Uint8Array(H),C);else if(ArrayBuffer.isView(H))this.buffer.set(new Uint8Array(H.buffer,H.byteOffset,H.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(H){return c(this.buffer,H)}writeUInt32BE(H,C){f(this.buffer,H,C)}readUInt32LE(H){return e(this.buffer,H)}writeUInt32LE(H,C){n(this.buffer,H,C)}readUInt8(H){return r(this.buffer,H)}writeUInt8(H,C){h(this.buffer,H,C)}indexOf(H,C=0){return b(this.buffer,H instanceof m?H.buffer:H,C)}}t.$ze=m;function b(M,H,C=0){const G=H.byteLength,Z=M.byteLength;if(G===0)return 0;if(G===1)return M.indexOf(H[0]);if(G>Z-C)return-1;const ce=W.value;ce.fill(H.length);for(let De=0;De<H.length;De++)ce[H[De]]=H.length-De-1;let re=C+H.length-1,te=re,$e=-1;for(;re<Z;)if(M[re]===H[te]){if(te===0){$e=re;break}re--,te--}else re+=Math.max(H.length-te,ce[M[re]]),te=H.length-1;return $e}function w(M,H){return M[H+0]<<0>>>0|M[H+1]<<8>>>0}function B(M,H,C){M[C+0]=H&255,H=H>>>8,M[C+1]=H&255}function c(M,H){return M[H]*2**24+M[H+1]*2**16+M[H+2]*2**8+M[H+3]}function f(M,H,C){M[C+3]=H,H=H>>>8,M[C+2]=H,H=H>>>8,M[C+1]=H,H=H>>>8,M[C]=H}function e(M,H){return M[H+0]<<0>>>0|M[H+1]<<8>>>0|M[H+2]<<16>>>0|M[H+3]<<24>>>0}function n(M,H,C){M[C+0]=H&255,H=H>>>8,M[C+1]=H&255,H=H>>>8,M[C+2]=H&255,H=H>>>8,M[C+3]=H&255}function r(M,H){return M[H]}function h(M,H,C){M[C]=H}function g(M){return F.$oe(M,H=>m.concat(H))}function D(M){return F.$ve(M)}function o(M){return F.$qe(M,H=>m.concat(H))}async function d(M){return M.ended?m.concat(M.buffer):m.concat([...M.buffer,await o(M.stream)])}function l(M){return F.$te(M,H=>m.concat(H))}function T(M){return F.$we(M,{data:H=>typeof H=="string"?m.fromString(H):m.wrap(H)},H=>m.concat(H))}function N(M){return F.$ne(H=>m.concat(H),M)}function R(M,H){return F.$xe(M,H,C=>m.concat(C))}function I(M,H){return F.$ye(M,H,C=>m.concat(C))}function j(M){let H=0,C=0,G=0;const Z=new Uint8Array(Math.floor(M.length/4*3)),ce=te=>{switch(C){case 3:Z[G++]=H|te,C=0;break;case 2:Z[G++]=H|te>>>2,H=te<<6,C=3;break;case 1:Z[G++]=H|te>>>4,H=te<<4,C=2;break;default:H=te<<2,C=1}};for(let te=0;te<M.length;te++){const $e=M.charCodeAt(te);if($e>=65&&$e<=90)ce($e-65);else if($e>=97&&$e<=122)ce($e-97+26);else if($e>=48&&$e<=57)ce($e-48+52);else if($e===43||$e===45)ce(62);else if($e===47||$e===95)ce(63);else{if($e===61)break;throw new SyntaxError(`Unexpected base64 character ${M[te]}`)}}const re=G;for(;C>0;)ce(0);return m.wrap(Z).slice(0,re)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:M},H=!0,C=!1){const G=C?O:$;let Z="";const ce=M.byteLength%3;let re=0;for(;re<M.byteLength-ce;re+=3){const te=M[re+0],$e=M[re+1],De=M[re+2];Z+=G[te>>>2],Z+=G[(te<<4|$e>>>4)&63],Z+=G[($e<<2|De>>>6)&63],Z+=G[De&63]}if(ce===1){const te=M[re+0];Z+=G[te>>>2],Z+=G[te<<4&63],H&&(Z+="==")}else if(ce===2){const te=M[re+0],$e=M[re+1];Z+=G[te>>>2],Z+=G[(te<<4|$e>>>4)&63],Z+=G[$e<<2&63],H&&(Z+="=")}return Z}}),define(ge[9],be([1,0,95,23]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zf=t.$Yf=t.$Xf=t.GraphemeBreakType=t.$Nf=t.$Gf=t.$zf=t.$yf=void 0,t.$Ze=P,t.$1e=S,t.$2e=m,t.$3e=b,t.$4e=w,t.$5e=B,t.$6e=c,t.$7e=f,t.$8e=e,t.$9e=n,t.$0e=r,t.$$e=h,t.$_e=g,t.$af=D,t.$bf=o,t.$cf=d,t.$df=l,t.$ef=T,t.$ff=N,t.$gf=R,t.$hf=I,t.$if=j,t.$jf=$,t.$kf=O,t.$lf=V,t.$mf=M,t.$nf=H,t.$of=C,t.$pf=G,t.$qf=Z,t.$rf=ce,t.$sf=re,t.$tf=te,t.$uf=$e,t.$vf=De,t.$wf=Fe,t.$xf=He,t.$Af=le,t.$Bf=J,t.$Cf=Q,t.$Df=se,t.$Ef=Ne,t.$Ff=Le,t.$Hf=x,t.$If=u,t.$Jf=y,t.$Kf=a,t.$Lf=k,t.$Mf=s,t.$Of=E,t.$Pf=v,t.$Qf=L,t.$Rf=z,t.$Sf=X,t.$Tf=U,t.$Uf=oe,t.$Vf=we,t.$Wf=Ee;function P(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}const W=/{(\d+)}/g;function S(Y,...ie){return ie.length===0?Y:Y.replace(W,function(pe,ye){const Re=parseInt(ye,10);return isNaN(Re)||Re<0||Re>=ie.length?pe:ie[Re]})}const A=/{([^}]+)}/g;function m(Y,ie){return Object.keys(ie).length===0?Y:Y.replace(A,(pe,ye)=>ie[ye]??pe)}function b(Y){return Y.replace(/[<>"'&]/g,ie=>{switch(ie){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ie})}function w(Y){return Y.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}function B(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(Y,ie){let pe=0;const ye=ie.charCodeAt(0);for(let Re=Y.length-1;Re>=0;Re--)Y.charCodeAt(Re)===ye&&pe++;return pe}function f(Y,ie,pe="\u2026"){return Y.length<=ie?Y:`${Y.substr(0,ie)}${pe}`}function e(Y,ie,pe="\u2026"){if(Y.length<=ie)return Y;const ye=Math.ceil(ie/2)-pe.length/2,Re=Math.floor(ie/2)-pe.length/2;return`${Y.substr(0,ye)}${pe}${Y.substr(Y.length-Re)}`}function n(Y,ie=" "){const pe=r(Y,ie);return h(pe,ie)}function r(Y,ie){if(!Y||!ie)return Y;const pe=ie.length;if(pe===0||Y.length===0)return Y;let ye=0;for(;Y.indexOf(ie,ye)===ye;)ye=ye+pe;return Y.substring(ye)}function h(Y,ie){if(!Y||!ie)return Y;const pe=ie.length,ye=Y.length;if(pe===0||ye===0)return Y;let Re=ye,xe=-1;for(;xe=Y.lastIndexOf(ie,Re-1),!(xe===-1||xe+pe!==Re);){if(xe===0)return"";Re=xe}return Y.substring(0,Re)}function g(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function D(Y){return Y.replace(/\*/g,"")}function o(Y,ie,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");ie||(Y=B(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(Y,ye)}function d(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}function l(Y){return Y.split(/\r\n|\r|\n/)}function T(Y){const ie=[],pe=Y.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ie.push(pe[2*ye]+(pe[2*ye+1]??""));return ie}function N(Y){for(let ie=0,pe=Y.length;ie<pe;ie++){const ye=Y.charCodeAt(ie);if(ye!==32&&ye!==9)return ie}return-1}function R(Y,ie=0,pe=Y.length){for(let ye=ie;ye<pe;ye++){const Re=Y.charCodeAt(ye);if(Re!==32&&Re!==9)return Y.substring(ie,ye)}return Y.substring(ie,pe)}function I(Y,ie=Y.length-1){for(let pe=ie;pe>=0;pe--){const ye=Y.charCodeAt(pe);if(ye!==32&&ye!==9)return pe}return-1}function j(Y,ie,pe){const ye=[];let Re=0;for(const xe of Y.matchAll(ie)){if(ye.push(Y.slice(Re,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Re=xe.index+xe[0].length,ye.push(pe(xe[0],...xe.slice(1),xe.index,Y,xe.groups))}return ye.push(Y.slice(Re)),Promise.all(ye).then(xe=>xe.join(""))}function $(Y,ie){return Y<ie?-1:Y>ie?1:0}function O(Y,ie,pe=0,ye=Y.length,Re=0,xe=ie.length){for(;pe<ye&&Re<xe;pe++,Re++){const it=Y.charCodeAt(pe),st=ie.charCodeAt(Re);if(it<st)return-1;if(it>st)return 1}const Ve=ye-pe,et=xe-Re;return Ve<et?-1:Ve>et?1:0}function V(Y,ie){return M(Y,ie,0,Y.length,0,ie.length)}function M(Y,ie,pe=0,ye=Y.length,Re=0,xe=ie.length){for(;pe<ye&&Re<xe;pe++,Re++){let it=Y.charCodeAt(pe),st=ie.charCodeAt(Re);if(it===st)continue;if(it>=128||st>=128)return O(Y.toLowerCase(),ie.toLowerCase(),pe,ye,Re,xe);C(it)&&(it-=32),C(st)&&(st-=32);const Je=it-st;if(Je!==0)return Je}const Ve=ye-pe,et=xe-Re;return Ve<et?-1:Ve>et?1:0}function H(Y){return Y>=48&&Y<=57}function C(Y){return Y>=97&&Y<=122}function G(Y){return Y>=65&&Y<=90}function Z(Y,ie){return Y.length===ie.length&&M(Y,ie)===0}function ce(Y,ie){const pe=ie.length;return ie.length>Y.length?!1:M(Y,ie,0,pe)===0}function re(Y,ie){const pe=Math.min(Y.length,ie.length);let ye;for(ye=0;ye<pe;ye++)if(Y.charCodeAt(ye)!==ie.charCodeAt(ye))return ye;return pe}function te(Y,ie){const pe=Math.min(Y.length,ie.length);let ye;const Re=Y.length-1,xe=ie.length-1;for(ye=0;ye<pe;ye++)if(Y.charCodeAt(Re-ye)!==ie.charCodeAt(xe-ye))return ye;return pe}function $e(Y){return 55296<=Y&&Y<=56319}function De(Y){return 56320<=Y&&Y<=57343}function Fe(Y,ie){return(Y-55296<<10)+(ie-56320)+65536}function He(Y,ie,pe){const ye=Y.charCodeAt(pe);if($e(ye)&&pe+1<ie){const Re=Y.charCodeAt(pe+1);if(De(Re))return Fe(ye,Re)}return ye}function he(Y,ie){const pe=Y.charCodeAt(ie-1);if(De(pe)&&ie>1){const ye=Y.charCodeAt(ie-2);if($e(ye))return Fe(ye,pe)}return pe}class _{get offset(){return this.e}constructor(ie,pe=0){this.c=ie,this.d=ie.length,this.e=pe}setOffset(ie){this.e=ie}prevCodePoint(){const ie=he(this.c,this.e);return this.e-=ie>=65536?2:1,ie}nextCodePoint(){const ie=He(this.c,this.d,this.e);return this.e+=ie>=65536?2:1,ie}eol(){return this.e>=this.d}}t.$yf=_;class ae{get offset(){return this.c.offset}constructor(ie,pe=0){this.c=new _(ie,pe)}nextGraphemeLength(){const ie=ke.getInstance(),pe=this.c,ye=pe.offset;let Re=ie.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const xe=pe.offset,Ve=ie.getGraphemeBreakType(pe.nextCodePoint());if(me(Re,Ve)){pe.setOffset(xe);break}Re=Ve}return pe.offset-ye}prevGraphemeLength(){const ie=ke.getInstance(),pe=this.c,ye=pe.offset;let Re=ie.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const xe=pe.offset,Ve=ie.getGraphemeBreakType(pe.prevCodePoint());if(me(Ve,Re)){pe.setOffset(xe);break}Re=Ve}return ye-pe.offset}eol(){return this.c.eol()}}t.$zf=ae;function le(Y,ie){return new ae(Y,ie).nextGraphemeLength()}function J(Y,ie){return new ae(Y,ie).prevGraphemeLength()}function Q(Y,ie){ie>0&&De(Y.charCodeAt(ie))&&ie--;const pe=ie+le(Y,ie);return[pe-J(Y,pe),pe]}function se(Y){const ie=new ae(Y);let pe=0;for(;!ie.eol();)pe++,ie.nextGraphemeLength();return pe}let fe;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ne(Y){return fe||(fe=ve()),fe.test(Y)}const Ae=/^[\t\n\r\x20-\x7E]*$/;function Le(Y){return Ae.test(Y)}t.$Gf=/[\u2028\u2029]/;function x(Y){return t.$Gf.test(Y)}function u(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}function y(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}function a(Y,ie,pe=""){const ye=Y.trimStart();if(ye.length<ie)return ye;const Re=/\b/g;let xe=0;for(;Re.test(ye)&&!(ye.length-Re.lastIndex<ie);)xe=Re.lastIndex,Re.lastIndex+=1;return xe===0?ye:pe+ye.substring(xe).trimStart()}const p=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*k(Y){let ie=0;for(const pe of Y.matchAll(p))ie!==pe.index&&(yield{isCode:!1,str:Y.substring(ie,pe.index)}),yield{isCode:!0,str:pe[0]},ie=pe.index+pe[0].length;ie!==Y.length&&(yield{isCode:!1,str:Y.substring(ie)})}function s(Y){return Y&&(Y=Y.replace(p,"")),Y}t.$Nf="\uFEFF";function E(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}function v(Y){return E(Y)?Y.substr(1):Y}function L(Y,ie){if(!Y||!ie||Y.length<ie.length)return!1;const pe=ie.length,ye=Y.toLowerCase();let Re=0,xe=-1;for(;Re<pe;){const Ve=ye.indexOf(ie[Re],xe+1);if(Ve<0)return!1;xe=Ve,Re++}return!0}function z(Y,ie=!1){return Y?(ie&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}function X(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}function U(Y,ie=1){if(ie===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),ie--;while(ie>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}function oe(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}function we(Y){return ke.getInstance().getGraphemeBreakType(Y)}function me(Y,ie){return Y===0?ie!==5&&ie!==7:Y===2&&ie===3?!1:Y===4||Y===2||Y===3||ie===4||ie===2||ie===3?!0:!(Y===8&&(ie===8||ie===9||ie===11||ie===12)||(Y===11||Y===9)&&(ie===9||ie===10)||(Y===12||Y===10)&&ie===10||ie===5||ie===13||ie===7||Y===1||Y===13&&ie===14||Y===6&&ie===6)}var Ie;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(t.GraphemeBreakType=Ie={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=je()}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const pe=this.d,ye=pe.length/3;let Re=1;for(;Re<=ye;)if(ie<pe[3*Re])Re=2*Re;else if(ie>pe[3*Re+1])Re=2*Re+1;else return pe[3*Re+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Y,ie){if(Y===0)return 0;const pe=Te(Y,ie);if(pe!==void 0)return pe;const ye=new _(ie,Y);return ye.prevCodePoint(),ye.offset}function Te(Y,ie){const pe=new _(ie,Y);let ye=pe.prevCodePoint();for(;We(ye)||ye===65039||ye===8419;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!y(ye))return;let Re=pe.offset;return Re>0&&pe.prevCodePoint()===8205&&(Re=pe.offset),Re}function We(Y){return 127995<=Y&&Y<=127999}var Ue;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.$Xf="\xA0";class Ye{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Ve(ie=>{function pe(Je){const rt=new Map;for(let tt=0;tt<Je.length;tt+=2)rt.set(Je[tt],Je[tt+1]);return rt}function ye(Je,rt){const tt=new Map(Je);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Re(Je,rt){if(!Je)return rt;const tt=new Map;for(const[mt,gt]of Je)rt.has(mt)&&tt.set(mt,gt);return tt}const xe=this.c.value;let Ve=ie.filter(Je=>!Je.startsWith("_")&&Je in xe);Ve.length===0&&(Ve=["_default"]);let et;for(const Je of Ve){const rt=pe(xe[Je]);et=Re(et,rt)}const it=pe(xe._common),st=ye(it,et);return new Ye(st)})}static getInstance(ie){return Ye.d.get(Array.from(ie))}static{this.e=new F.$V(()=>Object.keys(Ye.c.value).filter(ie=>!ie.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ie){this.f=ie}isAmbiguous(ie){return this.f.has(ie)}getPrimaryConfusable(ie){return this.f.get(ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Yf=Ye;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ie){return _e.e().has(ie)}static get codePoints(){return _e.e()}}t.$Zf=_e}),define(ge[44],be([1,0,39,89,9]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ak=t.FuzzyScore=t.$pk=t.$ok=void 0,t.or=W,t.$qk=A,t.$rk=m,t.$sk=B,t.$tk=j,t.$uk=$,t.$vk=G,t.$wk=Z,t.$xk=ce,t.$yk=re,t.$zk=Ne,t.$Bk=u,t.$Ck=p,t.$Dk=k;function W(...v){return function(L,z){for(let X=0,U=v.length;X<U;X++){const oe=v[X](L,z);if(oe)return oe}return null}}t.$ok=S.bind(void 0,!1),t.$pk=S.bind(void 0,!0);function S(v,L,z){if(!z||z.length<L.length)return null;let X;return v?X=P.$rf(z,L):X=z.indexOf(L)===0,X?L.length>0?[{start:0,end:L.length}]:[]:null}function A(v,L){const z=L.toLowerCase().indexOf(v.toLowerCase());return z===-1?null:[{start:z,end:z+v.length}]}function m(v,L){return b(v.toLowerCase(),L.toLowerCase(),0,0)}function b(v,L,z,X){if(z===v.length)return[];if(X===L.length)return null;if(v[z]===L[X]){let U=null;return(U=b(v,L,z+1,X+1))?o({start:X,end:X+1},U):null}return b(v,L,z,X+1)}function w(v){return 97<=v&&v<=122}function B(v){return 65<=v&&v<=90}function c(v){return 48<=v&&v<=57}function f(v){return v===32||v===9||v===10||v===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(v=>e.add(v.charCodeAt(0)));function n(v){return f(v)||e.has(v)}function r(v,L){return v===L||n(v)&&n(L)}const h=new Map;function g(v){if(h.has(v))return h.get(v);let L;const z=(0,F.$mk)(v);return z&&(L=z),h.set(v,L),L}function D(v){return w(v)||B(v)||c(v)}function o(v,L){return L.length===0?L=[v]:v.end===L[0].start?L[0].start=v.start:L.unshift(v),L}function d(v,L){for(let z=L;z<v.length;z++){const X=v.charCodeAt(z);if(B(X)||c(X)||z>0&&!D(v.charCodeAt(z-1)))return z}return v.length}function l(v,L,z,X){if(z===v.length)return[];if(X===L.length)return null;if(v[z]!==L[X].toLowerCase())return null;{let U=null,oe=X+1;for(U=l(v,L,z+1,X+1);!U&&(oe=d(L,oe))<L.length;)U=l(v,L,z+1,oe),oe++;return U===null?null:o({start:X,end:X+1},U)}}function T(v){let L=0,z=0,X=0,U=0,oe=0;for(let je=0;je<v.length;je++)oe=v.charCodeAt(je),B(oe)&&L++,w(oe)&&z++,D(oe)&&X++,c(oe)&&U++;const we=L/v.length,me=z/v.length,Ie=X/v.length,ke=U/v.length;return{upperPercent:we,lowerPercent:me,alphaPercent:Ie,numericPercent:ke}}function N(v){const{upperPercent:L,lowerPercent:z}=v;return z===0&&L>.6}function R(v){const{upperPercent:L,lowerPercent:z,alphaPercent:X,numericPercent:U}=v;return z>.2&&L<.8&&X>.6&&U<.2}function I(v){let L=0,z=0,X=0,U=0;for(let oe=0;oe<v.length;oe++)X=v.charCodeAt(oe),B(X)&&L++,w(X)&&z++,f(X)&&U++;return(L===0||z===0)&&U===0?v.length<=30:L<=5}function j(v,L){if(!L||(L=L.trim(),L.length===0)||!I(v))return null;L.length>60&&(L=L.substring(0,60));const z=T(L);if(!R(z)){if(!N(z))return null;L=L.toLowerCase()}let X=null,U=0;for(v=v.toLowerCase();U<L.length&&(X=l(v,L,0,U))===null;)U=d(L,U+1);return X}function $(v,L,z=!1){if(!L||L.length===0)return null;let X=null,U=0;for(v=v.toLowerCase(),L=L.toLowerCase();U<L.length&&(X=O(v,L,0,U,z),X===null);)U=V(L,U+1);return X}function O(v,L,z,X,U){let oe=0;if(z===v.length)return[];if(X===L.length)return null;if(!r(v.charCodeAt(z),L.charCodeAt(X))){const Ie=g(v.charCodeAt(z));if(!Ie)return null;for(let ke=0;ke<Ie.length;ke++)if(!r(Ie[ke],L.charCodeAt(X+ke)))return null;oe+=Ie.length-1}let we=null,me=X+oe+1;if(we=O(v,L,z+1,me,U),!U)for(;!we&&(me=V(L,me))<L.length;)we=O(v,L,z+1,me,U),me++;if(!we)return null;if(v.charCodeAt(z)!==L.charCodeAt(X)){const Ie=g(v.charCodeAt(z));if(!Ie)return we;for(let ke=0;ke<Ie.length;ke++)if(Ie[ke]!==L.charCodeAt(X+ke))return we}return o({start:X,end:X+oe+1},we)}function V(v,L){for(let z=L;z<v.length;z++)if(n(v.charCodeAt(z))||z>0&&n(v.charCodeAt(z-1)))return z;return v.length}const M=W(t.$pk,j,A),H=W(t.$pk,j,m),C=new i.$Ec(1e4);function G(v,L,z=!1){if(typeof v!="string"||typeof L!="string")return null;let X=C.get(v);X||(X=new RegExp(P.$_e(v),"i"),C.set(v,X));const U=X.exec(L);return U?[{start:U.index,end:U.index+U[0].length}]:z?H(v,L):M(v,L)}function Z(v,L){const z=u(v,v.toLowerCase(),0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?re(z):null}function ce(v,L,z,X,U,oe){const we=Math.min(13,v.length);for(;z<we;z++){const me=u(v,L,z,X,U,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(me)return me}return[0,oe]}function re(v){if(typeof v>"u")return[];const L=[],z=v[1];for(let X=v.length-1;X>1;X--){const U=v[X]+z,oe=L[L.length-1];oe&&oe.end===U?oe.end=U+1:L.push({start:U,end:U+1})}return L}const te=128;function $e(){const v=[],L=[];for(let z=0;z<=te;z++)L[z]=0;for(let z=0;z<=te;z++)v.push(L.slice(0));return v}function De(v){const L=[];for(let z=0;z<=v;z++)L[z]=0;return L}const Fe=De(2*te),He=De(2*te),he=$e(),_=$e(),ae=$e(),le=!1;function J(v,L,z,X,U){function oe(me,Ie,ke=" "){for(;me.length<Ie;)me=ke+me;return me}let we=` |   |${X.split("").map(me=>oe(me,3)).join("|")}
`;for(let me=0;me<=z;me++)me===0?we+=" |":we+=`${L[me-1]}|`,we+=v[me].slice(0,U+1).map(Ie=>oe(Ie.toString(),3)).join("|")+`
`;return we}function Q(v,L,z,X){v=v.substr(L),z=z.substr(X),console.log(J(_,v,v.length,z,z.length)),console.log(J(ae,v,v.length,z,z.length)),console.log(J(he,v,v.length,z,z.length))}function se(v,L){if(L<0||L>=v.length)return!1;const z=v.codePointAt(L);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Jf(z)}}function fe(v,L){if(L<0||L>=v.length)return!1;switch(v.charCodeAt(L)){case 32:case 9:return!0;default:return!1}}function ve(v,L,z){return L[v]!==z[v]}function Ne(v,L,z,X,U,oe,we=!1){for(;L<z&&U<oe;)v[L]===X[U]&&(we&&(Fe[L]=U),L+=1),U+=1;return L===z}var Ae;(function(v){v[v.Diag=1]="Diag",v[v.Left=2]="Left",v[v.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var Le;(function(v){v.Default=[-100,0];function L(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}v.isDefault=L})(Le||(t.FuzzyScore=Le={}));class x{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(L,z){this.firstMatchCanBeWeak=L,this.boostFullMatch=z}}t.$Ak=x;function u(v,L,z,X,U,oe,we=x.default){const me=v.length>te?te:v.length,Ie=X.length>te?te:X.length;if(z>=me||oe>=Ie||me-z>Ie-oe||!Ne(L,z,me,U,oe,Ie,!0))return;y(me,Ie,z,oe,L,U);let ke=1,je=1,Ee=z,Te=oe;const We=[!1];for(ke=1,Ee=z;Ee<me;ke++,Ee++){const ie=Fe[Ee],pe=He[Ee],ye=Ee+1<me?He[Ee+1]:Ie;for(je=ie-oe+1,Te=ie;Te<ye;je++,Te++){let Re=Number.MIN_SAFE_INTEGER,xe=!1;Te<=pe&&(Re=a(v,L,Ee,z,X,U,Te,Ie,oe,he[ke-1][je-1]===0,We));let Ve=0;Re!==Number.MAX_SAFE_INTEGER&&(xe=!0,Ve=Re+_[ke-1][je-1]);const et=Te>ie,it=et?_[ke][je-1]+(he[ke][je-1]>0?-5:0):0,st=Te>ie+1&&he[ke][je-1]>0,Je=st?_[ke][je-2]+(he[ke][je-2]>0?-5:0):0;if(st&&(!et||Je>=it)&&(!xe||Je>=Ve))_[ke][je]=Je,ae[ke][je]=3,he[ke][je]=0;else if(et&&(!xe||it>=Ve))_[ke][je]=it,ae[ke][je]=2,he[ke][je]=0;else if(xe)_[ke][je]=Ve,ae[ke][je]=1,he[ke][je]=he[ke-1][je-1]+1;else throw new Error("not possible")}}if(le&&Q(v,z,X,oe),!We[0]&&!we.firstMatchCanBeWeak)return;ke--,je--;const Ue=[_[ke][je],oe];let Ye=0,_e=0;for(;ke>=1;){let ie=je;do{const pe=ae[ke][ie];if(pe===3)ie=ie-2;else if(pe===2)ie=ie-1;else break}while(ie>=1);Ye>1&&L[z+ke-1]===U[oe+je-1]&&!ve(ie+oe-1,X,U)&&Ye+1>he[ke][ie]&&(ie=je),ie===je?Ye++:Ye=1,_e||(_e=ie),ke--,je=ie-1,Ue.push(je)}Ie===me&&we.boostFullMatch&&(Ue[0]+=2);const Y=_e-me;return Ue[0]-=Y,Ue}function y(v,L,z,X,U,oe){let we=v-1,me=L-1;for(;we>=z&&me>=X;)U[we]===oe[me]&&(He[we]=me,we--),me--}function a(v,L,z,X,U,oe,we,me,Ie,ke,je){if(L[z]!==oe[we])return Number.MIN_SAFE_INTEGER;let Ee=1,Te=!1;return we===z-X?Ee=v[z]===U[we]?7:5:ve(we,U,oe)&&(we===0||!ve(we-1,U,oe))?(Ee=v[z]===U[we]?7:5,Te=!0):se(oe,we)&&(we===0||!se(oe,we-1))?Ee=5:(se(oe,we-1)||fe(oe,we-1))&&(Ee=5,Te=!0),Ee>1&&z===X&&(je[0]=!0),Te||(Te=ve(we,U,oe)||se(oe,we-1)||fe(oe,we-1)),z===X?we>Ie&&(Ee-=Te?3:5):ke?Ee+=Te?2:0:Ee+=Te?0:1,we+1===me&&(Ee-=Te?3:5),Ee}function p(v,L,z,X,U,oe,we){return s(v,L,z,X,U,oe,!0,we)}function k(v,L,z,X,U,oe,we){return s(v,L,z,X,U,oe,!1,we)}function s(v,L,z,X,U,oe,we,me){let Ie=u(v,L,z,X,U,oe,me);if(Ie&&!we)return Ie;if(v.length>=3){const ke=Math.min(7,v.length-1);for(let je=z+1;je<ke;je++){const Ee=E(v,je);if(Ee){const Te=u(Ee,Ee.toLowerCase(),z,X,U,oe,me);Te&&(Te[0]-=3,(!Ie||Te[0]>Ie[0])&&(Ie=Te))}}}return Ie}function E(v,L){if(L+1>=v.length)return;const z=v[L],X=v[L+1];if(z!==X)return v.slice(0,L)+X+z+v.slice(L+2)}}),define(ge[59],be([1,0,9]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hj=t.$fj=void 0,t.$bj=F,t.$cj=P,t.$dj=W,t.$ej=A,t.$gj=n;function F(h){return P(h,0)}function P(h,g){switch(typeof h){case"object":return h===null?W(349,g):Array.isArray(h)?m(h,g):b(h,g);case"string":return A(h,g);case"boolean":return S(h,g);case"number":return W(h,g);case"undefined":return W(937,g);default:return W(617,g)}}function W(h,g){return(g<<5)-g+h|0}function S(h,g){return W(h?433:863,g)}function A(h,g){g=W(149417,g);for(let D=0,o=h.length;D<o;D++)g=W(h.charCodeAt(D),g);return g}function m(h,g){return g=W(104579,g),h.reduce((D,o)=>P(o,D),g)}function b(h,g){return g=W(181387,g),Object.keys(h).sort().reduce((D,o)=>(D=A(o,D),P(h[o],D)),g)}class w{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=P(g,this.g),this.g}}t.$fj=w;var B;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(B||(B={}));function c(h,g,D=32){const o=D-g,d=~((1<<o)-1);return(h<<g|(d&h)>>>o)>>>0}function f(h,g=0,D=h.byteLength,o=0){for(let d=0;d<D;d++)h[g+d]=o}function e(h,g,D="0"){for(;h.length<g;)h=D+h;return h}function n(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),g/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const D=g.length;if(D===0)return;const o=this.p;let d=this.r,l=this.u,T,N;for(l!==0?(T=l,N=-1,l=0):(T=g.charCodeAt(0),N=0);;){let R=T;if(i.$uf(T))if(N+1<D){const I=g.charCodeAt(N+1);i.$vf(I)?(N++,R=i.$wf(T,I)):R=65533}else{l=T;break}else i.$vf(T)&&(R=65533);if(d=this.w(o,d,R),N++,N<D)T=g.charCodeAt(N);else break}this.r=d,this.u=l}w(g,D,o){return o<128?g[D++]=o:o<2048?(g[D++]=192|(o&1984)>>>6,g[D++]=128|(o&63)>>>0):o<65536?(g[D++]=224|(o&61440)>>>12,g[D++]=128|(o&4032)>>>6,g[D++]=128|(o&63)>>>0):(g[D++]=240|(o&1835008)>>>18,g[D++]=128|(o&258048)>>>12,g[D++]=128|(o&4032)>>>6,g[D++]=128|(o&63)>>>0),D>=64&&(this.y(),D-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),D}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=r.g,D=this.q;for(let $=0;$<64;$+=4)g.setUint32($,D.getUint32($,!1),!1);for(let $=64;$<320;$+=4)g.setUint32($,c(g.getUint32($-12,!1)^g.getUint32($-32,!1)^g.getUint32($-56,!1)^g.getUint32($-64,!1),1),!1);let o=this.h,d=this.l,l=this.m,T=this.n,N=this.o,R,I,j;for(let $=0;$<80;$++)$<20?(R=d&l|~d&T,I=1518500249):$<40?(R=d^l^T,I=1859775393):$<60?(R=d&l|d&T|l&T,I=2400959708):(R=d^l^T,I=3395469782),j=c(o,5)+R+N+I+g.getUint32($*4,!1)&4294967295,N=T,T=l,l=c(d,30),d=o,o=j;this.h=this.h+o&4294967295,this.l=this.l+d&4294967295,this.m=this.m+l&4294967295,this.n=this.n+T&4294967295,this.o=this.o+N&4294967295}}t.$hj=r}),define(ge[98],be([1,0,85,59]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nt=t.$lt=void 0,t.$mt=W;class P{constructor(c){this.a=c}getElements(){const c=this.a,f=new Int32Array(c.length);for(let e=0,n=c.length;e<n;e++)f[e]=c.charCodeAt(e);return f}}t.$lt=P;function W(B,c,f){return new w(new P(B),new P(c)).ComputeDiff(f).changes}class S{static Assert(c,f){if(!c)throw new Error(f)}}class A{static Copy(c,f,e,n,r){for(let h=0;h<r;h++)e[n+h]=c[f+h]}static Copy2(c,f,e,n,r){for(let h=0;h<r;h++)e[n+h]=c[f+h]}}var m;(function(B){B[B.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class b{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$kt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(c,f,e=null){this.a=e,this.b=c,this.c=f;const[n,r,h]=w.o(c),[g,D,o]=w.o(f);this.d=h&&o,this.e=n,this.f=r,this.g=g,this.h=D,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const f=c.getElements();if(w.n(f)){const e=new Int32Array(f.length);for(let n=0,r=f.length;n<r;n++)e[n]=(0,F.$ej)(f[n],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(c,f){return this.f[c]!==this.h[f]?!1:this.d?this.e[c]===this.g[f]:!0}q(c,f){if(!this.p(c,f))return!1;const e=w.r(this.b,c),n=w.r(this.c,f);return e===n}static r(c,f){return typeof c.getStrictElement=="function"?c.getStrictElement(f):null}s(c,f){return this.f[c]!==this.f[f]?!1:this.d?this.e[c]===this.e[f]:!0}u(c,f){return this.h[c]!==this.h[f]?!1:this.d?this.g[c]===this.g[f]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,f,e,n,r){const h=[!1];let g=this.w(c,f,e,n,h);return r&&(g=this.z(g)),{quitEarly:h[0],changes:g}}w(c,f,e,n,r){for(r[0]=!1;c<=f&&e<=n&&this.p(c,e);)c++,e++;for(;f>=c&&n>=e&&this.p(f,n);)f--,n--;if(c>f||e>n){let l;return e<=n?(S.Assert(c===f+1,"originalStart should only be one more than originalEnd"),l=[new i.$kt(c,0,e,n-e+1)]):c<=f?(S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),l=[new i.$kt(c,f-c+1,e,0)]):(S.Assert(c===f+1,"originalStart should only be one more than originalEnd"),S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const h=[0],g=[0],D=this.y(c,f,e,n,h,g,r),o=h[0],d=g[0];if(D!==null)return D;if(!r[0]){const l=this.w(c,o,e,d,r);let T=[];return r[0]?T=[new i.$kt(o+1,f-(o+1)+1,d+1,n-(d+1)+1)]:T=this.w(o+1,f,d+1,n,r),this.H(l,T)}return[new i.$kt(c,f-c+1,e,n-e+1)]}x(c,f,e,n,r,h,g,D,o,d,l,T,N,R,I,j,$,O){let V=null,M=null,H=new b,C=f,G=e,Z=N[0]-j[0]-n,ce=-1073741824,re=this.k.length-1;do{const te=Z+c;te===C||te<G&&o[te-1]<o[te+1]?(l=o[te+1],R=l-Z-n,l<ce&&H.MarkNextChange(),ce=l,H.AddModifiedElement(l+1,R),Z=te+1-c):(l=o[te-1]+1,R=l-Z-n,l<ce&&H.MarkNextChange(),ce=l-1,H.AddOriginalElement(l,R+1),Z=te-1-c),re>=0&&(o=this.k[re],c=o[0],C=1,G=o.length-1)}while(--re>=-1);if(V=H.getReverseChanges(),O[0]){let te=N[0]+1,$e=j[0]+1;if(V!==null&&V.length>0){const De=V[V.length-1];te=Math.max(te,De.getOriginalEnd()),$e=Math.max($e,De.getModifiedEnd())}M=[new i.$kt(te,T-te+1,$e,I-$e+1)]}else{H=new b,C=h,G=g,Z=N[0]-j[0]-D,ce=1073741824,re=$?this.m.length-1:this.m.length-2;do{const te=Z+r;te===C||te<G&&d[te-1]>=d[te+1]?(l=d[te+1]-1,R=l-Z-D,l>ce&&H.MarkNextChange(),ce=l+1,H.AddOriginalElement(l+1,R+1),Z=te+1-r):(l=d[te-1],R=l-Z-D,l>ce&&H.MarkNextChange(),ce=l,H.AddModifiedElement(l+1,R+1),Z=te-1-r),re>=0&&(d=this.m[re],r=d[0],C=1,G=d.length-1)}while(--re>=-1);M=H.getChanges()}return this.H(V,M)}y(c,f,e,n,r,h,g){let D=0,o=0,d=0,l=0,T=0,N=0;c--,e--,r[0]=0,h[0]=0,this.k=[],this.m=[];const R=f-c+(n-e),I=R+1,j=new Int32Array(I),$=new Int32Array(I),O=n-e,V=f-c,M=c-e,H=f-n,G=(V-O)%2===0;j[O]=c,$[V]=f,g[0]=!1;for(let Z=1;Z<=R/2+1;Z++){let ce=0,re=0;d=this.J(O-Z,Z,O,I),l=this.J(O+Z,Z,O,I);for(let $e=d;$e<=l;$e+=2){$e===d||$e<l&&j[$e-1]<j[$e+1]?D=j[$e+1]:D=j[$e-1]+1,o=D-($e-O)-M;const De=D;for(;D<f&&o<n&&this.p(D+1,o+1);)D++,o++;if(j[$e]=D,D+o>ce+re&&(ce=D,re=o),!G&&Math.abs($e-V)<=Z-1&&D>=$[$e])return r[0]=D,h[0]=o,De<=$[$e]&&1447>0&&Z<=1448?this.x(O,d,l,M,V,T,N,H,j,$,D,f,r,o,n,h,G,g):null}const te=(ce-c+(re-e)-Z)/2;if(this.a!==null&&!this.a(ce,te))return g[0]=!0,r[0]=ce,h[0]=re,te>0&&1447>0&&Z<=1448?this.x(O,d,l,M,V,T,N,H,j,$,D,f,r,o,n,h,G,g):(c++,e++,[new i.$kt(c,f-c+1,e,n-e+1)]);T=this.J(V-Z,Z,V,I),N=this.J(V+Z,Z,V,I);for(let $e=T;$e<=N;$e+=2){$e===T||$e<N&&$[$e-1]>=$[$e+1]?D=$[$e+1]-1:D=$[$e-1],o=D-($e-V)-H;const De=D;for(;D>c&&o>e&&this.p(D,o);)D--,o--;if($[$e]=D,G&&Math.abs($e-O)<=Z&&D<=j[$e])return r[0]=D,h[0]=o,De>=j[$e]&&1447>0&&Z<=1448?this.x(O,d,l,M,V,T,N,H,j,$,D,f,r,o,n,h,G,g):null}if(Z<=1447){let $e=new Int32Array(l-d+2);$e[0]=O-d+1,A.Copy2(j,d,$e,1,l-d+1),this.k.push($e),$e=new Int32Array(N-T+2),$e[0]=V-T+1,A.Copy2($,T,$e,1,N-T+1),this.m.push($e)}}return this.x(O,d,l,M,V,T,N,H,j,$,D,f,r,o,n,h,G,g)}z(c){for(let f=0;f<c.length;f++){const e=c[f],n=f<c.length-1?c[f+1].originalStart:this.f.length,r=f<c.length-1?c[f+1].modifiedStart:this.h.length,h=e.originalLength>0,g=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<r&&(!h||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!g||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const D=[null];if(f<c.length-1&&this.I(c[f],c[f+1],D)){c[f]=D[0],c.splice(f+1,1),f--;continue}}for(let f=c.length-1;f>=0;f--){const e=c[f];let n=0,r=0;if(f>0){const l=c[f-1];n=l.originalStart+l.originalLength,r=l.modifiedStart+l.modifiedLength}const h=e.originalLength>0,g=e.modifiedLength>0;let D=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let l=1;;l++){const T=e.originalStart-l,N=e.modifiedStart-l;if(T<n||N<r||h&&!this.s(T,T+e.originalLength)||g&&!this.u(N,N+e.modifiedLength))break;const I=(T===n&&N===r?5:0)+this.G(T,e.originalLength,N,e.modifiedLength);I>o&&(o=I,D=l)}e.originalStart-=D,e.modifiedStart-=D;const d=[null];if(f>0&&this.I(c[f-1],c[f],d)){c[f-1]=d[0],c.splice(f,1),f++;continue}}if(this.d)for(let f=1,e=c.length;f<e;f++){const n=c[f-1],r=c[f],h=r.originalStart-n.originalStart-n.originalLength,g=n.originalStart,D=r.originalStart+r.originalLength,o=D-g,d=n.modifiedStart,l=r.modifiedStart+r.modifiedLength,T=l-d;if(h<5&&o<20&&T<20){const N=this.A(g,o,d,T,h);if(N){const[R,I]=N;(R!==n.originalStart+n.originalLength||I!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=R-n.originalStart,n.modifiedLength=I-n.modifiedStart,r.originalStart=R+h,r.modifiedStart=I+h,r.originalLength=D-r.originalStart,r.modifiedLength=l-r.modifiedStart)}}}return c}A(c,f,e,n,r){if(f<r||n<r)return null;const h=c+f-r+1,g=e+n-r+1;let D=0,o=0,d=0;for(let l=c;l<h;l++)for(let T=e;T<g;T++){const N=this.B(l,T,r);N>0&&N>D&&(D=N,o=l,d=T)}return D>0?[o,d]:null}B(c,f,e){let n=0;for(let r=0;r<e;r++){if(!this.p(c+r,f+r))return 0;n+=this.e[c+r].length}return n}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,f){if(this.C(c)||this.C(c-1))return!0;if(f>0){const e=c+f;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,f){if(this.E(c)||this.E(c-1))return!0;if(f>0){const e=c+f;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,f,e,n){const r=this.D(c,f)?1:0,h=this.F(e,n)?1:0;return r+h}H(c,f){const e=[];if(c.length===0||f.length===0)return f.length>0?f:c;if(this.I(c[c.length-1],f[0],e)){const n=new Array(c.length+f.length-1);return A.Copy(c,0,n,0,c.length-1),n[c.length-1]=e[0],A.Copy(f,1,n,c.length,f.length-1),n}else{const n=new Array(c.length+f.length);return A.Copy(c,0,n,0,c.length),A.Copy(f,0,n,c.length,f.length),n}}I(c,f,e){if(S.Assert(c.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),S.Assert(c.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=f.originalStart||c.modifiedStart+c.modifiedLength>=f.modifiedStart){const n=c.originalStart;let r=c.originalLength;const h=c.modifiedStart;let g=c.modifiedLength;return c.originalStart+c.originalLength>=f.originalStart&&(r=f.originalStart+f.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=f.modifiedStart&&(g=f.modifiedStart+f.modifiedLength-c.modifiedStart),e[0]=new i.$kt(n,r,h,g),!0}else return e[0]=null,!1}J(c,f,e,n){if(c>=0&&c<n)return c;const r=e,h=n-e-1,g=f%2===0;if(c<0){const D=r%2===0;return g===D?0:1}else{const D=h%2===0;return g===D?n-1:n-2}}}t.$nt=w}),define(ge[60],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9d=void 0,t.$9d=Symbol("MicrotaskDelay")}),define(ge[99],be([1,0,8,9]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ti=t.$si=t.$ri=t.$qi=t.$pi=void 0;class P{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const e=f.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$pi=P;class W{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,F.$kf)(f,this.b,0,f.length,this.c,this.d):(0,F.$mf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$qi=W;class S{constructor(f=!0,e=!0){this.f=f,this.g=e}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let e=f.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,F.$kf)(f,this.b,0,f.length,this.d,this.e):(0,F.$mf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$ri=S;var A;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(A||(A={}));class m{constructor(f,e){this.f=f,this.g=e,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,F.$lf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,F.$lf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,F.$jf)(f,this.c.query);if(this.d[this.e]===5)return(0,F.$jf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$si=m;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(w||(w={}));class B{static forUris(f=()=>!1,e=()=>!1){return new B(new m(f,e))}static forPaths(f=!1){return new B(new S(void 0,!f))}static forStrings(){return new B(new P)}static forConfigKeys(){return new B(new W)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,e){if(e){const n=e.slice(0);(0,i.$Xb)(n);for(const r of n)this.set(r,f)}else{const n=f.slice(0);(0,i.$Xb)(n);for(const r of n)this.set(r[0],r[1])}}set(f,e){const n=this.b.reset(f);let r;this.c||(this.c=new b,this.c.segment=n.value());const h=[];for(r=this.c;;){const D=n.cmp(r.segment);if(D>0)r.left||(r.left=new b,r.left.segment=n.value()),h.push([-1,r]),r=r.left;else if(D<0)r.right||(r.right=new b,r.right.segment=n.value()),h.push([1,r]),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new b,r.mid.segment=n.value()),h.push([0,r]),r=r.mid;else break}const g=r.value;r.value=e,r.key=f;for(let D=h.length-1;D>=0;D--){const o=h[D][1];o.updateHeight();const d=o.balanceFactor();if(d<-1||d>1){const l=h[D][0],T=h[D+1][0];if(l===1&&T===1)h[D][1]=o.rotateLeft();else if(l===-1&&T===-1)h[D][1]=o.rotateRight();else if(l===1&&T===-1)o.right=h[D+1][1]=h[D+1][1].rotateRight(),h[D][1]=o.rotateLeft();else if(l===-1&&T===1)o.left=h[D+1][1]=h[D+1][1].rotateLeft(),h[D][1]=o.rotateRight();else throw new Error;if(D>0)switch(h[D-1][0]){case-1:h[D-1][1].left=h[D][1];break;case 1:h[D-1][1].right=h[D][1];break;case 0:h[D-1][1].mid=h[D][1];break}else this.c=h[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const e=this.b.reset(f);let n=this.c;for(;n;){const r=e.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(f){const e=this.d(f);return!(e?.value===void 0&&e?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,e){const n=this.b.reset(f),r=[];let h=this.c;for(;h;){const g=n.cmp(h.segment);if(g>0)r.push([-1,h]),h=h.left;else if(g<0)r.push([1,h]),h=h.right;else if(n.hasNext())n.next(),r.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:D,value:o,segment:d}=g;this.e(g.key,!1),h.key=D,h.value=o,h.segment=d}}else{const g=h.left??h.right;if(r.length>0){const[D,o]=r[r.length-1];switch(D){case-1:o.left=g;break;case 0:o.mid=g;break;case 1:o.right=g;break}}else this.c=g}for(let g=r.length-1;g>=0;g--){const D=r[g][1];D.updateHeight();const o=D.balanceFactor();if(o>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),r[g][1]=D.rotateLeft()):o<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),r[g][1]=D.rotateRight()),g>0)switch(r[g-1][0]){case-1:r[g-1][1].left=r[g][1];break;case 1:r[g-1][1].right=r[g][1];break;case 0:r[g-1][1].mid=r[g][1];break}else this.c=r[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const e=this.b.reset(f);let n=this.c,r;for(;n;){const h=e.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(e.hasNext())e.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(f){return this.g(f,!1)}g(f,e){const n=this.b.reset(f);let r=this.c;for(;r;){const h=n.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else return r.mid?this.h(r.mid):e?r.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[e,n]of this)f(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const e=[];return this.j(f,e),e[Symbol.iterator]()}j(f,e){f&&(f.left&&this.j(f.left,e),f.value&&e.push([f.key,f.value]),f.mid&&this.j(f.mid,e),f.right&&this.j(f.right,e))}_isBalanced(){const f=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:f(e.left)&&f(e.right)};return f(this.c)}}t.$ti=B}),define(ge[10],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1f=i,t.$2f=F,t.$3f=P,t.$4f=W,t.$5f=S,t.$6f=A,t.$7f=m,t.$8f=b,t.$9f=w,t.$0f=B,t.$$f=c,t.$_f=f,t.$ag=e,t.$bg=r,t.$cg=h,t.$dg=g,t.$eg=D,t.$fg=o;function i(d){return typeof d=="string"}function F(d){return Array.isArray(d)&&d.every(l=>i(l))}function P(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function W(d){const l=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof l}function S(d){return typeof d=="number"&&!isNaN(d)}function A(d){return!!d&&typeof d[Symbol.iterator]=="function"}function m(d){return d===!0||d===!1}function b(d){return typeof d>"u"}function w(d){return!B(d)}function B(d){return b(d)||d===null}function c(d,l){if(!d)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}function f(d){if(B(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function e(...d){const l=[];for(let T=0;T<d.length;T++){const N=d[T];if(B(N))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);l.push(N)}return l}const n=Object.prototype.hasOwnProperty;function r(d){if(!P(d))return!1;for(const l in d)if(n.call(d,l))return!1;return!0}function h(d){return typeof d=="function"}function g(...d){return d.length>0&&d.every(h)}function D(d,l){const T=Math.min(d.length,l.length);for(let N=0;N<T;N++)o(d[N],l[N])}function o(d,l){if(i(l)){if(typeof d!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(h(l)){try{if(d instanceof l)return}catch{}if(!B(d)&&d.constructor===l||l.length===1&&l.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ge[45],be([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hj=P,t.$Ij=W;const F=Object.create(null);function P(S,A){if((0,i.$1f)(A)){const m=F[A];if(m===void 0)throw new Error(`${S} references an unknown codicon: ${A}`);A=m}return F[S]=A,{id:S}}function W(){return F}}),define(ge[100],be([1,0,45]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jj=void 0,t.$Jj={add:(0,i.$Hj)("add",6e4),plus:(0,i.$Hj)("plus",6e4),gistNew:(0,i.$Hj)("gist-new",6e4),repoCreate:(0,i.$Hj)("repo-create",6e4),lightbulb:(0,i.$Hj)("lightbulb",60001),lightBulb:(0,i.$Hj)("light-bulb",60001),repo:(0,i.$Hj)("repo",60002),repoDelete:(0,i.$Hj)("repo-delete",60002),gistFork:(0,i.$Hj)("gist-fork",60003),repoForked:(0,i.$Hj)("repo-forked",60003),gitPullRequest:(0,i.$Hj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Hj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Hj)("record-keys",60005),keyboard:(0,i.$Hj)("keyboard",60005),tag:(0,i.$Hj)("tag",60006),gitPullRequestLabel:(0,i.$Hj)("git-pull-request-label",60006),tagAdd:(0,i.$Hj)("tag-add",60006),tagRemove:(0,i.$Hj)("tag-remove",60006),person:(0,i.$Hj)("person",60007),personFollow:(0,i.$Hj)("person-follow",60007),personOutline:(0,i.$Hj)("person-outline",60007),personFilled:(0,i.$Hj)("person-filled",60007),gitBranch:(0,i.$Hj)("git-branch",60008),gitBranchCreate:(0,i.$Hj)("git-branch-create",60008),gitBranchDelete:(0,i.$Hj)("git-branch-delete",60008),sourceControl:(0,i.$Hj)("source-control",60008),mirror:(0,i.$Hj)("mirror",60009),mirrorPublic:(0,i.$Hj)("mirror-public",60009),star:(0,i.$Hj)("star",60010),starAdd:(0,i.$Hj)("star-add",60010),starDelete:(0,i.$Hj)("star-delete",60010),starEmpty:(0,i.$Hj)("star-empty",60010),comment:(0,i.$Hj)("comment",60011),commentAdd:(0,i.$Hj)("comment-add",60011),alert:(0,i.$Hj)("alert",60012),warning:(0,i.$Hj)("warning",60012),search:(0,i.$Hj)("search",60013),searchSave:(0,i.$Hj)("search-save",60013),logOut:(0,i.$Hj)("log-out",60014),signOut:(0,i.$Hj)("sign-out",60014),logIn:(0,i.$Hj)("log-in",60015),signIn:(0,i.$Hj)("sign-in",60015),eye:(0,i.$Hj)("eye",60016),eyeUnwatch:(0,i.$Hj)("eye-unwatch",60016),eyeWatch:(0,i.$Hj)("eye-watch",60016),circleFilled:(0,i.$Hj)("circle-filled",60017),primitiveDot:(0,i.$Hj)("primitive-dot",60017),closeDirty:(0,i.$Hj)("close-dirty",60017),debugBreakpoint:(0,i.$Hj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Hj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Hj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Hj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Hj)("primitive-square",60018),edit:(0,i.$Hj)("edit",60019),pencil:(0,i.$Hj)("pencil",60019),info:(0,i.$Hj)("info",60020),issueOpened:(0,i.$Hj)("issue-opened",60020),gistPrivate:(0,i.$Hj)("gist-private",60021),gitForkPrivate:(0,i.$Hj)("git-fork-private",60021),lock:(0,i.$Hj)("lock",60021),mirrorPrivate:(0,i.$Hj)("mirror-private",60021),close:(0,i.$Hj)("close",60022),removeClose:(0,i.$Hj)("remove-close",60022),x:(0,i.$Hj)("x",60022),repoSync:(0,i.$Hj)("repo-sync",60023),sync:(0,i.$Hj)("sync",60023),clone:(0,i.$Hj)("clone",60024),desktopDownload:(0,i.$Hj)("desktop-download",60024),beaker:(0,i.$Hj)("beaker",60025),microscope:(0,i.$Hj)("microscope",60025),vm:(0,i.$Hj)("vm",60026),deviceDesktop:(0,i.$Hj)("device-desktop",60026),file:(0,i.$Hj)("file",60027),fileText:(0,i.$Hj)("file-text",60027),more:(0,i.$Hj)("more",60028),ellipsis:(0,i.$Hj)("ellipsis",60028),kebabHorizontal:(0,i.$Hj)("kebab-horizontal",60028),mailReply:(0,i.$Hj)("mail-reply",60029),reply:(0,i.$Hj)("reply",60029),organization:(0,i.$Hj)("organization",60030),organizationFilled:(0,i.$Hj)("organization-filled",60030),organizationOutline:(0,i.$Hj)("organization-outline",60030),newFile:(0,i.$Hj)("new-file",60031),fileAdd:(0,i.$Hj)("file-add",60031),newFolder:(0,i.$Hj)("new-folder",60032),fileDirectoryCreate:(0,i.$Hj)("file-directory-create",60032),trash:(0,i.$Hj)("trash",60033),trashcan:(0,i.$Hj)("trashcan",60033),history:(0,i.$Hj)("history",60034),clock:(0,i.$Hj)("clock",60034),folder:(0,i.$Hj)("folder",60035),fileDirectory:(0,i.$Hj)("file-directory",60035),symbolFolder:(0,i.$Hj)("symbol-folder",60035),logoGithub:(0,i.$Hj)("logo-github",60036),markGithub:(0,i.$Hj)("mark-github",60036),github:(0,i.$Hj)("github",60036),terminal:(0,i.$Hj)("terminal",60037),console:(0,i.$Hj)("console",60037),repl:(0,i.$Hj)("repl",60037),zap:(0,i.$Hj)("zap",60038),symbolEvent:(0,i.$Hj)("symbol-event",60038),error:(0,i.$Hj)("error",60039),stop:(0,i.$Hj)("stop",60039),variable:(0,i.$Hj)("variable",60040),symbolVariable:(0,i.$Hj)("symbol-variable",60040),array:(0,i.$Hj)("array",60042),symbolArray:(0,i.$Hj)("symbol-array",60042),symbolModule:(0,i.$Hj)("symbol-module",60043),symbolPackage:(0,i.$Hj)("symbol-package",60043),symbolNamespace:(0,i.$Hj)("symbol-namespace",60043),symbolObject:(0,i.$Hj)("symbol-object",60043),symbolMethod:(0,i.$Hj)("symbol-method",60044),symbolFunction:(0,i.$Hj)("symbol-function",60044),symbolConstructor:(0,i.$Hj)("symbol-constructor",60044),symbolBoolean:(0,i.$Hj)("symbol-boolean",60047),symbolNull:(0,i.$Hj)("symbol-null",60047),symbolNumeric:(0,i.$Hj)("symbol-numeric",60048),symbolNumber:(0,i.$Hj)("symbol-number",60048),symbolStructure:(0,i.$Hj)("symbol-structure",60049),symbolStruct:(0,i.$Hj)("symbol-struct",60049),symbolParameter:(0,i.$Hj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Hj)("symbol-type-parameter",60050),symbolKey:(0,i.$Hj)("symbol-key",60051),symbolText:(0,i.$Hj)("symbol-text",60051),symbolReference:(0,i.$Hj)("symbol-reference",60052),goToFile:(0,i.$Hj)("go-to-file",60052),symbolEnum:(0,i.$Hj)("symbol-enum",60053),symbolValue:(0,i.$Hj)("symbol-value",60053),symbolRuler:(0,i.$Hj)("symbol-ruler",60054),symbolUnit:(0,i.$Hj)("symbol-unit",60054),activateBreakpoints:(0,i.$Hj)("activate-breakpoints",60055),archive:(0,i.$Hj)("archive",60056),arrowBoth:(0,i.$Hj)("arrow-both",60057),arrowDown:(0,i.$Hj)("arrow-down",60058),arrowLeft:(0,i.$Hj)("arrow-left",60059),arrowRight:(0,i.$Hj)("arrow-right",60060),arrowSmallDown:(0,i.$Hj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Hj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Hj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Hj)("arrow-small-up",60064),arrowUp:(0,i.$Hj)("arrow-up",60065),bell:(0,i.$Hj)("bell",60066),bold:(0,i.$Hj)("bold",60067),book:(0,i.$Hj)("book",60068),bookmark:(0,i.$Hj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Hj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Hj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Hj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Hj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Hj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Hj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Hj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Hj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Hj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Hj)("briefcase",60076),broadcast:(0,i.$Hj)("broadcast",60077),browser:(0,i.$Hj)("browser",60078),bug:(0,i.$Hj)("bug",60079),calendar:(0,i.$Hj)("calendar",60080),caseSensitive:(0,i.$Hj)("case-sensitive",60081),check:(0,i.$Hj)("check",60082),checklist:(0,i.$Hj)("checklist",60083),chevronDown:(0,i.$Hj)("chevron-down",60084),chevronLeft:(0,i.$Hj)("chevron-left",60085),chevronRight:(0,i.$Hj)("chevron-right",60086),chevronUp:(0,i.$Hj)("chevron-up",60087),chromeClose:(0,i.$Hj)("chrome-close",60088),chromeMaximize:(0,i.$Hj)("chrome-maximize",60089),chromeMinimize:(0,i.$Hj)("chrome-minimize",60090),chromeRestore:(0,i.$Hj)("chrome-restore",60091),circleOutline:(0,i.$Hj)("circle-outline",60092),circle:(0,i.$Hj)("circle",60092),debugBreakpointUnverified:(0,i.$Hj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Hj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Hj)("circle-slash",60093),circuitBoard:(0,i.$Hj)("circuit-board",60094),clearAll:(0,i.$Hj)("clear-all",60095),clippy:(0,i.$Hj)("clippy",60096),closeAll:(0,i.$Hj)("close-all",60097),cloudDownload:(0,i.$Hj)("cloud-download",60098),cloudUpload:(0,i.$Hj)("cloud-upload",60099),code:(0,i.$Hj)("code",60100),collapseAll:(0,i.$Hj)("collapse-all",60101),colorMode:(0,i.$Hj)("color-mode",60102),commentDiscussion:(0,i.$Hj)("comment-discussion",60103),creditCard:(0,i.$Hj)("credit-card",60105),dash:(0,i.$Hj)("dash",60108),dashboard:(0,i.$Hj)("dashboard",60109),database:(0,i.$Hj)("database",60110),debugContinue:(0,i.$Hj)("debug-continue",60111),debugDisconnect:(0,i.$Hj)("debug-disconnect",60112),debugPause:(0,i.$Hj)("debug-pause",60113),debugRestart:(0,i.$Hj)("debug-restart",60114),debugStart:(0,i.$Hj)("debug-start",60115),debugStepInto:(0,i.$Hj)("debug-step-into",60116),debugStepOut:(0,i.$Hj)("debug-step-out",60117),debugStepOver:(0,i.$Hj)("debug-step-over",60118),debugStop:(0,i.$Hj)("debug-stop",60119),debug:(0,i.$Hj)("debug",60120),deviceCameraVideo:(0,i.$Hj)("device-camera-video",60121),deviceCamera:(0,i.$Hj)("device-camera",60122),deviceMobile:(0,i.$Hj)("device-mobile",60123),diffAdded:(0,i.$Hj)("diff-added",60124),diffIgnored:(0,i.$Hj)("diff-ignored",60125),diffModified:(0,i.$Hj)("diff-modified",60126),diffRemoved:(0,i.$Hj)("diff-removed",60127),diffRenamed:(0,i.$Hj)("diff-renamed",60128),diff:(0,i.$Hj)("diff",60129),diffSidebyside:(0,i.$Hj)("diff-sidebyside",60129),discard:(0,i.$Hj)("discard",60130),editorLayout:(0,i.$Hj)("editor-layout",60131),emptyWindow:(0,i.$Hj)("empty-window",60132),exclude:(0,i.$Hj)("exclude",60133),extensions:(0,i.$Hj)("extensions",60134),eyeClosed:(0,i.$Hj)("eye-closed",60135),fileBinary:(0,i.$Hj)("file-binary",60136),fileCode:(0,i.$Hj)("file-code",60137),fileMedia:(0,i.$Hj)("file-media",60138),filePdf:(0,i.$Hj)("file-pdf",60139),fileSubmodule:(0,i.$Hj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Hj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Hj)("file-symlink-file",60142),fileZip:(0,i.$Hj)("file-zip",60143),files:(0,i.$Hj)("files",60144),filter:(0,i.$Hj)("filter",60145),flame:(0,i.$Hj)("flame",60146),foldDown:(0,i.$Hj)("fold-down",60147),foldUp:(0,i.$Hj)("fold-up",60148),fold:(0,i.$Hj)("fold",60149),folderActive:(0,i.$Hj)("folder-active",60150),folderOpened:(0,i.$Hj)("folder-opened",60151),gear:(0,i.$Hj)("gear",60152),gift:(0,i.$Hj)("gift",60153),gistSecret:(0,i.$Hj)("gist-secret",60154),gist:(0,i.$Hj)("gist",60155),gitCommit:(0,i.$Hj)("git-commit",60156),gitCompare:(0,i.$Hj)("git-compare",60157),compareChanges:(0,i.$Hj)("compare-changes",60157),gitMerge:(0,i.$Hj)("git-merge",60158),githubAction:(0,i.$Hj)("github-action",60159),githubAlt:(0,i.$Hj)("github-alt",60160),globe:(0,i.$Hj)("globe",60161),grabber:(0,i.$Hj)("grabber",60162),graph:(0,i.$Hj)("graph",60163),gripper:(0,i.$Hj)("gripper",60164),heart:(0,i.$Hj)("heart",60165),home:(0,i.$Hj)("home",60166),horizontalRule:(0,i.$Hj)("horizontal-rule",60167),hubot:(0,i.$Hj)("hubot",60168),inbox:(0,i.$Hj)("inbox",60169),issueReopened:(0,i.$Hj)("issue-reopened",60171),issues:(0,i.$Hj)("issues",60172),italic:(0,i.$Hj)("italic",60173),jersey:(0,i.$Hj)("jersey",60174),json:(0,i.$Hj)("json",60175),kebabVertical:(0,i.$Hj)("kebab-vertical",60176),key:(0,i.$Hj)("key",60177),law:(0,i.$Hj)("law",60178),lightbulbAutofix:(0,i.$Hj)("lightbulb-autofix",60179),linkExternal:(0,i.$Hj)("link-external",60180),link:(0,i.$Hj)("link",60181),listOrdered:(0,i.$Hj)("list-ordered",60182),listUnordered:(0,i.$Hj)("list-unordered",60183),liveShare:(0,i.$Hj)("live-share",60184),loading:(0,i.$Hj)("loading",60185),location:(0,i.$Hj)("location",60186),mailRead:(0,i.$Hj)("mail-read",60187),mail:(0,i.$Hj)("mail",60188),markdown:(0,i.$Hj)("markdown",60189),megaphone:(0,i.$Hj)("megaphone",60190),mention:(0,i.$Hj)("mention",60191),milestone:(0,i.$Hj)("milestone",60192),gitPullRequestMilestone:(0,i.$Hj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Hj)("mortar-board",60193),move:(0,i.$Hj)("move",60194),multipleWindows:(0,i.$Hj)("multiple-windows",60195),mute:(0,i.$Hj)("mute",60196),noNewline:(0,i.$Hj)("no-newline",60197),note:(0,i.$Hj)("note",60198),octoface:(0,i.$Hj)("octoface",60199),openPreview:(0,i.$Hj)("open-preview",60200),package:(0,i.$Hj)("package",60201),paintcan:(0,i.$Hj)("paintcan",60202),pin:(0,i.$Hj)("pin",60203),play:(0,i.$Hj)("play",60204),run:(0,i.$Hj)("run",60204),plug:(0,i.$Hj)("plug",60205),preserveCase:(0,i.$Hj)("preserve-case",60206),preview:(0,i.$Hj)("preview",60207),project:(0,i.$Hj)("project",60208),pulse:(0,i.$Hj)("pulse",60209),question:(0,i.$Hj)("question",60210),quote:(0,i.$Hj)("quote",60211),radioTower:(0,i.$Hj)("radio-tower",60212),reactions:(0,i.$Hj)("reactions",60213),references:(0,i.$Hj)("references",60214),refresh:(0,i.$Hj)("refresh",60215),regex:(0,i.$Hj)("regex",60216),remoteExplorer:(0,i.$Hj)("remote-explorer",60217),remote:(0,i.$Hj)("remote",60218),remove:(0,i.$Hj)("remove",60219),replaceAll:(0,i.$Hj)("replace-all",60220),replace:(0,i.$Hj)("replace",60221),repoClone:(0,i.$Hj)("repo-clone",60222),repoForcePush:(0,i.$Hj)("repo-force-push",60223),repoPull:(0,i.$Hj)("repo-pull",60224),repoPush:(0,i.$Hj)("repo-push",60225),report:(0,i.$Hj)("report",60226),requestChanges:(0,i.$Hj)("request-changes",60227),rocket:(0,i.$Hj)("rocket",60228),rootFolderOpened:(0,i.$Hj)("root-folder-opened",60229),rootFolder:(0,i.$Hj)("root-folder",60230),rss:(0,i.$Hj)("rss",60231),ruby:(0,i.$Hj)("ruby",60232),saveAll:(0,i.$Hj)("save-all",60233),saveAs:(0,i.$Hj)("save-as",60234),save:(0,i.$Hj)("save",60235),screenFull:(0,i.$Hj)("screen-full",60236),screenNormal:(0,i.$Hj)("screen-normal",60237),searchStop:(0,i.$Hj)("search-stop",60238),server:(0,i.$Hj)("server",60240),settingsGear:(0,i.$Hj)("settings-gear",60241),settings:(0,i.$Hj)("settings",60242),shield:(0,i.$Hj)("shield",60243),smiley:(0,i.$Hj)("smiley",60244),sortPrecedence:(0,i.$Hj)("sort-precedence",60245),splitHorizontal:(0,i.$Hj)("split-horizontal",60246),splitVertical:(0,i.$Hj)("split-vertical",60247),squirrel:(0,i.$Hj)("squirrel",60248),starFull:(0,i.$Hj)("star-full",60249),starHalf:(0,i.$Hj)("star-half",60250),symbolClass:(0,i.$Hj)("symbol-class",60251),symbolColor:(0,i.$Hj)("symbol-color",60252),symbolConstant:(0,i.$Hj)("symbol-constant",60253),symbolEnumMember:(0,i.$Hj)("symbol-enum-member",60254),symbolField:(0,i.$Hj)("symbol-field",60255),symbolFile:(0,i.$Hj)("symbol-file",60256),symbolInterface:(0,i.$Hj)("symbol-interface",60257),symbolKeyword:(0,i.$Hj)("symbol-keyword",60258),symbolMisc:(0,i.$Hj)("symbol-misc",60259),symbolOperator:(0,i.$Hj)("symbol-operator",60260),symbolProperty:(0,i.$Hj)("symbol-property",60261),wrench:(0,i.$Hj)("wrench",60261),wrenchSubaction:(0,i.$Hj)("wrench-subaction",60261),symbolSnippet:(0,i.$Hj)("symbol-snippet",60262),tasklist:(0,i.$Hj)("tasklist",60263),telescope:(0,i.$Hj)("telescope",60264),textSize:(0,i.$Hj)("text-size",60265),threeBars:(0,i.$Hj)("three-bars",60266),thumbsdown:(0,i.$Hj)("thumbsdown",60267),thumbsup:(0,i.$Hj)("thumbsup",60268),tools:(0,i.$Hj)("tools",60269),triangleDown:(0,i.$Hj)("triangle-down",60270),triangleLeft:(0,i.$Hj)("triangle-left",60271),triangleRight:(0,i.$Hj)("triangle-right",60272),triangleUp:(0,i.$Hj)("triangle-up",60273),twitter:(0,i.$Hj)("twitter",60274),unfold:(0,i.$Hj)("unfold",60275),unlock:(0,i.$Hj)("unlock",60276),unmute:(0,i.$Hj)("unmute",60277),unverified:(0,i.$Hj)("unverified",60278),verified:(0,i.$Hj)("verified",60279),versions:(0,i.$Hj)("versions",60280),vmActive:(0,i.$Hj)("vm-active",60281),vmOutline:(0,i.$Hj)("vm-outline",60282),vmRunning:(0,i.$Hj)("vm-running",60283),watch:(0,i.$Hj)("watch",60284),whitespace:(0,i.$Hj)("whitespace",60285),wholeWord:(0,i.$Hj)("whole-word",60286),window:(0,i.$Hj)("window",60287),wordWrap:(0,i.$Hj)("word-wrap",60288),zoomIn:(0,i.$Hj)("zoom-in",60289),zoomOut:(0,i.$Hj)("zoom-out",60290),listFilter:(0,i.$Hj)("list-filter",60291),listFlat:(0,i.$Hj)("list-flat",60292),listSelection:(0,i.$Hj)("list-selection",60293),selection:(0,i.$Hj)("selection",60293),listTree:(0,i.$Hj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Hj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Hj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Hj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Hj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Hj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Hj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Hj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Hj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Hj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Hj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Hj)("symbol-string",60301),debugReverseContinue:(0,i.$Hj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Hj)("debug-step-back",60303),debugRestartFrame:(0,i.$Hj)("debug-restart-frame",60304),debugAlt:(0,i.$Hj)("debug-alt",60305),callIncoming:(0,i.$Hj)("call-incoming",60306),callOutgoing:(0,i.$Hj)("call-outgoing",60307),menu:(0,i.$Hj)("menu",60308),expandAll:(0,i.$Hj)("expand-all",60309),feedback:(0,i.$Hj)("feedback",60310),gitPullRequestReviewer:(0,i.$Hj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Hj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Hj)("ungroup-by-ref-type",60312),account:(0,i.$Hj)("account",60313),gitPullRequestAssignee:(0,i.$Hj)("git-pull-request-assignee",60313),bellDot:(0,i.$Hj)("bell-dot",60314),debugConsole:(0,i.$Hj)("debug-console",60315),library:(0,i.$Hj)("library",60316),output:(0,i.$Hj)("output",60317),runAll:(0,i.$Hj)("run-all",60318),syncIgnored:(0,i.$Hj)("sync-ignored",60319),pinned:(0,i.$Hj)("pinned",60320),githubInverted:(0,i.$Hj)("github-inverted",60321),serverProcess:(0,i.$Hj)("server-process",60322),serverEnvironment:(0,i.$Hj)("server-environment",60323),pass:(0,i.$Hj)("pass",60324),issueClosed:(0,i.$Hj)("issue-closed",60324),stopCircle:(0,i.$Hj)("stop-circle",60325),playCircle:(0,i.$Hj)("play-circle",60326),record:(0,i.$Hj)("record",60327),debugAltSmall:(0,i.$Hj)("debug-alt-small",60328),vmConnect:(0,i.$Hj)("vm-connect",60329),cloud:(0,i.$Hj)("cloud",60330),merge:(0,i.$Hj)("merge",60331),export:(0,i.$Hj)("export",60332),graphLeft:(0,i.$Hj)("graph-left",60333),magnet:(0,i.$Hj)("magnet",60334),notebook:(0,i.$Hj)("notebook",60335),redo:(0,i.$Hj)("redo",60336),checkAll:(0,i.$Hj)("check-all",60337),pinnedDirty:(0,i.$Hj)("pinned-dirty",60338),passFilled:(0,i.$Hj)("pass-filled",60339),circleLargeFilled:(0,i.$Hj)("circle-large-filled",60340),circleLarge:(0,i.$Hj)("circle-large",60341),circleLargeOutline:(0,i.$Hj)("circle-large-outline",60341),combine:(0,i.$Hj)("combine",60342),gather:(0,i.$Hj)("gather",60342),table:(0,i.$Hj)("table",60343),variableGroup:(0,i.$Hj)("variable-group",60344),typeHierarchy:(0,i.$Hj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Hj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Hj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Hj)("git-pull-request-create",60348),runAbove:(0,i.$Hj)("run-above",60349),runBelow:(0,i.$Hj)("run-below",60350),notebookTemplate:(0,i.$Hj)("notebook-template",60351),debugRerun:(0,i.$Hj)("debug-rerun",60352),workspaceTrusted:(0,i.$Hj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Hj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Hj)("workspace-unknown",60355),terminalCmd:(0,i.$Hj)("terminal-cmd",60356),terminalDebian:(0,i.$Hj)("terminal-debian",60357),terminalLinux:(0,i.$Hj)("terminal-linux",60358),terminalPowershell:(0,i.$Hj)("terminal-powershell",60359),terminalTmux:(0,i.$Hj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Hj)("terminal-ubuntu",60361),terminalBash:(0,i.$Hj)("terminal-bash",60362),arrowSwap:(0,i.$Hj)("arrow-swap",60363),copy:(0,i.$Hj)("copy",60364),personAdd:(0,i.$Hj)("person-add",60365),filterFilled:(0,i.$Hj)("filter-filled",60366),wand:(0,i.$Hj)("wand",60367),debugLineByLine:(0,i.$Hj)("debug-line-by-line",60368),inspect:(0,i.$Hj)("inspect",60369),layers:(0,i.$Hj)("layers",60370),layersDot:(0,i.$Hj)("layers-dot",60371),layersActive:(0,i.$Hj)("layers-active",60372),compass:(0,i.$Hj)("compass",60373),compassDot:(0,i.$Hj)("compass-dot",60374),compassActive:(0,i.$Hj)("compass-active",60375),azure:(0,i.$Hj)("azure",60376),issueDraft:(0,i.$Hj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Hj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Hj)("git-pull-request-draft",60379),debugAll:(0,i.$Hj)("debug-all",60380),debugCoverage:(0,i.$Hj)("debug-coverage",60381),runErrors:(0,i.$Hj)("run-errors",60382),folderLibrary:(0,i.$Hj)("folder-library",60383),debugContinueSmall:(0,i.$Hj)("debug-continue-small",60384),beakerStop:(0,i.$Hj)("beaker-stop",60385),graphLine:(0,i.$Hj)("graph-line",60386),graphScatter:(0,i.$Hj)("graph-scatter",60387),pieChart:(0,i.$Hj)("pie-chart",60388),bracket:(0,i.$Hj)("bracket",60175),bracketDot:(0,i.$Hj)("bracket-dot",60389),bracketError:(0,i.$Hj)("bracket-error",60390),lockSmall:(0,i.$Hj)("lock-small",60391),azureDevops:(0,i.$Hj)("azure-devops",60392),verifiedFilled:(0,i.$Hj)("verified-filled",60393),newline:(0,i.$Hj)("newline",60394),layout:(0,i.$Hj)("layout",60395),layoutActivitybarLeft:(0,i.$Hj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Hj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Hj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Hj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Hj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Hj)("layout-panel-right",60401),layoutPanel:(0,i.$Hj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Hj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Hj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Hj)("layout-statusbar",60405),layoutMenubar:(0,i.$Hj)("layout-menubar",60406),layoutCentered:(0,i.$Hj)("layout-centered",60407),target:(0,i.$Hj)("target",60408),indent:(0,i.$Hj)("indent",60409),recordSmall:(0,i.$Hj)("record-small",60410),errorSmall:(0,i.$Hj)("error-small",60411),terminalDecorationError:(0,i.$Hj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Hj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Hj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Hj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Hj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Hj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Hj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Hj)("layout-sidebar-left-off",60418),blank:(0,i.$Hj)("blank",60419),heartFilled:(0,i.$Hj)("heart-filled",60420),map:(0,i.$Hj)("map",60421),mapHorizontal:(0,i.$Hj)("map-horizontal",60421),foldHorizontal:(0,i.$Hj)("fold-horizontal",60421),mapFilled:(0,i.$Hj)("map-filled",60422),mapHorizontalFilled:(0,i.$Hj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Hj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Hj)("circle-small",60423),bellSlash:(0,i.$Hj)("bell-slash",60424),bellSlashDot:(0,i.$Hj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Hj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Hj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Hj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Hj)("search-fuzzy",60429),commentDraft:(0,i.$Hj)("comment-draft",60430),send:(0,i.$Hj)("send",60431),sparkle:(0,i.$Hj)("sparkle",60432),insert:(0,i.$Hj)("insert",60433),mic:(0,i.$Hj)("mic",60434),thumbsdownFilled:(0,i.$Hj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Hj)("thumbsup-filled",60436),coffee:(0,i.$Hj)("coffee",60437),snake:(0,i.$Hj)("snake",60438),game:(0,i.$Hj)("game",60439),vr:(0,i.$Hj)("vr",60440),chip:(0,i.$Hj)("chip",60441),piano:(0,i.$Hj)("piano",60442),music:(0,i.$Hj)("music",60443),micFilled:(0,i.$Hj)("mic-filled",60444),repoFetch:(0,i.$Hj)("repo-fetch",60445),copilot:(0,i.$Hj)("copilot",60446),lightbulbSparkle:(0,i.$Hj)("lightbulb-sparkle",60447),robot:(0,i.$Hj)("robot",60448),sparkleFilled:(0,i.$Hj)("sparkle-filled",60449),diffSingle:(0,i.$Hj)("diff-single",60450),diffMultiple:(0,i.$Hj)("diff-multiple",60451),surroundWith:(0,i.$Hj)("surround-with",60452),share:(0,i.$Hj)("share",60453),gitStash:(0,i.$Hj)("git-stash",60454),gitStashApply:(0,i.$Hj)("git-stash-apply",60455),gitStashPop:(0,i.$Hj)("git-stash-pop",60456),vscode:(0,i.$Hj)("vscode",60457),vscodeInsiders:(0,i.$Hj)("vscode-insiders",60458),codeOss:(0,i.$Hj)("code-oss",60459),runCoverage:(0,i.$Hj)("run-coverage",60460),runAllCoverage:(0,i.$Hj)("run-all-coverage",60461),coverage:(0,i.$Hj)("coverage",60462),githubProject:(0,i.$Hj)("github-project",60463),mapVertical:(0,i.$Hj)("map-vertical",60464),foldVertical:(0,i.$Hj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Hj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Hj)("fold-vertical-filled",60465)}}),define(ge[18],be([1,0,45,100]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mj=t.$Lj=void 0,t.$Kj=P;function P(){return Object.values(t.$Mj)}t.$Lj={dialogError:(0,i.$Hj)("dialog-error","error"),dialogWarning:(0,i.$Hj)("dialog-warning","warning"),dialogInfo:(0,i.$Hj)("dialog-info","info"),dialogClose:(0,i.$Hj)("dialog-close","close"),treeItemExpanded:(0,i.$Hj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Hj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Hj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Hj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Hj)("tree-item-loading","loading"),menuSelection:(0,i.$Hj)("menu-selection","check"),menuSubmenu:(0,i.$Hj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Hj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Hj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Hj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Hj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Hj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Hj)("toolbar-more","more"),quickInputBack:(0,i.$Hj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Hj)("drop-down-button",60084),symbolCustomColor:(0,i.$Hj)("symbol-customcolor",60252),exportIcon:(0,i.$Hj)("export",60332),workspaceUnspecified:(0,i.$Hj)("workspace-unspecified",60355),newLine:(0,i.$Hj)("newline",60394),thumbsDownFilled:(0,i.$Hj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Hj)("thumbsup-filled",60436),gitFetch:(0,i.$Hj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Hj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Hj)("debug-breakpoint-pending",60377)},t.$Mj={...F.$Jj,...t.$Lj}}),define(ge[61],be([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tn=F,t.$Un=P,t.$Vn=S,t.$Wn=m,t.$Xn=b,t.$Yn=w,t.$Zn=B,t.$1n=c,t.$2n=f,t.$3n=e,t.$4n=n,t.$5n=r;function F(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([D,o])=>{g[D]=o&&typeof o=="object"?F(o):o}),g}function P(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const D=g.shift();Object.freeze(D);for(const o in D)if(W.call(D,o)){const d=D[o];typeof d=="object"&&!Object.isFrozen(d)&&!(0,i.$4f)(d)&&g.push(d)}}return h}const W=Object.prototype.hasOwnProperty;function S(h,g){return A(h,g,new Set)}function A(h,g,D){if((0,i.$0f)(h))return h;const o=g(h);if(typeof o<"u")return o;if(Array.isArray(h)){const d=[];for(const l of h)d.push(A(l,g,D));return d}if((0,i.$3f)(h)){if(D.has(h))throw new Error("Cannot clone recursive data-structure");D.add(h);const d={};for(const l in h)W.call(h,l)&&(d[l]=A(h[l],g,D));return D.delete(h),d}return h}function m(h,g,D=!0){return(0,i.$3f)(h)?((0,i.$3f)(g)&&Object.keys(g).forEach(o=>{o in h?D&&((0,i.$3f)(h[o])&&(0,i.$3f)(g[o])?m(h[o],g[o],D):h[o]=g[o]):h[o]=g[o]}),h):g}function b(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let D,o;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(D=0;D<h.length;D++)if(!b(h[D],g[D]))return!1}else{const d=[];for(o in h)d.push(o);d.sort();const l=[];for(o in g)l.push(o);if(l.sort(),!b(d,l))return!1;for(D=0;D<d.length;D++)if(!b(h[d[D]],g[d[D]]))return!1}return!0}function w(h){const g=new Set;return JSON.stringify(h,(D,o)=>{if((0,i.$3f)(o)||Array.isArray(o)){if(g.has(o))return"[Circular]";g.add(o)}return o})}function B(h,g){const D=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const l=h[d],T=g[d];b(l,T)||(D[d]=T)}),D}function c(h,g){const D=g.toLowerCase(),o=Object.keys(h).find(d=>d.toLowerCase()===D);return o?h[o]:h[g]}function f(h,g){const D=Object.create(null);for(const[o,d]of Object.entries(h))g(o,d)&&(D[o]=d);return D}function e(h){let g=[];for(;Object.prototype!==h;)g=g.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return g}function n(h){const g=[];for(const D of e(h))typeof h[D]=="function"&&g.push(D);return g}function r(h,g){const D=d=>function(){const l=Array.prototype.slice.call(arguments,0);return g(d,l)},o={};for(const d of h)o[d]=D(d);return o}}),define(ge[19],be([1,0,18]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Nj=P;var F;(function(S){function A(m){return m&&typeof m=="object"&&typeof m.id=="string"}S.isThemeColor=A})(F||(t.ThemeColor=F={}));function P(S){return{id:S}}var W;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function m(g){const D=A.exec(g.id);if(!D)return m(i.$Mj.error);const[,o,d]=D,l=["codicon","codicon-"+o];return d&&l.push("codicon-modifier-"+d.substring(1)),l}S.asClassNameArray=m;function b(g){return m(g).join(" ")}S.asClassName=b;function w(g){return"."+m(g).join(".")}S.asCSSSelector=w;function B(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||F.isThemeColor(g.color))}S.isThemeIcon=B;const c=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function f(g){const D=c.exec(g);if(!D)return;const[,o]=D;return{id:o}}S.fromString=f;function e(g){return{id:g}}S.fromId=e;function n(g,D){let o=g.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),D&&(o=`${o}~${D}`),{id:o}}S.modify=n;function r(g){const D=g.id.lastIndexOf("~");if(D!==-1)return g.id.substring(D+1)}S.getModifier=r;function h(g,D){return g.id===D.id&&g.color?.id===D.color?.id}S.isEqual=h})(W||(t.ThemeIcon=W={}))}),define(ge[62],be([1,0,44,9,19]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ek=m,t.$Fk=w,t.$Gk=c,t.$Hk=f,t.$Ik=n,t.$Jk=r;const W="$(",S=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function m(h){return h.replace(A,(g,D)=>D?g:`\\${g}`)}const b=new RegExp(`\\\\${S.source}`,"g");function w(h){return h.replace(b,g=>`\\${g}`)}const B=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function c(h){return h.indexOf(W)===-1?h:h.replace(B,(g,D,o,d)=>o?g:D||d||"")}function f(h){return h?h.replace(/\$\((.*?)\)/g,(g,D)=>` ${D} `).trim():""}const e=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(h){e.lastIndex=0;let g="";const D=[];let o=0;for(;;){const d=e.lastIndex,l=e.exec(h),T=h.substring(d,l?.index);if(T.length>0){g+=T;for(let N=0;N<T.length;N++)D.push(o)}if(!l)break;o+=l[0].length}return{text:g,iconOffsets:D}}function r(h,g,D=!1){const{text:o,iconOffsets:d}=g;if(!d||d.length===0)return(0,i.$vk)(h,o,D);const l=(0,F.$0e)(o," "),T=o.length-l.length,N=(0,i.$vk)(h,l,D);if(N)for(const R of N){const I=d[R.start+T]+T;R.start+=I,R.end+=I}return N}}),define(ge[101],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iW=t.$hW=void 0,t.$hW="vscode:contextmenu",t.$iW="vscode:onCloseContextMenu"}),define(ge[102],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pW=void 0;class i{constructor(P,W){this.a=P,this.onMessage=W}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$pW=i}),define(ge[35],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(ge[103],be([1,0,101,35]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lW=W;let P=0;function W(A,m,b){const w=[],B=P++,c=`vscode:onContextMenu${B}`,f=(e,n,r)=>{w[n].click?.(r)};F.$O.once(c,f),F.$O.once(i.$iW,(e,n)=>{n===B&&(F.$O.removeListener(c,f),b?.())}),F.$O.send(i.$hW,B,A.map(e=>S(e,w)),c,m)}function S(A,m){const b={id:m.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return m.push(A),Array.isArray(A.submenu)&&(b.submenu=A.submenu.map(w=>S(w,m))),b}}),define(ge[63],be([7]),{}),define(ge[104],be([7]),{}),define(ge[105],be([7]),{}),define(ge[106],be([7]),{}),define(ge[107],be([1,0,105,106]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[108],be([7]),{}),define(ge[109],be([7]),{}),define(ge[110],be([7]),{}),define(ge[111],be([7]),{}),define(ge[112],be([7]),{}),define(ge[113],be([7]),{}),define(ge[114],be([7]),{}),define(ge[115],be([7]),{}),define(ge[116],be([7]),{}),define(ge[117],be([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[118],be([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[119],be([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[120],be([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[121],be([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[122],be([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[123],be([13,12]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define(ge[46],be([1,0,3,2,123]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9i=t.$8i=t.$7i=t.$6i=t.$5i=void 0,t.$0i=w;class W extends F.$Uc{constructor(c,f="",e="",n=!0,r){super(),this.h=this.B(new i.$_d),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=f,this.u=e,this.w=n,this.C=r}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,f){this.C&&await this.C(c)}}t.$5i=W;class S extends F.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$_d),this.onWillRun=this.f.event,this.m=this.B(new i.$_d),this.onDidRun=this.m.event}async run(c,f){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,f)}catch(n){e=n}this.m.fire({action:c,error:e})}async u(c,f){await c.run(f)}}t.$6i=S;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let f=[];for(const e of c)e.length&&(f.length?f=[...f,new A,...e]:f=e);return f}static{this.ID="vs.actions.separator"}async run(){}}t.$7i=A;class m{get actions(){return this.a}constructor(c,f,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=f,this.class=n,this.a=e}async run(){}}t.$8i=m;class b extends W{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,P.localize(0,null),void 0,!1)}}t.$9i=b;function w(B){return{id:B.id,label:B.label,class:B.class,enabled:B.enabled??!0,checked:B.checked,run:async(...c)=>B.run(...c),tooltip:B.label}}}),define(ge[124],be([13,12]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define(ge[5],be([1,0,124]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=T,t.$D=O,t.$J=V,t.$g="en";let F=!1,P=!1,W=!1,S=!1,A=!1,m=!1,b=!1,w=!1,B=!1,c=!1,f,e=t.$g,n=t.$g,r,h;const g=globalThis;let D;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?D=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(D=process);const o=typeof D?.versions?.electron=="string",d=o&&D?.type==="renderer";if(typeof D=="object"){F=D.platform==="win32",P=D.platform==="darwin",W=D.platform==="linux",S=W&&!!D.env.SNAP&&!!D.env.SNAP_REVISION,b=o,B=!!D.env.CI||!!D.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$g,e=t.$g;const M=D.env.VSCODE_NLS_CONFIG;if(M)try{const H=JSON.parse(M),C=H.availableLanguages["*"];f=H.locale,n=H.osLocale,e=C||t.$g,r=H._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!d?(h=navigator.userAgent,F=h.indexOf("Windows")>=0,P=h.indexOf("Macintosh")>=0,w=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=h.indexOf("Linux")>=0,c=h?.indexOf("Mobi")>=0,m=!0,f=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=f,n=navigator.language):console.error("Unable to resolve platform.");var l;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(l||(t.Platform=l={}));function T(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let N=0;P?N=1:F?N=3:W&&(N=2),t.$i=F,t.$j=P,t.$k=W,t.$l=S,t.$m=A,t.$n=b,t.$o=m,t.$p=m&&typeof g.importScripts=="function",t.$q=t.$p?g.origin:void 0,t.$r=w,t.$s=c,t.$t=B,t.$u=N,t.$v=h,t.$w=e;var R;(function(M){function H(){return t.$w}M.value=H;function C(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}M.isDefaultVariant=C;function G(){return t.$w==="en"}M.isDefault=G})(R||(t.Language=R={})),t.$x=f,t.$y=n,t.$z=r,t.$A=typeof g.postMessage=="function"&&!g.importScripts,t.$B=(()=>{if(t.$A){const M=[];g.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let G=0,Z=M.length;G<Z;G++){const ce=M[G];if(ce.id===C.data.vscodeScheduleAsyncWork){M.splice(G,1),ce.callback();return}}});let H=0;return C=>{const G=++H;M.push({id:G,callback:C}),g.postMessage({vscodeScheduleAsyncWork:G},"*")}}return M=>setTimeout(M)})();var I;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=P||w?2:F?1:3;let j=!0,$=!1;function O(){if(!$){$=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,j=new Uint16Array(M.buffer)[0]===513}return j}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function V(M){return parseFloat(M)>=20}}),define(ge[125],be([1,0,17,22,5]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=t.KeyboardSupport=void 0;var W;(function(S){S[S.Always=0]="Always",S[S.FullScreen=1]="FullScreen",S[S.None=2]="None"})(W||(t.KeyboardSupport=W={})),t.$aR={clipboard:{writeText:P.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:P.$m||i.$$Q()?0:navigator.keyboard||i.$7Q?1:2,touch:"ontouchstart"in F.$RQ||navigator.maxTouchPoints>0,pointerEvents:F.$RQ.PointerEvent&&("ontouchstart"in F.$RQ||navigator.maxTouchPoints>0)}}),define(ge[15],be([1,0,17,54,87,5]),function(ne,t,i,F,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=void 0,t.$gR=B,t.$hR=c;function S(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return F.KeyCodeUtils.fromString(r)}const n=e.keyCode;if(n===3)return 7;if(i.$4Q)switch(n){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(i.$5Q){if(W.$j&&n===93)return 57;if(!W.$j&&n===92)return 57}return F.$or[n]||0}const A=W.$j?256:2048,m=512,b=1024,w=W.$j?2048:256;function B(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${F.KeyCodeUtils.toString(e.keyCode)}')`}class f{constructor(n){this._standardKeyboardEventBrand=!0;const r=n;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=S(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let r=0;return this.ctrlKey&&(r|=A),this.altKey&&(r|=m),this.shiftKey&&(r|=b),this.metaKey&&(r|=w),r|=n,r}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new P.$wr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$iR=f}),define(ge[20],be([1,0,17,79,5]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=t.$eR=t.$dR=void 0;class W{constructor(b,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const B=F.$bR.getPositionOfChildWindowRelativeToAncestorWindow(b,w.view);this.posx-=B.left,this.posy-=B.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$dR=W;class S extends W{constructor(b,w){super(b,w),this.dataTransfer=w.dataTransfer}}t.$eR=S;class A{constructor(b,w=0,B=0){this.browserEvent=b||null,this.target=b?b.target||b.targetNode||b.srcElement:null,this.deltaY=B,this.deltaX=w;let c=!1;if(i.$6Q){const f=navigator.userAgent.match(/Chrome\/(\d+)/);c=(f?parseInt(f[1]):123)<=122}if(b){const f=b,e=b,n=b.view?.devicePixelRatio||1;if(typeof f.wheelDeltaY<"u")c?this.deltaY=f.wheelDeltaY/(120*n):this.deltaY=f.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?i.$4Q&&!P.$j?this.deltaY=-b.deltaY/3:this.deltaY=-b.deltaY:this.deltaY=-b.deltaY/40}if(typeof f.wheelDeltaX<"u")i.$7Q&&P.$i?this.deltaX=-(f.wheelDeltaX/120):c?this.deltaX=f.wheelDeltaX/(120*n):this.deltaX=f.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-b.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?i.$4Q&&!P.$j?this.deltaX=-b.deltaX/3:this.deltaX=-b.deltaX:this.deltaX=-b.deltaX/40}this.deltaY===0&&this.deltaX===0&&b.wheelDelta&&(c?this.deltaY=b.wheelDelta/(120*n):this.deltaY=b.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$fR=A}),define(ge[126],be([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let F;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const W=P.process;F={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$ec=F.platform,t.$fc=F.arch}),define(ge[25],be([1,0,126]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const F=65,P=97,W=90,S=122,A=46,m=47,b=92,w=58,B=63;class c extends Error{constructor(T,N,R){let I;typeof N=="string"&&N.indexOf("not ")===0?(I="must not be",N=N.replace(/^not /,"")):I="must be";const j=T.indexOf(".")!==-1?"property":"argument";let $=`The "${T}" ${j} ${I} of type ${N}`;$+=`. Received type ${typeof R}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function f(l,T){if(l===null||typeof l!="object")throw new c(T,"Object",l)}function e(l,T){if(typeof l!="string")throw new c(T,"string",l)}const n=i.$ec==="win32";function r(l){return l===m||l===b}function h(l){return l===m}function g(l){return l>=F&&l<=W||l>=P&&l<=S}function D(l,T,N,R){let I="",j=0,$=-1,O=0,V=0;for(let M=0;M<=l.length;++M){if(M<l.length)V=l.charCodeAt(M);else{if(R(V))break;V=m}if(R(V)){if(!($===M-1||O===1))if(O===2){if(I.length<2||j!==2||I.charCodeAt(I.length-1)!==A||I.charCodeAt(I.length-2)!==A){if(I.length>2){const H=I.lastIndexOf(N);H===-1?(I="",j=0):(I=I.slice(0,H),j=I.length-1-I.lastIndexOf(N)),$=M,O=0;continue}else if(I.length!==0){I="",j=0,$=M,O=0;continue}}T&&(I+=I.length>0?`${N}..`:"..",j=2)}else I.length>0?I+=`${N}${l.slice($+1,M)}`:I=l.slice($+1,M),j=M-$-1;$=M,O=0}else V===A&&O!==-1?++O:O=-1}return I}function o(l,T){f(T,"pathObject");const N=T.dir||T.root,R=T.base||`${T.name||""}${T.ext||""}`;return N?N===T.root?`${N}${R}`:`${N}${l}${R}`:R}t.$gc={resolve(...l){let T="",N="",R=!1;for(let I=l.length-1;I>=-1;I--){let j;if(I>=0){if(j=l[I],e(j,"path"),j.length===0)continue}else T.length===0?j=i.cwd():(j=i.env[`=${T}`]||i.cwd(),(j===void 0||j.slice(0,2).toLowerCase()!==T.toLowerCase()&&j.charCodeAt(2)===b)&&(j=`${T}\\`));const $=j.length;let O=0,V="",M=!1;const H=j.charCodeAt(0);if($===1)r(H)&&(O=1,M=!0);else if(r(H))if(M=!0,r(j.charCodeAt(1))){let C=2,G=C;for(;C<$&&!r(j.charCodeAt(C));)C++;if(C<$&&C!==G){const Z=j.slice(G,C);for(G=C;C<$&&r(j.charCodeAt(C));)C++;if(C<$&&C!==G){for(G=C;C<$&&!r(j.charCodeAt(C));)C++;(C===$||C!==G)&&(V=`\\\\${Z}\\${j.slice(G,C)}`,O=C)}}}else O=1;else g(H)&&j.charCodeAt(1)===w&&(V=j.slice(0,2),O=2,$>2&&r(j.charCodeAt(2))&&(M=!0,O=3));if(V.length>0)if(T.length>0){if(V.toLowerCase()!==T.toLowerCase())continue}else T=V;if(R){if(T.length>0)break}else if(N=`${j.slice(O)}\\${N}`,R=M,M&&T.length>0)break}return N=D(N,!R,"\\",r),R?`${T}\\${N}`:`${T}${N}`||"."},normalize(l){e(l,"path");const T=l.length;if(T===0)return".";let N=0,R,I=!1;const j=l.charCodeAt(0);if(T===1)return h(j)?"\\":l;if(r(j))if(I=!0,r(l.charCodeAt(1))){let O=2,V=O;for(;O<T&&!r(l.charCodeAt(O));)O++;if(O<T&&O!==V){const M=l.slice(V,O);for(V=O;O<T&&r(l.charCodeAt(O));)O++;if(O<T&&O!==V){for(V=O;O<T&&!r(l.charCodeAt(O));)O++;if(O===T)return`\\\\${M}\\${l.slice(V)}\\`;O!==V&&(R=`\\\\${M}\\${l.slice(V,O)}`,N=O)}}}else N=1;else g(j)&&l.charCodeAt(1)===w&&(R=l.slice(0,2),N=2,T>2&&r(l.charCodeAt(2))&&(I=!0,N=3));let $=N<T?D(l.slice(N),!I,"\\",r):"";return $.length===0&&!I&&($="."),$.length>0&&r(l.charCodeAt(T-1))&&($+="\\"),R===void 0?I?`\\${$}`:$:I?`${R}\\${$}`:`${R}${$}`},isAbsolute(l){e(l,"path");const T=l.length;if(T===0)return!1;const N=l.charCodeAt(0);return r(N)||T>2&&g(N)&&l.charCodeAt(1)===w&&r(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let T,N;for(let j=0;j<l.length;++j){const $=l[j];e($,"path"),$.length>0&&(T===void 0?T=N=$:T+=`\\${$}`)}if(T===void 0)return".";let R=!0,I=0;if(typeof N=="string"&&r(N.charCodeAt(0))){++I;const j=N.length;j>1&&r(N.charCodeAt(1))&&(++I,j>2&&(r(N.charCodeAt(2))?++I:R=!1))}if(R){for(;I<T.length&&r(T.charCodeAt(I));)I++;I>=2&&(T=`\\${T.slice(I)}`)}return t.$gc.normalize(T)},relative(l,T){if(e(l,"from"),e(T,"to"),l===T)return"";const N=t.$gc.resolve(l),R=t.$gc.resolve(T);if(N===R||(l=N.toLowerCase(),T=R.toLowerCase(),l===T))return"";let I=0;for(;I<l.length&&l.charCodeAt(I)===b;)I++;let j=l.length;for(;j-1>I&&l.charCodeAt(j-1)===b;)j--;const $=j-I;let O=0;for(;O<T.length&&T.charCodeAt(O)===b;)O++;let V=T.length;for(;V-1>O&&T.charCodeAt(V-1)===b;)V--;const M=V-O,H=$<M?$:M;let C=-1,G=0;for(;G<H;G++){const ce=l.charCodeAt(I+G);if(ce!==T.charCodeAt(O+G))break;ce===b&&(C=G)}if(G!==H){if(C===-1)return R}else{if(M>H){if(T.charCodeAt(O+G)===b)return R.slice(O+G+1);if(G===2)return R.slice(O+G)}$>H&&(l.charCodeAt(I+G)===b?C=G:G===2&&(C=3)),C===-1&&(C=0)}let Z="";for(G=I+C+1;G<=j;++G)(G===j||l.charCodeAt(G)===b)&&(Z+=Z.length===0?"..":"\\..");return O+=C,Z.length>0?`${Z}${R.slice(O,V)}`:(R.charCodeAt(O)===b&&++O,R.slice(O,V))},toNamespacedPath(l){if(typeof l!="string"||l.length===0)return l;const T=t.$gc.resolve(l);if(T.length<=2)return l;if(T.charCodeAt(0)===b){if(T.charCodeAt(1)===b){const N=T.charCodeAt(2);if(N!==B&&N!==A)return`\\\\?\\UNC\\${T.slice(2)}`}}else if(g(T.charCodeAt(0))&&T.charCodeAt(1)===w&&T.charCodeAt(2)===b)return`\\\\?\\${T}`;return l},dirname(l){e(l,"path");const T=l.length;if(T===0)return".";let N=-1,R=0;const I=l.charCodeAt(0);if(T===1)return r(I)?l:".";if(r(I)){if(N=R=1,r(l.charCodeAt(1))){let O=2,V=O;for(;O<T&&!r(l.charCodeAt(O));)O++;if(O<T&&O!==V){for(V=O;O<T&&r(l.charCodeAt(O));)O++;if(O<T&&O!==V){for(V=O;O<T&&!r(l.charCodeAt(O));)O++;if(O===T)return l;O!==V&&(N=R=O+1)}}}}else g(I)&&l.charCodeAt(1)===w&&(N=T>2&&r(l.charCodeAt(2))?3:2,R=N);let j=-1,$=!0;for(let O=T-1;O>=R;--O)if(r(l.charCodeAt(O))){if(!$){j=O;break}}else $=!1;if(j===-1){if(N===-1)return".";j=N}return l.slice(0,j)},basename(l,T){T!==void 0&&e(T,"ext"),e(l,"path");let N=0,R=-1,I=!0,j;if(l.length>=2&&g(l.charCodeAt(0))&&l.charCodeAt(1)===w&&(N=2),T!==void 0&&T.length>0&&T.length<=l.length){if(T===l)return"";let $=T.length-1,O=-1;for(j=l.length-1;j>=N;--j){const V=l.charCodeAt(j);if(r(V)){if(!I){N=j+1;break}}else O===-1&&(I=!1,O=j+1),$>=0&&(V===T.charCodeAt($)?--$===-1&&(R=j):($=-1,R=O))}return N===R?R=O:R===-1&&(R=l.length),l.slice(N,R)}for(j=l.length-1;j>=N;--j)if(r(l.charCodeAt(j))){if(!I){N=j+1;break}}else R===-1&&(I=!1,R=j+1);return R===-1?"":l.slice(N,R)},extname(l){e(l,"path");let T=0,N=-1,R=0,I=-1,j=!0,$=0;l.length>=2&&l.charCodeAt(1)===w&&g(l.charCodeAt(0))&&(T=R=2);for(let O=l.length-1;O>=T;--O){const V=l.charCodeAt(O);if(r(V)){if(!j){R=O+1;break}continue}I===-1&&(j=!1,I=O+1),V===A?N===-1?N=O:$!==1&&($=1):N!==-1&&($=-1)}return N===-1||I===-1||$===0||$===1&&N===I-1&&N===R+1?"":l.slice(N,I)},format:o.bind(null,"\\"),parse(l){e(l,"path");const T={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return T;const N=l.length;let R=0,I=l.charCodeAt(0);if(N===1)return r(I)?(T.root=T.dir=l,T):(T.base=T.name=l,T);if(r(I)){if(R=1,r(l.charCodeAt(1))){let C=2,G=C;for(;C<N&&!r(l.charCodeAt(C));)C++;if(C<N&&C!==G){for(G=C;C<N&&r(l.charCodeAt(C));)C++;if(C<N&&C!==G){for(G=C;C<N&&!r(l.charCodeAt(C));)C++;C===N?R=C:C!==G&&(R=C+1)}}}}else if(g(I)&&l.charCodeAt(1)===w){if(N<=2)return T.root=T.dir=l,T;if(R=2,r(l.charCodeAt(2))){if(N===3)return T.root=T.dir=l,T;R=3}}R>0&&(T.root=l.slice(0,R));let j=-1,$=R,O=-1,V=!0,M=l.length-1,H=0;for(;M>=R;--M){if(I=l.charCodeAt(M),r(I)){if(!V){$=M+1;break}continue}O===-1&&(V=!1,O=M+1),I===A?j===-1?j=M:H!==1&&(H=1):j!==-1&&(H=-1)}return O!==-1&&(j===-1||H===0||H===1&&j===O-1&&j===$+1?T.base=T.name=l.slice($,O):(T.name=l.slice($,j),T.base=l.slice($,O),T.ext=l.slice(j,O))),$>0&&$!==R?T.dir=l.slice(0,$-1):T.dir=T.root,T},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(n){const l=/\\/g;return()=>{const T=i.cwd().replace(l,"/");return T.slice(T.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...l){let T="",N=!1;for(let R=l.length-1;R>=-1&&!N;R--){const I=R>=0?l[R]:d();e(I,"path"),I.length!==0&&(T=`${I}/${T}`,N=I.charCodeAt(0)===m)}return T=D(T,!N,"/",h),N?`/${T}`:T.length>0?T:"."},normalize(l){if(e(l,"path"),l.length===0)return".";const T=l.charCodeAt(0)===m,N=l.charCodeAt(l.length-1)===m;return l=D(l,!T,"/",h),l.length===0?T?"/":N?"./":".":(N&&(l+="/"),T?`/${l}`:l)},isAbsolute(l){return e(l,"path"),l.length>0&&l.charCodeAt(0)===m},join(...l){if(l.length===0)return".";let T;for(let N=0;N<l.length;++N){const R=l[N];e(R,"path"),R.length>0&&(T===void 0?T=R:T+=`/${R}`)}return T===void 0?".":t.$hc.normalize(T)},relative(l,T){if(e(l,"from"),e(T,"to"),l===T||(l=t.$hc.resolve(l),T=t.$hc.resolve(T),l===T))return"";const N=1,R=l.length,I=R-N,j=1,$=T.length-j,O=I<$?I:$;let V=-1,M=0;for(;M<O;M++){const C=l.charCodeAt(N+M);if(C!==T.charCodeAt(j+M))break;C===m&&(V=M)}if(M===O)if($>O){if(T.charCodeAt(j+M)===m)return T.slice(j+M+1);if(M===0)return T.slice(j+M)}else I>O&&(l.charCodeAt(N+M)===m?V=M:M===0&&(V=0));let H="";for(M=N+V+1;M<=R;++M)(M===R||l.charCodeAt(M)===m)&&(H+=H.length===0?"..":"/..");return`${H}${T.slice(j+V)}`},toNamespacedPath(l){return l},dirname(l){if(e(l,"path"),l.length===0)return".";const T=l.charCodeAt(0)===m;let N=-1,R=!0;for(let I=l.length-1;I>=1;--I)if(l.charCodeAt(I)===m){if(!R){N=I;break}}else R=!1;return N===-1?T?"/":".":T&&N===1?"//":l.slice(0,N)},basename(l,T){T!==void 0&&e(T,"ext"),e(l,"path");let N=0,R=-1,I=!0,j;if(T!==void 0&&T.length>0&&T.length<=l.length){if(T===l)return"";let $=T.length-1,O=-1;for(j=l.length-1;j>=0;--j){const V=l.charCodeAt(j);if(V===m){if(!I){N=j+1;break}}else O===-1&&(I=!1,O=j+1),$>=0&&(V===T.charCodeAt($)?--$===-1&&(R=j):($=-1,R=O))}return N===R?R=O:R===-1&&(R=l.length),l.slice(N,R)}for(j=l.length-1;j>=0;--j)if(l.charCodeAt(j)===m){if(!I){N=j+1;break}}else R===-1&&(I=!1,R=j+1);return R===-1?"":l.slice(N,R)},extname(l){e(l,"path");let T=-1,N=0,R=-1,I=!0,j=0;for(let $=l.length-1;$>=0;--$){const O=l.charCodeAt($);if(O===m){if(!I){N=$+1;break}continue}R===-1&&(I=!1,R=$+1),O===A?T===-1?T=$:j!==1&&(j=1):T!==-1&&(j=-1)}return T===-1||R===-1||j===0||j===1&&T===R-1&&T===N+1?"":l.slice(T,R)},format:o.bind(null,"/"),parse(l){e(l,"path");const T={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return T;const N=l.charCodeAt(0)===m;let R;N?(T.root="/",R=1):R=0;let I=-1,j=0,$=-1,O=!0,V=l.length-1,M=0;for(;V>=R;--V){const H=l.charCodeAt(V);if(H===m){if(!O){j=V+1;break}continue}$===-1&&(O=!1,$=V+1),H===A?I===-1?I=V:M!==1&&(M=1):I!==-1&&(M=-1)}if($!==-1){const H=j===0&&N?1:j;I===-1||M===0||M===1&&I===$-1&&I===j+1?T.base=T.name=l.slice(H,$):(T.name=l.slice(H,I),T.base=l.slice(H,$),T.ext=l.slice(I,$))}return j>0?T.dir=l.slice(0,j-1):N&&(T.dir="/"),T},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=n?t.$gc.normalize:t.$hc.normalize,t.$jc=n?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=n?t.$gc.join:t.$hc.join,t.$lc=n?t.$gc.resolve:t.$hc.resolve,t.$mc=n?t.$gc.relative:t.$hc.relative,t.$nc=n?t.$gc.dirname:t.$hc.dirname,t.$oc=n?t.$gc.basename:t.$hc.basename,t.$pc=n?t.$gc.extname:t.$hc.extname,t.$qc=n?t.$gc.format:t.$hc.format,t.$rc=n?t.$gc.parse:t.$hc.parse,t.$sc=n?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=n?t.$gc.sep:t.$hc.sep,t.$uc=n?t.$gc.delimiter:t.$hc.delimiter}),define(ge[127],be([1,0,25,5,9,10]),function(ne,t,i,F,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gg=S,t.$hg=A,t.$ig=m,t.$jg=b,t.$kg=w,t.$lg=e,t.$mg=n,t.$ng=r,t.$og=h,t.$pg=g,t.$qg=D,t.$rg=o,t.$sg=d,t.$tg=l,t.$ug=T,t.$vg=I;function S(j){return j===47||j===92}function A(j){return j.replace(/[\\/]/g,i.$hc.sep)}function m(j){return j.indexOf("/")===-1&&(j=A(j)),/^[a-zA-Z]:(\/|$)/.test(j)&&(j="/"+j),j}function b(j,$=i.$hc.sep){if(!j)return"";const O=j.length,V=j.charCodeAt(0);if(S(V)){if(S(j.charCodeAt(1))&&!S(j.charCodeAt(2))){let H=3;const C=H;for(;H<O&&!S(j.charCodeAt(H));H++);if(C!==H&&!S(j.charCodeAt(H+1))){for(H+=1;H<O;H++)if(S(j.charCodeAt(H)))return j.slice(0,H+1).replace(/[\\/]/g,$)}}return $}else if(h(V)&&j.charCodeAt(1)===58)return S(j.charCodeAt(2))?j.slice(0,2)+$:j.slice(0,2);let M=j.indexOf("://");if(M!==-1){for(M+=3;M<O;M++)if(S(j.charCodeAt(M)))return j.slice(0,M+1)}return""}function w(j){if(!F.$i||!j||j.length<5)return!1;let $=j.charCodeAt(0);if($!==92||($=j.charCodeAt(1),$!==92))return!1;let O=2;const V=O;for(;O<j.length&&($=j.charCodeAt(O),$!==92);O++);return!(V===O||($=j.charCodeAt(O+1),isNaN($)||$===92))}const B=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(j,$=F.$i){const O=$?B:c;return!(!j||j.length===0||/^\s+$/.test(j)||(O.lastIndex=0,O.test(j))||$&&f.test(j)||j==="."||j===".."||$&&j[j.length-1]==="."||$&&j.length!==j.trim().length||j.length>255)}function n(j,$,O){const V=j===$;return!O||V?V:!j||!$?!1:(0,P.$qf)(j,$)}function r(j,$,O,V=i.sep){if(j===$)return!0;if(!j||!$||$.length>j.length)return!1;if(O){if(!(0,P.$rf)(j,$))return!1;if($.length===j.length)return!0;let H=$.length;return $.charAt($.length-1)===V&&H--,j.charAt(H)===V}return $.charAt($.length-1)!==V&&($+=V),j.indexOf($)===0}function h(j){return j>=65&&j<=90||j>=97&&j<=122}function g(j,$){return F.$i&&j.endsWith(":")&&(j+=i.sep),(0,i.$jc)(j)||(j=(0,i.$kc)($,j)),j=(0,i.$ic)(j),F.$i?(j=(0,P.$$e)(j,i.sep),j.endsWith(":")&&(j+=i.sep)):(j=(0,P.$$e)(j,i.sep),j||(j=i.sep)),j}function D(j){const $=(0,i.$ic)(j);return F.$i?j.length>3?!1:o($)&&(j.length===2||$.charCodeAt(2)===92):$===i.$hc.sep}function o(j,$=F.$i){return $?h(j.charCodeAt(0))&&j.charCodeAt(1)===58:!1}function d(j,$=F.$i){return o(j,$)?j[0]:void 0}function l(j,$,O){return $.length>j.length?-1:j===$?0:(O&&(j=j.toLowerCase(),$=$.toLowerCase()),j.indexOf($))}function T(j){const $=j.split(":");let O,V,M;for(const H of $){const C=Number(H);(0,W.$5f)(C)?V===void 0?V=C:M===void 0&&(M=C):O=O?[O,H].join(":"):H}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:V!==void 0?V:void 0,column:M!==void 0?M:V!==void 0?1:void 0}}const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function I(j,$,O=8){let V="";for(let H=0;H<O;H++){let C;H===0&&F.$i&&!$&&(O===3||O===4)?C=R:C=N,V+=C.charAt(Math.floor(Math.random()*C.length))}let M;return $?M=`${$}-${V}`:M=V,j?(0,i.$kc)(j,M):M}}),define(ge[128],be([1,0,25]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Es=void 0,t.$Fs=W,t.$Gs=S,t.$Hs=A,t.$Is=b,t.$Es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(w){const B=(0,i.$pc)(w),c=F[B.toLowerCase()];return c!==void 0?c:S(w)}function S(w){const B=(0,i.$pc)(w);return P[B.toLowerCase()]}function A(w){for(const B in P)if(P[B]===w)return B}const m=/^(.+)\/(.+?)(;.+)?$/;function b(w,B){const c=m.exec(w);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:B?void 0:w}}),define(ge[16],be([1,0,25,5]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=o;const P=/^\w[\w\d+.-]*$/,W=/^\//,S=/^\/\//;function A(R,I){if(!R.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!P.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!W.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(R,I){return!R&&!I?"file":R}function b(R,I){switch(R){case"https":case"http":case"file":I?I[0]!==B&&(I=B+I):I=B;break}return I}const w="",B="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(I){return I instanceof f?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,j,$,O,V,M=!1){typeof I=="object"?(this.scheme=I.scheme||w,this.authority=I.authority||w,this.path=I.path||w,this.query=I.query||w,this.fragment=I.fragment||w):(this.scheme=m(I,M),this.authority=j||w,this.path=b(this.scheme,$||w),this.query=O||w,this.fragment=V||w,A(this,M))}get fsPath(){return o(this,!1)}with(I){if(!I)return this;let{scheme:j,authority:$,path:O,query:V,fragment:M}=I;return j===void 0?j=this.scheme:j===null&&(j=w),$===void 0?$=this.authority:$===null&&($=w),O===void 0?O=this.path:O===null&&(O=w),V===void 0?V=this.query:V===null&&(V=w),M===void 0?M=this.fragment:M===null&&(M=w),j===this.scheme&&$===this.authority&&O===this.path&&V===this.query&&M===this.fragment?this:new r(j,$,O,V,M)}static parse(I,j=!1){const $=c.exec(I);return $?new r($[2]||w,N($[4]||w),N($[5]||w),N($[7]||w),N($[9]||w),j):new r(w,w,w,w,w)}static file(I){let j=w;if(F.$i&&(I=I.replace(/\\/g,B)),I[0]===B&&I[1]===B){const $=I.indexOf(B,2);$===-1?(j=I.substring(2),I=B):(j=I.substring(2,$),I=I.substring($)||B)}return new r("file",j,I,w,w)}static from(I,j){return new r(I.scheme,I.authority,I.path,I.query,I.fragment,j)}static joinPath(I,...j){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return F.$i&&I.scheme==="file"?$=f.file(i.$gc.join(o(I,!0),...j)).path:$=i.$hc.join(I.path,...j),I.with({path:$})}toString(I=!1){return d(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof f)return I;{const j=new r(I);return j._formatted=I.external??null,j._fsPath=I._sep===n?I.fsPath??null:null,j}}else return I}}t.URI=f;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const n=F.$i?1:void 0;class r extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(I=!1){return I?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const I={$mid:1};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=n),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(R,I,j){let $,O=-1;for(let V=0;V<R.length;V++){const M=R.charCodeAt(V);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||I&&M===47||j&&M===91||j&&M===93||j&&M===58)O!==-1&&($+=encodeURIComponent(R.substring(O,V)),O=-1),$!==void 0&&($+=R.charAt(V));else{$===void 0&&($=R.substr(0,V));const H=h[M];H!==void 0?(O!==-1&&($+=encodeURIComponent(R.substring(O,V)),O=-1),$+=H):O===-1&&(O=V)}}return O!==-1&&($+=encodeURIComponent(R.substring(O))),$!==void 0?$:R}function D(R){let I;for(let j=0;j<R.length;j++){const $=R.charCodeAt(j);$===35||$===63?(I===void 0&&(I=R.substr(0,j)),I+=h[$]):I!==void 0&&(I+=R[j])}return I!==void 0?I:R}function o(R,I){let j;return R.authority&&R.path.length>1&&R.scheme==="file"?j=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?I?j=R.path.substr(1):j=R.path[1].toLowerCase()+R.path.substr(2):j=R.path,F.$i&&(j=j.replace(/\//g,"\\")),j}function d(R,I){const j=I?D:g;let $="",{scheme:O,authority:V,path:M,query:H,fragment:C}=R;if(O&&($+=O,$+=":"),(V||O==="file")&&($+=B,$+=B),V){let G=V.indexOf("@");if(G!==-1){const Z=V.substr(0,G);V=V.substr(G+1),G=Z.lastIndexOf(":"),G===-1?$+=j(Z,!1,!1):($+=j(Z.substr(0,G),!1,!1),$+=":",$+=j(Z.substr(G+1),!1,!0)),$+="@"}V=V.toLowerCase(),G=V.lastIndexOf(":"),G===-1?$+=j(V,!1,!0):($+=j(V.substr(0,G),!1,!0),$+=V.substr(G))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const G=M.charCodeAt(1);G>=65&&G<=90&&(M=`/${String.fromCharCode(G+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const G=M.charCodeAt(0);G>=65&&G<=90&&(M=`${String.fromCharCode(G+32)}:${M.substr(2)}`)}$+=j(M,!0,!1)}return H&&($+="?",$+=j(H,!1,!1)),C&&($+="#",$+=I?C:g(C,!1,!1)),$}function l(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+l(R.substr(3)):R}}const T=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(R){return R.match(T)?R.replace(T,I=>l(I)):R}}),define(ge[64],be([1,0,43,16]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uh=P,t.$Vh=W,t.$Wh=A;function P(m){return JSON.stringify(m,S)}function W(m){let b=JSON.parse(m);return b=A(b),b}function S(m,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function A(m,b=0){if(!m||b>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return F.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof i.$ze||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let w=0;w<m.length;++w)m[w]=A(m[w],b+1);else for(const w in m)Object.hasOwnProperty.call(m,w)&&(m[w]=A(m[w],b+1))}return m}}),define(ge[36],be([1,0,6,5,9,16,25]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Ag=t.$zg=t.$yg=t.Schemas=void 0,t.$wg=m,t.$xg=b,t.$Bg=B;var A;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.codeSetting="code-setting"})(A||(t.Schemas=A={}));function m(e,n){return W.URI.isUri(e)?(0,P.$qf)(e.scheme,n):(0,P.$rf)(e,n+":")}function b(e,...n){return n.some(r=>m(e,r))}t.$yg="vscode-tkn",t.$zg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,r){this.f=B(n,r)}getServerRootPath(){return this.f}get g(){return S.$hc.join(this.f,A.vscodeRemoteResource)}set(n,r,h){this.a[n]=r,this.b[n]=h}setConnectionToken(n,r){this.c[n]=r}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(d){return i.$1(d),n}const r=n.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this.b[r],D=this.c[r];let o=`path=${encodeURIComponent(n.path)}`;return typeof D=="string"&&(o+=`&${t.$zg}=${encodeURIComponent(D)}`),W.URI.from({scheme:F.$o?this.d:A.vscodeRemoteResource,authority:`${h}:${g}`,path:this.g,query:o})}}t.$Ag=new w;function B(e,n){return S.$hc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Cg="vs/../../extensions",t.$Dg="vs/../../node_modules",t.$Eg="vs/../../node_modules.asar",t.$Fg="vs/../../node_modules.asar.unpacked",t.$Gg="vscode-app";class c{static{this.a=t.$Gg}asBrowserUri(n){const r=this.b(n,ne);return this.uriToBrowserUri(r)}uriToBrowserUri(n){return n.scheme===A.vscodeRemote?t.$Ag.rewrite(n):n.scheme===A.file&&(F.$m||F.$q===`${A.vscodeFileResource}://${c.a}`)?n.with({scheme:A.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const r=this.b(n,ne);return this.uriToFileUri(r)}uriToFileUri(n){return n.scheme===A.vscodeFileResource?n.with({scheme:A.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,r){return W.URI.isUri(n)?n:W.URI.parse(r.toUrl(n))}}t.$Hg=new c;var f;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const r="vscode-coi";function h(D){let o;typeof D=="string"?o=new URL(D).searchParams:D instanceof URL?o=D.searchParams:W.URI.isUri(D)&&(o=new URL(D.toString(!0)).searchParams);const d=o?.get(r);if(d)return n.get(d)}e.getHeadersFromQuery=h;function g(D,o,d){if(!globalThis.crossOriginIsolated)return;const l=o&&d?"3":d?"2":"1";D instanceof URLSearchParams?D.set(r,l):D[r]=l}e.addSearchParam=g})(f||(t.COI=f={}))}),define(ge[47],be([1,0,127,36,25,5,9,16]),function(ne,t,i,F,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=void 0,t.$Og=m,t.$0g=w,t.$$g=c;function m(f){return(0,A.$xc)(f,!0)}class b{constructor(e){this.a=e}compare(e,n,r=!1){return e===n?0:(0,S.$jf)(this.getComparisonKey(e,r),this.getComparisonKey(n,r))}isEqual(e,n,r=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,r)===this.getComparisonKey(n,r)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,r=!1){if(e.scheme===n.scheme){if(e.scheme===F.Schemas.file)return i.$ng(m(e),m(n),this.a(e))&&e.query===n.query&&(r||e.fragment===n.fragment);if((0,t.$6g)(e.authority,n.authority))return i.$ng(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(r||e.fragment===n.fragment)}return!1}joinPath(e,...n){return A.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$Xg)(e)||e.authority}basename(e){return P.$hc.basename(e.path)}extname(e){return P.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===F.Schemas.file?n=A.URI.file(P.$nc(m(e))).path:(n=P.$hc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===F.Schemas.file?n=A.URI.file(P.$ic(m(e))).path:n=P.$hc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$6g)(e.authority,n.authority))return;if(e.scheme===F.Schemas.file){const g=P.$mc(m(e),m(n));return W.$i?i.$hg(g):g}let r=e.path||"/";const h=n.path||"/";if(this.a(e)){let g=0;for(const D=Math.min(r.length,h.length);g<D&&!(r.charCodeAt(g)!==h.charCodeAt(g)&&r.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);r=h.substr(0,g)+r.substr(g)}return P.$hc.relative(r,h)}resolvePath(e,n){if(e.scheme===F.Schemas.file){const r=A.URI.file(P.$lc(m(e),n));return e.with({authority:r.authority,path:r.path})}return n=i.$ig(n),e.with({path:P.$hc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,S.$qf)(e,n)}hasTrailingPathSeparator(e,n=P.sep){if(e.scheme===F.Schemas.file){const r=m(e);return r.length>i.$jg(r).length&&r[r.length-1]===n}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=P.sep){return(0,t.$7g)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=P.sep){let r=!1;if(e.scheme===F.Schemas.file){const h=m(e);r=h!==void 0&&h.length===i.$jg(h).length&&h[h.length-1]===n}else{n="/";const h=e.path;r=h.length===1&&h.charCodeAt(h.length-1)===47}return!r&&!(0,t.$7g)(e,n)?e.with({path:e.path+"/"}):e}}t.$Pg=b,t.$Qg=new b(()=>!1),t.$Rg=new b(f=>f.scheme===F.Schemas.file?!W.$k:!0),t.$Sg=new b(f=>!0),t.$Tg=t.$Qg.isEqual.bind(t.$Qg),t.$Ug=t.$Qg.isEqualOrParent.bind(t.$Qg),t.$Vg=t.$Qg.getComparisonKey.bind(t.$Qg),t.$Wg=t.$Qg.basenameOrAuthority.bind(t.$Qg),t.$Xg=t.$Qg.basename.bind(t.$Qg),t.$Yg=t.$Qg.extname.bind(t.$Qg),t.$Zg=t.$Qg.dirname.bind(t.$Qg),t.$1g=t.$Qg.joinPath.bind(t.$Qg),t.$2g=t.$Qg.normalizePath.bind(t.$Qg),t.$3g=t.$Qg.relativePath.bind(t.$Qg),t.$4g=t.$Qg.resolvePath.bind(t.$Qg),t.$5g=t.$Qg.isAbsolutePath.bind(t.$Qg),t.$6g=t.$Qg.isEqualAuthority.bind(t.$Qg),t.$7g=t.$Qg.hasTrailingPathSeparator.bind(t.$Qg),t.$8g=t.$Qg.removeTrailingPathSeparator.bind(t.$Qg),t.$9g=t.$Qg.addTrailingPathSeparator.bind(t.$Qg);function w(f,e){const n=[];for(let r=0;r<f.length;r++){const h=e(f[r]);f.some((g,D)=>D===r?!1:(0,t.$Ug)(h,e(g)))||n.push(f[r])}return n}var B;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function e(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(D=>{const[o,d]=D.split(":");o&&d&&r.set(o,d)});const g=n.path.substring(0,n.path.indexOf(";"));return g&&r.set(f.META_DATA_MIME,g),r}f.parseMetaData=e})(B||(t.DataUri=B={}));function c(f,e,n){if(e){let r=f.path;return r&&r[0]!==P.$hc.sep&&(r=P.$hc.sep+r),f.with({scheme:n,authority:e,path:r})}return f.with({scheme:n})}}),define(ge[11],be([1,0,34,6,3,2,47,5,60,23]),function(ne,t,i,F,P,W,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qh=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.Promises=t.$Kh=t.$Jh=t.$Ih=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=void 0,t.$_g=w,t.$ah=B,t.$bh=c,t.$ch=f,t.$dh=e,t.$eh=n,t.$fh=r,t.$gh=h,t.$oh=j,t.$ph=$,t.$qh=O,t.$rh=V,t.$sh=M,t.$Hh=_,t.$Ph=x;function w(y){return!!y&&typeof y.then=="function"}function B(y){const a=new i.$je,p=y(a.token),k=new Promise((s,E)=>{const v=a.token.onCancellationRequested(()=>{v.dispose(),E(new F.$5)});Promise.resolve(p).then(L=>{v.dispose(),a.dispose(),s(L)},L=>{v.dispose(),a.dispose(),E(L)})});return new class{cancel(){a.cancel(),a.dispose()}then(s,E){return k.then(s,E)}catch(s){return this.then(void 0,s)}finally(s){return k.finally(s)}}}function c(y,a,p){return new Promise((k,s)=>{const E=a.onCancellationRequested(()=>{E.dispose(),k(p)});y.then(k,s).finally(()=>E.dispose())})}function f(y,a){return new Promise((p,k)=>{const s=a.onCancellationRequested(()=>{s.dispose(),k(new F.$5)});y.then(p,k).finally(()=>s.dispose())})}async function e(y){let a=-1;const p=y.map((k,s)=>k.then(E=>(a=s,E)));try{return await Promise.race(p)}finally{y.forEach((k,s)=>{s!==a&&k.cancel()})}}function n(y,a,p){let k;const s=setTimeout(()=>{k?.(void 0),p?.()},a);return Promise.race([y.finally(()=>clearTimeout(s)),new Promise(E=>k=E)])}function r(y){return new Promise((a,p)=>{const k=y();w(k)?k.then(a,p):a(k)})}function h(){let y,a;return{promise:new Promise((k,s)=>{y=k,a=s}),resolve:y,reject:a}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const p=()=>{if(this.b=null,this.f)return;const k=this.queue(this.d);return this.d=null,k};this.b=new Promise(k=>{this.a.then(p,p).then(k)})}return new Promise((p,k)=>{this.b.then(p,k)})}return this.a=a(),new Promise((p,k)=>{this.a.then(s=>{this.a=null,p(s)},s=>{this.a=null,k(s)})})}dispose(){this.f=!0}}t.$hh=g;class D{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}t.$ih=D;class o{constructor(){this.a=new Map}queue(a,p){const s=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(p).finally(()=>{this.a.get(a)===s&&this.a.delete(a)});return this.a.set(a,s),s}}t.$jh=o;const d=(y,a)=>{let p=!0;const k=setTimeout(()=>{p=!1,a()},y);return{isTriggered:()=>p,dispose:()=>{clearTimeout(k),p=!1}}},l=y=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,y())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class T{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,p=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((s,E)=>{this.d=s,this.f=E}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const k=()=>{this.a=null,this.d?.(null)};return this.a=p===m.$9d?l(k):d(p,k),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$kh=T;class N{constructor(a){this.a=new T(a),this.b=new g}trigger(a,p){return this.a.trigger(()=>this.b.queue(a),p)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$lh=N;class R{constructor(){this.a=!1,this.b=new Promise((a,p)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$mh=R;class I extends R{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}t.$nh=I;function j(y,a){return a?new Promise((p,k)=>{const s=setTimeout(()=>{E.dispose(),p()},y),E=a.onCancellationRequested(()=>{clearTimeout(s),E.dispose(),k(new F.$5)})}):B(p=>j(y,p))}function $(y,a=0,p){const k=setTimeout(()=>{y(),p&&s.dispose()},a),s=(0,W.$Sc)(()=>{clearTimeout(k),p?.deleteAndLeak(s)});return p?.add(s),s}function O(y){const a=[];let p=0;const k=y.length;function s(){return p<k?y[p++]():null}function E(v){v!=null&&a.push(v);const L=s();return L?L.then(E):Promise.resolve(a)}return Promise.resolve(null).then(E)}function V(y,a=k=>!!k,p=null){let k=0;const s=y.length,E=()=>{if(k>=s)return Promise.resolve(p);const v=y[k++];return Promise.resolve(v()).then(z=>a(z)?Promise.resolve(z):E())};return E()}function M(y,a=k=>!!k,p=null){if(y.length===0)return Promise.resolve(p);let k=y.length;const s=()=>{k=-1;for(const E of y)E.cancel?.()};return new Promise((E,v)=>{for(const L of y)L.then(z=>{--k>=0&&a(z)?(s(),E(z)):k===0&&E(p)}).catch(z=>{--k>=0&&(s(),v(z))})})}class H{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new P.$_d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((p,k)=>{this.g.push({factory:a,c:p,e:k}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const p=a.factory();p.then(a.c,a.e),p.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$th=H;class C extends H{constructor(){super(1)}}t.$uh=C;class G{constructor(){this.a=new ae,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}t.$vh=G;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new Q;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,p=S.$Qg){const k=p.getComparisonKey(a);return this.a.get(k)?.size??0}queueFor(a,p,k=S.$Qg){const s=k.getComparisonKey(a);let E=this.a.get(s);if(!E){E=new C;const v=this.f++,L=P.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose(v),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$4c),this.d.set(v,L),this.a.set(s,E)}return E.queue(p)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$wh=Z;class ce{constructor(a,p){this.a=-1,typeof a=="function"&&typeof p=="number"&&this.setIfNotSet(a,p)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,p){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},p)}setIfNotSet(a,p){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},p))}}t.$xh=ce;class re{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,p,k=globalThis){this.cancel();const s=k.setInterval(()=>{a()},p);this.d=(0,W.$Sc)(()=>{k.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$yh=re;class te{constructor(a,p){this.b=-1,this.a=a,this.d=p,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$zh=te;class $e{constructor(a,p){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.a=a,this.b=p,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Ah=$e;class De extends te{constructor(a,p){super(a,p),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}t.$Bh=De;class Fe extends W.$Uc{constructor(a,p){super(),this.g=a,this.h=p,this.a=[],this.b=this.B(new W.$Vc),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const p of a)this.a.push(p);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Ch=Fe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Eh=(y,a)=>{(0,A.$B)(()=>{if(p)return;const k=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$Eh=(y,a,p)=>{const k=y.requestIdleCallback(a,typeof p=="number"?{timeout:p}:void 0);let s=!1;return{dispose(){s||(s=!0,y.cancelIdleCallback(k))}}},t.$Dh=y=>(0,t.$Eh)(globalThis,y)}();class He{constructor(a,p){this.g=!1,this.d=()=>{try{this.j=p()}catch(k){this.l=k}finally{this.g=!0}},this.f=(0,t.$Eh)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Fh=He;class he extends He{constructor(a){super(globalThis,a)}}t.$Gh=he;async function _(y,a,p){let k;for(let s=0;s<p;s++)try{return await y()}catch(E){k=E,await j(a)}throw k}class ae{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,p,k){return this.a={taskId:a,cancel:()=>k?.(),promise:p},p.then(()=>this.d(a),()=>this.d(a)),p}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:p,resolve:k,reject:s}=h();this.b={run:a,promise:p,promiseResolve:k,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Ih=ae;class le{constructor(a,p=()=>Date.now()){this.d=a,this.f=p,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}t.$Jh=le;var J;(function(y){y[y.Resolved=0]="Resolved",y[y.Rejected=1]="Rejected"})(J||(J={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((a,p)=>{this.a=a,this.b=p})}complete(a){return new Promise(p=>{this.a(a),this.d={outcome:0,value:a},p()})}error(a){return new Promise(p=>{this.b(a),this.d={outcome:1,value:a},p()})}cancel(){return this.error(new F.$5)}}t.$Kh=Q;var se;(function(y){async function a(k){let s;const E=await Promise.all(k.map(v=>v.then(L=>L,L=>{s||(s=L)})));if(typeof s<"u")throw s;return E}y.settled=a;function p(k){return new Promise(async(s,E)=>{try{await k(s,E)}catch(v){E(v)}})}y.withAsyncBody=p})(se||(t.Promises=se={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(p=>(this.a=p,this.d=!0,p),p=>{throw this.b=p,this.d=!0,p})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Lh=fe;class ve{constructor(a){this.b=a,this.a=new b.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Mh=ve;var Ne;(function(y){y[y.Initial=0]="Initial",y[y.DoneOK=1]="DoneOK",y[y.DoneError=2]="DoneError"})(Ne||(Ne={}));class Ae{static fromArray(a){return new Ae(p=>{p.emitMany(a)})}static fromPromise(a){return new Ae(async p=>{p.emitMany(await a)})}static fromPromises(a){return new Ae(async p=>{await Promise.all(a.map(async k=>p.emitOne(await k)))})}static merge(a){return new Ae(async p=>{await Promise.all(a.map(async k=>{for await(const s of k)p.emitOne(s)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(a){this.a=0,this.b=[],this.d=null,this.f=new P.$_d,queueMicrotask(async()=>{const p={emitOne:k=>this.g(k),emitMany:k=>this.h(k),reject:k=>this.k(k)};try{await Promise.resolve(a(p)),this.j()}catch(k){this.k(k)}finally{p.emitOne=void 0,p.emitMany=void 0,p.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(a,p){return new Ae(async k=>{for await(const s of a)k.emitOne(p(s))})}map(a){return Ae.map(this,a)}static filter(a,p){return new Ae(async k=>{for await(const s of a)p(s)&&k.emitOne(s)})}filter(a){return Ae.filter(this,a)}static coalesce(a){return Ae.filter(a,p=>!!p)}coalesce(){return Ae.coalesce(this)}static async toPromise(a){const p=[];for await(const k of a)p.push(k);return p}toPromise(){return Ae.toPromise(this)}g(a){this.a===0&&(this.b.push(a),this.f.fire())}h(a){this.a===0&&(this.b=this.b.concat(a),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(a){this.a===0&&(this.a=2,this.d=a,this.f.fire())}}t.$Nh=Ae;class Le extends Ae{constructor(a,p){super(p),this.l=a}cancel(){this.l.cancel()}}t.$Oh=Le;function x(y){const a=new i.$je,p=y(a.token);return new Le(a,async k=>{const s=a.token.onCancellationRequested(()=>{s.dispose(),a.dispose(),k.reject(new F.$5)});try{for await(const E of p){if(a.token.isCancellationRequested)return;k.emitOne(E)}s.dispose(),a.dispose()}catch(E){s.dispose(),a.dispose(),k.reject(E)}})}class u{constructor(){this.a=new Q,this.b=new Ae(k=>{if(a){k.reject(a);return}return p&&k.emitMany(p),this.d=s=>k.reject(s),this.f=s=>k.emitOne(s),this.a.p});let a,p;this.f=k=>{p||(p=[]),p.push(k)},this.d=k=>{a||(a=k)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}t.$Qh=u}),define(ge[4],be([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$NS=t.$LS=t.$IS=t.DetectedFullscreenMode=t.Namespace=t.$gS=t.$eS=t.$8R=t.$DR=t.$xR=t.$vR=t.$uR=t.$tR=t.$oR=t.$nR=t.$mR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$kR=h,t.$lR=D,t.$pR=R,t.$qR=I,t.$rR=j,t.$sR=$,t.$wR=V,t.$yR=C,t.$zR=G,t.$AR=te,t.$BR=$e,t.$CR=De,t.$ER=he,t.$FR=_,t.$GR=ae,t.$HR=le,t.$IR=J,t.$JR=Q,t.$KR=se,t.$LR=fe,t.$MR=ve,t.$NR=Ne,t.$OR=Le,t.$PR=x,t.$QR=y,t.$RR=p,t.$SR=k,t.$TR=s,t.$UR=E,t.$VR=v,t.$WR=L,t.$XR=z,t.$YR=X,t.$ZR=U,t.$1R=oe,t.$2R=we,t.$3R=me,t.$4R=ke,t.$5R=je,t.$6R=Te,t.$7R=We,t.$9R=Ye,t.$0R=_e,t.$$R=Re,t.$_R=xe,t.$aS=et,t.$bS=it,t.$cS=st,t.$dS=Je,t.$fS=rt,t.$hS=tt,t.$iS=mt,t.$jS=At,t.$kS=kt,t.$lS=Tt,t.$mS=Pe,t.$nS=ue,t.$=nt,t.$pS=at,t.$qS=Xe,t.$rS=ut,t.$sS=$t,t.$tS=Xt,t.$uS=Si,t.$vS=Ai,t.$wS=ki,t.$xS=Ti,t.$yS=Fi,t.$zS=Ci,t.$AS=Ni,t.$BS=Ri,t.$CS=Ii,t.$DS=Ut,t.$ES=Li,t.$FS=Mi,t.$GS=ji,t.$HS=_t,t.$JS=Pi,t.$KS=xi,t.$MS=zi,t.h=qi,t.$PS=ti,t.$QS=Qi,r=function(){const q=new Map;(0,n.$QQ)(n.$RQ,1);const K={window:n.$RQ,disposables:new w.$Tc};q.set(n.$RQ.vscodeWindowId,K);const ee=new m.$_d,de=new m.$_d,Se=new m.$_d;function Be(Oe,qe){return(typeof Oe=="number"?q.get(Oe):void 0)??(qe?K:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:de.event,registerWindow(Oe){if(q.has(Oe.vscodeWindowId))return w.$Uc.None;const qe=new w.$Tc,Ke={window:Oe,disposables:qe.add(new w.$Tc)};return q.set(Oe.vscodeWindowId,Ke),qe.add((0,w.$Sc)(()=>{q.delete(Oe.vscodeWindowId),de.fire(Oe)})),qe.add(D(Oe,t.$eS.BEFORE_UNLOAD,()=>{Se.fire(Oe)})),ee.fire(Ke),qe},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return q.has(Oe)},getWindowById:Be,getWindow(Oe){const qe=Oe;if(qe?.ownerDocument?.defaultView)return qe.ownerDocument.defaultView.window;const Ke=Oe;return Ke?.view?Ke.view.window:n.$RQ},getDocument(Oe){const qe=Oe;return(0,t.getWindow)(qe).document}}}(),t.registerWindow=r.registerWindow,t.getWindow=r.getWindow,t.getDocument=r.getDocument,t.getWindows=r.getWindows,t.getWindowsCount=r.getWindowsCount,t.getWindowId=r.getWindowId,t.getWindowById=r.getWindowById,t.hasWindow=r.hasWindow,t.onDidRegisterWindow=r.onDidRegisterWindow,t.onWillUnregisterWindow=r.onWillUnregisterWindow,t.onDidUnregisterWindow=r.onDidUnregisterWindow;function h(q){for(;q.firstChild;)q.firstChild.remove()}class g{constructor(K,ee,de,Se){this.f=K,this.g=ee,this.d=de,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function D(q,K,ee,de){return new g(q,K,ee,de)}function o(q,K){return function(ee){return K(new W.$dR(q,ee))}}function d(q){return function(K){return q(new P.$iR(K))}}const l=function(K,ee,de,Se){let Be=de;return ee==="click"||ee==="mousedown"?Be=o((0,t.getWindow)(K),de):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(Be=d(de)),D(K,ee,Be,Se)};t.$mR=l;const T=function(K,ee,de){const Se=o((0,t.getWindow)(K),ee);return R(K,Se,de)};t.$nR=T;const N=function(K,ee,de){const Se=o((0,t.getWindow)(K),ee);return j(K,Se,de)};t.$oR=N;function R(q,K,ee){return D(q,c.$r&&F.$aR.pointerEvents?t.$eS.POINTER_DOWN:t.$eS.MOUSE_DOWN,K,ee)}function I(q,K,ee){return D(q,c.$r&&F.$aR.pointerEvents?t.$eS.POINTER_MOVE:t.$eS.MOUSE_MOVE,K,ee)}function j(q,K,ee){return D(q,c.$r&&F.$aR.pointerEvents?t.$eS.POINTER_UP:t.$eS.MOUSE_UP,K,ee)}function $(q,K,ee){return(0,S.$Eh)(q,K,ee)}class O extends S.$Fh{constructor(K,ee){super(K,ee)}}t.$tR=O;function V(q,K,ee,de){let Se=0;const Be=q.setInterval(()=>{Se++,(typeof de=="number"&&Se>=de||K()===!0)&&Oe.dispose()},ee),Oe=(0,w.$Sc)(()=>{q.clearInterval(Be)});return Oe}class M extends S.$yh{constructor(K){super(),this.f=K&&(0,t.getWindow)(K)}cancelAndSet(K,ee,de){return super.cancelAndSet(K,ee,de??this.f)}}t.$xR=M;class H{constructor(K,ee=0){this.d=K,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,A.$1)(K)}}static sort(K,ee){return ee.priority-K.priority}}(function(){const q=new Map,K=new Map,ee=new Map,de=new Map,Se=Be=>{ee.set(Be,!1);const Oe=q.get(Be)??[];for(K.set(Be,Oe),q.set(Be,[]),de.set(Be,!0);Oe.length>0;)Oe.sort(H.sort),Oe.shift().execute();de.set(Be,!1)};t.$vR=(Be,Oe,qe=0)=>{const Ke=(0,t.getWindowId)(Be),Ge=new H(Oe,qe);let lt=q.get(Ke);return lt||(lt=[],q.set(Ke,lt)),lt.push(Ge),ee.get(Ke)||(ee.set(Ke,!0),Be.requestAnimationFrame(()=>Se(Ke))),Ge},t.$uR=(Be,Oe,qe)=>{const Ke=(0,t.getWindowId)(Be);if(de.get(Ke)){const Ge=new H(Oe,qe);let lt=K.get(Ke);return lt||(lt=[],K.set(Ke,lt)),lt.push(Ge),Ge}else return(0,t.$vR)(Be,Oe,qe)}})();function C(q,K){return(0,t.$vR)(q,K,1e4)}function G(q,K){return(0,t.$vR)(q,K,-1e4)}const Z=8,ce=function(q,K){return K};class re extends w.$Uc{constructor(K,ee,de,Se=ce,Be=Z){super();let Oe=null,qe=0;const Ke=this.B(new S.$xh),Ge=()=>{qe=new Date().getTime(),de(Oe),Oe=null};this.B(D(K,ee,lt=>{Oe=Se(Oe,lt);const Ct=new Date().getTime()-qe;Ct>=Be?(Ke.cancel(),Ge()):Ke.setIfNotSet(Ge,Be-Ct)}))}}function te(q,K,ee,de,Se){return new re(q,K,ee,de,Se)}function $e(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}function De(q,K){const ee=(0,t.getWindow)(q),de=ee.document;if(q!==de.body)return new He(q.clientWidth,q.clientHeight);if(c.$r&&ee?.visualViewport)return new He(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new He(ee.innerWidth,ee.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new He(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new He(de.documentElement.clientWidth,de.documentElement.clientHeight);if(K)return De(K);throw new Error("Unable to figure out browser width and height")}class Fe{static d(K,ee){return parseFloat(ee)||0}static f(K,ee,de){const Se=$e(K),Be=Se?Se.getPropertyValue(ee):"0";return Fe.d(K,Be)}static getBorderLeftWidth(K){return Fe.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return Fe.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return Fe.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return Fe.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return Fe.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return Fe.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return Fe.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return Fe.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return Fe.f(K,"margin-left","marginLeft")}static getMarginTop(K){return Fe.f(K,"margin-top","marginTop")}static getMarginRight(K){return Fe.f(K,"margin-right","marginRight")}static getMarginBottom(K){return Fe.f(K,"margin-bottom","marginBottom")}}class He{static{this.None=new He(0,0)}constructor(K,ee){this.width=K,this.height=ee}with(K=this.width,ee=this.height){return K!==this.width||ee!==this.height?new He(K,ee):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof He?K:new He(K.width,K.height)}static equals(K,ee){return K===ee?!0:!K||!ee?!1:K.width===ee.width&&K.height===ee.height}}t.$DR=He;function he(q){let K=q.offsetParent,ee=q.offsetTop,de=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){ee-=q.scrollTop;const Se=E(q)?null:$e(q);Se&&(de-=Se.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===K&&(de+=Fe.getBorderLeftWidth(q),ee+=Fe.getBorderTopWidth(q),ee+=q.offsetTop,de+=q.offsetLeft,K=q.offsetParent)}return{left:de,top:ee}}function _(q,K,ee){typeof K=="number"&&(q.style.width=`${K}px`),typeof ee=="number"&&(q.style.height=`${ee}px`)}function ae(q,K,ee,de,Se,Be="absolute"){typeof K=="number"&&(q.style.top=`${K}px`),typeof ee=="number"&&(q.style.right=`${ee}px`),typeof de=="number"&&(q.style.bottom=`${de}px`),typeof Se=="number"&&(q.style.left=`${Se}px`),q.style.position=Be}function le(q){const K=q.getBoundingClientRect(),ee=(0,t.getWindow)(q);return{left:K.left+ee.scrollX,top:K.top+ee.scrollY,width:K.width,height:K.height}}function J(q){let K=q,ee=1;do{const de=$e(K).zoom;de!=null&&de!=="1"&&(ee*=de),K=K.parentElement}while(K!==null&&K!==K.ownerDocument.documentElement);return ee}function Q(q){const K=Fe.getMarginLeft(q)+Fe.getMarginRight(q);return q.offsetWidth+K}function se(q){const K=Fe.getBorderLeftWidth(q)+Fe.getBorderRightWidth(q),ee=Fe.getPaddingLeft(q)+Fe.getPaddingRight(q);return q.offsetWidth-K-ee}function fe(q){const K=Fe.getMarginLeft(q)+Fe.getMarginRight(q);return q.scrollWidth+K}function ve(q){const K=Fe.getBorderTopWidth(q)+Fe.getBorderBottomWidth(q),ee=Fe.getPaddingTop(q)+Fe.getPaddingBottom(q);return q.offsetHeight-K-ee}function Ne(q){const K=Fe.getMarginTop(q)+Fe.getMarginBottom(q);return q.offsetHeight+K}function Ae(q,K){if(q===null)return 0;const ee=he(q),de=he(K);return ee.left-de.left}function Le(q,K){const ee=K.map(Se=>Math.max(fe(Se),Q(Se))+Ae(Se,q)||0);return Math.max(...ee)}function x(q,K){return!!K?.contains(q)}const u="parentFlowToElementId";function y(q,K){q.dataset[u]=K.id}function a(q){const K=q.dataset[u];return typeof K=="string"?q.ownerDocument.getElementById(K):null}function p(q,K){let ee=q;for(;ee;){if(ee===K)return!0;if(ee instanceof HTMLElement){const de=a(ee);if(de){ee=de;continue}}ee=ee.parentNode}return!1}function k(q,K,ee){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(K))return q;if(ee){if(typeof ee=="string"){if(q.classList.contains(ee))return null}else if(q===ee)return null}q=q.parentNode}return null}function s(q,K,ee){return!!k(q,K,ee)}function E(q){return q&&!!q.host&&!!q.mode}function v(q){return!!L(q)}function L(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return E(q)?q:null}function z(){let q=we().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}function X(q){return z()===q}function U(q){return x(z(),q)}function oe(q){return q.ownerDocument===we()}function we(){return(0,t.getWindowsCount)()<=1?n.$RQ.document:Array.from((0,t.getWindows)()).map(({window:K})=>K.document).find(K=>K.hasFocus())??n.$RQ.document}function me(){return we().defaultView?.window??n.$RQ}const Ie=new Map;function ke(q){return Ie.has(q)}function je(){return new Ee}class Ee{constructor(){this.d="",this.f=void 0}setStyle(K){K!==this.d&&(this.d=K,this.f?this.f.innerText=K:this.f=Te(n.$RQ.document.head,ee=>ee.innerText=K))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Te(q=n.$RQ.document.head,K,ee){const de=document.createElement("style");if(de.type="text/css",de.media="screen",K?.(de),q.appendChild(de),ee&&ee.add((0,w.$Sc)(()=>q.removeChild(de))),q===n.$RQ.document.head){const Se=new Set;Ie.set(de,Se);for(const{window:Be,disposables:Oe}of(0,t.getWindows)()){if(Be===n.$RQ)continue;const qe=Oe.add(Ue(de,Se,Be));ee?.add(qe)}}return de}function We(q){const K=new w.$Tc;for(const[ee,de]of Ie)K.add(Ue(ee,de,q));return K}function Ue(q,K,ee){const de=new w.$Tc,Se=q.cloneNode(!0);ee.document.head.appendChild(Se),de.add((0,w.$Sc)(()=>ee.document.head.removeChild(Se)));for(const Be of ye(q))Se.sheet?.insertRule(Be.cssText,Se.sheet?.cssRules.length);return de.add(t.$8R.observe(q,de,{childList:!0})(()=>{Se.textContent=q.textContent})),K.add(Se),de.add((0,w.$Sc)(()=>K.delete(Se))),de}t.$8R=new class{constructor(){this.mutationObservers=new Map}observe(q,K,ee){let de=this.mutationObservers.get(q);de||(de=new Map,this.mutationObservers.set(q,de));const Se=(0,e.$bj)(ee);let Be=de.get(Se);if(Be)Be.users+=1;else{const Oe=new m.$_d,qe=new MutationObserver(Ge=>Oe.fire(Ge));qe.observe(q,ee);const Ke=Be={users:1,observer:qe,onDidMutate:Oe.event};K.add((0,w.$Sc)(()=>{Ke.users-=1,Ke.users===0&&(Oe.dispose(),qe.disconnect(),de?.delete(Se),de?.size===0&&this.mutationObservers.delete(q))})),de.set(Se,Be)}return Be.onDidMutate}};function Ye(q=n.$RQ.document.head){return Y("meta",q)}function _e(q=n.$RQ.document.head){return Y("link",q)}function Y(q,K=n.$RQ.document.head){const ee=document.createElement(q);return K.appendChild(ee),ee}let ie=null;function pe(){return ie||(ie=Te()),ie}function ye(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Re(q,K,ee=pe()){if(!(!ee||!K)){ee.sheet?.insertRule(`${q} {${K}}`,0);for(const de of Ie.get(ee)??[])Re(q,K,de)}}function xe(q,K=pe()){if(!K)return;const ee=ye(K),de=[];for(let Se=0;Se<ee.length;Se++){const Be=ee[Se];Ve(Be)&&Be.selectorText.indexOf(q)!==-1&&de.push(Se)}for(let Se=de.length-1;Se>=0;Se--)K.sheet?.deleteRule(de[Se]);for(const Se of Ie.get(K)??[])xe(q,Se)}function Ve(q){return typeof q.selectorText=="string"}function et(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}function it(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}function st(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}function Je(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$eS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$5Q?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$5Q?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$5Q?"webkitAnimationIteration":"animationiteration"};function rt(q){const K=q;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.$gS={stop:(q,K)=>(q.preventDefault(),K&&q.stopPropagation(),q)};function tt(q){const K=[];for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)K[ee]=q.scrollTop,q=q.parentNode;return K}function mt(q,K){for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)q.scrollTop!==K[ee]&&(q.scrollTop=K[ee]),q=q.parentNode}class gt extends w.$Uc{static m(K){if(K instanceof HTMLElement){const ee=L(K),de=ee?ee.activeElement:K.ownerDocument.activeElement;return x(de,K)}else{const ee=K;return x(ee.document.activeElement,ee.document)}}constructor(K){super(),this.f=this.B(new m.$_d),this.onDidFocus=this.f.event,this.g=this.B(new m.$_d),this.onDidBlur=this.g.event;let ee=gt.m(K),de=!1;const Se=()=>{de=!1,ee||(ee=!0,this.f.fire())},Be=()=>{ee&&(de=!0,(K instanceof HTMLElement?(0,t.getWindow)(K):K).setTimeout(()=>{de&&(de=!1,ee=!1,this.g.fire())},0))};this.j=()=>{gt.m(K)!==ee&&(ee?Be():Se())},this.B(D(K,t.$eS.FOCUS,Se,!0)),this.B(D(K,t.$eS.BLUR,Be,!0)),K instanceof HTMLElement&&(this.B(D(K,t.$eS.FOCUS_IN,()=>this.j())),this.B(D(K,t.$eS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(q){return new gt(q)}function kt(q,K){return q.after(K),K}function Tt(q,...K){if(q.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}function Pe(q,K){return q.insertBefore(K,q.firstChild),K}function ue(q,...K){q.innerText="",Tt(q,...K)}const Ce=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Me;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(Me||(t.Namespace=Me={}));function Qe(q,K,ee,...de){const Se=Ce.exec(K);if(!Se)throw new Error("Bad use of emmet");const Be=Se[1]||"div";let Oe;return q!==Me.HTML?Oe=document.createElementNS(q,Be):Oe=document.createElement(Be),Se[3]&&(Oe.id=Se[3]),Se[4]&&(Oe.className=Se[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([qe,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(qe)?Oe[qe]=Ke:qe==="selected"?Ke&&Oe.setAttribute(qe,"true"):Oe.setAttribute(qe,Ke))}),Oe.append(...de),Oe}function nt(q,K,...ee){return Qe(Me.HTML,q,K,...ee)}nt.SVG=function(q,K,...ee){return Qe(Me.SVG,q,K,...ee)};function at(q,K){const ee=[];return q.forEach((de,Se)=>{Se>0&&(K instanceof Node?ee.push(K.cloneNode()):ee.push(document.createTextNode(K))),ee.push(de)}),ee}function Xe(q,...K){q?ut(...K):$t(...K)}function ut(...q){for(const K of q)K.style.display="",K.removeAttribute("aria-hidden")}function $t(...q){for(const K of q)K.style.display="none",K.setAttribute("aria-hidden","true")}function Ft(q,K){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(K))return q;q=q.parentNode}return null}function Xt(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Ft(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}function Si(q){return K=>{K.preventDefault(),K.stopPropagation(),q(K)}}function Ai(q){return new Promise(K=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)K(void 0);else{const de=()=>{q.window.removeEventListener("DOMContentLoaded",de,!1),K()};q.window.addEventListener("DOMContentLoaded",de,!1)}})}function ki(q,K){const ee=q.devicePixelRatio*K;return Math.max(1,Math.floor(ee))/q.devicePixelRatio}function Ti(q){n.$RQ.open(q,"_blank","noopener")}const Zt=780,Jt=640;function Fi(q){const K=Math.floor(n.$RQ.screenLeft+n.$RQ.innerWidth/2-Zt/2),ee=Math.floor(n.$RQ.screenTop+n.$RQ.innerHeight/2-Jt/2);n.$RQ.open(q,"_blank",`width=${Zt},height=${Jt},top=${ee},left=${K}`)}function Ci(q,K=!0){const ee=n.$RQ.open();return ee?(K&&(ee.opener=null),ee.location.href=q,!0):!1}function Ni(q,K){const ee=()=>{K(),de=(0,t.$vR)(q,ee)};let de=(0,t.$vR)(q,ee);return(0,w.$Sc)(()=>de.dispose())}B.$Ag.setPreferredWebSchema(/^https:/.test(n.$RQ.location.href)?"https":"http");function Ri(q){return q?`url('${B.$Hg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ii(q){return`'${q.replace(/'/g,"%27")}'`}function Ut(q,K){if(q!==void 0){const ee=q.match(/^\s*var\((.+)\)$/);if(ee){const de=ee[1].split(",",2);return de.length===2&&(K=Ut(de[1].trim(),K)),`var(${de[0]}, ${K})`}return q}return K}function Li(q,K){let ee;if(f.URI.isUri(q))ee=q.toString(!0);else{const Be=new Blob([q]);ee=URL.createObjectURL(Be),setTimeout(()=>URL.revokeObjectURL(ee))}const de=me(),Se=document.createElement("a");de.document.body.appendChild(Se),Se.download=K,Se.href=ee,Se.click(),setTimeout(()=>de.document.body.removeChild(Se))}function Mi(){return new Promise(q=>{const K=me(),ee=document.createElement("input");K.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{q(ee.files??void 0)}),ee.click(),setTimeout(()=>K.document.body.removeChild(ee))})}var yt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function ji(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:yt.BROWSER,guess:!1}:(c.$j||c.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:yt.BROWSER,guess:!0}:null}function _t(q,K=!1){const ee=document.createElement("a");return b.addHook("afterSanitizeAttributes",de=>{for(const Se of["href","src"])if(de.hasAttribute(Se)){const Be=de.getAttribute(Se);if(Se==="href"&&Be.startsWith("#"))continue;if(ee.href=Be,!q.includes(ee.protocol.replace(/:$/,""))){if(K&&Se==="src"&&ee.href.startsWith("data:"))continue;de.removeAttribute(Se)}}}),(0,w.$Sc)(()=>{b.removeHook("afterSanitizeAttributes")})}const Oi=[B.Schemas.http,B.Schemas.https,B.Schemas.command];t.$IS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Hi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Pi(q,K){const ee=_t(Oi);try{const de=b.sanitize(K,Hi);q.innerHTML=de}finally{ee.dispose()}}function Bi(q){const K=new Uint16Array(q.length);for(let Se=0;Se<K.length;Se++)K[Se]=q.charCodeAt(Se);let ee="";const de=new Uint8Array(K.buffer);for(let Se=0;Se<de.length;Se++)ee+=String.fromCharCode(de[Se]);return ee}function xi(q){return btoa(Bi(q))}class pt extends m.$_d{constructor(){super(),this.o=new w.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:K,disposables:ee})=>this.C(K,ee),{window:n.$RQ,disposables:this.o}))}C(K,ee){ee.add(D(K,"keydown",de=>{if(de.defaultPrevented)return;const Se=new P.$iR(de);if(!(Se.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Se.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),ee.add(D(K,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),ee.add(D(K.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(D(K.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(D(K.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add(D(K,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$LS=pt;function zi(q){const K=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}class Wi extends w.$Uc{constructor(K,ee){super(),this.j=K,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(D(this.j,t.$eS.DRAG_START,K=>{this.m.onDragStart?.(K)})),this.m.onDrag&&this.B(D(this.j,t.$eS.DRAG,K=>{this.m.onDrag?.(K)})),this.B(D(this.j,t.$eS.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.m.onDragEnter?.(K)})),this.B(D(this.j,t.$eS.DRAG_OVER,K=>{K.preventDefault(),this.m.onDragOver?.(K,K.timeStamp-this.g)})),this.B(D(this.j,t.$eS.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(K))})),this.B(D(this.j,t.$eS.DRAG_END,K=>{this.f=0,this.g=0,this.m.onDragEnd?.(K)})),this.B(D(this.j,t.$eS.DROP,K=>{this.f=0,this.g=0,this.m.onDrop?.(K)}))}}t.$NS=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(q,...K){let ee,de;Array.isArray(K[0])?(ee={},de=K[0]):(ee=K[0]||{},de=K[1]);const Se=Vi.exec(q);if(!Se||!Se.groups)throw new Error("Bad use of h");const Be=Se.groups.tag||"div",Oe=document.createElement(Be);Se.groups.id&&(Oe.id=Se.groups.id);const qe=[];if(Se.groups.class)for(const Ge of Se.groups.class.split("."))Ge!==""&&qe.push(Ge);if(ee.className!==void 0)for(const Ge of ee.className.split("."))Ge!==""&&qe.push(Ge);qe.length>0&&(Oe.className=qe.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=Oe),de)for(const Ge of de)Ge instanceof HTMLElement?Oe.appendChild(Ge):typeof Ge=="string"?Oe.append(Ge):"root"in Ge&&(Object.assign(Ke,Ge),Oe.appendChild(Ge.root));for(const[Ge,lt]of Object.entries(ee))if(Ge!=="className")if(Ge==="style")for(const[Ct,Ht]of Object.entries(lt))Oe.style.setProperty(ei(Ct),typeof Ht=="number"?Ht+"px":""+Ht);else Ge==="tabIndex"?Oe.tabIndex=lt:Oe.setAttribute(ei(Ge),lt.toString());return Ke.root=Oe,Ke}function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,K,ee){for(const{name:de,value:Se}of q.attributes)(!ee||ee.includes(de))&&K.setAttribute(de,Se)}function Ki(q,K,ee){const de=q.getAttribute(ee);de?K.setAttribute(ee,de):K.removeAttribute(ee)}function Qi(q,K,ee){ti(q,K,ee);const de=new w.$Tc;return de.add(t.$8R.observe(q,de,{attributes:!0,attributeFilter:ee})(Se=>{for(const Be of Se)Be.type==="attributes"&&Be.attributeName&&Ki(q,K,Be.attributeName)})),de}}),define(ge[65],be([1,0,4,2,128]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SS=t.$RS=void 0,t.$TS=S;class W extends F.$Uc{constructor(m,b){super(),this.B((0,i.$lR)(m,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{b(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$lR)(m,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$RS=W,t.$SS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.$Es.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function S(A,m,b,w,B){const c=document.createElement("div");if(c.className=b,c.textContent=m,B&&(c.style.color=B),w&&(c.style.background=w),A.dataTransfer){const f=(0,i.getWindow)(A).document;f.body.appendChild(c),A.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>f.body.removeChild(c),0)}}}),define(ge[66],be([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kT=F,t.$lT=P,t.$mT=W;function F(c,f={}){const e=W(f);return e.textContent=c,e}function P(c,f={}){const e=W(f);return m(e,b(c,!!f.renderCodeSegments),f.actionHandler,f.renderCodeSegments),e}function W(c){const f=c.inline?"span":"div",e=document.createElement(f);return c.className&&(e.className=c.className),e}class S{constructor(f){this.b=f,this.c=0}eos(){return this.c>=this.b.length}next(){const f=this.peek();return this.advance(),f}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(A||(A={}));function m(c,f,e,n){let r;if(f.type===2)r=document.createTextNode(f.content||"");else if(f.type===3)r=document.createElement("b");else if(f.type===4)r=document.createElement("i");else if(f.type===7&&n)r=document.createElement("code");else if(f.type===5&&e){const h=document.createElement("a");e.disposables.add(i.$mR(h,"click",g=>{e.callback(String(f.index),g)})),r=h}else f.type===8?r=document.createElement("br"):f.type===1&&(r=c);r&&c!==r&&c.appendChild(r),r&&Array.isArray(f.children)&&f.children.forEach(h=>{m(r,h,e,n)})}function b(c,f){const e={type:1,children:[]};let n=0,r=e;const h=[],g=new S(c);for(;!g.eos();){let D=g.next();const o=D==="\\"&&B(g.peek(),f)!==0;if(o&&(D=g.next()),!o&&w(D,f)&&D===g.peek()){g.advance(),r.type===2&&(r=h.pop());const d=B(D,f);if(r.type===d||r.type===5&&d===6)r=h.pop();else{const l={type:d,children:[]};d===5&&(l.index=n,n++),r.children.push(l),h.push(r),r=l}}else if(D===`
`)r.type===2&&(r=h.pop()),r.children.push({type:8});else if(r.type!==2){const d={type:2,content:D};r.children.push(d),h.push(r),r=d}else r.content+=D}return r.type===2&&(r=h.pop()),h.length,e}function w(c,f){return B(c,f)!==0}function B(c,f){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return f?7:0;default:return 0}}}),define(ge[67],be([1,0,4,2]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XS=void 0;class P{constructor(){this.a=new F.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(S,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,S&&m&&m(A)}isMonitoring(){return!!this.b}startMonitoring(S,A,m,b,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=b,this.c=w;let B=S;try{S.setPointerCapture(A),this.a.add((0,F.$Sc)(()=>{try{S.releasePointerCapture(A)}catch{}}))}catch{B=i.getWindow(S)}this.a.add(i.$lR(B,i.$eS.POINTER_MOVE,c=>{if(c.buttons!==m){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$lR(B,i.$eS.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$XS=P});var Ze=this&&this.__decorate||function(ne,t,i,F){var P=arguments.length,W=P<3?t:F===null?F=Object.getOwnPropertyDescriptor(t,i):F,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(ne,t,i,F);else for(var A=ne.length-1;A>=0;A--)(S=ne[A])&&(W=(P<3?S(W):P>3?S(t,i,W):S(t,i))||W);return P>3&&W&&Object.defineProperty(t,i,W),W};define(ge[28],be([1,0,4,22,8,31,3,2,55]),function(ne,t,i,F,P,W,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=t.EventType=void 0;var b;(function(B){B.Tap="-monaco-gesturetap",B.Change="-monaco-gesturechange",B.Start="-monaco-gesturestart",B.End="-monaco-gesturesend",B.Contextmenu="-monaco-gesturecontextmenu"})(b||(t.EventType=b={}));class w extends A.$Uc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new m.$5c,this.m=new m.$5c,this.r={},this.n=null,this.s=0,this.B(S.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:f})=>{f.add(i.$lR(c.document,"touchstart",e=>this.w(e),{passive:!1})),f.add(i.$lR(c.document,"touchend",e=>this.z(c,e))),f.add(i.$lR(c.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:F.$RQ,disposables:this.q}))}static addTarget(c){if(!w.isTouchDevice())return A.$Uc.None;w.f||(w.f=(0,A.$Nc)(new w));const f=w.f.j.push(c);return(0,A.$Sc)(f)}static ignoreTarget(c){if(!w.isTouchDevice())return A.$Uc.None;w.f||(w.f=(0,A.$Nc)(new w));const f=w.f.m.push(c);return(0,A.$Sc)(f)}static isTouchDevice(){return"ontouchstart"in F.$RQ||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(c){const f=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,n=c.targetTouches.length;e<n;e++){const r=c.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:f,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[f],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(b.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}z(c,f){const e=Date.now(),n=Object.keys(this.r).length;for(let r=0,h=f.changedTouches.length;r<h;r++){const g=f.changedTouches.item(r);if(!this.r.hasOwnProperty(String(g.identifier))){console.warn("move of an UNKNOWN touch",g);continue}const D=this.r[g.identifier],o=Date.now()-D.initialTimeStamp;if(o<w.g&&Math.abs(D.initialPageX-P.$sb(D.rollingPageX))<30&&Math.abs(D.initialPageY-P.$sb(D.rollingPageY))<30){const d=this.C(b.Tap,D.initialTarget);d.pageX=P.$sb(D.rollingPageX),d.pageY=P.$sb(D.rollingPageY),this.D(d)}else if(o>=w.g&&Math.abs(D.initialPageX-P.$sb(D.rollingPageX))<30&&Math.abs(D.initialPageY-P.$sb(D.rollingPageY))<30){const d=this.C(b.Contextmenu,D.initialTarget);d.pageX=P.$sb(D.rollingPageX),d.pageY=P.$sb(D.rollingPageY),this.D(d)}else if(n===1){const d=P.$sb(D.rollingPageX),l=P.$sb(D.rollingPageY),T=P.$sb(D.rollingTimestamps)-D.rollingTimestamps[0],N=d-D.rollingPageX[0],R=l-D.rollingPageY[0],I=[...this.j].filter(j=>D.initialTarget instanceof Node&&j.contains(D.initialTarget));this.F(c,I,e,Math.abs(N)/T,N>0?1:-1,d,Math.abs(R)/T,R>0?1:-1,l)}this.D(this.C(b.End,D.initialTarget)),delete this.r[g.identifier]}this.h&&(f.preventDefault(),f.stopPropagation(),this.h=!1)}C(c,f){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=f,e.tapCount=0,e}D(c){if(c.type===b.Tap){const f=new Date().getTime();let e=0;f-this.s>w.u?e=1:e=2,this.s=f,c.tapCount=e}else(c.type===b.Change||c.type===b.Contextmenu)&&(this.s=0);if(c.initialTarget instanceof Node){for(const e of this.m)if(e.contains(c.initialTarget))return;const f=[];for(const e of this.j)if(e.contains(c.initialTarget)){let n=0,r=c.initialTarget;for(;r&&r!==e;)n++,r=r.parentElement;f.push([n,e])}f.sort((e,n)=>e[0]-n[0]);for(const[e,n]of f)n.dispatchEvent(c),this.h=!0}}F(c,f,e,n,r,h,g,D,o){this.n=i.$vR(c,()=>{const d=Date.now(),l=d-e;let T=0,N=0,R=!0;n+=w.c*l,g+=w.c*l,n>0&&(R=!1,T=r*n*l),g>0&&(R=!1,N=D*g*l);const I=this.C(b.Change);I.translationX=T,I.translationY=N,f.forEach(j=>j.dispatchEvent(I)),R||this.F(c,f,d,n,r,h+T,g,D,o+N)})}G(c){const f=Date.now();for(let e=0,n=c.changedTouches.length;e<n;e++){const r=c.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],g=this.C(b.Change,h.initialTarget);g.translationX=r.pageX-P.$sb(h.rollingPageX),g.translationY=r.pageY-P.$sb(h.rollingPageY),g.pageX=r.pageX,g.pageY=r.pageY,this.D(g),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(f)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}}t.$US=w,Ze([W.$Rh],w,"isTouchDevice",null)}),define(ge[68],be([1,0,4,104]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=b,t.$pT=w,t.$qT=B;const F=2e4;let P,W,S,A,m;function b(f){P=document.createElement("div"),P.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};W=e(),S=e();const n=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};A=n(),m=n(),f.appendChild(P)}function w(f){P&&(W.textContent!==f?(i.$kR(S),c(W,f)):(i.$kR(W),c(S,f)))}function B(f){P&&(A.textContent!==f?(i.$kR(m),c(A,f)):(i.$kR(A),c(m,f)))}function c(f,e){i.$kR(f),e.length>F&&(e=e.substr(0,F)),f.textContent=e,f.style.visibility="hidden",f.style.visibility="visible"}}),define(ge[130],be([1,0,4,19]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=W,t.$UT=S;const P=new RegExp(`(\\\\)?\\$\\((${F.ThemeIcon.iconNameExpression}(?:${F.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(A){const m=new Array;let b,w=0,B=0;for(;(b=P.exec(A))!==null;){B=b.index||0,w<B&&m.push(A.substring(w,B)),w=(b.index||0)+b[0].length;const[,c,f]=b;m.push(c?`$(${f})`:S({id:f}))}return w<A.length&&m.push(A.substring(w)),m}function S(A){const m=i.$("span");return m.classList.add(...F.ThemeIcon.asClassNameArray(A)),m}}),define(ge[131],be([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wT=void 0;function F(W){try{W.parentElement?.removeChild(W)}catch{}}class P{constructor(S){this.d=S,this.a=new Map,this.b=new Set,this.c=!1}alloc(S){let A=this.h(S).pop(),m=!1;if(A)m=this.b.has(A.domNode),m&&this.b.delete(A.domNode);else{const b=(0,i.$)(".monaco-list-row"),B=this.i(S).renderTemplate(b);A={domNode:b,templateId:S,templateData:B}}return{row:A,isReusingConnectedDomNode:m}}release(S){S&&this.f(S)}transact(S){if(this.c)throw new Error("Already in transaction");this.c=!0;try{S()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(S){const{domNode:A,templateId:m}=S;A&&(this.c?this.b.add(A):this.g(A)),this.h(m).push(S)}g(S){S.classList.remove("scrolling"),F(S)}h(S){let A=this.a.get(S);return A||(A=[],this.a.set(S,A)),A}dispose(){this.a.forEach((S,A)=>{for(const m of S)this.i(A).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(S){const A=this.d.get(S);if(!A)throw new Error(`No renderer found for ${S}`);return A}}t.$wT=P}),define(ge[132],be([1,0,11,2]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=void 0;class P extends F.$Uc{constructor(S,A,m){super(),this.a=S,this.b=A,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$xh)}setVisibility(S){this.a!==S&&(this.a=S,this.s())}setShouldBeVisible(S){this.g=S,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const S=this.r();this.h!==S&&(this.h=S,this.ensureVisibility())}setIsNeeded(S){this.j!==S&&(this.j=S,this.ensureVisibility())}setDomNode(S){this.f=S,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(S){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(S?" fade":"")))}}t.$3S=P}),define(ge[133],be([1,0,4,28,8,3,2,5]),function(ne,t,i,F,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4T=void 0;class m extends S.$Uc{constructor(w,B,c,f){super(),this.f=0,this.b=f||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$_d),this.h=c,this.j(),this.setOptions(w,B)}j(){this.B(F.$US.addTarget(this.a)),[F.EventType.Tap].forEach(w=>{this.B(i.$lR(this.a,w,B=>{this.a.focus()}))}),this.B(i.$mR(this.a,"click",w=>{i.$gS.stop(w,!0)})),this.B(i.$mR(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(i.$mR(this.a,"keydown",w=>{let B=!1;A.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(B=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(B=!0),B&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,B){(!this.c||!P.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((c,f)=>{this.a.add(this.m(c.text,f,c.isDisabled))})),B!==void 0&&this.select(B)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,B,c){const f=document.createElement("option");return f.value=w,f.text=w,f.disabled=!!c,f}}t.$4T=m}),define(ge[69],be([1,0,30,8,11,60,98,3,32]),function(ne,t,i,F,P,W,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BV=void 0,t.$zV=b,t.$AV=w;function b(f){return typeof f=="object"&&"visibility"in f&&"data"in f}function w(f){switch(f){case!0:return 1;case!1:return 0;default:return f}}function B(f){return typeof f.collapsible=="boolean"}class c{constructor(e,n,r,h={}){this.p=e,this.q=n,this.rootRef=[],this.d=new A.$he,this.f=new A.$_d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$_d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new A.$_d,this.onDidSplice=this.m.event,this.o=new P.$kh(W.$9d),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,r=m.Iterable.empty(),h={}){if(e.length===0)throw new i.$xV(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,n,r,h):this.t(e,n,r,h)}s(e,n,r,h=m.Iterable.empty(),g,D=g.diffDepth??0){const{parentNode:o}=this.H(n);if(!o.lastDiffIds)return this.t(n,r,h,g);const d=[...h],l=n[n.length-1],T=new S.$nt({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,l),...d,...o.children.slice(l+r)].map($=>e.getId($.element).toString())}).ComputeDiff(!1);if(T.quitEarly)return o.lastDiffIds=void 0,this.t(n,r,d,g);const N=n.slice(0,-1),R=($,O,V)=>{if(D>0)for(let M=0;M<V;M++)$--,O--,this.s(e,[...N,$,0],Number.MAX_SAFE_INTEGER,d[O].children,g,D-1)};let I=Math.min(o.children.length,l+r),j=d.length;for(const $ of T.changes.sort((O,V)=>V.originalStart-O.originalStart))R(I,j,I-($.originalStart+$.originalLength)),I=$.originalStart,j=$.modifiedStart-l,this.t([...N,I],$.originalLength,m.Iterable.slice(d,j,j+$.modifiedLength),g);R(I,j,I)}t(e,n,r=m.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:g,diffIdentityProvider:D}){const{parentNode:o,listIndex:d,revealed:l,visible:T}=this.H(e),N=[],R=m.Iterable.map(r,G=>this.x(G,o,o.visible?1:0,l,N,h)),I=e[e.length-1];let j=0;for(let G=I;G>=0&&G<o.children.length;G--){const Z=o.children[G];if(Z.visible){j=Z.visibleChildIndex;break}}const $=[];let O=0,V=0;for(const G of R)$.push(G),V+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=j+O++);const M=(0,F.$6b)(o.children,I,n,$);D?o.lastDiffIds?(0,F.$6b)(o.lastDiffIds,I,n,$.map(G=>D.getId(G.element).toString())):o.lastDiffIds=o.children.map(G=>D.getId(G.element).toString()):o.lastDiffIds=void 0;let H=0;for(const G of M)G.visible&&H++;if(H!==0)for(let G=I+$.length;G<o.children.length;G++){const Z=o.children[G];Z.visible&&(Z.visibleChildIndex-=H)}if(o.visibleChildrenCount+=O-H,l&&T){const G=M.reduce((Z,ce)=>Z+(ce.visible?ce.renderNodeCount:0),0);this.C(o,V-G),this.q.splice(d,G,N)}if(M.length>0&&g){const G=Z=>{g(Z),Z.children.forEach(G)};M.forEach(G)}this.m.fire({insertedNodes:$,deletedNodes:M});let C=o;for(;C;){if(C.visibility===2){this.o.trigger(()=>this.refilter());break}C=C.parent}}rerender(e){if(e.length===0)throw new i.$xV(this.p,"Invalid tree location");const{node:n,listIndex:r,revealed:h}=this.G(e);n.visible&&h&&this.q.splice(r,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$xV(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:r,revealed:h}=this.G(e);return r&&h?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const r=this.F(e);typeof n>"u"&&(n=!r.collapsible);const h={collapsible:n};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,r){const h=this.F(e);typeof n>"u"&&(n=!h.collapsed);const g={collapsed:n,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,g))}u(e,n){const{node:r,listIndex:h,revealed:g}=this.G(e),D=this.v(r,h,g,n);if(r!==this.c&&this.l&&D&&!B(n)&&r.collapsible&&!r.collapsed&&!n.recursive){let o=-1;for(let d=0;d<r.children.length;d++)if(r.children[d].visible)if(o>-1){o=-1;break}else o=d;o>-1&&this.u([...e,o],n)}return D}v(e,n,r,h){const g=this.w(e,h,!1);if(!r||!e.visible||!g)return g;const D=e.renderNodeCount,o=this.y(e),d=D-(n===-1?0:1);return this.q.splice(n+1,d,o.slice(1)),g}w(e,n,r){let h;if(e===this.c?h=!1:(B(n)?(h=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(h=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!B(n)&&n.recursive)for(const g of e.children)h=this.w(g,n,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,r,h,g,D){const o={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},d=this.D(o,r);o.visibility=d,h&&g.push(o);const l=e.children||m.Iterable.empty(),T=h&&d!==0&&!o.collapsed;let N=0,R=1;for(const I of l){const j=this.x(I,o,d,T,g,D);o.children.push(j),R+=j.renderNodeCount,j.visible&&(j.visibleChildIndex=N++)}return this.j||(o.collapsible=o.collapsible||o.children.length>0),o.visibleChildrenCount=N,o.visible=d===2?N>0:d===1,o.visible?o.collapsed||(o.renderNodeCount=R):(o.renderNodeCount=0,h&&g.pop()),D?.(o),o}y(e){const n=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-n),r}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,r=[];return this.B(e,e.visible?1:0,r),this.C(e.parent,r.length-n),r}B(e,n,r,h=!0){let g;if(e!==this.c){if(g=this.D(e,n),g===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const D=r.length;e.renderNodeCount=e===this.c?0:1;let o=!1;if(!e.collapsed||g!==0){let d=0;for(const l of e.children)o=this.B(l,g,r,h&&!e.collapsed)||o,l.visible&&(l.visibleChildIndex=d++);e.visibleChildrenCount=d}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=g===2?o:g===1,e.visibility=g),e.visible?e.collapsed||(e.renderNodeCount+=r.length-D):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const r=this.k?this.k.filter(e.element,n):1;return typeof r=="boolean"?(e.filterData=void 0,r?1:0):b(r)?(e.filterData=r.data,w(r.visibility)):(e.filterData=void 0,w(r))}E(e,n=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>n.children.length?!1:this.E(h,n.children[r])}F(e,n=this.c){if(!e||e.length===0)return n;const[r,...h]=e;if(r<0||r>n.children.length)throw new i.$xV(this.p,"Invalid tree location");return this.F(h,n.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:r,revealed:h,visible:g}=this.H(e),D=e[e.length-1];if(D<0||D>n.children.length)throw new i.$xV(this.p,"Invalid tree location");const o=n.children[D];return{node:o,listIndex:r,revealed:h,visible:g&&o.visible}}H(e,n=this.c,r=0,h=!0,g=!0){const[D,...o]=e;if(D<0||D>n.children.length)throw new i.$xV(this.p,"Invalid tree location");for(let d=0;d<D;d++)r+=n.children[d].renderNodeCount;return h=h&&!n.collapsed,g=g&&n.visible,o.length===0?{parentNode:n,listIndex:r,revealed:h,visible:g}:this.H(o,n.children[D],r+1,h,g)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let r=e;for(;r.parent;)n.push(r.parent.children.indexOf(r)),r=r.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,F.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$BV=c}),define(ge[134],be([1,0,69,30,32]),function(ne,t,i,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IV=void 0;class W{get size(){return this.d.size}constructor(A,m,b={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$BV(A,m,null,b),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,b.sorter&&(this.j={compare(w,B){return b.sorter.compare(w.element,B.element)}}),this.h=b.identityProvider}setChildren(A,m=P.Iterable.empty(),b={}){const w=this.o(A);this.l(w,this.m(m),b)}l(A,m=P.Iterable.empty(),b){const w=new Set,B=new Set,c=e=>{if(e.element===null)return;const n=e;if(w.add(n.element),this.d.set(n.element,n),this.h){const r=this.h.getId(n.element).toString();B.add(r),this.f.set(r,n)}b.onDidCreateNode?.(n)},f=e=>{if(e.element===null)return;const n=e;if(w.has(n.element)||this.d.delete(n.element),this.h){const r=this.h.getId(n.element).toString();B.has(r)||this.f.delete(r)}b.onDidDeleteNode?.(n)};this.c.splice([...A,0],Number.MAX_VALUE,m,{...b,onDidCreateNode:c,onDidDeleteNode:f})}m(A=P.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),P.Iterable.map(A,m=>{let b=this.d.get(m.element);if(!b&&this.h){const c=this.h.getId(m.element).toString();b=this.f.get(c)}if(!b){let c;return typeof m.collapsed>"u"?c=void 0:m.collapsed===F.ObjectTreeElementCollapseState.Collapsed||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:m.collapsed===F.ObjectTreeElementCollapseState.Expanded||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!m.collapsed,{...m,children:this.m(m.children),collapsed:c}}const w=typeof m.collapsible=="boolean"?m.collapsible:b.collapsible;let B;return typeof m.collapsed>"u"||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?B=b.collapsed:m.collapsed===F.ObjectTreeElementCollapseState.Collapsed?B=!0:m.collapsed===F.ObjectTreeElementCollapseState.Expanded?B=!1:B=!!m.collapsed,{...m,collapsible:w,collapsed:B,children:this.m(m.children)}})}rerender(A){const m=this.o(A);this.c.rerender(m)}updateElementHeight(A,m){const b=this.o(A);this.c.updateElementHeight(b,m)}resort(A=null,m=!0){if(!this.j)return;const b=this.o(A),w=this.c.getNode(b);this.l(b,this.n(w,m),{})}n(A,m,b=!0){let w=[...A.children];return(m||b)&&(w=w.sort(this.j.compare.bind(this.j))),P.Iterable.map(w,B=>({element:B.element,collapsible:B.collapsible,collapsed:B.collapsed,children:this.n(B,m,!1)}))}getFirstElementChild(A=null){const m=this.o(A);return this.c.getFirstElementChild(m)}getLastElementAncestor(A=null){const m=this.o(A);return this.c.getLastElementAncestor(m)}has(A){return this.d.has(A)}getListIndex(A){const m=this.o(A);return this.c.getListIndex(m)}getListRenderCount(A){const m=this.o(A);return this.c.getListRenderCount(m)}isCollapsible(A){const m=this.o(A);return this.c.isCollapsible(m)}setCollapsible(A,m){const b=this.o(A);return this.c.setCollapsible(b,m)}isCollapsed(A){const m=this.o(A);return this.c.isCollapsed(m)}setCollapsed(A,m,b){const w=this.o(A);return this.c.setCollapsed(w,m,b)}expandTo(A){const m=this.o(A);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(A);if(!m)throw new F.$xV(this.k,`Tree element not found: ${A}`);return m}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new F.$xV(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(A);if(!m)throw new F.$xV(this.k,`Tree element not found: ${A}`);const b=this.c.getNodeLocation(m),w=this.c.getParentNodeLocation(b);return this.c.getNode(w).element}o(A){if(A===null)return[];const m=this.d.get(A);if(!m)throw new F.$xV(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(m)}}t.$IV=W}),define(ge[21],be([1,0,4,15,20,28,2]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YS=void 0;class A extends S.$Uc{f(b,w){this.B(i.$lR(b,i.$eS.CLICK,B=>w(new P.$dR(i.getWindow(b),B))))}j(b,w){this.B(i.$lR(b,i.$eS.MOUSE_DOWN,B=>w(new P.$dR(i.getWindow(b),B))))}m(b,w){this.B(i.$lR(b,i.$eS.MOUSE_OVER,B=>w(new P.$dR(i.getWindow(b),B))))}u(b,w){this.B(i.$lR(b,i.$eS.MOUSE_LEAVE,B=>w(new P.$dR(i.getWindow(b),B))))}z(b,w){this.B(i.$lR(b,i.$eS.KEY_DOWN,B=>w(new F.$iR(B))))}C(b,w){this.B(i.$lR(b,i.$eS.KEY_UP,B=>w(new F.$iR(B))))}D(b,w){this.B(i.$lR(b,i.$eS.INPUT,w))}F(b,w){this.B(i.$lR(b,i.$eS.BLUR,w))}G(b,w){this.B(i.$lR(b,i.$eS.FOCUS,w))}H(b,w){this.B(i.$lR(b,i.$eS.CHANGE,w))}I(b){return W.$US.ignoreTarget(b)}}t.$YS=A}),define(ge[48],be([1,0,67,21,11,19,4]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=t.$ZS=void 0,t.$ZS=11;class A extends F.$YS{constructor(b){super(),this.a=b.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=b.bgWidth+"px",this.bgDomNode.style.height=b.bgHeight+"px",typeof b.top<"u"&&(this.bgDomNode.style.top="0px"),typeof b.left<"u"&&(this.bgDomNode.style.left="0px"),typeof b.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof b.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=b.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(b.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$ZS+"px",this.domNode.style.height=t.$ZS+"px",typeof b.top<"u"&&(this.domNode.style.top=b.top+"px"),typeof b.left<"u"&&(this.domNode.style.left=b.left+"px"),typeof b.bottom<"u"&&(this.domNode.style.bottom=b.bottom+"px"),typeof b.right<"u"&&(this.domNode.style.right=b.right+"px"),this.g=this.B(new i.$XS),this.B(S.$mR(this.bgDomNode,S.$eS.POINTER_DOWN,w=>this.h(w))),this.B(S.$mR(this.domNode,S.$eS.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new S.$xR),this.c=this.B(new P.$xh)}h(b){if(!b.target||!(b.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,S.getWindow(b))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring(b.target,b.pointerId,b.buttons,B=>{},()=>{this.b.cancel(),this.c.cancel()}),b.preventDefault()}}t.$1S=A}),define(ge[70],be([1,0,4,51,67,48,132,21,5]),function(ne,t,i,F,P,W,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4S=void 0;const b=140;class w extends A.$YS{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new S.$3S(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new P.$XS),this.s=!0,this.domNode=(0,F.$WS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$lR(this.domNode.domNode,i.$eS.POINTER_DOWN,f=>this.M(f)))}t(c){const f=this.B(new W.$1S(c));this.domNode.domNode.appendChild(f.bgDomNode),this.domNode.domNode.appendChild(f.domNode)}w(c,f,e,n){this.slider=(0,F.$WS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(f),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$lR(this.slider.domNode,i.$eS.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const f=this.domNode.domNode.getClientRects()[0].top,e=f+this.h.getSliderPosition(),n=f+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U(c);e<=r&&r<=n?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let f,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")f=c.offsetX,e=c.offsetY;else{const r=i.$HR(this.domNode.domNode);f=c.pageX-r.left,e=c.pageY-r.top}const n=this.S(f,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const f=this.U(c),e=this.W(c),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,r=>{const h=this.W(r),g=Math.abs(h-e);if(m.$i&&g>b){this.P(n.getScrollPosition());return}const o=this.U(r)-f;this.P(n.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const f={};this.writeScrollPosition(f,c),this.b.setScrollPositionNow(f)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$4S=w}),define(ge[135],be([1,0,20,70,48,52,18]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=void 0;class A extends F.$4S{constructor(b,w,B){const c=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:B,scrollbarState:new W.$2S(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,c.width,c.scrollWidth,f.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-P.$ZS)/2,n=(w.horizontalScrollbarSize-P.$ZS)/2;this.t({className:"scra",icon:S.$Mj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$fR(null,1,0))}),this.t({className:"scra",icon:S.$Mj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$fR(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R(b,w){this.slider.setWidth(b),this.slider.setLeft(w)}Q(b,w){this.domNode.setWidth(b),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this.s=this.J(b.scrollWidth)||this.s,this.s=this.L(b.scrollLeft)||this.s,this.s=this.y(b.width)||this.s,this.s}S(b,w){return b}U(b){return b.pageX}W(b){return b.pageY}X(b){this.slider.setHeight(b)}writeScrollPosition(b,w){b.scrollLeft=w}updateOptions(b){this.updateScrollbarSize(b.horizontal===2?0:b.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.n.setVisibility(b.horizontal),this.c=b.scrollByPage}}t.$5S=A}),define(ge[136],be([1,0,20,70,48,52,18]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=void 0;class A extends F.$4S{constructor(b,w,B){const c=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:B,scrollbarState:new W.$2S(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,c.height,c.scrollHeight,f.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-P.$ZS)/2,n=(w.verticalScrollbarSize-P.$ZS)/2;this.t({className:"scra",icon:S.$Mj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$fR(null,0,1))}),this.t({className:"scra",icon:S.$Mj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$fR(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R(b,w){this.slider.setHeight(b),this.slider.setTop(w)}Q(b,w){this.domNode.setWidth(w),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this.s=this.J(b.scrollHeight)||this.s,this.s=this.L(b.scrollTop)||this.s,this.s=this.y(b.height)||this.s,this.s}S(b,w){return w}U(b){return b.pageY}W(b){return b.pageX}X(b){this.slider.setWidth(b)}writeScrollPosition(b,w){b.scrollTop=w}updateOptions(b){this.updateScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(b.vertical),this.c=b.scrollByPage}}t.$6S=A}),define(ge[71],be([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$S=t.$0S=t.$9S=t.$8S=t.$7S=void 0;const e=500,n=50,r=!0;class h{constructor(R,I,j){this.timestamp=R,this.deltaX=I,this.deltaY=j,this.score=0}}class g{static{this.INSTANCE=new g}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,I=0,j=1,$=this.d;do{const O=$===this.c?R:Math.pow(2,-j);if(R-=O,I+=this.b[$].score*O,$===this.c)break;$=(this.a+$-1)%this.a,j++}while(!0);return I<=.5}acceptStandardWheelEvent(R){if(i.$6Q){const I=F.getWindow(R.browserEvent),j=(0,i.$YQ)(I);this.accept(Date.now(),R.deltaX*j,R.deltaY*j)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,I,j){let $=null;const O=new h(R,I,j);this.c===-1&&this.d===-1?(this.b[0]=O,this.c=0,this.d=0):($=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=O),O.score=this.f(O,$)}f(R,I){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let j=.5;if((!this.g(R.deltaX)||!this.g(R.deltaY))&&(j+=.25),I){const $=Math.abs(R.deltaX),O=Math.abs(R.deltaY),V=Math.abs(I.deltaX),M=Math.abs(I.deltaY),H=Math.max(Math.min($,V),1),C=Math.max(Math.min(O,M),1),G=Math.max($,V),Z=Math.max(O,M);G%H===0&&Z%C===0&&(j-=.5)}return Math.min(Math.max(j,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$7S=g;class D extends m.$YS{get options(){return this.a}constructor(R,I,j){super(),this.O=this.B(new w.$_d),this.onScroll=this.O.event,this.P=this.B(new w.$_d),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=T(I),this.b=j,this.B(this.b.onScroll(O=>{this.P.fire(O),this.S(O),this.O.fire(O)}));const $={onMouseWheel:O=>this.R(O),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$6S(this.b,this.a,$)),this.g=this.B(new S.$5S(this.b,this.a,$)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,P.$WS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,P.$WS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,P.$WS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,O=>this.Z(O)),this.u(this.t,O=>this.Y(O)),this.L=this.B(new b.$xh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,B.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new W.$fR(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,B.$Pc)(this.w),R)){const j=$=>{this.R(new W.$fR($))};this.w.push(F.$lR(this.t,F.$eS.MOUSE_WHEEL,j,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const I=g.INSTANCE;r&&I.acceptStandardWheelEvent(R);let j=!1;if(R.deltaY||R.deltaX){let O=R.deltaY*this.a.mouseWheelScrollSensitivity,V=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+O===0?V=O=0:Math.abs(O)>=Math.abs(V)?V=0:O=0),this.a.flipAxes&&([O,V]=[V,O]);const M=!c.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||M)&&!V&&(V=O,O=0),R.browserEvent&&R.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,O=O*this.a.fastScrollSensitivity);const H=this.b.getFutureScrollPosition();let C={};if(O){const G=n*O,Z=H.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this.c.writeScrollPosition(C,Z)}if(V){const G=n*V,Z=H.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this.g.writeScrollPosition(C,Z)}C=this.b.validateScrollPosition(C),(H.scrollLeft!==C.scrollLeft||H.scrollTop!==C.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&I.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(C):this.b.setScrollPositionNow(C),j=!0)}let $=j;!$&&this.a.alwaysConsumeMouseWheel&&($=!0),!$&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&($=!0),$&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),I=R.scrollTop>0,j=R.scrollLeft>0,$=j?" left":"",O=I?" top":"",V=j||I?" top-left-corner":"";this.n.setClassName(`shadow${$}`),this.r.setClassName(`shadow${O}`),this.s.setClassName(`shadow${V}${O}${$}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$8S=D;class o extends D{constructor(R,I){I=I||{},I.mouseWheelSmoothScroll=!1;const j=new f.$Ks({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>F.$vR(F.getWindow(R),$)});super(R,I,j),this.B(j)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$9S=o;class d extends D{constructor(R,I,j){super(R,I,j)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$0S=d;class l extends D{constructor(R,I){I=I||{},I.mouseWheelSmoothScroll=!1;const j=new f.$Ks({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>F.$vR(F.getWindow(R),$)});super(R,I,j),this.B(j),this.cb=R,this.B(this.onScroll($=>{$.scrollTopChanged&&(this.cb.scrollTop=$.scrollTop),$.scrollLeftChanged&&(this.cb.scrollLeft=$.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$$S=l;function T(N){const R={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return R.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:R.verticalScrollbarSize,c.$j&&(R.className+=" mac"),R}}),define(ge[72],be([1,0,65,4,24,28,71,8,11,31,3,2,56,58,93,131,6,40]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e,n,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=t.$zT=t.$yT=t.$xT=t.ListViewTargetSector=void 0;const g={CurrentDragAndDropData:void 0};var D;(function(j){j[j.TOP=0]="TOP",j[j.CENTER_TOP=1]="CENTER_TOP",j[j.CENTER_BOTTOM=2]="CENTER_BOTTOM",j[j.BOTTOM=3]="BOTTOM"})(D||(t.ListViewTargetSector=D={}));const o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(j){return[j]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context($){this.d=$}constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$xT=d;class l{constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$yT=l;class T{constructor(){this.types=[],this.files=[]}update($){if($.types&&this.types.splice(0,this.types.length,...$.types),$.files){this.files.splice(0,this.files.length);for(let O=0;O<$.files.length;O++){const V=$.files.item(O);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$zT=T;function N(j,$){return Array.isArray(j)&&Array.isArray($)?(0,A.$ub)(j,$):j===$}class R{constructor($){$?.getSetSize?this.getSetSize=$.getSetSize.bind($):this.getSetSize=(O,V,M)=>M,$?.getPosInSet?this.getPosInSet=$.getPosInSet.bind($):this.getPosInSet=(O,V)=>V+1,$?.getRole?this.getRole=$.getRole.bind($):this.getRole=O=>"listitem",$?.isChecked?this.isChecked=$.isChecked.bind($):this.isChecked=O=>{}}}class I{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q($){if($!==this.P){if($&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=$,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const O of this.d)this.ab(O);this.X(),this.q.setScrollDimensions({width:(0,F.$KR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor($,O,V,M=o){if(this.R=O,this.domId=`list_id_${++I.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$kh(50),this.v=!1,this.x=B.$Uc.None,this.y=0,this.G=!1,this.K=B.$Uc.None,this.L=B.$Uc.None,this.M=new B.$Tc,this.N=new w.$_d,this.O=new w.$_d,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,M.horizontalScrolling&&M.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(M.paddingTop??0);for(const C of V)this.j.set(C.templateId,C);this.h=this.M.add(new n.$wT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof M.mouseSupport=="boolean"?M.mouseSupport:!0),this.P=M.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof M.paddingBottom>"u"?0:M.paddingBottom,this.D=new R(M.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(M.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(W.$US.addTarget(this.o)),this.p=this.M.add(new f.$Ks({forceIntegerValues:!0,smoothScrollDuration:M.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:C=>(0,F.$vR)((0,F.getWindow)(this.domNode),C)})),this.q=this.M.add(new S.$0S(this.o,{alwaysConsumeMouseWheel:M.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:M.verticalScrollMode??o.verticalScrollMode,useShadows:M.useShadows??o.useShadows,mouseWheelScrollSensitivity:M.mouseWheelScrollSensitivity,fastScrollSensitivity:M.fastScrollSensitivity,scrollByPage:M.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),$.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,F.$lR)(this.o,W.EventType.Change,C=>this.jb(C))),this.M.add((0,F.$lR)(this.q.getDomNode(),"scroll",C=>C.target.scrollTop=0)),this.M.add((0,F.$lR)(this.domNode,"dragover",C=>this.lb(this.hb(C)))),this.M.add((0,F.$lR)(this.domNode,"drop",C=>this.nb(this.hb(C)))),this.M.add((0,F.$lR)(this.domNode,"dragleave",C=>this.mb(this.hb(C)))),this.M.add((0,F.$lR)(this.domNode,"dragend",C=>this.ob(C))),this.z=M.setRowLineHeight??o.setRowLineHeight,this.A=M.setRowHeight??o.setRowHeight,this.B=M.supportDynamicHeights??o.supportDynamicHeights,this.F=M.dnd??this.M.add(o.dnd),this.layout(M.initialSize?.height,M.initialSize?.width)}updateOptions($){$.paddingBottom!==void 0&&(this.C=$.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),$.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration($.smoothScrolling?125:0),$.horizontalScrolling!==void 0&&(this.Q=$.horizontalScrolling);let O;if($.scrollByPage!==void 0&&(O={...O??{},scrollByPage:$.scrollByPage}),$.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:$.mouseWheelScrollSensitivity}),$.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:$.fastScrollSensitivity}),O&&this.q.updateOptions(O),$.paddingTop!==void 0&&$.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),M=$.paddingTop-this.g.paddingTop;this.g.paddingTop=$.paddingTop,this.Y(V,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent($){this.q.delegateScrollFromMouseWheelEvent($)}delegateVerticalScrollbarPointerDown($){this.q.delegateVerticalScrollbarPointerDown($)}updateElementHeight($,O,V){if($<0||$>=this.d.length)return;const M=this.d[$].size;if(typeof O>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[$].lastDynamicHeightWidth=void 0,O=M+this.xb($)}if(M===O)return;const H=this.vb(this.k,this.m);let C=0;$<H.start||V!==null&&V>$&&V<H.end?C=O-M:C=0,this.g.splice($,1,[{size:O}]),this.d[$].size=O,this.Y(H,Math.max(0,this.k+C),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S($){return new e.$vT($)}splice($,O,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U($,O,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U($,O,V=[]){const M=this.vb(this.k,this.m),H={start:$,end:$+O},C=c.Range.intersect(M,H),G=new Map;for(let Q=C.end-1;Q>=C.start;Q--){const se=this.d[Q];if(se.dragStartDisposable.dispose(),se.checkedDisposable.dispose(),se.row){let fe=G.get(se.templateId);fe||(fe=[],G.set(se.templateId,fe));const ve=this.j.get(se.templateId);ve&&ve.disposeElement&&ve.disposeElement(se.element,Q,se.row.templateData,se.size),fe.unshift(se.row)}se.row=null,se.stale=!0}const Z={start:$+O,end:this.d.length},ce=c.Range.intersect(Z,M),re=c.Range.relativeComplement(Z,M),te=V.map(Q=>({id:String(this.f++),element:Q,templateId:this.R.getTemplateId(Q),size:this.R.getHeight(Q),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(Q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:B.$Uc.None,checkedDisposable:B.$Uc.None,stale:!1}));let $e;$===0&&O>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,te),$e=this.d,this.d=te):(this.g.splice($,O,te),$e=this.d.splice($,O,...te));const De=V.length-O,Fe=this.vb(this.k,this.m),He=(0,e.$tT)(ce,De),he=c.Range.intersect(Fe,He);for(let Q=he.start;Q<he.end;Q++)this.bb(this.d[Q],Q);const _=c.Range.relativeComplement(He,Fe);for(const Q of _)for(let se=Q.start;se<Q.end;se++)this.db(se);const ae=re.map(Q=>(0,e.$tT)(Q,De)),J=[{start:$,end:$+V.length},...ae].map(Q=>c.Range.intersect(Fe,Q)).reverse();for(const Q of J)for(let se=Q.end-1;se>=Q.start;se--){const fe=this.d[se],Ne=G.get(fe.templateId)?.pop();this.Z(se,Ne)}for(const Q of G.values())for(const se of Q)this.h.release(se);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),$e.map(Q=>Q.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,F.$vR)((0,F.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let $=0;for(const O of this.d)typeof O.width<"u"&&($=Math.max($,O.width));this.E=$,this.q.setScrollDimensions({scrollWidth:$===0?0:$+10}),this.O.fire(this.E)}updateWidth($){if(!this.Q||typeof this.E>"u")return;const O=this.d[$];this.ab(O),typeof O.width<"u"&&O.width>this.E&&(this.E=O.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const $ of this.d)$.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const $=this.firstVisibleIndex,O=this.g.positionAt($),V=this.g.positionAt($+1);return V!==-1&&(V-O)/2+O<this.scrollTop?$+1:$}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element($){return this.d[$].element}indexOf($){return this.d.findIndex(O=>O.element===$)}domElement($){const O=this.d[$].row;return O&&O.domNode}elementHeight($){return this.d[$].size}elementTop($){return this.g.positionAt($)}indexAt($){return this.g.indexAt($)}indexAfter($){return this.g.indexAfter($)}layout($,O){const V={height:typeof $=="number"?$:(0,F.$MR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof O<"u"&&(this.n=O,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof O=="number"?O:(0,F.$KR)(this.domNode)})}Y($,O,V,M,H,C=!1){const G=this.vb(O,V),Z=c.Range.relativeComplement(G,$).reverse(),ce=c.Range.relativeComplement($,G);if(C){const re=c.Range.intersect($,G);for(let te=re.start;te<re.end;te++)this.bb(this.d[te],te)}this.h.transact(()=>{for(const re of ce)for(let te=re.start;te<re.end;te++)this.db(te);for(const re of Z)for(let te=re.end-1;te>=re.start;te--)this.Z(te)}),M!==void 0&&(this.o.style.left=`-${M}px`),this.o.style.top=`-${O}px`,this.Q&&H!==void 0&&(this.o.style.width=`${Math.max(H,this.n)}px`),this.k=O,this.m=V}Z($,O){const V=this.d[$];if(!V.row)if(O)V.row=O,V.stale=!0;else{const Z=this.h.alloc(V.templateId);V.row=Z.row,V.stale||=Z.isReusingConnectedDomNode}const M=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",M);const H=this.D.isChecked(V.element);if(typeof H=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!H));else if(H){const Z=ce=>V.row.domNode.setAttribute("aria-checked",String(!!ce));Z(H.value),V.checkedDisposable=H.onDidChange(Z)}if(V.stale||!V.row.domNode.parentElement){const Z=this.d.at($+1)?.row?.domNode??null;(V.row.domNode.parentElement!==this.o||V.row.domNode.nextElementSibling!==Z)&&this.o.insertBefore(V.row.domNode,Z),V.stale=!1}this.bb(V,$);const C=this.j.get(V.templateId);if(!C)throw new Error(`No renderer found for template id ${V.templateId}`);C?.renderElement(V.element,$,V.row.templateData,V.size);const G=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!G,G&&(V.dragStartDisposable=(0,F.$lR)(V.row.domNode,"dragstart",Z=>this.kb(V.element,G,Z))),this.Q&&(this.ab(V),this.W())}ab($){if(!$.row||!$.row.domNode)return;$.row.domNode.style.width="fit-content",$.width=(0,F.$KR)($.row.domNode);const O=(0,F.getWindow)($.row.domNode).getComputedStyle($.row.domNode);O.paddingLeft&&($.width+=parseFloat(O.paddingLeft)),O.paddingRight&&($.width+=parseFloat(O.paddingRight)),$.row.domNode.style.width=""}bb($,O){$.row.domNode.style.top=`${this.elementTop(O)}px`,this.A&&($.row.domNode.style.height=`${$.size}px`),this.z&&($.row.domNode.style.lineHeight=`${$.size}px`),$.row.domNode.setAttribute("data-index",`${O}`),$.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),$.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),$.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize($.element,O,this.length))),$.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet($.element,O))),$.row.domNode.setAttribute("id",this.getElementDomId(O)),$.row.domNode.classList.toggle("drop-target",$.dropTarget)}db($){const O=this.d[$];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const V=this.j.get(O.templateId);V&&V.disposeElement&&V.disposeElement(O.element,$,O.row.templateData,O.size),this.h.release(O.row),O.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop($,O){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:$,reuseAnimation:O})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft($){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:$})}get scrollTop(){return this.getScrollTop()}set scrollTop($){this.setScrollTop($)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"click")).event,$=>this.eb($),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"dblclick")).event,$=>this.eb($),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new P.$nT(this.domNode,"auxclick")).event,$=>this.eb($),this.M),$=>$.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"mouseup")).event,$=>this.eb($),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"mousedown")).event,$=>this.eb($),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"mouseover")).event,$=>this.eb($),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"mousemove")).event,$=>this.eb($),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"mouseout")).event,$=>this.eb($),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new P.$nT(this.domNode,"contextmenu")).event,$=>this.eb($),this.M),w.Event.map(this.M.add(new P.$nT(this.domNode,W.EventType.Contextmenu)).event,$=>this.gb($),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new P.$nT(this.domNode,"touchstart")).event,$=>this.fb($),this.M)}get onTap(){return w.Event.map(this.M.add(new P.$nT(this.o,W.EventType.Tap)).event,$=>this.gb($),this.M)}eb($){const O=this.ub($.target||null),V=typeof O>"u"?void 0:this.d[O],M=V&&V.element;return{browserEvent:$,index:O,element:M}}fb($){const O=this.ub($.target||null),V=typeof O>"u"?void 0:this.d[O],M=V&&V.element;return{browserEvent:$,index:O,element:M}}gb($){const O=this.ub($.initialTarget||null),V=typeof O>"u"?void 0:this.d[O],M=V&&V.element;return{browserEvent:$,index:O,element:M}}hb($){const O=this.ub($.target||null),V=typeof O>"u"?void 0:this.d[O],M=V&&V.element,H=this.tb($,O);return{browserEvent:$,index:O,element:M,sector:H}}ib($){try{const O=this.vb(this.k,this.m);this.Y(O,$.scrollTop,$.height,$.scrollLeft,$.scrollWidth),this.B&&this.wb($.scrollTop,$.height,$.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",$),O}}jb($){$.preventDefault(),$.stopPropagation(),this.scrollTop-=$.translationY}kb($,O,V){if(!V.dataTransfer)return;const M=this.F.getDragElements($);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(i.$SS.TEXT,O),V.dataTransfer.setDragImage){let H;this.F.getDragLabel&&(H=this.F.getDragLabel(M,V)),typeof H>"u"&&(H=String(M.length));const C=(0,F.$)(".monaco-drag-image");C.textContent=H;const Z=(ce=>{for(;ce&&!ce.classList.contains("monaco-workbench");)ce=ce.parentElement;return ce||this.domNode.ownerDocument})(this.domNode);Z.appendChild(C),V.dataTransfer.setDragImage(C,-10,-10),setTimeout(()=>Z.removeChild(C),0)}this.domNode.classList.add("dragging"),this.H=new d(M),g.CurrentDragAndDropData=new l(M),this.F.onDragStart?.(this.H,V)}lb($){if($.browserEvent.preventDefault(),this.L.dispose(),g.CurrentDragAndDropData&&g.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb($.browserEvent),!$.browserEvent.dataTransfer))return!1;if(!this.H)if(g.CurrentDragAndDropData)this.H=g.CurrentDragAndDropData;else{if(!$.browserEvent.dataTransfer.types)return!1;this.H=new T}const O=this.F.onDragOver(this.H,$.element,$.index,$.sector,$.browserEvent);if(this.G=typeof O=="boolean"?O:O.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;$.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===0?"copy":"move";let V;typeof O!="boolean"&&O.feedback?V=O.feedback:typeof $.index>"u"?V=[-1]:V=[$.index],V=(0,A.$Mb)(V).filter(H=>H>=-1&&H<this.length).sort((H,C)=>H-C),V=V[0]===-1?[-1]:V;let M=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:"drop-target";if(N(this.I,V)&&this.J===M)return!0;if(this.I=V,this.J=M,this.K.dispose(),V[0]===-1)this.domNode.classList.add(M),this.o.classList.add(M),this.K=(0,B.$Sc)(()=>{this.domNode.classList.remove(M),this.o.classList.remove(M)});else{if(V.length>1&&M!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");M==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,M="drop-target-before");for(const H of V){const C=this.d[H];C.dropTarget=!0,C.row?.domNode.classList.add(M)}this.K=(0,B.$Sc)(()=>{for(const H of V){const C=this.d[H];C.dropTarget=!1,C.row?.domNode.classList.remove(M)}})}return!0}mb($){this.L.dispose(),this.L=(0,m.$ph)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,$.element,$.index,$.browserEvent)}nb($){if(!this.G)return;const O=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,!(!O||!$.browserEvent.dataTransfer)&&($.browserEvent.preventDefault(),O.update($.browserEvent.dataTransfer),this.F.drop(O,$.element,$.index,$.sector,$.browserEvent))}ob($){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,this.F.onDragEnd?.($)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=B.$Uc.None}qb($){if(!this.w){const O=(0,F.$ER)(this.domNode).top;this.w=(0,F.$AS)((0,F.getWindow)(this.domNode),this.rb.bind(this,O))}this.x.dispose(),this.x=(0,m.$ph)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=$.pageY}rb($){if(this.y===void 0)return;const O=this.y-$,V=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb($,O){if(O===void 0)return;const V=$.offsetY/this.d[O].size,M=Math.floor(V/.25);return(0,h.$sm)(M,0,3)}ub($){const O=this.q.getDomNode();let V=$;for(;V instanceof HTMLElement&&V!==this.o&&O.contains(V);){const M=V.getAttribute("data-index");if(M){const H=Number(M);if(!isNaN(H))return H}V=V.parentElement}}vb($,O){return{start:this.g.indexAt($),end:this.g.indexAfter($+O-1)}}wb($,O,V){const M=this.vb($,O);let H,C;$===this.elementTop(M.start)?(H=M.start,C=0):M.end-M.start>1&&(H=M.start+1,C=this.elementTop(H)-$);let G=0;for(;;){const Z=this.vb($,O);let ce=!1;for(let re=Z.start;re<Z.end;re++){const te=this.xb(re);te!==0&&this.g.splice(re,1,[this.d[re]]),G+=te,ce=ce||te!==0}if(!ce){G!==0&&this.V();const re=c.Range.relativeComplement(M,Z);for(const $e of re)for(let De=$e.start;De<$e.end;De++)this.d[De].row&&this.db(De);const te=c.Range.relativeComplement(Z,M).reverse();for(const $e of te)for(let De=$e.end-1;De>=$e.start;De--)this.Z(De);for(let $e=Z.start;$e<Z.end;$e++)this.d[$e].row&&this.bb(this.d[$e],$e);if(typeof H=="number"){const $e=this.p.getFutureScrollPosition().scrollTop-$,De=this.elementTop(H)-C+$e;this.setScrollTop(De,V)}this.N.fire(this.contentHeight);return}}}xb($){const O=this.d[$];if(this.R.getDynamicHeight){const C=this.R.getDynamicHeight(O.element);if(C!==null){const G=O.size;return O.size=C,O.lastDynamicHeightWidth=this.n,C-G}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(O.element))return 0;const V=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.size===0&&!(0,F.$PR)(O.row.domNode,(0,F.getWindow)(O.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),O.lastDynamicHeightWidth=this.n,O.size-V;const{row:M}=this.h.alloc(O.templateId);M.domNode.style.height="",this.o.appendChild(M.domNode);const H=this.j.get(O.templateId);if(!H)throw new r.$cb("Missing renderer for templateId: "+O.templateId);return H.renderElement(O.element,$,M.templateData,void 0),O.size=M.domNode.offsetHeight,H.disposeElement?.(O.element,$,M.templateData,void 0),this.R.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.n,this.o.removeChild(M.domNode),this.h.release(M),O.size-V}getElementDomId($){return`${this.domId}_${$}`}dispose(){for(const $ of this.d)if($.dragStartDisposable.dispose(),$.checkedDisposable.dispose(),$.row){const O=this.j.get($.row.templateId);O&&(O.disposeElement?.($.element,-1,$.row.templateData,void 0),O.disposeTemplate($.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$AT=I,Ze([b.$Rh],I.prototype,"onMouseClick",null),Ze([b.$Rh],I.prototype,"onMouseDblClick",null),Ze([b.$Rh],I.prototype,"onMouseMiddleClick",null),Ze([b.$Rh],I.prototype,"onMouseUp",null),Ze([b.$Rh],I.prototype,"onMouseDown",null),Ze([b.$Rh],I.prototype,"onMouseOver",null),Ze([b.$Rh],I.prototype,"onMouseMove",null),Ze([b.$Rh],I.prototype,"onMouseOut",null),Ze([b.$Rh],I.prototype,"onContextMenu",null),Ze([b.$Rh],I.prototype,"onTouchStart",null),Ze([b.$Rh],I.prototype,"onTap",null)}),define(ge[49],be([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e,n,r,h,g,D,o,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ST=t.$RT=t.$QT=t.$PT=t.$MT=t.TypeNavigationMode=void 0,t.$ET=I,t.$FT=$,t.$GT=O,t.$HT=V,t.$IT=M,t.$JT=H,t.$KT=C,t.$LT=G,t.$NT=De,t.$OT=Fe;class l{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,y,a){const p=this.c.findIndex(k=>k.templateData===a);if(p>=0){const k=this.c[p];this.d.unrender(a),k.index=y}else{const k={index:y,templateData:a};this.c.push(k)}this.d.renderIndex(y,a)}splice(u,y,a){const p=[];for(const k of this.c)k.index<u?p.push(k):k.index>=u+y&&p.push({index:k.index+a-y,templateData:k.templateData});this.c=p}renderIndexes(u){for(const{index:y,templateData:a}of this.c)u.indexOf(y)>-1&&this.d.renderIndex(y,a)}disposeTemplate(u){const y=this.c.findIndex(a=>a.templateData===u);y<0||this.c.splice(y,1)}}class T{get name(){return this.g}get renderer(){return new l(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$_d,this.onChange=this.f.event}splice(u,y,a){const p=a.length-y,k=u+y,s=[];let E=0;for(;E<this.d.length&&this.d[E]<u;)s.push(this.d[E++]);for(let v=0;v<a.length;v++)a[v]&&s.push(v+u);for(;E<this.d.length&&this.d[E]>=k;)s.push(this.d[E++]+p);this.renderer.splice(u,y,a.length),this.h(s,s)}renderIndex(u,y){y.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,y){return this.h(u,[...u].sort(fe),y)}h(u,y,a){const p=this.c,k=this.d;this.c=u,this.d=y;const s=Q(k,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:a}),p}get(){return this.c}contains(u){return(0,m.$wb)(this.d,u,fe)>=0}dispose(){(0,e.$Pc)(this.f)}}Ze([B.$Rh],T.prototype,"renderer",null);class N extends T{constructor(u){super("selected"),this.k=u}renderIndex(u,y){super.renderIndex(u,y),this.k&&(this.contains(u)?y.setAttribute("aria-selected","true"):y.setAttribute("aria-selected","false"))}}class R{constructor(u,y,a){this.c=u,this.d=y,this.f=a}splice(u,y,a){if(!this.f)return this.c.splice(u,y,new Array(a.length).fill(!1));const p=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(p.length===0)return this.c.splice(u,y,new Array(a.length).fill(!1));const k=new Set(p),s=a.map(E=>k.has(this.f.getId(E).toString()));this.c.splice(u,y,s)}}function I(x){return x.tagName==="INPUT"||x.tagName==="TEXTAREA"}function j(x,u){return x.classList.contains(u)?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:j(x.parentElement,u)}function $(x){return j(x,"monaco-editor")}function O(x){return j(x,"monaco-custom-toggle")}function V(x){return j(x,"action-item")}function M(x){return j(x,"monaco-tl-twistie")}function H(x){return j(x,"monaco-tree-sticky-row")}function C(x){return x.classList.contains("monaco-tree-sticky-container")}function G(x){return x.tagName==="A"&&x.classList.contains("monaco-button")||x.tagName==="DIV"&&x.classList.contains("monaco-button-dropdown")?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:G(x.parentElement)}class Z{get g(){return c.Event.chain(this.c.add(new F.$nT(this.k.domNode,"keydown")).event,u=>u.filter(y=>!I(y.target)).map(y=>new P.$iR(y)))}constructor(u,y,a){this.h=u,this.k=y,this.c=new e.$Tc,this.d=new e.$Tc,this.f=a.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(r.$j?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ze([B.$Rh],Z.prototype,"g",null);var ce;(function(x){x[x.Automatic=0]="Automatic",x[x.Trigger=1]="Trigger"})(ce||(t.TypeNavigationMode=ce={}));var re;(function(x){x[x.Idle=0]="Idle",x[x.Typing=1]="Typing"})(re||(re={})),t.$MT=new class{mightProducePrintableCharacter(x){return x.ctrlKey||x.metaKey||x.altKey?!1:x.keyCode>=31&&x.keyCode<=56||x.keyCode>=21&&x.keyCode<=30||x.keyCode>=98&&x.keyCode<=107||x.keyCode>=85&&x.keyCode<=95}};class te{constructor(u,y,a,p,k){this.o=u,this.p=y,this.q=a,this.s=p,this.t=k,this.c=!1,this.d=re.Idle,this.f=ce.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??ce.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const y=c.Event.chain(this.k.add(new F.$nT(this.p.domNode,"keydown")).event,k=>k.filter(s=>!I(s.target)).filter(()=>this.f===ce.Automatic||this.g).map(s=>new P.$iR(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$gS.stop(s,!0)).map(s=>s.browserEvent.key)),a=c.Event.debounce(y,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(y,a),(k,s)=>s===null?null:(k||"")+s,void 0,this.k)(this.x,this,this.k),a(this.w,this,this.k),y(()=>u=!0,void 0,this.k),a(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const y=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));typeof y=="string"?(0,S.$pT)(y):y&&(0,S.$pT)(y.get())}this.h=-1}x(u){if(!u){this.d=re.Idle,this.g=!1;return}const y=this.o.getFocus(),a=y.length>0?y[0]:0,p=this.d===re.Idle?1:0;this.d=re.Typing;for(let k=0;k<this.o.length;k++){const s=(a+k+p)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(s)),v=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof v<"u"){if((0,f.$pk)(u,v)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}const L=(0,f.$wk)(u,v);if(L&&L[0].end-L[0].start>1&&L.length===1){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof v>"u"||(0,f.$pk)(u,v)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class $e{constructor(u,y){this.d=u,this.f=y,this.c=new e.$Tc;const a=c.Event.chain(this.c.add(new F.$nT(y.domNode,"keydown")).event,k=>k.filter(s=>!I(s.target)).map(s=>new P.$iR(s)));c.Event.chain(a,k=>k.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const y=this.d.getFocus();if(y.length===0)return;const a=this.f.domElement(y[0]);if(!a)return;const p=a.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const k=(0,i.getWindow)(p).getComputedStyle(p);k.visibility==="hidden"||k.display==="none"||(u.preventDefault(),u.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function De(x){return r.$j?x.browserEvent.metaKey:x.browserEvent.ctrlKey}function Fe(x){return x.browserEvent.shiftKey}function He(x){return(0,i.$aS)(x)&&x.button===2}const he={isSelectionSingleChangeEvent:De,isSelectionRangeChangeEvent:Fe};class _{constructor(u){this.k=u,this.f=new e.$Tc,this.g=new c.$_d,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||he),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(W.$US.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||he))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){$(u.browserEvent.target)||(0,i.$XR)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(I(u.browserEvent.target)||$(u.browserEvent.target))return;const y=typeof u.index>"u"?[]:[u.index];this.k.setFocus(y,u.browserEvent)}u(u){if(!this.d||I(u.browserEvent.target)||$(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=u.index;if(typeof y>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([y],u.browserEvent),this.k.setAnchor(y),He(u.browserEvent)||this.k.setSelection([y],u.browserEvent),this.g.fire(u)}v(u){if(I(u.browserEvent.target)||$(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=this.k.getFocus();this.k.setSelection(y,u.browserEvent)}w(u){const y=u.index;let a=this.k.getAnchor();if(this.p(u)){typeof a>"u"&&(a=this.k.getFocus()[0]??y,this.k.setAnchor(a));const p=Math.min(a,y),k=Math.max(a,y),s=(0,m.$Sb)(p,k+1),E=this.k.getSelection(),v=J(Q(E,[a]),a);if(v.length===0)return;const L=Q(s,se(E,v));this.k.setSelection(L,u.browserEvent),this.k.setFocus([y],u.browserEvent)}else if(this.o(u)){const p=this.k.getSelection(),k=p.filter(s=>s!==y);this.k.setFocus([y]),this.k.setAnchor(y),p.length===k.length?this.k.setSelection([...k,y],u.browserEvent):this.k.setSelection(k,u.browserEvent)}}dispose(){this.f.dispose()}}t.$PT=_;class ae{constructor(u,y){this.c=u,this.d=y}style(u){const y=this.d&&`.${this.d}`,a=[];u.listBackground&&a.push(`.monaco-list${y} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&a.push(`.monaco-list${y} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(a.push(`.monaco-list${y} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&a.push(`.monaco-list${y} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const p=(0,i.$DS)(u.listFocusAndSelectionOutline,(0,i.$DS)(u.listSelectionOutline,u.listFocusOutline??""));p&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),u.listFocusOutline&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${y}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const k=(0,i.$DS)(u.listSelectionOutline,u.listInactiveFocusOutline??"");k&&a.push(`.monaco-list${y} .monaco-list-row.focused.selected { outline: 1px dotted ${k}; outline-offset: -1px; }`),u.listSelectionOutline&&a.push(`.monaco-list${y} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&a.push(`.monaco-list${y} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&a.push(`.monaco-list${y} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&a.push(`
				.monaco-list${y}.drop-target,
				.monaco-list${y} .monaco-list-rows.drop-target,
				.monaco-list${y} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${y} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${y} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&a.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&a.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=a.join(`
`)}}t.$QT=ae,t.$RT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Ct.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Ct.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Ct.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function J(x,u){const y=x.indexOf(u);if(y===-1)return[];const a=[];let p=y-1;for(;p>=0&&x[p]===u-(y-p);)a.push(x[p--]);for(a.reverse(),p=y;p<x.length&&x[p]===u+(p-y);)a.push(x[p++]);return a}function Q(x,u){const y=[];let a=0,p=0;for(;a<x.length||p<u.length;)if(a>=x.length)y.push(u[p++]);else if(p>=u.length)y.push(x[a++]);else if(x[a]===u[p]){y.push(x[a]),a++,p++;continue}else x[a]<u[p]?y.push(x[a++]):y.push(u[p++]);return y}function se(x,u){const y=[];let a=0,p=0;for(;a<x.length||p<u.length;)if(a>=x.length)y.push(u[p++]);else if(p>=u.length)y.push(x[a++]);else if(x[a]===u[p]){a++,p++;continue}else x[a]<u[p]?y.push(x[a++]):p++;return y}const fe=(x,u)=>x-u;class ve{constructor(u,y){this.c=u,this.d=y}get templateId(){return this.c}renderTemplate(u){return this.d.map(y=>y.renderTemplate(u))}renderElement(u,y,a,p){let k=0;for(const s of this.d)s.renderElement(u,y,a[k++],p)}disposeElement(u,y,a,p){let k=0;for(const s of this.d)s.disposeElement?.(u,y,a[k],p),k+=1}disposeTemplate(u){let y=0;for(const a of this.d)a.disposeTemplate(u[y++])}}class Ne{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return{container:u,disposables:new e.$Tc}}renderElement(u,y,a){const p=this.c.getAriaLabel(u),k=p&&typeof p!="string"?p:(0,d.constObservable)(p);a.disposables.add((0,d.autorun)(E=>{this.d(E.readObservable(k),a.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof s=="number"?a.container.setAttribute("aria-level",`${s}`):a.container.removeAttribute("aria-level")}d(u,y){u?y.setAttribute("aria-label",u):y.removeAttribute("aria-label")}disposeElement(u,y,a,p){a.disposables.clear()}disposeTemplate(u){u.disposables.dispose()}}class Ae{constructor(u,y){this.c=u,this.d=y}getDragElements(u){const y=this.c.getSelectedElements();return y.indexOf(u)>-1?y:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,y){if(this.d.getDragLabel)return this.d.getDragLabel(u,y)}onDragStart(u,y){this.d.onDragStart?.(u,y)}onDragOver(u,y,a,p,k){return this.d.onDragOver(u,y,a,p,k)}onDragLeave(u,y,a,p){this.d.onDragLeave?.(u,y,a,p)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,y,a,p,k){this.d.drop(u,y,a,p,k)}dispose(){this.d.dispose()}}class Le{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const y=c.Event.chain(this.y.add(new F.$nT(this.k.domNode,"keydown")).event,k=>k.map(s=>new P.$iR(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$gS.stop(s,!0)).filter(()=>!1)),a=c.Event.chain(this.y.add(new F.$nT(this.k.domNode,"keyup")).event,k=>k.forEach(()=>u=!1).map(s=>new P.$iR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$gS.stop(s,!0)).map(({browserEvent:s})=>{const E=this.getFocus(),v=E.length?E[0]:void 0,L=typeof v<"u"?this.k.element(v):void 0,z=typeof v<"u"?this.k.domElement(v):this.k.domNode;return{index:v,element:L,anchor:z,browserEvent:s}})),p=c.Event.chain(this.k.onContextMenu,k=>k.filter(s=>!u).map(({element:s,index:E,browserEvent:v})=>({element:s,index:E,anchor:new o.$dR((0,i.getWindow)(this.k.domNode),v),browserEvent:v})));return c.Event.any(y,a,p)}get onKeyDown(){return this.y.add(new F.$nT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new F.$nT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new F.$nT(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new F.$nT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new F.$nT(this.k.domNode,"blur",!0)).event)}constructor(u,y,a,p,k=le){this.A=u,this.B=k,this.c=new T("focused"),this.f=new T("anchor"),this.g=new c.$he,this.x="",this.y=new e.$Tc,this.z=new c.$_d,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(s!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=k.accessibilityProvider,this.u&&(E.push(new Ne(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(L=>new ve(L.templateId,[...E,L]));const v={...k,dnd:k.dnd&&new Ae(this,k.dnd)};if(this.k=this.C(y,a,p,v),this.k.domNode.setAttribute("role",s),k.styleController)this.q=k.styleController(this.k.domId);else{const L=(0,i.$6R)(this.k.domNode);this.q=new ae(L,this.k.domId)}if(this.o=new A.$rT([new R(this.c,this.k,k.identityProvider),new R(this.d,this.k,k.identityProvider),new R(this.f,this.k,k.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new $e(this,this.k)),(typeof k.keyboardSupport!="boolean"||k.keyboardSupport)&&(this.v=new Z(this,this.k,k),this.y.add(this.v)),k.keyboardNavigationLabelProvider){const L=k.keyboardNavigationDelegate||t.$MT;this.t=new te(this,this.k,k.keyboardNavigationLabelProvider,k.keyboardNavigationEventFilter??(()=>!0),L),this.y.add(this.t)}this.w=this.D(k),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,y,a,p){return new D.$AT(u,y,a,p)}D(u){return new _(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,y,a=[]){if(u<0||u>this.k.length)throw new g.$CT(this.A,`Invalid start index: ${u}`);if(y<0)throw new g.$CT(this.A,`Invalid delete count: ${y}`);y===0&&a.length===0||this.g.bufferEvents(()=>this.o.splice(u,y,a))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,y){this.k.updateElementHeight(u,y,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,y){this.k.layout(u,y)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,y){for(const a of u)if(a<0||a>=this.length)throw new g.$CT(this.A,`Invalid index ${a}`);this.d.set(u,y)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new g.$CT(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,y){for(const a of u)if(a<0||a>=this.length)throw new g.$CT(this.A,`Invalid index ${a}`);this.c.set(u,y)}focusNext(u=1,y=!1,a,p){if(this.length===0)return;const k=this.c.get(),s=this.E(k.length>0?k[0]+u:0,y,p);s>-1&&this.setFocus([s],a)}focusPrevious(u=1,y=!1,a,p){if(this.length===0)return;const k=this.c.get(),s=this.F(k.length>0?k[0]-u:0,y,p);s>-1&&this.setFocus([s],a)}async focusNextPage(u,y){let a=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);a=a===0?0:a-1;const p=this.getFocus()[0];if(p!==a&&(p===void 0||a>p)){const k=this.F(a,!1,y);k>-1&&p!==k?this.setFocus([k],u):this.setFocus([a],u)}else{const k=this.k.getScrollTop();let s=k+this.k.renderHeight;a>p&&(s-=this.k.elementHeight(a)),this.k.setScrollTop(s),this.k.getScrollTop()!==k&&(this.setFocus([]),await(0,b.$oh)(0),await this.focusNextPage(u,y))}}async focusPreviousPage(u,y,a=()=>0){let p;const k=a(),s=this.k.getScrollTop()+k;s===0?p=this.k.indexAt(s):p=this.k.indexAfter(s-1);const E=this.getFocus()[0];if(E!==p&&(E===void 0||E>=p)){const v=this.E(p,!1,y);v>-1&&E!==v?this.setFocus([v],u):this.setFocus([p],u)}else{const v=s;this.k.setScrollTop(s-this.k.renderHeight-k),this.k.getScrollTop()+a()!==v&&(this.setFocus([]),await(0,b.$oh)(0),await this.focusPreviousPage(u,y,a))}}focusLast(u,y){if(this.length===0)return;const a=this.F(this.length-1,!1,y);a>-1&&this.setFocus([a],u)}focusFirst(u,y){this.focusNth(0,u,y)}focusNth(u,y,a){if(this.length===0)return;const p=this.E(u,!1,a);p>-1&&this.setFocus([p],y)}E(u,y=!1,a){for(let p=0;p<this.length;p++){if(u>=this.length&&!y)return-1;if(u=u%this.length,!a||a(this.element(u)))return u;u++}return-1}F(u,y=!1,a){for(let p=0;p<this.length;p++){if(u<0&&!y)return-1;if(u=(this.length+u%this.length)%this.length,!a||a(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,y,a=0){if(u<0||u>=this.length)throw new g.$CT(this.A,`Invalid index ${u}`);const p=this.k.getScrollTop(),k=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,h.$5f)(y)){const E=s-this.k.renderHeight+a;this.k.setScrollTop(E*(0,n.$sm)(y,0,1)+k-a)}else{const E=k+s,v=p+this.k.renderHeight;k<p+a&&E>=v||(k<p+a||E>=v&&s>=this.k.renderHeight?this.k.setScrollTop(k-a):E>=v&&this.k.setScrollTop(E-this.k.renderHeight))}}getRelativeTop(u,y=0){if(u<0||u>=this.length)throw new g.$CT(this.A,`Invalid index ${u}`);const a=this.k.getScrollTop(),p=this.k.elementTop(u),k=this.k.elementHeight(u);if(p<a+y||p+k>a+this.k.renderHeight)return null;const s=k-this.k.renderHeight+y;return Math.abs((a+y-p)/s)}isDOMFocused(){return(0,i.$YR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:y}){return{indexes:u,elements:u.map(a=>this.k.element(a)),browserEvent:y}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let y;this.u?.getActiveDescendantId&&(y=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",y||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$ST=Le,Ze([B.$Rh],Le.prototype,"onDidChangeFocus",null),Ze([B.$Rh],Le.prototype,"onDidChangeSelection",null),Ze([B.$Rh],Le.prototype,"onContextMenu",null),Ze([B.$Rh],Le.prototype,"onKeyDown",null),Ze([B.$Rh],Le.prototype,"onKeyUp",null),Ze([B.$Rh],Le.prototype,"onKeyPress",null),Ze([B.$Rh],Le.prototype,"onDidFocus",null),Ze([B.$Rh],Le.prototype,"onDidBlur",null)}),define(ge[137],be([1,0,6,62,47,9,16]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kk=t.MarkdownStringTextNewlineStyle=void 0,t.$Lk=b,t.$Mk=w,t.$Nk=B,t.$Ok=c,t.$Pk=f,t.$Qk=e,t.$Rk=n,t.$Sk=r;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class m{constructor(g="",D=!1){if(this.value=g,typeof this.value!="string")throw(0,i.$7)("value");typeof D=="boolean"?(this.isTrusted=D,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=D.isTrusted??void 0,this.supportThemeIcons=D.supportThemeIcons??!1,this.supportHtml=D.supportHtml??!1)}appendText(g,D=0){return this.value+=c(this.supportThemeIcons?(0,F.$Ek)(g):g).replace(/([ \t]+)/g,(o,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,D===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,D){return this.value+=`
${f(D,g)}
`,this}appendLink(g,D,o){return this.value+="[",this.value+=this.c(D,"]"),this.value+="](",this.value+=this.c(String(g),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(g,D){const o=new RegExp((0,W.$5e)(D),"g");return g.replace(o,(d,l)=>g.charAt(l-1)!=="\\"?`\\${d}`:d)}}t.$Kk=m;function b(h){return w(h)?!h.value:Array.isArray(h)?h.every(b):!0}function w(h){return h instanceof m?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function B(h,g){return h===g?!0:!h||!g?!1:h.value===g.value&&h.isTrusted===g.isTrusted&&h.supportThemeIcons===g.supportThemeIcons&&h.supportHtml===g.supportHtml&&(h.baseUri===g.baseUri||!!h.baseUri&&!!g.baseUri&&(0,P.$Tg)(S.URI.from(h.baseUri),S.URI.from(g.baseUri)))}function c(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function f(h,g){const D=h.match(/^`+/gm)?.reduce((d,l)=>d.length>l.length?d:l).length??0,o=D>=3?D+1:3;return[`${"`".repeat(o)}${g}`,h,`${"`".repeat(o)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function n(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const g=[],D=h.split("|").map(d=>d.trim());h=D[0];const o=D[1];if(o){const d=/height=(\d+)/.exec(o),l=/width=(\d+)/.exec(o),T=d?d[1]:"",N=l?l[1]:"",R=isFinite(parseInt(N)),I=isFinite(parseInt(T));R&&g.push(`width="${N}"`),I&&g.push(`height="${T}"`)}return{href:h,dimensions:g}}}),define(ge[138],be([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e,n,r,h,g,D,o,d,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=void 0,t.$VT=N,t.$XT=O,t.$YT=V,t.$ZT=ce;const T=Object.freeze({image:(Q,se,fe)=>{let ve=[],Ne=[];return Q&&({href:Q,dimensions:ve}=(0,B.$Sk)(Q),Ne.push(`src="${(0,B.$Qk)(Q)}"`)),fe&&Ne.push(`alt="${(0,B.$Qk)(fe)}"`),se&&Ne.push(`title="${(0,B.$Qk)(se)}"`),ve.length&&(Ne=Ne.concat(ve)),"<img "+Ne.join(" ")+">"},paragraph:Q=>`<p>${Q}</p>`,link:(Q,se,fe)=>typeof Q!="string"?"":(Q===fe&&(fe=(0,B.$Rk)(fe)),se=typeof se=="string"?(0,B.$Qk)((0,B.$Rk)(se)):"",Q=(0,B.$Rk)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${se||Q}" draggable="false">${fe}</a>`)});function N(Q,se={},fe={}){const ve=new n.$Tc;let Ne=!1;const Ae=(0,W.$mT)(se),Le=function(v){let L;try{L=(0,h.$Vh)(decodeURIComponent(v))}catch{}return L?(L=(0,D.$Vn)(L,z=>{if(Q.uris&&Q.uris[z])return l.URI.revive(Q.uris[z])}),encodeURIComponent(JSON.stringify(L))):v},x=function(v,L){const z=Q.uris&&Q.uris[v];let X=l.URI.revive(z);return L?v.startsWith(g.Schemas.data+":")?v:(X||(X=l.URI.parse(v)),g.$Hg.uriToBrowserUri(X).toString(!0)):!X||l.URI.parse(v).toString()===X.toString()?v:(X.query&&(X=X.with({query:Le(X.query)})),X.toString())},u=new r.marked.Renderer;u.image=T.image,u.link=T.link,u.paragraph=T.paragraph;const y=[],a=[];if(se.codeBlockRendererSync?u.code=(v,L)=>{const z=f.$1O.nextId(),X=se.codeBlockRendererSync(R(L),v);return a.push([z,X]),`<div class="code" data-code="${z}">${(0,d.$4e)(v)}</div>`}:se.codeBlockRenderer&&(u.code=(v,L)=>{const z=f.$1O.nextId(),X=se.codeBlockRenderer(R(L),v);return y.push(X.then(U=>[z,U])),`<div class="code" data-code="${z}">${(0,d.$4e)(v)}</div>`}),se.actionHandler){const v=function(X){let U=X.target;if(!(U.tagName!=="A"&&(U=U.parentElement,!U||U.tagName!=="A")))try{let oe=U.dataset.href;oe&&(Q.baseUri&&(oe=I(l.URI.from(Q.baseUri),oe)),se.actionHandler.callback(oe,X))}catch(oe){(0,b.$1)(oe)}finally{X.preventDefault()}},L=se.actionHandler.disposables.add(new P.$nT(Ae,"click")),z=se.actionHandler.disposables.add(new P.$nT(Ae,"auxclick"));se.actionHandler.disposables.add(w.Event.any(L.event,z.event)(X=>{const U=new A.$dR(i.getWindow(Ae),X);!U.leftButton&&!U.middleButton||v(U)})),se.actionHandler.disposables.add(i.$lR(Ae,"keydown",X=>{const U=new S.$iR(X);!U.equals(10)&&!U.equals(3)||v(U)}))}Q.supportHtml||(fe.sanitizer=v=>(Q.isTrusted?v.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?v:"",fe.sanitize=!0,fe.silent=!0),fe.renderer=u;let p=Q.value??"";p.length>1e5&&(p=`${p.substr(0,1e5)}\u2026`),Q.supportThemeIcons&&(p=(0,c.$Fk)(p));let k;if(se.fillInIncompleteTokens){const v={...r.marked.defaults,...fe},L=r.marked.lexer(p,v),z=ce(L);k=r.marked.parser(z,v)}else k=r.marked.parse(p,fe);Q.supportThemeIcons&&(k=(0,m.$TT)(k).map(L=>typeof L=="string"?L:L.outerHTML).join(""));const E=new DOMParser().parseFromString(j(Q,k),"text/html");if(E.body.querySelectorAll("img").forEach(v=>{const L=v.getAttribute("src");if(L){let z=L;try{Q.baseUri&&(z=I(l.URI.from(Q.baseUri),z))}catch{}v.src=x(z,!0)}}),E.body.querySelectorAll("a").forEach(v=>{const L=v.getAttribute("href");if(v.setAttribute("href",""),!L||/^data:|javascript:/i.test(L)||/^command:/i.test(L)&&!Q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(L))v.replaceWith(...v.childNodes);else{let z=x(L,!1);Q.baseUri&&(z=I(l.URI.from(Q.baseUri),L)),v.dataset.href=z}}),Ae.innerHTML=j(Q,E.body.innerHTML),y.length>0)Promise.all(y).then(v=>{if(Ne)return;const L=new Map(v),z=Ae.querySelectorAll("div[data-code]");for(const X of z){const U=L.get(X.dataset.code??"");U&&i.$nS(X,U)}se.asyncRenderCallback?.()});else if(a.length>0){const v=new Map(a),L=Ae.querySelectorAll("div[data-code]");for(const z of L){const X=v.get(z.dataset.code??"");X&&i.$nS(z,X)}}if(se.asyncRenderCallback)for(const v of Ae.getElementsByTagName("img")){const L=ve.add(i.$lR(v,"load",()=>{L.dispose(),se.asyncRenderCallback()}))}return{element:Ae,dispose:()=>{Ne=!0,ve.dispose()}}}function R(Q){if(!Q)return"";const se=Q.split(/[\s+|:|,|\{|\?]/,1);return se.length?se[0]:Q}function I(Q,se){return/^\w[\w\d+.-]*:/.test(se)?se:Q.path.endsWith("/")?(0,o.$4g)(Q,se).toString():(0,o.$4g)((0,o.$Zg)(Q),se).toString()}function j(Q,se){const{config:fe,allowedSchemes:ve}=$(Q);F.addHook("uponSanitizeAttribute",(Ae,Le)=>{if(Le.attrName==="style"||Le.attrName==="class"){if(Ae.tagName==="SPAN"){if(Le.attrName==="style"){Le.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Le.attrValue);return}else if(Le.attrName==="class"){Le.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Le.attrValue);return}}Le.keepAttr=!1;return}else if(Ae.tagName==="INPUT"&&Ae.attributes.getNamedItem("type")?.value==="checkbox"){if(Le.attrName==="type"&&Le.attrValue==="checkbox"||Le.attrName==="disabled"||Le.attrName==="checked"){Le.keepAttr=!0;return}Le.keepAttr=!1}}),F.addHook("uponSanitizeElement",(Ae,Le)=>{Le.tagName==="input"&&(Ae.attributes.getNamedItem("type")?.value==="checkbox"?Ae.setAttribute("disabled",""):Ae.parentElement?.removeChild(Ae))});const Ne=i.$HS(ve);try{return F.sanitize(se,{...fe,RETURN_TRUSTED_TYPE:!0})}finally{F.removeHook("uponSanitizeAttribute"),Ne.dispose()}}t.$WT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function $(Q){const se=[g.Schemas.http,g.Schemas.https,g.Schemas.mailto,g.Schemas.data,g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemote,g.Schemas.vscodeRemoteResource];return Q.isTrusted&&se.push(g.Schemas.command),{config:{ALLOWED_TAGS:[...i.$IS],ALLOWED_ATTR:t.$WT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:se}}function O(Q){return typeof Q=="string"?Q:V(Q)}function V(Q){let se=Q.value??"";se.length>1e5&&(se=`${se.substr(0,1e5)}\u2026`);const fe=r.marked.parse(se,{renderer:H.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ve=>M.get(ve)??ve);return j({isTrusted:!1},fe).toString()}const M=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),H=new e.$V(()=>{const Q=new r.marked.Renderer;return Q.code=se=>se,Q.blockquote=se=>se,Q.html=se=>"",Q.heading=(se,fe,ve)=>se+`
`,Q.hr=()=>"",Q.list=(se,fe)=>se,Q.listitem=se=>se+`
`,Q.paragraph=se=>se+`
`,Q.table=(se,fe)=>se+fe+`
`,Q.tablerow=se=>se,Q.tablecell=(se,fe)=>se+" ",Q.strong=se=>se,Q.em=se=>se,Q.codespan=se=>se,Q.br=()=>`
`,Q.del=se=>se,Q.image=(se,fe,ve)=>"",Q.text=se=>se,Q.link=(se,fe,ve)=>ve,Q});function C(Q){let se="";return Q.forEach(fe=>{se+=fe.raw}),se}function G(Q){for(let se=0;se<Q.tokens.length;se++){const fe=Q.tokens[se];if(fe.type==="text"){const ve=fe.raw.split(`
`),Ne=ve[ve.length-1];if(Ne.includes("`"))return te(Q);if(Ne.includes("**"))return _(Q);if(Ne.match(/\*\w/))return $e(Q);if(Ne.match(/(^|\s)__\w/))return ae(Q);if(Ne.match(/(^|\s)_\w/))return De(Q);if(Ne.match(/(^|\s)\[.*\]\(\w*/)){const Ae=Q.tokens.slice(se+1);return Ae[0]?.type==="link"&&Ae[1]?.type==="text"&&Ae[1].raw.match(/^ *"[^"]*$/)?He(Q):Fe(Q)}else{if(Z(Ne))return Fe(Q);if(Ne.match(/(^|\s)\[\w/)&&!Q.tokens.slice(se+1).some(Ae=>Z(Ae.raw)))return he(Q)}}}}function Z(Q){return!!Q.match(/^[^\[]*\]\([^\)]*$/)}function ce(Q){let se,fe;for(se=0;se<Q.length;se++){const ve=Q[se];let Ne;if(ve.type==="paragraph"&&(Ne=ve.raw.match(/(\n|^)(````*)/))){const Ae=Ne[2];fe=re(Q.slice(se),Ae);break}if(ve.type==="paragraph"&&ve.raw.match(/(\n|^)\|/)){fe=J(Q.slice(se));break}if(se===Q.length-1&&ve.type==="paragraph"){const Ae=G(ve);if(Ae){fe=[Ae];break}}}if(fe){const ve=[...Q.slice(0,se),...fe];return ve.links=Q.links,ve}return Q}function re(Q,se){const fe=C(Q);return r.marked.lexer(fe+`
${se}`)}function te(Q){return le(Q,"`")}function $e(Q){return le(Q,"*")}function De(Q){return le(Q,"_")}function Fe(Q){return le(Q,")")}function He(Q){return le(Q,'")')}function he(Q){return le(Q,"](about:blank)")}function _(Q){return le(Q,"**")}function ae(Q){return le(Q,"__")}function le(Q,se){const fe=C(Array.isArray(Q)?Q:[Q]);return r.marked.lexer(fe+se)[0]}function J(Q){const se=C(Q),fe=se.split(`
`);let ve,Ne=!1;for(let Ae=0;Ae<fe.length;Ae++){const Le=fe[Ae].trim();if(typeof ve>"u"&&Le.match(/^\s*\|/)){const x=Le.match(/(\|[^\|]+)(?=\||$)/g);x&&(ve=x.length)}else if(typeof ve=="number")if(Le.match(/^\s*\|/)){if(Ae!==fe.length-1)return;Ne=!0}else return}if(typeof ve=="number"&&ve>0){const Ae=Ne?fe.slice(0,-1).join(`
`):se,Le=!!Ae.match(/\|\s*$/),x=Ae+(Le?"":"|")+`
|${" --- |".repeat(ve)}`;return r.marked.lexer(x)}}}),define(ge[139],be([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3T=void 0;const n=i.$,r="selectOption.entry.template";class h{get templateId(){return r}renderTemplate(o){const d=Object.create(null);return d.root=o,d.text=i.$lS(o,n(".option-text")),d.detail=i.$lS(o,n(".option-detail")),d.decoratorRight=i.$lS(o,n(".option-decorator-right")),d}renderElement(o,d,l){const T=l,N=o.text,R=o.detail,I=o.decoratorRight,j=o.isDisabled;T.text.textContent=N,T.detail.textContent=R||"",T.decoratorRight.innerText=I||"",j?T.root.classList.add("option-disabled"):T.root.classList.remove("option-disabled")}disposeTemplate(o){}}class g extends c.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,d,l,T,N){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=T,this.g=N||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=g.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$_d,this.B(this.r),this.Q(),this.P(l),this.n=d||0,o&&this.setOptions(o,d),this.S()}O(o){!this.M&&o?this.M=this.B((0,S.$2T)().setupUpdatableHover((0,A.$dT)("mouse"),this.h,o)):this.M&&this.M.update(o)}getHeight(){return 22}getTemplateId(){return r}P(o){this.u=o,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$lS(this.w,n(".select-box-details-pane"));const d=i.$lS(this.w,n(".select-box-dropdown-container-width-control")),l=i.$lS(d,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$lS(l,this.D),this.G=0,this.y=i.$6R(this.w),this.w.setAttribute("draggable","true"),this.B(i.$lR(this.w,i.$eS.DRAG_START,T=>{i.$gS.stop(T,!0)}))}Q(){this.B(i.$mR(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$lR(this.h,i.$eS.CLICK,d=>{i.$gS.stop(d),this.f?this.Z(!0):this.Y()})),this.B(i.$lR(this.h,i.$eS.MOUSE_DOWN,d=>{i.$gS.stop(d)}));let o;this.B(i.$lR(this.h,"touchstart",d=>{o=this.f})),this.B(i.$lR(this.h,"touchend",d=>{i.$gS.stop(d),o?this.Z(!0):this.Y()})),this.B(i.$lR(this.h,i.$eS.KEY_DOWN,d=>{const l=new P.$iR(d);let T=!1;f.$j?(l.keyCode===18||l.keyCode===16||l.keyCode===10||l.keyCode===3)&&(T=!0):(l.keyCode===18&&l.altKey||l.keyCode===16&&l.altKey||l.keyCode===10||l.keyCode===3)&&(T=!0),T&&(this.Y(),i.$gS.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,d){b.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((l,T)=>{this.h.add(this.X(l.text,T,l.isDisabled)),typeof l.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.U()}S(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}U(){const o=this.s.selectBackground??"",d=this.s.selectForeground??"",l=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=d,this.h.style.borderColor=l}W(){const o=this.s.selectBackground??"",d=i.$DS(this.s.selectListBackground,o);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const l=this.s.focusBorder??"";this.w.style.outlineColor=l,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(o,d,l){const T=document.createElement("option");return T.value=o,T.text=o,T.disabled=!!l,T}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}ab(o,d){return o.appendChild(this.w),this.cb(d),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}bb(){let o=0;return this.m.forEach((d,l)=>{this.jb(l),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}cb(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=i.getWindow(this.h),l=i.$HR(this.h),T=i.getWindow(this.h).getComputedStyle(this.h),N=parseFloat(T.getPropertyValue("--dropdown-padding-top"))+parseFloat(T.getPropertyValue("--dropdown-padding-bottom")),R=d.innerHeight-l.top-l.height-(this.g.minBottomMargin||0),I=l.top-g.b,j=this.h.offsetWidth,$=this.db(this.D),O=Math.max($,Math.round(j)).toString()+"px";this.w.style.width=O,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const M=this.H?this.L:0,H=V+N+M,C=Math.floor((R-N-M)/this.getHeight()),G=Math.floor((I-N-M)/this.getHeight());if(o)return l.top+l.height>d.innerHeight-22||l.top<g.b||C<1&&G<1?!1:(C<g.c&&G>C&&this.m.length>C?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(l.top+l.height>d.innerHeight-22||l.top<g.b||this.G===0&&C<1||this.G===1&&G<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&C+G<1)return this.Z(!0),!1;H>R&&(V=C*this.getHeight())}else H>I&&(V=G*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+N+"px",this.w.style.height=""):this.w.style.height=V+N+"px",this.jb(this.n),this.w.style.width=O,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(o){let d=0;if(o){let l=0,T=0;this.m.forEach((N,R)=>{const I=N.detail?N.detail.length:0,j=N.decoratorRight?N.decoratorRight.length:0,$=N.text.length+I+j;$>T&&(l=R,T=$)}),o.textContent=this.m[l].text+(this.m[l].decoratorRight?this.m[l].decoratorRight+" ":""),d=i.$JR(o)}return d}eb(o){if(this.z)return;this.C=i.$lS(o,n(".select-box-dropdown-list-container")),this.t=new h,this.z=new m.$ST("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:T=>{let N=T.text;return T.detail&&(N+=`. ${T.detail}`),T.decoratorRight&&(N+=`. ${T.decoratorRight}`),T.description&&(N+=`. ${T.description}`),N},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>f.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new F.$nT(this.C,"keydown")),l=w.Event.chain(d.event,T=>T.filter(()=>this.z.length>0).map(N=>new P.$iR(N)));this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===3))(this.lb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===2))(this.lb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===9))(this.kb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===16))(this.nb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===18))(this.mb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===12))(this.pb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===11))(this.ob,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===14))(this.qb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode===13))(this.rb,this)),this.B(w.Event.chain(l,T=>T.filter(N=>N.keyCode>=21&&N.keyCode<=56||N.keyCode>=85&&N.keyCode<=113))(this.sb,this)),this.B(i.$lR(this.z.getHTMLElement(),i.$eS.POINTER_UP,T=>this.fb(T))),this.B(this.z.onMouseOver(T=>typeof T.index<"u"&&this.z.setFocus([T.index]))),this.B(this.z.onDidChangeFocus(T=>this.ib(T))),this.B(i.$lR(this.w,i.$eS.FOCUS_OUT,T=>{!this.f||i.$PR(T.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(o){if(!this.z.length)return;i.$gS.stop(o);const d=o.target;if(!d||d.classList.contains("slider"))return;const l=d.closest(".monaco-list-row");if(!l)return;const T=Number(l.getAttribute("data-index")),N=l.classList.contains("option-disabled");T>=0&&T<this.m.length&&!N&&(this.n=T,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(o,d){const l=N=>{for(let R=0;R<N.childNodes.length;R++){const I=N.childNodes.item(R);(I.tagName&&I.tagName.toLowerCase())==="img"?N.removeChild(I):l(I)}},T=(0,W.$VT)({value:o,supportThemeIcons:!0},{actionHandler:d});return T.element.classList.add("select-box-description-markdown"),l(T.element),T.element}ib(o){!this.f||!this.H||this.jb(o.indexes[0])}jb(o){this.I.innerText="";const d=this.m[o],l=d?.description??"",T=d?.descriptionIsMarkdown??!1;if(l){if(T){const N=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(l,N))}else this.I.innerText=l;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(o){i.$gS.stop(o),this.select(this.F),this.Z(!0)}lb(o){i.$gS.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(o){if(this.n<this.m.length-1){i.$gS.stop(o,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(o){this.n>0&&(i.$gS.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(o){i.$gS.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(o){i.$gS.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(o){i.$gS.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(o){i.$gS.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(o){const d=B.KeyCodeUtils.toString(o.keyCode);let l=-1;for(let T=0;T<this.m.length-1;T++)if(l=(T+this.n+1)%this.m.length,this.m[l].text.charAt(0).toUpperCase()===d&&!this.m[l].isDisabled){this.select(l),this.z.setFocus([l]),this.z.reveal(this.z.getFocus()[0]),i.$gS.stop(o);break}}dispose(){this.Z(!1),super.dispose()}}t.$3T=g}),define(ge[140],be([1,0,49,139,133,21,5,112]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6T=t.$5T=void 0,t.$5T={...i.$RT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends W.$YS{constructor(b,w,B,c,f){super(),S.$j&&!f?.useCustomDrawn?this.a=new P.$4T(b,w,c,f):this.a=new F.$3T(b,w,B,c,f),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(b,w){this.a.setOptions(b,w)}select(b){this.a.select(b)}setAriaLabel(b){this.a.setAriaLabel(b)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(b){this.a.setFocusable(b)}render(b){this.a.render(b)}}t.$6T=A}),define(ge[73],be([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bU=t.$aU=t.$_T=void 0;class e extends b.$Uc{get action(){return this._action}constructor(g,D,o={}){super(),this.m=o,this._context=g||this,this._action=D,D instanceof m.$5i&&this.B(D.onDidChange(d=>{this.element&&this.t(d)}))}t(g){g.enabled!==void 0&&this.u(),g.checked!==void 0&&this.H(),g.class!==void 0&&this.G(),g.label!==void 0&&(this.w(),this.D()),g.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$6i)),this.j}set actionRunner(g){this.j=g}isEnabled(){return this._action.enabled}setActionContext(g){this._context=g}render(g){const D=this.element=g;this.B(W.$US.addTarget(g));const o=this.m&&this.m.draggable;o&&(g.draggable=!0,i.$4Q&&this.B((0,P.$lR)(g,P.$eS.DRAG_START,d=>d.dataTransfer?.setData(F.$SS.TEXT,this._action.label)))),this.B((0,P.$lR)(D,W.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,P.$lR)(D,P.$eS.MOUSE_DOWN,d=>{o||P.$gS.stop(d,!0),this._action.enabled&&d.button===0&&D.classList.add("active")})),w.$j&&this.B((0,P.$lR)(D,P.$eS.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,P.$lR)(D,P.$eS.CLICK,d=>{P.$gS.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,P.$lR)(D,P.$eS.DBLCLICK,d=>{P.$gS.stop(d,!0)})),[P.$eS.MOUSE_UP,P.$eS.MOUSE_OUT].forEach(d=>{this.B((0,P.$lR)(D,d,l=>{P.$gS.stop(l),D.classList.remove("active")}))})}onClick(g,D=!1){P.$gS.stop(g,!0);const o=B.$0f(this._context)?this.m?.useEventAsContext?g:{preserveFocus:D}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(g){this.element&&(this.element.tabIndex=g?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const g=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=g;else if(!this.f&&g!==""){const D=this.m.hoverDelegate??(0,S.$dT)("element");this.f=this.q.add((0,f.$2T)().setupUpdatableHover(D,this.element,g))}else this.f&&this.f.update(g)}F(){if(this.element){const g=this.C()??"";this.element.setAttribute("aria-label",g)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$_T=e;class n extends e{constructor(g,D,o){super(g,D,o),this.m=o,this.m.icon=o.icon!==void 0?o.icon:!1,this.m.label=o.label!==void 0?o.label:!0,this.L=""}render(g){super.render(g),B.$$f(this.element);const D=document.createElement("a");if(D.classList.add("action-label"),D.setAttribute("role",this.M()),this.I=D,this.element.appendChild(D),this.m.label&&this.m.keybinding){const o=document.createElement("span");o.classList.add("keybinding"),o.textContent=this.m.keybinding,this.element.appendChild(o)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$7i.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(g){this.I&&(this.I.tabIndex=g?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let g=null;return this.action.tooltip?g=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(g=this.action.label,this.m.keybinding&&(g=c.localize(0,null,g,this.m.keybinding))),g??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const g=this.C()??"";this.I.setAttribute("aria-label",g)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$aU=n;class r extends e{constructor(g,D,o,d,l,T,N){super(g,D),this.b=new A.$6T(o,d,l,T,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(g,D){this.b.setOptions(g,D)}select(g){this.b.select(g)}g(){this.B(this.b.onDidSelect(g=>this.n(g.selected,g.index)))}n(g,D){this.actionRunner.run(this._action,this.r(g,D))}r(g,D){return g}setFocusable(g){this.b.setFocusable(g)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(g){this.b.render(g)}}t.$bU=r}),define(ge[74],be([1,0,4,15,73,14,46,3,2,10,63]),function(ne,t,i,F,P,W,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=t.ActionsOrientation=void 0,t.$gT=c;var w;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class B extends m.$Uc{constructor(e,n={}){super(),this.j=this.B(new m.$Tc),this.s=this.B(new m.$4c),this.y=!1,this.z=!0,this.D=this.B(new A.$_d),this.onDidBlur=this.D.event,this.F=this.B(new A.$_d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new A.$_d),this.onDidRun=this.H.event,this.I=this.B(new A.$_d),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,W.$eT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new S.$6i,this.j.add(this.g)),this.j.add(this.g.onDidRun(g=>this.H.fire(g))),this.j.add(this.g.onWillRun(g=>this.I.fire(g))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let r,h;switch(this.n){case 0:r=[15],h=[17];break;case 1:r=[16],h=[18],this.domNode.className+=" vertical";break}this.B(i.$lR(this.domNode,i.$eS.KEY_DOWN,g=>{const D=new F.$iR(g);let o=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;r&&(D.equals(r[0])||D.equals(r[1]))?o=this.Q():h&&(D.equals(h[0])||D.equals(h[1]))?o=this.P():D.equals(9)&&this.G?this.F.fire():D.equals(14)?o=this.N():D.equals(13)?o=this.O():D.equals(2)&&d instanceof P.$_T&&d.trapsArrowNavigation?o=this.P():this.L(D)?this.r.keyDown?this.S(D):this.y=!0:o=!1,o&&(D.preventDefault(),D.stopPropagation())})),this.B(i.$lR(this.domNode,i.$eS.KEY_UP,g=>{const D=new F.$iR(g);this.L(D)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(D)),D.preventDefault(),D.stopPropagation()):(D.equals(2)||D.equals(1026)||D.equals(16)||D.equals(18)||D.equals(15)||D.equals(17))&&this.M()})),this.w=this.B(i.$jS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$XR()===this.domNode||!i.$PR(i.$XR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(r=>r instanceof P.$_T&&r.isEnabled());n instanceof P.$_T&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof P.$_T&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(r=>{n=n||e.equals(r)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$PR(i.$XR(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const r=Array.isArray(e)?e:[e];let h=b.$5f(n.index)?n.index:null;r.forEach(g=>{const D=document.createElement("li");D.className="action-item",D.setAttribute("role","presentation");let o;const d={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(g,d)),o||(o=new P.$aU(this.context,g,d)),this.b.allowContextMenu||this.s.set(o,i.$lR(D,i.$eS.CONTEXT_MENU,l=>{i.$gS.stop(l,!0)})),o.actionRunner=this.g,o.setActionContext(this.context),o.render(D),this.z&&o instanceof P.$_T&&this.viewItems.length===0&&o.setFocusable(!0),h===null||h<0||h>=this.C.children.length?(this.C.appendChild(D),this.viewItems.push(o)):(this.C.insertBefore(D,this.C.children[h]),this.viewItems.splice(h,0,o),h++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,m.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,m.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$kR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,r;if(e===void 0?n=!0:typeof e=="number"?r=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const h=this.viewItems.findIndex(g=>g.isEnabled());this.u=h===-1?void 0:h,this.R(void 0,void 0,!0)}else r!==void 0&&(this.u=r),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let r;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,r=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===S.$7i.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let r;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}r=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===S.$7i.ID));return this.R(!0),!0}R(e,n,r=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const h=this.u!==void 0?this.viewItems[this.u]:void 0;if(h){let g=!0;b.$cg(h.focus)||(g=!1),this.b.focusOnlyEnabledItems&&b.$cg(h.isEnabled)&&!h.isEnabled()&&(g=!1),h.action.id===S.$7i.ID&&(g=!1),g?(r||this.t!==this.u)&&(h.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),g&&h.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof P.$_T){const r=n._context===null||n._context===void 0?e:n._context;this.run(n._action,r)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,m.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$fT=B;function c(f){if(!f.length)return f;let e=-1;for(let r=0;r<f.length;r++)if(f[r].id!==S.$7i.ID){e=r;break}if(e===-1)return[];f=f.slice(e);for(let r=f.length-1;r>=0&&f[r].id===S.$7i.ID;r--)f.splice(r,1);let n=!1;for(let r=f.length-1;r>=0;r--){const h=f[r].id===S.$7i.ID;h&&!n?f.splice(r,1):h?h&&(n=!1):n=!0}return f}}),define(ge[75],be([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UU=t.$TU=t.$SU=t.MessageType=void 0;const n=i.$;var r;(function(D){D[D.INFO=1]="INFO",D[D.WARNING=2]="WARNING",D[D.ERROR=3]="ERROR"})(r||(t.MessageType=r={})),t.$SU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends w.$YS{constructor(o,d,l){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new B.$_d),this.onDidChange=this.P.event,this.Q=this.B(new B.$_d),this.onDidHeightChange=this.Q.event,this.a=d,this.g=l,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$lS(o,n(".monaco-inputbox.idle"));const T=this.g.flexibleHeight?"textarea":"input",N=i.$lS(this.element,n(".ibwrapper"));if(this.b=i.$lS(N,n(T+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$lS(N,n("div.mirror")),this.y.innerText="\xA0",this.N=new b.$9S(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$lS(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(j=>this.b.scrollTop=j.scrollTop));const R=this.B(new F.$nT(o.ownerDocument,"selectionchange")),I=B.Event.filter(R.event,()=>o.ownerDocument.getSelection()?.anchorNode===N);this.B(I(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new W.$fT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.O?this.O.update(o):this.O=this.B((0,A.$2T)().setupUpdatableHover((0,m.$dT)("mouse"),this.b,o))}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Z())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:i.$NR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$YR(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const o=this.b.selectionStart;if(o===null)return null;const d=this.b.selectionEnd??o;return{start:o,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(o){o?this.enable():this.disable()}get width(){return i.$JR(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const l=parseFloat(this.y.style.paddingLeft||"")||0,T=parseFloat(this.y.style.paddingRight||"")||0;d=l+T}this.b.style.width=o-d+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,d=this.J,l=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:d}),this.N.setScrollPosition({scrollTop:l})}showMessage(o,d){if(this.w==="open"&&(0,f.$Xn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(o.type));const l=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$DS(l.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const d=this.g.inputBoxStyles;switch(o){case 1:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case 2:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let o;const d=()=>o.style.width=i.$JR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:T=>{if(!this.h)return null;o=i.$lS(T,n(".monaco-inputbox-container")),d();const N={inline:!0,className:"monaco-inputbox-message"},R=this.h.formatContent?(0,P.$lT)(this.h.content,N):(0,P.$kT)(this.h.content,N);R.classList.add(this.W(this.h.type));const I=this.stylesForType(this.h.type);return R.style.backgroundColor=I.background??"",R.style.color=I.foreground??"",R.style.border=I.border?`1px solid ${I.border}`:"",i.$lS(o,R),null},onHide:()=>{this.w="closed"},layout:d});let l;this.h.type===3?l=e.localize(0,null,this.h.content):this.h.type===2?l=e.localize(1,null,this.h.content):l=e.localize(2,null,this.h.content),S.$pT(l),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const o=this.value,l=o.charCodeAt(o.length-1)===10?" ":"";(o+l).replace(/\u000c/g,"")?this.y.textContent=o+l:this.y.innerText="\xA0",this.layout()}bb(){const o=this.g.inputBoxStyles,d=o.inputBackground??"",l=o.inputForeground??"",T=o.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=l,this.b.style.backgroundColor="inherit",this.b.style.color=l,this.element.style.border=`1px solid ${i.$DS(T,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=i.$NR(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(o){const d=this.inputElement,l=d.selectionStart,T=d.selectionEnd,N=d.value;l!==null&&T!==null&&(this.value=N.substr(0,l)+o+N.substr(T),d.setSelectionRange(l+1,l+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$TU=h;class g extends h{constructor(o,d,l){const T=e.localize(3,null,"\u21C5"),N=e.localize(4,null,"\u21C5");super(o,d,l),this.eb=this.B(new B.$_d),this.onDidFocus=this.eb.event,this.fb=this.B(new B.$_d),this.onDidBlur=this.fb.event,this.cb=new c.$QU(l.history,100);const R=()=>{if(l.showHistoryHint&&l.showHistoryHint()&&!this.n.endsWith(T)&&!this.n.endsWith(N)&&this.cb.getHistory().length){const I=this.n.endsWith(")")?T:N,j=this.n+I;l.showPlaceholderOnFocus&&!i.$YR(this.b)?this.n=j:this.setPlaceHolder(j)}};this.db=new MutationObserver((I,j)=>{I.forEach($=>{$.target.textContent||R()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>R()),this.F(this.b,()=>{const I=j=>{if(this.n.endsWith(j)){const $=this.n.slice(0,this.n.length-j.length);return l.showPlaceholderOnFocus?this.n=$:this.setPlaceHolder($),!0}else return!1};I(N)||I(T)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(o){this.value&&(o||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(o){const d=this.getHistory();this.clearHistory(),o.forEach(l=>{this.cb.add(l)}),d.forEach(l=>{this.cb.add(l)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let o=this.kb();o&&(o=o===this.value?this.kb():o),this.value=o??"",S.$qT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),o&&(this.value=o,S.$qT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let o=this.cb.current();return o||(o=this.cb.last(),this.cb.next()),o}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$UU=g}),define(ge[76],be([1,0,73,21,18,19,3,4,14,29,114]),function(ne,t,i,F,P,W,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$T=t.$0T=t.$9T=t.$8T=t.$7T=void 0,t.$7T={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends i.$_T{constructor(n,r,h){super(n,r,h),this.a=this.B(new B({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground,hoverDelegate:h.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$8T=w;class B extends F.$YS{constructor(n){super(),this.a=this.B(new S.$_d),this.onChange=this.a.event,this.b=this.B(new S.$_d),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$2T)().setupUpdatableHover(n.hoverDelegate??(0,m.$dT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,h=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),h.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,h=>{if(h.keyCode===10||h.keyCode===3){this.checked=!this.s,this.a.fire(!0),h.preventDefault(),h.stopPropagation();return}this.b.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}}t.$9T=B;class c extends F.$YS{constructor(n,r,h){super(),this.g=n,this.h=r,this.a=this.B(new S.$_d),this.onChange=this.a.event,this.b=this.B(new B({title:this.g,isChecked:this.h,icon:P.$Mj.check,actionClassName:"monaco-checkbox",...t.$7T})),this.domNode=this.b.domNode,this.c=h,this.n(),this.B(this.b.onChange(g=>{this.n(),this.a.fire(g)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$YR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$0T=c;class f extends i.$_T{constructor(n,r,h){super(n,r,h),this.a=this.B(new c(this._action.label,!!this._action.checked,h.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const r=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this.B((0,A.$lR)(r,A.$eS.CLICK,h=>{this.a.checked=!this.a.checked,h.stopPropagation(),h.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$$T=f}),define(ge[141],be([1,0,14,76,18,119]),function(ne,t,i,F,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8U=t.$7U=t.$6U=void 0;const S=W.localize(0,null),A=W.localize(1,null),m=W.localize(2,null);class b extends F.$9T{constructor(f){super({icon:P.$Mj.caseSensitive,title:S+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$dT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$6U=b;class w extends F.$9T{constructor(f){super({icon:P.$Mj.wholeWord,title:A+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$dT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$7U=w;class B extends F.$9T{constructor(f){super({icon:P.$Mj.regex,title:m+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$dT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$8U=B}),define(ge[142],be([1,0,4,141,75,21,3,118,2,14,108]),function(ne,t,i,F,P,W,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9U=void 0;const w=A.localize(0,null);class B extends W.$YS{static{this.OPTION_CHANGE="optionChange"}constructor(f,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Vc),this.N=[],this.O=this.B(new S.$_d),this.onDidOptionChange=this.O.event,this.P=this.B(new S.$_d),this.onKeyDown=this.P.event,this.Q=this.B(new S.$_d),this.onMouseDown=this.Q.event,this.R=this.B(new S.$_d),this.onInput=this.R.event,this.S=this.B(new S.$_d),this.onKeyUp=this.S.event,this.U=this.B(new S.$_d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new S.$_d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||w,this.h=!!n.showCommonFindToggles;const r=n.appendCaseSensitiveLabel||"",h=n.appendWholeWordsLabel||"",g=n.appendRegexLabel||"",D=n.history||[],o=!!n.flexibleHeight,d=!!n.flexibleWidth,l=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new P.$UU(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:D,showHistoryHint:n.showHistoryHint,flexibleHeight:o,flexibleWidth:d,flexibleMaxHeight:l,inputBoxStyles:n.inputBoxStyles}));const T=this.B((0,b.$eT)());if(this.h){this.J=this.B(new F.$8U({appendTitle:g,isChecked:!1,hoverDelegate:T,...n.toggleStyles})),this.B(this.J.onChange(R=>{this.O.fire(R),!R&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(R=>{this.W.fire(R)})),this.L=this.B(new F.$7U({appendTitle:h,isChecked:!1,hoverDelegate:T,...n.toggleStyles})),this.B(this.L.onChange(R=>{this.O.fire(R),!R&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new F.$6U({appendTitle:r,isChecked:!1,hoverDelegate:T,...n.toggleStyles})),this.B(this.M.onChange(R=>{this.O.fire(R),!R&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(R=>{this.U.fire(R)}));const N=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,R=>{if(R.equals(15)||R.equals(17)||R.equals(9)){const I=N.indexOf(this.domNode.ownerDocument.activeElement);if(I>=0){let j=-1;R.equals(17)?j=(I+1)%N.length:R.equals(15)&&(I===0?j=N.length-1:j=I-1),R.equals(9)?(N[I].blur(),this.inputBox.focus()):j>=0&&N[j].focus(),i.$gS.stop(R,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),f?.appendChild(this.domNode),this.B(i.$lR(this.inputBox.inputElement,"compositionstart",N=>{this.s=!0})),this.B(i.$lR(this.inputBox.inputElement,"compositionend",N=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,N=>this.P.fire(N)),this.C(this.inputBox.inputElement,N=>this.S.fire(N)),this.D(this.inputBox.inputElement,N=>this.R.fire()),this.j(this.inputBox.inputElement,N=>this.Q.fire(N))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(f){this.inputBox.layout(),this.X(f.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const f of this.N)f.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const f of this.N)f.disable()}setFocusInputOnOptionClick(f){this.n=f}setEnabled(f){f?this.enable():this.disable()}setAdditionalToggles(f){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new m.$Tc;for(const e of f??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(f=!1){f?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(f){this.inputBox.value!==f&&(this.inputBox.value=f)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(f){this.M&&(this.M.checked=f)}getWholeWords(){return this.L?.checked??!1}setWholeWords(f){this.L&&(this.L.checked=f)}getRegex(){return this.J?.checked??!1}setRegex(f){this.J&&(this.J.checked=f,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(f){this.inputBox.showMessage(f)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$9U=B}),define(ge[143],be([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e,n,r,h,g,D,o,d,l,T,N,R,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$GV=t.$FV=t.$EV=t.RenderIndentGuides=t.$DV=t.$CV=void 0;class j extends m.$xT{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(E=>E.element)),this.c=s}}function $(k){return k instanceof m.$xT?new j(k):k}class O{constructor(s,E){this.d=s,this.f=E,this.b=d.$Uc.None,this.c=new d.$Tc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,E){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(v=>v.element),E)}onDragStart(s,E){this.f.onDragStart?.($(s),E)}onDragOver(s,E,v,L,z,X=!0){const U=this.f.onDragOver($(s),E&&E.element,v,L,z),oe=this.a!==E;if(oe&&(this.b.dispose(),this.a=E),typeof E>"u")return U;if(oe&&typeof U!="boolean"&&U.autoExpand&&(this.b=(0,n.$ph)(()=>{const je=this.d(),Ee=je.getNodeLocation(E);je.isCollapsed(Ee)&&je.setCollapsed(Ee,!1),this.a=void 0},500,this.c)),typeof U=="boolean"||!U.accept||typeof U.bubble>"u"||U.feedback){if(!X){const je=typeof U=="boolean"?U:U.accept,Ee=typeof U=="boolean"?void 0:U.effect;return{accept:je,effect:Ee,feedback:[v]}}return U}if(U.bubble===1){const je=this.d(),Ee=je.getNodeLocation(E),Te=je.getParentNodeLocation(Ee),We=je.getNode(Te),Ue=Te&&je.getListIndex(Te);return this.onDragOver(s,We,Ue,L,z,!1)}const we=this.d(),me=we.getNodeLocation(E),Ie=we.getListIndex(me),ke=we.getListRenderCount(me);return{...U,feedback:(0,e.$Sb)(Ie,Ie+ke)}}drop(s,E,v,L,z){this.b.dispose(),this.a=void 0,this.f.drop($(s),E&&E.element,v,L,z)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function V(k,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(E){return s.identityProvider.getId(E.element)}},dnd:s.dnd&&new O(k,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return s.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return s.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(E){const v=k(),L=v.getNodeLocation(E),z=v.getParentNodeLocation(L);return v.getNode(z).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?E=>s.accessibilityProvider.isChecked(E.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?E=>s.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return s.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?E=>s.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(E=>s.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class M{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,E){this.a.setDynamicHeight?.(s.element,E)}}t.$CV=M;class H{static lift(s){return s instanceof H?s:new H(s)}static empty(s=0){return new H({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const E of s.expanded)this.expanded[E]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$DV=H;var C;(function(k){k.None="none",k.OnHover="onHover",k.Always="always"})(C||(t.RenderIndentGuides=C={}));class G{get elements(){return this.b}constructor(s,E=[]){this.b=E,this.a=new d.$Tc,this.onDidChange=D.Event.forEach(s,v=>this.b=v,this.a)}dispose(){this.a.dispose()}}class Z{static{this.a=8}constructor(s,E,v,L,z,X={}){this.o=s,this.p=E,this.q=L,this.s=z,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Uc.None,this.m=new d.$Tc,this.templateId=s.templateId,this.updateOptions(X),D.Event.map(v,U=>U.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const E=(0,l.$sm)(s.indent,0,40);if(E!==this.d){this.d=E;for(const[v,L]of this.c)this.v(v,L)}}if(typeof s.renderIndentGuides<"u"){const E=s.renderIndentGuides!==C.None;if(E!==this.g){this.g=E;for(const[v,L]of this.c)this.w(v,L);if(this.k.dispose(),E){const v=new d.$Tc;this.q.onDidChange(this.x,this,v),this.k=v,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const E=(0,i.$lS)(s,(0,i.$)(".monaco-tl-row")),v=(0,i.$lS)(E,(0,i.$)(".monaco-tl-indent")),L=(0,i.$lS)(E,(0,i.$)(".monaco-tl-twistie")),z=(0,i.$lS)(E,(0,i.$)(".monaco-tl-contents")),X=this.o.renderTemplate(z);return{container:s,indent:v,twistie:L,indentGuidesDisposable:d.$Uc.None,templateData:X}}renderElement(s,E,v,L){this.c.set(s,v),this.b.set(s.element,s),this.v(s,v),this.o.renderElement(s,E,v.templateData,L)}disposeElement(s,E,v,L){v.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,E,v.templateData,L),typeof L=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const E=this.b.get(s);E&&this.u(E)}u(s){const E=this.c.get(s);E&&(this.x(this.q.elements),this.v(s,E))}v(s,E){const v=Z.a+(s.depth-1)*this.d;E.twistie.style.paddingLeft=`${v}px`,E.indent.style.width=`${v+this.d-16}px`,s.collapsible?E.container.setAttribute("aria-expanded",String(!s.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$Mj.treeItemExpanded));let L=!1;this.o.renderTwistie&&(L=this.o.renderTwistie(s.element,E.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(L||E.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$Mj.treeItemExpanded)),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",s.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),this.w(s,E)}w(s,E){if((0,i.$kR)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const v=new d.$Tc,L=this.p();for(;;){const z=L.getNodeLocation(s),X=L.getParentNodeLocation(z);if(!X)break;const U=L.getNode(X),oe=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(U)&&oe.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(oe):E.indent.insertBefore(oe,E.indent.firstElementChild),this.s.add(U,oe),v.add((0,d.$Sc)(()=>this.s.delete(U,oe))),s=U}E.indentGuidesDisposable=v}x(s){if(!this.g)return;const E=new Set,v=this.p();s.forEach(L=>{const z=v.getNodeLocation(L);try{const X=v.getParentNodeLocation(z);L.collapsible&&L.children.length>0&&!L.collapsed?E.add(L):X&&E.add(v.getNode(X))}catch{}}),this.j.forEach(L=>{E.has(L)||this.s.forEach(L,z=>z.classList.remove("active"))}),E.forEach(L=>{this.j.has(L)||this.s.forEach(L,z=>z.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Pc)(this.m)}}t.$EV=Z;class ce{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,E,v){this.g=s,this.j=E,this.k=v,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Tc,s.onWillRefilter(this.m,this,this.f)}filter(s,E){let v=1;if(this.k){const X=this.k.filter(s,E);if(typeof X=="boolean"?v=X?1:0:(0,B.$zV)(X)?v=(0,B.$AV)(X.visibility):v=X,v===0)return!1}if(this.a++,!this.c)return this.b++,{data:o.FuzzyScore.Default,visibility:v};const L=this.j.getKeyboardNavigationLabel(s),z=Array.isArray(L)?L:[L];for(const X of z){const U=X&&X.toString();if(typeof U>"u")return{data:o.FuzzyScore.Default,visibility:v};let oe;if(this.g.findMatchType===Fe.Contiguous){const we=U.toLowerCase().indexOf(this.d);if(we>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let me=this.d.length;me>0;me--)oe.push(we+me-1)}}else oe=(0,o.$Bk)(this.c,this.d,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,z.length===1?{data:oe,visibility:v}:{data:{label:U,score:oe},visibility:v}}return this.g.findMode===De.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:o.FuzzyScore.Default,visibility:v}}m(){this.a=0,this.b=0}dispose(){(0,d.$Pc)(this.f)}}class re extends w.$9T{constructor(s){super({icon:r.$Mj.listFilter,title:(0,N.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,R.$dT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$FV=re;class te extends w.$9T{constructor(s){super({icon:r.$Mj.searchFuzzy,title:(0,N.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,R.$dT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$GV=te;const $e={inputBoxStyles:A.$SU,toggleStyles:w.$7T,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var De;(function(k){k[k.Highlight=0]="Highlight",k[k.Filter=1]="Filter"})(De||(t.TreeFindMode=De={}));var Fe;(function(k){k[k.Fuzzy=0]="Fuzzy",k[k.Contiguous=1]="Contiguous"})(Fe||(t.TreeFindMatchType=Fe={}));class He extends d.$Uc{set mode(s){this.b.checked=s===De.Filter,this.f.inputBox.setPlaceHolder(s===De.Filter?(0,N.localize)(2,null):(0,N.localize)(3,null))}set matchType(s){this.c.checked=s===Fe.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,E,v,L,z,X){super(),this.t=E,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new D.$_d,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,d.$Sc)(()=>s.removeChild(this.a.root)));const U=X?.styles??$e;U.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=U.listFilterWidgetBackground),U.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${U.listFilterWidgetShadow}`);const oe=this.B((0,R.$eT)());this.b=this.B(new re({...U.toggleStyles,isChecked:L===De.Filter,hoverDelegate:oe})),this.c=this.B(new te({...U.toggleStyles,isChecked:z===Fe.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=D.Event.map(this.b.onChange,()=>this.b.checked?De.Filter:De.Highlight,this.q),this.onDidChangeMatchType=D.Event.map(this.c.onChange,()=>this.c.checked?Fe.Fuzzy:Fe.Contiguous,this.q),this.f=this.B(new S.$9U(this.a.findInput,v,{label:(0,N.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:U.inputBoxStyles,toggleStyles:U.toggleStyles,history:X?.history})),this.g=this.B(new W.$fT(this.a.actionbar)),this.mode=L;const we=this.B(new F.$nT(this.f.inputBox.inputElement,"keydown")),me=D.Event.chain(we.event,Ee=>Ee.map(Te=>new P.$iR(Te)));this.B(me(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Ie=this.B(new f.$5i("close",(0,N.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Ie,{icon:!0,label:!1});const ke=this.B(new F.$nT(this.a.grab,"mousedown"));this.B(ke.event(Ee=>{const Te=new d.$Tc,We=Te.add(new F.$nT((0,i.getWindow)(Ee),"mousemove")),Ue=Te.add(new F.$nT((0,i.getWindow)(Ee),"mouseup")),Ye=this.m,_e=Ee.pageX,Y=this.s,ie=Ee.pageY;this.a.grab.classList.add("grabbing");const pe=this.a.root.style.transition;this.a.root.style.transition="unset";const ye=Re=>{const xe=Re.pageX-_e;this.m=Ye-xe;const Ve=Re.pageY-ie;this.s=Y+Ve,this.layout()};Te.add(We.event(ye)),Te.add(Ue.event(Re=>{ye(Re),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=pe,Te.dispose()}))}));const je=D.Event.chain(this.B(new F.$nT(this.a.grab,"keydown")).event,Ee=>Ee.map(Te=>new P.$iR(Te)));this.B(je(Ee=>{let Te,We;if(Ee.keyCode===15?Te=Number.POSITIVE_INFINITY:Ee.keyCode===17?Te=0:Ee.keyCode===10&&(Te=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?We=0:Ee.keyCode===18&&(We=Number.POSITIVE_INFINITY),Te!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=Te,this.layout()),We!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=We;const Ue=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ue},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,l.$sm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,l.$sm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$oh)(300),super.dispose()}}class he{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,E,v,L,z,X={}){this.t=s,this.u=v,this.v=L,this.w=z,this.x=X,this.b="",this.c="",this.j=0,this.k=new D.$_d,this.onDidChangeMode=this.k.event,this.m=new D.$_d,this.onDidChangeMatchType=this.m.event,this.o=new D.$_d,this.onDidChangePattern=this.o.event,this.p=new D.$_d,this.onDidChangeOpenState=this.p.event,this.q=new d.$Tc,this.s=new d.$Tc,this.d=s.options.defaultFindMode??De.Highlight,this.f=s.options.defaultFindMatchType??Fe.Fuzzy,E.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new He(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,v=>!o.FuzzyScore.isDefault(v.filterData));const E=this.t.getFocus();if(E.length>0){const v=E[0];this.t.getRelativeTop(v)===null&&this.t.reveal(v,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,N.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!o.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(k,s){return k.position===s.position&&ae(k,s)}function ae(k,s){return k.node.element===s.node.element&&k.startIndex===s.startIndex&&k.height===s.height&&k.endIndex===s.endIndex}class le{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const E=this.stickyNodes[this.count-2];return E.position+E.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,ae)||this.count===0)return!1;const E=this.stickyNodes[this.count-1],v=s.stickyNodes[s.count-1];return E.position!==v.position}}class J{constrainStickyScrollNodes(s,E,v){for(let L=0;L<s.length;L++){const z=s[L];if(z.position+z.height>v||L>=E)return s.slice(0,L)}return s}}class Q extends d.$Uc{constructor(s,E,v,L,z,X={}){super(),this.g=s,this.j=E,this.m=v,this.s=z,this.c=.4;const U=this.validateStickySettings(X);this.b=U.stickyScrollMaxItemCount,this.a=X.stickyScrollDelegate??new J,this.f=this.B(new se(v.getScrollableElement(),v,s,L,z,X.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(v.onDidScroll(()=>this.u())),this.B(v.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let E;if(s===0?E=this.m.firstVisibleIndex:E=this.m.indexAt(s+this.m.scrollTop),!(E<0||E>=this.m.length))return this.m.element(E)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const E=this.w(s);this.f.setState(E)}w(s){const E=[];let v=s,L=0,z=this.z(v,void 0,L);for(;z&&(E.push(z),L+=z.height,!(E.length<=this.b&&(v=this.y(z),!v)));)z=this.z(v,z.node,L);const X=this.H(E);return X.length?new le(X):void 0}y(s){return this.t(s.position+s.height)}z(s,E,v){const L=this.F(s,E);if(L&&!(L===s&&(!this.J(s)||this.C(s,v))))return this.D(L,v)}C(s,E){const v=this.L(s),L=this.m.getElementTop(v),z=E;return this.m.scrollTop===L-z}D(s,E){const v=this.s.getHeight(s),{startIndex:L,endIndex:z}=this.M(s),X=this.G(z,E,v);return{node:s,position:X,height:v,startIndex:L,endIndex:z}}F(s,E=void 0){let v=s,L=this.I(v);for(;L;){if(L===E)return v;v=L,L=this.I(v)}if(E===void 0)return v}G(s,E,v){let L=this.m.getRelativeTop(s);if(L===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const we=this.s.getHeight(this.m.element(s)),me=this.m.getRelativeTop(s+1);L=me?me-we/this.m.renderHeight:null}if(L===null)return E;const z=this.m.element(s),X=this.s.getHeight(z),oe=L*this.m.renderHeight+X;return E+v>oe&&E<=oe?oe-v:E}H(s){if(s.length===0)return[];const E=this.m.renderHeight*this.c,v=s[s.length-1];if(s.length<=this.b&&v.position+v.height<=E)return s;const L=this.a.constrainStickyScrollNodes(s,this.b,E);if(!L.length)return[];const z=L[L.length-1];if(L.length>this.b||z.position+z.height>E)throw new Error("stickyScrollDelegate violates constraints");return L}I(s){const E=this.j.getNodeLocation(s),v=this.j.getParentNodeLocation(E);return v?this.j.getNode(v):void 0}J(s){const E=this.j.getNodeLocation(s);return this.j.getListRenderCount(E)>1}L(s){const E=this.j.getNodeLocation(s);return this.j.getListIndex(E)}M(s){const E=this.j.getNodeLocation(s),v=this.j.getListIndex(E);if(v<0)throw new Error("Node not found in tree");const L=this.j.getListRenderCount(E),z=v+L-1;return{startIndex:v,endIndex:z}}nodePositionTopBelowWidget(s){const E=[];let v=this.I(s);for(;v;)E.push(v),v=this.I(v);let L=0;for(let z=0;z<E.length&&z<this.b;z++)L+=this.s.getHeight(E[z]);return L}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const E=this.validateStickySettings(s);this.b!==E.stickyScrollMaxItemCount&&(this.b=E.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let E=7;return typeof s.stickyScrollMaxItemCount=="number"&&(E=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:E}}}class se{constructor(s,E,v,L,z,X){this.g=E,this.j=v,this.k=L,this.m=z,this.o=X,this.c=[],this.d=new d.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const U=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(U),this.f=new fe(this.a,E),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(E=>E.node===s)}setState(s){const E=!!this.b&&this.b.count>0,v=!!s&&s.count>0;if(!E&&!v||E&&v&&this.b.equal(s))return;if(E!==v&&this.s(v),!v){this.b=void 0,this.c=[],this.d.clear();return}const L=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${L.position}px`;else{this.d.clear();const z=Array(s.count);for(let X=s.count-1;X>=0;X--){const U=s.stickyNodes[X],{element:oe,disposable:we}=this.p(U,X,s.count);z[X]=oe,this.a.appendChild(oe),this.d.add(we)}this.f.updateElements(z,s),this.c=z}this.b=s,this.a.style.height=`${L.position+L.height}px`}p(s,E,v){const L=s.startIndex,z=document.createElement("div");z.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(z.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(z.style.lineHeight=`${s.height}px`),z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${L}`),z.setAttribute("data-parity",L%2===0?"even":"odd"),z.setAttribute("id",this.g.getElementID(L));const X=this.q(z,s.node.element,E,v),U=this.m.getTemplateId(s.node),oe=this.k.find(ke=>ke.templateId===U);if(!oe)throw new Error(`No renderer found for template id ${U}`);let we=s.node;we===this.j.getNode(this.j.getNodeLocation(s.node))&&(we=new Proxy(s.node,{}));const me=oe.renderTemplate(z);oe.renderElement(we,s.startIndex,me,s.height);const Ie=(0,d.$Sc)(()=>{X.dispose(),oe.disposeElement(we,s.startIndex,me,s.height),oe.disposeTemplate(me),z.remove()});return{element:z,disposable:Ie}}q(s,E,v,L){if(!this.o)return d.$Uc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(E,v,L))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(E,v))),this.o.getRole&&s.setAttribute("role",this.o.getRole(E)??"treeitem");const z=this.o.getAriaLabel(E),X=z&&typeof z!="string"?z:(0,I.constObservable)(z),U=(0,I.autorun)(we=>{const me=we.readObservable(X);me?s.setAttribute("aria-label",me):s.removeAttribute("aria-label")});typeof z=="string"||z&&s.setAttribute("aria-label",z.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(E);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),U}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class fe extends d.$Uc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,E){super(),this.s=s,this.t=E,this.a=-1,this.b=[],this.f=new D.$_d,this.onDidChangeHasFocus=this.f.event,this.g=new D.$_d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(v=>this.w(v))),this.B(this.t.onMouseDown(v=>this.y(v))),this.B(this.t.onContextMenu(v=>this.u(v)))}u(s){const E=s.browserEvent.target;if(!(0,b.$KT)(E)&&!(0,b.$JT)(E)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$bS)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const X=this.c.stickyNodes.findIndex(U=>U.node.element===s.element?.element);if(X===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(X);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const L=this.c.stickyNodes[this.a].node.element,z=this.b[this.a];this.g.fire({element:L,anchor:z,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const E=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([E]),this.C(E,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const E=s.browserEvent.target;!(0,b.$KT)(E)&&!(0,b.$JT)(E)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,E){if(E&&E.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(E&&E.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const v=this.a;if(this.D(),this.b=s,this.c=E,E){const L=(0,l.$sm)(v,0,E.count-1);this.F(L)}else this.m&&this.t.domFocus();this.s.tabIndex=E?0:-1}z(s){const E=this.c;if(!E)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<E.count-1)&&E.lastNodePartiallyVisible()){const v=E.stickyNodes[s];this.C(v.endIndex+1,E)}}C(s,E){const v=E.stickyNodes[E.count-1],L=E.count>1?E.stickyNodes[E.count-2]:void 0,z=this.t.getElementTop(s),X=L?L.position+L.height+v.height:v.height;this.t.scrollTop=z-X}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const E=this.a;E>=0&&this.G(this.b[E],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,E){this.I(s,E&&this.m),this.J(s,E)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,E){s.classList.toggle("focused",E)}J(s,E){s.classList.toggle("passive-focused",E)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function ve(k){let s=c.TreeMouseEventTarget.Unknown;return(0,i.$TR)(k.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,i.$TR)(k.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,i.$TR)(k.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:k.browserEvent,element:k.element?k.element.element:null,target:s}}function Ne(k){const s=(0,b.$KT)(k.browserEvent.target);return{element:k.element?k.element.element:null,browserEvent:k.browserEvent,anchor:k.anchor,isStickyScroll:s}}function Ae(k,s){s(k),k.children.forEach(E=>Ae(E,s))}class Le{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,E){this.g=s,this.j=E,this.a=[],this.c=new D.$_d,this.onDidChange=this.c.event}set(s,E){!E?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,E)}k(s,E,v){if(this.a=[...s],this.b=void 0,this.d=void 0,!E){const L=this;this.c.fire({get elements(){return L.get()},browserEvent:v})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:E}){if(!this.j){const oe=this.m(),we=me=>oe.delete(me);E.forEach(me=>Ae(me,we)),this.set([...oe.values()]);return}const v=new Set,L=oe=>v.add(this.j.getId(oe.element).toString());E.forEach(oe=>Ae(oe,L));const z=new Map,X=oe=>z.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Ae(oe,X));const U=[];for(const oe of this.a){const we=this.j.getId(oe.element).toString();if(!v.has(we))U.push(oe);else{const Ie=z.get(we);Ie&&Ie.visible&&U.push(Ie)}}if(this.a.length>0&&U.length===0){const oe=this.g();oe&&U.push(oe)}this.k(U,!0)}m(){const s=new Set;for(const E of this.a)s.add(E);return s}}class x extends b.$PT{constructor(s,E,v){super(s),this.x=E,this.y=v}u(s){if((0,b.$LT)(s.browserEvent.target)||(0,b.$ET)(s.browserEvent.target)||(0,b.$FT)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const E=s.element;if(!E)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const v=s.browserEvent.target,L=v.classList.contains("monaco-tl-twistie")||v.classList.contains("monaco-icon-label")&&v.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,z=(0,b.$JT)(s.browserEvent.target);let X=!1;if(z?X=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?X=this.x.expandOnlyOnTwistieClick(E.element):X=!!this.x.expandOnlyOnTwistieClick,z)this.A(s,E);else{if(X&&!L&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(E.collapsible&&(!z||L)){const U=this.x.getNodeLocation(E),oe=s.browserEvent.altKey;if(this.x.setFocus([U]),this.x.toggleCollapsed(U,oe),L){s.browserEvent.isHandledByList=!0;return}}z||super.u(s)}A(s,E){if((0,b.$GT)(s.browserEvent.target)||(0,b.$HT)(s.browserEvent.target))return;const v=this.y();if(!v)throw new Error("Sticky scroll controller not found");const L=this.k.indexOf(E),z=this.k.getElementTop(L),X=v.nodePositionTopBelowWidget(E);this.x.scrollTop=z-X,this.k.domFocus(),this.k.setFocus([L]),this.k.setSelection([L])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const E=s.browserEvent.target;if(!(0,b.$KT)(E)&&!(0,b.$JT)(E)){super.s(s);return}}t(s){const E=s.browserEvent.target;if(!(0,b.$KT)(E)&&!(0,b.$JT)(E)){super.t(s);return}}}class u extends b.$ST{constructor(s,E,v,L,z,X,U,oe){super(s,E,v,L,oe),this.p=z,this.s=X,this.K=U}D(s){return new x(this,s.tree,s.stickyScrollProvider)}splice(s,E,v=[]){if(super.splice(s,E,v),v.length===0)return;const L=[],z=[];let X;v.forEach((U,oe)=>{this.p.has(U)&&L.push(s+oe),this.s.has(U)&&z.push(s+oe),this.K.has(U)&&(X=s+oe)}),L.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...L])),z.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...z])),typeof X=="number"&&super.setAnchor(X)}setFocus(s,E,v=!1){super.setFocus(s,E),v||this.p.set(s.map(L=>this.element(L)),E)}setSelection(s,E,v=!1){super.setSelection(s,E),v||this.s.set(s.map(L=>this.element(L)),E)}setAnchor(s,E=!1){super.setAnchor(s),E||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var y;(function(k){k[k.Tree=0]="Tree",k[k.StickyScroll=1]="StickyScroll"})(y||(t.AbstractTreePart=y={}));class a{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return D.Event.map(this.j.onMouseClick,ve)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.j.onMouseDblClick,ve),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return D.Event.map(this.j.onMouseOver,ve)}get onMouseOut(){return D.Event.map(this.j.onMouseOut,ve)}get onContextMenu(){return D.Event.any(D.Event.filter(D.Event.map(this.j.onContextMenu,Ne),s=>!s.isStickyScroll),this.B?.onContextMenu??D.Event.None)}get onTap(){return D.Event.map(this.j.onTap,ve)}get onPointer(){return D.Event.map(this.j.onPointer,ve)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??De.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Fe.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,E,v,L,z={}){this.G=s,this.H=z,this.y=new D.$he,this.onDidChangeFindOpenState=D.Event.None,this.onDidChangeStickyScrollFocused=D.Event.None,this.D=new d.$Tc,this.E=new D.$_d,this.onWillRefilter=this.E.event,this.F=new D.$_d,this.onDidUpdateOptions=this.F.event,this.p=new M(v);const X=new D.$ie,U=new D.$ie,oe=this.D.add(new G(U.event)),we=new g.$Hc;this.k=L.map(Ee=>new Z(Ee,()=>this.o,X.event,oe,we,z));for(const Ee of this.k)this.D.add(Ee);let me;z.keyboardNavigationLabelProvider&&(me=new ce(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:me},this.D.add(me)),this.q=new Le(()=>this.j.getFocusedElements()[0],z.identityProvider),this.w=new Le(()=>this.j.getSelectedElements()[0],z.identityProvider),this.x=new Le(()=>this.j.getAnchorElement(),z.identityProvider),this.j=new u(s,E,this.p,this.k,this.q,this.w,this.x,{...V(()=>this.o,z),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,z),X.input=this.o.onDidChangeCollapseState;const Ie=D.Event.forEach(this.o.onDidSplice,Ee=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ee),this.w.onDidModelSplice(Ee)})},this.D);Ie(()=>null,null,this.D);const ke=this.D.add(new D.$_d),je=this.D.add(new n.$kh(0));if(this.D.add(D.Event.any(Ie,this.q.onDidChange,this.w.onDidChange)(()=>{je.trigger(()=>{const Ee=new Set;for(const Te of this.q.getNodes())Ee.add(Te);for(const Te of this.w.getNodes())Ee.add(Te);ke.fire([...Ee.values()])})})),U.input=ke.event,z.keyboardSupport!==!1){const Ee=D.Event.chain(this.j.onKeyDown,Te=>Te.filter(We=>!(0,b.$ET)(We.target)).map(We=>new P.$iR(We)));D.Event.chain(Ee,Te=>Te.filter(We=>We.keyCode===15))(this.J,this,this.D),D.Event.chain(Ee,Te=>Te.filter(We=>We.keyCode===17))(this.K,this,this.D),D.Event.chain(Ee,Te=>Te.filter(We=>We.keyCode===10))(this.L,this,this.D)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const Ee=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new he(this,this.o,this.j,me,z.contextViewProvider,Ee),this.A=Te=>this.z.shouldAllowFocus(Te),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;z.enableStickyScroll&&(this.B=new Q(this,this.o,this.j,this.k,this.p,z),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$6R)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===C.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const E of this.k)E.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===C.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new Q(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=D.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const E=this.o.getListIndex(s);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$YR)(this.getHTMLElement())}layout(s,E){this.j.layout(s,E),(0,T.$5f)(E)&&this.z?.layout(E)}style(s){const E=`.${this.j.domId}`,v=[];s.treeIndentGuidesStroke&&(v.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),v.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`)),s.listBackground&&(v.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${s.listBackground}; }`),v.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${s.listBackground}; }`)),s.listFocusForeground&&(v.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),v.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const L=(0,i.$DS)(s.listFocusAndSelectionOutline,(0,i.$DS)(s.listSelectionOutline,s.listFocusOutline??""));L&&(v.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${L}; outline-offset: -1px;}`),v.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(v.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),v.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),v.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),v.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),v.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=v.join(`
`),this.j.style(s)}getParentElement(s){const E=this.o.getParentNodeLocation(s);return this.o.getNode(E).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,E=!1){return this.o.setCollapsed(s,!0,E)}expand(s,E=!1){return this.o.setCollapsed(s,!1,E)}toggleCollapsed(s,E=!1){return this.o.setCollapsed(s,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,E){return this.o.setCollapsible(s,E)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const E=this.o.getNode(s);this.x.set([E]);const v=this.o.getListIndex(s);v>-1&&this.j.setAnchor(v,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,E){this.y.bufferEvents(()=>{const v=s.map(z=>this.o.getNode(z));this.w.set(v,E);const L=s.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setSelection(L,E,!0)})}getSelection(){return this.w.get()}setFocus(s,E){this.y.bufferEvents(()=>{const v=s.map(z=>this.o.getNode(z));this.q.set(v,E);const L=s.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setFocus(L,E,!0)})}focusNext(s=1,E=!1,v,L=(0,i.$bS)(v)&&v.altKey?void 0:this.A){this.j.focusNext(s,E,v,L)}focusPrevious(s=1,E=!1,v,L=(0,i.$bS)(v)&&v.altKey?void 0:this.A){this.j.focusPrevious(s,E,v,L)}focusNextPage(s,E=(0,i.$bS)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,E)}focusPreviousPage(s,E=(0,i.$bS)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,E,()=>this.B?.height??0)}focusLast(s,E=(0,i.$bS)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,E)}focusFirst(s,E=(0,i.$bS)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,E)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,E){this.o.expandTo(s);const v=this.o.getListIndex(s);if(v!==-1)if(!this.B)this.j.reveal(v,E);else{const L=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(v,E,L)}}getRelativeTop(s){const E=this.o.getListIndex(s);if(E===-1)return null;const v=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(E,v?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$xV(this.G,"Can't get tree view state without an identity provider");const E=X=>s.getId(X).toString(),v=H.empty(this.scrollTop);for(const X of this.getFocus())v.focus.add(E(X));for(const X of this.getSelection())v.selection.add(E(X));const L=this.o.getNode(),z=[L];for(;z.length>0;){const X=z.shift();X!==L&&X.collapsible&&(v.expanded[E(X.element)]=X.collapsed?0:1),z.push(...X.children)}return v}J(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const v=E[0],L=this.o.getNodeLocation(v);if(!this.o.setCollapsed(L,!0)){const X=this.o.getParentNodeLocation(L);if(!X)return;const U=this.o.getListIndex(X);this.j.reveal(U),this.j.setFocus([U])}}K(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const v=E[0],L=this.o.getNodeLocation(v);if(!this.o.setCollapsed(L,!1)){if(!v.children.some(oe=>oe.visible))return;const[X]=this.j.getFocus(),U=X+1;this.j.reveal(U),this.j.setFocus([U])}}L(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const v=E[0],L=this.o.getNodeLocation(v),z=s.browserEvent.altKey;this.o.setCollapsed(L,void 0,z)}navigate(s){return new p(this.j,this.o,s)}dispose(){(0,d.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$HV=a;class p{constructor(s,E,v){this.b=s,this.c=E,v?this.a=this.c.getListIndex(v):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[144],be([1,0,143,134,30,32]),function(ne,t,i,F,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SV=void 0;class S extends i.$HV{constructor(m,b,w,B,c,f={}){super(m,b,w,B,f),this.f=m,this.g=c,this.d=new Map,this.c=f.identityProvider}getInput(){return this.b}setInput(m,b){if(b&&!this.c)throw new P.$xV(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!b){this.m(m);return}const w=[],B=[],c=e=>{const n=this.c.getId(e).toString();return!b.expanded[n]},f=e=>{const n=this.c.getId(e.element).toString();b.focus.has(n)&&w.push(e.element),b.selection.has(n)&&B.push(e.element)};this.m(m,c,f),this.setFocus(w),this.setSelection(B),b&&typeof b.scrollTop=="number"&&(this.scrollTop=b.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new P.$xV(this.f,"Tree input not set");let b;this.c&&(b=w=>{const B=this.c.getId(w).toString(),c=this.d.get(B);if(c)return c.collapsed}),this.m(m,b)}resort(m=this.b,b=!0){this.o.resort(m===this.b?null:m,b)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,b,w){let B;if(this.c){const c=new Set,f=w;w=e=>{const n=this.c.getId(e.element).toString();c.add(n),this.d.set(n,e),f?.(e)},B=e=>{const n=this.c.getId(e.element).toString();c.has(n)||this.d.delete(n)}}this.o.setChildren(m===this.b?null:m,this.s(m,b).elements,{onDidCreateNode:w,onDidDeleteNode:B})}s(m,b){const w=[...this.g.getChildren(m)];return{elements:W.Iterable.map(w,c=>{const{elements:f,size:e}=this.s(c,b),n=this.g.hasChildren?this.g.hasChildren(c):void 0,r=e===0?void 0:b&&b(c);return{element:c,children:f,collapsible:n,collapsed:r}}),size:w.length}}M(m,b,w){return new F.$IV(m,b,w)}}t.$SV=S}),define(ge[77],be([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9h=t.ProxyChannel=t.$8h=t.$5h=t.$4h=t.$3h=t.RequestInitiator=t.$2h=t.$Yh=t.$Xh=void 0,t.$Zh=j,t.$1h=$,t.$6h=G,t.$7h=Z;var f;(function(he){he[he.Promise=100]="Promise",he[he.PromiseCancel=101]="PromiseCancel",he[he.EventListen=102]="EventListen",he[he.EventDispose=103]="EventDispose"})(f||(f={}));function e(he){switch(he){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(he){he[he.Initialize=200]="Initialize",he[he.PromiseSuccess=201]="PromiseSuccess",he[he.PromiseError=202]="PromiseError",he[he.PromiseErrorObj=203]="PromiseErrorObj",he[he.EventFire=204]="EventFire"})(n||(n={}));function r(he){switch(he){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(he){he[he.Uninitialized=0]="Uninitialized",he[he.Idle=1]="Idle"})(h||(h={}));function g(he){let _=0;for(let ae=0;;ae+=7){const le=he.read(1);if(_|=(le.buffer[0]&127)<<ae,!(le.buffer[0]&128))return _}}const D=N(0);function o(he,_){if(_===0){he.write(D);return}let ae=0;for(let J=_;J!==0;J=J>>>7)ae++;const le=P.$ze.alloc(ae);for(let J=0;_!==0;J++)le.buffer[J]=_&127,_=_>>>7,_>0&&(le.buffer[J]|=128);he.write(le)}class d{constructor(_){this.b=_,this.a=0}read(_){const ae=this.b.slice(this.a,this.a+_);return this.a+=ae.byteLength,ae}}t.$Xh=d;class l{constructor(){this.a=[]}get buffer(){return P.$ze.concat(this.a)}write(_){this.a.push(_)}}t.$Yh=l;var T;(function(he){he[he.Undefined=0]="Undefined",he[he.String=1]="String",he[he.Buffer=2]="Buffer",he[he.VSBuffer=3]="VSBuffer",he[he.Array=4]="Array",he[he.Object=5]="Object",he[he.Int=6]="Int"})(T||(T={}));function N(he){const _=P.$ze.alloc(1);return _.writeUInt8(he,0),_}const R={Undefined:N(T.Undefined),String:N(T.String),Buffer:N(T.Buffer),VSBuffer:N(T.VSBuffer),Array:N(T.Array),Object:N(T.Object),Uint:N(T.Int)},I=typeof Buffer<"u";function j(he,_){if(typeof _>"u")he.write(R.Undefined);else if(typeof _=="string"){const ae=P.$ze.fromString(_);he.write(R.String),o(he,ae.byteLength),he.write(ae)}else if(I&&Buffer.isBuffer(_)){const ae=P.$ze.wrap(_);he.write(R.Buffer),o(he,ae.byteLength),he.write(ae)}else if(_ instanceof P.$ze)he.write(R.VSBuffer),o(he,_.byteLength),he.write(_);else if(Array.isArray(_)){he.write(R.Array),o(he,_.length);for(const ae of _)j(he,ae)}else if(typeof _=="number"&&(_|0)===_)he.write(R.Uint),o(he,_);else{const ae=P.$ze.fromString(JSON.stringify(_));he.write(R.Object),o(he,ae.byteLength),he.write(ae)}}function $(he){switch(he.read(1).readUInt8(0)){case T.Undefined:return;case T.String:return he.read(g(he)).toString();case T.Buffer:return he.read(g(he)).buffer;case T.VSBuffer:return he.read(g(he));case T.Array:{const ae=g(he),le=[];for(let J=0;J<ae;J++)le.push($(he));return le}case T.Object:return JSON.parse(he.read(g(he)).toString());case T.Int:return g(he)}}class O{constructor(_,ae,le=null,J=1e3){this.h=_,this.j=ae,this.k=le,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(_,ae){this.b.set(_,ae),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ae=this.o([_.type]);this.k?.logOutgoing(ae,0,1,r(_.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ae,_.id,1,r(_.type),_.data);return}}}o(_,ae=void 0){const le=new l;return j(le,_),j(le,ae),this.p(le.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ae=new d(_),le=$(ae),J=$(ae),Q=le[0];switch(Q){case 100:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(Q)}: ${le[2]}.${le[3]}`,J),this.s({type:Q,id:le[1],channelName:le[2],name:le[3],arg:J});case 102:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(Q)}: ${le[2]}.${le[3]}`,J),this.t({type:Q,id:le[1],channelName:le[2],name:le[3],arg:J});case 101:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(Q)}`),this.u({type:Q,id:le[1]});case 103:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(Q)}`),this.u({type:Q,id:le[1]})}}s(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const le=new W.$je;let J;try{J=ae.call(this.j,_.name,_.arg,le.token)}catch(fe){J=Promise.reject(fe)}const Q=_.id;J.then(fe=>{this.m({id:Q,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:Q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:Q,data:fe,type:203})}).finally(()=>{se.dispose(),this.d.delete(_.id)});const se=(0,b.$Sc)(()=>le.cancel());this.d.set(_.id,se)}t(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const le=_.id,Q=ae.listen(this.j,_.name,_.arg)(se=>this.m({id:le,data:se,type:204}));this.d.set(_.id,Q)}u(_){const ae=this.d.get(_.id);ae&&(ae.dispose(),this.d.delete(_.id))}v(_){let ae=this.g.get(_.channelName);ae||(ae=[],this.g.set(_.channelName,ae));const le=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:_,timeoutTimer:le})}w(_){const ae=this.g.get(_);if(ae){for(const le of ae)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$2h=O;var V;(function(he){he[he.LocalSide=0]="LocalSide",he[he.OtherSide=1]="OtherSide"})(V||(t.RequestInitiator=V={}));class M{constructor(_,ae=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$_d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=ae}getChannel(_){const ae=this;return{call(le,J,Q){return ae.a?Promise.reject(new A.$5):ae.m(_,le,J,Q)},listen(le,J){return ae.a?m.Event.None:ae.o(_,le,J)}}}m(_,ae,le,J=W.CancellationToken.None){const Q=this.g++,fe={id:Q,type:100,channelName:_,name:ae,arg:le};if(J.isCancellationRequested)return Promise.reject(new A.$5);let ve;return new Promise((Ae,Le)=>{if(J.isCancellationRequested)return Le(new A.$5);const x=()=>{const p=k=>{switch(k.type){case 201:this.f.delete(Q),Ae(k.data);break;case 202:{this.f.delete(Q);const s=new Error(k.data.message);s.stack=Array.isArray(k.data.stack)?k.data.stack.join(`
`):k.data.stack,s.name=k.data.name,Le(s);break}case 203:this.f.delete(Q),Le(k.data);break}};this.f.set(Q,p),this.p(fe)};let u=null;this.b===h.Idle?x():(u=(0,F.$ah)(p=>this.u()),u.then(()=>{u=null,x()}));const y=()=>{u?(u.cancel(),u=null):this.p({id:Q,type:101}),Le(new A.$5)},a=J.onCancellationRequested(y);ve=(0,b.$Rc)((0,b.$Sc)(y),a),this.d.add(ve)}).finally(()=>{ve.dispose(),this.d.delete(ve)})}o(_,ae,le){const J=this.g++,se={id:J,type:102,channelName:_,name:ae,arg:le};let fe=null;const ve=new m.$_d({onWillAddFirstListener:()=>{fe=(0,F.$ah)(Ae=>this.u()),fe.then(()=>{fe=null,this.d.add(ve),this.p(se)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(ve),this.p({id:J,type:103}))}}),Ne=Ae=>ve.fire(Ae.data);return this.f.set(J,Ne),ve.event}p(_){switch(_.type){case 100:case 102:{const ae=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ae,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ae=this.q([_.type,_.id]);this.j?.logOutgoing(ae,_.id,0,e(_.type));return}}}q(_,ae=void 0){const le=new l;return j(le,_),j(le,ae),this.r(le.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ae=new d(_),le=$(ae),J=$(ae),Q=le[0];switch(Q){case 200:return this.j?.logIncoming(_.byteLength,0,0,r(Q)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,le[1],0,r(Q),J),this.t({type:le[0],id:le[1],data:J})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$3h=M,Ze([S.$Rh],M.prototype,"onDidInitializePromise",null);class H{get connections(){const _=[];return this.f.forEach(ae=>_.push(ae)),_}constructor(_,ae,le){this.a=new Map,this.f=new Set,this.g=new m.$_d,this.onDidAddConnection=this.g.event,this.h=new m.$_d,this.onDidRemoveConnection=this.h.event,this.j=new b.$Tc,this.j.add(_(({protocol:J,onDidClientDisconnect:Q})=>{const se=m.Event.once(J.onMessage);this.j.add(se(fe=>{const ve=new d(fe),Ne=$(ve),Ae=new O(J,Ne,ae,le),Le=new M(J,ae);this.a.forEach((u,y)=>Ae.registerChannel(y,u));const x={channelServer:Ae,channelClient:Le,ctx:Ne};this.f.add(x),this.g.fire(x),this.j.add(Q(()=>{Ae.dispose(),Le.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(_,ae){const le=this;return{call(J,Q,se){let fe;if((0,c.$cg)(ae)){const Ne=(0,i.$4b)(le.connections.filter(ae));fe=Ne?Promise.resolve(Ne):m.Event.toPromise(m.Event.filter(le.onDidAddConnection,ae))}else fe=ae.routeCall(le,J,Q);const ve=fe.then(Ne=>Ne.channelClient.getChannel(_));return G(ve).call(J,Q,se)},listen(J,Q){if((0,c.$cg)(ae))return le.k(_,ae,J,Q);const se=ae.routeEvent(le,J,Q).then(fe=>fe.channelClient.getChannel(_));return G(se).listen(J,Q)}}}k(_,ae,le,J){const Q=this;let se;const fe=new m.$_d({onWillAddFirstListener:()=>{se=new b.$Tc;const ve=new m.$fe,Ne=new Map,Ae=x=>{const y=x.channelClient.getChannel(_).listen(le,J),a=ve.add(y);Ne.set(x,a)},Le=x=>{const u=Ne.get(x);u&&(u.dispose(),Ne.delete(x))};Q.connections.filter(ae).forEach(Ae),m.Event.filter(Q.onDidAddConnection,ae)(Ae,void 0,se),Q.onDidRemoveConnection(Le,void 0,se),ve.event(fe.fire,fe,se),se.add(ve)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return fe.event}registerChannel(_,ae){this.a.set(_,ae);for(const le of this.f)le.channelServer.registerChannel(_,ae)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$4h=H;class C{constructor(_,ae,le=null){const J=new l;j(J,ae),_.send(J.buffer),this.a=new M(_,le),this.d=new O(_,ae,le)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ae){this.d.registerChannel(_,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$5h=C;function G(he){return{call(_,ae,le){return he.then(J=>J.call(_,ae,le))},listen(_,ae){const le=new m.$ie;return he.then(J=>le.input=J.listen(_,ae)),le.event}}}function Z(he){let _=!1;return{call(ae,le,J){return _?he.call(ae,le,J):(0,F.$oh)(0).then(()=>_=!0).then(()=>he.call(ae,le,J))},listen(ae,le){if(_)return he.listen(ae,le);const J=new m.$ie;return(0,F.$oh)(0).then(()=>_=!0).then(()=>J.input=he.listen(ae,le)),J.event}}}class ce{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ae of _.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await m.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$8h=ce;var re;(function(he){function _(Q,se,fe){const ve=Q,Ne=fe&&fe.disableMarshalling,Ae=new Map;for(const Le in ve)le(Le)&&Ae.set(Le,m.Event.buffer(ve[Le],!0,void 0,se));return new class{listen(Le,x,u){const y=Ae.get(x);if(y)return y;const a=ve[x];if(typeof a=="function"){if(J(x))return a.call(ve,u);if(le(x))return Ae.set(x,m.Event.buffer(ve[x],!0,void 0,se)),Ae.get(x)}throw new A.$bb(`Event not found: ${x}`)}call(Le,x,u){const y=ve[x];if(typeof y=="function"){if(!Ne&&Array.isArray(u))for(let p=0;p<u.length;p++)u[p]=(0,w.$Wh)(u[p]);let a=y.apply(ve,u);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new A.$bb(`Method not found: ${x}`)}}}he.fromService=_;function ae(Q,se){const fe=se&&se.disableMarshalling;return new Proxy({},{get(ve,Ne){if(typeof Ne=="string")return se?.properties?.has(Ne)?se.properties.get(Ne):J(Ne)?function(Ae){return Q.listen(Ne,Ae)}:le(Ne)?Q.listen(Ne):async function(...Ae){let Le;se&&!(0,c.$0f)(se.context)?Le=[se.context,...Ae]:Le=Ae;const x=await Q.call(Ne,Le);return fe?x:(0,w.$Wh)(x)};throw new A.$bb(`Property not found: ${String(Ne)}`)}})}he.toService=ae;function le(Q){return Q[0]==="o"&&Q[1]==="n"&&B.$pf(Q.charCodeAt(2))}function J(Q){return/^onDynamic/.test(Q)&&B.$pf(Q.charCodeAt(9))}})(re||(t.ProxyChannel=re={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $e(he){if(Array.isArray(he))return he;if(he&&typeof he=="object"&&typeof he.toString=="function"){const _=he.toString();if(_!=="[object Object]")return _}return he}function De(he){return Array.isArray(he)?he.map($e):$e(he)}function Fe(he,_,ae,le,J,Q,se){se=De(se);const fe=te[J],ve=fe[le%fe.length];let Ne=[`%c[${he}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(Q)?(Ne=Ne.concat(se),Ne.push(")")):Ne.push(se),console.log.apply(console,Ne)}class He{constructor(_,ae){this.d=_,this.f=ae,this.a=0,this.b=0}logOutgoing(_,ae,le,J,Q){this.b+=_,Fe(this.d,this.b,_,ae,le,J,Q)}logIncoming(_,ae,le,J,Q){this.a+=_,Fe(this.f,this.a,_,ae,le,J,Q)}}t.$9h=He}),define(ge[145],be([1,0,43,3,77,102,35]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tW=void 0;class A extends P.$5h{static f(){const b=F.Event.fromNodeEventEmitter(S.$O,"vscode:message",(w,B)=>i.$ze.wrap(B));return S.$O.send("vscode:hello"),new W.$pW(S.$O,b)}constructor(b){const w=A.f();super(w,b),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$tW=A}),define(ge[146],be([13,12]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define(ge[147],be([13,12]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[50],be([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mi=t._util=void 0,t.$ni=P,t.$oi=W;var i;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function A(m){return m[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=A})(i||(t._util=i={})),t.$mi=P("instantiationService");function F(S,A,m){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:S,index:m}):(A[i.DI_DEPENDENCIES]=[{id:S,index:m}],A[i.DI_TARGET]=A)}function P(S){if(i.serviceIds.has(S))return i.serviceIds.get(S);const A=function(m,b,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(A,m,w)};return A.toString=()=>S,i.serviceIds.set(S,A),A}function W(S){return S}}),define(ge[148],be([1,0,50]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9m=t.$7m=t.ID=void 0,t.$8m=F,t.ID="diagnosticsService",t.$7m=(0,i.$ni)(t.ID);function F(W){return!!W.hostName&&!!W.errorMessage}class P{async getPerformanceInfo(S,A){return{}}async getSystemInfo(S,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,A){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}t.$9m=P}),define(ge[149],be([1,0,99,25,9,10,16,146,50,5,36,23]),function(ne,t,i,F,P,W,S,A,m,b,w,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pl=t.$ml=t.FileKind=t.$ll=t.$kl=t.$jl=t.$il=t.$hl=t.$gl=t.$fl=t.FileOperationResult=t.$el=t.$dl=t.$cl=t.$al=t.FileChangeType=t.$_k=t.FileOperation=t.$6k=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Tk=void 0,t.$Uk=c,t.$Vk=n,t.$Wk=h,t.$Xk=g,t.$Yk=D,t.$Zk=o,t.$1k=d,t.$2k=l,t.$3k=T,t.$4k=N,t.$5k=R,t.$7k=$,t.$8k=O,t.$9k=V,t.$0k=M,t.$$k=H,t.$bl=re,t.$nl=he,t.$ol=_,t.$ql=le,t.$Tk=(0,m.$ni)("fileService");function c(J){return J.create===!0}var f;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(f||(t.FileType=f={}));var e;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function n(J){const Q=J;return!!Q&&typeof Q.onDidChange=="function"}var r;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(r||(t.FileSystemProviderCapabilities=r={}));function h(J){return!!(J.capabilities&2)}function g(J){return!!(J.capabilities&8)}function D(J){return!!(J.capabilities&131072)}function o(J){return!!(J.capabilities&4)}function d(J){return!!(J.capabilities&16)}function l(J){return h(J)?!!(J.capabilities&16384):!1}function T(J){return h(J)?!!(J.capabilities&32768):!1}function N(J){return!!(J.capabilities&65536)}function R(J){return!!(J.capabilities&2048)}var I;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(I||(t.FileSystemProviderErrorCode=I={}));class j extends Error{static create(Q,se){const fe=new j(Q.toString(),se);return V(fe,se),fe}constructor(Q,se){super(Q),this.code=se}}t.$6k=j;function $(J,Q){return j.create(J,Q)}function O(J){return J||$((0,A.localize)(0,null),I.Unknown)}function V(J,Q){return J.name=Q?`${Q} (FileSystemError)`:"FileSystemError",J}function M(J){if(!J)return I.Unknown;if(J instanceof j)return J.code;const Q=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!Q)return I.Unknown;switch(Q[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function H(J){if(J instanceof te)return J.fileOperationResult;switch(M(J)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 9;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileTooLarge:return 7;default:return 10}}var C;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(C||(t.FileOperation=C={}));class G{constructor(Q,se,fe){this.resource=Q,this.operation=se,this.target=fe}isOperation(Q){return this.operation===Q}}t.$_k=G;var Z;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class ce{static{this.a=null}constructor(Q,se){this.c=se,this.b=void 0,this.d=new B.$V(()=>{const fe=i.$ti.forUris(()=>this.c);return fe.fill(this.rawAdded.map(ve=>[ve,!0])),fe}),this.f=new B.$V(()=>{const fe=i.$ti.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(ve=>[ve,!0])),fe}),this.g=new B.$V(()=>{const fe=i.$ti.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(ve=>[ve,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of Q){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==ce.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=ce.a):this.b!==void 0&&(this.b=ce.a))}}contains(Q,...se){return this.h(Q,{includeChildren:!1},...se)}affects(Q,...se){return this.h(Q,{includeChildren:!0},...se)}h(Q,se,...fe){if(!Q)return!1;const ve=fe.length>0;return!!((!ve||fe.includes(1))&&(this.d.value.get(Q)||se.includeChildren&&this.d.value.findSuperstr(Q))||(!ve||fe.includes(0))&&(this.f.value.get(Q)||se.includeChildren&&this.f.value.findSuperstr(Q))||(!ve||fe.includes(2))&&(this.g.value.findSubstr(Q)||se.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}t.$al=ce;function re(J,Q,se){return!J||!Q||J===Q||Q.length>J.length?!1:(Q.charAt(Q.length-1)!==F.sep&&(Q+=F.sep),se?(0,P.$rf)(J,Q):J.indexOf(Q)===0)}class te extends Error{constructor(Q,se,fe){super(Q),this.fileOperationResult=se,this.options=fe}}t.$cl=te;class $e extends te{constructor(Q,se,fe,ve){super(Q,se,ve),this.fileOperationResult=se,this.size=fe}}t.$dl=$e;class De extends te{constructor(Q,se,fe){super(Q,2,fe),this.stat=se}}t.$el=De;var Fe;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Fe||(t.FileOperationResult=Fe={})),t.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$hl="files.associations",t.$il="files.exclude",t.$jl="files.readonlyInclude",t.$kl="files.readonlyExclude",t.$ll="files.readonlyFromPermissions";var He;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(He||(t.FileKind=He={})),t.$ml="";function he(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}async function _(J,Q){if(!Q.hasProvider(S.URI.from({scheme:J.scheme})))return new Promise(se=>{const fe=Q.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===J.scheme&&ve.added&&(fe.dispose(),se())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(Q){return(0,W.$5f)(Q)||(Q=0),Q<ae.KB?(0,A.localize)(1,null,Q.toFixed(0)):Q<ae.MB?(0,A.localize)(2,null,(Q/ae.KB).toFixed(2)):Q<ae.GB?(0,A.localize)(3,null,(Q/ae.MB).toFixed(2)):Q<ae.TB?(0,A.localize)(4,null,(Q/ae.GB).toFixed(2)):(0,A.localize)(5,null,(Q/ae.TB).toFixed(2))}}t.$pl=ae;function le(J){const Q=typeof J=="string"||J?.scheme===w.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===w.Schemas.file?1024*ae.MB:Q?10*ae.MB:b.$o?50*ae.MB:1024*ae.MB}}),define(ge[150],be([1,0,50]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Acc=t.$zcc=void 0,t.$zcc=(0,i.$ni)("mainProcessService");class F{constructor(W,S){this.a=W,this.b=S}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,S){this.a.registerChannel(W,S)}}t.$Acc=F}),define(ge[151],be([1,0,2,145]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bcc=void 0;class P extends i.$Uc{constructor(S){super(),this.a=this.B(new F.$tW(`window:${S}`))}getChannel(S){return this.a.getChannel(S)}registerChannel(S,A){this.a.registerChannel(S,A)}}t.$Bcc=P});var Ei=this&&this.__param||function(ne,t){return function(i,F){t(i,F,ne)}};define(ge[152],be([1,0,77,150]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fcc=void 0;let P=class{constructor(S,A){return this.windowId=S,i.ProxyChannel.toService(A.getChannel("nativeHost"),{context:S,properties:(()=>{const m=new Map;return m.set("windowId",S),m})()})}};t.$Fcc=P,t.$Fcc=P=Ze([Ei(1,F.$zcc)],P)}),define(ge[78],be([1,0,37,10]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6n=void 0;class P{constructor(){this.a=new Map}add(S,A){i.ok(F.$1f(S)),i.ok(F.$3f(A)),i.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,A)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}t.$6n=new P}),define(ge[153],be([1,0,3,78]),function(ne,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7n=void 0,t.$7n={JSONContribution:"base.contributions.json"};function P(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class W{constructor(){this.b=new i.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,b){this.a[P(m)]=b,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const S=new W;F.$6n.add(t.$7n.JSONContribution,S)}),define(ge[154],be([1,0,11,18,45,19,3,10,16,147,153,78]),function(ne,t,i,F,P,W,S,A,m,b,w,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7w=t.$6w=t.$5w=t.$4w=t.$3w=t.$2w=t.IconFontDefinition=t.IconContribution=t.$Yw=void 0,t.$Zw=r,t.$1w=h,t.$Yw={IconContribution:"base.contributions.icons"};var c;(function(d){function l(T,N){let R=T.defaults;for(;W.ThemeIcon.isThemeIcon(R);){const I=n.getIcon(R.id);if(!I)return;R=I.defaults}return R}d.getDefinition=l})(c||(t.IconContribution=c={}));var f;(function(d){function l(N){return{weight:N.weight,style:N.style,src:N.src.map(R=>({format:R.format,location:R.location.toString()}))}}d.toJSONObject=l;function T(N){const R=I=>(0,A.$1f)(I)?I:void 0;if(N&&Array.isArray(N.src)&&N.src.every(I=>(0,A.$1f)(I.format)&&(0,A.$1f)(I.location)))return{weight:R(N.weight),style:R(N.style),src:N.src.map(I=>({format:I.format,location:m.URI.parse(I.location)}))}}d.fromJSONObject=T})(f||(t.IconFontDefinition=f={}));class e{constructor(){this.a=new S.$_d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${W.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,T,N,R){const I=this.b[l];if(I){if(N&&!I.description){I.description=N,this.d.properties[l].markdownDescription=`${N} $(${l})`;const O=this.e.enum.indexOf(l);O!==-1&&(this.e.enumDescriptions[O]=N),this.a.fire()}return I}const j={id:l,description:N,defaults:T,deprecationMessage:R};this.b[l]=j;const $={$ref:"#/definitions/icons"};return R&&($.deprecationMessage=R),N&&($.markdownDescription=`${N}: $(${l})`),this.d.properties[l]=$,this.e.enum.push(l),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const T=this.e.enum.indexOf(l);T!==-1&&(this.e.enum.splice(T,1),this.e.enumDescriptions.splice(T,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,T){const N=this.f[l];return N||(this.f[l]=T,this.a.fire(),T)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(I,j)=>I.id.localeCompare(j.id),T=I=>{for(;W.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.b).map(I=>this.b[I]);for(const I of R.filter(j=>!!j.description).sort(l))N.push(`|<i class="${T(I)}"></i>|${I.id}|${W.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const I of R.filter(j=>!W.ThemeIcon.isThemeIcon(j.defaults)).sort(l))N.push(`|<i class="${T(I)}"></i>|${I.id}|`);return N.join(`
`)}}const n=new e;B.$6n.add(t.$Yw.IconContribution,n);function r(d,l,T,N){return n.registerIcon(d,l,T,N)}function h(){return n}function g(){const d=(0,P.$Ij)();for(const l in d){const T="\\"+d[l].toString(16);n.registerIcon(l,{fontCharacter:T})}}g(),t.$2w="vscode://schemas/icons";const D=B.$6n.as(w.$7n.JSONContribution);D.registerSchema(t.$2w,n.getIconSchema());const o=new i.$zh(()=>D.notifySchemaChanged(t.$2w),200);n.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.$3w=r("widget-close",F.$Mj.close,(0,b.localize)(2,null)),t.$4w=r("goto-previous-location",F.$Mj.arrowUp,(0,b.localize)(3,null)),t.$5w=r("goto-next-location",F.$Mj.arrowDown,(0,b.localize)(4,null)),t.$6w=W.ThemeIcon.modify(F.$Mj.sync,"spin"),t.$7w=W.ThemeIcon.modify(F.$Mj.loading,"spin")}),define(ge[155],be([1,0,4,3,2,19,154]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NIb=void 0,t.$MIb=A;function A(b){const w=new P.$Tc,B=w.add(new F.$_d),c=(0,S.$1w)();return w.add(c.onDidChange(()=>B.fire())),b&&w.add(b.onDidProductIconThemeChange(()=>B.fire())),{dispose:()=>w.dispose(),onDidChange:B.event,getCSS(){const f=b?b.getProductIconTheme():new m,e={},n=h=>{const g=f.getIcon(h);if(!g)return;const D=g.font;return D?(e[D.id]=D.definition,`.codicon-${h.id}:before { content: '${g.fontCharacter}'; font-family: ${(0,i.$CS)(D.id)}; }`):`.codicon-${h.id}:before { content: '${g.fontCharacter}'; }`},r=[];for(const h of c.getIcons()){const g=n(h);g&&r.push(g)}for(const h in e){const g=e[h],D=g.weight?`font-weight: ${g.weight};`:"",o=g.style?`font-style: ${g.style};`:"",d=g.src.map(l=>`${(0,i.$BS)(l.location)} format('${l.format}')`).join(", ");r.push(`@font-face { src: ${d}; font-family: ${(0,i.$CS)(h)};${D}${o} font-display: block; }`)}return r.join(`
`)}}}class m{getIcon(w){const B=(0,S.$1w)();let c=w.defaults;for(;W.ThemeIcon.isThemeIcon(c);){const f=B.getIcon(c.id);if(!f)return;c=f.defaults}return c}}t.$NIb=m}),define(ge[156],be([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$iD=void 0,t.$jD=F,t.$kD=P,t.$lD=W,t.$mD=S,t.$nD=A,t.$oD=B,t.$pD=c,t.$qD=f,t.$rD=e,t.$sD=n,t.$tD=r,t.$iD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function F(h){return typeof h.parentId=="number"}function P(h){return!!h.workspaceUri}function W(h){return!!h.folderUri}function S(h){return!!h.fileUri}function A(h){const g=c(h),D=h.getValue("window.menuBarVisibility");return D==="default"||g&&D==="compact"||i.$j&&i.$m?"classic":D}var m;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(t.TitleBarSetting=m={}));var b;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(b||(t.TitlebarStyle=b={}));var w;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function B(h,g){return!0}function c(h,g){return g||(g=f(h)),g==="native"}function f(h){if(i.$o)return"custom";const g=h.getValue("window");if(g){if(i.$j&&g.nativeTabs===!0||i.$j&&g.nativeFullScreen===!1)return"native";const d=g.titleBarStyle;if(d==="native"||d==="custom")return d}return i.$k?"native":"custom"}function e(h){return!(!i.$i||i.$o||c(h))}function n(h){const g=h.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(ge[157],be([1,0,17,4,22,35,156]),function(ne,t,i,F,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Icc=t.$Hcc=t.ApplyZoomTarget=void 0,t.$Jcc=m,t.$Kcc=w,t.$Lcc=B;var A;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={})),t.$Hcc=8,t.$Icc=-8;function m(c,f){c=Math.min(Math.max(c,t.$Icc),t.$Hcc);const e=[];f===A.ACTIVE_WINDOW?e.push((0,F.$3R)()):f===A.ALL_WINDOWS?e.push(...Array.from((0,F.getWindows)()).map(({window:n})=>n)):e.push(f);for(const n of e)b(n)?.webFrame?.setZoomLevel(c),(0,i.$ZQ)((0,S.$tD)(c),n),(0,i.$VQ)(c,n)}function b(c){if(c===P.$RQ)return{ipcRenderer:W.$O,webFrame:W.$Q};{const f=c;if(f?.vscode?.ipcRenderer&&f?.vscode?.webFrame)return f.vscode}}function w(c){m((0,i.$WQ)(typeof c=="number"?(0,F.$3R)():c)+1,c)}function B(c){m((0,i.$WQ)(typeof c=="number"?(0,F.$3R)():c)-1,c)}}),define(ge[158],be([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(ne,t,i,F,P,W,S,A,m,b,w,B,c,f,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=O;const r=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class g{getHeight(M){return 22}getTemplateId(M){return I(M)?"process":N(M)?"machine":(0,m.$8m)(M)?"error":R(M)?"header":""}}class D{hasChildren(M){return(0,m.$8m)(M)?!1:I(M)?!!M.children?.length:!0}getChildren(M){return I(M)?M.children?M.children:[]:(0,m.$8m)(M)?[]:R(M)?M.processRoots.length>1?M.processRoots:[M.processRoots[0].rootProcess]:N(M)?[M.rootProcess]:[M.processes]}}class o{constructor(){this.templateId="header"}renderTemplate(M){const H=(0,F.$lS)(M,(0,F.$)(".row")),C=(0,F.$lS)(H,(0,F.$)(".nameLabel")),G=(0,F.$lS)(H,(0,F.$)(".cpu")),Z=(0,F.$lS)(H,(0,F.$)(".memory")),ce=(0,F.$lS)(H,(0,F.$)(".pid"));return{name:C,CPU:G,memory:Z,PID:ce}}renderElement(M,H,C,G){C.name.textContent=(0,i.localize)(0,null),C.CPU.textContent=(0,i.localize)(1,null),C.PID.textContent=(0,i.localize)(2,null),C.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(M){}}class d{constructor(){this.templateId="machine"}renderTemplate(M){const H=Object.create(null),C=(0,F.$lS)(M,(0,F.$)(".row"));return H.name=(0,F.$lS)(C,(0,F.$)(".nameLabel")),H}renderElement(M,H,C,G){C.name.textContent=M.element.name}disposeTemplate(M){}}class l{constructor(){this.templateId="error"}renderTemplate(M){const H=Object.create(null),C=(0,F.$lS)(M,(0,F.$)(".row"));return H.name=(0,F.$lS)(C,(0,F.$)(".nameLabel")),H}renderElement(M,H,C,G){C.name.textContent=M.element.errorMessage}disposeTemplate(M){}}class T{constructor(M,H,C){this.a=M,this.b=H,this.c=C,this.templateId="process"}renderTemplate(M){const H=(0,F.$lS)(M,(0,F.$)(".row")),C=(0,F.$lS)(H,(0,F.$)(".nameLabel")),G=(0,F.$lS)(H,(0,F.$)(".cpu")),Z=(0,F.$lS)(H,(0,F.$)(".memory")),ce=(0,F.$lS)(H,(0,F.$)(".pid"));return{name:C,CPU:G,PID:ce,memory:Z}}renderElement(M,H,C,G){const{element:Z}=M,ce=Z.pid.toFixed(0);let re=Z.name;this.c.has(Z.pid)&&(re=this.c.get(Z.pid)),C.name.textContent=re,C.name.title=Z.cmd,C.CPU.textContent=Z.load.toFixed(0),C.PID.textContent=ce,C.PID.parentElement.id=`pid-${ce}`;const te=this.a==="win32"?Z.mem:this.b*(Z.mem/100);C.memory.textContent=(te/b.$pl.MB).toFixed(0)}disposeTemplate(M){}}function N(V){return!!V.name&&!!V.rootProcess}function R(V){return!!V.processRoots}function I(V){return!!V.pid}class j{constructor(M,H){this.f=H,this.b=new Map;const C=new w.$Bcc(M);this.c=new B.$Fcc(M,C),this.k(H.styles),this.g(H),A.$O.on("vscode:pidToNameResponse",(G,Z)=>{this.b.clear();for(const[ce,re]of Z)this.b.set(ce,re)}),A.$O.on("vscode:listProcessesResponse",async(G,Z)=>{Z.forEach((ce,re)=>{I(ce.rootProcess)&&(ce.rootProcess.name=re===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(n.$RQ.innerHeight,n.$RQ.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")}g(M){n.$RQ.document.onkeydown=H=>{const C=M.platform==="darwin"?H.metaKey:H.ctrlKey;C&&H.keyCode===87&&(H.stopPropagation(),H.preventDefault(),A.$O.send("vscode:closeProcessExplorer")),C&&H.keyCode===187&&(0,f.$Kcc)(n.$RQ),C&&H.keyCode===189&&(0,f.$Lcc)(n.$RQ)}}async h(M){const H=n.$RQ.document.getElementById("process-list");if(!H)return;const{totalmem:C}=await this.c.getOSStatistics(),G=[new T(this.f.platform,C,this.b),new o,new d,new l];this.d=new P.$SV("processExplorer",H,new g,G,new D,{identityProvider:{getId:Z=>I(Z)?Z.pid.toString():(0,m.$8m)(Z)?Z.hostName:R(Z)?"processes":N(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:M}}),this.d.layout(n.$RQ.innerHeight,n.$RQ.innerWidth),this.d.onKeyDown(Z=>{const ce=new e.$iR(Z);if(ce.keyCode===35&&ce.altKey){const re=this.n();Promise.all(re.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Z=>{I(Z.element)&&this.l(Z.element,!0)}),H.style.height=`${n.$RQ.innerHeight}px`,n.$RQ.addEventListener("resize",()=>{H.style.height=`${n.$RQ.innerHeight}px`,this.d?.layout(n.$RQ.innerHeight,n.$RQ.innerWidth)})}i(M){const H=r.exec(M);return H&&H.groups.port!=="0"||M.indexOf("node ")>=0||M.indexOf("node.exe")>=0}j(M){const H={type:"node",request:"attach",name:`process ${M.pid}`};let C=r.exec(M.cmd);C?H.port=Number(C.groups.port):H.processId=String(M.pid),C=h.exec(M.cmd),C&&(H.port=Number(C.groups.port)),A.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[H]})}k(M){const H=(0,F.$6R)(),C=[];M.listFocusBackground&&(C.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${M.listFocusBackground}; }`),C.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${M.listFocusBackground}; }`)),M.listFocusForeground&&C.push(`.monaco-list:focus .monaco-list-row.focused { color: ${M.listFocusForeground}; }`),M.listActiveSelectionBackground&&(C.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${M.listActiveSelectionBackground}; }`),C.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${M.listActiveSelectionBackground}; }`)),M.listActiveSelectionForeground&&C.push(`.monaco-list:focus .monaco-list-row.selected { color: ${M.listActiveSelectionForeground}; }`),M.listHoverBackground&&C.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${M.listHoverBackground}; }`),M.listHoverForeground&&C.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${M.listHoverForeground}; }`),M.listFocusOutline&&C.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${M.listFocusOutline}; outline-offset: -1px; }`),M.listHoverOutline&&C.push(`.monaco-list-row:hover { outline: 1px dashed ${M.listHoverOutline}; outline-offset: -1px; }`),M.scrollbarShadowColor&&C.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${M.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),M.scrollbarSliderBackgroundColor&&C.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${M.scrollbarSliderBackgroundColor};
				}
			`),M.scrollbarSliderHoverBackgroundColor&&C.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${M.scrollbarSliderHoverBackgroundColor};
				}
			`),M.scrollbarSliderActiveBackgroundColor&&C.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${M.scrollbarSliderActiveBackgroundColor};
				}
			`),H.textContent=C.join(`
`),M.color&&(n.$RQ.document.body.style.color=M.color)}l(M,H){const C=[],G=Number(M.pid);H&&(C.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(G,"SIGTERM")}}),C.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(G,"SIGKILL")}}),C.push({type:"separator"})),C.push({label:(0,i.localize)(6,null),click:()=>{const Z=this.n();Z?.includes(G)||(Z.length=0,Z.push(G));const ce=Z?.map(re=>n.$RQ.document.getElementById(`pid-${re}`)).filter(re=>!!re);if(ce){const re=ce.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(re.join(`
`))}}}),C.push({label:(0,i.localize)(7,null),click:()=>{const Z=n.$RQ.document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),M&&H&&this.i(M.cmd)&&(C.push({type:"separator"}),C.push({label:(0,i.localize)(8,null),click:()=>{this.j(M)}})),(0,S.$lW)(C)}m(M){setTimeout(()=>{const H=Date.now(),C=M+H-this.a;this.a=H,C>1e3?(A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")):this.m(C)},200)}n(){return this.d?.getSelection()?.map(M=>{if(!(!M||!("pid"in M)))return M.pid}).filter(M=>!!M)}}function $(){const V=(0,F.$6R)();V.id="codiconStyles";const M=(0,c.$MIb)(void 0);function H(){V.textContent=M.getCSS()}const C=new W.$zh(H,0);M.onDidChange(()=>C.schedule()),C.schedule()}function O(V){const M=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";n.$RQ.document.body.classList.add(M),$(),(0,f.$Jcc)(V.data.zoomLevel,n.$RQ),new j(V.windowId,V.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
