/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/base/common/extpath","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(J){for(var e=[],j=0,D=J.length;j<D;j++)e[j]=se[J[j]];return e};define(se[71],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class j{static get(){const k=new Map,A=new Map,O=new Map,S=new Map;function u($,y){$.has(y.detail)||$.set(y.detail,-y.timestamp)}function a($,y){const R=$.get(y.detail);R&&(R>=0||$.set(y.detail,R+y.timestamp))}let g=[];typeof J=="function"&&typeof J.getStats=="function"&&(g=J.getStats().slice(0).sort(($,y)=>$.timestamp-y.timestamp));for(const $ of g)switch($.type){case 10:u(k,$);break;case 11:case 12:a(k,$);break;case 21:u(A,$);break;case 22:a(A,$);break;case 33:u(O,$);break;case 34:a(O,$);break;case 31:u(S,$);break;case 32:a(S,$);break}let b=0;O.forEach($=>b+=$);function d($){const y=[];return $.forEach((R,m)=>y.push([m,R])),y}return{amdLoad:d(k),amdInvoke:d(A),nodeRequire:d(O),nodeEval:d(S),nodeRequireTotal:b}}static toMarkdownTable(k,A){let O="";const S=[];return k.forEach((u,a)=>{S[a]=u.length}),A.forEach(u=>{u.forEach((a,g)=>{typeof a>"u"&&(a=u[g]="-");const b=a.toString().length;S[g]=Math.max(b,S[g])})}),k.forEach((u,a)=>{O+=`| ${u+" ".repeat(S[a]-u.toString().length)} `}),O+=`|
`,k.forEach((u,a)=>{O+=`| ${"-".repeat(S[a])} `}),O+=`|
`,A.forEach(u=>{u.forEach((a,g)=>{typeof a<"u"&&(O+=`| ${a+" ".repeat(S[g]-a.toString().length)} `)}),O+=`|
`}),O}}e.$U=j}),define(se[54],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=D,e.$Sh=k,e.$Th=A;function j(O){return(S,u,a)=>{let g=null,b=null;if(typeof a.value=="function"?(g="value",b=a.value):typeof a.get=="function"&&(g="get",b=a.get),!b)throw new Error("not supported");a[g]=O(b,u)}}function D(O,S,u){let a=null,g=null;if(typeof u.value=="function"?(a="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",g=u.get),!g)throw new Error("not supported");const b=`$memoize$${S}`;u[a]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,d)}),this[b]}}function k(O,S,u){return j((a,g)=>{const b=`$debounce$${g}`,d=`$debounce$result$${g}`;return function(...$){this[d]||(this[d]=u?u():void 0),clearTimeout(this[b]),S&&(this[d]=S(this[d],...$),$=[this[d]]),this[b]=setTimeout(()=>{a.apply(this,$),this[d]=u?u():void 0},O)}})}function A(O,S,u){return j((a,g)=>{const b=`$throttle$timer$${g}`,d=`$throttle$result$${g}`,$=`$throttle$lastRun$${g}`,y=`$throttle$pending$${g}`;return function(...R){if(this[d]||(this[d]=u?u():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...R)),this[y])return;const m=this[$]+O;m<=Date.now()?(this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[y]=!0,this[b]=setTimeout(()=>{this[y]=!1,this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},m-Date.now()))}})}}),define(se[72],re([0,1,9]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.$cd=k,e.$dd=A,e.$ed=O,e.$fd=S,e.$gd=u;function D(a,g){if(!a)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function k(a,g="Unreachable"){throw new Error(g)}function A(a){if(!a)throw new j.$cb("Assertion Failed")}function O(a){a||(0,j.$1)(new j.$cb("Soft Assertion Failed"))}function S(a){if(!a()){debugger;a(),(0,j.$1)(new j.$cb("Assertion Failed"))}}function u(a,g){let b=0;for(;b<a.length-1;){const d=a[b],$=a[b+1];if(!g(d,$))return!1;b++}return!0}}),define(se[38],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=O,e.$zn=b,e.$An=d,e.$Bn=$,e.$Cn=y,e.$Dn=R,e.$En=m,e.$Fn=c,e.$Gn=v,e.$Hn=w,e.$In=h,e.$Jn=p;var j;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(j||(e.ScanError=j={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,P=0;function I(K){let le=0,ue=0;for(;le<K;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)ue=ue*16+ae-48;else if(ae>=65&&ae<=70)ue=ue*16+ae-65+10;else if(ae>=97&&ae<=102)ue=ue*16+ae-97+10;else break;t++,le++}return le<K&&(ue=-1),ue}function z(K){t=K,s="",o=0,l=16,P=0}function N(){const K=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return P=3,i.substring(K,t);let le=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;le=t}else P=3;return i.substring(K,le)}function U(){let K="",le=t;for(;;){if(t>=n){K+=i.substring(le,t),P=2;break}const ue=i.charCodeAt(t);if(ue===34){K+=i.substring(le,t),t++;break}if(ue===92){if(K+=i.substring(le,t),t++,t>=n){P=2;break}switch(i.charCodeAt(t++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:{const B=I(4);B>=0?K+=String.fromCharCode(B):P=4;break}default:P=5}le=t;continue}if(ue>=0&&ue<=31)if(u(ue)){K+=i.substring(le,t),P=2;break}else P=6;t++}return K}function V(){if(s="",P=0,o=t,t>=n)return o=n,l=17;let K=i.charCodeAt(t);if(S(K)){do t++,s+=String.fromCharCode(K),K=i.charCodeAt(t);while(S(K));return l=15}if(u(K))return t++,s+=String.fromCharCode(K),K===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(K){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=U(),l=10;case 47:{const le=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(le,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const ue=n-1;let ae=!1;for(;t<ue;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,P=1),s=i.substring(le,t),l=13}return s+=String.fromCharCode(K),t++,l=16}case 45:if(s+=String.fromCharCode(K),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),l=11;default:for(;t<n&&X(K);)t++,K=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(K),t++,l=16}}function X(K){if(S(K)||u(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let K;do K=V();while(K>=12&&K<=15);return K}return{setPosition:z,getPosition:()=>t,scan:r?_:V,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>P}}function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function b(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(I,z,N,U){o.value=I,o.offset=z,o.length=N,o.type=U,o.colonOffset=void 0,s=o}try{w(i,{onObjectBegin:(I,z)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,z,N)=>{if(r<z||(P(I,z,N,"property"),t[t.length-1]=I,r<=z+N))throw n},onObjectEnd:(I,z)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,z)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,z)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,z,N)=>{if(r<z||(P(I,z,N,p(I)),r<=z+N))throw n},onSeparator:(I,z,N)=>{if(r<=z)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=z,l=!1,s=void 0;else if(I===","){const U=t[t.length-1];typeof U=="number"?t[t.length-1]=U+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let z=0;for(let N=0;z<I.length&&N<t.length;N++)if(I[z]===t[N]||I[z]==="*")z++;else if(I[z]!=="**")return!1;return z===I.length}}}function d(i,r=[],t=A.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return w(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,z,N)=>{r.push({error:I,offset:z,length:N})}},t),s[0]}function $(i,r=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}w(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,z,N)=>{n=o({type:"property",offset:z,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:z,length:N,parent:n})},onObjectEnd:(I,z)=>{n.length=I+z-n.offset,n=n.parent,s(I+z)},onArrayBegin:(I,z)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,z)=>{n.length=I+z-n.offset,n=n.parent,s(I+z)},onLiteralValue:(I,z,N)=>{o({type:p(I),offset:z,length:N,parent:n,value:I}),s(z+N)},onSeparator:(I,z,N)=>{n.type==="property"&&(I===":"?n.colonOffset=z:I===","&&s(z))},onError:(I,z,N)=>{r.push({error:I,offset:z,length:N})}},t);const P=n.children[0];return P&&delete P.parent,P}function y(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function R(i){if(!i.parent||!i.parent.children)return[];const r=R(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=m(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}function v(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=v(n[s],r,t);if(o)return o}return i}}function w(i,r,t=A.DEFAULT){const n=O(i,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?te=>Y(te,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),P=o(r.onObjectProperty),I=s(r.onObjectEnd),z=s(r.onArrayBegin),N=s(r.onArrayEnd),U=o(r.onLiteralValue),V=o(r.onSeparator),X=s(r.onComment),_=o(r.onError),K=t&&t.disallowComments,le=t&&t.allowTrailingComma;function ue(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:K||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Y){case 12:case 13:K?ae(10):X();break;case 16:ae(1);break;case 15:case 14:break;default:return Y}}}function ae(Y,te=[],T=[]){if(_(Y),te.length+T.length>0){let F=n.getToken();for(;F!==17;){if(te.indexOf(F)!==-1){ue();break}else if(T.indexOf(F)!==-1)break;F=ue()}}}function B(Y){const te=n.getTokenValue();return Y?U(te):P(te),ue(),!0}function Q(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ae(2),Y=0)}catch{ae(2)}U(Y);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ue(),!0}function q(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(V(":"),ue(),Z()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function M(){l(),ue();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),V(","),ue(),n.getToken()===2&&le)break}else Y&&ae(6,[],[]);q()||ae(4,[],[2,5]),Y=!0}return I(),n.getToken()!==2?ae(7,[2],[]):ue(),!0}function W(){z(),ue();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),V(","),ue(),n.getToken()===4&&le)break}else Y&&ae(6,[],[]);Z()||ae(4,[],[4,5]),Y=!0}return N(),n.getToken()!==4?ae(8,[4],[]):ue(),!0}function Z(){switch(n.getToken()){case 3:return W();case 1:return M();case 10:return B(!0);default:return Q()}}return ue(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):Z()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}function h(i,r){const t=O(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[73],re([0,1,38]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=D,e.$Ln=k,e.$Mn=S,e.$Nn=u;function D(a,g,b){let d,$,y,R,m;if(g){for(R=g.offset,m=R+g.length,y=R;y>0&&!u(a,y-1);)y--;let l=m;for(;l<a.length&&!u(a,l);)l++;$=a.substring(y,l),d=O($,b)}else $=a,d=0,y=0,R=0,m=a.length;const c=S(b,a);let v=!1,w=0,h;b.insertSpaces?h=A(" ",b.tabSize||4):h="	";const p=(0,j.$yn)($,!1);let i=!1;function r(){return c+A(h,d+w)}function t(){let l=p.scan();for(v=!1;l===15||l===14;)v=v||l===14,l=p.scan();return i=l===16||p.getTokenError()!==0,l}const n=[];function s(l,P,I){!i&&P<m&&I>R&&a.substring(P,I)!==l&&n.push({offset:P,length:I-P,content:l})}let o=t();if(o!==17){const l=p.getTokenOffset()+y,P=A(h,d);s(P,y,l)}for(;o!==17;){let l=p.getTokenOffset()+p.getTokenLength()+y,P=t(),I="";for(;!v&&(P===12||P===13);){const N=p.getTokenOffset()+y;s(" ",l,N),l=p.getTokenOffset()+p.getTokenLength()+y,I=P===12?r():"",P=t()}if(P===2)o!==1&&(w--,I=r());else if(P===4)o!==3&&(w--,I=r());else{switch(o){case 3:case 1:w++,I=r();break;case 5:case 12:I=r();break;case 13:v?I=r():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}v&&(P===12||P===13)&&(I=r())}const z=p.getTokenOffset()+y;s(I,l,z),o=P}return n}function k(a,g){const b=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?b.replace(/\r\n|\r|\n/g,g.eol):b}function A(a,g){let b="";for(let d=0;d<g;d++)b+=a;return b}function O(a,g){let b=0,d=0;const $=g.tabSize||4;for(;b<a.length;){const y=a.charAt(b);if(y===" ")d++;else if(y==="	")d+=$;else break;b++}return Math.floor(d/$)}function S(a,g){for(let b=0;b<g.length;b++){const d=g.charAt(b);if(d==="\r")return b+1<g.length&&g.charAt(b+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function u(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}}),define(se[74],re([0,1,38,73]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=k,e.$Pn=A,e.$Qn=O,e.$Rn=S,e.$Sn=u;function k(a,g,b){return A(a,g,void 0,b)}function A(a,g,b,d,$){const y=g.slice(),R=[],m=(0,j.$Bn)(a,R);let c,v;for(;y.length>0&&(v=y.pop(),c=(0,j.$Cn)(m,y),c===void 0&&b!==void 0);)typeof v=="string"?b={[v]:b}:b=[b];if(c)if(c.type==="object"&&typeof v=="string"&&Array.isArray(c.children)){const w=(0,j.$Cn)(c,[v]);if(w!==void 0)if(b===void 0){if(!w.parent)throw new Error("Malformed AST");const h=c.children.indexOf(w.parent);let p,i=w.parent.offset+w.parent.length;if(h>0){const r=c.children[h-1];p=r.offset+r.length}else p=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return O(a,{offset:p,length:i-p,content:""},d)}else return O(a,{offset:w.offset,length:w.length,content:JSON.stringify(b)},d);else{if(b===void 0)return[];const h=`${JSON.stringify(v)}: ${JSON.stringify(b)}`,p=$?$(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(p>0){const r=c.children[p-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return O(a,i,d)}}else if(c.type==="array"&&typeof v=="number"&&Array.isArray(c.children))if(b!==void 0){const w=`${JSON.stringify(b)}`;let h;if(c.children.length===0||v===0)h={offset:c.offset+1,length:0,content:c.children.length===0?w:w+","};else{const p=v===-1||v>c.children.length?c.children.length:v,i=c.children[p-1];h={offset:i.offset+i.length,length:0,content:","+w}}return O(a,h,d)}else{const w=v,h=c.children[w];let p;if(c.children.length===1)p={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===w){const i=c.children[w-1],r=i.offset+i.length,t=c.offset+c.length;p={offset:r,length:t-2-r,content:""}}else p={offset:h.offset,length:c.children[w+1].offset-h.offset,content:""};return O(a,p,d)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${c.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return O(a,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(b)},d)}}function O(a,g,b){let d=S(a,g),$=g.offset,y=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;$>0&&!(0,D.$Nn)(d,$-1);)$--;for(;y<d.length&&!(0,D.$Nn)(d,y);)y++}const R=(0,D.$Kn)(d,{offset:$,length:y-$},b);for(let c=R.length-1;c>=0;c--){const v=R[c];d=S(d,v),$=Math.min($,v.offset),y=Math.max(y,v.offset+v.length),y+=v.content.length-v.length}const m=a.length-(d.length-y)-$;return[{offset:$,length:m,content:d.substring($,y)}]}function S(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}function u(a,g){const b=g.slice(0).sort(($,y)=>{const R=$.offset-y.offset;return R===0?$.length-y.length:R});let d=a.length;for(let $=b.length-1;$>=0;$--){const y=b[$];if(y.offset+y.length<=d)a=S(a,y);else throw new Error("Overlapping edit");d=y.offset}return a}}),define(se[75],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0,e.$sm=j,e.rot=D;function j(S,u,a){return Math.min(Math.max(S,u),a)}function D(S,u){return(u+S%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$um=k;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$vm=A;class O{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$wm=O}),function(){function J(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function O(u){A.push(u,Date.now())}function S(){const u=[];for(let a=0;a<A.length;a+=2)u.push({name:A[a],startTime:A[a+1]});return u}return{mark:O,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(k+O.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function j(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return j(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=j(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var j=e();for(var D in j)(typeof exports=="object"?exports:J)[D]=j[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function j(D){if(e[D])return e[D].exports;var k=e[D]={i:D,l:!1,exports:{}};return J[D].call(k.exports,k,k.exports,j),k.l=!0,k.exports}return j.m=J,j.c=e,j.d=function(D,k,A){j.o(D,k)||Object.defineProperty(D,k,{enumerable:!0,get:A})},j.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},j.t=function(D,k){if(1&k&&(D=j(D)),8&k||4&k&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(j.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&k&&typeof D!="string")for(var O in D)j.d(A,O,function(S){return D[S]}.bind(null,O));return A},j.n=function(D){var k=D&&D.__esModule?function(){return D.default}:function(){return D};return j.d(k,"a",k),k},j.o=function(D,k){return Object.prototype.hasOwnProperty.call(D,k)},j.p="",j(j.s=0)}([function(J,e,j){(function(D){var k;e=J.exports=T,k=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],u=e.src=[],a=0,g=a++;u[g]="0|[1-9]\\d*";var b=a++;u[b]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=a++;u[$]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var y=a++;u[y]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var R=a++;u[R]="(?:"+u[g]+"|"+u[d]+")";var m=a++;u[m]="(?:"+u[b]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[R]+"(?:\\."+u[R]+")*))";var v=a++;u[v]="(?:-?("+u[m]+"(?:\\."+u[m]+")*))";var w=a++;u[w]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[w]+"(?:\\."+u[w]+")*))";var p=a++,i="v?"+u[$]+u[c]+"?"+u[h]+"?";u[p]="^"+i+"$";var r="[v=\\s]*"+u[y]+u[v]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[b]+"|x|X|\\*";var o=a++;u[o]=u[g]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var P=a++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[v]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var z=a++;u[z]="^"+u[n]+"\\s*"+u[P]+"$";var N=a++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=a++;u[U]="(?:~>?)";var V=a++;u[V]="(\\s*)"+u[U]+"\\s+",S[V]=new RegExp(u[V],"g");var X=a++;u[X]="^"+u[U]+u[l]+"$";var _=a++;u[_]="^"+u[U]+u[P]+"$";var K=a++;u[K]="(?:\\^)";var le=a++;u[le]="(\\s*)"+u[K]+"\\s+",S[le]=new RegExp(u[le],"g");var ue=a++;u[ue]="^"+u[K]+u[l]+"$";var ae=a++;u[ae]="^"+u[K]+u[P]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var Q=a++;u[Q]="^"+u[n]+"\\s*("+i+")$|^$";var q=a++;u[q]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",S[q]=new RegExp(u[q],"g");var M=a++;u[M]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var W=a++;u[W]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var Z=a++;u[Z]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,u[Y]),S[Y]||(S[Y]=new RegExp(u[Y]));function te(x,ee){if(x instanceof T)return x;if(typeof x!="string"||x.length>A||!(ee?S[t]:S[p]).test(x))return null;try{return new T(x,ee)}catch{return null}}function T(x,ee){if(x instanceof T){if(x.loose===ee)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof T))return new T(x,ee);k("SemVer",x,ee),this.loose=ee;var ie=x.trim().match(ee?S[t]:S[p]);if(!ie)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var be=+ge;if(be>=0&&be<O)return be}return ge}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}e.parse=te,e.valid=function(x,ee){var ie=te(x,ee);return ie?ie.version:null},e.clean=function(x,ee){var ie=te(x.trim().replace(/^[=v]+/,""),ee);return ie?ie.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof T||(x=new T(x,this.loose)),this.compareMain(x)||this.comparePre(x)},T.prototype.compareMain=function(x){return x instanceof T||(x=new T(x,this.loose)),f(this.major,x.major)||f(this.minor,x.minor)||f(this.patch,x.patch)},T.prototype.comparePre=function(x){if(x instanceof T||(x=new T(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var ee=0;do{var ie=this.prerelease[ee],ge=x.prerelease[ee];if(k("prerelease compare",ee,ie,ge),ie===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ie===void 0)return-1;if(ie!==ge)return f(ie,ge)}while(++ee)},T.prototype.inc=function(x,ee){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,ee,ie,ge){typeof ie=="string"&&(ge=ie,ie=void 0);try{return new T(x,ie).inc(ee,ge).version}catch{return null}},e.diff=function(x,ee){if(G(x,ee))return null;var ie=te(x),ge=te(ee);if(ie.prerelease.length||ge.prerelease.length){for(var be in ie)if((be==="major"||be==="minor"||be==="patch")&&ie[be]!==ge[be])return"pre"+be;return"prerelease"}for(var be in ie)if((be==="major"||be==="minor"||be==="patch")&&ie[be]!==ge[be])return be},e.compareIdentifiers=f;var F=/^[0-9]+$/;function f(x,ee){var ie=F.test(x),ge=F.test(ee);return ie&&ge&&(x=+x,ee=+ee),ie&&!ge?-1:ge&&!ie?1:x<ee?-1:x>ee?1:0}function E(x,ee,ie){return new T(x,ie).compare(new T(ee,ie))}function L(x,ee,ie){return E(x,ee,ie)>0}function C(x,ee,ie){return E(x,ee,ie)<0}function G(x,ee,ie){return E(x,ee,ie)===0}function H(x,ee,ie){return E(x,ee,ie)!==0}function ne(x,ee,ie){return E(x,ee,ie)>=0}function ce(x,ee,ie){return E(x,ee,ie)<=0}function he(x,ee,ie,ge){var be;switch(ee){case"===":typeof x=="object"&&(x=x.version),typeof ie=="object"&&(ie=ie.version),be=x===ie;break;case"!==":typeof x=="object"&&(x=x.version),typeof ie=="object"&&(ie=ie.version),be=x!==ie;break;case"":case"=":case"==":be=G(x,ie,ge);break;case"!=":be=H(x,ie,ge);break;case">":be=L(x,ie,ge);break;case">=":be=ne(x,ie,ge);break;case"<":be=C(x,ie,ge);break;case"<=":be=ce(x,ie,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return be}function pe(x,ee){if(x instanceof pe){if(x.loose===ee)return x;x=x.value}if(!(this instanceof pe))return new pe(x,ee);k("comparator",x,ee),this.loose=ee,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,ee){return f(ee,x)},e.major=function(x,ee){return new T(x,ee).major},e.minor=function(x,ee){return new T(x,ee).minor},e.patch=function(x,ee){return new T(x,ee).patch},e.compare=E,e.compareLoose=function(x,ee){return E(x,ee,!0)},e.rcompare=function(x,ee,ie){return E(ee,x,ie)},e.sort=function(x,ee){return x.sort(function(ie,ge){return e.compare(ie,ge,ee)})},e.rsort=function(x,ee){return x.sort(function(ie,ge){return e.rcompare(ie,ge,ee)})},e.gt=L,e.lt=C,e.eq=G,e.neq=H,e.gte=ne,e.lte=ce,e.cmp=he,e.Comparator=pe;var ye={};function fe(x,ee){if(x instanceof fe)return x.loose===ee?x:new fe(x.raw,ee);if(x instanceof pe)return new fe(x.value,ee);if(!(this instanceof fe))return new fe(x,ee);if(this.loose=ee,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,ee,ie,ge,be,je,Pe,Le,Re,Ae,Fe,De,Ne){return((ee=me(ie)?"":me(ge)?">="+ie+".0.0":me(be)?">="+ie+"."+ge+".0":">="+ee)+" "+(Le=me(Re)?"":me(Ae)?"<"+(+Re+1)+".0.0":me(Fe)?"<"+Re+"."+(+Ae+1)+".0":De?"<="+Re+"."+Ae+"."+Fe+"-"+De:"<="+Le)).trim()}function we(x,ee){for(var ie=0;ie<x.length;ie++)if(!x[ie].test(ee))return!1;if(ee.prerelease.length){for(ie=0;ie<x.length;ie++)if(k(x[ie].semver),x[ie].semver!==ye&&x[ie].semver.prerelease.length>0){var ge=x[ie].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function Ee(x,ee,ie){try{ee=new fe(ee,ie)}catch{return!1}return ee.test(x)}function ke(x,ee,ie,ge){var be,je,Pe,Le,Re;switch(x=new T(x,ge),ee=new fe(ee,ge),ie){case">":be=L,je=ce,Pe=C,Le=">",Re=">=";break;case"<":be=C,je=ne,Pe=L,Le="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,ee,ge))return!1;for(var Ae=0;Ae<ee.set.length;++Ae){var Fe=ee.set[Ae],De=null,Ne=null;if(Fe.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),De=De||ze,Ne=Ne||ze,be(ze.semver,De.semver,ge)?De=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),De.operator===Le||De.operator===Re||(!Ne.operator||Ne.operator===Le)&&je(x,Ne.semver)||Ne.operator===Re&&Pe(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var ee=this.loose?S[B]:S[Q],ie=x.match(ee);if(!ie)throw new TypeError("Invalid comparator: "+x);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new T(ie[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new T(x,this.loose)),he(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,ee){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new fe(x.value,ee),Ee(this.value,ie,ee);if(x.operator==="")return ie=new fe(this.value,ee),Ee(x.semver,ie,ee);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),je=this.semver.version===x.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=he(this.semver,"<",x.semver,ee)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Re=he(this.semver,">",x.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||be||je&&Pe||Le||Re},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var ee=this.loose;x=x.trim(),k("range",x,ee);var ie=ee?S[W]:S[M];x=x.replace(ie,de),k("hyphen replace",x),x=x.replace(S[q],"$1$2$3"),k("comparator trim",x,S[q]),x=(x=(x=x.replace(S[V],"$1~")).replace(S[le],"$1^")).split(/\s+/).join(" ");var ge=ee?S[B]:S[Q],be=x.split(" ").map(function(je){return function(Pe,Le){return k("comp",Pe),Pe=function(Re,Ae){return Re.trim().split(/\s+/).map(function(Fe){return function(De,Ne){k("caret",De,Ne);var ze=Ne?S[ae]:S[ue];return De.replace(ze,function(Te,ve,Se,Ie,Oe){var Ue;return k("caret",De,Te,ve,Se,Ie,Oe),me(ve)?Ue="":me(Se)?Ue=">="+ve+".0.0 <"+(+ve+1)+".0.0":me(Ie)?Ue=ve==="0"?">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+".0 <"+(+ve+1)+".0.0":Oe?(k("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=ve==="0"?Se==="0"?">="+ve+"."+Se+"."+Ie+Oe+" <"+ve+"."+Se+"."+(+Ie+1):">="+ve+"."+Se+"."+Ie+Oe+" <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+"."+Ie+Oe+" <"+(+ve+1)+".0.0"):(k("no pr"),Ue=ve==="0"?Se==="0"?">="+ve+"."+Se+"."+Ie+" <"+ve+"."+Se+"."+(+Ie+1):">="+ve+"."+Se+"."+Ie+" <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+"."+Ie+" <"+(+ve+1)+".0.0"),k("caret return",Ue),Ue})}(Fe,Ae)}).join(" ")}(Pe,Le),k("caret",Pe),Pe=function(Re,Ae){return Re.trim().split(/\s+/).map(function(Fe){return function(De,Ne){var ze=Ne?S[_]:S[X];return De.replace(ze,function(Te,ve,Se,Ie,Oe){var Ue;return k("tilde",De,Te,ve,Se,Ie,Oe),me(ve)?Ue="":me(Se)?Ue=">="+ve+".0.0 <"+(+ve+1)+".0.0":me(Ie)?Ue=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0":Oe?(k("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+ve+"."+Se+"."+Ie+Oe+" <"+ve+"."+(+Se+1)+".0"):Ue=">="+ve+"."+Se+"."+Ie+" <"+ve+"."+(+Se+1)+".0",k("tilde return",Ue),Ue})}(Fe,Ae)}).join(" ")}(Pe,Le),k("tildes",Pe),Pe=function(Re,Ae){return k("replaceXRanges",Re,Ae),Re.split(/\s+/).map(function(Fe){return function(De,Ne){De=De.trim();var ze=Ne?S[z]:S[I];return De.replace(ze,function(Te,ve,Se,Ie,Oe,Ue){k("xRange",De,Te,ve,Se,Ie,Oe,Ue);var qe=me(Se),Ce=qe||me(Ie),Me=Ce||me(Oe);return ve==="="&&Me&&(ve=""),qe?Te=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Me?(Ce&&(Ie=0),Me&&(Oe=0),ve===">"?(ve=">=",Ce?(Se=+Se+1,Ie=0,Oe=0):Me&&(Ie=+Ie+1,Oe=0)):ve==="<="&&(ve="<",Ce?Se=+Se+1:Ie=+Ie+1),Te=ve+Se+"."+Ie+"."+Oe):Ce?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":Me&&(Te=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),k("xRange return",Te),Te})}(Fe,Ae)}).join(" ")}(Pe,Le),k("xrange",Pe),Pe=function(Re,Ae){return k("replaceStars",Re,Ae),Re.trim().replace(S[Z],"")}(Pe,Le),k("stars",Pe),Pe}(je,ee)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(je){return!!je.match(ge)})),be=be.map(function(je){return new pe(je,ee)})},fe.prototype.intersects=function(x,ee){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function(ge){return x.set.some(function(be){return be.every(function(je){return ge.intersects(je,ee)})})})})},e.toComparators=function(x,ee){return new fe(x,ee).set.map(function(ie){return ie.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new T(x,this.loose));for(var ee=0;ee<this.set.length;ee++)if(we(this.set[ee],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,ee,ie){var ge=null,be=null;try{var je=new fe(ee,ie)}catch{return null}return x.forEach(function(Pe){je.test(Pe)&&(ge&&be.compare(Pe)!==-1||(be=new T(ge=Pe,ie)))}),ge},e.minSatisfying=function(x,ee,ie){var ge=null,be=null;try{var je=new fe(ee,ie)}catch{return null}return x.forEach(function(Pe){je.test(Pe)&&(ge&&be.compare(Pe)!==1||(be=new T(ge=Pe,ie)))}),ge},e.validRange=function(x,ee){try{return new fe(x,ee).range||"*"}catch{return null}},e.ltr=function(x,ee,ie){return ke(x,ee,"<",ie)},e.gtr=function(x,ee,ie){return ke(x,ee,">",ie)},e.outside=ke,e.prerelease=function(x,ee){var ie=te(x,ee);return ie&&ie.prerelease.length?ie.prerelease:null},e.intersects=function(x,ee,ie){return x=new fe(x,ie),ee=new fe(ee,ie),x.intersects(ee)},e.coerce=function(x){if(x instanceof T)return x;if(typeof x!="string")return null;var ee=x.match(S[N]);return ee==null?null:te((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,j(1))},function(J,e){var j,D,k=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function S(m){if(j===setTimeout)return setTimeout(m,0);if((j===A||!j)&&setTimeout)return j=setTimeout,setTimeout(m,0);try{return j(m,0)}catch{try{return j.call(null,m,0)}catch{return j.call(this,m,0)}}}(function(){try{j=typeof setTimeout=="function"?setTimeout:A}catch{j=A}try{D=typeof clearTimeout=="function"?clearTimeout:O}catch{D=O}})();var u,a=[],g=!1,b=-1;function d(){g&&u&&(g=!1,u.length?a=u.concat(a):b=-1,a.length&&$())}function $(){if(!g){var m=S(d);g=!0;for(var c=a.length;c;){for(u=a,a=[];++b<c;)u&&u[b].run();b=-1,c=a.length}u=null,g=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===O||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(m)}}function y(m,c){this.fun=m,this.array=c}function R(){}k.nextTick=function(m){var c=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)c[v-1]=arguments[v];a.push(new y(m,c)),a.length!==1||g||S($)},y.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=R,k.addListener=R,k.once=R,k.off=R,k.removeListener=R,k.removeAllListeners=R,k.emit=R,k.prependListener=R,k.prependOnceListener=R,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(se[76],re([0,1]),function(J,e){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class D{constructor(S,u,a){this.level=S,this.key=u,this.value=a,this.forward=[]}}const k=void 0;class A{constructor(S,u=2**16){this.comparator=S,this[j]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,k,k)}get size(){return this.f}clear(){this.e=new D(this.c,k,k),this.f=0}has(S){return!!A.g(this,S,this.comparator)}get(S){return A.g(this,S,this.comparator)?.value}set(S,u){return A.h(this,S,u,this.comparator)&&(this.f+=1),this}delete(S){const u=A.k(this,S,this.comparator);return u&&(this.f-=1),u}forEach(S,u){let a=this.e.forward[0];for(;a;)S.call(u,a.value,a.key,this),a=a.forward[0]}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",u=this.e.forward[0];for(;u;)S+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return S}static g(S,u,a){let g=S.e;for(let b=S.d-1;b>=0;b--)for(;g.forward[b]&&a(g.forward[b].key,u)<0;)g=g.forward[b];if(g=g.forward[0],g&&a(g.key,u)===0)return g}static h(S,u,a,g){const b=[];let d=S.e;for(let $=S.d-1;$>=0;$--){for(;d.forward[$]&&g(d.forward[$].key,u)<0;)d=d.forward[$];b[$]=d}if(d=d.forward[0],d&&g(d.key,u)===0)return d.value=a,!1;{const $=A.j(S);if($>S.d){for(let y=S.d;y<$;y++)b[y]=S.e;S.d=$}d=new D($,u,a);for(let y=0;y<$;y++)d.forward[y]=b[y].forward[y],b[y].forward[y]=d;return!0}}static j(S,u=.5){let a=1;for(;Math.random()<u&&a<S.c;)a+=1;return a}static k(S,u,a){const g=[];let b=S.e;for(let d=S.d-1;d>=0;d--){for(;b.forward[d]&&a(b.forward[d].key,u)<0;)b=b.forward[d];g[d]=b}if(b=b.forward[0],!b||a(b.key,u)!==0)return!1;for(let d=0;d<S.d&&g[d].forward[d]===b;d++)g[d].forward[d]=b.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===k;)S.d-=1;return!0}}e.$ns=A}),define(se[46],re([0,1,9,2]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=k,e.$le=A,e.$me=O,e.$ne=S,e.$oe=a,e.$pe=g,e.$qe=b,e.$re=d,e.$se=$,e.$te=y,e.$ue=R,e.$ve=m,e.$we=c,e.$xe=v,e.$ye=w;function k(h){const p=h;return p?typeof p.read=="function":!1}function A(h){const p=h;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}function O(h){const p=h;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}function S(h,p){return new u(h,p)}class u{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,j.$1)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let r;switch(p){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,p){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return p(i)}function g(h,p,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?p(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}function b(h,p){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{p&&t.push(n)},onError:n=>{p?r(n):i(void 0)},onEnd:()=>{i(p?p(t):void 0)}})})}function d(h,p,i){h.on("error",r=>{i?.isCancellationRequested||p.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||p.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||p.onData(r)})}function $(h,p){return new Promise((i,r)=>{const t=new D.$Tc,n=[],s=P=>{if(n.push(P),n.length>p)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=P=>(t.dispose(),r(P)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,D.$Sc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,D.$Sc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,D.$Sc)(()=>h.removeListener("data",s))),h.on("data",s)})}function y(h,p){const i=S(p);return i.end(h),i}function R(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}function m(h){let p=!1;return{read:()=>p?null:(p=!0,h)}}function c(h,p,i){const r=S(i);return d(h,{onData:t=>r.write(p.data(t)),onError:t=>r.error(p.error?p.error(t):t),onEnd:()=>r.end()}),r}function v(h,p,i){let r=!1;return{read:()=>{const t=p.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}function w(h,p,i){let r=!1;const t=S(i);return d(p,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}}),define(se[14],re([0,1,169,46]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=a,e.$Be=g,e.$Ce=b,e.$De=d,e.$Ee=$,e.$Fe=y,e.$Ge=R,e.$He=m,e.$Ie=c,e.$Je=v,e.$Ke=w,e.$Le=h,e.$Me=p,e.$Ne=i,e.$Oe=r,e.$Pe=t,e.$Qe=n,e.$Re=s,e.$Se=o,e.$Te=I;const k=typeof Buffer<"u",A=new j.$V(()=>new Uint8Array(256));let O,S;class u{static alloc(N){return k?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return k&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,U){return!(U?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(N)):(O||(O=new TextEncoder),new u(O.encode(N)))}static fromByteArray(N){const U=u.alloc(N.length);for(let V=0,X=N.length;V<X;V++)U.buffer[V]=N[V];return U}static concat(N,U){if(typeof U>"u"){U=0;for(let _=0,K=N.length;_<K;_++)U+=N[_].byteLength}const V=u.alloc(U);let X=0;for(let _=0,K=N.length;_<K;_++){const le=N[_];V.set(le,X),X+=le.byteLength}return V}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return k?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(N,U){return new u(this.buffer.subarray(N,U))}set(N,U){if(N instanceof u)this.buffer.set(N.buffer,U);else if(N instanceof Uint8Array)this.buffer.set(N,U);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),U);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return d(this.buffer,N)}writeUInt32BE(N,U){$(this.buffer,N,U)}readUInt32LE(N){return y(this.buffer,N)}writeUInt32LE(N,U){R(this.buffer,N,U)}readUInt8(N){return m(this.buffer,N)}writeUInt8(N,U){c(this.buffer,N,U)}indexOf(N,U=0){return a(this.buffer,N instanceof u?N.buffer:N,U)}}e.$ze=u;function a(z,N,U=0){const V=N.byteLength,X=z.byteLength;if(V===0)return 0;if(V===1)return z.indexOf(N[0]);if(V>X-U)return-1;const _=A.value;_.fill(N.length);for(let ae=0;ae<N.length;ae++)_[N[ae]]=N.length-ae-1;let K=U+N.length-1,le=K,ue=-1;for(;K<X;)if(z[K]===N[le]){if(le===0){ue=K;break}K--,le--}else K+=Math.max(N.length-le,_[z[K]]),le=N.length-1;return ue}function g(z,N){return z[N+0]<<0>>>0|z[N+1]<<8>>>0}function b(z,N,U){z[U+0]=N&255,N=N>>>8,z[U+1]=N&255}function d(z,N){return z[N]*2**24+z[N+1]*2**16+z[N+2]*2**8+z[N+3]}function $(z,N,U){z[U+3]=N,N=N>>>8,z[U+2]=N,N=N>>>8,z[U+1]=N,N=N>>>8,z[U]=N}function y(z,N){return z[N+0]<<0>>>0|z[N+1]<<8>>>0|z[N+2]<<16>>>0|z[N+3]<<24>>>0}function R(z,N,U){z[U+0]=N&255,N=N>>>8,z[U+1]=N&255,N=N>>>8,z[U+2]=N&255,N=N>>>8,z[U+3]=N&255}function m(z,N){return z[N]}function c(z,N,U){z[U]=N}function v(z){return D.$oe(z,N=>u.concat(N))}function w(z){return D.$ve(z)}function h(z){return D.$qe(z,N=>u.concat(N))}async function p(z){return z.ended?u.concat(z.buffer):u.concat([...z.buffer,await h(z.stream)])}function i(z){return D.$te(z,N=>u.concat(N))}function r(z){return D.$we(z,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}function t(z){return D.$ne(N=>u.concat(N),z)}function n(z,N){return D.$xe(z,N,U=>u.concat(U))}function s(z,N){return D.$ye(z,N,U=>u.concat(U))}function o(z){let N=0,U=0,V=0;const X=new Uint8Array(Math.floor(z.length/4*3)),_=le=>{switch(U){case 3:X[V++]=N|le,U=0;break;case 2:X[V++]=N|le>>>2,N=le<<6,U=3;break;case 1:X[V++]=N|le>>>4,N=le<<4,U=2;break;default:N=le<<2,U=1}};for(let le=0;le<z.length;le++){const ue=z.charCodeAt(le);if(ue>=65&&ue<=90)_(ue-65);else if(ue>=97&&ue<=122)_(ue-97+26);else if(ue>=48&&ue<=57)_(ue-48+52);else if(ue===43||ue===45)_(62);else if(ue===47||ue===95)_(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${z[le]}`)}}const K=V;for(;U>0;)_(0);return u.wrap(X).slice(0,K)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:z},N=!0,U=!1){const V=U?P:l;let X="";const _=z.byteLength%3;let K=0;for(;K<z.byteLength-_;K+=3){const le=z[K+0],ue=z[K+1],ae=z[K+2];X+=V[le>>>2],X+=V[(le<<4|ue>>>4)&63],X+=V[(ue<<2|ae>>>6)&63],X+=V[ae&63]}if(_===1){const le=z[K+0];X+=V[le>>>2],X+=V[le<<4&63],N&&(X+="==")}else if(_===2){const le=z[K+0],ue=z[K+1];X+=V[le>>>2],X+=V[(le<<4|ue>>>4)&63],X+=V[ue<<2&63],N&&(X+="=")}return X}}),define(se[43],re([0,1,30]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$fj=void 0,e.$bj=D,e.$cj=k,e.$dj=A,e.$ej=S,e.$gj=R;function D(c){return k(c,0)}function k(c,v){switch(typeof c){case"object":return c===null?A(349,v):Array.isArray(c)?u(c,v):a(c,v);case"string":return S(c,v);case"boolean":return O(c,v);case"number":return A(c,v);case"undefined":return A(937,v);default:return A(617,v)}}function A(c,v){return(v<<5)-v+c|0}function O(c,v){return A(c?433:863,v)}function S(c,v){v=A(149417,v);for(let w=0,h=c.length;w<h;w++)v=A(c.charCodeAt(w),v);return v}function u(c,v){return v=A(104579,v),c.reduce((w,h)=>k(h,w),v)}function a(c,v){return v=A(181387,v),Object.keys(c).sort().reduce((w,h)=>(w=S(h,w),k(c[h],w)),v)}class g{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=k(v,this.g),this.g}}e.$fj=g;var b;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function d(c,v,w=32){const h=w-v,p=~((1<<h)-1);return(c<<v|(p&c)>>>h)>>>0}function $(c,v=0,w=c.byteLength,h=0){for(let p=0;p<w;p++)c[v+p]=h}function y(c,v,w="0"){for(;c.length<v;)c=w+c;return c}function R(c,v=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(w=>w.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),v/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const w=v.length;if(w===0)return;const h=this.p;let p=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=v.charCodeAt(0),t=0);;){let n=r;if(j.$uf(r))if(t+1<w){const s=v.charCodeAt(t+1);j.$vf(s)?(t++,n=j.$wf(r,s)):n=65533}else{i=r;break}else j.$vf(r)&&(n=65533);if(p=this.w(h,p,n),t++,t<w)r=v.charCodeAt(t);else break}this.r=p,this.u=i}w(v,w,h){return h<128?v[w++]=h:h<2048?(v[w++]=192|(h&1984)>>>6,v[w++]=128|(h&63)>>>0):h<65536?(v[w++]=224|(h&61440)>>>12,v[w++]=128|(h&4032)>>>6,v[w++]=128|(h&63)>>>0):(v[w++]=240|(h&1835008)>>>18,v[w++]=128|(h&258048)>>>12,v[w++]=128|(h&4032)>>>6,v[w++]=128|(h&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,v[0]=v[64],v[1]=v[65],v[2]=v[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=m.g,w=this.q;for(let l=0;l<64;l+=4)v.setUint32(l,w.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)v.setUint32(l,d(v.getUint32(l-12,!1)^v.getUint32(l-32,!1)^v.getUint32(l-56,!1)^v.getUint32(l-64,!1),1),!1);let h=this.h,p=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=p&i|~p&r,s=1518500249):l<40?(n=p^i^r,s=1859775393):l<60?(n=p&i|p&r|i&r,s=2400959708):(n=p^i^r,s=3395469782),o=d(h,5)+n+t+s+v.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(p,30),p=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+p&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$hj=m}),define(se[55],re([0,1,30]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(D||(D={})),function(k){const A="error",O="warning",S="warn",u="info",a="ignore";function g(d){return d?j.$qf(A,d)?k.Error:j.$qf(O,d)||j.$qf(S,d)?k.Warning:j.$qf(u,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=g;function b(d){switch(d){case k.Error:return A;case k.Warning:return O;case k.Info:return u;default:return a}}k.toString=b}(D||(D={})),e.default=D}),define(se[27],re([0,1,3]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=D,e.$Un=k,e.$Vn=O,e.$Wn=u,e.$Xn=a,e.$Yn=g,e.$Zn=b,e.$1n=d,e.$2n=$,e.$3n=y,e.$4n=R,e.$5n=m;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,h])=>{v[w]=h&&typeof h=="object"?D(h):h}),v}function k(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const w=v.shift();Object.freeze(w);for(const h in w)if(A.call(w,h)){const p=w[h];typeof p=="object"&&!Object.isFrozen(p)&&!(0,j.$4f)(p)&&v.push(p)}}return c}const A=Object.prototype.hasOwnProperty;function O(c,v){return S(c,v,new Set)}function S(c,v,w){if((0,j.$0f)(c))return c;const h=v(c);if(typeof h<"u")return h;if(Array.isArray(c)){const p=[];for(const i of c)p.push(S(i,v,w));return p}if((0,j.$3f)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const p={};for(const i in c)A.call(c,i)&&(p[i]=S(c[i],v,w));return w.delete(c),p}return c}function u(c,v,w=!0){return(0,j.$3f)(c)?((0,j.$3f)(v)&&Object.keys(v).forEach(h=>{h in c?w&&((0,j.$3f)(c[h])&&(0,j.$3f)(v[h])?u(c[h],v[h],w):c[h]=v[h]):c[h]=v[h]}),c):v}function a(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let w,h;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(w=0;w<c.length;w++)if(!a(c[w],v[w]))return!1}else{const p=[];for(h in c)p.push(h);p.sort();const i=[];for(h in v)i.push(h);if(i.sort(),!a(p,i))return!1;for(w=0;w<p.length;w++)if(!a(c[p[w]],v[p[w]]))return!1}return!0}function g(c){const v=new Set;return JSON.stringify(c,(w,h)=>{if((0,j.$3f)(h)||Array.isArray(h)){if(v.has(h))return"[Circular]";v.add(h)}return h})}function b(c,v){const w=Object.create(null);return!c||!v||Object.keys(v).forEach(p=>{const i=c[p],r=v[p];a(i,r)||(w[p]=r)}),w}function d(c,v){const w=v.toLowerCase(),h=Object.keys(c).find(p=>p.toLowerCase()===w);return h?c[h]:c[v]}function $(c,v){const w=Object.create(null);for(const[h,p]of Object.entries(c))v(h,p)&&(w[h]=p);return w}function y(c){let v=[];for(;Object.prototype!==c;)v=v.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return v}function R(c){const v=[];for(const w of y(c))typeof c[w]=="function"&&v.push(w);return v}function m(c,v){const w=p=>function(){const i=Array.prototype.slice.call(arguments,0);return v(p,i)},h={};for(const p of c)h[p]=w(p);return h}}),define(se[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=D;const j=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(k){return j.test(k)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let u=0;u<S.length;u++)S[u]=Math.floor(Math.random()*256);return S};const A=new Uint8Array(16),O=[];for(let S=0;S<256;S++)O.push(S.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,a="";return a+=O[A[u++]],a+=O[A[u++]],a+=O[A[u++]],a+=O[A[u++]],a+="-",a+=O[A[u++]],a+=O[A[u++]],a+="-",a+=O[A[u++]],a+=O[A[u++]],a+="-",a+=O[A[u++]],a+=O[A[u++]],a+="-",a+=O[A[u++]],a+=O[A[u++]],a+=O[A[u++]],a+=O[A[u++]],a+=O[A[u++]],a+=O[A[u++]],a}}()}),define(se[77],re([0,1,33]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=A;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(O){const S=O.replace(/\-/g,":").toLowerCase();return!D.has(S)}function A(){const O=(0,j.networkInterfaces)();for(const S in O){const u=O[S];if(u){for(const{mac:a}of u)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[78],re([7,4]),function(J,e){return J.create("vs/base/common/date",e)}),define(se[79],re([0,1,78]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=a,e.$Tm=g,e.$Um=b;const D=60,k=D*60,A=k*24,O=A*7,S=A*30,u=A*365;function a(d,$,y,R){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return(0,j.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!R&&m<30)return(0,j.localize)(1,null);let c;return m<D?(c=m,$?c===1?y?(0,j.localize)(2,null,c):(0,j.localize)(3,null,c):y?(0,j.localize)(4,null,c):(0,j.localize)(5,null,c):c===1?y?(0,j.localize)(6,null,c):(0,j.localize)(7,null,c):y?(0,j.localize)(8,null,c):(0,j.localize)(9,null,c)):m<k?(c=Math.floor(m/D),$?c===1?y?(0,j.localize)(10,null,c):(0,j.localize)(11,null,c):y?(0,j.localize)(12,null,c):(0,j.localize)(13,null,c):c===1?y?(0,j.localize)(14,null,c):(0,j.localize)(15,null,c):y?(0,j.localize)(16,null,c):(0,j.localize)(17,null,c)):m<A?(c=Math.floor(m/k),$?c===1?y?(0,j.localize)(18,null,c):(0,j.localize)(19,null,c):y?(0,j.localize)(20,null,c):(0,j.localize)(21,null,c):c===1?y?(0,j.localize)(22,null,c):(0,j.localize)(23,null,c):y?(0,j.localize)(24,null,c):(0,j.localize)(25,null,c)):m<O?(c=Math.floor(m/A),$?c===1?(0,j.localize)(26,null,c):(0,j.localize)(27,null,c):c===1?(0,j.localize)(28,null,c):(0,j.localize)(29,null,c)):m<S?(c=Math.floor(m/O),$?c===1?y?(0,j.localize)(30,null,c):(0,j.localize)(31,null,c):y?(0,j.localize)(32,null,c):(0,j.localize)(33,null,c):c===1?y?(0,j.localize)(34,null,c):(0,j.localize)(35,null,c):y?(0,j.localize)(36,null,c):(0,j.localize)(37,null,c)):m<u?(c=Math.floor(m/S),$?c===1?y?(0,j.localize)(38,null,c):(0,j.localize)(39,null,c):y?(0,j.localize)(40,null,c):(0,j.localize)(41,null,c):c===1?y?(0,j.localize)(42,null,c):(0,j.localize)(43,null,c):y?(0,j.localize)(44,null,c):(0,j.localize)(45,null,c)):(c=Math.floor(m/u),$?c===1?y?(0,j.localize)(46,null,c):(0,j.localize)(47,null,c):y?(0,j.localize)(48,null,c):(0,j.localize)(49,null,c):c===1?y?(0,j.localize)(50,null,c):(0,j.localize)(51,null,c):y?(0,j.localize)(52,null,c):(0,j.localize)(53,null,c))}function g(d,$){const y=Math.abs(d/1e3);return y<1?$?(0,j.localize)(54,null,d):(0,j.localize)(55,null,d):y<D?$?(0,j.localize)(56,null,Math.round(d)/1e3):(0,j.localize)(57,null,Math.round(d)/1e3):y<k?$?(0,j.localize)(58,null,Math.round(d/(1e3*D))):(0,j.localize)(59,null,Math.round(d/(1e3*D))):y<A?$?(0,j.localize)(60,null,Math.round(d/(1e3*k))):(0,j.localize)(61,null,Math.round(d/(1e3*k))):(0,j.localize)(62,null,Math.round(d/(1e3*A)))}function b(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[80],re([7,4]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(se[34],re([0,1,19,3,80]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=u,e.$_i=a,e.$aj=g;function A(b,d){return d&&(b.stack||b.stacktrace)?k.localize(0,null,S(b),O(b.stack)||O(b.stacktrace)):S(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function S(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function u(b=null,d=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const $=j.$Hb(b),y=u($[0],d);return $.length>1?k.localize(4,null,y,$.length):y}if(D.$1f(b))return b;if(b.detail){const $=b.detail;if($.error)return A($.error,d);if($.exception)return A($.exception,d)}return b.stack?A(b,d):b.message?b.message:k.localize(5,null)}function a(b){const d=b;return d instanceof Error&&Array.isArray(d.actions)}function g(b,d){let $;return typeof b=="string"?$=new Error(b):$=b,$.actions=d,$}}),define(se[81],re([7,4]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(se[82],re([0,1,81]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=D;function D(k){switch(k){case 1:return(0,j.localize)(0,null);case 2:return(0,j.localize)(1,null);case 3:return(0,j.localize)(2,null);case 4:return(0,j.localize)(3,null);case 5:return(0,j.localize)(4,null);case 6:return(0,j.localize)(5,null);case 7:return(0,j.localize)(6,null);case 8:return(0,j.localize)(7,null);case 9:return(0,j.localize)(8,null);default:return""}}}),define(se[56],re([0,1,12]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$dm=A,e.$em=O;var D;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(D||(e.Source=D={}));var k;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(S,...u){const a=u.reduce((d,$)=>(d[$]=!0,d),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!a[d]).forEach(d=>{for(let $=0;$<g.length;$++)if(d.search(g[$])!==-1){delete S[d];break}})}function O(S){S&&(delete S.DEBUG,j.$j&&delete S.DYLD_LIBRARY_PATH,j.$k&&delete S.LD_PRELOAD)}}),define(se[83],re([0,1,11]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=D,e.$Lq=k,e.$Mq=A,e.log=S;function D(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function k(a){const g=[];let b;try{const d=JSON.parse(a.arguments),$=d[d.length-1];$&&$.__$stack&&(d.pop(),b=$.__$stack),g.push(...d)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:b}}function A(a){if(typeof a!="string")return A(k(a).stack);const g=a;if(g){const b=O(g),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:j.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function O(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function S(a,g){const{args:b,stack:d}=k(a),$=typeof b[0]=="string"&&b.length===1;let y=O(d);y&&(y=`(${y.trim()})`);let R=[];if(typeof b[0]=="string"?y&&$?R=[`%c[${g}] %c${b[0]} %c${y}`,u("blue"),u(""),u("grey")]:R=[`%c[${g}] %c${b[0]}`,u("blue"),u(""),...b.slice(1)]:R=[`%c[${g}]%`,u("blue"),...b],y&&!$&&R.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function u(a){return`color: ${a}`}}),define(se[47],re([0,1,14,11]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=k,e.$Vh=A,e.$Wh=S;function k(u){return JSON.stringify(u,O)}function A(u){let a=JSON.parse(u);return a=S(a),a}function O(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof j.$ze||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let g=0;g<u.length;++g)u[g]=S(u[g],a+1);else for(const g in u)Object.hasOwnProperty.call(u,g)&&(u[g]=S(u[g],a+1))}return u}}),define(se[84],re([0,1,71,15,12,11]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=g;class O{constructor(d,$,y){this.id=d,this.dependencies=$,this.callback=y}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,$,y)=>{typeof d!="string"&&(y=$,$=d,d=null),(typeof $!="object"||!Array.isArray($))&&(y=$,$=null),this.c.push(new O(d,$,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const $=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!$)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(d){return new Promise(($,y)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const m=()=>{R.removeEventListener("load",c),R.removeEventListener("error",v)},c=w=>{m(),$(this.c.pop())},v=w=>{m(),y(w)};R.addEventListener("load",c),R.addEventListener("error",v),this.f&&(d=this.f.createScriptURL(d)),R.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(d){return new Promise(($,y)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),$(this.c.pop())}catch(R){y(R)}})}async j(d){try{const $=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,c=$.readFileSync(m).toString(),v=R.wrap(c.replace(/^#!.*/,""));return new y.Script(v).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function g(b,d,$){if(j.$T){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const y=`${b}/${d}`;if(u.has(y))return u.get(y);let R;if(/^\w[\w\d+.-]*:\/\//.test(y))R=y;else{const w=`${$&&!k.$o?D.$Eg:D.$Dg}/${y}`;R=D.$Hg.asBrowserUri(w).toString(!0)}const m=S.INSTANCE.load(R);return u.set(y,m),m}else return await new Promise((y,R)=>{J([b],y,R)})}}),define(se[85],re([0,1,33,48,28,77,12]),function(J,e,j,D,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$wn=u,e.$xn=b,e.$vn=new class{c(d){return this.a||(this.a=D.$ti.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,$=0;const y=(0,j.networkInterfaces)();for(const R in y){const m=y[R];if(m)for(const{mac:c,internal:v}of m)v||($+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=$>0?d/$:0}return this.b}};let S;async function u(d){return S||(S=(async()=>await a(d)||k.$Jg())()),S}async function a(d){try{const $=await new Promise((R,m)=>{J(["crypto"],R,m)}),y=(0,A.$un)();return $.createHash("sha256").update(y,"utf8").digest("hex")}catch($){d($);return}}const g="Software\\Microsoft\\SQMClient";async function b(d){if(O.$i){const $=await new Promise((y,R)=>{J(["@vscode/windows-registry"],y,R)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(y){return d(y),""}}return""}}),define(se[86],re([0,1,33,16,25]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=v,e.$cm=w;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class b{constructor(p,i,r){this.exePath=p,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:h=!1,findPreview:p=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=D.$kc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(p){const z=l.indexOf("-");if(z<0)continue;const N=l.substring(0,z);if(!A.test(N)||l.substring(z+1)!=="preview")continue;P=parseInt(N,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const I=D.$kc(r,l,"pwsh.exe");await k.SymlinkSupport.existsFile(I)&&(n=I,t=P)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=p?" Preview":"";return new b(n,`PowerShell${o}${s}`,!0)}async function y({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const p=D.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(p))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(p))if(i.test(t)){const n=D.$kc(p,t,"pwsh.exe");return new b(n,r)}return null}function R(){const h=D.$kc(j.homedir(),".dotnet","tools","pwsh.exe");return new b(h,".NET Core PowerShell Global Tool")}function m(){const h=D.$kc(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(h,"Windows PowerShell",!0)}async function*c(){let h=await $();h&&(yield h),h=await $({useAlternateBitness:!0}),h&&(yield h),h=await y(),h&&(yield h),h=R(),h&&(yield h),h=await $({findPreview:!0}),h&&(yield h),h=await y({findPreview:!0}),h&&(yield h),h=await $({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*v(){for await(const h of c())await h.exists()&&(yield h)}async function w(){for await(const h of v())return h;return null}}),define(se[57],re([0,1,16,12,35,56,3,25]),function(J,e,j,D,k,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$fm=u,e.$gm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(b=k.env){return b.comspec||"cmd.exe"}function a(b){let d=[],$=!1;const y=function(R){if($){d.push(R);return}(!b.send(R,c=>{if(c&&console.error(c),$=!1,d.length>0){const v=d.slice(0);d=[],v.forEach(w=>y(w))}})||D.$i)&&($=!0)};return{send:y}}var g;(function(b){async function d($,y,R){if(j.$jc($))return $;if(y===void 0&&(y=k.cwd()),j.$nc($)!=="."||(R===void 0&&O.$1f(k.env.PATH)&&(R=k.env.PATH.split(j.$uc)),R===void 0||R.length===0))return j.$kc(y,$);async function c(v){if(await S.Promises.exists(v)){let w;try{w=await S.Promises.stat(v)}catch(h){h.message.startsWith("EACCES")&&(w=await S.Promises.lstat(v))}return w?!w.isDirectory():!1}return!1}for(const v of R){let w;if(j.$jc(v)?w=j.$kc(v,$):w=j.$kc(y,v,$),await c(w))return w;let h=w+".com";if(await c(h)||(h=w+".exe",await c(h)))return h}return j.$kc(y,$)}b.findExecutable=d})(g||(e.win32=g={}))}),define(se[87],re([0,1,33,12,86,57]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=O;async function O(b,d){return b===1?D.$i?g():A.$fm(d):u(b,d)}let S=null;function u(b,d){if(D.$k&&b===2||D.$j&&b===3)return"/bin/bash";if(!S){let $;if(D.$i)$="/bin/bash";else{if($=d.SHELL,!$)try{$=(0,j.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}S=$}return S}let a=null;async function g(){return a||(a=(await(0,k.$cm)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,j,D){var k=arguments.length,A=k<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,j):D,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,j,D);else for(var S=J.length-1;S>=0;S--)(O=J[S])&&(A=(k<3?O(A):k>3?O(e,j,A):O(e,j))||A);return k>3&&A&&Object.defineProperty(e,j,A),A};define(se[58],re([0,1,19,8,14,20,54,9,5,2,47,30,3]),function(J,e,j,D,k,A,O,S,u,a,g,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.ProxyChannel=e.$8h=e.$5h=e.$4h=e.$3h=e.RequestInitiator=e.$2h=e.$Yh=e.$Xh=void 0,e.$Zh=o,e.$1h=l,e.$6h=V,e.$7h=X;var $;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})($||($={}));function y(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(R||(R={}));function m(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(c||(c={}));function v(q){let M=0;for(let W=0;;W+=7){const Z=q.read(1);if(M|=(Z.buffer[0]&127)<<W,!(Z.buffer[0]&128))return M}}const w=t(0);function h(q,M){if(M===0){q.write(w);return}let W=0;for(let Y=M;Y!==0;Y=Y>>>7)W++;const Z=k.$ze.alloc(W);for(let Y=0;M!==0;Y++)Z.buffer[Y]=M&127,M=M>>>7,M>0&&(Z.buffer[Y]|=128);q.write(Z)}class p{constructor(M){this.b=M,this.a=0}read(M){const W=this.b.slice(this.a,this.a+M);return this.a+=W.byteLength,W}}e.$Xh=p;class i{constructor(){this.a=[]}get buffer(){return k.$ze.concat(this.a)}write(M){this.a.push(M)}}e.$Yh=i;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const M=k.$ze.alloc(1);return M.writeUInt8(q,0),M}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(q,M){if(typeof M>"u")q.write(n.Undefined);else if(typeof M=="string"){const W=k.$ze.fromString(M);q.write(n.String),h(q,W.byteLength),q.write(W)}else if(s&&Buffer.isBuffer(M)){const W=k.$ze.wrap(M);q.write(n.Buffer),h(q,W.byteLength),q.write(W)}else if(M instanceof k.$ze)q.write(n.VSBuffer),h(q,M.byteLength),q.write(M);else if(Array.isArray(M)){q.write(n.Array),h(q,M.length);for(const W of M)o(q,W)}else if(typeof M=="number"&&(M|0)===M)q.write(n.Uint),h(q,M);else{const W=k.$ze.fromString(JSON.stringify(M));q.write(n.Object),h(q,W.byteLength),q.write(W)}}function l(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(v(q)).toString();case r.Buffer:return q.read(v(q)).buffer;case r.VSBuffer:return q.read(v(q));case r.Array:{const W=v(q),Z=[];for(let Y=0;Y<W;Y++)Z.push(l(q));return Z}case r.Object:return JSON.parse(q.read(v(q)).toString());case r.Int:return v(q)}}class P{constructor(M,W,Z=null,Y=1e3){this.h=M,this.j=W,this.k=Z,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(M,W){this.b.set(M,W),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const W=this.o([M.type]);this.k?.logOutgoing(W,0,1,m(M.type));return}case 201:case 202:case 204:case 203:{const W=this.o([M.type,M.id],M.data);this.k?.logOutgoing(W,M.id,1,m(M.type),M.data);return}}}o(M,W=void 0){const Z=new i;return o(Z,M),o(Z,W),this.p(Z.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const W=new p(M),Z=l(W),Y=l(W),te=Z[0];switch(te){case 100:return this.k?.logIncoming(M.byteLength,Z[1],1,`${y(te)}: ${Z[2]}.${Z[3]}`,Y),this.s({type:te,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case 102:return this.k?.logIncoming(M.byteLength,Z[1],1,`${y(te)}: ${Z[2]}.${Z[3]}`,Y),this.t({type:te,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case 101:return this.k?.logIncoming(M.byteLength,Z[1],1,`${y(te)}`),this.u({type:te,id:Z[1]});case 103:return this.k?.logIncoming(M.byteLength,Z[1],1,`${y(te)}`),this.u({type:te,id:Z[1]})}}s(M){const W=this.b.get(M.channelName);if(!W){this.v(M);return}const Z=new A.$je;let Y;try{Y=W.call(this.j,M.name,M.arg,Z.token)}catch(F){Y=Promise.reject(F)}const te=M.id;Y.then(F=>{this.m({id:te,data:F,type:201})},F=>{F instanceof Error?this.m({id:te,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:te,data:F,type:203})}).finally(()=>{T.dispose(),this.d.delete(M.id)});const T=(0,a.$Sc)(()=>Z.cancel());this.d.set(M.id,T)}t(M){const W=this.b.get(M.channelName);if(!W){this.v(M);return}const Z=M.id,te=W.listen(this.j,M.name,M.arg)(T=>this.m({id:Z,data:T,type:204}));this.d.set(M.id,te)}u(M){const W=this.d.get(M.id);W&&(W.dispose(),this.d.delete(M.id))}v(M){let W=this.g.get(M.channelName);W||(W=[],this.g.set(M.channelName,W));const Z=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:M,timeoutTimer:Z})}w(M){const W=this.g.get(M);if(W){for(const Z of W)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$2h=P;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class z{constructor(M,W=null){this.l=M,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$_d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=W}getChannel(M){const W=this;return{call(Z,Y,te){return W.a?Promise.reject(new S.$5):W.m(M,Z,Y,te)},listen(Z,Y){return W.a?u.Event.None:W.o(M,Z,Y)}}}m(M,W,Z,Y=A.CancellationToken.None){const te=this.g++,F={id:te,type:100,channelName:M,name:W,arg:Z};if(Y.isCancellationRequested)return Promise.reject(new S.$5);let f;return new Promise((L,C)=>{if(Y.isCancellationRequested)return C(new S.$5);const G=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(te),L(pe.data);break;case 202:{this.f.delete(te);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,C(ye);break}case 203:this.f.delete(te),C(pe.data);break}};this.f.set(te,he),this.p(F)};let H=null;this.b===c.Idle?G():(H=(0,D.$ah)(he=>this.u()),H.then(()=>{H=null,G()}));const ne=()=>{H?(H.cancel(),H=null):this.p({id:te,type:101}),C(new S.$5)},ce=Y.onCancellationRequested(ne);f=(0,a.$Rc)((0,a.$Sc)(ne),ce),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(M,W,Z){const Y=this.g++,T={id:Y,type:102,channelName:M,name:W,arg:Z};let F=null;const f=new u.$_d({onWillAddFirstListener:()=>{F=(0,D.$ah)(L=>this.u()),F.then(()=>{F=null,this.d.add(f),this.p(T)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(f),this.p({id:Y,type:103}))}}),E=L=>f.fire(L.data);return this.f.set(Y,E),f.event}p(M){switch(M.type){case 100:case 102:{const W=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(W,M.id,0,`${y(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const W=this.q([M.type,M.id]);this.j?.logOutgoing(W,M.id,0,y(M.type));return}}}q(M,W=void 0){const Z=new i;return o(Z,M),o(Z,W),this.r(Z.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const W=new p(M),Z=l(W),Y=l(W),te=Z[0];switch(te){case 200:return this.j?.logIncoming(M.byteLength,0,0,m(te)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,Z[1],0,m(te),Y),this.t({type:Z[0],id:Z[1],data:Y})}}t(M){if(M.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$3h=z,$e([O.$Rh],z.prototype,"onDidInitializePromise",null);class N{get connections(){const M=[];return this.f.forEach(W=>M.push(W)),M}constructor(M,W,Z){this.a=new Map,this.f=new Set,this.g=new u.$_d,this.onDidAddConnection=this.g.event,this.h=new u.$_d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(M(({protocol:Y,onDidClientDisconnect:te})=>{const T=u.Event.once(Y.onMessage);this.j.add(T(F=>{const f=new p(F),E=l(f),L=new P(Y,E,W,Z),C=new z(Y,W);this.a.forEach((H,ne)=>L.registerChannel(ne,H));const G={channelServer:L,channelClient:C,ctx:E};this.f.add(G),this.g.fire(G),this.j.add(te(()=>{L.dispose(),C.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(M,W){const Z=this;return{call(Y,te,T){let F;if((0,d.$cg)(W)){const E=(0,j.$4b)(Z.connections.filter(W));F=E?Promise.resolve(E):u.Event.toPromise(u.Event.filter(Z.onDidAddConnection,W))}else F=W.routeCall(Z,Y,te);const f=F.then(E=>E.channelClient.getChannel(M));return V(f).call(Y,te,T)},listen(Y,te){if((0,d.$cg)(W))return Z.k(M,W,Y,te);const T=W.routeEvent(Z,Y,te).then(F=>F.channelClient.getChannel(M));return V(T).listen(Y,te)}}}k(M,W,Z,Y){const te=this;let T;const F=new u.$_d({onWillAddFirstListener:()=>{T=new a.$Tc;const f=new u.$fe,E=new Map,L=G=>{const ne=G.channelClient.getChannel(M).listen(Z,Y),ce=f.add(ne);E.set(G,ce)},C=G=>{const H=E.get(G);H&&(H.dispose(),E.delete(G))};te.connections.filter(W).forEach(L),u.Event.filter(te.onDidAddConnection,W)(L,void 0,T),te.onDidRemoveConnection(C,void 0,T),f.event(F.fire,F,T),T.add(f)},onDidRemoveLastListener:()=>{T?.dispose(),T=void 0}});return F.event}registerChannel(M,W){this.a.set(M,W);for(const Z of this.f)Z.channelServer.registerChannel(M,W)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$4h=N;class U{constructor(M,W,Z=null){const Y=new i;o(Y,W),M.send(Y.buffer),this.a=new z(M,Z),this.d=new P(M,W,Z)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,W){this.d.registerChannel(M,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5h=U;function V(q){return{call(M,W,Z){return q.then(Y=>Y.call(M,W,Z))},listen(M,W){const Z=new u.$ie;return q.then(Y=>Z.input=Y.listen(M,W)),Z.event}}}function X(q){let M=!1;return{call(W,Z,Y){return M?q.call(W,Z,Y):(0,D.$oh)(0).then(()=>M=!0).then(()=>q.call(W,Z,Y))},listen(W,Z){if(M)return q.listen(W,Z);const Y=new u.$ie;return(0,D.$oh)(0).then(()=>M=!0).then(()=>Y.input=q.listen(W,Z)),Y.event}}}class _{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const W of M.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$8h=_;var K;(function(q){function M(te,T,F){const f=te,E=F&&F.disableMarshalling,L=new Map;for(const C in f)Z(C)&&L.set(C,u.Event.buffer(f[C],!0,void 0,T));return new class{listen(C,G,H){const ne=L.get(G);if(ne)return ne;const ce=f[G];if(typeof ce=="function"){if(Y(G))return ce.call(f,H);if(Z(G))return L.set(G,u.Event.buffer(f[G],!0,void 0,T)),L.get(G)}throw new S.$bb(`Event not found: ${G}`)}call(C,G,H){const ne=f[G];if(typeof ne=="function"){if(!E&&Array.isArray(H))for(let he=0;he<H.length;he++)H[he]=(0,g.$Wh)(H[he]);let ce=ne.apply(f,H);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new S.$bb(`Method not found: ${G}`)}}}q.fromService=M;function W(te,T){const F=T&&T.disableMarshalling;return new Proxy({},{get(f,E){if(typeof E=="string")return T?.properties?.has(E)?T.properties.get(E):Y(E)?function(L){return te.listen(E,L)}:Z(E)?te.listen(E):async function(...L){let C;T&&!(0,d.$0f)(T.context)?C=[T.context,...L]:C=L;const G=await te.call(E,C);return F?G:(0,g.$Wh)(G)};throw new S.$bb(`Property not found: ${String(E)}`)}})}q.toService=W;function Z(te){return te[0]==="o"&&te[1]==="n"&&b.$pf(te.charCodeAt(2))}function Y(te){return/^onDynamic/.test(te)&&b.$pf(te.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const M=q.toString();if(M!=="[object Object]")return M}return q}function ae(q){return Array.isArray(q)?q.map(ue):ue(q)}function B(q,M,W,Z,Y,te,T){T=ae(T);const F=le[Y],f=F[Z%F.length];let E=[`%c[${q}]%c[${String(M).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(te)?(E=E.concat(T),E.push(")")):E.push(T),console.log.apply(console,E)}class Q{constructor(M,W){this.d=M,this.f=W,this.a=0,this.b=0}logOutgoing(M,W,Z,Y,te){this.b+=M,B(this.d,this.b,M,W,Z,Y,te)}logIncoming(M,W,Z,Y,te){this.a+=M,B(this.f,this.a,M,W,Z,Y,te)}}e.$9h=Q}),define(se[88],re([0,1,59,8,14,20,83,9,5,2,27,57,56,58]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class y extends $.$2h{constructor(c){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",v=>k.$ze.wrap(Buffer.from(v,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Oq=y;class R{constructor(c,v){this.i=c,this.j=v,this.c=new Set,this.g=new Map,this.h=new u.$_d,this.onDidProcessExit=this.h.event;const w=v&&v.timeout?v.timeout:6e4;this.b=new D.$kh(w),this.d=null,this.f=null}getChannel(c){const v=this;return{call(w,h,p){return v.k(c,w,h,p)},listen(w,h){return v.l(c,w,h)}}}k(c,v,w,h=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const p=this.n(c),i=(0,D.$ah)(n=>p.call(v,w,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Sc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,v,w){if(!this.b)return u.Event.None;this.b.cancel();let h;const p=new u.$_d({onWillAddFirstListener:()=>{h=this.n(c).listen(v,w)(p.fire,p),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return p.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,g.$Tn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,d.$em)(v.env),this.d=(0,j.fork)(this.i,c,v);const w=new u.$_d,p=u.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.$Kq)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}w.fire(k.$ze.wrap(Buffer.from(o,"base64")))}),i=this.j.useQueue?(0,b.$gm)(this.d):this.d,r=o=>this.d&&this.d.connected&&i.send(o.buffer.toString("base64")),t=w.event,n={send:r,onMessage:t};this.f=new $.$3h(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),p.dispose(),this.c.forEach(P=>(0,a.$Pc)(P)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(c){let v=this.g.get(c);return v||(v=this.m.getChannel(c),this.g.set(c,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pq=R}),define(se[89],re([0,1,8,5,2,47,3]),function(J,e,j,D,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.StorageState=e.StorageHint=void 0,e.$Mp=u;var S;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function u(d){const $=d;return $?.changed instanceof Map||$?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends k.$Uc{static{this.a=100}constructor($,y=Object.create(null)){super(),this.r=$,this.s=y,this.b=this.B(new D.$ce),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new j.$lh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((y,R)=>this.w(R,y)),$.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w($,y){if(this.c===a.Closed)return;let R=!1;(0,O.$0f)(y)?R=this.f.delete($):this.f.get($)!==y&&(this.f.set($,y),R=!0),R&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,y){const R=this.f.get($);return(0,O.$0f)(R)?y:R}getBoolean($,y){const R=this.get($);return(0,O.$0f)(R)?y:R==="true"}getNumber($,y){const R=this.get($);return(0,O.$0f)(R)?y:parseInt(R,10)}getObject($,y){const R=this.get($);return(0,O.$0f)(R)?y:(0,A.$Vh)(R)}async set($,y,R=!1){if(this.c===a.Closed)return;if((0,O.$0f)(y))return this.delete($,R);const m=(0,O.$3f)(y)||Array.isArray(y)?(0,A.$Uh)(y):String(y);if(this.f.get($)!==m)return this.f.set($,m),this.j.set($,m),this.h.delete($),this.b.fire({key:$,external:R}),this.D()}async delete($,y=!1){if(!(this.c===a.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Np=g;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((y,R)=>this.a.set(R,y)),$.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Op=b}),define(se[90],re([7,4]),function(J,e){return J.create("vs/base/node/zip",e)}),define(se[49],re([0,1,60,8,16,3,25,90]),function(J,e,j,D,k,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.zip=m,e.$_p=c,e.$aq=w,e.$9p="end of central directory record signature not found";const u=new RegExp(e.$9p);class a extends Error{constructor(p,i){let r=i.message;switch(p){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=p,this.cause=i}}e.$0p=a;function g(h){const p=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>p&i).reduce((i,r)=>i+r,p&61440)}function b(h){if(h instanceof a)return h;let p;return u.test(h.message)&&(p="CorruptZip"),new a(p,h)}function d(h,p,i,r,t,n){const s=k.$nc(p),o=k.$kc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(S.localize(0,null,p)));const l=k.$kc(r,p);let P;return n.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,z)=>{if(!n.isCancellationRequested)try{P=(0,j.createWriteStream)(l,{mode:i}),P.once("close",()=>I()),P.once("error",z),h.once("error",z),h.pipe(P)}catch(N){z(N)}}))}function $(h,p,i,r){let t=(0,D.$ah)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const P=new D.$ih,I=z=>{z.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(S.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",z=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(z.fileName)){I(r);return}const N=z.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const X=k.$kc(p,N);t=(0,D.$ah)(_=>O.Promises.mkdir(X,{recursive:!0}).then(()=>I(_)).then(void 0,l));return}const U=R(h,z),V=g(z);t=(0,D.$ah)(X=>P.queue(()=>U.then(_=>d(_,N,V,p,i,X).then(()=>I(X)))).then(null,l))})}).finally(()=>s.dispose())}async function y(h,p=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,p?{lazyEntries:!0}:void 0,(n,s)=>{n?t(b(n)):r((0,A.$_f)(s))})})}function R(h,p){return new Promise((i,r)=>{h.openReadStream(p,(t,n)=>{t?r(b(t)):i((0,A.$_f)(n))})})}async function m(h,p){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;p.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,j.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}function c(h,p,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=y(h,!0);return i.overwrite&&(n=n.then(s=>O.Promises.rm(p).then(()=>s))),n.then(s=>$(s,p,{sourcePathRegex:t},r))}function v(h,p){return y(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===p&&R(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(S.localize(2,null,p))))}))}function w(h,p){return v(h,p).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}}),define(se[91],re([7,4]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[92],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(se[93],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(se[94],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[95],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[96],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(se[97],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[98],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[99],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[100],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[101],re([7,4]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[102],re([7,4]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(se[103],re([7,4]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(se[104],re([7,4]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[105],re([7,4]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[106],re([7,4]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(se[107],re([7,4]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(se[108],re([7,4]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(se[109],re([7,4]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[110],re([7,4]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[111],re([7,4]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(se[112],re([0,1,9,93]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const O=(0,D.localize)(3,null),S=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,j.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const b=this.d,d=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:d};this.g.push({offset:b,lexeme:d,additionalInfo:g}),this.f.push($)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const b=this.c.substring(this.d,this.e),d=u.b.get(b);d?this.k(d):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,b=!1,d=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(S);return}const y=this.c.charCodeAt(g);if(b)b=!1;else if(y===47&&!d){g++;break}else y===91?d=!0:y===92?b=!0:y===93&&(d=!1);g++}for(;g<this.c.length&&u.a.has(this.c.charCodeAt(g));)g++;this.e=g;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=u}),define(se[113],re([0,1,79,54,15,16,35,17,11]),function(J,e,j,D,k,A,O,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Xm=g,e.$Ym=b,e.$Vm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.$nc)(k.$Hg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,S.$1g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$1g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,j.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",$)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$1g)(u.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$1g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$1g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$1g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=O.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"argv.json")):(0,S.$1g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,A.$lc)($):(0,A.$ic)((0,A.$kc)(k.$Hg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?u.URI.file((0,A.$lc)($)):u.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,A.$lc)($);const y=O.env.VSCODE_EXTENSIONS;if(y)return y;const R=O.env.VSCODE_PORTABLE;return R?(0,A.$kc)(R,"extensions"):(0,S.$1g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(y=>/^[^:/?#]+?:\/\//.test(y)?u.URI.parse(y):u.URI.file((0,A.$ic)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,A.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Vm.test($))}get extensionLogLevel(){const $=[];for(const y of this.args.log||[]){const R=e.$Vm.exec(y);R&&R[1]&&R[2]&&$.push([R[1],R[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,S.$1g)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=O.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"policy.json")):(0,S.$1g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,y,R){this.a=$,this.b=y,this.c=R,this.editSessionId=this.args.editSessionId}}e.$Wm=a,$e([D.$Rh],a.prototype,"appRoot",null),$e([D.$Rh],a.prototype,"userHome",null),$e([D.$Rh],a.prototype,"userDataPath",null),$e([D.$Rh],a.prototype,"appSettingsHome",null),$e([D.$Rh],a.prototype,"tmpDir",null),$e([D.$Rh],a.prototype,"cacheHome",null),$e([D.$Rh],a.prototype,"stateResource",null),$e([D.$Rh],a.prototype,"userRoamingDataHome",null),$e([D.$Rh],a.prototype,"userDataSyncHome",null),$e([D.$Rh],a.prototype,"sync",null),$e([D.$Rh],a.prototype,"machineSettingsResource",null),$e([D.$Rh],a.prototype,"workspaceStorageHome",null),$e([D.$Rh],a.prototype,"localHistoryHome",null),$e([D.$Rh],a.prototype,"keyboardLayoutResource",null),$e([D.$Rh],a.prototype,"argvResource",null),$e([D.$Rh],a.prototype,"isExtensionDevelopment",null),$e([D.$Rh],a.prototype,"untitledWorkspacesHome",null),$e([D.$Rh],a.prototype,"builtinExtensionsPath",null),$e([D.$Rh],a.prototype,"extensionsPath",null),$e([D.$Rh],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$Rh],a.prototype,"extensionDevelopmentKind",null),$e([D.$Rh],a.prototype,"extensionTestsLocationURI",null),$e([D.$Rh],a.prototype,"debugExtensionHost",null),$e([D.$Rh],a.prototype,"logLevel",null),$e([D.$Rh],a.prototype,"extensionLogLevel",null),$e([D.$Rh],a.prototype,"serviceMachineIdResource",null),$e([D.$Rh],a.prototype,"disableTelemetry",null),$e([D.$Rh],a.prototype,"disableWorkspaceTrust",null),$e([D.$Rh],a.prototype,"useInMemorySecretStorage",null),$e([D.$Rh],a.prototype,"policyFile",null);function g(d,$){return b(d["inspect-extensions"],d["inspect-brk-extensions"],5870,$,d.debugId,d.extensionEnvironment)}function b(d,$,y,R,m,c){const w=Number($||d)||(R?null:y),h=w?!!$:!1;let p;if(c)try{p=JSON.parse(c)}catch{}return{port:w,break:h,debugId:m,env:p}}}),function(){"use strict";function J(e,j,D){function k(O,S){const u=A(O,S),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function A(O,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const g=O["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(j.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(j.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:k}}if(typeof define=="function")define(se[114],re([170,33,35]),function(e,j,D){return J(e,j,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),j=require("os");module.exports=J(e,j,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[115],re([0,1,33,113,114]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=void 0,e.$1m=O,e.$2m=S;class A extends D.$Wm{constructor(a,g){super(a,{homeDir:(0,j.homedir)(),tmpDir:(0,j.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,g.nameShort)},g)}}e.$Zm=A;function O(u,a){return(0,D.$Ym)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function S(u,a){return(0,D.$Ym)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(se[116],re([0,1,3,97]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=k;function k(O,S,u,a){try{A(O,S,u,a)}catch(g){O.error(g?.message??g)}return S}function A(O,S,u,a){const g=(b,d,$)=>{const y=b[d];if((0,j.$1f)(y)){const R=y,m=R.length;if(m>1&&R[0]==="%"&&R[m-1]==="%"){const c=R.substr(1,m-2);let v=u[c];v===void 0&&a&&(v=a[c]);const w=typeof v=="string"?v:v?.message,h=a?.[c],p=typeof h=="string"?h:h?.message;if(!w){p||O.warn(`[${S.name}]: ${(0,D.localize)(0,null,c)}`);return}if($&&(d==="title"||d==="category")&&p&&p!==w){const i={value:w,original:p};b[d]=i}else b[d]=w}}else if((0,j.$3f)(y))for(const R in y)y.hasOwnProperty(R)&&(R==="commands"?g(y,R,!0):g(y,R,$));else if(Array.isArray(y))for(let R=0;R<y.length;R++)g(y,R,$)};for(const b in S)S.hasOwnProperty(b)&&g(S,b)}}),define(se[117],re([0,1,49,100]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=k;function k(A){return(0,j.$aq)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}}),define(se[50],re([0,1,17,55,101,44]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=u,e.$yp=a,e.$zp=g,e.$Ap=b,e.$Bp=d,e.$Cp=$,e.$Dp=y;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||O.test(c)}function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=c.match(O);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}function g(c){if(!c)return null;const v=c.majorBase,w=c.majorMustEqual,h=c.minorBase;let p=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(v===0||(p=!1),r=!1);let t=0;if(c.preRelease){const n=S.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:v,majorMustEqual:w,minorBase:h,minorMustEqual:p,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function b(c,v,w){let h;typeof c=="string"?h=g(a(c)):h=c;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let i;if(typeof w=="string"?i=g(a(w)):i=w,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const P=i.notBefore;let I=i.majorMustEqual,z=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||p&&p<P?!1:n>=l:(r===1&&s===0&&(!I||!z||!N)&&(s=1,o=0,l=0,I=!0,z=!1,N=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!z:n<l?!1:n>l?!N:!(p&&p<P))}function d(c,v,w,h,p){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([D.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([D.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([D.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([D.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([D.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!m(h.extensionDependencies))return i.push([D.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!m(h.activationEvents))return i.push([D.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([D.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([D.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([D.default.Error,k.localize(9,null,"main")]),i;{const n=(0,j.$1g)(w,h.main);(0,j.$Ug)(n,w)||i.push([D.default.Warning,k.localize(10,null,n.path,w.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([D.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,j.$1g)(w,h.browser);(0,j.$Ug)(n,w)||i.push([D.default.Warning,k.localize(12,null,n.path,w.path)])}}if(!A.valid(h.version))return i.push([D.default.Error,k.localize(13,null)]),i;const r=[];if(!$(c,v,h,p,r))for(const n of r)i.push([D.default.Error,n]);return i}function $(c,v,w,h,p){return h||typeof w.main>"u"&&typeof w.browser>"u"?!0:R(c,v,w.engines.vscode,p)}function y(c,v,w){return c==="*"||R(v,w,c)}function R(c,v,w,h=[]){const p=g(a(w));if(!p)return h.push(k.localize(14,null,w)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return h.push(k.localize(15,null,w)),!1}else if(!p.majorMustEqual)return h.push(k.localize(16,null,w)),!1;return b(c,v,p)?!0:(h.push(k.localize(17,null,c,w)),!1)}function m(c){if(!Array.isArray(c))return!1;for(let v=0,w=c.length;v<w;v++)if(typeof c[v]!="string")return!1;return!0}}),define(se[118],re([0,1,14,28]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=k;async function k(A,O,S){let u=S&&S.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const g=(await O.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$Ig)(g)?g:null}catch{u=null}if(!u){u=(0,D.$Jg)();try{await O.writeFile(A.serviceMachineIdResource,j.$ze.fromString(u))}catch{}}return S?.store("storage.serviceMachineId",u,-1,1),u}}),define(se[51],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class j{constructor(k,A=[],O=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$ki=j}),define(se[119],re([0,1,51]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=A,e.$ms=O;const D=[];var k;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(S,u,a){u instanceof j.$ki||(u=new j.$ki(u,[],!!a)),D.push([S,u])}function O(){return D}}),define(se[120],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class j{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$2q=j;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const S=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(O);S.outgoing.set(u.key,u),u.incoming.set(S.key,S)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const S of this.a.values())S.outgoing.delete(O),S.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let S=this.a.get(O);return S||(S=new j(O,A),this.a.set(O,S)),S}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,S]of this.a)A.push(`${O}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const S=new Set([A]),u=this.c(O,S);if(u)return u}}c(A,O){for(const[S,u]of A.outgoing){if(O.has(S))return[...O,S].join(" -> ");O.add(S);const a=this.c(u,O);if(a)return a;O.delete(S)}}}e.$3q=D}),define(se[29],re([0,1,3,11,10]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=A,e.$Vi=O,e.$Wi=u,e.$Xi=a,e.$Yi=g,e.$Zi=b,e.$1i=d,e.$2i=y,e.$3i=R,e.$4i=m,e.$Ti=(0,k.$ni)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function g(c,v){const w=Object.create(null);for(const h in c)b(w,h,c[h],v);return w}function b(c,v,w,h){const p=v.split("."),i=p.pop();let r=c;for(let t=0;t<p.length;t++){const n=p[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${v} as ${p.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=w}catch{h(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(r)}`)}function d(c,v){const w=v.split(".");$(c,w)}function $(c,v){const w=v.shift();if(v.length===0){delete c[w];return}if(Object.keys(c).indexOf(w)!==-1){const h=c[w];typeof h=="object"&&!Array.isArray(h)&&($(h,v),Object.keys(h).length===0&&delete c[w])}}function y(c,v,w){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const p=v.split("."),i=h(c,p);return typeof i>"u"?w:i}function R(c,v,w){Object.keys(v).forEach(h=>{h!=="__proto__"&&(h in c?j.$3f(c[h])&&j.$3f(v[h])?R(c[h],v[h],w):w&&(c[h]=v[h]):c[h]=v[h])})}function m(c){return c.replace(/[\[\]]/g,"")}}),define(se[121],re([0,1,12,30,112,10,92,9]),function(J,e,j,D,k,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=a,e.$mj=r,e.$nj=t,e.$Gj=Y;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",j.$j),u.set("isLinux",j.$k),u.set("isWindows",j.$i),u.set("isWeb",j.$o),u.set("isMacNative",j.$j&&!j.$o),u.set("isEdge",j.$H),u.set("isFirefox",j.$F),u.set("isChrome",j.$E),u.set("isSafari",j.$G);function a(F,f){if(u.get(F)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,f)}const g=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const d={regexParsingWithErrorRecovery:!0},$=(0,O.localize)(0,null),y=(0,O.localize)(1,null),R=(0,O.localize)(2,null),m=(0,O.localize)(3,null),c=(0,O.localize)(4,null),v=(0,O.localize)(5,null),w=(0,O.localize)(6,null),h=(0,O.localize)(7,null);class p{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new k.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const E=this.l();if(!this.E()){const L=this.D(),C=L.type===17?v:void 0;throw this.h.push({message:c,offset:L.offset,lexeme:k.$ij.getLexeme(L),additionalInfo:C}),p.c}return E}catch(E){if(E!==p.c)throw E;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const E=this.o();f.push(E)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const E=this.s();f.push(E)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const E=this.l();return this.A(1,m),E?.negate()}case 17:return this.z(),U.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const E=this.l();return this.A(1,m),E}case 17:{const E=f.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const G=C.lexeme,H=G.lastIndexOf("/"),ne=H===G.length-1?void 0:this.w(G.substring(H+1));let ce;try{ce=new RegExp(G.substring(1,H),ne)}catch{throw this.B("REGEX",C)}return ue.create(E,ce)}switch(C.type){case 10:case 19:{const G=[C.lexeme];this.z();let H=this.D(),ne=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ne++:C.lexeme.charCodeAt(fe)===41&&ne--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ne++:C.lexeme.charCodeAt(fe)===41&&ne--}if(ne<0)break;G.push(k.$ij.getLexeme(H)),this.z(),H=this.D()}const ce=G.join(""),he=ce.lastIndexOf("/"),pe=he===ce.length-1?void 0:this.w(ce.substring(he+1));let ye;try{ye=new RegExp(ce.substring(1,he),pe)}catch{throw this.B("REGEX",C)}return i.regex(E,ye)}case 18:{const G=C.lexeme;this.z();let H=null;if(!(0,D.$Ze)(G)){const ne=G.indexOf("/"),ce=G.lastIndexOf("/");if(ne!==ce&&ne>=0){const he=G.slice(ne+1,ce),pe=G[ce+1]==="i"?"i":"";try{H=new RegExp(he,pe)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return ue.create(E,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const C=this.u();return i.notIn(E,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return i.equals(E,C);switch(C){case"true":return i.has(E);case"false":return i.not(E);default:return i.equals(E,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return i.notEquals(E,C);switch(C){case"true":return i.not(E);case"false":return i.has(E);default:return i.notEquals(E,C)}}case 5:return this.z(),K.create(E,this.u());case 6:return this.z(),le.create(E,this.u());case 7:return this.z(),X.create(E,this.u());case 8:return this.z(),_.create(E,this.u());case 13:return this.z(),i.in(E,this.u());default:return i.has(E)}}case 20:throw this.h.push({message:w,offset:f.offset,lexeme:"",additionalInfo:h}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,E){if(this.C(f))return this.z();throw this.B(E,this.D())}B(f,E,L){const C=(0,O.localize)(8,null,f,k.$ij.getLexeme(E)),G=E.offset,H=k.$ij.getLexeme(E);return this.h.push({message:C,offset:G,lexeme:H,additionalInfo:L}),p.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=p;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,E){return P.create(f,E)}static notEquals(f,E){return N.create(f,E)}static regex(f,E){return ue.create(f,E)}static in(f,E){return I.create(f,E)}static notIn(f,E){return z.create(f,E)}static not(f){return U.create(f)}static and(...f){return Q.create(f,null,!0)}static or(...f){return q.create(f,null,!0)}static greater(f,E){return X.create(f,E)}static greaterEquals(f,E){return _.create(f,E)}static smaller(f,E){return K.create(f,E)}static smallerEquals(f,E){return le.create(f,E)}static{this.c=new p({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$lj=i;function r(F){const f=new p({regexParsingWithErrorRecovery:!1});return F.map(E=>(f.parse(E),f.lexingErrors.length>0?f.lexingErrors.map(L=>({errorMessage:L.additionalInfo?(0,O.localize)(9,null,L.additionalInfo):(0,O.localize)(10,null),offset:L.offset,length:L.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(L=>({errorMessage:L.additionalInfo?`${L.message}. ${L.additionalInfo}`:L.message,offset:L.offset,length:L.lexeme.length})):[]))}function t(F,f){const E=F?F.substituteConstants():void 0,L=f?f.substituteConstants():void 0;return!E&&!L?!0:!E||!L?!1:E.equals(L)}function n(F,f){return F.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$oj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$pj=o;class l{static create(f,E=null){const L=u.get(f);return typeof L=="boolean"?L?o.INSTANCE:s.INSTANCE:new l(f,E)}constructor(f,E){this.key=f,this.c=E,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:W(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$qj=l;class P{static create(f,E,L=null){if(typeof E=="boolean")return E?l.create(f,L):U.create(f,L);const C=u.get(f);return typeof C=="boolean"?E===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new P(f,E,L)}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const E=f?"true":"false";return this.d===E?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$rj=P;class I{static create(f,E){return new I(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const E=f.getValue(this.f),L=f.getValue(this.d);return Array.isArray(E)?E.includes(L):typeof L=="string"&&typeof E=="object"&&E!==null?g.call(E,L):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=z.create(this.d,this.f)),this.c}}e.$sj=I;class z{static create(f,E){return new z(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=11,this.c=I.create(f,E)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=z;class N{static create(f,E,L=null){if(typeof E=="boolean")return E?U.create(f,L):l.create(f,L);const C=u.get(f);return typeof C=="boolean"?E===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new N(f,E,L)}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const E=f?"true":"false";return this.d===E?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$uj=N;class U{static create(f,E=null){const L=u.get(f);return typeof L=="boolean"?L?s.INSTANCE:o.INSTANCE:new U(f,E)}constructor(f,E){this.c=f,this.d=E,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:W(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$vj=U;function V(F,f){if(typeof F=="string"){const E=parseFloat(F);isNaN(E)||(F=E)}return typeof F=="string"||typeof F=="number"?f(F):s.INSTANCE}class X{static create(f,E,L=null){return V(E,C=>new X(f,C,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$wj=X;class _{static create(f,E,L=null){return V(E,C=>new _(f,C,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$xj=_;class K{static create(f,E,L=null){return V(E,C=>new K(f,C,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$yj=K;class le{static create(f,E,L=null){return V(E,C=>new le(f,C,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$zj=le;class ue{static create(f,E){return new ue(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const E=this.f?this.f.source:"",L=f.f?f.f.source:"";return E<L?-1:E>L?1:0}equals(f){if(f.type===this.type){const E=this.f?this.f.source:"",L=f.f?f.f.source:"";return this.d===f.d&&E===L}return!1}substituteConstants(){return this}evaluate(f){const E=f.getValue(this.d);return this.f?this.f.test(E):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Aj=ue;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$Bj=ae;function B(F){let f=null;for(let E=0,L=F.length;E<L;E++){const C=F[E].substituteConstants();if(F[E]!==C&&f===null){f=[];for(let G=0;G<E;G++)f[G]=F[G]}f!==null&&(f[E]=C)}return f===null?F:f}class Q{static create(f,E,L){return Q.d(f,E,L)}constructor(f,E){this.expr=f,this.c=E,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let E=0,L=this.expr.length;E<L;E++){const C=n(this.expr[E],f.expr[E]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let E=0,L=this.expr.length;E<L;E++)if(!this.expr[E].equals(f.expr[E]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:Q.create(f,this.c,!1)}evaluate(f){for(let E=0,L=this.expr.length;E<L;E++)if(!this.expr[E].evaluate(f))return!1;return!0}static d(f,E,L){const C=[];let G=!1;for(const H of f)if(H){if(H.type===1){G=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&G)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const ne=C.pop(),ce=C.length===0,he=q.create(H.expr.map(pe=>Q.create([pe,ne],null,L)),null,ce);he&&(C.push(he),C.sort(n))}if(C.length===1)return C[0];if(L){for(let H=0;H<C.length;H++)for(let ne=H+1;ne<C.length;ne++)if(C[H].negate().equals(C[ne]))return s.INSTANCE;if(C.length===1)return C[0]}return new Q(C,E)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const E of this.expr)f.push(...E.keys());return f}map(f){return new Q(this.expr.map(E=>E.map(f)),null)}negate(){if(!this.c){const f=[];for(const E of this.expr)f.push(E.negate());this.c=q.create(f,this,!0)}return this.c}}e.$Cj=Q;class q{static create(f,E,L){return q.d(f,E,L)}constructor(f,E){this.expr=f,this.c=E,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let E=0,L=this.expr.length;E<L;E++){const C=n(this.expr[E],f.expr[E]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let E=0,L=this.expr.length;E<L;E++)if(!this.expr[E].equals(f.expr[E]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:q.create(f,this.c,!1)}evaluate(f){for(let E=0,L=this.expr.length;E<L;E++)if(this.expr[E].evaluate(f))return!0;return!1}static d(f,E,L){let C=[],G=!1;if(f){for(let H=0,ne=f.length;H<ne;H++){const ce=f[H];if(ce){if(ce.type===0){G=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){C=C.concat(ce.expr);continue}C.push(ce)}}if(C.length===0&&G)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(L){for(let H=0;H<C.length;H++)for(let ne=H+1;ne<C.length;ne++)if(C[H].negate().equals(C[ne]))return o.INSTANCE;if(C.length===1)return C[0]}return new q(C,E)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const E of this.expr)f.push(...E.keys());return f}map(f){return new q(this.expr.map(E=>E.map(f)),null)}negate(){if(!this.c){const f=[];for(const E of this.expr)f.push(E.negate());for(;f.length>1;){const E=f.shift(),L=f.shift(),C=[];for(const G of T(E))for(const H of T(L))C.push(Q.create([G,H],null,!1));f.unshift(q.create(C,null,!1))}this.c=q.create(f,this,!0)}return this.c}}e.$Dj=q;class M extends l{static{this.d=[]}static all(){return M.d.values()}constructor(f,E,L){super(f,null),this.f=E,typeof L=="object"?M.d.push({...L,key:f}):L!==!0&&M.d.push({key:f,description:L,type:E!=null?typeof E:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return P.create(this.key,f)}notEqualsTo(f){return N.create(this.key,f)}}e.$Ej=M,e.$Fj=(0,A.$ni)("contextKeyService");function W(F,f){return F<f?-1:F>f?1:0}function Z(F,f,E,L){return F<E?-1:F>E?1:f<L?-1:f>L?1:0}function Y(F,f){if(F.type===0||f.type===1)return!0;if(F.type===9)return f.type===9?te(F.expr,f.expr):!1;if(f.type===9){for(const E of f.expr)if(Y(F,E))return!0;return!1}if(F.type===6){if(f.type===6)return te(f.expr,F.expr);for(const E of F.expr)if(Y(E,f))return!0;return!1}return F.equals(f)}function te(F,f){let E=0,L=0;for(;E<F.length&&L<f.length;){const C=F[E].cmp(f[L]);if(C<0)return!1;C===0&&E++,L++}return E===F.length}function T(F){return F.type===9?F.expr:[F]}}),define(se[61],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=void 0,e.$Bo=(0,j.$ni)("downloadService")}),define(se[18],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,j.$ni)("environmentService"),e.$vi=(0,j.$oi)(e.$ui)}),define(se[21],re([0,1,95,10]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=k,e.$Ro=A,e.$So=O,e.$To=S,e.$Uo=u,e.$Vo=a,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function k(w){switch(w){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(w){switch(w){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(w,h){switch(w){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function S(w,h){return h==="web"&&!w.includes("web")}function u(w,h,p){return S(h,p)?!1:w==="undefined"||w==="universal"?!0:w==="unknown"?!1:w===p}function a(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}var g;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=10]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var b;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var d;(function(w){w.Install="install",w.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var $;(function(w){w[w.None=1]="None",w[w.Install=2]="Install",w[w.Update=3]="Update",w[w.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Wo=(0,D.$ni)("extensionGalleryService");var y;(function(w){w.Unsupported="Unsupported",w.Deprecated="Deprecated",w.Malicious="Malicious",w.Incompatible="Incompatible",w.IncompatibleTargetPlatform="IncompatibleTargetPlatform",w.ReleaseVersionNotFound="ReleaseVersionNotFound",w.Invalid="Invalid",w.Download="Download",w.DownloadSignature="DownloadSignature",w.UpdateMetadata="UpdateMetadata",w.Extract="Extract",w.Scanning="Scanning",w.Delete="Delete",w.Rename="Rename",w.CorruptZip="CorruptZip",w.IncompleteZip="IncompleteZip",w.Signature="Signature",w.NotAllowed="NotAllowed",w.Gallery="Gallery",w.Unknown="Unknown",w.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var R;(function(w){w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(R||(e.ExtensionSignaturetErrorCode=R={}));class m extends Error{constructor(h,p){super(h),this.code=p,this.name=p}}e.$Xo=m;var c;(function(w){w.Timeout="Timeout",w.Cancelled="Cancelled",w.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class v extends Error{constructor(h,p){super(h),this.code=p,this.name=p}}e.$Yo=v,e.$Zo=(0,D.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,D.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,D.$ni)("IExtensionTipsService"),e.$5o=(0,j.localize2)(0,"Extensions"),e.$6o=(0,j.localize2)(1,"Preferences")}),define(se[62],re([0,1,14,9,103,13]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=O;async function O(g,b,d,$,y,R){let m;try{await S(g,b,d,$,y,R)}catch(c){m=c}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}async function S(g,b,d,$,y,R){u(R);const m=await g.open(b,{create:!1});try{u(R);let c=0,v=0,w=y&&typeof y.length=="number"?y.length:void 0,h=j.$ze.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),p=y&&typeof y.position=="number"?y.position:0,i=0;do v=await g.read(m,p,h.buffer,i,h.byteLength-i),p+=v,i+=v,c+=v,typeof w=="number"&&(w-=v),i===h.byteLength&&(await d.write($(h)),h=j.$ze.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),i=0);while(v>0&&(typeof w!="number"||w>0)&&u(R)&&a(c,y));if(i>0){let r=i;typeof w=="number"&&(r=Math.min(i,w)),d.write($(h.slice(0,r)))}}catch(c){throw(0,A.$8k)(c)}finally{await g.close(m)}}function u(g){if(g.isCancellationRequested)throw(0,D.$6)();return!0}function a(g,b){if(typeof b?.limits?.size=="number"&&g>b.limits.size)throw(0,A.$7k)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[122],re([0,1,60,2,52,5,11,8]),function(J,e,j,D,k,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class u extends D.$Uc{constructor(){super(),this.a=this.B(new A.$_d),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$_d),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$_d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new D.$4c),this.m=new Set,this.n=5007,this.r=new S.$Kh,this.B(this.f(g=>this.s(g)))}s(g){this.t(g)&&this.w(g)}t(g){return(0,k.$Aq)(g)}async watch(g){this.r.isSettled||this.r.complete(),this.r=new S.$Kh;try{this.h.clear(),this.g.clear();for(const b of g)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))])}isSuspended(g){return typeof g.correlationId!="number"?!1:this.m.has(g.correlationId)?"polling":this.j.has(g.correlationId)}async w(g){if(this.j.has(g.correlationId))return;const b=new D.$Tc;this.j.set(g.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(g,b),this.u())}y(g){this.j.deleteAndDispose(g.correlationId),this.m.delete(g.correlationId),this.u()}z(g,b){this.C(g,b)?(this.M(`reusing an existing recursive watcher to monitor ${g.path}`),this.m.delete(g.correlationId)):(this.D(g,b),this.m.add(g.correlationId))}C(g,b){const d=this.L?.subscribe(g.path,($,y)=>{b.isDisposed||($?this.z(g,b):y?.type===1&&this.F(g))});return d?(b.add(d),!0):!1}D(g,b){let d=!1;const $=(y,R)=>{if(b.isDisposed)return;const m=this.G(y),c=this.G(R),v=d;d=m,!m&&(c||v)&&this.F(g)};this.M(`starting fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,j.watchFile)(g.path,{persistent:!1,interval:this.n},$)}catch(y){this.N(`fs.watchFile() failed with error ${y} on path ${g.path} (correlationId: ${g.correlationId})`)}b.add((0,D.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,j.unwatchFile)(g.path,$)}catch(y){this.N(`fs.unwatchFile() failed with error ${y} on path ${g.path} (correlationId: ${g.correlationId})`)}}))}F(g){this.M(`detected ${g.path} exists again, resuming watcher (correlationId: ${g.correlationId})`);const b={resource:O.URI.file(g.path),type:1,cId:g.correlationId};this.a.fire([b]),this.H(b,g),this.y(g)}G(g){return g.ctimeMs===0&&g.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(g,b){const d=` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`;this.M(typeof b.correlationId=="number"?`${d} (correlationId: ${b.correlationId})`:d)}I(g){return`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`}}e.$Rq=u}),define(se[123],re([0,1,5,171,122,12,172,124]),function(J,e,j,D,k,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class u extends k.$Rq{constructor(g){super(),this.L=g,this.onDidError=j.Event.None,this.watchers=new Set,this.O=!1}async J(g){g=this.W(g);const b=[],d=new Set(Array.from(this.watchers));for(const $ of g){const y=this.R($);y&&(0,D.$lk)(y.request.excludes,$.excludes)&&(0,D.$lk)(y.request.includes,$.includes)?d.delete(y):b.push($)}b.length&&this.M(`Request to start watching: ${b.map($=>this.I($)).join(",")}`),d.size&&this.M(`Request to stop watching: ${Array.from(d).map($=>this.I($.request)).join(",")}`);for(const $ of d)this.U($);for(const $ of b)this.S($)}R(g){for(const b of this.watchers)if(typeof g.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===g.correlationId)return b}else if((0,S.$mg)(b.request.path,g.path,!A.$k))return b}S(g){const b=new O.$Wq(g,this.L,$=>this.a.fire($),()=>this.c.fire(g),$=>this.b.fire($),this.O),d={request:g,instance:b};this.watchers.add(d)}async stop(){await super.stop();for(const g of this.watchers)this.U(g)}U(g){this.M("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}W(g){const b=new Map;for(const d of g){const $=A.$k?d.path:d.path.toLowerCase();let y=b.get(d.correlationId);y||(y=new Map,b.set(d.correlationId,y)),y.has($)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(d)}`),y.set($,d)}return Array.from(b.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(g){this.O=g;for(const b of this.watchers)b.instance.setVerboseLogging(g)}M(g,b){this.O&&this.b.fire({type:"trace",message:this.Z(g,b)})}N(g){this.b.fire({type:"warn",message:this.Z(g)})}Z(g,b){return b?`[File Watcher (node.js)] ${g} (${this.I(b.request)})`:`[File Watcher (node.js)] ${g}`}}e.$Yq=u}),define(se[125],re([0,1,52,123]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class k extends j.$Dq{constructor(O,S,u){super(O,S,u),this.s()}r(O){return O.add(new D.$Yq(void 0))}}e.$Zq=k}),define(se[126],re([0,1,15,58,88,52]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class O extends A.$Eq{constructor(u,a,g){super(u,a,g),this.s()}r(u){const a=u.add(new k.$Pq(j.$Hg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:g,signal:b})=>this.t(`terminated by itself with code ${g}, signal: ${b}`))),D.ProxyChannel.toService((0,D.$7h)(a.getChannel("watcher")))}}e.$Qq=O}),define(se[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class j{constructor(...k){this.a=new Map;for(const[A,O]of k)this.set(A,O)}set(k,A){const O=this.a.get(k);return this.a.set(k,A),O}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$li=j}),define(se[127],re([0,1,8,9,2,51,120,10,63,173]),function(J,e,j,D,k,A,O,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const g=!1;class b extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new u.$li,c=!1,v,w=g){this.i=m,this.j=c,this.k=v,this.l=w,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(S.$mi,this),this._globalGraph=w?v?._globalGraph??new O.$3q(h=>h):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,k.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m){this.m();const c=new class extends d{dispose(){this.h.delete(c),super.dispose()}}(m,this.j,this,this.l);return this.h.add(c),c}invokeFunction(m,...c){this.m();const v=y.traceInvocation(this.l,m);let w=!1;try{return m({get:p=>{if(w)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(p,v);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...c)}finally{w=!0,v.stop()}}createInstance(m,...c){this.m();let v,w;return m instanceof A.$ki?(v=y.traceCreation(this.l,m.ctor),w=this.o(m.ctor,m.staticArguments.concat(c),v)):(v=y.traceCreation(this.l,m),w=this.o(m,c,v)),v.stop(),w}o(m,c=[],v){const w=S._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),h=[];for(const i of w){const r=this.s(i.id,v);r||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const p=w.length>0?w[0].index:c.length;if(c.length!==p){console.trace(`[createInstance] First service dependency of ${m.name} at position ${p+1} conflicts with ${c.length} static arguments`);const i=p-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,p)}return Reflect.construct(m,c.concat(h))}q(m,c){if(this.i.get(m)instanceof A.$ki)this.i.set(m,c);else if(this.k)this.k.q(m,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const c=this.i.get(m);return!c&&this.k?this.k.r(m):c}s(m,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const v=this.r(m);return v instanceof A.$ki?this.u(m,v,c.branch(m,!0)):(c.branch(m,!1),v)}u(m,c,v){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,c,v)}finally{this.t.delete(m)}}v(m,c,v){const w=new O.$3q(i=>i.id.toString());let h=0;const p=[{id:m,desc:c,_trace:v}];for(;p.length;){const i=p.pop();if(w.lookupOrInsertNode(i),h++>1e3)throw new b(w);for(const r of S._util.getServiceDependencies(i.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof A.$ki){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};w.insertEdge(i,n),p.push(n)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:r}of i){if(this.r(r.id)instanceof A.$ki){const n=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,n)}w.removeNode(r)}}return this.r(m)}w(m,c,v=[],w,h){if(this.i.get(m)instanceof A.$ki)return this.x(m,c,v,w,h,this.g);if(this.k)return this.k.w(m,c,v,w,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(m,c,v=[],w,h,p){if(w){const i=new d(void 0,this.j,this,this.l);i.c=String(m);const r=new Map,t=new j.$Gh(()=>{const n=i.o(c,v,h);for(const[s,o]of r){const l=n[s];if(typeof l=="function")for(const P of o)P.disposable=l.apply(n,P.listener)}return r.clear(),p.add(n),n});return new Proxy(Object.create(null),{get(n,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let P=r.get(s);return P||(P=new a.$5c,r.set(s,P)),(z,N,U)=>{if(t.isInitialized)return t.value[s](z,N,U);{const V={listener:[z,N,U],disposable:void 0},X=P.push(V);return(0,k.$Sc)(()=>{X(),V.disposable?.dispose()})}}}if(s in n)return n[s];const o=t.value;let l=o[s];return typeof l!="function"||(l=l.bind(o),n[s]=l),l},set(n,s,o){return t.value[s]=o,!0},getPrototypeOf(n){return c.prototype}})}else{const i=this.o(c,v,h);return p.add(i),i}}y(m,c){if(c&&console.warn(m),this.j)throw new Error(m)}}e.$4q=d;var $;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})($||($={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,c){return m?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(m,c){return m?new y(1,c.name):y.c}static{this.f=0}constructor(m,c){this.type=m,this.name=c,this.g=Date.now(),this.h=[]}branch(m,c){const v=new y(3,m.toString());return this.h.push([m,c,v]),v}stop(){const m=Date.now()-this.g;y.f+=m;let c=!1;function v(h,p){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of p.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=v(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(m>2||c)&&y.all.add(w.join(`
`))}}e.$5q=y});var oe=this&&this.__param||function(J,e){return function(j,D){e(j,D,J)}};define(se[64],re([0,1,20,2,12,105,21,10]),function(J,e,j,D,k,A,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=void 0,e.$Fr=u;function u(g){return g.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Gr=(0,S.$ni)("languagePackService");let a=class extends D.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new j.$je;setTimeout(()=>b.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const y=d.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(m=>m.startsWith("lp-"))).map(R=>{const m=R.properties.localizedLanguages?.[0],c=u(R);return{...this.f(c,m,R),extensionId:R.identifier.id,galleryExtension:R}});return y.push(this.f("en","English")),y}f(b,d,$){const y=d??b;let R;if(y!==b&&(R=`(${b})`),b.toLowerCase()===k.$w.toLowerCase()&&(R??="",R+=(0,A.localize)(0,null)),$?.installCount){R??="";const m=$.installCount;let c;m>1e6?c=`${Math.floor(m/1e5)/10}M`:m>1e3?c=`${Math.floor(m/1e3)}K`:c=String(m),R+=` $(cloud-download) ${c}`}return{id:b,label:y,description:R}}};e.$Hr=a,e.$Hr=a=$e([oe(0,O.$Wo)],a)}),define(se[6],re([0,1,106,34,5,43,2,31,12,17,3,11,121,10]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=R,e.log=c,e.$8j=l,e.$9j=P,e.$0j=I,e.$$j=z,e.$Tj=(0,$.$ni)("logService"),e.$Uj=(0,$.$ni)("loggerService");function y(){return new Date().toISOString()}function R(N){return(0,g.$5f)(N)}var m;(function(N){N[N.Off=0]="Off",N[N.Trace=1]="Trace",N[N.Debug=2]="Debug",N[N.Info=3]="Info",N[N.Warning=4]="Warning",N[N.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Wj=m.Info;function c(N,U,V){switch(U){case m.Trace:N.trace(V);break;case m.Debug:N.debug(V);break;case m.Info:N.info(V);break;case m.Warning:N.warn(V);break;case m.Error:N.error(V);break;case m.Off:break;default:throw new Error(`Invalid log level ${U}`)}}function v(N,U=!1){let V="";for(let X=0;X<N.length;X++){let _=N[X];if(_ instanceof Error&&(_=(0,D.$$i)(_,U)),typeof _=="object")try{_=JSON.stringify(_)}catch{}V+=(X>0?" ":"")+_}return V}class w extends O.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new k.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(U){this.b!==U&&(this.b=U,this.c.fire(this.b))}getLevel(){return this.b}f(U){return this.b!==m.Off&&this.b<=U}}e.$Yj=w;class h extends w{constructor(U){super(),this.h=U}f(U){return this.h||super.f(U)}trace(U,...V){this.f(m.Trace)&&this.g(m.Trace,v([U,...V],!0))}debug(U,...V){this.f(m.Debug)&&this.g(m.Debug,v([U,...V]))}info(U,...V){this.f(m.Info)&&this.g(m.Info,v([U,...V]))}warn(U,...V){this.f(m.Warning)&&this.g(m.Warning,v([U,...V]))}error(U,...V){if(this.f(m.Error))if(U instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=U.stack,this.g(m.Error,v(X))}else this.g(m.Error,v([U,...V]))}flush(){}}e.$Zj=h;class p extends w{constructor(U=e.$Wj){super(),this.setLevel(U),this.g=!u.$i}trace(U,...V){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,U,...V):console.log(`[main ${y()}]`,U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,U,...V):console.log(`[main ${y()}]`,U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,U,...V):console.log(`[main ${y()}]`,U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,U,...V):console.warn(`[main ${y()}]`,U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,U,...V):console.error(`[main ${y()}]`,U,...V))}flush(){}}e.$1j=p;class i extends w{constructor(U=e.$Wj,V=!0){super(),this.g=V,this.setLevel(U)}trace(U,...V){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",U,...V):console.log(U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",U,...V):console.log(U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",U,...V):console.log(U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",U,...V):console.log(U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",U,...V):console.error(U,...V))}flush(){}}e.$2j=i;class r extends w{constructor(U,V=e.$Wj){super(),this.g=U,this.setLevel(V)}trace(U,...V){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(U),...V])}debug(U,...V){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(U),...V])}info(U,...V){this.f(m.Info)&&this.g.log(m.Info,[this.h(U),...V])}warn(U,...V){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(U),...V])}error(U,...V){this.f(m.Error)&&this.g.log(m.Error,[this.h(U),...V])}h(U){return typeof U=="string"?U:(0,D.$$i)(U,this.f(m.Trace))}flush(){}}e.$3j=r;class t extends w{constructor(U){super(),this.g=U,U.length&&this.setLevel(U[0].getLevel())}setLevel(U){for(const V of this.g)V.setLevel(U);super.setLevel(U)}trace(U,...V){for(const X of this.g)X.trace(U,...V)}debug(U,...V){for(const X of this.g)X.debug(U,...V)}info(U,...V){for(const X of this.g)X.info(U,...V)}warn(U,...V){for(const X of this.g)X.warn(U,...V)}error(U,...V){for(const X of this.g)X.error(U,...V)}flush(){for(const U of this.g)U.flush()}dispose(){for(const U of this.g)U.dispose();super.dispose()}}e.$4j=t;class n extends O.$Uc{constructor(U,V,X){if(super(),this.h=U,this.j=V,this.b=new S.$Bc,this.c=this.B(new k.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$_d),this.onDidChangeVisibility=this.g.event,X)for(const _ of X)this.b.set(_.resource,{logger:void 0,info:_})}m(U){return(0,g.$1f)(U)?[...this.b.values()].find(V=>V.info.id===U):this.b.get(U)}getLogger(U){return this.m(U)?.logger}createLogger(U,V){const X=this.n(U),_=(0,g.$1f)(U)?U:V?.id??(0,A.$bj)(X.toString()).toString(16);let K=this.b.get(X)?.logger;const le=V?.logLevel==="always"?m.Trace:V?.logLevel;K||(K=this.s(X,le??this.getLogLevel(X)??this.h,{...V,id:_}));const ue={logger:K,info:{resource:X,id:_,logLevel:le,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(ue.info),this.b.set(X,ue),K}n(U){return(0,g.$1f)(U)?(0,a.$1g)(this.j,`${U}.log`):U}setLogLevel(U,V){if(b.URI.isUri(U)){const X=U,_=V,K=this.b.get(X);K&&_!==K.info.logLevel&&(K.info.logLevel=_===this.h?void 0:_,K.logger?.setLevel(_),this.b.set(K.info.resource,K),this.f.fire([X,_]))}else{this.h=U;for(const[X,_]of this.b.entries())this.b.get(X)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(U,V){const X=this.m(U);X&&V!==!X.info.hidden&&(X.info.hidden=!V,this.b.set(X.info.resource,X),this.g.fire([X.info.resource,V]))}getLogLevel(U){let V;return U&&(V=this.b.get(U)?.info.logLevel),V??this.h}registerLogger(U){const V=this.b.get(U.resource);V?V.info.hidden!==U.hidden&&this.setVisibility(U.resource,!U.hidden):(this.b.set(U.resource,{info:U,logger:void 0}),this.c.fire({added:[U],removed:[]}))}deregisterLogger(U){const V=this.b.get(U);V&&(V.logger&&V.logger.dispose(),this.b.delete(U),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const U of this.b.values())yield U.info}getRegisteredLogger(U){return this.b.get(U)?.info}dispose(){this.b.forEach(U=>U.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=n;class s{constructor(){this.onDidChangeLogLevel=new k.$_d().event}setLevel(U){}getLevel(){return m.Info}trace(U,...V){}debug(U,...V){}info(U,...V){}warn(U,...V){}error(U,...V){}critical(U,...V){}dispose(){}flush(){}}e.$6j=s;class o extends s{}e.$7j=o;function l(N){if(N.verbose)return m.Trace;if(typeof N.logLevel=="string"){const U=z(N.logLevel.toLowerCase());if(U!==void 0)return U}return e.$Wj}function P(N){switch(N){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function I(N){switch(N){case m.Trace:return{original:"Trace",value:j.localize(0,null)};case m.Debug:return{original:"Debug",value:j.localize(1,null)};case m.Info:return{original:"Info",value:j.localize(2,null)};case m.Warning:return{original:"Warning",value:j.localize(3,null)};case m.Error:return{original:"Error",value:j.localize(4,null)};case m.Off:return{original:"Off",value:j.localize(5,null)}}}function z(N){switch(N){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$_j=new d.$Ej("logLevel",P(m.Info))}),define(se[128],re([0,1,19,8,9,5,2,16,52,6]),function(J,e,j,D,k,A,O,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class g extends O.$Uc{constructor(d,$){super(),this.a=d,this.b=$,this.c=this.B(new A.$_d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$_d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$lh(0)),this.w=[],this.y=this.B(new D.$lh(0))}watch(d,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(d,$):this.z(d,$)}n(d,$){const y={path:this.I(d),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},R=(0,j.$Ub)(this.j,y);return this.r(),(0,O.$Sc)(()=>{R(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,k.$1)(d))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,u.$Fq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const $ of this.j)(0,u.$Bq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const $ of this.j)(0,u.$Bq)($)&&d.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,$){const y={path:this.I(d),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},R=(0,j.$Ub)(this.w,y);return this.C(),(0,O.$Sc)(()=>{R(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,k.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$Fq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.H(d)}H(d){this.a[d.type](d.message)}I(d){return(0,S.$ic)(d.fsPath)}}e.$Jq=g}),define(se[129],re([0,1,19,8,14,20,5,43,65,2,48,15,130,17,46,102,13,62,6,9]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let p=class extends a.$Uc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new O.$_d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$_d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$_d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$_d),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$_d),this.Y=this.B(new O.$_d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$_d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$wh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new m.$al(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,$.$5g)(r))throw new m.$cl((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new w.$bb;throw n.message=(0,R.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,m.$Zk)(t)||(0,m.$Wk)(t)||(0,m.$1k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,m.$Zk)(t)||(0,m.$Wk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,m.$0k)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.$cl((0,R.localize)(2,null,this.sb(r)),1):(0,m.$8k)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,I=await n.stat(r);let z;return this.t(n,r,I,void 0,!!P,(N,U)=>(z||(z=g.$ti.forUris(()=>!s),z.set(r,!0),o&&z.fill(!0,o)),z.get(N.resource)||z.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&l?U===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:P}=this.R(r),I={resource:t,name:P.basename(t),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.$nl)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const z=await r.readdir(t),N=await D.Promises.settled(z.map(async([U,V])=>{try{const X=P.joinPath(t,U),_=o?await r.stat(X):{type:V};return await this.t(r,X,_,z.length,o,l)}catch(X){return this.b.trace(X),null}}));I.children=(0,j.$Hb)(N)}catch(z){this.b.trace(z),I.children=[]}return I}return I}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new m.$cl((0,R.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$ze.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new m.$_k(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,m.$3k)(s)&&!l?.atomic){const P=s.enforceAtomicWriteFile?.(r);P&&(l={...n,atomic:P})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,m.$Wk)(s)&&!(t instanceof k.$ze))if((0,y.$le)(t)){const z=await(0,y.$se)(t,3);z.ended?I=k.$ze.concat(z.buffer):I=z}else I=(0,y.$pe)(t,z=>k.$ze.concat(z),3);else I=t;!(0,m.$Zk)(s)||(0,m.$Wk)(s)&&I instanceof k.$ze||(0,m.$Wk)(s)&&(0,m.$3k)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof k.$ze?(0,k.$Ke)(I):I),this.r.fire(new m.$_k(r,4))}catch(P){throw new m.$cl((0,R.localize)(4,null,this.sb(r),(0,m.$8k)(P).toString()),(0,m.$$k)(P),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(t)));if(s)throw new Error((0,R.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$cl((0,R.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.$ml&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,m.$nl)({mtime:n.mtime,size:l.size}))throw new m.$cl((0,R.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const P=await this.C(r,t,n,s);o(P)}catch(P){l(P)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Le)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new A.$je(s);let l=n;(0,m.$2k)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const P=this.J(t,l).then(z=>z,z=>{throw o.dispose(!0),z});let I;try{return typeof l?.etag=="string"&&l.etag!==m.$ml&&await P,l?.atomic&&(0,m.$2k)(r)||!((0,m.$Zk)(r)||(0,m.$1k)(r))||(0,m.$Wk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,m.$1k)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await P,value:I}}catch(z){throw I&&await(0,y.$qe)(I),this.F(z,t,l)}}F(r,t,n){const s=(0,R.localize)(11,null,this.sb(t),(0,m.$8k)(r).toString());return r instanceof m.$el?new m.$el(s,r.stat,n):r instanceof m.$dl?new m.$dl(s,r.fileOperationResult,r.size,r.options):new m.$cl(s,(0,m.$$k)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,y.$we)(o,{data:l=>l instanceof k.$ze?l:k.$ze.wrap(l),error:l=>this.F(l,t,s)},l=>k.$ze.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,k.$Pe)();return(0,c.$yq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,y.$ne)(o=>k.$ze.concat(o));return(async()=>{try{let o;n?.atomic&&(0,m.$2k)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(k.$ze.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new m.$cl((0,R.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$ml&&t.etag===n.etag)throw new m.$el((0,R.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new m.$dl((0,R.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$_k(r,l==="move"?2:3,P)),P}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$_k(r,l==="copy"?3:2,P)),P}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:P,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(P&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,m.$Xk)(r))await r.copy(t,s,{overwrite:l});else{const z=await this.resolve(t);z.isDirectory?await this.P(r,z,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,m.$Zk)(r)&&(0,m.$Zk)(n))return this.jb(r,t,n,s);if((0,m.$Zk)(r)&&(0,m.$Wk)(n))return this.pb(r,t,n,s);if((0,m.$Wk)(r)&&(0,m.$Zk)(n))return this.nb(r,t,n,s);if((0,m.$Wk)(r)&&(0,m.$Wk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let P=!1;if(r===n){const{providerExtUri:z,isPathCaseSensitive:N}=this.R(r);if(N||(P=z.isEqual(t,s)),P&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(t),this.sb(s)));if(!P&&z.isEqualOrParent(s,t))throw new Error((0,R.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!P){if(!l)throw new m.$cl((0,R.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:z}=this.R(r);if(z.isEqualOrParent(t,s))throw new Error((0,R.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:P}}R(r){const t=this.S(r);return{providerExtUri:t?$.$Qg:$.$Sg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$_k(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&m.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(t)));break}catch(o){if((0,m.$0k)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,m.$0k)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new m.$cl((0,R.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,m.$4k)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,P=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:P}),this.r.fire(new m.$_k(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,m.$Yk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,m.$Xk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Tc;let s=!1,o=()=>{s=!0};n.add((0,a.$Sc)(()=>o())),(async()=>{try{const P=await this.bb(r,t);s?(0,a.$Pc)(P):o=()=>(0,a.$Pc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=n.add(new O.$_d);return n.add(this.X.event(z=>{z.correlates(l)&&P.fire(z)})),{onDidChange:P.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,S.$bj)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,y.$le)(s)||(0,y.$me)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,m.$8k)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,y.$me)(n)){if(n.buffer.length>0){const l=k.$ze.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,P)=>{(0,y.$re)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(z){return P(z)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>P(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let P=0;for(;P<s;){const I=await r.write(t,o+P,n.buffer,l+P,s-P);P+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof k.$ze?o=s:(0,y.$le)(s)?o=await(0,k.$Le)(s):(0,y.$me)(s)?o=await(0,k.$Me)(s):o=(0,k.$Je)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const P=k.$ze.alloc(this.a);let I=0,z=0,N=0;do N=await r.read(o,I,P.buffer,z,P.byteLength-z),await this.gb(n,l,P,N,I,z),I+=N,z+=N,z===P.byteLength&&(z=0);while(N>0)}catch(P){throw(0,m.$8k)(P)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,k.$ze.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$8k)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,k.$Le)(this.H(r,t,A.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new m.$cl((0,R.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$cl((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$zq=p,e.$zq=p=h=$e([oe(0,v.$Tj)],p)}),define(se[131],re([0,1,60,174,8,31,14,5,124,2,16,12,17,46,25,104,13,62,128,34,126,125]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,(()=>{try{(0,D.gracefulify)(j)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.$$i)(r)}`)}})();class i extends v.$Jq{static{this.J=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=S.Event.None,this.O=new A.$Bc(s=>d.$Rg.getComparisonKey(s)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,b.$k&&(this.L|=1024)),this.L}async stat(t){try{const{stat:n,symbolicLink:s}=await y.SymlinkSupport.stat(this.I(t));return{type:this.N(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:m.FilePermission.Locked}}catch(n){throw this.gb(n)}}async M(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await y.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$1g)(t,o.name))).type:l=this.N(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.gb(n)}}N(t,n){let s;return n?.dangling?s=m.FileType.Unknown:t.isFile()?s=m.FileType.File:t.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,n&&(s|=m.FileType.SymbolicLink),s}async P(t){const n=this.I(t);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.O.get(t);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new k.$mh;return this.O.set(t,o),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.O.get(t)===o&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.O.delete(t)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.P(t));const o=this.I(t);return await y.Promises.readFile(o)}catch(o){throw this.gb(o)}finally{s?.dispose()}}Q(t){i.J&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,$.$ne)(l=>O.$ze.concat(l.map(P=>O.$ze.wrap(P))).buffer);return(0,c.$yq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.R(t)?this.S(t,(0,d.$1g)((0,d.$Zg)(t),`${(0,d.$Xg)(t)}${s.atomic.postfix}`),n,s):this.U(t,n,s)}async R(t){try{const n=this.I(t),{symbolicLink:s}=await y.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async S(t,n,s,o){const l=new a.$Tc;try{l.add(await this.P(t)),l.add(await this.P(n)),await this.U(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(P){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async U(t,n,s,o){let l;try{const P=this.I(t);if(!s.create||!s.overwrite){if(await y.Promises.exists(P)){if(!s.overwrite)throw(0,m.$7k)((0,R.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$7k)((0,R.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(P){throw await this.hb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Z=!0}static configureFlushOnWrite(t){i.Z=t}async open(t,n,s){const o=this.I(t);let l;(0,m.$Uk)(n)&&!s&&(l=await this.P(t));let P;try{if((0,m.$Uk)(n)&&n.unlock)try{const{stat:z}=await y.SymlinkSupport.stat(o);z.mode&128||await y.Promises.chmod(o,z.mode|128)}catch(z){z.code!=="ENOENT"&&this.a.trace(z)}let I;if((0,m.$Uk)(n)){if(b.$i)try{await y.Promises.truncate(o,0),I="r+"}catch(z){z.code!=="ENOENT"&&this.a.trace(z)}I||(I="w")}else I="r";P=await y.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,m.$Uk)(n)?await this.hb(t,I):this.gb(I)}if(this.W.set(P,0),(0,m.$Uk)(n)&&this.Y.set(P,t),l){const I=this.X.get(P);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.X.set(P,l),I&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),I.dispose())}return P}async close(t){const n=this.X.get(t);try{if(this.W.delete(t),this.Y.delete(t)&&i.Z)try{await y.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await y.Promises.close(t)}catch(s){throw this.gb(s)}finally{n&&(this.X.get(t)===n&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.X.delete(t)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const P=this.$(t,n);let I=null;try{I=(await y.Promises.read(t,s,o,l,P)).bytesRead}catch(z){throw this.gb(z)}finally{this.ab(t,P,I)}return I}$(t,n){return n===this.W.get(t)?null:n}ab(t,n,s){const o=this.W.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.W.set(t,o+s):this.W.delete(t)))}async write(t,n,s,o,l){return(0,k.$Hh)(()=>this.bb(t,n,s,o,l),100,3)}async bb(t,n,s,o,l){const P=this.$(t,n);let I=null;try{I=(await y.Promises.write(t,s,o,l,P)).bytesWritten}catch(z){throw await this.hb(this.Y.get(t),z)}finally{this.ab(t,P,I)}return I}async mkdir(t){try{await y.Promises.mkdir(this.I(t))}catch(n){throw this.gb(n)}}async delete(t,n){try{const s=this.I(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,g.$kc)((0,g.$nc)(s),`${(0,g.$oc)(s)}${n.atomic.postfix}`)),await y.Promises.rm(s,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:I}=await y.SymlinkSupport.stat(s);l=P.isDirectory()&&!I}catch{}if(l)await y.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.gb(s)}}async rename(t,n,s){const o=this.I(t),l=this.I(n);if(o!==l)try{await this.cb(t,n,"move",s.overwrite),await y.Promises.rename(o,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,R.localize)(2,null,(0,g.$oc)(o),(0,g.$oc)((0,g.$nc)(l)),P.toString()))),this.gb(P)}}async copy(t,n,s){const o=this.I(t),l=this.I(n);if(o!==l)try{await this.cb(t,n,"copy",s.overwrite),await y.Promises.copy(o,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,R.localize)(3,null,(0,g.$oc)(o),(0,g.$oc)((0,g.$nc)(l)),P.toString()))),this.gb(P)}}async cb(t,n,s,o){const l=this.I(t),P=this.I(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$mg)(l,P,!0)),I){if(s==="copy")throw(0,m.$7k)((0,R.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const N=await this.M(t);if(!N)throw(0,m.$7k)((0,R.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const U=await this.M(n);if(U){if(!o)throw(0,m.$7k)((0,R.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);N.type&m.FileType.File&&U.type&m.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.db(t,n,!1)}async db(t,n,s){const o=this.I(t),l=this.I(n),P=!!(this.capabilities&1024);if((0,u.$mg)(o,l,!P))return;const I=new a.$Tc;try{I.add(await this.P(t)),I.add(await this.P(n)),s&&await y.Promises.mkdir((0,g.$nc)(l),{recursive:!0}),await y.Promises.copyFile(o,l)}catch(z){if(z.code==="ENOENT"&&!s)return this.db(t,n,!0);throw this.gb(z)}finally{I.dispose()}}t(t,n,s){return new h.$Qq(o=>t(o),o=>n(o),s)}F(t,n,s){return new p.$Zq(o=>t(o),o=>n(o),s)}gb(t){if(t instanceof m.$6k)return t;let n=t,s;switch(t.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$7k)(n,s)}async hb(t,n){let s=this.gb(n);if(t&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,m.$7k)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$1q=i}),define(se[132],re([0,1,2,6]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=void 0;class k extends j.$Uc{constructor(O,S=[]){super(),this.a=new D.$4j([O,...S]),this.B(O.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...S){this.a.trace(O,...S)}debug(O,...S){this.a.debug(O,...S)}info(O,...S){this.a.info(O,...S)}warn(O,...S){this.a.warn(O,...S)}error(O,...S){this.a.error(O,...S)}flush(){this.a.flush()}}e.$gQ=k}),define(se[133],re([0,1,13,6]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function A(a,g,b,d,$){try{const y=await new Promise((m,c)=>{J(["@vscode/spdlog"],m,c)});y.setFlushOn(k.Trace);const R=await y.createAsyncRotatingLogger(a,g,b,d);return $?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(y){console.error(y)}return null}function O(a,g,b){switch(g){case D.LogLevel.Trace:a.trace(b);break;case D.LogLevel.Debug:a.debug(b);break;case D.LogLevel.Info:a.info(b);break;case D.LogLevel.Warning:a.warn(b);break;case D.LogLevel.Error:a.error(b);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function S(a,g){switch(g){case D.LogLevel.Trace:a.setLevel(k.Trace);break;case D.LogLevel.Debug:a.setLevel(k.Debug);break;case D.LogLevel.Info:a.setLevel(k.Info);break;case D.LogLevel.Warning:a.setLevel(k.Warning);break;case D.LogLevel.Error:a.setLevel(k.Error);break;case D.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class u extends D.$Zj{constructor(g,b,d,$,y){super(),this.m=[],this.setLevel(y),this.n=this.s(g,b,d,$),this.B(this.onDidChangeLogLevel(R=>{this.r&&S(this.r,R)}))}async s(g,b,d,$){const y=d?6:1,R=30/y*j.$pl.MB,m=await A(g,b,R,y,$);if(m){this.r=m,S(this.r,this.getLevel());for(const{level:c,message:v}of this.m)O(this.r,c,v);this.m=[]}}g(g,b){this.r?O(this.r,g,b):this.getLevel()<=g&&this.m.push({level:g,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$8P=u}),define(se[134],re([0,1,28,6,133]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=void 0;class A extends D.$5j{s(S,u,a){return new k.$8P((0,j.$Jg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$9P=A}),define(se[39],re([0,1,5,65,2,10]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=void 0,e.$8n=(0,A.$ni)("policy");class O extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new j.$_d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(b,[d,$])=>({...b,[d]:$}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[g,b])=>({...a,[g]:{definition:b,value:this.g.get(g)}}),{})}}e.$9n=O;class S{constructor(){this.onDidChange=j.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$0n=S}),define(se[135],re([0,1,8,5,65,3,13,6,39]),function(J,e,j,D,k,A,O,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;function a(b,d){const $=[];for(const y of new Set(k.Iterable.concat(b.keys(),d.keys())))b.get(y)!==d.get(y)&&$.push(y);return $}let g=class extends u.$9n{constructor(d,$,y){super(),this.m=d,this.n=$,this.s=y,this.c=this.B(new j.$lh(500));const R=D.Event.filter($.onDidFilesChange,m=>m.affects(d));this.B($.watch(d)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const $=await this.n.readFile(this.m),y=JSON.parse($.value.toString());if(!(0,A.$3f)(y))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(y))this.f[R]&&d.set(R,y[R])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return d}async w(){const d=await this.u(),$=a(this.g,d);this.g=d,$.length>0&&this.h.fire($)}};e.$xcc=g,e.$xcc=g=$e([oe(1,O.$Tk),oe(2,S.$Tj)],g)}),define(se[136],re([0,1,39,8,2,6]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;let O=class extends j.$9n{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$hh,this.b=this.B(new k.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((g,b)=>{J(["@vscode/policy-watcher"],g,b)});await this.a.queue(()=>new Promise((g,b)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),g()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),b(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const g=u[a];g===void 0?this.g.delete(a):this.g.set(a,g)}this.h.fire(Object.keys(u))}};e.$wcc=O,e.$wcc=O=$e([oe(0,A.$Tj)],O)}),define(se[32],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,j.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"}),define(se[36],re([0,1,72,3]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class k{constructor(){this.a=new Map}add(O,S){j.ok(D.$1f(O)),j.ok(D.$3f(S)),j.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,S)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$6n=new k}),define(se[137],re([0,1,5,36]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class A{constructor(){this.b=new j.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[k(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;D.$6n.add(e.$7n.JSONContribution,O)}),define(se[40],re([0,1,19,5,3,91,29,137,36]),function(J,e,j,D,k,A,O,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=R,e.$ko=m,e.$lo=c,e.$mo=w,e.$no=h;var a;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$$n={Configuration:"base.contributions.configuration"};var g;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const b=u.$6n.as(S.$7n.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$_d,this.onDidSchemaChange=this.i.event,this.j=new D.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),b.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),b.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),b.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$io.test(o)){const l=this.a.get(o),P=l?.valuesSources??new Map;if(s)for(const U of Object.keys(n[o]))P.set(U,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:P});const z=(0,O.$4i)(o),N={type:"object",default:I,description:A.localize(1,null,z),$ref:e.$fo,defaultDefaultValue:I,source:k.$1f(s)?void 0:s,defaultValueSource:s};t.push(...R(o)),this.d[o]=N,this.b.properties[o]=N}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=k.$1f(n)?n:n?.id,P=k.$1f(o?.source)?o?.source:o?.source?.id;if(l===P)if(r.add(s),this.a.delete(s),e.$io.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=k.$0f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const z=l[I];if(r&&w(I,z)){delete l[I];continue}if(z.source=t,z.defaultDefaultValue=l[I].default,this.w(I,z),e.$io.test(I)?z.scope=void 0:(z.scope=k.$0f(z.scope)?s:z.scope,z.restricted=k.$0f(z.restricted)?!!n?.includes(I):z.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const P=i.allOf;if(P)for(const I of P)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$_n.properties[i]=r,r.scope){case 1:e.$ao.properties[i]=r;break;case 2:e.$bo.properties[i]=r;break;case 6:e.$co.properties[i]=r;break;case 3:e.$do.properties[i]=r;break;case 4:e.$eo.properties[i]=r;break;case 5:e.$eo.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$_n.properties[i],r.scope){case 1:delete e.$ao.properties[i];break;case 2:delete e.$bo.properties[i];break;case 6:delete e.$co.properties[i];break;case 3:delete e.$do.properties[i];break;case 4:case 5:delete e.$eo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$fo};this.w(r,t),e.$_n.properties[r]=t,e.$ao.properties[r]=t,e.$bo.properties[r]=t,e.$co.properties[r]=t,e.$do.properties[r]=t,e.$eo.properties[r]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=i,e.$ao.patternProperties[e.$ho]=i,e.$bo.patternProperties[e.$ho]=i,e.$co.patternProperties[e.$ho]=i,e.$do.patternProperties[e.$ho]=i,e.$eo.patternProperties[e.$ho]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;k.$8f(n)&&(n=r.defaultDefaultValue,s=void 0),k.$8f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",y=new RegExp($,"g");e.$ho=`^(${$})+$`,e.$io=new RegExp(e.$ho);function R(p){const i=[];if(e.$io.test(p)){let r=y.exec(p);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=y.exec(p)}}return(0,j.$Mb)(i)}function m(p){return p.reduce((i,r)=>`${i}[${r}]`,"")}function c(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const v=new d;u.$6n.add(e.$$n.Configuration,v);function w(p,i){return p.trim()?e.$io.test(p)?A.localize(7,null,p):v.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,p,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function h(){const p=[],i=v.getConfigurationProperties();for(const r of Object.keys(i))p.push([r,i[r].scope]);return p.push(["launch",4]),p.push(["task",4]),p}}),define(se[66],re([0,1,19,5,38,2,31,27,3,11,29,40,36]),function(J,e,j,D,k,A,O,S,u,a,g,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=w;function $(r){return Object.isFrozen(r)?r:S.$Un(r)}class y{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof y)return n;const s=new R("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,g.$2i)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return $(s.rawConfiguration.getValue(t))},get override(){return n?$(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return $(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:P,keys:I}of s.rawConfiguration.overrides){const z=new y(l,I).getValue(t);z!==void 0&&o.push({identifiers:P,value:z})}return o.length?$(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,g.$2i)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return j.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return j.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=S.$Tn(this.contents),s=S.$Tn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const I of P.overrides){const[z]=s.filter(N=>j.$ub(N.identifiers,I.identifiers));z?(this.h(z.contents,I.contents),z.keys.push(...I.keys),z.keys=j.$Mb(z.keys)):s.push(S.$Tn(I))}for(const I of P.keys)o.indexOf(I)===-1&&o.push(I)}return new y(n,o,s,l.every(P=>P instanceof y)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of j.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const P=n[o];P&&(typeof l=="object"&&typeof P=="object"?(l=S.$Tn(l),this.h(l,P)):l=P),s[o]=l}return new y(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$3f(t[s])&&u.$3f(n[s])){this.h(t[s],n[s]);continue}t[s]=S.$Tn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=S.$Tn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,g.$1i)(this.contents,t),b.$io.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>j.$ub(s.identifiers,(0,b.$jo)(t))),1))}j(t,n,s){(0,g.$Zi)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.$io.test(t)&&this.overrides.push({identifiers:(0,b.$jo)(t),keys:Object.keys(this.contents[t]),contents:(0,g.$Yi)(this.contents[t],o=>console.error(o))})}}e.$oo=y;class R{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$0f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:P,hasExcludedProperties:I}=this.h(t,n);this.b=new y(s,o,l,I?[t]:void 0),this.c=P||[]}g(t){let n={},s=null,o=[];const l=[],P=[];function I(N){Array.isArray(o)?o.push(N):s!==null&&(o[s]=N)}const z={onObjectBegin:()=>{const N={};I(N),l.push(o),o=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const N=[];I(N),l.push(o),o=N,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(N,U,V)=>{P.push({error:N,offset:U,length:V})}};if(t)try{k.$Hn(t,z),n=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return n}h(t,n){const s=d.$6n.as(b.$$n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,g.$Yi)(t,z=>console.error(`Conflict in settings file ${this.f}: ${z}`)),P=Object.keys(t),I=this.j(t,z=>console.error(`Conflict in settings file ${this.f}: ${z}`));return{contents:l,keys:P,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},I=[];for(const z in t)if(b.$io.test(z)&&s){const N=this.i(t[z],n,!1,o);P[z]=N.raw,l=l||N.hasExcludedProperties,I.push(...N.restricted)}else{const N=n[z],U=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&I.push(z),!o.exclude?.includes(z)&&(o.include?.includes(z)||(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&!(o.skipRestricted&&N?.restricted))?P[z]=t[z]:l=!0}return{raw:P,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(b.$io.test(o)){const l={};for(const P in t[o])l[P]=t[o][P];s.push({identifiers:(0,b.$jo)(o),keys:Object.keys(l),contents:(0,g.$Yi)(l,n)})}return s}}e.$po=R;class m extends A.$Uc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$_d),this.onDidChange=this.b.event,this.a=new R(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=m;class c{constructor(t,n,s,o,l,P,I,z,N,U,V,X,_){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=P,this.g=I,this.h=z,this.i=N,this.j=U,this.k=V,this.l=X,this.m=_}get value(){return $(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class v{constructor(t,n,s,o,l=new y,P=new y,I=new O.$Bc,z=new y,N=new O.$Bc){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=P,this.j=I,this.l=z,this.m=N,this.a=null,this.b=new O.$Bc,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new y,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),P=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const z of o.overrides)for(const N of z.identifiers)o.getOverrideValue(t,N)!==void 0&&I.add(N);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,P)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:P}=p(this.c,t);n=[...o,...l,...P]}for(const o of n)for(const l of(0,b.$jo)(o)){const P=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),z=[...I.filter(N=>P.indexOf(N)===-1),...P.filter(N=>I.indexOf(N)===-1),...P.filter(N=>!S.$Xn(this.c.override(l).getValue(N),t.override(l).getValue(N)))];s.push([l,z])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=p(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.applicationConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.localUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.remoteUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.workspaceConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:P,overrides:I}=p(s,n),z=[...o,...l,...P];return(z.length||!s)&&this.updateFolderConfiguration(t,n),{keys:z,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:P}=p(n,void 0);return{keys:[...s,...o,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),P=this.w(t.workspace),I=t.folders.reduce((z,N)=>(z.set(a.URI.revive(N[0]),this.w(N[1])),z),new O.$Bc);return new v(n,s,o,l,new y,P,I,new y,new O.$Bc)}static w(t){return new y(t.contents,t.keys,t.overrides)}}e.$ro=v;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,P])=>{const I=(0,O.$yc)(n,l,new Set);P.forEach(z=>I.add(z))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,z=this.g.getValue(t,n,this.h);return!S.$Xn(I,z)}return!0}}e.$to=h;function p(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],P=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const z=I.filter(N=>!P.includes(N));for(const N of z)l.push([N,t.getKeysForOverrideIdentifier(N)])}if(r){const z=P.filter(N=>!I.includes(N));for(const N of z)l.push([N,r.getKeysForOverrideIdentifier(N)])}if(t&&r){for(const z of P)if(I.includes(z)){const N=i({contents:r.getOverrideValue(void 0,z)||{},keys:r.getKeysForOverrideIdentifier(z)},{contents:t.getOverrideValue(void 0,z)||{},keys:t.getKeysForOverrideIdentifier(z)});l.push([z,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const P=(0,g.$2i)(t.contents,l),I=(0,g.$2i)(r.contents,l);S.$Xn(P,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(se[138],re([0,1,19,5,2,27,3,66,40,6,39,36]),function(J,e,j,D,k,A,O,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0;class d extends k.$Uc{constructor(){super(...arguments),this.a=this.B(new D.$_d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$oo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$6n.as(u.$$n.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.c(Array.from(m),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,c){this.h(m,b.$6n.as(u.$$n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new S.$oo;const m=b.$6n.as(u.$$n.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,c){const v=this.f();for(const w of m){const h=v[w],p=c[w];h!==void 0?this.b.addValue(w,h):p?this.b.addValue(w,p.default):this.b.removeValue(w)}}}e.$uo=d;class ${constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new S.$oo}async initialize(){return this.configurationModel}}e.$vo=$;let y=class extends k.$Uc{get configurationModel(){return this.b}constructor(m,c,v){super(),this.c=m,this.f=c,this.g=v,this.a=this.B(new D.$_d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$oo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const c={},v=[],w=b.$6n.as(u.$$n.Configuration).getConfigurationProperties();for(const h of m){const p=w[h];if(!p){v.push(h);continue}if(p.policy){if(p.type!=="string"&&p.type!=="number"){this.g.warn(`Policy ${p.policy.name} has unsupported type ${p.type}`);continue}v.push(h),c[p.policy.name]={type:p.type}}}return(0,O.$bg)(c)||await this.f.updatePolicyDefinitions(c),v}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const c=b.$6n.as(u.$$n.Configuration).getPolicyConfigurations(),v=(0,j.$Hb)(m.map(w=>c.get(w)));this.m(v,!0)}m(m,c){this.g.trace("PolicyConfiguration#update",m);const v=b.$6n.as(u.$$n.Configuration).getConfigurationProperties(),w=[],h=this.b.isEmpty();for(const p of m){const i=v[p]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,A.$Xn)(this.b.getValue(p),r))&&w.push([p,r])}else this.b.getValue(p)!==void 0&&w.push([p,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const p=this.b;this.b=new S.$oo;for(const i of p.keys)this.b.setValue(i,p.getValue(i));for(const[i,r]of w)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$wo=y,e.$wo=y=$e([oe(1,g.$8n),oe(2,a.$Tj)],y)}),define(se[139],re([0,1,19,8,14,5,38,74,2,27,12,17,29,66,40,138,39]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0;class c extends u.$Uc{constructor(h,p,i,r){super(),this.m=h,this.h=this.B(new A.$_d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new R.$uo),this.c=i instanceof m.$0n?new R.$vo:this.B(new R.$wo(this.b,i,r)),this.f=this.B(new $.$qo(this.m,{},b.$Rg,p)),this.a=new $.$ro(this.b.configurationModel,this.c.configurationModel,new $.$oo,new $.$oo),this.j=new v(h,p,this),this.g=this.B(new D.$zh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,p,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$ro(h,p,new $.$oo,i)}getConfigurationData(){return this.a.toData()}getValue(h,p){const i=typeof h=="string"?h:void 0,r=(0,d.$Ui)(h)?h:(0,d.$Ui)(p)?p:{};return this.a.getValue(i,r,void 0)}async updateValue(h,p,i,r,t){const n=(0,d.$Vi)(i)?i:(0,d.$Ui)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,j.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$Xn)(p,o.defaultValue)&&(p=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const P=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(z=>(0,j.$ub)([...z.identifiers].sort(),P));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,y.$ko)(n.overrideIdentifiers),h]:[h];await this.j.write(l,p),await this.reloadConfiguration()}inspect(h,p={}){return this.a.inspect(h,p,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const p=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,p,2)}r(h,p){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,p);this.t(r,i,7)}s(h){const p=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,p,7)}t(h,p,i){const r=new $.$to(h,{data:p},this.a);r.source=i,this.h.fire(r)}}e.$xo=c;class v{constructor(h,p,i){this.b=h,this.c=p,this.d=i,this.a=new D.$uh}write(h,p){return this.a.queue(()=>this.e(h,p))}async e(h,p){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,O.$An)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,p);i=(0,S.$Sn)(i,t),await this.c.writeFile(this.b,k.$ze.fromString(i))}f(h,p,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!p.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,S.$Pn)(h,p,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=g.OS===3||g.OS===2?`
`:`\r
`;const p=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});p&&typeof p=="string"&&p!=="auto"&&(h=p),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[67],re([0,1,15]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=D,e.$zm=k,e.$Am=A,e.$Bm=O;function D(u){return u.scheme===j.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function A(u){const{host:a,port:g}=S(u);if(typeof g>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:g}}function O(u,a){let{host:g,port:b}=S(u);return typeof b>"u"&&(b=a),{host:g,port:b}}function S(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const g=u.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const b=u.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:u,port:void 0}}}),define(se[37],re([0,1,30,10,67]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=A,e.$Lm=b,e.$Mm=d,e.$Nm=$,e.$Om=y,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function A(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(O||(e.ExtensionType=O={}));var S;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class u{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,c){if(typeof m>"u"||m===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof m=="string"||typeof c=="string"){const v=typeof m=="string"?m:m.value,w=typeof c=="string"?c:c.value;return j.$qf(v,w)}return m._lower===c._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Im=u;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const c of m)this.add(c)}add(m){this.c.add(u.toKey(m))}delete(m){return this.c.delete(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}}e.$Jm=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(u.toKey(m))}get(m){return this.c.get(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}set(m,c){this.c.set(u.toKey(m),c)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=g;function b(R){return d(R)}function d(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function $(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function y(R,m){if(m){const c=`onResolveRemoteAuthority:${(0,k.$zm)(m)}`;return!!R.activationEvents?.includes(c)}return!1}e.$Pm=(0,D.$ni)("IBuiltinExtensionsScannerService")}),define(se[140],re([0,1,2,37,13]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class A extends j.$Uc{constructor(S,u,a,g,b){super(),this.a=S,this.b=u,this.c=a,this.f=b,this.B(g.onDidInstallExtensions(d=>this.g(d))),this.B(g.onDidUninstallExtension(d=>this.h(d)))}g(S){for(const u of S)u.local&&this.invalidate(u.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,S)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,D.$Cm))}catch(u){(0,k.$$k)(u)!==1&&this.f.error(u)}}}e.$sq=A}),define(se[45],re([0,1,14,9,2,107,40,10,6,36]),function(J,e,j,D,k,A,O,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0,e.$Gp=d,e.$Hp=$,e.$Ip=y,e.$Jp=R,e.$Kp=m,e.$Lp=c,e.$Ep=(0,S.$ni)("requestService");class g{constructor(p){this.b=p}toJSON(){if(!this.a){const p=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?p[i]="*****":p[i]=this.b[i];this.a=p}return this.a}}class b extends k.$Uc{constructor(p){super(),this.b=0,this.a=p.createLogger("network",{name:(0,A.localize)(0,null),when:u.$_j.isEqualTo((0,u.$9j)(u.LogLevel.Trace)).serialize()})}async c(p,i,r){const t=`${p} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new g(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$Fp=b;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function $(h){return h.res.statusCode===204}async function y(h){return $(h)?null:(await(0,j.$Le)(h.stream)).toString()}async function R(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return y(h)}async function m(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if($(h))return null;const i=(await(0,j.$Le)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function c(h){w(h)}let v;function w(h){const p=a.$6n.as(O.$$n.Configuration),i=v;v={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},p.updateConfigurations({add:[v],remove:i?[i]:[]})}w(1)}),define(se[141],re([0,1,20,15,13,45]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;let O=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,g=j.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const b={type:"GET",url:u.toString(!0)},d=await this.a.request(b,g);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const $=await(0,A.$Jp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${$}`)}}};e.$vQ=O,e.$vQ=O=$e([oe(0,A.$Ep),oe(1,k.$Tk)],O)}),define(se[142],re([0,1,143,3]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=A;function k(O,S){return O.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:O.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function A(O,S,u={}){const a=(0,j.parse)(O),g=u.proxyUrl||k(a,S);if(!g)return null;const b=(0,j.parse)(g);if(!/^https?:$/.test(b.protocol||""))return null;const d={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,D.$7f)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise(($,y)=>{J(["http-proxy-agent"],$,y)})).HttpProxyAgent(g,d):new(await new Promise(($,y)=>{J(["https-proxy-agent"],$,y)})).HttpsProxyAgent(g,d)}}),define(se[144],re([0,1,59,16,108,20,34,9,12,28,87,175,8,75]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=R;let y;async function R(c,v,w,h){return w["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$rm)(h)&&!w["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$rm)(h)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=d.Promises.withAsyncBody(async(p,i)=>{const r=new A.$je;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,$.$sm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{p(await m(v,r.token))}catch(o){!(0,S.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,O.$$i)(o)))):p({})}finally{clearTimeout(s),r.dispose()}})),y)}async function m(c,v){const w=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",w);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const p=(0,a.$Jg)().replace(/-/g,"").substr(0,12),i=new RegExp(p+"({.*})"+p),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,g.$hm)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(v.isCancellationRequested)return s(new S.$5);const o=(0,D.$oc)(t);let l,P;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${p}'' + JSON.stringify(process.env) + ''${p}'''`,P=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,P=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${p}", json.dumps(dict(os.environ)), "${p}")`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const z=(0,j.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(z.kill(),s(new S.$5))),z.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,O.$$i)(V)),s(V)});const N=[];z.stdout.on("data",V=>N.push(V));const U=[];z.stderr.on("data",V=>U.push(V)),z.on("close",(V,X)=>{const _=Buffer.concat(N).toString("utf8");c.trace("getUnixShellEnvironment#raw",_);const K=Buffer.concat(U).toString("utf8");if(K.trim()&&c.trace("getUnixShellEnvironment#stderr",K),V||X)return s(new Error((0,k.localize)(2,null,V,X)));const le=i.exec(_),ue=le?le[1]:"{}";try{const ae=JSON.parse(ue);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,O.$$i)(ae)),s(ae)}})})}}),define(se[145],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=void 0,e.$0P=(0,j.$ni)("stateReadService"),e.$$P=(0,j.$ni)("stateService")}),define(se[68],re([0,1,8,14,2,3,18,13,6]),function(J,e,j,D,k,A,O,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.$aQ=e.$_P=e.SaveStrategy=void 0;var a;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends k.$Uc{constructor(y,R,m,c){super(),this.h=y,this.j=R,this.m=m,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new j.$lh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,R){const m=this.a[y];return(0,A.$0f)(m)?R:m}setItem(y,R){this.setItems([{key:y,data:R}])}setItems(y){let R=!1;for(const{key:m,data:c}of y)this.a[m]!==c&&((0,A.$0f)(c)?(0,A.$8f)(this.a[m])||(this.a[m]=void 0,R=!0):(this.a[m]=c,R=!0));R&&this.s()}removeItem(y){(0,A.$8f)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,D.$ze.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$_P=g;let b=class extends k.$Uc{constructor(y,R,m,c){super(),this.a=this.B(new g(R.stateResource,y,m,c))}async init(){await this.a.init()}getItem(y,R){return this.a.getItem(y,R)}};e.$aQ=b,e.$aQ=b=$e([oe(1,O.$ui),oe(2,u.$Tj),oe(3,S.$Tk)],b);class d extends b{setItem(y,R){this.a.setItem(y,R)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$bQ=d}),define(se[69],re([0,1,12,35,28]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=O,e.$8o=S;function A(u){if(j.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function O(u,a,g,b,d,$,y,R,m){const c=Object.create(null);c["common.machineId"]=$,c["common.sqmId"]=y,c.sessionID=(0,k.$Jg)()+Date.now(),c.commitHash=b,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,j.$h)(j.$u),c["common.nodePlatform"]=D.$ec,c["common.nodeArch"]=g,c["common.product"]=m||"desktop",R&&(c["common.msftInternal"]=R);let v=0;const w=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),j.$l&&(c["common.snap"]="true");const h=A(a);return h&&(c["common.platformDetail"]=h),c}function S(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return u.some(b=>g===b)}}),define(se[22],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,j.$ni)("telemetryService"),e.$Tl=(0,j.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(se[70],re([0,1,9,10,6,22]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0,e.$3p=(0,D.$ni)("IExtensionSignatureVerificationService");let O=class{constructor(u,a){this.b=u,this.c=a}d(){return this.a||(this.a=new Promise((u,a)=>J(["@vscode/vsce-sign"],async g=>u(g),a))),this.a}async verify(u,a,g){let b;try{b=await this.d()}catch(R){return this.b.error("Could not load vsce-sign module",(0,j.$0)(R)),!1}const d=new Date().getTime();let $,y;try{return $=await b.verify(u,a,g),$}catch(R){throw y=R,R}finally{const R=new Date().getTime()-d;this.c.publicLog2("extensionsignature:verification",{duration:R,verified:$,error:y?y.code??"unknown":void 0})}}};e.$4p=O,e.$4p=O=$e([oe(0,k.$Tj),oe(1,A.$Sl)],O)}),define(se[41],re([0,1,27,3,67,69,22]),function(J,e,j,D,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=g,e.$ep=b,e.$fp=d,e.$gp=$,e.$hp=R,e.$ip=c,e.$jp=v,e.$kp=p;class S{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$9o=S;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=u,e.$$o=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$_o=a,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function b(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const r=i.getValue(O.$1l),t=i.getValue(O.$2l);if(i.getValue(O.$3l)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(i){const r={},t={},n={};m(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(i){if(!i)return"none";const r=(0,k.$zm)(i);return y.has(r)?r:"other"}function m(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,j.$Yn)(o):o instanceof Date?r[l]=o.toISOString():(0,D.$3f)(o)?t<2?m(o,r,t+1,l+"."):r[l]=(0,j.$Yn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.$8o)(t)||n}function v(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function w(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const P of r)for(;;){const I=P.exec(i);if(!I)break;n.push([I.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const P=o.exec(i);if(!P)break;const I=n.some(([z,N])=>P.index<N&&z<o.lastIndex);!s.test(P[0])&&!I&&(t+=i.substring(l,P.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function p(i,r){return(0,j.$Vn)(i,t=>{if(t instanceof S||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=w(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}}),define(se[26],re([0,1,30,21,37,12,11,9,35,41]),function(J,e,j,D,k,A,O,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=g,e.$np=y,e.$op=R,e.$pp=m,e.$qp=c,e.$rp=v,e.$sp=w,e.$tp=h,e.$vp=p,e.$wp=r;function g(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,j.$lf)(t.id,n.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=b.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?g(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$mp=d;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(t){const n=$.exec(t);return n&&n[1]?[m(n[1]),n[2]]:[m(t),void 0]}function R(t,n){return`${t}.${n}`}function m(t){return t.toLowerCase()}function c(t,n){return m(R(t??k.$Em,n))}function v(t,n){const s=[],o=l=>{for(const P of s)if(P.some(I=>g(n(I),n(l))))return P;return null};for(const l of t){const P=o(l);P?P.push(l):s.push([l])}return s}function w(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function h(t){return{id:new a.$9o(t.identifier.id),name:new a.$9o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$up=new k.$Im("pprice.better-merge");function p(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(P=>!g(P.identifier,{id:l}))){const P=t.filter(I=>g(I.identifier,{id:l}));P.length===1&&(s.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function i(t,n){if(!A.$k)return!1;let s;try{s=(await t.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,S.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$So)(s?"alpine":A.$u,u.$fc);return n.debug("ComputeTargetPlatform:",o),o}}),define(se[146],re([0,1,20,9,15,17,44,11,96,21,26,37]),function(J,e,j,D,k,A,O,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;const d=R=>(0,u.localize)(0,null,R),$=(0,u.localize)(1,null,"ms-dotnettools.csharp");let y=class{constructor(m,c,v){this.a=m,this.b=c,this.d=v}get f(){}async listExtensions(m,c,v){let w=await this.b.getInstalled(1,v);const h=b.$Hm.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),w=w.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let p;for(const i of w)p!==i.identifier.id&&(p=i.identifier.id,this.a.info(m?`${p}@${i.manifest.version}`:p))}async installExtensions(m,c,v,w){const h=[];try{m.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const p=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...v,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||v.installPreReleaseVersion}})};for(const n of m)if(n instanceof S.URI)p.push({vsix:n,installOptions:v});else{const[s,o]=(0,g.$np)(n);r(s,o,!1)}for(const n of c)if(n instanceof S.URI)p.push({vsix:n,installOptions:{...v,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,g.$np)(n);r(s,o,!0)}const t=await this.b.getInstalled(void 0,v.profileLocation);if(p.length&&await Promise.all(p.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,w,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,w);h.push(...n)}}catch(p){throw this.a.error((0,u.localize)(5,null,(0,D.$0)(p))),p}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(m){const c=await this.b.getInstalled(1,m),v=[];for(const i of c)i.identifier.uuid&&v.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,v.length));const w=await this.d.getExtensions(v,{compatible:!0},j.CancellationToken.None),h=[];for(const i of w)for(const r of c)(0,g.$lp)(r.identifier,i.identifier)&&(0,O.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const p=await this.b.installGalleryExtensions(h);for(const i of p)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(m,c,v){if(m=m.filter(({id:i,version:r})=>{const t=c.find(n=>(0,g.$lp)(n.identifier,{id:i}));if(t){if(!v&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!m.length)return[];const w=[],h=[],p=await this.j(m);if(await Promise.all(m.map(async({id:i,version:r,installOptions:t})=>{const n=p.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${$}`),w.push(i);return}try{const o=await this.d.getManifest(n,j.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),w.push(i);return}const s=c.find(o=>(0,g.$lp)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),w.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return w}async h(m,c,v,w){const h=await this.b.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.l(h,v,c.profileLocation,w))try{await this.b.install(m,c),this.a.info((0,u.localize)(22,null,(0,A.$Xg)(m)))}catch(i){if((0,D.$4)(i))this.a.info((0,u.localize)(23,null,(0,A.$Xg)(m)));else throw i}}async j(m){const c=new Map,v=m.some(p=>p.installOptions.installPreReleaseVersion),w=await this.b.getTargetPlatform(),h=[];for(const p of m)a.$Lo.test(p.id)&&h.push({...p,preRelease:v});if(h.length){const p=await this.d.getExtensions(h,{targetPlatform:w},j.CancellationToken.None);for(const i of p)c.set(i.identifier.id.toLowerCase(),i)}return c}k(m){return!0}async l(m,c,v,w){if(!c){const h={id:(0,g.$qp)(m.publisher,m.name)},p=w.find(i=>(0,g.$lp)(h,i.identifier)&&(0,O.gt)(i.manifest.version,m.version));if(p)return this.a.info((0,u.localize)(24,null,p.identifier.id,p.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,c,v){const w=async p=>{if(p instanceof S.URI){const i=await this.b.getManifest(p);return(0,g.$op)(i.publisher,i.name)}return p},h=[];for(const p of m){const i=await w(p),t=(await this.b.getInstalled(void 0,v)).filter(n=>(0,g.$lp)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${$}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:v}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(m){const c=await this.b.getInstalled();m.forEach(v=>{c.forEach(w=>{if(w.identifier.id===v&&w.location.scheme===k.Schemas.file){this.a.info(w.location.fsPath);return}})})}m(m){return this.f?(0,u.localize)(30,null,m,this.f):(0,u.localize)(31,null,m)}};e.$5p=y,e.$5p=y=$e([oe(1,a.$Zo),oe(2,a.$Wo)],y)}),define(se[147],re([0,1,8,9,2,15,17,44,3,28,25,49,29,18,21,26,70,13,6]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;let h=class extends k.$Uc{static{w=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,O.$1g)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new y.$Xo(o.message,y.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===v.LogLevel.Trace)}catch(l){const P=l;if(s=P.code,P.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${P.output}`),s===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new y.$Xo(b.$9p,y.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$7f)(r)?r:!0}async u(i){await this.g;const r=(0,O.$1g)(this.extensionsDownloadDir,`${this.z(i)}${w.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new y.$Xo(t.message,y.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const n=(0,O.$1g)(this.extensionsDownloadDir,`.${(0,a.$Jg)()}`);await this.h.exists(n)||await t(n);try{await g.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith(w.c))n.push(l.resource);else{const P=R.$mp.parse(l.name);P&&t.push([P,l])}const s=(0,R.$rp)(t,([l])=>l),o=[];for(const l of s)l.sort((P,I)=>S.rcompare(P[0].version,I[0].version)),r.push(...l.slice(1).map(P=>P[1].resource)),o.push(l[0][1]);o.sort((l,P)=>l.mtime-P.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await j.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?R.$mp.create(i).toString().toLowerCase():(0,a.$Jg)()}};e.$pq=h,e.$pq=h=w=$e([oe(0,$.$vi),oe(1,c.$Tk),oe(2,y.$Wo),oe(3,d.$Ti),oe(4,m.$3p),oe(5,v.$Tj)],h)}),define(se[148],re([0,1,5,2,31,26,37]),function(J,e,j,D,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;class S extends D.$Uc{constructor(a,g,b,d,$,y,R){super(),this.f=a,this.g=g,this.h=b,this.j=d,this.m=$,this.n=y,this.r=R,this.a=this.B(new j.$_d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$4c),this.s().then(null,m=>R.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(g=>(this.c.set(g.id,(0,D.$Rc)(this.n.watch(this.m.extUri.dirname(g.extensionsResource)),this.n.watch(g.extensionsResource))),this.G(g.extensionsResource))))}catch(g){throw this.r.error(g),g}}async w(a){for(const g of a.extensions)this.I(this.L(g.identifier,g.version),a.profileLocation)}async y(a){for(const g of a.extensions){const b=this.L(g.identifier,g.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const g of a.extensions)this.J(this.L(g.identifier,g.version),a.profileLocation)}async C(a){const g=[],b=[];for(const d of a.extensions){const $=this.L(d.identifier,d.version);a.error?this.I($,a.profileLocation):(this.J($,a.profileLocation),this.b.has($)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),b.push(this.f.scanInstalledExtensionAtLocation(d.location).then(y=>{y?g.push(y):this.r.info("Extension not found at the location",d.location.toString())},y=>this.r.error(y)))))}try{await Promise.all(b),g.length&&await this.H(g)}catch(d){this.r.error(d)}}D(a){for(const g of this.h.profiles)a.contains(g.extensionsResource,0,1)&&this.F(g.extensionsResource)}async F(a){const g=[],b=[],d=await this.j.scanProfileExtensions(a),$=new Set,y=new Set;for(const[R,m]of this.b)m.has(a)&&y.add(R);for(const R of d){const m=this.L(R.identifier,R.version);$.add(m),y.has(m)||(g.push(R.identifier),this.I(m,a))}for(const R of y)if(!$.has(R)){const m=this.M(R);m&&(b.push(m.identifier),this.J(R,a))}(g.length||b.length)&&this.a.fire({added:g.length?{extensions:g,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const g=await this.j.scanProfileExtensions(a);for(const b of g)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,g){let b=this.b.get(a);b||this.b.set(a,b=new k.$Cc(d=>this.m.extUri.getComparisonKey(d))),b.add(g)}J(a,g){const b=this.b.get(a);b&&b.delete(g),b?.size||this.b.delete(a)}L(a,g){return`${O.$Im.toKey(a.id)}@${g}`}M(a){const[g,b]=(0,A.$np)(a);return b?{identifier:{id:g},version:b}:void 0}}e.$tq=S}),define(se[149],re([0,1,118,41]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=k;async function k(A,O,S,u,a,g,b){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,D.$dp)(O,S)&&(0,D.$fp)(u)===3){const $=await(0,j.$Xp)(S,a,g);d["X-Market-User-Id"]=$,d["VSCode-SessionId"]=b.machineId||$}return d}}),define(se[150],re([0,1,176,19,8,2,15,16,25,18,21,26,6,64,11]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;let R=class extends $.$Hr{constructor(w,h,p,i){super(p),this.h=w,this.j=i,this.g=this.B(new m(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(w,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[w];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),h=Object.keys(w).map(p=>{const i=w[p];return{...this.f(p,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((p,i)=>p.label.localeCompare(i.label)),h}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const h=await this.g.getLanguagePacks();Object.keys(h).some(p=>h[p]&&h[p].extensions.some(i=>(0,b.$lp)(i.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),p=await this.g.update(h);return!(0,D.$ub)(Object.keys(w),Object.keys(p))}};e.$Ir=R,e.$Ir=R=$e([oe(0,g.$Zo),oe(1,a.$vi),oe(2,g.$Wo),oe(3,d.$Tj)],R);let m=class extends A.$Uc{constructor(w,h){super(),this.j=h,this.c={},this.f=(0,S.$kc)(w.userDataPath,"languagepacks.json"),this.g=new k.$uh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(h=>{Object.keys(h).forEach(p=>delete h[p]),this.m(h,...w)}).then(()=>this.c)}m(w,...h){for(const p of h)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.n(w,p);Object.keys(w).forEach(p=>this.r(w[p]))}n(w,h){const p=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===O.Schemas.file&&c(r)){let t=w[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},w[r.languageId]=t);const n=t.extensions.filter(s=>(0,b.$lp)(s.extensionIdentifier,p))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:p,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,S.$kc)(h.location.fsPath,s.path)}}r(w){if(w){const h=(0,j.createHash)("md5");for(const p of w.extensions)h.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);w.hash=h.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(h=w(p),p)).then(p=>{for(const r of Object.keys(p))p[r]||delete p[r];this.c=p,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,p=>this.j.error(p))})}};m=$e([oe(0,a.$vi),oe(1,d.$Tj)],m);function c(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const w of v.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(se[151],re([0,1,84,9,27,41]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function u(g,b,d){const $=await(0,j.$OD)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,j.$OD)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new $.AppInsightsCore,m=new y.PostChannel,c={instrumentationKey:g,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){c.extensionConfig={};const v={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[m.identifier]=v}return R.initialize(c,[]),R.addTelemetryInitializer(v=>{v.ext=v.ext??{},v.ext.web=v.ext.web??{},v.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),R}class a{constructor(b,d,$,y,R){this.e=b,this.f=d,this.g=$,this.h=R,this.c=O,this.d=S,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{b(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(b,d){if(!this.a)return;d=(0,k.$Wn)(d,this.g),d=(0,A.$gp)(d);const $=this.f+"/"+b;try{this.i(y=>{y.pluginVersionString=d?.properties.version??"Unknown",y.track({name:$,baseData:{name:$,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$6P=a}),define(se[152],re([0,1,2,27,12,30,109,29,40,153,32,36,22,41]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,v,w){this.k=v,this.l=w,this.d={},this.i=new j.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,A.$5e)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$5e)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$1l)||h.affectsConfiguration(d.$3l)||h.affectsConfiguration(d.$2l))&&this.m()}))}setExperimentProperty(c,v){this.d[c]=v}m(){let c=(0,$.$fp)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const w=v.usage?3:v.error?2:0;c=Math.min(c,w)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,v,w){this.g<v||(w=(0,D.$Wn)(w,this.d),w=(0,$.$kp)(w,this.j),w=(0,D.$Wn)(w,this.c),this.b.forEach(h=>h.log(c,w)))}publicLog(c,v){this.n(c,3,v)}publicLog2(c,v){this.publicLog(c,v)}publicLogError(c,v){this.h&&this.n(c,2,v)}publicLogError2(c,v){this.publicLogError(c,v)}};e.$Or=y,e.$Or=y=$e([oe(1,S.$Ti),oe(2,g.$ak)],y);function R(){const m=(0,O.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=k.$o?"":(0,O.localize)(3,null),w=(0,O.localize)(4,null),h=(0,O.localize)(5,null),p=(0,O.localize)(6,null),i=(0,O.localize)(7,null),r=`
|       | ${w} | ${h} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${m} ${c} ${v}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}b.$6n.as(u.$$n.Configuration).registerConfiguration({id:d.$Zl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[d.$1l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$6n.as(u.$$n.Configuration).registerConfiguration({id:d.$Zl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[d.$3l]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,O.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,O.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${d.$1l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],re([0,1,14,20,177,151]),function(J,e,j,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;async function O(g,b){const d=await b.request(g,D.CancellationToken.None),$=(await(0,j.$Le)(d.stream)).toString(),y=d.res.statusCode??200;return{headers:d.res.headers,statusCode:y,responseData:$}}async function S(g){const b={method:g.type,headers:g.headers};return new Promise(($,y)=>{const R=k.request(g.url??"",b,m=>{m.on("data",function(c){$({headers:m.headers,statusCode:m.statusCode??200,responseData:c.toString()})}),m.on("error",function(c){y(c)})});R.write(g.data,m=>{m&&y(m)}),R.end()})}async function u(g,b,d){const $=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),y={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:$};try{const R=g?await O(y,g):await S(y);d(R.statusCode,R.headers,R.responseData)}catch{d(0,{})}}class a extends A.$6P{constructor(b,d,$,y,R){const m={sendPOST:(c,v)=>{u(b,c,v)}};super(d,$,y,R,m)}}e.$7P=a}),define(se[155],re([0,1,16,25]),function(J,e,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=k;async function k(A,O){const S=Object.create(null),u=(g,b)=>{const d=JSON.parse(g);S[b]=d};if(O){const g=[],b=await D.Promises.readdir(O);for(const $ of b)try{(await D.Promises.stat((0,j.$kc)(O,$))).isDirectory()&&g.push($)}catch{}const d=[];for(const $ of g)(await D.Promises.readdir((0,j.$kc)(O,$))).filter(R=>R==="telemetry.json").length===1&&d.push($);for(const $ of d){const y=(await D.Promises.readFile((0,j.$kc)(O,$,"telemetry.json"))).toString();u(y,$)}}let a=(await D.Promises.readFile((0,j.$kc)(A,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,j.$kc)(A,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(S,null,4)}}),define(se[156],re([0,1,12,85,22]),function(J,e,j,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=A,e.$bcc=O;async function A(S,u){let a=S.getItem(k.$Xl);return(typeof a!="string"||j.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$wn)(u.error.bind(u))),a}async function O(S,u){let a=S.getItem(k.$Yl);return typeof a!="string"&&(a=await(0,D.$xn)(u.error.bind(u))),a}}),define(se[23],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=void 0,e.$rl=(0,j.$ni)("IUriIdentityService")}),define(se[157],re([0,1,23,119,13,17,76,5,2]),function(J,e,j,D,k,A,O,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(d){this.g=d,this.c=new u.$Tc,this.f=2**16;const $=new Map,y=R=>{let m=$.get(R.scheme);return m===void 0&&(m=d.hasProvider(R)&&!this.g.hasCapability(R,1024),$.set(R.scheme,m)),m};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(R=>{$.delete(R.scheme)})),this.extUri=new A.$Pg(y),this.d=new O.$ns((R,m)=>this.extUri.compare(R,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$2g)(d));const $=this.d.get(d);return $?$.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((y,R)=>y[1].time<R[1].time?1:y[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const $=this.f*.5;for(let y=0;y<$;y++)this.d.set(d[y][0],d[y][1].touch())}};e.$os=g,e.$os=g=$e([oe(0,k.$Tk)],g),(0,D.$ls)(j.$rl,g,1)}),define(se[158],re([0,1,5,2,13,48,31]),function(J,e,j,D,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class S extends D.$Uc{constructor(a,g,b,d,$,y){super(),this.f=a,this.g=g,this.h=b,this.j=d,this.m=$,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new j.$_d),this.onDidChangeFile=this.a.event,this.b=A.$ti.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Cc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,b,d,$){return this.g.read(a,g,b,d,$)}write(a,g,b,d,$){return this.g.write(a,g,b,d,$)}watch(a,g){this.b.set(a,a);const b=this.g.watch(this.t(a),g);return(0,D.$Sc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,b){return this.g.rename(this.t(a),this.t(g),b)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,b){return this.g.readFileStream(this.t(a),g,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,b){return this.g.writeFile(this.t(a),g,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,b){if((0,k.$Xk)(this.g))return this.g.copy(this.t(a),this.t(g),b);throw new Error("copy not supported")}cloneFile(a,g){if((0,k.$Yk)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const d=this.u(b.resource);this.b.findSubstr(d)&&g.push({resource:d,type:b.type,cId:b.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$ycc=S}),define(se[159],re([0,1,111,16,48,17,11,10,15]),function(J,e,j,D,k,A,O,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=a,e.$yi=g,e.$Bi=b,e.$Ci=d,e.$Di=$,e.$Ei=R,e.$Fi=m,e.$Ii=w,e.$Ni=h,e.$Oi=p,e.$Qi=i,e.$Ri=r,e.$Si=t,e.$wi=(0,S.$ni)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&O.URI.isUri(s.uri)}function g(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function b(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$oc)(n)}:s?e.$zi:e.$Ai;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const s=n;return typeof s?.id=="string"&&O.URI.isUri(s.configPath)}function $(n){const s=n;if(s?.uri)return{id:s.id,uri:O.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function R(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function m(n){const s=n;return!!(s&&typeof s=="object"&&O.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,l,P,I){this.h=s,this.j=l,this.k=P,this.l=I,this.c=k.$ti.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$ti.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=c;class v{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$1g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=v;function w(n){return new v({uri:n,index:0,name:(0,A.$Wg)(n)},{uri:n.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,j.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function h(n,s){return A.$Rg.isEqualOrParent(n,s.untitledWorkspacesHome)}function p(n){let s;return O.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Pi}function r(n,s){return!h(n,s)&&!p(n)}function t(n){return(typeof n=="string"?(0,D.$pc)(n):(0,A.$Yg)(n))===e.$Ki}}),define(se[24],re([0,1,43,5,2,17,11,110,18,13,10,6,159,31,23,8,28,30,3]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$tl=e.ProfileResourceType=void 0,e.$sl=h,e.$ul=p,e.$vl=i;var w;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&O.URI.isUri(s.location)&&O.URI.isUri(s.globalStorageHome)&&O.URI.isUri(s.settingsResource)&&O.URI.isUri(s.keybindingsResource)&&O.URI.isUri(s.tasksResource)&&O.URI.isUri(s.snippetsHome)&&O.URI.isUri(s.extensionsResource))}e.$tl=(0,g.$ni)("IUserDataProfilesService");function p(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:O.URI.revive(n.location).with({scheme:s}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,s,o,l,P,I){return{id:n,name:s,location:o,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$1g)(o,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,A.$1g)(o,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$1g)(o,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$1g)(o,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$1g)(o,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$1g)(o,"extensions.json"),cacheHome:(0,A.$1g)(l,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,P){super(),this.t=s,this.u=o,this.w=l,this.y=P,this.f=!0,this.h=this.B(new D.$_d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$_d),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$_d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$_d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$1g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$1g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,v.$1f)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,A.$Xg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new $.$Bc,P=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[z,N]of Object.entries(I.workspaces)){const U=O.URI.parse(z),V=o.find(X=>X.id===N);V&&l.set(U,V)}if(I.emptyWindows)for(const[z,N]of Object.entries(I.emptyWindows)){const U=o.find(V=>V.id===N);U&&P.set(z,U)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:P}}return this.z}D(){const s=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$5e)(o)}\\s(\\d+)`);let P=0;for(const z of this.profiles){const N=l.exec(z.name),U=N?parseInt(N[1]):0;P=U>P?U:P}const I=`${o} ${P+1}`;return this.createProfile((0,j.$bj)((0,m.$Jg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,j.$bj)((0,m.$Jg)()).toString(16),s,o,l)}async createProfile(s,o,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return P&&await this.setProfileForWorkspace(P,I),I}async F(s,o,l){if(!(0,v.$1f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(o);return P||(P=(async()=>{try{if(this.profiles.find(U=>U.name===o||U.id===s))throw new Error(`Profile with ${o} name already exists`);const z=i(s,o,(0,A.$1g)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(z.location);const N=[];return this.j.fire({profile:z,join(U){N.push(U)}}),await R.Promises.settled(N),this.I([z],[],[]),z}finally{this.r.delete(o)}})(),this.r.set(o,P)),P}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(P){(0,a.$$k)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return O.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$xi)(s)?s.uri:(0,d.$Ci)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const P=[...this.profiles,...s],I=[];this.s.profiles=[];for(let z of P)z.isDefault||o.some(N=>z.id===N.id)||(z=l.find(N=>z.id===N.id)??z,z.isTransient?this.s.profiles.push(z):I.push({location:z.location,name:z.name,shortName:z.shortName,icon:z.icon,useDefaultFlags:z.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const P=this.G(s),I=l?this.s:this.C;O.URI.isUri(P)?(I.workspaces.delete(P),o&&I.workspaces.set(P,o)):(I.emptyWindows.delete(P),o&&I.emptyWindows.set(P,o)),l||this.M()}M(){const s={};for(const[l,P]of this.C.workspaces.entries())s[l.toString()]=P.id;const o={};for(const[l,P]of this.C.emptyWindows.entries())o[l.toString()]=P.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,z]of Object.entries(s.workspaces)){const N=O.URI.parse(z);o[I]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const P={};if(s.emptyWindows)for(const[I,z]of Object.entries(s.emptyWindows)){const N=O.URI.parse(z);P[I]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:o,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$wl=r,e.$wl=r=$e([oe(0,u.$ui),oe(1,a.$Tk),oe(2,y.$rl),oe(3,b.$Tj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$xl=t}),define(se[160],re([0,1,19,8,20,9,5,2,12,3,11,94,21,26,37,6,32,22,23,24]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$bq=void 0,e.$cq=p,e.$dq=i;let h=class extends S.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,P,I,z){super(),this.z=s,this.C=o,this.D=l,this.F=P,this.G=I,this.H=z,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$_d),this.s=this.B(new O.$_d),this.t=this.B(new O.$_d),this.u=this.B(new O.$_d),this.w=this.B(new O.$_d),this.y=[],this.B((0,S.$Sc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Uo)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const P=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,$.$lp)(I,s.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new d.$Xo(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Xo(b.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:P,options:I})=>{try{const z=await this.N(P,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});l.push({...z,options:I})}catch(z){o.push({identifier:P.identifier,operation:2,source:P,error:z})}})),l.length&&o.push(...await this.I(l));for(const P of o)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!g.URI.isUri(P.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,$.$tp)(P.source),error:P.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,y.$Lm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const P of this.H.profiles){const I=(await this.getInstalled(1,P.extensionsResource)).find(z=>(0,$.$lp)(z.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=new Map,l=new Map,P=[],I=(N,U)=>`${$.$mp.create(N).toString()}-${U.toString()}`,z=(N,U,V,X)=>{const _=this.Y(N,U,V),K=`${(0,$.$qp)(N.publisher,N.name)}-${V.profileLocation.toString()}`;l.set(K,{task:_,root:X}),this.n.fire({identifier:_.identifier,source:U,profileLocation:V.profileLocation}),this.F.info("Installing extension:",_.identifier.id),g.URI.isUri(U)||this.j.set(I(U,V.profileLocation),{task:_,waitingTasks:[]})};try{for(const{manifest:N,extension:U,options:V}of s){const X=V.isApplicationScoped||V.isBuiltin||(0,y.$Lm)(N),_={...V,installOnlyNewlyAddedFromExtensionPack:V.installOnlyNewlyAddedFromExtensionPack??!g.URI.isUri(U),isApplicationScoped:X,profileLocation:X?this.H.defaultProfile.extensionsResource:V.profileLocation??this.X(),productVersion:V.productVersion??{version:this.G.version,date:this.G.date}},K=g.URI.isUri(U)?void 0:this.j.get(I(U,_.profileLocation));K?(this.F.info("Extension is already requested to install",K.task.identifier.id),P.push(K.task.waitUntilTaskIsFinished())):z(N,U,_,void 0)}return await Promise.all([...l.values()].map(async({task:N})=>{if(N.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const U=await this.M(N.identifier,N.manifest,!!N.options.installOnlyNewlyAddedFromExtensionPack,!!N.options.installPreReleaseVersion,N.options.profileLocation,N.options.productVersion),V=await this.getInstalled(void 0,N.options.profileLocation,N.options.productVersion),X={...N.options,context:{...N.options.context,[d.$Po]:!0}};for(const{gallery:_,manifest:K}of(0,j.$Mb)(U,({gallery:le})=>le.identifier.id)){if(l.has(`${_.identifier.id.toLowerCase()}-${X.profileLocation.toString()}`))continue;const le=this.j.get(I(_,X.profileLocation));if(le){if(this.J(N,le.task)){const ue=le.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,N.identifier.id),le.waitingTasks.push(N),P.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,ae=>ae.some(B=>(0,$.$lp)(B.identifier,ue)))).then(ae=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,N.identifier.id),!ae.find(Q=>(0,$.$lp)(Q.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else V.some(({identifier:ue})=>(0,$.$lp)(ue,_.identifier))||z(K,_,X,N)}}catch(U){if(g.URI.isUri(N.source))(0,j.$Lb)(N.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",N.identifier.id,U.message),(0,j.$Lb)(N.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",N.identifier.id,U.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),U}})),await this.L([...l.entries()].map(async([N,{task:U}])=>{const V=new Date().getTime();try{const X=await U.run();if(await this.L(this.y.map(_=>_.postInstall(X,U.source,U.options,k.CancellationToken.None))),!g.URI.isUri(U.source)){const _=U.operation===3,K=_?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(r(this.C,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$tp)(U.source),verificationStatus:U.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:K}),u.$o&&U.operation!==3)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}o.set(N,{local:X,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw o.set(N,{error:X,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.profileLocation,applicationScoped:U.options.isApplicationScoped}),this.F.error("Error while installing the extension",U.identifier.id,(0,A.$0)(X)),X}})),P.length&&await this.L(P),[...o.values()]}catch(N){const U=(_,K,le)=>{const ue=[];_.manifest.extensionDependencies?.length&&ue.push(..._.manifest.extensionDependencies),_.manifest.extensionPack?.length&&ue.push(..._.manifest.extensionPack);for(const ae of ue){if(le.includes(ae.toLowerCase()))continue;le.push(ae.toLowerCase());const B=o.get(`${ae.toLowerCase()}-${K.toString()}`);B?.local&&(le=U(B.local,K,le))}return le},V=_=>({identifier:_.identifier,operation:2,source:_.source,context:_.options.context,profileLocation:_.profileLocation,error:N}),X=[];for(const[_,{task:K,root:le}]of l){const ue=o.get(_);ue?ue.local&&le&&!o.get(`${le.identifier.id.toLowerCase()}-${K.profileLocation.toString()}`)?.local&&(X.push(this.Z(ue.local,{versionOnly:!0,profileLocation:K.profileLocation})),o.set(_,V(K))):(K.cancel(),o.set(_,V(K)))}for(const[_,{task:K}]of l){const le=o.get(_);if(!le?.local||K.options.donotIncludePackAndDependencies)continue;U(le.local,K.profileLocation,[le.local.identifier.id.toLowerCase()]).slice(1).some(ae=>l.has(`${ae.toLowerCase()}-${K.profileLocation.toString()}`)&&!o.get(`${ae.toLowerCase()}-${K.profileLocation.toString()}`)?.local)&&(X.push(this.Z(le.local,{versionOnly:!0,profileLocation:K.profileLocation})),o.set(_,V(K)))}throw X.length&&await Promise.allSettled(X.map(async _=>{try{await _.run(),this.F.info("Rollback: Uninstalled extension",_.extension.identifier.id)}catch(K){this.F.warn("Rollback: Error while uninstalling extension",_.extension.identifier.id,(0,A.$0)(K))}})),N}finally{for(const{task:N}of l.values())N.source&&!g.URI.isUri(N.source)&&this.j.delete(I(N.source,N.profileLocation));if(o.size){const N=[...o.values()];for(const U of N)U.local&&this.F.info("Extension installed successfully:",U.identifier.id);this.s.fire(N)}}}J(s,o){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===s&&(P.includes(o)||P.some(I=>this.J(I,o)))||l===o&&P[0]&&!this.J(s,P[0]))return!1;return!0}async L(s){const o=[],l=[],P=await Promise.allSettled(s);for(const I of P)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw p(l);return o}async M(s,o,l,P,I,z){if(!this.z.isEnabled())return[];const N=await this.getInstalled(void 0,I,z),U=[],V=[],X=async(_,K)=>{U.push(_);const le=K.extensionDependencies||[],ue=[...le];if(K.extensionPack){const ae=l?N.find(B=>(0,$.$lp)(B.identifier,_)):void 0;for(const B of K.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(Q=>(0,$.$lp)({id:Q},{id:B}))||ue.every(Q=>!(0,$.$lp)({id:Q},{id:B}))&&ue.push(B)}if(ue.length){const ae=ue.filter(B=>U.every(Q=>!(0,$.$lp)(Q,{id:B})));if(ae.length){const B=await this.z.getExtensions(ae.map(Q=>({id:Q,preRelease:P})),k.CancellationToken.None);for(const Q of B){if(U.find(W=>(0,$.$lp)(W,Q.identifier)))continue;const q=le.some(W=>(0,$.$lp)({id:W},Q.identifier));let M;try{M=await this.N(Q,!1,P,z)}catch(W){if(q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",Q.identifier.id,(0,A.$0)(W));continue}V.push({gallery:M.extension,manifest:M.manifest}),await X(M.extension.identifier,M.manifest)}}}};return await X(s,o),V}async N(s,o,l,P){let I;const z=await this.getExtensionsControlManifest();if(z.malicious.some(V=>(0,$.$lp)(s.identifier,V)))throw new d.$Xo(b.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const N=z.deprecated[s.identifier.id.toLowerCase()];if(N?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${N.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:N.extension.id,preRelease:N.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},k.CancellationToken.None))[0],!I)throw new d.$Xo(b.localize(2,null,s.identifier.id,N.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const V=await this.getTargetPlatform();throw new d.$Xo(b.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Qo)(V)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,o,l,P),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],k.CancellationToken.None))[0]?new d.$Xo(b.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Xo(b.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const U=await this.z.getManifest(I,k.CancellationToken.None);if(U===null)throw new d.$Xo(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(U.version!==I.version)throw new d.$Xo(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:U}}async O(s,o,l,P){const I=await this.getTargetPlatform();let z=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(z=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null),!z&&await this.z.isExtensionCompatible(s,l,I,P)&&(z=s),z||(o?z=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null:z=await this.z.getCompatibleExtension(s,l,I,P)),z}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},P=X=>`${X.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(P(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const z=X=>{const _=this.Z(X,l);return this.m.set(P(_.extension.identifier),_),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.t.fire({identifier:X.identifier,profileLocation:l.profileLocation,applicationScoped:X.isApplicationScoped}),_},N=(X,_)=>{_?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString(),_.message):this.F.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,_.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$sp)(X),error:_}),this.u.fire({identifier:X.identifier,error:_?.code,profileLocation:l.profileLocation,applicationScoped:X.isApplicationScoped})},U=[],V=[];try{U.push(z(s));const X=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const _=this.S(s,X);for(const K of _)this.m.has(P(K.identifier))?this.F.info("Extensions is already requested to uninstall",K.identifier.id):U.push(z(K))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(U.map(_=>_.extension),X,s),await this.L(U.map(async _=>{try{if(await _.run(),await this.L(this.y.map(K=>K.postUninstall(_.extension,l,k.CancellationToken.None))),_.extension.identifier.uuid)try{await this.z.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}N(_.extension)}catch(K){const le=K instanceof d.$Xo?K:new d.$Xo((0,A.$0)(K),d.ExtensionManagementErrorCode.Internal);throw N(_.extension,le),le}finally{V.push(_)}}))}catch(X){const _=X instanceof d.$Xo?X:new d.$Xo((0,A.$0)(X),d.ExtensionManagementErrorCode.Internal);for(const K of U){try{K.cancel()}catch{}V.includes(K)||N(K.extension,_)}throw _}finally{for(const X of U)this.m.delete(P(X.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}Q(s,o,l){for(const P of s){const I=this.U(P,o);if(I.length){const z=I.filter(N=>!s.some(U=>(0,$.$lp)(U.identifier,N.identifier)));if(z.length)throw new Error(this.R(P,z,l))}}}R(s,o,l){return l===s?o.length===1?b.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?b.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):b.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?b.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?b.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):b.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const P=s.manifest.extensionPack?s.manifest.extensionPack:[];if(P.length){const I=o.filter(N=>!N.isBuiltin&&P.some(U=>(0,$.$lp)({id:U},N.identifier))),z=[];for(const N of I)z.push(...this.S(N,o,l));return[...I,...z]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,$.$lp)({id:P},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$bq=h,e.$bq=h=$e([oe(0,d.$Wo),oe(1,c.$Sl),oe(2,v.$rl),oe(3,R.$Tj),oe(4,m.$ak),oe(5,w.$tl)],h);function p(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}function i(n){if(n instanceof d.$Xo)return n;if(n instanceof d.$Yo){const o=new d.$Xo(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Xo(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function r(n,s,{extensionData:o,verificationStatus:l,duration:P,error:I,durationSinceUpdate:z}){let N,U;(0,a.$9f)(l)&&(l===!0?l="Verified":(l===!1||(N=d.ExtensionManagementErrorCode.Signature,U=l),l="Unverified")),I&&(I instanceof d.$Xo||I instanceof d.$Yo?(N=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(U=I.message)):N=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:P,errorcode:N,errorcodeDetail:U,durationSinceUpdate:z})}class t{constructor(){this.d=new D.$mh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,D.$ah)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$ah)(s=>new Promise((o,l)=>{const P=s.onCancellationRequested(()=>{P.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$eq=t}),define(se[42],re([0,1,8,14,2,5,31,11,21,26,13,10,6,24,23,3,9,22]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v||(e.ExtensionsProfileScanningErrorCode=v={}));class w extends Error{constructor(t,n){super(t),this.code=n}}e.$fq=w,e.$gq=(0,b.$ni)("IExtensionsProfileScannerService");let h=class extends k.$Uc{constructor(t,n,s,o,l,P){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=P,this.b=this.B(new A.$_d),this.onAddExtensions=this.b.event,this.c=this.B(new A.$_d),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$_d),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$_d),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n,s){const o=[],l=[];try{return await this.u(n,P=>{const I=[];if(s)I.push(...P);else for(const z of P)t.some(([N])=>(0,a.$lp)(N.identifier,z.identifier)&&N.manifest.version!==z.version)?o.push(z):I.push(z);for(const[z,N]of t){const U=I.findIndex(X=>(0,a.$lp)(X.identifier,z.identifier)&&X.version===z.manifest.version),V={identifier:z.identifier,version:z.manifest.version,location:z.location,metadata:N};U===-1?(l.push(V),I.push(V)):I.splice(U,1,V)}return l.length&&this.b.fire({extensions:l,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),l.length&&this.c.fire({extensions:l,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),l}catch(P){throw l.length&&this.c.fire({extensions:l,error:P,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:P,profileLocation:n}),P}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const P of o){const I=t.find(([z])=>(0,a.$lp)(z.identifier,P.identifier)&&z.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},s.push(P)),l.push(P)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const P of o)(0,a.$lp)(P.identifier,t.identifier)?s.push(P):l.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,g.$$k)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new w((0,m.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const I of l){p(I)||this.w(t);let z;if((0,R.$1f)(I.relativeLocation)&&I.relativeLocation)z=this.z(I.relativeLocation);else if((0,R.$1f)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{z=S.URI.revive(I.location);const N=this.y(z);N&&(P=!0,I.relativeLocation=N)}(0,R.$8f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(P=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:z,version:I.version,metadata:I.metadata})}P&&await this.m.writeFile(t,D.$ze.fromString(JSON.stringify(l)))}if(n){o=n(o);const P=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,D.$ze.fromString(JSON.stringify(P)))}return o})}w(t){const n=new w(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,g.$$k)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(P=>p(P))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ze.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,g.$$k)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,g.$$k)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,g.$$k)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new j.$uh,this.h.set(t,n)),n}};e.$hq=h,e.$hq=h=$e([oe(1,g.$Tk),oe(2,$.$tl),oe(3,y.$rl),oe(4,c.$Sl),oe(5,d.$Tj)],h);function p(r){return(0,R.$3f)(r)&&(0,u.$Vo)(r.identifier)&&(i(r.location)||(0,R.$1f)(r.location)&&r.location)&&((0,R.$8f)(r.relativeLocation)||(0,R.$1f)(r.relativeLocation))&&r.version&&(0,R.$1f)(r.version)}function i(r){return r?(0,R.$1f)(r.path)&&(0,R.$1f)(r.scheme):!1}}),define(se[53],re([0,1,19,8,27,14,9,38,82,2,15,16,12,17,44,55,3,11,98,18,26,37,50,13,10,6,32,5,47,42,24,23,116]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w,h,p,i,r,t,n,s,o,l,P,I,z,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$mq=e.$lq=e.$kq=e.Translations=void 0,e.$nq=le;var U;(function(ae){function B(Q,q){if(Q===q)return!0;const M=Object.keys(Q),W=new Set;for(const Z of Object.keys(q))W.add(Z);if(M.length!==W.size)return!1;for(const Z of M){if(Q[Z]!==q[Z])return!1;W.delete(Z)}return W.size===0}ae.equals=B})(U||(e.Translations=U={})),e.$kq=(0,t.$ni)("IExtensionsScannerService");let V=class extends a.$Uc{constructor(B,Q,q,M,W,Z,Y,te,T,F,f,E){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Q,this.r=q,this.s=M,this.t=W,this.u=Z,this.w=Y,this.y=te,this.z=T,this.C=F,this.D=f,this.F=E,this.g=this.B(new o.$_d),this.onDidChangeCache=this.g.event,this.h=(0,$.$1g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(_,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$wp)(this.w,this.y)),this.G}async scanAllExtensions(B,Q,q){const[M,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Q)]),Z=q?await this.scanExtensionsUnderDevelopment(B,[...M,...W]):[];return this.L(M,W,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Q=[];Q.push(this.M(!!B.useCache,B.language)),Q.push(this.N(B.language,!!B.checkControlFile));const[q,M]=await Promise.all(Q);return this.J([...q,...M],0,B,!1)}async scanUserExtensions(B){const Q=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const q=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(Q,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,q,B.productVersion??this.R()),W=B.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let Z;try{Z=await W.scanExtensions(M)}catch(Y){if(Y instanceof P.$fq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await W.scanExtensions(M);else throw Y}return Z=await this.J(Z,1,B,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===g.Schemas.file).map(async M=>{const W=await this.P(M,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=Q.find(te=>(0,h.$lp)(te.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,W)))}))).flat();return this.J(q,"development",B,!0)}return[]}async scanExistingExtension(B,Q,q){const M=await this.P(B,!1,Q,!0,q.language,!0,void 0,q.productVersion??this.R()),W=await this.n.scanExtension(M);return!W||!q.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,Q,q){const M=await this.P(B,!1,Q,!0,q.language,!0,void 0,q.productVersion??this.R()),W=await this.n.scanOneOrMultipleExtensions(M);return this.J(W,Q,q,!0)}async scanMultipleExtensions(B,Q,q){const M=[];return await Promise.all(B.map(async W=>{const Z=await this.scanOneOrMultipleExtensions(W,Q,q);M.push(...Z)})),this.J(M,Q,q,!0)}async scanMetadata(B){const Q=(0,$.$1g)(B,"package.json"),q=(await this.w.readFile(Q)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(B,Q){const q=(0,$.$1g)(B,"package.json"),M=(await this.w.readFile(q)).value.toString(),W=JSON.parse(M);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,W.__metadata={...W.__metadata,...Q},await this.w.writeFile((0,$.$1g)(B,"package.json"),A.$ze.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof P.$fq&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ze.fromString(JSON.stringify([])))}catch(Q){(0,r.$$k)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Q,q,M){return q.includeAllVersions||(B=this.L(Q===0?B:void 0,Q===1?B:void 0,Q==="development"?B:void 0,await this.getTargetPlatform(),M)),q.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,Z)=>{const Y=b.$oc(W.location.fsPath),te=b.$oc(Z.location.fsPath);return Y<te?-1:Y>te?1:0})}L(B,Q,q,M,W){const Z=(te,T,F)=>{if(te.isValid&&!T.isValid)return!1;if(te.isValid===T.isValid){if(W&&y.gt(te.manifest.version,T.manifest.version))return this.y.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(y.eq(te.manifest.version,T.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${T.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===M)return this.y.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${te.location.path} with ${T.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${T.location.path}.`),!0},Y=new p.$Km;return B?.forEach(te=>{const T=Y.get(te.identifier.id);(!T||Z(T,te,!1))&&Y.set(te.identifier.id,te)}),Q?.forEach(te=>{const T=Y.get(te.identifier.id);if(!T&&B&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!T||Z(T,te,!1))&&Y.set(te.identifier.id,te)}),q?.forEach(te=>{const T=Y.get(te.identifier.id);(!T||Z(T,te,!0))&&Y.set(te.identifier.id,te),Y.set(te.identifier.id,te)}),[...Y.values()]}async M(B,Q){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0,this.R()),W=await(B&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",W.length),W}async N(B,Q){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const M=Q?await this.O():{},W=[],Z=c.URI.file(b.$ic(b.$kc(g.$Hg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of q){const T=M[te.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":W.push((0,$.$1g)(Z,te.name));break;default:W.push(c.URI.file(T));break}}const Y=await Promise.all(W.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,j.$Hb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Q,q,M,W,Z,Y,te){const T=await this.f(W??d.$w),F=await this.Q(B),f=Q&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=f?await this.Q(f):void 0;return new X(B,F,f,E,Q,Y,q,M,Z,te.version,te.date,this.C.commit,!this.z.isBuilt,W,T)}async Q(B){try{const Q=await this.w.stat(B);if(typeof Q.mtime=="number")return Q.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$lq=V,e.$lq=V=$e([oe(4,I.$tl),oe(5,P.$gq),oe(6,r.$Tk),oe(7,n.$Tj),oe(8,w.$ui),oe(9,s.$ak),oe(10,z.$rl),oe(11,t.$mi)],V);class X{constructor(B,Q,q,M,W,Z,Y,te,T,F,f,E,L,C,G){this.location=B,this.mtime=Q,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=M,this.profile=W,this.profileScanOptions=Z,this.type=Y,this.excludeObsolete=te,this.validate=T,this.productVersion=F,this.productDate=f,this.productCommit=E,this.devMode=L,this.language=C,this.translations=G}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Q){return(0,$.$Tg)(B.location,Q.location)&&B.mtime===Q.mtime&&(0,$.$Tg)(B.applicationExtensionslocation,Q.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&B.profile===Q.profile&&k.$Xn(B.profileScanOptions,Q.profileScanOptions)&&B.type===Q.type&&B.excludeObsolete===Q.excludeObsolete&&B.validate===Q.validate&&B.productVersion===Q.productVersion&&B.productDate===Q.productDate&&B.productCommit===Q.productCommit&&B.devMode===Q.devMode&&B.language===Q.language&&U.equals(B.translations,Q.translations)}}e.$mq=X;let _=class extends a.$Uc{constructor(B,Q,q,M,W){super(),this.f=B,this.g=Q,this.h=q,this.j=M,this.m=W}async scanExtensions(B){const Q=B.profile?await this.r(B):await this.n(B);let q={};if(B.excludeObsolete&&B.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(M)}catch{}return(0,m.$bg)(q)?Q:Q.filter(M=>!q[h.$mp.create(M).toString()])}async n(B){const Q=await this.j.resolve(B.location);if(!Q.children?.length)return[];const q=await Promise.all(Q.children.map(async M=>{if(!M.isDirectory||B.type===1&&(0,$.$Xg)(M.resource).indexOf(".")===0)return null;const W=new X(M.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,j.$Hb)(q).sort((M,W)=>M.location.path<W.location.path?-1:1)}async r(B){let Q=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){Q=Q.filter(M=>!M.metadata?.isApplicationScoped);const q=await this.s(B.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,B);Q.push(...q)}return Q}async s(B,Q,q){const M=await this.g.scanProfileExtensions(B,q.profileScanOptions);if(!M.length)return[];const W=await Promise.all(M.map(async Z=>{if(Q(Z)){const Y=new X(Z.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Y,Z.metadata)}return null}));return(0,j.$Hb)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,$.$1g)(B.location,"package.json"))){const Q=await this.scanExtension(B);return Q?[Q]:[]}else return await this.scanExtensions(B)}catch(Q){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,O.$0)(Q)),[]}}async scanExtension(B,Q){try{let q=await this.scanExtensionManifest(B.location);if(q){q.publisher||(q.publisher=p.$Em),Q=Q??q.__metadata,delete q.__metadata;const M=(0,h.$qp)(q.publisher,q.name),W=Q?.id?{id:M,uuid:Q.id}:{id:M},Z=Q?.isSystem?0:B.type,Y=Z===0||!!Q?.isBuiltin;q=await this.t(B.location,q,X.createNlsConfiguration(B));const te={type:Z,identifier:W,manifest:q,location:B.location,isBuiltin:Y,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return B.validate?this.validate(te,B):te}}catch(q){B.type!==0&&this.m.error(q)}return null}validate(B,Q){let q=!0;const M=(0,i.$Bp)(Q.productVersion,Q.productDate,Q.location,B.manifest,B.isBuiltin);for(const[W,Z]of M)W===R.default.Error&&(q=!1,this.m.error(this.z(Q.location,Z)));return B.isValid=q,B.validations=M,B}async scanExtensionManifest(B){const Q=(0,$.$1g)(B,"package.json");let q;try{q=(await this.j.readFile(Q)).value.toString()}catch(W){return(0,r.$$k)(W)!==1&&this.m.error(this.z(B,(0,v.localize)(0,null,Q.path,W.message))),null}let M;try{M=JSON.parse(q)}catch{const Z=[];(0,S.$An)(q,Z);for(const Y of Z)this.m.error(this.z(B,(0,v.localize)(1,null,Q.path,Y.offset,Y.length,(0,u.$iq)(Y.error))));return null}return(0,S.$Jn)(M)!=="object"?(this.m.error(this.z(B,(0,v.localize)(2,null,Q.path))),null):M}async t(B,Q,q){const M=await this.u(B,Q,q);if(M)try{const W=[],Z=await this.w(M.default,W);if(W.length>0)return W.forEach(te=>{this.m.error(this.z(B,(0,v.localize)(3,null,M.default?.path,(0,u.$iq)(te.error))))}),Q;if((0,S.$Jn)(M)!=="object")return this.m.error(this.z(B,(0,v.localize)(4,null,M.default?.path))),Q;const Y=M.values||Object.create(null);return(0,N.$jq)(this.m,Q,Y,Z)}catch{}return Q}async u(B,Q,q){const M=(0,$.$1g)(B,"package.nls.json"),W=(T,F)=>{F.forEach(f=>{this.m.error(this.z(B,(0,v.localize)(5,null,T?.path,(0,u.$iq)(f.error))))})},Z=T=>{this.m.error(this.z(B,(0,v.localize)(6,null,T?.path)))},Y=`${Q.publisher}.${Q.name}`,te=q.translations[Y];if(te)try{const T=c.URI.file(te),F=(await this.j.readFile(T)).value.toString(),f=[],E=(0,S.$An)(F,f);return f.length>0?(W(T,f),{values:void 0,default:M}):(0,S.$Jn)(E)!=="object"?(Z(T),{values:void 0,default:M}):{values:E.contents?E.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let F;try{F=await this.y(B,q)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const f=(await this.j.readFile(F.localized)).value.toString(),E=[],L=(0,S.$An)(f,E);return E.length>0?(W(F.localized,E),{values:void 0,default:F.original}):(0,S.$Jn)(L)!=="object"?(Z(F.localized),{values:void 0,default:F.original}):{values:L,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,Q){if(B)try{const q=(await this.j.readFile(B)).value.toString();return(0,S.$An)(q,Q)}catch{}}y(B,Q){return new Promise((q,M)=>{const W=Z=>{const Y=(0,$.$1g)(B,`package.nls.${Z}.json`);this.j.exists(Y).then(te=>{te&&q({localized:Y,original:(0,$.$1g)(B,"package.nls.json")});const T=Z.lastIndexOf("-");T===-1?q({localized:(0,$.$1g)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,T),W(Z))})};if(Q.devMode||Q.pseudo||!Q.language)return q({localized:(0,$.$1g)(B,"package.nls.json"),original:null});W(Q.language)})}z(B,Q){return`[${B.path}]: ${Q}`}};_=$e([oe(1,P.$gq),oe(2,z.$rl),oe(3,r.$Tk),oe(4,n.$Tj)],_);let K=class extends _{constructor(B,Q,q,M,W,Z,Y){super(Q,M,W,Z,Y),this.G=B,this.H=q,this.D=this.B(new D.$lh(3e3)),this.F=this.B(new o.$_d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const Q=this.M(B),q=await this.I(Q);if(this.C=B,q&&q.input&&X.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),q.result.map(W=>(W.location=c.URI.revive(W.location),W));const M=await super.scanExtensions(B);return await this.J(Q,{input:B,result:M}),M}async I(B){try{const Q=await this.j.readFile(B),q=JSON.parse(Q.value.toString());return{result:q.result,input:(0,l.$Wh)(q.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",B.path,(0,O.$0)(Q))}return null}async J(B,Q){try{await this.j.writeFile(B,A.$ze.fromString(JSON.stringify(Q)))}catch(q){this.m.debug("Error while writing the extension cache file:",B.path,(0,O.$0)(q))}}async L(){if(!this.C)return;const B=this.M(this.C),Q=await this.I(B);if(!Q)return;const q=Q.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$Xn(M,q))try{this.m.info("Invalidating Cache",q,M),await this.j.del(B),this.F.fire()}catch(W){this.m.error(W)}}M(B){const Q=this.N(B);return this.h.extUri.joinPath(Q.cacheHome,B.type===0?p.$Dm:p.$Cm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(B.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};K=$e([oe(2,I.$tl),oe(3,P.$gq),oe(4,z.$rl),oe(5,r.$Tk),oe(6,n.$Tj)],K);function le(ae,B){const Q=(0,h.$op)(ae.manifest.publisher,ae.manifest.name);return{id:Q,identifier:new p.$Im(Q),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}class ue extends V{constructor(B,Q,q,M,W,Z,Y,te,T,F,f,E){super(B,Q,(0,$.$1g)(q,".vscode-oss-dev","extensions","control.json"),M,W,Z,Y,te,T,F,f,E),this.S=(async()=>{if(d.$z)try{const L=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$oq=ue}),define(se[161],re([0,1,59,8,34,5,2,15,16,25,6,24]),function(J,e,j,D,k,A,O,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;let d=class extends O.$Uc{constructor(y,R){super(),this.b=y,this.f=R,this.a=new D.$th(5)}async postUninstall(y){const R=this.g(y,"uninstall");R&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(m)}}));try{await a.Promises.rm(this.m(y))}catch(m){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(m)}}g(y,R){const m=`vscode:${R}`;if(y.location.scheme===S.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[m]=="string"){const c=y.manifest.scripts[m].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${m} should be a node script`),null):{script:(0,u.$kc)(y.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(y,R,m,c,v){return new Promise((w,h)=>{const p=this.j(y,R,m,v);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):w(void 0)};p.on("error",t=>{r((0,k.$$i)(t)||"Unknown")}),p.on("exit",(t,n)=>{r(t?`post-${R} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,p.kill(),h("timed out")},5e3))})}j(y,R,m,c){const v={silent:!0,execArgv:void 0},w=(0,j.fork)(y,[`--type=extension-post-${R}`,...m],v);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const h=A.Event.fromNodeEventEmitter(w.stdout,"data"),p=A.Event.fromNodeEventEmitter(w.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${R}`,t)),p(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${R}`,t));const i=A.Event.any(A.Event.map(h,t=>({data:`%c${t}`,format:[""]})),A.Event.map(p,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),w}m(y){return(0,u.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};e.$qq=d,e.$qq=d=$e([oe(0,b.$tl),oe(1,g.$Tj)],d)}),define(se[162],re([0,1,8,14,20,34,9,5,43,2,31,15,16,17,44,3,11,28,25,49,99,61,18,160,21,26,42,53,147,161,117,140,148,50,13,10,6,32,22,23,24]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w,h,p,i,r,t,n,s,o,l,P,I,z,N,U,V,X,_,K,le,ue,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=void 0,e.$uq=(0,X.$oi)(t.$Zo);const B=".vsctmp";let Q=class extends r.$bq{constructor(T,F,f,E,L,C,G,H,ne,ce,he,pe){super(T,F,he,f,ce,pe),this.eb=L,this.fb=C,this.gb=G,this.hb=ne,this.db=new Map,this.qb=new g.$Cc;const ye=this.B(H.createInstance(P.$qq));this.ab=this.B(H.createInstance(q,me=>ye.postUninstall(me))),this.bb=this.B(new z.$sq(pe,ne,he,this,this.F)),this.cb=this.B(H.createInstance(l.$pq));const fe=this.B(new N.$tq(this,this.eb,pe,C,he,ne,f));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$wp)(this.hb,this.F)),this.ib}async zip(T){this.F.trace("ExtensionManagementService#zip",T.identifier.id);const F=await this.ob(T),f=await(0,w.zip)((0,$.$1g)(this.cb.extensionsDownloadDir,(0,c.$Jg)()).fsPath,F);return m.URI.file(f)}async unzip(T){return this.F.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:F,cleanup:f}=await this.kb(T),E=d.$lc(F.fsPath);try{return await(0,I.$rq)(E)}finally{await f()}}getInstalled(T,F=this.H.defaultProfile.extensionsResource,f={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(T??null,F,f)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(T){return this.ab.scanUserExtensionAtLocation(T)}async install(T,F={}){this.F.trace("ExtensionManagementService#install",T.toString());const{location:f,cleanup:E}=await this.kb(T);try{const L=await(0,I.$rq)(d.$lc(f.fsPath)),C=(0,n.$qp)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,U.$Dp)(L.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:L,extension:f,options:F}])).find(({identifier:ne})=>(0,n.$lp)(ne,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,r.$dq)(new Error(`Unknown error while installing extension ${C}`))}finally{await E()}}async installFromLocation(T,F){this.F.trace("ExtensionManagementService#installFromLocation",T.toString());const f=await this.ab.scanUserExtensionAtLocation(T);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.tb([[f,{source:"resource"}]],F),this.F.info("Successfully installed extension",f.identifier.id,F.toString()),f}async installExtensionsFromProfile(T,F,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",T,F.toString(),f.toString());const E=(await this.getInstalled(1,F)).filter(L=>T.some(C=>(0,n.$lp)(C,L.identifier)));if(E.length){const L=await Promise.all(E.map(C=>this.ab.scanMetadata(C,F)));await this.tb(E.map((C,G)=>[C,L[G]]),f),this.F.info("Successfully installed extensions",E.map(C=>C.identifier.id),f.toString())}return E}async updateMetadata(T,F,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",T.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),T=await this.ab.updateMetadata(T,F,f),this.bb.invalidate(f),this.w.fire(T),T}async reinstallFromGallery(T){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const F=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(T);try{await this.ab.removeUninstalledExtension(T)}catch(E){throw new Error(h.localize(3,null,(0,A.$$i)(E)))}return this.installFromGallery(f)}$(T,F,f,E){return this.ab.copyExtension(T,F,f,E)}copyExtensions(T,F){return this.ab.copyExtensions(T,F,{version:this.G.version,date:this.G.date})}markAsUninstalled(...T){return this.ab.setUninstalled(...T)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(T){this.F.error(T)}}async download(T,F,f){const{location:E}=await this.cb.download(T,F,!f);return E}async kb(T){if(T.scheme===b.Schemas.file)return{location:T,async cleanup(){}};this.F.trace("Downloading extension from",T.toString());const F=(0,$.$1g)(this.cb.extensionsDownloadDir,(0,c.$Jg)());return await this.gb.download(T,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(T,F,f){if(m.URI.isUri(F))return new Z(T,F,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const E=n.$mp.create(F).toString();let L=this.db.get(E);return L||(this.db.set(E,L=new W(T,F,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),L.waitUntilTaskIsFinished().finally(()=>this.db.delete(E))),L}Z(T,F){return new Y(T,F.profileLocation,this.fb)}async ob(T){const F=async E=>{let L=await v.Promises.readdir(E);L=L.map(H=>d.$kc(E,H));const C=await Promise.all(L.map(H=>v.Promises.stat(H)));let G=Promise.resolve([]);return C.forEach((H,ne)=>{const ce=L[ne];H.isFile()&&(G=G.then(he=>[...he,ce])),H.isDirectory()&&(G=G.then(he=>F(ce).then(pe=>[...he,...pe])))}),G};return(await F(T.location.fsPath)).map(E=>({path:`extension/${d.$mc(T.location.fsPath,E)}`,localPath:E}))}async pb({added:T,removed:F}){if(F){const f=T&&this.D.extUri.isEqual(F.profileLocation,T.profileLocation)?F.extensions.filter(E=>T.extensions.every(L=>!(0,n.$lp)(L,E))):F.extensions;for(const E of f)this.F.info("Extensions removed from another source",E.id,F.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:F.profileLocation})}if(T){const E=(await this.getInstalled(1,T.profileLocation)).filter(L=>T.extensions.some(C=>(0,n.$lp)(C,L.identifier)));this.s.fire(E.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,T.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:T.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const T=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of T.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(T){if(!T.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const f of T.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(f);E&&E.installedTimestamp===void 0&&(this.qb.add(f),F.push(E))}F.length&&(await this.tb(F.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(f=>f.identifier.id)))}async tb(T,F){const f=T.map(E=>E[0]);await this.ub(f),await this.fb.addExtensionsToProfile(T,F),this.s.fire(f.map(E=>({local:E,identifier:E.identifier,operation:1,profileLocation:F})))}async ub(T){const F=await this.ab.getUninstalledExtensions();for(const f of T){const E=n.$mp.create(f);F[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$vq=Q,e.$vq=Q=$e([oe(0,t.$Wo),oe(1,le.$Sl),oe(2,_.$Tj),oe(3,i.$vi),oe(4,o.$kq),oe(5,s.$gq),oe(6,p.$Bo),oe(7,X.$mi),oe(8,V.$Tk),oe(9,K.$ak),oe(10,ue.$rl),oe(11,ae.$tl)],Q);let q=class extends a.$Uc{constructor(T,F,f,E,L,C){super(),this.j=T,this.m=F,this.n=f,this.s=E,this.t=L,this.u=C,this.h=this.B(new S.$_d),this.onExtract=this.h.event,this.c=(0,$.$1g)(this.n.userExtensionsLocation,".obsolete"),this.g=new j.$uh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(T,F,f){const E={includeInvalid:!0,profileLocation:F,productVersion:f};let L=[];return T===null||T===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},E,!1)):T===1&&L.push(...await this.n.scanUserExtensions(E)),L=T!==null?L.filter(C=>C.type===T):L,Promise.all(L.map(C=>this.F(C)))}async scanAllUserExtensions(T){const F=await this.n.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(F.map(f=>this.F(f)))}async scanUserExtensionAtLocation(T){try{const F=await this.n.scanExistingExtension(T,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(T,F,f,E,L){const C=T.toString(),G=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Jg)()}`)),H=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,C));let ne=await this.m.exists(H);if(ne&&E){try{await this.y(T.id,H,"removeExisting")}catch{throw new t.$Xo(h.localize(4,null,H.fsPath,T.id),t.ExtensionManagementErrorCode.Delete)}ne=!1}if(ne)await this.n.updateMetadata(H,f);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${H.fsPath}`),await(0,w.$_p)(F,G.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${H}:`,T.id)}catch(ce){let he=t.ExtensionManagementErrorCode.Extract;throw ce instanceof w.$0p&&(ce.type==="CorruptZip"?he=t.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(he=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Xo(ce.message,he)}await this.n.updateMetadata(G,f);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${H.fsPath}`),await this.C(G.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(ce)}. Deleted from extracted location`,G),ce}this.h.fire(H)}catch(ce){try{await this.m.del(G,{recursive:!0})}catch{}throw ce}return this.D(H,1)}async scanMetadata(T,F){return F?(await this.w(T,F))?.metadata:this.n.scanMetadata(T.location)}async w(T,F){return(await this.s.scanProfileExtensions(F)).find(E=>(0,n.$lp)(E.identifier,T.identifier))}async updateMetadata(T,F,f){return f?await this.s.updateMetadata([[T,F]],f):await this.n.updateMetadata(T.location,F),this.D(T.location,T.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...T){const F=T.map(f=>n.$mp.create(f));await this.z(f=>F.forEach(E=>{f[E.toString()]=!0,this.u.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(T){await this.z(F=>delete F[T.toString()])}async removeExtension(T,F){if(this.t.extUri.isEqualOrParent(T.location,this.n.userExtensionsLocation))return this.y(T.identifier.id,T.location,F)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.z(F=>delete F[n.$mp.create(T).toString()])}async copyExtension(T,F,f,E){const L=await this.w(T,F),C=await this.w(T,f);if(E={...L?.metadata,...E},C)if(this.t.extUri.isEqual(C.location,T.location))await this.s.updateMetadata([[T,{...C.metadata,...E}]],f);else{const G=await this.D(C.location,T.type,f);await this.s.removeExtensionFromProfile(G,f),await this.s.addExtensionsToProfile([[T,{...C.metadata,...E}]],f)}else await this.s.addExtensionsToProfile([[T,E]],f);return this.D(T.location,T.type,f)}async copyExtensions(T,F,f){const E=await this.scanExtensions(1,T,f),L=await Promise.all(E.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,T)]));await this.s.addExtensionsToProfile(L,F)}async y(T,F,f){this.u.trace(`Deleting ${f} extension from disk`,T,F.fsPath);const E=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,u.$bj)((0,c.$Jg)()).toString(16)}${B}`);await this.C(F.fsPath,E.fsPath),await this.m.del(E,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,T,F.fsPath)}async z(T){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,V.$$k)(E)!==1)throw E}let f={};if(F)try{f=JSON.parse(F)}catch{}return T&&(T(f),Object.keys(f).length?await this.m.writeFile(this.c,D.$ze.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(T,F){try{await v.Promises.rename(T,F,2*60*1e3)}catch(f){throw new t.$Xo(f.message||h.localize(5,null,T,F),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(T,F,f){if(f){const L=(await this.n.scanUserExtensions({profileLocation:f})).find(C=>this.t.extUri.isEqual(C.location,T));if(L)return this.F(L)}else{const E=await this.n.scanExistingExtension(T,F,{includeInvalid:!0});if(E)return this.F(E)}throw new Error(h.localize(6,null,T.path))}async F(T){const F=await this.m.resolve(T.location);let f,E;return F.children&&(f=F.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,E=F.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:f,changelogUrl:E,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!T.metadata?.hasPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated,pinned:!!T.metadata?.pinned,isWorkspaceScoped:!1,source:T.metadata?.source??(T.identifier.uuid?"gallery":"vsix")}}async G(){const T=await this.getUninstalledExtensions();if(Object.keys(T).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(T));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const L of F)T[n.$mp.create(L).toString()]||f.add(L.identifier.id.toLowerCase());try{const L=(0,n.$rp)(F,C=>C.identifier);await j.Promises.settled(L.map(async C=>{const G=C.sort((H,ne)=>y.rcompare(H.manifest.version,ne.manifest.version))[0];f.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(L){this.u.error(L)}const E=F.filter(L=>L.metadata&&T[n.$mp.create(L).toString()]);await Promise.allSettled(E.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let T;try{T=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,V.$$k)(F)!==1&&this.u.error(F);return}if(T?.children)try{await Promise.allSettled(T.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(f){(0,V.$$k)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$wq=q,e.$wq=q=$e([oe(1,V.$Tk),oe(2,o.$kq),oe(3,s.$gq),oe(4,ue.$rl),oe(5,_.$Tj)],q);class M extends r.$eq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.$8f)(this.options.operation)?this.l:this.options.operation}constructor(T,F,f,E,L,C,G,H,ne,ce){super(),this.manifest=T,this.identifier=F,this.source=f,this.options=E,this.m=L,this.n=C,this.o=G,this.p=H,this.q=ne,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(T){const[F,f]=await this.x(T);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,f]],this.j,!F.isValid),F}async u({zipPath:T,key:F,metadata:f},E,L){let C=await this.v(F);return C?C=await this.m.updateMetadata(C,f):(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,T,f,E,L),this.s.info("Extracting extension completed.",F.id)),C}async v(T){return await this.w(T)?(this.s.trace("Removing the extension from uninstalled list:",T.id),await this.m.setInstalled(T),this.s.info("Removed the extension from uninstalled list:",T.id),(await this.m.scanAllUserExtensions(!0)).find(E=>n.$mp.create(E).equals(T))):void 0}async w(T){return!!(await this.m.getUninstalledExtensions())[T.toString()]}}class W extends M{constructor(T,F,f,E,L,C,G,H,ne,ce,he){super(T,F.identifier,F,f,L,C,G,H,ne,ce),this.y=F,this.z=E,this.A=he}async x(T){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(L){throw new t.$Xo(L,t.ExtensionManagementErrorCode.Scanning)}const f=F.find(L=>(0,n.$lp)(L.identifier,this.y.identifier));f&&(this.l=3);const E={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,R.$7f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease,source:"gallery"};if(f&&f.type!==0&&f.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,E),E]}catch(L){throw new t.$Xo((0,O.$0)(L),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(E,T)}catch(L){if(L instanceof t.$Xo&&(L.code===t.ExtensionManagementErrorCode.CorruptZip||L.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const C=await this.C(E,T);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),C}catch(C){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),C}}else throw L}}async C(T,F){const{location:f,verificationStatus:E}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=E,this.D(f.fsPath),[await this.u({zipPath:f.fsPath,key:n.$mp.create(this.y),metadata:T},!1,F),T]}catch(L){try{await this.z.delete(f)}catch(C){this.s.warn("Error while deleting the downloaded file",f.toString(),(0,O.$0)(C))}throw L}}async D(T){try{await(0,I.$rq)(T)}catch(F){throw new t.$Xo((0,r.$cq)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$xq=W;class Z extends M{constructor(T,F,f,E,L,C,G,H,ne,ce){super(T,{id:(0,n.$qp)(T.publisher,T.name)},F,f,L,C,G,H,ne,ce),this.y=F,this.z=E}async h(T){const F=await super.h(T);return this.C(F,T),F}async x(T){const F=new n.$mp(this.identifier,this.manifest.version),E=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,n.$lp)(this.identifier,G.identifier)),L={isApplicationScoped:this.options.isApplicationScoped||E?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||E?.isMachineScoped,isBuiltin:this.options.isBuiltin||E?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??E?.pinned,source:"vsix"};if(E)if(this.l=3,F.equals(new n.$mp(E.identifier,E.manifest.version)))try{await this.m.removeExtension(E,"existing")}catch{throw new Error(h.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&y.gt(E.manifest.version,this.manifest.version)&&await this.m.setUninstalled(E);else{const G=await this.v(F);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(h.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:d.$lc(this.y.fsPath),key:F,metadata:L},!0,T),L]}async C(T,F){try{let[f]=await this.z.getExtensions([{id:T.identifier.id,version:T.manifest.version}],F);if(f||([f]=await this.z.getExtensions([{id:T.identifier.id}],F)),f){const E={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:T.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(T,E,this.options.profileLocation)}}catch{}}}class Y extends r.$eq{constructor(T,F,f){super(),this.extension=T,this.j=F,this.k=f}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],re([0,1,6,24,23,22,42,13,18,11]),function(J,e,j,D,k,A,O,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;let g=class extends O.$hq{constructor(d,$,y,R,m,c){super(a.URI.file(d.extensionsPath),$,y,R,m,c)}};e.$fQ=g,e.$fQ=g=$e([oe(0,u.$vi),oe(1,S.$Tk),oe(2,D.$tl),oe(3,k.$rl),oe(4,A.$Sl),oe(5,j.$Tj)],g)}),define(se[164],re([0,1,11,18,42,53,13,10,6,32,23,24]),function(J,e,j,D,k,A,O,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;let d=class extends A.$oq{constructor(y,R,m,c,v,w,h,p){super(j.URI.file(v.builtinExtensionsPath),j.URI.file(v.extensionsPath),v.userHome,y.defaultProfile,y,R,m,c,v,w,h,p)}};e.$0bc=d,e.$0bc=d=$e([oe(0,b.$tl),oe(1,k.$gq),oe(2,O.$Tk),oe(3,u.$Tj),oe(4,D.$vi),oe(5,a.$ak),oe(6,g.$rl),oe(7,S.$mi)],d)}),define(se[165],re([0,1,8,5,2,130,3,89,10,24]),function(J,e,j,D,k,A,O,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Tp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Rp=e.$Qp=e.$Pp=void 0,e.$Sp=$,e.$Up=R,e.$Wp=c,e.$Pp="__$__isNewStorageMarker",e.$Qp="__$__targetStorageMarker",e.$Rp=(0,u.$ni)("storageService");var g;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var b;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function $(v){const w=v.get(e.$Qp);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}class y extends k.$Uc{static{this.a=60*1e3}constructor(w={flushInterval:y.a}){super(),this.m=w,this.b=this.B(new D.$ce),this.c=this.B(new D.$ce),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$_d),this.onWillSaveState=this.f.event,this.h=this.B(new j.$zh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(w,h,p){return D.Event.filter(this.b.event,i=>i.scope===w&&(h===void 0||i.key===h),p)}n(){this.j.value=(0,j.$Dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(w,h){const{key:p,external:i}=h;if(p===e.$Qp){switch(w){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:p,target:this.J(w)[p],external:i})}w(w){this.f.fire({reason:w})}get(w,h,p){return this.P(h)?.get(w,p)}getBoolean(w,h,p){return this.P(h)?.getBoolean(w,p)}getNumber(w,h,p){return this.P(h)?.getNumber(w,p)}getObject(w,h,p){return this.P(h)?.getObject(w,p)}storeAll(w,h){this.y(()=>{for(const p of w)this.store(p.key,p.value,p.scope,p.target,h)})}store(w,h,p,i,r=!1){if((0,O.$0f)(h)){this.remove(w,p,r);return}this.y(()=>{this.z(w,p,i),this.P(p)?.set(w,h,r)})}remove(w,h,p=!1){this.y(()=>{this.z(w,h,void 0),this.P(h)?.delete(w,p)})}y(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,h){const p=[],i=this.J(w);for(const r of Object.keys(i))i[r]===h&&p.push(r);return p}z(w,h,p,i=!1){const r=this.J(h);typeof p=="number"?r[w]!==p&&(r[w]=p,this.P(h)?.set(e.$Qp,JSON.stringify(r),i)):typeof r[w]=="number"&&(delete r[w],this.P(h)?.set(e.$Qp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(w){switch(w){case-1:return this.I;case 0:return this.G;default:return this.D}}L(w){const h=this.P(w);return h?$(h):Object.create(null)}isNew(w){return this.getBoolean(e.$Pp,w)===!0}async flush(w=g.NONE){this.f.fire({reason:w});const h=this.P(-1),p=this.P(0),i=this.P(1);switch(w){case g.NONE:await j.Promises.settled([h?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await j.Promises.settled([h?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,p=this.P(1)?.items??new Map;return c(w,h,p,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(w){return await this.flush(),this.P(w)?.optimize()}async switch(w,h){return this.w(g.NONE),(0,a.$sl)(w)?this.R(w,h):this.S(w,h)}M(w,h){return!(w.id===h.id||R(h)&&R(w))}N(w,h,p){this.y(()=>{const i=new Set;for(const[r,t]of w)i.add(r),h.get(r)!==t&&this.u(p,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(p,{key:r,external:!0})})}}e.$Tp=y;function R(v){return v.isDefault||!!v.useDefaultFlags?.globalState}class m extends y{constructor(){super(),this.U=this.B(new S.$Np(new S.$Op,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Np(new S.$Op,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Np(new S.$Op,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(w=>this.u(1,w))),this.B(this.W.onDidChangeStorage(w=>this.u(0,w))),this.B(this.U.onDidChangeStorage(w=>this.u(-1,w)))}P(w){switch(w){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(w){return!1}}e.$Vp=m;async function c(v,w,h,p,i,r){const t=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,s=new Map;v.forEach((U,V)=>{n.set(V,U),s.set(V,t(U))});const o=new Map,l=new Map;w.forEach((U,V)=>{o.set(V,U),l.set(V,t(U))});const P=new Map,I=new Map;h.forEach((U,V)=>{P.set(V,U),I.set(V,t(U))}),console.group(p!==i?`Storage: Application (path: ${p})`:`Storage: Application & Profile (path: ${p}, default profile)`);const z=[];if(n.forEach((U,V)=>{z.push({key:V,value:U})}),console.table(z),console.groupEnd(),console.log(s),p!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];o.forEach((V,X)=>{U.push({key:X,value:V})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const N=[];P.forEach((U,V)=>{N.push({key:V,value:U})}),console.table(N),console.groupEnd(),console.log(I)}}),define(se[166],re([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$Zp=Z;const i=A.$o?"web":(0,b.$So)(A.$u,O.$fc),r="X-Market-Search-Activity-Id";var t;(function(E){E[E.None=0]="None",E[E.IncludeVersions=1]="IncludeVersions",E[E.IncludeFiles=2]="IncludeFiles",E[E.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",E[E.IncludeSharedAccounts=8]="IncludeSharedAccounts",E[E.IncludeVersionProperties=16]="IncludeVersionProperties",E[E.ExcludeNonValidated=32]="ExcludeNonValidated",E[E.IncludeInstallationTargets=64]="IncludeInstallationTargets",E[E.IncludeAssetUri=128]="IncludeAssetUri",E[E.IncludeStatistics=256]="IncludeStatistics",E[E.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",E[E.Unpublished=4096]="Unpublished",E[E.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...E){return String(E.reduce((L,C)=>L|C,0))}var s;(function(E){E[E.Tag=1]="Tag",E[E.ExtensionId=4]="ExtensionId",E[E.Category=5]="Category",E[E.ExtensionName=7]="ExtensionName",E[E.Target=8]="Target",E[E.Featured=9]="Featured",E[E.SearchText=10]="SearchText",E[E.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class z{constructor(L=I){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,C=this.d.pageSize){return new z({...this.d,pageNumber:L,pageSize:C})}withFilter(L,...C){const G=[...this.d.criteria,...C.length?C.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new z({...this.d,criteria:G})}withSortBy(L){return new z({...this.d,sortBy:L})}withSortOrder(L){return new z({...this.d,sortOrder:L})}withFlags(...L){return new z({...this.d,flags:L.reduce((C,G)=>C|G,0)})}withAssetTypes(...L){return new z({...this.d,assetTypes:L})}withSource(L){return new z({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:C,pageSize:G,sortBy:H,sortOrder:ne,flags:ce,assetTypes:he}=this.d;return{filters:[{criteria:L,pageNumber:C,pageSize:G,sortBy:H,sortOrder:ne}],assetTypes:he,flags:ce}}get searchText(){const L=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(E,L){const C=(E||[]).filter(G=>G.statisticName===L)[0];return C?C.value:0}function U(E){const L="Microsoft.VisualStudio.Code.Translation.";return E.files.filter(G=>G.assetType.indexOf(L)===0).reduce((G,H)=>{const ne=_(E,H.assetType);return ne&&G.push([H.assetType.substring(L.length),ne]),G},[])}function V(E){if(E.properties){const L=E.properties.filter(H=>H.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=L.filter(H=>C.test(H.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return _(E,o.Repository)}function X(E){return{uri:`${E.fallbackAssetUri}/${o.VSIX}?redirect=true${E.targetPlatform?`&targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${o.VSIX}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}}function _(E,L){return E.files.filter(G=>G.assetType===L)[0]?{uri:`${E.assetUri}/${L}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${L}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}:null}function K(E,L){const C=E.properties?E.properties.filter(H=>H.key===L):[],G=C.length>0&&C[0].value;return G?G.split(",").map(H=>(0,d.$pp)(H)):[]}function le(E){const L=E.properties?E.properties.filter(C=>C.key===l.Engine):[];return L.length>0&&L[0].value||""}function ue(E){const L=E.properties?E.properties.filter(C=>C.key===l.PreRelease):[];return L.length>0&&L[0].value==="true"}function ae(E){const L=E.properties?E.properties.filter(G=>G.key===l.LocalizedLanguages):[],C=L.length>0&&L[0].value||"";return C?C.split(","):[]}function B(E){return E.properties?.find(L=>L.key===l.SponsorLink)?.value}function Q(E){return E.properties?.find(L=>L.key===l.SupportLink)?.value}function q(E){return E.indexOf("preview")!==-1}function M(E){return E.targetPlatform?(0,b.$Ro)(E.targetPlatform):"undefined"}function W(E){const L=(0,j.$Mb)(E.versions.map(M)),C=!!E.tags?.includes(b.$Mo),G=L.indexOf("web");return C?G===-1&&L.push("web"):G!==-1&&L.splice(G,1),L}function Z(E,L){for(let C=0;C<E.length;C++){const G=E[C];if(G.version===E[C-1]?.version){let H=C;if(M(G)===L)for(;H>0&&E[H-1].version===G.version;)H--;H!==C&&(E.splice(C,1),E.splice(H,0,G))}}return E}function Y(E,L,C){E.telemetryData={index:L,querySource:C,queryActivityId:E.queryContext?.[r]}}function te(E,L,C,G){const H=E.versions[0],ne={manifest:_(L,o.Manifest),readme:_(L,o.Details),changelog:_(L,o.Changelog),license:_(L,o.License),repository:V(L),download:X(L),icon:_(L,o.Icon),signature:_(L,o.Signature),coreTranslations:U(L)};return{identifier:{id:(0,d.$qp)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},name:E.extensionName,version:L.version,displayName:E.displayName,publisherId:E.publisher.publisherId,publisher:E.publisher.publisherName,publisherDisplayName:E.publisher.displayName,publisherDomain:E.publisher.domain?{link:E.publisher.domain,verified:!!E.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(H),description:E.shortDescription??"",installCount:N(E.statistics,"install"),rating:N(E.statistics,"averagerating"),ratingCount:N(E.statistics,"ratingcount"),categories:E.categories||[],tags:E.tags||[],releaseDate:Date.parse(E.releaseDate),lastUpdated:Date.parse(E.lastUpdated),allTargetPlatforms:C,assets:ne,properties:{dependencies:K(L,l.Dependency),extensionPack:K(L,l.ExtensionPack),engine:le(L),localizedLanguages:ae(L),targetPlatform:M(L),isPreReleaseVersion:ue(L)},hasPreReleaseVersion:ue(H),hasReleaseVersion:!0,preview:q(E.flags),isSigned:!!ne.signature,queryContext:G,supportLink:Q(H)}}let T=class{constructor(L,C,G,H,ne,ce,he,pe){this.k=C,this.l=G,this.n=H,this.o=ne,this.q=ce,this.u=he,this.w=pe;const ye=he.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,v.$Yp)(he.version,he,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,C,G){const H=D.CancellationToken.isCancellationToken(C)?{}:C,ne=D.CancellationToken.isCancellationToken(C)?C:G,ce=[],he=[],pe=[],ye=[];let fe=!0;for(const we of L){we.uuid?he.push(we.uuid):ce.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!he.length&&!ce.length)return[];let me=new z().withPage(1,L.length);he.length&&(me=me.withFilter(s.ExtensionId,...he)),ce.length&&(me=me.withFilter(s.ExtensionName,...ce)),(H.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),H.source&&(me=me.withSource(H.source));const{extensions:de}=await this.z(me,{targetPlatform:H.targetPlatform??i,includePreRelease:pe,versions:ye,compatible:!!H.compatible,productVersion:H.productVersion??{version:this.u.version,date:this.u.date}},ne);return H.source&&de.forEach((we,Ee)=>Y(we,Ee,H.source)),de}async getCompatibleExtension(L,C,G,H={version:this.u.version,date:this.u.date}){if((0,b.$To)(L.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(L,C,G))return L;const ne=new z().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,L.identifier.uuid),{extensions:ce}=await this.z(ne,{targetPlatform:G,compatible:!0,includePreRelease:C,productVersion:H},D.CancellationToken.None);return ce[0]||null}async isExtensionCompatible(L,C,G,H={version:this.u.version,date:this.u.date}){if(!(0,b.$Uo)(L.properties.targetPlatform,L.allTargetPlatforms,G)||!C&&L.properties.isPreReleaseVersion)return!1;let ne=L.properties.engine;if(!ne){const ce=await this.getManifest(L,D.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ne=ce.engines.vscode}return(0,$.$Dp)(ne,H.version,H.date)}async y(L,C,G,H,ne,ce,he={version:this.u.version,date:this.u.date}){if(!(0,b.$Uo)(M(C),ne,ce)||G!=="any"&&ue(C)!==(G==="prerelease"))return!1;if(H)try{const pe=await this.E(L,C);if(!(0,$.$Dp)(pe,he.version,he.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,k.$0)(pe)),!1}return!0}async query(L,C){let G=L.text||"";const H=L.pageSize??50;let ne=new z().withPage(1,H);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(ne=ne.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(ne=ne.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),ne=ne.withFilter(s.SearchText,G)),ne=ne.withSortBy(0)):L.ids?ne=ne.withFilter(s.ExtensionId,...L.ids):L.names?ne=ne.withFilter(s.ExtensionName,...L.names):ne=ne.withSortBy(4),typeof L.sortBy=="number"&&(ne=ne.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(ne=ne.withSortOrder(L.sortOrder)),L.source&&(ne=ne.withSource(L.source));const ce=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!L.includePreRelease,productVersion:L.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+ke,L.source)),{extensions:de,total:we}},{extensions:he,total:pe}=await ce(ne,C),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ce(ne.withPage(fe+1),me);return de};return{firstPage:he,total:pe,pageSize:ne.pageSize,getPage:ye}}async z(L,C,G){const H=L.flags;L.flags&t.IncludeLatestVersionOnly&&L.flags&t.IncludeVersions&&(L=L.withFlags(L.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(L.flags&t.IncludeLatestVersionOnly)&&!(L.flags&t.IncludeVersions)&&(L=L.withFlags(L.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(L=L.withFlags(L.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),L=L.withFlags(L.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ne,total:ce,context:he}=await this.B(L,G);if(!(L.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of ne){const we=await this.A(de,C,he);we&&me.push(we)}return{extensions:me,total:ce}}const ye=[],fe=new Map;for(let me=0;me<ne.length;me++){const de=ne[me],we={id:(0,d.$qp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,S.$7f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(x=>(0,d.$lp)(x,we))?.includePreRelease;if(C.compatible&&(0,b.$To)(W(de),C.targetPlatform))continue;const ke=await this.A(de,C,he);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==C.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new p.$8d,de=new z().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,C,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ce}}async A(L,C,G){const H={id:(0,d.$qp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},ne=C.versions?.find(ye=>(0,d.$lp)(ye,H))?.version,ce=(0,S.$7f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ye=>(0,d.$lp)(ye,H))?.includePreRelease,he=W(L),pe=Z(L.versions,C.targetPlatform);if(C.compatible&&(0,b.$To)(he,C.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(ne&&fe.version!==ne)){if(await this.y((0,d.$qp)(L.publisher.publisherName,L.extensionName),fe,ce?"any":"release",C.compatible,he,C.targetPlatform,C.productVersion))return te(L,fe,he,G);if(ne&&fe.version===ne)return null}}return ne||C.compatible?null:te(L,L.versions[0],he)}async B(L,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const G=await this.j,H=JSON.stringify(L.raw),ne={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ce=new p.$8d;let he,pe,ye=0;try{if(he=await this.k.request({type:"POST",url:this.g&&L.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:ne},C),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Kp)(he);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?b.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?b.ExtensionGalleryErrorCode.Timeout:b.ExtensionGalleryErrorCode.Failed;throw pe=new b.$Yo((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:ce.elapsed(),success:!!he&&(0,c.$Gp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(L,C,G,H){if(!this.isEnabled())return;const ne=A.$o?this.x(`/itemName/${L}.${C}/version/${G}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${C}/${G}/stats?statType=${H}`),ce=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:ne,headers:pe},D.CancellationToken.None)}catch{}}async download(L,C,G){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,d.$tp)(L),ne=new Date().getTime(),ce=me=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:me}),he=G===2?"install":G===3?"update":"",pe=he?{uri:`${L.assets.download.uri}${u.URI.parse(L.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${L.assets.download.fallbackUri}${u.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:L.assets.download,ye=L.queryContext?.[r]?{[r]:L.queryContext[r]}:void 0,fe=await this.D(L.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(C,fe.stream),ce(new Date().getTime()-ne)}async downloadSignatureArchive(L,C){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const G=await this.D(L.identifier.id,L.assets.signature,o.Signature);await this.q.writeFile(C,G.stream)}async getReadme(L,C){if(L.assets.readme){const G=await this.D(L.identifier.id,L.assets.readme,o.Details,{},C);return await(0,c.$Jp)(G)||""}return""}async getManifest(L,C){if(L.assets.manifest){const G=await this.D(L.identifier.id,L.assets.manifest,o.Manifest,{},C),H=await(0,c.$Jp)(G);return H?JSON.parse(H):null}return null}async C(L,C,G){const H=_(C,o.Manifest);if(!H)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},ce=await this.D(L,H,o.Manifest,{headers:ne});return await(0,c.$Kp)(ce)}async getCoreTranslation(L,C){const G=L.assets.coreTranslations.filter(H=>H[0]===C.toUpperCase())[0];if(G){const H=await this.D(L.identifier.id,G[1],G[0]),ne=await(0,c.$Jp)(H);return ne?JSON.parse(ne):null}return null}async getChangelog(L,C){if(L.assets.changelog){const G=await this.D(L.identifier.id,L.assets.changelog,o.Changelog,{},C);return await(0,c.$Jp)(G)||""}return""}async getAllCompatibleVersions(L,C,G){let H=new z().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(s.ExtensionId,L.identifier.uuid):H=H.withFilter(s.ExtensionName,L.identifier.id);const{galleryExtensions:ne}=await this.B(H,D.CancellationToken.None);if(!ne.length)return[];const ce=W(ne[0]);if((0,b.$To)(ce,G))return[];const he=[];await Promise.all(ne[0].versions.map(async fe=>{try{await this.y(L.identifier.id,fe,C?"any":"release",!0,ce,G)&&he.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Z(he,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}));return pe}async D(L,C,G,H={},ne=D.CancellationToken.None){const ce=await this.j,he={type:"GET"},pe={...ce,...H.headers||{}};H={...H,...he,headers:pe};const ye=C.uri,fe=C.fallbackUri,me={...H,url:ye};try{const de=await this.k.request(me,ne);if(de.res.statusCode===200)return de;const we=await(0,c.$Jp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:L,assetType:G,message:we});const Ee={...H,url:fe};return this.k.request(Ee,ne)}}async E(L,C){let G=le(C);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:L,version:C.version});const H=await this.C(L,C,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Kp)(L),G=[],H={},ne=[];if(C){for(const ce of C.malicious)G.push({id:ce});if(C.migrateToPreRelease)for(const[ce,he]of Object.entries(C.migrateToPreRelease))(!he.engine||(0,$.$Dp)(he.engine,this.u.version,this.u.date))&&(H[ce.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[ce,he]of Object.entries(C.deprecated))he&&(H[ce.toLowerCase()]=(0,S.$7f)(he)?{}:he);if(C.search)for(const ce of C.search)ne.push(ce)}return{malicious:G,deprecated:H,search:ne}}};T=$e([oe(1,c.$Ep),oe(2,R.$Tj),oe(3,g.$ui),oe(4,h.$Sl),oe(5,y.$Tk),oe(6,m.$ak),oe(7,a.$Ti)],T);let F=class extends T{constructor(L,C,G,H,ne,ce,he,pe){super(L,C,G,H,ne,ce,he,pe)}};e.$1p=F,e.$1p=F=$e([oe(0,w.$Rp),oe(1,c.$Ep),oe(2,R.$Tj),oe(3,g.$ui),oe(4,h.$Sl),oe(5,y.$Tk),oe(6,m.$ak),oe(7,a.$Ti)],F);let f=class extends T{constructor(L,C,G,H,ne,ce,he){super(void 0,L,C,G,H,ne,ce,he)}};e.$2p=f,e.$2p=f=$e([oe(0,c.$Ep),oe(1,R.$Tj),oe(2,g.$ui),oe(3,h.$Sl),oe(4,y.$Tk),oe(5,m.$ak),oe(6,a.$Ti)],f)}),define(se[167],re([0,1,11,18,13,6,145,23,24,3,68]),function(J,e,j,D,k,A,O,S,u,a,g){"use strict";var b,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=void 0;let $=class extends u.$wl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(c,v,w,h,p){super(w,h,v,p),this.U=c,this.W=w}O(){return this.U.getItem(b.b,[]).map(v=>({...v,location:(0,a.$1f)(v.location)?this.w.extUri.joinPath(this.profilesHome,v.location):j.URI.revive(v.location)}))}Q(){const c=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(j.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$cQ=$,e.$cQ=$=b=$e([oe(0,O.$0P),oe(1,S.$rl),oe(2,D.$vi),oe(3,k.$Tk),oe(4,A.$Tj)],$);let y=d=class extends ${constructor(c,v,w,h,p){super(c,v,w,h,p),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(v=>({...v,location:this.w.extUri.basename(v.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",v=this.$.getItem(c,void 0);if(v){this.$.removeItem(c);const h=v.reduce((p,{workspace:i,profile:r})=>(p[j.URI.revive(i).toString()]=j.URI.revive(r).toString(),p),{});this.$.setItem(d.c,{workspaces:h})}const w=super.Q();return this.$.getItem(d.a,!1)||(this.R(w),this.$.setItem(d.a,!0)),w}};e.$dQ=y,e.$dQ=y=d=$e([oe(0,O.$$P),oe(1,S.$rl),oe(2,D.$vi),oe(3,k.$Tk),oe(4,A.$Tj)],y);let R=class extends y{constructor(c,v,w,h){super(new g.$bQ(0,v,h,w),c,v,w,h)}async init(){return await this.$.init(),super.init()}};e.$eQ=R,e.$eQ=R=$e([oe(0,S.$rl),oe(1,D.$vi),oe(2,k.$Tk),oe(3,A.$Tj)],R)}),define(se[168],re([0,1,143,8,14,9,3,29,18,144,6,45,142,179]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0,e.$Nr=m;let y=class extends b.$Fp{constructor(v,w,h,p){super(p),this.m=v,this.n=w,this.r=h,this.s(),this.B(v.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const v=this.m.getValue("http");this.f=v?.proxy,this.g=!!v?.proxyStrictSSL,this.h=v?.proxyAuthorization}async request(v,w){const{f:h,g:p}=this;let i;try{i=await(0,a.$xm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const r={...process.env,...i},t=v.agent?v.agent:await(0,d.$Lr)(v.url||"",r,{proxyUrl:h,strictSSL:p});return v.agent=t,v.strictSSL=p,this.h&&(v.headers={...v.headers||{},"Proxy-Authorization":this.h}),this.c(v.isChromiumNetwork?"electron":"node",v,()=>m(v,w))}async resolveProxy(v){}async loadCertificates(){return(await new Promise((w,h)=>{J(["@vscode/proxy-agent"],w,h)})).loadSystemCertificates({log:this.r})}};e.$Mr=y,e.$Mr=y=$e([oe(0,S.$Ti),oe(1,u.$vi),oe(2,g.$Tj),oe(3,g.$Uj)],y);async function R(c){return((0,j.parse)(c.url).protocol==="https:"?await new Promise((h,p)=>{J(["https"],h,p)}):await new Promise((h,p)=>{J(["http"],h,p)})).request}async function m(c,v){return D.Promises.withAsyncBody(async(w,h)=>{const p=(0,j.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await R(c),r={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,O.$7f)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,O.$5f)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)m({...c,url:n.headers.location,followRedirects:s-1},v).then(w,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,$.createGunzip)())),w({res:n,stream:(0,k.$Oe)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),v.onCancellationRequested(()=>{t.abort(),h(new A.$5)})})}}),define(se[180],re([0,1,33,8,34,9,2,15,16,12,35,11,25,29,139,61,141,18,115,166,21,70,146,42,53,162,164,13,129,131,51,127,63,64,150,6,135,39,136,153,32,45,168,68,69,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(J,e,j,D,k,A,O,S,u,a,g,b,d,$,y,R,m,c,v,w,h,p,i,r,t,n,s,o,l,P,I,z,N,U,V,X,_,K,le,ue,ae,B,Q,q,M,W,Z,Y,te,T,F,f,E,L,C,G,H,ne,ce,he,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends O.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(X.$Tj),x=Ee.get(o.$Tk),ee=Ee.get(c.$vi),ie=Ee.get(E.$tl);ke.info("CLI main",this.b),this.h(ke),await this.j(ee,x,ie,de),await Promise.all(we.map(ge=>{(0,D.$eh)(ge.flush(),1e3)}))})}async f(){const de=new N.$li,we={_serviceBrand:void 0,...ue.default};de.set(ae.$ak,we);const Ee=new v.$Zm(this.b,we);de.set(c.$vi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:S.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(ve=>ve?d.Promises.mkdir(ve,{recursive:!0}):void 0));const ke=new ne.$9P((0,X.$8j)(Ee),Ee.logsHome);de.set(X.$Uj,ke);const x=this.B(ke.createLogger("cli",{name:(0,ce.localize)(0,null)})),ee=[];ke.getLogLevel()===X.LogLevel.Trace&&ee.push(new X.$2j(ke.getLogLevel()));const ie=this.B(new H.$gQ(x,ee));de.set(X.$Tj,ie);const ge=this.B(new l.$zq(ie));de.set(o.$Tk,ge);const be=this.B(new P.$1q(ie));ge.registerProvider(S.Schemas.file,be);const je=new f.$os(ge);de.set(F.$rl,je);const Pe=new q.$aQ(1,Ee,ie,ge),Le=new L.$cQ(Pe,je,Ee,ge,ie);de.set(E.$tl,Le),ge.registerProvider(S.Schemas.vscodeUserData,new he.$ycc(S.Schemas.file,be,S.Schemas.vscodeUserData,Le,je,ie));const Re=a.$i&&we.win32RegValueName?this.B(new le.$wcc(ie,we.win32RegValueName)):Ee.policyFile?this.B(new _.$xcc(Ee.policyFile,ge,ie)):new K.$0n;de.set(K.$8n,Re);const Ae=this.B(new y.$xo(Le.defaultProfile.settingsResource,ge,Re,ie));de.set($.$Ti,Ae),await Promise.all([Pe.init(),Ae.initialize()]);let Fe;try{Fe=await(0,C.$acc)(Pe,ie)}catch(ve){ve.code!=="ENOENT"&&ie.error(ve)}const De=await(0,C.$bcc)(Pe,ie);Le.init(),de.set(F.$rl,new f.$os(ge));const Ne=new Q.$Mr(Ae,Ee,ie,ke);de.set(B.$Ep,Ne),de.set(R.$Bo,new I.$ki(m.$vQ,void 0,!0)),de.set(r.$gq,new I.$ki(G.$fQ,void 0,!0)),de.set(t.$kq,new I.$ki(s.$0bc,void 0,!0)),de.set(p.$3p,new I.$ki(p.$4p,void 0,!0)),de.set(n.$uq,new I.$ki(n.$vq,void 0,!0)),de.set(h.$Wo,new I.$ki(w.$2p,void 0,!0)),de.set(U.$Gr,new I.$ki(V.$Ir,void 0,!1));const ze=[],Te=(0,Y.$ip)(we,Ae);if((0,Y.$dp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new te.$7P(Ne,Te,"monacoworkbench",null,we.aiConfig.ariaKey));const ve={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,M.$7o)((0,j.release)(),(0,j.hostname)(),process.arch,we.commit,we.version,Fe,De,Te),piiPaths:(0,Y.$jp)(Ee)};de.set(W.$Sl,new I.$ki(Z.$Or,[ve],!1))}else de.set(W.$Sl,Y.$$o);return[new z.$4q(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,A.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$$i)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async j(de,we,Ee,ke){let x;if(de.args.profile&&(x=Ee.profiles.find(ie=>ie.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$5p,new X.$2j(X.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ke.createInstance(i.$5p,new X.$2j(X.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$5p,new X.$2j(X.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ke.createInstance(i.$5p,new X.$2j(X.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ke.createInstance(i.$5p,new X.$2j(X.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.$Wcc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?b.URI.file((0,u.$jc)(we)?we:(0,u.$kc)((0,g.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/code/node/cliProcessMain.js.map
