/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],I=0,N=se.length;I<N;I++)e[I]=le[se[I]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const j=new Map,A=new Map,O=new Map,R=new Map;function C(f,h){f.has(h.detail)||f.set(h.detail,-h.timestamp)}function m(f,h){const b=f.get(h.detail);b&&(b>=0||f.set(h.detail,b+h.timestamp))}let k=[];typeof se=="function"&&typeof se.getStats=="function"&&(k=se.getStats().slice(0).sort((f,h)=>f.timestamp-h.timestamp));for(const f of k)switch(f.type){case 10:C(j,f);break;case 11:case 12:m(j,f);break;case 21:C(A,f);break;case 22:m(A,f);break;case 33:C(O,f);break;case 34:m(O,f);break;case 31:C(R,f);break;case 32:m(R,f);break}let v=0;O.forEach(f=>v+=f);function $(f){const h=[];return f.forEach((b,w)=>h.push([w,b])),h}return{amdLoad:$(j),amdInvoke:$(A),nodeRequire:$(O),nodeEval:$(R),nodeRequireTotal:v}}static toMarkdownTable(j,A){let O="";const R=[];return j.forEach((C,m)=>{R[m]=C.length}),A.forEach(C=>{C.forEach((m,k)=>{typeof m>"u"&&(m=C[k]="-");const v=m.toString().length;R[k]=Math.max(v,R[k])})}),j.forEach((C,m)=>{O+=`| ${C+" ".repeat(R[m]-C.toString().length)} `}),O+=`|
`,j.forEach((C,m)=>{O+=`| ${"-".repeat(R[m])} `}),O+=`|
`,A.forEach(C=>{C.forEach((m,k)=>{typeof m<"u"&&(O+=`| ${m+" ".repeat(R[k]-m.toString().length)} `)}),O+=`|
`}),O}}e.$U=I}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=I,e.$gb=N,e.$hb=j,e.$ib=A,e.$jb=O,e.$kb=R,e.$lb=C,e.$nb=k,e.$ob=v,e.$pb=$,e.$qb=f,e.$rb=h;function I(b,w,u){const d=N(b,w);if(d!==-1)return b[d]}function N(b,w,u=b.length-1){for(let d=u;d>=0;d--){const l=b[d];if(w(l))return d}return-1}function j(b,w){const u=A(b,w);return u===-1?void 0:b[u]}function A(b,w,u=0,d=b.length){let l=u,c=d;for(;l<c;){const g=Math.floor((l+c)/2);w(b[g])?l=g+1:c=g}return l-1}function O(b,w){const u=R(b,w);return u===b.length?void 0:b[u]}function R(b,w,u=0,d=b.length){let l=u,c=d;for(;l<c;){const g=Math.floor((l+c)/2);w(b[g])?c=g:l=g+1}return l}function C(b,w,u=0,d=b.length){const l=R(b,w,u,d);return l===b.length?-1:l}class m{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(m.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!w(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const u=A(this.e,w,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=m;function k(b,w){if(b.length===0)return;let u=b[0];for(let d=1;d<b.length;d++){const l=b[d];w(l,u)>0&&(u=l)}return u}function v(b,w){if(b.length===0)return;let u=b[0];for(let d=1;d<b.length;d++){const l=b[d];w(l,u)>=0&&(u=l)}return u}function $(b,w){return k(b,(u,d)=>-w(u,d))}function f(b,w){if(b.length===0)return-1;let u=0;for(let d=1;d<b.length;d++){const l=b[d];w(l,b[u])>0&&(u=d)}return u}function h(b,w){for(const u of b){const d=w(u);if(d!==void 0)return d}}}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=I,e.$L=N,e.$M=j,e.$N=A;function I(O,R){const C=Object.create(null);for(const m of O){const k=R(m);let v=C[k];v||(v=C[k]=[]),v.push(m)}return C}function N(O,R){const C=[],m=[];for(const k of O)R.has(k)||C.push(k);for(const k of R)O.has(k)||m.push(k);return{removed:C,added:m}}function j(O,R){const C=[],m=[];for(const[k,v]of O)R.has(k)||C.push(v);for(const[k,v]of R)O.has(k)||m.push(v);return{removed:C,added:m}}function A(O,R){const C=new Set;for(const m of R)O.has(m)&&C.add(m);return C}}),define(le[84],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=N,e.$Sh=j,e.$Th=A;function I(O){return(R,C,m)=>{let k=null,v=null;if(typeof m.value=="function"?(k="value",v=m.value):typeof m.get=="function"&&(k="get",v=m.get),!v)throw new Error("not supported");m[k]=O(v,C)}}function N(O,R,C){let m=null,k=null;if(typeof C.value=="function"?(m="value",k=C.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(m="get",k=C.get),!k)throw new Error("not supported");const v=`$memoize$${R}`;C[m]=function(...$){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,$)}),this[v]}}function j(O,R,C){return I((m,k)=>{const v=`$debounce$${k}`,$=`$debounce$result$${k}`;return function(...f){this[$]||(this[$]=C?C():void 0),clearTimeout(this[v]),R&&(this[$]=R(this[$],...f),f=[this[$]]),this[v]=setTimeout(()=>{m.apply(this,f),this[$]=C?C():void 0},O)}})}function A(O,R,C){return I((m,k)=>{const v=`$throttle$timer$${k}`,$=`$throttle$result$${k}`,f=`$throttle$lastRun$${k}`,h=`$throttle$pending$${k}`;return function(...b){if(this[$]||(this[$]=C?C():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[$]=R(this[$],...b)),this[h])return;const w=this[f]+O;w<=Date.now()?(this[f]=Date.now(),m.apply(this,[this[$]]),this[$]=C?C():void 0):(this[h]=!0,this[v]=setTimeout(()=>{this[h]=!1,this[f]=Date.now(),m.apply(this,[this[$]]),this[$]=C?C():void 0},w-Date.now()))}})}}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=j,e.$1=A,e.$2=O,e.$3=R,e.$4=m,e.$6=v,e.$7=$,e.$8=f,e.$0=b;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=I,e.$X=new I;function N(g){e.$X.setUnexpectedErrorHandler(g)}function j(g){if(!g||typeof g!="object")return!1;const i=g;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(g){m(g)||e.$X.onUnexpectedError(g)}function O(g){m(g)||e.$X.onUnexpectedExternalError(g)}function R(g){if(g instanceof Error){const{name:i,message:o}=g,n=g.stacktrace||g.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:l.isErrorNoTelemetry(g)}}return g}const C="Canceled";function m(g){return g instanceof k?!0:g instanceof Error&&g.name===C&&g.message===C}class k extends Error{constructor(){super(C),this.name=this.message}}e.$5=k;function v(){const g=new Error(C);return g.name=g.message,g}function $(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}function f(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=h;function b(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const o=new l;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=j,e.$tb=A,e.$ub=O,e.$vb=R,e.$wb=C,e.$xb=m,e.$yb=k,e.$zb=v,e.$Ab=$,e.$Bb=f,e.$Cb=h,e.$Db=b,e.$Eb=w,e.top=u,e.$Gb=d,e.$Hb=c,e.$Ib=g,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=E,e.$Rb=S,e.$Sb=P,e.$Tb=y,e.$Ub=p,e.$Vb=D,e.$Wb=z,e.$Xb=F,e.$Yb=M,e.$Zb=X,e.$1b=G,e.$2b=Y,e.$3b=V,e.$4b=K,e.$5b=W,e.$6b=B,e.$7b=te,e.$8b=ce,e.$$b=L;function j(J,ee=0){return J[J.length-(1+ee)]}function A(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function O(J,ee,_=(Z,ne)=>Z===ne){if(J===ee)return!0;if(!J||!ee||J.length!==ee.length)return!1;for(let Z=0,ne=J.length;Z<ne;Z++)if(!_(J[Z],ee[Z]))return!1;return!0}function R(J,ee){const _=J.length-1;ee<_&&(J[ee]=J[_]),J.pop()}function C(J,ee,_){return m(J.length,Z=>_(J[Z],ee))}function m(J,ee){let _=0,Z=J-1;for(;_<=Z;){const ne=(_+Z)/2|0,re=ee(ne);if(re<0)_=ne+1;else if(re>0)Z=ne-1;else return ne}return-(_+1)}function k(J,ee,_){if(J=J|0,J>=ee.length)throw new TypeError("invalid index");const Z=ee[Math.floor(ee.length*Math.random())],ne=[],re=[],ue=[];for(const de of ee){const $e=_(de,Z);$e<0?ne.push(de):$e>0?re.push(de):ue.push(de)}return J<ne.length?k(J,ne,_):J<ne.length+ue.length?ue[0]:k(J-(ne.length+ue.length),re,_)}function v(J,ee){const _=[];let Z;for(const ne of J.slice(0).sort(ee))!Z||ee(Z[0],ne)!==0?(Z=[ne],_.push(Z)):Z.push(ne);return _}function*$(J,ee){let _,Z;for(const ne of J)Z!==void 0&&ee(Z,ne)?_.push(ne):(_&&(yield _),_=[ne]),Z=ne;_&&(yield _)}function f(J,ee){for(let _=0;_<=J.length;_++)ee(_===0?void 0:J[_-1],_===J.length?void 0:J[_])}function h(J,ee){for(let _=0;_<J.length;_++)ee(_===0?void 0:J[_-1],J[_],_+1===J.length?void 0:J[_+1])}function b(J,ee,_){const Z=[];function ne(de,$e,ye){if($e===0&&ye.length===0)return;const Se=Z[Z.length-1];Se&&Se.start+Se.deleteCount===de?(Se.deleteCount+=$e,Se.toInsert.push(...ye)):Z.push({start:de,deleteCount:$e,toInsert:ye})}let re=0,ue=0;for(;;){if(re===J.length){ne(re,0,ee.slice(ue));break}if(ue===ee.length){ne(re,J.length-re,[]);break}const de=J[re],$e=ee[ue],ye=_(de,$e);ye===0?(re+=1,ue+=1):ye<0?(ne(re,1,[]),re+=1):ye>0&&(ne(re,0,[$e]),ue+=1)}return Z}function w(J,ee,_){const Z=b(J,ee,_),ne=[],re=[];for(const ue of Z)ne.push(...J.slice(ue.start,ue.start+ue.deleteCount)),re.push(...ue.toInsert);return{removed:ne,added:re}}function u(J,ee,_){if(_===0)return[];const Z=J.slice(0,_).sort(ee);return l(J,ee,Z,_,J.length),Z}function d(J,ee,_,Z,ne){return _===0?Promise.resolve([]):new Promise((re,ue)=>{(async()=>{const de=J.length,$e=J.slice(0,_).sort(ee);for(let ye=_,Se=Math.min(_+Z,de);ye<de;ye=Se,Se=Math.min(Se+Z,de)){if(ye>_&&await new Promise(Ie=>setTimeout(Ie)),ne&&ne.isCancellationRequested)throw new I.$5;l(J,ee,$e,ye,Se)}return $e})().then(re,ue)})}function l(J,ee,_,Z,ne){for(const re=_.length;Z<ne;Z++){const ue=J[Z];if(ee(ue,_[re-1])<0){_.pop();const de=(0,N.$kb)(_,$e=>ee(ue,$e)<0);_.splice(de,0,ue)}}}function c(J){return J.filter(ee=>!!ee)}function g(J){let ee=0;for(let _=0;_<J.length;_++)J[_]&&(J[ee]=J[_],ee+=1);J.length=ee}function i(J,ee,_){J.splice(_,0,J.splice(ee,1)[0])}function o(J){return!Array.isArray(J)||J.length===0}function n(J){return Array.isArray(J)&&J.length>0}function s(J,ee=_=>_){const _=new Set;return J.filter(Z=>{const ne=ee(Z);return _.has(ne)?!1:(_.add(ne),!0)})}function t(J){const ee=new Set;return _=>{const Z=J(_);return ee.has(Z)?!1:(ee.add(Z),!0)}}function r(J,ee){return J.length>0?J[0]:ee}function a(J,ee){return J.length>0?J[J.length-1]:ee}function E(J,ee,_=(Z,ne)=>Z===ne){let Z=0;for(let ne=0,re=Math.min(J.length,ee.length);ne<re&&_(J[ne],ee[ne]);ne++)Z++;return Z}function S(J){return[].concat(...J)}function P(J,ee){let _=typeof ee=="number"?J:0;typeof ee=="number"?_=J:(_=0,ee=J);const Z=[];if(_<=ee)for(let ne=_;ne<ee;ne++)Z.push(ne);else for(let ne=_;ne>ee;ne--)Z.push(ne);return Z}function y(J,ee,_){return J.reduce((Z,ne)=>(Z[ee(ne)]=_?_(ne):ne,Z),Object.create(null))}function p(J,ee){return J.push(ee),()=>D(J,ee)}function D(J,ee){const _=J.indexOf(ee);if(_>-1)return J.splice(_,1),ee}function z(J,ee,_){const Z=J.slice(0,ee),ne=J.slice(ee);return Z.concat(_,ne)}function F(J,ee){let _;if(typeof ee=="number"){let Z=ee;_=()=>{const ne=Math.sin(Z++)*179426549;return ne-Math.floor(ne)}}else _=Math.random;for(let Z=J.length-1;Z>0;Z-=1){const ne=Math.floor(_()*(Z+1)),re=J[Z];J[Z]=J[ne],J[ne]=re}}function M(J,ee){const _=J.indexOf(ee);_>-1&&(J.splice(_,1),J.unshift(ee))}function X(J,ee){const _=J.indexOf(ee);_>-1&&(J.splice(_,1),J.push(ee))}function G(J,ee){for(const _ of ee)J.push(_)}function Y(J,ee){return Array.isArray(J)?J.map(ee):ee(J)}function V(J){return Array.isArray(J)?J:[J]}function K(J){return J[Math.floor(Math.random()*J.length)]}function W(J,ee,_){const Z=ie(J,ee),ne=J.length,re=_.length;J.length=ne+re;for(let ue=ne-1;ue>=Z;ue--)J[ue+re]=J[ue];for(let ue=0;ue<re;ue++)J[ue+Z]=_[ue]}function B(J,ee,_,Z){const ne=ie(J,ee);let re=J.splice(ne,_);return re===void 0&&(re=[]),W(J,ne,Z),re}function ie(J,ee){return ee<0?Math.max(ee+J.length,0):Math.min(ee,J.length)}var ae;(function(J){function ee(re){return re<0}J.isLessThan=ee;function _(re){return re<=0}J.isLessThanOrEqual=_;function Z(re){return re>0}J.isGreaterThan=Z;function ne(re){return re===0}J.isNeitherLessOrGreaterThan=ne,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function te(J,ee){return(_,Z)=>ee(J(_),J(Z))}function ce(...J){return(ee,_)=>{for(const Z of J){const ne=Z(ee,_);if(!ae.isNeitherLessOrGreaterThan(ne))return ne}return ae.neitherLessOrGreaterThan}}const H=(J,ee)=>J-ee;e.$9b=H;const U=(J,ee)=>(0,e.$9b)(J?1:0,ee?1:0);e.$0b=U;function L(J){return(ee,_)=>-J(ee,_)}class T{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const Z=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Z}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const Z=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=T;class q{static{this.empty=new q(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new q(_=>this.iterate(Z=>ee(Z)?_(Z):!0))}map(ee){return new q(_=>this.iterate(Z=>_(ee(Z))))}some(ee){let _=!1;return this.iterate(Z=>(_=ee(Z),!_)),_}findFirst(ee){let _;return this.iterate(Z=>ee(Z)?(_=Z,!1):!0),_}findLast(ee){let _;return this.iterate(Z=>(ee(Z)&&(_=Z),!0)),_}findLastMaxBy(ee){let _,Z=!0;return this.iterate(ne=>((Z||ae.isGreaterThan(ee(ne,_)))&&(Z=!1,_=ne),!0)),_}}e.$ac=q;class x{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const Z=Array.from(ee.keys()).sort((ne,re)=>_(ee[ne],ee[re]));return new x(Z)}apply(ee){return ee.map((_,Z)=>ee[this.c[Z]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new x(ee)}}e.$bc=x}),define(le[127],he([0,1,7]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=j,e.$dd=A,e.$ed=O,e.$fd=R,e.$gd=C;function N(m,k){if(!m)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}function j(m,k="Unreachable"){throw new Error(k)}function A(m){if(!m)throw new I.$cb("Assertion Failed")}function O(m){m||(0,I.$1)(new I.$cb("Soft Assertion Failed"))}function R(m){if(!m()){debugger;m(),(0,I.$1)(new I.$cb("Assertion Failed"))}}function C(m,k){let v=0;for(;v<m.length-1;){const $=m[v],f=m[v+1];if(!k($,f))return!1;v++}return!0}}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=I;function I(N,j){const A=this;let O=!1,R;return function(){if(O)return R;if(O=!0,j)try{R=N.apply(A,arguments)}finally{j()}else R=N.apply(A,arguments);return R}}}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(N){function j(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}N.is=j;const A=Object.freeze([]);function O(){return A}N.empty=O;function*R(i){yield i}N.single=R;function C(i){return j(i)?i:R(i)}N.wrap=C;function m(i){return i||A}N.from=m;function*k(i){for(let o=i.length-1;o>=0;o--)yield i[o]}N.reverse=k;function v(i){return!i||i[Symbol.iterator]().next().done===!0}N.isEmpty=v;function $(i){return i[Symbol.iterator]().next().value}N.first=$;function f(i,o){for(const n of i)if(o(n))return!0;return!1}N.some=f;function h(i,o){for(const n of i)if(o(n))return n}N.find=h;function*b(i,o){for(const n of i)o(n)&&(yield n)}N.filter=b;function*w(i,o){let n=0;for(const s of i)yield o(s,n++)}N.map=w;function*u(...i){for(const o of i)yield*o}N.concat=u;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}N.reduce=d;function*l(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}N.slice=l;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,N.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=c;async function g(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}N.asyncToArray=g})(I||(e.Iterable=I={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=O,e.$zn=v,e.$An=$,e.$Bn=f,e.$Cn=h,e.$Dn=b,e.$En=w,e.$Fn=u,e.$Gn=d,e.$Hn=l,e.$In=c,e.$Jn=g;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var j;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,E=0;function S(M){let X=0,G=0;for(;X<M;){const Y=i.charCodeAt(n);if(Y>=48&&Y<=57)G=G*16+Y-48;else if(Y>=65&&Y<=70)G=G*16+Y-65+10;else if(Y>=97&&Y<=102)G=G*16+Y-97+10;else break;n++,X++}return X<M&&(G=-1),G}function P(M){n=M,t="",r=0,a=16,E=0}function y(){const M=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return E=3,i.substring(M,n);let X=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;X=n}else E=3;return i.substring(M,X)}function p(){let M="",X=n;for(;;){if(n>=s){M+=i.substring(X,n),E=2;break}const G=i.charCodeAt(n);if(G===34){M+=i.substring(X,n),n++;break}if(G===92){if(M+=i.substring(X,n),n++,n>=s){E=2;break}switch(i.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const V=S(4);V>=0?M+=String.fromCharCode(V):E=4;break}default:E=5}X=n;continue}if(G>=0&&G<=31)if(C(G)){M+=i.substring(X,n),E=2;break}else E=6;n++}return M}function D(){if(t="",E=0,r=n,n>=s)return r=s,a=17;let M=i.charCodeAt(n);if(R(M)){do n++,t+=String.fromCharCode(M),M=i.charCodeAt(n);while(R(M));return a=15}if(C(M))return n++,t+=String.fromCharCode(M),M===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(M){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=p(),a=10;case 47:{const X=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!C(i.charCodeAt(n));)n++;return t=i.substring(X,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const G=s-1;let Y=!1;for(;n<G;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Y=!0;break}n++}return Y||(n++,E=1),t=i.substring(X,n),a=13}return t+=String.fromCharCode(M),n++,a=16}case 45:if(t+=String.fromCharCode(M),n++,n===s||!m(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=y(),a=11;default:for(;n<s&&z(M);)n++,M=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(M),n++,a=16}}function z(M){if(R(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let M;do M=D();while(M>=12&&M<=15);return M}return{setPosition:P,getPosition:()=>n,scan:o?F:D,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>E}}function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var k;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(k||(k={}));function v(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function E(S,P,y,p){r.value=S,r.offset=P,r.length=y,r.type=p,r.colonOffset=void 0,t=r}try{l(i,{onObjectBegin:(S,P)=>{if(o<=S)throw s;t=void 0,a=o>S,n.push("")},onObjectProperty:(S,P,y)=>{if(o<P||(E(S,P,y,"property"),n[n.length-1]=S,o<=P+y))throw s},onObjectEnd:(S,P)=>{if(o<=S)throw s;t=void 0,n.pop()},onArrayBegin:(S,P)=>{if(o<=S)throw s;t=void 0,n.push(0)},onArrayEnd:(S,P)=>{if(o<=S)throw s;t=void 0,n.pop()},onLiteralValue:(S,P,y)=>{if(o<P||(E(S,P,y,g(S)),o<=P+y))throw s},onSeparator:(S,P,y)=>{if(o<=P)throw s;if(S===":"&&t&&t.type==="property")t.colonOffset=P,a=!1,t=void 0;else if(S===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:t,isAtPropertyKey:a,matches:S=>{let P=0;for(let y=0;P<S.length&&y<n.length;y++)if(S[P]===n[y]||S[P]==="*")P++;else if(S[P]!=="**")return!1;return P===S.length}}}function $(i,o=[],n=A.DEFAULT){let s=null,t=[];const r=[];function a(S){Array.isArray(t)?t.push(S):s!==null&&(t[s]=S)}return l(i,{onObjectBegin:()=>{const S={};a(S),r.push(t),t=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const S=[];a(S),r.push(t),t=S,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(S,P,y)=>{o.push({error:S,offset:P,length:y})}},n),t[0]}function f(i,o=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function r(S){return s.children.push(S),S}l(i,{onObjectBegin:S=>{s=r({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,P,y)=>{s=r({type:"property",offset:P,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:P,length:y,parent:s})},onObjectEnd:(S,P)=>{s.length=S+P-s.offset,s=s.parent,t(S+P)},onArrayBegin:(S,P)=>{s=r({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,P)=>{s.length=S+P-s.offset,s=s.parent,t(S+P)},onLiteralValue:(S,P,y)=>{r({type:g(S),offset:P,length:y,parent:s,value:S}),t(P+y)},onSeparator:(S,P,y)=>{s.type==="property"&&(S===":"?s.colonOffset=P:S===","&&t(P))},onError:(S,P,y)=>{o.push({error:S,offset:P,length:y})}},n);const E=s.children[0];return E&&delete E.parent,E}function h(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=w(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function u(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function d(i,o,n=!1){if(u(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}function l(i,o,n=A.DEFAULT){const s=O(i,!1);function t(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(te){return te?ce=>te(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),E=r(o.onObjectProperty),S=t(o.onObjectEnd),P=t(o.onArrayBegin),y=t(o.onArrayEnd),p=r(o.onLiteralValue),D=r(o.onSeparator),z=t(o.onComment),F=r(o.onError),M=n&&n.disallowComments,X=n&&n.allowTrailingComma;function G(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:M||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(te){case 12:case 13:M?Y(10):z();break;case 16:Y(1);break;case 15:case 14:break;default:return te}}}function Y(te,ce=[],H=[]){if(F(te),ce.length+H.length>0){let U=s.getToken();for(;U!==17;){if(ce.indexOf(U)!==-1){G();break}else if(H.indexOf(U)!==-1)break;U=G()}}}function V(te){const ce=s.getTokenValue();return te?p(ce):E(ce),G(),!0}function K(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(Y(2),te=0)}catch{Y(2)}p(te);break}case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return G(),!0}function W(){return s.getToken()!==10?(Y(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(D(":"),G(),ae()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function B(){a(),G();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||Y(4,[],[]),D(","),G(),s.getToken()===2&&X)break}else te&&Y(6,[],[]);W()||Y(4,[],[2,5]),te=!0}return S(),s.getToken()!==2?Y(7,[2],[]):G(),!0}function ie(){P(),G();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||Y(4,[],[]),D(","),G(),s.getToken()===4&&X)break}else te&&Y(6,[],[]);ae()||Y(4,[],[4,5]),te=!0}return y(),s.getToken()!==4?Y(8,[4],[]):G(),!0}function ae(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return V(!0);default:return K()}}return G(),s.getToken()===17?n.allowEmptyContent?!0:(Y(4,[],[]),!1):ae()?(s.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}function c(i,o){const n=O(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[43],he([0,1,34]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=N,e.$Ln=j,e.$Mn=R,e.$Nn=C;function N(m,k,v){let $,f,h,b,w;if(k){for(b=k.offset,w=b+k.length,h=b;h>0&&!C(m,h-1);)h--;let a=w;for(;a<m.length&&!C(m,a);)a++;f=m.substring(h,a),$=O(f,v)}else f=m,$=0,h=0,b=0,w=m.length;const u=R(v,m);let d=!1,l=0,c;v.insertSpaces?c=A(" ",v.tabSize||4):c="	";const g=(0,I.$yn)(f,!1);let i=!1;function o(){return u+A(c,$+l)}function n(){let a=g.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=g.scan();return i=a===16||g.getTokenError()!==0,a}const s=[];function t(a,E,S){!i&&E<w&&S>b&&m.substring(E,S)!==a&&s.push({offset:E,length:S-E,content:a})}let r=n();if(r!==17){const a=g.getTokenOffset()+h,E=A(c,$);t(E,h,a)}for(;r!==17;){let a=g.getTokenOffset()+g.getTokenLength()+h,E=n(),S="";for(;!d&&(E===12||E===13);){const y=g.getTokenOffset()+h;t(" ",a,y),a=g.getTokenOffset()+g.getTokenLength()+h,S=E===12?o():"",E=n()}if(E===2)r!==1&&(l--,S=o());else if(E===4)r!==3&&(l--,S=o());else{switch(r){case 3:case 1:l++,S=o();break;case 5:case 12:S=o();break;case 13:d?S=o():S=" ";break;case 6:S=" ";break;case 10:if(E===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?S=" ":E!==5&&E!==17&&(i=!0);break;case 16:i=!0;break}d&&(E===12||E===13)&&(S=o())}const P=g.getTokenOffset()+h;t(S,a,P),r=E}return s}function j(m,k){const v=JSON.stringify(m,void 0,k.insertSpaces?k.tabSize||4:"	");return k.eol!==void 0?v.replace(/\r\n|\r|\n/g,k.eol):v}function A(m,k){let v="";for(let $=0;$<k;$++)v+=m;return v}function O(m,k){let v=0,$=0;const f=k.tabSize||4;for(;v<m.length;){const h=m.charAt(v);if(h===" ")$++;else if(h==="	")$+=f;else break;v++}return Math.floor($/f)}function R(m,k){for(let v=0;v<k.length;v++){const $=k.charAt(v);if($==="\r")return v+1<k.length&&k.charAt(v+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return m&&m.eol||`
`}function C(m,k){return`\r
`.indexOf(m.charAt(k))!==-1}}),define(le[62],he([0,1,34,43]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=j,e.$Pn=A,e.$Qn=O,e.$Rn=R,e.$Sn=C;function j(m,k,v){return A(m,k,void 0,v)}function A(m,k,v,$,f){const h=k.slice(),b=[],w=(0,I.$Bn)(m,b);let u,d;for(;h.length>0&&(d=h.pop(),u=(0,I.$Cn)(w,h),u===void 0&&v!==void 0);)typeof d=="string"?v={[d]:v}:v=[v];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const l=(0,I.$Cn)(u,[d]);if(l!==void 0)if(v===void 0){if(!l.parent)throw new Error("Malformed AST");const c=u.children.indexOf(l.parent);let g,i=l.parent.offset+l.parent.length;if(c>0){const o=u.children[c-1];g=o.offset+o.length}else g=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return O(m,{offset:g,length:i-g,content:""},$)}else return O(m,{offset:l.offset,length:l.length,content:JSON.stringify(v)},$);else{if(v===void 0)return[];const c=`${JSON.stringify(d)}: ${JSON.stringify(v)}`,g=f?f(u.children.map(o=>o.children[0].value)):u.children.length;let i;if(g>0){const o=u.children[g-1];i={offset:o.offset+o.length,length:0,content:","+c}}else u.children.length===0?i={offset:u.offset+1,length:0,content:c}:i={offset:u.offset+1,length:0,content:c+","};return O(m,i,$)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(v!==void 0){const l=`${JSON.stringify(v)}`;let c;if(u.children.length===0||d===0)c={offset:u.offset+1,length:0,content:u.children.length===0?l:l+","};else{const g=d===-1||d>u.children.length?u.children.length:d,i=u.children[g-1];c={offset:i.offset+i.length,length:0,content:","+l}}return O(m,c,$)}else{const l=d,c=u.children[l];let g;if(u.children.length===1)g={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===l){const i=u.children[l-1],o=i.offset+i.length,n=u.offset+u.length;g={offset:o,length:n-2-o,content:""}}else g={offset:c.offset,length:u.children[l+1].offset-c.offset,content:""};return O(m,g,$)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return O(m,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(v)},$)}}function O(m,k,v){let $=R(m,k),f=k.offset,h=k.offset+k.content.length;if(k.length===0||k.content.length===0){for(;f>0&&!(0,N.$Nn)($,f-1);)f--;for(;h<$.length&&!(0,N.$Nn)($,h);)h++}const b=(0,N.$Kn)($,{offset:f,length:h-f},v);for(let u=b.length-1;u>=0;u--){const d=b[u];$=R($,d),f=Math.min(f,d.offset),h=Math.max(h,d.offset+d.length),h+=d.content.length-d.length}const w=m.length-($.length-h)-f;return[{offset:f,length:w,content:$.substring(f,h)}]}function R(m,k){return m.substring(0,k.offset)+k.content+m.substring(k.offset+k.length)}function C(m,k){const v=k.slice(0).sort((f,h)=>{const b=f.offset-h.offset;return b===0?f.length-h.length:b});let $=m.length;for(let f=v.length-1;f>=0;f--){const h=v[f];if(h.offset+h.length<=$)m=R(m,h);else throw new Error("Overlapping edit");$=h.offset}return m}}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class N{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const O=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new I(A);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const m=this.b;this.b=R,R.prev=m,m.next=R}else{const m=this.a;this.a=R,R.next=m,m.prev=R}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$5c=N}),define(le[35],he([0,1]),function(se,e){"use strict";var I,N,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=O,e.$Ac=R,e.$Ic=d;function A(l,c,g){let i=l.get(c);return i===void 0&&(i=g,l.set(c,i)),i}function O(l){const c=[];return l.forEach((g,i)=>{c.push(`${i} => ${g}`)}),`Map(${l.size}) {${c.join(", ")}}`}function R(l){const c=[];return l.forEach(g=>{c.push(g)}),`Set(${l.size}) {${c.join(", ")}}`}class C{constructor(c,g){this.uri=c,this.value=g}}function m(l){return Array.isArray(l)}class k{static{this.c=c=>c.toString()}constructor(c,g){if(this[I]="ResourceMap",c instanceof k)this.d=new Map(c.d),this.e=g??k.c;else if(m(c)){this.d=new Map,this.e=g??k.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??k.c}set(c,g){return this.d.set(this.e(c),new C(c,g)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,g){typeof g<"u"&&(c=c.bind(g));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Bc=k;class v{constructor(c,g){this[N]="ResourceSet",!c||typeof c=="function"?this.c=new k(c):(this.c=new k(g),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,g){this.c.forEach((i,o)=>c.call(g,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=v;var $;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})($||(e.Touch=$={}));class f{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,g=0){const i=this.c.get(c);if(i)return g!==0&&this.l(i,g),i.value}set(c,g,i=0){let o=this.c.get(c);if(o)o.value=g,i!==0&&this.l(o,i);else{switch(o={key:c,value:g,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const g=this.c.get(c);if(g)return this.c.delete(c),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,g){const i=this.g;let o=this.d;for(;o;){if(g?c.bind(g)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,g=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==g)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,g=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==g)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,g=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==g)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let g=this.d,i=this.size;for(;g&&i>c;)this.c.delete(g.key),g=g.next,i--;this.d=g,this.f=i,g&&(g.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const g=c.next,i=c.previous;if(!g||!i)throw new Error("Invalid list");g.previous=i,i.next=g}c.next=void 0,c.previous=void 0,this.g++}l(c,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(g===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((g,i)=>{c.push([i,g])}),c}fromJSON(c){this.clear();for(const[g,i]of c)this.set(g,i)}}e.$Dc=f;class h extends f{constructor(c,g=1){super(),this.m=c,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,g=2){return super.get(c,g)}peek(c){return super.get(c,0)}set(c,g){return super.set(c,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=h;class b{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let g=this.c.get(c)||0;return g===0?!1:(g--,g===0?this.c.delete(c):this.c.set(c,g),!0)}has(c){return this.c.has(c)}}e.$Fc=b;class w{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[g,i]of c)this.set(g,i)}clear(){this.c.clear(),this.d.clear()}set(c,g){this.c.set(c,g),this.d.set(g,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const g=this.c.get(c);return g===void 0?!1:(this.c.delete(c),this.d.delete(g),!0)}forEach(c,g){this.c.forEach((i,o)=>{c.call(g,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class u{constructor(){this.c=new Map}add(c,g){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(g)}delete(c,g){const i=this.c.get(c);i&&(i.delete(g),i.size===0&&this.c.delete(c))}forEach(c,g){const i=this.c.get(c);i&&i.forEach(g)}get(c){const g=this.c.get(c);return g||new Set}}e.$Hc=u;function d(l,c){if(l===c)return!0;if(l.size!==c.size)return!1;for(const[g,i]of l)if(!c.has(g)||c.get(g)!==i)return!1;for(const[g]of c)if(!l.has(g))return!1;return!0}}),define(le[2],he([0,1,17,126,35,85,61]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=k,e.$Lc=v,e.$Mc=$,e.$Nc=b,e.$Oc=w,e.$Pc=u,e.$Qc=d,e.$Rc=l,e.$Sc=c,e.$3c=S;const R=!1;let C=null;class m{constructor(){this.b=new Map}static{this.a=0}c(p){let D=this.b.get(p);return D||(D={parent:null,source:null,isSingleton:!1,value:p,idx:m.a++},this.b.set(p,D)),D}trackDisposable(p){const D=this.c(p);D.source||(D.source=new Error().stack)}setParent(p,D){const z=this.c(p);z.parent=D}markAsDisposed(p){this.b.delete(p)}markAsSingleton(p){this.c(p).isSingleton=!0}f(p,D){const z=D.get(p);if(z)return z;const F=p.parent?this.f(this.c(p.parent),D):p;return D.set(p,F),F}getTrackedDisposables(){const p=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,p).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(p=10,D){let z;if(D)z=D;else{const Y=new Map,V=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,Y).isSingleton);if(V.length===0)return;const K=new Set(V.map(W=>W.value));if(z=V.filter(W=>!(W.parent&&K.has(W.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function F(Y){function V(W,B){for(;W.length>0&&B.some(ie=>typeof ie=="string"?ie===W[0]:W[0].match(ie));)W.shift()}const K=Y.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return V(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const M=new j.$Hc;for(const Y of z){const V=F(Y);for(let K=0;K<=V.length;K++)M.add(V.slice(0,K).join(`
`),Y)}z.sort((0,I.$7b)(Y=>Y.idx,I.$9b));let X="",G=0;for(const Y of z.slice(0,p)){G++;const V=F(Y),K=[];for(let W=0;W<V.length;W++){let B=V[W];B=`(shared with ${M.get(V.slice(0,W+1).join(`
`)).size}/${z.length} leaks) at ${B}`;const ae=M.get(V.slice(0,W).join(`
`)),te=(0,N.$K)([...ae].map(ce=>F(ce)[W]),ce=>ce);delete te[V[W]];for(const[ce,H]of Object.entries(te))K.unshift(`    - stacktraces of ${H.length} other leaks continue with ${ce}`);K.unshift(B)}X+=`


==================== Leaking disposable ${G}/${z.length}: ${Y.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return z.length>p&&(X+=`


... and ${z.length-p} more leaking disposables

`),{leaks:z,details:X}}}e.$Jc=m;function k(y){C=y}if(R){const y="__is_disposable_tracked__";k(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[y]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==i.None)try{p[y]=!0}catch{}}markAsDisposed(p){if(p&&p!==i.None)try{p[y]=!0}catch{}}markAsSingleton(p){}})}function v(y){return C?.trackDisposable(y),y}function $(y){C?.markAsDisposed(y)}function f(y,p){C?.setParent(y,p)}function h(y,p){if(C)for(const D of y)C.setParent(D,p)}function b(y){return C?.markAsSingleton(y),y}function w(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function u(y){if(O.Iterable.is(y)){const p=[];for(const D of y)if(D)try{D.dispose()}catch(z){p.push(z)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function d(y){for(const p of y)w(p)&&p.dispose();return[]}function l(...y){const p=c(()=>u(y));return h(y,p),p}function c(y){const p=v({dispose:(0,A.$db)(()=>{$(p),y()})});return p}class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return f(p,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(p),p.dispose()}}deleteAndLeak(p){p&&this.f.has(p)&&(this.f.delete(p),f(p,null))}}e.$Tc=g;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,v(this),f(this.q,this)}dispose(){$(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}e.$Uc=i;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&f(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&f(p,null),p}}e.$Vc=o;class n{constructor(p){this.a=new o,this.b=!1,this.a.value=p}get value(){return this.a.value}set value(p){this.b||p===this.a.value||(this.a.value=p)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,$(this))},this}}e.$Yc=t;class r{constructor(){this.a=new Map}acquire(p,...D){let z=this.a.get(p);z||(z={counter:0,object:this.b(p,...D)},this.a.set(p,z));const{object:F}=z,M=(0,A.$db)(()=>{--z.counter===0&&(this.c(p,z.object),this.a.delete(p))});return z.counter++,{object:F,dispose:M}}}e.$Zc=r;class a{constructor(p){this.a=p}async acquire(p,...D){const z=this.a.acquire(p,...D);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(F){throw z.dispose(),F}}}e.$1c=a;class E{constructor(p){this.object=p}dispose(){}}e.$2c=E;function S(y){const p=new g;try{y(p)}finally{p.dispose()}}class P{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get size(){return this.a.size}get(p){return this.a.get(p)}set(p,D,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(p)?.dispose(),this.a.set(p,D)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=P}),define(le[87],he([0,1,35]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0,e.$5l=j,e.$6l=O;const N=new I.$Ec(1e4);function j(m){return C(m,"NFC",N)}const A=new I.$Ec(1e4);function O(m){return C(m,"NFD",A)}const R=/[^\u0000-\u0080]/;function C(m,k,v){if(!m)return m;const $=v.get(m);if($)return $;let f;return R.test(m)?f=m.normalize(k):f=m,v.set(m,f),f}e.$7l=function(){const m=/[\u0300-\u036f]/g;return function(k){return O(k).replace(m,"")}}()}),function(){function se(j){const A=[];typeof j=="number"&&A.push("code/timeOrigin",j);function O(C){A.push(C,Date.now())}function R(){const C=[];for(let m=0;m<A.length;m+=2)C.push({name:A[m],startTime:A[m+1]});return C}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(j+O.startTime)});return A}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function I(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:se)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function I(N){if(e[N])return e[N].exports;var j=e[N]={i:N,l:!1,exports:{}};return se[N].call(j.exports,j,j.exports,I),j.l=!0,j.exports}return I.m=se,I.c=e,I.d=function(N,j,A){I.o(N,j)||Object.defineProperty(N,j,{enumerable:!0,get:A})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,j){if(1&j&&(N=I(N)),8&j||4&j&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&j&&typeof N!="string")for(var O in N)I.d(A,O,function(R){return N[R]}.bind(null,O));return A},I.n=function(N){var j=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(j,"a",j),j},I.o=function(N,j){return Object.prototype.hasOwnProperty.call(N,j)},I.p="",I(I.s=0)}([function(se,e,I){(function(N){var j;e=se.exports=H,j=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],m=0,k=m++;C[k]="0|[1-9]\\d*";var v=m++;C[v]="[0-9]+";var $=m++;C[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=m++;C[f]="("+C[k]+")\\.("+C[k]+")\\.("+C[k]+")";var h=m++;C[h]="("+C[v]+")\\.("+C[v]+")\\.("+C[v]+")";var b=m++;C[b]="(?:"+C[k]+"|"+C[$]+")";var w=m++;C[w]="(?:"+C[v]+"|"+C[$]+")";var u=m++;C[u]="(?:-("+C[b]+"(?:\\."+C[b]+")*))";var d=m++;C[d]="(?:-?("+C[w]+"(?:\\."+C[w]+")*))";var l=m++;C[l]="[0-9A-Za-z-]+";var c=m++;C[c]="(?:\\+("+C[l]+"(?:\\."+C[l]+")*))";var g=m++,i="v?"+C[f]+C[u]+"?"+C[c]+"?";C[g]="^"+i+"$";var o="[v=\\s]*"+C[h]+C[d]+"?"+C[c]+"?",n=m++;C[n]="^"+o+"$";var s=m++;C[s]="((?:<|>)?=?)";var t=m++;C[t]=C[v]+"|x|X|\\*";var r=m++;C[r]=C[k]+"|x|X|\\*";var a=m++;C[a]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[u]+")?"+C[c]+"?)?)?";var E=m++;C[E]="[v=\\s]*("+C[t]+")(?:\\.("+C[t]+")(?:\\.("+C[t]+")(?:"+C[d]+")?"+C[c]+"?)?)?";var S=m++;C[S]="^"+C[s]+"\\s*"+C[a]+"$";var P=m++;C[P]="^"+C[s]+"\\s*"+C[E]+"$";var y=m++;C[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var p=m++;C[p]="(?:~>?)";var D=m++;C[D]="(\\s*)"+C[p]+"\\s+",R[D]=new RegExp(C[D],"g");var z=m++;C[z]="^"+C[p]+C[a]+"$";var F=m++;C[F]="^"+C[p]+C[E]+"$";var M=m++;C[M]="(?:\\^)";var X=m++;C[X]="(\\s*)"+C[M]+"\\s+",R[X]=new RegExp(C[X],"g");var G=m++;C[G]="^"+C[M]+C[a]+"$";var Y=m++;C[Y]="^"+C[M]+C[E]+"$";var V=m++;C[V]="^"+C[s]+"\\s*("+o+")$|^$";var K=m++;C[K]="^"+C[s]+"\\s*("+i+")$|^$";var W=m++;C[W]="(\\s*)"+C[s]+"\\s*("+o+"|"+C[a]+")",R[W]=new RegExp(C[W],"g");var B=m++;C[B]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var ie=m++;C[ie]="^\\s*("+C[E]+")\\s+-\\s+("+C[E]+")\\s*$";var ae=m++;C[ae]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)j(te,C[te]),R[te]||(R[te]=new RegExp(C[te]));function ce(fe,me){if(fe instanceof H)return fe;if(typeof fe!="string"||fe.length>A||!(me?R[n]:R[g]).test(fe))return null;try{return new H(fe,me)}catch{return null}}function H(fe,me){if(fe instanceof H){if(fe.loose===me)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof H))return new H(fe,me);j("SemVer",fe,me),this.loose=me;var be=fe.trim().match(me?R[n]:R[g]);if(!be)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Re=+Ce;if(Re>=0&&Re<O)return Re}return Ce}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ce,e.valid=function(fe,me){var be=ce(fe,me);return be?be.version:null},e.clean=function(fe,me){var be=ce(fe.trim().replace(/^[=v]+/,""),me);return be?be.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(fe){return j("SemVer.compare",this.version,this.loose,fe),fe instanceof H||(fe=new H(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},H.prototype.compareMain=function(fe){return fe instanceof H||(fe=new H(fe,this.loose)),L(this.major,fe.major)||L(this.minor,fe.minor)||L(this.patch,fe.patch)},H.prototype.comparePre=function(fe){if(fe instanceof H||(fe=new H(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var me=0;do{var be=this.prerelease[me],Ce=fe.prerelease[me];if(j("prerelease compare",me,be,Ce),be===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(be===void 0)return-1;if(be!==Ce)return L(be,Ce)}while(++me)},H.prototype.inc=function(fe,me){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,me,be,Ce){typeof be=="string"&&(Ce=be,be=void 0);try{return new H(fe,be).inc(me,Ce).version}catch{return null}},e.diff=function(fe,me){if(J(fe,me))return null;var be=ce(fe),Ce=ce(me);if(be.prerelease.length||Ce.prerelease.length){for(var Re in be)if((Re==="major"||Re==="minor"||Re==="patch")&&be[Re]!==Ce[Re])return"pre"+Re;return"prerelease"}for(var Re in be)if((Re==="major"||Re==="minor"||Re==="patch")&&be[Re]!==Ce[Re])return Re},e.compareIdentifiers=L;var U=/^[0-9]+$/;function L(fe,me){var be=U.test(fe),Ce=U.test(me);return be&&Ce&&(fe=+fe,me=+me),be&&!Ce?-1:Ce&&!be?1:fe<me?-1:fe>me?1:0}function T(fe,me,be){return new H(fe,be).compare(new H(me,be))}function q(fe,me,be){return T(fe,me,be)>0}function x(fe,me,be){return T(fe,me,be)<0}function J(fe,me,be){return T(fe,me,be)===0}function ee(fe,me,be){return T(fe,me,be)!==0}function _(fe,me,be){return T(fe,me,be)>=0}function Z(fe,me,be){return T(fe,me,be)<=0}function ne(fe,me,be,Ce){var Re;switch(me){case"===":typeof fe=="object"&&(fe=fe.version),typeof be=="object"&&(be=be.version),Re=fe===be;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof be=="object"&&(be=be.version),Re=fe!==be;break;case"":case"=":case"==":Re=J(fe,be,Ce);break;case"!=":Re=ee(fe,be,Ce);break;case">":Re=q(fe,be,Ce);break;case">=":Re=_(fe,be,Ce);break;case"<":Re=x(fe,be,Ce);break;case"<=":Re=Z(fe,be,Ce);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function re(fe,me){if(fe instanceof re){if(fe.loose===me)return fe;fe=fe.value}if(!(this instanceof re))return new re(fe,me);j("comparator",fe,me),this.loose=me,this.parse(fe),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(fe,me){return L(me,fe)},e.major=function(fe,me){return new H(fe,me).major},e.minor=function(fe,me){return new H(fe,me).minor},e.patch=function(fe,me){return new H(fe,me).patch},e.compare=T,e.compareLoose=function(fe,me){return T(fe,me,!0)},e.rcompare=function(fe,me,be){return T(me,fe,be)},e.sort=function(fe,me){return fe.sort(function(be,Ce){return e.compare(be,Ce,me)})},e.rsort=function(fe,me){return fe.sort(function(be,Ce){return e.rcompare(be,Ce,me)})},e.gt=q,e.lt=x,e.eq=J,e.neq=ee,e.gte=_,e.lte=Z,e.cmp=ne,e.Comparator=re;var ue={};function de(fe,me){if(fe instanceof de)return fe.loose===me?fe:new de(fe.raw,me);if(fe instanceof re)return new de(fe.value,me);if(!(this instanceof de))return new de(fe,me);if(this.loose=me,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function $e(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function ye(fe,me,be,Ce,Re,ze,De,Ue,Te,Me,qe,Ae,oe){return((me=$e(be)?"":$e(Ce)?">="+be+".0.0":$e(Re)?">="+be+"."+Ce+".0":">="+me)+" "+(Ue=$e(Te)?"":$e(Me)?"<"+(+Te+1)+".0.0":$e(qe)?"<"+Te+"."+(+Me+1)+".0":Ae?"<="+Te+"."+Me+"."+qe+"-"+Ae:"<="+Ue)).trim()}function Se(fe,me){for(var be=0;be<fe.length;be++)if(!fe[be].test(me))return!1;if(me.prerelease.length){for(be=0;be<fe.length;be++)if(j(fe[be].semver),fe[be].semver!==ue&&fe[be].semver.prerelease.length>0){var Ce=fe[be].semver;if(Ce.major===me.major&&Ce.minor===me.minor&&Ce.patch===me.patch)return!0}return!1}return!0}function Ie(fe,me,be){try{me=new de(me,be)}catch{return!1}return me.test(fe)}function Le(fe,me,be,Ce){var Re,ze,De,Ue,Te;switch(fe=new H(fe,Ce),me=new de(me,Ce),be){case">":Re=q,ze=Z,De=x,Ue=">",Te=">=";break;case"<":Re=x,ze=_,De=q,Ue="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(fe,me,Ce))return!1;for(var Me=0;Me<me.set.length;++Me){var qe=me.set[Me],Ae=null,oe=null;if(qe.forEach(function(ge){ge.semver===ue&&(ge=new re(">=0.0.0")),Ae=Ae||ge,oe=oe||ge,Re(ge.semver,Ae.semver,Ce)?Ae=ge:De(ge.semver,oe.semver,Ce)&&(oe=ge)}),Ae.operator===Ue||Ae.operator===Te||(!oe.operator||oe.operator===Ue)&&ze(fe,oe.semver)||oe.operator===Te&&De(fe,oe.semver))return!1}return!0}re.prototype.parse=function(fe){var me=this.loose?R[V]:R[K],be=fe.match(me);if(!be)throw new TypeError("Invalid comparator: "+fe);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new H(be[2],this.loose):this.semver=ue},re.prototype.toString=function(){return this.value},re.prototype.test=function(fe){return j("Comparator.test",fe,this.loose),this.semver===ue||(typeof fe=="string"&&(fe=new H(fe,this.loose)),ne(fe,this.operator,this.semver,this.loose))},re.prototype.intersects=function(fe,me){if(!(fe instanceof re))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(fe.value,me),Ie(this.value,be,me);if(fe.operator==="")return be=new de(this.value,me),Ie(fe.semver,be,me);var Ce=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),ze=this.semver.version===fe.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),Ue=ne(this.semver,"<",fe.semver,me)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),Te=ne(this.semver,">",fe.semver,me)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return Ce||Re||ze&&De||Ue||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(fe){var me=this.loose;fe=fe.trim(),j("range",fe,me);var be=me?R[ie]:R[B];fe=fe.replace(be,ye),j("hyphen replace",fe),fe=fe.replace(R[W],"$1$2$3"),j("comparator trim",fe,R[W]),fe=(fe=(fe=fe.replace(R[D],"$1~")).replace(R[X],"$1^")).split(/\s+/).join(" ");var Ce=me?R[V]:R[K],Re=fe.split(" ").map(function(ze){return function(De,Ue){return j("comp",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(qe){return function(Ae,oe){j("caret",Ae,oe);var ge=oe?R[Y]:R[G];return Ae.replace(ge,function(we,pe,Ee,Pe,Oe){var Ne;return j("caret",Ae,we,pe,Ee,Pe,Oe),$e(pe)?Ne="":$e(Ee)?Ne=">="+pe+".0.0 <"+(+pe+1)+".0.0":$e(Pe)?Ne=pe==="0"?">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+".0 <"+(+pe+1)+".0.0":Oe?(j("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Pe+Oe+" <"+pe+"."+Ee+"."+(+Pe+1):">="+pe+"."+Ee+"."+Pe+Oe+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Pe+Oe+" <"+(+pe+1)+".0.0"):(j("no pr"),Ne=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Pe+" <"+pe+"."+Ee+"."+(+Pe+1):">="+pe+"."+Ee+"."+Pe+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Pe+" <"+(+pe+1)+".0.0"),j("caret return",Ne),Ne})}(qe,Me)}).join(" ")}(De,Ue),j("caret",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(qe){return function(Ae,oe){var ge=oe?R[F]:R[z];return Ae.replace(ge,function(we,pe,Ee,Pe,Oe){var Ne;return j("tilde",Ae,we,pe,Ee,Pe,Oe),$e(pe)?Ne="":$e(Ee)?Ne=">="+pe+".0.0 <"+(+pe+1)+".0.0":$e(Pe)?Ne=">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":Oe?(j("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+pe+"."+Ee+"."+Pe+Oe+" <"+pe+"."+(+Ee+1)+".0"):Ne=">="+pe+"."+Ee+"."+Pe+" <"+pe+"."+(+Ee+1)+".0",j("tilde return",Ne),Ne})}(qe,Me)}).join(" ")}(De,Ue),j("tildes",De),De=function(Te,Me){return j("replaceXRanges",Te,Me),Te.split(/\s+/).map(function(qe){return function(Ae,oe){Ae=Ae.trim();var ge=oe?R[P]:R[S];return Ae.replace(ge,function(we,pe,Ee,Pe,Oe,Ne){j("xRange",Ae,we,pe,Ee,Pe,Oe,Ne);var We=$e(Ee),Be=We||$e(Pe),Fe=Be||$e(Oe);return pe==="="&&Fe&&(pe=""),We?we=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Fe?(Be&&(Pe=0),Fe&&(Oe=0),pe===">"?(pe=">=",Be?(Ee=+Ee+1,Pe=0,Oe=0):Fe&&(Pe=+Pe+1,Oe=0)):pe==="<="&&(pe="<",Be?Ee=+Ee+1:Pe=+Pe+1),we=pe+Ee+"."+Pe+"."+Oe):Be?we=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Fe&&(we=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),j("xRange return",we),we})}(qe,Me)}).join(" ")}(De,Ue),j("xrange",De),De=function(Te,Me){return j("replaceStars",Te,Me),Te.trim().replace(R[ae],"")}(De,Ue),j("stars",De),De}(ze,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(ze){return!!ze.match(Ce)})),Re=Re.map(function(ze){return new re(ze,me)})},de.prototype.intersects=function(fe,me){if(!(fe instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Ce){return fe.set.some(function(Re){return Re.every(function(ze){return Ce.intersects(ze,me)})})})})},e.toComparators=function(fe,me){return new de(fe,me).set.map(function(be){return be.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new H(fe,this.loose));for(var me=0;me<this.set.length;me++)if(Se(this.set[me],fe))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(fe,me,be){var Ce=null,Re=null;try{var ze=new de(me,be)}catch{return null}return fe.forEach(function(De){ze.test(De)&&(Ce&&Re.compare(De)!==-1||(Re=new H(Ce=De,be)))}),Ce},e.minSatisfying=function(fe,me,be){var Ce=null,Re=null;try{var ze=new de(me,be)}catch{return null}return fe.forEach(function(De){ze.test(De)&&(Ce&&Re.compare(De)!==1||(Re=new H(Ce=De,be)))}),Ce},e.validRange=function(fe,me){try{return new de(fe,me).range||"*"}catch{return null}},e.ltr=function(fe,me,be){return Le(fe,me,"<",be)},e.gtr=function(fe,me,be){return Le(fe,me,">",be)},e.outside=Le,e.prerelease=function(fe,me){var be=ce(fe,me);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(fe,me,be){return fe=new de(fe,be),me=new de(me,be),fe.intersects(me)},e.coerce=function(fe){if(fe instanceof H)return fe;if(typeof fe!="string")return null;var me=fe.match(R[y]);return me==null?null:ce((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,I(1))},function(se,e){var I,N,j=se.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(w){if(I===setTimeout)return setTimeout(w,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(w,0);try{return I(w,0)}catch{try{return I.call(null,w,0)}catch{return I.call(this,w,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var C,m=[],k=!1,v=-1;function $(){k&&C&&(k=!1,C.length?m=C.concat(m):v=-1,m.length&&f())}function f(){if(!k){var w=R($);k=!0;for(var u=m.length;u;){for(C=m,m=[];++v<u;)C&&C[v].run();v=-1,u=m.length}C=null,k=!1,function(d){if(N===clearTimeout)return clearTimeout(d);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(d);try{N(d)}catch{try{return N.call(null,d)}catch{return N.call(this,d)}}}(w)}}function h(w,u){this.fun=w,this.array=u}function b(){}j.nextTick=function(w){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];m.push(new h(w,u)),m.length!==1||k||R(f)},h.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=b,j.addListener=b,j.once=b,j.off=b,j.removeListener=b,j.removeAllListeners=b,j.emit=b,j.prependListener=b,j.prependOnceListener=b,j.listeners=function(w){return[]},j.binding=function(w){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(w){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class N{constructor(R,C,m){this.level=R,this.key=C,this.value=m,this.forward=[]}}const j=void 0;class A{constructor(R,C=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,j,j)}get size(){return this.f}clear(){this.e=new N(this.c,j,j),this.f=0}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,C){return A.h(this,R,C,this.comparator)&&(this.f+=1),this}delete(R){const C=A.k(this,R,this.comparator);return C&&(this.f-=1),C}forEach(R,C){let m=this.e.forward[0];for(;m;)R.call(C,m.value,m.key,this),m=m.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this.e.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static g(R,C,m){let k=R.e;for(let v=R.d-1;v>=0;v--)for(;k.forward[v]&&m(k.forward[v].key,C)<0;)k=k.forward[v];if(k=k.forward[0],k&&m(k.key,C)===0)return k}static h(R,C,m,k){const v=[];let $=R.e;for(let f=R.d-1;f>=0;f--){for(;$.forward[f]&&k($.forward[f].key,C)<0;)$=$.forward[f];v[f]=$}if($=$.forward[0],$&&k($.key,C)===0)return $.value=m,!1;{const f=A.j(R);if(f>R.d){for(let h=R.d;h<f;h++)v[h]=R.e;R.d=f}$=new N(f,C,m);for(let h=0;h<f;h++)$.forward[h]=v[h].forward[h],v[h].forward[h]=$;return!0}}static j(R,C=.5){let m=1;for(;Math.random()<C&&m<R.c;)m+=1;return m}static k(R,C,m){const k=[];let v=R.e;for(let $=R.d-1;$>=0;$--){for(;v.forward[$]&&m(v.forward[$].key,C)<0;)v=v.forward[$];k[$]=v}if(v=v.forward[0],!v||m(v.key,C)!==0)return!1;for(let $=0;$<R.d&&k[$].forward[$]===v;$++)k[$].forward[$]=v.forward[$];for(;R.d>0&&R.e.forward[R.d-1]===j;)R.d-=1;return!0}}e.$ns=A}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8d=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$8d=N}),define(le[3],he([0,1,7,85,2,86,63]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$0d=e.Event=void 0,e.$$d=f;const R=!1,C=!1,m=!1;var k;(function(y){y.None=()=>j.$Uc.None;function p(re){if(m){const{onDidAddListener:ue}=re,de=b.create();let $e=0;re.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ue?.()}}}function D(re,ue){return B(re,()=>{},0,void 0,!0,void 0,ue)}y.defer=D;function z(re){return(ue,de=null,$e)=>{let ye=!1,Se;return Se=re(Ie=>{if(!ye)return Se?Se.dispose():ye=!0,ue.call(de,Ie)},null,$e),ye&&Se.dispose(),Se}}y.once=z;function F(re,ue,de){return K(($e,ye=null,Se)=>re(Ie=>$e.call(ye,ue(Ie)),null,Se),de)}y.map=F;function M(re,ue,de){return K(($e,ye=null,Se)=>re(Ie=>{ue(Ie),$e.call(ye,Ie)},null,Se),de)}y.forEach=M;function X(re,ue,de){return K(($e,ye=null,Se)=>re(Ie=>ue(Ie)&&$e.call(ye,Ie),null,Se),de)}y.filter=X;function G(re){return re}y.signal=G;function Y(...re){return(ue,de=null,$e)=>{const ye=(0,j.$Rc)(...re.map(Se=>Se(Ie=>ue.call(de,Ie))));return W(ye,$e)}}y.any=Y;function V(re,ue,de,$e){let ye=de;return F(re,Se=>(ye=ue(ye,Se),ye),$e)}y.reduce=V;function K(re,ue){let de;const $e={onWillAddFirstListener(){de=re(ye.fire,ye)},onDidRemoveLastListener(){de?.dispose()}};ue||p($e);const ye=new g($e);return ue?.add(ye),ye.event}function W(re,ue){return ue instanceof Array?ue.push(re):ue&&ue.add(re),re}function B(re,ue,de=100,$e=!1,ye=!1,Se,Ie){let Le,fe,me,be=0,Ce;const Re={leakWarningThreshold:Se,onWillAddFirstListener(){Le=re(De=>{be++,fe=ue(fe,De),$e&&!me&&(ze.fire(fe),fe=void 0),Ce=()=>{const Ue=fe;fe=void 0,me=void 0,(!$e||be>1)&&ze.fire(Ue),be=0},typeof de=="number"?(clearTimeout(me),me=setTimeout(Ce,de)):me===void 0&&(me=0,queueMicrotask(Ce))})},onWillRemoveListener(){ye&&be>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,Le.dispose()}};Ie||p(Re);const ze=new g(Re);return Ie?.add(ze),ze.event}y.debounce=B;function ie(re,ue=0,de){return y.debounce(re,($e,ye)=>$e?($e.push(ye),$e):[ye],ue,void 0,!0,void 0,de)}y.accumulate=ie;function ae(re,ue=($e,ye)=>$e===ye,de){let $e=!0,ye;return X(re,Se=>{const Ie=$e||!ue(Se,ye);return $e=!1,ye=Se,Ie},de)}y.latch=ae;function te(re,ue,de){return[y.filter(re,ue,de),y.filter(re,$e=>!ue($e),de)]}y.split=te;function ce(re,ue=!1,de=[],$e){let ye=de.slice(),Se=re(fe=>{ye?ye.push(fe):Le.fire(fe)});$e&&$e.add(Se);const Ie=()=>{ye?.forEach(fe=>Le.fire(fe)),ye=null},Le=new g({onWillAddFirstListener(){Se||(Se=re(fe=>Le.fire(fe)),$e&&$e.add(Se))},onDidAddFirstListener(){ye&&(ue?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return $e&&$e.add(Le),Le.event}y.buffer=ce;function H(re,ue){return($e,ye,Se)=>{const Ie=ue(new L);return re(function(Le){const fe=Ie.evaluate(Le);fe!==U&&$e.call(ye,fe)},void 0,Se)}}y.chain=H;const U=Symbol("HaltChainable");class L{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(de=>(ue(de),de)),this}filter(ue){return this.f.push(de=>ue(de)?de:U),this}reduce(ue,de){let $e=de;return this.f.push(ye=>($e=ue($e,ye),$e)),this}latch(ue=(de,$e)=>de===$e){let de=!0,$e;return this.f.push(ye=>{const Se=de||!ue(ye,$e);return de=!1,$e=ye,Se?ye:U}),this}evaluate(ue){for(const de of this.f)if(ue=de(ue),ue===U)break;return ue}}function T(re,ue,de=$e=>$e){const $e=(...Le)=>Ie.fire(de(...Le)),ye=()=>re.on(ue,$e),Se=()=>re.removeListener(ue,$e),Ie=new g({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Ie.event}y.fromNodeEventEmitter=T;function q(re,ue,de=$e=>$e){const $e=(...Le)=>Ie.fire(de(...Le)),ye=()=>re.addEventListener(ue,$e),Se=()=>re.removeEventListener(ue,$e),Ie=new g({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Ie.event}y.fromDOMEventEmitter=q;function x(re){return new Promise(ue=>z(re)(ue))}y.toPromise=x;function J(re){const ue=new g;return re.then(de=>{ue.fire(de)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}y.fromPromise=J;function ee(re,ue,de){return ue(de),re($e=>ue($e))}y.runAndSubscribe=ee;class _{constructor(ue,de){this._observable=ue,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};de||p($e),this.emitter=new g($e),de&&de.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,de){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Z(re,ue){return new _(re,ue).emitter.event}y.fromObservable=Z;function ne(re){return(ue,de,$e)=>{let ye=0,Se=!1;const Ie={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(re.reportChanges(),Se&&(Se=!1,ue.call(de)))},handlePossibleChange(){},handleChange(){Se=!0}};re.addObserver(Ie),re.reportChanges();const Le={dispose(){re.removeObserver(Ie)}};return $e instanceof j.$Tc?$e.add(Le):Array.isArray($e)&&$e.push(Le),Le}}y.fromObservableLight=ne})(k||(e.Event=k={}));class v{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${v.f++}`,v.all.add(this)}start(p){this.g=new O.$8d,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$0d=v;let $=-1;function f(y){const p=$;return $=y,{dispose(){$=p}}}class h{constructor(p,D=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=D,this.g=0}dispose(){this.f?.clear()}check(p,D){const z=this.threshold;if(z<=0||D<z)return;this.f||(this.f=new Map);const F=this.f.get(p.value)||0;if(this.f.set(p.value,F+1),this.g-=1,this.g<=0){this.g=z*.5;let M,X=0;for(const[G,Y]of this.f)(!M||X<Y)&&(M=G,X=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${X}):`),console.warn(M)}return()=>{const M=this.f.get(p.value)||0;this.f.set(p.value,M-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(p){this.value=p,this.id=w++}}const d=2,l=(y,p)=>{if(y instanceof u)p(y);else for(let D=0;D<y.length;D++){const z=y[D];z&&p(z)}},c=R?new FinalizationRegistry(y=>{typeof y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(y))}):void 0;class g{constructor(p){this.w=0,this.f=p,this.g=$>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const p=this.t;queueMicrotask(()=>{l(p,D=>D.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,D,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Uc.None;if(this.m)return j.$Uc.None;D&&(p=p.bind(D));const F=new u(p);let M,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=b.create(),M=this.g.check(F.stack,this.w+1)),C&&(F.stack=X??b.create()),this.t?this.t instanceof u?(this.u??=new o,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const G=(0,j.$Sc)(()=>{c?.unregister(G),M?.(),this.x(F)});if(z instanceof j.$Tc?z.add(G):Array.isArray(z)&&z.push(G),c){const Y=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(G,Y,G)}return G},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const D=this.t,z=D.indexOf(p);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,D[z]=void 0;const F=this.u.current===this;if(this.w*d<=D.length){let M=0;for(let X=0;X<D.length;X++)D[X]?D[M++]=D[X]:F&&(this.u.end--,M<this.u.i&&this.u.i--);D.length=M}}y(p,D){if(!p)return;const z=this.f?.onListenerError||I.$1;if(!z){p.value(D);return}try{p.value(D)}catch(F){z(F)}}z(p){const D=p.current.t;for(;p.i<p.end;)this.y(D[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,p);else{const D=this.u;D.enqueue(this,p,this.t.length),this.z(D)}this.j?.stop()}hasListeners(){return this.w>0}}e.$_d=g;const i=()=>new o;e.$ae=i;class o{constructor(){this.i=-1,this.end=0}enqueue(p,D,z){this.i=0,this.end=z,this.current=p,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends g{async fireAsync(p,D,z){if(this.t)for(this.h||(this.h=new A.$5c),l(this.t,F=>this.h.push([F.value,p]));this.h.size>0&&!D.isCancellationRequested;){const[F,M]=this.h.shift(),X=[],G={...M,token:D,waitUntil:Y=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");z&&(Y=z(Y,F)),X.push(Y)}};try{F(G)}catch(Y){(0,I.$1)(Y);continue}Object.freeze(X),await Promise.allSettled(X).then(Y=>{for(const V of Y)V.status==="rejected"&&(0,I.$1)(V.reason)})}}}e.$be=n;class s extends g{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new A.$5c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$ce=s;class t extends s{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$de=t;class r extends g{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(D=>super.fire(D)),this.h=[]}))}}e.$ee=r;class a{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const D={event:p,listener:null};this.h.push(D),this.g&&this.m(D);const z=()=>{this.g&&this.o(D);const F=this.h.indexOf(D);this.h.splice(F,1)};return(0,j.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(D=>this.f.fire(D))}o(p){p.listener?.dispose(),p.listener=null}dispose(){this.f.dispose();for(const p of this.h)p.listener?.dispose();this.h=[]}}e.$fe=a;class E{constructor(p,D,z,F){this.f=new j.$Tc;const M=this.f.add(new a),X=this.f.add(new j.$4c);function G(Y){X.set(Y,M.add(F(Y)))}for(const Y of p)G(Y);this.f.add(D(Y=>{G(Y)})),this.f.add(z(Y=>{X.deleteAndDispose(Y)})),this.event=M.event}dispose(){this.f.dispose()}}e.$ge=E;class S{constructor(){this.f=[]}wrapEvent(p){return(D,z,F)=>p(M=>{const X=this.f[this.f.length-1];X?X.push(()=>D.call(z,M)):D.call(z,M)},void 0,F)}bufferEvents(p){const D=[];this.f.push(D);const z=p();return this.f.pop(),D.forEach(F=>F()),z}}e.$he=S;class P{constructor(){this.f=!1,this.g=k.None,this.h=j.$Uc.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ie=P}),define(le[26],he([0,1,3]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.CancellationToken=void 0;const N=Object.freeze(function(R,C){const m=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(m)}}});var j;(function(R){function C(m){return m===R.None||m===R.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(j||(e.CancellationToken=j={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new I.$_d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(C){this.f=void 0,this.g=void 0,this.g=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=j.Cancelled}dispose(C=!1){C&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=j.None}}e.$je=O}),define(le[129],he([0,1,26]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$We=e.$Ve=e.$Ue=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$je,C=this.b(R.token);return this.a={promise:C,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Ue=N;class j{constructor(R,C=JSON.stringify){this.c=R,this.d=C,this.a=void 0,this.b=void 0}get(R){const C=this.d(R);return this.b!==C&&(this.b=C,this.a=this.c(R)),this.a}}e.$Ve=j;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const C=this.b(R);return this.a.set(R,C),C}}e.$We=A}),define(le[50],he([0,1,7,2]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=j,e.$le=A,e.$me=O,e.$ne=R,e.$oe=m,e.$pe=k,e.$qe=v,e.$re=$,e.$se=f,e.$te=h,e.$ue=b,e.$ve=w,e.$we=u,e.$xe=d,e.$ye=l;function j(c){const g=c;return g?typeof g.read=="function":!1}function A(c){const g=c;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}function O(c){const g=c;return g?A(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function R(c,g){return new C(c,g)}class C{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,I.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let o;switch(g){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(c,g){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return g(i)}function k(c,g,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?g(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function v(c,g){return new Promise((i,o)=>{const n=[];$(c,{onData:s=>{g&&n.push(s)},onError:s=>{g?o(s):i(void 0)},onEnd:()=>{i(g?g(n):void 0)}})})}function $(c,g,i){c.on("error",o=>{i?.isCancellationRequested||g.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||g.onData(o)})}function f(c,g){return new Promise((i,o)=>{const n=new N.$Tc,s=[],t=E=>{if(s.push(E),s.length>g)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=E=>(n.dispose(),o(E)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,N.$Sc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,N.$Sc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,N.$Sc)(()=>c.removeListener("data",t))),c.on("data",t)})}function h(c,g){const i=R(g);return i.end(c),i}function b(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}function w(c){let g=!1;return{read:()=>g?null:(g=!0,c)}}function u(c,g,i){const o=R(i);return $(c,{onData:n=>o.write(g.data(n)),onError:n=>o.error(g.error?g.error(n):n),onEnd:()=>o.end()}),o}function d(c,g,i){let o=!1;return{read:()=>{const n=g.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function l(c,g,i){let o=!1;const n=R(i);return $(g,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(le[15],he([0,1,53,50]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=m,e.$Be=k,e.$Ce=v,e.$De=$,e.$Ee=f,e.$Fe=h,e.$Ge=b,e.$He=w,e.$Ie=u,e.$Je=d,e.$Ke=l,e.$Le=c,e.$Me=g,e.$Ne=i,e.$Oe=o,e.$Pe=n,e.$Qe=s,e.$Re=t,e.$Se=r,e.$Te=S;const j=typeof Buffer<"u",A=new I.$V(()=>new Uint8Array(256));let O,R;class C{static alloc(y){return j?new C(Buffer.allocUnsafe(y)):new C(new Uint8Array(y))}static wrap(y){return j&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new C(y)}static fromString(y,p){return!(p?.dontUseNodeBuffer||!1)&&j?new C(Buffer.from(y)):(O||(O=new TextEncoder),new C(O.encode(y)))}static fromByteArray(y){const p=C.alloc(y.length);for(let D=0,z=y.length;D<z;D++)p.buffer[D]=y[D];return p}static concat(y,p){if(typeof p>"u"){p=0;for(let F=0,M=y.length;F<M;F++)p+=y[F].byteLength}const D=C.alloc(p);let z=0;for(let F=0,M=y.length;F<M;F++){const X=y[F];D.set(X,z),z+=X.byteLength}return D}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=C.alloc(this.byteLength);return y.set(this),y}toString(){return j?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(y,p){return new C(this.buffer.subarray(y,p))}set(y,p){if(y instanceof C)this.buffer.set(y.buffer,p);else if(y instanceof Uint8Array)this.buffer.set(y,p);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),p);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return $(this.buffer,y)}writeUInt32BE(y,p){f(this.buffer,y,p)}readUInt32LE(y){return h(this.buffer,y)}writeUInt32LE(y,p){b(this.buffer,y,p)}readUInt8(y){return w(this.buffer,y)}writeUInt8(y,p){u(this.buffer,y,p)}indexOf(y,p=0){return m(this.buffer,y instanceof C?y.buffer:y,p)}}e.$ze=C;function m(P,y,p=0){const D=y.byteLength,z=P.byteLength;if(D===0)return 0;if(D===1)return P.indexOf(y[0]);if(D>z-p)return-1;const F=A.value;F.fill(y.length);for(let Y=0;Y<y.length;Y++)F[y[Y]]=y.length-Y-1;let M=p+y.length-1,X=M,G=-1;for(;M<z;)if(P[M]===y[X]){if(X===0){G=M;break}M--,X--}else M+=Math.max(y.length-X,F[P[M]]),X=y.length-1;return G}function k(P,y){return P[y+0]<<0>>>0|P[y+1]<<8>>>0}function v(P,y,p){P[p+0]=y&255,y=y>>>8,P[p+1]=y&255}function $(P,y){return P[y]*2**24+P[y+1]*2**16+P[y+2]*2**8+P[y+3]}function f(P,y,p){P[p+3]=y,y=y>>>8,P[p+2]=y,y=y>>>8,P[p+1]=y,y=y>>>8,P[p]=y}function h(P,y){return P[y+0]<<0>>>0|P[y+1]<<8>>>0|P[y+2]<<16>>>0|P[y+3]<<24>>>0}function b(P,y,p){P[p+0]=y&255,y=y>>>8,P[p+1]=y&255,y=y>>>8,P[p+2]=y&255,y=y>>>8,P[p+3]=y&255}function w(P,y){return P[y]}function u(P,y,p){P[p]=y}function d(P){return N.$oe(P,y=>C.concat(y))}function l(P){return N.$ve(P)}function c(P){return N.$qe(P,y=>C.concat(y))}async function g(P){return P.ended?C.concat(P.buffer):C.concat([...P.buffer,await c(P.stream)])}function i(P){return N.$te(P,y=>C.concat(y))}function o(P){return N.$we(P,{data:y=>typeof y=="string"?C.fromString(y):C.wrap(y)},y=>C.concat(y))}function n(P){return N.$ne(y=>C.concat(y),P)}function s(P,y){return N.$xe(P,y,p=>C.concat(p))}function t(P,y){return N.$ye(P,y,p=>C.concat(p))}function r(P){let y=0,p=0,D=0;const z=new Uint8Array(Math.floor(P.length/4*3)),F=X=>{switch(p){case 3:z[D++]=y|X,p=0;break;case 2:z[D++]=y|X>>>2,y=X<<6,p=3;break;case 1:z[D++]=y|X>>>4,y=X<<4,p=2;break;default:y=X<<2,p=1}};for(let X=0;X<P.length;X++){const G=P.charCodeAt(X);if(G>=65&&G<=90)F(G-65);else if(G>=97&&G<=122)F(G-97+26);else if(G>=48&&G<=57)F(G-48+52);else if(G===43||G===45)F(62);else if(G===47||G===95)F(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${P[X]}`)}}const M=D;for(;p>0;)F(0);return C.wrap(z).slice(0,M)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:P},y=!0,p=!1){const D=p?E:a;let z="";const F=P.byteLength%3;let M=0;for(;M<P.byteLength-F;M+=3){const X=P[M+0],G=P[M+1],Y=P[M+2];z+=D[X>>>2],z+=D[(X<<4|G>>>4)&63],z+=D[(G<<2|Y>>>6)&63],z+=D[Y&63]}if(F===1){const X=P[M+0];z+=D[X>>>2],z+=D[X<<4&63],y&&(z+="==")}else if(F===2){const X=P[M+0],G=P[M+1];z+=D[X>>>2],z+=D[(X<<4|G>>>4)&63],z+=D[G<<2&63],y&&(z+="=")}return z}}),define(le[27],he([0,1,129,53]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.GraphemeBreakType=e.$Nf=e.$Gf=e.$zf=e.$yf=void 0,e.$Ze=j,e.$1e=O,e.$2e=C,e.$3e=m,e.$4e=k,e.$5e=v,e.$6e=$,e.$7e=f,e.$8e=h,e.$9e=b,e.$0e=w,e.$$e=u,e.$_e=d,e.$af=l,e.$bf=c,e.$cf=g,e.$df=i,e.$ef=o,e.$ff=n,e.$gf=s,e.$hf=t,e.$if=r,e.$jf=a,e.$kf=E,e.$lf=S,e.$mf=P,e.$nf=y,e.$of=p,e.$pf=D,e.$qf=z,e.$rf=F,e.$sf=M,e.$tf=X,e.$uf=G,e.$vf=Y,e.$wf=V,e.$xf=K,e.$Af=ae,e.$Bf=te,e.$Cf=ce,e.$Df=H,e.$Ef=T,e.$Ff=x,e.$Hf=J,e.$If=ee,e.$Jf=_,e.$Kf=Z,e.$Lf=re,e.$Mf=ue,e.$Of=de,e.$Pf=$e,e.$Qf=ye,e.$Rf=Se,e.$Sf=Ie,e.$Tf=Le,e.$Uf=fe,e.$Vf=me,e.$Wf=De;function j(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const A=/{(\d+)}/g;function O(oe,...ge){return ge.length===0?oe:oe.replace(A,function(we,pe){const Ee=parseInt(pe,10);return isNaN(Ee)||Ee<0||Ee>=ge.length?we:ge[Ee]})}const R=/{([^}]+)}/g;function C(oe,ge){return Object.keys(ge).length===0?oe:oe.replace(R,(we,pe)=>ge[pe]??we)}function m(oe){return oe.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function k(oe){return oe.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function v(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(oe,ge){let we=0;const pe=ge.charCodeAt(0);for(let Ee=oe.length-1;Ee>=0;Ee--)oe.charCodeAt(Ee)===pe&&we++;return we}function f(oe,ge,we="\u2026"){return oe.length<=ge?oe:`${oe.substr(0,ge)}${we}`}function h(oe,ge,we="\u2026"){if(oe.length<=ge)return oe;const pe=Math.ceil(ge/2)-we.length/2,Ee=Math.floor(ge/2)-we.length/2;return`${oe.substr(0,pe)}${we}${oe.substr(oe.length-Ee)}`}function b(oe,ge=" "){const we=w(oe,ge);return u(we,ge)}function w(oe,ge){if(!oe||!ge)return oe;const we=ge.length;if(we===0||oe.length===0)return oe;let pe=0;for(;oe.indexOf(ge,pe)===pe;)pe=pe+we;return oe.substring(pe)}function u(oe,ge){if(!oe||!ge)return oe;const we=ge.length,pe=oe.length;if(we===0||pe===0)return oe;let Ee=pe,Pe=-1;for(;Pe=oe.lastIndexOf(ge,Ee-1),!(Pe===-1||Pe+we!==Ee);){if(Pe===0)return"";Ee=Pe}return oe.substring(0,Ee)}function d(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(oe){return oe.replace(/\*/g,"")}function c(oe,ge,we={}){if(!oe)throw new Error("Cannot create regex from empty string");ge||(oe=v(oe)),we.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let pe="";return we.global&&(pe+="g"),we.matchCase||(pe+="i"),we.multiline&&(pe+="m"),we.unicode&&(pe+="u"),new RegExp(oe,pe)}function g(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function i(oe){return oe.split(/\r\n|\r|\n/)}function o(oe){const ge=[],we=oe.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(we.length/2);pe++)ge.push(we[2*pe]+(we[2*pe+1]??""));return ge}function n(oe){for(let ge=0,we=oe.length;ge<we;ge++){const pe=oe.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}function s(oe,ge=0,we=oe.length){for(let pe=ge;pe<we;pe++){const Ee=oe.charCodeAt(pe);if(Ee!==32&&Ee!==9)return oe.substring(ge,pe)}return oe.substring(ge,we)}function t(oe,ge=oe.length-1){for(let we=ge;we>=0;we--){const pe=oe.charCodeAt(we);if(pe!==32&&pe!==9)return we}return-1}function r(oe,ge,we){const pe=[];let Ee=0;for(const Pe of oe.matchAll(ge)){if(pe.push(oe.slice(Ee,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Ee=Pe.index+Pe[0].length,pe.push(we(Pe[0],...Pe.slice(1),Pe.index,oe,Pe.groups))}return pe.push(oe.slice(Ee)),Promise.all(pe).then(Pe=>Pe.join(""))}function a(oe,ge){return oe<ge?-1:oe>ge?1:0}function E(oe,ge,we=0,pe=oe.length,Ee=0,Pe=ge.length){for(;we<pe&&Ee<Pe;we++,Ee++){const We=oe.charCodeAt(we),Be=ge.charCodeAt(Ee);if(We<Be)return-1;if(We>Be)return 1}const Oe=pe-we,Ne=Pe-Ee;return Oe<Ne?-1:Oe>Ne?1:0}function S(oe,ge){return P(oe,ge,0,oe.length,0,ge.length)}function P(oe,ge,we=0,pe=oe.length,Ee=0,Pe=ge.length){for(;we<pe&&Ee<Pe;we++,Ee++){let We=oe.charCodeAt(we),Be=ge.charCodeAt(Ee);if(We===Be)continue;if(We>=128||Be>=128)return E(oe.toLowerCase(),ge.toLowerCase(),we,pe,Ee,Pe);p(We)&&(We-=32),p(Be)&&(Be-=32);const Fe=We-Be;if(Fe!==0)return Fe}const Oe=pe-we,Ne=Pe-Ee;return Oe<Ne?-1:Oe>Ne?1:0}function y(oe){return oe>=48&&oe<=57}function p(oe){return oe>=97&&oe<=122}function D(oe){return oe>=65&&oe<=90}function z(oe,ge){return oe.length===ge.length&&P(oe,ge)===0}function F(oe,ge){const we=ge.length;return ge.length>oe.length?!1:P(oe,ge,0,we)===0}function M(oe,ge){const we=Math.min(oe.length,ge.length);let pe;for(pe=0;pe<we;pe++)if(oe.charCodeAt(pe)!==ge.charCodeAt(pe))return pe;return we}function X(oe,ge){const we=Math.min(oe.length,ge.length);let pe;const Ee=oe.length-1,Pe=ge.length-1;for(pe=0;pe<we;pe++)if(oe.charCodeAt(Ee-pe)!==ge.charCodeAt(Pe-pe))return pe;return we}function G(oe){return 55296<=oe&&oe<=56319}function Y(oe){return 56320<=oe&&oe<=57343}function V(oe,ge){return(oe-55296<<10)+(ge-56320)+65536}function K(oe,ge,we){const pe=oe.charCodeAt(we);if(G(pe)&&we+1<ge){const Ee=oe.charCodeAt(we+1);if(Y(Ee))return V(pe,Ee)}return pe}function W(oe,ge){const we=oe.charCodeAt(ge-1);if(Y(we)&&ge>1){const pe=oe.charCodeAt(ge-2);if(G(pe))return V(pe,we)}return we}class B{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=W(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=K(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$yf=B;class ie{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new B(ge,we)}nextGraphemeLength(){const ge=Re.getInstance(),we=this.c,pe=we.offset;let Ee=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Pe=we.offset,Oe=ge.getGraphemeBreakType(we.nextCodePoint());if(be(Ee,Oe)){we.setOffset(Pe);break}Ee=Oe}return we.offset-pe}prevGraphemeLength(){const ge=Re.getInstance(),we=this.c,pe=we.offset;let Ee=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Pe=we.offset,Oe=ge.getGraphemeBreakType(we.prevCodePoint());if(be(Oe,Ee)){we.setOffset(Pe);break}Ee=Oe}return pe-we.offset}eol(){return this.c.eol()}}e.$zf=ie;function ae(oe,ge){return new ie(oe,ge).nextGraphemeLength()}function te(oe,ge){return new ie(oe,ge).prevGraphemeLength()}function ce(oe,ge){ge>0&&Y(oe.charCodeAt(ge))&&ge--;const we=ge+ae(oe,ge);return[we-te(oe,we),we]}function H(oe){const ge=new ie(oe);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let U;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(oe){return U||(U=L()),U.test(oe)}const q=/^[\t\n\r\x20-\x7E]*$/;function x(oe){return q.test(oe)}e.$Gf=/[\u2028\u2029]/;function J(oe){return e.$Gf.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function _(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Z(oe,ge,we=""){const pe=oe.trimStart();if(pe.length<ge)return pe;const Ee=/\b/g;let Pe=0;for(;Ee.test(pe)&&!(pe.length-Ee.lastIndex<ge);)Pe=Ee.lastIndex,Ee.lastIndex+=1;return Pe===0?pe:we+pe.substring(Pe).trimStart()}const ne=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*re(oe){let ge=0;for(const we of oe.matchAll(ne))ge!==we.index&&(yield{isCode:!1,str:oe.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==oe.length&&(yield{isCode:!1,str:oe.substring(ge)})}function ue(oe){return oe&&(oe=oe.replace(ne,"")),oe}e.$Nf="\uFEFF";function de(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function $e(oe){return de(oe)?oe.substr(1):oe}function ye(oe,ge){if(!oe||!ge||oe.length<ge.length)return!1;const we=ge.length,pe=oe.toLowerCase();let Ee=0,Pe=-1;for(;Ee<we;){const Oe=pe.indexOf(ge[Ee],Pe+1);if(Oe<0)return!1;Pe=Oe,Ee++}return!0}function Se(oe,ge=!1){return oe?(ge&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Ie(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Le(oe,ge=1){if(ge===0)return"";let we=-1;do we=oe.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?oe:(oe[we-1]==="\r"&&we--,oe.substr(0,we))}function fe(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function me(oe){return Re.getInstance().getGraphemeBreakType(oe)}function be(oe,ge){return oe===0?ge!==5&&ge!==7:oe===2&&ge===3?!1:oe===4||oe===2||oe===3||ge===4||ge===2||ge===3?!0:!(oe===8&&(ge===8||ge===9||ge===11||ge===12)||(oe===11||oe===9)&&(ge===9||ge===10)||(oe===12||oe===10)&&ge===10||ge===5||ge===13||ge===7||oe===1||oe===13&&ge===14||oe===6&&ge===6)}var Ce;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=ze()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const we=this.d,pe=we.length/3;let Ee=1;for(;Ee<=pe;)if(ge<we[3*Ee])Ee=2*Ee;else if(ge>we[3*Ee+1])Ee=2*Ee+1;else return we[3*Ee+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(oe,ge){if(oe===0)return 0;const we=Ue(oe,ge);if(we!==void 0)return we;const pe=new B(ge,oe);return pe.prevCodePoint(),pe.offset}function Ue(oe,ge){const we=new B(ge,oe);let pe=we.prevCodePoint();for(;Te(pe)||pe===65039||pe===8419;){if(we.offset===0)return;pe=we.prevCodePoint()}if(!_(pe))return;let Ee=we.offset;return Ee>0&&we.prevCodePoint()===8205&&(Ee=we.offset),Ee}function Te(oe){return 127995<=oe&&oe<=127999}var Me;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$Xf="\xA0";class qe{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Ve(ge=>{function we(Fe){const Qe=new Map;for(let Ge=0;Ge<Fe.length;Ge+=2)Qe.set(Fe[Ge],Fe[Ge+1]);return Qe}function pe(Fe,Qe){const Ge=new Map(Fe);for(const[_e,tt]of Qe)Ge.set(_e,tt);return Ge}function Ee(Fe,Qe){if(!Fe)return Qe;const Ge=new Map;for(const[_e,tt]of Fe)Qe.has(_e)&&Ge.set(_e,tt);return Ge}const Pe=this.c.value;let Oe=ge.filter(Fe=>!Fe.startsWith("_")&&Fe in Pe);Oe.length===0&&(Oe=["_default"]);let Ne;for(const Fe of Oe){const Qe=we(Pe[Fe]);Ne=Ee(Ne,Qe)}const We=we(Pe._common),Be=pe(We,Ne);return new qe(Be)})}static getInstance(ge){return qe.d.get(Array.from(ge))}static{this.e=new N.$V(()=>Object.keys(qe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return qe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Yf=qe;class Ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ae.c())),this.d}static isInvisibleCharacter(ge){return Ae.e().has(ge)}static get codePoints(){return Ae.e()}}e.$Zf=Ae}),define(le[54],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$fj=void 0,e.$bj=N,e.$cj=j,e.$dj=A,e.$ej=R,e.$gj=b;function N(u){return j(u,0)}function j(u,d){switch(typeof u){case"object":return u===null?A(349,d):Array.isArray(u)?C(u,d):m(u,d);case"string":return R(u,d);case"boolean":return O(u,d);case"number":return A(u,d);case"undefined":return A(937,d);default:return A(617,d)}}function A(u,d){return(d<<5)-d+u|0}function O(u,d){return A(u?433:863,d)}function R(u,d){d=A(149417,d);for(let l=0,c=u.length;l<c;l++)d=A(u.charCodeAt(l),d);return d}function C(u,d){return d=A(104579,d),u.reduce((l,c)=>j(c,l),d)}function m(u,d){return d=A(181387,d),Object.keys(u).sort().reduce((l,c)=>(l=R(c,l),j(u[c],l)),d)}class k{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=j(d,this.g),this.g}}e.$fj=k;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function $(u,d,l=32){const c=l-d,g=~((1<<c)-1);return(u<<d|(g&u)>>>c)>>>0}function f(u,d=0,l=u.byteLength,c=0){for(let g=0;g<l;g++)u[d+g]=c}function h(u,d,l="0"){for(;u.length<d;)u=l+u;return u}function b(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(l=>l.toString(16).padStart(2,"0")).join(""):h((u>>>0).toString(16),d/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const l=d.length;if(l===0)return;const c=this.p;let g=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(I.$uf(o))if(n+1<l){const t=d.charCodeAt(n+1);I.$vf(t)?(n++,s=I.$wf(o,t)):s=65533}else{i=o;break}else I.$vf(o)&&(s=65533);if(g=this.w(c,g,s),n++,n<l)o=d.charCodeAt(n);else break}this.r=g,this.u=i}w(d,l,c){return c<128?d[l++]=c:c<2048?(d[l++]=192|(c&1984)>>>6,d[l++]=128|(c&63)>>>0):c<65536?(d[l++]=224|(c&61440)>>>12,d[l++]=128|(c&4032)>>>6,d[l++]=128|(c&63)>>>0):(d[l++]=240|(c&1835008)>>>18,d[l++]=128|(c&258048)>>>12,d[l++]=128|(c&4032)>>>6,d[l++]=128|(c&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=w.g,l=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,$(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this.h,g=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=g&i|~g&o,t=1518500249):a<40?(s=g^i^o,t=1859775393):a<60?(s=g&i|g&o|i&o,t=2400959708):(s=g^i^o,t=3395469782),r=$(c,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=$(g,30),g=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$hj=w}),define(le[88],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(N||(N={})),function(j){const A="error",O="warning",R="warn",C="info",m="ignore";function k($){return $?I.$qf(A,$)?j.Error:I.$qf(O,$)||I.$qf(R,$)?j.Warning:I.$qf(C,$)?j.Info:j.Ignore:j.Ignore}j.fromValue=k;function v($){switch($){case j.Error:return A;case j.Warning:return O;case j.Info:return C;default:return m}}j.toString=v}(N||(N={})),e.default=N}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(le[51],he([0,1,17,27]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;class j{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const h=f.charCodeAt(0),b=this.b.charCodeAt(this.c);return h-b}value(){return this.b[this.c]}}e.$pi=j;class A{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,N.$kf)(f,this.b,0,f.length,this.c,this.d):(0,N.$mf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qi=A;class O{constructor(f=!0,h=!0){this.f=f,this.g=h}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let h=f.length-1;h>=0;h--,this.c--){const b=this.b.charCodeAt(h);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,N.$kf)(f,this.b,0,f.length,this.d,this.e):(0,N.$mf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ri=O;var R;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(R||(R={}));class C{constructor(f,h){this.f=f,this.g=h,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,N.$lf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,N.$lf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,N.$jf)(f,this.c.query);if(this.d[this.e]===5)return(0,N.$jf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$si=C;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var k;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(k||(k={}));class v{static forUris(f=()=>!1,h=()=>!1){return new v(new C(f,h))}static forPaths(f=!1){return new v(new O(void 0,!f))}static forStrings(){return new v(new j)}static forConfigKeys(){return new v(new A)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,h){if(h){const b=h.slice(0);(0,I.$Xb)(b);for(const w of b)this.set(w,f)}else{const b=f.slice(0);(0,I.$Xb)(b);for(const w of b)this.set(w[0],w[1])}}set(f,h){const b=this.b.reset(f);let w;this.c||(this.c=new m,this.c.segment=b.value());const u=[];for(w=this.c;;){const l=b.cmp(w.segment);if(l>0)w.left||(w.left=new m,w.left.segment=b.value()),u.push([-1,w]),w=w.left;else if(l<0)w.right||(w.right=new m,w.right.segment=b.value()),u.push([1,w]),w=w.right;else if(b.hasNext())b.next(),w.mid||(w.mid=new m,w.mid.segment=b.value()),u.push([0,w]),w=w.mid;else break}const d=w.value;w.value=h,w.key=f;for(let l=u.length-1;l>=0;l--){const c=u[l][1];c.updateHeight();const g=c.balanceFactor();if(g<-1||g>1){const i=u[l][0],o=u[l+1][0];if(i===1&&o===1)u[l][1]=c.rotateLeft();else if(i===-1&&o===-1)u[l][1]=c.rotateRight();else if(i===1&&o===-1)c.right=u[l+1][1]=u[l+1][1].rotateRight(),u[l][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=u[l+1][1]=u[l+1][1].rotateLeft(),u[l][1]=c.rotateRight();else throw new Error;if(l>0)switch(u[l-1][0]){case-1:u[l-1][1].left=u[l][1];break;case 1:u[l-1][1].right=u[l][1];break;case 0:u[l-1][1].mid=u[l][1];break}else this.c=u[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const h=this.b.reset(f);let b=this.c;for(;b;){const w=h.cmp(b.segment);if(w>0)b=b.left;else if(w<0)b=b.right;else if(h.hasNext())h.next(),b=b.mid;else break}return b}has(f){const h=this.d(f);return!(h?.value===void 0&&h?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,h){const b=this.b.reset(f),w=[];let u=this.c;for(;u;){const d=b.cmp(u.segment);if(d>0)w.push([-1,u]),u=u.left;else if(d<0)w.push([1,u]),u=u.right;else if(b.hasNext())b.next(),w.push([0,u]),u=u.mid;else break}if(u){if(h?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:l,value:c,segment:g}=d;this.e(d.key,!1),u.key=l,u.value=c,u.segment=g}}else{const d=u.left??u.right;if(w.length>0){const[l,c]=w[w.length-1];switch(l){case-1:c.left=d;break;case 0:c.mid=d;break;case 1:c.right=d;break}}else this.c=d}for(let d=w.length-1;d>=0;d--){const l=w[d][1];l.updateHeight();const c=l.balanceFactor();if(c>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),w[d][1]=l.rotateLeft()):c<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),w[d][1]=l.rotateRight()),d>0)switch(w[d-1][0]){case-1:w[d-1][1].left=w[d][1];break;case 1:w[d-1][1].right=w[d][1];break;case 0:w[d-1][1].mid=w[d][1];break}else this.c=w[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const h=this.b.reset(f);let b=this.c,w;for(;b;){const u=h.cmp(b.segment);if(u>0)b=b.left;else if(u<0)b=b.right;else if(h.hasNext())h.next(),w=b.value||w,b=b.mid;else break}return b&&b.value||w}findSuperstr(f){return this.g(f,!1)}g(f,h){const b=this.b.reset(f);let w=this.c;for(;w;){const u=b.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(b.hasNext())b.next(),w=w.mid;else return w.mid?this.h(w.mid):h?w.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[h,b]of this)f(b,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const h=[];return this.j(f,h),h[Symbol.iterator]()}j(f,h){f&&(f.left&&this.j(f.left,h),f.value&&h.push([f.key,f.value]),f.mid&&this.j(f.mid,h),f.right&&this.j(f.right,h))}_isBalanced(){const f=h=>{if(!h)return!0;const b=h.balanceFactor();return b<-1||b>1?!1:f(h.left)&&f(h.right)};return f(this.c)}}e.$ti=v}),define(le[13],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=I,e.$2f=N,e.$3f=j,e.$4f=A,e.$5f=O,e.$6f=R,e.$7f=C,e.$8f=m,e.$9f=k,e.$0f=v,e.$$f=$,e.$_f=f,e.$ag=h,e.$bg=w,e.$cg=u,e.$dg=d,e.$eg=l,e.$fg=c;function I(g){return typeof g=="string"}function N(g){return Array.isArray(g)&&g.every(i=>I(i))}function j(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}function A(g){const i=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof i}function O(g){return typeof g=="number"&&!isNaN(g)}function R(g){return!!g&&typeof g[Symbol.iterator]=="function"}function C(g){return g===!0||g===!1}function m(g){return typeof g>"u"}function k(g){return!v(g)}function v(g){return m(g)||g===null}function $(g,i){if(!g)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f(g){if(v(g))throw new Error("Assertion Failed: argument is undefined or null");return g}function h(...g){const i=[];for(let o=0;o<g.length;o++){const n=g[o];if(v(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const b=Object.prototype.hasOwnProperty;function w(g){if(!j(g))return!1;for(const i in g)if(b.call(g,i))return!1;return!0}function u(g){return typeof g=="function"}function d(...g){return g.length>0&&g.every(u)}function l(g,i){const o=Math.min(g.length,i.length);for(let n=0;n<o;n++)c(g[n],i[n])}function c(g,i){if(I(i)){if(typeof g!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(g instanceof i)return}catch{}if(!v(g)&&g.constructor===i||i.length===1&&i.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=N,e.$Un=j,e.$Vn=O,e.$Wn=C,e.$Xn=m,e.$Yn=k,e.$Zn=v,e.$1n=$,e.$2n=f,e.$3n=h,e.$4n=b,e.$5n=w;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([l,c])=>{d[l]=c&&typeof c=="object"?N(c):c}),d}function j(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const l=d.shift();Object.freeze(l);for(const c in l)if(A.call(l,c)){const g=l[c];typeof g=="object"&&!Object.isFrozen(g)&&!(0,I.$4f)(g)&&d.push(g)}}return u}const A=Object.prototype.hasOwnProperty;function O(u,d){return R(u,d,new Set)}function R(u,d,l){if((0,I.$0f)(u))return u;const c=d(u);if(typeof c<"u")return c;if(Array.isArray(u)){const g=[];for(const i of u)g.push(R(i,d,l));return g}if((0,I.$3f)(u)){if(l.has(u))throw new Error("Cannot clone recursive data-structure");l.add(u);const g={};for(const i in u)A.call(u,i)&&(g[i]=R(u[i],d,l));return l.delete(u),g}return u}function C(u,d,l=!0){return(0,I.$3f)(u)?((0,I.$3f)(d)&&Object.keys(d).forEach(c=>{c in u?l&&((0,I.$3f)(u[c])&&(0,I.$3f)(d[c])?C(u[c],d[c],l):u[c]=d[c]):u[c]=d[c]}),u):d}function m(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let l,c;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(l=0;l<u.length;l++)if(!m(u[l],d[l]))return!1}else{const g=[];for(c in u)g.push(c);g.sort();const i=[];for(c in d)i.push(c);if(i.sort(),!m(g,i))return!1;for(l=0;l<g.length;l++)if(!m(u[g[l]],d[g[l]]))return!1}return!0}function k(u){const d=new Set;return JSON.stringify(u,(l,c)=>{if((0,I.$3f)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return c})}function v(u,d){const l=Object.create(null);return!u||!d||Object.keys(d).forEach(g=>{const i=u[g],o=d[g];m(i,o)||(l[g]=o)}),l}function $(u,d){const l=d.toLowerCase(),c=Object.keys(u).find(g=>g.toLowerCase()===l);return c?u[c]:u[d]}function f(u,d){const l=Object.create(null);for(const[c,g]of Object.entries(u))d(c,g)&&(l[c]=g);return l}function h(u){let d=[];for(;Object.prototype!==u;)d=d.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return d}function b(u){const d=[];for(const l of h(u))typeof u[l]=="function"&&d.push(l);return d}function w(u,d){const l=g=>function(){const i=Array.prototype.slice.call(arguments,0);return d(g,i)},c={};for(const g of u)c[g]=l(g);return c}}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(j){return I.test(j)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(R){for(let C=0;C<R.length;C++)R[C]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){j(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let C=0,m="";return m+=O[A[C++]],m+=O[A[C++]],m+=O[A[C++]],m+=O[A[C++]],m+="-",m+=O[A[C++]],m+=O[A[C++]],m+="-",m+=O[A[C++]],m+=O[A[C++]],m+="-",m+=O[A[C++]],m+=O[A[C++]],m+="-",m+=O[A[C++]],m+=O[A[C++]],m+=O[A[C++]],m+=O[A[C++]],m+=O[A[C++]],m+=O[A[C++]],m}}()}),define(le[131],he([0,1,37]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=A;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function A(){const O=(0,I.networkInterfaces)();for(const R in O){const C=O[R];if(C){for(const{mac:m}of C)if(j(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[132],he([0,1,273,15]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dW=void 0;class j extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,C){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let m=0;for(;m<this.a.length;){const k=typeof this.b=="number"?this.a.indexOf(this.b,m):(0,N.$Ae)(this.a,this.b,m);if(k===-1)break;this.push(this.a.slice(m,k+this.c)),m=k+this.c}this.a=m===this.a.length?void 0:this.a.slice(m),C()}_flush(O){this.a&&this.push(this.a),O()}}e.$dW=j}),define(le[133],he([0,1,64]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N,e.$Ng=A;function N(R,C,m,k=1){let v=!1;return new Promise($=>{const f=setTimeout(()=>{if(!v)return v=!0,$(0)},m);j(R,C,k,h=>{if(!v)return v=!0,clearTimeout(f),$(h)})})}function j(R,C,m,k){if(C===0)return k(0);const v=new I.Socket;v.once("connect",()=>(O(v),j(R+m,C-1,m,k))),v.once("data",()=>{}),v.once("error",$=>(O(v),$.code!=="ECONNREFUSED"?j(R+m,C-1,m,k):k(R))),v.connect(R,"127.0.0.1")}e.$Mg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,C,m,k="127.0.0.1"){let v=!1,$,f=1;const h=I.createServer({pauseOnConnect:!0});function b(w,u){v||(v=!0,h.removeAllListeners(),h.close(),$&&clearTimeout($),u(w))}return new Promise(w=>{$=setTimeout(()=>{b(0,w)},m),h.on("listening",()=>{b(R,w)}),h.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<C?(R++,f++,h.listen(R,k)):b(0,w)}),h.on("close",()=>{b(0,w)}),h.listen(R,k)})}function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vW=I;function I(N){return!!N.parentPort}}),define(le[135],he([11,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=m,e.$Tm=k,e.$Um=v;const N=60,j=N*60,A=j*24,O=A*7,R=A*30,C=A*365;function m($,f,h,b){typeof $!="number"&&($=$.getTime());const w=Math.round((new Date().getTime()-$)/1e3);if(w<-30)return(0,I.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!b&&w<30)return(0,I.localize)(1,null);let u;return w<N?(u=w,f?u===1?h?(0,I.localize)(2,null,u):(0,I.localize)(3,null,u):h?(0,I.localize)(4,null,u):(0,I.localize)(5,null,u):u===1?h?(0,I.localize)(6,null,u):(0,I.localize)(7,null,u):h?(0,I.localize)(8,null,u):(0,I.localize)(9,null,u)):w<j?(u=Math.floor(w/N),f?u===1?h?(0,I.localize)(10,null,u):(0,I.localize)(11,null,u):h?(0,I.localize)(12,null,u):(0,I.localize)(13,null,u):u===1?h?(0,I.localize)(14,null,u):(0,I.localize)(15,null,u):h?(0,I.localize)(16,null,u):(0,I.localize)(17,null,u)):w<A?(u=Math.floor(w/j),f?u===1?h?(0,I.localize)(18,null,u):(0,I.localize)(19,null,u):h?(0,I.localize)(20,null,u):(0,I.localize)(21,null,u):u===1?h?(0,I.localize)(22,null,u):(0,I.localize)(23,null,u):h?(0,I.localize)(24,null,u):(0,I.localize)(25,null,u)):w<O?(u=Math.floor(w/A),f?u===1?(0,I.localize)(26,null,u):(0,I.localize)(27,null,u):u===1?(0,I.localize)(28,null,u):(0,I.localize)(29,null,u)):w<R?(u=Math.floor(w/O),f?u===1?h?(0,I.localize)(30,null,u):(0,I.localize)(31,null,u):h?(0,I.localize)(32,null,u):(0,I.localize)(33,null,u):u===1?h?(0,I.localize)(34,null,u):(0,I.localize)(35,null,u):h?(0,I.localize)(36,null,u):(0,I.localize)(37,null,u)):w<C?(u=Math.floor(w/R),f?u===1?h?(0,I.localize)(38,null,u):(0,I.localize)(39,null,u):h?(0,I.localize)(40,null,u):(0,I.localize)(41,null,u):u===1?h?(0,I.localize)(42,null,u):(0,I.localize)(43,null,u):h?(0,I.localize)(44,null,u):(0,I.localize)(45,null,u)):(u=Math.floor(w/C),f?u===1?h?(0,I.localize)(46,null,u):(0,I.localize)(47,null,u):h?(0,I.localize)(48,null,u):(0,I.localize)(49,null,u):u===1?h?(0,I.localize)(50,null,u):(0,I.localize)(51,null,u):h?(0,I.localize)(52,null,u):(0,I.localize)(53,null,u))}function k($,f){const h=Math.abs($/1e3);return h<1?f?(0,I.localize)(54,null,$):(0,I.localize)(55,null,$):h<N?f?(0,I.localize)(56,null,Math.round($)/1e3):(0,I.localize)(57,null,Math.round($)/1e3):h<j?f?(0,I.localize)(58,null,Math.round($/(1e3*N))):(0,I.localize)(59,null,Math.round($/(1e3*N))):h<A?f?(0,I.localize)(60,null,Math.round($/(1e3*j))):(0,I.localize)(61,null,Math.round($/(1e3*j))):(0,I.localize)(62,null,Math.round($/(1e3*A)))}function v($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[136],he([11,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,13,136]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=C,e.$_i=m,e.$aj=k;function A(v,$){return $&&(v.stack||v.stacktrace)?j.localize(0,null,R(v),O(v.stack)||O(v.stacktrace)):R(v)}function O(v){return Array.isArray(v)?v.join(`
`):v}function R(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?j.localize(1,null,v.message):v.message||j.localize(2,null)}function C(v=null,$=!1){if(!v)return j.localize(3,null);if(Array.isArray(v)){const f=I.$Hb(v),h=C(f[0],$);return f.length>1?j.localize(4,null,h,f.length):h}if(N.$1f(v))return v;if(v.detail){const f=v.detail;if(f.error)return A(f.error,$);if(f.exception)return A(f.exception,$)}return v.stack?A(v,$):v.message?v.message:j.localize(5,null)}function m(v){const $=v;return $ instanceof Error&&Array.isArray($.actions)}function k(v,$){let f;return typeof v=="string"?f=new Error(v):f=v,f.actions=$,f}}),define(le[137],he([11,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=N;function N(j){switch(j){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}}),define(le[139],he([11,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=E,e.$J=S,e.$g="en";let N=!1,j=!1,A=!1,O=!1,R=!1,C=!1,m=!1,k=!1,v=!1,$=!1,f,h=e.$g,b=e.$g,w,u;const d=globalThis;let l;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?l=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const c=typeof l?.versions?.electron=="string",g=c&&l?.type==="renderer";if(typeof l=="object"){N=l.platform==="win32",j=l.platform==="darwin",A=l.platform==="linux",O=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,m=c,v=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,h=e.$g;const P=l.env.VSCODE_NLS_CONFIG;if(P)try{const y=JSON.parse(P),p=y.availableLanguages["*"];f=y.locale,b=y.osLocale,h=p||e.$g,w=y._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!g?(u=navigator.userAgent,N=u.indexOf("Windows")>=0,j=u.indexOf("Macintosh")>=0,k=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=u.indexOf("Linux")>=0,$=u?.indexOf("Mobi")>=0,C=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,h=f,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;j?n=1:N?n=3:A&&(n=2),e.$i=N,e.$j=j,e.$k=A,e.$l=O,e.$m=R,e.$n=m,e.$o=C,e.$p=C&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=k,e.$s=$,e.$t=v,e.$u=n,e.$v=u,e.$w=h;var s;(function(P){function y(){return e.$w}P.value=y;function p(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}P.isDefaultVariant=p;function D(){return e.$w==="en"}P.isDefault=D})(s||(e.Language=s={})),e.$x=f,e.$y=b,e.$z=w,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const P=[];d.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let D=0,z=P.length;D<z;D++){const F=P[D];if(F.id===p.data.vscodeScheduleAsyncWork){P.splice(D,1),F.callback();return}}});let y=0;return p=>{const D=++y;P.push({id:D,callback:p}),d.postMessage({vscodeScheduleAsyncWork:D},"*")}}return P=>setTimeout(P)})();var t;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=j||k?2:N?1:3;let r=!0,a=!1;function E(){if(!a){a=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,r=new Uint16Array(P.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(P){return parseFloat(P)>=20}}),define(le[36],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const A=j.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(le[140],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WV=O;var N;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(N||(N={}));const j="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function O(){const R=I.env[j];if(R){const m=R.split(":").map(k=>k.trim()).filter(k=>k.length>0);for(const k of m)switch(k){case"Unity":{const v=I.env.DESKTOP_SESSION;return v&&v.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const v=I.env[A];return v==="5"?N.KDE5:v==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const C=I.env.DESKTOP_SESSION;if(C)switch(C){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return A in I.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?N.GNOME:"KDE_FULL_SESSION"in I.env?A in I.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(le[14],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,j=97,A=90,O=122,R=46,C=47,m=92,k=58,v=63;class $ extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new $(o,"Object",i)}function h(i,o){if(typeof i!="string")throw new $(o,"string",i)}const b=I.$ec==="win32";function w(i){return i===C||i===m}function u(i){return i===C}function d(i){return i>=N&&i<=A||i>=j&&i<=O}function l(i,o,n,s){let t="",r=0,a=-1,E=0,S=0;for(let P=0;P<=i.length;++P){if(P<i.length)S=i.charCodeAt(P);else{if(s(S))break;S=C}if(s(S)){if(!(a===P-1||E===1))if(E===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const y=t.lastIndexOf(n);y===-1?(t="",r=0):(t=t.slice(0,y),r=t.length-1-t.lastIndexOf(n)),a=P,E=0;continue}else if(t.length!==0){t="",r=0,a=P,E=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,P)}`:t=i.slice(a+1,P),r=P-a-1;a=P,E=0}else S===R&&E!==-1?++E:E=-1}return t}function c(i,o){f(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$gc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],h(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let E=0,S="",P=!1;const y=r.charCodeAt(0);if(a===1)w(y)&&(E=1,P=!0);else if(w(y))if(P=!0,w(r.charCodeAt(1))){let p=2,D=p;for(;p<a&&!w(r.charCodeAt(p));)p++;if(p<a&&p!==D){const z=r.slice(D,p);for(D=p;p<a&&w(r.charCodeAt(p));)p++;if(p<a&&p!==D){for(D=p;p<a&&!w(r.charCodeAt(p));)p++;(p===a||p!==D)&&(S=`\\\\${z}\\${r.slice(D,p)}`,E=p)}}}else E=1;else d(y)&&r.charCodeAt(1)===k&&(S=r.slice(0,2),E=2,a>2&&w(r.charCodeAt(2))&&(P=!0,E=3));if(S.length>0)if(o.length>0){if(S.toLowerCase()!==o.toLowerCase())continue}else o=S;if(s){if(o.length>0)break}else if(n=`${r.slice(E)}\\${n}`,s=P,P&&o.length>0)break}return n=l(n,!s,"\\",w),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){h(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return u(r)?"\\":i;if(w(r))if(t=!0,w(i.charCodeAt(1))){let E=2,S=E;for(;E<o&&!w(i.charCodeAt(E));)E++;if(E<o&&E!==S){const P=i.slice(S,E);for(S=E;E<o&&w(i.charCodeAt(E));)E++;if(E<o&&E!==S){for(S=E;E<o&&!w(i.charCodeAt(E));)E++;if(E===o)return`\\\\${P}\\${i.slice(S)}\\`;E!==S&&(s=`\\\\${P}\\${i.slice(S,E)}`,n=E)}}}else n=1;else d(r)&&i.charCodeAt(1)===k&&(s=i.slice(0,2),n=2,o>2&&w(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?l(i.slice(n),!t,"\\",w):"";return a.length===0&&!t&&(a="."),a.length>0&&w(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){h(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return w(n)||o>2&&d(n)&&i.charCodeAt(1)===k&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];h(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&w(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$gc.normalize(o)},relative(i,o){if(h(i,"from"),h(o,"to"),i===o)return"";const n=e.$gc.resolve(i),s=e.$gc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===m;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===m;)r--;const a=r-t;let E=0;for(;E<o.length&&o.charCodeAt(E)===m;)E++;let S=o.length;for(;S-1>E&&o.charCodeAt(S-1)===m;)S--;const P=S-E,y=a<P?a:P;let p=-1,D=0;for(;D<y;D++){const F=i.charCodeAt(t+D);if(F!==o.charCodeAt(E+D))break;F===m&&(p=D)}if(D!==y){if(p===-1)return s}else{if(P>y){if(o.charCodeAt(E+D)===m)return s.slice(E+D+1);if(D===2)return s.slice(E+D)}a>y&&(i.charCodeAt(t+D)===m?p=D:D===2&&(p=3)),p===-1&&(p=0)}let z="";for(D=t+p+1;D<=r;++D)(D===r||i.charCodeAt(D)===m)&&(z+=z.length===0?"..":"\\..");return E+=p,z.length>0?`${z}${s.slice(E,S)}`:(s.charCodeAt(E)===m&&++E,s.slice(E,S))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$gc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const n=o.charCodeAt(2);if(n!==v&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===k&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return i},dirname(i){h(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return w(t)?i:".";if(w(t)){if(n=s=1,w(i.charCodeAt(1))){let E=2,S=E;for(;E<o&&!w(i.charCodeAt(E));)E++;if(E<o&&E!==S){for(S=E;E<o&&w(i.charCodeAt(E));)E++;if(E<o&&E!==S){for(S=E;E<o&&!w(i.charCodeAt(E));)E++;if(E===o)return i;E!==S&&(n=s=E+1)}}}}else d(t)&&i.charCodeAt(1)===k&&(n=o>2&&w(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let E=o-1;E>=s;--E)if(w(i.charCodeAt(E))){if(!a){r=E;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&h(o,"ext"),h(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===k&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=n;--r){const S=i.charCodeAt(r);if(w(S)){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(S===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(w(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){h(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===k&&d(i.charCodeAt(0))&&(o=s=2);for(let E=i.length-1;E>=o;--E){const S=i.charCodeAt(E);if(w(S)){if(!r){s=E+1;break}continue}t===-1&&(r=!1,t=E+1),S===R?n===-1?n=E:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){h(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return w(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(w(t)){if(s=1,w(i.charCodeAt(1))){let p=2,D=p;for(;p<n&&!w(i.charCodeAt(p));)p++;if(p<n&&p!==D){for(D=p;p<n&&w(i.charCodeAt(p));)p++;if(p<n&&p!==D){for(D=p;p<n&&!w(i.charCodeAt(p));)p++;p===n?s=p:p!==D&&(s=p+1)}}}}else if(d(t)&&i.charCodeAt(1)===k){if(n<=2)return o.root=o.dir=i,o;if(s=2,w(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,E=-1,S=!0,P=i.length-1,y=0;for(;P>=s;--P){if(t=i.charCodeAt(P),w(t)){if(!S){a=P+1;break}continue}E===-1&&(S=!1,E=P+1),t===R?r===-1?r=P:y!==1&&(y=1):r!==-1&&(y=-1)}return E!==-1&&(r===-1||y===0||y===1&&r===E-1&&r===a+1?o.base=o.name=i.slice(a,E):(o.name=i.slice(a,r),o.base=i.slice(a,E),o.ext=i.slice(r,E))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(b){const i=/\\/g;return()=>{const o=I.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$hc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:g();h(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===C)}return o=l(o,!n,"/",u),n?`/${o}`:o.length>0?o:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===C,n=i.charCodeAt(i.length-1)===C;return i=l(i,!o,"/",u),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===C},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];h(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$hc.normalize(o)},relative(i,o){if(h(i,"from"),h(o,"to"),i===o||(i=e.$hc.resolve(i),o=e.$hc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,E=t<a?t:a;let S=-1,P=0;for(;P<E;P++){const p=i.charCodeAt(n+P);if(p!==o.charCodeAt(r+P))break;p===C&&(S=P)}if(P===E)if(a>E){if(o.charCodeAt(r+P)===C)return o.slice(r+P+1);if(P===0)return o.slice(r+P)}else t>E&&(i.charCodeAt(n+P)===C?S=P:P===0&&(S=0));let y="";for(P=n+S+1;P<=s;++P)(P===s||i.charCodeAt(P)===C)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(r+S)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===C;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===C){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&h(o,"ext"),h(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=0;--r){const S=i.charCodeAt(r);if(S===C){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(S===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===C){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){h(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const E=i.charCodeAt(a);if(E===C){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),E===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){h(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===C;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,E=!0,S=i.length-1,P=0;for(;S>=s;--S){const y=i.charCodeAt(S);if(y===C){if(!E){r=S+1;break}continue}a===-1&&(E=!1,a=S+1),y===R?t===-1?t=S:P!==1&&(P=1):t!==-1&&(P=-1)}if(a!==-1){const y=r===0&&n?1:r;t===-1||P===0||P===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(y,a):(o.name=i.slice(y,t),o.base=i.slice(y,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=b?e.$gc.normalize:e.$hc.normalize,e.$jc=b?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=b?e.$gc.join:e.$hc.join,e.$lc=b?e.$gc.resolve:e.$hc.resolve,e.$mc=b?e.$gc.relative:e.$hc.relative,e.$nc=b?e.$gc.dirname:e.$hc.dirname,e.$oc=b?e.$gc.basename:e.$hc.basename,e.$pc=b?e.$gc.extname:e.$hc.extname,e.$qc=b?e.$gc.format:e.$hc.format,e.$rc=b?e.$gc.parse:e.$hc.parse,e.$sc=b?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=b?e.$gc.sep:e.$hc.sep,e.$uc=b?e.$gc.delimiter:e.$hc.delimiter}),define(le[44],he([0,1,14,5,27,13]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=O,e.$hg=R,e.$ig=C,e.$jg=m,e.$kg=k,e.$lg=h,e.$mg=b,e.$ng=w,e.$og=u,e.$pg=d,e.$qg=l,e.$rg=c,e.$sg=g,e.$tg=i,e.$ug=o,e.$vg=t;function O(r){return r===47||r===92}function R(r){return r.replace(/[\\/]/g,I.$hc.sep)}function C(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function m(r,a=I.$hc.sep){if(!r)return"";const E=r.length,S=r.charCodeAt(0);if(O(S)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let y=3;const p=y;for(;y<E&&!O(r.charCodeAt(y));y++);if(p!==y&&!O(r.charCodeAt(y+1))){for(y+=1;y<E;y++)if(O(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(u(S)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let P=r.indexOf("://");if(P!==-1){for(P+=3;P<E;P++)if(O(r.charCodeAt(P)))return r.slice(0,P+1)}return""}function k(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let E=2;const S=E;for(;E<r.length&&(a=r.charCodeAt(E),a!==92);E++);return!(S===E||(a=r.charCodeAt(E+1),isNaN(a)||a===92))}const v=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,a=N.$i){const E=a?v:$;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||a&&f.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function b(r,a,E){const S=r===a;return!E||S?S:!r||!a?!1:(0,j.$qf)(r,a)}function w(r,a,E,S=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(E){if(!(0,j.$rf)(r,a))return!1;if(a.length===r.length)return!0;let y=a.length;return a.charAt(a.length-1)===S&&y--,r.charAt(y)===S}return a.charAt(a.length-1)!==S&&(a+=S),r.indexOf(a)===0}function u(r){return r>=65&&r<=90||r>=97&&r<=122}function d(r,a){return N.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$jc)(r)||(r=(0,I.$kc)(a,r)),r=(0,I.$ic)(r),N.$i?(r=(0,j.$$e)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,j.$$e)(r,I.sep),r||(r=I.sep)),r}function l(r){const a=(0,I.$ic)(r);return N.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$hc.sep}function c(r,a=N.$i){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function g(r,a=N.$i){return c(r,a)?r[0]:void 0}function i(r,a,E){return a.length>r.length?-1:r===a?0:(E&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let E,S,P;for(const y of a){const p=Number(y);(0,A.$5f)(p)?S===void 0?S=p:P===void 0&&(P=p):E=E?[E,y].join(":"):y}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:S!==void 0?S:void 0,column:P!==void 0?P:S!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,E=8){let S="";for(let y=0;y<E;y++){let p;y===0&&N.$i&&!a&&(E===3||E===4)?p=s:p=n,S+=p.charAt(Math.floor(Math.random()*p.length))}let P;return a?P=`${a}-${S}`:P=S,r?(0,I.$kc)(r,P):P}}),define(le[141],he([0,1,14]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Fs=A,e.$Gs=O,e.$Hs=R,e.$Is=m,e.$Es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(k){const v=(0,I.$pc)(k),$=N[v.toLowerCase()];return $!==void 0?$:O(k)}function O(k){const v=(0,I.$pc)(k);return j[v.toLowerCase()]}function R(k){for(const v in j)if(j[v]===k)return v}const C=/^(.+)\/(.+?)(;.+)?$/;function m(k,v){const $=C.exec(k);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:v?void 0:k}}),define(le[89],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$dm=A,e.$em=O;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var j;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function A(R,...C){const m=C.reduce(($,f)=>($[f]=!0,$),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter($=>!m[$]).forEach($=>{for(let f=0;f<k.length;f++)if($.search(k[f])!==-1){delete R[$];break}})}function O(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}}),define(le[8],he([0,1,14,5]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=h,e.$xc=c;const j=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!j.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(s,t){return!s&&!t?"file":s}function m(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==v&&(t=v+t):t=v;break}return t}const k="",v="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,E,S,P=!1){typeof t=="object"?(this.scheme=t.scheme||k,this.authority=t.authority||k,this.path=t.path||k,this.query=t.query||k,this.fragment=t.fragment||k):(this.scheme=C(t,P),this.authority=r||k,this.path=m(this.scheme,a||k),this.query=E||k,this.fragment=S||k,R(this,P))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:E,query:S,fragment:P}=t;return r===void 0?r=this.scheme:r===null&&(r=k),a===void 0?a=this.authority:a===null&&(a=k),E===void 0?E=this.path:E===null&&(E=k),S===void 0?S=this.query:S===null&&(S=k),P===void 0?P=this.fragment:P===null&&(P=k),r===this.scheme&&a===this.authority&&E===this.path&&S===this.query&&P===this.fragment?this:new w(r,a,E,S,P)}static parse(t,r=!1){const a=$.exec(t);return a?new w(a[2]||k,n(a[4]||k),n(a[5]||k),n(a[7]||k),n(a[9]||k),r):new w(k,k,k,k,k)}static file(t){let r=k;if(N.$i&&(t=t.replace(/\\/g,v)),t[0]===v&&t[1]===v){const a=t.indexOf(v,2);a===-1?(r=t.substring(2),t=v):(r=t.substring(2,a),t=t.substring(a)||v)}return new w("file",r,t,k,k)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=f.file(I.$gc.join(c(t,!0),...r)).path:a=I.$hc.join(t.path,...r),t.with({path:a})}toString(t=!1){return g(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=f;function h(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const b=N.$i?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(s,t,r){let a,E=-1;for(let S=0;S<s.length;S++){const P=s.charCodeAt(S);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||t&&P===47||r&&P===91||r&&P===93||r&&P===58)E!==-1&&(a+=encodeURIComponent(s.substring(E,S)),E=-1),a!==void 0&&(a+=s.charAt(S));else{a===void 0&&(a=s.substr(0,S));const y=u[P];y!==void 0?(E!==-1&&(a+=encodeURIComponent(s.substring(E,S)),E=-1),a+=y):E===-1&&(E=S)}}return E!==-1&&(a+=encodeURIComponent(s.substring(E))),a!==void 0?a:s}function l(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=u[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}function g(s,t){const r=t?l:d;let a="",{scheme:E,authority:S,path:P,query:y,fragment:p}=s;if(E&&(a+=E,a+=":"),(S||E==="file")&&(a+=v,a+=v),S){let D=S.indexOf("@");if(D!==-1){const z=S.substr(0,D);S=S.substr(D+1),D=z.lastIndexOf(":"),D===-1?a+=r(z,!1,!1):(a+=r(z.substr(0,D),!1,!1),a+=":",a+=r(z.substr(D+1),!1,!0)),a+="@"}S=S.toLowerCase(),D=S.lastIndexOf(":"),D===-1?a+=r(S,!1,!0):(a+=r(S.substr(0,D),!1,!0),a+=S.substr(D))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const D=P.charCodeAt(1);D>=65&&D<=90&&(P=`/${String.fromCharCode(D+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const D=P.charCodeAt(0);D>=65&&D<=90&&(P=`${String.fromCharCode(D+32)}:${P.substr(2)}`)}a+=r(P,!0,!1)}return y&&(a+="?",a+=r(y,!1,!1)),p&&(a+="#",a+=t?p:d(p,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],he([0,1,8]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=N,e.$Lq=j,e.$Mq=A,e.log=R;function N(m){const k=m;return k&&typeof k.type=="string"&&typeof k.severity=="string"}function j(m){const k=[];let v;try{const $=JSON.parse(m.arguments),f=$[$.length-1];f&&f.__$stack&&($.pop(),v=f.__$stack),k.push(...$)}catch{k.push("Unable to log remote console arguments",m.arguments)}return{args:k,stack:v}}function A(m){if(typeof m!="string")return A(j(m).stack);const k=m;if(k){const v=O(k),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if($&&$.length===4)return{uri:I.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function O(m){if(!m)return m;const k=m.indexOf(`
`);return k===-1?m:m.substring(0,k)}function R(m,k){const{args:v,stack:$}=j(m),f=typeof v[0]=="string"&&v.length===1;let h=O($);h&&(h=`(${h.trim()})`);let b=[];if(typeof v[0]=="string"?h&&f?b=[`%c[${k}] %c${v[0]} %c${h}`,C("blue"),C(""),C("grey")]:b=[`%c[${k}] %c${v[0]}`,C("blue"),C(""),...v.slice(1)]:b=[`%c[${k}]%`,C("blue"),...v],h&&!f&&b.push(h),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,b)}function C(m){return`color: ${m}`}}),define(le[66],he([0,1,15,8]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=j,e.$Vh=A,e.$Wh=R;function j(C){return JSON.stringify(C,O)}function A(C){let m=JSON.parse(C);return m=R(m),m}function O(C,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function R(C,m=0){if(!C||m>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof I.$ze||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let k=0;k<C.length;++k)C[k]=R(C[k],m+1);else for(const k in C)Object.hasOwnProperty.call(C,k)&&(C[k]=R(C[k],m+1))}return C}}),define(le[23],he([0,1,7,5,27,8,14]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=C,e.$xg=m,e.$Bg=v;var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.codeSetting="code-setting"})(R||(e.Schemas=R={}));function C(h,b){return A.URI.isUri(h)?(0,j.$qf)(h.scheme,b):(0,j.$rf)(h,b+":")}function m(h,...b){return b.some(w=>C(h,w))}e.$yg="vscode-tkn",e.$zg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,w){this.f=v(b,w)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,R.vscodeRemoteResource)}set(b,w,u){this.a[b]=w,this.b[b]=u}setConnectionToken(b,w){this.c[b]=w}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(g){return I.$1(g),b}const w=b.authority;let u=this.a[w];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const d=this.b[w],l=this.c[w];let c=`path=${encodeURIComponent(b.path)}`;return typeof l=="string"&&(c+=`&${e.$zg}=${encodeURIComponent(l)}`),A.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${u}:${d}`,path:this.g,query:c})}}e.$Ag=new k;function v(h,b){return O.$hc.join(b??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class ${static{this.a=e.$Gg}asBrowserUri(b){const w=this.b(b,se);return this.uriToBrowserUri(w)}uriToBrowserUri(b){return b.scheme===R.vscodeRemote?e.$Ag.rewrite(b):b.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${$.a}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||$.a,query:null,fragment:null}):b}asFileUri(b){const w=this.b(b,se);return this.uriToFileUri(w)}uriToFileUri(b){return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==$.a?b.authority:null,query:null,fragment:null}):b}b(b,w){return A.URI.isUri(b)?b:A.URI.parse(w.toUrl(b))}}e.$Hg=new $;var f;(function(h){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(b.get("3"));const w="vscode-coi";function u(l){let c;typeof l=="string"?c=new URL(l).searchParams:l instanceof URL?c=l.searchParams:A.URI.isUri(l)&&(c=new URL(l.toString(!0)).searchParams);const g=c?.get(w);if(g)return b.get(g)}h.getHeadersFromQuery=u;function d(l,c,g){if(!globalThis.crossOriginIsolated)return;const i=c&&g?"3":g?"2":"1";l instanceof URLSearchParams?l.set(w,i):l[w]=i}h.addSearchParam=d})(f||(e.COI=f={}))}),define(le[143],he([0,1,124,23,5,8]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=k;class O{constructor($,f,h){this.id=$,this.dependencies=f,this.callback=h}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,f,h)=>{typeof $!="string"&&(h=f,f=$,$=null),(typeof f!="object"||!Array.isArray(f))&&(h=f,f=null),this.c.push(new O($,f,h))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const f=await(this.a?this.i($):this.b?this.h($):this.j($));if(!f)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h($){return new Promise((f,h)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const w=()=>{b.removeEventListener("load",u),b.removeEventListener("error",d)},u=l=>{w(),f(this.c.pop())},d=l=>{w(),h(l)};b.addEventListener("load",u),b.addEventListener("error",d),this.f&&($=this.f.createScriptURL($)),b.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(b)})}i($){return new Promise((f,h)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),f(this.c.pop())}catch(b){h(b)}})}async j($){try{const f=globalThis._VSCODE_NODE_MODULES.fs,h=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,w=A.URI.parse($).fsPath,u=f.readFileSync(w).toString(),d=b.wrap(u.replace(/^#!.*/,""));return new h.Script(d).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const C=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function k(v,$,f){if(I.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[v]&&(v=m[v]);const h=`${v}/${$}`;if(C.has(h))return C.get(h);let b;if(/^\w[\w\d+.-]*:\/\//.test(h))b=h;else{const l=`${f&&!j.$o?N.$Eg:N.$Dg}/${h}`;b=N.$Hg.asBrowserUri(l).toString(!0)}const w=R.INSTANCE.load(b);return C.set(h,w),w}else return await new Promise((h,b)=>{se([v],h,b)})}}),define(le[20],he([0,1,44,23,14,5,27,8]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=C,e.$0g=k,e.$$g=$;function C(f){return(0,R.$xc)(f,!0)}class m{constructor(h){this.a=h}compare(h,b,w=!1){return h===b?0:(0,O.$jf)(this.getComparisonKey(h,w),this.getComparisonKey(b,w))}isEqual(h,b,w=!1){return h===b?!0:!h||!b?!1:this.getComparisonKey(h,w)===this.getComparisonKey(b,w)}getComparisonKey(h,b=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,b,w=!1){if(h.scheme===b.scheme){if(h.scheme===N.Schemas.file)return I.$ng(C(h),C(b),this.a(h))&&h.query===b.query&&(w||h.fragment===b.fragment);if((0,e.$6g)(h.authority,b.authority))return I.$ng(h.path,b.path,this.a(h),"/")&&h.query===b.query&&(w||h.fragment===b.fragment)}return!1}joinPath(h,...b){return R.URI.joinPath(h,...b)}basenameOrAuthority(h){return(0,e.$Xg)(h)||h.authority}basename(h){return j.$hc.basename(h.path)}extname(h){return j.$hc.extname(h.path)}dirname(h){if(h.path.length===0)return h;let b;return h.scheme===N.Schemas.file?b=R.URI.file(j.$nc(C(h))).path:(b=j.$hc.dirname(h.path),h.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),b="/")),h.with({path:b})}normalizePath(h){if(!h.path.length)return h;let b;return h.scheme===N.Schemas.file?b=R.URI.file(j.$ic(C(h))).path:b=j.$hc.normalize(h.path),h.with({path:b})}relativePath(h,b){if(h.scheme!==b.scheme||!(0,e.$6g)(h.authority,b.authority))return;if(h.scheme===N.Schemas.file){const d=j.$mc(C(h),C(b));return A.$i?I.$hg(d):d}let w=h.path||"/";const u=b.path||"/";if(this.a(h)){let d=0;for(const l=Math.min(w.length,u.length);d<l&&!(w.charCodeAt(d)!==u.charCodeAt(d)&&w.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);w=u.substr(0,d)+w.substr(d)}return j.$hc.relative(w,u)}resolvePath(h,b){if(h.scheme===N.Schemas.file){const w=R.URI.file(j.$lc(C(h),b));return h.with({authority:w.authority,path:w.path})}return b=I.$ig(b),h.with({path:j.$hc.resolve(h.path,b)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,b){return h===b||h!==void 0&&b!==void 0&&(0,O.$qf)(h,b)}hasTrailingPathSeparator(h,b=j.sep){if(h.scheme===N.Schemas.file){const w=C(h);return w.length>I.$jg(w).length&&w[w.length-1]===b}else{const w=h.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,b=j.sep){return(0,e.$7g)(h,b)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,b=j.sep){let w=!1;if(h.scheme===N.Schemas.file){const u=C(h);w=u!==void 0&&u.length===I.$jg(u).length&&u[u.length-1]===b}else{b="/";const u=h.path;w=u.length===1&&u.charCodeAt(u.length-1)===47}return!w&&!(0,e.$7g)(h,b)?h.with({path:h.path+"/"}):h}}e.$Pg=m,e.$Qg=new m(()=>!1),e.$Rg=new m(f=>f.scheme===N.Schemas.file?!A.$k:!0),e.$Sg=new m(f=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function k(f,h){const b=[];for(let w=0;w<f.length;w++){const u=h(f[w]);f.some((d,l)=>l===w?!1:(0,e.$Ug)(u,h(d)))||b.push(f[w])}return b}var v;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(b){const w=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,g]=l.split(":");c&&g&&w.set(c,g)});const d=b.path.substring(0,b.path.indexOf(";"));return d&&w.set(f.META_DATA_MIME,d),w}f.parseMetaData=h})(v||(e.DataUri=v={}));function $(f,h,b){if(h){let w=f.path;return w&&w[0]!==j.$hc.sep&&(w=j.$hc.sep+w),f.with({scheme:b,authority:h,path:w})}return f.with({scheme:b})}}),define(le[6],he([0,1,26,7,3,2,20,5,130,53]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=k,e.$ah=v,e.$bh=$,e.$ch=f,e.$dh=h,e.$eh=b,e.$fh=w,e.$gh=u,e.$oh=r,e.$ph=a,e.$qh=E,e.$rh=S,e.$sh=P,e.$Hh=B,e.$Ph=J;function k(_){return!!_&&typeof _.then=="function"}function v(_){const Z=new I.$je,ne=_(Z.token),re=new Promise((ue,de)=>{const $e=Z.token.onCancellationRequested(()=>{$e.dispose(),de(new N.$5)});Promise.resolve(ne).then(ye=>{$e.dispose(),Z.dispose(),ue(ye)},ye=>{$e.dispose(),Z.dispose(),de(ye)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(ue,de){return re.then(ue,de)}catch(ue){return this.then(void 0,ue)}finally(ue){return re.finally(ue)}}}function $(_,Z,ne){return new Promise((re,ue)=>{const de=Z.onCancellationRequested(()=>{de.dispose(),re(ne)});_.then(re,ue).finally(()=>de.dispose())})}function f(_,Z){return new Promise((ne,re)=>{const ue=Z.onCancellationRequested(()=>{ue.dispose(),re(new N.$5)});_.then(ne,re).finally(()=>ue.dispose())})}async function h(_){let Z=-1;const ne=_.map((re,ue)=>re.then(de=>(Z=ue,de)));try{return await Promise.race(ne)}finally{_.forEach((re,ue)=>{ue!==Z&&re.cancel()})}}function b(_,Z,ne){let re;const ue=setTimeout(()=>{re?.(void 0),ne?.()},Z);return Promise.race([_.finally(()=>clearTimeout(ue)),new Promise(de=>re=de)])}function w(_){return new Promise((Z,ne)=>{const re=_();k(re)?re.then(Z,ne):Z(re)})}function u(){let _,Z;return{promise:new Promise((re,ue)=>{_=re,Z=ue}),resolve:_,reject:Z}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ne=()=>{if(this.b=null,this.f)return;const re=this.queue(this.d);return this.d=null,re};this.b=new Promise(re=>{this.a.then(ne,ne).then(re)})}return new Promise((ne,re)=>{this.b.then(ne,re)})}return this.a=Z(),new Promise((ne,re)=>{this.a.then(ue=>{this.a=null,ne(ue)},ue=>{this.a=null,re(ue)})})}dispose(){this.f=!0}}e.$hh=d;class l{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$ih=l;class c{constructor(){this.a=new Map}queue(Z,ne){const ue=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(Z)===ue&&this.a.delete(Z)});return this.a.set(Z,ue),ue}}e.$jh=c;const g=(_,Z)=>{let ne=!0;const re=setTimeout(()=>{ne=!1,Z()},_);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(re),ne=!1}}},i=_=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,_())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class o{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ne=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((ue,de)=>{this.d=ue,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const re=()=>{this.a=null,this.d?.(null)};return this.a=ne===C.$9d?i(re):g(ne,re),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=o;class n{constructor(Z){this.a=new o(Z),this.b=new d}trigger(Z,ne){return this.a.trigger(()=>this.b.queue(Z),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=n;class s{constructor(){this.a=!1,this.b=new Promise((Z,ne)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=s;class t extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$nh=t;function r(_,Z){return Z?new Promise((ne,re)=>{const ue=setTimeout(()=>{de.dispose(),ne()},_),de=Z.onCancellationRequested(()=>{clearTimeout(ue),de.dispose(),re(new N.$5)})}):v(ne=>r(_,ne))}function a(_,Z=0,ne){const re=setTimeout(()=>{_(),ne&&ue.dispose()},Z),ue=(0,A.$Sc)(()=>{clearTimeout(re),ne?.deleteAndLeak(ue)});return ne?.add(ue),ue}function E(_){const Z=[];let ne=0;const re=_.length;function ue(){return ne<re?_[ne++]():null}function de($e){$e!=null&&Z.push($e);const ye=ue();return ye?ye.then(de):Promise.resolve(Z)}return Promise.resolve(null).then(de)}function S(_,Z=re=>!!re,ne=null){let re=0;const ue=_.length,de=()=>{if(re>=ue)return Promise.resolve(ne);const $e=_[re++];return Promise.resolve($e()).then(Se=>Z(Se)?Promise.resolve(Se):de())};return de()}function P(_,Z=re=>!!re,ne=null){if(_.length===0)return Promise.resolve(ne);let re=_.length;const ue=()=>{re=-1;for(const de of _)de.cancel?.()};return new Promise((de,$e)=>{for(const ye of _)ye.then(Se=>{--re>=0&&Z(Se)?(ue(),de(Se)):re===0&&de(ne)}).catch(Se=>{--re>=0&&(ue(),$e(Se))})})}class y{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new j.$_d}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,re)=>{this.g.push({factory:Z,c:ne,e:re}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ne=Z.factory();ne.then(Z.c,Z.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=y;class p extends y{constructor(){super(1)}}e.$uh=p;class D{constructor(){this.a=new ie,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$vh=D;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new ce;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ne=O.$Qg){const re=ne.getComparisonKey(Z);return this.a.get(re)?.size??0}queueFor(Z,ne,re=O.$Qg){const ue=re.getComparisonKey(Z);let de=this.a.get(ue);if(!de){de=new p;const $e=this.f++,ye=j.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set($e,ye),this.a.set(ue,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=z;class F{constructor(Z,ne){this.a=-1,typeof Z=="function"&&typeof ne=="number"&&this.setIfNotSet(Z,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ne)}setIfNotSet(Z,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ne))}}e.$xh=F;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ne,re=globalThis){this.cancel();const ue=re.setInterval(()=>{Z()},ne);this.d=(0,A.$Sc)(()=>{re.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$yh=M;class X{constructor(Z,ne){this.b=-1,this.a=Z,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=X;class G{constructor(Z,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=G;class Y extends X{constructor(Z,ne){super(Z,ne),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Bh=Y;class V extends A.$Uc{constructor(Z,ne){super(),this.g=Z,this.h=ne,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of Z)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(_,Z)=>{(0,R.$B)(()=>{if(ne)return;const re=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$Eh=(_,Z,ne)=>{const re=_.requestIdleCallback(Z,typeof ne=="number"?{timeout:ne}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,_.cancelIdleCallback(re))}}},e.$Dh=_=>(0,e.$Eh)(globalThis,_)}();class K{constructor(Z,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(re){this.l=re}finally{this.g=!0}},this.f=(0,e.$Eh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=K;class W extends K{constructor(Z){super(globalThis,Z)}}e.$Gh=W;async function B(_,Z,ne){let re;for(let ue=0;ue<ne;ue++)try{return await _()}catch(de){re=de,await r(Z)}throw re}class ie{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ne,re){return this.a={taskId:Z,cancel:()=>re?.(),promise:ne},ne.then(()=>this.d(Z),()=>this.d(Z)),ne}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ne,resolve:re,reject:ue}=u();this.b={run:Z,promise:ne,promiseResolve:re,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=ie;class ae{constructor(Z,ne=()=>Date.now()){this.d=Z,this.f=ne,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Jh=ae;var te;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(te||(te={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ne)=>{this.a=Z,this.b=ne})}complete(Z){return new Promise(ne=>{this.a(Z),this.d={outcome:0,value:Z},ne()})}error(Z){return new Promise(ne=>{this.b(Z),this.d={outcome:1,value:Z},ne()})}cancel(){return this.error(new N.$5)}}e.$Kh=ce;var H;(function(_){async function Z(re){let ue;const de=await Promise.all(re.map($e=>$e.then(ye=>ye,ye=>{ue||(ue=ye)})));if(typeof ue<"u")throw ue;return de}_.settled=Z;function ne(re){return new Promise(async(ue,de)=>{try{await re(ue,de)}catch($e){de($e)}})}_.withAsyncBody=ne})(H||(e.Promises=H={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=U;class L{constructor(Z){this.b=Z,this.a=new m.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=L;var T;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(T||(T={}));class q{static fromArray(Z){return new q(ne=>{ne.emitMany(Z)})}static fromPromise(Z){return new q(async ne=>{ne.emitMany(await Z)})}static fromPromises(Z){return new q(async ne=>{await Promise.all(Z.map(async re=>ne.emitOne(await re)))})}static merge(Z){return new q(async ne=>{await Promise.all(Z.map(async re=>{for await(const ue of re)ne.emitOne(ue)}))})}static{this.EMPTY=q.fromArray([])}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new j.$_d,queueMicrotask(async()=>{const ne={emitOne:re=>this.g(re),emitMany:re=>this.h(re),reject:re=>this.k(re)};try{await Promise.resolve(Z(ne)),this.j()}catch(re){this.k(re)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,ne){return new q(async re=>{for await(const ue of Z)re.emitOne(ne(ue))})}map(Z){return q.map(this,Z)}static filter(Z,ne){return new q(async re=>{for await(const ue of Z)ne(ue)&&re.emitOne(ue)})}filter(Z){return q.filter(this,Z)}static coalesce(Z){return q.filter(Z,ne=>!!ne)}coalesce(){return q.coalesce(this)}static async toPromise(Z){const ne=[];for await(const re of Z)ne.push(re);return ne}toPromise(){return q.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.$Nh=q;class x extends q{constructor(Z,ne){super(ne),this.l=Z}cancel(){this.l.cancel()}}e.$Oh=x;function J(_){const Z=new I.$je,ne=_(Z.token);return new x(Z,async re=>{const ue=Z.token.onCancellationRequested(()=>{ue.dispose(),Z.dispose(),re.reject(new N.$5)});try{for await(const de of ne){if(Z.token.isCancellationRequested)return;re.emitOne(de)}ue.dispose(),Z.dispose()}catch(de){ue.dispose(),Z.dispose(),re.reject(de)}})}class ee{constructor(){this.a=new ce,this.b=new q(re=>{if(Z){re.reject(Z);return}return ne&&re.emitMany(ne),this.d=ue=>re.reject(ue),this.f=ue=>re.emitOne(ue),this.a.p});let Z,ne;this.f=re=>{ne||(ne=[]),ne.push(re)},this.d=re=>{Z||(Z=re)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$Qh=ee}),define(le[90],he([0,1,17,6,44,35,14,5,27]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$ck=m,e.$fk=h,e.$gk=p,e.$hk=D,e.$ik=z,e.$jk=F,e.$kk=M,e.$lk=V;function m(){return Object.create(null)}e.$dk="**",e.$ek="/";const k="[/\\\\]",v="[^/\\\\]",$=/\//g;function f(K,W){switch(K){case 0:return"";case 1:return`${v}*?`;default:return`(?:${k}|${v}+${k}${W?`|${k}${v}+`:""})*?`}}function h(K,W){if(!K)return[];const B=[];let ie=!1,ae=!1,te="";for(const ce of K){switch(ce){case W:if(!ie&&!ae){B.push(te),te="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}te+=ce}return te&&B.push(te),B}function b(K){if(!K)return"";let W="";const B=h(K,e.$ek);if(B.every(ie=>ie===e.$dk))W=".*";else{let ie=!1;B.forEach((ae,te)=>{if(ae===e.$dk){if(ie)return;W+=f(2,te===B.length-1)}else{let ce=!1,H="",U=!1,L="";for(const T of ae){if(T!=="}"&&ce){H+=T;continue}if(U&&(T!=="]"||!L)){let q;T==="-"?q=T:(T==="^"||T==="!")&&!L?q="^":T===e.$ek?q="":q=(0,C.$5e)(T),L+=q;continue}switch(T){case"{":ce=!0;continue;case"[":U=!0;continue;case"}":{const x=`(?:${h(H,",").map(J=>b(J)).join("|")})`;W+=x,ce=!1,H="";break}case"]":{W+="["+L+"]",U=!1,L="";break}case"?":W+=v;continue;case"*":W+=f(1);continue;default:W+=(0,C.$5e)(T)}}te<B.length-1&&(B[te+1]!==e.$dk||te+2<B.length)&&(W+=k)}ie=ae===e.$dk})}return W}const w=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$Ec(1e4),o=function(){return!1},n=function(){return null};function s(K,W){if(!K)return n;let B;typeof K!="string"?B=K.pattern:B=K,B=B.trim();const ie=`${B}_${!!W.trimForExclusions}`;let ae=i.get(ie);if(ae)return t(ae,K);let te;return w.test(B)?ae=a(B.substr(4),B):(te=u.exec(r(B,W)))?ae=E(te[1],B):(W.trimForExclusions?l:d).test(B)?ae=S(B,W):(te=c.exec(r(B,W)))?ae=P(te[1].substr(1),B,!0):(te=g.exec(r(B,W)))?ae=P(te[1],B,!1):ae=y(B),i.set(ie,ae),t(ae,K)}function t(K,W){if(typeof W=="string")return K;const B=function(ie,ae){return(0,j.$ng)(ie,W.base,!R.$k)?K((0,C.$0e)(ie.substr(W.base.length),O.sep),ae):null};return B.allBasenames=K.allBasenames,B.allPaths=K.allPaths,B.basenames=K.basenames,B.patterns=K.patterns,B}function r(K,W){return W.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,W){return function(B,ie){return typeof B=="string"&&B.endsWith(K)?W:null}}function E(K,W){const B=`/${K}`,ie=`\\${K}`,ae=function(ce,H){return typeof ce!="string"?null:H?H===K?W:null:ce===K||ce.endsWith(B)||ce.endsWith(ie)?W:null},te=[K];return ae.basenames=te,ae.patterns=[W],ae.allBasenames=te,ae}function S(K,W){const B=Y(K.slice(1,-1).split(",").map(H=>s(H,W)).filter(H=>H!==n),K),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const ae=function(H,U){for(let L=0,T=B.length;L<T;L++)if(B[L](H,U))return K;return null},te=B.find(H=>!!H.allBasenames);te&&(ae.allBasenames=te.allBasenames);const ce=B.reduce((H,U)=>U.allPaths?H.concat(U.allPaths):H,[]);return ce.length&&(ae.allPaths=ce),ae}function P(K,W,B){const ie=O.sep===O.$hc.sep,ae=ie?K:K.replace($,O.sep),te=O.sep+ae,ce=O.$hc.sep+K;let H;return B?H=function(U,L){return typeof U=="string"&&(U===ae||U.endsWith(te)||!ie&&(U===K||U.endsWith(ce)))?W:null}:H=function(U,L){return typeof U=="string"&&(U===ae||!ie&&U===K)?W:null},H.allPaths=[(B?"*/":"./")+K],H}function y(K){try{const W=new RegExp(`^${b(K)}$`);return function(B){return W.lastIndex=0,typeof B=="string"&&W.test(B)?K:null}}catch{return n}}function p(K,W,B){return!K||typeof W!="string"?!1:D(K)(W,void 0,B)}function D(K,W={}){if(!K)return o;if(typeof K=="string"||z(K)){const B=s(K,W);if(B===n)return o;const ie=function(ae,te){return!!B(ae,te)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return X(K,W)}function z(K){const W=K;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function F(K){return K.allBasenames||[]}function M(K){return K.allPaths||[]}function X(K,W){const B=Y(Object.getOwnPropertyNames(K).map(H=>G(H,K[H],W)).filter(H=>H!==n)),ie=B.length;if(!ie)return n;if(!B.some(H=>!!H.requiresSiblings)){if(ie===1)return B[0];const H=function(T,q){let x;for(let J=0,ee=B.length;J<ee;J++){const _=B[J](T,q);if(typeof _=="string")return _;(0,N.$_g)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const J of x){const ee=await J;if(typeof ee=="string")return ee}return null})():null},U=B.find(T=>!!T.allBasenames);U&&(H.allBasenames=U.allBasenames);const L=B.reduce((T,q)=>q.allPaths?T.concat(q.allPaths):T,[]);return L.length&&(H.allPaths=L),H}const ae=function(H,U,L){let T,q;for(let x=0,J=B.length;x<J;x++){const ee=B[x];ee.requiresSiblings&&L&&(U||(U=(0,O.$oc)(H)),T||(T=U.substr(0,U.length-(0,O.$pc)(H).length)));const _=ee(H,U,T,L);if(typeof _=="string")return _;(0,N.$_g)(_)&&(q||(q=[]),q.push(_))}return q?(async()=>{for(const x of q){const J=await x;if(typeof J=="string")return J}return null})():null},te=B.find(H=>!!H.allBasenames);te&&(ae.allBasenames=te.allBasenames);const ce=B.reduce((H,U)=>U.allPaths?H.concat(U.allPaths):H,[]);return ce.length&&(ae.allPaths=ce),ae}function G(K,W,B){if(W===!1)return n;const ie=s(K,B);if(ie===n)return n;if(typeof W=="boolean")return ie;if(W){const ae=W.when;if(typeof ae=="string"){const te=(ce,H,U,L)=>{if(!L||!ie(ce,H))return null;const T=ae.replace("$(basename)",()=>U),q=L(T);return(0,N.$_g)(q)?q.then(x=>x?K:null):q?K:null};return te.requiresSiblings=!0,te}}return ie}function Y(K,W){const B=K.filter(H=>!!H.basenames);if(B.length<2)return K;const ie=B.reduce((H,U)=>{const L=U.basenames;return L?H.concat(L):H},[]);let ae;if(W){ae=[];for(let H=0,U=ie.length;H<U;H++)ae.push(W)}else ae=B.reduce((H,U)=>{const L=U.patterns;return L?H.concat(L):H},[]);const te=function(H,U){if(typeof H!="string")return null;if(!U){let T;for(T=H.length;T>0;T--){const q=H.charCodeAt(T-1);if(q===47||q===92)break}U=H.substr(T)}const L=ie.indexOf(U);return L!==-1?ae[L]:null};te.basenames=ie,te.patterns=ae,te.allBasenames=ie;const ce=K.filter(H=>!H.basenames);return ce.push(te),ce}function V(K,W){return(0,I.$ub)(K,W,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(le[91],he([0,1,15,8]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0,e.$rn=R,e.$sn=m,e.$tn=k;function j(v){return v.toJSON()}class A{constructor($){this.a=$}transformIncoming($){const f=this.a.transformIncoming($);return f===$?$:j(N.URI.from(f))}transformOutgoing($){const f=this.a.transformOutgoing($);return f===$?$:j(N.URI.from(f))}transformOutgoingURI($){const f=this.a.transformOutgoing($);return f===$?$:N.URI.from(f)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$pn=A,e.$qn=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function O(v,$,f){if(!v||f>200)return null;if(typeof v=="object"){if(v instanceof N.URI)return $.transformOutgoing(v);for(const h in v)if(Object.hasOwnProperty.call(v,h)){const b=O(v[h],$,f+1);b!==null&&(v[h]=b)}}return null}function R(v,$){const f=O(v,$,0);return f===null?v:f}function C(v,$,f,h){if(!v||h>200)return null;if(typeof v=="object"){if(v.$mid===1)return f?N.URI.revive($.transformIncoming(v)):$.transformIncoming(v);if(v instanceof I.$ze)return null;for(const b in v)if(Object.hasOwnProperty.call(v,b)){const w=C(v[b],$,f,h+1);w!==null&&(v[b]=w)}}return null}function m(v,$){const f=C(v,$,!1,0);return f===null?v:f}function k(v,$){const f=C(v,$,!0,0);return f===null?v:f}}),define(le[144],he([0,1,37,51,32,131,5]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$wn=C,e.$xn=v,e.$vn=new class{c($){return this.a||(this.a=N.$ti.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,f=0;const h=(0,I.networkInterfaces)();for(const b in h){const w=h[b];if(w)for(const{mac:u,internal:d}of w)d||(f+=1,this.c(u.toUpperCase())&&($+=1))}this.b=f>0?$/f:0}return this.b}};let R;async function C($){return R||(R=(async()=>await m($)||j.$Jg())()),R}async function m($){try{const f=await new Promise((b,w)=>{se(["crypto"],b,w)}),h=(0,A.$un)();return f.createHash("sha256").update(h,"utf8").digest("hex")}catch(f){$(f);return}}const k="Software\\Microsoft\\SQMClient";async function v($){if(O.$i){const f=await new Promise((h,b)=>{se(["@vscode/windows-registry"],h,b)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",k,"MachineId")||""}catch(h){return $(h),""}}return""}}),define(le[145],he([0,1,40,146,14,36]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eW=k,e.$fW=v;const O="XDG_SESSION_TYPE",R="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var m;(function($){$.Wayland="wayland",$.XWayland="xwayland",$.X11="x11",$.Unknown="unknown"})(m||(m={}));async function k($){const f=A.env[O];if(f)return f==="wayland"||f==="x11"?f:"unknown";if(A.env[R]){const b=A.env[C];if(b){const w=(0,j.$kc)(b,"wayland-0");try{return await(0,N.access)(w,I.constants.R_OK),"wayland"}catch(u){return $(u),"unknown"}}else return"unknown"}else return"x11"}function v($,f){if(f)switch(f){case"auto":return $;case"x11":return $==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return $==="wayland"?"xwayland":"x11"}}),define(le[147],he([0,1,40,146,274,5]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kg=O;async function O(R){if(A.$j||A.$i)return;let C;for(const m of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await(0,N.open)(m,I.constants.R_OK);break}catch{}if(!C){R("Unable to retrieve release information from known identifier paths.");return}try{const m=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),k={id:"unknown"};for await(const v of(0,j.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const $=v.split("=")[0].toUpperCase().trim();if(m.has($)){const f=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();$==="ID"||$==="DISTRIB_ID"?k.id=f:$==="ID_LIKE"?k.id_like=f:($==="VERSION_ID"||$==="DISTRIB_RELEASE")&&(k.version_id=f)}}return k}catch(m){R(m)}}}),define(le[31],he([0,1,40,37,275,6,44,87,14,5,20,8]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=l,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=E;var $;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function f(G,Y=$.UNLINK,V){if((0,O.$qg)(G))throw new Error("rimraf - will refuse to recursively delete root");return Y===$.UNLINK?b(G):h(G,V)}async function h(G,Y=(0,O.$vg)((0,N.tmpdir)())){try{try{await I.promises.rename(G,Y)}catch(V){return V.code==="ENOENT"?void 0:b(G)}b(Y).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function b(G){return(0,j.promisify)(I.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function w(G){if((0,O.$qg)(G))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function u(G,Y){return c(await(Y?d(G):(0,j.promisify)(I.readdir)(G)))}async function d(G){try{return await(0,j.promisify)(I.readdir)(G,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Y=[],V=await u(G);for(const K of V){let W=!1,B=!1,ie=!1;try{const ae=await e.Promises.lstat((0,C.$kc)(G,K));W=ae.isFile(),B=ae.isDirectory(),ie=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}Y.push({name:K,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Y}function l(G){return c(I.readdirSync(G))}function c(G){return G.map(Y=>typeof Y=="string"?m.$j?(0,R.$5l)(Y):Y:(Y.name=m.$j?(0,R.$5l)(Y.name):Y.name,Y))}async function g(G){const Y=await u(G),V=[];for(const K of Y)await o.existsDirectory((0,C.$kc)(G,K))&&V.push(K);return V}function i(G,Y=1e3){return new Promise(V=>{let K=!1;const W=setInterval(()=>{K||(K=!0,I.access(G,B=>{K=!1,B&&(clearInterval(W),V(void 0))}))},Y)})}var o;(function(G){async function Y(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(m.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ae}throw ie}}G.stat=Y;async function V(W){try{const{stat:B,symbolicLink:ie}=await G.stat(W);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}G.existsFile=V;async function K(W){try{const{stat:B,symbolicLink:ie}=await G.stat(W);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}G.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const n=new A.$wh;function s(G,Y,V){return n.queueFor(v.URI.file(G),()=>{const K=S(V);return new Promise((W,B)=>a(G,Y,K,ie=>ie?B(ie):W()))},k.$Rg)}let t=!0;function r(G){t=G}function a(G,Y,V,K){if(!t)return I.writeFile(G,Y,{mode:V.mode,flag:V.flag},K);I.open(G,V.flag,V.mode,(W,B)=>{if(W)return K(W);I.writeFile(B,Y,ie=>{if(ie)return I.close(B,()=>K(ie));I.fdatasync(B,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),r(!1)),I.close(B,te=>K(te))))})})}function E(G,Y,V){const K=S(V);if(!t)return I.writeFileSync(G,Y,{mode:K.mode,flag:K.flag});const W=I.openSync(G,K.flag,K.mode);try{I.writeFileSync(W,Y);try{I.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{I.closeSync(W)}}function S(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function P(G,Y,V=6e4){if(G!==Y)try{m.$i&&typeof V=="number"?await y(G,Y,Date.now(),V):await(0,j.promisify)(I.rename)(G,Y)}catch(K){if(G.toLowerCase()!==Y.toLowerCase()&&K.code==="EXDEV"||G.endsWith("."))await p(G,Y,{preserveSymlinks:!1}),await f(G,$.MOVE);else throw K}}async function y(G,Y,V,K,W=0){try{return await(0,j.promisify)(I.rename)(G,Y)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-V>=K)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${B}`),B;if(W===0){let ie=!1;try{const{stat:ae}=await o.stat(Y);ae.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,A.$oh)(Math.min(100,W*10)),y(G,Y,V,K,W+1)}}async function p(G,Y,V){return z(G,Y,{root:{source:G,target:Y},options:V,handledSourcePaths:new Set})}const D=511;async function z(G,Y,V){if(V.handledSourcePaths.has(G))return;V.handledSourcePaths.add(G);const{stat:K,symbolicLink:W}=await o.stat(G);if(W){if(V.options.preserveSymlinks)try{return await X(G,Y,V)}catch{}if(W.dangling)return}return K.isDirectory()?F(G,Y,K.mode&D,V):M(G,Y,K.mode&D)}async function F(G,Y,V,K){await e.Promises.mkdir(Y,{recursive:!0,mode:V});const W=await u(G);for(const B of W)await z((0,C.$kc)(G,B),(0,C.$kc)(Y,B),K)}async function M(G,Y,V){await e.Promises.copyFile(G,Y),await e.Promises.chmod(Y,V)}async function X(G,Y,V){let K=await e.Promises.readlink(G);(0,O.$ng)(K,V.root.source,!m.$k)&&(K=(0,C.$kc)(V.root.target,K.substr(V.root.source.length+1))),await e.Promises.symlink(K,Y)}e.Promises=new class{get access(){return(0,j.promisify)(I.access)}get stat(){return(0,j.promisify)(I.stat)}get lstat(){return(0,j.promisify)(I.lstat)}get utimes(){return(0,j.promisify)(I.utimes)}get read(){return(G,Y,V,K,W)=>new Promise((B,ie)=>{I.read(G,Y,V,K,W,(ae,te,ce)=>ae?ie(ae):B({bytesRead:te,buffer:ce}))})}get readFile(){return(0,j.promisify)(I.readFile)}get write(){return(G,Y,V,K,W)=>new Promise((B,ie)=>{I.write(G,Y,V,K,W,(ae,te,ce)=>ae?ie(ae):B({bytesWritten:te,buffer:ce}))})}get appendFile(){return(0,j.promisify)(I.appendFile)}get fdatasync(){return(0,j.promisify)(I.fdatasync)}get truncate(){return(0,j.promisify)(I.truncate)}get copyFile(){return(0,j.promisify)(I.copyFile)}get open(){return(0,j.promisify)(I.open)}get close(){return(0,j.promisify)(I.close)}get symlink(){return(0,j.promisify)(I.symlink)}get readlink(){return(0,j.promisify)(I.readlink)}get chmod(){return(0,j.promisify)(I.chmod)}get mkdir(){return(0,j.promisify)(I.mkdir)}get unlink(){return(0,j.promisify)(I.unlink)}get rmdir(){return(0,j.promisify)(I.rmdir)}get realpath(){return(0,j.promisify)(I.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return g}get writeFile(){return s}get rm(){return f}get rename(){return P}get copy(){return p}}}),define(le[148],he([0,1,40,14,5,27,31]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=R,e.$Tq=C,e.$Uq=m,e.$Vq=k;function R($){if(j.$k)return $;const f=(0,N.$nc)($);if($===f)return $;const h=((0,N.$oc)($)||$).toLowerCase();try{const w=(0,O.readdirSync)(f).filter(u=>u.toLowerCase()===h);if(w.length===1){const u=R(f);if(u)return(0,N.$kc)(u,w[0])}else if(w.length>1){const u=w.indexOf(h);if(u>=0){const d=R(f);if(d)return(0,N.$kc)(d,w[u])}}}catch{}return null}async function C($,f){if(j.$k)return $;const h=(0,N.$nc)($);if($===h)return $;const b=((0,N.$oc)($)||$).toLowerCase();try{if(f?.isCancellationRequested)return null;const u=(await O.Promises.readdir(h)).filter(d=>d.toLowerCase()===b);if(u.length===1){const d=await C(h,f);if(d)return(0,N.$kc)(d,u[0])}else if(u.length>1){const d=u.indexOf(b);if(d>=0){const l=await C(h,f);if(l)return(0,N.$kc)(l,u[d])}}}catch{}return null}async function m($){try{return await O.Promises.realpath($)}catch{const h=v($);return await O.Promises.access(h,I.constants.R_OK),h}}function k($){try{return I.realpathSync($)}catch{const h=v($);return I.accessSync(h,I.constants.R_OK),h}}function v($){return(0,A.$$e)((0,N.$ic)($),N.sep)}}),define(le[149],he([0,1,14,5,36,89,13,31]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$fm=C,e.$gm=m,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function C(v=j.env){return v.comspec||"cmd.exe"}function m(v){let $=[],f=!1;const h=function(b){if(f){$.push(b);return}(!v.send(b,u=>{if(u&&console.error(u),f=!1,$.length>0){const d=$.slice(0);$=[],d.forEach(l=>h(l))}})||N.$i)&&(f=!0)};return{send:h}}var k;(function(v){async function $(f,h,b){if(I.$jc(f))return f;if(h===void 0&&(h=j.cwd()),I.$nc(f)!=="."||(b===void 0&&O.$1f(j.env.PATH)&&(b=j.env.PATH.split(I.$uc)),b===void 0||b.length===0))return I.$kc(h,f);async function u(d){if(await R.Promises.exists(d)){let l;try{l=await R.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&(l=await R.Promises.lstat(d))}return l?!l.isDirectory():!1}return!1}for(const d of b){let l;if(I.$jc(d)?l=I.$kc(d,f):l=I.$kc(h,d,f),await u(l))return l;let c=l+".com";if(await u(c)||(c=l+".exe",await u(c)))return c}return I.$kc(h,f)}v.findExecutable=$})(k||(e.win32=k={}))}),define(le[150],he([0,1,67,23]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=j;function j(O){return new Promise((R,C)=>{let m;const k=new Map;function v(f,h,b,w,u){const d=k.get(h);if(f===O||d){const l={name:$(b),cmd:b,pid:f,ppid:h,load:w,mem:u};k.set(f,l),f===O&&(m=l),d&&(d.children||(d.children=[]),d.children.push(l),d.children.length>1&&(d.children=d.children.sort((c,g)=>c.pid-g.pid)))}}function $(f){const h=/--utility-sub-type=network/i,b=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(b.exec(f))return"electron-crash-reporter";if(w.exec(f))return"winpty-agent";if(u.exec(f))return"conpty-agent";let l=d.exec(f);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?h.exec(f)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const c=/[a-zA-Z-]+\.js/g;let g="";do l=c.exec(f),l&&(g+=l+" ");while(l);return g&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${g})`:f}if(process.platform==="win32"){const f=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,b)=>{se(["@vscode/windows-process-tree"],h,b)}).then(h=>{h.getProcessList(O,b=>{if(!b){C(new Error(`Root process ${O} not found`));return}h.getProcessCpuUsage(b,w=>{const u=new Map;w.forEach(d=>{const l=f(d.commandLine||"");u.set(d.pid,{name:$(l),cmd:l,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),m=u.get(O),m?(u.forEach(d=>{const l=u.get(d.ppid);l&&(l.children||(l.children=[]),l.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((l,c)=>l.pid-c.pid))}),R(m)):C(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let f=function(){let h=[m];const b=[];for(;h.length;){const u=h.shift();u&&(b.push(u.pid),u.children&&(h=h.concat(u.children)))}let w=JSON.stringify(N.$Hg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+b.join(" "),(0,I.exec)(w,{},(u,d,l)=>{if(u||l)C(u||new Error(l.toString()));else{const c=d.toString().split(`
`);for(let g=0;g<b.length;g++){const i=k.get(b[g]);i.load=parseFloat(c[g])}if(!m){C(new Error(`Root process ${O} not found`));return}R(m)}})};(0,I.exec)("which ps",{},(h,b,w)=>{if(h||w)if(process.platform!=="linux")C(h||new Error(w.toString()));else{const u=JSON.stringify(N.$Hg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(d,l,c)=>{d||c?C(d||new Error(c.toString())):(A(l,v),f())})}else{const u=b.toString().trim();(0,I.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,g)=>{l||g&&!g.includes("screen size is bogus")?C(l||new Error(g.toString())):(A(c,v),process.platform==="linux"?f():m?R(m):C(new Error(`Root process ${O} not found`)))})}})}})}function A(O,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=O.toString().split(`
`);for(const k of m){const v=C.exec(k.trim());v&&v.length===6&&R(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}});var ve=this&&this.__decorate||function(se,e,I,N){var j=arguments.length,A=j<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,I,N);else for(var R=se.length-1;R>=0;R--)(O=se[R])&&(A=(j<3?O(A):j>3?O(e,I,A):O(e,I))||A);return j>3&&A&&Object.defineProperty(e,I,A),A};define(le[41],he([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(se,e,I,N,j,A,O,R,C,m,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.ProxyChannel=e.$8h=e.$5h=e.$4h=e.$3h=e.RequestInitiator=e.$2h=e.$Yh=e.$Xh=void 0,e.$Zh=r,e.$1h=a,e.$6h=D,e.$7h=z;var f;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(f||(f={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(b||(b={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));function d(W){let B=0;for(let ie=0;;ie+=7){const ae=W.read(1);if(B|=(ae.buffer[0]&127)<<ie,!(ae.buffer[0]&128))return B}}const l=n(0);function c(W,B){if(B===0){W.write(l);return}let ie=0;for(let te=B;te!==0;te=te>>>7)ie++;const ae=j.$ze.alloc(ie);for(let te=0;B!==0;te++)ae.buffer[te]=B&127,B=B>>>7,B>0&&(ae.buffer[te]|=128);W.write(ae)}class g{constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$Xh=g;class i{constructor(){this.a=[]}get buffer(){return j.$ze.concat(this.a)}write(B){this.a.push(B)}}e.$Yh=i;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function n(W){const B=j.$ze.alloc(1);return B.writeUInt8(W,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(W,B){if(typeof B>"u")W.write(s.Undefined);else if(typeof B=="string"){const ie=j.$ze.fromString(B);W.write(s.String),c(W,ie.byteLength),W.write(ie)}else if(t&&Buffer.isBuffer(B)){const ie=j.$ze.wrap(B);W.write(s.Buffer),c(W,ie.byteLength),W.write(ie)}else if(B instanceof j.$ze)W.write(s.VSBuffer),c(W,B.byteLength),W.write(B);else if(Array.isArray(B)){W.write(s.Array),c(W,B.length);for(const ie of B)r(W,ie)}else if(typeof B=="number"&&(B|0)===B)W.write(s.Uint),c(W,B);else{const ie=j.$ze.fromString(JSON.stringify(B));W.write(s.Object),c(W,ie.byteLength),W.write(ie)}}function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(d(W)).toString();case o.Buffer:return W.read(d(W)).buffer;case o.VSBuffer:return W.read(d(W));case o.Array:{const ie=d(W),ae=[];for(let te=0;te<ie;te++)ae.push(a(W));return ae}case o.Object:return JSON.parse(W.read(d(W)).toString());case o.Int:return d(W)}}class E{constructor(B,ie,ae=null,te=1e3){this.h=B,this.j=ie,this.k=ae,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,w(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,w(B.type),B.data);return}}}o(B,ie=void 0){const ae=new i;return r(ae,B),r(ae,ie),this.p(ae.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new g(B),ae=a(ie),te=a(ie),ce=ae[0];switch(ce){case 100:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}: ${ae[2]}.${ae[3]}`,te),this.s({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:te});case 102:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}: ${ae[2]}.${ae[3]}`,te),this.t({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:te});case 101:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}`),this.u({type:ce,id:ae[1]});case 103:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}`),this.u({type:ce,id:ae[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const ae=new A.$je;let te;try{te=ie.call(this.j,B.name,B.arg,ae.token)}catch(U){te=Promise.reject(U)}const ce=B.id;te.then(U=>{this.m({id:ce,data:U,type:201})},U=>{U instanceof Error?this.m({id:ce,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:ce,data:U,type:203})}).finally(()=>{H.dispose(),this.d.delete(B.id)});const H=(0,m.$Sc)(()=>ae.cancel());this.d.set(B.id,H)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const ae=B.id,ce=ie.listen(this.j,B.name,B.arg)(H=>this.m({id:ae,data:H,type:204}));this.d.set(B.id,ce)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const ae=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:ae})}w(B){const ie=this.g.get(B);if(ie){for(const ae of ie)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$Pc)(this.d.values()),this.d.clear()}}e.$2h=E;var S;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class P{constructor(B,ie=null){this.l=B,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$_d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=ie}getChannel(B){const ie=this;return{call(ae,te,ce){return ie.a?Promise.reject(new R.$5):ie.m(B,ae,te,ce)},listen(ae,te){return ie.a?C.Event.None:ie.o(B,ae,te)}}}m(B,ie,ae,te=A.CancellationToken.None){const ce=this.g++,U={id:ce,type:100,channelName:B,name:ie,arg:ae};if(te.isCancellationRequested)return Promise.reject(new R.$5);let L;return new Promise((q,x)=>{if(te.isCancellationRequested)return x(new R.$5);const J=()=>{const ne=re=>{switch(re.type){case 201:this.f.delete(ce),q(re.data);break;case 202:{this.f.delete(ce);const ue=new Error(re.data.message);ue.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,ue.name=re.data.name,x(ue);break}case 203:this.f.delete(ce),x(re.data);break}};this.f.set(ce,ne),this.p(U)};let ee=null;this.b===u.Idle?J():(ee=(0,N.$ah)(ne=>this.u()),ee.then(()=>{ee=null,J()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:ce,type:101}),x(new R.$5)},Z=te.onCancellationRequested(_);L=(0,m.$Rc)((0,m.$Sc)(_),Z),this.d.add(L)}).finally(()=>{L.dispose(),this.d.delete(L)})}o(B,ie,ae){const te=this.g++,H={id:te,type:102,channelName:B,name:ie,arg:ae};let U=null;const L=new C.$_d({onWillAddFirstListener:()=>{U=(0,N.$ah)(q=>this.u()),U.then(()=>{U=null,this.d.add(L),this.p(H)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(L),this.p({id:te,type:103}))}}),T=q=>L.fire(q.data);return this.f.set(te,T),L.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,h(B.type));return}}}q(B,ie=void 0){const ae=new i;return r(ae,B),r(ae,ie),this.r(ae.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new g(B),ae=a(ie),te=a(ie),ce=ae[0];switch(ce){case 200:return this.j?.logIncoming(B.byteLength,0,0,w(ce)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,ae[1],0,w(ce),te),this.t({type:ae[0],id:ae[1],data:te})}}t(B){if(B.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$Pc)(this.d.values()),this.d.clear()}}e.$3h=P,ve([O.$Rh],P.prototype,"onDidInitializePromise",null);class y{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,ae){this.a=new Map,this.f=new Set,this.g=new C.$_d,this.onDidAddConnection=this.g.event,this.h=new C.$_d,this.onDidRemoveConnection=this.h.event,this.j=new m.$Tc,this.j.add(B(({protocol:te,onDidClientDisconnect:ce})=>{const H=C.Event.once(te.onMessage);this.j.add(H(U=>{const L=new g(U),T=a(L),q=new E(te,T,ie,ae),x=new P(te,ie);this.a.forEach((ee,_)=>q.registerChannel(_,ee));const J={channelServer:q,channelClient:x,ctx:T};this.f.add(J),this.g.fire(J),this.j.add(ce(()=>{q.dispose(),x.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(B,ie){const ae=this;return{call(te,ce,H){let U;if((0,$.$cg)(ie)){const T=(0,I.$4b)(ae.connections.filter(ie));U=T?Promise.resolve(T):C.Event.toPromise(C.Event.filter(ae.onDidAddConnection,ie))}else U=ie.routeCall(ae,te,ce);const L=U.then(T=>T.channelClient.getChannel(B));return D(L).call(te,ce,H)},listen(te,ce){if((0,$.$cg)(ie))return ae.k(B,ie,te,ce);const H=ie.routeEvent(ae,te,ce).then(U=>U.channelClient.getChannel(B));return D(H).listen(te,ce)}}}k(B,ie,ae,te){const ce=this;let H;const U=new C.$_d({onWillAddFirstListener:()=>{H=new m.$Tc;const L=new C.$fe,T=new Map,q=J=>{const _=J.channelClient.getChannel(B).listen(ae,te),Z=L.add(_);T.set(J,Z)},x=J=>{const ee=T.get(J);ee&&(ee.dispose(),T.delete(J))};ce.connections.filter(ie).forEach(q),C.Event.filter(ce.onDidAddConnection,ie)(q,void 0,H),ce.onDidRemoveConnection(x,void 0,H),L.event(U.fire,U,H),H.add(L)},onDidRemoveLastListener:()=>{H?.dispose(),H=void 0}});return U.event}registerChannel(B,ie){this.a.set(B,ie);for(const ae of this.f)ae.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$4h=y;class p{constructor(B,ie,ae=null){const te=new i;r(te,ie),B.send(te.buffer),this.a=new P(B,ae),this.d=new E(B,ie,ae)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5h=p;function D(W){return{call(B,ie,ae){return W.then(te=>te.call(B,ie,ae))},listen(B,ie){const ae=new C.$ie;return W.then(te=>ae.input=te.listen(B,ie)),ae.event}}}function z(W){let B=!1;return{call(ie,ae,te){return B?W.call(ie,ae,te):(0,N.$oh)(0).then(()=>B=!0).then(()=>W.call(ie,ae,te))},listen(ie,ae){if(B)return W.listen(ie,ae);const te=new C.$ie;return(0,N.$oh)(0).then(()=>B=!0).then(()=>te.input=W.listen(ie,ae)),te.event}}}class F{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await C.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$8h=F;var M;(function(W){function B(ce,H,U){const L=ce,T=U&&U.disableMarshalling,q=new Map;for(const x in L)ae(x)&&q.set(x,C.Event.buffer(L[x],!0,void 0,H));return new class{listen(x,J,ee){const _=q.get(J);if(_)return _;const Z=L[J];if(typeof Z=="function"){if(te(J))return Z.call(L,ee);if(ae(J))return q.set(J,C.Event.buffer(L[J],!0,void 0,H)),q.get(J)}throw new R.$bb(`Event not found: ${J}`)}call(x,J,ee){const _=L[J];if(typeof _=="function"){if(!T&&Array.isArray(ee))for(let ne=0;ne<ee.length;ne++)ee[ne]=(0,k.$Wh)(ee[ne]);let Z=_.apply(L,ee);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new R.$bb(`Method not found: ${J}`)}}}W.fromService=B;function ie(ce,H){const U=H&&H.disableMarshalling;return new Proxy({},{get(L,T){if(typeof T=="string")return H?.properties?.has(T)?H.properties.get(T):te(T)?function(q){return ce.listen(T,q)}:ae(T)?ce.listen(T):async function(...q){let x;H&&!(0,$.$0f)(H.context)?x=[H.context,...q]:x=q;const J=await ce.call(T,x);return U?J:(0,k.$Wh)(J)};throw new R.$bb(`Property not found: ${String(T)}`)}})}W.toService=ie;function ae(ce){return ce[0]==="o"&&ce[1]==="n"&&v.$pf(ce.charCodeAt(2))}function te(ce){return/^onDynamic/.test(ce)&&v.$pf(ce.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function Y(W){return Array.isArray(W)?W.map(G):G(W)}function V(W,B,ie,ae,te,ce,H){H=Y(H);const U=X[te],L=U[ae%U.length];let T=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(ce)?(T=T.concat(H),T.push(")")):T.push(H),console.log.apply(console,T)}class K{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,ae,te,ce){this.b+=B,V(this.d,this.b,B,ie,ae,te,ce)}logIncoming(B,ie,ae,te,ce){this.a+=B,V(this.f,this.a,B,ie,ae,te,ce)}}e.$9h=K}),define(le[68],he([0,1,15,3,2,41]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.ProtocolConstants=e.$0h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(S,P){if(!t.has(S)){const y=String(++r);t.set(S,y)}return t.get(S)}function E(S,P,y,p){if(!s.enableDiagnostics)return;const D=a(S,P);if(p instanceof I.$ze||p instanceof Uint8Array||p instanceof ArrayBuffer||ArrayBuffer.isView(p)){const z=I.$ze.alloc(p.byteLength);z.set(p),s.records.push({timestamp:Date.now(),id:D,label:P,type:y,buff:z})}else s.records.push({timestamp:Date.now(),id:D,label:P,type:y,data:p})}s.traceSocketEvent=E})(R||(e.SocketDiagnostics=R={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let m=null;function k(){return m||(m=I.$ze.alloc(0)),m}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return k();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const P=this.a[0];return r&&(this.a.shift(),this.b-=t),P}if(this.a[0].byteLength>t){const P=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),P}const a=I.$ze.alloc(t);let E=0,S=0;for(;t>0;){const P=this.a[S];if(P.byteLength>t){const y=P.slice(0,t);a.set(y,E),E+=t,r&&(this.a[S]=P.slice(t),this.b-=t),t-=t}else a.set(P,E),E+=P.byteLength,r?(this.a.shift(),this.b-=P.byteLength):S++,t-=P.byteLength}return a}}e.$0h=v;var $;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})($||($={}));function f(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class b{constructor(t,r,a,E){this.type=t,this.id=r,this.ack=a,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends j.$Uc{constructor(t){super(),this.f=this.B(new N.$_d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new v,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,E=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,E,S,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$ze.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=I.$ze.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends j.$Uc{constructor(t){super(),this.f=new N.$_d,this.onMessage=this.f.event,this.g=new N.$_d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new u(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$$h=d;class l extends A.$5h{static fromSocket(t,r){return new l(new d(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$_h=l;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$_d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$ai=c;class g{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new g(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let E=0;E<o.a;E++)t-this.c[E]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Tc,this.o=t.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,k());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,k());this.p.write(t)}sendResume(){const t=new b(8,0,0,k());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new j.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,k());this.p.write(t);const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,k())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(r>=2e4&&a>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-r,2e4-a,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,k());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,k());this.p.write(t)}}e.$bi=n}),define(le[92],he([0,1,67,6,15,26,142,7,3,2,30,149,89,41]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class h extends f.$2h{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",d=>j.$ze.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Oq=h;class b{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new C.$_d,this.onDidProcessExit=this.h.event;const l=d&&d.timeout?d.timeout:6e4;this.b=new N.$kh(l),this.d=null,this.f=null}getChannel(u){const d=this;return{call(l,c,g){return d.k(u,l,c,g)},listen(l,c){return d.l(u,l,c)}}}k(u,d,l,c=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const g=this.n(u),i=(0,N.$ah)(s=>g.call(d,l,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,m.$Sc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,d,l){if(!this.b)return C.Event.None;this.b.cancel();let c;const g=new C.$_d({onWillAddFirstListener:()=>{c=this.n(u).listen(d,l)(g.fire,g),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,k.$Tn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,$.$em)(d.env),this.d=(0,I.fork)(this.i,u,d);const l=new C.$_d,g=C.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,O.$Kq)(r)){(0,O.log)(r,`IPC Library: ${this.j.serverName}`);return}l.fire(j.$ze.wrap(Buffer.from(r,"base64")))}),i=this.j.useQueue?(0,v.$gm)(this.d):this.d,o=r=>this.d&&this.d.connected&&i.send(r.buffer.toString("base64")),n=l.event,s={send:o,onMessage:n};this.f=new f.$3h(s);const t=()=>this.o();process.once("exit",t),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",t),g.dispose(),this.c.forEach(E=>(0,m.$Pc)(E)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pq=b}),define(le[151],he([0,1,134,15,41,3,13,17]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wW=void 0,e.$xW=k;class C{constructor($){this.a=$,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",f=>f.data?N.$ze.wrap(f.data):N.$ze.alloc(0)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class m extends j.$4h{static b($){(0,O.$$f)((0,I.$vW)(process),"Electron Utility Process");const f=new A.$_d;return process.parentPort.on("message",h=>{if($?.handledClientConnection(h))return;const b=(0,R.$Ob)(h.ports);b&&f.fire(b)}),A.Event.map(f.event,h=>({protocol:new C(h),onDidClientDisconnect:A.Event.fromNodeEventEmitter(h,"close")}))}constructor($){super(m.b($))}}e.$wW=m;function k(v,$,f){const h=b=>{b.data===$&&(v.removeListener("message",h),f())};v.on("message",h)}}),define(le[69],he([0,1,6,3,2,66,13]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.StorageState=e.StorageHint=void 0,e.$Mp=C;var R;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function C($){const f=$;return f?.changed instanceof Map||f?.deleted instanceof Set}var m;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(m||(e.StorageState=m={}));class k extends j.$Uc{static{this.a=100}constructor(f,h=Object.create(null)){super(),this.r=f,this.s=h,this.b=this.B(new N.$ce),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new I.$lh(k.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((h,b)=>this.w(b,h)),f.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(f,h){if(this.c===m.Closed)return;let b=!1;(0,O.$0f)(h)?b=this.f.delete(f):this.f.get(f)!==h&&(this.f.set(f,h),b=!0),b&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,h){const b=this.f.get(f);return(0,O.$0f)(b)?h:b}getBoolean(f,h){const b=this.get(f);return(0,O.$0f)(b)?h:b==="true"}getNumber(f,h){const b=this.get(f);return(0,O.$0f)(b)?h:parseInt(b,10)}getObject(f,h){const b=this.get(f);return(0,O.$0f)(b)?h:(0,A.$Vh)(b)}async set(f,h,b=!1){if(this.c===m.Closed)return;if((0,O.$0f)(h))return this.delete(f,b);const w=(0,O.$3f)(h)||Array.isArray(h)?(0,A.$Uh)(h):String(h);if(this.f.get(f)!==w)return this.f.set(f,w),this.j.set(f,w),this.h.delete(f),this.b.fire({key:f,external:b}),this.D()}async delete(f,h=!1){if(!(this.c===m.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:h}),this.D()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=m.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Np=k;class v{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((h,b)=>this.a.set(b,h)),f.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$Op=v}),define(le[152],he([11,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,40,6,14,13,31,152]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.zip=w,e.$_p=u,e.$aq=l,e.$9p="end of central directory record signature not found";const C=new RegExp(e.$9p);class m extends Error{constructor(g,i){let o=i.message;switch(g){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=g,this.cause=i}}e.$0p=m;function k(c){const g=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,o)=>i+o,g&61440)}function v(c){if(c instanceof m)return c;let g;return C.test(c.message)&&(g="CorruptZip"),new m(g,c)}function $(c,g,i,o,n,s){const t=j.$nc(g),r=j.$kc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,g)));const a=j.$kc(o,g);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((S,P)=>{if(!s.isCancellationRequested)try{E=(0,I.createWriteStream)(a,{mode:i}),E.once("close",()=>S()),E.once("error",P),c.once("error",P),c.pipe(E)}catch(y){P(y)}}))}function f(c,g,i,o){let n=(0,N.$ah)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const E=new N.$ih,S=P=>{P.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new m("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",P=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(P.fileName)){S(o);return}const y=P.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(y)){const z=j.$kc(g,y);n=(0,N.$ah)(F=>O.Promises.mkdir(z,{recursive:!0}).then(()=>S(F)).then(void 0,a));return}const p=b(c,P),D=k(P);n=(0,N.$ah)(z=>E.queue(()=>p.then(F=>$(F,y,D,g,i,z).then(()=>S(z)))).then(null,a))})}).finally(()=>t.dispose())}async function h(c,g=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,g?{lazyEntries:!0}:void 0,(s,t)=>{s?n(v(s)):o((0,A.$_f)(t))})})}function b(c,g){return new Promise((i,o)=>{c.openReadStream(g,(n,s)=>{n?o(v(n)):i((0,A.$_f)(s))})})}async function w(c,g){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;g.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,I.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function u(c,g,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=h(c,!0);return i.overwrite&&(s=s.then(t=>O.Promises.rm(g).then(()=>t))),s.then(t=>f(t,g,{sourcePathRegex:n},o))}function d(c,g){return h(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===g&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,g))))}))}function l(c,g){return d(c,g).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(le[153],he([11,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[154],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[155],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[156],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[157],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[158],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[159],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[160],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[161],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[162],he([11,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[163],he([11,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[164],he([11,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[165],he([11,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[166],he([11,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[167],he([11,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[168],he([11,10]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[169],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[170],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[171],he([11,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[172],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[173],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[174],he([11,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[175],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[176],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[177],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[178],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[179],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[180],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[181],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[182],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[183],he([11,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[184],he([0,1,7,155]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var j;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(j||(e.TokenType=j={}));function A(...m){switch(m.length){case 1:return(0,N.localize)(0,null,m[0]);case 2:return(0,N.localize)(1,null,m[0],m[1]);case 3:return(0,N.localize)(2,null,m[0],m[1],m[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(k){switch(k.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return k.isTripleEq?"===":"==";case 4:return k.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return k.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return k.lexeme;case 18:return k.lexeme;case 19:return k.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(k)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(k=>k.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(k){return this.c=k,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(k){return this.r()||this.c.charCodeAt(this.e)!==k?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(k){this.f.push({type:k,offset:this.d})}l(k){const v=this.d,$=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:$};this.g.push({offset:v,lexeme:$,additionalInfo:k}),this.f.push(f)}n(){this.m.lastIndex=this.d;const k=this.m.exec(this.c);if(k){this.e=this.d+k[0].length;const v=this.c.substring(this.d,this.e),$=C.b.get(v);$?this.k($):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let k=this.e,v=!1,$=!1;for(;;){if(k>=this.c.length){this.e=k,this.l(R);return}const h=this.c.charCodeAt(k);if(v)v=!1;else if(h===47&&!$){k++;break}else h===91?$=!0:h===92?v=!0:h===93&&($=!1);k++}for(;k<this.c.length&&C.a.has(this.c.charCodeAt(k));)k++;this.e=k;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=C}),define(le[185],he([0,1,65,84,23,14,36,20,8]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Xm=k,e.$Ym=v,e.$Vm=/^([^.]+\..+)[:=](.+)$/;class m{get appRoot(){return(0,A.$nc)(j.$Hg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,R.$1g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$1g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",f)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$1g)(C.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$1g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$1g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$1g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=O.env.VSCODE_PORTABLE;return f?C.URI.file((0,A.$kc)(f,"argv.json")):(0,R.$1g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$lc)(f):(0,A.$ic)((0,A.$kc)(j.$Hg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?C.URI.file((0,A.$lc)(f)):C.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$lc)(f);const h=O.env.VSCODE_EXTENSIONS;if(h)return h;const b=O.env.VSCODE_PORTABLE;return b?(0,A.$kc)(b,"extensions"):(0,R.$1g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(h=>/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file((0,A.$ic)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?C.URI.parse(f):C.URI.file((0,A.$ic)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return k(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$Vm.test(f))}get extensionLogLevel(){const f=[];for(const h of this.args.log||[]){const b=e.$Vm.exec(h);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.$1g)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=O.env.VSCODE_PORTABLE;return f?C.URI.file((0,A.$kc)(f,"policy.json")):(0,R.$1g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,h,b){this.a=f,this.b=h,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Wm=m,ve([N.$Rh],m.prototype,"appRoot",null),ve([N.$Rh],m.prototype,"userHome",null),ve([N.$Rh],m.prototype,"userDataPath",null),ve([N.$Rh],m.prototype,"appSettingsHome",null),ve([N.$Rh],m.prototype,"tmpDir",null),ve([N.$Rh],m.prototype,"cacheHome",null),ve([N.$Rh],m.prototype,"stateResource",null),ve([N.$Rh],m.prototype,"userRoamingDataHome",null),ve([N.$Rh],m.prototype,"userDataSyncHome",null),ve([N.$Rh],m.prototype,"sync",null),ve([N.$Rh],m.prototype,"machineSettingsResource",null),ve([N.$Rh],m.prototype,"workspaceStorageHome",null),ve([N.$Rh],m.prototype,"localHistoryHome",null),ve([N.$Rh],m.prototype,"keyboardLayoutResource",null),ve([N.$Rh],m.prototype,"argvResource",null),ve([N.$Rh],m.prototype,"isExtensionDevelopment",null),ve([N.$Rh],m.prototype,"untitledWorkspacesHome",null),ve([N.$Rh],m.prototype,"builtinExtensionsPath",null),ve([N.$Rh],m.prototype,"extensionsPath",null),ve([N.$Rh],m.prototype,"extensionDevelopmentLocationURI",null),ve([N.$Rh],m.prototype,"extensionDevelopmentKind",null),ve([N.$Rh],m.prototype,"extensionTestsLocationURI",null),ve([N.$Rh],m.prototype,"debugExtensionHost",null),ve([N.$Rh],m.prototype,"logLevel",null),ve([N.$Rh],m.prototype,"extensionLogLevel",null),ve([N.$Rh],m.prototype,"serviceMachineIdResource",null),ve([N.$Rh],m.prototype,"disableTelemetry",null),ve([N.$Rh],m.prototype,"disableWorkspaceTrust",null),ve([N.$Rh],m.prototype,"useInMemorySecretStorage",null),ve([N.$Rh],m.prototype,"policyFile",null);function k($,f){return v($["inspect-extensions"],$["inspect-brk-extensions"],5870,f,$.debugId,$.extensionEnvironment)}function v($,f,h,b,w,u){const l=Number(f||$)||(b?null:h),c=l?!!f:!1;let g;if(u)try{g=JSON.parse(u)}catch{}return{port:l,break:c,debugId:w,env:g}}}),function(){"use strict";function se(e,I,N){function j(O,R){const C=A(O,R),m=[C];return e.isAbsolute(C)||m.unshift(N),e.resolve(...m)}function A(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const k=O["user-data-dir"];if(k)return k;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(v,"AppData","Roaming")}break;case"darwin":m=e.join(I.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:j}}if(typeof define=="function")define(le[186],he([276,37,36]),function(e,I,N){return se(e,I,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=se(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[187],he([0,1,37,185,186]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=void 0,e.$1m=O,e.$2m=R;class A extends N.$Wm{constructor(m,k){super(m,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,j.getUserDataPath)(m,k.nameShort)},k)}}e.$Zm=A;function O(C,m){return(0,N.$Ym)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,m,C.extensionEnvironment)}function R(C,m){return(0,N.$Ym)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,m,C.extensionEnvironment)}}),define(le[188],he([0,1,13,158]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=j;function j(O,R,C,m){try{A(O,R,C,m)}catch(k){O.error(k?.message??k)}return R}function A(O,R,C,m){const k=(v,$,f)=>{const h=v[$];if((0,I.$1f)(h)){const b=h,w=b.length;if(w>1&&b[0]==="%"&&b[w-1]==="%"){const u=b.substr(1,w-2);let d=C[u];d===void 0&&m&&(d=m[u]);const l=typeof d=="string"?d:d?.message,c=m?.[u],g=typeof c=="string"?c:c?.message;if(!l){g||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,u)}`);return}if(f&&($==="title"||$==="category")&&g&&g!==l){const i={value:l,original:g};v[$]=i}else v[$]=l}}else if((0,I.$3f)(h))for(const b in h)h.hasOwnProperty(b)&&(b==="commands"?k(h,b,!0):k(h,b,f));else if(Array.isArray(h))for(let b=0;b<h.length;b++)k(h,b,f)};for(const v in R)R.hasOwnProperty(v)&&k(R,v)}}),define(le[189],he([0,1,70,161]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=j;function j(A){return(0,I.$aq)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(le[190],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=void 0;class I{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$rdc=I;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$sdc=N}),define(le[71],he([0,1,20,88,162,55]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=C,e.$yp=m,e.$zp=k,e.$Ap=v,e.$Bp=$,e.$Cp=f,e.$Dp=h;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||O.test(u)}function m(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function k(u){if(!u)return null;const d=u.majorBase,l=u.majorMustEqual,c=u.minorBase;let g=u.minorMustEqual;const i=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(d===0||(g=!1),o=!1);let n=0;if(u.preRelease){const s=R.exec(u.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:l,minorBase:c,minorMustEqual:g,patchBase:i,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:n}}function v(u,d,l){let c;typeof u=="string"?c=k(m(u)):c=u;let g;d instanceof Date?g=d.getTime():typeof d=="string"&&(g=new Date(d).getTime());let i;if(typeof l=="string"?i=k(m(l)):i=l,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const E=i.notBefore;let S=i.majorMustEqual,P=i.minorMustEqual,y=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||g&&g<E?!1:s>=a:(o===1&&t===0&&(!S||!P||!y)&&(t=1,r=0,a=0,S=!0,P=!1,y=!1),o<t?!1:o>t?!S:n<r?!1:n>r?!P:s<a?!1:s>a?!y:!(g&&g<E))}function $(u,d,l,c,g){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,j.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,j.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,j.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,j.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,j.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!w(c.extensionDependencies))return i.push([N.default.Error,j.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!w(c.activationEvents))return i.push([N.default.Error,j.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,j.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,j.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,j.localize(9,null,"main")]),i;{const s=(0,I.$1g)(l,c.main);(0,I.$Ug)(s,l)||i.push([N.default.Warning,j.localize(10,null,s.path,l.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,j.localize(11,null,"browser")]),i;{const s=(0,I.$1g)(l,c.browser);(0,I.$Ug)(s,l)||i.push([N.default.Warning,j.localize(12,null,s.path,l.path)])}}if(!A.valid(c.version))return i.push([N.default.Error,j.localize(13,null)]),i;const o=[];if(!f(u,d,c,g,o))for(const s of o)i.push([N.default.Error,s]);return i}function f(u,d,l,c,g){return c||typeof l.main>"u"&&typeof l.browser>"u"?!0:b(u,d,l.engines.vscode,g)}function h(u,d,l){return u==="*"||b(d,l,u)}function b(u,d,l,c=[]){const g=k(m(l));if(!g)return c.push(j.localize(14,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return c.push(j.localize(15,null,l)),!1}else if(!g.majorMustEqual)return c.push(j.localize(16,null,l)),!1;return v(u,d,g)?!0:(c.push(j.localize(17,null,u,l)),!1)}function w(u){if(!Array.isArray(u))return!1;for(let d=0,l=u.length;d<l;d++)if(typeof u[d]!="string")return!1;return!0}}),define(le[45],he([0,1,15,32]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=j;async function j(A,O,R){let C=R&&R.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const k=(await O.readFile(A.serviceMachineIdResource)).value.toString();C=(0,N.$Ig)(k)?k:null}catch{C=null}if(!C){C=(0,N.$Jg)();try{await O.writeFile(A.serviceMachineIdResource,I.$ze.fromString(C))}catch{}}return R?.store("storage.serviceMachineId",C,-1,1),C}}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class I{constructor(j,A=[],O=!1){this.ctor=j,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$ki=I}),define(le[191],he([0,1,72]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=A,e.$ms=O;const N=[];var j;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function A(R,C,m){C instanceof I.$ki||(C=new I.$ki(C,[],!!m)),N.push([R,C])}function O(){return N}}),define(le[192],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class I{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$2q=I;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(O);R.outgoing.set(C.key,C),C.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new I(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),C=this.c(O,R);if(C)return C}}c(A,O){for(const[R,C]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const m=this.c(C,O);if(m)return m;O.delete(R)}}}e.$3q=N}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e._util=void 0,e.$ni=j,e.$oi=A;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$mi=j("instantiationService");function N(O,R,C){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:C}):(R[I.DI_DEPENDENCIES]=[{id:O,index:C}],R[I.DI_TARGET]=R)}function j(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(C,m,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,C,k)};return R.toString=()=>O,I.serviceIds.set(O,R),R}function A(O){return O}}),define(le[193],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0,e.$4cc=(0,I.$ni)("checksumService")}),define(le[21],he([0,1,13,8,4]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=A,e.$Vi=O,e.$Wi=C,e.$Xi=m,e.$Yi=k,e.$Zi=v,e.$1i=$,e.$2i=h,e.$3i=b,e.$4i=w,e.$Ti=(0,j.$ni)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function C(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function m(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function k(u,d){const l=Object.create(null);for(const c in u)v(l,c,u[c],d);return l}function v(u,d,l,c){const g=d.split("."),i=g.pop();let o=u;for(let n=0;n<g.length;n++){const s=g[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${d} as ${g.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=l}catch{c(`Ignoring ${d} as ${g.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${d} as ${g.join(".")} is ${JSON.stringify(o)}`)}function $(u,d){const l=d.split(".");f(u,l)}function f(u,d){const l=d.shift();if(d.length===0){delete u[l];return}if(Object.keys(u).indexOf(l)!==-1){const c=u[l];typeof c=="object"&&!Array.isArray(c)&&(f(c,d),Object.keys(c).length===0&&delete u[l])}}function h(u,d,l){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const g=d.split("."),i=c(u,g);return typeof i>"u"?l:i}function b(u,d,l){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in u?I.$3f(u[c])&&I.$3f(d[c])?b(u[c],d[c],l):l&&(u[c]=d[c]):u[c]=d[c])})}function w(u){return u.replace(/[\[\]]/g,"")}}),define(le[93],he([0,1,5,27,184,4,154,7]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=m,e.$mj=o,e.$nj=n,e.$Gj=te;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",I.$j),C.set("isLinux",I.$k),C.set("isWindows",I.$i),C.set("isWeb",I.$o),C.set("isMacNative",I.$j&&!I.$o),C.set("isEdge",I.$H),C.set("isFirefox",I.$F),C.set("isChrome",I.$E),C.set("isSafari",I.$G);function m(U,L){if(C.get(U)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(U,L)}const k=Object.prototype.hasOwnProperty;var v;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const $={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(0,null),h=(0,O.localize)(1,null),b=(0,O.localize)(2,null),w=(0,O.localize)(3,null),u=(0,O.localize)(4,null),d=(0,O.localize)(5,null),l=(0,O.localize)(6,null),c=(0,O.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=$){this.k=L,this.d=new j.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:h});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const q=this.D(),x=q.type===17?d:void 0;throw this.h.push({message:u,offset:q.offset,lexeme:j.$ij.getLexeme(q),additionalInfo:x}),g.c}return T}catch(T){if(T!==g.c)throw T;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const T=this.o();L.push(T)}return L.length===1?L[0]:i.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const T=this.s();L.push(T)}return L.length===1?L[0]:i.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,w),T?.negate()}case 17:return this.z(),p.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,w),T}case 17:{const T=L.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const J=x.lexeme,ee=J.lastIndexOf("/"),_=ee===J.length-1?void 0:this.w(J.substring(ee+1));let Z;try{Z=new RegExp(J.substring(1,ee),_)}catch{throw this.B("REGEX",x)}return G.create(T,Z)}switch(x.type){case 10:case 19:{const J=[x.lexeme];this.z();let ee=this.D(),_=0;for(let de=0;de<x.lexeme.length;de++)x.lexeme.charCodeAt(de)===40?_++:x.lexeme.charCodeAt(de)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let de=0;de<ee.lexeme.length;de++)ee.lexeme.charCodeAt(de)===40?_++:x.lexeme.charCodeAt(de)===41&&_--}if(_<0)break;J.push(j.$ij.getLexeme(ee)),this.z(),ee=this.D()}const Z=J.join(""),ne=Z.lastIndexOf("/"),re=ne===Z.length-1?void 0:this.w(Z.substring(ne+1));let ue;try{ue=new RegExp(Z.substring(1,ne),re)}catch{throw this.B("REGEX",x)}return i.regex(T,ue)}case 18:{const J=x.lexeme;this.z();let ee=null;if(!(0,N.$Ze)(J)){const _=J.indexOf("/"),Z=J.lastIndexOf("/");if(_!==Z&&_>=0){const ne=J.slice(_+1,Z),re=J[Z+1]==="i"?"i":"";try{ee=new RegExp(ne,re)}catch{throw this.B("REGEX",x)}}}if(ee===null)throw this.B("REGEX",x);return G.create(T,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const x=this.u();return i.notIn(T,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return i.equals(T,x);switch(x){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return i.notEquals(T,x);switch(x){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,x)}}case 5:return this.z(),M.create(T,this.u());case 6:return this.z(),X.create(T,this.u());case 7:return this.z(),z.create(T,this.u());case 8:return this.z(),F.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:l,offset:L.offset,lexeme:"",additionalInfo:c}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,T){if(this.C(L))return this.z();throw this.B(T,this.D())}B(L,T,q){const x=(0,O.localize)(8,null,L,j.$ij.getLexeme(T)),J=T.offset,ee=j.$ij.getLexeme(T);return this.h.push({message:x,offset:J,lexeme:ee,additionalInfo:q}),g.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=g;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(L){return a.create(L)}static equals(L,T){return E.create(L,T)}static notEquals(L,T){return y.create(L,T)}static regex(L,T){return G.create(L,T)}static in(L,T){return S.create(L,T)}static notIn(L,T){return P.create(L,T)}static not(L){return p.create(L)}static and(...L){return K.create(L,null,!0)}static or(...L){return W.create(L,null,!0)}static greater(L,T){return z.create(L,T)}static greaterEquals(L,T){return F.create(L,T)}static smaller(L,T){return M.create(L,T)}static smallerEquals(L,T){return X.create(L,T)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$lj=i;function o(U){const L=new g({regexParsingWithErrorRecovery:!1});return U.map(T=>(L.parse(T),L.lexingErrors.length>0?L.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,O.localize)(9,null,q.additionalInfo):(0,O.localize)(10,null),offset:q.offset,length:q.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}function n(U,L){const T=U?U.substituteConstants():void 0,q=L?L.substituteConstants():void 0;return!T&&!q?!0:!T||!q?!1:T.equals(q)}function s(U,L){return U.cmp(L)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return r.INSTANCE}}e.$oj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return t.INSTANCE}}e.$pj=r;class a{static create(L,T=null){const q=C.get(L);return typeof q=="boolean"?q?r.INSTANCE:t.INSTANCE:new a(L,T)}constructor(L,T){this.key=L,this.c=T,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=C.get(this.key);return typeof L=="boolean"?L?r.INSTANCE:t.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.$qj=a;class E{static create(L,T,q=null){if(typeof T=="boolean")return T?a.create(L,q):p.create(L,q);const x=C.get(L);return typeof x=="boolean"?T===(x?"true":"false")?r.INSTANCE:t.INSTANCE:new E(L,T,q)}constructor(L,T,q){this.c=L,this.d=T,this.f=q,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=C.get(this.c);if(typeof L=="boolean"){const T=L?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$rj=E;class S{static create(L,T){return new S(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const T=L.getValue(this.f),q=L.getValue(this.d);return Array.isArray(T)?T.includes(q):typeof q=="string"&&typeof T=="object"&&T!==null?k.call(T,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=P.create(this.d,this.f)),this.c}}e.$sj=S;class P{static create(L,T){return new P(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=11,this.c=S.create(L,T)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=P;class y{static create(L,T,q=null){if(typeof T=="boolean")return T?p.create(L,q):a.create(L,q);const x=C.get(L);return typeof x=="boolean"?T===(x?"true":"false")?t.INSTANCE:r.INSTANCE:new y(L,T,q)}constructor(L,T,q){this.c=L,this.d=T,this.f=q,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=C.get(this.c);if(typeof L=="boolean"){const T=L?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$uj=y;class p{static create(L,T=null){const q=C.get(L);return typeof q=="boolean"?q?t.INSTANCE:r.INSTANCE:new p(L,T)}constructor(L,T){this.c=L,this.d=T,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=C.get(this.c);return typeof L=="boolean"?L?t.INSTANCE:r.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$vj=p;function D(U,L){if(typeof U=="string"){const T=parseFloat(U);isNaN(T)||(U=T)}return typeof U=="string"||typeof U=="number"?L(U):t.INSTANCE}class z{static create(L,T,q=null){return D(T,x=>new z(L,x,q))}constructor(L,T,q){this.c=L,this.d=T,this.f=q,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$wj=z;class F{static create(L,T,q=null){return D(T,x=>new F(L,x,q))}constructor(L,T,q){this.c=L,this.d=T,this.f=q,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$xj=F;class M{static create(L,T,q=null){return D(T,x=>new M(L,x,q))}constructor(L,T,q){this.c=L,this.d=T,this.f=q,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$yj=M;class X{static create(L,T,q=null){return D(T,x=>new X(L,x,q))}constructor(L,T,q){this.c=L,this.d=T,this.f=q,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$zj=X;class G{static create(L,T){return new G(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const T=this.f?this.f.source:"",q=L.f?L.f.source:"";return T<q?-1:T>q?1:0}equals(L){if(L.type===this.type){const T=this.f?this.f.source:"",q=L.f?L.f.source:"";return this.d===L.d&&T===q}return!1}substituteConstants(){return this}evaluate(L){const T=L.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Aj=G;class Y{static create(L){return new Y(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new Y(this.c.map(L))}negate(){return this.c}}e.$Bj=Y;function V(U){let L=null;for(let T=0,q=U.length;T<q;T++){const x=U[T].substituteConstants();if(U[T]!==x&&L===null){L=[];for(let J=0;J<T;J++)L[J]=U[J]}L!==null&&(L[T]=x)}return L===null?U:L}class K{static create(L,T,q){return K.d(L,T,q)}constructor(L,T){this.expr=L,this.c=T,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let T=0,q=this.expr.length;T<q;T++){const x=s(this.expr[T],L.expr[T]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let T=0,q=this.expr.length;T<q;T++)if(!this.expr[T].equals(L.expr[T]))return!1;return!0}return!1}substituteConstants(){const L=V(this.expr);return L===this.expr?this:K.create(L,this.c,!1)}evaluate(L){for(let T=0,q=this.expr.length;T<q;T++)if(!this.expr[T].evaluate(L))return!1;return!0}static d(L,T,q){const x=[];let J=!1;for(const ee of L)if(ee){if(ee.type===1){J=!0;continue}if(ee.type===0)return t.INSTANCE;if(ee.type===6){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&J)return r.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==9)break;x.pop();const _=x.pop(),Z=x.length===0,ne=W.create(ee.expr.map(re=>K.create([re,_],null,q)),null,Z);ne&&(x.push(ne),x.sort(s))}if(x.length===1)return x[0];if(q){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return t.INSTANCE;if(x.length===1)return x[0]}return new K(x,T)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const T of this.expr)L.push(...T.keys());return L}map(L){return new K(this.expr.map(T=>T.map(L)),null)}negate(){if(!this.c){const L=[];for(const T of this.expr)L.push(T.negate());this.c=W.create(L,this,!0)}return this.c}}e.$Cj=K;class W{static create(L,T,q){return W.d(L,T,q)}constructor(L,T){this.expr=L,this.c=T,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let T=0,q=this.expr.length;T<q;T++){const x=s(this.expr[T],L.expr[T]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let T=0,q=this.expr.length;T<q;T++)if(!this.expr[T].equals(L.expr[T]))return!1;return!0}return!1}substituteConstants(){const L=V(this.expr);return L===this.expr?this:W.create(L,this.c,!1)}evaluate(L){for(let T=0,q=this.expr.length;T<q;T++)if(this.expr[T].evaluate(L))return!0;return!1}static d(L,T,q){let x=[],J=!1;if(L){for(let ee=0,_=L.length;ee<_;ee++){const Z=L[ee];if(Z){if(Z.type===0){J=!0;continue}if(Z.type===1)return r.INSTANCE;if(Z.type===9){x=x.concat(Z.expr);continue}x.push(Z)}}if(x.length===0&&J)return t.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if(q){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return r.INSTANCE;if(x.length===1)return x[0]}return new W(x,T)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const T of this.expr)L.push(...T.keys());return L}map(L){return new W(this.expr.map(T=>T.map(L)),null)}negate(){if(!this.c){const L=[];for(const T of this.expr)L.push(T.negate());for(;L.length>1;){const T=L.shift(),q=L.shift(),x=[];for(const J of H(T))for(const ee of H(q))x.push(K.create([J,ee],null,!1));L.unshift(W.create(x,null,!1))}this.c=W.create(L,this,!0)}return this.c}}e.$Dj=W;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(L,T,q){super(L,null),this.f=T,typeof q=="object"?B.d.push({...q,key:L}):q!==!0&&B.d.push({key:L,description:q,type:T!=null?typeof T:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return E.create(this.key,L)}notEqualsTo(L){return y.create(this.key,L)}}e.$Ej=B,e.$Fj=(0,A.$ni)("contextKeyService");function ie(U,L){return U<L?-1:U>L?1:0}function ae(U,L,T,q){return U<T?-1:U>T?1:L<q?-1:L>q?1:0}function te(U,L){if(U.type===0||L.type===1)return!0;if(U.type===9)return L.type===9?ce(U.expr,L.expr):!1;if(L.type===9){for(const T of L.expr)if(te(U,T))return!0;return!1}if(U.type===6){if(L.type===6)return ce(L.expr,U.expr);for(const T of U.expr)if(te(T,L))return!0;return!1}return U.equals(L)}function ce(U,L){let T=0,q=0;for(;T<U.length&&q<L.length;){const x=U[T].cmp(L[q]);if(x<0)return!1;x===0&&T++,q++}return T===U.length}function H(U){return U.type===9?U.expr:[U]}}),define(le[94],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$7m=e.ID=void 0,e.$8m=N,e.ID="diagnosticsService",e.$7m=(0,I.$ni)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}class j{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$9m=j}),define(le[95],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=void 0,e.$Bo=(0,I.$ni)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,I.$ni)("environmentService"),e.$vi=(0,I.$oi)(e.$ui)}),define(le[29],he([0,1,157,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=j,e.$Ro=A,e.$So=O,e.$To=R,e.$Uo=C,e.$Vo=m,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function j(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(l,c){switch(l){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(l,c){return c==="web"&&!l.includes("web")}function C(l,c,g){return R(c,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g}function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var k;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var v;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var $;(function(l){l.Install="install",l.Uninstall="uninstall"})($||(e.StatisticType=$={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$Wo=(0,N.$ni)("extensionGalleryService");var h;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));var b;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class w extends Error{constructor(c,g){super(c),this.code=g,this.name=g}}e.$Xo=w;var u;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class d extends Error{constructor(c,g){super(c),this.code=g,this.name=g}}e.$Yo=d,e.$Zo=(0,N.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,N.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,N.$ni)("IExtensionTipsService"),e.$5o=(0,I.localize2)(0,"Extensions"),e.$6o=(0,I.localize2)(1,"Preferences")}),define(le[194],he([0,1,3,2,30,8,91,29]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=void 0;function C(w,u){return w?A.URI.revive(u?u.transformIncoming(w):w):void 0}function m(w,u){return u?u.transformOutgoingURI(w):w}function k(w,u){u=u||O.$qn;const d=w.manifest;return{...(0,O.$tn)({...w,manifest:void 0},u),manifest:d}}function v(w,u){return w?.profileLocation?(0,O.$tn)(w,u??O.$qn):w}function $(w,u){return u?(0,j.$Vn)(w,d=>d instanceof A.URI?u.transformOutgoingURI(d):void 0):w}class f{constructor(u,d){this.a=u,this.b=d,this.onInstallExtension=I.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const l=this.b(u);switch(d){case"onInstallExtension":return I.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?m(c.profileLocation,l):c.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,c=>c.map(g=>({...g,local:g.local?$(g.local,l):g.local,profileLocation:g.profileLocation?m(g.profileLocation,l):g.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?m(c.profileLocation,l):c.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?m(c.profileLocation,l):c.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,c=>$(c,l))}throw new Error("Invalid listen")}async call(u,d,l){const c=this.b(u);switch(d){case"zip":{const g=k(l[0],c),i=await this.a.zip(g);return m(i,c)}case"unzip":return this.a.unzip(C(l[0],c));case"install":return this.a.install(C(l[0],c),v(l[1],c));case"installFromLocation":return this.a.installFromLocation(C(l[0],c),C(l[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],C(l[1],c),C(l[2],c));case"getManifest":return this.a.getManifest(C(l[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],v(l[1],c));case"installGalleryExtensions":{const g=l[0];return this.a.installGalleryExtensions(g.map(({extension:i,options:o})=>({extension:i,options:v(o,c)??{}})))}case"uninstall":return this.a.uninstall(k(l[0],c),v(l[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(k(l[0],c));case"getInstalled":return(await this.a.getInstalled(l[0],C(l[1],c),l[2])).map(i=>$(i,c));case"toggleAppliationScope":{const g=await this.a.toggleAppliationScope(k(l[0],c),C(l[1],c));return $(g,c)}case"copyExtensions":return this.a.copyExtensions(C(l[0],c),C(l[1],c));case"updateMetadata":{const g=await this.a.updateMetadata(k(l[0],c),l[1],C(l[2],c));return $(g,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$6p=f;class h extends N.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new I.$_d),this.f=this.B(new I.$_d),this.g=this.B(new I.$_d),this.h=this.B(new I.$_d),this.j=this.B(new I.$_d),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?A.URI.revive(d.source):d.source,profileLocation:A.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(l=>({...l,local:l.local?k(l.local,null):l.local,source:this.r(l.source)?A.URI.revive(l.source):l.source,profileLocation:A.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:A.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(k(d,null))))}n(u,d){u.fire(d)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(l=>(0,R.$Uo)(l,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(d=>A.URI.revive(d)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,d){return Promise.resolve(this.m.call("install",[u,d])).then(l=>k(l,null))}installFromLocation(u,d){return Promise.resolve(this.m.call("installFromLocation",[u,d])).then(l=>k(l,null))}async installExtensionsFromProfile(u,d,l){return(await this.m.call("installExtensionsFromProfile",[u,d,l])).map(g=>k(g,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.m.call("installFromGallery",[u,d])).then(l=>k(l,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(l=>({...l,local:l.local?k(l.local,null):l.local,source:this.r(l.source)?A.URI.revive(l.source):l.source,profileLocation:A.URI.revive(l.profileLocation)}))}uninstall(u,d){if(u.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(d=>k(d,null))}getInstalled(u=null,d,l){return Promise.resolve(this.m.call("getInstalled",[u,d,l])).then(c=>c.map(g=>k(g,null)))}updateMetadata(u,d,l){return Promise.resolve(this.m.call("updateMetadata",[u,d,l])).then(c=>k(c,null))}toggleAppliationScope(u,d){return this.m.call("toggleAppliationScope",[u,d]).then(l=>k(l,null))}copyExtensions(u,d){return this.m.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,d,l){const c=await this.m.call("download",[u,d,l]);return A.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$7p=h;class b{constructor(u){this.a=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,l){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$8p=b}),define(le[96],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$f3b=j;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function j(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$g3b=(0,I.$ni)("IExtensionRecommendationNotificationService")}),define(le[12],he([0,1,51,14,27,13,8,164,4,5,23,53]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ml=e.FileKind=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.FileOperationResult=e.$el=e.$dl=e.$cl=e.$al=e.FileChangeType=e.$_k=e.FileOperation=e.$6k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tk=void 0,e.$Uk=$,e.$Vk=b,e.$Wk=u,e.$Xk=d,e.$Yk=l,e.$Zk=c,e.$1k=g,e.$2k=i,e.$3k=o,e.$4k=n,e.$5k=s,e.$7k=a,e.$8k=E,e.$9k=S,e.$0k=P,e.$$k=y,e.$bl=M,e.$nl=W,e.$ol=B,e.$ql=ae,e.$Tk=(0,C.$ni)("fileService");function $(te){return te.create===!0}var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var h;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(h||(e.FilePermission=h={}));function b(te){const ce=te;return!!ce&&typeof ce.onDidChange=="function"}var w;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function u(te){return!!(te.capabilities&2)}function d(te){return!!(te.capabilities&8)}function l(te){return!!(te.capabilities&131072)}function c(te){return!!(te.capabilities&4)}function g(te){return!!(te.capabilities&16)}function i(te){return u(te)?!!(te.capabilities&16384):!1}function o(te){return u(te)?!!(te.capabilities&32768):!1}function n(te){return!!(te.capabilities&65536)}function s(te){return!!(te.capabilities&2048)}var t;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ce,H){const U=new r(ce.toString(),H);return S(U,H),U}constructor(ce,H){super(ce),this.code=H}}e.$6k=r;function a(te,ce){return r.create(te,ce)}function E(te){return te||a((0,R.localize)(0,null),t.Unknown)}function S(te,ce){return te.name=ce?`${ce} (FileSystemError)`:"FileSystemError",te}function P(te){if(!te)return t.Unknown;if(te instanceof r)return te.code;const ce=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ce)return t.Unknown;switch(ce[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function y(te){if(te instanceof X)return te.fileOperationResult;switch(P(te)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var p;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(p||(e.FileOperation=p={}));class D{constructor(ce,H,U){this.resource=ce,this.operation=H,this.target=U}isOperation(ce){return this.operation===ce}}e.$_k=D;var z;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class F{static{this.a=null}constructor(ce,H){this.c=H,this.b=void 0,this.d=new v.$V(()=>{const U=I.$ti.forUris(()=>this.c);return U.fill(this.rawAdded.map(L=>[L,!0])),U}),this.f=new v.$V(()=>{const U=I.$ti.forUris(()=>this.c);return U.fill(this.rawUpdated.map(L=>[L,!0])),U}),this.g=new v.$V(()=>{const U=I.$ti.forUris(()=>this.c);return U.fill(this.rawDeleted.map(L=>[L,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ce){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==F.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...H){return this.h(ce,{includeChildren:!1},...H)}affects(ce,...H){return this.h(ce,{includeChildren:!0},...H)}h(ce,H,...U){if(!ce)return!1;const L=U.length>0;return!!((!L||U.includes(1))&&(this.d.value.get(ce)||H.includeChildren&&this.d.value.findSuperstr(ce))||(!L||U.includes(0))&&(this.f.value.get(ce)||H.includeChildren&&this.f.value.findSuperstr(ce))||(!L||U.includes(2))&&(this.g.value.findSubstr(ce)||H.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$al=F;function M(te,ce,H){return!te||!ce||te===ce||ce.length>te.length?!1:(ce.charAt(ce.length-1)!==N.sep&&(ce+=N.sep),H?(0,j.$rf)(te,ce):te.indexOf(ce)===0)}class X extends Error{constructor(ce,H,U){super(ce),this.fileOperationResult=H,this.options=U}}e.$cl=X;class G extends X{constructor(ce,H,U,L){super(ce,H,L),this.fileOperationResult=H,this.size=U}}e.$dl=G;class Y extends X{constructor(ce,H,U){super(ce,2,U),this.stat=H}}e.$el=Y;var V;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$hl="files.associations",e.$il="files.exclude",e.$jl="files.readonlyInclude",e.$kl="files.readonlyExclude",e.$ll="files.readonlyFromPermissions";var K;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$ml="";function W(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function B(te,ce){if(!ce.hasProvider(O.URI.from({scheme:te.scheme})))return new Promise(H=>{const U=ce.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===te.scheme&&L.added&&(U.dispose(),H())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ce){return(0,A.$5f)(ce)||(ce=0),ce<ie.KB?(0,R.localize)(1,null,ce.toFixed(0)):ce<ie.MB?(0,R.localize)(2,null,(ce/ie.KB).toFixed(2)):ce<ie.GB?(0,R.localize)(3,null,(ce/ie.MB).toFixed(2)):ce<ie.TB?(0,R.localize)(4,null,(ce/ie.GB).toFixed(2)):(0,R.localize)(5,null,(ce/ie.TB).toFixed(2))}}e.$pl=ie;function ae(te){const ce=typeof te=="string"||te?.scheme===k.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===k.Schemas.file?1024*ie.MB:ce?10*ie.MB:m.$o?50*ie.MB:1024*ie.MB}});var Q=this&&this.__param||function(se,e){return function(I,N){e(I,N,se)}};define(le[195],he([0,1,73,50,12]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const C=(await this.a.readFileStream(R)).value;return new Promise((m,k)=>{const v=(0,I.createHash)("sha256");(0,N.$re)(C,{onData:$=>v.update($.buffer),onError:$=>k($),onEnd:()=>m(v.digest("base64").replace(/=+$/,""))})})}};e.$5cc=A,e.$5cc=A=ve([Q(0,j.$Tk)],A)}),define(le[97],he([0,1,15,7,165,12]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=O;async function O(k,v,$,f,h,b){let w;try{await R(k,v,$,f,h,b)}catch(u){w=u}finally{w&&h.errorTransformer&&(w=h.errorTransformer(w)),typeof w<"u"&&$.error(w),$.end()}}async function R(k,v,$,f,h,b){C(b);const w=await k.open(v,{create:!1});try{C(b);let u=0,d=0,l=h&&typeof h.length=="number"?h.length:void 0,c=I.$ze.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),g=h&&typeof h.position=="number"?h.position:0,i=0;do d=await k.read(w,g,c.buffer,i,c.byteLength-i),g+=d,i+=d,u+=d,typeof l=="number"&&(l-=d),i===c.byteLength&&(await $.write(f(c)),c=I.$ze.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),i=0);while(d>0&&(typeof l!="number"||l>0)&&C(b)&&m(u,h));if(i>0){let o=i;typeof l=="number"&&(o=Math.min(i,l)),$.write(f(c.slice(0,o)))}}catch(u){throw(0,A.$8k)(u)}finally{await k.close(w)}}function C(k){if(k.isCancellationRequested)throw(0,N.$6)();return!0}function m(k,v){if(typeof v?.limits?.size=="number"&&k>v.limits.size)throw(0,A.$7k)((0,j.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[46],he([0,1,90,2,14,5,8,12]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=void 0,e.$Aq=C,e.$Bq=m,e.$Fq=f,e.$Gq=h,e.$Hq=b,e.$Iq=w;function C(d){return typeof d.correlationId=="number"}function m(d){return d.recursive===!0}class k extends N.$Uc{static{this.a=5}constructor(l,c,g,i){super(),this.h=l,this.j=c,this.m=g,this.n=i,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const l=new N.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(c=>this.h(c))),l.add(this.b.onDidLogMessage(c=>this.j(c))),l.add(this.b.onDidError(c=>this.t(c)))}t(l){this.n.restartOnError?this.g<k.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cq=k;class v extends k{constructor(l,c,g){super(l,c,g,{type:"node.js",restartOnError:!1})}}e.$Dq=v;class $ extends k{constructor(l,c,g){super(l,c,g,{type:"universal",restartOnError:!0})}}e.$Eq=$;function f(d){return d.map(l=>({type:l.type,resource:O.URI.revive(l.resource),cId:l.cId}))}function h(d){const l=new u;for(const c of d)l.processEvent(c);return l.coalesce()}function b(d,l){return typeof l=="string"&&!l.startsWith(I.$dk)&&!(0,j.$jc)(l)?{base:d,pattern:l}:l}function w(d,l){const c=[];for(const g of l)c.push((0,I.$hk)(b(d,g)));return c}class u{constructor(){this.a=new Set,this.b=new Map}c(l){return A.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const c=this.b.get(this.c(l));let g=!1;if(c){const i=c.type,o=l.type;c.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?g=!0:i===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(c)):i===2&&o===1?c.type=0:i===1&&o===0||(c.type=o)}else g=!0;g&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],c=[];return Array.from(this.a).filter(g=>g.type!==2?(l.push(g),!1):!0).sort((g,i)=>g.resource.fsPath.length-i.resource.fsPath.length).filter(g=>c.some(i=>(0,R.$bl)(g.resource.fsPath,i,!A.$k))?!1:(c.push(g.resource.fsPath),!0)).concat(l)}}}),define(le[196],he([0,1,15,38,7,3,2,50,32,12,46]),function(se,e,I,N,j,A,O,R,C,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P="localFilesystem";class v extends O.$Uc{constructor(f,h){super(),this.a=f,this.b=h,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$_d),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$_d),this.onDidWatchError=this.g.event,this.h=(0,C.$Jg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,h){const{buffer:b}=await this.a.call("readFile",[f,h]);return b}readFileStream(f,h,b){const w=(0,R.$ne)(d=>I.$ze.concat(d.map(l=>I.$ze.wrap(l))).buffer),u=new O.$Tc;return u.add(this.a.listen("readFileStream",[f,h])(d=>{if(d instanceof I.$ze)w.write(d.buffer);else{if(d==="end")w.end();else{let l;if(d instanceof Error)l=d;else{const c=d;l=(0,m.$7k)(c.message??(0,N.$$i)(c),c.code??m.FileSystemProviderErrorCode.Unknown)}w.error(l),w.end()}u.dispose()}})),u.add(b.onCancellationRequested(()=>{w.error((0,j.$6)()),w.end(),u.dispose()})),w}writeFile(f,h,b){return this.a.call("writeFile",[f,I.$ze.wrap(h),b])}open(f,h){return this.a.call("open",[f,h])}close(f){return this.a.call("close",[f])}async read(f,h,b,w,u){const[d,l]=await this.a.call("read",[f,h,u]);return b.set(d.buffer.slice(0,l),w),l}write(f,h,b,w,u){return this.a.call("write",[f,h,I.$ze.wrap(b),w,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,h){return this.a.call("delete",[f,h])}rename(f,h,b){return this.a.call("rename",[f,h,b])}copy(f,h,b){return this.a.call("copy",[f,h,b])}cloneFile(f,h){return this.a.call("cloneFile",[f,h])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const h=f;this.f.fire((0,k.$Fq)(h))}else{const h=f;this.g.fire(h)}}))}watch(f,h){const b=(0,C.$Jg)();return this.a.call("watch",[this.h,b,f,h]),(0,O.$Sc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$2P=v}),define(le[197],he([0,1,40,2,46,3,8,6]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class C extends N.$Uc{constructor(){super(),this.a=this.B(new A.$_d),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$_d),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$_d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new R.$Kh,this.B(this.f(k=>this.s(k)))}s(k){this.t(k)&&this.w(k)}t(k){return(0,j.$Aq)(k)}async watch(k){this.r.isSettled||this.r.complete(),this.r=new R.$Kh;try{this.h.clear(),this.g.clear();for(const v of k)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(k=>!this.j.has(k.correlationId))])}isSuspended(k){return typeof k.correlationId!="number"?!1:this.m.has(k.correlationId)?"polling":this.j.has(k.correlationId)}async w(k){if(this.j.has(k.correlationId))return;const v=new N.$Tc;this.j.set(k.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(k,v),this.u())}y(k){this.j.deleteAndDispose(k.correlationId),this.m.delete(k.correlationId),this.u()}z(k,v){this.C(k,v)?(this.M(`reusing an existing recursive watcher to monitor ${k.path}`),this.m.delete(k.correlationId)):(this.D(k,v),this.m.add(k.correlationId))}C(k,v){const $=this.L?.subscribe(k.path,(f,h)=>{v.isDisposed||(f?this.z(k,v):h?.type===1&&this.F(k))});return $?(v.add($),!0):!1}D(k,v){let $=!1;const f=(h,b)=>{if(v.isDisposed)return;const w=this.G(h),u=this.G(b),d=$;$=w,!w&&(u||d)&&this.F(k)};this.M(`starting fs.watchFile() on ${k.path} (correlationId: ${k.correlationId})`);try{(0,I.watchFile)(k.path,{persistent:!1,interval:this.n},f)}catch(h){this.N(`fs.watchFile() failed with error ${h} on path ${k.path} (correlationId: ${k.correlationId})`)}v.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${k.path} (correlationId: ${k.correlationId})`);try{(0,I.unwatchFile)(k.path,f)}catch(h){this.N(`fs.unwatchFile() failed with error ${h} on path ${k.path} (correlationId: ${k.correlationId})`)}}))}F(k){this.M(`detected ${k.path} exists again, resuming watcher (correlationId: ${k.correlationId})`);const v={resource:O.URI.file(k.path),type:1,cId:k.correlationId};this.a.fire([v]),this.H(v,k),this.y(k)}G(k){return k.ctimeMs===0&&k.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(k,v){const $=` >> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`;this.M(typeof v.correlationId=="number"?`${$} (correlationId: ${v.correlationId})`:$)}I(k){return`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"}, correlationId: ${typeof k.correlationId=="number"?k.correlationId:"<none>"})`}}e.$Rq=C}),define(le[198],he([0,1,40,6,26,44,2,87,14,5,20,8,148,31,46]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,e.$Xq=w;class b extends O.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(d,l,c,g,i,o){super(),this.r=d,this.s=l,this.t=c,this.u=g,this.w=i,this.y=o,this.c=this.B(new N.$Ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.t(n))),this.f=this.B(new N.$Bh(n=>this.L(n),b.b)),this.g=(0,h.$Iq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,h.$Iq)(this.r.path,this.r.includes):void 0,this.j=new j.$je,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const d=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const l=await f.Promises.stat(d);if(this.j.token.isCancellationRequested)return;this.B(await this.F(d,l.isDirectory()))}catch(d){d.code!=="ENOENT"?this.N(d):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${d})`),this.C()}}C(){this.n=!0,this.u?.()}async D(d){let l=d.path;try{l=await f.Promises.realpath(d.path),d.path===l&&(l=await(0,$.$Tq)(d.path,this.j.token)??d.path),d.path!==l&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${l})`)}catch{}return l}async F(d,l){const c=new O.$Tc;return this.G(d,l,c)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(d,l,c)),c}G(d,l,c){if(l)return!1;const g=v.URI.file(this.r.path),i=this.s?.subscribe(this.r.path,async(o,n)=>{if(!c.isDisposed)if(o){const s=await this.F(d,l);c.isDisposed?s.dispose():c.add(s)}else n&&(typeof n.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:g,type:n.type,cId:this.r.correlationId}])});return i?(c.add(i),!0):!1}async H(d,l,c){if(m.$j&&(0,A.$ng)(d,"/Volumes/",!0)){this.N(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const g=new j.$je(this.j.token);c.add((0,O.$Sc)(()=>g.dispose(!0)));const i=new O.$Tc;c.add(i);try{const o=v.URI.file(this.r.path),n=(0,C.$oc)(d),s=(0,I.watch)(d);i.add((0,O.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.P(`Started watching: '${d}'`);const t=new Set;if(l)try{for(const a of await f.Promises.readdir(d))t.add(a)}catch(a){this.N(a)}if(g.token.isCancellationRequested)return;const r=new Map;i.add((0,O.$Sc)(()=>{for(const[,a]of r)a.dispose();r.clear()})),s.on("error",(a,E)=>{g.token.isCancellationRequested||(this.N(`Failed to watch ${d} for changes using fs.watch() (${a}, ${E})`),this.C())}),s.on("change",(a,E)=>{if(g.token.isCancellationRequested)return;this.P(`[raw] ["${a}"] ${E}`);let S="";if(E&&(S=E.toString(),m.$j&&(S=(0,R.$5l)(S))),!(!S||a!=="change"&&a!=="rename"))if(l)if(a==="rename"){r.get(S)?.dispose();const P=setTimeout(async()=>{if(r.delete(S),S===n&&!await f.Promises.exists(d)){this.I(o);return}if(g.token.isCancellationRequested)return;const y=await this.M((0,C.$kc)(d,S));if(g.token.isCancellationRequested)return;let p;y?t.has(S)?p=0:(p=1,t.add(S)):(t.delete(S),p=2),this.J({resource:(0,k.$1g)(o,S),type:p,cId:this.r.correlationId})},b.a);r.set(S,(0,O.$Sc)(()=>clearTimeout(P)))}else{let P;t.has(S)?P=0:(P=1,t.add(S)),this.J({resource:(0,k.$1g)(o,S),type:P,cId:this.r.correlationId})}else if(a==="rename"||S!==n){const P=setTimeout(async()=>{const y=await f.Promises.exists(d);g.token.isCancellationRequested||(y?(this.J({resource:o,type:0,cId:this.r.correlationId},!0),i.add(await this.F(d,!1))):this.I(o))},b.a);i.clear(),i.add((0,O.$Sc)(()=>clearTimeout(P)))}else this.J({resource:o,type:0,cId:this.r.correlationId},!0)})}catch(o){g.token.isCancellationRequested||this.N(`Failed to watch ${d} for changes using fs.watch() (${o.toString()})`),this.C()}}I(d){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:d,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(d,l=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!l&&this.g.some(c=>c(d.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${d.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(c=>c(d.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}L(d){const l=(0,h.$Gq)(d);if(l.length>0){if(this.y)for(const g of l)this.P(` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(d){if(m.$k)return f.Promises.exists(d);try{const l=(0,C.$oc)(d);return(await f.Promises.readdir((0,C.$nc)(d))).some(g=>g===l)}catch(l){return this.P(l),!1}}setVerboseLogging(d){this.y=d}N(d){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}O(d){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}P(d){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Wq=b;async function w(u,d,l,c,g=512){const i=await f.Promises.open(u,"r"),o=Buffer.allocUnsafe(g),n=new j.$je(c);let s,t=!1;const r={path:u,excludes:[],recursive:!1},a=new b(r,void 0,E=>{(async()=>{for(const{type:S}of E)if(S===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:P}=await f.Promises.read(i,o,0,g,null);if(!P||n.token.isCancellationRequested)break;d(o.slice(0,P))}}catch(P){s=new Error(P),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,l(),new Promise((E,S)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await f.Promises.close(i)}catch(P){s=new Error(P)}s?S(s):E()})})}}),define(le[199],he([0,1,3,90,197,5,198,44]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class C extends j.$Rq{constructor(k){super(),this.L=k,this.onDidError=I.Event.None,this.watchers=new Set,this.O=!1}async J(k){k=this.W(k);const v=[],$=new Set(Array.from(this.watchers));for(const f of k){const h=this.R(f);h&&(0,N.$lk)(h.request.excludes,f.excludes)&&(0,N.$lk)(h.request.includes,f.includes)?$.delete(h):v.push(f)}v.length&&this.M(`Request to start watching: ${v.map(f=>this.I(f)).join(",")}`),$.size&&this.M(`Request to stop watching: ${Array.from($).map(f=>this.I(f.request)).join(",")}`);for(const f of $)this.U(f);for(const f of v)this.S(f)}R(k){for(const v of this.watchers)if(typeof k.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===k.correlationId)return v}else if((0,R.$mg)(v.request.path,k.path,!A.$k))return v}S(k){const v=new O.$Wq(k,this.L,f=>this.a.fire(f),()=>this.c.fire(k),f=>this.b.fire(f),this.O),$={request:k,instance:v};this.watchers.add($)}async stop(){await super.stop();for(const k of this.watchers)this.U(k)}U(k){this.M("stopping file watcher",k),this.watchers.delete(k),k.instance.dispose()}W(k){const v=new Map;for(const $ of k){const f=A.$k?$.path:$.path.toLowerCase();let h=v.get($.correlationId);h||(h=new Map,v.set($.correlationId,h)),h.has(f)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I($)}`),h.set(f,$)}return Array.from(v.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(k){this.O=k;for(const v of this.watchers)v.instance.setVerboseLogging(k)}M(k,v){this.O&&this.b.fire({type:"trace",message:this.Z(k,v)})}N(k){this.b.fire({type:"warn",message:this.Z(k)})}Z(k,v){return v?`[File Watcher (node.js)] ${k} (${this.I(v.request)})`:`[File Watcher (node.js)] ${k}`}}e.$Yq=C}),define(le[200],he([0,1,46,199]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class j extends I.$Dq{constructor(O,R,C){super(O,R,C),this.s()}r(O){return O.add(new N.$Yq(void 0))}}e.$Zq=j}),define(le[201],he([0,1,23,41,92,46]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class O extends A.$Eq{constructor(C,m,k){super(C,m,k),this.s()}r(C){const m=C.add(new j.$Pq(I.$Hg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(m.onDidProcessExit(({code:k,signal:v})=>this.t(`terminated by itself with code ${k}, signal: ${v}`))),N.ProxyChannel.toService((0,N.$7h)(m.getChannel("watcher")))}}e.$Qq=O}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class I{constructor(...j){this.a=new Map;for(const[A,O]of j)this.set(A,O)}set(j,A){const O=this.a.get(j);return this.a.set(j,A),O}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$li=I}),define(le[202],he([0,1,6,7,2,72,192,4,74,86]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const k=!1;class v extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class ${constructor(w=new C.$li,u=!1,d,l=k){this.i=w,this.j=u,this.k=d,this.l=l,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$mi,this),this._globalGraph=l?d?._globalGraph??new O.$3q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,j.$Pc)(this.h),this.h.clear();for(const w of this.g)(0,j.$Oc)(w)&&w.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(w){this.m();const u=new class extends ${dispose(){this.h.delete(u),super.dispose()}}(w,this.j,this,this.l);return this.h.add(u),u}invokeFunction(w,...u){this.m();const d=h.traceInvocation(this.l,w);let l=!1;try{return w({get:g=>{if(l)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(g,d);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...u)}finally{l=!0,d.stop()}}createInstance(w,...u){this.m();let d,l;return w instanceof A.$ki?(d=h.traceCreation(this.l,w.ctor),l=this.o(w.ctor,w.staticArguments.concat(u),d)):(d=h.traceCreation(this.l,w),l=this.o(w,u,d)),d.stop(),l}o(w,u=[],d){const l=R._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),c=[];for(const i of l){const o=this.s(i.id,d);o||this.y(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const g=l.length>0?l[0].index:u.length;if(u.length!==g){console.trace(`[createInstance] First service dependency of ${w.name} at position ${g+1} conflicts with ${u.length} static arguments`);const i=g-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,g)}return Reflect.construct(w,u.concat(c))}q(w,u){if(this.i.get(w)instanceof A.$ki)this.i.set(w,u);else if(this.k)this.k.q(w,u);else throw new Error("illegalState - setting UNKNOWN service instance")}r(w){const u=this.i.get(w);return!u&&this.k?this.k.r(w):u}s(w,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const d=this.r(w);return d instanceof A.$ki?this.u(w,d,u.branch(w,!0)):(u.branch(w,!1),d)}u(w,u,d){if(this.t.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.t.add(w);try{return this.v(w,u,d)}finally{this.t.delete(w)}}v(w,u,d){const l=new O.$3q(i=>i.id.toString());let c=0;const g=[{id:w,desc:u,_trace:d}];for(;g.length;){const i=g.pop();if(l.lookupOrInsertNode(i),c++>1e3)throw new v(l);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.r(o.id);if(n||this.y(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.$ki){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};l.insertEdge(i,s),g.push(s)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new v(l);break}for(const{data:o}of i){if(this.r(o.id)instanceof A.$ki){const s=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,s)}l.removeNode(o)}}return this.r(w)}w(w,u,d=[],l,c){if(this.i.get(w)instanceof A.$ki)return this.x(w,u,d,l,c,this.g);if(this.k)return this.k.w(w,u,d,l,c);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}x(w,u,d=[],l,c,g){if(l){const i=new $(void 0,this.j,this,this.l);i.c=String(w);const o=new Map,n=new I.$Gh(()=>{const s=i.o(u,d,c);for(const[t,r]of o){const a=s[t];if(typeof a=="function")for(const E of r)E.disposable=a.apply(s,E.listener)}return o.clear(),g.add(s),s});return new Proxy(Object.create(null),{get(s,t){if(!n.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let E=o.get(t);return E||(E=new m.$5c,o.set(t,E)),(P,y,p)=>{if(n.isInitialized)return n.value[t](P,y,p);{const D={listener:[P,y,p],disposable:void 0},z=E.push(D);return(0,j.$Sc)(()=>{z(),D.disposable?.dispose()})}}}if(t in s)return s[t];const r=n.value;let a=r[t];return typeof a!="function"||(a=a.bind(r),s[t]=a),a},set(s,t,r){return n.value[t]=r,!0},getPrototypeOf(s){return u.prototype}})}else{const i=this.o(u,d,c);return g.add(i),i}}y(w,u){if(u&&console.warn(w),this.j)throw new Error(w)}}e.$4q=$;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,u){return w?new h(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(w,u){return w?new h(1,u.name):h.c}static{this.f=0}constructor(w,u){this.type=w,this.name=u,this.g=Date.now(),this.h=[]}branch(w,u){const d=new h(3,w.toString());return this.h.push([w,u,d]),d}stop(){const w=Date.now()-this.g;h.f+=w;let u=!1;function d(c,g){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of g.h)if(s&&t){u=!0,i.push(`${o}CREATES -> ${n}`);const r=d(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(w>2||u)&&h.all.add(l.join(`
`))}}e.$5q=h}),define(le[56],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0,e.$zcc=(0,I.$ni)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$Acc=N}),define(le[75],he([0,1,26,2,5,167,29,4]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=void 0,e.$Fr=C;function C(k){return k.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Gr=(0,R.$ni)("languagePackService");let m=class extends N.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new I.$je;setTimeout(()=>v.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const h=$.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(w=>w.startsWith("lp-"))).map(b=>{const w=b.properties.localizedLanguages?.[0],u=C(b);return{...this.f(u,w,b),extensionId:b.identifier.id,galleryExtension:b}});return h.push(this.f("en","English")),h}f(v,$,f){const h=$??v;let b;if(h!==v&&(b=`(${v})`),v.toLowerCase()===j.$w.toLowerCase()&&(b??="",b+=(0,A.localize)(0,null)),f?.installCount){b??="";const w=f.installCount;let u;w>1e6?u=`${Math.floor(w/1e5)/10}M`:w>1e3?u=`${Math.floor(w/1e3)}K`:u=String(w),b+=` $(cloud-download) ${u}`}return{id:v,label:h,description:b}}};e.$Hr=m,e.$Hr=m=ve([Q(0,O.$Wo)],m)}),define(le[203],he([0,1,2,75]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;let j=class extends I.$Uc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$1cc=j,e.$1cc=j=ve([Q(0,N.$Gr)],j)}),define(le[9],he([0,1,168,38,3,54,2,35,5,20,13,8,93,4]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=b,e.log=u,e.$8j=a,e.$9j=E,e.$0j=S,e.$$j=P,e.$Tj=(0,f.$ni)("logService"),e.$Uj=(0,f.$ni)("loggerService");function h(){return new Date().toISOString()}function b(y){return(0,k.$5f)(y)}var w;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Wj=w.Info;function u(y,p,D){switch(p){case w.Trace:y.trace(D);break;case w.Debug:y.debug(D);break;case w.Info:y.info(D);break;case w.Warning:y.warn(D);break;case w.Error:y.error(D);break;case w.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function d(y,p=!1){let D="";for(let z=0;z<y.length;z++){let F=y[z];if(F instanceof Error&&(F=(0,N.$$i)(F,p)),typeof F=="object")try{F=JSON.stringify(F)}catch{}D+=(z>0?" ":"")+F}return D}class l extends O.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new j.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==w.Off&&this.b<=p}}e.$Yj=l;class c extends l{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...D){this.f(w.Trace)&&this.g(w.Trace,d([p,...D],!0))}debug(p,...D){this.f(w.Debug)&&this.g(w.Debug,d([p,...D]))}info(p,...D){this.f(w.Info)&&this.g(w.Info,d([p,...D]))}warn(p,...D){this.f(w.Warning)&&this.g(w.Warning,d([p,...D]))}error(p,...D){if(this.f(w.Error))if(p instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=p.stack,this.g(w.Error,d(z))}else this.g(w.Error,d([p,...D]))}flush(){}}e.$Zj=c;class g extends l{constructor(p=e.$Wj){super(),this.setLevel(p),this.g=!C.$i}trace(p,...D){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,p,...D):console.log(`[main ${h()}]`,p,...D))}debug(p,...D){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,p,...D):console.log(`[main ${h()}]`,p,...D))}info(p,...D){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,p,...D):console.log(`[main ${h()}]`,p,...D))}warn(p,...D){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,p,...D):console.warn(`[main ${h()}]`,p,...D))}error(p,...D){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,p,...D):console.error(`[main ${h()}]`,p,...D))}flush(){}}e.$1j=g;class i extends l{constructor(p=e.$Wj,D=!0){super(),this.g=D,this.setLevel(p)}trace(p,...D){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...D):console.log(p,...D))}debug(p,...D){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...D):console.log(p,...D))}info(p,...D){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...D):console.log(p,...D))}warn(p,...D){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...D):console.log(p,...D))}error(p,...D){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...D):console.error(p,...D))}flush(){}}e.$2j=i;class o extends l{constructor(p,D=e.$Wj){super(),this.g=p,this.setLevel(D)}trace(p,...D){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(p),...D])}debug(p,...D){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(p),...D])}info(p,...D){this.f(w.Info)&&this.g.log(w.Info,[this.h(p),...D])}warn(p,...D){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(p),...D])}error(p,...D){this.f(w.Error)&&this.g.log(w.Error,[this.h(p),...D])}h(p){return typeof p=="string"?p:(0,N.$$i)(p,this.f(w.Trace))}flush(){}}e.$3j=o;class n extends l{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const D of this.g)D.setLevel(p);super.setLevel(p)}trace(p,...D){for(const z of this.g)z.trace(p,...D)}debug(p,...D){for(const z of this.g)z.debug(p,...D)}info(p,...D){for(const z of this.g)z.info(p,...D)}warn(p,...D){for(const z of this.g)z.warn(p,...D)}error(p,...D){for(const z of this.g)z.error(p,...D)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose();super.dispose()}}e.$4j=n;class s extends O.$Uc{constructor(p,D,z){if(super(),this.h=p,this.j=D,this.b=new R.$Bc,this.c=this.B(new j.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$_d),this.onDidChangeVisibility=this.g.event,z)for(const F of z)this.b.set(F.resource,{logger:void 0,info:F})}m(p){return(0,k.$1f)(p)?[...this.b.values()].find(D=>D.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,D){const z=this.n(p),F=(0,k.$1f)(p)?p:D?.id??(0,A.$bj)(z.toString()).toString(16);let M=this.b.get(z)?.logger;const X=D?.logLevel==="always"?w.Trace:D?.logLevel;M||(M=this.s(z,X??this.getLogLevel(z)??this.h,{...D,id:F}));const G={logger:M,info:{resource:z,id:F,logLevel:X,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(G.info),this.b.set(z,G),M}n(p){return(0,k.$1f)(p)?(0,m.$1g)(this.j,`${p}.log`):p}setLogLevel(p,D){if(v.URI.isUri(p)){const z=p,F=D,M=this.b.get(z);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([z,F]))}else{this.h=p;for(const[z,F]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,D){const z=this.m(p);z&&D!==!z.info.hidden&&(z.info.hidden=!D,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,D]))}getLogLevel(p){let D;return p&&(D=this.b.get(p)?.info.logLevel),D??this.h}registerLogger(p){const D=this.b.get(p.resource);D?D.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const D=this.b.get(p);D&&(D.logger&&D.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=s;class t{constructor(){this.onDidChangeLogLevel=new j.$_d().event}setLevel(p){}getLevel(){return w.Info}trace(p,...D){}debug(p,...D){}info(p,...D){}warn(p,...D){}error(p,...D){}critical(p,...D){}dispose(){}flush(){}}e.$6j=t;class r extends t{}e.$7j=r;function a(y){if(y.verbose)return w.Trace;if(typeof y.logLevel=="string"){const p=P(y.logLevel.toLowerCase());if(p!==void 0)return p}return e.$Wj}function E(y){switch(y){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function S(y){switch(y){case w.Trace:return{original:"Trace",value:I.localize(0,null)};case w.Debug:return{original:"Debug",value:I.localize(1,null)};case w.Info:return{original:"Info",value:I.localize(2,null)};case w.Warning:return{original:"Warning",value:I.localize(3,null)};case w.Error:return{original:"Error",value:I.localize(4,null)};case w.Off:return{original:"Off",value:I.localize(5,null)}}}function P(y){switch(y){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$_j=new $.$Ej("logLevel",E(w.Info))}),define(le[204],he([0,1,6,7,2,23,14,20,31,16,9]),function(se,e,I,N,j,A,O,R,C,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;let v=class extends j.$Uc{constructor(f,h){super(),this.a=f,this.b=h,this.B(new I.$zh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,R.$Xg)(this.a.logsHome),h=(0,R.$Zg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,u=(await C.Promises.readdir(h)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==f),d=u.slice(0,Math.max(0,u.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(l=>C.Promises.rm((0,O.$kc)(h,l)))))}catch(f){(0,N.$1)(f)}}};e.$2cc=v,e.$2cc=v=ve([Q(0,m.$ui),Q(1,k.$Tj)],v)}),define(le[205],he([0,1,17,6,7,3,2,14,46,9]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class k extends O.$Uc{constructor($,f){super(),this.a=$,this.b=f,this.c=this.B(new A.$_d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$_d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$lh(0)),this.w=[],this.y=this.B(new N.$lh(0))}watch($,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n($,f):this.z($,f)}n($,f){const h={path:this.I($),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},b=(0,I.$Ub)(this.j,h);return this.r(),(0,O.$Sc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,j.$1)($))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,C.$Fq)(f)),f=>this.G(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const f of this.j)(0,C.$Bq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const f of this.j)(0,C.$Bq)(f)&&$.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,f){const h={path:this.I($),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},b=(0,I.$Ub)(this.w,h);return this.C(),(0,O.$Sc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,j.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,C.$Fq)($)),$=>this.G($),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,R.$ic)($.fsPath)}}e.$Jq=k}),define(le[206],he([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let g=class extends m.$Uc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$_d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$_d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$_d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$_d),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$_d),this.Y=this.B(new O.$_d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$_d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$wh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${o}`);const s=new m.$Tc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new w.$al(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,m.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,m.$Pc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return C.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,f.$5g)(o))throw new w.$cl((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new l.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,w.$Zk)(n)||(0,w.$Wk)(n)||(0,w.$1k)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,w.$Zk)(n)||(0,w.$Wk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,w.$0k)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.$cl((0,b.localize)(2,null,this.sb(o)),1):(0,w.$8k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,E=n?.resolveMetadata,S=await s.stat(o);let P;return this.t(s,o,S,void 0,!!E,(y,p)=>(P||(P=k.$ti.forUris(()=>!t),P.set(o,!0),r&&P.fill(!0,r)),P.get(y.resource)||P.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?p===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:E}=this.R(o),S={resource:n,name:E.basename(n),isFile:(s.type&w.FileType.File)!==0,isDirectory:(s.type&w.FileType.Directory)!==0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&w.FilePermission.Locked),etag:(0,w.$nl)({mtime:s.mtime,size:s.size}),children:void 0};if(S.isDirectory&&a(S,t)){try{const P=await o.readdir(n),y=await N.Promises.settled(P.map(async([p,D])=>{try{const z=E.joinPath(n,p),F=r?await o.stat(z):{type:D};return await this.t(o,z,F,P.length,r,a)}catch(z){return this.b.trace(z),null}}));S.children=(0,I.$Hb)(y)}catch(P){this.b.trace(P),S.children=[]}return S}return S}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new w.$cl((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=j.$ze.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new w.$_k(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,w.$3k)(t)&&!a?.atomic){const E=t.enforceAtomicWriteFile?.(o);E&&(a={...s,atomic:E})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let S;if((0,w.$Wk)(t)&&!(n instanceof j.$ze))if((0,h.$le)(n)){const P=await(0,h.$se)(n,3);P.ended?S=j.$ze.concat(P.buffer):S=P}else S=(0,h.$pe)(n,P=>j.$ze.concat(P),3);else S=n;!(0,w.$Zk)(t)||(0,w.$Wk)(t)&&S instanceof j.$ze||(0,w.$Wk)(t)&&(0,w.$3k)(t)&&a?.atomic?await this.hb(t,o,a,S):await this.db(t,o,a,S instanceof j.$ze?(0,j.$Ke)(S):S),this.r.fire(new w.$_k(o,4))}catch(E){throw new w.$cl((0,b.localize)(4,null,this.sb(o),(0,w.$8k)(E).toString()),(0,w.$$k)(E),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&w.FileType.Directory)throw new w.$cl((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.$ml&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,w.$nl)({mtime:s.mtime,size:a.size}))throw new w.$cl((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const E=await this.C(o,n,s,t);r(E)}catch(E){a(E)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,j.$Le)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new A.$je(t);let a=s;(0,w.$2k)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const E=this.J(n,a).then(P=>P,P=>{throw r.dispose(!0),P});let S;try{return typeof a?.etag=="string"&&a.etag!==w.$ml&&await E,a?.atomic&&(0,w.$2k)(o)||!((0,w.$Zk)(o)||(0,w.$1k)(o))||(0,w.$Wk)(o)&&a?.preferUnbuffered?S=this.I(o,n,a):(0,w.$1k)(o)?S=this.G(o,n,r.token,a):S=this.H(o,n,r.token,a),S.on("end",()=>r.dispose()),S.on("error",()=>r.dispose()),{...await E,value:S}}catch(P){throw S&&await(0,h.$qe)(S),this.F(P,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,w.$8k)(o).toString());return o instanceof w.$el?new w.$el(t,o.stat,s):o instanceof w.$dl?new w.$dl(t,o.fileOperationResult,o.size,o.options):new w.$cl(t,(0,w.$$k)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,h.$we)(r,{data:a=>a instanceof j.$ze?a:j.$ze.wrap(a),error:a=>this.F(a,n,t)},a=>j.$ze.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,j.$Pe)();return(0,u.$yq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,h.$ne)(r=>j.$ze.concat(r));return(async()=>{try{let r;s?.atomic&&(0,w.$2k)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(j.$ze.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new w.$cl((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$ml&&n.etag===s.etag)throw new w.$el((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new w.$dl((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$_k(o,a==="move"?2:3,E)),E}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$_k(o,a==="copy"?3:2,E)),E}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:S}=await this.Q(o,n,s,t,r,a);if(E&&!S&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,w.$Xk)(o))await o.copy(n,t,{overwrite:a});else{const P=await this.resolve(n);P.isDirectory?await this.P(o,P,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,w.$Zk)(o)&&(0,w.$Zk)(s))return this.jb(o,n,s,t);if((0,w.$Zk)(o)&&(0,w.$Wk)(s))return this.pb(o,n,s,t);if((0,w.$Wk)(o)&&(0,w.$Zk)(s))return this.nb(o,n,s,t);if((0,w.$Wk)(o)&&(0,w.$Wk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let E=!1;if(o===s){const{providerExtUri:P,isPathCaseSensitive:y}=this.R(o);if(y||(E=P.isEqual(n,t)),E&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!E&&P.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const S=await this.exists(t);if(S&&!E){if(!a)throw new w.$cl((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:P}=this.R(o);if(P.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:S,isSameResourceWithDifferentPathCase:E}}R(o){const n=this.S(o);return{providerExtUri:n?f.$Qg:f.$Sg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$_k(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&w.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$0k)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,w.$0k)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new w.$cl((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const S=await this.resolve(o);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,w.$4k)(s)&&!t?.atomic){const S=s.enforceAtomicDelete?.(o);S&&(t={...n,atomic:S})}const r=!!t?.useTrash,a=!!t?.recursive,E=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:E}),this.r.fire(new w.$_k(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,w.$Yk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,w.$Xk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new m.$Tc;let t=!1,r=()=>{t=!0};s.add((0,m.$Sc)(()=>r())),(async()=>{try{const E=await this.bb(o,n);t?(0,m.$Pc)(E):r=()=>(0,m.$Pc)(E)}catch(E){this.b.error(E)}})();const a=n.correlationId;if(typeof a=="number"){const E=s.add(new O.$_d);return s.add(this.X.event(P=>{P.correlates(a)&&E.fire(P)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$bj)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,m.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,m.$Pc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,m.$Pc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,h.$le)(t)||(0,h.$me)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,w.$8k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,h.$me)(s)){if(s.buffer.length>0){const a=j.$ze.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,E)=>{(0,h.$re)(r,{onData:async S=>{r.pause();try{await this.gb(o,n,S,S.byteLength,t,0)}catch(P){return E(P)}t+=S.byteLength,setTimeout(()=>r.resume())},onError:S=>E(S),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let E=0;for(;E<t;){const S=await o.write(n,r+E,s.buffer,a+E,t-E);E+=S}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof j.$ze?r=t:(0,h.$le)(t)?r=await(0,j.$Le)(t):(0,h.$me)(t)?r=await(0,j.$Me)(t):r=(0,j.$Je)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const E=j.$ze.alloc(this.a);let S=0,P=0,y=0;do y=await o.read(r,S,E.buffer,P,E.byteLength-P),await this.gb(s,a,E,y,S,P),S+=y,P+=y,P===E.byteLength&&(P=0);while(y>0)}catch(E){throw(0,w.$8k)(E)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,j.$ze.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.$8k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,j.$Le)(this.H(o,n,A.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new w.$cl((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$cl((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$zq=g,e.$zq=g=c=ve([Q(0,d.$Tj)],g)}),define(le[207],he([0,1,40,277,6,35,15,3,44,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,(()=>{try{(0,N.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$$i)(o)}`)}})();class i extends d.$Jq{static{this.J=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.O=new A.$Bc(t=>$.$Rg.getComparisonKey(t)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,v.$k&&(this.L|=1024)),this.L}async stat(n){try{const{stat:s,symbolicLink:t}=await h.SymlinkSupport.stat(this.I(n));return{type:this.N(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:w.FilePermission.Locked}}catch(s){throw this.gb(s)}}async M(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await h.Promises.readdir(this.I(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,$.$1g)(n,r.name))).type:a=this.N(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.gb(s)}}N(n,s){let t;return s?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,s&&(t|=w.FileType.SymbolicLink),t}async P(n){const s=this.I(n);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.O.get(n);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new j.$mh;return this.O.set(n,r),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,m.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.O.get(n)===r&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.O.delete(n)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),t=await this.P(n));const r=this.I(n);return await h.Promises.readFile(r)}catch(r){throw this.gb(r)}finally{t?.dispose()}}Q(n){i.J&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,f.$ne)(a=>O.$ze.concat(a.map(E=>O.$ze.wrap(E))).buffer);return(0,u.$yq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.R(n)?this.S(n,(0,$.$1g)((0,$.$Zg)(n),`${(0,$.$Xg)(n)}${t.atomic.postfix}`),s,t):this.U(n,s,t)}async R(n){try{const s=this.I(n),{symbolicLink:t}=await h.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async S(n,s,t,r){const a=new m.$Tc;try{a.add(await this.P(n)),a.add(await this.P(s)),await this.U(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(E){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{a.dispose()}}async U(n,s,t,r){let a;try{const E=this.I(n);if(!t.create||!t.overwrite){if(await h.Promises.exists(E)){if(!t.overwrite)throw(0,w.$7k)((0,b.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$7k)((0,b.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(E){throw await this.hb(n,E)}finally{typeof a=="number"&&await this.close(a)}}static{this.Z=!0}static configureFlushOnWrite(n){i.Z=n}async open(n,s,t){const r=this.I(n);let a;(0,w.$Uk)(s)&&!t&&(a=await this.P(n));let E;try{if((0,w.$Uk)(s)&&s.unlock)try{const{stat:P}=await h.SymlinkSupport.stat(r);P.mode&128||await h.Promises.chmod(r,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}let S;if((0,w.$Uk)(s)){if(v.$i)try{await h.Promises.truncate(r,0),S="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}S||(S="w")}else S="r";E=await h.Promises.open(r,S)}catch(S){throw a?.dispose(),(0,w.$Uk)(s)?await this.hb(n,S):this.gb(S)}if(this.W.set(E,0),(0,w.$Uk)(s)&&this.Y.set(E,n),a){const S=this.X.get(E);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.X.set(E,a),S&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),S.dispose())}return E}async close(n){const s=this.X.get(n);try{if(this.W.delete(n),this.Y.delete(n)&&i.Z)try{await h.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await h.Promises.close(n)}catch(t){throw this.gb(t)}finally{s&&(this.X.get(n)===s&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.X.delete(n)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const E=this.$(n,s);let S=null;try{S=(await h.Promises.read(n,t,r,a,E)).bytesRead}catch(P){throw this.gb(P)}finally{this.ab(n,E,S)}return S}$(n,s){return s===this.W.get(n)?null:s}ab(n,s,t){const r=this.W.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.W.set(n,r+t):this.W.delete(n)))}async write(n,s,t,r,a){return(0,j.$Hh)(()=>this.bb(n,s,t,r,a),100,3)}async bb(n,s,t,r,a){const E=this.$(n,s);let S=null;try{S=(await h.Promises.write(n,t,r,a,E)).bytesWritten}catch(P){throw await this.hb(this.Y.get(n),P)}finally{this.ab(n,E,S)}return S}async mkdir(n){try{await h.Promises.mkdir(this.I(n))}catch(s){throw this.gb(s)}}async delete(n,s){try{const t=this.I(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,k.$kc)((0,k.$nc)(t),`${(0,k.$oc)(t)}${s.atomic.postfix}`)),await h.Promises.rm(t,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:E,symbolicLink:S}=await h.SymlinkSupport.stat(t);a=E.isDirectory()&&!S}catch{}if(a)await h.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.gb(t)}}async rename(n,s,t){const r=this.I(n),a=this.I(s);if(r!==a)try{await this.cb(n,s,"move",t.overwrite),await h.Promises.rename(r,a)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(2,null,(0,k.$oc)(r),(0,k.$oc)((0,k.$nc)(a)),E.toString()))),this.gb(E)}}async copy(n,s,t){const r=this.I(n),a=this.I(s);if(r!==a)try{await this.cb(n,s,"copy",t.overwrite),await h.Promises.copy(r,a,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(3,null,(0,k.$oc)(r),(0,k.$oc)((0,k.$nc)(a)),E.toString()))),this.gb(E)}}async cb(n,s,t,r){const a=this.I(n),E=this.I(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,C.$mg)(a,E,!0)),S){if(t==="copy")throw(0,w.$7k)((0,b.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const y=await this.M(n);if(!y)throw(0,w.$7k)((0,b.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const p=await this.M(s);if(p){if(!r)throw(0,w.$7k)((0,b.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);y.type&w.FileType.File&&p.type&w.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.db(n,s,!1)}async db(n,s,t){const r=this.I(n),a=this.I(s),E=!!(this.capabilities&1024);if((0,C.$mg)(r,a,!E))return;const S=new m.$Tc;try{S.add(await this.P(n)),S.add(await this.P(s)),t&&await h.Promises.mkdir((0,k.$nc)(a),{recursive:!0}),await h.Promises.copyFile(r,a)}catch(P){if(P.code==="ENOENT"&&!t)return this.db(n,s,!0);throw this.gb(P)}finally{S.dispose()}}t(n,s,t){return new c.$Qq(r=>n(r),r=>s(r),t)}F(n,s,t){return new g.$Zq(r=>n(r),r=>s(r),t)}gb(n){if(n instanceof w.$6k)return n;let s=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$7k)(s,t)}async hb(n,s){let t=this.gb(s);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(n));r.mode&128||(t=(0,w.$7k)(s,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$1q=i}),define(le[99],he([0,1,3,2,4,9]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0,e.$odc=(0,j.$ni)("sharedProcessLifecycleService");let O=class extends N.$Uc{constructor(C){super(),this.b=C,this.a=this.B(new I.$_d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$pdc=O,e.$pdc=O=ve([Q(0,A.$Tj)],O)}),define(le[208],he([0,1,8,3,9,2]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=void 0;class O extends j.$5j{constructor(v,$,f,h,b){super($,f,h),this.r=v,this.t=b,this.B(b.listen("onDidChangeLogLevel",v)(w=>{(0,j.$Vj)(w)?super.setLogLevel(w):super.setLogLevel(I.URI.revive(w[0]),w[1])})),this.B(b.listen("onDidChangeVisibility",v)(([w,u])=>super.setVisibility(I.URI.revive(w),u))),this.B(b.listen("onDidChangeLoggers",v)(({added:w,removed:u})=>{for(const d of w)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new j.$3j({log:(v,$)=>{this.t.call("consoleLog",[v,$])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,$){super.setLogLevel(v,$),this.t.call("setLogLevel",[v,$])}setVisibility(v,$){super.setVisibility(v,$),this.t.call("setVisibility",[this.n(v),$])}s(v,$,f){return new R(this.t,v,$,f,this.r)}static setLogLevel(v,$,f){return v.call("setLogLevel",[$,f])}}e.$Zr=O;class R extends j.$Zj{constructor(v,$,f,h,b){super(h?.logLevel==="always"),this.r=v,this.s=$,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[$,h,b]).then(()=>{this.u(this.n),this.m=!0})}g(v,$){const f=[[v,$]];this.m?this.u(f):this.n.push(...f)}u(v){this.r.call("log",[this.s,v])}}class C{constructor(v,$){this.a=v,this.b=$}listen(v,$){const f=this.b(v);switch($){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(b=>this.c(b,f)),removed:[...h.removed].map(b=>this.c(b,f))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,h=>[f.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,h=>(0,j.$Vj)(h)?h:[f.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${$}`)}async call(v,$,f){const h=this.b(v);switch($){case"setLogLevel":return(0,j.$Vj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(I.URI.revive(h.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,h)))}throw new Error(`Call not found: ${$}`)}c(v,$){return{...v,resource:$.transformOutgoingURI(v.resource)}}}e.$1r=C;class m extends A.$Uc{constructor(v,$){super(),$.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(f=>$.call("setLogLevel",[f]))),$.call("getRegisteredLoggers").then(f=>{for(const h of f)v.registerLogger({...h,resource:I.URI.revive(h.resource)})}),this.B($.listen("onDidChangeVisibility")(([f,h])=>v.setVisibility(I.URI.revive(f),h))),this.B($.listen("onDidChangeLoggers")(({added:f,removed:h})=>{for(const b of f)v.registerLogger({...b,resource:I.URI.revive(b.resource)});for(const b of h)v.deregisterLogger(b.resource)}))}}e.$2r=m}),define(le[209],he([0,1,2,9]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=void 0;class j extends I.$Uc{constructor(O,R=[]){super(),this.a=new N.$4j([O,...R]),this.B(O.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$gQ=j}),define(le[57],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0,e.$kbc=(0,I.$ni)("nativeHostService")}),define(le[210],he([0,1,41,56]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;let j=class{constructor(O,R){return this.windowId=O,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const C=new Map;return C.set("windowId",O),C})()})}};e.$Fcc=j,e.$Fcc=j=ve([Q(1,N.$zcc)],j)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=void 0,e.$8n=(0,A.$ni)("policy");class O extends j.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$_d),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const k=Object.keys(this.f).length;return this.f={...m,...this.f},k!==Object.keys(this.f).length&&await this.j(m),N.Iterable.reduce(this.g.entries(),(v,[$,f])=>({...v,[$]:f}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(m,[k,v])=>({...m,[k]:{definition:v,value:this.g.get(k)}}),{})}}e.$9n=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$0n=R}),define(le[211],he([0,1,3,2,58]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=void 0;class A{constructor(C){this.b=C,this.a=new N.$Tc}listen(C,m){switch(m){case"onDidChange":return I.Event.map(this.b.onDidChange,k=>k.reduce((v,$)=>({...v,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(C,m,k){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(k)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.$8bc=A;class O extends j.$9n{constructor(C,m){super(),this.a=m;for(const k in C){const{definition:v,value:$}=C[k];this.f[k]=v,$!==void 0&&this.g.set(k,$)}this.a.listen("onDidChange")(k=>{for(const v in k){const $=k[v];$===null?this.g.delete(v):this.g.set(v,$)}this.h.fire(Object.keys(k))})}async j(C){const m=await this.a.call("updatePolicyDefinitions",C);for(const k in m)this.g.set(k,m[k])}}e.$9bc=O}),define(le[100],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.context<"u"){const A=j.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(le[24],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,I.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"}),define(le[212],he([0,1,6,7,2,14,31,9,24]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;let m=class extends j.$Uc{constructor(v,$,f){super(),this.b=$,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this.B(new I.$zh(()=>{this.f(v)},3e4)).schedule()}async f(v){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),f=(0,A.$nc)(v),h=(0,A.$oc)(v),b=await O.Promises.readdir(f);await Promise.all(b.map(async w=>{if(w===h)return;const u=(0,A.$kc)(f,w),d=await O.Promises.stat(u);if(d.isDirectory()&&$-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(u)}))}catch($){(0,N.$1)($)}}};e.$Ycc=m,e.$Ycc=m=ve([Q(1,C.$ak),Q(2,R.$Tj)],m)}),define(le[213],he([0,1,6,7,2,14,31,16,9,24]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;let k=class extends j.$Uc{constructor($,f,h){super(),this.b=$,this.c=f,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$zh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),f=JSON.parse(await O.Promises.readFile((0,A.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(f)){const l=f[d];$[`${l.hash}.${d}`]=!0}const h=(0,A.$kc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(h))return;const w=await O.Promises.readdir(h);for(const d of w){if($[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,A.$kc)(h,d))}const u=Date.now();for(const d of Object.keys($)){const l=(0,A.$kc)(h,d),c=await O.Promises.readdir(l);for(const g of c){if(g==="tcf.json")continue;const i=(0,A.$kc)(l,g),o=await O.Promises.stat(i);o.isDirectory()&&u-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$kc)(d,g)}`),await O.Promises.rm(i))}}}catch($){(0,N.$1)($)}}};e.$Zcc=k,e.$Zcc=k=ve([Q(0,R.$vi),Q(1,C.$Tj),Q(2,m.$ak)],k)}),define(le[214],he([0,1,14,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$ZF=void 0,e.$ZF=(0,N.$ni)("IV8InspectProfilingService");var j;(function(A){function O(C){return!!(C.samples&&C.timeDeltas)}A.isValidProfile=O;function R(C,m="noAbsolutePaths"){for(const k of C.nodes)k.callFrame&&k.callFrame.url&&((0,I.$jc)(k.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(k.callFrame.url))&&(k.callFrame.url=(0,I.$kc)(m,(0,I.$oc)(k.callFrame.url)));return C}A.rewriteAbsolutePaths=R})(j||(e.Utils=j={}))}),define(le[215],he([0,1,32]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((m,k)=>{se(["v8-inspect-profiler"],m,k)})).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),C=(0,I.$Jg)();return this.a.set(C,R),C}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const R=await O.stop();return this.a.delete(A),R.profile}}e.$edc=N}),define(le[42],he([0,1,127,13]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class j{constructor(){this.a=new Map}add(O,R){I.ok(N.$1f(O)),I.ok(N.$3f(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$6n=new j}),define(le[101],he([0,1,3,42]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function j(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new I.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,m){this.a[j(C)]=m,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$6n.add(e.$7n.JSONContribution,O)}),define(le[47],he([0,1,17,3,13,153,21,101,42]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=b,e.$ko=w,e.$lo=u,e.$mo=l,e.$no=c;var m;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$$n={Configuration:"base.contributions.configuration"};var k;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const v=C.$6n.as(R.$7n.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$_d,this.onDidSchemaChange=this.i.event,this.j=new N.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),v.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),v.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),v.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$io.test(r)){const a=this.a.get(r),E=a?.valuesSources??new Map;if(t)for(const p of Object.keys(s[r]))E.set(p,t);const S={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:S,valuesSources:E});const P=(0,O.$4i)(r),y={type:"object",default:S,description:A.localize(1,null,P),$ref:e.$fo,defaultDefaultValue:S,source:j.$1f(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=y,this.b.properties[r]=y}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=j.$1f(s)?s:s?.id,E=j.$1f(r?.source)?r?.source:r?.source?.id;if(a===E)if(o.add(t),this.a.delete(t),e.$io.test(t))delete this.d[t],delete this.b.properties[t];else{const S=this.d[t];S&&(this.w(t,S),this.r(t,S))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=j.$0f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const S in a){const P=a[S];if(o&&l(S,P)){delete a[S];continue}if(P.source=n,P.defaultDefaultValue=a[S].default,this.w(S,P),e.$io.test(S)?P.scope=void 0:(P.scope=j.$0f(P.scope)?t:P.scope,P.restricted=j.$0f(P.restricted)?!!s?.includes(S):P.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),r.add(S)}const E=i.allOf;if(E)for(const S of E)this.p(S,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$_n.properties[i]=o,o.scope){case 1:e.$ao.properties[i]=o;break;case 2:e.$bo.properties[i]=o;break;case 6:e.$co.properties[i]=o;break;case 3:e.$do.properties[i]=o;break;case 4:e.$eo.properties[i]=o;break;case 5:e.$eo.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$_n.properties[i],o.scope){case 1:delete e.$ao.properties[i];break;case 2:delete e.$bo.properties[i];break;case 6:delete e.$co.properties[i];break;case 3:delete e.$do.properties[i];break;case 4:case 5:delete e.$eo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$fo};this.w(o,n),e.$_n.properties[o]=n,e.$ao.properties[o]=n,e.$bo.properties[o]=n,e.$co.properties[o]=n,e.$do.properties[o]=n,e.$eo.properties[o]=n}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=i,e.$ao.patternProperties[e.$ho]=i,e.$bo.patternProperties[e.$ho]=i,e.$co.patternProperties[e.$ho]=i,e.$do.patternProperties[e.$ho]=i,e.$eo.patternProperties[e.$ho]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;j.$8f(s)&&(s=o.defaultDefaultValue,t=void 0),j.$8f(s)&&(s=u(o.type)),o.default=s,o.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",h=new RegExp(f,"g");e.$ho=`^(${f})+$`,e.$io=new RegExp(e.$ho);function b(g){const i=[];if(e.$io.test(g)){let o=h.exec(g);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=h.exec(g)}}return(0,I.$Mb)(i)}function w(g){return g.reduce((i,o)=>`${i}[${o}]`,"")}function u(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new $;C.$6n.add(e.$$n.Configuration,d);function l(g,i){return g.trim()?e.$io.test(g)?A.localize(7,null,g):d.getConfigurationProperties()[g]!==void 0?A.localize(8,null,g):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,g,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function c(){const g=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))g.push([o,i[o].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(le[76],he([0,1,17,3,34,2,35,30,13,8,21,47,42]),function(se,e,I,N,j,A,O,R,C,m,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=l;function f(o){return Object.isFrozen(o)?o:R.$Un(o)}class h{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof h)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,k.$2i)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return f(t.rawConfiguration.getValue(n))},get override(){return s?f(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return f(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:E,keys:S}of t.rawConfiguration.overrides){const P=new h(a,S).getValue(n);P!==void 0&&r.push({identifiers:E,value:P})}return r.length?f(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,k.$2i)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return I.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Tn(this.contents),t=R.$Tn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const E of n)if(a.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(s,E.contents);for(const S of E.overrides){const[P]=t.filter(y=>I.$ub(y.identifiers,S.identifiers));P?(this.h(P.contents,S.contents),P.keys.push(...S.keys),P.keys=I.$Mb(P.keys)):t.push(R.$Tn(S))}for(const S of E.keys)r.indexOf(S)===-1&&r.push(S)}return new h(s,r,t,a.every(E=>E instanceof h)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const E=s[r];E&&(typeof a=="object"&&typeof E=="object"?(a=R.$Tn(a),this.h(a,E)):a=E),t[r]=a}return new h(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&C.$3f(n[t])&&C.$3f(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Tn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Tn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,k.$1i)(this.contents,n),v.$io.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,v.$jo)(n))),1))}j(n,s,t){(0,k.$Zi)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),v.$io.test(n)&&this.overrides.push({identifiers:(0,v.$jo)(n),keys:Object.keys(this.contents[n]),contents:(0,k.$Yi)(this.contents[n],r=>console.error(r))})}}e.$oo=h;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!C.$0f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:E,hasExcludedProperties:S}=this.h(n,s);this.b=new h(t,r,a,S?[n]:void 0),this.c=E||[]}g(n){let s={},t=null,r=[];const a=[],E=[];function S(y){Array.isArray(r)?r.push(y):t!==null&&(r[t]=y)}const P={onObjectBegin:()=>{const y={};S(y),a.push(r),r=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const y=[];S(y),a.push(r),r=y,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:S,onError:(y,p,D)=>{E.push({error:y,offset:p,length:D})}};if(n)try{j.$Hn(n,P),s=r[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return s}h(n,s){const t=$.$6n.as(v.$$n.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,k.$Yi)(n,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),E=Object.keys(n),S=this.j(n,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:a,keys:E,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const E={},S=[];for(const P in n)if(v.$io.test(P)&&t){const y=this.i(n[P],s,!1,r);E[P]=y.raw,a=a||y.hasExcludedProperties,S.push(...y.restricted)}else{const y=s[P],p=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&S.push(P),!r.exclude?.includes(P)&&(r.include?.includes(P)||(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&!(r.skipRestricted&&y?.restricted))?E[P]=n[P]:a=!0}return{raw:E,restricted:S,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(v.$io.test(r)){const a={};for(const E in n[r])a[E]=n[r][E];t.push({identifiers:(0,v.$jo)(r),keys:Object.keys(a),contents:(0,k.$Yi)(a,s)})}return t}}e.$po=b;class w extends A.$Uc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new N.$_d),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new h}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=w;class u{constructor(n,s,t,r,a,E,S,P,y,p,D,z,F){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=E,this.g=S,this.h=P,this.i=y,this.j=p,this.k=D,this.l=z,this.m=F}get value(){return f(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(n,s,t,r,a=new h,E=new h,S=new O.$Bc,P=new h,y=new O.$Bc){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=E,this.j=S,this.l=P,this.m=y,this.a=null,this.b=new O.$Bc,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new h,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),E=s.resource?this.m.get(s.resource)||this.l:this.l,S=new Set;for(const P of r.overrides)for(const y of P.identifiers)r.getOverrideValue(n,y)!==void 0&&S.add(y);return new u(n,s,r.getValue(n),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,E)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:E}=g(this.c,n);s=[...r,...a,...E]}for(const r of s)for(const a of(0,v.$jo)(r)){const E=this.c.getKeysForOverrideIdentifier(a),S=n.getKeysForOverrideIdentifier(a),P=[...S.filter(y=>E.indexOf(y)===-1),...E.filter(y=>S.indexOf(y)===-1),...E.filter(y=>!R.$Xn(this.c.override(a).getValue(y),n.override(a).getValue(y)))];t.push([a,P])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=g(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.applicationConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateApplicationConfiguration(n),{keys:E,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.localUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateLocalUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.remoteUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateRemoteUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.workspaceConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateWorkspaceConfiguration(n),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:E,overrides:S}=g(t,s),P=[...r,...a,...E];return(P.length||!t)&&this.updateFolderConfiguration(n,s),{keys:P,overrides:S}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:E}=g(s,void 0);return{keys:[...t,...r,...a],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),E=this.w(n.workspace),S=n.folders.reduce((P,y)=>(P.set(m.URI.revive(y[0]),this.w(y[1])),P),new O.$Bc);return new d(s,t,r,a,new h,E,S,new h,new O.$Bc)}static w(n){return new h(n.contents,n.keys,n.overrides)}}e.$ro=d;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,E])=>{const S=(0,O.$yc)(s,a,new Set);E.forEach(P=>S.add(P))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const E of a)this.affectedKeys.add(E);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const E=this.d.charCodeAt(a);if(E!==this.b&&E!==this.c)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,P=this.g.getValue(n,s,this.h);return!R.$Xn(S,P)}return!0}}e.$to=c;function g(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],E=o?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const P=S.filter(y=>!E.includes(y));for(const y of P)a.push([y,n.getKeysForOverrideIdentifier(y)])}if(o){const P=E.filter(y=>!S.includes(y));for(const y of P)a.push([y,o.getKeysForOverrideIdentifier(y)])}if(n&&o){for(const P of E)if(S.includes(P)){const y=i({contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});a.push([P,[...y.added,...y.removed,...y.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const E=(0,k.$2i)(n.contents,a),S=(0,k.$2i)(o.contents,a);R.$Xn(E,S)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[216],he([0,1,17,3,2,30,13,76,47,9,58,42]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0;class $ extends j.$Uc{constructor(){super(...arguments),this.a=this.B(new N.$_d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$oo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$6n.as(C.$$n.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:u})=>this.c(Array.from(w),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,u){this.h(w,v.$6n.as(C.$$n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new R.$oo;const w=v.$6n.as(C.$$n.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,u){const d=this.f();for(const l of w){const c=d[l],g=u[l];c!==void 0?this.b.addValue(l,c):g?this.b.addValue(l,g.default):this.b.removeValue(l)}}}e.$uo=$;class f{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$oo}async initialize(){return this.configurationModel}}e.$vo=f;let h=class extends j.$Uc{get configurationModel(){return this.b}constructor(w,u,d){super(),this.c=w,this.f=u,this.g=d,this.a=this.B(new N.$_d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$oo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const u={},d=[],l=v.$6n.as(C.$$n.Configuration).getConfigurationProperties();for(const c of w){const g=l[c];if(!g){d.push(c);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}d.push(c),u[g.policy.name]={type:g.type}}}return(0,O.$bg)(u)||await this.f.updatePolicyDefinitions(u),d}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const u=v.$6n.as(C.$$n.Configuration).getPolicyConfigurations(),d=(0,I.$Hb)(w.map(l=>u.get(l)));this.m(d,!0)}m(w,u){this.g.trace("PolicyConfiguration#update",w);const d=v.$6n.as(C.$$n.Configuration).getConfigurationProperties(),l=[],c=this.b.isEmpty();for(const g of w){const i=d[g]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,A.$Xn)(this.b.getValue(g),o))&&l.push([g,o])}else this.b.getValue(g)!==void 0&&l.push([g,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const g=this.b;this.b=new R.$oo;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,o]of l)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);u&&this.a.fire(this.b)}}};e.$wo=h,e.$wo=h=ve([Q(1,k.$8n),Q(2,m.$Tj)],h)}),define(le[217],he([0,1,17,6,15,3,34,62,2,30,5,20,21,76,47,216,58]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0;class u extends C.$Uc{constructor(c,g,i,o){super(),this.m=c,this.h=this.B(new A.$_d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$uo),this.c=i instanceof w.$0n?new b.$vo:this.B(new b.$wo(this.b,i,o)),this.f=this.B(new f.$qo(this.m,{},v.$Rg,g)),this.a=new f.$ro(this.b.configurationModel,this.c.configurationModel,new f.$oo,new f.$oo),this.j=new d(c,g,this),this.g=this.B(new N.$zh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$ro(c,g,new f.$oo,i)}getConfigurationData(){return this.a.toData()}getValue(c,g){const i=typeof c=="string"?c:void 0,o=(0,$.$Ui)(c)?c:(0,$.$Ui)(g)?g:{};return this.a.getValue(i,o,void 0)}async updateValue(c,g,i,o,n){const s=(0,$.$Vi)(i)?i:(0,$.$Ui)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,I.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,m.$Xn)(g,r.defaultValue)&&(g=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const E=s.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(P=>(0,I.$ub)([...P.identifiers].sort(),E));S&&(s.overrideIdentifiers=S.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,h.$ko)(s.overrideIdentifiers),c]:[c];await this.j.write(a,g),await this.reloadConfiguration()}inspect(c,g={}){return this.a.inspect(c,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,g,2)}r(c,g){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,g);this.t(o,i,7)}s(c){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,g,7)}t(c,g,i){const o=new f.$to(c,{data:g},this.a);o.source=i,this.h.fire(o)}}e.$xo=u;class d{constructor(c,g,i){this.b=c,this.c=g,this.d=i,this.a=new N.$uh}write(c,g){return this.a.queue(()=>this.e(c,g))}async e(c,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,O.$An)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,g);i=(0,R.$Sn)(i,n),await this.c.writeFile(this.b,j.$ze.fromString(i))}f(c,g,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!g.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$Pn)(c,g,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=k.OS===3||k.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(c=g),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[218],he([0,1,15,3,2,68]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csb=e.$asb=e.$_rb=void 0,e.$bsb=R;const O=(m,k,v)=>{const $=new Uint8Array(16);for(let b=0;b<16;b++)$[b]=Math.round(Math.random()*256);const f=(0,I.$Te)(I.$ze.wrap($));return[`GET ws://localhost${m}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.$_rb=O,e.$asb=I.$ze.fromString(`\r
\r
`);async function R(m,k,v,$,f){m.write(I.$ze.fromString((0,e.$_rb)(k,v,$)));const h=new j.$Tc;try{return await new Promise((b,w)=>{let u;h.add(m.onData(d=>{u?u=I.$ze.concat([u,d],u.byteLength+d.byteLength):u=d;const l=u.indexOf(e.$asb);if(l===-1)return;b(m),m.pauseData();const c=u.slice(l+e.$asb.byteLength);c.byteLength&&f.onData.fire(c)})),h.add(m.onClose(d=>w(d??new Error("socket closed")))),h.add(m.onEnd(()=>w(new Error("socket ended"))))})}catch(b){throw m.dispose(),b}finally{h.dispose()}}class C extends j.$Uc{constructor(k,v){super(),this.g=k,this.a=this.B(new N.$ce),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$_d),this.onDidDispose=this.b.event,this.f=!1,this.B(v.onData),this.B(v.onData.event($=>this.a.fire($))),this.onClose=this.B(v.onClose).event,this.onEnd=this.B(v.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(k,v){A.SocketDiagnostics.traceSocketEvent(this,this.g,k,v)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$csb=C}),define(le[219],he([0,1,7,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.RemoteAuthorityResolverErrorCode=e.$Al=e.$zl=e.RemoteConnectionType=e.$yl=void 0,e.$Cl=m,e.$yl=(0,N.$ni)("remoteAuthorityResolverService");var j;(function(k){k[k.WebSocket=0]="WebSocket",k[k.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class A{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$zl=A;class O{constructor(v,$){this.host=v,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Al=O;var R;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound",k.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class C extends I.$bb{static isNotAvailable(v){return v instanceof C&&v._code===R.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof C&&v._code===R.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof C&&v._code===R.NoResolverFound}static isInvalidAuthority(v){return v instanceof C&&v._code===R.InvalidAuthority}static isHandled(v){return v instanceof C&&v.isHandled}constructor(v,$=R.Unknown,f){super(v),this._message=v,this._code=$,this._detail=f,this.isHandled=$===R.NotAvailable&&f===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Bl=C;function m(k){const v=k.indexOf("+");return v===-1?k:k.substring(0,v)}}),define(le[220],he([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Hl=E,e.$Il=S,e.$Jl=y;const h=30*1e3;var b;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function w(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const L=new j.$je;return setTimeout(()=>L.cancel(),U),L.token}function d(U,L){if(U.isCancellationRequested||L.isCancellationRequested)return j.CancellationToken.Cancelled;const T=new j.$je;return U.onCancellationRequested(()=>T.cancel()),L.onCancellationRequested(()=>T.cancel()),T.token}class l{get didTimeout(){return this.c==="timedout"}constructor(L){this.c="pending",this.d=new R.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$gh)(),L.isCancellationRequested?this.h():this.d.add(L.onCancellationRequested(()=>this.h()))}registerDisposable(L){this.c==="pending"?this.d.add(L):L.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(L))}reject(L){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(L))}}function c(U,L){const T=new l(L);return T.registerDisposable(U.onControlMessage(q=>{const x=JSON.parse(q.toString()),J=B(x);J?T.reject(J):T.resolve(x)})),T.promise}function g(U,L,T,q,x,J,ee,_){const Z=new l(_),ne=k.$8d.create(!1);return U.info(`Creating a socket (${ee})...`),m.mark(`code/willCreateSocket/${J}`),L.connect(T,q,x,ee).then(re=>{Z.didTimeout?(m.mark(`code/didCreateSocketError/${J}`),U.info(`Creating a socket (${ee}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(m.mark(`code/didCreateSocketOK/${J}`),U.info(`Creating a socket (${ee}) was successful after ${ne.elapsed()} ms.`),Z.resolve(re))},re=>{m.mark(`code/didCreateSocketError/${J}`),U.info(`Creating a socket (${ee}) returned an error after ${ne.elapsed()} ms.`),U.error(re),Z.reject(re)}),Z.promise}function i(U,L){const T=new l(L);return U.then(q=>{T.didTimeout||T.resolve(q)},q=>{T.didTimeout||T.reject(q)}),T.promise}async function o(U,L,T,q){const x=ce(U,L);U.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let J;try{J=await g(U.logService,U.remoteSocketFactoryService,U.connectTo,C.$Ag.getServerRootPath(),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,w(L),`renderer-${w(L)}-${U.reconnectionToken}`,q)}catch(re){throw U.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),U.logService.error(re),re}U.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,_;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(J,null),ee=U.reconnectionProtocol,_=!1):(ee=new $.$bi({socket:J}),_=!0),U.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await i(U.signService.createNewMessage((0,v.$Jg)()),q),ne={type:"auth",auth:U.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(N.$ze.fromString(JSON.stringify(ne)));try{const re=await c(ee,d(q,u(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(U.logService.trace(`${x} 4/6. received SignRequest control message.`),!await i(U.signService.validate(Z,re.signedData),q)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const de=await i(U.signService.sign(re.data),q),$e={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:L};return T&&($e.args=T),U.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$ze.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(U.logService.error(`${x} the handshake timed out. Error:`),U.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${x} received error control message when negotiating connection. Error:`),U.logService.error(re)),_&&W(ee),re}}async function n(U,L,T,q){const x=Date.now(),J=ce(U,L),{protocol:ee,ownsProtocol:_}=await o(U,L,T,q),Z=new l(q);return Z.registerDisposable(ee.onControlMessage(ne=>{const re=JSON.parse(ne.toString()),ue=B(re);ue?(U.logService.error(`${J} received error control message when negotiating connection. Error:`),U.logService.error(ue),_&&W(ee),Z.reject(ue)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${H(x)}!`),Z.resolve({protocol:ee,firstMessage:re}))})),Z.promise}async function s(U,L){const{protocol:T}=await n(U,1,void 0,L);return{protocol:T}}async function t(U,L,T){const{protocol:q,firstMessage:x}=await n(U,2,L,T),J=x&&x.debugPort;return{protocol:q,debugPort:J}}async function r(U,L,T){const q=Date.now(),x=ce(U,3),{protocol:J}=await o(U,3,L,T);return U.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${H(q)}!`),J}async function a(U,L,T){const{connectTo:q,connectionToken:x}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:q,connectionToken:x,reconnectionToken:L,reconnectionProtocol:T,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function E(U,L,T){return P(U,async q=>{const{protocol:x}=await s(q,j.CancellationToken.None);return new V(U,L,T,q.reconnectionToken,x)})}async function S(U,L){return P(U,async T=>{const{protocol:q,debugPort:x}=await t(T,L,j.CancellationToken.None);return new K(U,L,T.reconnectionToken,q,x)})}async function P(U,L){for(let q=1;;q++)try{const x=(0,v.$Jg)(),J=await a(U,x,null);return await L(J)}catch(x){if(q<5)U.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(x);else throw U.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(x),Y.triggerPermanentFailure(0,0,f.$Bl.isHandled(x)),x}}async function y(U,L,T){const q=await a(U,(0,v.$Jg)(),null);return await r(q,{host:L,port:T},j.CancellationToken.None)}function p(U){return(0,I.$ah)(L=>new Promise((T,q)=>{const x=setTimeout(T,U*1e3);L.onCancellationRequested(()=>{clearTimeout(x),T()})}))}var D;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(D||(e.PersistentConnectionEventType=D={}));class z{constructor(L,T){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.type=0}}e.$Kl=z;class F{constructor(L,T,q,x){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.durationSeconds=q,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.$Ll=F;class M{constructor(L,T,q){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=q,this.type=2}}e.$Ml=M;class X{constructor(L,T,q){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=q,this.type=4}}e.$Nl=X;class G{constructor(L,T,q,x){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=q,this.handled=x,this.type=3}}e.$Ol=G;class Y extends R.$Uc{static triggerPermanentFailure(L,T,q){this._permanentFailure=!0,this.f=L,this.g=T,this.h=q,this.j.forEach(x=>x.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(L=>L.y())}static debugPauseSocketWriting(){this.j.forEach(L=>L.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Y._permanentFailure}constructor(L,T,q,x,J){super(),this.t=L,this.u=T,this.reconnectionToken=q,this.protocol=x,this.w=J,this.m=this.B(new O.$_d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(x.onSocketClose(ee=>{const _=te(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(x.onSocketTimeout(ee=>{const _=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Y.j.push(this),this.B((0,R.$Sc)(()=>{const ee=Y.j.indexOf(this);ee>=0&&Y.j.splice(ee,1)})),this.n&&this.D(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const L=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const x=q<T.length?T[q]:T[T.length-1];try{if(x>0){const ee=p(x);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this.u.logService.info(`${L} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.u.logService.info(`${L} resolving connection...`);const J=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${L} connecting to ${J.connectTo}...`),await this.G(J,u(h)),this.u.logService.info(`${L} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.u.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(f.$Bl.isTemporarilyNotAvailable(J)){this.u.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,A.$4)(J)){this.u.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof f.$Bl){this.u.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,f.$Bl.isHandled(J));break}this.u.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.n&&!this.s)}C(L,T,q){this.w?Y.triggerPermanentFailure(L,T,q):this.D(L,T,q)}D(L,T,q){this.m.fire(new G(this.reconnectionToken,L,T,q)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Pl=Y;class V extends Y{constructor(L,T,q,x,J){super(1,L,x,J,!0),this.client=this.B(new $.$_h(J,{remoteAuthority:T,clientId:q},L.ipcLogger))}async G(L,T){await s(L,T)}}e.$Ql=V;class K extends Y{constructor(L,T,q,x,J){super(2,L,q,x,!1),this.H=T,this.debugPort=J}async G(L,T){await t(L,this.H,T)}}e.$Rl=K;function W(U){try{U.acceptDisconnect();const L=U.getSocket();U.dispose(),L.dispose()}catch(L){(0,A.$1)(L)}}function B(U){if(U&&U.type==="error"){const L=new Error(`Connection error: ${U.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function ie(U,L){for(;U.length<L;)U+=" ";return U}function ae(U,L){return`[remote-connection][${ie(w(U),13)}][${L.substr(0,5)}\u2026]`}function te(U,L,T){return`${ae(U,L)}[${T?"reconnect":"initial"}]`}function ce(U,L){return`${te(L,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function H(U){return`${Date.now()-U} ms`}}),define(le[102],he([0,1,23]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=N,e.$zm=j,e.$Am=A,e.$Bm=O;function N(C){return C.scheme===I.Schemas.vscodeRemote?C.authority:void 0}function j(C){if(!C)return;const m=C.indexOf("+");return m<0?C:C.substr(0,m)}function A(C){const{host:m,port:k}=R(C);if(typeof k>"u")throw new Error(`Invalid remote authority: ${C}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:m,port:k}}function O(C,m){let{host:k,port:v}=R(C);return typeof v>"u"&&(v=m),{host:k,port:v}}function R(C){const m=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const k=C.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=C.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:C,port:void 0}}}),define(le[48],he([0,1,27,4,102]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=A,e.$Lm=v,e.$Mm=$,e.$Nm=f,e.$Om=h,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class C{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,u){if(typeof w>"u"||w===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof w=="string"||typeof u=="string"){const d=typeof w=="string"?w:w.value,l=typeof u=="string"?u:u.value;return I.$qf(d,l)}return w._lower===u._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Im=C;class m{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const u of w)this.add(u)}add(w){this.c.add(C.toKey(w))}delete(w){return this.c.delete(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}}e.$Jm=m;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(C.toKey(w))}get(w){return this.c.get(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}set(w,u){this.c.set(C.toKey(w),u)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=k;function v(b){return $(b)}function $(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function h(b,w){if(w){const u=`onResolveRemoteAuthority:${(0,j.$zm)(w)}`;return!!b.activationEvents?.includes(u)}return!1}e.$Pm=(0,N.$ni)("IBuiltinExtensionsScannerService")}),define(le[221],he([0,1,2,48,12]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class A extends I.$Uc{constructor(R,C,m,k,v){super(),this.a=R,this.b=C,this.c=m,this.f=v,this.B(k.onDidInstallExtensions($=>this.g($))),this.B(k.onDidUninstallExtension($=>this.h($)))}g(R){for(const C of R)C.local&&this.invalidate(C.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,R)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$Cm))}catch(C){(0,j.$$k)(C)!==1&&this.f.error(C)}}}e.$sq=A}),define(le[103],he([0,1,2,4]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=void 0,e.$Dl=(0,N.$ni)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Sc)(()=>{const C=this.a[O]?.indexOf(R);typeof C=="number"&&C>=0&&this.a[O]?.splice(C,1)})}b(O){return(this.a[O.type]||[]).find(C=>C.supports(O))}connect(O,R,C,m){const k=this.b(O);if(!k)throw new Error(`No socket factory found for ${O}`);return k.connect(O,R,C,m)}}e.$El=j}),define(le[222],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0,e.$bdc=(0,I.$ni)("sharedProcessTunnelService"),e.$cdc="sharedProcessTunnel"}),define(le[104],he([0,1,4,169]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=e.$ldc=e.$kdc=e.$jdc=e.$idc=e.TunnelStates=e.$hdc=e.$gdc=void 0,e.$gdc=(0,I.$ni)("IRemoteTunnelService"),e.$hdc={active:!1};var j;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$idc="remote.tunnels.access",e.$jdc=e.$idc+".hostNameOverride",e.$kdc=e.$idc+".preventSleep",e.$ldc="remoteTunnelService",e.$mdc=(0,N.localize)(0,null)}),define(le[59],he([0,1,15,7,2,171,47,4,9,42]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0,e.$Gp=$,e.$Hp=f,e.$Ip=h,e.$Jp=b,e.$Kp=w,e.$Lp=u,e.$Ep=(0,R.$ni)("requestService");class k{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class v extends j.$Uc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,A.localize)(0,null),when:C.$_j.isEqualTo((0,C.$9j)(C.LogLevel.Trace)).serialize()})}async c(g,i,o){const n=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new k(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$0)(s)),s}}}e.$Fp=v;function $(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function f(c){return c.res.statusCode===204}async function h(c){return f(c)?null:(await(0,I.$Le)(c.stream)).toString()}async function b(c){if(!$(c))throw new Error("Server returned "+c.res.statusCode);return h(c)}async function w(c){if(!$(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const i=(await(0,I.$Le)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function u(c){l(c)}let d;function l(c){const g=m.$6n.as(O.$$n.Configuration),i=d;d={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:i?[i]:[]})}l(1)}),define(le[223],he([0,1,26,23,12,59]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;let O=class{constructor(C,m){this.a=C,this.b=m}async download(C,m,k=I.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,m);return}const v={type:"GET",url:C.toString(!0)},$=await this.a.request(v,k);if($.res.statusCode===200)await this.b.writeFile(m,$.stream);else{const f=await(0,A.$Jp)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${f}`)}}};e.$vQ=O,e.$vQ=O=ve([Q(0,A.$Ep),Q(1,j.$Tk)],O)}),define(le[224],he([0,1,15,26]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=void 0;class j{constructor(R){this.a=R}listen(R,C){throw new Error("Invalid listen")}call(R,C,m,k=N.CancellationToken.None){switch(C){case"request":return this.a.request(m[0],k).then(async({res:v,stream:$})=>{const f=await(0,I.$Le)($);return[{statusCode:v.statusCode,headers:v.headers},f]});case"resolveProxy":return this.a.resolveProxy(m[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Jr=j;class A{constructor(R){this.a=R}async request(R,C){const[m,k]=await this.a.call("request",[R],C);return{res:m,stream:(0,I.$Ne)(k)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Kr=A}),define(le[225],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=void 0,e.$Fbc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Gbc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Hbc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[226],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const A=await this.c();if(A){const O=String(I.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,A){if(!j.id)return!0;const O=this.b.get(j.id);if(!O)return!1;this.b.delete(j.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$z0b=I}),define(le[105],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=void 0,e.$Fl="signService",e.$Gl=(0,I.$ni)(e.$Fl)}),define(le[227],he([0,1,226]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class N extends I.$z0b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>se(["vsda"],A,O))}}e.$vcc=N}),define(le[77],he([0,1,3,2]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJb=e.$sJb=e.$rJb=e.$qJb=void 0;class j extends N.$Uc{constructor(v,$,f){super(),this.a=v,this.b=$,this.c=f}async getItems(){const v={profile:this.b,workspace:this.c},$=await this.a.call("getItems",v);return new Map($)}updateItems(v){const $={profile:this.b,workspace:this.c};return v.insert&&($.insert=Array.from(v.insert.entries())),v.delete&&($.delete=Array.from(v.delete.values())),this.a.call("updateItems",$)}optimize(){const v={profile:this.b,workspace:this.c};return this.a.call("optimize",v)}}class A extends j{constructor(v,$){super(v,$,void 0),this.f=this.B(new I.$_d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(v=>this.h(v)))}h(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this.f.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}}class O extends A{constructor(v){super(v,void 0)}async close(){this.dispose()}}e.$qJb=O;class R extends A{constructor(v,$){super(v,$)}async close(){this.dispose()}}e.$rJb=R;class C extends j{constructor(v,$){super(v,void 0,$),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$sJb=C;class m{constructor(v){this.a=v}isUsed(v){const $={payload:v,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$tJb=m}),define(le[106],he([0,1,5,36,32]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=O,e.$8o=R;function A(C){if(I.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function O(C,m,k,v,$,f,h,b,w){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=h,u.sessionID=(0,j.$Jg)()+Date.now(),u.commitHash=v,u.version=$,u["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,I.$h)(I.$u),u["common.nodePlatform"]=N.$ec,u["common.nodeArch"]=k,u["common.product"]=w||"desktop",b&&(u["common.msftInternal"]=b);let d=0;const l=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),I.$l&&(u["common.snap"]="true");const c=A(m);return c&&(u["common.platformDetail"]=c),u}function R(C){const m=N.env.USERDNSDOMAIN;if(!m)return!1;const k=m.toLowerCase();return C.some(v=>k===v)}}),define(le[22],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,I.$ni)("telemetryService"),e.$Tl=(0,I.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var j;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(le[228],he([0,1,37,6,34,23,14,5,8,144,31,150,94,12,24,22]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0,e.$ss=u,e.$ts=l,e.$us=c;const w=new Map;async function u(i,o){const n=`${i}::${o.join(":")}`,s=w.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,E=2e4;function S(y,p,D,z){const F=p.substring(y.length+1);return N.Promises.withAsyncBody(async M=>{let X;try{X=await k.Promises.readdir(p,{withFileTypes:!0})}catch{M();return}if(z.count>=E){z.count+=X.length,z.maxReached=!0,M();return}let G=X.length;if(G===0){M();return}let Y=X;z.count+X.length>E&&(z.maxReached=!0,G=E-z.count,Y=X.slice(0,G)),z.count+=X.length;for(const V of Y)if(V.isDirectory()){if(D.includes(V.name)||await S(y,(0,O.$kc)(p,V.name),D,z),--G===0){M();return}}else{const K=V.name.lastIndexOf(".");if(K>=0){const W=V.name.substring(K+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of t)W.relativePathPattern?.test(F)!==!1&&W.filePattern.test(V.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--G===0){M();return}}})}const P=N.Promises.withAsyncBody(async y=>{const p={count:0,maxReached:!1};await S(i,i,o,p);const D=await c(i);y({configFiles:d(a),fileTypes:d(r),fileCount:p.count,maxFilesReached:p.maxReached,launchConfigFiles:D})});return w.set(n,P),P}function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function l(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.$pl.GB).toFixed(2)}GB (${(I.freemem()/f.$pl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.$vn.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,O.$kc)(i,".vscode","launch.json"),s=await k.Promises.readFile(n),t=[],r=(0,j.$An)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$Jn)(r)==="object"&&r.configurations)for(const a of r.configurations){const E=a.type;E&&(o.has(E)?o.set(E,o.get(E)+1):o.set(E,1))}return d(o)}catch{return[]}}let g=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/f.$pl.GB).toFixed(2)}GB (${(I.freemem()/f.$pl.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(m.$vn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,v.$rs)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(E=>{if((0,$.$8m)(E))a+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(a+=`

Remote: ${E.hostName}`,E.processes&&(a+=`
${this.m(o,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const S of Object.keys(E.workspaceMetadata)){const P=E.workspaceMetadata[S];let y=`${P.fileCount} files`;P.maxFilesReached&&(y=`more than ${y}`),r+=`|    Folder (${S}): ${y}`,r+=this.h(P)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=l(),E={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(E.load=`${I.loadavg().map(S=>Math.round(S)).join(", ")}`),R.$k&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(o,n){const s=[];return(0,v.$rs)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,$.$8m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[a];let S=`${E.fileCount} files`;E.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${a}): ${S}`),s.push(this.h(E))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(P,y)=>{const p=` ${P}(${y})`;t+p.length>60?(n.push(a),a="|                 ",t=a.length):t+=p.length,a+=p};let a="|      File types:";const E=10,S=o.fileTypes.length>E?E:o.fileTypes.length;for(let P=0;P<S;P++){const y=o.fileTypes[P];r(y.name,y.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(P=>{r(P.name,P.count)}),n.push(a)),o.launchConfigFiles.length>0){let P="|      Launch Configs:";o.launchConfigFiles.forEach(y=>{const p=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;P+=p}),n.push(P)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=C.URI.revive(r);if(a.scheme===A.Schemas.file){const E=a.fsPath;s.push(u(E,["node_modules",".git"]).then(S=>{let P=`${S.fileCount} files`;S.maxFilesReached&&(P=`more than ${P}`),n.push(`|    Folder (${(0,O.$oc)(E)}): ${P}`),n.push(this.h(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${E} (${S.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let E;a?E=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?E=n.get(t.pid):E=`${"  ".repeat(r)} ${t.name}`;const S=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(S/f.$pl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(t.children)&&t.children.forEach(P=>this.n(o,n,s,P,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=C.URI.revive(s);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await u(r,["node_modules",".git"])).fileTypes.forEach(E=>n.add(E.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=C.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const t=s.fsPath;try{const r=await u(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$vs=g,e.$vs=g=ve([Q(0,b.$Sl),Q(1,h.$ak)],g)}),define(le[107],he([0,1,7,4,9,22]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0,e.$3p=(0,N.$ni)("IExtensionSignatureVerificationService");let O=class{constructor(C,m){this.b=C,this.c=m}d(){return this.a||(this.a=new Promise((C,m)=>se(["@vscode/vsce-sign"],async k=>C(k),m))),this.a}async verify(C,m,k){let v;try{v=await this.d()}catch(b){return this.b.error("Could not load vsce-sign module",(0,I.$0)(b)),!1}const $=new Date().getTime();let f,h;try{return f=await v.verify(C,m,k),f}catch(b){throw h=b,b}finally{const b=new Date().getTime()-$;this.c.publicLog2("extensionsignature:verification",{duration:b,verified:f,error:h?h.code??"unknown":void 0})}}};e.$4p=O,e.$4p=O=ve([Q(0,j.$Tj),Q(1,A.$Sl)],O)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;class I{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:R,data:C}){return this.b.forEach(m=>m.log(R,C)),Promise.resolve(null)}}e.$Kbc=I;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Lbc=N}),define(le[49],he([0,1,30,13,102,106,22]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=k,e.$ep=v,e.$fp=$,e.$gp=f,e.$hp=b,e.$ip=u,e.$jp=d,e.$kp=g;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$9o=R;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=C,e.$$o=new C;class m{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$_o=m,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function k(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function v(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function $(i){const o=i.getValue(O.$1l),n=i.getValue(O.$2l);if(i.getValue(O.$3l)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function f(i){const o={},n={},s={};w(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,j.$zm)(i);return h.has(o)?o:"other"}function w(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,I.$Yn)(r):r instanceof Date?o[a]=r.toISOString():(0,N.$3f)(r)?n<2?w(r,o,n+1,a+"."):o[a]=(0,I.$Yn)(r):o[a]=r}}function u(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,A.$8o)(n)||s}function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function l(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const E of o)for(;;){const S=E.exec(i);if(!S)break;s.push([S.index,E.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const E=r.exec(i);if(!E)break;const S=s.some(([P,y])=>E.index<y&&P<r.lastIndex);!t.test(E[0])&&!S&&(n+=i.substring(a,E.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function g(i,o){return(0,I.$Vn)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=l(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(le[33],he([0,1,27,29,48,5,8,7,36,49]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=k,e.$np=h,e.$op=b,e.$pp=w,e.$qp=u,e.$rp=d,e.$sp=l,e.$tp=c,e.$vp=g,e.$wp=o;function k(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$lf)(n.id,s.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new $(s.identifier,t,r)}static parse(s){const t=v.exec(s);return t&&t[1]&&t[2]?new $({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof $?k(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$mp=$;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(n){const s=f.exec(n);return s&&s[1]?[w(s[1]),s[2]]:[w(n),void 0]}function b(n,s){return`${n}.${s}`}function w(n){return n.toLowerCase()}function u(n,s){return w(b(n??j.$Em,s))}function d(n,s){const t=[],r=a=>{for(const E of t)if(E.some(S=>k(s(S),s(a))))return E;return null};for(const a of n){const E=r(a);E?E.push(a):t.push([a])}return t}function l(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new m.$9o(n.identifier.id),name:new m.$9o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$up=new j.$Im("pprice.better-merge");function g(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(E=>!k(E.identifier,{id:a}))){const E=n.filter(S=>k(S.identifier,{id:a}));E.length===1&&(t.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!A.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,N.$So)(t?"alpine":A.$u,C.$fc);return s.debug("ComputeTargetPlatform:",r),r}}),define(le[229],he([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=e.$I_b=void 0;let h=class extends N.$Uc{constructor(l,c){super(),this.b=l,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,g])=>this.a.set(g.configPath,g))}getConfigBasedTips(l){return this.f(l)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(l){const c=[];for(const[g,i]of this.a)if(!(i.configScheme&&i.configScheme!==l.scheme))try{const o=(await this.b.readFile((0,j.$1g)(l,g))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$I_b=h,e.$I_b=h=ve([Q(0,O.$Tk),Q(1,R.$ak)],h);const b="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class u extends h{constructor(l,c,g,i,o,n,s,t){super(s,t),this.r=l,this.s=c,this.t=g,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const E=[],S=[],P=[];Object.entries(a.recommendations).forEach(([y,p])=>{p.important?a.important?E.push({extensionId:y,extensionName:p.name,isExtensionPack:!!p.isExtensionPack}):S.push({extensionId:y,extensionName:p.name,isExtensionPack:!!p.isExtensionPack}):P.push({extensionId:y,extensionName:p.name,isExtensionPack:!!p.isExtensionPack})}),E.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),S.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),P.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:P})}),(0,C.$ph)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const l=await this.O(this.g),c=await this.O(this.h);return[...l,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const l=await this.O(this.g),c=await this.O(this.h),g=await this.u.getInstalled();this.m=this.D(l,g),this.n=this.D(c,g)}D(l,c){const g=new Map;l.forEach(t=>g.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...g.keys()],c);for(const t of i){const r=g.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=g.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=g.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[l,c]=[...this.m.entries()][0];this.H(c).then(g=>{switch(g){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(l);break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new N.$Vc);i.value=(0,C.$ph)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const l=this.I(),c=Date.now()-l,g=7*24*60*60*1e3;if(c<g){const n=this.B(new N.$Vc);n.value=(0,C.$ph)(()=>{n.dispose(),this.G()},g-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new N.$Vc);s.value=(0,C.$ph)(()=>{s.dispose(),this.G()},g);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=m.Event.once(m.Event.latch(m.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Vc);s.value=(0,C.$ph)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(l){const c=await this.u.getInstalled(1),g=l.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,f.$lp)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:g,source:3,name:l[0].exeFriendlyName,searchValue:`@exe:"${l[0].exeName}"`})}I(){let l=this.w.getNumber(w,-1);return l||(l=Date.now(),this.J(l)),l}J(l){this.w.store(w,l,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(l,c){const g=this.L();g[l]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify(g),-1,0)}N(l,c){const g=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return l.forEach(n=>{o.has(n.toLowerCase())?g.push(n):i.push(n)}),{installed:g,uninstalled:i}}async O(l){const c=[],g=new Map;for(const i of l.keys()){const o=l.get(i);if(!o||!(0,I.$Lb)(o.recommendations))continue;const n=[];v.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(n.push((0,k.$kc)("/usr/local/bin",i)),n.push((0,k.$kc)("/usr/bin",i)),n.push((0,k.$kc)(this.r.fsPath,i)));for(const s of n){let t=g.get(s);if(t===void 0&&(t=await this.b.exists(A.URI.file(s)),g.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:E,whenNotInstalled:S}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:E,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:S})}}return c}}e.$J_b=u}),define(le[230],he([0,1,26,33]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w3b=j;async function j(A,O,R,C,m){try{const k=await A.getExtensionsControlManifest();if(!k.deprecated)return;const v=await A.getInstalled(1);for(const[$,f]of Object.entries(k.deprecated)){if(!f?.extension)continue;const{id:h,autoMigrate:b,preRelease:w}=f.extension;if(!b)continue;const u=v.find(l=>(0,N.$lp)(l.identifier,{id:$}));if(!u)continue;const d=(await O.getExtensions([{id:h,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!d){m.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{m.info(`Migrating '${u.identifier.id}' extension to '${h}' extension...`);const l=!C.getDisabledExtensions().some(g=>(0,N.$lp)(g,u.identifier));await A.uninstall(u),m.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let c=v.find(g=>(0,N.$lp)(g.identifier,{id:h}));(!c||!c.isPreReleaseVersion&&l)&&(c=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${c.identifier.id}'`),l||(await C.disableExtension(c.identifier),m.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),b.storage&&(R.addToMigrationList((0,N.$op)(u.manifest.publisher,u.manifest.name),(0,N.$op)(c.manifest.publisher,c.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${u.identifier.id}' extension to '${h}' extension.`)}catch(l){m.error(l)}}}catch(k){m.error(k)}}}),define(le[231],he([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;let c=class extends j.$Uc{static{l=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,O.$1g)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new h.$Xo(r.message,h.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(a){const E=a;if(t=E.code,E.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${E.output}`),t===h.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===h.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(S){this.r.error(S)}throw new h.$Xo(v.$9p,h.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,C.$7f)(o)?o:!0}async u(i){await this.g;const o=(0,O.$1g)(this.extensionsDownloadDir,`${this.z(i)}${l.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new h.$Xo(n.message,h.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const s=(0,O.$1g)(this.extensionsDownloadDir,`.${(0,m.$Jg)()}`);await this.h.exists(s)||await n(s);try{await k.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(l.c))s.push(a.resource);else{const E=b.$mp.parse(a.name);E&&n.push([E,a])}const t=(0,b.$rp)(n,([a])=>a),r=[];for(const a of t)a.sort((E,S)=>R.rcompare(E[0].version,S[0].version)),o.push(...a.slice(1).map(E=>E[1].resource)),r.push(a[0][1]);r.sort((a,E)=>a.mtime-E.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await I.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$mp.create(i).toString().toLowerCase():(0,m.$Jg)()}};e.$pq=c,e.$pq=c=l=ve([Q(0,f.$vi),Q(1,u.$Tk),Q(2,h.$Wo),Q(3,$.$Ti),Q(4,w.$3p),Q(5,d.$Tj)],c)}),define(le[232],he([0,1,3,2,35,33,48]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;class R extends N.$Uc{constructor(m,k,v,$,f,h,b){super(),this.f=m,this.g=k,this.h=v,this.j=$,this.m=f,this.n=h,this.r=b,this.a=this.B(new I.$_d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$4c),this.s().then(null,w=>b.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(m=>this.u(m.added))),this.B(this.j.onAddExtensions(m=>this.w(m))),this.B(this.j.onDidAddExtensions(m=>this.y(m))),this.B(this.j.onRemoveExtensions(m=>this.z(m))),this.B(this.j.onDidRemoveExtensions(m=>this.C(m))),this.B(this.n.onDidFilesChange(m=>this.D(m)))}async u(m){try{m.length&&await Promise.all(m.map(k=>(this.c.set(k.id,(0,N.$Rc)(this.n.watch(this.m.extUri.dirname(k.extensionsResource)),this.n.watch(k.extensionsResource))),this.G(k.extensionsResource))))}catch(k){throw this.r.error(k),k}}async w(m){for(const k of m.extensions)this.I(this.L(k.identifier,k.version),m.profileLocation)}async y(m){for(const k of m.extensions){const v=this.L(k.identifier,k.version);m.error?this.J(v,m.profileLocation):this.I(v,m.profileLocation)}}async z(m){for(const k of m.extensions)this.J(this.L(k.identifier,k.version),m.profileLocation)}async C(m){const k=[],v=[];for(const $ of m.extensions){const f=this.L($.identifier,$.version);m.error?this.I(f,m.profileLocation):(this.J(f,m.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),v.push(this.f.scanInstalledExtensionAtLocation($.location).then(h=>{h?k.push(h):this.r.info("Extension not found at the location",$.location.toString())},h=>this.r.error(h)))))}try{await Promise.all(v),k.length&&await this.H(k)}catch($){this.r.error($)}}D(m){for(const k of this.h.profiles)m.contains(k.extensionsResource,0,1)&&this.F(k.extensionsResource)}async F(m){const k=[],v=[],$=await this.j.scanProfileExtensions(m),f=new Set,h=new Set;for(const[b,w]of this.b)w.has(m)&&h.add(b);for(const b of $){const w=this.L(b.identifier,b.version);f.add(w),h.has(w)||(k.push(b.identifier),this.I(w,m))}for(const b of h)if(!f.has(b)){const w=this.M(b);w&&(v.push(w.identifier),this.J(b,m))}(k.length||v.length)&&this.a.fire({added:k.length?{extensions:k,profileLocation:m}:void 0,removed:v.length?{extensions:v,profileLocation:m}:void 0})}async G(m){const k=await this.j.scanProfileExtensions(m);for(const v of k)this.I(this.L(v.identifier,v.version),m)}async H(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}I(m,k){let v=this.b.get(m);v||this.b.set(m,v=new j.$Cc($=>this.m.extUri.getComparisonKey($))),v.add(k)}J(m,k){const v=this.b.get(m);v&&v.delete(k),v?.size||this.b.delete(m)}L(m,k){return`${O.$Im.toKey(m.id)}@${k}`}M(m){const[k,v]=(0,A.$np)(m);return v?{identifier:{id:k},version:v}:void 0}}e.$tq=R}),define(le[233],he([0,1,45,49]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=j;async function j(A,O,R,C,m,k,v){const $={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$dp)(O,R)&&(0,N.$fp)(C)===3){const f=await(0,I.$Xp)(R,m,k);$["X-Market-User-Id"]=f,$["VSCode-SessionId"]=v.machineId||f}return $}}),define(le[234],he([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;let b=class extends f.$Hr{constructor(l,c,g,i){super(g),this.h=l,this.j=i,this.g=this.B(new w(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(l,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[l];return o?h.URI.file(o):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),c=Object.keys(l).map(g=>{const i=l[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((g,i)=>g.label.localeCompare(i.label)),c}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const c=await this.g.getLanguagePacks();Object.keys(c).some(g=>c[g]&&c[g].extensions.some(i=>(0,v.$lp)(i.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(c);return!(0,N.$ub)(Object.keys(l),Object.keys(g))}};e.$Ir=b,e.$Ir=b=ve([Q(0,k.$Zo),Q(1,m.$vi),Q(2,k.$Wo),Q(3,$.$Tj)],b);let w=class extends A.$Uc{constructor(l,c){super(),this.j=c,this.c={},this.f=(0,R.$kc)(l.userDataPath,"languagepacks.json"),this.g=new j.$uh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s(c=>{Object.keys(c).forEach(g=>delete c[g]),this.m(c,...l)}).then(()=>this.c)}m(l,...c){for(const g of c)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(l,g);Object.keys(l).forEach(g=>this.r(l[g]))}n(l,c){const g=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===O.Schemas.file&&u(o)){let n=l[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},l[o.languageId]=n);const s=n.extensions.filter(t=>(0,v.$lp)(t.extensionIdentifier,g))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:g,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$kc)(c.location.fsPath,t.path)}}r(l){if(l){const c=(0,I.createHash)("md5");for(const g of l.extensions)c.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);l.hash=c.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let c=null;return C.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(c=l(g),g)).then(g=>{for(const o of Object.keys(g))g[o]||delete g[o];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),C.Promises.writeFile(this.f,i)}).then(()=>c,g=>this.j.error(g))})}};w=ve([Q(0,m.$vi),Q(1,$.$Tj)],w);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const l of d.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(le[235],he([0,1,143,7,30,49]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function C(k,v,$){const f=await(0,I.$OD)("@microsoft/1ds-core-js","dist/ms.core.js"),h=await(0,I.$OD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new f.AppInsightsCore,w=new h.PostChannel,u={instrumentationKey:k,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if($){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:$};u.extensionConfig[w.identifier]=d}return b.initialize(u,[]),b.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),b}class m{constructor(v,$,f,h,b){this.e=v,this.f=$,this.g=f,this.h=b,this.c=O,this.d=R,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then($=>{v($)},$=>{(0,N.$1)($),console.error($)})}}log(v,$){if(!this.a)return;$=(0,j.$Wn)($,this.g),$=(0,A.$gp)($);const f=this.f+"/"+v;try{this.i(h=>{h.pluginVersionString=$?.properties.version??"Unknown",h.track({name:f,baseData:{name:f,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$6P=m}),define(le[109],he([0,1,2,172,16,9,24,49]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=void 0;let C=class extends I.$Uc{constructor(k,v,$,f,h=""){super(),this.b=h;const b=v.getLogger(R.$ap);if(b)this.a=this.B(b);else{const u=(0,R.$ep)(f,$)?" (Not Sent)":"",d=()=>(0,R.$dp)(f,$)&&k.getLevel()===A.LogLevel.Trace;this.a=this.B(v.createLogger(R.$ap,{name:(0,N.localize)(0,null,u),hidden:!d()})),this.B(k.onDidChangeLogLevel(()=>v.setVisibility(R.$ap,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(k,v){this.a.trace(`${this.b}telemetry/${k}`,(0,R.$gp)(v))}};e.$9$b=C,e.$9$b=C=ve([Q(0,A.$Tj),Q(1,A.$Uj),Q(2,j.$ui),Q(3,O.$ak)],C)}),define(le[110],he([0,1,2,30,5,27,173,21,47,100,24,42,22,49]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,l){this.k=d,this.l=l,this.d={},this.i=new I.$Tc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,A.$5e)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$5e)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration($.$1l)||c.affectsConfiguration($.$3l)||c.affectsConfiguration($.$2l))&&this.m()}))}setExperimentProperty(u,d){this.d[u]=d}m(){let u=(0,f.$fp)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const l=d.usage?3:d.error?2:0;u=Math.min(u,l)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,d,l){this.g<d||(l=(0,N.$Wn)(l,this.d),l=(0,f.$kp)(l,this.j),l=(0,N.$Wn)(l,this.c),this.b.forEach(c=>c.log(u,l)))}publicLog(u,d){this.n(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this.h&&this.n(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.$Or=h,e.$Or=h=ve([Q(1,R.$Ti),Q(2,k.$ak)],h);function b(){const w=(0,O.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=j.$o?"":(0,O.localize)(3,null),l=(0,O.localize)(4,null),c=(0,O.localize)(5,null),g=(0,O.localize)(6,null),i=(0,O.localize)(7,null),o=`
|       | ${l} | ${c} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${w} ${u} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}v.$6n.as(C.$$n.Configuration).registerConfiguration({id:$.$Zl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[$.$1l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$6n.as(C.$$n.Configuration).registerConfiguration({id:$.$Zl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[$.$3l]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,O.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,O.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${$.$1l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[236],he([0,1,15,26,278,235]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;async function O(k,v){const $=await v.request(k,N.CancellationToken.None),f=(await(0,I.$Le)($.stream)).toString(),h=$.res.statusCode??200;return{headers:$.res.headers,statusCode:h,responseData:f}}async function R(k){const v={method:k.type,headers:k.headers};return new Promise((f,h)=>{const b=j.request(k.url??"",v,w=>{w.on("data",function(u){f({headers:w.headers,statusCode:w.statusCode??200,responseData:u.toString()})}),w.on("error",function(u){h(u)})});b.write(k.data,w=>{w&&h(w)}),b.end()})}async function C(k,v,$){const f=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),h={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:f};try{const b=k?await O(h,k):await R(h);$(b.statusCode,b.headers,b.responseData)}catch{$(0,{})}}class m extends A.$6P{constructor(v,$,f,h,b){const w={sendPOST:(u,d)=>{C(v,u,d)}};super($,f,h,b,w)}}e.$7P=m}),define(le[237],he([0,1,23,92,21,16,9,24,22,108,109,110]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;let $=class{constructor(h,b,w,u,d,l){this.b=h,this.c=b,this.d=w,this.e=u,this.f=d,this.g=l,this.a=new Map}h(h){if(!this.a.has(h.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const w=[h.id,JSON.stringify(b),h.aiKey],d=new N.$Pq(I.$Hg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new m.$Lbc(d),new k.$9$b(this.d,this.e,this.f,this.g,`[${h.id}] `)];this.a.set(h.id,new v.$Or({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.g))}return this.a.get(h.id)}publicLog(h,b,w){this.h(h).publicLog(b,w)}publicLogError(h,b,w){this.h(h).publicLogError(b,w)}};e.$6cc=$,e.$6cc=$=ve([Q(0,j.$Ti),Q(1,C.$Sl),Q(2,O.$Tj),Q(3,O.$Uj),Q(4,A.$ui),Q(5,R.$ak)],$)}),define(le[78],he([0,1,3,8,21,4,9]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$9v=e.$7v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$3v=e.$2v=void 0,e.$4v=m,e.$5v=v,e.$6v=$,e.$8v=f,e.$0v=h,e.$$v=b,e.$2v=(0,A.$ni)("tunnelService"),e.$3v=(0,A.$ni)("sharedTunnelsService");var R;(function(d){d.Http="http",d.Https="https"})(R||(e.TunnelProtocol=R={}));var C;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(C||(e.TunnelPrivacyId=C={}));function m(d){return!!d.forwardPort}var k;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function v(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(l)return{address:l[1],port:+l[2]}}function $(d){if(d.scheme!=="http"&&d.scheme!=="https"||!d.query)return;const l=d.query.split("&");for(const c of l){const g=c.split("=")[1];if(/^https?:/.exec(g)){const i=v(N.URI.parse(g));if(i)return i}}}e.$7v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(d){return e.$7v.indexOf(d)>=0}e.$9v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(d){return e.$9v.indexOf(d)>=0}function b(d,l,c,g){if(c===1)return!1;if(c===2&&h(l)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(i?.length===4&&parseInt(i[1])>=18)return!1}return d<1024}class w{constructor(l,c,g){this.remoteAddress=l,this.localAddress=c,this.b=g,this.a=new I.$_d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_v=w;let u=class{constructor(l,c){this.k=l,this.l=c,this.a=new I.$_d,this.onTunnelOpened=this.a.event,this.b=new I.$_d,this.onTunnelClosed=this.b.event,this.c=new I.$_d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],c=Array.from(this.e.values());for(const g of c){const i=Array.from(g.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&l.push(n)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:c}of l.values())await c.then(g=>typeof g!="string"?g?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,c,g,i,o){this.q(l,c,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:c,localAddress:g,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,c){(h(l)||f(l))&&(l=e.$7v[0]);const g=this.s(l,c);if(g)return++g.refcount,g.value}openTunnel(l,c,g,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${o}.`);const r=this.f??l;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(g)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,g,i,o,n,s,t);return a?a.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,g),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,g);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(E);return(E.tunnelRemoteHost!==c||E.tunnelRemotePort!==g)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&E.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this.e.get(l.tunnelRemoteHost);if(c){const g=c.get(l.tunnelRemotePort);g&&(g.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,g))}}}}async p(l,c,g){if(g.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const i=g.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(c),i}}async closeTunnel(l,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const g=this.e.get(l);if(g&&g.has(c)){const i=g.get(c);i.refcount=0,await this.p(l,c,i)}}q(l,c,g){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(c,{refcount:1,value:g})}async r(l,c){const g=this.e.get(l);if(g){const i=g.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&g.delete(c),g.size===0&&this.e.delete(l)}}s(l,c){const g=[l];f(l)?(g.push(...e.$7v),g.push(...e.$9v)):h(l)&&g.push(...e.$9v);const i=g.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(l){return!!v(l)}u(l,c,g,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${i}.`);const t=g;this.j.add(t);const r=i===void 0?g:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},E={remoteAddress:{host:c,port:g},localAddressPort:i,privacy:n,public:n?n!==C.Private:void 0,protocol:s},S=l.forwardPort(E,a);return S?(this.q(c,g,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),S}};e.$aw=u,e.$aw=u=ve([Q(0,O.$Tj),Q(1,j.$Ti)],u)}),define(le[238],he([0,1,9,78,2,7,6]),function(se,e,I,N,j,A,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class C extends j.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Kh),this.b.p)}setAddress(v){this.a=v,this.b&&(this.b.complete(v),this.b=null)}setTunnel(v){this.B(v)}}let m=class extends j.$Uc{static{R=this}static{this.a=0}constructor(v,$){super(),this.f=v,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(v=>v.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(v,$,f,h,b,w,u){const d=new C,l=await Promise.resolve(this.f.openTunnel(v,d,f,h,b,w,u));if(!l||typeof l=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${h} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),d.dispose(),await l.dispose(),(0,A.$6)();return d.setTunnel(l),this.b.set($,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${l.localAddress} (local) to ${f}:${h} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(v,$){const f=this.b.get(v);f&&f.setAddress($)}async destroyTunnel(v){const $=this.b.get(v);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${v}.`),this.b.delete(v),await $.dispose();return}this.c.add(v)}};e.$ddc=m,e.$ddc=m=R=ve([Q(0,N.$3v),Q(1,I.$Tj)],m)}),define(le[28],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=void 0,e.$rl=(0,I.$ni)("IUriIdentityService")}),define(le[239],he([0,1,28,191,12,20,128,3,2]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0;class m{static{this._clock=0}constructor($){this.uri=$,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let k=class{constructor($){this.g=$,this.c=new C.$Tc,this.f=2**16;const f=new Map,h=b=>{let w=f.get(b.scheme);return w===void 0&&(w=$.hasProvider(b)&&!this.g.hasCapability(b,1024),f.set(b.scheme,w)),w};this.c.add(R.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new A.$Pg(h),this.d=new O.$ns((b,w)=>this.extUri.compare(b,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,A.$2g)($));const f=this.d.get($);return f?f.touch().uri.with({fragment:$.fragment}):(this.d.set($,new m($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((h,b)=>h[1].time<b[1].time?1:h[1].time>b[1].time?-1:0);m._clock=0,this.d.clear();const f=this.f*.5;for(let h=0;h<f;h++)this.d.set($[h][0],$[h][1].touch())}};e.$os=k,e.$os=k=ve([Q(0,j.$Tk)],k),(0,N.$ls)(I.$rl,k,1)}),define(le[240],he([0,1,3,2,12,51,35]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class R extends N.$Uc{constructor(m,k,v,$,f,h){super(),this.f=m,this.g=k,this.h=v,this.j=$,this.m=f,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$_d),this.onDidChangeFile=this.a.event,this.b=A.$ti.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Cc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const m of this.j.profiles)this.c.add(m.settingsResource),this.c.add(m.keybindingsResource),this.c.add(m.tasksResource),this.c.add(m.extensionsResource)}open(m,k){return this.g.open(this.t(m),k)}close(m){return this.g.close(m)}read(m,k,v,$,f){return this.g.read(m,k,v,$,f)}write(m,k,v,$,f){return this.g.write(m,k,v,$,f)}watch(m,k){this.b.set(m,m);const v=this.g.watch(this.t(m),k);return(0,N.$Sc)(()=>{this.b.delete(m),v.dispose()})}stat(m){return this.g.stat(this.t(m))}mkdir(m){return this.g.mkdir(this.t(m))}rename(m,k,v){return this.g.rename(this.t(m),this.t(k),v)}readFile(m,k){return this.g.readFile(this.t(m),k)}readFileStream(m,k,v){return this.g.readFileStream(this.t(m),k,v)}readdir(m){return this.g.readdir(this.t(m))}enforceAtomicReadFile(m){return this.c.has(m)}writeFile(m,k,v){return this.g.writeFile(this.t(m),k,v)}enforceAtomicWriteFile(m){return this.c.has(m)?{postfix:".vsctmp"}:!1}delete(m,k){return this.g.delete(this.t(m),k)}copy(m,k,v){if((0,j.$Xk)(this.g))return this.g.copy(this.t(m),this.t(k),v);throw new Error("copy not supported")}cloneFile(m,k){if((0,j.$Yk)(this.g))return this.g.cloneFile(this.t(m),this.t(k));throw new Error("clone not supported")}s(m){const k=[];for(const v of m){if(v.resource.scheme!==this.f)continue;const $=this.u(v.resource);this.b.findSubstr($)&&k.push({resource:$,type:v.type,cId:v.cId})}k.length&&(this.n.debug("User data changed"),this.a.fire(k))}t(m){return m.with({scheme:this.f})}u(m){return m.with({scheme:this.h})}}e.$ycc=R}),define(le[79],he([0,1,62]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$9Ib=j,e.$0Ib=A;function N(O,R,C,m){const k=(0,I.$Pn)(O,R,C,m)[0];return k&&(O=O.substring(0,k.offset)+k.content+O.substring(k.offset+k.length)),O}function j(O,R,C){let m=C;for(;m>=0;){if(O.charAt(m)===R.charAt(R.length-1)&&R.length===1)return m+1;if(m--,R.length===2&&m>=0&&O.charAt(m)===R.charAt(0))return m+2}return 0}function A(O,R,C){let m=C;for(;m>=0;)if(O.charAt(m)===R.charAt(R.length-1)&&R.length===1||(m++,R.length===2&&m>=0&&O.charAt(m)===R.charAt(1)))return m;return O.length-1}}),define(le[241],he([0,1,30,55,13]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=A;function A(f,h,b,w,u,d){const l=[],c=[],g=[];if(!h){const M=f.filter(({identifier:X})=>u.every(G=>G.toLowerCase()!==X.id.toLowerCase()));return{local:{added:l,removed:c,updated:g},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}f=f.map(v),h=h.map(v),b=b?b.map(v):null;const i=new Map,o=M=>{M.uuid&&i.set(M.id.toLowerCase(),M.uuid)};f.forEach(({identifier:M})=>o(M)),h.forEach(({identifier:M})=>o(M)),b?.forEach(({identifier:M})=>o(M)),w?.forEach(({identifier:M})=>o(M)),d?.forEach(M=>o(M));const n=M=>{const X=M.identifier.uuid||i.get(M.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${M.identifier.id.toLowerCase()}`},s=(M,X)=>(M.set(n(X),X),M),t=f.reduce(s,new Map),r=h.reduce(s,new Map),a=h.reduce((M,X)=>s(M,(0,I.$Tn)(X)),new Map),E=b?b.reduce(s,new Map):null,S=w.reduce(s,new Map),P=u.reduce((M,X)=>{const G=i.get(X.toLowerCase());return M.add(G?`uuid:${G}`:`id:${X.toLowerCase()}`)},new Set),y=d?d.reduce((M,{id:X,uuid:G})=>(G=G??i.get(X.toLowerCase()),M.add(G?`uuid:${G}`:`id:${X.toLowerCase()}`)),new Set):null,p=O(t,r,P,!1);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const M=O(E,t,P,!1),X=O(E,r,P,!0),G=(Y,V,K,W)=>{let B,ie,ae;return V.installed?(B=W.pinned,ae=W.preRelease,B&&(ie=W.version)):(B=K.pinned,ae=K.preRelease,B&&(ie=K.version)),B===void 0&&(B=V.pinned,B&&(ie=V.version)),ae===void 0&&(ae=V.preRelease),{...W,installed:V.installed||K.installed,pinned:B,preRelease:ae,version:ie??(K.version&&(!V.installed||N.gt(K.version,V.version))?K.version:V.version),state:C(V,K,E?.get(Y))}};for(const Y of X.removed.values()){const V=t.get(Y);if(!V)continue;const K=(0,j.$_f)(E?.get(Y)),W=y&&!y.has(Y)&&K.installed;V.installed&&W?c.push(V.identifier):a.set(Y,V)}for(const Y of X.added.values()){const V=(0,j.$_f)(r.get(Y)),K=t.get(Y);if(K){if(p.updated.has(Y)){const W=G(Y,K,V,V);R(K,V,!1,!1)||g.push($(W,Y)),a.set(Y,W)}}else V.installed&&l.push($(V,Y))}for(const Y of X.updated.values()){const V=(0,j.$_f)(r.get(Y)),K=(0,j.$_f)(E?.get(Y)),W=t.get(Y);if(W)if(y&&!y.has(Y)&&K.installed&&W.installed&&!V.installed)c.push(W.identifier);else{const ie=G(Y,W,V,V);g.push($(ie,Y)),a.set(Y,ie)}else V.installed&&l.push($(V,Y))}for(const Y of M.added.values())X.added.has(Y)||a.set(Y,(0,j.$_f)(t.get(Y)));for(const Y of M.updated.values()){if(X.removed.has(Y)||X.updated.has(Y))continue;const V=(0,j.$_f)(t.get(Y)),K=(0,j.$_f)(r.get(Y));a.set(Y,G(Y,V,K,V))}for(const Y of M.removed.values())X.updated.has(Y)||X.removed.has(Y)||S.has(Y)||(0,j.$_f)(r.get(Y)).installed&&y&&(y.has(Y)||!(0,j.$_f)(E?.get(Y)).installed||a.delete(Y))}const D=[],z=O(r,a,new Set,!0),F=z.added.size>0||z.updated.size>0||z.removed.size>0;return F&&a.forEach((M,X)=>D.push($(M,X))),{local:{added:l,removed:c,updated:g},remote:F?{added:[...z.added].map(M=>a.get(M)),updated:[...z.updated].map(M=>a.get(M)),removed:[...z.removed].map(M=>r.get(M)),all:D}:null}}function O(f,h,b,w){const u=f?[...f.keys()].filter(i=>!b.has(i)):[],d=[...h.keys()].filter(i=>!b.has(i)),l=d.filter(i=>!u.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=u.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),g=new Set;for(const i of u){if(c.has(i))continue;const o=f.get(i),n=h.get(i);(!n||!R(o,n,w,!0))&&g.add(i)}return{added:l,removed:c,updated:g}}function R(f,h,b,w){return!(f.disabled!==h.disabled||!!f.isApplicationScoped!=!!h.isApplicationScoped||w&&f.installed!==h.installed||f.installed&&h.installed&&(f.preRelease!==h.preRelease||f.pinned!==h.pinned||h.pinned&&f.version!==h.version)||!k(f.state,h.state)||b&&f.version!==h.version)}function C(f,h,b){const w=f.state,u=h.state,d=b?.state;if(!h.version||w&&N.gt(f.version,h.version))return w;if(u&&N.gt(h.version,f.version)||!w)return u;if(!u)return w;const l=(0,I.$Tn)(w),c=d?m(d,u):{added:Object.keys(u).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},g=d?m(d,w):{added:Object.keys(w).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])l[i]=u[i];for(const i of c.removed.values())g.updated.has(i)||delete l[i];return l}function m(f,h){const b=Object.keys(f),w=Object.keys(h),u=w.filter(c=>!b.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),d=b.filter(c=>!w.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),l=new Set;for(const c of b){if(d.has(c))continue;const g=f[c],i=h[c];(0,I.$Xn)(g,i)||l.add(c)}return{added:u,removed:d,updated:l}}function k(f={},h={}){const{added:b,removed:w,updated:u}=m(f,h);return b.size===0&&w.size===0&&u.size===0}function v(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function $(f,h){const b={...f,identifier:{id:f.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete b.disabled,f.installed||delete b.installed,f.state||delete b.state,f.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fLb=e.$eLb=void 0,e.$eLb=(0,j.$ni)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(k=>k.toLowerCase());return m=m.filter(k=>k!==R&&k!==`-${R}`),C&&m.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(R,C){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(k=>k.toLowerCase());return m=m.filter(k=>k!==R&&k!==`-${R}`),C&&m.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(R){const C=R.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),m=this.b().map($=>$.toLowerCase()),k=[],v=[];if(Array.isArray(m))for(const $ of m)$.startsWith("-")?v.push($.substring(1)):k.push($);return(0,I.$Mb)([...C,...k].filter($=>!v.includes($)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$fLb=A,e.$fLb=A=ve([Q(0,N.$Ti)],A)}),define(le[242],he([0,1,17,34,30,93,79]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=C;function R(c){return(0,N.$An)(c)||[]}async function C(c,g,i,o,n){const s=R(c),t=R(g),r=i?R(i):null,a=[...s,...t,...r||[]].map(G=>G.key),E=await n.resolveUserBindings(a),S=k(s,t,r,E);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const P=$(s),y=$(t),p=r?$(r):null,D=h(P,y,E),z=p?h(p,P,E):{added:[...P.keys()].reduce((G,Y)=>(G.add(Y),G),new Set),removed:new Set,updated:new Set},F=p?h(p,y,E):{added:[...y.keys()].reduce((G,Y)=>(G.add(Y),G),new Set),removed:new Set,updated:new Set},M=m(D,z,F);let X=c;for(const G of M.removed.values())M.conflicts.has(G)||(X=d(X,G,o));for(const G of M.added.values()){if(M.conflicts.has(G))continue;const Y=y.get(G);if(Y.some(V=>V.command!==`-${G}`&&S.conflicts.has(E[V.key]))){M.conflicts.add(G);continue}X=u(X,Y,o)}for(const G of M.updated.values()){if(M.conflicts.has(G))continue;const Y=y.get(G);if(Y.some(V=>V.command!==`-${G}`&&S.conflicts.has(E[V.key]))){M.conflicts.add(G);continue}X=l(X,G,Y,o)}return{mergeContent:X,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function m(c,g,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of g.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(g.updated.has(r)?t.add(r):n.add(r));for(const r of g.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(g.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of g.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(g.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function k(c,g,i,o){const n=new Set,s=v(c,o),t=v(g,o),r=i?v(i,o):null,a=f(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const E=r?f(r,s):{added:[...s.keys()].reduce((z,F)=>(z.add(F),z),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=r?f(r,t):{added:[...t.keys()].reduce((z,F)=>(z.add(F),z),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:P,removed:y,updated:p,conflicts:D}=m(a,E,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:y,updated:p,conflicts:D}}function v(c,g){const i=new Map;for(const o of c){const n=g[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function $(c){const g=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=g.get(o);n||(n=[],g.set(o,n)),n.push(i)}return g}function f(c,g){const i=[...c.keys()],o=[...g.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(S=>({...S,key:r})),E=g.get(r).map(S=>({...S,key:r}));(0,I.$ub)(a,E,(S,P)=>w(S,P))||t.add(r)}return{added:n,removed:s,updated:t}}function h(c,g,i){const o=[...c.keys()],n=[...g.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const E=c.get(a).map(P=>({...P,key:i[P.key]})),S=g.get(a).map(P=>({...P,key:i[P.key]}));b(E,S)||r.add(a)}return{added:s,removed:t,updated:r}}function b(c,g){return!(!(0,I.$ub)(c.filter(({command:i})=>i[0]!=="-"),g.filter(({command:i})=>i[0]!=="-"),(i,o)=>w(i,o))||!(0,I.$ub)(c.filter(({command:i})=>i[0]==="-"),g.filter(({command:i})=>i[0]==="-"),(i,o)=>w(i,o)))}function w(c,g){if(c.command!==g.command||c.key!==g.key)return!1;const i=A.$lj.deserialize(c.when),o=A.$lj.deserialize(g.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!j.$Xn(c.args,g.args))}function u(c,g,i){for(const o of g)c=O.edit(c,[-1],o,i);return c}function d(c,g,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===g||o[n].command===`-${g}`)&&(c=O.edit(c,[n],void 0,i));return c}function l(c,g,i,o){const n=R(c),s=n.findIndex(t=>t.command===g||t.command===`-${g}`);for(let t=n.length-1;t>=0;t--)(n[t].command===g||n[t].command===`-${g}`)&&(c=O.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=O.edit(c,[s],i[t],o);return c}}),define(le[243],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=I,e.$10b=j;function I(A,O,R){const C={},m={},k=new Set;if(!O)return{local:{added:C,updated:m,removed:[...k.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const v=N(A,O);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:C,updated:m,removed:[...k.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=N(R,A),f=N(R,O),h={},b={},w=new Set,u=new Set;for(const d of $.removed.values())f.updated.has(d)?C[d]=O[d]:w.add(d);for(const d of f.removed.values())u.has(d)||($.updated.has(d)?u.add(d):k.add(d));for(const d of $.updated.values())u.has(d)||(f.updated.has(d)?v.updated.has(d)&&u.add(d):b[d]=A[d]);for(const d of f.updated.values())u.has(d)||($.updated.has(d)?v.updated.has(d)&&u.add(d):A[d]!==void 0&&(m[d]=O[d]));for(const d of $.added.values())u.has(d)||(f.added.has(d)?v.updated.has(d)&&u.add(d):h[d]=A[d]);for(const d of f.added.values())u.has(d)||($.added.has(d)?v.updated.has(d)&&u.add(d):C[d]=O[d]);return{local:{added:C,removed:[...k.values()],updated:m},remote:{added:h,removed:[...w.values()],updated:b},conflicts:[...u.values()]}}function N(A,O){const R=A?Object.keys(A):[],C=O?Object.keys(O):[],m=C.filter($=>!R.includes($)).reduce(($,f)=>($.add(f),$),new Set),k=R.filter($=>!C.includes($)).reduce(($,f)=>($.add(f),$),new Set),v=new Set;for(const $ of R){if(k.has($))continue;const f=A[$],h=O[$];f!==h&&v.add($)}return{added:m,removed:k,updated:v}}function j(A,O){const{added:R,removed:C,updated:m}=N(A,O);return R.size===0&&C.size===0&&m.size===0}}),define(le[244],he([0,1,30]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=N;function N(A,O,R,C){const m={added:[],removed:[],updated:[]};let k={added:[],removed:[],updated:[]};if(!O){const $=A.filter(({id:f})=>!C.includes(f));return $.length?k.added=$:k=null,{local:m,remote:k}}const v=j(A,O,C);if(v.added.length>0||v.removed.length>0||v.updated.length>0){const $=j(R,A,C),f=j(R,O,C);for(const h of f.removed){const b=A.find(w=>w.id===h);b&&m.removed.push(b)}for(const h of f.added){const b=O.find(w=>w.id===h);$.added.includes(h)?v.updated.includes(h)&&m.updated.push(b):m.added.push(b)}for(const h of f.updated)m.updated.push(O.find(b=>b.id===h));for(const h of $.added)f.added.includes(h)||k.added.push(A.find(b=>b.id===h));for(const h of $.updated)f.removed.includes(h)||f.updated.includes(h)||k.updated.push(A.find(b=>b.id===h));for(const h of $.removed){const b=O.find(w=>w.id===h);b&&k.removed.push(b)}}return k.added.length===0&&k.removed.length===0&&k.updated.length===0&&(k=null),{local:m,remote:k}}function j(A,O,R){A=A?A.filter(({id:f})=>!R.includes(f)):[],O=O.filter(({id:f})=>!R.includes(f));const C=A.map(({id:f})=>f),m=O.map(({id:f})=>f),k=m.filter(f=>!C.includes(f)),v=C.filter(f=>!m.includes(f)),$=[];for(const{id:f,name:h,shortName:b,icon:w,useDefaultFlags:u}of A){if(v.includes(f))continue;const d=O.find(l=>l.id===f);(!d||d.name!==h||d.shortName!==b||d.icon!==w||!(0,I.$Xn)(d.useDefaultFlags,u))&&$.push(f)}return{added:k,removed:v,updated:$}}}),define(le[25],he([0,1,17,13,179,47,29,4,101,42]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qzb=e.$Pzb=e.$Ozb=e.$Nzb=e.$Mzb=e.$Lzb=e.$Kzb=e.$Jzb=e.$Izb=e.$Gzb=e.MergeState=e.Change=e.SyncStatus=e.$Fzb=e.$Ezb=e.$Dzb=e.UserDataSyncErrorCode=e.$Bzb=e.$Azb=e.$zzb=e.$yzb=e.$xzb=e.$uzb=e.SyncResource=e.$rzb=e.$qzb=void 0,e.$ozb=k,e.$pzb=v,e.$szb=$,e.$tzb=f,e.$vzb=b,e.$wzb=w,e.$Czb=u,e.$Hzb=s;function k(){const t=m.$6n.as(A.$$n.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function v(){const t=m.$6n.as(A.$$n.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(S=>!!t[S].ignoreSync),a=Object.keys(t).filter(S=>t[S].scope===2||t[S].scope===6),E=k();return(0,I.$Mb)([...r,...a,...E])}e.$qzb="settingsSync",e.$rzb="settingsSync.keybindingsPerPlatform";function $(){const t="vscode://schemas/ignoredSettings",r=m.$6n.as(A.$$n.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$rzb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:O.$Ko,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.$6n.as(C.$7n.JSONContribution),E=()=>{const S=k(),P=v(),y=Object.keys(A.$_n.properties).filter(z=>!P.includes(z)),p=P.filter(z=>!S.includes(z)),D={items:{type:"string",enum:[...y,...p.map(z=>`-${z}`)]}};a.registerSchema(t,D)};return r.onDidUpdateConfiguration(()=>E())}function f(t){return t&&(0,N.$3f)(t)&&(0,N.$1f)(t.id)&&Array.isArray(t.scopes)}var h;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(h||(e.SyncResource=h={})),e.$uzb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}function w(t,r,a,E){return E.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$xzb=(0,R.$ni)("IUserDataSyncStoreManagementService"),e.$yzb=(0,R.$ni)("IUserDataSyncStoreService"),e.$zzb=(0,R.$ni)("IUserDataSyncLocalStoreService"),e.$Azb="x-operation-id",e.$Bzb="X-Execution-Id";function u(t){const r={};return r[e.$Bzb]=t,r}var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class l extends Error{constructor(r,a,E,S){super(r),this.code=a,this.resource=E,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Dzb=l;class c extends l{constructor(r,a,E,S,P){super(r,E,void 0,P),this.url=a,this.serverCode=S}}e.$Ezb=c;class g extends l{constructor(r,a){super(r,a)}}e.$Fzb=g,function(t){function r(a){if(a instanceof t)return a;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(E&&E[1]){const S=E[2]==="unknown"?void 0:E[2],P=E[3]==="unknown"?void 0:E[3];return new t(a.message,E[1],S,P)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(l||(e.$Dzb=l={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Gzb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Izb=(0,R.$ni)("IUserDataSyncEnablementService"),e.$Jzb=(0,R.$ni)("IUserDataSyncService"),e.$Kzb=(0,R.$ni)("IUserDataSyncResourceProviderService"),e.$Lzb=(0,R.$ni)("IUserDataAutoSyncService"),e.$Mzb=(0,R.$ni)("IUserDataSyncUtilService"),e.$Nzb=(0,R.$ni)("IUserDataSyncLogService"),e.$Ozb="userDataSync",e.$Pzb="vscode-userdata-sync",e.$Qzb="preview"}),define(le[245],he([0,1,30,25]),function(se,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wKb=j;function j(O,R,C,m,k){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const v=A(O,R);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=C?A(C,R):{added:Object.keys(R).reduce((d,l)=>(d.add(l),d),new Set),removed:new Set,updated:new Set},f=C?A(C,O):{added:Object.keys(O).reduce((d,l)=>(d.add(l),d),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},b=I.$Tn(R),w=!C;for(const d of f.added.values())d!==N.$Gzb&&w&&$.added.has(d)||(b[d]=O[d]);for(const d of f.updated.values())b[d]=O[d];for(const d of f.removed.values())m.unregistered.includes(d)||delete b[d];for(const d of $.added.values()){const l=R[d];if(m.machine.includes(d)){k.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(C&&f.added.has(d))continue;const c=O[d];c&&c.value===l.value||d===N.$Gzb&&w&&f.added.has(d)||(c?h.updated[d]=l:h.added[d]=l)}for(const d of $.updated.values()){const l=R[d];if(m.machine.includes(d)){k.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(d)||f.removed.has(d))continue;const c=O[d];c&&c.value===l.value||(h.updated[d]=l)}for(const d of $.removed.values()){if(m.machine.includes(d)){k.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}f.updated.has(d)||f.removed.has(d)||h.removed.push(d)}const u=A(R,b);return{local:h,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:b}}}function A(O,R){const C=Object.keys(O),m=Object.keys(R),k=m.filter(f=>!C.includes(f)).reduce((f,h)=>(f.add(h),f),new Set),v=C.filter(f=>!m.includes(f)).reduce((f,h)=>(f.add(h),f),new Set),$=new Set;for(const f of C){if(v.has(f))continue;const h=O[f],b=R[f];I.$Xn(h,b)||$.add(f)}return{added:k,removed:v,updated:$}}}),define(le[246],he([0,1,17,34,62,43,30,79,25]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Ib=m,e.$_Ib=$,e.$aJb=f,e.$bJb=h,e.$cJb=w,e.$dJb=d;function m(a,E,S){let P=[];S?P=v(S):P=k(E);const y=[],p=[...(0,C.$ozb)()];if(Array.isArray(P))for(const D of P)D.startsWith("-")?p.push(D.substring(1)):y.push(D);return(0,I.$Mb)([...a,...y].filter(D=>!p.includes(D)))}function k(a){let E=a.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=a.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:a.getValue("settingsSync.ignoredSettings")||[]}function v(a){const E=(0,N.$An)(a);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function $(a,E){const S=(0,N.$An)(a)||{};let P="{}";for(const y of Object.keys(S)){const p=(0,j.$Pn)(P,[y],S[y],E);P=(0,j.$Sn)(P,p)}return P}function f(a,E,S,P){if(S.length){const y=r(E),p=(0,N.$An)(E)||{},D=(0,N.$An)(a);if(!D)return a;const z=[];for(const F of S){const M=p[F],X=D[F];M===void 0?a=R.edit(a,[F],void 0,P):X!==void 0?a=R.edit(a,[F],M,P):z.push(i(F,y))}z.sort((F,M)=>F.startOffset-M.startOffset),z.forEach(F=>a=d(F.setting.key,E,a,P))}return a}function h(a,E,S,P,y,p){const D=f(a,E,P,p),z=S!==D,F=S!==E;if(!z&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!F)return{conflictsSettings:[],localContent:null,remoteContent:D,hasConflicts:!1};if(F&&!z)return{conflictsSettings:[],localContent:f(E,a,P,p),remoteContent:null,hasConflicts:!1};if(S===null&&w(a)){const T=b(a,E,P)?null:f(E,a,P,p);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let M=a,X=E;const G=(0,N.$An)(a),Y=(0,N.$An)(E),V=S?(0,N.$An)(S):null,K=P.reduce((T,q)=>(T.add(q),T),new Set),W=u(G,Y,K),B=u(V,G,K),ie=u(V,Y,K),ae=new Map,te=new Set,ce=T=>{te.add(T);const q=y.filter(({key:x})=>x===T)[0];q?(M=R.edit(M,[T],q.value,p),X=R.edit(X,[T],q.value,p)):ae.set(T,{key:T,localValue:G[T],remoteValue:Y[T]})};for(const T of B.removed.values())ie.updated.has(T)?ce(T):X=R.edit(X,[T],void 0,p);for(const T of ie.removed.values())te.has(T)||(B.updated.has(T)?ce(T):M=R.edit(M,[T],void 0,p));for(const T of B.updated.values())te.has(T)||(ie.updated.has(T)?W.updated.has(T)&&ce(T):X=R.edit(X,[T],G[T],p));for(const T of ie.updated.values())te.has(T)||(B.updated.has(T)?W.updated.has(T)&&ce(T):M=R.edit(M,[T],Y[T],p));for(const T of B.added.values())te.has(T)||(ie.added.has(T)?W.updated.has(T)&&ce(T):X=d(T,M,X,p));for(const T of ie.added.values())te.has(T)||(B.added.has(T)?W.updated.has(T)&&ce(T):M=d(T,X,M,p));const H=ae.size>0||!b(M,X,P),U=H||!b(M,a,[]),L=H||!b(X,E,[]);return{localContent:U?M:null,remoteContent:L?X:null,conflictsSettings:[...ae.values()],hasConflicts:H}}function b(a,E,S){if(a===E)return!0;const P=(0,N.$An)(a),y=(0,N.$An)(E),p=S.reduce((F,M)=>(F.add(M),F),new Set),D=r(a).filter(F=>!(F.setting&&p.has(F.setting.key))),z=r(E).filter(F=>!(F.setting&&p.has(F.setting.key)));if(D.length!==z.length)return!1;for(let F=0;F<D.length;F++){const M=D[F],X=z[F];if(M.setting&&X.setting){if(M.setting.key!==X.setting.key||!O.$Xn(P[M.setting.key],y[M.setting.key]))return!1}else if(!M.setting&&!X.setting){if(M.value!==X.value)return!1}else return!1}return!0}function w(a){return a?r(a).length===0:!0}function u(a,E,S){const P=a?Object.keys(a).filter(F=>!S.has(F)):[],y=Object.keys(E).filter(F=>!S.has(F)),p=y.filter(F=>!P.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),D=P.filter(F=>!y.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),z=new Set;if(a)for(const F of P){if(D.has(F))continue;const M=a[F],X=E[F];O.$Xn(M,X)||z.add(F)}return{added:p,removed:D,updated:z}}function d(a,E,S,P){const y=(0,N.$An)(E),p=r(E),D=r(S),z=l(a,p,D);return c(S,a,y[a],z,D,P)}function l(a,E,S){const P=E.findIndex(p=>p.setting?.key===a),y=E[P-1];if(y){if(y.setting){const D=i(y.setting.key,S);if(D)return{index:S.indexOf(D),insertAfter:!0}}else{const D=o(P,E);if(D){const z=i(D.setting.key,S);if(z){const F=n(S.indexOf(z),S),M=s(E,D,E[P]);if(F){const X=s(S,z,F),G=t(M,X);return G?{index:S.indexOf(G),insertAfter:!0}:{index:S.indexOf(F),insertAfter:!1}}else{const X=s(S,z,S[S.length-1]),G=t(M,X);return G?{index:S.indexOf(G),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const p=E[P+1];if(p)if(p.setting){const D=i(p.setting.key,S);if(D)return{index:S.indexOf(D),insertAfter:!1}}else{const D=n(P,E);if(D){const z=i(D.setting.key,S);if(z){const F=o(S.indexOf(z),S),M=s(E,E[P],D);if(F){const X=s(S,F,z),G=t(M.reverse(),X.reverse());return G?{index:S.indexOf(G),insertAfter:!1}:{index:S.indexOf(F),insertAfter:!0}}else{const X=s(S,S[0],z),G=t(M.reverse(),X.reverse());return G?{index:S.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function c(a,E,S,P,y,p){let D;return P.index===-1?D=(0,j.$Pn)(a,[E],S,p):D=g(a,E,S,P,y,p).map(z=>(0,j.$Qn)(a,z,p)[0]),(0,j.$Sn)(a,D)}function g(a,E,S,P,y,p){const D=`${JSON.stringify(E)}: ${JSON.stringify(S)}`,z=(0,A.$Mn)(p,a),F=y[P.index];if(P.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+D});else{const X=n(P.index,y),G=o(P.index,y),Y=G?.setting?.commaOffset;G&&Y===void 0&&M.push({offset:G.endOffset,length:0,content:","});const V=Y!==void 0&&Y>F.endOffset;M.push({offset:V?Y+1:F.endOffset,length:0,content:X?z+D+",":z+D})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:D+","}];const M=(y[P.index-1]&&!y[P.index-1].setting?z:"")+D+(n(P.index,y)?",":"")+z;return[{offset:F.startOffset,length:0,content:M}]}}function i(a,E){return E.filter(S=>S.setting?.key===a)[0]}function o(a,E){for(let S=a-1;S>=0;S--)if(E[S].setting)return E[S]}function n(a,E){for(let S=a+1;S<E.length;S++)if(E[S].setting)return E[S]}function s(a,E,S){const P=a.indexOf(E),y=a.indexOf(S);return a.filter((p,D)=>P<D&&D<y)}function t(a,E){if(a.length&&E.length){let S=0;for(;S<E.length&&S<a.length;S++)if(a[S].value!==E[S].value)return E[S-1];return E[S-1]}}function r(a){const E=[];let S=-1,P,y;const p={onObjectBegin:D=>{S++},onObjectProperty:(D,z,F)=>{S===0&&(P=z,y=D)},onObjectEnd:(D,z)=>{S--,S===0&&E.push({startOffset:P,endOffset:D+z,value:a.substring(P,D+z),setting:{key:y,commaOffset:void 0}})},onArrayBegin:(D,z)=>{S++},onArrayEnd:(D,z)=>{S--,S===0&&E.push({startOffset:P,endOffset:D+z,value:a.substring(P,D+z),setting:{key:y,commaOffset:void 0}})},onLiteralValue:(D,z,F)=>{S===0&&E.push({startOffset:P,endOffset:z+F,value:a.substring(P,z+F),setting:{key:y,commaOffset:void 0}})},onSeparator:(D,z,F)=>{if(S===0&&D===","){let M=E.length-1;for(;M>=0&&!E[M].setting;M--);const X=E[M];X&&E.splice(M,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:z}})}},onComment:(D,z)=>{S===0&&E.push({startOffset:D,endOffset:D+z,value:a.substring(D,D+z)})}};return(0,N.$Hn)(a,p),E}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TIb=e.$SIb=void 0,e.$SIb=(0,j.$ni)("IUserDataSyncAccountService");let O=class extends N.$Uc{get account(){return this.a}constructor(C,m){super(),this.g=C,this.h=m,this.b=this.B(new I.$_d),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$_d),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(k=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,k),this.updateAccount(void 0),k==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$TIb=O,e.$TIb=O=ve([Q(0,A.$yzb),Q(1,A.$Nzb)],O)}),define(le[247],he([0,1,20,180,16,9,25]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gLb=void 0;let R=class extends A.$Yj{constructor(m,k){super(),this.g=this.B(m.createLogger((0,I.$1g)(k.logsHome,`${O.$Ozb}.log`),{id:O.$Ozb,name:(0,N.localize)(0,null)}))}trace(m,...k){this.g.trace(m,...k)}debug(m,...k){this.g.debug(m,...k)}info(m,...k){this.g.info(m,...k)}warn(m,...k){this.g.warn(m,...k)}error(m,...k){this.g.error(m,...k)}flush(){this.g.flush()}};e.$gLb=R,e.$gLb=R=ve([Q(0,A.$Uj),Q(1,j.$ui)],R)}),define(le[248],he([0,1,6,3,2]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class A extends j.$Uc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:C,getActiveWindowId:m}){super(),this.a=this.B(new j.$Tc),N.Event.latch(N.Event.any(R,C))(this.f,this,this.a),this.b=(0,I.$ah)(()=>m()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$6bc=A}),define(le[112],he([0,1,183,14,51,20,8,4,23]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=m,e.$yi=k,e.$Bi=v,e.$Ci=$,e.$Di=f,e.$Ei=b,e.$Fi=w,e.$Ii=l,e.$Ni=c,e.$Oi=g,e.$Qi=i,e.$Ri=o,e.$Si=n,e.$wi=(0,R.$ni)("contextService");function m(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}function k(s){return typeof s?.id=="string"&&!m(s)&&!$(s)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function v(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:t?e.$zi:e.$Ai;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function $(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}function f(s){const t=s;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function w(s){const t=s;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class u{constructor(t,r,a,E,S){this.h=t,this.j=a,this.k=E,this.l=S,this.c=j.$ti.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=j.$ti.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=u;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$1g)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=d;function l(s){return new d({uri:s,index:0,name:(0,A.$Wg)(s)},{uri:s.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,I.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function c(s,t){return A.$Rg.isEqualOrParent(s,t.untitledWorkspacesHome)}function g(s){let t;return O.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===C.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Pi}function o(s,t){return!c(s,t)&&!g(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,A.$Yg)(s))===e.$Ki}}),define(le[18],he([0,1,54,3,2,20,8,174,16,12,4,9,112,35,28,6,32,27,13]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$tl=e.ProfileResourceType=void 0,e.$sl=c,e.$ul=g,e.$vl=i;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$tl=(0,k.$ni)("IUserDataProfilesService");function g(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:t}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,E,S){return{id:s,name:t,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:S&&E?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.$1g)(r,"globalStorage"),settingsResource:S&&E?.useDefaultFlags?.settings?S.settingsResource:(0,A.$1g)(r,"settings.json"),keybindingsResource:S&&E?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.$1g)(r,"keybindings.json"),tasksResource:S&&E?.useDefaultFlags?.tasks?S.tasksResource:(0,A.$1g)(r,"tasks.json"),snippetsHome:S&&E?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.$1g)(r,"snippets"),extensionsResource:S&&E?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.$1g)(r,"extensions.json"),cacheHome:(0,A.$1g)(a,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let o=class extends j.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,E){super(),this.t=t,this.u=r,this.w=a,this.y=E,this.f=!0,this.h=this.B(new N.$_d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$_d),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$_d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$_d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$1g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$1g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,d.$1f)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}r.push(i((0,A.$Xg)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},t))}}catch(S){this.y.error(S)}const a=new f.$Bc,E=new Map;if(r.length)try{const S=this.Q();if(S.workspaces)for(const[P,y]of Object.entries(S.workspaces)){const p=O.URI.parse(P),D=r.find(z=>z.id===y);D&&a.set(p,D)}if(S.emptyWindows)for(const[P,y]of Object.entries(S.emptyWindows)){const p=r.find(D=>D.id===y);p&&E.set(P,p)}}catch(S){this.y.error(S)}this.z={profiles:r,workspaces:a,emptyWindows:E}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,u.$5e)(r)}\\s(\\d+)`);let E=0;for(const P of this.profiles){const y=a.exec(P.name),p=y?parseInt(y[1]):0;E=p>E?p:E}const S=`${r} ${E+1}`;return this.createProfile((0,I.$bj)((0,w.$Jg)()).toString(16),S,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,I.$bj)((0,w.$Jg)()).toString(16),t,r,a)}async createProfile(t,r,a,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(t,r,a);return E&&await this.setProfileForWorkspace(E,S),S}async F(t,r,a){if(!(0,d.$1f)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{if(this.profiles.find(p=>p.name===r||p.id===t))throw new Error(`Profile with ${r} name already exists`);const P=i(t,r,(0,A.$1g)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(P.location);const y=[];return this.j.fire({profile:P,join(p){y.push(p)}}),await b.Promises.settled(y),this.I([P],[],[]),P}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(E=>E.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(E){a.push(E)}});try{await Promise.allSettled(a)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,m.$$k)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(E=>E.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,$.$xi)(t)?t.uri:(0,$.$Ci)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const E=[...this.profiles,...t],S=[];this.s.profiles=[];for(let P of E)P.isDefault||r.some(y=>P.id===y.id)||(P=a.find(y=>P.id===y.id)??P,P.isTransient?this.s.profiles.push(P):S.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.P(S),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const E=this.G(t),S=a?this.s:this.C;O.URI.isUri(E)?(S.workspaces.delete(E),r&&S.workspaces.set(E,r)):(S.emptyWindows.delete(E),r&&S.emptyWindows.set(E,r)),a||this.M()}M(){const t={};for(const[a,E]of this.C.workspaces.entries())t[a.toString()]=E.id;const r={};for(const[a,E]of this.C.emptyWindows.entries())r[a.toString()]=E.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[S,P]of Object.entries(t.workspaces)){const y=O.URI.parse(P);r[S]=this.w.extUri.isEqual(y,a.location)?a.id:this.w.extUri.basename(y)}const E={};if(t.emptyWindows)for(const[S,P]of Object.entries(t.emptyWindows)){const y=O.URI.parse(P);E[S]=this.w.extUri.isEqual(y,a.location)?a.id:this.w.extUri.basename(y)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$wl=o,e.$wl=o=ve([Q(0,C.$ui),Q(1,m.$Tk),Q(2,h.$rl),Q(3,v.$Tj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$xl=n}),define(le[249],he([0,1,6,2,18]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;let A=class extends N.$Uc{constructor(R){super(),this.B(new I.$zh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$fdc=A,e.$fdc=A=ve([Q(0,j.$tl)],A)}),define(le[250],he([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$bq=void 0,e.$cq=g,e.$dq=i;let c=class extends R.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,E,S,P){super(),this.z=t,this.C=r,this.D=a,this.F=E,this.G=S,this.H=P,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$_d),this.s=this.B(new O.$_d),this.t=this.B(new O.$_d),this.u=this.B(new O.$_d),this.w=this.B(new O.$_d),this.y=[],this.B((0,R.$Sc)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.m.forEach(y=>y.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,$.$Uo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const E=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:S})=>(0,f.$lp)(S,t.identifier));if(E?.local)return E?.local;throw E?.error?E.error:new $.$Xo(`Unknown error while installing extension ${t.identifier.id}`,$.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new $.$Xo(v.localize(0,null),$.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:E,options:S})=>{try{const P=await this.N(E,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});a.push({...P,options:S})}catch(P){r.push({identifier:E.identifier,operation:2,source:E,error:P})}})),a.length&&r.push(...await this.I(a));for(const E of r)E.error&&(this.F.error("Failed to install extension.",E.identifier.id),this.F.error(E.error),E.source&&!k.URI.isUri(E.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$tp)(E.source),error:E.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,h.$Lm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const E of this.H.profiles){const S=(await this.getInstalled(1,E.extensionsResource)).find(P=>(0,f.$lp)(P.identifier,t.identifier));S?this.w.fire(S):this.u.fire({identifier:t.identifier,profileLocation:E.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=new Map,a=new Map,E=[],S=(y,p)=>`${f.$mp.create(y).toString()}-${p.toString()}`,P=(y,p,D,z)=>{const F=this.Y(y,p,D),M=`${(0,f.$qp)(y.publisher,y.name)}-${D.profileLocation.toString()}`;a.set(M,{task:F,root:z}),this.n.fire({identifier:F.identifier,source:p,profileLocation:D.profileLocation}),this.F.info("Installing extension:",F.identifier.id),k.URI.isUri(p)||this.j.set(S(p,D.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:y,extension:p,options:D}of t){const z=D.isApplicationScoped||D.isBuiltin||(0,h.$Lm)(y),F={...D,installOnlyNewlyAddedFromExtensionPack:D.installOnlyNewlyAddedFromExtensionPack??!k.URI.isUri(p),isApplicationScoped:z,profileLocation:z?this.H.defaultProfile.extensionsResource:D.profileLocation??this.X(),productVersion:D.productVersion??{version:this.G.version,date:this.G.date}},M=k.URI.isUri(p)?void 0:this.j.get(S(p,F.profileLocation));M?(this.F.info("Extension is already requested to install",M.task.identifier.id),E.push(M.task.waitUntilTaskIsFinished())):P(y,p,F,void 0)}return await Promise.all([...a.values()].map(async({task:y})=>{if(y.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",y.identifier.id);else try{const p=await this.M(y.identifier,y.manifest,!!y.options.installOnlyNewlyAddedFromExtensionPack,!!y.options.installPreReleaseVersion,y.options.profileLocation,y.options.productVersion),D=await this.getInstalled(void 0,y.options.profileLocation,y.options.productVersion),z={...y.options,context:{...y.options.context,[$.$Po]:!0}};for(const{gallery:F,manifest:M}of(0,I.$Mb)(p,({gallery:X})=>X.identifier.id)){if(a.has(`${F.identifier.id.toLowerCase()}-${z.profileLocation.toString()}`))continue;const X=this.j.get(S(F,z.profileLocation));if(X){if(this.J(y,X.task)){const G=X.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,y.identifier.id),X.waitingTasks.push(y),E.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,Y=>Y.some(V=>(0,f.$lp)(V.identifier,G)))).then(Y=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,y.identifier.id),!Y.find(K=>(0,f.$lp)(K.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else D.some(({identifier:G})=>(0,f.$lp)(G,F.identifier))||P(M,F,z,y)}}catch(p){if(k.URI.isUri(y.source))(0,I.$Lb)(y.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",y.identifier.id,p.message),(0,I.$Lb)(y.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",y.identifier.id,p.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",y.identifier.id),p}})),await this.L([...a.entries()].map(async([y,{task:p}])=>{const D=new Date().getTime();try{const z=await p.run();if(await this.L(this.y.map(F=>F.postInstall(z,p.source,p.options,j.CancellationToken.None))),!k.URI.isUri(p.source)){const F=p.operation===3,M=F?void 0:(new Date().getTime()-p.source.lastUpdated)/1e3;if(o(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$tp)(p.source),verificationStatus:p.verificationStatus,duration:new Date().getTime()-D,durationSinceUpdate:M}),C.$o&&p.operation!==3)try{await this.z.reportStatistic(z.manifest.publisher,z.manifest.name,z.manifest.version,"install")}catch{}}r.set(y,{local:z,identifier:p.identifier,operation:p.operation,source:p.source,context:p.options.context,profileLocation:p.profileLocation,applicationScoped:z.isApplicationScoped})}catch(z){throw r.set(y,{error:z,identifier:p.identifier,operation:p.operation,source:p.source,context:p.options.context,profileLocation:p.profileLocation,applicationScoped:p.options.isApplicationScoped}),this.F.error("Error while installing the extension",p.identifier.id,(0,A.$0)(z)),z}})),E.length&&await this.L(E),[...r.values()]}catch(y){const p=(F,M,X)=>{const G=[];F.manifest.extensionDependencies?.length&&G.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&G.push(...F.manifest.extensionPack);for(const Y of G){if(X.includes(Y.toLowerCase()))continue;X.push(Y.toLowerCase());const V=r.get(`${Y.toLowerCase()}-${M.toString()}`);V?.local&&(X=p(V.local,M,X))}return X},D=F=>({identifier:F.identifier,operation:2,source:F.source,context:F.options.context,profileLocation:F.profileLocation,error:y}),z=[];for(const[F,{task:M,root:X}]of a){const G=r.get(F);G?G.local&&X&&!r.get(`${X.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`)?.local&&(z.push(this.Z(G.local,{versionOnly:!0,profileLocation:M.profileLocation})),r.set(F,D(M))):(M.cancel(),r.set(F,D(M)))}for(const[F,{task:M}]of a){const X=r.get(F);if(!X?.local||M.options.donotIncludePackAndDependencies)continue;p(X.local,M.profileLocation,[X.local.identifier.id.toLowerCase()]).slice(1).some(Y=>a.has(`${Y.toLowerCase()}-${M.profileLocation.toString()}`)&&!r.get(`${Y.toLowerCase()}-${M.profileLocation.toString()}`)?.local)&&(z.push(this.Z(X.local,{versionOnly:!0,profileLocation:M.profileLocation})),r.set(F,D(M)))}throw z.length&&await Promise.allSettled(z.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,A.$0)(M))}})),y}finally{for(const{task:y}of a.values())y.source&&!k.URI.isUri(y.source)&&this.j.delete(S(y.source,y.profileLocation));if(r.size){const y=[...r.values()];for(const p of y)p.local&&this.F.info("Extension installed successfully:",p.identifier.id);this.s.fire(y)}}}J(t,r){for(const[,{task:a,waitingTasks:E}]of this.j.entries())if(a===t&&(E.includes(r)||E.some(S=>this.J(S,r)))||a===r&&E[0]&&!this.J(t,E[0]))return!1;return!0}async L(t){const r=[],a=[],E=await Promise.allSettled(t);for(const S of E)S.status==="fulfilled"?r.push(S.value):a.push(S.reason);if(a.length)throw g(a);return r}async M(t,r,a,E,S,P){if(!this.z.isEnabled())return[];const y=await this.getInstalled(void 0,S,P),p=[],D=[],z=async(F,M)=>{p.push(F);const X=M.extensionDependencies||[],G=[...X];if(M.extensionPack){const Y=a?y.find(V=>(0,f.$lp)(V.identifier,F)):void 0;for(const V of M.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(K=>(0,f.$lp)({id:K},{id:V}))||G.every(K=>!(0,f.$lp)({id:K},{id:V}))&&G.push(V)}if(G.length){const Y=G.filter(V=>p.every(K=>!(0,f.$lp)(K,{id:V})));if(Y.length){const V=await this.z.getExtensions(Y.map(K=>({id:K,preRelease:E})),j.CancellationToken.None);for(const K of V){if(p.find(ie=>(0,f.$lp)(ie,K.identifier)))continue;const W=X.some(ie=>(0,f.$lp)({id:ie},K.identifier));let B;try{B=await this.N(K,!1,E,P)}catch(ie){if(W)throw ie;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,A.$0)(ie));continue}D.push({gallery:B.extension,manifest:B.manifest}),await z(B.extension.identifier,B.manifest)}}}};return await z(t,r),D}async N(t,r,a,E){let S;const P=await this.getExtensionsControlManifest();if(P.malicious.some(D=>(0,f.$lp)(t.identifier,D)))throw new $.$Xo(v.localize(1,null,t.identifier.id),$.ExtensionManagementErrorCode.Malicious);const y=P.deprecated[t.identifier.id.toLowerCase()];if(y?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${y.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:y.extension.id,preRelease:y.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:E},j.CancellationToken.None))[0],!S)throw new $.$Xo(v.localize(2,null,t.identifier.id,y.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new $.$Xo(v.localize(3,null,t.identifier.id,this.G.nameLong,(0,$.$Qo)(D)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.O(t,r,a,E),!S)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],j.CancellationToken.None))[0]?new $.$Xo(v.localize(4,null,t.displayName??t.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$Xo(v.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const p=await this.z.getManifest(S,j.CancellationToken.None);if(p===null)throw new $.$Xo(`Missing manifest for extension ${S.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(p.version!==S.version)throw new $.$Xo(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:p}}async O(t,r,a,E){const S=await this.getTargetPlatform();let P=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(P=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:S,compatible:!0,productVersion:E},j.CancellationToken.None))[0]||null),!P&&await this.z.isExtensionCompatible(t,a,S,E)&&(P=t),P||(r?P=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:S,compatible:!0,productVersion:E},j.CancellationToken.None))[0]||null:P=await this.z.getCompatibleExtension(t,a,S,E)),P}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},E=z=>`${z.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,S=this.m.get(E(t.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),S.waitUntilTaskIsFinished();const P=z=>{const F=this.Z(z,a);return this.m.set(E(F.extension.identifier),F),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${z.identifier.id}@${z.manifest.version}`),this.t.fire({identifier:z.identifier,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped}),F},y=(z,F)=>{F?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${z.identifier.id}@${z.manifest.version}`,F.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${z.identifier.id}@${z.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$sp)(z),error:F}),this.u.fire({identifier:z.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped})},p=[],D=[];try{p.push(P(t));const z=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,z);for(const M of F)this.m.has(E(M.identifier))?this.F.info("Extensions is already requested to uninstall",M.identifier.id):p.push(P(M))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(p.map(F=>F.extension),z,t),await this.L(p.map(async F=>{try{if(await F.run(),await this.L(this.y.map(M=>M.postUninstall(F.extension,a,j.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}y(F.extension)}catch(M){const X=M instanceof $.$Xo?M:new $.$Xo((0,A.$0)(M),$.ExtensionManagementErrorCode.Internal);throw y(F.extension,X),X}finally{D.push(F)}}))}catch(z){const F=z instanceof $.$Xo?z:new $.$Xo((0,A.$0)(z),$.ExtensionManagementErrorCode.Internal);for(const M of p){try{M.cancel()}catch{}D.includes(M)||y(M.extension,F)}throw F}finally{for(const z of p)this.m.delete(E(z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",z.extension.identifier.id)}}Q(t,r,a){for(const E of t){const S=this.U(E,r);if(S.length){const P=S.filter(y=>!t.some(p=>(0,f.$lp)(p.identifier,y.identifier)));if(P.length)throw new Error(this.R(E,P,a))}}}R(t,r,a){return a===t?r.length===1?v.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?v.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const E=t.manifest.extensionPack?t.manifest.extensionPack:[];if(E.length){const S=r.filter(y=>!y.isBuiltin&&E.some(p=>(0,f.$lp)({id:p},y.identifier))),P=[];for(const y of S)P.push(...this.S(y,r,a));return[...S,...P]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(E=>(0,f.$lp)({id:E},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$bq=c,e.$bq=c=ve([Q(0,$.$Wo),Q(1,u.$Sl),Q(2,d.$rl),Q(3,b.$Tj),Q(4,w.$ak),Q(5,l.$tl)],c);function g(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof $.$Xo)return s;if(s instanceof $.$Yo){const r=new $.$Xo(s.message,$.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new $.$Xo(s.message,$.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:E,error:S,durationSinceUpdate:P}){let y,p;(0,m.$9f)(a)&&(a===!0?a="Verified":(a===!1||(y=$.ExtensionManagementErrorCode.Signature,p=a),a="Unverified")),S&&(S instanceof $.$Xo||S instanceof $.$Yo?(y=S.code,S.code===$.ExtensionManagementErrorCode.Signature&&(p=S.message)):y=$.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!S,duration:E,errorcode:y,errorcodeDetail:p,durationSinceUpdate:P})}class n{constructor(){this.d=new N.$mh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$ah)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$ah)(t=>new Promise((r,a)=>{const E=t.onCancellationRequested(()=>{E.dispose(),a(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$eq=n}),define(le[52],he([0,1,6,15,2,3,35,8,29,33,12,4,9,18,28,13,7,22]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class l extends Error{constructor(n,s){super(n),this.code=s}}e.$fq=l,e.$gq=(0,v.$ni)("IExtensionsProfileScannerService");let c=class extends j.$Uc{constructor(n,s,t,r,a,E){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=E,this.b=this.B(new A.$_d),this.onAddExtensions=this.b.event,this.c=this.B(new A.$_d),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$_d),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$_d),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,E=>{const S=[];if(t)S.push(...E);else for(const P of E)n.some(([y])=>(0,m.$lp)(y.identifier,P.identifier)&&y.manifest.version!==P.version)?r.push(P):S.push(P);for(const[P,y]of n){const p=S.findIndex(z=>(0,m.$lp)(z.identifier,P.identifier)&&z.version===P.manifest.version),D={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:y};p===-1?(a.push(D),S.push(D)):S.splice(p,1,D)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),S}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(E){throw a.length&&this.c.fire({extensions:a,error:E,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:E,profileLocation:s}),E}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const E of r){const S=n.find(([P])=>(0,m.$lp)(P.identifier,E.identifier)&&P.manifest.version===E.version);S&&(E.metadata={...E.metadata,...S[1]},t.push(E)),a.push(E)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const E of r)(0,m.$lp)(E.identifier,n.identifier)?t.push(E):a.push(E);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const E=await this.m.readFile(n);a=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,k.$$k)(E)!==1)throw E;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new l((0,w.$0)(E),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let E=!1;for(const S of a){g(S)||this.w(n);let P;if((0,b.$1f)(S.relativeLocation)&&S.relativeLocation)P=this.z(S.relativeLocation);else if((0,b.$1f)(S.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${S.location}`);continue}else{P=R.URI.revive(S.location);const y=this.y(P);y&&(E=!0,S.relativeLocation=y)}(0,b.$8f)(S.metadata?.hasPreReleaseVersion)&&S.metadata?.preRelease&&(E=!0,S.metadata.hasPreReleaseVersion=!0),r.push({identifier:S.identifier,location:P,version:S.version,metadata:S.metadata})}E&&await this.m.writeFile(n,N.$ze.fromString(JSON.stringify(a)))}if(s){r=s(r);const E=r.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(n,N.$ze.fromString(JSON.stringify(E)))}return r})}w(n){const s=new l(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,k.$$k)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(E=>g(E))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ze.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,k.$$k)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,k.$$k)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,k.$$k)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new I.$uh,this.h.set(n,s)),s}};e.$hq=c,e.$hq=c=ve([Q(1,k.$Tk),Q(2,f.$tl),Q(3,h.$rl),Q(4,u.$Sl),Q(5,$.$Tj)],c);function g(o){return(0,b.$3f)(o)&&(0,C.$Vo)(o.identifier)&&(i(o.location)||(0,b.$1f)(o.location)&&o.location)&&((0,b.$8f)(o.relativeLocation)||(0,b.$1f)(o.relativeLocation))&&o.version&&(0,b.$1f)(o.version)}function i(o){return o?(0,b.$1f)(o.path)&&(0,b.$1f)(o.scheme):!1}}),define(le[81],he([0,1,17,6,30,15,7,34,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i,o,n,s,t,r,a,E,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$mq=e.$lq=e.$kq=e.Translations=void 0,e.$nq=X;var p;(function(Y){function V(K,W){if(K===W)return!0;const B=Object.keys(K),ie=new Set;for(const ae of Object.keys(W))ie.add(ae);if(B.length!==ie.size)return!1;for(const ae of B){if(K[ae]!==W[ae])return!1;ie.delete(ae)}return ie.size===0}Y.equals=V})(p||(e.Translations=p={})),e.$kq=(0,n.$ni)("IExtensionsScannerService");let D=class extends m.$Uc{constructor(V,K,W,B,ie,ae,te,ce,H,U,L,T){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=K,this.r=W,this.s=B,this.t=ie,this.u=ae,this.w=te,this.y=ce,this.z=H,this.C=U,this.D=L,this.F=T,this.g=this.B(new r.$_d),this.onDidChangeCache=this.g.event,this.h=(0,f.$1g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$wp)(this.w,this.y)),this.G}async scanAllExtensions(V,K,W){const[B,ie]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(K)]),ae=W?await this.scanExtensionsUnderDevelopment(V,[...B,...ie]):[];return this.L(B,ie,ae,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const K=[];K.push(this.M(!!V.useCache,V.language)),K.push(this.N(V.language,!!V.checkControlFile));const[W,B]=await Promise.all(K);return this.J([...W,...B],0,V,!1)}async scanUserExtensions(V){const K=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const W=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(K,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,W,V.productVersion??this.R()),ie=V.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let ae;try{ae=await ie.scanExtensions(B)}catch(te){if(te instanceof E.$fq&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ae=await ie.scanExtensions(B);else throw te}return ae=await this.J(ae,1,V,!0),this.y.trace("Scanned user extensions:",ae.length),ae}async scanExtensionsUnderDevelopment(V,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===k.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(te=>(te.type=K.find(ce=>(0,c.$lp)(ce.identifier,te.identifier))?.type??te.type,this.n.validate(te,ie)))}))).flat();return this.J(W,"development",V,!0)}return[]}async scanExistingExtension(V,K,W){const B=await this.P(V,!1,K,!0,W.language,!0,void 0,W.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!W.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(V,K,W){const B=await this.P(V,!1,K,!0,W.language,!0,void 0,W.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,K,W,!0)}async scanMultipleExtensions(V,K,W){const B=[];return await Promise.all(V.map(async ie=>{const ae=await this.scanOneOrMultipleExtensions(ie,K,W);B.push(...ae)})),this.J(B,K,W,!0)}async scanMetadata(V){const K=(0,f.$1g)(V,"package.json"),W=(await this.w.readFile(K)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(V,K){const W=(0,f.$1g)(V,"package.json"),B=(await this.w.readFile(W)).value.toString(),ie=JSON.parse(B);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,ie.__metadata={...ie.__metadata,...K},await this.w.writeFile((0,f.$1g)(V,"package.json"),A.$ze.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof E.$fq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ze.fromString(JSON.stringify([])))}catch(K){(0,o.$$k)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,K,W,B){return W.includeAllVersions||(V=this.L(K===0?V:void 0,K===1?V:void 0,K==="development"?V:void 0,await this.getTargetPlatform(),B)),W.includeInvalid||(V=V.filter(ie=>ie.isValid)),V.sort((ie,ae)=>{const te=v.$oc(ie.location.fsPath),ce=v.$oc(ae.location.fsPath);return te<ce?-1:te>ce?1:0})}L(V,K,W,B,ie){const ae=(ce,H,U)=>{if(ce.isValid&&!H.isValid)return!1;if(ce.isValid===H.isValid){if(ie&&h.gt(ce.manifest.version,H.manifest.version))return this.y.debug(`Skipping extension ${H.location.path} with lower version ${H.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(h.eq(ce.manifest.version,H.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${H.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===B)return this.y.debug(`Skipping extension ${H.location.path} from different target platform ${H.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${ce.location.path} with ${H.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${H.location.path}.`),!0},te=new g.$Km;return V?.forEach(ce=>{const H=te.get(ce.identifier.id);(!H||ae(H,ce,!1))&&te.set(ce.identifier.id,ce)}),K?.forEach(ce=>{const H=te.get(ce.identifier.id);if(!H&&V&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!H||ae(H,ce,!1))&&te.set(ce.identifier.id,ce)}),W?.forEach(ce=>{const H=te.get(ce.identifier.id);(!H||ae(H,ce,!0))&&te.set(ce.identifier.id,ce),te.set(ce.identifier.id,ce)}),[...te.values()]}async M(V,K){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),ie=await(V&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(V,K){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const B=K?await this.O():{},ie=[],ae=u.URI.file(v.$ic(v.$kc(k.$Hg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of W){const H=B[ce.name]||"marketplace";switch(H){case"disabled":break;case"marketplace":ie.push((0,f.$1g)(ae,ce.name));break;default:ie.push(u.URI.file(H));break}}const te=await Promise.all(ie.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,I.$Hb)(te)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,K,W,B,ie,ae,te,ce){const H=await this.f(ie??$.$w),U=await this.Q(V),L=K&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,T=L?await this.Q(L):void 0;return new z(V,U,L,T,K,te,W,B,ae,ce.version,ce.date,this.C.commit,!this.z.isBuilt,ie,H)}async Q(V){try{const K=await this.w.stat(V);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$lq=D,e.$lq=D=ve([Q(4,S.$tl),Q(5,E.$gq),Q(6,o.$Tk),Q(7,s.$Tj),Q(8,l.$ui),Q(9,t.$ak),Q(10,P.$rl),Q(11,n.$mi)],D);class z{constructor(V,K,W,B,ie,ae,te,ce,H,U,L,T,q,x,J){this.location=V,this.mtime=K,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=ae,this.type=te,this.excludeObsolete=ce,this.validate=H,this.productVersion=U,this.productDate=L,this.productCommit=T,this.devMode=q,this.language=x,this.translations=J}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,K){return(0,f.$Tg)(V.location,K.location)&&V.mtime===K.mtime&&(0,f.$Tg)(V.applicationExtensionslocation,K.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&V.profile===K.profile&&j.$Xn(V.profileScanOptions,K.profileScanOptions)&&V.type===K.type&&V.excludeObsolete===K.excludeObsolete&&V.validate===K.validate&&V.productVersion===K.productVersion&&V.productDate===K.productDate&&V.productCommit===K.productCommit&&V.devMode===K.devMode&&V.language===K.language&&p.equals(V.translations,K.translations)}}e.$mq=z;let F=class extends m.$Uc{constructor(V,K,W,B,ie){super(),this.f=V,this.g=K,this.h=W,this.j=B,this.m=ie}async scanExtensions(V){const K=V.profile?await this.r(V):await this.n(V);let W={};if(V.excludeObsolete&&V.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(B)}catch{}return(0,w.$bg)(W)?K:K.filter(B=>!W[c.$mp.create(B).toString()])}async n(V){const K=await this.j.resolve(V.location);if(!K.children?.length)return[];const W=await Promise.all(K.children.map(async B=>{if(!B.isDirectory||V.type===1&&(0,f.$Xg)(B.resource).indexOf(".")===0)return null;const ie=new z(B.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ie)}));return(0,I.$Hb)(W).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(V){let K=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){K=K.filter(B=>!B.metadata?.isApplicationScoped);const W=await this.s(V.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,V);K.push(...W)}return K}async s(V,K,W){const B=await this.g.scanProfileExtensions(V,W.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async ae=>{if(K(ae)){const te=new z(ae.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te,ae.metadata)}return null}));return(0,I.$Hb)(ie)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,f.$1g)(V.location,"package.json"))){const K=await this.scanExtension(V);return K?[K]:[]}else return await this.scanExtensions(V)}catch(K){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,O.$0)(K)),[]}}async scanExtension(V,K){try{let W=await this.scanExtensionManifest(V.location);if(W){W.publisher||(W.publisher=g.$Em),K=K??W.__metadata,delete W.__metadata;const B=(0,c.$qp)(W.publisher,W.name),ie=K?.id?{id:B,uuid:K.id}:{id:B},ae=K?.isSystem?0:V.type,te=ae===0||!!K?.isBuiltin;W=await this.t(V.location,W,z.createNlsConfiguration(V));const ce={type:ae,identifier:ie,manifest:W,location:V.location,isBuiltin:te,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return V.validate?this.validate(ce,V):ce}}catch(W){V.type!==0&&this.m.error(W)}return null}validate(V,K){let W=!0;const B=(0,i.$Bp)(K.productVersion,K.productDate,K.location,V.manifest,V.isBuiltin);for(const[ie,ae]of B)ie===b.default.Error&&(W=!1,this.m.error(this.z(K.location,ae)));return V.isValid=W,V.validations=B,V}async scanExtensionManifest(V){const K=(0,f.$1g)(V,"package.json");let W;try{W=(await this.j.readFile(K)).value.toString()}catch(ie){return(0,o.$$k)(ie)!==1&&this.m.error(this.z(V,(0,d.localize)(0,null,K.path,ie.message))),null}let B;try{B=JSON.parse(W)}catch{const ae=[];(0,R.$An)(W,ae);for(const te of ae)this.m.error(this.z(V,(0,d.localize)(1,null,K.path,te.offset,te.length,(0,C.$iq)(te.error))));return null}return(0,R.$Jn)(B)!=="object"?(this.m.error(this.z(V,(0,d.localize)(2,null,K.path))),null):B}async t(V,K,W){const B=await this.u(V,K,W);if(B)try{const ie=[],ae=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(ce=>{this.m.error(this.z(V,(0,d.localize)(3,null,B.default?.path,(0,C.$iq)(ce.error))))}),K;if((0,R.$Jn)(B)!=="object")return this.m.error(this.z(V,(0,d.localize)(4,null,B.default?.path))),K;const te=B.values||Object.create(null);return(0,y.$jq)(this.m,K,te,ae)}catch{}return K}async u(V,K,W){const B=(0,f.$1g)(V,"package.nls.json"),ie=(H,U)=>{U.forEach(L=>{this.m.error(this.z(V,(0,d.localize)(5,null,H?.path,(0,C.$iq)(L.error))))})},ae=H=>{this.m.error(this.z(V,(0,d.localize)(6,null,H?.path)))},te=`${K.publisher}.${K.name}`,ce=W.translations[te];if(ce)try{const H=u.URI.file(ce),U=(await this.j.readFile(H)).value.toString(),L=[],T=(0,R.$An)(U,L);return L.length>0?(ie(H,L),{values:void 0,default:B}):(0,R.$Jn)(T)!=="object"?(ae(H),{values:void 0,default:B}):{values:T.contents?T.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let U;try{U=await this.y(V,W)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const L=(await this.j.readFile(U.localized)).value.toString(),T=[],q=(0,R.$An)(L,T);return T.length>0?(ie(U.localized,T),{values:void 0,default:U.original}):(0,R.$Jn)(q)!=="object"?(ae(U.localized),{values:void 0,default:U.original}):{values:q,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(V,K){if(V)try{const W=(await this.j.readFile(V)).value.toString();return(0,R.$An)(W,K)}catch{}}y(V,K){return new Promise((W,B)=>{const ie=ae=>{const te=(0,f.$1g)(V,`package.nls.${ae}.json`);this.j.exists(te).then(ce=>{ce&&W({localized:te,original:(0,f.$1g)(V,"package.nls.json")});const H=ae.lastIndexOf("-");H===-1?W({localized:(0,f.$1g)(V,"package.nls.json"),original:null}):(ae=ae.substring(0,H),ie(ae))})};if(K.devMode||K.pseudo||!K.language)return W({localized:(0,f.$1g)(V,"package.nls.json"),original:null});ie(K.language)})}z(V,K){return`[${V.path}]: ${K}`}};F=ve([Q(1,E.$gq),Q(2,P.$rl),Q(3,o.$Tk),Q(4,s.$Tj)],F);let M=class extends F{constructor(V,K,W,B,ie,ae,te){super(K,B,ie,ae,te),this.G=V,this.H=W,this.D=this.B(new N.$lh(3e3)),this.F=this.B(new r.$_d),this.onDidChangeCache=this.F.event}async scanExtensions(V){const K=this.M(V),W=await this.I(K);if(this.C=V,W&&W.input&&z.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),W.result.map(ie=>(ie.location=u.URI.revive(ie.location),ie));const B=await super.scanExtensions(V);return await this.J(K,{input:V,result:B}),B}async I(V){try{const K=await this.j.readFile(V),W=JSON.parse(K.value.toString());return{result:W.result,input:(0,a.$Wh)(W.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",V.path,(0,O.$0)(K))}return null}async J(V,K){try{await this.j.writeFile(V,A.$ze.fromString(JSON.stringify(K)))}catch(W){this.m.debug("Error while writing the extension cache file:",V.path,(0,O.$0)(W))}}async L(){if(!this.C)return;const V=this.M(this.C),K=await this.I(V);if(!K)return;const W=K.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$Xn(B,W))try{this.m.info("Invalidating Cache",W,B),await this.j.del(V),this.F.fire()}catch(ie){this.m.error(ie)}}M(V){const K=this.N(V);return this.h.extUri.joinPath(K.cacheHome,V.type===0?g.$Dm:g.$Cm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(V.location,K.extensionsResource))??this.G:this.H.defaultProfile}};M=ve([Q(2,S.$tl),Q(3,E.$gq),Q(4,P.$rl),Q(5,o.$Tk),Q(6,s.$Tj)],M);function X(Y,V){const K=(0,c.$op)(Y.manifest.publisher,Y.manifest.name);return{id:K,identifier:new g.$Im(K),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:V,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,...Y.manifest}}class G extends D{constructor(V,K,W,B,ie,ae,te,ce,H,U,L,T){super(V,K,(0,f.$1g)(W,".vscode-oss-dev","extensions","control.json"),B,ie,ae,te,ce,H,U,L,T),this.S=(async()=>{if($.$z)try{const q=await this.w.readFile(u.URI.file($.$z));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$oq=G}),define(le[251],he([0,1,67,6,38,3,2,23,14,31,9,18]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;let $=class extends O.$Uc{constructor(h,b){super(),this.b=h,this.f=b,this.a=new N.$th(5)}async postUninstall(h){const b=this.g(h,"uninstall");b&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,h),this.f.info("Finished running post uninstall script",h.identifier.id,h.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",h.identifier.id,h.manifest.version),this.f.error(w)}}));try{await m.Promises.rm(this.m(h))}catch(w){this.f.error("Error while removing extension storage path",h.identifier.id),this.f.error(w)}}g(h,b){const w=`vscode:${b}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[w]=="string"){const u=h.manifest.scripts[w].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${w} should be a node script`),null):{script:(0,C.$kc)(h.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(h,b,w,u,d){return new Promise((l,c)=>{const g=this.j(h,b,w,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):l(void 0)};g.on("error",n=>{o((0,j.$$i)(n)||"Unknown")}),g.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),u&&(i=setTimeout(()=>{i=null,g.kill(),c("timed out")},5e3))})}j(h,b,w,u){const d={silent:!0,execArgv:void 0},l=(0,I.fork)(h,[`--type=extension-post-${b}`,...w],d);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const c=A.Event.fromNodeEventEmitter(l.stdout,"data"),g=A.Event.fromNodeEventEmitter(l.stderr,"data");c(n=>this.f.info(u.identifier.id,u.manifest.version,`post-${b}`,n)),g(n=>this.f.error(u.identifier.id,u.manifest.version,`post-${b}`,n));const i=A.Event.any(A.Event.map(c,n=>({data:`%c${n}`,format:[""]})),A.Event.map(g,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}m(h){return(0,C.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};e.$qq=$,e.$qq=$=ve([Q(0,v.$tl),Q(1,k.$Tj)],$)}),define(le[113],he([0,1,6,15,26,38,7,3,54,2,35,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i,o,n,s,t,r,a,E,S,P,y,p,D,z,F,M,X,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=void 0,e.$uq=(0,z.$oi)(n.$Zo);const V=".vsctmp";let K=class extends o.$bq{constructor(H,U,L,T,q,x,J,ee,_,Z,ne,re){super(H,U,ne,L,Z,re),this.eb=q,this.fb=x,this.gb=J,this.hb=_,this.db=new Map,this.qb=new k.$Cc;const ue=this.B(ee.createInstance(E.$qq));this.ab=this.B(ee.createInstance(W,$e=>ue.postUninstall($e))),this.bb=this.B(new P.$sq(re,_,ne,this,this.F)),this.cb=this.B(ee.createInstance(a.$pq));const de=this.B(new y.$tq(this,this.eb,re,x,ne,_,L));this.B(de.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$wp)(this.hb,this.F)),this.ib}async zip(H){this.F.trace("ExtensionManagementService#zip",H.identifier.id);const U=await this.ob(H),L=await(0,l.zip)((0,f.$1g)(this.cb.extensionsDownloadDir,(0,u.$Jg)()).fsPath,U);return w.URI.file(L)}async unzip(H){return this.F.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:U,cleanup:L}=await this.kb(H),T=$.$lc(U.fsPath);try{return await(0,S.$rq)(T)}finally{await L()}}getInstalled(H,U=this.H.defaultProfile.extensionsResource,L={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(H??null,U,L)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.ab.scanUserExtensionAtLocation(H)}async install(H,U={}){this.F.trace("ExtensionManagementService#install",H.toString());const{location:L,cleanup:T}=await this.kb(H);try{const q=await(0,S.$rq)($.$lc(L.fsPath)),x=(0,s.$qp)(q.publisher,q.name);if(q.engines&&q.engines.vscode&&!(0,p.$Dp)(q.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,x,this.G.version));const ee=(await this.I([{manifest:q,extension:L,options:U}])).find(({identifier:_})=>(0,s.$lp)(_,{id:x}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,o.$dq)(new Error(`Unknown error while installing extension ${x}`))}finally{await T()}}async installFromLocation(H,U){this.F.trace("ExtensionManagementService#installFromLocation",H.toString());const L=await this.ab.scanUserExtensionAtLocation(H);if(!L||!L.manifest.name||!L.manifest.version)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.tb([[L,{source:"resource"}]],U),this.F.info("Successfully installed extension",L.identifier.id,U.toString()),L}async installExtensionsFromProfile(H,U,L){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",H,U.toString(),L.toString());const T=(await this.getInstalled(1,U)).filter(q=>H.some(x=>(0,s.$lp)(x,q.identifier)));if(T.length){const q=await Promise.all(T.map(x=>this.ab.scanMetadata(x,U)));await this.tb(T.map((x,J)=>[x,q[J]]),L),this.F.info("Successfully installed extensions",T.map(x=>x.identifier.id),L.toString())}return T}async updateMetadata(H,U,L=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",H.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),H=await this.ab.updateMetadata(H,U,L),this.bb.invalidate(L),this.w.fire(H),H}async reinstallFromGallery(H){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const U=await this.getTargetPlatform(),[L]=await this.z.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:U,compatible:!0},j.CancellationToken.None);if(!L)throw new Error(c.localize(2,null));await this.ab.setUninstalled(H);try{await this.ab.removeUninstalledExtension(H)}catch(T){throw new Error(c.localize(3,null,(0,A.$$i)(T)))}return this.installFromGallery(L)}$(H,U,L,T){return this.ab.copyExtension(H,U,L,T)}copyExtensions(H,U){return this.ab.copyExtensions(H,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...H){return this.ab.setUninstalled(...H)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(H){this.F.error(H)}}async download(H,U,L){const{location:T}=await this.cb.download(H,U,!L);return T}async kb(H){if(H.scheme===v.Schemas.file)return{location:H,async cleanup(){}};this.F.trace("Downloading extension from",H.toString());const U=(0,f.$1g)(this.cb.extensionsDownloadDir,(0,u.$Jg)());return await this.gb.download(H,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(H,U,L){if(w.URI.isUri(U))return new ae(H,U,L,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$mp.create(U).toString();let q=this.db.get(T);return q||(this.db.set(T,q=new ie(H,U,L,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),q.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),q}Z(H,U){return new te(H,U.profileLocation,this.fb)}async ob(H){const U=async T=>{let q=await d.Promises.readdir(T);q=q.map(ee=>$.$kc(T,ee));const x=await Promise.all(q.map(ee=>d.Promises.stat(ee)));let J=Promise.resolve([]);return x.forEach((ee,_)=>{const Z=q[_];ee.isFile()&&(J=J.then(ne=>[...ne,Z])),ee.isDirectory()&&(J=J.then(ne=>U(Z).then(re=>[...ne,...re])))}),J};return(await U(H.location.fsPath)).map(T=>({path:`extension/${$.$mc(H.location.fsPath,T)}`,localPath:T}))}async pb({added:H,removed:U}){if(U){const L=H&&this.D.extUri.isEqual(U.profileLocation,H.profileLocation)?U.extensions.filter(T=>H.extensions.every(q=>!(0,s.$lp)(q,T))):U.extensions;for(const T of L)this.F.info("Extensions removed from another source",T.id,U.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:U.profileLocation})}if(H){const T=(await this.getInstalled(1,H.profileLocation)).filter(q=>H.extensions.some(x=>(0,s.$lp)(x,q.identifier)));this.s.fire(T.map(q=>(this.F.info("Extensions added from another source",q.identifier.id,H.profileLocation.toString()),{identifier:q.identifier,local:q,profileLocation:H.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const H=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of H.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(H){if(!H.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const L of H.rawAdded){if(this.qb.has(L)||!this.D.extUri.isEqual(this.D.extUri.dirname(L),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(L,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(L).startsWith(".")||!(await this.hb.stat(L)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(L);T&&T.installedTimestamp===void 0&&(this.qb.add(L),U.push(T))}U.length&&(await this.tb(U.map(L=>[L,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(L=>L.identifier.id)))}async tb(H,U){const L=H.map(T=>T[0]);await this.ub(L),await this.fb.addExtensionsToProfile(H,U),this.s.fire(L.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:U})))}async ub(H){const U=await this.ab.getUninstalledExtensions();for(const L of H){const T=s.$mp.create(L);U[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$vq=K,e.$vq=K=ve([Q(0,n.$Wo),Q(1,X.$Sl),Q(2,F.$Tj),Q(3,i.$vi),Q(4,r.$kq),Q(5,t.$gq),Q(6,g.$Bo),Q(7,z.$mi),Q(8,D.$Tk),Q(9,M.$ak),Q(10,G.$rl),Q(11,Y.$tl)],K);let W=class extends m.$Uc{constructor(H,U,L,T,q,x){super(),this.j=H,this.m=U,this.n=L,this.s=T,this.t=q,this.u=x,this.h=this.B(new R.$_d),this.onExtract=this.h.event,this.c=(0,f.$1g)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$uh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(H,U,L){const T={includeInvalid:!0,profileLocation:U,productVersion:L};let q=[];return H===null||H===0?q.push(...await this.n.scanAllExtensions({includeInvalid:!0},T,!1)):H===1&&q.push(...await this.n.scanUserExtensions(T)),q=H!==null?q.filter(x=>x.type===H):q,Promise.all(q.map(x=>this.F(x)))}async scanAllUserExtensions(H){const U=await this.n.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return Promise.all(U.map(L=>this.F(L)))}async scanUserExtensionAtLocation(H){try{const U=await this.n.scanExistingExtension(H,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(H,U,L,T,q){const x=H.toString(),J=w.URI.file($.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$Jg)()}`)),ee=w.URI.file($.$kc(this.n.userExtensionsLocation.fsPath,x));let _=await this.m.exists(ee);if(_&&T){try{await this.y(H.id,ee,"removeExisting")}catch{throw new n.$Xo(c.localize(4,null,ee.fsPath,H.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,L);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${ee.fsPath}`),await(0,l.$_p)(U,J.fsPath,{sourcePath:"extension",overwrite:!0},q),this.u.info(`Extracted extension to ${ee}:`,H.id)}catch(Z){let ne=n.ExtensionManagementErrorCode.Extract;throw Z instanceof l.$0p&&(Z.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:Z.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Xo(Z.message,ne)}await this.n.updateMetadata(J,L);try{this.u.trace(`Started renaming the extension from ${J.fsPath} to ${ee.fsPath}`),await this.C(J.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Z){if(Z.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(Z)}. Deleted from extracted location`,J),Z}this.h.fire(ee)}catch(Z){try{await this.m.del(J,{recursive:!0})}catch{}throw Z}return this.D(ee,1)}async scanMetadata(H,U){return U?(await this.w(H,U))?.metadata:this.n.scanMetadata(H.location)}async w(H,U){return(await this.s.scanProfileExtensions(U)).find(T=>(0,s.$lp)(T.identifier,H.identifier))}async updateMetadata(H,U,L){return L?await this.s.updateMetadata([[H,U]],L):await this.n.updateMetadata(H.location,U),this.D(H.location,H.type,L)}getUninstalledExtensions(){return this.z()}async setUninstalled(...H){const U=H.map(L=>s.$mp.create(L));await this.z(L=>U.forEach(T=>{L[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(H){await this.z(U=>delete U[H.toString()])}async removeExtension(H,U){if(this.t.extUri.isEqualOrParent(H.location,this.n.userExtensionsLocation))return this.y(H.identifier.id,H.location,U)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.z(U=>delete U[s.$mp.create(H).toString()])}async copyExtension(H,U,L,T){const q=await this.w(H,U),x=await this.w(H,L);if(T={...q?.metadata,...T},x)if(this.t.extUri.isEqual(x.location,H.location))await this.s.updateMetadata([[H,{...x.metadata,...T}]],L);else{const J=await this.D(x.location,H.type,L);await this.s.removeExtensionFromProfile(J,L),await this.s.addExtensionsToProfile([[H,{...x.metadata,...T}]],L)}else await this.s.addExtensionsToProfile([[H,T]],L);return this.D(H.location,H.type,L)}async copyExtensions(H,U,L){const T=await this.scanExtensions(1,H,L),q=await Promise.all(T.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,H)]));await this.s.addExtensionsToProfile(q,U)}async y(H,U,L){this.u.trace(`Deleting ${L} extension from disk`,H,U.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,C.$bj)((0,u.$Jg)()).toString(16)}${V}`);await this.C(U.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${L} extension from disk`,H,U.fsPath)}async z(H){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,D.$$k)(T)!==1)throw T}let L={};if(U)try{L=JSON.parse(U)}catch{}return H&&(H(L),Object.keys(L).length?await this.m.writeFile(this.c,N.$ze.fromString(JSON.stringify(L))):await this.m.del(this.c)),L})}async C(H,U){try{await d.Promises.rename(H,U,2*60*1e3)}catch(L){throw new n.$Xo(L.message||c.localize(5,null,H,U),L.code||n.ExtensionManagementErrorCode.Rename)}}async D(H,U,L){if(L){const q=(await this.n.scanUserExtensions({profileLocation:L})).find(x=>this.t.extUri.isEqual(x.location,H));if(q)return this.F(q)}else{const T=await this.n.scanExistingExtension(H,U,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(c.localize(6,null,H.path))}async F(H){const U=await this.m.resolve(H.location);let L,T;return U.children&&(L=U.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,T=U.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:L,changelogUrl:T,publisherDisplayName:H.metadata?.publisherDisplayName||null,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!H.metadata?.hasPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned,isWorkspaceScoped:!1,source:H.metadata?.source??(H.identifier.uuid?"gallery":"vsix")}}async G(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(H));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const q of U)H[s.$mp.create(q).toString()]||L.add(q.identifier.id.toLowerCase());try{const q=(0,s.$rp)(U,x=>x.identifier);await I.Promises.settled(q.map(async x=>{const J=x.sort((ee,_)=>h.rcompare(ee.manifest.version,_.manifest.version))[0];L.has(J.identifier.id.toLowerCase())||await this.j(await this.F(J))}))}catch(q){this.u.error(q)}const T=U.filter(q=>q.metadata&&H[s.$mp.create(q).toString()]);await Promise.allSettled(T.map(q=>this.removeUninstalledExtension(q)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let H;try{H=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,D.$$k)(U)!==1&&this.u.error(U);return}if(H?.children)try{await Promise.allSettled(H.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(L){(0,D.$$k)(L)!==1&&this.u.error(L)}}}))}catch{}}};e.$wq=W,e.$wq=W=ve([Q(1,D.$Tk),Q(2,r.$kq),Q(3,t.$gq),Q(4,G.$rl),Q(5,F.$Tj)],W);class B extends o.$eq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$8f)(this.options.operation)?this.l:this.options.operation}constructor(H,U,L,T,q,x,J,ee,_,Z){super(),this.manifest=H,this.identifier=U,this.source=L,this.options=T,this.m=q,this.n=x,this.o=J,this.p=ee,this.q=_,this.s=Z,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(H){const[U,L]=await this.x(H);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,L]],this.j,!U.isValid),U}async u({zipPath:H,key:U,metadata:L},T,q){let x=await this.v(U);return x?x=await this.m.updateMetadata(x,L):(this.s.trace("Extracting extension...",U.id),x=await this.m.extractUserExtension(U,H,L,T,q),this.s.info("Extracting extension completed.",U.id)),x}async v(H){return await this.w(H)?(this.s.trace("Removing the extension from uninstalled list:",H.id),await this.m.setInstalled(H),this.s.info("Removed the extension from uninstalled list:",H.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$mp.create(T).equals(H))):void 0}async w(H){return!!(await this.m.getUninstalledExtensions())[H.toString()]}}class ie extends B{constructor(H,U,L,T,q,x,J,ee,_,Z,ne){super(H,U.identifier,U,L,q,x,J,ee,_,Z),this.y=U,this.z=T,this.A=ne}async x(H){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(q){throw new n.$Xo(q,n.ExtensionManagementErrorCode.Scanning)}const L=U.find(q=>(0,s.$lp)(q.identifier,this.y.identifier));L&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||L?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:L?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??L?.pinned,preRelease:(0,b.$7f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||L?.preRelease,source:"gallery"};if(L&&L.type!==0&&L.manifest.version===this.y.version)try{return[await this.m.updateMetadata(L,T),T]}catch(q){throw new n.$Xo((0,O.$0)(q),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(T,H)}catch(q){if(q instanceof n.$Xo&&(q.code===n.ExtensionManagementErrorCode.CorruptZip||q.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const x=await this.C(T,H);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),x}catch(x){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),x}}else throw q}}async C(H,U){const{location:L,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.D(L.fsPath),[await this.u({zipPath:L.fsPath,key:s.$mp.create(this.y),metadata:H},!1,U),H]}catch(q){try{await this.z.delete(L)}catch(x){this.s.warn("Error while deleting the downloaded file",L.toString(),(0,O.$0)(x))}throw q}}async D(H){try{await(0,S.$rq)(H)}catch(U){throw new n.$Xo((0,o.$cq)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$xq=ie;class ae extends B{constructor(H,U,L,T,q,x,J,ee,_,Z){super(H,{id:(0,s.$qp)(H.publisher,H.name)},U,L,q,x,J,ee,_,Z),this.y=U,this.z=T}async h(H){const U=await super.h(H);return this.C(U,H),U}async x(H){const U=new s.$mp(this.identifier,this.manifest.version),T=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(J=>(0,s.$lp)(this.identifier,J.identifier)),q={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned,source:"vsix"};if(T)if(this.l=3,U.equals(new s.$mp(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(c.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&h.gt(T.manifest.version,this.manifest.version)&&await this.m.setUninstalled(T);else{const J=await this.v(U);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(c.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:$.$lc(this.y.fsPath),key:U,metadata:q},!0,H),q]}async C(H,U){try{let[L]=await this.z.getExtensions([{id:H.identifier.id,version:H.manifest.version}],U);if(L||([L]=await this.z.getExtensions([{id:H.identifier.id}],U)),L){const T={id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,hasPreReleaseVersion:H.hasPreReleaseVersion||L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(H,T,this.options.profileLocation)}}catch{}}}class te extends o.$eq{constructor(H,U,L){super(),this.extension=H,this.j=U,this.k=L}async h(H){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[252],he([0,1,9,18,28,22,52,12,16,8]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;let k=class extends O.$hq{constructor($,f,h,b,w,u){super(m.URI.file($.extensionsPath),f,h,b,w,u)}};e.$fQ=k,e.$fQ=k=ve([Q(0,C.$vi),Q(1,R.$Tk),Q(2,N.$tl),Q(3,j.$rl),Q(4,A.$Sl),Q(5,I.$Tj)],k)}),define(le[253],he([0,1,8,16,52,81,12,4,9,24,28,18]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;let $=class extends A.$oq{constructor(h,b,w,u,d,l,c,g){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,h.defaultProfile,h,b,w,u,d,l,c,g)}};e.$0bc=$,e.$0bc=$=ve([Q(0,v.$tl),Q(1,j.$gq),Q(2,O.$Tk),Q(3,C.$Tj),Q(4,N.$vi),Q(5,m.$ak),Q(6,k.$rl),Q(7,R.$mi)],$)}),define(le[19],he([0,1,6,3,2,98,13,69,4,18]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Tp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Rp=e.$Qp=e.$Pp=void 0,e.$Sp=f,e.$Up=b,e.$Wp=u,e.$Pp="__$__isNewStorageMarker",e.$Qp="__$__targetStorageMarker",e.$Rp=(0,C.$ni)("storageService");var k;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var v;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var $;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function f(d){const l=d.get(e.$Qp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class h extends j.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:h.a}){super(),this.m=l,this.b=this.B(new N.$ce),this.c=this.B(new N.$ce),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$_d),this.onWillSaveState=this.f.event,this.h=this.B(new I.$zh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,c,g){return N.Event.filter(this.b.event,i=>i.scope===l&&(c===void 0||i.key===c),g)}n(){this.j.value=(0,I.$Dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,c){const{key:g,external:i}=c;if(g===e.$Qp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:g,target:this.J(l)[g],external:i})}w(l){this.f.fire({reason:l})}get(l,c,g){return this.P(c)?.get(l,g)}getBoolean(l,c,g){return this.P(c)?.getBoolean(l,g)}getNumber(l,c,g){return this.P(c)?.getNumber(l,g)}getObject(l,c,g){return this.P(c)?.getObject(l,g)}storeAll(l,c){this.y(()=>{for(const g of l)this.store(g.key,g.value,g.scope,g.target,c)})}store(l,c,g,i,o=!1){if((0,O.$0f)(c)){this.remove(l,g,o);return}this.y(()=>{this.z(l,g,i),this.P(g)?.set(l,c,o)})}remove(l,c,g=!1){this.y(()=>{this.z(l,c,void 0),this.P(c)?.delete(l,g)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,c){const g=[],i=this.J(l);for(const o of Object.keys(i))i[o]===c&&g.push(o);return g}z(l,c,g,i=!1){const o=this.J(c);typeof g=="number"?o[l]!==g&&(o[l]=g,this.P(c)?.set(e.$Qp,JSON.stringify(o),i)):typeof o[l]=="number"&&(delete o[l],this.P(c)?.set(e.$Qp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const c=this.P(l);return c?f(c):Object.create(null)}isNew(l){return this.getBoolean(e.$Pp,l)===!0}async flush(l=k.NONE){this.f.fire({reason:l});const c=this.P(-1),g=this.P(0),i=this.P(1);switch(l){case k.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return u(l,c,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,c){return this.w(k.NONE),(0,m.$sl)(l)?this.R(l,c):this.S(l,c)}M(l,c){return!(l.id===c.id||b(c)&&b(l))}N(l,c,g){this.y(()=>{const i=new Set;for(const[o,n]of l)i.add(o),c.get(o)!==n&&this.u(g,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(g,{key:o,external:!0})})}}e.$Tp=h;function b(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class w extends h{constructor(){super(),this.U=this.B(new R.$Np(new R.$Op,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Np(new R.$Op,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Np(new R.$Op,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Vp=w;async function u(d,l,c,g,i,o){const n=p=>{try{return JSON.parse(p)}catch{return p}},s=new Map,t=new Map;d.forEach((p,D)=>{s.set(D,p),t.set(D,n(p))});const r=new Map,a=new Map;l.forEach((p,D)=>{r.set(D,p),a.set(D,n(p))});const E=new Map,S=new Map;c.forEach((p,D)=>{E.set(D,p),S.set(D,n(p))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const P=[];if(s.forEach((p,D)=>{P.push({key:D,value:p})}),console.table(P),console.groupEnd(),console.log(t),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const p=[];r.forEach((D,z)=>{p.push({key:z,value:D})}),console.table(p),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const y=[];E.forEach((p,D)=>{y.push({key:D,value:p})}),console.table(y),console.groupEnd(),console.log(S)}}),define(le[114],he([0,1,3,2,13,29,33,19]),function(se,e,I,N,j,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RIb=e.$QIb=void 0;let C=class extends N.$Uc{constructor(v,$){super(),this.a=new I.$_d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new m(v)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B($.onDidInstallExtensions(f=>f.forEach(({local:h,operation:b})=>{h&&b===4&&this.f(h.identifier)})))}async enableExtension(v,$){return this.f(v)?(this.a.fire({extensions:[v],source:$}),!0):!1}async disableExtension(v,$){return this.c(v)?(this.a.fire({extensions:[v],source:$}),!0):!1}getDisabledExtensions(){return this.h(A.$1o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(v){const $=this.getDisabledExtensions();return $.every(f=>!(0,O.$lp)(f,v))?($.push(v),this.g($),!0):!1}f(v){const $=this.getDisabledExtensions();for(let f=0;f<$.length;f++){const h=$[f];if((0,O.$lp)(h,v))return $.splice(f,1),this.g($),!0}return!1}g(v){this.j(A.$1o,v)}h(v){return this.b.get(v,0)}j(v,$){this.b.set(v,$,0)}};e.$QIb=C,e.$QIb=C=ve([Q(0,R.$Rp),Q(1,A.$Zo)],C);class m extends N.$Uc{constructor(v){super(),this.c=v,this.a=Object.create(null),this.b=this.B(new I.$_d),this.onDidChange=this.b.event,this.B(v.onDidChangeValue(0,void 0,this.B(new N.$Tc))($=>this.f($)))}get(v,$){let f;return $===0?((0,j.$0f)(this.a[v])&&(this.a[v]=this.g(v,$)),f=this.a[v]):f=this.g(v,$),JSON.parse(f)}set(v,$,f){const h=JSON.stringify($.map(({id:w,uuid:u})=>({id:w,uuid:u})));this.g(v,f)!==h&&(f===0&&($.length?this.a[v]=h:delete this.a[v]),this.h(v,$.length?h:void 0,f))}f(v){if(!(0,j.$0f)(this.a[v.key])&&this.g(v.key,v.scope)!==this.a[v.key]){const f=this.get(v.key,v.scope);delete this.a[v.key];const h=this.get(v.key,v.scope),b=f.filter(u=>!h.some(d=>(0,O.$lp)(u,d))),w=h.filter(u=>!f.some(d=>(0,O.$lp)(d,u)));(b.length||w.length)&&this.b.fire([...b,...w])}}g(v,$){return this.c.get(v,$,"[]")}h(v,$,f){$?this.c.store(v,$,f,1):this.c.remove(v,f)}}e.$RIb=m}),define(le[254],he([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$Zp=ae;const i=A.$o?"web":(0,v.$So)(A.$u,O.$fc),o="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((q,x)=>q|x,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class P{constructor(q=S){this.d=q}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(q,x=this.d.pageSize){return new P({...this.d,pageNumber:q,pageSize:x})}withFilter(q,...x){const J=[...this.d.criteria,...x.length?x.map(ee=>({filterType:q,value:ee})):[{filterType:q}]];return new P({...this.d,criteria:J})}withSortBy(q){return new P({...this.d,sortBy:q})}withSortOrder(q){return new P({...this.d,sortOrder:q})}withFlags(...q){return new P({...this.d,flags:q.reduce((x,J)=>x|J,0)})}withAssetTypes(...q){return new P({...this.d,assetTypes:q})}withSource(q){return new P({...this.d,source:q})}get raw(){const{criteria:q,pageNumber:x,pageSize:J,sortBy:ee,sortOrder:_,flags:Z,assetTypes:ne}=this.d;return{filters:[{criteria:q,pageNumber:x,pageSize:J,sortBy:ee,sortOrder:_}],assetTypes:ne,flags:Z}}get searchText(){const q=this.d.criteria.filter(x=>x.filterType===t.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(q=>String(q.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(T,q){const x=(T||[]).filter(J=>J.statisticName===q)[0];return x?x.value:0}function p(T){const q="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(J=>J.assetType.indexOf(q)===0).reduce((J,ee)=>{const _=F(T,ee.assetType);return _&&J.push([ee.assetType.substring(q.length),_]),J},[])}function D(T){if(T.properties){const q=T.properties.filter(ee=>ee.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=q.filter(ee=>x.test(ee.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return F(T,r.Repository)}function z(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function F(T,q){return T.files.filter(J=>J.assetType===q)[0]?{uri:`${T.assetUri}/${q}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${q}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function M(T,q){const x=T.properties?T.properties.filter(ee=>ee.key===q):[],J=x.length>0&&x[0].value;return J?J.split(",").map(ee=>(0,$.$pp)(ee)):[]}function X(T){const q=T.properties?T.properties.filter(x=>x.key===a.Engine):[];return q.length>0&&q[0].value||""}function G(T){const q=T.properties?T.properties.filter(x=>x.key===a.PreRelease):[];return q.length>0&&q[0].value==="true"}function Y(T){const q=T.properties?T.properties.filter(J=>J.key===a.LocalizedLanguages):[],x=q.length>0&&q[0].value||"";return x?x.split(","):[]}function V(T){return T.properties?.find(q=>q.key===a.SponsorLink)?.value}function K(T){return T.properties?.find(q=>q.key===a.SupportLink)?.value}function W(T){return T.indexOf("preview")!==-1}function B(T){return T.targetPlatform?(0,v.$Ro)(T.targetPlatform):"undefined"}function ie(T){const q=(0,I.$Mb)(T.versions.map(B)),x=!!T.tags?.includes(v.$Mo),J=q.indexOf("web");return x?J===-1&&q.push("web"):J!==-1&&q.splice(J,1),q}function ae(T,q){for(let x=0;x<T.length;x++){const J=T[x];if(J.version===T[x-1]?.version){let ee=x;if(B(J)===q)for(;ee>0&&T[ee-1].version===J.version;)ee--;ee!==x&&(T.splice(x,1),T.splice(ee,0,J))}}return T}function te(T,q,x){T.telemetryData={index:q,querySource:x,queryActivityId:T.queryContext?.[o]}}function ce(T,q,x,J){const ee=T.versions[0],_={manifest:F(q,r.Manifest),readme:F(q,r.Details),changelog:F(q,r.Changelog),license:F(q,r.License),repository:D(q),download:z(q),icon:F(q,r.Icon),signature:F(q,r.Signature),coreTranslations:p(q)};return{identifier:{id:(0,$.$qp)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:q.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(ee),description:T.shortDescription??"",installCount:y(T.statistics,"install"),rating:y(T.statistics,"averagerating"),ratingCount:y(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:x,assets:_,properties:{dependencies:M(q,a.Dependency),extensionPack:M(q,a.ExtensionPack),engine:X(q),localizedLanguages:Y(q),targetPlatform:B(q),isPreReleaseVersion:G(q)},hasPreReleaseVersion:G(ee),hasReleaseVersion:!0,preview:W(T.flags),isSigned:!!_.signature,queryContext:J,supportLink:K(ee)}}let H=class{constructor(q,x,J,ee,_,Z,ne,re){this.k=x,this.l=J,this.n=ee,this.o=_,this.q=Z,this.u=ne,this.w=re;const ue=ne.extensionsGallery,de=ue?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.d=de?ue.servicePPEUrl:ue?.serviceUrl,this.g=de?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,d.$Yp)(ne.version,ne,this.n,this.w,this.q,q,this.o)}x(q=""){return`${this.d}${q}`}isEnabled(){return!!this.d}async getExtensions(q,x,J){const ee=N.CancellationToken.isCancellationToken(x)?{}:x,_=N.CancellationToken.isCancellationToken(x)?x:J,Z=[],ne=[],re=[],ue=[];let de=!0;for(const Se of q){Se.uuid?ne.push(Se.uuid):Z.push(Se.id);const Ie=!!(Se.version||Se.preRelease);re.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&ue.push({id:Se.id,uuid:Se.uuid,version:Se.version}),de=de&&!!Se.hasPreRelease&&!Ie}if(!ne.length&&!Z.length)return[];let $e=new P().withPage(1,q.length);ne.length&&($e=$e.withFilter(t.ExtensionId,...ne)),Z.length&&($e=$e.withFilter(t.ExtensionName,...Z)),(ee.queryAllVersions||de)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??i,includePreRelease:re,versions:ue,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((Se,Ie)=>te(Se,Ie,ee.source)),ye}async getCompatibleExtension(q,x,J,ee={version:this.u.version,date:this.u.date}){if((0,v.$To)(q.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(q,x,J))return q;const _=new P().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,q.identifier.uuid),{extensions:Z}=await this.z(_,{targetPlatform:J,compatible:!0,includePreRelease:x,productVersion:ee},N.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(q,x,J,ee={version:this.u.version,date:this.u.date}){if(!(0,v.$Uo)(q.properties.targetPlatform,q.allTargetPlatforms,J)||!x&&q.properties.isPreReleaseVersion)return!1;let _=q.properties.engine;if(!_){const Z=await this.getManifest(q,N.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");_=Z.engines.vscode}return(0,f.$Dp)(_,ee.version,ee.date)}async y(q,x,J,ee,_,Z,ne={version:this.u.version,date:this.u.date}){if(!(0,v.$Uo)(B(x),_,Z)||J!=="any"&&G(x)!==(J==="prerelease"))return!1;if(ee)try{const re=await this.E(q,x);if(!(0,f.$Dp)(re,ne.version,ne.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,j.$0)(re)),!1}return!0}async query(q,x){let J=q.text||"";const ee=q.pageSize??50;let _=new P().withPage(1,ee);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,ye)=>(_=_.withFilter(t.Category,ye||$e),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,ye)=>(_=_.withFilter(t.Tag,ye||$e),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),_=_.withFilter(t.SearchText,J)),_=_.withSortBy(0)):q.ids?_=_.withFilter(t.ExtensionId,...q.ids):q.names?_=_.withFilter(t.ExtensionName,...q.names):_=_.withSortBy(4),typeof q.sortBy=="number"&&(_=_.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(_=_.withSortOrder(q.sortOrder)),q.source&&(_=_.withSource(q.source));const Z=async(de,$e)=>{const{extensions:ye,total:Se}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!q.includePreRelease,productVersion:q.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Ie,Le)=>te(Ie,(de.pageNumber-1)*de.pageSize+Le,q.source)),{extensions:ye,total:Se}},{extensions:ne,total:re}=await Z(_,x),ue=async(de,$e)=>{if($e.isCancellationRequested)throw new j.$5;const{extensions:ye}=await Z(_.withPage(de+1),$e);return ye};return{firstPage:ne,total:re,pageSize:_.pageSize,getPage:ue}}async z(q,x,J){const ee=q.flags;q.flags&n.IncludeLatestVersionOnly&&q.flags&n.IncludeVersions&&(q=q.withFlags(q.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(q.flags&n.IncludeLatestVersionOnly)&&!(q.flags&n.IncludeVersions)&&(q=q.withFlags(q.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(q=q.withFlags(q.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),q=q.withFlags(q.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Z,context:ne}=await this.B(q,J);if(!(q.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const Se=await this.A(ye,x,ne);Se&&$e.push(Se)}return{extensions:$e,total:Z}}const ue=[],de=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],Se={id:(0,$.$qp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ie=(0,R.$7f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(fe=>(0,$.$lp)(fe,Se))?.includePreRelease;if(x.compatible&&(0,v.$To)(ie(ye),x.targetPlatform))continue;const Le=await this.A(ye,x,ne);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==x.targetPlatform&&Le.hasPreReleaseVersion?de.set(ye.extensionId,$e):ue.push([$e,Le])}if(de.size){const $e=new g.$8d,ye=new P().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Se}=await this.z(ye,x,J);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:de.size});for(const Ie of Se){const Le=de.get(Ie.identifier.uuid);ue.push([Le,Ie])}}return{extensions:ue.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Z}}async A(q,x,J){const ee={id:(0,$.$qp)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},_=x.versions?.find(ue=>(0,$.$lp)(ue,ee))?.version,Z=(0,R.$7f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ue=>(0,$.$lp)(ue,ee))?.includePreRelease,ne=ie(q),re=ae(q.versions,x.targetPlatform);if(x.compatible&&(0,v.$To)(ne,x.targetPlatform))return null;for(let ue=0;ue<re.length;ue++){const de=re[ue];if(!(_&&de.version!==_)){if(await this.y((0,$.$qp)(q.publisher.publisherName,q.extensionName),de,Z?"any":"release",x.compatible,ne,x.targetPlatform,x.productVersion))return ce(q,de,ne,J);if(_&&de.version===_)return null}}return _||x.compatible?null:ce(q,q.versions[0],ne)}async B(q,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const J=await this.j,ee=JSON.stringify(q.raw),_={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new g.$8d;let ne,re,ue=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&q.criteria.some($e=>$e.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},x),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,u.$Kp)(ne);if(de){const $e=de.results[0],ye=$e.extensions,Se=$e.resultMetadata&&$e.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ue=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ue,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){const $e=(0,j.$4)(de)?v.ExtensionGalleryErrorCode.Cancelled:(0,j.$0)(de).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw re=new v.$Yo((0,j.$0)(de),$e),re}finally{this.o.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(ee.length),duration:Z.elapsed(),success:!!ne&&(0,u.$Gp)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:re?.code,count:String(ue)})}}async reportStatistic(q,x,J,ee){if(!this.isEnabled())return;const _=A.$o?this.x(`/itemName/${q}.${x}/version/${J}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${q}/extensions/${x}/${J}/stats?statType=${ee}`),Z=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:_,headers:re},N.CancellationToken.None)}catch{}}async download(q,x,J){this.l.trace("ExtensionGalleryService#download",q.identifier.id);const ee=(0,$.$tp)(q),_=new Date().getTime(),Z=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),ne=J===2?"install":J===3?"update":"",re=ne?{uri:`${q.assets.download.uri}${C.URI.parse(q.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${q.assets.download.fallbackUri}${C.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:q.assets.download,ue=q.queryContext?.[o]?{[o]:q.queryContext[o]}:void 0,de=await this.D(q.identifier.id,re,r.VSIX,ue?{headers:ue}:void 0);await this.q.writeFile(x,de.stream),Z(new Date().getTime()-_)}async downloadSignatureArchive(q,x){if(!q.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",q.identifier.id);const J=await this.D(q.identifier.id,q.assets.signature,r.Signature);await this.q.writeFile(x,J.stream)}async getReadme(q,x){if(q.assets.readme){const J=await this.D(q.identifier.id,q.assets.readme,r.Details,{},x);return await(0,u.$Jp)(J)||""}return""}async getManifest(q,x){if(q.assets.manifest){const J=await this.D(q.identifier.id,q.assets.manifest,r.Manifest,{},x),ee=await(0,u.$Jp)(J);return ee?JSON.parse(ee):null}return null}async C(q,x,J){const ee=F(x,r.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},Z=await this.D(q,ee,r.Manifest,{headers:_});return await(0,u.$Kp)(Z)}async getCoreTranslation(q,x){const J=q.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(J){const ee=await this.D(q.identifier.id,J[1],J[0]),_=await(0,u.$Jp)(ee);return _?JSON.parse(_):null}return null}async getChangelog(q,x){if(q.assets.changelog){const J=await this.D(q.identifier.id,q.assets.changelog,r.Changelog,{},x);return await(0,u.$Jp)(J)||""}return""}async getAllCompatibleVersions(q,x,J){let ee=new P().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);q.identifier.uuid?ee=ee.withFilter(t.ExtensionId,q.identifier.uuid):ee=ee.withFilter(t.ExtensionName,q.identifier.id);const{galleryExtensions:_}=await this.B(ee,N.CancellationToken.None);if(!_.length)return[];const Z=ie(_[0]);if((0,v.$To)(Z,J))return[];const ne=[];await Promise.all(_[0].versions.map(async de=>{try{await this.y(q.identifier.id,de,x?"any":"release",!0,Z,J)&&ne.push(de)}catch{}}));const re=[],ue=new Set;for(const de of ae(ne,J))ue.has(de.version)||(ue.add(de.version),re.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:G(de)}));return re}async D(q,x,J,ee={},_=N.CancellationToken.None){const Z=await this.j,ne={type:"GET"},re={...Z,...ee.headers||{}};ee={...ee,...ne,headers:re};const ue=x.uri,de=x.fallbackUri,$e={...ee,url:ue};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const Se=await(0,u.$Jp)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${Se}`)}catch(ye){if((0,j.$4)(ye))throw ye;const Se=(0,j.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:q,assetType:J,message:Se});const Ie={...ee,url:de};return this.k.request(Ie,_)}}async E(q,x){let J=X(x);if(!J){this.o.publicLog2("galleryService:engineFallback",{extension:q,version:x.version});const ee=await this.C(q,x,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");J=ee.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const q=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,u.$Kp)(q),J=[],ee={},_=[];if(x){for(const Z of x.malicious)J.push({id:Z});if(x.migrateToPreRelease)for(const[Z,ne]of Object.entries(x.migrateToPreRelease))(!ne.engine||(0,f.$Dp)(ne.engine,this.u.version,this.u.date))&&(ee[Z.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[Z,ne]of Object.entries(x.deprecated))ne&&(ee[Z.toLowerCase()]=(0,R.$7f)(ne)?{}:ne);if(x.search)for(const Z of x.search)_.push(Z)}return{malicious:J,deprecated:ee,search:_}}};H=ve([Q(1,u.$Ep),Q(2,b.$Tj),Q(3,k.$ui),Q(4,c.$Sl),Q(5,h.$Tk),Q(6,w.$ak),Q(7,m.$Ti)],H);let U=class extends H{constructor(q,x,J,ee,_,Z,ne,re){super(q,x,J,ee,_,Z,ne,re)}};e.$1p=U,e.$1p=U=ve([Q(0,l.$Rp),Q(1,u.$Ep),Q(2,b.$Tj),Q(3,k.$ui),Q(4,c.$Sl),Q(5,h.$Tk),Q(6,w.$ak),Q(7,m.$Ti)],U);let L=class extends H{constructor(q,x,J,ee,_,Z,ne){super(void 0,q,x,J,ee,_,Z,ne)}};e.$2p=L,e.$2p=L=ve([Q(0,u.$Ep),Q(1,b.$Tj),Q(2,k.$ui),Q(3,c.$Sl),Q(4,h.$Tk),Q(5,w.$ak),Q(6,m.$Ti)],L)}),define(le[82],he([0,1,4,3,2,19,33,24,17,9,13]),function(se,e,I,N,j,A,O,R,C,m,k){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=void 0,e.$Nv=(0,I.$ni)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends j.$Uc{static{v=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,O.$pp)(b.id)}@${b.version}`}static c(b){const w=$.exec(b);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(b,w){const u=await b.getInstalled(),d=[];for(const[l,c]of v.f(w)){const g=u.find(i=>(0,O.$lp)(i.identifier,{id:l}))?.manifest.version;for(const i of c)g!==i&&d.push(v.b({id:l,version:i}))}for(const l of d)w.remove(l,0)}static f(b){const w=new Map,u=b.keys(0,1);for(const d of u){const l=v.c(d);if(l){let c=w.get(l.id.toLowerCase());c||w.set(l.id.toLowerCase(),c=[]),c.push(l.version)}}return w}constructor(b,w,u){super(),this.j=b,this.m=w,this.n=u,this.g=this.B(new N.$_d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=v.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Tc))(d=>this.r(d)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const w=v.c(b.key);if(w){if(this.j.get(b.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let u=this.h.get(w.id.toLowerCase());u||this.h.set(w.id.toLowerCase(),u=[]),u.push(w.version),this.g.fire()}return}}s(b){if((0,k.$1f)(b))return b;const w=b.manifest?b.manifest.publisher:b.publisher,u=b.manifest?b.manifest.name:b.name;return(0,O.$op)(w,u)}getExtensionState(b,w){const u=this.s(b),d=this.getExtensionStateRaw(b,w);if(d)try{return JSON.parse(d)}catch(l){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${w}): ${l}`)}}getExtensionStateRaw(b,w){const u=this.s(b),d=this.j.get(u,w?0:1);return d&&d?.length>v.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${w}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(b,w,u){const d=this.s(b);w===void 0?this.j.remove(d,u?0:1):this.j.store(d,JSON.stringify(w),u?0:1,1)}setKeysForSync(b,w){this.j.store(v.b(b),JSON.stringify(w),0,1)}getKeysForSync(b){const w=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],u=this.j.get(v.b(b),0),d=u?JSON.parse(u):void 0;return d&&w?(0,C.$Mb)([...d,...w]):d||w}addToMigrationList(b,w){if(b!==w){const u=this.t.filter(d=>!d.includes(b)&&!d.includes(w));u.push([b,w]),this.t=u}}getSourceExtensionToMigrate(b){const w=this.t.find(([,u])=>b===u);return w?w[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(b);if(Array.isArray(w))return w}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Ov=f,e.$Ov=f=v=ve([Q(0,A.$Rp),Q(1,R.$ak),Q(2,m.$Tj)],f)}),define(le[255],he([0,1,2,29,82,230,113,9,19]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;let m=class extends I.$Uc{constructor(v,$,f,h,b,w){super(),v.cleanUp(),(0,A.$w3b)(v,$,f,h,w),j.$Ov.removeOutdatedExtensionVersions(v,b)}};e.$ndc=m,e.$ndc=m=ve([Q(0,O.$uq),Q(1,N.$Wo),Q(2,j.$Nv),Q(3,N.$3o),Q(4,C.$Rp),Q(5,R.$Tj)],m)}),define(le[256],he([0,1,29,12,24,16,96,57,19,22,229]),function(se,e,I,N,j,A,O,R,C,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;let v=class extends k.$J_b{constructor(f,h,b,w,u,d,l,c){super(f.userHome,u,h,b,w,d,l,c)}};e.$udc=v,e.$udc=v=ve([Q(0,A.$vi),Q(1,m.$Sl),Q(2,I.$Zo),Q(3,C.$Rp),Q(4,R.$kbc),Q(5,O.$g3b),Q(6,N.$Tk),Q(7,j.$ak)],v)}),define(le[257],he([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;const g=[I.$jdc,I.$kdc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Uc{constructor(a,E,S,P,y,p,D){super(),this.y=a,this.z=E,this.C=S,this.D=p,this.F=D,this.f=new N.$_d,this.onDidTokenFailed=this.f.event,this.g=new N.$_d,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$_d,this.onDidChangeMode=this.h.event,this.n=I.$hdc,this.w=!1,this.I=(z,F)=>{F?this.j.error(z):this.j.info(z)},this.j=this.B(P.createLogger((0,c.$1g)(S.logsHome,`${I.$ldc}.log`),{id:I.$ldc,name:I.$mdc})),this.t=new $.$kh(100),this.B(this.j.onDidChangeLogLevel(z=>this.j.info("Log level changed to "+(0,R.$9j)(z)))),this.B(y.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(p.onDidChangeConfiguration(z=>{g.some(F=>z.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}J(){if(!this.u){let a;v.$j?a=this.C.appRoot:a=(0,C.$nc)((0,C.$nc)(this.C.appRoot)),this.u=(0,C.$kc)(a,"bin",`${this.z.tunnelApplicationName}${v.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$hdc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(E){this.j.error(E)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",E=!1;const S=(F,M)=>{M?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,b.localize)(0,null)))},P=this.O("status",["status"],S);this.r=P;try{if(await P,this.r!==P)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(E=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(I.TunnelStates.disconnected());return}finally{this.r===P&&(this.r=void 0)}const y=this.n.active?this.n.session:void 0;if(y&&y.token){const F=y.token;this.G(I.TunnelStates.connecting((0,b.localize)(1,null,y.accountLabel,y.providerId)));const M=(G,Y)=>{G=G.replaceAll(F,"*".repeat(4)),S(G,Y)},X=this.O("login",["user","login","--provider",y.providerId,"--access-token",F,"--log",(0,R.$9j)(this.j.getLevel())],M);this.r=X;try{if(await X,this.r!==X)return}catch(G){this.j.error(G),this.r=void 0,this.f.fire(y),this.G(I.TunnelStates.disconnected(y));return}}const p=this.Q();p?this.G(I.TunnelStates.connecting((0,b.localize)(2,null,p))):this.G(I.TunnelStates.connecting((0,b.localize)(3,null)));const D=["--accept-server-license-terms","--log",(0,R.$9j)(this.j.getLevel())];p?D.push("--name",p):D.push("--random-name");let z=!1;return this.n.active&&this.n.asService&&!E&&(z=await this.M(D)===!1),this.N(y,D,z)}async M(a){let E;try{E=await this.O("serviceInstall",["service","install",...a])}catch(S){this.j.error(S),E=1}if(E!==0){const S=(0,b.localize)(4,null);return this.j.warn(S),this.G(I.TunnelStates.connecting(S)),!1}return!0}async N(a,E,S){E.push("--parent-process-id",String(process.pid)),this.P()&&E.push("--no-sleep");let P=!1;const y=this.O("tunnel",E,(p,D)=>{D?this.j.error(p):this.j.info(p),p.includes("Connected to an existing tunnel process")&&(P=!0);const z=p.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(z){const F={link:z[1],domain:z[2],tunnelName:z[4],isAttached:P};this.G(I.TunnelStates.connected(F,S))}else p.match(/error refreshing token/)&&(y.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=y,y.finally(()=>{y===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$hdc,this.G(I.TunnelStates.disconnected()))})}O(a,E,S=this.I){return(0,$.$ah)(P=>new Promise((y,p)=>{P.isCancellationRequested&&y(-1);let D;const z=["ignore","pipe","pipe"];if(P.onCancellationRequested(()=>{D&&(this.j.info(`${a} terminating(${D.pid})`),D.kill())}),!this.C.isBuilt)S(`Building tunnel CLI from sources and run
`,!1),S(`${a} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),D=(0,m.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,C.$kc)(this.C.appRoot,"cli"),stdio:z});else{S(`Running tunnel CLI
`,!1);const F=this.J();S(`${a} Spawning: ${F} tunnel ${E.join(" ")}
`,!1),D=(0,m.spawn)(F,["tunnel",...E],{cwd:(0,w.homedir)(),stdio:z})}D.stdout.pipe(new l.$dW(`
`)).on("data",F=>{if(D){const M=F.toString();S(M,!1)}}),D.stderr.pipe(new l.$dW(`
`)).on("data",F=>{if(D){const M=F.toString();S(M,!0)}}),D.on("exit",F=>{D&&(S(`${a} exit(${D.pid}): + ${F} `,!1),D=void 0,y(F||0))}),D.on("error",F=>{D&&(S(`${a} error(${D.pid}): + ${F} `,!0),D=void 0,p())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$kdc)}Q(){let a=this.D.getValue(I.$jdc)||(0,w.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),E=this.F.getBoolean(o,-1,!1);if(a){const S=JSON.parse(a);if(S&&(0,d.$1f)(S.accountLabel)&&(0,d.$1f)(S.sessionId)&&(0,d.$1f)(S.providerId))return{active:!0,session:S,asService:E};this.j.error("Problems restoring session from storage, invalid format",S)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$hdc}S(a){if(a.active){const E={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(E),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$qdc=n,e.$qdc=n=ve([Q(0,j.$Sl),Q(1,k.$ak),Q(2,A.$vi),Q(3,R.$Uj),Q(4,f.$odc),Q(5,h.$Ti),Q(6,u.$Rp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[258],he([0,1,6,2,23,20,69,19,77,18]),function(se,e,I,N,j,A,O,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class k extends R.$Tp{constructor($,f,h,b){super(),this.bb=$,this.cb=f,this.db=h,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Tc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new C.$qJb(this.db.getChannel("storage"))),f=this.B(new O.$Np($));return this.B(f.onDidChangeStorage(h=>this.u(-1,h))),f}gb($){this.X.clear(),this.W=$;let f;if((0,R.$Up)($))f=this.U;else{const h=this.X.add(new C.$rJb(this.db.getChannel("storage"),$));f=this.X.add(new O.$Np(h))}return this.X.add(f.onDidChangeStorage(h=>this.u(0,h))),f}hb($){this.$.clear(),this.Z=$?.id;let f;if($){const h=this.$.add(new C.$sJb(this.db.getChannel("storage"),$));f=this.$.add(new O.$Np(h)),this.$.add(f.onDidChangeStorage(b=>this.u(1,b)))}return f}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q($){switch($){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$1g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const f=this.Y,h=f.items;f!==this.U&&await f.close(),this.Y=this.gb($),await this.Y.init(),this.N(h,this.Y,0)}async S($,f){const h=this.ab,b=h?.items??new Map;await h?.close(),this.ab=this.hb($),await this.ab.init(),this.N(b,this.ab,1)}hasScope($){return(0,m.$sl)($)?this.W.id===$.id:this.Z===$.id}}e.$vdc=k}),define(le[259],he([0,1,3,2,18,91]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0;class O{constructor(m,k){this.a=m,this.b=k}listen(m,k){const v=this.b(m);switch(k){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(f=>(0,A.$rn)({...f},v)),added:$.added.map(f=>(0,A.$rn)({...f},v)),removed:$.removed.map(f=>(0,A.$rn)({...f},v)),updated:$.updated.map(f=>(0,A.$rn)({...f},v))}))}throw new Error(`Invalid listen ${k}`)}async call(m,k,v){const $=this.b(m);switch(k){case"createProfile":{const f=await this.a.createProfile(v[0],v[1],v[2]);return(0,A.$rn)({...f},$)}case"updateProfile":{let f=(0,j.$ul)((0,A.$sn)(v[0],$),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,v[1]),(0,A.$rn)({...f},$)}case"removeProfile":{const f=(0,j.$ul)((0,A.$sn)(v[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${k}`)}}e.$mQ=O;class R extends N.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,k,v){super(),this.profilesHome=k,this.f=v,this.a=[],this.b=this.B(new I.$_d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map($=>(0,j.$ul)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const f=$.added.map(w=>(0,j.$ul)(w,this.profilesHome.scheme)),h=$.removed.map(w=>(0,j.$ul)(w,this.profilesHome.scheme)),b=$.updated.map(w=>(0,j.$ul)(w,this.profilesHome.scheme));this.a=$.all.map(w=>(0,j.$ul)(w,this.profilesHome.scheme)),this.b.fire({added:f,removed:h,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,k,v){const $=await this.f.call("createNamedProfile",[m,k,v]);return(0,j.$ul)($,this.profilesHome.scheme)}async createProfile(m,k,v,$){const f=await this.f.call("createProfile",[m,k,v,$]);return(0,j.$ul)(f,this.profilesHome.scheme)}async createTransientProfile(m){const k=await this.f.call("createTransientProfile",[m]);return(0,j.$ul)(k,this.profilesHome.scheme)}async setProfileForWorkspace(m,k){await this.f.call("setProfileForWorkspace",[m,k])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,k){const v=await this.f.call("updateProfile",[m,k]);return(0,j.$ul)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$nQ=R}),define(le[60],he([0,1,2,69,4,19,3,77,18]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJb=e.$vJb=e.$uJb=void 0,e.$uJb=(0,j.$ni)("IUserDataProfileStorageService");let m=class extends I.$Uc{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async h=>this.b(h))}async updateStorageData(f,h,b){return this.withProfileScopedStorageService(f,async w=>this.c(w,h,b))}async withProfileScopedStorageService(f,h){if(this.a.hasScope(f))return h(this.a);const b=await this.g(f),w=new v(b);try{await w.initialize();const u=await h(w);return await w.flush(),u}finally{w.dispose(),await this.f(b)}}b(f){const h=new Map,b=w=>{for(const u of f.keys(0,w))h.set(u,{value:f.get(u,0),target:w})};return b(0),b(1),h}c(f,h,b){f.storeAll(Array.from(h.entries()).map(([w,u])=>({key:w,value:u,scope:0,target:b})),!0)}async f(f){try{await f.close()}finally{(0,I.$Oc)(f)&&f.dispose()}}};e.$vJb=m,e.$vJb=m=ve([Q(0,A.$Rp)],m);class k extends m{constructor(f,h,b,w){super(b),this.j=f;const u=f.getChannel("profileStorageListener"),d=this.B(new I.$Vc);this.h=this.B(new O.$_d({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(l=>{w.trace("profile storage changes",l),this.h.fire({targetChanges:l.targetChanges.map(c=>(0,C.$ul)(c,h.profilesHome.scheme)),valueChanges:l.valueChanges.map(c=>({...c,profile:(0,C.$ul)(c.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(f){const h=this.j.getChannel("storage");return(0,A.$Up)(f)?new R.$qJb(h):new R.$rJb(h,f)}}e.$wJb=k;class v extends A.$Tp{constructor(f){super({flushInterval:100}),this.s=this.B(new N.$Np(f))}O(){return this.s.init()}P(f){return f===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[260],he([0,1,19,9,18,56,60]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;let R=class extends O.$wJb{constructor(m,k,v,$){super(m,k,v,$)}};e.$adc=R,e.$adc=R=ve([Q(0,A.$zcc),Q(1,j.$tl),Q(2,I.$Rp),Q(3,N.$Tj)],R)}),define(le[39],he([0,1,17,6,15,26,3,34,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vKb=e.$uKb=e.$tKb=e.$sKb=void 0,e.$pKb=i,e.$qKb=o,e.$rKb=n;function i(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||o(E.syncData)))}function o(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}function n(E,S){return`${(0,m.$Sf)(E)}${S.isDefault?"":` (${S.name})`}`}let s=class extends C.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(S,P,y,p,D,z,F,M,X,G,Y,V){super(),this.syncResource=S,this.collection=P,this.G=y,this.H=p,this.I=D,this.J=z,this.L=F,this.M=M,this.N=X,this.O=G,this.P=Y,this.c=null,this.m="idle",this.n=this.B(new O.$_d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$_d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$lh(50)),this.w=this.B(new O.$_d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(S.syncResource,S.profile),this.h=V.extUri,this.f=this.h.joinPath(p.userDataSyncHome,...(0,c.$vzb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,c.$Qzb),this.y=(0,c.$wzb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,p,this.h),this.j=(0,w.$Xp)(p,y,D)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const P=await this.Y(S.remoteUserData,S.lastSyncUserData,!0,this.ob());this.S(P)}else{this.O.trace(`${this.D}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.ub(S):!0)&&this.w.fire()}}S(S){this.m!==S&&(this.m=S,this.n.fire(S))}async sync(S,P={}){await this.U(S,!0,this.ob(),P)}async preview(S,P,y={}){return this.U(S,!1,P,y)}async apply(S,P={}){try{this.F={...P};const y=await this.ab(S);return this.S(y),this.c}finally{this.F={}}}async U(S,P,y,p){try{if(this.F={...p},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let D="idle";try{const z=await this.getLastSyncUserData(),F=await this.X(S,z);return D=await this.Y(F,z,P,y),D==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):D==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(D)}}finally{this.F={}}}async replace(S){const P=this.kb(S);if(!P)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const y=await this.getLastSyncUserData(),p=await this.X(null,y),D=await this.W(p),z=await this.qb({ref:p.ref,syncData:P},y,D,this.ob(),A.CancellationToken.None),F=[];for(const M of z){const X=await this.sb(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:G}=await this.sb(M,M.previewResource,M.remoteContent,A.CancellationToken.None);F.push([M,{...X,remoteChange:G!==0?G:2}])}await this.tb(p,y,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(S){const P=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===P}async X(S,P){if(P){const y=S?S[this.resource]:void 0;if(P.ref===y||y===void 0&&P.syncData===null)return P}return this.getRemoteUserData(P)}async Y(S,P,y,p){if(S.syncData&&S.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$Dzb((0,v.localize)(0,null,this.resource,this.pb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(S,P,y,p)}catch(D){if(D instanceof c.$Dzb)switch(D.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(S,P,y,p);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),P=await this.getLastSyncUserData(),this.Y(S,P,y,p)}throw D}}async Z(S,P,y,p){try{const D=await this.W(S),z=!D&&P===null&&this.gb()!==void 0,F=y&&!z;this.c||(this.c=(0,N.$ah)(X=>this.eb(S,P,D,F,p,X)));let M=await this.c;if(y&&z){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of M.resourcePreviews)M=await this.accept(X.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:X})=>X==="conflict")?"hasConflicts":y?await this.ab(!1):"syncing"}catch(D){throw this.c=null,D}}async merge(S){return await this.$(S,async P=>{const y=await this.rb(P,A.CancellationToken.None);await this.G.writeFile(P.previewResource,j.$ze.fromString(y?.content||""));const p=y&&!y.hasConflicts?await this.sb(P,P.previewResource,void 0,A.CancellationToken.None):void 0;return P.acceptResult=p,P.mergeState=y.hasConflicts?"conflict":p?"accepted":"preview",P.localChange=p?p.localChange:y.localChange,P.remoteChange=p?p.remoteChange:y.remoteChange,P}),this.c}async accept(S,P){return await this.$(S,async y=>{const p=await this.sb(y,S,P,A.CancellationToken.None);return y.acceptResult=p,y.mergeState="accepted",y.localChange=p.localChange,y.remoteChange=p.remoteChange,y}),this.c}async discard(S){return await this.$(S,async P=>{const y=await this.rb(P,A.CancellationToken.None);return await this.G.writeFile(P.previewResource,j.$ze.fromString(y.content||"")),P.acceptResult=void 0,P.mergeState="preview",P.localChange=y.localChange,P.remoteChange=y.remoteChange,P}),this.c}async $(S,P){if(!this.c)return;let y=await this.c;const p=y.resourcePreviews.findIndex(({localResource:D,remoteResource:z,previewResource:F})=>this.h.isEqual(D,S)||this.h.isEqual(z,S)||this.h.isEqual(F,S));p!==-1&&(this.c=(0,N.$ah)(async D=>{const z=[...y.resourcePreviews];return z[p]=await P(z[p]),{...y,resourcePreviews:z}}),y=await this.c,this.cb(y.resourcePreviews),y.resourcePreviews.some(({mergeState:D})=>D==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(S){if(!this.c)return"idle";const P=await this.c;return P.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":P.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.tb(P.remoteUserData,P.lastSyncUserData,P.resourcePreviews.map(y=>[y,y.acceptResult]),S),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(S){const P=S.filter(({mergeState:y})=>y==="conflict");(0,I.$ub)(this.s,P,(y,p)=>this.h.isEqual(y.previewResource,p.previewResource))||(this.s=P,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async db(S){const P=this.c?await this.c:null;if(P)for(const y of P.resourcePreviews){if(this.h.isEqual(y.acceptedResource,S))return y.acceptResult?y.acceptResult.content:null;if(this.h.isEqual(y.remoteResource,S))return y.remoteContent;if(this.h.isEqual(y.localResource,S))return y.localContent;if(this.h.isEqual(y.baseResource,S))return y.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(S){(0,h.$$k)(S)!==1&&this.O.error(S)}}async eb(S,P,y,p,D,z){const F=await this.qb(S,P,y,D,z),M=[];for(const X of F){const G=X.previewResource.with({scheme:c.$Pzb,authority:"accepted"});if(X.localChange===0&&X.remoteChange===0)M.push({...X,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=p?await this.rb(X,z):void 0;if(z.isCancellationRequested)break;await this.G.writeFile(X.previewResource,j.$ze.fromString(Y?.content||""));const V=Y&&!Y.hasConflicts?await this.sb(X,X.previewResource,void 0,z):void 0;M.push({...X,acceptResult:V,mergeState:Y?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:Y?Y.localChange:X.localChange,remoteChange:V?V.remoteChange:Y?Y.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:P,resourcePreviews:M,isLastSyncFromCurrentMachine:y}}async getLastSyncUserData(){let S=this.gb();if(S||(S=await this.jb()),!S)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const P=JSON.parse(S),y=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!P.version&&!!y&&P.version!==y,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${P.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;let p,D=1;for(;p===void 0&&D++<6;)try{const z=await this.hb();z&&(z.ref===P.ref?p=z.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof h.$cl&&z.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(z instanceof c.$Dzb)throw z;this.O.error(z,D)}}if(p===void 0)try{const z=await this.J.resolveResourceContent(this.resource,P.ref,this.collection,this.F);p=z===null?null:this.kb(z),await this.ib({ref:P.ref,syncData:p})}catch(z){if(z instanceof c.$Dzb&&z.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw z}return p===void 0?null:{...P,syncData:p}}async fb(S,P={}){if(P.ref||P.version)throw new Error("Cannot have core properties as additional");const y=this.M.getResourceSyncStateVersion(this.resource),p={ref:S.ref,version:y,...P};this.I.store(this.z,JSON.stringify(p),-1,1),await this.ib(S)}gb(){return this.I.get(this.z,-1)}async hb(){const S=(await this.G.readFile(this.y)).value.toString();try{const P=S?JSON.parse(S):void 0;if(i(P))return P}catch(P){this.O.error(P)}}async ib(S){await this.G.writeFile(this.y,j.$ze.fromString(JSON.stringify(S)))}async jb(){try{const S=await this.G.readFile(this.y),P=JSON.parse(S.value.toString());await this.G.del(this.y),P.ref&&P.content!==void 0?(this.I.store(this.z,JSON.stringify({...P,content:void 0}),-1,1),await this.ib({ref:P.ref,syncData:P.content===null?null:JSON.parse(P.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,P)}catch(S){S instanceof h.$cl&&S.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(S)}return this.I.get(this.z,-1)}async getRemoteUserData(S){const{ref:P,content:y}=await this.lb(S);let p=null;return y!==null&&(p=this.kb(y)),{ref:P,syncData:p}}kb(S){try{const P=JSON.parse(S);if(o(P))return P}catch(P){this.O.error(P)}throw new c.$Dzb((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(S){const P=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.J.readResource(this.resource,P,this.collection,this.F)}async mb(S,P){const y=await this.j,p={version:this.pb,machineId:y,content:S};try{return P=await this.J.writeResource(this.resource,JSON.stringify(p),P,this.collection,this.F),{ref:P,syncData:p}}catch(D){throw D instanceof c.$Dzb&&D.code==="TooLarge"&&(D=new c.$Dzb(D.message,D.code,this.resource)),D}}async nb(S){const P={version:this.pb,content:S};return this.L.writeResource(this.resource,JSON.stringify(P),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$qzb)}};e.$sKb=s,e.$sKb=s=ve([Q(2,h.$Tk),Q(3,f.$ui),Q(4,u.$Rp),Q(5,c.$yzb),Q(6,c.$zzb),Q(7,c.$Izb),Q(8,d.$Sl),Q(9,c.$Nzb),Q(10,$.$Ti),Q(11,l.$rl)],s);let t=class extends s{constructor(S,P,y,p,D,z,F,M,X,G,Y,V,K){super(P,y,p,D,z,F,M,X,G,Y,V,K),this.r=S,this.B(this.G.watch(this.h.dirname(S))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(S,P,y){try{P?await this.G.writeFile(this.r,j.$ze.fromString(S),y?void 0:P):await this.G.createFile(this.r,j.$ze.fromString(S),{overwrite:y})}catch(p){throw p instanceof h.$cl&&p.fileOperationResult===1||p instanceof h.$cl&&p.fileOperationResult===3?new c.$Dzb(p.message,"LocalPreconditionFailed"):p}}async xb(){try{await this.G.del(this.r)}catch(S){if(!(S instanceof h.$cl&&S.fileOperationResult===1))throw S}}yb(S){S.contains(this.r)&&this.Q()}};e.$tKb=t,e.$tKb=t=ve([Q(3,h.$Tk),Q(4,f.$ui),Q(5,u.$Rp),Q(6,c.$yzb),Q(7,c.$zzb),Q(8,c.$Izb),Q(9,d.$Sl),Q(10,c.$Nzb),Q(11,$.$Ti),Q(12,l.$rl)],t);let r=class extends t{constructor(S,P,y,p,D,z,F,M,X,G,Y,V,K,W){super(S,P,y,p,D,z,F,M,X,G,Y,K,W),this.zb=V,this.Bb=void 0}Ab(S,P){const y=[],p=(0,R.$An)(S,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,k.$8f)(p)&&P!==Array.isArray(p)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$uKb=r,e.$uKb=r=ve([Q(3,h.$Tk),Q(4,f.$ui),Q(5,u.$Rp),Q(6,c.$yzb),Q(7,c.$zzb),Q(8,c.$Izb),Q(9,d.$Sl),Q(10,c.$Nzb),Q(11,c.$Mzb),Q(12,$.$Ti),Q(13,l.$rl)],r);let a=class{constructor(S,P,y,p,D,z,F){this.resource=S,this.g=P,this.h=y,this.j=p,this.k=D,this.l=z,this.d=F.extUri,this.f=(0,c.$wzb)(void 0,this.resource,y,this.d)}async initialize({ref:S,content:P}){if(!P){this.j.info("Remote content does not exist.",this.resource);return}const y=this.m(P);if(y)try{await this.o({ref:S,syncData:y})}catch(p){this.j.error(p)}}m(S){try{const P=JSON.parse(S);if(o(P))return P}catch(P){this.j.error(P)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,P={}){if(P.ref||P.version)throw new Error("Cannot have core properties as additional");const y={ref:S.ref,version:void 0,...P};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(y),-1,1),await this.k.writeFile(this.f,j.$ze.fromString(JSON.stringify(S)))}};e.$vKb=a,e.$vKb=a=ve([Q(1,g.$tl),Q(2,f.$ui),Q(3,b.$Tj),Q(4,h.$Tk),Q(5,u.$Rp),Q(6,l.$rl)],a)}),define(le[115],he([0,1,6,26,7,3,43,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=e.$Q0b=e.$P0b=void 0,e.$N0b=S,e.$O0b=P;async function E(z,F){const M=JSON.parse(z.content);if(z.version===1||z.version===2){const X=(await F.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of M)z.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),z.version===2&&X.every(Y=>!(0,f.$lp)(Y.identifier,G.identifier))&&(G.installed=!0)}return M}function S(z){return JSON.parse(z.content)}function P(z,F){return z.sort((M,X)=>!M.identifier.uuid&&X.identifier.uuid?-1:M.identifier.uuid&&!X.identifier.uuid?1:(0,C.$jf)(M.identifier.id,X.identifier.id)),F?(0,O.$Ln)(z,{}):JSON.stringify(z)}let y=class extends n.$sKb{constructor(F,M,X,G,Y,V,K,W,B,ie,ae,te,ce,H,U,L,T){super({syncResource:"extensions",profile:F},M,G,X,Y,V,K,te,ce,ie,ae,U),this.Cb=W,this.Db=B,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Pzb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Pzb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Pzb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Pzb,authority:"accepted"}),this.Bb=this.Eb.createInstance(p),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,q=>q.some(({local:x})=>!!x)),A.Event.filter(this.Cb.onDidUninstallExtension,q=>!q.error),A.Event.filter(L.onDidChange,q=>q.valueChanges.some(({profile:x,changes:J})=>this.syncResource.profile.id===x.id&&J.some(ee=>ee.key===$.$1o))),H.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,M){const X=F.syncData?await E(F.syncData,this.Cb):null,G=M?.skippedExtensions??[],Y=M?.builtinExtensions??null,V=M?.syncData?await E(M.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);X?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$M0b)(K,X,V,G,W,Y),ae={local:B,remote:ie,content:this.Hb(K,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},te=this.Ob(K,!1);return[{skippedExtensions:G,builtinExtensions:Y,baseResource:this.xb,baseContent:V?this.Ob(V,!1):te,localResource:this.yb,localContent:te,localExtensions:K,remoteResource:this.zb,remoteExtensions:X,remoteContent:X?this.Ob(X,!1):null,previewResource:this.wb,previewResult:ae,localChange:ae.localChange,remoteChange:ae.remoteChange,acceptedResource:this.Ab}]}async ub(F){const M=F.syncData?await E(F.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Y}=(0,s.$M0b)(X,M,M,F.skippedExtensions||[],G,F.builtinExtensions||[]);return Y!==null}Hb(F,M,X,G){const Y=[...M,...X],V=new Set,K=W=>{V.add(W.id.toLowerCase()),W.uuid&&V.add(W.uuid)};Y.forEach(({identifier:W})=>K(W)),G.forEach(K);for(const W of F)V.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&V.has(W.identifier.uuid)||Y.push(W);return this.Ob(Y,!1)}async rb(F,M){return{...F.previewResult,hasConflicts:!1}}async sb(F,M,X,G){if(this.h.isEqual(M,this.yb))return this.Kb(F);if(this.h.isEqual(M,this.zb))return this.Lb(F);if(this.h.isEqual(M,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(M),G=(0,s.$M0b)(F.localExtensions,null,null,F.skippedExtensions,X,F.builtinExtensions),{local:Y,remote:V}=G;return{content:F.localContent,local:Y,remote:V,localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Lb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(M),G=F.remoteContent?JSON.parse(F.remoteContent):null;if(G!==null){const Y=(0,s.$M0b)(F.localExtensions,G,F.localExtensions,[],X,F.builtinExtensions),{local:V,remote:K}=Y;return{content:F.remoteContent,local:V,remote:K,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,M,X,G){let{skippedExtensions:Y,builtinExtensions:V,localExtensions:K}=X[0][0];const{local:W,remote:B,localChange:ie,remoteChange:ae}=X[0][1];if(ie===0&&ae===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(K)),Y=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,Y,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const te=JSON.stringify(B.all);F=await this.mb(te,G?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ce=>ce.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ce=>ce.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ce=>ce.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(K,V),await this.fb(F,{skippedExtensions:Y,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${Y.length?` Skipped: ${JSON.stringify(Y.map(te=>te.identifier.id))}.`:""}`))}Nb(F,M){const X=new Set,G=[];for(const Y of F)X.add(Y.identifier.id.toLowerCase()),Y.installed||G.push(Y.identifier);if(M)for(const Y of M)X.has(Y.id.toLowerCase())||G.push(Y);return G}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const M=await this.db(F);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(F,M){return P(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$P0b=y,e.$P0b=y=ve([Q(2,k.$ui),Q(3,w.$Tk),Q(4,c.$Rp),Q(5,r.$yzb),Q(6,r.$zzb),Q(7,$.$Zo),Q(8,t.$eLb),Q(9,r.$Nzb),Q(10,m.$Ti),Q(11,r.$Izb),Q(12,g.$Sl),Q(13,h.$Nv),Q(14,i.$rl),Q(15,a.$uJb),Q(16,u.$mi)],y);let p=class{constructor(F,M,X,G,Y,V){this.a=F,this.b=M,this.c=X,this.d=G,this.f=Y,this.g=V}async getLocalExtensions(F){const M=await this.a.getInstalled(void 0,F.extensionsResource),X=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(F,async(Y,V)=>{const K=Y.getDisabledExtensions();return M.map(W=>{const{identifier:B,isBuiltin:ie,manifest:ae,preRelease:te,pinned:ce,isApplicationScoped:H}=W,U={identifier:B,preRelease:te,version:ae.version,pinned:!!ce};H&&!(0,b.$Lm)(ae)&&(U.isApplicationScoped=H),K.some(L=>(0,f.$lp)(L,B))&&(U.disabled=!0),ie||(U.installed=!0);try{const L=V.getKeysForSync({id:B.id,version:ae.version});if(L){const T=V.getExtensionState(W,!0)||{};U.state=Object.keys(T).reduce((q,x)=>(L.includes(x)&&(q[x]=T[x]),q),{})}}catch(L){this.g.info(`${(0,n.$rKb)("extensions",F)}: Error while parsing extension state`,(0,j.$0)(L))}return U})}),ignoredExtensions:X}}async updateLocalExtensions(F,M,X,G,Y){const V=(0,n.$rKb)("extensions",Y),K=[],W=new Map,B=[],ie=[],ae=await this.a.getInstalled(void 0,Y.extensionsResource);if((F.length||X.length)&&await this.j(Y,async(H,U)=>{await I.Promises.settled([...F,...X].map(async L=>{const T=ae.find(J=>(0,f.$lp)(J.identifier,L.identifier));if(T&&T.isBuiltin){L.state&&T.manifest.version===L.version&&this.h(L.state,T,T.manifest.version,U),H.getDisabledExtensions().some(ee=>(0,f.$lp)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${V}: Disabling extension...`,L.identifier.id),await H.disableExtension(L.identifier),this.g.info(`${V}: Disabled extension`,L.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,L.identifier.id),await H.enableExtension(L.identifier),this.g.info(`${V}: Enabled extension`,L.identifier.id))),B.push(L.identifier);return}const q=L.pinned?L.version:void 0,x=(await this.c.getExtensions([{...L.identifier,version:q,preRelease:q?void 0:L.preRelease}],N.CancellationToken.None))[0];if(L.state&&(T?T.manifest.version===L.version:x)&&this.h(L.state,T||x,T?.manifest.version,U),x)try{H.getDisabledExtensions().some(ee=>(0,f.$lp)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${V}: Disabling extension...`,L.identifier.id,x.version),await H.disableExtension(x.identifier),this.g.info(`${V}: Disabled extension`,L.identifier.id,x.version)):(this.g.trace(`${V}: Enabling extension...`,L.identifier.id,x.version),await H.enableExtension(x.identifier),this.g.info(`${V}: Enabled extension`,L.identifier.id,x.version))),(!T||T.preRelease!==L.preRelease||T.pinned!==L.pinned||q&&T.manifest.version!==q)&&(await this.a.canInstall(x)?(K.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:L.pinned&&!!L.version,installPreReleaseVersion:L.preRelease,profileLocation:Y.extensionsResource,isApplicationScoped:L.isApplicationScoped,context:{[$.$No]:!0,[$.$Oo]:!0}}}),W.set(x.identifier.id.toLowerCase(),L)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ie.push(L)))}catch(J){ie.push(L),this.g.error(J),this.g.info(`${V}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ie.push(L),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,L.identifier.id)}))}),M.length){const H=ae.filter(({identifier:U,isBuiltin:L})=>!L&&M.some(T=>(0,f.$lp)(U,T)));await I.Promises.settled(H.map(async U=>{this.g.trace(`${V}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Y.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,U.identifier.id),B.push(U.identifier)}))}const te=await this.a.installGalleryExtensions(K);for(const{identifier:H,local:U,error:L,source:T}of te){const q=T;if(U)this.g.info(`${V}: Installed extension.`,H.id,q.version),B.push(H);else{const x=W.get(H.id.toLowerCase());x&&(ie.push(x),this.g.info(`${V}: Skipped synchronizing extension`,q.displayName||q.identifier.id)),L instanceof $.$Xo&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(L.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,q.displayName||q.identifier.id):L&&this.g.error(L)}}const ce=[];for(const H of G)B.some(U=>(0,f.$lp)(U,H.identifier))||ce.push(H);for(const H of ie)ce.some(U=>(0,f.$lp)(U.identifier,H.identifier))||ce.push(H);return ce}h(F,M,X,G){const Y=G.getExtensionState(M,!0)||{},V=X?G.getKeysForSync({id:M.identifier.id,version:X}):void 0;V?V.forEach(K=>{Y[K]=F[K]}):Object.keys(F).forEach(K=>Y[K]=F[K]),G.setExtensionState(M,Y,!0)}async j(F,M){return this.b.withProfileScopedStorageService(F,async X=>{const G=new R.$Tc,Y=this.f.createChild(new d.$li([c.$Rp,X])),V=G.add(Y.createInstance(v.$QIb)),K=G.add(Y.createInstance(h.$Ov));try{return await M(V,K)}finally{G.dispose()}})}};e.$Q0b=p,e.$Q0b=p=ve([Q(0,$.$Zo),Q(1,a.$uJb),Q(2,$.$Wo),Q(3,t.$eLb),Q(4,u.$mi),Q(5,r.$Nzb)],p);let D=class extends n.$vKb{constructor(F,M,X,G,Y,V,K,W){super("extensions",G,Y,V,X,K,W),this.p=F,this.q=M}async t(F){return F.syncData?await E(F.syncData,this.p):null}u(F,M){const X=[],G=[],Y=[];for(const V of F){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const K=M.find(W=>(0,f.$lp)(W.identifier,V.identifier));K?(X.push(K),V.disabled&&Y.push(V.identifier)):V.installed&&(G.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&Y.push(V.identifier))}return{installedExtensions:X,newExtensions:G,disabledExtensions:Y,remoteExtensions:F}}};e.$R0b=D,e.$R0b=D=ve([Q(0,$.$Zo),Q(1,t.$eLb),Q(2,w.$Tk),Q(3,o.$tl),Q(4,k.$ui),Q(5,l.$Tj),Q(6,c.$Rp),Q(7,i.$rl)],D)}),define(le[116],he([0,1,15,7,3,34,43,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BKb=e.$AKb=e.$zKb=e.$yKb=void 0,e.$xKb=t;const n="globalState.argv.",s=["locale"];function t(y,p){const D=y.storage?Object.keys(y.storage).sort():[],z={};return D.forEach(F=>z[F]=y.storage[F]),y.storage=z,p?(0,O.$Ln)(y,{}):JSON.stringify(y)}const r=1;let a=class extends u.$sKb{constructor(p,D,z,F,M,X,G,Y,V,K,W,B,ie,ae){super({syncResource:"globalState",profile:p},D,F,Y,B,M,X,V,K,G,W,ie),this.Bb=z,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$Pzb,authority:"base"}),this.xb=this.vb.with({scheme:c.$Pzb,authority:"local"}),this.yb=this.vb.with({scheme:c.$Pzb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$Pzb,authority:"accepted"}),this.Ab=ae.createInstance(E),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(F.onDidFilesChange,te=>te.contains(this.H.argvResource)),j.Event.filter(z.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:H})=>this.syncResource.profile.id===ce.id&&H.some(U=>U.target===0)))))(()=>this.Q()))}async qb(p,D,z){const F=p.syncData?JSON.parse(p.syncData.content):null;D=D===null&&z?p:D;const M=D&&D.syncData?JSON.parse(D.syncData.content):null,X=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Jb(M),{local:Y,remote:V}=(0,l.$wKb)(X.storage,F?F.storage:null,M?M.storage:null,G,this.O),K={content:null,local:Y,remote:V,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:V.all!==null?2:0},W=t(X,!1);return[{baseResource:this.wb,baseContent:M?t(M,!1):W,localResource:this.xb,localContent:W,localUserData:X,remoteResource:this.yb,remoteContent:F?t(F,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:G}]}async ub(p){const D=p.syncData?JSON.parse(p.syncData.content):null;if(D===null)return!0;const z=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(D),{remote:M}=(0,l.$wKb)(z.storage,D.storage,D.storage,F,this.O);return M.all!==null}async rb(p,D){return{...p.previewResult,hasConflicts:!1}}async sb(p,D,z,F){if(this.h.isEqual(D,this.xb))return this.Gb(p);if(this.h.isEqual(D,this.yb))return this.Hb(p);if(this.h.isEqual(D,this.vb))return p.previewResult;throw new Error(`Invalid Resource: ${D.toString()}`)}async Gb(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(p.localUserData.storage),removed:[],updated:[],all:p.localUserData.storage},localChange:0,remoteChange:2}}async Hb(p){if(p.remoteContent!==null){const D=JSON.parse(p.remoteContent),{local:z,remote:F}=(0,l.$wKb)(p.localUserData.storage,D.storage,null,p.storageKeys,this.O);return{content:p.remoteContent,local:z,remote:F,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(p,D,z,F){const{localUserData:M}=z[0][0],{local:X,remote:G,localChange:Y,remoteChange:V}=z[0][1];if(Y===0&&V===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Y!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(X,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:G.all});p=await this.mb(K,F?null:p.ref),this.O.info(`${this.D}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}D?.ref!==p.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(p),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(p){if(this.h.isEqual(this.yb,p)||this.h.isEqual(this.wb,p)||this.h.isEqual(this.xb,p)||this.h.isEqual(this.zb,p)){const D=await this.db(p);return D&&t(JSON.parse(D),!0)}return null}async hasLocalData(){try{const{storage:p}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(p).length>1||p[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(p){const D=await this.Bb.readStorageData(this.syncResource.profile),z=[],F=[];for(const[G,Y]of D)Y.target===0?z.push(G):Y.target===1&&F.push(G);const M=[...z,...F],X=p?.storage?Object.keys(p.storage).filter(G=>!G.startsWith(n)&&!M.includes(G)&&D.get(G)!==void 0):[];if(!R.$o){const G=[...c.$uzb.map(Y=>(0,c.$Hzb)(Y)),c.$Gzb];X.push(...G),F.push(...G)}return{user:z,machine:F,unregistered:X}}};e.$yKb=a,e.$yKb=a=ve([Q(2,i.$uJb),Q(3,v.$Tk),Q(4,c.$yzb),Q(5,c.$zzb),Q(6,c.$Nzb),Q(7,k.$ui),Q(8,c.$Izb),Q(9,b.$Sl),Q(10,m.$Ti),Q(11,h.$Rp),Q(12,w.$rl),Q(13,o.$mi)],a);let E=class{constructor(p,D,z,F){this.a=p,this.b=D,this.c=z,this.d=F}async getLocalGlobalState(p){const D={};if(p.isDefault){const F=await this.f(),M=(0,A.$An)(F);for(const X of s)M[X]!==void 0&&(D[`${n}${X}`]={version:1,value:M[X]})}const z=await this.c.readStorageData(p);for(const[F,M]of z)M.value&&M.target===0&&(D[F]={version:1,value:M.value});return{storage:D}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const p=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),p.value.toString()}catch(p){this.d.debug((0,N.$0)(p))}return"{}"}async writeLocalGlobalState({added:p,removed:D,updated:z},F){const M=(0,u.$rKb)("globalState",F),X={},G=new Map,Y=await this.c.readStorageData(F),V=(K,W)=>{for(const B of K){if(B.startsWith(n)){X[B.substring(n.length)]=W?W[B].value:void 0;continue}if(W){const ie=W[B];ie.value!==Y.get(B)?.value&&G.set(B,ie.value)}else Y.get(B)!==void 0&&G.set(B,void 0)}};if(V(Object.keys(p),p),V(Object.keys(z),z),V(D),Object.keys(X).length){this.d.trace(`${M}: Updating locale...`);const K=await this.f();let W=K;for(const B of Object.keys(X))W=(0,d.edit)(W,[B],X[B],{});K!==W&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$ze.fromString(W)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}G.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(F,G,0),this.d.info(`${M}: Updated global state`,[...G.keys()]))}};e.$zKb=E,e.$zKb=E=ve([Q(0,v.$Tk),Q(1,k.$ui),Q(2,i.$uJb),Q(3,c.$Nzb)],E);let S=class extends u.$vKb{constructor(p,D,z,F,M,X){super("globalState",z,F,M,D,p,X)}async o(p){const D=p.syncData?JSON.parse(p.syncData.content):null;if(!D){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},F={};for(const M of Object.keys(D.storage))M.startsWith(n)?z[M.substring(n.length)]=D.storage[M].value:this.l.get(M,0)===void 0&&(F[M]=D.storage[M].value);if(Object.keys(z).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const X of Object.keys(z))M=(0,d.edit)(M,[X],z[X],{});await this.k.writeFile(this.h.argvResource,I.$ze.fromString(M))}if(Object.keys(F).length){const M=[];for(const X of Object.keys(F))M.push({key:X,value:F[X],scope:0,target:0});this.l.storeAll(M,!0)}}};e.$AKb=S,e.$AKb=S=ve([Q(0,h.$Rp),Q(1,v.$Tk),Q(2,g.$tl),Q(3,k.$ui),Q(4,c.$Nzb),Q(5,w.$rl)],S);let P=class{constructor(p,D,z,F,M){this.a=p,this.b=D,this.c=z,this.d=F,this.f=M}getSyncStoreType(p){return this.h(p)?.storage[c.$Gzb]?.value}async sync(p){const D=(0,c.$Czb)((0,C.$Jg)());try{return await this.g(p,D)}catch(z){if(z instanceof c.$Dzb)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(p,D)}throw z}}async g(p,D){const z=await this.a.readResource("globalState",null,void 0,D),F=this.h(z)||{storage:{}};F.storage[c.$Gzb]={value:p,version:r};const M=await(0,f.$Xp)(this.c,this.d,this.b),X={version:r,machineId:M,content:t(F,!1)};await this.a.writeResource("globalState",JSON.stringify(X),z.ref,void 0,D)}h({content:p}){if(!p)return null;const D=JSON.parse(p);if((0,u.$qKb)(D))return D?JSON.parse(D.content):null;throw new Error("Invalid remote data")}};e.$BKb=P,e.$BKb=P=ve([Q(1,h.$Rp),Q(2,k.$ui),Q(3,v.$Tk),Q(4,$.$Tj)],P)}),define(le[117],he([0,1,17,15,3,34,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=e.$U0b=void 0,e.$T0b=l;function l(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$8f)(s.all)?null:s.all;switch(O.OS){case 2:return(0,R.$8f)(s.mac)?null:s.mac;case 3:return(0,R.$8f)(s.linux)?null:s.linux;case 1:return(0,R.$8f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends w.$uKb{constructor(o,n,s,t,r,a,E,S,P,y,p,D,z){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,S,P,y,s,t,E,D,r,p,a,z),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$Pzb,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$Pzb,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$Pzb,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$Pzb,authority:"accepted"}),this.B(j.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?l(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,E=await this.vb(),S=await this.Cb();let P=null,y=!1,p=!1,D=!1;if(r){let M=E?E.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new d.$Dzb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==M||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const X=await(0,u.$S0b)(M,r,a,S,this.zb);X.hasChanges&&(P=X.mergeContent,D=X.hasConflicts,y=D||X.mergeContent!==M,p=D||X.mergeContent!==r)}}else E&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),P=E.value.toString(),p=!0);const z={content:D?a:P,localChange:y?E?2:1:0,remoteChange:p?2:0,hasConflicts:D},F=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:z.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:z.remoteChange,previewResource:this.Eb,previewResult:z,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,u.$S0b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:E,remoteChange:S}=s[0][1];if(E===0&&S===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new d.$Dzb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),S!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const P=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(P,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,A.$An)(o.value.toString());if((0,I.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:l(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,O.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(d.$rzb)}};e.$U0b=c,e.$U0b=c=ve([Q(2,d.$yzb),Q(3,d.$zzb),Q(4,d.$Nzb),Q(5,m.$Ti),Q(6,d.$Izb),Q(7,v.$Tk),Q(8,k.$ui),Q(9,$.$Rp),Q(10,d.$Mzb),Q(11,f.$Sl),Q(12,h.$rl)],c);let g=class extends w.$vKb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ze.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$An)(o.value.toString());return!(0,I.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return l(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$V0b=g,e.$V0b=g=ve([Q(0,v.$Tk),Q(1,b.$tl),Q(2,k.$ui),Q(3,d.$Nzb),Q(4,$.$Rp),Q(5,h.$rl)],g)}),define(le[118],he([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=e.$X0b=void 0,e.$W0b=d;function u(g){return g&&g.settings&&typeof g.settings=="string"&&Object.keys(g).length===1}function d(g){const i=JSON.parse(g);return u(i)?i:{settings:g}}let l=class extends h.$uKb{constructor(i,o,n,s,t,r,a,E,S,P,y,p,D,z){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,y,p,E,S,P,z),this.Eb=D,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Pzb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Pzb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Pzb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Pzb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new O.$po(w.$qzb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(w.$qzb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,E=await this.Pb();let S=null,P=!1,y=!1,p=!1;if(r){let M=s?s.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const X=(0,b.$bJb)(M,r.settings,a?a.settings:null,E,[],t);S=X.localContent||X.remoteContent,P=X.localContent!==null,y=X.remoteContent!==null,p=X.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=s.value.toString().trim()||"{}",this.Qb(S),y=!0);const D=s?s.value.toString():null,z=a?.settings??null,F={content:p?z:S,localChange:P?2:0,remoteChange:y?2:0,hasConflicts:p};return[{fileContent:s,baseResource:this.baseResource,baseContent:z,localResource:this.localResource,localContent:D,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$bJb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$aJb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$aJb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$aJb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$aJb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:E}=n[0][1];if(a===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),E!==0){const S=await this.Cb(),P=this.Lb(i),y=await this.Pb(r);r=(0,b.$aJb)(r,P?P.settings:"{}",y,S),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$cJb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$aJb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return d(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$$Ib)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new w.$Dzb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$X0b=l,e.$X0b=l=ve([Q(2,m.$Tk),Q(3,R.$ui),Q(4,k.$Rp),Q(5,w.$yzb),Q(6,w.$zzb),Q(7,w.$Nzb),Q(8,w.$Mzb),Q(9,A.$Ti),Q(10,w.$Izb),Q(11,v.$Sl),Q(12,C.$Zo),Q(13,$.$rl)],l);let c=class extends h.$vKb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$ze.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$cJb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return d(i)}catch(o){this.j.error(o)}return null}};e.$Y0b=c,e.$Y0b=c=ve([Q(0,m.$Tk),Q(1,f.$tl),Q(2,R.$ui),Q(3,w.$Nzb),Q(4,k.$Rp),Q(5,$.$rl)],c)}),define(le[119],he([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=void 0,e.$20b=b;function b(d){return JSON.parse(d.content)}let w=class extends $.$sKb{constructor(l,c,g,i,o,n,s,t,r,a,E,S){super({syncResource:"snippets",profile:l},c,i,g,o,n,s,a,E,t,r,S),this.pb=1,this.vb=l.snippetsHome,this.B(this.G.watch(g.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,P=>P.affects(this.vb))(()=>this.Q()))}async qb(l,c,g){const i=await this.Hb(),o=this.Gb(i),n=l.syncData?this.Fb(l.syncData):null;c=c===null&&g?l:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,f.$Z0b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(l){const c=l.syncData?this.Fb(l.syncData):null;if(c===null)return!0;const g=await this.Hb(),i=this.Gb(g),o=(0,f.$Z0b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(l,c){return l.previewResult}async sb(l,c,g,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:h.$Pzb,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:h.$Pzb,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return g===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:g,localChange:g===null?l.fileContent!==null?3:0:2,remoteChange:g===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(l,c,g,i){const o=g.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(l=await this.Eb(o,l,i)),c?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(l,c,g,i){const o=new Map;for(const n of Object.keys(l.local.added)){const s={content:l.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of Object.keys(l.local.updated)){const s={content:l.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of l.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of Object.keys(l.remote.added)){const s={content:l.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of Object.keys(l.remote.updated)){const s={content:l.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of l.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of l.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:g[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:g[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"remote"}),remoteContent:g[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Pzb,authority:"accepted"})})}return[...o.values()]}async resolveContent(l){return this.h.isEqualOrParent(l,this.g.with({scheme:h.$Pzb,authority:"remote"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$Pzb,authority:"local"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$Pzb,authority:"base"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$Pzb,authority:"accepted"}))?this.db(l):null}async hasLocalData(){try{const l=await this.Hb();if(Object.keys(l).length)return!0}catch{}return!1}async Cb(l){const c={};for(const g of l)g.fileContent&&(c[this.h.basename(g.localResource)]=g.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(l,c){for(const{fileContent:g,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of l)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$ze.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$ze.fromString(i.content),c?void 0:g),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(l,c,g){const i=c.syncData?this.Fb(c.syncData):{},o=(0,j.$Tn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of l)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,f.$10b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),g?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(l){return b(l)}Gb(l){const c={};for(const g of Object.keys(l))c[g]=l[g].value.toString();return c}async Hb(){const l={};let c;try{c=await this.G.resolve(this.vb)}catch(g){if(g instanceof R.$cl&&g.fileOperationResult===1)return l;throw g}for(const g of c.children||[]){const i=g.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);l[n]=s}}return l}};e.$30b=w,e.$30b=w=ve([Q(2,O.$ui),Q(3,R.$Tk),Q(4,C.$Rp),Q(5,h.$yzb),Q(6,h.$zzb),Q(7,h.$Nzb),Q(8,A.$Ti),Q(9,h.$Izb),Q(10,m.$Sl),Q(11,k.$rl)],w);let u=class extends $.$vKb{constructor(l,c,g,i,o,n){super("snippets",c,g,i,l,o,n)}async o(l){const c=l.syncData?JSON.parse(l.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,I.$ze.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(l)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};e.$40b=u,e.$40b=u=ve([Q(0,R.$Tk),Q(1,v.$tl),Q(2,O.$ui),Q(3,h.$Nzb),Q(4,C.$Rp),Q(5,k.$rl)],u)}),define(le[120],he([0,1,15,21,16,12,19,22,28,18,39,25]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=e.$60b=void 0,e.$50b=$;function $(w,u){try{return JSON.parse(w).tasks??null}catch(d){return u.error(d),null}}let f=class extends k.$tKb{constructor(u,d,l,c,g,i,o,n,s,t,r,a){super(u.tasksResource,{syncResource:"tasks",profile:u},d,n,s,t,l,c,o,r,g,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:v.$Pzb,authority:"base"}),this.Cb=this.Ab.with({scheme:v.$Pzb,authority:"local"}),this.Db=this.Ab.with({scheme:v.$Pzb,authority:"remote"}),this.Eb=this.Ab.with({scheme:v.$Pzb,authority:"accepted"})}async qb(u,d,l,c){const g=u.syncData?$(u.syncData.content,this.O):null;d=d===null&&l?u:d;const i=d?.syncData?$(d.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(u.syncData){const S=o?o.value.toString():null;if(!i||i!==S||i!==g){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const P=b(S,g,i);n=P.content,r=P.hasConflicts,s=P.hasLocalChanged,t=P.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},E=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:E,localChange:a.localChange,remoteResource:this.Db,remoteContent:g,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(u){const d=u?.syncData?$(u.syncData.content,this.O):null;if(d===null)return!0;const l=await this.vb(),c=l?l.value.toString():null,g=b(c,d,d);return g.hasLocalChanged||g.hasRemoteChanged}async rb(u,d){return u.previewResult}async sb(u,d,l,c){if(this.h.isEqual(d,this.Cb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.Db))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.Ab))return l===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(u,d,l,c){const{fileContent:g}=l[0][0],{content:i,localChange:o,remoteChange:n}=l[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),g&&await this.nb(JSON.stringify(this.Kb(g.value.toString()))),i?await this.wb(i,g,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));u=await this.mb(s,c?null:u.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(u){return this.h.isEqual(this.Db,u)||this.h.isEqual(this.Bb,u)||this.h.isEqual(this.Cb,u)||this.h.isEqual(this.Eb,u)?this.db(u):null}Kb(u){return u?{tasks:u}:{}}};e.$60b=f,e.$60b=f=ve([Q(2,v.$yzb),Q(3,v.$zzb),Q(4,v.$Nzb),Q(5,N.$Ti),Q(6,v.$Izb),Q(7,A.$Tk),Q(8,j.$ui),Q(9,O.$Rp),Q(10,R.$Sl),Q(11,C.$rl)],f);let h=class extends k.$vKb{constructor(u,d,l,c,g,i){super("tasks",d,l,c,u,g,i),this.c=this.g.defaultProfile.tasksResource}async o(u){const d=u.syncData?$(u.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$ze.fromString(d)),await this.n(u)}async p(){return this.k.exists(this.c)}};e.$70b=h,e.$70b=h=ve([Q(0,A.$Tk),Q(1,m.$tl),Q(2,j.$ui),Q(3,v.$Nzb),Q(4,O.$Rp),Q(5,C.$rl)],h);function b(w,u,d){if(w===null&&u===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=d!==w,c=d!==u;return!l&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!c?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!l?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,43,21,16,12,19,22,28,18,39,244,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=void 0,e.$O_b=h,e.$P_b=b;let f=class extends k.$sKb{constructor(u,d,l,c,g,i,o,n,s,t,r,a,E){super({syncResource:"profiles",profile:u},d,c,g,i,o,n,r,a,s,t,E),this.vb=l,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$Pzb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Pzb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Pzb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Pzb,authority:"accepted"}),this.B(l.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?b(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),l=await this.X(u,d);return l?.syncData?b(l.syncData):null}async qb(u,d,l){if(!this.vb.isEnabled())throw new $.$Dzb("Cannot sync profiles because they are disabled","LocalError");const c=u.syncData?b(u.syncData):null,g=d?.syncData?b(d.syncData):null,i=this.Db(),{local:o,remote:n}=(0,v.$M_b)(i,c,g,[]),s={local:o,remote:n,content:g?this.Eb(g):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=h(i,!1);return[{baseResource:this.baseResource,baseContent:g?this.Eb(g):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(u){const d=u?.syncData?b(u.syncData):null,l=this.Db(),{remote:c}=(0,v.$M_b)(l,d,d,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(u,d){return{...u.previewResult,hasConflicts:!1}}async sb(u,d,l,c){if(this.h.isEqual(d,this.localResource))return this.Ab(u);if(this.h.isEqual(d,this.remoteResource))return this.Bb(u);if(this.h.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(u){const d=this.Db(),l=(0,v.$M_b)(d,null,null,[]),{local:c,remote:g}=l;return{content:u.localContent,local:c,remote:g,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:g!==null?2:0}}async Bb(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,l=[],c=[];for(const g of this.Db()){const i=d?.find(o=>o.id===g.id);i&&(l.push({id:g.id,name:g.name,collection:i.collection}),c.push(g))}if(d!==null){const g=(0,v.$M_b)(c,d,l,[]),{local:i,remote:o}=g;return{content:u.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(u,d,l,c){const{local:g,remote:i,localChange:o,remoteChange:n}=l[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=l[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new $.$Dzb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0&&(await this.nb(h(this.Db(),!1)),await Promise.all(g.removed.map(async t=>{this.O.trace(`${this.D}: Removing '${t.name}' profile...`),await this.vb.removeProfile(t),this.O.info(`${this.D}: Removed profile '${t.name}'.`)})),await Promise.all(g.added.map(async t=>{this.O.trace(`${this.D}: Creating '${t.name}' profile...`),await this.vb.createProfile(t.id,t.name,{shortName:t.shortName,icon:t.icon,useDefaultFlags:t.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${t.name}'.`)})),await Promise.all(g.updated.map(async t=>{const r=this.vb.profiles.find(a=>a.id===t.id);r?(this.O.trace(`${this.D}: Updating '${t.name}' profile...`),await this.vb.updateProfile(r,{name:t.name,shortName:t.shortName,icon:t.icon,useDefaultFlags:t.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${t.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${t.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const E=await this.J.createCollection(this.F);t.push(E),s.push({id:a.id,name:a.name,collection:E,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:E})=>a.id===E),1);for(const a of i?.updated||[]){const E=s.find(({id:S})=>a.id===S);E&&s.splice(s.indexOf(E),1,{...E,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(s,c?null:u.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of t)await this.J.deleteCollection(E,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}d?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.mb(this.Eb(u),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const d=await this.db(u);return d&&(0,I.$Ln)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Eb(u){return JSON.stringify([...u].sort((d,l)=>d.name.localeCompare(l.name)))}};e.$N_b=f,e.$N_b=f=ve([Q(2,m.$tl),Q(3,A.$Tk),Q(4,j.$ui),Q(5,O.$Rp),Q(6,$.$yzb),Q(7,$.$zzb),Q(8,$.$Nzb),Q(9,N.$Ti),Q(10,$.$Izb),Q(11,R.$Sl),Q(12,C.$rl)],f);function h(w,u){const d=[...w].sort((l,c)=>l.name.localeCompare(c.name)).map(l=>({id:l.id,name:l.name}));return u?(0,I.$Ln)(d,{}):JSON.stringify(d)}function b(w){return JSON.parse(w.content)}}),define(le[261],he([0,1,3,2,5,16,19,22,25]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;const m="sync.enable";let k=class extends N.$Uc{constructor($,f,h,b){super(),this.c=$,this.f=f,this.g=h,this.h=b,this.a=new I.$_d,this.onDidChangeEnablement=this.a.event,this.b=new I.$_d,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new N.$Tc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(m,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(m,{enabled:$}),this.c.store(m,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,C.$Hzb)($),-1,!0)}setResourceEnablement($,f){if(this.isResourceEnabled($)!==f){const h=(0,C.$Hzb)($);this.j(h,f)}}getResourceSyncStateVersion($){}j($,f){this.c.store($,f,-1,j.$o?0:1)}m($){if(m===$.key){this.a.fire(this.isEnabled());return}const f=C.$uzb.filter(h=>(0,C.$Hzb)(h)===$.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$A_b=k,e.$A_b=k=ve([Q(0,O.$Rp),Q(1,R.$Sl),Q(2,A.$ui),Q(3,C.$xzb)],k)}),define(le[262],he([0,1,6,15,65,2,20,21,16,12,18,25]),function(se,e,I,N,j,A,O,R,C,m,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=void 0;let $=class extends A.$Uc{constructor(h,b,w,u,d){super(),this.a=h,this.b=b,this.c=w,this.f=u,this.g=d,this.h()}async h(){for(const b of this.g.profiles)for(const w of v.$uzb)try{await this.m(this.j(w,b.isDefault?void 0:b.id))}catch(u){this.f.error(u)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,m.$$k)(b)!==1&&this.f.error(b);return}if(h.children){for(const b of h.children)if(b.isDirectory&&!this.g.profiles.some(w=>w.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(h,b,w){const u=this.j(h,b,w);try{const d=await this.b.resolve(u);if(d.children)return d.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(d){if((0,m.$$k)(d)!==1)throw d}return[]}async resolveResourceContent(h,b,w,u){const d=this.j(h,w,u),l=(0,O.$1g)(d,b);try{return(await this.b.readFile(l)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(h,b,w,u,d){const l=this.j(h,u,d),c=(0,O.$1g)(l,`${(0,j.$Um)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,N.$ze.fromString(b))}catch(g){this.f.error(g)}}j(h,b,w=this.a.userDataSyncHome){return(0,O.$1g)(w,...b?[b,h]:[h])}async m(h){try{try{if(!await this.b.exists(h))return}catch{return}const b=await this.b.resolve(h);if(b.children){const w=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=w.filter(c=>Date.now()-this.n(c)>u);const l=w.length-d.length;l<10&&(d=d.slice(10-l)),await I.Promises.settled(d.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(b){this.f.error(b)}}n(h){return new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};e.$L_b=$,e.$L_b=$=ve([Q(0,C.$ui),Q(1,m.$Tk),Q(2,R.$Ti),Q(3,v.$Nzb),Q(4,k.$tl)],$)}),define(le[83],he([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$nzb=e.$lzb=void 0,e.$mzb=g,e.$lzb=(0,m.$ni)("IUserDataSyncMachinesService");const b="sync.currentMachineName",w="Safari",u="Chrome",d="Edge",l="Firefox",c="Android";function g(n){switch(n){case w:case u:case d:case l:case c:case(0,j.$h)(0):return!0}return!1}function i(){return j.$G?w:j.$E?u:j.$H?d:j.$F?l:j.$I?c:(0,j.$h)(j.$o?0:j.$u)}let o=class extends N.$Uc{static{h=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,E,S){super(),this.h=r,this.j=a,this.m=E,this.n=S,this.c=this.B(new I.$_d),this.onDidChange=this.c.event,this.g=null,this.f=(0,v.$Xp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:E})=>E!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),E=a.machines.find(({id:S})=>S===s);if(E){E.name=t,await this.t(a);const S=await this.f;s===S&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const E=t.machines.find(S=>S.id===r);E&&(E.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$5e)(r)}\\s#(\\d+)`);let E=0;for(const S of s){const P=a.exec(S.name),y=P?parseInt(P[1]):0;E=y>E?y:E}return`${r} #${E+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==h.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(h.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[h.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(h.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:h.a,machines:[]}}};e.$nzb=o,e.$nzb=o=h=ve([Q(0,R.$ui),Q(1,C.$Tk),Q(2,$.$Rp),Q(3,f.$yzb),Q(4,f.$Nzb),Q(5,k.$ak)],o)}),define(le[263],he([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=void 0;const d="sync.disableMachineEventually",l="sync.sessionId",c="sync.storeUrl",g="sync.productQuality";let i=class extends R.$Uc{get n(){const s=this.H.get(c,-1);return s?k.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(g,-1)}set s(s){s?this.H.store(g,s,-1,1):this.H.remove(g,-1)}constructor(s,t,r,a,E,S,P,y,p,D){super(),this.u=t,this.w=r,this.y=a,this.z=E,this.C=S,this.D=P,this.F=y,this.G=p,this.H=D,this.a=this.B(new R.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$_d),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$lh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,m.$Tg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(P.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(E.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$Um)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(l,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$Dzb.toUserDataSyncError(s);t instanceof b.$Fzb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?C.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(d,!0,-1,1),await(0,I.$oh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,-1,!1)}R(){this.H.remove(d,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$R_b=i,e.$R_b=i=ve([Q(0,$.$ak),Q(1,b.$xzb),Q(2,b.$yzb),Q(3,b.$Izb),Q(4,b.$Jzb),Q(5,b.$Nzb),Q(6,w.$SIb),Q(7,h.$Sl),Q(8,u.$lzb),Q(9,f.$Rp)],i);class o extends R.$Uc{static{this.a="Interval"}constructor(s,t,r,a,E,S,P,y,p){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=E,this.w=S,this.y=P,this.z=y,this.C=p,this.b=this.B(new R.$Vc),this.c=this.B(new O.$_d),this.onDidStartSync=this.c.event,this.f=this.B(new O.$_d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,I.$ph)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,I.$ah)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(E){if((0,A.$4)(E))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,m.$Tg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,m.$Tg)(t.defaultUrl,s.defaultUrl)||!(0,m.$Tg)(t.insidersUrl,s.insidersUrl)||!(0,m.$Tg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(E){if(this.y.error(E),a=E,b.$Dzb.toUserDataSyncError(E).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(S){this.y.error(S),a=S}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$Fzb((0,v.localize)(0,null),"DefaultServiceChanged"):new b.$Fzb((0,v.localize)(1,null),"ServiceChanged"):new b.$Fzb((0,v.localize)(2,null),"TurnedOff");const r=this.C.get(l,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$Fzb((0,v.localize)(3,null),"DefaultServiceChanged"):new b.$Fzb((0,v.localize)(4,null),"ServiceChanged"):new b.$Fzb((0,v.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const E=a.find(P=>P.isCurrent);if(E?.disabled)throw new b.$Fzb((0,v.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.g===null)try{this.g=await this.s.manifest(null)}catch(P){throw new b.$Fzb((0,j.$$i)(P),P instanceof b.$Dzb?P.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(l,this.g.session,-1,1),!t.isCancellationRequested&&(E||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[264],he([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,43,27]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,E,S,P,y,p,D,z){this.e=t,this.f=r,this.g=a,this.h=S,this.i=P,this.j=y,this.k=p,this.l=D,this.n=z,this.d=E.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$P_b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const E=this.L(a,"profiles");return(0,c.$P_b)(E)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(S=>({...S,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:E,ref:S})=>({created:E,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:S,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:S,ref:P})=>({created:S,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:P,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(E=>E.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(E=>E.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$Xp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,E,S){if(t){const{content:P}=await this.M(r,E,a);return P}return this.f.resolveResourceContent(r,E,a,S)}q(t,r,a){const E=this.L(r,t);switch(t){case"settings":return this.t(E,a);case"keybindings":return this.v(E,a);case"tasks":return this.x(E,a);case"snippets":return this.z(E,a);case"globalState":return this.E(E,a);case"extensions":return this.B(E,a);case"profiles":return this.H(E,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(E=>E.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),E=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}t(t,r){switch(r){case"settings.json":return(0,f.$W0b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),E=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}v(t,r){switch(r){case"keybindings.json":return(0,h.$T0b)(t.content,!!this.l.getValue(m.$rzb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),E=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}x(t,r){switch(r){case"tasks.json":return(0,w.$50b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const E=this.L(a,"snippets");if(E){const S=(0,$.$20b)(E),P=[];for(const y of Object.keys(S)){const p=this.d.joinPath(t,y),D=r?this.d.joinPath(r.snippetsHome,y):this.d.joinPath(t,o.a);P.push({resource:p,comparableResource:D})}return P}}return[]}z(t,r){return(0,$.$20b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),E=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}B(t,r){switch(r){case"extensions.json":return(0,u.$O0b)((0,u.$N0b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(u.$Q0b).getLocalExtensions(t);return(0,u.$O0b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),E=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}E(t,r){switch(r){case"globalState.json":return(0,d.$xKb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(d.$zKb).getLocalGlobalState(t);return(0,d.$xKb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),E=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:E}]}H(t,r){switch(r){case"profiles.json":return(0,g.$Ln)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$O_b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$9e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(I.URI.from({scheme:m.$Pzb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==m.$Pzb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let E,S;const P=[];let y,p,D,z,F;for(;r.length;){const M=r.shift();M.startsWith("scheme:")?E=M.substring(7):M.startsWith("authority:")?S=M.substring(10):M.startsWith("syncResource:")?y=M.substring(13):M.startsWith("profile:")?p=M.substring(8):M.startsWith("collection:")?D=M.substring(11):M.startsWith("ref:")?z=M.substring(4):y?F=M:P.push(M)}return{remote:a,syncResource:y,profile:p,collection:D,ref:z,node:F,location:E&&S!==void 0?this.d.joinPath(I.URI.from({scheme:E,authority:S,query:t.query,fragment:t.fragment,path:"/"}),...P):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,v.$qKb)(a))return a}catch(a){this.g.error(a)}throw new m.$Dzb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const E=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:E}}};e.$nac=n,e.$nac=n=o=ve([Q(0,m.$yzb),Q(1,m.$zzb),Q(2,m.$Nzb),Q(3,C.$rl),Q(4,j.$ui),Q(5,R.$Rp),Q(6,A.$Tk),Q(7,k.$tl),Q(8,b.$Ti),Q(9,l.$mi)],n)}),define(le[265],he([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(y,p,D,z,F,M,X,G,Y,V,K){super(),this.C=y,this.D=p,this.F=D,this.G=z,this.H=F,this.I=M,this.J=X,this.L=G,this.M=Y,this.N=V,this.O=K,this.f="uninitialized",this.g=this.B(new O.$_d),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$_d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$_d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$_d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$_d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$_d),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$_d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=D.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Sc)(()=>this.bb()))}async createSyncTask(y,p){this.cb(),this.H.info("Sync started.");const D=new Date().getTime(),z=(0,k.$Jg)();try{const G=(0,s.$Czb)(z);p&&(G["Cache-Control"]="no-cache"),y=await this.D.manifest(y,G)}catch(G){const Y=s.$Dzb.toUserDataSyncError(G);throw S(Y,z,this.F,this.I),Y}const F=!1,M=this;let X;return{manifest:y,async run(){if(F)throw new Error("Can run a task only once");X=(0,N.$ah)(G=>M.P(y,!1,z,G)),await X.finally(()=>X=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-D}ms`),M.$()},stop(){return X?.cancel(),M.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Dzb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const y=new Date().getTime(),p=(0,k.$Jg)(),D=(0,s.$Czb)(p);let z;try{z=await this.D.manifest(null,D)}catch(X){const G=s.$Dzb.toUserDataSyncError(X);throw S(G,p,this.F,this.I),G}await this.resetLocal();const F=this,M=new j.$je;return{id:p,async merge(){return F.P(z,!0,p,M.token)},async apply(){try{try{await F.R(z,p,M.token)}catch(X){if(s.$Dzb.toUserDataSyncError(X).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(z,p,M.token);else throw X}}catch(X){throw F.H.error(X),X}F.H.info(`Sync done. Took ${new Date().getTime()-y}ms`),F.$()},async stop(){M.cancel(),await F.U(),await F.resetLocal()}}}async P(y,p,D,z){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,y,p,D,z));const M=F.enabled.find(X=>X.resource==="profiles");if(M){const X=await M.getLastSyncedProfiles()||[];if(z.isCancellationRequested)return;await this.Q(X,y,p,D,z)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(y,p,D,z,F){for(const M of y){if(F.isCancellationRequested)return;const X=this.M.profiles.find(Y=>Y.id===M.id);if(!X){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const G=this.getOrCreateActiveProfileSynchronizer(X,M);this.n.push(...await this.S(G,p,D,z,F))}for(const[M,X]of this.z.entries())this.M.profiles.some(G=>G.id===X[0].profile.id)||(X[1].dispose(),this.z.delete(M))}async R(y,p,D){const z=this.ab();for(const Y of z){if(D.isCancellationRequested)return;await Y.apply(p,D)}const F=z.find(Y=>Y.profile.isDefault);if(!F)return;const M=F.enabled.find(Y=>Y.resource==="profiles");if(!M)return;const G=(await M.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(Y=>z.every(V=>V.profile.id!==Y.id));G.length&&await this.Q(G,y,!1,p,D)}async S(y,p,D,z,F){return(await y.sync(p,D,z,F)).map(([X,G])=>({profile:y.profile,syncResource:X,error:G}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(y=>y.stop()))}async resolveContent(y){const p=await this.N.resolveContent(y);if(p)return p;for(const D of this.ab())for(const z of D.enabled){const F=await z.resolveContent(y);if(F)return F}return null}async replace(y){this.cb();const p=this.N.resolveUserDataSyncResource(y);if(!p)return;const D=await this.resolveContent(y.uri);D&&await this.W(p.profile,async z=>{if(p.syncResource===z.resource)return await z.replace(D),!0})}async accept(y,p,D,z){this.cb(),await this.W(y.profile,async F=>{if(y.syncResource===F.resource)return await F.accept(p,D),z&&await F.apply((0,m.$7f)(z)?!1:z.force,(0,s.$Czb)((0,k.$Jg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async p=>{if(p.resource!=="globalState"&&await p.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async p=>{if(await p.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(y){this.H.error(y)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[y]of this.z.values())try{await y.resetLocal()}catch(p){this.H.error(p)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.N.getRemoteSyncedProfiles(),p=y.map(M=>M.collection),D=await this.D.getAllCollections(),z=D.filter(M=>!p.includes(M));z.length&&(this.H.info(`Deleting ${z.length} redundant collections on server`),await Promise.allSettled(z.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const F=y.filter(M=>D.includes(M.collection));if(F.length!==y.length){const M=this.G.createInstance(n.$N_b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(y){this.cb();const p=await this.D.getActivityData();await this.C.writeFile(y,p)}async extractActivityData(y,p){const D=(await this.C.readFile(y)).value.toString(),z=JSON.parse(D);if(z.resources)for(const F in z.resources)for(const M of z.resources[F])await this.O.writeResource(F,M.content,new Date(M.created*1e3),void 0,p);if(z.collections)for(const F in z.collections)for(const M in z.collections[F].resources)for(const X of z.collections[F].resources?.[M]??[])await this.O.writeResource(M,X.content,new Date(X.created*1e3),F,p)}async W(y,p){const D=new R.$Tc;try{const z=this.z.get(y.id);if(z){const Y=await this.X(z[0],p,D);return(0,m.$8f)(Y)?null:Y}if(y.isDefault){const Y=D.add(this.G.createInstance(a,y,void 0)),V=await this.X(Y,p,D);return(0,m.$8f)(V)?null:V}if(this.M.isEnabled())return null;const F=D.add(this.G.createInstance(n.$N_b,y,void 0)),M=await this.D.manifest(null),G=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(Y=>Y.id===y.id);if(G){const Y=D.add(this.G.createInstance(a,y,G.collection)),V=await this.X(Y,p,D);return(0,m.$8f)(V)?null:V}return null}finally{D.dispose()}}async X(y,p,D){const z=[...y.enabled,...y.disabled.reduce((F,M)=>(M!=="workspaceState"&&F.push(D.add(y.createSynchronizer(M))),F),[])];for(const F of z){const M=await p(F);if(!(0,m.$8f)(M))return M}}Y(y){const p=this.f;this.f!==y&&(this.f=y,this.g.fire(y),p==="hasConflicts"&&this.$())}Z(){const y=this.ab().map(p=>p.conflicts).flat();(0,I.$ub)(this.j,y,(p,D)=>p.profile.id===D.profile.id&&p.syncResource===D.syncResource&&(0,I.$ub)(p.conflicts,D.conflicts,(z,F)=>(0,C.$Tg)(z.previewResource,F.previewResource)))||(this.j=y,this.m.fire(y))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(y,p){let D=this.z.get(y.id);if(D&&D[0].collection!==p?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.z.delete(y.id)),!D){const z=new R.$Tc,F=z.add(this.G.createInstance(a,y,p?.collection));z.add(F.onDidChangeStatus(M=>this.Y(M))),z.add(F.onDidChangeConflicts(M=>this.Z())),z.add(F.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(y.id,D=[F,z])}return D[0]}ab(){const y=[];for(const[p]of this.z.values())y.push(p);return y}bb(){this.z.forEach(([,y])=>y.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Q_b=r,e.$Q_b=r=ve([Q(0,f.$Tk),Q(1,s.$yzb),Q(2,s.$xzb),Q(3,h.$mi),Q(4,s.$Nzb),Q(5,w.$Sl),Q(6,b.$Rp),Q(7,s.$Izb),Q(8,u.$tl),Q(9,s.$Kzb),Q(10,s.$zzb)],r);let a=class extends R.$Uc{get enabled(){return this.f.sort((y,p)=>y[1]-p[1]).map(([y])=>y)}get disabled(){return s.$uzb.filter(y=>!this.r.isResourceEnabled(y))}get status(){return this.g}get conflicts(){return this.m}constructor(y,p,D,z,F,M,X,G,Y,V){super(),this.profile=y,this.collection=p,this.r=D,this.t=z,this.u=F,this.w=M,this.y=X,this.z=G,this.C=Y,this.D=V,this.f=[],this.g="idle",this.h=this.B(new O.$_d),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$_d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$_d),this.onDidChangeConflicts=this.n.event,this.B(D.onDidChangeResourceEnablement(([K,W])=>this.F(K,W))),this.B((0,R.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of s.$uzb)D.isResourceEnabled(K)&&this.G(K)}F(y,p){p?this.G(y):this.H(y)}G(y){if(this.f.some(([F])=>F.resource===y))return;if(y==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||y==="workspaceState")return;if(y!=="profiles"&&this.profile.useDefaultFlags?.[y]){this.z.debug(`Skipping syncing ${y} in ${this.profile.name} because it is already synced by default profile`);return}const p=new R.$Tc,D=p.add(this.createSynchronizer(y));p.add(D.onDidChangeStatus(()=>this.L())),p.add(D.onDidChangeConflicts(()=>this.M())),p.add(D.onDidChangeLocal(()=>this.j.fire(y)));const z=this.N(y);this.f.push([D,z,p])}H(y){const p=this.f.findIndex(([D])=>D.resource===y);if(p!==-1){const[[D,,z]]=this.f.splice(p,1);z.dispose(),this.L(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(y){switch(y){case"settings":return this.t.createInstance(g.$X0b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$U0b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$30b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$60b,this.profile,this.collection);case"globalState":return this.t.createInstance(l.$yKb,this.profile,this.collection);case"extensions":return this.t.createInstance(d.$P0b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$N_b,this.profile,this.collection)}}async sync(y,p,D,z){if(z.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],X=(0,s.$Czb)(D),G=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,Y=p?await this.I(G):{};for(const V of F){if(z.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(p){const K=await V.preview(G,Y,X);if(K)for(const W of K.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await V.merge(W.previewResource)}else await V.sync(G,X)}catch(K){const W=s.$Dzb.toUserDataSyncError(K);if(S(W,D,this.w,this.y),E(K))throw W;this.z.error(K),this.z.error(`${V.resource}: ${(0,A.$$i)(K)}`),M.push([V.resource,W])}}return M}finally{this.L()}}async apply(y,p){const D=(0,s.$Czb)(y);for(const z of this.enabled){if(p.isCancellationRequested)return;try{await z.apply(!1,D)}catch(F){const M=s.$Dzb.toUserDataSyncError(F);if(S(M,y,this.w,this.y),E(F))throw M;this.z.error(F),this.z.error(`${z.resource}: ${(0,A.$$i)(F)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(p){this.z.error(p)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(p){this.z.error(`${y.resource}: ${(0,A.$$i)(p)}`),this.z.error(p)}}async I(y){if(!this.profile.isDefault)return{};const p=this.D.getValue(s.$qzb),D=this.enabled.find(z=>z instanceof g.$X0b);if(D){const z=await D.getRemoteUserDataSyncConfiguration(y);return{...p,...z}}return p}J(y){this.g!==y&&(this.g=y,this.h.fire(y))}L(){return this.M(),this.enabled.some(y=>y.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const y=this.enabled.filter(p=>p.status==="hasConflicts").filter(p=>p.conflicts.conflicts.length>0).map(p=>p.conflicts);(0,I.$ub)(this.m,y,(p,D)=>p.syncResource===D.syncResource&&(0,I.$ub)(p.conflicts,D.conflicts,(z,F)=>(0,C.$Tg)(z.previewResource,F.previewResource)))||(this.m=y,this.n.fire(y))}N(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ve([Q(2,s.$Izb),Q(3,h.$mi),Q(4,$.$Wo),Q(5,s.$xzb),Q(6,w.$Sl),Q(7,s.$Nzb),Q(8,u.$tl),Q(9,v.$Ti)],a);function E(P){if(P instanceof s.$Dzb)switch(P.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function S(P,y,p,D){D.publicLog2("sync/error",{code:P.code,serverCode:P instanceof s.$Ezb?String(P.serverCode):void 0,url:P instanceof s.$Ezb?P.url:void 0,resource:P.resource,executionId:y,service:p.userDataSyncStore.url.toString()})}}),define(le[266],he([0,1,3,2,8,18,25]),function(se,e,I,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0;function R($,f){return{...$,profile:(0,A.$ul)($.profile,f.profilesHome.scheme)}}function C($){return{created:$.created,uri:j.URI.revive($.uri)}}class m{constructor(f,h,b){this.c=f,this.d=h,this.f=b,this.a=new Map,this.b=new I.$_d}listen(f,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${h}`)}async call(f,h,b){try{return await this.g(f,h,b)}catch(w){throw this.f.error(w),w}}async g(f,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(b[0]));case"accept":return this.c.accept(R(b[0],this.d),j.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(C(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(b[0]),j.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const w=h.substring(11),u=b[0],d=this.h(u);switch(b=b.slice(1),w){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(f){const h=this.a.get(this.j(f));if(!h)throw new Error(`Manual sync taks not found: ${f}`);return h}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$$cc=m;let k=class extends N.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,h){super(),this.n=h,this.b="uninitialized",this.c=this.B(new I.$_d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$_d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$_d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$_d),this.onSyncErrors=this.m.event,this.a={call(b,w,u){return f.call(b,w,u).then(null,d=>{throw O.$Dzb.toUserDataSyncError(d)})},listen(b,w){return f.listen(b,w)}},this.a.call("_getInitialData").then(([b,w,u])=>{this.s(b),this.t(w),u&&this.u(u),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(w=>({...w,error:O.$Dzb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),h=this;return new v(f,{async call(w,u,d){return h.a.call(`manualSync/${w}`,[f,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,h,b,w){return this.a.call("accept",[f,h,b,w])}resolveContent(f){return this.a.call("resolveContent",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}saveRemoteActivityData(f){return this.a.call("getRemoteActivityData",[f])}extractActivityData(f,h){return this.a.call("extractActivityData",[f,h])}async s(f){this.b=f,this.c.fire(f)}async t(f){this.f=f.map(h=>({syncResource:h.syncResource,profile:(0,A.$ul)(h.profile,this.n.profilesHome.scheme),conflicts:h.conflicts.map(b=>({...b,baseResource:j.URI.revive(b.baseResource),localResource:j.URI.revive(b.localResource),remoteResource:j.URI.revive(b.remoteResource),previewResource:j.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(f){this.h!==f&&(this.h=f,this.j.fire(f))}};e.$_cc=k,e.$_cc=k=ve([Q(1,A.$tl)],k);class v extends N.$Uc{constructor(f,h){super(),this.id=f,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oKb=e.$nKb=e.$mKb=e.$lKb=e.$kKb=void 0;const g="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$Gzb,-1)}set c(D){this.h.store(c.$Gzb,D,-1,C.$o?0:1)}constructor(D,z,F){super(),this.f=D,this.g=z,this.h=F,this.a=this.B(new A.$_d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new O.$Tc);this.B(A.Event.filter(F.onDidChangeValue(-1,c.$Gzb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[g]),this.a.fire()}m(D){if(D&&(D=C.$o&&D.web?{...D,...D.web}:D,(0,k.$1f)(D.url)&&(0,k.$3f)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(z=>Array.isArray(D.authenticationProviders[z].scopes)))){const z=D,F=!!z.canSwitch,M=z.url===z.insidersUrl?"insiders":"stable",X=(F?this.c:void 0)||M,G=X==="insiders"?z.insidersUrl:X==="stable"?z.stableUrl:z.url;return{url:v.URI.parse(G),type:X,defaultType:M,defaultUrl:v.URI.parse(z.url),stableUrl:v.URI.parse(z.stableUrl),insidersUrl:v.URI.parse(z.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(z.authenticationProviders).reduce((Y,V)=>(Y.push({id:V,scopes:z.authenticationProviders[V].scopes}),Y),[])}}}};e.$kKb=a,e.$kKb=a=ve([Q(0,w.$ak),Q(1,f.$Ti),Q(2,l.$Rp)],a);let E=class extends a{constructor(D,z,F){super(D,z,F);const M=this.h.get(i,-1);M&&(this.n=JSON.parse(M));const X=this.f[g];X?this.h.store(i,JSON.stringify(X),-1,1):this.h.remove(i,-1)}async switch(D){D!==this.c&&(this.c=D,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$lKb=E,e.$lKb=E=ve([Q(0,w.$ak),Q(1,f.$Ti),Q(2,l.$Rp)],E);let S=class extends O.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(D,z,F,M,X,G,Y){super(),this.n=F,this.r=M,this.s=Y,this.g=this.B(new A.$_d),this.onTokenFailed=this.g.event,this.h=this.B(new A.$_d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$_d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(D),this.c=(0,d.$Xp)(X,G,Y).then(V=>{const K={"X-Client-Name":`${z.applicationName}${C.$o?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(K["X-Client-Commit"]=z.commit),K}),this.f=new y(t,r,this.n,this.r),this.u(),this.B((0,O.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(D,z){this.b={token:D,type:z}}t(D){this.a=D?(0,m.$1g)(D,"v1"):void 0}u(){const D=this.s.getNumber(o,-1);D&&Date.now()<D&&this.y(new Date(D))}y(D){this.j?.getTime()!==D?.getTime()&&(this.j=D,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,I.$ah)(z=>(0,I.$oh)(this.j.getTime()-Date.now(),z).then(()=>this.y(void 0))),this.w.then(null,z=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,m.$1g)(this.a,"collection").toString();D={...D},D["Content-Type"]="application/json";const F=await this.D(z,{type:"GET",headers:D},[],N.CancellationToken.None);return(await(0,u.$Kp)(F))?.map(({id:M})=>M)||[]}async createCollection(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,m.$1g)(this.a,"collection").toString();D={...D},D["Content-Type"]=R.$Es.text;const F=await this.D(z,{type:"POST",headers:D},[],N.CancellationToken.None),M=await(0,u.$Jp)(F);if(!M)throw new c.$Ezb("Server did not return the collection id",z,"NoCollection",F.res.statusCode,F.res.headers[c.$Azb]);return M}async deleteCollection(D,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=D?(0,m.$1g)(this.a,"collection",D).toString():(0,m.$1g)(this.a,"collection").toString();z={...z},await this.D(F,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async getAllResourceRefs(D,z){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,z,D),M={},X=await this.D(F.toString(),{type:"GET",headers:M},[],N.CancellationToken.None);return(await(0,u.$Kp)(X)||[]).map(({url:Y,created:V})=>({ref:(0,m.$3g)(F,F.with({path:Y})),created:V*1e3}))}async resolveResourceContent(D,z,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,m.$1g)(this.z(this.a,F,D),z).toString();M={...M},M["Cache-Control"]="no-cache";const G=await this.D(X,{type:"GET",headers:M},[],N.CancellationToken.None);return await(0,u.$Jp)(G)}async deleteResource(D,z,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=z!==null?(0,m.$1g)(this.z(this.a,F,D),z).toString():this.z(this.a,F,D).toString(),X={};await this.D(M,{type:"DELETE",headers:X},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,m.$1g)(this.a,"resource").toString(),z={"Content-Type":R.$Es.text};await this.D(D,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async readResource(D,z,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,m.$1g)(this.z(this.a,F,D),"latest").toString();M={...M},M["Cache-Control"]="no-cache",z&&(M["If-None-Match"]=z.ref);const G=await this.D(X,{type:"GET",headers:M},[304],N.CancellationToken.None);let Y=null;if(G.res.statusCode===304&&(Y=z),Y===null){const V=G.res.headers.etag;if(!V)throw new c.$Ezb("Server did not return the ref",X,"NoRef",G.res.statusCode,G.res.headers[c.$Azb]);const K=await(0,u.$Jp)(G);if(!K&&G.res.statusCode===304)throw new c.$Ezb("Empty response",X,"EmptyResponse",G.res.statusCode,G.res.headers[c.$Azb]);Y={ref:V,content:K}}return Y}async writeResource(D,z,F,M,X={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=this.z(this.a,M,D).toString();X={...X},X["Content-Type"]=R.$Es.text,F&&(X["If-Match"]=F);const Y=await this.D(G,{type:"POST",data:z,headers:X},[],N.CancellationToken.None),V=Y.res.headers.etag;if(!V)throw new c.$Ezb("Server did not return the ref",G,"NoRef",Y.res.statusCode,Y.res.headers[c.$Azb]);return V}async manifest(D,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$1g)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",D&&(z["If-None-Match"]=D.ref);const M=await this.D(F,{type:"GET",headers:z},[304],N.CancellationToken.None);let X=null;if(M.res.statusCode===304&&(X=D),!X){const Y=M.res.headers.etag;if(!Y)throw new c.$Ezb("Server did not return the ref",F,"NoRef",M.res.statusCode,M.res.headers[c.$Azb]);const V=await(0,u.$Jp)(M);if(!V&&M.res.statusCode===304)throw new c.$Ezb("Empty response",F,"EmptyResponse",M.res.statusCode,M.res.headers[c.$Azb]);V&&(X={...JSON.parse(V),ref:Y})}const G=this.s.get(n,-1);return G&&X&&G!==X.session&&this.C(),X===null&&G&&this.C(),X&&this.s.store(n,X.session,-1,1),X}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,m.$1g)(this.a,"download").toString(),z={},F=await this.D(D,{type:"GET",headers:z},[],N.CancellationToken.None);if(!(0,u.$Gp)(F))throw new c.$Ezb("Server returned "+F.res.statusCode,D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$Azb]);if((0,u.$Hp)(F))throw new c.$Ezb("Empty response",D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$Azb]);return F.stream}z(D,z,F){return z?(0,m.$1g)(D,"collection",z,"resource",F):(0,m.$1g)(D,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(D,z,F,M){if(!this.b)throw new c.$Ezb("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$Ezb(`${z.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const X=await this.c;z.headers={...z.headers||{},...X,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(z.headers),this.r.trace("Sending request to server",{url:D,type:z.type,headers:{...z.headers,authorization:void 0}});let G;try{G=await this.f.request(D,z,M)}catch(B){if(!(B instanceof c.$Ezb)){let ie="RequestFailed";const ae=(0,j.$0)(B).toLowerCase();ae.includes("xhr timeout")?ie="RequestTimeout":ae.includes("protocol")&&ae.includes("not supported")?ie="RequestProtocolNotSupported":ae.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":ae.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,j.$4)(B)&&(ie="RequestCanceled"),B=new c.$Ezb(`Connection refused for the request '${D}'.`,D,ie,void 0,void 0)}throw this.r.info("Request failed",D),B}const Y=G.res.headers[c.$Azb],V={url:D,status:G.res.statusCode,"execution-id":z.headers[c.$Bzb],"operation-id":Y},K=(0,u.$Gp)(G)||G.res.statusCode&&F.includes(G.res.statusCode);let W="";if(K?this.r.trace("Request succeeded",V):(W=await(0,u.$Ip)(G)||"",this.r.info("Request failed",V,W)),G.res.statusCode===401||G.res.statusCode===403){if(this.b=void 0,G.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$Ezb(`${z.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",G.res.statusCode,Y);if(G.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$Ezb(`${z.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",G.res.statusCode,Y)}if(this.h.fire(),G.res.statusCode===404)throw new c.$Ezb(`${z.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",G.res.statusCode,Y);if(G.res.statusCode===405)throw new c.$Ezb(`${z.type} request '${D}' failed because the requested endpoint is not found (405). ${W}`,D,"MethodNotFound",G.res.statusCode,Y);if(G.res.statusCode===409)throw new c.$Ezb(`${z.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",G.res.statusCode,Y);if(G.res.statusCode===410)throw new c.$Ezb(`${z.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",G.res.statusCode,Y);if(G.res.statusCode===412)throw new c.$Ezb(`${z.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",G.res.statusCode,Y);if(G.res.statusCode===413)throw new c.$Ezb(`${z.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",G.res.statusCode,Y);if(G.res.statusCode===426)throw new c.$Ezb(`${z.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",G.res.statusCode,Y);if(G.res.statusCode===429){const B=G.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new c.$Ezb(`${z.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",G.res.statusCode,Y)):new c.$Ezb(`${z.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",G.res.statusCode,Y)}if(!K)throw new c.$Ezb("Server returned "+G.res.statusCode,D,"Unknown",G.res.statusCode,Y);return G}F(D){let z=this.s.get(s,-1);z===void 0&&(z=(0,$.$Jg)(),this.s.store(s,z,-1,1)),D["X-Machine-Session-Id"]=z;const F=this.s.get(n,-1);F!==void 0&&(D["X-User-Session-Id"]=F)}};e.$mKb=S,e.$mKb=S=ve([Q(1,w.$ak),Q(2,u.$Ep),Q(3,c.$Nzb),Q(4,h.$ui),Q(5,b.$Tk),Q(6,l.$Rp)],S);let P=class extends S{constructor(D,z,F,M,X,G,Y){super(D.userDataSyncStore?.url,z,F,M,X,G,Y),this.B(D.onDidChangeUserDataSyncStore(()=>this.t(D.userDataSyncStore?.url)))}};e.$nKb=P,e.$nKb=P=ve([Q(0,c.$xzb),Q(1,w.$ak),Q(2,u.$Ep),Q(3,c.$Nzb),Q(4,h.$ui),Q(5,b.$Tk),Q(6,l.$Rp)],P);class y{constructor(D,z,F,M){this.c=D,this.d=z,this.f=F,this.g=M,this.a=[],this.b=void 0}request(D,z,F){if(this.h()&&this.i(),z.url=D,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$Ezb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(D),this.f.request(z,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$oKb=y}),define(le[267],he([0,1,3,2,8,21,24,19,122]),function(se,e,I,N,j,A,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=void 0;class m{constructor(h){this.a=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(h,b,w){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(w)}throw new Error("Invalid call")}}e.$7cc=m;class k extends N.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(h){super(),this.c=h,this.b=this.B(new I.$_d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(w=>{this.a=w,this.b.fire(w)}))})}updateAccount(h){return this.c.call("updateAccount",h)}}e.$8cc=k;class v{constructor(h){this.a=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(h,b,w){switch(b){case"switch":return this.a.switch(w[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$9cc=v;let $=class extends C.$kKb{constructor(h,b,w,u){super(b,w,u),this.n=h,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(h){return this.n.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.n.call("getPreviousUserDataSyncStore");return this.r(h)}r(h){return{url:j.URI.revive(h.url),type:h.type,defaultUrl:j.URI.revive(h.defaultUrl),insidersUrl:j.URI.revive(h.insidersUrl),stableUrl:j.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}};e.$0cc=$,e.$0cc=$=ve([Q(1,O.$ak),Q(2,A.$Ti),Q(3,R.$Rp)],$)}),define(le[268],he([0,1,3,57,24,19,22,263,25,80,83]),function(se,e,I,N,j,A,O,R,C,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;let v=class extends R.$R_b{constructor(f,h,b,w,u,d,l,c,g,i,o){super(f,h,b,w,u,l,c,g,i,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$tdc=v,e.$tdc=v=ve([Q(0,j.$ak),Q(1,C.$xzb),Q(2,C.$yzb),Q(3,C.$Izb),Q(4,C.$Jzb),Q(5,N.$kbc),Q(6,C.$Nzb),Q(7,m.$SIb),Q(8,O.$Sl),Q(9,k.$lzb),Q(10,A.$Rp)],v)}),define(le[269],he([0,1,73,23,5,20]),function(se,e,I,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0,e.$Lac=O,e.$Mac=R,e.$Nac=C,e.$Kac=128/4;function O(m){function k(){let v=m.scheme===N.Schemas.file?(0,A.$Og)(m):m.toString();return j.$k||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:k(),configPath:m}}function R(m,k){function v(){if(m.scheme!==N.Schemas.file)return(0,I.createHash)("md5").update(m.toString()).digest("hex");if(!k)return;let f;return j.$k?f=k.ino:j.$j?f=k.birthtime.getTime():j.$i&&(typeof k.birthtimeMs=="number"?f=Math.floor(k.birthtimeMs):f=k.birthtime.getTime()),(0,I.createHash)("md5").update(m.fsPath).update(f?String(f):"").digest("hex")}const $=v();if(typeof $=="string")return{id:$,uri:m}}function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[270],he([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;let b=class extends j.$Uc{constructor(u,d,l,c){super(),this.a=u,this.b=d,this.c=l,this.f=c,this.B(new I.$zh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=this.a.workspaceStorageHome.with({scheme:h.Schemas.file}).fsPath,d=await O.Promises.readdir(u),l=new m.$tJb(this.f.getChannel("storage"));await Promise.all(d.map(async c=>{const g=(0,A.$kc)(u,c);c.length===v.$Kac||c===k.$zi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await l.isUsed(g)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await O.Promises.rm(g))}))}catch(u){(0,N.$1)(u)}}};e.$3cc=b,e.$3cc=b=ve([Q(0,R.$vi),Q(1,C.$Tj),Q(2,$.$kbc),Q(3,f.$zcc)],b)}),define(le[123],he([0,1,73,64,37,279,15,7,3,2,14,5,32,41,68]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$ei=e.$di=e.$ci=void 0,e.$fi=n,e.$gi=s,e.$ii=a,e.$ji=E;class b{traceSocketEvent(P,y){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,y)}constructor(P,y=""){this.f=!0,this.debugLabel=y,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,R.$1)(p)}},this.socket.on("error",this.a),this.b=p=>{this.traceSocketEvent("close",{hadError:p}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(P){const y=p=>{this.traceSocketEvent("read",p),P(O.$ze.wrap(p))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(P){const y=p=>{P({type:0,hadError:p,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(P){const y=()=>{P()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(P){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,R.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,R.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.$ci=b;var w;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var u;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(u||(u={}));class d extends m.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(P,y){this.socket.traceSocketEvent(P,y)}constructor(P,y,p,D){super(),this.f=this.B(new C.$_d),this.g=this.B(new C.$_d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:p?.byteLength||0,recordInflateBytes:D}),this.a=this.B(new l(this,y,p,D,this.f,(z,F)=>this.m(z,F))),this.B(this.a.onError(z=>{console.error(z),(0,R.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new h.$0h,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this.f.event(P)}onClose(P){return this.g.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let y=0;for(;y<P.byteLength;)this.a.writeMessage(P.slice(y,Math.min(y+262144,P.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(P,{compressed:y,opcode:p}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let D=2;P.byteLength<126?D+=0:P.byteLength<2**16?D+=2:D+=8;const z=O.$ze.alloc(D),F=y?64:0,M=p&15;if(z.writeUInt8(128|F|M,0),P.byteLength<126)z.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){z.writeUInt8(126,1);let X=1;z.writeUInt8(P.byteLength>>>8&255,++X),z.writeUInt8(P.byteLength>>>0&255,++X)}else{z.writeUInt8(127,1);let X=1;z.writeUInt8(0,++X),z.writeUInt8(0,++X),z.writeUInt8(0,++X),z.writeUInt8(0,++X),z.writeUInt8(P.byteLength>>>24&255,++X),z.writeUInt8(P.byteLength>>>16&255,++X),z.writeUInt8(P.byteLength>>>8&255,++X),z.writeUInt8(P.byteLength>>>0&255,++X)}this.socket.write(O.$ze.concat([z,P]))}end(){this.h=!0,this.socket.end()}n(P){if(P.byteLength!==0){for(this.b.acceptChunk(P);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),p=y.readUInt8(0),D=(p&128)>>>7,z=(p&64)>>>6,F=p&15,M=y.readUInt8(1),X=(M&128)>>>7,G=M&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=D,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!D,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),p=y.readUInt8(1),D=(p&128)>>>7;let z=p&127,F=1;z===126?z=y.readUInt8(++F)*2**8+y.readUInt8(++F):z===127&&(z=y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F));let M=0;D&&(M=y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F)),this.j.state=3,this.j.readLen=z,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),i(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$di=d;class l extends m.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ze.alloc(0)}constructor(P,y,p,D,z,F){super(),this.n=P,this.r=z,this.s=F,this.a=this.B(new C.$_d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$_d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$_d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new c(this.n,D,p,{windowBits:15})),this.f=this.B(new g(this.n,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(P,y){this.g.push({data:P,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:P,options:y}=this.g.shift();if(this.f&&y.compressed){const p=await this.w(this.f,P);this.s(p,y)}else this.s(P,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(P,y){return new Promise((p,D)=>{P.write(y),P.flush(z=>p(z))})}acceptFrame(P,y,p){this.h.push({data:P,isCompressed:y,isLastFrameOfMessage:p}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const P=this.h.shift();if(this.b&&P.isCompressed){const y=await this.C(this.b,P.data,P.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(P.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(P,y,p){return new Promise((D,z)=>{P.write(y),p&&P.write(O.$ze.fromByteArray([0,0,255,255])),P.flush(F=>D(F))})}}class c extends m.$Uc{get recordedInflateBytes(){return this.j?O.$ze.concat(this.f):O.$ze.alloc(0)}constructor(P,y,p,D){super(),this.h=P,this.j=y,this.a=this.B(new C.$_d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(D),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(O.$ze.wrap(z))}),p&&(this.h.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this.b.write(p.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(P){this.j&&this.f.push(P.clone()),this.h.traceSocketEvent("zlibInflateWrite",P),this.b.write(P.buffer)}flush(P){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=O.$ze.concat(this.g);this.g.length=0,P(y)})}}class g extends m.$Uc{constructor(P,y){super(),this.g=P,this.a=this.B(new C.$_d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",p=>{this.g.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.g.traceSocketEvent("zlibDeflateData",p),this.f.push(O.$ze.wrap(p))})}write(P){this.g.traceSocketEvent("zlibDeflateWrite",P.buffer),this.b.write(P.buffer)}flush(P){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=O.$ze.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),P(y)})}}function i(S,P){if(P===0)return;const y=S.byteLength>>>2;for(let X=0;X<y;X++){const G=S.readUInt32BE(X*4);S.writeUInt32BE(G^P,X*4)}const p=y*4,D=S.byteLength-p,z=P>>>24&255,F=P>>>16&255,M=P>>>8&255;D>=1&&S.writeUInt8(S.readUInt8(p)^z,p),D>=2&&S.writeUInt8(S.readUInt8(p+1)^F,p+1),D>=3&&S.writeUInt8(S.readUInt8(p+2)^M,p+2)}e.$ei=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const S=(0,$.$Jg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const P=process.platform!=="darwin"&&e.$ei?e.$ei:(0,j.tmpdir)(),y=(0,k.$kc)(P,`vscode-ipc-${S}.sock`);return t(y),y}function s(S,P,y){const D=(0,I.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${y}-${P}-sock`;const z=y.substr(0,4),F=P.substr(0,6);let M;return process.platform!=="darwin"&&e.$ei&&!process.env.VSCODE_PORTABLE?M=(0,k.$kc)(e.$ei,`vscode-${D}-${z}-${F}.sock`):M=(0,k.$kc)(S,`${z}-${F}.sock`),t(M),M}function t(S){const P=o[v.$u];typeof P=="number"&&S.length>=P&&console.warn(`WARNING: IPC handle "${S}" is longer than ${P} chars, try a shorter --user-data-dir`)}class r extends f.$4h{static b(P){const y=C.Event.fromNodeEventEmitter(P,"connection");return C.Event.map(y,p=>({protocol:new h.$$h(new b(p,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(p,"close"))}))}constructor(P){super(r.b(P)),this.d=P}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hi=r;function a(S){return new Promise((P,y)=>{const p=(0,N.createServer)();p.on("error",y),p.listen(S,()=>{p.removeListener("error",y),P(new r(p))})})}function E(S,P){return new Promise((y,p)=>{const D=(0,N.createConnection)(S,()=>{D.removeListener("error",p),y(h.$_h.fromSocket(new b(D,`ipc-client${P}`),P))});D.once("error",p)})}}),define(le[271],he([0,1,64,123,218]),function(se,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0,e.$wdc=new class{supports(A){return!0}connect({host:A,port:O},R,C,m){return new Promise((k,v)=>{const $=I.createConnection({host:A,port:O},()=>{$.removeListener("error",v),$.write((0,j.$_rb)(R,C,m));const f=h=>{h.toString().indexOf(`\r
\r
`)>=0&&($.off("data",f),k(new N.$ci($,m)))};$.on("data",f)});$.setNoDelay(!0),$.once("error",v)})}}}),define(le[272],he([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=e.$rcc=e.$qcc=void 0;async function u(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&j.$Mg[t]||!j.$Mg[r.tunnelLocalPort]));a--);return r}class d extends R.$Uc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=I.createServer(),this.c=new O.$mh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$0v)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,j.$Ng)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$8v)(this.tunnelRemoteHost)||(0,b.$0v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,$.$Jl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof A.$ci?t.socket.destroy():t.end()}),t instanceof A.$ci?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(w.$ze.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$qcc=d;let l=class extends b.$aw{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$$v)(o,this.m,C.OS,N.release())}t(o,n,s,t,r,a,E,S){const P=this.s(n,s);if(P)return++P.refcount,P.value;if((0,b.$4v)(o))return this.u(o,n,s,r,a,E,S);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},p=u(y,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,p),p}}};e.$rcc=l,e.$rcc=l=ve([Q(0,f.$Dl),Q(1,k.$Tj),Q(2,h.$Gl),Q(3,v.$ak),Q(4,m.$Ti)],l);let c=class extends l{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$scc=c,e.$scc=c=ve([Q(0,f.$Dl),Q(1,k.$Tj),Q(2,h.$Gl),Q(3,v.$ak),Q(4,m.$Ti)],c);let g=class extends R.$Uc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,E,S,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const y=new c(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(o,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,E,S,P)}};e.$tcc=g,e.$tcc=g=ve([Q(0,f.$Dl),Q(1,k.$Tj),Q(2,v.$ak),Q(3,h.$Gl),Q(4,m.$Ti)],g)}),define(le[280],he([0,1,37,38,7,2,23,8,17,3,41,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(se,e,I,N,j,A,O,R,C,m,k,v,$,f,h,b,w,u,d,l,c,g,i,o,n,s,t,r,a,E,S,P,y,p,D,z,F,M,X,G,Y,V,K,W,B,ie,ae,te,ce,H,U,L,T,q,x,J,ee,_,Z,ne,re,ue,de,$e,ye,Se,Ie,Le,fe,me,be,Ce,Re,ze,De,Ue,Te,Me,qe,Ae,oe,ge,we,pe,Ee,Pe,Oe,Ne,We,Be,Fe,Qe,Ge,_e,tt,St,kt,gt,Pt,Ct,Rt,It,Ot,Dt,Lt,jt,$t,At,mt,Nt,zt,st,Tt,Ft,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class Mt extends A.$Uc{constructor(ke){super(),this.f=ke,this.a=this.B(new v.$wW(this)),this.b=void 0,this.c=this.B(new m.$_d),this.g()}g(){let ke=!1;const je=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,v.$xW)(process.parentPort,st.$Fbc.exit,je)}async init(){const ke=await this.h();(0,_.$szb)(),ke.invokeFunction(je=>{const He=je.get(K.$Tj),Ve=je.get(H.$Sl),Xe=je.get(Pe.$tl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(He),this.n(Ve,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(Ve,Xe))),this.r(Ve,He)}),this.B((0,A.$Rc)(ke.createInstance($.$Ycc,this.f.codeCachePath),ke.createInstance(f.$Zcc),ke.createInstance(w.$3cc),ke.createInstance(b.$2cc),ke.createInstance(h.$1cc),ke.createInstance(tt.$ndc),ke.createInstance(Qe.$fdc)))}async h(){const ke=new G.$li,je={_serviceBrand:void 0,...B.default};ke.set(ie.$ak,je);const He=new k.$8h(Ke=>Ke==="main"),Ve=new $t.$Acc(this.a,He);ke.set($t.$zcc,Ve);const Xe=this.f.policiesData?new Ne.$9bc(this.f.policiesData,Ve.getChannel("policy")):new We.$0n;ke.set(We.$8n,Xe);const Je=new zt.$Zm(this.f.args,je);ke.set(s.$vi,Je);const et=new W.$Zr(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:R.URI.revive(Ke.resource)})),Ve.getChannel("logger"));ke.set(K.$Uj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ht=this.B(new K.$2j(ot.getLevel())),Ze=this.B(new kt.$gQ(ot,[ht]));ke.set(K.$Tj,Ze),this.b=this.B(new gt.$pdc(Ze)),ke.set(gt.$odc,this.b);const Ye=this.B(new D.$zq(Ze));ke.set(p.$Tk,Ye);const ut=this.B(new z.$1q(Ze));Ye.registerProvider(O.Schemas.file,ut);const at=new Me.$os(Ye);ke.set(Te.$rl,at);const xe=this.B(new Be.$nQ(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ke.set(Pe.$tl,xe);const ft=this.B(new Ae.$ycc(O.Schemas.file,this.B(new oe.$2P(Ve.getChannel(oe.$1P),{pathCaseSensitive:qe.$k})),O.Schemas.vscodeUserData,xe,at,Ze));Ye.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new c.$xo(xe.defaultProfile.settingsResource,Ye,Xe,Ze));ke.set(l.$Ti,it);const dt=new At.$vdc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);ke.set(te.$Rp,dt),this.B((0,A.$Sc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new Rt.$Kr(Ve.getChannel("request"));ke.set(ae.$Ep,bt),ke.set(u.$4cc,new F.$ki(d.$5cc,void 0,!1)),ke.set(we.$ZF,new F.$ki(ge.$edc,void 0,!1));const yt=new Dt.$Fcc(-1,Ve);ke.set(Ot.$kbc,yt),ke.set(o.$Bo,new F.$ki(n.$vQ,void 0,!0));const qt=this.B(new me.$6bc(yt)),Bt=new k.$8h(Ke=>qt.getActiveClientId().then(lt=>Ke===lt));ke.set(y.$g3b,new It.$rdc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,q.$ip)(je,it);if((0,q.$dp)(je,Je)){const Ke=new L.$9$b(Ze,et,Je,je);if(nt.push(Ke),!(0,q.$ep)(je,Je)&&je.aiConfig?.ariaKey){const lt=new Fe.$7P(bt,vt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Sc)(()=>lt.flush())),nt.push(lt)}ct=new T.$Or({appenders:nt,commonProperties:(0,ce.$7o)((0,I.release)(),(0,I.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,q.$jp)(Je)},it,je)}else{ct=q.$$o;const Ke=q.$cp;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new U.$Kbc(nt)),ke.set(H.$Sl,ct);const Vt=new x.$6cc(it,ct,Ze,et,Je,je);ke.set(H.$Tl,Vt),ke.set(Oe.$gq,new F.$ki(Ct.$fQ,void 0,!0)),ke.set(pe.$kq,new F.$ki(Ee.$0bc,void 0,!0)),ke.set(E.$3p,new F.$ki(E.$4p,void 0,!0)),ke.set(P.$uq,new F.$ki(P.$vq,void 0,!0)),ke.set(a.$Wo,new F.$ki(r.$1p,void 0,!0)),ke.set(a.$4o,new F.$ki(jt.$udc,void 0,!1)),ke.set(Y.$Gr,new F.$ki(V.$Ir,void 0,!1)),ke.set(g.$7m,new F.$ki(i.$vs,void 0,!1)),ke.set(Z.$SIb,new F.$ki(Z.$TIb,void 0,!0)),ke.set(_.$Nzb,new F.$ki(ue.$gLb,void 0,!0)),ke.set(_.$Mzb,k.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ke.set(a.$3o,new F.$ki(t.$QIb,void 0,!1)),ke.set(ee.$eLb,new F.$ki(ee.$fLb,void 0,!0)),ke.set(J.$Nv,new F.$ki(J.$Ov)),ke.set(_.$xzb,new F.$ki(Ie.$lKb,void 0,!0)),ke.set(_.$yzb,new F.$ki(Ie.$nKb,void 0,!0)),ke.set(de.$lzb,new F.$ki(de.$nzb,void 0,!0)),ke.set(_.$zzb,new F.$ki(ne.$L_b,void 0,!1)),ke.set(_.$Izb,new F.$ki($e.$A_b,void 0,!0)),ke.set(_.$Jzb,new F.$ki(ye.$Q_b,void 0,!1)),ke.set(Le.$uJb,new F.$ki(fe.$adc,void 0,!0)),ke.set(_.$Kzb,new F.$ki(_e.$nac,void 0,!0)),ke.set(be.$Gl,new F.$ki(Ce.$vcc,void 0,!1));const Et=new mt.$El;return ke.set(mt.$Dl,Et),Et.register(0,Nt.$wdc),ke.set(Re.$3v,new F.$ki(ze.$tcc)),ke.set(De.$bdc,new F.$ki(Ue.$ddc)),ke.set(Ge.$gdc,new F.$ki(Pt.$qdc)),new X.$4q(ke)}j(ke){const je=new S.$6p(ke.get(a.$Zo),()=>null);this.a.registerChannel("extensions",je);const He=k.ProxyChannel.fromService(ke.get(Y.$Gr),this.q);this.a.registerChannel("languagePacks",He);const Ve=k.ProxyChannel.fromService(ke.get(g.$7m),this.q);this.a.registerChannel("diagnostics",Ve);const Xe=new S.$8p(ke.get(a.$4o));this.a.registerChannel("extensionTipsService",Xe);const Je=k.ProxyChannel.fromService(ke.get(u.$4cc),this.q);this.a.registerChannel("checksum",Je);const et=k.ProxyChannel.fromService(ke.get(we.$ZF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=k.ProxyChannel.fromService(ke.get(de.$lzb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=k.ProxyChannel.fromService(ke.get(H.$Tl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Ze=new re.$7cc(ke.get(Z.$SIb));this.a.registerChannel("userDataSyncAccount",Ze);const Ye=new re.$9cc(ke.get(_.$xzb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new Se.$$cc(ke.get(_.$Jzb),ke.get(Pe.$tl),ke.get(K.$Tj));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(M.$mi).createInstance(Lt.$tdc));this.a.registerChannel("userDataAutoSync",k.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",k.ProxyChannel.fromService(ke.get(_.$Kzb),this.q));const xe=k.ProxyChannel.fromService(ke.get(De.$bdc),this.q);this.a.registerChannel(De.$cdc,xe);const ft=k.ProxyChannel.fromService(ke.get(Ge.$gdc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",je=>(0,j.$1)(je)),process.on("unhandledRejection",je=>(0,j.$1)(je)),(0,j.setUnexpectedErrorHandler)(je=>{const He=(0,N.$$i)(je,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,je){ke.publicLog2("profilesInfo",{count:je.profiles.length})}async r(ke,je){if(qe.$k){const[He,Ve]=await Promise.all([(0,Tt.$Kg)(je.error.bind(je)),(0,wt.$eW)(je.error.bind(je))]),Xe=(0,Ft.$WV)(),Je=(0,wt.$fW)(Ve,this.f.args["ozone-platform"]);He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Xe,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(ke){if(ke.data!==st.$Hbc.response)return!1;const je=(0,C.$Ob)(ke.ports);return je?(this.c.fire(je),!0):!1}}async function pt(rt){try{const ke=new Mt(rt);process.parentPort.postMessage(st.$Fbc.ipcReady),await ke.init(),process.parentPort.postMessage(st.$Fbc.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const Ut=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(Ut),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
