/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(he){for(var e=[],u=0,O=he.length;u<O;u++)e[u]=ke[he[u]];return e};define(ke[162],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const L=new Map,R=new Map,M=new Map,b=new Map;function p(S,v){S.has(v.detail)||S.set(v.detail,-v.timestamp)}function E(S,v){const a=S.get(v.detail);a&&(a>=0||S.set(v.detail,a+v.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((S,v)=>S.timestamp-v.timestamp));for(const S of A)switch(S.type){case 10:p(L,S);break;case 11:case 12:E(L,S);break;case 21:p(R,S);break;case 22:E(R,S);break;case 33:p(M,S);break;case 34:E(M,S);break;case 31:p(b,S);break;case 32:E(b,S);break}let P=0;M.forEach(S=>P+=S);function $(S){const v=[];return S.forEach((a,m)=>v.push([m,a])),v}return{amdLoad:$(L),amdInvoke:$(R),nodeRequire:$(M),nodeEval:$(b),nodeRequireTotal:P}}static toMarkdownTable(L,R){let M="";const b=[];return L.forEach((p,E)=>{b[E]=p.length}),R.forEach(p=>{p.forEach((E,A)=>{typeof E>"u"&&(E=p[A]="-");const P=E.toString().length;b[A]=Math.max(P,b[A])})}),L.forEach((p,E)=>{M+=`| ${p+" ".repeat(b[E]-p.toString().length)} `}),M+=`|
`,L.forEach((p,E)=>{M+=`| ${"-".repeat(b[E])} `}),M+=`|
`,R.forEach(p=>{p.forEach((E,A)=>{typeof E<"u"&&(M+=`| ${E+" ".repeat(b[A]-E.toString().length)} `)}),M+=`|
`}),M}}e.$U=u}),define(ke[163],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=O,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=b,e.$lb=p,e.$nb=A,e.$ob=P,e.$pb=$,e.$qb=S,e.$rb=v;function u(a,m,o){const n=O(a,m);if(n!==-1)return a[n]}function O(a,m,o=a.length-1){for(let n=o;n>=0;n--){const i=a[n];if(m(i))return n}return-1}function L(a,m){const o=R(a,m);return o===-1?void 0:a[o]}function R(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?i=s+1:r=s}return i-1}function M(a,m){const o=b(a,m);return o===a.length?void 0:a[o]}function b(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?r=s:i=s+1}return i}function p(a,m,o=0,n=a.length){const i=b(a,m,o,n);return i===a.length?-1:i}class E{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=R(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=E;function A(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>0&&(o=i)}return o}function P(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>=0&&(o=i)}return o}function $(a,m){return A(a,(o,n)=>-m(o,n))}function S(a,m){if(a.length===0)return-1;let o=0;for(let n=1;n<a.length;n++){const i=a[n];m(i,a[o])>0&&(o=n)}return o}function v(a,m){for(const o of a){const n=m(o);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=O,e.$M=L,e.$N=R;function u(M,b){const p=Object.create(null);for(const E of M){const A=b(E);let P=p[A];P||(P=p[A]=[]),P.push(E)}return p}function O(M,b){const p=[],E=[];for(const A of M)b.has(A)||p.push(A);for(const A of b)M.has(A)||E.push(A);return{removed:p,added:E}}function L(M,b){const p=[],E=[];for(const[A,P]of M)b.has(A)||p.push(P);for(const[A,P]of b)M.has(A)||E.push(P);return{removed:p,added:E}}function R(M,b){const p=new Set;for(const E of b)M.has(E)&&p.add(E);return p}}),define(ke[55],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=O,e.$Sh=L,e.$Th=R;function u(M){return(b,p,E)=>{let A=null,P=null;if(typeof E.value=="function"?(A="value",P=E.value):typeof E.get=="function"&&(A="get",P=E.get),!P)throw new Error("not supported");E[A]=M(P,p)}}function O(M,b,p){let E=null,A=null;if(typeof p.value=="function"?(E="value",A=p.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",A=p.get),!A)throw new Error("not supported");const P=`$memoize$${b}`;p[E]=function(...$){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[P]}}function L(M,b,p){return u((E,A)=>{const P=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...S){this[$]||(this[$]=p?p():void 0),clearTimeout(this[P]),b&&(this[$]=b(this[$],...S),S=[this[$]]),this[P]=setTimeout(()=>{E.apply(this,S),this[$]=p?p():void 0},M)}})}function R(M,b,p){return u((E,A)=>{const P=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...a){if(this[$]||(this[$]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...a)),this[v])return;const m=this[S]+M;m<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[$]]),this[$]=p?p():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[S]=Date.now(),E.apply(this,[this[$]]),this[$]=p?p():void 0},m-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=O,e.$Z=L,e.$1=R,e.$2=M,e.$3=b,e.$4=E,e.$6=P,e.$7=$,e.$8=S,e.$0=a;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function O(s){e.$X.setUnexpectedErrorHandler(s)}function L(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(s){E(s)||e.$X.onUnexpectedError(s)}function M(s){E(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const p="Canceled";function E(s){return s instanceof A?!0:s instanceof Error&&s.name===p&&s.message===p}class A extends Error{constructor(){super(p),this.name=this.message}}e.$5=A;function P(){const s=new Error(p);return s.name=s.message,s}function $(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function S(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,163]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=b,e.$wb=p,e.$xb=E,e.$yb=A,e.$zb=P,e.$Ab=$,e.$Bb=S,e.$Cb=v,e.$Db=a,e.$Eb=m,e.top=o,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=l,e.$Nb=c,e.$Ob=h,e.$Pb=g,e.$Qb=D,e.$Rb=w,e.$Sb=k,e.$Tb=y,e.$Ub=C,e.$Vb=I,e.$Wb=z,e.$Xb=j,e.$Yb=F,e.$Zb=N,e.$1b=T,e.$2b=B,e.$3b=H,e.$4b=Z,e.$5b=ee,e.$6b=J,e.$7b=te,e.$8b=pe,e.$$b=U;function L(ae,ce=0){return ae[ae.length-(1+ce)]}function R(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function M(ae,ce,se=(K,ie)=>K===ie){if(ae===ce)return!0;if(!ae||!ce||ae.length!==ce.length)return!1;for(let K=0,ie=ae.length;K<ie;K++)if(!se(ae[K],ce[K]))return!1;return!0}function b(ae,ce){const se=ae.length-1;ce<se&&(ae[ce]=ae[se]),ae.pop()}function p(ae,ce,se){return E(ae.length,K=>se(ae[K],ce))}function E(ae,ce){let se=0,K=ae-1;for(;se<=K;){const ie=(se+K)/2|0,le=ce(ie);if(le<0)se=ie+1;else if(le>0)K=ie-1;else return ie}return-(se+1)}function A(ae,ce,se){if(ae=ae|0,ae>=ce.length)throw new TypeError("invalid index");const K=ce[Math.floor(ce.length*Math.random())],ie=[],le=[],de=[];for(const Ae of ce){const me=se(Ae,K);me<0?ie.push(Ae):me>0?le.push(Ae):de.push(Ae)}return ae<ie.length?A(ae,ie,se):ae<ie.length+de.length?de[0]:A(ae-(ie.length+de.length),le,se)}function P(ae,ce){const se=[];let K;for(const ie of ae.slice(0).sort(ce))!K||ce(K[0],ie)!==0?(K=[ie],se.push(K)):K.push(ie);return se}function*$(ae,ce){let se,K;for(const ie of ae)K!==void 0&&ce(K,ie)?se.push(ie):(se&&(yield se),se=[ie]),K=ie;se&&(yield se)}function S(ae,ce){for(let se=0;se<=ae.length;se++)ce(se===0?void 0:ae[se-1],se===ae.length?void 0:ae[se])}function v(ae,ce){for(let se=0;se<ae.length;se++)ce(se===0?void 0:ae[se-1],ae[se],se+1===ae.length?void 0:ae[se+1])}function a(ae,ce,se){const K=[];function ie(Ae,me,Pe){if(me===0&&Pe.length===0)return;const Me=K[K.length-1];Me&&Me.start+Me.deleteCount===Ae?(Me.deleteCount+=me,Me.toInsert.push(...Pe)):K.push({start:Ae,deleteCount:me,toInsert:Pe})}let le=0,de=0;for(;;){if(le===ae.length){ie(le,0,ce.slice(de));break}if(de===ce.length){ie(le,ae.length-le,[]);break}const Ae=ae[le],me=ce[de],Pe=se(Ae,me);Pe===0?(le+=1,de+=1):Pe<0?(ie(le,1,[]),le+=1):Pe>0&&(ie(le,0,[me]),de+=1)}return K}function m(ae,ce,se){const K=a(ae,ce,se),ie=[],le=[];for(const de of K)ie.push(...ae.slice(de.start,de.start+de.deleteCount)),le.push(...de.toInsert);return{removed:ie,added:le}}function o(ae,ce,se){if(se===0)return[];const K=ae.slice(0,se).sort(ce);return i(ae,ce,K,se,ae.length),K}function n(ae,ce,se,K,ie){return se===0?Promise.resolve([]):new Promise((le,de)=>{(async()=>{const Ae=ae.length,me=ae.slice(0,se).sort(ce);for(let Pe=se,Me=Math.min(se+K,Ae);Pe<Ae;Pe=Me,Me=Math.min(Me+K,Ae)){if(Pe>se&&await new Promise(je=>setTimeout(je)),ie&&ie.isCancellationRequested)throw new u.$5;i(ae,ce,me,Pe,Me)}return me})().then(le,de)})}function i(ae,ce,se,K,ie){for(const le=se.length;K<ie;K++){const de=ae[K];if(ce(de,se[le-1])<0){se.pop();const Ae=(0,O.$kb)(se,me=>ce(de,me)<0);se.splice(Ae,0,de)}}}function r(ae){return ae.filter(ce=>!!ce)}function s(ae){let ce=0;for(let se=0;se<ae.length;se++)ae[se]&&(ae[ce]=ae[se],ce+=1);ae.length=ce}function t(ae,ce,se){ae.splice(se,0,ae.splice(ce,1)[0])}function f(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,ce=se=>se){const se=new Set;return ae.filter(K=>{const ie=ce(K);return se.has(ie)?!1:(se.add(ie),!0)})}function c(ae){const ce=new Set;return se=>{const K=ae(se);return ce.has(K)?!1:(ce.add(K),!0)}}function h(ae,ce){return ae.length>0?ae[0]:ce}function g(ae,ce){return ae.length>0?ae[ae.length-1]:ce}function D(ae,ce,se=(K,ie)=>K===ie){let K=0;for(let ie=0,le=Math.min(ae.length,ce.length);ie<le&&se(ae[ie],ce[ie]);ie++)K++;return K}function w(ae){return[].concat(...ae)}function k(ae,ce){let se=typeof ce=="number"?ae:0;typeof ce=="number"?se=ae:(se=0,ce=ae);const K=[];if(se<=ce)for(let ie=se;ie<ce;ie++)K.push(ie);else for(let ie=se;ie>ce;ie--)K.push(ie);return K}function y(ae,ce,se){return ae.reduce((K,ie)=>(K[ce(ie)]=se?se(ie):ie,K),Object.create(null))}function C(ae,ce){return ae.push(ce),()=>I(ae,ce)}function I(ae,ce){const se=ae.indexOf(ce);if(se>-1)return ae.splice(se,1),ce}function z(ae,ce,se){const K=ae.slice(0,ce),ie=ae.slice(ce);return K.concat(se,ie)}function j(ae,ce){let se;if(typeof ce=="number"){let K=ce;se=()=>{const ie=Math.sin(K++)*179426549;return ie-Math.floor(ie)}}else se=Math.random;for(let K=ae.length-1;K>0;K-=1){const ie=Math.floor(se()*(K+1)),le=ae[K];ae[K]=ae[ie],ae[ie]=le}}function F(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.unshift(ce))}function N(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.push(ce))}function T(ae,ce){for(const se of ce)ae.push(se)}function B(ae,ce){return Array.isArray(ae)?ae.map(ce):ce(ae)}function H(ae){return Array.isArray(ae)?ae:[ae]}function Z(ae){return ae[Math.floor(Math.random()*ae.length)]}function ee(ae,ce,se){const K=Y(ae,ce),ie=ae.length,le=se.length;ae.length=ie+le;for(let de=ie-1;de>=K;de--)ae[de+le]=ae[de];for(let de=0;de<le;de++)ae[de+K]=se[de]}function J(ae,ce,se,K){const ie=Y(ae,ce);let le=ae.splice(ie,se);return le===void 0&&(le=[]),ee(ae,ie,K),le}function Y(ae,ce){return ce<0?Math.max(ce+ae.length,0):Math.min(ce,ae.length)}var re;(function(ae){function ce(le){return le<0}ae.isLessThan=ce;function se(le){return le<=0}ae.isLessThanOrEqual=se;function K(le){return le>0}ae.isGreaterThan=K;function ie(le){return le===0}ae.isNeitherLessOrGreaterThan=ie,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function te(ae,ce){return(se,K)=>ce(ae(se),ae(K))}function pe(...ae){return(ce,se)=>{for(const K of ae){const ie=K(ce,se);if(!re.isNeitherLessOrGreaterThan(ie))return ie}return re.neitherLessOrGreaterThan}}const Ce=(ae,ce)=>ae-ce;e.$9b=Ce;const x=(ae,ce)=>(0,e.$9b)(ae?1:0,ce?1:0);e.$0b=x;function U(ae){return(ce,se)=>-ae(ce,se)}class ne{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let se=this.c;for(;se<this.g.length&&ce(this.g[se]);)se++;const K=se===this.c?null:this.g.slice(this.c,se);return this.c=se,K}takeFromEndWhile(ce){let se=this.d;for(;se>=0&&ce(this.g[se]);)se--;const K=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const se=this.g.slice(this.c,this.c+ce);return this.c+=ce,se}}e.$_b=ne;class be{static{this.empty=new be(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(se=>(ce(se),!0))}toArray(){const ce=[];return this.iterate(se=>(ce.push(se),!0)),ce}filter(ce){return new be(se=>this.iterate(K=>ce(K)?se(K):!0))}map(ce){return new be(se=>this.iterate(K=>se(ce(K))))}some(ce){let se=!1;return this.iterate(K=>(se=ce(K),!se)),se}findFirst(ce){let se;return this.iterate(K=>ce(K)?(se=K,!1):!0),se}findLast(ce){let se;return this.iterate(K=>(ce(K)&&(se=K),!0)),se}findLastMaxBy(ce){let se,K=!0;return this.iterate(ie=>((K||re.isGreaterThan(ce(ie,se)))&&(K=!1,se=ie),!0)),se}}e.$ac=be;class De{constructor(ce){this.c=ce}static createSortPermutation(ce,se){const K=Array.from(ce.keys()).sort((ie,le)=>se(ce[ie],ce[le]));return new De(K)}apply(ce){return ce.map((se,K)=>ce[this.c[K]])}inverse(){const ce=this.c.slice();for(let se=0;se<this.c.length;se++)ce[this.c[se]]=se;return new De(ce)}}e.$bc=De}),define(ke[62],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$cd=L,e.$dd=R,e.$ed=M,e.$fd=b,e.$gd=p;function O(E,A){if(!E)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(E,A="Unreachable"){throw new Error(A)}function R(E){if(!E)throw new u.$cb("Assertion Failed")}function M(E){E||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function p(E,A){let P=0;for(;P<E.length-1;){const $=E[P],S=E[P+1];if(!A($,S))return!1;P++}return!0}}),define(ke[74],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(O,L){const R=this;let M=!1,b;return function(){if(M)return b;if(M=!0,L)try{b=O.apply(R,arguments)}finally{L()}else b=O.apply(R,arguments);return b}}}),define(ke[124],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=void 0;class u{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZO=u,e.$1O=new u("id#")}),define(ke[45],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(O){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=L;const R=Object.freeze([]);function M(){return R}O.empty=M;function*b(t){yield t}O.single=b;function p(t){return L(t)?t:b(t)}O.wrap=p;function E(t){return t||R}O.from=E;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}O.reverse=A;function P(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=P;function $(t){return t[Symbol.iterator]().next().value}O.first=$;function S(t,f){for(const d of t)if(f(d))return!0;return!1}O.some=S;function v(t,f){for(const d of t)if(f(d))return d}O.find=v;function*a(t,f){for(const d of t)f(d)&&(yield d)}O.filter=a;function*m(t,f){let d=0;for(const l of t)yield f(l,d++)}O.map=m;function*o(...t){for(const f of t)yield*f}O.concat=o;function n(t,f,d){let l=d;for(const c of t)l=f(l,c);return l}O.reduce=n;function*i(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}O.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const l=t[Symbol.iterator]();for(let c=0;c<f;c++){const h=l.next();if(h.done)return[d,O.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}O.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}O.asyncToArray=s})(u||(e.Iterable=u={}))}),define(ke[164],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=M,e.$zn=P,e.$An=$,e.$Bn=S,e.$Cn=v,e.$Dn=a,e.$En=m,e.$Fn=o,e.$Gn=n,e.$Hn=i,e.$In=r,e.$Jn=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,f=!1){let d=0;const l=t.length;let c="",h=0,g=16,D=0;function w(F){let N=0,T=0;for(;N<F;){const B=t.charCodeAt(d);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;d++,N++}return N<F&&(T=-1),T}function k(F){d=F,c="",h=0,g=16,D=0}function y(){const F=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&E(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&E(t.charCodeAt(d)))for(d++;d<t.length&&E(t.charCodeAt(d));)d++;else return D=3,t.substring(F,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&E(t.charCodeAt(d))){for(d++;d<t.length&&E(t.charCodeAt(d));)d++;N=d}else D=3;return t.substring(F,N)}function C(){let F="",N=d;for(;;){if(d>=l){F+=t.substring(N,d),D=2;break}const T=t.charCodeAt(d);if(T===34){F+=t.substring(N,d),d++;break}if(T===92){if(F+=t.substring(N,d),d++,d>=l){D=2;break}switch(t.charCodeAt(d++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=w(4);H>=0?F+=String.fromCharCode(H):D=4;break}default:D=5}N=d;continue}if(T>=0&&T<=31)if(p(T)){F+=t.substring(N,d),D=2;break}else D=6;d++}return F}function I(){if(c="",D=0,h=d,d>=l)return h=l,g=17;let F=t.charCodeAt(d);if(b(F)){do d++,c+=String.fromCharCode(F),F=t.charCodeAt(d);while(b(F));return g=15}if(p(F))return d++,c+=String.fromCharCode(F),F===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),g=14;switch(F){case 123:return d++,g=1;case 125:return d++,g=2;case 91:return d++,g=3;case 93:return d++,g=4;case 58:return d++,g=6;case 44:return d++,g=5;case 34:return d++,c=C(),g=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!p(t.charCodeAt(d));)d++;return c=t.substring(N,d),g=12}if(t.charCodeAt(d+1)===42){d+=2;const T=l-1;let B=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,D=1),c=t.substring(N,d),g=13}return c+=String.fromCharCode(F),d++,g=16}case 45:if(c+=String.fromCharCode(F),d++,d===l||!E(t.charCodeAt(d)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=y(),g=11;default:for(;d<l&&z(F);)d++,F=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return c+=String.fromCharCode(F),d++,g=16}}function z(F){if(b(F)||p(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let F;do F=I();while(F>=12&&F<=15);return F}return{setPosition:k,getPosition:()=>d,scan:f?j:I,getToken:()=>g,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,f){const d=[],l=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(w,k,y,C){h.value=w,h.offset=k,h.length=y,h.type=C,h.colonOffset=void 0,c=h}try{i(t,{onObjectBegin:(w,k)=>{if(f<=w)throw l;c=void 0,g=f>w,d.push("")},onObjectProperty:(w,k,y)=>{if(f<k||(D(w,k,y,"property"),d[d.length-1]=w,f<=k+y))throw l},onObjectEnd:(w,k)=>{if(f<=w)throw l;c=void 0,d.pop()},onArrayBegin:(w,k)=>{if(f<=w)throw l;c=void 0,d.push(0)},onArrayEnd:(w,k)=>{if(f<=w)throw l;c=void 0,d.pop()},onLiteralValue:(w,k,y)=>{if(f<k||(D(w,k,y,s(w)),f<=k+y))throw l},onSeparator:(w,k,y)=>{if(f<=k)throw l;if(w===":"&&c&&c.type==="property")c.colonOffset=k,g=!1,c=void 0;else if(w===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(g=!0,d[d.length-1]=""),c=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:c,isAtPropertyKey:g,matches:w=>{let k=0;for(let y=0;k<w.length&&y<d.length;y++)if(w[k]===d[y]||w[k]==="*")k++;else if(w[k]!=="**")return!1;return k===w.length}}}function $(t,f=[],d=R.DEFAULT){let l=null,c=[];const h=[];function g(w){Array.isArray(c)?c.push(w):l!==null&&(c[l]=w)}return i(t,{onObjectBegin:()=>{const w={};g(w),h.push(c),c=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const w=[];g(w),h.push(c),c=w,l=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:g,onError:(w,k,y)=>{f.push({error:w,offset:k,length:y})}},d),c[0]}function S(t,f=[],d=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}i(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,k,y)=>{l=h({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:k,length:y,parent:l})},onObjectEnd:(w,k)=>{l.length=w+k-l.offset,l=l.parent,c(w+k)},onArrayBegin:(w,k)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,k)=>{l.length=w+k-l.offset,l=l.parent,c(w+k)},onLiteralValue:(w,k,y)=>{h({type:s(w),offset:k,length:y,parent:l,value:w}),c(k+y)},onSeparator:(w,k,y)=>{l.type==="property"&&(w===":"?l.colonOffset=k:w===","&&c(k))},onError:(w,k,y)=>{f.push({error:w,offset:k,length:y})}},d);const D=l.children[0];return D&&delete D.parent,D}function v(t,f){if(!t)return;let d=t;for(const l of f)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],c=!0;break}if(!c)return}else{const c=l;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}function a(t){if(!t.parent||!t.parent.children)return[];const f=a(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(f[d.children[0].value]=m(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function n(t,f,d=!1){if(o(t,f,d)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=f;c++){const h=n(l[c],f,d);if(h)return h}return t}}function i(t,f,d=R.DEFAULT){const l=M(t,!1);function c(te){return te?()=>te(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(te){return te?pe=>te(pe,l.getTokenOffset(),l.getTokenLength()):()=>!0}const g=c(f.onObjectBegin),D=h(f.onObjectProperty),w=c(f.onObjectEnd),k=c(f.onArrayBegin),y=c(f.onArrayEnd),C=h(f.onLiteralValue),I=h(f.onSeparator),z=c(f.onComment),j=h(f.onError),F=d&&d.disallowComments,N=d&&d.allowTrailingComma;function T(){for(;;){const te=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:F?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,pe=[],Ce=[]){if(j(te),pe.length+Ce.length>0){let x=l.getToken();for(;x!==17;){if(pe.indexOf(x)!==-1){T();break}else if(Ce.indexOf(x)!==-1)break;x=T()}}}function H(te){const pe=l.getTokenValue();return te?C(pe):D(pe),T(),!0}function Z(){switch(l.getToken()){case 11:{let te=0;try{te=JSON.parse(l.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}C(te);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return T(),!0}function ee(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(I(":"),T(),re()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function J(){g(),T();let te=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(te||B(4,[],[]),I(","),T(),l.getToken()===2&&N)break}else te&&B(6,[],[]);ee()||B(4,[],[2,5]),te=!0}return w(),l.getToken()!==2?B(7,[2],[]):T(),!0}function Y(){k(),T();let te=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(te||B(4,[],[]),I(","),T(),l.getToken()===4&&N)break}else te&&B(6,[],[]);re()||B(4,[],[4,5]),te=!0}return y(),l.getToken()!==4?B(8,[4],[]):T(),!0}function re(){switch(l.getToken()){case 3:return Y();case 1:return J();case 10:return H(!0);default:return Z()}}return T(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):re()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const d=M(t),l=[];let c,h=0,g;do switch(g=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==g&&l.push(t.substring(h,g)),f!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,f)),h=d.getPosition();break}while(c!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(R){this.element=R,this.next=u.Undefined,this.prev=u.Undefined}}class O{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let R=this.a;for(;R!==u.Undefined;){const M=R.next;R.prev=u.Undefined,R.next=u.Undefined,R=M}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const b=new u(R);if(this.a===u.Undefined)this.a=b,this.b=b;else if(M){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(b))}}shift(){if(this.a!==u.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==u.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==u.Undefined&&R.next!==u.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===u.Undefined&&R.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):R.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):R.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==u.Undefined;)yield R.element,R=R.next}}e.$5c=O}),define(ke[27],Ee([1,0]),function(he,e){"use strict";var u,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=b,e.$Ic=n;function R(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function M(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function b(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class p{constructor(r,s){this.uri=r,this.value=s}}function E(i){return Array.isArray(i)}class A{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(E(r)){this.d=new Map,this.e=s??A.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new p(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A;class P{constructor(r,s){this[O]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class S{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=S;class v extends S{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class a{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=a;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class o{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,45]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=P,e.$Mc=$,e.$Nc=a,e.$Oc=m,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=w;const b=!1;let p=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let I=this.b.get(C);return I||(I={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,I)),I}trackDisposable(C){const I=this.c(C);I.source||(I.source=new Error().stack)}setParent(C,I){const z=this.c(C);z.parent=I}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,I){const z=I.get(C);if(z)return z;const j=C.parent?this.f(this.c(C.parent),I):C;return I.set(C,j),j}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,C).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(C=10,I){let z;if(I)z=I;else{const B=new Map,H=[...this.b.values()].filter(ee=>ee.source!==null&&!this.f(ee,B).isSingleton);if(H.length===0)return;const Z=new Set(H.map(ee=>ee.value));if(z=H.filter(ee=>!(ee.parent&&Z.has(ee.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function j(B){function H(ee,J){for(;ee.length>0&&J.some(Y=>typeof Y=="string"?Y===ee[0]:ee[0].match(Y));)ee.shift()}const Z=B.source.split(`
`).map(ee=>ee.trim().replace("at ","")).filter(ee=>ee!=="");return H(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const F=new L.$Hc;for(const B of z){const H=j(B);for(let Z=0;Z<=H.length;Z++)F.add(H.slice(0,Z).join(`
`),B)}z.sort((0,u.$7b)(B=>B.idx,u.$9b));let N="",T=0;for(const B of z.slice(0,C)){T++;const H=j(B),Z=[];for(let ee=0;ee<H.length;ee++){let J=H[ee];J=`(shared with ${F.get(H.slice(0,ee+1).join(`
`)).size}/${z.length} leaks) at ${J}`;const re=F.get(H.slice(0,ee).join(`
`)),te=(0,O.$K)([...re].map(pe=>j(pe)[ee]),pe=>pe);delete te[H[ee]];for(const[pe,Ce]of Object.entries(te))Z.unshift(`    - stacktraces of ${Ce.length} other leaks continue with ${pe}`);Z.unshift(J)}N+=`


==================== Leaking disposable ${T}/${z.length}: ${B.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return z.length>C&&(N+=`


... and ${z.length-C} more leaking disposables

`),{leaks:z,details:N}}}e.$Jc=E;function A(y){p=y}if(b){const y="__is_disposable_tracked__";A(new class{trackDisposable(C){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[y]||console.log(I)},3e3)}setParent(C,I){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsSingleton(C){}})}function P(y){return p?.trackDisposable(y),y}function $(y){p?.markAsDisposed(y)}function S(y,C){p?.setParent(y,C)}function v(y,C){if(p)for(const I of y)p.setParent(I,C)}function a(y){return p?.markAsSingleton(y),y}function m(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function o(y){if(M.Iterable.is(y)){const C=[];for(const I of y)if(I)try{I.dispose()}catch(z){C.push(z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const C of y)m(C)&&C.dispose();return[]}function i(...y){const C=r(()=>o(y));return v(y,C),C}function r(y){const C=P({dispose:(0,R.$db)(()=>{$(C),y()})});return C}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return S(C,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),S(C,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,P(this),S(this.q,this)}dispose(){$(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&S(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&S(C,null),C}}e.$Vc=f;class d{constructor(C){this.a=new f,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let I=C;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}e.$Yc=c;class h{constructor(){this.a=new Map}acquire(C,...I){let z=this.a.get(C);z||(z={counter:0,object:this.b(C,...I)},this.a.set(C,z));const{object:j}=z,F=(0,R.$db)(()=>{--z.counter===0&&(this.c(C,z.object),this.a.delete(C))});return z.counter++,{object:j,dispose:F}}}e.$Zc=h;class g{constructor(C){this.a=C}async acquire(C,...I){const z=this.a.acquire(C,...I);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(j){throw z.dispose(),j}}}e.$1c=g;class D{constructor(C){this.object=C}dispose(){}}e.$2c=D;function w(y){const C=new s;try{y(C)}finally{C.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,I,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(C)?.dispose(),this.a.set(C,I)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),function(he,e){typeof define=="function"&&define.amd?define(ke[165],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ae,ce){for(var se=0;se<ce.length;se++){var K=ce[se];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ae,K.key,K)}}function u(ae,ce,se){return ce&&e(ae.prototype,ce),se&&e(ae,se),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function O(ae,ce){if(ae){if(typeof ae=="string")return L(ae,ce);var se=Object.prototype.toString.call(ae).slice(8,-1);if(se==="Object"&&ae.constructor&&(se=ae.constructor.name),se==="Map"||se==="Set")return Array.from(ae);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return L(ae,ce)}}function L(ae,ce){(ce==null||ce>ae.length)&&(ce=ae.length);for(var se=0,K=new Array(ce);se<ce;se++)K[se]=ae[se];return K}function R(ae,ce){var se=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(se)return(se=se.call(ae)).next.bind(se);if(Array.isArray(ae)||(se=O(ae))||ce&&ae&&typeof ae.length=="number"){se&&(ae=se);var K=0;return function(){return K>=ae.length?{done:!0}:{done:!1,value:ae[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=M();function b(ae){he.defaults=ae}var p=/[&<>"']/,E=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ce){return $[ce]};function v(ae,ce){if(ce){if(p.test(ae))return ae.replace(E,S)}else if(A.test(ae))return ae.replace(P,S);return ae}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ae){return ae.replace(a,function(ce,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ae,ce){ae=typeof ae=="string"?ae:ae.source,ce=ce||"";var se={replace:function(ie,le){return le=le.source||le,le=le.replace(o,"$1"),ae=ae.replace(ie,le),se},getRegex:function(){return new RegExp(ae,ce)}};return se}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ae,ce,se){if(ae){var K;try{K=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ce&&!r.test(se)&&(se=c(ce,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ae,ce){t[" "+ae]||(f.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=w(ae,"/",!0)),ae=t[" "+ae];var se=ae.indexOf(":")===-1;return ce.substring(0,2)==="//"?se?ce:ae.replace(d,"$1")+ce:ce.charAt(0)==="/"?se?ce:ae.replace(l,"$1")+ce:ae+ce}var h={exec:function(){}};function g(ae){for(var ce=1,se,K;ce<arguments.length;ce++){se=arguments[ce];for(K in se)Object.prototype.hasOwnProperty.call(se,K)&&(ae[K]=se[K])}return ae}function D(ae,ce){var se=ae.replace(/\|/g,function(le,de,Ae){for(var me=!1,Pe=de;--Pe>=0&&Ae[Pe]==="\\";)me=!me;return me?"|":" |"}),K=se.split(/ \|/),ie=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ce)K.splice(ce);else for(;K.length<ce;)K.push("");for(;ie<K.length;ie++)K[ie]=K[ie].trim().replace(/\\\|/g,"|");return K}function w(ae,ce,se){var K=ae.length;if(K===0)return"";for(var ie=0;ie<K;){var le=ae.charAt(K-ie-1);if(le===ce&&!se)ie++;else if(le!==ce&&se)ie++;else break}return ae.slice(0,K-ie)}function k(ae,ce){if(ae.indexOf(ce[1])===-1)return-1;for(var se=ae.length,K=0,ie=0;ie<se;ie++)if(ae[ie]==="\\")ie++;else if(ae[ie]===ce[0])K++;else if(ae[ie]===ce[1]&&(K--,K<0))return ie;return-1}function y(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ae,ce){if(ce<1)return"";for(var se="";ce>1;)ce&1&&(se+=ae),ce>>=1,ae+=ae;return se+ae}function I(ae,ce,se,K){var ie=ce.href,le=ce.title?v(ce.title):null,de=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){K.state.inLink=!0;var Ae={type:"link",raw:se,href:ie,title:le,text:de,tokens:K.inlineTokens(de)};return K.state.inLink=!1,Ae}return{type:"image",raw:se,href:ie,title:le,text:v(de)}}function z(ae,ce){var se=ae.match(/^(\s+)(?:```)/);if(se===null)return ce;var K=se[1];return ce.split(`
`).map(function(ie){var le=ie.match(/^\s+/);if(le===null)return ie;var de=le[0];return de.length>=K.length?ie.slice(K.length):ie}).join(`
`)}var j=function(){function ae(se){this.options=se||he.defaults}var ce=ae.prototype;return ce.space=function(K){var ie=this.rules.block.newline.exec(K);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},ce.code=function(K){var ie=this.rules.block.code.exec(K);if(ie){var le=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?le:w(le,`
`)}}},ce.fences=function(K){var ie=this.rules.block.fences.exec(K);if(ie){var le=ie[0],de=z(le,ie[3]||"");return{type:"code",raw:le,lang:ie[2]?ie[2].trim():ie[2],text:de}}},ce.heading=function(K){var ie=this.rules.block.heading.exec(K);if(ie){var le=ie[2].trim();if(/#$/.test(le)){var de=w(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:le,tokens:this.lexer.inline(le)}}},ce.hr=function(K){var ie=this.rules.block.hr.exec(K);if(ie)return{type:"hr",raw:ie[0]}},ce.blockquote=function(K){var ie=this.rules.block.blockquote.exec(K);if(ie){var le=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ce.list=function(K){var ie=this.rules.block.list.exec(K);if(ie){var le,de,Ae,me,Pe,Me,je,q,W,X,Q,fe,we=ie[1].trim(),Fe=we.length>1,Ve={type:"list",raw:"",ordered:Fe,start:Fe?+we.slice(0,-1):"",loose:!1,items:[]};we=Fe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Fe?we:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(fe=!1,!(!(ie=Ze.exec(K))||this.rules.block.hr.test(K)));){if(le=ie[0],K=K.substring(le.length),q=ie[2].split(`
`,1)[0],W=K.split(`
`,1)[0],this.options.pedantic?(me=2,Q=q.trimLeft()):(me=ie[2].search(/[^ ]/),me=me>4?1:me,Q=q.slice(me),me+=ie[1].length),Me=!1,!q&&/^ *$/.test(W)&&(le+=W+`
`,K=K.substring(W.length+1),fe=!0),!fe)for(var tt=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");K&&(X=K.split(`
`,1)[0],q=X,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(q)||ot.test(q)||tt.test(q)||st.test(K)));){if(q.search(/[^ ]/)>=me||!q.trim())Q+=`
`+q.slice(me);else if(!Me)Q+=`
`+q;else break;!Me&&!q.trim()&&(Me=!0),le+=X+`
`,K=K.substring(X.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test(le)&&(je=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Q),de&&(Ae=de[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Ae,loose:!1,text:Q}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=Q.trimRight(),Ve.raw=Ve.raw.trimRight();var Se=Ve.items.length;for(Pe=0;Pe<Se;Pe++){this.lexer.state.top=!1,Ve.items[Pe].tokens=this.lexer.blockTokens(Ve.items[Pe].text,[]);var Be=Ve.items[Pe].tokens.filter(function(Le){return Le.type==="space"}),Ge=Be.every(function(Le){for(var Qe=Le.raw.split(""),oe=0,ue=R(Qe),Ie;!(Ie=ue()).done;){var Ke=Ie.value;if(Ke===`
`&&(oe+=1),oe>1)return!0}return!1});!Ve.loose&&Be.length&&Ge&&(Ve.loose=!0,Ve.items[Pe].loose=!0)}return Ve}},ce.html=function(K){var ie=this.rules.block.html.exec(K);if(ie){var le={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},ce.def=function(K){var ie=this.rules.block.def.exec(K);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var le=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:ie[0],href:ie[2],title:ie[3]}}},ce.table=function(K){var ie=this.rules.block.table.exec(K);if(ie){var le={type:"table",header:D(ie[1]).map(function(je){return{text:je}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ie[0];var de=le.align.length,Ae,me,Pe,Me;for(Ae=0;Ae<de;Ae++)/^ *-+: *$/.test(le.align[Ae])?le.align[Ae]="right":/^ *:-+: *$/.test(le.align[Ae])?le.align[Ae]="center":/^ *:-+ *$/.test(le.align[Ae])?le.align[Ae]="left":le.align[Ae]=null;for(de=le.rows.length,Ae=0;Ae<de;Ae++)le.rows[Ae]=D(le.rows[Ae],le.header.length).map(function(je){return{text:je}});for(de=le.header.length,me=0;me<de;me++)le.header[me].tokens=this.lexer.inline(le.header[me].text);for(de=le.rows.length,me=0;me<de;me++)for(Me=le.rows[me],Pe=0;Pe<Me.length;Pe++)Me[Pe].tokens=this.lexer.inline(Me[Pe].text);return le}}},ce.lheading=function(K){var ie=this.rules.block.lheading.exec(K);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},ce.paragraph=function(K){var ie=this.rules.block.paragraph.exec(K);if(ie){var le=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:le,tokens:this.lexer.inline(le)}}},ce.text=function(K){var ie=this.rules.block.text.exec(K);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},ce.escape=function(K){var ie=this.rules.inline.escape.exec(K);if(ie)return{type:"escape",raw:ie[0],text:v(ie[1])}},ce.tag=function(K){var ie=this.rules.inline.tag.exec(K);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]}},ce.link=function(K){var ie=this.rules.inline.link.exec(K);if(ie){var le=ie[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=w(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Ae=k(ie[2],"()");if(Ae>-1){var me=ie[0].indexOf("!")===0?5:4,Pe=me+ie[1].length+Ae;ie[2]=ie[2].substring(0,Ae),ie[0]=ie[0].substring(0,Pe).trim(),ie[3]=""}}var Me=ie[2],je="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);q&&(Me=q[1],je=q[3])}else je=ie[3]?ie[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(le)?Me=Me.slice(1):Me=Me.slice(1,-1)),I(ie,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},ce.reflink=function(K,ie){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=ie[de.toLowerCase()],!de||!de.href){var Ae=le[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return I(le,de,le[0],this.lexer)}},ce.emStrong=function(K,ie,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(K);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=de[1]||de[2]||"";if(!Ae||Ae&&(le===""||this.rules.inline.punctuation.exec(le))){var me=de[0].length-1,Pe,Me,je=me,q=0,W=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,ie=ie.slice(-1*K.length+me);(de=W.exec(ie))!=null;)if(Pe=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Pe){if(Me=Pe.length,de[3]||de[4]){je+=Me;continue}else if((de[5]||de[6])&&me%3&&!((me+Me)%3)){q+=Me;continue}if(je-=Me,!(je>0)){if(Me=Math.min(Me,Me+je+q),Math.min(me,Me)%2){var X=K.slice(1,me+de.index+Me);return{type:"em",raw:K.slice(0,me+de.index+Me+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Q=K.slice(2,me+de.index+Me-1);return{type:"strong",raw:K.slice(0,me+de.index+Me+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},ce.codespan=function(K){var ie=this.rules.inline.code.exec(K);if(ie){var le=ie[2].replace(/\n/g," "),de=/[^ ]/.test(le),Ae=/^ /.test(le)&&/ $/.test(le);return de&&Ae&&(le=le.substring(1,le.length-1)),le=v(le,!0),{type:"codespan",raw:ie[0],text:le}}},ce.br=function(K){var ie=this.rules.inline.br.exec(K);if(ie)return{type:"br",raw:ie[0]}},ce.del=function(K){var ie=this.rules.inline.del.exec(K);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},ce.autolink=function(K,ie){var le=this.rules.inline.autolink.exec(K);if(le){var de,Ae;return le[2]==="@"?(de=v(this.options.mangle?ie(le[1]):le[1]),Ae="mailto:"+de):(de=v(le[1]),Ae=de),{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ce.url=function(K,ie){var le;if(le=this.rules.inline.url.exec(K)){var de,Ae;if(le[2]==="@")de=v(this.options.mangle?ie(le[0]):le[0]),Ae="mailto:"+de;else{var me;do me=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(me!==le[0]);de=v(le[0]),le[1]==="www."?Ae="http://"+de:Ae=de}return{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ce.inlineText=function(K,ie){var le=this.rules.inline.text.exec(K);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):v(le[0]):le[0]:de=v(this.options.smartypants?ie(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},ae}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=n(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=n(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=n(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=n(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=n(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=g({},F),F.gfm=g({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=n(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=g({},F.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=n(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=n(F._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=n(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=n(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=n(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=n(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=n(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=n(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=n(N.reflink).replace("label",N._label).replace("ref",F._label).getRegex(),N.nolink=n(N.nolink).replace("ref",F._label).getRegex(),N.reflinkSearch=n(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=g({},N),N.pedantic=g({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=g({},N.normal,{escape:n(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=n(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=g({},N.gfm,{br:n(N.br).replace("{2,}","*").getRegex(),text:n(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ae){var ce="",se,K,ie=ae.length;for(se=0;se<ie;se++)K=ae.charCodeAt(se),Math.random()>.5&&(K="x"+K.toString(16)),ce+="&#"+K+";";return ce}var H=function(){function ae(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||he.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:F.normal,inline:N.normal};this.options.pedantic?(K.block=F.pedantic,K.inline=N.pedantic):this.options.gfm&&(K.block=F.gfm,this.options.breaks?K.inline=N.breaks:K.inline=N.gfm),this.tokenizer.rules=K}ae.lex=function(K,ie){var le=new ae(ie);return le.lex(K)},ae.lexInline=function(K,ie){var le=new ae(ie);return le.inlineTokens(K)};var ce=ae.prototype;return ce.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},ce.blockTokens=function(K,ie){var le=this;ie===void 0&&(ie=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(je,q,W){return q+"    ".repeat(W.length)});for(var de,Ae,me,Pe;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(de=je.call({lexer:le},K,ie))?(K=K.substring(de.raw.length),ie.push(de),!0):!1}))){if(de=this.tokenizer.space(K)){K=K.substring(de.raw.length),de.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(de);continue}if(de=this.tokenizer.code(K)){K=K.substring(de.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(de);continue}if(de=this.tokenizer.fences(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.heading(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.hr(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.blockquote(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.list(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.html(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.def(K)){K=K.substring(de.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.lheading(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(me=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,q=K.slice(1),W=void 0;le.options.extensions.startBlock.forEach(function(X){W=X.call({lexer:this},q),typeof W=="number"&&W>=0&&(je=Math.min(je,W))}),je<1/0&&je>=0&&(me=K.substring(0,je+1))}(),this.state.top&&(de=this.tokenizer.paragraph(me))){Ae=ie[ie.length-1],Pe&&Ae.type==="paragraph"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(de),Pe=me.length!==K.length,K=K.substring(de.raw.length);continue}if(de=this.tokenizer.text(K)){K=K.substring(de.raw.length),Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(de);continue}if(K){var Me="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,ie},ce.inline=function(K,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:K,tokens:ie}),ie},ce.inlineTokens=function(K,ie){var le=this;ie===void 0&&(ie=[]);var de,Ae,me,Pe=K,Me,je,q;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)W.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Me.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(je||(q=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(de=Q.call({lexer:le},K,ie))?(K=K.substring(de.raw.length),ie.push(de),!0):!1}))){if(de=this.tokenizer.escape(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.tag(K)){K=K.substring(de.raw.length),Ae=ie[ie.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):ie.push(de);continue}if(de=this.tokenizer.link(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(de.raw.length),Ae=ie[ie.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):ie.push(de);continue}if(de=this.tokenizer.emStrong(K,Pe,q)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.codespan(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.br(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.del(K)){K=K.substring(de.raw.length),ie.push(de);continue}if(de=this.tokenizer.autolink(K,B)){K=K.substring(de.raw.length),ie.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(K,B))){K=K.substring(de.raw.length),ie.push(de);continue}if(me=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,fe=K.slice(1),we=void 0;le.options.extensions.startInline.forEach(function(Fe){we=Fe.call({lexer:this},fe),typeof we=="number"&&we>=0&&(Q=Math.min(Q,we))}),Q<1/0&&Q>=0&&(me=K.substring(0,Q+1))}(),de=this.tokenizer.inlineText(me,T)){K=K.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(q=de.raw.slice(-1)),je=!0,Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):ie.push(de);continue}if(K){var X="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ie},u(ae,null,[{key:"rules",get:function(){return{block:F,inline:N}}}]),ae}(),Z=function(){function ae(se){this.options=se||he.defaults}var ce=ae.prototype;return ce.code=function(K,ie,le){var de=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(K,de);Ae!=null&&Ae!==K&&(le=!0,K=Ae)}return K=K.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+v(de,!0)+'">'+(le?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:v(K,!0))+`</code></pre>
`},ce.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ce.html=function(K){return K},ce.heading=function(K,ie,le,de){if(this.options.headerIds){var Ae=this.options.headerPrefix+de.slug(le);return"<h"+ie+' id="'+Ae+'">'+K+"</h"+ie+`>
`}return"<h"+ie+">"+K+"</h"+ie+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(K,ie,le){var de=ie?"ol":"ul",Ae=ie&&le!==1?' start="'+le+'"':"";return"<"+de+Ae+`>
`+K+"</"+de+`>
`},ce.listitem=function(K){return"<li>"+K+`</li>
`},ce.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(K){return"<p>"+K+`</p>
`},ce.table=function(K,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ie+`</table>
`},ce.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ce.tablecell=function(K,ie){var le=ie.header?"th":"td",de=ie.align?"<"+le+' align="'+ie.align+'">':"<"+le+">";return de+K+("</"+le+`>
`)},ce.strong=function(K){return"<strong>"+K+"</strong>"},ce.em=function(K){return"<em>"+K+"</em>"},ce.codespan=function(K){return"<code>"+K+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(K){return"<del>"+K+"</del>"},ce.link=function(K,ie,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<a href="'+v(K)+'"';return ie&&(de+=' title="'+ie+'"'),de+=">"+le+"</a>",de},ce.image=function(K,ie,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<img src="'+K+'" alt="'+le+'"';return ie&&(de+=' title="'+ie+'"'),de+=this.options.xhtml?"/>":">",de},ce.text=function(K){return K},ae}(),ee=function(){function ae(){}var ce=ae.prototype;return ce.strong=function(K){return K},ce.em=function(K){return K},ce.codespan=function(K){return K},ce.del=function(K){return K},ce.html=function(K){return K},ce.text=function(K){return K},ce.link=function(K,ie,le){return""+le},ce.image=function(K,ie,le){return""+le},ce.br=function(){return""},ae}(),J=function(){function ae(){this.seen={}}var ce=ae.prototype;return ce.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(K,ie){var le=K,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[K];do de++,le=K+"-"+de;while(this.seen.hasOwnProperty(le))}return ie||(this.seen[K]=de,this.seen[le]=0),le},ce.slug=function(K,ie){ie===void 0&&(ie={});var le=this.serialize(K);return this.getNextSafeSlug(le,ie.dryrun)},ae}(),Y=function(){function ae(se){this.options=se||he.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new J}ae.parse=function(K,ie){var le=new ae(ie);return le.parse(K)},ae.parseInline=function(K,ie){var le=new ae(ie);return le.parseInline(K)};var ce=ae.prototype;return ce.parse=function(K,ie){ie===void 0&&(ie=!0);var le="",de,Ae,me,Pe,Me,je,q,W,X,Q,fe,we,Fe,Ve,Ze,tt,st,at,ot,Se=K.length;for(de=0;de<Se;de++){if(Q=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(ot=this.options.extensions.renderers[Q.type].call({parser:this},Q),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){le+=ot||"";continue}switch(Q.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,m(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(W="",q="",Pe=Q.header.length,Ae=0;Ae<Pe;Ae++)q+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for(W+=this.renderer.tablerow(q),X="",Pe=Q.rows.length,Ae=0;Ae<Pe;Ae++){for(je=Q.rows[Ae],q="",Me=je.length,me=0;me<Me;me++)q+=this.renderer.tablecell(this.parseInline(je[me].tokens),{header:!1,align:Q.align[me]});X+=this.renderer.tablerow(q)}le+=this.renderer.table(W,X);continue}case"blockquote":{X=this.parse(Q.tokens),le+=this.renderer.blockquote(X);continue}case"list":{for(fe=Q.ordered,we=Q.start,Fe=Q.loose,Pe=Q.items.length,X="",Ae=0;Ae<Pe;Ae++)Ze=Q.items[Ae],tt=Ze.checked,st=Ze.task,Ve="",Ze.task&&(at=this.renderer.checkbox(tt),Fe?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=at+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=at+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:at}):Ve+=at),Ve+=this.parse(Ze.tokens,Fe),X+=this.renderer.listitem(Ve,st,tt);le+=this.renderer.list(X,fe,we);continue}case"html":{le+=this.renderer.html(Q.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(X=Q.tokens?this.parseInline(Q.tokens):Q.text;de+1<Se&&K[de+1].type==="text";)Q=K[++de],X+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);le+=ie?this.renderer.paragraph(X):X;continue}default:{var Be='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return le},ce.parseInline=function(K,ie){ie=ie||this.renderer;var le="",de,Ae,me,Pe=K.length;for(de=0;de<Pe;de++){if(Ae=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(me=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){le+=me||"";continue}switch(Ae.type){case"escape":{le+=ie.text(Ae.text);break}case"html":{le+=ie.html(Ae.text);break}case"link":{le+=ie.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ie));break}case"image":{le+=ie.image(Ae.href,Ae.title,Ae.text);break}case"strong":{le+=ie.strong(this.parseInline(Ae.tokens,ie));break}case"em":{le+=ie.em(this.parseInline(Ae.tokens,ie));break}case"codespan":{le+=ie.codespan(Ae.text);break}case"br":{le+=ie.br();break}case"del":{le+=ie.del(this.parseInline(Ae.tokens,ie));break}case"text":{le+=ie.text(Ae.text);break}default:{var Me='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return le},ae}();function re(ae,ce,se){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof ce=="function"&&(se=ce,ce=null),ce=g({},re.defaults,ce||{}),y(ce),se){var K=ce.highlight,ie;try{ie=H.lex(ae,ce)}catch(Pe){return se(Pe)}var le=function(Me){var je;if(!Me)try{ce.walkTokens&&re.walkTokens(ie,ce.walkTokens),je=Y.parse(ie,ce)}catch(q){Me=q}return ce.highlight=K,Me?se(Me):se(null,je)};if(!K||K.length<3||(delete ce.highlight,!ie.length))return le();var de=0;re.walkTokens(ie,function(Pe){Pe.type==="code"&&(de++,setTimeout(function(){K(Pe.text,Pe.lang,function(Me,je){if(Me)return le(Me);je!=null&&je!==Pe.text&&(Pe.text=je,Pe.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Ae(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(Pe.message+"",!0)+"</pre>";throw Pe}try{var me=H.lex(ae,ce);if(ce.walkTokens){if(ce.async)return Promise.all(re.walkTokens(me,ce.walkTokens)).then(function(){return Y.parse(me,ce)}).catch(Ae);re.walkTokens(me,ce.walkTokens)}return Y.parse(me,ce)}catch(Pe){Ae(Pe)}}re.options=re.setOptions=function(ae){return g(re.defaults,ae),b(re.defaults),re},re.getDefaults=M,re.defaults=he.defaults,re.use=function(){for(var ae=arguments.length,ce=new Array(ae),se=0;se<ae;se++)ce[se]=arguments[se];var K=g.apply(void 0,[{}].concat(ce)),ie=re.defaults.extensions||{renderers:{},childTokens:{}},le;ce.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Pe=ie.renderers?ie.renderers[me.name]:null;Pe?ie.renderers[me.name]=function(){for(var Me=arguments.length,je=new Array(Me),q=0;q<Me;q++)je[q]=arguments[q];var W=me.renderer.apply(this,je);return W===!1&&(W=Pe.apply(this,je)),W}:ie.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[me.level]?ie[me.level].unshift(me.tokenizer):ie[me.level]=[me.tokenizer],me.start&&(me.level==="block"?ie.startBlock?ie.startBlock.push(me.start):ie.startBlock=[me.start]:me.level==="inline"&&(ie.startInline?ie.startInline.push(me.start):ie.startInline=[me.start]))}me.childTokens&&(ie.childTokens[me.name]=me.childTokens)})),de.renderer&&function(){var me=re.defaults.renderer||new Z,Pe=function(q){var W=me[q];me[q]=function(){for(var X=arguments.length,Q=new Array(X),fe=0;fe<X;fe++)Q[fe]=arguments[fe];var we=de.renderer[q].apply(me,Q);return we===!1&&(we=W.apply(me,Q)),we}};for(var Me in de.renderer)Pe(Me);K.renderer=me}(),de.tokenizer&&function(){var me=re.defaults.tokenizer||new j,Pe=function(q){var W=me[q];me[q]=function(){for(var X=arguments.length,Q=new Array(X),fe=0;fe<X;fe++)Q[fe]=arguments[fe];var we=de.tokenizer[q].apply(me,Q);return we===!1&&(we=W.apply(me,Q)),we}};for(var Me in de.tokenizer)Pe(Me);K.tokenizer=me}(),de.walkTokens){var Ae=re.defaults.walkTokens;K.walkTokens=function(me){var Pe=[];return Pe.push(de.walkTokens.call(this,me)),Ae&&(Pe=Pe.concat(Ae.call(this,me))),Pe}}le&&(K.extensions=ie),re.setOptions(K)})},re.walkTokens=function(ae,ce){for(var se=[],K=function(){var Ae=le.value;switch(se=se.concat(ce.call(re,Ae)),Ae.type){case"table":{for(var me=R(Ae.header),Pe;!(Pe=me()).done;){var Me=Pe.value;se=se.concat(re.walkTokens(Me.tokens,ce))}for(var je=R(Ae.rows),q;!(q=je()).done;)for(var W=q.value,X=R(W),Q;!(Q=X()).done;){var fe=Q.value;se=se.concat(re.walkTokens(fe.tokens,ce))}break}case"list":{se=se.concat(re.walkTokens(Ae.items,ce));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[Ae.type]?re.defaults.extensions.childTokens[Ae.type].forEach(function(we){se=se.concat(re.walkTokens(Ae[we],ce))}):Ae.tokens&&(se=se.concat(re.walkTokens(Ae.tokens,ce)))}},ie=R(ae),le;!(le=ie()).done;)K();return se},re.parseInline=function(ae,ce){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");ce=g({},re.defaults,ce||{}),y(ce);try{var se=H.lexInline(ae,ce);return ce.walkTokens&&re.walkTokens(se,ce.walkTokens),Y.parseInline(se,ce)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},re.Parser=Y,re.parser=Y.parse,re.Renderer=Z,re.TextRenderer=ee,re.Lexer=H,re.lexer=H.lex,re.Tokenizer=j,re.Slugger=J,re.parse=re;var te=re.options,pe=re.setOptions,Ce=re.use,x=re.walkTokens,U=re.parseInline,ne=re,be=Y.parse,De=H.lex;he.Lexer=H,he.Parser=Y,he.Renderer=Z,he.Slugger=J,he.TextRenderer=ee,he.Tokenizer=j,he.getDefaults=M,he.lexer=De,he.marked=re,he.options=te,he.parse=ne,he.parseInline=U,he.parser=be,he.setOptions=pe,he.use=Ce,he.walkTokens=x,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[166],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=u;function u(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let O=0;const L=new Uint32Array(10);function R(a){if(O=0,M(a,P,4352),O>0||(M(a,$,4449),O>0)||(M(a,S,4520),O>0)||(M(a,v,12593),O))return L.subarray(0,O);if(a>=44032&&a<=55203){const m=a-44032,o=m%588,n=Math.floor(m/588),i=Math.floor(o/28),r=o%28-1;if(n<P.length?M(n,P,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<$.length?M(i,$,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),r>=0&&(r<S.length?M(r,S,0):4520+r-12593<v.length&&M(4520+r-12593,v,12593)),O>0)return L.subarray(0,O)}}function M(a,m,o){a>=o&&a<o+m.length&&b(m[a-o])}function b(a){a!==0&&(L[O++]=a&255,a>>8&&(L[O++]=a>>8&255),a>>16&&(L[O++]=a>>16&255))}var p;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var E;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(E||(E={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0,e.$5l=L,e.$6l=M;const O=new u.$Ec(1e4);function L(E){return p(E,"NFC",O)}const R=new u.$Ec(1e4);function M(E){return p(E,"NFD",R)}const b=/[^\u0000-\u0080]/;function p(E,A,P){if(!E)return E;const $=P.get(E);if($)return $;let S;return b.test(E)?S=E.normalize(A):S=E,P.set(E,S),S}e.$7l=function(){const E=/[\u0300-\u036f]/g;return function(A){return M(A).replace(E,"")}}()}),define(ke[125],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0,e.$sm=u,e.rot=O;function u(b,p,E){return Math.min(Math.max(b,p),E)}function O(b,p){return(p+b%p)%p}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$um=L;class R{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$vm=R;class M{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const E=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$wm=M}),function(){function he(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M(p){R.push(p,Date.now())}function b(){const p=[];for(let E=0;E<R.length;E+=2)p.push({name:R[E],startTime:R[E+1]});return p}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function u(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=u(O))}(),define(ke[167],Ee([1,0,45]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=void 0;const O=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert(p,E,A){this.d(p,P=>P._value=E,A)}mutate(p,E){this.d(p,A=>A._value=E(A._value===O?void 0:A._value))}delete(p){const E=this.c(p);if(!E)return;let A=E.length-1;const P=E[A].node._value;if(P!==O){for(this.b--,E[A].node._value=O;A>0;A--){const{node:$,part:S}=E[A];if($.children?.size||$._value!==O)break;E[A-1].node.children.delete(S)}return P}}*deleteRecursive(p){const E=this.c(p);if(!E)return;const A=E[E.length-1].node;for(let P=E.length-1;P>0;P--){const $=E[P-1];if($.node.children.delete(E[P].part),$.node.children.size>0||$.node._value!==O)break}for(const P of R(A))P._value!==O&&(this.b--,yield P._value)}find(p){let E=this.a;for(const A of p){const P=E.children?.get(A);if(!P)return;E=P}return E._value===O?void 0:E._value}hasKeyOrParent(p){let E=this.a;for(const A of p){const P=E.children?.get(A);if(!P)return!1;if(P._value!==O)return!0;E=P}return!1}hasKeyOrChildren(p){let E=this.a;for(const A of p){const P=E.children?.get(A);if(!P)return!1;E=P}return!0}hasKey(p){let E=this.a;for(const A of p){const P=E.children?.get(A);if(!P)return!1;E=P}return E._value!==O}c(p){const E=[{part:"",node:this.a}];let A=0;for(const P of p){const $=E[A].node.children?.get(P);if(!$)return;E.push({part:P,node:$}),A++}return E}d(p,E,A){let P=this.a;for(const v of p){if(P.children)if(P.children.has(v))P=P.children.get(v);else{const a=new M;P.children.set(v,a),P=a}else{const a=new M;P.children=new Map([[v,a]]),P=a}A?.(P)}const $=P._value===O?0:1;E(P);const S=P._value===O?0:1;this.b+=S-$}*values(){for(const{_value:p}of R(this.a))p!==O&&(yield p)}}e.$JO=L;function*R(b){const p=[b];for(;p.length>0;){const E=p.pop();if(yield E,E.children)for(const A of E.children.values())p.push(A)}}class M{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(p){this._value=p===void 0?O:p}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var O in u)(typeof exports=="object"?exports:he)[O]=u[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function u(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return he[O].call(L.exports,L,L.exports,u),L.l=!0,L.exports}return u.m=he,u.c=e,u.d=function(O,L,R){u.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:R})},u.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},u.t=function(O,L){if(1&L&&(O=u(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(u.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var M in O)u.d(R,M,function(b){return O[b]}.bind(null,M));return R},u.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return u.d(L,"a",L),L},u.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},u.p="",u(u.s=0)}([function(he,e,u){(function(O){var L;e=he.exports=Ce,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],p=e.src=[],E=0,A=E++;p[A]="0|[1-9]\\d*";var P=E++;p[P]="[0-9]+";var $=E++;p[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;p[S]="("+p[A]+")\\.("+p[A]+")\\.("+p[A]+")";var v=E++;p[v]="("+p[P]+")\\.("+p[P]+")\\.("+p[P]+")";var a=E++;p[a]="(?:"+p[A]+"|"+p[$]+")";var m=E++;p[m]="(?:"+p[P]+"|"+p[$]+")";var o=E++;p[o]="(?:-("+p[a]+"(?:\\."+p[a]+")*))";var n=E++;p[n]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var i=E++;p[i]="[0-9A-Za-z-]+";var r=E++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var s=E++,t="v?"+p[S]+p[o]+"?"+p[r]+"?";p[s]="^"+t+"$";var f="[v=\\s]*"+p[v]+p[n]+"?"+p[r]+"?",d=E++;p[d]="^"+f+"$";var l=E++;p[l]="((?:<|>)?=?)";var c=E++;p[c]=p[P]+"|x|X|\\*";var h=E++;p[h]=p[A]+"|x|X|\\*";var g=E++;p[g]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var D=E++;p[D]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[n]+")?"+p[r]+"?)?)?";var w=E++;p[w]="^"+p[l]+"\\s*"+p[g]+"$";var k=E++;p[k]="^"+p[l]+"\\s*"+p[D]+"$";var y=E++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;p[C]="(?:~>?)";var I=E++;p[I]="(\\s*)"+p[C]+"\\s+",b[I]=new RegExp(p[I],"g");var z=E++;p[z]="^"+p[C]+p[g]+"$";var j=E++;p[j]="^"+p[C]+p[D]+"$";var F=E++;p[F]="(?:\\^)";var N=E++;p[N]="(\\s*)"+p[F]+"\\s+",b[N]=new RegExp(p[N],"g");var T=E++;p[T]="^"+p[F]+p[g]+"$";var B=E++;p[B]="^"+p[F]+p[D]+"$";var H=E++;p[H]="^"+p[l]+"\\s*("+f+")$|^$";var Z=E++;p[Z]="^"+p[l]+"\\s*("+t+")$|^$";var ee=E++;p[ee]="(\\s*)"+p[l]+"\\s*("+f+"|"+p[g]+")",b[ee]=new RegExp(p[ee],"g");var J=E++;p[J]="^\\s*("+p[g]+")\\s+-\\s+("+p[g]+")\\s*$";var Y=E++;p[Y]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var re=E++;p[re]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)L(te,p[te]),b[te]||(b[te]=new RegExp(p[te]));function pe(W,X){if(W instanceof Ce)return W;if(typeof W!="string"||W.length>R||!(X?b[d]:b[s]).test(W))return null;try{return new Ce(W,X)}catch{return null}}function Ce(W,X){if(W instanceof Ce){if(W.loose===X)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Ce))return new Ce(W,X);L("SemVer",W,X),this.loose=X;var Q=W.trim().match(X?b[d]:b[s]);if(!Q)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<M)return we}return fe}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=pe,e.valid=function(W,X){var Q=pe(W,X);return Q?Q.version:null},e.clean=function(W,X){var Q=pe(W.trim().replace(/^[=v]+/,""),X);return Q?Q.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof Ce||(W=new Ce(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Ce.prototype.compareMain=function(W){return W instanceof Ce||(W=new Ce(W,this.loose)),U(this.major,W.major)||U(this.minor,W.minor)||U(this.patch,W.patch)},Ce.prototype.comparePre=function(W){if(W instanceof Ce||(W=new Ce(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var X=0;do{var Q=this.prerelease[X],fe=W.prerelease[X];if(L("prerelease compare",X,Q,fe),Q===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(Q===void 0)return-1;if(Q!==fe)return U(Q,fe)}while(++X)},Ce.prototype.inc=function(W,X){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,X,Q,fe){typeof Q=="string"&&(fe=Q,Q=void 0);try{return new Ce(W,Q).inc(X,fe).version}catch{return null}},e.diff=function(W,X){if(ae(W,X))return null;var Q=pe(W),fe=pe(X);if(Q.prerelease.length||fe.prerelease.length){for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==fe[we])return we},e.compareIdentifiers=U;var x=/^[0-9]+$/;function U(W,X){var Q=x.test(W),fe=x.test(X);return Q&&fe&&(W=+W,X=+X),Q&&!fe?-1:fe&&!Q?1:W<X?-1:W>X?1:0}function ne(W,X,Q){return new Ce(W,Q).compare(new Ce(X,Q))}function be(W,X,Q){return ne(W,X,Q)>0}function De(W,X,Q){return ne(W,X,Q)<0}function ae(W,X,Q){return ne(W,X,Q)===0}function ce(W,X,Q){return ne(W,X,Q)!==0}function se(W,X,Q){return ne(W,X,Q)>=0}function K(W,X,Q){return ne(W,X,Q)<=0}function ie(W,X,Q,fe){var we;switch(X){case"===":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),we=W===Q;break;case"!==":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),we=W!==Q;break;case"":case"=":case"==":we=ae(W,Q,fe);break;case"!=":we=ce(W,Q,fe);break;case">":we=be(W,Q,fe);break;case">=":we=se(W,Q,fe);break;case"<":we=De(W,Q,fe);break;case"<=":we=K(W,Q,fe);break;default:throw new TypeError("Invalid operator: "+X)}return we}function le(W,X){if(W instanceof le){if(W.loose===X)return W;W=W.value}if(!(this instanceof le))return new le(W,X);L("comparator",W,X),this.loose=X,this.parse(W),this.semver===de?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,X){return U(X,W)},e.major=function(W,X){return new Ce(W,X).major},e.minor=function(W,X){return new Ce(W,X).minor},e.patch=function(W,X){return new Ce(W,X).patch},e.compare=ne,e.compareLoose=function(W,X){return ne(W,X,!0)},e.rcompare=function(W,X,Q){return ne(X,W,Q)},e.sort=function(W,X){return W.sort(function(Q,fe){return e.compare(Q,fe,X)})},e.rsort=function(W,X){return W.sort(function(Q,fe){return e.rcompare(Q,fe,X)})},e.gt=be,e.lt=De,e.eq=ae,e.neq=ce,e.gte=se,e.lte=K,e.cmp=ie,e.Comparator=le;var de={};function Ae(W,X){if(W instanceof Ae)return W.loose===X?W:new Ae(W.raw,X);if(W instanceof le)return new Ae(W.value,X);if(!(this instanceof Ae))return new Ae(W,X);if(this.loose=X,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function me(W){return!W||W.toLowerCase()==="x"||W==="*"}function Pe(W,X,Q,fe,we,Fe,Ve,Ze,tt,st,at,ot,Se){return((X=me(Q)?"":me(fe)?">="+Q+".0.0":me(we)?">="+Q+"."+fe+".0":">="+X)+" "+(Ze=me(tt)?"":me(st)?"<"+(+tt+1)+".0.0":me(at)?"<"+tt+"."+(+st+1)+".0":ot?"<="+tt+"."+st+"."+at+"-"+ot:"<="+Ze)).trim()}function Me(W,X){for(var Q=0;Q<W.length;Q++)if(!W[Q].test(X))return!1;if(X.prerelease.length){for(Q=0;Q<W.length;Q++)if(L(W[Q].semver),W[Q].semver!==de&&W[Q].semver.prerelease.length>0){var fe=W[Q].semver;if(fe.major===X.major&&fe.minor===X.minor&&fe.patch===X.patch)return!0}return!1}return!0}function je(W,X,Q){try{X=new Ae(X,Q)}catch{return!1}return X.test(W)}function q(W,X,Q,fe){var we,Fe,Ve,Ze,tt;switch(W=new Ce(W,fe),X=new Ae(X,fe),Q){case">":we=be,Fe=K,Ve=De,Ze=">",tt=">=";break;case"<":we=De,Fe=se,Ve=be,Ze="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(W,X,fe))return!1;for(var st=0;st<X.set.length;++st){var at=X.set[st],ot=null,Se=null;if(at.forEach(function(Be){Be.semver===de&&(Be=new le(">=0.0.0")),ot=ot||Be,Se=Se||Be,we(Be.semver,ot.semver,fe)?ot=Be:Ve(Be.semver,Se.semver,fe)&&(Se=Be)}),ot.operator===Ze||ot.operator===tt||(!Se.operator||Se.operator===Ze)&&Fe(W,Se.semver)||Se.operator===tt&&Ve(W,Se.semver))return!1}return!0}le.prototype.parse=function(W){var X=this.loose?b[H]:b[Z],Q=W.match(X);if(!Q)throw new TypeError("Invalid comparator: "+W);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Ce(Q[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===de||(typeof W=="string"&&(W=new Ce(W,this.loose)),ie(W,this.operator,this.semver,this.loose))},le.prototype.intersects=function(W,X){if(!(W instanceof le))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae(W.value,X),je(this.value,Q,X);if(W.operator==="")return Q=new Ae(this.value,X),je(W.semver,Q,X);var fe=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Fe=this.semver.version===W.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ze=ie(this.semver,"<",W.semver,X)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=ie(this.semver,">",W.semver,X)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return fe||we||Fe&&Ve||Ze||tt},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(W){var X=this.loose;W=W.trim(),L("range",W,X);var Q=X?b[Y]:b[J];W=W.replace(Q,Pe),L("hyphen replace",W),W=W.replace(b[ee],"$1$2$3"),L("comparator trim",W,b[ee]),W=(W=(W=W.replace(b[I],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var fe=X?b[H]:b[Z],we=W.split(" ").map(function(Fe){return function(Ve,Ze){return L("comp",Ve),Ve=function(tt,st){return tt.trim().split(/\s+/).map(function(at){return function(ot,Se){L("caret",ot,Se);var Be=Se?b[B]:b[T];return ot.replace(Be,function(Ge,Le,Qe,oe,ue){var Ie;return L("caret",ot,Ge,Le,Qe,oe,ue),me(Le)?Ie="":me(Qe)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":me(oe)?Ie=Le==="0"?">="+Le+"."+Qe+".0 <"+Le+"."+(+Qe+1)+".0":">="+Le+"."+Qe+".0 <"+(+Le+1)+".0.0":ue?(L("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=Le==="0"?Qe==="0"?">="+Le+"."+Qe+"."+oe+ue+" <"+Le+"."+Qe+"."+(+oe+1):">="+Le+"."+Qe+"."+oe+ue+" <"+Le+"."+(+Qe+1)+".0":">="+Le+"."+Qe+"."+oe+ue+" <"+(+Le+1)+".0.0"):(L("no pr"),Ie=Le==="0"?Qe==="0"?">="+Le+"."+Qe+"."+oe+" <"+Le+"."+Qe+"."+(+oe+1):">="+Le+"."+Qe+"."+oe+" <"+Le+"."+(+Qe+1)+".0":">="+Le+"."+Qe+"."+oe+" <"+(+Le+1)+".0.0"),L("caret return",Ie),Ie})}(at,st)}).join(" ")}(Ve,Ze),L("caret",Ve),Ve=function(tt,st){return tt.trim().split(/\s+/).map(function(at){return function(ot,Se){var Be=Se?b[j]:b[z];return ot.replace(Be,function(Ge,Le,Qe,oe,ue){var Ie;return L("tilde",ot,Ge,Le,Qe,oe,ue),me(Le)?Ie="":me(Qe)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":me(oe)?Ie=">="+Le+"."+Qe+".0 <"+Le+"."+(+Qe+1)+".0":ue?(L("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=">="+Le+"."+Qe+"."+oe+ue+" <"+Le+"."+(+Qe+1)+".0"):Ie=">="+Le+"."+Qe+"."+oe+" <"+Le+"."+(+Qe+1)+".0",L("tilde return",Ie),Ie})}(at,st)}).join(" ")}(Ve,Ze),L("tildes",Ve),Ve=function(tt,st){return L("replaceXRanges",tt,st),tt.split(/\s+/).map(function(at){return function(ot,Se){ot=ot.trim();var Be=Se?b[k]:b[w];return ot.replace(Be,function(Ge,Le,Qe,oe,ue,Ie){L("xRange",ot,Ge,Le,Qe,oe,ue,Ie);var Ke=me(Qe),Re=Ke||me(oe),it=Re||me(ue);return Le==="="&&it&&(Le=""),Ke?Ge=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Re&&(oe=0),it&&(ue=0),Le===">"?(Le=">=",Re?(Qe=+Qe+1,oe=0,ue=0):it&&(oe=+oe+1,ue=0)):Le==="<="&&(Le="<",Re?Qe=+Qe+1:oe=+oe+1),Ge=Le+Qe+"."+oe+"."+ue):Re?Ge=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":it&&(Ge=">="+Qe+"."+oe+".0 <"+Qe+"."+(+oe+1)+".0"),L("xRange return",Ge),Ge})}(at,st)}).join(" ")}(Ve,Ze),L("xrange",Ve),Ve=function(tt,st){return L("replaceStars",tt,st),tt.trim().replace(b[re],"")}(Ve,Ze),L("stars",Ve),Ve}(Fe,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Fe){return!!Fe.match(fe)})),we=we.map(function(Fe){return new le(Fe,X)})},Ae.prototype.intersects=function(W,X){if(!(W instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(fe){return W.set.some(function(we){return we.every(function(Fe){return fe.intersects(Fe,X)})})})})},e.toComparators=function(W,X){return new Ae(W,X).set.map(function(Q){return Q.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Ce(W,this.loose));for(var X=0;X<this.set.length;X++)if(Me(this.set[X],W))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(W,X,Q){var fe=null,we=null;try{var Fe=new Ae(X,Q)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(fe&&we.compare(Ve)!==-1||(we=new Ce(fe=Ve,Q)))}),fe},e.minSatisfying=function(W,X,Q){var fe=null,we=null;try{var Fe=new Ae(X,Q)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(fe&&we.compare(Ve)!==1||(we=new Ce(fe=Ve,Q)))}),fe},e.validRange=function(W,X){try{return new Ae(W,X).range||"*"}catch{return null}},e.ltr=function(W,X,Q){return q(W,X,"<",Q)},e.gtr=function(W,X,Q){return q(W,X,">",Q)},e.outside=q,e.prerelease=function(W,X){var Q=pe(W,X);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(W,X,Q){return W=new Ae(W,Q),X=new Ae(X,Q),W.intersects(X)},e.coerce=function(W){if(W instanceof Ce)return W;if(typeof W!="string")return null;var X=W.match(b[y]);return X==null?null:pe((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,u(1))},function(he,e){var u,O,L=he.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(m){if(u===setTimeout)return setTimeout(m,0);if((u===R||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:R}catch{u=R}try{O=typeof clearTimeout=="function"?clearTimeout:M}catch{O=M}})();var p,E=[],A=!1,P=-1;function $(){A&&p&&(A=!1,p.length?E=p.concat(E):P=-1,E.length&&S())}function S(){if(!A){var m=b($);A=!0;for(var o=E.length;o;){for(p=E,E=[];++P<o;)p&&p[P].run();P=-1,o=E.length}p=null,A=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===M||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(m)}}function v(m,o){this.fun=m,this.array=o}function a(){}L.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];E.push(new v(m,o)),E.length!==1||A||b(S)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=a,L.addListener=a,L.once=a,L.off=a,L.removeListener=a,L.removeAllListeners=a,L.emit=a,L.prependListener=a,L.prependOnceListener=a,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[38],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(R){return new O(R)}constructor(R){this.c=u&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$8d=O}),define(ke[4],Ee([1,0,13,74,3,75,38]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$0d=e.Event=void 0,e.$$d=S;const b=!1,p=!1,E=!1;var A;(function(y){y.None=()=>L.$Uc.None;function C(le){if(E){const{onDidAddListener:de}=le,Ae=a.create();let me=0;le.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),de?.()}}}function I(le,de){return J(le,()=>{},0,void 0,!0,void 0,de)}y.defer=I;function z(le){return(de,Ae=null,me)=>{let Pe=!1,Me;return Me=le(je=>{if(!Pe)return Me?Me.dispose():Pe=!0,de.call(Ae,je)},null,me),Pe&&Me.dispose(),Me}}y.once=z;function j(le,de,Ae){return Z((me,Pe=null,Me)=>le(je=>me.call(Pe,de(je)),null,Me),Ae)}y.map=j;function F(le,de,Ae){return Z((me,Pe=null,Me)=>le(je=>{de(je),me.call(Pe,je)},null,Me),Ae)}y.forEach=F;function N(le,de,Ae){return Z((me,Pe=null,Me)=>le(je=>de(je)&&me.call(Pe,je),null,Me),Ae)}y.filter=N;function T(le){return le}y.signal=T;function B(...le){return(de,Ae=null,me)=>{const Pe=(0,L.$Rc)(...le.map(Me=>Me(je=>de.call(Ae,je))));return ee(Pe,me)}}y.any=B;function H(le,de,Ae,me){let Pe=Ae;return j(le,Me=>(Pe=de(Pe,Me),Pe),me)}y.reduce=H;function Z(le,de){let Ae;const me={onWillAddFirstListener(){Ae=le(Pe.fire,Pe)},onDidRemoveLastListener(){Ae?.dispose()}};de||C(me);const Pe=new s(me);return de?.add(Pe),Pe.event}function ee(le,de){return de instanceof Array?de.push(le):de&&de.add(le),le}function J(le,de,Ae=100,me=!1,Pe=!1,Me,je){let q,W,X,Q=0,fe;const we={leakWarningThreshold:Me,onWillAddFirstListener(){q=le(Ve=>{Q++,W=de(W,Ve),me&&!X&&(Fe.fire(W),W=void 0),fe=()=>{const Ze=W;W=void 0,X=void 0,(!me||Q>1)&&Fe.fire(Ze),Q=0},typeof Ae=="number"?(clearTimeout(X),X=setTimeout(fe,Ae)):X===void 0&&(X=0,queueMicrotask(fe))})},onWillRemoveListener(){Pe&&Q>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,q.dispose()}};je||C(we);const Fe=new s(we);return je?.add(Fe),Fe.event}y.debounce=J;function Y(le,de=0,Ae){return y.debounce(le,(me,Pe)=>me?(me.push(Pe),me):[Pe],de,void 0,!0,void 0,Ae)}y.accumulate=Y;function re(le,de=(me,Pe)=>me===Pe,Ae){let me=!0,Pe;return N(le,Me=>{const je=me||!de(Me,Pe);return me=!1,Pe=Me,je},Ae)}y.latch=re;function te(le,de,Ae){return[y.filter(le,de,Ae),y.filter(le,me=>!de(me),Ae)]}y.split=te;function pe(le,de=!1,Ae=[],me){let Pe=Ae.slice(),Me=le(W=>{Pe?Pe.push(W):q.fire(W)});me&&me.add(Me);const je=()=>{Pe?.forEach(W=>q.fire(W)),Pe=null},q=new s({onWillAddFirstListener(){Me||(Me=le(W=>q.fire(W)),me&&me.add(Me))},onDidAddFirstListener(){Pe&&(de?setTimeout(je):je())},onDidRemoveLastListener(){Me&&Me.dispose(),Me=null}});return me&&me.add(q),q.event}y.buffer=pe;function Ce(le,de){return(me,Pe,Me)=>{const je=de(new U);return le(function(q){const W=je.evaluate(q);W!==x&&me.call(Pe,W)},void 0,Me)}}y.chain=Ce;const x=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(Ae=>(de(Ae),Ae)),this}filter(de){return this.f.push(Ae=>de(Ae)?Ae:x),this}reduce(de,Ae){let me=Ae;return this.f.push(Pe=>(me=de(me,Pe),me)),this}latch(de=(Ae,me)=>Ae===me){let Ae=!0,me;return this.f.push(Pe=>{const Me=Ae||!de(Pe,me);return Ae=!1,me=Pe,Me?Pe:x}),this}evaluate(de){for(const Ae of this.f)if(de=Ae(de),de===x)break;return de}}function ne(le,de,Ae=me=>me){const me=(...q)=>je.fire(Ae(...q)),Pe=()=>le.on(de,me),Me=()=>le.removeListener(de,me),je=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Me});return je.event}y.fromNodeEventEmitter=ne;function be(le,de,Ae=me=>me){const me=(...q)=>je.fire(Ae(...q)),Pe=()=>le.addEventListener(de,me),Me=()=>le.removeEventListener(de,me),je=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Me});return je.event}y.fromDOMEventEmitter=be;function De(le){return new Promise(de=>z(le)(de))}y.toPromise=De;function ae(le){const de=new s;return le.then(Ae=>{de.fire(Ae)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}y.fromPromise=ae;function ce(le,de,Ae){return de(Ae),le(me=>de(me))}y.runAndSubscribe=ce;class se{constructor(de,Ae){this._observable=de,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Ae||C(me),this.emitter=new s(me),Ae&&Ae.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,Ae){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function K(le,de){return new se(le,de).emitter.event}y.fromObservable=K;function ie(le){return(de,Ae,me)=>{let Pe=0,Me=!1;const je={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(le.reportChanges(),Me&&(Me=!1,de.call(Ae)))},handlePossibleChange(){},handleChange(){Me=!0}};le.addObserver(je),le.reportChanges();const q={dispose(){le.removeObserver(je)}};return me instanceof L.$Tc?me.add(q):Array.isArray(me)&&me.push(q),q}}y.fromObservableLight=ie})(A||(e.Event=A={}));class P{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${P.f++}`,P.all.add(this)}start(C){this.g=new M.$8d,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}e.$0d=P;let $=-1;function S(y){const C=$;return $=y,{dispose(){$=C}}}class v{constructor(C,I=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=I,this.g=0}dispose(){this.f?.clear()}check(C,I){const z=this.threshold;if(z<=0||I<z)return;this.f||(this.f=new Map);const j=this.f.get(C.value)||0;if(this.f.set(C.value,j+1),this.g-=1,this.g<=0){this.g=z*.5;let F,N=0;for(const[T,B]of this.f)(!F||N<B)&&(F=T,N=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${N}):`),console.warn(F)}return()=>{const F=this.f.get(C.value)||0;this.f.set(C.value,F-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class o{constructor(C){this.value=C,this.id=m++}}const n=2,i=(y,C)=>{if(y instanceof o)C(y);else for(let I=0;I<y.length;I++){const z=y[I];z&&C(z)}},r=b?new FinalizationRegistry(y=>{typeof y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(y))}):void 0;class s{constructor(C){this.w=0,this.f=C,this.g=$>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const C=this.t;queueMicrotask(()=>{i(C,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,I,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;I&&(C=C.bind(I));const j=new o(C);let F,N;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=a.create(),F=this.g.check(j.stack,this.w+1)),p&&(j.stack=N??a.create()),this.t?this.t instanceof o?(this.u??=new f,this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,L.$Sc)(()=>{r?.unregister(T),F?.(),this.x(j)});if(z instanceof L.$Tc?z.add(T):Array.isArray(z)&&z.push(T),r){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(T,B,T)}return T},this.q}x(C){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,z=I.indexOf(C);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[z]=void 0;const j=this.u.current===this;if(this.w*n<=I.length){let F=0;for(let N=0;N<I.length;N++)I[N]?I[F++]=I[N]:j&&(this.u.end--,F<this.u.i&&this.u.i--);I.length=F}}y(C,I){if(!C)return;const z=this.f?.onListenerError||u.$1;if(!z){C.value(I);return}try{C.value(I)}catch(j){z(j)}}z(C){const I=C.current.t;for(;C.i<C.end;)this.y(I[C.i++],C.value);C.reset()}fire(C){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,C);else{const I=this.u;I.enqueue(this,C,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$_d=s;const t=()=>new f;e.$ae=t;class f{constructor(){this.i=-1,this.end=0}enqueue(C,I,z){this.i=0,this.end=z,this.current=C,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(C,I,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,j=>this.h.push([j.value,C]));this.h.size>0&&!I.isCancellationRequested;){const[j,F]=this.h.shift(),N=[],T={...F,token:I,waitUntil:B=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");z&&(B=z(B,j)),N.push(B)}};try{j(T)}catch(B){(0,u.$1)(B);continue}Object.freeze(N),await Promise.allSettled(N).then(B=>{for(const H of B)H.status==="rejected"&&(0,u.$1)(H.reason)})}}}e.$be=d;class l extends s{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new R.$5c,this.A=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.A(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.w&&(this.h!==0?this.s.push(C):super.fire(C))}}e.$ce=l;class c extends l{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}e.$de=c;class h extends s{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$ee=h;class g{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const I={event:C,listener:null};this.h.push(I),this.g&&this.m(I);const z=()=>{this.g&&this.o(I);const j=this.h.indexOf(I);this.h.splice(j,1)};return(0,L.$Sc)((0,O.$db)(z))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(I=>this.f.fire(I))}o(C){C.listener?.dispose(),C.listener=null}dispose(){this.f.dispose();for(const C of this.h)C.listener?.dispose();this.h=[]}}e.$fe=g;class D{constructor(C,I,z,j){this.f=new L.$Tc;const F=this.f.add(new g),N=this.f.add(new L.$4c);function T(B){N.set(B,F.add(j(B)))}for(const B of C)T(B);this.f.add(I(B=>{T(B)})),this.f.add(z(B=>{N.deleteAndDispose(B)})),this.event=F.event}dispose(){this.f.dispose()}}e.$ge=D;class w{constructor(){this.f=[]}wrapEvent(C){return(I,z,j)=>C(F=>{const N=this.f[this.f.length-1];N?N.push(()=>I.call(z,F)):I.call(z,F)},void 0,j)}bufferEvents(C){const I=[];this.f.push(I);const z=C();return this.f.pop(),I.forEach(j=>j()),z}}e.$he=w;class k{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ie=k}),define(ke[22],Ee([1,0,4]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.CancellationToken=void 0;const O=Object.freeze(function(b,p){const E=setTimeout(b.bind(p),0);return{dispose(){clearTimeout(E)}}});var L;(function(b){function p(E){return E===b.None||E===b.Cancelled||E instanceof R?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}b.isCancellationToken=p,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new u.$_d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$je=M}),define(ke[168],Ee([1,0,22]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$We=e.$Ve=e.$Ue=void 0;class O{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new u.$je,p=this.b(b.token);return this.a={promise:p,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ue=O;class L{constructor(b,p=JSON.stringify){this.c=b,this.d=p,this.a=void 0,this.b=void 0}get(b){const p=this.d(b);return this.b!==p&&(this.b=p,this.a=this.c(b)),this.a}}e.$Ve=L;class R{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const p=this.b(b);return this.a.set(b,p),p}}e.$We=R}),define(ke[98],Ee([1,0,13,3]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=L,e.$le=R,e.$me=M,e.$ne=b,e.$oe=E,e.$pe=A,e.$qe=P,e.$re=$,e.$se=S,e.$te=v,e.$ue=a,e.$ve=m,e.$we=o,e.$xe=n,e.$ye=i;function L(r){const s=r;return s?typeof s.read=="function":!1}function R(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function M(r){const s=r;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(r,s){return new p(r,s)}class p{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function P(r,s){return new Promise((t,f)=>{const d=[];$(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function $(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function S(r,s){return new Promise((t,f)=>{const d=new O.$Tc,l=[],c=D=>{if(l.push(D),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=D=>(d.dispose(),f(D)),g=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,O.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,O.$Sc)(()=>r.removeListener("end",g))),r.on("end",g),d.add((0,O.$Sc)(()=>r.removeListener("data",c))),r.on("data",c)})}function v(r,s){const t=b(s);return t.end(r),t}function a(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=b(t);return $(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let f=!1;const d=b(t);return $(s,{onData:l=>f?d.write(l):(f=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(ke[21],Ee([1,0,46,98]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=E,e.$Be=A,e.$Ce=P,e.$De=$,e.$Ee=S,e.$Fe=v,e.$Ge=a,e.$He=m,e.$Ie=o,e.$Je=n,e.$Ke=i,e.$Le=r,e.$Me=s,e.$Ne=t,e.$Oe=f,e.$Pe=d,e.$Qe=l,e.$Re=c,e.$Se=h,e.$Te=w;const L=typeof Buffer<"u",R=new u.$V(()=>new Uint8Array(256));let M,b;class p{static alloc(y){return L?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&L?new p(Buffer.from(y)):(M||(M=new TextEncoder),new p(M.encode(y)))}static fromByteArray(y){const C=p.alloc(y.length);for(let I=0,z=y.length;I<z;I++)C.buffer[I]=y[I];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let j=0,F=y.length;j<F;j++)C+=y[j].byteLength}const I=p.alloc(C);let z=0;for(let j=0,F=y.length;j<F;j++){const N=y[j];I.set(N,z),z+=N.byteLength}return I}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,C){return new p(this.buffer.subarray(y,C))}set(y,C){if(y instanceof p)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return $(this.buffer,y)}writeUInt32BE(y,C){S(this.buffer,y,C)}readUInt32LE(y){return v(this.buffer,y)}writeUInt32LE(y,C){a(this.buffer,y,C)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,C){o(this.buffer,y,C)}indexOf(y,C=0){return E(this.buffer,y instanceof p?y.buffer:y,C)}}e.$ze=p;function E(k,y,C=0){const I=y.byteLength,z=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(y[0]);if(I>z-C)return-1;const j=R.value;j.fill(y.length);for(let B=0;B<y.length;B++)j[y[B]]=y.length-B-1;let F=C+y.length-1,N=F,T=-1;for(;F<z;)if(k[F]===y[N]){if(N===0){T=F;break}F--,N--}else F+=Math.max(y.length-N,j[k[F]]),N=y.length-1;return T}function A(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0}function P(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255}function $(k,y){return k[y]*2**24+k[y+1]*2**16+k[y+2]*2**8+k[y+3]}function S(k,y,C){k[C+3]=y,y=y>>>8,k[C+2]=y,y=y>>>8,k[C+1]=y,y=y>>>8,k[C]=y}function v(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0|k[y+2]<<16>>>0|k[y+3]<<24>>>0}function a(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255,y=y>>>8,k[C+2]=y&255,y=y>>>8,k[C+3]=y&255}function m(k,y){return k[y]}function o(k,y,C){k[C]=y}function n(k){return O.$oe(k,y=>p.concat(y))}function i(k){return O.$ve(k)}function r(k){return O.$qe(k,y=>p.concat(y))}async function s(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await r(k.stream)])}function t(k){return O.$te(k,y=>p.concat(y))}function f(k){return O.$we(k,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}function d(k){return O.$ne(y=>p.concat(y),k)}function l(k,y){return O.$xe(k,y,C=>p.concat(C))}function c(k,y){return O.$ye(k,y,C=>p.concat(C))}function h(k){let y=0,C=0,I=0;const z=new Uint8Array(Math.floor(k.length/4*3)),j=N=>{switch(C){case 3:z[I++]=y|N,C=0;break;case 2:z[I++]=y|N>>>2,y=N<<6,C=3;break;case 1:z[I++]=y|N>>>4,y=N<<4,C=2;break;default:y=N<<2,C=1}};for(let N=0;N<k.length;N++){const T=k.charCodeAt(N);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[N]}`)}}const F=I;for(;C>0;)j(0);return p.wrap(z).slice(0,F)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:k},y=!0,C=!1){const I=C?D:g;let z="";const j=k.byteLength%3;let F=0;for(;F<k.byteLength-j;F+=3){const N=k[F+0],T=k[F+1],B=k[F+2];z+=I[N>>>2],z+=I[(N<<4|T>>>4)&63],z+=I[(T<<2|B>>>6)&63],z+=I[B&63]}if(j===1){const N=k[F+0];z+=I[N>>>2],z+=I[N<<4&63],y&&(z+="==")}else if(j===2){const N=k[F+0],T=k[F+1];z+=I[N>>>2],z+=I[(N<<4|T>>>4)&63],z+=I[T<<2&63],y&&(z+="=")}return z}}),define(ke[14],Ee([1,0,168,46]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.GraphemeBreakType=e.$Nf=e.$Gf=e.$zf=e.$yf=void 0,e.$Ze=L,e.$1e=M,e.$2e=p,e.$3e=E,e.$4e=A,e.$5e=P,e.$6e=$,e.$7e=S,e.$8e=v,e.$9e=a,e.$0e=m,e.$$e=o,e.$_e=n,e.$af=i,e.$bf=r,e.$cf=s,e.$df=t,e.$ef=f,e.$ff=d,e.$gf=l,e.$hf=c,e.$if=h,e.$jf=g,e.$kf=D,e.$lf=w,e.$mf=k,e.$nf=y,e.$of=C,e.$pf=I,e.$qf=z,e.$rf=j,e.$sf=F,e.$tf=N,e.$uf=T,e.$vf=B,e.$wf=H,e.$xf=Z,e.$Af=re,e.$Bf=te,e.$Cf=pe,e.$Df=Ce,e.$Ef=ne,e.$Ff=De,e.$Hf=ae,e.$If=ce,e.$Jf=se,e.$Kf=K,e.$Lf=le,e.$Mf=de,e.$Of=Ae,e.$Pf=me,e.$Qf=Pe,e.$Rf=Me,e.$Sf=je,e.$Tf=q,e.$Uf=W,e.$Vf=X,e.$Wf=Ve;function L(Se){return!Se||typeof Se!="string"?!0:Se.trim().length===0}const R=/{(\d+)}/g;function M(Se,...Be){return Be.length===0?Se:Se.replace(R,function(Ge,Le){const Qe=parseInt(Le,10);return isNaN(Qe)||Qe<0||Qe>=Be.length?Ge:Be[Qe]})}const b=/{([^}]+)}/g;function p(Se,Be){return Object.keys(Be).length===0?Se:Se.replace(b,(Ge,Le)=>Be[Le]??Ge)}function E(Se){return Se.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(Se){return Se.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Se){return Se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(Se,Be){let Ge=0;const Le=Be.charCodeAt(0);for(let Qe=Se.length-1;Qe>=0;Qe--)Se.charCodeAt(Qe)===Le&&Ge++;return Ge}function S(Se,Be,Ge="\u2026"){return Se.length<=Be?Se:`${Se.substr(0,Be)}${Ge}`}function v(Se,Be,Ge="\u2026"){if(Se.length<=Be)return Se;const Le=Math.ceil(Be/2)-Ge.length/2,Qe=Math.floor(Be/2)-Ge.length/2;return`${Se.substr(0,Le)}${Ge}${Se.substr(Se.length-Qe)}`}function a(Se,Be=" "){const Ge=m(Se,Be);return o(Ge,Be)}function m(Se,Be){if(!Se||!Be)return Se;const Ge=Be.length;if(Ge===0||Se.length===0)return Se;let Le=0;for(;Se.indexOf(Be,Le)===Le;)Le=Le+Ge;return Se.substring(Le)}function o(Se,Be){if(!Se||!Be)return Se;const Ge=Be.length,Le=Se.length;if(Ge===0||Le===0)return Se;let Qe=Le,oe=-1;for(;oe=Se.lastIndexOf(Be,Qe-1),!(oe===-1||oe+Ge!==Qe);){if(oe===0)return"";Qe=oe}return Se.substring(0,Qe)}function n(Se){return Se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Se){return Se.replace(/\*/g,"")}function r(Se,Be,Ge={}){if(!Se)throw new Error("Cannot create regex from empty string");Be||(Se=P(Se)),Ge.wholeWord&&(/\B/.test(Se.charAt(0))||(Se="\\b"+Se),/\B/.test(Se.charAt(Se.length-1))||(Se=Se+"\\b"));let Le="";return Ge.global&&(Le+="g"),Ge.matchCase||(Le+="i"),Ge.multiline&&(Le+="m"),Ge.unicode&&(Le+="u"),new RegExp(Se,Le)}function s(Se){return Se.source==="^"||Se.source==="^$"||Se.source==="$"||Se.source==="^\\s*$"?!1:!!(Se.exec("")&&Se.lastIndex===0)}function t(Se){return Se.split(/\r\n|\r|\n/)}function f(Se){const Be=[],Ge=Se.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(Ge.length/2);Le++)Be.push(Ge[2*Le]+(Ge[2*Le+1]??""));return Be}function d(Se){for(let Be=0,Ge=Se.length;Be<Ge;Be++){const Le=Se.charCodeAt(Be);if(Le!==32&&Le!==9)return Be}return-1}function l(Se,Be=0,Ge=Se.length){for(let Le=Be;Le<Ge;Le++){const Qe=Se.charCodeAt(Le);if(Qe!==32&&Qe!==9)return Se.substring(Be,Le)}return Se.substring(Be,Ge)}function c(Se,Be=Se.length-1){for(let Ge=Be;Ge>=0;Ge--){const Le=Se.charCodeAt(Ge);if(Le!==32&&Le!==9)return Ge}return-1}function h(Se,Be,Ge){const Le=[];let Qe=0;for(const oe of Se.matchAll(Be)){if(Le.push(Se.slice(Qe,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");Qe=oe.index+oe[0].length,Le.push(Ge(oe[0],...oe.slice(1),oe.index,Se,oe.groups))}return Le.push(Se.slice(Qe)),Promise.all(Le).then(oe=>oe.join(""))}function g(Se,Be){return Se<Be?-1:Se>Be?1:0}function D(Se,Be,Ge=0,Le=Se.length,Qe=0,oe=Be.length){for(;Ge<Le&&Qe<oe;Ge++,Qe++){const Ke=Se.charCodeAt(Ge),Re=Be.charCodeAt(Qe);if(Ke<Re)return-1;if(Ke>Re)return 1}const ue=Le-Ge,Ie=oe-Qe;return ue<Ie?-1:ue>Ie?1:0}function w(Se,Be){return k(Se,Be,0,Se.length,0,Be.length)}function k(Se,Be,Ge=0,Le=Se.length,Qe=0,oe=Be.length){for(;Ge<Le&&Qe<oe;Ge++,Qe++){let Ke=Se.charCodeAt(Ge),Re=Be.charCodeAt(Qe);if(Ke===Re)continue;if(Ke>=128||Re>=128)return D(Se.toLowerCase(),Be.toLowerCase(),Ge,Le,Qe,oe);C(Ke)&&(Ke-=32),C(Re)&&(Re-=32);const it=Ke-Re;if(it!==0)return it}const ue=Le-Ge,Ie=oe-Qe;return ue<Ie?-1:ue>Ie?1:0}function y(Se){return Se>=48&&Se<=57}function C(Se){return Se>=97&&Se<=122}function I(Se){return Se>=65&&Se<=90}function z(Se,Be){return Se.length===Be.length&&k(Se,Be)===0}function j(Se,Be){const Ge=Be.length;return Be.length>Se.length?!1:k(Se,Be,0,Ge)===0}function F(Se,Be){const Ge=Math.min(Se.length,Be.length);let Le;for(Le=0;Le<Ge;Le++)if(Se.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return Ge}function N(Se,Be){const Ge=Math.min(Se.length,Be.length);let Le;const Qe=Se.length-1,oe=Be.length-1;for(Le=0;Le<Ge;Le++)if(Se.charCodeAt(Qe-Le)!==Be.charCodeAt(oe-Le))return Le;return Ge}function T(Se){return 55296<=Se&&Se<=56319}function B(Se){return 56320<=Se&&Se<=57343}function H(Se,Be){return(Se-55296<<10)+(Be-56320)+65536}function Z(Se,Be,Ge){const Le=Se.charCodeAt(Ge);if(T(Le)&&Ge+1<Be){const Qe=Se.charCodeAt(Ge+1);if(B(Qe))return H(Le,Qe)}return Le}function ee(Se,Be){const Ge=Se.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Le=Se.charCodeAt(Be-2);if(T(Le))return H(Le,Ge)}return Ge}class J{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=ee(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=Z(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$yf=J;class Y{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new J(Be,Ge)}nextGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Le=Ge.offset;let Qe=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const oe=Ge.offset,ue=Be.getGraphemeBreakType(Ge.nextCodePoint());if(Q(Qe,ue)){Ge.setOffset(oe);break}Qe=ue}return Ge.offset-Le}prevGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Le=Ge.offset;let Qe=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const oe=Ge.offset,ue=Be.getGraphemeBreakType(Ge.prevCodePoint());if(Q(ue,Qe)){Ge.setOffset(oe);break}Qe=ue}return Le-Ge.offset}eol(){return this.c.eol()}}e.$zf=Y;function re(Se,Be){return new Y(Se,Be).nextGraphemeLength()}function te(Se,Be){return new Y(Se,Be).prevGraphemeLength()}function pe(Se,Be){Be>0&&B(Se.charCodeAt(Be))&&Be--;const Ge=Be+re(Se,Be);return[Ge-te(Se,Ge),Ge]}function Ce(Se){const Be=new Y(Se);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let x;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(Se){return x||(x=U()),x.test(Se)}const be=/^[\t\n\r\x20-\x7E]*$/;function De(Se){return be.test(Se)}e.$Gf=/[\u2028\u2029]/;function ae(Se){return e.$Gf.test(Se)}function ce(Se){return Se>=11904&&Se<=55215||Se>=63744&&Se<=64255||Se>=65281&&Se<=65374}function se(Se){return Se>=127462&&Se<=127487||Se===8986||Se===8987||Se===9200||Se===9203||Se>=9728&&Se<=10175||Se===11088||Se===11093||Se>=127744&&Se<=128591||Se>=128640&&Se<=128764||Se>=128992&&Se<=129008||Se>=129280&&Se<=129535||Se>=129648&&Se<=129782}function K(Se,Be,Ge=""){const Le=Se.trimStart();if(Le.length<Be)return Le;const Qe=/\b/g;let oe=0;for(;Qe.test(Le)&&!(Le.length-Qe.lastIndex<Be);)oe=Qe.lastIndex,Qe.lastIndex+=1;return oe===0?Le:Ge+Le.substring(oe).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le(Se){let Be=0;for(const Ge of Se.matchAll(ie))Be!==Ge.index&&(yield{isCode:!1,str:Se.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==Se.length&&(yield{isCode:!1,str:Se.substring(Be)})}function de(Se){return Se&&(Se=Se.replace(ie,"")),Se}e.$Nf="\uFEFF";function Ae(Se){return!!(Se&&Se.length>0&&Se.charCodeAt(0)===65279)}function me(Se){return Ae(Se)?Se.substr(1):Se}function Pe(Se,Be){if(!Se||!Be||Se.length<Be.length)return!1;const Ge=Be.length,Le=Se.toLowerCase();let Qe=0,oe=-1;for(;Qe<Ge;){const ue=Le.indexOf(Be[Qe],oe+1);if(ue<0)return!1;oe=ue,Qe++}return!0}function Me(Se,Be=!1){return Se?(Be&&(Se=Se.replace(/\\./g,"")),Se.toLowerCase()!==Se):!1}function je(Se){return Se.charAt(0).toUpperCase()+Se.slice(1)}function q(Se,Be=1){if(Be===0)return"";let Ge=-1;do Ge=Se.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?Se:(Se[Ge-1]==="\r"&&Ge--,Se.substr(0,Ge))}function W(Se){return Se=Se%(2*26),Se<26?String.fromCharCode(97+Se):String.fromCharCode(65+Se-26)}function X(Se){return we.getInstance().getGraphemeBreakType(Se)}function Q(Se,Be){return Se===0?Be!==5&&Be!==7:Se===2&&Be===3?!1:Se===4||Se===2||Se===3||Be===4||Be===2||Be===3?!0:!(Se===8&&(Be===8||Be===9||Be===11||Be===12)||(Se===11||Se===9)&&(Be===9||Be===10)||(Se===12||Se===10)&&Be===10||Be===5||Be===13||Be===7||Se===1||Se===13&&Be===14||Se===6&&Be===6)}var fe;(function(Se){Se[Se.Other=0]="Other",Se[Se.Prepend=1]="Prepend",Se[Se.CR=2]="CR",Se[Se.LF=3]="LF",Se[Se.Control=4]="Control",Se[Se.Extend=5]="Extend",Se[Se.Regional_Indicator=6]="Regional_Indicator",Se[Se.SpacingMark=7]="SpacingMark",Se[Se.L=8]="L",Se[Se.V=9]="V",Se[Se.T=10]="T",Se[Se.LV=11]="LV",Se[Se.LVT=12]="LVT",Se[Se.ZWJ=13]="ZWJ",Se[Se.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(e.GraphemeBreakType=fe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Fe()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Le=Ge.length/3;let Qe=1;for(;Qe<=Le;)if(Be<Ge[3*Qe])Qe=2*Qe;else if(Be>Ge[3*Qe+1])Qe=2*Qe+1;else return Ge[3*Qe+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Se,Be){if(Se===0)return 0;const Ge=Ze(Se,Be);if(Ge!==void 0)return Ge;const Le=new J(Be,Se);return Le.prevCodePoint(),Le.offset}function Ze(Se,Be){const Ge=new J(Be,Se);let Le=Ge.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(Ge.offset===0)return;Le=Ge.prevCodePoint()}if(!se(Le))return;let Qe=Ge.offset;return Qe>0&&Ge.prevCodePoint()===8205&&(Qe=Ge.offset),Qe}function tt(Se){return 127995<=Se&&Se<=127999}var st;(function(Se){Se[Se.zwj=8205]="zwj",Se[Se.emojiVariantSelector=65039]="emojiVariantSelector",Se[Se.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.$Xf="\xA0";class at{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Ve(Be=>{function Ge(it){const ht=new Map;for(let wt=0;wt<it.length;wt+=2)ht.set(it[wt],it[wt+1]);return ht}function Le(it,ht){const wt=new Map(it);for(const[It,Bt]of ht)wt.set(It,Bt);return wt}function Qe(it,ht){if(!it)return ht;const wt=new Map;for(const[It,Bt]of it)ht.has(It)&&wt.set(It,Bt);return wt}const oe=this.c.value;let ue=Be.filter(it=>!it.startsWith("_")&&it in oe);ue.length===0&&(ue=["_default"]);let Ie;for(const it of ue){const ht=Ge(oe[it]);Ie=Qe(Ie,ht)}const Ke=Ge(oe._common),Re=Le(Ke,Ie);return new at(Re)})}static getInstance(Be){return at.d.get(Array.from(Be))}static{this.e=new O.$V(()=>Object.keys(at.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return at.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Yf=at;class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(Be){return ot.e().has(Be)}static get codePoints(){return ot.e()}}e.$Zf=ot}),define(ke[126],Ee([1,0,27,166,14]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.FuzzyScore=e.$pk=e.$ok=void 0,e.or=R,e.$qk=b,e.$rk=p,e.$sk=P,e.$tk=h,e.$uk=g,e.$vk=I,e.$wk=z,e.$xk=j,e.$yk=F,e.$zk=ne,e.$Bk=ce,e.$Ck=ie,e.$Dk=le;function R(...me){return function(Pe,Me){for(let je=0,q=me.length;je<q;je++){const W=me[je](Pe,Me);if(W)return W}return null}}e.$ok=M.bind(void 0,!1),e.$pk=M.bind(void 0,!0);function M(me,Pe,Me){if(!Me||Me.length<Pe.length)return null;let je;return me?je=L.$rf(Me,Pe):je=Me.indexOf(Pe)===0,je?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function b(me,Pe){const Me=Pe.toLowerCase().indexOf(me.toLowerCase());return Me===-1?null:[{start:Me,end:Me+me.length}]}function p(me,Pe){return E(me.toLowerCase(),Pe.toLowerCase(),0,0)}function E(me,Pe,Me,je){if(Me===me.length)return[];if(je===Pe.length)return null;if(me[Me]===Pe[je]){let q=null;return(q=E(me,Pe,Me+1,je+1))?r({start:je,end:je+1},q):null}return E(me,Pe,Me,je+1)}function A(me){return 97<=me&&me<=122}function P(me){return 65<=me&&me<=90}function $(me){return 48<=me&&me<=57}function S(me){return me===32||me===9||me===10||me===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>v.add(me.charCodeAt(0)));function a(me){return S(me)||v.has(me)}function m(me,Pe){return me===Pe||a(me)&&a(Pe)}const o=new Map;function n(me){if(o.has(me))return o.get(me);let Pe;const Me=(0,O.$mk)(me);return Me&&(Pe=Me),o.set(me,Pe),Pe}function i(me){return A(me)||P(me)||$(me)}function r(me,Pe){return Pe.length===0?Pe=[me]:me.end===Pe[0].start?Pe[0].start=me.start:Pe.unshift(me),Pe}function s(me,Pe){for(let Me=Pe;Me<me.length;Me++){const je=me.charCodeAt(Me);if(P(je)||$(je)||Me>0&&!i(me.charCodeAt(Me-1)))return Me}return me.length}function t(me,Pe,Me,je){if(Me===me.length)return[];if(je===Pe.length)return null;if(me[Me]!==Pe[je].toLowerCase())return null;{let q=null,W=je+1;for(q=t(me,Pe,Me+1,je+1);!q&&(W=s(Pe,W))<Pe.length;)q=t(me,Pe,Me+1,W),W++;return q===null?null:r({start:je,end:je+1},q)}}function f(me){let Pe=0,Me=0,je=0,q=0,W=0;for(let Fe=0;Fe<me.length;Fe++)W=me.charCodeAt(Fe),P(W)&&Pe++,A(W)&&Me++,i(W)&&je++,$(W)&&q++;const X=Pe/me.length,Q=Me/me.length,fe=je/me.length,we=q/me.length;return{upperPercent:X,lowerPercent:Q,alphaPercent:fe,numericPercent:we}}function d(me){const{upperPercent:Pe,lowerPercent:Me}=me;return Me===0&&Pe>.6}function l(me){const{upperPercent:Pe,lowerPercent:Me,alphaPercent:je,numericPercent:q}=me;return Me>.2&&Pe<.8&&je>.6&&q<.2}function c(me){let Pe=0,Me=0,je=0,q=0;for(let W=0;W<me.length;W++)je=me.charCodeAt(W),P(je)&&Pe++,A(je)&&Me++,S(je)&&q++;return(Pe===0||Me===0)&&q===0?me.length<=30:Pe<=5}function h(me,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!c(me))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Me=f(Pe);if(!l(Me)){if(!d(Me))return null;Pe=Pe.toLowerCase()}let je=null,q=0;for(me=me.toLowerCase();q<Pe.length&&(je=t(me,Pe,0,q))===null;)q=s(Pe,q+1);return je}function g(me,Pe,Me=!1){if(!Pe||Pe.length===0)return null;let je=null,q=0;for(me=me.toLowerCase(),Pe=Pe.toLowerCase();q<Pe.length&&(je=D(me,Pe,0,q,Me),je===null);)q=w(Pe,q+1);return je}function D(me,Pe,Me,je,q){let W=0;if(Me===me.length)return[];if(je===Pe.length)return null;if(!m(me.charCodeAt(Me),Pe.charCodeAt(je))){const fe=n(me.charCodeAt(Me));if(!fe)return null;for(let we=0;we<fe.length;we++)if(!m(fe[we],Pe.charCodeAt(je+we)))return null;W+=fe.length-1}let X=null,Q=je+W+1;if(X=D(me,Pe,Me+1,Q,q),!q)for(;!X&&(Q=w(Pe,Q))<Pe.length;)X=D(me,Pe,Me+1,Q,q),Q++;if(!X)return null;if(me.charCodeAt(Me)!==Pe.charCodeAt(je)){const fe=n(me.charCodeAt(Me));if(!fe)return X;for(let we=0;we<fe.length;we++)if(fe[we]!==Pe.charCodeAt(je+we))return X}return r({start:je,end:je+W+1},X)}function w(me,Pe){for(let Me=Pe;Me<me.length;Me++)if(a(me.charCodeAt(Me))||Me>0&&a(me.charCodeAt(Me-1)))return Me;return me.length}const k=R(e.$pk,h,b),y=R(e.$pk,h,p),C=new u.$Ec(1e4);function I(me,Pe,Me=!1){if(typeof me!="string"||typeof Pe!="string")return null;let je=C.get(me);je||(je=new RegExp(L.$_e(me),"i"),C.set(me,je));const q=je.exec(Pe);return q?[{start:q.index,end:q.index+q[0].length}]:Me?y(me,Pe):k(me,Pe)}function z(me,Pe){const Me=ce(me,me.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?F(Me):null}function j(me,Pe,Me,je,q,W){const X=Math.min(13,me.length);for(;Me<X;Me++){const Q=ce(me,Pe,Me,je,q,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,W]}function F(me){if(typeof me>"u")return[];const Pe=[],Me=me[1];for(let je=me.length-1;je>1;je--){const q=me[je]+Me,W=Pe[Pe.length-1];W&&W.end===q?W.end=q+1:Pe.push({start:q,end:q+1})}return Pe}const N=128;function T(){const me=[],Pe=[];for(let Me=0;Me<=N;Me++)Pe[Me]=0;for(let Me=0;Me<=N;Me++)me.push(Pe.slice(0));return me}function B(me){const Pe=[];for(let Me=0;Me<=me;Me++)Pe[Me]=0;return Pe}const H=B(2*N),Z=B(2*N),ee=T(),J=T(),Y=T(),re=!1;function te(me,Pe,Me,je,q){function W(Q,fe,we=" "){for(;Q.length<fe;)Q=we+Q;return Q}let X=` |   |${je.split("").map(Q=>W(Q,3)).join("|")}
`;for(let Q=0;Q<=Me;Q++)Q===0?X+=" |":X+=`${Pe[Q-1]}|`,X+=me[Q].slice(0,q+1).map(fe=>W(fe.toString(),3)).join("|")+`
`;return X}function pe(me,Pe,Me,je){me=me.substr(Pe),Me=Me.substr(je),console.log(te(J,me,me.length,Me,Me.length)),console.log(te(Y,me,me.length,Me,Me.length)),console.log(te(ee,me,me.length,Me,Me.length))}function Ce(me,Pe){if(Pe<0||Pe>=me.length)return!1;const Me=me.codePointAt(Pe);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Jf(Me)}}function x(me,Pe){if(Pe<0||Pe>=me.length)return!1;switch(me.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(me,Pe,Me){return Pe[me]!==Me[me]}function ne(me,Pe,Me,je,q,W,X=!1){for(;Pe<Me&&q<W;)me[Pe]===je[q]&&(X&&(H[Pe]=q),Pe+=1),q+=1;return Pe===Me}var be;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(be||(be={}));var De;(function(me){me.Default=[-100,0];function Pe(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}me.isDefault=Pe})(De||(e.FuzzyScore=De={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Me){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Me}}e.$Ak=ae;function ce(me,Pe,Me,je,q,W,X=ae.default){const Q=me.length>N?N:me.length,fe=je.length>N?N:je.length;if(Me>=Q||W>=fe||Q-Me>fe-W||!ne(Pe,Me,Q,q,W,fe,!0))return;se(Q,fe,Me,W,Pe,q);let we=1,Fe=1,Ve=Me,Ze=W;const tt=[!1];for(we=1,Ve=Me;Ve<Q;we++,Ve++){const Be=H[Ve],Ge=Z[Ve],Le=Ve+1<Q?Z[Ve+1]:fe;for(Fe=Be-W+1,Ze=Be;Ze<Le;Fe++,Ze++){let Qe=Number.MIN_SAFE_INTEGER,oe=!1;Ze<=Ge&&(Qe=K(me,Pe,Ve,Me,je,q,Ze,fe,W,ee[we-1][Fe-1]===0,tt));let ue=0;Qe!==Number.MAX_SAFE_INTEGER&&(oe=!0,ue=Qe+J[we-1][Fe-1]);const Ie=Ze>Be,Ke=Ie?J[we][Fe-1]+(ee[we][Fe-1]>0?-5:0):0,Re=Ze>Be+1&&ee[we][Fe-1]>0,it=Re?J[we][Fe-2]+(ee[we][Fe-2]>0?-5:0):0;if(Re&&(!Ie||it>=Ke)&&(!oe||it>=ue))J[we][Fe]=it,Y[we][Fe]=3,ee[we][Fe]=0;else if(Ie&&(!oe||Ke>=ue))J[we][Fe]=Ke,Y[we][Fe]=2,ee[we][Fe]=0;else if(oe)J[we][Fe]=ue,Y[we][Fe]=1,ee[we][Fe]=ee[we-1][Fe-1]+1;else throw new Error("not possible")}}if(re&&pe(me,Me,je,W),!tt[0]&&!X.firstMatchCanBeWeak)return;we--,Fe--;const st=[J[we][Fe],W];let at=0,ot=0;for(;we>=1;){let Be=Fe;do{const Ge=Y[we][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);at>1&&Pe[Me+we-1]===q[W+Fe-1]&&!U(Be+W-1,je,q)&&at+1>ee[we][Be]&&(Be=Fe),Be===Fe?at++:at=1,ot||(ot=Be),we--,Fe=Be-1,st.push(Fe)}fe===Q&&X.boostFullMatch&&(st[0]+=2);const Se=ot-Q;return st[0]-=Se,st}function se(me,Pe,Me,je,q,W){let X=me-1,Q=Pe-1;for(;X>=Me&&Q>=je;)q[X]===W[Q]&&(Z[X]=Q,X--),Q--}function K(me,Pe,Me,je,q,W,X,Q,fe,we,Fe){if(Pe[Me]!==W[X])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return X===Me-je?Ve=me[Me]===q[X]?7:5:U(X,q,W)&&(X===0||!U(X-1,q,W))?(Ve=me[Me]===q[X]?7:5,Ze=!0):Ce(W,X)&&(X===0||!Ce(W,X-1))?Ve=5:(Ce(W,X-1)||x(W,X-1))&&(Ve=5,Ze=!0),Ve>1&&Me===je&&(Fe[0]=!0),Ze||(Ze=U(X,q,W)||Ce(W,X-1)||x(W,X-1)),Me===je?X>fe&&(Ve-=Ze?3:5):we?Ve+=Ze?2:0:Ve+=Ze?0:1,X+1===Q&&(Ve-=Ze?3:5),Ve}function ie(me,Pe,Me,je,q,W,X){return de(me,Pe,Me,je,q,W,!0,X)}function le(me,Pe,Me,je,q,W,X){return de(me,Pe,Me,je,q,W,!1,X)}function de(me,Pe,Me,je,q,W,X,Q){let fe=ce(me,Pe,Me,je,q,W,Q);if(fe&&!X)return fe;if(me.length>=3){const we=Math.min(7,me.length-1);for(let Fe=Me+1;Fe<we;Fe++){const Ve=Ae(me,Fe);if(Ve){const Ze=ce(Ve,Ve.toLowerCase(),Me,je,q,W,Q);Ze&&(Ze[0]-=3,(!fe||Ze[0]>fe[0])&&(fe=Ze))}}}return fe}function Ae(me,Pe){if(Pe+1>=me.length)return;const Me=me[Pe],je=me[Pe+1];if(Me!==je)return me.slice(0,Pe)+je+Me+me.slice(Pe+2)}}),define(ke[56],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$fj=void 0,e.$bj=O,e.$cj=L,e.$dj=R,e.$ej=b,e.$gj=a;function O(o){return L(o,0)}function L(o,n){switch(typeof o){case"object":return o===null?R(349,n):Array.isArray(o)?p(o,n):E(o,n);case"string":return b(o,n);case"boolean":return M(o,n);case"number":return R(o,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(o,n){return(n<<5)-n+o|0}function M(o,n){return R(o?433:863,n)}function b(o,n){n=R(149417,n);for(let i=0,r=o.length;i<r;i++)n=R(o.charCodeAt(i),n);return n}function p(o,n){return n=R(104579,n),o.reduce((i,r)=>L(r,i),n)}function E(o,n){return n=R(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=b(r,i),L(o[r],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$fj=A;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function $(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function S(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function a(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=n.charCodeAt(0),d=0);;){let l=f;if(u.$uf(f))if(d+1<i){const c=n.charCodeAt(d+1);u.$vf(c)?(d++,l=u.$wf(f,c)):l=65533}else{t=f;break}else u.$vf(f)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)f=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,$(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,l,c,h;for(let g=0;g<80;g++)g<20?(l=s&t|~s&f,c=1518500249):g<40?(l=s^t^f,c=1859775393):g<60?(l=s&t|s&f|t&f,c=2400959708):(l=s^t^f,c=3395469782),h=$(r,5)+l+d+c+n.getUint32(g*4,!1)&4294967295,d=f,f=t,t=$(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$hj=m}),define(ke[39],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const R="error",M="warning",b="warn",p="info",E="ignore";function A($){return $?u.$qf(R,$)?L.Error:u.$qf(M,$)||u.$qf(b,$)?L.Warning:u.$qf(p,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function P($){switch($){case L.Error:return R;case L.Warning:return M;case L.Info:return p;default:return E}}L.toString=P}(O||(O={})),e.default=O}),define(ke[169],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;class L{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const v=S.charCodeAt(0),a=this.b.charCodeAt(this.c);return v-a}value(){return this.b[this.c]}}e.$pi=L;class R{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,O.$kf)(S,this.b,0,S.length,this.c,this.d):(0,O.$mf)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qi=R;class M{constructor(S=!0,v=!0){this.f=S,this.g=v}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let v=S.length-1;v>=0;v--,this.c--){const a=this.b.charCodeAt(v);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,O.$kf)(S,this.b,0,S.length,this.d,this.e):(0,O.$mf)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ri=M;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(S,v){this.f=S,this.g=v,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,O.$lf)(S,this.c.scheme);if(this.d[this.e]===2)return(0,O.$lf)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,O.$jf)(S,this.c.query);if(this.d[this.e]===5)return(0,O.$jf)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$si=p;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class P{static forUris(S=()=>!1,v=()=>!1){return new P(new p(S,v))}static forPaths(S=!1){return new P(new M(void 0,!S))}static forStrings(){return new P(new L)}static forConfigKeys(){return new P(new R)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,v){if(v){const a=v.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m,S)}else{const a=S.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m[0],m[1])}}set(S,v){const a=this.b.reset(S);let m;this.c||(this.c=new E,this.c.segment=a.value());const o=[];for(m=this.c;;){const i=a.cmp(m.segment);if(i>0)m.left||(m.left=new E,m.left.segment=a.value()),o.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new E,m.right.segment=a.value()),o.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new E,m.mid.segment=a.value()),o.push([0,m]),m=m.mid;else break}const n=m.value;m.value=v,m.key=S;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(S){return this.d(S)?.value}d(S){const v=this.b.reset(S);let a=this.c;for(;a;){const m=v.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else break}return a}has(S){const v=this.d(S);return!(v?.value===void 0&&v?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,v){const a=this.b.reset(S),m=[];let o=this.c;for(;o;){const n=a.cmp(o.segment);if(n>0)m.push([-1,o]),o=o.left;else if(n<0)m.push([1,o]),o=o.right;else if(a.hasNext())a.next(),m.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const v=this.b.reset(S);let a=this.c,m;for(;a;){const o=v.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(v.hasNext())v.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(S){return this.g(S,!1)}g(S,v){const a=this.b.reset(S);let m=this.c;for(;m;){const o=a.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this.h(m.mid):v?m.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[v,a]of this)S(a,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const v=[];return this.j(S,v),v[Symbol.iterator]()}j(S,v){S&&(S.left&&this.j(S.left,v),S.value&&v.push([S.key,S.value]),S.mid&&this.j(S.mid,v),S.right&&this.j(S.right,v))}_isBalanced(){const S=v=>{if(!v)return!0;const a=v.balanceFactor();return a<-1||a>1?!1:S(v.left)&&S(v.right)};return S(this.c)}}e.$ti=P}),define(ke[18],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=u,e.$2f=O,e.$3f=L,e.$4f=R,e.$5f=M,e.$6f=b,e.$7f=p,e.$8f=E,e.$9f=A,e.$0f=P,e.$$f=$,e.$_f=S,e.$ag=v,e.$bg=m,e.$cg=o,e.$dg=n,e.$eg=i,e.$fg=r;function u(s){return typeof s=="string"}function O(s){return Array.isArray(s)&&s.every(t=>u(t))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function R(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function M(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function p(s){return s===!0||s===!1}function E(s){return typeof s>"u"}function A(s){return!P(s)}function P(s){return E(s)||s===null}function $(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function S(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(P(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!L(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!P(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=L,e.$Ij=R;const O=Object.create(null);function L(M,b){if((0,u.$1f)(b)){const p=O[b];if(p===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=p}return O[M]=b,{id:M}}function R(){return O}}),define(ke[170],Ee([1,0,99]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=void 0,e.$Jj={add:(0,u.$Hj)("add",6e4),plus:(0,u.$Hj)("plus",6e4),gistNew:(0,u.$Hj)("gist-new",6e4),repoCreate:(0,u.$Hj)("repo-create",6e4),lightbulb:(0,u.$Hj)("lightbulb",60001),lightBulb:(0,u.$Hj)("light-bulb",60001),repo:(0,u.$Hj)("repo",60002),repoDelete:(0,u.$Hj)("repo-delete",60002),gistFork:(0,u.$Hj)("gist-fork",60003),repoForked:(0,u.$Hj)("repo-forked",60003),gitPullRequest:(0,u.$Hj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Hj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Hj)("record-keys",60005),keyboard:(0,u.$Hj)("keyboard",60005),tag:(0,u.$Hj)("tag",60006),gitPullRequestLabel:(0,u.$Hj)("git-pull-request-label",60006),tagAdd:(0,u.$Hj)("tag-add",60006),tagRemove:(0,u.$Hj)("tag-remove",60006),person:(0,u.$Hj)("person",60007),personFollow:(0,u.$Hj)("person-follow",60007),personOutline:(0,u.$Hj)("person-outline",60007),personFilled:(0,u.$Hj)("person-filled",60007),gitBranch:(0,u.$Hj)("git-branch",60008),gitBranchCreate:(0,u.$Hj)("git-branch-create",60008),gitBranchDelete:(0,u.$Hj)("git-branch-delete",60008),sourceControl:(0,u.$Hj)("source-control",60008),mirror:(0,u.$Hj)("mirror",60009),mirrorPublic:(0,u.$Hj)("mirror-public",60009),star:(0,u.$Hj)("star",60010),starAdd:(0,u.$Hj)("star-add",60010),starDelete:(0,u.$Hj)("star-delete",60010),starEmpty:(0,u.$Hj)("star-empty",60010),comment:(0,u.$Hj)("comment",60011),commentAdd:(0,u.$Hj)("comment-add",60011),alert:(0,u.$Hj)("alert",60012),warning:(0,u.$Hj)("warning",60012),search:(0,u.$Hj)("search",60013),searchSave:(0,u.$Hj)("search-save",60013),logOut:(0,u.$Hj)("log-out",60014),signOut:(0,u.$Hj)("sign-out",60014),logIn:(0,u.$Hj)("log-in",60015),signIn:(0,u.$Hj)("sign-in",60015),eye:(0,u.$Hj)("eye",60016),eyeUnwatch:(0,u.$Hj)("eye-unwatch",60016),eyeWatch:(0,u.$Hj)("eye-watch",60016),circleFilled:(0,u.$Hj)("circle-filled",60017),primitiveDot:(0,u.$Hj)("primitive-dot",60017),closeDirty:(0,u.$Hj)("close-dirty",60017),debugBreakpoint:(0,u.$Hj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Hj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Hj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Hj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Hj)("primitive-square",60018),edit:(0,u.$Hj)("edit",60019),pencil:(0,u.$Hj)("pencil",60019),info:(0,u.$Hj)("info",60020),issueOpened:(0,u.$Hj)("issue-opened",60020),gistPrivate:(0,u.$Hj)("gist-private",60021),gitForkPrivate:(0,u.$Hj)("git-fork-private",60021),lock:(0,u.$Hj)("lock",60021),mirrorPrivate:(0,u.$Hj)("mirror-private",60021),close:(0,u.$Hj)("close",60022),removeClose:(0,u.$Hj)("remove-close",60022),x:(0,u.$Hj)("x",60022),repoSync:(0,u.$Hj)("repo-sync",60023),sync:(0,u.$Hj)("sync",60023),clone:(0,u.$Hj)("clone",60024),desktopDownload:(0,u.$Hj)("desktop-download",60024),beaker:(0,u.$Hj)("beaker",60025),microscope:(0,u.$Hj)("microscope",60025),vm:(0,u.$Hj)("vm",60026),deviceDesktop:(0,u.$Hj)("device-desktop",60026),file:(0,u.$Hj)("file",60027),fileText:(0,u.$Hj)("file-text",60027),more:(0,u.$Hj)("more",60028),ellipsis:(0,u.$Hj)("ellipsis",60028),kebabHorizontal:(0,u.$Hj)("kebab-horizontal",60028),mailReply:(0,u.$Hj)("mail-reply",60029),reply:(0,u.$Hj)("reply",60029),organization:(0,u.$Hj)("organization",60030),organizationFilled:(0,u.$Hj)("organization-filled",60030),organizationOutline:(0,u.$Hj)("organization-outline",60030),newFile:(0,u.$Hj)("new-file",60031),fileAdd:(0,u.$Hj)("file-add",60031),newFolder:(0,u.$Hj)("new-folder",60032),fileDirectoryCreate:(0,u.$Hj)("file-directory-create",60032),trash:(0,u.$Hj)("trash",60033),trashcan:(0,u.$Hj)("trashcan",60033),history:(0,u.$Hj)("history",60034),clock:(0,u.$Hj)("clock",60034),folder:(0,u.$Hj)("folder",60035),fileDirectory:(0,u.$Hj)("file-directory",60035),symbolFolder:(0,u.$Hj)("symbol-folder",60035),logoGithub:(0,u.$Hj)("logo-github",60036),markGithub:(0,u.$Hj)("mark-github",60036),github:(0,u.$Hj)("github",60036),terminal:(0,u.$Hj)("terminal",60037),console:(0,u.$Hj)("console",60037),repl:(0,u.$Hj)("repl",60037),zap:(0,u.$Hj)("zap",60038),symbolEvent:(0,u.$Hj)("symbol-event",60038),error:(0,u.$Hj)("error",60039),stop:(0,u.$Hj)("stop",60039),variable:(0,u.$Hj)("variable",60040),symbolVariable:(0,u.$Hj)("symbol-variable",60040),array:(0,u.$Hj)("array",60042),symbolArray:(0,u.$Hj)("symbol-array",60042),symbolModule:(0,u.$Hj)("symbol-module",60043),symbolPackage:(0,u.$Hj)("symbol-package",60043),symbolNamespace:(0,u.$Hj)("symbol-namespace",60043),symbolObject:(0,u.$Hj)("symbol-object",60043),symbolMethod:(0,u.$Hj)("symbol-method",60044),symbolFunction:(0,u.$Hj)("symbol-function",60044),symbolConstructor:(0,u.$Hj)("symbol-constructor",60044),symbolBoolean:(0,u.$Hj)("symbol-boolean",60047),symbolNull:(0,u.$Hj)("symbol-null",60047),symbolNumeric:(0,u.$Hj)("symbol-numeric",60048),symbolNumber:(0,u.$Hj)("symbol-number",60048),symbolStructure:(0,u.$Hj)("symbol-structure",60049),symbolStruct:(0,u.$Hj)("symbol-struct",60049),symbolParameter:(0,u.$Hj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Hj)("symbol-type-parameter",60050),symbolKey:(0,u.$Hj)("symbol-key",60051),symbolText:(0,u.$Hj)("symbol-text",60051),symbolReference:(0,u.$Hj)("symbol-reference",60052),goToFile:(0,u.$Hj)("go-to-file",60052),symbolEnum:(0,u.$Hj)("symbol-enum",60053),symbolValue:(0,u.$Hj)("symbol-value",60053),symbolRuler:(0,u.$Hj)("symbol-ruler",60054),symbolUnit:(0,u.$Hj)("symbol-unit",60054),activateBreakpoints:(0,u.$Hj)("activate-breakpoints",60055),archive:(0,u.$Hj)("archive",60056),arrowBoth:(0,u.$Hj)("arrow-both",60057),arrowDown:(0,u.$Hj)("arrow-down",60058),arrowLeft:(0,u.$Hj)("arrow-left",60059),arrowRight:(0,u.$Hj)("arrow-right",60060),arrowSmallDown:(0,u.$Hj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Hj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Hj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Hj)("arrow-small-up",60064),arrowUp:(0,u.$Hj)("arrow-up",60065),bell:(0,u.$Hj)("bell",60066),bold:(0,u.$Hj)("bold",60067),book:(0,u.$Hj)("book",60068),bookmark:(0,u.$Hj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Hj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Hj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Hj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Hj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Hj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Hj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Hj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Hj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Hj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Hj)("briefcase",60076),broadcast:(0,u.$Hj)("broadcast",60077),browser:(0,u.$Hj)("browser",60078),bug:(0,u.$Hj)("bug",60079),calendar:(0,u.$Hj)("calendar",60080),caseSensitive:(0,u.$Hj)("case-sensitive",60081),check:(0,u.$Hj)("check",60082),checklist:(0,u.$Hj)("checklist",60083),chevronDown:(0,u.$Hj)("chevron-down",60084),chevronLeft:(0,u.$Hj)("chevron-left",60085),chevronRight:(0,u.$Hj)("chevron-right",60086),chevronUp:(0,u.$Hj)("chevron-up",60087),chromeClose:(0,u.$Hj)("chrome-close",60088),chromeMaximize:(0,u.$Hj)("chrome-maximize",60089),chromeMinimize:(0,u.$Hj)("chrome-minimize",60090),chromeRestore:(0,u.$Hj)("chrome-restore",60091),circleOutline:(0,u.$Hj)("circle-outline",60092),circle:(0,u.$Hj)("circle",60092),debugBreakpointUnverified:(0,u.$Hj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Hj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Hj)("circle-slash",60093),circuitBoard:(0,u.$Hj)("circuit-board",60094),clearAll:(0,u.$Hj)("clear-all",60095),clippy:(0,u.$Hj)("clippy",60096),closeAll:(0,u.$Hj)("close-all",60097),cloudDownload:(0,u.$Hj)("cloud-download",60098),cloudUpload:(0,u.$Hj)("cloud-upload",60099),code:(0,u.$Hj)("code",60100),collapseAll:(0,u.$Hj)("collapse-all",60101),colorMode:(0,u.$Hj)("color-mode",60102),commentDiscussion:(0,u.$Hj)("comment-discussion",60103),creditCard:(0,u.$Hj)("credit-card",60105),dash:(0,u.$Hj)("dash",60108),dashboard:(0,u.$Hj)("dashboard",60109),database:(0,u.$Hj)("database",60110),debugContinue:(0,u.$Hj)("debug-continue",60111),debugDisconnect:(0,u.$Hj)("debug-disconnect",60112),debugPause:(0,u.$Hj)("debug-pause",60113),debugRestart:(0,u.$Hj)("debug-restart",60114),debugStart:(0,u.$Hj)("debug-start",60115),debugStepInto:(0,u.$Hj)("debug-step-into",60116),debugStepOut:(0,u.$Hj)("debug-step-out",60117),debugStepOver:(0,u.$Hj)("debug-step-over",60118),debugStop:(0,u.$Hj)("debug-stop",60119),debug:(0,u.$Hj)("debug",60120),deviceCameraVideo:(0,u.$Hj)("device-camera-video",60121),deviceCamera:(0,u.$Hj)("device-camera",60122),deviceMobile:(0,u.$Hj)("device-mobile",60123),diffAdded:(0,u.$Hj)("diff-added",60124),diffIgnored:(0,u.$Hj)("diff-ignored",60125),diffModified:(0,u.$Hj)("diff-modified",60126),diffRemoved:(0,u.$Hj)("diff-removed",60127),diffRenamed:(0,u.$Hj)("diff-renamed",60128),diff:(0,u.$Hj)("diff",60129),diffSidebyside:(0,u.$Hj)("diff-sidebyside",60129),discard:(0,u.$Hj)("discard",60130),editorLayout:(0,u.$Hj)("editor-layout",60131),emptyWindow:(0,u.$Hj)("empty-window",60132),exclude:(0,u.$Hj)("exclude",60133),extensions:(0,u.$Hj)("extensions",60134),eyeClosed:(0,u.$Hj)("eye-closed",60135),fileBinary:(0,u.$Hj)("file-binary",60136),fileCode:(0,u.$Hj)("file-code",60137),fileMedia:(0,u.$Hj)("file-media",60138),filePdf:(0,u.$Hj)("file-pdf",60139),fileSubmodule:(0,u.$Hj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Hj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Hj)("file-symlink-file",60142),fileZip:(0,u.$Hj)("file-zip",60143),files:(0,u.$Hj)("files",60144),filter:(0,u.$Hj)("filter",60145),flame:(0,u.$Hj)("flame",60146),foldDown:(0,u.$Hj)("fold-down",60147),foldUp:(0,u.$Hj)("fold-up",60148),fold:(0,u.$Hj)("fold",60149),folderActive:(0,u.$Hj)("folder-active",60150),folderOpened:(0,u.$Hj)("folder-opened",60151),gear:(0,u.$Hj)("gear",60152),gift:(0,u.$Hj)("gift",60153),gistSecret:(0,u.$Hj)("gist-secret",60154),gist:(0,u.$Hj)("gist",60155),gitCommit:(0,u.$Hj)("git-commit",60156),gitCompare:(0,u.$Hj)("git-compare",60157),compareChanges:(0,u.$Hj)("compare-changes",60157),gitMerge:(0,u.$Hj)("git-merge",60158),githubAction:(0,u.$Hj)("github-action",60159),githubAlt:(0,u.$Hj)("github-alt",60160),globe:(0,u.$Hj)("globe",60161),grabber:(0,u.$Hj)("grabber",60162),graph:(0,u.$Hj)("graph",60163),gripper:(0,u.$Hj)("gripper",60164),heart:(0,u.$Hj)("heart",60165),home:(0,u.$Hj)("home",60166),horizontalRule:(0,u.$Hj)("horizontal-rule",60167),hubot:(0,u.$Hj)("hubot",60168),inbox:(0,u.$Hj)("inbox",60169),issueReopened:(0,u.$Hj)("issue-reopened",60171),issues:(0,u.$Hj)("issues",60172),italic:(0,u.$Hj)("italic",60173),jersey:(0,u.$Hj)("jersey",60174),json:(0,u.$Hj)("json",60175),kebabVertical:(0,u.$Hj)("kebab-vertical",60176),key:(0,u.$Hj)("key",60177),law:(0,u.$Hj)("law",60178),lightbulbAutofix:(0,u.$Hj)("lightbulb-autofix",60179),linkExternal:(0,u.$Hj)("link-external",60180),link:(0,u.$Hj)("link",60181),listOrdered:(0,u.$Hj)("list-ordered",60182),listUnordered:(0,u.$Hj)("list-unordered",60183),liveShare:(0,u.$Hj)("live-share",60184),loading:(0,u.$Hj)("loading",60185),location:(0,u.$Hj)("location",60186),mailRead:(0,u.$Hj)("mail-read",60187),mail:(0,u.$Hj)("mail",60188),markdown:(0,u.$Hj)("markdown",60189),megaphone:(0,u.$Hj)("megaphone",60190),mention:(0,u.$Hj)("mention",60191),milestone:(0,u.$Hj)("milestone",60192),gitPullRequestMilestone:(0,u.$Hj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Hj)("mortar-board",60193),move:(0,u.$Hj)("move",60194),multipleWindows:(0,u.$Hj)("multiple-windows",60195),mute:(0,u.$Hj)("mute",60196),noNewline:(0,u.$Hj)("no-newline",60197),note:(0,u.$Hj)("note",60198),octoface:(0,u.$Hj)("octoface",60199),openPreview:(0,u.$Hj)("open-preview",60200),package:(0,u.$Hj)("package",60201),paintcan:(0,u.$Hj)("paintcan",60202),pin:(0,u.$Hj)("pin",60203),play:(0,u.$Hj)("play",60204),run:(0,u.$Hj)("run",60204),plug:(0,u.$Hj)("plug",60205),preserveCase:(0,u.$Hj)("preserve-case",60206),preview:(0,u.$Hj)("preview",60207),project:(0,u.$Hj)("project",60208),pulse:(0,u.$Hj)("pulse",60209),question:(0,u.$Hj)("question",60210),quote:(0,u.$Hj)("quote",60211),radioTower:(0,u.$Hj)("radio-tower",60212),reactions:(0,u.$Hj)("reactions",60213),references:(0,u.$Hj)("references",60214),refresh:(0,u.$Hj)("refresh",60215),regex:(0,u.$Hj)("regex",60216),remoteExplorer:(0,u.$Hj)("remote-explorer",60217),remote:(0,u.$Hj)("remote",60218),remove:(0,u.$Hj)("remove",60219),replaceAll:(0,u.$Hj)("replace-all",60220),replace:(0,u.$Hj)("replace",60221),repoClone:(0,u.$Hj)("repo-clone",60222),repoForcePush:(0,u.$Hj)("repo-force-push",60223),repoPull:(0,u.$Hj)("repo-pull",60224),repoPush:(0,u.$Hj)("repo-push",60225),report:(0,u.$Hj)("report",60226),requestChanges:(0,u.$Hj)("request-changes",60227),rocket:(0,u.$Hj)("rocket",60228),rootFolderOpened:(0,u.$Hj)("root-folder-opened",60229),rootFolder:(0,u.$Hj)("root-folder",60230),rss:(0,u.$Hj)("rss",60231),ruby:(0,u.$Hj)("ruby",60232),saveAll:(0,u.$Hj)("save-all",60233),saveAs:(0,u.$Hj)("save-as",60234),save:(0,u.$Hj)("save",60235),screenFull:(0,u.$Hj)("screen-full",60236),screenNormal:(0,u.$Hj)("screen-normal",60237),searchStop:(0,u.$Hj)("search-stop",60238),server:(0,u.$Hj)("server",60240),settingsGear:(0,u.$Hj)("settings-gear",60241),settings:(0,u.$Hj)("settings",60242),shield:(0,u.$Hj)("shield",60243),smiley:(0,u.$Hj)("smiley",60244),sortPrecedence:(0,u.$Hj)("sort-precedence",60245),splitHorizontal:(0,u.$Hj)("split-horizontal",60246),splitVertical:(0,u.$Hj)("split-vertical",60247),squirrel:(0,u.$Hj)("squirrel",60248),starFull:(0,u.$Hj)("star-full",60249),starHalf:(0,u.$Hj)("star-half",60250),symbolClass:(0,u.$Hj)("symbol-class",60251),symbolColor:(0,u.$Hj)("symbol-color",60252),symbolConstant:(0,u.$Hj)("symbol-constant",60253),symbolEnumMember:(0,u.$Hj)("symbol-enum-member",60254),symbolField:(0,u.$Hj)("symbol-field",60255),symbolFile:(0,u.$Hj)("symbol-file",60256),symbolInterface:(0,u.$Hj)("symbol-interface",60257),symbolKeyword:(0,u.$Hj)("symbol-keyword",60258),symbolMisc:(0,u.$Hj)("symbol-misc",60259),symbolOperator:(0,u.$Hj)("symbol-operator",60260),symbolProperty:(0,u.$Hj)("symbol-property",60261),wrench:(0,u.$Hj)("wrench",60261),wrenchSubaction:(0,u.$Hj)("wrench-subaction",60261),symbolSnippet:(0,u.$Hj)("symbol-snippet",60262),tasklist:(0,u.$Hj)("tasklist",60263),telescope:(0,u.$Hj)("telescope",60264),textSize:(0,u.$Hj)("text-size",60265),threeBars:(0,u.$Hj)("three-bars",60266),thumbsdown:(0,u.$Hj)("thumbsdown",60267),thumbsup:(0,u.$Hj)("thumbsup",60268),tools:(0,u.$Hj)("tools",60269),triangleDown:(0,u.$Hj)("triangle-down",60270),triangleLeft:(0,u.$Hj)("triangle-left",60271),triangleRight:(0,u.$Hj)("triangle-right",60272),triangleUp:(0,u.$Hj)("triangle-up",60273),twitter:(0,u.$Hj)("twitter",60274),unfold:(0,u.$Hj)("unfold",60275),unlock:(0,u.$Hj)("unlock",60276),unmute:(0,u.$Hj)("unmute",60277),unverified:(0,u.$Hj)("unverified",60278),verified:(0,u.$Hj)("verified",60279),versions:(0,u.$Hj)("versions",60280),vmActive:(0,u.$Hj)("vm-active",60281),vmOutline:(0,u.$Hj)("vm-outline",60282),vmRunning:(0,u.$Hj)("vm-running",60283),watch:(0,u.$Hj)("watch",60284),whitespace:(0,u.$Hj)("whitespace",60285),wholeWord:(0,u.$Hj)("whole-word",60286),window:(0,u.$Hj)("window",60287),wordWrap:(0,u.$Hj)("word-wrap",60288),zoomIn:(0,u.$Hj)("zoom-in",60289),zoomOut:(0,u.$Hj)("zoom-out",60290),listFilter:(0,u.$Hj)("list-filter",60291),listFlat:(0,u.$Hj)("list-flat",60292),listSelection:(0,u.$Hj)("list-selection",60293),selection:(0,u.$Hj)("selection",60293),listTree:(0,u.$Hj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Hj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Hj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Hj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Hj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Hj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Hj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Hj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Hj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Hj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Hj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Hj)("symbol-string",60301),debugReverseContinue:(0,u.$Hj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Hj)("debug-step-back",60303),debugRestartFrame:(0,u.$Hj)("debug-restart-frame",60304),debugAlt:(0,u.$Hj)("debug-alt",60305),callIncoming:(0,u.$Hj)("call-incoming",60306),callOutgoing:(0,u.$Hj)("call-outgoing",60307),menu:(0,u.$Hj)("menu",60308),expandAll:(0,u.$Hj)("expand-all",60309),feedback:(0,u.$Hj)("feedback",60310),gitPullRequestReviewer:(0,u.$Hj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Hj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Hj)("ungroup-by-ref-type",60312),account:(0,u.$Hj)("account",60313),gitPullRequestAssignee:(0,u.$Hj)("git-pull-request-assignee",60313),bellDot:(0,u.$Hj)("bell-dot",60314),debugConsole:(0,u.$Hj)("debug-console",60315),library:(0,u.$Hj)("library",60316),output:(0,u.$Hj)("output",60317),runAll:(0,u.$Hj)("run-all",60318),syncIgnored:(0,u.$Hj)("sync-ignored",60319),pinned:(0,u.$Hj)("pinned",60320),githubInverted:(0,u.$Hj)("github-inverted",60321),serverProcess:(0,u.$Hj)("server-process",60322),serverEnvironment:(0,u.$Hj)("server-environment",60323),pass:(0,u.$Hj)("pass",60324),issueClosed:(0,u.$Hj)("issue-closed",60324),stopCircle:(0,u.$Hj)("stop-circle",60325),playCircle:(0,u.$Hj)("play-circle",60326),record:(0,u.$Hj)("record",60327),debugAltSmall:(0,u.$Hj)("debug-alt-small",60328),vmConnect:(0,u.$Hj)("vm-connect",60329),cloud:(0,u.$Hj)("cloud",60330),merge:(0,u.$Hj)("merge",60331),export:(0,u.$Hj)("export",60332),graphLeft:(0,u.$Hj)("graph-left",60333),magnet:(0,u.$Hj)("magnet",60334),notebook:(0,u.$Hj)("notebook",60335),redo:(0,u.$Hj)("redo",60336),checkAll:(0,u.$Hj)("check-all",60337),pinnedDirty:(0,u.$Hj)("pinned-dirty",60338),passFilled:(0,u.$Hj)("pass-filled",60339),circleLargeFilled:(0,u.$Hj)("circle-large-filled",60340),circleLarge:(0,u.$Hj)("circle-large",60341),circleLargeOutline:(0,u.$Hj)("circle-large-outline",60341),combine:(0,u.$Hj)("combine",60342),gather:(0,u.$Hj)("gather",60342),table:(0,u.$Hj)("table",60343),variableGroup:(0,u.$Hj)("variable-group",60344),typeHierarchy:(0,u.$Hj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Hj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Hj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Hj)("git-pull-request-create",60348),runAbove:(0,u.$Hj)("run-above",60349),runBelow:(0,u.$Hj)("run-below",60350),notebookTemplate:(0,u.$Hj)("notebook-template",60351),debugRerun:(0,u.$Hj)("debug-rerun",60352),workspaceTrusted:(0,u.$Hj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Hj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Hj)("workspace-unknown",60355),terminalCmd:(0,u.$Hj)("terminal-cmd",60356),terminalDebian:(0,u.$Hj)("terminal-debian",60357),terminalLinux:(0,u.$Hj)("terminal-linux",60358),terminalPowershell:(0,u.$Hj)("terminal-powershell",60359),terminalTmux:(0,u.$Hj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Hj)("terminal-ubuntu",60361),terminalBash:(0,u.$Hj)("terminal-bash",60362),arrowSwap:(0,u.$Hj)("arrow-swap",60363),copy:(0,u.$Hj)("copy",60364),personAdd:(0,u.$Hj)("person-add",60365),filterFilled:(0,u.$Hj)("filter-filled",60366),wand:(0,u.$Hj)("wand",60367),debugLineByLine:(0,u.$Hj)("debug-line-by-line",60368),inspect:(0,u.$Hj)("inspect",60369),layers:(0,u.$Hj)("layers",60370),layersDot:(0,u.$Hj)("layers-dot",60371),layersActive:(0,u.$Hj)("layers-active",60372),compass:(0,u.$Hj)("compass",60373),compassDot:(0,u.$Hj)("compass-dot",60374),compassActive:(0,u.$Hj)("compass-active",60375),azure:(0,u.$Hj)("azure",60376),issueDraft:(0,u.$Hj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Hj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Hj)("git-pull-request-draft",60379),debugAll:(0,u.$Hj)("debug-all",60380),debugCoverage:(0,u.$Hj)("debug-coverage",60381),runErrors:(0,u.$Hj)("run-errors",60382),folderLibrary:(0,u.$Hj)("folder-library",60383),debugContinueSmall:(0,u.$Hj)("debug-continue-small",60384),beakerStop:(0,u.$Hj)("beaker-stop",60385),graphLine:(0,u.$Hj)("graph-line",60386),graphScatter:(0,u.$Hj)("graph-scatter",60387),pieChart:(0,u.$Hj)("pie-chart",60388),bracket:(0,u.$Hj)("bracket",60175),bracketDot:(0,u.$Hj)("bracket-dot",60389),bracketError:(0,u.$Hj)("bracket-error",60390),lockSmall:(0,u.$Hj)("lock-small",60391),azureDevops:(0,u.$Hj)("azure-devops",60392),verifiedFilled:(0,u.$Hj)("verified-filled",60393),newline:(0,u.$Hj)("newline",60394),layout:(0,u.$Hj)("layout",60395),layoutActivitybarLeft:(0,u.$Hj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Hj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Hj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Hj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Hj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Hj)("layout-panel-right",60401),layoutPanel:(0,u.$Hj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Hj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Hj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Hj)("layout-statusbar",60405),layoutMenubar:(0,u.$Hj)("layout-menubar",60406),layoutCentered:(0,u.$Hj)("layout-centered",60407),target:(0,u.$Hj)("target",60408),indent:(0,u.$Hj)("indent",60409),recordSmall:(0,u.$Hj)("record-small",60410),errorSmall:(0,u.$Hj)("error-small",60411),terminalDecorationError:(0,u.$Hj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Hj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Hj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Hj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Hj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Hj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Hj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Hj)("layout-sidebar-left-off",60418),blank:(0,u.$Hj)("blank",60419),heartFilled:(0,u.$Hj)("heart-filled",60420),map:(0,u.$Hj)("map",60421),mapHorizontal:(0,u.$Hj)("map-horizontal",60421),foldHorizontal:(0,u.$Hj)("fold-horizontal",60421),mapFilled:(0,u.$Hj)("map-filled",60422),mapHorizontalFilled:(0,u.$Hj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Hj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Hj)("circle-small",60423),bellSlash:(0,u.$Hj)("bell-slash",60424),bellSlashDot:(0,u.$Hj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Hj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Hj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Hj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Hj)("search-fuzzy",60429),commentDraft:(0,u.$Hj)("comment-draft",60430),send:(0,u.$Hj)("send",60431),sparkle:(0,u.$Hj)("sparkle",60432),insert:(0,u.$Hj)("insert",60433),mic:(0,u.$Hj)("mic",60434),thumbsdownFilled:(0,u.$Hj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Hj)("thumbsup-filled",60436),coffee:(0,u.$Hj)("coffee",60437),snake:(0,u.$Hj)("snake",60438),game:(0,u.$Hj)("game",60439),vr:(0,u.$Hj)("vr",60440),chip:(0,u.$Hj)("chip",60441),piano:(0,u.$Hj)("piano",60442),music:(0,u.$Hj)("music",60443),micFilled:(0,u.$Hj)("mic-filled",60444),repoFetch:(0,u.$Hj)("repo-fetch",60445),copilot:(0,u.$Hj)("copilot",60446),lightbulbSparkle:(0,u.$Hj)("lightbulb-sparkle",60447),robot:(0,u.$Hj)("robot",60448),sparkleFilled:(0,u.$Hj)("sparkle-filled",60449),diffSingle:(0,u.$Hj)("diff-single",60450),diffMultiple:(0,u.$Hj)("diff-multiple",60451),surroundWith:(0,u.$Hj)("surround-with",60452),share:(0,u.$Hj)("share",60453),gitStash:(0,u.$Hj)("git-stash",60454),gitStashApply:(0,u.$Hj)("git-stash-apply",60455),gitStashPop:(0,u.$Hj)("git-stash-pop",60456),vscode:(0,u.$Hj)("vscode",60457),vscodeInsiders:(0,u.$Hj)("vscode-insiders",60458),codeOss:(0,u.$Hj)("code-oss",60459),runCoverage:(0,u.$Hj)("run-coverage",60460),runAllCoverage:(0,u.$Hj)("run-all-coverage",60461),coverage:(0,u.$Hj)("coverage",60462),githubProject:(0,u.$Hj)("github-project",60463),mapVertical:(0,u.$Hj)("map-vertical",60464),foldVertical:(0,u.$Hj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Hj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Hj)("fold-vertical-filled",60465)}}),define(ke[78],Ee([1,0,99,170]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=void 0,e.$Kj=L;function L(){return Object.values(e.$Mj)}e.$Lj={dialogError:(0,u.$Hj)("dialog-error","error"),dialogWarning:(0,u.$Hj)("dialog-warning","warning"),dialogInfo:(0,u.$Hj)("dialog-info","info"),dialogClose:(0,u.$Hj)("dialog-close","close"),treeItemExpanded:(0,u.$Hj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Hj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Hj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Hj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Hj)("tree-item-loading","loading"),menuSelection:(0,u.$Hj)("menu-selection","check"),menuSubmenu:(0,u.$Hj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Hj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Hj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Hj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Hj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Hj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Hj)("toolbar-more","more"),quickInputBack:(0,u.$Hj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Hj)("drop-down-button",60084),symbolCustomColor:(0,u.$Hj)("symbol-customcolor",60252),exportIcon:(0,u.$Hj)("export",60332),workspaceUnspecified:(0,u.$Hj)("workspace-unspecified",60355),newLine:(0,u.$Hj)("newline",60394),thumbsDownFilled:(0,u.$Hj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Hj)("thumbsup-filled",60436),gitFetch:(0,u.$Hj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Hj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Hj)("debug-breakpoint-pending",60377)},e.$Mj={...O.$Jj,...e.$Lj}}),define(ke[24],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=O,e.$Un=L,e.$Vn=M,e.$Wn=p,e.$Xn=E,e.$Yn=A,e.$Zn=P,e.$1n=$,e.$2n=S,e.$3n=v,e.$4n=a,e.$5n=m;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?O(r):r}),n}function L(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(R.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$4f)(s)&&n.push(s)}}return o}const R=Object.prototype.hasOwnProperty;function M(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,u.$0f)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,u.$3f)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)R.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function p(o,n,i=!0){return(0,u.$3f)(o)?((0,u.$3f)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,u.$3f)(o[r])&&(0,u.$3f)(n[r])?p(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function E(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!E(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!E(s,t))return!1;for(i=0;i<s.length;i++)if(!E(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,u.$3f)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function P(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];E(t,f)||(i[s]=f)}),i}function $(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function S(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function a(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function m(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ke[57],Ee([1,0,78]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Nj=L;var O;(function(M){function b(p){return p&&typeof p=="object"&&typeof p.id=="string"}M.isThemeColor=b})(O||(e.ThemeColor=O={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function p(n){const i=b.exec(n.id);if(!i)return p(u.$Mj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}M.asClassNameArray=p;function E(n){return p(n).join(" ")}M.asClassName=E;function A(n){return"."+p(n).join(".")}M.asCSSSelector=A;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}M.isThemeIcon=P;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function S(n){const i=$.exec(n);if(!i)return;const[,r]=i;return{id:r}}M.fromString=S;function v(n){return{id:n}}M.fromId=v;function a(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}M.modify=a;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=m;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[171],Ee([1,0,126,14,57]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=p,e.$Fk=A,e.$Gk=$,e.$Hk=S,e.$Ik=a,e.$Jk=m;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function p(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${M.source}`,"g");function A(o){return o.replace(E,n=>`\\${n}`)}const P=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(P,(n,i,r,s)=>r?n:i||s||"")}function S(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(o){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=v.lastIndex,t=v.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let d=0;d<f.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$vk)(o,r,i);const t=(0,O.$0e)(r," "),f=r.length-t.length,d=(0,u.$vk)(o,t,i);if(d)for(const l of d){const c=s[l.start+f]+f;l.start+=c,l.end+=c}return d}}),define(ke[127],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Xe=O,e.$Ye=L;var u;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function O(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=O;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return u.test(L)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let p=0;p<b.length;p++)b[p]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,E="";return E+=M[R[p++]],E+=M[R[p++]],E+=M[R[p++]],E+=M[R[p++]],E+="-",E+=M[R[p++]],E+=M[R[p++]],E+="-",E+=M[R[p++]],E+=M[R[p++]],E+="-",E+=M[R[p++]],E+=M[R[p++]],E+="-",E+=M[R[p++]],E+=M[R[p++]],E+=M[R[p++]],E+=M[R[p++]],E+=M[R[p++]],E+=M[R[p++]],E}}()}),define(ke[172],Ee([1,0,19,45,30]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Ft=void 0,e.$Dt=R,e.$Et=M,e.$Gt=E;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function M(P,$,S){const v={id:(0,L.$Jg)(),name:P,uri:$,data:S};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let $=0;for(const S of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const S=[...this.a.keys()];return O.Iterable.some(this,([v,a])=>a.asFile())&&S.push("files"),A(p($),S)}get($){return this.a.get(this.b($))?.[0]}append($,S){const v=this.a.get($);v?v.push(S):this.a.set(this.b($),[S])}replace($,S){this.a.set(this.b($),[S])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,S]of this.a)for(const v of S)yield[$,v]}b($){return p($)}}e.$Ft=b;function p(P){return P.toLowerCase()}function E(P,$){return A(p(P),$.map(p))}function A(P,$){if(P==="*/*")return $.length>0;if($.includes(P))return!0;const S=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[v,a,m]=S;return m==="*"?$.some(o=>o.startsWith(a+"/")):!1}e.$Ht=Object.freeze({create:P=>(0,u.$Mb)(P.map($=>$.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Ht.split(P).filter($=>!$.startsWith("#"))})}),define(ke[173],Ee([1,0,63]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=O,e.$Ng=R;function O(b,p,E,A=1){let P=!1;return new Promise($=>{const S=setTimeout(()=>{if(!P)return P=!0,$(0)},E);L(b,p,A,v=>{if(!P)return P=!0,clearTimeout(S),$(v)})})}function L(b,p,E,A){if(p===0)return A(0);const P=new u.Socket;P.once("connect",()=>(M(P),L(b+E,p-1,E,A))),P.once("data",()=>{}),P.once("error",$=>(M(P),$.code!=="ECONNREFUSED"?L(b+E,p-1,E,A):A(b))),P.connect(b,"127.0.0.1")}e.$Mg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,p,E,A="127.0.0.1"){let P=!1,$,S=1;const v=u.createServer({pauseOnConnect:!0});function a(m,o){P||(P=!0,v.removeAllListeners(),v.close(),$&&clearTimeout($),o(m))}return new Promise(m=>{$=setTimeout(()=>{a(0,m)},E),v.on("listening",()=>{a(b,m)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<p?(b++,S++,v.listen(b,A)):a(0,m)}),v.on("close",()=>{a(0,m)}),v.listen(b,A)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(p){console.error(p)}}}),define(ke[128],Ee([1,0,127]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=void 0;class O{constructor(b){const p=(0,u.$Xe)(b);this.c=p,this.a=O.d(p),this.b=new Map}static d(b){const p=new Uint8Array(256);return p.fill(b),p}set(b,p){const E=(0,u.$Xe)(p);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$vt=O;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new O(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$wt=R}),define(ke[174],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=O;var u;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function O(L){let R=0,M=0,b=0,p=0;for(let E=0,A=L.length;E<A;E++){const P=L.charCodeAt(E);P===13?(R===0&&(M=E),R++,E+1<A&&L.charCodeAt(E+1)===10?(p|=2,E++):p|=3,b=E+1):P===10&&(p|=1,R===0&&(M=E),R++,b=E+1)}return R===0&&(M=L.length),[R,M,L.length-b,p]}}),define(ke[50],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0;class u{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new u(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return u.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return u.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return u.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,b=R.lineNumber|0;if(M===b){const p=L.column|0,E=R.column|0;return p-E}return M-b}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new u(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$gt=u}),define(ke[29],Ee([1,0,50]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=void 0;class O{constructor(R,M,b,p){R>b||R===b&&M>p?(this.startLineNumber=b,this.startColumn=p,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=b,this.endColumn=p)}isEmpty(){return O.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return O.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return O.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return O.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return O.plusRange(this,R)}static plusRange(R,M){let b,p,E,A;return M.startLineNumber<R.startLineNumber?(b=M.startLineNumber,p=M.startColumn):M.startLineNumber===R.startLineNumber?(b=M.startLineNumber,p=Math.min(M.startColumn,R.startColumn)):(b=R.startLineNumber,p=R.startColumn),M.endLineNumber>R.endLineNumber?(E=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(E=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(E=R.endLineNumber,A=R.endColumn),new O(b,p,E,A)}intersectRanges(R){return O.intersectRanges(this,R)}static intersectRanges(R,M){let b=R.startLineNumber,p=R.startColumn,E=R.endLineNumber,A=R.endColumn;const P=M.startLineNumber,$=M.startColumn,S=M.endLineNumber,v=M.endColumn;return b<P?(b=P,p=$):b===P&&(p=Math.max(p,$)),E>S?(E=S,A=v):E===S&&(A=Math.min(A,v)),b>E||b===E&&p>A?null:new O(b,p,E,A)}equalsRange(R){return O.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(R){return new u.$gt(R.endLineNumber,R.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(R){return new u.$gt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new O(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new O(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(R){return new O(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(R){return new O(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new O(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new O(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new O(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const E=R.startLineNumber|0,A=M.startLineNumber|0;if(E===A){const P=R.startColumn|0,$=M.startColumn|0;if(P===$){const S=R.endLineNumber|0,v=M.endLineNumber|0;if(S===v){const a=R.endColumn|0,m=M.endColumn|0;return a-m}return S-v}return P-$}return E-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ht=O}),define(ke[175],Ee([1,0,29]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0;class O{static insert(R,M){return{range:new u.$ht(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$it=O}),define(ke[176],Ee([1,0,50,29]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends O.$ht{constructor(b,p,E,A){super(b,p,E,A),this.selectionStartLineNumber=b,this.selectionStartColumn=p,this.positionLineNumber=E,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,p){return b.selectionStartLineNumber===p.selectionStartLineNumber&&b.selectionStartColumn===p.selectionStartColumn&&b.positionLineNumber===p.positionLineNumber&&b.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,p){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,p):new R(b,p,this.startLineNumber,this.startColumn)}getPosition(){return new u.$gt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$gt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,p){return this.getDirection()===0?new R(b,p,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,p)}static fromPositions(b,p=b){return new R(b.lineNumber,b.column,p.lineNumber,p.column)}static fromRange(b,p){return p===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,p){if(b&&!p||!b&&p)return!1;if(!b&&!p)return!0;if(b.length!==p.length)return!1;for(let E=0,A=b.length;E<A;E++)if(!this.selectionsEqual(b[E],p[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,p,E,A,P){return P===0?new R(b,p,E,A):new R(E,A,b,p)}}e.$jt=R}),define(ke[177],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Ee([1,0,27,128]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.WordCharacterClass=void 0,e.$yt=b;var L;(function(p){p[p.Regular=0]="Regular",p[p.Whitespace=1]="Whitespace",p[p.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends O.$vt{constructor(E,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,$=E.length;P<$;P++)this.set(E.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(E,A){let P=null;for(const $ of this.h(E)){if($.index>A)break;P=$}return P}findNextIntlWordAtOrAfterOffset(E,A){for(const P of this.h(E))if(!(P.index<A))return P;return null}h(E){return this.e?this.f===E?this.g:(this.f=E,this.g=this.j(this.e.segment(E)),this.g):[]}j(E){const A=[];for(const P of E)this.k(P)&&A.push(P);return A}k(E){return!!E.isWordLike}}e.$xt=R;const M=new u.$Ec(10);function b(p,E){const A=`${p}/${E.join(",")}`;let P=M.get(A);return P||(P=new R(p,E),M.set(A,P)),P}}),define(ke[129],Ee([1,0,45,3,75]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=void 0,e.$Us=M,e.$Vs=p,e.$Ws=E,e.$Ss="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Ss)P.indexOf(S)>=0||($+="\\"+S);return $+="\\s]+)",new RegExp($,"g")}e.$Ts=R();function M(P){let $=e.$Ts;if(P&&P instanceof RegExp)if(P.global)$=P;else{let S="g";P.ignoreCase&&(S+="i"),P.multiline&&(S+="m"),P.unicode&&(S+="u"),$=new RegExp(P.source,S)}return $.lastIndex=0,$}const b=new L.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(P){const $=b.unshift(P);return(0,O.$Sc)($)}function E(P,$,S,v,a){if($=M($),a||(a=u.Iterable.first(b)),S.length>a.maxLen){let r=P-a.maxLen/2;return r<0?r=0:v+=r,S=S.substring(r,P+a.maxLen/2),E(P,$,S,v,a)}const m=Date.now(),o=P-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=o-a.windowSize*r;$.lastIndex=Math.max(0,s);const t=A($,S,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return $.lastIndex=0,r}return null}function A(P,$,S,v){let a;for(;a=P.exec($);){const m=a.index||0;if(m<=S&&P.lastIndex>=S)return a;if(v>0&&m>v)return null}return null}}),define(ke[179],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=e.IndentAction=void 0;var u;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let p=0,E=b.notIn.length;p<E;p++)switch(b.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,p){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset(p-2),A=b.getStandardTokenType(E);return this.isOK(A)}g(b,p){for(let E=b;E<=p;E++){const A=String.fromCharCode(E);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$0t=O;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of b)R(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),R(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),R(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),R(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&R(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$$t=L;function R(M,b,p){M.has(b)?M.get(b).push(p):M.set(b,[p])}}),define(ke[180],Ee([1,0,128]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H2=e.$G2=e.State=void 0,e.$I2=$;var O;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class L{constructor(v,a,m){const o=new Uint8Array(v*a);for(let n=0,i=v*a;n<i;n++)o[n]=m;this.a=o,this.rows=v,this.cols=a}get(v,a){return this.a[v*this.cols+a]}set(v,a,m){this.a[v*this.cols+a]=m}}class R{constructor(v){let a=0,m=0;for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const o=new L(m,a,0);for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];o.set(r,s,t)}this.a=o,this.b=a}nextState(v,a){return a<0||a>=this.b?0:this.a.get(v,a)}}e.$G2=R;let M=null;function b(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var p;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let E=null;function A(){if(E===null){E=new u.$vt(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<S.length;a++)E.set(S.charCodeAt(a),1);const v=".,;:";for(let a=0;a<v.length;a++)E.set(v.charCodeAt(a),2)}return E}class P{static a(v,a,m,o,n){let i=n-1;do{const r=a.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>o);if(o>0){const r=a.charCodeAt(o-1),s=a.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:i+2},url:a.substring(o,i+1)}}static computeLinks(v,a=b()){const m=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),s=r.length;let t=0,f=0,d=0,l=1,c=!1,h=!1,g=!1,D=!1;for(;t<s;){let w=!1;const k=r.charCodeAt(t);if(l===13){let y;switch(k){case 40:c=!0,y=0;break;case 41:y=c?0:1;break;case 91:g=!0,h=!0,y=0;break;case 93:g=!1,y=h?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:d===k?y=1:d===39||d===34||d===96?y=0:y=1;break;case 42:y=d===42?1:0;break;case 124:y=d===124?1:0;break;case 32:y=g?0:1;break;default:y=m.get(k)}y===1&&(o.push(P.a(m,r,n,f,t)),w=!0)}else if(l===12){let y;k===91?(h=!0,y=0):y=m.get(k),y===1?w=!0:l=13}else l=a.nextState(l,k),l===0&&(w=!0);w&&(l=1,c=!1,h=!1,D=!1,f=t+1,d=k),t++}l===13&&o.push(P.a(m,r,n,f,s))}return o}}e.$H2=P;function $(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:P.computeLinks(S)}}),define(ke[79],Ee([1,0,24]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$sv=e.$rv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$tv=v,e.$xv=r;var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var p;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var E;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$Xn)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$rv=P;class ${constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$sv=$;var S;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(S||(e.TrackedRangeStickiness=S={}));function v(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class o{constructor(t,f,d,l,c,h){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=c,this._isTracked=h}}e.$uv=o;class n{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$vv=n;class i{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$wv=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[181],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.NodeColor=e.$nC=void 0,e.$pC=L,e.$qC=R,e.$rC=E,e.$sC=A,e.$tC=P,e.$uC=$,e.$vC=S,e.$wC=v;class u{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oC)return L(this.right);let m=this;for(;m.parent!==e.$oC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$oC?e.$oC:m.parent}prev(){if(this.left!==e.$oC)return R(this.left);let m=this;for(;m.parent!==e.$oC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$oC?e.$oC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nC=u;var O;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$oC=new u(null,0),e.$oC.parent=e.$oC,e.$oC.left=e.$oC,e.$oC.right=e.$oC,e.$oC.color=0;function L(a){for(;a.left!==e.$oC;)a=a.left;return a}function R(a){for(;a.right!==e.$oC;)a=a.right;return a}function M(a){return a===e.$oC?0:a.size_left+a.piece.length+M(a.right)}function b(a){return a===e.$oC?0:a.lf_left+a.piece.lineFeedCnt+b(a.right)}function p(){e.$oC.parent=e.$oC}function E(a,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$oC&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$oC?a.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}function A(a,m){const o=m.left;m.left=o.right,o.right!==e.$oC&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$oC?a.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}function P(a,m){let o,n;if(m.left===e.$oC?(n=m,o=n.right):m.right===e.$oC?(n=m,o=n.left):(n=L(m.right),o=n.right),n===a.root){a.root=o,o.color=0,m.detach(),p(),a.root.parent=e.$oC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===m?(o.parent=n.parent,v(a,o)):(n.parent===m?o.parent=n:o.parent=n.parent,v(a,o),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===a.root?a.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$oC&&(n.left.parent=n),n.right!==e.$oC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,v(a,n)),m.detach(),o.parent.left===o){const s=M(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,S(a,o.parent,f,d)}}if(v(a,o.parent),i){p();return}let r;for(;o!==a.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,E(a,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,E(a,o.parent),o=a.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(a,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,E(a,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(a,o.parent),o=a.root));o.color=0,p()}function $(a,m){for(v(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,E(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,E(a,m.parent.parent))}a.root.color=0}function S(a,m,o,n){for(;m!==a.root&&m!==e.$oC;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}function v(a,m){let o=0,n=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,o=M(m.left)-m.size_left,n=b(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=n;m!==a.root&&(o!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}}}),define(ke[182],Ee([1,0,19,127]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=void 0;class L{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,E){p=(0,O.$Ye)(p);const A=this.a,P=this.b,$=E.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,p),0),this.a.set(A.subarray(p),p+$),this.a.set(E,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(p,E){return p=(0,O.$Ye)(p),E=(0,O.$Ye)(E),this.a[p]===E?!1:(this.a[p]=E,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,E){p=(0,O.$Ye)(p),E=(0,O.$Ye)(E);const A=this.a,P=this.b;if(p>=A.length)return!1;const $=A.length-p;return E>=$&&(E=$),E===0?!1:(this.a=new Uint32Array(A.length-E),this.a.set(A.subarray(0,p),0),this.a.set(A.subarray(p+E),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,O.$Ye)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),p>=this.a.length&&(p=this.a.length-1);for(let A=E;A<=p;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let E=0,A=this.a.length-1,P=0,$=0,S=0;for(;E<=A;)if(P=E+(A-E)/2|0,$=this.b[P],S=$-this.a[P],p<S)A=P-1;else if(p>=$)E=P+1;else break;return new M(P,p-S)}}e.$Jv=L;class R{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const E=this.e[p],A=E>0?this.d[E-1]:0;return new M(E,p-A)}removeValues(p,E){this.a.splice(p,E),this.f(p)}insertValues(p,E){this.a=(0,u.$Wb)(this.a,p,E),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,E=this.a.length;p<E;p++){const A=this.a[p],P=p>0?this.d[p-1]:0;this.d[p]=P+A;for(let $=0;$<A;$++)this.e[P+$]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,E){this.a[p]!==E&&(this.a[p]=E,this.f(p))}}e.$Kv=R;class M{constructor(p,E){this.index=p,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=E}}e.$Lv=M}),define(ke[183],Ee([1,0,14,50,182]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=void 0;class R{constructor(b,p,E,A){this.d=b,this.f=p,this.g=E,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const p=b.changes;for(const E of p)this.o(E.range),this.p(new O.$gt(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,p=this.f.length,E=new Uint32Array(p);for(let A=0;A<p;A++)E[A]=this.f[A].length+b;this.j=new L.$Jv(E)}}n(b,p){this.f[b]=p,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,p){if(p.length===0)return;const E=(0,u.$df)(p);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const A=new Uint32Array(E.length-1);for(let P=1;P<E.length;P++)this.f.splice(b.lineNumber+P-1,0,E[P]),A[P-1]=E[P].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Mv=R}),define(ke[100],Ee([1,0,14,178,50,29,79]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CC=e.$AC=e.$xC=void 0,e.$yC=E,e.$zC=A,e.$BC=a;const b=999;class p{constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$bf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$vv(i,this.wordSeparators?(0,O.$yt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$xC=p;function E(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new M.$sv(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new M.$sv(o,r)}class P{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class ${static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new m(f.wordSeparators,f.regex),s,t):this.c(n,r,f,s,t):[]}static a(n,i,r,s,t,f){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let c;if(s){const w=s.findLineFeedCountBeforeOffset(t+f.length)-l;c=d+f.length+w}else c=d+f.length;const h=n.getPositionAt(d),g=n.getPositionAt(c);return new R.$ht(h.lineNumber,h.column,g.lineNumber,g.column)}static b(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new P(d):null,c=[];let h=0,g;for(r.reset(0);g=r.next(d);)if(c[h++]=A(this.a(n,f,d,l,g.index,g[0]),g,s),h>=t)return c;return c}static c(n,i,r,s,t){const f=[];let d=0;if(i.startLineNumber===i.endLineNumber){const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,c,i.startLineNumber,i.startColumn-1,d,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,f,s,t);for(let c=i.startLineNumber+1;c<i.endLineNumber&&d<t;c++)d=this.d(r,n.getLineContent(c),c,0,d,f,s,t);if(d<t){const c=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,c,i.endLineNumber,0,d,f,s,t)}return f}static d(n,i,r,s,t,f,d,l){const c=n.wordSeparators;if(!d&&n.simpleSearch){const D=n.simpleSearch,w=D.length,k=i.length;let y=-w;for(;(y=i.indexOf(D,y+w))!==-1;)if((!c||a(c,i,k,y,w))&&(f[t++]=new M.$sv(new R.$ht(r,y+1+s,r,y+1+w+s),null),t>=l))return t;return t}const h=new m(n.wordSeparators,n.regex);let g;h.reset(0);do if(g=h.next(i),g&&(f[t++]=A(new R.$ht(r,g.index+1+s,r,g.index+1+g[0].length+s),g,d),t>=l))return t;while(g);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,s):this.f(n,r,f,s)}static e(n,i,r,s){const t=new L.$gt(i.lineNumber,1),f=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new R.$ht(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),c=n.getEOL()===`\r
`?new P(l):null;r.reset(i.column-1);const h=r.next(l);return h?A(this.a(n,f,l,c,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new L.$gt(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f),l=this.g(r,d,f,i.column,s);if(l)return l;for(let c=1;c<=t;c++){const h=(f+c-1)%t,g=n.getLineContent(h+1),D=this.g(r,g,h+1,1,s);if(D)return D}return null}static g(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?A(new R.$ht(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,s):this.j(n,r,f,s)}static h(n,i,r,s){const t=this.b(n,new R.$ht(1,1,i.lineNumber,i.column),r,s,10*b);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new L.$gt(f,n.getLineMaxColumn(f)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f).substring(0,i.column-1),l=this.k(r,d,f,s);if(l)return l;for(let c=1;c<=t;c++){const h=(t+f-c-1)%t,g=n.getLineContent(h+1),D=this.k(r,g,h+1,s);if(D)return D}return null}static k(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=A(new R.$ht(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$AC=$;function S(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function v(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function a(o,n,i,r,s){return S(o,n,i,r,s)&&v(o,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$xf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||a(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$CC=m}),define(ke[130],Ee([1,0,50,29,79,181,100]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.$GC=e.$FC=void 0,e.$DC=A,e.$EC=P;const b=65535;function p(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class E{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?p(i):i}function P(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,c=n.length;l<c;l++){const h=n.charCodeAt(l);h===13?l+1<c&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):h===10?(s++,o[i++]=l+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const d=new E(p(o),r,s,t,f);return o.length=0,d}class ${constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$FC=$;class S{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$GC=S;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$oC&&n.iterate(n.root,r=>(r!==R.$oC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=R.$oC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const d=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,l=>{const c=this.R(l),h=c.length;if(f<=r||f+h<s)return t+=c,f+=h,!0;const g=t.replace(/\r\n|\r|\n/g,n);return d.push(new S(g,A(g))),t=c,f=h,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new S(l,A(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===R.$oC)return!0;const t=this.R(s),f=t.length,d=n.G(i),l=n.G(i+f),c=n.getValueInRange2(d,l);return i+=f,t===c})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==R.$oC;)if(s.left!==R.$oC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==R.$oC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new u.$gt(r+1,d+1)}return new u.$gt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$oC){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new u.$gt(r+1,f+1)}else i=i.right;return new u.$gt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(c+n.remainder,c+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==R.$oC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=d.substring(l,l+i.remainder);break}else f+=d.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===R.$oC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const l=this.a[f.bufferIndex].buffer,c=this.a[f.bufferIndex].lineStarts,h=f.start.line,g=f.end.line;let D=c[h]+f.start.column;if(s&&(l.charCodeAt(D)===10&&(D++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===g)return!this.f&&l.charCodeAt(D+d-1)===13?(s=!0,r+=l.substr(D,d-1)):r+=l.substr(D,d),!0;r+=this.f?l.substring(D,Math.max(D,c[h+1]-this.e)):l.substring(D,c[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let w=h+1;w<g;w++)r=this.f?l.substring(c[w],c[w+1]-this.e):l.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(c[g]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(c[g],f.end.column-1)):r=l.substr(c[g],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,f,d,l,c,h,g){const D=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,f);let C;const I={line:0,column:0};let z,j;i._wordSeparators?(z=D.buffer.substring(k,y),j=F=>F+k,i.reset(0)):(z=D.buffer,j=F=>F,i.reset(k));do if(C=i.next(z),C){if(j(C.index)>=y)return h;this.s(n,j(C.index)-w,I);const F=this.t(n.piece.bufferIndex,t,I),N=I.line===t.line?I.column-t.column+s:I.column+1,T=N+C[0].length;if(g[h++]=(0,M.$zC)(new O.$ht(r+F,N,r+F,T),C,l),j(C.index)+C[0].length>=y||h>=c)return h}while(C);return h}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const d=new M.$CC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const c=this.H(n.endLineNumber,n.endColumn);if(c===null)return[];let h=this.s(l.node,l.remainder);const g=this.s(c.node,c.remainder);if(l.node===c.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,g,i,r,s,f,t),t;let D=n.startLineNumber,w=l.node;for(;w!==c.node;){const y=this.t(w.piece.bufferIndex,h,w.piece.end);if(y>=1){const I=this.a[w.piece.bufferIndex].lineStarts,z=this.u(w.piece.bufferIndex,w.piece.start),j=I[h.line+y],F=D===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(w,d,D,F,h,this.s(w,j-z),i,r,s,f,t),f>=s)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(C,n.endColumn-1);return f=this.n(i,d,I,n.endLineNumber,C,f,t,r,s),t}if(f=this.n(i,d,this.getLineContent(D).substr(C),D,C,f,t,r,s),f>=s)return t;D++,l=this.H(D,1),w=l.node,h=this.s(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return f=this.n(i,d,C,n.endLineNumber,y,f,t,r,s),t}const k=D===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(c.node,d,D,k,h,g,i,r,s,f,t),t}n(n,i,r,s,t,f,d,l,c){const h=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,w=D.length,k=r.length;let y=-w;for(;(y=r.indexOf(D,y+w))!==-1;)if((!h||(0,M.$BC)(h,r,k,y,w))&&(d[f++]=new L.$sv(new O.$ht(s,y+1+t,s,y+1+w+t),null),f>=c))return f;return f}let g;i.reset(0);do if(g=i.next(r),g&&(d[f++]=(0,M.$zC)(new O.$ht(s,g.index+1+t,s,g.index+1+g[0].length+t),g,l),f>=c))return f;while(g);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$oC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(n),d=s.piece,l=d.bufferIndex,c=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===n&&i.length<b){this.F(s,i),this.y();return}if(f===n)this.o(i,s),this.h.validate(n);else if(f+s.piece.length>n){const h=[];let g=new $(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(l,d.end)-this.u(l,c));if(this.K()&&this.M(i)&&this.I(s,t)===10){const y={line:g.start.line+1,column:0};g=new $(g.bufferIndex,y,g.end,this.t(g.bufferIndex,y,g.end),g.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,c);else this.C(s,c);const D=this.w(i);g.length>0&&this.S(s,g);let w=s;for(let k=0;k<D.length;k++)w=this.S(w,D[k]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$oC)return;const r=this.G(n),s=this.G(n+i),t=r.node,f=s.node;if(t===f){const D=this.s(t,r.remainder),w=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,R.$tC)(this,t),this.N(k),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,w),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const c=this.s(f,s.remainder);this.D(f,c),f.piece.length===0&&d.push(f);const h=t.next();for(let D=h;D!==R.$oC&&D!==f;D=D.next())d.push(D);const g=t.piece.length===0?t.prev():t;this.v(d),this.O(g),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,d={line:f.start.line+1,column:0},l=new $(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);i.piece=l,n+=`
`,(0,R.$vC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,l=f[s.start.line]+s.start.column+i;let c=s.start.line,h=s.end.line,g=0,D=0,w=0;for(;c<=h&&(g=c+(h-c)/2|0,w=f[g],g!==h);)if(D=f[g+1],l<w)h=g-1;else if(l>=D)c=g+1;else break;return r?(r.line=g,r.column=l-w,null):{line:g,column:l-w}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const d=f-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$tC)(this,n[i])}w(n){if(n.length>b){const h=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let w;D===13||D>=55296&&D<=56319?(w=n.substring(0,b-1),n=n.substring(b-1)):(w=n.substring(0,b),n=n.substring(b));const k=A(w);h.push(new $(this.a.length,{line:0,column:0},{line:k.length-1,column:w.length-k[k.length-1]},k.length-1,w.length)),this.a.push(new S(w,k))}const g=A(n);return h.push(new $(this.a.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this.a.push(new S(n,g)),h}let i=this.a[0].buffer.length;const r=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],l={line:f,column:d},c=new $(0,s,l,this.t(0,s,l),t-i);return this.g=l,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+f,l+r.piece.length);else{const c=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+f,l+c-i)}}else{let f=0;const d=n;for(;r!==R.$oC;)if(r.left!==R.$oC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),c=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,g=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(g+l,g+c-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=c.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$oC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==R.$oC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,d=this.u(r.bufferIndex,f),l=this.t(r.bufferIndex,r.start,f),c=l-s,h=d-t,g=r.length+h;n.piece=new $(r.bufferIndex,r.start,f,l,g),(0,R.$vC)(this,n,h,c)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,d=this.t(r.bufferIndex,f,r.end),l=this.u(r.bufferIndex,f),c=d-s,h=t-l,g=r.length+h;n.piece=new $(r.bufferIndex,f,r.end,d,g),(0,R.$vC)(this,n,h,c)}E(n,i,r){const s=n.piece,t=s.start,f=s.end,d=s.length,l=s.lineFeedCnt,c=i,h=this.t(s.bufferIndex,s.start,c),g=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new $(s.bufferIndex,s.start,c,h,g),(0,R.$vC)(this,n,g-d,h-l);const D=new $(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),w=this.S(n,D);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let w=0;w<t.length;w++)t[w]+=s;if(r){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],l={line:f,column:d},c=n.piece.length+i.length,h=n.piece.lineFeedCnt,g=this.t(0,n.piece.start,l),D=g-h;n.piece=new $(n.piece.bufferIndex,n.piece.start,l,g,c),this.g=l,(0,R.$vC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==R.$oC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==R.$oC;)if(r.left!==R.$oC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$oC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$oC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$oC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,d,f),(0,R.$vC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},c=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new $(i.piece.bufferIndex,l,i.piece.end,h,c),(0,R.$vC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const g=this.w(`\r
`);this.S(n,g[0]);for(let D=0;D<r.length;D++)(0,R.$tC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,R.$tC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new $(s.bufferIndex,t,s.end,d,f),(0,R.$vC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$oC)return i(R.$oC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$oC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new R.$nC(i,1);if(r.left=R.$oC,r.right=R.$oC,r.parent=R.$oC,r.size_left=0,r.lf_left=0,this.root===R.$oC)this.root=r,r.color=0;else if(n.right===R.$oC)n.right=r,r.parent=n;else{const t=(0,R.$pC)(n.right);t.left=r,r.parent=t}return(0,R.$uC)(this,r),r}T(n,i){const r=new R.$nC(i,1);if(r.left=R.$oC,r.right=R.$oC,r.parent=R.$oC,r.size_left=0,r.lf_left=0,this.root===R.$oC)this.root=r,r.color=0;else if(n.left===R.$oC)n.left=r,r.parent=n;else{const s=(0,R.$qC)(n.left);s.right=r,r.parent=s}return(0,R.$uC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$HC=m}),define(ke[184],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t0=e.$s0=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$s0=u;class O{constructor(R){this.identifier=R}}e.$t0=O}),define(ke[185],Ee([1,0,4,3]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$_d,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,p){return this.a.set(b,p),this.handleChange([b]),(0,O.$Sc)(()=>{this.a.get(b)===p&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,p){this.b.get(b)?.dispose();const E=new R(this,b,p);return this.b.set(b,E),(0,O.$Sc)(()=>{const A=this.b.get(b);!A||A!==E||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const p=this.get(b);if(p)return p;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Jt=L;class R extends O.$Uc{get isResolved(){return this.c}constructor(b,p,E){super(),this.f=b,this.g=p,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[186],Ee([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[187],Ee([1,0,4,3,186]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0,e.$0i=A;class R extends O.$Uc{constructor($,S="",v="",a=!0,m){super(),this.h=this.B(new u.$_d),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=S,this.u=v,this.w=a,this.C=m}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,S){this.C&&await this.C($)}}e.$5i=R;class M extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$_d),this.onWillRun=this.f.event,this.m=this.B(new u.$_d),this.onDidRun=this.m.event}async run($,S){if(!$.enabled)return;this.f.fire({action:$});let v;try{await this.u($,S)}catch(a){v=a}this.m.fire({action:$,error:v})}async u($,S){await $.run(S)}}e.$6i=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let S=[];for(const v of $)v.length&&(S.length?S=[...S,new b,...v]:S=v);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$7i=b;class p{get actions(){return this.a}constructor($,S,v,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=S,this.class=a,this.a=v}async run(){}}e.$8i=p;class E extends R{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,L.localize(0,null),void 0,!1)}}e.$9i=E;function A(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...$)=>P.run(...$),tooltip:P.label}}}),define(ke[188],Ee([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[189],Ee([1,0,188]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=E,e.$Tm=A,e.$Um=P;const O=60,L=O*60,R=L*24,M=R*7,b=R*30,p=R*365;function E($,S,v,a){typeof $!="number"&&($=$.getTime());const m=Math.round((new Date().getTime()-$)/1e3);if(m<-30)return(0,u.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,u.localize)(1,null);let o;return m<O?(o=m,S?o===1?v?(0,u.localize)(2,null,o):(0,u.localize)(3,null,o):v?(0,u.localize)(4,null,o):(0,u.localize)(5,null,o):o===1?v?(0,u.localize)(6,null,o):(0,u.localize)(7,null,o):v?(0,u.localize)(8,null,o):(0,u.localize)(9,null,o)):m<L?(o=Math.floor(m/O),S?o===1?v?(0,u.localize)(10,null,o):(0,u.localize)(11,null,o):v?(0,u.localize)(12,null,o):(0,u.localize)(13,null,o):o===1?v?(0,u.localize)(14,null,o):(0,u.localize)(15,null,o):v?(0,u.localize)(16,null,o):(0,u.localize)(17,null,o)):m<R?(o=Math.floor(m/L),S?o===1?v?(0,u.localize)(18,null,o):(0,u.localize)(19,null,o):v?(0,u.localize)(20,null,o):(0,u.localize)(21,null,o):o===1?v?(0,u.localize)(22,null,o):(0,u.localize)(23,null,o):v?(0,u.localize)(24,null,o):(0,u.localize)(25,null,o)):m<M?(o=Math.floor(m/R),S?o===1?(0,u.localize)(26,null,o):(0,u.localize)(27,null,o):o===1?(0,u.localize)(28,null,o):(0,u.localize)(29,null,o)):m<b?(o=Math.floor(m/M),S?o===1?v?(0,u.localize)(30,null,o):(0,u.localize)(31,null,o):v?(0,u.localize)(32,null,o):(0,u.localize)(33,null,o):o===1?v?(0,u.localize)(34,null,o):(0,u.localize)(35,null,o):v?(0,u.localize)(36,null,o):(0,u.localize)(37,null,o)):m<p?(o=Math.floor(m/b),S?o===1?v?(0,u.localize)(38,null,o):(0,u.localize)(39,null,o):v?(0,u.localize)(40,null,o):(0,u.localize)(41,null,o):o===1?v?(0,u.localize)(42,null,o):(0,u.localize)(43,null,o):v?(0,u.localize)(44,null,o):(0,u.localize)(45,null,o)):(o=Math.floor(m/p),S?o===1?v?(0,u.localize)(46,null,o):(0,u.localize)(47,null,o):v?(0,u.localize)(48,null,o):(0,u.localize)(49,null,o):o===1?v?(0,u.localize)(50,null,o):(0,u.localize)(51,null,o):v?(0,u.localize)(52,null,o):(0,u.localize)(53,null,o))}function A($,S){const v=Math.abs($/1e3);return v<1?S?(0,u.localize)(54,null,$):(0,u.localize)(55,null,$):v<O?S?(0,u.localize)(56,null,Math.round($)/1e3):(0,u.localize)(57,null,Math.round($)/1e3):v<L?S?(0,u.localize)(58,null,Math.round($/(1e3*O))):(0,u.localize)(59,null,Math.round($/(1e3*O))):v<R?S?(0,u.localize)(60,null,Math.round($/(1e3*L))):(0,u.localize)(61,null,Math.round($/(1e3*L))):(0,u.localize)(62,null,Math.round($/(1e3*R)))}function P($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Ee([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[47],Ee([1,0,19,18,190]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=p,e.$_i=E,e.$aj=A;function R(P,$){return $&&(P.stack||P.stacktrace)?L.localize(0,null,b(P),M(P.stack)||M(P.stacktrace)):b(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?L.localize(1,null,P.message):P.message||L.localize(2,null)}function p(P=null,$=!1){if(!P)return L.localize(3,null);if(Array.isArray(P)){const S=u.$Hb(P),v=p(S[0],$);return S.length>1?L.localize(4,null,v,S.length):v}if(O.$1f(P))return P;if(P.detail){const S=P.detail;if(S.error)return R(S.error,$);if(S.exception)return R(S.exception,$)}return P.stack?R(P,$):P.message?P.message:L.localize(5,null)}function E(P){const $=P;return $ instanceof Error&&Array.isArray($.actions)}function A(P,$){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=$,S}}),define(ke[191],Ee([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,191]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=D,e.$J=w,e.$g="en";let O=!1,L=!1,R=!1,M=!1,b=!1,p=!1,E=!1,A=!1,P=!1,$=!1,S,v=e.$g,a=e.$g,m,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){O=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=r,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,v=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const y=JSON.parse(k),C=y.availableLanguages["*"];S=y.locale,a=y.osLocale,v=C||e.$g,m=y._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,O=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,p=!0,S=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=S,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;L?d=1:O?d=3:R&&(d=2),e.$i=O,e.$j=L,e.$k=R,e.$l=M,e.$m=b,e.$n=E,e.$o=p,e.$p=p&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=$,e.$t=P,e.$u=d,e.$v=o,e.$w=v;var l;(function(k){function y(){return e.$w}k.value=y;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=C;function I(){return e.$w==="en"}k.isDefault=I})(l||(e.Language=l={})),e.$x=S,e.$y=a,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let I=0,z=k.length;I<z;I++){const j=k[I];if(j.id===C.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let y=0;return C=>{const I=++y;k.push({id:I,callback:C}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var c;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=L||A?2:O?1:3;let h=!0,g=!1;function D(){if(!g){g=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,h=new Uint16Array(k.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(k){return parseFloat(k)>=20}}),define(ke[51],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;O={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$ec=O.platform,e.$fc=O.arch}),define(ke[17],Ee([1,0,51]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const O=65,L=97,R=90,M=122,b=46,p=47,E=92,A=58,P=63;class $ extends Error{constructor(f,d,l){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${h} ${c} of type ${d}`;g+=`. Received type ${typeof l}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,f){if(t===null||typeof t!="object")throw new $(f,"Object",t)}function v(t,f){if(typeof t!="string")throw new $(f,"string",t)}const a=u.$ec==="win32";function m(t){return t===p||t===E}function o(t){return t===p}function n(t){return t>=O&&t<=R||t>=L&&t<=M}function i(t,f,d,l){let c="",h=0,g=-1,D=0,w=0;for(let k=0;k<=t.length;++k){if(k<t.length)w=t.charCodeAt(k);else{if(l(w))break;w=p}if(l(w)){if(!(g===k-1||D===1))if(D===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const y=c.lastIndexOf(d);y===-1?(c="",h=0):(c=c.slice(0,y),h=c.length-1-c.lastIndexOf(d)),g=k,D=0;continue}else if(c.length!==0){c="",h=0,g=k,D=0;continue}}f&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(g+1,k)}`:c=t.slice(g+1,k),h=k-g-1;g=k,D=0}else w===b&&D!==-1?++D:D=-1}return c}function r(t,f){S(f,"pathObject");const d=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let f="",d="",l=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],v(h,"path"),h.length===0)continue}else f.length===0?h=u.cwd():(h=u.env[`=${f}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==f.toLowerCase()&&h.charCodeAt(2)===E)&&(h=`${f}\\`));const g=h.length;let D=0,w="",k=!1;const y=h.charCodeAt(0);if(g===1)m(y)&&(D=1,k=!0);else if(m(y))if(k=!0,m(h.charCodeAt(1))){let C=2,I=C;for(;C<g&&!m(h.charCodeAt(C));)C++;if(C<g&&C!==I){const z=h.slice(I,C);for(I=C;C<g&&m(h.charCodeAt(C));)C++;if(C<g&&C!==I){for(I=C;C<g&&!m(h.charCodeAt(C));)C++;(C===g||C!==I)&&(w=`\\\\${z}\\${h.slice(I,C)}`,D=C)}}}else D=1;else n(y)&&h.charCodeAt(1)===A&&(w=h.slice(0,2),D=2,g>2&&m(h.charCodeAt(2))&&(k=!0,D=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(l){if(f.length>0)break}else if(d=`${h.slice(D)}\\${d}`,l=k,k&&f.length>0)break}return d=i(d,!l,"\\",m),l?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){v(t,"path");const f=t.length;if(f===0)return".";let d=0,l,c=!1;const h=t.charCodeAt(0);if(f===1)return o(h)?"\\":t;if(m(h))if(c=!0,m(t.charCodeAt(1))){let D=2,w=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==w){const k=t.slice(w,D);for(w=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return`\\\\${k}\\${t.slice(w)}\\`;D!==w&&(l=`\\\\${k}\\${t.slice(w,D)}`,d=D)}}}else d=1;else n(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,f>2&&m(t.charCodeAt(2))&&(c=!0,d=3));let g=d<f?i(t.slice(d),!c,"\\",m):"";return g.length===0&&!c&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),l===void 0?c?`\\${g}`:g:c?`${l}\\${g}`:`${l}${g}`},isAbsolute(t){v(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return m(d)||f>2&&n(d)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let h=0;h<t.length;++h){const g=t[h];v(g,"path"),g.length>0&&(f===void 0?f=d=g:f+=`\\${g}`)}if(f===void 0)return".";let l=!0,c=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++c;const h=d.length;h>1&&m(d.charCodeAt(1))&&(++c,h>2&&(m(d.charCodeAt(2))?++c:l=!1))}if(l){for(;c<f.length&&m(f.charCodeAt(c));)c++;c>=2&&(f=`\\${f.slice(c)}`)}return e.$gc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(f);if(d===l||(t=d.toLowerCase(),f=l.toLowerCase(),t===f))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===E;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===E;)h--;const g=h-c;let D=0;for(;D<f.length&&f.charCodeAt(D)===E;)D++;let w=f.length;for(;w-1>D&&f.charCodeAt(w-1)===E;)w--;const k=w-D,y=g<k?g:k;let C=-1,I=0;for(;I<y;I++){const j=t.charCodeAt(c+I);if(j!==f.charCodeAt(D+I))break;j===E&&(C=I)}if(I!==y){if(C===-1)return l}else{if(k>y){if(f.charCodeAt(D+I)===E)return l.slice(D+I+1);if(I===2)return l.slice(D+I)}g>y&&(t.charCodeAt(c+I)===E?C=I:I===2&&(C=3)),C===-1&&(C=0)}let z="";for(I=c+C+1;I<=h;++I)(I===h||t.charCodeAt(I)===E)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${l.slice(D,w)}`:(l.charCodeAt(D)===E&&++D,l.slice(D,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const d=f.charCodeAt(2);if(d!==P&&d!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return t},dirname(t){v(t,"path");const f=t.length;if(f===0)return".";let d=-1,l=0;const c=t.charCodeAt(0);if(f===1)return m(c)?t:".";if(m(c)){if(d=l=1,m(t.charCodeAt(1))){let D=2,w=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return t;D!==w&&(d=l=D+1)}}}}else n(c)&&t.charCodeAt(1)===A&&(d=f>2&&m(t.charCodeAt(2))?3:2,l=d);let h=-1,g=!0;for(let D=f-1;D>=l;--D)if(m(t.charCodeAt(D))){if(!g){h=D;break}}else g=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(m(w)){if(!c){d=h+1;break}}else D===-1&&(c=!1,D=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(m(t.charCodeAt(h))){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=0,d=-1,l=0,c=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(f=l=2);for(let D=t.length-1;D>=f;--D){const w=t.charCodeAt(D);if(m(w)){if(!h){l=D+1;break}continue}c===-1&&(h=!1,c=D+1),w===b?d===-1?d=D:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||c===-1||g===0||g===1&&d===c-1&&d===l+1?"":t.slice(d,c)},format:r.bind(null,"\\"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let l=0,c=t.charCodeAt(0);if(d===1)return m(c)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(c)){if(l=1,m(t.charCodeAt(1))){let C=2,I=C;for(;C<d&&!m(t.charCodeAt(C));)C++;if(C<d&&C!==I){for(I=C;C<d&&m(t.charCodeAt(C));)C++;if(C<d&&C!==I){for(I=C;C<d&&!m(t.charCodeAt(C));)C++;C===d?l=C:C!==I&&(l=C+1)}}}}else if(n(c)&&t.charCodeAt(1)===A){if(d<=2)return f.root=f.dir=t,f;if(l=2,m(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let h=-1,g=l,D=-1,w=!0,k=t.length-1,y=0;for(;k>=l;--k){if(c=t.charCodeAt(k),m(c)){if(!w){g=k+1;break}continue}D===-1&&(w=!1,D=k+1),c===b?h===-1?h=k:y!==1&&(y=1):h!==-1&&(y=-1)}return D!==-1&&(h===-1||y===0||y===1&&h===D-1&&h===g+1?f.base=f.name=t.slice(g,D):(f.name=t.slice(g,h),f.base=t.slice(g,D),f.ext=t.slice(h,D))),g>0&&g!==l?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const c=l>=0?t[l]:s();v(c,"path"),c.length!==0&&(f=`${c}/${f}`,d=c.charCodeAt(0)===p)}return f=i(f,!d,"/",o),d?`/${f}`:f.length>0?f:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p,d=t.charCodeAt(t.length-1)===p;return t=i(t,!f,"/",o),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const l=t[d];v(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,l=t.length,c=l-d,h=1,g=f.length-h,D=c<g?c:g;let w=-1,k=0;for(;k<D;k++){const C=t.charCodeAt(d+k);if(C!==f.charCodeAt(h+k))break;C===p&&(w=k)}if(k===D)if(g>D){if(f.charCodeAt(h+k)===p)return f.slice(h+k+1);if(k===0)return f.slice(h+k)}else c>D&&(t.charCodeAt(d+k)===p?w=k:k===0&&(w=0));let y="";for(k=d+w+1;k<=l;++k)(k===l||t.charCodeAt(k)===p)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p;let d=-1,l=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===p){if(!l){d=c;break}}else l=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===p){if(!c){d=h+1;break}}else D===-1&&(c=!1,D=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===p){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=-1,d=0,l=-1,c=!0,h=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===p){if(!c){d=g+1;break}continue}l===-1&&(c=!1,l=g+1),D===b?f===-1?f=g:h!==1&&(h=1):f!==-1&&(h=-1)}return f===-1||l===-1||h===0||h===1&&f===l-1&&f===d+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===p;let l;d?(f.root="/",l=1):l=0;let c=-1,h=0,g=-1,D=!0,w=t.length-1,k=0;for(;w>=l;--w){const y=t.charCodeAt(w);if(y===p){if(!D){h=w+1;break}continue}g===-1&&(D=!1,g=w+1),y===b?c===-1?c=w:k!==1&&(k=1):c!==-1&&(k=-1)}if(g!==-1){const y=h===0&&d?1:h;c===-1||k===0||k===1&&c===g-1&&c===h+1?f.base=f.name=t.slice(y,g):(f.name=t.slice(y,c),f.base=t.slice(y,g),f.ext=t.slice(c,g))}return h>0?f.dir=t.slice(0,h-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,46,17]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=b,e.$9q=p,e.$0q=E,e.$$q=A,e.$_q=P,e.$ar=$,e.$br=S,e.$cr=v,e.$dr=a,e.$er=m,e.$fr=c,e.$gr=h,e.$hr=g;const L=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,w,k=!1){const y=D||"",C=w||"",I=L.value.collator.compare(y,C);return L.value.collatorIsNumeric&&I===0&&y!==C?y<C?-1:1:I}function p(D,w){const k=R.value.collator;return D=D||"",w=w||"",r(k,D,w)}function E(D,w){const k=R.value.collator;return D=D||"",w=w||"",d(D,w)||r(k,D,w)}function A(D,w){const k=R.value.collator;return D=D||"",w=w||"",f(D,w)||r(k,D,w)}function P(D,w){return D=D||"",w=w||"",D===w?0:D<w?-1:1}function $(D,w){const[k,y]=n(D),[C,I]=n(w);let z=L.value.collator.compare(y,I);if(z===0){if(L.value.collatorIsNumeric&&y!==I)return y<I?-1:1;if(z=L.value.collator.compare(k,C),L.value.collatorIsNumeric&&z===0&&k!==C)return k<C?-1:1}return z}function S(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||r(C,D,w)}function v(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||d(D,w)||r(C,D,w)}function a(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||f(D,w)||r(C,D,w)}function m(D,w){D=D||"",w=w||"";const k=i(D).toLowerCase(),y=i(w).toLowerCase();return k!==y?k<y?-1:1:D!==w?D<w?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(D,w=!1){const k=D?o.exec(D):[];let y=[k&&k[1]||"",k&&k[3]||""];return w&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const w=D?o.exec(D):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function r(D,w,k){const y=D.compare(w,k);return y!==0?y:w.length!==k.length?w.length<k.length?-1:1:0}function s(D){const w=D.charAt(0);return w.toLocaleUpperCase()!==w}function t(D){const w=D.charAt(0);return w.toLocaleLowerCase()!==w}function f(D,w){return s(D)&&t(w)?-1:t(D)&&s(w)?1:0}function d(D,w){return t(D)&&s(w)?-1:s(D)&&t(w)?1:0}function l(D,w,k=!1){return k||(D=D&&D.toLowerCase(),w=w&&w.toLowerCase()),D===w?0:D<w?-1:1}function c(D,w,k=!1){const y=D.split(O.sep),C=w.split(O.sep),I=y.length-1,z=C.length-1;let j,F;for(let N=0;;N++){if(j=I===N,F=z===N,j&&F)return b(y[N],C[N],k);if(j)return-1;if(F)return 1;const T=l(y[N],C[N],k);if(T!==0)return T}}function h(D,w,k){const y=D.toLowerCase(),C=w.toLowerCase(),I=g(D,w,k);if(I)return I;const z=y.endsWith(k),j=C.endsWith(k);if(z!==j)return z?-1:1;const F=b(y,C);return F!==0?F:y.localeCompare(C)}function g(D,w,k){const y=D.toLowerCase(),C=w.toLowerCase(),I=y.startsWith(k),z=C.startsWith(k);if(I!==z)return I?-1:1;if(I&&z){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=M,e.$hg=b,e.$ig=p,e.$jg=E,e.$kg=A,e.$lg=v,e.$mg=a,e.$ng=m,e.$og=o,e.$pg=n,e.$qg=i,e.$rg=r,e.$sg=s,e.$tg=t,e.$ug=f,e.$vg=c;function M(h){return h===47||h===92}function b(h){return h.replace(/[\\/]/g,u.$hc.sep)}function p(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function E(h,g=u.$hc.sep){if(!h)return"";const D=h.length,w=h.charCodeAt(0);if(M(w)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!M(h.charCodeAt(y));y++);if(C!==y&&!M(h.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,g)}}return g}else if(o(w)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let k=h.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(M(h.charCodeAt(k)))return h.slice(0,k+1)}return""}function A(h){if(!O.$i||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let D=2;const w=D;for(;D<h.length&&(g=h.charCodeAt(D),g!==92);D++);return!(w===D||(g=h.charCodeAt(D+1),isNaN(g)||g===92))}const P=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(h,g=O.$i){const D=g?P:$;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||g&&S.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}function a(h,g,D){const w=h===g;return!D||w?w:!h||!g?!1:(0,L.$qf)(h,g)}function m(h,g,D,w=u.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(D){if(!(0,L.$rf)(h,g))return!1;if(g.length===h.length)return!0;let y=g.length;return g.charAt(g.length-1)===w&&y--,h.charAt(y)===w}return g.charAt(g.length-1)!==w&&(g+=w),h.indexOf(g)===0}function o(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,g){return O.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(g,h)),h=(0,u.$ic)(h),O.$i?(h=(0,L.$$e)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,L.$$e)(h,u.sep),h||(h=u.sep)),h}function i(h){const g=(0,u.$ic)(h);return O.$i?h.length>3?!1:r(g)&&(h.length===2||g.charCodeAt(2)===92):g===u.$hc.sep}function r(h,g=O.$i){return g?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,g=O.$i){return r(h,g)?h[0]:void 0}function t(h,g,D){return g.length>h.length?-1:h===g?0:(D&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}function f(h){const g=h.split(":");let D,w,k;for(const y of g){const C=Number(y);(0,R.$5f)(C)?w===void 0?w=C:k===void 0&&(k=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:w!==void 0?w:void 0,column:k!==void 0?k:w!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,g,D=8){let w="";for(let y=0;y<D;y++){let C;y===0&&O.$i&&!g&&(D===3||D===4)?C=l:C=d,w+=C.charAt(Math.floor(Math.random()*C.length))}let k;return g?k=`${g}-${w}`:k=w,h?(0,u.$kc)(h,k):k}}),define(ke[132],Ee([1,0,131,126,56,17,11,14]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=A,e.$jr=m,e.$kr=d,e.$lr=k,e.$mr=F,e.$nr=T;const p=0,E=[p,[]];function A(B,H,Z,ee){if(!B||!H)return E;const J=B.length,Y=H.length;if(J<Y)return E;const re=B.toLowerCase();return P(H,Z,Y,B,re,J,ee)}function P(B,H,Z,ee,J,Y,re){const te=[],pe=[];for(let ne=0;ne<Z;ne++){const be=ne*Y,De=be-Y,ae=ne>0,ce=B[ne],se=H[ne];for(let K=0;K<Y;K++){const ie=K>0,le=be+K,de=le-1,Ae=De+K-1,me=ie?te[de]:0,Pe=ae&&ie?te[Ae]:0,Me=ae&&ie?pe[Ae]:0;let je;!Pe&&ae?je=0:je=$(ce,se,ee,J,K,Me),je&&Pe+je>=me&&(re||ae||J.startsWith(H,K))?(pe[le]=Me+1,te[le]=Pe+je):(pe[le]=p,te[le]=me)}}const Ce=[];let x=Z-1,U=Y-1;for(;x>=0&&U>=0;){const ne=x*Y+U;pe[ne]===p||(Ce.push(U),x--),U--}return[te[Z*Y-1],Ce.reverse()]}function $(B,H,Z,ee,J,Y){let re=0;if(!S(H,ee[J]))return re;if(re+=1,Y>0&&(re+=Y*5),B===Z[J]&&(re+=1),J===0)re+=8;else{const te=v(Z.charCodeAt(J-1));te?re+=te:(0,O.$sk)(Z.charCodeAt(J))&&Y===0&&(re+=2)}return re}function S(B,H){return B===H?!0:B==="/"||B==="\\"?H==="/"||H==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(B,H,Z=0,ee=0){const J=H;return J.values&&J.values.length>1?o(B,J.values,Z,ee):n(B,H,Z,ee)}function o(B,H,Z,ee){let J=0;const Y=[];for(const re of H){const[te,pe]=n(B,re,Z,ee);if(typeof te!="number")return a;J+=te,Y.push(...pe)}return[J,D(Y)]}function n(B,H,Z,ee){const J=(0,O.$Bk)(H.original,H.originalLowercase,Z,B,B.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,O.$yk)(J)]:a}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,H,Z,ee){const J=ee.values?ee.values:[ee];return(0,L.$bj)({[ee.normalized]:{values:J.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:B,description:H,allowNonContiguousMatches:Z}})}function d(B,H,Z,ee,J){if(!B||!H.normalized)return i;const Y=ee.getItemLabel(B);if(!Y)return i;const re=ee.getItemDescription(B),te=f(Y,re,Z,H),pe=J[te];if(pe)return pe;const Ce=l(Y,re,ee.getItemPath(B),H,Z);return J[te]=Ce,Ce}function l(B,H,Z,ee,J){const Y=!Z||!ee.containsPathSeparator;return Z&&(M.$k?ee.pathNormalized===Z:(0,b.$qf)(ee.pathNormalized,Z))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:ee.values&&ee.values.length>1?c(B,H,Z,ee.values,Y,J):h(B,H,Z,ee,Y,J)}function c(B,H,Z,ee,J,Y){let re=0;const te=[],pe=[];for(const Ce of ee){const{score:x,labelMatch:U,descriptionMatch:ne}=h(B,H,Z,Ce,J,Y);if(x===p)return i;re+=x,U&&te.push(...U),ne&&pe.push(...ne)}return{score:re,labelMatch:D(te),descriptionMatch:D(pe)}}function h(B,H,Z,ee,J,Y){if(J||!H){const[re,te]=A(B,ee.normalized,ee.normalizedLowercase,Y&&!ee.expectContiguousMatch);if(re){const pe=(0,O.$pk)(ee.normalized,B);let Ce;if(pe){Ce=s;const x=Math.round(ee.normalized.length/B.length*100);Ce+=x}else Ce=t;return{score:Ce+re,labelMatch:pe||g(te)}}}if(H){let re=H;Z&&(re=`${H}${R.sep}`);const te=re.length,pe=`${re}${B}`,[Ce,x]=A(pe,ee.normalized,ee.normalizedLowercase,Y&&!ee.expectContiguousMatch);if(Ce){const U=g(x),ne=[],be=[];return U.forEach(De=>{De.start<te&&De.end>te?(ne.push({start:0,end:De.end-te}),be.push({start:De.start,end:te})):De.start>=te?ne.push({start:De.start-te,end:De.end-te}):be.push(De)}),{score:Ce,labelMatch:ne,descriptionMatch:be}}}return i}function g(B){const H=[];if(!B)return H;let Z;for(const ee of B)Z&&Z.end===ee?Z.end+=1:(Z={start:ee,end:ee+1},H.push(Z));return H}function D(B){const H=B.sort((J,Y)=>J.start-Y.start),Z=[];let ee;for(const J of H)!ee||!w(ee,J)?(ee=J,Z.push(J)):(ee.start=Math.min(ee.start,J.start),ee.end=Math.max(ee.end,J.end));return Z}function w(B,H){return!(B.end<H.start||H.end<B.start)}function k(B,H,Z,ee,J,Y){const re=d(B,Z,ee,J,Y),te=d(H,Z,ee,J,Y),pe=re.score,Ce=te.score;if((pe===r||Ce===r)&&pe!==Ce)return pe===r?-1:1;if(pe>t||Ce>t){if(pe!==Ce)return pe>Ce?-1:1;if(pe<s&&Ce<s){const ce=C(re.labelMatch,te.labelMatch);if(ce!==0)return ce}const De=J.getItemLabel(B)||"",ae=J.getItemLabel(H)||"";if(De.length!==ae.length)return De.length-ae.length}if(pe!==Ce)return pe>Ce?-1:1;const x=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,U=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(x&&!U)return-1;if(U&&!x)return 1;const ne=y(B,re,J),be=y(H,te,J);return ne&&be&&ne!==be?be>ne?-1:1:I(B,H,Z,J)}function y(B,H,Z){let ee=-1,J=-1;if(H.descriptionMatch&&H.descriptionMatch.length?ee=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(ee=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(J=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const Y=Z.getItemDescription(B);Y&&(J+=Y.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(J=H.descriptionMatch[H.descriptionMatch.length-1].end);return J-ee}function C(B,H){if(!B&&!H||(!B||!B.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!B||!B.length)return 1;const Z=B[0].start,J=B[B.length-1].end-Z,Y=H[0].start,te=H[H.length-1].end-Y;return J===te?0:te<J?1:-1}function I(B,H,Z,ee){const J=ee.getItemLabel(B)||"",Y=ee.getItemLabel(H)||"",re=ee.getItemDescription(B),te=ee.getItemDescription(H),pe=J.length+(re?re.length:0),Ce=Y.length+(te?te.length:0);if(pe!==Ce)return pe-Ce;const x=ee.getItemPath(B),U=ee.getItemPath(H);return x&&U&&x.length!==U.length?x.length-U.length:J!==Y?(0,u.$gr)(J,Y,Z.normalized):re&&te&&re!==te?(0,u.$gr)(re,te,Z.normalized):x&&U&&x!==U?(0,u.$gr)(x,U,Z.normalized):0}function z(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function F(B){typeof B!="string"&&(B="");const H=B.toLowerCase(),{pathNormalized:Z,normalized:ee,normalizedLowercase:J}=N(B),Y=Z.indexOf(R.sep)>=0,re=z(B);let te;const pe=B.split(j);if(pe.length>1)for(const Ce of pe){const x=z(Ce),{pathNormalized:U,normalized:ne,normalizedLowercase:be}=N(Ce);ne&&(te||(te=[]),te.push({original:Ce,originalLowercase:Ce.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:be,expectContiguousMatch:x}))}return{original:B,originalLowercase:H,pathNormalized:Z,normalized:ee,normalizedLowercase:J,values:te,containsPathSeparator:Y,expectContiguousMatch:re}}function N(B){let H;M.$i?H=B.replace(/\//g,R.sep):H=B.replace(/\\/g,R.sep);const Z=(0,b.$af)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function T(B){return Array.isArray(B)?F(B.map(H=>H.original).join(j)):F(B.original)}}),define(ke[101],Ee([1,0,17]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Fs=R,e.$Gs=M,e.$Hs=b,e.$Is=E,e.$Es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const P=(0,u.$pc)(A),$=O[P.toLowerCase()];return $!==void 0?$:M(A)}function M(A){const P=(0,u.$pc)(A);return L[P.toLowerCase()]}function b(A){for(const P in L)if(L[P]===A)return P}const p=/^(.+)\/(.+?)(;.+)?$/;function E(A,P){const $=p.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:P?void 0:A}}),define(ke[102],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$dm=R,e.$em=M;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(b,...p){const E=p.reduce(($,S)=>($[S]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!E[$]).forEach($=>{for(let S=0;S<A.length;S++)if($.search(A[S])!==-1){delete b[$];break}})}function M(b){b&&(delete b.DEBUG,u.$j&&delete b.DYLD_LIBRARY_PATH,u.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function b(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!L.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!R.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(l,c){return!l&&!c?"file":l}function E(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==P&&(c=P+c):c=P;break}return c}const A="",P="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(c){return c instanceof S?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,g,D,w,k=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=p(c,k),this.authority=h||A,this.path=E(this.scheme,g||A),this.query=D||A,this.fragment=w||A,b(this,k))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:g,path:D,query:w,fragment:k}=c;return h===void 0?h=this.scheme:h===null&&(h=A),g===void 0?g=this.authority:g===null&&(g=A),D===void 0?D=this.path:D===null&&(D=A),w===void 0?w=this.query:w===null&&(w=A),k===void 0?k=this.fragment:k===null&&(k=A),h===this.scheme&&g===this.authority&&D===this.path&&w===this.query&&k===this.fragment?this:new m(h,g,D,w,k)}static parse(c,h=!1){const g=$.exec(c);return g?new m(g[2]||A,d(g[4]||A),d(g[5]||A),d(g[7]||A),d(g[9]||A),h):new m(A,A,A,A,A)}static file(c){let h=A;if(O.$i&&(c=c.replace(/\\/g,P)),c[0]===P&&c[1]===P){const g=c.indexOf(P,2);g===-1?(h=c.substring(2),c=P):(h=c.substring(2,g),c=c.substring(g)||P)}return new m("file",h,c,A,A)}static from(c,h){return new m(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return O.$i&&c.scheme==="file"?g=S.file(u.$gc.join(r(c,!0),...h)).path:g=u.$hc.join(c.path,...h),c.with({path:g})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof S)return c;{const h=new m(c);return h._formatted=c.external??null,h._fsPath=c._sep===a?c.fsPath??null:null,h}}else return c}}e.URI=S;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const a=O.$i?1:void 0;class m extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,c,h){let g,D=-1;for(let w=0;w<l.length;w++){const k=l.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||c&&k===47||h&&k===91||h&&k===93||h&&k===58)D!==-1&&(g+=encodeURIComponent(l.substring(D,w)),D=-1),g!==void 0&&(g+=l.charAt(w));else{g===void 0&&(g=l.substr(0,w));const y=o[k];y!==void 0?(D!==-1&&(g+=encodeURIComponent(l.substring(D,w)),D=-1),g+=y):D===-1&&(D=w)}}return D!==-1&&(g+=encodeURIComponent(l.substring(D))),g!==void 0?g:l}function i(l){let c;for(let h=0;h<l.length;h++){const g=l.charCodeAt(h);g===35||g===63?(c===void 0&&(c=l.substr(0,h)),c+=o[g]):c!==void 0&&(c+=l[h])}return c!==void 0?c:l}function r(l,c){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,O.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,c){const h=c?i:n;let g="",{scheme:D,authority:w,path:k,query:y,fragment:C}=l;if(D&&(g+=D,g+=":"),(w||D==="file")&&(g+=P,g+=P),w){let I=w.indexOf("@");if(I!==-1){const z=w.substr(0,I);w=w.substr(I+1),I=z.lastIndexOf(":"),I===-1?g+=h(z,!1,!1):(g+=h(z.substr(0,I),!1,!1),g+=":",g+=h(z.substr(I+1),!1,!0)),g+="@"}w=w.toLowerCase(),I=w.lastIndexOf(":"),I===-1?g+=h(w,!1,!0):(g+=h(w.substr(0,I),!1,!0),g+=w.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}g+=h(k,!0,!1)}return y&&(g+="?",g+=h(y,!1,!1)),C&&(g+="#",g+=c?C:n(C,!1,!1)),g}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,c=>t(c)):l}}),define(ke[192],Ee([1,0,2]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=O,e.$Lq=L,e.$Mq=R,e.log=b;function O(E){const A=E;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(E){const A=[];let P;try{const $=JSON.parse(E.arguments),S=$[$.length-1];S&&S.__$stack&&($.pop(),P=S.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",E.arguments)}return{args:A,stack:P}}function R(E){if(typeof E!="string")return R(L(E).stack);const A=E;if(A){const P=M(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if($&&$.length===4)return{uri:u.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function M(E){if(!E)return E;const A=E.indexOf(`
`);return A===-1?E:E.substring(0,A)}function b(E,A){const{args:P,stack:$}=L(E),S=typeof P[0]=="string"&&P.length===1;let v=M($);v&&(v=`(${v.trim()})`);let a=[];if(typeof P[0]=="string"?v&&S?a=[`%c[${A}] %c${P[0]} %c${v}`,p("blue"),p(""),p("grey")]:a=[`%c[${A}] %c${P[0]}`,p("blue"),p(""),...P.slice(1)]:a=[`%c[${A}]%`,p("blue"),...P],v&&!S&&a.push(v),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,a)}function p(E){return`color: ${E}`}}),define(ke[58],Ee([1,0,21,2]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=L,e.$Vh=R,e.$Wh=b;function L(p){return JSON.stringify(p,M)}function R(p){let E=JSON.parse(p);return E=b(E),E}function M(p,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b(p,E=0){if(!p||E>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return O.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof u.$ze||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let A=0;A<p.length;++A)p[A]=b(p[A],E+1);else for(const A in p)Object.hasOwnProperty.call(p,A)&&(p[A]=b(p[A],E+1))}return p}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=p,e.$xg=E,e.$Bg=P;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function p(v,a){return R.URI.isUri(v)?(0,L.$qf)(v.scheme,a):(0,L.$rf)(v,a+":")}function E(v,...a){return a.some(m=>p(v,m))}e.$yg="vscode-tkn",e.$zg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=P(a,m)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,b.vscodeRemoteResource)}set(a,m,o){this.a[a]=m,this.b[a]=o}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(s){return u.$1(s),a}const m=a.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(r+=`&${e.$zg}=${encodeURIComponent(i)}`),R.URI.from({scheme:O.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:r})}}e.$Ag=new A;function P(v,a){return M.$hc.join(a??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class ${static{this.a=e.$Gg}asBrowserUri(a){const m=this.b(a,he);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===b.vscodeRemote?e.$Ag.rewrite(a):a.scheme===b.file&&(O.$m||O.$q===`${b.vscodeFileResource}://${$.a}`)?a.with({scheme:b.vscodeFileResource,authority:a.authority||$.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,he);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===b.vscodeFileResource?a.with({scheme:b.file,authority:a.authority!==$.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$Hg=new $;var S;(function(v){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:R.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}v.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}v.addSearchParam=n})(S||(e.COI=S={}))}),define(ke[193],Ee([1,0,162,15,11,2]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=A;class M{constructor($,S,v){this.id=$,this.dependencies=S,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,S,v)=>{typeof $!="string"&&(v=S,S=$,$=null),(typeof S!="object"||!Array.isArray(S))&&(v=S,S=null),this.c.push(new M($,S,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const S=await(this.a?this.i($):this.b?this.h($):this.j($));if(!S)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h($){return new Promise((S,v)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",o),a.removeEventListener("error",n)},o=i=>{m(),S(this.c.pop())},n=i=>{m(),v(i)};a.addEventListener("load",o),a.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),a.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(a)})}i($){return new Promise((S,v)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),S(this.c.pop())}catch(a){v(a)}})}async j($){try{const S=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=R.URI.parse($).fsPath,o=S.readFileSync(m).toString(),n=a.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const p=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function A(P,$,S){if(u.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[P]&&(P=E[P]);const v=`${P}/${$}`;if(p.has(v))return p.get(v);let a;if(/^\w[\w\d+.-]*:\/\//.test(v))a=v;else{const i=`${S&&!L.$o?O.$Eg:O.$Dg}/${v}`;a=O.$Hg.asBrowserUri(i).toString(!0)}const m=b.INSTANCE.load(a);return p.set(v,m),m}else return await new Promise((v,a)=>{he([P],v,a)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=p,e.$0g=A,e.$$g=$;function p(S){return(0,b.$xc)(S,!0)}class E{constructor(v){this.a=v}compare(v,a,m=!1){return v===a?0:(0,M.$jf)(this.getComparisonKey(v,m),this.getComparisonKey(a,m))}isEqual(v,a,m=!1){return v===a?!0:!v||!a?!1:this.getComparisonKey(v,m)===this.getComparisonKey(a,m)}getComparisonKey(v,a=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,a,m=!1){if(v.scheme===a.scheme){if(v.scheme===O.Schemas.file)return u.$ng(p(v),p(a),this.a(v))&&v.query===a.query&&(m||v.fragment===a.fragment);if((0,e.$6g)(v.authority,a.authority))return u.$ng(v.path,a.path,this.a(v),"/")&&v.query===a.query&&(m||v.fragment===a.fragment)}return!1}joinPath(v,...a){return b.URI.joinPath(v,...a)}basenameOrAuthority(v){return(0,e.$Xg)(v)||v.authority}basename(v){return L.$hc.basename(v.path)}extname(v){return L.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let a;return v.scheme===O.Schemas.file?a=b.URI.file(L.$nc(p(v))).path:(a=L.$hc.dirname(v.path),v.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),a="/")),v.with({path:a})}normalizePath(v){if(!v.path.length)return v;let a;return v.scheme===O.Schemas.file?a=b.URI.file(L.$ic(p(v))).path:a=L.$hc.normalize(v.path),v.with({path:a})}relativePath(v,a){if(v.scheme!==a.scheme||!(0,e.$6g)(v.authority,a.authority))return;if(v.scheme===O.Schemas.file){const n=L.$mc(p(v),p(a));return R.$i?u.$hg(n):n}let m=v.path||"/";const o=a.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(m.length,o.length);n<i&&!(m.charCodeAt(n)!==o.charCodeAt(n)&&m.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);m=o.substr(0,n)+m.substr(n)}return L.$hc.relative(m,o)}resolvePath(v,a){if(v.scheme===O.Schemas.file){const m=b.URI.file(L.$lc(p(v),a));return v.with({authority:m.authority,path:m.path})}return a=u.$ig(a),v.with({path:L.$hc.resolve(v.path,a)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,a){return v===a||v!==void 0&&a!==void 0&&(0,M.$qf)(v,a)}hasTrailingPathSeparator(v,a=L.sep){if(v.scheme===O.Schemas.file){const m=p(v);return m.length>u.$jg(m).length&&m[m.length-1]===a}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,a=L.sep){return(0,e.$7g)(v,a)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,a=L.sep){let m=!1;if(v.scheme===O.Schemas.file){const o=p(v);m=o!==void 0&&o.length===u.$jg(o).length&&o[o.length-1]===a}else{a="/";const o=v.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$7g)(v,a)?v.with({path:v.path+"/"}):v}}e.$Pg=E,e.$Qg=new E(()=>!1),e.$Rg=new E(S=>S.scheme===O.Schemas.file?!R.$k:!0),e.$Sg=new E(S=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function A(S,v){const a=[];for(let m=0;m<S.length;m++){const o=v(S[m]);S.some((n,i)=>i===m?!1:(0,e.$Ug)(o,v(n)))||a.push(S[m])}return a}var P;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function v(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&m.set(S.META_DATA_MIME,n),m}S.parseMetaData=v})(P||(e.DataUri=P={}));function $(S,v,a){if(v){let m=S.path;return m&&m[0]!==L.$hc.sep&&(m=L.$hc.sep+m),S.with({scheme:a,authority:v,path:m})}return S.with({scheme:a})}}),define(ke[7],Ee([1,0,22,13,4,3,23,11,169,46]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=A,e.$ah=P,e.$bh=$,e.$ch=S,e.$dh=v,e.$eh=a,e.$fh=m,e.$gh=o,e.$oh=h,e.$ph=g,e.$qh=D,e.$rh=w,e.$sh=k,e.$Hh=J,e.$Ph=ae;function A(se){return!!se&&typeof se.then=="function"}function P(se){const K=new u.$je,ie=se(K.token),le=new Promise((de,Ae)=>{const me=K.token.onCancellationRequested(()=>{me.dispose(),Ae(new O.$5)});Promise.resolve(ie).then(Pe=>{me.dispose(),K.dispose(),de(Pe)},Pe=>{me.dispose(),K.dispose(),Ae(Pe)})});return new class{cancel(){K.cancel(),K.dispose()}then(de,Ae){return le.then(de,Ae)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function $(se,K,ie){return new Promise((le,de)=>{const Ae=K.onCancellationRequested(()=>{Ae.dispose(),le(ie)});se.then(le,de).finally(()=>Ae.dispose())})}function S(se,K){return new Promise((ie,le)=>{const de=K.onCancellationRequested(()=>{de.dispose(),le(new O.$5)});se.then(ie,le).finally(()=>de.dispose())})}async function v(se){let K=-1;const ie=se.map((le,de)=>le.then(Ae=>(K=de,Ae)));try{return await Promise.race(ie)}finally{se.forEach((le,de)=>{de!==K&&le.cancel()})}}function a(se,K,ie){let le;const de=setTimeout(()=>{le?.(void 0),ie?.()},K);return Promise.race([se.finally(()=>clearTimeout(de)),new Promise(Ae=>le=Ae)])}function m(se){return new Promise((K,ie)=>{const le=se();A(le)?le.then(K,ie):K(le)})}function o(){let se,K;return{promise:new Promise((le,de)=>{se=le,K=de}),resolve:se,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ie=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(ie,ie).then(le)})}return new Promise((ie,le)=>{this.b.then(ie,le)})}return this.a=K(),new Promise((ie,le)=>{this.a.then(de=>{this.a=null,ie(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$hh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$ih=i;class r{constructor(){this.a=new Map}queue(K,ie){const de=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(K)===de&&this.a.delete(K)});return this.a.set(K,de),de}}e.$jh=r;const s=(se,K)=>{let ie=!0;const le=setTimeout(()=>{ie=!1,K()},se);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(le),ie=!1}}},t=se=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,se())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class f{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ie=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((de,Ae)=>{this.d=de,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=ie===p.$9d?t(le):s(ie,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=f;class d{constructor(K){this.a=new f(K),this.b=new n}trigger(K,ie){return this.a.trigger(()=>this.b.queue(K),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=d;class l{constructor(){this.a=!1,this.b=new Promise((K,ie)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=l;class c extends l{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$nh=c;function h(se,K){return K?new Promise((ie,le)=>{const de=setTimeout(()=>{Ae.dispose(),ie()},se),Ae=K.onCancellationRequested(()=>{clearTimeout(de),Ae.dispose(),le(new O.$5)})}):P(ie=>h(se,ie))}function g(se,K=0,ie){const le=setTimeout(()=>{se(),ie&&de.dispose()},K),de=(0,R.$Sc)(()=>{clearTimeout(le),ie?.deleteAndLeak(de)});return ie?.add(de),de}function D(se){const K=[];let ie=0;const le=se.length;function de(){return ie<le?se[ie++]():null}function Ae(me){me!=null&&K.push(me);const Pe=de();return Pe?Pe.then(Ae):Promise.resolve(K)}return Promise.resolve(null).then(Ae)}function w(se,K=le=>!!le,ie=null){let le=0;const de=se.length,Ae=()=>{if(le>=de)return Promise.resolve(ie);const me=se[le++];return Promise.resolve(me()).then(Me=>K(Me)?Promise.resolve(Me):Ae())};return Ae()}function k(se,K=le=>!!le,ie=null){if(se.length===0)return Promise.resolve(ie);let le=se.length;const de=()=>{le=-1;for(const Ae of se)Ae.cancel?.()};return new Promise((Ae,me)=>{for(const Pe of se)Pe.then(Me=>{--le>=0&&K(Me)?(de(),Ae(Me)):le===0&&Ae(ie)}).catch(Me=>{--le>=0&&(de(),me(Me))})})}class y{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new L.$_d}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,le)=>{this.g.push({factory:K,c:ie,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ie=K.factory();ie.then(K.c,K.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=y;class C extends y{constructor(){super(1)}}e.$uh=C;class I{constructor(){this.a=new Y,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$vh=I;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new pe;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ie=M.$Qg){const le=ie.getComparisonKey(K);return this.a.get(le)?.size??0}queueFor(K,ie,le=M.$Qg){const de=le.getComparisonKey(K);let Ae=this.a.get(de);if(!Ae){Ae=new C;const me=this.f++,Pe=L.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(me,Pe),this.a.set(de,Ae)}return Ae.queue(ie)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=z;class j{constructor(K,ie){this.a=-1,typeof K=="function"&&typeof ie=="number"&&this.setIfNotSet(K,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ie)}setIfNotSet(K,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ie))}}e.$xh=j;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ie,le=globalThis){this.cancel();const de=le.setInterval(()=>{K()},ie);this.d=(0,R.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$yh=F;class N{constructor(K,ie){this.b=-1,this.a=K,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=N;class T{constructor(K,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=K,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=T;class B extends N{constructor(K,ie){super(K,ie),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Bh=B;class H extends R.$Uc{constructor(K,ie){super(),this.g=K,this.h=ie,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of K)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(se,K)=>{(0,b.$B)(()=>{if(ie)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Eh=(se,K,ie)=>{const le=se.requestIdleCallback(K,typeof ie=="number"?{timeout:ie}:void 0);let de=!1;return{dispose(){de||(de=!0,se.cancelIdleCallback(le))}}},e.$Dh=se=>(0,e.$Eh)(globalThis,se)}();class Z{constructor(K,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Eh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=Z;class ee extends Z{constructor(K){super(globalThis,K)}}e.$Gh=ee;async function J(se,K,ie){let le;for(let de=0;de<ie;de++)try{return await se()}catch(Ae){le=Ae,await h(K)}throw le}class Y{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ie,le){return this.a={taskId:K,cancel:()=>le?.(),promise:ie},ie.then(()=>this.d(K),()=>this.d(K)),ie}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ie,resolve:le,reject:de}=o();this.b={run:K,promise:ie,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=Y;class re{constructor(K,ie=()=>Date.now()){this.d=K,this.f=ie,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Jh=re;var te;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(te||(te={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ie)=>{this.a=K,this.b=ie})}complete(K){return new Promise(ie=>{this.a(K),this.d={outcome:0,value:K},ie()})}error(K){return new Promise(ie=>{this.b(K),this.d={outcome:1,value:K},ie()})}cancel(){return this.error(new O.$5)}}e.$Kh=pe;var Ce;(function(se){async function K(le){let de;const Ae=await Promise.all(le.map(me=>me.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return Ae}se.settled=K;function ie(le){return new Promise(async(de,Ae)=>{try{await le(de,Ae)}catch(me){Ae(me)}})}se.withAsyncBody=ie})(Ce||(e.Promises=Ce={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=x;class U{constructor(K){this.b=K,this.a=new E.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=U;var ne;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(ne||(ne={}));class be{static fromArray(K){return new be(ie=>{ie.emitMany(K)})}static fromPromise(K){return new be(async ie=>{ie.emitMany(await K)})}static fromPromises(K){return new be(async ie=>{await Promise.all(K.map(async le=>ie.emitOne(await le)))})}static merge(K){return new be(async ie=>{await Promise.all(K.map(async le=>{for await(const de of le)ie.emitOne(de)}))})}static{this.EMPTY=be.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new L.$_d,queueMicrotask(async()=>{const ie={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(K(ie)),this.j()}catch(le){this.k(le)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(K,ie){return new be(async le=>{for await(const de of K)le.emitOne(ie(de))})}map(K){return be.map(this,K)}static filter(K,ie){return new be(async le=>{for await(const de of K)ie(de)&&le.emitOne(de)})}filter(K){return be.filter(this,K)}static coalesce(K){return be.filter(K,ie=>!!ie)}coalesce(){return be.coalesce(this)}static async toPromise(K){const ie=[];for await(const le of K)ie.push(le);return ie}toPromise(){return be.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Nh=be;class De extends be{constructor(K,ie){super(ie),this.l=K}cancel(){this.l.cancel()}}e.$Oh=De;function ae(se){const K=new u.$je,ie=se(K.token);return new De(K,async le=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),K.dispose(),le.reject(new O.$5)});try{for await(const Ae of ie){if(K.token.isCancellationRequested)return;le.emitOne(Ae)}de.dispose(),K.dispose()}catch(Ae){de.dispose(),K.dispose(),le.reject(Ae)}})}class ce{constructor(){this.a=new pe,this.b=new be(le=>{if(K){le.reject(K);return}return ie&&le.emitMany(ie),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let K,ie;this.f=le=>{ie||(ie=[]),ie.push(le)},this.d=le=>{K||(K=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Qh=ce}),define(ke[35],Ee([1,0,19,7,34,27,17,11,14]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$ck=E,e.$fk=v,e.$gk=C,e.$hk=I,e.$ik=z,e.$jk=j,e.$kk=F,e.$lk=H;function E(){return Object.create(null)}e.$dk="**",e.$ek="/";const A="[/\\\\]",P="[^/\\\\]",$=/\//g;function S(Z,ee){switch(Z){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${ee?`|${A}${P}+`:""})*?`}}function v(Z,ee){if(!Z)return[];const J=[];let Y=!1,re=!1,te="";for(const pe of Z){switch(pe){case ee:if(!Y&&!re){J.push(te),te="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":re=!0;break;case"]":re=!1;break}te+=pe}return te&&J.push(te),J}function a(Z){if(!Z)return"";let ee="";const J=v(Z,e.$ek);if(J.every(Y=>Y===e.$dk))ee=".*";else{let Y=!1;J.forEach((re,te)=>{if(re===e.$dk){if(Y)return;ee+=S(2,te===J.length-1)}else{let pe=!1,Ce="",x=!1,U="";for(const ne of re){if(ne!=="}"&&pe){Ce+=ne;continue}if(x&&(ne!=="]"||!U)){let be;ne==="-"?be=ne:(ne==="^"||ne==="!")&&!U?be="^":ne===e.$ek?be="":be=(0,p.$5e)(ne),U+=be;continue}switch(ne){case"{":pe=!0;continue;case"[":x=!0;continue;case"}":{const De=`(?:${v(Ce,",").map(ae=>a(ae)).join("|")})`;ee+=De,pe=!1,Ce="";break}case"]":{ee+="["+U+"]",x=!1,U="";break}case"?":ee+=P;continue;case"*":ee+=S(1);continue;default:ee+=(0,p.$5e)(ne)}}te<J.length-1&&(J[te+1]!==e.$dk||te+2<J.length)&&(ee+=A)}Y=re===e.$dk})}return ee}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),f=function(){return!1},d=function(){return null};function l(Z,ee){if(!Z)return d;let J;typeof Z!="string"?J=Z.pattern:J=Z,J=J.trim();const Y=`${J}_${!!ee.trimForExclusions}`;let re=t.get(Y);if(re)return c(re,Z);let te;return m.test(J)?re=g(J.substr(4),J):(te=o.exec(h(J,ee)))?re=D(te[1],J):(ee.trimForExclusions?i:n).test(J)?re=w(J,ee):(te=r.exec(h(J,ee)))?re=k(te[1].substr(1),J,!0):(te=s.exec(h(J,ee)))?re=k(te[1],J,!1):re=y(J),t.set(Y,re),c(re,Z)}function c(Z,ee){if(typeof ee=="string")return Z;const J=function(Y,re){return(0,L.$ng)(Y,ee.base,!b.$k)?Z((0,p.$0e)(Y.substr(ee.base.length),M.sep),re):null};return J.allBasenames=Z.allBasenames,J.allPaths=Z.allPaths,J.basenames=Z.basenames,J.patterns=Z.patterns,J}function h(Z,ee){return ee.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function g(Z,ee){return function(J,Y){return typeof J=="string"&&J.endsWith(Z)?ee:null}}function D(Z,ee){const J=`/${Z}`,Y=`\\${Z}`,re=function(pe,Ce){return typeof pe!="string"?null:Ce?Ce===Z?ee:null:pe===Z||pe.endsWith(J)||pe.endsWith(Y)?ee:null},te=[Z];return re.basenames=te,re.patterns=[ee],re.allBasenames=te,re}function w(Z,ee){const J=B(Z.slice(1,-1).split(",").map(Ce=>l(Ce,ee)).filter(Ce=>Ce!==d),Z),Y=J.length;if(!Y)return d;if(Y===1)return J[0];const re=function(Ce,x){for(let U=0,ne=J.length;U<ne;U++)if(J[U](Ce,x))return Z;return null},te=J.find(Ce=>!!Ce.allBasenames);te&&(re.allBasenames=te.allBasenames);const pe=J.reduce((Ce,x)=>x.allPaths?Ce.concat(x.allPaths):Ce,[]);return pe.length&&(re.allPaths=pe),re}function k(Z,ee,J){const Y=M.sep===M.$hc.sep,re=Y?Z:Z.replace($,M.sep),te=M.sep+re,pe=M.$hc.sep+Z;let Ce;return J?Ce=function(x,U){return typeof x=="string"&&(x===re||x.endsWith(te)||!Y&&(x===Z||x.endsWith(pe)))?ee:null}:Ce=function(x,U){return typeof x=="string"&&(x===re||!Y&&x===Z)?ee:null},Ce.allPaths=[(J?"*/":"./")+Z],Ce}function y(Z){try{const ee=new RegExp(`^${a(Z)}$`);return function(J){return ee.lastIndex=0,typeof J=="string"&&ee.test(J)?Z:null}}catch{return d}}function C(Z,ee,J){return!Z||typeof ee!="string"?!1:I(Z)(ee,void 0,J)}function I(Z,ee={}){if(!Z)return f;if(typeof Z=="string"||z(Z)){const J=l(Z,ee);if(J===d)return f;const Y=function(re,te){return!!J(re,te)};return J.allBasenames&&(Y.allBasenames=J.allBasenames),J.allPaths&&(Y.allPaths=J.allPaths),Y}return N(Z,ee)}function z(Z){const ee=Z;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}function j(Z){return Z.allBasenames||[]}function F(Z){return Z.allPaths||[]}function N(Z,ee){const J=B(Object.getOwnPropertyNames(Z).map(Ce=>T(Ce,Z[Ce],ee)).filter(Ce=>Ce!==d)),Y=J.length;if(!Y)return d;if(!J.some(Ce=>!!Ce.requiresSiblings)){if(Y===1)return J[0];const Ce=function(ne,be){let De;for(let ae=0,ce=J.length;ae<ce;ae++){const se=J[ae](ne,be);if(typeof se=="string")return se;(0,O.$_g)(se)&&(De||(De=[]),De.push(se))}return De?(async()=>{for(const ae of De){const ce=await ae;if(typeof ce=="string")return ce}return null})():null},x=J.find(ne=>!!ne.allBasenames);x&&(Ce.allBasenames=x.allBasenames);const U=J.reduce((ne,be)=>be.allPaths?ne.concat(be.allPaths):ne,[]);return U.length&&(Ce.allPaths=U),Ce}const re=function(Ce,x,U){let ne,be;for(let De=0,ae=J.length;De<ae;De++){const ce=J[De];ce.requiresSiblings&&U&&(x||(x=(0,M.$oc)(Ce)),ne||(ne=x.substr(0,x.length-(0,M.$pc)(Ce).length)));const se=ce(Ce,x,ne,U);if(typeof se=="string")return se;(0,O.$_g)(se)&&(be||(be=[]),be.push(se))}return be?(async()=>{for(const De of be){const ae=await De;if(typeof ae=="string")return ae}return null})():null},te=J.find(Ce=>!!Ce.allBasenames);te&&(re.allBasenames=te.allBasenames);const pe=J.reduce((Ce,x)=>x.allPaths?Ce.concat(x.allPaths):Ce,[]);return pe.length&&(re.allPaths=pe),re}function T(Z,ee,J){if(ee===!1)return d;const Y=l(Z,J);if(Y===d)return d;if(typeof ee=="boolean")return Y;if(ee){const re=ee.when;if(typeof re=="string"){const te=(pe,Ce,x,U)=>{if(!U||!Y(pe,Ce))return null;const ne=re.replace("$(basename)",()=>x),be=U(ne);return(0,O.$_g)(be)?be.then(De=>De?Z:null):be?Z:null};return te.requiresSiblings=!0,te}}return Y}function B(Z,ee){const J=Z.filter(Ce=>!!Ce.basenames);if(J.length<2)return Z;const Y=J.reduce((Ce,x)=>{const U=x.basenames;return U?Ce.concat(U):Ce},[]);let re;if(ee){re=[];for(let Ce=0,x=Y.length;Ce<x;Ce++)re.push(ee)}else re=J.reduce((Ce,x)=>{const U=x.patterns;return U?Ce.concat(U):Ce},[]);const te=function(Ce,x){if(typeof Ce!="string")return null;if(!x){let ne;for(ne=Ce.length;ne>0;ne--){const be=Ce.charCodeAt(ne-1);if(be===47||be===92)break}x=Ce.substr(ne)}const U=Y.indexOf(x);return U!==-1?re[U]:null};te.basenames=Y,te.patterns=re,te.allBasenames=Y;const pe=Z.filter(Ce=>!Ce.basenames);return pe.push(te),pe}function H(Z,ee){return(0,u.$ub)(Z,ee,(J,Y)=>typeof J=="string"&&typeof Y=="string"?J===Y:typeof J!="string"&&typeof Y!="string"?J.base===Y.base&&J.pattern===Y.pattern:!1)}}),define(ke[80],Ee([1,0,13,171,23,14,2]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.MarkdownStringTextNewlineStyle=void 0,e.$Lk=E,e.$Mk=A,e.$Nk=P,e.$Ok=$,e.$Pk=S,e.$Qk=v,e.$Rk=a,e.$Sk=m;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class p{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=$(this.supportThemeIcons?(0,O.$Ek)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${S(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,R.$5e)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Kk=p;function E(o){return A(o)?!o.value:Array.isArray(o)?o.every(E):!0}function A(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function P(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,L.$Tg)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function $(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function a(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),c=isFinite(parseInt(f));l&&n.push(`width="${d}"`),c&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=p,e.$mw=A,e.$nw=$,e.$ow=S,e.$pw=o,e.$qw=i,e.$rw=r,e.$sw=s,e.$tw=t,e.$uw=f;function p(l,c){const{os:h,tildify:g,relative:D}=c;if(D){const y=E(l,D,h);if(typeof y=="string")return y}let w=l.fsPath;if(h===1&&!R.$i?w=w.replace(/\//g,"\\"):h!==1&&R.$i&&(w=w.replace(/\\/g,"/")),h!==1&&g?.userHome){const y=g.userHome.fsPath;let C;l.scheme!==g.userHome.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep?C=g.userHome.with({path:l.path}).fsPath:C=w,w=$(C,y,h)}return(h===1?L.$gc:L.$hc).normalize(A(w,h===1))}function E(l,c,h){const g=h===1?L.$gc:L.$hc,D=h===3?M.$Qg:M.$Sg,w=c.getWorkspace(),k=(0,u.$Ob)(w.folders);if(!k)return;l.scheme!==k.uri.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep&&(l=k.uri.with({path:l.path}));const y=c.getWorkspaceFolder(l);if(!y)return;let C;if(D.isEqual(y.uri,l)?C="":C=D.relativePath(y.uri,l)??"",C&&(C=g.normalize(C)),w.folders.length>1&&!c.noPrefix){const I=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${I} \u2022 ${C}`:I}return C}function A(l,c=R.$i){return(0,O.$rg)(l,c)?l.charAt(0).toUpperCase()+l.slice(1):l}let P=Object.create(null);function $(l,c,h=R.OS){if(h===1||!l||!c)return l;let g=P.original===c?P.normalized:void 0;g||(g=c,R.$i&&(g=(0,O.$hg)(g)),g=`${(0,b.$$e)(g,L.$hc.sep)}${L.$hc.sep}`,P={original:c,normalized:g});let D=l;return R.$i&&(D=(0,O.$hg)(D)),(h===3?D.startsWith(g):(0,b.$rf)(D,g))?`~/${D.substr(g.length)}`:l}function S(l,c){return l.replace(/^~($|\/|\\)/,`${c}$1`)}const v="\u2026",a="\\\\",m="~";function o(l,c=L.sep){const h=new Array(l.length);let g=!1;for(let D=0;D<l.length;D++){const w=l[D];if(w===""){h[D]=`.${c}`;continue}if(!w){h[D]=w;continue}g=!0;let k="",y=w;y.indexOf(a)===0?(k=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(c)===0?(k=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(m)===0&&(k=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const C=y.split(c);for(let I=1;g&&I<=C.length;I++)for(let z=C.length-I;g&&z>=0;z--){g=!1;let j=C.slice(z,z+I).join(c);for(let F=0;!g&&F<l.length;F++)if(F!==D&&l[F]&&l[F].indexOf(j)>-1){const N=z+I===C.length,T=z>0&&l[F].indexOf(c)>-1?c+j:j,B=l[F].endsWith(T);g=!N||B}if(!g){let F="";(C[0].endsWith(":")||k!=="")&&(z===1&&(z=0,I++,j=C[0]+c+j),z>0&&(F=C[0]+c),F=k+F),z>0&&(F=F+v+c),F=F+j,z+I<C.length&&(F=F+c+v),h[D]=F}}g&&(h[D]=w)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,c=Object.create(null)){const h=[];let g=!1,D="";for(const w of l)if(w==="$"||g&&w==="{")D&&h.push({value:D,type:n.TEXT}),D="",g=!0;else if(w==="}"&&g){const k=c[D];if(typeof k=="string")k.length&&h.push({value:k,type:n.VARIABLE});else if(k){const y=h[h.length-1];(!y||y.type!==n.SEPARATOR)&&h.push({value:k.label,type:n.SEPARATOR})}D="",g=!1}else D+=w;return D&&!g&&h.push({value:D,type:n.TEXT}),h.filter((w,k)=>{if(w.type===n.SEPARATOR){const y=h[k-1],C=h[k+1];return[y,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(w=>w.value).join("")}function r(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,""):R.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const c=l.lastIndexOf(" [",l.length-2);if(c!==-1){const h=d(l.substring(0,c)),g=l.substring(c);return{name:h.name+g,parentPath:h.parentPath}}}return d(l)}function d(l){const c=l.indexOf("/")!==-1?L.$hc:L.$gc,h=c.basename(l),g=c.dirname(l);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0,e.$rn=b,e.$sn=E,e.$tn=A;function L(P){return P.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const S=this.a.transformIncoming($);return S===$?$:L(O.URI.from(S))}transformOutgoing($){const S=this.a.transformOutgoing($);return S===$?$:L(O.URI.from(S))}transformOutgoingURI($){const S=this.a.transformOutgoing($);return S===$?$:O.URI.from(S)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$pn=R,e.$qn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function M(P,$,S){if(!P||S>200)return null;if(typeof P=="object"){if(P instanceof O.URI)return $.transformOutgoing(P);for(const v in P)if(Object.hasOwnProperty.call(P,v)){const a=M(P[v],$,S+1);a!==null&&(P[v]=a)}}return null}function b(P,$){const S=M(P,$,0);return S===null?P:S}function p(P,$,S,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return S?O.URI.revive($.transformIncoming(P)):$.transformIncoming(P);if(P instanceof u.$ze)return null;for(const a in P)if(Object.hasOwnProperty.call(P,a)){const m=p(P[a],$,S,v+1);m!==null&&(P[a]=m)}}return null}function E(P,$){const S=p(P,$,!1,0);return S===null?P:S}function A(P,$){const S=p(P,$,!0,0);return S===null?P:S}}),define(ke[31],Ee([1,0,52,64,395,7,34,76,17,11,23,2]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=D;var $;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function S(T,B=$.UNLINK,H){if((0,M.$qg)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===$.UNLINK?a(T):v(T,H)}async function v(T,B=(0,M.$vg)((0,O.tmpdir)())){try{try{await u.promises.rename(T,B)}catch(H){return H.code==="ENOENT"?void 0:a(T)}a(B).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function a(T){return(0,L.promisify)(u.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,M.$qg)(T))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function o(T,B){return r(await(B?n(T):(0,L.promisify)(u.readdir)(T)))}async function n(T){try{return await(0,L.promisify)(u.readdir)(T,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const B=[],H=await o(T);for(const Z of H){let ee=!1,J=!1,Y=!1;try{const re=await e.Promises.lstat((0,p.$kc)(T,Z));ee=re.isFile(),J=re.isDirectory(),Y=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}B.push({name:Z,isFile:()=>ee,isDirectory:()=>J,isSymbolicLink:()=>Y})}return B}function i(T){return r(u.readdirSync(T))}function r(T){return T.map(B=>typeof B=="string"?E.$j?(0,b.$5l)(B):B:(B.name=E.$j?(0,b.$5l)(B.name):B.name,B))}async function s(T){const B=await o(T),H=[];for(const Z of B)await f.existsDirectory((0,p.$kc)(T,Z))&&H.push(Z);return H}function t(T,B=1e3){return new Promise(H=>{let Z=!1;const ee=setInterval(()=>{Z||(Z=!0,u.access(T,J=>{Z=!1,J&&(clearInterval(ee),H(void 0))}))},B)})}var f;(function(T){async function B(ee){let J;try{if(J=await e.Promises.lstat(ee),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(E.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw re}throw Y}}T.stat=B;async function H(ee){try{const{stat:J,symbolicLink:Y}=await T.stat(ee);return J.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=H;async function Z(ee){try{const{stat:J,symbolicLink:Y}=await T.stat(ee);return J.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=Z})(f||(e.SymlinkSupport=f={}));const d=new R.$wh;function l(T,B,H){return d.queueFor(P.URI.file(T),()=>{const Z=w(H);return new Promise((ee,J)=>g(T,B,Z,Y=>Y?J(Y):ee()))},A.$Rg)}let c=!0;function h(T){c=T}function g(T,B,H,Z){if(!c)return u.writeFile(T,B,{mode:H.mode,flag:H.flag},Z);u.open(T,H.flag,H.mode,(ee,J)=>{if(ee)return Z(ee);u.writeFile(J,B,Y=>{if(Y)return u.close(J,()=>Z(Y));u.fdatasync(J,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),h(!1)),u.close(J,te=>Z(te))))})})}function D(T,B,H){const Z=w(H);if(!c)return u.writeFileSync(T,B,{mode:Z.mode,flag:Z.flag});const ee=u.openSync(T,Z.flag,Z.mode);try{u.writeFileSync(ee,B);try{u.fdatasyncSync(ee)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),h(!1)}}finally{u.closeSync(ee)}}function w(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,B,H=6e4){if(T!==B)try{E.$i&&typeof H=="number"?await y(T,B,Date.now(),H):await(0,L.promisify)(u.rename)(T,B)}catch(Z){if(T.toLowerCase()!==B.toLowerCase()&&Z.code==="EXDEV"||T.endsWith("."))await C(T,B,{preserveSymlinks:!1}),await S(T,$.MOVE);else throw Z}}async function y(T,B,H,Z,ee=0){try{return await(0,L.promisify)(u.rename)(T,B)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-H>=Z)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${J}`),J;if(ee===0){let Y=!1;try{const{stat:re}=await f.stat(B);re.isFile()||(Y=!0)}catch{}if(Y)throw J}return await(0,R.$oh)(Math.min(100,ee*10)),y(T,B,H,Z,ee+1)}}async function C(T,B,H){return z(T,B,{root:{source:T,target:B},options:H,handledSourcePaths:new Set})}const I=511;async function z(T,B,H){if(H.handledSourcePaths.has(T))return;H.handledSourcePaths.add(T);const{stat:Z,symbolicLink:ee}=await f.stat(T);if(ee){if(H.options.preserveSymlinks)try{return await N(T,B,H)}catch{}if(ee.dangling)return}return Z.isDirectory()?j(T,B,Z.mode&I,H):F(T,B,Z.mode&I)}async function j(T,B,H,Z){await e.Promises.mkdir(B,{recursive:!0,mode:H});const ee=await o(T);for(const J of ee)await z((0,p.$kc)(T,J),(0,p.$kc)(B,J),Z)}async function F(T,B,H){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,H)}async function N(T,B,H){let Z=await e.Promises.readlink(T);(0,M.$ng)(Z,H.root.source,!E.$k)&&(Z=(0,p.$kc)(H.root.target,Z.substr(H.root.source.length+1))),await e.Promises.symlink(Z,B)}e.Promises=new class{get access(){return(0,L.promisify)(u.access)}get stat(){return(0,L.promisify)(u.stat)}get lstat(){return(0,L.promisify)(u.lstat)}get utimes(){return(0,L.promisify)(u.utimes)}get read(){return(T,B,H,Z,ee)=>new Promise((J,Y)=>{u.read(T,B,H,Z,ee,(re,te,pe)=>re?Y(re):J({bytesRead:te,buffer:pe}))})}get readFile(){return(0,L.promisify)(u.readFile)}get write(){return(T,B,H,Z,ee)=>new Promise((J,Y)=>{u.write(T,B,H,Z,ee,(re,te,pe)=>re?Y(re):J({bytesWritten:te,buffer:pe}))})}get appendFile(){return(0,L.promisify)(u.appendFile)}get fdatasync(){return(0,L.promisify)(u.fdatasync)}get truncate(){return(0,L.promisify)(u.truncate)}get copyFile(){return(0,L.promisify)(u.copyFile)}get open(){return(0,L.promisify)(u.open)}get close(){return(0,L.promisify)(u.close)}get symlink(){return(0,L.promisify)(u.symlink)}get readlink(){return(0,L.promisify)(u.readlink)}get chmod(){return(0,L.promisify)(u.chmod)}get mkdir(){return(0,L.promisify)(u.mkdir)}get unlink(){return(0,L.promisify)(u.unlink)}get rmdir(){return(0,L.promisify)(u.rmdir)}get realpath(){return(0,L.promisify)(u.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return S}get rename(){return k}get copy(){return C}}}),define(ke[104],Ee([1,0,52,17,11,14,31]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=b,e.$Tq=p,e.$Uq=E,e.$Vq=A;function b($){if(L.$k)return $;const S=(0,O.$nc)($);if($===S)return $;const v=((0,O.$oc)($)||$).toLowerCase();try{const m=(0,M.readdirSync)(S).filter(o=>o.toLowerCase()===v);if(m.length===1){const o=b(S);if(o)return(0,O.$kc)(o,m[0])}else if(m.length>1){const o=m.indexOf(v);if(o>=0){const n=b(S);if(n)return(0,O.$kc)(n,m[o])}}}catch{}return null}async function p($,S){if(L.$k)return $;const v=(0,O.$nc)($);if($===v)return $;const a=((0,O.$oc)($)||$).toLowerCase();try{if(S?.isCancellationRequested)return null;const o=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===a);if(o.length===1){const n=await p(v,S);if(n)return(0,O.$kc)(n,o[0])}else if(o.length>1){const n=o.indexOf(a);if(n>=0){const i=await p(v,S);if(i)return(0,O.$kc)(i,o[n])}}}catch{}return null}async function E($){try{return await M.Promises.realpath($)}catch{const v=P($);return await M.Promises.access(v,u.constants.R_OK),v}}function A($){try{return u.realpathSync($)}catch{const v=P($);return u.accessSync(v,u.constants.R_OK),v}}function P($){return(0,R.$$e)((0,O.$ic)($),O.sep)}}),define(ke[105],Ee([1,0,17,11,51,102,18,31]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$fm=p,e.$gm=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(P=L.env){return P.comspec||"cmd.exe"}function E(P){let $=[],S=!1;const v=function(a){if(S){$.push(a);return}(!P.send(a,o=>{if(o&&console.error(o),S=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>v(i))}})||O.$i)&&(S=!0)};return{send:v}}var A;(function(P){async function $(S,v,a){if(u.$jc(S))return S;if(v===void 0&&(v=L.cwd()),u.$nc(S)!=="."||(a===void 0&&M.$1f(L.env.PATH)&&(a=L.env.PATH.split(u.$uc)),a===void 0||a.length===0))return u.$kc(v,S);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of a){let i;if(u.$jc(n)?i=u.$kc(n,S):i=u.$kc(v,n,S),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return u.$kc(v,S)}P.findExecutable=$})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(he,e,u,O){var L=arguments.length,R=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,u):O,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(he,e,u,O);else for(var b=he.length-1;b>=0;b--)(M=he[b])&&(R=(L<3?M(R):L>3?M(e,u,R):M(e,u))||R);return L>3&&R&&Object.defineProperty(e,u,R),R};define(ke[81],Ee([1,0,19,7,21,22,55,13,4,3,58,14,18]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.ProxyChannel=e.$8h=e.$5h=e.$4h=e.$3h=e.RequestInitiator=e.$2h=e.$Yh=e.$Xh=void 0,e.$Zh=h,e.$1h=g,e.$6h=I,e.$7h=z;var S;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(S||(S={}));function v(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(a||(a={}));function m(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(o||(o={}));function n(ee){let J=0;for(let Y=0;;Y+=7){const re=ee.read(1);if(J|=(re.buffer[0]&127)<<Y,!(re.buffer[0]&128))return J}}const i=d(0);function r(ee,J){if(J===0){ee.write(i);return}let Y=0;for(let te=J;te!==0;te=te>>>7)Y++;const re=L.$ze.alloc(Y);for(let te=0;J!==0;te++)re.buffer[te]=J&127,J=J>>>7,J>0&&(re.buffer[te]|=128);ee.write(re)}class s{constructor(J){this.b=J,this.a=0}read(J){const Y=this.b.slice(this.a,this.a+J);return this.a+=Y.byteLength,Y}}e.$Xh=s;class t{constructor(){this.a=[]}get buffer(){return L.$ze.concat(this.a)}write(J){this.a.push(J)}}e.$Yh=t;var f;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(f||(f={}));function d(ee){const J=L.$ze.alloc(1);return J.writeUInt8(ee,0),J}const l={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},c=typeof Buffer<"u";function h(ee,J){if(typeof J>"u")ee.write(l.Undefined);else if(typeof J=="string"){const Y=L.$ze.fromString(J);ee.write(l.String),r(ee,Y.byteLength),ee.write(Y)}else if(c&&Buffer.isBuffer(J)){const Y=L.$ze.wrap(J);ee.write(l.Buffer),r(ee,Y.byteLength),ee.write(Y)}else if(J instanceof L.$ze)ee.write(l.VSBuffer),r(ee,J.byteLength),ee.write(J);else if(Array.isArray(J)){ee.write(l.Array),r(ee,J.length);for(const Y of J)h(ee,Y)}else if(typeof J=="number"&&(J|0)===J)ee.write(l.Uint),r(ee,J);else{const Y=L.$ze.fromString(JSON.stringify(J));ee.write(l.Object),r(ee,Y.byteLength),ee.write(Y)}}function g(ee){switch(ee.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return ee.read(n(ee)).toString();case f.Buffer:return ee.read(n(ee)).buffer;case f.VSBuffer:return ee.read(n(ee));case f.Array:{const Y=n(ee),re=[];for(let te=0;te<Y;te++)re.push(g(ee));return re}case f.Object:return JSON.parse(ee.read(n(ee)).toString());case f.Int:return n(ee)}}class D{constructor(J,Y,re=null,te=1e3){this.h=J,this.j=Y,this.k=re,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(pe=>this.q(pe)),this.m({type:200})}registerChannel(J,Y){this.b.set(J,Y),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const Y=this.o([J.type]);this.k?.logOutgoing(Y,0,1,m(J.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([J.type,J.id],J.data);this.k?.logOutgoing(Y,J.id,1,m(J.type),J.data);return}}}o(J,Y=void 0){const re=new t;return h(re,J),h(re,Y),this.p(re.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const Y=new s(J),re=g(Y),te=g(Y),pe=re[0];switch(pe){case 100:return this.k?.logIncoming(J.byteLength,re[1],1,`${v(pe)}: ${re[2]}.${re[3]}`,te),this.s({type:pe,id:re[1],channelName:re[2],name:re[3],arg:te});case 102:return this.k?.logIncoming(J.byteLength,re[1],1,`${v(pe)}: ${re[2]}.${re[3]}`,te),this.t({type:pe,id:re[1],channelName:re[2],name:re[3],arg:te});case 101:return this.k?.logIncoming(J.byteLength,re[1],1,`${v(pe)}`),this.u({type:pe,id:re[1]});case 103:return this.k?.logIncoming(J.byteLength,re[1],1,`${v(pe)}`),this.u({type:pe,id:re[1]})}}s(J){const Y=this.b.get(J.channelName);if(!Y){this.v(J);return}const re=new R.$je;let te;try{te=Y.call(this.j,J.name,J.arg,re.token)}catch(x){te=Promise.reject(x)}const pe=J.id;te.then(x=>{this.m({id:pe,data:x,type:201})},x=>{x instanceof Error?this.m({id:pe,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:pe,data:x,type:203})}).finally(()=>{Ce.dispose(),this.d.delete(J.id)});const Ce=(0,E.$Sc)(()=>re.cancel());this.d.set(J.id,Ce)}t(J){const Y=this.b.get(J.channelName);if(!Y){this.v(J);return}const re=J.id,pe=Y.listen(this.j,J.name,J.arg)(Ce=>this.m({id:re,data:Ce,type:204}));this.d.set(J.id,pe)}u(J){const Y=this.d.get(J.id);Y&&(Y.dispose(),this.d.delete(J.id))}v(J){let Y=this.g.get(J.channelName);Y||(Y=[],this.g.set(J.channelName,Y));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:J,timeoutTimer:re})}w(J){const Y=this.g.get(J);if(Y){for(const re of Y)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$2h=D;var w;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class k{constructor(J,Y=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$_d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=Y}getChannel(J){const Y=this;return{call(re,te,pe){return Y.a?Promise.reject(new b.$5):Y.m(J,re,te,pe)},listen(re,te){return Y.a?p.Event.None:Y.o(J,re,te)}}}m(J,Y,re,te=R.CancellationToken.None){const pe=this.g++,x={id:pe,type:100,channelName:J,name:Y,arg:re};if(te.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((be,De)=>{if(te.isCancellationRequested)return De(new b.$5);const ae=()=>{const ie=le=>{switch(le.type){case 201:this.f.delete(pe),be(le.data);break;case 202:{this.f.delete(pe);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,De(de);break}case 203:this.f.delete(pe),De(le.data);break}};this.f.set(pe,ie),this.p(x)};let ce=null;this.b===o.Idle?ae():(ce=(0,O.$ah)(ie=>this.u()),ce.then(()=>{ce=null,ae()}));const se=()=>{ce?(ce.cancel(),ce=null):this.p({id:pe,type:101}),De(new b.$5)},K=te.onCancellationRequested(se);U=(0,E.$Rc)((0,E.$Sc)(se),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,Y,re){const te=this.g++,Ce={id:te,type:102,channelName:J,name:Y,arg:re};let x=null;const U=new p.$_d({onWillAddFirstListener:()=>{x=(0,O.$ah)(be=>this.u()),x.then(()=>{x=null,this.d.add(U),this.p(Ce)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(U),this.p({id:te,type:103}))}}),ne=be=>U.fire(be.data);return this.f.set(te,ne),U.event}p(J){switch(J.type){case 100:case 102:{const Y=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(Y,J.id,0,`${v(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const Y=this.q([J.type,J.id]);this.j?.logOutgoing(Y,J.id,0,v(J.type));return}}}q(J,Y=void 0){const re=new t;return h(re,J),h(re,Y),this.r(re.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const Y=new s(J),re=g(Y),te=g(Y),pe=re[0];switch(pe){case 200:return this.j?.logIncoming(J.byteLength,0,0,m(pe)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,re[1],0,m(pe),te),this.t({type:re[0],id:re[1],data:te})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$3h=k,Je([M.$Rh],k.prototype,"onDidInitializePromise",null);class y{get connections(){const J=[];return this.f.forEach(Y=>J.push(Y)),J}constructor(J,Y,re){this.a=new Map,this.f=new Set,this.g=new p.$_d,this.onDidAddConnection=this.g.event,this.h=new p.$_d,this.onDidRemoveConnection=this.h.event,this.j=new E.$Tc,this.j.add(J(({protocol:te,onDidClientDisconnect:pe})=>{const Ce=p.Event.once(te.onMessage);this.j.add(Ce(x=>{const U=new s(x),ne=g(U),be=new D(te,ne,Y,re),De=new k(te,Y);this.a.forEach((ce,se)=>be.registerChannel(se,ce));const ae={channelServer:be,channelClient:De,ctx:ne};this.f.add(ae),this.g.fire(ae),this.j.add(pe(()=>{be.dispose(),De.dispose(),this.f.delete(ae),this.h.fire(ae)}))}))}))}getChannel(J,Y){const re=this;return{call(te,pe,Ce){let x;if((0,$.$cg)(Y)){const ne=(0,u.$4b)(re.connections.filter(Y));x=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(re.onDidAddConnection,Y))}else x=Y.routeCall(re,te,pe);const U=x.then(ne=>ne.channelClient.getChannel(J));return I(U).call(te,pe,Ce)},listen(te,pe){if((0,$.$cg)(Y))return re.k(J,Y,te,pe);const Ce=Y.routeEvent(re,te,pe).then(x=>x.channelClient.getChannel(J));return I(Ce).listen(te,pe)}}}k(J,Y,re,te){const pe=this;let Ce;const x=new p.$_d({onWillAddFirstListener:()=>{Ce=new E.$Tc;const U=new p.$fe,ne=new Map,be=ae=>{const se=ae.channelClient.getChannel(J).listen(re,te),K=U.add(se);ne.set(ae,K)},De=ae=>{const ce=ne.get(ae);ce&&(ce.dispose(),ne.delete(ae))};pe.connections.filter(Y).forEach(be),p.Event.filter(pe.onDidAddConnection,Y)(be,void 0,Ce),pe.onDidRemoveConnection(De,void 0,Ce),U.event(x.fire,x,Ce),Ce.add(U)},onDidRemoveLastListener:()=>{Ce?.dispose(),Ce=void 0}});return x.event}registerChannel(J,Y){this.a.set(J,Y);for(const re of this.f)re.channelServer.registerChannel(J,Y)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$4h=y;class C{constructor(J,Y,re=null){const te=new t;h(te,Y),J.send(te.buffer),this.a=new k(J,re),this.d=new D(J,Y,re)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,Y){this.d.registerChannel(J,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5h=C;function I(ee){return{call(J,Y,re){return ee.then(te=>te.call(J,Y,re))},listen(J,Y){const re=new p.$ie;return ee.then(te=>re.input=te.listen(J,Y)),re.event}}}function z(ee){let J=!1;return{call(Y,re,te){return J?ee.call(Y,re,te):(0,O.$oh)(0).then(()=>J=!0).then(()=>ee.call(Y,re,te))},listen(Y,re){if(J)return ee.listen(Y,re);const te=new p.$ie;return(0,O.$oh)(0).then(()=>J=!0).then(()=>te.input=ee.listen(Y,re)),te.event}}}class j{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const Y of J.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await p.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$8h=j;var F;(function(ee){function J(pe,Ce,x){const U=pe,ne=x&&x.disableMarshalling,be=new Map;for(const De in U)re(De)&&be.set(De,p.Event.buffer(U[De],!0,void 0,Ce));return new class{listen(De,ae,ce){const se=be.get(ae);if(se)return se;const K=U[ae];if(typeof K=="function"){if(te(ae))return K.call(U,ce);if(re(ae))return be.set(ae,p.Event.buffer(U[ae],!0,void 0,Ce)),be.get(ae)}throw new b.$bb(`Event not found: ${ae}`)}call(De,ae,ce){const se=U[ae];if(typeof se=="function"){if(!ne&&Array.isArray(ce))for(let ie=0;ie<ce.length;ie++)ce[ie]=(0,A.$Wh)(ce[ie]);let K=se.apply(U,ce);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ae}`)}}}ee.fromService=J;function Y(pe,Ce){const x=Ce&&Ce.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return Ce?.properties?.has(ne)?Ce.properties.get(ne):te(ne)?function(be){return pe.listen(ne,be)}:re(ne)?pe.listen(ne):async function(...be){let De;Ce&&!(0,$.$0f)(Ce.context)?De=[Ce.context,...be]:De=be;const ae=await pe.call(ne,De);return x?ae:(0,A.$Wh)(ae)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}ee.toService=Y;function re(pe){return pe[0]==="o"&&pe[1]==="n"&&P.$pf(pe.charCodeAt(2))}function te(pe){return/^onDynamic/.test(pe)&&P.$pf(pe.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const J=ee.toString();if(J!=="[object Object]")return J}return ee}function B(ee){return Array.isArray(ee)?ee.map(T):T(ee)}function H(ee,J,Y,re,te,pe,Ce){Ce=B(Ce);const x=N[te],U=x[re%x.length];let ne=[`%c[${ee}]%c[${String(J).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${pe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(pe)?(ne=ne.concat(Ce),ne.push(")")):ne.push(Ce),console.log.apply(console,ne)}class Z{constructor(J,Y){this.d=J,this.f=Y,this.a=0,this.b=0}logOutgoing(J,Y,re,te,pe){this.b+=J,H(this.d,this.b,J,Y,re,te,pe)}logIncoming(J,Y,re,te,pe){this.a+=J,H(this.f,this.a,J,Y,re,te,pe)}}e.$9h=Z}),define(ke[82],Ee([1,0,21,4,3,81]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.ProtocolConstants=e.$0h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const c=new WeakMap;let h=0;function g(w,k){if(!c.has(w)){const y=String(++h);c.set(w,y)}return c.get(w)}function D(w,k,y,C){if(!l.enableDiagnostics)return;const I=g(w,k);if(C instanceof u.$ze||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=u.$ze.alloc(C.byteLength);z.set(C),l.records.push({timestamp:Date.now(),id:I,label:k,type:y,buff:z})}else l.records.push({timestamp:Date.now(),id:I,label:k,type:y,data:C})}l.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var p;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let E=null;function A(){return E||(E=u.$ze.alloc(0)),E}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const k=this.a[0];return h&&(this.a.shift(),this.b-=c),k}if(this.a[0].byteLength>c){const k=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),k}const g=u.$ze.alloc(c);let D=0,w=0;for(;c>0;){const k=this.a[w];if(k.byteLength>c){const y=k.slice(0,c);g.set(y,D),D+=c,h&&(this.a[w]=k.slice(c),this.b-=c),c-=c}else g.set(k,D),D+=k.byteLength,h?(this.a.shift(),this.b-=k.byteLength):w++,c-=k.byteLength}return g}}e.$0h=P;var $;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})($||($={}));function S(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class a{constructor(c,h,g,D){this.type=c,this.id=h,this.ack=g,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.$Uc{constructor(c){super(),this.f=this.B(new O.$_d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,D=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new a(g,D,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$ze.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const g=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,g}h(){const c=u.$ze.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class n extends L.$Uc{constructor(c){super(),this.f=new O.$_d,this.onMessage=this.f.event,this.g=new O.$_d,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new a(1,0,0,c))}}e.$$h=n;class i extends R.$5h{static fromSocket(c,h){return new i(new n(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,g=null){super(c,h,g),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$_h=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$_d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$ai=r;class s{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,g=this.a;for(;g;)c[h++]=g.data,g=g.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<f.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=f.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+f.a)*1e3;let g=0;for(let D=0;D<f.a;D++)c-this.c[D]<=h&&g++;return 1-g/f.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??f.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new a(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new a(7,0,0,A());this.p.write(c)}sendResume(){const c=new a(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c);const h=this.b.toArray();for(let g=0,D=h.length;g<D;g++)this.p.write(h[g]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new a(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let g=0,D=h.length;g<D;g++)this.p.write(h[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const g=new a(1,h,this.h,c);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(c){const h=new a(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,g=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&g>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:g});return}const w=Math.max(2e4-h,2e4-g,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new a(9,0,this.h,A());this.p.write(c)}}e.$bi=d}),define(ke[194],Ee([1,0,53,7,21,22,192,13,4,3,24,105,102,81]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;class v extends S.$2h{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",n=>L.$ze.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Oq=v;class a{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new p.$_d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new O.$kh(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,r,s){return n.k(o,i,r,s)},listen(i,r){return n.l(o,i,r)}}}k(o,n,i,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(o),t=(0,O.$ah)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,E.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return p.Event.None;this.b.cancel();let r;const s=new p.$_d({onWillAddFirstListener:()=>{r=this.n(o).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Tn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$em)(n.env),this.d=(0,u.fork)(this.i,o,n);const i=new p.$_d,s=p.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,M.$Kq)(h)){(0,M.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$ze.wrap(Buffer.from(h,"base64")))}),t=this.j.useQueue?(0,P.$gm)(this.d):this.d,f=h=>this.d&&this.d.connected&&t.send(h.buffer.toString("base64")),d=i.event,l={send:f,onMessage:d};this.f=new S.$3h(l);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,g)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(D=>(0,E.$Pc)(D)),this.c.clear(),h!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:g})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pq=a}),define(ke[195],Ee([1,0,7,4,3,58,18]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.StorageState=e.StorageHint=void 0,e.$Mp=p;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function p($){const S=$;return S?.changed instanceof Map||S?.deleted instanceof Set}var E;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(E||(e.StorageState=E={}));class A extends L.$Uc{static{this.a=100}constructor(S,v=Object.create(null)){super(),this.r=S,this.s=v,this.b=this.B(new O.$ce),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new u.$lh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((v,a)=>this.w(a,v)),S.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(S,v){if(this.c===E.Closed)return;let a=!1;(0,M.$0f)(v)?a=this.f.delete(S):this.f.get(S)!==v&&(this.f.set(S,v),a=!0),a&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,v){const a=this.f.get(S);return(0,M.$0f)(a)?v:a}getBoolean(S,v){const a=this.get(S);return(0,M.$0f)(a)?v:a==="true"}getNumber(S,v){const a=this.get(S);return(0,M.$0f)(a)?v:parseInt(a,10)}getObject(S,v){const a=this.get(S);return(0,M.$0f)(a)?v:(0,R.$Vh)(a)}async set(S,v,a=!1){if(this.c===E.Closed)return;if((0,M.$0f)(v))return this.delete(S,a);const m=(0,M.$3f)(v)||Array.isArray(v)?(0,R.$Uh)(v):String(v);if(this.f.get(S)!==m)return this.f.set(S,m),this.j.set(S,m),this.h.delete(S),this.b.fire({key:S,external:a}),this.D()}async delete(S,v=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:v}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Np=A;class P{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((v,a)=>this.a.set(a,v)),S.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Op=P}),define(ke[196],Ee([1,0,14,11,21]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0,e.$qt=A,e.$rt=P;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function p(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function A(){return E||(E=O.$D()?M():p()),E}function P(v,a,m){const o=new Uint16Array(v.buffer,a,m);return m>0&&(o[0]===65279||o[0]===65534)?$(v,a,m):M().decode(o)}function $(v,a,m){const o=[];let n=0;for(let i=0;i<m;i++){const r=L.$Be(v,a);a+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class S{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||u.$uf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let o=0;o<m;o++)this.b[this.d++]=a.charCodeAt(o)}}e.$st=S}),define(ke[197],Ee([1,0,21,196]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$ut=M;function L(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,A,P,$){this.oldPosition=E,this.oldText=A,this.newPosition=P,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,A,P){const $=A.length;u.$Ee(E,$,P),P+=4;for(let S=0;S<$;S++)u.$Ce(E,A.charCodeAt(S),P),P+=2;return P}static d(E,A){const P=u.$De(E,A);return A+=4,(0,O.$rt)(E,A,P)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(E,A){return u.$Ee(E,this.oldPosition,A),A+=4,u.$Ee(E,this.newPosition,A),A+=4,A=R.c(E,this.oldText,A),A=R.c(E,this.newText,A),A}static read(E,A,P){const $=u.$De(E,A);A+=4;const S=u.$De(E,A);A+=4;const v=R.d(E,A);A+=R.a(v);const a=R.d(E,A);return A+=R.a(a),P.push(new R($,v,S,a)),A}}e.$tt=R;function M(p,E){return p===null||p.length===0?E:new b(p,E).compress()}class b{constructor(E,A){this.a=E,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,A=0,P=this.n(E),$=this.l(A);for(;E<this.f||A<this.h;){if(P===null){this.k($),$=this.l(++A);continue}if($===null){this.m(P),P=this.n(++E);continue}if($.oldEnd<=P.newPosition){this.k($),$=this.l(++A);continue}if(P.newEnd<=$.oldPosition){this.m(P),P=this.n(++E);continue}if($.oldPosition<P.newPosition){const[o,n]=b.r($,P.newPosition-$.oldPosition);this.k(o),$=n;continue}if(P.newPosition<$.oldPosition){const[o,n]=b.q(P,$.oldPosition-P.newPosition);this.m(o),P=n;continue}let a,m;if($.oldEnd===P.newEnd)a=P,m=$,P=this.n(++E),$=this.l(++A);else if($.oldEnd<P.newEnd){const[o,n]=b.q(P,$.oldLength);a=o,m=$,P=n,$=this.l(++A)}else{const[o,n]=b.r($,P.newLength);a=P,m=o,P=this.n(++E),$=n}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const S=b.s(this.d);return b.t(S)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,A){return new R(A.oldPosition-E,A.oldText,A.newPosition,A.newText)}static p(E,A){return new R(A.oldPosition,A.oldText,A.newPosition+E,A.newText)}static q(E,A){const P=E.newText.substr(0,A),$=E.newText.substr(A);return[new R(E.oldPosition,E.oldText,E.newPosition,P),new R(E.oldEnd,"",E.newPosition+A,$)]}static r(E,A){const P=E.oldText.substr(0,A),$=E.oldText.substr(A);return[new R(E.oldPosition,P,E.newPosition,E.newText),new R(E.oldPosition+A,$,E.newEnd,"")]}static s(E){if(E.length===0)return E;const A=[];let P=0,$=E[0];for(let S=1;S<E.length;S++){const v=E[S];$.oldEnd===v.oldPosition?$=new R($.oldPosition,$.oldText+v.oldText,$.newPosition,$.newText+v.newText):(A[P++]=$,$=v)}return A[P++]=$,A}static t(E){if(E.length===0)return E;const A=[];let P=0;for(let $=0;$<E.length;$++){const S=E[$];S.oldText!==S.newText&&(A[P++]=S)}return A}}}),define(ke[198],Ee([1,0,35,17]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=L,e.$St=R;function L(M,b,p,E,A,P){if(Array.isArray(M)){let $=0;for(const S of M){const v=L(S,b,p,E,A,P);if(v===10)return v;v>$&&($=v)}return $}else{if(typeof M=="string")return E?M==="*"?5:M===p?10:0:0;if(M){const{language:$,pattern:S,scheme:v,hasAccessToAllModels:a,notebookType:m}=M;if(!E&&!a)return 0;m&&A&&(b=A);let o=0;if(v)if(v===b.scheme)o=10;else if(v==="*")o=5;else return 0;if($)if($===p)o=10;else if($==="*")o=Math.max(o,5);else return 0;if(m)if(m===P)o=10;else if(m==="*"&&P!==void 0)o=Math.max(o,5);else return 0;if(S){let n;if(typeof S=="string"?n=S:n={...S,base:(0,O.$ic)(S.base)},n===b.fsPath||(0,u.$gk)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[199],Ee([1,0,4,14,29,79,130,174,197,3]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class A extends E.$Uc{constructor($,S,v,a,m,o,n){super(),this.m=this.B(new u.$_d),this.onDidChangeContent=this.m.event,this.f=S,this.j=!o,this.g=a,this.h=m,this.c=new M.$HC($,v,n)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,S){return this.c.getOffsetAt($,S)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,S){const v=$+S,a=this.getPositionAt($),m=this.getPositionAt(v);return new L.$ht(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange($,S=0){if($.isEmpty())return"";const v=this.n(S);return this.c.getValueInRange($,v)}getValueLengthInRange($,S=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const v=this.getOffsetAt($.startLineNumber,$.startColumn),a=this.getOffsetAt($.endLineNumber,$.endColumn);let m=0;const o=this.n(S),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=$.endLineNumber-$.startLineNumber;m=i*r}return a-v+m}getCharacterCountInRange($,S=0){if(this.j){let v=0;const a=$.startLineNumber,m=$.endLineNumber;for(let o=a;o<=m;o++){const n=this.getLineContent(o),i=o===a?$.startColumn-1:0,r=o===m?$.endColumn-1:n.length;for(let s=i;s<r;s++)O.$uf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(S).length*(m-a),v}return this.getValueLengthInRange($,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,S){return this.c.getLineCharCode($,S)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const S=O.$ff(this.getLineContent($));return S===-1?0:S+1}getLineLastNonWhitespaceColumn($){const S=O.$hf(this.getLineContent($));return S===-1?0:S+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,S,v){let a=this.g,m=this.h,o=this.j,n=!0,i=[];for(let c=0;c<$.length;c++){const h=$[c];n&&h._isTracked&&(n=!1);const g=h.range;if(h.text){let C=!0;o||(C=!O.$Ff(h.text),o=C),!a&&C&&(a=O.$Ef(h.text)),!m&&C&&(m=O.$Hf(h.text))}let D="",w=0,k=0,y=0;if(h.text){let C;[w,k,y,C]=(0,b.$Kt)(h.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,I)}i[c]={sortIndex:c,identifier:h.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:w,firstLineLength:k,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let c=0,h=i.length-1;c<h;c++){const g=i[c].range.getEndPosition(),D=i[c+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=v||S?A._getInverseEditRanges(i):[],t=[];if(S)for(let c=0;c<i.length;c++){const h=i[c],g=s[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let w="";D===g.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),O.$ff(w)!==-1)||t.push({lineNumber:D,oldContent:w})}}let f=null;if(v){let c=0;f=[];for(let h=0;h<i.length;h++){const g=i[h],D=s[h],w=this.getValueInRange(g.range),k=g.rangeOffset+c;c+=g.text.length-w.length,f[h]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:w,textChange:new p.$tt(g.rangeOffset,w,k,g.text)}}r||f.sort((h,g)=>h.sortIndex-g.sortIndex)}this.g=a,this.h=m,this.j=o;const d=this.t(i);let l=null;if(S&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),l=[];for(let c=0,h=t.length;c<h;c++){const g=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===g)continue;const D=t[c].oldContent,w=this.getLineContent(g);w.length===0||w===D||O.$ff(w)!==-1||l.push(g)}}return this.m.fire(),new R.$wv(f,d,l)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let S=!1;const v=$[0].range,a=$[$.length-1].range,m=new L.$ht(v.startLineNumber,v.startColumn,a.endLineNumber,a.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let d=0,l=$.length;d<l;d++){const c=$[d],h=c.range;S=S||c.forceMoveMarkers,i.push(this.getValueInRange(new L.$ht(o,n,h.startLineNumber,h.startColumn))),c.text.length>0&&i.push(c.text),o=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,f]=(0,b.$Kt)(r);return{sortIndex:0,identifier:$[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const S=[];for(let v=0;v<$.length;v++){const a=$[v],m=a.range.startLineNumber,o=a.range.startColumn,n=a.range.endLineNumber,i=a.range.endColumn;if(m===n&&o===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const r=new L.$ht(m,o,n,i);S.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return S}findMatchesLineByLine($,S,v,a){return this.c.findMatchesLineByLine($,S,v,a)}getPieceTree(){return this.c}static _getInverseEditRange($,S){const v=$.startLineNumber,a=$.startColumn,[m,o,n]=(0,b.$Kt)(S);let i;if(S.length>0){const r=m+1;r===1?i=new L.$ht(v,a,v,a+o):i=new L.$ht(v,a,v+r-1,n+1)}else i=new L.$ht(v,a,v,a);return i}static _getInverseEditRanges($){const S=[];let v=0,a=0,m=null;for(let o=0,n=$.length;o<n;o++){const i=$[o];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=v,s=a+(i.range.startColumn-m.range.endColumn)):(r=v+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new L.$ht(r,s,r,s+i.firstLineLength):t=new L.$ht(r,s,r+f-1,i.lastLineLength+1)}else t=new L.$ht(r,s,r,s);v=t.endLineNumber,a=t.endColumn,S.push(t),m=i}return S}static u($,S){const v=L.$ht.compareRangesUsingEnds($.range,S.range);return v===0?$.sortIndex-S.sortIndex:v}static w($,S){const v=L.$ht.compareRangesUsingEnds($.range,S.range);return v===0?S.sortIndex-$.sortIndex:-v}}e.$IC=A}),define(ke[200],Ee([1,0,14,130,199]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=void 0;class R{constructor(p,E,A,P,$,S,v,a,m){this.a=p,this.b=E,this.c=A,this.d=P,this.e=$,this.f=S,this.g=v,this.h=a,this.j=m}k(p){const E=this.c+this.d+this.e,A=this.c+this.e;return E===0?p===1?`
`:`\r
`:A>E/2?`\r
`:`
`}create(p){const E=this.k(p),A=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let $=0,S=A.length;$<S;$++){const v=A[$].buffer.replace(/\r\n|\r|\n/g,E),a=(0,O.$DC)(v);A[$]=new O.$GC(v,a)}const P=new L.$IC(A,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&u.$Of(p)&&(this.b=u.$Nf,p=p.substr(1));const E=p.charCodeAt(p.length-1);E===13||E>=55296&&E<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=E):(this.m(p,!1),this.c=!1,this.d=E)}m(p,E){!E&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const E=(0,O.$EC)(this.e,p);this.a.push(new O.$GC(p,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=u.$Ef(p)),this.k||(this.k=u.$Hf(p)))}finish(p=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const E=(0,O.$DC)(p.buffer);p.lineStarts=E,this.d===13&&this.f++}}}e.$JC=M}),define(ke[134],Ee([1,0,21,11]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zab=p,e.$1ab=A;var L;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(L||(L={}));function R(P){for(let $=0,S=P.length;$<S;$+=4){const v=P[$+0],a=P[$+1],m=P[$+2],o=P[$+3];P[$+0]=o,P[$+1]=m,P[$+2]=a,P[$+3]=v}}function M(P){const $=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return O.$D()||R($),u.$ze.wrap($)}function b(P){const $=P.buffer;if(O.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const S=new Uint8Array($.byteLength);return S.set($),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function p(P){const $=new Uint32Array(E(P));let S=0;if($[S++]=P.id,P.type==="full")$[S++]=1,$[S++]=P.data.length,$.set(P.data,S),S+=P.data.length;else{$[S++]=2,$[S++]=P.deltas.length;for(const v of P.deltas)$[S++]=v.start,$[S++]=v.deleteCount,v.data?($[S++]=v.data.length,$.set(v.data,S),S+=v.data.length):$[S++]=0}return M($)}function E(P){let $=0;if($+=2,P.type==="full")$+=1+P.data.length;else{$+=1,$+=3*P.deltas.length;for(const S of P.deltas)S.data&&($+=S.data.length)}return $}function A(P){const $=b(P);let S=0;const v=$[S++];if($[S++]===1){const n=$[S++],i=$.subarray(S,S+n);return S+=n,{id:v,type:"full",data:i}}const m=$[S++],o=[];for(let n=0;n<m;n++){const i=$[S++],r=$[S++],s=$[S++];let t;s>0&&(t=$.subarray(S,S+s),S+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:o}}}),define(ke[201],Ee([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,177,129,201]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=de;var p;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=E;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,Ie,Ke,Re){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Re}applyUpdate(ue,Ie){return S(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class ${constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=$;function S(oe,ue){if(typeof oe!="object"||typeof ue!="object"||!oe||!ue)return new $(ue,oe!==ue);if(Array.isArray(oe)||Array.isArray(ue)){const Ke=Array.isArray(oe)&&Array.isArray(ue)&&u.$ub(oe,ue);return new $(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Re=S(oe[Ke],ue[Ke]);Re.didChange&&(oe[Ke]=Re.newValue,Ie=!0)}return new $(oe,Ie)}class v{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return S(ue,Ie)}validate(ue){return this.defaultValue}}class a{constructor(ue,Ie,Ke,Re){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Re}applyUpdate(ue,Ie){return S(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function m(oe,ue){return typeof oe>"u"?ue:oe==="false"?!1:!!oe}class o extends a{constructor(ue,Ie,Ke,Re=void 0){typeof Re<"u"&&(Re.type="boolean",Re.default=Ke),super(ue,Ie,Ke,Re)}validate(ue){return m(ue,this.defaultValue)}}function n(oe,ue,Ie,Ke){if(typeof oe>"u")return ue;let Re=parseInt(oe,10);return isNaN(Re)?ue:(Re=Math.max(Ie,Re),Re=Math.min(Ke,Re),Re|0)}class i extends a{static clampedInt(ue,Ie,Ke,Re){return n(ue,Ie,Ke,Re)}constructor(ue,Ie,Ke,Re,it,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ke,ht.minimum=Re,ht.maximum=it),super(ue,Ie,Ke,ht),this.minimum=Re,this.maximum=it}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(oe,ue,Ie,Ke){if(typeof oe>"u")return ue;const Re=s.float(oe,ue);return s.clamp(Re,Ie,Ke)}class s extends a{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Re,it){typeof it<"u"&&(it.type="number",it.default=Ke),super(ue,Ie,Ke,it),this.validationFn=Re}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends a{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Re=void 0){typeof Re<"u"&&(Re.type="string",Re.default=Ke),super(ue,Ie,Ke,Re)}validate(ue){return t.string(ue,this.defaultValue)}}function f(oe,ue,Ie,Ke){return typeof oe!="string"?ue:Ke&&oe in Ke?Ke[oe]:Ie.indexOf(oe)===-1?ue:oe}class d extends a{constructor(ue,Ie,Ke,Re,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Re,it.default=Ke),super(ue,Ie,Ke,it),this.c=Re}validate(ue){return f(ue,this.defaultValue,this.c)}}class l extends P{constructor(ue,Ie,Ke,Re,it,ht,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=it,wt.default=Re),super(ue,Ie,Ke,wt),this.c=it,this.d=ht}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class g extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:m(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function w(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function y(oe){switch(oe){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(oe){switch(oe){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ue,Ie,Ke){const Re=["monaco-editor"];return Ie.get(39)&&Re.push(Ie.get(39)),ue.extraEditorClassName&&Re.push(ue.extraEditorClassName),Ie.get(74)==="default"?Re.push("mouse-default"):Ie.get(74)==="copy"&&Re.push("mouse-copy"),Ie.get(111)&&Re.push("showUnused"),Ie.get(140)&&Re.push("showDeprecated"),Re.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class j extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:m(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ie.loop,this.defaultValue.loop)}}}class F extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?F.OFF:ue==="true"?F.ON:ue:ue?F.ON:F.OFF}}e.EditorFontLigatures=F;class N extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?N.OFF:ue==="true"?N.TRANSLATE:ue:ue?N.TRANSLATE:N.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class T extends v{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class B extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Ie=s.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class H extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}class Z extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:f(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??f(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??f(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??f(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??f(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??f(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:m(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ie.above,this.defaultValue.above)}}}var J;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class Y extends v{constructor(){super(145)}compute(ue,Ie,Ke){return Y.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Re=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Re=Math.max(Re,Ie-1));const it=(Ke+ue.viewLineCount+Re)/(ue.pixelRatio*ue.height),ht=Math.floor(ue.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Re,desiredRatio:it,minimapLineCount:ht}}static c(ue,Ie){const Ke=ue.outerWidth,Re=ue.outerHeight,it=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Re),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Re};const ht=Ie.stableMinimapLayoutInput,wt=ht&&ue.outerHeight===ht.outerHeight&&ue.lineHeight===ht.lineHeight&&ue.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ue.pixelRatio===ht.pixelRatio&&ue.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ue.paddingTop===ht.paddingTop&&ue.paddingBottom===ht.paddingBottom&&ue.minimap.enabled===ht.minimap.enabled&&ue.minimap.side===ht.minimap.side&&ue.minimap.size===ht.minimap.size&&ue.minimap.showSlider===ht.minimap.showSlider&&ue.minimap.renderCharacters===ht.minimap.renderCharacters&&ue.minimap.maxColumn===ht.minimap.maxColumn&&ue.minimap.scale===ht.minimap.scale&&ue.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ue.isViewportWrapping===ht.isViewportWrapping,It=ue.lineHeight,Bt=ue.typicalHalfwidthCharacterWidth,Qt=ue.scrollBeyondLastLine,ei=ue.minimap.renderCharacters;let Dt=it>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Vt=ue.minimap.maxColumn,Xt=ue.minimap.size,et=ue.minimap.side,ai=ue.verticalScrollbarWidth,ti=ue.viewLineCount,ii=ue.remainingWidth,dt=ue.isViewportWrapping,bt=ei?2:3;let si=Math.floor(it*Re);const ni=si/it;let Ot=!1,mt=!1,Rt=bt*Dt,qt=Dt/it,Yt=1;if(Xt==="fill"||Xt==="fit"){const{typicalViewportLineCount:Mt,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:ri,desiredRatio:oi,minimapLineCount:Wt}=Y.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Qt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Re,lineHeight:It,pixelRatio:it});if(ti/Wt>1)Ot=!0,mt=!0,Dt=1,Rt=1,qt=Dt/it;else{let Et=!1,xt=Dt+1;if(Xt==="fit"){const Ct=Math.ceil((Ft+ti+ri)*Rt);dt&&wt&&ii<=Ie.stableFitRemainingWidth?(Et=!0,xt=Ie.stableFitMaxMinimapScale):Et=Ct>si}if(Xt==="fill"||Et){Ot=!0;const Ct=Dt;Rt=Math.min(It*it,Math.max(1,Math.floor(1/oi))),dt&&wt&&ii<=Ie.stableFitRemainingWidth&&(xt=Ie.stableFitMaxMinimapScale),Dt=Math.min(xt,Math.max(1,Math.floor(Rt/bt))),Dt>Ct&&(Yt=Math.min(2,Dt/Ct)),qt=Dt/it/Yt,si=Math.ceil(Math.max(Mt,Ft+ti+ri)*Rt),dt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=ii,Ie.stableFitMaxMinimapScale=Dt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Xe=Math.floor(Vt*qt),Zt=Math.min(Xe,Math.max(0,Math.floor((ii-ai-2)*qt/(Bt+qt)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(it*Zt);const Ht=Ut/it;Ut=Math.floor(Ut*Yt);const $t=ei?1:2,jt=et==="left"?0:Ke-Zt-ai;return{renderMinimap:$t,minimapLeft:jt,minimapWidth:Zt,minimapHeightIsEditorHeight:Ot,minimapIsSampling:mt,minimapScale:Dt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:si,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:ni}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Re=Ie.outerHeight|0,it=Ie.lineHeight|0,ht=Ie.lineNumbersDigitCount|0,wt=Ie.typicalHalfwidthCharacterWidth,It=Ie.maxDigitWidth,Bt=Ie.pixelRatio,Qt=Ie.viewLineCount,ei=ue.get(137),Dt=ei==="inherit"?ue.get(136):ei,Vt=Dt==="inherit"?ue.get(132):Dt,Xt=ue.get(135),et=Ie.isDominatedByLongLines,ai=ue.get(57),ti=ue.get(68).renderType!==0,ii=ue.get(69),dt=ue.get(105),bt=ue.get(84),si=ue.get(73),ni=ue.get(103),Ot=ni.verticalScrollbarSize,mt=ni.verticalHasArrows,Rt=ni.arrowSize,qt=ni.horizontalScrollbarSize,Yt=ue.get(43),Xe=ue.get(110)!=="never";let Zt=ue.get(66);Yt&&Xe&&(Zt+=16);let Ut=0;if(ti){const Pt=Math.max(ht,ii);Ut=Math.round(Pt*It)}let Ht=0;ai&&(Ht=it*Ie.glyphMarginDecorationLaneCount);let $t=0,jt=$t+Ht,Mt=jt+Ut,Ft=Mt+Zt;const ri=Ke-Ht-Ut-Zt;let oi=!1,Wt=!1,At=-1;Dt==="inherit"&&et?(oi=!0,Wt=!0):Vt==="on"||Vt==="bounded"?Wt=!0:Vt==="wordWrapColumn"&&(At=Xt);const Et=Y.c({outerWidth:Ke,outerHeight:Re,lineHeight:it,typicalHalfwidthCharacterWidth:wt,pixelRatio:Bt,scrollBeyondLastLine:dt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:si,verticalScrollbarWidth:Ot,viewLineCount:Qt,remainingWidth:ri,isViewportWrapping:Wt},Ie.memory||new A);Et.renderMinimap!==0&&Et.minimapLeft===0&&($t+=Et.minimapWidth,jt+=Et.minimapWidth,Mt+=Et.minimapWidth,Ft+=Et.minimapWidth);const xt=ri-Et.minimapWidth,Ct=Math.max(1,Math.floor((xt-Ot-2)/wt)),kt=mt?Rt:0;return Wt&&(At=Math.max(1,Ct),Vt==="bounded"&&(At=Math.min(At,Xt))),{width:Ke,height:Re,glyphMarginLeft:$t,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:Ut,decorationsLeft:Mt,decorationsWidth:Zt,contentLeft:Ft,contentWidth:xt,minimap:Et,viewportColumn:Ct,isWordWrapMinified:oi,isViewportWrapping:Wt,wrappingColumn:At,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:qt,overviewRuler:{top:kt,width:Ot,height:Re-2*kt,right:0}}}}e.EditorLayoutInfoComputer=Y;class re extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}var te;(function(oe){oe.Off="off",oe.OnCode="onCode",oe.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class pe extends P{constructor(){const ue={enabled:te.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:ue.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class Ce extends P{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:f(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:m(Ie.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?i.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ne extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:b.localize(66,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class be extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ue.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),autohide:m(Ie.autohide,this.defaultValue.autohide),size:f(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ie.side,this.defaultValue.side,["right","left"]),showSlider:f(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(Ie.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(Ie.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Ie.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function De(oe){return oe==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class ae extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class ce extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),cycle:m(Ie.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(143)}compute(ue,Ie,Ke){return ue.pixelRatio}}class K extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:b.localize(88,null)},comments:{anyOf:Ie,default:ue.comments,description:b.localize(89,null)},other:{anyOf:Ie,default:ue.other,description:b.localize(90,null)}},default:ue,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Bt=ue?"on":"off";return{comments:Bt,strings:Bt,other:Bt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Re}=ue,it=["on","inline","off"];let ht,wt,It;return typeof Ie=="boolean"?ht=Ie?"on":"off":ht=f(Ie,this.defaultValue.other,it),typeof Ke=="boolean"?wt=Ke?"on":"off":wt=f(Ke,this.defaultValue.comments,it),typeof Re=="boolean"?It=Re?"on":"off":It=f(Re,this.defaultValue.strings,it),{other:ht,comments:wt,strings:It}}}var ie;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class le extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function de(oe){const ue=oe.get(98);return ue==="editable"?oe.get(91):ue!=="on"}class Ae extends P{constructor(){const ue=[],Ie={type:"number",description:b.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ue,description:b.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Re=Ke;Ie.push({column:i.clampedInt(Re.column,0,0,1e4),color:Re.color})}return Ie.sort((Ke,Re)=>Ke.column-Re.column),Ie}return this.defaultValue}}class me extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(oe,ue){if(typeof oe!="string")return ue;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Re=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:m(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Re,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,Re,0,1e3),scrollByPage:m(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(O.$Xn(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(O.$Xn(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Re=super.applyUpdate(ue,Ie);return Ke?new $(Re.newValue,!0):Re}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:fe(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Re,it]of Object.entries(ue))it===!0&&(Ke[Re]=!0);return Ke}}class q extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),mode:f(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class W extends P{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:b.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends P{constructor(){const ue={enabled:R.$Rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ue.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ue.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ue.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:fe(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(oe,ue,Ie){const Ke=Ie.indexOf(oe);return Ke===-1?ue:Ie[Ke]}class we extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ue.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ue.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:f(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ie.preview,this.defaultValue.preview),previewMode:f(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ie.showMethods,this.defaultValue.showMethods),showFunctions:m(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ie.showFields,this.defaultValue.showFields),showVariables:m(Ie.showVariables,this.defaultValue.showVariables),showClasses:m(Ie.showClasses,this.defaultValue.showClasses),showStructs:m(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ie.showModules,this.defaultValue.showModules),showProperties:m(Ie.showProperties,this.defaultValue.showProperties),showEvents:m(Ie.showEvents,this.defaultValue.showEvents),showOperators:m(Ie.showOperators,this.defaultValue.showOperators),showUnits:m(Ie.showUnits,this.defaultValue.showUnits),showValues:m(Ie.showValues,this.defaultValue.showValues),showConstants:m(Ie.showConstants,this.defaultValue.showConstants),showEnums:m(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ie.showKeywords,this.defaultValue.showKeywords),showWords:m(Ie.showWords,this.defaultValue.showWords),showColors:m(Ie.showColors,this.defaultValue.showColors),showFiles:m(Ie.showFiles,this.defaultValue.showFiles),showReferences:m(Ie.showReferences,this.defaultValue.showReferences),showFolders:m(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ie.showUsers,this.defaultValue.showUsers),showIssues:m(Ie.showIssues,this.defaultValue.showIssues)}}}class Fe extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends P{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Ie.push(Ke)}catch{}return Ie}return this.defaultValue}}var Ze;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(Ze||(e.WrappingIndent=Ze={}));class tt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class st extends v{constructor(){super(146)}compute(ue,Ie,Ke){const Re=Ie.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Re.isWordWrapMinified,isViewportWrapping:Re.isViewportWrapping,wrappingColumn:Re.wrappingColumn}}}class at extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showDropSelector:f(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showPasteSelector:f(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Se="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?Ge:Se,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var Qe;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.ariaRequired=5]="ariaRequired",oe[oe.autoClosingBrackets=6]="autoClosingBrackets",oe[oe.autoClosingComments=7]="autoClosingComments",oe[oe.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",oe[oe.autoClosingDelete=9]="autoClosingDelete",oe[oe.autoClosingOvertype=10]="autoClosingOvertype",oe[oe.autoClosingQuotes=11]="autoClosingQuotes",oe[oe.autoIndent=12]="autoIndent",oe[oe.automaticLayout=13]="automaticLayout",oe[oe.autoSurround=14]="autoSurround",oe[oe.bracketPairColorization=15]="bracketPairColorization",oe[oe.guides=16]="guides",oe[oe.codeLens=17]="codeLens",oe[oe.codeLensFontFamily=18]="codeLensFontFamily",oe[oe.codeLensFontSize=19]="codeLensFontSize",oe[oe.colorDecorators=20]="colorDecorators",oe[oe.colorDecoratorsLimit=21]="colorDecoratorsLimit",oe[oe.columnSelection=22]="columnSelection",oe[oe.comments=23]="comments",oe[oe.contextmenu=24]="contextmenu",oe[oe.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=26]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=28]="cursorStyle",oe[oe.cursorSurroundingLines=29]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=31]="cursorWidth",oe[oe.disableLayerHinting=32]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",oe[oe.domReadOnly=34]="domReadOnly",oe[oe.dragAndDrop=35]="dragAndDrop",oe[oe.dropIntoEditor=36]="dropIntoEditor",oe[oe.emptySelectionClipboard=37]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=39]="extraEditorClassName",oe[oe.fastScrollSensitivity=40]="fastScrollSensitivity",oe[oe.find=41]="find",oe[oe.fixedOverflowWidgets=42]="fixedOverflowWidgets",oe[oe.folding=43]="folding",oe[oe.foldingStrategy=44]="foldingStrategy",oe[oe.foldingHighlight=45]="foldingHighlight",oe[oe.foldingImportsByDefault=46]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=47]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=49]="fontFamily",oe[oe.fontInfo=50]="fontInfo",oe[oe.fontLigatures=51]="fontLigatures",oe[oe.fontSize=52]="fontSize",oe[oe.fontWeight=53]="fontWeight",oe[oe.fontVariations=54]="fontVariations",oe[oe.formatOnPaste=55]="formatOnPaste",oe[oe.formatOnType=56]="formatOnType",oe[oe.glyphMargin=57]="glyphMargin",oe[oe.gotoLocation=58]="gotoLocation",oe[oe.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",oe[oe.hover=60]="hover",oe[oe.inDiffEditor=61]="inDiffEditor",oe[oe.inlineSuggest=62]="inlineSuggest",oe[oe.inlineEdit=63]="inlineEdit",oe[oe.letterSpacing=64]="letterSpacing",oe[oe.lightbulb=65]="lightbulb",oe[oe.lineDecorationsWidth=66]="lineDecorationsWidth",oe[oe.lineHeight=67]="lineHeight",oe[oe.lineNumbers=68]="lineNumbers",oe[oe.lineNumbersMinChars=69]="lineNumbersMinChars",oe[oe.linkedEditing=70]="linkedEditing",oe[oe.links=71]="links",oe[oe.matchBrackets=72]="matchBrackets",oe[oe.minimap=73]="minimap",oe[oe.mouseStyle=74]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=76]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=78]="multiCursorModifier",oe[oe.multiCursorPaste=79]="multiCursorPaste",oe[oe.multiCursorLimit=80]="multiCursorLimit",oe[oe.occurrencesHighlight=81]="occurrencesHighlight",oe[oe.overviewRulerBorder=82]="overviewRulerBorder",oe[oe.overviewRulerLanes=83]="overviewRulerLanes",oe[oe.padding=84]="padding",oe[oe.pasteAs=85]="pasteAs",oe[oe.parameterHints=86]="parameterHints",oe[oe.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=89]="quickSuggestions",oe[oe.quickSuggestionsDelay=90]="quickSuggestionsDelay",oe[oe.readOnly=91]="readOnly",oe[oe.readOnlyMessage=92]="readOnlyMessage",oe[oe.renameOnType=93]="renameOnType",oe[oe.renderControlCharacters=94]="renderControlCharacters",oe[oe.renderFinalNewline=95]="renderFinalNewline",oe[oe.renderLineHighlight=96]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=98]="renderValidationDecorations",oe[oe.renderWhitespace=99]="renderWhitespace",oe[oe.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",oe[oe.roundedSelection=101]="roundedSelection",oe[oe.rulers=102]="rulers",oe[oe.scrollbar=103]="scrollbar",oe[oe.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=105]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=106]="scrollPredominantAxis",oe[oe.selectionClipboard=107]="selectionClipboard",oe[oe.selectionHighlight=108]="selectionHighlight",oe[oe.selectOnLineNumbers=109]="selectOnLineNumbers",oe[oe.showFoldingControls=110]="showFoldingControls",oe[oe.showUnused=111]="showUnused",oe[oe.snippetSuggestions=112]="snippetSuggestions",oe[oe.smartSelect=113]="smartSelect",oe[oe.smoothScrolling=114]="smoothScrolling",oe[oe.stickyScroll=115]="stickyScroll",oe[oe.stickyTabStops=116]="stickyTabStops",oe[oe.stopRenderingLineAfter=117]="stopRenderingLineAfter",oe[oe.suggest=118]="suggest",oe[oe.suggestFontSize=119]="suggestFontSize",oe[oe.suggestLineHeight=120]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",oe[oe.suggestSelection=122]="suggestSelection",oe[oe.tabCompletion=123]="tabCompletion",oe[oe.tabIndex=124]="tabIndex",oe[oe.unicodeHighlighting=125]="unicodeHighlighting",oe[oe.unusualLineTerminators=126]="unusualLineTerminators",oe[oe.useShadowDOM=127]="useShadowDOM",oe[oe.useTabStops=128]="useTabStops",oe[oe.wordBreak=129]="wordBreak",oe[oe.wordSegmenterLocales=130]="wordSegmenterLocales",oe[oe.wordSeparators=131]="wordSeparators",oe[oe.wordWrap=132]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=135]="wordWrapColumn",oe[oe.wordWrapOverride1=136]="wordWrapOverride1",oe[oe.wordWrapOverride2=137]="wordWrapOverride2",oe[oe.wrappingIndent=138]="wrappingIndent",oe[oe.wrappingStrategy=139]="wrappingStrategy",oe[oe.showDeprecated=140]="showDeprecated",oe[oe.inlayHints=141]="inlayHints",oe[oe.editorClassName=142]="editorClassName",oe[oe.pixelRatio=143]="pixelRatio",oe[oe.tabFocusMode=144]="tabFocusMode",oe[oe.layoutInfo=145]="layoutInfo",oe[oe.wrappingInfo=146]="wrappingInfo",oe[oe.defaultColorDecorators=147]="defaultColorDecorators",oe[oe.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",oe[oe.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Le(new X),bracketPairGuides:Le(new Q),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Le(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Le(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Le(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Le(new g),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Le(new l(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:Le(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Le(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new at),stickyScroll:Le(new Ce),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new s(40,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:b.localize(271,null)})),find:Le(new j),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Le(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Le(new T),fontLigatures2:Le(new F),fontSize:Le(new B),fontWeight:Le(new H),fontVariations:Le(new N),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Le(new Z),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Le(new ee),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>s.clamp(oe,-5,20),{description:b.localize(285,null)})),lightbulb:Le(new pe),lineDecorationsWidth:Le(new U),lineHeight:Le(new ne),lineNumbers:Le(new le),lineNumbersMinChars:Le(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Le(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Le(new d(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Le(new be),mouseStyle:Le(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new s(75,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Le(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Le(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Le(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Le(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Le(new i(83,"overviewRulerLanes",3,0,3)),padding:Le(new ae),pasteAs:Le(new ot),parameterHints:Le(new ce),peekWidgetDefaultFocus:Le(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Le(new K),quickSuggestionsDelay:Le(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new me),renameOnType:Le(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Le(new d(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Le(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Le(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Le(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Le(new Ae),scrollbar:Le(new Me),scrollBeyondLastColumn:Le(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Le(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Le(new x),snippetSuggestions:Le(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Le(new Fe),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Le(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new we),inlineSuggest:Le(new q),inlineEdit:Le(new W),inlineCompletionsAccessibilityVerbose:Le(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Le(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Le(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Le(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Le(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new je),unusualLineTerminators:Le(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Le(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Le(new Ve),wordSeparators:Le(new t(131,"wordSeparators",M.$Ss,{description:b.localize(359,null)})),wordWrap:Le(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Le(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Le(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new I),defaultColorDecorators:Le(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Le(new se),tabFocusMode:Le(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Le(new Y),wrappingInfo:Le(new st),wrappingIndent:Le(new tt),wrappingStrategy:Le(new re)}}),define(ke[202],Ee([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,175,29,185,202]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$5t=e.$4t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$3t=e.$2t=e.SymbolKinds=e.SymbolTag=e.$Zt=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Xt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Wt=e.$Vt=e.$Ut=void 0,e.$Yt=f,e.$1t=l;class p{constructor(Z,ee,J){this.offset=Z,this.type=ee,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ut=p;class E{constructor(Z,ee){this.tokens=Z,this.endState=ee,this._tokenizationResultBrand=void 0}}e.$Vt=E;class A{constructor(Z,ee){this.tokens=Z,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}e.$Wt=A;var P;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var $;(function(H){const Z=new Map;Z.set(0,u.$Mj.symbolMethod),Z.set(1,u.$Mj.symbolFunction),Z.set(2,u.$Mj.symbolConstructor),Z.set(3,u.$Mj.symbolField),Z.set(4,u.$Mj.symbolVariable),Z.set(5,u.$Mj.symbolClass),Z.set(6,u.$Mj.symbolStruct),Z.set(7,u.$Mj.symbolInterface),Z.set(8,u.$Mj.symbolModule),Z.set(9,u.$Mj.symbolProperty),Z.set(10,u.$Mj.symbolEvent),Z.set(11,u.$Mj.symbolOperator),Z.set(12,u.$Mj.symbolUnit),Z.set(13,u.$Mj.symbolValue),Z.set(15,u.$Mj.symbolEnum),Z.set(14,u.$Mj.symbolConstant),Z.set(15,u.$Mj.symbolEnum),Z.set(16,u.$Mj.symbolEnumMember),Z.set(17,u.$Mj.symbolKeyword),Z.set(27,u.$Mj.symbolSnippet),Z.set(18,u.$Mj.symbolText),Z.set(19,u.$Mj.symbolColor),Z.set(20,u.$Mj.symbolFile),Z.set(21,u.$Mj.symbolReference),Z.set(22,u.$Mj.symbolCustomColor),Z.set(23,u.$Mj.symbolFolder),Z.set(24,u.$Mj.symbolTypeParameter),Z.set(25,u.$Mj.account),Z.set(26,u.$Mj.issues);function ee(re){let te=Z.get(re);return te||(console.info("No codicon found for CompletionItemKind "+re),te=u.$Mj.symbolProperty),te}H.toIcon=ee;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function Y(re,te){let pe=J.get(re);return typeof pe>"u"&&!te&&(pe=9),pe}H.fromString=Y})($||(e.CompletionItemKinds=$={}));var S;(function(H){H[H.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var v;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var a;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var o;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(Z,ee,J,Y){this.range=Z,this.text=ee,this.completionKind=J,this.isSnippetText=Y}equals(Z){return R.$ht.lift(this.range).equalsRange(Z.range)&&this.text===Z.text&&this.completionKind===Z.completionKind&&this.isSnippetText===Z.isSnippetText}}e.$Xt=n;var i;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(H){return H&&O.URI.isUri(H.uri)&&R.$ht.isIRange(H.range)&&(R.$ht.isIRange(H.originSelectionRange)||R.$ht.isIRange(H.targetSelectionRange))}var d;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$Zt={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function l(H,Z){return(0,b.localize)(26,null,H,e.$Zt[Z])}var c;(function(H){H[H.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var h;(function(H){const Z=new Map;Z.set(0,u.$Mj.symbolFile),Z.set(1,u.$Mj.symbolModule),Z.set(2,u.$Mj.symbolNamespace),Z.set(3,u.$Mj.symbolPackage),Z.set(4,u.$Mj.symbolClass),Z.set(5,u.$Mj.symbolMethod),Z.set(6,u.$Mj.symbolProperty),Z.set(7,u.$Mj.symbolField),Z.set(8,u.$Mj.symbolConstructor),Z.set(9,u.$Mj.symbolEnum),Z.set(10,u.$Mj.symbolInterface),Z.set(11,u.$Mj.symbolFunction),Z.set(12,u.$Mj.symbolVariable),Z.set(13,u.$Mj.symbolConstant),Z.set(14,u.$Mj.symbolString),Z.set(15,u.$Mj.symbolNumber),Z.set(16,u.$Mj.symbolBoolean),Z.set(17,u.$Mj.symbolArray),Z.set(18,u.$Mj.symbolObject),Z.set(19,u.$Mj.symbolKey),Z.set(20,u.$Mj.symbolNull),Z.set(21,u.$Mj.symbolEnumMember),Z.set(22,u.$Mj.symbolStruct),Z.set(23,u.$Mj.symbolEvent),Z.set(24,u.$Mj.symbolOperator),Z.set(25,u.$Mj.symbolTypeParameter);function ee(J){let Y=Z.get(J);return Y||(console.info("No codicon found for SymbolKind "+J),Y=u.$Mj.symbolProperty),Y}H.toIcon=ee})(h||(e.SymbolKinds=h={}));class g{static asEditOperation(Z){return L.$it.replace(R.$ht.lift(Z.range),Z.text)}}e.$2t=g;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(Z){switch(Z){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(Z)}constructor(Z){this.value=Z}}e.$3t=D;var w;(function(H){H[H.AIGenerated=1]="AIGenerated"})(w||(e.NewSymbolNameTag=w={}));var k;(function(H){function Z(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}H.is=Z})(k||(e.Command=k={}));var y;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var C;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(C||(e.CommentThreadState=C={}));var I;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var z;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var j;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(j||(e.CommentState=j={}));var F;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class N{constructor(Z){this.b=Z,this.a=null}dispose(){this.a&&this.a.then(Z=>{Z&&Z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$4t=N,e.$5t=new M.$Jt;var T;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Ee([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Ee([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Ee([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Ee([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Ee([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[211],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ke[212],Ee([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Ee([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[214],Ee([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[215],Ee([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Ee([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Ee([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[219],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[220],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[221],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[222],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[223],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[224],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[225],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[226],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[227],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[228],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[229],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[230],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[231],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[232],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[233],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[234],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[235],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[236],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[237],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[238],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[239],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[240],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[241],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[242],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[243],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[244],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[245],Ee([1,0,13,205]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var L;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,$=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:$};this.g.push({offset:P,lexeme:$,additionalInfo:A}),this.f.push(S)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),$=p.b.get(P);$?this.k($):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(P)P=!1;else if(v===47&&!$){A++;break}else v===91?$=!0:v===92?P=!0:v===93&&($=!1);A++}for(;A<this.c.length&&p.a.has(this.c.charCodeAt(A));)A++;this.e=A;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=p}),define(ke[246],Ee([1,0,23,39,208,396]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=p,e.$yp=E,e.$zp=A,e.$Ap=P,e.$Bp=$,e.$Cp=S,e.$Dp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||M.test(o)}function E(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let d=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,c,h,g]=l;d=Date.UTC(Number(c),Number(h)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:d}}function P(o,n,i){let r;typeof o=="string"?r=A(E(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(E(i)):t=i,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,l=r.patchBase;let c=t.majorBase,h=t.minorBase,g=t.patchBase;const D=t.notBefore;let w=t.majorMustEqual,k=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>c?!0:f<c?!1:d>h?!0:d<h||s&&s<D?!1:l>=g:(f===1&&c===0&&(!w||!k||!y)&&(c=1,h=0,g=0,w=!0,k=!1,y=!1),f<c?!1:f>c?!w:d<h?!1:d>h?!k:l<g?!1:l>g?!y:!(s&&s<D))}function $(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([O.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([O.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([O.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([O.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([O.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([O.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([O.default.Error,L.localize(9,null,"main")]),t;{const l=(0,u.$1g)(i,r.main);(0,u.$Ug)(l,i)||t.push([O.default.Warning,L.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([O.default.Error,L.localize(11,null,"browser")]),t;{const l=(0,u.$1g)(i,r.browser);(0,u.$Ug)(l,i)||t.push([O.default.Warning,L.localize(12,null,l.path,i.path)])}}if(!R.valid(r.version))return t.push([O.default.Error,L.localize(13,null)]),t;const f=[];if(!S(o,n,r,s,f))for(const l of f)t.push([O.default.Error,l]);return t}function S(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:a(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||a(n,i,o)}function a(o,n,i,r=[]){const s=A(E(i));if(!s)return r.push(L.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(L.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(L.localize(16,null,i)),!1;return P(o,n,s)?!0:(r.push(L.localize(17,null,o,i)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class u{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ki=u}),define(ke[84],Ee([1,0,106]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=R,e.$ms=M;const O=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(b,p,E){p instanceof u.$ki||(p=new u.$ki(p,[],!!E)),O.push([b,p])}function M(){return O}}),define(ke[247],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class u{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$2q=u;class O{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const b=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(M);b.outgoing.set(p.key,p),p.incoming.set(b.key,b)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let b=this.a.get(M);return b||(b=new u(M,R),this.a.set(M,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,b]of this.a)R.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const b=new Set([R]),p=this.c(M,b);if(p)return p}}c(R,M){for(const[b,p]of R.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const E=this.c(p,M);if(E)return E;M.delete(b)}}}e.$3q=O}),define(ke[5],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e._util=void 0,e.$ni=L,e.$oi=R;var u;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(p){return p[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(u||(e._util=u={})),e.$mi=L("instantiationService");function O(M,b,p){b[u.DI_TARGET]===b?b[u.DI_DEPENDENCIES].push({id:M,index:p}):(b[u.DI_DEPENDENCIES]=[{id:M,index:p}],b[u.DI_TARGET]=b)}function L(M){if(u.serviceIds.has(M))return u.serviceIds.get(M);const b=function(p,E,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,p,A)};return b.toString=()=>M,u.serviceIds.set(M,b),b}function R(M){return M}}),define(ke[54],Ee([1,0,18,2,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=R,e.$Vi=M,e.$Wi=p,e.$Xi=E,e.$Yi=A,e.$Zi=P,e.$1i=$,e.$2i=v,e.$3i=a,e.$4i=m,e.$Ti=(0,L.$ni)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function p(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const r in o)P(i,r,o[r],n);return i}function P(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let d=0;d<s.length;d++){const l=s[d];let c=f[l];switch(typeof c){case"undefined":c=f[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}f=c}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function $(o,n){const i=n.split(".");S(o,i)}function S(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(S(r,n),Object.keys(r).length===0&&delete o[i])}}function v(o,n,i){function r(f,d){let l=f;for(const c of d){if(typeof l!="object"||l===null)return;l=l[c]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function a(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?u.$3f(o[r])&&u.$3f(n[r])?a(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function m(o){return o.replace(/[\[\]]/g,"")}}),define(ke[40],Ee([1,0,11,14,245,5,204,13]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=E,e.$mj=f,e.$nj=d,e.$Gj=te;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",u.$j),p.set("isLinux",u.$k),p.set("isWindows",u.$i),p.set("isWeb",u.$o),p.set("isMacNative",u.$j&&!u.$o),p.set("isEdge",u.$H),p.set("isFirefox",u.$F),p.set("isChrome",u.$E),p.set("isSafari",u.$G);function E(x,U){if(p.get(x)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(x,U)}const A=Object.prototype.hasOwnProperty;var P;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const $={regexParsingWithErrorRecovery:!0},S=(0,M.localize)(0,null),v=(0,M.localize)(1,null),a=(0,M.localize)(2,null),m=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new L.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const be=this.D(),De=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:L.$ij.getLexeme(be),additionalInfo:De}),s.c}return ne}catch(ne){if(ne!==s.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,m),ne?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,m),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const De=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),De.type!==10)throw this.B("REGEX",De);const ae=De.lexeme,ce=ae.lastIndexOf("/"),se=ce===ae.length-1?void 0:this.w(ae.substring(ce+1));let K;try{K=new RegExp(ae.substring(1,ce),se)}catch{throw this.B("REGEX",De)}return T.create(ne,K)}switch(De.type){case 10:case 19:{const ae=[De.lexeme];this.z();let ce=this.D(),se=0;for(let Ae=0;Ae<De.lexeme.length;Ae++)De.lexeme.charCodeAt(Ae)===40?se++:De.lexeme.charCodeAt(Ae)===41&&se--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?se++:De.lexeme.charCodeAt(Ae)===41&&se--}if(se<0)break;ae.push(L.$ij.getLexeme(ce)),this.z(),ce=this.D()}const K=ae.join(""),ie=K.lastIndexOf("/"),le=ie===K.length-1?void 0:this.w(K.substring(ie+1));let de;try{de=new RegExp(K.substring(1,ie),le)}catch{throw this.B("REGEX",De)}return t.regex(ne,de)}case 18:{const ae=De.lexeme;this.z();let ce=null;if(!(0,O.$Ze)(ae)){const se=ae.indexOf("/"),K=ae.lastIndexOf("/");if(se!==K&&se>=0){const ie=ae.slice(se+1,K),le=ae[K+1]==="i"?"i":"";try{ce=new RegExp(ie,le)}catch{throw this.B("REGEX",De)}}}if(ce===null)throw this.B("REGEX",De);return T.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const De=this.u();return t.notIn(ne,De)}switch(this.D().type){case 3:{this.z();const De=this.u();if(this.x().type===18)return t.equals(ne,De);switch(De){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,De)}}case 4:{this.z();const De=this.u();if(this.x().type===18)return t.notEquals(ne,De);switch(De){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,De)}}case 5:return this.z(),F.create(ne,this.u());case 6:return this.z(),N.create(ne,this.u());case 7:return this.z(),z.create(ne,this.u());case 8:return this.z(),j.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,be){const De=(0,M.localize)(8,null,U,L.$ij.getLexeme(ne)),ae=ne.offset,ce=L.$ij.getLexeme(ne);return this.h.push({message:De,offset:ae,lexeme:ce,additionalInfo:be}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=s;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return g.create(U)}static equals(U,ne){return D.create(U,ne)}static notEquals(U,ne){return y.create(U,ne)}static regex(U,ne){return T.create(U,ne)}static in(U,ne){return w.create(U,ne)}static notIn(U,ne){return k.create(U,ne)}static not(U){return C.create(U)}static and(...U){return Z.create(U,null,!0)}static or(...U){return ee.create(U,null,!0)}static greater(U,ne){return z.create(U,ne)}static greaterEquals(U,ne){return j.create(U,ne)}static smaller(U,ne){return F.create(U,ne)}static smallerEquals(U,ne){return N.create(U,ne)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$lj=t;function f(x){const U=new s({regexParsingWithErrorRecovery:!1});return x.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function d(x,U){const ne=x?x.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ne&&!be?!0:!ne||!be?!1:ne.equals(be)}function l(x,U){return x.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$oj=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$pj=h;class g{static create(U,ne=null){const be=p.get(U);return typeof be=="boolean"?be?h.INSTANCE:c.INSTANCE:new g(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=p.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$qj=g;class D{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?g.create(U,be):C.create(U,be);const De=p.get(U);return typeof De=="boolean"?ne===(De?"true":"false")?h.INSTANCE:c.INSTANCE:new D(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=p.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$rj=D;class w{static create(U,ne){return new w(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:re(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ne)?ne.includes(be):typeof be=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$sj=w;class k{static create(U,ne){return new k(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=w.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=k;class y{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?C.create(U,be):g.create(U,be);const De=p.get(U);return typeof De=="boolean"?ne===(De?"true":"false")?c.INSTANCE:h.INSTANCE:new y(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=p.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$uj=y;class C{static create(U,ne=null){const be=p.get(U);return typeof be=="boolean"?be?c.INSTANCE:h.INSTANCE:new C(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=p.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$vj=C;function I(x,U){if(typeof x=="string"){const ne=parseFloat(x);isNaN(ne)||(x=ne)}return typeof x=="string"||typeof x=="number"?U(x):c.INSTANCE}class z{static create(U,ne,be=null){return I(ne,De=>new z(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$wj=z;class j{static create(U,ne,be=null){return I(ne,De=>new j(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$xj=j;class F{static create(U,ne,be=null){return I(ne,De=>new F(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$yj=F;class N{static create(U,ne,be=null){return I(ne,De=>new N(U,De,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$zj=N;class T{static create(U,ne){return new T(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return ne<be?-1:ne>be?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ne===be}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Aj=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Bj=B;function H(x){let U=null;for(let ne=0,be=x.length;ne<be;ne++){const De=x[ne].substituteConstants();if(x[ne]!==De&&U===null){U=[];for(let ae=0;ae<ne;ae++)U[ae]=x[ae]}U!==null&&(U[ne]=De)}return U===null?x:U}class Z{static create(U,ne,be){return Z.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const De=l(this.expr[ne],U.expr[ne]);if(De!==0)return De}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=H(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,be){const De=[];let ae=!1;for(const ce of U)if(ce){if(ce.type===1){ae=!0;continue}if(ce.type===0)return c.INSTANCE;if(ce.type===6){De.push(...ce.expr);continue}De.push(ce)}if(De.length===0&&ae)return h.INSTANCE;if(De.length!==0){if(De.length===1)return De[0];De.sort(l);for(let ce=1;ce<De.length;ce++)De[ce-1].equals(De[ce])&&(De.splice(ce,1),ce--);if(De.length===1)return De[0];for(;De.length>1;){const ce=De[De.length-1];if(ce.type!==9)break;De.pop();const se=De.pop(),K=De.length===0,ie=ee.create(ce.expr.map(le=>Z.create([le,se],null,be)),null,K);ie&&(De.push(ie),De.sort(l))}if(De.length===1)return De[0];if(be){for(let ce=0;ce<De.length;ce++)for(let se=ce+1;se<De.length;se++)if(De[ce].negate().equals(De[se]))return c.INSTANCE;if(De.length===1)return De[0]}return new Z(De,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new Z(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=ee.create(U,this,!0)}return this.c}}e.$Cj=Z;class ee{static create(U,ne,be){return ee.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const De=l(this.expr[ne],U.expr[ne]);if(De!==0)return De}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=H(this.expr);return U===this.expr?this:ee.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,be){let De=[],ae=!1;if(U){for(let ce=0,se=U.length;ce<se;ce++){const K=U[ce];if(K){if(K.type===0){ae=!0;continue}if(K.type===1)return h.INSTANCE;if(K.type===9){De=De.concat(K.expr);continue}De.push(K)}}if(De.length===0&&ae)return c.INSTANCE;De.sort(l)}if(De.length!==0){if(De.length===1)return De[0];for(let ce=1;ce<De.length;ce++)De[ce-1].equals(De[ce])&&(De.splice(ce,1),ce--);if(De.length===1)return De[0];if(be){for(let ce=0;ce<De.length;ce++)for(let se=ce+1;se<De.length;se++)if(De[ce].negate().equals(De[se]))return h.INSTANCE;if(De.length===1)return De[0]}return new ee(De,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new ee(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),be=U.shift(),De=[];for(const ae of Ce(ne))for(const ce of Ce(be))De.push(Z.create([ae,ce],null,!1));U.unshift(ee.create(De,null,!1))}this.c=ee.create(U,this,!0)}return this.c}}e.$Dj=ee;class J extends g{static{this.d=[]}static all(){return J.d.values()}constructor(U,ne,be){super(U,null),this.f=ne,typeof be=="object"?J.d.push({...be,key:U}):be!==!0&&J.d.push({key:U,description:be,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Ej=J,e.$Fj=(0,R.$ni)("contextKeyService");function Y(x,U){return x<U?-1:x>U?1:0}function re(x,U,ne,be){return x<ne?-1:x>ne?1:U<be?-1:U>be?1:0}function te(x,U){if(x.type===0||U.type===1)return!0;if(x.type===9)return U.type===9?pe(x.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(te(x,ne))return!0;return!1}if(x.type===6){if(U.type===6)return pe(U.expr,x.expr);for(const ne of x.expr)if(te(ne,U))return!0;return!1}return x.equals(U)}function pe(x,U){let ne=0,be=0;for(;ne<x.length&&be<U.length;){const De=x[ne].cmp(U[be]);if(De<0)return!1;De===0&&ne++,be++}return ne===x.length}function Ce(x){return x.type===9?x.expr:[x]}}),define(ke[248],Ee([1,0,23,39,206,5,103,11,24]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$xw=e.$ww=e.$vw=void 0,e.$yw=S,e.$zw=v,e.$vw=(0,R.$ni)("dialogService");var E;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(E||(E={}));class A{a(m){return this.d(m,E.Confirmation)}b(m){return this.d(m,E.Prompt)}c(m){return this.d(m,E.Input)}d(m,o){const n=[];switch(o){case E.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case E.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case E.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===O.default.Info?"info":m===O.default.Error?"error":m===O.default.Warning?"warning":"none"}f(m,o,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$ww=A,e.$xw=(0,R.$ni)("fileDialogService");var P;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const $=10;function S(a){const m=[];return m.push(...a.slice(0,$).map(o=>typeof o=="string"?o:(0,u.$Xg)(o))),a.length>$&&(a.length-$===1?m.push((0,L.localize)(7,null)):m.push((0,L.localize)(8,null,a.length-$))),m.push(""),m.join(`
`)}function v(a,m){const o=(0,p.$Tn)(a);let n=(o.buttons??[]).map(t=>(0,M.$sw)(t)),i=(a.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,u.$ni)("environmentService"),e.$vi=(0,u.$oi)(e.$ui)}),define(ke[137],Ee([1,0,207,5]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=L,e.$Ro=R,e.$So=M,e.$To=b,e.$Uo=p,e.$Vo=E,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,r){return r==="web"&&!i.includes("web")}function p(i,r,s){return b(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var $;(function(i){i.Install="install",i.Uninstall="uninstall"})($||(e.StatisticType=$={}));var S;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Wo=(0,O.$ni)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var a;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Xo=m;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Yo=n,e.$Zo=(0,O.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,O.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,O.$ni)("IExtensionTipsService"),e.$5o=(0,u.localize2)(0,"Extensions"),e.$6o=(0,u.localize2)(1,"Preferences")}),define(ke[249],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=e.$$5b=void 0,e.$$5b=(0,u.$ni)("externalTerminal"),e.$_5b="Terminal.app"}),define(ke[250],Ee([1,0,53,55,15,17,11,102,31,105,209,249]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=e.$gbc=void 0;const $=A.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends S{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,E.$fm(),t)}spawnTerminal(s,t,f,d){const l=t.windowsExec||v.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const c=R.$oc(l,".exe").toLowerCase();if(c==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),c==="wt"&&h.push("-d ."),new Promise((g,D)=>{const w=o(process),k=s.spawn(f,h,{cwd:d,env:w,detached:!0});k.on("error",D),k.on("exit",()=>g())})}async runInTerminal(s,t,f,d,l){const c="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),h=await v.f();return new Promise((g,D)=>{const w=`"${t} - ${$}"`,k=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),d);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const C={cwd:t,env:y,windowsVerbatimArguments:!0};let I,z;R.$oc(c,".exe")==="wt"?(I=c,z=["-d",".",v.b,"/c",k]):h?(I=h,z=["-d",".",c,"/c",k]):(I=v.b,z=["/c","start",w,"/wait",c,"/c",`"${k}"`]),u.spawn(I,z,C).on("error",F=>{D(n(F))}),g(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await E.win32.findExecutable("wt");return await p.Promises.exists(s)?s:void 0}catch{return}}}e.$gbc=v,Je([O.$Rh],v,"f",null);class a extends S{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.osxExec||P.$_5b;return new Promise((h,g)=>{if(c===P.$_5b||c==="iTerm.app"){const D=c===P.$_5b?"TerminalHelper":"iTermHelper",k=[L.$Hg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",s||$,"-w",t];for(const I of f)k.push("-a"),k.push(I);if(d){const I=Object.assign({},o(process),d);for(const z in I){const j=I[z];j===null?(k.push("-u"),k.push(z)):(k.push("-e"),k.push(`${z}=${j}`))}}let y="";const C=u.spawn(a.b,k);C.on("error",I=>{g(n(I))}),C.stderr.on("data",I=>{y+=I.toString()}),C.on("exit",I=>{if(I===0)h(void 0);else if(y){const z=y.split(`
`,1);g(new Error(z[0]))}else g(new Error(A.localize(1,null,D,I)))})}else g(new Error(A.localize(2,null,c)))})}spawnTerminal(s,t,f){const d=t.osxExec||P.$_5b;return new Promise((l,c)=>{const h=["-a",d];f&&h.push(f);const g=o(process),D=s.spawn("/usr/bin/open",h,{cwd:f,env:g});D.on("error",c),D.on("exit",()=>l())})}}e.$hbc=a;class m extends S{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,g)=>{const D=[];c.then(w=>{w.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${i(f)}; echo; read -p "${m.b}" -n1;`;D.push(`''${k}''`);const y=Object.assign({},o(process),d);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const C={cwd:t,env:y};let I="";const z=u.spawn(w,D,C);z.on("error",j=>{g(n(j))}),z.stderr.on("data",j=>{I+=j.toString()}),z.on("exit",j=>{if(j===0)h(void 0);else if(I){const F=I.split(`
`,1);g(new Error(F[0]))}else g(new Error(A.localize(4,null,w,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const s=await p.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,c)=>{d.then(h=>{const g=o(process),D=s.spawn(h,[],{cwd:f,env:g});D.on("error",c),D.on("exit",()=>l())})})}}e.$ibc=m;function o(r){const s={...r.env};return(0,b.$dm)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Ee([1,0,77,17,14,18,2,210,5,11,15,46]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ml=e.FileKind=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.FileOperationResult=e.$el=e.$dl=e.$cl=e.$al=e.FileChangeType=e.$_k=e.FileOperation=e.$6k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tk=void 0,e.$Uk=$,e.$Vk=a,e.$Wk=o,e.$Xk=n,e.$Yk=i,e.$Zk=r,e.$1k=s,e.$2k=t,e.$3k=f,e.$4k=d,e.$5k=l,e.$7k=g,e.$8k=D,e.$9k=w,e.$0k=k,e.$$k=y,e.$bl=F,e.$nl=ee,e.$ol=J,e.$ql=re,e.$Tk=(0,p.$ni)("fileService");function $(te){return te.create===!0}var S;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function a(te){const pe=te;return!!pe&&typeof pe.onDidChange=="function"}var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(te){return!!(te.capabilities&2)}function n(te){return!!(te.capabilities&8)}function i(te){return!!(te.capabilities&131072)}function r(te){return!!(te.capabilities&4)}function s(te){return!!(te.capabilities&16)}function t(te){return o(te)?!!(te.capabilities&16384):!1}function f(te){return o(te)?!!(te.capabilities&32768):!1}function d(te){return!!(te.capabilities&65536)}function l(te){return!!(te.capabilities&2048)}var c;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(pe,Ce){const x=new h(pe.toString(),Ce);return w(x,Ce),x}constructor(pe,Ce){super(pe),this.code=Ce}}e.$6k=h;function g(te,pe){return h.create(te,pe)}function D(te){return te||g((0,b.localize)(0,null),c.Unknown)}function w(te,pe){return te.name=pe?`${pe} (FileSystemError)`:"FileSystemError",te}function k(te){if(!te)return c.Unknown;if(te instanceof h)return te.code;const pe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!pe)return c.Unknown;switch(pe[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function y(te){if(te instanceof N)return te.fileOperationResult;switch(k(te)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}var C;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class I{constructor(pe,Ce,x){this.resource=pe,this.operation=Ce,this.target=x}isOperation(pe){return this.operation===pe}}e.$_k=I;var z;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class j{static{this.a=null}constructor(pe,Ce){this.c=Ce,this.b=void 0,this.d=new P.$V(()=>{const x=u.$ti.forUris(()=>this.c);return x.fill(this.rawAdded.map(U=>[U,!0])),x}),this.f=new P.$V(()=>{const x=u.$ti.forUris(()=>this.c);return x.fill(this.rawUpdated.map(U=>[U,!0])),x}),this.g=new P.$V(()=>{const x=u.$ti.forUris(()=>this.c);return x.fill(this.rawDeleted.map(U=>[U,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of pe){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==j.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(pe,...Ce){return this.h(pe,{includeChildren:!1},...Ce)}affects(pe,...Ce){return this.h(pe,{includeChildren:!0},...Ce)}h(pe,Ce,...x){if(!pe)return!1;const U=x.length>0;return!!((!U||x.includes(1))&&(this.d.value.get(pe)||Ce.includeChildren&&this.d.value.findSuperstr(pe))||(!U||x.includes(0))&&(this.f.value.get(pe)||Ce.includeChildren&&this.f.value.findSuperstr(pe))||(!U||x.includes(2))&&(this.g.value.findSubstr(pe)||Ce.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}e.$al=j;function F(te,pe,Ce){return!te||!pe||te===pe||pe.length>te.length?!1:(pe.charAt(pe.length-1)!==O.sep&&(pe+=O.sep),Ce?(0,L.$rf)(te,pe):te.indexOf(pe)===0)}class N extends Error{constructor(pe,Ce,x){super(pe),this.fileOperationResult=Ce,this.options=x}}e.$cl=N;class T extends N{constructor(pe,Ce,x,U){super(pe,Ce,U),this.fileOperationResult=Ce,this.size=x}}e.$dl=T;class B extends N{constructor(pe,Ce,x){super(pe,2,x),this.stat=Ce}}e.$el=B;var H;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$hl="files.associations",e.$il="files.exclude",e.$jl="files.readonlyInclude",e.$kl="files.readonlyExclude",e.$ll="files.readonlyFromPermissions";var Z;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$ml="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function J(te,pe){if(!pe.hasProvider(M.URI.from({scheme:te.scheme})))return new Promise(Ce=>{const x=pe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===te.scheme&&U.added&&(x.dispose(),Ce())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(pe){return(0,R.$5f)(pe)||(pe=0),pe<Y.KB?(0,b.localize)(1,null,pe.toFixed(0)):pe<Y.MB?(0,b.localize)(2,null,(pe/Y.KB).toFixed(2)):pe<Y.GB?(0,b.localize)(3,null,(pe/Y.MB).toFixed(2)):pe<Y.TB?(0,b.localize)(4,null,(pe/Y.GB).toFixed(2)):(0,b.localize)(5,null,(pe/Y.TB).toFixed(2))}}e.$pl=Y;function re(te){const pe=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*Y.MB:pe?10*Y.MB:E.$o?50*Y.MB:1024*Y.MB}}),define(ke[251],Ee([1,0,21,13,211,32]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=M;async function M(A,P,$,S,v,a){let m;try{await b(A,P,$,S,v,a)}catch(o){m=o}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&$.error(m),$.end()}}async function b(A,P,$,S,v,a){p(a);const m=await A.open(P,{create:!1});try{p(a);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$ze.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await $.write(S(r)),r=u.$ze.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&p(a)&&E(o,v));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),$.write(S(r.slice(0,f)))}}catch(o){throw(0,R.$8k)(o)}finally{await A.close(m)}}function p(A){if(A.isCancellationRequested)throw(0,O.$6)();return!0}function E(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,R.$7k)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Ee([1,0,35,3,17,11,2,32]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=void 0,e.$Aq=p,e.$Bq=E,e.$Fq=S,e.$Gq=v,e.$Hq=a,e.$Iq=m;function p(n){return typeof n.correlationId=="number"}function E(n){return n.recursive===!0}class A extends O.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new O.$Vc),this.f=void 0,this.g=0}s(){const i=new O.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cq=A;class P extends A{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$Dq=P;class $ extends A{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$Eq=$;function S(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function a(n,i){return typeof i=="string"&&!i.startsWith(u.$dk)&&!(0,L.$jc)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,u.$hk)(a(n,s)));return r}class o{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,b.$bl)(s.resource.fsPath,t,!R.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[252],Ee([1,0,52,3,65,4,2,7]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class p extends O.$Uc{constructor(){super(),this.a=this.B(new R.$_d),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$_d),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$_d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$4c),this.m=new Set,this.n=5007,this.r=new b.$Kh,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Aq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Kh;try{this.h.clear(),this.g.clear();for(const P of A)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const P=new O.$Tc;this.j.set(A.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(A,P),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,P){this.C(A,P)?(this.M(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,P),this.m.add(A.correlationId))}C(A,P){const $=this.L?.subscribe(A.path,(S,v)=>{P.isDisposed||(S?this.z(A,P):v?.type===1&&this.F(A))});return $?(P.add($),!0):!1}D(A,P){let $=!1;const S=(v,a)=>{if(P.isDisposed)return;const m=this.G(v),o=this.G(a),n=$;$=m,!m&&(o||n)&&this.F(A)};this.M(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.watchFile)(A.path,{persistent:!1,interval:this.n},S)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}P.add((0,O.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.unwatchFile)(A.path,S)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.M(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const P={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([P]),this.H(P,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,P){const $=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.M(typeof P.correlationId=="number"?`${$} (correlationId: ${P.correlationId})`:$)}I(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}}e.$Rq=p}),define(ke[253],Ee([1,0,52,7,22,34,3,76,17,11,23,2,104,31,65]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0,e.$Xq=m;class a extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(n,i,r,s,t,f){super(),this.r=n,this.s=i,this.t=r,this.u=s,this.w=t,this.y=f,this.c=this.B(new O.$Ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.t(d))),this.f=this.B(new O.$Bh(d=>this.L(d),a.b)),this.g=(0,v.$Iq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,v.$Iq)(this.r.path,this.r.includes):void 0,this.j=new L.$je,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const n=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const i=await S.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.F(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.N(n):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${n})`),this.C()}}C(){this.n=!0,this.u?.()}async D(n){let i=n.path;try{i=await S.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$Tq)(n.path,this.j.token)??n.path),n.path!==i&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async F(n,i){const r=new M.$Tc;return this.G(n,i,r)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(n,i,r)),r}G(n,i,r){if(i)return!1;const s=P.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(f,d)=>{if(!r.isDisposed)if(f){const l=await this.F(n,i);r.isDisposed?l.dispose():r.add(l)}else d&&(typeof d.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:s,type:d.type,cId:this.r.correlationId}])});return t?(r.add(t),!0):!1}async H(n,i,r){if(E.$j&&(0,R.$ng)(n,"/Volumes/",!0)){this.N(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new L.$je(this.j.token);r.add((0,M.$Sc)(()=>s.dispose(!0)));const t=new M.$Tc;r.add(t);try{const f=P.URI.file(this.r.path),d=(0,p.$oc)(n),l=(0,u.watch)(n);t.add((0,M.$Sc)(()=>{l.removeAllListeners(),l.close()})),this.P(`Started watching: '${n}'`);const c=new Set;if(i)try{for(const g of await S.Promises.readdir(n))c.add(g)}catch(g){this.N(g)}if(s.token.isCancellationRequested)return;const h=new Map;t.add((0,M.$Sc)(()=>{for(const[,g]of h)g.dispose();h.clear()})),l.on("error",(g,D)=>{s.token.isCancellationRequested||(this.N(`Failed to watch ${n} for changes using fs.watch() (${g}, ${D})`),this.C())}),l.on("change",(g,D)=>{if(s.token.isCancellationRequested)return;this.P(`[raw] ["${g}"] ${D}`);let w="";if(D&&(w=D.toString(),E.$j&&(w=(0,b.$5l)(w))),!(!w||g!=="change"&&g!=="rename"))if(i)if(g==="rename"){h.get(w)?.dispose();const k=setTimeout(async()=>{if(h.delete(w),w===d&&!await S.Promises.exists(n)){this.I(f);return}if(s.token.isCancellationRequested)return;const y=await this.M((0,p.$kc)(n,w));if(s.token.isCancellationRequested)return;let C;y?c.has(w)?C=0:(C=1,c.add(w)):(c.delete(w),C=2),this.J({resource:(0,A.$1g)(f,w),type:C,cId:this.r.correlationId})},a.a);h.set(w,(0,M.$Sc)(()=>clearTimeout(k)))}else{let k;c.has(w)?k=0:(k=1,c.add(w)),this.J({resource:(0,A.$1g)(f,w),type:k,cId:this.r.correlationId})}else if(g==="rename"||w!==d){const k=setTimeout(async()=>{const y=await S.Promises.exists(n);s.token.isCancellationRequested||(y?(this.J({resource:f,type:0,cId:this.r.correlationId},!0),t.add(await this.F(n,!1))):this.I(f))},a.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(k)))}else this.J({resource:f,type:0,cId:this.r.correlationId},!0)})}catch(f){s.token.isCancellationRequested||this.N(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.C()}}I(n){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:n,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(n,i=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}L(n){const i=(0,v.$Gq)(n);if(i.length>0){if(this.y)for(const s of i)this.P(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(n){if(E.$k)return S.Promises.exists(n);try{const i=(0,p.$oc)(n);return(await S.Promises.readdir((0,p.$nc)(n))).some(s=>s===i)}catch(i){return this.P(i),!1}}setVerboseLogging(n){this.y=n}N(n){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}O(n){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}P(n){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Wq=a;async function m(o,n,i,r,s=512){const t=await S.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),d=new L.$je(r);let l,c=!1;const h={path:o,excludes:[],recursive:!1},g=new a(h,void 0,D=>{(async()=>{for(const{type:w}of D)if(w===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:k}=await S.Promises.read(t,f,0,s,null);if(!k||d.token.isCancellationRequested)break;n(f.slice(0,k))}}catch(k){l=new Error(k),d.dispose(!0)}finally{c=!1}}})()});return await g.ready,i(),new Promise((D,w)=>{d.token.onCancellationRequested(async()=>{g.dispose();try{await S.Promises.close(t)}catch(k){l=new Error(k)}l?w(l):D()})})}}),define(ke[254],Ee([1,0,4,35,252,11,253,34]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class p extends L.$Rq{constructor(A){super(),this.L=A,this.onDidError=u.Event.None,this.watchers=new Set,this.O=!1}async J(A){A=this.W(A);const P=[],$=new Set(Array.from(this.watchers));for(const S of A){const v=this.R(S);v&&(0,O.$lk)(v.request.excludes,S.excludes)&&(0,O.$lk)(v.request.includes,S.includes)?$.delete(v):P.push(S)}P.length&&this.M(`Request to start watching: ${P.map(S=>this.I(S)).join(",")}`),$.size&&this.M(`Request to stop watching: ${Array.from($).map(S=>this.I(S.request)).join(",")}`);for(const S of $)this.U(S);for(const S of P)this.S(S)}R(A){for(const P of this.watchers)if(typeof A.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===A.correlationId)return P}else if((0,b.$mg)(P.request.path,A.path,!R.$k))return P}S(A){const P=new M.$Wq(A,this.L,S=>this.a.fire(S),()=>this.c.fire(A),S=>this.b.fire(S),this.O),$={request:A,instance:P};this.watchers.add($)}async stop(){await super.stop();for(const A of this.watchers)this.U(A)}U(A){this.M("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}W(A){const P=new Map;for(const $ of A){const S=R.$k?$.path:$.path.toLowerCase();let v=P.get($.correlationId);v||(v=new Map,P.set($.correlationId,v)),v.has(S)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I($)}`),v.set(S,$)}return Array.from(P.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(A){this.O=A;for(const P of this.watchers)P.instance.setVerboseLogging(A)}M(A,P){this.O&&this.b.fire({type:"trace",message:this.Z(A,P)})}N(A){this.b.fire({type:"warn",message:this.Z(A)})}Z(A,P){return P?`[File Watcher (node.js)] ${A} (${this.I(P.request)})`:`[File Watcher (node.js)] ${A}`}}e.$Yq=p}),define(ke[255],Ee([1,0,65,254]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class L extends u.$Dq{constructor(M,b,p){super(M,b,p),this.s()}r(M){return M.add(new O.$Yq(void 0))}}e.$Zq=L}),define(ke[256],Ee([1,0,15,81,194,65]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class M extends R.$Eq{constructor(p,E,A){super(p,E,A),this.s()}r(p){const E=p.add(new L.$Pq(u.$Hg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(E.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),O.ProxyChannel.toService((0,O.$7h)(E.getChannel("watcher")))}}e.$Qq=M}),define(ke[107],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class u{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$li=u}),define(ke[257],Ee([1,0,7,13,3,106,247,5,107,75]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const A=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class ${constructor(m=new p.$li,o=!1,n,i=A){this.i=m,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$mi,this),this._globalGraph=i?n?._globalGraph??new M.$3q(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,L.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m){this.m();const o=new class extends ${dispose(){this.h.delete(o),super.dispose()}}(m,this.j,this,this.l);return this.h.add(o),o}invokeFunction(m,...o){this.m();const n=v.traceInvocation(this.l,m);let i=!1;try{return m({get:s=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(m,...o){this.m();let n,i;return m instanceof R.$ki?(n=v.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat(o),n)):(n=v.traceCreation(this.l,m),i=this.o(m,o,n)),n.stop(),i}o(m,o=[],n){const i=b._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.s(t.id,n);f||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(m,o.concat(r))}q(m,o){if(this.i.get(m)instanceof R.$ki)this.i.set(m,o);else if(this.k)this.k.q(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const o=this.i.get(m);return!o&&this.k?this.k.r(m):o}s(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.r(m);return n instanceof R.$ki?this.u(m,n,o.branch(m,!0)):(o.branch(m,!1),n)}u(m,o,n){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,o,n)}finally{this.t.delete(m)}}v(m,o,n){const i=new M.$3q(t=>t.id.toString());let r=0;const s=[{id:m,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new P(i);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const d=this.r(f.id);if(d||this.y(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof R.$ki){const l={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new P(i);break}for(const{data:f}of t){if(this.r(f.id)instanceof R.$ki){const l=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,l)}i.removeNode(f)}}return this.r(m)}w(m,o,n=[],i,r){if(this.i.get(m)instanceof R.$ki)return this.x(m,o,n,i,r,this.g);if(this.k)return this.k.w(m,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(m,o,n=[],i,r,s){if(i){const t=new $(void 0,this.j,this,this.l);t.c=String(m);const f=new Map,d=new u.$Gh(()=>{const l=t.o(o,n,r);for(const[c,h]of f){const g=l[c];if(typeof g=="function")for(const D of h)D.disposable=g.apply(l,D.listener)}return f.clear(),s.add(l),l});return new Proxy(Object.create(null),{get(l,c){if(!d.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let D=f.get(c);return D||(D=new E.$5c,f.set(c,D)),(k,y,C)=>{if(d.isInitialized)return d.value[c](k,y,C);{const I={listener:[k,y,C],disposable:void 0},z=D.push(I);return(0,L.$Sc)(()=>{z(),I.disposable?.dispose()})}}}if(c in l)return l[c];const h=d.value;let g=h[c];return typeof g!="function"||(g=g.bind(h),l[c]=g),g},set(l,c,h){return d.value[c]=h,!0},getPrototypeOf(l){return o.prototype}})}else{const t=this.o(o,n,r);return s.add(t),t}}y(m,o){if(o&&console.warn(m),this.j)throw new Error(m)}}e.$4q=$;var S;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(S||(S={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,o){return m?new v(1,o.name):v.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const n=new v(3,m.toString());return this.h.push([m,o,n]),n}stop(){const m=Date.now()-this.g;v.f+=m;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,l,c]of s.h)if(l&&c){o=!0,t.push(`${f}CREATES -> ${d}`);const h=n(r+1,c);h&&t.push(h)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||o)&&v.all.add(i.join(`
`))}}e.$5q=v}),define(ke[12],Ee([1,0,213,47,4,56,3,27,11,23,18,2,40,5]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=a,e.log=o,e.$8j=g,e.$9j=D,e.$0j=w,e.$$j=k,e.$Tj=(0,S.$ni)("logService"),e.$Uj=(0,S.$ni)("loggerService");function v(){return new Date().toISOString()}function a(y){return(0,A.$5f)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Wj=m.Info;function o(y,C,I){switch(C){case m.Trace:y.trace(I);break;case m.Debug:y.debug(I);break;case m.Info:y.info(I);break;case m.Warning:y.warn(I);break;case m.Error:y.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let I="";for(let z=0;z<y.length;z++){let j=y[z];if(j instanceof Error&&(j=(0,O.$$i)(j,C)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(z>0?" ":"")+j}return I}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new L.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$Yj=i;class r extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(m.Trace)&&this.g(m.Trace,n([C,...I],!0))}debug(C,...I){this.f(m.Debug)&&this.g(m.Debug,n([C,...I]))}info(C,...I){this.f(m.Info)&&this.g(m.Info,n([C,...I]))}warn(C,...I){this.f(m.Warning)&&this.g(m.Warning,n([C,...I]))}error(C,...I){if(this.f(m.Error))if(C instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=C.stack,this.g(m.Error,n(z))}else this.g(m.Error,n([C,...I]))}flush(){}}e.$Zj=r;class s extends i{constructor(C=e.$Wj){super(),this.setLevel(C),this.g=!p.$i}trace(C,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}debug(C,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}info(C,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}warn(C,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...I):console.warn(`[main ${v()}]`,C,...I))}error(C,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...I):console.error(`[main ${v()}]`,C,...I))}flush(){}}e.$1j=s;class t extends i{constructor(C=e.$Wj,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$2j=t;class f extends i{constructor(C,I=e.$Wj){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...I])}debug(C,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...I])}info(C,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...I])}warn(C,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...I])}error(C,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,O.$$i)(C,this.f(m.Trace))}flush(){}}e.$3j=f;class d extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const z of this.g)z.trace(C,...I)}debug(C,...I){for(const z of this.g)z.debug(C,...I)}info(C,...I){for(const z of this.g)z.info(C,...I)}warn(C,...I){for(const z of this.g)z.warn(C,...I)}error(C,...I){for(const z of this.g)z.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$4j=d;class l extends M.$Uc{constructor(C,I,z){if(super(),this.h=C,this.j=I,this.b=new b.$Bc,this.c=this.B(new L.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$_d),this.onDidChangeVisibility=this.g.event,z)for(const j of z)this.b.set(j.resource,{logger:void 0,info:j})}m(C){return(0,A.$1f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const z=this.n(C),j=(0,A.$1f)(C)?C:I?.id??(0,R.$bj)(z.toString()).toString(16);let F=this.b.get(z)?.logger;const N=I?.logLevel==="always"?m.Trace:I?.logLevel;F||(F=this.s(z,N??this.getLogLevel(z)??this.h,{...I,id:j}));const T={logger:F,info:{resource:z,id:j,logLevel:N,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(z,T),F}n(C){return(0,A.$1f)(C)?(0,E.$1g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(P.URI.isUri(C)){const z=C,j=I,F=this.b.get(z);F&&j!==F.info.logLevel&&(F.info.logLevel=j===this.h?void 0:j,F.logger?.setLevel(j),this.b.set(F.info.resource,F),this.f.fire([z,j]))}else{this.h=C;for(const[z,j]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const z=this.m(C);z&&I!==!z.info.hidden&&(z.info.hidden=!I,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=l;class c{constructor(){this.onDidChangeLogLevel=new L.$_d().event}setLevel(C){}getLevel(){return m.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$6j=c;class h extends c{}e.$7j=h;function g(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const C=k(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Wj}function D(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function w(y){switch(y){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function k(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$_j=new $.$Ej("logLevel",D(m.Info))}),define(ke[258],Ee([1,0,19,7,13,4,3,17,65,12]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class A extends M.$Uc{constructor($,S){super(),this.a=$,this.b=S,this.c=this.B(new R.$_d),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$_d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$lh(0)),this.w=[],this.y=this.B(new O.$lh(0))}watch($,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n($,S):this.z($,S)}n($,S){const v={path:this.I($),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},a=(0,u.$Ub)(this.j,v);return this.r(),(0,M.$Sc)(()=>{a(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$1)($))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,p.$Fq)(S)),S=>this.G(S),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const S of this.j)(0,p.$Bq)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const S of this.j)(0,p.$Bq)(S)&&$.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,S){const v={path:this.I($),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},a=(0,u.$Ub)(this.w,v);return this.C(),(0,M.$Sc)(()=>{a(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,p.$Fq)($)),$=>this.G($),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,b.$ic)($.fsPath)}}e.$Jq=A}),define(ke[259],Ee([1,0,52,397,7,27,21,4,34,3,17,11,23,98,31,212,32,251,258,47,256,255]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,(()=>{try{(0,O.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$$i)(f)}`)}})();class t extends n.$Jq{static{this.J=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.O=new R.$Bc(c=>$.$Rg.getComparisonKey(c)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,P.$k&&(this.L|=1024)),this.L}async stat(d){try{const{stat:l,symbolicLink:c}=await v.SymlinkSupport.stat(this.I(d));return{type:this.N(l,c),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.gb(l)}}async M(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await v.Promises.readdir(this.I(d),{withFileTypes:!0}),c=[];return await Promise.all(l.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,$.$1g)(d,h.name))).type:g=this.N(h),c.push([h.name,g])}catch(g){this.a.trace(g)}})),c}catch(l){throw this.gb(l)}}N(d,l){let c;return l?.dangling?c=m.FileType.Unknown:d.isFile()?c=m.FileType.File:d.isDirectory()?c=m.FileType.Directory:c=m.FileType.Unknown,l&&(c|=m.FileType.SymbolicLink),c}async P(d){const l=this.I(d);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let c;for(;c=this.O.get(d);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await c.wait();const h=new L.$mh;return this.O.set(d,h),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,E.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.O.get(d)===h&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.O.delete(d)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let c;try{l?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(d)})`),c=await this.P(d));const h=this.I(d);return await v.Promises.readFile(h)}catch(h){throw this.gb(h)}finally{c?.dispose()}}Q(d){t.J&&this.a.trace(d)}readFileStream(d,l,c){const h=(0,S.$ne)(g=>M.$ze.concat(g.map(D=>M.$ze.wrap(D))).buffer);return(0,o.$yq)(this,d,h,g=>g.buffer,{...l,bufferSize:256*1024},c),h}async writeFile(d,l,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.R(d)?this.S(d,(0,$.$1g)((0,$.$Zg)(d),`${(0,$.$Xg)(d)}${c.atomic.postfix}`),l,c):this.U(d,l,c)}async R(d){try{const l=this.I(d),{symbolicLink:c}=await v.SymlinkSupport.stat(l);if(c)return!1}catch{}return!0}async S(d,l,c,h){const g=new E.$Tc;try{g.add(await this.P(d)),g.add(await this.P(l)),await this.U(l,c,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{g.dispose()}}async U(d,l,c,h){let g;try{const D=this.I(d);if(!c.create||!c.overwrite){if(await v.Promises.exists(D)){if(!c.overwrite)throw(0,m.$7k)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,m.$7k)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(g,0,l,0,l.byteLength)}catch(D){throw await this.hb(d,D)}finally{typeof g=="number"&&await this.close(g)}}static{this.Z=!0}static configureFlushOnWrite(d){t.Z=d}async open(d,l,c){const h=this.I(d);let g;(0,m.$Uk)(l)&&!c&&(g=await this.P(d));let D;try{if((0,m.$Uk)(l)&&l.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(h);k.mode&128||await v.Promises.chmod(h,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let w;if((0,m.$Uk)(l)){if(P.$i)try{await v.Promises.truncate(h,0),w="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}w||(w="w")}else w="r";D=await v.Promises.open(h,w)}catch(w){throw g?.dispose(),(0,m.$Uk)(l)?await this.hb(d,w):this.gb(w)}if(this.W.set(D,0),(0,m.$Uk)(l)&&this.Y.set(D,d),g){const w=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.X.set(D,g),w&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),w.dispose())}return D}async close(d){const l=this.X.get(d);try{if(this.W.delete(d),this.Y.delete(d)&&t.Z)try{await v.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await v.Promises.close(d)}catch(c){throw this.gb(c)}finally{l&&(this.X.get(d)===l&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.X.delete(d)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,c,h,g){const D=this.$(d,l);let w=null;try{w=(await v.Promises.read(d,c,h,g,D)).bytesRead}catch(k){throw this.gb(k)}finally{this.ab(d,D,w)}return w}$(d,l){return l===this.W.get(d)?null:l}ab(d,l,c){const h=this.W.get(d);typeof h=="number"&&(typeof l=="number"||(typeof c=="number"?this.W.set(d,h+c):this.W.delete(d)))}async write(d,l,c,h,g){return(0,L.$Hh)(()=>this.bb(d,l,c,h,g),100,3)}async bb(d,l,c,h,g){const D=this.$(d,l);let w=null;try{w=(await v.Promises.write(d,c,h,g,D)).bytesWritten}catch(k){throw await this.hb(this.Y.get(d),k)}finally{this.ab(d,D,w)}return w}async mkdir(d){try{await v.Promises.mkdir(this.I(d))}catch(l){throw this.gb(l)}}async delete(d,l){try{const c=this.I(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$kc)((0,A.$nc)(c),`${(0,A.$oc)(c)}${l.atomic.postfix}`)),await v.Promises.rm(c,v.RimRafMode.MOVE,h)}else try{await v.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:w}=await v.SymlinkSupport.stat(c);g=D.isDirectory()&&!w}catch{}if(g)await v.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.gb(c)}}async rename(d,l,c){const h=this.I(d),g=this.I(l);if(h!==g)try{await this.cb(d,l,"move",c.overwrite),await v.Promises.rename(h,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(2,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.gb(D)}}async copy(d,l,c){const h=this.I(d),g=this.I(l);if(h!==g)try{await this.cb(d,l,"copy",c.overwrite),await v.Promises.copy(h,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(3,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.gb(D)}}async cb(d,l,c,h){const g=this.I(d),D=this.I(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,p.$mg)(g,D,!0)),w){if(c==="copy")throw(0,m.$7k)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const y=await this.M(d);if(!y)throw(0,m.$7k)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const C=await this.M(l);if(C){if(!h)throw(0,m.$7k)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&C.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.db(d,l,!1)}async db(d,l,c){const h=this.I(d),g=this.I(l),D=!!(this.capabilities&1024);if((0,p.$mg)(h,g,!D))return;const w=new E.$Tc;try{w.add(await this.P(d)),w.add(await this.P(l)),c&&await v.Promises.mkdir((0,A.$nc)(g),{recursive:!0}),await v.Promises.copyFile(h,g)}catch(k){if(k.code==="ENOENT"&&!c)return this.db(d,l,!0);throw this.gb(k)}finally{w.dispose()}}t(d,l,c){return new r.$Qq(h=>d(h),h=>l(h),c)}F(d,l,c){return new s.$Zq(h=>d(h),h=>l(h),c)}gb(d){if(d instanceof m.$6k)return d;let l=d,c;switch(d.code){case"ENOENT":c=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=m.FileSystemProviderErrorCode.Unknown;break;default:c=m.FileSystemProviderErrorCode.Unknown}return(0,m.$7k)(l,c)}async hb(d,l){let c=this.gb(l);if(d&&c.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await v.SymlinkSupport.stat(this.I(d));h.mode&128||(c=(0,m.$7k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$1q=t}),define(ke[260],Ee([1,0,3,12]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=void 0;class L extends u.$Uc{constructor(M,b=[]){super(),this.a=new O.$4j([M,...b]),this.B(M.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$gQ=L}),define(ke[261],Ee([1,0,32,12]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;var L;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(L||(L={}));async function R(E,A,P,$,S){try{const v=await new Promise((m,o)=>{he(["@vscode/spdlog"],m,o)});v.setFlushOn(L.Trace);const a=await v.createAsyncRotatingLogger(E,A,P,$);return S?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(v){console.error(v)}return null}function M(E,A,P){switch(A){case O.LogLevel.Trace:E.trace(P);break;case O.LogLevel.Debug:E.debug(P);break;case O.LogLevel.Info:E.info(P);break;case O.LogLevel.Warning:E.warn(P);break;case O.LogLevel.Error:E.error(P);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(E,A){switch(A){case O.LogLevel.Trace:E.setLevel(L.Trace);break;case O.LogLevel.Debug:E.setLevel(L.Debug);break;case O.LogLevel.Info:E.setLevel(L.Info);break;case O.LogLevel.Warning:E.setLevel(L.Warning);break;case O.LogLevel.Error:E.setLevel(L.Error);break;case O.LogLevel.Off:E.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class p extends O.$Zj{constructor(A,P,$,S,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,P,$,S),this.B(this.onDidChangeLogLevel(a=>{this.r&&b(this.r,a)}))}async s(A,P,$,S){const v=$?6:1,a=30/v*u.$pl.MB,m=await R(A,P,a,v,S);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(A,P){this.r?M(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$8P=p}),define(ke[138],Ee([1,0,39,214,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(p){function E(v,a){return a-v}p.compare=E;const A=Object.create(null);A[p.Error]=(0,O.localize)(0,null),A[p.Warning]=(0,O.localize)(1,null),A[p.Info]=(0,O.localize)(2,null);function P(v){return A[v]||""}p.toString=P;function $(v){switch(v){case u.default.Error:return p.Error;case u.default.Warning:return p.Warning;case u.default.Info:return p.Info;case u.default.Ignore:return p.Hint}}p.fromSeverity=$;function S(v){switch(v){case p.Error:return u.default.Error;case p.Warning:return u.default.Warning;case p.Info:return u.default.Info;case p.Hint:return u.default.Ignore}}p.toSeverity=S}(M||(e.MarkerSeverity=M={}));var b;(function(p){const E="";function A($){return P($,!0)}p.makeKey=A;function P($,S){const v=[E];return $.source?v.push($.source.replace("\xA6","\\\xA6")):v.push(E),$.code?typeof $.code=="string"?v.push($.code.replace("\xA6","\\\xA6")):v.push($.code.value.replace("\xA6","\\\xA6")):v.push(E),$.severity!==void 0&&$.severity!==null?v.push(M.toString($.severity)):v.push(E),$.message&&S?v.push($.message.replace("\xA6","\\\xA6")):v.push(E),$.startLineNumber!==void 0&&$.startLineNumber!==null?v.push($.startLineNumber.toString()):v.push(E),$.startColumn!==void 0&&$.startColumn!==null?v.push($.startColumn.toString()):v.push(E),$.endLineNumber!==void 0&&$.endLineNumber!==null?v.push($.endLineNumber.toString()):v.push(E),$.endColumn!==void 0&&$.endColumn!==null?v.push($.endColumn.toString()):v.push(E),v.push(E),v.join("\xA6")}p.makeKeyOptionalMessage=P})(b||(e.IMarkerData=b={})),e.$Qt=(0,L.$ni)("markerService")}),define(ke[262],Ee([1,0,4,39,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Qv=e.Severity=void 0,e.$Rv=b,e.Severity=O.default,e.$Qv=(0,L.$ni)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(P){if(P){const $=P;return typeof $.id=="string"&&typeof $.label=="string"}return!1}var p;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new A,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity($){}updateMessage($){}updateActions($){}close(){}}e.$Sv=E;class A{infinite(){}done(){}total($){}worked($){}}e.$Tv=A}),define(ke[263],Ee([1,0,51]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)O=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:R.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ke[139],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,u.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(u,O){e(u,O,he)}};define(ke[108],Ee([1,0,7,22,3,5]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.ProgressLocation=e.$Uv=void 0,e.$Uv=(0,R.$ni)("progressService");var M;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Vv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$Wv=b;class p{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const S=this.d;this.d=()=>{S?.(),$()}}):Promise.resolve()}}e.$Xv=p;let E=class extends L.$Uc{constructor($,S){super(),this.a=new u.$Kh,S.withProgress($,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$Yv=E,e.$Yv=E=Je([We(1,e.$Uv)],E);class A extends L.$Uc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new L.$Tc)}start($){this.stop();const S=++this.a,v=new O.$je;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:v.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$Zv=A,e.$1v=(0,R.$ni)("editorProgressService")}),define(ke[37],Ee([1,0,62,18]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class L{constructor(){this.a=new Map}add(M,b){u.ok(O.$1f(M)),u.ok(O.$3f(b)),u.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$6n=new L}),define(ke[109],Ee([1,0,4,37]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new u.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,E){this.a[L(p)]=E,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;O.$6n.add(e.$7n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,203,54,109,37]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=a,e.$ko=m,e.$lo=o,e.$mo=i,e.$no=r;var E;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$$n={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const P=p.$6n.as(b.$7n.JSONContribution);class ${constructor(){this.h=new Set,this.i=new O.$_d,this.onDidSchemaChange=this.i.event,this.j=new O.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),P.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),P.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),P.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:l,source:c}of t)for(const h in l)if(f.add(h),e.$io.test(h)){const g=this.a.get(h),D=g?.valuesSources??new Map;if(c)for(const C of Object.keys(l[h]))D.set(C,c);const w={...g?.value||{},...l[h]};this.a.set(h,{source:c,value:w,valuesSources:D});const k=(0,M.$4i)(h),y={type:"object",default:w,description:R.localize(1,null,k),$ref:e.$fo,defaultDefaultValue:w,source:L.$1f(c)?void 0:c,defaultValueSource:c};d.push(...a(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:l[h],source:c});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:l}of t)for(const c in d){const h=this.a.get(c),g=L.$1f(l)?l:l?.id,D=L.$1f(h?.source)?h?.source:h?.source?.id;if(g===D)if(f.add(c),this.a.delete(c),e.$io.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(l=>{this.p(l,f,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,f){const d=l=>{if(l.properties)for(const c in l.properties){f.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>d(c))};for(const l of t){d(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,f=!0,d,l,c=3,h){c=L.$0f(t.scope)?c:t.scope;const g=t.properties;if(g)for(const w in g){const k=g[w];if(f&&i(w,k)){delete g[w];continue}if(k.source=d,k.defaultDefaultValue=g[w].default,this.w(w,k),e.$io.test(w)?k.scope=void 0:(k.scope=L.$0f(k.scope)?c:k.scope,k.restricted=L.$0f(k.restricted)?!!l?.includes(w):k.restricted),g[w].hasOwnProperty("included")&&!g[w].included){this.f[w]=g[w],delete g[w];continue}else this.d[w]=g[w],g[w].policy?.name&&this.e.set(g[w].policy.name,w);!g[w].deprecationMessage&&g[w].markdownDeprecationMessage&&(g[w].deprecationMessage=g[w].markdownDeprecationMessage),h.add(w)}const D=t.allOf;if(D)for(const w of D)this.p(w,f,d,l,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$_n.properties[t]=f,f.scope){case 1:e.$ao.properties[t]=f;break;case 2:e.$bo.properties[t]=f;break;case 6:e.$co.properties[t]=f;break;case 3:e.$do.properties[t]=f;break;case 4:e.$eo.properties[t]=f;break;case 5:e.$eo.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$_n.properties[t],f.scope){case 1:delete e.$ao.properties[t];break;case 2:delete e.$bo.properties[t];break;case 6:delete e.$co.properties[t];break;case 3:delete e.$do.properties[t];break;case 4:case 5:delete e.$eo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$fo};this.w(f,d),e.$_n.properties[f]=d,e.$ao.properties[f]=d,e.$bo.properties[f]=d,e.$co.properties[f]=d,e.$do.properties[f]=d,e.$eo.properties[f]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=t,e.$ao.patternProperties[e.$ho]=t,e.$bo.patternProperties[e.$ho]=t,e.$co.patternProperties[e.$ho]=t,e.$do.patternProperties[e.$ho]=t,e.$eo.patternProperties[e.$ho]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let l=d?.value,c=d?.source;L.$8f(l)&&(l=f.defaultDefaultValue,c=void 0),L.$8f(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=c}}const S="\\[([^\\]]+)\\]",v=new RegExp(S,"g");e.$ho=`^(${S})+$`,e.$io=new RegExp(e.$ho);function a(s){const t=[];if(e.$io.test(s)){let f=v.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=v.exec(s)}}return(0,u.$Mb)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new $;p.$6n.add(e.$$n.Configuration,n);function i(s,t){return s.trim()?e.$io.test(s)?R.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[264],Ee([1,0,19,4,164,3,27,24,18,2,54,85,37]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=i;function S(f){return Object.isFrozen(f)?f:b.$Un(f)}class v{constructor(d={},l=[],c=[],h){this.b=d,this.c=l,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof v)return l;const c=new a("");return c.parseRaw(l),c.configurationModel});this.f=d.reduce((l,c)=>c===l?c:l.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$2i)(this.contents,d):this.contents}inspect(d,l){const c=this;return{get value(){return S(c.rawConfiguration.getValue(d))},get override(){return l?S(c.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return S(l?c.rawConfiguration.override(l).getValue(d):c.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:g,identifiers:D,keys:w}of c.rawConfiguration.overrides){const k=new v(g,w).getValue(d);k!==void 0&&h.push({identifiers:D,value:k})}return h.length?S(h):void 0}}}getOverrideValue(d,l){const c=this.i(l);return c?d?(0,A.$2i)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const c of this.overrides)c.identifiers.includes(d)&&l.push(...c.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$Tn(this.contents),c=b.$Tn(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of d)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(l,D.contents);for(const w of D.overrides){const[k]=c.filter(y=>u.$ub(y.identifiers,w.identifiers));k?(this.h(k.contents,w.contents),k.keys.push(...w.keys),k.keys=u.$Mb(k.keys)):c.push(b.$Tn(w))}for(const w of D.keys)h.indexOf(w)===-1&&h.push(w)}return new v(l,h,c,g.every(D=>D instanceof v)?void 0:g)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let g=this.contents[h];const D=l[h];D&&(typeof g=="object"&&typeof D=="object"?(g=b.$Tn(g),this.h(g,D)):g=D),c[h]=g}return new v(c,this.keys,this.overrides)}h(d,l){for(const c of Object.keys(l)){if(c in d&&p.$3f(d[c])&&p.$3f(l[c])){this.h(d[c],l[c]);continue}d[c]=b.$Tn(l[c])}}i(d){let l=null,c=null;const h=g=>{g&&(c?this.h(c,g):c=b.$Tn(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===d?l=g.contents:g.identifiers.includes(d)&&h(g.contents);return h(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$1i)(this.contents,d),P.$io.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>u.$ub(c.identifiers,(0,P.$jo)(d))),1))}j(d,l,c){(0,A.$Zi)(this.contents,d,l,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),P.$io.test(d)&&this.overrides.push({identifiers:(0,P.$jo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$Yi)(this.contents[d],h=>console.error(h))})}}e.$oo=v;class a{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!p.$0f(d)){const c=this.g(d);this.parseRaw(c,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:c,keys:h,overrides:g,restricted:D,hasExcludedProperties:w}=this.h(d,l);this.b=new v(c,h,g,w?[d]:void 0),this.c=D||[]}g(d){let l={},c=null,h=[];const g=[],D=[];function w(y){Array.isArray(h)?h.push(y):c!==null&&(h[c]=y)}const k={onObjectBegin:()=>{const y={};w(y),g.push(h),h=y,c=null},onObjectProperty:y=>{c=y},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const y=[];w(y),g.push(h),h=y,c=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:w,onError:(y,C,I)=>{D.push({error:y,offset:C,length:I})}};if(d)try{L.$Hn(d,k),l=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}h(d,l){const c=$.$6n.as(P.$$n.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,l);d=h.raw;const g=(0,A.$Yi)(d,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(d),w=this.j(d,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:g,keys:D,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,c,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:g};const D={},w=[];for(const k in d)if(P.$io.test(k)&&c){const y=this.i(d[k],l,!1,h);D[k]=y.raw,g=g||y.hasExcludedProperties,w.push(...y.restricted)}else{const y=l[k],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&w.push(k),!h.exclude?.includes(k)&&(h.include?.includes(k)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&y?.restricted))?D[k]=d[k]:g=!0}return{raw:D,restricted:w,hasExcludedProperties:g}}j(d,l){const c=[];for(const h of Object.keys(d))if(P.$io.test(h)){const g={};for(const D in d[h])g[D]=d[h][D];c.push({identifiers:(0,P.$jo)(h),keys:Object.keys(g),contents:(0,A.$Yi)(g,l)})}return c}}e.$po=a;class m extends R.$Uc{constructor(d,l,c,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new O.$_d),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&c.isEqual(g.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=m;class o{constructor(d,l,c,h,g,D,w,k,y,C,I,z,j){this.a=d,this.b=l,this.c=c,this.overrideIdentifiers=h,this.d=g,this.f=D,this.g=w,this.h=k,this.i=y,this.j=C,this.k=I,this.l=z,this.m=j}get value(){return S(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,c,h,g=new v,D=new v,w=new M.$Bc,k=new v,y=new M.$Bc){this.c=d,this.d=l,this.f=c,this.g=h,this.h=g,this.i=D,this.j=w,this.l=k,this.m=y,this.a=null,this.b=new M.$Bc,this.n=null}getValue(d,l,c){return this.p(d,l,c).getValue(d)}updateValue(d,l,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new v,this.m.set(c.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),c.resource||(this.a=null)}inspect(d,l,c){const h=this.p(d,l,c),g=this.t(l.resource,c),D=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const k of h.overrides)for(const y of k.identifiers)h.getOverrideValue(d,y)!==void 0&&w.add(y);return new o(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,g||void 0,D)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const c=[];if(!l){const{added:h,updated:g,removed:D}=s(this.c,d);l=[...h,...g,...D]}for(const h of l)for(const g of(0,P.$jo)(h)){const D=this.c.getKeysForOverrideIdentifier(g),w=d.getKeysForOverrideIdentifier(g),k=[...w.filter(y=>D.indexOf(y)===-1),...D.filter(y=>w.indexOf(y)===-1),...D.filter(y=>!b.$Xn(this.c.override(g).getValue(y),d.override(g).getValue(y)))];c.push([g,k])}return this.updateDefaultConfiguration(d),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:c,removed:h}=s(this.d,d),g=[...l,...c,...h];return g.length&&this.updatePolicyConfiguration(d),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.applicationConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.localUserConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.remoteUserConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.workspaceConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(d,l){const c=this.folderConfigurations.get(d),{added:h,updated:g,removed:D,overrides:w}=s(c,l),k=[...h,...g,...D];return(k.length||!c)&&this.updateFolderConfiguration(d,l),{keys:k,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:g,overrides:D}=s(l,void 0);return{keys:[...c,...h,...g],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,c){let h=this.q(l,c);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let c=this.r();if(l&&d){const h=l.getFolder(d);h&&(c=this.s(h.uri)||c);const g=this.m.get(d);g&&(c=c.merge(g))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const c=this.r(),h=this.j.get(d);h?(l=c.merge(h),this.b.set(d,l)):l=c}return l}t(d,l){if(l&&d){const c=l.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:c,overrides:h,keys:g}=this.j.get(l);return d.push([l,{contents:c,overrides:h,keys:g}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),g=this.w(d.user),D=this.w(d.workspace),w=d.folders.reduce((k,y)=>(k.set(E.URI.revive(y[0]),this.w(y[1])),k),new M.$Bc);return new n(l,c,h,g,new v,D,w,new v,new M.$Bc)}static w(d){return new v(d.contents,d.keys,d.overrides)}}e.$ro=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,l=new Map;for(const h of f)h.keys.forEach(g=>d.add(g)),h.overrides.forEach(([g,D])=>{const w=(0,M.$yc)(l,g,new Set);D.forEach(k=>w.add(k))});const c=[];return l.forEach((h,g)=>c.push([g,[...h.values()]])),{keys:[...d.values()],overrides:c}}class r{constructor(d,l,c,h){this.change=d,this.f=l,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of d.keys)this.affectedKeys.add(g);for(const[,g]of d.overrides)for(const D of g)this.affectedKeys.add(D);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const g=h+c.length;if(g>=this.d.length)return!1;const D=this.d.charCodeAt(g);if(D!==this.b&&D!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,k=this.g.getValue(d,l,this.h);return!b.$Xn(w,k)}return!0}}e.$to=r;function s(f,d){const{added:l,removed:c,updated:h}=t(d?.rawConfiguration,f?.rawConfiguration),g=[],D=f?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const k=w.filter(y=>!D.includes(y));for(const y of k)g.push([y,d.getKeysForOverrideIdentifier(y)])}if(f){const k=D.filter(y=>!w.includes(y));for(const y of k)g.push([y,f.getKeysForOverrideIdentifier(y)])}if(d&&f){for(const k of D)if(w.includes(k)){const y=t({contents:f.getOverrideValue(void 0,k)||{},keys:f.getKeysForOverrideIdentifier(k)},{contents:d.getOverrideValue(void 0,k)||{},keys:d.getKeysForOverrideIdentifier(k)});g.push([k,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:c,updated:h,overrides:g}}function t(f,d){const l=f?d?f.keys.filter(g=>d.keys.indexOf(g)===-1):[...f.keys]:[],c=d?f?d.keys.filter(g=>f.keys.indexOf(g)===-1):[...d.keys]:[],h=[];if(f&&d){for(const g of d.keys)if(f.keys.indexOf(g)!==-1){const D=(0,A.$2i)(d.contents,g),w=(0,A.$2i)(f.contents,g);b.$Xn(D,w)||h.push(g)}}return{added:l,removed:c,updated:h}}}),define(ke[265],Ee([1,0,21,4,3,82]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csb=e.$asb=e.$_rb=void 0,e.$bsb=b;const M=(E,A,P)=>{const $=new Uint8Array(16);for(let a=0;a<16;a++)$[a]=Math.round(Math.random()*256);const S=(0,u.$Te)(u.$ze.wrap($));return[`GET ws://localhost${E}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$_rb=M,e.$asb=u.$ze.fromString(`\r
\r
`);async function b(E,A,P,$,S){E.write(u.$ze.fromString((0,e.$_rb)(A,P,$)));const v=new L.$Tc;try{return await new Promise((a,m)=>{let o;v.add(E.onData(n=>{o?o=u.$ze.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$asb);if(i===-1)return;a(E),E.pauseData();const r=o.slice(i+e.$asb.byteLength);r.byteLength&&S.onData.fire(r)})),v.add(E.onClose(n=>m(n??new Error("socket closed")))),v.add(E.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw E.dispose(),a}finally{v.dispose()}}class p extends L.$Uc{constructor(A,P){super(),this.g=A,this.a=this.B(new O.$ce),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new O.$_d),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event($=>this.a.fire($))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$csb=p}),define(ke[66],Ee([1,0,13,5]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.RemoteAuthorityResolverErrorCode=e.$Al=e.$zl=e.RemoteConnectionType=e.$yl=void 0,e.$Cl=E,e.$yl=(0,O.$ni)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$zl=R;class M{constructor(P,$){this.host=P,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Al=M;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class p extends u.$bb{static isNotAvailable(P){return P instanceof p&&P._code===b.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof p&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof p&&P._code===b.NoResolverFound}static isInvalidAuthority(P){return P instanceof p&&P._code===b.InvalidAuthority}static isHandled(P){return P instanceof p&&P.isHandled}constructor(P,$=b.Unknown,S){super(P),this._message=P,this._code=$,this._detail=S,this.isHandled=$===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Bl=p;function E(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}}),define(ke[266],Ee([1,0,7,21,22,13,4,3,15,59,38,30,82,66]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Hl=D,e.$Il=w,e.$Jl=y;const v=30*1e3;var a;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(x){const U=new L.$je;return setTimeout(()=>U.cancel(),x),U.token}function n(x,U){if(x.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ne=new L.$je;return x.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$gh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(x,U){const ne=new i(U);return ne.registerDisposable(x.onControlMessage(be=>{const De=JSON.parse(be.toString()),ae=J(De);ae?ne.reject(ae):ne.resolve(De)})),ne.promise}function s(x,U,ne,be,De,ae,ce,se){const K=new i(se),ie=A.$8d.create(!1);return x.info(`Creating a socket (${ce})...`),E.mark(`code/willCreateSocket/${ae}`),U.connect(ne,be,De,ce).then(le=>{K.didTimeout?(E.mark(`code/didCreateSocketError/${ae}`),x.info(`Creating a socket (${ce}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(E.mark(`code/didCreateSocketOK/${ae}`),x.info(`Creating a socket (${ce}) was successful after ${ie.elapsed()} ms.`),K.resolve(le))},le=>{E.mark(`code/didCreateSocketError/${ae}`),x.info(`Creating a socket (${ce}) returned an error after ${ie.elapsed()} ms.`),x.error(le),K.reject(le)}),K.promise}function t(x,U){const ne=new i(U);return x.then(be=>{ne.didTimeout||ne.resolve(be)},be=>{ne.didTimeout||ne.reject(be)}),ne.promise}async function f(x,U,ne,be){const De=pe(x,U);x.logService.trace(`${De} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await s(x.logService,x.remoteSocketFactoryService,x.connectTo,p.$Ag.getServerRootPath(),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${x.reconnectionToken}`,be)}catch(le){throw x.logService.error(`${De} socketFactory.connect() failed or timed out. Error:`),x.logService.error(le),le}x.logService.trace(`${De} 2/6. socketFactory.connect() was successful.`);let ce,se;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(ae,null),ce=x.reconnectionProtocol,se=!1):(ce=new $.$bi({socket:ae}),se=!0),x.logService.trace(`${De} 3/6. sending AuthRequest control message.`);const K=await t(x.signService.createNewMessage((0,P.$Jg)()),be),ie={type:"auth",auth:x.connectionToken||"00000000000000000000",data:K.data};ce.sendControl(O.$ze.fromString(JSON.stringify(ie)));try{const le=await r(ce,n(be,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(x.logService.trace(`${De} 4/6. received SignRequest control message.`),!await t(x.signService.validate(K,le.signedData),be)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Ae=await t(x.signService.sign(le.data),be),me={type:"connectionType",commit:x.commit,signedData:Ae,desiredConnectionType:U};return ne&&(me.args=ne),x.logService.trace(`${De} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(O.$ze.fromString(JSON.stringify(me))),{protocol:ce,ownsProtocol:se}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(x.logService.error(`${De} the handshake timed out. Error:`),x.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${De} received error control message when negotiating connection. Error:`),x.logService.error(le)),se&&ee(ce),le}}async function d(x,U,ne,be){const De=Date.now(),ae=pe(x,U),{protocol:ce,ownsProtocol:se}=await f(x,U,ne,be),K=new i(be);return K.registerDisposable(ce.onControlMessage(ie=>{const le=JSON.parse(ie.toString()),de=J(le);de?(x.logService.error(`${ae} received error control message when negotiating connection. Error:`),x.logService.error(de),se&&ee(ce),K.reject(de)):(x.reconnectionProtocol?.endAcceptReconnection(),x.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${Ce(De)}!`),K.resolve({protocol:ce,firstMessage:le}))})),K.promise}async function l(x,U){const{protocol:ne}=await d(x,1,void 0,U);return{protocol:ne}}async function c(x,U,ne){const{protocol:be,firstMessage:De}=await d(x,2,U,ne),ae=De&&De.debugPort;return{protocol:be,debugPort:ae}}async function h(x,U,ne){const be=Date.now(),De=pe(x,3),{protocol:ae}=await f(x,3,U,ne);return x.logService.trace(`${De} 6/6. handshake finished, connection is up and running after ${Ce(be)}!`),ae}async function g(x,U,ne){const{connectTo:be,connectionToken:De}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,connectTo:be,connectionToken:De,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:x.remoteSocketFactoryService,signService:x.signService,logService:x.logService}}async function D(x,U,ne){return k(x,async be=>{const{protocol:De}=await l(be,L.CancellationToken.None);return new H(x,U,ne,be.reconnectionToken,De)})}async function w(x,U){return k(x,async ne=>{const{protocol:be,debugPort:De}=await c(ne,U,L.CancellationToken.None);return new Z(x,U,ne.reconnectionToken,be,De)})}async function k(x,U){for(let be=1;;be++)try{const De=(0,P.$Jg)(),ae=await g(x,De,null);return await U(ae)}catch(De){if(be<5)x.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),x.logService.error(De);else throw x.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),x.logService.error(De),B.triggerPermanentFailure(0,0,S.$Bl.isHandled(De)),De}}async function y(x,U,ne){const be=await g(x,(0,P.$Jg)(),null);return await h(be,{host:U,port:ne},L.CancellationToken.None)}function C(x){return(0,u.$ah)(U=>new Promise((ne,be)=>{const De=setTimeout(ne,x*1e3);U.onCancellationRequested(()=>{clearTimeout(De),ne()})}))}var I;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class z{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$Kl=z;class j{constructor(U,ne,be,De){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=be,this.c=De,this.type=1}skipWait(){this.c.cancel()}}e.$Ll=j;class F{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=2}}e.$Ml=F;class N{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=4}}e.$Nl=N;class T{constructor(U,ne,be,De){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.handled=De,this.type=3}}e.$Ol=T;class B extends b.$Uc{static triggerPermanentFailure(U,ne,be){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=be,this.j.forEach(De=>De.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ne,be,De,ae){super(),this.t=U,this.u=ne,this.reconnectionToken=be,this.protocol=De,this.w=ae,this.m=this.B(new M.$_d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(De.onSocketClose(ce=>{const se=te(this.t,this.reconnectionToken,!0);ce?ce.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(De.onSocketTimeout(ce=>{const se=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Sc)(()=>{const ce=B.j.indexOf(this);ce>=0&&B.j.splice(ce,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const De=be<ne.length?ne[be]:ne[ne.length-1];try{if(De>0){const ce=C(De);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),De,ce)),this.u.logService.info(`${U} waiting for ${De} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const ae=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ae.connectTo}...`),await this.G(ae,o(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(S.$Bl.isTemporarilyNotAvailable(ae)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((0,R.$4)(ae)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if(ae instanceof S.$Bl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,S.$Bl.isHandled(ae));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,be){this.w?B.triggerPermanentFailure(U,ne,be):this.D(U,ne,be)}D(U,ne,be){this.m.fire(new T(this.reconnectionToken,U,ne,be)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Pl=B;class H extends B{constructor(U,ne,be,De,ae){super(1,U,De,ae,!0),this.client=this.B(new $.$_h(ae,{remoteAuthority:ne,clientId:be},U.ipcLogger))}async G(U,ne){await l(U,ne)}}e.$Ql=H;class Z extends B{constructor(U,ne,be,De,ae){super(2,U,be,De,!1),this.H=ne,this.debugPort=ae}async G(U,ne){await c(U,this.H,ne)}}e.$Rl=Z;function ee(x){try{x.acceptDisconnect();const U=x.getSocket();x.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function J(x){if(x&&x.type==="error"){const U=new Error(`Connection error: ${x.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Y(x,U){for(;x.length<U;)x+=" ";return x}function re(x,U){return`[remote-connection][${Y(m(x),13)}][${U.substr(0,5)}\u2026]`}function te(x,U,ne){return`${re(x,U)}[${ne?"reconnect":"initial"}]`}function pe(x,U){return`${te(U,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.connectTo}]`}function Ce(x){return`${Date.now()-x} ms`}}),define(ke[86],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=O,e.$zm=L,e.$Am=R,e.$Bm=M;function O(p){return p.scheme===u.Schemas.vscodeRemote?p.authority:void 0}function L(p){if(!p)return;const E=p.indexOf("+");return E<0?p:p.substr(0,E)}function R(p){const{host:E,port:A}=b(p);if(typeof A>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:A}}function M(p,E){let{host:A,port:P}=b(p);return typeof P>"u"&&(P=E),{host:A,port:P}}function b(p){const E=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const A=p.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const P=p.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:p,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=R,e.$Lm=P,e.$Mm=$,e.$Nm=S,e.$Om=v,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function R(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const n=typeof m=="string"?m:m.value,i=typeof o=="string"?o:o.value;return u.$qf(n,i)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Im=p;class E{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add(p.toKey(m))}delete(m){return this.c.delete(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}}e.$Jm=E;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(p.toKey(m))}get(m){return this.c.get(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}set(m,o){this.c.set(p.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=A;function P(a){return $(a)}function $(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function S(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function v(a,m){if(m){const o=`onResolveRemoteAuthority:${(0,L.$zm)(m)}`;return!!a.activationEvents?.includes(o)}return!1}e.$Pm=(0,O.$ni)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const p of M){const E=this.readActivationEvents(p);E.length>0&&(b[O.$Im.toKey(p.identifier)]=E)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let p=0;p<b.length;p++)b[p]==="onUri"&&(b[p]=`onUri:${O.$Im.toKey(M.identifier)}`);if(!M.contributes)return b;for(const p in M.contributes){const E=this.a.get(p);if(!E)continue;const A=M.contributes[p],P=Array.isArray(A)?A:[A];try{E(P,b)}catch($){(0,u.$1)($)}}return b}}e.$XF=L,e.$YF=new L}),define(ke[267],Ee([1,0,3,5]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=void 0,e.$Dl=(0,O.$ni)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,u.$Sc)(()=>{const p=this.a[M]?.indexOf(b);typeof p=="number"&&p>=0&&this.a[M]?.splice(p,1)})}b(M){return(this.a[M.type]||[]).find(p=>p.supports(M))}connect(M,b,p,E){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,b,p,E)}}e.$El=L}),define(ke[268],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(u.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$z0b=u}),define(ke[110],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=void 0,e.$Fl="signService",e.$Gl=(0,u.$ni)(e.$Fl)}),define(ke[141],Ee([1,0,268]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class O extends u.$z0b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>he(["vsda"],R,M))}}e.$vcc=O}),define(ke[269],Ee([1,0,11,51,30]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=M,e.$8o=b;function R(p){if(u.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function M(p,E,A,P,$,S,v,a,m){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=v,o.sessionID=(0,L.$Jg)()+Date.now(),o.commitHash=P,o.version=$,o["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,u.$h)(u.$u),o["common.nodePlatform"]=O.$ec,o["common.nodeArch"]=A,o["common.product"]=m||"desktop",a&&(o["common.msftInternal"]=a);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(o["common.snap"]="true");const r=R(E);return r&&(o["common.platformDetail"]=r),o}function b(p){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const A=E.toLowerCase();return p.some(P=>A===P)}}),define(ke[270],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,u.$ni)("telemetryService"),e.$Tl=(0,u.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var O;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Ee([1,0,24,18,86,269,270]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=A,e.$ep=P,e.$fp=$,e.$gp=S,e.$hp=a,e.$ip=o,e.$jp=n,e.$kp=s;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$9o=b;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=p,e.$$o=new p;class E{async publicLog(f,d,l){}async publicLogError(f,d,l){}}e.$_o=E,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function P(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const f=t.getValue(M.$1l),d=t.getValue(M.$2l);if(t.getValue(M.$3l)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(t){const f={},d={},l={};m(t,l);for(let c in l){c=c.length>150?c.substr(c.length-149):c;const h=l[c];typeof h=="number"?d[c]=h:typeof h=="boolean"?d[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),f[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[c]=h)}return{properties:f,measurements:d}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const f=(0,L.$zm)(t);return v.has(f)?f:"other"}function m(t,f,d=0,l){if(t)for(const c of Object.getOwnPropertyNames(t)){const h=t[c],g=l?l+c:c;Array.isArray(h)?f[g]=(0,u.$Yn)(h):h instanceof Date?f[g]=h.toISOString():(0,O.$3f)(h)?d<2?m(h,f,d+1,g+"."):f[g]=(0,u.$Yn)(h):f[g]=h}}function o(t,f){const d=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,R.$8o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const D of f)for(;;){const w=D.exec(t);if(!w)break;l.push([w.index,D.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const D=h.exec(t);if(!D)break;const w=l.some(([k,y])=>D.index<y&&k<h.lastIndex);!c.test(D[0])&&!w&&(d+=t.substring(g,D.index)+"<REDACTED: user-file-path>",g=h.lastIndex)}return g<t.length&&(d+=t.substr(g)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,u.$Vn)(t,d=>{if(d instanceof b||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,f);for(const c of f)l=l.replace(c,"");return l=r(l),l}})}}),define(ke[271],Ee([1,0,14,137,25,11,2,13,51,87]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=A,e.$np=v,e.$op=a,e.$pp=m,e.$qp=o,e.$rp=n,e.$sp=i,e.$tp=r,e.$vp=s,e.$wp=f;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$lf)(d.id,l.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(l){const c=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new $(l.identifier,c,h)}static parse(l){const c=P.exec(l);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof $?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$mp=$;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(d){const l=S.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function o(d,l){return m(a(d??L.$Em,l))}function n(d,l){const c=[],h=g=>{for(const D of c)if(D.some(w=>A(l(w),l(g))))return D;return null};for(const g of d){const D=h(g);D?D.push(g):c.push([g])}return c}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new E.$9o(d.identifier.id),name:new E.$9o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$up=new L.$Im("pprice.better-merge");function s(d,l){const c=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&c.every(D=>!A(D.identifier,{id:g}))){const D=d.filter(w=>A(w.identifier,{id:g}));D.length===1&&(c.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(d,l){if(!R.$k)return!1;let c;try{c=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){l.debug("Error while getting the os-release file.",(0,b.$0)(g))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,l){const c=await t(d,l),h=(0,O.$So)(c?"alpine":R.$u,p.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(ke[272],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=u,e.$as=O,e.$bs=L,e.$cs=R,e.$ds=M,e.$es=b;function u(p){return[...p.entries()]}function O(p){return p?[...p.entries()]:[]}function L(p){return new Map(p)}function R(p){return new Map(p??[])}function M(p){return Array.from(p.entries()).map(E=>[E[0],u(E[1].map),O(E[1].descriptionMap)])}function b(p){return new Map(p.map(E=>[E[0],{map:L(E[1]),descriptionMap:R(E[2])}]))}}),define(ke[273],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usb=void 0;class u{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const b=R(p=>{const E=typeof p=="string"?p:p.data;let A=this.a.get(L);if(A){A.data.push(E);return}const P=setTimeout(()=>this.flushBuffer(L),M);A={data:[E],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(L),b.dispose()}},this.a.set(L,A)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$usb=u}),define(ke[274],Ee([1,0,7,78,99,57,4,18,2,215,109,37]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$6w=e.$5w=e.$4w=e.$3w=e.$2w=e.IconFontDefinition=e.IconContribution=e.$Yw=void 0,e.$Zw=m,e.$1w=o,e.$Yw={IconContribution:"base.contributions.icons"};var $;(function(s){function t(f,d){let l=f.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const c=a.getIcon(l.id);if(!c)return;l=c.defaults}return l}s.getDefinition=t})($||(e.IconContribution=$={}));var S;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(d){const l=c=>(0,b.$1f)(c)?c:void 0;if(d&&Array.isArray(d.src)&&d.src.every(c=>(0,b.$1f)(c.format)&&(0,b.$1f)(c.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(c=>({format:c.format,location:p.URI.parse(c.location)}))}}s.fromJSONObject=f})(S||(e.IconFontDefinition=S={}));class v{constructor(){this.a=new M.$_d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,l){const c=this.b[t];if(c){if(d&&!c.description){c.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return c}const h={id:t,description:d,defaults:f,deprecationMessage:l};this.b[t]=h;const g={$ref:"#/definitions/icons"};return l&&(g.deprecationMessage=l),d&&(g.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(c,h)=>c.id.localeCompare(h.id),f=c=>{for(;R.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(c=>this.b[c]);for(const c of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|${R.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of l.filter(h=>!R.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|`);return d.join(`
`)}}const a=new v;P.$6n.add(e.$Yw.IconContribution,a);function m(s,t,f,d){return a.registerIcon(s,t,f,d)}function o(){return a}function n(){const s=(0,L.$Ij)();for(const t in s){const f="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:f})}}n(),e.$2w="vscode://schemas/icons";const i=P.$6n.as(A.$7n.JSONContribution);i.registerSchema(e.$2w,a.getIconSchema());const r=new u.$zh(()=>i.notifySchemaChanged(e.$2w),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$3w=m("widget-close",O.$Mj.close,(0,E.localize)(2,null)),e.$4w=m("goto-previous-location",O.$Mj.arrowUp,(0,E.localize)(3,null)),e.$5w=m("goto-next-location",O.$Mj.arrowDown,(0,E.localize)(4,null)),e.$6w=R.ThemeIcon.modify(O.$Mj.sync,"spin"),e.$7w=R.ThemeIcon.modify(O.$Mj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,54,5,12]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$9v=e.$7v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$3v=e.$2v=void 0,e.$4v=E,e.$5v=P,e.$6v=$,e.$8v=S,e.$0v=v,e.$$v=a,e.$2v=(0,R.$ni)("tunnelService"),e.$3v=(0,R.$ni)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var p;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=P(O.URI.parse(s));if(t)return t}}}e.$7v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(n){return e.$7v.indexOf(n)>=0}e.$9v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$9v.indexOf(n)>=0}function a(n,i,r,s){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$_d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_v=m;let o=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$_d,this.onTunnelOpened=this.a.event,this.b=new u.$_d,this.onTunnelClosed=this.b.event,this.c=new u.$_d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||S(i))&&(i=e.$7v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,d=!1,l,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(h,r,s,t,f,d,l,c);return g?g.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];S(i)?(s.push(...e.$7v),s.push(...e.$9v)):v(i)&&s.push(...e.$9v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(i){return!!P(i)}u(i,r,s,t,f,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const c=s;this.j.add(c);const h=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(h):!1},D={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==p.Private:void 0,protocol:l},w=i.forwardPort(D,g);return w?(this.q(r,s,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),w}};e.$aw=o,e.$aw=o=Je([We(0,M.$Tj),We(1,L.$Ti)],o)}),define(ke[275],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=void 0,e.$rl=(0,u.$ni)("IUriIdentityService")}),define(ke[276],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$bw=void 0,e.$bw=(0,u.$ni)("editSessionIdentityService");var O;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ke[277],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=O,e.$8L=L,e.$9L=R,e.$0L=M,e.$$L=b;function O(p){return p.scheme!==u.Schemas.file&&p.scheme!==u.Schemas.vscodeRemote}function L(p){if(p.folders.length)return p.folders.every(E=>O(E.uri))?p.folders[0].uri:void 0;if(p.configuration&&O(p.configuration))return p.configuration}function R(p){return L(p)?.scheme}function M(p){return L(p)?.authority}function b(p){return L(p)!==void 0}}),define(ke[41],Ee([1,0,217,17,77,23,2,5,15]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=E,e.$yi=A,e.$Bi=P,e.$Ci=$,e.$Di=S,e.$Ei=a,e.$Fi=m,e.$Ii=i,e.$Ni=r,e.$Oi=s,e.$Qi=t,e.$Ri=f,e.$Si=d,e.$wi=(0,b.$ni)("contextService");function E(l){const c=l;return typeof c?.id=="string"&&M.URI.isUri(c.uri)}function A(l){return typeof l?.id=="string"&&!E(l)&&!$(l)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function P(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,O.$oc)(l)}:c?e.$zi:e.$Ai;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(l){const c=l;return typeof c?.id=="string"&&M.URI.isUri(c.configPath)}function S(l){const c=l;if(c?.uri)return{id:c.id,uri:M.URI.revive(c.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function a(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(l){const c=l;return!!(c&&typeof c=="object"&&M.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class o{constructor(c,h,g,D,w){this.h=c,this.j=g,this.k=D,this.l=w,this.c=L.$ti.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=L.$ti.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=o;class n{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.$1g)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=n;function i(l){return new n({uri:l,index:0,name:(0,R.$Wg)(l)},{uri:l.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,u.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function r(l,c){return R.$Rg.isEqualOrParent(l,c.untitledWorkspacesHome)}function s(l){let c;return M.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===p.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Pi}function f(l,c){return!r(l,c)&&!s(l)}function d(l){return(typeof l=="string"?(0,O.$pc)(l):(0,R.$Yg)(l))===e.$Ki}}),define(ke[278],Ee([1,0,56,4,3,23,2,216,136,32,5,12,41,27,275,7,30,14,18]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.$tl=e.ProfileResourceType=void 0,e.$sl=r,e.$ul=s,e.$vl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&M.URI.isUri(c.location)&&M.URI.isUri(c.globalStorageHome)&&M.URI.isUri(c.settingsResource)&&M.URI.isUri(c.keybindingsResource)&&M.URI.isUri(c.tasksResource)&&M.URI.isUri(c.snippetsHome)&&M.URI.isUri(c.extensionsResource))}e.$tl=(0,A.$ni)("IUserDataProfilesService");function s(l,c){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:c}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:c}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:c}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:c}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:c}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:c}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:c}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:c}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,c,h,g,D,w){return{id:l,name:c,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:w&&D?.useDefaultFlags?.globalState?w.globalStorageHome:(0,R.$1g)(h,"globalStorage"),settingsResource:w&&D?.useDefaultFlags?.settings?w.settingsResource:(0,R.$1g)(h,"settings.json"),keybindingsResource:w&&D?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,R.$1g)(h,"keybindings.json"),tasksResource:w&&D?.useDefaultFlags?.tasks?w.tasksResource:(0,R.$1g)(h,"tasks.json"),snippetsHome:w&&D?.useDefaultFlags?.snippets?w.snippetsHome:(0,R.$1g)(h,"snippets"),extensionsResource:w&&D?.useDefaultFlags?.extensions?w.extensionsResource:(0,R.$1g)(h,"extensions.json"),cacheHome:(0,R.$1g)(g,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let f=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,g,D){super(),this.t=c,this.u=h,this.w=g,this.y=D,this.f=!0,this.h=this.B(new O.$_d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$_d),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$_d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$_d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$1g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$1g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$1f)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,R.$Xg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const g=new S.$Bc,D=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[k,y]of Object.entries(w.workspaces)){const C=M.URI.parse(k),I=h.find(z=>z.id===y);I&&g.set(C,I)}if(w.emptyWindows)for(const[k,y]of Object.entries(w.emptyWindows)){const C=h.find(I=>I.id===y);C&&D.set(k,C)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:g,emptyWindows:D}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",g=new RegExp(`${(0,o.$5e)(h)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const y=g.exec(k.name),C=y?parseInt(y[1]):0;D=C>D?C:D}const w=`${h} ${D+1}`;return this.createProfile((0,u.$bj)((0,m.$Jg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,h,g){return this.createProfile((0,u.$bj)((0,m.$Jg)()).toString(16),c,h,g)}async createProfile(c,h,g,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,h,g);return D&&await this.setProfileForWorkspace(D,w),w}async F(c,h,g){if(!(0,n.$1f)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{if(this.profiles.find(C=>C.name===h||C.id===c))throw new Error(`Profile with ${h} name already exists`);const k=t(c,h,(0,R.$1g)(this.profilesHome,c),this.g,g,this.defaultProfile);await this.u.createFolder(k.location);const y=[];return this.j.fire({profile:k,join(C){y.push(C)}}),await a.Promises.settled(y),this.I([k],[],[]),k}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(D=>D.id===c.id);if(!g)throw new Error(`Profile '${c.name}' does not exist`);return g=t(g.id,h.name??g.name,g.location,this.g,{shortName:h.shortName??g.shortName,icon:h.icon===null?void 0:h.icon??g.icon,transient:h.transient??g.isTransient,useDefaultFlags:h.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const g=[];this.m.fire({profile:h,join(D){g.push(D)}});try{await Promise.allSettled(g)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,E.$$k)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(D=>D.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,g)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return M.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,$.$xi)(c)?c.uri:(0,$.$Ci)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,g){const D=[...this.profiles,...c],w=[];this.s.profiles=[];for(let k of D)k.isDefault||h.some(y=>k.id===y.id)||(k=g.find(y=>k.id===y.id)??k,k.isTransient?this.s.profiles.push(k):w.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,h,g)}J(c,h,g){this.h.fire({added:c,removed:h,updated:g,all:this.profiles})}L(c,h,g){g=h?.isTransient?!0:g,g||this.L(c,void 0,!0);const D=this.G(c),w=g?this.s:this.C;M.URI.isUri(D)?(w.workspaces.delete(D),h&&w.workspaces.set(D,h)):(w.emptyWindows.delete(D),h&&w.emptyWindows.set(D,h)),g||this.M()}M(){const c={};for(const[g,D]of this.C.workspaces.entries())c[g.toString()]=D.id;const h={};for(const[g,D]of this.C.emptyWindows.entries())h[g.toString()]=D.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},g=this.D();if(c.workspaces)for(const[w,k]of Object.entries(c.workspaces)){const y=M.URI.parse(k);h[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}const D={};if(c.emptyWindows)for(const[w,k]of Object.entries(c.emptyWindows)){const y=M.URI.parse(k);D[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$wl=f,e.$wl=f=Je([We(0,p.$ui),We(1,E.$Tk),We(2,v.$rl),We(3,P.$Tj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$xl=d}),define(ke[279],Ee([1,0,7,4,3,59,18,195,5,278]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Tp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Rp=e.$Qp=e.$Pp=void 0,e.$Sp=S,e.$Up=a,e.$Wp=o,e.$Pp="__$__isNewStorageMarker",e.$Qp="__$__targetStorageMarker",e.$Rp=(0,p.$ni)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function S(n){const i=n.get(e.$Qp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new O.$ce),this.c=this.B(new O.$ce),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$_d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$zh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return O.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$Dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Qp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,M.$0f)(r)){this.remove(i,s,f);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,f)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(i,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.P(r)?.set(e.$Qp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Qp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?S(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Pp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,E.$sl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||a(r)&&a(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[f,d]of i)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Tp=v;function a(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends v{constructor(){super(),this.U=this.B(new b.$Np(new b.$Op,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Np(new b.$Op,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Np(new b.$Op,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Vp=m;async function o(n,i,r,s,t,f){const d=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,c=new Map;n.forEach((C,I)=>{l.set(I,C),c.set(I,d(C))});const h=new Map,g=new Map;i.forEach((C,I)=>{h.set(I,C),g.set(I,d(C))});const D=new Map,w=new Map;r.forEach((C,I)=>{D.set(I,C),w.set(I,d(C))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const k=[];if(l.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(c),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((I,z)=>{C.push({key:z,value:I})}),console.table(C),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const y=[];D.forEach((C,I)=>{y.push({key:I,value:C})}),console.table(y),console.groupEnd(),console.log(w)}}),define(ke[111],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class u{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Wjc=u}),define(ke[60],Ee([1,0,15,23,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=void 0;class R{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new O.$Pg(b=>{const p=this.b.get(b.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(b,p){p===null?this.b.delete(b.scheme):this.b.set(b.scheme,p)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$2jc=R,e.$3jc=(0,L.$ni)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=void 0,e.$$O=(0,u.$ni)("IExtHostInitDataService")}),define(ke[280],Ee([1,0,223,12,260,28]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let M=class extends L.$gQ{constructor(p,E,A){const P=A.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",$=A.remote.isRemote?(0,u.localize)(0,null):p?(0,u.localize)(1,null):(0,u.localize)(2,null);super(E.createLogger(P,{name:$}))}};e.$0lc=M,e.$0lc=M=Je([We(1,O.$Uj),We(2,R.$$O)],M)}),define(ke[281],Ee([1,0,7]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;class O{constructor(M,b,p){this.h=new Map,this.a=M,this.b=b,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new u.$zh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of E.values())A.complete()}catch(A){for(const P of E.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let p=this.f[M];return typeof p>"u"&&(p=b),p}update(M,b){this.f[M]=b;const p=this.h.get(M);if(p!==void 0)return p.p;const E=new u.$Kh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Kkc=O;class L extends O{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Lkc=L}),define(ke[282],Ee([1,0,4,2]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class L{constructor(M){this.c=M,this.a=new u.$_d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$_d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,p,E){const P=this.c.getNotebookDocument(O.URI.revive(M)).acceptModelChanged(b.value,p,E);this.b.fire(P)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(O.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(O.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$xlc=L}),define(ke[20],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0,e.$UO=(0,u.$ni)("IExtHostRpcService");class O{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$VO=O}),define(ke[283],Ee([1,0,25,4]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class L{#e;constructor(M,b){this.b=new O.$_d,this.onDidChange=this.b.event,this.a=u.$Im.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$Skc=L}),define(ke[67],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0,e.$ikc=(0,u.$ni)("IURITransformerService");class O{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$jkc=O}),define(ke[284],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnb=L,e.$Mnb=M;class O{constructor(){this.buffers=[]}add(p){let E=this.buffers.indexOf(p);return E<0&&(E=this.buffers.length,this.buffers.push(p)),E}}function L(b,p){if(p.serializeBuffersForPostMessage){const E=new O,P=JSON.stringify(b,(S,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v)};if(ArrayBuffer.isView(v)){const a=R(v);if(a)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v.buffer),view:{type:a,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),$=E.buffers.map(S=>{const v=new Uint8Array(S);return u.$ze.wrap(v)});return{message:P,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,p){const E=p.map($=>{const S=new ArrayBuffer($.byteLength);return new Uint8Array(S).set($.buffer),S}),A=p.length?($,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const v=S,{index:a}=v,m=E[a];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return S}:void 0;return{message:JSON.parse(b,A),arrayBuffers:E}}}),define(ke[285],Ee([1,0,286,398,399,63,2,12,400]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=A;const E=!1;function A(i,r,s,t,f,d){const l=d.environment.useHostProxy,c=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>S(r),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return p.LogLevel.Trace;case b.LogLevel.Debug:return p.LogLevel.Debug;case b.LogLevel.Info:return p.LogLevel.Info;case b.LogLevel.Warning:return p.LogLevel.Warning;case b.LogLevel.Error:return p.LogLevel.Error;case b.LogLevel.Off:return p.LogLevel.Off;default:return k(w)}function k(y){return t.error("Unknown log level",y),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,p.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),w.push(k)}return(await Promise.all(w)).flat()},env:process.env},g=(0,p.createProxyResolver)(h),D=P(h,g);return a(s,D)}function P(i,r){return{http:Object.assign(u,(0,p.createHttpPatch)(i,u,r)),https:Object.assign(O,(0,p.createHttpPatch)(i,O,r)),net:Object.assign(R,(0,p.createNetPatch)(i,R)),tls:Object.assign(L,(0,p.createTlsPatch)(i,L))}}function $(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",E)&&!!r.get("systemCertificates")}function S(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",E)&&!!r.get("systemCertificates")}const v=new Map;function a(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,c,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const g=s.findSubstr(M.URI.file(c.filename));let D=v.get(g);if(D||v.set(g,D={}),!D[l]){const w=r[l];D[l]={...w}}return D[l]}})}async function m(i,r,s,t,f,d,l,c){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const g=l||h,D=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(r,D,f),D.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((z,j)=>{he(["kerberos"],z,j)}),k=new URL(d),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${y}`),"Negotiate "+await(await w.initializeClient(y)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[287],Ee([1,0,133]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=L;function O(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new u.$pn(O(R))}}),define(ke[142],Ee([1,0,233,18,2,3,5,37,32,15,47,187,39]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$yF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$pF=e.EditorInputCapabilities=e.$oF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0,e.$fF=a,e.$gF=m,e.$hF=o,e.$iF=n,e.$jF=i,e.$kF=r,e.$lF=s,e.$mF=t,e.$nF=f,e.$qF=D,e.$rF=k,e.$sF=y,e.$tF=C,e.$uF=I,e.$vF=z,e.$wF=j,e.$xF=Z,e.$zF=Y,e.$AF=te,e.$BF=pe,e.$CF=Ce,e.$aF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bF={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$cF="workbench.editor.sidebysideEditor",e.$dF="workbench.editors.textDiffEditor",e.$eF="workbench.editors.binaryResourceDiffEditor";var S;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var v;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function a(x){const U=x;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(x){const U=x;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(x,U,ne){for(const be of ne.visibleEditorPanes)if(be.group.id===U&&x.matches(be.input))return be.getViewState()}function n(x){if(D(x))return!1;const U=x;return L.URI.isUri(U?.resource)}function i(x){if(D(x))return!1;const U=x;return U?.original!==void 0&&U.modified!==void 0}function r(x){if(D(x))return!1;const U=x;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(x){if(D(x)||i(x))return!1;const U=x;return U?.primary!==void 0&&U.secondary!==void 0}function t(x){if(D(x))return!1;const U=x;return U?U.resource===void 0||U.resource.scheme===E.Schemas.untitled||U.forceUntitled===!0:!1}function f(x){if(D(x))return!1;const U=x;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var d;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class c{constructor(){this.a=new Map}registerSource(U,ne){let be=this.a.get(U);return be||(be={source:U,label:ne},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$oF=new c;var h;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors",x[x.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class g extends R.$Uc{}e.$pF=g;function D(x){return x instanceof g}function w(x){const U=x;return L.URI.isUri(U?.preferredResource)}function k(x){const U=x;return D(U?.primary)&&D(U?.secondary)}function y(x){const U=x;return D(U?.modified)&&D(U?.original)}function C(x,U,ne,be,De){return Ce(be,[(0,P.$0i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const ae={...ne,limits:{size:Number.MAX_VALUE}};x.openEditor(U,ae)}}),(0,P.$0i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>De.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function I(x){return D(x?.editor)}function z(x){const U=x;return I(x)&&U?.group!==void 0}function j(x){const U=x;return typeof U?.groupId=="number"&&D(U.editor)}var F;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var N;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LABEL=2]="GROUP_LABEL",x[x.GROUP_LOCKED=3]="GROUP_LOCKED",x[x.EDITOR_OPEN=4]="EDITOR_OPEN",x[x.EDITOR_CLOSE=5]="EDITOR_CLOSE",x[x.EDITOR_MOVE=6]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=8]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=10]="EDITOR_PIN",x[x.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",x[x.EDITOR_STICKY=12]="EDITOR_STICKY",x[x.EDITOR_DIRTY=13]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var T;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,ne){if(!U)return;if(f(U))return e.$yF.getOriginalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:De,secondary:ae}=this.a(U);if(De&&ae){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(De,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getOriginalUri(De,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?De:ae}}if(i(U)||r(U)||s(U)||f(U))return;const be=w(U)?U.preferredResource:U.resource;return!be||!ne||!ne.filterByScheme?be:this.b(be,ne.filterByScheme)}a(U){return k(U)||s(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ne){if(!U)return;if(f(U))return e.$yF.getCanonicalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:De,secondary:ae}=this.a(U);if(De&&ae){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(De,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getCanonicalUri(De,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?De:ae}}if(i(U)||r(U)||s(U)||f(U))return;const be=U.resource;return!be||!ne||!ne.filterByScheme?be:this.b(be,ne.filterByScheme)}b(U,ne){if(Array.isArray(ne)){if(ne.some(be=>U.scheme===be))return U}else if(ne===U.scheme)return U}}var H;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.KEYBOARD=1]="KEYBOARD",x[x.MOUSE=2]="MOUSE"})(H||(e.EditorCloseMethod=H={}));function Z(x,U,ne,be){if(!x.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ne===H.MOUSE||ne===H.KEYBOARD;case"mouse":return ne===H.MOUSE;case"keyboard":return ne===H.KEYBOARD}return!1}e.$yF=new B;var ee;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class J{constructor(){this.c=new Map,this.d=new Map}start(U){const ne=this.a=U.get(M.$mi);for(const[be,De]of this.c)this.e(be,De,ne);this.c.clear()}e(U,ne,be){const De=be.createInstance(ne);this.d.set(U,De)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,O.$_f)(this.b)}registerEditorSerializer(U,ne){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ne,this.a):this.c.set(U,ne),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$6n.add(e.$aF.EditorFactory,new J);async function Y(x,U,ne){return!x||!x.length?[]:await Promise.all(x.map(async be=>{const De=L.URI.revive(be.fileUri);if(!De){ne.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(De)){ne.info("Cannot resolve the path because it cannot be handled",be);return}let ce=be.exists,se=be.type;if(typeof ce!="boolean"||typeof se!="number")try{se=(await U.stat(De)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ce=!0}catch(ie){ne.error(ie),ce=!1}if(!ce&&be.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",be);return}if(se===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",be);return}const K={...be.options,pinned:!0};return ce?{resource:De,options:K}:{resource:De,options:K,forceUntitled:!0}}))}var re;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(re||(e.EditorsOrder=re={}));function te(x){const U=x;if(!U)return!1;const ne=U;if(ne.modified)return te(ne.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function pe(x){return(0,A.$_i)(x)}function Ce(x,U,ne){const be=(0,A.$aj)(x,U);return be.forceMessage=ne?.forceMessage,be.forceSeverity=ne?.forceSeverity,be.allowDialog=ne?.allowDialog,be}}),define(ke[288],Ee([1,0,4,234,5,3,27,37,19,24,78,274]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IF=e.ViewContentGroups=e.$GF=e.ViewContainerLocation=e.Extensions=e.$FF=e.$EF=e.$DF=void 0,e.$HF=v,e.$DF="views",e.$EF=(0,O.localize)(0,null),e.$FF=(0,P.$Zw)("default-view-icon",A.$Mj.window,(0,O.localize)(1,null));var $;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var S;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$GF=[0,1,2];function v(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$_d),this.onDidRegister=this.c.event,this.f=this.B(new u.$_d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(d,l,c){const h=this.get(d.id);if(h)return h;const g=d;return g.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,M.$yc)(this.g,l,[]).push(g),c?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:l}),g}deregisterViewContainer(d){for(const l of this.g.keys()){const c=this.g.get(l),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$6n.add($.ViewContainersRegistry,new a);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,d){const l=f.group??m.More,c=d.group??m.More;return l!==c?l.localeCompare(c):(f.order??5)-(d.order??5)}class n extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$_d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$_d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$_d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$_d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:c})=>this.r(l,c)),this.c.fire(d)}deregisterViews(d,l){const c=this.s(d,l);c.length&&this.f.fire({views:c,viewContainer:l})}moveViews(d,l){for(const c of this.m.keys())if(c!==l){const h=this.s(d,c);h.length&&(this.r(h,l),this.g.fire({views:h,from:c,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const c=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,R.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const c=new Map;for(const[h,g]of l)this.n.add(d,g),c.set(h,(0,R.$Sc)(()=>{this.n.delete(d,g),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,c=>l.push(c)),l.sort(o)}r(d,l){let c=this.m.get(l);c||(c=[],this.m.set(l,c),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,O.localize)(2,null,h.id));c.push(h)}}s(d,l){const c=this.m.get(l);if(!c)return[];const h=[],g=[];for(const D of c)d.includes(D)?h.push(D):g.push(D);return h.length&&(g.length?this.m.set(l,g):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}b.$6n.add($.ViewsRegistry,new n),e.$IF=(0,L.$ni)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,E.$Wn)(this,d),this.d=!!l,this.resolve=async c=>{if(l&&!this.c){const h=await l(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JF=s;class t extends Error{constructor(d){super((0,O.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$KF=t}),define(ke[289],Ee([1,0,4,45,3,40,5]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=e.$KG=e.ChatAgentLocation=void 0;var b;(function(A){A.Panel="panel",A.Terminal="terminal",A.Notebook="notebook",A.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(A){function P($){switch($){case"panel":return A.Panel;case"terminal":return A.Terminal;case"notebook":return A.Notebook}return A.Panel}A.fromRaw=P}(b||(e.ChatAgentLocation=b={})),e.$KG=(0,M.$ni)("chatAgentService");let p=class{static{this.AGENT_LEADER="@"}constructor(P){this.e=P,this.b=[],this.d=new u.$_d,this.onDidChangeAgents=this.d.event}registerAgent(P,$){if(this.getAgent(P))throw new Error(`Agent already registered: ${JSON.stringify(P)}`);const v=this,a=$.slashCommands;$={...$,get slashCommands(){return a.filter(o=>!o.when||v.e.contextMatchesRules(R.$lj.deserialize(o.when)))}};const m={data:$};return this.b.push(m),(0,L.$Sc)(()=>{this.b=this.b.filter(o=>o!==m),this.d.fire(void 0)})}registerAgentImplementation(P,$){const S=this.f(P);if(!S)throw new Error(`Unknown agent: ${JSON.stringify(P)}`);if(S.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(P)}`);return S.impl=$,this.d.fire(new E(S.data,$)),(0,L.$Sc)(()=>{S.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(P,$){const S={data:P,impl:$};return this.b.push(S),this.d.fire(new E(P,$)),(0,L.$Sc)(()=>{this.b=this.b.filter(v=>v!==S),this.d.fire(void 0)})}updateAgent(P,$){const S=this.f(P);if(!S?.impl)throw new Error(`No activated agent with id ${JSON.stringify(P)} registered`);S.data.metadata={...S.data.metadata,...$},this.d.fire(new E(S.data,S.impl))}getDefaultAgent(P){return this.getActivatedAgents().find($=>!!$.isDefault&&$.locations.includes(P))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),P=>!!P.data.metadata.isSecondary)?.data}f(P){return this.b.find($=>$.data.id===P)}getAgent(P){return this.f(P)?.data}getAgents(){return this.b.map(P=>P.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(P=>!!P.impl).map(P=>new E(P.data,P.impl))}getAgentsByName(P){return this.getAgents().filter($=>$.name===P)}async invokeAgent(P,$,S,v,a){const m=this.f(P);if(!m?.impl)throw new Error(`No activated agent with id ${P}`);return await m.impl.invoke($,S,v,a)}async getFollowups(P,$,S,v,a){const m=this.f(P);if(!m?.impl)throw new Error(`No activated agent with id ${P}`);return m.impl?.provideFollowups?m.impl.provideFollowups($,S,v,a):[]}};e.$LG=p,e.$LG=p=Je([We(0,R.$Fj)],p);class E{constructor(P,$){this.b=P,this.d=$}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(P,$,S,v){return this.d.invoke(P,$,S,v)}async provideFollowups(P,$,S,v){return this.d.provideFollowups?this.d.provideFollowups(P,$,S,v):[]}provideWelcomeMessage(P){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(P)}provideSampleQuestions(P){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(P)}}e.$MG=E}),define(ke[290],Ee([1,0,2,29,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$TF=R,e.$UF=M;function R(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof u.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$ht.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(R)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var p;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$VF=(0,L.$ni)("IChatService"),e.$WF="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,7,235]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gob=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new u.$_d,this.o=new u.$_d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,p,E,A){const P={command:b};if(p&&Object.keys(p).length>0&&(P.arguments=p),this.u("request",P),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const S=this.f.get(P.seq);if(S){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:b,message:(0,L.localize)(0,null,A,b)};S(v)}},A)}return E&&this.f.set(P.seq,E),P.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,p){return b.type!=="event"||p.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,O.$oh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const p=b,E=this.f.get(p.request_seq);E&&(this.f.delete(p.request_seq),E(p));break}}}}u(b,p){p.type=b,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((p,E)=>b.set(E,p)),await(0,O.$oh)(500),b.forEach((p,E)=>{p({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$gob=R}),define(ke[291],Ee([1,0,2,236,40,5]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$3I=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$1I=e.MemoryRangeType=e.State=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=void 0,e.$ZI=p,e.$2I=A,e.$NH="workbench.view.debug",e.$OH="workbench.debug.variablesView",e.$PH="workbench.debug.watchExpressionsView",e.$QH="workbench.debug.callStackView",e.$RH="workbench.debug.loadedScriptsView",e.$SH="workbench.debug.breakPointsView",e.$TH="workbench.debug.disassemblyView",e.$UH="workbench.panel.repl",e.$VH="workbench.panel.repl.view",e.$WH=new L.$Ej("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$XH=new L.$Ej("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$YH=new L.$Ej("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$ZH="debugUx",e.$1H=new L.$Ej(e.$ZH,"default",{type:"string",description:O.localize(3,null)}),e.$2H=new L.$Ej("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$3H=new L.$Ej("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$4H=new L.$Ej("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$5H=new L.$Ej("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$6H=new L.$Ej("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$7H=new L.$Ej("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$8H=new L.$Ej("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$9H=new L.$Ej("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$0H=new L.$Ej("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$$H=new L.$Ej("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$_H=new L.$Ej("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$aI=new L.$Ej("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$bI=new L.$Ej("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$cI=new L.$Ej("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$dI=new L.$Ej("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$eI=new L.$Ej("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$fI=new L.$Ej("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$gI=new L.$Ej("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$hI=new L.$Ej("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$iI=new L.$Ej("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$jI=new L.$Ej("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$kI=new L.$Ej("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$lI=new L.$Ej("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$mI=new L.$Ej("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$nI=new L.$Ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$oI=new L.$Ej("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$pI=new L.$Ej("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$qI=new L.$Ej("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$rI=new L.$Ej("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$sI=new L.$Ej("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$tI=new L.$Ej("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$uI=new L.$Ej("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$vI=new L.$Ej("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$wI=new L.$Ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$xI=new L.$Ej("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$yI=new L.$Ej("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$zI=new L.$Ej("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$AI=new L.$Ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$BI=new L.$Ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$CI=new L.$Ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$DI=new L.$Ej("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$EI=new L.$Ej("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$FI=new L.$Ej("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$GI=new L.$Ej("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$HI=new L.$Ej("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$II=new L.$Ej("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$JI=new L.$Ej("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$KI=new L.$Ej("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$LI=new L.$Ej("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$MI=new L.$Ej("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$NI=new L.$Ej("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$OI=new L.$Ej("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$PI=new L.$Ej("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$QI=new L.$Ej("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$RI=new L.$Ej("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$SI=new L.$Ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$TI=new L.$Ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const M=i=>O.localize(61,null,i);e.$UI=M,e.$VI="editor.contrib.debug",e.$WI="editor.contrib.breakpoint",e.$XI="debug",e.$YI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function p(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$1I="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var P;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var $;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$3I=(0,R.$ni)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:u.URI.revive(r.iconPath.light),dark:u.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(n||(e.IDebugVisualization=n={}))}),define(ke[292],Ee([1,0,14,2,17,24,15,29,22,19]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=void 0,e.$PG=P,e.$QG=$,e.$RG=S,e.$SG=v,e.$TG=a,e.$UG=m,e.$VG=o,e.$WG=i,e.$XG=t,e.$YG=f,e.$ZG=l,e.$1G=h;const A=/{([^}]+)}/g;function P(D,w,k){return D.replace(A,function(y,C){return w&&C.length>0&&C[0]!=="_"?y:k&&k.hasOwnProperty(C)?k[C]:y})}function $(D){const w={};for(const k of Object.keys(D))k.startsWith("!")||(w[k]=D[k]);return w}function S(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||S(D.parentSession))}function v(D){let w=D.configuration.type;if(w)return w==="vslsShare"&&(w=D.configuration.adapterProxy.configuration.type),(0,u.$qf)(w,"extensionhost")||(0,u.$qf)(w,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,w,k){let y,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=I.exec(D);){const j=z.index+1,F=j+z[0].length;if(j<=w&&F>=k){y=z[0],C=j;break}}if(y){const j=/\w+/g;let F=null;for(;(F=j.exec(y))&&!(F.index+1+C+F[0].length>=k););F&&(y=y.substring(0,j.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function o(D,w,k,y){if(D.evaluatableExpressionProvider.has(w)){const C=D.evaluatableExpressionProvider.ordered(w),I=(0,E.$Hb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression(w,k,y??p.CancellationToken.None)}catch{return}})));if(I.length>0){let z=I[0].expression;const j=I[0].range;return z||(z=w.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:z}}}else{const C=w.getLineContent(k.lineNumber),{start:I,end:z}=m(C,k.column,k.column),j=C.substring(I-1,z);return{matchingExpression:j,range:new b.$ht(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return O.URI.parse(D.path);if((0,L.$jc)(D.path))return O.URI.file(D.path)}return D.path}function s(D){if(typeof D.path=="object"){const w=O.URI.revive(D.path);if(w)return w.scheme===M.Schemas.file?w.fsPath:w.toString()}return D.path}function t(D,w){const k=w?r:s,y=(0,R.$Tn)(D);return d(y,(C,I)=>{C&&I&&(I.path=k(I))}),y}function f(D,w){const k=w?r:s,y=(0,R.$Tn)(D);return d(y,(C,I)=>{!C&&I&&(I.path=k(I))}),y}function d(D,w){switch(D.type){case"event":{const k=D;switch(k.event){case"output":w(!1,k.body.source);break;case"loadedSource":w(!1,k.body.source);break;case"breakpoint":w(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":w(!0,k.arguments.source);break;case"breakpointLocations":w(!0,k.arguments.source);break;case"source":w(!0,k.arguments.source);break;case"gotoTargets":w(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(y=>w(!1,y));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(y=>w(!1,y.source));break;case"loadedSources":k.body.sources.forEach(y=>w(!1,y));break;case"scopes":k.body.scopes.forEach(y=>w(!1,y.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(y=>w(!1,y.source));break;case"setBreakpoints":k.body.breakpoints.forEach(y=>w(!1,y.source));break;case"disassemble":k.body?.instructions.forEach(C=>w(!1,C.location));break;default:break}break}}}function l(D){return D.filter(w=>!w.presentation?.hidden).sort((w,k)=>w.presentation?k.presentation?w.presentation.group?k.presentation.group?w.presentation.group!==k.presentation.group?w.presentation.group.localeCompare(k.presentation.group):c(w.presentation.order,k.presentation.order):-1:k.presentation.group?1:c(w.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function c(D,w){return typeof D!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:D-w}async function h(D,w){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(k!=="none"&&(await w.saveAll(),k==="allEditorsInActiveGroup")){const y=w.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await w.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const g=(D,w)=>!D||!w?D===w:D.name===w.name&&D.path===w.path&&D.sourceReference===w.sourceReference;e.$2G=g}),define(ke[293],Ee([1,0,53,63,24,17,11,14,31,237,143]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=e.$fmc=e.$emc=e.$dmc=void 0;class P extends A.$gob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${P.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(P.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(P.b);for(const s of r){const t=s.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+P.a.length);continue}}break}}}e.$dmc=P;class $ extends P{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$emc=$;class S extends ${constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$fmc=S;class v extends ${constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$gmc=v;class a extends P{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(R.$jc(o)){if(!await p.Promises.exists(o))throw new Error(E.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=L.$Wn(L.$Tn(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(E.localize(2,null,n[0]));this.x=f}else throw new Error(E.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((o,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=R.$kc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(R.$jc(o.program)?i.program=o.program:i.program=R.$kc(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=a.A(r.win,n)),r.winx86&&(i.winx86=a.A(r.winx86,n)),r.windows&&(i.windows=a.A(r.windows,n)),r.osx&&(i.osx=a.A(r.osx,n)),r.linux&&(i.linux=a.A(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&b.$qf(h.type,n)).forEach(h=>{const g=a.A(h,l.extensionLocation.fsPath);i=L.$Wn(i,g,l.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:M.$i?r=i.win||i.windows:M.$j?r=i.osx:M.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$hmc=a}),define(ke[294],Ee([1,0,53,34,11]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=M,e.$jmc=p;function R(E,A){return new Promise((P,$)=>{let S="";const v=u.spawn(E,A);v.pid&&v.stdout.on("data",a=>{S+=a.toString()}),v.on("error",a=>{$(a)}),v.on("close",a=>{P(S)})})}async function M(E){if(E)if(L.$i){const A=await new Promise((P,$)=>{he(["@vscode/windows-process-tree"],P,$)});return new Promise(P=>{A.getProcessTree(E,$=>{P(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(E)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function p(E,A,P,$){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:L.$i?S=0:S=2;let v,a=" ";switch(S){case 1:if(v=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),$){const m=(0,O.$sg)($);m&&(a+=`${m}:; `),a+=`cd ${v($)}; `}if(A.length>0){const m=A.shift(),o=P?m:v(m);a+=o[0]==="'"?`& ${o} `:`${o} `;for(const n of A)a+=n==="<"||n===">"||P?n:v(n),a+=" "}break;case 0:if(v=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),$){const m=(0,O.$sg)($);m&&(a+=`${m}: && `),a+=`cd ${v($)} && `}for(const m of A)a+=m==="<"||m===">"||P?m:v(m),a+=" ";break;case 2:{v=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),$&&(a+=`cd ${v($)} ; `);for(const m of A)a+=m==="<"||m===">"||P?m:v(m),a+=" ";break}}return a}}),define(ke[295],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.CellExecutionUpdateType=void 0;var O;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$dK=(0,u.$ni)("INotebookExecutionService")}),define(ke[296],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhb=e.$Whb=e.ProxyKernelState=e.$Vhb=void 0,e.$Vhb=100;var O;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Whb=(0,u.$ni)("INotebookKernelService"),e.$Xhb=(0,u.$ni)("INotebookKernelHistoryService")}),define(ke[297],Ee([1,0,3,29,200,100]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Vb=void 0;class M extends u.$Uc{constructor(p,E,A){super(),this._source=p,this.b=E,this.c=A,this.a=void 0}f(p){const E=p.getLineCount();return new O.$ht(1,1,E,this.g(p,E))}g(p,E){if(E<1||E>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const p=new L.$JC;p.acceptChunk(this._source);const E=p.finish(!0),{textBuffer:A,disposable:P}=E.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const E=new L.$JC;E.acceptChunk(p);const A=E.finish(!0),{textBuffer:P,disposable:$}=A.create(1);return this.B($),P})),this.a}findInInputs(p){const A=new R.$xC(p,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(p){const A=new R.$xC(p,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const $=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if($.length!==0)return{textBuffer:P,matches:$}}).filter(P=>!!P):[]}}e.$0Vb=M}),define(ke[68],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(R){R.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var O;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class L{static fromExtHostTestItem(M,b,p=M.parent){if(M._isRoot)return new L([b]);const E=[M.id];for(let A=p;A&&A.id!==b;A=A.parent)E.push(A.id);return E.push(b),new L(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new L(M.split("\0"))}static join(M,b){return new L([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:L.isChild(M,b)?2:L.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$jL=L}),define(ke[89],Ee([1,0,2,50,29,68]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$rL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$qL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$pL=e.$oL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$nL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$mL=e.$lL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$kL=e.TestResultState=void 0;var M;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$kL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var p;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$lL=[2,4,8,16,32,64];const E=N=>"runId"in N;e.$mL=E;var A;(function(N){N.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),N.deserialize=(T,B)=>({range:L.$ht.lift(B.range),uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var P;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(P||(e.TestMessageType=P={}));var $;(function(N){N.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),N.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(T,B.location)})})($||(e.ITestErrorMessage=$={}));const S=(N,T)=>`${T?"s":"e"}${N}`;e.$nL=S;var v;(function(N){N.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),N.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var a;(function(N){N.serialize=T=>T.type===0?$.serialize(T):v.serialize(T),N.deserialize=(T,B)=>B.type===0?$.deserialize(T,B):v.deserialize(T,B)})(a||(e.ITestMessage=a={}));var m;(function(N){N.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),N.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(a.serialize)}),N.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(H=>a.deserialize(T,H))})})(m||(e.ITestTaskState=m={}));const o="\0",n=(N,T)=>N+o+T;e.$oL=n;const i=N=>{const T=N.indexOf(o);return{ctrlId:N.slice(0,T),tagId:N.slice(T+1)}};e.$pL=i;var r;(function(N){N.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),N.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?L.$ht.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(N){N.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),N.deserialize=(T,B)=>({controllerId:R.$jL.root(B.item.extId),expand:B.expand,item:r.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(N){N.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},N.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?L.$ht.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const d=(N,T)=>{T.expand!==void 0&&(N.expand=T.expand),T.item!==void 0&&(N.item=N.item?Object.assign(N.item,T.item):T.item)};e.$qL=d;var l;(function(N){N.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),N.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),N.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(H=>m.deserialize(T,H)),retired:!0})})(l||(e.TestResultItem=l={}));var c;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(c||(e.ICoverageCount=c={}));var h;(function(N){N.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),N.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function g(N){return{...N,location:N.location?.toJSON()}}function D(N){return N.location=N.location?O.$gt.isIPosition(N.location)?O.$gt.lift(N.location):L.$ht.lift(N.location):void 0,N}e.$rL=3;var w;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(w||(e.DetailType=w={}));var k;(function(N){N.serialize=T=>T.type===0?C.serialize(T):I.serialize(T),N.deserialize=T=>T.type===0?C.deserialize(T):I.deserialize(T)})(k||(e.CoverageDetails=k={}));var y;(function(N){N.serialize=g,N.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(N){N.serialize=g,N.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var I;(function(N){N.serialize=T=>({...g(T),branches:T.branches?.map(y.serialize)}),N.deserialize=T=>({...D(T),branches:T.branches?.map(y.deserialize)})})(I||(e.IStatementCoverage=I={}));var z;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var j;(function(N){N.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,N.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:f.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class F{constructor(T){this.l=T,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(T){const B=this.w();for(const H of T)switch(H.op){case 0:this.o(t.deserialize(this.l,H.item),B);break;case 1:this.p(f.deserialize(H.item),B);break;case 3:this.q(H.itemId,B);break;case 5:this.v(H.itemId);break;case 4:this.updatePendingRoots(H.amount);break;case 6:this.f.set(H.tag.id,H.tag);break;case 7:this.f.delete(H.id);break}B.complete?.()}o(T,B){const H=R.$jL.parentId(T.item.extId)?.toString();let Z;if(!H)Z=this.x(T),this.h.add(Z),this.g.set(T.item.extId,Z);else if(this.g.has(H)){const ee=this.g.get(H);ee.children.add(T.item.extId),Z=this.x(T,ee),this.g.set(T.item.extId,Z)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(Z),T.expand===2&&this.j++,Z}p(T,B){const H=this.g.get(T.extId);if(H)return T.expand!==void 0&&(H.expand===2&&this.j--,T.expand===2&&this.j++),(0,e.$qL)(H,T),B.update?.(H),H}q(T,B){const H=this.g.get(T);if(!H)return;const Z=R.$jL.parentId(H.item.extId)?.toString();Z?this.g.get(Z).children.delete(H.item.extId):this.h.delete(H);const ee=[[T]];for(;ee.length;)for(const J of ee.pop()){const Y=this.g.get(J);Y&&(ee.push(Y.children),this.g.delete(J),B.remove?.(Y,Y!==H),Y.expand===2&&this.j--)}}v(T){}updatePendingRoots(T){this.k+=T}w(){return{}}}e.$sL=F}),define(ke[112],Ee([1,0,7,4,3,62,89,68]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.TestItemEventOp=void 0;var p;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const E=(n,i)=>n===i,P=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),$=(n,i)=>{let r;for(const[s,t]of P)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class S extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$zh(()=>this.flushDiff(),200)),this.g=this.B(new O.$_d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,M.$qL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,M.$qL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(b.$jL.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$cd)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=b.$jL.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(f.actual),l=f.actual,c=$(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,f.actual=i,f.resolveBarrier=void 0,f.expand=0,c&&(c.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete c.tags),this.w(f,{op:4,update:c})),this.I(i,f,r);for(const[g,D]of d)this.s.getChildren(i).get(D.id)||this.O(b.$jL.joinToString(s,D.id));const h=f.expandLevels;h!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(s.toString(),h))}),this.y(f.actual.uri)}C(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,M.$oL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$oL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$oL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(i.actual)){const d=this.expand(b.$jL.joinToString(i.fullId,f.id),r);(0,u.$_g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$mh;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$mh,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,u.$_g)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$jL.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$KO=S;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$LO=v;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$MO=a;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$NO=m;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new a(c.id);const h=i(c).controllerId;if(h!==n.controllerId)throw new m(c.id,h,n.controllerId);if(f.has(c.id))throw new v(c.id);f.set(c.id,c),d.delete(c.id),l.ops.push({op:0,item:c})}for(const c of d.keys())l.ops.push({op:3,id:c});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$OO=o}),define(ke[144],Ee([1,0,112]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0;const O=new WeakMap,L=(M,b)=>{const p={controllerId:b};return O.set(M,p),p};e.$PO=L;const R=M=>{const b=O.get(M);if(!b)throw new u.$MO(M?.id||"<unknown>");return b};e.$QO=R}),define(ke[113],Ee([1,0,15,2]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uxb=e.$txb=e.$sxb=void 0,e.$vxb=L,e.$wxb=M,e.$sxb="vscode-cdn.net",e.$txb=`vscode-resource.${e.$sxb}`,e.$uxb=`'self' https://*.${e.$sxb}`;function L(b,p){return b.scheme===u.Schemas.http||b.scheme===u.Schemas.https?b:(p&&p.authority&&p.isRemote&&b.scheme===u.Schemas.file&&(b=O.URI.from({scheme:u.Schemas.vscodeRemote,authority:p.authority,path:b.path})),O.URI.from({scheme:u.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$txb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,p=>{const E=p.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?p:"-"+E.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,(p,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[298],Ee([1,0,4,3,113]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class R{constructor(b,p,E){this.d=b,this.e=p,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const A=p.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,p,E,A,P){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){$=i;break}if(!$)throw new Error("not a visible editor");const S=this,v=this.a++,a=new u.$_d,m=new u.$_d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$vxb)(i,S.f)}get cspSource(){return L.$uxb}set options(i){this.b=i,S.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return S.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=p,this.height=E,this.webview=o,this.onDidDispose=m.event}dispose(){S.c.has(v)&&(S.c.delete(v),S.d.$disposeEditorInset(v),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(v,$.id,$.value.document.uri,p+1,E,A||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(b){const p=this.c.get(b);p&&p.inset.dispose()}$onDidReceiveMessage(b,p){this.c.get(b)?.onDidReceiveMessage.fire(p)}}e.$gkc=R}),define(ke[145],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=void 0,e.$zL="__",e.$AL=(0,u.$ni)("IAuthenticationService"),e.$BL=(0,u.$ni)("IAuthenticationExtensionsService")}),define(ke[299],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.VariableKind=e.$GP=void 0,e.$GP=(0,u.$ni)("configurationResolverService");var O;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class L extends Error{constructor(M,b){super(b),this.variable=M}}e.$HP=L}),define(ke[300],Ee([1,0,17,51,18,24,11,103,240,299,14]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,v,a,m){this.h=new Map,this.a=S,this.b=v,this.g=a,m&&(this.c=m.then(o=>this.i(o)))}i(S){if(M.$i){const v=Object.create(null);return Object.keys(S).forEach(a=>{v[a.toLowerCase()]=S[a]}),v}return S}resolveWithEnvironment(S,v,a){return this.l({env:this.i(S),userHome:void 0},v?v.uri:void 0,a)}async resolveAsync(S,v){const a={env:await this.c,userHome:await this.g};return this.l(a,S?S.uri:void 0,v)}async j(S,v,a,m){const o=R.$Tn(v);M.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,o,a,m)}async resolveAnyAsync(S,v,a){return this.j(S,v,a)}async resolveAnyMap(S,v,a){const m=new Map;return{newConfig:await this.j(S,v,a,m),resolvedVariables:m}}resolveWithInteractionReplace(S,v,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,v,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,v){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,v)}async l(S,v,a,m,o){if(L.$1f(a))return this.m(S,v,a,m,o);if(Array.isArray(a))return Promise.all(a.map(n=>this.l(S,v,n,m,o)));if(L.$3f(a)){const n=Object.create(null),i=await Promise.all(Object.keys(a).map(async r=>[await this.m(S,v,r,m,o),await this.l(S,v,a[r],m,o)]));for(const[r,s]of i)n[r]=s;return n}return a}m(S,v,a,m,o){return(0,A.$if)(a,P.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(P.VARIABLE_LHS))return n;let r=await this.o(S,n,i,v,m);return o?.set(i,r),r!==n&&L.$1f(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(S,v,r,m,o)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,v,a,m,o){let n;const i=a.split(":");i.length>1&&(a=i[0],n=i[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,b.$mw)(d);throw new E.$HP(f,(0,p.localize)(0,null,v))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$mw)(l)}throw new E.$HP(f,(0,p.localize)(1,null,v,u.$oc(d)))},t=f=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new E.$HP(f,(0,p.localize)(2,null,v,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new E.$HP(f,(0,p.localize)(3,null,v)):new E.$HP(f,(0,p.localize)(4,null,v))};switch(a){case"env":if(n){if(S.env){const f=S.env[M.$i?n.toLowerCase():n];if(L.$1f(f))return f}return""}throw new E.$HP(E.VariableKind.Env,(0,p.localize)(5,null,v));case"config":if(n){const f=this.a.getConfigurationValue(m,n);if(L.$0f(f))throw new E.$HP(E.VariableKind.Config,(0,p.localize)(6,null,v,n));if(L.$3f(f))throw new E.$HP(E.VariableKind.Config,(0,p.localize)(7,null,v,n));return f}throw new E.$HP(E.VariableKind.Config,(0,p.localize)(8,null,v));case"command":return this.p(E.VariableKind.Command,v,n,o,"command");case"input":return this.p(E.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new E.$HP(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,v,n));return this.n(f.extensionLocation)}throw new E.$HP(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,v));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,b.$mw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,b.$mw)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$mw)(u.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$HP(E.VariableKind.UserHome,(0,p.localize)(11,null,v))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$HP(E.VariableKind.LineNumber,(0,p.localize)(12,null,v))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$HP(E.VariableKind.SelectedText,(0,p.localize)(13,null,v))}case"file":return r(E.VariableKind.File);case"fileWorkspaceFolder":return s(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(E.VariableKind.RelativeFile)),r(E.VariableKind.RelativeFile)):r(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$nc(r(E.VariableKind.RelativeFileDirname));if(m||n){const d=u.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return u.$nc(r(E.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(E.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$oc(r(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$pc(f).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||v}case"execInstallFolder":{const f=this.a.getAppRoot();return f||v}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${a}:${n}`:a;return this.p(E.VariableKind.Unknown,v,f,o,void 0)}catch{return v}}}}p(S,v,a,m,o){if(a&&m){const n=o===void 0?m[a]:m[o+":"+a];if(typeof n=="string")return n;throw new E.$HP(S,(0,p.localize)(14,null,v))}return v}}e.$WP=P}),define(ke[146],Ee([1,0,5,142]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FD=void 0,e.$GD=E,e.$HD=$,e.$ID=S,e.$FD=(0,u.$ni)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var p;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function E(v){const a=v;return(0,O.$qF)(a?.editor)&&(0,O.$qF)(a?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function $(v){const a=v;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function S(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[301],Ee([1,0,5,146]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$ND=L,e.$JD=(0,u.$ni)("editorService"),e.$KD=-1,e.$LD=-2,e.$MD=-3;function L(R){const M=R;return typeof R=="number"||(0,O.$HD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=void 0,e.$UL=(0,u.$oi)(O.$ui)}),define(ke[148],Ee([1,0,25,4,17,3,7]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=e.$B$b=e.$A$b=e.$z$b=e.$y$b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$y$b=b;class p{static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$_d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new u.$Km,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const r=p.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const c=i.getArcs(d);for(let h=0;h<c.length;h++)if(!l.has(c[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Km;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Im.toKey(d.identifier),u.$Im.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$z$b=p;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$A$b=E;class A{constructor(n){this.d=new S,this.c=new p(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new P(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$B$b=A;class P extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$C$b=P;class ${constructor(n){this.name=n;const i=(0,M.$gh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class S{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new $(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function a(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=L.$hc.basename(o.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(o,n){const i=new u.$Jm(n);return o.filter(r=>!i.has(r.identifier))}}),define(ke[302],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.ExtHostConnectionType=void 0,e.$en=b,e.$fn=p;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[O.ENV_KEY]=this.pipeName}}e.$bn=O;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[L.ENV_KEY]="1"}}e.$cn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$dn=R;function M(A){delete A[O.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function b(A,P){M(P),A.serialize(P)}function p(A){if(A[O.ENV_KEY])return E(A,new O(A[O.ENV_KEY]));if(A[L.ENV_KEY])return E(A,new L);if(A[R.ENV_KEY])return E(A,new R);throw new Error("No connection information defined in environment!")}function E(A,P){return M(A),P}}),define(ke[114],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Qm=M,e.$Rm=b;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(E){const A=u.$ze.alloc(1);switch(E){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(E,A){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var p;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,226]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$aP=e.$_O=void 0,e.$bP=a;let S=class extends P.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new O.$_d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$_d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:p.$bp,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$Vj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$zm)((0,p.$hp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$_O=S,e.$_O=S=Je([We(0,R.$$O),We(1,L.$Uj)],S);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new O.$_d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,p.$kp)(n,[]),this.c&&(n=(0,E.$Wn)(n,this.c)),this.b||(n=(0,E.$Wn)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,p.$kp)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$aP=v;function a(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$cP=(0,u.$ni)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,271,140,25,5]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mG=e.ActivationKind=e.$jG=e.$iG=e.$fG=e.ExtensionHostStartup=e.$eG=e.$dG=e.$cG=e.$bG=void 0,e.$gG=$,e.$hG=S,e.$kG=o,e.$lG=n,e.$bG=Object.freeze({identifier:new M.$Im("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$cG="extensions.webWorker",e.$dG=(0,b.$ni)("extensionService");class p{constructor(s){this.dependency=s}}e.$eG=p;var E;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$YF.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],c=[],h=[],g=P(this.d),D=P(t),w=(z,j)=>z.extensionLocation.toString()===j.extensionLocation.toString()||z.isBuiltin===j.isBuiltin||z.isUserBuiltin===j.isUserBuiltin||z.isUnderDevelopment===j.isUnderDevelopment;for(const z of this.d){const j=D.get(z.identifier);if(!j){d.push(z.identifier),g.delete(z.identifier);continue}if(!w(z,j)){d.push(z.identifier),g.delete(z.identifier);continue}}for(const z of t){const j=g.get(z.identifier);if(!j){l.push(z);continue}if(!w(j,z)){d.push(j.identifier),g.delete(j.identifier);continue}}const k=new M.$Jm(this.e),y=new M.$Jm(f);for(const z of this.e)y.has(z)||c.push(z);for(const z of f)k.has(z)||h.push(z);const C=R.$YF.createActivationEventsMap(l),I={versionId:s,toRemove:d,toAdd:l,addActivationEvents:C,myToRemove:c,myToAdd:h};return this.delta(I),I}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:l}=s,c=new M.$Jm(t),h=new M.$Jm(d);for(let g=0;g<this.d.length;g++)c.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)h.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of f)this.d.push(g);for(const g of l)this.e.push(g);return this.f=null,s}containsExtension(s){for(const t of this.e)if(M.$Im.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=R.$YF.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$fG=A;function P(r){const s=new M.$Km;for(const t of r)s.set(t.identifier,t);return s}function $(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function S(r,s){if(!$(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$iG=v;class a{constructor(s,t){this.description=s,this.value=t}}e.$jG=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.$qp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new M.$Im((0,L.$op)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$mG=i}),define(ke[303],Ee([1,0,13,148,25,26,12,7]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Ckc=p;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Dkc=E;class A{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$Ekc=A;class P extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fkc=P;class $ extends A{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gkc=$;class S extends A{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,r){this.g=r,this.a=o,this.b=n,this.c=i,this.d=new L.$Km,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new S(s));return this.c.onExtensionActivationError(o.id,s,new R.$eG(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),c=this.k(o,n.displayName,[],new S(l));return this.c.onExtensionActivationError(n.identifier,l,new R.$eG(s)),c}return this.k(o,n.displayName,i,null)}k(o,n,i,r){const s=new a(o.id,n,o.reason,i,r,this.c,this.g);return this.d.set(o.id,s),s}l(o){return O.$z$b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Hkc=v,e.$Hkc=v=Je([We(3,M.$Tj)],v);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,r,s,t,f){this.c=o,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new b.$mh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new S(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new S(n),this.b&&u.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};a=Je([We(6,M.$Tj)],a)}),define(ke[304],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[305],Ee([1,0,242,13,39,137,109,37,25,304,139,140]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0;const $=b.$6n.as(M.$7n.JSONContribution);class S{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(L.default.Error,s)}warn(s){this.d(L.default.Warning,s)}info(s){this.d(L.default.Info,s)}}e.$8F=S;class v{static a(s){const t=new p.$Jm;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const f=this.a(s),d=this.a(t),l=t.filter(h=>!f.has(h.description.identifier)),c=s.filter(h=>!d.has(h.description.identifier));return new v(l,c)}constructor(s,t){this.added=s,this.removed=t}}e.$9F=v;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,O.$1)(s)}}}e.$0F=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$$F={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Hm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Ko}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Ko}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&P.$YF.register(s.extensionPoint,s.activationEventsGenerator),e.$$F.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,$.registerSchema(o,e.$$F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$_F=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$6n.add(i.ExtensionsRegistry,new n),e.$aG=b.$6n.as(i.ExtensionsRegistry),$.registerSchema(o,e.$$F),$.registerSchema(A.$bk,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[306],Ee([1,0,238,18,24,305,40,4]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var E;(function($){function S(v,a,m){if(!v)return;const o=O.$1f(v.type)?v.type:void 0;if(!o||o.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)O.$1f(i)&&n.push(i);return{extensionId:a.value,taskType:o,required:n,properties:v.properties?L.$Tn(v.properties):{},when:v.when?M.$lj.deserialize(v.when):void 0}}$.from=S})(E||(E={}));const A=R.$aG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,S)=>{for(const v of $)v.type&&S.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:p}});class P{constructor(){this.d=new b.$_d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,v)=>{A.setHandler((a,m)=>{this.c=void 0;try{for(const o of m.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of m.added){const n=o.value;for(const i of n){const r=E.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const v of this.all()){const a={type:"object",additionalProperties:!1};v.required.length>0&&(a.required=v.required.slice(0)),v.properties!==void 0?a.properties=L.$Tn(v.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[v.taskType]},S.push(a)}this.c={oneOf:S}}return this.c}}e.$CH=new P}),define(ke[307],Ee([1,0,239,18,23,24,40,306]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MH=e.JsonSchemaVersion=e.ExecutionEngine=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GH=e.ShellQuoting=e.$FH=e.$EH=e.$DH=void 0,e.$DH="settings",e.$EH=new M.$Ej("taskRunning",!1,u.localize(0,null)),e.$FH=u.localize2(2,"Tasks");var p;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$GH="$customized",function(N){function T(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=T}(p||(e.ShellQuoting=p={}));var E;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function T(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=T}(A||(e.RevealKind=A={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function T(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=T}(P||(e.RevealProblemKind=P={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($||(e.PanelKind=$={})),function(N){function T(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=T}($||(e.PanelKind=$={}));var S;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var v;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(N){function T(H){switch(H.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=T;function B(H){switch(H){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(v||(e.RuntimeType=v={}));var a;(function(N){function T(B){return O.$1f(B)?B:B.value}N.value=T})(a||(e.CommandString=a={}));var m;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function T(H){return H===N.Clean._id||H===N.Build._id||H===N.Rebuild._id||H===N.Test._id}N.is=T;function B(H){if(H!==void 0)return O.$1f(H)?T(H)?{_id:H,isDefault:!1}:void 0:H}N.from=B})(m||(e.TaskGroup=m={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function T(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(N){N.parallel="parallel",N.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(T,B,H,Z,ee,J){this._label="",this._id=T,B&&(this._label=B),H&&(this.type=H),this.runOptions=Z,this.configurationProperties=ee,this._source=J}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(O.$1f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$HH=t;class f extends t{constructor(T,B,H,Z,ee,J,Y,re){super(T,H,void 0,Y,re,B),this.command={},this._source=B,this.hasDefinedMatchers=J,ee&&(this.command=ee)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof f}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$DH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const H={type:e.$GH,folder:T,id:B};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Xg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new f(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$IH=f;class d extends t{constructor(T,B,H,Z,ee,J,Y){super(T,H,Z,J,Y,B),this._source=B,this.configures=ee}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Xg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$DH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const H={type:e.$GH,folder:T,id:B};return JSON.stringify(H)}}e.$JH=d;class l extends t{constructor(T,B,H,Z,ee,J,Y,re,te){super(T,H,Z,re,te,B),this.defines=ee,this.hasDefinedMatchers=Y,this.command=J,this.icon=te.icon,this.hide=te.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof l}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new l(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$KH=l;class c extends t{constructor(T,B,H,Z,ee,J){super(T,H,Z,ee,J,B),this._source=B}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$LH=c;var h;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(N){N._default=N.Terminal}(h||(e.ExecutionEngine=h={}));var g;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const H=T.getWorkspaceFolder(),Z=B.getWorkspaceFolder();if(H&&Z){let ee=this.c.get(H.uri.toString());ee=ee===void 0?0:ee+1;let J=this.c.get(Z.uri.toString());return J=J===void 0?0:J+1,ee===J?T._label.localeCompare(B._label):ee-J}else return!H&&Z?-1:H&&!Z?1:0}}e.$MH=D;var w;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(w||(e.TaskEventKind=w={}));var k;(function(N){N.SingleRun="singleRun",N.Background="background"})(k||(e.TaskRunType=k={}));var y;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(N){function T(re){return{taskId:re._id,taskName:re.configurationProperties.name,runType:re.configurationProperties.isBackground?"background":"singleRun",group:re.configurationProperties.group,__task:re}}function B(re,te,pe){return{...T(re),kind:"start",terminalId:te,resolvedVariables:pe}}N.start=B;function H(re,te,pe){return{...T(re),kind:"processStarted",terminalId:te,processId:pe}}N.processStarted=H;function Z(re,te,pe){return{...T(re),kind:"processEnded",terminalId:te,exitCode:pe}}N.processEnded=Z;function ee(re,te,pe){return{...T(re),kind:"terminated",exitReason:pe,terminalId:te}}N.terminated=ee;function J(re,te,pe){return{...T(te),kind:re,terminalId:pe}}N.general=J;function Y(){return{kind:"changed"}}N.changed=Y})(C||(e.TaskEvent=C={}));var I;(function(N){function T(H){const Z=Object.keys(H).sort();let ee="";for(const J of Z){let Y=H[J];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),ee+=J+","+Y+","}return ee}function B(H){const ee={_key:T(H),type:H.taskType};return Object.assign(ee,H),ee}N.create=B})(I||(e.KeyedTaskIdentifier=I={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var j;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var F;(function(N){function T(B,H){const Z=b.$CH.get(B.type);if(Z===void 0){const re=R.$Tn(B);return delete re._key,I.create(re)}const ee=Object.create(null);ee.type=Z.taskType;const J=new Set;Z.required.forEach(re=>J.add(re));const Y=Z.properties;for(const re of Object.keys(Y)){const te=B[re];if(te!=null)ee[re]=te;else if(J.has(re)){const pe=Y[re];if(pe.default!==void 0)ee[re]=R.$Tn(pe.default);else switch(pe.type){case"boolean":ee[re]=!1;break;case"number":case"integer":ee[re]=0;break;case"string":ee[re]="";break;default:H.error(u.localize(1,null,JSON.stringify(B,void 0,0),re));return}}}return I.create(ee)}N.createTaskIdentifier=T})(F||(e.TaskDefinition=F={}))}),define(ke[308],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,u.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$D$b=O;class L extends O{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$E$b=L}),define(ke[48],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$gw=void 0,e.$hw=L,e.$iw=R;class u{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++u.count}}e.$gw=u;const O=[];function L(b){const p=new u(b);return O[p.nid]=p,p}function R(b){return O[b].sid}class M{constructor(p){this.value=p}}e.$jw=M}),define(ke[6],Ee([1,0,48]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var L;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var p;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var E;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(m){return m._id=P.a++,m}}e.$wM=P;var $;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var S;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var v;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$xM={MainThreadAuthentication:(0,u.$hw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$hw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$hw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$hw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$hw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$hw)("MainThreadClipboard"),MainThreadCommands:(0,u.$hw)("MainThreadCommands"),MainThreadComments:(0,u.$hw)("MainThreadComments"),MainThreadConfiguration:(0,u.$hw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$hw)("MainThreadConsole"),MainThreadDebugService:(0,u.$hw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$hw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$hw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$hw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$hw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$hw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$hw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$hw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$hw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$hw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$hw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$hw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$hw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$hw)("MainThreadLanguages"),MainThreadLogger:(0,u.$hw)("MainThreadLogger"),MainThreadMessageService:(0,u.$hw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$hw)("MainThreadOutputService"),MainThreadProgress:(0,u.$hw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$hw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$hw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$hw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$hw)("MainThreadSecretState"),MainThreadStorage:(0,u.$hw)("MainThreadStorage"),MainThreadSpeech:(0,u.$hw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$hw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$hw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,u.$hw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,u.$hw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$hw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$hw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$hw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$hw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$hw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$hw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$hw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$hw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$hw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$hw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$hw)("MainThreadSCM"),MainThreadSearch:(0,u.$hw)("MainThreadSearch"),MainThreadShare:(0,u.$hw)("MainThreadShare"),MainThreadTask:(0,u.$hw)("MainThreadTask"),MainThreadWindow:(0,u.$hw)("MainThreadWindow"),MainThreadLabelService:(0,u.$hw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$hw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$hw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$hw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$hw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$hw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$hw)("MainThreadInteractive"),MainThreadChat:(0,u.$hw)("MainThreadChat"),MainThreadInlineChat:(0,u.$hw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$hw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$hw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$hw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$hw)("MainThreadTimeline"),MainThreadTesting:(0,u.$hw)("MainThreadTesting"),MainThreadLocalization:(0,u.$hw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$hw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$hw)("MainThreadAiEmbeddingVector")},e.$yM={ExtHostCommands:(0,u.$hw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$hw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$hw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$hw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$hw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$hw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$hw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$hw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$hw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$hw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$hw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$hw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$hw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$hw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$hw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$hw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$hw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$hw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$hw)("ExtHostStatusBar"),ExtHostShare:(0,u.$hw)("ExtHostShare"),ExtHostExtensionService:(0,u.$hw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$hw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$hw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,u.$hw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,u.$hw)("ExtHostSCM"),ExtHostSearch:(0,u.$hw)("ExtHostSearch"),ExtHostTask:(0,u.$hw)("ExtHostTask"),ExtHostWorkspace:(0,u.$hw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$hw)("ExtHostWindow"),ExtHostWebviews:(0,u.$hw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$hw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$hw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$hw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$hw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$hw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$hw)("ExtHostProgress"),ExtHostComments:(0,u.$hw)("ExtHostComments"),ExtHostSecretState:(0,u.$hw)("ExtHostSecretState"),ExtHostStorage:(0,u.$hw)("ExtHostStorage"),ExtHostUrls:(0,u.$hw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$hw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$hw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$hw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$hw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$hw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$hw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$hw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$hw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$hw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$hw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$hw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$hw)("ExtHostInlineChatShape"),ExtHostChat:(0,u.$hw)("ExtHostChat"),ExtHostChatAgents2:(0,u.$hw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$hw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$hw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$hw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$hw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$hw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$hw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$hw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$hw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$hw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$hw)("ExtHostTimeline"),ExtHostTesting:(0,u.$hw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$hw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$hw)("ExtHostLocalization")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=e.$Zjc=e.$Yjc=void 0,e.$Yjc=(0,u.$ni)("IExtHostApiDeprecationService");let M=class{constructor(p,E){this.c=E,this.a=new Set,this.b=p.getProxy(L.$xM.MainThreadTelemetry)}report(p,E,A){const P=this.d(p,E);this.a.has(P)||(this.a.add(P),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:p}))}d(p,E){return`${p}-${E.identifier.value}`}};e.$Zjc=M,e.$Zjc=M=Je([We(0,R.$UO),We(1,O.$Tj)],M),e.$1jc=Object.freeze(new class{report(b,p,E){}})}),define(ke[309],Ee([1,0,3,6]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class L{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=L.a++}}class R{static{this.a=0}constructor(b){this.b=new Map,this.c=new Map,this.d=b.getProxy(O.$xM.MainThreadChat)}registerChatProvider(b,p,E){const A=new L(b,E);return this.b.set(A.handle,A),this.d.$registerChatProvider(A.handle,p),(0,u.$Sc)(()=>{this.d.$unregisterChatProvider(A.handle),this.b.delete(A.handle)})}transferActiveChat(b){this.d.$transferActiveChatSession(b)}async $prepareChat(b,p){const E=this.b.get(b);if(!E)return;const A=await E.provider.prepareSession(p);if(!A)return;const P=R.a++;return this.c.set(P,A),{id:P}}$releaseSession(b){this.c.delete(b)}}e.$_jc=R}),define(ke[310],Ee([1,0,6]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class O{constructor(R){const M=R.getProxy(u.$xM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$ekc=O}),define(ke[311],Ee([1,0,24,6,28,20]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;let M=class{constructor(A,P){this.a=A.getProxy(O.$xM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,P){const $=this,S=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,P,S,arguments)}})}e(A,P,$,S){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:p(S,this.b)}),this.c&&this.f(A,$,S)}};e.$9lc=M,e.$9lc=M=Je([We(0,R.$UO),We(1,L.$$O)],M);const b=1e5;function p(E,A){const P=[];if(E.length)for(let $=0;$<E.length;$++){let S=E[$];if(typeof S>"u")S="undefined";else if(S instanceof Error){const v=S;v.stack?S=v.stack:S=v.toString()}P.push(S)}if(A){const $=new Error().stack;$&&P.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,u.$Yn)(P);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[312],Ee([1,0,2,6,26]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class R{constructor(b){this.a=b.getProxy(O.$xM.MainThreadDialogs)}showOpenDialog(b,p){return p?.allowUIResources&&(0,L.$hG)(b,"showLocal"),this.a.$showOpenDialog(p).then(E=>E?E.map(A=>u.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(p=>p?u.URI.revive(p):void 0)}}e.$_kc=R}),define(ke[313],Ee([1,0,3,6]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(O.$xM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$tlc=L}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;let A=class{constructor($,S,v){this.f=v,this.d=new Map,this.a=S.getProxy(b.$xM.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===u.$g}getMessage($,S){const{message:v,args:a,comment:m}=S;if(this.c)return(0,O.$2e)(v,a??{});let o=v;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get($)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$2e)(n??v,a??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let S;const v=await this.g($);if(!v){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(v),m=JSON.parse(a);S=$.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${$.identifier.value} from ${v}: ${a.message}`);return}S&&this.d.set($.identifier.value,{contents:S,uri:v})}async g($){if($.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return L.URI.revive(S)}return $.l10n?L.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Tkc=A,e.$Tkc=A=Je([We(0,p.$$O),We(1,E.$UO),We(2,M.$Tj)],A),e.$Ukc=(0,R.$ni)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,58]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;let p=class extends u.$5j{constructor(P,$){super($.logLevel,$.logsLocation,$.loggers.map(S=>(0,b.$Wh)(S))),this.r=P.getProxy(O.$xM.MainThreadLogger)}$setLogLevel(P,$){$?this.setLogLevel(M.URI.revive($),P):this.setLogLevel(P)}setVisibility(P,$){super.setVisibility(P,$),this.r.$setVisibility(P,$)}s(P,$,S){return new E(this.r,P,$,S)}};e.$8lc=p,e.$8lc=p=Je([We(0,R.$UO),We(1,L.$$O)],p);class E extends u.$Zj{constructor(P,$,S,v){super(v?.logLevel==="always"),this.r=P,this.s=$,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger($,v).then(()=>{this.u(this.n),this.m=!0})}g(P,$){const S=[[P,$]];this.m?this.u(S):this.n.push(...S)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=void 0,e.$Vkc=(0,O.$ni)("IExtHostManagedSockets");let b=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(u.$xM.MainThreadManagedSockets)}setFactory(P,$){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(P,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const $=++this.b,S=await this.c.makeConnection(),v=new L.$Tc;return this.d.set($,new E($,S,v)),v.add((0,L.$Sc)(()=>this.d.delete($))),v.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),v.dispose()})),v.add(S.onDidClose(a=>{this.a.$onDidManagedSocketClose($,a?.stack??a?.message),v.dispose()})),v.add(S.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData($,M.$ze.wrap(a)))),$}$remoteSocketWrite(P,$){this.d.get(P)?.actual.send($.buffer)}$remoteSocketEnd(P){const $=this.d.get(P);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$Wkc=b,e.$Wkc=b=Je([We(0,R.$UO)],b);class p{constructor(P,$){this.socketFactoryId=P,this.makeConnection=$}}class E extends L.$Uc{constructor(P,$,S){super(),this.socketId=P,this.actual=$,this.B(S)}}}),define(ke[314],Ee([1,0,6,12,26]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;function R(b){return b&&b.title}let M=class{constructor(p,E){this.b=E,this.a=p.getProxy(u.$xM.MainThreadMessageService)}showMessage(p,E,A,P,$){const S={source:{identifier:p.identifier,label:p.displayName||p.name}};let v;typeof P=="string"||R(P)?v=[P,...$]:(S.modal=P?.modal,S.useCustom=P?.useCustom,S.detail=P?.detail,v=$),S.useCustom&&(0,L.$hG)(p,"resolvers");const a=[];let m=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")a.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;a.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,A,S,a).then(o=>{if(typeof o=="number")return v[o]})}};e.$vlc=M,e.$vlc=M=Je([We(1,O.$Tj)],M)}),define(ke[315],Ee([1,0,3,18,2,26,6]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(M.$xM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,A,P){if((0,R.$hG)(E,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,E.identifier.value),(0,u.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(E,A,P,$){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(A,P,$)}async $readProfile(E,A,P){const $=this.b.get(E);if(!$)throw new Error(`Unknown handler with id: ${E}`);return $.readProfile((0,O.$1f)(A)?A:L.URI.revive(A),P)}}e.$Elc=b}),define(ke[117],Ee([1,0,6,4,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0;class R{constructor(b){this.b=new O.$_d,this.onDidChangePassword=this.b.event,this.a=b.getProxy(u.$xM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,p){return this.a.$getPassword(b,p)}store(b,p,E){return this.a.$setPassword(b,p,E)}delete(b,p){return this.a.$deletePassword(b,p)}}e.$Qkc=R,e.$Rkc=(0,L.$ni)("IExtHostSecretState")}),define(ke[316],Ee([1,0,22,3,6]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(L.$xM.MainThreadSpeech)}async $createSpeechToTextSession(b,p,E){const A=this.c.get(b);if(!A)return;const P=new O.$Tc,$=new u.$je;this.d.set(p,$);const S=P.add(A.provideSpeechToTextSession($.token,E?{language:E}:void 0));P.add(S.onDidChange(v=>{$.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,v)})),P.add($.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,p){const E=this.c.get(b);if(!E)return;const A=new O.$Tc,P=new u.$je;this.d.set(p,P);const $=A.add(E.provideKeywordRecognitionSession(P.token));A.add($.onDidChange(S=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,S)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,p,E){const A=R.a++;return this.c.set(A,E),this.b.$registerProvider(A,p,{extension:b,displayName:b.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Llc=R}),define(ke[118],Ee([1,0,6,4,5]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=void 0;class R{constructor(b,p){this.c=p,this.b=new O.$_d,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(u.$xM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,p){this.a.$registerExtensionStorageKeysToSync(b,p)}async initializeExtensionStorage(b,p,E){const A=await this.a.$initializeExtensionStorage(b,p);let P;return A&&(P=this.d(b,p,A)),P||E}setValue(b,p,E){return this.a.$setValue(b,p,E)}$acceptValue(b,p,E){const A=this.d(b,p,E);A&&this.b.fire({shared:b,key:p,value:A})}d(b,p,E){try{return JSON.parse(E)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${b}): ${A}`)}}}e.$Ikc=R,e.$Jkc=(0,L.$ni)("IExtHostStorage")}),define(ke[317],Ee([1,0,3,15,2,6]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class M{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(R.$xM.MainThreadUriOpeners)}registerExternalUriOpener(p,E,A,P){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const $=P.schemes.find(S=>!M.a.has(S));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(E,A),this.b.$registerUriOpener(E,P.schemes,p,P.label),(0,u.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(p,E,A){const P=this.c.get(p);if(!P)throw new Error(`Unknown opener with id: ${p}`);const $=L.URI.revive(E);return P.canOpenExternalUri($,A)}async $openUri(p,E,A){const P=this.c.get(p);if(!P)throw new Error(`Unknown opener id: '${p}'`);return P.openExternalUri(L.URI.revive(E.resolvedUri),{sourceUri:L.URI.revive(E.sourceUri)},A)}}e.$Zlc=M}),define(ke[318],Ee([1,0,6,2,3,13,25]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class b{static{this.a=0}constructor(E){this.c=new M.$Jm,this.d=new Map,this.b=E.getProxy(u.$xM.MainThreadUrls)}registerUriHandler(E,A){const P=E.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const $=b.a++;return this.c.add(P),this.d.set($,A),this.b.$registerUriHandler($,P,E.displayName||E.name),(0,L.$Sc)(()=>{this.c.delete(P),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(E,A){const P=this.d.get(E);if(!P)return Promise.resolve(void 0);try{P.handleUri(O.URI.revive(A))}catch($){(0,R.$1)($)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$1lc=b}),define(ke[92],Ee([1,0,4,3,15,24,2,246,284,113,6]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$tkc=void 0,e.$ukc=$,e.$wkc=a,e.$xkc=m;class P{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,f,d,l,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$_d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$_d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=d,this.#r=l,this.#l=$(l),this.#d=S(l),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,E.$vxb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+E.$uxb}return E.$uxb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),R.$Xn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,p.$Lnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const D=M.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,E.$vxb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const D=M.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,E.$vxb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`})}}e.$tkc=P;function $(i){try{const r=(0,b.$zp)((0,b.$yp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function S(i){try{const r=(0,b.$zp)((0,b.$yp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends O.$Uc{constructor(r,s,t,f,d){super(),this.c=s,this.f=t,this.g=f,this.h=d,this.b=new Map,this.a=r.getProxy(A.$xM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const f=this.j(r);if(f){const{message:d}=(0,p.$Mnb)(s,t.value);f._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new P(r,this.a,o(s),this.c,this.f,t,this.h);this.b.set(r,f);const d=f._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$vkc=v;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>M.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(he,e,u,O,L,R,M,b,p,E){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(S){const v=this.d;return{get focused(){return v.focused},get active(){return(0,E.$hG)(S,"windowActivity"),v.active}}}constructor(S){this.c=new u.$_d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=S.getProxy(O.$xM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:a})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,v){v!==this.d[S]&&(this.d={...this.d,[S]:v},this.c.fire(this.d))}openUri(S,v){let a;if(typeof S=="string"){a=S;try{S=L.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,M.$Ze)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,a,v)}async asExternalUri(S,v){if((0,M.$Ze)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(S,v);return L.URI.from(a)}};e.$3lc=P,e.$3lc=P=A=Je([We(0,p.$UO)],P),e.$4lc=(0,b.$ni)("IExtHostWindow")}),define(ke[319],Ee([1,0,311,28,20]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;const R=1024*1024;let M=class extends u.$9lc{constructor(p,E){super(p,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(p,E,A){const P=p==="error"||p==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),E.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(p,E){const A=process[p],P=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(S,v,a)=>{if(!this.g){$+=S.toString(v);const m=$.length>R?$.length:$.lastIndexOf(`
`);m!==-1&&(console[E]($.slice(0,m)),$=$.slice(m+1))}P.call(A,S,v,a)}})}};e.$Hmc=M,e.$Hmc=M=Je([We(0,L.$UO),We(1,O.$$O)],M)}),define(ke[320],Ee([1,0,149,15,261,30]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class M extends u.$8lc{s(p,E,A){return p.scheme===O.Schemas.file?new L.$8P(A?.name||(0,R.$Jg)(),p.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,E):super.s(p,E,A)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Tmc=M}),define(ke[321],Ee([1,0,7,21,22,13,4,3,133,308,48]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$F$b=m,e.$G$b=o;function $(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const S="$$ref$$",v={[S]:-1};class a{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function m(y,C=null,I=!1){const z=[];return{jsonString:(I?$:JSON.stringify)(y,(F,N)=>{if(typeof N>"u")return v;if(typeof N=="object"){if(N instanceof O.$ze){const T=z.push(N)-1;return{[S]:T}}if(C)return C(F,N)}return N}),referencedBuffers:z}}function o(y,C,I){return JSON.parse(y,(z,j)=>{if(j){const F=j[S];if(typeof F=="number")return C[F];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Uc{static{P=f}static{this.a=3*1e3}constructor(C,I=null,z=null){super(),this[P]=!0,this.b=this.B(new M.$_d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=z,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,F=A.$gw.count;j<F;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$zh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,p.$sn)(C,this.g):C}getProxy(C){const{nid:I,sid:z}=C;return this.s[I]||(this.s[I]=this.J(I,z)),this.s[I]}J(C,I){const z={get:(j,F)=>(typeof F=="string"&&!j[F]&&F.charCodeAt(0)===36&&(j[F]=(...N)=>this.U(C,F,N)),F===d?I:j[F])};return new Proxy(Object.create(null),z)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,z=C.length;I<z;I++){const j=C[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,z=h.read(C,0),j=z.readUInt8(),F=z.readUInt32();switch(j){case 1:case 2:{let{rpcId:N,method:T,args:B}=D.deserializeRequestJSONArgs(z);this.g&&(B=(0,p.$sn)(B,this.g)),this.M(I,F,N,T,B,j===2);break}case 3:case 4:{let{rpcId:N,method:T,args:B}=D.deserializeRequestMixedArgs(z);this.g&&(B=(0,p.$sn)(B,this.g)),this.M(I,F,N,T,B,j===4);break}case 5:{this.f?.logIncoming(I,F,0,"ack"),this.G(F);break}case 6:{this.N(I,F);break}case 7:{this.O(I,F,void 0);break}case 9:{let N=D.deserializeReplyOKJSON(z);this.g&&(N=(0,p.$sn)(N,this.g)),this.O(I,F,N);break}case 10:{const N=D.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(I,F,N);break}case 8:{const N=D.deserializeReplyOKVSBuffer(z);this.O(I,F,N);break}case 11:{let N=D.deserializeReplyErrError(z);this.g&&(N=(0,p.$sn)(N,this.g)),this.P(I,F,N);break}case 12:{this.P(I,F,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,z,j,F,N){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,A.$iw)(z)}.${j}(`,F);const T=String(I);let B,H;if(N){const ee=new L.$je;F.push(ee.token),B=this.Q(z,j,F),H=()=>ee.cancel()}else B=this.Q(z,j,F),H=t;this.u[T]=H;const Z=D.serializeAcknowledged(I);this.f?.logOutgoing(Z.byteLength,I,1,"ack"),this.c.send(Z),B.then(ee=>{delete this.u[T];const J=D.serializeReplyOK(I,ee,this.h);this.f?.logOutgoing(J.byteLength,I,1,"reply:",ee),this.c.send(J)},ee=>{delete this.u[T];const J=D.serializeReplyErr(I,ee);this.f?.logOutgoing(J.byteLength,I,1,"replyErr:",ee),this.c.send(J)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const z=String(I);this.u[z]?.()}O(C,I,z){this.f?.logIncoming(C,I,0,"receiveReply:",z);const j=String(I);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j],F.resolveOk(z)}P(C,I,z){this.f?.logIncoming(C,I,0,"receiveReplyErr:",z);const j=String(I);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),F.resolveErr(N)}Q(C,I,z){try{return Promise.resolve(this.S(C,I,z))}catch(j){return Promise.reject(j)}}S(C,I,z){const j=this.m[C];if(!j)throw new Error("Unknown actor "+(0,A.$iw)(C));const F=j[I];if(typeof F!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$iw)(C));return F.apply(j,z)}U(C,I,z){if(this.j)return new E.$E$b;let j=null;if(z.length>0&&L.CancellationToken.isCancellationToken(z[z.length-1])&&(j=z.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$6());const F=D.serializeRequestArguments(z,this.h),N=++this.t,T=String(N),B=new E.$D$b,H=new b.$Tc;j&&H.add(j.onCancellationRequested(()=>{const ee=D.serializeCancel(N);this.f?.logOutgoing(ee.byteLength,N,0,"cancel"),this.c.send(D.serializeCancel(N))})),this.w[T]=new c(B,H),this.F(N);const Z=D.serializeRequest(N,C,I,F,!!j);return this.f?.logOutgoing(Z.byteLength,N,0,`request: ${(0,A.$iw)(C)}.${I}(`,z),this.c.send(Z),B}}e.$H$b=l;class c{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,I,z){const j=new h(O.$ze.alloc(z+1+4),0);return j.writeUInt8(C),j.writeUInt32(I),j}static read(C,I){return new h(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let z=0,j=C.length;z<j;z++){const F=C[z];switch(I+=1,F.type){case 1:I+=this.sizeLongString(F.value);break;case 2:I+=this.sizeVSBuffer(F.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(F.value);for(let N=0;N<F.buffers.length;++N)I+=this.sizeVSBuffer(F.buffers[N]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,z=C.length;I<z;I++){const j=C[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let F=0;F<j.buffers.length;++F)this.writeBuffer(j.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:I[z]=this.readLongString();break;case 2:I[z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),N=this.readLongString(),T=[];for(let B=0;B<F;++B)T.push(this.readVSBuffer());I[z]=new A.$jw(o(N,T,null));break}case 4:I[z]=void 0;break}return I}}var g;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(g||(g={}));class D{static a(C){for(let I=0,z=C.length;I<z;I++)if(C[I]instanceof O.$ze||C[I]instanceof A.$jw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const z=[];for(let j=0,F=C.length;j<F;j++){const N=C[j];if(N instanceof O.$ze)z[j]={type:2,value:N};else if(typeof N>"u")z[j]={type:4};else if(N instanceof A.$jw){const{jsonString:T,referencedBuffers:B}=m(N.value,I);z[j]={type:3,value:O.$ze.fromString(T),buffers:B}}else z[j]={type:1,value:O.$ze.fromString(n(N,I))}}return{type:1,args:z}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,z,j,F){switch(j.type){case 0:return this.b(C,I,z,j.args,F);case 1:return this.c(C,I,z,j.args,F)}}static b(C,I,z,j,F){const N=O.$ze.fromString(z),T=O.$ze.fromString(j);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(N),B+=h.sizeLongString(T);const H=h.alloc(F?2:1,C,B);return H.writeUInt8(I),H.writeShortString(N),H.writeLongString(T),H.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),z=C.readShortString(),j=C.readLongString();return{rpcId:I,method:z,args:JSON.parse(j)}}static c(C,I,z,j,F){const N=O.$ze.fromString(z);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(N),T+=h.sizeMixedArray(j);const B=h.alloc(F?4:3,C,T);return B.writeUInt8(I),B.writeShortString(N),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),z=C.readShortString(),j=C.readMixedArray(),F=new Array(j.length);for(let N=0,T=j.length;N<T;N++){const B=j[N];typeof B=="string"?F[N]=JSON.parse(B):F[N]=B}return{rpcId:I,method:z,args:F}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,I,z){if(typeof I>"u")return this.d(C);if(I instanceof O.$ze)return this.e(C,I);if(I instanceof A.$jw){const{jsonString:j,referencedBuffers:F}=m(I.value,z,!0);return this.g(C,j,F)}else return this.f(C,$(I,z))}static d(C){return h.alloc(7,C,0).buffer}static e(C,I){let z=0;z+=h.sizeVSBuffer(I);const j=h.alloc(8,C,z);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const z=O.$ze.fromString(I);let j=0;j+=h.sizeLongString(z);const F=h.alloc(9,C,j);return F.writeLongString(z),F.buffer}static g(C,I,z){const j=O.$ze.fromString(I);let F=0;F+=h.sizeUInt32,F+=h.sizeLongString(j);for(const T of z)F+=h.sizeVSBuffer(T);const N=h.alloc(10,C,F);N.writeUInt32(z.length),N.writeLongString(j);for(const T of z)N.writeBuffer(T);return N.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const z=C.readUInt32(),j=C.readLongString(),F=[];for(let N=0;N<z;++N)F.push(C.readVSBuffer());return new A.$jw(o(j,F,I))}static serializeReplyErr(C,I){const z=I?$(R.$3(I),null):void 0;if(typeof z!="string")return this.h(C);const j=O.$ze.fromString(z);let F=0;F+=h.sizeLongString(j);const N=h.alloc(11,C,F);return N.writeLongString(j),N.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return h.alloc(12,C,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var k;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[322],Ee([1,0,21,27,15,84,5]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$_J=void 0,e.$aK=A,e.$bK=P,e.$_J=(0,M.$ni)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${b.join("")}]+`),E=7;function A(S){if(S.scheme!==L.Schemas.vscodeNotebookCell)return;const v=S.fragment.indexOf("s");if(v<0)return;const a=parseInt(S.fragment.substring(0,v).replace(p,""),E),m=(0,u.$Se)(S.fragment.substring(v+1)).toString();if(!isNaN(a))return{handle:a,notebook:S.with({scheme:m,fragment:null})}}function P(S,v){const a=v.toString(E),o=`${a.length<b.length?b[a.length-1]:"z"}${a}s${(0,u.$Te)(u.$ze.fromString(S.scheme),!0,!0)}`;return S.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}class ${constructor(){this.a=new O.$Bc}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const a=A(v);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$cK=$,(0,R.$ls)(e.$_J,$,1)}),define(ke[119],Ee([1,0,21,35,45,101,15,17,11,40,322]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.$tK=e.CellStatusbarAlignment=e.$sK=e.NotebookEditorPriority=e.$pK=e.$oK=e.$mK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$lK=e.$kK=e.$jK=e.$iK=e.CellKind=e.$hK=e.$gK=e.$fK=void 0,e.$nK=f,e.$qK=l,e.$rK=c,e.$uK=D,e.$vK=k,e.$fK="workbench.editor.notebook",e.$gK="workbench.editor.notebookTextDiffEditor",e.$hK="workbench.editor.interactive";var P;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(P||(e.CellKind=P={})),e.$iK=["application/json","application/javascript","text/html","image/svg+xml",R.$Es.latex,R.$Es.markdown,"image/png","image/jpeg",R.$Es.text],e.$jK=[R.$Es.latex,R.$Es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Es.text],e.$kK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$lK="_notAvailable";var $;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function H(te,pe){return(0,A.$bK)(te,pe)}B.generate=H;function Z(te){return(0,A.$aK)(te)}B.parse=Z;function ee(te,pe){return te.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${te.scheme!==M.Schemas.file?te.scheme:""}`})}B.generateCellOutputUri=ee;function J(te){if(te.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!pe)return;const Ce=pe[1]&&pe[1]!==""?pe[1]:void 0,x=pe[2];return{outputId:Ce,notebook:te.with({scheme:x||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=J;function Y(te,pe,Ce){return B.generate(te,pe).with({scheme:Ce})}B.generateCellPropertyUri=Y;function re(te,pe){if(te.scheme===pe)return B.parse(te.with({scheme:B.scheme}))}B.parseCellPropertyUri=re})(r||(e.CellUri=r={}));const s=B=>p.$i?B.replace(/\//g,"\\"):B;class t{constructor(H=[],Z=e.$iK){this.e=Z,this.d=[...new Set(H)].map(ee=>({pattern:ee,matches:O.$hk(s(ee))}))}sort(H){const Z=new Map(L.Iterable.map(H,J=>[J,s(J)]));let ee=[];for(const{matches:J}of this.d)for(const[Y,re]of Z)if(J(re)){ee.push(Y),Z.delete(Y);break}return Z.size&&(ee=ee.concat([...Z.keys()].sort((J,Y)=>this.e.indexOf(J)-this.e.indexOf(Y)))),ee}prioritize(H,Z){const ee=this.f(H);if(ee===-1){this.d.unshift({pattern:H,matches:O.$hk(s(H))});return}const J=new Set(Z.map(re=>this.f(re,ee)));J.delete(-1);const Y=Array.from(J).sort();this.d.splice(ee+1,0,...Y.map(re=>this.d[re]));for(let re=Y.length-1;re>=0;re--)this.d.splice(Y[re],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,Z=this.d.length){const ee=s(H);for(let J=0;J<Z;J++)if(this.d[J].matches(ee))return J;return-1}}e.$mK=t;function f(B,H,Z,ee=(J,Y)=>J===Y){const J=[];function Y(pe,Ce,x){if(Ce===0&&x.length===0)return;const U=J[J.length-1];U&&U.start+U.deleteCount===pe?(U.deleteCount+=Ce,U.toInsert.push(...x)):J.push({start:pe,deleteCount:Ce,toInsert:x})}let re=0,te=0;for(;;){if(re===B.length){Y(re,0,H.slice(te));break}if(te===H.length){Y(re,B.length-re,[]);break}const pe=B[re],Ce=H[te];if(ee(pe,Ce)){re+=1,te+=1;continue}Z(Ce)?(Y(re,1,[]),re+=1):(Y(re,0,[Ce]),te+=1)}return J}e.$oK=new E.$Ej("notebookEditorCursorAtBoundary","none"),e.$pK=new E.$Ej("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const H=B;return!!((typeof H.include=="string"||O.$ik(H.include))&&(typeof H.exclude=="string"||O.$ik(H.exclude)))}function c(B,H,Z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(H)>=0||B.viewType===H)return!0;if(B.filenamePattern){const ee=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,J=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(O.$gk(ee,(0,b.$oc)(Z.fsPath).toLowerCase()))return!(J&&O.$gk(J,(0,b.$oc)(Z.fsPath).toLowerCase()))}return!1}e.$sK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class g{static{this.d="notebook/"}static create(H){return`${g.d}${H}`}static parse(H){if(H.startsWith(g.d))return H.substring(g.d.length)}}e.$tK=g;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const w=new TextDecoder;function k(B){const H=[];let Z=!1;for(const re of B)(H.length===0||Z)&&(H.push(re),Z=!0);let ee=I(H);const J=u.$ze.concat(H.map(re=>u.$ze.wrap(re))),Y=T(J);return ee=ee||Y.byteLength!==J.byteLength,{data:Y,didCompression:ee}}e.$wK="\x1B[A";const y=e.$wK.split("").map(B=>B.charCodeAt(0)),C=10;function I(B){let H=!1;return B.forEach((Z,ee)=>{if(ee===0||Z.length<e.$wK.length)return;const J=B[ee-1],Y=Z.subarray(0,e.$wK.length);if(Y[0]===y[0]&&Y[1]===y[1]&&Y[2]===y[2]){const re=J.lastIndexOf(C);if(re===-1)return;H=!0,B[ee-1]=J.subarray(0,re),B[ee]=Z.subarray(e.$wK.length)}}),H}function z(B){let H=B;do B=H,H=B.replace(/[^\n]\x08/gm,"");while(H.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const H=B.match(/^(.*)\r+/m)[1];let Z=B.match(/\r+(.*)$/m)[1];Z=Z+H.slice(Z.length,H.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return B}const F=8,N=13;function T(B){return!B.buffer.includes(F)&&!B.buffer.includes(N)?B:u.$ze.fromString(j(z(w.decode(B.buffer))))}}),define(ke[8],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v){"use strict";var a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$IO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$HO=e.$GO=e.$FO=e.$EO=e.ChatLocation=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$uO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$hO=e.$gO=e.$fO=e.$eO=e.$cO=e.$bO=e.$aO=e.$_N=e.TestRunProfileKind=e.TestResultState=e.$$N=e.$0N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$9N=e.NotebookVariablesRequestKind=e.$8N=e.$7N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$6N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.ColorThemeKind=e.$ZN=e.$YN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$XN=e.$WN=e.DebugConsoleMode=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$QN=e.$PN=e.FileChangeType=e.$ON=e.NewSymbolNameTag=e.$NN=e.$MN=e.$LN=e.$KN=e.InlineCompletionTriggerKind=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$xN=e.ConfigurationTarget=e.$wN=e.$vN=e.$uN=e.$tN=e.DocumentPasteTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mN=e.ViewBadge=e.ProgressLocation=e.$lN=e.$kN=e.TaskScope=e.ShellQuoting=e.$jN=e.$iN=e.$hN=e.TaskPanelKind=e.TaskRevealKind=e.$gN=e.TerminalLocation=e.$fN=e.$eN=e.$dN=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cN=e.$bN=e.$aN=e.$_M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$0M=e.$9M=e.$8M=e.$7M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6M=e.$5M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.LanguageStatusSeverity=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.CodeActionTriggerKind=e.$SM=e.$RM=e.SymbolTag=e.SymbolKind=e.$QM=e.$PM=e.DocumentHighlightKind=e.$OM=e.$NM=e.$MM=e.$LM=e.DiagnosticSeverity=e.DiagnosticTag=e.$KM=e.$JM=e.FileEditType=e.$IM=e.$HM=e.$GM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$$M=ht,e.$yN=ve,e.$dO=He;function y(G){return Object.assign(G,{apply:function(...$e){if($e.length===0)return Reflect.construct(G,[]);{const Te=$e.length===1?[]:$e[1];return Reflect.construct(G,Te,$e[0].constructor)}},call:function(...$e){if($e.length===0)return Reflect.construct(G,[]);{const[Te,...xe]=$e;return Reflect.construct(G,xe,Te.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let z=a=class{static from(...V){let $e=V;return new a(function(){if($e){for(const Te of $e)Te&&typeof Te.dispose=="function"&&Te.dispose();$e=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zM=z,e.$zM=z=a=Je([y],z);let j=m=class{static Min(...V){if(V.length===0)throw new TypeError;let $e=V[0];for(let Te=1;Te<V.length;Te++){const xe=V[Te];xe.isBefore($e)&&($e=xe)}return $e}static Max(...V){if(V.length===0)throw new TypeError;let $e=V[0];for(let Te=1;Te<V.length;Te++){const xe=V[Te];xe.isAfter($e)&&($e=xe)}return $e}static isPosition(V){if(!V)return!1;if(V instanceof m)return!0;const{line:$e,character:Te}=V;return typeof $e=="number"&&typeof Te=="number"}static of(V){if(V instanceof m)return V;if(this.isPosition(V))return new m(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,$e){if(V<0)throw(0,O.$7)("line must be non-negative");if($e<0)throw(0,O.$7)("character must be non-negative");this.c=V,this.e=$e}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,$e=0){if(V===null||$e===null)throw(0,O.$7)();let Te;return typeof V>"u"?Te=0:typeof V=="number"?Te=V:(Te=typeof V.lineDelta=="number"?V.lineDelta:0,$e=typeof V.characterDelta=="number"?V.characterDelta:0),Te===0&&$e===0?this:new m(this.line+Te,this.character+$e)}with(V,$e=this.character){if(V===null||$e===null)throw(0,O.$7)();let Te;return typeof V>"u"?Te=this.line:typeof V=="number"?Te=V:(Te=typeof V.line=="number"?V.line:this.line,$e=typeof V.character=="number"?V.character:this.character),Te===this.line&&$e===this.character?this:new m(Te,$e)}toJSON(){return{line:this.line,character:this.character}}};e.$AM=j,e.$AM=j=m=Je([y],j);let F=o=class{static isRange(V){return V instanceof o?!0:V?j.isPosition(V.start)&&j.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,$e,Te,xe){let nt,ft;if(typeof V=="number"&&typeof $e=="number"&&typeof Te=="number"&&typeof xe=="number"?(nt=new j(V,$e),ft=new j(Te,xe)):j.isPosition(V)&&j.isPosition($e)&&(nt=j.of(V),ft=j.of($e)),!nt||!ft)throw new Error("Invalid arguments");nt.isBefore(ft)?(this.c=nt,this.e=ft):(this.c=ft,this.e=nt)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):j.isPosition(V)?!(j.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const $e=j.Max(V.start,this.c),Te=j.Min(V.end,this.e);if(!$e.isAfter(Te))return new o($e,Te)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const $e=j.Min(V.start,this.c),Te=j.Max(V.end,this.end);return new o($e,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,$e=this.end){if(V===null||$e===null)throw(0,O.$7)();let Te;return V?j.isPosition(V)?Te=V:(Te=V.start||this.start,$e=V.end||this.end):Te=this.start,Te.isEqual(this.c)&&$e.isEqual(this.end)?this:new o(Te,$e)}toJSON(){return[this.start,this.end]}};e.$BM=F,e.$BM=F=o=Je([y],F);let N=n=class extends F{static isSelection(V){return V instanceof n?!0:V?F.isRange(V)&&j.isPosition(V.anchor)&&j.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,$e,Te,xe){let nt,ft;if(typeof V=="number"&&typeof $e=="number"&&typeof Te=="number"&&typeof xe=="number"?(nt=new j(V,$e),ft=new j(Te,xe)):j.isPosition(V)&&j.isPosition($e)&&(nt=j.of(V),ft=j.of($e)),!nt||!ft)throw new Error("Invalid arguments");super(nt,ft),this.f=nt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CM=N,e.$CM=N=n=Je([y],N);const T=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,O.$7)("connectionToken")};class B{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,$e,Te){if(typeof V!="string"||V.length===0)throw(0,O.$7)("host");if(typeof $e!="number"||$e===0||Math.round($e)!==$e)throw(0,O.$7)("port");typeof Te<"u"&&T(Te),this.host=V,this.port=Math.round($e),this.connectionToken=Te}}e.$DM=B;class H{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,$e){this.makeConnection=V,this.connectionToken=$e,typeof $e<"u"&&T($e)}}e.$EM=H;class Z extends Error{static NotAvailable(V,$e){return new Z(V,S.RemoteAuthorityResolverErrorCode.NotAvailable,$e)}static TemporarilyNotAvailable(V){return new Z(V,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,$e=S.RemoteAuthorityResolverErrorCode.Unknown,Te){super(V),this._message=V,this._code=$e,this._detail=Te,Object.setPrototypeOf(this,Z.prototype)}}e.$FM=Z;var ee;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ee||(e.EndOfLine=ee={}));var J;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let Y=i=class{static isTextEdit(V){return V instanceof i?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,$e){return new i(V,$e)}static insert(V,$e){return i.replace(new F(V,V),$e)}static delete(V){return i.replace(V,"")}static setEndOfLine(V){const $e=new i(new F(new j(0,0),new j(0,0)),"");return $e.newEol=V,$e}get range(){return this.c}set range(V){if(V&&!F.isRange(V))throw(0,O.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,O.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,O.$7)("newEol");this.f=V}constructor(V,$e){this.c=V,this.e=$e}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GM=Y,e.$GM=Y=i=Je([y],Y);let re=r=class{static isNotebookCellEdit(V){return V instanceof r?!0:V?Ue.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,$e){return new r(V,$e)}static insertCells(V,$e){return new r(new Ue(V,V),$e)}static deleteCells(V){return new r(V,[])}static updateCellMetadata(V,$e){const Te=new r(new Ue(V,V),[]);return Te.newCellMetadata=$e,Te}static updateNotebookMetadata(V){const $e=new r(new Ue(0,0),[]);return $e.newNotebookMetadata=V,$e}constructor(V,$e){this.range=V,this.newCells=$e}};e.$HM=re,e.$HM=re=r=Je([y],re);class te{static isSnippetTextEdit(V){return V instanceof te?!0:V?F.isRange(V.range)&&x.isSnippetString(V.snippet):!1}static replace(V,$e){return new te(V,$e)}static insert(V,$e){return te.replace(new F(V,V),$e)}constructor(V,$e){this.range=V,this.snippet=$e}}e.$IM=te;var pe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,$e,Te,xe){this.c.push({_type:1,from:V,to:$e,options:Te,metadata:xe})}createFile(V,$e,Te){this.c.push({_type:1,from:void 0,to:V,options:$e,metadata:Te})}deleteFile(V,$e,Te){this.c.push({_type:1,from:V,to:void 0,options:$e,metadata:Te})}e(V,$e,Te){this.c.push({_type:3,metadata:Te,uri:V,edit:{editType:5,metadata:$e},notebookMetadata:$e})}f(V,$e,Te,xe){const nt=$e.start,ft=$e.end;(nt!==ft||Te.length>0)&&this.c.push({_type:5,uri:V,index:nt,count:ft-nt,cells:Te,metadata:xe})}g(V,$e,Te,xe){this.c.push({_type:3,metadata:xe,uri:V,edit:{editType:3,index:$e,metadata:Te}})}replace(V,$e,Te,xe){this.c.push({_type:2,uri:V,edit:new Y($e,Te),metadata:xe})}insert(V,$e,Te,xe){this.replace(V,new F($e,$e),Te,xe)}delete(V,$e,Te){this.replace(V,$e,"",Te)}has(V){return this.c.some($e=>$e._type===2&&$e.uri.toString()===V.toString())}set(V,$e){if($e)for(const Te of $e){if(!Te)continue;let xe,nt;Array.isArray(Te)?(xe=Te[0],nt=Te[1]):xe=Te,re.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(V,xe.range.start,xe.newCellMetadata,nt):xe.newNotebookMetadata?this.e(V,xe.newNotebookMetadata,nt):this.f(V,xe.range,xe.newCells,nt):te.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:V,range:xe.range,edit:xe.snippet,metadata:nt}):this.c.push({_type:2,uri:V,edit:xe,metadata:nt})}else{for(let Te=0;Te<this.c.length;Te++){const xe=this.c[Te];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===V.toString()&&(this.c[Te]=void 0);break}}(0,u.$Ib)(this.c)}}get(V){const $e=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===V.toString()&&$e.push(Te.edit);return $e}entries(){const V=new R.$Bc;for(const $e of this.c)if($e._type===2){let Te=V.get($e.uri);Te||(Te=[$e.uri,[]],V.set($e.uri,Te)),Te[1].push($e.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JM=Ce,e.$JM=Ce=Je([y],Ce);let x=s=class{static isSnippetString(V){return V instanceof s?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=s.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,$e=this.e++){if(typeof V=="function"){const Te=new s;Te.e=this.e,V(Te),this.e=Te.e,V=Te.value}else V=s.c(V);return this.value+="${",this.value+=$e,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,$e=this.e++){const Te=V.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=$e,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(V,$e){if(typeof $e=="function"){const Te=new s;Te.e=this.e,$e(Te),this.e=Te.e,$e=Te.value}else typeof $e=="string"&&($e=$e.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,$e&&(this.value+=":",this.value+=$e),this.value+="}",this}};e.$KM=x,e.$KM=x=s=Je([y],x);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let be=t=class{static isLocation(V){return V instanceof t?!0:V?F.isRange(V.range)&&E.URI.isUri(V.uri):!1}constructor(V,$e){if(this.uri=V,$e)if(F.isRange($e))this.range=F.of($e);else if(j.isPosition($e))this.range=new F($e,$e);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LM=be,e.$LM=be=t=Je([y],be);let De=class{static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&E.URI.isUri(V.location.uri):!1}constructor(V,$e){this.location=V,this.message=$e}static isEqual(V,$e){return V===$e?!0:!V||!$e?!1:V.message===$e.message&&V.location.range.isEqual($e.location.range)&&V.location.uri.toString()===$e.location.uri.toString()}};e.$MM=De,e.$MM=De=Je([y],De);let ae=class{constructor(V,$e,Te=ne.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!$e)throw new TypeError("message must be set");this.range=V,this.message=$e,this.severity=Te}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,$e){return V===$e?!0:!V||!$e?!1:V.message===$e.message&&V.severity===$e.severity&&V.code===$e.code&&V.severity===$e.severity&&V.source===$e.source&&V.range.isEqual($e.range)&&(0,u.$ub)(V.tags,$e.tags)&&(0,u.$ub)(V.relatedInformation,$e.relatedInformation,De.isEqual)}};e.$NM=ae,e.$NM=ae=Je([y],ae);let ce=class{constructor(V,$e){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=$e}};e.$OM=ce,e.$OM=ce=Je([y],ce);var se;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let K=class{constructor(V,$e=se.Text){this.range=V,this.kind=$e}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$PM=K,e.$PM=K=Je([y],K);let ie=class{constructor(V,$e){this.uri=V,this.highlights=$e}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$QM=ie,e.$QM=ie=Je([y],ie);var le;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(G){G[G.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ae=f=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,$e,Te,xe,nt){this.name=V,this.kind=$e,this.containerName=nt,typeof Te=="string"&&(this.containerName=Te),xe instanceof be?this.location=xe:Te instanceof F&&(this.location=new be(xe,Te)),f.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$RM=Ae,e.$RM=Ae=f=Je([y],Ae);let me=d=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(d.validate)}constructor(V,$e,Te,xe,nt){this.name=V,this.detail=$e,this.kind=Te,this.range=xe,this.selectionRange=nt,this.children=[],d.validate(this)}};e.$SM=me,e.$SM=me=d=Je([y],me);var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Me=class{constructor(V,$e){this.title=V,this.kind=$e}};e.$TM=Me,e.$TM=Me=Je([y],Me);let je=class{static{l=this}static{this.c="."}constructor(V){this.value=V}append(V){return new l(this.value?this.value+l.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+l.c)}};e.$UM=je,e.$UM=je=l=Je([y],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let q=class{constructor(V,$e){if(this.range=V,this.parent=$e,$e&&!$e.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VM=q,e.$VM=q=Je([y],q);class W{constructor(V,$e,Te,xe,nt,ft){this.kind=V,this.name=$e,this.detail=Te,this.uri=xe,this.range=nt,this.selectionRange=ft}}e.$WM=W;class X{constructor(V,$e){this.fromRanges=$e,this.from=V}}e.$XM=X;class Q{constructor(V,$e){this.fromRanges=$e,this.to=V}}e.$YM=Q;var fe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(fe||(e.LanguageStatusSeverity=fe={}));let we=class{constructor(V,$e){this.range=V,this.command=$e}get isResolved(){return!!this.command}};e.$ZM=we,e.$ZM=we=Je([y],we);let Fe=c=class{#e;static isMarkdownString(V){return V instanceof c?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,$e=!1){this.#e=new L.$Kk(V,{supportThemeIcons:$e})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,$e){return this.#e.appendCodeblock($e??"",V),this}};e.$1M=Fe,e.$1M=Fe=c=Je([y],Fe);let Ve=class{constructor(V,$e){this.label=V,this.documentation=$e}};e.$2M=Ve,e.$2M=Ve=Je([y],Ve);let Ze=class{constructor(V,$e){this.label=V,this.documentation=$e,this.parameters=[]}};e.$3M=Ze,e.$3M=Ze=Je([y],Ze);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4M=tt,e.$4M=tt=Je([y],tt);var st;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var at;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let ot=class{constructor(V){this.value=V}};e.$5M=ot,e.$5M=ot=Je([y],ot);let Se=class{constructor(V,$e,Te){this.position=V,this.label=$e,this.kind=Te}};e.$6M=Se,e.$6M=Se=Je([y],Se);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Le;(function(G){G[G.Deprecated=1]="Deprecated"})(Le||(e.CompletionItemTag=Le={}));let Qe=class{constructor(V,$e){this.label=V,this.kind=$e}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7M=Qe,e.$7M=Qe=Je([y],Qe);let oe=class{constructor(V=[],$e=!1){this.items=V,this.isIncomplete=$e}};e.$8M=oe,e.$8M=oe=Je([y],oe);let ue=class{constructor(V,$e,Te){this.insertText=V,this.range=$e,this.command=Te}};e.$9M=ue,e.$9M=ue=Je([y],ue);let Ie=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$0M=Ie,e.$0M=Ie=Je([y],Ie);var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var Re;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Re||(e.ViewColumn=Re={}));var it;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(it||(e.StatusBarAlignment=it={}));function ht(G,V){return`${P.$Im.toKey(G)}.${V}`}var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var It;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var Bt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Bt||(e.TextEditorRevealType=Bt={}));var Qt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var ei;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var Dt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(G){function V($e){switch($e){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=V}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Vt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(G){function V($e){switch($e){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=V}(Vt||(e.SyntaxTokenType=Vt={}));let Xt=class{constructor(V,$e){if($e&&!E.URI.isUri($e))throw(0,O.$7)("target");if(!F.isRange(V)||V.isEmpty)throw(0,O.$7)("range");this.range=V,this.target=$e}};e.$_M=Xt,e.$_M=Xt=Je([y],Xt);let et=class{constructor(V,$e,Te,xe){this.red=V,this.green=$e,this.blue=Te,this.alpha=xe}};e.$aN=et,e.$aN=et=Je([y],et);let ai=class{constructor(V,$e){if($e&&!($e instanceof et))throw(0,O.$7)("color");if(!F.isRange(V)||V.isEmpty)throw(0,O.$7)("range");this.range=V,this.color=$e}};e.$bN=ai,e.$bN=ai=Je([y],ai);let ti=class{constructor(V){if(!V||typeof V!="string")throw(0,O.$7)("label");this.label=V}};e.$cN=ti,e.$cN=ti=Je([y],ti);var ii;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var dt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));class si{constructor(V,$e,Te){if(this.startIndex=V,this.length=$e,this.tooltip=Te,typeof V!="number"||V<0)throw(0,O.$7)("startIndex");if(typeof $e!="number"||$e<1)throw(0,O.$7)("length");if(Te!==void 0&&typeof Te!="string")throw(0,O.$7)("tooltip")}}e.$dN=si;class ni{constructor(V){this.uri=V}}e.$eN=ni;class Ot{constructor(V){this.terminalCommand=V}}e.$fN=Ot;var mt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(mt||(e.TerminalLocation=mt={}));class Rt{constructor(V){if(this.options=V,typeof V!="object")throw(0,O.$7)("options")}}e.$gN=Rt;var qt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(qt||(e.TaskRevealKind=qt={}));var Yt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Yt||(e.TaskPanelKind=Yt={}));let Xe=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(V){switch(V){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(V,$e){if(this.label=$e,typeof V!="string"||typeof $e!="string")throw(0,O.$7)("name");this.c=V}get id(){return this.c}};e.$hN=Xe,e.$hN=Xe=h=Je([y],Xe);function Zt(G){let V="";for(let $e=0;$e<G.length;$e++)V+=G[$e].replace(/,/g,",,")+",";return V}let Ut=class{constructor(V,$e,Te){if(typeof V!="string")throw(0,O.$7)("process");this.e=[],this.c=V,$e!==void 0&&(Array.isArray($e)?(this.e=$e,this.f=Te):this.f=$e)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,O.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const $e of this.e)V.push($e);return Zt(V)}};e.$iN=Ut,e.$iN=Ut=Je([y],Ut);let Ht=class{constructor(V,$e,Te){if(this.f=[],Array.isArray($e)){if(!V)throw(0,O.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,O.$7)("command");this.e=V,this.f=$e,this.g=Te}else{if(typeof V!="string")throw(0,O.$7)("commandLine");this.c=V,this.g=$e}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,O.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,O.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const $e of this.f)V.push(typeof $e=="string"?$e:$e.value);return Zt(V)}};e.$jN=Ht,e.$jN=Ht=Je([y],Ht);var $t;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var jt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(jt||(e.TaskScope=jt={}));class Mt{constructor(V){this.c=V}computeId(){return"customExecution"+(0,A.$Jg)()}set callback(V){this.c=V}get callback(){return this.c}}e.$kN=Mt;let Ft=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,$e,Te,xe,nt,ft){this.k=!1,this.l=this.definition=V;let gt;typeof $e=="string"?(this.o=this.name=$e,this.w=this.source=Te,this.execution=xe,gt=nt,this.k=!0):$e===jt.Global||$e===jt.Workspace?(this.target=$e,this.o=this.name=Te,this.w=this.source=xe,this.execution=nt,gt=ft):(this.target=$e,this.o=this.name=Te,this.w=this.source=xe,this.execution=nt,gt=ft),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:g.e,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:g.f,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:g.c,id:this.q.computeId()}:this.l={type:g.g,id:(0,A.$Jg)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=V}get scope(){return this.m}set target(V){this.B(),this.m=V}get name(){return this.o}set name(V){if(typeof V!="string")throw(0,O.$7)("name");this.B(),this.o=V}get execution(){return this.q}set execution(V){V===null&&(V=void 0),this.B(),this.q=V;const $e=this.l.type;(g.g===$e||g.e===$e||g.f===$e||g.c===$e)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(V){if(Array.isArray(V))this.B(),this.r=V,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.B(),this.u=V}get source(){return this.w}set source(V){if(typeof V!="string"||V.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=V}get group(){return this.x}set group(V){V===null&&(V=void 0),this.B(),this.x=V}get detail(){return this.A}set detail(V){V===null&&(V=void 0),this.A=V}get presentationOptions(){return this.y}set presentationOptions(V){V==null&&(V=Object.create(null)),this.B(),this.y=V}get runOptions(){return this.z}set runOptions(V){V==null&&(V=Object.create(null)),this.B(),this.z=V}};e.$lN=Ft,e.$lN=Ft=g=Je([y],Ft);var ri;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ri||(e.ProgressLocation=ri={}));var oi;(function(G){function V($e){const Te=$e;return(0,p.$5f)(Te.value)?Te.tooltip&&!(0,p.$1f)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=V})(oi||(e.ViewBadge=oi={}));let Wt=D=class{static isTreeItem(V,$e){const Te=V;if(Te.checkboxState!==void 0){const xe=(0,p.$5f)(Te.checkboxState)?Te.checkboxState:(0,p.$3f)(Te.checkboxState)&&(0,p.$5f)(Te.checkboxState.state)?Te.checkboxState.state:void 0,nt=!(0,p.$5f)(Te.checkboxState)&&(0,p.$3f)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(xe===void 0||xe!==Et.Checked&&xe!==Et.Unchecked||nt!==void 0&&!(0,p.$1f)(nt))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(V instanceof D)return!0;if(Te.label!==void 0&&!(0,p.$1f)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,p.$1f)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,p.$1f)(Te.iconPath)&&!E.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,p.$1f)(Te.iconPath.id))){const xe=Te.iconPath;if(!xe||!(0,p.$1f)(xe.light)&&!E.URI.isUri(xe.light)&&!(0,p.$1f)(xe.dark)&&!E.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,p.$1f)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!E.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,p.$1f)(Te.tooltip)&&!(Te.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<At.None&&Te.collapsibleState>At.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,p.$1f)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(V,$e=At.None){this.collapsibleState=$e,E.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$mN=Wt,e.$mN=Wt=D=Je([y],Wt);var At;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(At||(e.TreeItemCollapsibleState=At={}));var Et;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let xt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$nN=xt,e.$nN=xt=Je([y],xt);class Ct extends xt{}e.$oN=Ct;class kt extends Ct{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$pN=kt;class Pt{constructor(V,$e,Te,xe){this.name=V,this.uri=$e,this._itemId=Te,this.c=xe}data(){return this.c()}}e.$qN=Pt;let li=class{#e=new Map;constructor(V){for(const[$e,Te]of V??[]){const xe=this.#e.get(this.#t($e));xe?xe.push(Te):this.#e.set(this.#t($e),[Te])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,$e){this.#e.set(this.#t(V),[$e])}forEach(V,$e){for(const[Te,xe]of this.#e)for(const nt of xe)V.call($e,nt,Te,this)}*[Symbol.iterator](){for(const[V,$e]of this.#e)for(const Te of $e)yield[V,Te]}#t(V){return V.toLowerCase()}};e.$rN=li,e.$rN=li=Je([y],li);let St=class{constructor(V,$e,Te){this.insertText=V,this.title=$e,this.kind=Te}};e.$sN=St,e.$sN=St=Je([y],St);var hi;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(hi||(e.DocumentPasteTriggerKind=hi={}));class zt{static{this.c="."}constructor(V){this.value=V}append(...V){return new zt((this.value?[this.value,...V]:V).join(zt.c))}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+zt.c)}}e.$tN=zt,zt.Empty=new zt("");let bi=class{constructor(V,$e,Te){this.title=$e,this.insertText=V,this.kind=Te}};e.$uN=bi,e.$uN=bi=Je([y],bi);let Gt=class{constructor(V,$e){this.id=V,this.color=$e}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$vN=Gt,e.$vN=Gt=Je([y],Gt),Gt.File=new Gt("file"),Gt.Folder=new Gt("folder");let gi=class{constructor(V){this.id=V}};e.$wN=gi,e.$wN=gi=Je([y],gi);var Nt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Nt||(e.ConfigurationTarget=Nt={}));let Oe=class{get base(){return this.c}set base(V){this.c=V,this.e=E.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,$e){if(typeof V!="string"&&(!V||!E.URI.isUri(V)&&!E.URI.isUri(V.uri)))throw(0,O.$7)("base");if(typeof $e!="string")throw(0,O.$7)("pattern");typeof V=="string"?this.baseUri=E.URI.file(V):E.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=$e}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xN=Oe,e.$xN=Oe=Je([y],Oe);const ze=new WeakMap;function ve(G,V){ze.set(G,V)}let _=class{constructor(V,$e,Te,xe,nt){this.enabled=typeof V=="boolean"?V:!0,typeof $e=="string"&&(this.condition=$e),typeof Te=="string"&&(this.hitCondition=Te),typeof xe=="string"&&(this.logMessage=xe),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=ze.get(this)??(0,A.$Jg)()),this.c}};e.$zN=_,e.$zN=_=Je([y],_);let Ne=class extends _{constructor(V,$e,Te,xe,nt,ft){if(super($e,Te,xe,nt,ft),V===null)throw(0,O.$7)("location");this.location=V}};e.$AN=Ne,e.$AN=Ne=Je([y],Ne);let qe=class extends _{constructor(V,$e,Te,xe,nt,ft){super($e,Te,xe,nt,ft),this.functionName=V}};e.$BN=qe,e.$BN=qe=Je([y],qe);let _e=class extends _{constructor(V,$e,Te,xe,nt,ft,gt,Jt){if(super(xe,nt,ft,gt,Jt),!$e)throw(0,O.$7)("dataId");this.label=V,this.dataId=$e,this.canPersist=Te}};e.$CN=_e,e.$CN=_e=Je([y],_e);let Ye=class{constructor(V,$e,Te){this.command=V,this.args=$e||[],this.options=Te}};e.$DN=Ye,e.$DN=Ye=Je([y],Ye);let ct=class{constructor(V,$e){this.port=V,this.host=$e}};e.$EN=ct,e.$EN=ct=Je([y],ct);let yt=class{constructor(V){this.path=V}};e.$FN=yt,e.$FN=yt=Je([y],yt);let Kt=class{constructor(V){this.implementation=V}};e.$GN=Kt,e.$GN=Kt=Je([y],Kt);class _t{constructor(V,$e,Te){this.session=V,this.threadId=$e,this.frameId=Te}}e.$HN=_t;class Lt{constructor(V,$e){this.session=V,this.threadId=$e}}e.$IN=Lt;let lt=class{constructor(V,$e){this.range=V,this.expression=$e}};e.$JN=lt,e.$JN=lt=Je([y],lt);var Wi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Wi||(e.InlineCompletionTriggerKind=Wi={}));let di=class{constructor(V,$e){this.range=V,this.text=$e}};e.$KN=di,e.$KN=di=Je([y],di);let $i=class{constructor(V,$e,Te=!0){this.range=V,this.variableName=$e,this.caseSensitiveLookup=Te}};e.$LN=$i,e.$LN=$i=Je([y],$i);let yi=class{constructor(V,$e){this.range=V,this.expression=$e}};e.$MN=yi,e.$MN=yi=Je([y],yi);let Ai=class{constructor(V,$e){this.frameId=V,this.stoppedLocation=$e}};e.$NN=Ai,e.$NN=Ai=Je([y],Ai);var Vi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Vi||(e.NewSymbolNameTag=Vi={}));class hn{constructor(V,$e){this.newSymbolName=V,this.tags=$e}}e.$ON=hn;var Ri;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=w=class extends Error{static FileExists(V){return new w(V,$.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(V){return new w(V,$.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(V){return new w(V,$.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(V){return new w(V,$.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(V){return new w(V,$.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(V){return new w(V,$.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(V,$e=$.FileSystemProviderErrorCode.Unknown,Te){super(E.URI.isUri(V)?V.toString(!0):V),this.code=Te?.name??"Unknown",(0,$.$9k)(this,$e),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$PN=Mi,e.$PN=Mi=w=Je([y],Mi);let ki=class{constructor(V,$e,Te){this.start=V,this.end=$e,this.kind=Te}};e.$QN=ki,e.$QN=ki=Je([y],ki);var qi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Si;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Si||(e.CommentMode=Si={}));var Gi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var Ki;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Ki||(e.CommentThreadState=Ki={}));var wi;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(wi||(e.CommentThreadApplicability=wi={}));class dn{constructor(V,$e=[]){this.tokenTypes=V,this.tokenModifiers=$e}}e.$RN=dn;function fn(G){return typeof G>"u"||(0,p.$2f)(G)}class Li{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let $e=0,Te=V.tokenTypes.length;$e<Te;$e++)this.k.set(V.tokenTypes[$e],$e);for(let $e=0,Te=V.tokenModifiers.length;$e<Te;$e++)this.l.set(V.tokenModifiers[$e],$e)}}push(V,$e,Te,xe,nt){if(typeof V=="number"&&typeof $e=="number"&&typeof Te=="number"&&typeof xe=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(V,$e,Te,xe,nt);if(F.isRange(V)&&typeof $e=="string"&&fn(Te))return this.o(V,$e,Te);throw(0,O.$7)()}o(V,$e,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has($e))throw new Error("`tokenType` is not in the provided legend");const xe=V.start.line,nt=V.start.character,ft=V.end.character-V.start.character,gt=this.k.get($e);let Jt=0;if(Te)for(const ui of Te){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ui);Jt|=1<<fi>>>0}this.q(xe,nt,ft,gt,Jt)}q(V,$e,Te,xe,nt){if(this.f&&(V<this.c||V===this.c&&$e<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ui=0,fi=0;for(let mi=0;mi<Jt;mi++){let pi=this.g[5*mi],Ui=this.g[5*mi+1];pi===0?(pi=ui,Ui+=fi):pi+=ui,this.g[5*mi]=pi,this.g[5*mi+1]=Ui,ui=pi,fi=Ui}}let ft=V,gt=$e;this.f&&this.j>0&&(ft-=this.c,ft===0&&(gt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=gt,this.g[this.j++]=Te,this.g[this.j++]=xe,this.g[this.j++]=nt,this.c=V,this.e=$e}static r(V){const $e=[],Te=V.length/5|0;for(let gt=0;gt<Te;gt++)$e[gt]=gt;$e.sort((gt,Jt)=>{const ui=V[5*gt],fi=V[5*Jt];if(ui===fi){const mi=V[5*gt+1],pi=V[5*Jt+1];return mi-pi}return ui-fi});const xe=new Uint32Array(V.length);let nt=0,ft=0;for(let gt=0;gt<Te;gt++){const Jt=5*$e[gt],ui=V[Jt+0],fi=V[Jt+1],mi=V[Jt+2],pi=V[Jt+3],Ui=V[Jt+4],On=ui-nt,or=On===0?fi-ft:fi,Hi=5*gt;xe[Hi+0]=On,xe[Hi+1]=or,xe[Hi+2]=mi,xe[Hi+3]=pi,xe[Hi+4]=Ui,nt=ui,ft=fi}return xe}build(V){return this.f?new Di(new Uint32Array(this.g),V):new Di(Li.r(this.g),V)}}e.$SN=Li;class Di{constructor(V,$e){this.resultId=$e,this.data=V}}e.$TN=Di;class gn{constructor(V,$e,Te){this.start=V,this.deleteCount=$e,this.data=Te}}e.$UN=gn;class Ji{constructor(V,$e){this.resultId=$e,this.edits=V}}e.$VN=Ji;var Oi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Oi||(e.DebugConsoleMode=Oi={}));class mn{constructor(V){this.name=V}}e.$WN=mn;let Ci=class{static{this.Back={iconPath:new Gt("arrow-left")}}constructor(){}};e.$XN=Ci,e.$XN=Ci=Je([y],Ci);var Qi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Xi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var Yi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Yi||(e.ExtensionKind=Yi={}));class $n{static validate(V){if(typeof V.badge=="string"){let $e=(0,b.$Af)(V.badge,0);if($e<V.badge.length&&($e+=(0,b.$Af)(V.badge,$e)),V.badge.length>$e)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Gt.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,$e,Te){this.badge=V,this.tooltip=$e,this.color=Te}}e.$YN=$n;let vi=class{constructor(V){this.kind=V}};e.$ZN=vi,e.$ZN=vi=Je([y],vi);var Ni;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class Ue{static isNotebookRange(V){return V instanceof Ue?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,$e){if(V<0)throw(0,O.$7)("start must be positive");if($e<0)throw(0,O.$7)("end must be positive");V<=$e?(this.c=V,this.e=$e):(this.c=$e,this.e=V)}with(V){let $e=this.c,Te=this.e;return V.start!==void 0&&($e=V.start),V.end!==void 0&&(Te=V.end),$e===this.c&&Te===this.e?this:new Ue($e,Te)}}e.$1N=Ue;class ci{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every($e=>ci.isNotebookCellData($e))}static isNotebookCellData(V){return!0}constructor(V,$e,Te,xe,nt,ft,gt){this.kind=V,this.value=$e,this.languageId=Te,this.mime=xe,this.outputs=nt??[],this.metadata=ft,this.executionSummary=gt,ci.validate(this)}}e.$2N=ci;class Zi{constructor(V){this.cells=V}}e.$3N=Zi;class rt{static isNotebookCellOutputItem(V){return V instanceof rt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const $e={name:V.name,message:V.message,stack:V.stack};return rt.json($e,"application/vnd.code.notebook.error")}static stdout(V){return rt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return rt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,$e="application/octet-stream"){return new rt(V,$e)}static#e=new TextEncoder;static text(V,$e=M.$Es.text){const Te=rt.#e.encode(String(V));return new rt(Te,$e)}static json(V,$e="text/x-json"){const Te=JSON.stringify(V,void 0,"	");return rt.text(Te,$e)}constructor(V,$e){this.data=V,this.mime=$e;const Te=(0,M.$Is)($e,!0);if(!Te)throw new Error(`INVALID mime type: ${$e}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$4N=rt;class pt{static isNotebookCellOutput(V){return V instanceof pt?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,$e=!1){const Te=new Set,xe=new Set;for(let nt=0;nt<V.length;nt++){const ft=V[nt],gt=(0,M.$Is)(ft.mime);if(!Te.has(gt)||(0,v.$uK)(gt)){Te.add(gt);continue}xe.add(nt),$e&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?V:V.filter((nt,ft)=>!xe.has(ft))}constructor(V,$e,Te){this.items=pt.ensureUniqueMimeTypes(V,!0),typeof $e=="string"?(this.id=$e,this.metadata=Te):(this.id=(0,A.$Jg)(),this.metadata=$e??Te)}}e.$5N=pt;var xi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var _i;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var Ti;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ti||(e.NotebookCellStatusBarAlignment=Ti={}));var en;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class Pi{constructor(V,$e){this.text=V,this.alignment=$e}}e.$6N=Pi;var tn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var nn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(nn||(e.NotebookControllerAffinity2=nn={}));class pn{constructor(V,$e=[]){this.uri=V,this.provides=(0,u.$3b)($e)}}e.$7N=pn;class rn{constructor(V){this.label=V}}e.$8N=rn;var sn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let ji=class{constructor(V,$e){this.label=V,this.timestamp=$e}};e.$9N=ji,e.$9N=ji=Je([y],ji);var on;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var an;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var cn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class bn{constructor(V,$e){this.ranges=V,this.wordPattern=$e}}e.$0N=bn;class wn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$$N=wn;var un;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Fi=class{constructor(V=void 0,$e=void 0,Te=void 0,xe=!1){this.include=V,this.exclude=$e,this.profile=Te,this.continuous=xe}};e.$_N=Fi,e.$_N=Fi=Je([y],Fi);let zi=k=class{static diff(V,$e,Te){const xe=new k(V);return xe.expectedOutput=$e,xe.actualOutput=Te,xe}constructor(V){this.message=V}};e.$aO=zi,e.$aO=zi=k=Je([y],zi);let ge=class{constructor(V){this.id=V}};e.$bO=ge,e.$bO=ge=Je([y],ge);class ye{constructor(V,$e){this.covered=V,this.total=$e,He(this)}}e.$cO=ye;function He(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class ut{static fromDetails(V,$e){const Te=new ye(0,0),xe=new ye(0,0),nt=new ye(0,0);for(const gt of $e)if("branches"in gt){Te.total+=1,Te.covered+=gt.executed?1:0;for(const Jt of gt.branches)xe.total+=1,xe.covered+=Jt.executed?1:0}else nt.total+=1,nt.covered+=gt.executed?1:0;const ft=new ut(V,Te,xe.total>0?xe:void 0,nt.total>0?nt:void 0);return ft.detailedCoverage=$e,ft}constructor(V,$e,Te,xe){this.uri=V,this.statementCoverage=$e,this.branchCoverage=Te,this.declarationCoverage=xe}}e.$eO=ut;class vt{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,$e,Te=[]){this.executed=V,this.location=$e,this.branches=Te}}e.$fO=vt;class Tt{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,$e,Te){this.executed=V,this.location=$e,this.label=Te}}e.$gO=Tt;class Bi{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,$e,Te){this.name=V,this.executed=$e,this.location=Te}}e.$hO=Bi;var vn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var yn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Nn{constructor(V,$e,Te,xe,nt,ft){this.kind=V,this.name=$e,this.detail=Te,this.uri=xe,this.range=nt,this.selectionRange=ft}}e.$iO=Nn;class Tn{constructor(V){this.uri=V}}e.$jO=Tn;class jn{constructor(V,$e){this.original=V,this.modified=$e}}e.$kO=jn;class Fn{constructor(V,$e,Te,xe){this.base=V,this.input1=$e,this.input2=Te,this.result=xe}}e.$lO=Fn;class zn{constructor(V,$e){this.uri=V,this.viewType=$e}}e.$mO=zn;class Bn{constructor(V){this.viewType=V}}e.$nO=Bn;class Un{constructor(V,$e){this.uri=V,this.notebookType=$e}}e.$oO=Un;class Hn{constructor(V,$e,Te){this.original=V,this.modified=$e,this.notebookType=Te}}e.$pO=Hn;class Wn{constructor(){}}e.$qO=Wn;class Vn{constructor(V,$e){this.uri=V,this.inputBoxUri=$e}}e.$rO=Vn;class qn{constructor(V){this.providerId=V}}e.$sO=qn;class Gn{constructor(V){this.textDiffs=V}}e.$tO=Gn;var En;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Sn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var Dn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Kn{constructor(V,$e){this.label=V,this.values=$e}}e.$uO=Kn;var Cn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var Pn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class Jn{constructor(V){this.value=typeof V=="string"?new Fe(V):V}}e.$vO=Jn;class Qn{constructor(V,$e){this.value=V,this.baseUri=$e}}e.$wO=Qn;class Xn{constructor(V,$e){this.value=V,this.title=$e}}e.$xO=Xn;class Yn{constructor(V){this.value=V}}e.$yO=Yn;class Zn{constructor(V){this.value=V}}e.$zO=Zn;class xn{constructor(V){this.value=V}}e.$AO=xn;class _n{constructor(V,$e){this.uri=V,this.edits=Array.isArray($e)?$e:[$e]}}e.$BO=_n;class er{constructor(V,$e,Te,xe){this.prompt=V,this.command=$e,this.variables=Te,this.participant=xe}}e.$CO=er;class tr{constructor(V,$e,Te,xe){this.response=V,this.result=$e,this.participant=Te,this.command=xe}}e.$DO=tr;var In;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class ir{constructor(V){this.content=V}}e.$EO=ir;class nr{constructor(V,$e){this.content=V,this.name=$e}}e.$FO=nr;class rr{constructor(V,$e){this.content=V,this.name=$e}}e.$GO=rr;class Ii extends Error{static NotFound(V){return new Ii(V,Ii.NotFound.name)}static NoPermissions(V){return new Ii(V,Ii.NoPermissions.name)}constructor(V,$e,Te){super(V,{cause:Te}),this.name="LanguageModelError",this.code=$e??""}}e.$HO=Ii;var An;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(Rn||(e.SpeechToTextStatus=Rn={}));var Mn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class sr{constructor(V,$e){this.text=V,this.range=$e}}e.$IO=sr;var Ln;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(ke[323],Ee([1,0,6,8]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$xM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,p){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,p)??[]}getRelatedInformation(M,b,p){return this.c.$getAiRelatedInformation(b,p)}registerRelatedInformationProvider(M,b,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiRelatedInformationProvider(E,b),new O.$zM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Xjc=L}),define(ke[120],Ee([1,0,4,6,8,25,145,5,20]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$9jc=void 0,e.$9jc=(0,b.$ni)("IExtHostAuthentication");let E=class{constructor($){this.b=new Map,this.c=new u.$_d,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=$.getProxy(O.$xM.MainThreadAuthentication)}async getSession($,S,v,a={}){const m=R.$Im.toKey($.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${m} ${S} ${o}`,async()=>{await this.a.$ensureProvider(S);const n=$.displayName||$.name;return this.a.$getSession(S,v,m,n,a)})}async getSessions($,S,v){const a=R.$Im.toKey($.identifier),m=[...v].sort().join(" ");return await this.f.getOrCreate(`${a} ${m}`,async()=>{await this.a.$ensureProvider(S);const o=$.displayName||$.name;return this.a.$getSessions(S,v,a,o)})}async removeSession($,S){const v=this.b.get($);return v?v.provider.removeSession(S):this.a.$removeSession($,S)}registerAuthenticationProvider($,S,v,a){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:S,provider:v,options:a??{supportsMultipleAccounts:!1}});const m=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions($,o));return this.a.$registerAuthenticationProvider($,S,a?.supportsMultipleAccounts??!1),new L.$zM(()=>{m.dispose(),this.b.delete($),this.a.$unregisterAuthenticationProvider($)})}$createSession($,S,v){const a=this.b.get($);if(a)return Promise.resolve(a.provider.createSession(S,v));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,S){const v=this.b.get($);if(v)return Promise.resolve(v.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,S){const v=this.b.get($);if(v)return Promise.resolve(v.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,S){return $.startsWith(M.$zL)||this.c.fire({provider:{id:$,label:S}}),Promise.resolve()}};e.$0jc=E,e.$0jc=E=Je([We(0,p.$UO)],E);class A{constructor(){this.a=new Map}getOrCreate($,S){const v=this.a.get($);if(v)return v;const a=S().finally(()=>this.a.delete($));return this.a.set($,a),a}}}),define(ke[151],Ee([1,0,2,6,8,5,20,12,19,14,17,26]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$0kc=void 0;let S=class{static{$=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(O.$xM.MainThreadDecorations)}registerFileDecorationProvider(a,m){const o=$.c++;this.f.set(o,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,p.$3b)(i);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,E.$6e)(d.path,"/")})),t=(0,p.$zb)(s,(d,l)=>d.rank-l.rank||(0,E.$jf)(d.uri.path,l.uri.path)),f=[];e:for(const d of t){let l;for(const c of d){const h=(0,A.$nc)(c.uri.path);if(l!==h&&(l=h,f.push(c.uri)>=$.d))break e}}this.g.$onDidChange(o,f)});return new L.$zM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(a,m,o){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),o));if(!d)return;try{L.$YN.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$hG)(r,"codiconDecoration"),n[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$0kc=S,e.$0kc=S=$=Je([We(0,M.$UO),We(1,b.$Tj)],S),e.$$kc=(0,R.$ni)("IExtHostDecorations")}),define(ke[324],Ee([1,0,13,2,8,6,15,22,14]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class E{static{this.a=0}constructor(P,$,S){this.d=$,this.e=S,this.b=new Map,this.c=P.getProxy(R.$xM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,$){if(Object.keys(M.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const S=E.a++;this.b.set(S,$),this.c.$registerTextContentProvider(S,P);let v;if(typeof $.onDidChange=="function"){let a;v=$.onDidChange(async m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const o=this.$provideTextDocumentContent(S,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const r=(0,p.$df)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{a===o&&(a=void 0)});a=o})}return new L.$zM(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,$){const S=this.b.get(P);return S?Promise.resolve(S.provideTextDocumentContent(O.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$alc=E}),define(ke[152],Ee([1,0,62,15,14,183,129,8,19]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=void 0,e.$WO=A;const E=new Map;function A(v,a){a?E.set(v,a):E.delete(v)}function P(v){return E.get(v)}class $ extends R.$Mv{constructor(a,m,o,n,i,r,s){super(m,o,n,i),this.c=a,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,p.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===O.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,o){return a.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,u.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,u.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,n=m.start.line,i=m.end.line,r=[];r.push(this.f[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,m.end.character)),r.join(o)}t(a){let m;if(a instanceof b.$AM?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new S(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),o=this.f[m.index].length;return new b.$AM(m.index,Math.min(m.remainder,o))}w(a){if(!(a instanceof b.$BM))throw new Error("Invalid argument");const m=this.x(a.start),o=this.x(a.end);return m===a.start&&o===a.end?a:new b.$BM(m.line,m.character,o.line,o.character)}x(a){if(!(a instanceof b.$AM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:o}=a,n=!1;if(m<0)m=0,o=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,n=!0;else{const i=this.f[m].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$AM(m,o):a}y(a,m){const o=this.x(a);if(!m)m=P(this.m);else if((0,L.$cf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,M.$Ws)(o.character+1,(0,M.$Us)(m),this.f[o.line],0);if(n)return new b.$BM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$XO=$;class S{constructor(a,m,o){this.a=a,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$BM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$BM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YO=S}),define(ke[325],Ee([1,0,6,8]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$xM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const A=await E.provideEmbeddingVector(b,p);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,b,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiEmbeddingVectorProvider(b,E),new O.$zM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$clc=L}),define(ke[69],Ee([1,0,6,32,8,21,5,20,60,3,7,23,15]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0;let v=S=class{constructor(m,o){this.b=new Map,this.c=new A.$wh,this.a=m.getProxy(u.$xM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===O.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return S.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return S.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return S.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$ze.wrap(r))}catch(s){return S.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return S.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return S.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return S.e(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(m,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await m.stat(n)).type&O.FileType.Directory))throw L.$PN.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(O.$0k(r)!==O.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(O.$0k(s)!==O.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof L.$PN)throw m;if(m instanceof O.$6k)switch(m.code){case O.FileSystemProviderErrorCode.FileExists:throw L.$PN.FileExists(m.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$PN.FileNotFound(m.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$PN.FileNotADirectory(m.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$PN.FileIsADirectory(m.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$PN.NoPermissions(m.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$PN.Unavailable(m.message);default:throw new L.$PN(m.message,m.name)}if(!(m instanceof Error))throw new L.$PN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw L.$PN.Unavailable(m.message);switch(m.name){case O.FileSystemProviderErrorCode.FileExists:throw L.$PN.FileExists(m.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$PN.FileNotFound(m.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$PN.FileNotADirectory(m.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$PN.FileIsADirectory(m.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$PN.NoPermissions(m.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$PN.Unavailable(m.message);default:throw new L.$PN(m.message,m.name)}}addFileSystemProvider(m,o,n){return this.b.set(m,{impl:o,extUri:n?.isCaseSensitive?P.$Qg:P.$Sg,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??P.$Qg}};e.$pkc=v,e.$pkc=v=S=Je([We(0,b.$UO),We(1,p.$3jc)],v),e.$qkc=(0,M.$ni)("IExtHostConsumerFileSystem")}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0,e.$rkc=(0,u.$ni)("IExtensionStoragePaths");let b=class{constructor(E,A,P){this.d=A,this.f=P,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then($=>this.c=$)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,A=await this.g(E);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$skc=b,e.$skc=b=Je([We(0,O.$$O),We(1,L.$Tj),We(2,R.$qkc)],b)}),define(ke[326],Ee([1,0,8,20,4]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;let R=class{constructor(b){this.a=new u.$ZN(u.ColorThemeKind.Dark),this.b=new L.$_d}get activeColorTheme(){return this.a}$onColorThemeChange(b){let p;switch(b){case"light":p=u.ColorThemeKind.Light;break;case"hcDark":p=u.ColorThemeKind.HighContrast;break;case"hcLight":p=u.ColorThemeKind.HighContrastLight;break;default:p=u.ColorThemeKind.Dark}this.a=new u.$ZN(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Vlc=R,e.$Vlc=R=Je([We(0,O.$UO)],R)}),define(ke[70],Ee([1,0,22,4,3,229,5,12,88,6,28,20,8]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fCb=e.$eCb=e.TunnelDtoConverter=void 0;class S extends p.$_v{}var v;(function(m){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$eCb=(0,M.$ni)("IExtHostTunnelService");let a=class extends L.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$_d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$xM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const r=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new $.$zM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async c=>{let h;try{h=await l.provider.providePortAttributes({port:c,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(c,i,r,s)}return{providedAttributes:h,port:c}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await o.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$fCb=a,e.$fCb=a=Je([We(0,P.$UO),We(1,A.$$O),We(2,b.$Tj)],a)}),define(ke[16],Ee([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,289,119,68,89,301,26,8]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f,d,l,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$RO=B,e.$SO=Z,e.$TO=ee;var g;(function(Oe){function ze(_){const{selectionStartLineNumber:Ne,selectionStartColumn:qe,positionLineNumber:_e,positionColumn:Ye}=_,ct=new h.$AM(Ne-1,qe-1),yt=new h.$AM(_e-1,Ye-1);return new h.$CM(ct,yt)}Oe.to=ze;function ve(_){const{anchor:Ne,active:qe}=_;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Oe.from=ve})(g||(e.Selection=g={}));var D;(function(Oe){function ze(_){if(!_)return;const{start:Ne,end:qe}=_;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Oe.from=ze;function ve(_){if(!_)return;const{startLineNumber:Ne,startColumn:qe,endLineNumber:_e,endColumn:Ye}=_;return new h.$BM(Ne-1,qe-1,_e-1,Ye-1)}Oe.to=ve})(D||(e.Range=D={}));var w;(function(Oe){function ze(_){return{uri:_.uri,range:D.from(_.range)}}Oe.from=ze;function ve(_){return new h.$LM(a.URI.revive(_.uri),D.to(_.range))}Oe.to=ve})(w||(e.Location=w={}));var k;(function(Oe){function ze(ve){switch(ve){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Oe.to=ze})(k||(e.TokenType=k={}));var y;(function(Oe){function ze(_){return new h.$AM(_.lineNumber-1,_.column-1)}Oe.to=ze;function ve(_){return{lineNumber:_.line+1,column:_.character+1}}Oe.from=ve})(y||(e.Position=y={}));var C;(function(Oe){function ze(Ne,qe,_e){return(0,u.$Hb)((0,u.$3b)(Ne).map(Ye=>ve(Ye,qe,_e)))}Oe.from=ze;function ve(Ne,qe,_e){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:_e?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:_(Ne.scheme,qe),pattern:Ie.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:_e?.isBuiltin}}function _(Ne,qe){return qe&&typeof Ne=="string"?qe.transformOutgoingScheme(Ne):Ne}})(C||(e.DocumentSelector=C={}));var I;(function(Oe){function ze(_){switch(_){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Oe.from=ze;function ve(_){switch(_){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Oe.to=ve})(I||(e.DiagnosticTag=I={}));var z;(function(Oe){function ze(_){let Ne;return _.code&&((0,v.$1f)(_.code)||(0,v.$5f)(_.code)?Ne=String(_.code):Ne={value:String(_.code.value),target:_.code.target}),{...D.from(_.range),message:_.message,source:_.source,code:Ne,severity:F.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(j.from),tags:Array.isArray(_.tags)?(0,u.$Hb)(_.tags.map(I.from)):void 0}}Oe.from=ze;function ve(_){const Ne=new h.$NM(D.to(_),_.message,F.to(_.severity));return Ne.source=_.source,Ne.code=(0,v.$1f)(_.code)?_.code:_.code?.value,Ne.relatedInformation=_.relatedInformation&&_.relatedInformation.map(j.to),Ne.tags=_.tags&&(0,u.$Hb)(_.tags.map(I.to)),Ne}Oe.to=ve})(z||(e.Diagnostic=z={}));var j;(function(Oe){function ze(_){return{...D.from(_.location.range),message:_.message,resource:_.location.uri}}Oe.from=ze;function ve(_){return new h.$MM(new h.$LM(_.resource,D.to(_)),_.message)}Oe.to=ve})(j||(e.DiagnosticRelatedInformation=j={}));var F;(function(Oe){function ze(_){switch(_){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=ze;function ve(_){switch(_){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Oe.to=ve})(F||(e.DiagnosticSeverity=F={}));var N;(function(Oe){function ze(_){return typeof _=="number"&&_>=h.ViewColumn.One?_-1:_===h.ViewColumn.Beside?l.$LD:l.$KD}Oe.from=ze;function ve(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=ve})(N||(e.ViewColumn=N={}));function T(Oe){return typeof Oe.range<"u"}function B(Oe){return Oe.length===0?!0:!!T(Oe[0])}var H;(function(Oe){function ze(Ye){return Ye.map(Oe.from)}Oe.fromMany=ze;function ve(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function _(Ye){let ct;if(ve(Ye)){const{language:Lt,value:lt}=Ye;ct={value:"```"+Lt+`
`+lt+"\n```\n"}}else h.$1M.isMarkdownString(Ye)?ct={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?ct={value:Ye}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const Kt=Lt=>{try{let lt=a.URI.parse(Lt,!0);lt=lt.with({query:Ne(lt.query,yt)}),yt[Lt]=lt}catch{}return""},_t=new p.marked.Renderer;return _t.link=Kt,_t.image=Lt=>typeof Lt=="string"?Kt(M.$Sk(Lt).href):"",(0,p.marked)(ct.value,{renderer:_t}),ct}Oe.from=_;function Ne(Ye,ct){if(!Ye)return Ye;let yt;try{yt=(0,E.$Vh)(Ye)}catch{}if(!yt)return Ye;let Kt=!1;return yt=(0,P.$Vn)(yt,_t=>{if(a.URI.isUri(_t)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Lt]=_t,Kt=!0,Lt}else return}),Kt?JSON.stringify(yt):Ye}function qe(Ye){const ct=new h.$1M(Ye.value,Ye.supportThemeIcons);return ct.isTrusted=Ye.isTrusted,ct.supportHtml=Ye.supportHtml,ct.baseUri=Ye.baseUri?a.URI.from(Ye.baseUri):void 0,ct}Oe.to=qe;function _e(Ye){if(Ye)return typeof Ye=="string"?Ye:Oe.from(Ye)}Oe.fromStrict=_e})(H||(e.MarkdownString=H={}));function Z(Oe){return B(Oe)?Oe.map(ze=>({range:D.from(ze.range),hoverMessage:Array.isArray(ze.hoverMessage)?H.fromMany(ze.hoverMessage):ze.hoverMessage?H.from(ze.hoverMessage):void 0,renderOptions:ze.renderOptions})):Oe.map(ze=>({range:D.from(ze)}))}function ee(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?a.URI.file(Oe):Oe}var J;(function(Oe){function ze(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?ee(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Oe.from=ze})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var Y;(function(Oe){function ze(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?ee(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?J.from(ve.before):void 0,after:ve.after?J.from(ve.after):void 0}}Oe.from=ze})(Y||(e.ThemableDecorationRenderOptions=Y={}));var re;(function(Oe){function ze(ve){if(typeof ve>"u")return ve;switch(ve){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=ze})(re||(e.DecorationRangeBehavior=re={}));var te;(function(Oe){function ze(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?re.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?Y.from(ve.light):void 0,dark:ve.dark?Y.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?ee(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?J.from(ve.before):void 0,after:ve.after?J.from(ve.after):void 0}}Oe.from=ze})(te||(e.DecorationRenderOptions=te={}));var pe;(function(Oe){function ze(_){return{text:_.newText,eol:_.newEol&&Ge.from(_.newEol),range:D.from(_.range)}}Oe.from=ze;function ve(_){const Ne=new h.$GM(D.to(_.range),_.text);return Ne.newEol=typeof _.eol>"u"?void 0:Ge.to(_.eol),Ne}Oe.to=ve})(pe||(e.TextEdit=pe={}));var Ce;(function(Oe){function ze(_,Ne){const qe={edits:[]};if(_ instanceof h.$JM){const _e=new b.$Cc;for(const Ye of _._allEntries())Ye._type===1&&a.URI.isUri(Ye.to)&&Ye.from===void 0&&_e.add(Ye.to);for(const Ye of _._allEntries())if(Ye._type===1){let ct;Ye.options?.contents&&(ArrayBuffer.isView(Ye.options.contents)?ct={type:"base64",value:(0,O.$Te)(O.$ze.wrap(Ye.options.contents))}:ct={type:"dataTransferItem",id:Ye.options.contents._itemId}),qe.edits.push({oldResource:Ye.from,newResource:Ye.to,options:{...Ye.options,contents:ct},metadata:Ye.metadata})}else Ye._type===2?qe.edits.push({resource:Ye.uri,textEdit:pe.from(Ye.edit),versionId:_e.has(Ye.uri)?void 0:Ne?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===6?qe.edits.push({resource:Ye.uri,textEdit:{range:D.from(Ye.range),text:Ye.edit.value,insertAsSnippet:!0},versionId:_e.has(Ye.uri)?void 0:Ne?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===3?qe.edits.push({metadata:Ye.metadata,resource:Ye.uri,cellEdit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ye.uri)}):Ye._type===5&&qe.edits.push({metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ye.uri),cellEdit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(Qt.from)}})}return qe}Oe.from=ze;function ve(_){const Ne=new h.$JM,qe=new b.$Bc;for(const _e of _.edits)if(_e.textEdit){const Ye=_e,ct=a.URI.revive(Ye.resource),yt=D.to(Ye.textEdit.range),Kt=Ye.textEdit.text,_t=Ye.textEdit.insertAsSnippet;let Lt;_t?Lt=h.$IM.replace(yt,new h.$KM(Kt)):Lt=h.$GM.replace(yt,Kt);const lt=qe.get(ct);lt?lt.push(Lt):qe.set(ct,[Lt])}else Ne.renameFile(a.URI.revive(_e.oldResource),a.URI.revive(_e.newResource),_e.options);for(const[_e,Ye]of qe)Ne.set(_e,Ye);return Ne}Oe.to=ve})(Ce||(e.WorkspaceEdit=Ce={}));var x;(function(Oe){const ze=Object.create(null);ze[h.SymbolKind.File]=0,ze[h.SymbolKind.Module]=1,ze[h.SymbolKind.Namespace]=2,ze[h.SymbolKind.Package]=3,ze[h.SymbolKind.Class]=4,ze[h.SymbolKind.Method]=5,ze[h.SymbolKind.Property]=6,ze[h.SymbolKind.Field]=7,ze[h.SymbolKind.Constructor]=8,ze[h.SymbolKind.Enum]=9,ze[h.SymbolKind.Interface]=10,ze[h.SymbolKind.Function]=11,ze[h.SymbolKind.Variable]=12,ze[h.SymbolKind.Constant]=13,ze[h.SymbolKind.String]=14,ze[h.SymbolKind.Number]=15,ze[h.SymbolKind.Boolean]=16,ze[h.SymbolKind.Array]=17,ze[h.SymbolKind.Object]=18,ze[h.SymbolKind.Key]=19,ze[h.SymbolKind.Null]=20,ze[h.SymbolKind.EnumMember]=21,ze[h.SymbolKind.Struct]=22,ze[h.SymbolKind.Event]=23,ze[h.SymbolKind.Operator]=24,ze[h.SymbolKind.TypeParameter]=25;function ve(Ne){return typeof ze[Ne]=="number"?ze[Ne]:6}Oe.from=ve;function _(Ne){for(const qe in ze)if(ze[qe]===Ne)return Number(qe);return h.SymbolKind.Property}Oe.to=_})(x||(e.SymbolKind=x={}));var U;(function(Oe){function ze(_){switch(_){case h.SymbolTag.Deprecated:return 1}}Oe.from=ze;function ve(_){switch(_){case 1:return h.SymbolTag.Deprecated}}Oe.to=ve})(U||(e.SymbolTag=U={}));var ne;(function(Oe){function ze(_){return{name:_.name,kind:x.from(_.kind),tags:_.tags&&_.tags.map(U.from),containerName:_.containerName,location:se.from(_.location)}}Oe.from=ze;function ve(_){const Ne=new h.$RM(_.name,x.to(_.kind),_.containerName,se.to(_.location));return Ne.tags=_.tags&&_.tags.map(U.to),Ne}Oe.to=ve})(ne||(e.WorkspaceSymbol=ne={}));var be;(function(Oe){function ze(_){const Ne={name:_.name||"!!MISSING: name!!",detail:_.detail,range:D.from(_.range),selectionRange:D.from(_.selectionRange),kind:x.from(_.kind),tags:_.tags?.map(U.from)??[]};return _.children&&(Ne.children=_.children.map(ze)),Ne}Oe.from=ze;function ve(_){const Ne=new h.$SM(_.name,_.detail,x.to(_.kind),D.to(_.range),D.to(_.selectionRange));return(0,u.$Lb)(_.tags)&&(Ne.tags=_.tags.map(U.to)),_.children&&(Ne.children=_.children.map(ve)),Ne}Oe.to=ve})(be||(e.DocumentSymbol=be={}));var De;(function(Oe){function ze(_){const Ne=new h.$WM(x.to(_.kind),_.name,_.detail||"",a.URI.revive(_.uri),D.to(_.range),D.to(_.selectionRange));return Ne._sessionId=_._sessionId,Ne._itemId=_._itemId,Ne}Oe.to=ze;function ve(_,Ne,qe){if(Ne=Ne??_._sessionId,qe=qe??_._itemId,Ne===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:qe,name:_.name,detail:_.detail,kind:x.from(_.kind),uri:_.uri,range:D.from(_.range),selectionRange:D.from(_.selectionRange),tags:_.tags?.map(U.from)}}Oe.from=ve})(De||(e.CallHierarchyItem=De={}));var ae;(function(Oe){function ze(ve){return new h.$XM(De.to(ve.from),ve.fromRanges.map(_=>D.to(_)))}Oe.to=ze})(ae||(e.CallHierarchyIncomingCall=ae={}));var ce;(function(Oe){function ze(ve){return new h.$YM(De.to(ve.to),ve.fromRanges.map(_=>D.to(_)))}Oe.to=ze})(ce||(e.CallHierarchyOutgoingCall=ce={}));var se;(function(Oe){function ze(_){return{range:_.range&&D.from(_.range),uri:_.uri}}Oe.from=ze;function ve(_){return new h.$LM(a.URI.revive(_.uri),D.to(_.range))}Oe.to=ve})(se||(e.location=se={}));var K;(function(Oe){function ze(_){const Ne=_,qe=_;return{originSelectionRange:Ne.originSelectionRange?D.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:qe.uri,range:D.from(Ne.targetRange?Ne.targetRange:qe.range),targetSelectionRange:Ne.targetSelectionRange?D.from(Ne.targetSelectionRange):void 0}}Oe.from=ze;function ve(_){return{targetUri:a.URI.revive(_.uri),targetRange:D.to(_.range),targetSelectionRange:_.targetSelectionRange?D.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?D.to(_.originSelectionRange):void 0}}Oe.to=ve})(K||(e.DefinitionLink=K={}));var ie;(function(Oe){function ze(_){return{range:D.from(_.range),contents:H.fromMany(_.contents)}}Oe.from=ze;function ve(_){return new h.$OM(_.contents.map(H.to),D.to(_.range))}Oe.to=ve})(ie||(e.Hover=ie={}));var le;(function(Oe){function ze(_){return{range:D.from(_.range),expression:_.expression}}Oe.from=ze;function ve(_){return new h.$JN(D.to(_.range),_.expression)}Oe.to=ve})(le||(e.EvaluatableExpression=le={}));var de;(function(Oe){function ze(_){if(_ instanceof h.$KN)return{type:"text",range:D.from(_.range),text:_.text};if(_ instanceof h.$LN)return{type:"variable",range:D.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof h.$MN)return{type:"expression",range:D.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=ze;function ve(_){switch(_.type){case"text":return{range:D.to(_.range),text:_.text};case"variable":return{range:D.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:D.to(_.range),expression:_.expression}}}Oe.to=ve})(de||(e.InlineValue=de={}));var Ae;(function(Oe){function ze(_){return{frameId:_.frameId,stoppedLocation:D.from(_.stoppedLocation)}}Oe.from=ze;function ve(_){return new h.$NN(_.frameId,D.to(_.stoppedLocation))}Oe.to=ve})(Ae||(e.InlineValueContext=Ae={}));var me;(function(Oe){function ze(_){return{range:D.from(_.range),kind:_.kind}}Oe.from=ze;function ve(_){return new h.$PM(D.to(_.range),_.kind)}Oe.to=ve})(me||(e.DocumentHighlight=me={}));var Pe;(function(Oe){function ze(_){return{uri:_.uri,highlights:_.highlights.map(me.from)}}Oe.from=ze;function ve(_){return new h.$QM(a.URI.revive(_.uri),_.highlights.map(me.to))}Oe.to=ve})(Pe||(e.MultiDocumentHighlight=Pe={}));var Me;(function(Oe){function ze(ve){switch(ve){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Oe.to=ze})(Me||(e.CompletionTriggerKind=Me={}));var je;(function(Oe){function ze(ve){return{triggerKind:Me.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Oe.to=ze})(je||(e.CompletionContext=je={}));var q;(function(Oe){function ze(_){switch(_){case h.CompletionItemTag.Deprecated:return 1}}Oe.from=ze;function ve(_){switch(_){case 1:return h.CompletionItemTag.Deprecated}}Oe.to=ve})(q||(e.CompletionItemTag=q={}));var W;(function(Oe){const ze=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ve(qe){return ze.get(qe)??9}Oe.from=ve;const _=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ne(qe){return _.get(qe)??h.CompletionItemKind.Property}Oe.to=Ne})(W||(e.CompletionItemKind=W={}));var X;(function(Oe){function ze(ve,_){const Ne=new h.$7M(ve.label);return Ne.insertText=ve.insertText,Ne.kind=W.to(ve.kind),Ne.tags=ve.tags?.map(q.to),Ne.detail=ve.detail,Ne.documentation=M.$Mk(ve.documentation)?H.to(ve.documentation):ve.documentation,Ne.sortText=ve.sortText,Ne.filterText=ve.filterText,Ne.preselect=ve.preselect,Ne.commitCharacters=ve.commitCharacters,m.$ht.isIRange(ve.range)?Ne.range=D.to(ve.range):typeof ve.range=="object"&&(Ne.range={inserting:D.to(ve.range.insert),replacing:D.to(ve.range.replace)}),Ne.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Ne.insertText=new h.$KM(ve.insertText):(Ne.insertText=ve.insertText,Ne.textEdit=Ne.range instanceof h.$BM?new h.$GM(Ne.range,Ne.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Ne.additionalTextEdits=ve.additionalTextEdits.map(qe=>pe.to(qe))),Ne.command=_&&ve.command?_.fromInternal(ve.command):void 0,Ne}Oe.to=ze})(X||(e.CompletionItem=X={}));var Q;(function(Oe){function ze(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:H.fromStrict(_.documentation)}}Oe.from=ze;function ve(_){return{label:_.label,documentation:M.$Mk(_.documentation)?H.to(_.documentation):_.documentation}}Oe.to=ve})(Q||(e.ParameterInformation=Q={}));var fe;(function(Oe){function ze(_){return{label:_.label,documentation:H.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(Q.from):[],activeParameter:_.activeParameter}}Oe.from=ze;function ve(_){return{label:_.label,documentation:M.$Mk(_.documentation)?H.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(Q.to):[],activeParameter:_.activeParameter}}Oe.to=ve})(fe||(e.SignatureInformation=fe={}));var we;(function(Oe){function ze(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(fe.from):[]}}Oe.from=ze;function ve(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(fe.to):[]}}Oe.to=ve})(we||(e.SignatureHelp=we={}));var Fe;(function(Oe){function ze(ve,_){const Ne=new h.$6M(y.to(_.position),typeof _.label=="string"?_.label:_.label.map(Ve.to.bind(void 0,ve)),_.kind&&Ze.to(_.kind));return Ne.textEdits=_.textEdits&&_.textEdits.map(pe.to),Ne.tooltip=M.$Mk(_.tooltip)?H.to(_.tooltip):_.tooltip,Ne.paddingLeft=_.paddingLeft,Ne.paddingRight=_.paddingRight,Ne}Oe.to=ze})(Fe||(e.InlayHint=Fe={}));var Ve;(function(Oe){function ze(ve,_){const Ne=new h.$5M(_.label);return Ne.tooltip=M.$Mk(_.tooltip)?H.to(_.tooltip):_.tooltip,o.Command.is(_.command)&&(Ne.command=ve.fromInternal(_.command)),_.location&&(Ne.location=se.to(_.location)),Ne}Oe.to=ze})(Ve||(e.InlayHintLabelPart=Ve={}));var Ze;(function(Oe){function ze(_){return _}Oe.from=ze;function ve(_){return _}Oe.to=ve})(Ze||(e.InlayHintKind=Ze={}));var tt;(function(Oe){function ze(_){return{range:D.from(_.range),url:_.target,tooltip:_.tooltip}}Oe.from=ze;function ve(_){let Ne;if(_.url)try{Ne=typeof _.url=="string"?a.URI.parse(_.url,!0):a.URI.revive(_.url)}catch{}return new h.$_M(D.to(_.range),Ne)}Oe.to=ve})(tt||(e.DocumentLink=tt={}));var st;(function(Oe){function ze(_){const Ne=new h.$cN(_.label);return _.textEdit&&(Ne.textEdit=pe.to(_.textEdit)),_.additionalTextEdits&&(Ne.additionalTextEdits=_.additionalTextEdits.map(qe=>pe.to(qe))),Ne}Oe.to=ze;function ve(_){return{label:_.label,textEdit:_.textEdit?pe.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Ne=>pe.from(Ne)):void 0}}Oe.from=ve})(st||(e.ColorPresentation=st={}));var at;(function(Oe){function ze(_){return new h.$aN(_[0],_[1],_[2],_[3])}Oe.to=ze;function ve(_){return[_.red,_.green,_.blue,_.alpha]}Oe.from=ve})(at||(e.Color=at={}));var ot;(function(Oe){function ze(_){return{range:D.from(_.range)}}Oe.from=ze;function ve(_){return new h.$VM(D.to(_.range))}Oe.to=ve})(ot||(e.SelectionRange=ot={}));var Se;(function(Oe){function ze(ve){switch(ve){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Oe.to=ze})(Se||(e.TextDocumentSaveReason=Se={}));var Be;(function(Oe){function ze(_){switch(_){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=ze;function ve(_){switch(_){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Oe.to=ve})(Be||(e.TextEditorLineNumbersStyle=Be={}));var Ge;(function(Oe){function ze(_){if(_===h.EndOfLine.CRLF)return 1;if(_===h.EndOfLine.LF)return 0}Oe.from=ze;function ve(_){if(_===1)return h.EndOfLine.CRLF;if(_===0)return h.EndOfLine.LF}Oe.to=ve})(Ge||(e.EndOfLine=Ge={}));var Le;(function(Oe){function ze(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=ze})(Le||(e.ProgressLocation=Le={}));var Qe;(function(Oe){function ze(_){const Ne={start:_.start+1,end:_.end+1};return _.kind&&(Ne.kind=oe.from(_.kind)),Ne}Oe.from=ze;function ve(_){const Ne={start:_.start-1,end:_.end-1};return _.kind&&(Ne.kind=oe.to(_.kind)),Ne}Oe.to=ve})(Qe||(e.FoldingRange=Qe={}));var oe;(function(Oe){function ze(_){if(_)switch(_){case h.FoldingRangeKind.Comment:return o.$3t.Comment;case h.FoldingRangeKind.Imports:return o.$3t.Imports;case h.FoldingRangeKind.Region:return o.$3t.Region}}Oe.from=ze;function ve(_){if(_)switch(_.value){case o.$3t.Comment.value:return h.FoldingRangeKind.Comment;case o.$3t.Imports.value:return h.FoldingRangeKind.Imports;case o.$3t.Region.value:return h.FoldingRangeKind.Region}}Oe.to=ve})(oe||(e.FoldingRangeKind=oe={}));var ue;(function(Oe){function ze(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?D.from(ve.selection):void 0,override:typeof ve.override=="boolean"?r.$bF.id:void 0}}Oe.from=ze})(ue||(e.TextEditorOpenOptions=ue={}));var Ie;(function(Oe){function ze(qe){return qe instanceof h.$xN?qe.toJSON():typeof qe=="string"?qe:ve(qe)||_(qe)?new h.$xN(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Oe.from=ze;function ve(qe){const _e=qe;return _e?a.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function _(qe){const _e=qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(qe){return typeof qe=="string"?qe:new h.$xN(a.URI.revive(qe.baseUri),qe.pattern)}Oe.to=Ne})(Ie||(e.GlobPattern=Ie={}));var Ke;(function(Oe){function ze(ve){if(ve){if(Array.isArray(ve))return ve.map(ze);if(typeof ve=="string")return ve;{const _=ve;return{language:_.language,scheme:_.scheme,pattern:Ie.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Oe.from=ze})(Ke||(e.LanguageSelector=Ke={}));var Re;(function(Oe){function ze(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&a.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(_e=>_e instanceof h.$BM)))}Oe.is=ze;function ve(_){return{documents:_.documents.map(Ne=>Ne.map(qe=>({uri:a.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>D.from(_e))})))}}Oe.from=ve})(Re||(e.MappedEditsContext=Re={}));var it;(function(Oe){function ze(_){return{start:_.start,end:_.end}}Oe.from=ze;function ve(_){return new h.$1N(_.start,_.end)}Oe.to=ve})(it||(e.NotebookRange=it={}));var ht;(function(Oe){function ze(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Oe.to=ze;function ve(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Oe.from=ve})(ht||(e.NotebookCellExecutionSummary=ht={}));var wt;(function(Oe){function ze(ve){if(ve===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ve===t.NotebookCellExecutionState.Pending)return;if(ve===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Oe.to=ze})(wt||(e.NotebookCellExecutionState=wt={}));var It;(function(Oe){function ze(_){switch(_){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Oe.from=ze;function ve(_){switch(_){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Oe.to=ve})(It||(e.NotebookCellKind=It={}));var Bt;(function(Oe){function ze(_){const Ne={metadata:_.metadata??Object.create(null),cells:[]};for(const qe of _.cells)h.$2N.validate(qe),Ne.cells.push(Qt.from(qe));return Ne}Oe.from=ze;function ve(_){const Ne=new h.$3N(_.cells.map(Qt.to));return(0,v.$bg)(_.metadata)||(Ne.metadata=_.metadata),Ne}Oe.to=ve})(Bt||(e.NotebookData=Bt={}));var Qt;(function(Oe){function ze(_){return{cellKind:It.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:ht.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(Dt.from):[]}}Oe.from=ze;function ve(_){return new h.$2N(It.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(Dt.to):void 0,_.metadata,_.internalMetadata?ht.to(_.internalMetadata):void 0)}Oe.to=ve})(Qt||(e.NotebookCellData=Qt={}));var ei;(function(Oe){function ze(_){return{mime:_.mime,valueBytes:O.$ze.wrap(_.data)}}Oe.from=ze;function ve(_){return new h.$4N(_.valueBytes.buffer,_.mime)}Oe.to=ve})(ei||(e.NotebookCellOutputItem=ei={}));var Dt;(function(Oe){function ze(_){return{outputId:_.id,items:_.items.map(ei.from),metadata:_.metadata}}Oe.from=ze;function ve(_){const Ne=_.items.map(ei.to);return new h.$5N(Ne,_.outputId,_.metadata)}Oe.to=ve})(Dt||(e.NotebookCellOutput=Dt={}));var Vt;(function(Oe){function ze(Ne){return _(Ne)?{include:Ie.from(Ne.include)??void 0,exclude:Ie.from(Ne.exclude)??void 0}:Ie.from(Ne)??void 0}Oe.from=ze;function ve(Ne){return _(Ne)?{include:Ie.to(Ne.include),exclude:Ie.to(Ne.exclude)}:Ie.to(Ne)}Oe.to=ve;function _(Ne){const qe=Ne;return qe?!(0,v.$0f)(qe.include)&&!(0,v.$0f)(qe.exclude):!1}})(Vt||(e.NotebookExclusiveDocumentPattern=Vt={}));var Xt;(function(Oe){function ze(ve,_,Ne){const qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(qe,Ne),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Oe.from=ze})(Xt||(e.NotebookStatusBarItem=Xt={}));var et;(function(Oe){function ze(ve,_,Ne){const qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:_.toInternal(qe,Ne),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Oe.from=ze})(et||(e.NotebookKernelSourceAction=et={}));var ai;(function(Oe){function ze(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Oe.from=ze})(ai||(e.NotebookDocumentContentOptions=ai={}));var ti;(function(Oe){function ze(_){return{uri:_.uri,provides:_.provides}}Oe.from=ze;function ve(_){return new h.$7N(a.URI.revive(_.uri),_.provides)}Oe.to=ve})(ti||(e.NotebookRendererScript=ti={}));var ii;(function(Oe){function ze(_){return{message:H.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:D.from(_.location.range),uri:_.location.uri}}}Oe.from=ze;function ve(_){const Ne=new h.$aO(typeof _.message=="string"?_.message:H.to(_.message));return Ne.actualOutput=_.actual,Ne.expectedOutput=_.expected,Ne.contextValue=_.contextValue,Ne.location=_.location?se.to(_.location):void 0,Ne}Oe.to=ve})(ii||(e.TestMessage=ii={}));var dt;(function(Oe){Oe.namespace=d.$oL,Oe.denamespace=d.$pL})(dt||(e.TestTag=dt={}));var bt;(function(Oe){function ze(_){const Ne=(0,i.$QO)(_).controllerId;return{extId:f.$jL.fromExtHostTestItem(_,Ne).toString(),label:_.label,uri:a.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(qe=>dt.namespace(Ne,qe.id)),range:m.$ht.lift(D.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&H.fromStrict(_.error)||null}}Oe.from=ze;function ve(_){return{parent:void 0,error:void 0,id:f.$jL.fromString(_.extId).localId,label:_.label,uri:a.URI.revive(_.uri),tags:(_.tags||[]).map(Ne=>{const{tagId:qe}=dt.denamespace(Ne);return new h.$bO(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Oe.toPlain=ve})(bt||(e.TestItem=bt={})),function(Oe){function ze(_){return{id:_.id}}Oe.from=ze;function ve(_){return new h.$bO(_.id)}Oe.to=ve}(dt||(e.TestTag=dt={}));var si;(function(Oe){const ze=(_,Ne)=>{const qe=_.value;if(!qe)return;const _e={...bt.toPlain(qe.item),parent:Ne,taskStates:qe.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(ct=>ct.type===0).map(ii.to)})),children:[]};if(_.children)for(const Ye of _.children.values()){const ct=ze(Ye,_e);ct&&_e.children.push(ct)}return _e};function ve(_){const Ne=new $.$JO;for(const Ye of _.items)Ne.insert(f.$jL.fromString(Ye.item.extId).path,Ye);const qe=[Ne.nodes],_e=[];for(;qe.length;)for(const Ye of qe.pop())Ye.value?_e.push(Ye):Ye.children&&qe.push(Ye.children.values());return{completedAt:_.completedAt,results:_e.map(Ye=>ze(Ye)).filter(v.$9f)}}Oe.to=ve})(si||(e.TestResults=si={}));var ni;(function(Oe){function ze(qe){return{covered:qe.covered,total:qe.total}}function ve(qe){return"line"in qe?y.from(qe):D.from(qe)}function _(qe){if(typeof qe.executed=="number"&&qe.executed<0)throw new Error(`Invalid coverage count ${qe.executed}`);return"branches"in qe?{count:qe.executed,location:ve(qe.location),type:1,branches:qe.branches.length?qe.branches.map(_e=>({count:_e.executed,location:_e.location&&ve(_e.location),label:_e.label})):void 0}:{type:0,name:qe.name,count:qe.executed,location:ve(qe.location)}}Oe.fromDetails=_;function Ne(qe,_e){return h.$dO(_e.statementCoverage),h.$dO(_e.branchCoverage),h.$dO(_e.declarationCoverage),{id:qe,uri:_e.uri,statement:ze(_e.statementCoverage),branch:_e.branchCoverage&&ze(_e.branchCoverage),declaration:_e.declarationCoverage&&ze(_e.declarationCoverage)}}Oe.fromFile=Ne})(ni||(e.TestCoverage=ni={}));var Ot;(function(Oe){function ze(ve){switch(ve){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Oe.to=ze})(Ot||(e.CodeActionTriggerKind=Ot={}));var mt;(function(Oe){function ze(_){const Ne=new h.$iO(x.to(_.kind),_.name,_.detail||"",a.URI.revive(_.uri),D.to(_.range),D.to(_.selectionRange));return Ne._sessionId=_._sessionId,Ne._itemId=_._itemId,Ne}Oe.to=ze;function ve(_,Ne,qe){if(Ne=Ne??_._sessionId,qe=qe??_._itemId,Ne===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:qe,kind:x.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:D.from(_.range),selectionRange:D.from(_.selectionRange),tags:_.tags?.map(U.from)}}Oe.from=ve})(mt||(e.TypeHierarchyItem=mt={}));var Rt;(function(Oe){function ze(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Oe.from=ze})(Rt||(e.ViewBadge=Rt={}));var qt;(function(Oe){function ze(qe,_e,Ye){const ct=_e.fileData;return ct?new h.$pN(new h.$qN(ct.name,a.URI.revive(ct.uri),ct.id,(0,R.$db)(()=>Ye(ct.id)))):qe===A.$Es.uriList&&_e.uriListData?new h.$oN(Ne(_e.uriListData)):new h.$oN(_e.asString)}Oe.to=ze;async function ve(qe,_e){const Ye=await _e.asString();if(qe===A.$Es.uriList)return{asString:Ye,fileData:void 0,uriListData:_(Ye)};const ct=_e.asFile();return{asString:Ye,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Oe.from=ve;function _(qe){return L.$Ht.split(qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return a.URI.parse(_e)}catch{}return _e})}function Ne(qe){return L.$Ht.create(qe.map(_e=>typeof _e=="string"?_e:a.URI.revive(_e)))}})(qt||(e.DataTransferItem=qt={}));var Yt;(function(Oe){function ze(_,Ne){const qe=_.items.map(([_e,Ye])=>[_e,qt.to(_e,Ye,Ne)]);return new h.$rN(qe)}Oe.toDataTransfer=ze;async function ve(_){const Ne={items:[]},qe=[];for(const[_e,Ye]of _)qe.push((async()=>{Ne.items.push([_e,await qt.from(_e,Ye)])})());return await Promise.all(qe),Ne}Oe.from=ve})(Yt||(e.DataTransfer=Yt={}));var Xe;(function(Oe){function ze(_,Ne){return{kind:"reply",agentId:_.participant??Ne?.agentId??"",subCommand:_.command??Ne?.command,message:_.prompt,title:_.label}}Oe.from=ze;function ve(_){return{prompt:_.message,label:_.title,participant:_.agentId,command:_.subCommand}}Oe.to=ve})(Xe||(e.ChatFollowup=Xe={}));var Zt;(function(Oe){function ze(ve){return"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Oe.from=ze})(Zt||(e.ChatInlineFollowup=Zt={}));var Ut;(function(Oe){function ze(_){switch(_.role){case 0:return new h.$EO(_.content);case 1:return new h.$FO(_.content);case 2:return new h.$GO(_.content)}}Oe.to=ze;function ve(_){if(_ instanceof h.$EO)return{role:0,content:_.content};if(_ instanceof h.$FO)return{role:1,content:_.content};if(_ instanceof h.$GO)return{role:2,content:_.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=ve})(Ut||(e.LanguageModelMessage=Ut={}));var Ht;(function(Oe){function ze(Ne){const qe={};for(const _e of Object.keys(Ne))qe[_e]=Ne[_e].map(Oe.to);return qe}Oe.objectTo=ze;function ve(Ne){return{level:$t.to(Ne.level),kind:Ne.kind,value:(0,a.$wc)(Ne.value)?a.URI.revive(Ne.value):Ne.value,description:Ne.description}}Oe.to=ve;function _(Ne){return{level:$t.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Oe.from=_})(Ht||(e.ChatVariable=Ht={}));var $t;(function(Oe){function ze(_){switch(_){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Oe.to=ze;function ve(_){switch(_){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Oe.from=ve})($t||(e.ChatVariableLevel=$t={}));var jt;(function(Oe){function ze(ve){switch(ve){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=ze})(jt||(e.InteractiveEditorResponseFeedbackKind=jt={}));var Mt;(function(Oe){function ze(_){return{kind:"markdownContent",content:H.from(_.value)}}Oe.from=ze;function ve(_){return new h.$vO(H.to(_.content))}Oe.to=ve})(Mt||(e.ChatResponseMarkdownPart=Mt={}));var Ft;(function(Oe){function ze(_){const{value:Ne,baseUri:qe}=_;function _e(Ye,ct){return Ye.map(yt=>{const Kt=a.URI.joinPath(ct,yt.name);return{label:yt.name,uri:Kt,children:yt.children&&_e(yt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,S.$Xg)(qe),uri:qe,children:_e(Ne,qe)}}}Oe.from=ze;function ve(_){const Ne=(0,E.$Wh)(_.treeData);function qe(ct){return ct.map(yt=>({name:yt.label,children:yt.children&&qe(yt.children)}))}const _e=Ne.uri,Ye=Ne.children?qe(Ne.children):[];return new h.$wO(Ye,_e)}Oe.to=ve})(Ft||(e.ChatResponseFilesPart=Ft={}));var ri;(function(Oe){function ze(_){return{kind:"inlineReference",name:_.title,inlineReference:a.URI.isUri(_.value)?_.value:w.from(_.value)}}Oe.from=ze;function ve(_){const Ne=(0,E.$Wh)(_);return new h.$xO(a.URI.isUri(Ne.inlineReference)?Ne.inlineReference:w.to(Ne.inlineReference),_.name)}Oe.to=ve})(ri||(e.ChatResponseAnchorPart=ri={}));var oi;(function(Oe){function ze(_){return{kind:"progressMessage",content:H.from(_.value)}}Oe.from=ze;function ve(_){return new h.$yO(_.content.value)}Oe.to=ve})(oi||(e.ChatResponseProgressPart=oi={}));var Wt;(function(Oe){function ze(_,Ne,qe){return{kind:"command",command:Ne.toInternal(_.value,qe)??{command:_.value.command,title:_.value.title}}}Oe.from=ze;function ve(_,Ne){return new h.$zO(Ne.fromInternal(_.command)??{command:_.command.id,title:_.command.title})}Oe.to=ve})(Wt||(e.ChatResponseCommandButtonPart=Wt={}));var At;(function(Oe){function ze(_){return{kind:"textEdit",uri:_.uri,edits:_.edits.map(Ne=>pe.from(Ne))}}Oe.from=ze;function ve(_){return new h.$BO(a.URI.revive(_.uri),_.edits.map(Ne=>pe.to(Ne)))}Oe.to=ve})(At||(e.ChatResponseTextEditPart=At={}));var Et;(function(Oe){function ze(_){return"variableName"in _.value?{kind:"reference",reference:{variableName:_.value.variableName,value:a.URI.isUri(_.value.value)||!_.value.value?_.value.value:w.from(_.value.value)}}:{kind:"reference",reference:a.URI.isUri(_.value)?_.value:w.from(_.value)}}Oe.from=ze;function ve(_){const Ne=(0,E.$Wh)(_),qe=_e=>a.URI.isUri(_e)?_e:w.to(_e);return new h.$AO("variableName"in Ne.reference?{variableName:Ne.reference.variableName,value:Ne.reference.value&&qe(Ne.reference.value)}:qe(Ne.reference))}Oe.to=ve})(Et||(e.ChatResponseReferencePart=Et={}));var xt;(function(Oe){function ze(Ne,qe,_e){return Ne instanceof h.$vO?Mt.from(Ne):Ne instanceof h.$xO?ri.from(Ne):Ne instanceof h.$AO?Et.from(Ne):Ne instanceof h.$yO?oi.from(Ne):Ne instanceof h.$wO?Ft.from(Ne):Ne instanceof h.$zO?Wt.from(Ne,qe,_e):Ne instanceof h.$BO?At.from(Ne):{kind:"content",content:""}}Oe.from=ze;function ve(Ne,qe){switch(Ne.kind){case"reference":return Et.to(Ne);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return _(Ne,qe)}}Oe.to=ve;function _(Ne,qe){switch(Ne.kind){case"markdownContent":return Mt.to(Ne);case"inlineReference":return ri.to(Ne);case"progressMessage":return;case"treeData":return Ft.to(Ne);case"command":return Wt.to(Ne,qe)}}Oe.toContent=_})(xt||(e.ChatResponsePart=xt={}));var Ct;(function(Oe){function ze(_,Ne){return"markdownContent"in Ne?((0,c.$hG)(_,"chatParticipantAdditions"),{content:H.from(Ne.markdownContent),kind:"markdownContent"}):"content"in Ne?"vulnerabilities"in Ne&&Ne.vulnerabilities?((0,c.$hG)(_,"chatParticipantAdditions"),{content:Ne.content,vulnerabilities:Ne.vulnerabilities,kind:"vulnerability"}):typeof Ne.content=="string"?{content:Ne.content,kind:"content"}:((0,c.$hG)(_,"chatParticipantAdditions"),{content:H.from(Ne.content),kind:"markdownContent"}):"documents"in Ne?{documents:Ne.documents.map(qe=>({uri:qe.uri,version:qe.version,ranges:qe.ranges.map(_e=>D.from(_e))})),kind:"usedContext"}:"reference"in Ne?{reference:"uri"in Ne.reference?{uri:Ne.reference.uri,range:D.from(Ne.reference.range)}:Ne.reference,kind:"reference"}:"inlineReference"in Ne?{inlineReference:"uri"in Ne.inlineReference?{uri:Ne.inlineReference.uri,range:D.from(Ne.inlineReference.range)}:Ne.inlineReference,name:Ne.title,kind:"inlineReference"}:"participant"in Ne?((0,c.$hG)(_,"chatParticipantAdditions"),{agentId:Ne.participant,command:Ne.command,kind:"agentDetection"}):"message"in Ne?{content:H.from(Ne.message),kind:"progressMessage"}:void 0}Oe.from=ze;function ve(_,Ne){switch(_.kind){case"markdownContent":return{content:_.content.value};case"inlineReference":return{inlineReference:(0,a.$wc)(_.inlineReference)?a.URI.revive(_.inlineReference):w.to(_.inlineReference),title:_.name};case"command":return{command:Ne.fromInternal(_.command)??{command:_.command.id,title:_.command.title}};default:return}}Oe.toProgressContent=ve})(Ct||(e.ChatResponseProgress=Ct={}));var kt;(function(Oe){function ze(ve){return{prompt:ve.message,command:ve.command,variables:ve.variables.variables.map(li.to),location:Pt.to(ve.location)}}Oe.to=ze})(kt||(e.ChatAgentRequest=kt={}));var Pt;(function(Oe){function ze(ve){switch(ve){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return h.ChatLocation.Editor}}Oe.to=ze})(Pt||(e.ChatLocation=Pt={}));var li;(function(Oe){function ze(ve){return{name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],values:ve.values.map(Ht.to)}}Oe.to=ze})(li||(e.ChatAgentResolvedVariable=li={}));var St;(function(Oe){function ze(ve){return{label:ve.label,values:ve.values.map(Ht.from),insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation}}Oe.from=ze})(St||(e.ChatAgentCompletionItem=St={}));var hi;(function(Oe){function ze(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Oe.to=ze})(hi||(e.ChatAgentResult=hi={}));var zt;(function(Oe){function ze(ve,_,Ne){if(_.action.kind==="vote")return;const qe=hi.to(ve);return _.action.kind==="command"?{action:{kind:"command",commandButton:Ct.toProgressContent(_.action.commandButton,Ne)},result:qe}:_.action.kind==="followUp"?{action:{kind:"followUp",followup:Xe.to(_.action.followup)},result:qe}:{action:_.action,result:qe}}Oe.to=ze})(zt||(e.ChatAgentUserActionEvent=zt={}));var bi;(function(Oe){function ze(ve,_,Ne){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:_.toInternal(ve,Ne)}Oe.from=ze})(bi||(e.TerminalQuickFix=bi={}));var Gt;(function(Oe){function ze(ve){return{kind:gi.to(ve.kind)}}Oe.to=ze})(Gt||(e.PartialAcceptInfo=Gt={}));var gi;(function(Oe){function ze(ve){switch(ve){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Oe.to=ze})(gi||(e.PartialAcceptTriggerKind=gi={}));var Nt;(function(Oe){function ze(ve,_){return{id:_,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||0,contextValue:ve.contextValue}}Oe.from=ze})(Nt||(e.DebugTreeItem=Nt={}))}),define(ke[327],Ee([1,0,6,20,16,48]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;let M=class{constructor(p,E){this.a=p.getProxy(u.$xM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>E.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,E,A){const P=new R.$jw(L.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,A?.isRefactoring??!1)}};e.$$jc=M,e.$$jc=M=Je([We(0,O.$UO)],M)}),define(ke[328],Ee([1,0,19,7,47,4,45,3,38,18,2,218,25,6,16,8,290,26]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;class n{constructor(t,f,d,l,c,h){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.n=h,this.b=p.$8d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(l){if(t.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,l),c}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){f(this.markdown);const c=new a.$vO(l),h=v.ChatResponseMarkdownPart.from(c);return d(h),this},filetree(l,c){f(this.filetree);const h=new a.$wO(l,c),g=v.ChatResponseFilesPart.from(h);return d(g),this},anchor(l,c){f(this.anchor);const h=new a.$xO(l,c),g=v.ChatResponseAnchorPart.from(h);return d(g),this},button(l){f(this.anchor);const c=new a.$zO(l),h=v.ChatResponseCommandButtonPart.from(c,t.m,t.n);return d(h),this},progress(l){f(this.progress);const c=new a.$yO(l),h=v.ChatResponseProgressPart.from(c);return d(h),this},reference(l){if(f(this.reference),"variableName"in l&&!l.value){const c=t.j.variables.variables.find(h=>h.name===l.variableName);if(c){let h;if(c.references?.length)h=c.references.map(g=>({kind:"reference",reference:{variableName:l.variableName,value:g.reference}}));else{const g=new a.$AO(l);h=[v.ChatResponseReferencePart.from(g)]}return h.forEach(g=>d(g)),this}}else{const c=new a.$AO(l),h=v.ChatResponseReferencePart.from(c);d(h)}return this},textEdit(l,c){f(this.textEdit),(0,o.$hG)(t.i,"chatParticipantAdditions");const h=new a.$BO(l,c),g=v.ChatResponseTextEditPart.from(h);return d(g),this},push(l){if(f(this.push),l instanceof a.$BO&&(0,o.$hG)(t.i,"chatParticipantAdditions"),l instanceof a.$AO)this.reference(l.value);else{const c=v.ChatResponsePart.from(l,t.m,t.n);d(c)}return this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const c=v.ChatResponseProgress.from(t.i,l);if(!c){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(c),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new b.$4c,this.d=t.getProxy(S.$xM.MainThreadChatAgents2)}createChatAgent(t,f,d){const l=i.b++,c=new r(t,f,this.d,l,d);return this.c.set(l,c),this.d.$registerAgent(l,t.identifier,f,{},void 0),c.apiAgent}createDynamicChatAgent(t,f,d,l,c){const h=i.b++,g=new r(t,f,this.d,h,c);return this.c.set(h,g),this.d.$registerAgent(h,t.identifier,f,{},{name:d,description:l}),g.apiAgent}async $invokeAgent(t,f,d,l){const c=this.c.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(f.sessionId);h||(h=new b.$Tc,this.g.set(f.sessionId,h));const g=new n(c.extension,f,this.d,this.i,this.j.converter,h);try{const D=await this.k(f.agentId,d),w=c.invoke(v.ChatAgentRequest.to(f),{history:D},g.apiObject,l);return await(0,O.$bh)(Promise.resolve(w).then(k=>{if(k?.metadata)try{JSON.stringify(k.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${C}`,c.extension),{errorDetails:{message:C},timings:g.timings}}return{errorDetails:k?.errorDetails,timings:g.timings,metadata:k?.metadata}}),l)}catch(D){return this.i.error(D,c.extension),{errorDetails:{message:(0,P.localize)(0,null,(0,L.$$i)(D)),responseIsIncomplete:!0}}}finally{g.close()}}async k(t,f){const d=[];for(const l of f.history){const c=v.ChatAgentResult.to(l.result),h=t===l.request.agentId?c:{...c,metadata:void 0};d.push(new a.$CO(l.request.message,l.request.command,l.request.variables.variables.map(v.ChatAgentResolvedVariable.to),l.request.agentId));const g=(0,u.$Hb)(l.response.map(D=>v.ChatResponsePart.toContent(D,this.j.converter)));d.push(new a.$DO(g,h,l.request.agentId,l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,l,c){const h=this.c.get(f);if(!h)return Promise.resolve([]);const g=await this.k(h.id,l),D=v.ChatAgentResult.to(d);return(await h.provideFollowups(D,{history:g},c)).filter(w=>{const k=!w.participant||M.Iterable.some(this.c.values(),y=>y.id===w.participant&&$.$Im.equals(y.extension.identifier,h.extension.identifier));return k||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),k}).map(w=>v.ChatFollowup.from(w,t))}$acceptFeedback(t,f,d,l){const c=this.c.get(t);if(!c)return;const h=v.ChatAgentResult.to(f);let g;switch(d){case m.InteractiveSessionVoteDirection.Down:g=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=a.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(l?{result:h,kind:g,reportIssue:l}:{result:h,kind:g}))}$acceptAction(t,f,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(f,d,this.j.converter);c&&l.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,f,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(f,d)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(f)).map(l=>v.ChatFollowup.from(l,void 0))}}e.$akc=i;class r{constructor(t,f,d,l,c){this.extension=t,this.id=f,this.u=d,this.w=l,this.x=c,this.n=new R.$_d,this.o=new R.$_d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,f){return this.q?await this.q.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,f,d);return l?l.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:v.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof a.$vN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),f=!1}))},l=this;return{get id(){return l.id},get fullName(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.c??l.extension.displayName??l.extension.name},set fullName(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.c=c,d()},get iconPath(){return l.d},set iconPath(c){l.d=c,d()},get requestHandler(){return l.x},set requestHandler(c){(0,E.$$f)(typeof c=="function","Invalid request handler"),l.x=c},get followupProvider(){return l.b},set followupProvider(c){l.b=c,d()},get isDefault(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.g},set isDefault(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.g=c,d()},get helpTextPrefix(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.i},set helpTextPrefix(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.i=c,d()},get helpTextVariablesPrefix(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.j},set helpTextVariablesPrefix(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.j=c,d()},get helpTextPostfix(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.k},set helpTextPostfix(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.k=c,d()},get isSecondary(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.m},set isSecondary(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.m=c,d()},get sampleRequest(){return l.l},set sampleRequest(c){l.l=c,d()},get supportIssueReporting(){return(0,o.$hG)(l.extension,"chatParticipantAdditions"),l.p},set supportIssueReporting(c){(0,o.$hG)(l.extension,"chatParticipantAdditions"),l.p=c,d()},get onDidReceiveFeedback(){return l.n.event},set participantVariableProvider(c){if((0,o.$hG)(l.extension,"chatParticipantAdditions"),l.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");l.u.$registerAgentCompletionsProvider(l.w,c.triggerCharacters)}else l.u.$unregisterAgentCompletionsProvider(l.w)},get participantVariableProvider(){return(0,o.$hG)(l.extension,"chatParticipantAdditions"),l.q},set welcomeMessageProvider(c){(0,o.$hG)(l.extension,"defaultChatParticipant"),l.s=c,d()},get welcomeMessageProvider(){return(0,o.$hG)(l.extension,"defaultChatParticipant"),l.s},onDidPerformAction:(0,o.$gG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){l.t=c,d()},get requester(){return l.t},dispose(){t=!0,l.b=void 0,l.n.dispose(),l.u.$unregisterAgent(l.w)}}}invoke(t,f,d,l){return this.x(t,f,d,l)}}}),define(ke[329],Ee([1,0,13,3,6,16,8,26]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class p{static{this.a=0}constructor(P){this.b=new Map,this.c=P.getProxy(L.$xM.MainThreadChatVariables)}async $resolveVariable(P,$,S,v){const a=this.b.get(P);if(a)try{if(a.resolver.resolve2){(0,b.$hG)(a.extension,"chatParticipantAdditions");const m=new E($,this.c),o=await a.resolver.resolve2(a.data.name,{prompt:S},m.apiObject,v);if(o)return o.map(R.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:S},v);if(m)return m.map(R.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(P,$,S,v){const a=p.a++;return this.b.set(a,{extension:P,data:{name:$,description:S},resolver:v}),this.c.$registerVariable(a,{name:$,description:S}),(0,O.$Sc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$dkc=p;class E{constructor(P,$){this.c=P,this.d=$,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let $=function(v){if(P.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,v),a}};const P=this,S=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){$(this.progress);const a=new M.$yO(v),m=R.ChatResponseProgressPart.from(a);return S(m),this},reference(v){$(this.reference);const a=new M.$AO(v),m=R.ChatResponseReferencePart.from(a);return S(m),this},push(v){return $(this.push),v instanceof M.$AO?S(R.ChatResponseReferencePart.from(v)):v instanceof M.$yO&&S(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[330],Ee([1,0,7,55,4,3,2,83,25,16,8,6,26]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=S;function S(v,a,m){const o=v.getProxy(P.$xM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$Km,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this.b.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=g,w=this.b.get(D.commentControlHandle);if(!w)return D;const k=w.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(g&&(g.$mid===9||g.$mid===8)){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);return w?g.$mid===8?w.value:{thread:w.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const k=g.commentUniqueId,y=w.getCommentByUniqueId(k);return y||g}else if(g&&g.$mid===11){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const k=g.text,y=g.commentUniqueId,C=w.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=k:C.body=new A.$1M(k),C):g}return g}})}createCommentController(g,D,w){const k=n.a++,y=new r(g,k,D,w);this.b.set(y.handle,y);const C=this.c.get(g.identifier)||[];return C.push(y),this.c.set(g.identifier,C),y.value}async $createCommentThreadTemplate(g,D,w){const k=this.b.get(g);k&&k.$createCommentThreadTemplate(D,w)}async $setActiveComment(g,D){const w=this.b.get(g);w&&w.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(g,D,w){const k=this.b.get(g);k&&k.$updateCommentThreadTemplate(D,w)}$deleteCommentThread(g,D){this.b.get(g)?.$deleteCommentThread(D)}async $provideCommentingRanges(g,D,w){const k=this.b.get(g);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const y=await m.ensureDocumentData(M.URI.revive(D));return(0,u.$fh)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(y.document,w);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(z=>E.Range.from(z)),fileComments:C.fileComments}),I})}$toggleReaction(g,D,w,k,y){const C=this.b.get(g);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,u.$fh)(()=>{const I=C.getCommentThread(D);if(I){const z=I.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&z&&C.reactionHandler)return C.reactionHandler(z,f(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,$.$hG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,D,w,k,y,C,I,z){this.m=D,this.n=w,this.o=k,this.p=y,this.q=C,this.extensionDescription=I,this.r=z,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$_d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),o.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(F){j.range=F},get comments(){return j.comments},set comments(F){j.comments=F},get collapsibleState(){return j.collapsibleState},set collapsibleState(F){j.collapsibleState=F},get canReply(){return j.canReply},set canReply(F){j.canReply=F},get contextValue(){return j.contextValue},set contextValue(F){j.contextValue=F},get label(){return j.label},set label(F){j.label=F},get state(){return j.state},set state(F){j.state=F},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const g=w=>Object.prototype.hasOwnProperty.call(this.b,w),D={};g("range")&&(D.range=E.Range.from(this.p)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this.q.map(w=>s(this,w,this.k,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=d(this.g)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=l(this.h)),g("applicability")&&(D.applicability=c(this.h)),g("isTemplate")&&(D.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(g){for(const D of this.k){const w=D[0],k=D[1];if(g===k)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Je([(0,O.$Sh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,$.$hG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,$.$hG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,$.$hG)(this.h,"activeComment"),this.f}constructor(g,D,w,k){this.h=g,this.i=D,this.j=w,this.k=k,this.a=new Map,o.$registerCommentController(this.handle,w,k,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,I,z){return y.createCommentThread(C,I,z).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,w){D===void 0&&(0,$.$hG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,g,D,w,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const D=this.a.get(g.commentThreadHandle);D&&(this.e=g.uniqueIdInThread?D.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(g,D){const w=new i(this.id,this.handle,void 0,M.URI.revive(g),E.Range.to(D),[],this.h,!0);return w.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(g,D){const w=this.a.get(g);w&&(w.range=E.Range.to(D))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function s(h,g,D,w){let k=D.get(g);return k||(k=++h.commentHandle,D.set(g,k)),g.state!==void 0&&(0,$.$hG)(w,"commentsDraftState"),g.reactions?.some(y=>y.reactors!==void 0)&&(0,$.$hG)(w,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:k,body:typeof g.body=="string"?g.body:E.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(y=>t(y)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?E.$TO(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(g=>g.name):h.reactors}}function f(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?M.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(g=>({name:g}))}}function d(h){if(h!==void 0)switch(h){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(h){let g;if(typeof h=="object"?g=h.resolved:g=h,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function c(h){let g;if(typeof h=="object"&&(g=h.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[331],Ee([1,0,22,56,3,15,23,2,16,92,111,6,8]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class S{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new A.$Wjc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,M.$1g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,l){const c=this.b(f,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const h=new S(d,l);return this.a.set(c,h),h}delete(f,d){const l=this.b(f,d.uri);this.a.delete(l)}b(f,d){return`${f}@@@${d}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(f,d,l){return this.b(0,f,d,l)}addCustomProvider(f,d,l){return this.b(1,f,d,l)}get(f){return this.a.get(f)}b(f,d,l,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:l,provider:c}),new $.$zM(()=>this.a.delete(d))}}class o{constructor(f,d,l,c,h){this.d=d,this.f=l,this.g=c,this.h=h,this.b=new m,this.c=new v,this.a=f.getProxy(P.$xM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,l,c){const h=new L.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,f,l)),this.a.$registerTextEditorProvider((0,E.$wkc)(f),d,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,E.$ukc)(f))):(h.add(this.b.addCustomProvider(d,f,l)),n(l)&&h.add(l.onDidChangeCustomDocument(g=>{const D=this.i(d,g.document.uri);if(r(g)){const w=D.addEdit(g);this.a.$onDidEdit(g.document.uri,d,w,g.label)}else this.a.$onContentChange(g.document.uri,d)})),this.a.$registerCustomEditorProvider((0,E.$wkc)(f),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,E.$ukc)(f))),$.$zM.from(h,new $.$zM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,l,c,h){const g=this.b.get(d);if(!g)throw new Error(`No provider found for '${d}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=b.URI.revive(f),w=await g.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:c?.buffer},h);let k;return n(g.provider)&&this.f&&(k=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(d,w,k),{editable:n(g.provider)}}async $disposeCustomDocument(f,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=b.URI.revive(f),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(f,d,l,c,h,g){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const w=p.ViewColumn.to(h),k=this.g.createNewWebview(d,c.contentOptions,D.extension),y=this.h.createNewWebviewPanel(d,l,c.title,w,c.options,k,c.active),C=b.URI.revive(f);switch(D.type){case 1:{const{document:I}=this.i(l,C);return D.provider.resolveCustomEditor(I,y,g)}case 0:{const I=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(I,y,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,l){this.i(d,f).disposeEdits(l)}async $onMoveCustomEditor(f,d,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const g=b.URI.revive(d),D=this.d.getDocument(g);await c.provider.moveCustomTextEditor(D,h,u.CancellationToken.None)}async $undo(f,d,l,c){return this.i(d,f).undo(l,c)}async $redo(f,d,l,c){return this.i(d,f).redo(l,c)}async $revert(f,d,l){const c=this.i(d,f);await this.j(d).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(f,d,l){const c=this.i(d,f);await this.j(d).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(f,d,l,c){const h=this.i(d,f);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(l),c)}async $backup(f,d,l){const c=this.i(d,f),g=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(g),g.id}i(f,d){const l=this.c.get(f,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(f){const l=this.b.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$zkc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,O.$bj)(f)+""}}),define(ke[332],Ee([1,0,219,138,2,6,8,16,4,12,27,60]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;class S{#e;#t;#i;constructor(m,o,n,i,r,s,t,f){this.d=m,this.e=o,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let n=[];if(L.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(S.k);for(const t of m){const[f,d]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),d)this.#i.get(f)?.push(...d);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this.g){t=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of f)if(c.severity===d[l]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[n,i]of this)m.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$4jc=S;let v=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(m){const o=new A.$Bc;for(const n of m)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new p.$de({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,$._mapper),this.f=m.getProxy(R.$xM.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:n,f:i,h:r,j:s,k:t,l:f}=this,d=new class{$changeMany(h,g){i.$changeMany(h,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,g.length===0?"CLEARING":g)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+$.c++;while(n.has(l))}return new class extends S{constructor(){super(o,l,$.e,$.d,h=>f.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(m){let o=[];for(const n of this.g.values())n.has(m)&&(o=o.concat(n.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",n=new S(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of m)this.n.set(L.URI.revive(o),n.map(b.Diagnostic.to))}};e.$5jc=v,e.$5jc=v=$=Je([We(1,E.$Tj),We(2,P.$3jc)],v)}),define(ke[333],Ee([1,0,2,13,8,16,75,48]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class p{constructor(A,P,$,S={timeout:1500,errors:3}){this.c=A,this.d=P,this.f=$,this.g=S,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(P,$,S)=>{const a={dispose:this.a.push([P,$,A])};return Array.isArray(S)&&S.push(a),a}}async $participateInSave(A,P){const $=u.URI.revive(A);let S=!1;const v=setTimeout(()=>S=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(S)break;const o=this.d.getDocument($),n=await this.h(m,{document:o,reason:R.TextDocumentSaveReason.to(P)});a.push(n)}}finally{clearTimeout(v)}return a}h([A,P,$],S){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i($,A,P,S).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(A);this.b.set(A,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,P,$,S){const v=[],a=Date.now(),{document:m,reason:o}=S,{version:n}=m,i=Object.freeze({document:m,reason:o,waitUntil(r){if(Object.isFrozen(v))throw(0,O.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{P.apply($,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),r(f)}).catch(f=>{clearTimeout(t),s(f)})}).then(r=>{const s={edits:[]};for(const t of r)if(Array.isArray(t)&&t.every(f=>f instanceof L.$GM))for(const{newText:f,newEol:d,range:l}of t)s.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:f,eol:d&&R.EndOfLine.from(d)}});if(s.edits.length!==0)return n===m.version?this.f.$tryApplyWorkspaceEdit(new b.$jw(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$blc=p}),define(ke[334],Ee([1,0,4,3,2,6,152,16,18,24,8]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=void 0;class P{constructor(S,v){this.a=new u.$_d,this.b=new u.$_d,this.c=new u.$_d,this.d=new u.$_d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=S.getProxy(R.$xM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const v=this.g.getDocument(S);if(v)return v}getDocument(S){const v=this.getDocumentData(S);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return v.document}ensureDocumentData(S){const v=this.g.getDocument(S);if(v)return Promise.resolve(v);let a=this.h.get(S.toString());return a||(a=this.f.$tryOpenDocument(S).then(m=>{this.h.delete(S.toString());const o=L.URI.revive(m);return(0,p.$_f)(this.g.getDocument(o))},m=>(this.h.delete(S.toString()),Promise.reject(m))),this.h.set(S.toString(),a)),a}createDocumentData(S){return this.f.$tryCreateDocument(S).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(S,v){const a=L.URI.revive(S),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(S){const v=L.URI.revive(S),a=this.g.getDocument(v);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(S,v){const a=L.URI.revive(S),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,v,a){const m=L.URI.revive(S),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(a),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Un)({document:o.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(S,v){(0,M.$WO)(S,v)}}e.$6jc=P}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,8]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0,e.$Akc=(0,M.$ni)("IExtHostEditorTabs");class P{constructor(m,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$jO(R.URI.revive(this.b.input.uri));case 2:return new A.$kO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$lO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$mO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$nO(this.b.input.viewType);case 4:return new A.$oO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$pO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$qO;case 9:return new A.$rO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$sO(this.b.input.providerId);case 11:return new A.$tO(this.b.input.diffEditors.map(m=>new A.$kO(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class ${constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new P(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return E.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const o=this.c.find(n=>n.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let S=class{constructor(m){this.b=new O.$_d,this.c=new O.$_d,this.e=[],this.a=m.getProxy(b.$xM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,L.$_f)(m.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(m.map(d=>d.groupId)),i=(0,u.$L)(o,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const l=new $(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,L.$_f)(m.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const n=[];for(const i of m){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,o)}async j(m,o){const n=[];for(const i of m){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,o)}};e.$Bkc=S,e.$Bkc=S=Je([We(0,p.$UO)],S);function v(a){return a.tabs!==void 0}}),define(ke[335],Ee([1,0,2,6,3,8,16,180,14,21,26,80]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class ${constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const m=this.a.indexOf(a);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),m=[];let o,n,i=14,r=14;for(const s of a){let t=o?(0,p.$sf)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new b.$G2(m)}}provideDocumentLinks(a){this.c();const m=[],o=b.$H2.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&m.push(i)}return m}}class S{constructor(a,m){this.i=m,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(O.$xM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,m,o,n={}){if(S.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$hG)(a,"fsChunks"),r+=4);let s;n.isReadonly&&(0,P.$Mk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const d=[];for(const l of f){const{uri:c,type:h}=l;if(c.scheme!==m)continue;let g;switch(h){case R.FileChangeType.Changed:g=0;break;case R.FileChangeType.Created:g=1;break;case R.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:g})}this.a.$onFileSystemChange(i,d)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:m,ctime:o,mtime:n,size:i,permissions:r}=a;return{type:m,ctime:o,mtime:n,size:i,permissions:r}}$stat(a,m){return Promise.resolve(this.l(a).stat(u.URI.revive(m))).then(o=>S.k(o))}$readdir(a,m){return Promise.resolve(this.l(a).readDirectory(u.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this.l(a).readFile(u.URI.revive(m))).then(o=>E.$ze.wrap(o))}$writeFile(a,m,o,n){return Promise.resolve(this.l(a).writeFile(u.URI.revive(m),o.buffer,n))}$delete(a,m,o){return Promise.resolve(this.l(a).delete(u.URI.revive(m),o))}$rename(a,m,o,n){return Promise.resolve(this.l(a).rename(u.URI.revive(m),u.URI.revive(o),n))}$copy(a,m,o,n){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(o),n))}$mkdir(a,m){return Promise.resolve(this.l(a).createDirectory(u.URI.revive(m)))}$watch(a,m,o,n){const i=this.l(a).watch(u.URI.revive(o),n);this.f.set(m,i)}$unwatch(a,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(a,m,o){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),o))}$close(a,m){const o=this.l(a);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(a,m,o,n){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=E.$ze.alloc(n);return Promise.resolve(i.read(m,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(a,m,o,n){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,o,n.buffer,0,n.byteLength))}l(a){const m=this.c.get(a);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$dlc=S}),define(ke[336],Ee([1,0,4,35,2,6,16,8,46]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,v,a,m,o,n){this.a=Math.random(),this.b=new u.$_d,this.c=new u.$_d,this.d=new u.$_d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$hk)(o),r=typeof o=="string",s=n?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const d of f.created){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of f.changed){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of f.deleted){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$zM.from(this.i(S,a,o,n,n?.correlate),this.b,this.c,this.d,t)}i(S,v,a,m,o){const n=b.$zM.from();if(typeof a=="string")return n;const i=S.getProxy(R.$xM.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(O.$dk)||a.pattern.includes(O.$ek))&&(r=!0),i.$watch(v.identifier.value,this.a,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),b.$zM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(S){this.a=S,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map(L.URI.revive)),this.c=new p.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(S,v,a){this.j=S,this.k=v,this.l=a,this.a=new u.$_d,this.b=new u.$_d,this.c=new u.$_d,this.d=new u.$_d,this.g=new u.$be,this.h=new u.$be,this.i=new u.$be,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,v,a,m){return new E(this.j,S,v,this.a.event,M.GlobPattern.from(a),m)}$onFileEvent(S){this.a.fire(new A(S))}$onDidRunFileOperation(S,v){switch(S){case 2:this.b.fire(Object.freeze({files:v.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(a=>L.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(a=>L.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,v){return(a,m,o)=>{const n=function(r){a.call(m,r)};return n.extension=S,v.event(n,void 0,o)}}async $onWillRunFileOperation(S,v,a,m){switch(S){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},a,m);case 1:return await this.n(this.i,{files:v.map(o=>L.URI.revive(o.target))},a,m);case 0:case 3:return await this.n(this.h,{files:v.map(o=>L.URI.revive(o.target))},a,m)}}async n(S,v,a,m){const o=new Set,n=[];if(await S.fireAsync(v,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof b.$JM&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$elc=P}),define(ke[337],Ee([1,0,19,7,22,13,124,3,24,38,14,18,2,29,176,83,134,221,25,16,8,26,111,6]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=void 0;class d{constructor(q,W){this.d=q,this.e=W}async provideDocumentSymbols(q,W){const X=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(X,W);if(!(0,u.$Kb)(Q))return Q[0]instanceof r.$SM?Q.map(i.DocumentSymbol.from):d.f(Q)}static f(q){q=q.slice(0).sort((Q,fe)=>{let we=Q.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(Q.location.range.end)),we});const W=[],X=[];for(const Q of q){const fe={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(X.length===0){X.push(fe),W.push(fe);break}const we=X[X.length-1];if(S.$ht.containsRange(we.range,fe.range)&&!S.$ht.equalsRange(we.range,fe.range)){we.children?.push(fe),X.push(fe);break}X.pop()}}return W}}class l{constructor(q,W,X,Q,fe,we){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=fe,this.l=we,this.d=new t.$Wjc("CodeLens"),this.e=new Map}async provideCodeLenses(q,W){const X=this.f.getDocument(q),Q=await this.h.provideCodeLenses(X,W);if(!Q||W.isCancellationRequested)return;const fe=this.d.add(Q),we=new b.$Tc;this.e.set(fe,we);const Fe={cacheId:fe,lenses:[]};for(let Ve=0;Ve<Q.length;Ve++)Fe.lenses.push({cacheId:[fe,Ve],range:i.Range.from(Q[Ve].range),command:this.g.toInternal(Q[Ve].command,we)});return Fe}async resolveCodeLens(q,W){const X=q.cacheId&&this.d.get(...q.cacheId);if(!X)return;let Q;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Q=X:Q=await this.h.resolveCodeLens(X,W),Q||(Q=X),W.isCancellationRequested)return;const fe=q.cacheId&&this.e.get(q.cacheId[0]);if(fe){if(!Q.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(Q.command,fe),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function c(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class h{constructor(q,W){this.d=q,this.e=W}async provideDefinition(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideDefinition(Q,fe,X);return c(we)}}class g{constructor(q,W){this.d=q,this.e=W}async provideDeclaration(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideDeclaration(Q,fe,X);return c(we)}}class D{constructor(q,W){this.d=q,this.e=W}async provideImplementation(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideImplementation(Q,fe,X);return c(we)}}class w{constructor(q,W){this.d=q,this.e=W}async provideTypeDefinition(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideTypeDefinition(Q,fe,X);return c(we)}}class k{constructor(q,W){this.d=q,this.e=W}async provideHover(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideHover(Q,fe,X);if(!(!we||(0,u.$Kb)(we.contents)))return we.range||(we.range=Q.getWordRangeAtPosition(fe)),we.range||(we.range=new r.$BM(fe,fe)),i.Hover.from(we)}}class y{constructor(q,W){this.d=q,this.e=W}async provideEvaluatableExpression(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideEvaluatableExpression(Q,fe,X);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(q,W){this.d=q,this.e=W}async provideInlineValues(q,W,X,Q){const fe=this.d.getDocument(q),we=await this.e.provideInlineValues(fe,i.Range.to(W),i.InlineValueContext.to(X),Q);if(Array.isArray(we))return we.map(Fe=>i.InlineValue.from(Fe))}}class I{constructor(q,W){this.d=q,this.e=W}async provideDocumentHighlights(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideDocumentHighlights(Q,fe,X);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class z{constructor(q,W){this.d=q,this.e=W}async provideMultiDocumentHighlights(q,W,X,Q){const fe=this.d.getDocument(q),we=X.map(Ze=>this.d.getDocument(Ze)),Fe=i.Position.to(W),Ve=await this.e.provideMultiDocumentHighlights(fe,Fe,we,Q);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class j{constructor(q,W){this.d=q,this.e=W}async provideLinkedEditingRanges(q,W,X){const Q=this.d.getDocument(q),fe=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(Q,fe,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,u.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class F{constructor(q,W){this.d=q,this.e=W}async provideReferences(q,W,X,Q){const fe=this.d.getDocument(q),we=i.Position.to(W),Fe=await this.e.provideReferences(fe,we,X,Q);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class N{static{this.d=1e3}constructor(q,W,X,Q,fe,we,Fe){this.g=q,this.h=W,this.j=X,this.k=Q,this.l=fe,this.m=we,this.n=Fe,this.e=new t.$Wjc("CodeAction"),this.f=new Map}async provideCodeActions(q,W,X,Q){const fe=this.g.getDocument(q),we=v.$jt.isISelection(W)?i.Selection.to(W):i.Range.to(W),Fe=[];for(const ot of this.j.getDiagnostics(q))if(we.intersection(ot.range)&&Fe.push(ot)>N.d)break;const Ve={diagnostics:Fe,only:X.only?new r.$UM(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Ze=await this.k.provideCodeActions(fe,we,Ve,Q);if(!(0,u.$Lb)(Ze)||Q.isCancellationRequested)return;const tt=this.e.add(Ze),st=new b.$Tc;this.f.set(tt,st);const at=[];for(let ot=0;ot<Ze.length;ot++){const Se=Ze[ot];if(Se)if(N.o(Se))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Se.title,command:this.h.toInternal(Se,st)});else{Ve.only&&(Se.kind?Ve.only.contains(Se.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${Se.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Se.ranges??[];at.push({cacheId:[tt,ot],title:Se.title,command:Se.command&&this.h.toInternal(Se.command,st),diagnostics:Se.diagnostics&&Se.diagnostics.map(i.Diagnostic.from),edit:Se.edit&&i.WorkspaceEdit.from(Se.edit,void 0),kind:Se.kind&&Se.kind.value,isPreferred:Se.isPreferred,isAI:(0,s.$gG)(this.m,"codeActionAI")?Se.isAI:!1,ranges:(0,s.$gG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:Se.disabled?.reason})}}return{cacheId:tt,actions:at}}async resolveCodeAction(q,W){const[X,Q]=q,fe=this.e.get(X,Q);if(!fe||N.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,W)??fe;let Fe;we.edit&&(Fe=i.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Ze=this.f.get(X);Ze&&(Ve=this.h.toInternal(we.command,Ze))}return{edit:Fe,command:Ve}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class T{constructor(q,W,X,Q,fe){this.e=q,this.f=W,this.g=X,this.h=Q,this.j=fe,this.d=new t.$Wjc("DocumentPasteEdit")}async prepareDocumentPaste(q,W,X,Q){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(q),we=W.map(Ze=>i.Range.to(Ze)),Fe=i.DataTransfer.toDataTransfer(X,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(fe,we,Fe,Q),Q.isCancellationRequested)return;const Ve=Array.from(Fe).filter(([,Ze])=>!(Ze instanceof r.$oN));return i.DataTransfer.from(Ve)}async providePasteEdits(q,W,X,Q,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(W),Ve=X.map(at=>i.Range.to(at)),Ze=i.DataTransfer.toDataTransfer(Q,async at=>(await this.e.$resolvePasteFileData(this.h,q,at)).buffer),tt=await this.g.provideDocumentPasteEdits(Fe,Ve,Ze,{only:fe.only?new r.$tN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const st=this.d.add(tt);return tt.map((at,ot)=>({_cacheId:[st,ot],title:at.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(Se=>Se.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,W){const[X,Q]=q,fe=this.d.get(X,Q);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,W)??fe;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,W){this.d=q,this.e=W}async provideDocumentFormattingEdits(q,W,X){const Q=this.d.getDocument(q),fe=await this.e.provideDocumentFormattingEdits(Q,W,X);if(Array.isArray(fe))return fe.map(i.TextEdit.from)}}class H{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeFormattingEdits(q,W,X,Q){const fe=this.d.getDocument(q),we=i.Range.to(W),Fe=await this.e.provideDocumentRangeFormattingEdits(fe,we,X,Q);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,W,X,Q){(0,P.$$f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(q),we=W.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(fe,we,X,Q);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class Z{constructor(q,W){this.d=q,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,W,X,Q,fe){const we=this.d.getDocument(q),Fe=i.Position.to(W),Ve=await this.e.provideOnTypeFormattingEdits(we,Fe,X,Q,fe);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class ee{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Wjc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,W){const X=await this.e.provideWorkspaceSymbols(q,W);if(!(0,u.$Lb)(X))return{symbols:[]};const Q=this.d.add(X),fe={cacheId:Q,symbols:[]};for(let we=0;we<X.length;we++){const Fe=X[we];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}fe.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[Q,we]})}return fe}async resolveWorkspaceSymbol(q,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const X=this.d.get(...q.cacheId);if(X){const Q=await this.e.resolveWorkspaceSymbol(X,W);return Q&&(0,p.$Wn)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class J{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideRenameEdits(q,W,X,Q){const fe=this.d.getDocument(q),we=i.Position.to(W);try{const Fe=await this.e.provideRenameEdits(fe,we,X,Q);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ve=J.g(Fe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(q,W,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),fe=i.Position.to(W);try{const we=await this.e.prepareRename(Q,fe,X);let Fe,Ve;if(r.$BM.isRange(we)?(Fe=we,Ve=Q.getText(we)):(0,P.$3f)(we)&&(Fe=we.range,Ve=we.placeholder),!Fe||!Ve)return;if(Fe.start.line>fe.line||Fe.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Ve}}catch(we){const Fe=J.g(we);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Y{constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideNewSymbolNames(q,W,X){const Q=this.d.getDocument(q),fe=i.Range.to(W);try{const we=await this.e.provideNewSymbolNames(Q,fe,X);return we?we.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(we){this.f.error(Y.g(we)??JSON.stringify(we,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class re{constructor(q,W){this.resultId=q,this.tokens=W}}class te{constructor(q,W){this.f=q,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,W,X){const Q=this.f.getDocument(q),fe=W!==0?this.d.get(W):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,fe.resultId,X):await this.g.provideDocumentSemanticTokens(Q,X);return fe&&this.d.delete(W),we?(we=te.h(we),this.o(te.n(fe,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return te.j(q)?te.k(q)?q:new r.$TN(new Uint32Array(q.data),q.resultId):te.l(q)?te.m(q)?q:new r.$VN(q.edits.map(W=>new r.$UN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const W of q.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(q,W){if(!te.j(W)||!q||!q.tokens)return W;const X=q.tokens,Q=X.length,fe=W.data,we=fe.length;let Fe=0;const Ve=Math.min(Q,we);for(;Fe<Ve&&X[Fe]===fe[Fe];)Fe++;if(Fe===Q&&Fe===we)return new r.$VN([],W.resultId);let Ze=0;const tt=Ve-Fe;for(;Ze<tt&&X[Q-Ze-1]===fe[we-Ze-1];)Ze++;return new r.$VN([{start:Fe,deleteCount:Q-Fe-Ze,data:fe.subarray(Fe,we-Ze)}],W.resultId)}o(q,W){if(te.j(q)){const X=this.e++;return this.d.set(X,new re(q.resultId,q.data)),(0,m.$Zab)({id:X,type:"full",data:q.data})}if(te.l(q)){const X=this.e++;return te.j(W)?this.d.set(X,new re(W.resultId,W.data)):this.d.set(X,new re(q.resultId)),(0,m.$Zab)({id:X,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class pe{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeSemanticTokens(q,W,X){const Q=this.d.getDocument(q),fe=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(W),X);return fe?this.f(fe):null}f(q){return(0,m.$Zab)({id:0,type:"full",data:q.data})}}class Ce{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,W,X,Q,fe){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=fe,this.d=new t.$Wjc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,W,X,Q){const fe=this.f.getDocument(q),we=i.Position.to(W),Fe=fe.getWordRangeAtPosition(we)||new r.$BM(we,we),Ve=Fe.with({end:we}),Ze=new E.$8d,tt=await this.h.provideCompletionItems(fe,we,Q,i.CompletionContext.to(X));if(!tt||Q.isCancellationRequested)return;const st=Array.isArray(tt)?new r.$8M(tt):tt,at=Ce.supportsResolving(this.h)?this.d.add(st.items):this.d.add([]),ot=new b.$Tc;this.e.set(at,ot);const Se=[],Be={x:at,b:Se,a:{replace:i.Range.from(Fe),insert:i.Range.from(Ve)},c:st.isIncomplete||void 0,d:Ze.elapsed()};for(let Ge=0;Ge<st.items.length;Ge++){const Le=st.items[Ge],Qe=this.l(Le,[at,Ge],Ve,Fe);Se.push(Qe)}return Be}async resolveCompletionItem(q,W){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...q);if(!X)return;const Q=this.l(X,q),fe=await this.h.resolveCompletionItem(X,W);if(!fe)return;const we=this.l(fe,q);return(Q.h!==we.h||Q.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==we.n||Q.o!==we.o||!(0,p.$Xn)(Q.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W,X,Q){const fe=this.e.get(W[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,fe),Fe={x:W,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=q.textEdit.newText):typeof q.insertText=="string"?Fe.h=q.insertText:q.insertText instanceof r.$KM&&(Fe.h=q.insertText.value,Fe.i|=4);let Ve;return q.textEdit?Ve=q.textEdit.range:q.range&&(Ve=q.range),r.$BM.isRange(Ve)?Fe.j=i.Range.from(Ve):Ve&&(!X?.isEqual(Ve.inserting)||!Q?.isEqual(Ve.replacing))&&(Fe.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Fe}}class x{async provideInlineCompletions(q,W,X,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,W,X){}handlePartialAccept(q,W,X,Q){}}class U extends x{constructor(q,W,X,Q){super(),this.f=q,this.g=W,this.h=X,this.j=Q,this.d=new be,this.e=(0,s.$gG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$gG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,W,X,Q){const fe=this.g.getDocument(q),we=i.Position.to(W),Fe=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Q);if(!Fe||Q.isCancellationRequested)return;const Ve=Array.isArray(Fe)?Fe:Fe.items,Ze=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],tt=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let st;return{pid:this.d.createReferenceId({dispose(){st?.dispose()},items:Ve}),items:Ve.map((ot,Se)=>{let Be;ot.command&&(st||(st=new b.$Tc),Be=this.j.toInternal(ot.command,st));const Ge=ot.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:Be,idx:Se,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Ze.map(ot=>(st||(st=new b.$Tc),this.j.toInternal(ot,st))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,W,X){const Q=this.d.get(q)?.items[W];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,X)}handlePartialAccept(q,W,X,Q){const fe=this.d.get(q)?.items[W];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,X),this.h.handleDidPartiallyAcceptCompletionItem(fe,i.PartialAcceptInfo.to(Q)))}}class ne{async provideInlineEdits(q,W,X){const Q=this.f.getDocument(q),fe=await this.g.provideInlineEdit(Q,{triggerKind:this.e[W.triggerKind]},X);if(!fe||X.isCancellationRequested)return;let we;const Fe=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ve;fe.accepted&&(we||(we=new b.$Tc),Ve=this.h.toInternal(fe.accepted,we));let Ze;return fe.rejected&&(we||(we=new b.$Tc),Ze=this.h.toInternal(fe.rejected,we)),{pid:Fe,text:fe.text,range:i.Range.from(fe.range),accepted:Ve,rejected:Ze}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,W,X,Q){this.f=W,this.g=X,this.h=Q,this.d=new be,this.e={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const W=this.e++;return this.d.set(W,q),W}disposeReferenceId(q){const W=this.d.get(q);return this.d.delete(q),W}get(q){return this.d.get(q)}}class De{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Wjc("SignatureHelp")}async provideSignatureHelp(q,W,X,Q){const fe=this.e.getDocument(q),we=i.Position.to(W),Fe=this.g(X),Ve=await this.f.provideSignatureHelp(fe,we,Q,Fe);if(Ve){const Ze=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ze}}}g(q){let W;if(q.activeSignatureHelp){const X=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(W=Q,W.activeSignature=X.activeSignature,W.activeParameter=X.activeParameter):W=X}return{...q,activeSignatureHelp:W}}releaseSignatureHelp(q){this.d.delete(q)}}class ae{constructor(q,W,X,Q,fe){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=fe,this.d=new t.$Wjc("InlayHints"),this.e=new Map}async provideInlayHints(q,W,X){const Q=this.f.getDocument(q),fe=i.Range.to(W),we=await this.h.provideInlayHints(Q,fe,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(X.isCancellationRequested)return;const Fe=this.d.add(we);this.e.set(Fe,new b.$Tc);const Ve={hints:[],cacheId:Fe};for(let Ze=0;Ze<we.length;Ze++)this.l(we[Ze],fe)&&Ve.hints.push(this.m(we[Ze],[Fe,Ze]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ve}async resolveInlayHint(q,W){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.h.resolveInlayHint(X,W);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W){return q.label.length===0||Array.isArray(q.label)&&q.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(W&&!W.contains(q.position))}m(q,W){const X=this.e.get(W[0]);if(!X)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const fe=[];Q.label=fe;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};r.$LM.isLocation(we.location)&&(Fe.location=i.location.from(we.location)),we.command&&(Fe.command=this.g.toInternal(we.command,X)),fe.push(Fe)}}return Q}}class ce{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Wjc("DocumentLink")}async provideLinks(q,W){const X=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(X,W);if(!(!Array.isArray(Q)||Q.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ce.g).map(i.DocumentLink.from)};{const fe=this.d.add(Q),we={links:[],cacheId:fe};for(let Fe=0;Fe<Q.length;Fe++){if(!ce.g(Q[Fe]))continue;const Ve=i.DocumentLink.from(Q[Fe]);Ve.cacheId=[fe,Fe],we.links.push(Ve)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,W){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.f.resolveDocumentLink(X,W);if(!(!Q||!ce.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class se{constructor(q,W){this.d=q,this.e=W}async provideColors(q,W){const X=this.d.getDocument(q),Q=await this.e.provideDocumentColors(X,W);return Array.isArray(Q)?Q.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(q,W,X){const Q=this.d.getDocument(q),fe=i.Range.to(W.range),we=i.Color.to(W.color),Fe=await this.e.provideColorPresentations(we,{document:Q,range:fe},X);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class K{constructor(q,W){this.d=q,this.e=W}async provideFoldingRanges(q,W,X){const Q=this.d.getDocument(q),fe=await this.e.provideFoldingRanges(Q,W,X);if(Array.isArray(fe))return fe.map(i.FoldingRange.from)}}class ie{constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideSelectionRanges(q,W,X){const Q=this.d.getDocument(q),fe=W.map(i.Position.to),we=await this.e.provideSelectionRanges(Q,fe,X);if(!(0,u.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ve=0;Ve<fe.length;Ve++){const Ze=[];Fe.push(Ze);let tt=fe[Ve],st=we[Ve];for(;;){if(!st.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(i.SelectionRange.from(st)),!st.parent)break;tt=st.range,st=st.parent}}return Fe}}class le{constructor(q,W){this.f=q,this.g=W,this.d=new M.$ZO(""),this.e=new Map}async prepareSession(q,W,X){const Q=this.f.getDocument(q),fe=i.Position.to(W),we=await this.g.prepareCallHierarchy(Q,fe,X);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,we)]}async provideCallsTo(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(Q,X);if(fe)return fe.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(Q,X);if(fe)return fe.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(q){this.e.delete(q)}h(q,W){const X=this.e.get(q),Q=i.CallHierarchyItem.from(W,q,X.size.toString(36));return X.set(Q._itemId,W),Q}j(q,W){return this.e.get(q)?.get(W)}}class de{constructor(q,W){this.f=q,this.g=W,this.d=new M.$ZO(""),this.e=new Map}async prepareSession(q,W,X){const Q=this.f.getDocument(q),fe=i.Position.to(W),we=await this.g.prepareTypeHierarchy(Q,fe,X);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,we)]}async provideSupertypes(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(Q,X);if(fe)return fe.map(we=>this.h(q,we))}async provideSubtypes(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(Q,X);if(fe)return fe.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,W){const X=this.e.get(q),Q=i.TypeHierarchyItem.from(W,q,X.size.toString(36));return X.set(Q._itemId,W),Q}j(q,W){return this.e.get(q)?.get(W)}}class Ae{constructor(q,W,X,Q,fe){this.d=q,this.e=W,this.f=X,this.g=Q,this.h=fe}async provideDocumentOnDropEdits(q,W,X,Q,fe){const we=this.e.getDocument(W),Fe=i.Position.to(X),Ve=i.DataTransfer.toDataTransfer(Q,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,q,tt)).buffer),Ze=await this.f.provideDocumentDropEdits(we,Fe,Ve,fe);if(Ze)return(0,u.$3b)(Ze).map(tt=>({title:tt.title??(0,o.localize)(1,null,this.h.displayName||this.h.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(st=>st.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}}class me{constructor(q,W){this.d=q,this.e=W}async provideMappedEdits(q,W,X,Q){const fe=$.URI.revive(q),we=this.d.getDocument(fe),Fe=X.documents.map(tt=>tt.map(st=>({uri:$.URI.revive(st.uri),version:st.version,ranges:st.ranges.map(at=>i.Range.to(at))}))),Ve={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(we,W,Ve,Q);return Ze?i.WorkspaceEdit.from(Ze):null}}class Pe{constructor(q,W){this.adapter=q,this.extension=W}}class Me{static{this.d=0}constructor(q,W,X,Q,fe,we,Fe,Ve){this.g=W,this.h=X,this.j=Q,this.k=fe,this.l=we,this.m=Fe,this.n=Ve,this.f=new Map,this.e=q.getProxy(f.$xM.MainThreadLanguageFeatures)}o(q,W){return i.DocumentSelector.from(q,this.g,W)}p(q){return new r.$zM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Me.d++}async s(q,W,X,Q,fe,we=!1){const Fe=this.f.get(q);if(!Fe||!(Fe.adapter instanceof W))return Q;const Ve=Date.now();we||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ze=X(Fe.adapter,Fe.extension);return Promise.resolve(Ze).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Fe.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(fe)?(0,O.$ch)(Ze,fe):Ze}t(q,W){const X=this.q();return this.f.set(X,new Pe(q,W)),X}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,W,X,Q){const fe=this.t(new d(this.h,X),q),we=Q&&Q.label||Me.u(q);return this.e.$registerDocumentSymbolProvider(fe,this.o(W,q),we),this.p(fe)}$provideDocumentSymbols(q,W,X){return this.s(q,d,Q=>Q.provideDocumentSymbols($.URI.revive(W),X),void 0,X)}registerCodeLensProvider(q,W,X){const Q=this.q(),fe=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Pe(new l(this.h,this.j.converter,X,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(W,q),fe);let we=this.p(Q);if(fe!==void 0){const Fe=X.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(fe));we=r.$zM.from(we,Fe)}return we}$provideCodeLenses(q,W,X){return this.s(q,l,Q=>Q.provideCodeLenses($.URI.revive(W),X),void 0,X)}$resolveCodeLens(q,W,X){return this.s(q,l,Q=>Q.resolveCodeLens(W,X),void 0,void 0)}$releaseCodeLenses(q,W){this.s(q,l,X=>Promise.resolve(X.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(q,W,X){const Q=this.t(new h(this.h,X),q);return this.e.$registerDefinitionSupport(Q,this.o(W,q)),this.p(Q)}$provideDefinition(q,W,X,Q){return this.s(q,h,fe=>fe.provideDefinition($.URI.revive(W),X,Q),[],Q)}registerDeclarationProvider(q,W,X){const Q=this.t(new g(this.h,X),q);return this.e.$registerDeclarationSupport(Q,this.o(W,q)),this.p(Q)}$provideDeclaration(q,W,X,Q){return this.s(q,g,fe=>fe.provideDeclaration($.URI.revive(W),X,Q),[],Q)}registerImplementationProvider(q,W,X){const Q=this.t(new D(this.h,X),q);return this.e.$registerImplementationSupport(Q,this.o(W,q)),this.p(Q)}$provideImplementation(q,W,X,Q){return this.s(q,D,fe=>fe.provideImplementation($.URI.revive(W),X,Q),[],Q)}registerTypeDefinitionProvider(q,W,X){const Q=this.t(new w(this.h,X),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(W,q)),this.p(Q)}$provideTypeDefinition(q,W,X,Q){return this.s(q,w,fe=>fe.provideTypeDefinition($.URI.revive(W),X,Q),[],Q)}registerHoverProvider(q,W,X,Q){const fe=this.t(new k(this.h,X),q);return this.e.$registerHoverProvider(fe,this.o(W,q)),this.p(fe)}$provideHover(q,W,X,Q){return this.s(q,k,fe=>fe.provideHover($.URI.revive(W),X,Q),void 0,Q)}registerEvaluatableExpressionProvider(q,W,X,Q){const fe=this.t(new y(this.h,X),q);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(W,q)),this.p(fe)}$provideEvaluatableExpression(q,W,X,Q){return this.s(q,y,fe=>fe.provideEvaluatableExpression($.URI.revive(W),X,Q),void 0,Q)}registerInlineValuesProvider(q,W,X,Q){const fe=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,X),q);this.e.$registerInlineValuesProvider(we,this.o(W,q),fe);let Fe=this.p(we);if(fe!==void 0){const Ve=X.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(fe));Fe=r.$zM.from(Fe,Ve)}return Fe}$provideInlineValues(q,W,X,Q,fe){return this.s(q,C,we=>we.provideInlineValues($.URI.revive(W),X,Q,fe),void 0,fe)}registerDocumentHighlightProvider(q,W,X){const Q=this.t(new I(this.h,X),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(W,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,W,X){const Q=this.t(new z(this.h,X),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(W,q)),this.p(Q)}$provideDocumentHighlights(q,W,X,Q){return this.s(q,I,fe=>fe.provideDocumentHighlights($.URI.revive(W),X,Q),void 0,Q)}$provideMultiDocumentHighlights(q,W,X,Q,fe){return this.s(q,z,we=>we.provideMultiDocumentHighlights($.URI.revive(W),X,Q.map(Fe=>$.URI.revive(Fe)),fe),void 0,fe)}registerLinkedEditingRangeProvider(q,W,X){const Q=this.t(new j(this.h,X),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(W,q)),this.p(Q)}$provideLinkedEditingRanges(q,W,X,Q){return this.s(q,j,async fe=>{const we=await fe.provideLinkedEditingRanges($.URI.revive(W),X,Q);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Me.w(we.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,W,X){const Q=this.t(new F(this.h,X),q);return this.e.$registerReferenceSupport(Q,this.o(W,q)),this.p(Q)}$provideReferences(q,W,X,Q,fe){return this.s(q,F,we=>we.provideReferences($.URI.revive(W),X,Q,fe),void 0,fe)}registerCodeActionProvider(q,W,X,Q){const fe=new b.$Tc,we=this.t(new N(this.h,this.j.converter,this.k,X,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(we,this.o(W,q),{providedKinds:Q?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:Q?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,fe)}))},Me.u(q),!!X.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(q,W,X,Q,fe){return this.s(q,N,we=>we.provideCodeActions($.URI.revive(W),X,Q,fe),void 0,fe)}$resolveCodeAction(q,W,X){return this.s(q,N,Q=>Q.resolveCodeAction(W,X),{},void 0)}$releaseCodeActions(q,W){this.s(q,N,X=>Promise.resolve(X.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(q,W,X){const Q=this.t(new B(this.h,X),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(W,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,W,X,Q){return this.s(q,B,fe=>fe.provideDocumentFormattingEdits($.URI.revive(W),X,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,W,X){const Q=typeof X.provideDocumentRangesFormattingEdits=="function",fe=this.t(new H(this.h,X),q);return this.e.$registerRangeFormattingSupport(fe,this.o(W,q),q.identifier,q.displayName||q.name,Q),this.p(fe)}$provideDocumentRangeFormattingEdits(q,W,X,Q,fe){return this.s(q,H,we=>we.provideDocumentRangeFormattingEdits($.URI.revive(W),X,Q,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(q,W,X,Q,fe){return this.s(q,H,we=>we.provideDocumentRangesFormattingEdits($.URI.revive(W),X,Q,fe),void 0,fe)}registerOnTypeFormattingEditProvider(q,W,X,Q){const fe=this.t(new Z(this.h,X),q);return this.e.$registerOnTypeFormattingSupport(fe,this.o(W,q),Q,q.identifier),this.p(fe)}$provideOnTypeFormattingEdits(q,W,X,Q,fe,we){return this.s(q,Z,Fe=>Fe.provideOnTypeFormattingEdits($.URI.revive(W),X,Q,fe,we),void 0,we)}registerWorkspaceSymbolProvider(q,W){const X=this.t(new ee(W,this.l),q);return this.e.$registerNavigateTypeSupport(X,typeof W.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(q,W,X){return this.s(q,ee,Q=>Q.provideWorkspaceSymbols(W,X),{symbols:[]},X)}$resolveWorkspaceSymbol(q,W,X){return this.s(q,ee,Q=>Q.resolveWorkspaceSymbol(W,X),void 0,void 0)}$releaseWorkspaceSymbols(q,W){this.s(q,ee,X=>X.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(q,W,X){const Q=this.t(new J(this.h,X,this.l),q);return this.e.$registerRenameSupport(Q,this.o(W,q),J.supportsResolving(X)),this.p(Q)}$provideRenameEdits(q,W,X,Q,fe){return this.s(q,J,we=>we.provideRenameEdits($.URI.revive(W),X,Q,fe),void 0,fe)}$resolveRenameLocation(q,W,X,Q){return this.s(q,J,fe=>fe.resolveRenameLocation($.URI.revive(W),X,Q),void 0,Q)}registerNewSymbolNamesProvider(q,W,X){const Q=this.t(new Y(this.h,X,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(W,q)),this.p(Q)}$provideNewSymbolNames(q,W,X,Q){return this.s(q,Y,fe=>fe.provideNewSymbolNames($.URI.revive(W),X,Q),void 0,Q)}registerDocumentSemanticTokensProvider(q,W,X,Q){const fe=this.t(new te(this.h,X),q),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(W,q),Q,we);let Fe=this.p(fe);if(we){const Ve=X.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(we));Fe=r.$zM.from(Fe,Ve)}return Fe}$provideDocumentSemanticTokens(q,W,X,Q){return this.s(q,te,fe=>fe.provideDocumentSemanticTokens($.URI.revive(W),X,Q),null,Q)}$releaseDocumentSemanticTokens(q,W){this.s(q,te,X=>X.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,W,X,Q){const fe=this.t(new pe(this.h,X),q);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(W,q),Q),this.p(fe)}$provideDocumentRangeSemanticTokens(q,W,X,Q){return this.s(q,pe,fe=>fe.provideDocumentRangeSemanticTokens($.URI.revive(W),X,Q),null,Q)}registerCompletionItemProvider(q,W,X,Q){const fe=this.t(new Ce(this.h,this.j.converter,X,this.m,q),q);return this.e.$registerCompletionsProvider(fe,this.o(W,q),Q,Ce.supportsResolving(X),q.identifier),this.p(fe)}$provideCompletionItems(q,W,X,Q,fe){return this.s(q,Ce,we=>we.provideCompletionItems($.URI.revive(W),X,Q,fe),void 0,fe)}$resolveCompletionItem(q,W,X){return this.s(q,Ce,Q=>Q.resolveCompletionItem(W,X),void 0,X)}$releaseCompletionItems(q,W){this.s(q,Ce,X=>X.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(q,W,X,Q){const fe=new U(q,this.h,X,this.j.converter),we=this.t(fe,q);return this.e.$registerInlineCompletionsSupport(we,this.o(W,q),fe.supportsHandleEvents,n.$Im.toKey(q.identifier.value),Q?.yieldTo?.map(Fe=>n.$Im.toKey(Fe))||[]),this.p(we)}$provideInlineCompletions(q,W,X,Q,fe){return this.s(q,x,we=>we.provideInlineCompletions($.URI.revive(W),X,Q,fe),void 0,fe)}$handleInlineCompletionDidShow(q,W,X,Q){this.s(q,x,async fe=>{fe.handleDidShowCompletionItem(W,X,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,W,X,Q,fe){this.s(q,x,async we=>{we.handlePartialAccept(W,X,Q,fe)},void 0,void 0)}$freeInlineCompletionsList(q,W){this.s(q,x,async X=>{X.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(q,W,X){const Q=new ne(q,this.h,X,this.j.converter),fe=this.t(Q,q);return this.e.$registerInlineEditProvider(fe,this.o(W,q),q.identifier),this.p(fe)}$provideInlineEdit(q,W,X,Q){return this.s(q,ne,fe=>fe.provideInlineEdits($.URI.revive(W),X,Q),void 0,Q)}$freeInlineEdit(q,W){this.s(q,ne,async X=>{X.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(q,W,X,Q){const fe=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,we=this.t(new De(this.h,X),q);return this.e.$registerSignatureHelpProvider(we,this.o(W,q),fe),this.p(we)}$provideSignatureHelp(q,W,X,Q,fe){return this.s(q,De,we=>we.provideSignatureHelp($.URI.revive(W),X,Q,fe),void 0,fe)}$releaseSignatureHelp(q,W){this.s(q,De,X=>X.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(q,W,X){const Q=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ae(this.h,this.j.converter,X,this.l,q),q);this.e.$registerInlayHintsProvider(fe,this.o(W,q),typeof X.resolveInlayHint=="function",Q,Me.u(q));let we=this.p(fe);if(Q!==void 0){const Fe=X.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(Q));we=r.$zM.from(we,Fe)}return we}$provideInlayHints(q,W,X,Q){return this.s(q,ae,fe=>fe.provideInlayHints($.URI.revive(W),X,Q),void 0,Q)}$resolveInlayHint(q,W,X){return this.s(q,ae,Q=>Q.resolveInlayHint(W,X),void 0,X)}$releaseInlayHints(q,W){this.s(q,ae,X=>X.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(q,W,X){const Q=this.t(new ce(this.h,X),q);return this.e.$registerDocumentLinkProvider(Q,this.o(W,q),typeof X.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,W,X){return this.s(q,ce,Q=>Q.provideLinks($.URI.revive(W),X),void 0,X,W.scheme==="output")}$resolveDocumentLink(q,W,X){return this.s(q,ce,Q=>Q.resolveLink(W,X),void 0,void 0,!0)}$releaseDocumentLinks(q,W){this.s(q,ce,X=>X.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(q,W,X){const Q=this.t(new se(this.h,X),q);return this.e.$registerDocumentColorProvider(Q,this.o(W,q)),this.p(Q)}$provideDocumentColors(q,W,X){return this.s(q,se,Q=>Q.provideColors($.URI.revive(W),X),[],X)}$provideColorPresentations(q,W,X,Q){return this.s(q,se,fe=>fe.provideColorPresentations($.URI.revive(W),X,Q),void 0,Q)}registerFoldingRangeProvider(q,W,X){const Q=this.q(),fe=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Pe(new K(this.h,X),q)),this.e.$registerFoldingRangeProvider(Q,this.o(W,q),q.identifier,fe);let we=this.p(Q);if(fe!==void 0){const Fe=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=r.$zM.from(we,Fe)}return we}$provideFoldingRanges(q,W,X,Q){return this.s(q,K,fe=>fe.provideFoldingRanges($.URI.revive(W),X,Q),void 0,Q)}registerSelectionRangeProvider(q,W,X){const Q=this.t(new ie(this.h,X,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(W,q)),this.p(Q)}$provideSelectionRanges(q,W,X,Q){return this.s(q,ie,fe=>fe.provideSelectionRanges($.URI.revive(W),X,Q),[],Q)}registerCallHierarchyProvider(q,W,X){const Q=this.t(new le(this.h,X),q);return this.e.$registerCallHierarchyProvider(Q,this.o(W,q)),this.p(Q)}$prepareCallHierarchy(q,W,X,Q){return this.s(q,le,fe=>Promise.resolve(fe.prepareSession($.URI.revive(W),X,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,W,X,Q){return this.s(q,le,fe=>fe.provideCallsTo(W,X,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,W,X,Q){return this.s(q,le,fe=>fe.provideCallsFrom(W,X,Q),void 0,Q)}$releaseCallHierarchy(q,W){this.s(q,le,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(q,W,X){const Q=this.t(new de(this.h,X),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(W,q)),this.p(Q)}$prepareTypeHierarchy(q,W,X,Q){return this.s(q,de,fe=>Promise.resolve(fe.prepareSession($.URI.revive(W),X,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,W,X,Q){return this.s(q,de,fe=>fe.provideSupertypes(W,X,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,W,X,Q){return this.s(q,de,fe=>fe.provideSubtypes(W,X,Q),void 0,Q)}$releaseTypeHierarchy(q,W){this.s(q,de,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(q,W,X,Q){const fe=this.q();return this.f.set(fe,new Pe(new Ae(this.e,this.h,X,fe,q),q)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(W,q),(0,s.$gG)(q,"dropMetadata")?Q:void 0),this.p(fe)}$provideDocumentOnDropEdits(q,W,X,Q,fe,we){return this.s(q,Ae,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(W,$.URI.revive(X),Q,fe,we)),void 0,void 0)}registerMappedEditsProvider(q,W,X){const Q=this.t(new me(this.h,X),q);return this.e.$registerMappedEditsProvider(Q,this.o(W,q)),this.p(Q)}$provideMappedEdits(q,W,X,Q,fe){return this.s(q,me,we=>Promise.resolve(we.provideMappedEdits(W,X,Q,fe)),null,fe)}registerDocumentPasteEditProvider(q,W,X,Q){const fe=this.q();return this.f.set(fe,new Pe(new T(this.e,this.h,X,fe,q),q)),this.e.$registerPasteEditProvider(fe,this.o(W,q),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(q,W,X,Q,fe){return this.s(q,T,we=>we.prepareDocumentPaste($.URI.revive(W),X,Q,fe),void 0,fe)}$providePasteEdits(q,W,X,Q,fe,we,Fe){return this.s(q,T,Ve=>Ve.providePasteEdits(W,$.URI.revive(X),Q,fe,we,Fe),void 0,Fe)}$resolvePasteEdit(q,W,X){return this.s(q,T,Q=>Q.resolvePasteEdit(W,X),{},void 0)}$releasePasteEdits(q,W){this.s(q,T,X=>Promise.resolve(X.releasePasteEdits(W)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Me.w(q.decreaseIndentPattern),increaseIndentPattern:Me.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Me.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Me.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Me.w(q.beforeText),afterText:q.afterText?Me.w(q.afterText):void 0,previousLineText:q.previousLineText?Me.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Me.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(W=>r.SyntaxTokenType.toString(W)):void 0}}static D(q){return q.map(Me.C)}setLanguageConfiguration(q,W,X){const{wordPattern:Q}=X;if(Q&&(0,A.$cf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(W,Q):this.h.setWordDefinitionFor(W,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const fe=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Me.w(X.wordPattern):void 0,indentationRules:X.indentationRules?Me.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Me.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Me.D(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,W,we),this.p(fe)}$setWordDefinitions(q){for(const W of q)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$7jc=Me}),define(ke[121],Ee([1,0,3,6,16,8,108,25,7,4,222,145,13,5,20,120,12]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$bkc=(0,S.$ni)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new p.$Qh,this.stream=f??new p.$Qh}}class i{constructor(){this.a=new Map,this.b=new p.$Qh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,d){this.j=f,this.k=d,this.c=new E.$_d,this.d=new E.$_d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Km,this.i=new Map,this.o=new Set,this.b=t.getProxy(O.$xM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,l){const c=o.a++;this.f.set(c,{extension:t.identifier,provider:d,languageModelId:f});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(c,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(c),this.b.$unregisterProvider(c)})}async $provideLanguageModelResponse(t,f,d,l,c,h){const g=this.f.get(t);if(!g)return;const D=new M.$Wv(async w=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:w.index,part:w.part})});return g.provider.provideLanguageModelResponse2(l.map(L.LanguageModelMessage.to),c,b.$Im.toKey(d),D,h)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[c,h]of this.i)h.languageModelId===l&&(h.res.reject(new $.$5),this.i.delete(c))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:l,enabled:c}of t){const h=this.h.get(d)??new b.$Jm;if(h.has(l)!==c){c?h.add(l):h.delete(l),this.h.set(d,h);const D={from:d,to:l};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,d,l,c){const h=t.identifier,g=await this.b.$prepareChatAccess(h,f,l.justification);if(!g||!this.g.has(f))throw R.$HO.NotFound(`Language model '${f}' is unknown.`);if(this.m(h,g)&&(!await this.l(t,{identifier:g.extension,displayName:g.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(g.extension)))throw R.$HO.NoPermissions(`Language model '${f}' cannot be used by '${h.value}'.`);const D=Math.random()*1e6|0,w=this.b.$fetchResponse(h,f,D,d.map(L.LanguageModelMessage.from),l.modelOptions??{},c),k=new p.$mh,y=new i;this.i.set(D,{languageModelId:f,res:y});let C;if(w.catch(I=>{k.isOpen()?y.reject(I):C=I}).finally(()=>{this.i.delete(D),y.resolve(),k.open()}),await k.wait(),C)throw new R.$HO(`Language model '${f}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,l){const c=P.$zL+f.identifier.value;if(await this.k.getSession(t,c,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const g=d?(0,A.localize)(0,null,f.displayName,d):(0,A.localize)(1,null,f.displayName);return await this.k.getSession(t,c,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!b.$Im.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=E.Event.signal(E.Event.filter(this.c.event,c=>b.$Im.equals(c.from,t.identifier))),l=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(d,l)},canSendRequest(c){const h=f.g.get(c);if(!h)return;if(!f.m(t.identifier,h))return!0;const g=f.h.get(t.identifier);if(g)return g.has(h.extension)}}}};e.$ckc=r,e.$ckc=r=o=Je([We(0,v.$UO),We(1,m.$Tj),We(2,a.$9jc)],r)}),define(ke[338],Ee([1,0,6,16,8,39,7,3,26]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class E{constructor(P,$,S,v){this.c=$,this.d=S,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(u.$xM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,$){await this.a.$changeLanguage(P,$);const S=this.c.getDocumentData(P);if(!S)throw new Error(`document '${P.toString()}' NOT found`);return S.document}async tokenAtPosition(P,$){const S=P.version,v=O.Position.from($),a=await this.a.$tokensAtPosition(P.uri,v),m={type:L.StandardTokenType.Other,range:P.getWordRangeAtPosition($)??new L.$BM($.line,$.character,$.line,$.character)};if(!a)return m;const o={range:O.Range.to(a.range),type:O.TokenType.to(a.type)};return!o.range.contains($)||S!==P.version?m:o}createLanguageStatusItem(P,$,S){const v=this.f++,a=this.a,m=this.g,o=`${P.identifier.value}/${$}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);m.add(o);const n={selector:S,id:$,name:P.displayName??P.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new b.$Tc,s=()=>{if(i?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${$}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$ph)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),a.$removeLanguageStatus(v),m.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,p.$hG)(P,"languageStatusText"),n.text=f,s()},get text2(){return(0,p.$hG)(P,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.$ulc=E}),define(ke[339],Ee([1,0,15,2,16,8,119]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=void 0;class b{constructor(P,$,S,v){this.start=P,this.deletedCount=$,this.deletedItems=S,this.items=v}asApiEvent(){return{range:new R.$1N(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,$,S){this.notebook=P,this.h=$,this.j=S,this.handle=S.handle,this.uri=O.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(L.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(S)}return this.f}setOutputs(P){this.a=P.map(L.NotebookCellOutput.to)}setOutputItems(P,$,S){const v=S.map(L.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===P);if(a&&($||(a.items.length=0),a.items.push(...v),a.items.length>1&&a.items.every(m=>M.$uK(m.mime)))){const m=new Map,o=[];a.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),a.items.length=0,o.forEach(n=>{const i=M.$vK(m.get(n));a.items.push({mime:n,data:i.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$glc=p;class E{static{this.a=0}constructor(P,$,S,v,a){this.k=P,this.l=$,this.m=S,this.uri=v,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,$={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===u.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(S){return S=P.n(S),P.b[S].apiCell},getCells(S){return(S?P.p(S):P.b).map(a=>a.apiCell)},save(){return P.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,$,S){this.g=P.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:S});const v={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},a=[];for(const o of P.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),a.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),a.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<a.length;o++){const n=a[o],i=m.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let $=P.start|0,S=P.end|0;return $<0&&($=0),S>this.b.length&&(S=this.b.length),P.with({start:$,end:S})}p(P){P=this.o(P);const $=[];for(let S=P.start;S<P.end;S++)$.push(this.b[S]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,$,S){if(this.j)return;const v=[],a=[],m=[];if(P.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new p(this,this.l,t);return $||a.push(p.asModelAddData(t)),f}),r=new b(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),S)for(const o of v)S.push(o.asApiEvent())}s(P,$,S,v){const a=this.b.splice(P,$);this.b.splice(S,0,...a);const m=[new b(P,$,a.map(o=>o.apiCell),[]),new b(S,0,[],a)];for(const o of m)v.push(o.asApiEvent())}t(P,$){this.b[P].setOutputs($)}u(P,$,S,v){this.b[P].setOutputItems($,S,v)}v(P,$){const S=this.b[P];S.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(S.uri,$)}w(P,$){const S=this.b[P];S.apiCell.mime=$}x(P,$){this.b[P].setMetadata($)}y(P,$){this.b[P].setInternalMetadata($)}getCellFromApiCell(P){return this.b.find($=>$.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find($=>$.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$hlc=E}),define(ke[340],Ee([1,0,4,2,16,8,48]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class b{constructor(E,A,P,$={timeout:1500,errors:3}){this.b=E,this.c=A,this.d=P,this.f=$,this.a=new u.$be}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(A,P,$)=>{const S=function(a){A.call(P,a)};return S.extension=E,this.a.event(S,void 0,$)}}async $participateInSave(E,A,P){const $=O.URI.revive(E),S=this.c.getNotebookDocument($);if(!S)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},P,async(m,o)=>{const n=Date.now(),i=await await Promise.resolve(m);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!P.isCancellationRequested&&i&&(i instanceof R.$JM?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const a={edits:[]};for(const m of v){const{edits:o}=L.WorkspaceEdit.from(m);a.edits=a.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new M.$jw(a))}}e.$wlc=b}),define(ke[153],Ee([1,0,13,16,8]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,p,E,A,P,$){this.id=b,this.f=p,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(p){this.selections=[p]},get selections(){return b.a},set selections(p){if(!Array.isArray(p)||!p.every(L.$1N.isNotebookRange))throw(0,u.$7)("selections");b.a=p,b.g(p)},get visibleRanges(){return b.b},revealRange(p,E){b.f.$tryRevealRange(b.id,O.NotebookRange.from(p),E??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$ilc=R}),define(ke[341],Ee([1,0,4,12,16]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;let R=class{constructor(b,p){this.c=b,this.d=p,this.a=new u.$_d,this.b=new u.$_d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,p);const E=this.d.getEditorById(b);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(L.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(L.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const p in b)this.d.getEditorById(p)._acceptViewColumn(L.ViewColumn.to(b[p]))}};e.$ylc=R,e.$ylc=R=Je([We(0,O.$Tj)],R)}),define(ke[342],Ee([1,0,4,6,153]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;class R{constructor(b,p){this.c=p,this.a=new Map,this.b=b.getProxy(O.$xM.MainThreadNotebookRenderers)}$postRendererMessage(b,p,E){const A=this.c.getEditorById(b);this.a.get(p)?.fire({editor:A.apiEditor,message:E})}createRendererMessaging(b,p){if(!b.contributes?.notebookRenderer?.some(A=>A.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(A,P,$)=>this.d(p).event(A,P,$),postMessage:(A,P)=>{L.$ilc.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const $=P&&L.$ilc.apiEditorsToExtHost.get(P);return this.b.$postMessage($?.id,p,A)}}}d(b){let p=this.a.get(b);return p||(p=new u.$_d({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(b)}}),this.a.set(b,p),p)}}e.$Blc=R}),define(ke[343],Ee([1,0,16,108,22,55,13]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class b{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,$,S){const v=this.b++,{title:a,location:m,cancellable:o}=$,n={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(m),title:a,source:n,cancellable:o},P.isUnderDevelopment?void 0:P.identifier.value).catch(M.$2),this.d(v,S,!!o)}d(P,$,S){let v;S&&(v=new L.$je,this.c.set(P,v));const a=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let m;try{m=$(new E(this.a,P),S&&v?v.token:L.CancellationToken.None)}catch(o){throw a(P),o}return m.then(o=>a(P),o=>a(P)),m}$acceptProgressCanceled(P){const $=this.c.get(P);$&&($.cancel(),this.c.delete(P))}}e.$Flc=b;function p(A,P){return A.message=P.message,typeof P.increment=="number"&&(typeof A.increment=="number"?A.increment+=P.increment:A.increment=P.increment),A}class E extends O.$Wv{constructor(P,$){super(S=>this.throttledReport(S)),this.c=P,this.d=$}throttledReport(P){this.c.$progressReport(this.d,P)}}Je([(0,R.$Th)(100,(A,P)=>p(A,P),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[344],Ee([1,0,2,6,7,16]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class M{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(O.$xM.MainThreadQuickDiff)}$provideOriginalResource(p,E,A){const P=u.URI.revive(E),$=this.c.get(p);return $?(0,L.$fh)(()=>$.provideOriginalResource(P,A)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(p,E,A,P){const $=M.a++;return this.c.set($,E),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(p,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Glc=M}),define(ke[345],Ee([1,0,22,4,3,6,2,8,13,19,39,57,26,16]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=v;function v(a,m,o){const n=a.getProxy(R.$xM.MainThreadQuickOpen);class i{constructor(g,D){this.e=new Map,this.f=0,this.a=g,this.b=D}showQuickPick(g,D,w,k=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,I=n.$show(C,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},k),z={},j=I.then(()=>z);return Promise.race([j,y]).then(F=>{if(F===z)return;const N=(0,$.$gG)(g,"quickPickItemTooltip");return y.then(T=>{const B=[];for(let H=0;H<T.length;H++){const Z=T[H];if(typeof Z=="string")B.push({label:Z,handle:H});else if(Z.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:Z.label});else{Z.tooltip&&!N&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const ee=Z.iconPath?d(Z.iconPath):void 0;B.push({label:Z.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:N?S.MarkdownString.fromStrict(Z.tooltip):void 0,handle:H})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=H=>{w.onDidSelectItem(T[H])}),n.$setItems(C,B),I.then(H=>{if(typeof H=="number")return T[H];if(Array.isArray(H))return H.map(Z=>T[Z])})})}).then(void 0,F=>{if(!(0,p.$4)(F))return n.$setError(C,F),Promise.reject(F)})}$onItemSelected(g){this.c?.(g)}showInput(g,D=u.CancellationToken.None){return this.d=g?.validateInput,n.$input(g,typeof this.d=="function",D).then(void 0,w=>{if(!(0,p.$4)(w))return Promise.reject(w)})}async $validateInput(g){if(!this.d)return;const D=await this.d(g);if(!D||typeof D=="string")return D;let w;switch(D.severity){case b.InputBoxValidationSeverity.Info:w=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=A.default.Error;break;default:w=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:w}}async showWorkspaceFolderPick(g,D=u.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!w)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(g){const D=new l(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(g){const D=new c(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(g,D){this.e.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const w=this.e.get(g);w instanceof l&&w._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const w=this.e.get(g);w instanceof l&&w._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this.e.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,w){const k=this.e.get(g);k instanceof l&&k._fireDidTriggerItemButton(D,w)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class r{static{this.a=1}constructor(g,D){this.x=g,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$_d,this.q=new O.$_d,this.r=new O.$_d,this.s=new O.$_d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((D,w)=>{const k=D===b.$XN.Back?-1:w;this.o.set(k,D)}),this.z({buttons:g.map((D,w)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===b.$XN.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const D=this.o.get(g);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(g){if(!this.v){for(const D of Object.keys(g)){const w=g[D];this.u[D]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof b.$vN)return{id:h.id};const g=f(h),D=t(h);return{dark:typeof g=="string"?M.URI.file(g):g,light:typeof D=="string"?M.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const g=s(h);let D,w;return"id"in g?w=P.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:w}}class l extends r{constructor(g,D){super(g.identifier,D),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$_d,this.L=[],this.M=new O.$_d,this.N=new O.$_d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((k,y)=>{this.C.set(y,k),this.D.set(k,y)});const D=(0,$.$gG)(this.O,"quickPickItemTooltip"),w=[];for(let k=0;k<g.length;k++){const y=g[k];if(y.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?d(y.iconPath):void 0;w.push({handle:k,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((I,z)=>({...d(I.iconPath),tooltip:I.tooltip,handle:z}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(g){const D=(0,E.$Hb)(g.map(w=>this.C.get(w)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(g){const D=(0,E.$Hb)(g.map(w=>this.C.get(w)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(g,D){const w=this.C.get(g);if(!w||!w.buttons||!w.buttons.length)return;const k=w.buttons[D];k&&this.N.fire({button:k,item:w})}}class c extends r{constructor(g,D){super(g.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:A.default.Error}):this.z({validationMessage:g.message,severity:g.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(m,o)}}),define(ke[346],Ee([1,0,2,4,55,3,7,6,19,131,12,25,57,16,26,15,11]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=e.$Ilc=void 0;function n(C){return C instanceof u.URI}function i(C,I){return C.scheme===a.Schemas.file&&I.scheme===a.Schemas.file&&m.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function r(C){if(C)return typeof C.iconPath=="string"?u.URI.file(C.iconPath):u.URI.isUri(C.iconPath)||$.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function s(C){if(C.icon){if(u.URI.isUri(C.icon))return C.icon;if($.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const z=typeof C.iconPath=="string"?C.iconPath:u.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:u.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,E.$fr)(z,j)}function f(C,I){let z=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(z=t(C,I),z!==0)return z;if(C.light&&I.light)z=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(z!==0)return z;if(C.dark&&I.dark)z=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return z}function d(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let z=0;z<C.arguments.length;z++){const j=C.arguments[z],F=I.arguments[z];if(j!==F&&!(n(j)&&n(F)&&i(j,F)))return j<F?-1:1}return 0}function l(C,I){let z=(0,E.$fr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(z!==0)return z;if(C.command&&I.command)z=d(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(z!==0)return z;if(C.decorations&&I.decorations)z=f(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)z=(0,E.$fr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)z=(0,E.$fr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return z}function c(C,I){for(let z=0;z<C.length;z++)if(C[z]!==I[z])return!1;return!0}function h(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?c(C.arguments,I.arguments):C.arguments===I.arguments)}function g(C,I){return(0,p.$ub)(C,I,h)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$hG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$hG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$hG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,z,j,F,N){this.k=I,this.l=F,this.m=N,this.d="",this.e=new O.$_d,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=j}showValidationMessage(I,z){(0,v.$hG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,z)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Ilc=D;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,z,j,F,N,T,B){this.q=I,this.s=z,this.t=j,this.u=F,this.v=N,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$_d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$_d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,z){const j=this.h.get(I);return j?(0,M.$fh)(()=>this.s.executeCommand(j.command,...j.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(l),j=(0,p.$Db)(this.o,I,l).map(T=>{const B=T.toInsert.map(H=>{const Z=this.e++;this.g.set(Z,H);const ee=H.resourceUri;let J;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"||H.command.command==="vscode.changes"){const se=new R.$Tc;J=this.s.converter.toInternal(H.command,se),this.j.set(Z,se)}else this.h.set(Z,H.command);const Y=(0,v.$gG)(this.w,"scmMultiDiffEditor"),re=Y?H.multiDiffEditorOriginalUri:void 0,te=Y?H.multiFileDiffEditorModifiedUri:void 0,pe=r(H.decorations),Ce=H.decorations&&r(H.decorations.light)||pe,x=H.decorations&&r(H.decorations.dark)||pe,U=[Ce,x],ne=H.decorations&&H.decorations.tooltip||"",be=H.decorations&&!!H.decorations.strikeThrough,De=H.decorations&&!!H.decorations.faded,ae=H.contextValue||"";return{rawResource:[Z,ee,U,ne,be,De,ae,J,re,te],handle:Z}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),F=j.map(({start:T,deleteCount:B,toInsert:H})=>[T,B,H.map(Z=>Z.rawResource)]),N=j.reverse();for(const{start:T,deleteCount:B,toInsert:H}of N){const Z=H.map(J=>J.handle),ee=this.n.splice(T,B,...Z);for(const J of ee)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=I,F}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let z;(0,v.$gG)(this.x,"quickDiffProvider")&&(z=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:z})}get historyProvider(){return(0,v.$hG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$hG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const z=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,v.$hG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$hG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const z=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(F=>this.y.converter.toInternal(F,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&g(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const z=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(I,z,j,F,N,T,B){this.x=I,this.y=F,this.z=N,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new O.$_d,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const H=u.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,z,this.#e,this.w,H),this.#e.$registerSourceControl(this.w,N,T,B,H)}createResourceGroup(I,z,j){const F=(0,v.$gG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,N=new w(this.#e,this.y,this.w,I,z,F,this.x),T=O.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,T),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const I=[],z=[];for(const[j,F]of this.C){F.dispose();const N=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});O.Event.once(j.onDidDispose)(()=>{this.D.delete(j),N.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&z.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,z),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(z=>{const j=z._takeResourceStateSnapshot();j.length!==0&&I.push([z.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Sh)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Sh)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,z,j,F){this.l=z,this.m=j,this.n=F,this.g=new Map,this.h=new P.$Km,this.j=new O.$_d,this.e=I.getProxy(b.$xM.MainThreadSCM),this.f=I.getProxy(b.$xM.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const T=this.g.get(N.sourceControlHandle);if(!T)return N;const B=T.getResourceGroup(N.groupHandle);return B?B.getResourceState(N.handle):N}else if(N&&N.$mid===4){const T=this.g.get(N.sourceControlHandle);return T?T.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const T=this.g.get(N.handle);return T||N}return N}})}createSourceControl(I,z,j,F){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,z,j,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const N=o.d++,T=new k(I,this.m,this.e,this.l,z,j,F);this.g.set(N,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const z=this.h.get(I.identifier),j=z&&z[z.length-1];return j&&j.inputBox}$provideOriginalResource(I,z,j){const F=u.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",I,F.toString());const N=this.g.get(I);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$fh)(()=>N.quickDiffProvider.provideOriginalResource(F,j)).then(T=>T||null)}$onInputBoxValueChange(I,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(I,z,j,F){this.n.trace("ExtHostSCM#$executeResourceCommand",I,z,j);const N=this.g.get(I);if(!N)return Promise.resolve(void 0);const T=N.getResourceGroup(z);return T?T.$executeResourceCommand(j,F):Promise.resolve(void 0)}$validateInput(I,z,j){this.n.trace("ExtHostSCM#$validateInput",I);const F=this.g.get(I);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,M.$fh)(()=>F.inputBox.validateInput(z,j)).then(N=>{if(!N)return Promise.resolve(void 0);const T=S.MarkdownString.fromStrict(N.message);return T?Promise.resolve([T,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,z,j,F){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,j,F)??void 0}async $provideHistoryItems(I,z,j,F){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(z,j,F))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(I,z,j,F){const N=this.g.get(I)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const T=await N.provideHistoryItemSummary(z,j,F);return T?{...T,icon:s(T)}:void 0}async $provideHistoryItemChanges(I,z,j,F){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(z,j,F)??void 0}};e.$Jlc=y,e.$Jlc=y=o=Je([We(3,A.$Tj)],y)}),define(ke[347],Ee([1,0,6,16,2]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class R{static{this.a=0}constructor(b,p){this.d=p,this.c=new Map,this.b=b.getProxy(u.$xM.MainThreadShare)}async $provideShare(b,p,E){return await this.c.get(b)?.provideShare({selection:O.Range.to(p.selection),resourceUri:L.URI.revive(p.resourceUri)},E)??void 0}registerShareProvider(b,p){const E=R.a++;return this.c.set(E,p),this.b.$registerShareProvider(E,O.DocumentSelector.from(b,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Klc=R}),define(ke[348],Ee([1,0,8,6,225,3,16,18]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Mlc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$wN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$wN("statusBarItem.warningForeground")]])}#e;#t;constructor($,S,v,a,m,o=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=$,this.#t=S,m&&a){this.c=(0,u.$$M)(a.identifier,m);const i=v.get(this.c);i&&(o=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=a,this.f=m,this.g=o,this.h=this.u(n)}u($){if((0,b.$5f)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!p.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let S;this.m?S=this.m:S=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=p.b.get(this.o.id));const a=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,S,this.k,a,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Mlc=p;class E{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const S={message:$};return this.b.unshift(S),this.c(),new u.$zM(()=>{const v=this.b.indexOf(S);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,S){this.e=new Map,this.a=$.getProxy(O.$xM.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries($){for(const S of $)this.e.set(S.entryId,S)}createStatusBarEntry($,S,v,a){return new p(this.a,this.b,this.e,$,S,v,a)}setStatusBarMessage($,S){const v=this.c.setMessage($);let a;return typeof S=="number"?a=setTimeout(()=>v.dispose(),S):typeof S<"u"&&S.then(()=>v.dispose(),()=>v.dispose()),new u.$zM(()=>{v.dispose(),clearTimeout(a)})}}e.$Nlc=A}),define(ke[154],Ee([1,0,29,144,68,112,89,16,2]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=e.$8O=e.$7O=void 0;const E=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const l=f;f=d,i.listener?.(t(d,l))}}}},A=(i,r)=>i===r,P={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},$=i=>r=>({op:4,update:i(r)}),S=(i,r)=>({range:(()=>{let s;const t=$(f=>({range:u.$ht.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),P.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:E(i,r,P.label,$(s=>({label:s}))),description:E(i,void 0,P.description,$(s=>({description:s}))),sortText:E(i,void 0,P.sortText,$(s=>({sortText:s}))),canResolveChildren:E(i,!1,P.canResolveChildren,s=>({op:2,state:s})),busy:E(i,!1,P.busy,$(s=>({busy:s}))),error:E(i,void 0,P.error,$(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:E(i,[],P.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const r=L.$jL.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$pL)(t).tagId})),s},a=i=>{let r;for(const s of i.tests){const t=v(s.item);(0,O.$QO)(t).parent=r,r=t}return r};e.$7O=a;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,O.$PO)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$OO)(d,O.$QO,m),enumerable:!0,writable:!1},...S(d,t)})}}e.$8O=m;class o extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$9O=o;class n extends R.$KO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:O.$QO,getChildren:f=>f.children,root:new o(r,s),toITestItem:b.TestItem.from})}}e.$0O=n}),define(ke[33],Ee([1,0,18,8,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,38,87,90,30]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=void 0;let d=class{#e;#t;#i;constructor(w,k,y){this.b=new Map,this.c=new Map,this.#e=w.getProxy(M.$xM.MainThreadCommands),this.d=k,this.#i=y,this.#t=w.getProxy(M.$xM.MainThreadTelemetry),this.converter=new l(this,C=>{const I=this.c.get(C);return I?.result===h.Void?I:void 0},k),this.f=[{processArgument(C){return(0,E.$Wh)(C)}},{processArgument(C){return(0,R.$Vn)(C,function(I){if(A.$ht.isIRange(I))return L.Range.to(I);if(P.$gt.isIPosition(I))return L.Position.to(I);if(A.$ht.isIRange(I.range)&&$.URI.isUri(I.uri))return L.location.to(I);if(I instanceof o.$ze)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const k=this.registerCommand(!1,w.id,async(...y)=>{const C=w.args.map((z,j)=>{if(!z.validate(y[j]))throw new Error(`Invalid argument '${z.name}' when running '${w.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return z.convert(y[j])}),I=await this.executeCommand(w.internalId,...C);return w.result.convert(I,y,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new O.$zM(()=>{k.dispose(),this.c.delete(w.id)})}registerCommand(w,k,y,C,I,z){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:y,thisArg:C,metadata:I,extension:z}),w&&this.#e.$registerCommand(k),new O.$zM(()=>{this.b.delete(k)&&w&&this.#e.$unregisterCommand(k)})}executeCommand(w,...k){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,k,!0)}async g(w,k,y){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,k,!1);{let C=!1;const I=(0,R.$Vn)(k,function(z){if(z instanceof O.$AM)return L.Position.from(z);if(z instanceof O.$BM)return L.Range.from(z);if(z instanceof O.$LM)return L.location.from(z);if(O.$1N.isNotebookRange(z))return L.NotebookRange.from(z);if(z instanceof ArrayBuffer)return C=!0,o.$ze.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return C=!0,o.$ze.wrap(z);if(z instanceof o.$ze)return C=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(w,C?new n.$jw(I):I,y);return(0,E.$Wh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(w,k,!1);throw z}}}async h(w,k,y){const C=this.b.get(w);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:z,metadata:j}=C;if(j?.args)for(let N=0;N<j.args.length;N++)try{(0,u.$fg)(k[N],j.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${j.args[N].name}' - ${j.args[N].description}`)}const F=r.$8d.create();try{return await I.apply(z,k)}catch(N){if(w===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...k);T&&(w=T.command)}if(this.d.error(N,w,C.extension?.identifier),!y)throw N;if(C.extension?.identifier){const T=this.#i.onExtensionError(C.extension.identifier,N);this.d.trace("forwarded error to extension?",T,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$$i)(N)),this.id=w,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,w,F.elapsed())}}j(w,k,y){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new s.$9o(k),duration:y})}$executeContributedCommand(w,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const y=this.b.get(w);return y?(k=k.map(C=>this.f.reduce((I,z)=>z.processArgument(I,y.extension?.identifier),C)),this.h(w,k,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(k=>(w&&(k=k.filter(y=>y[0]!=="_")),k))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[k,y]of this.b){const{metadata:C}=y;C&&(w[k]=C)}return Promise.resolve(w)}};e.$dP=d,e.$dP=d=Je([We(0,a.$UO),We(1,p.$Tj),We(2,t.$cP)],d),e.$eP=(0,v.$ni)("IExtHostCommands");class l{constructor(w,k,y){this.d=w,this.f=k,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Jg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,k){if(!w)return;const y={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return y;const C=this.f(w.command);if(C)y.id=C.internalId,y.arguments=C.args.map((I,z)=>I.convert(w.arguments&&w.arguments[z]));else if((0,b.$Lb)(w.arguments)){const I=`${w.command} /${++this.c}`;this.b.set(I,w),k.add((0,S.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),y.$ident=I,y.id=this.delegatingCommandId,y.arguments=[I],this.g.trace("CommandsConverter#CREATE",w.command,I)}return y}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const k=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$fP=l;class c{static{this.Uri=new c("uri","Uri of a text document",w=>$.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>O.$AM.isPosition(w),L.Position.from)}static{this.Range=new c("range","A range in a text document",w=>O.$BM.isRange(w),L.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>O.$CM.isSelection(w),L.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,k=>Array.isArray(k)&&k.every(y=>w.validate(y)),k=>k.map(y=>w.convert(y)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof O.$WM,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof O.$iO,L.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof m.$8O,L.TestItem.from)}constructor(w,k,y,C){this.name=w,this.description=k,this.validate=y,this.convert=C}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,k){return new c(w??this.name,k??this.description,this.validate,this.convert)}}e.$gP=c;class h{static{this.Void=new h("no result",w=>w)}constructor(w,k){this.description=w,this.convert=k}}e.$hP=h;class g{constructor(w,k,y,C,I){this.id=w,this.internalId=k,this.description=y,this.args=C,this.result=I}}e.$iP=g}),define(ke[349],Ee([1,0,19,15,2,83,134,40,33,16,8]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;const P=[new p.$iP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new p.$iP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$gP.Uri],new p.$hP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,u.$Kb)(a))return;class o extends A.$RM{static to(i){const r=new o(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new A.$LM(m[0],E.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=E.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return a.map(o.to)})),new p.$iP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$gP.Uri,new p.$gP("options","Formatting options",a=>!0,a=>a)],new p.$hP("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$iP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$gP.Uri,p.$gP.Range,new p.$gP("options","Formatting options",a=>!0,a=>a)],new p.$hP("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$iP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$gP.Uri,p.$gP.Position,new p.$gP("ch","Trigger character",a=>typeof a=="string",a=>a),new p.$gP("options","Formatting options",a=>!0,a=>a)],new p.$hP("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$iP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$iP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$iP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$iP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$iP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of Location-instances.",S(E.location.to))),new p.$iP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new p.$iP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$gP.Uri,new p.$gP("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.$AM.isPosition(m)),a=>a.map(E.Position.from))],new p.$hP("A promise that resolves to an array of ranges.",a=>a.map(m=>{let o;for(const n of m.reverse())o=new A.$VM(E.Range.to(n),o);return o}))),new p.$iP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$gP.String.with("query","Search string")],new p.$hP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(E.WorkspaceSymbol.to))),new p.$iP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(E.CallHierarchyItem.to))),new p.$iP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$gP.CallHierarchyItem],new p.$hP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(E.CallHierarchyIncomingCall.to))),new p.$iP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$gP.CallHierarchyItem],new p.$hP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(E.CallHierarchyOutgoingCall.to))),new p.$iP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:E.Range.to(a.range),placeholder:a.text}})),new p.$iP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$gP.Uri,p.$gP.Position,p.$gP.String.with("newName","The new symbol name")],new p.$hP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return E.WorkspaceEdit.to(a)}})),new p.$iP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$gP.Uri,p.$gP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$hP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(E.DocumentLink.to))),new p.$iP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$gP.Uri],new p.$hP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$RN(a.tokenTypes,a.tokenModifiers)})),new p.$iP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$gP.Uri],new p.$hP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,M.$1ab)(a);if(m.type==="full")return new A.$TN(m.data,void 0)})),new p.$iP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$gP.Uri,p.$gP.Range.optional()],new p.$hP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$RN(a.tokenTypes,a.tokenModifiers)})),new p.$iP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$gP.Uri,p.$gP.Range],new p.$hP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,M.$1ab)(a);if(m.type==="full")return new A.$TN(m.data,void 0)})),new p.$iP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$gP.Uri,p.$gP.Position,p.$gP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$gP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$hP("A promise that resolves to a CompletionList-instance.",(a,m,o)=>{if(!a)return new A.$8M([]);const n=a.suggestions.map(i=>E.CompletionItem.to(i,o));return new A.$8M(n,a.incomplete)})),new p.$iP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$gP.Uri,p.$gP.Position,p.$gP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$hP("A promise that resolves to SignatureHelp.",a=>{if(a)return E.SignatureHelp.to(a)})),new p.$iP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$gP.Uri,p.$gP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$hP("A promise that resolves to an array of CodeLens-instances.",(a,m,o)=>S(n=>new A.$ZM(E.Range.to(n.range),n.command&&o.fromInternal(n.command)))(a))),new p.$iP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$gP.Uri,new p.$gP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$BM.isRange(a),a=>A.$CM.isSelection(a)?E.Selection.from(a):E.Range.from(a)),p.$gP.String.with("kind","Code action kind to return code actions for").optional(),p.$gP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$hP("A promise that resolves to an array of Command-instances.",(a,m,o)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$TM(n.title,n.kind?new A.$UM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(a))),new p.$iP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$gP.Uri],new p.$hP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.$bN(E.Range.to(m.range),E.Color.to(m.color))):[])),new p.$iP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$gP("color","The color to show and insert",a=>a instanceof A.$aN,E.Color.from),new p.$gP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:E.Range.from(a.range)}))],new p.$hP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(E.ColorPresentation.to):[])),new p.$iP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$gP.Uri,p.$gP.Range],new p.$hP("A promise that resolves to an array of Inlay objects",(a,m,o)=>a.map(E.InlayHint.to.bind(void 0,o)))),new p.$iP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$gP.Uri],new p.$hP("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(E.FoldingRange.to)})),new p.$iP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$hP("A promise that resolves to an array of NotebookContentProvider static info objects.",S(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>E.NotebookExclusiveDocumentPattern.to(m))})))),new p.$iP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$gP.Uri,p.$gP.Range,new p.$gP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$BM,a=>E.InlineValueContext.from(a))],new p.$hP("A promise that resolves to an array of InlineValue objects",a=>a.map(E.InlineValue.to))),new p.$iP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$gP("uriOrString","Uri-instance or string (only http/https)",a=>L.URI.isUri(a)||typeof a=="string"&&(0,O.$xg)(a,O.Schemas.http,O.Schemas.https),a=>a),new p.$gP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[E.ViewColumn.from(a),void 0]:[E.ViewColumn.from(a.viewColumn),E.TextEditorOpenOptions.from(a)])).optional(),p.$gP.String.with("label","").optional()],p.$hP.Void),new p.$iP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$gP.Uri.with("resource","Resource to open"),p.$gP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$gP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[E.ViewColumn.from(a),void 0]:[E.ViewColumn.from(a.viewColumn),E.TextEditorOpenOptions.from(a)])).optional()],p.$hP.Void),new p.$iP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$gP.Uri.with("left","Left-hand side resource of the diff editor"),p.$gP.Uri.with("right","Right-hand side resource of the diff editor"),p.$gP.String.with("title","Human readable title for the diff editor").optional(),new p.$gP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[E.ViewColumn.from(a.viewColumn),E.TextEditorOpenOptions.from(a)]).optional()],p.$hP.Void),new p.$iP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$gP.String.with("title","Human readable title for the changes editor"),new p.$gP("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[o,n,i]=m;if(!L.URI.isUri(o)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],p.$hP.Void),new p.$iP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$gP.Uri,p.$gP.Position],new p.$hP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(E.TypeHierarchyItem.to))),new p.$iP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$gP.TypeHierarchyItem],new p.$hP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(E.TypeHierarchyItem.to))),new p.$iP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$gP.TypeHierarchyItem],new p.$hP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(E.TypeHierarchyItem.to))),new p.$iP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$gP.TestItem],p.$hP.Void),new p.$iP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$gP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$hP.Void),new p.$iP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$gP.String.with("name","The context key name"),new p.$gP("value","The context key value",()=>!0,a=>a)],p.$hP.Void),new p.$iP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$gP.Uri,p.$gP.StringArray,new p.$gP("MappedEditsContext","Mapped Edits Context",a=>E.MappedEditsContext.is(a),a=>E.MappedEditsContext.from(a))],new p.$hP("A promise that resolves to a workspace edit or null",a=>a?E.WorkspaceEdit.to(a):null))];class ${static register(m){P.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",b.$mj)}}e.$8jc=$;function S(a){return m=>{if(Array.isArray(m))return m.map(a)}}function v(a){if(!Array.isArray(a))return;const m=[];for(const o of a)R.$Yt(o)?m.push(E.DefinitionLink.to(o)):m.push(E.location.to(o));return m}}),define(ke[350],Ee([1,0,7,3,2,6,33,16,8]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class E{static{this.a=0}constructor(S,v){this.extension=S,this.provider=v,this.handle=E.a++}}class A{constructor(S){this.session=S,this.responses=[]}}class P{static{this.a=0}constructor(S,v,a,m){this.f=a,this.g=m,this.b=new Map,this.d=new Map,this.e=S.getProxy(R.$xM.MainThreadInlineChat),v.registerApiCommand(new M.$iP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$gP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?b.Range.from(o.initialRange):void 0,initialSelection:p.$CM.isSelection(o.initialSelection)?b.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?b.Position.from(o.position):void 0}})],M.$hP.Void))}registerProvider(S,v,a){const m=new E(S,v);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,a?.label??S.displayName??S.name,S.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",a?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(S,v,a,m){const o=this.b.get(S);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=b.Selection.to(a),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=P.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(r.wholeRange),message:r.message}}async $provideResponse(S,v,a,m){const o=this.b.get(S);if(!o)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:a.prompt,selection:b.Selection.to(a.selection),wholeRange:b.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this.f.getDocument(L.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async D=>{if(!a.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.$1M.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,m));let f;try{f=await(0,u.$bh)(t,m)}finally{r=!0}if(!f)return;const d=n.responses.push(f)-1,l={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!P.h(f))return{...l,id:d,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:c,contents:h}=f,g=h!==void 0?b.MarkdownString.from(h):void 0;return c instanceof p.$JM?{...l,id:d,type:"bulkEdit",edits:b.WorkspaceEdit.from(c),message:g}:{...l,id:d,type:"editorEdit",edits:c.map(b.TextEdit.from),message:g}}async $provideFollowups(S,v,a,m){const o=this.b.get(S),n=this.d.get(v),i=n?.responses[a];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,m));return(await(0,u.$bh)(r,m))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(S,v,a,m){const o=this.b.get(S),n=this.d.get(v),i=n?.responses[a];if(o&&i){const r=b.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(S,v){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$flc=P}),define(ke[351],Ee([1,0,2,33]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class L{constructor(M,b,p,E,A){this.a=b,this.b=p,this.c=E;const P=new O.$iP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$gP("showOptions","Show Options",$=>!0,$=>$),new O.$gP("resource","Interactive resource Uri",$=>!0,$=>$),new O.$gP("controllerId","Notebook controller Id",$=>!0,$=>$),new O.$gP("title","Interactive editor title",$=>!0,$=>$)],new O.$hP("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const S=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri),notebookEditor:S.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(M,b,p,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:p,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$slc=L}),define(ke[352],Ee([1,0,19,7,22,4,3,27,2,25,12,6,33,16,8,113,295,26,48,296]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0,e.$Alc=c;let r=class{constructor(g,D,w,k,y){this.m=D,this.n=w,this.o=k,this.q=y,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$_d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(P.$xM.MainThreadNotebookKernels);const C=new $.$iP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$gP("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const j=this.n.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:j}}else if(z&&"notebookEditor"in z){const j=this.n.getIdByEditor(z.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return z})],$.$hP.Void),I=new $.$iP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[$.$gP.Uri],new $.$hP("A promise that resolves to an array of variables",(z,j)=>z.map(F=>({variable:{name:F.name,value:F.value,expression:F.expression,type:F.type,language:F.language},hasNamedChildren:F.hasNamedChildren,indexedChildrenCount:F.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(g,D,w,k,y,C){for(const pe of this.j.values())if(pe.controller.id===D&&E.$Im.equals(g.identifier,pe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,z=this;this.q.trace(`NotebookController[${I}], CREATED by ${g.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${g.identifier}'`);let F=!1;const N=new R.$_d,T=new R.$_d,B={id:c(g.identifier,D),notebookType:w,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:k||g.identifier.value,preloads:C?C.map(S.NotebookRendererScript.from):[]};let H=y??j,Z,ee;this.a.$addKernel(I,B).catch(pe=>{console.log(pe),F=!0});let J=0;const Y=()=>{if(F)return;const pe=++J;Promise.resolve().then(()=>{pe===J&&this.a.$updateKernel(I,B)})},re=new b.$Bc,te={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return B.label},set label(pe){B.label=pe??g.displayName??g.name,Y()},get detail(){return B.detail??""},set detail(pe){B.detail=pe,Y()},get description(){return B.description??""},set description(pe){B.description=pe,Y()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(pe){B.supportedLanguages=pe,Y()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){B.supportsExecutionOrder=pe,Y()},get rendererScripts(){return B.preloads?B.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(pe){H=pe??j},get interruptHandler(){return Z},set interruptHandler(pe){Z=pe,B.supportsInterrupt=!!pe,Y()},set variableProvider(pe){(0,o.$hG)(g,"notebookVariableProvider"),ee=pe,B.hasVariableProvider=!!pe,pe?.onDidChangeVariables(Ce=>z.a.$variablesUpdated(Ce.uri)),Y()},get variableProvider(){return ee},createNotebookCellExecution(pe){if(F)throw new Error("notebook controller is DISPOSED");if(!re.has(pe.notebook.uri))throw z.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return z._createNotebookCellExecution(pe,c(g.identifier,this.id))},createNotebookExecution(pe){if((0,o.$hG)(g,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!re.has(pe.uri))throw z.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return z._createNotebookExecution(pe,c(g.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${I}], DISPOSED`),F=!0,this.j.delete(I),N.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(pe,Ce){Ce===v.NotebookControllerAffinity2.Hidden&&(0,o.$hG)(g,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(I,pe.uri,Ce)},onDidReceiveMessage:T.event,postMessage(pe,Ce){return(0,o.$hG)(g,"notebookMessaging"),z.a.$postMessage(I,Ce&&z.n.getIdByEditor(Ce),pe)},asWebviewUri(pe){return(0,o.$hG)(g,"notebookMessaging"),(0,a.$vxb)(pe,z.m.remote)}};return this.j.set(I,{extensionId:g.identifier,controller:te,onDidReceiveMessage:T,onDidChangeSelection:N,associatedNotebooks:re}),te}getIdByController(g){for(const[D,w]of this.j)if(w.controller===g)return c(w.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const w=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(w,D);const y={dispose:()=>{this.f.delete(w),k.a.$removeKernelDetectionTask(w)}};return this.f.set(w,y),y}registerKernelSourceActionProvider(g,D,w){const k=this.i++,y=typeof w.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,w),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return y!==void 0&&(I=w.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(g,D){const w=this.h.get(g);if(w){const k=new M.$Tc;return(await w.provideNotebookKernelSourceActions(D)??[]).map(C=>S.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(g,D,w){const k=this.j.get(g);if(k){const y=this.n.getNotebookDocument(p.URI.revive(D));w?k.associatedNotebooks.set(y.uri,!0):k.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,y.uri.toString(),w),k.onDidChangeSelection.fire({selected:w,notebook:y.apiNotebook})}}async $executeCells(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(D)),C=[];for(const I of w){const z=y.getCell(I);z&&C.push(z.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,y.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,y.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${g}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,y.apiNotebook);else for(const C of w){const I=y.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(y.uri);w.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(g,D,w,k,y,C,I){const z=this.j.get(g);if(!z)return;const j=this.n.getNotebookDocument(p.URI.revive(w)),F=z.controller.variableProvider;if(!F)return;let N;if(k!==void 0){if(N=this.s[k],!N)return}else this.s={};const T=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=F.provideVariables(j.apiNotebook,N,T,C,I);let H=0;for await(const Z of B){if(I.isCancellationRequested)return;const ee={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,interfaces:Z.variable.interfaces,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[ee.id]=Z.variable,this.a.$receiveVariable(D,ee),H++>=i.$Vhb)return}}$acceptKernelMessageFromRenderer(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:w}))}$cellExecutionChanged(g,D,w){const y=this.n.getNotebookDocument(p.URI.revive(g)).getCell(D);if(y){const C=w?S.NotebookCellExecutionState.to(w):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const y=new t(D,k,this.a);this.b.set(k.uri,y);const C=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),C.dispose(),this.b.delete(k.uri))});return y.asApiObject()}_createNotebookExecution(g,D){const w=this.n.getNotebookDocument(g.uri),k=g.getCells().find(I=>{const z=w.getCellFromApiCell(I);return z&&this.b.has(z.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const y=new d(D,w,this.a),C=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),C.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[y,C]),y.asApiObject()}};e.$zlc=r,e.$zlc=r=Je([We(4,A.$Tj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,D,w){super(),this.m=D,this.n=w,this.b=t.a++,this.c=new R.$_d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new L.$je),this.h=new l(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const D=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$jw(D))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let D=this.m;if(g&&(D=this.m.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}y(g){return g.map(D=>{const w=v.$5N.ensureUniqueMimeTypes(D.items,!0);return w===D.items?S.NotebookCellOutput.from(D):S.NotebookCellOutput.from({items:w,id:D.id,metadata:D.metadata})})}async z(g,D,w){const k=this.w(D),y=this.y((0,u.$3b)(g));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:k,append:w,outputs:y})}async C(g,D,w){return g=v.$5N.ensureUniqueMimeTypes((0,u.$3b)(g),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(S.NotebookCellOutputItem.from),outputId:D.id,append:w})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(w){g.j=w,g.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(w){if(g.f===s.Resolved||g.f===s.Started)throw new Error("Cannot call start again");g.f=s.Started,g.c.fire(),g.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,k,y){if(g.f===s.Resolved)throw new Error("Cannot call resolve twice");g.f=s.Resolved,g.c.fire(),g.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;g.n.$completeExecution(g.b,new n.$jw({runEndTime:k,lastRunSuccess:w,error:C}))},clearOutput(w){return g.t(),g.z([],w,!1)},appendOutput(w,k){return g.t(),g.z(w,k,!0)},replaceOutput(w,k){return g.t(),g.z(w,k,!1)},appendOutputItems(w,k){return g.t(),g.C(w,k,!0)},replaceOutputItems(w,k){return g.t(),g.C(w,k,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class d extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,D,w){super(),this.h=D,this.j=w,this.b=d.a++,this.c=new R.$_d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new L.$je),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(g,D){this.f=g,this.g=D,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new O.$Kh,this.b=Date.now(),(0,O.$oh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>g.complete())}}function c(h,g){return`${h.value}/${g}`}}),define(ke[42],Ee([1,0,4,6,5,2,20,3,8,227,13,272,22,30,273,57,7,16,33]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=e.$Nkc=e.$Mkc=void 0,e.$Mkc=(0,L.$ni)("IExtHostTerminalService");class i extends b.$Uc{constructor(w,k,y,C){super(),this.u=w,this._id=k,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new u.$_d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(z=>this.g=z);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(z,j=!0){I.C(),I.u.$sendText(I._id,z,j)},show(z){I.C(),I.u.$show(I._id,z)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??k?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:a.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(w.location,k?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,k,y,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:a.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(w,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,k){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in w?{viewColumn:o.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,k){this.j=Object.freeze({code:w,reason:k})}setDimensions(w,k){return w===this.f&&k===this.h||w===0||k===0?!1:(this.f=w,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(k=>{k!==w&&(this.b=Promise.resolve(w))})}}e.$Nkc=i;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new u.$_d,this.onProcessData=this.a.event,this.b=new u.$_d,this.d=new u.$_d,this.onDidChangeProperty=this.d.event,this.f=new u.$_d,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,k){this.g.setDimensions?.({columns:w,rows:k})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,k,y){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$_d,this.onDidCloseTerminal=this.H.event,this.I=new u.$_d,this.onDidOpenTerminal=this.I.event,this.J=new u.$_d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$_d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$_d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$_d,this.onDidChangeShell=this.N.event,this.O=new u.$_d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$_d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(O.$xM.MainThreadTerminalService),this.y=new v.$usb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:C=>{const I=z=>{const j=z;return this.getTerminalById(j.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=I(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,k){const y=new i(this.a,(0,S.$Jg)(),w,w.name),C=new r(w.pty);return y.createExtensionTerminal(w.location,k,this.R(w,k).resolvedExtHostIdentifier,c(w.iconPath),h(w.color)).then(I=>{const z=this.S(I,C);this.h[I]=z}),this.f.push(y),y.value}R(w,k){if(k=k||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const y=w.location.parentTerminal;if(y){const C=this.f.find(I=>I.value===y);C&&(k.resolvedExtHostIdentifier=C._id)}}else w.location&&typeof w.location!="object"?k.location=w.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(w,k){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const C=new r(k),I=this.S(w,C);this.h[w]=I}async $acceptActiveTerminalChanged(w){const k=this.b;if(w===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(w);y&&(this.b=y,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,k){const y=this.getTerminalById(w);y&&this.O.fire({terminal:y.value,data:k})}async $acceptTerminalDimensions(w,k,y){const C=this.getTerminalById(w);C&&C.setDimensions(k,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(w,k){const y=this.getTerminalById(w);y&&this.P.fire({terminal:y.value,...k})}async $acceptTerminalMaximumDimensions(w,k,y){this.g.get(w)?.resize(k,y)}async $acceptTerminalTitleChange(w,k){const y=this.getTerminalById(w);y&&(y.name=k)}async $acceptTerminalClosed(w,k,y){const C=this.X(this.f,w);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(k,y),this.H.fire(I.value)}}$acceptTerminalOpened(w,k,y,C){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=w,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new i(this.a,w,I,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(w,k){this.getTerminalById(w)?._setProcessId(k)}async $startExtensionTerminal(w,k){const y=this.getTerminalById(w);if(!y)return{message:(0,E.localize)(0,null,w)};y.isOpen||await new Promise(I=>{const z=this.onDidOpenTerminal(async j=>{j===y.value&&(z.dispose(),I())})});const C=this.g.get(w);C?C.startSendingEvents(k):this.j[w]={initialDimensions:k}}S(w,k){const y=new b.$Tc;y.add(k.onProcessReady(I=>this.a.$sendProcessReady(w,I.pid,I.cwd,I.windowsPty))),y.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(w,I))),this.y.startBuffering(w,k.onProcessData),y.add(k.onProcessExit(I=>this.U(w,I))),this.g.set(w,k);const C=this.j[w];return C&&k instanceof r&&(k.startSendingEvents(C.initialDimensions),delete this.j[w]),y}$acceptProcessAckDataEvent(w,k){this.g.get(w)?.acknowledgeDataEvent(k)}$acceptProcessInput(w,k){this.g.get(w)?.input(k)}$acceptTerminalInteraction(w){const k=this.getTerminalById(w);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(w,k){this.getTerminalById(w)?.setSelection(k)}$acceptProcessResize(w,k,y){try{this.g.get(w)?.resize(k,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(w,k){this.g.get(w)?.shutdown(k)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(k=>this.a.$sendProcessProperty(w,{type:"cwd",value:k}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new p.$zM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,k,y){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,y),this.a.$registerProfileProvider(k,w.identifier.value),new p.$zM(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(w,k,y){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,y),this.a.$registerQuickFixProvider(w,k),new p.$zM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,k){const y=new $.$je().token;if(y.isCancellationRequested)return;const C=this.D.get(w);if(!C)return;const I=await C.provideTerminalQuickFixes(k,y);if(I===null||Array.isArray(I)&&I.length===0)return;const z=new b.$Tc;if(this.w.value=z,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,z):void 0;const j=[];for(const F of I){const N=o.TerminalQuickFix.from(F,this.Q.converter,z);N&&j.push(N)}return j}async $createContributedProfileTerminal(w,k){const y=new $.$je().token;let C=await this.C.get(w)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks(w,k){const y=this.getTerminalById(w);if(!y)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const I=new $.$je;this.G.set(w,I);const z=[],j={terminal:y.value,line:k},F=[];for(const B of this.z)F.push(m.Promises.withAsyncBody(async H=>{I.token.onCancellationRequested(()=>H({provider:B,links:[]}));const Z=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||H({provider:B,links:Z})}));const N=await Promise.all(F);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of N)B&&B.links.length>0&&z.push(...B.links.map(H=>{const Z={id:s++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return T.set(Z.id,{provider:B.provider,link:H}),Z}));return this.F.set(w,T),z}$activateLink(w,k){const y=this.F.get(w)?.get(k);y&&y.provider.handleTerminalLink(y.link)}U(w,k){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const y=this.h[w];y&&(y.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,k)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const k=this.f.findIndex(y=>y.value===w);return k>=0?k:null}W(w,k){const y=this.X(w,k);return y!==null?w[y]:null}X(w,k){const y=w.findIndex(C=>C._id===k);return y>=0?y:null}getEnvironmentVariableCollection(w){let k=this.n.get(w.identifier.value);return k||(k=new f,this.Z(w.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(w,k){const y=(0,P.$_r)(k.map),C=(0,P.$as)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(w,k.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(w){w.forEach(k=>{const y=k[0],C=new f(k[1]);this.Z(y,C)})}$acceptDefaultProfile(w,k){const y=this.s;this.s=w,this.u=k,y?.path!==w.path&&this.N.fire(w.path)}Z(w,k){this.n.set(w,k),k.onDidChangeCollection(()=>{this.Y(w,k)})}};e.$Okc=t,e.$Okc=t=Je([We(1,n.$eP),We(2,M.$UO)],t);class f{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$_d,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const k=this.h(w);let y=this.a.get(k);return y||(y=new d(this,w),this.a.set(k,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(w,k,y,C){this.f(w,{value:k,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(w,k,y,C){this.f(w,{value:k,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(w,k,y,C){this.f(w,{value:k,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(w,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(w,k.scope),C=this.map.get(y),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const z=this.g(w,k.scope),j={variable:w,...k,options:I};this.map.set(z,j),this.d.fire()}}get(w,k){const y=this.g(w,k),C=this.map.get(y);return C?g(C):void 0}g(w,k){const y=this.h(k);return y.length?`${w}:::${y}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const k=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(w)&&k.set(C.variable,g(C));return k}delete(w,k){const y=this.g(w,k);this.map.delete(y),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[k,y]of this.map)y.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(k);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,k){const y=this.h(k),C=this.descriptionMap.get(y);if(!C||C.description!==w){let I;typeof w=="string"?I=w:I=w?.value.split(`

`)[0];const z={description:I,scope:k};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(w){const k=this.h(w);return this.descriptionMap.get(k)?.description}k(w){const k=this.h(w);this.descriptionMap.delete(k)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,k){this.b=w,this.d=k,this.a=new u.$_d}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,k,y){this.b.replace(w,k,y,this.d)}append(w,k,y){this.b.append(w,k,y,this.d)}prepend(w,k,y){this.b.prepend(w,k,y,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,k){this.b.getVariableMap(this.d).forEach((y,C)=>w.call(k,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,k){super(!1,w,k)}createTerminal(w,k,y){throw new A.$_}createTerminalFromOptions(w,k){throw new A.$_}};e.$Pkc=l,e.$Pkc=l=Je([We(0,n.$eP),We(1,M.$UO)],l);function c(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return a.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const w={...D};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ke[155],Ee([1,0,3,5,6,20,42,4,2,7]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0,e.$5lc=(0,O.$ni)("IExtHostTerminalShellIntegration");let A=class extends u.$Uc{constructor(a,m){super(),this.h=m,this.b=new Map,this.c=new b.$_d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$_d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$_d,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(L.$xM.MainThreadTerminalShellIntegration),this.B((0,u.$Sc)(()=>{for(const[o,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(a){const m=this.h.getTerminalById(a);if(!m)return;const o=m.value;let n=this.b.get(a);n||(n=new P(m.value,this.f),this.b.set(a,n),n.store.add(m.onWillDispose(()=>this.b.get(a)?.dispose())),n.store.add(n.onDidRequestShellExecution(i=>this.a.$executeCommand(a,i))),n.store.add(n.onDidRequestEndExecution(i=>this.g.fire(i))),n.store.add(n.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),m.shellIntegration=n.value),this.c.fire({terminal:o,shellIntegration:n.value})}$shellExecutionStart(a,m,o){this.b.has(a)||this.$shellIntegrationChange(a),this.b.get(a)?.startShellExecution(m,o)}$shellExecutionEnd(a,m,o){this.b.get(a)?.endShellExecution(m,o)}$shellExecutionData(a,m){this.b.get(a)?.emitData(m)}$cwdChange(a,m){this.b.get(a)?.setCwd(m)}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$6lc=A,e.$6lc=A=Je([We(0,R.$UO),We(1,M.$Mkc)],A);class P extends u.$Uc{get currentExecution(){return this.a}constructor(a,m){super(),this.j=a,this.m=m,this.b=!1,this.store=this.B(new u.$Tc),this.f=this.B(new b.$_d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$_d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$_d),this.onDidRequestEndExecution=this.h.event;const o=this;this.value={get cwd(){return o.c},executeCommand(n){o.g.fire(n);const i=o.startShellExecution(n,o.c,!0).value;return o.b=!0,i}}}startShellExecution(a,m,o){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0,void 0),this.h.fire({execution:this.a.value,exitCode:void 0}));const n=this.a=new $(this.j,a,m);o?queueMicrotask(()=>this.m.fire(n.value)):this.m.fire(this.a.value)}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,m){this.a&&(this.a.endExecution(a,m),this.h.fire({execution:this.a.value,exitCode:m}),this.a=void 0)}setCwd(a){let m=!1;p.URI.isUri(this.c)?m=!p.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(m=!0),m&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class ${constructor(a,m,o){this.terminal=a,this.c=m,this.cwd=o,this.b=!1;const n=this;this.value={get terminal(){return n.terminal},get commandLine(){return n.c},get cwd(){return n.cwd},readData(){return n.d()}}}d(){if(!this.a){if(this.b)return E.$Nh.EMPTY;this.a=new S}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a,m){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class S extends u.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const a=this.a=new E.$mh;return new E.$Nh(async o=>{this.b.push(o),await a.wait()})}emitData(a){for(const m of this.b)m.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[353],Ee([1,0,7,21,22,4,74,56,3,18,30,12,6,20,154,16,8,68,112,89]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=e.$Slc=e.$Rlc=void 0;let r=class extends p.$Uc{constructor(I,z,j,F){super(),this.w=F,this.f=this.B(new R.$_d),this.g=new Map,this.s=this.B(new R.$_d),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy($.$xM.MainThreadTesting),this.m=new D(this.h),this.j=new d(this.h,z),j.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const T=N,B=T.tests[T.tests.length-1].item.extId;return this.g.get(o.$jL.root(B))?.collection.tree.get(B)?.actual??(0,v.$7O)(N)}case 18:{const{test:T,message:B}=N,H=T.item.extId;return{test:this.g.get(o.$jL.root(H))?.collection.tree.get(H)?.actual??(0,v.$7O)({$mid:16,tests:[T]}),message:a.TestMessage.to(B)}}default:return N}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await j.executeCommand("_testing.getExplorerSelection"),T=B=>{const H=this.g.get(o.$jL.root(B));if(H)return o.$jL.isRoot(B)?H.controller:H.collection.tree.get(B)?.actual};return{include:N?.include.map(T).filter(E.$9f)||[],exclude:N?.exclude.map(T).filter(E.$9f)||[]}})}createTestController(I,z,j,F){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const N=new p.$Tc,T=N.add(new v.$0O(z,j,this.w));T.root.label=j;const B=new Map,H=new Set,Z=this.h,ee={items:T.root.children,get label(){return j},set label(Y){j=Y,T.root.label=Y,Z.$updateController(z,{label:j})},get refreshHandler(){return F},set refreshHandler(Y){F=Y,Z.$updateController(z,{canRefresh:!!Y})},get id(){return z},createRunProfile:(Y,re,te,pe,Ce,x)=>{let U=(0,b.$bj)(Y);for(;B.has(U);)U++;return new k(this.h,B,H,this.s.event,z,U,Y,re,te,pe,Ce,x)},createTestItem(Y,re,te){return new v.$8O(z,Y,re,te)},createTestRun:(Y,re,te=!0)=>this.j.createTestRun(z,T,Y,re,te),invalidateTestResults:Y=>{if(Y===void 0)this.h.$markTestRetired(void 0);else{const re=Y instanceof Array?Y:[Y];this.h.$markTestRetired(re.map(te=>o.$jL.fromExtHostTestItem(te,z).toString()))}},set resolveHandler(Y){T.resolveHandler=Y},get resolveHandler(){return T.resolveHandler},dispose:()=>{N.dispose()}};Z.$registerTestController(z,j,!!F),N.add((0,p.$Sc)(()=>Z.$unregisterTestController(z)));const J={controller:ee,collection:T,profiles:B,extension:I,activeProfiles:H};return this.g.set(z,J),N.add((0,p.$Sc)(()=>this.g.delete(z))),N.add(T.onDidGenerateDiff(Y=>Z.$publishDiff(z,Y.map(i.TestsDiffOp.serialize)))),ee}createTestObserver(){return this.m.checkout()}async runTests(I,z=L.CancellationToken.None){const j=l(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.g.get(j.controllerId);if(!F)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(N=>o.$jL.fromExtHostTestItem(N,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:y[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(N=>N.id)},z)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,z){return(await this.j.getCoverageDetails(I,z))?.map(a.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,z){this.g.get(I)?.profiles.get(z)?.configureHandler?.()}$setDefaultRunProfiles(I){const z=new Map;for(const[j,F]of Object.entries(I)){const N=this.g.get(j);if(!N)continue;const T=new Map,B=F.filter(Z=>!N.activeProfiles.has(Z)),H=[...N.activeProfiles].filter(Z=>!F.includes(Z));for(const Z of B)T.set(Z,!0),N.activeProfiles.add(Z);for(const Z of H)T.set(Z,!1),N.activeProfiles.delete(Z);T.size&&z.set(j,T)}this.s.fire(z)}async $refreshTests(I,z){await this.g.get(I)?.controller.refreshHandler?.(z)}$publishTestResults(I){this.results=Object.freeze(I.map(a.TestResults.to).concat(this.results).sort((z,j)=>j.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,z){const j=this.g.get(o.$jL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,z<0?1/0:z),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(z=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},z)))}async $runControllerTests(I,z){return Promise.all(I.map(j=>this.y(j,!1,z)))}async $startContinuousRun(I,z){const j=new L.$je(z),F=await Promise.all(I.map(N=>this.y(N,!0,j.token)));return!z.isCancellationRequested&&!F.some(N=>N.error)&&await new Promise(N=>z.onCancellationRequested(N)),j.dispose(!0),F}async y(I,z,j){const F=this.g.get(I.controllerId);if(!F)return{};const{collection:N,profiles:T}=F,B=T.get(I.profileId);if(!B)return{};const H=I.testIds.map(Y=>N.tree.get(Y)).filter(E.$9f),Z=I.excludeExtIds.map(Y=>F.collection.tree.get(Y)).filter(E.$9f).filter(Y=>H.some(re=>re.fullId.compare(Y.fullId)===2));if(!H.length)return{};const ee=new m.$_N(H.some(Y=>Y.actual instanceof v.$9O)?void 0:H.map(Y=>Y.actual),Z.map(Y=>Y.actual),B,z),J=(0,i.$mL)(I)&&this.j.prepareForMainThreadTestRun(ee,c.fromInternal(I,F.collection),B,j);try{return await B.runHandler(ee,j),{}}catch(Y){return{error:String(Y)}}finally{J&&J.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(J.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Rlc=r,e.$Rlc=r=Je([We(0,S.$UO),We(1,P.$Tj)],r);const s=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class f extends p.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(I,z,j,F,N){super(),this.z=I,this.C=z,this.D=j,this.F=F,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new R.$_d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new L.$je(N));const T=this.B(new u.$zh(()=>this.G(),s));this.B(this.m.token.onCancellationRequested(()=>T.schedule()));const B=new R.$_d;this.w=B.event,this.B((0,p.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(I,z){const[,j,F]=o.$jL.fromString(I).path,N=this.y.get(F);if(!N)return[];if(N.backCompatResolve)return N.backCompatResolve(z);const T=this.h.get(j);if(!T)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(T.run,N.coverage,z)??[]}createRun(I){const z=this.z.id,j=this.z.controllerId,F=(0,A.$Jg)(),N=J=>(Y,...re)=>{if(H){this.D.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}this.z.isIncluded(Y)&&(this.I(Y),J(Y,...re))},T=(J,Y)=>{const re=Y instanceof Array?Y.map(a.TestMessage.from):[a.TestMessage.from(Y)];if(J.uri&&J.range){const te={range:a.Range.from(J.range),uri:J.uri};for(const pe of re)pe.location=pe.location||te}this.C.$appendTestMessagesInRun(z,F,o.$jL.fromExtHostTestItem(J,j).toString(),re)},B=(J,Y)=>{const re=J.uri.toString(),te=new o.$jL([z,F,re]).toString();this.y.set(re,{coverage:J,backCompatResolve:Y}),this.C.$appendCoverage(z,F,a.TestCoverage.fromFile(te,J))};let H=!1,Z;const ee={isPersisted:this.z.isPersisted,token:this.m.token,name:I,onDidDispose:this.w,get coverageProvider(){return Z},set coverageProvider(J){Z=J,J&&Promise.resolve(J.provideFileCoverage(L.CancellationToken.None)).then(Y=>{Y?.forEach(re=>B(re,J.resolveFileCoverage&&(async te=>(await J.resolveFileCoverage(re,te)||re).detailedCoverage)))})},addCoverage:B,enqueued:N(J=>{this.C.$updateTestStateInRun(z,F,o.$jL.fromExtHostTestItem(J,j).toString(),1)}),skipped:N(J=>{this.C.$updateTestStateInRun(z,F,o.$jL.fromExtHostTestItem(J,j).toString(),5)}),started:N(J=>{this.C.$updateTestStateInRun(z,F,o.$jL.fromExtHostTestItem(J,j).toString(),2)}),errored:N((J,Y,re)=>{T(J,Y),this.C.$updateTestStateInRun(z,F,o.$jL.fromExtHostTestItem(J,j).toString(),6,re)}),failed:N((J,Y,re)=>{T(J,Y),this.C.$updateTestStateInRun(z,F,o.$jL.fromExtHostTestItem(J,j).toString(),4,re)}),passed:N((J,Y)=>{this.C.$updateTestStateInRun(z,F,o.$jL.fromExtHostTestItem(J,this.z.controllerId).toString(),3,Y)}),appendOutput:(J,Y,re)=>{H||(re&&(this.z.isIncluded(re)?this.I(re):re=void 0),this.C.$appendOutputToRun(z,F,O.$ze.fromString(J),Y&&a.location.from(Y),re&&o.$jL.fromExtHostTestItem(re,j).toString()))},end:()=>{H||(H=!0,this.C.$finishedTestRunTask(z,F),--this.g||this.H())}};return this.g++,this.h.set(F,{run:ee}),this.C.$startedTestRunTask(z,{id:F,name:I,running:!0}),ee}G(){for(const{run:I}of this.h.values())I.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(I){if(!(I instanceof v.$8O))throw new n.$MO(I.id);if(this.j.has(o.$jL.fromExtHostTestItem(I,this.z.controllerId).toString()))return;const z=[],j=this.z.colllection.root;for(;;){const F=a.TestItem.from(I);if(z.unshift(F),this.j.has(F.extId)||(this.j.add(F.extId),I===j))break;I=I.parent||j}this.C.$addTestsToRun(this.z.controllerId,this.z.id,z)}dispose(){this.H(),super.dispose()}}class d{get trackers(){return this.f.values()}constructor(I,z){this.h=I,this.j=z,this.f=new Map,this.g=new Map}getCoverageDetails(I,z){const j=o.$jL.root(I);return this.g.get(j)?.getCoverageDetails(I,z)||[]}disposeTestRun(I){this.g.get(I)?.dispose(),this.g.delete(I);for(const[z,{id:j}]of this.f)j===I&&this.f.delete(z)}prepareForMainThreadTestRun(I,z,j,F){return this.k(I,z,j,F)}cancelRunById(I){this.g.get(I)?.cancel()}cancelAllRuns(){for(const I of this.f.values())I.cancel()}createTestRun(I,z,j,F,N){const T=this.f.get(j);if(T)return T.createRun(F);const B=c.fromPublic(I,z,j,N),H=l(j);this.h.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:H&&{group:y[H.kind],id:H.profileId},exclude:j.exclude?.map(ee=>o.$jL.fromExtHostTestItem(ee,z.root.id).toString())??[],id:B.id,include:j.include?.map(ee=>o.$jL.fromExtHostTestItem(ee,z.root.id).toString())??[z.root.id],persist:N});const Z=this.k(j,B,j.profile);return R.Event.once(Z.onEnd)(()=>{this.h.$finishedExtensionTestRun(B.id)}),Z.createRun(F)}k(I,z,j,F){const N=new f(z,this.h,this.j,j,F);return this.f.set(I,N),this.g.set(N.id,N),N}}e.$Slc=d;const l=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class c{static fromPublic(I,z,j,F){return new c(I,(0,A.$Jg)(),j.include?.map(N=>o.$jL.fromExtHostTestItem(N,I).toString())??[I],j.exclude?.map(N=>o.$jL.fromExtHostTestItem(N,I).toString())??[],F,z)}static fromInternal(I,z){return new c(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,z)}constructor(I,z,j,F,N,T){this.controllerId=I,this.id=z,this.isPersisted=N,this.colllection=T,this.f=j.map(B=>B+"\0"),this.g=F.map(B=>B+"\0")}isIncluded(I){const z=o.$jL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.g)if(z===j||z.startsWith(j))return!1;for(const j of this.f)if(z===j||z.startsWith(j))return!0;return!1}}e.$Tlc=c;class h{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(I){this.k=I,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(I){this.f.add(I)}update(I){Object.assign(I.revived,a.TestItem.toPlain(I.item)),this.f.has(I)||this.g.add(I)}remove(I){if(this.f.has(I)){this.f.delete(I);return}this.g.delete(I);const z=o.$jL.parentId(I.item.extId);if(z&&this.j.has(z.toString())){this.j.add(I.item.extId);return}this.h.add(I)}getChangeEvent(){const{f:I,g:z,h:j}=this;return{get added(){return[...I].map(F=>F.revived)},get updated(){return[...z].map(F=>F.revived)},get removed(){return[...j].map(F=>F.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class g extends i.$sL{constructor(){super(...arguments),this.s=new R.$_d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(I){return this.g.get(I)}getMirroredTestDataByReference(I){return this.g.get(I.id)}x(I,z){return{...I,revived:a.TestItem.toPlain(I.item),depth:z?z.depth+1:0,children:new Set}}w(){return new h(this.s)}}class D{constructor(I){this.g=I}checkout(){this.f||(this.f=this.h());const I=this.f;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(z=>z.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(I){return this.f?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.f?.tests.apply(I)}h(){const I=new g({asCanonicalUri:z=>z});return this.g.$subscribeToDiffs(),{observers:0,tests:I}}}const w=(C,I,z,j)=>{z?Object.assign(z,j):I.$updateTestRunConfig(C.controllerId,C.profileId,j)};class k{#e;#t;#i;#n;#s;get label(){return this.g}set label(I){I!==this.g&&(this.g=I,w(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(I){I!==this.h&&(this.h=I,w(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),w(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,w(this,this.#e,this.#n,{tag:I?a.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.f}set configureHandler(I){I!==this.f&&(this.f=I,w(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#i,I=>I.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(E.$9f))}constructor(I,z,j,F,N,T,B,H,Z,ee=!1,J=void 0,Y=!1){this.controllerId=N,this.profileId=T,this.g=B,this.kind=H,this.runHandler=Z,this._tag=J,this.h=Y,this.#e=I,this.#s=z,this.#t=j,this.#i=F,z.set(T,this);const re=y[H];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);ee&&j.add(T),this.#n={profileId:T,controllerId:N,tag:J?a.TestTag.namespace(this.controllerId,J.id):null,label:B,group:re,isDefault:ee,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ulc=k;const y={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ke[156],Ee([1,0,62,13,124,16,8]),function(he,e,u,O,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=void 0;class b{static{this.c=new L.$ZO("TextEditorDecorationType")}constructor($,S,v){const a=b.c.nextId();$.$registerTextEditorDecorationType(S.identifier,a,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:a,dispose(){$.$removeTextEditorDecorationType(a)}})}}e.$2O=b;class p{constructor($,S){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,S){this.k();let v=null;if($ instanceof M.$AM)v=new M.$BM($,$);else if($ instanceof M.$BM)v=$;else throw new Error("Unrecognized location");this.l(v,S,!1)}insert($,S){this.k(),this.l(new M.$BM($,$),S,!0)}delete($){this.k();let S=null;if($ instanceof M.$BM)S=$;else throw new Error("Unrecognized location");this.l(S,null,!0)}l($,S,v){const a=this.c.validateRange($);this.g.push({range:a,text:S,forceMoveMarkers:v})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=$}}class E{constructor($,S,v,a){this.c=$,this.d=S,this._accept(v),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.originalIndentSize,this.j=$.insertSpaces,this.k=$.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to($.lineNumbers)}m($){if($==="auto")return"auto";if(typeof $=="number"){const S=Math.floor($);return S>0?S:null}if(typeof $=="string"){const S=parseInt($,10);return isNaN(S)?null:S>0?S:null}return null}n($){const S=this.m($);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const S=Math.floor($);return S>0?S:null}if(typeof $=="string"){const S=parseInt($,10);return isNaN(S)?null:S>0?S:null}return null}p($){const S=this.o($);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q($){return $==="auto"?"auto":$==="false"?!1:!!$}s($){const S=this.q($);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t($){this.k!==$&&(this.k=$,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}u($){this.l!==$&&(this.l=$,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const S={};let v=!1;if(typeof $.tabSize<"u"){const a=this.m($.tabSize);a==="auto"?(v=!0,S.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,v=!0,S.tabSize=a)}if(typeof $.indentSize<"u"){const a=this.o($.indentSize);a==="tabSize"?(v=!0,S.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,v=!0,S.indentSize=a)}if(typeof $.insertSpaces<"u"){const a=this.q($.insertSpaces);a==="auto"?(v=!0,S.insertSpaces=a):this.j!==a&&(this.j=a,v=!0,S.insertSpaces=a)}typeof $.cursorStyle<"u"&&this.k!==$.cursorStyle&&(this.k=$.cursorStyle,v=!0,S.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.l!==$.lineNumbers&&(this.l=$.lineNumbers,v=!0,S.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v($,S){S.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(v)})}}e.$3O=E;class A{constructor($,S,v,a,m,o,n,i){this.id=$,this.j=S,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new E(this.j,this.id,o,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new O.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof M.$CM))throw(0,O.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof M.$CM)))throw(0,O.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new O.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new O.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(a.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>R.Range.from(l));else if(t instanceof M.$AM){const{lineNumber:l,column:c}=R.Position.from(t);d=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof M.$BM)d=[R.Range.from(t)];else{d=[];for(const l of t)if(l instanceof M.$BM)d.push(R.Range.from(l));else{const{lineNumber:c,column:h}=R.Position.from(l);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return S.$tryInsertSnippet($,a.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(R.$RO(t))return S.$trySetDecorations($,s.key,R.$SO(t));{const d=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return S.$trySetDecorationsFast($,s.key,d)}}))},revealRange(s,t){r.n(()=>S.$tryRevealRange($,R.Range.from(s),t||M.TextEditorRevealType.Default))},show(s){S.$tryShowEditor($,R.ViewColumn.from(s))},hide(){S.$tryHideEditor($)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions($){(0,u.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,u.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,u.ok)(!this.g),this.f=$}_acceptSelections($){(0,u.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const S=$.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const v=S.edits.map(m=>m.range);v.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=v.length-1;m<o;m++){const n=v[m].end;if(v[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=S.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,a,{setEndOfLine:typeof S.setEndOfLine=="number"?R.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$4O=A}),define(ke[72],Ee([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,45,46]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new S.$Bc,this.d=new O.$_d,this.e=new O.$_d,this.f=new O.$_d,this.g=new O.$_d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=R.URI.revive(d),c=this.c.get(l);c?.unref()&&(this.c.delete(l),s.push(c.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=R.URI.revive(d.uri);let c=this.c.get(l);if(c&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new o(new p.$XO(this.h.getProxy(b.$xM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&f.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=R.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(l).value,h=new A.$4O(d.id,this.h.getProxy(b.$xM.MainThreadTextEditors),this.i,new m.$V(()=>c.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(g=>P.Range.to(g)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,L.$Pc)(s),(0,L.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return a.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$5O=n,e.$5O=n=Je([We(0,E.$UO),We(1,$.$Tj)],n),e.$6O=(0,M.$ni)("IExtHostDocumentsAndEditors")}),define(ke[354],Ee([1,0,19,4,6,156,16,8]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class p{constructor(A,P){this.i=P,this.a=new O.$_d,this.b=new O.$_d,this.c=new O.$_d,this.d=new O.$_d,this.f=new O.$_d,this.g=new O.$_d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$xM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const P=this.i.allEditors();return A?P:P.map($=>$.value)}async showTextDocument(A,P,$){let S;typeof P=="number"?S={position:M.ViewColumn.from(P),preserveFocus:$}:typeof P=="object"?S={position:M.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?M.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:S={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,S),a=v&&this.i.getEditor(v);if(a)return a.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,P){return new R.$2O(this.h,A,P).value}$acceptEditorPropertiesChanged(A,P){const $=this.i.getEditor(A);if(!$)throw new Error("unknown text editor");if(P.options&&$._acceptOptions(P.options),P.selections){const S=P.selections.selections.map(M.Selection.to);$._acceptSelections(S)}if(P.visibleRanges){const S=u.$Hb(P.visibleRanges.map(M.Range.to));$._acceptVisibleRanges(S)}if(P.options&&this.b.fire({textEditor:$.value,options:{...P.options,lineNumbers:M.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const S=b.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(M.Selection.to);this.a.fire({textEditor:$.value,selections:v,kind:S})}if(P.visibleRanges){const S=u.$Hb(P.visibleRanges.map(M.Range.to));this.c.fire({textEditor:$.value,visibleRanges:S})}}$acceptEditorPositionData(A){for(const P in A){const $=this.i.getEditor(P);if(!$)throw new Error("Unknown text editor");const S=M.ViewColumn.to(A[P]);$.value.viewColumn!==S&&($._acceptViewColumn(S),this.d.fire({textEditor:$.value,viewColumn:S}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$fkc=p}),define(ke[355],Ee([1,0,2,5,6,3,8,16,25,18]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0,e.$Wlc=(0,O.$ni)("IExtHostTimeline");class A{constructor(S,v){this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$xM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&p.$Im.equals(m,this.b.get(a.source)?.extension)){const o=a.uri===void 0?void 0:u.URI.revive(a.uri);return this.c.get(a.source)?.get(P(o))?.get(a.handle)}else return;return a}})}async $getTimeline(S,v,a,m){return this.b.get(S)?.provider.provideTimeline(u.URI.revive(v),a,m)}registerTimelineProvider(S,v,a,m){const o=new R.$Tc,n=this.d(v.id,m,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const r=this.c;return this.f({...v,scheme:S,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(v.id)?.clear());const d=await v.provideTimeline(s,t,f);if(d==null)return;const l=n(s,t);return{...d,source:v.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},a)}d(S,v,a){return(m,o)=>{let n;if(o?.cacheResults){let i=this.c.get(S);i===void 0&&(i=new Map,this.c.set(S,i));const r=P(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${S}|${i.id??i.timestamp}`;n?.set(t,i);let f,d,l;i.iconPath&&(r instanceof M.$vN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let c;return M.$1M.isMarkdownString(s.tooltip)?c=b.MarkdownString.from(s.tooltip):(0,E.$1f)(s.tooltip)?c=s.tooltip:M.$1M.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(s.detail)):(0,E.$1f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=s.detail),{...s,id:s.id??void 0,handle:t,source:S,command:i.command?v.toInternal(i.command,a):void 0,icon:f,iconDark:d,themeIcon:l,tooltip:c,accessibilityInformation:i.accessibilityInformation}}}}f(S,v){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:v}),(0,R.$Sc)(()=>{for(const m of this.c.values())m.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Xlc=A;function P($){return $?.toString()}}),define(ke[356],Ee([1,0,228,23,2,4,3,288,7,8,18,19,16,80,22,184,26]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;function o(r,s){if((0,A.$1f)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends M.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new a.$s0;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(c=>d(c)?this.r(c):c):l})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,g=this.m(s,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(s,D),k={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.$hG)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.$hG)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(y){(0,S.$Mk)(y)&&(0,m.$hG)(f,"treeViewMarkdownMessage"),g.message=y},get title(){return g.title},set title(y){g.title=y},get description(){return g.description},set description(y){g.description=y},get badge(){return g.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?g.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(g.badge=void 0)},reveal:(y,C)=>g.reveal(y,C),dispose:async()=>{await w,this.a.delete(s),g.dispose()}};return this.B(k),k}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new b.$KF(s))}async $handleDrop(s,t,f,d,l,c,h,g){const D=this.a.get(s);if(!D)return Promise.reject(new b.$KF(s));const w=$.DataTransfer.toDataTransfer(f,async k=>(await this.f.$resolveDropFileData(s,t,k)).buffer);return h===s&&g&&await this.j(w,D,g,l,c),D.onDrop(w,d,l)}async j(s,t,f,d,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((h,g)=>{h&&s.set(g,h)});else if(l&&t.handleDrag){const h=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,f,d){const l=this.a.get(s);if(!l)return Promise.reject(new b.$KF(s));const c=await this.j(new E.$rN,l,t,d,f);if(!(!c||d.isCancellationRequested))return $.DataTransfer.from(c)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$KF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new b.$KF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new b.$KF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new b.$KF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new b.$KF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new b.$KF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$Ylc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$0f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,l,c){if(super(),this.I=s,this.J=f,this.L=d,this.M=l,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$_d),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$_d),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$_d),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$_d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$_d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$_d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$_d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$je,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const k of c.contributes.views[w])k.id===s&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,g;const D=R.Event.debounce(this.F.event,(w,k)=>(w||(w={message:!1,elements:[]}),k.element!==!1&&(h||(h=new Promise(y=>g=y),this.G=this.G.then(()=>h)),Array.isArray(k.element)?w.elements.push(...k.element):w.elements.push(k.element)),k.message&&(w.message=!0),w),200,!0);this.B(D(({message:w,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const y=g;return h=null,this.$(k).then(()=>y())})),w&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.$0f)(t.select)?!0:t.select,d=(0,A.$0f)(t.focus)?!1:t.focus,l=(0,A.$0f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(c=>this.W(s,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(g=>g.item)},{select:f,focus:d,expand:l})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=$.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,P.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const l of s){const c=this.getExtensionElement(l);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,p.$fh)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$fh)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,p.$fh)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const c=this.m.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$je(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,P.$Hb)(d||[]),c=await Promise.all((0,P.$Hb)(l).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const h=c.map((g,D)=>g?this.db(l[D],g,f):null);return(0,P.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new v.$je,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(l=>this.m.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&f.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const c=this.j.get(l);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,p.$fh)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,f.parent);return this.pb(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return E.$1M.isMarkdownString(s)?$.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!E.$mN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new M.$Tc),l=this.kb(s,t,f),c=this.lb(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$0f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof E.$vN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},l,c){if(t)return`${i.b}/${t}`;const h=o(f,this.N),g=l?l.item.handle:i.a;let D=h?h.label:d?(0,O.$Xg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const w=this.m.has(s)?this.m.get(s).item.handle:void 0,k=this.X(l)||[];let y,C=0;do{if(y=`${g}/${C}:${D}`,c||!this.j.has(y)||w===y)break;C++}while(C<=k.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof E.$vN))return typeof s.iconPath=="string"||L.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof E.$vN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return L.URI.isUri(s)?s:L.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const l=this.X(d)||[],c=l.filter(h=>h.item.handle===f.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[357],Ee([1,0,4,3,2,30,16,92,6,8]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class A extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,a,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$_d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$_d),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=a,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends O.$Uc{static c(){return(0,R.$Jg)()}constructor(v,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=v.getProxy(p.$xM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,a,m,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.$ukc)(v),t=P.c();this.f.$createWebviewPanel((0,b.$wkc)(v),t,a,{title:m,panelOptions:$(n),webviewOptions:(0,b.$xkc)(v,this.m,n),serializeBuffersForPostMessage:s},r);const f=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,a,m,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(v){const a=Object.keys(v);a.sort((m,o)=>{const n=v[m],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of a){const o=this.getWebviewPanel(m);if(!o)continue;const n=v[m];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:v}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,b.$ukc)(v)}),new E.$zM(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(v,a,m,o){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(v,m.webviewOptions,r),t=this.createNewWebviewPanel(v,a,m.title,o,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(v,a,m,o,n,i,r){const s=new A(v,this.f,i,{viewType:a,title:m,viewColumn:o,panelOptions:n,active:r});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$ykc=P;function $(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ke[358],Ee([1,0,4,3,92,16,6,8]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class p extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(P,$,S,v,a,m){super(),this.#s=!1,this.#u=this.B(new u.$_d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$_d),this.onDidDispose=this.#l.event,this.#i=S,this.#a=v,this.#e=P,this.#t=$,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#o}set description(P){this.a(),this.#o!==P&&(this.#o=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(P){P===this.#r||this.#s||(this.#r=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(P,$){this.d=$,this.b=new Map,this.c=new Map,this.a=P.getProxy(M.$xM.MainThreadWebviewViews)}registerWebviewViewProvider(P,$,S,v){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:S,extension:P}),this.a.$registerWebviewViewProvider((0,L.$wkc)(P),$,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$ukc)(P)}),new b.$zM(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(P,$,S,v,a){const m=this.b.get($);if(!m)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:n}=m,i=this.d.createNewWebview(P,{},n),r=new p(P,this.a,$,S,i,!0);this.c.set(P,r),await o.resolveWebviewView(r,{state:v},a)}async $onDidChangeWebviewViewVisibility(P,$){this.e(P)._setVisible($)}async $disposeWebviewView(P){const $=this.e(P);this.c.delete(P),$.dispose(),this.d.deleteWebview(P)}e(P){const $=this.c.get(P);if(!$)throw new Error("No webview found");return $}}e.$2lc=E}),define(ke[359],Ee([1,0,69,15,12,259,32,11]),function(he,e,u,O,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;let p=class{constructor(P,$){P.addFileSystemProvider(O.Schemas.file,new E($),{isCaseSensitive:b.$k})}};e.$Imc=p,e.$Imc=p=Je([We(0,u.$qkc),We(1,L.$Tj)],p);class E{constructor(P){this.b=P,this.a=new R.$1q(this.b)}async stat(P){const $=await this.a.stat(P);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,$,S){return this.a.writeFile(P,$,{...S,unlock:!1,atomic:!1})}delete(P,$){return this.a.delete(P,{...$,useTrash:!1,atomic:!1})}rename(P,$,S){return this.a.rename(P,$,S)}copy(P,$,S){return this.a.copy(P,$,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,$){throw new Error("Method not implemented.")}}}),define(ke[360],Ee([1,0,17,64,30,33,3,6,2,20]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;let A=class extends M.$Uc{constructor($,S){super();const v=$.getProxy(b.$xM.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=p.URI.file((0,u.$kc)((0,O.tmpdir)(),(0,L.$Jg)()));return await v.$download(a,m),m})}};e.$Gmc=A,e.$Gmc=A=Je([We(0,E.$UO),We(1,R.$eP)],A)}),define(ke[361],Ee([1,0,52,17,2,93,3,15,7,31]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class A extends R.$skc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==b.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let l=0;do{let c;l===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await P(c);const h=O.$kc(c,"vscode.lock"),g=await a(this.d,h,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),L.URI.file(c);l++}while(l<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Smc=A;async function P(s){try{await E.Promises.stat(s);return}catch{}try{await E.Promises.mkdir(s,{recursive:!0})}catch{}}const $=1e3,S=10*60*1e3;class v extends M.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new p.$yh),this.a.cancelAndSet(async()=>{const d=await m(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function a(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await m(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function m(s,t){let f;try{f=await E.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function o(s,t){let f;try{f=await E.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,p.$oh)(Math.min(100,g)),await o(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await o(s,t),l=Date.now()-d;if(l<=S)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$oh)(2e3);const c=await o(s,t),h=Date.now()-c;return h<=S?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(ke[362],Ee([1,0,30,20,42,33]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0;let M=class extends L.$Okc{constructor(p,E){super(!0,p,E)}createTerminal(p,E,A){return this.createTerminalFromOptions({name:p,shellPath:E,shellArgs:A})}createTerminalFromOptions(p,E){const A=new L.$Nkc(this.a,(0,u.$Jg)(),p,p.name);return this.f.push(A),A.create(p,this.R(p,E)),A.value}};e.$bmc=M,e.$bmc=M=Je([We(0,R.$eP),We(1,O.$UO)],M)}),define(ke[363],Ee([1,0,4,37,40,5]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.OutputChannelUpdateMode=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=void 0,e.$FL="text/x-code-output",e.$GL="output",e.$HL="Log",e.$IL="text/x-code-log-output",e.$JL="log",e.$KL="workbench.panel.output",e.$LL=new L.$Ej("inOutput",!1),e.$ML=new L.$Ej("activeLogOutput",!1),e.$NL=new L.$Ej("activeLogOutput.levelSettable",!1),e.$OL=new L.$Ej("activeLogOutput.level",""),e.$PL=new L.$Ej("activeLogOutput.levelIsDefault",!1),e.$QL=new L.$Ej("outputView.scrollLock",!1),e.$RL=(0,R.$ni)("outputService");var M;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$SL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new u.$_d,this.onDidRegisterChannel=this.b.event,this.c=new u.$_d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(A=>E.push(A)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$6n.add(e.$SL.OutputChannels,new b),e.$TL=new L.$Ej("activeOutputChannel","")}),define(ke[157],Ee([1,0,6,5,20,25,12,363,69,28,60,189,21,18,32,4,3]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;class o extends M.$Zj{get disposed(){return this.n}constructor(s,t,f,d,l){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=$.$ze.fromString(t).byteLength,(0,M.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,d,l,c){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$xM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,S.$1f)(t)?t:void 0;if((0,S.$1f)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([D])=>R.$Im.equals(f.identifier,D))?.[1];h&&(c=(0,M.$$j)(h));const g=d?this.o(s,c,f):this.n(s,l,f);return g.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(s,c??this.m.getLevel(),g):this.q(s,g)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,f.identifier.value);return new o(h,s,c,this.a,f)}async o(s,t,f){const d=await this.p(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${l}.log`),h=`${f.identifier.value}.${l}`,g=this.l.createLogger(c,{id:h,name:s,logLevel:t,extensionId:f.identifier.value});return new n(h,s,g,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,v.$0k)(d)!==v.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(c=>c.append(l))},appendLine(l){d(),t.then(c=>c.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(c=>c.replace(l))},show(l,c){d(),t.then(h=>h.show(l,c))},hide(){d(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}r(s,t,f){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new a.$_d);function h(g){t=g,c.fire(g)}return f.then(g=>{d.add(g),g.logLevel!==t&&h(g.logLevel),d.add(g.onDidChangeLogLevel(D=>h(D)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(g,...D){l(),f.then(w=>w.trace(g,...D))},debug(g,...D){l(),f.then(w=>w.debug(g,...D))},info(g,...D){l(),f.then(w=>w.info(g,...D))},warn(g,...D){l(),f.then(w=>w.warn(g,...D))},error(g,...D){l(),f.then(w=>w.error(g,...D))},dispose(){d.dispose()}}}};e.$Clc=i,e.$Clc=i=Je([We(0,L.$UO),We(1,E.$$O),We(2,p.$qkc),We(3,A.$3jc),We(4,M.$Uj),We(5,M.$Tj)],i),e.$Dlc=(0,O.$ni)("IExtHostOutputService")}),define(ke[158],Ee([1,0,5,7]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$0m=(0,u.$ni)("remoteAgentService"),e.$$m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const p=await L.getRoundTripTime();if(p===void 0)return;R=Math.min(R,p/2),await(0,O.$oh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((b,p)=>b+p,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((b,p)=>b+p,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[364],Ee([1,0,232,85,37,41,54,3,4,158,11,24,7]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=void 0,e.$$I=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$_I=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$aJ=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$bJ=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$cJ={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new p.$_d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new S;L.$6n.add(e.$cJ.ConfigurationMigration,v);let a=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const c=await this.h(n,t,d.value,i,void 0);for(const h of c??[])l.push([h,[]])}for(const{identifiers:c,value:h}of d.overrides??[])if(h!==void 0){const g=await this.h(n,t,h,i,c);for(const D of g??[])l.push([D,c])}l.length&&await Promise.allSettled(l.map(async([[c,h],g])=>this.a.updateValue(c,h.value,{resource:i,overrideIdentifiers:g},f)))}}async h(n,i,r,s,t){const f=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:g})=>(0,P.$Xn)(g,t))?.value:h.value},d=await n.migrateFn(r,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$dJ=a,e.$dJ=a=Je([We(0,M.$Ti),We(1,R.$wi)],a);let m=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new $.$Kh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$6n.as(O.$$n.Configuration).registerConfiguration({...e.$aJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$eJ=m,e.$eJ=m=Je([We(0,E.$0m)],m)}),define(ke[365],Ee([1,0,35,15,17,23,241,364,85,5,37]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Vfb=e.$Ufb=void 0,e.$Wfb=a,e.$Xfb=m,e.$Ufb=(0,E.$ni)("editorResolverService"),e.$Vfb="workbench.editorAssociations";const P=A.$6n.as(p.$$n.Configuration),$={...b.$_I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration($);var S;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(S||(e.RegisteredEditorPriority=S={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function a(o){switch(o){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function m(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$Xg)(n);return u.$gk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ke[366],Ee([1,0,34,15,17,11,23,2,5,277,41,147,158]),function(he,e,u,O,L,R,M,b,p,E,A,P,$){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=void 0,e.$_L=(0,p.$ni)("pathService");let v=S=class{constructor(m,o,n,i){this.d=m,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(m,i,o)):this.h(m,o,n)}h(m,o,n){return m.scheme===O.Schemas.file||m.scheme===O.Schemas.vscodeRemote?(0,u.$lg)(n??(0,M.$Xg)(m),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,E.$9L)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:O.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?L.$gc:L.$hc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(o=m.substring(2),m="/"):(o=m.substring(2,i),m=m.substring(i)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$aM=v,e.$aM=v=S=Je([We(1,$.$0m),We(2,P.$UL),We(3,A.$wi)],v)}),define(ke[367],Ee([1,0,243,19,55,4,56,3,2,54,248,12,66,279,88,41,147,26,22,18,24,40]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.OnPortForward=e.$ZL=e.$YL=e.TunnelSource=e.TunnelCloseReason=e.$WL=e.$VL=void 0,e.$XL=c,e.$1L=D,e.$2L=w,e.$3L=k,e.$4L=C;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$VL="onTunnel",e.$WL=new s.$Ej("forwardedPortsViewEnabled",!1,u.localize(0,null));function c(j){const F=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}var h;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$YL={source:g.User,description:u.localize(1,null)},e.$ZL={source:g.Auto,description:u.localize(2,null)};function D(j,F,N){const T=j.get(k(F,N));if(T)return T;if((0,v.$8v)(F))for(const B of v.$7v){const H=k(B,N);if(j.has(H))return j.get(H)}else if((0,v.$0v)(F))for(const B of v.$9v){const H=k(B,N);if(j.has(H))return j.get(H)}}function w(j,F,N){const T=D(j,F,N);if(T)return T;const B=(0,v.$0v)(F)?"localhost":(0,v.$8v)(F)?"0.0.0.0":void 0;if(B)return D(j,B,N)}function k(j,F){return j+":"+F}var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function C(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends b.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new R.$_d,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(N=>{(N.affectsConfiguration(I.c)||N.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,N,T){let B=this.w(F,N,T,this.j,0);const H={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Z=this.j[B];Z.key===F?(H.onAutoForward=Z.onAutoForward??H.onAutoForward,H.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:H.elevateIfNeeded,H.label=Z.label??H.label,H.requireLocalPort=Z.requireLocalPort,H.protocol=Z.protocol):(H.onAutoForward=H.onAutoForward??Z.onAutoForward,H.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:Z.elevateIfNeeded,H.label=H.label??Z.label,H.requireLocalPort=H.requireLocalPort!==void 0?H.requireLocalPort:void 0,H.protocol=H.protocol??Z.protocol),B=this.w(F,N,T,this.j,B+1)}return H.onAutoForward!==void 0||H.elevateIfNeeded!==void 0||H.label!==void 0||H.requireLocalPort!==void 0||H.protocol!==void 0?H:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,i.$1f)(F.host)&&(0,i.$5f)(F.port)}w(F,N,T,B,H){if(H>=B.length)return-1;const Z=!(0,v.$8v)(N)&&!(0,v.$0v)(N),J=B.slice(H).findIndex(Y=>(0,i.$5f)(Y.key)?Z?!1:Y.key===F:this.t(Y.key)?Z?!1:F>=Y.key.start&&F<=Y.key.end:this.u(Y.key)?F===Y.key.port&&N===Y.key.host:T?Y.key.test(T):!1);return J>=0?J+H:-1}y(){const F=this.r.getValue(I.c);if(!F||!(0,i.$3f)(F))return[];const N=[];for(const B in F){if(B===void 0)continue;const H=F[B];let Z;if(Number(B))Z=Number(B);else if((0,i.$1f)(B))if(I.g.test(B)){const ee=B.match(I.g);Z={start:Number(ee[1]),end:Number(ee[2])}}else if(I.h.test(B)){const ee=B.match(I.h);Z={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(B)}catch{}ee&&(Z=ee)}Z&&N.push({key:Z,elevateIfNeeded:H.elevateIfNeeded,onAutoForward:H.onAutoForward,label:H.label,requireLocalPort:H.requireLocalPort,protocol:H.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(N)}z(F){function N(T,B){return(0,i.$5f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return F.sort((T,B)=>N(T,this)-N(B,this))}C(){return this.m}static providedActionToAction(F){switch(F){case v.ProvidedOnAutoForward.Notify:return y.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case v.ProvidedOnAutoForward.Silent:return y.Silent;case v.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,N,T){const H=this.r.inspect(I.c).userRemoteValue;let Z;!H||!(0,i.$3f)(H)?Z={}:Z=(0,r.$Tn)(H),Z[`${F}`]||(Z[`${F}`]={});for(const ee in N)Z[`${F}`][ee]=N[ee];return this.r.updateValue(I.c,Z,T)}}e.$5L=I;let z=class extends b.$Uc{constructor(F,N,T,B,H,Z,ee,J,Y,re){super(),this.H=F,this.I=N,this.J=T,this.L=B,this.M=H,this.N=Z,this.O=ee,this.P=J,this.Q=Y,this.R=re,this.c=new Map,this.g=new R.$_d,this.onForwardPort=this.g.event,this.h=new R.$_d,this.onClosePort=this.h.event,this.j=new R.$_d,this.onPortName=this.j.event,this.n=new R.$_d,this.onCandidatesChanged=this.n.event,this.t=new R.$_d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$_d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async te=>{const pe=await this.getAttributes(te.map(Ce=>({port:Ce.tunnelRemotePort,host:Ce.tunnelRemoteHost})));for(const Ce of te)if(Ce.localAddress){const x=k(Ce.tunnelRemoteHost,Ce.tunnelRemotePort),U=w(this.m??new Map,Ce.tunnelRemoteHost,Ce.tunnelRemotePort);this.forwarded.set(x,{remotePort:Ce.tunnelRemotePort,remoteHost:Ce.tunnelRemoteHost,localAddress:Ce.localAddress,protocol:pe?.get(Ce.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Ce.localAddress,pe?.get(Ce.tunnelRemotePort)),localPort:Ce.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Ce.privacy,source:e.$YL}),this.f.set(x,Ce)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async te=>{const pe=k(te.tunnelRemoteHost,te.tunnelRemotePort);if(!w(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!w(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!w(this.c,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const Ce=w(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),x=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(pe,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:x?.protocol??v.TunnelProtocol.Http,localUri:await this.X(te.localAddress,x),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:Ce?.detail,hasRunningProcess:!!Ce,pid:Ce?.pid,privacy:te.privacy,source:e.$YL})}await this.cb(),this.f.set(pe,te),this.g.fire(this.forwarded.get(pe))})),this.B(this.H.onTunnelClosed(te=>this.W(te,h.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$VL))?(this.R.createKey(e.$WL.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,N){const T=k(F.host,F.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(F))}X(F,N){if(F.startsWith("http"))return p.URI.parse(F);const T=N?.protocol??"http";return p.URI.parse(`${T}://${F}`)}async Y(F){const N=this.N.getWorkspace(),T=N.configuration?(0,M.$bj)(N.configuration.path):N.folders.length>0?(0,M.$bj)(N.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const F=this.I.get(f,1);if(F)return this.I.remove(f,1),await this.cb(),F;const N=await this.Z();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const N=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(T=>T.remotePort).join(", ")}`);for(const T of N){const B=w(this.detected,T.remoteHost,T.remotePort);T.source.source!==g.Extension&&!B||T.source.source===g.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===g.Extension&&!B&&this.D.set(k(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new b.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(0,0).filter(N=>N.startsWith(d));for(const N of F){const T=this.I.getNumber(N,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=N.replace(d,f);this.I.remove(N,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),N=F.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let T;F.length>0&&(T=JSON.stringify(N));const B=await this.Z(),H=await this.$();!T&&B&&H?(this.I.remove(B,0),this.I.remove(H,0)):T!==this.y&&B&&H&&(this.I.store(B,T,0,0),this.I.store(H,Date.now()+l,0,0)),this.y=T}}async eb(F,N,T){if(!F.tunnelLocalPort||!T?.requireLocalPort||F.tunnelLocalPort===N)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const H=u.localize(3,null,N,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(H)}async forward(F,N){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(F,N)}async fb(F,N){await this.Q.activateByEvent(e.$VL);const T=w(this.forwarded,F.remote.host,F.remote.port);N=N??(N!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const B=F.local!==void 0?F.local:F.remote.port;let H;if(T)return this.hb(T,F,N);{const Z=this.L.remoteAuthority,ee=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,J=k(F.remote.host,F.remote.port);this.c.set(J,!0),F=this.gb(J,F);const Y=await this.H.openTunnel(ee,F.remote.host,F.remote.port,void 0,B,F.elevateIfNeeded?F.elevateIfNeeded:N?.elevateIfNeeded,F.privacy,N?.protocol);if(typeof Y=="string")H=Y;else if(Y&&Y.localAddress){const re=w(this.m??new Map,F.remote.host,F.remote.port),te=Y.protocol?Y.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:N?.protocol??v.TunnelProtocol.Http,pe={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:N?.label??F.name,closeable:!0,localAddress:Y.localAddress,protocol:te,localUri:await this.X(Y.localAddress,N),runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,source:F.source??e.$YL,privacy:Y.privacy};return this.forwarded.set(J,pe),this.f.set(J,Y),this.c.delete(J),await this.cb(),await this.eb(Y,B,N),this.g.fire(pe),Y}this.c.delete(J)}return H}gb(F,N){const T=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(T){const B=T.get(F);T.delete(F),B&&(N.name=B.name??N.name,N.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async hb(F,N,T){const B=T?.label??N.name;let H;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(H||(H={}));let Z=H.None;switch(B!==F.name&&(F.name=B,Z=H.Fire),(T?.protocol||F.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==F.protocol&&(N.source=F.source,Z=H.Reopen),N.privacy&&F.privacy!==N.privacy&&(Z=H.Reopen),Z){case H.Fire:{this.g.fire();break}case H.Reopen:await this.close(F.remoteHost,F.remotePort,h.User),await this.fb(N,T)}return w(this.f,N.remote.host,N.remote.port)}async name(F,N,T){const B=w(this.forwarded,F,N),H=k(F,N);if(B){B.name=T,await this.cb(),this.j.fire({host:F,port:N});return}else this.detected.has(H)&&(this.detected.get(H).name=T,this.j.fire({host:F,port:N}))}async close(F,N,T){const B=k(F,N),H=this.forwarded.get(B);return T===h.AutoForwardEnd&&H&&H.source.source===g.Auto&&this.F.set(B,{local:H.localPort,name:H.name,privacy:H.privacy}),await this.H.closeTunnel(F,N),this.W({host:F,port:N},T)}address(F,N){const T=k(F,N);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const N of F){const T=w(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),B=typeof N.localAddress=="string"?N.localAddress:k(N.localAddress.host,N.localAddress.port);this.detected.set(k(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let N=F;this.r&&(N=await this.r(F));const T=this.ib(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(F){const N=this.m??new Map,T=new Map;return this.m=T,F.forEach(B=>{const H=k(B.host,B.port);T.set(H,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),N.has(H)&&N.delete(H);const Z=w(this.forwarded,B.host,B.port);Z&&(Z.runningProcess=B.detail,Z.hasRunningProcess=!0,Z.pid=B.pid)}),N.forEach((B,H)=>{const Z=c(H);if(!Z)return;const ee=w(this.forwarded,Z.host,Z.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const J=w(this.detected,Z.host,Z.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),N=await this.getAttributes(F.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(N)for(const T of F){const B=N.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(F,N=!0){const T=new Map,B=new Map;F.forEach(Y=>{const re=w(this.m??new Map,v.$7v[0],Y.port)??Y;if(re){T.set(Y.port,re);const te=C(re)?re.pid:void 0;B.has(te)||B.set(te,[]),B.get(te)?.push(Y.port)}});const H=new Map;if(F.forEach(Y=>{const re=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);re&&H.set(Y.port,re)}),this.G.length===0||!N)return H.size>0?H:void 0;const Z=await Promise.all((0,O.$Rb)(this.G.map(Y=>Array.from(B.entries()).map(re=>{const te=re[1],pe=T.get(te[0]);return Y.providePortAttributes(te,pe?.pid,pe?.detail,n.CancellationToken.None)})))),ee=new Map;if(Z.forEach(Y=>Y.forEach(re=>{re&&ee.set(re.port,re)})),!H&&!ee)return;const J=new Map;return F.forEach(Y=>{const re=H.get(Y.port),te=ee.get(Y.port);J.set(Y.port,{elevateIfNeeded:re?.elevateIfNeeded,label:re?.label,onAutoForward:re?.onAutoForward??I.providedActionToAction(te?.autoForwardAction),requireLocalPort:re?.requireLocalPort,protocol:re?.protocol})}),J}addAttributesProvider(F){this.G.push(F)}};e.$6L=z,Je([(0,L.$Sh)(1e3)],z.prototype,"cb",null),e.$6L=z=Je([We(0,v.$2v),We(1,S.$Rp),We(2,E.$Ti),We(3,m.$UL),We(4,$.$yl),We(5,a.$wi),We(6,P.$Tj),We(7,A.$vw),We(8,o.$dG),We(9,s.$Fj)],z)}),define(ke[94],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$FK=e.$EK=void 0;class u{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new u(0,0)}with(M){return new u(0,0)}}e.$EK=u;class O{constructor(M,b,p,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(M,b),this.end=new u(p,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new O(0,0,0,0)}with(M){return new O(0,0,0,0)}}e.$FK=O;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,7]),function(he,e,u,O,L,R,M,b,p,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$3K=e.$VK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$SK=e.$RK=e.$QK=e.$PK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.TextSearchCompleteMessageType=void 0,e.$MK=o,e.$NK=n,e.$OK=i,e.$TK=g,e.$UK=D,e.$WK=y,e.$XK=C,e.$YK=I,e.$ZK=z,e.$1K=j,e.$2K=F,e.$4K=T,e.$6K=Z,e.$7K=ee,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$GK="workbench.view.search",e.$HK="workbench.panel.search",e.$IK="workbench.view.search",e.$JK="search-result",e.$KK="search.exclude";const $="\u27EA ",S=" characters skipped \u27EB",v=($.length+S.length+5)*2;e.$LK=(0,b.$ni)("searchService");var a;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(Y){return!!Y.preview}function n(Y){return!!Y.resource}function i(Y){return!!Y.message}var r;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(re){this.resource=re,this.results=[]}}e.$PK=s;class t{constructor(re,te,pe,Ce){this.ranges=te,this.webviewIndex=Ce;const x=Array.isArray(te)?te:[te];if(pe&&pe.matchLines===1&&f(x)){re=(0,M.$Tf)(re,pe.matchLines);let U="",ne=0,be=0;const De=Math.floor(pe.charsPerLine/5),ae=[];for(const ce of x){const se=Math.max(ce.startColumn-De,0),K=ce.startColumn+pe.charsPerLine;if(se>be+De+v){const ie=$+(se-be)+S;U+=ie+re.slice(se,K),ne+=se-(be+ie.length)}else U+=re.slice(be,K);ae.push(new l(0,ce.startColumn-ne,ce.endColumn-ne)),be=K}this.preview={text:U,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const U=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:re,matches:(0,u.$2b)(te,ne=>new d(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$QK=t;function f(Y){const re=Y[0].startLineNumber;for(const te of Y)if(te.startLineNumber!==re||te.endLineNumber!==re)return!1;return!0}class d{constructor(re,te,pe,Ce){this.startLineNumber=re,this.startColumn=te,this.endLineNumber=pe,this.endColumn=Ce}}e.$RK=d;class l extends d{constructor(re,te,pe){super(re,te,re,pe)}}e.$SK=l;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function g(Y,re=!0){const te=Y&&Y.files&&Y.files.exclude,pe=re&&Y&&Y.search&&Y.search.exclude;if(!te&&!pe)return;if(!te||!pe)return te||pe;let Ce=Object.create(null);return Ce=L.$Wn(Ce,L.$Tn(te)),Ce=L.$Wn(Ce,L.$Tn(pe),!0),Ce}function D(Y,re){return Y.excludePattern&&O.$gk(Y.excludePattern,re)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&O.$gk(Y.includePattern,re)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(te=>{const pe=te.folder.fsPath;if(R.$ng(re,pe)){const Ce=p.$mc(pe,re);return!te.includePattern||!!O.$gk(te.includePattern,Ce)}else return!1}):!1:!0}var w;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class k extends Error{constructor(re,te){super(re),this.code=te}}e.$VK=k;function y(Y){const re=Y.message;if((0,E.$4)(Y))return new k(re,w.canceled);try{const te=JSON.parse(re);return new k(te.message,te.code)}catch{return new k(re,w.other)}}function C(Y){const re={message:Y.message,code:Y.code};return new Error(JSON.stringify(re))}function I(Y){return Y.type==="error"?!0:Y.type==="success"}function z(Y){return Y.type==="success"}function j(Y){return!!Y.path}function F(Y,re,te=!0){const pe=Y.searchPath?Y.searchPath:Y.relativePath;return te?(0,M.$Qf)(pe,re):O.$gk(re,pe)}class N{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$3K=N;function T(Y,re){const te={...Y||{},...re||{}};return Object.keys(te).filter(pe=>{const Ce=te[pe];return typeof Ce=="boolean"&&Ce})}class B{constructor(re,te){this.c=null,this.a={...re.excludePattern||{},...te.excludePattern||{}},this.b=O.$hk(this.a);let pe=re.includePattern;te.includePattern&&(pe?pe={...pe,...te.includePattern}:pe=te.includePattern),pe&&(this.c=O.$hk(pe))}matchesExcludesSync(re,te,pe){return!!(this.b&&this.b(re,te,pe))}includedInQuerySync(re,te,pe){return!(this.b&&this.b(re,te,pe)||this.c&&!this.c(re,te,pe))}includedInQuery(re,te,pe){const Ce=this.b(re,te,pe),x=()=>this.c?!!this.c(re,te,pe):!0;return(0,P.$_g)(Ce)?Ce.then(U=>U?!1:x()):x()}hasSiblingExcludeClauses(){return H(this.a)}}e.$5K=B;function H(Y){for(const re in Y)if(typeof Y[re]!="boolean")return!0;return!1}function Z(Y){if(!Y)return;let re;return te=>(re||(re=(Y()||Promise.resolve([])).then(pe=>pe?J(pe):{})),re.then(pe=>!!pe[te]))}function ee(Y){if(!Y)return;let re;return te=>{if(!re){const pe=Y();re=pe?J(pe):{}}return!!re[te]}}function J(Y){const re={};for(const te of Y)re[te]=!0;return re}}),define(ke[43],Ee([1,0,19,7,22,4,3,77,15,125,23,14,2,230,5,12,262,41,60,28,20,16,8,67,36,6,58]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;function h(z,j,F){return new A.$Pg(N=>k(N,F)).isEqual(z,j)}function g(z,j,F){return h(z.uri,j.uri,F)?0:(0,P.$jf)(z.uri.toString(),j.uri.toString())}function D(z,j,F){return z.index!==j.index?z.index<j.index?-1:1:h(z.uri,j.uri,F)?(0,P.$jf)(z.name,j.name):(0,P.$jf)(z.uri.toString(),j.uri.toString())}function w(z,j,F,N){const T=z.slice(0).sort((H,Z)=>F(H,Z,N)),B=j.slice(0).sort((H,Z)=>F(H,Z,N));return(0,u.$Eb)(T,B,(H,Z)=>F(H,Z,N))}function k(z,j){const F=j.getCapabilities(z.scheme);return!(F&&F&1024)}class y extends o.$Gi{static toExtHostWorkspace(j,F,N,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:H,folders:Z,configuration:ee,transient:J,isUntitled:Y}=j,re=[],te=F;F?Z.forEach((U,ne)=>{const be=$.URI.revive(U.uri),De=y.o(N||F,be,T);De?(De.name=U.name,De.index=U.index,re.push(De)):re.push({uri:be,name:U.name,index:ne})}):re.push(...Z.map(({uri:U,name:ne,index:be})=>({uri:$.URI.revive(U),name:ne,index:be}))),re.sort((U,ne)=>U.index<ne.index?-1:1);const pe=new y(B,H,re,!!J,ee?$.URI.revive(ee):null,!!Y,U=>k(U,T)),{added:Ce,removed:x}=w(te?te.workspaceFolders:[],pe.workspaceFolders,g,T);return{workspace:pe,added:Ce,removed:x}}static o(j,F,N){for(let T=0;T<j.folders.length;T++){const B=j.workspaceFolders[T];if(h(B.uri,F,N))return B}}constructor(j,F,N,T,B,H,Z){super(j,N.map(ee=>new o.$Hi(ee)),T,B,Z),this.t=F,this.u=H,this.q=[],this.s=b.$ti.forUris(Z),N.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,F){return F&&this.s.get(j)&&(j=(0,A.$Zg)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let C=class{constructor(j,F,N,T,B){this.c=new R.$_d,this.onDidChangeWorkspace=this.c.event,this.g=new R.$_d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$be,this.C=new Map,this.h=T,this.s=N,this.t=B,this.j=new E.$um,this.k=new O.$mh,this.o=j.getProxy(l.$xM.MainThreadWorkspace),this.q=j.getProxy(l.$xM.MainThreadMessageService);const H=F.workspace;this.l=H?new y(H.id,H.name,[],!!H.transient,H.configuration?$.URI.revive(H.configuration):null,!!H.isUntitled,Z=>k(Z,N)):void 0}$initializeWorkspace(j,F){this.v=F,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:p.Schemas.untitled,path:(0,A.$Xg)((0,A.$Zg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,F,N,...T){const B=[];if(Array.isArray(T)&&T.forEach(Y=>{$.URI.isUri(Y.uri)&&!B.some(re=>h(re.uri,Y.uri,this.s))&&B.push({uri:Y.uri,name:Y.name||(0,A.$Wg)(Y.uri)})}),this.n||[F,N].some(Y=>typeof Y!="number"||Y<0)||N===0&&B.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(F+N>H.length)return!1;const Z=H.slice(0);Z.splice(F,N,...B.map(Y=>({uri:Y.uri,name:Y.name||(0,A.$Wg)(Y.uri),index:void 0})));for(let Y=0;Y<Z.length;Y++){const re=Z[Y];if(Z.some((te,pe)=>pe!==Y&&h(re.uri,te.uri,this.s)))return!1}Z.forEach((Y,re)=>Y.index=re);const{added:ee,removed:J}=w(H,Z,D,this.s);if(ee.length===0&&J.length===0)return!1;if(this.o){const Y=j.displayName||j.name;this.o.$updateWorkspaceFolders(Y,F,N,B).then(void 0,re=>{this.n=void 0;const te={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(m.Severity.Error,(0,S.localize)(0,null,Y,re.toString()),te,[])})}return this.y(Z),!0}getWorkspaceFolder(j,F){if(this.x)return this.x.getWorkspaceFolder(j,F)}async getWorkspaceFolder2(j,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,F)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,F){let N,T="";if(typeof j=="string"?(N=$.URI.file(j),T=j):typeof j<"u"&&(N=j,T=j.fsPath),!N)return T;const B=this.getWorkspaceFolder(N,!0);if(!B)return T;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let H=(0,A.$3g)(B.uri,N);return F&&B.name&&(H=`${B.name}/${H}`),H}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:F,added:N,removed:T}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:T}))}findFiles(j,F,N,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let H="",Z=!0;return F===null?Z=!1:F!==void 0&&(typeof F=="string"?H=F:H=F.pattern),this.z(j,void 0,{exclude:H,maxResults:N,useDefaultExcludes:Z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,F={},N,T=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,j,F,T)}async z(j,F,N,T=L.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,H={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:B,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let Z;if(j){const{includePattern:ee,folder:J}=I(s.GlobPattern.from(j));Z=J,H.includePattern=ee}else{const{includePattern:ee,folder:J}=I(s.GlobPattern.from(F));Z=J,H.filePattern=ee}return this.o.$startFileSearch(Z??null,H,T).then(ee=>Array.isArray(ee)?ee.map(J=>$.URI.revive(J)):[])}async findTextInFiles(j,F,N,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),Z=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:ee,folder:J}=I(s.GlobPattern.from(F.include)),Y=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,re={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:Z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:ee,excludePattern:Y},te=!1;if(this.u[H]=pe=>{if(te)return;const Ce=$.URI.revive(pe.resource);pe.results.forEach(x=>{const U=(0,c.$Wh)(x);(0,d.$MK)(U)?N({uri:Ce,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ne=>new t.$BM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,u.$2b)(U.ranges,ne=>new t.$BM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):N({uri:Ce,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(j,J??null,re,H,B);return delete this.u[H],pe||{}}catch(pe){throw delete this.u[H],pe}}$handleTextSearchResult(j,F){this.u[F]?.(j)}async save(j){const F=await this.o.$save(j,{saveAs:!1});return $.URI.revive(F)}async saveAs(j){const F=await this.o.$save(j,{saveAs:!0});return $.URI.revive(F)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,F){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,F);const N=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,N),(0,M.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const N=await this.resolveWorkspaceFolder($.URI.revive(j));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const T=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(N,F);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,F,N,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder($.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const H=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!H),!H)return;const Z=await H.provideEditSessionIdentityMatch?.(F,N,T);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(j){return(F,N,T)=>{const B=function(Z){F.call(N,Z)};return B.extension=j,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(j,F,N){const T=await this.resolveWorkspaceFolder($.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},F,async(B,H)=>{const Z=Date.now();await Promise.resolve(B),Date.now()-Z>N&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(j,F){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,F);const N=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,N),(0,M.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,F,N){const T=this.C.get(j.scheme);if(!T)return;const B=await T.provideCanonicalUri?.($.URI.revive(j),F,N);if(B)return B}async $provideCanonicalUri(j,F,N){return this.provideCanonicalUri($.URI.revive(j),{targetScheme:F},N)}};e.$kkc=C,e.$kkc=C=Je([We(0,r.$UO),We(1,i.$$O),We(2,n.$3jc),We(3,a.$Tj),We(4,f.$ikc)],C),e.$lkc=(0,v.$ni)("IExtHostWorkspace");function I(z){let j,F;return z&&(typeof z=="string"?j=z:(j=z.pattern,F=$.URI.revive(z.baseUri))),{includePattern:j,folder:F}}}),define(ke[44],Ee([1,0,24,4,43,6,8,264,85,18,7,5,20,12,2]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=e.$mkc=void 0;function a(f,d){if(d){const l=d.split(".");let c=f;for(let h=0;c&&h<l.length;h++)c=c[l[h]];return c}}function m(f){return f instanceof v.URI}function o(f){return f&&f.uri instanceof v.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof v.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,l,c){this.a=d.getProxy(R.$xM.MainThreadConfiguration),this.c=l,this.b=c,this.d=new A.$mh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,l))}};e.$mkc=s,e.$mkc=s=Je([We(0,$.$UO),We(1,L.$lkc),We(2,S.$Tj)],s);class t{constructor(d,l,c,h){this.a=new O.$_d,this.b=d,this.f=h,this.c=l,this.e=b.$ro.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$ro.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(d,l,c){const h=r(l)||{},g=this.g(d?a(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(k){return typeof a(g,k)<"u"},get:(k,y)=>{this.h(d?`${d}.${k}`:k,h,c?.identifier);let C=a(g,k);if(typeof C>"u")C=y;else{let I;const z=(j,F)=>{if((0,E.$3f)(j)){let N;const T=()=>{I=I||(0,u.$Tn)(g),N=N||a(I,F)};return new Proxy(j,{get:(B,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return T(),()=>N;if(I)return N=N||a(I,F),N[H];const Z=B[H];return typeof H=="string"?z(Z,`${F}.${H}`):Z},set:(B,H,Z)=>(T(),N&&(N[H]=Z),!0),deleteProperty:(B,H)=>(T(),N&&delete N[H],!0),defineProperty:(B,H,Z)=>(T(),N&&Object.defineProperty(N,H,Z),!0)})}return Array.isArray(j)?(0,u.$Tn)(j):j};C=z(C,k)}return C},update:(k,y,C,I)=>{k=d?`${d}.${k}`:k;const z=D(C);return y!==void 0?this.b.$updateConfigurationOption(z,k,y,h,I):this.b.$removeConfigurationOption(z,k,h,I)},inspect:k=>{k=d?`${d}.${k}`:k;const y=this.e.inspect(k,h,this.c.workspace);if(y)return{key:k,defaultValue:(0,u.$Tn)(y.policy?.value??y.default?.value),globalValue:(0,u.$Tn)(y.user?.value??y.application?.value),workspaceValue:(0,u.$Tn)(y.workspace?.value),workspaceFolderValue:(0,u.$Tn)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$Tn)(y.default?.override),globalLanguageValue:(0,u.$Tn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$Tn)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$Tn)(y.workspaceFolder?.override),languageIds:(0,u.$Tn)(y.overrideIdentifiers)}}};return typeof g=="object"&&(0,u.$Wn)(w,g,!1),Object.freeze(w)}g(d){const l=c=>(0,E.$3f)(c)?new Proxy(c,{get:(h,g)=>l(h[g]),set:(h,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(d)}h(d,l,c){const h=p.$io.test(d)?4:this.d.get(d),g=c?`[${c.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const c=new b.$to(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,g)=>c.affectsConfiguration(h,r(g))})}k(d){return d.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.$nkc=t,e.$okc=(0,P.$ni)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,7,4,6,8,43,72,44,22,42,20,28,5,15,11,12,91,307,13]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(z){function j(N){if(N!=null)return N}z.from=j;function F(N){if(N!=null)return N}z.to=F})(s||(s={}));var t;(function(z){function j(N){if(N!=null)return N}z.from=j;function F(N){if(N!=null)return N}z.to=F})(t||(t={}));var f;(function(z){function j(N){if(N!=null)return N}z.from=j;function F(N){if(N!=null)return N}z.to=F})(f||(f={}));var d;(function(z){function j(T){if(T){const B=T;return B&&!!B.process}else return!1}z.is=j;function F(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=f.from(T.options)),B}z.from=F;function N(T){if(T!=null)return new M.$iN(T.process,T.args,T.options)}z.to=N})(d||(d={}));var l;(function(z){function j(N){if(N!=null)return N}z.from=j;function F(N){if(N!=null)return N}z.to=F})(l||(l={}));var c;(function(z){function j(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=j;function F(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=l.from(T.options)),B}z.from=F;function N(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$jN(T.commandLine,T.options):new M.$jN(T.command,T.args?T.args:[],T.options)}z.to=N})(c||(c={}));var h;(function(z){function j(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}z.is=j;function F(T){return{customExecution:"customExecution"}}z.from=F;function N(T,B){return B.get(T)}z.to=N})(h||(e.CustomExecutionDTO=h={}));var g;(function(z){function j(F,N){let T;return F.scope!==void 0&&typeof F.scope!="number"?T=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===M.TaskScope.Workspace&&N&&N.workspaceFile?T=N.workspaceFile:T=i.$DH),{id:F._id,workspaceFolder:T}}z.from=j})(g||(e.TaskHandleDTO=g={}));var D;(function(z){function j(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=j})(D||(D={}));var w;(function(z){function j(T,B){if(T==null)return[];const H=[];for(const Z of T){const ee=F(Z,B);ee&&H.push(ee)}return H}z.fromMany=j;function F(T,B){if(T==null)return;let H;T.execution instanceof M.$iN?H=d.from(T.execution):T.execution instanceof M.$jN?H=c.from(T.execution):T.execution&&T.execution instanceof M.$kN&&(H=h.from(T.execution));const Z=s.from(T.definition);let ee;return T.scope?typeof T.scope=="number"?ee=T.scope:ee=T.scope.uri:ee=M.TaskScope.Workspace,!Z||!ee?void 0:{_id:T._id,definition:Z,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:ee},execution:H,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}z.from=F;async function N(T,B,H){if(T==null)return;let Z;d.is(T.execution)?Z=d.to(T.execution):c.is(T.execution)?Z=c.to(T.execution):h.is(T.execution)&&(Z=h.to(T._id,H));const ee=s.to(T.definition);let J;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?J=T.source.scope:J=await B.resolveWorkspaceFolder(u.URI.revive(T.source.scope)):J=M.TaskScope.Workspace),!ee||!J)return;const Y=new M.$lN(ee,J,T.name,T.source.label,Z,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=M.$hN.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new M.$hN(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}z.to=N})(w||(e.TaskDTO=w={}));var k;(function(z){function j(N){return N}z.from=j;function F(N){if(N)return Object.assign(Object.create(null),N)}z.to=F})(k||(k={}));class y{#e;constructor(j,F,N){this._id=F,this.a=N,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let C=class{constructor(j,F,N,T,B,H,Z,ee){this.q=new L.$_d,this.r=new L.$_d,this.s=new L.$_d,this.u=new L.$_d,this.a=j.getProxy(R.$xM.MainThreadTask),this.b=N,this.c=T,this.d=B,this.e=H,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,F,N){if(!N)return new M.$zM(()=>{});const T=this.x();return this.j.set(T,{type:F,provider:N,extension:j}),this.a.$registerTaskProvider(T,F),new M.$zM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,F){this.a.$registerTaskSystem(j,F)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async F=>{const N=[];for(const T of F){const B=await w.to(T,this.b,this.m);B&&N.push(B)}return N})}get taskExecutions(){const j=[];return this.k.forEach(F=>j.push(F)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,F,N){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(F,await T.callback(N))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const F=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const F=await this.z(j.id);this.s.fire({execution:F,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const F=await this.z(j.id);this.u.fire({execution:F,exitCode:j.exitCode})}$provideTasks(j,F){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));const T=[],B=(0,O.$fh)(()=>N.provider.provideTasks(A.CancellationToken.None)).then(H=>this.v(F,T,N,H));return new Promise(H=>{B.then(Z=>{Promise.all(T).then(()=>{H(Z)})})})}async $resolveTask(j,F){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));if(F.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${N.type}].`);const T=await w.to(F,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask(T,A.CancellationToken.None);if(!B)return;this.A(B,N);const H=w.from(B,N.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(H.execution)&&await this.y(H,B,!0),await this.w(H)}x(){return this.h++}async y(j,F,N){const T=await this.a.$createTaskId(j);!N&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,F.execution)),this.m.set(T,F.execution)}async z(j,F){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const N=this.l.get(j.id);if(N)return N;let T;return F?T=Promise.resolve(new y(this,j.id,F)):T=w.to(j.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,j.id,B)}),this.l.set(j.id,T),T.then(B=>(this.k.set(j.id,B),B))}A(j,F){j._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const N=this.n.values();let T=N.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=N.next()}};e.$Olc=C,e.$Olc=C=Je([We(0,$.$UO),We(1,S.$$O),We(2,b.$lkc),We(3,p.$6O),We(4,E.$okc),We(5,P.$Mkc),We(6,o.$Tj),We(7,n.$Yjc)],C);let I=class extends C{constructor(j,F,N,T,B,H,Z,ee){super(j,F,N,T,B,H,Z,ee),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(j,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const N=w.from(F,j);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.y(N,F,!1);else throw new r.$_;const T=await this.z(await this.a.$getTaskExecution(N),F);return this.a.$executeTask(N).catch(B=>{throw new Error(B)}),T}v(j,F,N,T){const B=[];if(T)for(const H of T){if(this.A(H,N),!H.definition||!j[H.definition.type]){const ee=H.source?H.source:"No task source";this.f.warn(`The task [${ee}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`)}const Z=w.from(H,N.extension);Z&&h.is(Z.execution)?(B.push(Z),F.push(this.y(Z,H,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async w(j){if(h.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,F,N){}};e.$Plc=I,e.$Plc=I=Je([We(0,$.$UO),We(1,S.$$O),We(2,b.$lkc),We(3,p.$6O),We(4,E.$okc),We(5,P.$Mkc),We(6,o.$Tj),We(7,n.$Yjc)],I),e.$Qlc=(0,v.$ni)("IExtHostTask")}),define(ke[368],Ee([1,0,36,29]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=void 0,e.$aL=L,e.$cL=R;function L(M){return"cellResults"in M}e.$bL="rawCell#";function R(M,b){let p=-1;const E=[];let A=[];return M.forEach($=>{$.range.startLineNumber!==p&&A.length>0&&(E.push([...A]),A=[]),A.push($),p=$.range.endLineNumber}),A.length>0&&E.push([...A]),E.map($=>{const S=[],v=$[0].range.startLineNumber,a=$[$.length-1].range.endLineNumber;for(let m=v;m<=a;m++)S.push(b.getLineContent(m));return new u.$QK(S.join(`
`)+`
`,$.map(m=>new O.$ht(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[369],Ee([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,8,48,339,153,24,15,297,368,365]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,h,g,D,w,k){this.q=g,this.r=D,this.s=w,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$_d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$_d,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$_d,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$_d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Wjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy($.$xM.MainThreadNotebook),this.c=c.getProxy($.$xM.MainThreadNotebookDocuments),this.d=c.getProxy($.$xM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,I=y.cell.handle,j=this.g.get(C)?.getCell(I);if(j)return j.apiCell}if(y&&y.$mid===14){const C=y.uri,I=this.g.get(C);if(I)return I.apiNotebook}return y}}),d.B(h)}getEditorById(c){const h=this.h.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(c){for(const[h,g]of this.h)if(g.apiEditor===c)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,h){const g=this.g.get(c);if(!g&&!h)throw new Error(`NO notebook document for '${c}'`);return g}static u(c,h){if(!h)return;const g=h.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(h.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:h.displayName,filenamePattern:g,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,h,g){const D=d.a++,w=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(D,g),this.b.$registerNotebookCellStatusBarItemProvider(D,w,h);let k;return w!==void 0&&(k=g.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(w))),new a.$zM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,w),k?.dispose()})}async createNotebookDocument(c){const h=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&v.NotebookData.from(c.content)});return E.URI.revive(h)}async openNotebookDocument(c){const h=this.g.get(c);if(h)return h.apiNotebook;const g=await this.c.$tryOpenNotebook(c),D=this.g.get(E.URI.revive(g));return(0,p.$_f)(D?.apiNotebook)}async showNotebookDocument(c,h){E.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let g;typeof h=="object"?g={position:v.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(v.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,g),w=D&&this.h.get(D)?.apiEditor;if(w)return w;throw D?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,h,g,D){const w=this.f.get(c),k=E.URI.revive(h),y=this.g.get(k);if(!y||!w)return;const C=y.getCellFromIndex(g);if(!C)return;const I=await w.provideCellStatusBarItems(C.apiCell,D);if(!I)return;const z=new R.$Tc,j=this.p.add([z]),N=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,z));return{cacheId:j,items:N}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,h,g,D,w){if((0,b.$Ze)(h))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:h,serializer:g,options:D}),this.b.$registerNotebookSerializer(k,{id:c.identifier,location:c.extensionLocation},h,v.NotebookDocumentContentOptions.from(D),d.u(c,w)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(c,h,g){const D=this.x.get(c);if(!D)throw new Error("NO serializer found");const w=await D.serializer.deserializeNotebook(h.buffer,g);return new m.$jw(v.NotebookData.from(w))}async $notebookToData(c,h,g){const D=this.x.get(c);if(!D)throw new Error("NO serializer found");const w=await D.serializer.serializeNotebook(v.NotebookData.to(h.value),g);return O.$ze.wrap(w)}async $saveNotebook(c,h,g,D,w){const k=E.URI.revive(h),y=this.x.get(c);if(!y)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$cl((0,u.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,i.$2n)(C.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of C.apiNotebook.getCells()){const B=new a.$2N(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$2n)(T.metadata,H=>!(y.options?.transientCellMetadata??{})[H]),I.cells.push(B)}const z=await y.serializer.serializeNotebook(I,w);await this.s.value.writeFile(k,z);const j=this.s.getFileSystemProviderExtUri(k.scheme),F=await this.s.value.stat(k);return{name:j.basename(k),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$nl({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(c,h,g,D,w){const k=this.x.get(c)?.serializer;if(!k)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(F,N,T)=>{await Promise.all(F.map(async B=>await Promise.all(B.filenamePatterns.map(H=>{const Z={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:H};return this.t.doInternalFileSearchWithCustomCallback(Z,N,ee=>{ee.forEach(J=>{y.has(J)||D.some(re=>B.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(te=>(0,f.$Xfb)(te,J)))||y.add(J)})}).catch(ee=>{if(ee.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ee})}))))})(g,w,h);const I=new M.$Bc;let z=!1;const j=Array.from(y).map(async F=>{const N=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...I.values()].reduce((Z,ee)=>Z+ee.cellResults.length,0)>h.maxResults){z=!0;return}const T=[],B=this.g.get(F);if(B)B.apiNotebook.getCells().forEach(ee=>T.push({input:ee.document.getText(),outputs:ee.outputs.flatMap(J=>J.items.map(Y=>Y.data.toString()))}));else{const Z=await this.s.value.readFile(F),ee=O.$ze.fromString(Z.toString()),J=await k.deserializeNotebook(ee.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(J).cells.forEach(re=>T.push({input:re.source,outputs:re.outputs.flatMap(te=>te.items.map(pe=>pe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;T.forEach((Z,ee)=>{const J=h.contentPattern.pattern,Y=new s.$0Vb(Z.input,void 0,Z.outputs),re=Y.findInInputs(J),te=Y.findInOutputs(J),pe=te.flatMap(Ce=>(0,t.$cL)(Ce.matches,Ce.textBuffer)).map((Ce,x)=>(Ce.webviewIndex=x,Ce));if(re.length>0||te.length>0){const Ce={index:ee,contentResults:(0,t.$cL)(re,Y.inputTextBuffer),webviewResults:pe};N.push(Ce)}});const H={resource:F,cellResults:N};I.set(F,H);return}catch{return}});return await Promise.all(j),{limitHit:z,results:[...I.values()]}}async y(c,h){const g=await this.s.value.stat(c);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$ml&&typeof g.mtime=="number"&&typeof g.size=="number"&&h.mtime<g.mtime&&h.etag!==A.$nl({mtime:h.mtime,size:g.size}))throw new A.$cl((0,u.localize)(1,null),3,h)}z(c){return c.scheme===r.Schemas.file?c.fsPath:c.toString()}A(c,h,g){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const D=new n.$ilc(h,this.d,c,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(h,D)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const g of c.value.removedDocuments){const D=E.URI.revive(g),w=this.g.get(D);w&&(w.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(w.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(c.value.addedDocuments){const g=[];for(const D of c.value.addedDocuments){const w=E.URI.revive(D.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const k=new o.$hlc(this.c,this.q,this.r,w,D);g.push(...D.cells.map(y=>o.$glc.asModelAddData(y))),this.g.get(w)?.dispose(),this.g.set(w,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(k.apiNotebook)}}if(c.value.addedEditors)for(const g of c.value.addedEditors){if(this.h.has(g.id))return;const D=E.URI.revive(g.documentUri),w=this.g.get(D);w&&this.A(w,g.id,g)}const h=[];if(c.value.removedEditors)for(const g of c.value.removedEditors){const D=this.h.get(g);D&&(this.h.delete(g),this.k?.id===D.id&&(this.k=void 0),h.push(D))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const g=new Set;this.l.forEach(D=>g.add(D.id));for(const D of this.h.values()){const w=g.has(D.id);D._acceptVisibility(w)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const h=S.$gP.String.with("notebookType","A notebook type"),g=new S.$iP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new S.$gP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>O.$ze.wrap(w))],new S.$hP("Notebook Data",w=>v.NotebookData.to(w.value))),D=new S.$iP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new S.$gP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$jw(v.NotebookData.from(w)))],new S.$hP("Bytes",w=>w.buffer));c.registerApiCommand(g),c.registerApiCommand(D)}}e.$rlc=d}),define(ke[370],Ee([1,0,17,22,47,35,23,38,36]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;class E{constructor($,S,v){this.k=$,this.l=S,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$hk($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$hk($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const S=this.k.folderQueries||[];return new Promise((v,a)=>{const m=o=>{this.f++,$(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:o,basename:i})}),Promise.all(S.map(o=>this.p(o,m))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{a(new Error((0,L.$$i)(o)))})})}async p($,S){const v=new O.$je,a=this.q($),m=this.r(),o=new p.$5K(this.k,$),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$8d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,v.token),s=i.elapsed(),t=b.$8d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=u.$hc.relative($.folder.path,f.path);if(n){const l=u.$oc(f.path);this.v(S,{base:$.folder,relativePath:d,basename:l});return}this.s(m,$.folder,d,S)}),this.g&&!this.e)?null:(this.u(m,o,S),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q($){const S=(0,p.$4K)(this.k.includePattern,$.includePattern),v=(0,p.$4K)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:v,includes:S,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},S,v,a){if(v===this.a){const o=u.$oc(this.a);this.v(a,{base:S,relativePath:this.a,basename:o})}function m(o){const n=u.$oc(o),i=u.$nc(o);let r=$[i];r||(r=$[i]=[],m(i)),r.push({base:S,relativePath:o,basename:n})}m(v)}u({rootEntries:$,pathToEntries:S},v,a){const m=this,o=this.a;function n(i){const r=(0,p.$7K)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:d,basename:l}=f;if(v.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const c=S[d];if(c)n(c);else{if(d===o)continue;m.v(a,f)}if(m.e)break}}n($)}v($,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(S))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,S,v,a){const m=this.c($.cacheKey),o=new E($,S,m&&m.token);let n=0;const i=r=>{n+=r.length,v(r.map(s=>this.d(s)))};return this.e(o,A.a,i,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new O.$je),this.b.get($)}d($){return $.relativePath?{resource:M.$1g($.base,$.relativePath)}:{resource:$.base}}e($,S,v,a){const m=a.onCancellationRequested(()=>{$.cancel()}),o=i=>{i&&(n.push(i),S>0&&n.length>=S&&(v(n),n=[]))};let n=[];return $.search(o).then(i=>(n.length&&v(n),m.dispose(),i),i=>(n.length&&v(n),m.dispose(),Promise.reject(i)))}}e.$jlc=A}),define(ke[371],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,244,54,12,41,146,366,36]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=void 0,e.$cM=D;let s=class{constructor(k,y,C,I,z){this.a=k,this.b=y,this.c=C,this.d=I,this.e=z}text(k,y,C={}){k=this.f(k,C);const I=this.a.getValue(),z=y&&y.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(y?.map(o.$Ii),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,y){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,y)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),I}file(k,y={}){return{...this.h(k,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(k,y){return k?(k=Array.isArray(k)?k.map(c):c(k),y?this.parseSearchPaths(k):{pattern:f(...Array.isArray(k)?k:[k])}):{}}h(k=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),I=this.g(y.excludePattern,y.expandPatterns),z=k.length>1,j=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(T=>this.q(T,y,I)):k.map(T=>this.r(T,y,I,z))).filter(T=>!!T),F={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=u.$Hb(u.$Rb(this.c.groups.map(Z=>Z.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(Z=>(0,r.$UK)(F,Z.fsPath)),H=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...F,...H}}const N=y.extraFileResources&&y.extraFileResources.filter(T=>(0,r.$UK)(F,T.fsPath));return F.extraFileResources=N&&N.length?N:void 0,F}i(k){const y=[],C=new M.$Bc,I={};let z=!1;return k.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,E.$5g)(j)){const N=this.b.getWorkspaceFolder(j)?.uri??j.with({path:p.$nc(j.fsPath)});let T=C.get(N);T||(z=!0,T={folder:N,includePattern:{}},y.push(T),C.set(N,T));const B=p.$mc(N.fsPath,j.fsPath);(0,P.$_f)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(z=!0,I[j.fsPath]=!0)}),{folderQueries:y,includePattern:I,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(k,y){if(y.isSmartCase){if(k.isRegExp){if(A.$Rf(k.pattern,!0))return!0}else if(A.$Rf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,S.$yC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const y=H=>p.$jc(H)||/^\.\.?([\/\\]|$)/.test(H),I=(Array.isArray(k)?k:d(k)).map(H=>{const Z=this.e.resolvedUserHome;return Z?(0,R.$ow)(H,Z.scheme===b.Schemas.file?Z.fsPath:Z.path):H}),z=O.$K(I,H=>y(H)?"searchPaths":"exprSegments"),j=(z.exprSegments||[]).map(H=>A.$$e(H,"/")).map(H=>A.$$e(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),l(H))),F={},N=this.m(z.searchPaths||[]);N&&N.length&&(F.searchPaths=N);const T=u.$Rb(j),B=f(...T);return B&&(F.pattern=B),F}l(k,y){return y.disregardExcludeSettings?void 0:(0,r.$TK)(k,!y.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const y=k.flatMap(I=>{let{pathPortion:z,globPortion:j}=t(I);return j&&(j=h(j)),this.n(z).flatMap(N=>this.o(N,j))}),C=new Map;return y.forEach(I=>{const z=I.searchPath.toString(),j=C.get(z);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):C.set(z,{searchPath:I.searchPath,pattern:I.pattern?f(I.pattern):void 0})}),Array.from(C.values())}n(k){if(p.$jc(k)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:k})}]:[{searchPath:$.URI.file(p.$ic(k))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(k=c(k),k.startsWith("../")||k===".."){const I=p.$hc.resolve(y.path,k);return[{searchPath:y.with({path:I})}]}const C=h(k);return[{searchPath:y,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const y=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(z=>{const j=y.match(new RegExp(`^${A.$5e(z.name)}(?:/(.*)|$)`));return j?{match:j,folder:z}:null}).filter(P.$9f);if(I.length)return I.map(z=>{const j=z.match[1];return{searchPath:z.folder.uri,pattern:j&&h(j)}});{const z=k.match(/\.[\/\\](.+)[\/\\]?/),j=z?z[1]:k,F=v.localize(0,null,j);throw new Error(F)}}}}o(k,y){const C=k.pattern&&y?`${k.pattern}/${y}`:k.pattern||y,I=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:C+"/**"}),I}q(k,y,C){const I=this.r((0,o.$Ii)(k.searchPath),y,C,!1);return I?{...I,includePattern:k.pattern}:null}r(k,y,C,I){let z;const j=$.URI.isUri(k)?k:k.uri;if(C.searchPaths){const H=C.searchPaths.filter(Z=>(0,E.$Tg)(Z.searchPath,j))[0];if(H&&!H.pattern)return null;H&&(z=H.pattern)}const F=this.a.getValue({resource:j}),T={...this.l(F,y)||{},...z||{}},B=$.URI.isUri(k)?(0,E.$Xg)(k):k.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.$bM=s,e.$bM=s=Je([We(0,a.$Ti),We(1,o.$wi),We(2,n.$FD),We(3,m.$Tj),We(4,i.$_L)],s);function t(w){const k=w.match(/[\*\{\}\(\)\[\]\?]/);if(k){const y=k.index,C=w.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let I=w.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:w.substr((C.index||0)+1)}}}return{pathPortion:w}}function f(...w){return w.length?w.reduce((k,y)=>(k[y]=!0,k),Object.create(null)):void 0}function d(w){return L.$fk(w,",").map(k=>k.trim()).filter(k=>!!k.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function h(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(w){return w.replace(/([?*[\]])/g,"[$1]")}function D(w,k){w=u.$Mb(w,I=>I.toString());const y=[],C=k.getWorkspace();return w&&w.forEach(I=>{let z;if(k.getWorkbenchState()===2)z=(0,E.$3g)(C.folders[0].uri,I),z&&z!=="."&&(z="./"+z);else{const j=k.getWorkspaceFolder(I);if(j){const F=j.name;if(C.folders.filter(T=>T.name===F).length===1){const T=(0,E.$3g)(j.uri,I);T===""?z=`./${j.name}`:z=`./${j.name}/${T}`}else z=I.fsPath}}z&&y.push(g(z))}),y}}),define(ke[372],Ee([1,0,23,2,22,13,5,371,36,41,7]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btb=$,e.$ctb=a;const P=7e3;function $(m,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const c of n)if(/^workspaceContains:/.test(c)){const h=c.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$gh)(),f=c=>t({activationEvent:c}),d=Promise.all(i.map(c=>S(m,c,f))).then(()=>{}),l=v(m,o.identifier,r,f);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function S(m,o,n){for(const i of m.folders)if(await m.exists(u.$1g(O.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(m,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new L.$je,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let f=!1;try{f=await s}catch(d){R.$4(d)||R.$1(d)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function a(m,o,n,i){const r=m.get(M.$mi),s=m.get(p.$LK),f=r.createInstance(b.$bM).file(o.map(d=>(0,E.$Ii)(O.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(d=>!!d.limitHit,d=>R.$4(d)?!1:Promise.reject(d))}}),define(ke[49],Ee([1,0,220,17,59,23,7,3,77,2,12,6,44,303,118,43,26,148,13,25,21,281,8,66,5,28,93,20,107,70,42,121,4,372,117,283,15,115,38,11,116]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k,y,C,I,z,j,F,N,T,B){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$1kc=e.$Zkc=e.$Ykc=e.$Xkc=void 0,e.$Xkc=(0,d.$ni)("IHostUtils");let Z=H=class extends b.$Uc{constructor(U,ne,be,De,ae,ce,se,K,ie,le,de,Ae,me){super(),this.Y=Ae,this.Z=me,this.a=this.B(new y.$_d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ne,this.g=be,this.f=se,this.j=De,this.m=ae,this.s=ce,this.t=ie,this.u=le,this.w=de,this.y=this.g.getProxy(P.$xM.MainThreadWorkspace),this.z=this.g.getProxy(P.$xM.MainThreadTelemetry),this.C=this.g.getProxy(P.$xM.MainThreadExtensionService),this.D=new M.$mh,this.F=new M.$mh,this.G=new M.$mh,this.H=new M.$mh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new o.$z$b(this.I,this.f.extensions.allExtensions);const Pe=new i.$Jm(this.f.extensions.myExtensions);this.J=new o.$z$b(this.I,te(this.L,Pe)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new v.$Ikc(this.g,this.s),this.N=new I.$Qkc(this.g),this.O=K,this.h=U.createChild(new g.$li([v.$Jkc,this.M],[I.$Rkc,this.N])),this.P=this.B(new S.$Hkc(this.J,this.L,{onExtensionActivationError:(Me,je,q)=>{this.C.$onExtensionActivationError(Me,n.$3(je),q)},actualActivateExtension:async(Me,je)=>{if(o.$z$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,je),new S.$Gkc;const q=this.J.getExtensionDescription(Me);return this.fb(q,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(U)}terminate(U,ne=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(De=>{this.s.error(De)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$oh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.s.info(`Extension host exiting with code ${ne}`),this.s.flush(),this.s.dispose(),this.c.exit(ne)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ne=await this.C.$getExtension(U);return ne&&{...ne,identifier:new i.$Im(ne.identifier.value),extensionLocation:E.URI.revive(ne.extensionLocation)}}ab(U,ne){return this.P.activateByEvent(U,ne)}bb(U,ne){return this.P.activateById(U,ne)}activateByIdWithErrors(U,ne){return this.bb(U,ne).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const ne=U.fsPath;this.R.has(ne)||this.R.set(ne,this.c.fsRealpath(ne));const be=await this.R.get(ne);return E.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new pe(U))),this.Q}async db(U){const ne=p.$ti.forUris(be=>R.$Rg.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const De=await this.cb(be.extensionLocation);ne.set(De,be)}})),ne}eb(U){let ne=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ne;const be=this.P.getActivatedExtension(U);if(!be)return ne;try{typeof be.module.deactivate=="function"&&(ne=Promise.resolve(be.module.deactivate()).then(void 0,De=>(this.s.error(De),Promise.resolve(void 0))))}catch(De){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(De)}try{(0,b.$Pc)(be.subscriptions)}catch(De){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(De)}return ne}async fb(U,ne){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ne).then(be=>{const De=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,ne),this.gb(U,ne,"success",De),be},be=>{throw this.gb(U,ne,"failure"),be})}gb(U,ne,be,De){const ae=J(U,ne);this.z.$publicLog2("extensionActivationTimes",{...ae,...De||{},outcome:be})}hb(U,ne){const be=J(U,ne);this.z.$publicLog2("activatePlugin",be);const De=this.wb(U);if(!De)return Promise.resolve(new S.$Fkc(S.$Ckc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${U.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.s.flush();const ae=new S.$Dkc(ne.startup);return Promise.all([this.xb(U,(0,R.$1g)(U.extensionLocation,De),ae),this.ib(U)]).then(ce=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),H.jb(this.s,U.identifier,ce[0],ce[1],ae))).then(ce=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ce))}ib(U){const ne=this.Z.createLanguageModelAccessInformation(U),be=new s.$Lkc(U,this.M),De=new s.$Kkc(U.identifier.value,!1,this.M),ae=new z.$Skc(U,this.N),ce=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,De.whenReady,this.O.whenReady]).then(()=>{const K=this;let ie,le;const de=(0,m.$gG)(U,"ipc")?this.f.messagePorts?.get(i.$Im.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:De,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return O.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return O.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return ce},get extension(){return ie===void 0&&(ie=new re(K,U.identifier,U,se,!1)),ie},get extensionRuntime(){return(0,m.$hG)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!le){if(!de)return;const Ae=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",me=>me.data));de.start(),le={onDidReceiveMessage:Ae,postMessage:de.postMessage.bind(de)}}return le}})})}static jb(U,ne,be,De,ae){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ne,be,De,ae).then(ce=>new S.$Ekc(!1,null,ae.build(),be,ce,De.subscriptions))}static kb(U,ne,be,De,ae){if(typeof be.activate=="function")try{ae.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const ce=typeof global=="object"?global:self,se=be.activate.apply(ce,[De]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(se).then(K=>(ae.activateResolveStop(),K))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(be)}lb(U,ne){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ne}).then(void 0,be=>{this.s.error(be)})}mb(U,ne=0){const De=Date.now();(0,T.$B)(()=>{for(let ae=ne;ae<U.length;ae+=1){const ce=U[ae];for(const se of ce.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-De>50){this.mb(U,ae);break}else this.lb(ce,se)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ne=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ne)this.mb(be);else for(const De of be)if(De.activationEvents)for(const ae of De.activationEvents)ae==="onStartupFinished"&&this.lb(De,ae)})}ob(){const U=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const ne=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ne),De=this.rb(),ae=Promise.all([De,U,be]).then(()=>{});return Promise.race([ae,(0,M.$oh)(1e4)]).then(()=>{this.nb()}),ae}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ne=>this.qb(U,ne))).then(()=>{})}async qb(U,ne){if(this.isActivated(ne.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,De={logService:this.s,folders:U.map(ce=>ce.uri),forceUsingSearch:be||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,se,K)=>this.y.$checkExists(ce,se,K)},ae=await(0,C.$btb)(De,ne);if(ae)return this.bb(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:ae.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ne}=this.f.environment;if(!U||!ne)throw new Error(u.localize(0,null));const be=await this.xb(null,ne,new S.$Dkc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,ne.toString()));return new Promise((De,ae)=>{const ce=(ie,le)=>{ie?(T.$t&&this.s.error("Test runner called back with error",ie),ae(ie)):(T.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),De(typeof le=="number"&&le>0?1:0))},se=(0,R.$Og)(ne),K=be.run(se,ce);K&&K.then&&K.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),De(0)}).catch(ie=>{T.$t&&this.s.error("Test runner finished with error",ie),ae(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$oh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ne){return this.S[U]=ne,(0,b.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ne}=await this.ub(U);return ne?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ne=U.indexOf("+");if(ne===-1)throw new t.$FM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ne);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ne){const be=N.$8d.create(!1),De=()=>`[resolveAuthority(${(0,f.$Cl)(U)},${ne})][${be.elapsed()}ms] `,ae=W=>this.s.info(`${De()}${W}`),ce=W=>this.s.warn(`${De()}${W}`),se=(W,X=void 0)=>this.s.error(`${De()}${W}`,X),K=W=>{if(W instanceof t.$FM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},ie=async W=>{ae(`activating resolver for ${W}...`);const{resolver:X,authorityPrefix:Q}=await this.ub(W);if(!X)throw se(`no resolver for ${Q}`),new t.$FM(`No remote extension installed to resolve ${Q}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:Q,remoteAuthority:W}},le=U.split(/@|%40/g).reverse();ae(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(ie)).catch(async W=>{if(!(W instanceof t.$FM)||W._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return ce(`resolving nested authorities failed: ${W.message}`),[await ie(U)]})}catch(W){return K(W)}const Ae=new M.$yh;Ae.cancelAndSet(()=>ae("waiting..."),1e3);let me,Pe;for(const[W,{authorityPrefix:X,resolver:Q,remoteAuthority:fe}]of de.entries())try{if(W===de.length-1)ae("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${X}`),me=await Q.resolve(fe,{resolveAttempt:ne,execServer:Pe}),L.mark(`code/extHost/didResolveAuthorityOK/${X}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$EM.isManagedResolvedAuthority(me)?me:void 0));else{if(ae(`invoking resolveExecServer() for ${fe}`),L.mark(`code/extHost/willResolveExecServer/${X}`),Pe=await Q.resolveExecServer?.(fe,{resolveAttempt:ne,execServer:Pe}),!Pe)throw new t.$FM(`Exec server was not available for ${fe}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(we){return L.mark(`code/extHost/didResolveAuthorityError/${X}`),se("returned an error",we),Ae.dispose(),K(we)}Ae.dispose();const Me={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures?{elevation:me.tunnelFeatures.elevation,privacyOptions:me.tunnelFeatures.privacyOptions,protocol:me.tunnelFeatures.protocol===void 0?!0:me.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$EM.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let q;if(t.$EM.isManagedResolvedAuthority(me)){const W=ne;this.Y.setFactory(W,me.makeConnection),q={authority:U,connectTo:new f.$zl(W),connectionToken:me.connectionToken}}else q={authority:U,connectTo:new f.$Al(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:q,options:je,tunnelInformation:Me}}}async $getCanonicalURI(U,ne){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Cl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const De=E.URI.revive(ne);if(typeof be.getCanonicalURI>"u")return De;const ae=await(0,M.$fh)(()=>be.getCanonicalURI(De));return ae||De}async $startExtensionHost(U){U.toAdd.forEach(ce=>ce.extensionLocation=E.URI.revive(ce.extensionLocation));const{globalRegistry:ne,myExtensions:be}=ee(this.I,this.L,this.J,U),De=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(De),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(U,ne){return ne===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ne){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ne),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ce=>ce.extensionLocation=E.URI.revive(ce.extensionLocation));const{globalRegistry:ne,myExtensions:be}=ee(this.I,this.L,this.J,U),De=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(De),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ne=r.$ze.alloc(U),be=Math.random()%256;for(let De=0;De<U;De++)ne.writeUInt8(be,De);return ne}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$Ykc=Z,e.$Ykc=Z=H=Je([We(0,d.$mi),We(1,e.$Xkc),We(2,h.$UO),We(3,a.$lkc),We(4,$.$okc),We(5,A.$Tj),We(6,l.$$O),We(7,c.$rkc),We(8,D.$eCb),We(9,w.$Mkc),We(10,F.$Ukc),We(11,B.$Vkc),We(12,k.$bkc)],Z);function ee(x,U,ne,be){x.addActivationEvents(be.addActivationEvents);const De=new o.$z$b(x,U.getAllExtensionDescriptions());De.deltaExtensions(be.toAdd,be.toRemove);const ae=new i.$Jm(ne.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of be.myToRemove)ae.delete(se);for(const se of be.myToAdd)ae.add(se);const ce=te(De,ae);return{globalRegistry:De,myExtensions:ce}}function J(x,U){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Y(x){return x.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$Zkc=(0,d.$ni)("IExtHostExtensionService");class re{#e;#t;#i;constructor(U,ne,be,De,ae){this.#e=U,this.#t=ne,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.$ic((0,R.$Og)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=De,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$1kc=re;function te(x,U){return x.getAllExtensionDescriptions().filter(ne=>U.has(ne.identifier))}class pe{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$2kc=pe;class Ce{constructor(U){this.a=new i.$Km,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ne of Object.keys(U))this.a.set(ne,U[ne])}}}),define(ke[373],Ee([1,0,59,2,6,44,26,25,20,28,5,49,12,14]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let a=class{constructor(r,s,t,f,d,l,c){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$$lc=a,e.$$lc=a=Je([We(2,A.$mi),We(3,R.$okc),We(4,P.$Zkc),We(5,E.$$O),We(6,$.$Tj)],a);let m=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const s=(0,S.$5e)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,l=v.a.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};m=v=Je([We(0,E.$$O)],m);class o{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new b.$Km}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,l)=>f+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(M.$bG,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$xM.MainThreadTelemetry);const f=t.getProxy(L.$xM.MainThreadWindow);this.c=(d,l)=>{const c=O.URI.parse(d);return l?this.g(d,l):c.scheme==="http"||c.scheme==="https"?f.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?f.$openUri(c,d,{}):this.g(d,l)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,p.$UO)],n)}),define(ke[61],Ee([1,0,46,3,17,51,5,72,71,49,8,43,300,44]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=void 0,e.$3kc=(0,M.$ni)("IExtHostVariableResolverProvider");class v extends $.$WP{constructor(o,n,i,r,s,t,f){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const c=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$kO||c.input instanceof A.$pO)return c.input.modified;if(c.input instanceof A.$jO||c.input instanceof A.$oO||c.input instanceof A.$mO)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(h=>h.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>s.getConfiguration(void 0,l).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return L.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const c=n.getWorkspaceFolder(l);if(c)return L.$ic(c.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(R.env))}}let a=class extends O.$Uc{constructor(o,n,i,r,s){super(),this.b=o,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$4kc=a,e.$4kc=a=Je([We(0,E.$Zkc),We(1,P.$lkc),We(2,b.$6O),We(3,S.$okc),We(4,p.$Akc)],a)}),define(ke[96],Ee([1,0,7,4,2,25,5,6,71,49,20,8,43,143,292,44,61,3,57,33,16]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=e.$8kc=e.$7kc=e.$6kc=e.$5kc=void 0,e.$5kc=(0,M.$ni)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,D,w,k,y,C,I){this.N=D,this.O=w,this.P=k,this.Q=y,this.R=C,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$_d,this.o=new O.$_d,this.q=new O.$_d,this.w=new O.$_d,this.l=g.getProxy(b.$xM.MainThreadDebugService),this.A=new O.$_d,this.C=new O.$_d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(z=>{z.onDidChange(j=>{this.V(z)}),this.V(z)})}async $getVisualizerTreeItem(g,D){const w=this.W(D);if(!w)return;const k=await this.H.get(g)?.getTreeItem?.(w);return k?this.U(g,k):void 0}registerDebugVisualizationTree(g,D,w){const k=R.$Im.toKey(g.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,w),this.l.$registerDebugVisualizerTree(y,!!w.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const w=this.J.get(D)?.item;return w?(await this.H.get(g)?.getChildren?.(w))?.map(y=>this.U(g,y))||[]:[]}async $editVisualizerTreeItem(g,D){const w=this.J.get(g);if(!w)return;const k=await this.H.get(w.provider)?.editItem?.(w.item,D);return this.U(w.provider,k||w.item)}$disposeVisualizedTree(g){const D=this.J.get(g);if(!D)return;const w=[D.children];for(const k of w)if(k)for(const y of k)w.push(this.J.get(y)?.children),this.J.delete(y)}U(g,D){let w=this.I.get(D);return w||(w=this.F++,this.I.set(D,w),this.J.set(w,{provider:g,item:D})),r.DebugTreeItem.from(D,w)}asDebugSourceUri(g,D){const w=g;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let k=`debug:${encodeURIComponent(w.path||"")}`,y="?";return D&&(k+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),k+=`${y}ref=${w.sourceReference}`,L.URI.parse(k)}else{if(w.path)return L.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const D=[];for(const w of g.getAllExtensionDescriptions())if(w.contributes){const k=w.contributes.debuggers;if(k&&k.length>0)for(const y of k)(0,v.$TG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const w=this.L.get(g);if(!w)throw new Error(`No debug visualizer found with id '${g}'`);let{v:k,provider:y,extensionId:C}=w;if(k.visualization||(k=await y.resolveDebugVisualization?.(k,D)||k,w.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(g){const D=this.L.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const w=D.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(g){const D=this.m.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,w,k){const y=this.W(w),C=this.jb(g,D),I=this.G.get(C);if(!y||!I)return[];const z=await I.provideDebugVisualization(y,k);return z?z.map(j=>{const F=++this.M;this.L.set(F,{v:j,provider:I,extensionId:g});const N=j.iconPath?this.lb(j.iconPath):void 0;return{id:F,name:j.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.kb(g,j.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this.L.delete(D)}registerDebugVisualizationProvider(g,D,w){if(!g.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=R.$Im.toKey(g.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,w),this.l.$registerDebugVisualizer(k,D),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(g){const D=g.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const w=[],k=new Map;for(const y of D)if(y instanceof P.$AN){let C=k.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},k.set(y.location.uri.toString(),C),w.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof P.$BN&&w.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(g){const D=g.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const w=D.filter(C=>C instanceof P.$AN).map(C=>C.id),k=D.filter(C=>C instanceof P.$BN).map(C=>C.id),y=D.filter(C=>C instanceof P.$CN).map(C=>C.id);return this.l.$unregisterBreakpoints(w,k,y)}startDebugging(g,D,w){return this.l.$startDebugging(g?g.uri:void 0,D,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,w){if(!D)return new P.$zM(()=>{});const k=this.d++;return this.f.push({type:g,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(g,w,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new P.$zM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(g,D,w){if(!w)return new P.$zM(()=>{});if(!this.cb(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new P.$zM(()=>{this.h=this.h.filter(y=>y.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new P.$zM(()=>{});const w=this.j++;return this.k.push({type:g,handle:w,factory:D}),new P.$zM(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let w;const k=await this.ib(g);return k&&(w={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,D)}X(g,D){if(g.type==="implementation")return new l(g.implementation)}Y(){}async $startDASession(g,D){const w=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(y),I=this.X(C,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const z=I;return this.D.set(g,z),this.db(k).then(j=>(j&&this.E.set(g,j),z.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const N=F,T={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(N.arguments.value);T.body={signature:B},z.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,z.sendResponse(T)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(F),F=(0,v.$YG)(F,!0),w.l.$acceptDAMessage(g,F)}),z.onError(F=>{j&&j.onError&&j.onError(F),this.l.$acceptDAError(g,F.name,F.message,F.stack)}),z.onExit(F=>{j&&j.onExit&&j.onExit(F??void 0,void 0),this.l.$acceptDAExit(g,F??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),z.startSession()))})}$sendDAMessage(g,D){D=(0,v.$XG)(D,!1);const w=this.E.get(g);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(D),this.D.get(g)?.sendMessage(D)}$stopDASession(g){const D=this.E.get(g);this.E.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const w=this.D.get(g);return this.D.delete(g),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],w=[],k=[];if(g.added)for(const y of g.added){const C=y.id;if(C&&!this.z.has(C)){let I;if(y.type==="function")I=new P.$BN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")I=new P.$CN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const z=L.URI.revive(y.uri);I=new P.$AN(new P.$LM(z,new P.$AM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,P.$yN)(I,C),this.z.set(C,I),D.push(I)}}if(g.removed)for(const y of g.removed){const C=this.z.get(y);C&&(this.z.delete(y),w.push(C))}if(g.changed){for(const y of g.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof P.$BN&&y.type==="function"){const I=C;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.functionName=y.functionName}else if(C instanceof P.$AN&&y.type==="source"){const I=C;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.location=new P.$LM(L.URI.revive(y.uri),new P.$AM(y.line,y.character))}k.push(C)}}}this.gb(D,w,k)}async $acceptStackFrameFocus(g){let D;if(g){const w=await this.hb(g.sessionId);g.kind==="thread"?D=new P.$IN(w.api,g.threadId):D=new P.$HN(w.api,g.threadId,g.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(g,D,w){return(0,u.$fh)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return k.provideDebugConfigurations(y,w)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(g,D,w,k){return(0,u.$fh)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,w,k)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,w,k){return(0,u.$fh)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,w,k)})}async $provideDebugAdapter(g,D){const w=this.ab(g);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb(w,k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(g){const D=await this.hb(g);this.n.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.hb(g);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.hb(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const k={session:(await this.hb(g)).api,event:D.event,body:D.body};this.w.fire(k)}Z(g){if(g instanceof P.$DN)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof P.$EN)return{type:"server",port:g.port,host:g.host};if(g instanceof P.$FN)return{type:"pipeServer",path:g.path};if(g instanceof P.$GN)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const D=this.h.filter(w=>w.type===g);if(D.length>0)return D[0].factory}ab(g){const D=this.h.filter(w=>w.handle===g);if(D.length>0)return D[0].factory}bb(g){const D=this.f.filter(w=>w.handle===g);if(D.length>0)return D[0].provider}cb(g,D){if(g.contributes){const w=g.contributes.debuggers;if(w&&w.length>0){for(const k of w)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(g){const w=g.configuration.type,k=this.k.filter(y=>y.type===w||y.type==="*").map(y=>(0,u.$fh)(()=>y.factory.createDebugAdapterTracker(g.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(y=>{const C=y.filter(I=>!!I);if(C.length>0)return new d(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(g,D){const w=D.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new P.$EN(w));if(g){const y=await this.O.getExtensionRegistry();return(0,u.$fh)(()=>g.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(g,D){}gb(g,D,w){(g.length>0||D.length>0||w.length>0)&&this.A.fire(Object.freeze({added:g,removed:D,changed:w}))}async hb(g){if(g)if(typeof g=="string"){const D=this.m.get(g);if(D)return D}else{let D=this.m.get(g.id);if(!D){const w=await this.ib(g.folderUri),k=g.parent?this.m.get(g.parent):void 0;D=new t(this.l,g.id,g.type,g.name,w,g.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(g){if(g){const D=L.URI.revive(g);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(g,D){return`${g}\0${D}`}kb(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const D=this.mb(g);let w,k;return"id"in D?k=n.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:k}}mb(g){if(g instanceof P.$vN)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,w=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof w=="string"?L.URI.file(w):w}}};e.$6kc=s,e.$6kc=s=Je([We(0,A.$UO),We(1,$.$lkc),We(2,E.$Zkc),We(3,a.$okc),We(4,p.$Akc),We(5,m.$3kc),We(6,i.$eP)],s);class t{constructor(g,D,w,k,y,C,I){this.f=g,this.g=D,this.h=w,this.j=k,this.k=y,this.l=C,this.m=I}get api(){const g=this;return this.d??=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(D){g.j=D,g.f.$setDebugSessionName(g.g,D)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(D,w){return g.f.$customDebugAdapterRequest(g.g,D,w)},getDebugProtocolBreakpoint(D){return g.f.$getDebugProtocolBreakpoint(g.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$7kc=t;class f{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$8kc=f;class d{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.d.forEach(w=>w.onExit?w.onExit(g,D):void 0)}}class l extends S.$gob{constructor(g){super(),this.h=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends s{constructor(g,D,w,k,y,C,I){super(g,D,w,k,y,C,I)}};e.$9kc=c,e.$9kc=c=Je([We(0,A.$UO),We(1,$.$lkc),We(2,E.$Zkc),We(3,a.$okc),We(4,p.$Akc),We(5,m.$3kc),We(6,i.$eP)],c)}),define(ke[374],Ee([1,0,13,59,2,6,321,12,84,107,28,257,20,67,49,90]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=e.$_lc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(b.$Tj),t=i.get($.$UO).getProxy(R.$xM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const d=u.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(b.$Tj),s=i.get($.$UO),t=i.get(v.$Zkc),f=i.get(a.$cP),d=s.getProxy(R.$xM.MainThreadExtensionService),l=s.getProxy(R.$xM.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function g(k,y){if(h.has(k))return h.get(k).stack;let C="",I,z;for(const F of y)C+=`
	at ${F.toString()}`,z=F.getFileName(),!I&&z&&(I=c.findSubstr(L.URI.file(z)));const j=`${k.name||"Error"}: ${k.message||""}${C}`;return h.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let w=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(k){if(k===g||!k||k[D]){w=k||g;return}w=function(y,C){return g(y,C),k.call(Error,y,C)},Object.assign(w,{[D]:!0})}}),u.setUnexpectedErrorHandler(k=>{r.error(k);const y=u.$3(k),C=h.get(k);if(!C?.extensionIdentifier){l.$onUnexpectedError(y);return}d.$onExtensionRuntimeError(C.extensionIdentifier,y);const I=f.onExtensionError(C.extensionIdentifier,k);r.trace("forwarded error to extension?",I,C)})}}e.$_lc=m;class o{constructor(i,r,s,t,f){this.a=s,this.b=new M.$H$b(i,null,t),r=o.e(r,this.b);const d=new E.$li(...(0,p.$ms)());d.set(A.$$O,{_serviceBrand:void 0,...r,messagePorts:f}),d.set($.$UO,new $.$VO(this.b)),d.set(S.$ikc,new S.$jkc(t)),d.set(v.$Xkc,s);const l=new P.$4q(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(b.$Tj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(c=>c.get(v.$Zkc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(R.$xM.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$amc=o}),define(ke[375],Ee([1,0,7,11,231,250,141,96,71,49,20,42,8,61,43,293,294,44,33,376]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;let r=class extends b.$6kc{constructor(c,h,g,D,w,k,y,C){super(c,h,g,D,k,y,C),this.pb=w,this.nb=new d}X(c,h){switch(c.type){case"server":return new a.$fmc(c);case"pipeServer":return new a.$gmc(c);case"executable":return new a.$hmc(c,h.type)}return super.X(c,h)}fb(c,h){const g=a.$hmc.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(g)return new $.$DN(g.command,g.args,g.options)}Y(){return new M.$vcc}async $runInTerminal(c,h){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(T=>{this.nb.onTerminalClosed(T)}));const g=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),k=c.title||L.localize(0,null),y=s(D,w,c);let C=await this.nb.checkout(y,k,!0),I,z=!1;if(C)I=c.cwd;else{const T={shellPath:D,shellArgs:w,cwd:c.cwd,name:k,iconPath:new $.$vN("debug"),env:c.env};z=!0,C=this.pb.createTerminalFromOptions(T,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,y)}C.show(!0);const j=await C.processId;z?await new Promise(T=>setTimeout(T,1e3)):(C.state.isInteractedWith&&C.sendText(""),g.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?C.sendText("cls"):D.indexOf("bash")>=0?C.sendText("clear"):O.$i?C.sendText("cls"):C.sendText("clear")));const F=(0,m.$jmc)(D,c.args,!!c.argsCanBeInterpretedByShell,I);C.sendText(F);const N=this.onDidTerminateDebugSession(T=>{T.id===h&&(this.nb.free(C),N.dispose())});return j}else if(c.kind==="external")return f(c,await this.P.getConfigProvider());return super.$runInTerminal(c,h)}};e.$kmc=r,e.$kmc=r=Je([We(0,A.$UO),We(1,v.$lkc),We(2,E.$Zkc),We(3,o.$okc),We(4,P.$Mkc),We(5,p.$Akc),We(6,S.$3kc),We(7,n.$eP)],r);function s(l,c,h){const g=(0,i.createHash)("sha256");return g.update(JSON.stringify({shell:l,shellArgs:c})),g.update(JSON.stringify(Object.entries(h.env||{}).sort(([D],[w])=>D.localeCompare(w)))),g.digest("base64")}let t;function f(l,c){if(!t)if(O.$i)t=new R.$gbc;else if(O.$j)t=new R.$hbc;else if(O.$k)t=new R.$ibc;else throw new Error("external terminals not supported on this platform");const h=c.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,h,g=!1){const w=[...this.b.entries()].map(([k,y])=>(0,u.$ah)(async C=>{if(k.name!==h||y.lastUsedAt!==-1&&await(0,m.$imc)(await k.processId))return null;const I=Date.now();return y.lastUsedAt+d.a>I||C.isCancellationRequested?null:y.config!==c?(g&&k.dispose(),null):(y.lastUsedAt=I,k)}));return await(0,u.$sh)(w,k=>!!k)}insert(c,h){this.b.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this.b.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(ke[377],Ee([1,0,17,2,105,43,72,44,41,42,20,28,95,15,12,91,23,64,61]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;let i=class extends $.$Olc{constructor(s,t,f,d,l,c,h,g,D){super(s,t,f,d,l,c,h,g),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=$.TaskHandleDTO.from(f,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=$.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,f,d){const l=[];if(d)for(const c of d){this.A(c,f),(!c.definition||!s[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(c,f.extension);h&&(l.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,c,!0)))}return{tasks:l,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=O.URI.file((0,o.homedir)());t=new p.$Hi({uri:f,name:m.$Xg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=O.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(f),c=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),g=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(c);for(const D of t.variables)d.variables[D]=await h.resolveAsync(g,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let w=0;w<D.length;w++)D[w]=await h.resolveAsync(g,D[w])}d.process=await L.win32.findExecutable(await h.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(g,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return L.win32.findExecutable(s,t,f)}};e.$cmc=i,e.$cmc=i=Je([We(0,A.$UO),We(1,P.$$O),We(2,R.$lkc),We(3,M.$6O),We(4,b.$okc),We(5,E.$Mkc),We(6,v.$Tj),We(7,a.$Yjc),We(8,n.$3kc)],i)}),define(ke[378],Ee([1,0,64,61]),function(he,e,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;class L extends O.$4kc{m(){return(0,u.homedir)()}}e.$Umc=L}),define(ke[159],Ee([1,0,19,7,22,47,15,17,23,2,36]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$llc=e.$klc=void 0,e.$mlc=a;class P{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new L.$je(i);return new Promise((t,f)=>{this.a=new S(n);let d=!1;const l=(c,h)=>{if(!d&&!this.b){const g=this.h(c);a(c)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),c=this.j(c,this.g.maxResults-this.c));const D=this.h(c);this.c+=D,(D>0||!a(c))&&this.a.add(c,h)}};Promise.all(r.map((c,h)=>this.k(c,g=>l(g,h),s.token))).then(c=>{s.dispose(),this.a.flush();const h=c.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(c.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},c=>{s.dispose();const h=(0,R.$$i)(c);f(new Error(h))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new A.$5K(this.g,n),t=[],f={report:c=>{if(!this.l(c))return;const h=n.folder.scheme===M.Schemas.file?(0,A.$6K)(()=>this.e.readdir(p.$Zg(c.uri))):void 0,g=p.$3g(n.folder,c.uri);if(g){const D=s.includedInQuery(g,b.$oc(g),h);(0,O.$_g)(D)?t.push(D.then(w=>{w&&i(c)})):D&&i(c)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):l=await this.d.provider.provideTextSearchResults($(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),l}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$4K)(this.g.includePattern,n.includePattern),r=(0,A.$4K)(this.g.excludePattern,n.excludePattern),s={folder:E.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$klc=P;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!p.$Tg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$llc=S;function v(o){return a(o)?{preview:{matches:(0,u.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,u.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function a(o){return!!o.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$nlc=m}),define(ke[97],Ee([1,0,3,6,5,370,20,67,12,2,159]),function(he,e,u,O,L,R,M,b,p,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0,e.$qlc=$,e.$olc=(0,L.$ni)("IExtHostSearch");let P=class{constructor(a,m,o){this.n=a,this.o=m,this.q=o,this.c=this.n.getProxy(O.$xM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$jlc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.g.delete(a),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.i.delete(a),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.k.delete(a),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(a,m,o,n){const i=$(o),r=this.j.get(a);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(a,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,o){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,o,n){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=$(o);return this.t(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$provideAITextSearchResults(a,m,o,n){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=$(o);return this.v(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$enableExtensionHostSearch(){}t(a,m){return new A.$klc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(a,m){return new A.$klc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$plc=P,e.$plc=P=Je([We(0,M.$UO),We(1,b.$ikc),We(2,p.$Tj)],P);function $(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(S),extraFileResources:v.extraFileResources&&v.extraFileResources.map(a=>E.URI.revive(a))}}function S(v){return{...v,folder:E.URI.revive(v.folder)}}}),define(ke[379],Ee([1,0,22,13,4,3,15,39,2,135,198,179,79,25,32,12,86,87,276,6,323,349,91,120,327,309,328,121,329,310,298,33,330,44,331,96,151,332,312,324,333,334,72,71,325,49,335,69,336,60,28,350,351,313,337,338,115,116,314,369,340,282,341,352,342,157,315,343,344,345,20,346,97,117,347,316,348,118,93,95,90,42,353,354,326,355,356,70,16,8,317,67,318,92,357,358,150,43,291,114,26,94,155]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k,y,C,I,z,j,F,N,T,B,H,Z,ee,J,Y,re,te,pe,Ce,x,U,ne,be,De,ae,ce,se,K,ie,le,de,Ae,me,Pe,Me,je,q,W,X,Q,fe,we,Fe,Ve,Ze,tt,st,at,ot,Se,Be,Ge,Le,Qe,oe,ue,Ie,Ke,Re,it,ht,wt,It,Bt,Qt,ei,Dt,Vt,Xt,et,ai,ti){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=ii;function ii(dt){const bt=dt.get(x.$$O),si=dt.get(Ce.$3jc),ni=dt.get(te.$qkc),Ot=dt.get(Y.$Zkc),mt=dt.get(Dt.$lkc),Rt=dt.get(Se.$cP),qt=dt.get(C.$okc),Yt=dt.get(ht.$ikc),Xe=dt.get(Q.$UO),Zt=dt.get(st.$Jkc),Ut=dt.get(at.$rkc),Ht=dt.get(a.$Uj),$t=dt.get(a.$Tj),jt=dt.get(Ie.$eCb),Mt=dt.get(t.$Yjc),Ft=dt.get(ei.$4lc),ri=dt.get(Fe.$Rkc),oi=dt.get(ee.$Akc),Wt=dt.get(se.$Vkc),At=dt.get(f.$9jc),Et=dt.get(h.$bkc);Xe.set(i.$yM.ExtHostFileSystemInfo,si),Xe.set(i.$yM.ExtHostLogLevelServiceShape,Ht),Xe.set(i.$yM.ExtHostWorkspace,mt),Xe.set(i.$yM.ExtHostConfiguration,qt),Xe.set(i.$yM.ExtHostExtensionService,Ot),Xe.set(i.$yM.ExtHostStorage,Zt),Xe.set(i.$yM.ExtHostTunnelService,jt),Xe.set(i.$yM.ExtHostWindow,Ft),Xe.set(i.$yM.ExtHostSecretState,ri),Xe.set(i.$yM.ExtHostTelemetry,Rt),Xe.set(i.$yM.ExtHostEditorTabs,oi),Xe.set(i.$yM.ExtHostManagedSockets,Wt),Xe.set(i.$yM.ExtHostAuthentication,At),Xe.set(i.$yM.ExtHostChatProvider,Et);const xt=Xe.set(i.$yM.ExtHostDecorations,dt.get(j.$$kc)),Ct=Xe.set(i.$yM.ExtHostDocumentsAndEditors,dt.get(Z.$6O)),kt=Xe.set(i.$yM.ExtHostCommands,dt.get(k.$eP)),Pt=Xe.set(i.$yM.ExtHostTerminalService,dt.get(Be.$Mkc)),li=Xe.set(i.$yM.ExtHostTerminalShellIntegration,dt.get(ti.$5lc)),St=Xe.set(i.$yM.ExtHostDebugService,dt.get(z.$5kc)),hi=Xe.set(i.$yM.ExtHostSearch,dt.get(we.$olc)),zt=Xe.set(i.$yM.ExtHostTask,dt.get(ot.$Qlc)),bi=Xe.set(i.$yM.ExtHostOutputService,dt.get(Me.$Dlc)),Gt=Xe.set(i.$yM.ExtHostLocalization,dt.get(ce.$Ukc)),gi=Xe.set(i.$yM.ExtHostUrls,new wt.$1lc(Xe)),Nt=Xe.set(i.$yM.ExtHostDocuments,new H.$6jc(Xe,Ct)),Oe=Xe.set(i.$yM.ExtHostDocumentContentProviders,new T.$alc(Xe,Ct,$t)),ze=Xe.set(i.$yM.ExtHostDocumentSaveParticipant,new B.$blc($t,Nt,Xe.getProxy(i.$xM.MainThreadBulkEdits))),ve=Xe.set(i.$yM.ExtHostNotebook,new ie.$rlc(Xe,kt,Ct,Nt,ni,hi)),_=Xe.set(i.$yM.ExtHostNotebookDocuments,new de.$xlc(ve)),Ne=Xe.set(i.$yM.ExtHostNotebookEditors,new Ae.$ylc($t,ve)),qe=Xe.set(i.$yM.ExtHostNotebookKernels,new me.$zlc(Xe,bt,ve,kt,$t)),_e=Xe.set(i.$yM.ExtHostNotebookRenderers,new Pe.$Blc(Xe,ve)),Ye=Xe.set(i.$yM.ExtHostNotebookDocumentSaveParticipant,new le.$wlc($t,ve,Xe.getProxy(i.$xM.MainThreadBulkEdits))),ct=Xe.set(i.$yM.ExtHostEditors,new Le.$fkc(Xe,Ct)),yt=Xe.set(i.$yM.ExtHostTreeViews,new ue.$Ylc(Xe.getProxy(i.$xM.MainThreadTreeViews),kt,$t)),Kt=Xe.set(i.$yM.ExtHostEditorInsets,new w.$gkc(Xe.getProxy(i.$xM.MainThreadEditorInsets),ct,bt.remote)),_t=Xe.set(i.$yM.ExtHostDiagnostics,new F.$5jc(Xe,$t,si,Ct)),Lt=Xe.set(i.$yM.ExtHostLanguages,new ae.$ulc(Xe,Nt,kt.converter,Yt)),lt=Xe.set(i.$yM.ExtHostLanguageFeatures,new De.$7jc(Xe,Yt,Nt,kt,_t,$t,Mt,Rt)),Wi=Xe.set(i.$yM.ExtHostFileSystem,new re.$dlc(Xe,lt)),di=Xe.set(i.$yM.ExtHostFileSystemEventService,new pe.$elc(Xe,$t,Ct)),$i=Xe.set(i.$yM.ExtHostQuickOpen,(0,X.$Hlc)(Xe,mt,kt)),yi=Xe.set(i.$yM.ExtHostSCM,new fe.$Jlc(Xe,kt,Nt,$t)),Ai=Xe.set(i.$yM.ExtHostQuickDiff,new W.$Glc(Xe,Yt)),Vi=Xe.set(i.$yM.ExtHostShare,new Ve.$Klc(Xe,Yt)),hn=Xe.set(i.$yM.ExtHostComments,(0,y.$hkc)(Xe,kt,Nt)),Ri=Xe.set(i.$yM.ExtHostProgress,new q.$Flc(Xe.getProxy(i.$xM.MainThreadProgress))),Mi=Xe.set(i.$yM.ExtHostLabelService,new be.$tlc(Xe)),ki=Xe.set(i.$yM.ExtHostTheming,new Qe.$Vlc(Xe)),qi=Xe.set(i.$yM.ExtHostTimeline,new oe.$Xlc(Xe,kt)),Ei=Xe.set(i.$yM.ExtHostWebviews,new It.$vkc(Xe,bt.remote,mt,$t,Mt)),Si=Xe.set(i.$yM.ExtHostWebviewPanels,new Bt.$ykc(Xe,Ei,mt)),Gi=Xe.set(i.$yM.ExtHostCustomEditors,new I.$zkc(Xe,Nt,Ut,Ei,Si)),Ki=Xe.set(i.$yM.ExtHostWebviewViews,new Qt.$2lc(Xe,Ei)),wi=Xe.set(i.$yM.ExtHostTesting,new Ge.$Rlc(Xe,$t,kt,Ct)),dn=Xe.set(i.$yM.ExtHostUriOpeners,new it.$Zlc(Xe)),fn=Xe.set(i.$yM.ExtHostProfileContentHandlers,new je.$Elc(Xe));Xe.set(i.$yM.ExtHostInteractive,new ne.$slc(Xe,ve,Ct,kt,$t));const Li=Xe.set(i.$yM.ExtHostInlineChat,new U.$flc(Xe,kt,Nt,$t)),Di=Xe.set(i.$yM.ExtHostChatAgents2,new c.$akc(Xe,$t,kt)),gn=Xe.set(i.$yM.ExtHostChatVariables,new g.$dkc(Xe)),Ji=Xe.set(i.$yM.ExtHostChat,new l.$_jc(Xe)),Oi=Xe.set(i.$yM.ExtHostAiRelatedInformation,new r.$Xjc(Xe)),mn=Xe.set(i.$yM.ExtHostAiEmbeddingVector,new J.$clc(Xe)),Ci=Xe.set(i.$yM.ExtHostStatusBar,new tt.$Nlc(Xe,kt.converter)),Qi=Xe.set(i.$yM.ExtHostSpeech,new Ze.$Llc(Xe)),Xi=Object.values(i.$yM);Xe.assertRegistered(Xi);const Yi=new d.$$jc(Xe,Ct),$n=new D.$ekc(Xe),vi=new K.$vlc(Xe,$t),Ni=new N.$_kc(Xe);return s.$8jc.register(kt),function(Ue,ci,Zi){function rt(ge){return(ye,He,ut)=>{const vt=ge(Tt=>{try{ye.call(He,Tt)}catch(Bi){O.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Bi.toString()}`,{cause:Bi})),Rt.onExtensionError(Ue.identifier,Bi)}});return ut?.push(vt),vt}}const pt=function(){let ge=!Ue.isUnderDevelopment;function ye(){ge||($t.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function He(ut){if(Array.isArray(ut))ut.forEach(He);else if(typeof ut=="string")ye();else{const vt=ut;typeof vt.scheme>"u"&&ye(),typeof vt.exclusive=="boolean"&&(0,et.$hG)(Ue,"documentFiltersExclusive")}return ut}}(),xi={getSession(ge,ye,He){return typeof He?.forceNewSession=="object"&&He.forceNewSession.learnMore&&(0,et.$hG)(Ue,"authLearnMore"),At.getSession(Ue,ge,ye,He)},getSessions(ge,ye){return(0,et.$hG)(Ue,"authGetSessions"),At.getSessions(Ue,ge,ye)},async hasSession(ge,ye){return(0,et.$hG)(Ue,"authSession"),!!await At.getSession(Ue,ge,ye,{silent:!0})},get onDidChangeSessions(){return rt(At.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,He,ut){return At.registerAuthenticationProvider(ge,ye,He,ut)}},_i={registerCommand(ge,ye,He){return kt.registerCommand(!0,ge,ye,He,void 0,Ue)},registerTextEditorCommand(ge,ye,He){return kt.registerCommand(!0,ge,(...ut)=>{const vt=ct.getActiveTextEditor();if(!vt){$t.warn("Cannot execute "+ge+" because there is no active text editor.");return}return vt.edit(Tt=>{ye.apply(He,[vt,Tt,...ut])}).then(Tt=>{Tt||$t.warn("Edits from command "+ge+" were not applied.")},Tt=>{$t.warn("An error occurred while running command "+ge,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,ye,He)=>((0,et.$hG)(Ue,"diffCommand"),kt.registerCommand(!0,ge,async(...ut)=>{const vt=Ct.activeEditor(!0);if(!vt){$t.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Tt=await ct.getDiffInformation(vt.id);ye.apply(He,[Tt,...ut])},void 0,void 0,Ue)),executeCommand(ge,...ye){return kt.executeCommand(ge,...ye)},getCommands(ge=!1){return kt.getCommands(ge)}},Ti={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return rt(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return rt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$hG)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$hG)(Ue,"telemetry"),rt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Se.$bP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return Se.$aP.validateSender(ge),Rt.instantiateLogger(Ue,ge,ye)},openExternal(ge,ye){return Ft.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return gi.createAppUri(ge);try{return await Ft.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ye){if((0,M.$wg)(ge,M.Schemas.http)||(0,M.$wg)(ge,M.Schemas.https))return ge;throw ye}},get remoteName(){return(0,m.$zm)(bt.remote.authority)},get remoteAuthority(){return(0,et.$hG)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return rt($t.onDidChangeLogLevel)},get appQuality(){return(0,et.$hG)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,et.$hG)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Ti);const en={createTestController(ge,ye,He){return wi.createTestController(Ue,ge,ye,He)},createTestObserver(){return(0,et.$hG)(Ue,"testObserver"),wi.createTestObserver()},runTests(ge){return(0,et.$hG)(Ue,"testObserver"),wi.runTests(ge)},get onDidChangeTestResults(){return(0,et.$hG)(Ue,"testObserver"),rt(wi.onResultsChanged)},get testResults(){return(0,et.$hG)(Ue,"testObserver"),wi.results}},Pi=bt.remote.isRemote?Re.ExtensionKind.Workspace:Re.ExtensionKind.UI,tn={getExtension(ge,ye){(0,et.$gG)(Ue,"extensionsAny")||(ye=!1);const He=ci.mine.getExtensionDescription(ge);if(He)return new Y.$1kc(Ot,Ue.identifier,He,Pi,!1);if(ye){const ut=ci.all.getExtensionDescription(ge);if(ut)return new Y.$1kc(Ot,Ue.identifier,ut,Pi,!0)}},get all(){const ge=[];for(const ye of ci.mine.getAllExtensionDescriptions())ge.push(new Y.$1kc(Ot,Ue.identifier,ye,Pi,!1));return ge},get allAcrossExtensionHosts(){(0,et.$hG)(Ue,"extensionsAny");const ge=new S.$Jm(ci.mine.getAllExtensionDescriptions().map(He=>He.identifier)),ye=[];for(const He of ci.all.getAllExtensionDescriptions()){const ut=!ge.has(He.identifier);ye.push(new Y.$1kc(Ot,Ue.identifier,He,Pi,ut))}return ye},get onDidChange(){return(0,et.$gG)(Ue,"extensionsAny")?rt(L.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):rt(ci.mine.onDidChange)}},nn={createDiagnosticCollection(ge){return _t.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return rt(_t.onDidChangeDiagnostics)},getDiagnostics:ge=>_t.getDiagnostics(ge),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(ge,ye){return Lt.changeLanguage(ge.uri,ye)},match(ge,ye){const He=Ke.LanguageSelector.from(ge);let ut;return(0,A.$St)(He)&&(ut=ve.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Tt=>Tt.document===ye))?.apiNotebook),(0,A.$Rt)(He,ye.uri,ye.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(ge,ye,He){return lt.registerCodeActionProvider(Ue,pt(ge),ye,He)},registerDocumentPasteEditProvider(ge,ye,He){return(0,et.$hG)(Ue,"documentPaste"),lt.registerDocumentPasteEditProvider(Ue,pt(ge),ye,He)},registerCodeLensProvider(ge,ye){return lt.registerCodeLensProvider(Ue,pt(ge),ye)},registerDefinitionProvider(ge,ye){return lt.registerDefinitionProvider(Ue,pt(ge),ye)},registerDeclarationProvider(ge,ye){return lt.registerDeclarationProvider(Ue,pt(ge),ye)},registerImplementationProvider(ge,ye){return lt.registerImplementationProvider(Ue,pt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return lt.registerTypeDefinitionProvider(Ue,pt(ge),ye)},registerHoverProvider(ge,ye){return lt.registerHoverProvider(Ue,pt(ge),ye,Ue.identifier)},registerEvaluatableExpressionProvider(ge,ye){return lt.registerEvaluatableExpressionProvider(Ue,pt(ge),ye,Ue.identifier)},registerInlineValuesProvider(ge,ye){return lt.registerInlineValuesProvider(Ue,pt(ge),ye,Ue.identifier)},registerDocumentHighlightProvider(ge,ye){return lt.registerDocumentHighlightProvider(Ue,pt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return lt.registerMultiDocumentHighlightProvider(Ue,pt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return lt.registerLinkedEditingRangeProvider(Ue,pt(ge),ye)},registerReferenceProvider(ge,ye){return lt.registerReferenceProvider(Ue,pt(ge),ye)},registerRenameProvider(ge,ye){return lt.registerRenameProvider(Ue,pt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,et.$hG)(Ue,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Ue,pt(ge),ye)},registerDocumentSymbolProvider(ge,ye,He){return lt.registerDocumentSymbolProvider(Ue,pt(ge),ye,He)},registerWorkspaceSymbolProvider(ge){return lt.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,ye){return lt.registerDocumentFormattingEditProvider(Ue,pt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return lt.registerDocumentRangeFormattingEditProvider(Ue,pt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,He,...ut){return lt.registerOnTypeFormattingEditProvider(Ue,pt(ge),ye,[He].concat(ut))},registerDocumentSemanticTokensProvider(ge,ye,He){return lt.registerDocumentSemanticTokensProvider(Ue,pt(ge),ye,He)},registerDocumentRangeSemanticTokensProvider(ge,ye,He){return lt.registerDocumentRangeSemanticTokensProvider(Ue,pt(ge),ye,He)},registerSignatureHelpProvider(ge,ye,He,...ut){return typeof He=="object"?lt.registerSignatureHelpProvider(Ue,pt(ge),ye,He):lt.registerSignatureHelpProvider(Ue,pt(ge),ye,typeof He>"u"?[]:[He,...ut])},registerCompletionItemProvider(ge,ye,...He){return lt.registerCompletionItemProvider(Ue,pt(ge),ye,He)},registerInlineCompletionItemProvider(ge,ye,He){return ye.handleDidShowCompletionItem&&(0,et.$hG)(Ue,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.$hG)(Ue,"inlineCompletionsAdditions"),He&&(0,et.$hG)(Ue,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ue,pt(ge),ye,He)},registerInlineEditProvider(ge,ye){return(0,et.$hG)(Ue,"inlineEdit"),lt.registerInlineEditProvider(Ue,pt(ge),ye)},registerDocumentLinkProvider(ge,ye){return lt.registerDocumentLinkProvider(Ue,pt(ge),ye)},registerColorProvider(ge,ye){return lt.registerColorProvider(Ue,pt(ge),ye)},registerFoldingRangeProvider(ge,ye){return lt.registerFoldingRangeProvider(Ue,pt(ge),ye)},registerSelectionRangeProvider(ge,ye){return lt.registerSelectionRangeProvider(Ue,ge,ye)},registerCallHierarchyProvider(ge,ye){return lt.registerCallHierarchyProvider(Ue,ge,ye)},registerTypeHierarchyProvider(ge,ye){return lt.registerTypeHierarchyProvider(Ue,ge,ye)},setLanguageConfiguration:(ge,ye)=>lt.setLanguageConfiguration(Ue,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,et.$hG)(Ue,"tokenInformation"),Lt.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return lt.registerInlayHintsProvider(Ue,ge,ye)},createLanguageStatusItem(ge,ye){return Lt.createLanguageStatusItem(Ue,ge,ye)},registerDocumentDropEditProvider(ge,ye,He){return lt.registerDocumentOnDropEditProvider(Ue,ge,ye,(0,et.$gG)(Ue,"dropMetadata")?He:void 0)}},pn={get activeTextEditor(){return ct.getActiveTextEditor()},get visibleTextEditors(){return ct.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(ge,ye,He){p.URI.isUri(ge)&&ge.scheme===M.Schemas.vscodeRemote&&!ge.authority&&Mt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await(p.URI.isUri(ge)?Promise.resolve(rn.openTextDocument(ge)):Promise.resolve(ge));return ct.showTextDocument(ut,ye,He)},createTextEditorDecorationType(ge){return ct.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,ye,He){return rt(ct.onDidChangeActiveTextEditor)(ge,ye,He)},onDidChangeVisibleTextEditors(ge,ye,He){return rt(ct.onDidChangeVisibleTextEditors)(ge,ye,He)},onDidChangeTextEditorSelection(ge,ye,He){return rt(ct.onDidChangeTextEditorSelection)(ge,ye,He)},onDidChangeTextEditorOptions(ge,ye,He){return rt(ct.onDidChangeTextEditorOptions)(ge,ye,He)},onDidChangeTextEditorVisibleRanges(ge,ye,He){return rt(ct.onDidChangeTextEditorVisibleRanges)(ge,ye,He)},onDidChangeTextEditorViewColumn(ge,ye,He){return rt(ct.onDidChangeTextEditorViewColumn)(ge,ye,He)},onDidCloseTerminal(ge,ye,He){return rt(Pt.onDidCloseTerminal)(ge,ye,He)},onDidOpenTerminal(ge,ye,He){return rt(Pt.onDidOpenTerminal)(ge,ye,He)},onDidChangeActiveTerminal(ge,ye,He){return rt(Pt.onDidChangeActiveTerminal)(ge,ye,He)},onDidChangeTerminalDimensions(ge,ye,He){return(0,et.$hG)(Ue,"terminalDimensions"),rt(Pt.onDidChangeTerminalDimensions)(ge,ye,He)},onDidChangeTerminalState(ge,ye,He){return rt(Pt.onDidChangeTerminalState)(ge,ye,He)},onDidWriteTerminalData(ge,ye,He){return(0,et.$hG)(Ue,"terminalDataWriteEvent"),rt(Pt.onDidWriteTerminalData)(ge,ye,He)},onDidExecuteTerminalCommand(ge,ye,He){return(0,et.$hG)(Ue,"terminalExecuteCommandEvent"),rt(Pt.onDidExecuteTerminalCommand)(ge,ye,He)},onDidChangeTerminalShellIntegration(ge,ye,He){return(0,et.$hG)(Ue,"terminalShellIntegration"),rt(li.onDidChangeTerminalShellIntegration)(ge,ye,He)},onDidStartTerminalShellExecution(ge,ye,He){return(0,et.$hG)(Ue,"terminalShellIntegration"),rt(li.onDidStartTerminalShellExecution)(ge,ye,He)},onDidEndTerminalShellExecution(ge,ye,He){return(0,et.$hG)(Ue,"terminalShellIntegration"),rt(li.onDidEndTerminalShellExecution)(ge,ye,He)},get state(){return Ft.getState(Ue)},onDidChangeWindowState(ge,ye,He){return rt(Ft.onDidChangeWindowState)(ge,ye,He)},showInformationMessage(ge,...ye){return vi.showMessage(Ue,b.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return vi.showMessage(Ue,b.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return vi.showMessage(Ue,b.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,He){return $i.showQuickPick(Ue,ge,ye,He)},showWorkspaceFolderPick(ge){return $i.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return $i.showInput(ge,ye)},showOpenDialog(ge){return Ni.showOpenDialog(Ue,ge)},showSaveDialog(ge){return Ni.showSaveDialog(ge)},createStatusBarItem(ge,ye,He){let ut,vt,Tt;return typeof ge=="string"?(ut=ge,vt=ye,Tt=He):(vt=ge,Tt=ye),Ci.createStatusBarEntry(Ue,ut,vt,Tt)},setStatusBarMessage(ge,ye){return Ci.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Mt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ri.withProgress(Ue,{location:Re.ProgressLocation.SourceControl},(ye,He)=>ge({report(ut){}}))},withProgress(ge,ye){return Ri.withProgress(Ue,ge,ye)},createOutputChannel(ge,ye){return bi.createOutputChannel(ge,ye,Ue)},createWebviewPanel(ge,ye,He,ut){return Si.createWebviewPanel(Ue,ge,ye,He,ut)},createWebviewTextEditorInset(ge,ye,He,ut){return(0,et.$hG)(Ue,"editorInsets"),Kt.createWebviewEditorInset(ge,ye,He,ut,Ue)},createTerminal(ge,ye,He){return typeof ge=="object"?"pty"in ge?Pt.createExtensionTerminal(ge):Pt.createTerminalFromOptions(ge):Pt.createTerminal(ge,ye,He)},registerTerminalLinkProvider(ge){return Pt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Pt.registerProfileProvider(Ue,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,et.$hG)(Ue,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(ge,Ue.identifier.value,ye)},registerTreeDataProvider(ge,ye){return yt.registerTreeDataProvider(ge,ye,Ue)},createTreeView(ge,ye){return yt.createTreeView(ge,ye,Ue)},registerWebviewPanelSerializer:(ge,ye)=>Si.registerWebviewPanelSerializer(Ue,ge,ye),registerCustomEditorProvider:(ge,ye,He={})=>Gi.registerCustomEditorProvider(Ue,ge,ye,He),registerFileDecorationProvider(ge){return xt.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return gi.registerUriHandler(Ue,ge)},createQuickPick(){return $i.createQuickPick(Ue)},createInputBox(){return $i.createInputBox(Ue)},get activeColorTheme(){return ki.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,He){return rt(ki.onDidChangeActiveColorTheme)(ge,ye,He)},registerWebviewViewProvider(ge,ye,He){return Ki.registerWebviewViewProvider(Ue,ge,ye,He?.webviewOptions)},get activeNotebookEditor(){return ve.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,He){return rt(ve.onDidChangeActiveNotebookEditor)(ge,ye,He)},get visibleNotebookEditors(){return ve.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return rt(ve.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,He){return rt(Ne.onDidChangeNotebookEditorSelection)(ge,ye,He)},onDidChangeNotebookEditorVisibleRanges(ge,ye,He){return rt(Ne.onDidChangeNotebookEditorVisibleRanges)(ge,ye,He)},showNotebookDocument(ge,ye){return ve.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,He){return(0,et.$hG)(Ue,"externalUriOpener"),dn.registerExternalUriOpener(Ue.identifier,ge,ye,He)},registerProfileContentHandler(ge,ye){return(0,et.$hG)(Ue,"profileContentHandlers"),fn.registerProfileContentHandler(Ue,ge,ye)},registerQuickDiffProvider(ge,ye,He,ut){return(0,et.$hG)(Ue,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt(ge),ye,He,ut)},get tabGroups(){return oi.tabGroups},registerShareProvider(ge,ye){return(0,et.$hG)(Ue,"shareProvider"),Vi.registerShareProvider(pt(ge),ye)}},rn={get rootPath(){return Mt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw new O.$9("rootPath")},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw new O.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(ge,ye,...He)=>mt.updateWorkspaceFolders(Ue,ge,ye||0,...He),onDidChangeWorkspaceFolders:function(ge,ye,He){return rt(mt.onDidChangeWorkspace)(ge,ye,He)},asRelativePath:(ge,ye)=>mt.getRelativePath(ge,ye),findFiles:(ge,ye,He,ut)=>mt.findFiles(ge,ye,He,Ue.identifier,ut),findFiles2:(ge,ye,He)=>((0,et.$hG)(Ue,"findFiles2"),mt.findFiles2(ge,ye,Ue.identifier,He)),findTextInFiles:(ge,ye,He,ut)=>{(0,et.$hG)(Ue,"findTextInFiles");let vt,Tt;return typeof ye=="object"?(vt=ye,Tt=He):(vt={},Tt=ye,ut=He),mt.findTextInFiles(ge,vt||{},Tt,Ue.identifier,ut)},save:ge=>mt.save(ge),saveAs:ge=>mt.saveAs(ge),saveAll:ge=>mt.saveAll(ge),applyEdit(ge,ye){return Yi.applyWorkspaceEdit(ge,Ue,ye)},createFileSystemWatcher:(ge,ye,He,ut)=>{let vt;return typeof ye=="boolean"?vt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!He,ignoreDeleteEvents:!!ut,correlate:!1}:ye&&((0,et.$hG)(Ue,"createFileSystemWatcher"),vt={...ye,correlate:!0}),di.createFileSystemWatcher(mt,Ue,ge,vt)},get textDocuments(){return Nt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new O.$9("textDocuments")},openTextDocument(ge){let ye;const He=ge;if(typeof ge=="string")ye=Promise.resolve(p.URI.file(ge));else if(p.URI.isUri(ge))ye=Promise.resolve(ge);else if(!He||typeof He=="object")ye=Nt.createDocumentData(He);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ut=>(ut.scheme===M.Schemas.vscodeRemote&&!ut.authority&&Mt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(ut).then(vt=>vt.document)))},onDidOpenTextDocument:(ge,ye,He)=>rt(Nt.onDidAddDocument)(ge,ye,He),onDidCloseTextDocument:(ge,ye,He)=>rt(Nt.onDidRemoveDocument)(ge,ye,He),onDidChangeTextDocument:(ge,ye,He)=>rt(Nt.onDidChangeDocument)(ge,ye,He),onDidSaveTextDocument:(ge,ye,He)=>rt(Nt.onDidSaveDocument)(ge,ye,He),onWillSaveTextDocument:(ge,ye,He)=>rt(ze.getOnWillSaveTextDocumentEvent(Ue))(ge,ye,He),get notebookDocuments(){return ve.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let He;if(p.URI.isUri(ge))He=ge,await ve.openNotebookDocument(ge);else if(typeof ge=="string")He=p.URI.revive(await ve.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return ve.getNotebookDocument(He).apiNotebook},onDidSaveNotebookDocument(ge,ye,He){return rt(_.onDidSaveNotebookDocument)(ge,ye,He)},onDidChangeNotebookDocument(ge,ye,He){return rt(_.onDidChangeNotebookDocument)(ge,ye,He)},onWillSaveNotebookDocument(ge,ye,He){return rt(Ye.getOnWillSaveNotebookDocumentEvent(Ue))(ge,ye,He)},get onDidOpenNotebookDocument(){return rt(ve.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return rt(ve.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,He,ut){return ve.registerNotebookSerializer(Ue,ge,ye,He,(0,et.$gG)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(ge,ye,He)=>rt(Zi.onDidChangeConfiguration)(ge,ye,He),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,Zi.getConfiguration(ge,ye,Ue)},registerTextDocumentContentProvider(ge,ye){return Oe.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Mt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),zt.registerTaskProvider(Ue,ge,ye)),registerFileSystemProvider(ge,ye,He){return(0,R.$Rc)(Wi.registerFileSystemProvider(Ue,ge,ye,He),ni.addFileSystemProvider(ge,ye,He))},get fs(){return ni.value},registerFileSearchProvider:(ge,ye)=>((0,et.$hG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,et.$hG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,et.$hG)(Ue,"aiTextSearchProvider"),(0,et.$hG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,et.$hG)(Ue,"resolvers"),Ot.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,et.$hG)(Ue,"resolvers"),Mi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,et.$hG)(Ue,"resolvers"),Ot.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,He)=>rt(di.onDidCreateFile)(ge,ye,He),onDidDeleteFiles:(ge,ye,He)=>rt(di.onDidDeleteFile)(ge,ye,He),onDidRenameFiles:(ge,ye,He)=>rt(di.onDidRenameFile)(ge,ye,He),onWillCreateFiles:(ge,ye,He)=>rt(di.getOnWillCreateFileEvent(Ue))(ge,ye,He),onWillDeleteFiles:(ge,ye,He)=>rt(di.getOnWillDeleteFileEvent(Ue))(ge,ye,He),onWillRenameFiles:(ge,ye,He)=>rt(di.getOnWillRenameFileEvent(Ue))(ge,ye,He),openTunnel:ge=>((0,et.$hG)(Ue,"tunnels"),jt.openTunnel(Ue,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.$hG)(Ue,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(ge,ye,He)=>((0,et.$hG)(Ue,"tunnels"),rt(jt.onDidChangeTunnels)(ge,ye,He)),registerPortAttributesProvider:(ge,ye)=>((0,et.$hG)(Ue,"portsAttributes"),jt.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,et.$hG)(Ue,"tunnelFactory"),jt.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,et.$hG)(Ue,"timeline"),qi.registerTimelineProvider(ge,ye,Ue.identifier,kt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,et.$hG)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,He)=>rt(mt.onDidGrantWorkspaceTrust)(ge,ye,He),registerEditSessionIdentityProvider:(ge,ye)=>((0,et.$hG)(Ue,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,He)=>((0,et.$hG)(Ue,"editSessionIdentityProvider"),rt(mt.getOnWillCreateEditSessionIdentityEvent(Ue))(ge,ye,He)),registerCanonicalUriProvider:(ge,ye)=>((0,et.$hG)(Ue,"canonicalUriProvider"),mt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,He)=>((0,et.$hG)(Ue,"canonicalUriProvider"),mt.provideCanonicalUri(ge,ye,He))},sn={get inputBox(){return Mt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Ue)},createSourceControl(ge,ye,He){return yi.createSourceControl(Ue,ge,ye,He)}},ji={createCommentController(ge,ye){return hn.createCommentController(Ue,ge,ye)}},on={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){if((0,et.$gG)(Ue,"debugFocus"))return St.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,et.$hG)(Ue,"debugVisualization"),St.registerDebugVisualizationProvider(Ue,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,et.$hG)(Ue,"debugVisualization"),St.registerDebugVisualizationTree(Ue,ge,ye)},onDidStartDebugSession(ge,ye,He){return rt(St.onDidStartDebugSession)(ge,ye,He)},onDidTerminateDebugSession(ge,ye,He){return rt(St.onDidTerminateDebugSession)(ge,ye,He)},onDidChangeActiveDebugSession(ge,ye,He){return rt(St.onDidChangeActiveDebugSession)(ge,ye,He)},onDidReceiveDebugSessionCustomEvent(ge,ye,He){return rt(St.onDidReceiveDebugSessionCustomEvent)(ge,ye,He)},onDidChangeBreakpoints(ge,ye,He){return rt(St.onDidChangeBreakpoints)(ge,ye,He)},onDidChangeActiveStackItem(ge,ye,He){return(0,et.$hG)(Ue,"debugFocus"),rt(St.onDidChangeActiveStackItem)(ge,ye,He)},registerDebugConfigurationProvider(ge,ye,He){return St.registerDebugConfigurationProvider(ge,ye,He||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return St.registerDebugAdapterDescriptorFactory(Ue,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return St.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,He){return!He||typeof He=="object"&&"configuration"in He?St.startDebugging(ge,ye,{parentSession:He}):St.startDebugging(ge,ye,He||{})},stopDebugging(ge){return St.stopDebugging(ge)},addBreakpoints(ge){return St.addBreakpoints(ge)},removeBreakpoints(ge){return St.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return St.asDebugSourceUri(ge,ye)}},an={registerTaskProvider:(ge,ye)=>zt.registerTaskProvider(Ue,ge,ye),fetchTasks:ge=>zt.fetchTasks(ge),executeTask:ge=>zt.executeTask(Ue,ge),get taskExecutions(){return zt.taskExecutions},onDidStartTask:(ge,ye,He)=>rt(zt.onDidStartTask)(ge,ye,He),onDidEndTask:(ge,ye,He)=>rt(zt.onDidEndTask)(ge,ye,He),onDidStartTaskProcess:(ge,ye,He)=>rt(zt.onDidStartTaskProcess)(ge,ye,He),onDidEndTaskProcess:(ge,ye,He)=>rt(zt.onDidEndTaskProcess)(ge,ye,He)},cn={createNotebookController(ge,ye,He,ut,vt){return qe.createNotebookController(Ue,ge,ye,He,ut,(0,et.$gG)(Ue,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>ve.registerNotebookCellStatusBarItemProvider(Ue,ge,ye),createRendererMessaging(ge){return _e.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,et.$hG)(Ue,"notebookKernelSource"),qe.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,ye){return(0,et.$hG)(Ue,"notebookKernelSource"),qe.registerKernelSourceActionProvider(Ue,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,He){return(0,et.$hG)(Ue,"notebookCellExecutionState"),rt(qe.onDidChangeNotebookCellExecutionState)(ge,ye,He)}},bn={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),He=!ge||typeof ge[0]!="object"?ge:ge[0];return Gt.getMessage(Ue.identifier.value,{message:ye,args:He})}return Gt.getMessage(Ue.identifier.value,ge[0])},get bundle(){return Gt.getBundle(Ue.identifier.value)},get uri(){return Gt.getBundleUri(Ue.identifier.value)}},wn={_version:1,registerInteractiveEditorSessionProvider(ge,ye){return(0,et.$hG)(Ue,"interactive"),Li.registerProvider(Ue,ge,ye)},registerInteractiveSessionProvider(ge,ye){return(0,et.$hG)(Ue,"interactive"),Ji.registerChatProvider(Ue,ge,ye)},transferActiveChat(ge){return(0,et.$hG)(Ue,"interactive"),Ji.transferActiveChat(ge)}},un={getRelatedInformation(ge,ye){return(0,et.$hG)(Ue,"aiRelatedInformation"),Oi.getRelatedInformation(Ue,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,et.$hG)(Ue,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(Ue,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,et.$hG)(Ue,"aiRelatedInformation"),mn.registerEmbeddingVectorProvider(Ue,ge,ye)}},ln={registerChatResponseProvider(ge,ye,He){return(0,et.$hG)(Ue,"chatProvider"),Et.registerLanguageModel(Ue,ge,ye,He)},registerChatVariableResolver(ge,ye,He){return(0,et.$hG)(Ue,"chatVariableResolver"),gn.registerVariableResolver(Ue,ge,ye,He)},registerMappedEditsProvider(ge,ye){return(0,et.$hG)(Ue,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ue,ge,ye)},createChatParticipant(ge,ye){return(0,et.$hG)(Ue,"chatParticipant"),Di.createChatAgent(Ue,ge,ye)},createDynamicChatParticipant(ge,ye,He,ut){return(0,et.$hG)(Ue,"chatParticipantAdditions"),Di.createDynamicChatAgent(Ue,ge,ye,He,ut)}},Fi={get languageModels(){return(0,et.$hG)(Ue,"languageModels"),Et.getLanguageModelIds()},onDidChangeLanguageModels:(ge,ye,He)=>((0,et.$hG)(Ue,"languageModels"),Et.onDidChangeProviders(ge,ye,He)),sendChatRequest(ge,ye,He,ut){return(0,et.$hG)(Ue,"languageModels"),Et.sendChatRequest(Ue,ge,ye,He,ut)}},zi={registerSpeechProvider(ge,ye){return(0,et.$hG)(Ue,"speech"),Qi.registerProvider(Ue.identifier,ge,ye)}};return{version:bt.version,ai:un,authentication:xi,commands:_i,comments:ji,chat:ln,debug:on,env:Ti,extensions:tn,interactive:wn,l10n:bn,languages:nn,lm:Fi,notebooks:cn,scm:sn,speech:zi,tasks:an,tests:en,window:pn,workspace:rn,Breakpoint:Re.$zN,TerminalOutputAnchor:Re.TerminalOutputAnchor,ChatResultFeedbackKind:Re.ChatResultFeedbackKind,ChatVariableLevel:Re.ChatVariableLevel,ChatCompletionItem:Re.$uO,CallHierarchyIncomingCall:Re.$XM,CallHierarchyItem:Re.$WM,CallHierarchyOutgoingCall:Re.$YM,CancellationError:O.$5,CancellationTokenSource:u.$je,CandidatePortSource:i.CandidatePortSource,CodeAction:Re.$TM,CodeActionKind:Re.$UM,CodeActionTriggerKind:Re.CodeActionTriggerKind,CodeLens:Re.$ZM,Color:Re.$aN,ColorInformation:Re.$bN,ColorPresentation:Re.$cN,ColorThemeKind:Re.ColorThemeKind,CommentMode:Re.CommentMode,CommentState:Re.CommentState,CommentThreadCollapsibleState:Re.CommentThreadCollapsibleState,CommentThreadState:Re.CommentThreadState,CommentThreadApplicability:Re.CommentThreadApplicability,CompletionItem:Re.$7M,CompletionItemKind:Re.CompletionItemKind,CompletionItemTag:Re.CompletionItemTag,CompletionList:Re.$8M,CompletionTriggerKind:Re.CompletionTriggerKind,ConfigurationTarget:Re.ConfigurationTarget,CustomExecution:Re.$kN,DebugAdapterExecutable:Re.$DN,DebugAdapterInlineImplementation:Re.$GN,DebugAdapterNamedPipeServer:Re.$FN,DebugAdapterServer:Re.$EN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Re.DebugConsoleMode,DebugVisualization:Re.$WN,DecorationRangeBehavior:Re.DecorationRangeBehavior,Diagnostic:Re.$NM,DiagnosticRelatedInformation:Re.$MM,DiagnosticSeverity:Re.DiagnosticSeverity,DiagnosticTag:Re.DiagnosticTag,Disposable:Re.$zM,DocumentHighlight:Re.$PM,DocumentHighlightKind:Re.DocumentHighlightKind,MultiDocumentHighlight:Re.$QM,DocumentLink:Re.$_M,DocumentSymbol:Re.$SM,EndOfLine:Re.EndOfLine,EnvironmentVariableMutatorType:Re.EnvironmentVariableMutatorType,EvaluatableExpression:Re.$JN,InlineValueText:Re.$KN,InlineValueVariableLookup:Re.$LN,InlineValueEvaluatableExpression:Re.$MN,InlineCompletionTriggerKind:Re.InlineCompletionTriggerKind,EventEmitter:L.$_d,ExtensionKind:Re.ExtensionKind,ExtensionMode:Re.ExtensionMode,ExternalUriOpenerPriority:Re.ExternalUriOpenerPriority,FileChangeType:Re.FileChangeType,FileDecoration:Re.$YN,FileDecoration2:Re.$YN,FileSystemError:Re.$PN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Re.$QN,FoldingRangeKind:Re.FoldingRangeKind,FunctionBreakpoint:Re.$BN,InlineCompletionItem:Re.$9M,InlineCompletionList:Re.$0M,Hover:Re.$OM,IndentAction:P.IndentAction,Location:Re.$LM,MarkdownString:Re.$1M,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Re.$2M,PortAutoForwardAction:Re.PortAutoForwardAction,Position:Re.$AM,ProcessExecution:Re.$iN,ProgressLocation:Re.ProgressLocation,QuickInputButtons:Re.$XN,Range:Re.$BM,RelativePattern:Re.$xN,Selection:Re.$CM,SelectionRange:Re.$VM,SemanticTokens:Re.$TN,SemanticTokensBuilder:Re.$SN,SemanticTokensEdit:Re.$UN,SemanticTokensEdits:Re.$VN,SemanticTokensLegend:Re.$RN,ShellExecution:Re.$jN,ShellQuoting:Re.ShellQuoting,SignatureHelp:Re.$4M,SignatureHelpTriggerKind:Re.SignatureHelpTriggerKind,SignatureInformation:Re.$3M,SnippetString:Re.$KM,SourceBreakpoint:Re.$AN,StandardTokenType:Re.StandardTokenType,StatusBarAlignment:Re.StatusBarAlignment,SymbolInformation:Re.$RM,SymbolKind:Re.SymbolKind,SymbolTag:Re.SymbolTag,Task:Re.$lN,TaskGroup:Re.$hN,TaskPanelKind:Re.TaskPanelKind,TaskRevealKind:Re.TaskRevealKind,TaskScope:Re.TaskScope,TerminalLink:Re.$dN,TerminalQuickFixTerminalCommand:Re.$fN,TerminalQuickFixOpener:Re.$eN,TerminalLocation:Re.TerminalLocation,TerminalProfile:Re.$gN,TerminalExitReason:Re.TerminalExitReason,TextDocumentSaveReason:Re.TextDocumentSaveReason,TextEdit:Re.$GM,SnippetTextEdit:Re.$IM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Re.TextEditorLineNumbersStyle,TextEditorRevealType:Re.TextEditorRevealType,TextEditorSelectionChangeKind:Re.TextEditorSelectionChangeKind,SyntaxTokenType:Re.SyntaxTokenType,TextDocumentChangeReason:Re.TextDocumentChangeReason,ThemeColor:Re.$wN,ThemeIcon:Re.$vN,TreeItem:Re.$mN,TreeItemCheckboxState:Re.TreeItemCheckboxState,TreeItemCollapsibleState:Re.TreeItemCollapsibleState,TypeHierarchyItem:Re.$iO,UIKind:Xt.UIKind,Uri:p.URI,ViewColumn:Re.ViewColumn,WorkspaceEdit:Re.$JM,DocumentPasteTriggerKind:Re.DocumentPasteTriggerKind,DocumentDropEdit:Re.$sN,DocumentPasteEditKind:Re.$tN,DocumentPasteEdit:Re.$uN,InlayHint:Re.$6M,InlayHintLabelPart:Re.$5M,InlayHintKind:Re.InlayHintKind,RemoteAuthorityResolverError:Re.$FM,ResolvedAuthority:Re.$DM,ManagedResolvedAuthority:Re.$EM,SourceControlInputBoxValidationType:Re.SourceControlInputBoxValidationType,ExtensionRuntime:Re.ExtensionRuntime,TimelineItem:Re.$9N,NotebookRange:Re.$1N,NotebookCellKind:Re.NotebookCellKind,NotebookCellExecutionState:Re.NotebookCellExecutionState,NotebookCellData:Re.$2N,NotebookData:Re.$3N,NotebookRendererScript:Re.$7N,NotebookCellStatusBarAlignment:Re.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Re.NotebookEditorRevealType,NotebookCellOutput:Re.$5N,NotebookCellOutputItem:Re.$4N,NotebookCellStatusBarItem:Re.$6N,NotebookControllerAffinity:Re.NotebookControllerAffinity,NotebookControllerAffinity2:Re.NotebookControllerAffinity2,NotebookEdit:Re.$HM,NotebookKernelSourceAction:Re.$8N,NotebookVariablesRequestKind:Re.NotebookVariablesRequestKind,PortAttributes:Re.$$N,LinkedEditingRanges:Re.$0N,TestResultState:Re.TestResultState,TestRunRequest:Re.$_N,TestMessage:Re.$aO,TestTag:Re.$bO,TestRunProfileKind:Re.TestRunProfileKind,TextSearchCompleteMessageType:ai.TextSearchCompleteMessageType,DataTransfer:Re.$rN,DataTransferItem:Re.$nN,TestCoverageCount:Re.$cO,FileCoverage:Re.$eO,StatementCoverage:Re.$fO,BranchCoverage:Re.$gO,DeclarationCoverage:Re.$hO,FunctionCoverage:Re.$hO,WorkspaceTrustState:Re.WorkspaceTrustState,LanguageStatusSeverity:Re.LanguageStatusSeverity,QuickPickItemKind:Re.QuickPickItemKind,InputBoxValidationSeverity:Re.InputBoxValidationSeverity,TabInputText:Re.$jO,TabInputTextDiff:Re.$kO,TabInputTextMerge:Re.$lO,TabInputCustom:Re.$mO,TabInputNotebook:Re.$oO,TabInputNotebookDiff:Re.$pO,TabInputWebview:Re.$nO,TabInputTerminal:Re.$qO,TabInputInteractiveWindow:Re.$rO,TabInputChat:Re.$sO,TabInputTextMultiDiff:Re.$tO,TelemetryTrustedValue:o.$9o,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Re.InteractiveSessionVoteDirection,ChatCopyKind:Re.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Re.InteractiveEditorResponseFeedbackKind,StackFrame:Re.$HN,Thread:Re.$IN,RelatedInformationType:Re.RelatedInformationType,SpeechToTextStatus:Re.SpeechToTextStatus,PartialAcceptTriggerKind:Re.PartialAcceptTriggerKind,KeywordRecognitionStatus:Re.KeywordRecognitionStatus,ChatResponseMarkdownPart:Re.$vO,ChatResponseFileTreePart:Re.$wO,ChatResponseAnchorPart:Re.$xO,ChatResponseProgressPart:Re.$yO,ChatResponseReferencePart:Re.$AO,ChatResponseTextEditPart:Re.$BO,ChatResponseCommandButtonPart:Re.$zO,ChatRequestTurn:Re.$CO,ChatResponseTurn:Re.$DO,ChatLocation:Re.ChatLocation,LanguageModelChatSystemMessage:Re.$EO,LanguageModelChatUserMessage:Re.$FO,LanguageModelChatAssistantMessage:Re.$GO,LanguageModelSystemMessage:Re.$EO,LanguageModelUserMessage:Re.$FO,LanguageModelAssistantMessage:Re.$GO,LanguageModelError:Re.$HO,NewSymbolName:Re.$ON,NewSymbolNameTag:Re.NewSymbolNameTag,InlineEdit:Re.$IO,InlineEditTriggerKind:Re.InlineEditTriggerKind}}}}),define(ke[380],Ee([1,0,84,157,43,151,44,33,72,42,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$ls)(l.$Ukc,l.$Tkc,1),(0,u.$ls)(f.$Uj,t.$8lc,1),(0,u.$ls)(a.$Yjc,a.$Zjc,1),(0,u.$ls)(b.$eP,b.$dP,0),(0,u.$ls)(h.$9jc,h.$0jc,0),(0,u.$ls)(g.$bkc,g.$ckc,0),(0,u.$ls)(M.$okc,M.$mkc,0),(0,u.$ls)(o.$qkc,o.$pkc,0),(0,u.$ls)(P.$5kc,P.$9kc,0),(0,u.$ls)(R.$$kc,R.$0kc,0),(0,u.$ls)(p.$6O,p.$5O,0),(0,u.$ls)(c.$Vkc,c.$Wkc,0),(0,u.$ls)(n.$3jc,n.$2jc,0),(0,u.$ls)(O.$Dlc,O.$Clc,1),(0,u.$ls)($.$olc,$.$plc,0),(0,u.$ls)(S.$Jkc,S.$Ikc,0),(0,u.$ls)(A.$Qlc,A.$Plc,0),(0,u.$ls)(E.$Mkc,E.$Pkc,0),(0,u.$ls)(D.$5lc,D.$6lc,0),(0,u.$ls)(v.$eCb,v.$fCb,0),(0,u.$ls)(m.$4lc,m.$3lc,0),(0,u.$ls)(L.$lkc,L.$kkc,0),(0,u.$ls)(i.$Rkc,i.$Qkc,0),(0,u.$ls)(r.$cP,r.$_O,0),(0,u.$ls)(s.$Akc,s.$Bkc,0),(0,u.$ls)(d.$3kc,d.$4kc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0,e.$lmc=M,e.$mmc=b;function M(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function b(P,$,S,v){const a=(0,u.$2b)(S,p),m=new L.$QK($,a,v),o=m.preview.matches;return{ranges:(0,u.$2b)(a,E),uri:P,preview:{text:m.preview.text,matches:(0,u.$2b)(o,E)}}}function p(P){return new L.$RK(P.start.line,P.start.character,P.end.line,P.end.character)}function E(P){return new R.$FK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor($,S){this.a=$,this.b=S}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$nmc=A,e.$nmc=A=Je([We(1,O.$Tj)],A)}),define(ke[381],Ee([1,0,53,17,76,34,11,14,122,382]),function(he,e,u,O,L,R,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=P,e.$pmc=m,e.$qmc=n;const A=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(i,r,s,t){const f=$(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(A,f.args,{cwd:d}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function $(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],s,!1).forEach(l=>{const c=(0,p.$lmc)(l);if(f.push("-g",c),M.$j){const h=(0,L.$6l)(c);h!==c&&f.push("-g",h)}});const d=S([r],t,void 0,!1);return d.globArgs.forEach(l=>{const c=`!${(0,p.$lmc)(l)}`;if(f.push("-g",c),M.$j){const h=(0,L.$6l)(c);h!==c&&f.push("-g",h)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function S(i,r,s,t=!0){const f=[];let d={};return i.forEach(l=>{const c=Object.assign({},l.excludePattern||{},r||{}),h=a(c,t?l.folder.fsPath:void 0,s);f.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:f,siblingClauses:d}}function v(i,r,s=!0){const t=[];return i.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),l=a(d,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function a(i,r,s){const t=[],f={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=o(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(f[d]=l)}),{globArgs:t,siblingClauses:f}}function m(i,r){return O.$jc(r)?r:O.$kc(i,r)}function o(i){return i=b.$$e(i,"\\"),b.$$e(i,"/")}function n(i){return R.$jg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[383],Ee([1,0,53,52,17,384,19,47,35,76,34,11,38,14,18,31,36,381,132]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&p.$hk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$mr)(this.b).normalizedLowercase),this.u=l.excludePattern&&p.$hk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),g=c.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==g).forEach(D=>{(0,A.$ng)(D,g)&&(h[L.$mc(g,D)]=!0)}),this.t.set(g,new t(h,g))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,c,h,g,D){if(this.m=$.$8d.create(!1),this.l)return D(null,this.j);c.forEach(w=>{const k=L.$oc(w.fsPath);this.u&&this.u(w.fsPath,k)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=$.$8d.create(!1),this.w(l,(w,k)=>{this.x(this.y,this,w,h,g,y=>{if(y){const C=(0,b.$$i)(y);console.error(C),this.q.push(C),k(y,void 0)}else k(null,void 0)})},(w,k)=>{this.m.stop();const y=w?M.$Hb(w)[0]:null;D(y,this.j)})}w(l,c,h){const g=new Array(l.length),D=new Array(l.length);let w=!1,k=0;if(l.length===0)return h(null,[]);l.forEach((y,C)=>{c(y,(I,z)=>{if(I?(w=!0,g[C]=null,D[C]=I):(g[C]=z,D[C]=null),++k===l.length)return h(w?D:null,g)})})}x(l,c,...h){try{l.apply(c,h)}catch(g){h[h.length-1](g)}}y(l,c,h,g){const D=l.folder.fsPath,w=P.$j,k=()=>j&&j.kill();i.add(k);let y=B=>{i.delete(k),y=()=>{},g(B)},C="";const I=this.D(),z=(0,o.$omc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),j=z.cmd,F=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(j,"utf8",h,(B,H,Z)=>{if(B){y(B);return}if(this.j){y();return}const J=(C+(w?E.$5l(H||""):H)).split(`
`);if(Z){const Y=J.length;J[Y-1]=J[Y-1].trim(),J[Y-1]||J.pop()}else C=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=J.length,F){for(const Y of J)if(this.J(c,{base:D,relativePath:Y,searchPath:this.N(l,Y)}),this.j){k();break}(Z||this.j)&&y();return}this.G(l,I,D,J,c),Z&&(this.H(I,D,c),y())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),h=c.getBasenameTerms(),g=c.getPathTerms(),D=["-L","."];if(h.length||g.length){D.push("-not","(","(");for(const w of h)D.push("-name",w),D.push("-o");for(const w of g)D.push("-path",w),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,c,h){let g="";this.z(l,c,()=>{},(D,w,k)=>{if(D){h(D);return}g+=w,k&&h(null,g)})}z(l,c,h,g){let D=(y,C,I)=>{(y||I)&&(D=()=>{},this.r?.stop()),g(y,C,I)},w=!1;l.stdout?(this.A(l.stdout,c,D),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let k;l.stderr?k=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let C;!w&&(C=this.C(k,c))&&f(C)?D(new Error(`command failed with error code ${y}: ${this.C(k,c)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(l,c,h){const g=new R.StringDecoder(c);return l.on("data",D=>{h(null,g.write(D))}),g}B(l){const c=[];return l.on("data",h=>{c.push(h)}),c}C(l,c){const h=new R.StringDecoder(c);return l.map(g=>h.write(g)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},h,g,D){g.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=k=>{const y=L.$oc(k),C=L.$nc(k);let I=c[C];I||(I=c[C]=[],w(C)),I.push({base:h,relativePath:k,basename:y,searchPath:this.N(l,k)})};g.forEach(w)}H({rootEntries:l,pathToEntries:c},h,g){const D=this,w=this.t.get(h),k=this.b;function y(C){D.o++;const I=(0,m.$7K)(()=>C.map(z=>z.basename));for(let z=0,j=C.length;z<j;z++){const F=C[z],{relativePath:N,basename:T}=F;if(w.test(N,T,k!==T?I:void 0))continue;const B=c[N];if(B)y(B);else{if(D.p++,N===k)continue;D.J(g,F)}if(D.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,h,g,D){const w=l.folder,k=(0,m.$7K)(()=>h);this.w(h,(y,C)=>{if(this.l||this.j)return C(null);const I=c?[c,y].join(L.sep):y;if(this.t.get(l.folder.fsPath).test(I,y,this.a.filePattern!==y?k:void 0))return C(null);const z=[w.fsPath,I].join(L.sep);O.lstat(z,(j,F)=>{if(j||this.l||this.j)return C(null);this.L(z,F,(N,T)=>N||this.l||this.j?C(null):T.isDirectory()?(this.o++,this.M(z,F,(B,H)=>B||this.l||this.j||(H=H||"",this.v[H])?C(null):(this.v[H]=!0,a.Promises.readdir(z).then(Z=>{if(this.l||this.j)return C(null);this.I(l,I,Z,g,ee=>C(ee||null))},Z=>{C(null)})))):(this.p++,I===this.b||this.h&&v.$5f(T.size)&&T.size>this.h||this.J(g,{base:w.fsPath,relativePath:I,searchPath:this.N(l,I)}),C(null,void 0)))})},y=>{const C=y&&M.$Hb(y);return D(C&&C.length>0?C[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,L.$oc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$2K)(l,this.c);if(this.b)return(0,m.$2K)(l,this.b,!1)}return!0}L(l,c,h){return c.isSymbolicLink()?O.stat(l,h):h(null,c)}M(l,c,h){return c.isSymbolicLink()?O.realpath(l,(g,D)=>g?h(g):h(null,D)):h(null,l)}N(l,c){return l.folderName?L.$kc(l.folderName,c):c}}e.$rmc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,c,h){this.c.walk(this.a,this.b,l,c,(g,D)=>{h(g,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$smc=s;class t{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,h;Object.keys(l).filter(g=>l[g]).forEach(g=>{L.$jc(g)?(c=c||p.$ck(),c[g]=l[g]):(h=h||p.$ck(),h[g]=l[g])}),this.a=c&&p.$hk(c,{trimForExclusions:!0}),this.b=h&&p.$hk(h,{trimForExclusions:!0})}test(l,c,h){return this.b&&this.b(l,c,h)||this.a&&this.a(L.$kc(this.c,l),c,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...p.$jk(this.a)),this.b&&l.push(...p.$jk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...p.$kk(this.a)),this.b&&l.push(...p.$kk(this.b)),l}}function f(d){const l=d.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return S.$Sf(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[385],Ee([1,0,98,21,193,22]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$XD=e.DecodeStreamErrorKind=e.$WD=e.$VD=e.$UD=e.$SD=e.$RD=e.$QD=e.$PD=void 0,e.$TD=M,e.$YD=v,e.$ZD=a,e.$1D=m,e.$2D=o,e.$3D=n,e.$4D=d,e.$5D=l,e.$PD="utf8",e.$QD="utf8bom",e.$RD="utf16be",e.$SD="utf16le";function M(c){return[e.$PD,e.$QD,e.$RD,e.$SD].some(h=>h===c)}e.$UD=[254,255],e.$VD=[255,254],e.$WD=[239,187,191];const b=512,p=512,E=512*8,A=512*128;var P;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class $ extends Error{constructor(h,g){super(h),this.decodeStreamErrorKind=g}}e.$XD=$;class S{static async create(h){let g;if(h!==e.$PD)g=(await(0,L.$OD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;g={write(w){return D.decode(w,{stream:!0})},end(){return D.decode()}}}return new S(g)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function v(c,h){const g=h.minBytesRequiredForDetection??h.guessEncoding?E:p;return new Promise((D,w)=>{const k=(0,u.$ne)(F=>F.join("")),y=[];let C=0,I;const z=new R.$je,j=async()=>{try{const F=await l({buffer:O.$ze.concat(y),bytesRead:C},h.guessEncoding);if(F.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);F.encoding=await h.overwriteEncoding(F.encoding),I=await S.create(F.encoding);const N=I.write(O.$ze.concat(y).buffer);k.write(N),y.length=0,C=0,D({stream:k,detected:F})}catch(F){z.cancel(),k.destroy(),w(F)}};(0,u.$re)(c,{onData:async F=>{I?k.write(I.write(F.buffer)):(y.push(F),C+=F.byteLength,C>=g&&(c.pause(),await j(),setTimeout(()=>c.resume())))},onError:F=>k.error(F),onEnd:async()=>{I||await j(),k.end(I?.end())}},z.token)})}async function a(c,h,g){const w=(await(0,L.$OD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),g);let k=!1,y=!1;return{read(){if(y)return null;const C=c.read();if(typeof C!="string"){if(y=!0,!k&&g?.addBOM)switch(h){case e.$PD:case e.$QD:return O.$ze.wrap(Uint8Array.from(e.$WD));case e.$RD:return O.$ze.wrap(Uint8Array.from(e.$UD));case e.$SD:return O.$ze.wrap(Uint8Array.from(e.$VD))}const I=w.end();return I&&I.length>0?(k=!0,O.$ze.wrap(I)):null}return k=!0,O.$ze.wrap(w.write(C))}}}async function m(c){return(await(0,L.$OD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}function o(c){return c===e.$QD||c===null?e.$PD:c}function n(c,h){if(!c||h<e.$UD.length)return null;const g=c.readUInt8(0),D=c.readUInt8(1);if(g===e.$UD[0]&&D===e.$UD[1])return e.$RD;if(g===e.$VD[0]&&D===e.$VD[1])return e.$SD;if(h<e.$WD.length)return null;const w=c.readUInt8(2);return g===e.$WD[0]&&D===e.$WD[1]&&w===e.$WD[2]?e.$QD:null}const i=["ascii","utf-16","utf-32"];async function r(c){const h=await(0,L.$OD)("jschardet","dist/jschardet.min.js"),g=c.slice(0,A),D=f(g.buffer),w=h.detect(D);if(!w||!w.encoding)return null;const k=w.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t(w.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function f(c){let h="";for(let g=0;g<c.length;g++)h+=String.fromCharCode(c[g]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}function l({buffer:c,bytesRead:h},g){let D=n(c,h),w=!1;if(D!==e.$RD&&D!==e.$SD&&c){let k=!0,y=!0,C=!1;for(let I=0;I<h&&I<b;I++){const z=I%2===1,j=c.readUInt8(I)===0;if(j&&(C=!0),k&&(z&&!j||!z&&j)&&(k=!1),y&&(z&&j||!z&&!j)&&(y=!1),j&&!k&&!y)break}C&&(k?D=e.$SD:y?D=e.$RD:w=!0)}return g&&!w&&!D&&c?r(c.slice(0,h)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:w,encoding:D}}e.$6D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Ee([1,0,385,31,159]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class R extends L.$klc{constructor(b,p,E=O,A="searchProcess"){super({query:b,provider:p},{readdir:P=>E.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,u.$4D)(P)},A)}}e.$Amc=R}),define(ke[161],Ee([1,0,53,401,384,19,73,35,14,2,36,94,402,382,122]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0,e.$vmc=t,e.$wmc=d,e.$xmc=c,e.$ymc=h,e.$zmc=D;const a=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(k){this.a=k}provideTextSearchResults(k,y,C,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,j)=>{I.onCancellationRequested(()=>J());const F=t(k,y),N=y.folder.fsPath,T=F.map(Ce=>Ce.match(/^-/)?Ce:`'${Ce}'`).join(" ");this.a.appendLine(`${a} ${T}
 - cwd: ${N}`);let B=u.spawn(a,F,{cwd:N});B.on("error",Ce=>{console.error(Ce),this.a.appendLine("Error: "+(Ce&&Ce.message)),j((0,A.$XK)(new A.$VK(Ce&&Ce.message,A.SearchErrorCode.rgProcessError)))});let H=!1;const Z=new i(y.maxResults,y.folder,y.previewOptions);Z.on("result",Ce=>{H=!0,re="",C.report(Ce)});let ee=!1;const J=()=>{ee=!0,B?.kill(),Z?.cancel()};let Y=!1;Z.on("hitLimit",()=>{Y=!0,J()});let re="";B.stdout.on("data",Ce=>{Z.handleData(Ce),H||(re+=Ce)});let te=!1;B.stdout.once("data",()=>te=!0);let pe="";B.stderr.on("data",Ce=>{const x=Ce.toString();this.a.appendLine(x),pe.length+x.length<1e6&&(pe+=x)}),B.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(H?"Got result from parser":"No result from parser"),re&&this.a.appendLine(`Got data without result: ${re}`),this.a.appendLine(""),ee)z({limitHit:Y});else{Z.flush(),B=null;let Ce;pe&&!te&&(Ce=o(pe))?j((0,A.$XK)(new A.$VK(Ce.message,Ce.code))):z({limitHit:Y})}})})}}e.$tmc=m;function o(w){const k=w.split(`
`),y=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new A.$VK(n(k),A.SearchErrorCode.regexParseError);const C=y.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$VK(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.$VK(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.$VK(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.$VK(y,A.SearchErrorCode.regexParseError)}function n(w){const k=["Regex parse error"],y=w.filter(C=>C.startsWith("PCRE2:"));if(y.length>=1){const C=y[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const I=C.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends O.EventEmitter{constructor(k,y,C){super(),this.g=k,this.h=y,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,y){return super.on(k,y),this}handleData(k){if(this.b)return;const y=typeof k=="string"?k:this.d.write(k);this.k(y)}k(k){let y=k.indexOf(`
`);const C=this.a+k;if(y>=0)y+=this.a.length;else{this.a=C;return}let I=0;for(;y>=0;)this.m(C.substring(I,y).trim()),I=y+1,y=C.indexOf(`
`,I);this.a=C.substring(I)}m(k){if(this.b||!k)return;let y;try{y=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(y.type==="match"){const C=r(y.data.path),I=E.URI.joinPath(this.h,C),z=this.n(y.data,I);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const C=r(y.data.path),I=E.URI.joinPath(this.h,C);this.o(y.data,I).forEach(j=>this.p(j))}}n(k,y){const C=k.line_number-1,I=r(k.lines),z=Buffer.from(I);let j=0,F=0,N=C;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(k.submatches.map((B,H)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=r(B.match),ee=z.slice(j,B.start).toString(),J=s(ee),Y=J.numLines>0?J.lastLineLength:J.lastLineLength+F,re=s(Z),te=J.numLines+N,pe=re.numLines+te,Ce=re.numLines>0?re.lastLineLength:re.lastLineLength+Y;return j=B.end,F=Ce,N=pe,new P.$FK(te,Y,pe,Ce)}));return(0,v.$mmc)(y,I,T,this.j)}o(k,y){const C=r(k.lines),I=k.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((z,j)=>({text:z,uri:y,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$umc=i;function r(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function s(w){const k=/\n/g;let y=0,C=-1,I;for(;I=k.exec(w);)y++,C=I.index;const z=C>=0?w.length-C-1:w.length;return{numLines:y,lastLineLength:z}}function t(w,k){const y=["--hidden","--no-require-git"];y.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:I}=(0,M.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(F=>{j.add(F)}),y.push("-g","!*"),j.forEach(F=>{f(F).map(v.$lmc).forEach(N=>{y.push("-g",N)})})}C&&C.length&&C.forEach(j=>{y.push("-g",j)}),k.excludes.map(v.$lmc).forEach(j=>y.push("-g",`!${j}`)),k.maxFileSize&&y.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),k.followSymlinks&&y.push("--follow"),k.encoding&&k.encoding!=="utf8"&&y.push("--encoding",k.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,p.$5e)(w.pattern),w.isRegExp=!0),k.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),y.push("--engine","auto"));let z;if(w.isWordMatch){const F=(0,p.$bf)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(w.isRegExp){let j=c(w.pattern);j=h(j),y.push("--regexp",j)}else z=w.pattern,y.push("--fixed-strings");return y.push("--no-config"),k.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),w.isMultiline&&y.push("--multiline"),k.beforeContext&&y.push("--before-context",k.beforeContext+""),k.afterContext&&y.push("--after-context",k.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}function f(w){return D(w).flatMap(y=>{const C=(0,b.$fk)(y,"/");return C.map((I,z)=>C.slice(0,z+1).join("/"))})}function d(w){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(k);)w=w.replace(k,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");return w}const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function c(w){let k;try{k=new $.RegExpParser().parsePattern(w)}catch{return w}let y="",C=0;const I=(F,N,T)=>{y+=w.slice(C,F)+T,C=N},z=[];return new $.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const N=z[0];if(!N)I(F.start,F.end,"\\r?\\n");else if(!z.some(l))if(N.type==="CharacterClass")if(N.negate){const T=w.slice(N.start+2,F.start)+w.slice(F.end,N.end-1);N.parent?.type==="Quantifier"?I(N.start,N.end,T?`[^${T}]`:"."):I(N.start,N.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=w.slice(N.start+1,F.start)+w.slice(F.end,N.end-1);I(N.start,N.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else N.type==="Quantifier"&&I(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){z.unshift(F)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(F){z.unshift(F)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(F){z.unshift(F)},onCharacterClassLeave(){z.shift()},onAssertionEnter(F){l(F)&&z.push(F)},onAssertionLeave(F){z[0]===F&&z.shift()}}).visit(k),y+=w.slice(C),y}function h(w){return w.replace(/\n/g,"\\r?\\n")}function g(w){let k=!1,y=!1,C="",I="";for(let z=0;z<w.length;z++){const j=w[z];switch(j){case"\\":y?(k?I+="\\"+j:C+="\\"+j,y=!1):y=!0;break;case"{":if(y)k?I+=j:C+=j,y=!1;else{if(k)return{strInBraces:C+"{"+I+"{"+w.substring(z+1)};k=!0}break;case"}":if(y)k?I+=j:C+=j,y=!1;else{if(k)return{fixedStart:C,strInBraces:I,fixedEnd:w.substring(z+1)};C+=j}break;default:k?I+=(y?"\\":"")+j:C+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:C+(k?"{"+I:"")}}function D(w){const{fixedStart:k,strInBraces:y,fixedEnd:C}=g(w);if(k===void 0||C===void 0)return[y];let I=(0,b.$fk)(y,",");I.length||(I=[""]);const z=D(C);return I.flatMap(j=>{const F=k+j;return z.map(N=>F+N)})}}),define(ke[386],Ee([1,0,22,161,108,15]),function(he,e,u,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class M{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,A,P,$){const S=new O.$tmc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},a=new L.$Wv(m=>P.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.c($,m=>S.provideTextSearchResults(E,v,a,m))}else return this.c($,v=>S.provideTextSearchResults(E,A,P,v))}async c(E,A){const P=b(E);this.a.add(P);const $=await A(P.token);return this.a.delete(P),$}d(){this.a.forEach(E=>E.cancel())}}e.$Dmc=M;function b(p){const E=new u.$je;return p.onCancellationRequested(()=>E.cancel()),E}}),define(ke[387],Ee([1,0,31,161,160]),function(he,e,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;class R{constructor(p){this.a=p}search(p,E,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(S){A({message:S})}},$=new L.$Amc(this.a,new O.$tmc(P),u);return new Promise((S,v)=>$.search(a=>{E(a.map(M))},p).then(a=>S({limitHit:a.limitHit,type:"success",stats:a.stats}),v))}}e.$Bmc=R;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((p,E)=>{if(E.ranges){const A=E;return p+(Array.isArray(A.ranges)?A.ranges.length:1)}else return p+1},0)}}}),define(ke[388],Ee([1,0,19,7,13,4,132,17,38,2,32,36,383,387]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new R.$_d({onDidAddFirstListener:()=>{s=(0,O.$ah)(d=>this.doFileSearchWithEngine($.$smc,t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new R.$_d({onDidAddFirstListener:()=>{s=(0,O.$ah)(d=>this.f(t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new S.$Bmc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$pl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine($.$smc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=v.a){let l=0;const c=g=>{Array.isArray(g)?(l+=g.length,t(g.map(D=>this.h(D)))):g.relativePath?(l++,t(this.h(g))):t(g)};if(s.sortByScore){let g=this.l(s,c,f);if(!g){const D=s.maxResults?Object.assign({},s,{maxResults:null}):s,w=new r(D);g=this.j(w,s,t,c,f)}return new Promise((D,w)=>{g.then(([k,y])=>{const C=y.map(I=>this.h(I));this.o(C,t,d),D(k)},w)})}const h=new r(s);return this.r(h,c,d,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const l=new R.$_d;let c=(0,O.$ah)(g=>{let D=[];const w=k=>{Array.isArray(k)?D=k:(f(k),l.fire(k))};return this.r(r,w,-1,g).then(k=>[k,D])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const g={promise:c,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=g,c.then(()=>{g.resolved=!0},D=>{delete h.resultsToSearchCache[s.filePattern||""]}),c=this.s(c)}return c.then(([g,D])=>{const w=h?h.scorerCache:Object.create(null),k=(typeof s.maxResults!="number"||s.maxResults>0)&&p.$8d.create(!1);return this.n(s,D,w,d).then(y=>{const C=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&D.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new a)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([l,c,h])=>{const g=p.$8d.create(!1);return this.n(r,c,f.scorerCache,t).then(D=>{const w=g.elapsed(),k={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:k},D]})})}n(r,s,t,f){const d=(0,M.$mr)(r.filePattern||""),l=(h,g)=>(0,M.$lr)(h,g,d,!0,m,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,c,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=p.$8d.create(!1),l=s.indexOf(b.sep)>=0;let c;for(const w in r.resultsToSearchCache)if(s.startsWith(w)){if(l&&w.indexOf(b.sep)<0&&w!=="")continue;const k=r.resultsToSearchCache[w];c={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!c)return null;const h=d.elapsed(),g=p.$8d.create(!1),D=c.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),c.promise.then(([w,k])=>{if(f&&f.isCancellationRequested)throw(0,L.$6)();const y=[],C=(0,M.$mr)(s).normalizedLowercase;for(const I of k)(0,P.$2K)(I,C)&&y.push(I);return[w,y,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:g.elapsed(),cacheEntryCount:k.length}]})}r(r,s,t,f){return new Promise((d,l)=>{let c=[];f?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(s(c),c=[])):s(h))},h=>{s(h)},(h,g)=>{c.length&&s(c),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),d(g))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$Cmc=v;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>E.URI.revive(r))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[389],Ee([1,0,3,15,2,31,12,28,20,97,67,36,388,386,122,160]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;let m=class extends E.$plc{constructor(n,i,r,s){super(n,r,s),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$nmc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new S.$Dmc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$nmc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.file,new S.$Dmc(n))),this.A.add(this.C(O.Schemas.file,new $.$Cmc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,E.$qlc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-f;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,P.$1K)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>L.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new a.$Amc(n,i,void 0,"textSearchProvider")}};e.$Emc=m,e.$Emc=m=Je([We(0,p.$UO),We(1,b.$$O),We(2,A.$ikc),We(3,M.$Tj)],m)}),define(ke[123],Ee([1,0,376,63,64,403,21,13,4,3,17,11,30,81,82]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$ei=e.$di=e.$ci=void 0,e.$fi=d,e.$gi=l,e.$ii=g,e.$ji=D;class a{traceSocketEvent(k,y){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,y)}constructor(k,y=""){this.f=!0,this.debugLabel=y,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const y=C=>{this.traceSocketEvent("read",C),k(M.$ze.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(k){const y=C=>{k({type:0,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(k){const y=()=>{k()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ci=a;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(o||(o={}));class n extends E.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,y){this.socket.traceSocketEvent(k,y)}constructor(k,y,C,I){super(),this.f=this.B(new p.$_d),this.g=this.B(new p.$_d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,y,C,I,this.f,(z,j)=>this.m(z,j))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$0h,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let y=0;for(;y<k.byteLength;)this.a.writeMessage(k.slice(y,Math.min(y+262144,k.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(k,{compressed:y,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const z=M.$ze.alloc(I),j=y?64:0,F=C&15;if(z.writeUInt8(128|j|F,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(k.byteLength>>>8&255,++N),z.writeUInt8(k.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(k.byteLength>>>24&255,++N),z.writeUInt8(k.byteLength>>>16&255,++N),z.writeUInt8(k.byteLength>>>8&255,++N),z.writeUInt8(k.byteLength>>>0&255,++N)}this.socket.write(M.$ze.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),I=(C&128)>>>7,z=(C&64)>>>6,j=C&15,F=y.readUInt8(1),N=(F&128)>>>7,T=F&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),I=(C&128)>>>7;let z=C&127,j=1;z===126?z=y.readUInt8(++j)*2**8+y.readUInt8(++j):z===127&&(z=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let F=0;I&&(F=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=z,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$di=n;class i extends E.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$ze.alloc(0)}constructor(k,y,C,I,z,j){super(),this.n=k,this.r=z,this.s=j,this.a=this.B(new p.$_d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$_d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$_d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,I,C,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(k,y){this.g.push({data:k,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:y}=this.g.shift();if(this.f&&y.compressed){const C=await this.w(this.f,k);this.s(C,y)}else this.s(k,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,y){return new Promise((C,I)=>{k.write(y),k.flush(z=>C(z))})}acceptFrame(k,y,C){this.h.push({data:k,isCompressed:y,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const y=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,y,C){return new Promise((I,z)=>{k.write(y),C&&k.write(M.$ze.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class r extends E.$Uc{get recordedInflateBytes(){return this.j?M.$ze.concat(this.f):M.$ze.alloc(0)}constructor(k,y,C,I){super(),this.h=k,this.j=y,this.a=this.B(new p.$_d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(M.$ze.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=M.$ze.concat(this.g);this.g.length=0,k(y)})}}class s extends E.$Uc{constructor(k,y){super(),this.g=k,this.a=this.B(new p.$_d),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$ze.wrap(C))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=M.$ze.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),k(y)})}}function t(w,k){if(k===0)return;const y=w.byteLength>>>2;for(let N=0;N<y;N++){const T=w.readUInt32BE(N*4);w.writeUInt32BE(T^k,N*4)}const C=y*4,I=w.byteLength-C,z=k>>>24&255,j=k>>>16&255,F=k>>>8&255;I>=1&&w.writeUInt8(w.readUInt8(C)^z,C),I>=2&&w.writeUInt8(w.readUInt8(C+1)^j,C+1),I>=3&&w.writeUInt8(w.readUInt8(C+2)^F,C+2)}e.$ei=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const w=(0,$.$Jg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const k=process.platform!=="darwin"&&e.$ei?e.$ei:(0,L.tmpdir)(),y=(0,A.$kc)(k,`vscode-ipc-${w}.sock`);return c(y),y}function l(w,k,y){const I=(0,u.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${k}-sock`;const z=y.substr(0,4),j=k.substr(0,6);let F;return process.platform!=="darwin"&&e.$ei&&!process.env.VSCODE_PORTABLE?F=(0,A.$kc)(e.$ei,`vscode-${I}-${z}-${j}.sock`):F=(0,A.$kc)(w,`${z}-${j}.sock`),c(F),F}function c(w){const k=f[P.$u];typeof k=="number"&&w.length>=k&&console.warn(`WARNING: IPC handle "${w}" is longer than ${k} chars, try a shorter --user-data-dir`)}class h extends S.$4h{static b(k){const y=p.Event.fromNodeEventEmitter(k,"connection");return p.Event.map(y,C=>({protocol:new v.$$h(new a(C,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(C,"close"))}))}constructor(k){super(h.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hi=h;function g(w){return new Promise((k,y)=>{const C=(0,O.createServer)();C.on("error",y),C.listen(w,()=>{C.removeListener("error",y),k(new h(C))})})}function D(w,k){return new Promise((y,C)=>{const I=(0,O.createConnection)(w,()=>{I.removeListener("error",C),y(v.$_h.fromSocket(new a(I,`ipc-client${k}`),k))});I.once("error",C)})}}),define(ke[390],Ee([1,0,63,64,173,123,7,3,11,54,12,139,266,267,110,88,21]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=e.$rcc=e.$qcc=void 0;async function o(t,f,d,l,c){let h;for(let g=3;g&&(h?.dispose(),h=await new n(t,f,d,l,c).waitForReady(),!(c&&L.$Mg[c]||!L.$Mg[h.tunnelLocalPort]));g--);return h}class n extends b.$Uc{constructor(f,d,l,c,h){super(),this.m=d,this.n=h,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new M.$mh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,a.$0v)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,L.$Ng)(f,2,1e3,d),c=null;return this.b.listen(l,this.m),await this.c.wait(),c=this.b.address(),c||(l=0,this.b.listen(l,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(f){f.pause();const d=(0,a.$8v)(this.tunnelRemoteHost)||(0,a.$0v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$Jl)(this.a,d,this.tunnelRemotePort),c=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&f.write(h.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),c.end()}),f.on("close",()=>c.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),c instanceof R.$ci?c.socket.destroy():c.end()}),c instanceof R.$ci?this.t(f,c):this.s(f,c),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),c.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(l=>f.write(l.buffer)),f.on("data",l=>d.write(m.$ze.wrap(l))),f.resume()}t(f,d){const l=d.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.$qcc=n;let i=class extends a.$aw{constructor(f,d,l,c,h){super(d,h),this.v=f,this.w=l,this.y=c}isPortPrivileged(f){return(0,a.$$v)(f,this.m,p.OS,O.release())}t(f,d,l,c,h,g,D,w){const k=this.s(d,l);if(k)return++k.refcount,k.value;if((0,a.$4v)(f))return this.u(f,d,l,h,g,D,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=o(y,c,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,C),C}}};e.$rcc=i,e.$rcc=i=Je([We(0,S.$Dl),We(1,A.$Tj),We(2,v.$Gl),We(3,P.$ak),We(4,E.$Ti)],i);let r=class extends i{constructor(f,d,l,c,h){super(f,d,l,c,h)}};e.$scc=r,e.$scc=r=Je([We(0,S.$Dl),We(1,A.$Tj),We(2,v.$Gl),We(3,P.$ak),We(4,E.$Ti)],r);let s=class extends b.$Uc{constructor(f,d,l,c,h){super(),this.b=f,this.c=d,this.f=l,this.g=c,this.h=h,this.a=new Map}async openTunnel(f,d,l,c,h,g,D,w,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${c} on local port ${g}.`),!this.a.has(f)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,l,c,h,g,D,w,k)}};e.$tcc=s,e.$tcc=s=Je([We(0,S.$Dl),We(1,A.$Tj),We(2,P.$ak),We(3,v.$Gl),We(4,E.$Ti)],s)}),define(ke[391],Ee([1,0,123,286,52,33,2,12,41]),function(he,e,u,O,L,R,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=void 0;class E{constructor($,S,v){this.b=$,this.c=S,this.f=v,this.a=O.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(S.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,S){const v=(m,o)=>{S.writeHead(m,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},a=[];$.setEncoding("utf8"),$.on("data",m=>a.push(m)),$.on("end",async()=>{try{const m=JSON.parse(a.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);v(500,o),this.c.error("Error while processing pipe request",m)}})}async i($){const{fileURIs:S,folderURIs:v,forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=$,f=[];if(Array.isArray(v))for(const h of v)try{f.push({folderUri:M.URI.parse(h)})}catch{}if(Array.isArray(S))for(const h of S)try{(0,p.$Si)(h)?f.push({workspaceUri:M.URI.parse(h)}):f.push({fileUri:M.URI.parse(h)})}catch{}const d=s?M.URI.file(s):void 0,c={forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,c)}async j($){for(const S of $.uris){const v=M.URI.parse(S),a=v.scheme==="file"?v:S;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k($){const S=a=>a?.map(m=>/\.vsix$/i.test(m)?M.URI.parse(m):m),v={list:$.list,install:S($.install),uninstall:S($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$jP=E;let A=class extends E{constructor($,S){super($,S,(0,u.$fi)())}};e.$kP=A,e.$kP=A=Je([We(0,R.$eP),We(1,b.$Tj)],A)}),define(ke[392],Ee([1,0,59,379,373,285,49,360,2,15,8,391,104,319,359]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class a extends L.$$lc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,c){return d=t(d),n.a.has(d)?n.a.get(d).load(d,p.URI.file((0,$.$Vq)(l.filename)),h=>r.apply(this,[h,l,c])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,d)=>s.call(this,t(f),d);const t=f=>{for(const d of n.b){const l=d(f);if(l){f=l;break}}return f}}}class m extends M.$Ykc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(S.$Hmc);const n=this.h.invokeFunction(O.$7lc);if(this.h.createInstance(b.$Gmc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(P.$kP);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$Imc),await this.h.createInstance(a,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$Fmc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$Jmc=m}),define(ke[393],Ee([1,0,53,21,4,3,125,11,23,2,31,12,265,66,110,88,390,28,20,70,367]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0,e.$Kmc=s,e.$Lmc=t,e.$Mmc=f,e.$Nmc=d,e.$Omc=c,e.$Pmc=h,e.$Qmc=g;function s(k){const y=k.trim().split(`
`),C=[];return y.forEach(z=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);j&&j.length>=3&&C.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),C.reduce((z,j)=>(z[j.socket]=j,z),{})}function t(...k){const y=[].concat(...k.map(d));return[...new Map(y.filter(C=>C.st==="0A").map(C=>{const I=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:f(I[0]),port:parseInt(I[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function f(k){let y="";if(k.length===8)for(let C=k.length-2;C>=0;C-=2)y+=parseInt(k.substr(C,2),16),C!==0&&(y+=".");else for(let C=0;C<k.length;C+=8){const I=k.substring(C,C+8);let z="";for(let j=8;j>=2;j-=2)z+=I.substring(j-2,j),(j===6||j===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",C+j!==k.length-6&&(y+=":"))}return y}function d(k){const y=k.trim().split(`
`),C=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((j,F,N)=>(j[C[N]||N]=F,j),{}))}function l(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function c(k){const y=k.trim().split(`
`),C=[];return y.forEach(I=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}async function h(k,y,C){const I=C.reduce((j,F)=>(j[F.pid]=F,j),{}),z=[];return k.forEach(({socket:j,ip:F,port:N})=>{const T=y[j]?y[j].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!l(B)&&z.push({host:F,port:N,detail:B,pid:T})}),z}function g(k,y,C){const I=new Map,z=c(y);for(const j of k){const F=C.get(j.port);if(F){I.set(j.port,F);continue}const N=z.find(T=>T.cmd.includes(`${j.port}`));if(N){let T=N,B;do B=z.find(H=>H.ppid===T.pid),B&&(T=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$fCb{constructor(y,C,I,z){super(y,C,I),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$vm;let z=0;for(;this.C;){const j=new Date().getTime(),F=(await this.I()).filter(B=>(0,a.$8v)(B.host)||(0,a.$0v)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&I.update(N),(!C||JSON.stringify(C)!==JSON.stringify(F))&&(C=F,await this.a.$onFoundNewCandidates(C));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",C="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(y,C),z=await new Promise(ee=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,Y,re)=>{ee(Y)})}),j=s(z),F=await A.Promises.readdir("/proc"),N=[];for(const ee of F)try{const J=Number(ee),Y=p.$1g(E.URI.file("/proc"),ee);if((await A.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(J)){const te=await A.Promises.readlink(p.$1g(Y,"cwd").fsPath),pe=await A.Promises.readFile(p.$1g(Y,"cmdline").fsPath,"utf8");N.push({pid:J,cwd:te,cmd:pe})}}catch{}const T=[],B=I.filter(ee=>{const J=j[ee.socket];return J||T.push(ee),J}),H=h(B,j,N);let Z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const ee=await new Promise(J=>{(0,u.exec)("ps -F -A -l | grep root",(Y,re,te)=>{J(re)})});this.z=g(T,ee,this.z),Z=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Z.map(J=>J.port).join(", ")}`)}return H.then(ee=>Z?ee.concat(Z):ee)}w(y){return async C=>{const I=new m.$qcc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,F,N,T){const B=await y.makeConnection();return w.connect(B,F,N,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$zl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await I.waitForReady();const z=new L.$_d;return{localAddress:(0,r.$XL)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{I.dispose(),z.fire(),z.dispose()}}}}};e.$Rmc=D,e.$Rmc=D=Je([We(0,n.$UO),We(1,o.$$O),We(2,P.$Tj),We(3,v.$Gl)],D);class w extends $.$csb{static connect(y,C,I,z){const j=new R.$Tc,F={onClose:j.add(new L.$_d),onData:j.add(new L.$_d),onEnd:j.add(new L.$_d)};j.add(y.onDidReceiveMessage(T=>F.onData.fire(O.$ze.wrap(T)))),j.add(y.onDidEnd(()=>F.onEnd.fire())),j.add(y.onDidClose(T=>F.onClose.fire({type:0,error:T,hadError:!!T})));const N=new w(y,z,F);return N.B(j),(0,$.$bsb)(N,C,I,z,F)}constructor(y,C,I){super(C,I),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[394],Ee([1,0,84,362,377,375,389,392,393,96,49,97,95,42,70,93,361,320,12,378,61,280,106,110,141]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o,n,i,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$ls)(A.$Zkc,b.$Jmc,0),(0,u.$ls)(n.$Uj,o.$Tmc,1),(0,u.$ls)(n.$Tj,new t.$ki(s.$0lc,[!1],!0)),(0,u.$ls)(f.$Gl,d.$vcc,1),(0,u.$ls)(a.$rkc,m.$Smc,0),(0,u.$ls)(E.$5kc,R.$kmc,0),(0,u.$ls)(P.$olc,M.$Emc,0),(0,u.$ls)($.$Qlc,L.$cmc,0),(0,u.$ls)(S.$Mkc,O.$bmc,0),(0,u.$ls)(v.$eCb,p.$Rmc,0),(0,u.$ls)(r.$3kc,i.$Umc,0)}),define(ke[404],Ee([1,0,63,405,59,13,82,123,263,114,374,21,31,104,7,135,287,302,380,394]),function(he,e,u,O,L,R,M,b,p,E,A,P,$,S,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,g=h._load;h._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(g){if(h)i(g);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,D){g==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(g,D)}}let t=function(h){i()};function f(){const h=(0,o.$fn)(process.env);if(h.type===3)return new Promise((g,D)=>{const w=k=>{const y=k[0],C=new M.$ai;y.on("message",I=>C.fire(P.$ze.wrap(I.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),g({onMessage:C.event,send:I=>y.postMessage(I.buffer)})};process.parentPort.on("message",k=>w(k.ports))});if(h.type===2)return new Promise((g,D)=>{let w=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,C=3e5,I=new v.$Ah(()=>t("renderer disconnected for too long (1)"),y),z=new v.$Ah(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const T=P.$ze.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new b.$ci(N,"extHost-socket");else{const H=P.$ze.wrap(Buffer.from(F.inflateBytes,"base64"));B=new b.$di(new b.$ci(N,"extHost-socket"),F.permessageDeflate,H,!1)}w?(I.cancel(),z.cancel(),w.beginAcceptReconnection(B,T),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(k),w=new M.$bi({socket:B,initialChunk:T}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),g(w),w.onSocketClose(()=>{I.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;I.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const g=h.pipeName;return new Promise((D,w)=>{const k=u.createConnection(g,()=>{k.removeListener("error",w);const y=new M.$bi({socket:new b.$ci(k,"extHost-renderer")});y.sendResume(),D(y)});k.once("error",w),k.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await f();return new class{constructor(){this.a=new M.$ai,this.onMessage=this.a.event,this.b=!1,h.onMessage(g=>{(0,E.$Rm)(g,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||h.send(g)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(g=>{const D=h.onMessage(w=>{D.dispose();const k=JSON.parse(w.toString()),y=k.commit,C=p.default.commit;if(y&&C&&y!==C&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(k.parentPid)}catch(j){(0,R.$1)(j)}}h.send((0,E.$Qm)(0)),g({protocol:h,initData:k})});h.send((0,E.$Qm)(1))})}async function c(){const h=[];process.on("unhandledRejection",(I,z)=>{h.push(z),setTimeout(()=>{const j=h.indexOf(z);j>=0&&z.catch(F=>{h.splice(j,1),(0,R.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const z=h.indexOf(I);z>=0&&h.splice(z,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const g=await d();L.mark("code/extHost/didConnectToRenderer");const D=await l(g);L.mark("code/extHost/didWaitForInitData");const{initData:w}=D;s(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,a.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(z){i(z)}fsExists(z){return $.Promises.exists(z)}fsRealpath(z){return(0,S.$Uq)(z)}};let y=null;w.remote.authority&&n.transformURIs&&(y=(0,m.$ps)(w.remote.authority));const C=new A.$amc(D.protocol,w,k,y);t=I=>C.terminate(I)}c().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/workbench/api/node/extensionHostProcess.js.map
