/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],I=0,O=ge.length;I<O;I++)e[I]=Pe[ge[I]];return e};define(Pe[68],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=O,e.$Sh=R,e.$Th=N;function I(M){return(d,f,E)=>{let T=null,y=null;if(typeof E.value=="function"?(T="value",y=E.value):typeof E.get=="function"&&(T="get",y=E.get),!y)throw new Error("not supported");E[T]=M(y,f)}}function O(M,d,f){let E=null,T=null;if(typeof f.value=="function"?(E="value",T=f.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(E="get",T=f.get),!T)throw new Error("not supported");const y=`$memoize$${d}`;f[E]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,u)}),this[y]}}function R(M,d,f){return I((E,T)=>{const y=`$debounce$${T}`,u=`$debounce$result$${T}`;return function(...w){this[u]||(this[u]=f?f():void 0),clearTimeout(this[y]),d&&(this[u]=d(this[u],...w),w=[this[u]]),this[y]=setTimeout(()=>{E.apply(this,w),this[u]=f?f():void 0},M)}})}function N(M,d,f){return I((E,T)=>{const y=`$throttle$timer$${T}`,u=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,m=`$throttle$pending$${T}`;return function(...n){if(this[u]||(this[u]=f?f():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),d&&(this[u]=d(this[u],...n)),this[m])return;const o=this[w]+M;o<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[u]]),this[u]=f?f():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),E.apply(this,[this[u]]),this[u]=f?f():void 0},o-Date.now()))}})}}),define(Pe[90],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZO=I,e.$1O=new I("id#")}),define(Pe[123],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$yn=M,e.$zn=y,e.$An=u,e.$Bn=w,e.$Cn=m,e.$Dn=n,e.$En=o,e.$Fn=s,e.$Gn=r,e.$Hn=i,e.$In=a,e.$Jn=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function M(t,v=!1){let c=0;const $=t.length;let b="",p=0,l=16,D=0;function g(q){let A=0,U=0;for(;A<q;){const K=t.charCodeAt(c);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;c++,A++}return A<q&&(U=-1),U}function S(q){c=q,b="",p=0,l=16,D=0}function k(){const q=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&E(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&E(t.charCodeAt(c)))for(c++;c<t.length&&E(t.charCodeAt(c));)c++;else return D=3,t.substring(q,c);let A=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&E(t.charCodeAt(c))){for(c++;c<t.length&&E(t.charCodeAt(c));)c++;A=c}else D=3;return t.substring(q,A)}function P(){let q="",A=c;for(;;){if(c>=$){q+=t.substring(A,c),D=2;break}const U=t.charCodeAt(c);if(U===34){q+=t.substring(A,c),c++;break}if(U===92){if(q+=t.substring(A,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=g(4);ie>=0?q+=String.fromCharCode(ie):D=4;break}default:D=5}A=c;continue}if(U>=0&&U<=31)if(f(U)){q+=t.substring(A,c),D=2;break}else D=6;c++}return q}function C(){if(b="",D=0,p=c,c>=$)return p=$,l=17;let q=t.charCodeAt(c);if(d(q)){do c++,b+=String.fromCharCode(q),q=t.charCodeAt(c);while(d(q));return l=15}if(f(q))return c++,b+=String.fromCharCode(q),q===13&&t.charCodeAt(c)===10&&(c++,b+=`
`),l=14;switch(q){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,b=P(),l=10;case 47:{const A=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!f(t.charCodeAt(c));)c++;return b=t.substring(A,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const U=$-1;let K=!1;for(;c<U;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,D=1),b=t.substring(A,c),l=13}return b+=String.fromCharCode(q),c++,l=16}case 45:if(b+=String.fromCharCode(q),c++,c===$||!E(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=k(),l=11;default:for(;c<$&&W(q);)c++,q=t.charCodeAt(c);if(p!==c){switch(b=t.substring(p,c),b){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return b+=String.fromCharCode(q),c++,l=16}}function W(q){if(d(q)||f(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=C();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>c,scan:v?V:C,getToken:()=>l,getTokenValue:()=>b,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>D}}function d(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function y(t,v){const c=[],$=new Object;let b;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(g,S,k,P){p.value=g,p.offset=S,p.length=k,p.type=P,p.colonOffset=void 0,b=p}try{i(t,{onObjectBegin:(g,S)=>{if(v<=g)throw $;b=void 0,l=v>g,c.push("")},onObjectProperty:(g,S,k)=>{if(v<S||(D(g,S,k,"property"),c[c.length-1]=g,v<=S+k))throw $},onObjectEnd:(g,S)=>{if(v<=g)throw $;b=void 0,c.pop()},onArrayBegin:(g,S)=>{if(v<=g)throw $;b=void 0,c.push(0)},onArrayEnd:(g,S)=>{if(v<=g)throw $;b=void 0,c.pop()},onLiteralValue:(g,S,k)=>{if(v<S||(D(g,S,k,h(g)),v<=S+k))throw $},onSeparator:(g,S,k)=>{if(v<=S)throw $;if(g===":"&&b&&b.type==="property")b.colonOffset=S,l=!1,b=void 0;else if(g===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(l=!0,c[c.length-1]=""),b=void 0}}})}catch(g){if(g!==$)throw g}return{path:c,previousNode:b,isAtPropertyKey:l,matches:g=>{let S=0;for(let k=0;S<g.length&&k<c.length;k++)if(g[S]===c[k]||g[S]==="*")S++;else if(g[S]!=="**")return!1;return S===g.length}}}function u(t,v=[],c=N.DEFAULT){let $=null,b=[];const p=[];function l(g){Array.isArray(b)?b.push(g):$!==null&&(b[$]=g)}return i(t,{onObjectBegin:()=>{const g={};l(g),p.push(b),b=g,$=null},onObjectProperty:g=>{$=g},onObjectEnd:()=>{b=p.pop()},onArrayBegin:()=>{const g=[];l(g),p.push(b),b=g,$=null},onArrayEnd:()=>{b=p.pop()},onLiteralValue:l,onError:(g,S,k)=>{v.push({error:g,offset:S,length:k})}},c),b[0]}function w(t,v=[],c=N.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(g){$.type==="property"&&($.length=g-$.offset,$=$.parent)}function p(g){return $.children.push(g),g}i(t,{onObjectBegin:g=>{$=p({type:"object",offset:g,length:-1,parent:$,children:[]})},onObjectProperty:(g,S,k)=>{$=p({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:g,offset:S,length:k,parent:$})},onObjectEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,b(g+S)},onArrayBegin:(g,S)=>{$=p({type:"array",offset:g,length:-1,parent:$,children:[]})},onArrayEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,b(g+S)},onLiteralValue:(g,S,k)=>{p({type:h(g),offset:S,length:k,parent:$,value:g}),b(S+k)},onSeparator:(g,S,k)=>{$.type==="property"&&(g===":"?$.colonOffset=S:g===","&&b(S))},onError:(g,S,k)=>{v.push({error:g,offset:S,length:k})}},c);const D=$.children[0];return D&&delete D.parent,D}function m(t,v){if(!t)return;let c=t;for(const $ of v)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let b=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===$){c=p.children[1],b=!0;break}if(!b)return}else{const b=$;if(c.type!=="array"||b<0||!Array.isArray(c.children)||b>=c.children.length)return;c=c.children[b]}return c}function n(t){if(!t.parent||!t.parent.children)return[];const v=n(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;v.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&v.push(c)}return v}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const v=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(v[c.children[0].value]=o($))}return v}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,v,c=!1){return v>=t.offset&&v<t.offset+t.length||c&&v===t.offset+t.length}function r(t,v,c=!1){if(s(t,v,c)){const $=t.children;if(Array.isArray($))for(let b=0;b<$.length&&$[b].offset<=v;b++){const p=r($[b],v,c);if(p)return p}return t}}function i(t,v,c=N.DEFAULT){const $=M(t,!1);function b(ne){return ne?()=>ne($.getTokenOffset(),$.getTokenLength()):()=>!0}function p(ne){return ne?Ie=>ne(Ie,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=b(v.onObjectBegin),D=p(v.onObjectProperty),g=b(v.onObjectEnd),S=b(v.onArrayBegin),k=b(v.onArrayEnd),P=p(v.onLiteralValue),C=p(v.onSeparator),W=b(v.onComment),V=p(v.onError),q=c&&c.disallowComments,A=c&&c.allowTrailingComma;function U(){for(;;){const ne=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ne){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return ne}}}function K(ne,Ie=[],ze=[]){if(V(ne),Ie.length+ze.length>0){let re=$.getToken();for(;re!==17;){if(Ie.indexOf(re)!==-1){U();break}else if(ze.indexOf(re)!==-1)break;re=U()}}}function ie(ne){const Ie=$.getTokenValue();return ne?P(Ie):D(Ie),U(),!0}function fe(){switch($.getToken()){case 11:{let ne=0;try{ne=JSON.parse($.getTokenValue()),typeof ne!="number"&&(K(2),ne=0)}catch{K(2)}P(ne);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function Se(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),$.getToken()===6?(C(":"),U(),$e()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ke(){l(),U();let ne=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(ne||K(4,[],[]),C(","),U(),$.getToken()===2&&A)break}else ne&&K(6,[],[]);Se()||K(4,[],[2,5]),ne=!0}return g(),$.getToken()!==2?K(7,[2],[]):U(),!0}function oe(){S(),U();let ne=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(ne||K(4,[],[]),C(","),U(),$.getToken()===4&&A)break}else ne&&K(6,[],[]);$e()||K(4,[],[4,5]),ne=!0}return k(),$.getToken()!==4?K(8,[4],[]):U(),!0}function $e(){switch($.getToken()){case 3:return oe();case 1:return ke();case 10:return ie(!0);default:return fe()}}return U(),$.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):$e()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(t,v){const c=M(t),$=[];let b,p=0,l;do switch(l=c.getPosition(),b=c.scan(),b){case 12:case 13:case 17:p!==l&&$.push(t.substring(p,l)),v!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,v)),p=c.getPosition();break}while(b!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[124],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ee,pe){for(var de=0;de<pe.length;de++){var Q=pe[de];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ee,Q.key,Q)}}function I(Ee,pe,de){return pe&&e(Ee.prototype,pe),de&&e(Ee,de),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function O(Ee,pe){if(Ee){if(typeof Ee=="string")return R(Ee,pe);var de=Object.prototype.toString.call(Ee).slice(8,-1);if(de==="Object"&&Ee.constructor&&(de=Ee.constructor.name),de==="Map"||de==="Set")return Array.from(Ee);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return R(Ee,pe)}}function R(Ee,pe){(pe==null||pe>Ee.length)&&(pe=Ee.length);for(var de=0,Q=new Array(pe);de<pe;de++)Q[de]=Ee[de];return Q}function N(Ee,pe){var de=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(de)return(de=de.call(Ee)).next.bind(de);if(Array.isArray(Ee)||(de=O(Ee))||pe&&Ee&&typeof Ee.length=="number"){de&&(Ee=de);var Q=0;return function(){return Q>=Ee.length?{done:!0}:{done:!1,value:Ee[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function d(Ee){ge.defaults=Ee}var f=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(pe){return u[pe]};function m(Ee,pe){if(pe){if(f.test(Ee))return Ee.replace(E,w)}else if(T.test(Ee))return Ee.replace(y,w);return Ee}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(n,function(pe,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var s=/(^|[^\[])\^/g;function r(Ee,pe){Ee=typeof Ee=="string"?Ee:Ee.source,pe=pe||"";var de={replace:function(Y,ue){return ue=ue.source||ue,ue=ue.replace(s,"$1"),Ee=Ee.replace(Y,ue),de},getRegex:function(){return new RegExp(Ee,pe)}};return de}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ee,pe,de){if(Ee){var Q;try{Q=decodeURIComponent(o(de)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}pe&&!a.test(de)&&(de=b(pe,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},v=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Ee,pe){t[" "+Ee]||(v.test(Ee)?t[" "+Ee]=Ee+"/":t[" "+Ee]=g(Ee,"/",!0)),Ee=t[" "+Ee];var de=Ee.indexOf(":")===-1;return pe.substring(0,2)==="//"?de?pe:Ee.replace(c,"$1")+pe:pe.charAt(0)==="/"?de?pe:Ee.replace($,"$1")+pe:Ee+pe}var p={exec:function(){}};function l(Ee){for(var pe=1,de,Q;pe<arguments.length;pe++){de=arguments[pe];for(Q in de)Object.prototype.hasOwnProperty.call(de,Q)&&(Ee[Q]=de[Q])}return Ee}function D(Ee,pe){var de=Ee.replace(/\|/g,function(ue,he,Ne){for(var le=!1,Ce=he;--Ce>=0&&Ne[Ce]==="\\";)le=!le;return le?"|":" |"}),Q=de.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>pe)Q.splice(pe);else for(;Q.length<pe;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function g(Ee,pe,de){var Q=Ee.length;if(Q===0)return"";for(var Y=0;Y<Q;){var ue=Ee.charAt(Q-Y-1);if(ue===pe&&!de)Y++;else if(ue!==pe&&de)Y++;else break}return Ee.slice(0,Q-Y)}function S(Ee,pe){if(Ee.indexOf(pe[1])===-1)return-1;for(var de=Ee.length,Q=0,Y=0;Y<de;Y++)if(Ee[Y]==="\\")Y++;else if(Ee[Y]===pe[0])Q++;else if(Ee[Y]===pe[1]&&(Q--,Q<0))return Y;return-1}function k(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ee,pe){if(pe<1)return"";for(var de="";pe>1;)pe&1&&(de+=Ee),pe>>=1,Ee+=Ee;return de+Ee}function C(Ee,pe,de,Q){var Y=pe.href,ue=pe.title?m(pe.title):null,he=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:de,href:Y,title:ue,text:he,tokens:Q.inlineTokens(he)};return Q.state.inLink=!1,Ne}return{type:"image",raw:de,href:Y,title:ue,text:m(he)}}function W(Ee,pe){var de=Ee.match(/^(\s+)(?:```)/);if(de===null)return pe;var Q=de[1];return pe.split(`
`).map(function(Y){var ue=Y.match(/^\s+/);if(ue===null)return Y;var he=ue[0];return he.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var V=function(){function Ee(de){this.options=de||ge.defaults}var pe=Ee.prototype;return pe.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},pe.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var ue=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:g(ue,`
`)}}},pe.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var ue=Y[0],he=W(ue,Y[3]||"");return{type:"code",raw:ue,lang:Y[2]?Y[2].trim():Y[2],text:he}}},pe.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var ue=Y[2].trim();if(/#$/.test(ue)){var he=g(ue,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ue=he.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ue,tokens:this.lexer.inline(ue)}}},pe.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var ue=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},pe.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var ue,he,Ne,le,Ce,Ae,Ue,j,z,G,H,ee,se=Y[1].trim(),Oe=se.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+se.slice(0,-1):"",loose:!1,items:[]};se=Oe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Oe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=Qe.exec(Q))||this.rules.block.hr.test(Q)));){if(ue=Y[0],Q=Q.substring(ue.length),j=Y[2].split(`
`,1)[0],z=Q.split(`
`,1)[0],this.options.pedantic?(le=2,H=j.trimLeft()):(le=Y[2].search(/[^ ]/),le=le>4?1:le,H=j.slice(le),le+=Y[1].length),Ae=!1,!j&&/^ *$/.test(z)&&(ue+=z+`
`,Q=Q.substring(z.length+1),ee=!0),!ee)for(var Ye=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");Q&&(G=Q.split(`
`,1)[0],j=G,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(j)||it.test(j)||Ye.test(j)||et.test(Q)));){if(j.search(/[^ ]/)>=le||!j.trim())H+=`
`+j.slice(le);else if(!Ae)H+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),ue+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(Ue?Be.loose=!0:/\n *\n *$/.test(ue)&&(Ue=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(H),he&&(Ne=he[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:ue,task:!!he,checked:Ne,loose:!1,text:H}),Be.raw+=ue}Be.items[Be.items.length-1].raw=ue.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var tt=Be.items.length;for(Ce=0;Ce<tt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(je){return je.type==="space"}),ft=ct.every(function(je){for(var st=je.raw.split(""),X=0,Z=N(st),me;!(me=Z()).done;){var qe=me.value;if(qe===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&ct.length&&ft&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},pe.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var ue={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);ue.type="paragraph",ue.text=he,ue.tokens=this.lexer.inline(he)}return ue}},pe.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ue=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var ue={type:"table",header:D(Y[1]).map(function(Ue){return{text:Ue}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=Y[0];var he=ue.align.length,Ne,le,Ce,Ae;for(Ne=0;Ne<he;Ne++)/^ *-+: *$/.test(ue.align[Ne])?ue.align[Ne]="right":/^ *:-+: *$/.test(ue.align[Ne])?ue.align[Ne]="center":/^ *:-+ *$/.test(ue.align[Ne])?ue.align[Ne]="left":ue.align[Ne]=null;for(he=ue.rows.length,Ne=0;Ne<he;Ne++)ue.rows[Ne]=D(ue.rows[Ne],ue.header.length).map(function(Ue){return{text:Ue}});for(he=ue.header.length,le=0;le<he;le++)ue.header[le].tokens=this.lexer.inline(ue.header[le].text);for(he=ue.rows.length,le=0;le<he;le++)for(Ae=ue.rows[le],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return ue}}},pe.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},pe.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var ue=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:ue,tokens:this.lexer.inline(ue)}}},pe.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},pe.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},pe.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},pe.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var ue=Y[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var he=g(ue.slice(0,-1),"\\");if((ue.length-he.length)%2===0)return}else{var Ne=S(Y[2],"()");if(Ne>-1){var le=Y[0].indexOf("!")===0?5:4,Ce=le+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Ae=Y[2],Ue="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],Ue=j[3])}else Ue=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ue)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),C(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},pe.reflink=function(Q,Y){var ue;if((ue=this.rules.inline.reflink.exec(Q))||(ue=this.rules.inline.nolink.exec(Q))){var he=(ue[2]||ue[1]).replace(/\s+/g," ");if(he=Y[he.toLowerCase()],!he||!he.href){var Ne=ue[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return C(ue,he,ue[0],this.lexer)}},pe.emStrong=function(Q,Y,ue){ue===void 0&&(ue="");var he=this.rules.inline.emStrong.lDelim.exec(Q);if(he&&!(he[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=he[1]||he[2]||"";if(!Ne||Ne&&(ue===""||this.rules.inline.punctuation.exec(ue))){var le=he[0].length-1,Ce,Ae,Ue=le,j=0,z=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,Y=Y.slice(-1*Q.length+le);(he=z.exec(Y))!=null;)if(Ce=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Ce){if(Ae=Ce.length,he[3]||he[4]){Ue+=Ae;continue}else if((he[5]||he[6])&&le%3&&!((le+Ae)%3)){j+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ae=Math.min(Ae,Ae+Ue+j),Math.min(le,Ae)%2){var G=Q.slice(1,le+he.index+Ae);return{type:"em",raw:Q.slice(0,le+he.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,le+he.index+Ae-1);return{type:"strong",raw:Q.slice(0,le+he.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var ue=Y[2].replace(/\n/g," "),he=/[^ ]/.test(ue),Ne=/^ /.test(ue)&&/ $/.test(ue);return he&&Ne&&(ue=ue.substring(1,ue.length-1)),ue=m(ue,!0),{type:"codespan",raw:Y[0],text:ue}}},pe.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},pe.autolink=function(Q,Y){var ue=this.rules.inline.autolink.exec(Q);if(ue){var he,Ne;return ue[2]==="@"?(he=m(this.options.mangle?Y(ue[1]):ue[1]),Ne="mailto:"+he):(he=m(ue[1]),Ne=he),{type:"link",raw:ue[0],text:he,href:Ne,tokens:[{type:"text",raw:he,text:he}]}}},pe.url=function(Q,Y){var ue;if(ue=this.rules.inline.url.exec(Q)){var he,Ne;if(ue[2]==="@")he=m(this.options.mangle?Y(ue[0]):ue[0]),Ne="mailto:"+he;else{var le;do le=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(le!==ue[0]);he=m(ue[0]),ue[1]==="www."?Ne="http://"+he:Ne=he}return{type:"link",raw:ue[0],text:he,href:Ne,tokens:[{type:"text",raw:he,text:he}]}}},pe.inlineText=function(Q,Y){var ue=this.rules.inline.text.exec(Q);if(ue){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]):ue[0]:he=m(this.options.smartypants?Y(ue[0]):ue[0]),{type:"text",raw:ue[0],text:he}}},Ee}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=r(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=r(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=r(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=r(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=r(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=l({},q),q.gfm=l({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=r(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=l({},q.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:r(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=r(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=r(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=r(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=r(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=r(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=r(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=r(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=r(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=r(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=r(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=r(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=l({},A),A.pedantic=l({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=l({},A.normal,{escape:r(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=r(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=l({},A.gfm,{br:r(A.br).replace("{2,}","*").getRegex(),text:r(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ee){var pe="",de,Q,Y=Ee.length;for(de=0;de<Y;de++)Q=Ee.charCodeAt(de),Math.random()>.5&&(Q="x"+Q.toString(16)),pe+="&#"+Q+";";return pe}var ie=function(){function Ee(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}Ee.lex=function(Q,Y){var ue=new Ee(Y);return ue.lex(Q)},Ee.lexInline=function(Q,Y){var ue=new Ee(Y);return ue.inlineTokens(Q)};var pe=Ee.prototype;return pe.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},pe.blockTokens=function(Q,Y){var ue=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Ue,j,z){return j+"    ".repeat(z.length)});for(var he,Ne,le,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(he=Ue.call({lexer:ue},Q,Y))?(Q=Q.substring(he.raw.length),Y.push(he),!0):!1}))){if(he=this.tokenizer.space(Q)){Q=Q.substring(he.raw.length),he.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(he);continue}if(he=this.tokenizer.code(Q)){Q=Q.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he);continue}if(he=this.tokenizer.fences(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.heading(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.hr(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.blockquote(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.list(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.html(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.def(Q)){Q=Q.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.lheading(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(le=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,j=Q.slice(1),z=void 0;ue.options.extensions.startBlock.forEach(function(G){z=G.call({lexer:this},j),typeof z=="number"&&z>=0&&(Ue=Math.min(Ue,z))}),Ue<1/0&&Ue>=0&&(le=Q.substring(0,Ue+1))}(),this.state.top&&(he=this.tokenizer.paragraph(le))){Ne=Y[Y.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he),Ce=le.length!==Q.length,Q=Q.substring(he.raw.length);continue}if(he=this.tokenizer.text(Q)){Q=Q.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},pe.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},pe.inlineTokens=function(Q,Y){var ue=this;Y===void 0&&(Y=[]);var he,Ne,le,Ce=Q,Ae,Ue,j;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)z.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Ue||(j=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(he=H.call({lexer:ue},Q,Y))?(Q=Q.substring(he.raw.length),Y.push(he),!0):!1}))){if(he=this.tokenizer.escape(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.tag(Q)){Q=Q.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&he.type==="text"&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(he=this.tokenizer.link(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&he.type==="text"&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(he=this.tokenizer.emStrong(Q,Ce,j)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.codespan(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.br(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.del(Q)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.autolink(Q,K)){Q=Q.substring(he.raw.length),Y.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(Q,K))){Q=Q.substring(he.raw.length),Y.push(he);continue}if(le=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),se=void 0;ue.options.extensions.startInline.forEach(function(Oe){se=Oe.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(le=Q.substring(0,H+1))}(),he=this.tokenizer.inlineText(le,U)){Q=Q.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(j=he.raw.slice(-1)),Ue=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(Ee,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),Ee}(),fe=function(){function Ee(de){this.options=de||ge.defaults}var pe=Ee.prototype;return pe.code=function(Q,Y,ue){var he=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,he);Ne!=null&&Ne!==Q&&(ue=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+m(he,!0)+'">'+(ue?Q:m(Q,!0))+`</code></pre>
`:"<pre><code>"+(ue?Q:m(Q,!0))+`</code></pre>
`},pe.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},pe.html=function(Q){return Q},pe.heading=function(Q,Y,ue,he){if(this.options.headerIds){var Ne=this.options.headerPrefix+he.slug(ue);return"<h"+Y+' id="'+Ne+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(Q,Y,ue){var he=Y?"ol":"ul",Ne=Y&&ue!==1?' start="'+ue+'"':"";return"<"+he+Ne+`>
`+Q+"</"+he+`>
`},pe.listitem=function(Q){return"<li>"+Q+`</li>
`},pe.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(Q){return"<p>"+Q+`</p>
`},pe.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},pe.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},pe.tablecell=function(Q,Y){var ue=Y.header?"th":"td",he=Y.align?"<"+ue+' align="'+Y.align+'">':"<"+ue+">";return he+Q+("</"+ue+`>
`)},pe.strong=function(Q){return"<strong>"+Q+"</strong>"},pe.em=function(Q){return"<em>"+Q+"</em>"},pe.codespan=function(Q){return"<code>"+Q+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(Q){return"<del>"+Q+"</del>"},pe.link=function(Q,Y,ue){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return ue;var he='<a href="'+m(Q)+'"';return Y&&(he+=' title="'+Y+'"'),he+=">"+ue+"</a>",he},pe.image=function(Q,Y,ue){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return ue;var he='<img src="'+Q+'" alt="'+ue+'"';return Y&&(he+=' title="'+Y+'"'),he+=this.options.xhtml?"/>":">",he},pe.text=function(Q){return Q},Ee}(),Se=function(){function Ee(){}var pe=Ee.prototype;return pe.strong=function(Q){return Q},pe.em=function(Q){return Q},pe.codespan=function(Q){return Q},pe.del=function(Q){return Q},pe.html=function(Q){return Q},pe.text=function(Q){return Q},pe.link=function(Q,Y,ue){return""+ue},pe.image=function(Q,Y,ue){return""+ue},pe.br=function(){return""},Ee}(),ke=function(){function Ee(){this.seen={}}var pe=Ee.prototype;return pe.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(Q,Y){var ue=Q,he=0;if(this.seen.hasOwnProperty(ue)){he=this.seen[Q];do he++,ue=Q+"-"+he;while(this.seen.hasOwnProperty(ue))}return Y||(this.seen[Q]=he,this.seen[ue]=0),ue},pe.slug=function(Q,Y){Y===void 0&&(Y={});var ue=this.serialize(Q);return this.getNextSafeSlug(ue,Y.dryrun)},Ee}(),oe=function(){function Ee(de){this.options=de||ge.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new ke}Ee.parse=function(Q,Y){var ue=new Ee(Y);return ue.parse(Q)},Ee.parseInline=function(Q,Y){var ue=new Ee(Y);return ue.parseInline(Q)};var pe=Ee.prototype;return pe.parse=function(Q,Y){Y===void 0&&(Y=!0);var ue="",he,Ne,le,Ce,Ae,Ue,j,z,G,H,ee,se,Oe,Be,Qe,Ye,et,at,it,tt=Q.length;for(he=0;he<tt;he++){if(H=Q[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){ue+=it||"";continue}switch(H.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(z="",j="",Ce=H.header.length,Ne=0;Ne<Ce;Ne++)j+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(z+=this.renderer.tablerow(j),G="",Ce=H.rows.length,Ne=0;Ne<Ce;Ne++){for(Ue=H.rows[Ne],j="",Ae=Ue.length,le=0;le<Ae;le++)j+=this.renderer.tablecell(this.parseInline(Ue[le].tokens),{header:!1,align:H.align[le]});G+=this.renderer.tablerow(j)}ue+=this.renderer.table(z,G);continue}case"blockquote":{G=this.parse(H.tokens),ue+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,se=H.start,Oe=H.loose,Ce=H.items.length,G="",Ne=0;Ne<Ce;Ne++)Qe=H.items[Ne],Ye=Qe.checked,et=Qe.task,Be="",Qe.task&&(at=this.renderer.checkbox(Ye),Oe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=at+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=at+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:at}):Be+=at),Be+=this.parse(Qe.tokens,Oe),G+=this.renderer.listitem(Be,et,Ye);ue+=this.renderer.list(G,ee,se);continue}case"html":{ue+=this.renderer.html(H.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;he+1<tt&&Q[he+1].type==="text";)H=Q[++he],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);ue+=Y?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return ue},pe.parseInline=function(Q,Y){Y=Y||this.renderer;var ue="",he,Ne,le,Ce=Q.length;for(he=0;he<Ce;he++){if(Ne=Q[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(le=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){ue+=le||"";continue}switch(Ne.type){case"escape":{ue+=Y.text(Ne.text);break}case"html":{ue+=Y.html(Ne.text);break}case"link":{ue+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{ue+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{ue+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{ue+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{ue+=Y.codespan(Ne.text);break}case"br":{ue+=Y.br();break}case"del":{ue+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{ue+=Y.text(Ne.text);break}default:{var Ae='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ue},Ee}();function $e(Ee,pe,de){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof pe=="function"&&(de=pe,pe=null),pe=l({},$e.defaults,pe||{}),k(pe),de){var Q=pe.highlight,Y;try{Y=ie.lex(Ee,pe)}catch(Ce){return de(Ce)}var ue=function(Ae){var Ue;if(!Ae)try{pe.walkTokens&&$e.walkTokens(Y,pe.walkTokens),Ue=oe.parse(Y,pe)}catch(j){Ae=j}return pe.highlight=Q,Ae?de(Ae):de(null,Ue)};if(!Q||Q.length<3||(delete pe.highlight,!Y.length))return ue();var he=0;$e.walkTokens(Y,function(Ce){Ce.type==="code"&&(he++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Ae,Ue){if(Ae)return ue(Ae);Ue!=null&&Ue!==Ce.text&&(Ce.text=Ue,Ce.escaped=!0),he--,he===0&&ue()})},0))}),he===0&&ue();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Ce.message+"",!0)+"</pre>";throw Ce}try{var le=ie.lex(Ee,pe);if(pe.walkTokens){if(pe.async)return Promise.all($e.walkTokens(le,pe.walkTokens)).then(function(){return oe.parse(le,pe)}).catch(Ne);$e.walkTokens(le,pe.walkTokens)}return oe.parse(le,pe)}catch(Ce){Ne(Ce)}}$e.options=$e.setOptions=function(Ee){return l($e.defaults,Ee),d($e.defaults),$e},$e.getDefaults=M,$e.defaults=ge.defaults,$e.use=function(){for(var Ee=arguments.length,pe=new Array(Ee),de=0;de<Ee;de++)pe[de]=arguments[de];var Q=l.apply(void 0,[{}].concat(pe)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},ue;pe.forEach(function(he){if(he.extensions&&(ue=!0,he.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var Ce=Y.renderers?Y.renderers[le.name]:null;Ce?Y.renderers[le.name]=function(){for(var Ae=arguments.length,Ue=new Array(Ae),j=0;j<Ae;j++)Ue[j]=arguments[j];var z=le.renderer.apply(this,Ue);return z===!1&&(z=Ce.apply(this,Ue)),z}:Y.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[le.level]?Y[le.level].unshift(le.tokenizer):Y[le.level]=[le.tokenizer],le.start&&(le.level==="block"?Y.startBlock?Y.startBlock.push(le.start):Y.startBlock=[le.start]:le.level==="inline"&&(Y.startInline?Y.startInline.push(le.start):Y.startInline=[le.start]))}le.childTokens&&(Y.childTokens[le.name]=le.childTokens)})),he.renderer&&function(){var le=$e.defaults.renderer||new fe,Ce=function(j){var z=le[j];le[j]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=he.renderer[j].apply(le,H);return se===!1&&(se=z.apply(le,H)),se}};for(var Ae in he.renderer)Ce(Ae);Q.renderer=le}(),he.tokenizer&&function(){var le=$e.defaults.tokenizer||new V,Ce=function(j){var z=le[j];le[j]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=he.tokenizer[j].apply(le,H);return se===!1&&(se=z.apply(le,H)),se}};for(var Ae in he.tokenizer)Ce(Ae);Q.tokenizer=le}(),he.walkTokens){var Ne=$e.defaults.walkTokens;Q.walkTokens=function(le){var Ce=[];return Ce.push(he.walkTokens.call(this,le)),Ne&&(Ce=Ce.concat(Ne.call(this,le))),Ce}}ue&&(Q.extensions=Y),$e.setOptions(Q)})},$e.walkTokens=function(Ee,pe){for(var de=[],Q=function(){var Ne=ue.value;switch(de=de.concat(pe.call($e,Ne)),Ne.type){case"table":{for(var le=N(Ne.header),Ce;!(Ce=le()).done;){var Ae=Ce.value;de=de.concat($e.walkTokens(Ae.tokens,pe))}for(var Ue=N(Ne.rows),j;!(j=Ue()).done;)for(var z=j.value,G=N(z),H;!(H=G()).done;){var ee=H.value;de=de.concat($e.walkTokens(ee.tokens,pe))}break}case"list":{de=de.concat($e.walkTokens(Ne.items,pe));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Ne.type]?$e.defaults.extensions.childTokens[Ne.type].forEach(function(se){de=de.concat($e.walkTokens(Ne[se],pe))}):Ne.tokens&&(de=de.concat($e.walkTokens(Ne.tokens,pe)))}},Y=N(Ee),ue;!(ue=Y()).done;)Q();return de},$e.parseInline=function(Ee,pe){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");pe=l({},$e.defaults,pe||{}),k(pe);try{var de=ie.lexInline(Ee,pe);return pe.walkTokens&&$e.walkTokens(de,pe.walkTokens),oe.parseInline(de,pe)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Q.message+"",!0)+"</pre>";throw Q}},$e.Parser=oe,$e.parser=oe.parse,$e.Renderer=fe,$e.TextRenderer=Se,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=ke,$e.parse=$e;var ne=$e.options,Ie=$e.setOptions,ze=$e.use,re=$e.walkTokens,L=$e.parseInline,_=$e,ve=oe.parse,Te=ie.lex;ge.Lexer=ie,ge.Parser=oe,ge.Renderer=fe,ge.Slugger=ke,ge.TextRenderer=Se,ge.Tokenizer=V,ge.getDefaults=M,ge.lexer=Te,ge.marked=$e,ge.options=ne,ge.parse=_,ge.parseInline=L,ge.parser=ve,ge.setOptions=Ie,ge.use=ze,ge.walkTokens=re,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=I;function I(n){const o=N(n);if(o&&o.length>0)return new Uint32Array(o)}let O=0;const R=new Uint32Array(10);function N(n){if(O=0,M(n,y,4352),O>0||(M(n,u,4449),O>0)||(M(n,w,4520),O>0)||(M(n,m,12593),O))return R.subarray(0,O);if(n>=44032&&n<=55203){const o=n-44032,s=o%588,r=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(r<y.length?M(r,y,0):4352+r-12593<m.length&&M(4352+r,m,12593),i<u.length?M(i,u,0):4449+i-12593<m.length&&M(4449+i-12593,m,12593),a>=0&&(a<w.length?M(a,w,0):4520+a-12593<m.length&&M(4520+a-12593,m,12593)),O>0)return R.subarray(0,O)}}function M(n,o,s){n>=s&&n<s+o.length&&d(o[n-s])}function d(n){n!==0&&(R[O++]=n&255,n>>8&&(R[O++]=n>>8&255),n>>16&&(R[O++]=n>>16&255))}var f;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var E;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(E||(E={}));var T;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(T||(T={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[126],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0,e.$sm=I,e.rot=O;function I(d,f,E){return Math.min(Math.max(d,f),E)}function O(d,f){return(f+d%f)%f}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$um=R;class N{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$vm=N;class M{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const E=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$wm=M}),function(){function ge(R){const N=[];typeof R=="number"&&N.push("code/timeOrigin",R);function M(f){N.push(f,Date.now())}function d(){const f=[];for(let E=0;E<N.length;E+=2)f.push({name:N[E],startTime:N[E+1]});return f}return{mark:M,getMarks:d}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))N.push({name:M.name,startTime:Math.round(R+M.startTime)});return N}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=I(O))}(),define(Pe[127],Re([1,0,46]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=void 0;const O=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(f,E,T){this.d(f,y=>y._value=E,T)}mutate(f,E){this.d(f,T=>T._value=E(T._value===O?void 0:T._value))}delete(f){const E=this.c(f);if(!E)return;let T=E.length-1;const y=E[T].node._value;if(y!==O){for(this.b--,E[T].node._value=O;T>0;T--){const{node:u,part:w}=E[T];if(u.children?.size||u._value!==O)break;E[T-1].node.children.delete(w)}return y}}*deleteRecursive(f){const E=this.c(f);if(!E)return;const T=E[E.length-1].node;for(let y=E.length-1;y>0;y--){const u=E[y-1];if(u.node.children.delete(E[y].part),u.node.children.size>0||u.node._value!==O)break}for(const y of N(T))y._value!==O&&(this.b--,yield y._value)}find(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return;E=y}return E._value===O?void 0:E._value}hasKeyOrParent(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return!1;if(y._value!==O)return!0;E=y}return!1}hasKeyOrChildren(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return!1;E=y}return!0}hasKey(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return!1;E=y}return E._value!==O}c(f){const E=[{part:"",node:this.a}];let T=0;for(const y of f){const u=E[T].node.children?.get(y);if(!u)return;E.push({part:y,node:u}),T++}return E}d(f,E,T){let y=this.a;for(const m of f){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const n=new M;y.children.set(m,n),y=n}else{const n=new M;y.children=new Map([[m,n]]),y=n}T?.(y)}const u=y._value===O?0:1;E(y);const w=y._value===O?0:1;this.b+=w-u}*values(){for(const{_value:f}of N(this.a))f!==O&&(yield f)}}e.$JO=R;function*N(d){const f=[d];for(;f.length>0;){const E=f.pop();if(yield E,E.children)for(const T of E.children.values())f.push(T)}}class M{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(f){this._value=f===void 0?O:f}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var O in I)(typeof exports=="object"?exports:ge)[O]=I[O]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return ge[O].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=ge,I.c=e,I.d=function(O,R,N){I.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:N})},I.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},I.t=function(O,R){if(1&R&&(O=I(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(I.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var M in O)I.d(N,M,function(d){return O[d]}.bind(null,M));return N},I.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return I.d(R,"a",R),R},I.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},I.p="",I(I.s=0)}([function(ge,e,I){(function(O){var R;e=ge.exports=ze,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,d=e.re=[],f=e.src=[],E=0,T=E++;f[T]="0|[1-9]\\d*";var y=E++;f[y]="[0-9]+";var u=E++;f[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;f[w]="("+f[T]+")\\.("+f[T]+")\\.("+f[T]+")";var m=E++;f[m]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var n=E++;f[n]="(?:"+f[T]+"|"+f[u]+")";var o=E++;f[o]="(?:"+f[y]+"|"+f[u]+")";var s=E++;f[s]="(?:-("+f[n]+"(?:\\."+f[n]+")*))";var r=E++;f[r]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var i=E++;f[i]="[0-9A-Za-z-]+";var a=E++;f[a]="(?:\\+("+f[i]+"(?:\\."+f[i]+")*))";var h=E++,t="v?"+f[w]+f[s]+"?"+f[a]+"?";f[h]="^"+t+"$";var v="[v=\\s]*"+f[m]+f[r]+"?"+f[a]+"?",c=E++;f[c]="^"+v+"$";var $=E++;f[$]="((?:<|>)?=?)";var b=E++;f[b]=f[y]+"|x|X|\\*";var p=E++;f[p]=f[T]+"|x|X|\\*";var l=E++;f[l]="[v=\\s]*("+f[p]+")(?:\\.("+f[p]+")(?:\\.("+f[p]+")(?:"+f[s]+")?"+f[a]+"?)?)?";var D=E++;f[D]="[v=\\s]*("+f[b]+")(?:\\.("+f[b]+")(?:\\.("+f[b]+")(?:"+f[r]+")?"+f[a]+"?)?)?";var g=E++;f[g]="^"+f[$]+"\\s*"+f[l]+"$";var S=E++;f[S]="^"+f[$]+"\\s*"+f[D]+"$";var k=E++;f[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=E++;f[P]="(?:~>?)";var C=E++;f[C]="(\\s*)"+f[P]+"\\s+",d[C]=new RegExp(f[C],"g");var W=E++;f[W]="^"+f[P]+f[l]+"$";var V=E++;f[V]="^"+f[P]+f[D]+"$";var q=E++;f[q]="(?:\\^)";var A=E++;f[A]="(\\s*)"+f[q]+"\\s+",d[A]=new RegExp(f[A],"g");var U=E++;f[U]="^"+f[q]+f[l]+"$";var K=E++;f[K]="^"+f[q]+f[D]+"$";var ie=E++;f[ie]="^"+f[$]+"\\s*("+v+")$|^$";var fe=E++;f[fe]="^"+f[$]+"\\s*("+t+")$|^$";var Se=E++;f[Se]="(\\s*)"+f[$]+"\\s*("+v+"|"+f[l]+")",d[Se]=new RegExp(f[Se],"g");var ke=E++;f[ke]="^\\s*("+f[l]+")\\s+-\\s+("+f[l]+")\\s*$";var oe=E++;f[oe]="^\\s*("+f[D]+")\\s+-\\s+("+f[D]+")\\s*$";var $e=E++;f[$e]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)R(ne,f[ne]),d[ne]||(d[ne]=new RegExp(f[ne]));function Ie(z,G){if(z instanceof ze)return z;if(typeof z!="string"||z.length>N||!(G?d[c]:d[h]).test(z))return null;try{return new ze(z,G)}catch{return null}}function ze(z,G){if(z instanceof ze){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof ze))return new ze(z,G);R("SemVer",z,G),this.loose=G;var H=z.trim().match(G?d[c]:d[h]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<M)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Ie,e.valid=function(z,G){var H=Ie(z,G);return H?H.version:null},e.clean=function(z,G){var H=Ie(z.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=ze,ze.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ze.prototype.toString=function(){return this.version},ze.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof ze||(z=new ze(z,this.loose)),this.compareMain(z)||this.comparePre(z)},ze.prototype.compareMain=function(z){return z instanceof ze||(z=new ze(z,this.loose)),L(this.major,z.major)||L(this.minor,z.minor)||L(this.patch,z.patch)},ze.prototype.comparePre=function(z){if(z instanceof ze||(z=new ze(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=z.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return L(H,ee)}while(++G)},ze.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new ze(z,H).inc(G,ee).version}catch{return null}},e.diff=function(z,G){if(Ee(z,G))return null;var H=Ie(z),ee=Ie(G);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=L;var re=/^[0-9]+$/;function L(z,G){var H=re.test(z),ee=re.test(G);return H&&ee&&(z=+z,G=+G),H&&!ee?-1:ee&&!H?1:z<G?-1:z>G?1:0}function _(z,G,H){return new ze(z,H).compare(new ze(G,H))}function ve(z,G,H){return _(z,G,H)>0}function Te(z,G,H){return _(z,G,H)<0}function Ee(z,G,H){return _(z,G,H)===0}function pe(z,G,H){return _(z,G,H)!==0}function de(z,G,H){return _(z,G,H)>=0}function Q(z,G,H){return _(z,G,H)<=0}function Y(z,G,H,ee){var se;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),se=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),se=z!==H;break;case"":case"=":case"==":se=Ee(z,H,ee);break;case"!=":se=pe(z,H,ee);break;case">":se=ve(z,H,ee);break;case">=":se=de(z,H,ee);break;case"<":se=Te(z,H,ee);break;case"<=":se=Q(z,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return se}function ue(z,G){if(z instanceof ue){if(z.loose===G)return z;z=z.value}if(!(this instanceof ue))return new ue(z,G);R("comparator",z,G),this.loose=G,this.parse(z),this.semver===he?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,G){return L(G,z)},e.major=function(z,G){return new ze(z,G).major},e.minor=function(z,G){return new ze(z,G).minor},e.patch=function(z,G){return new ze(z,G).patch},e.compare=_,e.compareLoose=function(z,G){return _(z,G,!0)},e.rcompare=function(z,G,H){return _(G,z,H)},e.sort=function(z,G){return z.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(z,G){return z.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=ve,e.lt=Te,e.eq=Ee,e.neq=pe,e.gte=de,e.lte=Q,e.cmp=Y,e.Comparator=ue;var he={};function Ne(z,G){if(z instanceof Ne)return z.loose===G?z:new Ne(z.raw,G);if(z instanceof ue)return new Ne(z.value,G);if(!(this instanceof Ne))return new Ne(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function le(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ce(z,G,H,ee,se,Oe,Be,Qe,Ye,et,at,it,tt){return((G=le(H)?"":le(ee)?">="+H+".0.0":le(se)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=le(Ye)?"":le(et)?"<"+(+Ye+1)+".0.0":le(at)?"<"+Ye+"."+(+et+1)+".0":it?"<="+Ye+"."+et+"."+at+"-"+it:"<="+Qe)).trim()}function Ae(z,G){for(var H=0;H<z.length;H++)if(!z[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<z.length;H++)if(R(z[H].semver),z[H].semver!==he&&z[H].semver.prerelease.length>0){var ee=z[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function Ue(z,G,H){try{G=new Ne(G,H)}catch{return!1}return G.test(z)}function j(z,G,H,ee){var se,Oe,Be,Qe,Ye;switch(z=new ze(z,ee),G=new Ne(G,ee),H){case">":se=ve,Oe=Q,Be=Te,Qe=">",Ye=">=";break;case"<":se=Te,Oe=de,Be=ve,Qe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,G,ee))return!1;for(var et=0;et<G.set.length;++et){var at=G.set[et],it=null,tt=null;if(at.forEach(function(ct){ct.semver===he&&(ct=new ue(">=0.0.0")),it=it||ct,tt=tt||ct,se(ct.semver,it.semver,ee)?it=ct:Be(ct.semver,tt.semver,ee)&&(tt=ct)}),it.operator===Qe||it.operator===Ye||(!tt.operator||tt.operator===Qe)&&Oe(z,tt.semver)||tt.operator===Ye&&Be(z,tt.semver))return!1}return!0}ue.prototype.parse=function(z){var G=this.loose?d[ie]:d[fe],H=z.match(G);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ze(H[2],this.loose):this.semver=he},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===he||(typeof z=="string"&&(z=new ze(z,this.loose)),Y(z,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(z,G){if(!(z instanceof ue))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(z.value,G),Ue(this.value,H,G);if(z.operator==="")return H=new Ne(this.value,G),Ue(z.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Qe=Y(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ye=Y(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ee||se||Oe&&Be||Qe||Ye},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),R("range",z,G);var H=G?d[oe]:d[ke];z=z.replace(H,Ce),R("hyphen replace",z),z=z.replace(d[Se],"$1$2$3"),R("comparator trim",z,d[Se]),z=(z=(z=z.replace(d[C],"$1~")).replace(d[A],"$1^")).split(/\s+/).join(" ");var ee=G?d[ie]:d[fe],se=z.split(" ").map(function(Oe){return function(Be,Qe){return R("comp",Be),Be=function(Ye,et){return Ye.trim().split(/\s+/).map(function(at){return function(it,tt){R("caret",it,tt);var ct=tt?d[K]:d[U];return it.replace(ct,function(ft,je,st,X,Z){var me;return R("caret",it,ft,je,st,X,Z),le(je)?me="":le(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":le(X)?me=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+Z+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+Z+" <"+(+je+1)+".0.0"):(R("no pr"),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+" <"+(+je+1)+".0.0"),R("caret return",me),me})}(at,et)}).join(" ")}(Be,Qe),R("caret",Be),Be=function(Ye,et){return Ye.trim().split(/\s+/).map(function(at){return function(it,tt){var ct=tt?d[V]:d[W];return it.replace(ct,function(ft,je,st,X,Z){var me;return R("tilde",it,ft,je,st,X,Z),le(je)?me="":le(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":le(X)?me=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0"):me=">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0",R("tilde return",me),me})}(at,et)}).join(" ")}(Be,Qe),R("tildes",Be),Be=function(Ye,et){return R("replaceXRanges",Ye,et),Ye.split(/\s+/).map(function(at){return function(it,tt){it=it.trim();var ct=tt?d[S]:d[g];return it.replace(ct,function(ft,je,st,X,Z,me){R("xRange",it,ft,je,st,X,Z,me);var qe=le(st),we=qe||le(X),ot=we||le(Z);return je==="="&&ot&&(je=""),qe?ft=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(we&&(X=0),ot&&(Z=0),je===">"?(je=">=",we?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):je==="<="&&(je="<",we?st=+st+1:X=+X+1),ft=je+st+"."+X+"."+Z):we?ft=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(ft=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),R("xRange return",ft),ft})}(at,et)}).join(" ")}(Be,Qe),R("xrange",Be),Be=function(Ye,et){return R("replaceStars",Ye,et),Ye.trim().replace(d[$e],"")}(Be,Qe),R("stars",Be),Be}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Oe){return!!Oe.match(ee)})),se=se.map(function(Oe){return new ue(Oe,G)})},Ne.prototype.intersects=function(z,G){if(!(z instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return z.set.some(function(se){return se.every(function(Oe){return ee.intersects(Oe,G)})})})})},e.toComparators=function(z,G){return new Ne(z,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new ze(z,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],z))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(z,G,H){var ee=null,se=null;try{var Oe=new Ne(G,H)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(ee&&se.compare(Be)!==-1||(se=new ze(ee=Be,H)))}),ee},e.minSatisfying=function(z,G,H){var ee=null,se=null;try{var Oe=new Ne(G,H)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(ee&&se.compare(Be)!==1||(se=new ze(ee=Be,H)))}),ee},e.validRange=function(z,G){try{return new Ne(z,G).range||"*"}catch{return null}},e.ltr=function(z,G,H){return j(z,G,"<",H)},e.gtr=function(z,G,H){return j(z,G,">",H)},e.outside=j,e.prerelease=function(z,G){var H=Ie(z,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(z,G,H){return z=new Ne(z,H),G=new Ne(G,H),z.intersects(G)},e.coerce=function(z){if(z instanceof ze)return z;if(typeof z!="string")return null;var G=z.match(d[k]);return G==null?null:Ie((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,O,R=ge.exports={};function N(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function d(o){if(I===setTimeout)return setTimeout(o,0);if((I===N||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:N}catch{I=N}try{O=typeof clearTimeout=="function"?clearTimeout:M}catch{O=M}})();var f,E=[],T=!1,y=-1;function u(){T&&f&&(T=!1,f.length?E=f.concat(E):y=-1,E.length&&w())}function w(){if(!T){var o=d(u);T=!0;for(var s=E.length;s;){for(f=E,E=[];++y<s;)f&&f[y].run();y=-1,s=E.length}f=null,T=!1,function(r){if(O===clearTimeout)return clearTimeout(r);if((O===M||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(r);try{O(r)}catch{try{return O.call(null,r)}catch{return O.call(this,r)}}}(o)}}function m(o,s){this.fun=o,this.array=s}function n(){}R.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)s[r-1]=arguments[r];E.push(new m(o,s)),E.length!==1||T||d(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=n,R.addListener=n,R.once=n,R.off=n,R.removeListener=n,R.removeAllListeners=n,R.emit=n,R.prependListener=n,R.prependOnceListener=n,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Pe[128],Re([1,0,14,6]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=R,e.$le=N,e.$me=M,e.$ne=d,e.$oe=E,e.$pe=T,e.$qe=y,e.$re=u,e.$se=w,e.$te=m,e.$ue=n,e.$ve=o,e.$we=s,e.$xe=r,e.$ye=i;function R(a){const h=a;return h?typeof h.read=="function":!1}function N(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function M(a){const h=a;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function d(a,h){return new f(a,h)}class f{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let v;switch(h){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const c=v.indexOf(t);c>=0&&v.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,h){const t=[];let v;for(;(v=a.read())!==null;)t.push(v);return h(t)}function T(a,h,t){const v=[];let c;for(;(c=a.read())!==null&&v.length<t;)v.push(c);return c===null&&v.length>0?h(v):{read:()=>{if(v.length>0)return v.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function y(a,h){return new Promise((t,v)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?v($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",v=>{t?.isCancellationRequested||h.onError(v)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",v=>{t?.isCancellationRequested||h.onData(v)})}function w(a,h){return new Promise((t,v)=>{const c=new O.$Tc,$=[],b=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},p=D=>(c.dispose(),v(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,O.$Sc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,O.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,O.$Sc)(()=>a.removeListener("data",b))),a.on("data",b)})}function m(a,h){const t=d(h);return t.end(a),t}function n(){const a=d(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const v=d(t);return u(a,{onData:c=>v.write(h.data(c)),onError:c=>v.error(h.error?h.error(c):c),onEnd:()=>v.end()}),v}function r(a,h,t){let v=!1;return{read:()=>{const c=h.read();return v?c:(v=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let v=!1;const c=d(t);return u(h,{onData:$=>v?c.write($):(v=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{v||(v=!0,c.write(a)),c.end()}}),c}}),define(Pe[22],Re([1,0,40,128]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=E,e.$Be=T,e.$Ce=y,e.$De=u,e.$Ee=w,e.$Fe=m,e.$Ge=n,e.$He=o,e.$Ie=s,e.$Je=r,e.$Ke=i,e.$Le=a,e.$Me=h,e.$Ne=t,e.$Oe=v,e.$Pe=c,e.$Qe=$,e.$Re=b,e.$Se=p,e.$Te=g;const R=typeof Buffer<"u",N=new I.$V(()=>new Uint8Array(256));let M,d;class f{static alloc(k){return R?new f(Buffer.allocUnsafe(k)):new f(new Uint8Array(k))}static wrap(k){return R&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new f(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&R?new f(Buffer.from(k)):(M||(M=new TextEncoder),new f(M.encode(k)))}static fromByteArray(k){const P=f.alloc(k.length);for(let C=0,W=k.length;C<W;C++)P.buffer[C]=k[C];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let V=0,q=k.length;V<q;V++)P+=k[V].byteLength}const C=f.alloc(P);let W=0;for(let V=0,q=k.length;V<q;V++){const A=k[V];C.set(A,W),W+=A.byteLength}return C}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=f.alloc(this.byteLength);return k.set(this),k}toString(){return R?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(k,P){return new f(this.buffer.subarray(k,P))}set(k,P){if(k instanceof f)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return u(this.buffer,k)}writeUInt32BE(k,P){w(this.buffer,k,P)}readUInt32LE(k){return m(this.buffer,k)}writeUInt32LE(k,P){n(this.buffer,k,P)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,P){s(this.buffer,k,P)}indexOf(k,P=0){return E(this.buffer,k instanceof f?k.buffer:k,P)}}e.$ze=f;function E(S,k,P=0){const C=k.byteLength,W=S.byteLength;if(C===0)return 0;if(C===1)return S.indexOf(k[0]);if(C>W-P)return-1;const V=N.value;V.fill(k.length);for(let K=0;K<k.length;K++)V[k[K]]=k.length-K-1;let q=P+k.length-1,A=q,U=-1;for(;q<W;)if(S[q]===k[A]){if(A===0){U=q;break}q--,A--}else q+=Math.max(k.length-A,V[S[q]]),A=k.length-1;return U}function T(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0}function y(S,k,P){S[P+0]=k&255,k=k>>>8,S[P+1]=k&255}function u(S,k){return S[k]*2**24+S[k+1]*2**16+S[k+2]*2**8+S[k+3]}function w(S,k,P){S[P+3]=k,k=k>>>8,S[P+2]=k,k=k>>>8,S[P+1]=k,k=k>>>8,S[P]=k}function m(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0|S[k+2]<<16>>>0|S[k+3]<<24>>>0}function n(S,k,P){S[P+0]=k&255,k=k>>>8,S[P+1]=k&255,k=k>>>8,S[P+2]=k&255,k=k>>>8,S[P+3]=k&255}function o(S,k){return S[k]}function s(S,k,P){S[P]=k}function r(S){return O.$oe(S,k=>f.concat(k))}function i(S){return O.$ve(S)}function a(S){return O.$qe(S,k=>f.concat(k))}async function h(S){return S.ended?f.concat(S.buffer):f.concat([...S.buffer,await a(S.stream)])}function t(S){return O.$te(S,k=>f.concat(k))}function v(S){return O.$we(S,{data:k=>typeof k=="string"?f.fromString(k):f.wrap(k)},k=>f.concat(k))}function c(S){return O.$ne(k=>f.concat(k),S)}function $(S,k){return O.$xe(S,k,P=>f.concat(P))}function b(S,k){return O.$ye(S,k,P=>f.concat(P))}function p(S){let k=0,P=0,C=0;const W=new Uint8Array(Math.floor(S.length/4*3)),V=A=>{switch(P){case 3:W[C++]=k|A,P=0;break;case 2:W[C++]=k|A>>>2,k=A<<6,P=3;break;case 1:W[C++]=k|A>>>4,k=A<<4,P=2;break;default:k=A<<2,P=1}};for(let A=0;A<S.length;A++){const U=S.charCodeAt(A);if(U>=65&&U<=90)V(U-65);else if(U>=97&&U<=122)V(U-97+26);else if(U>=48&&U<=57)V(U-48+52);else if(U===43||U===45)V(62);else if(U===47||U===95)V(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${S[A]}`)}}const q=C;for(;P>0;)V(0);return f.wrap(W).slice(0,q)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:S},k=!0,P=!1){const C=P?D:l;let W="";const V=S.byteLength%3;let q=0;for(;q<S.byteLength-V;q+=3){const A=S[q+0],U=S[q+1],K=S[q+2];W+=C[A>>>2],W+=C[(A<<4|U>>>4)&63],W+=C[(U<<2|K>>>6)&63],W+=C[K&63]}if(V===1){const A=S[q+0];W+=C[A>>>2],W+=C[A<<4&63],k&&(W+="==")}else if(V===2){const A=S[q+0],U=S[q+1];W+=C[A>>>2],W+=C[(A<<4|U>>>4)&63],W+=C[U<<2&63],k&&(W+="=")}return W}}),define(Pe[129],Re([1,0,28,125,15]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.FuzzyScore=e.$pk=e.$ok=void 0,e.or=N,e.$qk=d,e.$rk=f,e.$sk=y,e.$tk=p,e.$uk=l,e.$vk=C,e.$wk=W,e.$xk=V,e.$yk=q,e.$zk=_,e.$Bk=pe,e.$Ck=Y,e.$Dk=ue;function N(...le){return function(Ce,Ae){for(let Ue=0,j=le.length;Ue<j;Ue++){const z=le[Ue](Ce,Ae);if(z)return z}return null}}e.$ok=M.bind(void 0,!1),e.$pk=M.bind(void 0,!0);function M(le,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Ue;return le?Ue=R.$rf(Ae,Ce):Ue=Ae.indexOf(Ce)===0,Ue?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function d(le,Ce){const Ae=Ce.toLowerCase().indexOf(le.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+le.length}]}function f(le,Ce){return E(le.toLowerCase(),Ce.toLowerCase(),0,0)}function E(le,Ce,Ae,Ue){if(Ae===le.length)return[];if(Ue===Ce.length)return null;if(le[Ae]===Ce[Ue]){let j=null;return(j=E(le,Ce,Ae+1,Ue+1))?a({start:Ue,end:Ue+1},j):null}return E(le,Ce,Ae,Ue+1)}function T(le){return 97<=le&&le<=122}function y(le){return 65<=le&&le<=90}function u(le){return 48<=le&&le<=57}function w(le){return le===32||le===9||le===10||le===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>m.add(le.charCodeAt(0)));function n(le){return w(le)||m.has(le)}function o(le,Ce){return le===Ce||n(le)&&n(Ce)}const s=new Map;function r(le){if(s.has(le))return s.get(le);let Ce;const Ae=(0,O.$mk)(le);return Ae&&(Ce=Ae),s.set(le,Ce),Ce}function i(le){return T(le)||y(le)||u(le)}function a(le,Ce){return Ce.length===0?Ce=[le]:le.end===Ce[0].start?Ce[0].start=le.start:Ce.unshift(le),Ce}function h(le,Ce){for(let Ae=Ce;Ae<le.length;Ae++){const Ue=le.charCodeAt(Ae);if(y(Ue)||u(Ue)||Ae>0&&!i(le.charCodeAt(Ae-1)))return Ae}return le.length}function t(le,Ce,Ae,Ue){if(Ae===le.length)return[];if(Ue===Ce.length)return null;if(le[Ae]!==Ce[Ue].toLowerCase())return null;{let j=null,z=Ue+1;for(j=t(le,Ce,Ae+1,Ue+1);!j&&(z=h(Ce,z))<Ce.length;)j=t(le,Ce,Ae+1,z),z++;return j===null?null:a({start:Ue,end:Ue+1},j)}}function v(le){let Ce=0,Ae=0,Ue=0,j=0,z=0;for(let Oe=0;Oe<le.length;Oe++)z=le.charCodeAt(Oe),y(z)&&Ce++,T(z)&&Ae++,i(z)&&Ue++,u(z)&&j++;const G=Ce/le.length,H=Ae/le.length,ee=Ue/le.length,se=j/le.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function c(le){const{upperPercent:Ce,lowerPercent:Ae}=le;return Ae===0&&Ce>.6}function $(le){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Ue,numericPercent:j}=le;return Ae>.2&&Ce<.8&&Ue>.6&&j<.2}function b(le){let Ce=0,Ae=0,Ue=0,j=0;for(let z=0;z<le.length;z++)Ue=le.charCodeAt(z),y(Ue)&&Ce++,T(Ue)&&Ae++,w(Ue)&&j++;return(Ce===0||Ae===0)&&j===0?le.length<=30:Ce<=5}function p(le,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!b(le))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=v(Ce);if(!$(Ae)){if(!c(Ae))return null;Ce=Ce.toLowerCase()}let Ue=null,j=0;for(le=le.toLowerCase();j<Ce.length&&(Ue=t(le,Ce,0,j))===null;)j=h(Ce,j+1);return Ue}function l(le,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Ue=null,j=0;for(le=le.toLowerCase(),Ce=Ce.toLowerCase();j<Ce.length&&(Ue=D(le,Ce,0,j,Ae),Ue===null);)j=g(Ce,j+1);return Ue}function D(le,Ce,Ae,Ue,j){let z=0;if(Ae===le.length)return[];if(Ue===Ce.length)return null;if(!o(le.charCodeAt(Ae),Ce.charCodeAt(Ue))){const ee=r(le.charCodeAt(Ae));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],Ce.charCodeAt(Ue+se)))return null;z+=ee.length-1}let G=null,H=Ue+z+1;if(G=D(le,Ce,Ae+1,H,j),!j)for(;!G&&(H=g(Ce,H))<Ce.length;)G=D(le,Ce,Ae+1,H,j),H++;if(!G)return null;if(le.charCodeAt(Ae)!==Ce.charCodeAt(Ue)){const ee=r(le.charCodeAt(Ae));if(!ee)return G;for(let se=0;se<ee.length;se++)if(ee[se]!==Ce.charCodeAt(Ue+se))return G}return a({start:Ue,end:Ue+z+1},G)}function g(le,Ce){for(let Ae=Ce;Ae<le.length;Ae++)if(n(le.charCodeAt(Ae))||Ae>0&&n(le.charCodeAt(Ae-1)))return Ae;return le.length}const S=N(e.$pk,p,d),k=N(e.$pk,p,f),P=new I.$Ec(1e4);function C(le,Ce,Ae=!1){if(typeof le!="string"||typeof Ce!="string")return null;let Ue=P.get(le);Ue||(Ue=new RegExp(R.$_e(le),"i"),P.set(le,Ue));const j=Ue.exec(Ce);return j?[{start:j.index,end:j.index+j[0].length}]:Ae?k(le,Ce):S(le,Ce)}function W(le,Ce){const Ae=pe(le,le.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function V(le,Ce,Ae,Ue,j,z){const G=Math.min(13,le.length);for(;Ae<G;Ae++){const H=pe(le,Ce,Ae,Ue,j,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,z]}function q(le){if(typeof le>"u")return[];const Ce=[],Ae=le[1];for(let Ue=le.length-1;Ue>1;Ue--){const j=le[Ue]+Ae,z=Ce[Ce.length-1];z&&z.end===j?z.end=j+1:Ce.push({start:j,end:j+1})}return Ce}const A=128;function U(){const le=[],Ce=[];for(let Ae=0;Ae<=A;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=A;Ae++)le.push(Ce.slice(0));return le}function K(le){const Ce=[];for(let Ae=0;Ae<=le;Ae++)Ce[Ae]=0;return Ce}const ie=K(2*A),fe=K(2*A),Se=U(),ke=U(),oe=U(),$e=!1;function ne(le,Ce,Ae,Ue,j){function z(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let G=` |   |${Ue.split("").map(H=>z(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=le[H].slice(0,j+1).map(ee=>z(ee.toString(),3)).join("|")+`
`;return G}function Ie(le,Ce,Ae,Ue){le=le.substr(Ce),Ae=Ae.substr(Ue),console.log(ne(ke,le,le.length,Ae,Ae.length)),console.log(ne(oe,le,le.length,Ae,Ae.length)),console.log(ne(Se,le,le.length,Ae,Ae.length))}function ze(le,Ce){if(Ce<0||Ce>=le.length)return!1;const Ae=le.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Jf(Ae)}}function re(le,Ce){if(Ce<0||Ce>=le.length)return!1;switch(le.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function L(le,Ce,Ae){return Ce[le]!==Ae[le]}function _(le,Ce,Ae,Ue,j,z,G=!1){for(;Ce<Ae&&j<z;)le[Ce]===Ue[j]&&(G&&(ie[Ce]=j),Ce+=1),j+=1;return Ce===Ae}var ve;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Te;(function(le){le.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}le.isDefault=Ce})(Te||(e.FuzzyScore=Te={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$Ak=Ee;function pe(le,Ce,Ae,Ue,j,z,G=Ee.default){const H=le.length>A?A:le.length,ee=Ue.length>A?A:Ue.length;if(Ae>=H||z>=ee||H-Ae>ee-z||!_(Ce,Ae,H,j,z,ee,!0))return;de(H,ee,Ae,z,Ce,j);let se=1,Oe=1,Be=Ae,Qe=z;const Ye=[!1];for(se=1,Be=Ae;Be<H;se++,Be++){const ct=ie[Be],ft=fe[Be],je=Be+1<H?fe[Be+1]:ee;for(Oe=ct-z+1,Qe=ct;Qe<je;Oe++,Qe++){let st=Number.MIN_SAFE_INTEGER,X=!1;Qe<=ft&&(st=Q(le,Ce,Be,Ae,Ue,j,Qe,ee,z,Se[se-1][Oe-1]===0,Ye));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+ke[se-1][Oe-1]);const me=Qe>ct,qe=me?ke[se][Oe-1]+(Se[se][Oe-1]>0?-5:0):0,we=Qe>ct+1&&Se[se][Oe-1]>0,ot=we?ke[se][Oe-2]+(Se[se][Oe-2]>0?-5:0):0;if(we&&(!me||ot>=qe)&&(!X||ot>=Z))ke[se][Oe]=ot,oe[se][Oe]=3,Se[se][Oe]=0;else if(me&&(!X||qe>=Z))ke[se][Oe]=qe,oe[se][Oe]=2,Se[se][Oe]=0;else if(X)ke[se][Oe]=Z,oe[se][Oe]=1,Se[se][Oe]=Se[se-1][Oe-1]+1;else throw new Error("not possible")}}if($e&&Ie(le,Ae,Ue,z),!Ye[0]&&!G.firstMatchCanBeWeak)return;se--,Oe--;const et=[ke[se][Oe],z];let at=0,it=0;for(;se>=1;){let ct=Oe;do{const ft=oe[se][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);at>1&&Ce[Ae+se-1]===j[z+Oe-1]&&!L(ct+z-1,Ue,j)&&at+1>Se[se][ct]&&(ct=Oe),ct===Oe?at++:at=1,it||(it=ct),se--,Oe=ct-1,et.push(Oe)}ee===H&&G.boostFullMatch&&(et[0]+=2);const tt=it-H;return et[0]-=tt,et}function de(le,Ce,Ae,Ue,j,z){let G=le-1,H=Ce-1;for(;G>=Ae&&H>=Ue;)j[G]===z[H]&&(fe[G]=H,G--),H--}function Q(le,Ce,Ae,Ue,j,z,G,H,ee,se,Oe){if(Ce[Ae]!==z[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Ae-Ue?Be=le[Ae]===j[G]?7:5:L(G,j,z)&&(G===0||!L(G-1,j,z))?(Be=le[Ae]===j[G]?7:5,Qe=!0):ze(z,G)&&(G===0||!ze(z,G-1))?Be=5:(ze(z,G-1)||re(z,G-1))&&(Be=5,Qe=!0),Be>1&&Ae===Ue&&(Oe[0]=!0),Qe||(Qe=L(G,j,z)||ze(z,G-1)||re(z,G-1)),Ae===Ue?G>ee&&(Be-=Qe?3:5):se?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function Y(le,Ce,Ae,Ue,j,z,G){return he(le,Ce,Ae,Ue,j,z,!0,G)}function ue(le,Ce,Ae,Ue,j,z,G){return he(le,Ce,Ae,Ue,j,z,!1,G)}function he(le,Ce,Ae,Ue,j,z,G,H){let ee=pe(le,Ce,Ae,Ue,j,z,H);if(ee&&!G)return ee;if(le.length>=3){const se=Math.min(7,le.length-1);for(let Oe=Ae+1;Oe<se;Oe++){const Be=Ne(le,Oe);if(Be){const Qe=pe(Be,Be.toLowerCase(),Ae,Ue,j,z,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Ne(le,Ce){if(Ce+1>=le.length)return;const Ae=le[Ce],Ue=le[Ce+1];if(Ae!==Ue)return le.slice(0,Ce)+Ue+Ae+le.slice(Ce+2)}}),define(Pe[32],Re([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const N="error",M="warning",d="warn",f="info",E="ignore";function T(u){return u?I.$qf(N,u)?R.Error:I.$qf(M,u)||I.$qf(d,u)?R.Warning:I.$qf(f,u)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function y(u){switch(u){case R.Error:return N;case R.Warning:return M;case R.Info:return f;default:return E}}R.toString=y}(O||(O={})),e.default=O}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(Pe[52],Re([1,0,18,15]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),n=this.b.charCodeAt(this.c);return m-n}value(){return this.b[this.c]}}e.$pi=R;class N{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,O.$kf)(w,this.b,0,w.length,this.c,this.d):(0,O.$mf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qi=N;class M{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const n=this.b.charCodeAt(m);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,O.$kf)(w,this.b,0,w.length,this.d,this.e):(0,O.$mf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ri=M;var d;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(d||(d={}));class f{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,O.$lf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,O.$lf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,O.$jf)(w,this.c.query);if(this.d[this.e]===5)return(0,O.$jf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$si=f;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(T||(T={}));class y{static forUris(w=()=>!1,m=()=>!1){return new y(new f(w,m))}static forPaths(w=!1){return new y(new M(void 0,!w))}static forStrings(){return new y(new R)}static forConfigKeys(){return new y(new N)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const n=m.slice(0);(0,I.$Xb)(n);for(const o of n)this.set(o,w)}else{const n=w.slice(0);(0,I.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(w,m){const n=this.b.reset(w);let o;this.c||(this.c=new E,this.c.segment=n.value());const s=[];for(o=this.c;;){const i=n.cmp(o.segment);if(i>0)o.left||(o.left=new E,o.left.segment=n.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new E,o.right.segment=n.value()),s.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new E,o.mid.segment=n.value()),s.push([0,o]),o=o.mid;else break}const r=o.value;o.value=m,o.key=w;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],v=s[i+1][0];if(t===1&&v===1)s[i][1]=a.rotateLeft();else if(t===-1&&v===-1)s[i][1]=a.rotateRight();else if(t===1&&v===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&v===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return r}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let n=this.c;for(;n;){const o=m.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(m.hasNext())m.next(),n=n.mid;else break}return n}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const n=this.b.reset(w),o=[];let s=this.c;for(;s;){const r=n.cmp(s.segment);if(r>0)o.push([-1,s]),s=s.left;else if(r<0)o.push([1,s]),s=s.right;else if(n.hasNext())n.next(),o.push([0,s]),s=s.mid;else break}if(s){if(m?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const r=this.f(s.right);if(r.key){const{key:i,value:a,segment:h}=r;this.e(r.key,!1),s.key=i,s.value=a,s.segment=h}}else{const r=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const i=o[r][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[r][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[r][1]=i.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let n=this.c,o;for(;n;){const s=m.cmp(n.segment);if(s>0)n=n.left;else if(s<0)n=n.right;else if(m.hasNext())m.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(w){return this.g(w,!1)}g(w,m){const n=this.b.reset(w);let o=this.c;for(;o;){const s=n.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[m,n]of this)w(n,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const m=[];return this.j(w,m),m[Symbol.iterator]()}j(w,m){w&&(w.left&&this.j(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.j(w.mid,m),w.right&&this.j(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const n=m.balanceFactor();return n<-1||n>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.$ti=y}),define(Pe[41],Re([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Nj=R;var O;(function(M){function d(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=d})(O||(e.ThemeColor=O={}));function R(M){return{id:M}}var N;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(r){const i=d.exec(r.id);if(!i)return f(I.$Mj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}M.asClassNameArray=f;function E(r){return f(r).join(" ")}M.asClassName=E;function T(r){return"."+f(r).join(".")}M.asCSSSelector=T;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||O.isThemeColor(r.color))}M.isThemeIcon=y;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function w(r){const i=u.exec(r);if(!i)return;const[,a]=i;return{id:a}}M.fromString=w;function m(r){return{id:r}}M.fromId=m;function n(r,i){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}M.modify=n;function o(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}M.getModifier=o;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}M.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Pe[131],Re([1,0,129,15,41]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=f,e.$Fk=T,e.$Gk=u,e.$Hk=w,e.$Ik=n,e.$Jk=o;const N="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),d=new RegExp(`(\\\\)?${M.source}`,"g");function f(s){return s.replace(d,(r,i)=>i?r:`\\${r}`)}const E=new RegExp(`\\\\${M.source}`,"g");function T(s){return s.replace(E,r=>`\\${r}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(s){return s.indexOf(N)===-1?s:s.replace(y,(r,i,a,h)=>a?r:i||h||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(r,i)=>` ${i} `).trim():""}const m=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(s){m.lastIndex=0;let r="";const i=[];let a=0;for(;;){const h=m.lastIndex,t=m.exec(s),v=s.substring(h,t?.index);if(v.length>0){r+=v;for(let c=0;c<v.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:r,iconOffsets:i}}function o(s,r,i=!1){const{text:a,iconOffsets:h}=r;if(!h||h.length===0)return(0,I.$vk)(s,a,i);const t=(0,O.$0e)(a," "),v=a.length-t.length,c=(0,I.$vk)(s,t,i);if(c)for(const $ of c){const b=h[$.start+v]+v;$.start+=b,$.end+=b}return c}}),define(Pe[35],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=void 0,e.$Ig=O;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return I.test(R)}e.$Jg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(d){for(let f=0;f<d.length;f++)d[f]=Math.floor(Math.random()*256);return d};const N=new Uint8Array(16),M=[];for(let d=0;d<256;d++)M.push(d.toString(16).padStart(2,"0"));return function(){R(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let f=0,E="";return E+=M[N[f++]],E+=M[N[f++]],E+=M[N[f++]],E+=M[N[f++]],E+="-",E+=M[N[f++]],E+=M[N[f++]],E+="-",E+=M[N[f++]],E+=M[N[f++]],E+="-",E+=M[N[f++]],E+=M[N[f++]],E+="-",E+=M[N[f++]],E+=M[N[f++]],E+=M[N[f++]],E+=M[N[f++]],E+=M[N[f++]],E+=M[N[f++]],E}}()}),define(Pe[132],Re([1,0,18,46,35]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Ft=void 0,e.$Dt=N,e.$Et=M,e.$Gt=E;function N(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,u,w){const m={id:(0,R.$Jg)(),name:y,uri:u,data:w};return{asString:async()=>"",asFile:()=>m,value:void 0}}class d{constructor(){this.a=new Map}get size(){let u=0;for(const w of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const w=[...this.a.keys()];return O.Iterable.some(this,([m,n])=>n.asFile())&&w.push("files"),T(f(u),w)}get(u){return this.a.get(this.b(u))?.[0]}append(u,w){const m=this.a.get(u);m?m.push(w):this.a.set(this.b(u),[w])}replace(u,w){this.a.set(this.b(u),[w])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,w]of this.a)for(const m of w)yield[u,m]}b(u){return f(u)}}e.$Ft=d;function f(y){return y.toLowerCase()}function E(y,u){return T(f(y),u.map(f))}function T(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const w=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[m,n,o]=w;return o==="*"?u.some(s=>s.startsWith(n+"/")):!1}e.$Ht=Object.freeze({create:y=>(0,I.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Ht.split(y).filter(u=>!u.startsWith("#"))})}),define(Pe[133],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=O;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function O(R){let N=0,M=0,d=0,f=0;for(let E=0,T=R.length;E<T;E++){const y=R.charCodeAt(E);y===13?(N===0&&(M=E),N++,E+1<T&&R.charCodeAt(E+1)===10?(f|=2,E++):f|=3,d=E+1):y===10&&(f|=1,N===0&&(M=E),N++,d=E+1)}return N===0&&(M=R.length),[N,M,R.length-d,f]}}),define(Pe[134],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0,e.$Rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[135],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(d){if(this.e=null,this.f=!1,this.open=d.open,this.close=d.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(d.notIn))for(let f=0,E=d.notIn.length;f<E;f++)switch(d.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(d){switch(d){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(d,f){if(d.getTokenCount()===0)return!0;const E=d.findTokenIndexAtOffset(f-2),T=d.getStandardTokenType(E);return this.isOK(T)}g(d,f){for(let E=d;E<=f;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$0t=O;class R{constructor(d){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of d)N(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),N(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),N(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),N(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&N(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$$t=R;function N(M,d,f){M.has(d)?M.get(d).push(f):M.set(d,[f])}}),define(Pe[136],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.NodeColor=e.$nC=void 0,e.$pC=R,e.$qC=N,e.$rC=E,e.$sC=T,e.$tC=y,e.$uC=u,e.$vC=w,e.$wC=m;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oC)return R(this.right);let o=this;for(;o.parent!==e.$oC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$oC?e.$oC:o.parent}prev(){if(this.left!==e.$oC)return N(this.left);let o=this;for(;o.parent!==e.$oC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$oC?e.$oC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nC=I;var O;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$oC=new I(null,0),e.$oC.parent=e.$oC,e.$oC.left=e.$oC,e.$oC.right=e.$oC,e.$oC.color=0;function R(n){for(;n.left!==e.$oC;)n=n.left;return n}function N(n){for(;n.right!==e.$oC;)n=n.right;return n}function M(n){return n===e.$oC?0:n.size_left+n.piece.length+M(n.right)}function d(n){return n===e.$oC?0:n.lf_left+n.piece.lineFeedCnt+d(n.right)}function f(){e.$oC.parent=e.$oC}function E(n,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$oC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$oC?n.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function T(n,o){const s=o.left;o.left=s.right,s.right!==e.$oC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$oC?n.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function y(n,o){let s,r;if(o.left===e.$oC?(r=o,s=r.right):o.right===e.$oC?(r=o,s=r.left):(r=R(o.right),s=r.right),r===n.root){n.root=s,s.color=0,o.detach(),f(),n.root.parent=e.$oC;return}const i=r.color===1;if(r===r.parent.left?r.parent.left=s:r.parent.right=s,r===o?(s.parent=r.parent,m(n,s)):(r.parent===o?s.parent=r:s.parent=r.parent,m(n,s),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$oC&&(r.left.parent=r),r.right!==e.$oC&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,m(n,r)),o.detach(),s.parent.left===s){const h=M(s),t=d(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const v=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,w(n,s.parent,v,c)}}if(m(n,s.parent),i){f();return}let a;for(;s!==n.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,E(n,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,T(n,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,E(n,s.parent),s=n.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,T(n,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(n,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,T(n,s.parent),s=n.root));s.color=0,f()}function u(n,o){for(m(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(n,o)),o.parent.color=0,o.parent.parent.color=1,T(n,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(n,o)),o.parent.color=0,o.parent.parent.color=1,E(n,o.parent.parent))}n.root.color=0}function w(n,o,s,r){for(;o!==n.root&&o!==e.$oC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}function m(n,o){let s=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,s=M(o.left)-o.size_left,r=d(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=r;o!==n.root&&(s!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}}}),define(Pe[92],Re([1,0,93,29,94,136,95]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.$GC=e.$FC=void 0,e.$DC=T,e.$EC=y;const d=65535;function f(s){let r;return s[s.length-1]<65536?r=new Uint16Array(s.length):r=new Uint32Array(s.length),r.set(s,0),r}class E{constructor(r,i,a,h,t){this.lineStarts=r,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function T(s,r=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const v=s.charCodeAt(h);v===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:v===10&&(i[a++]=h+1)}return r?f(i):i}function y(s,r){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,v=!0;for(let $=0,b=r.length;$<b;$++){const p=r.charCodeAt($);p===13?$+1<b&&r.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):p===10?(h++,s[i++]=$+1):v&&p!==9&&(p<32||p>126)&&(v=!1)}const c=new E(f(s),a,h,t,v);return s.length=0,c}class u{constructor(r,i,a,h,t){this.bufferIndex=r,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$FC=u;class w{constructor(r,i){this.buffer=r,this.lineStarts=i}}e.$GC=w;class m{constructor(r,i){this.a=[],this.c=r,this.d=i,this.b=0,r.root!==N.$oC&&r.iterate(r.root,a=>(a!==N.$oC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(r){this.a=r,this.b=[]}get(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=r){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(r,i,a){this.create(r,i,a)}create(r,i,a){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=N.$oC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,v=r.length;t<v;t++)if(r[t].buffer.length>0){r[t].lineStarts||(r[t].lineStarts=T(r[t].buffer));const c=new u(t+1,{line:0,column:0},{line:r[t].lineStarts.length-1,column:r[t].buffer.length-r[t].lineStarts[r[t].lineStarts.length-1]},r[t].lineStarts.length-1,r[t].buffer.length);this.a.push(r[t]),h=this.S(h,c)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const i=d,a=i-Math.floor(i/3),h=a*2;let t="",v=0;const c=[];if(this.iterate(this.root,$=>{const b=this.R($),p=b.length;if(v<=a||v+p<h)return t+=b,v+=p,!0;const l=t.replace(/\r\n|\r|\n/g,r);return c.push(new w(l,T(l))),t=b,v=p,!0}),v>0){const $=t.replace(/\r\n|\r|\n/g,r);c.push(new w($,T($)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new m(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$oC)return!0;const t=this.R(h),v=t.length,c=r.G(i),$=r.G(i+v),b=r.getValueInRange2(c,$);return i+=v,t===b})}getOffsetAt(r,i){let a=0,h=this.root;for(;h!==N.$oC;)if(h.left!==N.$oC&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){a+=h.size_left;const t=this.B(h,r-h.lf_left-2);return a+=t+i-1}else r-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let i=this.root,a=0;const h=r;for(;i!==N.$oC;)if(i.size_left!==0&&i.size_left>=r)i=i.left;else if(i.size_left+i.piece.length>=r){const t=this.A(i,r-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const v=this.getOffsetAt(a+1,1),c=h-v;return new I.$gt(a+1,c+1)}return new I.$gt(a+1,t.remainder+1)}else if(r-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$oC){const t=this.getOffsetAt(a+1,1),v=h-r-t;return new I.$gt(a+1,v+1)}else i=i.right;return new I.$gt(1,1)}getValueInRange(r,i){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(r,i){if(r.node===i.node){const c=r.node,$=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(b+r.remainder,b+i.remainder)}let a=r.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let v=h.substring(t+r.remainder,t+a.piece.length);for(a=a.next();a!==N.$oC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){v+=c.substring($,$+i.remainder);break}else v+=c.substr($,a.piece.length);a=a.next()}return v}getLinesContent(){const r=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===N.$oC)return!0;const v=t.piece;let c=v.length;if(c===0)return!0;const $=this.a[v.bufferIndex].buffer,b=this.a[v.bufferIndex].lineStarts,p=v.start.line,l=v.end.line;let D=b[p]+v.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),r[i++]=a,a="",h=!1,c===0))return!0;if(p===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,b[p+1]-this.e)):$.substring(D,b[p+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;for(let g=p+1;g<l;g++)a=this.f?$.substring(b[g],b[g+1]-this.e):$.substring(b[g],b[g+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;return!this.f&&$.charCodeAt(b[l]+v.end.column-1)===13?(h=!0,v.end.column===0?i--:a=$.substr(b[l],v.end.column-1)):a=$.substr(b[l],v.end.column),!0}),h&&(r[i++]=a,a=""),r[i++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const i=r.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(r,i){const a=this.H(r,i+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const i=this.getOffsetAt(r,1);return this.getLength()-i}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const i=this.G(r);return this.l(i)}findMatchesInNode(r,i,a,h,t,v,c,$,b,p,l){const D=this.a[r.piece.bufferIndex],g=this.u(r.piece.bufferIndex,r.piece.start),S=this.u(r.piece.bufferIndex,t),k=this.u(r.piece.bufferIndex,v);let P;const C={line:0,column:0};let W,V;i._wordSeparators?(W=D.buffer.substring(S,k),V=q=>q+S,i.reset(0)):(W=D.buffer,V=q=>q,i.reset(S));do if(P=i.next(W),P){if(V(P.index)>=k)return p;this.s(r,V(P.index)-g,C);const q=this.t(r.piece.bufferIndex,t,C),A=C.line===t.line?C.column-t.column+h:C.column+1,U=A+P[0].length;if(l[p++]=(0,M.$zC)(new O.$ht(a+q,A,a+q,U),P,$),V(P.index)+P[0].length>=k||p>=b)return p}while(P);return p}findMatchesLineByLine(r,i,a,h){const t=[];let v=0;const c=new M.$CC(i.wordSeparators,i.regex);let $=this.H(r.startLineNumber,r.startColumn);if($===null)return[];const b=this.H(r.endLineNumber,r.endColumn);if(b===null)return[];let p=this.s($.node,$.remainder);const l=this.s(b.node,b.remainder);if($.node===b.node)return this.findMatchesInNode($.node,c,r.startLineNumber,r.startColumn,p,l,i,a,h,v,t),t;let D=r.startLineNumber,g=$.node;for(;g!==b.node;){const k=this.t(g.piece.bufferIndex,p,g.piece.end);if(k>=1){const C=this.a[g.piece.bufferIndex].lineStarts,W=this.u(g.piece.bufferIndex,g.piece.start),V=C[p.line+k],q=D===r.startLineNumber?r.startColumn:1;if(v=this.findMatchesInNode(g,c,D,q,p,this.s(g,V-W),i,a,h,v,t),v>=h)return t;D+=k}const P=D===r.startLineNumber?r.startColumn-1:0;if(D===r.endLineNumber){const C=this.getLineContent(D).substring(P,r.endColumn-1);return v=this.n(i,c,C,r.endLineNumber,P,v,t,a,h),t}if(v=this.n(i,c,this.getLineContent(D).substr(P),D,P,v,t,a,h),v>=h)return t;D++,$=this.H(D,1),g=$.node,p=this.s($.node,$.remainder)}if(D===r.endLineNumber){const k=D===r.startLineNumber?r.startColumn-1:0,P=this.getLineContent(D).substring(k,r.endColumn-1);return v=this.n(i,c,P,r.endLineNumber,k,v,t,a,h),t}const S=D===r.startLineNumber?r.startColumn:1;return v=this.findMatchesInNode(b.node,c,D,S,p,l,i,a,h,v,t),t}n(r,i,a,h,t,v,c,$,b){const p=r.wordSeparators;if(!$&&r.simpleSearch){const D=r.simpleSearch,g=D.length,S=a.length;let k=-g;for(;(k=a.indexOf(D,k+g))!==-1;)if((!p||(0,M.$BC)(p,a,S,k,g))&&(c[v++]=new R.$sv(new O.$ht(h,k+1+t,h,k+1+g+t),null),v>=b))return v;return v}let l;i.reset(0);do if(l=i.next(a),l&&(c[v++]=(0,M.$zC)(new O.$ht(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),v>=b))return v;while(l);return v}insert(r,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==N.$oC){const{node:h,remainder:t,nodeStartOffset:v}=this.G(r),c=h.piece,$=c.bufferIndex,b=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&v+c.length===r&&i.length<d){this.F(h,i),this.y();return}if(v===r)this.o(i,h),this.h.validate(r);else if(v+h.piece.length>r){const p=[];let l=new u(c.bufferIndex,b,c.end,this.t(c.bufferIndex,b,c.end),this.u($,c.end)-this.u($,b));if(this.K()&&this.M(i)&&this.I(h,t)===10){const k={line:l.start.line+1,column:0};l=new u(l.bufferIndex,k,l.end,this.t(l.bufferIndex,k,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const k=this.s(h,t-1);this.C(h,k),i="\r"+i,h.piece.length===0&&p.push(h)}else this.C(h,b);else this.C(h,b);const D=this.w(i);l.length>0&&this.S(h,l);let g=h;for(let S=0;S<D.length;S++)g=this.S(g,D[S]);this.v(p)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let v=1;v<h.length;v++)t=this.S(t,h[v])}this.y()}delete(r,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$oC)return;const a=this.G(r),h=this.G(r+i),t=a.node,v=h.node;if(t===v){const D=this.s(t,a.remainder),g=this.s(t,h.remainder);if(a.nodeStartOffset===r){if(i===t.piece.length){const S=t.next();(0,N.$tC)(this,t),this.N(S),this.y();return}this.D(t,g),this.h.validate(r),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===r+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,g),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(r),t.piece.length===0&&c.push(t);const b=this.s(v,h.remainder);this.D(v,b),v.piece.length===0&&c.push(v);const p=t.next();for(let D=p;D!==N.$oC&&D!==v;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(r,i){const a=[];if(this.K()&&this.M(r)&&this.L(i)){const v=i.piece,c={line:v.start.line+1,column:0},$=new u(v.bufferIndex,c,v.end,this.t(v.bufferIndex,c,v.end),v.length-1);i.piece=$,r+=`
`,(0,N.$vC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(r);let t=this.T(i,h[h.length-1]);for(let v=h.length-2;v>=0;v--)t=this.T(t,h[v]);this.N(t),this.v(a)}q(r,i){this.Q(r,i)&&(r+=`
`);const a=this.w(r),h=this.S(i,a[0]);let t=h;for(let v=1;v<a.length;v++)t=this.S(t,a[v]);this.N(h)}s(r,i,a){const h=r.piece,t=r.piece.bufferIndex,v=this.a[t].lineStarts,$=v[h.start.line]+h.start.column+i;let b=h.start.line,p=h.end.line,l=0,D=0,g=0;for(;b<=p&&(l=b+(p-b)/2|0,g=v[l],l!==p);)if(D=v[l+1],$<g)p=l-1;else if($>=D)b=l+1;else break;return a?(a.line=l,a.column=$-g,null):{line:l,column:$-g}}t(r,i,a){if(a.column===0)return a.line-i.line;const h=this.a[r].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],v=h[a.line]+a.column;if(t>v+1)return a.line-i.line;const c=v-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(r,i){return this.a[r].lineStarts[i.line]+i.column}v(r){for(let i=0;i<r.length;i++)(0,N.$tC)(this,r[i])}w(r){if(r.length>d){const p=[];for(;r.length>d;){const D=r.charCodeAt(d-1);let g;D===13||D>=55296&&D<=56319?(g=r.substring(0,d-1),r=r.substring(d-1)):(g=r.substring(0,d),r=r.substring(d));const S=T(g);p.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:g.length-S[S.length-1]},S.length-1,g.length)),this.a.push(new w(g,S))}const l=T(r);return p.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:r.length-l[l.length-1]},l.length-1,r.length)),this.a.push(new w(r,l)),p}let i=this.a[0].buffer.length;const a=T(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,i+=1}else{if(i!==0)for(let p=0;p<a.length;p++)a[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const t=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[v],$={line:v,column:c},b=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,i=0){let a=this.root,h="";const t=this.h.get2(r);if(t){a=t.node;const v=this.B(a,r-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===r)h=c.substring($+v,$+a.piece.length);else{const b=this.B(a,r-t.nodeStartLineNumber);return c.substring($+v,$+b-i)}}else{let v=0;const c=r;for(;a!==N.$oC;)if(a.left!==N.$oC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const $=this.B(a,r-a.lf_left-2),b=this.B(a,r-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this.h.set({node:a,nodeStartOffset:v,nodeStartLineNumber:c-(r-1-a.lf_left)}),p.substring(l+$,l+b-i)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const $=this.B(a,r-a.lf_left-2),b=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=b.substring(p+$,p+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==N.$oC;){const v=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=v.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=v.substr(c,a.piece.length)}a=a.next()}return h}y(){let r=this.root,i=1,a=0;for(;r!==N.$oC;)i+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=i,this.c=a,this.h.validate(this.c)}A(r,i){const a=r.piece,h=this.s(r,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const v=this.t(r.piece.bufferIndex,a.start,h);if(v!==t)return{index:v,remainder:0}}return{index:t,remainder:h.column}}B(r,i){if(i<0)return 0;const a=r.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(r,i){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),v=i,c=this.u(a.bufferIndex,v),$=this.t(a.bufferIndex,a.start,v),b=$-h,p=c-t,l=a.length+p;r.piece=new u(a.bufferIndex,a.start,v,$,l),(0,N.$vC)(this,r,p,b)}D(r,i){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),v=i,c=this.t(a.bufferIndex,v,a.end),$=this.u(a.bufferIndex,v),b=c-h,p=t-$,l=a.length+p;r.piece=new u(a.bufferIndex,v,a.end,c,l),(0,N.$vC)(this,r,p,b)}E(r,i,a){const h=r.piece,t=h.start,v=h.end,c=h.length,$=h.lineFeedCnt,b=i,p=this.t(h.bufferIndex,h.start,b),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);r.piece=new u(h.bufferIndex,h.start,b,p,l),(0,N.$vC)(this,r,l-c,p-$);const D=new u(h.bufferIndex,a,v,this.t(h.bufferIndex,a,v),this.u(h.bufferIndex,v)-this.u(h.bufferIndex,a)),g=this.S(r,D);this.N(g)}F(r,i){this.Q(i,r)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let g=0;g<t.length;g++)t[g]+=h;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const v=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[v],$={line:v,column:c},b=r.piece.length+i.length,p=r.piece.lineFeedCnt,l=this.t(0,r.piece.start,$),D=l-p;r.piece=new u(r.piece.bufferIndex,r.piece.start,$,l,b),this.g=$,(0,N.$vC)(this,r,i.length,D)}G(r){let i=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let h=0;for(;i!==N.$oC;)if(i.size_left>r)i=i.left;else if(i.size_left+i.piece.length>=r){h+=i.size_left;const t={node:i,remainder:r-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else r-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(r,i){let a=this.root,h=0;for(;a!==N.$oC;)if(a.left!==N.$oC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const t=this.B(a,r-a.lf_left-2),v=this.B(a,r-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,v),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const t=this.B(a,r-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else r-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==N.$oC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),v=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:v}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(r,i){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+i;return a.buffer.charCodeAt(h)}J(r){if(!r)return 0;let i=r.size_left;for(;r!==this.root;)r.parent.right===r&&(i+=r.parent.size_left+r.parent.piece.length),r=r.parent;return i}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===N.$oC||r.piece.lineFeedCnt===0)return!1;const i=r.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===N.$oC||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const i=r.prev();this.M(i)&&this.P(i,r)}}O(r){if(this.K()&&this.M(r)){const i=r.next();this.L(i)&&this.P(r,i)}}P(r,i){const a=[],h=this.a[r.piece.bufferIndex].lineStarts;let t;r.piece.end.column===0?t={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:t={line:r.piece.end.line,column:r.piece.end.column-1};const v=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,t,c,v),(0,N.$vC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const $={line:i.piece.start.line+1,column:0},b=i.piece.length-1,p=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,p,b),(0,N.$vC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(r,l[0]);for(let D=0;D<a.length;D++)(0,N.$tC)(this,a[D])}Q(r,i){if(this.K()&&this.M(r)){const a=i.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,N.$tC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},v=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,v),(0,N.$vC)(this,a,-1,-1)}return!0}}return!1}iterate(r,i){if(r===N.$oC)return i(N.$oC);const a=this.iterate(r.left,i);return a&&i(r)&&this.iterate(r.right,i)}R(r){if(r===N.$oC)return"";const i=this.a[r.piece.bufferIndex],a=r.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(r){const i=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return i.buffer.substring(a,h)}S(r,i){const a=new N.$nC(i,1);if(a.left=N.$oC,a.right=N.$oC,a.parent=N.$oC,a.size_left=0,a.lf_left=0,this.root===N.$oC)this.root=a,a.color=0;else if(r.right===N.$oC)r.right=a,a.parent=r;else{const t=(0,N.$pC)(r.right);t.left=a,a.parent=t}return(0,N.$uC)(this,a),a}T(r,i){const a=new N.$nC(i,1);if(a.left=N.$oC,a.right=N.$oC,a.parent=N.$oC,a.size_left=0,a.lf_left=0,this.root===N.$oC)this.root=a,a.color=0;else if(r.left===N.$oC)r.left=a,a.parent=r;else{const h=(0,N.$qC)(r.left);h.right=a,a.parent=h}return(0,N.$uC)(this,a),a}U(r){let i="";return this.iterate(r,a=>(i+=this.R(a),!0)),i}}e.$HC=o}),define(Pe[137],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t0=e.$s0=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const M=this.a.get(N);return this.a.delete(N),M}}addDragOperationTransfer(N,M){this.a.set(N,M)}}e.$s0=I;class O{constructor(N){this.identifier=N}}e.$t0=O}),define(Pe[138],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[139],Re([1,0,5,6,138]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0,e.$0i=T;class N extends O.$Uc{constructor(u,w="",m="",n=!0,o){super(),this.h=this.B(new I.$_d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=w,this.u=m,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,w){this.C&&await this.C(u)}}e.$5i=N;class M extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$_d),this.onWillRun=this.f.event,this.m=this.B(new I.$_d),this.onDidRun=this.m.event}async run(u,w){if(!u.enabled)return;this.f.fire({action:u});let m;try{await this.u(u,w)}catch(n){m=n}this.m.fire({action:u,error:m})}async u(u,w){await u.run(w)}}e.$6i=M;class d{constructor(){this.id=d.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let w=[];for(const m of u)m.length&&(w.length?w=[...w,new d,...m]:w=m);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$7i=d;class f{get actions(){return this.a}constructor(u,w,m,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=w,this.class=n,this.a=m}async run(){}}e.$8i=f;class E extends N{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$9i=E;function T(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u),tooltip:y.label}}}),define(Pe[140],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[141],Re([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=E,e.$Tm=T,e.$Um=y;const O=60,R=O*60,N=R*24,M=N*7,d=N*30,f=N*365;function E(u,w,m,n){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,I.localize)(1,null);let s;return o<O?(s=o,w?s===1?m?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):m?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?m?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):m?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<R?(s=Math.floor(o/O),w?s===1?m?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):m?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?m?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):m?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<N?(s=Math.floor(o/R),w?s===1?m?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):m?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?m?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):m?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<M?(s=Math.floor(o/N),w?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<d?(s=Math.floor(o/M),w?s===1?m?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):m?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?m?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):m?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<f?(s=Math.floor(o/d),w?s===1?m?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):m?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?m?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):m?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/f),w?s===1?m?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):m?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?m?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):m?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function T(u,w){const m=Math.abs(u/1e3);return m<1?w?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):m<O?w?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):m<R?w?(0,I.localize)(58,null,Math.round(u/(1e3*O))):(0,I.localize)(59,null,Math.round(u/(1e3*O))):m<N?w?(0,I.localize)(60,null,Math.round(u/(1e3*R))):(0,I.localize)(61,null,Math.round(u/(1e3*R))):(0,I.localize)(62,null,Math.round(u/(1e3*N)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[142],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[42],Re([1,0,18,17,142]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=f,e.$_i=E,e.$aj=T;function N(y,u){return u&&(y.stack||y.stacktrace)?R.localize(0,null,d(y),M(y.stack)||M(y.stacktrace)):d(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function d(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?R.localize(1,null,y.message):y.message||R.localize(2,null)}function f(y=null,u=!1){if(!y)return R.localize(3,null);if(Array.isArray(y)){const w=I.$Hb(y),m=f(w[0],u);return w.length>1?R.localize(4,null,m,w.length):m}if(O.$1f(y))return y;if(y.detail){const w=y.detail;if(w.error)return N(w.error,u);if(w.exception)return N(w.exception,u)}return y.stack?N(y,u):y.message?y.message:R.localize(5,null)}function E(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function T(y,u){let w;return typeof y=="string"?w=new Error(y):w=y,w.actions=u,w}}),define(Pe[143],Re([1,0,40,19]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=d,e.$9q=f,e.$0q=E,e.$$q=T,e.$_q=y,e.$ar=u,e.$br=w,e.$cr=m,e.$dr=n,e.$er=o,e.$fr=b,e.$gr=p,e.$hr=l;const R=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),N=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function d(D,g,S=!1){const k=D||"",P=g||"",C=R.value.collator.compare(k,P);return R.value.collatorIsNumeric&&C===0&&k!==P?k<P?-1:1:C}function f(D,g){const S=N.value.collator;return D=D||"",g=g||"",a(S,D,g)}function E(D,g){const S=N.value.collator;return D=D||"",g=g||"",c(D,g)||a(S,D,g)}function T(D,g){const S=N.value.collator;return D=D||"",g=g||"",v(D,g)||a(S,D,g)}function y(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}function u(D,g){const[S,k]=r(D),[P,C]=r(g);let W=R.value.collator.compare(k,C);if(W===0){if(R.value.collatorIsNumeric&&k!==C)return k<C?-1:1;if(W=R.value.collator.compare(S,P),R.value.collatorIsNumeric&&W===0&&S!==P)return S<P?-1:1}return W}function w(D,g){D=D||"",g=g||"";const S=i(D),k=i(g),P=N.value.collator,C=M.value.collator;return a(C,S,k)||a(P,D,g)}function m(D,g){D=D||"",g=g||"";const S=i(D),k=i(g),P=N.value.collator,C=M.value.collator;return a(C,S,k)||c(D,g)||a(P,D,g)}function n(D,g){D=D||"",g=g||"";const S=i(D),k=i(g),P=N.value.collator,C=M.value.collator;return a(C,S,k)||v(D,g)||a(P,D,g)}function o(D,g){D=D||"",g=g||"";const S=i(D).toLowerCase(),k=i(g).toLowerCase();return S!==k?S<k?-1:1:D!==g?D<g?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function r(D,g=!1){const S=D?s.exec(D):[];let k=[S&&S[1]||"",S&&S[3]||""];return g&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(D){const g=D?s.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(D,g,S){const k=D.compare(g,S);return k!==0?k:g.length!==S.length?g.length<S.length?-1:1:0}function h(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function v(D,g){return h(D)&&t(g)?-1:t(D)&&h(g)?1:0}function c(D,g){return t(D)&&h(g)?-1:h(D)&&t(g)?1:0}function $(D,g,S=!1){return S||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function b(D,g,S=!1){const k=D.split(O.sep),P=g.split(O.sep),C=k.length-1,W=P.length-1;let V,q;for(let A=0;;A++){if(V=C===A,q=W===A,V&&q)return d(k[A],P[A],S);if(V)return-1;if(q)return 1;const U=$(k[A],P[A],S);if(U!==0)return U}}function p(D,g,S){const k=D.toLowerCase(),P=g.toLowerCase(),C=l(D,g,S);if(C)return C;const W=k.endsWith(S),V=P.endsWith(S);if(W!==V)return W?-1:1;const q=d(k,P);return q!==0?q:k.localeCompare(P)}function l(D,g,S){const k=D.toLowerCase(),P=g.toLowerCase(),C=k.startsWith(S),W=P.startsWith(S);if(C!==W)return C?-1:1;if(C&&W){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}}),define(Pe[47],Re([1,0,19,21,15,17]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=M,e.$hg=d,e.$ig=f,e.$jg=E,e.$kg=T,e.$lg=m,e.$mg=n,e.$ng=o,e.$og=s,e.$pg=r,e.$qg=i,e.$rg=a,e.$sg=h,e.$tg=t,e.$ug=v,e.$vg=b;function M(p){return p===47||p===92}function d(p){return p.replace(/[\\/]/g,I.$hc.sep)}function f(p){return p.indexOf("/")===-1&&(p=d(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function E(p,l=I.$hc.sep){if(!p)return"";const D=p.length,g=p.charCodeAt(0);if(M(g)){if(M(p.charCodeAt(1))&&!M(p.charCodeAt(2))){let k=3;const P=k;for(;k<D&&!M(p.charCodeAt(k));k++);if(P!==k&&!M(p.charCodeAt(k+1))){for(k+=1;k<D;k++)if(M(p.charCodeAt(k)))return p.slice(0,k+1).replace(/[\\/]/g,l)}}return l}else if(s(g)&&p.charCodeAt(1)===58)return M(p.charCodeAt(2))?p.slice(0,2)+l:p.slice(0,2);let S=p.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(M(p.charCodeAt(S)))return p.slice(0,S+1)}return""}function T(p){if(!O.$i||!p||p.length<5)return!1;let l=p.charCodeAt(0);if(l!==92||(l=p.charCodeAt(1),l!==92))return!1;let D=2;const g=D;for(;D<p.length&&(l=p.charCodeAt(D),l!==92);D++);return!(g===D||(l=p.charCodeAt(D+1),isNaN(l)||l===92))}const y=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(p,l=O.$i){const D=l?y:u;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||l&&w.test(p)||p==="."||p===".."||l&&p[p.length-1]==="."||l&&p.length!==p.trim().length||p.length>255)}function n(p,l,D){const g=p===l;return!D||g?g:!p||!l?!1:(0,R.$qf)(p,l)}function o(p,l,D,g=I.sep){if(p===l)return!0;if(!p||!l||l.length>p.length)return!1;if(D){if(!(0,R.$rf)(p,l))return!1;if(l.length===p.length)return!0;let k=l.length;return l.charAt(l.length-1)===g&&k--,p.charAt(k)===g}return l.charAt(l.length-1)!==g&&(l+=g),p.indexOf(l)===0}function s(p){return p>=65&&p<=90||p>=97&&p<=122}function r(p,l){return O.$i&&p.endsWith(":")&&(p+=I.sep),(0,I.$jc)(p)||(p=(0,I.$kc)(l,p)),p=(0,I.$ic)(p),O.$i?(p=(0,R.$$e)(p,I.sep),p.endsWith(":")&&(p+=I.sep)):(p=(0,R.$$e)(p,I.sep),p||(p=I.sep)),p}function i(p){const l=(0,I.$ic)(p);return O.$i?p.length>3?!1:a(l)&&(p.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(p,l=O.$i){return l?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function h(p,l=O.$i){return a(p,l)?p[0]:void 0}function t(p,l,D){return l.length>p.length?-1:p===l?0:(D&&(p=p.toLowerCase(),l=l.toLowerCase()),p.indexOf(l))}function v(p){const l=p.split(":");let D,g,S;for(const k of l){const P=Number(k);(0,N.$5f)(P)?g===void 0?g=P:S===void 0&&(S=P):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(p,l,D=8){let g="";for(let k=0;k<D;k++){let P;k===0&&O.$i&&!l&&(D===3||D===4)?P=$:P=c,g+=P.charAt(Math.floor(Math.random()*P.length))}let S;return l?S=`${l}-${g}`:S=g,p?(0,I.$kc)(p,S):S}}),define(Pe[69],Re([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0,e.$Fs=N,e.$Gs=M,e.$Hs=d,e.$Is=E,e.$Es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(T){const y=(0,I.$pc)(T),u=O[y.toLowerCase()];return u!==void 0?u:M(T)}function M(T){const y=(0,I.$pc)(T);return R[y.toLowerCase()]}function d(T){for(const y in R)if(R[y]===T)return y}const f=/^(.+)\/(.+?)(;.+)?$/;function E(T,y){const u=f.exec(T);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:T}}),define(Pe[53],Re([1,0,22,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=R,e.$Vh=N,e.$Wh=d;function R(f){return JSON.stringify(f,M)}function N(f){let E=JSON.parse(f);return E=d(E),E}function M(f,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function d(f,E=0){if(!f||E>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return O.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof I.$ze||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let T=0;T<f.length;++T)f[T]=d(f[T],E+1);else for(const T in f)Object.hasOwnProperty.call(f,T)&&(f[T]=d(f[T],E+1))}return f}}),define(Pe[12],Re([1,0,14,21,15,2,19]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=f,e.$xg=E,e.$Bg=y;var d;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(d||(e.Schemas=d={}));function f(m,n){return N.URI.isUri(m)?(0,R.$qf)(m.scheme,n):(0,R.$rf)(m,n+":")}function E(m,...n){return n.some(o=>f(m,o))}e.$yg="vscode-tkn",e.$zg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=y(n,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,d.vscodeRemoteResource)}set(n,o,s){this.a[n]=o,this.b[n]=s}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(h){return I.$1(h),n}const o=n.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const r=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(a+=`&${e.$zg}=${encodeURIComponent(i)}`),N.URI.from({scheme:O.$o?this.d:d.vscodeRemoteResource,authority:`${s}:${r}`,path:this.g,query:a})}}e.$Ag=new T;function y(m,n){return M.$hc.join(n??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class u{static{this.a=e.$Gg}asBrowserUri(n){const o=this.b(n,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===d.vscodeRemote?e.$Ag.rewrite(n):n.scheme===d.file&&(O.$m||O.$q===`${d.vscodeFileResource}://${u.a}`)?n.with({scheme:d.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,ge);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===d.vscodeFileResource?n.with({scheme:d.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return N.URI.isUri(n)?n:N.URI.parse(o.toUrl(n))}}e.$Hg=new u;var w;(function(m){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:N.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return n.get(h)}m.getHeadersFromQuery=s;function r(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}m.addSearchParam=r})(w||(e.COI=w={}))}),define(Pe[23],Re([1,0,47,12,19,21,15,2]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=f,e.$0g=T,e.$$g=u;function f(w){return(0,d.$xc)(w,!0)}class E{constructor(m){this.a=m}compare(m,n,o=!1){return m===n?0:(0,M.$jf)(this.getComparisonKey(m,o),this.getComparisonKey(n,o))}isEqual(m,n,o=!1){return m===n?!0:!m||!n?!1:this.getComparisonKey(m,o)===this.getComparisonKey(n,o)}getComparisonKey(m,n=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,n,o=!1){if(m.scheme===n.scheme){if(m.scheme===O.Schemas.file)return I.$ng(f(m),f(n),this.a(m))&&m.query===n.query&&(o||m.fragment===n.fragment);if((0,e.$6g)(m.authority,n.authority))return I.$ng(m.path,n.path,this.a(m),"/")&&m.query===n.query&&(o||m.fragment===n.fragment)}return!1}joinPath(m,...n){return d.URI.joinPath(m,...n)}basenameOrAuthority(m){return(0,e.$Xg)(m)||m.authority}basename(m){return R.$hc.basename(m.path)}extname(m){return R.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let n;return m.scheme===O.Schemas.file?n=d.URI.file(R.$nc(f(m))).path:(n=R.$hc.dirname(m.path),m.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),n="/")),m.with({path:n})}normalizePath(m){if(!m.path.length)return m;let n;return m.scheme===O.Schemas.file?n=d.URI.file(R.$ic(f(m))).path:n=R.$hc.normalize(m.path),m.with({path:n})}relativePath(m,n){if(m.scheme!==n.scheme||!(0,e.$6g)(m.authority,n.authority))return;if(m.scheme===O.Schemas.file){const r=R.$mc(f(m),f(n));return N.$i?I.$hg(r):r}let o=m.path||"/";const s=n.path||"/";if(this.a(m)){let r=0;for(const i=Math.min(o.length,s.length);r<i&&!(o.charCodeAt(r)!==s.charCodeAt(r)&&o.charAt(r).toLowerCase()!==s.charAt(r).toLowerCase());r++);o=s.substr(0,r)+o.substr(r)}return R.$hc.relative(o,s)}resolvePath(m,n){if(m.scheme===O.Schemas.file){const o=d.URI.file(R.$lc(f(m),n));return m.with({authority:o.authority,path:o.path})}return n=I.$ig(n),m.with({path:R.$hc.resolve(m.path,n)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,n){return m===n||m!==void 0&&n!==void 0&&(0,M.$qf)(m,n)}hasTrailingPathSeparator(m,n=R.sep){if(m.scheme===O.Schemas.file){const o=f(m);return o.length>I.$jg(o).length&&o[o.length-1]===n}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,n=R.sep){return(0,e.$7g)(m,n)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,n=R.sep){let o=!1;if(m.scheme===O.Schemas.file){const s=f(m);o=s!==void 0&&s.length===I.$jg(s).length&&s[s.length-1]===n}else{n="/";const s=m.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$7g)(m,n)?m.with({path:m.path+"/"}):m}}e.$Pg=E,e.$Qg=new E(()=>!1),e.$Rg=new E(w=>w.scheme===O.Schemas.file?!N.$k:!0),e.$Sg=new E(w=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function T(w,m){const n=[];for(let o=0;o<w.length;o++){const s=m(w[o]);w.some((r,i)=>i===o?!1:(0,e.$Ug)(s,m(r)))||n.push(w[o])}return n}var y;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set(w.META_DATA_MIME,r),o}w.parseMetaData=m})(y||(e.DataUri=y={}));function u(w,m,n){if(m){let o=w.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),w.with({scheme:n,authority:m,path:o})}return w.with({scheme:n})}}),define(Pe[11],Re([1,0,24,14,5,6,23,21,130,40]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=T,e.$ah=y,e.$bh=u,e.$ch=w,e.$dh=m,e.$eh=n,e.$fh=o,e.$gh=s,e.$oh=p,e.$ph=l,e.$qh=D,e.$rh=g,e.$sh=S,e.$Hh=ke,e.$Ph=Ee;function T(de){return!!de&&typeof de.then=="function"}function y(de){const Q=new I.$je,Y=de(Q.token),ue=new Promise((he,Ne)=>{const le=Q.token.onCancellationRequested(()=>{le.dispose(),Ne(new O.$5)});Promise.resolve(Y).then(Ce=>{le.dispose(),Q.dispose(),he(Ce)},Ce=>{le.dispose(),Q.dispose(),Ne(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(he,Ne){return ue.then(he,Ne)}catch(he){return this.then(void 0,he)}finally(he){return ue.finally(he)}}}function u(de,Q,Y){return new Promise((ue,he)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),ue(Y)});de.then(ue,he).finally(()=>Ne.dispose())})}function w(de,Q){return new Promise((Y,ue)=>{const he=Q.onCancellationRequested(()=>{he.dispose(),ue(new O.$5)});de.then(Y,ue).finally(()=>he.dispose())})}async function m(de){let Q=-1;const Y=de.map((ue,he)=>ue.then(Ne=>(Q=he,Ne)));try{return await Promise.race(Y)}finally{de.forEach((ue,he)=>{he!==Q&&ue.cancel()})}}function n(de,Q,Y){let ue;const he=setTimeout(()=>{ue?.(void 0),Y?.()},Q);return Promise.race([de.finally(()=>clearTimeout(he)),new Promise(Ne=>ue=Ne)])}function o(de){return new Promise((Q,Y)=>{const ue=de();T(ue)?ue.then(Q,Y):Q(ue)})}function s(){let de,Q;return{promise:new Promise((ue,he)=>{de=ue,Q=he}),resolve:de,reject:Q}}class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(Y,Y).then(ue)})}return new Promise((Y,ue)=>{this.b.then(Y,ue)})}return this.a=Q(),new Promise((Y,ue)=>{this.a.then(he=>{this.a=null,Y(he)},he=>{this.a=null,ue(he)})})}dispose(){this.f=!0}}e.$hh=r;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$ih=i;class a{constructor(){this.a=new Map}queue(Q,Y){const he=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===he&&this.a.delete(Q)});return this.a.set(Q,he),he}}e.$jh=a;const h=(de,Q)=>{let Y=!0;const ue=setTimeout(()=>{Y=!1,Q()},de);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(ue),Y=!1}}},t=de=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,de())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class v{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((he,Ne)=>{this.d=he,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=Y===f.$9d?t(ue):h(Y,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=v;class c{constructor(Q){this.a=new v(Q),this.b=new r}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=c;class ${constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=$;class b extends ${constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$nh=b;function p(de,Q){return Q?new Promise((Y,ue)=>{const he=setTimeout(()=>{Ne.dispose(),Y()},de),Ne=Q.onCancellationRequested(()=>{clearTimeout(he),Ne.dispose(),ue(new O.$5)})}):y(Y=>p(de,Y))}function l(de,Q=0,Y){const ue=setTimeout(()=>{de(),Y&&he.dispose()},Q),he=(0,N.$Sc)(()=>{clearTimeout(ue),Y?.deleteAndLeak(he)});return Y?.add(he),he}function D(de){const Q=[];let Y=0;const ue=de.length;function he(){return Y<ue?de[Y++]():null}function Ne(le){le!=null&&Q.push(le);const Ce=he();return Ce?Ce.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function g(de,Q=ue=>!!ue,Y=null){let ue=0;const he=de.length,Ne=()=>{if(ue>=he)return Promise.resolve(Y);const le=de[ue++];return Promise.resolve(le()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Ne())};return Ne()}function S(de,Q=ue=>!!ue,Y=null){if(de.length===0)return Promise.resolve(Y);let ue=de.length;const he=()=>{ue=-1;for(const Ne of de)Ne.cancel?.()};return new Promise((Ne,le)=>{for(const Ce of de)Ce.then(Ae=>{--ue>=0&&Q(Ae)?(he(),Ne(Ae)):ue===0&&Ne(Y)}).catch(Ae=>{--ue>=0&&(he(),le(Ae))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$_d}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,ue)=>{this.g.push({factory:Q,c:Y,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=k;class P extends k{constructor(){super(1)}}e.$uh=P;class C{constructor(){this.a=new oe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$vh=C;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new Ie;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=M.$Qg){const ue=Y.getComparisonKey(Q);return this.a.get(ue)?.size??0}queueFor(Q,Y,ue=M.$Qg){const he=ue.getComparisonKey(Q);let Ne=this.a.get(he);if(!Ne){Ne=new P;const le=this.f++,Ce=R.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(le,Ce),this.a.set(he,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=W;class V{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$xh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,ue=globalThis){this.cancel();const he=ue.setInterval(()=>{Q()},Y);this.d=(0,N.$Sc)(()=>{ue.clearInterval(he),this.d=void 0})}dispose(){this.cancel()}}e.$yh=q;class A{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=A;class U{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=U;class K extends A{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Bh=K;class ie extends N.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(de,Q)=>{(0,d.$B)(()=>{if(Y)return;const ue=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Eh=(de,Q,Y)=>{const ue=de.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let he=!1;return{dispose(){he||(he=!0,de.cancelIdleCallback(ue))}}},e.$Dh=de=>(0,e.$Eh)(globalThis,de)}();class fe{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Eh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=fe;class Se extends fe{constructor(Q){super(globalThis,Q)}}e.$Gh=Se;async function ke(de,Q,Y){let ue;for(let he=0;he<Y;he++)try{return await de()}catch(Ne){ue=Ne,await p(Q)}throw ue}class oe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,ue){return this.a={taskId:Q,cancel:()=>ue?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:ue,reject:he}=s();this.b={run:Q,promise:Y,promiseResolve:ue,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=oe;class $e{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Jh=$e;var ne;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(ne||(ne={}));class Ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Kh=Ie;var ze;(function(de){async function Q(ue){let he;const Ne=await Promise.all(ue.map(le=>le.then(Ce=>Ce,Ce=>{he||(he=Ce)})));if(typeof he<"u")throw he;return Ne}de.settled=Q;function Y(ue){return new Promise(async(he,Ne)=>{try{await ue(he,Ne)}catch(le){Ne(le)}})}de.withAsyncBody=Y})(ze||(e.Promises=ze={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=re;class L{constructor(Q){this.b=Q,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=L;var _;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(_||(_={}));class ve{static fromArray(Q){return new ve(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new ve(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new ve(async Y=>{await Promise.all(Q.map(async ue=>Y.emitOne(await ue)))})}static merge(Q){return new ve(async Y=>{await Promise.all(Q.map(async ue=>{for await(const he of ue)Y.emitOne(he)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new R.$_d,queueMicrotask(async()=>{const Y={emitOne:ue=>this.g(ue),emitMany:ue=>this.h(ue),reject:ue=>this.k(ue)};try{await Promise.resolve(Q(Y)),this.j()}catch(ue){this.k(ue)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,Y){return new ve(async ue=>{for await(const he of Q)ue.emitOne(Y(he))})}map(Q){return ve.map(this,Q)}static filter(Q,Y){return new ve(async ue=>{for await(const he of Q)Y(he)&&ue.emitOne(he)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const Y=[];for await(const ue of Q)Y.push(ue);return Y}toPromise(){return ve.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$Nh=ve;class Te extends ve{constructor(Q,Y){super(Y),this.l=Q}cancel(){this.l.cancel()}}e.$Oh=Te;function Ee(de){const Q=new I.$je,Y=de(Q.token);return new Te(Q,async ue=>{const he=Q.token.onCancellationRequested(()=>{he.dispose(),Q.dispose(),ue.reject(new O.$5)});try{for await(const Ne of Y){if(Q.token.isCancellationRequested)return;ue.emitOne(Ne)}he.dispose(),Q.dispose()}catch(Ne){he.dispose(),Q.dispose(),ue.reject(Ne)}})}class pe{constructor(){this.a=new Ie,this.b=new ve(ue=>{if(Q){ue.reject(Q);return}return Y&&ue.emitMany(Y),this.d=he=>ue.reject(he),this.f=he=>ue.emitOne(he),this.a.p});let Q,Y;this.f=ue=>{Y||(Y=[]),Y.push(ue)},this.d=ue=>{Q||(Q=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Qh=pe}),define(Pe[36],Re([1,0,18,11,47,28,19,21,15]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$ck=E,e.$fk=m,e.$gk=P,e.$hk=C,e.$ik=W,e.$jk=V,e.$kk=q,e.$lk=ie;function E(){return Object.create(null)}e.$dk="**",e.$ek="/";const T="[/\\\\]",y="[^/\\\\]",u=/\//g;function w(fe,Se){switch(fe){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}${Se?`|${T}${y}+`:""})*?`}}function m(fe,Se){if(!fe)return[];const ke=[];let oe=!1,$e=!1,ne="";for(const Ie of fe){switch(Ie){case Se:if(!oe&&!$e){ke.push(ne),ne="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ne+=Ie}return ne&&ke.push(ne),ke}function n(fe){if(!fe)return"";let Se="";const ke=m(fe,e.$ek);if(ke.every(oe=>oe===e.$dk))Se=".*";else{let oe=!1;ke.forEach(($e,ne)=>{if($e===e.$dk){if(oe)return;Se+=w(2,ne===ke.length-1)}else{let Ie=!1,ze="",re=!1,L="";for(const _ of $e){if(_!=="}"&&Ie){ze+=_;continue}if(re&&(_!=="]"||!L)){let ve;_==="-"?ve=_:(_==="^"||_==="!")&&!L?ve="^":_===e.$ek?ve="":ve=(0,f.$5e)(_),L+=ve;continue}switch(_){case"{":Ie=!0;continue;case"[":re=!0;continue;case"}":{const Te=`(?:${m(ze,",").map(Ee=>n(Ee)).join("|")})`;Se+=Te,Ie=!1,ze="";break}case"]":{Se+="["+L+"]",re=!1,L="";break}case"?":Se+=y;continue;case"*":Se+=w(1);continue;default:Se+=(0,f.$5e)(_)}}ne<ke.length-1&&(ke[ne+1]!==e.$dk||ne+2<ke.length)&&(Se+=T)}oe=$e===e.$dk})}return Se}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),v=function(){return!1},c=function(){return null};function $(fe,Se){if(!fe)return c;let ke;typeof fe!="string"?ke=fe.pattern:ke=fe,ke=ke.trim();const oe=`${ke}_${!!Se.trimForExclusions}`;let $e=t.get(oe);if($e)return b($e,fe);let ne;return o.test(ke)?$e=l(ke.substr(4),ke):(ne=s.exec(p(ke,Se)))?$e=D(ne[1],ke):(Se.trimForExclusions?i:r).test(ke)?$e=g(ke,Se):(ne=a.exec(p(ke,Se)))?$e=S(ne[1].substr(1),ke,!0):(ne=h.exec(p(ke,Se)))?$e=S(ne[1],ke,!1):$e=k(ke),t.set(oe,$e),b($e,fe)}function b(fe,Se){if(typeof Se=="string")return fe;const ke=function(oe,$e){return(0,R.$ng)(oe,Se.base,!d.$k)?fe((0,f.$0e)(oe.substr(Se.base.length),M.sep),$e):null};return ke.allBasenames=fe.allBasenames,ke.allPaths=fe.allPaths,ke.basenames=fe.basenames,ke.patterns=fe.patterns,ke}function p(fe,Se){return Se.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function l(fe,Se){return function(ke,oe){return typeof ke=="string"&&ke.endsWith(fe)?Se:null}}function D(fe,Se){const ke=`/${fe}`,oe=`\\${fe}`,$e=function(Ie,ze){return typeof Ie!="string"?null:ze?ze===fe?Se:null:Ie===fe||Ie.endsWith(ke)||Ie.endsWith(oe)?Se:null},ne=[fe];return $e.basenames=ne,$e.patterns=[Se],$e.allBasenames=ne,$e}function g(fe,Se){const ke=K(fe.slice(1,-1).split(",").map(ze=>$(ze,Se)).filter(ze=>ze!==c),fe),oe=ke.length;if(!oe)return c;if(oe===1)return ke[0];const $e=function(ze,re){for(let L=0,_=ke.length;L<_;L++)if(ke[L](ze,re))return fe;return null},ne=ke.find(ze=>!!ze.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Ie=ke.reduce((ze,re)=>re.allPaths?ze.concat(re.allPaths):ze,[]);return Ie.length&&($e.allPaths=Ie),$e}function S(fe,Se,ke){const oe=M.sep===M.$hc.sep,$e=oe?fe:fe.replace(u,M.sep),ne=M.sep+$e,Ie=M.$hc.sep+fe;let ze;return ke?ze=function(re,L){return typeof re=="string"&&(re===$e||re.endsWith(ne)||!oe&&(re===fe||re.endsWith(Ie)))?Se:null}:ze=function(re,L){return typeof re=="string"&&(re===$e||!oe&&re===fe)?Se:null},ze.allPaths=[(ke?"*/":"./")+fe],ze}function k(fe){try{const Se=new RegExp(`^${n(fe)}$`);return function(ke){return Se.lastIndex=0,typeof ke=="string"&&Se.test(ke)?fe:null}}catch{return c}}function P(fe,Se,ke){return!fe||typeof Se!="string"?!1:C(fe)(Se,void 0,ke)}function C(fe,Se={}){if(!fe)return v;if(typeof fe=="string"||W(fe)){const ke=$(fe,Se);if(ke===c)return v;const oe=function($e,ne){return!!ke($e,ne)};return ke.allBasenames&&(oe.allBasenames=ke.allBasenames),ke.allPaths&&(oe.allPaths=ke.allPaths),oe}return A(fe,Se)}function W(fe){const Se=fe;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}function V(fe){return fe.allBasenames||[]}function q(fe){return fe.allPaths||[]}function A(fe,Se){const ke=K(Object.getOwnPropertyNames(fe).map(ze=>U(ze,fe[ze],Se)).filter(ze=>ze!==c)),oe=ke.length;if(!oe)return c;if(!ke.some(ze=>!!ze.requiresSiblings)){if(oe===1)return ke[0];const ze=function(_,ve){let Te;for(let Ee=0,pe=ke.length;Ee<pe;Ee++){const de=ke[Ee](_,ve);if(typeof de=="string")return de;(0,O.$_g)(de)&&(Te||(Te=[]),Te.push(de))}return Te?(async()=>{for(const Ee of Te){const pe=await Ee;if(typeof pe=="string")return pe}return null})():null},re=ke.find(_=>!!_.allBasenames);re&&(ze.allBasenames=re.allBasenames);const L=ke.reduce((_,ve)=>ve.allPaths?_.concat(ve.allPaths):_,[]);return L.length&&(ze.allPaths=L),ze}const $e=function(ze,re,L){let _,ve;for(let Te=0,Ee=ke.length;Te<Ee;Te++){const pe=ke[Te];pe.requiresSiblings&&L&&(re||(re=(0,M.$oc)(ze)),_||(_=re.substr(0,re.length-(0,M.$pc)(ze).length)));const de=pe(ze,re,_,L);if(typeof de=="string")return de;(0,O.$_g)(de)&&(ve||(ve=[]),ve.push(de))}return ve?(async()=>{for(const Te of ve){const Ee=await Te;if(typeof Ee=="string")return Ee}return null})():null},ne=ke.find(ze=>!!ze.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Ie=ke.reduce((ze,re)=>re.allPaths?ze.concat(re.allPaths):ze,[]);return Ie.length&&($e.allPaths=Ie),$e}function U(fe,Se,ke){if(Se===!1)return c;const oe=$(fe,ke);if(oe===c)return c;if(typeof Se=="boolean")return oe;if(Se){const $e=Se.when;if(typeof $e=="string"){const ne=(Ie,ze,re,L)=>{if(!L||!oe(Ie,ze))return null;const _=$e.replace("$(basename)",()=>re),ve=L(_);return(0,O.$_g)(ve)?ve.then(Te=>Te?fe:null):ve?fe:null};return ne.requiresSiblings=!0,ne}}return oe}function K(fe,Se){const ke=fe.filter(ze=>!!ze.basenames);if(ke.length<2)return fe;const oe=ke.reduce((ze,re)=>{const L=re.basenames;return L?ze.concat(L):ze},[]);let $e;if(Se){$e=[];for(let ze=0,re=oe.length;ze<re;ze++)$e.push(Se)}else $e=ke.reduce((ze,re)=>{const L=re.patterns;return L?ze.concat(L):ze},[]);const ne=function(ze,re){if(typeof ze!="string")return null;if(!re){let _;for(_=ze.length;_>0;_--){const ve=ze.charCodeAt(_-1);if(ve===47||ve===92)break}re=ze.substr(_)}const L=oe.indexOf(re);return L!==-1?$e[L]:null};ne.basenames=oe,ne.patterns=$e,ne.allBasenames=oe;const Ie=fe.filter(ze=>!ze.basenames);return Ie.push(ne),Ie}function ie(fe,Se){return(0,I.$ub)(fe,Se,(ke,oe)=>typeof ke=="string"&&typeof oe=="string"?ke===oe:typeof ke!="string"&&typeof oe!="string"?ke.base===oe.base&&ke.pattern===oe.pattern:!1)}}),define(Pe[54],Re([1,0,14,131,23,15,2]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.MarkdownStringTextNewlineStyle=void 0,e.$Lk=E,e.$Mk=T,e.$Nk=y,e.$Ok=u,e.$Pk=w,e.$Qk=m,e.$Rk=n,e.$Sk=o;var d;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(d||(e.MarkdownStringTextNewlineStyle=d={}));class f{constructor(r="",i=!1){if(this.value=r,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(r,i=0){return this.value+=u(this.supportThemeIcons?(0,O.$Ek)(r):r).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,i){return this.value+=`
${w(i,r)}
`,this}appendLink(r,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,i){const a=new RegExp((0,N.$5e)(i),"g");return r.replace(a,(h,t)=>r.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Kk=f;function E(s){return T(s)?!s.value:Array.isArray(s)?s.every(E):!0}function T(s){return s instanceof f?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function y(s,r){return s===r?!0:!s||!r?!1:s.value===r.value&&s.isTrusted===r.isTrusted&&s.supportThemeIcons===r.supportThemeIcons&&s.supportHtml===r.supportHtml&&(s.baseUri===r.baseUri||!!s.baseUri&&!!r.baseUri&&(0,R.$Tg)(M.URI.from(s.baseUri),M.URI.from(r.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,r){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${r}`,s,`${"`".repeat(a)}`].join(`
`)}function m(s){return s.replace(/"/g,"&quot;")}function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const r=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),v=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),b=isFinite(parseInt(v));$&&r.push(`width="${c}"`),b&&r.push(`height="${v}"`)}return{href:s,dimensions:r}}}),define(Pe[96],Re([1,0,18,47,19,21,23,15]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=f,e.$mw=T,e.$nw=u,e.$ow=w,e.$pw=s,e.$qw=i,e.$rw=a,e.$sw=h,e.$tw=t,e.$uw=v;function f($,b){const{os:p,tildify:l,relative:D}=b;if(D){const k=E($,D,p);if(typeof k=="string")return k}let g=$.fsPath;if(p===1&&!N.$i?g=g.replace(/\//g,"\\"):p!==1&&N.$i&&(g=g.replace(/\\/g,"/")),p!==1&&l?.userHome){const k=l.userHome.fsPath;let P;$.scheme!==l.userHome.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep?P=l.userHome.with({path:$.path}).fsPath:P=g,g=u(P,k,p)}return(p===1?R.$gc:R.$hc).normalize(T(g,p===1))}function E($,b,p){const l=p===1?R.$gc:R.$hc,D=p===3?M.$Qg:M.$Sg,g=b.getWorkspace(),S=(0,I.$Ob)(g.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep&&($=S.uri.with({path:$.path}));const k=b.getWorkspaceFolder($);if(!k)return;let P;if(D.isEqual(k.uri,$)?P="":P=D.relativePath(k.uri,$)??"",P&&(P=l.normalize(P)),g.folders.length>1&&!b.noPrefix){const C=k.name?k.name:D.basenameOrAuthority(k.uri);P=P?`${C} \u2022 ${P}`:C}return P}function T($,b=N.$i){return(0,O.$rg)($,b)?$.charAt(0).toUpperCase()+$.slice(1):$}let y=Object.create(null);function u($,b,p=N.OS){if(p===1||!$||!b)return $;let l=y.original===b?y.normalized:void 0;l||(l=b,N.$i&&(l=(0,O.$hg)(l)),l=`${(0,d.$$e)(l,R.$hc.sep)}${R.$hc.sep}`,y={original:b,normalized:l});let D=$;return N.$i&&(D=(0,O.$hg)(D)),(p===3?D.startsWith(l):(0,d.$rf)(D,l))?`~/${D.substr(l.length)}`:$}function w($,b){return $.replace(/^~($|\/|\\)/,`${b}$1`)}const m="\u2026",n="\\\\",o="~";function s($,b=R.sep){const p=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const g=$[D];if(g===""){p[D]=`.${b}`;continue}if(!g){p[D]=g;continue}l=!0;let S="",k=g;k.indexOf(n)===0?(S=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(b)===0?(S=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(o)===0&&(S=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const P=k.split(b);for(let C=1;l&&C<=P.length;C++)for(let W=P.length-C;l&&W>=0;W--){l=!1;let V=P.slice(W,W+C).join(b);for(let q=0;!l&&q<$.length;q++)if(q!==D&&$[q]&&$[q].indexOf(V)>-1){const A=W+C===P.length,U=W>0&&$[q].indexOf(b)>-1?b+V:V,K=$[q].endsWith(U);l=!A||K}if(!l){let q="";(P[0].endsWith(":")||S!=="")&&(W===1&&(W=0,C++,V=P[0]+b+V),W>0&&(q=P[0]+b),q=S+q),W>0&&(q=q+m+b),q=q+V,W+C<P.length&&(q=q+b+m),p[D]=q}}l&&(p[D]=g)}return p}var r;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function i($,b=Object.create(null)){const p=[];let l=!1,D="";for(const g of $)if(g==="$"||l&&g==="{")D&&p.push({value:D,type:r.TEXT}),D="",l=!0;else if(g==="}"&&l){const S=b[D];if(typeof S=="string")S.length&&p.push({value:S,type:r.VARIABLE});else if(S){const k=p[p.length-1];(!k||k.type!==r.SEPARATOR)&&p.push({value:S.label,type:r.SEPARATOR})}D="",l=!1}else D+=g;return D&&!l&&p.push({value:D,type:r.TEXT}),p.filter((g,S)=>{if(g.type===r.SEPARATOR){const k=p[S-1],P=p[S+1];return[k,P].every(C=>C&&(C.type===r.VARIABLE||C.type===r.TEXT)&&C.value.length>0)}return!0}).map(g=>g.value).join("")}function a($,b){return N.$j||b?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):$.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function h($,b){return N.$j||b?$.replace(/\(&&\w\)|&&/g,""):N.$i?$.replace(/&&|&/g,p=>p==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function v($){if($.endsWith("]")){const b=$.lastIndexOf(" [",$.length-2);if(b!==-1){const p=c($.substring(0,b)),l=$.substring(b);return{name:p.name+l,parentPath:p.parentPath}}}return c($)}function c($){const b=$.indexOf("/")!==-1?R.$hc:R.$gc,p=b.basename($),l=b.dirname($);return p.length?{name:p,parentPath:l}:{name:l,parentPath:""}}}),define(Pe[144],Re([1,0,22,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=void 0,e.$rn=d,e.$sn=E,e.$tn=T;function R(y){return y.toJSON()}class N{constructor(u){this.a=u}transformIncoming(u){const w=this.a.transformIncoming(u);return w===u?u:R(O.URI.from(w))}transformOutgoing(u){const w=this.a.transformOutgoing(u);return w===u?u:R(O.URI.from(w))}transformOutgoingURI(u){const w=this.a.transformOutgoing(u);return w===u?u:O.URI.from(w)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$pn=N,e.$qn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,u,w){if(!y||w>200)return null;if(typeof y=="object"){if(y instanceof O.URI)return u.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const n=M(y[m],u,w+1);n!==null&&(y[m]=n)}}return null}function d(y,u){const w=M(y,u,0);return w===null?y:w}function f(y,u,w,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return w?O.URI.revive(u.transformIncoming(y)):u.transformIncoming(y);if(y instanceof I.$ze)return null;for(const n in y)if(Object.hasOwnProperty.call(y,n)){const o=f(y[n],u,w,m+1);o!==null&&(y[n]=o)}}return null}function E(y,u){const w=f(y,u,!1,0);return w===null?y:w}function T(y,u){const w=f(y,u,!0,0);return w===null?y:w}}),define(Pe[145],Re([1,0,15,21,22]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0,e.$qt=T,e.$rt=y;let N;function M(){return N||(N=new TextDecoder("UTF-16LE")),N}let d;function f(){return d||(d=new TextDecoder("UTF-16BE")),d}let E;function T(){return E||(E=O.$D()?M():f()),E}function y(m,n,o){const s=new Uint16Array(m.buffer,n,o);return o>0&&(s[0]===65279||s[0]===65534)?u(m,n,o):M().decode(s)}function u(m,n,o){const s=[];let r=0;for(let i=0;i<o;i++){const a=R.$Be(m,n);n+=2,s[r++]=String.fromCharCode(a)}return s.join("")}class w{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return T().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||I.$uf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let s=0;s<o;s++)this.b[this.d++]=n.charCodeAt(s)}}e.$st=w}),define(Pe[146],Re([1,0,22,145]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$ut=M;function R(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,y,u){this.oldPosition=E,this.oldText=T,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,y){const u=T.length;I.$Ee(E,u,y),y+=4;for(let w=0;w<u;w++)I.$Ce(E,T.charCodeAt(w),y),y+=2;return y}static d(E,T){const y=I.$De(E,T);return T+=4,(0,O.$rt)(E,T,y)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(E,T){return I.$Ee(E,this.oldPosition,T),T+=4,I.$Ee(E,this.newPosition,T),T+=4,T=N.c(E,this.oldText,T),T=N.c(E,this.newText,T),T}static read(E,T,y){const u=I.$De(E,T);T+=4;const w=I.$De(E,T);T+=4;const m=N.d(E,T);T+=N.a(m);const n=N.d(E,T);return T+=N.a(n),y.push(new N(u,m,w,n)),T}}e.$tt=N;function M(f,E){return f===null||f.length===0?E:new d(f,E).compress()}class d{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,y=this.n(E),u=this.l(T);for(;E<this.f||T<this.h;){if(y===null){this.k(u),u=this.l(++T);continue}if(u===null){this.m(y),y=this.n(++E);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++T);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++E);continue}if(u.oldPosition<y.newPosition){const[s,r]=d.r(u,y.newPosition-u.oldPosition);this.k(s),u=r;continue}if(y.newPosition<u.oldPosition){const[s,r]=d.q(y,u.oldPosition-y.newPosition);this.m(s),y=r;continue}let n,o;if(u.oldEnd===y.newEnd)n=y,o=u,y=this.n(++E),u=this.l(++T);else if(u.oldEnd<y.newEnd){const[s,r]=d.q(y,u.oldLength);n=s,o=u,y=r,u=this.l(++T)}else{const[s,r]=d.r(u,y.newLength);n=y,o=s,y=this.n(++E),u=r}this.d[this.e++]=new N(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const w=d.s(this.d);return d.t(w)}k(E){this.d[this.e++]=d.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=d.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new N(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new N(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const y=E.newText.substr(0,T),u=E.newText.substr(T);return[new N(E.oldPosition,E.oldText,E.newPosition,y),new N(E.oldEnd,"",E.newPosition+T,u)]}static r(E,T){const y=E.oldText.substr(0,T),u=E.oldText.substr(T);return[new N(E.oldPosition,y,E.newPosition,E.newText),new N(E.oldPosition+T,u,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let y=0,u=E[0];for(let w=1;w<E.length;w++){const m=E[w];u.oldEnd===m.oldPosition?u=new N(u.oldPosition,u.oldText+m.oldText,u.newPosition,u.newText+m.newText):(T[y++]=u,u=m)}return T[y++]=u,T}static t(E){if(E.length===0)return E;const T=[];let y=0;for(let u=0;u<E.length;u++){const w=E[u];w.oldText!==w.newText&&(T[y++]=w)}return T}}}),define(Pe[147],Re([1,0,36,19]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=R,e.$St=N;function R(M,d,f,E,T,y){if(Array.isArray(M)){let u=0;for(const w of M){const m=R(w,d,f,E,T,y);if(m===10)return m;m>u&&(u=m)}return u}else{if(typeof M=="string")return E?M==="*"?5:M===f?10:0:0;if(M){const{language:u,pattern:w,scheme:m,hasAccessToAllModels:n,notebookType:o}=M;if(!E&&!n)return 0;o&&T&&(d=T);let s=0;if(m)if(m===d.scheme)s=10;else if(m==="*")s=5;else return 0;if(u)if(u===f)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===y)s=10;else if(o==="*"&&y!==void 0)s=Math.max(s,5);else return 0;if(w){let r;if(typeof w=="string"?r=w:r={...w,base:(0,O.$ic)(w.base)},r===d.fsPath||(0,I.$gk)(r,d.fsPath))s=10;else return 0}return s}else return 0}}function N(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(N):!!M.notebookType}}),define(Pe[148],Re([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class T extends E.$Uc{constructor(u,w,m,n,o,s,r){super(),this.m=this.B(new I.$_d),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=n,this.h=o,this.c=new M.$HC(u,m,r)}equals(u){return!(u instanceof T)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,w){return this.c.getOffsetAt(u,w)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,w){const m=u+w,n=this.getPositionAt(u),o=this.getPositionAt(m);return new R.$ht(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(u,w=0){if(u.isEmpty())return"";const m=this.n(w);return this.c.getValueInRange(u,m)}getValueLengthInRange(u,w=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const m=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(w),r=this.getEOL();if(s.length!==r.length){const i=s.length-r.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return n-m+o}getCharacterCountInRange(u,w=0){if(this.j){let m=0;const n=u.startLineNumber,o=u.endLineNumber;for(let s=n;s<=o;s++){const r=this.getLineContent(s),i=s===n?u.startColumn-1:0,a=s===o?u.endColumn-1:r.length;for(let h=i;h<a;h++)O.$uf(r.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(w).length*(o-n),m}return this.getValueLengthInRange(u,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,w){return this.c.getLineCharCode(u,w)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const w=O.$ff(this.getLineContent(u));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(u){const w=O.$hf(this.getLineContent(u));return w===-1?0:w+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,w,m){let n=this.g,o=this.h,s=this.j,r=!0,i=[];for(let b=0;b<u.length;b++){const p=u[b];r&&p._isTracked&&(r=!1);const l=p.range;if(p.text){let P=!0;s||(P=!O.$Ff(p.text),s=P),!n&&P&&(n=O.$Ef(p.text)),!o&&P&&(o=O.$Hf(p.text))}let D="",g=0,S=0,k=0;if(p.text){let P;[g,S,k,P]=(0,d.$Kt)(p.text);const C=this.getEOL();P===0||P===(C===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,C)}i[b]={sortIndex:b,identifier:p.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:g,firstLineLength:S,lastLineLength:k,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(T.u);let a=!1;for(let b=0,p=i.length-1;b<p;b++){const l=i[b].range.getEndPosition(),D=i[b+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(i=this.s(i));const h=m||w?T._getInverseEditRanges(i):[],t=[];if(w)for(let b=0;b<i.length;b++){const p=i[b],l=h[b];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let g="";D===l.startLineNumber&&(g=this.getLineContent(p.range.startLineNumber),O.$ff(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let v=null;if(m){let b=0;v=[];for(let p=0;p<i.length;p++){const l=i[p],D=h[p],g=this.getValueInRange(l.range),S=l.rangeOffset+b;b+=l.text.length-g.length,v[p]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:g,textChange:new f.$tt(l.rangeOffset,g,S,l.text)}}a||v.sort((p,l)=>p.sortIndex-l.sortIndex)}this.g=n,this.h=o,this.j=s;const c=this.t(i);let $=null;if(w&&t.length>0){t.sort((b,p)=>p.lineNumber-b.lineNumber),$=[];for(let b=0,p=t.length;b<p;b++){const l=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===l)continue;const D=t[b].oldContent,g=this.getLineContent(l);g.length===0||g===D||O.$ff(g)!==-1||$.push(l)}}return this.m.fire(),new N.$wv(v,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let w=!1;const m=u[0].range,n=u[u.length-1].range,o=new R.$ht(m.startLineNumber,m.startColumn,n.endLineNumber,n.endColumn);let s=m.startLineNumber,r=m.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const b=u[c],p=b.range;w=w||b.forceMoveMarkers,i.push(this.getValueInRange(new R.$ht(s,r,p.startLineNumber,p.startColumn))),b.text.length>0&&i.push(b.text),s=p.endLineNumber,r=p.endColumn}const a=i.join(""),[h,t,v]=(0,d.$Kt)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:v,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(u){u.sort(T.w);const w=[];for(let m=0;m<u.length;m++){const n=u[m],o=n.range.startLineNumber,s=n.range.startColumn,r=n.range.endLineNumber,i=n.range.endColumn;if(o===r&&s===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const a=new R.$ht(o,s,r,i);w.push({range:a,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return w}findMatchesLineByLine(u,w,m,n){return this.c.findMatchesLineByLine(u,w,m,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,w){const m=u.startLineNumber,n=u.startColumn,[o,s,r]=(0,d.$Kt)(w);let i;if(w.length>0){const a=o+1;a===1?i=new R.$ht(m,n,m,n+s):i=new R.$ht(m,n,m+a-1,r+1)}else i=new R.$ht(m,n,m,n);return i}static _getInverseEditRanges(u){const w=[];let m=0,n=0,o=null;for(let s=0,r=u.length;s<r;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=m,h=n+(i.range.startColumn-o.range.endColumn)):(a=m+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const v=i.eolCount+1;v===1?t=new R.$ht(a,h,a,h+i.firstLineLength):t=new R.$ht(a,h,a+v-1,i.lastLineLength+1)}else t=new R.$ht(a,h,a,h);m=t.endLineNumber,n=t.endColumn,w.push(t),o=i}return w}static u(u,w){const m=R.$ht.compareRangesUsingEnds(u.range,w.range);return m===0?u.sortIndex-w.sortIndex:m}static w(u,w){const m=R.$ht.compareRangesUsingEnds(u.range,w.range);return m===0?w.sortIndex-u.sortIndex:-m}}e.$IC=T}),define(Pe[149],Re([1,0,15,92,148]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=void 0;class N{constructor(f,E,T,y,u,w,m,n,o){this.a=f,this.b=E,this.c=T,this.d=y,this.e=u,this.f=w,this.g=m,this.h=n,this.j=o}k(f){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?f===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(f){const E=this.k(f),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let u=0,w=T.length;u<w;u++){const m=T[u].buffer.replace(/\r\n|\r|\n/g,E),n=(0,O.$DC)(m);T[u]=new O.$GC(m,n)}const y=new R.$IC(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&I.$Of(f)&&(this.b=I.$Nf,f=f.substr(1));const E=f.charCodeAt(f.length-1);E===13||E>=55296&&E<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=E):(this.m(f,!1),this.c=!1,this.d=E)}m(f,E){!E&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const E=(0,O.$EC)(this.e,f);this.a.push(new O.$GC(f,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Ef(f)),this.k||(this.k=I.$Hf(f)))}finish(f=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const E=(0,O.$DC)(f.buffer);f.lineStarts=E,this.d===13&&this.f++}}}e.$JC=M}),define(Pe[97],Re([1,0,22,21]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zab=f,e.$1ab=T;var R;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(R||(R={}));function N(y){for(let u=0,w=y.length;u<w;u+=4){const m=y[u+0],n=y[u+1],o=y[u+2],s=y[u+3];y[u+0]=s,y[u+1]=o,y[u+2]=n,y[u+3]=m}}function M(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return O.$D()||N(u),I.$ze.wrap(u)}function d(y){const u=y.buffer;if(O.$D()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const w=new Uint8Array(u.byteLength);return w.set(u),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function f(y){const u=new Uint32Array(E(y));let w=0;if(u[w++]=y.id,y.type==="full")u[w++]=1,u[w++]=y.data.length,u.set(y.data,w),w+=y.data.length;else{u[w++]=2,u[w++]=y.deltas.length;for(const m of y.deltas)u[w++]=m.start,u[w++]=m.deleteCount,m.data?(u[w++]=m.data.length,u.set(m.data,w),w+=m.data.length):u[w++]=0}return M(u)}function E(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const w of y.deltas)w.data&&(u+=w.data.length)}return u}function T(y){const u=d(y);let w=0;const m=u[w++];if(u[w++]===1){const r=u[w++],i=u.subarray(w,w+r);return w+=r,{id:m,type:"full",data:i}}const o=u[w++],s=[];for(let r=0;r<o;r++){const i=u[w++],a=u[w++],h=u[w++];let t;h>0&&(t=u.subarray(w,w+h),w+=h),s[r]={start:i,deleteCount:a,data:t}}return{id:m,type:"delta",deltas:s}}}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[151],Re([1,0,18,26,21,134,152,150]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=r,e.clampedFloat=a,e.stringSet=v,e.cursorStyleToString=k,e.filterValidationDecorations=he;var f;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class y{constructor(Z,me,qe,we){this.id=Z,this.name=me,this.defaultValue=qe,this.schema=we}applyUpdate(Z,me){return w(Z,me)}compute(Z,me,qe){return qe}}class u{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=u;function w(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new u(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const qe=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new u(Z,!qe)}let me=!1;for(const qe in Z)if(Z.hasOwnProperty(qe)){const we=w(X[qe],Z[qe]);we.didChange&&(X[qe]=we.newValue,me=!0)}return new u(X,me)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return w(Z,me)}validate(Z){return this.defaultValue}}class n{constructor(Z,me,qe,we){this.id=Z,this.name=me,this.defaultValue=qe,this.schema=we}applyUpdate(Z,me){return w(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,qe){return qe}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class s extends n{constructor(Z,me,qe,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=qe),super(Z,me,qe,we)}validate(Z){return o(Z,this.defaultValue)}}function r(X,Z,me,qe){if(typeof X>"u")return Z;let we=parseInt(X,10);return isNaN(we)?Z:(we=Math.max(me,we),we=Math.min(qe,we),we|0)}class i extends n{static clampedInt(Z,me,qe,we){return r(Z,me,qe,we)}constructor(Z,me,qe,we,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=qe,dt.minimum=we,dt.maximum=ot),super(Z,me,qe,dt),this.minimum=we,this.maximum=ot}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function a(X,Z,me,qe){if(typeof X>"u")return Z;const we=h.float(X,Z);return h.clamp(we,me,qe)}class h extends n{static clamp(Z,me,qe){return Z<me?me:Z>qe?qe:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const qe=parseFloat(Z);return isNaN(qe)?me:qe}constructor(Z,me,qe,we,ot){typeof ot<"u"&&(ot.type="number",ot.default=qe),super(Z,me,qe,ot),this.validationFn=we}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class t extends n{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,qe,we=void 0){typeof we<"u"&&(we.type="string",we.default=qe),super(Z,me,qe,we)}validate(Z){return t.string(Z,this.defaultValue)}}function v(X,Z,me,qe){return typeof X!="string"?Z:qe&&X in qe?qe[X]:me.indexOf(X)===-1?Z:X}class c extends n{constructor(Z,me,qe,we,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=we,ot.default=qe),super(Z,me,qe,ot),this.c=we}validate(Z){return v(Z,this.defaultValue,this.c)}}class $ extends y{constructor(Z,me,qe,we,ot,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=ot,Ct.default=we),super(Z,me,qe,Ct),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function b(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",tags:["accessibility"],description:d.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,qe){return qe===0?Z.accessibilitySupport:qe}}class l extends y{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function k(X){switch(X){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function P(X){switch(X){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class C extends m{constructor(){super(142)}compute(Z,me,qe){const we=["monaco-editor"];return me.get(39)&&we.push(me.get(39)),Z.extraEditorClassName&&we.push(Z.extraEditorClassName),me.get(74)==="default"?we.push("mouse-default"):me.get(74)==="copy"&&we.push("mouse-copy"),me.get(111)&&we.push("showUnused"),me.get(140)&&we.push("showDeprecated"),we.join(" ")}}class W extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Z,me,qe){return qe&&Z.emptySelectionClipboard}}class V extends y{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:d.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:d.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":v(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":v(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:d.localize(22,null)},{type:"string",description:d.localize(23,null)}],description:d.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.TRANSLATE:Z:Z?A.TRANSLATE:A.OFF}compute(Z,me,qe){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class U extends m{constructor(){super(50)}compute(Z,me,qe){return Z.fontInfo}}class K extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(25,null)})}validate(Z){const me=h.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(Z,me,qe){return Z.fontInfo.fontSize}}class ie extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:d.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class fe extends y{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[d.localize(28,null),d.localize(29,null),d.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:d.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:d.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:d.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:qe,description:d.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:qe,description:d.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:qe,description:d.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:qe,description:d.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:qe,description:d.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:v(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??v(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??v(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??v(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??v(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??v(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Se extends y{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:d.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:d.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:d.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:d.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:d.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class oe extends m{constructor(){super(145)}compute(Z,me,qe){return oe.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,qe=Math.floor(Z.paddingTop/Z.lineHeight);let we=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(we=Math.max(we,me-1));const ot=(qe+Z.viewLineCount+we)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:we,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const qe=Z.outerWidth,we=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=me.stableMinimapLayoutInput,Ct=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,jt=Z.lineHeight,_t=Z.typicalHalfwidthCharacterWidth,Jt=Z.scrollBeyondLastLine,ei=Z.minimap.renderCharacters;let Dt=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Wt=Z.minimap.maxColumn,Qt=Z.minimap.size,Xe=Z.minimap.side,ai=Z.verticalScrollbarWidth,ti=Z.viewLineCount,ii=Z.remainingWidth,lt=Z.isViewportWrapping,vt=ei?2:3;let si=Math.floor(ot*we);const ni=si/ot;let Tt=!1,mt=!1,Rt=vt*Dt,qt=Dt/ot,Zt=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:At,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:ri,desiredRatio:oi,minimapLineCount:Vt}=oe.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Jt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:we,lineHeight:jt,pixelRatio:ot});if(ti/Vt>1)Tt=!0,mt=!0,Dt=1,Rt=1,qt=Dt/ot;else{let kt=!1,Yt=Dt+1;if(Qt==="fit"){const St=Math.ceil((Lt+ti+ri)*Rt);lt&&Ct&&ii<=me.stableFitRemainingWidth?(kt=!0,Yt=me.stableFitMaxMinimapScale):kt=St>si}if(Qt==="fill"||kt){Tt=!0;const St=Dt;Rt=Math.min(jt*ot,Math.max(1,Math.floor(1/oi))),lt&&Ct&&ii<=me.stableFitRemainingWidth&&(Yt=me.stableFitMaxMinimapScale),Dt=Math.min(Yt,Math.max(1,Math.floor(Rt/vt))),Dt>St&&(Zt=Math.min(2,Dt/St)),qt=Dt/ot/Zt,si=Math.ceil(Math.max(At,Lt+ti+ri)*Rt),lt?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=ii,me.stableFitMaxMinimapScale=Dt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const He=Math.floor(Wt*qt),Xt=Math.min(He,Math.max(0,Math.floor((ii-ai-2)*qt/(_t+qt)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(ot*Xt);const Bt=Ut/ot;Ut=Math.floor(Ut*Zt);const $t=ei?1:2,Ft=Xe==="left"?0:qe-Xt-ai;return{renderMinimap:$t,minimapLeft:Ft,minimapWidth:Xt,minimapHeightIsEditorHeight:Tt,minimapIsSampling:mt,minimapScale:Dt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:si,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ni}}static computeLayout(Z,me){const qe=me.outerWidth|0,we=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Ct=me.typicalHalfwidthCharacterWidth,jt=me.maxDigitWidth,_t=me.pixelRatio,Jt=me.viewLineCount,ei=Z.get(137),Dt=ei==="inherit"?Z.get(136):ei,Wt=Dt==="inherit"?Z.get(132):Dt,Qt=Z.get(135),Xe=me.isDominatedByLongLines,ai=Z.get(57),ti=Z.get(68).renderType!==0,ii=Z.get(69),lt=Z.get(105),vt=Z.get(84),si=Z.get(73),ni=Z.get(103),Tt=ni.verticalScrollbarSize,mt=ni.verticalHasArrows,Rt=ni.arrowSize,qt=ni.horizontalScrollbarSize,Zt=Z.get(43),He=Z.get(110)!=="never";let Xt=Z.get(66);Zt&&He&&(Xt+=16);let Ut=0;if(ti){const It=Math.max(dt,ii);Ut=Math.round(It*jt)}let Bt=0;ai&&(Bt=ot*me.glyphMarginDecorationLaneCount);let $t=0,Ft=$t+Bt,At=Ft+Ut,Lt=At+Xt;const ri=qe-Bt-Ut-Xt;let oi=!1,Vt=!1,Pt=-1;Dt==="inherit"&&Xe?(oi=!0,Vt=!0):Wt==="on"||Wt==="bounded"?Vt=!0:Wt==="wordWrapColumn"&&(Pt=Qt);const kt=oe.c({outerWidth:qe,outerHeight:we,lineHeight:ot,typicalHalfwidthCharacterWidth:Ct,pixelRatio:_t,scrollBeyondLastLine:lt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:si,verticalScrollbarWidth:Tt,viewLineCount:Jt,remainingWidth:ri,isViewportWrapping:Vt},me.memory||new T);kt.renderMinimap!==0&&kt.minimapLeft===0&&($t+=kt.minimapWidth,Ft+=kt.minimapWidth,At+=kt.minimapWidth,Lt+=kt.minimapWidth);const Yt=ri-kt.minimapWidth,St=Math.max(1,Math.floor((Yt-Tt-2)/Ct)),yt=mt?Rt:0;return Vt&&(Pt=Math.max(1,St),Wt==="bounded"&&(Pt=Math.min(Pt,Qt))),{width:qe,height:we,glyphMarginLeft:$t,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Ft,lineNumbersWidth:Ut,decorationsLeft:At,decorationsWidth:Xt,contentLeft:Lt,contentWidth:Yt,minimap:kt,viewportColumn:St,isWordWrapMinified:oi,isViewportWrapping:Vt,wrappingColumn:Pt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:qt,overviewRuler:{top:yt,width:Tt,height:we-2*yt,right:0}}}}e.EditorLayoutInfoComputer=oe;class $e extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[d.localize(47,null),d.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:d.localize(49,null)}})}validate(Z){return v(Z,"simple",["simple","advanced"])}compute(Z,me,qe){return me.get(2)===2?"advanced":qe}}var ne;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class Ie extends y{constructor(){const Z={enabled:ne.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:Z.enabled,enumDescriptions:[d.localize(50,null),d.localize(51,null),d.localize(52,null)],description:d.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:v(Z.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class ze extends y{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:d.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:d.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:d.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:d.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends y{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:d.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(59,null),d.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),d.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),d.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:d.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:d.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:d.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:v(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class L extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,qe){return qe<0?i.clampedInt(-qe*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class _ extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:d.localize(66,null)})}compute(Z,me,qe){return Z.fontInfo.lineHeight}}class ve extends y{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:d.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:d.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(69,null),d.localize(70,null),d.localize(71,null)],default:Z.size,description:d.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:d.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:d.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:d.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:d.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:d.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:d.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:d.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:v(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(me.side,this.defaultValue.side,["right","left"]),showSlider:v(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Te(X){return X==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class pe extends y{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:d.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class de extends m{constructor(){super(143)}compute(Z,me,qe){return Z.pixelRatio}}class Q extends y{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:d.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:d.localize(89,null)},other:{anyOf:me,default:Z.other,description:d.localize(90,null)}},default:Z,markdownDescription:d.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const _t=Z?"on":"off";return{comments:_t,strings:_t,other:_t}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:qe,strings:we}=Z,ot=["on","inline","off"];let dt,Ct,jt;return typeof me=="boolean"?dt=me?"on":"off":dt=v(me,this.defaultValue.other,ot),typeof qe=="boolean"?Ct=qe?"on":"off":Ct=v(qe,this.defaultValue.comments,ot),typeof we=="boolean"?jt=we?"on":"off":jt=v(we,this.defaultValue.strings,ot),{other:dt,comments:Ct,strings:jt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class ue extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(92,null),d.localize(93,null),d.localize(94,null),d.localize(95,null)],default:"on",description:d.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,qe=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:qe}}}function he(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Ne extends y{constructor(){const Z=[],me={type:"number",description:d.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:d.localize(98,null),format:"color-hex"}}}]},default:Z,description:d.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const qe of Z)if(typeof qe=="number")me.push({column:i.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const we=qe;me.push({column:i.clampedInt(we.column,0,0,1e4),color:we.color})}return me.sort((qe,we)=>qe.column-we.column),me}return this.defaultValue}}class le extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends y{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(100,null),d.localize(101,null),d.localize(102,null)],default:"auto",description:d.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(104,null),d.localize(105,null),d.localize(106,null)],default:"auto",description:d.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:d.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:d.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:d.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:d.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,qe=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:we,verticalSliderSize:i.clampedInt(me.verticalSliderSize,we,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends y{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:d.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:d.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:d.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:d.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:d.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:d.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:d.localize(118,null)}})}applyUpdate(Z,me){let qe=!1;me.allowedCharacters&&Z&&(O.$Xn(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},qe=!0)),me.allowedLocales&&Z&&(O.$Xn(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},qe=!0));const we=super.applyUpdate(Z,me);return qe?new u(we.newValue,!0):we}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const qe={};for(const[we,ot]of Object.entries(Z))ot===!0&&(qe[we]=!0);return qe}}class j extends y{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:d.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[d.localize(120,null),d.localize(121,null),d.localize(122,null)],description:d.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:d.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:d.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:v(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class z extends y{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:d.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[d.localize(127,null),d.localize(128,null),d.localize(129,null)],description:d.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:d.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:d.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:v(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends y{constructor(){const Z={enabled:N.$Rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:d.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:d.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends y{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(135,null),d.localize(136,null),d.localize(137,null)],default:Z.bracketPairs,description:d.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(139,null),d.localize(140,null),d.localize(141,null)],default:Z.bracketPairsHorizontal,description:d.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:d.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:d.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(145,null),d.localize(146,null),d.localize(147,null)],default:Z.highlightActiveIndentation,description:d.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const qe=me.indexOf(X);return qe===-1?Z:me[qe]}class se extends y{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(149,null),d.localize(150,null)],default:Z.insertMode,description:d.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:d.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:d.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:d.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[d.localize(155,null),d.localize(156,null),d.localize(157,null),d.localize(158,null)],default:Z.selectionMode,markdownDescription:d.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:d.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:d.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:d.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:d.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:d.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:d.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:v(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:v(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:d.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:d.localize(199,null),type:"string"},{description:d.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const qe of Z)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&me.push(qe)}catch{}return me}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class Ye extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[d.localize(201,null),d.localize(202,null),d.localize(203,null),d.localize(204,null)],description:d.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,qe){return me.get(2)===2?0:qe}}class et extends m{constructor(){super(146)}compute(Z,me,qe){const we=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class at extends y{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:d.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:d.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[d.localize(208,null),d.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:v(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:d.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:d.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[d.localize(212,null),d.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:v(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?ct:R.$k?ft:tt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(214,null)})),acceptSuggestionOnEnter:je(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(215,null),""],markdownDescription:d.localize(216,null)})),accessibilitySupport:je(new p),accessibilityPageSize:je(new i(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",d.localize(218,null))),ariaRequired:je(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:d.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(220,null),d.localize(221,null),""],description:d.localize(222,null)})),autoClosingComments:je(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(223,null),d.localize(224,null),""],description:d.localize(225,null)})),autoClosingDelete:je(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(226,null),""],description:d.localize(227,null)})),autoClosingOvertype:je(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(228,null),""],description:d.localize(229,null)})),autoClosingQuotes:je(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(230,null),d.localize(231,null),""],description:d.localize(232,null)})),autoIndent:je(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[d.localize(233,null),d.localize(234,null),d.localize(235,null),d.localize(236,null),d.localize(237,null)],description:d.localize(238,null)})),automaticLayout:je(new s(13,"automaticLayout",!1)),autoSurround:je(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(239,null),d.localize(240,null),d.localize(241,null),""],description:d.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new s(116,"stickyTabStops",!1,{description:d.localize(243,null)})),codeLens:je(new s(17,"codeLens",!0,{description:d.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:d.localize(245,null)})),codeLensFontSize:je(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(246,null)})),colorDecorators:je(new s(20,"colorDecorators",!0,{description:d.localize(247,null)})),colorDecoratorActivatedOn:je(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[d.localize(248,null),d.localize(249,null),d.localize(250,null)],description:d.localize(251,null)})),colorDecoratorsLimit:je(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:d.localize(252,null)})),columnSelection:je(new s(22,"columnSelection",!1,{description:d.localize(253,null)})),comments:je(new l),contextmenu:je(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new s(25,"copyWithSyntaxHighlighting",!0,{description:d.localize(254,null)})),cursorBlinking:je(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:d.localize(255,null)})),cursorSmoothCaretAnimation:je(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[d.localize(256,null),d.localize(257,null),d.localize(258,null)],description:d.localize(259,null)})),cursorStyle:je(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:d.localize(260,null)})),cursorSurroundingLines:je(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(261,null)})),cursorSurroundingLinesStyle:je(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(262,null),d.localize(263,null)],markdownDescription:d.localize(264,null)})),cursorWidth:je(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(265,null)})),disableLayerHinting:je(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new s(34,"domReadOnly",!1)),dragAndDrop:je(new s(35,"dragAndDrop",!0,{description:d.localize(266,null)})),emptySelectionClipboard:je(new W),dropIntoEditor:je(new at),stickyScroll:je(new ze),experimentalWhitespaceRendering:je(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[d.localize(267,null),d.localize(268,null),d.localize(269,null)],description:d.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:d.localize(271,null)})),find:je(new V),fixedOverflowWidgets:je(new s(42,"fixedOverflowWidgets",!1)),folding:je(new s(43,"folding",!0,{description:d.localize(272,null)})),foldingStrategy:je(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(273,null),d.localize(274,null)],description:d.localize(275,null)})),foldingHighlight:je(new s(45,"foldingHighlight",!0,{description:d.localize(276,null)})),foldingImportsByDefault:je(new s(46,"foldingImportsByDefault",!1,{description:d.localize(277,null)})),foldingMaximumRegions:je(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(280,null)})),fontInfo:je(new U),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new ie),fontVariations:je(new A),formatOnPaste:je(new s(55,"formatOnPaste",!1,{description:d.localize(281,null)})),formatOnType:je(new s(56,"formatOnType",!1,{description:d.localize(282,null)})),glyphMargin:je(new s(57,"glyphMargin",!0,{description:d.localize(283,null)})),gotoLocation:je(new fe),hideCursorInOverviewRuler:je(new s(59,"hideCursorInOverviewRuler",!1,{description:d.localize(284,null)})),hover:je(new Se),inDiffEditor:je(new s(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:d.localize(285,null)})),lightbulb:je(new Ie),lineDecorationsWidth:je(new L),lineHeight:je(new _),lineNumbers:je(new ue),lineNumbersMinChars:je(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new s(70,"linkedEditing",!1,{description:d.localize(286,null)})),links:je(new s(71,"links",!0,{description:d.localize(287,null)})),matchBrackets:je(new c(72,"matchBrackets","always",["always","near","never"],{description:d.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:d.localize(289,null)})),mouseWheelZoom:je(new s(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?d.localize(290,null):d.localize(291,null)})),multiCursorMergeOverlapping:je(new s(77,"multiCursorMergeOverlapping",!0,{description:d.localize(292,null)})),multiCursorModifier:je(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[d.localize(293,null),d.localize(294,null)],markdownDescription:d.localize(295,null)})),multiCursorPaste:je(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(296,null),d.localize(297,null)],markdownDescription:d.localize(298,null)})),multiCursorLimit:je(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:d.localize(299,null)})),occurrencesHighlight:je(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[d.localize(300,null),d.localize(301,null),d.localize(302,null)],markdownDescription:d.localize(303,null)})),overviewRulerBorder:je(new s(82,"overviewRulerBorder",!0,{description:d.localize(304,null)})),overviewRulerLanes:je(new i(83,"overviewRulerLanes",3,0,3)),padding:je(new Ee),pasteAs:je(new it),parameterHints:je(new pe),peekWidgetDefaultFocus:je(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(305,null),d.localize(306,null)],description:d.localize(307,null)})),definitionLinkOpensInPeek:je(new s(88,"definitionLinkOpensInPeek",!1,{description:d.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(309,null)})),readOnly:je(new s(91,"readOnly",!1)),readOnlyMessage:je(new le),renameOnType:je(new s(93,"renameOnType",!1,{description:d.localize(310,null),markdownDeprecationMessage:d.localize(311,null)})),renderControlCharacters:je(new s(94,"renderControlCharacters",!0,{description:d.localize(312,null),restricted:!0})),renderFinalNewline:je(new c(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:d.localize(313,null)})),renderLineHighlight:je(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(314,null)],description:d.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(316,null)})),renderValidationDecorations:je(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(317,null),d.localize(318,null),d.localize(319,null),""],description:d.localize(320,null)})),revealHorizontalRightPadding:je(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new s(101,"roundedSelection",!0,{description:d.localize(321,null)})),rulers:je(new Ne),scrollbar:je(new Ae),scrollBeyondLastColumn:je(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:d.localize(322,null)})),scrollBeyondLastLine:je(new s(105,"scrollBeyondLastLine",!0,{description:d.localize(323,null)})),scrollPredominantAxis:je(new s(106,"scrollPredominantAxis",!0,{description:d.localize(324,null)})),selectionClipboard:je(new s(107,"selectionClipboard",!0,{description:d.localize(325,null),included:R.$k})),selectionHighlight:je(new s(108,"selectionHighlight",!0,{description:d.localize(326,null)})),selectOnLineNumbers:je(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[d.localize(327,null),d.localize(328,null),d.localize(329,null)],description:d.localize(330,null)})),showUnused:je(new s(111,"showUnused",!0,{description:d.localize(331,null)})),showDeprecated:je(new s(140,"showDeprecated",!0,{description:d.localize(332,null)})),inlayHints:je(new re),snippetSuggestions:je(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(333,null),d.localize(334,null),d.localize(335,null),d.localize(336,null)],description:d.localize(337,null)})),smartSelect:je(new Oe),smoothScrolling:je(new s(114,"smoothScrolling",!1,{description:d.localize(338,null)})),stopRenderingLineAfter:je(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new se),inlineSuggest:je(new j),inlineEdit:je(new z),inlineCompletionsAccessibilityVerbose:je(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:d.localize(339,null)})),suggestFontSize:je(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new s(121,"suggestOnTriggerCharacters",!0,{description:d.localize(342,null)})),suggestSelection:je(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(343,null),d.localize(344,null),d.localize(345,null)],description:d.localize(346,null)})),tabCompletion:je(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(347,null),d.localize(348,null),d.localize(349,null)],description:d.localize(350,null)})),tabIndex:je(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new Ue),unusualLineTerminators:je(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(351,null),d.localize(352,null),d.localize(353,null)],description:d.localize(354,null)})),useShadowDOM:je(new s(127,"useShadowDOM",!0)),useTabStops:je(new s(128,"useTabStops",!0,{description:d.localize(355,null)})),wordBreak:je(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[d.localize(356,null),d.localize(357,null)],description:d.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",M.$Ss,{description:d.localize(359,null)})),wordWrap:je(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(360,null),d.localize(361,null),d.localize(362,null),d.localize(363,null)],description:d.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(365,null)})),wordWrapOverride1:je(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new C),defaultColorDecorators:je(new s(147,"defaultColorDecorators",!1,{markdownDescription:d.localize(366,null)})),pixelRatio:je(new de),tabFocusMode:je(new s(144,"tabFocusMode",!1,{markdownDescription:d.localize(367,null)})),layoutInfo:je(new oe),wrappingInfo:je(new et),wrappingIndent:je(new Ye),wrappingStrategy:je(new $e)}}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[181],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[182],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[183],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[184],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[185],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[186],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[187],Re([1,0,14,155]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function N(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,O.localize)(3,null),d=(0,O.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const y=this.d,u=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:u};this.g.push({offset:y,lexeme:u,additionalInfo:T}),this.f.push(w)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const y=this.c.substring(this.d,this.e),u=f.b.get(y);u?this.k(u):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,y=!1,u=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(d);return}const m=this.c.charCodeAt(T);if(y)y=!1;else if(m===47&&!u){T++;break}else m===91?u=!0:m===92?y=!0:m===93&&(u=!1);T++}for(;T<this.c.length&&f.a.has(this.c.charCodeAt(T));)T++;this.e=T;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$ij=f}),define(Pe[188],Re([1,0,23,32,157,300]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=f,e.$yp=E,e.$zp=T,e.$Ap=y,e.$Bp=u,e.$Cp=w,e.$Dp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,d=/^-(\d{4})(\d{2})(\d{2})$/;function f(s){return s=s.trim(),s==="*"||M.test(s)}function E(s){if(!f(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=s.match(M);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function T(s){if(!s)return null;const r=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let v=s.patchMustEqual;s.hasCaret&&(r===0||(h=!1),v=!1);let c=0;if(s.preRelease){const $=d.exec(s.preRelease);if($){const[,b,p,l]=$;c=Date.UTC(Number(b),Number(p)-1,Number(l))}}return{majorBase:r,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:v,isMinimum:s.hasGreaterEquals,notBefore:c}}function y(s,r,i){let a;typeof s=="string"?a=T(E(s)):a=s;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof i=="string"?t=T(E(i)):t=i,!a||!t)return!1;const v=a.majorBase,c=a.minorBase,$=a.patchBase;let b=t.majorBase,p=t.minorBase,l=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,S=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?v>b?!0:v<b?!1:c>p?!0:c<p||h&&h<D?!1:$>=l:(v===1&&b===0&&(!g||!S||!k)&&(b=1,p=0,l=0,g=!0,S=!1,k=!1),v<b?!1:v>b?!g:c<p?!1:c>p?!S:$<l?!1:$>l?!k:!(h&&h<D))}function u(s,r,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([O.default.Error,R.localize(0,null)]),t;if(typeof a.name!="string")return t.push([O.default.Error,R.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([O.default.Error,R.localize(2,null,"version")]),t;if(!a.engines)return t.push([O.default.Error,R.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([O.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([O.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([O.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([O.default.Error,R.localize(9,null,"main")]),t;{const $=(0,I.$1g)(i,a.main);(0,I.$Ug)($,i)||t.push([O.default.Warning,R.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([O.default.Error,R.localize(11,null,"browser")]),t;{const $=(0,I.$1g)(i,a.browser);(0,I.$Ug)($,i)||t.push([O.default.Warning,R.localize(12,null,$.path,i.path)])}}if(!N.valid(a.version))return t.push([O.default.Error,R.localize(13,null)]),t;const v=[];if(!w(s,r,a,h,v))for(const $ of v)t.push([O.default.Error,$]);return t}function w(s,r,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:n(s,r,i.engines.vscode,h)}function m(s,r,i){return s==="*"||n(r,i,s)}function n(s,r,i,a=[]){const h=T(E(i));if(!h)return a.push(R.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(R.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(R.localize(16,null,i)),!1;return y(s,r,h)?!0:(a.push(R.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let r=0,i=s.length;r<i;r++)if(typeof s[r]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=void 0;class I{constructor(R,N=[],M=!1){this.ctor=R,this.staticArguments=N,this.supportsDelayedInstantiation=M}}e.$ki=I}),define(Pe[55],Re([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ls=N,e.$ms=M;const O=[];var R;(function(d){d[d.Eager=0]="Eager",d[d.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function N(d,f,E){f instanceof I.$ki||(f=new I.$ki(f,[],!!E)),O.push([d,f])}function M(){return O}}),define(Pe[189],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;class I{constructor(N,M){this.key=N,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$2q=I;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const M of this.a.values())M.outgoing.size===0&&N.push(M);return N}insertEdge(N,M){const d=this.lookupOrInsertNode(N),f=this.lookupOrInsertNode(M);d.outgoing.set(f.key,f),f.incoming.set(d.key,d)}removeNode(N){const M=this.b(N);this.a.delete(M);for(const d of this.a.values())d.outgoing.delete(M),d.incoming.delete(M)}lookupOrInsertNode(N){const M=this.b(N);let d=this.a.get(M);return d||(d=new I(M,N),this.a.set(M,d)),d}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[M,d]of this.a)N.push(`${M}
	(-> incoming)[${[...d.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...d.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,M]of this.a){const d=new Set([N]),f=this.c(M,d);if(f)return f}}c(N,M){for(const[d,f]of N.outgoing){if(M.has(d))return[...M,d].join(" -> ");M.add(d);const E=this.c(f,M);if(E)return E;M.delete(d)}}}e.$3q=O}),define(Pe[3],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e._util=void 0,e.$ni=R,e.$oi=N;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function d(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=d})(I||(e._util=I={})),e.$mi=R("instantiationService");function O(M,d,f){d[I.DI_TARGET]===d?d[I.DI_DEPENDENCIES].push({id:M,index:f}):(d[I.DI_DEPENDENCIES]=[{id:M,index:f}],d[I.DI_TARGET]=d)}function R(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const d=function(f,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(d,f,T)};return d.toString=()=>M,I.serviceIds.set(M,d),d}function N(M){return M}}),define(Pe[48],Re([1,0,17,2,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ti=void 0,e.$Ui=N,e.$Vi=M,e.$Wi=f,e.$Xi=E,e.$Yi=T,e.$Zi=y,e.$1i=u,e.$2i=m,e.$3i=n,e.$4i=o,e.$Ti=(0,R.$ni)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof O.URI)}function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof O.URI)}var d;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(d||(e.ConfigurationTarget=d={}));function f(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function T(s,r){const i=Object.create(null);for(const a in s)y(i,a,s[a],r);return i}function y(s,r,i,a){const h=r.split("."),t=h.pop();let v=s;for(let c=0;c<h.length;c++){const $=h[c];let b=v[$];switch(typeof b){case"undefined":b=v[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(b)}`);return}v=b}if(typeof v=="object"&&v!==null)try{v[t]=i}catch{a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(v)}`)}function u(s,r){const i=r.split(".");w(s,i)}function w(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(w(a,r),Object.keys(a).length===0&&delete s[i])}}function m(s,r,i){function a(v,c){let $=v;for(const b of c){if(typeof $!="object"||$===null)return;$=$[b]}return $}const h=r.split("."),t=a(s,h);return typeof t>"u"?i:t}function n(s,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?I.$3f(s[a])&&I.$3f(r[a])?n(s[a],r[a],i):i&&(s[a]=r[a]):s[a]=r[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Pe[33],Re([1,0,21,15,187,3,154,14]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$lj=e.$kj=e.ContextKeyExprType=void 0,e.$jj=E,e.$mj=v,e.$nj=c,e.$Gj=ne;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",I.$j),f.set("isLinux",I.$k),f.set("isWindows",I.$i),f.set("isWeb",I.$o),f.set("isMacNative",I.$j&&!I.$o),f.set("isEdge",I.$H),f.set("isFirefox",I.$F),f.set("isChrome",I.$E),f.set("isSafari",I.$G);function E(re,L){if(f.get(re)!==void 0)throw(0,d.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(re,L)}const T=Object.prototype.hasOwnProperty;var y;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const u={regexParsingWithErrorRecovery:!0},w=(0,M.localize)(0,null),m=(0,M.localize)(1,null),n=(0,M.localize)(2,null),o=(0,M.localize)(3,null),s=(0,M.localize)(4,null),r=(0,M.localize)(5,null),i=(0,M.localize)(6,null),a=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=u){this.k=L,this.d=new R.$ij,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ve=this.D(),Te=ve.type===17?r:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:R.$ij.getLexeme(ve),additionalInfo:Te}),h.c}return _}catch(_){if(_!==h.c)throw _;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const _=this.o();L.push(_)}return L.length===1?L[0]:t.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const _=this.s();L.push(_)}return L.length===1?L[0]:t.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,o),_?.negate()}case 17:return this.z(),P.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,o),_}case 17:{const _=L.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Ee=Te.lexeme,pe=Ee.lastIndexOf("/"),de=pe===Ee.length-1?void 0:this.w(Ee.substring(pe+1));let Q;try{Q=new RegExp(Ee.substring(1,pe),de)}catch{throw this.B("REGEX",Te)}return U.create(_,Q)}switch(Te.type){case 10:case 19:{const Ee=[Te.lexeme];this.z();let pe=this.D(),de=0;for(let Ne=0;Ne<Te.lexeme.length;Ne++)Te.lexeme.charCodeAt(Ne)===40?de++:Te.lexeme.charCodeAt(Ne)===41&&de--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Ne=0;Ne<pe.lexeme.length;Ne++)pe.lexeme.charCodeAt(Ne)===40?de++:Te.lexeme.charCodeAt(Ne)===41&&de--}if(de<0)break;Ee.push(R.$ij.getLexeme(pe)),this.z(),pe=this.D()}const Q=Ee.join(""),Y=Q.lastIndexOf("/"),ue=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let he;try{he=new RegExp(Q.substring(1,Y),ue)}catch{throw this.B("REGEX",Te)}return t.regex(_,he)}case 18:{const Ee=Te.lexeme;this.z();let pe=null;if(!(0,O.$Ze)(Ee)){const de=Ee.indexOf("/"),Q=Ee.lastIndexOf("/");if(de!==Q&&de>=0){const Y=Ee.slice(de+1,Q),ue=Ee[Q+1]==="i"?"i":"";try{pe=new RegExp(Y,ue)}catch{throw this.B("REGEX",Te)}}}if(pe===null)throw this.B("REGEX",Te);return U.create(_,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const Te=this.u();return t.notIn(_,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(_,Te);switch(Te){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(_,Te);switch(Te){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,Te)}}case 5:return this.z(),q.create(_,this.u());case 6:return this.z(),A.create(_,this.u());case 7:return this.z(),W.create(_,this.u());case 8:return this.z(),V.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:L.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,_){if(this.C(L))return this.z();throw this.B(_,this.D())}B(L,_,ve){const Te=(0,M.localize)(8,null,L,R.$ij.getLexeme(_)),Ee=_.offset,pe=R.$ij.getLexeme(_);return this.h.push({message:Te,offset:Ee,lexeme:pe,additionalInfo:ve}),h.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$kj=h;class t{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(L){return l.create(L)}static equals(L,_){return D.create(L,_)}static notEquals(L,_){return k.create(L,_)}static regex(L,_){return U.create(L,_)}static in(L,_){return g.create(L,_)}static notIn(L,_){return S.create(L,_)}static not(L){return P.create(L)}static and(...L){return fe.create(L,null,!0)}static or(...L){return Se.create(L,null,!0)}static greater(L,_){return W.create(L,_)}static greaterEquals(L,_){return V.create(L,_)}static smaller(L,_){return q.create(L,_)}static smallerEquals(L,_){return A.create(L,_)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$lj=t;function v(re){const L=new h({regexParsingWithErrorRecovery:!1});return re.map(_=>(L.parse(_),L.lexingErrors.length>0?L.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,M.localize)(9,null,ve.additionalInfo):(0,M.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function c(re,L){const _=re?re.substituteConstants():void 0,ve=L?L.substituteConstants():void 0;return!_&&!ve?!0:!_||!ve?!1:_.equals(ve)}function $(re,L){return re.cmp(L)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.$oj=b;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.$pj=p;class l{static create(L,_=null){const ve=f.get(L);return typeof ve=="boolean"?ve?p.INSTANCE:b.INSTANCE:new l(L,_)}constructor(L,_){this.key=L,this.c=_,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=f.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$qj=l;class D{static create(L,_,ve=null){if(typeof _=="boolean")return _?l.create(L,ve):P.create(L,ve);const Te=f.get(L);return typeof Te=="boolean"?_===(Te?"true":"false")?p.INSTANCE:b.INSTANCE:new D(L,_,ve)}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=f.get(this.c);if(typeof L=="boolean"){const _=L?"true":"false";return this.d===_?p.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$rj=D;class g{static create(L,_){return new g(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const _=L.getValue(this.f),ve=L.getValue(this.d);return Array.isArray(_)?_.includes(ve):typeof ve=="string"&&typeof _=="object"&&_!==null?T.call(_,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$sj=g;class S{static create(L,_){return new S(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=11,this.c=g.create(L,_)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$tj=S;class k{static create(L,_,ve=null){if(typeof _=="boolean")return _?P.create(L,ve):l.create(L,ve);const Te=f.get(L);return typeof Te=="boolean"?_===(Te?"true":"false")?b.INSTANCE:p.INSTANCE:new k(L,_,ve)}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=f.get(this.c);if(typeof L=="boolean"){const _=L?"true":"false";return this.d===_?b.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$uj=k;class P{static create(L,_=null){const ve=f.get(L);return typeof ve=="boolean"?ve?b.INSTANCE:p.INSTANCE:new P(L,_)}constructor(L,_){this.c=L,this.d=_,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=f.get(this.c);return typeof L=="boolean"?L?b.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$vj=P;function C(re,L){if(typeof re=="string"){const _=parseFloat(re);isNaN(_)||(re=_)}return typeof re=="string"||typeof re=="number"?L(re):b.INSTANCE}class W{static create(L,_,ve=null){return C(_,Te=>new W(L,Te,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$wj=W;class V{static create(L,_,ve=null){return C(_,Te=>new V(L,Te,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$xj=V;class q{static create(L,_,ve=null){return C(_,Te=>new q(L,Te,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$yj=q;class A{static create(L,_,ve=null){return C(_,Te=>new A(L,Te,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$zj=A;class U{static create(L,_){return new U(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const _=this.f?this.f.source:"",ve=L.f?L.f.source:"";return _<ve?-1:_>ve?1:0}equals(L){if(L.type===this.type){const _=this.f?this.f.source:"",ve=L.f?L.f.source:"";return this.d===L.d&&_===ve}return!1}substituteConstants(){return this}evaluate(L){const _=L.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Aj=U;class K{static create(L){return new K(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new K(this.c.map(L))}negate(){return this.c}}e.$Bj=K;function ie(re){let L=null;for(let _=0,ve=re.length;_<ve;_++){const Te=re[_].substituteConstants();if(re[_]!==Te&&L===null){L=[];for(let Ee=0;Ee<_;Ee++)L[Ee]=re[Ee]}L!==null&&(L[_]=Te)}return L===null?re:L}class fe{static create(L,_,ve){return fe.d(L,_,ve)}constructor(L,_){this.expr=L,this.c=_,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let _=0,ve=this.expr.length;_<ve;_++){const Te=$(this.expr[_],L.expr[_]);if(Te!==0)return Te}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].equals(L.expr[_]))return!1;return!0}return!1}substituteConstants(){const L=ie(this.expr);return L===this.expr?this:fe.create(L,this.c,!1)}evaluate(L){for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].evaluate(L))return!1;return!0}static d(L,_,ve){const Te=[];let Ee=!1;for(const pe of L)if(pe){if(pe.type===1){Ee=!0;continue}if(pe.type===0)return b.INSTANCE;if(pe.type===6){Te.push(...pe.expr);continue}Te.push(pe)}if(Te.length===0&&Ee)return p.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort($);for(let pe=1;pe<Te.length;pe++)Te[pe-1].equals(Te[pe])&&(Te.splice(pe,1),pe--);if(Te.length===1)return Te[0];for(;Te.length>1;){const pe=Te[Te.length-1];if(pe.type!==9)break;Te.pop();const de=Te.pop(),Q=Te.length===0,Y=Se.create(pe.expr.map(ue=>fe.create([ue,de],null,ve)),null,Q);Y&&(Te.push(Y),Te.sort($))}if(Te.length===1)return Te[0];if(ve){for(let pe=0;pe<Te.length;pe++)for(let de=pe+1;de<Te.length;de++)if(Te[pe].negate().equals(Te[de]))return b.INSTANCE;if(Te.length===1)return Te[0]}return new fe(Te,_)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const _ of this.expr)L.push(..._.keys());return L}map(L){return new fe(this.expr.map(_=>_.map(L)),null)}negate(){if(!this.c){const L=[];for(const _ of this.expr)L.push(_.negate());this.c=Se.create(L,this,!0)}return this.c}}e.$Cj=fe;class Se{static create(L,_,ve){return Se.d(L,_,ve)}constructor(L,_){this.expr=L,this.c=_,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let _=0,ve=this.expr.length;_<ve;_++){const Te=$(this.expr[_],L.expr[_]);if(Te!==0)return Te}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].equals(L.expr[_]))return!1;return!0}return!1}substituteConstants(){const L=ie(this.expr);return L===this.expr?this:Se.create(L,this.c,!1)}evaluate(L){for(let _=0,ve=this.expr.length;_<ve;_++)if(this.expr[_].evaluate(L))return!0;return!1}static d(L,_,ve){let Te=[],Ee=!1;if(L){for(let pe=0,de=L.length;pe<de;pe++){const Q=L[pe];if(Q){if(Q.type===0){Ee=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Te=Te.concat(Q.expr);continue}Te.push(Q)}}if(Te.length===0&&Ee)return b.INSTANCE;Te.sort($)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let pe=1;pe<Te.length;pe++)Te[pe-1].equals(Te[pe])&&(Te.splice(pe,1),pe--);if(Te.length===1)return Te[0];if(ve){for(let pe=0;pe<Te.length;pe++)for(let de=pe+1;de<Te.length;de++)if(Te[pe].negate().equals(Te[de]))return p.INSTANCE;if(Te.length===1)return Te[0]}return new Se(Te,_)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const _ of this.expr)L.push(..._.keys());return L}map(L){return new Se(this.expr.map(_=>_.map(L)),null)}negate(){if(!this.c){const L=[];for(const _ of this.expr)L.push(_.negate());for(;L.length>1;){const _=L.shift(),ve=L.shift(),Te=[];for(const Ee of ze(_))for(const pe of ze(ve))Te.push(fe.create([Ee,pe],null,!1));L.unshift(Se.create(Te,null,!1))}this.c=Se.create(L,this,!0)}return this.c}}e.$Dj=Se;class ke extends l{static{this.d=[]}static all(){return ke.d.values()}constructor(L,_,ve){super(L,null),this.f=_,typeof ve=="object"?ke.d.push({...ve,key:L}):ve!==!0&&ke.d.push({key:L,description:ve,type:_!=null?typeof _:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return D.create(this.key,L)}notEqualsTo(L){return k.create(this.key,L)}}e.$Ej=ke,e.$Fj=(0,N.$ni)("contextKeyService");function oe(re,L){return re<L?-1:re>L?1:0}function $e(re,L,_,ve){return re<_?-1:re>_?1:L<ve?-1:L>ve?1:0}function ne(re,L){if(re.type===0||L.type===1)return!0;if(re.type===9)return L.type===9?Ie(re.expr,L.expr):!1;if(L.type===9){for(const _ of L.expr)if(ne(re,_))return!0;return!1}if(re.type===6){if(L.type===6)return Ie(L.expr,re.expr);for(const _ of re.expr)if(ne(_,L))return!0;return!1}return re.equals(L)}function Ie(re,L){let _=0,ve=0;for(;_<re.length&&ve<L.length;){const Te=re[_].cmp(L[ve]);if(Te<0)return!1;Te===0&&_++,ve++}return _===re.length}function ze(re){return re.type===9?re.expr:[re]}}),define(Pe[190],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=void 0,e.$ui=(0,I.$ni)("environmentService"),e.$vi=(0,I.$oi)(e.$ui)}),define(Pe[98],Re([1,0,156,3]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.ExtensionGalleryErrorCode=e.$Xo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Wo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Qo=R,e.$Ro=N,e.$So=M,e.$To=d,e.$Uo=f,e.$Vo=E,e.$Ko="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Lo=new RegExp(e.$Ko),e.$Mo="__web_extension",e.$No="skipWalkthrough",e.$Oo="extensionsSync",e.$Po="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function d(i,a){return a==="web"&&!i.includes("web")}function f(i,a,h){return d(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var y;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Wo=(0,O.$ni)("extensionGalleryService");var m;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var n;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Xo=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class r extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Yo=r,e.$Zo=(0,O.$ni)("extensionManagementService"),e.$1o="extensionsIdentifiers/disabled",e.$2o="extensionsIdentifiers/enabled",e.$3o=(0,O.$ni)("IGlobalExtensionEnablementService"),e.$4o=(0,O.$ni)("IExtensionTipsService"),e.$5o=(0,I.localize2)(0,"Extensions"),e.$6o=(0,I.localize2)(1,"Preferences")}),define(Pe[43],Re([1,0,52,19,15,17,2,158,3,21,12,40]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ml=e.FileKind=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.FileOperationResult=e.$el=e.$dl=e.$cl=e.$al=e.FileChangeType=e.$_k=e.FileOperation=e.$6k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tk=void 0,e.$Uk=u,e.$Vk=n,e.$Wk=s,e.$Xk=r,e.$Yk=i,e.$Zk=a,e.$1k=h,e.$2k=t,e.$3k=v,e.$4k=c,e.$5k=$,e.$7k=l,e.$8k=D,e.$9k=g,e.$0k=S,e.$$k=k,e.$bl=q,e.$nl=Se,e.$ol=ke,e.$ql=$e,e.$Tk=(0,f.$ni)("fileService");function u(ne){return ne.create===!0}var w;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var m;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function n(ne){const Ie=ne;return!!Ie&&typeof Ie.onDidChange=="function"}var o;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(ne){return!!(ne.capabilities&2)}function r(ne){return!!(ne.capabilities&8)}function i(ne){return!!(ne.capabilities&131072)}function a(ne){return!!(ne.capabilities&4)}function h(ne){return!!(ne.capabilities&16)}function t(ne){return s(ne)?!!(ne.capabilities&16384):!1}function v(ne){return s(ne)?!!(ne.capabilities&32768):!1}function c(ne){return!!(ne.capabilities&65536)}function $(ne){return!!(ne.capabilities&2048)}var b;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class p extends Error{static create(Ie,ze){const re=new p(Ie.toString(),ze);return g(re,ze),re}constructor(Ie,ze){super(Ie),this.code=ze}}e.$6k=p;function l(ne,Ie){return p.create(ne,Ie)}function D(ne){return ne||l((0,d.localize)(0,null),b.Unknown)}function g(ne,Ie){return ne.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",ne}function S(ne){if(!ne)return b.Unknown;if(ne instanceof p)return ne.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Ie)return b.Unknown;switch(Ie[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}function k(ne){if(ne instanceof A)return ne.fileOperationResult;switch(S(ne)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}var P;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class C{constructor(Ie,ze,re){this.resource=Ie,this.operation=ze,this.target=re}isOperation(Ie){return this.operation===Ie}}e.$_k=C;var W;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class V{static{this.a=null}constructor(Ie,ze){this.c=ze,this.b=void 0,this.d=new y.$V(()=>{const re=I.$ti.forUris(()=>this.c);return re.fill(this.rawAdded.map(L=>[L,!0])),re}),this.f=new y.$V(()=>{const re=I.$ti.forUris(()=>this.c);return re.fill(this.rawUpdated.map(L=>[L,!0])),re}),this.g=new y.$V(()=>{const re=I.$ti.forUris(()=>this.c);return re.fill(this.rawDeleted.map(L=>[L,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of Ie){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==V.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Ie,...ze){return this.h(Ie,{includeChildren:!1},...ze)}affects(Ie,...ze){return this.h(Ie,{includeChildren:!0},...ze)}h(Ie,ze,...re){if(!Ie)return!1;const L=re.length>0;return!!((!L||re.includes(1))&&(this.d.value.get(Ie)||ze.includeChildren&&this.d.value.findSuperstr(Ie))||(!L||re.includes(0))&&(this.f.value.get(Ie)||ze.includeChildren&&this.f.value.findSuperstr(Ie))||(!L||re.includes(2))&&(this.g.value.findSubstr(Ie)||ze.includeChildren&&this.g.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.b===Ie}hasCorrelation(){return typeof this.b=="number"}}e.$al=V;function q(ne,Ie,ze){return!ne||!Ie||ne===Ie||Ie.length>ne.length?!1:(Ie.charAt(Ie.length-1)!==O.sep&&(Ie+=O.sep),ze?(0,R.$rf)(ne,Ie):ne.indexOf(Ie)===0)}class A extends Error{constructor(Ie,ze,re){super(Ie),this.fileOperationResult=ze,this.options=re}}e.$cl=A;class U extends A{constructor(Ie,ze,re,L){super(Ie,ze,L),this.fileOperationResult=ze,this.size=re}}e.$dl=U;class K extends A{constructor(Ie,ze,re){super(Ie,2,re),this.stat=ze}}e.$el=K;var ie;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$fl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$gl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$hl="files.associations",e.$il="files.exclude",e.$jl="files.readonlyInclude",e.$kl="files.readonlyExclude",e.$ll="files.readonlyFromPermissions";var fe;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$ml="";function Se(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function ke(ne,Ie){if(!Ie.hasProvider(M.URI.from({scheme:ne.scheme})))return new Promise(ze=>{const re=Ie.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===ne.scheme&&L.added&&(re.dispose(),ze())})})}class oe{static{this.KB=1024}static{this.MB=oe.KB*oe.KB}static{this.GB=oe.MB*oe.KB}static{this.TB=oe.GB*oe.KB}static formatSize(Ie){return(0,N.$5f)(Ie)||(Ie=0),Ie<oe.KB?(0,d.localize)(1,null,Ie.toFixed(0)):Ie<oe.MB?(0,d.localize)(2,null,(Ie/oe.KB).toFixed(2)):Ie<oe.GB?(0,d.localize)(3,null,(Ie/oe.MB).toFixed(2)):Ie<oe.TB?(0,d.localize)(4,null,(Ie/oe.GB).toFixed(2)):(0,d.localize)(5,null,(Ie/oe.TB).toFixed(2))}}e.$pl=oe;function $e(ne){const Ie=typeof ne=="string"||ne?.scheme===T.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===T.Schemas.file?1024*oe.MB:Ie?10*oe.MB:E.$o?50*oe.MB:1024*oe.MB}}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=void 0;class I{constructor(...R){this.a=new Map;for(const[N,M]of R)this.set(N,M)}set(R,N){const M=this.a.get(R);return this.a.set(R,N),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$li=I}),define(Pe[191],Re([1,0,11,14,6,70,189,3,71,192]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;const T=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new f.$li,s=!1,r,i=T){this.i=o,this.j=s,this.k=r,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(d.$mi,this),this._globalGraph=i?r?._globalGraph??new M.$3q(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const s=new class extends u{dispose(){this.h.delete(s),super.dispose()}}(o,this.j,this,this.l);return this.h.add(s),s}invokeFunction(o,...s){this.m();const r=m.traceInvocation(this.l,o);let i=!1;try{return o({get:h=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,r.stop()}}createInstance(o,...s){this.m();let r,i;return o instanceof N.$ki?(r=m.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(s),r)):(r=m.traceCreation(this.l,o),i=this.o(o,s,r)),r.stop(),i}o(o,s=[],r){const i=d._util.getServiceDependencies(o).sort((t,v)=>t.index-v.index),a=[];for(const t of i){const v=this.s(t.id,r);v||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(v)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}q(o,s){if(this.i.get(o)instanceof N.$ki)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.r(o);return r instanceof N.$ki?this.u(o,r,s.branch(o,!0)):(s.branch(o,!1),r)}u(o,s,r){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,r)}finally{this.t.delete(o)}}v(o,s,r){const i=new M.$3q(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:r}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new y(i);for(const v of d._util.getServiceDependencies(t.desc.ctor)){const c=this.r(v.id);if(c||this.y(`[createInstance] ${o} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(v.id)),c instanceof N.$ki){const $={id:v.id,desc:c,_trace:t._trace.branch(v.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:v}of t){if(this.r(v.id)instanceof N.$ki){const $=this.w(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.q(v.id,$)}i.removeNode(v)}}return this.r(o)}w(o,s,r=[],i,a){if(this.i.get(o)instanceof N.$ki)return this.x(o,s,r,i,a,this.g);if(this.k)return this.k.w(o,s,r,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,r=[],i,a,h){if(i){const t=new u(void 0,this.j,this,this.l);t.c=String(o);const v=new Map,c=new I.$Gh(()=>{const $=t.o(s,r,a);for(const[b,p]of v){const l=$[b];if(typeof l=="function")for(const D of p)D.disposable=l.apply($,D.listener)}return v.clear(),h.add($),$});return new Proxy(Object.create(null),{get($,b){if(!c.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let D=v.get(b);return D||(D=new E.$5c,v.set(b,D)),(S,k,P)=>{if(c.isInitialized)return c.value[b](S,k,P);{const C={listener:[S,k,P],disposable:void 0},W=D.push(C);return(0,R.$Sc)(()=>{W(),C.disposable?.dispose()})}}}if(b in $)return $[b];const p=c.value;let l=p[b];return typeof l!="function"||(l=l.bind(p),$[b]=l),l},set($,b,p){return c.value[b]=p,!0},getPrototypeOf($){return s.prototype}})}else{const t=this.o(s,r,a);return h.add(t),t}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$4q=u;var w;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(w||(w={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new m(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,s){return o?new m(1,s.name):m.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const r=new m(3,o.toString());return this.h.push([o,s,r]),r}stop(){const o=Date.now()-this.g;m.f+=o;let s=!1;function r(a,h){const t=[],v=new Array(a+1).join("	");for(const[c,$,b]of h.h)if($&&b){s=!0,t.push(`${v}CREATES -> ${c}`);const p=r(a+1,b);p&&t.push(p)}else t.push(`${v}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||s)&&m.all.add(i.join(`
`))}}e.$5q=m}),define(Pe[13],Re([1,0,159,42,5,99,6,28,21,23,17,2,33,3]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Wj=e.LogLevel=e.$Uj=e.$Tj=void 0,e.$Vj=n,e.log=s,e.$8j=l,e.$9j=D,e.$0j=g,e.$$j=S,e.$Tj=(0,w.$ni)("logService"),e.$Uj=(0,w.$ni)("loggerService");function m(){return new Date().toISOString()}function n(k){return(0,T.$5f)(k)}var o;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Wj=o.Info;function s(k,P,C){switch(P){case o.Trace:k.trace(C);break;case o.Debug:k.debug(C);break;case o.Info:k.info(C);break;case o.Warning:k.warn(C);break;case o.Error:k.error(C);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function r(k,P=!1){let C="";for(let W=0;W<k.length;W++){let V=k[W];if(V instanceof Error&&(V=(0,O.$$i)(V,P)),typeof V=="object")try{V=JSON.stringify(V)}catch{}C+=(W>0?" ":"")+V}return C}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Wj,this.c=this.B(new R.$_d),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$Yj=i;class a extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...C){this.f(o.Trace)&&this.g(o.Trace,r([P,...C],!0))}debug(P,...C){this.f(o.Debug)&&this.g(o.Debug,r([P,...C]))}info(P,...C){this.f(o.Info)&&this.g(o.Info,r([P,...C]))}warn(P,...C){this.f(o.Warning)&&this.g(o.Warning,r([P,...C]))}error(P,...C){if(this.f(o.Error))if(P instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=P.stack,this.g(o.Error,r(W))}else this.g(o.Error,r([P,...C]))}flush(){}}e.$Zj=a;class h extends i{constructor(P=e.$Wj){super(),this.setLevel(P),this.g=!f.$i}trace(P,...C){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,P,...C):console.warn(`[main ${m()}]`,P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,P,...C):console.error(`[main ${m()}]`,P,...C))}flush(){}}e.$1j=h;class t extends i{constructor(P=e.$Wj,C=!0){super(),this.g=C,this.setLevel(P)}trace(P,...C){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...C):console.log(P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...C):console.log(P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...C):console.log(P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...C):console.log(P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...C):console.error(P,...C))}flush(){}}e.$2j=t;class v extends i{constructor(P,C=e.$Wj){super(),this.g=P,this.setLevel(C)}trace(P,...C){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...C])}debug(P,...C){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...C])}info(P,...C){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...C])}warn(P,...C){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...C])}error(P,...C){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...C])}h(P){return typeof P=="string"?P:(0,O.$$i)(P,this.f(o.Trace))}flush(){}}e.$3j=v;class c extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const C of this.g)C.setLevel(P);super.setLevel(P)}trace(P,...C){for(const W of this.g)W.trace(P,...C)}debug(P,...C){for(const W of this.g)W.debug(P,...C)}info(P,...C){for(const W of this.g)W.info(P,...C)}warn(P,...C){for(const W of this.g)W.warn(P,...C)}error(P,...C){for(const W of this.g)W.error(P,...C)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$4j=c;class $ extends M.$Uc{constructor(P,C,W){if(super(),this.h=P,this.j=C,this.b=new d.$Bc,this.c=this.B(new R.$_d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$_d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$_d),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(P){return(0,T.$1f)(P)?[...this.b.values()].find(C=>C.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,C){const W=this.n(P),V=(0,T.$1f)(P)?P:C?.id??(0,N.$bj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const A=C?.logLevel==="always"?o.Trace:C?.logLevel;q||(q=this.s(W,A??this.getLogLevel(W)??this.h,{...C,id:V}));const U={logger:q,info:{resource:W,id:V,logLevel:A,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(U.info),this.b.set(W,U),q}n(P){return(0,T.$1f)(P)?(0,E.$1g)(this.j,`${P}.log`):P}setLogLevel(P,C){if(y.URI.isUri(P)){const W=P,V=C,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=P;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,C){const W=this.m(P);W&&C!==!W.info.hidden&&(W.info.hidden=!C,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,C]))}getLogLevel(P){let C;return P&&(C=this.b.get(P)?.info.logLevel),C??this.h}registerLogger(P){const C=this.b.get(P.resource);C?C.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const C=this.b.get(P);C&&(C.logger&&C.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$5j=$;class b{constructor(){this.onDidChangeLogLevel=new R.$_d().event}setLevel(P){}getLevel(){return o.Info}trace(P,...C){}debug(P,...C){}info(P,...C){}warn(P,...C){}error(P,...C){}critical(P,...C){}dispose(){}flush(){}}e.$6j=b;class p extends b{}e.$7j=p;function l(k){if(k.verbose)return o.Trace;if(typeof k.logLevel=="string"){const P=S(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Wj}function D(k){switch(k){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(k){switch(k){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(k){switch(k){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$_j=new u.$Ej("logLevel",D(o.Info))}),define(Pe[193],Re([1,0,6,13]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=void 0;class R extends I.$Uc{constructor(M,d=[]){super(),this.a=new O.$4j([M,...d]),this.B(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...d){this.a.trace(M,...d)}debug(M,...d){this.a.debug(M,...d)}info(M,...d){this.a.info(M,...d)}warn(M,...d){this.a.warn(M,...d)}error(M,...d){this.a.error(M,...d)}flush(){this.a.flush()}}e.$gQ=R}),define(Pe[100],Re([1,0,32,160,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var M;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(f){function E(m,n){return n-m}f.compare=E;const T=Object.create(null);T[f.Error]=(0,O.localize)(0,null),T[f.Warning]=(0,O.localize)(1,null),T[f.Info]=(0,O.localize)(2,null);function y(m){return T[m]||""}f.toString=y;function u(m){switch(m){case I.default.Error:return f.Error;case I.default.Warning:return f.Warning;case I.default.Info:return f.Info;case I.default.Ignore:return f.Hint}}f.fromSeverity=u;function w(m){switch(m){case f.Error:return I.default.Error;case f.Warning:return I.default.Warning;case f.Info:return I.default.Info;case f.Hint:return I.default.Ignore}}f.toSeverity=w}(M||(e.MarkerSeverity=M={}));var d;(function(f){const E="";function T(u){return y(u,!0)}f.makeKey=T;function y(u,w){const m=[E];return u.source?m.push(u.source.replace("\xA6","\\\xA6")):m.push(E),u.code?typeof u.code=="string"?m.push(u.code.replace("\xA6","\\\xA6")):m.push(u.code.value.replace("\xA6","\\\xA6")):m.push(E),u.severity!==void 0&&u.severity!==null?m.push(M.toString(u.severity)):m.push(E),u.message&&w?m.push(u.message.replace("\xA6","\\\xA6")):m.push(E),u.startLineNumber!==void 0&&u.startLineNumber!==null?m.push(u.startLineNumber.toString()):m.push(E),u.startColumn!==void 0&&u.startColumn!==null?m.push(u.startColumn.toString()):m.push(E),u.endLineNumber!==void 0&&u.endLineNumber!==null?m.push(u.endLineNumber.toString()):m.push(E),u.endColumn!==void 0&&u.endColumn!==null?m.push(u.endColumn.toString()):m.push(E),m.push(E),m.join("\xA6")}f.makeKeyOptionalMessage=y})(d||(e.IMarkerData=d={})),e.$Qt=(0,R.$ni)("markerService")}),define(Pe[194],Re([1,0,5,32,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Qv=e.Severity=void 0,e.$Rv=d,e.Severity=O.default,e.$Qv=(0,R.$ni)("notificationService");var N;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function d(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var f;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class E{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Sv=E;class T{infinite(){}done(){}total(u){}worked(u){}}e.$Tv=T}),define(Pe[195],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=void 0,e.$ak=(0,I.$ni)("productService"),e.$bk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,O){var R=arguments.length,N=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,I):O,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ge,e,I,O);else for(var d=ge.length-1;d>=0;d--)(M=ge[d])&&(N=(R<3?M(N):R>3?M(e,I,N):M(e,I))||N);return R>3&&N&&Object.defineProperty(e,I,N),N},We=this&&this.__param||function(ge,e){return function(I,O){e(I,O,ge)}};define(Pe[101],Re([1,0,11,24,6,3]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.ProgressLocation=e.$Uv=void 0,e.$Uv=(0,N.$ni)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Vv=Object.freeze({total(){},worked(){},done(){}});class d{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Wv=d;class f{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const w=this.d;this.d=()=>{w?.(),u()}}):Promise.resolve()}}e.$Xv=f;let E=class extends R.$Uc{constructor(u,w){super(),this.a=new I.$Kh,w.withProgress(u,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Yv=E,e.$Yv=E=Je([We(1,e.$Uv)],E);class T extends R.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new R.$Tc)}start(u){this.stop();const w=++this.a,m=new O.$je;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>m.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:m.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Zv=T,e.$1v=(0,N.$ni)("editorProgressService")}),define(Pe[30],Re([1,0,56,17]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=void 0;class R{constructor(){this.a=new Map}add(M,d){I.ok(O.$1f(M)),I.ok(O.$3f(d)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,d)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$6n=new R}),define(Pe[72],Re([1,0,5,30]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=void 0,e.$7n={JSONContribution:"base.contributions.json"};function R(d){return d.length>0&&d.charAt(d.length-1)==="#"?d.substring(0,d.length-1):d}class N{constructor(){this.b=new I.$_d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,E){this.a[R(f)]=E,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const M=new N;O.$6n.add(e.$7n.JSONContribution,M)}),define(Pe[57],Re([1,0,18,5,17,153,48,72,30]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ConfigurationScope=e.$$n=e.EditPresentationTypes=void 0,e.$jo=n,e.$ko=o,e.$lo=s,e.$mo=i,e.$no=a;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$$n={Configuration:"base.contributions.configuration"};var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$_n={properties:{},patternProperties:{}},e.$ao={properties:{},patternProperties:{}},e.$bo={properties:{},patternProperties:{}},e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo="vscode://schemas/settings/resourceLanguage",e.$go="vscode://schemas/settings/configurationDefaults";const y=f.$6n.as(d.$7n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new O.$_d,this.onDidSchemaChange=this.i.event,this.j=new O.$_d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$fo,this.g),this.v()}registerConfiguration(t,v=!0){this.registerConfigurations([t],v)}registerConfigurations(t,v=!0){const c=new Set;this.n(t,v,c),y.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const v=new Set;this.o(t,v),y.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:t,remove:v}){const c=new Set;this.o(v,c),this.n(t,!1,c),y.registerSchema(e.$fo,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const v=new Set;this.k(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(t,v){const c=[];for(const{overrides:$,source:b}of t)for(const p in $)if(v.add(p),e.$io.test(p)){const l=this.a.get(p),D=l?.valuesSources??new Map;if(b)for(const P of Object.keys($[p]))D.set(P,b);const g={...l?.value||{},...$[p]};this.a.set(p,{source:b,value:g,valuesSources:D});const S=(0,M.$4i)(p),k={type:"object",default:g,description:N.localize(1,null,S),$ref:e.$fo,defaultDefaultValue:g,source:R.$1f(b)?void 0:b,defaultValueSource:b};c.push(...n(p)),this.d[p]=k,this.b.properties[p]=k}else{this.a.set(p,{value:$[p],source:b});const l=this.d[p];l&&(this.w(p,l),this.r(p,l))}this.m(c)}deregisterDefaultConfigurations(t){const v=new Set;this.l(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(t,v){for(const{overrides:c,source:$}of t)for(const b in c){const p=this.a.get(b),l=R.$1f($)?$:$?.id,D=R.$1f(p?.source)?p?.source:p?.source?.id;if(l===D)if(v.add(b),this.a.delete(b),e.$io.test(b))delete this.d[b],delete this.b.properties[b];else{const g=this.d[b];g&&(this.w(b,g),this.r(b,g))}}this.u()}deltaConfiguration(t){let v=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),v=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),v=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const v of t)this.h.add(v);this.u()}n(t,v,c){t.forEach($=>{this.p($,v,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,v){const c=$=>{if($.properties)for(const b in $.properties){v.add(b);const p=this.d[b];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[b],this.s(b,$.properties[b])}$.allOf?.forEach(b=>c(b))};for(const $ of t){c($);const b=this.c.indexOf($);b!==-1&&this.c.splice(b,1)}}p(t,v=!0,c,$,b=3,p){b=R.$0f(t.scope)?b:t.scope;const l=t.properties;if(l)for(const g in l){const S=l[g];if(v&&i(g,S)){delete l[g];continue}if(S.source=c,S.defaultDefaultValue=l[g].default,this.w(g,S),e.$io.test(g)?S.scope=void 0:(S.scope=R.$0f(S.scope)?b:S.scope,S.restricted=R.$0f(S.restricted)?!!$?.includes(g):S.restricted),l[g].hasOwnProperty("included")&&!l[g].included){this.f[g]=l[g],delete l[g];continue}else this.d[g]=l[g],l[g].policy?.name&&this.e.set(l[g].policy.name,g);!l[g].deprecationMessage&&l[g].markdownDeprecationMessage&&(l[g].deprecationMessage=l[g].markdownDeprecationMessage),p.add(g)}const D=t.allOf;if(D)for(const g of D)this.p(g,v,c,$,b,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const v=c=>{const $=c.properties;if($)for(const p in $)this.r(p,$[p]);c.allOf?.forEach(v)};v(t)}r(t,v){switch(e.$_n.properties[t]=v,v.scope){case 1:e.$ao.properties[t]=v;break;case 2:e.$bo.properties[t]=v;break;case 6:e.$co.properties[t]=v;break;case 3:e.$do.properties[t]=v;break;case 4:e.$eo.properties[t]=v;break;case 5:e.$eo.properties[t]=v,this.g.properties[t]=v;break}}s(t,v){switch(delete e.$_n.properties[t],v.scope){case 1:delete e.$ao.properties[t];break;case 2:delete e.$bo.properties[t];break;case 6:delete e.$co.properties[t];break;case 3:delete e.$do.properties[t];break;case 4:case 5:delete e.$eo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const v=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$fo};this.w(v,c),e.$_n.properties[v]=c,e.$ao.properties[v]=c,e.$bo.properties[v]=c,e.$co.properties[v]=c,e.$do.properties[v]=c,e.$eo.properties[v]=c}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$fo};e.$_n.patternProperties[e.$ho]=t,e.$ao.patternProperties[e.$ho]=t,e.$bo.patternProperties[e.$ho]=t,e.$co.patternProperties[e.$ho]=t,e.$do.patternProperties[e.$ho]=t,e.$eo.patternProperties[e.$ho]=t,this.i.fire()}w(t,v){const c=this.a.get(t);let $=c?.value,b=c?.source;R.$8f($)&&($=v.defaultDefaultValue,b=void 0),R.$8f($)&&($=s(v.type)),v.default=$,v.defaultValueSource=b}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$ho=`^(${w})+$`,e.$io=new RegExp(e.$ho);function n(h){const t=[];if(e.$io.test(h)){let v=m.exec(h);for(;v?.length;){const c=v[1].trim();c&&t.push(c),v=m.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,v)=>`${t}[${v}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const r=new u;f.$6n.add(e.$$n.Configuration,r);function i(h,t){return h.trim()?e.$io.test(h)?N.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function a(){const h=[],t=r.getConfigurationProperties();for(const v of Object.keys(t))h.push([v,t[v].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Pe[196],Re([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$so=i;function w(v){return Object.isFrozen(v)?v:d.$Un(v)}class m{constructor(c={},$=[],b=[],p){this.b=c,this.c=$,this.d=b,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof m)return $;const b=new n("");return b.parseRaw($),b.configurationModel});this.f=c.reduce(($,b)=>b===$?b:$.merge(b),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,T.$2i)(this.contents,c):this.contents}inspect(c,$){const b=this;return{get value(){return w(b.rawConfiguration.getValue(c))},get override(){return $?w(b.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return w($?b.rawConfiguration.override($).getValue(c):b.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:l,identifiers:D,keys:g}of b.rawConfiguration.overrides){const S=new m(l,g).getValue(c);S!==void 0&&p.push({identifiers:D,value:S})}return p.length?w(p):void 0}}}getOverrideValue(c,$){const b=this.i($);return b?c?(0,T.$2i)(b,c):b:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const b of this.overrides)b.identifiers.includes(c)&&$.push(...b.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=d.$Tn(this.contents),b=d.$Tn(this.overrides),p=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const g of D.overrides){const[S]=b.filter(k=>I.$ub(k.identifiers,g.identifiers));S?(this.h(S.contents,g.contents),S.keys.push(...g.keys),S.keys=I.$Mb(S.keys)):b.push(d.$Tn(g))}for(const g of D.keys)p.indexOf(g)===-1&&p.push(g)}return new m($,p,b,l.every(D=>D instanceof m)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const b={};for(const p of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[p];const D=$[p];D&&(typeof l=="object"&&typeof D=="object"?(l=d.$Tn(l),this.h(l,D)):l=D),b[p]=l}return new m(b,this.keys,this.overrides)}h(c,$){for(const b of Object.keys($)){if(b in c&&f.$3f(c[b])&&f.$3f($[b])){this.h(c[b],$[b]);continue}c[b]=d.$Tn($[b])}}i(c){let $=null,b=null;const p=l=>{l&&(b?this.h(b,l):b=d.$Tn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&p(l.contents);return p($),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,T.$1i)(this.contents,c),y.$io.test(c)&&this.overrides.splice(this.overrides.findIndex(b=>I.$ub(b.identifiers,(0,y.$jo)(c))),1))}j(c,$,b){(0,T.$Zi)(this.contents,c,$,p=>console.error(p)),b=b||this.keys.indexOf(c)===-1,b&&this.keys.push(c),y.$io.test(c)&&this.overrides.push({identifiers:(0,y.$jo)(c),keys:Object.keys(this.contents[c]),contents:(0,T.$Yi)(this.contents[c],p=>console.error(p))})}}e.$oo=m;class n{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!f.$0f(c)){const b=this.g(c);this.parseRaw(b,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:b,keys:p,overrides:l,restricted:D,hasExcludedProperties:g}=this.h(c,$);this.b=new m(b,p,l,g?[c]:void 0),this.c=D||[]}g(c){let $={},b=null,p=[];const l=[],D=[];function g(k){Array.isArray(p)?p.push(k):b!==null&&(p[b]=k)}const S={onObjectBegin:()=>{const k={};g(k),l.push(p),p=k,b=null},onObjectProperty:k=>{b=k},onObjectEnd:()=>{p=l.pop()},onArrayBegin:()=>{const k=[];g(k),l.push(p),p=k,b=null},onArrayEnd:()=>{p=l.pop()},onLiteralValue:g,onError:(k,P,C)=>{D.push({error:k,offset:P,length:C})}};if(c)try{R.$Hn(c,S),$=p[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return $}h(c,$){const b=u.$6n.as(y.$$n.Configuration).getConfigurationProperties(),p=this.i(c,b,!0,$);c=p.raw;const l=(0,T.$Yi)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),g=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:g,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,$,b,p){let l=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},g=[];for(const S in c)if(y.$io.test(S)&&b){const k=this.i(c[S],$,!1,p);D[S]=k.raw,l=l||k.hasExcludedProperties,g.push(...k.restricted)}else{const k=$[S],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&g.push(S),!p.exclude?.includes(S)&&(p.include?.includes(S)||(P===void 0||p.scopes===void 0||p.scopes.includes(P))&&!(p.skipRestricted&&k?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:g,hasExcludedProperties:l}}j(c,$){const b=[];for(const p of Object.keys(c))if(y.$io.test(p)){const l={};for(const D in c[p])l[D]=c[p][D];b.push({identifiers:(0,y.$jo)(p),keys:Object.keys(l),contents:(0,T.$Yi)(l,$)})}return b}}e.$po=n;class o extends N.$Uc{constructor(c,$,b,p){super(),this.c=c,this.f=$,this.g=p,this.b=this.B(new O.$_d),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&b.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qo=o;class s{constructor(c,$,b,p,l,D,g,S,k,P,C,W,V){this.a=c,this.b=$,this.c=b,this.overrideIdentifiers=p,this.d=l,this.f=D,this.g=g,this.h=S,this.i=k,this.j=P,this.k=C,this.l=W,this.m=V}get value(){return w(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(c,$,b,p,l=new m,D=new m,g=new M.$Bc,S=new m,k=new M.$Bc){this.c=c,this.d=$,this.f=b,this.g=p,this.h=l,this.i=D,this.j=g,this.l=S,this.m=k,this.a=null,this.b=new M.$Bc,this.n=null}getValue(c,$,b){return this.p(c,$,b).getValue(c)}updateValue(c,$,b={}){let p;b.resource?(p=this.m.get(b.resource),p||(p=new m,this.m.set(b.resource,p))):p=this.l,$===void 0?p.removeValue(c):p.setValue(c,$),b.resource||(this.a=null)}inspect(c,$,b){const p=this.p(c,$,b),l=this.t($.resource,b),D=$.resource?this.m.get($.resource)||this.l:this.l,g=new Set;for(const S of p.overrides)for(const k of S.identifiers)p.getOverrideValue(c,k)!==void 0&&g.add(k);return new s(c,$,p.getValue(c),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const b=[];if(!$){const{added:p,updated:l,removed:D}=h(this.c,c);$=[...p,...l,...D]}for(const p of $)for(const l of(0,y.$jo)(p)){const D=this.c.getKeysForOverrideIdentifier(l),g=c.getKeysForOverrideIdentifier(l),S=[...g.filter(k=>D.indexOf(k)===-1),...D.filter(k=>g.indexOf(k)===-1),...D.filter(k=>!d.$Xn(this.c.override(l).getValue(k),c.override(l).getValue(k)))];b.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:b}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:b,removed:p}=h(this.d,c),l=[...$,...b,...p];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const b=this.folderConfigurations.get(c),{added:p,updated:l,removed:D,overrides:g}=h(b,$),S=[...p,...l,...D];return(S.length||!b)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:g}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:b,updated:p,removed:l,overrides:D}=h($,void 0);return{keys:[...b,...p,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,b){let p=this.q($,b);return $.overrideIdentifier&&(p=p.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},$){let b=this.r();if($&&c){const p=$.getFolder(c);p&&(b=this.s(p.uri)||b);const l=this.m.get(c);l&&(b=b.merge(l))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const b=this.r(),p=this.j.get(c);p?($=b.merge(p),this.b.set(c,$)):$=b}return $}t(c,$){if($&&c){const b=$.getFolder(c);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:b,overrides:p,keys:l}=this.j.get($);return c.push([$,{contents:b,overrides:p,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(b=>c.add(b))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(b=>c.add(b))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(b=>$.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>$.add(b)),this.i.getKeysForOverrideIdentifier(c).forEach(b=>$.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(c).forEach(p=>$.add(p))),[...$.values()]}static parse(c){const $=this.w(c.defaults),b=this.w(c.policy),p=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),g=c.folders.reduce((S,k)=>(S.set(E.URI.revive(k[0]),this.w(k[1])),S),new M.$Bc);return new r($,b,p,l,new m,D,g,new m,new M.$Bc)}static w(c){return new m(c.contents,c.keys,c.overrides)}}e.$ro=r;function i(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const c=new Set,$=new Map;for(const p of v)p.keys.forEach(l=>c.add(l)),p.overrides.forEach(([l,D])=>{const g=(0,M.$yc)($,l,new Set);D.forEach(S=>g.add(S))});const b=[];return $.forEach((p,l)=>b.push([l,[...p.values()]])),{keys:[...c.values()],overrides:b}}class a{constructor(c,$,b,p){this.change=c,this.f=$,this.g=b,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(c,$){const b=this.a+c,p=this.d.indexOf(b);if(p<0)return!1;const l=p+b.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!d.$Xn(g,S)}return!0}}e.$to=a;function h(v,c){const{added:$,removed:b,updated:p}=t(c?.rawConfiguration,v?.rawConfiguration),l=[],D=v?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const S=g.filter(k=>!D.includes(k));for(const k of S)l.push([k,c.getKeysForOverrideIdentifier(k)])}if(v){const S=D.filter(k=>!g.includes(k));for(const k of S)l.push([k,v.getKeysForOverrideIdentifier(k)])}if(c&&v){for(const S of D)if(g.includes(S)){const k=t({contents:v.getOverrideValue(void 0,S)||{},keys:v.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...k.added,...k.removed,...k.updated]])}}return{added:$,removed:b,updated:p,overrides:l}}function t(v,c){const $=v?c?v.keys.filter(l=>c.keys.indexOf(l)===-1):[...v.keys]:[],b=c?v?c.keys.filter(l=>v.keys.indexOf(l)===-1):[...c.keys]:[],p=[];if(v&&c){for(const l of c.keys)if(v.keys.indexOf(l)!==-1){const D=(0,T.$2i)(c.contents,l),g=(0,T.$2i)(v.contents,l);d.$Xn(D,g)||p.push(l)}}return{added:$,removed:b,updated:p}}}),define(Pe[102],Re([1,0,14,3]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.RemoteAuthorityResolverErrorCode=e.$Al=e.$zl=e.RemoteConnectionType=e.$yl=void 0,e.$Cl=E,e.$yl=(0,O.$ni)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class N{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$zl=N;class M{constructor(y,u){this.host=y,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Al=M;var d;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(d||(e.RemoteAuthorityResolverErrorCode=d={}));class f extends I.$bb{static isNotAvailable(y){return y instanceof f&&y._code===d.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof f&&y._code===d.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof f&&y._code===d.NoResolverFound}static isInvalidAuthority(y){return y instanceof f&&y._code===d.InvalidAuthority}static isHandled(y){return y instanceof f&&y.isHandled}constructor(y,u=d.Unknown,w){super(y),this._message=y,this._code=u,this._detail=w,this.isHandled=u===d.NotAvailable&&w===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Bl=f;function E(T){const y=T.indexOf("+");return y===-1?T:T.substring(0,y)}}),define(Pe[58],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=O,e.$zm=R,e.$Am=N,e.$Bm=M;function O(f){return f.scheme===I.Schemas.vscodeRemote?f.authority:void 0}function R(f){if(!f)return;const E=f.indexOf("+");return E<0?f:f.substr(0,E)}function N(f){const{host:E,port:T}=d(f);if(typeof T>"u")throw new Error(`Invalid remote authority: ${f}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function M(f,E){let{host:T,port:y}=d(f);return typeof y>"u"&&(y=E),{host:T,port:y}}function d(f){const E=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=f.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const y=f.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:f,port:void 0}}}),define(Pe[20],Re([1,0,15,3,58]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Km=e.$Jm=e.$Im=e.TargetPlatform=e.ExtensionType=e.$Hm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0,e.$Gm=N,e.$Lm=y,e.$Mm=u,e.$Nm=w,e.$Om=m,e.$Cm="extensions.user.cache",e.$Dm="extensions.builtin.cache",e.$Em="undefined_publisher",e.$Fm=["ui","workspace","web"];function N(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$Hm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(M||(e.ExtensionType=M={}));var d;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(d||(e.TargetPlatform=d={}));class f{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const r=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$qf(r,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Im=f;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(f.toKey(o))}delete(o){return this.c.delete(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}}e.$Jm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(f.toKey(o))}get(o){return this.c.get(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}set(o,s){this.c.set(f.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Km=T;function y(n){return u(n)}function u(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}function m(n,o){if(o){const s=`onResolveRemoteAuthority:${(0,R.$zm)(o)}`;return!!n.activationEvents?.includes(s)}return!1}e.$Pm=(0,O.$ni)("IBuiltinExtensionsScannerService")}),define(Pe[103],Re([1,0,14,20]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,d){this.a.set(M,d)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const d=Object.create(null);for(const f of M){const E=this.readActivationEvents(f);E.length>0&&(d[O.$Im.toKey(f.identifier)]=E)}return d}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const d=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let f=0;f<d.length;f++)d[f]==="onUri"&&(d[f]=`onUri:${O.$Im.toKey(M.identifier)}`);if(!M.contributes)return d;for(const f in M.contributes){const E=this.a.get(f);if(!E)continue;const T=M.contributes[f],y=Array.isArray(T)?T:[T];try{E(y,d)}catch(u){(0,I.$1)(u)}}return d}}e.$XF=R,e.$YF=new R}),define(Pe[197],Re([1,0,21,73,35]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=M,e.$8o=d;function N(f){if(I.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function M(f,E,T,y,u,w,m,n,o){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=m,s.sessionID=(0,R.$Jg)()+Date.now(),s.commitHash=y,s.version=u,s["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=O.$ec,s["common.nodeArch"]=T,s["common.product"]=o||"desktop",n&&(s["common.msftInternal"]=n);let r=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=N(E);return a&&(s["common.platformDetail"]=a),s}function d(f){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return f.some(y=>T===y)}}),define(Pe[198],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl=(0,I.$ni)("telemetryService"),e.$Tl=(0,I.$ni)("customEndpointTelemetryService"),e.$Ul="telemetry.currentSessionDate",e.$Vl="telemetry.firstSessionDate",e.$Wl="telemetry.lastSessionDate",e.$Xl="telemetry.machineId",e.$Yl="telemetry.sqmId",e.$Zl="telemetry",e.$1l="telemetry.telemetryLevel",e.$2l="telemetry.enableCrashReporter",e.$3l="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var R;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Pe[59],Re([1,0,26,17,58,197,198]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=T,e.$ep=y,e.$fp=u,e.$gp=w,e.$hp=n,e.$ip=s,e.$jp=r,e.$kp=h;class d{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$9o=d;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$0o=f,e.$$o=new f;class E{async publicLog(v,c,$){}async publicLogError(v,c,$){}}e.$_o=E,e.$ap="telemetry",e.$bp="extensionTelemetryLog",e.$cp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!t.enableTelemetry)}function y(t,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const v=t.getValue(M.$1l),c=t.getValue(M.$2l);if(t.getValue(M.$3l)===!1||c===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const v={},c={},$={};o(t,$);for(let b in $){b=b.length>150?b.substr(b.length-149):b;const p=$[b];typeof p=="number"?c[b]=p:typeof p=="boolean"?c[b]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${p.length}`),v[b]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(v[b]=p)}return{properties:v,measurements:c}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(t){if(!t)return"none";const v=(0,R.$zm)(t);return m.has(v)?v:"other"}function o(t,v,c=0,$){if(t)for(const b of Object.getOwnPropertyNames(t)){const p=t[b],l=$?$+b:b;Array.isArray(p)?v[l]=(0,I.$Yn)(p):p instanceof Date?v[l]=p.toISOString():(0,O.$3f)(p)?c<2?o(p,v,c+1,l+"."):v[l]=(0,I.$Yn)(p):v[l]=p}}function s(t,v){const c=t.msftInternalDomains||[],$=v.getValue("telemetry.internalTesting");return(0,N.$8o)(c)||$}function r(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,v){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of v)for(;;){const g=D.exec(t);if(!g)break;$.push([g.index,D.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=p.exec(t);if(!D)break;const g=$.some(([S,k])=>D.index<k&&S<p.lastIndex);!b.test(D[0])&&!g&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of v)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,v){return(0,I.$Vn)(t,c=>{if(c instanceof d||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,v);for(const b of v)$=$.replace(b,"");return $=a($),$}})}}),define(Pe[199],Re([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$mp=void 0,e.$lp=T,e.$np=m,e.$op=n,e.$pp=o,e.$qp=s,e.$rp=r,e.$sp=i,e.$tp=a,e.$vp=h,e.$wp=v;function T(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$lf)(c.id,$.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const b=$.manifest?$.manifest.version:$.version,p=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,b,p)}static parse($){const b=y.exec($);return b&&b[1]&&b[2]?new u({id:b[1]},b[2],b[4]||void 0):null}constructor($,b,p="undefined"){this.version=b,this.targetPlatform=p,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?T(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$mp=u;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(c){const $=w.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function n(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(n(c??R.$Em,$))}function r(c,$){const b=[],p=l=>{for(const D of b)if(D.some(g=>T($(g),$(l))))return D;return null};for(const l of c){const D=p(l);D?D.push(l):b.push([l])}return b}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new E.$9o(c.identifier.id),name:new E.$9o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$up=new R.$Im("pprice.better-merge");function h(c,$){const b=[],p=$.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const l=p.shift();if(l&&b.every(D=>!T(D.identifier,{id:l}))){const D=c.filter(g=>T(g.identifier,{id:l}));D.length===1&&(b.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function t(c,$){if(!N.$k)return!1;let b;try{b=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,d.$0)(l))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(c,$){const b=await t(c,$),p=(0,O.$So)(b?"alpine":N.$u,f.$fc);return $.debug("ComputeTargetPlatform:",p),p}}),define(Pe[200],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=I,e.$as=O,e.$bs=R,e.$cs=N,e.$ds=M,e.$es=d;function I(f){return[...f.entries()]}function O(f){return f?[...f.entries()]:[]}function R(f){return new Map(f)}function N(f){return new Map(f??[])}function M(f){return Array.from(f.entries()).map(E=>[E[0],I(E[1].map),O(E[1].descriptionMap)])}function d(f){return new Map(f.map(E=>[E[0],{map:R(E[1]),descriptionMap:N(E[2])}]))}}),define(Pe[201],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,N,M=5){const d=N(f=>{const E=typeof f=="string"?f:f.data;let T=this.a.get(R);if(T){T.data.push(E);return}const y=setTimeout(()=>this.flushBuffer(R),M);T={data:[E],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(R),d.dispose()}},this.a.set(R,T)});return d}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const N=this.a.get(R);N&&(this.a.delete(R),this.b(R,N.data.join("")))}}e.$usb=I}),define(Pe[202],Re([1,0,11,91,301,41,5,17,2,161,72,30]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$6w=e.$5w=e.$4w=e.$3w=e.$2w=e.IconFontDefinition=e.IconContribution=e.$Yw=void 0,e.$Zw=o,e.$1w=s,e.$Yw={IconContribution:"base.contributions.icons"};var u;(function(h){function t(v,c){let $=v.defaults;for(;N.ThemeIcon.isThemeIcon($);){const b=n.getIcon($.id);if(!b)return;$=b.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var w;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function v(c){const $=b=>(0,d.$1f)(b)?b:void 0;if(c&&Array.isArray(c.src)&&c.src.every(b=>(0,d.$1f)(b.format)&&(0,d.$1f)(b.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(b=>({format:b.format,location:f.URI.parse(b.location)}))}}h.fromJSONObject=v})(w||(e.IconFontDefinition=w={}));class m{constructor(){this.a=new M.$_d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,v,c,$){const b=this.b[t];if(b){if(c&&!b.description){b.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return b}const p={id:t,description:c,defaults:v,deprecationMessage:$};this.b[t]=p;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enum.splice(v,1),this.e.enumDescriptions.splice(v,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,v){const c=this.f[t];return c||(this.f[t]=v,this.a.fire(),v)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(b,p)=>b.id.localeCompare(p.id),v=b=>{for(;N.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(b=>this.b[b]);for(const b of $.filter(p=>!!p.description).sort(t))c.push(`|<i class="${v(b)}"></i>|${b.id}|${N.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const b of $.filter(p=>!N.ThemeIcon.isThemeIcon(p.defaults)).sort(t))c.push(`|<i class="${v(b)}"></i>|${b.id}|`);return c.join(`
`)}}const n=new m;y.$6n.add(e.$Yw.IconContribution,n);function o(h,t,v,c){return n.registerIcon(h,t,v,c)}function s(){return n}function r(){const h=(0,R.$Ij)();for(const t in h){const v="\\"+h[t].toString(16);n.registerIcon(t,{fontCharacter:v})}}r(),e.$2w="vscode://schemas/icons";const i=y.$6n.as(T.$7n.JSONContribution);i.registerSchema(e.$2w,n.getIconSchema());const a=new I.$zh(()=>i.notifySchemaChanged(e.$2w),200);n.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$3w=o("widget-close",O.$Mj.close,(0,E.localize)(2,null)),e.$4w=o("goto-previous-location",O.$Mj.arrowUp,(0,E.localize)(3,null)),e.$5w=o("goto-next-location",O.$Mj.arrowDown,(0,E.localize)(4,null)),e.$6w=N.ThemeIcon.modify(O.$Mj.sync,"spin"),e.$7w=N.ThemeIcon.modify(O.$Mj.loading,"spin")}),define(Pe[203],Re([1,0,5,2,48,3,13]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$9v=e.$7v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$3v=e.$2v=void 0,e.$4v=E,e.$5v=y,e.$6v=u,e.$8v=w,e.$0v=m,e.$$v=n,e.$2v=(0,N.$ni)("tunnelService"),e.$3v=(0,N.$ni)("sharedTunnelsService");var d;(function(r){r.Http="http",r.Https="https"})(d||(e.TunnelProtocol=d={}));var f;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(f||(e.TunnelPrivacyId=f={}));function E(r){return!!r.forwardPort}var T;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function y(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}function u(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const i=r.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=y(O.URI.parse(h));if(t)return t}}}e.$7v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(r){return e.$7v.indexOf(r)>=0}e.$9v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(r){return e.$9v.indexOf(r)>=0}function n(r,i,a,h){if(a===1)return!1;if(a===2&&m(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return r<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$_d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_v=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$_d,this.onTunnelOpened=this.a.event,this.b=new I.$_d,this.onTunnelClosed=this.b.event,this.c=new I.$_d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const v of t){const c=await v.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,v){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(m(i)||w(i))&&(i=e.$7v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,v,c=!1,$,b){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${v}.`);const p=this.f??i;if(!p)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(p,a,h,t,v,c,$,b);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),v=t?await t.value:void 0;(!v||typeof v=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];w(i)?(h.push(...e.$7v),h.push(...e.$9v)):m(i)&&h.push(...e.$9v);const t=h.map(v=>this.e.get(v));for(const v of t){const c=v?.get(a);if(c)return c}}canTunnel(i){return!!y(i)}u(i,a,h,t,v,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const b=h;this.j.add(b);const p=t===void 0?h:t,l={elevationRequired:v?this.isPortPrivileged(p):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==f.Private:void 0,protocol:$},g=i.forwardPort(D,l);return g?(this.q(a,h,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(b)})):this.j.delete(b),g}};e.$aw=s,e.$aw=s=Je([We(0,M.$Tj),We(1,R.$Ti)],s)}),define(Pe[204],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$bw=void 0,e.$bw=(0,I.$ni)("editSessionIdentityService");var O;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Pe[205],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=O,e.$8L=R,e.$9L=N,e.$0L=M,e.$$L=d;function O(f){return f.scheme!==I.Schemas.file&&f.scheme!==I.Schemas.vscodeRemote}function R(f){if(f.folders.length)return f.folders.every(E=>O(E.uri))?f.folders[0].uri:void 0;if(f.configuration&&O(f.configuration))return f.configuration}function N(f){return R(f)?.scheme}function M(f){return R(f)?.authority}function d(f){return R(f)!==void 0}}),define(Pe[49],Re([1,0,162,19,52,23,2,3,12]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Hi=e.$Gi=e.WorkbenchState=e.$Ai=e.$zi=e.$wi=void 0,e.$xi=E,e.$yi=T,e.$Bi=y,e.$Ci=u,e.$Di=w,e.$Ei=n,e.$Fi=o,e.$Ii=i,e.$Ni=a,e.$Oi=h,e.$Qi=t,e.$Ri=v,e.$Si=c,e.$wi=(0,d.$ni)("contextService");function E($){const b=$;return typeof b?.id=="string"&&M.URI.isUri(b.uri)}function T($){return typeof $?.id=="string"&&!E($)&&!u($)}e.$zi={id:"ext-dev"},e.$Ai={id:"empty-window"};function y($,b){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,O.$oc)($)}:b?e.$zi:e.$Ai;const p=$;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function u($){const b=$;return typeof b?.id=="string"&&M.URI.isUri(b.configPath)}function w($){const b=$;if(b?.uri)return{id:b.id,uri:M.URI.revive(b.uri)};const p=$;if(p?.configPath)return{id:p.id,configPath:M.URI.revive(p.configPath)};if($?.id)return{id:$.id}}var m;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function n($){const b=$;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function o($){const b=$;return!!(b&&typeof b=="object"&&M.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class s{constructor(b,p,l,D,g){this.h=b,this.j=l,this.k=D,this.l=g,this.c=R.$ti.forUris(this.l,()=>!0),this.folders=p}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=R.$ti.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gi=s;class r{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,N.$1g)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hi=r;function i($){return new r({uri:$,index:0,name:(0,N.$Wg)($)},{uri:$.toString()})}e.$Ji="code-workspace",e.$Ki=`.${e.$Ji}`,e.$Li=[{name:(0,I.localize)(0,null),extensions:[e.$Ji]}],e.$Mi="workspace.json";function a($,b){return N.$Rg.isEqualOrParent($,b.untitledWorkspacesHome)}function h($){let b;return M.URI.isUri($)?b=$:b=$.configuration,b?.scheme===f.Schemas.tmp}e.$Pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Pi}function v($,b){return!a($,b)&&!h($)}function c($){return(typeof $=="string"?(0,O.$pc)($):(0,N.$Yg)($))===e.$Ki}}),define(Pe[74],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const N=this.c++;return this.b.set(N,R),this.e(),N}get(R,N){return this.b.has(R)?this.b.get(R)[N]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Wjc=I}),define(Pe[44],Re([1,0,12,23,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=void 0;class N{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new O.$Pg(d=>{const f=this.b.get(d.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(d,f){f===null?this.b.delete(d.scheme):this.b.set(d.scheme,f)}isFreeScheme(d){return!this.b.has(d)&&!this.a.has(d)}getCapabilities(d){return this.b.get(d)}}e.$2jc=N,e.$3jc=(0,R.$ni)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=void 0,e.$$O=(0,I.$ni)("IExtHostInitDataService")}),define(Pe[206],Re([1,0,168,13,193,27]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let M=class extends R.$gQ{constructor(f,E,T){const y=T.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",u=T.remote.isRemote?(0,I.localize)(0,null):f?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(y,{name:u}))}};e.$0lc=M,e.$0lc=M=Je([We(1,O.$Uj),We(2,N.$$O)],M)}),define(Pe[207],Re([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;class O{constructor(M,d,f){this.h=new Map,this.a=M,this.b=d,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$zh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const y of E.values())y.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,d){let f=this.f[M];return typeof f>"u"&&(f=d),f}update(M,d){this.f[M]=d;const f=this.h.get(M);if(f!==void 0)return f.p;const E=new I.$Kh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Kkc=O;class R extends O{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,d){super(M.identifier.value,!0,d),this.j=M}}e.$Lkc=R}),define(Pe[208],Re([1,0,5,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class R{constructor(M){this.c=M,this.a=new I.$_d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$_d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,d,f,E){const y=this.c.getNotebookDocument(O.URI.revive(M)).acceptModelChanged(d.value,f,E);this.b.fire(y)}$acceptDirtyStateChanged(M,d){this.c.getNotebookDocument(O.URI.revive(M)).acceptDirty(d)}$acceptModelSaved(M){const d=this.c.getNotebookDocument(O.URI.revive(M));this.a.fire(d.apiNotebook)}}e.$xlc=R}),define(Pe[16],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0,e.$UO=(0,I.$ni)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$VO=O}),define(Pe[209],Re([1,0,20,5]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class R{#e;constructor(M,d){this.b=new O.$_d,this.onDidChange=this.b.event,this.a=I.$Im.toKey(M.identifier),this.#e=d,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(M){return this.#e.get(this.a,M)}store(M,d){return this.#e.store(this.a,M,d)}delete(M){return this.#e.delete(this.a,M)}}e.$Skc=R}),define(Pe[60],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0,e.$ikc=(0,I.$ni)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$jkc=O}),define(Pe[210],Re([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnb=R,e.$Mnb=M;class O{constructor(){this.buffers=[]}add(f){let E=this.buffers.indexOf(f);return E<0&&(E=this.buffers.length,this.buffers.push(f)),E}}function R(d,f){if(f.serializeBuffersForPostMessage){const E=new O,y=JSON.stringify(d,(w,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m)};if(ArrayBuffer.isView(m)){const n=N(m);if(n)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m.buffer),view:{type:n,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),u=E.buffers.map(w=>{const m=new Uint8Array(w);return I.$ze.wrap(m)});return{message:y,buffers:u}}else return{message:JSON.stringify(d),buffers:[]}}function N(d){switch(d.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(d,f){const E=f.map(u=>{const w=new ArrayBuffer(u.byteLength);return new Uint8Array(w).set(u.buffer),w}),T=f.length?(u,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const m=w,{index:n}=m,o=E[n];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(d,T),arrayBuffers:E}}}),define(Pe[104],Re([1,0,177,17,2,6,3,30,43,12,42,139,32]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$yF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$pF=e.EditorInputCapabilities=e.$oF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0,e.$fF=n,e.$gF=o,e.$hF=s,e.$iF=r,e.$jF=i,e.$kF=a,e.$lF=h,e.$mF=t,e.$nF=v,e.$qF=D,e.$rF=S,e.$sF=k,e.$tF=P,e.$uF=C,e.$vF=W,e.$wF=V,e.$xF=fe,e.$zF=oe,e.$AF=ne,e.$BF=Ie,e.$CF=ze,e.$aF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$cF="workbench.editor.sidebysideEditor",e.$dF="workbench.editors.textDiffEditor",e.$eF="workbench.editors.binaryResourceDiffEditor";var w;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var m;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function n(re){const L=re;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function o(re){const L=re;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function s(re,L,_){for(const ve of _.visibleEditorPanes)if(ve.group.id===L&&re.matches(ve.input))return ve.getViewState()}function r(re){if(D(re))return!1;const L=re;return R.URI.isUri(L?.resource)}function i(re){if(D(re))return!1;const L=re;return L?.original!==void 0&&L.modified!==void 0}function a(re){if(D(re))return!1;const L=re;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function h(re){if(D(re)||i(re))return!1;const L=re;return L?.primary!==void 0&&L.secondary!==void 0}function t(re){if(D(re))return!1;const L=re;return L?L.resource===void 0||L.resource.scheme===E.Schemas.untitled||L.forceUntitled===!0:!1}function v(re){if(D(re))return!1;const L=re;return R.URI.isUri(L?.base?.resource)&&R.URI.isUri(L?.input1?.resource)&&R.URI.isUri(L?.input2?.resource)&&R.URI.isUri(L?.result?.resource)}var c;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var $;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class b{constructor(){this.a=new Map}registerSource(L,_){let ve=this.a.get(L);return ve||(ve={source:L,label:_},this.a.set(L,ve)),ve.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$oF=new b;var p;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class l extends N.$Uc{}e.$pF=l;function D(re){return re instanceof l}function g(re){const L=re;return R.URI.isUri(L?.preferredResource)}function S(re){const L=re;return D(L?.primary)&&D(L?.secondary)}function k(re){const L=re;return D(L?.modified)&&D(L?.original)}function P(re,L,_,ve,Te){return ze(ve,[(0,y.$0i)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Ee={..._,limits:{size:Number.MAX_VALUE}};re.openEditor(L,Ee)}}),(0,y.$0i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function C(re){return D(re?.editor)}function W(re){const L=re;return C(re)&&L?.group!==void 0}function V(re){const L=re;return typeof L?.groupId=="number"&&D(L.editor)}var q;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=12]="EDITOR_STICKY",re[re.EDITOR_DIRTY=13]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var U;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class K{getOriginalUri(L,_){if(!L)return;if(v(L))return e.$yF.getOriginalUri(L.result,_);if(_?.supportSideBySide){const{primary:Te,secondary:Ee}=this.a(L);if(Te&&Ee){if(_?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===U.ANY)return this.getOriginalUri(Te,{filterByScheme:_.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:_.filterByScheme});L=_.supportSideBySide===U.PRIMARY?Te:Ee}}if(i(L)||a(L)||h(L)||v(L))return;const ve=g(L)?L.preferredResource:L.resource;return!ve||!_||!_.filterByScheme?ve:this.b(ve,_.filterByScheme)}a(L){return S(L)||h(L)?{primary:L.primary,secondary:L.secondary}:k(L)||i(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,_){if(!L)return;if(v(L))return e.$yF.getCanonicalUri(L.result,_);if(_?.supportSideBySide){const{primary:Te,secondary:Ee}=this.a(L);if(Te&&Ee){if(_?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===U.ANY)return this.getCanonicalUri(Te,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:_.filterByScheme});L=_.supportSideBySide===U.PRIMARY?Te:Ee}}if(i(L)||a(L)||h(L)||v(L))return;const ve=L.resource;return!ve||!_||!_.filterByScheme?ve:this.b(ve,_.filterByScheme)}b(L,_){if(Array.isArray(_)){if(_.some(ve=>L.scheme===ve))return L}else if(_===L.scheme)return L}}var ie;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function fe(re,L,_,ve){if(!re.isSticky(L))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return _===ie.MOUSE||_===ie.KEYBOARD;case"mouse":return _===ie.MOUSE;case"keyboard":return _===ie.KEYBOARD}return!1}e.$yF=new K;var Se;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(Se||(e.CloseDirection=Se={}));class ke{constructor(){this.c=new Map,this.d=new Map}start(L){const _=this.a=L.get(M.$mi);for(const[ve,Te]of this.c)this.e(ve,Te,_);this.c.clear()}e(L,_,ve){const Te=ve.createInstance(_);this.d.set(L,Te)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,O.$_f)(this.b)}registerEditorSerializer(L,_){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,_,this.a):this.c.set(L,_),(0,N.$Sc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}d.$6n.add(e.$aF.EditorFactory,new ke);async function oe(re,L,_){return!re||!re.length?[]:await Promise.all(re.map(async ve=>{const Te=R.URI.revive(ve.fileUri);if(!Te){_.info("Cannot resolve the path because it is not valid.",ve);return}if(!await L.canHandleResource(Te)){_.info("Cannot resolve the path because it cannot be handled",ve);return}let pe=ve.exists,de=ve.type;if(typeof pe!="boolean"||typeof de!="number")try{de=(await L.stat(Te)).isDirectory?f.FileType.Directory:f.FileType.Unknown,pe=!0}catch(Y){_.error(Y),pe=!1}if(!pe&&ve.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",ve);return}if(de===f.FileType.Directory){_.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return pe?{resource:Te,options:Q}:{resource:Te,options:Q,forceUntitled:!0}}))}var $e;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function ne(re){const L=re;if(!L)return!1;const _=L;if(_.modified)return ne(_.modified);const ve=L;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Ie(re){return(0,T.$_i)(re)}function ze(re,L,_){const ve=(0,T.$aj)(re,L);return ve.forceMessage=_?.forceMessage,ve.forceSeverity=_?.forceSeverity,ve.allowDialog=_?.allowDialog,ve}}),define(Pe[211],Re([1,0,5,178,3,6,28,30,18,26,91,202]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IF=e.ViewContentGroups=e.$GF=e.ViewContainerLocation=e.Extensions=e.$FF=e.$EF=e.$DF=void 0,e.$HF=m,e.$DF="views",e.$EF=(0,O.localize)(0,null),e.$FF=(0,y.$Zw)("default-view-icon",T.$Mj.window,(0,O.localize)(1,null));var u;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var w;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$GF=[0,1,2];function m(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$_d),this.onDidRegister=this.c.event,this.f=this.B(new I.$_d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(c,$,b){const p=this.get(c.id);if(p)return p;const l=c;return l.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,M.$yc)(this.g,$,[]).push(l),b?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const b=this.g.get($),p=b?.indexOf(c);if(p!==-1){b?.splice(p,1),b.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}d.$6n.add(u.ViewContainersRegistry,new n);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(v,c){const $=v.group??o.More,b=c.group??o.More;return $!==b?$.localeCompare(b):(v.order??5)-(c.order??5)}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$_d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$_d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$_d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$_d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:b})=>this.r($,b)),this.c.fire(c)}deregisterViews(c,$){const b=this.s(c,$);b.length&&this.f.fire({views:b,viewContainer:$})}moveViews(c,$){for(const b of this.m.keys())if(b!==$){const p=this.s(c,b);p.length&&(this.r(p,$),this.g.fire({views:p,from:b,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const b=(this.m.get($)||[]).filter(p=>p.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(p=>p.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,N.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const b=new Map;for(const[p,l]of $)this.n.add(c,l),b.set(p,(0,N.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),b}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,b=>$.push(b)),$.sort(s)}r(c,$){let b=this.m.get($);b||(b=[],this.m.set($,b),this.j.push($));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,O.localize)(2,null,p.id));b.push(p)}}s(c,$){const b=this.m.get($);if(!b)return[];const p=[],l=[];for(const D of b)c.includes(D)?p.push(D):l.push(D);return p.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),p}}d.$6n.add(u.ViewsRegistry,new r),e.$IF=(0,R.$ni)("viewDescriptorService");var i;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,E.$Wn)(this,c),this.d=!!$,this.resolve=async b=>{if($&&!this.c){const p=await $(b);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JF=h;class t extends Error{constructor(c){super((0,O.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$KF=t}),define(Pe[212],Re([1,0,5,46,6,33,3]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=e.$LG=e.$KG=e.ChatAgentLocation=void 0;var d;(function(T){T.Panel="panel",T.Terminal="terminal",T.Notebook="notebook",T.Editor="editor"})(d||(e.ChatAgentLocation=d={})),function(T){function y(u){switch(u){case"panel":return T.Panel;case"terminal":return T.Terminal;case"notebook":return T.Notebook}return T.Panel}T.fromRaw=y}(d||(e.ChatAgentLocation=d={})),e.$KG=(0,M.$ni)("chatAgentService");let f=class{static{this.AGENT_LEADER="@"}constructor(y){this.e=y,this.b=[],this.d=new I.$_d,this.onDidChangeAgents=this.d.event}registerAgent(y,u){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const m=this,n=u.slashCommands;u={...u,get slashCommands(){return n.filter(s=>!s.when||m.e.contextMatchesRules(N.$lj.deserialize(s.when)))}};const o={data:u};return this.b.push(o),(0,R.$Sc)(()=>{this.b=this.b.filter(s=>s!==o),this.d.fire(void 0)})}registerAgentImplementation(y,u){const w=this.f(y);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return w.impl=u,this.d.fire(new E(w.data,u)),(0,R.$Sc)(()=>{w.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(y,u){const w={data:y,impl:u};return this.b.push(w),this.d.fire(new E(y,u)),(0,R.$Sc)(()=>{this.b=this.b.filter(m=>m!==w),this.d.fire(void 0)})}updateAgent(y,u){const w=this.f(y);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);w.data.metadata={...w.data.metadata,...u},this.d.fire(new E(w.data,w.impl))}getDefaultAgent(y){return this.getActivatedAgents().find(u=>!!u.isDefault&&u.locations.includes(y))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}f(y){return this.b.find(u=>u.data.id===y)}getAgent(y){return this.f(y)?.data}getAgents(){return this.b.map(y=>y.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).map(y=>new E(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(u=>u.name===y)}async invokeAgent(y,u,w,m,n){const o=this.f(y);if(!o?.impl)throw new Error(`No activated agent with id ${y}`);return await o.impl.invoke(u,w,m,n)}async getFollowups(y,u,w,m,n){const o=this.f(y);if(!o?.impl)throw new Error(`No activated agent with id ${y}`);return o.impl?.provideFollowups?o.impl.provideFollowups(u,w,m,n):[]}};e.$LG=f,e.$LG=f=Je([We(0,N.$Fj)],f);class E{constructor(y,u){this.b=y,this.d=u}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,u,w,m){return this.d.invoke(y,u,w,m)}async provideFollowups(y,u,w,m){return this.d.provideFollowups?this.d.provideFollowups(y,u,w,m):[]}provideWelcomeMessage(y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y)}provideSampleQuestions(y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y)}}e.$MG=E}),define(Pe[213],Re([1,0,2,29,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$TF=N,e.$UF=M;function N(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$ht.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(N)}var d;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(d||(e.InteractiveSessionVoteDirection=d={}));var f;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$VF=(0,R.$ni)("IChatService"),e.$WF="accessibility.voice.keywordActivation"}),define(Pe[214],Re([1,0,5,11,179]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gob=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new I.$_d,this.o=new I.$_d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(d){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=d}onEvent(d){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=d}onRequest(d){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=d}sendResponse(d){d.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${d.command}`)):this.u("response",d)}sendRequest(d,f,E,T){const y={command:d};if(f&&Object.keys(f).length>0&&(y.arguments=f),this.u("request",y),typeof T=="number"){const u=setTimeout(()=>{clearTimeout(u);const w=this.f.get(y.seq);if(w){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:d,message:(0,R.localize)(0,null,T,d)};w(m)}},T)}return E&&this.f.set(y.seq,E),y.seq}acceptMessage(d){this.k?this.k(d):(this.m.push(d),this.m.length===1&&this.s())}q(d,f){return d.type!=="event"||f.type!=="event"}async s(){let d;for(;this.m.length;){if((!d||this.q(this.m[0],d))&&await(0,O.$oh)(0),d=this.m.shift(),!d)return;switch(d.type){case"event":this.j?.(d);break;case"request":this.g?.(d);break;case"response":{const f=d,E=this.f.get(f.request_seq);E&&(this.f.delete(f.request_seq),E(f));break}}}}u(d,f){f.type=d,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const d=new Map;this.f.forEach((f,E)=>d.set(E,f)),await(0,O.$oh)(500),d.forEach((f,E)=>{f({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$gob=N}),define(Pe[215],Re([1,0,2,180,33,3]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$3I=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$1I=e.MemoryRangeType=e.State=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=void 0,e.$ZI=f,e.$2I=T,e.$NH="workbench.view.debug",e.$OH="workbench.debug.variablesView",e.$PH="workbench.debug.watchExpressionsView",e.$QH="workbench.debug.callStackView",e.$RH="workbench.debug.loadedScriptsView",e.$SH="workbench.debug.breakPointsView",e.$TH="workbench.debug.disassemblyView",e.$UH="workbench.panel.repl",e.$VH="workbench.panel.repl.view",e.$WH=new R.$Ej("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$XH=new R.$Ej("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$YH=new R.$Ej("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$ZH="debugUx",e.$1H=new R.$Ej(e.$ZH,"default",{type:"string",description:O.localize(3,null)}),e.$2H=new R.$Ej("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$3H=new R.$Ej("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$4H=new R.$Ej("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$5H=new R.$Ej("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$6H=new R.$Ej("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$7H=new R.$Ej("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$8H=new R.$Ej("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$9H=new R.$Ej("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$0H=new R.$Ej("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$$H=new R.$Ej("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$_H=new R.$Ej("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$aI=new R.$Ej("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$bI=new R.$Ej("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$cI=new R.$Ej("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$dI=new R.$Ej("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$eI=new R.$Ej("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$fI=new R.$Ej("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$gI=new R.$Ej("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$hI=new R.$Ej("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$iI=new R.$Ej("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$jI=new R.$Ej("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$kI=new R.$Ej("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$lI=new R.$Ej("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$mI=new R.$Ej("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$nI=new R.$Ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$oI=new R.$Ej("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$pI=new R.$Ej("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$qI=new R.$Ej("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$rI=new R.$Ej("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$sI=new R.$Ej("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$tI=new R.$Ej("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$uI=new R.$Ej("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$vI=new R.$Ej("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$wI=new R.$Ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$xI=new R.$Ej("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$yI=new R.$Ej("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$zI=new R.$Ej("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$AI=new R.$Ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$BI=new R.$Ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$CI=new R.$Ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$DI=new R.$Ej("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$EI=new R.$Ej("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$FI=new R.$Ej("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$GI=new R.$Ej("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$HI=new R.$Ej("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$II=new R.$Ej("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$JI=new R.$Ej("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$KI=new R.$Ej("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$LI=new R.$Ej("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$MI=new R.$Ej("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$NI=new R.$Ej("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$OI=new R.$Ej("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$PI=new R.$Ej("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$QI=new R.$Ej("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$RI=new R.$Ej("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$SI=new R.$Ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$TI=new R.$Ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const M=i=>O.localize(61,null,i);e.$UI=M,e.$VI="editor.contrib.debug",e.$WI="editor.contrib.breakpoint",e.$XI="debug",e.$YI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var d;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(d||(e.State=d={}));function f(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$1I="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var w;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$3I=(0,N.$ni)("debugService");var m;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(i){i.deserialize=a=>a,i.serialize=a=>a})(s||(e.IDebugVisualizationTreeItem=s={}));var r;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:I.URI.revive(a.iconPath.light),dark:I.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(r||(e.IDebugVisualization=r={}))}),define(Pe[216],Re([1,0,15,2,19,26,12,29,24,18]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=void 0,e.$PG=y,e.$QG=u,e.$RG=w,e.$SG=m,e.$TG=n,e.$UG=o,e.$VG=s,e.$WG=i,e.$XG=t,e.$YG=v,e.$ZG=$,e.$1G=p;const T=/{([^}]+)}/g;function y(D,g,S){return D.replace(T,function(k,P){return g&&P.length>0&&P[0]!=="_"?k:S&&S.hasOwnProperty(P)?S[P]:k})}function u(D){const g={};for(const S of Object.keys(D))S.startsWith("!")||(g[S]=D[S]);return g}function w(D){return D.configuration.request==="attach"&&!m(D)&&(!D.parentSession||w(D.parentSession))}function m(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,I.$qf)(g,"extensionhost")||(0,I.$qf)(g,"pwa-extensionhost")?D:D.parentSession?m(D.parentSession):void 0}function n(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,g,S){let k,P=0;const C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=C.exec(D);){const V=W.index+1,q=V+W[0].length;if(V<=g&&q>=S){k=W[0],P=V;break}}if(k){const V=/\w+/g;let q=null;for(;(q=V.exec(k))&&!(q.index+1+P+q[0].length>=S););q&&(k=k.substring(0,V.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}async function s(D,g,S,k){if(D.evaluatableExpressionProvider.has(g)){const P=D.evaluatableExpressionProvider.ordered(g),C=(0,E.$Hb)(await Promise.all(P.map(async W=>{try{return await W.provideEvaluatableExpression(g,S,k??f.CancellationToken.None)}catch{return}})));if(C.length>0){let W=C[0].expression;const V=C[0].range;return W||(W=g.getLineContent(S.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const P=g.getLineContent(S.lineNumber),{start:C,end:W}=o(P,S.column,S.column),V=P.substring(C-1,W);return{matchingExpression:V,range:new d.$ht(S.lineNumber,C,S.lineNumber,C+V.length)}}return null}const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(r))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return O.URI.parse(D.path);if((0,R.$jc)(D.path))return O.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const g=O.URI.revive(D.path);if(g)return g.scheme===M.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const S=g?a:h,k=(0,N.$Tn)(D);return c(k,(P,C)=>{P&&C&&(C.path=S(C))}),k}function v(D,g){const S=g?a:h,k=(0,N.$Tn)(D);return c(k,(P,C)=>{!P&&C&&(C.path=S(C))}),k}function c(D,g){switch(D.type){case"event":{const S=D;switch(S.event){case"output":g(!1,S.body.source);break;case"loadedSource":g(!1,S.body.source);break;case"breakpoint":g(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":g(!0,S.arguments.source);break;case"breakpointLocations":g(!0,S.arguments.source);break;case"source":g(!0,S.arguments.source);break;case"gotoTargets":g(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(k=>g(!1,k));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(k=>g(!1,k.source));break;case"loadedSources":S.body.sources.forEach(k=>g(!1,k));break;case"scopes":S.body.scopes.forEach(k=>g(!1,k.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(k=>g(!1,k.source));break;case"setBreakpoints":S.body.breakpoints.forEach(k=>g(!1,k.source));break;case"disassemble":S.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function $(D){return D.filter(g=>!g.presentation?.hidden).sort((g,S)=>g.presentation?S.presentation?g.presentation.group?S.presentation.group?g.presentation.group!==S.presentation.group?g.presentation.group.localeCompare(S.presentation.group):b(g.presentation.order,S.presentation.order):-1:S.presentation.group?1:b(g.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function b(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function p(D,g){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(S!=="none"&&(await g.saveAll(),S==="allEditorsInActiveGroup")){const k=g.activeEditorPane;k&&k.input.resource?.scheme===M.Schemas.untitled&&await g.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}const l=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.$2G=l}),define(Pe[217],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.CellExecutionUpdateType=void 0;var O;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$dK=(0,I.$ni)("INotebookExecutionService")}),define(Pe[218],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhb=e.$Whb=e.ProxyKernelState=e.$Vhb=void 0,e.$Vhb=100;var O;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Whb=(0,I.$ni)("INotebookKernelService"),e.$Xhb=(0,I.$ni)("INotebookKernelHistoryService")}),define(Pe[219],Re([1,0,6,29,149,95]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Vb=void 0;class M extends I.$Uc{constructor(f,E,T){super(),this._source=f,this.b=E,this.c=T,this.a=void 0}f(f){const E=f.getLineCount();return new O.$ht(1,1,E,this.g(f,E))}g(f,E){if(E<1||E>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const f=new R.$JC;f.acceptChunk(this._source);const E=f.finish(!0),{textBuffer:T,disposable:y}=E.create(1);this.b=T,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const E=new R.$JC;E.acceptChunk(f);const T=E.finish(!0),{textBuffer:y,disposable:u}=T.create(1);return this.B(u),y})),this.a}findInInputs(f){const T=new N.$xC(f,!1,!1,null).parseSearchRequest();if(!T)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,T,!0,5e3)}findInOutputs(f){const T=new N.$xC(f,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(y=>{const u=y.findMatchesLineByLine(this.f(y),T,!0,5e3);if(u.length!==0)return{textBuffer:y,matches:u}}).filter(y=>!!y):[]}}e.$0Vb=M}),define(Pe[50],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(N){N.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class R{static fromExtHostTestItem(M,d,f=M.parent){if(M._isRoot)return new R([d]);const E=[M.id];for(let T=f;T&&T.id!==d;T=T.parent)E.push(T.id);return E.push(d),new R(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const d=M.indexOf("\0");return d===-1?M:M.slice(0,d)}static fromString(M){return new R(M.split("\0"))}static join(M,d){return new R([...M.path,d])}static joinToString(M,d){return M.toString()+"\0"+d}static parentId(M){const d=M.lastIndexOf("\0");return d===-1?void 0:M.slice(0,d)}static localId(M){const d=M.lastIndexOf("\0");return d===-1?M:M.slice(d+1)}static isChild(M,d){return d.startsWith(M)&&d[M.length]==="\0"}static compare(M,d){return M===d?0:R.isChild(M,d)?2:R.isChild(d,M)?3:1}constructor(M,d=M.length){if(this.path=M,this.d=d,M.length===0||d<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let d=0;d<M.d&&d<this.d;d++)if(M.path[d]!==this.path[d])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$jL=R}),define(Pe[61],Re([1,0,2,93,29,50]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$rL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$qL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$pL=e.$oL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$nL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$mL=e.$lL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$kL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$kL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var d;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(d||(e.ExtTestRunProfileKind=d={}));var f;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$lL=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$mL=E;var T;(function(A){A.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({range:R.$ht.lift(K.range),uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var y;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(A){A.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&T.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(U,K.location)})})(u||(e.ITestErrorMessage=u={}));const w=(A,U)=>`${U?"s":"e"}${A}`;e.$nL=w;var m;(function(A){A.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&T.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(U,K.location)})})(m||(e.ITestOutputMessage=m={}));var n;(function(A){A.serialize=U=>U.type===0?u.serialize(U):m.serialize(U),A.deserialize=(U,K)=>K.type===0?u.deserialize(U,K):m.deserialize(U,K)})(n||(e.ITestMessage=n={}));var o;(function(A){A.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),A.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(n.serialize)}),A.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>n.deserialize(U,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",r=(A,U)=>A+s+U;e.$oL=r;const i=A=>{const U=A.indexOf(s);return{ctrlId:A.slice(0,U),tagId:A.slice(U+1)}};e.$pL=i;var a;(function(A){A.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),A.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$ht.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(A){A.serialize=U=>({expand:U.expand,item:a.serialize(U.item)}),A.deserialize=(U,K)=>({controllerId:N.$jL.root(K.item.extId),expand:K.expand,item:a.deserialize(U,K.item)})})(t||(e.InternalTestItem=t={}));var v;(function(A){A.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},A.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?R.$ht.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(v||(e.ITestItemUpdate=v={}));const c=(A,U)=>{U.expand!==void 0&&(A.expand=U.expand),U.item!==void 0&&(A.item=A.item?Object.assign(A.item,U.item):U.item)};e.$qL=c;var $;(function(A){A.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),A.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),A.deserialize=(U,K)=>({...t.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(U,ie)),retired:!0})})($||(e.TestResultItem=$={}));var b;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(b||(e.ICoverageCount=b={}));var p;(function(A){A.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function l(A){return{...A,location:A.location?.toJSON()}}function D(A){return A.location=A.location?O.$gt.isIPosition(A.location)?O.$gt.lift(A.location):R.$ht.lift(A.location):void 0,A}e.$rL=3;var g;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(g||(e.DetailType=g={}));var S;(function(A){A.serialize=U=>U.type===0?P.serialize(U):C.serialize(U),A.deserialize=U=>U.type===0?P.deserialize(U):C.deserialize(U)})(S||(e.CoverageDetails=S={}));var k;(function(A){A.serialize=l,A.deserialize=D})(k||(e.IBranchCoverage=k={}));var P;(function(A){A.serialize=l,A.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var C;(function(A){A.serialize=U=>({...l(U),branches:U.branches?.map(k.serialize)}),A.deserialize=U=>({...D(U),branches:U.branches?.map(k.deserialize)})})(C||(e.IStatementCoverage=C={}));var W;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(A){A.deserialize=(U,K)=>K.op===0?{op:K.op,item:t.deserialize(U,K.item)}:K.op===1?{op:K.op,item:v.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:v.serialize(U.item)}:U})(V||(e.TestsDiffOp=V={}));class q{constructor(U){this.l=U,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(U){const K=this.w();for(const ie of U)switch(ie.op){case 0:this.o(t.deserialize(this.l,ie.item),K);break;case 1:this.p(v.deserialize(ie.item),K);break;case 3:this.q(ie.itemId,K);break;case 5:this.v(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.f.set(ie.tag.id,ie.tag);break;case 7:this.f.delete(ie.id);break}K.complete?.()}o(U,K){const ie=N.$jL.parentId(U.item.extId)?.toString();let fe;if(!ie)fe=this.x(U),this.h.add(fe),this.g.set(U.item.extId,fe);else if(this.g.has(ie)){const Se=this.g.get(ie);Se.children.add(U.item.extId),fe=this.x(U,Se),this.g.set(U.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(fe),U.expand===2&&this.j++,fe}p(U,K){const ie=this.g.get(U.extId);if(ie)return U.expand!==void 0&&(ie.expand===2&&this.j--,U.expand===2&&this.j++),(0,e.$qL)(ie,U),K.update?.(ie),ie}q(U,K){const ie=this.g.get(U);if(!ie)return;const fe=N.$jL.parentId(ie.item.extId)?.toString();fe?this.g.get(fe).children.delete(ie.item.extId):this.h.delete(ie);const Se=[[U]];for(;Se.length;)for(const ke of Se.pop()){const oe=this.g.get(ke);oe&&(Se.push(oe.children),this.g.delete(ke),K.remove?.(oe,oe!==ie),oe.expand===2&&this.j--)}}v(U){}updatePendingRoots(U){this.k+=U}w(){return{}}}e.$sL=q}),define(Pe[75],Re([1,0,11,5,6,56,61,50]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.TestItemEventOp=void 0;var f;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const E=(r,i)=>r===i,y=Object.entries({range:(r,i)=>r===i?!0:!r||!i?!1:r.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(r,i)=>!(r.length!==i.length||r.some(a=>!i.includes(a)))}),u=(r,i)=>{let a;for(const[h,t]of y)t(r[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class w extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$zh(()=>this.flushDiff(),200)),this.g=this.B(new O.$_d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,M.$qL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,M.$qL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(d.$jL.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$cd)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=d.$jL.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(i)}}),this.I(i,v,a);return}if(v.actual===i){this.H(i,v,a);return}if(v.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(v.actual),$=v.actual,b=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,v.actual=i,v.resolveBarrier=void 0,v.expand=0,b&&(b.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete b.tags),this.w(v,{op:4,update:b})),this.I(i,v,a);for(const[l,D]of c)this.s.getChildren(i).get(D.id)||this.O(d.$jL.joinToString(h,D.id));const p=v.expandLevels;p!==void 0&&queueMicrotask(()=>{v.expand===1&&(v.expandLevels=void 0,this.expand(h.toString(),p))}),this.y(v.actual.uri)}C(i,a,h){const t=new Set(a.map(v=>v.id));for(const v of i)t.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(v=>(0,M.$oL)(this.s.controllerId,v.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$oL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$oL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=v=>this.w(a,v),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,v]of this.s.getChildren(i))this.z(v,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,v]of this.s.getChildren(i.actual)){const c=this.expand(d.$jL.joinToString(i.fullId,v.id),a);(0,I.$_g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const v=new I.$mh;return v.open(),v}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$mh,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(v){h(v)}return(0,I.$_g)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const v of t.actual.tags)this.F(v.id);this.tree.delete(t.fullId.toString());for(const[v,c]of this.s.getChildren(t.actual))h.push(this.tree.get(d.$jL.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$KO=w;class m extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$LO=m;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$MO=n;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$NO=o;const s=(r,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,v){for(const c of h.values())t.call(v,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const v=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const b of t){if(!(b instanceof a))throw new n(b.id);const p=i(b).controllerId;if(p!==r.controllerId)throw new o(b.id,p,r.controllerId);if(v.has(b.id))throw new m(b.id);v.set(b.id,b),c.delete(b.id),$.ops.push({op:0,item:b})}for(const b of c.keys())$.ops.push({op:3,id:b});r.listener?.($),h=v},add(t){if(!(t instanceof a))throw new n(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$OO=s}),define(Pe[105],Re([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0;const O=new WeakMap,R=(M,d)=>{const f={controllerId:d};return O.set(M,f),f};e.$PO=R;const N=M=>{const d=O.get(M);if(!d)throw new I.$MO(M?.id||"<unknown>");return d};e.$QO=N}),define(Pe[76],Re([1,0,12,2]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uxb=e.$txb=e.$sxb=void 0,e.$vxb=R,e.$wxb=M,e.$sxb="vscode-cdn.net",e.$txb=`vscode-resource.${e.$sxb}`,e.$uxb=`'self' https://*.${e.$sxb}`;function R(d,f){return d.scheme===I.Schemas.http||d.scheme===I.Schemas.https?d:(f&&f.authority&&f.isRemote&&d.scheme===I.Schemas.file&&(d=O.URI.from({scheme:I.Schemas.vscodeRemote,authority:f.authority,path:d.path})),O.URI.from({scheme:I.Schemas.https,authority:`${d.scheme}+${N(d.authority)}.${e.$txb}`,path:d.path,fragment:d.fragment,query:d.query}))}function N(d){return d.replace(/./g,f=>{const E=f.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?f:"-"+E.toString(16).padStart(4,"0")})}function M(d){return d.replace(/-([0-9a-f]{4})/g,(f,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Pe[220],Re([1,0,5,6,76]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class N{constructor(d,f,E){this.d=d,this.e=f,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const T=f.getVisibleTextEditors();for(const y of this.c.values())T.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(d=>d.inset.dispose()),this.b.dispose()}createWebviewEditorInset(d,f,E,T,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===d){u=i;break}if(!u)throw new Error("not a visible editor");const w=this,m=this.a++,n=new I.$_d,o=new I.$_d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$vxb)(i,w.f)}get cspSource(){return R.$uxb}set options(i){this.b=i,w.d.$setOptions(m,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(m,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return w.d.$postMessage(m,i)}},r=new class{constructor(){this.editor=d,this.line=f,this.height=E,this.webview=s,this.onDidDispose=o.event}dispose(){w.c.has(m)&&(w.c.delete(m),w.d.$disposeEditorInset(m),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(m,u.id,u.value.document.uri,f+1,E,T||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:d,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(d){const f=this.c.get(d);f&&f.inset.dispose()}$onDidReceiveMessage(d,f){this.c.get(d)?.onDidReceiveMessage.fire(f)}}e.$gkc=N}),define(Pe[106],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=void 0,e.$zL="__",e.$AL=(0,I.$ni)("IAuthenticationService"),e.$BL=(0,I.$ni)("IAuthenticationExtensionsService")}),define(Pe[221],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.VariableKind=e.$GP=void 0,e.$GP=(0,I.$ni)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class R extends Error{constructor(M,d){super(d),this.variable=M}}e.$HP=R}),define(Pe[222],Re([1,0,19,73,17,26,21,96,183,221,15]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,m,n,o){this.h=new Map,this.a=w,this.b=m,this.g=n,o&&(this.c=o.then(s=>this.i(s)))}i(w){if(M.$i){const m=Object.create(null);return Object.keys(w).forEach(n=>{m[n.toLowerCase()]=w[n]}),m}return w}resolveWithEnvironment(w,m,n){return this.l({env:this.i(w),userHome:void 0},m?m.uri:void 0,n)}async resolveAsync(w,m){const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,m)}async j(w,m,n,o){const s=N.$Tn(m);M.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):M.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):M.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,s,n,o)}async resolveAnyAsync(w,m,n){return this.j(w,m,n)}async resolveAnyMap(w,m,n){const o=new Map;return{newConfig:await this.j(w,m,n,o),resolvedVariables:o}}resolveWithInteractionReplace(w,m,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,m,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,m){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,m)}async l(w,m,n,o,s){if(R.$1f(n))return this.m(w,m,n,o,s);if(Array.isArray(n))return Promise.all(n.map(r=>this.l(w,m,r,o,s)));if(R.$3f(n)){const r=Object.create(null),i=await Promise.all(Object.keys(n).map(async a=>[await this.m(w,m,a,o,s),await this.l(w,m,n[a],o,s)]));for(const[a,h]of i)r[a]=h;return r}return n}m(w,m,n,o,s){return(0,T.$if)(n,y.VARIABLE_REGEXP,async(r,i)=>{if(i.includes(y.VARIABLE_LHS))return r;let a=await this.o(w,r,i,m,o);return s?.set(i,a),a!==r&&R.$1f(a)&&a.match(y.VARIABLE_REGEXP)&&(a=await this.m(w,m,a,o,s)),a})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,m,n,o,s){let r;const i=n.split(":");i.length>1&&(n=i[0],r=i[1]);const a=v=>{const c=this.a.getFilePath();if(c)return(0,d.$mw)(c);throw new E.$HP(v,(0,f.localize)(0,null,m))},h=v=>{const c=a(v);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,d.$mw)($)}throw new E.$HP(v,(0,f.localize)(1,null,m,I.$oc(c)))},t=v=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new E.$HP(v,(0,f.localize)(2,null,m,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$HP(v,(0,f.localize)(3,null,m)):new E.$HP(v,(0,f.localize)(4,null,m))};switch(n){case"env":if(r){if(w.env){const v=w.env[M.$i?r.toLowerCase():r];if(R.$1f(v))return v}return""}throw new E.$HP(E.VariableKind.Env,(0,f.localize)(5,null,m));case"config":if(r){const v=this.a.getConfigurationValue(o,r);if(R.$0f(v))throw new E.$HP(E.VariableKind.Config,(0,f.localize)(6,null,m,r));if(R.$3f(v))throw new E.$HP(E.VariableKind.Config,(0,f.localize)(7,null,m,r));return v}throw new E.$HP(E.VariableKind.Config,(0,f.localize)(8,null,m));case"command":return this.p(E.VariableKind.Command,m,r,s,"command");case"input":return this.p(E.VariableKind.Input,m,r,s,"input");case"extensionInstallFolder":if(r){const v=await this.a.getExtension(r);if(!v)throw new E.$HP(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,m,r));return this.n(v.extensionLocation)}throw new E.$HP(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,m));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,d.$mw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,d.$mw)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,d.$mw)(I.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new E.$HP(E.VariableKind.UserHome,(0,f.localize)(11,null,m))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new E.$HP(E.VariableKind.LineNumber,(0,f.localize)(12,null,m))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new E.$HP(E.VariableKind.SelectedText,(0,f.localize)(13,null,m))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?I.$mc(this.n(t(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const v=I.$nc(a(E.VariableKind.RelativeFileDirname));if(o||r){const c=I.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),v);return c.length===0?".":c}return v}case"fileDirname":return I.$nc(a(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=I.$oc(a(E.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-I.$pc(v).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||m}case"execInstallFolder":{const v=this.a.getAppRoot();return v||m}case"pathSeparator":case"/":return I.sep;default:try{const v=r?`${n}:${r}`:n;return this.p(E.VariableKind.Unknown,m,v,s,void 0)}catch{return m}}}}p(w,m,n,o,s){if(n&&o){const r=s===void 0?o[n]:o[s+":"+n];if(typeof r=="string")return r;throw new E.$HP(w,(0,f.localize)(14,null,m))}return m}}e.$WP=y}),define(Pe[107],Re([1,0,3,104]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FD=void 0,e.$GD=E,e.$HD=u,e.$ID=w,e.$FD=(0,I.$ni)("editorGroupsService");var R;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var N;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var d;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(d||(e.GroupsArrangement=d={}));var f;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function E(m){const n=m;return(0,O.$qF)(n?.editor)&&(0,O.$qF)(n?.replacement)}var T;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(m){const n=m;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[223],Re([1,0,3,107]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$ND=R,e.$JD=(0,I.$ni)("editorService"),e.$KD=-1,e.$LD=-2,e.$MD=-3;function R(N){const M=N;return typeof N=="number"||(0,O.$HD)(M)}}),define(Pe[224],Re([1,0,3,190]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=void 0,e.$UL=(0,I.$oi)(O.$ui)}),define(Pe[108],Re([1,0,20,5,19,6,11]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=e.$B$b=e.$A$b=e.$z$b=e.$y$b=void 0;class d{constructor(r,i){this.versionId=r,this.removedDueToLooping=i}}e.$y$b=d;class f{static isHostExtension(r,i,a){if(i.getExtensionDescription(r))return!1;const h=a.getExtensionDescription(r);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(r,i){this.j=r,this.c=new O.$_d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new I.$Km,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const i=this.j.readActivationEvents(r);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,i){this.e=o(this.e,i),this.e=this.e.concat(r);const a=f.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new d(this.d,a)}static l(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const b=i.getArcs(c);for(let p=0;p<b.length;p++)if(!$.has(b[p]))return!1;return!0}getNodes(){return this.e}},a=new I.$Km;for(const c of r)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Im.toKey(c.identifier),I.$Im.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let v;do{v=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),v=!0)}}while(v);return t.map(c=>a.get(c))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.h.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const i=this.f.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.g)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$z$b=f;class E{constructor(r,i){this.versionId=r,this.extensions=i}}e.$A$b=E;class T{constructor(r){this.d=new w,this.c=new f(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new y(this,i)}deltaExtensions(r,i,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$B$b=T;class y extends N.$Uc{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$C$b=y;class u{constructor(r){this.name=r;const i=(0,M.$gh)();this.promise=i.promise,this.c=i.resolve}resolve(r){this.c(r)}}class w{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new u(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};r.resolve((0,N.$Sc)(h))}}var m;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(m||(m={}));function n(s,r){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=R.$hc.basename(s.extensionLocation.path),t=R.$hc.basename(r.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,r){const i=new I.$Jm(r);return s.filter(a=>!i.has(a.identifier))}}),define(Pe[77],Re([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Qm=M,e.$Rm=d;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var N;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function M(E){const T=I.$ze.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function d(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var f;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[62],Re([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$aP=e.$_O=void 0,e.$bP=n;let w=class extends y.$Uc{constructor(s,r){super(),this.s=s,this.t=r,this.a=this.B(new O.$_d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$_d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:f.$bp,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(i=>{(0,R.$Vj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,r,i){const a=this.getTelemetryDetails(),h=new m(r,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,r,i){this.f=s,this.g=r,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const r=Object.create(null);switch(r["common.extname"]=`${s.publisher}.${s.name}`,r["common.extversion"]=s.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:r["common.uikind"]="web";break;case M.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,d.$zm)((0,f.$hp)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const r=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,r){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$_O=w,e.$_O=w=Je([We(0,N.$$O),We(1,R.$Uj)],w);class m{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,r,i,a,h,t,v){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new O.$_d,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,r){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let r="properties"in s?s.properties??{}:s;return r=(0,f.$kp)(r,[]),this.c&&(r=(0,E.$Wn)(r,this.c)),this.b||(r=(0,E.$Wn)(r,this.j)),"properties"in s?s.properties=r:s=r,s}k(s,r){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(s,r),this.h.trace(s,r))}logUsage(s,r){this.d.isUsageEnabled&&this.k(s,r)}logError(s,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,r);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,f.$kp)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const s=this,r={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$aP=m;function n(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$cP=(0,I.$ni)("IExtHostTelemetry")}),define(Pe[25],Re([1,0,5,2,199,103,20,3]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mG=e.ActivationKind=e.$jG=e.$iG=e.$fG=e.ExtensionHostStartup=e.$eG=e.$dG=e.$cG=e.$bG=void 0,e.$gG=u,e.$hG=w,e.$kG=s,e.$lG=r,e.$bG=Object.freeze({identifier:new M.$Im("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$cG="extensions.webWorker",e.$dG=(0,d.$ni)("extensionService");class f{constructor(h){this.dependency=h}}e.$eG=f;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,v){this.c=h,this.d=t.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$YF.createActivationEventsMap(this.d)}}set(h,t,v){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],b=[],p=[],l=y(this.d),D=y(t),g=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=D.get(W.identifier);if(!V){c.push(W.identifier),l.delete(W.identifier);continue}if(!g(W,V)){c.push(W.identifier),l.delete(W.identifier);continue}}for(const W of t){const V=l.get(W.identifier);if(!V){$.push(W);continue}if(!g(V,W)){c.push(V.identifier),l.delete(V.identifier);continue}}const S=new M.$Jm(this.e),k=new M.$Jm(v);for(const W of this.e)k.has(W)||b.push(W);for(const W of v)S.has(W)||p.push(W);const P=N.$YF.createActivationEventsMap($),C={versionId:h,toRemove:c,toAdd:$,addActivationEvents:P,myToRemove:b,myToAdd:p};return this.delta(C),C}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:v,myToRemove:c,myToAdd:$}=h,b=new M.$Jm(t),p=new M.$Jm(c);for(let l=0;l<this.d.length;l++)b.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)p.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of v)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(M.$Im.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const v=N.$YF.readActivationEvents(t);for(const c of v)h.add(c)}return h}}e.$fG=T;function y(a){const h=new M.$Km;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function w(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class m{constructor(h,t,v,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=v,this.activationReason=c}}e.$iG=m;class n{constructor(h,t){this.description=h,this.value=t}}e.$jG=n;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,R.$qp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function r(a,h){return{identifier:new M.$Im((0,R.$op)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$mG=i}),define(Pe[225],Re([1,0,14,108,20,25,13,11]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(s,r,i,a){this.startup=s,this.codeLoadingTime=r,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Ckc=f;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,r){return s===-1||r===-1?-1:r-s}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Dkc=E;class T{constructor(s,r,i,a,h,t){this.activationFailed=s,this.activationFailedError=r,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$Ekc=T;class y extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fkc=y;class u extends T{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gkc=u;class w extends T{constructor(s){super(!0,s,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(s,r,i,a){this.g=a,this.a=s,this.b=r,this.c=i,this.d=new R.$Km,this.f=Object.create(null)}dispose(){for(const[s,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const s=[];for(const[r,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const r=this.d.get(s);return!!(r&&r.value)}getActivatedExtension(s){const r=this.d.get(s);if(!r||!r.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return r.value}async activateByEvent(s,r){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,r){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:r}])}async h(s){const r=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(r.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const r=this.a.getExtensionDescription(s.id);if(!r){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(h));return this.c.onExtensionActivationError(s.id,h,new N.$eG(s.id.value)),t}const i=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const v=this.a.getExtensionDescription(h);if(v){if(!v.main&&!v.browser)continue;i.push(this.j({id:v.identifier,reason:s.reason}));continue}const c=r.displayName||r.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),b=this.k(s,r.displayName,[],new w($));return this.c.onExtensionActivationError(r.identifier,$,new N.$eG(h)),b}return this.k(s,r.displayName,i,null)}k(s,r,i,a){const h=new n(s.id,r,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return O.$z$b.isHostExtension(s,this.a,this.b)}m(s){const r=this.b.getExtensionDescription(s);return r?!r.main&&!r.browser:!1}};e.$Hkc=m,e.$Hkc=m=Je([We(3,M.$Tj)],m);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,r,i,a,h,t,v){this.c=s,this.d=r,this.f=i,this.g=a,this.h=h,this.j=t,this.k=v,this.a=new d.$mh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const r=this.g[s];if(r.value&&!r.value.activationFailed){this.g.splice(s,1),s--;continue}if(r.value&&r.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);i.detail=r.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const r=new Error;if(s&&s.name&&(r.name=s.name),s&&s.message?r.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(r.stack=s.stack),this.h=new w(r),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};n=Je([We(6,M.$Tj)],n)}),define(Pe[226],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Re([1,0,185,14,32,98,72,30,20,226,195,103]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0;const u=d.$6n.as(M.$7n.JSONContribution);class w{constructor(h,t,v){this.a=h,this.b=t,this.c=v}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$8F=w;class m{static a(h){const t=new f.$Jm;for(let v=0,c=h.length;v<c;v++)t.add(h[v].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new m(t,[]);if(!t||!t.length)return new m([],h);const v=this.a(h),c=this.a(t),$=t.filter(p=>!v.has(p.description.identifier)),b=h.filter(p=>!c.has(p.description.identifier));return new m($,b)}constructor(h,t){this.added=h,this.removed=t}}e.$9F=m;class n{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,O.$1)(h)}}}e.$0F=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$$F={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$Hm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Ko}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Ko}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&y.$YF.register(h.extensionPoint,h.activationEventsGenerator),e.$$F.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$$F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$_F=r;const i={ExtensionsRegistry:"ExtensionsRegistry"};d.$6n.add(i.ExtensionsRegistry,new r),e.$aG=d.$6n.as(i.ExtensionsRegistry),u.registerSchema(s,e.$$F),u.registerSchema(T.$bk,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Pe[228],Re([1,0,181,17,26,227,33,5]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(u){function w(m,n,o){if(!m)return;const s=O.$1f(m.type)?m.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const r=[];if(Array.isArray(m.required))for(const i of m.required)O.$1f(i)&&r.push(i);return{extensionId:n.value,taskType:s,required:r,properties:m.properties?R.$Tn(m.properties):{},when:m.when?M.$lj.deserialize(m.when):void 0}}u.from=w})(E||(E={}));const T=N.$aG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,w)=>{for(const m of u)m.type&&w.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:f}});class y{constructor(){this.d=new d.$_d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,m)=>{T.setHandler((n,o)=>{this.c=void 0;try{for(const s of o.removed){const r=s.value;for(const i of r)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const r=s.value;for(const i of r){const a=E.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const m of this.all()){const n={type:"object",additionalProperties:!1};m.required.length>0&&(n.required=m.required.slice(0)),m.properties!==void 0?n.properties=R.$Tn(m.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[m.taskType]},w.push(n)}this.c={oneOf:w}}return this.c}}e.$CH=new y}),define(Pe[229],Re([1,0,182,17,23,26,33,228]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MH=e.JsonSchemaVersion=e.ExecutionEngine=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GH=e.ShellQuoting=e.$FH=e.$EH=e.$DH=void 0,e.$DH="settings",e.$EH=new M.$Ej("taskRunning",!1,I.localize(0,null)),e.$FH=I.localize2(2,"Tasks");var f;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$GH="$customized",function(A){function U(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=U}(f||(e.ShellQuoting=f={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=U}(T||(e.RevealKind=T={}));var y;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=U}(y||(e.RevealProblemKind=y={}));var u;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(u||(e.PanelKind=u={})),function(A){function U(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=U}(u||(e.PanelKind=u={}));var w;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:y.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var m;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(A){function U(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=U;function K(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(m||(e.RuntimeType=m={}));var n;(function(A){function U(K){return O.$1f(K)?K:K.value}A.value=U})(n||(e.CommandString=n={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function U(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=U;function K(ie){if(ie!==void 0)return O.$1f(ie)?U(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=K})(o||(e.TaskGroup=o={}));var s;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var r;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function U(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=U})(r||(e.TaskSourceKind=r={}));var i;(function(A){A.parallel="parallel",A.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(U,K,ie,fe,Se,ke){this._label="",this._id=U,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=fe,this.configurationProperties=Se,this._source=ke}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(O.$1f(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$HH=t;class v extends t{constructor(U,K,ie,fe,Se,ke,oe,$e){super(U,ie,void 0,oe,$e,K),this.command={},this._source=K,this.hasDefinedMatchers=ke,Se&&(this.command=Se)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof v}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$DH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$GH,folder:U,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Xg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new v(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$IH=v;class c extends t{constructor(U,K,ie,fe,Se,ke,oe){super(U,ie,fe,ke,oe,K),this._source=K,this.configures=Se}static is(U){return U instanceof c}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Xg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$DH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$GH,folder:U,id:K};return JSON.stringify(ie)}}e.$JH=c;class $ extends t{constructor(U,K,ie,fe,Se,ke,oe,$e,ne){super(U,ie,fe,$e,ne,K),this.defines=Se,this.hasDefinedMatchers=oe,this.command=ke,this.icon=ne.icon,this.hide=ne.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof $}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new $(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$KH=$;class b extends t{constructor(U,K,ie,fe,Se,ke){super(U,ie,fe,Se,ke,K),this._source=K}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new b(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$LH=b;var p;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(A){A._default=A.Terminal}(p||(e.ExecutionEngine=p={}));var l;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const ie=U.getWorkspaceFolder(),fe=K.getWorkspaceFolder();if(ie&&fe){let Se=this.c.get(ie.uri.toString());Se=Se===void 0?0:Se+1;let ke=this.c.get(fe.uri.toString());return ke=ke===void 0?0:ke+1,Se===ke?U._label.localeCompare(K._label):Se-ke}else return!ie&&fe?-1:ie&&!fe?1:0}}e.$MH=D;var g;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(g||(e.TaskEventKind=g={}));var S;(function(A){A.SingleRun="singleRun",A.Background="background"})(S||(e.TaskRunType=S={}));var k;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(A){function U($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function K($e,ne,Ie){return{...U($e),kind:"start",terminalId:ne,resolvedVariables:Ie}}A.start=K;function ie($e,ne,Ie){return{...U($e),kind:"processStarted",terminalId:ne,processId:Ie}}A.processStarted=ie;function fe($e,ne,Ie){return{...U($e),kind:"processEnded",terminalId:ne,exitCode:Ie}}A.processEnded=fe;function Se($e,ne,Ie){return{...U($e),kind:"terminated",exitReason:Ie,terminalId:ne}}A.terminated=Se;function ke($e,ne,Ie){return{...U(ne),kind:$e,terminalId:Ie}}A.general=ke;function oe(){return{kind:"changed"}}A.changed=oe})(P||(e.TaskEvent=P={}));var C;(function(A){function U(ie){const fe=Object.keys(ie).sort();let Se="";for(const ke of fe){let oe=ie[ke];oe instanceof Object?oe=U(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),Se+=ke+","+oe+","}return Se}function K(ie){const Se={_key:U(ie),type:ie.taskType};return Object.assign(Se,ie),Se}A.create=K})(C||(e.KeyedTaskIdentifier=C={}));var W;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(A){function U(K,ie){const fe=d.$CH.get(K.type);if(fe===void 0){const $e=N.$Tn(K);return delete $e._key,C.create($e)}const Se=Object.create(null);Se.type=fe.taskType;const ke=new Set;fe.required.forEach($e=>ke.add($e));const oe=fe.properties;for(const $e of Object.keys(oe)){const ne=K[$e];if(ne!=null)Se[$e]=ne;else if(ke.has($e)){const Ie=oe[$e];if(Ie.default!==void 0)Se[$e]=N.$Tn(Ie.default);else switch(Ie.type){case"boolean":Se[$e]=!1;break;case"number":case"integer":Se[$e]=0;break;case"string":Se[$e]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),$e));return}}}return C.create(Se)}A.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(Pe[230],Re([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,d)=>{this.b=M,this.d=d,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,d){return this.j().then(M,d)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$D$b=O;class R extends O{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$E$b=R}),define(Pe[34],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$gw=void 0,e.$hw=R,e.$iw=N;class I{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++I.count}}e.$gw=I;const O=[];function R(d){const f=new I(d);return O[f.nid]=f,f}function N(d){return O[d].sid}class M{constructor(f){this.value=f}}e.$jw=M}),define(Pe[4],Re([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var R;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var N;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var M;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var d;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(d||(e.WebviewMessageArrayBufferViewType=d={}));var f;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var E;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$wM=y;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var w;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var m;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$xM={MainThreadAuthentication:(0,I.$hw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$hw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$hw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$hw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$hw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$hw)("MainThreadClipboard"),MainThreadCommands:(0,I.$hw)("MainThreadCommands"),MainThreadComments:(0,I.$hw)("MainThreadComments"),MainThreadConfiguration:(0,I.$hw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$hw)("MainThreadConsole"),MainThreadDebugService:(0,I.$hw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$hw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$hw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$hw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$hw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$hw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$hw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$hw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$hw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$hw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$hw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$hw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$hw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$hw)("MainThreadLanguages"),MainThreadLogger:(0,I.$hw)("MainThreadLogger"),MainThreadMessageService:(0,I.$hw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$hw)("MainThreadOutputService"),MainThreadProgress:(0,I.$hw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$hw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$hw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$hw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$hw)("MainThreadSecretState"),MainThreadStorage:(0,I.$hw)("MainThreadStorage"),MainThreadSpeech:(0,I.$hw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$hw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$hw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$hw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$hw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$hw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$hw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$hw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$hw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$hw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$hw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$hw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$hw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$hw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$hw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$hw)("MainThreadSCM"),MainThreadSearch:(0,I.$hw)("MainThreadSearch"),MainThreadShare:(0,I.$hw)("MainThreadShare"),MainThreadTask:(0,I.$hw)("MainThreadTask"),MainThreadWindow:(0,I.$hw)("MainThreadWindow"),MainThreadLabelService:(0,I.$hw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$hw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$hw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$hw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$hw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$hw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$hw)("MainThreadInteractive"),MainThreadChat:(0,I.$hw)("MainThreadChat"),MainThreadInlineChat:(0,I.$hw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$hw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$hw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$hw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$hw)("MainThreadTimeline"),MainThreadTesting:(0,I.$hw)("MainThreadTesting"),MainThreadLocalization:(0,I.$hw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$hw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$hw)("MainThreadAiEmbeddingVector")},e.$yM={ExtHostCommands:(0,I.$hw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$hw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$hw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$hw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$hw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$hw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$hw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$hw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$hw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$hw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$hw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$hw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$hw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$hw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$hw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$hw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$hw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$hw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$hw)("ExtHostStatusBar"),ExtHostShare:(0,I.$hw)("ExtHostShare"),ExtHostExtensionService:(0,I.$hw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$hw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$hw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$hw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$hw)("ExtHostSCM"),ExtHostSearch:(0,I.$hw)("ExtHostSearch"),ExtHostTask:(0,I.$hw)("ExtHostTask"),ExtHostWorkspace:(0,I.$hw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$hw)("ExtHostWindow"),ExtHostWebviews:(0,I.$hw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$hw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$hw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$hw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$hw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$hw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$hw)("ExtHostProgress"),ExtHostComments:(0,I.$hw)("ExtHostComments"),ExtHostSecretState:(0,I.$hw)("ExtHostSecretState"),ExtHostStorage:(0,I.$hw)("ExtHostStorage"),ExtHostUrls:(0,I.$hw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$hw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$hw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$hw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$hw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$hw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$hw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$hw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$hw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$hw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$hw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$hw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$hw)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$hw)("ExtHostChat"),ExtHostChatAgents2:(0,I.$hw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$hw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$hw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$hw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$hw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$hw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$hw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$hw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$hw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$hw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$hw)("ExtHostTimeline"),ExtHostTesting:(0,I.$hw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$hw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$hw)("ExtHostLocalization")}}),define(Pe[78],Re([1,0,3,13,4,16]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=e.$Zjc=e.$Yjc=void 0,e.$Yjc=(0,I.$ni)("IExtHostApiDeprecationService");let M=class{constructor(f,E){this.c=E,this.a=new Set,this.b=f.getProxy(R.$xM.MainThreadTelemetry)}report(f,E,T){const y=this.d(f,E);this.a.has(y)||(this.a.add(y),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:f}))}d(f,E){return`${f}-${E.identifier.value}`}};e.$Zjc=M,e.$Zjc=M=Je([We(0,N.$UO),We(1,O.$Tj)],M),e.$1jc=Object.freeze(new class{report(d,f,E){}})}),define(Pe[231],Re([1,0,6,4]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class R{static{this.a=0}constructor(d,f){this.extension=d,this.provider=f,this.handle=R.a++}}class N{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(O.$xM.MainThreadChat)}registerChatProvider(d,f,E){const T=new R(d,E);return this.b.set(T.handle,T),this.d.$registerChatProvider(T.handle,f),(0,I.$Sc)(()=>{this.d.$unregisterChatProvider(T.handle),this.b.delete(T.handle)})}transferActiveChat(d){this.d.$transferActiveChatSession(d)}async $prepareChat(d,f){const E=this.b.get(d);if(!E)return;const T=await E.provider.prepareSession(f);if(!T)return;const y=N.a++;return this.c.set(y,T),{id:y}}$releaseSession(d){this.c.delete(d)}}e.$_jc=N}),define(Pe[232],Re([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class O{constructor(N){const M=N.getProxy(I.$xM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(d){return M.$writeText(d)}})}}e.$ekc=O}),define(Pe[233],Re([1,0,26,4,27,16]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;let M=class{constructor(T,y){this.a=T.getProxy(O.$xM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,y){const u=this,w=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){u.e(T,y,w,arguments)}})}e(T,y,u,w){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:f(w,this.b)}),this.c&&this.f(T,u,w)}};e.$9lc=M,e.$9lc=M=Je([We(0,N.$UO),We(1,R.$$O)],M);const d=1e5;function f(E,T){const y=[];if(E.length)for(let u=0;u<E.length;u++){let w=E[u];if(typeof w>"u")w="undefined";else if(w instanceof Error){const m=w;m.stack?w=m.stack:w=m.toString()}y.push(w)}if(T){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$Yn)(y);return u.length>d?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[234],Re([1,0,2,4,25]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class N{constructor(d){this.a=d.getProxy(O.$xM.MainThreadDialogs)}showOpenDialog(d,f){return f?.allowUIResources&&(0,R.$hG)(d,"showLocal"),this.a.$showOpenDialog(f).then(E=>E?E.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(d){return this.a.$showSaveDialog(d).then(f=>f?I.URI.revive(f):void 0)}}e.$_kc=N}),define(Pe[235],Re([1,0,6,4]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(O.$xM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const d=this.b++;return this.a.$registerResourceLabelFormatter(d,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(d)})}}e.$tlc=R}),define(Pe[79],Re([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;let T=class{constructor(u,w,m){this.f=m,this.d=new Map,this.a=w.getProxy(d.$xM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,w){const{message:m,args:n,comment:o}=w;if(this.c)return(0,O.$2e)(m,n??{});let s=m;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(u)?.contents[s];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,O.$2e)(r??m,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let w;const m=await this.g(u);if(!m){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(m),o=JSON.parse(n);w=u.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${m}: ${n.message}`);return}w&&this.d.set(u.identifier.value,{contents:w,uri:m})}async g(u){if(u.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return R.URI.revive(w)}return u.l10n?R.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Tkc=T,e.$Tkc=T=Je([We(0,f.$$O),We(1,E.$UO),We(2,M.$Tj)],T),e.$Ukc=(0,N.$ni)("IExtHostLocalizationService")}),define(Pe[236],Re([1,0,13,4,27,16,2,53]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;let f=class extends I.$5j{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(w=>(0,d.$Wh)(w))),this.r=y.getProxy(O.$xM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(M.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,w){return new E(this.r,y,u,w)}};e.$8lc=f,e.$8lc=f=Je([We(0,N.$UO),We(1,R.$$O)],f);class E extends I.$Zj{constructor(y,u,w,m){super(m?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(u,m).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const w=[[y,u]];this.m?this.u(w):this.n.push(...w)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Re([1,0,4,3,6,16,22]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=void 0,e.$Vkc=(0,O.$ni)("IExtHostManagedSockets");let d=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(I.$xM.MainThreadManagedSockets)}setFactory(y,u){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,w=await this.c.makeConnection(),m=new R.$Tc;return this.d.set(u,new E(u,w,m)),m.add((0,R.$Sc)(()=>this.d.delete(u))),m.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),m.dispose()})),m.add(w.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),m.dispose()})),m.add(w.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,M.$ze.wrap(n)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Wkc=d,e.$Wkc=d=Je([We(0,N.$UO)],d);class f{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class E extends R.$Uc{constructor(y,u,w){super(),this.socketId=y,this.actual=u,this.B(w)}}}),define(Pe[237],Re([1,0,4,13,25]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;function N(d){return d&&d.title}let M=class{constructor(f,E){this.b=E,this.a=f.getProxy(I.$xM.MainThreadMessageService)}showMessage(f,E,T,y,u){const w={source:{identifier:f.identifier,label:f.displayName||f.name}};let m;typeof y=="string"||N(y)?m=[y,...u]:(w.modal=y?.modal,w.useCustom=y?.useCustom,w.detail=y?.detail,m=u),w.useCustom&&(0,R.$hG)(f,"resolvers");const n=[];let o=!1;for(let s=0;s<m.length;s++){const r=m[s];if(typeof r=="string")n.push({title:r,handle:s,isCloseAffordance:!1});else if(typeof r=="object"){const{title:i,isCloseAffordance:a}=r;n.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,r):o=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,r)}return this.a.$showMessage(E,T,w,n).then(s=>{if(typeof s=="number")return m[s]})}};e.$vlc=M,e.$vlc=M=Je([We(1,O.$Tj)],M)}),define(Pe[238],Re([1,0,6,17,2,25,4]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class d{constructor(E){this.b=new Map,this.a=E.getProxy(M.$xM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,y){if((0,N.$hG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,y),this.a.$registerProfileContentHandler(T,y.name,y.description,E.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,y,u){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.saveProfile(T,y,u)}async $readProfile(E,T,y){const u=this.b.get(E);if(!u)throw new Error(`Unknown handler with id: ${E}`);return u.readProfile((0,O.$1f)(T)?T:R.URI.revive(T),y)}}e.$Elc=d}),define(Pe[81],Re([1,0,4,5,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0;class N{constructor(d){this.b=new O.$_d,this.onDidChangePassword=this.b.event,this.a=d.getProxy(I.$xM.MainThreadSecretState)}async $onDidChangePassword(d){this.b.fire(d)}get(d,f){return this.a.$getPassword(d,f)}store(d,f,E){return this.a.$setPassword(d,f,E)}delete(d,f){return this.a.$deletePassword(d,f)}}e.$Qkc=N,e.$Rkc=(0,R.$ni)("IExtHostSecretState")}),define(Pe[239],Re([1,0,24,6,4]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class N{static{this.a=1}constructor(d){this.c=new Map,this.d=new Map,this.b=d.getProxy(R.$xM.MainThreadSpeech)}async $createSpeechToTextSession(d,f,E){const T=this.c.get(d);if(!T)return;const y=new O.$Tc,u=new I.$je;this.d.set(f,u);const w=y.add(T.provideSpeechToTextSession(u.token,E?{language:E}:void 0));y.add(w.onDidChange(m=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,m)})),y.add(u.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(d){this.d.get(d)?.dispose(!0),this.d.delete(d)}async $createKeywordRecognitionSession(d,f){const E=this.c.get(d);if(!E)return;const T=new O.$Tc,y=new I.$je;this.d.set(f,y);const u=T.add(E.provideKeywordRecognitionSession(y.token));T.add(u.onDidChange(w=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,w)})),T.add(y.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(d){this.d.get(d)?.dispose(!0),this.d.delete(d)}registerProvider(d,f,E){const T=N.a++;return this.c.set(T,E),this.b.$registerProvider(T,f,{extension:d,displayName:d.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Llc=N}),define(Pe[82],Re([1,0,4,5,3]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=void 0;class N{constructor(d,f){this.c=f,this.b=new O.$_d,this.onDidChangeStorage=this.b.event,this.a=d.getProxy(I.$xM.MainThreadStorage)}registerExtensionStorageKeysToSync(d,f){this.a.$registerExtensionStorageKeysToSync(d,f)}async initializeExtensionStorage(d,f,E){const T=await this.a.$initializeExtensionStorage(d,f);let y;return T&&(y=this.d(d,f,T)),y||E}setValue(d,f,E){return this.a.$setValue(d,f,E)}$acceptValue(d,f,E){const T=this.d(d,f,E);T&&this.b.fire({shared:d,key:f,value:T})}d(d,f,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${d}): ${T}`)}}}e.$Ikc=N,e.$Jkc=(0,R.$ni)("IExtHostStorage")}),define(Pe[240],Re([1,0,6,12,2,4]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class M{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(N.$xM.MainThreadUriOpeners)}registerExternalUriOpener(f,E,T,y){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const u=y.schemes.find(w=>!M.a.has(w));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,y.schemes,f,y.label),(0,I.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(f,E,T){const y=this.c.get(f);if(!y)throw new Error(`Unknown opener with id: ${f}`);const u=R.URI.revive(E);return y.canOpenExternalUri(u,T)}async $openUri(f,E,T){const y=this.c.get(f);if(!y)throw new Error(`Unknown opener id: '${f}'`);return y.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},T)}}e.$Zlc=M}),define(Pe[241],Re([1,0,4,2,6,14,20]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class d{static{this.a=0}constructor(E){this.c=new M.$Jm,this.d=new Map,this.b=E.getProxy(I.$xM.MainThreadUrls)}registerUriHandler(E,T){const y=E.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=d.a++;return this.c.add(y),this.d.set(u,T),this.b.$registerUriHandler(u,y,E.displayName||E.name),(0,R.$Sc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(E,T){const y=this.d.get(E);if(!y)return Promise.resolve(void 0);try{y.handleUri(O.URI.revive(T))}catch(u){(0,N.$1)(u)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$1lc=d}),define(Pe[63],Re([1,0,5,6,12,26,2,188,210,76,4]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$tkc=void 0,e.$ukc=u,e.$wkc=n,e.$xkc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,v,c,$,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$_d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$_d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=v,this.#s=c,this.#r=$,this.#l=u($),this.#d=w($),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$vxb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===R.Schemas.https||a.scheme===R.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+E.$uxb}return E.$uxb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),N.$Xn(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,f.$Lnb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,b,p,l)=>{const D=M.URI.from({scheme:b||"file",path:decodeURIComponent(p)}),g=(0,E.$vxb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,b,p,l)=>{const D=M.URI.from({scheme:b||"file",path:decodeURIComponent(p)}),g=(0,E.$vxb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`})}}e.$tkc=y;function u(i){try{const a=(0,d.$zp)((0,d.$yp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function w(i){try{const a=(0,d.$zp)((0,d.$yp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class m extends O.$Uc{constructor(a,h,t,v,c){super(),this.c=h,this.f=t,this.g=v,this.h=c,this.b=new Map,this.a=a.getProxy(T.$xM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const v=this.j(a);if(v){const{message:c}=(0,f.$Mnb)(h,t.value);v._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const v=new y(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,v);const c=v._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$vkc=m;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>M.URI.from(a))}}function r(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Pe[109],Re([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;let y=class{static{T=this}static{this.a={focused:!0,active:!0}}getState(w){const m=this.d;return{get focused(){return m.focused},get active(){return(0,E.$hG)(w,"windowActivity"),m.active}}}constructor(w){this.c=new I.$_d,this.onDidChangeWindowState=this.c.event,this.d=T.a,this.b=w.getProxy(O.$xM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:n})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,m){m!==this.d[w]&&(this.d={...this.d,[w]:m},this.c.fire(this.d))}openUri(w,m){let n;if(typeof w=="string"){n=w;try{w=R.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,M.$Ze)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,n,m)}async asExternalUri(w,m){if((0,M.$Ze)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri(w,m);return R.URI.from(n)}};e.$3lc=y,e.$3lc=y=T=Je([We(0,f.$UO)],y),e.$4lc=(0,d.$ni)("IExtHostWindow")}),define(Pe[242],Re([1,0,233,27,16]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;let N=class extends I.$9lc{constructor(d,f){super(d,f)}f(d,f,E){f.apply(console,E)}};e.$eoc=N,e.$eoc=N=Je([We(0,R.$UO),We(1,O.$$O)],N)}),define(Pe[243],Re([1,0,11,22,24,14,5,6,144,230,34]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$F$b=o,e.$G$b=s;function u(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const w="$$ref$$",m={[w]:-1};class n{constructor(P,C){this.jsonString=P,this.referencedBuffers=C}}function o(k,P=null,C=!1){const W=[];return{jsonString:(C?u:JSON.stringify)(k,(q,A)=>{if(typeof A>"u")return m;if(typeof A=="object"){if(A instanceof O.$ze){const U=W.push(A)-1;return{[w]:U}}if(P)return P(q,A)}return A}),referencedBuffers:W}}function s(k,P,C){return JSON.parse(k,(W,V)=>{if(V){const q=V[w];if(typeof q=="number")return P[q];if(C&&V.$mid===1)return C.transformIncoming(V)}return V})}function r(k,P){return JSON.stringify(k,P)}function i(k){return k?(P,C)=>C&&C.$mid===1?k.transformOutgoing(C):C:null}var a;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},v=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends d.$Uc{static{y=v}static{this.a=3*1e3}constructor(P,C=null,W=null){super(),this[y]=!0,this.b=this.B(new M.$_d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=C,this.g=W,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$gw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$zh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const C=this.w[P];delete this.w[P],C.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,f.$sn)(P,this.g):P}getProxy(P){const{nid:C,sid:W}=P;return this.s[C]||(this.s[C]=this.J(C,W)),this.s[C]}J(P,C){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...A)=>this.U(P,q,A)),q===c?C:V[q])};return new Proxy(Object.create(null),W)}set(P,C){return this.m[P.nid]=C,C}assertRegistered(P){for(let C=0,W=P.length;C<W;C++){const V=P[C];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(P){if(this.j)return;const C=P.byteLength,W=p.read(P,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:A,method:U,args:K}=D.deserializeRequestJSONArgs(W);this.g&&(K=(0,f.$sn)(K,this.g)),this.M(C,q,A,U,K,V===2);break}case 3:case 4:{let{rpcId:A,method:U,args:K}=D.deserializeRequestMixedArgs(W);this.g&&(K=(0,f.$sn)(K,this.g)),this.M(C,q,A,U,K,V===4);break}case 5:{this.f?.logIncoming(C,q,0,"ack"),this.G(q);break}case 6:{this.N(C,q);break}case 7:{this.O(C,q,void 0);break}case 9:{let A=D.deserializeReplyOKJSON(W);this.g&&(A=(0,f.$sn)(A,this.g)),this.O(C,q,A);break}case 10:{const A=D.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(C,q,A);break}case 8:{const A=D.deserializeReplyOKVSBuffer(W);this.O(C,q,A);break}case 11:{let A=D.deserializeReplyErrError(W);this.g&&(A=(0,f.$sn)(A,this.g)),this.P(C,q,A);break}case 12:{this.P(C,q,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,C,W,V,q,A){this.f?.logIncoming(P,C,1,`receiveRequest ${(0,T.$iw)(W)}.${V}(`,q);const U=String(C);let K,ie;if(A){const Se=new R.$je;q.push(Se.token),K=this.Q(W,V,q),ie=()=>Se.cancel()}else K=this.Q(W,V,q),ie=t;this.u[U]=ie;const fe=D.serializeAcknowledged(C);this.f?.logOutgoing(fe.byteLength,C,1,"ack"),this.c.send(fe),K.then(Se=>{delete this.u[U];const ke=D.serializeReplyOK(C,Se,this.h);this.f?.logOutgoing(ke.byteLength,C,1,"reply:",Se),this.c.send(ke)},Se=>{delete this.u[U];const ke=D.serializeReplyErr(C,Se);this.f?.logOutgoing(ke.byteLength,C,1,"replyErr:",Se),this.c.send(ke)})}N(P,C){this.f?.logIncoming(P,C,1,"receiveCancel");const W=String(C);this.u[W]?.()}O(P,C,W){this.f?.logIncoming(P,C,0,"receiveReply:",W);const V=String(C);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(P,C,W){this.f?.logIncoming(P,C,0,"receiveReplyErr:",W);const V=String(C);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let A;W&&(W.$isError?(A=new Error,A.name=W.name,A.message=W.message,A.stack=W.stack):A=W),q.resolveErr(A)}Q(P,C,W){try{return Promise.resolve(this.S(P,C,W))}catch(V){return Promise.reject(V)}}S(P,C,W){const V=this.m[P];if(!V)throw new Error("Unknown actor "+(0,T.$iw)(P));const q=V[C];if(typeof q!="function")throw new Error("Unknown method "+C+" on actor "+(0,T.$iw)(P));return q.apply(V,W)}U(P,C,W){if(this.j)return new E.$E$b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(N.$6());const q=D.serializeRequestArguments(W,this.h),A=++this.t,U=String(A),K=new E.$D$b,ie=new d.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const Se=D.serializeCancel(A);this.f?.logOutgoing(Se.byteLength,A,0,"cancel"),this.c.send(D.serializeCancel(A))})),this.w[U]=new b(K,ie),this.F(A);const fe=D.serializeRequest(A,P,C,q,!!V);return this.f?.logOutgoing(fe.byteLength,A,0,`request: ${(0,T.$iw)(P)}.${C}(`,W),this.c.send(fe),K}}e.$H$b=$;class b{constructor(P,C){this.a=P,this.b=C}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class p{static alloc(P,C,W){const V=new p(O.$ze.alloc(W+1+4),0);return V.writeUInt8(P),V.writeUInt32(C),V}static read(P,C){return new p(P,C)}get buffer(){return this.a}constructor(P,C){this.a=P,this.b=C}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const C=this.a.slice(this.b,this.b+P);return this.b+=P,C}static sizeMixedArray(P){let C=0;C+=1;for(let W=0,V=P.length;W<V;W++){const q=P[W];switch(C+=1,q.type){case 1:C+=this.sizeLongString(q.value);break;case 2:C+=this.sizeVSBuffer(q.value);break;case 3:C+=this.sizeUInt32,C+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)C+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return C}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let C=0,W=P.length;C<W;C++){const V=P[C];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const C=new Array(P);for(let W=0;W<P;W++)switch(this.readUInt8()){case 1:C[W]=this.readLongString();break;case 2:C[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());C[W]=new T.$jw(s(A,U,null));break}case 4:C[W]=void 0;break}return C}}var l;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(l||(l={}));class D{static a(P){for(let C=0,W=P.length;C<W;C++)if(P[C]instanceof O.$ze||P[C]instanceof T.$jw||typeof P[C]>"u")return!0;return!1}static serializeRequestArguments(P,C){if(this.a(P)){const W=[];for(let V=0,q=P.length;V<q;V++){const A=P[V];if(A instanceof O.$ze)W[V]={type:2,value:A};else if(typeof A>"u")W[V]={type:4};else if(A instanceof T.$jw){const{jsonString:U,referencedBuffers:K}=o(A.value,C);W[V]={type:3,value:O.$ze.fromString(U),buffers:K}}else W[V]={type:1,value:O.$ze.fromString(r(A,C))}}return{type:1,args:W}}return{type:0,args:r(P,C)}}static serializeRequest(P,C,W,V,q){switch(V.type){case 0:return this.b(P,C,W,V.args,q);case 1:return this.c(P,C,W,V.args,q)}}static b(P,C,W,V,q){const A=O.$ze.fromString(W),U=O.$ze.fromString(V);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(A),K+=p.sizeLongString(U);const ie=p.alloc(q?2:1,P,K);return ie.writeUInt8(C),ie.writeShortString(A),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(P){const C=P.readUInt8(),W=P.readShortString(),V=P.readLongString();return{rpcId:C,method:W,args:JSON.parse(V)}}static c(P,C,W,V,q){const A=O.$ze.fromString(W);let U=0;U+=p.sizeUInt8(),U+=p.sizeShortString(A),U+=p.sizeMixedArray(V);const K=p.alloc(q?4:3,P,U);return K.writeUInt8(C),K.writeShortString(A),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(P){const C=P.readUInt8(),W=P.readShortString(),V=P.readMixedArray(),q=new Array(V.length);for(let A=0,U=V.length;A<U;A++){const K=V[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:C,method:W,args:q}}static serializeAcknowledged(P){return p.alloc(5,P,0).buffer}static serializeCancel(P){return p.alloc(6,P,0).buffer}static serializeReplyOK(P,C,W){if(typeof C>"u")return this.d(P);if(C instanceof O.$ze)return this.e(P,C);if(C instanceof T.$jw){const{jsonString:V,referencedBuffers:q}=o(C.value,W,!0);return this.g(P,V,q)}else return this.f(P,u(C,W))}static d(P){return p.alloc(7,P,0).buffer}static e(P,C){let W=0;W+=p.sizeVSBuffer(C);const V=p.alloc(8,P,W);return V.writeVSBuffer(C),V.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,C){const W=O.$ze.fromString(C);let V=0;V+=p.sizeLongString(W);const q=p.alloc(9,P,V);return q.writeLongString(W),q.buffer}static g(P,C,W){const V=O.$ze.fromString(C);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(V);for(const U of W)q+=p.sizeVSBuffer(U);const A=p.alloc(10,P,q);A.writeUInt32(W.length),A.writeLongString(V);for(const U of W)A.writeBuffer(U);return A.buffer}static deserializeReplyOKJSON(P){const C=P.readLongString();return JSON.parse(C)}static deserializeReplyOKJSONWithBuffers(P,C){const W=P.readUInt32(),V=P.readLongString(),q=[];for(let A=0;A<W;++A)q.push(P.readVSBuffer());return new T.$jw(s(V,q,C))}static serializeReplyErr(P,C){const W=C?u(N.$3(C),null):void 0;if(typeof W!="string")return this.h(P);const V=O.$ze.fromString(W);let q=0;q+=p.sizeLongString(V);const A=p.alloc(11,P,q);return A.writeLongString(V),A.buffer}static deserializeReplyErrError(P){const C=P.readLongString();return JSON.parse(C)}static h(P){return p.alloc(12,P,0).buffer}}var g;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var S;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(S||(S={}))}),define(Pe[244],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;const I=function(N){const M=d=>{globalThis.removeEventListener("message",M);const f=d.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){f.postMessage(E,T)}},onmessage:{get(){return f.onmessage},set(E){f.onmessage=E}}}),f.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",M)}.toString();class O extends EventTarget{constructor(N,M,d){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${I})('${M}'))`,E=new Blob([f],{type:"application/javascript"}),T=URL.createObjectURL(E),y=new MessageChannel,u=T,w={type:"_newWorker",id:u,port:y.port2,url:T,options:d};N(w,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(T),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const n=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",m=>{const n=new MessageEvent("message",{data:m.data});this.dispatchEvent(n)}),y.port1.start()}}e.$goc=O}),define(Pe[245],Re([1,0,22,28,12,55,3]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$_J=void 0,e.$aK=T,e.$bK=y,e.$_J=(0,M.$ni)("notebookDocumentService");const d=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${d.join("")}]+`),E=7;function T(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const m=w.fragment.indexOf("s");if(m<0)return;const n=parseInt(w.fragment.substring(0,m).replace(f,""),E),o=(0,I.$Se)(w.fragment.substring(m+1)).toString();if(!isNaN(n))return{handle:n,notebook:w.with({scheme:o,fragment:null})}}function y(w,m){const n=m.toString(E),s=`${n.length<d.length?d[n.length-1]:"z"}${n}s${(0,I.$Te)(I.$ze.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new O.$Bc}getNotebook(m){if(m.scheme===R.Schemas.vscodeNotebookCell){const n=T(m);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$cK=u,(0,N.$ls)(e.$_J,u,1)}),define(Pe[83],Re([1,0,22,36,46,69,12,19,21,33,245]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.$tK=e.CellStatusbarAlignment=e.$sK=e.NotebookEditorPriority=e.$pK=e.$oK=e.$mK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$lK=e.$kK=e.$jK=e.$iK=e.CellKind=e.$hK=e.$gK=e.$fK=void 0,e.$nK=v,e.$qK=$,e.$rK=b,e.$uK=D,e.$vK=S,e.$fK="workbench.editor.notebook",e.$gK="workbench.editor.notebookTextDiffEditor",e.$hK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$iK=["application/json","application/javascript","text/html","image/svg+xml",N.$Es.latex,N.$Es.markdown,"image/png","image/jpeg",N.$Es.text],e.$jK=[N.$Es.latex,N.$Es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$Es.text],e.$kK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$lK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var n;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var r;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function ie(ne,Ie){return(0,T.$bK)(ne,Ie)}K.generate=ie;function fe(ne){return(0,T.$aK)(ne)}K.parse=fe;function Se(ne,Ie){return ne.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${ne.scheme!==M.Schemas.file?ne.scheme:""}`})}K.generateCellOutputUri=Se;function ke(ne){if(ne.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Ie)return;const ze=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,re=Ie[2];return{outputId:ze,notebook:ne.with({scheme:re||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=ke;function oe(ne,Ie,ze){return K.generate(ne,Ie).with({scheme:ze})}K.generateCellPropertyUri=oe;function $e(ne,Ie){if(ne.scheme===Ie)return K.parse(ne.with({scheme:K.scheme}))}K.parseCellPropertyUri=$e})(a||(e.CellUri=a={}));const h=K=>f.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],fe=e.$iK){this.e=fe,this.d=[...new Set(ie)].map(Se=>({pattern:Se,matches:O.$hk(h(Se))}))}sort(ie){const fe=new Map(R.Iterable.map(ie,ke=>[ke,h(ke)]));let Se=[];for(const{matches:ke}of this.d)for(const[oe,$e]of fe)if(ke($e)){Se.push(oe),fe.delete(oe);break}return fe.size&&(Se=Se.concat([...fe.keys()].sort((ke,oe)=>this.e.indexOf(ke)-this.e.indexOf(oe)))),Se}prioritize(ie,fe){const Se=this.f(ie);if(Se===-1){this.d.unshift({pattern:ie,matches:O.$hk(h(ie))});return}const ke=new Set(fe.map($e=>this.f($e,Se)));ke.delete(-1);const oe=Array.from(ke).sort();this.d.splice(Se+1,0,...oe.map($e=>this.d[$e]));for(let $e=oe.length-1;$e>=0;$e--)this.d.splice(oe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,fe=this.d.length){const Se=h(ie);for(let ke=0;ke<fe;ke++)if(this.d[ke].matches(Se))return ke;return-1}}e.$mK=t;function v(K,ie,fe,Se=(ke,oe)=>ke===oe){const ke=[];function oe(Ie,ze,re){if(ze===0&&re.length===0)return;const L=ke[ke.length-1];L&&L.start+L.deleteCount===Ie?(L.deleteCount+=ze,L.toInsert.push(...re)):ke.push({start:Ie,deleteCount:ze,toInsert:re})}let $e=0,ne=0;for(;;){if($e===K.length){oe($e,0,ie.slice(ne));break}if(ne===ie.length){oe($e,K.length-$e,[]);break}const Ie=K[$e],ze=ie[ne];if(Se(Ie,ze)){$e+=1,ne+=1;continue}fe(ze)?(oe($e,1,[]),$e+=1):(oe($e,0,[ze]),ne+=1)}return ke}e.$oK=new E.$Ej("notebookEditorCursorAtBoundary","none"),e.$pK=new E.$Ej("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(K){const ie=K;return!!((typeof ie.include=="string"||O.$ik(ie.include))&&(typeof ie.exclude=="string"||O.$ik(ie.exclude)))}function b(K,ie,fe){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const Se=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,ke=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(O.$gk(Se,(0,d.$oc)(fe.fsPath).toLowerCase()))return!(ke&&O.$gk(ke,(0,d.$oc)(fe.fsPath).toLowerCase()))}return!1}e.$sK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class l{static{this.d="notebook/"}static create(ie){return`${l.d}${ie}`}static parse(ie){if(ie.startsWith(l.d))return ie.substring(l.d.length)}}e.$tK=l;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const g=new TextDecoder;function S(K){const ie=[];let fe=!1;for(const $e of K)(ie.length===0||fe)&&(ie.push($e),fe=!0);let Se=C(ie);const ke=I.$ze.concat(ie.map($e=>I.$ze.wrap($e))),oe=U(ke);return Se=Se||oe.byteLength!==ke.byteLength,{data:oe,didCompression:Se}}e.$wK="\x1B[A";const k=e.$wK.split("").map(K=>K.charCodeAt(0)),P=10;function C(K){let ie=!1;return K.forEach((fe,Se)=>{if(Se===0||fe.length<e.$wK.length)return;const ke=K[Se-1],oe=fe.subarray(0,e.$wK.length);if(oe[0]===k[0]&&oe[1]===k[1]&&oe[2]===k[2]){const $e=ke.lastIndexOf(P);if($e===-1)return;ie=!0,K[Se-1]=ke.subarray(0,$e),K[Se]=fe.subarray(e.$wK.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let fe=K.match(/\r+(.*)$/m)[1];fe=fe+ie.slice(fe.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,fe)}return K}const q=8,A=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:I.$ze.fromString(V(W(g.decode(K.buffer))))}}),define(Pe[7],Re([1,0,18,14,54,28,69,15,17,2,35,20,43,102,83]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m){"use strict";var n,o,s,r,i,a,h,t,v,c,$,b,p,l,D,g,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$IO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$HO=e.$GO=e.$FO=e.$EO=e.ChatLocation=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$uO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$hO=e.$gO=e.$fO=e.$eO=e.$cO=e.$bO=e.$aO=e.$_N=e.TestRunProfileKind=e.TestResultState=e.$$N=e.$0N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$9N=e.NotebookVariablesRequestKind=e.$8N=e.$7N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$6N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.ColorThemeKind=e.$ZN=e.$YN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$XN=e.$WN=e.DebugConsoleMode=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$QN=e.$PN=e.FileChangeType=e.$ON=e.NewSymbolNameTag=e.$NN=e.$MN=e.$LN=e.$KN=e.InlineCompletionTriggerKind=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$xN=e.ConfigurationTarget=e.$wN=e.$vN=e.$uN=e.$tN=e.DocumentPasteTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mN=e.ViewBadge=e.ProgressLocation=e.$lN=e.$kN=e.TaskScope=e.ShellQuoting=e.$jN=e.$iN=e.$hN=e.TaskPanelKind=e.TaskRevealKind=e.$gN=e.TerminalLocation=e.$fN=e.$eN=e.$dN=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cN=e.$bN=e.$aN=e.$_M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$0M=e.$9M=e.$8M=e.$7M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6M=e.$5M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.LanguageStatusSeverity=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.CodeActionTriggerKind=e.$SM=e.$RM=e.SymbolTag=e.SymbolKind=e.$QM=e.$PM=e.DocumentHighlightKind=e.$OM=e.$NM=e.$MM=e.$LM=e.DiagnosticSeverity=e.DiagnosticTag=e.$KM=e.$JM=e.FileEditType=e.$IM=e.$HM=e.$GM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$$M=dt,e.$yN=ae,e.$dO=Le;function k(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ke]=te;return Reflect.construct(B,Ke,De.constructor)}}})}var P;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var C;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(C||(e.TerminalQuickFixType=C={}));let W=n=class{static from(...F){let te=F;return new n(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zM=W,e.$zM=W=n=Je([k],W);let V=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ke=F[De];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ke=F[De];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:De}=F;return typeof te=="number"&&typeof De=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,O.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,O.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$AM=V,e.$AM=V=o=Je([k],V);let q=s=class{static isRange(F){return F instanceof s?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof s)return F;if(this.isRange(F))return new s(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,De,Ke){let xe,ht;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(xe=new V(F,te),ht=new V(De,Ke)):V.isPosition(F)&&V.isPosition(te)&&(xe=V.of(F),ht=V.of(te)),!xe||!ht)throw new Error("Invalid arguments");xe.isBefore(ht)?(this.c=xe,this.e=ht):(this.c=ht,this.e=xe)}contains(F){return s.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=V.Max(F.start,this.c),De=V.Min(F.end,this.e);if(!te.isAfter(De))return new s(te,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=V.Min(F.start,this.c),De=V.Max(F.end,this.end);return new s(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,O.$7)();let De;return F?V.isPosition(F)?De=F:(De=F.start||this.start,te=F.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new s(De,te)}toJSON(){return[this.start,this.end]}};e.$BM=q,e.$BM=q=s=Je([k],q);let A=r=class extends q{static isSelection(F){return F instanceof r?!0:F?q.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,De,Ke){let xe,ht;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(xe=new V(F,te),ht=new V(De,Ke)):V.isPosition(F)&&V.isPosition(te)&&(xe=V.of(F),ht=V.of(te)),!xe||!ht)throw new Error("Invalid arguments");super(xe,ht),this.f=xe,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CM=A,e.$CM=A=r=Je([k],A);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,De){if(typeof F!="string"||F.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof De<"u"&&U(De),this.host=F,this.port=Math.round(te),this.connectionToken=De}}e.$DM=K;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&U(te)}}e.$EM=ie;class fe extends Error{static NotAvailable(F,te){return new fe(F,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new fe(F,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=w.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=te,this._detail=De,Object.setPrototypeOf(this,fe.prototype)}}e.$FM=fe;var Se;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(Se||(e.EndOfLine=Se={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let oe=i=class{static isTextEdit(F){return F instanceof i?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new q(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new q(new V(0,0),new V(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,O.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,O.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,O.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GM=oe,e.$GM=oe=i=Je([k],oe);let $e=a=class{static isNotebookCellEdit(F){return F instanceof a?!0:F?Fe.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new a(F,te)}static insertCells(F,te){return new a(new Fe(F,F),te)}static deleteCells(F){return new a(F,[])}static updateCellMetadata(F,te){const De=new a(new Fe(F,F),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(F){const te=new a(new Fe(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$HM=$e,e.$HM=$e=a=Je([k],$e);class ne{static isSnippetTextEdit(F){return F instanceof ne?!0:F?q.isRange(F.range)&&re.isSnippetString(F.snippet):!1}static replace(F,te){return new ne(F,te)}static insert(F,te){return ne.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$IM=ne;var Ie;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let ze=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,De,Ke){this.c.push({_type:1,from:F,to:te,options:De,metadata:Ke})}createFile(F,te,De){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:De})}deleteFile(F,te,De){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:De})}e(F,te,De){this.c.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,De,Ke){const xe=te.start,ht=te.end;(xe!==ht||De.length>0)&&this.c.push({_type:5,uri:F,index:xe,count:ht-xe,cells:De,metadata:Ke})}g(F,te,De,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:De}})}replace(F,te,De,Ke){this.c.push({_type:2,uri:F,edit:new oe(te,De),metadata:Ke})}insert(F,te,De,Ke){this.replace(F,new q(te,te),De,Ke)}delete(F,te,De){this.replace(F,te,"",De)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const De of te){if(!De)continue;let Ke,xe;Array.isArray(De)?(Ke=De[0],xe=De[1]):Ke=De,$e.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,xe):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,xe):this.f(F,Ke.range,Ke.newCells,xe):ne.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:xe}):this.c.push({_type:2,uri:F,edit:Ke,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Ke=this.c[De];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(F){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===F.toString()&&te.push(De.edit);return te}entries(){const F=new N.$Bc;for(const te of this.c)if(te._type===2){let De=F.get(te.uri);De||(De=[te.uri,[]],F.set(te.uri,De)),De[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JM=ze,e.$JM=ze=Je([k],ze);let re=h=class{static isSnippetString(F){return F instanceof h?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=h.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const De=new h;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=h.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const De=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const De=new h;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$KM=re,e.$KM=re=h=Je([k],re);var L;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(L||(e.DiagnosticTag=L={}));var _;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let ve=t=class{static isLocation(F){return F instanceof t?!0:F?q.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LM=ve,e.$LM=ve=t=Je([k],ve);let Te=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$MM=Te,e.$MM=Te=Je([k],Te);let Ee=class{constructor(F,te,De=_.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=De}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.$ub)(F.tags,te.tags)&&(0,I.$ub)(F.relatedInformation,te.relatedInformation,Te.isEqual)}};e.$NM=Ee,e.$NM=Ee=Je([k],Ee);let pe=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$OM=pe,e.$OM=pe=Je([k],pe);var de;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let Q=class{constructor(F,te=de.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$PM=Q,e.$PM=Q=Je([k],Q);let Y=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$QM=Y,e.$QM=Y=Je([k],Y);var ue;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var he;(function(B){B[B.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let Ne=v=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,De,Ke,xe){this.name=F,this.kind=te,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Ke instanceof ve?this.location=Ke:De instanceof q&&(this.location=new ve(Ke,De)),v.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.$RM=Ne,e.$RM=Ne=v=Je([k],Ne);let le=c=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(c.validate)}constructor(F,te,De,Ke,xe){this.name=F,this.detail=te,this.kind=De,this.range=Ke,this.selectionRange=xe,this.children=[],c.validate(this)}};e.$SM=le,e.$SM=le=c=Je([k],le);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Ae=class{constructor(F,te){this.title=F,this.kind=te}};e.$TM=Ae,e.$TM=Ae=Je([k],Ae);let Ue=class{static{$=this}static{this.c="."}constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};e.$UM=Ue,e.$UM=Ue=$=Je([k],Ue),Ue.Empty=new Ue(""),Ue.QuickFix=Ue.Empty.append("quickfix"),Ue.Refactor=Ue.Empty.append("refactor"),Ue.RefactorExtract=Ue.Refactor.append("extract"),Ue.RefactorInline=Ue.Refactor.append("inline"),Ue.RefactorMove=Ue.Refactor.append("move"),Ue.RefactorRewrite=Ue.Refactor.append("rewrite"),Ue.Source=Ue.Empty.append("source"),Ue.SourceOrganizeImports=Ue.Source.append("organizeImports"),Ue.SourceFixAll=Ue.Source.append("fixAll"),Ue.Notebook=Ue.Empty.append("notebook");let j=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VM=j,e.$VM=j=Je([k],j);class z{constructor(F,te,De,Ke,xe,ht){this.kind=F,this.name=te,this.detail=De,this.uri=Ke,this.range=xe,this.selectionRange=ht}}e.$WM=z;class G{constructor(F,te){this.fromRanges=te,this.from=F}}e.$XM=G;class H{constructor(F,te){this.fromRanges=te,this.to=F}}e.$YM=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$ZM=se,e.$ZM=se=Je([k],se);let Oe=b=class{#e;static isMarkdownString(F){return F instanceof b?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new R.$Kk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$1M=Oe,e.$1M=Oe=b=Je([k],Oe);let Be=class{constructor(F,te){this.label=F,this.documentation=te}};e.$2M=Be,e.$2M=Be=Je([k],Be);let Qe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$3M=Qe,e.$3M=Qe=Je([k],Qe);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4M=Ye,e.$4M=Ye=Je([k],Ye);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var at;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let it=class{constructor(F){this.value=F}};e.$5M=it,e.$5M=it=Je([k],it);let tt=class{constructor(F,te,De){this.position=F,this.label=te,this.kind=De}};e.$6M=tt,e.$6M=tt=Je([k],tt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7M=st,e.$7M=st=Je([k],st);let X=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$8M=X,e.$8M=X=Je([k],X);let Z=class{constructor(F,te,De){this.insertText=F,this.range=te,this.command=De}};e.$9M=Z,e.$9M=Z=Je([k],Z);let me=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$0M=me,e.$0M=me=Je([k],me);var qe;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(qe||(e.PartialAcceptTriggerKind=qe={}));var we;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(we||(e.ViewColumn=we={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,F){return`${y.$Im.toKey(B)}.${F}`}var Ct;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Ct||(e.TextEditorLineNumbersStyle=Ct={}));var jt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(jt||(e.TextDocumentSaveReason=jt={}));var _t;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var Jt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var ei;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var Dt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Wt||(e.SyntaxTokenType=Wt={}));let Qt=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.target=te}};e.$_M=Qt,e.$_M=Qt=Je([k],Qt);let Xe=class{constructor(F,te,De,Ke){this.red=F,this.green=te,this.blue=De,this.alpha=Ke}};e.$aN=Xe,e.$aN=Xe=Je([k],Xe);let ai=class{constructor(F,te){if(te&&!(te instanceof Xe))throw(0,O.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.color=te}};e.$bN=ai,e.$bN=ai=Je([k],ai);let ti=class{constructor(F){if(!F||typeof F!="string")throw(0,O.$7)("label");this.label=F}};e.$cN=ti,e.$cN=ti=Je([k],ti);var ii;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var lt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(lt||(e.SourceControlInputBoxValidationType=lt={}));var vt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(vt||(e.TerminalExitReason=vt={}));class si{constructor(F,te,De){if(this.startIndex=F,this.length=te,this.tooltip=De,typeof F!="number"||F<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,O.$7)("tooltip")}}e.$dN=si;class ni{constructor(F){this.uri=F}}e.$eN=ni;class Tt{constructor(F){this.terminalCommand=F}}e.$fN=Tt;var mt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(mt||(e.TerminalLocation=mt={}));class Rt{constructor(F){if(this.options=F,typeof F!="object")throw(0,O.$7)("options")}}e.$gN=Rt;var qt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(qt||(e.TaskRevealKind=qt={}));var Zt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let He=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(F){switch(F){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=F}get id(){return this.c}};e.$hN=He,e.$hN=He=p=Je([k],He);function Xt(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let Ut=class{constructor(F,te,De){if(typeof F!="string")throw(0,O.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,O.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Xt(F)}};e.$iN=Ut,e.$iN=Ut=Je([k],Ut);let Bt=class{constructor(F,te,De){if(this.f=[],Array.isArray(te)){if(!F)throw(0,O.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F,this.f=te,this.g=De}else{if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Xt(F)}};e.$jN=Bt,e.$jN=Bt=Je([k],Bt);var $t;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var Ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class At{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Jg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$kN=At;let Lt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,De,Ke,xe,ht){this.k=!1,this.l=this.definition=F;let gt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ke,gt=xe,this.k=!0):te===Ft.Global||te===Ft.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=xe,gt=ht):(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=xe,gt=ht),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof Bt?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof At?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,T.$Jg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,O.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(l.g===te||l.e===te||l.f===te||l.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$lN=Lt,e.$lN=Lt=l=Je([k],Lt);var ri;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ri||(e.ProgressLocation=ri={}));var oi;(function(B){function F(te){const De=te;return(0,f.$5f)(De.value)?De.tooltip&&!(0,f.$1f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=F})(oi||(e.ViewBadge=oi={}));let Vt=D=class{static isTreeItem(F,te){const De=F;if(De.checkboxState!==void 0){const Ke=(0,f.$5f)(De.checkboxState)?De.checkboxState:(0,f.$3f)(De.checkboxState)&&(0,f.$5f)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,f.$5f)(De.checkboxState)&&(0,f.$3f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==kt.Checked&&Ke!==kt.Unchecked||xe!==void 0&&!(0,f.$1f)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof D)return!0;if(De.label!==void 0&&!(0,f.$1f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,f.$1f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,f.$1f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,f.$1f)(De.iconPath.id))){const Ke=De.iconPath;if(!Ke||!(0,f.$1f)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,f.$1f)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,f.$1f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,f.$1f)(De.tooltip)&&!(De.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Pt.None&&De.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,f.$1f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,te=Pt.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$mN=Vt,e.$mN=Vt=D=Je([k],Vt);var Pt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var kt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$nN=Yt,e.$nN=Yt=Je([k],Yt);class St extends Yt{}e.$oN=St;class yt extends St{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$pN=yt;class It{constructor(F,te,De,Ke){this.name=F,this.uri=te,this._itemId=De,this.c=Ke}data(){return this.c()}}e.$qN=It;let li=class{#e=new Map;constructor(F){for(const[te,De]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(De):this.#e.set(this.#t(te),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[De,Ke]of this.#e)for(const xe of Ke)F.call(te,xe,De,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const De of te)yield[F,De]}#t(F){return F.toLowerCase()}};e.$rN=li,e.$rN=li=Je([k],li);let Et=class{constructor(F,te,De){this.insertText=F,this.title=te,this.kind=De}};e.$sN=Et,e.$sN=Et=Je([k],Et);var hi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(hi||(e.DocumentPasteTriggerKind=hi={}));class zt{static{this.c="."}constructor(F){this.value=F}append(...F){return new zt((this.value?[this.value,...F]:F).join(zt.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+zt.c)}}e.$tN=zt,zt.Empty=new zt("");let vi=class{constructor(F,te,De){this.title=te,this.insertText=F,this.kind=De}};e.$uN=vi,e.$uN=vi=Je([k],vi);let Ht=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$vN=Ht,e.$vN=Ht=Je([k],Ht),Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let gi=class{constructor(F){this.id=F}};e.$wN=gi,e.$wN=gi=Je([k],gi);var Ot;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ot||(e.ConfigurationTarget=Ot={}));let be=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xN=be,e.$xN=be=Je([k],be);const Me=new WeakMap;function ae(B,F){Me.set(B,F)}let J=class{constructor(F,te,De,Ke,xe){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke),typeof xe=="string"&&(this.mode=xe)}get id(){return this.c||(this.c=Me.get(this)??(0,T.$Jg)()),this.c}};e.$zN=J,e.$zN=J=Je([k],J);let ye=class extends J{constructor(F,te,De,Ke,xe,ht){if(super(te,De,Ke,xe,ht),F===null)throw(0,O.$7)("location");this.location=F}};e.$AN=ye,e.$AN=ye=Je([k],ye);let Ve=class extends J{constructor(F,te,De,Ke,xe,ht){super(te,De,Ke,xe,ht),this.functionName=F}};e.$BN=Ve,e.$BN=Ve=Je([k],Ve);let Ze=class extends J{constructor(F,te,De,Ke,xe,ht,gt,Kt){if(super(Ke,xe,ht,gt,Kt),!te)throw(0,O.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=De}};e.$CN=Ze,e.$CN=Ze=Je([k],Ze);let Ge=class{constructor(F,te,De){this.command=F,this.args=te||[],this.options=De}};e.$DN=Ge,e.$DN=Ge=Je([k],Ge);let nt=class{constructor(F,te){this.port=F,this.host=te}};e.$EN=nt,e.$EN=nt=Je([k],nt);let wt=class{constructor(F){this.path=F}};e.$FN=wt,e.$FN=wt=Je([k],wt);let Gt=class{constructor(F){this.implementation=F}};e.$GN=Gt,e.$GN=Gt=Je([k],Gt);class xt{constructor(F,te,De){this.session=F,this.threadId=te,this.frameId=De}}e.$HN=xt;class Mt{constructor(F,te){this.session=F,this.threadId=te}}e.$IN=Mt;let ut=class{constructor(F,te){this.range=F,this.expression=te}};e.$JN=ut,e.$JN=ut=Je([k],ut);var Wi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Wi||(e.InlineCompletionTriggerKind=Wi={}));let di=class{constructor(F,te){this.range=F,this.text=te}};e.$KN=di,e.$KN=di=Je([k],di);let $i=class{constructor(F,te,De=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=De}};e.$LN=$i,e.$LN=$i=Je([k],$i);let yi=class{constructor(F,te){this.range=F,this.expression=te}};e.$MN=yi,e.$MN=yi=Je([k],yi);let Ri=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$NN=Ri,e.$NN=Ri=Je([k],Ri);var qi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));class hn{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$ON=hn;var Ai;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Mi=g=class extends Error{static FileExists(F){return new g(F,u.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(F){return new g(F,u.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(F){return new g(F,u.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(F){return new g(F,u.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(F){return new g(F,u.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(F){return new g(F,u.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,u.$9k)(this,te),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$PN=Mi,e.$PN=Mi=g=Je([k],Mi);let ki=class{constructor(F,te,De){this.start=F,this.end=te,this.kind=De}};e.$QN=ki,e.$QN=ki=Je([k],ki);var Hi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ei;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Di;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Di||(e.CommentMode=Di={}));var Gi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var Ki;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ki||(e.CommentThreadState=Ki={}));var bi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(bi||(e.CommentThreadApplicability=bi={}));class dn{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$RN=dn;function fn(B){return typeof B>"u"||(0,f.$2f)(B)}class Ti{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,De=F.tokenTypes.length;te<De;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,De=F.tokenModifiers.length;te<De;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,De,Ke,xe){if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(F,te,De,Ke,xe);if(q.isRange(F)&&typeof te=="string"&&fn(De))return this.o(F,te,De);throw(0,O.$7)()}o(F,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,xe=F.start.character,ht=F.end.character-F.start.character,gt=this.k.get(te);let Kt=0;if(De)for(const ui of De){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ui);Kt|=1<<fi>>>0}this.q(Ke,xe,ht,gt,Kt)}q(F,te,De,Ke,xe){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Kt=this.g.length/5|0;let ui=0,fi=0;for(let mi=0;mi<Kt;mi++){let pi=this.g[5*mi],Bi=this.g[5*mi+1];pi===0?(pi=ui,Bi+=fi):pi+=ui,this.g[5*mi]=pi,this.g[5*mi+1]=Bi,ui=pi,fi=Bi}}let ht=F,gt=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&(gt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ke,this.g[this.j++]=xe,this.c=F,this.e=te}static r(F){const te=[],De=F.length/5|0;for(let gt=0;gt<De;gt++)te[gt]=gt;te.sort((gt,Kt)=>{const ui=F[5*gt],fi=F[5*Kt];if(ui===fi){const mi=F[5*gt+1],pi=F[5*Kt+1];return mi-pi}return ui-fi});const Ke=new Uint32Array(F.length);let xe=0,ht=0;for(let gt=0;gt<De;gt++){const Kt=5*te[gt],ui=F[Kt+0],fi=F[Kt+1],mi=F[Kt+2],pi=F[Kt+3],Bi=F[Kt+4],On=ui-xe,or=On===0?fi-ht:fi,Vi=5*gt;Ke[Vi+0]=On,Ke[Vi+1]=or,Ke[Vi+2]=mi,Ke[Vi+3]=pi,Ke[Vi+4]=Bi,xe=ui,ht=fi}return Ke}build(F){return this.f?new Si(new Uint32Array(this.g),F):new Si(Ti.r(this.g),F)}}e.$SN=Ti;class Si{constructor(F,te){this.resultId=te,this.data=F}}e.$TN=Si;class gn{constructor(F,te,De){this.start=F,this.deleteCount=te,this.data=De}}e.$UN=gn;class Ji{constructor(F,te){this.resultId=te,this.edits=F}}e.$VN=Ji;var Oi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Oi||(e.DebugConsoleMode=Oi={}));class mn{constructor(F){this.name=F}}e.$WN=mn;let Ii=class{static{this.Back={iconPath:new Ht("arrow-left")}}constructor(){}};e.$XN=Ii,e.$XN=Ii=Je([k],Ii);var Qi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var Xi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Xi||(e.ExtensionKind=Xi={}));class $n{static validate(F){if(typeof F.badge=="string"){let te=(0,d.$Af)(F.badge,0);if(te<F.badge.length&&(te+=(0,d.$Af)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ht.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,De){this.badge=F,this.tooltip=te,this.color=De}}e.$YN=$n;let wi=class{constructor(F){this.kind=F}};e.$ZN=wi,e.$ZN=wi=Je([k],wi);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class Fe{static isNotebookRange(F){return F instanceof Fe?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,De=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(De=F.end),te===this.c&&De===this.e?this:new Fe(te,De)}}e.$1N=Fe;class ci{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>ci.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,De,Ke,xe,ht,gt){this.kind=F,this.value=te,this.languageId=De,this.mime=Ke,this.outputs=xe??[],this.metadata=ht,this.executionSummary=gt,ci.validate(this)}}e.$2N=ci;class Yi{constructor(F){this.cells=F}}e.$3N=Yi;class _e{static isNotebookCellOutputItem(F){return F instanceof _e?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return _e.json(te,"application/vnd.code.notebook.error")}static stdout(F){return _e.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return _e.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new _e(F,te)}static#e=new TextEncoder;static text(F,te=M.$Es.text){const De=_e.#e.encode(String(F));return new _e(De,te)}static json(F,te="text/x-json"){const De=JSON.stringify(F,void 0,"	");return _e.text(De,te)}constructor(F,te){this.data=F,this.mime=te;const De=(0,M.$Is)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$4N=_e;class pt{static isNotebookCellOutput(F){return F instanceof pt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const De=new Set,Ke=new Set;for(let xe=0;xe<F.length;xe++){const ht=F[xe],gt=(0,M.$Is)(ht.mime);if(!De.has(gt)||(0,m.$uK)(gt)){De.add(gt);continue}Ke.add(xe),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?F:F.filter((xe,ht)=>!Ke.has(ht))}constructor(F,te,De){this.items=pt.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Jg)(),this.metadata=te??De)}}e.$5N=pt;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var _i;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var Fi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Fi||(e.NotebookCellStatusBarAlignment=Fi={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class Ci{constructor(F,te){this.text=F,this.alignment=te}}e.$6N=Ci;var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var nn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(nn||(e.NotebookControllerAffinity2=nn={}));class pn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.$3b)(te)}}e.$7N=pn;class rn{constructor(F){this.label=F}}e.$8N=rn;var sn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Li=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$9N=Li,e.$9N=Li=Je([k],Li);var on;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var an;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class vn{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$0N=vn;class bn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$$N=bn;var un;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let zi=class{constructor(F=void 0,te=void 0,De=void 0,Ke=!1){this.include=F,this.exclude=te,this.profile=De,this.continuous=Ke}};e.$_N=zi,e.$_N=zi=Je([k],zi);let Ui=S=class{static diff(F,te,De){const Ke=new S(F);return Ke.expectedOutput=te,Ke.actualOutput=De,Ke}constructor(F){this.message=F}};e.$aO=Ui,e.$aO=Ui=S=Je([k],Ui);let x=class{constructor(F){this.id=F}};e.$bO=x,e.$bO=x=Je([k],x);class ce{constructor(F,te){this.covered=F,this.total=te,Le(this)}}e.$cO=ce;function Le(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class rt{static fromDetails(F,te){const De=new ce(0,0),Ke=new ce(0,0),xe=new ce(0,0);for(const gt of te)if("branches"in gt){De.total+=1,De.covered+=gt.executed?1:0;for(const Kt of gt.branches)Ke.total+=1,Ke.covered+=Kt.executed?1:0}else xe.total+=1,xe.covered+=gt.executed?1:0;const ht=new rt(F,De,Ke.total>0?Ke:void 0,xe.total>0?xe:void 0);return ht.detailedCoverage=te,ht}constructor(F,te,De,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ke}}e.$eO=rt;class bt{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De=[]){this.executed=F,this.location=te,this.branches=De}}e.$fO=bt;class Nt{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.executed=F,this.location=te,this.label=De}}e.$gO=Nt;class ji{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.name=F,this.executed=te,this.location=De}}e.$hO=ji;var wn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Nn{constructor(F,te,De,Ke,xe,ht){this.kind=F,this.name=te,this.detail=De,this.uri=Ke,this.range=xe,this.selectionRange=ht}}e.$iO=Nn;class Fn{constructor(F){this.uri=F}}e.$jO=Fn;class Ln{constructor(F,te){this.original=F,this.modified=te}}e.$kO=Ln;class zn{constructor(F,te,De,Ke){this.base=F,this.input1=te,this.input2=De,this.result=Ke}}e.$lO=zn;class Un{constructor(F,te){this.uri=F,this.viewType=te}}e.$mO=Un;class jn{constructor(F){this.viewType=F}}e.$nO=jn;class Bn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$oO=Bn;class Vn{constructor(F,te,De){this.original=F,this.modified=te,this.notebookType=De}}e.$pO=Vn;class Wn{constructor(){}}e.$qO=Wn;class qn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$rO=qn;class Hn{constructor(F){this.providerId=F}}e.$sO=Hn;class Gn{constructor(F){this.textDiffs=F}}e.$tO=Gn;var En;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Dn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var Sn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Kn{constructor(F,te){this.label=F,this.values=te}}e.$uO=Kn;var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Jn{constructor(F){this.value=typeof F=="string"?new Oe(F):F}}e.$vO=Jn;class Qn{constructor(F,te){this.value=F,this.baseUri=te}}e.$wO=Qn;class Zn{constructor(F,te){this.value=F,this.title=te}}e.$xO=Zn;class Xn{constructor(F){this.value=F}}e.$yO=Xn;class Yn{constructor(F){this.value=F}}e.$zO=Yn;class xn{constructor(F){this.value=F}}e.$AO=xn;class _n{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$BO=_n;class er{constructor(F,te,De,Ke){this.prompt=F,this.command=te,this.variables=De,this.participant=Ke}}e.$CO=er;class tr{constructor(F,te,De,Ke){this.response=F,this.result=te,this.participant=De,this.command=Ke}}e.$DO=tr;var Pn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Pn||(e.ChatLocation=Pn={}));class ir{constructor(F){this.content=F}}e.$EO=ir;class nr{constructor(F,te){this.content=F,this.name=te}}e.$FO=nr;class rr{constructor(F,te){this.content=F,this.name=te}}e.$GO=rr;class Pi extends Error{static NotFound(F){return new Pi(F,Pi.NotFound.name)}static NoPermissions(F){return new Pi(F,Pi.NoPermissions.name)}constructor(F,te,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$HO=Pi;var Rn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var An;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(An||(e.SpeechToTextStatus=An={}));var Mn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class sr{constructor(F,te){this.text=F,this.range=te}}e.$IO=sr;var Tn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Tn||(e.InlineEditTriggerKind=Tn={}))}),define(Pe[246],Re([1,0,4,7]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$xM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,d,f){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(d,f)??[]}getRelatedInformation(M,d,f){return this.c.$getAiRelatedInformation(d,f)}registerRelatedInformationProvider(M,d,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiRelatedInformationProvider(E,d),new O.$zM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Xjc=R}),define(Pe[84],Re([1,0,5,4,7,20,106,3,16]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$9jc=void 0,e.$9jc=(0,d.$ni)("IExtHostAuthentication");let E=class{constructor(u){this.b=new Map,this.c=new I.$_d,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=u.getProxy(O.$xM.MainThreadAuthentication)}async getSession(u,w,m,n={}){const o=N.$Im.toKey(u.identifier),s=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const r=u.displayName||u.name;return this.a.$getSession(w,m,o,r,n)})}async getSessions(u,w,m){const n=N.$Im.toKey(u.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${n} ${o}`,async()=>{await this.a.$ensureProvider(w);const s=u.displayName||u.name;return this.a.$getSessions(w,m,n,s)})}async removeSession(u,w){const m=this.b.get(u);return m?m.provider.removeSession(w):this.a.$removeSession(u,w)}registerAuthenticationProvider(u,w,m,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:w,provider:m,options:n??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,w,n?.supportsMultipleAccounts??!1),new R.$zM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,w,m){const n=this.b.get(u);if(n)return Promise.resolve(n.provider.createSession(w,m));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,w){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,w){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,w){return u.startsWith(M.$zL)||this.c.fire({provider:{id:u,label:w}}),Promise.resolve()}};e.$0jc=E,e.$0jc=E=Je([We(0,f.$UO)],E);class T{constructor(){this.a=new Map}getOrCreate(u,w){const m=this.a.get(u);if(m)return m;const n=w().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Pe[110],Re([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$0kc=void 0;let w=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(O.$xM.MainThreadDecorations)}registerFileDecorationProvider(n,o){const s=u.c++;this.f.set(s,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,f.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,E.$6e)(c.path,"/")})),t=(0,f.$zb)(h,(c,$)=>c.rank-$.rank||(0,E.$jf)(c.uri.path,$.uri.path)),v=[];e:for(const c of t){let $;for(const b of c){const p=(0,T.$nc)(b.uri.path);if($!==p&&($=p,v.push(b.uri)>=u.d))break e}}this.g.$onDidChange(s,v)});return new R.$zM(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(n,o,s){if(!this.f.has(n))return Object.create(null);const r=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:t,id:v}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{R.$YN.validate(c),c.badge&&typeof c.badge!="string"&&(0,y.$hG)(a,"codiconDecoration"),r[v]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),r}};e.$0kc=w,e.$0kc=w=u=Je([We(0,M.$UO),We(1,d.$Tj)],w),e.$$kc=(0,N.$ni)("IExtHostDecorations")}),define(Pe[247],Re([1,0,14,2,7,4,12,24,15]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class E{static{this.a=0}constructor(y,u,w){this.d=u,this.e=w,this.b=new Map,this.c=y.getProxy(N.$xM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const w=E.a++;this.b.set(w,u),this.c.$registerTextContentProvider(w,y);let m;if(typeof u.onDidChange=="function"){let n;m=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const s=this.$provideTextDocumentContent(w,o).then(async r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,f.$df)(r);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,r)}).catch(I.$1).finally(()=>{n===s&&(n=void 0)});n=s})}return new R.$zM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,u){const w=this.b.get(y);return w?Promise.resolve(w.provideTextDocumentContent(O.URI.revive(u),d.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$alc=E}),define(Pe[111],Re([1,0,56,12,15,302,152,7,18]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=void 0,e.$WO=T;const E=new Map;function T(m,n){n?E.set(m,n):E.delete(m)}function y(m){return E.get(m)}class u extends N.$Mv{constructor(n,o,s,r,i,a,h){super(o,s,r,i),this.c=n,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,f.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===O.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?d.EndOfLine.LF:d.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,s){return n.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,I.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,I.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,r=o.start.line,i=o.end.line,a=[];a.push(this.f[r].substring(o.start.character));for(let h=r+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(n){let o;if(n instanceof d.$AM?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),s=this.f[o.index].length;return new d.$AM(o.index,Math.min(o.remainder,s))}w(n){if(!(n instanceof d.$BM))throw new Error("Invalid argument");const o=this.x(n.start),s=this.x(n.end);return o===n.start&&s===n.end?n:new d.$BM(o.line,o.character,s.line,s.character)}x(n){if(!(n instanceof d.$AM))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:s}=n,r=!1;if(o<0)o=0,s=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,r=!0;else{const i=this.f[o].length;s<0?(s=0,r=!0):s>i&&(s=i,r=!0)}return r?new d.$AM(o,s):n}y(n,o){const s=this.x(n);if(!o)o=y(this.m);else if((0,R.$cf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,M.$Ws)(s.character+1,(0,M.$Us)(o),this.f[s.line],0);if(r)return new d.$BM(s.line,r.startColumn-1,s.line,r.endColumn-1)}}e.$XO=u;class w{constructor(n,o,s){this.a=n,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new d.$BM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new d.$BM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YO=w}),define(Pe[248],Re([1,0,4,7]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$xM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,d,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(d,f);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,d,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiEmbeddingVectorProvider(d,E),new O.$zM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$clc=R}),define(Pe[64],Re([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0;let m=w=class{constructor(o,s){this.b=new Map,this.c=new T.$wh,this.a=o.getProxy(I.$xM.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(i){try{let a;const h=r.b.get(i.scheme);return h?(await r.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await r.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===O.FilePermission.Readonly?1:void 0}}catch(a){w.e(a)}},async readDirectory(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await r.a.$readdir(i)}catch(a){return w.e(a)}},async createDirectory(i){try{const a=r.b.get(i.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(a.impl,a.extUri,i)):await r.a.$mkdir(i)}catch(a){return w.e(a)}},async readFile(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await r.a.$readFile(i)).buffer}catch(a){return w.e(a)}},async writeFile(i,a){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(i)),await r.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(i,N.$ze.wrap(a))}catch(h){return w.e(h)}},async delete(i,a){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await r.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await r.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return w.e(h)}},async rename(i,a,h){try{return await r.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(i,a,h){try{return await r.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,r){const i=[];for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&O.FileType.Directory))throw R.$PN.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(O.$0k(a)!==O.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(r)),r=s.dirname(r)}for(let a=i.length-1;a>=0;a--){r=s.joinPath(r,i[a]);try{await o.createDirectory(r)}catch(h){if(O.$0k(h)!==O.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$PN)throw o;if(o instanceof O.$6k)switch(o.code){case O.FileSystemProviderErrorCode.FileExists:throw R.$PN.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$PN.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$PN.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$PN.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$PN.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$PN.Unavailable(o.message);default:throw new R.$PN(o.message,o.name)}if(!(o instanceof Error))throw new R.$PN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$PN.Unavailable(o.message);switch(o.name){case O.FileSystemProviderErrorCode.FileExists:throw R.$PN.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$PN.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$PN.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$PN.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$PN.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$PN.Unavailable(o.message);default:throw new R.$PN(o.message,o.name)}}addFileSystemProvider(o,s,r){return this.b.set(o,{impl:s,extUri:r?.isCaseSensitive?y.$Qg:y.$Sg,isReadonly:!!r?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Qg}};e.$pkc=m,e.$pkc=m=w=Je([We(0,d.$UO),We(1,f.$3jc)],m),e.$qkc=(0,M.$ni)("IExtHostConsumerFileSystem")}),define(Pe[85],Re([1,0,3,27,13,64,2]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0,e.$rkc=(0,I.$ni)("IExtensionStoragePaths");let d=class{constructor(E,T,y){this.d=T,this.f=y,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$skc=d,e.$skc=d=Je([We(0,O.$$O),We(1,R.$Tj),We(2,N.$qkc)],d)}),define(Pe[249],Re([1,0,7,16,5]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;let N=class{constructor(d){this.a=new I.$ZN(I.ColorThemeKind.Dark),this.b=new R.$_d}get activeColorTheme(){return this.a}$onColorThemeChange(d){let f;switch(d){case"light":f=I.ColorThemeKind.Light;break;case"hcDark":f=I.ColorThemeKind.HighContrast;break;case"hcLight":f=I.ColorThemeKind.HighContrastLight;break;default:f=I.ColorThemeKind.Dark}this.a=new I.$ZN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Vlc=N,e.$Vlc=N=Je([We(0,O.$UO)],N)}),define(Pe[86],Re([1,0,24,5,6,174,3,13,203,4,27,16,7]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fCb=e.$eCb=e.TunnelDtoConverter=void 0;class w extends f.$_v{}var m;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function r(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==f.TunnelPrivacyId.ConstantPrivate&&i.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=r})(m||(e.TunnelDtoConverter=m={})),e.$eCb=(0,M.$ni)("IExtHostTunnelService");let n=class extends R.$Uc{constructor(s,r,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$_d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$xM.MainThreadTunnelService)}async openTunnel(s,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const i=await this.a.$openTunnel(r,s.displayName);if(i){const a=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,r){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:r}),this.a.$registerPortsAttributesProvider(s,i),new u.$zM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,r,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(r.map(async b=>{let p;try{p=await $.provider.providePortAttributes({port:b,pid:i,commandLine:a},h)}catch{p=await $.provider.providePortAttributes(b,i,a,h)}return{providedAttributes:p,port:b}})))}const v=t.filter(c=>!!c.providedAttributes);return v.length>0?v.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,r){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(r?this.w(r):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,r){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(r&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),m.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const r=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$fCb=n,e.$fCb=n=Je([We(0,y.$UO),We(1,T.$$O),We(2,d.$Tj)],n)}),define(Pe[8],Re([1,0,18,22,132,250,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,212,83,50,61,223,25,7]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v,c,$,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$RO=K,e.$SO=fe,e.$TO=Se;var l;(function(be){function Me(J){const{selectionStartLineNumber:ye,selectionStartColumn:Ve,positionLineNumber:Ze,positionColumn:Ge}=J,nt=new p.$AM(ye-1,Ve-1),wt=new p.$AM(Ze-1,Ge-1);return new p.$CM(nt,wt)}be.to=Me;function ae(J){const{anchor:ye,active:Ve}=J;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}be.from=ae})(l||(e.Selection=l={}));var D;(function(be){function Me(J){if(!J)return;const{start:ye,end:Ve}=J;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}be.from=Me;function ae(J){if(!J)return;const{startLineNumber:ye,startColumn:Ve,endLineNumber:Ze,endColumn:Ge}=J;return new p.$BM(ye-1,Ve-1,Ze-1,Ge-1)}be.to=ae})(D||(e.Range=D={}));var g;(function(be){function Me(J){return{uri:J.uri,range:D.from(J.range)}}be.from=Me;function ae(J){return new p.$LM(n.URI.revive(J.uri),D.to(J.range))}be.to=ae})(g||(e.Location=g={}));var S;(function(be){function Me(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}be.to=Me})(S||(e.TokenType=S={}));var k;(function(be){function Me(J){return new p.$AM(J.lineNumber-1,J.column-1)}be.to=Me;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}be.from=ae})(k||(e.Position=k={}));var P;(function(be){function Me(ye,Ve,Ze){return(0,I.$Hb)((0,I.$3b)(ye).map(Ge=>ae(Ge,Ve,Ze)))}be.from=Me;function ae(ye,Ve,Ze){if(typeof ye=="string")return{$serialized:!0,language:ye,isBuiltin:Ze?.isBuiltin};if(ye)return{$serialized:!0,language:ye.language,scheme:J(ye.scheme,Ve),pattern:me.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ye,Ve){return Ve&&typeof ye=="string"?Ve.transformOutgoingScheme(ye):ye}})(P||(e.DocumentSelector=P={}));var C;(function(be){function Me(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}be.from=Me;function ae(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}be.to=ae})(C||(e.DiagnosticTag=C={}));var W;(function(be){function Me(J){let ye;return J.code&&((0,m.$1f)(J.code)||(0,m.$5f)(J.code)?ye=String(J.code):ye={value:String(J.code.value),target:J.code.target}),{...D.from(J.range),message:J.message,source:J.source,code:ye,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(C.from)):void 0}}be.from=Me;function ae(J){const ye=new p.$NM(D.to(J),J.message,q.to(J.severity));return ye.source=J.source,ye.code=(0,m.$1f)(J.code)?J.code:J.code?.value,ye.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),ye.tags=J.tags&&(0,I.$Hb)(J.tags.map(C.to)),ye}be.to=ae})(W||(e.Diagnostic=W={}));var V;(function(be){function Me(J){return{...D.from(J.location.range),message:J.message,resource:J.location.uri}}be.from=Me;function ae(J){return new p.$MM(new p.$LM(J.resource,D.to(J)),J.message)}be.to=ae})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(be){function Me(J){switch(J){case p.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}be.from=Me;function ae(J){switch(J){case r.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}be.to=ae})(q||(e.DiagnosticSeverity=q={}));var A;(function(be){function Me(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?$.$LD:$.$KD}be.from=Me;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(A||(e.ViewColumn=A={}));function U(be){return typeof be.range<"u"}function K(be){return be.length===0?!0:!!U(be[0])}var ie;(function(be){function Me(Ge){return Ge.map(be.from)}be.fromMany=Me;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let nt;if(ae(Ge)){const{language:Mt,value:ut}=Ge;nt={value:"```"+Mt+`
`+ut+"\n```\n"}}else p.$1M.isMarkdownString(Ge)?nt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?nt={value:Ge}:nt={value:""};const wt=Object.create(null);nt.uris=wt;const Gt=Mt=>{try{let ut=n.URI.parse(Mt,!0);ut=ut.with({query:ye(ut.query,wt)}),wt[Mt]=ut}catch{}return""},xt=new f.marked.Renderer;return xt.link=Gt,xt.image=Mt=>typeof Mt=="string"?Gt(M.$Sk(Mt).href):"",(0,f.marked)(nt.value,{renderer:xt}),nt}be.from=J;function ye(Ge,nt){if(!Ge)return Ge;let wt;try{wt=(0,E.$Vh)(Ge)}catch{}if(!wt)return Ge;let Gt=!1;return wt=(0,y.$Vn)(wt,xt=>{if(n.URI.isUri(xt)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[Mt]=xt,Gt=!0,Mt}else return}),Gt?JSON.stringify(wt):Ge}function Ve(Ge){const nt=new p.$1M(Ge.value,Ge.supportThemeIcons);return nt.isTrusted=Ge.isTrusted,nt.supportHtml=Ge.supportHtml,nt.baseUri=Ge.baseUri?n.URI.from(Ge.baseUri):void 0,nt}be.to=Ve;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:be.from(Ge)}be.fromStrict=Ze})(ie||(e.MarkdownString=ie={}));function fe(be){return K(be)?be.map(Me=>({range:D.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ie.fromMany(Me.hoverMessage):Me.hoverMessage?ie.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):be.map(Me=>({range:D.from(Me)}))}function Se(be){return typeof be>"u"?be:typeof be=="string"?n.URI.file(be):be}var ke;(function(be){function Me(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?Se(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Me})(ke||(e.ThemableDecorationAttachmentRenderOptions=ke={}));var oe;(function(be){function Me(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?Se(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ke.from(ae.before):void 0,after:ae.after?ke.from(ae.after):void 0}}be.from=Me})(oe||(e.ThemableDecorationRenderOptions=oe={}));var $e;(function(be){function Me(ae){if(typeof ae>"u")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Me})($e||(e.DecorationRangeBehavior=$e={}));var ne;(function(be){function Me(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?$e.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?oe.from(ae.light):void 0,dark:ae.dark?oe.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?Se(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ke.from(ae.before):void 0,after:ae.after?ke.from(ae.after):void 0}}be.from=Me})(ne||(e.DecorationRenderOptions=ne={}));var Ie;(function(be){function Me(J){return{text:J.newText,eol:J.newEol&&ft.from(J.newEol),range:D.from(J.range)}}be.from=Me;function ae(J){const ye=new p.$GM(D.to(J.range),J.text);return ye.newEol=typeof J.eol>"u"?void 0:ft.to(J.eol),ye}be.to=ae})(Ie||(e.TextEdit=Ie={}));var ze;(function(be){function Me(J,ye){const Ve={edits:[]};if(J instanceof p.$JM){const Ze=new d.$Cc;for(const Ge of J._allEntries())Ge._type===1&&n.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===1){let nt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?nt={type:"base64",value:(0,O.$Te)(O.$ze.wrap(Ge.options.contents))}:nt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:nt},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:Ie.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:ye?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:D.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:ye?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:ye?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Jt.from)}})}return Ve}be.from=Me;function ae(J){const ye=new p.$JM,Ve=new d.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const Ge=Ze,nt=n.URI.revive(Ge.resource),wt=D.to(Ge.textEdit.range),Gt=Ge.textEdit.text,xt=Ge.textEdit.insertAsSnippet;let Mt;xt?Mt=p.$IM.replace(wt,new p.$KM(Gt)):Mt=p.$GM.replace(wt,Gt);const ut=Ve.get(nt);ut?ut.push(Mt):Ve.set(nt,[Mt])}else ye.renameFile(n.URI.revive(Ze.oldResource),n.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of Ve)ye.set(Ze,Ge);return ye}be.to=ae})(ze||(e.WorkspaceEdit=ze={}));var re;(function(be){const Me=Object.create(null);Me[p.SymbolKind.File]=0,Me[p.SymbolKind.Module]=1,Me[p.SymbolKind.Namespace]=2,Me[p.SymbolKind.Package]=3,Me[p.SymbolKind.Class]=4,Me[p.SymbolKind.Method]=5,Me[p.SymbolKind.Property]=6,Me[p.SymbolKind.Field]=7,Me[p.SymbolKind.Constructor]=8,Me[p.SymbolKind.Enum]=9,Me[p.SymbolKind.Interface]=10,Me[p.SymbolKind.Function]=11,Me[p.SymbolKind.Variable]=12,Me[p.SymbolKind.Constant]=13,Me[p.SymbolKind.String]=14,Me[p.SymbolKind.Number]=15,Me[p.SymbolKind.Boolean]=16,Me[p.SymbolKind.Array]=17,Me[p.SymbolKind.Object]=18,Me[p.SymbolKind.Key]=19,Me[p.SymbolKind.Null]=20,Me[p.SymbolKind.EnumMember]=21,Me[p.SymbolKind.Struct]=22,Me[p.SymbolKind.Event]=23,Me[p.SymbolKind.Operator]=24,Me[p.SymbolKind.TypeParameter]=25;function ae(ye){return typeof Me[ye]=="number"?Me[ye]:6}be.from=ae;function J(ye){for(const Ve in Me)if(Me[Ve]===ye)return Number(Ve);return p.SymbolKind.Property}be.to=J})(re||(e.SymbolKind=re={}));var L;(function(be){function Me(J){switch(J){case p.SymbolTag.Deprecated:return 1}}be.from=Me;function ae(J){switch(J){case 1:return p.SymbolTag.Deprecated}}be.to=ae})(L||(e.SymbolTag=L={}));var _;(function(be){function Me(J){return{name:J.name,kind:re.from(J.kind),tags:J.tags&&J.tags.map(L.from),containerName:J.containerName,location:de.from(J.location)}}be.from=Me;function ae(J){const ye=new p.$RM(J.name,re.to(J.kind),J.containerName,de.to(J.location));return ye.tags=J.tags&&J.tags.map(L.to),ye}be.to=ae})(_||(e.WorkspaceSymbol=_={}));var ve;(function(be){function Me(J){const ye={name:J.name||"!!MISSING: name!!",detail:J.detail,range:D.from(J.range),selectionRange:D.from(J.selectionRange),kind:re.from(J.kind),tags:J.tags?.map(L.from)??[]};return J.children&&(ye.children=J.children.map(Me)),ye}be.from=Me;function ae(J){const ye=new p.$SM(J.name,J.detail,re.to(J.kind),D.to(J.range),D.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ye.tags=J.tags.map(L.to)),J.children&&(ye.children=J.children.map(ae)),ye}be.to=ae})(ve||(e.DocumentSymbol=ve={}));var Te;(function(be){function Me(J){const ye=new p.$WM(re.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}be.to=Me;function ae(J,ye,Ve){if(ye=ye??J._sessionId,Ve=Ve??J._itemId,ye===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Ve,name:J.name,detail:J.detail,kind:re.from(J.kind),uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(L.from)}}be.from=ae})(Te||(e.CallHierarchyItem=Te={}));var Ee;(function(be){function Me(ae){return new p.$XM(Te.to(ae.from),ae.fromRanges.map(J=>D.to(J)))}be.to=Me})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var pe;(function(be){function Me(ae){return new p.$YM(Te.to(ae.to),ae.fromRanges.map(J=>D.to(J)))}be.to=Me})(pe||(e.CallHierarchyOutgoingCall=pe={}));var de;(function(be){function Me(J){return{range:J.range&&D.from(J.range),uri:J.uri}}be.from=Me;function ae(J){return new p.$LM(n.URI.revive(J.uri),D.to(J.range))}be.to=ae})(de||(e.location=de={}));var Q;(function(be){function Me(J){const ye=J,Ve=J;return{originSelectionRange:ye.originSelectionRange?D.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Ve.uri,range:D.from(ye.targetRange?ye.targetRange:Ve.range),targetSelectionRange:ye.targetSelectionRange?D.from(ye.targetSelectionRange):void 0}}be.from=Me;function ae(J){return{targetUri:n.URI.revive(J.uri),targetRange:D.to(J.range),targetSelectionRange:J.targetSelectionRange?D.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?D.to(J.originSelectionRange):void 0}}be.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(be){function Me(J){return{range:D.from(J.range),contents:ie.fromMany(J.contents)}}be.from=Me;function ae(J){return new p.$OM(J.contents.map(ie.to),D.to(J.range))}be.to=ae})(Y||(e.Hover=Y={}));var ue;(function(be){function Me(J){return{range:D.from(J.range),expression:J.expression}}be.from=Me;function ae(J){return new p.$JN(D.to(J.range),J.expression)}be.to=ae})(ue||(e.EvaluatableExpression=ue={}));var he;(function(be){function Me(J){if(J instanceof p.$KN)return{type:"text",range:D.from(J.range),text:J.text};if(J instanceof p.$LN)return{type:"variable",range:D.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$MN)return{type:"expression",range:D.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Me;function ae(J){switch(J.type){case"text":return{range:D.to(J.range),text:J.text};case"variable":return{range:D.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:D.to(J.range),expression:J.expression}}}be.to=ae})(he||(e.InlineValue=he={}));var Ne;(function(be){function Me(J){return{frameId:J.frameId,stoppedLocation:D.from(J.stoppedLocation)}}be.from=Me;function ae(J){return new p.$NN(J.frameId,D.to(J.stoppedLocation))}be.to=ae})(Ne||(e.InlineValueContext=Ne={}));var le;(function(be){function Me(J){return{range:D.from(J.range),kind:J.kind}}be.from=Me;function ae(J){return new p.$PM(D.to(J.range),J.kind)}be.to=ae})(le||(e.DocumentHighlight=le={}));var Ce;(function(be){function Me(J){return{uri:J.uri,highlights:J.highlights.map(le.from)}}be.from=Me;function ae(J){return new p.$QM(n.URI.revive(J.uri),J.highlights.map(le.to))}be.to=ae})(Ce||(e.MultiDocumentHighlight=Ce={}));var Ae;(function(be){function Me(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}be.to=Me})(Ae||(e.CompletionTriggerKind=Ae={}));var Ue;(function(be){function Me(ae){return{triggerKind:Ae.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Me})(Ue||(e.CompletionContext=Ue={}));var j;(function(be){function Me(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}be.from=Me;function ae(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}be.to=ae})(j||(e.CompletionItemTag=j={}));var z;(function(be){const Me=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(Ve){return Me.get(Ve)??9}be.from=ae;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function ye(Ve){return J.get(Ve)??p.CompletionItemKind.Property}be.to=ye})(z||(e.CompletionItemKind=z={}));var G;(function(be){function Me(ae,J){const ye=new p.$7M(ae.label);return ye.insertText=ae.insertText,ye.kind=z.to(ae.kind),ye.tags=ae.tags?.map(j.to),ye.detail=ae.detail,ye.documentation=M.$Mk(ae.documentation)?ie.to(ae.documentation):ae.documentation,ye.sortText=ae.sortText,ye.filterText=ae.filterText,ye.preselect=ae.preselect,ye.commitCharacters=ae.commitCharacters,o.$ht.isIRange(ae.range)?ye.range=D.to(ae.range):typeof ae.range=="object"&&(ye.range={inserting:D.to(ae.range.insert),replacing:D.to(ae.range.replace)}),ye.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?ye.insertText=new p.$KM(ae.insertText):(ye.insertText=ae.insertText,ye.textEdit=ye.range instanceof p.$BM?new p.$GM(ye.range,ye.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ye.additionalTextEdits=ae.additionalTextEdits.map(Ve=>Ie.to(Ve))),ye.command=J&&ae.command?J.fromInternal(ae.command):void 0,ye}be.to=Me})(G||(e.CompletionItem=G={}));var H;(function(be){function Me(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}be.from=Me;function ae(J){return{label:J.label,documentation:M.$Mk(J.documentation)?ie.to(J.documentation):J.documentation}}be.to=ae})(H||(e.ParameterInformation=H={}));var ee;(function(be){function Me(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}be.from=Me;function ae(J){return{label:J.label,documentation:M.$Mk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}be.to=ae})(ee||(e.SignatureInformation=ee={}));var se;(function(be){function Me(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}be.from=Me;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}be.to=ae})(se||(e.SignatureHelp=se={}));var Oe;(function(be){function Me(ae,J){const ye=new p.$6M(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&Qe.to(J.kind));return ye.textEdits=J.textEdits&&J.textEdits.map(Ie.to),ye.tooltip=M.$Mk(J.tooltip)?ie.to(J.tooltip):J.tooltip,ye.paddingLeft=J.paddingLeft,ye.paddingRight=J.paddingRight,ye}be.to=Me})(Oe||(e.InlayHint=Oe={}));var Be;(function(be){function Me(ae,J){const ye=new p.$5M(J.label);return ye.tooltip=M.$Mk(J.tooltip)?ie.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ye.command=ae.fromInternal(J.command)),J.location&&(ye.location=de.to(J.location)),ye}be.to=Me})(Be||(e.InlayHintLabelPart=Be={}));var Qe;(function(be){function Me(J){return J}be.from=Me;function ae(J){return J}be.to=ae})(Qe||(e.InlayHintKind=Qe={}));var Ye;(function(be){function Me(J){return{range:D.from(J.range),url:J.target,tooltip:J.tooltip}}be.from=Me;function ae(J){let ye;if(J.url)try{ye=typeof J.url=="string"?n.URI.parse(J.url,!0):n.URI.revive(J.url)}catch{}return new p.$_M(D.to(J.range),ye)}be.to=ae})(Ye||(e.DocumentLink=Ye={}));var et;(function(be){function Me(J){const ye=new p.$cN(J.label);return J.textEdit&&(ye.textEdit=Ie.to(J.textEdit)),J.additionalTextEdits&&(ye.additionalTextEdits=J.additionalTextEdits.map(Ve=>Ie.to(Ve))),ye}be.to=Me;function ae(J){return{label:J.label,textEdit:J.textEdit?Ie.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ye=>Ie.from(ye)):void 0}}be.from=ae})(et||(e.ColorPresentation=et={}));var at;(function(be){function Me(J){return new p.$aN(J[0],J[1],J[2],J[3])}be.to=Me;function ae(J){return[J.red,J.green,J.blue,J.alpha]}be.from=ae})(at||(e.Color=at={}));var it;(function(be){function Me(J){return{range:D.from(J.range)}}be.from=Me;function ae(J){return new p.$VM(D.to(J.range))}be.to=ae})(it||(e.SelectionRange=it={}));var tt;(function(be){function Me(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}be.to=Me})(tt||(e.TextDocumentSaveReason=tt={}));var ct;(function(be){function Me(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Me;function ae(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}be.to=ae})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(be){function Me(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}be.from=Me;function ae(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}be.to=ae})(ft||(e.EndOfLine=ft={}));var je;(function(be){function Me(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Me})(je||(e.ProgressLocation=je={}));var st;(function(be){function Me(J){const ye={start:J.start+1,end:J.end+1};return J.kind&&(ye.kind=X.from(J.kind)),ye}be.from=Me;function ae(J){const ye={start:J.start-1,end:J.end-1};return J.kind&&(ye.kind=X.to(J.kind)),ye}be.to=ae})(st||(e.FoldingRange=st={}));var X;(function(be){function Me(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return s.$3t.Comment;case p.FoldingRangeKind.Imports:return s.$3t.Imports;case p.FoldingRangeKind.Region:return s.$3t.Region}}be.from=Me;function ae(J){if(J)switch(J.value){case s.$3t.Comment.value:return p.FoldingRangeKind.Comment;case s.$3t.Imports.value:return p.FoldingRangeKind.Imports;case s.$3t.Region.value:return p.FoldingRangeKind.Region}}be.to=ae})(X||(e.FoldingRangeKind=X={}));var Z;(function(be){function Me(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?D.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.$bF.id:void 0}}be.from=Me})(Z||(e.TextEditorOpenOptions=Z={}));var me;(function(be){function Me(Ve){return Ve instanceof p.$xN?Ve.toJSON():typeof Ve=="string"?Ve:ae(Ve)||J(Ve)?new p.$xN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}be.from=Me;function ae(Ve){const Ze=Ve;return Ze?n.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ve){const Ze=Ve;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ye(Ve){return typeof Ve=="string"?Ve:new p.$xN(n.URI.revive(Ve.baseUri),Ve.pattern)}be.to=ye})(me||(e.GlobPattern=me={}));var qe;(function(be){function Me(ae){if(ae){if(Array.isArray(ae))return ae.map(Me);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}be.from=Me})(qe||(e.LanguageSelector=qe={}));var we;(function(be){function Me(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ye=>Array.isArray(ye)&&ye.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&n.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ze=>Ze instanceof p.$BM)))}be.is=Me;function ae(J){return{documents:J.documents.map(ye=>ye.map(Ve=>({uri:n.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ze=>D.from(Ze))})))}}be.from=ae})(we||(e.MappedEditsContext=we={}));var ot;(function(be){function Me(J){return{start:J.start,end:J.end}}be.from=Me;function ae(J){return new p.$1N(J.start,J.end)}be.to=ae})(ot||(e.NotebookRange=ot={}));var dt;(function(be){function Me(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}be.to=Me;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}be.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(be){function Me(ae){if(ae===t.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(ae===t.NotebookCellExecutionState.Pending)return;if(ae===t.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Me})(Ct||(e.NotebookCellExecutionState=Ct={}));var jt;(function(be){function Me(J){switch(J){case p.NotebookCellKind.Markup:return t.CellKind.Markup;case p.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=Me;function ae(J){switch(J){case t.CellKind.Markup:return p.NotebookCellKind.Markup;case t.CellKind.Code:default:return p.NotebookCellKind.Code}}be.to=ae})(jt||(e.NotebookCellKind=jt={}));var _t;(function(be){function Me(J){const ye={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)p.$2N.validate(Ve),ye.cells.push(Jt.from(Ve));return ye}be.from=Me;function ae(J){const ye=new p.$3N(J.cells.map(Jt.to));return(0,m.$bg)(J.metadata)||(ye.metadata=J.metadata),ye}be.to=ae})(_t||(e.NotebookData=_t={}));var Jt;(function(be){function Me(J){return{cellKind:jt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Dt.from):[]}}be.from=Me;function ae(J){return new p.$2N(jt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Dt.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}be.to=ae})(Jt||(e.NotebookCellData=Jt={}));var ei;(function(be){function Me(J){return{mime:J.mime,valueBytes:O.$ze.wrap(J.data)}}be.from=Me;function ae(J){return new p.$4N(J.valueBytes.buffer,J.mime)}be.to=ae})(ei||(e.NotebookCellOutputItem=ei={}));var Dt;(function(be){function Me(J){return{outputId:J.id,items:J.items.map(ei.from),metadata:J.metadata}}be.from=Me;function ae(J){const ye=J.items.map(ei.to);return new p.$5N(ye,J.outputId,J.metadata)}be.to=ae})(Dt||(e.NotebookCellOutput=Dt={}));var Wt;(function(be){function Me(ye){return J(ye)?{include:me.from(ye.include)??void 0,exclude:me.from(ye.exclude)??void 0}:me.from(ye)??void 0}be.from=Me;function ae(ye){return J(ye)?{include:me.to(ye.include),exclude:me.to(ye.exclude)}:me.to(ye)}be.to=ae;function J(ye){const Ve=ye;return Ve?!(0,m.$0f)(Ve.include)&&!(0,m.$0f)(Ve.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Qt;(function(be){function Me(ae,J,ye){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,ye),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Me})(Qt||(e.NotebookStatusBarItem=Qt={}));var Xe;(function(be){function Me(ae,J,ye){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(Ve,ye),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Me})(Xe||(e.NotebookKernelSourceAction=Xe={}));var ai;(function(be){function Me(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Me})(ai||(e.NotebookDocumentContentOptions=ai={}));var ti;(function(be){function Me(J){return{uri:J.uri,provides:J.provides}}be.from=Me;function ae(J){return new p.$7N(n.URI.revive(J.uri),J.provides)}be.to=ae})(ti||(e.NotebookRendererScript=ti={}));var ii;(function(be){function Me(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:D.from(J.location.range),uri:J.location.uri}}}be.from=Me;function ae(J){const ye=new p.$aO(typeof J.message=="string"?J.message:ie.to(J.message));return ye.actualOutput=J.actual,ye.expectedOutput=J.expected,ye.contextValue=J.contextValue,ye.location=J.location?de.to(J.location):void 0,ye}be.to=ae})(ii||(e.TestMessage=ii={}));var lt;(function(be){be.namespace=c.$oL,be.denamespace=c.$pL})(lt||(e.TestTag=lt={}));var vt;(function(be){function Me(J){const ye=(0,i.$QO)(J).controllerId;return{extId:v.$jL.fromExtHostTestItem(J,ye).toString(),label:J.label,uri:n.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>lt.namespace(ye,Ve.id)),range:o.$ht.lift(D.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}be.from=Me;function ae(J){return{parent:void 0,error:void 0,id:v.$jL.fromString(J.extId).localId,label:J.label,uri:n.URI.revive(J.uri),tags:(J.tags||[]).map(ye=>{const{tagId:Ve}=lt.denamespace(ye);return new p.$bO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}be.toPlain=ae})(vt||(e.TestItem=vt={})),function(be){function Me(J){return{id:J.id}}be.from=Me;function ae(J){return new p.$bO(J.id)}be.to=ae}(lt||(e.TestTag=lt={}));var si;(function(be){const Me=(J,ye)=>{const Ve=J.value;if(!Ve)return;const Ze={...vt.toPlain(Ve.item),parent:ye,taskStates:Ve.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(nt=>nt.type===0).map(ii.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const nt=Me(Ge,Ze);nt&&Ze.children.push(nt)}return Ze};function ae(J){const ye=new u.$JO;for(const Ge of J.items)ye.insert(v.$jL.fromString(Ge.item.extId).path,Ge);const Ve=[ye.nodes],Ze=[];for(;Ve.length;)for(const Ge of Ve.pop())Ge.value?Ze.push(Ge):Ge.children&&Ve.push(Ge.children.values());return{completedAt:J.completedAt,results:Ze.map(Ge=>Me(Ge)).filter(m.$9f)}}be.to=ae})(si||(e.TestResults=si={}));var ni;(function(be){function Me(Ve){return{covered:Ve.covered,total:Ve.total}}function ae(Ve){return"line"in Ve?k.from(Ve):D.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ae(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ae(Ve.location)}}be.fromDetails=J;function ye(Ve,Ze){return p.$dO(Ze.statementCoverage),p.$dO(Ze.branchCoverage),p.$dO(Ze.declarationCoverage),{id:Ve,uri:Ze.uri,statement:Me(Ze.statementCoverage),branch:Ze.branchCoverage&&Me(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Me(Ze.declarationCoverage)}}be.fromFile=ye})(ni||(e.TestCoverage=ni={}));var Tt;(function(be){function Me(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}be.to=Me})(Tt||(e.CodeActionTriggerKind=Tt={}));var mt;(function(be){function Me(J){const ye=new p.$iO(re.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}be.to=Me;function ae(J,ye,Ve){if(ye=ye??J._sessionId,Ve=Ve??J._itemId,ye===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Ve,kind:re.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(L.from)}}be.from=ae})(mt||(e.TypeHierarchyItem=mt={}));var Rt;(function(be){function Me(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Me})(Rt||(e.ViewBadge=Rt={}));var qt;(function(be){function Me(Ve,Ze,Ge){const nt=Ze.fileData;return nt?new p.$pN(new p.$qN(nt.name,n.URI.revive(nt.uri),nt.id,(0,N.$db)(()=>Ge(nt.id)))):Ve===T.$Es.uriList&&Ze.uriListData?new p.$oN(ye(Ze.uriListData)):new p.$oN(Ze.asString)}be.to=Me;async function ae(Ve,Ze){const Ge=await Ze.asString();if(Ve===T.$Es.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const nt=Ze.asFile();return{asString:Ge,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}be.from=ae;function J(Ve){return R.$Ht.split(Ve).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return n.URI.parse(Ze)}catch{}return Ze})}function ye(Ve){return R.$Ht.create(Ve.map(Ze=>typeof Ze=="string"?Ze:n.URI.revive(Ze)))}})(qt||(e.DataTransferItem=qt={}));var Zt;(function(be){function Me(J,ye){const Ve=J.items.map(([Ze,Ge])=>[Ze,qt.to(Ze,Ge,ye)]);return new p.$rN(Ve)}be.toDataTransfer=Me;async function ae(J){const ye={items:[]},Ve=[];for(const[Ze,Ge]of J)Ve.push((async()=>{ye.items.push([Ze,await qt.from(Ze,Ge)])})());return await Promise.all(Ve),ye}be.from=ae})(Zt||(e.DataTransfer=Zt={}));var He;(function(be){function Me(J,ye){return{kind:"reply",agentId:J.participant??ye?.agentId??"",subCommand:J.command??ye?.command,message:J.prompt,title:J.label}}be.from=Me;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}be.to=ae})(He||(e.ChatFollowup=He={}));var Xt;(function(be){function Me(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Me})(Xt||(e.ChatInlineFollowup=Xt={}));var Ut;(function(be){function Me(J){switch(J.role){case 0:return new p.$EO(J.content);case 1:return new p.$FO(J.content);case 2:return new p.$GO(J.content)}}be.to=Me;function ae(J){if(J instanceof p.$EO)return{role:0,content:J.content};if(J instanceof p.$FO)return{role:1,content:J.content};if(J instanceof p.$GO)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}be.from=ae})(Ut||(e.LanguageModelMessage=Ut={}));var Bt;(function(be){function Me(ye){const Ve={};for(const Ze of Object.keys(ye))Ve[Ze]=ye[Ze].map(be.to);return Ve}be.objectTo=Me;function ae(ye){return{level:$t.to(ye.level),kind:ye.kind,value:(0,n.$wc)(ye.value)?n.URI.revive(ye.value):ye.value,description:ye.description}}be.to=ae;function J(ye){return{level:$t.from(ye.level),kind:ye.kind,value:ye.value,description:ye.description}}be.from=J})(Bt||(e.ChatVariable=Bt={}));var $t;(function(be){function Me(J){switch(J){case"short":return p.ChatVariableLevel.Short;case"medium":return p.ChatVariableLevel.Medium;case"full":default:return p.ChatVariableLevel.Full}}be.to=Me;function ae(J){switch(J){case p.ChatVariableLevel.Short:return"short";case p.ChatVariableLevel.Medium:return"medium";case p.ChatVariableLevel.Full:default:return"full"}}be.from=ae})($t||(e.ChatVariableLevel=$t={}));var Ft;(function(be){function Me(ae){switch(ae){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Me})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var At;(function(be){function Me(J){return{kind:"markdownContent",content:ie.from(J.value)}}be.from=Me;function ae(J){return new p.$vO(ie.to(J.content))}be.to=ae})(At||(e.ChatResponseMarkdownPart=At={}));var Lt;(function(be){function Me(J){const{value:ye,baseUri:Ve}=J;function Ze(Ge,nt){return Ge.map(wt=>{const Gt=n.URI.joinPath(nt,wt.name);return{label:wt.name,uri:Gt,children:wt.children&&Ze(wt.children,Gt)}})}return{kind:"treeData",treeData:{label:(0,w.$Xg)(Ve),uri:Ve,children:Ze(ye,Ve)}}}be.from=Me;function ae(J){const ye=(0,E.$Wh)(J.treeData);function Ve(nt){return nt.map(wt=>({name:wt.label,children:wt.children&&Ve(wt.children)}))}const Ze=ye.uri,Ge=ye.children?Ve(ye.children):[];return new p.$wO(Ge,Ze)}be.to=ae})(Lt||(e.ChatResponseFilesPart=Lt={}));var ri;(function(be){function Me(J){return{kind:"inlineReference",name:J.title,inlineReference:n.URI.isUri(J.value)?J.value:g.from(J.value)}}be.from=Me;function ae(J){const ye=(0,E.$Wh)(J);return new p.$xO(n.URI.isUri(ye.inlineReference)?ye.inlineReference:g.to(ye.inlineReference),J.name)}be.to=ae})(ri||(e.ChatResponseAnchorPart=ri={}));var oi;(function(be){function Me(J){return{kind:"progressMessage",content:ie.from(J.value)}}be.from=Me;function ae(J){return new p.$yO(J.content.value)}be.to=ae})(oi||(e.ChatResponseProgressPart=oi={}));var Vt;(function(be){function Me(J,ye,Ve){return{kind:"command",command:ye.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}be.from=Me;function ae(J,ye){return new p.$zO(ye.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}be.to=ae})(Vt||(e.ChatResponseCommandButtonPart=Vt={}));var Pt;(function(be){function Me(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ye=>Ie.from(ye))}}be.from=Me;function ae(J){return new p.$BO(n.URI.revive(J.uri),J.edits.map(ye=>Ie.to(ye)))}be.to=ae})(Pt||(e.ChatResponseTextEditPart=Pt={}));var kt;(function(be){function Me(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:n.URI.isUri(J.value.value)||!J.value.value?J.value.value:g.from(J.value.value)}}:{kind:"reference",reference:n.URI.isUri(J.value)?J.value:g.from(J.value)}}be.from=Me;function ae(J){const ye=(0,E.$Wh)(J),Ve=Ze=>n.URI.isUri(Ze)?Ze:g.to(Ze);return new p.$AO("variableName"in ye.reference?{variableName:ye.reference.variableName,value:ye.reference.value&&Ve(ye.reference.value)}:Ve(ye.reference))}be.to=ae})(kt||(e.ChatResponseReferencePart=kt={}));var Yt;(function(be){function Me(ye,Ve,Ze){return ye instanceof p.$vO?At.from(ye):ye instanceof p.$xO?ri.from(ye):ye instanceof p.$AO?kt.from(ye):ye instanceof p.$yO?oi.from(ye):ye instanceof p.$wO?Lt.from(ye):ye instanceof p.$zO?Vt.from(ye,Ve,Ze):ye instanceof p.$BO?Pt.from(ye):{kind:"content",content:""}}be.from=Me;function ae(ye,Ve){switch(ye.kind){case"reference":return kt.to(ye);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ye,Ve)}}be.to=ae;function J(ye,Ve){switch(ye.kind){case"markdownContent":return At.to(ye);case"inlineReference":return ri.to(ye);case"progressMessage":return;case"treeData":return Lt.to(ye);case"command":return Vt.to(ye,Ve)}}be.toContent=J})(Yt||(e.ChatResponsePart=Yt={}));var St;(function(be){function Me(J,ye){return"markdownContent"in ye?((0,b.$hG)(J,"chatParticipantAdditions"),{content:ie.from(ye.markdownContent),kind:"markdownContent"}):"content"in ye?"vulnerabilities"in ye&&ye.vulnerabilities?((0,b.$hG)(J,"chatParticipantAdditions"),{content:ye.content,vulnerabilities:ye.vulnerabilities,kind:"vulnerability"}):typeof ye.content=="string"?{content:ye.content,kind:"content"}:((0,b.$hG)(J,"chatParticipantAdditions"),{content:ie.from(ye.content),kind:"markdownContent"}):"documents"in ye?{documents:ye.documents.map(Ve=>({uri:Ve.uri,version:Ve.version,ranges:Ve.ranges.map(Ze=>D.from(Ze))})),kind:"usedContext"}:"reference"in ye?{reference:"uri"in ye.reference?{uri:ye.reference.uri,range:D.from(ye.reference.range)}:ye.reference,kind:"reference"}:"inlineReference"in ye?{inlineReference:"uri"in ye.inlineReference?{uri:ye.inlineReference.uri,range:D.from(ye.inlineReference.range)}:ye.inlineReference,name:ye.title,kind:"inlineReference"}:"participant"in ye?((0,b.$hG)(J,"chatParticipantAdditions"),{agentId:ye.participant,command:ye.command,kind:"agentDetection"}):"message"in ye?{content:ie.from(ye.message),kind:"progressMessage"}:void 0}be.from=Me;function ae(J,ye){switch(J.kind){case"markdownContent":return{content:J.content.value};case"inlineReference":return{inlineReference:(0,n.$wc)(J.inlineReference)?n.URI.revive(J.inlineReference):g.to(J.inlineReference),title:J.name};case"command":return{command:ye.fromInternal(J.command)??{command:J.command.id,title:J.command.title}};default:return}}be.toProgressContent=ae})(St||(e.ChatResponseProgress=St={}));var yt;(function(be){function Me(ae){return{prompt:ae.message,command:ae.command,variables:ae.variables.variables.map(li.to),location:It.to(ae.location)}}be.to=Me})(yt||(e.ChatAgentRequest=yt={}));var It;(function(be){function Me(ae){switch(ae){case h.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}be.to=Me})(It||(e.ChatLocation=It={}));var li;(function(be){function Me(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(Bt.to)}}be.to=Me})(li||(e.ChatAgentResolvedVariable=li={}));var Et;(function(be){function Me(ae){return{label:ae.label,values:ae.values.map(Bt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Me})(Et||(e.ChatAgentCompletionItem=Et={}));var hi;(function(be){function Me(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}be.to=Me})(hi||(e.ChatAgentResult=hi={}));var zt;(function(be){function Me(ae,J,ye){if(J.action.kind==="vote")return;const Ve=hi.to(ae);return J.action.kind==="command"?{action:{kind:"command",commandButton:St.toProgressContent(J.action.commandButton,ye)},result:Ve}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:He.to(J.action.followup)},result:Ve}:{action:J.action,result:Ve}}be.to=Me})(zt||(e.ChatAgentUserActionEvent=zt={}));var vi;(function(be){function Me(ae,J,ye){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,ye)}be.from=Me})(vi||(e.TerminalQuickFix=vi={}));var Ht;(function(be){function Me(ae){return{kind:gi.to(ae.kind)}}be.to=Me})(Ht||(e.PartialAcceptInfo=Ht={}));var gi;(function(be){function Me(ae){switch(ae){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}be.to=Me})(gi||(e.PartialAcceptTriggerKind=gi={}));var Ot;(function(be){function Me(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}be.from=Me})(Ot||(e.DebugTreeItem=Ot={}))}),define(Pe[251],Re([1,0,4,16,8,34]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;let M=class{constructor(f,E){this.a=f.getProxy(I.$xM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(f,E,T){const y=new N.$jw(R.WorkspaceEdit.from(f,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,T?.isRefactoring??!1)}};e.$$jc=M,e.$$jc=M=Je([We(0,O.$UO)],M)}),define(Pe[252],Re([1,0,18,11,42,5,46,6,65,17,2,163,20,4,8,7,213,25]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;class r{constructor(t,v,c,$,b,p){this.i=t,this.j=v,this.k=c,this.l=$,this.m=b,this.n=p,this.b=f.$8d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let v=function($){if(t.c){const b=new Error("Response stream has been closed");throw Error.captureStackTrace(b,$),b}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){v(this.markdown);const b=new n.$vO($),p=m.ChatResponseMarkdownPart.from(b);return c(p),this},filetree($,b){v(this.filetree);const p=new n.$wO($,b),l=m.ChatResponseFilesPart.from(p);return c(l),this},anchor($,b){v(this.anchor);const p=new n.$xO($,b),l=m.ChatResponseAnchorPart.from(p);return c(l),this},button($){v(this.anchor);const b=new n.$zO($),p=m.ChatResponseCommandButtonPart.from(b,t.m,t.n);return c(p),this},progress($){v(this.progress);const b=new n.$yO($),p=m.ChatResponseProgressPart.from(b);return c(p),this},reference($){if(v(this.reference),"variableName"in $&&!$.value){const b=t.j.variables.variables.find(p=>p.name===$.variableName);if(b){let p;if(b.references?.length)p=b.references.map(l=>({kind:"reference",reference:{variableName:$.variableName,value:l.reference}}));else{const l=new n.$AO($);p=[m.ChatResponseReferencePart.from(l)]}return p.forEach(l=>c(l)),this}}else{const b=new n.$AO($),p=m.ChatResponseReferencePart.from(b);c(p)}return this},textEdit($,b){v(this.textEdit),(0,s.$hG)(t.i,"chatParticipantAdditions");const p=new n.$BO($,b),l=m.ChatResponseTextEditPart.from(p);return c(l),this},push($){if(v(this.push),$ instanceof n.$BO&&(0,s.$hG)(t.i,"chatParticipantAdditions"),$ instanceof n.$AO)this.reference($.value);else{const b=m.ChatResponsePart.from($,t.m,t.n);c(b)}return this},report($){if(v(this.report),"placeholder"in $&&"resolvedContent"in $)return;const b=m.ChatResponseProgress.from(t.i,$);if(!b){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(b),this}}}return this.g}}class i{static{this.b=0}constructor(t,v,c){this.i=v,this.j=c,this.c=new Map,this.g=new d.$4c,this.d=t.getProxy(w.$xM.MainThreadChatAgents2)}createChatAgent(t,v,c){const $=i.b++,b=new a(t,v,this.d,$,c);return this.c.set($,b),this.d.$registerAgent($,t.identifier,v,{},void 0),b.apiAgent}createDynamicChatAgent(t,v,c,$,b){const p=i.b++,l=new a(t,v,this.d,p,b);return this.c.set(p,l),this.d.$registerAgent(p,t.identifier,v,{},{name:c,description:$}),l.apiAgent}async $invokeAgent(t,v,c,$){const b=this.c.get(t);if(!b)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.g.get(v.sessionId);p||(p=new d.$Tc,this.g.set(v.sessionId,p));const l=new r(b.extension,v,this.d,this.i,this.j.converter,p);try{const D=await this.k(v.agentId,c),g=b.invoke(m.ChatAgentRequest.to(v),{history:D},l.apiObject,$);return await(0,O.$bh)(Promise.resolve(g).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(k){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${b.extension.identifier.value}] [@${b.id}] ${P}`,b.extension),{errorDetails:{message:P},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,b.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,R.$$i)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,v){const c=[];for(const $ of v.history){const b=m.ChatAgentResult.to($.result),p=t===$.request.agentId?b:{...b,metadata:void 0};c.push(new n.$CO($.request.message,$.request.command,$.request.variables.variables.map(m.ChatAgentResolvedVariable.to),$.request.agentId));const l=(0,I.$Hb)($.response.map(D=>m.ChatResponsePart.toContent(D,this.j.converter)));c.push(new n.$DO(l,p,$.request.agentId,$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,v,c,$,b){const p=this.c.get(v);if(!p)return Promise.resolve([]);const l=await this.k(p.id,$),D=m.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:l},b)).filter(g=>{const S=!g.participant||M.Iterable.some(this.c.values(),k=>k.id===g.participant&&u.$Im.equals(k.extension.identifier,p.extension.identifier));return S||this.i.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${g.participant}`),S}).map(g=>m.ChatFollowup.from(g,t))}$acceptFeedback(t,v,c,$){const b=this.c.get(t);if(!b)return;const p=m.ChatAgentResult.to(v);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=n.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=n.ChatResultFeedbackKind.Helpful;break}b.acceptFeedback(Object.freeze($?{result:p,kind:l,reportIssue:$}:{result:p,kind:l}))}$acceptAction(t,v,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const b=m.ChatAgentUserActionEvent.to(v,c,this.j.converter);b&&$.acceptAction(Object.freeze(b))}async $invokeCompletionProvider(t,v,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(v,c)).map(m.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,v){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(v)}async $provideSampleQuestions(t,v){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(v)).map($=>m.ChatFollowup.from($,void 0))}}e.$akc=i;class a{constructor(t,v,c,$,b){this.extension=t,this.id=v,this.u=c,this.w=$,this.x=b,this.n=new N.$_d,this.o=new N.$_d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,v){return this.q?await this.q.provider.provideCompletionItems(t,v)??[]:[]}async provideFollowups(t,v,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,v,c);return $?$.filter(b=>!(b&&"commandId"in b)).filter(b=>!(b&&"message"in b)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const v=await this.s.provideWelcomeMessage(t);return v?v.map(c=>typeof c=="string"?c:m.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const v=await this.s.provideSampleQuestions(t);return v||[]}get apiAgent(){let t=!1,v=!1;const c=()=>{t||v||(v=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof n.$vN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:m.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:m.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),v=!1}))},$=this;return{get id(){return $.id},get fullName(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.c??$.extension.displayName??$.extension.name},set fullName(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.c=b,c()},get iconPath(){return $.d},set iconPath(b){$.d=b,c()},get requestHandler(){return $.x},set requestHandler(b){(0,E.$$f)(typeof b=="function","Invalid request handler"),$.x=b},get followupProvider(){return $.b},set followupProvider(b){$.b=b,c()},get isDefault(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.g},set isDefault(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.g=b,c()},get helpTextPrefix(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.i},set helpTextPrefix(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.i=b,c()},get helpTextVariablesPrefix(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.j},set helpTextVariablesPrefix(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.j=b,c()},get helpTextPostfix(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.k},set helpTextPostfix(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.k=b,c()},get isSecondary(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.m},set isSecondary(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.m=b,c()},get sampleRequest(){return $.l},set sampleRequest(b){$.l=b,c()},get supportIssueReporting(){return(0,s.$hG)($.extension,"chatParticipantAdditions"),$.p},set supportIssueReporting(b){(0,s.$hG)($.extension,"chatParticipantAdditions"),$.p=b,c()},get onDidReceiveFeedback(){return $.n.event},set participantVariableProvider(b){if((0,s.$hG)($.extension,"chatParticipantAdditions"),$.q=b,b){if(!b.triggerCharacters.length)throw new Error("triggerCharacters are required");$.u.$registerAgentCompletionsProvider($.w,b.triggerCharacters)}else $.u.$unregisterAgentCompletionsProvider($.w)},get participantVariableProvider(){return(0,s.$hG)($.extension,"chatParticipantAdditions"),$.q},set welcomeMessageProvider(b){(0,s.$hG)($.extension,"defaultChatParticipant"),$.s=b,c()},get welcomeMessageProvider(){return(0,s.$hG)($.extension,"defaultChatParticipant"),$.s},onDidPerformAction:(0,s.$gG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(b){$.t=b,c()},get requester(){return $.t},dispose(){t=!0,$.b=void 0,$.n.dispose(),$.u.$unregisterAgent($.w)}}}invoke(t,v,c,$){return this.x(t,v,c,$)}}}),define(Pe[253],Re([1,0,14,6,4,8,7,25]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class f{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(R.$xM.MainThreadChatVariables)}async $resolveVariable(y,u,w,m){const n=this.b.get(y);if(n)try{if(n.resolver.resolve2){(0,d.$hG)(n.extension,"chatParticipantAdditions");const o=new E(u,this.c),s=await n.resolver.resolve2(n.data.name,{prompt:w},o.apiObject,m);if(s)return s.map(N.ChatVariable.from)}else{const o=await n.resolver.resolve(n.data.name,{prompt:w},m);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(y,u,w,m){const n=f.a++;return this.b.set(n,{extension:y,data:{name:u,description:w},resolver:m}),this.c.$registerVariable(n,{name:u,description:w}),(0,O.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}}e.$dkc=f;class E{constructor(y,u){this.c=y,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(m){if(y.a){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,m),n}};const y=this,w=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){u(this.progress);const n=new M.$yO(m),o=N.ChatResponseProgressPart.from(n);return w(o),this},reference(m){u(this.reference);const n=new M.$AO(m),o=N.ChatResponseReferencePart.from(n);return w(o),this},push(m){return u(this.push),m instanceof M.$AO?w(N.ChatResponseReferencePart.from(m)):m instanceof M.$yO&&w(N.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Pe[254],Re([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=w;function w(m,n,o){const s=m.getProxy(y.$xM.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$Km,n.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,g=this.b.get(D.commentControlHandle);if(!g)return D;const S=g.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);return g?l.$mid===8?g.value:{thread:g.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.commentUniqueId,k=g.getCommentByUniqueId(S);return k||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.text,k=l.commentUniqueId,P=g.getCommentByUniqueId(k);return P?(typeof P.body=="string"?P.body=S:P.body=new T.$1M(S),P):l}return l}})}createCommentController(l,D,g){const S=r.a++,k=new a(l,S,D,g);this.b.set(k.handle,k);const P=this.c.get(l.identifier)||[];return P.push(k),this.c.set(l.identifier,P),k.value}async $createCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,g)}async $setActiveComment(l,D){const g=this.b.get(l);g&&g.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,g)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,g){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const k=await o.ensureDocumentData(M.URI.revive(D));return(0,I.$fh)(async()=>{const P=await S.commentingRangeProvider.provideCommentingRanges(k.document,g);let C;return Array.isArray(P)?C={ranges:P,fileComments:!1}:P?C={ranges:P.ranges||[],fileComments:P.fileComments||!1}:C=P??void 0,C}).then(P=>{let C;return P&&(C={ranges:P.ranges.map(W=>E.Range.from(W)),fileComments:P.fileComments}),C})}$toggleReaction(l,D,g,S,k){const P=this.b.get(l);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,I.$fh)(()=>{const C=P.getCommentThread(D);if(C){const W=C.getCommentByUniqueId(S.uniqueIdInThread);if(P!==void 0&&W&&P.reactionHandler)return P.reactionHandler(W,v(k))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$hG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,g,S,k,P,C,W){this.m=D,this.n=g,this.o=S,this.p=k,this.q=P,this.extensionDescription=C,this.r=W,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$_d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const l=g=>Object.prototype.hasOwnProperty.call(this.b,g),D={};l("range")&&(D.range=E.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(g=>h(this,g,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=b(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const g=D[0],S=D[1];if(l===S)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,O.$Sh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$hG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$hG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$hG)(this.h,"activeComment"),this.f}constructor(l,D,g,S){this.h=l,this.i=D,this.j=g,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,g,S,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},get activeCommentThread(){return k.activeCommentThread},createCommentThread(P,C,W){return k.createCommentThread(P,C,W).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,g){D===void 0&&(0,u.$hG)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,g,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const g=new i(this.id,this.handle,void 0,M.URI.revive(l),E.Range.to(D),[],this.h,!0);return g.collapsibleState=d.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(l,D){const g=this.a.get(l);g&&(g.range=E.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(p,l,D,g){let S=D.get(l);return S||(S=++p.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$hG)(g,"commentsDraftState"),l.reactions?.some(k=>k.reactors!==void 0)&&(0,u.$hG)(g,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(k=>t(k)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$TO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(l=>l.name):p.reactors}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?M.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(l=>({name:l}))}}function c(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return d.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return d.CommentThreadCollapsibleState.Collapsed}return d.CommentThreadCollapsibleState.Collapsed}function $(p){let l;if(typeof p=="object"?l=p.resolved:l=p,l!==void 0)switch(l){case T.CommentThreadState.Unresolved:return d.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return d.CommentThreadState.Resolved}return d.CommentThreadState.Unresolved}function b(p){let l;if(typeof p=="object"&&(l=p.applicability),l!==void 0)switch(l){case T.CommentThreadApplicability.Current:return d.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return d.CommentThreadApplicability.Outdated}return d.CommentThreadApplicability.Current}return new r}}),define(Pe[255],Re([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class w{constructor(v,c){this.document=v,this.b=c,this.a=1,this.c=new T.$Wjc("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,c){await this.f(v).undo(),c||this.disposeBackup()}async redo(v,c){await this.f(v).redo(),c||this.disposeBackup()}disposeEdits(v){for(const c of v)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=h(this.document.uri)+this.a++;return(0,M.$1g)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const c=this.c.get(v,0);if(!c)throw new Error("No edit found");return c}}class m{constructor(){this.a=new Map}get(v,c){return this.a.get(this.b(v,c))}add(v,c,$){const b=this.b(v,c.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${v} resource:${c.uri}`);const p=new w(c,$);return this.a.set(b,p),p}delete(v,c){const $=this.b(v,c.uri);this.a.delete($)}b(v,c){return`${v}@@@${c}`}}var n;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(v,c,$){return this.b(0,v,c,$)}addCustomProvider(v,c,$){return this.b(1,v,c,$)}get(v){return this.a.get(v)}b(v,c,$,b){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:v,extension:$,provider:b}),new u.$zM(()=>this.a.delete(c))}}class s{constructor(v,c,$,b,p){this.d=c,this.f=$,this.g=b,this.h=p,this.b=new o,this.c=new m,this.a=v.getProxy(y.$xM.MainThreadCustomEditors)}registerCustomEditorProvider(v,c,$,b){const p=new R.$Tc;return i($)?(p.add(this.b.addTextProvider(c,v,$)),this.a.$registerTextEditorProvider((0,E.$wkc)(v),c,b.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,E.$ukc)(v))):(p.add(this.b.addCustomProvider(c,v,$)),r($)&&p.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const g=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,g,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,E.$wkc)(v),c,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,E.$ukc)(v))),u.$zM.from(p,new u.$zM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(v,c,$,b,p){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=d.URI.revive(v),g=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:b?.buffer},p);let S;return r(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,g,S),{editable:r(l.provider)}}async $disposeCustomDocument(v,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const b=d.URI.revive(v),{document:p}=this.i(c,b);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor(v,c,$,b,p,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const g=f.ViewColumn.to(p),S=this.g.createNewWebview(c,b.contentOptions,D.extension),k=this.h.createNewWebviewPanel(c,$,b.title,g,b.options,S,b.active),P=d.URI.revive(v);switch(D.type){case 1:{const{document:C}=this.i($,P);return D.provider.resolveCustomEditor(C,k,l)}case 0:{const C=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(C,k,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,c,$){this.i(c,v).disposeEdits($)}async $onMoveCustomEditor(v,c,$){const b=this.b.get($);if(!b)throw new Error(`No provider found for '${$}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const p=this.h.getWebviewPanel(v);if(!p)throw new Error("No webview found");const l=d.URI.revive(c),D=this.d.getDocument(l);await b.provider.moveCustomTextEditor(D,p,I.CancellationToken.None)}async $undo(v,c,$,b){return this.i(c,v).undo($,b)}async $redo(v,c,$,b){return this.i(c,v).redo($,b)}async $revert(v,c,$){const b=this.i(c,v);await this.j(c).revertCustomDocument(b.document,$),b.disposeBackup()}async $onSave(v,c,$){const b=this.i(c,v);await this.j(c).saveCustomDocument(b.document,$),b.disposeBackup()}async $onSaveAs(v,c,$,b){const p=this.i(c,v);return this.j(c).saveCustomDocumentAs(p.document,d.URI.revive($),b)}async $backup(v,c,$){const b=this.i(c,v),l=await this.j(c).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},$);return b.updateBackup(l),l.id}i(v,c){const $=this.c.get(v,d.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(v){const $=this.b.get(v)?.provider;if(!$||!r($))throw new Error("Custom document is not editable");return $}}e.$zkc=s;function r(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const v=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$bj)(v)+""}}),define(Pe[256],Re([1,0,164,100,2,4,7,8,5,13,28,44]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;class w{#e;#t;#i;constructor(o,s,r,i,a,h,t,v){this.d=o,this.e=s,this.f=r,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,r),this.#i=new T.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let r=[];if(R.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),r=[o]}else if(Array.isArray(o)){r=[];let h;o=[...o].sort(w.k);for(const t of o){const[v,c]=t;if((!h||v.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=v,r.push(v),this.#i.set(v,[])),c)this.#i.get(v)?.push(...c);else{const $=this.#i.get(v);$&&($.length=0)}}}if(this.#t.fire(r),!this.#e)return;const i=[];let a=0;for(const h of r){let t=[];const v=this.#i.get(h);if(v)if(v.length>this.g){t=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const b of v)if(b.severity===c[$]&&t.push({...d.Diagnostic.from(b),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,I.localize)(0,null,v.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=v.map(c=>({...d.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[r,i]of this)o.call(s,r,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$4jc=w;let m=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new T.$Bc;for(const r of o)s.set(r,r);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,r,i){this.j=s,this.k=r,this.l=i,this.g=new Map,this.h=new f.$de({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,u._mapper),this.f=o.getProxy(N.$xM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:r,f:i,h:a,j:h,k:t,l:v}=this,c=new class{$changeMany(p,l){i.$changeMany(p,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,l.length===0?"CLEARING":l)}$clear(p){i.$clear(p),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!r.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(r.has($))}return new class extends w{constructor(){super(s,$,u.e,u.d,p=>v.getDocument(p)?.version,t.extUri,c,a),r.set($,this)}dispose(){super.dispose(),r.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,r=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=r.length,s.set(a.toString(),t),r.push([a,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(o){let s=[];for(const r of this.g.values())r.has(o)&&(s=s.concat(r.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",r=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,r),this.n=r}for(const[s,r]of o)this.n.set(R.URI.revive(s),r.map(d.Diagnostic.to))}};e.$5jc=m,e.$5jc=m=u=Je([We(1,E.$Tj),We(2,y.$3jc)],m)}),define(Pe[257],Re([1,0,2,14,7,8,192,34]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class f{constructor(T,y,u,w={timeout:1500,errors:3}){this.c=T,this.d=y,this.f=u,this.g=w,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(y,u,w)=>{const n={dispose:this.a.push([y,u,T])};return Array.isArray(w)&&w.push(n),n}}async $participateInSave(T,y){const u=I.URI.revive(T);let w=!1;const m=setTimeout(()=>w=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(w)break;const s=this.d.getDocument(u),r=await this.h(o,{document:s,reason:N.TextDocumentSaveReason.to(y)});n.push(r)}}finally{clearTimeout(m)}return n}h([T,y,u],w){const m=this.b.get(T);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(u,T,y,w).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,y,u,w){const m=[],n=Date.now(),{document:o,reason:s}=w,{version:r}=o,i=Object.freeze({document:o,reason:s,waitUntil(a){if(Object.isFrozen(m))throw(0,O.$8)("waitUntil can not be called async");m.push(Promise.resolve(a))}});try{y.apply(u,[i])}catch(a){return Promise.reject(a)}return Object.freeze(m),new Promise((a,h)=>{const t=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(m).then(v=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(t),a(v)}).catch(v=>{clearTimeout(t),h(v)})}).then(a=>{const h={edits:[]};for(const t of a)if(Array.isArray(t)&&t.every(v=>v instanceof R.$GM))for(const{newText:v,newEol:c,range:$}of t)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:$&&N.Range.from($),text:v,eol:c&&N.EndOfLine.from(c)}});if(h.edits.length!==0)return r===o.version?this.f.$tryApplyWorkspaceEdit(new d.$jw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$blc=f}),define(Pe[258],Re([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=void 0;class y{constructor(w,m){this.a=new I.$_d,this.b=new I.$_d,this.c=new I.$_d,this.d=new I.$_d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=w.getProxy(N.$xM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const m=this.g.getDocument(w);if(m)return m}getDocument(w){const m=this.getDocumentData(w);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return m.document}ensureDocumentData(w){const m=this.g.getDocument(w);if(m)return Promise.resolve(m);let n=this.h.get(w.toString());return n||(n=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const s=R.URI.revive(o);return(0,f.$_f)(this.g.getDocument(s))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),n)),n}createDocumentData(w){return this.f.$tryCreateDocument(w).then(m=>R.URI.revive(m))}$acceptModelLanguageChanged(w,m){const n=R.URI.revive(w),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(w){const m=R.URI.revive(w),n=this.g.getDocument(m);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(w,m){const n=R.URI.revive(w),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,m,n){const o=R.URI.revive(w),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(n),s.onEvents(m);let r;m.isUndoing?r=T.TextDocumentChangeReason.Undo:m.isRedoing&&(r=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Un)({document:s.document,contentChanges:m.changes.map(i=>({range:d.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:r}))}setWordDefinitionFor(w,m){(0,M.$WO)(w,m)}}e.$6jc=y}),define(Pe[66],Re([1,0,259,5,17,2,3,4,16,8,7]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0,e.$Akc=(0,M.$ni)("IExtHostEditorTabs");class y{constructor(o,s,r){this.e=r,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$jO(N.URI.revive(this.b.input.uri));case 2:return new T.$kO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new T.$lO(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new T.$mO(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$nO(this.b.input.viewType);case 4:return new T.$oO(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$pO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$qO;case 9:return new T.$rO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$sO(this.b.input.providerId);case 11:return new T.$tO(this.b.input.diffEditors.map(o=>new T.$kO(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new y(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const s=this.c.find(r=>r.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new O.$_d,this.c=new O.$_d,this.e=[],this.a=o.getProxy(d.$xM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,R.$_f)(o.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,i)=>{const a=Array.isArray(r)?r:[r];return a.length?m(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),r=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,r),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const v=(0,R.$_f)(o.find(c=>c.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(r=>r.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const r=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const s of this.e)for(const r of s.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const r=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,s)}async j(o,s){const r=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,s)}};e.$Bkc=w,e.$Bkc=w=Je([We(0,f.$UO)],w);function m(n){return n.tabs!==void 0}}),define(Pe[260],Re([1,0,2,4,6,7,8,303,15,22,25,54]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class u{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let s,r,i=14,a=14;for(const h of n){let t=s?(0,f.$sf)(s,h):0;for(t===0?r=1:r=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([r,h.toUpperCase().charCodeAt(t),a]),o.push([r,h.toLowerCase().charCodeAt(t),a]),r=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new d.$G2(o)}}provideDocumentLinks(n){this.c();const o=[],s=d.$H2.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this.b);for(const r of s){const i=M.DocumentLink.to(r);i.target&&o.push(i)}return o}}class w{constructor(n,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(O.$xM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,s,r={}){if(w.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,T.$hG)(n,"fsChunks"),a+=4);let h;r.isReadonly&&(0,y.$Mk)(r.isReadonly)&&r.isReadonly.value!==""&&(h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(v=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(v)});const t=s.onDidChangeFile(v=>{const c=[];for(const $ of v){const{uri:b,type:p}=$;if(b.scheme!==o)continue;let l;switch(p){case N.FileChangeType.Changed:l=0;break;case N.FileChangeType.Created:l=1;break;case N.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:b,type:l})}this.a.$onFileSystemChange(i,c)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:s,mtime:r,size:i,permissions:a}=n;return{type:o,ctime:s,mtime:r,size:i,permissions:a}}$stat(n,o){return Promise.resolve(this.l(n).stat(I.URI.revive(o))).then(s=>w.k(s))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory(I.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile(I.URI.revive(o))).then(s=>E.$ze.wrap(s))}$writeFile(n,o,s,r){return Promise.resolve(this.l(n).writeFile(I.URI.revive(o),s.buffer,r))}$delete(n,o,s){return Promise.resolve(this.l(n).delete(I.URI.revive(o),s))}$rename(n,o,s,r){return Promise.resolve(this.l(n).rename(I.URI.revive(o),I.URI.revive(s),r))}$copy(n,o,s,r){const i=this.l(n);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),r))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory(I.URI.revive(o)))}$watch(n,o,s,r){const i=this.l(n).watch(I.URI.revive(s),r);this.f.set(o,i)}$unwatch(n,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(n,o,s){const r=this.l(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(I.URI.revive(o),s))}$close(n,o){const s=this.l(n);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(n,o,s,r){const i=this.l(n);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$ze.alloc(r);return Promise.resolve(i.read(o,s,a.buffer,0,r)).then(h=>a.slice(0,h))}$write(n,o,s,r){const i=this.l(n);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,r.buffer,0,r.byteLength))}l(n){const o=this.c.get(n);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$dlc=w}),define(Pe[261],Re([1,0,5,36,2,4,8,7,40]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,m,n,o,s,r){this.a=Math.random(),this.b=new I.$_d,this.c=new I.$_d,this.d=new I.$_d,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$hk)(s),a=typeof s=="string",h=r?.correlate,t=o(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(h&&typeof v.session>"u")){if(!r?.ignoreCreateEvents)for(const c of v.created){const $=R.URI.revive(c);i($.fsPath)&&(!a||m.getWorkspaceFolder($))&&this.b.fire($)}if(!r?.ignoreChangeEvents)for(const c of v.changed){const $=R.URI.revive(c);i($.fsPath)&&(!a||m.getWorkspaceFolder($))&&this.c.fire($)}if(!r?.ignoreDeleteEvents)for(const c of v.deleted){const $=R.URI.revive(c);i($.fsPath)&&(!a||m.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=d.$zM.from(this.i(w,n,s,r,r?.correlate),this.b,this.c,this.d,t)}i(w,m,n,o,s){const r=d.$zM.from();if(typeof n=="string")return r;const i=w.getProxy(N.$xM.MainThreadFileSystemEventService);let a=!1;return(n.pattern.includes(O.$dk)||n.pattern.includes(O.$ek))&&(a=!0),i.$watch(m.identifier.value,this.a,n.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),d.$zM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(w){this.a=w,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(R.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(w,m,n){this.j=w,this.k=m,this.l=n,this.a=new I.$_d,this.b=new I.$_d,this.c=new I.$_d,this.d=new I.$_d,this.g=new I.$be,this.h=new I.$be,this.i=new I.$be,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,n,o){return new E(this.j,w,m,this.a.event,M.GlobPattern.from(n),o)}$onFileEvent(w){this.a.fire(new T(w))}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(n=>({oldUri:R.URI.revive(n.source),newUri:R.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(n=>R.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(n=>R.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(n,o,s)=>{const r=function(a){n.call(o,a)};return r.extension=w,m.event(r,void 0,s)}}async $onWillRunFileOperation(w,m,n,o){switch(w){case 2:return await this.n(this.g,{files:m.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))},n,o);case 1:return await this.n(this.i,{files:m.map(s=>R.URI.revive(s.target))},n,o);case 0:case 3:return await this.n(this.h,{files:m.map(s=>R.URI.revive(s.target))},n,o)}}async n(w,m,n,o){const s=new Set,r=[];if(await w.fireAsync(m,o,async(a,h)=>{const t=Date.now(),v=await Promise.resolve(a);v instanceof d.$JM&&(r.push([h.extension,v]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,a]of r){const{edits:h}=M.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$elc=y}),define(Pe[262],Re([1,0,18,11,24,14,90,6,26,65,15,17,2,29,304,87,97,166,20,8,7,25,74,4]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=void 0;class c{constructor(j,z){this.d=j,this.e=z}async provideDocumentSymbols(j,z){const G=this.d.getDocument(j),H=await this.e.provideDocumentSymbols(G,z);if(!(0,I.$Kb)(H))return H[0]instanceof a.$SM?H.map(i.DocumentSymbol.from):c.f(H)}static f(j){j=j.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const z=[],G=[];for(const H of j){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),z.push(ee);break}const se=G[G.length-1];if(w.$ht.containsRange(se.range,ee.range)&&!w.$ht.equalsRange(se.range,ee.range)){se.children?.push(ee),G.push(ee);break}G.pop()}}return z}}class ${constructor(j,z,G,H,ee,se){this.f=j,this.g=z,this.h=G,this.j=H,this.k=ee,this.l=se,this.d=new t.$Wjc("CodeLens"),this.e=new Map}async provideCodeLenses(j,z){const G=this.f.getDocument(j),H=await this.h.provideCodeLenses(G,z);if(!H||z.isCancellationRequested)return;const ee=this.d.add(H),se=new d.$Tc;this.e.set(ee,se);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:i.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,se)});return Oe}async resolveCodeLens(j,z){const G=j.cacheId&&this.d.get(...j.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,z),H||(H=G),z.isCancellationRequested)return;const ee=j.cacheId&&this.e.get(j.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return j.command=this.g.toInternal(H.command,ee),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function b(Ue){return Array.isArray(Ue)?Ue.map(i.DefinitionLink.from):Ue?[i.DefinitionLink.from(Ue)]:[]}class p{constructor(j,z){this.d=j,this.e=z}async provideDefinition(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideDefinition(H,ee,G);return b(se)}}class l{constructor(j,z){this.d=j,this.e=z}async provideDeclaration(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideDeclaration(H,ee,G);return b(se)}}class D{constructor(j,z){this.d=j,this.e=z}async provideImplementation(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideImplementation(H,ee,G);return b(se)}}class g{constructor(j,z){this.d=j,this.e=z}async provideTypeDefinition(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideTypeDefinition(H,ee,G);return b(se)}}class S{constructor(j,z){this.d=j,this.e=z}async provideHover(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideHover(H,ee,G);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new a.$BM(ee,ee)),i.Hover.from(se)}}class k{constructor(j,z){this.d=j,this.e=z}async provideEvaluatableExpression(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideEvaluatableExpression(H,ee,G);if(se)return i.EvaluatableExpression.from(se)}}class P{constructor(j,z){this.d=j,this.e=z}async provideInlineValues(j,z,G,H){const ee=this.d.getDocument(j),se=await this.e.provideInlineValues(ee,i.Range.to(z),i.InlineValueContext.to(G),H);if(Array.isArray(se))return se.map(Oe=>i.InlineValue.from(Oe))}}class C{constructor(j,z){this.d=j,this.e=z}async provideDocumentHighlights(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class W{constructor(j,z){this.d=j,this.e=z}async provideMultiDocumentHighlights(j,z,G,H){const ee=this.d.getDocument(j),se=G.map(Qe=>this.d.getDocument(Qe)),Oe=i.Position.to(z),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,se,H);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class V{constructor(j,z){this.d=j,this.e=z}async provideLinkedEditingRanges(j,z,G){const H=this.d.getDocument(j),ee=i.Position.to(z),se=await this.e.provideLinkedEditingRanges(H,ee,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class q{constructor(j,z){this.d=j,this.e=z}async provideReferences(j,z,G,H){const ee=this.d.getDocument(j),se=i.Position.to(z),Oe=await this.e.provideReferences(ee,se,G,H);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class A{static{this.d=1e3}constructor(j,z,G,H,ee,se,Oe){this.g=j,this.h=z,this.j=G,this.k=H,this.l=ee,this.m=se,this.n=Oe,this.e=new t.$Wjc("CodeAction"),this.f=new Map}async provideCodeActions(j,z,G,H){const ee=this.g.getDocument(j),se=m.$jt.isISelection(z)?i.Selection.to(z):i.Range.to(z),Oe=[];for(const it of this.j.getDiagnostics(j))if(se.intersection(it.range)&&Oe.push(it)>A.d)break;const Be={diagnostics:Oe,only:G.only?new a.$UM(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,se,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const Ye=this.e.add(Qe),et=new d.$Tc;this.f.set(Ye,et);const at=[];for(let it=0;it<Qe.length;it++){const tt=Qe[it];if(tt)if(A.o(tt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,et)});else{Be.only&&(tt.kind?Be.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=tt.ranges??[];at.push({cacheId:[Ye,it],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,et),diagnostics:tt.diagnostics&&tt.diagnostics.map(i.Diagnostic.from),edit:tt.edit&&i.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,h.$gG)(this.m,"codeActionAI")?tt.isAI:!1,ranges:(0,h.$gG)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:tt.disabled?.reason})}}return{cacheId:Ye,actions:at}}async resolveCodeAction(j,z){const[G,H]=j,ee=this.e.get(G,H);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,z)??ee;let Oe;se.edit&&(Oe=i.WorkspaceEdit.from(se.edit,void 0));let Be;if(se.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(se.command,Qe))}return{edit:Oe,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class U{constructor(j,z,G,H,ee){this.e=j,this.f=z,this.g=G,this.h=H,this.j=ee,this.d=new t.$Wjc("DocumentPasteEdit")}async prepareDocumentPaste(j,z,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(j),se=z.map(Qe=>i.Range.to(Qe)),Oe=i.DataTransfer.toDataTransfer(G,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,se,Oe,H),H.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,Qe])=>!(Qe instanceof a.$oN));return i.DataTransfer.from(Be)}async providePasteEdits(j,z,G,H,ee,se){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(z),Be=G.map(at=>i.Range.to(at)),Qe=i.DataTransfer.toDataTransfer(H,async at=>(await this.e.$resolvePasteFileData(this.h,j,at)).buffer),Ye=await this.g.provideDocumentPasteEdits(Oe,Be,Qe,{only:ee.only?new a.$tN(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!Ye||se.isCancellationRequested)return[];const et=this.d.add(Ye);return Ye.map((at,it)=>({_cacheId:[et,it],title:at.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(tt=>tt.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,z){const[G,H]=j,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(ee,z)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class K{constructor(j,z){this.d=j,this.e=z}async provideDocumentFormattingEdits(j,z,G){const H=this.d.getDocument(j),ee=await this.e.provideDocumentFormattingEdits(H,z,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeFormattingEdits(j,z,G,H){const ee=this.d.getDocument(j),se=i.Range.to(z),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,se,G,H);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,z,G,H){(0,y.$$f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(j),se=z.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,se,G,H);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class fe{constructor(j,z){this.d=j,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,z,G,H,ee){const se=this.d.getDocument(j),Oe=i.Position.to(z),Be=await this.e.provideOnTypeFormattingEdits(se,Oe,G,H,ee);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class Se{constructor(j,z){this.e=j,this.f=z,this.d=new t.$Wjc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,z){const G=await this.e.provideWorkspaceSymbols(j,z);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let se=0;se<G.length;se++){const Oe=G[se];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(j,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const G=this.d.get(...j.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,z);return H&&(0,f.$Wn)(j,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class ke{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,z,G){this.d=j,this.e=z,this.f=G}async provideRenameEdits(j,z,G,H){const ee=this.d.getDocument(j),se=i.Position.to(z);try{const Oe=await this.e.provideRenameEdits(ee,se,G,H);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=ke.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(j,z,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(j),ee=i.Position.to(z);try{const se=await this.e.prepareRename(H,ee,G);let Oe,Be;if(a.$BM.isRange(se)?(Oe=se,Be=H.getText(se)):(0,y.$3f)(se)&&(Oe=se.range,Be=se.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:Be}}catch(se){const Oe=ke.g(se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(se)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class oe{constructor(j,z,G){this.d=j,this.e=z,this.f=G}async provideNewSymbolNames(j,z,G){const H=this.d.getDocument(j),ee=i.Range.to(z);try{const se=await this.e.provideNewSymbolNames(H,ee,G);return se?se.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(se){this.f.error(oe.g(se)??JSON.stringify(se,null,"	"));return}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class $e{constructor(j,z){this.resultId=j,this.tokens=z}}class ne{constructor(j,z){this.f=j,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,z,G){const H=this.f.getDocument(j),ee=z!==0?this.d.get(z):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(z),se?(se=ne.h(se),this.o(ne.n(ee,se),se)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return ne.j(j)?ne.k(j)?j:new a.$TN(new Uint32Array(j.data),j.resultId):ne.l(j)?ne.m(j)?j:new a.$VN(j.edits.map(z=>new a.$UN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const z of j.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(j,z){if(!ne.j(z)||!j||!j.tokens)return z;const G=j.tokens,H=G.length,ee=z.data,se=ee.length;let Oe=0;const Be=Math.min(H,se);for(;Oe<Be&&G[Oe]===ee[Oe];)Oe++;if(Oe===H&&Oe===se)return new a.$VN([],z.resultId);let Qe=0;const Ye=Be-Oe;for(;Qe<Ye&&G[H-Qe-1]===ee[se-Qe-1];)Qe++;return new a.$VN([{start:Oe,deleteCount:H-Oe-Qe,data:ee.subarray(Oe,se-Qe)}],z.resultId)}o(j,z){if(ne.j(j)){const G=this.e++;return this.d.set(G,new $e(j.resultId,j.data)),(0,o.$Zab)({id:G,type:"full",data:j.data})}if(ne.l(j)){const G=this.e++;return ne.j(z)?this.d.set(G,new $e(z.resultId,z.data)):this.d.set(G,new $e(j.resultId)),(0,o.$Zab)({id:G,type:"delta",deltas:(j.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Ie{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeSemanticTokens(j,z,G){const H=this.d.getDocument(j),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(z),G);return ee?this.f(ee):null}f(j){return(0,o.$Zab)({id:0,type:"full",data:j.data})}}class ze{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,z,G,H,ee){this.f=j,this.g=z,this.h=G,this.j=H,this.k=ee,this.d=new t.$Wjc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,z,G,H){const ee=this.f.getDocument(j),se=i.Position.to(z),Oe=ee.getWordRangeAtPosition(se)||new a.$BM(se,se),Be=Oe.with({end:se}),Qe=new E.$8d,Ye=await this.h.provideCompletionItems(ee,se,H,i.CompletionContext.to(G));if(!Ye||H.isCancellationRequested)return;const et=Array.isArray(Ye)?new a.$8M(Ye):Ye,at=ze.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new d.$Tc;this.e.set(at,it);const tt=[],ct={x:at,b:tt,a:{replace:i.Range.from(Oe),insert:i.Range.from(Be)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<et.items.length;ft++){const je=et.items[ft],st=this.l(je,[at,ft],Be,Oe);tt.push(st)}return ct}async resolveCompletionItem(j,z){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...j);if(!G)return;const H=this.l(G,j),ee=await this.h.resolveCompletionItem(G,z);if(!ee)return;const se=this.l(ee,j);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,f.$Xn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z,G,H){const ee=this.e.get(z[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(j.command,ee),Oe={x:z,a:j.label,b:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(i.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=j.textEdit.newText):typeof j.insertText=="string"?Oe.h=j.insertText:j.insertText instanceof a.$KM&&(Oe.h=j.insertText.value,Oe.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),a.$BM.isRange(Be)?Oe.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Oe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Oe}}class re{async provideInlineCompletions(j,z,G,H){}disposeCompletions(j){}handleDidShowCompletionItem(j,z,G){}handlePartialAccept(j,z,G,H){}}class L extends re{constructor(j,z,G,H){super(),this.f=j,this.g=z,this.h=G,this.j=H,this.d=new ve,this.e=(0,h.$gG)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$gG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,z,G,H){const ee=this.g.getDocument(j),se=i.Position.to(z),Oe=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],Ye=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,tt)=>{let ct;it.command&&(et||(et=new d.$Tc),ct=this.j.toInternal(it.command,et));const ft=it.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:ct,idx:tt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new d.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,z,G){const H=this.d.get(j)?.items[z];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(j,z,G,H){const ee=this.d.get(j)?.items[z];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class _{async provideInlineEdits(j,z,G){const H=this.f.getDocument(j),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[z.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let se;const Oe=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Be;ee.accepted&&(se||(se=new d.$Tc),Be=this.h.toInternal(ee.accepted,se));let Qe;return ee.rejected&&(se||(se=new d.$Tc),Qe=this.h.toInternal(ee.rejected,se)),{pid:Oe,text:ee.text,range:i.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,z,G,H){this.f=z,this.g=G,this.h=H,this.d=new ve,this.e={[n.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const z=this.e++;return this.d.set(z,j),z}disposeReferenceId(j){const z=this.d.get(j);return this.d.delete(j),z}get(j){return this.d.get(j)}}class Te{constructor(j,z){this.e=j,this.f=z,this.d=new t.$Wjc("SignatureHelp")}async provideSignatureHelp(j,z,G,H){const ee=this.e.getDocument(j),se=i.Position.to(z),Oe=this.g(G),Be=await this.f.provideSignatureHelp(ee,se,H,Oe);if(Be){const Qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:Qe}}}g(j){let z;if(j.activeSignatureHelp){const G=i.SignatureHelp.to(j.activeSignatureHelp),H=this.d.get(j.activeSignatureHelp.id,0);H?(z=H,z.activeSignature=G.activeSignature,z.activeParameter=G.activeParameter):z=G}return{...j,activeSignatureHelp:z}}releaseSignatureHelp(j){this.d.delete(j)}}class Ee{constructor(j,z,G,H,ee){this.f=j,this.g=z,this.h=G,this.j=H,this.k=ee,this.d=new t.$Wjc("InlayHints"),this.e=new Map}async provideInlayHints(j,z,G){const H=this.f.getDocument(j),ee=i.Range.to(z),se=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(G.isCancellationRequested)return;const Oe=this.d.add(se);this.e.set(Oe,new d.$Tc);const Be={hints:[],cacheId:Oe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],ee)&&Be.hints.push(this.m(se[Qe],[Oe,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Be}async resolveInlayHint(j,z){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.h.resolveInlayHint(G,z);if(H&&this.l(H))return this.m(H,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z){return j.label.length===0||Array.isArray(j.label)&&j.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(z&&!z.contains(j.position))}m(j,z){const G=this.e.get(z[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:z,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")H.label=j.label;else{const ee=[];H.label=ee;for(const se of j.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$LM.isLocation(se.location)&&(Oe.location=i.location.from(se.location)),se.command&&(Oe.command=this.g.toInternal(se.command,G)),ee.push(Oe)}}return H}}class pe{constructor(j,z){this.e=j,this.f=z,this.d=new t.$Wjc("DocumentLink")}async provideLinks(j,z){const G=this.e.getDocument(j),H=await this.f.provideDocumentLinks(G,z);if(!(!Array.isArray(H)||H.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Oe=0;Oe<H.length;Oe++){if(!pe.g(H[Oe]))continue;const Be=i.DocumentLink.from(H[Oe]);Be.cacheId=[ee,Oe],se.links.push(Be)}return se}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,z){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.f.resolveDocumentLink(G,z);if(!(!H||!pe.g(H)))return i.DocumentLink.from(H)}releaseLinks(j){this.d.delete(j)}}class de{constructor(j,z){this.d=j,this.e=z}async provideColors(j,z){const G=this.d.getDocument(j),H=await this.e.provideDocumentColors(G,z);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(j,z,G){const H=this.d.getDocument(j),ee=i.Range.to(z.range),se=i.Color.to(z.color),Oe=await this.e.provideColorPresentations(se,{document:H,range:ee},G);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class Q{constructor(j,z){this.d=j,this.e=z}async provideFoldingRanges(j,z,G){const H=this.d.getDocument(j),ee=await this.e.provideFoldingRanges(H,z,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(j,z,G){this.d=j,this.e=z,this.f=G}async provideSelectionRanges(j,z,G){const H=this.d.getDocument(j),ee=z.map(i.Position.to),se=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Oe.push(Qe);let Ye=ee[Be],et=se[Be];for(;;){if(!et.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(et)),!et.parent)break;Ye=et.range,et=et.parent}}return Oe}}class ue{constructor(j,z){this.f=j,this.g=z,this.d=new M.$ZO(""),this.e=new Map}async prepareSession(j,z,G){const H=this.f.getDocument(j),ee=i.Position.to(z),se=await this.g.prepareCallHierarchy(H,ee,G);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(Be=>this.h(Oe,Be)):[this.h(Oe,se)]}async provideCallsTo(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(se=>({from:this.h(j,se.from),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(se=>({to:this.h(j,se.to),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(j){this.e.delete(j)}h(j,z){const G=this.e.get(j),H=i.CallHierarchyItem.from(z,j,G.size.toString(36));return G.set(H._itemId,z),H}j(j,z){return this.e.get(j)?.get(z)}}class he{constructor(j,z){this.f=j,this.g=z,this.d=new M.$ZO(""),this.e=new Map}async prepareSession(j,z,G){const H=this.f.getDocument(j),ee=i.Position.to(z),se=await this.g.prepareTypeHierarchy(H,ee,G);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(Be=>this.h(Oe,Be)):[this.h(Oe,se)]}async provideSupertypes(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(se=>this.h(j,se))}async provideSubtypes(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(se=>this.h(j,se))}releaseSession(j){this.e.delete(j)}h(j,z){const G=this.e.get(j),H=i.TypeHierarchyItem.from(z,j,G.size.toString(36));return G.set(H._itemId,z),H}j(j,z){return this.e.get(j)?.get(z)}}class Ne{constructor(j,z,G,H,ee){this.d=j,this.e=z,this.f=G,this.g=H,this.h=ee}async provideDocumentOnDropEdits(j,z,G,H,ee){const se=this.e.getDocument(z),Oe=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(H,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,j,Ye)).buffer),Qe=await this.f.provideDocumentDropEdits(se,Oe,Be,ee);if(Qe)return(0,I.$3b)(Qe).map(Ye=>({title:Ye.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:Ye.kind?.value,yieldTo:Ye.yieldTo?.map(et=>et.value),insertText:typeof Ye.insertText=="string"?Ye.insertText:{snippet:Ye.insertText.value},additionalEdit:Ye.additionalEdit?i.WorkspaceEdit.from(Ye.additionalEdit,void 0):void 0}))}}class le{constructor(j,z){this.d=j,this.e=z}async provideMappedEdits(j,z,G,H){const ee=u.URI.revive(j),se=this.d.getDocument(ee),Oe=G.documents.map(Ye=>Ye.map(et=>({uri:u.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(at=>i.Range.to(at))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,z,Be,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ce{constructor(j,z){this.adapter=j,this.extension=z}}class Ae{static{this.d=0}constructor(j,z,G,H,ee,se,Oe,Be){this.g=z,this.h=G,this.j=H,this.k=ee,this.l=se,this.m=Oe,this.n=Be,this.f=new Map,this.e=j.getProxy(v.$xM.MainThreadLanguageFeatures)}o(j,z){return i.DocumentSelector.from(j,this.g,z)}p(j){return new a.$zM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,z,G,H,ee,se=!1){const Oe=this.f.get(j);if(!Oe||!(Oe.adapter instanceof z))return H;const Be=Date.now();se||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Oe.adapter,Oe.extension);return Promise.resolve(Qe).catch(Ye=>{(0,N.$4)(Ye)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Oe.extension.identifier,Ye))}).finally(()=>{se||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,O.$ch)(Qe,ee):Qe}t(j,z){const G=this.q();return this.f.set(G,new Ce(j,z)),G}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,z,G,H){const ee=this.t(new c(this.h,G),j),se=H&&H.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(ee,this.o(z,j),se),this.p(ee)}$provideDocumentSymbols(j,z,G){return this.s(j,c,H=>H.provideDocumentSymbols(u.URI.revive(z),G),void 0,G)}registerCodeLensProvider(j,z,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new $(this.h,this.j.converter,G,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(H,this.o(z,j),ee);let se=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));se=a.$zM.from(se,Oe)}return se}$provideCodeLenses(j,z,G){return this.s(j,$,H=>H.provideCodeLenses(u.URI.revive(z),G),void 0,G)}$resolveCodeLens(j,z,G){return this.s(j,$,H=>H.resolveCodeLens(z,G),void 0,void 0)}$releaseCodeLenses(j,z){this.s(j,$,G=>Promise.resolve(G.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(j,z,G){const H=this.t(new p(this.h,G),j);return this.e.$registerDefinitionSupport(H,this.o(z,j)),this.p(H)}$provideDefinition(j,z,G,H){return this.s(j,p,ee=>ee.provideDefinition(u.URI.revive(z),G,H),[],H)}registerDeclarationProvider(j,z,G){const H=this.t(new l(this.h,G),j);return this.e.$registerDeclarationSupport(H,this.o(z,j)),this.p(H)}$provideDeclaration(j,z,G,H){return this.s(j,l,ee=>ee.provideDeclaration(u.URI.revive(z),G,H),[],H)}registerImplementationProvider(j,z,G){const H=this.t(new D(this.h,G),j);return this.e.$registerImplementationSupport(H,this.o(z,j)),this.p(H)}$provideImplementation(j,z,G,H){return this.s(j,D,ee=>ee.provideImplementation(u.URI.revive(z),G,H),[],H)}registerTypeDefinitionProvider(j,z,G){const H=this.t(new g(this.h,G),j);return this.e.$registerTypeDefinitionSupport(H,this.o(z,j)),this.p(H)}$provideTypeDefinition(j,z,G,H){return this.s(j,g,ee=>ee.provideTypeDefinition(u.URI.revive(z),G,H),[],H)}registerHoverProvider(j,z,G,H){const ee=this.t(new S(this.h,G),j);return this.e.$registerHoverProvider(ee,this.o(z,j)),this.p(ee)}$provideHover(j,z,G,H){return this.s(j,S,ee=>ee.provideHover(u.URI.revive(z),G,H),void 0,H)}registerEvaluatableExpressionProvider(j,z,G,H){const ee=this.t(new k(this.h,G),j);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(z,j)),this.p(ee)}$provideEvaluatableExpression(j,z,G,H){return this.s(j,k,ee=>ee.provideEvaluatableExpression(u.URI.revive(z),G,H),void 0,H)}registerInlineValuesProvider(j,z,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new P(this.h,G),j);this.e.$registerInlineValuesProvider(se,this.o(z,j),ee);let Oe=this.p(se);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Oe=a.$zM.from(Oe,Be)}return Oe}$provideInlineValues(j,z,G,H,ee){return this.s(j,P,se=>se.provideInlineValues(u.URI.revive(z),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(j,z,G){const H=this.t(new C(this.h,G),j);return this.e.$registerDocumentHighlightProvider(H,this.o(z,j)),this.p(H)}registerMultiDocumentHighlightProvider(j,z,G){const H=this.t(new W(this.h,G),j);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(z,j)),this.p(H)}$provideDocumentHighlights(j,z,G,H){return this.s(j,C,ee=>ee.provideDocumentHighlights(u.URI.revive(z),G,H),void 0,H)}$provideMultiDocumentHighlights(j,z,G,H,ee){return this.s(j,W,se=>se.provideMultiDocumentHighlights(u.URI.revive(z),G,H.map(Oe=>u.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(j,z,G){const H=this.t(new V(this.h,G),j);return this.e.$registerLinkedEditingRangeProvider(H,this.o(z,j)),this.p(H)}$provideLinkedEditingRanges(j,z,G,H){return this.s(j,V,async ee=>{const se=await ee.provideLinkedEditingRanges(u.URI.revive(z),G,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ae.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(j,z,G){const H=this.t(new q(this.h,G),j);return this.e.$registerReferenceSupport(H,this.o(z,j)),this.p(H)}$provideReferences(j,z,G,H,ee){return this.s(j,q,se=>se.provideReferences(u.URI.revive(z),G,H,ee),void 0,ee)}registerCodeActionProvider(j,z,G,H){const ee=new d.$Tc,se=this.t(new A(this.h,this.j.converter,this.k,G,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(se,this.o(z,j),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Ae.u(j),!!G.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(j,z,G,H,ee){return this.s(j,A,se=>se.provideCodeActions(u.URI.revive(z),G,H,ee),void 0,ee)}$resolveCodeAction(j,z,G){return this.s(j,A,H=>H.resolveCodeAction(z,G),{},void 0)}$releaseCodeActions(j,z){this.s(j,A,G=>Promise.resolve(G.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(j,z,G){const H=this.t(new K(this.h,G),j);return this.e.$registerDocumentFormattingSupport(H,this.o(z,j),j.identifier,j.displayName||j.name),this.p(H)}$provideDocumentFormattingEdits(j,z,G,H){return this.s(j,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(z),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(j,z,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),j);return this.e.$registerRangeFormattingSupport(ee,this.o(z,j),j.identifier,j.displayName||j.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(j,z,G,H,ee){return this.s(j,ie,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(z),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(j,z,G,H,ee){return this.s(j,ie,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(z),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(j,z,G,H){const ee=this.t(new fe(this.h,G),j);return this.e.$registerOnTypeFormattingSupport(ee,this.o(z,j),H,j.identifier),this.p(ee)}$provideOnTypeFormattingEdits(j,z,G,H,ee,se){return this.s(j,fe,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(z),G,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(j,z){const G=this.t(new Se(z,this.l),j);return this.e.$registerNavigateTypeSupport(G,typeof z.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(j,z,G){return this.s(j,Se,H=>H.provideWorkspaceSymbols(z,G),{symbols:[]},G)}$resolveWorkspaceSymbol(j,z,G){return this.s(j,Se,H=>H.resolveWorkspaceSymbol(z,G),void 0,void 0)}$releaseWorkspaceSymbols(j,z){this.s(j,Se,G=>G.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(j,z,G){const H=this.t(new ke(this.h,G,this.l),j);return this.e.$registerRenameSupport(H,this.o(z,j),ke.supportsResolving(G)),this.p(H)}$provideRenameEdits(j,z,G,H,ee){return this.s(j,ke,se=>se.provideRenameEdits(u.URI.revive(z),G,H,ee),void 0,ee)}$resolveRenameLocation(j,z,G,H){return this.s(j,ke,ee=>ee.resolveRenameLocation(u.URI.revive(z),G,H),void 0,H)}registerNewSymbolNamesProvider(j,z,G){const H=this.t(new oe(this.h,G,this.l),j);return this.e.$registerNewSymbolNamesProvider(H,this.o(z,j)),this.p(H)}$provideNewSymbolNames(j,z,G,H){return this.s(j,oe,ee=>ee.provideNewSymbolNames(u.URI.revive(z),G,H),void 0,H)}registerDocumentSemanticTokensProvider(j,z,G,H){const ee=this.t(new ne(this.h,G),j),se=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(z,j),H,se);let Oe=this.p(ee);if(se){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Oe=a.$zM.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(j,z,G,H){return this.s(j,ne,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(z),G,H),null,H)}$releaseDocumentSemanticTokens(j,z){this.s(j,ne,G=>G.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,z,G,H){const ee=this.t(new Ie(this.h,G),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(z,j),H),this.p(ee)}$provideDocumentRangeSemanticTokens(j,z,G,H){return this.s(j,Ie,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(z),G,H),null,H)}registerCompletionItemProvider(j,z,G,H){const ee=this.t(new ze(this.h,this.j.converter,G,this.m,j),j);return this.e.$registerCompletionsProvider(ee,this.o(z,j),H,ze.supportsResolving(G),j.identifier),this.p(ee)}$provideCompletionItems(j,z,G,H,ee){return this.s(j,ze,se=>se.provideCompletionItems(u.URI.revive(z),G,H,ee),void 0,ee)}$resolveCompletionItem(j,z,G){return this.s(j,ze,H=>H.resolveCompletionItem(z,G),void 0,G)}$releaseCompletionItems(j,z){this.s(j,ze,G=>G.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(j,z,G,H){const ee=new L(j,this.h,G,this.j.converter),se=this.t(ee,j);return this.e.$registerInlineCompletionsSupport(se,this.o(z,j),ee.supportsHandleEvents,r.$Im.toKey(j.identifier.value),H?.yieldTo?.map(Oe=>r.$Im.toKey(Oe))||[]),this.p(se)}$provideInlineCompletions(j,z,G,H,ee){return this.s(j,re,se=>se.provideInlineCompletions(u.URI.revive(z),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(j,z,G,H){this.s(j,re,async ee=>{ee.handleDidShowCompletionItem(z,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,z,G,H,ee){this.s(j,re,async se=>{se.handlePartialAccept(z,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(j,z){this.s(j,re,async G=>{G.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(j,z,G){const H=new _(j,this.h,G,this.j.converter),ee=this.t(H,j);return this.e.$registerInlineEditProvider(ee,this.o(z,j),j.identifier),this.p(ee)}$provideInlineEdit(j,z,G,H){return this.s(j,_,ee=>ee.provideInlineEdits(u.URI.revive(z),G,H),void 0,H)}$freeInlineEdit(j,z){this.s(j,_,async G=>{G.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(j,z,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Te(this.h,G),j);return this.e.$registerSignatureHelpProvider(se,this.o(z,j),ee),this.p(se)}$provideSignatureHelp(j,z,G,H,ee){return this.s(j,Te,se=>se.provideSignatureHelp(u.URI.revive(z),G,H,ee),void 0,ee)}$releaseSignatureHelp(j,z){this.s(j,Te,G=>G.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(j,z,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ee(this.h,this.j.converter,G,this.l,j),j);this.e.$registerInlayHintsProvider(ee,this.o(z,j),typeof G.resolveInlayHint=="function",H,Ae.u(j));let se=this.p(ee);if(H!==void 0){const Oe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));se=a.$zM.from(se,Oe)}return se}$provideInlayHints(j,z,G,H){return this.s(j,Ee,ee=>ee.provideInlayHints(u.URI.revive(z),G,H),void 0,H)}$resolveInlayHint(j,z,G){return this.s(j,Ee,H=>H.resolveInlayHint(z,G),void 0,G)}$releaseInlayHints(j,z){this.s(j,Ee,G=>G.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(j,z,G){const H=this.t(new pe(this.h,G),j);return this.e.$registerDocumentLinkProvider(H,this.o(z,j),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(j,z,G){return this.s(j,pe,H=>H.provideLinks(u.URI.revive(z),G),void 0,G,z.scheme==="output")}$resolveDocumentLink(j,z,G){return this.s(j,pe,H=>H.resolveLink(z,G),void 0,void 0,!0)}$releaseDocumentLinks(j,z){this.s(j,pe,G=>G.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(j,z,G){const H=this.t(new de(this.h,G),j);return this.e.$registerDocumentColorProvider(H,this.o(z,j)),this.p(H)}$provideDocumentColors(j,z,G){return this.s(j,de,H=>H.provideColors(u.URI.revive(z),G),[],G)}$provideColorPresentations(j,z,G,H){return this.s(j,de,ee=>ee.provideColorPresentations(u.URI.revive(z),G,H),void 0,H)}registerFoldingRangeProvider(j,z,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),j)),this.e.$registerFoldingRangeProvider(H,this.o(z,j),j.identifier,ee);let se=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=a.$zM.from(se,Oe)}return se}$provideFoldingRanges(j,z,G,H){return this.s(j,Q,ee=>ee.provideFoldingRanges(u.URI.revive(z),G,H),void 0,H)}registerSelectionRangeProvider(j,z,G){const H=this.t(new Y(this.h,G,this.l),j);return this.e.$registerSelectionRangeProvider(H,this.o(z,j)),this.p(H)}$provideSelectionRanges(j,z,G,H){return this.s(j,Y,ee=>ee.provideSelectionRanges(u.URI.revive(z),G,H),[],H)}registerCallHierarchyProvider(j,z,G){const H=this.t(new ue(this.h,G),j);return this.e.$registerCallHierarchyProvider(H,this.o(z,j)),this.p(H)}$prepareCallHierarchy(j,z,G,H){return this.s(j,ue,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(z),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(j,z,G,H){return this.s(j,ue,ee=>ee.provideCallsTo(z,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(j,z,G,H){return this.s(j,ue,ee=>ee.provideCallsFrom(z,G,H),void 0,H)}$releaseCallHierarchy(j,z){this.s(j,ue,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(j,z,G){const H=this.t(new he(this.h,G),j);return this.e.$registerTypeHierarchyProvider(H,this.o(z,j)),this.p(H)}$prepareTypeHierarchy(j,z,G,H){return this.s(j,he,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(z),G,H)),void 0,H)}$provideTypeHierarchySupertypes(j,z,G,H){return this.s(j,he,ee=>ee.provideSupertypes(z,G,H),void 0,H)}$provideTypeHierarchySubtypes(j,z,G,H){return this.s(j,he,ee=>ee.provideSubtypes(z,G,H),void 0,H)}$releaseTypeHierarchy(j,z){this.s(j,he,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(j,z,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Ne(this.e,this.h,G,ee,j),j)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(z,j),(0,h.$gG)(j,"dropMetadata")?H:void 0),this.p(ee)}$provideDocumentOnDropEdits(j,z,G,H,ee,se){return this.s(j,Ne,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(z,u.URI.revive(G),H,ee,se)),void 0,void 0)}registerMappedEditsProvider(j,z,G){const H=this.t(new le(this.h,G),j);return this.e.$registerMappedEditsProvider(H,this.o(z,j)),this.p(H)}$provideMappedEdits(j,z,G,H,ee){return this.s(j,le,se=>Promise.resolve(se.provideMappedEdits(z,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(j,z,G,H){const ee=this.q();return this.f.set(ee,new Ce(new U(this.e,this.h,G,ee,j),j)),this.e.$registerPasteEditProvider(ee,this.o(z,j),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(j,z,G,H,ee){return this.s(j,U,se=>se.prepareDocumentPaste(u.URI.revive(z),G,H,ee),void 0,ee)}$providePasteEdits(j,z,G,H,ee,se,Oe){return this.s(j,U,Be=>Be.providePasteEdits(z,u.URI.revive(G),H,ee,se,Oe),void 0,Oe)}$resolvePasteEdit(j,z,G){return this.s(j,U,H=>H.resolvePasteEdit(z,G),{},void 0)}$releasePasteEdits(j,z){this.s(j,U,G=>Promise.resolve(G.releasePasteEdits(z)),void 0,void 0)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Ae.w(j.decreaseIndentPattern),increaseIndentPattern:Ae.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Ae.w(j.beforeText),afterText:j.afterText?Ae.w(j.afterText):void 0,previousLineText:j.previousLineText?Ae.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Ae.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(z=>a.SyntaxTokenType.toString(z)):void 0}}static D(j){return j.map(Ae.C)}setLanguageConfiguration(j,z,G){const{wordPattern:H}=G;if(H&&(0,T.$cf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(z,H):this.h.setWordDefinitionFor(z,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ee=this.q(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,z,se),this.p(ee)}$setWordDefinitions(j){for(const z of j)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$7jc=Ae}),define(Pe[88],Re([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$bkc=(0,w.$ni)("IExtHostLanguageModels");class r{constructor(t,v){this.option=t,this.stream=new f.$Qh,this.stream=v??new f.$Qh}}class i{constructor(){this.a=new Map,this.b=new f.$Qh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let v=this.a.get(t.index);v||(this.a.size===0?v=new r(t.index,this.b):v=new r(t.index),this.a.set(t.index,v)),v.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const v of this.f())v.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,v,c){this.j=v,this.k=c,this.c=new E.$_d,this.d=new E.$_d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new d.$Km,this.i=new Map,this.o=new Set,this.b=t.getProxy(O.$xM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,v,c,$){const b=s.a++;this.f.set(b,{extension:t.identifier,provider:c,languageModelId:v});let p;return $.auth&&(p={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(b,v,{extension:t.identifier,identifier:v,model:$.name??"",auth:p}),(0,I.$Sc)(()=>{this.f.delete(b),this.b.$unregisterProvider(b)})}async $provideLanguageModelResponse(t,v,c,$,b,p){const l=this.f.get(t);if(!l)return;const D=new M.$Wv(async g=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:g.index,part:g.part})});return l.provider.provideLanguageModelResponse2($.map(R.LanguageModelMessage.to),b,d.$Im.toKey(c),D,p)}$updateLanguageModels(t){const v=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),v.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[b,p]of this.i)p.languageModelId===$&&(p.res.reject(new u.$5),this.i.delete(b))}this.d.fire(Object.freeze({added:Object.freeze(v),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const v=new Array;for(const{from:c,to:$,enabled:b}of t){const p=this.h.get(c)??new d.$Jm;if(p.has($)!==b){b?p.add($):p.delete($),this.h.set(c,p);const D={from:c,to:$};v.push(D),this.c.fire(D)}}}async sendChatRequest(t,v,c,$,b){const p=t.identifier,l=await this.b.$prepareChatAccess(p,v,$.justification);if(!l||!this.g.has(v))throw N.$HO.NotFound(`Language model '${v}' is unknown.`);if(this.m(p,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(p)?.has(l.extension)))throw N.$HO.NoPermissions(`Language model '${v}' cannot be used by '${p.value}'.`);const D=Math.random()*1e6|0,g=this.b.$fetchResponse(p,v,D,c.map(R.LanguageModelMessage.from),$.modelOptions??{},b),S=new f.$mh,k=new i;this.i.set(D,{languageModelId:v,res:k});let P;if(g.catch(C=>{S.isOpen()?k.reject(C):P=C}).finally(()=>{this.i.delete(D),k.resolve(),S.open()}),await S.wait(),P)throw new N.$HO(`Language model '${v}' errored, check cause for more details`,"Unknown",P);return k.apiObject}async $handleResponseFragment(t,v){const c=this.i.get(t);c&&c.res.handleFragment(v)}async l(t,v,c,$){const b=y.$zL+v.identifier.value;if(await this.k.getSession(t,b,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,T.localize)(0,null,v.displayName,c):(0,T.localize)(1,null,v.displayName);return await this.k.getSession(t,b,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0}catch{return!1}}m(t,v){return!!v.auth&&!d.$Im.equals(v.extension,t)}async n(t){for(const v of this.o)try{await this.l(v,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const v=this,c=E.Event.signal(E.Event.filter(this.c.event,b=>d.$Im.equals(b.from,t.identifier))),$=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,$)},canSendRequest(b){const p=v.g.get(b);if(!p)return;if(!v.m(t.identifier,p))return!0;const l=v.h.get(t.identifier);if(l)return l.has(p.extension)}}}};e.$ckc=a,e.$ckc=a=s=Je([We(0,m.$UO),We(1,o.$Tj),We(2,n.$9jc)],a)}),define(Pe[263],Re([1,0,4,8,7,32,11,6,25]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class E{constructor(y,u,w,m){this.c=u,this.d=w,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(I.$xM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const w=this.c.getDocumentData(y);if(!w)throw new Error(`document '${y.toString()}' NOT found`);return w.document}async tokenAtPosition(y,u){const w=y.version,m=O.Position.from(u),n=await this.a.$tokensAtPosition(y.uri,m),o={type:R.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new R.$BM(u.line,u.character,u.line,u.character)};if(!n)return o;const s={range:O.Range.to(n.range),type:O.TokenType.to(n.type)};return!s.range.contains(u)||w!==y.version?o:s}createLanguageStatusItem(y,u,w){const m=this.f++,n=this.a,o=this.g,s=`${y.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const r={selector:w,id:u,name:y.displayName??y.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new d.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$ph)(()=>{a.clear(),this.a.$setLanguageStatus(m,{id:s,name:r.name??y.displayName??y.name,source:y.displayName??y.name,selector:O.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===R.LanguageStatusSeverity.Error?N.default.Error:r.severity===R.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),n.$removeLanguageStatus(m),o.delete(s)},get id(){return r.id},get name(){return r.name},set name(v){r.name=v,h()},get selector(){return r.selector},set selector(v){r.selector=v,h()},get text(){return r.text},set text(v){r.text=v,h()},set text2(v){(0,f.$hG)(y,"languageStatusText"),r.text=v,h()},get text2(){return(0,f.$hG)(y,"languageStatusText"),r.text},get detail(){return r.detail},set detail(v){r.detail=v,h()},get severity(){return r.severity},set severity(v){r.severity=v,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(v){r.accessibilityInformation=v,h()},get command(){return r.command},set command(v){r.command=v,h()},get busy(){return r.busy},set busy(v){r.busy=v,h()}};return h(),t}}e.$ulc=E}),define(Pe[264],Re([1,0,12,2,8,7,83]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=void 0;class d{constructor(y,u,w,m){this.start=y,this.deletedCount=u,this.deletedItems=w,this.items=m}asApiEvent(){return{range:new N.$1N(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,w){this.notebook=y,this.h=u,this.j=w,this.handle=w.handle,this.uri=O.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(w)}return this.f}setOutputs(y){this.a=y.map(R.NotebookCellOutput.to)}setOutputItems(y,u,w){const m=w.map(R.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===y);if(n&&(u||(n.items.length=0),n.items.push(...m),n.items.length>1&&n.items.every(o=>M.$uK(o.mime)))){const o=new Map,s=[];n.items.forEach(r=>{let i;o.has(r.mime)?i=o.get(r.mime):(i=[],o.set(r.mime,i),s.push(r.mime)),i.push(r.data)}),n.items.length=0,s.forEach(r=>{const i=M.$vK(o.get(r));n.items.push({mime:r,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$glc=f;class E{static{this.a=0}constructor(y,u,w,m,n){this.k=y,this.l=u,this.m=w,this.uri=m,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(w){return w=y.n(w),y.b[w].apiCell},getCells(w){return(w?y.p(w):y.b).map(n=>n.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,w){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:w});const m={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},n=[];for(const s of y.rawEvents)s.kind===M.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,m.contentChanges):s.kind===M.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,m.contentChanges):s.kind===M.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===M.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),n.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),n.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<n.length;s++){const r=n[s],i=o.get(r.cell);if(i===void 0){const a=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,a-1)}else m.cellChanges[i]={...m.cellChanges[i],...r}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,w=y.end|0;return u<0&&(u=0),w>this.b.length&&(w=this.b.length),y.with({start:u,end:w})}p(y){y=this.o(y);const u=[];for(let w=y.start;w<y.end;w++)u.push(this.b[w]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,w){if(this.j)return;const m=[],n=[],o=[];if(y.reverse().forEach(s=>{const i=s[2].map(t=>{const v=new f(this,this.l,t);return u||n.push(f.asModelAddData(t)),v}),a=new d(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);m.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),w)for(const s of m)w.push(s.asApiEvent())}s(y,u,w,m){const n=this.b.splice(y,u);this.b.splice(w,0,...n);const o=[new d(y,u,n.map(s=>s.apiCell),[]),new d(w,0,[],n)];for(const s of o)m.push(s.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,w,m){this.b[y].setOutputItems(u,w,m)}v(y,u){const w=this.b[y];w.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(w.uri,u)}w(y,u){const w=this.b[y];w.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$hlc=E}),define(Pe[265],Re([1,0,5,2,8,7,34]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class d{constructor(E,T,y,u={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=y,this.f=u,this.a=new I.$be}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,y,u)=>{const w=function(n){T.call(y,n)};return w.extension=E,this.a.event(w,void 0,u)}}async $participateInSave(E,T,y){const u=O.URI.revive(E),w=this.c.getNotebookDocument(u);if(!w)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},y,async(o,s)=>{const r=Date.now(),i=await await Promise.resolve(o);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof N.$JM?m.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const n={edits:[]};for(const o of m){const{edits:s}=R.WorkspaceEdit.from(o);n.edits=n.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new M.$jw(n))}}e.$wlc=d}),define(Pe[112],Re([1,0,14,8,7]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(d,f,E,T,y,u){this.id=d,this.f=f,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=T,this.c=u}get apiEditor(){if(!this.e){const d=this;this.e={get notebook(){return d.notebookData.apiNotebook},get selection(){return d.a[0]},set selection(f){this.selections=[f]},get selections(){return d.a},set selections(f){if(!Array.isArray(f)||!f.every(R.$1N.isNotebookRange))throw(0,I.$7)("selections");d.a=f,d.g(f)},get visibleRanges(){return d.b},revealRange(f,E){d.f.$tryRevealRange(d.id,O.NotebookRange.from(f),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return d.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(d){this.d=d}_acceptVisibleRanges(d){this.b=d}_acceptSelections(d){this.a=d}g(d){this.f.$trySetSelections(this.id,d.map(O.NotebookRange.from))}_acceptViewColumn(d){this.c=d}}e.$ilc=N}),define(Pe[266],Re([1,0,5,13,8]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;let N=class{constructor(d,f){this.c=d,this.d=f,this.a=new I.$_d,this.b=new I.$_d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(d,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",d,f);const E=this.d.getEditorById(d);f.visibleRanges&&E._acceptVisibleRanges(f.visibleRanges.ranges.map(R.NotebookRange.to)),f.selections&&E._acceptSelections(f.selections.selections.map(R.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(d){for(const f in d)this.d.getEditorById(f)._acceptViewColumn(R.ViewColumn.to(d[f]))}};e.$ylc=N,e.$ylc=N=Je([We(0,O.$Tj)],N)}),define(Pe[267],Re([1,0,5,4,112]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;class N{constructor(d,f){this.c=f,this.a=new Map,this.b=d.getProxy(O.$xM.MainThreadNotebookRenderers)}$postRendererMessage(d,f,E){const T=this.c.getEditorById(d);this.a.get(f)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(d,f){if(!d.contributes?.notebookRenderer?.some(T=>T.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(T,y,u)=>this.d(f).event(T,y,u),postMessage:(T,y)=>{R.$ilc.apiEditorsToExtHost.has(T)&&([T,y]=[y,T]);const u=y&&R.$ilc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,f,T)}}}d(d){let f=this.a.get(d);return f||(f=new I.$_d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(d)}}),this.a.set(d,f),f)}}e.$Blc=N}),define(Pe[268],Re([1,0,8,101,24,68,14]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class d{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,w){const m=this.b++,{title:n,location:o,cancellable:s}=u,r={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:n,source:r,cancellable:s},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,w,!!s)}d(y,u,w){let m;w&&(m=new R.$je,this.c.set(y,m));const n=s=>{this.a.$progressEnd(s),this.c.delete(s),m?.dispose()};let o;try{o=u(new E(this.a,y),w&&m?m.token:R.CancellationToken.None)}catch(s){throw n(y),s}return o.then(s=>n(y),s=>n(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$Flc=d;function f(T,y){return T.message=y.message,typeof y.increment=="number"&&(typeof T.increment=="number"?T.increment+=y.increment:T.increment=y.increment),T}class E extends O.$Wv{constructor(y,u){super(w=>this.throttledReport(w)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,N.$Th)(100,(T,y)=>f(T,y),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Pe[269],Re([1,0,2,4,11,8]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class M{static{this.a=0}constructor(f,E){this.d=E,this.c=new Map,this.b=f.getProxy(O.$xM.MainThreadQuickDiff)}$provideOriginalResource(f,E,T){const y=I.URI.revive(E),u=this.c.get(f);return u?(0,R.$fh)(()=>u.provideOriginalResource(y,T)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(f,E,T,y){const u=M.a++;return this.c.set(u,E),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(f,this.d),T,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Glc=M}),define(Pe[270],Re([1,0,24,5,6,4,2,7,14,18,32,41,25,8]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=m;function m(n,o,s){const r=n.getProxy(N.$xM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,g,S=I.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),P=++this.f,C=r.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},S),W={},V=C.then(()=>W);return Promise.race([V,k]).then(q=>{if(q===W)return;const A=(0,u.$gG)(l,"quickPickItemTooltip");return k.then(U=>{const K=[];for(let ie=0;ie<U.length;ie++){const fe=U[ie];if(typeof fe=="string")K.push({label:fe,handle:ie});else if(fe.kind===d.QuickPickItemKind.Separator)K.push({type:"separator",label:fe.label});else{fe.tooltip&&!A&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const Se=fe.iconPath?c(fe.iconPath):void 0;K.push({label:fe.label,iconPath:Se?.iconPath,iconClass:Se?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(fe.tooltip):void 0,handle:ie})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=ie=>{g.onDidSelectItem(U[ie])}),r.$setItems(P,K),C.then(ie=>{if(typeof ie=="number")return U[ie];if(Array.isArray(ie))return ie.map(fe=>U[fe])})})}).then(void 0,q=>{if(!(0,f.$4)(q))return r.$setError(P,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,r.$input(l,typeof this.d=="function",D).then(void 0,g=>{if(!(0,f.$4)(g))return Promise.reject(g)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let g;switch(D.severity){case d.InputBoxValidationSeverity.Info:g=T.default.Info;break;case d.InputBoxValidationSeverity.Warning:g=T.default.Warning;break;case d.InputBoxValidationSeverity.Error:g=T.default.Error;break;default:g=D.message?T.default.Error:T.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!g)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(k=>k.uri.toString()===g.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new b(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,g){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,g)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$_d,this.q=new O.$_d,this.r=new O.$_d,this.s=new O.$_d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,g)=>{const S=D===d.$XN.Back?-1:g;this.o.set(S,D)}),this.z({buttons:l.map((D,g)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===d.$XN.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const g=l[D];this.u[D]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(p){if(p instanceof d.$vN)return{id:p.id};const l=v(p),D=t(p);return{dark:typeof l=="string"?M.URI.file(l):l,light:typeof D=="string"?M.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function v(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const l=h(p);let D,g;return"id"in l?g=y.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:g}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$_d,this.L=[],this.M=new O.$_d,this.N=new O.$_d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,k)=>{this.C.set(k,S),this.D.set(S,k)});const D=(0,u.$gG)(this.O,"quickPickItemTooltip"),g=[];for(let S=0;S<l.length;S++){const k=l[S];if(k.kind===d.QuickPickItemKind.Separator)g.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?c(k.iconPath):void 0;g.push({handle:S,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?w.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((C,W)=>({...c(C.iconPath),tooltip:C.tooltip,handle:W}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,E.$Hb)(l.map(g=>this.C.get(g)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,E.$Hb)(l.map(g=>this.C.get(g)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const g=this.C.get(l);if(!g||!g.buttons||!g.buttons.length)return;const S=g.buttons[D];S&&this.N.fire({button:S,item:g})}}class b extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:T.default.Error}):this.z({validationMessage:l.message,severity:l.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(o,s)}}),define(Pe[271],Re([1,0,2,5,68,6,11,4,18,143,13,20,41,8,25,12,21]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=e.$Ilc=void 0;function r(P){return P instanceof I.URI}function i(P,C){return P.scheme===n.Schemas.file&&C.scheme===n.Schemas.file&&o.$k?P.toString()===C.toString():P.toString().toLowerCase()===C.toString().toLowerCase()}function a(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||u.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function h(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(u.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const C=P.icon;return{light:C.light,dark:C.dark}}}else return}function t(P,C){if(!P.iconPath&&!C.iconPath)return 0;if(P.iconPath){if(!C.iconPath)return 1}else return-1;const W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,E.$fr)(W,V)}function v(P,C){let W=0;if(P.strikeThrough!==C.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==C.faded)return P.faded?1:-1;if(P.tooltip!==C.tooltip)return(P.tooltip||"").localeCompare(C.tooltip||"");if(W=t(P,C),W!==0)return W;if(P.light&&C.light)W=t(P.light,C.light);else{if(P.light)return 1;if(C.light)return-1}if(W!==0)return W;if(P.dark&&C.dark)W=t(P.dark,C.dark);else{if(P.dark)return 1;if(C.dark)return-1}return W}function c(P,C){if(P.command!==C.command)return P.command<C.command?-1:1;if(P.title!==C.title)return P.title<C.title?-1:1;if(P.tooltip!==C.tooltip){if(P.tooltip!==void 0&&C.tooltip!==void 0)return P.tooltip<C.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(P.arguments===C.arguments)return 0;if(P.arguments)if(C.arguments){if(P.arguments.length!==C.arguments.length)return P.arguments.length-C.arguments.length}else return 1;else return-1;for(let W=0;W<P.arguments.length;W++){const V=P.arguments[W],q=C.arguments[W];if(V!==q&&!(r(V)&&r(q)&&i(V,q)))return V<q?-1:1}return 0}function $(P,C){let W=(0,E.$fr)(P.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(W!==0)return W;if(P.command&&C.command)W=c(P.command,C.command);else{if(P.command)return 1;if(C.command)return-1}if(W!==0)return W;if(P.decorations&&C.decorations)W=v(P.decorations,C.decorations);else{if(P.decorations)return 1;if(C.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&C.multiFileDiffEditorModifiedUri)W=(0,E.$fr)(P.multiFileDiffEditorModifiedUri.fsPath,C.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(C.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&C.multiDiffEditorOriginalUri)W=(0,E.$fr)(P.multiDiffEditorOriginalUri.fsPath,C.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(C.multiDiffEditorOriginalUri)return-1}return W}function b(P,C){for(let W=0;W<P.length;W++)if(P[W]!==C[W])return!1;return!0}function p(P,C){return P.command===C.command&&P.title===C.title&&P.tooltip===C.tooltip&&(P.arguments&&C.arguments?b(P.arguments,C.arguments):P.arguments===C.arguments)}function l(P,C){return(0,f.$ub)(P,C,p)}class D{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.l,C),this.n(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.l,C),this.f=C}get validateInput(){return(0,m.$hG)(this.k,"scmValidation"),this.g}set validateInput(C){if((0,m.$hG)(this.k,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.l,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.l,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.l,C))}get document(){return(0,m.$hG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(C,W,V,q,A){this.k=C,this.l=q,this.m=A,this.d="",this.e=new O.$_d,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(C,W){(0,m.$hG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,C,W)}$onInputBoxValueChange(C){this.n(C)}n(C){this.d=C,this.e.fire(C)}}e.$Ilc=D;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,W,V,q,A,U,K){this.q=C,this.s=W,this.t=V,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$_d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$_d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,W){const V=this.h.get(C);return V?(0,M.$fh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort($),V=(0,f.$Db)(this.o,C,$).map(U=>{const K=U.toInsert.map(ie=>{const fe=this.e++;this.g.set(fe,ie);const Se=ie.resourceUri;let ke;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const de=new N.$Tc;ke=this.s.converter.toInternal(ie.command,de),this.j.set(fe,de)}else this.h.set(fe,ie.command);const oe=(0,m.$gG)(this.w,"scmMultiDiffEditor"),$e=oe?ie.multiDiffEditorOriginalUri:void 0,ne=oe?ie.multiFileDiffEditorModifiedUri:void 0,Ie=a(ie.decorations),ze=ie.decorations&&a(ie.decorations.light)||Ie,re=ie.decorations&&a(ie.decorations.dark)||Ie,L=[ze,re],_=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Te=ie.decorations&&!!ie.decorations.faded,Ee=ie.contextValue||"";return{rawResource:[fe,Se,L,_,ve,Te,Ee,ke,$e,ne],handle:fe}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=V.map(({start:U,deleteCount:K,toInsert:ie})=>[U,K,ie.map(fe=>fe.rawResource)]),A=V.reverse();for(const{start:U,deleteCount:K,toInsert:ie}of A){const fe=ie.map(ke=>ke.handle),Se=this.n.splice(U,K,...fe);for(const ke of Se)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=C,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.w,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let W;(0,m.$gG)(this.x,"quickDiffProvider")&&(W=C?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!C,quickDiffLabel:W})}get historyProvider(){return(0,m.$hG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(C){(0,m.$hG)(this.x,"scmHistoryProvider"),this.j=C,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!C}),C&&this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(C){C!==this.m&&(this.m=C,this.#e.$updateSourceControl(this.w,{commitTemplate:C}))}get acceptInputCommand(){return this.o}set acceptInputCommand(C){this.n.value=new N.$Tc,this.o=C;const W=this.y.converter.toInternal(C,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,m.$hG)(this.x,"scmActionButton"),this.q}set actionButton(C){(0,m.$hG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=C;const W=C!==void 0?{command:this.y.converter.toInternal(C.command,this.p.value),secondaryCommands:C.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(C){if(this.t&&C&&l(this.t,C))return;this.s.value=new N.$Tc,this.t=C;const W=(C||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(C,W,V,q,A,U,K){this.x=C,this.y=q,this.z=A,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$_d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=I.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(C,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,U,K,ie)}createResourceGroup(C,W,V){const q=(0,m.$gG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,A=new g(this.#e,this.y,this.w,C,W,q,this.x),U=O.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,U),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const C=[],W=[];for(const[V,q]of this.C){q.dispose();const A=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});O.Event.once(V.onDidDispose)(()=>{this.D.delete(V),A.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),C.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const U=V._takeResourceStateSnapshot();U.length>0&&W.push([V.handle,U]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,C,W),this.C.clear()}eventuallyUpdateResourceStates(){const C=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&C.push([W.handle,V])}),C.length>0&&this.#e.$spliceResourceStates(this.w,C),this.D.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.u=C,this.v.fire(C)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Sh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Sh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new y.$Km,this.j=new O.$_d,this.e=C.getProxy(d.$xM.MainThreadSCM),this.f=C.getProxy(d.$xM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const U=this.g.get(A.sourceControlHandle);if(!U)return A;const K=U.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const U=this.g.get(A.sourceControlHandle);return U?U.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const U=this.g.get(A.handle);return U||A}return A}})}createSourceControl(C,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const A=s.d++,U=new S(C,this.m,this.e,this.l,W,V,q);this.g.set(A,U);const K=this.h.get(C.identifier)||[];return K.push(U),this.h.set(C.identifier,K),U}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const W=this.h.get(C.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(C,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",C,q.toString());const A=this.g.get(C);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$fh)(()=>A.quickDiffProvider.provideOriginalResource(q,V)).then(U=>U||null)}$onInputBoxValueChange(C,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const V=this.g.get(C);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(C,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",C,W,V);const A=this.g.get(C);if(!A)return Promise.resolve(void 0);const U=A.getResourceGroup(W);return U?U.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(C,W,V){this.n.trace("ExtHostSCM#$validateInput",C);const q=this.g.get(C);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$fh)(()=>q.inputBox.validateInput(W,V)).then(A=>{if(!A)return Promise.resolve(void 0);const U=w.MarkdownString.fromStrict(A.message);return U?Promise.resolve([U,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(C,W,V,q){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(C,W,V,q){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(C,W,V,q){const A=this.g.get(C)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const U=await A.provideHistoryItemSummary(W,V,q);return U?{...U,icon:h(U)}:void 0}async $provideHistoryItemChanges(C,W,V,q){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$Jlc=k,e.$Jlc=k=s=Je([We(3,T.$Tj)],k)}),define(Pe[272],Re([1,0,4,8,2]),function(ge,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class N{static{this.a=0}constructor(d,f){this.d=f,this.c=new Map,this.b=d.getProxy(I.$xM.MainThreadShare)}async $provideShare(d,f,E){return await this.c.get(d)?.provideShare({selection:O.Range.to(f.selection),resourceUri:R.URI.revive(f.resourceUri)},E)??void 0}registerShareProvider(d,f){const E=N.a++;return this.c.set(E,f),this.b.$registerShareProvider(E,O.DocumentSelector.from(d,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Klc=N}),define(Pe[273],Re([1,0,7,4,170,6,8,17]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Mlc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$wN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$wN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,w,m,n,o,s=I.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=u,this.#t=w,o&&n){this.c=(0,I.$$M)(n.identifier,o);const i=m.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,r=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(f.a++);this.e=n,this.f=o,this.g=s,this.h=this.u(r)}u(u){if((0,d.$5f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!f.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=f.b.get(this.o.id));const n=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,w,this.k,n,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Mlc=f;class E{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const w={message:u};return this.b.unshift(w),this.c(),new I.$zM(()=>{const m=this.b.indexOf(w);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(u,w){this.e=new Map,this.a=u.getProxy(O.$xM.MainThreadStatusBar),this.b=w,this.c=new E(this)}$acceptStaticEntries(u){for(const w of u)this.e.set(w.entryId,w)}createStatusBarEntry(u,w,m,n){return new f(this.a,this.b,this.e,u,w,m,n)}setStatusBarMessage(u,w){const m=this.c.setMessage(u);let n;return typeof w=="number"?n=setTimeout(()=>m.dispose(),w):typeof w<"u"&&w.then(()=>m.dispose(),()=>m.dispose()),new I.$zM(()=>{m.dispose(),clearTimeout(n)})}}e.$Nlc=T}),define(Pe[113],Re([1,0,29,105,50,75,61,8,2]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=e.$8O=e.$7O=void 0;const E=(i,a,h,t)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(c){if(!h(v,c)){const $=v;v=c,i.listener?.(t(c,$))}}}},T=(i,a)=>i===a,y={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),w=(i,a)=>({range:(()=>{let h;const t=u(v=>({range:I.$ht.lift(d.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return h},set(v){i.listener?.({op:6}),y.range(h,v)||(h=v,i.listener?.(t(v)))}}})(),label:E(i,a,y.label,u(h=>({label:h}))),description:E(i,void 0,y.description,u(h=>({description:h}))),sortText:E(i,void 0,y.sortText,u(h=>({sortText:h}))),canResolveChildren:E(i,!1,y.canResolveChildren,h=>({op:2,state:h})),busy:E(i,!1,y.busy,u(h=>({busy:h}))),error:E(i,void 0,y.error,u(h=>({error:d.MarkdownString.fromStrict(h)||null}))),tags:E(i,[],y.tags,(h,t)=>({op:1,new:h.map(d.TestTag.from),old:t.map(d.TestTag.from)}))}),m=i=>{const a=R.$jL.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,f.URI.revive(i.uri)||void 0);return h.range=d.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>d.TestTag.to({id:(0,M.$pL)(t).tagId})),h},n=i=>{let a;for(const h of i.tests){const t=m(h.item);(0,O.$QO)(t).parent=a,a=t}return a};e.$7O=n;class o{constructor(a,h,t,v){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,O.$PO)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,N.$OO)(c,O.$QO,o),enumerable:!0,writable:!1},...w(c,t)})}}e.$8O=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$9O=s;class r extends N.$KO{constructor(a,h,t){super({controllerId:a,getDocumentVersion:v=>v&&t.getDocument(v)?.version,getApiFor:O.$QO,getChildren:v=>v.children,root:new s(a,h),toITestItem:d.TestItem.from})}}e.$0O=r}),define(Pe[31],Re([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,22,34,42,65,59,62,35]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=void 0;let c=class{#e;#t;#i;constructor(g,S,k){this.b=new Map,this.c=new Map,this.#e=g.getProxy(M.$xM.MainThreadCommands),this.d=S,this.#i=k,this.#t=g.getProxy(M.$xM.MainThreadTelemetry),this.converter=new $(this,P=>{const C=this.c.get(P);return C?.result===p.Void?C:void 0},S),this.f=[{processArgument(P){return(0,E.$Wh)(P)}},{processArgument(P){return(0,N.$Vn)(P,function(C){if(T.$ht.isIRange(C))return R.Range.to(C);if(y.$gt.isIPosition(C))return R.Position.to(C);if(T.$ht.isIRange(C.range)&&u.URI.isUri(C.uri))return R.location.to(C);if(C instanceof s.$ze)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const S=this.registerCommand(!1,g.id,async(...k)=>{const P=g.args.map((W,V)=>{if(!W.validate(k[V]))throw new Error(`Invalid argument '${W.name}' when running '${g.id}', received: ${typeof k[V]=="object"?JSON.stringify(k[V],null,"	"):k[V]} `);return W.convert(k[V])}),C=await this.executeCommand(g.internalId,...P);return g.result.convert(C,k,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new O.$zM(()=>{S.dispose(),this.c.delete(g.id)})}registerCommand(g,S,k,P,C,W){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:k,thisArg:P,metadata:C,extension:W}),g&&this.#e.$registerCommand(S),new O.$zM(()=>{this.b.delete(S)&&g&&this.#e.$unregisterCommand(S)})}executeCommand(g,...S){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,S,!0)}async g(g,S,k){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,S,!1);{let P=!1;const C=(0,N.$Vn)(S,function(W){if(W instanceof O.$AM)return R.Position.from(W);if(W instanceof O.$BM)return R.Range.from(W);if(W instanceof O.$LM)return R.location.from(W);if(O.$1N.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return P=!0,s.$ze.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return P=!0,s.$ze.wrap(W);if(W instanceof s.$ze)return P=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(g,P?new r.$jw(C):C,k);return(0,E.$Wh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(g,S,!1);throw W}}}async h(g,S,k){const P=this.b.get(g);if(!P)throw new Error("Unknown command");const{callback:C,thisArg:W,metadata:V}=P;if(V?.args)for(let A=0;A<V.args.length;A++)try{(0,I.$fg)(S[A],V.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${V.args[A].name}' - ${V.args[A].description}`)}const q=a.$8d.create();try{return await C.apply(W,S)}catch(A){if(g===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...S);U&&(g=U.command)}if(this.d.error(A,g,P.extension?.identifier),!k)throw A;if(P.extension?.identifier){const U=this.#i.onExtensionError(P.extension.identifier,A);this.d.trace("forwarded error to extension?",U,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$$i)(A)),this.id=g,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,g,q.elapsed())}}j(g,S,k){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new h.$9o(S),duration:k})}$executeContributedCommand(g,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const k=this.b.get(g);return k?(S=S.map(P=>this.f.reduce((C,W)=>W.processArgument(C,k.extension?.identifier),P)),this.h(g,S,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(S=>(g&&(S=S.filter(k=>k[0]!=="_")),S))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[S,k]of this.b){const{metadata:P}=k;P&&(g[S]=P)}return Promise.resolve(g)}};e.$dP=c,e.$dP=c=Je([We(0,n.$UO),We(1,f.$Tj),We(2,t.$cP)],c),e.$eP=(0,m.$ni)("IExtHostCommands");class ${constructor(g,S,k){this.d=g,this.f=S,this.g=k,this.delegatingCommandId=`__vsc${(0,v.$Jg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,S){if(!g)return;const k={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return k;const P=this.f(g.command);if(P)k.id=P.internalId,k.arguments=P.args.map((C,W)=>C.convert(g.arguments&&g.arguments[W]));else if((0,d.$Lb)(g.arguments)){const C=`${g.command} /${++this.c}`;this.b.set(C,g),S.add((0,w.$Sc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),k.$ident=C,k.id=this.delegatingCommandId,k.arguments=[C],this.g.trace("CommandsConverter#CREATE",g.command,C)}return k}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const S=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$fP=$;class b{static{this.Uri=new b("uri","Uri of a text document",g=>u.URI.isUri(g),g=>g)}static{this.Position=new b("position","A position in a text document",g=>O.$AM.isPosition(g),R.Position.from)}static{this.Range=new b("range","A range in a text document",g=>O.$BM.isRange(g),R.Range.from)}static{this.Selection=new b("selection","A selection in a text document",g=>O.$CM.isSelection(g),R.Selection.from)}static{this.Number=new b("number","",g=>typeof g=="number",g=>g)}static{this.String=new b("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=b.Arr(b.String)}static Arr(g){return new b(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,S=>Array.isArray(S)&&S.every(k=>g.validate(k)),S=>S.map(k=>g.convert(k)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",g=>g instanceof O.$WM,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",g=>g instanceof O.$iO,R.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",g=>g instanceof o.$8O,R.TestItem.from)}constructor(g,S,k,P){this.name=g,this.description=S,this.validate=k,this.convert=P}optional(){return new b(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,S){return new b(g??this.name,S??this.description,this.validate,this.convert)}}e.$gP=b;class p{static{this.Void=new p("no result",g=>g)}constructor(g,S){this.description=g,this.convert=S}}e.$hP=p;class l{constructor(g,S,k,P,C){this.id=g,this.internalId=S,this.description=k,this.args=P,this.result=C}}e.$iP=l}),define(Pe[274],Re([1,0,18,12,2,87,97,33,31,8,7]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;const y=[new f.$iP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of DocumentHighlight-instances.",w(E.DocumentHighlight.to))),new f.$iP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$gP.Uri],new f.$hP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,I.$Kb)(n))return;class s extends T.$RM{static to(i){const a=new s(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new T.$LM(o[0],E.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=E.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return n.map(s.to)})),new f.$iP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$gP.Uri,new f.$gP("options","Formatting options",n=>!0,n=>n)],new f.$hP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new f.$iP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$gP.Uri,f.$gP.Range,new f.$gP("options","Formatting options",n=>!0,n=>n)],new f.$hP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new f.$iP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$gP.Uri,f.$gP.Position,new f.$gP("ch","Trigger character",n=>typeof n=="string",n=>n),new f.$gP("options","Formatting options",n=>!0,n=>n)],new f.$hP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new f.$iP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$iP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$iP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$iP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$iP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of Location-instances.",w(E.location.to))),new f.$iP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of Hover-instances.",w(E.Hover.to))),new f.$iP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$gP.Uri,new f.$gP("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>T.$AM.isPosition(o)),n=>n.map(E.Position.from))],new f.$hP("A promise that resolves to an array of ranges.",n=>n.map(o=>{let s;for(const r of o.reverse())s=new T.$VM(E.Range.to(r),s);return s}))),new f.$iP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$gP.String.with("query","Search string")],new f.$hP("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(E.WorkspaceSymbol.to))),new f.$iP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(E.CallHierarchyItem.to))),new f.$iP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$gP.CallHierarchyItem],new f.$hP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(E.CallHierarchyIncomingCall.to))),new f.$iP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$gP.CallHierarchyItem],new f.$hP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(E.CallHierarchyOutgoingCall.to))),new f.$iP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:E.Range.to(n.range),placeholder:n.text}})),new f.$iP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$gP.Uri,f.$gP.Position,f.$gP.String.with("newName","The new symbol name")],new f.$hP("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return E.WorkspaceEdit.to(n)}})),new f.$iP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$gP.Uri,f.$gP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$hP("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(E.DocumentLink.to))),new f.$iP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$gP.Uri],new f.$hP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new T.$RN(n.tokenTypes,n.tokenModifiers)})),new f.$iP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$gP.Uri],new f.$hP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$1ab)(n);if(o.type==="full")return new T.$TN(o.data,void 0)})),new f.$iP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$gP.Uri,f.$gP.Range.optional()],new f.$hP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new T.$RN(n.tokenTypes,n.tokenModifiers)})),new f.$iP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$gP.Uri,f.$gP.Range],new f.$hP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$1ab)(n);if(o.type==="full")return new T.$TN(o.data,void 0)})),new f.$iP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$gP.Uri,f.$gP.Position,f.$gP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$gP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$hP("A promise that resolves to a CompletionList-instance.",(n,o,s)=>{if(!n)return new T.$8M([]);const r=n.suggestions.map(i=>E.CompletionItem.to(i,s));return new T.$8M(r,n.incomplete)})),new f.$iP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$gP.Uri,f.$gP.Position,f.$gP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$hP("A promise that resolves to SignatureHelp.",n=>{if(n)return E.SignatureHelp.to(n)})),new f.$iP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$gP.Uri,f.$gP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$hP("A promise that resolves to an array of CodeLens-instances.",(n,o,s)=>w(r=>new T.$ZM(E.Range.to(r.range),r.command&&s.fromInternal(r.command)))(n))),new f.$iP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$gP.Uri,new f.$gP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>T.$BM.isRange(n),n=>T.$CM.isSelection(n)?E.Selection.from(n):E.Range.from(n)),f.$gP.String.with("kind","Code action kind to return code actions for").optional(),f.$gP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$hP("A promise that resolves to an array of Command-instances.",(n,o,s)=>w(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(r.command)}else{const i=new T.$TM(r.title,r.kind?new T.$UM(r.kind):void 0);return r.edit&&(i.edit=E.WorkspaceEdit.to(r.edit)),r.command&&(i.command=s.fromInternal(r.command)),i.isPreferred=r.isPreferred,i}})(n))),new f.$iP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$gP.Uri],new f.$hP("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new T.$bN(E.Range.to(o.range),E.Color.to(o.color))):[])),new f.$iP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$gP("color","The color to show and insert",n=>n instanceof T.$aN,E.Color.from),new f.$gP("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:E.Range.from(n.range)}))],new f.$hP("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(E.ColorPresentation.to):[])),new f.$iP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$gP.Uri,f.$gP.Range],new f.$hP("A promise that resolves to an array of Inlay objects",(n,o,s)=>n.map(E.InlayHint.to.bind(void 0,s)))),new f.$iP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$gP.Uri],new f.$hP("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(E.FoldingRange.to)})),new f.$iP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$hP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new f.$iP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$gP.Uri,f.$gP.Range,new f.$gP("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof T.$BM,n=>E.InlineValueContext.from(n))],new f.$hP("A promise that resolves to an array of InlineValue objects",n=>n.map(E.InlineValue.to))),new f.$iP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$gP("uriOrString","Uri-instance or string (only http/https)",n=>R.URI.isUri(n)||typeof n=="string"&&(0,O.$xg)(n,O.Schemas.http,O.Schemas.https),n=>n),new f.$gP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional(),f.$gP.String.with("label","").optional()],f.$hP.Void),new f.$iP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$gP.Uri.with("resource","Resource to open"),f.$gP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$gP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional()],f.$hP.Void),new f.$iP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$gP.Uri.with("left","Left-hand side resource of the diff editor"),f.$gP.Uri.with("right","Right-hand side resource of the diff editor"),f.$gP.String.with("title","Human readable title for the diff editor").optional(),new f.$gP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)]).optional()],f.$hP.Void),new f.$iP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$gP.String.with("title","Human readable title for the changes editor"),new f.$gP("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[s,r,i]=o;if(!R.URI.isUri(s)||!R.URI.isUri(r)&&r!==void 0&&r!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],f.$hP.Void),new f.$iP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$gP.Uri,f.$gP.Position],new f.$hP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new f.$iP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$gP.TypeHierarchyItem],new f.$hP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new f.$iP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$gP.TypeHierarchyItem],new f.$hP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new f.$iP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$gP.TestItem],f.$hP.Void),new f.$iP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$gP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$hP.Void),new f.$iP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$gP.String.with("name","The context key name"),new f.$gP("value","The context key value",()=>!0,n=>n)],f.$hP.Void),new f.$iP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$gP.Uri,f.$gP.StringArray,new f.$gP("MappedEditsContext","Mapped Edits Context",n=>E.MappedEditsContext.is(n),n=>E.MappedEditsContext.from(n))],new f.$hP("A promise that resolves to a workspace edit or null",n=>n?E.WorkspaceEdit.to(n):null))];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",d.$mj)}}e.$8jc=u;function w(n){return o=>{if(Array.isArray(o))return o.map(n)}}function m(n){if(!Array.isArray(n))return;const o=[];for(const s of n)N.$Yt(s)?o.push(E.DefinitionLink.to(s)):o.push(E.location.to(s));return o}}),define(Pe[275],Re([1,0,11,6,2,4,31,8,7]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class E{static{this.a=0}constructor(w,m){this.extension=w,this.provider=m,this.handle=E.a++}}class T{constructor(w){this.session=w,this.responses=[]}}class y{static{this.a=0}constructor(w,m,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(N.$xM.MainThreadInlineChat),m.registerApiCommand(new M.$iP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$gP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?d.Range.from(s.initialRange):void 0,initialSelection:f.$CM.isSelection(s.initialSelection)?d.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?d.Position.from(s.position):void 0}})],M.$hP.Void))}registerProvider(w,m,n){const o=new E(w,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??w.displayName??w.name,w.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",n?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,m,n,o){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(R.URI.revive(m)),i=d.Selection.to(n),a=await s.provider.prepareInteractiveEditorSession({document:r,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=y.a++;return this.d.set(h,new T(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:d.Range.from(a.wholeRange),message:a.message}}async $provideResponse(w,m,n,o){const s=this.b.get(w);if(!s)return;const r=this.d.get(m.id);if(!r)return;const i={prompt:n.prompt,selection:d.Selection.to(n.selection),wholeRange:d.Range.to(n.wholeRange),attempt:n.attempt,live:n.live,previewDocument:this.f.getDocument(R.URI.revive(n.previewDocument)),withIntentDetection:n.withIntentDetection};let a=!1;const h={report:async D=>{if(!n.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:D.message,edits:D.edits?.map(d.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:f.$1M.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(r.session,i,h,o));let v;try{v=await(0,I.$bh)(t,o)}finally{a=!0}if(!v)return;const c=r.responses.push(v)-1,$={wholeRange:d.Range.from(v.wholeRange),placeholder:v.placeholder};if(!y.h(v))return{...$,id:c,type:"editorEdit",message:d.MarkdownString.from(v.contents),edits:[]};const{edits:b,contents:p}=v,l=p!==void 0?d.MarkdownString.from(p):void 0;return b instanceof f.$JM?{...$,id:c,type:"bulkEdit",edits:d.WorkspaceEdit.from(b),message:l}:{...$,id:c,type:"editorEdit",edits:b.map(d.TextEdit.from),message:l}}async $provideFollowups(w,m,n,o){const s=this.b.get(w),r=this.d.get(m),i=r?.responses[n];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(r.session,i,o));return(await(0,I.$bh)(a,o))?.map(d.ChatInlineFollowup.from)}}$handleFeedback(w,m,n,o){const s=this.b.get(w),r=this.d.get(m),i=r?.responses[n];if(s&&i){const a=d.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(r.session,i,a)}}$releaseSession(w,m){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$flc=y}),define(Pe[276],Re([1,0,2,31]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class R{constructor(M,d,f,E,T){this.a=d,this.b=f,this.c=E;const y=new O.$iP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$gP("showOptions","Show Options",u=>!0,u=>u),new O.$gP("resource","Interactive resource Uri",u=>!0,u=>u),new O.$gP("controllerId","Notebook controller Id",u=>!0,u=>u),new O.$gP("title","Interactive editor title",u=>!0,u=>u)],new O.$hP("Notebook and input URI",u=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const w=this.a.getEditorById(u.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:w.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,d,f,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:d,lines:[""],languageId:f,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,d){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$slc=R}),define(Pe[277],Re([1,0,18,11,24,5,6,28,2,20,13,4,31,8,7,76,217,25,34,218]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0,e.$Alc=b;let a=class{constructor(l,D,g,S,k){this.m=D,this.n=g,this.o=S,this.q=k,this.b=new d.$Bc,this.c=new d.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$_d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(y.$xM.MainThreadNotebookKernels);const P=new u.$iP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$gP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],u.$hP.Void),C=new u.$iP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$gP.Uri],new u.$hP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(C)}createNotebookController(l,D,g,S,k,P){for(const Ie of this.j.values())if(Ie.controller.id===D&&E.$Im.equals(l.identifier,Ie.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const C=this.k++,W=this;this.q.trace(`NotebookController[${C}], CREATED by ${l.identifier.value}, ${D}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${l.identifier}'`);let q=!1;const A=new N.$_d,U=new N.$_d,K={id:b(l.identifier,D),notebookType:g,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:P?P.map(w.NotebookRendererScript.from):[]};let ie=k??V,fe,Se;this.a.$addKernel(C,K).catch(Ie=>{console.log(Ie),q=!0});let ke=0;const oe=()=>{if(q)return;const Ie=++ke;Promise.resolve().then(()=>{Ie===ke&&this.a.$updateKernel(C,K)})},$e=new d.$Bc,ne={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(Ie){K.label=Ie??l.displayName??l.name,oe()},get detail(){return K.detail??""},set detail(Ie){K.detail=Ie,oe()},get description(){return K.description??""},set description(Ie){K.description=Ie,oe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Ie){K.supportedLanguages=Ie,oe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Ie){K.supportsExecutionOrder=Ie,oe()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Ie){ie=Ie??V},get interruptHandler(){return fe},set interruptHandler(Ie){fe=Ie,K.supportsInterrupt=!!Ie,oe()},set variableProvider(Ie){(0,s.$hG)(l,"notebookVariableProvider"),Se=Ie,K.hasVariableProvider=!!Ie,Ie?.onDidChangeVariables(ze=>W.a.$variablesUpdated(ze.uri)),oe()},get variableProvider(){return Se},createNotebookCellExecution(Ie){if(q)throw new Error("notebook controller is DISPOSED");if(!$e.has(Ie.notebook.uri))throw W.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(ze=>ze.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ie.notebook.uri.toString()}`);return W._createNotebookCellExecution(Ie,b(l.identifier,this.id))},createNotebookExecution(Ie){if((0,s.$hG)(l,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!$e.has(Ie.uri))throw W.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(ze=>ze.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ie.uri.toString()}`);return W._createNotebookExecution(Ie,b(l.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${C}], DISPOSED`),q=!0,this.j.delete(C),A.dispose(),U.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(Ie,ze){ze===m.NotebookControllerAffinity2.Hidden&&(0,s.$hG)(l,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(C,Ie.uri,ze)},onDidReceiveMessage:U.event,postMessage(Ie,ze){return(0,s.$hG)(l,"notebookMessaging"),W.a.$postMessage(C,ze&&W.n.getIdByEditor(ze),Ie)},asWebviewUri(Ie){return(0,s.$hG)(l,"notebookMessaging"),(0,n.$vxb)(Ie,W.m.remote)}};return this.j.set(C,{extensionId:l.identifier,controller:ne,onDidReceiveMessage:U,onDidChangeSelection:A,associatedNotebooks:$e}),ne}getIdByController(l){for(const[D,g]of this.j)if(g.controller===l)return b(g.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const g=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(g,D);const k={dispose:()=>{this.f.delete(g),S.a.$removeKernelDetectionTask(g)}};return this.f.set(g,k),k}registerKernelSourceActionProvider(l,D,g){const S=this.i++,k=typeof g.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,P=this;this.h.set(S,g),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let C;return k!==void 0&&(C=g.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(S),P.a.$removeKernelSourceActionProvider(S,S),C?.dispose()}}}async $provideKernelSourceActions(l,D){const g=this.h.get(l);if(g){const S=new M.$Tc;return(await g.provideNotebookKernelSourceActions(D)??[]).map(P=>w.NotebookKernelSourceAction.from(P,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,g){const S=this.j.get(l);if(S){const k=this.n.getNotebookDocument(f.URI.revive(D));g?S.associatedNotebooks.set(k.uri,!0):S.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,k.uri.toString(),g),S.onDidChangeSelection.fire({selected:g,notebook:k.apiNotebook})}}async $executeCells(l,D,g){const S=this.j.get(l);if(!S)return;const k=this.n.getNotebookDocument(f.URI.revive(D)),P=[];for(const C of g){const W=k.getCell(C);W&&P.push(W.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,k.uri.toString(),P.length),await S.controller.executeHandler.call(S.controller,P,k.apiNotebook,S.controller)}catch(C){this.q.error(`NotebookController[${l}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(l,D,g){const S=this.j.get(l);if(!S)return;const k=this.n.getNotebookDocument(f.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,k.apiNotebook);else for(const P of g){const C=k.getCell(P);C&&this.b.get(C.uri)?.cancel()}if(S.controller.interruptHandler){const P=this.c.get(k.uri);g.length&&Array.isArray(P)&&P.length&&P.forEach(C=>C.dispose())}}async $provideVariables(l,D,g,S,k,P,C){const W=this.j.get(l);if(!W)return;const V=this.n.getNotebookDocument(f.URI.revive(g)),q=W.controller.variableProvider;if(!q)return;let A;if(S!==void 0){if(A=this.s[S],!A)return}else this.s={};const U=k==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,A,U,P,C);let ie=0;for await(const fe of K){if(C.isCancellationRequested)return;const Se={id:this.r++,name:fe.variable.name,value:fe.variable.value,type:fe.variable.type,interfaces:fe.variable.interfaces,language:fe.variable.language,expression:fe.variable.expression,hasNamedChildren:fe.hasNamedChildren,indexedChildrenCount:fe.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[Se.id]=fe.variable,this.a.$receiveVariable(D,Se),ie++>=i.$Vhb)return}}$acceptKernelMessageFromRenderer(l,D,g){const S=this.j.get(l);if(!S)return;const k=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:g}))}$cellExecutionChanged(l,D,g){const k=this.n.getNotebookDocument(f.URI.revive(l)).getCell(D);if(k){const P=g?w.NotebookCellExecutionState.to(g):m.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const k=new t(D,S,this.a);this.b.set(S.uri,k);const P=k.onDidChangeState(()=>{k.state===h.Resolved&&(k.dispose(),P.dispose(),this.b.delete(S.uri))});return k.asApiObject()}_createNotebookExecution(l,D){const g=this.n.getNotebookDocument(l.uri),S=l.getCells().find(C=>{const W=g.getCellFromApiCell(C);return W&&this.b.has(W.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const k=new c(D,g,this.a),P=k.onDidChangeState(()=>{k.state===v.Resolved&&(k.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[k,P]),k.asApiObject()}};e.$zlc=a,e.$zlc=a=Je([We(4,T.$Tj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.m=D,this.n=g,this.b=t.a++,this.c=new N.$_d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$je),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new r.$jw(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const g=m.$5N.ensureUniqueMimeTypes(D.items,!0);return g===D.items?w.NotebookCellOutput.from(D):w.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async z(l,D,g){const S=this.w(D),k=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:g,outputs:k})}async C(l,D,g){return l=m.$5N.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(w.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(g){l.j=g,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(g){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,S,k){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const P=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;l.n.$completeExecution(l.b,new r.$jw({runEndTime:S,lastRunSuccess:g,error:P}))},clearOutput(g){return l.t(),l.z([],g,!1)},appendOutput(g,S){return l.t(),l.z(g,S,!0)},replaceOutput(g,S){return l.t(),l.z(g,S,!1)},appendOutputItems(g,S){return l.t(),l.C(g,S,!0)},replaceOutputItems(g,S){return l.t(),l.C(g,S,!1)}})}}var v;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(v||(v={}));class c extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.h=D,this.j=g,this.b=c.a++,this.c=new N.$_d,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new R.$je),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new O.$Kh,this.b=Date.now(),(0,O.$oh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function b(p,l){return`${p.value}/${l}`}}),define(Pe[51],Re([1,0,5,4,3,2,16,6,7,172,14,200,24,35,201,41,11,8,31]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=e.$Nkc=e.$Mkc=void 0,e.$Mkc=(0,R.$ni)("IExtHostTerminalService");class i extends d.$Uc{constructor(g,S,k,P){super(),this.u=g,this._id=S,this.w=k,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$_d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const C=this;this.value={get name(){return C.y||""},get processId(){return C.b},get creationOptions(){return C.w},get exitStatus(){return C.j},get state(){return C.m},get selection(){return C.n},get shellIntegration(){return C.shellIntegration},sendText(W,V=!0){C.C(),C.u.$sendText(C._id,W,V)},show(W){C.C(),C.u.$show(C._id,W)},hide(){C.C(),C.u.$hide(C._id)},dispose(){C.a||(C.a=!0,C.u.$dispose(C._id))},get dimensions(){if(!(C.f===void 0||C.h===void 0))return{columns:C.f,rows:C.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??S?.cwd??void 0,env:g.env??void 0,icon:b(g.iconPath)??void 0,color:n.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(g.location,S?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,S,k,P,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:n.ThemeColor.isThemeColor(C)?C.id:void 0,location:S?.location||this.z(g,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,S){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,S){this.j=Object.freeze({code:g,reason:S})}setDimensions(g,S){return g===this.f&&S===this.h||g===0||S===0?!1:(this.f=g,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(S=>{S!==g&&(this.b=Promise.resolve(g))})}}e.$Nkc=i;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$_d,this.onProcessData=this.a.event,this.b=new I.$_d,this.d=new I.$_d,this.onDidChangeProperty=this.d.event,this.f=new I.$_d,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,S){this.g.setDimensions?.({columns:g,rows:S})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends d.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,S,k){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new d.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$_d,this.onDidCloseTerminal=this.H.event,this.I=new I.$_d,this.onDidOpenTerminal=this.I.event,this.J=new I.$_d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$_d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$_d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$_d,this.onDidChangeShell=this.N.event,this.O=new I.$_d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$_d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$xM.MainThreadTerminalService),this.y=new m.$usb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const C=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(P?.$mid){case 15:return C(P);default:{if(Array.isArray(P))for(let W=0;W<P.length&&P[W].$mid===15;W++)P[W]=C(P[W]);return P}}}}),this.B({dispose:()=>{for(const[P,C]of this.g)C.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,S){const k=new i(this.a,(0,w.$Jg)(),g,g.name),P=new a(g.pty);return k.createExtensionTerminal(g.location,S,this.R(g,S).resolvedExtHostIdentifier,b(g.iconPath),p(g.color)).then(C=>{const W=this.S(C,P);this.h[C]=W}),this.f.push(k),k.value}R(g,S){if(S=S||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const k=g.location.parentTerminal;if(k){const P=this.f.find(C=>C.value===k);P&&(S.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?S.location=g.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(g,S){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new a(S),C=this.S(g,P);this.h[g]=C}async $acceptActiveTerminalChanged(g){const S=this.b;if(g===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(g);k&&(this.b=k,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,S){const k=this.getTerminalById(g);k&&this.O.fire({terminal:k.value,data:S})}async $acceptTerminalDimensions(g,S,k){const P=this.getTerminalById(g);P&&P.setDimensions(S,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,S){const k=this.getTerminalById(g);k&&this.P.fire({terminal:k.value,...S})}async $acceptTerminalMaximumDimensions(g,S,k){this.g.get(g)?.resize(S,k)}async $acceptTerminalTitleChange(g,S){const k=this.getTerminalById(g);k&&(k.name=S)}async $acceptTerminalClosed(g,S,k){const P=this.X(this.f,g);if(P!==null){const C=this.f.splice(P,1)[0];C.setExitStatus(S,k),this.H.fire(C.value)}}$acceptTerminalOpened(g,S,k,P){if(S){const V=this.X(this.f,S);if(V!==null){this.f[V]._id=g,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const C={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:N.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},W=new i(this.a,g,C,k);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(g,S){this.getTerminalById(g)?._setProcessId(S)}async $startExtensionTerminal(g,S){const k=this.getTerminalById(g);if(!k)return{message:(0,E.localize)(0,null,g)};k.isOpen||await new Promise(C=>{const W=this.onDidOpenTerminal(async V=>{V===k.value&&(W.dispose(),C())})});const P=this.g.get(g);P?P.startSendingEvents(S):this.j[g]={initialDimensions:S}}S(g,S){const k=new d.$Tc;k.add(S.onProcessReady(C=>this.a.$sendProcessReady(g,C.pid,C.cwd,C.windowsPty))),k.add(S.onDidChangeProperty(C=>this.a.$sendProcessProperty(g,C))),this.y.startBuffering(g,S.onProcessData),k.add(S.onProcessExit(C=>this.U(g,C))),this.g.set(g,S);const P=this.j[g];return P&&S instanceof a&&(S.startSendingEvents(P.initialDimensions),delete this.j[g]),k}$acceptProcessAckDataEvent(g,S){this.g.get(g)?.acknowledgeDataEvent(S)}$acceptProcessInput(g,S){this.g.get(g)?.input(S)}$acceptTerminalInteraction(g){const S=this.getTerminalById(g);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(g,S){this.getTerminalById(g)?.setSelection(S)}$acceptProcessResize(g,S,k){try{this.g.get(g)?.resize(S,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,S){this.g.get(g)?.shutdown(S)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(S=>this.a.$sendProcessProperty(g,{type:"cwd",value:S}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new f.$zM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,S,k){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,k),this.a.$registerProfileProvider(S,g.identifier.value),new f.$zM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(g,S,k){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,k),this.a.$registerQuickFixProvider(g,S),new f.$zM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,S){const k=new u.$je().token;if(k.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const C=await P.provideTerminalQuickFixes(S,k);if(C===null||Array.isArray(C)&&C.length===0)return;const W=new d.$Tc;if(this.w.value=W,!Array.isArray(C))return C?s.TerminalQuickFix.from(C,this.Q.converter,W):void 0;const V=[];for(const q of C){const A=s.TerminalQuickFix.from(q,this.Q.converter,W);A&&V.push(A)}return V}async $createContributedProfileTerminal(g,S){const k=new u.$je().token;let P=await this.C.get(g)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,S);return}this.createTerminalFromOptions(P.options,S)}}async $provideLinks(g,S){const k=this.getTerminalById(g);if(!k)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const C=new u.$je;this.G.set(g,C);const W=[],V={terminal:k.value,line:S},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async ie=>{C.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const fe=await K.provideTerminalLinks(V,C.token)||[];C.token.isCancellationRequested||ie({provider:K,links:fe})}));const A=await Promise.all(q);if(C.token.isCancellationRequested)return[];const U=new Map;for(const K of A)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const fe={id:h++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return U.set(fe.id,{provider:K.provider,link:ie}),fe}));return this.F.set(g,U),W}$activateLink(g,S){const k=this.F.get(g)?.get(S);k&&k.provider.handleTerminalLink(k.link)}U(g,S){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const k=this.h[g];k&&(k.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,S)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const S=this.f.findIndex(k=>k.value===g);return S>=0?S:null}W(g,S){const k=this.X(g,S);return k!==null?g[k]:null}X(g,S){const k=g.findIndex(P=>P._id===S);return k>=0?k:null}getEnvironmentVariableCollection(g){let S=this.n.get(g.identifier.value);return S||(S=new v,this.Z(g.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(g,S){const k=(0,y.$_r)(S.map),P=(0,y.$as)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(g,S.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(g){g.forEach(S=>{const k=S[0],P=new v(S[1]);this.Z(k,P)})}$acceptDefaultProfile(g,S){const k=this.s;this.s=g,this.u=S,k?.path!==g.path&&this.N.fire(g.path)}Z(g,S){this.n.set(g,S),S.onDidChangeCollection(()=>{this.Y(g,S)})}};e.$Okc=t,e.$Okc=t=Je([We(1,r.$eP),We(2,M.$UO)],t);class v{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$_d,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const S=this.h(g);let k=this.a.get(S);return k||(k=new c(this,g),this.a.set(S,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(g,S,k,P){this.f(g,{value:S,type:f.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(g,S,k,P){this.f(g,{value:S,type:f.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(g,S,k,P){this.f(g,{value:S,type:f.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(g,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(g,S.scope),P=this.map.get(k),C=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==S.value||P.type!==S.type||P.options?.applyAtProcessCreation!==C.applyAtProcessCreation||P.options?.applyAtShellIntegration!==C.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const W=this.g(g,S.scope),V={variable:g,...S,options:C};this.map.set(W,V),this.d.fire()}}get(g,S){const k=this.g(g,S),P=this.map.get(k);return P?l(P):void 0}g(g,S){const k=this.h(S);return k.length?`${g}:::${k}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const S=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(g)&&S.set(P.variable,l(P));return S}delete(g,S){const k=this.g(g,S);this.map.delete(k),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[S,k]of this.map)k.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(S);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,S){const k=this.h(S),P=this.descriptionMap.get(k);if(!P||P.description!==g){let C;typeof g=="string"?C=g:C=g?.value.split(`

`)[0];const W={description:C,scope:S};this.descriptionMap.set(k,W),this.d.fire()}}getDescription(g){const S=this.h(g);return this.descriptionMap.get(S)?.description}k(g){const S=this.h(g);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,S){this.b=g,this.d=S,this.a=new I.$_d}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,S,k){this.b.replace(g,S,k,this.d)}append(g,S,k){this.b.append(g,S,k,this.d)}prepend(g,S,k){this.b.prepend(g,S,k,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,S){this.b.getVariableMap(this.d).forEach((k,P)=>g.call(S,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(g,S){super(!1,g,S)}createTerminal(g,S,k){throw new T.$_}createTerminalFromOptions(g,S){throw new T.$_}};e.$Pkc=$,e.$Pkc=$=Je([We(0,r.$eP),We(1,M.$UO)],$);function b(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return n.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Pe[114],Re([1,0,6,3,4,16,51,5,2,11]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0,e.$5lc=(0,O.$ni)("IExtHostTerminalShellIntegration");let T=class extends I.$Uc{constructor(n,o){super(),this.h=o,this.b=new Map,this.c=new d.$_d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new d.$_d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new d.$_d,this.onDidEndTerminalShellExecution=this.g.event,this.a=n.getProxy(R.$xM.MainThreadTerminalShellIntegration),this.B((0,I.$Sc)(()=>{for(const[s,r]of this.b)r.dispose();this.b.clear()}))}$shellIntegrationChange(n){const o=this.h.getTerminalById(n);if(!o)return;const s=o.value;let r=this.b.get(n);r||(r=new y(o.value,this.f),this.b.set(n,r),r.store.add(o.onWillDispose(()=>this.b.get(n)?.dispose())),r.store.add(r.onDidRequestShellExecution(i=>this.a.$executeCommand(n,i))),r.store.add(r.onDidRequestEndExecution(i=>this.g.fire(i))),r.store.add(r.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),o.shellIntegration=r.value),this.c.fire({terminal:s,shellIntegration:r.value})}$shellExecutionStart(n,o,s){this.b.has(n)||this.$shellIntegrationChange(n),this.b.get(n)?.startShellExecution(o,s)}$shellExecutionEnd(n,o,s){this.b.get(n)?.endShellExecution(o,s)}$shellExecutionData(n,o){this.b.get(n)?.emitData(o)}$cwdChange(n,o){this.b.get(n)?.setCwd(o)}$closeTerminal(n){this.b.get(n)?.dispose(),this.b.delete(n)}};e.$6lc=T,e.$6lc=T=Je([We(0,N.$UO),We(1,M.$Mkc)],T);class y extends I.$Uc{get currentExecution(){return this.a}constructor(n,o){super(),this.j=n,this.m=o,this.b=!1,this.store=this.B(new I.$Tc),this.f=this.B(new d.$_d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new d.$_d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new d.$_d),this.onDidRequestEndExecution=this.h.event;const s=this;this.value={get cwd(){return s.c},executeCommand(r){s.g.fire(r);const i=s.startShellExecution(r,s.c,!0).value;return s.b=!0,i}}}startShellExecution(n,o,s){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0,void 0),this.h.fire({execution:this.a.value,exitCode:void 0}));const r=this.a=new u(this.j,n,o);s?queueMicrotask(()=>this.m.fire(r.value)):this.m.fire(this.a.value)}return this.a}emitData(n){this.currentExecution?.emitData(n)}endShellExecution(n,o){this.a&&(this.a.endExecution(n,o),this.h.fire({execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(n){let o=!1;f.URI.isUri(this.c)?o=!f.URI.isUri(n)||this.c.toString()!==n.toString():this.c!==n&&(o=!0),o&&(this.c=n,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class u{constructor(n,o,s){this.terminal=n,this.c=o,this.cwd=s,this.b=!1;const r=this;this.value={get terminal(){return r.terminal},get commandLine(){return r.c},get cwd(){return r.cwd},readData(){return r.d()}}}d(){if(!this.a){if(this.b)return E.$Nh.EMPTY;this.a=new w}return this.a.createIterable()}emitData(n){this.a?.emitData(n)}endExecution(n,o){n&&(this.c=n),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends I.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const n=this.a=new E.$mh;return new E.$Nh(async s=>{this.b.push(s),await n.wait()})}emitData(n){for(const o of this.b)o.emitOne(n)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Pe[278],Re([1,0,11,22,24,5,250,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=e.$Slc=e.$Rlc=void 0;let a=class extends f.$Uc{constructor(C,W,V,q){super(),this.w=q,this.f=this.B(new N.$_d),this.g=new Map,this.s=this.B(new N.$_d),this.onResultsChanged=this.f.event,this.results=[],this.h=C.getProxy(u.$xM.MainThreadTesting),this.m=new D(this.h),this.j=new c(this.h,W),V.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const U=A,K=U.tests[U.tests.length-1].item.extId;return this.g.get(s.$jL.root(K))?.collection.tree.get(K)?.actual??(0,m.$7O)(A)}case 18:{const{test:U,message:K}=A,ie=U.item.extId;return{test:this.g.get(s.$jL.root(ie))?.collection.tree.get(ie)?.actual??(0,m.$7O)({$mid:16,tests:[U]}),message:n.TestMessage.to(K)}}default:return A}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await V.executeCommand("_testing.getExplorerSelection"),U=K=>{const ie=this.g.get(s.$jL.root(K));if(ie)return s.$jL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:A?.include.map(U).filter(E.$9f)||[],exclude:A?.exclude.map(U).filter(E.$9f)||[]}})}createTestController(C,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const A=new f.$Tc,U=A.add(new m.$0O(W,V,this.w));U.root.label=V;const K=new Map,ie=new Set,fe=this.h,Se={items:U.root.children,get label(){return V},set label(oe){V=oe,U.root.label=oe,fe.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(oe){q=oe,fe.$updateController(W,{canRefresh:!!oe})},get id(){return W},createRunProfile:(oe,$e,ne,Ie,ze,re)=>{let L=(0,d.$bj)(oe);for(;K.has(L);)L++;return new S(this.h,K,ie,this.s.event,W,L,oe,$e,ne,Ie,ze,re)},createTestItem(oe,$e,ne){return new m.$8O(W,oe,$e,ne)},createTestRun:(oe,$e,ne=!0)=>this.j.createTestRun(W,U,oe,$e,ne),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const $e=oe instanceof Array?oe:[oe];this.h.$markTestRetired($e.map(ne=>s.$jL.fromExtHostTestItem(ne,W).toString()))}},set resolveHandler(oe){U.resolveHandler=oe},get resolveHandler(){return U.resolveHandler},dispose:()=>{A.dispose()}};fe.$registerTestController(W,V,!!q),A.add((0,f.$Sc)(()=>fe.$unregisterTestController(W)));const ke={controller:Se,collection:U,profiles:K,extension:C,activeProfiles:ie};return this.g.set(W,ke),A.add((0,f.$Sc)(()=>this.g.delete(W))),A.add(U.onDidGenerateDiff(oe=>fe.$publishDiff(W,oe.map(i.TestsDiffOp.serialize)))),Se}createTestObserver(){return this.m.checkout()}async runTests(C,W=R.CancellationToken.None){const V=$(C);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:C.include?.map(A=>s.$jL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:k[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:C.exclude?.map(A=>A.id)},W)}$syncTests(){for(const{collection:C}of this.g.values())C.flushDiff();return Promise.resolve()}async $getCoverageDetails(C,W){return(await this.j.getCoverageDetails(C,W))?.map(n.TestCoverage.fromDetails)}async $disposeRun(C){this.j.disposeTestRun(C)}$configureRunProfile(C,W){this.g.get(C)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(C){const W=new Map;for(const[V,q]of Object.entries(C)){const A=this.g.get(V);if(!A)continue;const U=new Map,K=q.filter(fe=>!A.activeProfiles.has(fe)),ie=[...A.activeProfiles].filter(fe=>!q.includes(fe));for(const fe of K)U.set(fe,!0),A.activeProfiles.add(fe);for(const fe of ie)U.set(fe,!1),A.activeProfiles.delete(fe);U.size&&W.set(V,U)}this.s.fire(W)}async $refreshTests(C,W){await this.g.get(C)?.controller.refreshHandler?.(W)}$publishTestResults(C){this.results=Object.freeze(C.map(n.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(C,W){const V=this.g.get(s.$jL.fromString(C).controllerId)?.collection;V&&(await V.expand(C,W<0?1/0:W),V.flushDiff())}$acceptDiff(C){this.m.applyDiff(C.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(C,W){return Promise.all(C.map(V=>this.y(V,!1,W)))}async $startContinuousRun(C,W){const V=new R.$je(W),q=await Promise.all(C.map(A=>this.y(A,!0,V.token)));return!W.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>W.onCancellationRequested(A)),V.dispose(!0),q}async y(C,W,V){const q=this.g.get(C.controllerId);if(!q)return{};const{collection:A,profiles:U}=q,K=U.get(C.profileId);if(!K)return{};const ie=C.testIds.map(oe=>A.tree.get(oe)).filter(E.$9f),fe=C.excludeExtIds.map(oe=>q.collection.tree.get(oe)).filter(E.$9f).filter(oe=>ie.some($e=>$e.fullId.compare(oe.fullId)===2));if(!ie.length)return{};const Se=new o.$_N(ie.some(oe=>oe.actual instanceof m.$9O)?void 0:ie.map(oe=>oe.actual),fe.map(oe=>oe.actual),K,W),ke=(0,i.$mL)(C)&&this.j.prepareForMainThreadTestRun(Se,b.fromInternal(C,q.collection),K,V);try{return await K.runHandler(Se,V),{}}catch(oe){return{error:String(oe)}}finally{ke&&ke.hasRunningTasks&&!V.isCancellationRequested&&await N.Event.toPromise(ke.onEnd)}}$cancelExtensionTestRun(C){C===void 0?this.j.cancelAllRuns():this.j.cancelRunById(C)}};e.$Rlc=a,e.$Rlc=a=Je([We(0,w.$UO),We(1,y.$Tj)],a);const h=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class v extends f.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(C,W,V,q,A){super(),this.z=C,this.C=W,this.D=V,this.F=q,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new N.$_d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new R.$je(A));const U=this.B(new I.$zh(()=>this.G(),h));this.B(this.m.token.onCancellationRequested(()=>U.schedule()));const K=new N.$_d;this.w=K.event,this.B((0,f.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(C,W){const[,V,q]=s.$jL.fromString(C).path,A=this.y.get(q);if(!A)return[];if(A.backCompatResolve)return A.backCompatResolve(W);const U=this.h.get(V);if(!U)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(U.run,A.coverage,W)??[]}createRun(C){const W=this.z.id,V=this.z.controllerId,q=(0,T.$Jg)(),A=ke=>(oe,...$e)=>{if(ie){this.D.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.z.isIncluded(oe)&&(this.I(oe),ke(oe,...$e))},U=(ke,oe)=>{const $e=oe instanceof Array?oe.map(n.TestMessage.from):[n.TestMessage.from(oe)];if(ke.uri&&ke.range){const ne={range:n.Range.from(ke.range),uri:ke.uri};for(const Ie of $e)Ie.location=Ie.location||ne}this.C.$appendTestMessagesInRun(W,q,s.$jL.fromExtHostTestItem(ke,V).toString(),$e)},K=(ke,oe)=>{const $e=ke.uri.toString(),ne=new s.$jL([W,q,$e]).toString();this.y.set($e,{coverage:ke,backCompatResolve:oe}),this.C.$appendCoverage(W,q,n.TestCoverage.fromFile(ne,ke))};let ie=!1,fe;const Se={isPersisted:this.z.isPersisted,token:this.m.token,name:C,onDidDispose:this.w,get coverageProvider(){return fe},set coverageProvider(ke){fe=ke,ke&&Promise.resolve(ke.provideFileCoverage(R.CancellationToken.None)).then(oe=>{oe?.forEach($e=>K($e,ke.resolveFileCoverage&&(async ne=>(await ke.resolveFileCoverage($e,ne)||$e).detailedCoverage)))})},addCoverage:K,enqueued:A(ke=>{this.C.$updateTestStateInRun(W,q,s.$jL.fromExtHostTestItem(ke,V).toString(),1)}),skipped:A(ke=>{this.C.$updateTestStateInRun(W,q,s.$jL.fromExtHostTestItem(ke,V).toString(),5)}),started:A(ke=>{this.C.$updateTestStateInRun(W,q,s.$jL.fromExtHostTestItem(ke,V).toString(),2)}),errored:A((ke,oe,$e)=>{U(ke,oe),this.C.$updateTestStateInRun(W,q,s.$jL.fromExtHostTestItem(ke,V).toString(),6,$e)}),failed:A((ke,oe,$e)=>{U(ke,oe),this.C.$updateTestStateInRun(W,q,s.$jL.fromExtHostTestItem(ke,V).toString(),4,$e)}),passed:A((ke,oe)=>{this.C.$updateTestStateInRun(W,q,s.$jL.fromExtHostTestItem(ke,this.z.controllerId).toString(),3,oe)}),appendOutput:(ke,oe,$e)=>{ie||($e&&(this.z.isIncluded($e)?this.I($e):$e=void 0),this.C.$appendOutputToRun(W,q,O.$ze.fromString(ke),oe&&n.location.from(oe),$e&&s.$jL.fromExtHostTestItem($e,V).toString()))},end:()=>{ie||(ie=!0,this.C.$finishedTestRunTask(W,q),--this.g||this.H())}};return this.g++,this.h.set(q,{run:Se}),this.C.$startedTestRunTask(W,{id:q,name:C,running:!0}),Se}G(){for(const{run:C}of this.h.values())C.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(C){if(!(C instanceof m.$8O))throw new r.$MO(C.id);if(this.j.has(s.$jL.fromExtHostTestItem(C,this.z.controllerId).toString()))return;const W=[],V=this.z.colllection.root;for(;;){const q=n.TestItem.from(C);if(W.unshift(q),this.j.has(q.extId)||(this.j.add(q.extId),C===V))break;C=C.parent||V}this.C.$addTestsToRun(this.z.controllerId,this.z.id,W)}dispose(){this.H(),super.dispose()}}class c{get trackers(){return this.f.values()}constructor(C,W){this.h=C,this.j=W,this.f=new Map,this.g=new Map}getCoverageDetails(C,W){const V=s.$jL.root(C);return this.g.get(V)?.getCoverageDetails(C,W)||[]}disposeTestRun(C){this.g.get(C)?.dispose(),this.g.delete(C);for(const[W,{id:V}]of this.f)V===C&&this.f.delete(W)}prepareForMainThreadTestRun(C,W,V,q){return this.k(C,W,V,q)}cancelRunById(C){this.g.get(C)?.cancel()}cancelAllRuns(){for(const C of this.f.values())C.cancel()}createTestRun(C,W,V,q,A){const U=this.f.get(V);if(U)return U.createRun(q);const K=b.fromPublic(C,W,V,A),ie=$(V);this.h.$startedExtensionTestRun({controllerId:C,continuous:!!V.continuous,profile:ie&&{group:k[ie.kind],id:ie.profileId},exclude:V.exclude?.map(Se=>s.$jL.fromExtHostTestItem(Se,W.root.id).toString())??[],id:K.id,include:V.include?.map(Se=>s.$jL.fromExtHostTestItem(Se,W.root.id).toString())??[W.root.id],persist:A});const fe=this.k(V,K,V.profile);return N.Event.once(fe.onEnd)(()=>{this.h.$finishedExtensionTestRun(K.id)}),fe.createRun(q)}k(C,W,V,q){const A=new v(W,this.h,this.j,V,q);return this.f.set(C,A),this.g.set(A.id,A),A}}e.$Slc=c;const $=P=>{if(P.profile){if(!(P.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class b{static fromPublic(C,W,V,q){return new b(C,(0,T.$Jg)(),V.include?.map(A=>s.$jL.fromExtHostTestItem(A,C).toString())??[C],V.exclude?.map(A=>s.$jL.fromExtHostTestItem(A,C).toString())??[],q,W)}static fromInternal(C,W){return new b(C.controllerId,C.runId,C.testIds,C.excludeExtIds,!0,W)}constructor(C,W,V,q,A,U){this.controllerId=C,this.id=W,this.isPersisted=A,this.colllection=U,this.f=V.map(K=>K+"\0"),this.g=q.map(K=>K+"\0")}isIncluded(C){const W=s.$jL.fromExtHostTestItem(C,this.controllerId).toString()+"\0";for(const V of this.g)if(W===V||W.startsWith(V))return!1;for(const V of this.f)if(W===V||W.startsWith(V))return!0;return!1}}e.$Tlc=b;class p{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(C){this.k=C,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(C){this.f.add(C)}update(C){Object.assign(C.revived,n.TestItem.toPlain(C.item)),this.f.has(C)||this.g.add(C)}remove(C){if(this.f.has(C)){this.f.delete(C);return}this.g.delete(C);const W=s.$jL.parentId(C.item.extId);if(W&&this.j.has(W.toString())){this.j.add(C.item.extId);return}this.h.add(C)}getChangeEvent(){const{f:C,g:W,h:V}=this;return{get added(){return[...C].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class l extends i.$sL{constructor(){super(...arguments),this.s=new N.$_d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(C){return this.g.get(C)}getMirroredTestDataByReference(C){return this.g.get(C.id)}x(C,W){return{...C,revived:n.TestItem.toPlain(C.item),depth:W?W.depth+1:0,children:new Set}}w(){return new p(this.s)}}class D{constructor(C){this.g=C}checkout(){this.f||(this.f=this.h());const C=this.f;return C.observers++,{onDidChangeTest:C.tests.onDidChangeTests,get tests(){return[...C.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--C.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(C){return this.f?.tests.getMirroredTestDataByReference(C)}applyDiff(C){this.f?.tests.apply(C)}h(){const C=new l({asCanonicalUri:W=>W});return this.g.$subscribeToDiffs(),{observers:0,tests:C}}}const g=(P,C,W,V)=>{W?Object.assign(W,V):C.$updateTestRunConfig(P.controllerId,P.profileId,V)};class S{#e;#t;#i;#n;#s;get label(){return this.g}set label(C){C!==this.g&&(this.g=C,g(this,this.#e,this.#n,{label:C}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(C){C!==this.h&&(this.h=C,g(this,this.#e,this.#n,{supportsContinuousRun:C}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(C){C!==this.isDefault&&(C?this.#t.add(this.profileId):this.#t.delete(this.profileId),g(this,this.#e,this.#n,{isDefault:C}))}get tag(){return this._tag}set tag(C){C?.id!==this._tag?.id&&(this._tag=C,g(this,this.#e,this.#n,{tag:C?n.TestTag.namespace(this.controllerId,C.id):null}))}get configureHandler(){return this.f}set configureHandler(C){C!==this.f&&(this.f=C,g(this,this.#e,this.#n,{hasConfigurationHandler:!!C}))}get onDidChangeDefault(){return N.Event.chain(this.#i,C=>C.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$9f))}constructor(C,W,V,q,A,U,K,ie,fe,Se=!1,ke=void 0,oe=!1){this.controllerId=A,this.profileId=U,this.g=K,this.kind=ie,this.runHandler=fe,this._tag=ke,this.h=oe,this.#e=C,this.#s=W,this.#t=V,this.#i=q,W.set(U,this);const $e=k[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Se&&V.add(U),this.#n={profileId:U,controllerId:A,tag:ke?n.TestTag.namespace(this.controllerId,ke.id):null,label:K,group:$e,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ulc=S;const k={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[115],Re([1,0,56,14,90,8,7]),function(ge,e,I,O,R,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=e.$2O=void 0;class d{static{this.c=new R.$ZO("TextEditorDecorationType")}constructor(u,w,m){const n=d.c.nextId();u.$registerTextEditorDecorationType(w.identifier,n,N.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$2O=d;class f{constructor(u,w){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,w){this.k();let m=null;if(u instanceof M.$AM)m=new M.$BM(u,u);else if(u instanceof M.$BM)m=u;else throw new Error("Unrecognized location");this.l(m,w,!1)}insert(u,w){this.k(),this.l(new M.$BM(u,u),w,!0)}delete(u){this.k();let w=null;if(u instanceof M.$BM)w=u;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(u,w,m){const n=this.c.validateRange(u);this.g.push({range:n,text:w,forceMoveMarkers:m})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=u}}class E{constructor(u,w,m,n){this.c=u,this.d=w,this._accept(m),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}n(u){const w=this.m(u);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}p(u){const w=this.o(u);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const w=this.q(u);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const w={};let m=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(m=!0,w.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,m=!0,w.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(m=!0,w.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,m=!0,w.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(m=!0,w.insertSpaces=n):this.j!==n&&(this.j=n,m=!0,w.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,m=!0,w.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,m=!0,w.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(u,w){w.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(m)})}}e.$3O=E;class T{constructor(u,w,m,n,o,s,r,i){this.id=u,this.j=w,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,s,m),this.e=r,this.f=i;const a=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new O.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof M.$CM))throw(0,O.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof M.$CM)))throw(0,O.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new O.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new O.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new f(n.value,t);return h(v),a.m(v)},insertSnippet(h,t,v={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>N.Range.from($));else if(t instanceof M.$AM){const{lineNumber:$,column:b}=N.Position.from(t);c=[{startLineNumber:$,startColumn:b,endLineNumber:$,endColumn:b}]}else if(t instanceof M.$BM)c=[N.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof M.$BM)c.push(N.Range.from($));else{const{lineNumber:b,column:p}=N.Position.from($);c.push({startLineNumber:b,startColumn:p,endLineNumber:b,endColumn:p})}}return w.$tryInsertSnippet(u,n.value.version,h.value,c,v)},setDecorations(h,t){const v=t.length===0;v&&!a.h.has(h.key)||(v?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(N.$RO(t))return w.$trySetDecorations(u,h.key,N.$SO(t));{const c=new Array(4*t.length);for(let $=0,b=t.length;$<b;$++){const p=t[$];c[4*$]=p.start.line+1,c[4*$+1]=p.start.character+1,c[4*$+2]=p.end.line+1,c[4*$+3]=p.end.character+1}return w.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>w.$tryRevealRange(u,N.Range.from(h),t||M.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(u,N.ViewColumn.from(h))},hide(){w.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const w=u.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const m=w.edits.map(o=>o.range);m.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=m.length-1;o<s;o++){const r=m[o].end;if(m[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=w.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,n,{setEndOfLine:typeof w.setEndOfLine=="number"?N.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$4O=T}),define(Pe[67],Re([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,46,40]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new O.$_d,this.e=new O.$_d,this.f=new O.$_d,this.g=new O.$_d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],v=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=N.URI.revive(c),b=this.c.get($);b?.unref()&&(this.c.delete($),h.push(b.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=N.URI.revive(c.uri);let b=this.c.get($);if(b&&$.scheme!==m.Schemas.vscodeNotebookCell&&$.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);b||(b=new s(new f.$XO(this.h.getProxy(d.$xM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,b),t.push(b.value)),b.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&v.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=N.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const b=this.c.get($).value,p=new T.$4O(c.id,this.h.getProxy(d.$xM.MainThreadTextEditors),this.i,new o.$V(()=>b.document),c.selections.map(y.Selection.to),c.options,c.visibleRanges.map(l=>y.Range.to(l)),typeof c.editorPosition=="number"?y.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,R.$Pc)(h),(0,R.$Pc)(v),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return n.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$5O=r,e.$5O=r=Je([We(0,E.$UO),We(1,u.$Tj)],r),e.$6O=(0,M.$ni)("IExtHostDocumentsAndEditors")}),define(Pe[279],Re([1,0,18,5,4,115,8,7]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class f{constructor(T,y){this.i=y,this.a=new O.$_d,this.b=new O.$_d,this.c=new O.$_d,this.d=new O.$_d,this.f=new O.$_d,this.g=new O.$_d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$xM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const y=this.i.allEditors();return T?y:y.map(u=>u.value)}async showTextDocument(T,y,u){let w;typeof y=="number"?w={position:M.ViewColumn.from(y),preserveFocus:u}:typeof y=="object"?w={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:w={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(T.uri,w),n=m&&this.i.getEditor(m);if(n)return n.value;throw m?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,y){return new N.$2O(this.h,T,y).value}$acceptEditorPropertiesChanged(T,y){const u=this.i.getEditor(T);if(!u)throw new Error("unknown text editor");if(y.options&&u._acceptOptions(y.options),y.selections){const w=y.selections.selections.map(M.Selection.to);u._acceptSelections(w)}if(y.visibleRanges){const w=I.$Hb(y.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(w)}if(y.options&&this.b.fire({textEditor:u.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const w=d.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:m,kind:w})}if(y.visibleRanges){const w=I.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const y in T){const u=this.i.getEditor(y);if(!u)throw new Error("Unknown text editor");const w=M.ViewColumn.to(T[y]);u.value.viewColumn!==w&&(u._acceptViewColumn(w),this.d.fire({textEditor:u.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$fkc=f}),define(Pe[280],Re([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0,e.$Wlc=(0,O.$ni)("IExtHostTimeline");class T{constructor(w,m){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$xM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&f.$Im.equals(o,this.b.get(n.source)?.extension)){const s=n.uri===void 0?void 0:I.URI.revive(n.uri);return this.c.get(n.source)?.get(y(s))?.get(n.handle)}else return;return n}})}async $getTimeline(w,m,n,o){return this.b.get(w)?.provider.provideTimeline(I.URI.revive(m),n,o)}registerTimelineProvider(w,m,n,o){const s=new N.$Tc,r=this.d(m.id,o,s).bind(this);let i;m.onDidChange&&(i=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const a=this.c;return this.f({...m,scheme:w,onDidChange:void 0,async provideTimeline(h,t,v){t?.resetCache&&(s.clear(),a.get(m.id)?.clear());const c=await m.provideTimeline(h,t,v);if(c==null)return;const $=r(h,t);return{...c,source:m.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(m.id)?.clear();i?.dispose(),s.dispose()}},n)}d(w,m,n){return(o,s)=>{let r;if(s?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const a=y(o);r=i.get(a),r===void 0&&(r=new Map,i.set(a,r))}return i=>{const{iconPath:a,...h}=i,t=`${w}|${i.id??i.timestamp}`;r?.set(t,i);let v,c,$;i.iconPath&&(a instanceof M.$vN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(v=a,c=a):{light:v,dark:c}=a);let b;return M.$1M.isMarkdownString(h.tooltip)?b=d.MarkdownString.from(h.tooltip):(0,E.$1f)(h.tooltip)?b=h.tooltip:M.$1M.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=d.MarkdownString.from(h.detail)):(0,E.$1f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:i.command?m.toInternal(i.command,n):void 0,icon:v,iconDark:c,themeIcon:$,tooltip:b,accessibilityInformation:i.accessibilityInformation}}}}f(w,m){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:m}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Xlc=T;function y(u){return u?.toString()}}),define(Pe[281],Re([1,0,173,23,2,5,6,211,11,7,17,18,8,54,24,137,25]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;function s(a,h){if((0,T.$1f)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class r extends M.$Uc{constructor(h,t,v){super(),this.f=h,this.g=t,this.h=v,this.a=new Map,this.b=new n.$s0;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(b=>c(b)?this.r(b):b):$})}registerTreeDataProvider(h,t,v){const c=this.createTreeView(h,{treeDataProvider:t},v);return{dispose:()=>c.dispose()}}createTreeView(h,t,v){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,v),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:b,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$hG)(v,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$hG)(v,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(k){(0,w.$Mk)(k)&&(0,o.$hG)(v,"treeViewMarkdownMessage"),l.message=k},get title(){return l.title},set title(k){l.title=k},get description(){return l.description},set description(k){l.description=k},get badge(){return l.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?l.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(l.badge=void 0)},reveal:(k,P)=>l.reveal(k,P),dispose:async()=>{await g,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const v=this.a.get(h);return v?v.getChildren(t):Promise.reject(new d.$KF(h))}async $handleDrop(h,t,v,c,$,b,p,l){const D=this.a.get(h);if(!D)return Promise.reject(new d.$KF(h));const g=u.DataTransfer.toDataTransfer(v,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return p===h&&l&&await this.j(g,D,l,$,b),D.onDrop(g,c,$)}async j(h,t,v,c,$){const b=this.b.removeDragOperationTransfer($);if(b)(await b)?.forEach((p,l)=>{p&&h.set(l,p)});else if($&&t.handleDrag){const p=t.handleDrag(v,h,c);this.b.addDragOperationTransfer($,p),await p}return h}async $handleDrag(h,t,v,c){const $=this.a.get(h);if(!$)return Promise.reject(new d.$KF(h));const b=await this.j(new E.$rN,$,t,c,v);if(!(!b||c.isCancellationRequested))return u.DataTransfer.from(b)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new d.$KF(h);return t.hasResolve}$resolve(h,t,v){const c=this.a.get(h);if(!c)throw new d.$KF(h);return c.resolveTreeItem(t,v)}$setExpanded(h,t,v){const c=this.a.get(h);if(!c)throw new d.$KF(h);c.setExpanded(t,v)}$setSelectionAndFocus(h,t,v){const c=this.a.get(h);if(!c)throw new d.$KF(h);c.setSelectionAndFocus(t,v)}$setVisible(h,t){const v=this.a.get(h);if(!v){if(!t)return;throw new d.$KF(h)}v.setVisible(t)}$changeCheckboxState(h,t){const v=this.a.get(h);if(!v)throw new d.$KF(h);v.setCheckboxState(t)}m(h,t,v){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,v));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Ylc=r;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,T.$0f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,v,c,$,b){if(super(),this.I=h,this.J=v,this.L=c,this.M=$,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$_d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$_d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$_d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$_d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$_d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$_d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$_d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$je,b.contributes&&b.contributes.views)for(const g in b.contributes.views)for(const S of b.contributes.views[g])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let p,l;const D=N.Event.debounce(this.F.event,(g,S)=>(g||(g={message:!1,elements:[]}),S.element!==!1&&(p||(p=new Promise(k=>l=k),this.G=this.G.then(()=>p)),Array.isArray(S.element)?g.elements.push(...S.element):g.elements.push(S.element)),S.message&&(g.message=!0),g),200,!0);this.B(D(({message:g,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const k=l;return p=null,this.$(S).then(()=>k())})),g&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let v=this.X(h);return v||(v=await this.Y(t)),v?v.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const v=(0,T.$0f)(t.select)?!0:t.select,c=(0,T.$0f)(t.focus)?!1:t.focus,$=(0,T.$0f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(b=>this.W(h,b[b.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:b.map(l=>l.item)},{select:v,focus:c,expand:$})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:v,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const v=this.getExtensionElement(h);v&&(t?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(h,t){const v=!(0,y.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async v=>{const c=this.getExtensionElement(v.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);t.forEach(v=>{v.treeItem.checkboxState=v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(v=>[v.extensionItem,v.newState])})}async handleDrag(h,t,v){const c=[];for(const $ of h){const b=this.getExtensionElement($);b&&c.push(b)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,v),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,v){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,f.$fh)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const v=this.j.get(h);if(v){const c=this.m.get(v);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,v,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(v=>this.W(t,v[v.length-1]).then(c=>(v.push(c),v))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$fh)(()=>this.f.getParent(h))}W(h,t){const v=this.m.get(h);return v?Promise.resolve(v):(0,f.$fh)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const b=this.m.get($);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const v=this.getExtensionElement(h);t=v?this.m.get(v):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new m.$je(this.Z.token);try{const v=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,y.$Hb)(c||[]),b=await Promise.all((0,y.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const p=b.map((l,D)=>l?this.db($[D],l,v):null);return(0,y.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some(v=>!v))return this.Z.dispose(!0),this.Z=new m.$je,this.tb(),this.J.$refresh(this.I);{const v=this.ab(h);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(h){const t=new Set,v=h.map($=>this.m.get($));for(const $ of v)if($&&!t.has($.item.handle)){let b=$;for(;b&&b.parent&&v.findIndex(p=>b&&b.parent&&p&&p.item.handle===b.parent.item.handle)===-1;){const p=this.j.get(b.parent.item.handle);b=p?this.m.get(p):void 0}b&&!b.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const b=this.j.get($);if(b){const p=this.m.get(b);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(v=>this.cb(v).then(c=>{c&&(t[v]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const v=this.m.get(t);if(v)return this.rb(t),(0,f.$fh)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,v.parent);return this.pb(t,$,v,v.parent),v.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,v){const c=this.ib(h,t,v);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,v),c}eb(h){return E.$1M.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,v,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,v=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:c}}hb(h){if(!E.$mN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,v){this.hb(t);const c=this.B(new M.$Tc),$=this.kb(h,t,v),b=this.lb(t);return{item:{handle:$,parentHandle:v?v.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:b,iconDark:this.mb(t)||b,themeIcon:this.jb(t),collapsibleState:(0,T.$0f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:v,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof E.$vN?h.iconPath:void 0}kb(h,{id:t,label:v,resourceUri:c},$,b){if(t)return`${i.b}/${t}`;const p=s(v,this.N),l=$?$.item.handle:i.a;let D=p?p.label:c?(0,O.$Xg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let k,P=0;do{if(k=`${l}/${P}:${D}`,b||!this.j.has(k)||g===k)break;P++}while(P<=S.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$vN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$vN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,v,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(h,t);const $=this.X(c)||[],b=$.filter(p=>p.item.handle===v.item.handle)[0];b&&$.splice($.indexOf(b),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[282],Re([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,O,R,N,M,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,n,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$_d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$_d),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=n,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,R.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends O.$Uc{static c(){return(0,N.$Jg)()}constructor(m,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(f.$xM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,n,o,s,r={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,d.$ukc)(m),t=y.c();this.f.$createWebviewPanel((0,d.$wkc)(m),t,n,{title:o,panelOptions:u(r),webviewOptions:(0,d.$xkc)(m,this.m,r),serializeBuffersForPostMessage:h},a);const v=this.j.createNewWebview(t,r,m);return this.createNewWebviewPanel(t,n,o,i,r,v,!0)}$onDidChangeWebviewPanelViewStates(m){const n=Object.keys(m);n.sort((o,s)=>{const r=m[o],i=m[s];return r.active?1:i.active?-1:+r.visible-+i.visible});for(const o of n){const s=this.getWebviewPanel(o);if(!s)continue;const r=m[o];s._updateViewState({active:r.active,visible:r.visible,viewColumn:M.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:m}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,d.$ukc)(m)}),new E.$zM(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(m,n,o,s){const r=this.h.get(n);if(!r)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:a}=r,h=this.j.createNewWebview(m,o.webviewOptions,a),t=this.createNewWebviewPanel(m,n,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(m,n,o,s,r,i,a){const h=new T(m,this.f,i,{viewType:n,title:o,viewColumn:s,panelOptions:r,active:a});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$ykc=y;function u(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Pe[283],Re([1,0,5,6,63,8,4,7]),function(ge,e,I,O,R,N,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class f extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,w,m,n,o){super(),this.#s=!1,this.#u=this.B(new I.$_d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$_d),this.onDidDispose=this.#l.event,this.#i=w,this.#a=m,this.#e=y,this.#t=u,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$xM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,w,m){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:w,extension:y}),this.a.$registerWebviewViewProvider((0,R.$wkc)(y),u,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$ukc)(y)}),new d.$zM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,w,m,n){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:r}=o,i=this.d.createNewWebview(y,{},r),a=new f(y,this.a,u,w,i,!0);this.c.set(y,a),await s.resolveWebviewView(a,{state:m},n)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$2lc=E}),define(Pe[284],Re([1,0,5,30,33,3]),function(ge,e,I,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.OutputChannelUpdateMode=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=void 0,e.$FL="text/x-code-output",e.$GL="output",e.$HL="Log",e.$IL="text/x-code-log-output",e.$JL="log",e.$KL="workbench.panel.output",e.$LL=new R.$Ej("inOutput",!1),e.$ML=new R.$Ej("activeLogOutput",!1),e.$NL=new R.$Ej("activeLogOutput.levelSettable",!1),e.$OL=new R.$Ej("activeLogOutput.level",""),e.$PL=new R.$Ej("activeLogOutput.levelIsDefault",!1),e.$QL=new R.$Ej("outputView.scrollLock",!1),e.$RL=(0,N.$ni)("outputService");var M;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$SL={OutputChannels:"workbench.contributions.outputChannels"};class d{constructor(){this.a=new Map,this.b=new I.$_d,this.onDidRegisterChannel=this.b.event,this.c=new I.$_d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$6n.add(e.$SL.OutputChannels,new d),e.$TL=new R.$Ej("activeOutputChannel","")}),define(Pe[116],Re([1,0,4,3,16,20,13,284,64,27,44,141,22,17,43,5,6]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;class s extends M.$Zj{get disposed(){return this.n}constructor(h,t,v,c,$){super(),this.id=h,this.name=t,this.r=v,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,d.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,d.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$ze.fromString(t).byteLength,(0,M.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,d.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,v,c,$,b){this.i=t,this.j=v,this.k=c,this.l=$,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$xM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,y.$Um)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,v]of this.g)v.visible=t===this.h}createOutputChannel(h,t,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,w.$1f)(t)?t:void 0;if((0,w.$1f)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const p=this.i.environment.extensionLogLevel?.find(([D])=>N.$Im.equals(v.identifier,D))?.[1];p&&(b=(0,M.$$j)(p));const l=c?this.o(h,b,v):this.n(h,$,v);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,b??this.m.getLevel(),l):this.q(h,l)}async n(h,t,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,$,t,v.identifier.value);return new s(p,h,b,this.a,v)}async o(h,t,v){const c=await this.p(v),$=h.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(c,`${$}.log`),p=`${v.identifier.value}.${$}`,l=this.l.createLogger(b,{id:p,name:h,logLevel:t,extensionId:v.identifier.value});return new r(p,h,l,this.a,v)}p(h){let t=this.d.get(h.identifier.value);if(!t){const v=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(v)}catch(c){if((0,m.$0k)(c)!==m.FileSystemProviderErrorCode.FileExists)throw c}return v})())}return t}q(h,t){let v=!1;const c=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(b=>b.append($))},appendLine($){c(),t.then(b=>b.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(b=>b.replace($))},show($,b){c(),t.then(p=>p.show($,b))},hide(){c(),t.then($=>$.hide())},dispose(){v=!0,t.then($=>$.dispose())}}}r(h,t,v){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},b=c.add(new n.$_d);function p(l){t=l,b.fire(l)}return v.then(l=>{c.add(l),l.logLevel!==t&&p(l.logLevel),c.add(l.onDidChangeLogLevel(D=>p(D)))}),{...this.q(h,v),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(l,...D){$(),v.then(g=>g.trace(l,...D))},debug(l,...D){$(),v.then(g=>g.debug(l,...D))},info(l,...D){$(),v.then(g=>g.info(l,...D))},warn(l,...D){$(),v.then(g=>g.warn(l,...D))},error(l,...D){$(),v.then(g=>g.error(l,...D))},dispose(){c.dispose()}}}};e.$Clc=i,e.$Clc=i=Je([We(0,R.$UO),We(1,E.$$O),We(2,f.$qkc),We(3,T.$3jc),We(4,M.$Uj),We(5,M.$Tj)],i),e.$Dlc=(0,O.$ni)("IExtHostOutputService")}),define(Pe[117],Re([1,0,3,11]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$0m=(0,I.$ni)("remoteAgentService"),e.$$m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let N=1/0;for(let d=0;d<this.maxSampleCount;d++){const f=await R.getRoundTripTime();if(f===void 0)return;N=Math.min(N,f/2),await(0,O.$oh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(N):M=this.initial.reduce((d,f)=>d+f,0)/this.initial.length,this.lastMeasurement={initial:M,current:N,average:this.average.reduce((d,f)=>d+f,0)/this.average.length,high:typeof M>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[285],Re([1,0,176,57,30,49,48,6,5,117,21,26,11]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=void 0,e.$$I=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$_I=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$aJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$bJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$cJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new f.$_d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const m=new w;R.$6n.add(e.$cJ.ConfigurationMigration,m);let n=class extends d.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,i){super(),this.a=r,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const i of this.b.getWorkspace().folders)await this.f(i,r)}async f(r,i){await Promise.all([i.map(a=>this.g(a,r?.uri))])}async g(r,i){const a=this.a.inspect(r.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,v]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const b=await this.h(r,t,c.value,i,void 0);for(const p of b??[])$.push([p,[]])}for(const{identifiers:b,value:p}of c.overrides??[])if(p!==void 0){const l=await this.h(r,t,p,i,b);for(const D of l??[])$.push([D,b])}$.length&&await Promise.allSettled($.map(async([[b,p],l])=>this.a.updateValue(b,p.value,{resource:i,overrideIdentifiers:l},v)))}}async h(r,i,a,h,t){const v=$=>{const p=this.a.inspect($,{resource:h})[i];if(p)return t?p.overrides?.find(({identifiers:l})=>(0,y.$Xn)(l,t))?.value:p.value},c=await r.migrateFn(a,v);return Array.isArray(c)?c:[[r.key,c]]}};e.$dJ=n,e.$dJ=n=Je([We(0,M.$Ti),We(1,N.$wi)],n);let o=class extends d.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$Kh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$6n.as(O.$$n.Configuration).registerConfiguration({...e.$aJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$eJ=o,e.$eJ=o=Je([We(0,E.$0m)],o)}),define(Pe[286],Re([1,0,36,12,19,23,184,285,57,3,30]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Vfb=e.$Ufb=void 0,e.$Wfb=n,e.$Xfb=o,e.$Ufb=(0,E.$ni)("editorResolverService"),e.$Vfb="workbench.editorAssociations";const y=T.$6n.as(f.$$n.Configuration),u={...d.$_I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var m;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function n(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(s,r){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof s=="string"&&s.indexOf(R.$hc.sep)>=0?`${r.scheme}:${r.path}`:(0,N.$Xg)(r);return I.$gk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Pe[287],Re([1,0,47,12,19,21,23,2,3,205,49,224,117]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=void 0,e.$_L=(0,f.$ni)("pathService");let m=w=class{constructor(o,s,r,i){this.d=o,this.e=s,this.f=r,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,r){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,r)}h(o,s,r){return o.scheme===O.Schemas.file||o.scheme===O.Schemas.vscodeRemote?(0,I.$lg)(r??(0,M.$Xg)(o),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return O.Schemas.vscodeRemote;const r=(0,E.$9L)(s.getWorkspace());if(r)return r;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:O.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return d.URI.from({scheme:O.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$aM=m,e.$aM=m=w=Je([We(1,u.$0m),We(2,y.$UL),We(3,T.$wi)],m)}),define(Pe[118],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$FK=e.$EK=void 0;class I{constructor(M,d){this.line=M,this.character=d}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,d){return new I(0,0)}with(M){return new I(0,0)}}e.$EK=I;class O{constructor(M,d,f,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,d),this.end=new I(f,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new O(0,0,0,0)}with(M){return new O(0,0,0,0)}}e.$FK=O;var R;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Pe[45],Re([1,0,18,36,26,47,15,3,19,14,118,11]),function(ge,e,I,O,R,N,M,d,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$3K=e.$VK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$SK=e.$RK=e.$QK=e.$PK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.TextSearchCompleteMessageType=void 0,e.$MK=s,e.$NK=r,e.$OK=i,e.$TK=l,e.$UK=D,e.$WK=k,e.$XK=P,e.$YK=C,e.$ZK=W,e.$1K=V,e.$2K=q,e.$4K=U,e.$6K=fe,e.$7K=Se,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$GK="workbench.view.search",e.$HK="workbench.panel.search",e.$IK="workbench.view.search",e.$JK="search-result",e.$KK="search.exclude";const u="\u27EA ",w=" characters skipped \u27EB",m=(u.length+w.length+5)*2;e.$LK=(0,d.$ni)("searchService");var n;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(oe){return!!oe.preview}function r(oe){return!!oe.resource}function i(oe){return!!oe.message}var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$PK=h;class t{constructor($e,ne,Ie,ze){this.ranges=ne,this.webviewIndex=ze;const re=Array.isArray(ne)?ne:[ne];if(Ie&&Ie.matchLines===1&&v(re)){$e=(0,M.$Tf)($e,Ie.matchLines);let L="",_=0,ve=0;const Te=Math.floor(Ie.charsPerLine/5),Ee=[];for(const pe of re){const de=Math.max(pe.startColumn-Te,0),Q=pe.startColumn+Ie.charsPerLine;if(de>ve+Te+m){const Y=u+(de-ve)+w;L+=Y+$e.slice(de,Q),_+=de-(ve+Y.length)}else L+=$e.slice(ve,Q);Ee.push(new $(0,pe.startColumn-_,pe.endColumn-_)),ve=Q}this.preview={text:L,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const L=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:$e,matches:(0,I.$2b)(ne,_=>new c(_.startLineNumber-L,_.startColumn,_.endLineNumber-L,_.endColumn))}}}}e.$QK=t;function v(oe){const $e=oe[0].startLineNumber;for(const ne of oe)if(ne.startLineNumber!==$e||ne.endLineNumber!==$e)return!1;return!0}class c{constructor($e,ne,Ie,ze){this.startLineNumber=$e,this.startColumn=ne,this.endLineNumber=Ie,this.endColumn=ze}}e.$RK=c;class $ extends c{constructor($e,ne,Ie){super($e,ne,$e,Ie)}}e.$SK=$;var b;(function(oe){oe.List="list",oe.Tree="tree"})(b||(e.ViewMode=b={}));var p;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function l(oe,$e=!0){const ne=oe&&oe.files&&oe.files.exclude,Ie=$e&&oe&&oe.search&&oe.search.exclude;if(!ne&&!Ie)return;if(!ne||!Ie)return ne||Ie;let ze=Object.create(null);return ze=R.$Wn(ze,R.$Tn(ne)),ze=R.$Wn(ze,R.$Tn(Ie),!0),ze}function D(oe,$e){return oe.excludePattern&&O.$gk(oe.excludePattern,$e)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&O.$gk(oe.includePattern,$e)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ne=>{const Ie=ne.folder.fsPath;if(N.$ng($e,Ie)){const ze=f.$mc(Ie,$e);return!ne.includePattern||!!O.$gk(ne.includePattern,ze)}else return!1}):!1:!0}var g;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class S extends Error{constructor($e,ne){super($e),this.code=ne}}e.$VK=S;function k(oe){const $e=oe.message;if((0,E.$4)(oe))return new S($e,g.canceled);try{const ne=JSON.parse($e);return new S(ne.message,ne.code)}catch{return new S($e,g.other)}}function P(oe){const $e={message:oe.message,code:oe.code};return new Error(JSON.stringify($e))}function C(oe){return oe.type==="error"?!0:oe.type==="success"}function W(oe){return oe.type==="success"}function V(oe){return!!oe.path}function q(oe,$e,ne=!0){const Ie=oe.searchPath?oe.searchPath:oe.relativePath;return ne?(0,M.$Qf)(Ie,$e):O.$gk($e,Ie)}class A{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$3K=A;function U(oe,$e){const ne={...oe||{},...$e||{}};return Object.keys(ne).filter(Ie=>{const ze=ne[Ie];return typeof ze=="boolean"&&ze})}class K{constructor($e,ne){this.c=null,this.a={...$e.excludePattern||{},...ne.excludePattern||{}},this.b=O.$hk(this.a);let Ie=$e.includePattern;ne.includePattern&&(Ie?Ie={...Ie,...ne.includePattern}:Ie=ne.includePattern),Ie&&(this.c=O.$hk(Ie))}matchesExcludesSync($e,ne,Ie){return!!(this.b&&this.b($e,ne,Ie))}includedInQuerySync($e,ne,Ie){return!(this.b&&this.b($e,ne,Ie)||this.c&&!this.c($e,ne,Ie))}includedInQuery($e,ne,Ie){const ze=this.b($e,ne,Ie),re=()=>this.c?!!this.c($e,ne,Ie):!0;return(0,y.$_g)(ze)?ze.then(L=>L?!1:re()):re()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$5K=K;function ie(oe){for(const $e in oe)if(typeof oe[$e]!="boolean")return!0;return!1}function fe(oe){if(!oe)return;let $e;return ne=>($e||($e=(oe()||Promise.resolve([])).then(Ie=>Ie?ke(Ie):{})),$e.then(Ie=>!!Ie[ne]))}function Se(oe){if(!oe)return;let $e;return ne=>{if(!$e){const Ie=oe();$e=Ie?ke(Ie):{}}return!!$e[ne]}}function ke(oe){const $e={};for(const ne of oe)$e[ne]=!0;return $e}}),define(Pe[37],Re([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,194,49,44,27,16,8,7,60,45,4,53]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;function p(W,V,q){return new T.$Pg(A=>S(A,q)).isEqual(W,V)}function l(W,V,q){return p(W.uri,V.uri,q)?0:(0,y.$jf)(W.uri.toString(),V.uri.toString())}function D(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:p(W.uri,V.uri,q)?(0,y.$jf)(W.name,V.name):(0,y.$jf)(W.uri.toString(),V.uri.toString())}function g(W,V,q,A){const U=W.slice(0).sort((ie,fe)=>q(ie,fe,A)),K=V.slice(0).sort((ie,fe)=>q(ie,fe,A));return(0,I.$Eb)(U,K,(ie,fe)=>q(ie,fe,A))}function S(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class k extends s.$Gi{static toExtHostWorkspace(V,q,A,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:fe,configuration:Se,transient:ke,isUntitled:oe}=V,$e=[],ne=q;q?fe.forEach((L,_)=>{const ve=u.URI.revive(L.uri),Te=k.o(A||q,ve,U);Te?(Te.name=L.name,Te.index=L.index,$e.push(Te)):$e.push({uri:ve,name:L.name,index:_})}):$e.push(...fe.map(({uri:L,name:_,index:ve})=>({uri:u.URI.revive(L),name:_,index:ve}))),$e.sort((L,_)=>L.index<_.index?-1:1);const Ie=new k(K,ie,$e,!!ke,Se?u.URI.revive(Se):null,!!oe,L=>S(L,U)),{added:ze,removed:re}=g(ne?ne.workspaceFolders:[],Ie.workspaceFolders,l,U);return{workspace:Ie,added:ze,removed:re}}static o(V,q,A){for(let U=0;U<V.folders.length;U++){const K=V.workspaceFolders[U];if(p(K.uri,q,A))return K}}constructor(V,q,A,U,K,ie,fe){super(V,A.map(Se=>new s.$Hi(Se)),U,K,fe),this.t=q,this.u=ie,this.q=[],this.s=d.$ti.forUris(fe),A.forEach(Se=>{this.q.push(Se),this.s.set(Se.uri,Se)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$Zg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let P=class{constructor(V,q,A,U,K){this.c=new N.$_d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$_d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$be,this.C=new Map,this.h=U,this.s=A,this.t=K,this.j=new E.$um,this.k=new O.$mh,this.o=V.getProxy($.$xM.MainThreadWorkspace),this.q=V.getProxy($.$xM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,fe=>S(fe,A)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:f.Schemas.untitled,path:(0,T.$Xg)((0,T.$Zg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,A,...U){const K=[];if(Array.isArray(U)&&U.forEach(oe=>{u.URI.isUri(oe.uri)&&!K.some($e=>p($e.uri,oe.uri,this.s))&&K.push({uri:oe.uri,name:oe.name||(0,T.$Wg)(oe.uri)})}),this.n||[q,A].some(oe=>typeof oe!="number"||oe<0)||A===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const fe=ie.slice(0);fe.splice(q,A,...K.map(oe=>({uri:oe.uri,name:oe.name||(0,T.$Wg)(oe.uri),index:void 0})));for(let oe=0;oe<fe.length;oe++){const $e=fe[oe];if(fe.some((ne,Ie)=>Ie!==oe&&p($e.uri,ne.uri,this.s)))return!1}fe.forEach((oe,$e)=>oe.index=$e);const{added:Se,removed:ke}=g(ie,fe,D,this.s);if(Se.length===0&&ke.length===0)return!1;if(this.o){const oe=V.displayName||V.name;this.o.$updateWorkspaceFolders(oe,q,A,K).then(void 0,$e=>{this.n=void 0;const ne={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,oe,$e.toString()),ne,[])})}return this.y(fe),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let A,U="";if(typeof V=="string"?(A=u.URI.file(V),U=V):typeof V<"u"&&(A=V,U=V.fsPath),!A)return U;const K=this.getWorkspaceFolder(A,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$3g)(K.uri,A);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:A,removed:U}=k.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:U}))}findFiles(V,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie="",fe=!0;return q===null?fe=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},A,U=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,V,q,U)}async z(V,q,A,U=R.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let fe;if(V){const{includePattern:Se,folder:ke}=C(h.GlobPattern.from(V));fe=ke,ie.includePattern=Se}else{const{includePattern:Se,folder:ke}=C(h.GlobPattern.from(q));fe=ke,ie.filePattern=Se}return this.o.$startFileSearch(fe??null,ie,U).then(Se=>Array.isArray(Se)?Se.map(ke=>u.URI.revive(ke)):[])}async findTextInFiles(V,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),fe=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:Se,folder:ke}=C(h.GlobPattern.from(q.include)),oe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,$e={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:fe,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:Se,excludePattern:oe},ne=!1;if(this.u[ie]=Ie=>{if(ne)return;const ze=u.URI.revive(Ie.resource);Ie.results.forEach(re=>{const L=(0,b.$Wh)(re);(0,c.$MK)(L)?A({uri:ze,preview:{text:L.preview.text,matches:(0,I.$2b)(L.preview.matches,_=>new t.$BM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,I.$2b)(L.ranges,_=>new t.$BM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):A({uri:ze,text:L.text,lineNumber:L.lineNumber})})},K.isCancellationRequested)return{};try{const Ie=await this.o.$startTextSearch(V,ke??null,$e,ie,K);return delete this.u[ie],Ie||{}}catch(Ie){throw delete this.u[ie],Ie}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return u.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return u.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const A=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,A),(0,M.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const A=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const U=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,A,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const fe=await ie.provideEditSessionIdentityMatch?.(q,A,U);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(V){return(q,A,U)=>{const K=function(fe){q.call(A,fe)};return K.extension=V,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(V,q,A){const U=await this.resolveWorkspaceFolder(u.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,ie)=>{const fe=Date.now();await Promise.resolve(K),Date.now()-fe>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const A=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerCanonicalUriProvider(U,A),(0,M.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,q,A){const U=this.C.get(V.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(u.URI.revive(V),q,A);if(K)return K}async $provideCanonicalUri(V,q,A){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:q},A)}};e.$kkc=P,e.$kkc=P=Je([We(0,a.$UO),We(1,i.$$O),We(2,r.$3jc),We(3,n.$Tj),We(4,v.$ikc)],P),e.$lkc=(0,m.$ni)("IExtHostWorkspace");function C(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=u.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Pe[38],Re([1,0,26,5,37,4,7,196,57,17,11,3,16,13,2]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=e.$mkc=void 0;function n(v,c){if(c){const $=c.split(".");let b=v;for(let p=0;b&&p<$.length;p++)b=b[$[p]];return b}}function o(v){return v instanceof m.URI}function s(v){return v&&v.uri instanceof m.URI&&v.languageId&&typeof v.languageId=="string"}function r(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&v.uri instanceof m.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(o(v))return{resource:v};if(s(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(r(v))return{overrideIdentifier:v.languageId};if(i(v))return{resource:v.uri};if(v===null)return{resource:null}}let h=class{constructor(c,$,b){this.a=c.getProxy(N.$xM.MainThreadConfiguration),this.c=$,this.b=b,this.d=new T.$mh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(c,$))}};e.$mkc=h,e.$mkc=h=Je([We(0,u.$UO),We(1,R.$lkc),We(2,w.$Tj)],h);class t{constructor(c,$,b,p){this.a=new O.$_d,this.b=c,this.f=p,this.c=$,this.e=d.$ro.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=d.$ro.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,b))}getConfiguration(c,$,b){const p=a($)||{},l=this.g(c?n(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,b?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(S){return typeof n(l,S)<"u"},get:(S,k)=>{this.h(c?`${c}.${S}`:S,p,b?.identifier);let P=n(l,S);if(typeof P>"u")P=k;else{let C;const W=(V,q)=>{if((0,E.$3f)(V)){let A;const U=()=>{C=C||(0,I.$Tn)(l),A=A||n(C,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return U(),()=>A;if(C)return A=A||n(C,q),A[ie];const fe=K[ie];return typeof ie=="string"?W(fe,`${q}.${ie}`):fe},set:(K,ie,fe)=>(U(),A&&(A[ie]=fe),!0),deleteProperty:(K,ie)=>(U(),A&&delete A[ie],!0),defineProperty:(K,ie,fe)=>(U(),A&&Object.defineProperty(A,ie,fe),!0)})}return Array.isArray(V)?(0,I.$Tn)(V):V};P=W(P,S)}return P},update:(S,k,P,C)=>{S=c?`${c}.${S}`:S;const W=D(P);return k!==void 0?this.b.$updateConfigurationOption(W,S,k,p,C):this.b.$removeConfigurationOption(W,S,p,C)},inspect:S=>{S=c?`${c}.${S}`:S;const k=this.e.inspect(S,p,this.c.workspace);if(k)return{key:S,defaultValue:(0,I.$Tn)(k.policy?.value??k.default?.value),globalValue:(0,I.$Tn)(k.user?.value??k.application?.value),workspaceValue:(0,I.$Tn)(k.workspace?.value),workspaceFolderValue:(0,I.$Tn)(k.workspaceFolder?.value),defaultLanguageValue:(0,I.$Tn)(k.default?.override),globalLanguageValue:(0,I.$Tn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,I.$Tn)(k.workspace?.override),workspaceFolderLanguageValue:(0,I.$Tn)(k.workspaceFolder?.override),languageIds:(0,I.$Tn)(k.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Wn)(g,l,!1),Object.freeze(g)}g(c){const $=b=>(0,E.$3f)(b)?new Proxy(b,{get:(p,l)=>$(p[l]),set:(p,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(p,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(p,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return $(c)}h(c,$,b){const p=f.$io.test(c)?4:this.d.get(c),l=b?`[${b.value}] `:"";if(p===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const b=new d.$to(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,l)=>b.affectsConfiguration(p,a(l))})}k(c){return c.reduce(($,b)=>($.set(b[0],b[1]),$),new Map)}}e.$nkc=t,e.$okc=(0,y.$ni)("IExtHostConfiguration")}),define(Pe[119],Re([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,229,14]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(h||(h={}));var t;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(t||(t={}));var v;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(v||(v={}));var c;(function(W){function V(U){if(U){const K=U;return K&&!!K.process}else return!1}W.is=V;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=v.from(U.options)),K}W.from=q;function A(U){if(U!=null)return new M.$iN(U.process,U.args,U.options)}W.to=A})(c||(c={}));var $;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})($||($={}));var b;(function(W){function V(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=$.from(U.options)),K}W.from=q;function A(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new M.$jN(U.commandLine,U.options):new M.$jN(U.command,U.args?U.args:[],U.options)}W.to=A})(b||(b={}));var p;(function(W){function V(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(U){return{customExecution:"customExecution"}}W.from=q;function A(U,K){return K.get(U)}W.to=A})(p||(e.CustomExecutionDTO=p={}));var l;(function(W){function V(q,A){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?U=A.workspaceFile:U=i.$DH),{id:q._id,workspaceFolder:U}}W.from=V})(l||(e.TaskHandleDTO=l={}));var D;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(D||(D={}));var g;(function(W){function V(U,K){if(U==null)return[];const ie=[];for(const fe of U){const Se=q(fe,K);Se&&ie.push(Se)}return ie}W.fromMany=V;function q(U,K){if(U==null)return;let ie;U.execution instanceof M.$iN?ie=c.from(U.execution):U.execution instanceof M.$jN?ie=b.from(U.execution):U.execution&&U.execution instanceof M.$kN&&(ie=p.from(U.execution));const fe=h.from(U.definition);let Se;return U.scope?typeof U.scope=="number"?Se=U.scope:Se=U.scope.uri:Se=M.TaskScope.Workspace,!fe||!Se?void 0:{_id:U._id,definition:fe,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:Se},execution:ie,isBackground:U.isBackground,group:D.from(U.group),presentationOptions:t.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=q;async function A(U,K,ie){if(U==null)return;let fe;c.is(U.execution)?fe=c.to(U.execution):b.is(U.execution)?fe=b.to(U.execution):p.is(U.execution)&&(fe=p.to(U._id,ie));const Se=h.to(U.definition);let ke;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?ke=U.source.scope:ke=await K.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):ke=M.TaskScope.Workspace),!Se||!ke)return;const oe=new M.$lN(Se,ke,U.name,U.source.label,fe,U.problemMatchers);return U.isBackground!==void 0&&(oe.isBackground=U.isBackground),U.group!==void 0&&(oe.group=M.$hN.from(U.group._id),oe.group&&U.group.isDefault&&(oe.group=new M.$hN(oe.group.id,oe.group.label),U.group.isDefault===!0&&(oe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(oe.presentationOptions=t.to(U.presentationOptions)),U._id&&(oe._id=U._id),U.detail&&(oe.detail=U.detail),oe}W.to=A})(g||(e.TaskDTO=g={}));var S;(function(W){function V(A){return A}W.from=V;function q(A){if(A)return Object.assign(Object.create(null),A)}W.to=q})(S||(S={}));class k{#e;constructor(V,q,A){this._id=q,this.a=A,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let P=class{constructor(V,q,A,U,K,ie,fe,Se){this.q=new R.$_d,this.r=new R.$_d,this.s=new R.$_d,this.u=new R.$_d,this.a=V.getProxy(N.$xM.MainThreadTask),this.b=A,this.c=U,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=Se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,A){if(!A)return new M.$zM(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:A,extension:V}),this.a.$registerTaskProvider(U,q),new M.$zM(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(S.from(V)).then(async q=>{const A=[];for(const U of q){const K=await g.to(U,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,A){const U=this.m.get(V.id);U&&(this.o.set(V.id,U),this.e.attachPtyToTerminal(q,await U.callback(A))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));const U=[],K=(0,O.$fh)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,U,A,ie));return new Promise(ie=>{K.then(fe=>{Promise.all(U).then(()=>{ie(fe)})})})}async $resolveTask(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const U=await g.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(U,T.CancellationToken.None);if(!K)return;this.A(K,A);const ie=g.from(K,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,A){const U=await this.a.$createTaskId(V);!A&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(V.id);if(A)return A;let U;return q?U=Promise.resolve(new k(this,V.id,q)):U=g.to(V.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new k(this,V.id,K)}),this.l.set(V.id,U),U.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const A=this.n.values();let U=A.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=A.next()}};e.$Olc=P,e.$Olc=P=Je([We(0,u.$UO),We(1,w.$$O),We(2,d.$lkc),We(3,f.$6O),We(4,E.$okc),We(5,y.$Mkc),We(6,s.$Tj),We(7,r.$Yjc)],P);let C=class extends P{constructor(V,q,A,U,K,ie,fe,Se){super(V,q,A,U,K,ie,fe,Se),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=g.from(q,V);if(A===void 0)throw new Error("Task is not valid");if(p.is(A.execution))await this.y(A,q,!1);else throw new a.$_;const U=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),U}v(V,q,A,U){const K=[];if(U)for(const ie of U){if(this.A(ie,A),!ie.definition||!V[ie.definition.type]){const Se=ie.source?ie.source:"No task source";this.f.warn(`The task [${Se}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=g.from(ie,A.extension);fe&&p.is(fe.execution)?(K.push(fe),q.push(this.y(fe,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(V){if(p.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,A){}};e.$Plc=C,e.$Plc=C=Je([We(0,u.$UO),We(1,w.$$O),We(2,d.$lkc),We(3,f.$6O),We(4,E.$okc),We(5,y.$Mkc),We(6,s.$Tj),We(7,r.$Yjc)],C),e.$Qlc=(0,m.$ni)("IExtHostTask")}),define(Pe[288],Re([1,0,45,29]),function(ge,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=void 0,e.$aL=R,e.$cL=N;function R(M){return"cellResults"in M}e.$bL="rawCell#";function N(M,d){let f=-1;const E=[];let T=[];return M.forEach(u=>{u.range.startLineNumber!==f&&T.length>0&&(E.push([...T]),T=[]),T.push(u),f=u.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(u=>{const w=[],m=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let o=m;o<=n;o++)w.push(d.getLineContent(o));return new I.$QK(w.join(`
`)+`
`,u.map(o=>new O.$ht(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[289],Re([1,0,169,22,5,6,28,15,17,2,43,74,4,31,8,7,34,264,112,26,12,219,288,286]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,p,l,D,g,S){this.q=l,this.r=D,this.s=g,this.t=S,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$_d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$_d,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$_d,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$_d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$Wjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=b.getProxy(u.$xM.MainThreadNotebook),this.c=b.getProxy(u.$xM.MainThreadNotebookDocuments),this.d=b.getProxy(u.$xM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,C=k.cell.handle,V=this.g.get(P)?.getCell(C);if(V)return V.apiCell}if(k&&k.$mid===14){const P=k.uri,C=this.g.get(P);if(C)return C.apiNotebook}return k}}),c.B(p)}getEditorById(b){const p=this.h.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(b){for(const[p,l]of this.h)if(l.apiEditor===b)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,p){const l=this.g.get(b);if(!l&&!p)throw new Error(`NO notebook document for '${b}'`);return l}static u(b,p){if(!p)return;const l=p.filenamePattern.map(D=>m.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:l,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,l){const D=c.a++,g=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,g,p);let S;return g!==void 0&&(S=l.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(g))),new n.$zM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,g),S?.dispose()})}async createNotebookDocument(b){const p=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&m.NotebookData.from(b.content)});return E.URI.revive(p)}async openNotebookDocument(b){const p=this.g.get(b);if(p)return p.apiNotebook;const l=await this.c.$tryOpenNotebook(b),D=this.g.get(E.URI.revive(l));return(0,f.$_f)(D?.apiNotebook)}async showNotebookDocument(b,p){E.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let l;typeof p=="object"?l={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,l),g=D&&this.h.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,l,D){const g=this.f.get(b),S=E.URI.revive(p),k=this.g.get(S);if(!k||!g)return;const P=k.getCellFromIndex(l);if(!P)return;const C=await g.provideCellStatusBarItems(P.apiCell,D);if(!C)return;const W=new N.$Tc,V=this.p.add([W]),A=(Array.isArray(C)?C:[C]).map(U=>m.NotebookStatusBarItem.from(U,this.i,W));return{cacheId:V,items:A}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,p,l,D,g){if((0,d.$Ze)(p))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:p,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:b.identifier,location:b.extensionLocation},p,m.NotebookDocumentContentOptions.from(D),c.u(b,g)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(b,p,l){const D=this.x.get(b);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(p.buffer,l);return new o.$jw(m.NotebookData.from(g))}async $notebookToData(b,p,l){const D=this.x.get(b);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(m.NotebookData.to(p.value),l);return O.$ze.wrap(g)}async $saveNotebook(b,p,l,D,g){const S=E.URI.revive(p),k=this.x.get(b);if(!k)throw new Error("NO serializer found");const P=this.g.get(S);if(!P)throw new Error("Document NOT found");if(P.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new T.$cl((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const C={metadata:(0,i.$2n)(P.apiNotebook.metadata,U=>!(k.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of P.apiNotebook.getCells()){const K=new n.$2N(U.kind,U.document.getText(),U.document.languageId,U.mime,k.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,i.$2n)(U.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),C.cells.push(K)}const W=await k.serializer.serializeNotebook(C,g);await this.s.value.writeFile(S,W);const V=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:V.basename(S),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$nl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(b,p,l,D,g){const S=this.x.get(b)?.serializer;if(!S)return{limitHit:!1,results:[]};const k=new M.$Cc;await(async(q,A,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const fe={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(fe,A,Se=>{Se.forEach(ke=>{k.has(ke)||D.some($e=>K.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(ne=>(0,v.$Xfb)(ne,ke)))||k.add(ke)})}).catch(Se=>{if(Se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Se})}))))})(l,g,p);const C=new M.$Bc;let W=!1;const V=Array.from(k).map(async q=>{const A=[];try{if(g.isCancellationRequested)return;if(p.maxResults&&[...C.values()].reduce((fe,Se)=>fe+Se.cellResults.length,0)>p.maxResults){W=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(Se=>U.push({input:Se.document.getText(),outputs:Se.outputs.flatMap(ke=>ke.items.map(oe=>oe.data.toString()))}));else{const fe=await this.s.value.readFile(q),Se=O.$ze.fromString(fe.toString()),ke=await S.deserializeNotebook(Se.buffer,g);if(g.isCancellationRequested)return;m.NotebookData.from(ke).cells.forEach($e=>U.push({input:$e.source,outputs:$e.outputs.flatMap(ne=>ne.items.map(Ie=>Ie.valueBytes.toString()))}))}if(g.isCancellationRequested)return;U.forEach((fe,Se)=>{const ke=p.contentPattern.pattern,oe=new h.$0Vb(fe.input,void 0,fe.outputs),$e=oe.findInInputs(ke),ne=oe.findInOutputs(ke),Ie=ne.flatMap(ze=>(0,t.$cL)(ze.matches,ze.textBuffer)).map((ze,re)=>(ze.webviewIndex=re,ze));if($e.length>0||ne.length>0){const ze={index:Se,contentResults:(0,t.$cL)($e,oe.inputTextBuffer),webviewResults:Ie};A.push(ze)}});const ie={resource:q,cellResults:A};C.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...C.values()]}}async y(b,p){const l=await this.s.value.stat(b);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==T.$ml&&typeof l.mtime=="number"&&typeof l.size=="number"&&p.mtime<l.mtime&&p.etag!==T.$nl({mtime:p.mtime,size:l.size}))throw new T.$cl((0,I.localize)(1,null),3,p)}z(b){return b.scheme===a.Schemas.file?b.fsPath:b.toString()}A(b,p,l){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new r.$ilc(p,this.d,b,l.visibleRanges.map(m.NotebookRange.to),l.selections.map(m.NotebookRange.to),typeof l.viewColumn=="number"?m.ViewColumn.to(l.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const l of b.value.removedDocuments){const D=E.URI.revive(l),g=this.g.get(D);g&&(g.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(g.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(b.value.addedDocuments){const l=[];for(const D of b.value.addedDocuments){const g=E.URI.revive(D.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const S=new s.$hlc(this.c,this.q,this.r,g,D);l.push(...D.cells.map(k=>s.$glc.asModelAddData(k))),this.g.get(g)?.dispose(),this.g.set(g,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(b.value.addedEditors)for(const l of b.value.addedEditors){if(this.h.has(l.id))return;const D=E.URI.revive(l.documentUri),g=this.g.get(D);g&&this.A(g,l.id,l)}const p=[];if(b.value.removedEditors)for(const l of b.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const g=l.has(D.id);D._acceptVisibility(g)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(b){const p=w.$gP.String.with("notebookType","A notebook type"),l=new w.$iP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new w.$gP("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>O.$ze.wrap(g))],new w.$hP("Notebook Data",g=>m.NotebookData.to(g.value))),D=new w.$iP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new w.$gP("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$jw(m.NotebookData.from(g)))],new w.$hP("Bytes",g=>g.buffer));b.registerApiCommand(l),b.registerApiCommand(D)}}e.$rlc=c}),define(Pe[290],Re([1,0,19,24,42,36,23,65,45]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;class E{constructor(u,w,m){this.k=u,this.l=w,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&N.$hk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&N.$hk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const w=this.k.folderQueries||[];return new Promise((m,n)=>{const o=s=>{this.f++,u(s)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const r=s.toString(),i=I.$oc(r);this.j&&this.j(r,i)||this.v(o,{base:s,basename:i})}),Promise.all(w.map(s=>this.p(s,o))).then(s=>{m({limitHit:this.e,stats:s[0]||void 0})},s=>{n(new Error((0,R.$$i)(s)))})})}async p(u,w){const m=new O.$je,n=this.q(u),o=this.r(),s=new f.$5K(this.k,u),r=!s.hasSiblingExcludeClauses();let i;try{this.h.add(m),i=d.$8d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,m.token),h=i.elapsed(),t=d.$8d.create();return this.g&&!this.e||(a&&a.forEach(v=>{const c=I.$hc.relative(u.folder.path,v.path);if(r){const $=I.$oc(v.path);this.v(w,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,w)}),this.g&&!this.e)?null:(this.u(o,s,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(u){const w=(0,f.$4K)(this.k.includePattern,u.includePattern),m=(0,f.$4K)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:m,includes:w,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},w,m,n){if(m===this.a){const s=I.$oc(this.a);this.v(n,{base:w,relativePath:this.a,basename:s})}function o(s){const r=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:w,relativePath:s,basename:r})}o(m)}u({rootEntries:u,pathToEntries:w},m,n){const o=this,s=this.a;function r(i){const a=(0,f.$7K)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const v=i[h],{relativePath:c,basename:$}=v;if(m.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const b=w[c];if(b)r(b);else{if(c===s)continue;o.v(n,v)}if(o.e)break}}r(u)}v(u,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(w))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,w,m,n){const o=this.c(u.cacheKey),s=new E(u,w,o&&o.token);let r=0;const i=a=>{r+=a.length,m(a.map(h=>this.d(h)))};return this.e(s,T.a,i,n).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new O.$je),this.b.get(u)}d(u){return u.relativePath?{resource:M.$1g(u.base,u.relativePath)}:{resource:u.base}}e(u,w,m,n){const o=n.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(r.push(i),w>0&&r.length>=w&&(m(r),r=[]))};let r=[];return u.search(s).then(i=>(r.length&&m(r),o.dispose(),i),i=>(r.length&&m(r),o.dispose(),Promise.reject(i)))}}e.$jlc=T}),define(Pe[291],Re([1,0,18,259,36,96,28,12,19,23,15,17,2,95,186,48,13,49,107,287,45]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=void 0,e.$cM=D;let h=class{constructor(S,k,P,C,W){this.a=S,this.b=k,this.c=P,this.d=C,this.e=W}text(S,k,P={}){S=this.f(S,P);const C=this.a.getValue(),W=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(s.$Ii),P),type:2,contentPattern:S,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:C.search.usePCRE2||W||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(S,k){const P=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const C={...S,wordSeparators:P.editor.wordSeparators};return this.j(S,k)&&(C.isCaseSensitive=!0),this.k(S)&&(C.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),C}file(S,k={}){return{...this.h(S,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(S,k){return S?(S=Array.isArray(S)?S.map(b):b(S),k?this.parseSearchPaths(S):{pattern:v(...Array.isArray(S)?S:[S])}):{}}h(S=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),C=this.g(k.excludePattern,k.expandPatterns),W=S.length>1,V=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(U=>this.q(U,k,C)):S.map(U=>this.r(U,k,C,W))).filter(U=>!!U),q={_reason:k._reason,folderQueries:V,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:C.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const U=I.$Hb(I.$Rb(this.c.groups.map(fe=>fe.editors.map(Se=>Se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(fe=>(0,a.$UK)(q,fe.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=k.extraFileResources&&k.extraFileResources.filter(U=>(0,a.$UK)(q,U.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(S){const k=[],P=new M.$Bc,C={};let W=!1;return S.forEach(V=>{if(V.scheme===d.Schemas.walkThrough)return;if((0,E.$5g)(V)){const A=this.b.getWorkspaceFolder(V)?.uri??V.with({path:f.$nc(V.fsPath)});let U=P.get(A);U||(W=!0,U={folder:A,includePattern:{}},k.push(U),P.set(A,U));const K=f.$mc(A.fsPath,V.fsPath);(0,y.$_f)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,C[V.fsPath]=!0)}),{folderQueries:k,includePattern:C,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(S,k){if(k.isSmartCase){if(S.isRegExp){if(T.$Rf(S.pattern,!0))return!0}else if(T.$Rf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,w.$yC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const k=ie=>f.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),C=(Array.isArray(S)?S:c(S)).map(ie=>{const fe=this.e.resolvedUserHome;return fe?(0,N.$ow)(ie,fe.scheme===d.Schemas.file?fe.fsPath:fe.path):ie}),W=O.$K(C,ie=>k(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$$e(ie,"/")).map(ie=>T.$$e(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),$(ie))),q={},A=this.m(W.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const U=I.$Rb(V),K=v(...U);return K&&(q.pattern=K),q}l(S,k){return k.disregardExcludeSettings?void 0:(0,a.$TK)(S,!k.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const k=S.flatMap(C=>{let{pathPortion:W,globPortion:V}=t(C);return V&&(V=p(V)),this.n(W).flatMap(A=>this.o(A,V))}),P=new Map;return k.forEach(C=>{const W=C.searchPath.toString(),V=P.get(W);V?C.pattern&&(V.pattern=V.pattern||{},V.pattern[C.pattern]=!0):P.set(W,{searchPath:C.searchPath,pattern:C.pattern?v(C.pattern):void 0})}),Array.from(P.values())}n(S){if(f.$jc(S)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==d.Schemas.file?[{searchPath:k[0].uri.with({path:S})}]:[{searchPath:u.URI.file(f.$ic(S))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(S=b(S),S.startsWith("../")||S===".."){const C=f.$hc.resolve(k.path,S);return[{searchPath:k.with({path:C})}]}const P=p(S);return[{searchPath:k,pattern:P}]}else{if(S==="./"||S===".\\")return[];{const k=S.replace(/^\.[\/\\]/,""),C=this.b.getWorkspace().folders.map(W=>{const V=k.match(new RegExp(`^${T.$5e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(y.$9f);if(C.length)return C.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&p(V)}});{const W=S.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:S,q=m.localize(0,null,V);throw new Error(q)}}}}o(S,k){const P=S.pattern&&k?`${S.pattern}/${k}`:S.pattern||k,C=[{searchPath:S.searchPath,pattern:P}];return P&&!P.endsWith("**")&&C.push({searchPath:S.searchPath,pattern:P+"/**"}),C}q(S,k,P){const C=this.r((0,s.$Ii)(S.searchPath),k,P,!1);return C?{...C,includePattern:S.pattern}:null}r(S,k,P,C){let W;const V=u.URI.isUri(S)?S:S.uri;if(P.searchPaths){const ie=P.searchPaths.filter(fe=>(0,E.$Tg)(fe.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),U={...this.l(q,k)||{},...W||{}},K=u.URI.isUri(S)?(0,E.$Xg)(S):S.name;return{folder:V,folderName:C?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$bM=h,e.$bM=h=Je([We(0,n.$Ti),We(1,s.$wi),We(2,r.$FD),We(3,o.$Tj),We(4,i.$_L)],h);function t(g){const S=g.match(/[\*\{\}\(\)\[\]\?]/);if(S){const k=S.index,P=g.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let C=g.substr(0,P.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function v(...g){return g.length?g.reduce((S,k)=>(S[k]=!0,S),Object.create(null)):void 0}function c(g){return R.$fk(g,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(g){return[`**/${g}/**`,`**/${g}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function b(g){return g.replace(/\\/g,"/")}function p(g){return b(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,S){g=I.$Mb(g,C=>C.toString());const k=[],P=S.getWorkspace();return g&&g.forEach(C=>{let W;if(S.getWorkbenchState()===2)W=(0,E.$3g)(P.folders[0].uri,C),W&&W!=="."&&(W="./"+W);else{const V=S.getWorkspaceFolder(C);if(V){const q=V.name;if(P.folders.filter(U=>U.name===q).length===1){const U=(0,E.$3g)(V.uri,C);U===""?W=`./${V.name}`:W=`./${V.name}/${U}`}else W=C.fsPath}}W&&k.push(l(W))}),k}}),define(Pe[292],Re([1,0,23,2,24,14,3,291,45,49,11]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btb=u,e.$ctb=n;const y=7e3;function u(o,s){const r=s.activationEvents;if(!r)return Promise.resolve(void 0);const i=[],a=[];for(const b of r)if(/^workspaceContains:/.test(b)){const p=b.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?a.push(p):i.push(p)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,T.$gh)(),v=b=>t({activationEvent:b}),c=Promise.all(i.map(b=>w(o,b,v))).then(()=>{}),$=m(o,s.identifier,a,v);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function w(o,s,r){for(const i of o.folders)if(await o.exists(I.$1g(O.URI.revive(i),s))){r(`workspaceContains:${s}`);return}}async function m(o,s,r,i){if(r.length===0)return Promise.resolve(void 0);const a=new R.$je,h=o.checkExists(o.folders,r,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},y);let v=!1;try{v=await h}catch(c){N.$4(c)||N.$1(c)}a.dispose(),clearTimeout(t),v&&i(`workspaceContains:${r.join(",")}`)}function n(o,s,r,i){const a=o.get(M.$mi),h=o.get(f.$LK),v=a.createInstance(d.$bM).file(s.map(c=>(0,E.$Ii)(O.URI.revive(c))),{_reason:"checkExists",includePattern:r,exists:!0});return h.fileSearch(v,i).then(c=>!!c.limitHit,c=>N.$4(c)?!1:Promise.reject(c))}}),define(Pe[39],Re([1,0,165,19,89,23,11,6,52,2,13,4,38,225,82,37,25,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,292,81,209,12,79,65,21,80]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v,c,$,b,p,l,D,g,S,k,P,C,W,V,q,A,U,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$1kc=e.$Zkc=e.$Ykc=e.$Xkc=void 0,e.$Xkc=(0,c.$ni)("IHostUtils");let fe=ie=class extends d.$Uc{constructor(L,_,ve,Te,Ee,pe,de,Q,Y,ue,he,Ne,le){super(),this.Y=Ne,this.Z=le,this.a=this.B(new k.$_d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=ve,this.f=de,this.j=Te,this.m=Ee,this.s=pe,this.t=Y,this.u=ue,this.w=he,this.y=this.g.getProxy(y.$xM.MainThreadWorkspace),this.z=this.g.getProxy(y.$xM.MainThreadTelemetry),this.C=this.g.getProxy(y.$xM.MainThreadExtensionService),this.D=new M.$mh,this.F=new M.$mh,this.G=new M.$mh,this.H=new M.$mh,this.I=new ze(this.f.extensions.activationEvents),this.L=new s.$z$b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Jm(this.f.extensions.myExtensions);this.J=new s.$z$b(this.I,ne(this.L,Ce)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new m.$Ikc(this.g,this.s),this.N=new C.$Qkc(this.g),this.O=Q,this.h=L.createChild(new l.$li([m.$Jkc,this.M],[C.$Rkc,this.N])),this.P=this.B(new w.$Hkc(this.J,this.L,{onExtensionActivationError:(Ae,Ue,j)=>{this.C.$onExtensionActivationError(Ae,r.$3(Ue),j)},actualActivateExtension:async(Ae,Ue)=>{if(s.$z$b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Ue),new w.$Gkc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,Ue)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(L){r.$1(L)}}async $(){this.O.onWillDeactivateAll();let L=[];try{L=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.eb(Ee))}catch{}await Promise.all(L)}terminate(L,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${L}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const ve=this.$();Promise.race([(0,M.$oh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(L){return this.G.isOpen()?this.P.isActivated(L):!1}async getExtension(L){const _=await this.C.$getExtension(L);return _&&{..._,identifier:new i.$Im(_.identifier.value),extensionLocation:E.URI.revive(_.extensionLocation)}}ab(L,_){return this.P.activateByEvent(L,_)}bb(L,_){return this.P.activateById(L,_)}activateByIdWithErrors(L,_){return this.bb(L,_).then(()=>{const ve=this.P.getActivatedExtension(L);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(L=>this.J)}getExtensionExports(L){if(this.G.isOpen())return this.P.getActivatedExtension(L).exports;try{return this.P.getActivatedExtension(L).exports}catch{return null}}async cb(L){if(L.scheme===V.Schemas.file&&this.c.fsRealpath){const _=L.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const ve=await this.R.get(_);return E.URI.file(ve)}return L}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(L=>new Ie(L))),this.Q}async db(L){const _=f.$ti.forUris(ve=>N.$Rg.ignorePathCasing(ve));return await Promise.all(L.map(async ve=>{if(this.wb(ve)){const Te=await this.cb(ve.extensionLocation);_.set(Te,ve)}})),_}eb(L){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(L))return _;const ve=this.P.getActivatedExtension(L);if(!ve)return _;try{typeof ve.module.deactivate=="function"&&(_=Promise.resolve(ve.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${L.value}':`),this.s.error(Te)}try{(0,d.$Pc)(ve.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${L.value}':`),this.s.error(Te)}return _}async fb(L,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(L.identifier):await this.C.$onWillActivateExtension(L.identifier),this.hb(L,_).then(ve=>{const Te=ve.activationTimes;return this.C.$onDidActivateExtension(L.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,_),this.gb(L,_,"success",Te),ve},ve=>{throw this.gb(L,_,"failure"),ve})}gb(L,_,ve,Te){const Ee=ke(L,_);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Te||{},outcome:ve})}hb(L,_){const ve=ke(L,_);this.z.$publicLog2("activatePlugin",ve);const Te=this.wb(L);if(!Te)return Promise.resolve(new w.$Fkc(w.$Ckc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${L.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${L.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const Ee=new w.$Dkc(_.startup);return Promise.all([this.xb(L,(0,N.$1g)(L.extensionLocation,Te),Ee),this.ib(L)]).then(pe=>(R.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),ie.jb(this.s,L.identifier,pe[0],pe[1],Ee))).then(pe=>(R.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),pe))}ib(L){const _=this.Z.createLanguageModelAccessInformation(L),ve=new h.$Lkc(L,this.M),Te=new h.$Kkc(L.identifier.value,!1,this.M),Ee=new W.$Skc(L,this.N),pe=L.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([ve.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,ue;const he=(0,o.$gG)(L,"ipc")?this.f.messagePorts?.get(i.$Im.toKey(L.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Te,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ne){return O.$kc(L.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(L)?.fsPath},get globalStoragePath(){return Q.O.globalValue(L).fsPath},get logPath(){return O.$kc(Q.f.logsLocation.fsPath,L.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,L.identifier.value)},get storageUri(){return Q.O.workspaceValue(L)},get globalStorageUri(){return Q.O.globalValue(L)},get extensionMode(){return pe},get extension(){return Y===void 0&&(Y=new $e(Q,L.identifier,L,de,!1)),Y},get extensionRuntime(){return(0,o.$hG)(L,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(L)},get messagePassingProtocol(){if(!ue){if(!he)return;const Ne=k.Event.buffer(k.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),ue={onDidReceiveMessage:Ne,postMessage:he.postMessage.bind(he)}}return ue}})})}static jb(L,_,ve,Te,Ee){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(L,_,ve,Te,Ee).then(pe=>new w.$Ekc(!1,null,Ee.build(),ve,pe,Te.subscriptions))}static kb(L,_,ve,Te,Ee){if(typeof ve.activate=="function")try{Ee.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${_.value}`);const pe=typeof global=="object"?global:self,de=ve.activate.apply(pe,[Te]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(de).then(Q=>(Ee.activateResolveStop(),Q))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(ve)}lb(L,_){this.bb(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:_}).then(void 0,ve=>{this.s.error(ve)})}mb(L,_=0){const Te=Date.now();(0,U.$B)(()=>{for(let Ee=_;Ee<L.length;Ee+=1){const pe=L[Ee];for(const de of pe.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-Te>50){this.mb(L,Ee);break}else this.lb(pe,de)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(L=>{const _=L.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(_)this.mb(ve);else for(const Te of ve)if(Te.activationEvents)for(const Ee of Te.activationEvents)Ee==="onStartupFinished"&&this.lb(Te,Ee)})}ob(){const L=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const _=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(_),Te=this.rb(),Ee=Promise.all([Te,L,ve]).then(()=>{});return Promise.race([Ee,(0,M.$oh)(1e4)]).then(()=>{this.nb()}),Ee}pb(L){return L.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(L,_))).then(()=>{})}async qb(L,_){if(this.isActivated(_.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:L.map(pe=>pe.uri),forceUsingSearch:ve||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,de,Q)=>this.y.$checkExists(pe,de,Q)},Ee=await(0,P.$btb)(Te,_);if(Ee)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:Ee.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(L){throw console.error(L),L}}async sb(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:_}=this.f.environment;if(!L||!_)throw new Error(I.localize(0,null));const ve=await this.xb(null,_,new w.$Dkc(!1));if(!ve||typeof ve.run!="function")throw new Error(I.localize(1,null,_.toString()));return new Promise((Te,Ee)=>{const pe=(Y,ue)=>{Y?(U.$t&&this.s.error("Test runner called back with error",Y),Ee(Y)):(U.$t&&(ue?this.s.info(`Test runner called back with ${ue} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof ue=="number"&&ue>0?1:0))},de=(0,N.$Og)(_),Q=ve.run(de,pe);Q&&Q.then&&Q.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(Y=>{U.$t&&this.s.error("Test runner finished with error",Y),Ee(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$oh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(L,_){return this.S[L]=_,(0,d.$Sc)(()=>{delete this.S[L]})}async getRemoteExecServer(L){const{resolver:_}=await this.ub(L);return _?.resolveExecServer?.(L,{resolveAttempt:0})}async ub(L){const _=L.indexOf("+");if(_===-1)throw new t.$FM("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=L.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(L,_){const ve=A.$8d.create(!1),Te=()=>`[resolveAuthority(${(0,v.$Cl)(L)},${_})][${ve.elapsed()}ms] `,Ee=z=>this.s.info(`${Te()}${z}`),pe=z=>this.s.warn(`${Te()}${z}`),de=(z,G=void 0)=>this.s.error(`${Te()}${z}`,G),Q=z=>{if(z instanceof t.$FM)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},Y=async z=>{Ee(`activating resolver for ${z}...`);const{resolver:G,authorityPrefix:H}=await this.ub(z);if(!G)throw de(`no resolver for ${H}`),new t.$FM(`No remote extension installed to resolve ${H}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:z}},ue=L.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${ue.join(" -> ")}`);let he;try{he=await Promise.all(ue.map(Y)).catch(async z=>{if(!(z instanceof t.$FM)||z._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return pe(`resolving nested authorities failed: ${z.message}`),[await Y(L)]})}catch(z){return Q(z)}const Ne=new M.$yh;Ne.cancelAndSet(()=>Ee("waiting..."),1e3);let le,Ce;for(const[z,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of he.entries())try{if(z===he.length-1)Ee("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),le=await H.resolve(ee,{resolveAttempt:_,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$EM.isManagedResolvedAuthority(le)?le:void 0));else{if(Ee(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:_,execServer:Ce}),!Ce)throw new t.$FM(`Exec server was not available for ${ee}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(se){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),de("returned an error",se),Ne.dispose(),Q(se)}Ne.dispose();const Ae={environmentTunnels:le.environmentTunnels,features:le.tunnelFeatures?{elevation:le.tunnelFeatures.elevation,privacyOptions:le.tunnelFeatures.privacyOptions,protocol:le.tunnelFeatures.protocol===void 0?!0:le.tunnelFeatures.protocol}:void 0},Ue={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted,authenticationSession:le.authenticationSessionForInitializingExtensions?{id:le.authenticationSessionForInitializingExtensions.id,providerId:le.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${t.$EM.isManagedResolvedAuthority(le)?"managed authority":`${le.host}:${le.port}`}`);let j;if(t.$EM.isManagedResolvedAuthority(le)){const z=_;this.Y.setFactory(z,le.makeConnection),j={authority:L,connectTo:new v.$zl(z),connectionToken:le.connectionToken}}else j={authority:L,connectTo:new v.$Al(le.host,le.port),connectionToken:le.connectionToken};return{type:"ok",value:{authority:j,options:Ue,tunnelInformation:Ae}}}async $getCanonicalURI(L,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$Cl)(L)})`);const{resolver:ve}=await this.ub(L);if(!ve)return null;const Te=E.URI.revive(_);if(typeof ve.getCanonicalURI>"u")return Te;const Ee=await(0,M.$fh)(()=>ve.getCanonicalURI(Te));return Ee||Te}async $startExtensionHost(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:_,myExtensions:ve}=Se(this.I,this.L,this.J,L),Te=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(L,_){return _===1?this.D.wait().then(ve=>this.ab(L,!1)):this.G.wait().then(ve=>this.ab(L,!1))}async $activate(L,_){return await this.G.wait(),this.J.getExtensionDescription(L)?(await this.bb(L,_),!0):!1}async $deltaExtensions(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:_,myExtensions:ve}=Se(this.I,this.L,this.J,L),Te=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){const _=a.$ze.alloc(L),ve=Math.random()%256;for(let Te=0;Te<L;Te++)_.writeUInt8(ve,Te);return _}async $updateRemoteConnectionData(L){this.X=L,this.a.fire()}};e.$Ykc=fe,e.$Ykc=fe=ie=Je([We(0,c.$mi),We(1,e.$Xkc),We(2,p.$UO),We(3,n.$lkc),We(4,u.$okc),We(5,T.$Tj),We(6,$.$$O),We(7,b.$rkc),We(8,D.$eCb),We(9,g.$Mkc),We(10,q.$Ukc),We(11,K.$Vkc),We(12,S.$bkc)],fe);function Se(re,L,_,ve){re.addActivationEvents(ve.addActivationEvents);const Te=new s.$z$b(re,L.getAllExtensionDescriptions());Te.deltaExtensions(ve.toAdd,ve.toRemove);const Ee=new i.$Jm(_.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ve.myToRemove)Ee.delete(de);for(const de of ve.myToAdd)Ee.add(de);const pe=ne(Te,Ee);return{globalRegistry:Te,myExtensions:pe}}function ke(re,L){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}function oe(re){return re.getAllExtensionDescriptions().map(L=>L.identifier.value).join(",")}e.$Zkc=(0,c.$ni)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(L,_,ve,Te,Ee){this.#e=L,this.#t=_,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=O.$ic((0,N.$Og)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Te,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$1kc=$e;function ne(re,L){return re.getAllExtensionDescriptions().filter(_=>L.has(_.identifier))}class Ie{constructor(L){this.a=L}setSearchTree(L){this.a=L}findSubstr(L){return this.a.findSubstr(L)}forEach(L){return this.a.forEach(L)}}e.$2kc=Ie;class ze{constructor(L){this.a=new i.$Km,this.addActivationEvents(L)}readActivationEvents(L){return this.a.get(L.identifier)??[]}addActivationEvents(L){for(const _ of Object.keys(L))this.a.set(_,L[_])}}}),define(Pe[293],Re([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let n=class{constructor(a,h,t,v,c,$,b){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.h=$,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$$lc=n,e.$$lc=n=Je([We(2,T.$mi),We(3,N.$okc),We(4,y.$Zkc),We(5,E.$$O),We(6,u.$Tj)],n);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&m.a.size){const h=(0,w.$5e)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",v=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,v,c]=h,$=m.a.get(v);if($!==void 0)return console.warn(`${v} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=m=Je([We(0,E.$$O)],o);class s{constructor(a,h,t,v,c){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.nodeModuleName="vscode",this.a=new d.$Km}load(a,h){const t=this.d.findSubstr(h);if(t){let v=this.a.get(t.identifier);return v||(v=this.c(t,this.e,this.f),this.a.set(t.identifier,v)),v}if(!this.b){let v="";this.d.forEach((c,$)=>v+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${v}`),this.b=this.c(M.$bG,this.e,this.f)}return this.b}}let r=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$xM.MainThreadTelemetry);const v=t.getProxy(R.$xM.MainThreadWindow);this.c=(c,$)=>{const b=O.URI.parse(c);return $?this.g(c,$):b.scheme==="http"||b.scheme==="https"?v.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?v.$openUri(b,c,{}):this.g(c,$)}}load(a,h,t){const v=this.e.findSubstr(h);return v&&(this.a=v.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Je([We(2,f.$UO)],r)}),define(Pe[120],Re([1,0,40,6,19,73,3,67,66,39,7,37,222,38]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=void 0,e.$3kc=(0,M.$ni)("IExtHostVariableResolverProvider");class m extends u.$WP{constructor(s,r,i,a,h,t,v){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const b=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof T.$kO||b.input instanceof T.$pO)return b.input.modified;if(b.input instanceof T.$jO||b.input instanceof T.$oO||b.input instanceof T.$mO)return b.input.uri}}}super({getFolderUri:$=>{const b=t.folders.filter(p=>p.name===$);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,b)=>h.getConfiguration(void 0,$).get(b),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return R.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const $=c();if($){const b=r.getWorkspaceFolder($);if(b)return R.$ic(b.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(N.env))}}let n=class extends O.$Uc{constructor(s,r,i,a,h){super(),this.b=s,this.c=r,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$4kc=n,e.$4kc=n=Je([We(0,E.$Zkc),We(1,y.$lkc),We(2,d.$6O),We(3,w.$okc),We(4,f.$Akc)],n)}),define(Pe[121],Re([1,0,11,5,2,20,3,4,66,39,16,7,37,214,216,38,120,6,41,31,8]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=e.$8kc=e.$7kc=e.$6kc=e.$5kc=void 0,e.$5kc=(0,M.$ni)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,g,S,k,P,C){this.N=D,this.O=g,this.P=S,this.Q=k,this.R=P,this.S=C,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$_d,this.o=new O.$_d,this.q=new O.$_d,this.w=new O.$_d,this.l=l.getProxy(d.$xM.MainThreadDebugService),this.A=new O.$_d,this.C=new O.$_d,this.y=new v(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(l,D){const g=this.W(D);if(!g)return;const S=await this.H.get(l)?.getTreeItem?.(g);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,g){const S=N.$Im.toKey(l.identifier),k=this.jb(S,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(k,g),this.l.$registerDebugVisualizerTree(k,!!g.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const g=this.J.get(D)?.item;return g?(await this.H.get(l)?.getChildren?.(g))?.map(k=>this.U(l,k))||[]:[]}async $editVisualizerTreeItem(l,D){const g=this.J.get(l);if(!g)return;const S=await this.H.get(g.provider)?.editItem?.(g.item,D);return this.U(g.provider,S||g.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const g=[D.children];for(const S of g)if(S)for(const k of S)g.push(this.J.get(k)?.children),this.J.delete(k)}U(l,D){let g=this.I.get(D);return g||(g=this.F++,this.I.set(D,g),this.J.set(g,{provider:l,item:D})),a.DebugTreeItem.from(D,g)}asDebugSourceUri(l,D){const g=l;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let S=`debug:${encodeURIComponent(g.path||"")}`,k="?";return D&&(S+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),S+=`${k}ref=${g.sourceReference}`,R.URI.parse(S)}else{if(g.path)return R.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const g of l.getAllExtensionDescriptions())if(g.contributes){const S=g.contributes.debuggers;if(S&&S.length>0)for(const k of S)(0,m.$TG)(k)&&D.push(k.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const g=this.L.get(l);if(!g)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:k,extensionId:P}=g;if(S.visualization||(S=await k.resolveDebugVisualization?.(S,D)||S,g.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(P,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const g=D.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,g,S){const k=this.W(g),P=this.jb(l,D),C=this.G.get(P);if(!k||!C)return[];const W=await C.provideDebugVisualization(k,S);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:C,extensionId:l});const A=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(l,V.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,g){if(!l.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=N.$Im.toKey(l.identifier),k=this.jb(S,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(k,g),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(k=>{const P=k.id;return this.z.has(P)?!1:(this.z.set(P,k),!0)});this.gb(D,[],[]);const g=[],S=new Map;for(const k of D)if(k instanceof y.$AN){let P=S.get(k.location.uri.toString());P||(P={type:"sourceMulti",uri:k.location.uri,lines:[]},S.set(k.location.uri.toString(),P),g.push(P)),P.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof y.$BN&&g.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(l){const D=l.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const g=D.filter(P=>P instanceof y.$AN).map(P=>P.id),S=D.filter(P=>P instanceof y.$BN).map(P=>P.id),k=D.filter(P=>P instanceof y.$CN).map(P=>P.id);return this.l.$unregisterBreakpoints(g,S,k)}startDebugging(l,D,g){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,g){if(!D)return new y.$zM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new y.$zM(()=>{this.f=this.f.filter(k=>k.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,g){if(!g)return new y.$zM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new y.$zM(()=>{this.h=this.h.filter(k=>k.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new y.$zM(()=>{});const g=this.j++;return this.k.push({type:l,handle:g,factory:D}),new y.$zM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let g;const S=await this.ib(l);return S&&(g={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const g=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const P=this.Z(k),C=this.X(P,S);if(!C)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const W=C;return this.D.set(l,W),this.db(S).then(V=>(V&&this.E.set(l,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,U={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);U.body={signature:K},W.sendResponse(U)}else throw new Error("no signer")}catch(K){U.success=!1,U.message=K.message,W.sendResponse(U)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,m.$YG)(q,!0),g.l.$acceptDAMessage(l,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(l,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(l,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(l,D){D=(0,m.$XG)(D,!1);const g=this.E.get(l);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const g=this.D.get(l);return this.D.delete(l),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],g=[],S=[];if(l.added)for(const k of l.added){const P=k.id;if(P&&!this.z.has(P)){let C;if(k.type==="function")C=new y.$BN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")C=new y.$CN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const W=R.URI.revive(k.uri);C=new y.$AN(new y.$LM(W,new y.$AM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,y.$yN)(C,P),this.z.set(P,C),D.push(C)}}if(l.removed)for(const k of l.removed){const P=this.z.get(k);P&&(this.z.delete(k),g.push(P))}if(l.changed){for(const k of l.changed)if(k.id){const P=this.z.get(k.id);if(P){if(P instanceof y.$BN&&k.type==="function"){const C=P;C.enabled=k.enabled,C.condition=k.condition,C.hitCondition=k.hitCondition,C.logMessage=k.logMessage,C.functionName=k.functionName}else if(P instanceof y.$AN&&k.type==="source"){const C=P;C.enabled=k.enabled,C.condition=k.condition,C.hitCondition=k.hitCondition,C.logMessage=k.logMessage,C.location=new y.$LM(R.URI.revive(k.uri),new y.$AM(k.line,k.character))}S.push(P)}}}this.gb(D,g,S)}async $acceptStackFrameFocus(l){let D;if(l){const g=await this.hb(l.sessionId);l.kind==="thread"?D=new y.$IN(g.api,l.threadId):D=new y.$HN(g.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,g){return(0,I.$fh)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(D);return S.provideDebugConfigurations(k,g)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,g,S){return(0,I.$fh)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return k.resolveDebugConfiguration(P,g,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,g,S){return(0,I.$fh)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return k.resolveDebugConfigurationWithSubstitutedVariables(P,g,S)})}async $provideDebugAdapter(l,D){const g=this.ab(l);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(g,S).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof y.$DN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof y.$EN)return{type:"server",port:l.port,host:l.host};if(l instanceof y.$FN)return{type:"pipeServer",path:l.path};if(l instanceof y.$GN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(g=>g.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(g=>g.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(g=>g.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const g=l.contributes.debuggers;if(g&&g.length>0){for(const S of g)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const g=l.configuration.type,S=this.k.filter(k=>k.type===g||k.type==="*").map(k=>(0,I.$fh)(()=>k.factory.createDebugAdapterTracker(l.api)).then(P=>P,P=>null));return Promise.race([Promise.all(S).then(k=>{const P=k.filter(C=>!!C);if(P.length>0)return new c(P)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(l,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new y.$EN(g));if(l){const k=await this.O.getExtensionRegistry();return(0,I.$fh)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,k))).then(P=>{if(P)return P})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,g){(l.length>0||D.length>0||g.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:g}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const g=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,g,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=R.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let g,S;return"id"in D?S=r.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:S}}mb(l){if(l instanceof y.$vN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,g=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof g=="string"?R.URI.file(g):g}}};e.$6kc=h,e.$6kc=h=Je([We(0,T.$UO),We(1,u.$lkc),We(2,E.$Zkc),We(3,n.$okc),We(4,f.$Akc),We(5,o.$3kc),We(6,i.$eP)],h);class t{constructor(l,D,g,S,k,P,C){this.f=l,this.g=D,this.h=g,this.j=S,this.k=k,this.l=P,this.m=C}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,g){return l.f.$customDebugAdapterRequest(l.g,D,g)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$7kc=t;class v{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$8kc=v;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(g=>g.onExit?g.onExit(l,D):void 0)}}class $ extends w.$gob{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends h{constructor(l,D,g,S,k,P,C){super(l,D,g,S,k,P,C)}};e.$9kc=b,e.$9kc=b=Je([We(0,T.$UO),We(1,u.$lkc),We(2,E.$Zkc),We(3,n.$okc),We(4,f.$Akc),We(5,o.$3kc),We(6,i.$eP)],b)}),define(Pe[294],Re([1,0,14,89,2,4,243,13,55,71,27,191,16,60,39,62]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=e.$_lc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(d.$Tj),t=i.get(u.$UO).getProxy(N.$xM.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{a.error(v);const c=I.$3(v);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(d.$Tj),h=i.get(u.$UO),t=i.get(m.$Zkc),v=i.get(n.$cP),c=h.getProxy(N.$xM.MainThreadExtensionService),$=h.getProxy(N.$xM.MainThreadErrors),b=await t.getExtensionPathIndex(),p=new WeakMap;function l(S,k){if(p.has(S))return p.get(S).stack;let P="",C,W;for(const q of k)P+=`
	at ${q.toString()}`,W=q.getFileName(),!C&&W&&(C=b.findSubstr(R.URI.file(W)));const V=`${S.name||"Error"}: ${S.message||""}${P}`;return p.set(S,{extensionIdentifier:C?.identifier,stack:V}),V}const D=Symbol("prepareStackTrace wrapped");let g=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(S){if(S===l||!S||S[D]){g=S||l;return}g=function(k,P){return l(k,P),S.call(Error,k,P)},Object.assign(g,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const k=I.$3(S),P=p.get(S);if(!P?.extensionIdentifier){$.$onUnexpectedError(k);return}c.$onExtensionRuntimeError(P.extensionIdentifier,k);const C=v.onExtensionError(P.extensionIdentifier,S);a.trace("forwarded error to extension?",C,P)})}}e.$_lc=o;class s{constructor(i,a,h,t,v){this.a=h,this.b=new M.$H$b(i,null,t),a=s.e(a,this.b);const c=new E.$li(...(0,f.$ms)());c.set(T.$$O,{_serviceBrand:void 0,...a,messagePorts:v}),c.set(u.$UO,new u.$VO(this.b)),c.set(w.$ikc,new w.$jkc(t)),c.set(m.$Xkc,h);const $=new y.$4q(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(b=>b.get(d.$Tj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(b=>b.get(m.$Zkc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(N.$xM.MainThreadExtensionService);return R.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>R.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$amc=s}),define(Pe[295],Re([1,0,18,11,24,42,12,19,23,2,45]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$llc=e.$klc=void 0,e.$mlc=n;class y{constructor(r,i,a){this.d=r,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(r,i){const a=this.g.folderQueries||[],h=new R.$je(i);return new Promise((t,v)=>{this.a=new w(r);let c=!1;const $=(b,p)=>{if(!c&&!this.b){const l=this.h(b);n(b)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),b=this.j(b,this.g.maxResults-this.c));const D=this.h(b);this.c+=D,(D>0||!n(b))&&this.a.add(b,p)}};Promise.all(a.map((b,p)=>this.k(b,l=>$(l,p),h.token))).then(b=>{h.dispose(),this.a.flush();const p=b.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||p,messages:(0,I.$Rb)(b.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},b=>{h.dispose();const p=(0,N.$$i)(b);v(new Error(p))})})}h(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,i){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:r.preview.text},uri:r.uri}}async k(r,i,a){const h=new T.$5K(this.g,r),t=[],v={report:b=>{if(!this.l(b))return;const p=r.folder.scheme===M.Schemas.file?(0,T.$6K)(()=>this.e.readdir(f.$Zg(b.uri))):void 0,l=f.$3g(r.folder,b.uri);if(l){const D=h.includedInQuery(l,d.$oc(l),p);(0,O.$_g)(D)?t.push(D.then(g=>{g&&i(b)})):D&&i(b)}}},c=this.n(r);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,v,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,v,a),t.length&&await Promise.all(t),$}l(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const i=(0,T.$4K)(this.g.includePattern,r.includePattern),a=(0,T.$4K)(this.g.excludePattern,r.excludePattern),h={folder:E.URI.from(r.folder),excludes:a,includes:i,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.e.toCanonicalName(r.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$klc=y;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(r,i){this.d&&(this.b!==i||!f.$Tg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:r.uri,results:[]}),this.d.results.push(m(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$llc=w;function m(s){return n(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function n(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(r,i){this.g=r,this.h=i,this.c=0,this.d=[],this.e=0}addItem(r,i){r&&this.j(r,i)}addItems(r,i){r&&this.k(r,i)}j(r,i){this.d.push(r),this.e+=i,this.l()}k(r,i){this.d=this.d.concat(r),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$nlc=o}),define(Pe[122],Re([1,0,6,4,3,290,16,60,13,2,295]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0,e.$qlc=u,e.$olc=(0,R.$ni)("IExtHostSearch");let y=class{constructor(n,o,s){this.n=n,this.o=o,this.q=s,this.c=this.n.getProxy(O.$xM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$jlc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.g.delete(n),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.i.delete(n),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.k.delete(n),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,o,s,r){const i=u(s),a=this.j.get(n);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(n,o,h.map(t=>t.resource))},r);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,s){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,s,r){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${n}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$provideAITextSearchResults(n,o,s,r){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${n}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$enableExtensionHostSearch(){}t(n,o){return new T.$klc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(n,o){return new T.$klc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$plc=y,e.$plc=y=Je([We(0,M.$UO),We(1,d.$ikc),We(2,f.$Tj)],y);function u(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(n=>E.URI.revive(n))}}function w(m){return{...m,folder:E.URI.revive(m.folder)}}}),define(Pe[296],Re([1,0,24,14,5,6,12,32,2,151,147,135,94,20,43,13,58,59,204,4,246,274,78,84,251,231,252,88,253,232,220,31,254,38,255,121,110,256,234,247,257,258,67,66,248,39,260,64,261,44,27,275,276,235,262,263,79,80,237,289,265,208,266,277,267,116,238,268,269,270,16,271,122,81,272,239,273,82,85,119,62,51,278,279,249,280,281,86,8,7,240,60,241,63,282,283,109,37,215,77,25,118,114]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v,c,$,b,p,l,D,g,S,k,P,C,W,V,q,A,U,K,ie,fe,Se,ke,oe,$e,ne,Ie,ze,re,L,_,ve,Te,Ee,pe,de,Q,Y,ue,he,Ne,le,Ce,Ae,Ue,j,z,G,H,ee,se,Oe,Be,Qe,Ye,et,at,it,tt,ct,ft,je,st,X,Z,me,qe,we,ot,dt,Ct,jt,_t,Jt,ei,Dt,Wt,Qt,Xe,ai,ti){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=ii;function ii(lt){const vt=lt.get(re.$$O),si=lt.get(ze.$3jc),ni=lt.get(ne.$qkc),Tt=lt.get(oe.$Zkc),mt=lt.get(Dt.$lkc),Rt=lt.get(tt.$cP),qt=lt.get(P.$okc),Zt=lt.get(dt.$ikc),He=lt.get(H.$UO),Xt=lt.get(et.$Jkc),Ut=lt.get(at.$rkc),Bt=lt.get(n.$Uj),$t=lt.get(n.$Tj),Ft=lt.get(me.$eCb),At=lt.get(t.$Yjc),Lt=lt.get(ei.$4lc),ri=lt.get(Oe.$Rkc),oi=lt.get(Se.$Akc),Vt=lt.get(de.$Vkc),Pt=lt.get(v.$9jc),kt=lt.get(p.$bkc);He.set(i.$yM.ExtHostFileSystemInfo,si),He.set(i.$yM.ExtHostLogLevelServiceShape,Bt),He.set(i.$yM.ExtHostWorkspace,mt),He.set(i.$yM.ExtHostConfiguration,qt),He.set(i.$yM.ExtHostExtensionService,Tt),He.set(i.$yM.ExtHostStorage,Xt),He.set(i.$yM.ExtHostTunnelService,Ft),He.set(i.$yM.ExtHostWindow,Lt),He.set(i.$yM.ExtHostSecretState,ri),He.set(i.$yM.ExtHostTelemetry,Rt),He.set(i.$yM.ExtHostEditorTabs,oi),He.set(i.$yM.ExtHostManagedSockets,Vt),He.set(i.$yM.ExtHostAuthentication,Pt),He.set(i.$yM.ExtHostChatProvider,kt);const Yt=He.set(i.$yM.ExtHostDecorations,lt.get(V.$$kc)),St=He.set(i.$yM.ExtHostDocumentsAndEditors,lt.get(fe.$6O)),yt=He.set(i.$yM.ExtHostCommands,lt.get(S.$eP)),It=He.set(i.$yM.ExtHostTerminalService,lt.get(ct.$Mkc)),li=He.set(i.$yM.ExtHostTerminalShellIntegration,lt.get(ti.$5lc)),Et=He.set(i.$yM.ExtHostDebugService,lt.get(W.$5kc)),hi=He.set(i.$yM.ExtHostSearch,lt.get(se.$olc)),zt=He.set(i.$yM.ExtHostTask,lt.get(it.$Qlc)),vi=He.set(i.$yM.ExtHostOutputService,lt.get(Ae.$Dlc)),Ht=He.set(i.$yM.ExtHostLocalization,lt.get(pe.$Ukc)),gi=He.set(i.$yM.ExtHostUrls,new Ct.$1lc(He)),Ot=He.set(i.$yM.ExtHostDocuments,new ie.$6jc(He,St)),be=He.set(i.$yM.ExtHostDocumentContentProviders,new U.$alc(He,St,$t)),Me=He.set(i.$yM.ExtHostDocumentSaveParticipant,new K.$blc($t,Ot,He.getProxy(i.$xM.MainThreadBulkEdits))),ae=He.set(i.$yM.ExtHostNotebook,new Y.$rlc(He,yt,St,Ot,ni,hi)),J=He.set(i.$yM.ExtHostNotebookDocuments,new he.$xlc(ae)),ye=He.set(i.$yM.ExtHostNotebookEditors,new Ne.$ylc($t,ae)),Ve=He.set(i.$yM.ExtHostNotebookKernels,new le.$zlc(He,vt,ae,yt,$t)),Ze=He.set(i.$yM.ExtHostNotebookRenderers,new Ce.$Blc(He,ae)),Ge=He.set(i.$yM.ExtHostNotebookDocumentSaveParticipant,new ue.$wlc($t,ae,He.getProxy(i.$xM.MainThreadBulkEdits))),nt=He.set(i.$yM.ExtHostEditors,new je.$fkc(He,St)),wt=He.set(i.$yM.ExtHostTreeViews,new Z.$Ylc(He.getProxy(i.$xM.MainThreadTreeViews),yt,$t)),Gt=He.set(i.$yM.ExtHostEditorInsets,new g.$gkc(He.getProxy(i.$xM.MainThreadEditorInsets),nt,vt.remote)),xt=He.set(i.$yM.ExtHostDiagnostics,new q.$5jc(He,$t,si,St)),Mt=He.set(i.$yM.ExtHostLanguages,new Ee.$ulc(He,Ot,yt.converter,Zt)),ut=He.set(i.$yM.ExtHostLanguageFeatures,new Te.$7jc(He,Zt,Ot,yt,xt,$t,At,Rt)),Wi=He.set(i.$yM.ExtHostFileSystem,new $e.$dlc(He,ut)),di=He.set(i.$yM.ExtHostFileSystemEventService,new Ie.$elc(He,$t,St)),$i=He.set(i.$yM.ExtHostQuickOpen,(0,G.$Hlc)(He,mt,yt)),yi=He.set(i.$yM.ExtHostSCM,new ee.$Jlc(He,yt,Ot,$t)),Ri=He.set(i.$yM.ExtHostQuickDiff,new z.$Glc(He,Zt)),qi=He.set(i.$yM.ExtHostShare,new Be.$Klc(He,Zt)),hn=He.set(i.$yM.ExtHostComments,(0,k.$hkc)(He,yt,Ot)),Ai=He.set(i.$yM.ExtHostProgress,new j.$Flc(He.getProxy(i.$xM.MainThreadProgress))),Mi=He.set(i.$yM.ExtHostLabelService,new ve.$tlc(He)),ki=He.set(i.$yM.ExtHostTheming,new st.$Vlc(He)),Hi=He.set(i.$yM.ExtHostTimeline,new X.$Xlc(He,yt)),Ei=He.set(i.$yM.ExtHostWebviews,new jt.$vkc(He,vt.remote,mt,$t,At)),Di=He.set(i.$yM.ExtHostWebviewPanels,new _t.$ykc(He,Ei,mt)),Gi=He.set(i.$yM.ExtHostCustomEditors,new C.$zkc(He,Ot,Ut,Ei,Di)),Ki=He.set(i.$yM.ExtHostWebviewViews,new Jt.$2lc(He,Ei)),bi=He.set(i.$yM.ExtHostTesting,new ft.$Rlc(He,$t,yt,St)),dn=He.set(i.$yM.ExtHostUriOpeners,new ot.$Zlc(He)),fn=He.set(i.$yM.ExtHostProfileContentHandlers,new Ue.$Elc(He));He.set(i.$yM.ExtHostInteractive,new _.$slc(He,ae,St,yt,$t));const Ti=He.set(i.$yM.ExtHostInlineChat,new L.$flc(He,yt,Ot,$t)),Si=He.set(i.$yM.ExtHostChatAgents2,new b.$akc(He,$t,yt)),gn=He.set(i.$yM.ExtHostChatVariables,new l.$dkc(He)),Ji=He.set(i.$yM.ExtHostChat,new $.$_jc(He)),Oi=He.set(i.$yM.ExtHostAiRelatedInformation,new a.$Xjc(He)),mn=He.set(i.$yM.ExtHostAiEmbeddingVector,new ke.$clc(He)),Ii=He.set(i.$yM.ExtHostStatusBar,new Ye.$Nlc(He,yt.converter)),Qi=He.set(i.$yM.ExtHostSpeech,new Qe.$Llc(He)),Zi=Object.values(i.$yM);He.assertRegistered(Zi);const Xi=new c.$$jc(He,St),$n=new D.$ekc(He),wi=new Q.$vlc(He,$t),Ni=new A.$_kc(He);return h.$8jc.register(yt),function(Fe,ci,Yi){function _e(x){return(ce,Le,rt)=>{const bt=x(Nt=>{try{ce.call(Le,Nt)}catch(ji){O.$2(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${ji.toString()}`,{cause:ji})),Rt.onExtensionError(Fe.identifier,ji)}});return rt?.push(bt),bt}}const pt=function(){let x=!Fe.isUnderDevelopment;function ce(){x||($t.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")ce();else{const bt=rt;typeof bt.scheme>"u"&&ce(),typeof bt.exclusive=="boolean"&&(0,Xe.$hG)(Fe,"documentFiltersExclusive")}return rt}}(),xi={getSession(x,ce,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$hG)(Fe,"authLearnMore"),Pt.getSession(Fe,x,ce,Le)},getSessions(x,ce){return(0,Xe.$hG)(Fe,"authGetSessions"),Pt.getSessions(Fe,x,ce)},async hasSession(x,ce){return(0,Xe.$hG)(Fe,"authSession"),!!await Pt.getSession(Fe,x,ce,{silent:!0})},get onDidChangeSessions(){return _e(Pt.onDidChangeSessions)},registerAuthenticationProvider(x,ce,Le,rt){return Pt.registerAuthenticationProvider(x,ce,Le,rt)}},_i={registerCommand(x,ce,Le){return yt.registerCommand(!0,x,ce,Le,void 0,Fe)},registerTextEditorCommand(x,ce,Le){return yt.registerCommand(!0,x,(...rt)=>{const bt=nt.getActiveTextEditor();if(!bt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}return bt.edit(Nt=>{ce.apply(Le,[bt,Nt,...rt])}).then(Nt=>{Nt||$t.warn("Edits from command "+x+" were not applied.")},Nt=>{$t.warn("An error occurred while running command "+x,Nt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(x,ce,Le)=>((0,Xe.$hG)(Fe,"diffCommand"),yt.registerCommand(!0,x,async(...rt)=>{const bt=St.activeEditor(!0);if(!bt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}const Nt=await nt.getDiffInformation(bt.id);ce.apply(Le,[Nt,...rt])},void 0,void 0,Fe)),executeCommand(x,...ce){return yt.executeCommand(x,...ce)},getCommands(x=!1){return yt.getCommands(x)}},Fi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return _e(It.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return _e(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$hG)(Fe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$hG)(Fe,"telemetry"),_e(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$bP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,ce){return tt.$aP.validateSender(x),Rt.instantiateLogger(Fe,x,ce)},openExternal(x,ce){return Lt.openUri(x,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===vt.environment.appUriScheme)return gi.createAppUri(x);try{return await Lt.asExternalUri(x,{allowTunneling:!!vt.remote.authority})}catch(ce){if((0,M.$wg)(x,M.Schemas.http)||(0,M.$wg)(x,M.Schemas.https))return x;throw ce}},get remoteName(){return(0,o.$zm)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.$hG)(Fe,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return _e($t.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$hG)(Fe,"resolvers"),vt.quality},get appCommit(){return(0,Xe.$hG)(Fe,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Fi);const en={createTestController(x,ce,Le){return bi.createTestController(Fe,x,ce,Le)},createTestObserver(){return(0,Xe.$hG)(Fe,"testObserver"),bi.createTestObserver()},runTests(x){return(0,Xe.$hG)(Fe,"testObserver"),bi.runTests(x)},get onDidChangeTestResults(){return(0,Xe.$hG)(Fe,"testObserver"),_e(bi.onResultsChanged)},get testResults(){return(0,Xe.$hG)(Fe,"testObserver"),bi.results}},Ci=vt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,tn={getExtension(x,ce){(0,Xe.$gG)(Fe,"extensionsAny")||(ce=!1);const Le=ci.mine.getExtensionDescription(x);if(Le)return new oe.$1kc(Tt,Fe.identifier,Le,Ci,!1);if(ce){const rt=ci.all.getExtensionDescription(x);if(rt)return new oe.$1kc(Tt,Fe.identifier,rt,Ci,!0)}},get all(){const x=[];for(const ce of ci.mine.getAllExtensionDescriptions())x.push(new oe.$1kc(Tt,Fe.identifier,ce,Ci,!1));return x},get allAcrossExtensionHosts(){(0,Xe.$hG)(Fe,"extensionsAny");const x=new w.$Jm(ci.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),ce=[];for(const Le of ci.all.getAllExtensionDescriptions()){const rt=!x.has(Le.identifier);ce.push(new oe.$1kc(Tt,Fe.identifier,Le,Ci,rt))}return ce},get onDidChange(){return(0,Xe.$gG)(Fe,"extensionsAny")?_e(R.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):_e(ci.mine.onDidChange)}},nn={createDiagnosticCollection(x){return xt.createDiagnosticCollection(Fe.identifier,x)},get onDidChangeDiagnostics(){return _e(xt.onDidChangeDiagnostics)},getDiagnostics:x=>xt.getDiagnostics(x),getLanguages(){return Mt.getLanguages()},setTextDocumentLanguage(x,ce){return Mt.changeLanguage(x.uri,ce)},match(x,ce){const Le=qe.LanguageSelector.from(x);let rt;return(0,T.$St)(Le)&&(rt=ae.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Nt=>Nt.document===ce))?.apiNotebook),(0,T.$Rt)(Le,ce.uri,ce.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(x,ce,Le){return ut.registerCodeActionProvider(Fe,pt(x),ce,Le)},registerDocumentPasteEditProvider(x,ce,Le){return(0,Xe.$hG)(Fe,"documentPaste"),ut.registerDocumentPasteEditProvider(Fe,pt(x),ce,Le)},registerCodeLensProvider(x,ce){return ut.registerCodeLensProvider(Fe,pt(x),ce)},registerDefinitionProvider(x,ce){return ut.registerDefinitionProvider(Fe,pt(x),ce)},registerDeclarationProvider(x,ce){return ut.registerDeclarationProvider(Fe,pt(x),ce)},registerImplementationProvider(x,ce){return ut.registerImplementationProvider(Fe,pt(x),ce)},registerTypeDefinitionProvider(x,ce){return ut.registerTypeDefinitionProvider(Fe,pt(x),ce)},registerHoverProvider(x,ce){return ut.registerHoverProvider(Fe,pt(x),ce,Fe.identifier)},registerEvaluatableExpressionProvider(x,ce){return ut.registerEvaluatableExpressionProvider(Fe,pt(x),ce,Fe.identifier)},registerInlineValuesProvider(x,ce){return ut.registerInlineValuesProvider(Fe,pt(x),ce,Fe.identifier)},registerDocumentHighlightProvider(x,ce){return ut.registerDocumentHighlightProvider(Fe,pt(x),ce)},registerMultiDocumentHighlightProvider(x,ce){return ut.registerMultiDocumentHighlightProvider(Fe,pt(x),ce)},registerLinkedEditingRangeProvider(x,ce){return ut.registerLinkedEditingRangeProvider(Fe,pt(x),ce)},registerReferenceProvider(x,ce){return ut.registerReferenceProvider(Fe,pt(x),ce)},registerRenameProvider(x,ce){return ut.registerRenameProvider(Fe,pt(x),ce)},registerNewSymbolNamesProvider(x,ce){return(0,Xe.$hG)(Fe,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(Fe,pt(x),ce)},registerDocumentSymbolProvider(x,ce,Le){return ut.registerDocumentSymbolProvider(Fe,pt(x),ce,Le)},registerWorkspaceSymbolProvider(x){return ut.registerWorkspaceSymbolProvider(Fe,x)},registerDocumentFormattingEditProvider(x,ce){return ut.registerDocumentFormattingEditProvider(Fe,pt(x),ce)},registerDocumentRangeFormattingEditProvider(x,ce){return ut.registerDocumentRangeFormattingEditProvider(Fe,pt(x),ce)},registerOnTypeFormattingEditProvider(x,ce,Le,...rt){return ut.registerOnTypeFormattingEditProvider(Fe,pt(x),ce,[Le].concat(rt))},registerDocumentSemanticTokensProvider(x,ce,Le){return ut.registerDocumentSemanticTokensProvider(Fe,pt(x),ce,Le)},registerDocumentRangeSemanticTokensProvider(x,ce,Le){return ut.registerDocumentRangeSemanticTokensProvider(Fe,pt(x),ce,Le)},registerSignatureHelpProvider(x,ce,Le,...rt){return typeof Le=="object"?ut.registerSignatureHelpProvider(Fe,pt(x),ce,Le):ut.registerSignatureHelpProvider(Fe,pt(x),ce,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(x,ce,...Le){return ut.registerCompletionItemProvider(Fe,pt(x),ce,Le)},registerInlineCompletionItemProvider(x,ce,Le){return ce.handleDidShowCompletionItem&&(0,Xe.$hG)(Fe,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$hG)(Fe,"inlineCompletionsAdditions"),Le&&(0,Xe.$hG)(Fe,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Fe,pt(x),ce,Le)},registerInlineEditProvider(x,ce){return(0,Xe.$hG)(Fe,"inlineEdit"),ut.registerInlineEditProvider(Fe,pt(x),ce)},registerDocumentLinkProvider(x,ce){return ut.registerDocumentLinkProvider(Fe,pt(x),ce)},registerColorProvider(x,ce){return ut.registerColorProvider(Fe,pt(x),ce)},registerFoldingRangeProvider(x,ce){return ut.registerFoldingRangeProvider(Fe,pt(x),ce)},registerSelectionRangeProvider(x,ce){return ut.registerSelectionRangeProvider(Fe,x,ce)},registerCallHierarchyProvider(x,ce){return ut.registerCallHierarchyProvider(Fe,x,ce)},registerTypeHierarchyProvider(x,ce){return ut.registerTypeHierarchyProvider(Fe,x,ce)},setLanguageConfiguration:(x,ce)=>ut.setLanguageConfiguration(Fe,x,ce),getTokenInformationAtPosition(x,ce){return(0,Xe.$hG)(Fe,"tokenInformation"),Mt.tokenAtPosition(x,ce)},registerInlayHintsProvider(x,ce){return ut.registerInlayHintsProvider(Fe,x,ce)},createLanguageStatusItem(x,ce){return Mt.createLanguageStatusItem(Fe,x,ce)},registerDocumentDropEditProvider(x,ce,Le){return ut.registerDocumentOnDropEditProvider(Fe,x,ce,(0,Xe.$gG)(Fe,"dropMetadata")?Le:void 0)}},pn={get activeTextEditor(){return nt.getActiveTextEditor()},get visibleTextEditors(){return nt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(x,ce,Le){f.URI.isUri(x)&&x.scheme===M.Schemas.vscodeRemote&&!x.authority&&At.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(f.URI.isUri(x)?Promise.resolve(rn.openTextDocument(x)):Promise.resolve(x));return nt.showTextDocument(rt,ce,Le)},createTextEditorDecorationType(x){return nt.createTextEditorDecorationType(Fe,x)},onDidChangeActiveTextEditor(x,ce,Le){return _e(nt.onDidChangeActiveTextEditor)(x,ce,Le)},onDidChangeVisibleTextEditors(x,ce,Le){return _e(nt.onDidChangeVisibleTextEditors)(x,ce,Le)},onDidChangeTextEditorSelection(x,ce,Le){return _e(nt.onDidChangeTextEditorSelection)(x,ce,Le)},onDidChangeTextEditorOptions(x,ce,Le){return _e(nt.onDidChangeTextEditorOptions)(x,ce,Le)},onDidChangeTextEditorVisibleRanges(x,ce,Le){return _e(nt.onDidChangeTextEditorVisibleRanges)(x,ce,Le)},onDidChangeTextEditorViewColumn(x,ce,Le){return _e(nt.onDidChangeTextEditorViewColumn)(x,ce,Le)},onDidCloseTerminal(x,ce,Le){return _e(It.onDidCloseTerminal)(x,ce,Le)},onDidOpenTerminal(x,ce,Le){return _e(It.onDidOpenTerminal)(x,ce,Le)},onDidChangeActiveTerminal(x,ce,Le){return _e(It.onDidChangeActiveTerminal)(x,ce,Le)},onDidChangeTerminalDimensions(x,ce,Le){return(0,Xe.$hG)(Fe,"terminalDimensions"),_e(It.onDidChangeTerminalDimensions)(x,ce,Le)},onDidChangeTerminalState(x,ce,Le){return _e(It.onDidChangeTerminalState)(x,ce,Le)},onDidWriteTerminalData(x,ce,Le){return(0,Xe.$hG)(Fe,"terminalDataWriteEvent"),_e(It.onDidWriteTerminalData)(x,ce,Le)},onDidExecuteTerminalCommand(x,ce,Le){return(0,Xe.$hG)(Fe,"terminalExecuteCommandEvent"),_e(It.onDidExecuteTerminalCommand)(x,ce,Le)},onDidChangeTerminalShellIntegration(x,ce,Le){return(0,Xe.$hG)(Fe,"terminalShellIntegration"),_e(li.onDidChangeTerminalShellIntegration)(x,ce,Le)},onDidStartTerminalShellExecution(x,ce,Le){return(0,Xe.$hG)(Fe,"terminalShellIntegration"),_e(li.onDidStartTerminalShellExecution)(x,ce,Le)},onDidEndTerminalShellExecution(x,ce,Le){return(0,Xe.$hG)(Fe,"terminalShellIntegration"),_e(li.onDidEndTerminalShellExecution)(x,ce,Le)},get state(){return Lt.getState(Fe)},onDidChangeWindowState(x,ce,Le){return _e(Lt.onDidChangeWindowState)(x,ce,Le)},showInformationMessage(x,...ce){return wi.showMessage(Fe,d.default.Info,x,ce[0],ce.slice(1))},showWarningMessage(x,...ce){return wi.showMessage(Fe,d.default.Warning,x,ce[0],ce.slice(1))},showErrorMessage(x,...ce){return wi.showMessage(Fe,d.default.Error,x,ce[0],ce.slice(1))},showQuickPick(x,ce,Le){return $i.showQuickPick(Fe,x,ce,Le)},showWorkspaceFolderPick(x){return $i.showWorkspaceFolderPick(x)},showInputBox(x,ce){return $i.showInput(x,ce)},showOpenDialog(x){return Ni.showOpenDialog(Fe,x)},showSaveDialog(x){return Ni.showSaveDialog(x)},createStatusBarItem(x,ce,Le){let rt,bt,Nt;return typeof x=="string"?(rt=x,bt=ce,Nt=Le):(bt=x,Nt=ce),Ii.createStatusBarEntry(Fe,rt,bt,Nt)},setStatusBarMessage(x,ce){return Ii.setStatusBarMessage(x,ce)},withScmProgress(x){return At.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Ai.withProgress(Fe,{location:we.ProgressLocation.SourceControl},(ce,Le)=>x({report(rt){}}))},withProgress(x,ce){return Ai.withProgress(Fe,x,ce)},createOutputChannel(x,ce){return vi.createOutputChannel(x,ce,Fe)},createWebviewPanel(x,ce,Le,rt){return Di.createWebviewPanel(Fe,x,ce,Le,rt)},createWebviewTextEditorInset(x,ce,Le,rt){return(0,Xe.$hG)(Fe,"editorInsets"),Gt.createWebviewEditorInset(x,ce,Le,rt,Fe)},createTerminal(x,ce,Le){return typeof x=="object"?"pty"in x?It.createExtensionTerminal(x):It.createTerminalFromOptions(x):It.createTerminal(x,ce,Le)},registerTerminalLinkProvider(x){return It.registerLinkProvider(x)},registerTerminalProfileProvider(x,ce){return It.registerProfileProvider(Fe,x,ce)},registerTerminalQuickFixProvider(x,ce){return(0,Xe.$hG)(Fe,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(x,Fe.identifier.value,ce)},registerTreeDataProvider(x,ce){return wt.registerTreeDataProvider(x,ce,Fe)},createTreeView(x,ce){return wt.createTreeView(x,ce,Fe)},registerWebviewPanelSerializer:(x,ce)=>Di.registerWebviewPanelSerializer(Fe,x,ce),registerCustomEditorProvider:(x,ce,Le={})=>Gi.registerCustomEditorProvider(Fe,x,ce,Le),registerFileDecorationProvider(x){return Yt.registerFileDecorationProvider(x,Fe)},registerUriHandler(x){return gi.registerUriHandler(Fe,x)},createQuickPick(){return $i.createQuickPick(Fe)},createInputBox(){return $i.createInputBox(Fe)},get activeColorTheme(){return ki.activeColorTheme},onDidChangeActiveColorTheme(x,ce,Le){return _e(ki.onDidChangeActiveColorTheme)(x,ce,Le)},registerWebviewViewProvider(x,ce,Le){return Ki.registerWebviewViewProvider(Fe,x,ce,Le?.webviewOptions)},get activeNotebookEditor(){return ae.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,ce,Le){return _e(ae.onDidChangeActiveNotebookEditor)(x,ce,Le)},get visibleNotebookEditors(){return ae.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _e(ae.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,ce,Le){return _e(ye.onDidChangeNotebookEditorSelection)(x,ce,Le)},onDidChangeNotebookEditorVisibleRanges(x,ce,Le){return _e(ye.onDidChangeNotebookEditorVisibleRanges)(x,ce,Le)},showNotebookDocument(x,ce){return ae.showNotebookDocument(x,ce)},registerExternalUriOpener(x,ce,Le){return(0,Xe.$hG)(Fe,"externalUriOpener"),dn.registerExternalUriOpener(Fe.identifier,x,ce,Le)},registerProfileContentHandler(x,ce){return(0,Xe.$hG)(Fe,"profileContentHandlers"),fn.registerProfileContentHandler(Fe,x,ce)},registerQuickDiffProvider(x,ce,Le,rt){return(0,Xe.$hG)(Fe,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(x),ce,Le,rt)},get tabGroups(){return oi.tabGroups},registerShareProvider(x,ce){return(0,Xe.$hG)(Fe,"shareProvider"),qi.registerShareProvider(pt(x),ce)}},rn={get rootPath(){return At.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(x){throw new O.$9("rootPath")},getWorkspaceFolder(x){return mt.getWorkspaceFolder(x)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(x){throw new O.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(x){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(x,ce,...Le)=>mt.updateWorkspaceFolders(Fe,x,ce||0,...Le),onDidChangeWorkspaceFolders:function(x,ce,Le){return _e(mt.onDidChangeWorkspace)(x,ce,Le)},asRelativePath:(x,ce)=>mt.getRelativePath(x,ce),findFiles:(x,ce,Le,rt)=>mt.findFiles(x,ce,Le,Fe.identifier,rt),findFiles2:(x,ce,Le)=>((0,Xe.$hG)(Fe,"findFiles2"),mt.findFiles2(x,ce,Fe.identifier,Le)),findTextInFiles:(x,ce,Le,rt)=>{(0,Xe.$hG)(Fe,"findTextInFiles");let bt,Nt;return typeof ce=="object"?(bt=ce,Nt=Le):(bt={},Nt=ce,rt=Le),mt.findTextInFiles(x,bt||{},Nt,Fe.identifier,rt)},save:x=>mt.save(x),saveAs:x=>mt.saveAs(x),saveAll:x=>mt.saveAll(x),applyEdit(x,ce){return Xi.applyWorkspaceEdit(x,Fe,ce)},createFileSystemWatcher:(x,ce,Le,rt)=>{let bt;return typeof ce=="boolean"?bt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:ce&&((0,Xe.$hG)(Fe,"createFileSystemWatcher"),bt={...ce,correlate:!0}),di.createFileSystemWatcher(mt,Fe,x,bt)},get textDocuments(){return Ot.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new O.$9("textDocuments")},openTextDocument(x){let ce;const Le=x;if(typeof x=="string")ce=Promise.resolve(f.URI.file(x));else if(f.URI.isUri(x))ce=Promise.resolve(x);else if(!Le||typeof Le=="object")ce=Ot.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&At.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Ot.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(x,ce,Le)=>_e(Ot.onDidAddDocument)(x,ce,Le),onDidCloseTextDocument:(x,ce,Le)=>_e(Ot.onDidRemoveDocument)(x,ce,Le),onDidChangeTextDocument:(x,ce,Le)=>_e(Ot.onDidChangeDocument)(x,ce,Le),onDidSaveTextDocument:(x,ce,Le)=>_e(Ot.onDidSaveDocument)(x,ce,Le),onWillSaveTextDocument:(x,ce,Le)=>_e(Me.getOnWillSaveTextDocumentEvent(Fe))(x,ce,Le),get notebookDocuments(){return ae.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,ce){let Le;if(f.URI.isUri(x))Le=x,await ae.openNotebookDocument(x);else if(typeof x=="string")Le=f.URI.revive(await ae.createNotebookDocument({viewType:x,content:ce}));else throw new Error("Invalid arguments");return ae.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(x,ce,Le){return _e(J.onDidSaveNotebookDocument)(x,ce,Le)},onDidChangeNotebookDocument(x,ce,Le){return _e(J.onDidChangeNotebookDocument)(x,ce,Le)},onWillSaveNotebookDocument(x,ce,Le){return _e(Ge.getOnWillSaveNotebookDocumentEvent(Fe))(x,ce,Le)},get onDidOpenNotebookDocument(){return _e(ae.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return _e(ae.onDidCloseNotebookDocument)},registerNotebookSerializer(x,ce,Le,rt){return ae.registerNotebookSerializer(Fe,x,ce,Le,(0,Xe.$gG)(Fe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(x,ce,Le)=>_e(Yi.onDidChangeConfiguration)(x,ce,Le),getConfiguration(x,ce){return ce=arguments.length===1?void 0:ce,Yi.getConfiguration(x,ce,Fe)},registerTextDocumentContentProvider(x,ce){return be.registerTextDocumentContentProvider(x,ce)},registerTaskProvider:(x,ce)=>(At.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),zt.registerTaskProvider(Fe,x,ce)),registerFileSystemProvider(x,ce,Le){return(0,N.$Rc)(Wi.registerFileSystemProvider(Fe,x,ce,Le),ni.addFileSystemProvider(x,ce,Le))},get fs(){return ni.value},registerFileSearchProvider:(x,ce)=>((0,Xe.$hG)(Fe,"fileSearchProvider"),hi.registerFileSearchProvider(x,ce)),registerTextSearchProvider:(x,ce)=>((0,Xe.$hG)(Fe,"textSearchProvider"),hi.registerTextSearchProvider(x,ce)),registerAITextSearchProvider:(x,ce)=>((0,Xe.$hG)(Fe,"aiTextSearchProvider"),(0,Xe.$hG)(Fe,"textSearchProvider"),hi.registerAITextSearchProvider(x,ce)),registerRemoteAuthorityResolver:(x,ce)=>((0,Xe.$hG)(Fe,"resolvers"),Tt.registerRemoteAuthorityResolver(x,ce)),registerResourceLabelFormatter:x=>((0,Xe.$hG)(Fe,"resolvers"),Mi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Xe.$hG)(Fe,"resolvers"),Tt.getRemoteExecServer(x)),onDidCreateFiles:(x,ce,Le)=>_e(di.onDidCreateFile)(x,ce,Le),onDidDeleteFiles:(x,ce,Le)=>_e(di.onDidDeleteFile)(x,ce,Le),onDidRenameFiles:(x,ce,Le)=>_e(di.onDidRenameFile)(x,ce,Le),onWillCreateFiles:(x,ce,Le)=>_e(di.getOnWillCreateFileEvent(Fe))(x,ce,Le),onWillDeleteFiles:(x,ce,Le)=>_e(di.getOnWillDeleteFileEvent(Fe))(x,ce,Le),onWillRenameFiles:(x,ce,Le)=>_e(di.getOnWillRenameFileEvent(Fe))(x,ce,Le),openTunnel:x=>((0,Xe.$hG)(Fe,"tunnels"),Ft.openTunnel(Fe,x).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Xe.$hG)(Fe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(x,ce,Le)=>((0,Xe.$hG)(Fe,"tunnels"),_e(Ft.onDidChangeTunnels)(x,ce,Le)),registerPortAttributesProvider:(x,ce)=>((0,Xe.$hG)(Fe,"portsAttributes"),Ft.registerPortsAttributesProvider(x,ce)),registerTunnelProvider:(x,ce)=>((0,Xe.$hG)(Fe,"tunnelFactory"),Ft.registerTunnelProvider(x,ce)),registerTimelineProvider:(x,ce)=>((0,Xe.$hG)(Fe,"timeline"),Hi.registerTimelineProvider(x,ce,Fe.identifier,yt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:x=>((0,Xe.$hG)(Fe,"workspaceTrust"),mt.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,ce,Le)=>_e(mt.onDidGrantWorkspaceTrust)(x,ce,Le),registerEditSessionIdentityProvider:(x,ce)=>((0,Xe.$hG)(Fe,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(x,ce)),onWillCreateEditSessionIdentity:(x,ce,Le)=>((0,Xe.$hG)(Fe,"editSessionIdentityProvider"),_e(mt.getOnWillCreateEditSessionIdentityEvent(Fe))(x,ce,Le)),registerCanonicalUriProvider:(x,ce)=>((0,Xe.$hG)(Fe,"canonicalUriProvider"),mt.registerCanonicalUriProvider(x,ce)),getCanonicalUri:(x,ce,Le)=>((0,Xe.$hG)(Fe,"canonicalUriProvider"),mt.provideCanonicalUri(x,ce,Le))},sn={get inputBox(){return At.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Fe)},createSourceControl(x,ce,Le){return yi.createSourceControl(Fe,x,ce,Le)}},Li={createCommentController(x,ce){return hn.createCommentController(Fe,x,ce)}},on={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,Xe.$gG)(Fe,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(x,ce){return(0,Xe.$hG)(Fe,"debugVisualization"),Et.registerDebugVisualizationProvider(Fe,x,ce)},registerDebugVisualizationTreeProvider(x,ce){return(0,Xe.$hG)(Fe,"debugVisualization"),Et.registerDebugVisualizationTree(Fe,x,ce)},onDidStartDebugSession(x,ce,Le){return _e(Et.onDidStartDebugSession)(x,ce,Le)},onDidTerminateDebugSession(x,ce,Le){return _e(Et.onDidTerminateDebugSession)(x,ce,Le)},onDidChangeActiveDebugSession(x,ce,Le){return _e(Et.onDidChangeActiveDebugSession)(x,ce,Le)},onDidReceiveDebugSessionCustomEvent(x,ce,Le){return _e(Et.onDidReceiveDebugSessionCustomEvent)(x,ce,Le)},onDidChangeBreakpoints(x,ce,Le){return _e(Et.onDidChangeBreakpoints)(x,ce,Le)},onDidChangeActiveStackItem(x,ce,Le){return(0,Xe.$hG)(Fe,"debugFocus"),_e(Et.onDidChangeActiveStackItem)(x,ce,Le)},registerDebugConfigurationProvider(x,ce,Le){return Et.registerDebugConfigurationProvider(x,ce,Le||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,ce){return Et.registerDebugAdapterDescriptorFactory(Fe,x,ce)},registerDebugAdapterTrackerFactory(x,ce){return Et.registerDebugAdapterTrackerFactory(x,ce)},startDebugging(x,ce,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(x,ce,{parentSession:Le}):Et.startDebugging(x,ce,Le||{})},stopDebugging(x){return Et.stopDebugging(x)},addBreakpoints(x){return Et.addBreakpoints(x)},removeBreakpoints(x){return Et.removeBreakpoints(x)},asDebugSourceUri(x,ce){return Et.asDebugSourceUri(x,ce)}},an={registerTaskProvider:(x,ce)=>zt.registerTaskProvider(Fe,x,ce),fetchTasks:x=>zt.fetchTasks(x),executeTask:x=>zt.executeTask(Fe,x),get taskExecutions(){return zt.taskExecutions},onDidStartTask:(x,ce,Le)=>_e(zt.onDidStartTask)(x,ce,Le),onDidEndTask:(x,ce,Le)=>_e(zt.onDidEndTask)(x,ce,Le),onDidStartTaskProcess:(x,ce,Le)=>_e(zt.onDidStartTaskProcess)(x,ce,Le),onDidEndTaskProcess:(x,ce,Le)=>_e(zt.onDidEndTaskProcess)(x,ce,Le)},cn={createNotebookController(x,ce,Le,rt,bt){return Ve.createNotebookController(Fe,x,ce,Le,rt,(0,Xe.$gG)(Fe,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(x,ce)=>ae.registerNotebookCellStatusBarItemProvider(Fe,x,ce),createRendererMessaging(x){return Ze.createRendererMessaging(Fe,x)},createNotebookControllerDetectionTask(x){return(0,Xe.$hG)(Fe,"notebookKernelSource"),Ve.createNotebookControllerDetectionTask(Fe,x)},registerKernelSourceActionProvider(x,ce){return(0,Xe.$hG)(Fe,"notebookKernelSource"),Ve.registerKernelSourceActionProvider(Fe,x,ce)},onDidChangeNotebookCellExecutionState(x,ce,Le){return(0,Xe.$hG)(Fe,"notebookCellExecutionState"),_e(Ve.onDidChangeNotebookCellExecutionState)(x,ce,Le)}},vn={t(...x){if(typeof x[0]=="string"){const ce=x.shift(),Le=!x||typeof x[0]!="object"?x:x[0];return Ht.getMessage(Fe.identifier.value,{message:ce,args:Le})}return Ht.getMessage(Fe.identifier.value,x[0])},get bundle(){return Ht.getBundle(Fe.identifier.value)},get uri(){return Ht.getBundleUri(Fe.identifier.value)}},bn={_version:1,registerInteractiveEditorSessionProvider(x,ce){return(0,Xe.$hG)(Fe,"interactive"),Ti.registerProvider(Fe,x,ce)},registerInteractiveSessionProvider(x,ce){return(0,Xe.$hG)(Fe,"interactive"),Ji.registerChatProvider(Fe,x,ce)},transferActiveChat(x){return(0,Xe.$hG)(Fe,"interactive"),Ji.transferActiveChat(x)}},un={getRelatedInformation(x,ce){return(0,Xe.$hG)(Fe,"aiRelatedInformation"),Oi.getRelatedInformation(Fe,x,ce)},registerRelatedInformationProvider(x,ce){return(0,Xe.$hG)(Fe,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(Fe,x,ce)},registerEmbeddingVectorProvider(x,ce){return(0,Xe.$hG)(Fe,"aiRelatedInformation"),mn.registerEmbeddingVectorProvider(Fe,x,ce)}},ln={registerChatResponseProvider(x,ce,Le){return(0,Xe.$hG)(Fe,"chatProvider"),kt.registerLanguageModel(Fe,x,ce,Le)},registerChatVariableResolver(x,ce,Le){return(0,Xe.$hG)(Fe,"chatVariableResolver"),gn.registerVariableResolver(Fe,x,ce,Le)},registerMappedEditsProvider(x,ce){return(0,Xe.$hG)(Fe,"mappedEditsProvider"),ut.registerMappedEditsProvider(Fe,x,ce)},createChatParticipant(x,ce){return(0,Xe.$hG)(Fe,"chatParticipant"),Si.createChatAgent(Fe,x,ce)},createDynamicChatParticipant(x,ce,Le,rt){return(0,Xe.$hG)(Fe,"chatParticipantAdditions"),Si.createDynamicChatAgent(Fe,x,ce,Le,rt)}},zi={get languageModels(){return(0,Xe.$hG)(Fe,"languageModels"),kt.getLanguageModelIds()},onDidChangeLanguageModels:(x,ce,Le)=>((0,Xe.$hG)(Fe,"languageModels"),kt.onDidChangeProviders(x,ce,Le)),sendChatRequest(x,ce,Le,rt){return(0,Xe.$hG)(Fe,"languageModels"),kt.sendChatRequest(Fe,x,ce,Le,rt)}},Ui={registerSpeechProvider(x,ce){return(0,Xe.$hG)(Fe,"speech"),Qi.registerProvider(Fe.identifier,x,ce)}};return{version:vt.version,ai:un,authentication:xi,commands:_i,comments:Li,chat:ln,debug:on,env:Fi,extensions:tn,interactive:bn,l10n:vn,languages:nn,lm:zi,notebooks:cn,scm:sn,speech:Ui,tasks:an,tests:en,window:pn,workspace:rn,Breakpoint:we.$zN,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$uO,CallHierarchyIncomingCall:we.$XM,CallHierarchyItem:we.$WM,CallHierarchyOutgoingCall:we.$YM,CancellationError:O.$5,CancellationTokenSource:I.$je,CandidatePortSource:i.CandidatePortSource,CodeAction:we.$TM,CodeActionKind:we.$UM,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$ZM,Color:we.$aN,ColorInformation:we.$bN,ColorPresentation:we.$cN,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$7M,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$8M,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$kN,DebugAdapterExecutable:we.$DN,DebugAdapterInlineImplementation:we.$GN,DebugAdapterNamedPipeServer:we.$FN,DebugAdapterServer:we.$EN,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$WN,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$NM,DiagnosticRelatedInformation:we.$MM,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$zM,DocumentHighlight:we.$PM,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$QM,DocumentLink:we.$_M,DocumentSymbol:we.$SM,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$JN,InlineValueText:we.$KN,InlineValueVariableLookup:we.$LN,InlineValueEvaluatableExpression:we.$MN,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:R.$_d,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$YN,FileDecoration2:we.$YN,FileSystemError:we.$PN,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:we.$QN,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$BN,InlineCompletionItem:we.$9M,InlineCompletionList:we.$0M,Hover:we.$OM,IndentAction:y.IndentAction,Location:we.$LM,MarkdownString:we.$1M,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:we.$2M,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$AM,ProcessExecution:we.$iN,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$XN,Range:we.$BM,RelativePattern:we.$xN,Selection:we.$CM,SelectionRange:we.$VM,SemanticTokens:we.$TN,SemanticTokensBuilder:we.$SN,SemanticTokensEdit:we.$UN,SemanticTokensEdits:we.$VN,SemanticTokensLegend:we.$RN,ShellExecution:we.$jN,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$4M,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$3M,SnippetString:we.$KM,SourceBreakpoint:we.$AN,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$RM,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$lN,TaskGroup:we.$hN,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$dN,TerminalQuickFixTerminalCommand:we.$fN,TerminalQuickFixOpener:we.$eN,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$gN,TerminalExitReason:we.TerminalExitReason,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$GM,SnippetTextEdit:we.$IM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$wN,ThemeIcon:we.$vN,TreeItem:we.$mN,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$iO,UIKind:Qt.UIKind,Uri:f.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$JM,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$sN,DocumentPasteEditKind:we.$tN,DocumentPasteEdit:we.$uN,InlayHint:we.$6M,InlayHintLabelPart:we.$5M,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$FM,ResolvedAuthority:we.$DM,ManagedResolvedAuthority:we.$EM,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$9N,NotebookRange:we.$1N,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$2N,NotebookData:we.$3N,NotebookRendererScript:we.$7N,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$5N,NotebookCellOutputItem:we.$4N,NotebookCellStatusBarItem:we.$6N,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$HM,NotebookKernelSourceAction:we.$8N,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$$N,LinkedEditingRanges:we.$0N,TestResultState:we.TestResultState,TestRunRequest:we.$_N,TestMessage:we.$aO,TestTag:we.$bO,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:ai.TextSearchCompleteMessageType,DataTransfer:we.$rN,DataTransferItem:we.$nN,TestCoverageCount:we.$cO,FileCoverage:we.$eO,StatementCoverage:we.$fO,BranchCoverage:we.$gO,DeclarationCoverage:we.$hO,FunctionCoverage:we.$hO,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$jO,TabInputTextDiff:we.$kO,TabInputTextMerge:we.$lO,TabInputCustom:we.$mO,TabInputNotebook:we.$oO,TabInputNotebookDiff:we.$pO,TabInputWebview:we.$nO,TabInputTerminal:we.$qO,TabInputInteractiveWindow:we.$rO,TabInputChat:we.$sO,TabInputTextMultiDiff:we.$tO,TelemetryTrustedValue:s.$9o,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,StackFrame:we.$HN,Thread:we.$IN,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$vO,ChatResponseFileTreePart:we.$wO,ChatResponseAnchorPart:we.$xO,ChatResponseProgressPart:we.$yO,ChatResponseReferencePart:we.$AO,ChatResponseTextEditPart:we.$BO,ChatResponseCommandButtonPart:we.$zO,ChatRequestTurn:we.$CO,ChatResponseTurn:we.$DO,ChatLocation:we.ChatLocation,LanguageModelChatSystemMessage:we.$EO,LanguageModelChatUserMessage:we.$FO,LanguageModelChatAssistantMessage:we.$GO,LanguageModelSystemMessage:we.$EO,LanguageModelUserMessage:we.$FO,LanguageModelAssistantMessage:we.$GO,LanguageModelError:we.$HO,NewSymbolName:we.$ON,NewSymbolNameTag:we.NewSymbolNameTag,InlineEdit:we.$IO,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Pe[297],Re([1,0,55,116,37,110,38,31,67,51,119,121,122,82,86,78,109,64,44,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,I,O,R,N,M,d,f,E,T,y,u,w,m,n,o,s,r,i,a,h,t,v,c,$,b,p,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$ls)($.$Ukc,$.$Tkc,1),(0,I.$ls)(v.$Uj,t.$8lc,1),(0,I.$ls)(n.$Yjc,n.$Zjc,1),(0,I.$ls)(d.$eP,d.$dP,0),(0,I.$ls)(p.$9jc,p.$0jc,0),(0,I.$ls)(l.$bkc,l.$ckc,0),(0,I.$ls)(M.$okc,M.$mkc,0),(0,I.$ls)(s.$qkc,s.$pkc,0),(0,I.$ls)(y.$5kc,y.$9kc,0),(0,I.$ls)(N.$$kc,N.$0kc,0),(0,I.$ls)(f.$6O,f.$5O,0),(0,I.$ls)(b.$Vkc,b.$Wkc,0),(0,I.$ls)(r.$3jc,r.$2jc,0),(0,I.$ls)(O.$Dlc,O.$Clc,1),(0,I.$ls)(u.$olc,u.$plc,0),(0,I.$ls)(w.$Jkc,w.$Ikc,0),(0,I.$ls)(T.$Qlc,T.$Plc,0),(0,I.$ls)(E.$Mkc,E.$Pkc,0),(0,I.$ls)(D.$5lc,D.$6lc,0),(0,I.$ls)(m.$eCb,m.$fCb,0),(0,I.$ls)(o.$4lc,o.$3lc,0),(0,I.$ls)(R.$lkc,R.$kkc,0),(0,I.$ls)(i.$Rkc,i.$Qkc,0),(0,I.$ls)(a.$cP,a.$_O,0),(0,I.$ls)(h.$Akc,h.$Bkc,0),(0,I.$ls)(c.$3kc,c.$4kc,0)}),define(Pe[298],Re([1,0,296,39,2,293,7,11,242]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;class E extends N.$$lc{j(){}getModule(w,m){for(const n of this.b){const o=n(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$Ykc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(f.$eoc);const w=this.h.invokeFunction(I.$7lc);this.r=this.h.createInstance(E,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,m,n){m=m.with({path:y(m.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=R.URI.revive(await this.C.$asBrowserUri(m)),r=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const i=await r.text(),a=`${m.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${m.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}w&&await this.w.initializeLocalizedMessages(w);const v={},c={exports:v},$=b=>{const p=this.r.getModule(b,m);if(p===void 0)throw new Error(`Cannot load module '${b}'`);return p};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,v,$),c.exports!==v?c.exports:v}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+w;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,d.$oh)(10)}}e.$foc=T;function y(u,w){return u.endsWith(w)?u:u+w}}),define(Pe[299],Re([1,0,70,55,13,39,206,85,298]),function(ge,e,I,O,R,N,M,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$ls)(R.$Tj,new I.$ki(M.$0lc,[!0],!0)),(0,O.$ls)(N.$Zkc,f.$foc,0),(0,O.$ls)(d.$rkc,d.$skc,0)}),define(Pe[305],Re([1,0,22,5,77,294,244,19,89,12,2,297,299]),function(ge,e,I,O,R,N,M,d,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function n(t){self.fetch=async function(v,c){return v instanceof Request||w(String(v))&&(v=(await t(T.URI.parse(String(v)))).toString(!0)),m(v,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,c,$,b,p){(async()=>(w(c.toString())&&(c=(await t(T.URI.parse(c.toString()))).toString(!0)),super.open(v,c,$??!0,b,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(v,c){if(/^file:/i.test(v.toString()))v=E.$Hg.uriToBrowserUri(T.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(g){function S(C){return typeof C=="string"||C instanceof URL?String(C).replace(/^file:\/\//i,"vscode-file://vscode-app"):C}const k=fetch.bind(self);self.fetch=function(C,W){return C instanceof Request?k(C,W):k(S(C),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(C,W,V,q,A){return super.open(C,S(W),V??!0,q,A)}};const P=importScripts.bind(self);self.importScripts=(...C)=>{P(...C.map(S))},P(g)}.toString()}('${v}'))`;c=c||{},c.name=`${name} -> ${c.name||d.$oc(v.toString())}`;const p=new Blob([b],{type:"application/javascript"}),l=URL.createObjectURL(p);return new t(l,c)}}else self.Worker=class extends M.$goc{constructor(t,v){super(u,t,{name:d.$oc(t.toString()),...v})}};const o=new class{constructor(){this.pid=void 0}exit(t){y()}};class s{constructor(){const v=new MessageChannel,c=new O.$_d;let $=!1;u(v.port2,[v.port2]),v.port1.onmessage=b=>{const{data:p}=b;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const l=I.$ze.wrap(new Uint8Array(p,0,p.byteLength));if((0,R.$Rm)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:b=>{if(!$){const p=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);v.port1.postMessage(p,[p])}}}}}function r(t){return new Promise(v=>{const c=t.onMessage($=>{c.dispose();const b=JSON.parse($.toString());t.send((0,R.$Qm)(0)),v({protocol:t,initData:b})});t.send((0,R.$Qm)(1))})}let i=t=>y();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(v){a(v)&&r(t.protocol).then(c=>{f.mark("code/extHost/didWaitForInitData");const $=new N.$amc(c.protocol,c.initData,o,null,v.data);n(b=>$.asBrowserUri(b)),i=b=>$.terminate(b)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/workbench/api/worker/extensionHostWorker.js.map
