/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/equals","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/arrays","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(z){for(var e=[],N=0,E=z.length;N<E;N++)e[N]=K[z[N]];return e};define(K[26],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const T=new Map,I=new Map,r=new Map,o=new Map;function i(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function a(u,n){const t=u.get(n.detail);t&&(t>=0||u.set(n.detail,t+n.timestamp))}let $=[];typeof z=="function"&&typeof z.getStats=="function"&&($=z.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of $)switch(u.type){case 10:i(T,u);break;case 11:case 12:a(T,u);break;case 21:i(I,u);break;case 22:a(I,u);break;case 33:i(r,u);break;case 34:a(r,u);break;case 31:i(o,u);break;case 32:a(o,u);break}let c=0;r.forEach(u=>c+=u);function b(u){const n=[];return u.forEach((t,s)=>n.push([s,t])),n}return{amdLoad:b(T),amdInvoke:b(I),nodeRequire:b(r),nodeEval:b(o),nodeRequireTotal:c}}static toMarkdownTable(T,I){let r="";const o=[];return T.forEach((i,a)=>{o[a]=i.length}),I.forEach(i=>{i.forEach((a,$)=>{typeof a>"u"&&(a=i[$]="-");const c=a.toString().length;o[$]=Math.max(c,o[$])})}),T.forEach((i,a)=>{r+=`| ${i+" ".repeat(o[a]-i.toString().length)} `}),r+=`|
`,T.forEach((i,a)=>{r+=`| ${"-".repeat(o[a])} `}),r+=`|
`,I.forEach(i=>{i.forEach((a,$)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(o[$]-a.toString().length)} `)}),r+=`|
`}),r}}e.$U=N}),define(K[7],W([0,1,13]),function(z,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=T,e.$8c=I,e.$9c=r,e.$0c=o;const E=(i,a)=>i===a;e.$6c=E;function T(i=e.$6c){return(a,$)=>N.$ub(a,$,i)}function I(){return(i,a)=>JSON.stringify(i)===JSON.stringify(a)}function r(){return(i,a)=>i.equals(a)}function o(i,a,$){return!i||!a?i===a:$(i,a)}}),define(K[4],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=I,e.$ad=b;class N{constructor(n,t,s){this.owner=n,this.debugNameSource=t,this.referenceFn=s}getDebugName(n){return I(n,this)}}e.$$c=N;const E=new Map,T=new WeakMap;function I(u,n){const t=T.get(u);if(t)return t;const s=r(u,n);if(s){let l=E.get(s)??0;l++,E.set(s,l);const y=l===1?s:`${s}#${l}`;return T.set(u,y),y}}function r(u,n){const t=T.get(u);if(t)return t;const s=n.owner?$(n.owner)+".":"";let l;const y=n.debugNameSource;if(y!==void 0)if(typeof y=="function"){if(l=y(),l!==void 0)return s+l}else return s+y;const M=n.referenceFn;if(M!==void 0&&(l=b(M),l!==void 0))return s+l;if(n.owner!==void 0){const L=o(n.owner,u);if(L!==void 0)return s+L}}function o(u,n){for(const t in u)if(u[t]===n)return t}const i=new Map,a=new WeakMap;function $(u){const n=a.get(u);if(n)return n;const t=c(u);let s=i.get(t)??0;s++,i.set(t,s);const l=s===1?t:`${t}#${s}`;return a.set(u,l),l}function c(u){const n=u.constructor;return n?n.name:"Object"}function b(u){const n=u.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(s?s[1]:void 0)?.trim()}}),define(K[5],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fd=void 0,e.$Dd=E,e.$Ed=T;let N;function E(t){N=t}function T(){return N}class I{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([o(u("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[o(" "),a($(s.oldValue,70),{color:"red",strikeThrough:!0}),o(" "),a($(s.newValue,60),{color:"green"})]:[o(" (unchanged)")]:[o(" "),a($(s.newValue,60),{color:"green"}),o(" (initial)")]}handleObservableChanged(s,l){console.log(...this.b([i("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(y,M)=>(this.d.get(s).add(y),l.apply(s,[y,M]))}handleDerivedRecomputed(s,l){const y=this.d.get(s);console.log(...this.b([i("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(y),{data:[{fn:s._computeFn}]}])),y.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.b([i("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(y,M)=>(this.d.get(s).add(y),l.apply(s,[y,M]))}handleAutorunTriggered(s){const l=this.d.get(s);console.log(...this.b([i("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.b([i("transaction"),a(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Fd=I;function r(t){const s=new Array,l=[];let y="";function M(O){if("length"in O)for(const f of O)f&&M(f);else"text"in O?(y+=`%c${O.text}`,s.push(O.style),O.data&&l.push(...O.data)):"data"in O&&l.push(...O.data)}M(t);const L=[y,...s];return L.push(...l),L}function o(t){return a(t,{color:"black"})}function i(t){return a(n(`${t}: `,10),{color:"black",bold:!0})}function a(t,s={color:"black"}){function l(M){return Object.entries(M).reduce((L,[O,f])=>`${L}${O}:${f};`,"")}const y={color:s.color};return s.strikeThrough&&(y["text-decoration"]="line-through"),s.bold&&(y["font-weight"]="bold"),{text:t,style:l(y)}}function $(t,s){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=s?`"${t}"`:`"${t.substr(0,s-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?c(t,s):b(t,s);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function c(t,s){let l="[ ",y=!0;for(const M of t){if(y||(l+=", "),l.length-5>s){l+="...";break}y=!1,l+=`${$(M,s-l.length)}`}return l+=" ]",l}function b(t,s){let l="{ ",y=!0;for(const[M,L]of Object.entries(t)){if(y||(l+=", "),l.length-5>s){l+="...";break}y=!1,l+=`${M}: ${$(L,s-l.length)}`}return l+=" }",l}function u(t,s){let l="";for(let y=1;y<=s;y++)l+=t;return l}function n(t,s){for(;t.length<s;)t+=" ";return t}}),define(K[8],W([0,1,27,2,4,5]),function(z,e,N,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=void 0,e.$hd=r,e.$id=o,e.$jd=i,e.$kd=a,e.$ld=$,e.$md=c;function r(n){return new u(new T.$$c(void 0,void 0,n),n,void 0,void 0)}function o(n,t){return new u(new T.$$c(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}function i(n,t){return new u(new T.$$c(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}function a(n,t){const s=new E.$Tc,l=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(y,M)=>{s.clear(),t(y,M,s)});return(0,E.$Sc)(()=>{l.dispose(),s.dispose()})}function $(n){const t=new E.$Tc,s=o({owner:void 0,debugName:void 0,debugReferenceFn:n},l=>{t.clear(),n(l,t)});return(0,E.$Sc)(()=>{s.dispose(),t.dispose()})}function c(n,t){let s;return o({debugReferenceFn:t},l=>{const y=n.read(l),M=s;s=y,t({lastValue:M,newValue:y})})}var b;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(b||(b={}));class u{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,s,l,y){this.h=t,this._runFn=s,this.i=l,this.j=y,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,I.$Ed)()?.handleAutorunCreated(this),this.k(),(0,E.$Lc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,E.$Mc)(this)}k(){if(this.a===3)return;const t=this.f;this.f=this.e,this.e=t,this.a=3;const s=this.c;try{if(!s){(0,I.$Ed)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{s||(0,I.$Ed)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const t of this.e)if(t.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,N.$fd)(()=>this.b>=0)}handlePossibleChange(t){this.a===3&&this.e.has(t)&&!this.f.has(t)&&(this.a=1)}handleChange(t,s){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:s,didChange:y=>y===t},this.g))&&(this.a=2)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const s=t.get();return this.e.add(t),this.f.delete(t),s}}e.$nd=u,function(n){n.Observer=u}(r||(e.$hd=r={}))}),define(K[6],W([0,1,7,4,5]),function(z,e,N,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Yd=e.$Vd=e.$Qd=e.$Pd=void 0,e.$Md=r,e.$Nd=i,e.$Od=$,e.$Rd=u,e.$Sd=t,e.$Td=s,e.$Ud=l,e.$Wd=M,e.$Xd=L,e.$Zd=f;let I;function r(w){I=w}let o;function i(w){o=w}let a;function $(w){a=w}class c{get TChange(){return null}reportChanges(){this.get()}read(C){return C?C.readObservable(this):this.get()}map(C,D){const d=D===void 0?void 0:C,m=D===void 0?C:D;return a({owner:d,debugName:()=>{const A=(0,E.$ad)(m);if(A!==void 0)return A;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(m.toString());if(k)return`${this.debugName}.${k[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:m},A=>m(this.read(A),A))}recomputeInitiallyAndOnChange(C,D){return C.add(I(this,D)),this}keepObserved(C){return C.add(o(this)),this}}e.$Pd=c;class b extends c{constructor(){super(...arguments),this.a=new Set}addObserver(C){const D=this.a.size;this.a.add(C),D===0&&this.b()}removeObserver(C){this.a.delete(C)&&this.a.size===0&&this.c()}b(){}c(){}}e.$Qd=b;function u(w,C){const D=new y(w,C);try{w(D)}finally{D.finish()}}let n;function t(w){if(n)w(n);else{const C=new y(w,void 0);n=C;try{w(C)}finally{C.finish(),n=void 0}}}async function s(w,C){const D=new y(w,C);try{await w(D)}finally{D.finish()}}function l(w,C,D){w?C(w):u(C,D)}class y{constructor(C,D){this._fn=C,this.b=D,this.a=[],(0,T.$Ed)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,E.$ad)(this._fn)}updateObserver(C,D){this.a.push({observer:C,observable:D}),C.beginUpdate(D)}finish(){const C=this.a;for(let D=0;D<C.length;D++){const{observer:d,observable:m}=C[D];d.endUpdate(m)}this.a=null,(0,T.$Ed)()?.handleEndTransaction()}}e.$Vd=y;function M(w,C){let D;return typeof w=="string"?D=new E.$$c(void 0,w,void 0):D=new E.$$c(w,void 0,void 0),new O(D,C,N.$6c)}function L(w,C){return new O(new E.$$c(w.owner,w.debugName,void 0),C,w.equalsFn??N.$6c)}class O extends b{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(C,D,d){super(),this.e=C,this.f=d,this.d=D}get(){return this.d}set(C,D,d){if(this.f(this.d,C))return;let m;D||(D=m=new y(()=>{},()=>`Setting ${this.debugName}`));try{const A=this.d;this.g(C),(0,T.$Ed)()?.handleObservableChanged(this,{oldValue:A,newValue:C,change:d,didChange:!0,hadValue:!0});for(const F of this.a)D.updateObserver(F,this),F.handleChange(this,d)}finally{m&&m.finish()}}toString(){return`${this.debugName}: ${this.d}`}g(C){this.d=C}}e.$Yd=O;function f(w,C){let D;return typeof w=="string"?D=new E.$$c(void 0,w,void 0):D=new E.$$c(w,void 0,void 0),new S(D,C,N.$6c)}class S extends O{g(C){this.d!==C&&(this.d&&this.d.dispose(),this.d=C)}dispose(){this.d?.dispose()}}e.$1d=S}),define(K[9],W([0,1,27,7,2,6,4,5]),function(z,e,N,E,T,I,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Gd=i,e.$Hd=a,e.$Id=$,e.$Jd=c,e.$Kd=b;function i(t,s){return s!==void 0?new n(new r.$$c(t,void 0,s),s,void 0,void 0,void 0,E.$6c):new n(new r.$$c(void 0,void 0,t),t,void 0,void 0,void 0,E.$6c)}function a(t,s){return new n(new r.$$c(t.owner,t.debugName,t.debugReferenceFn),s,void 0,void 0,t.onLastObserverRemoved,t.equalsFn??E.$6c)}(0,I.$Od)(a);function $(t,s){return new n(new r.$$c(t.owner,t.debugName,void 0),s,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??E.$6c)}function c(t,s){let l,y;s===void 0?(l=t,y=void 0):(y=t,l=s);const M=new T.$Tc;return new n(new r.$$c(y,void 0,l),L=>(M.clear(),l(L,M)),void 0,void 0,()=>M.dispose(),E.$6c)}function b(t,s){let l,y;s===void 0?(l=t,y=void 0):(y=t,l=s);const M=new T.$Tc;return new n(new r.$$c(y,void 0,l),L=>{M.clear();const O=l(L);return O&&M.add(O),O},void 0,void 0,()=>M.dispose(),E.$6c)}var u;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(u||(u={}));class n extends I.$Qd{get debugName(){return this.l.getDebugName(this)??"(anonymous)"}constructor(s,l,y,M,L=void 0,O){super(),this.l=s,this._computeFn=l,this.m=y,this.n=M,this.p=L,this.q=O,this.e=0,this.f=void 0,this.g=0,this.h=new Set,this.j=new Set,this.k=void 0,this.k=this.m?.(),(0,o.$Ed)()?.handleDerivedCreated(this)}c(){this.e=0,this.f=void 0;for(const s of this.h)s.removeObserver(this);this.h.clear(),this.p?.()}get(){if(this.a.size===0){const s=this._computeFn(this,this.m?.());return this.c(),s}else{do{if(this.e===1){for(const s of this.h)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.t()}while(this.e!==3);return this.f}}t(){if(this.e===3)return;const s=this.j;this.j=this.h,this.h=s;const l=this.e!==0,y=this.f;this.e=3;const M=this.k;this.k=this.m?.();try{this.f=this._computeFn(this,M)}finally{for(const O of this.j)O.removeObserver(this);this.j.clear()}const L=l&&!this.q(y,this.f);if((0,o.$Ed)()?.handleDerivedRecomputed(this,{oldValue:y,newValue:this.f,change:void 0,didChange:L,hadValue:l}),L)for(const O of this.a)O.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.g++;const l=this.g===1;if(this.e===3&&(this.e=1,!l))for(const y of this.a)y.handlePossibleChange(this);if(l)for(const y of this.a)y.beginUpdate(this)}endUpdate(s){if(this.g--,this.g===0){const l=[...this.a];for(const y of l)y.endUpdate(this)}(0,N.$fd)(()=>this.g>=0)}handlePossibleChange(s){if(this.e===3&&this.h.has(s)&&!this.j.has(s)){this.e=1;for(const l of this.a)l.handlePossibleChange(this)}}handleChange(s,l){if(this.h.has(s)&&!this.j.has(s)){const y=this.n?this.n({changedObservable:s,change:l,didChange:L=>L===s},this.k):!0,M=this.e===3;if(y&&(this.e===1||M)&&(this.e=2,M))for(const L of this.a)L.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const l=s.get();return this.h.add(s),this.j.delete(s),l}addObserver(s){const l=!this.a.has(s)&&this.g>0;super.addObserver(s),l&&s.beginUpdate(this)}removeObserver(s){const l=this.a.has(s)&&this.g>0;super.removeObserver(s),l&&s.endUpdate(this)}}e.$Ld=n}),define(K[28],W([0,1,2,8,6,4,9,5]),function(z,e,N,E,T,I,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zd=e.$rd=void 0,e.$od=i,e.$pd=$,e.$qd=c,e.$sd=u,e.$td=t,e.$ud=l,e.$vd=y,e.$wd=M,e.$xd=L,e.$yd=O,e.$Ad=S,e.$Bd=w,e.$Cd=C;function i(d){return new a(d)}class a extends T.$Pd{constructor(m){super(),this.a=m}get debugName(){return this.toString()}get(){return this.a}addObserver(m){}removeObserver(m){}toString(){return`Const: ${this.a}`}}function $(d){const m=(0,T.$Wd)("promiseValue",{});return d.then(A=>{m.set({value:A},void 0)}),m}function c(d,m){return new b(d,m)}class b extends T.$Qd{constructor(m,A){super(),this.h=m,this._getValue=A,this.f=!1,this.l=F=>{const k=this._getValue(F),g=this.e,R=!this.f||g!==k;let q=!1;R&&(this.e=k,this.f&&(q=!0,(0,T.$Ud)(b.globalTransaction,B=>{(0,o.$Ed)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:k,change:void 0,didChange:R,hadValue:this.f});for(const G of this.a)B.updateObserver(G,this),G.handleChange(this,void 0)},()=>{const B=this.j();return"Event fired"+(B?`: ${B}`:"")})),this.f=!0),q||(0,o.$Ed)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:k,change:void 0,didChange:R,hadValue:this.f})}}j(){return(0,I.$ad)(this._getValue)}get debugName(){const m=this.j();return"From Event"+(m?`: ${m}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this._getValue(void 0)}}e.$rd=b,function(d){d.Observer=b;function m(A,F){let k=!1;b.globalTransaction===void 0&&(b.globalTransaction=A,k=!0);try{F()}finally{k&&(b.globalTransaction=void 0)}}d.batchEventsGlobally=m}(c||(e.$qd=c={}));function u(d,m){return new n(d,m)}class n extends T.$Qd{constructor(m,A){super(),this.debugName=m,this.f=A,this.h=()=>{(0,T.$Rd)(F=>{for(const k of this.a)F.updateObserver(k,this),k.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function t(d){return typeof d=="string"?new s(d):new s(void 0,d)}class s extends T.$Qd{get debugName(){return new I.$$c(this.f,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(m,A){super(),this.e=m,this.f=A}trigger(m,A){if(!m){(0,T.$Rd)(F=>{this.trigger(F,A)},()=>`Trigger signal ${this.debugName}`);return}for(const F of this.a)m.updateObserver(F,this),F.handleChange(this,A)}get(){}}function l(d,m,A){const F=(0,T.$Wd)("debounced",void 0);let k;return A.add((0,E.$hd)(g=>{const R=d.read(g);k&&clearTimeout(k),k=setTimeout(()=>{(0,T.$Rd)(q=>{F.set(R,q)})},m)})),F}function y(d,m){let A=!1,F,k;return c(g=>{const R=(0,E.$hd)(q=>{const B=d.read(q);A?(k&&clearTimeout(k),k=setTimeout(()=>{F=B,g()},m)):(A=!0,F=B)});return{dispose(){R.dispose(),A=!1,F=void 0}}},()=>A?F:d.get())}function M(d,m,A){const F=(0,T.$Wd)("triggeredRecently",!1);let k;return A.add(d(()=>{F.set(!0,void 0),k&&clearTimeout(k),k=setTimeout(()=>{F.set(!1,void 0)},m)})),F}function L(d){const m=new f(!1,void 0);return d.addObserver(m),(0,N.$Sc)(()=>{d.removeObserver(m)})}(0,T.$Nd)(L);function O(d,m){const A=new f(!0,m);return d.addObserver(A),m?m(d.get()):d.reportChanges(),(0,N.$Sc)(()=>{d.removeObserver(A)})}(0,T.$Md)(O);class f{constructor(m,A){this.b=m,this.c=A,this.a=0}beginUpdate(m){this.a++}endUpdate(m){this.a--,this.a===0&&this.b&&(this.c?this.c(m.get()):m.reportChanges())}handlePossibleChange(m){}handleChange(m,A){}}e.$zd=f;function S(d,m){let A;return(0,r.$Gd)(d,k=>(A=m(k,A),A))}function w(d,m){let A;const F=(0,T.$Wd)("derivedObservableWithWritableCache.counter",0),k=(0,r.$Gd)(d,g=>(F.read(g),A=m(g,A),A));return Object.assign(k,{clearCache:g=>{A=void 0,F.set(F.get()+1,g)}})}function C(d,m,A,F){let k=new D(A,F);return(0,r.$Hd)({debugReferenceFn:A,owner:d,onLastObserverRemoved:()=>{k.dispose(),k=new D(A)}},R=>(k.setItems(m.read(R)),k.getItems()))}class D{constructor(m,A){this.c=m,this.e=A,this.a=new Map,this.b=[]}dispose(){this.a.forEach(m=>m.store.dispose()),this.a.clear()}setItems(m){const A=[],F=new Set(this.a.keys());for(const k of m){const g=this.e?this.e(k):k;let R=this.a.get(g);if(R)F.delete(g);else{const q=new N.$Tc;R={out:this.c(k,q),store:q},this.a.set(g,R)}A.push(R.out)}for(const k of F)this.a.get(k).store.dispose(),this.a.delete(k);this.b=A}getItems(){return this.b}}}),define(K[29],W([0,1,8,6,9,30,4,7]),function(z,e,N,E,T,I,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=void 0,e.$6d=b,e.$7d=u;class i{get cachedValue(){return this.a}constructor(t){this.b=t,this.a=(0,E.$Wd)(this,void 0)}getValue(){let t=this.a.get();return t||(t=this.b(),this.a.set(t,void 0)),t}}e.$2d=i;class a{constructor(t){this.a=(0,E.$Wd)(this,void 0),this.promiseResult=this.a,this.promise=t.then(s=>((0,E.$Rd)(l=>{this.a.set(new $(s,void 0),l)}),s),s=>{throw(0,E.$Rd)(l=>{this.a.set(new $(void 0,s),l)}),s})}}e.$3d=a;class ${constructor(t,s){this.data=t,this.error=s}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$4d=$;class c{constructor(t){this.b=t,this.a=new i(()=>new a(this.b())),this.cachedPromiseResult=(0,T.$Gd)(this,s=>this.a.cachedValue.read(s)?.promiseResult.read(s))}getPromise(){return this.a.getValue().promise}}e.$5d=c;function b(n,t,s){return new Promise((l,y)=>{let M=!0,L=!1;const O=n.map(S=>({isFinished:t(S),error:s?s(S):!1,state:S})),f=(0,N.$hd)(S=>{const{isFinished:w,error:C,state:D}=O.read(S);(w||C)&&(M?L=!0:f.dispose(),C?y(C===!0?D:C):l(D))});M=!1,L&&f.dispose()})}function u(n,t){let s,l;t===void 0?(s=n,l=void 0):(l=n,s=t);let y;return new T.$Ld(new r.$$c(l,void 0,s),M=>(y&&y.dispose(!0),y=new I.$je,s(M,y.token)),void 0,void 0,()=>y?.dispose(),o.$6c)}}),define(K[14],W([0,1,6,9,8,28,29,5]),function(z,e,N,E,T,I,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return N.$Wd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return N.$Zd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return N.$Rd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return N.$Ud}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.$Gd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return E.$Hd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return E.$Id}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return E.$Jd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return T.$hd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return T.$md}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return T.$jd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return T.$ld}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return T.$id}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return T.$kd}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return I.$od}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return I.$ud}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return I.$Ad}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return I.$Bd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return I.$xd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return I.$yd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return I.$qd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return I.$pd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return I.$td}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return I.$sd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return I.$wd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$2d}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$5d}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$3d}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$4d}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$6d}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$7d}}),!1&&(0,o.$Dd)(new o.$Fd)}),define(K[31],W([0,1,10,2]),function(z,e,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=T,e.$le=I,e.$me=r,e.$ne=o,e.$oe=a,e.$pe=$,e.$qe=c,e.$re=b,e.$se=u,e.$te=n,e.$ue=t,e.$ve=s,e.$we=l,e.$xe=y,e.$ye=M;function T(L){const O=L;return O?typeof O.read=="function":!1}function I(L){const O=L;return O?[O.on,O.pause,O.resume,O.destroy].every(f=>typeof f=="function"):!1}function r(L){const O=L;return O?I(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}function o(L,O){return new i(L,O)}class i{constructor(O,f){this.e=O,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(f=>f(O))}h(O){this.c.error.length===0?(0,N.$1)(O):this.c.error.slice(0).forEach(f=>f(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,f){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(O,f){if(this.a.destroyed)return;let S;switch(O){case"data":S=this.c.data;break;case"end":S=this.c.end;break;case"error":S=this.c.error;break}if(S){const w=S.indexOf(f);w>=0&&S.splice(w,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(S=>S())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(L,O){const f=[];let S;for(;(S=L.read())!==null;)f.push(S);return O(f)}function $(L,O,f){const S=[];let w;for(;(w=L.read())!==null&&S.length<f;)S.push(w);return w===null&&S.length>0?O(S):{read:()=>{if(S.length>0)return S.shift();if(typeof w<"u"){const C=w;return w=void 0,C}return L.read()}}}function c(L,O){return new Promise((f,S)=>{const w=[];b(L,{onData:C=>{O&&w.push(C)},onError:C=>{O?S(C):f(void 0)},onEnd:()=>{f(O?O(w):void 0)}})})}function b(L,O,f){L.on("error",S=>{f?.isCancellationRequested||O.onError(S)}),L.on("end",()=>{f?.isCancellationRequested||O.onEnd()}),L.on("data",S=>{f?.isCancellationRequested||O.onData(S)})}function u(L,O){return new Promise((f,S)=>{const w=new E.$Tc,C=[],D=A=>{if(C.push(A),C.length>O)return w.dispose(),L.pause(),f({stream:L,buffer:C,ended:!1})},d=A=>(w.dispose(),S(A)),m=()=>(w.dispose(),f({stream:L,buffer:C,ended:!0}));w.add((0,E.$Sc)(()=>L.removeListener("error",d))),L.on("error",d),w.add((0,E.$Sc)(()=>L.removeListener("end",m))),L.on("end",m),w.add((0,E.$Sc)(()=>L.removeListener("data",D))),L.on("data",D)})}function n(L,O){const f=o(O);return f.end(L),f}function t(){const L=o(()=>{throw new Error("not supported")});return L.end(),L}function s(L){let O=!1;return{read:()=>O?null:(O=!0,L)}}function l(L,O,f){const S=o(f);return b(L,{onData:w=>S.write(O.data(w)),onError:w=>S.error(O.error?O.error(w):w),onEnd:()=>S.end()}),S}function y(L,O,f){let S=!1;return{read:()=>{const w=O.read();return S?w:(S=!0,w!==null?f([L,w]):L)}}}function M(L,O,f){let S=!1;const w=o(f);return b(O,{onData:C=>S?w.write(C):(S=!0,w.write(f([L,C]))),onError:C=>w.error(C),onEnd:()=>{S||(S=!0,w.write(L)),w.end()}}),w}}),define(K[15],W([0,1,32,31]),function(z,e,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=void 0,e.$Ae=a,e.$Be=$,e.$Ce=c,e.$De=b,e.$Ee=u,e.$Fe=n,e.$Ge=t,e.$He=s,e.$Ie=l,e.$Je=y,e.$Ke=M,e.$Le=L,e.$Me=O,e.$Ne=f,e.$Oe=S,e.$Pe=w,e.$Qe=C,e.$Re=D,e.$Se=d,e.$Te=F;const T=typeof Buffer<"u",I=new N.$V(()=>new Uint8Array(256));let r,o;class i{static alloc(g){return T?new i(Buffer.allocUnsafe(g)):new i(new Uint8Array(g))}static wrap(g){return T&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new i(g)}static fromString(g,R){return!(R?.dontUseNodeBuffer||!1)&&T?new i(Buffer.from(g)):(r||(r=new TextEncoder),new i(r.encode(g)))}static fromByteArray(g){const R=i.alloc(g.length);for(let q=0,B=g.length;q<B;q++)R.buffer[q]=g[q];return R}static concat(g,R){if(typeof R>"u"){R=0;for(let G=0,H=g.length;G<H;G++)R+=g[G].byteLength}const q=i.alloc(R);let B=0;for(let G=0,H=g.length;G<H;G++){const V=g[G];q.set(V,B),B+=V.byteLength}return q}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=i.alloc(this.byteLength);return g.set(this),g}toString(){return T?this.buffer.toString():(o||(o=new TextDecoder),o.decode(this.buffer))}slice(g,R){return new i(this.buffer.subarray(g,R))}set(g,R){if(g instanceof i)this.buffer.set(g.buffer,R);else if(g instanceof Uint8Array)this.buffer.set(g,R);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),R);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,R){u(this.buffer,g,R)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,R){t(this.buffer,g,R)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,R){l(this.buffer,g,R)}indexOf(g,R=0){return a(this.buffer,g instanceof i?g.buffer:g,R)}}e.$ze=i;function a(k,g,R=0){const q=g.byteLength,B=k.byteLength;if(q===0)return 0;if(q===1)return k.indexOf(g[0]);if(q>B-R)return-1;const G=I.value;G.fill(g.length);for(let X=0;X<g.length;X++)G[g[X]]=g.length-X-1;let H=R+g.length-1,V=H,Q=-1;for(;H<B;)if(k[H]===g[V]){if(V===0){Q=H;break}H--,V--}else H+=Math.max(g.length-V,G[k[H]]),V=g.length-1;return Q}function $(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0}function c(k,g,R){k[R+0]=g&255,g=g>>>8,k[R+1]=g&255}function b(k,g){return k[g]*2**24+k[g+1]*2**16+k[g+2]*2**8+k[g+3]}function u(k,g,R){k[R+3]=g,g=g>>>8,k[R+2]=g,g=g>>>8,k[R+1]=g,g=g>>>8,k[R]=g}function n(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0|k[g+2]<<16>>>0|k[g+3]<<24>>>0}function t(k,g,R){k[R+0]=g&255,g=g>>>8,k[R+1]=g&255,g=g>>>8,k[R+2]=g&255,g=g>>>8,k[R+3]=g&255}function s(k,g){return k[g]}function l(k,g,R){k[R]=g}function y(k){return E.$oe(k,g=>i.concat(g))}function M(k){return E.$ve(k)}function L(k){return E.$qe(k,g=>i.concat(g))}async function O(k){return k.ended?i.concat(k.buffer):i.concat([...k.buffer,await L(k.stream)])}function f(k){return E.$te(k,g=>i.concat(g))}function S(k){return E.$we(k,{data:g=>typeof g=="string"?i.fromString(g):i.wrap(g)},g=>i.concat(g))}function w(k){return E.$ne(g=>i.concat(g),k)}function C(k,g){return E.$xe(k,g,R=>i.concat(R))}function D(k,g){return E.$ye(k,g,R=>i.concat(R))}function d(k){let g=0,R=0,q=0;const B=new Uint8Array(Math.floor(k.length/4*3)),G=V=>{switch(R){case 3:B[q++]=g|V,R=0;break;case 2:B[q++]=g|V>>>2,g=V<<6,R=3;break;case 1:B[q++]=g|V>>>4,g=V<<4,R=2;break;default:g=V<<2,R=1}};for(let V=0;V<k.length;V++){const Q=k.charCodeAt(V);if(Q>=65&&Q<=90)G(Q-65);else if(Q>=97&&Q<=122)G(Q-97+26);else if(Q>=48&&Q<=57)G(Q-48+52);else if(Q===43||Q===45)G(62);else if(Q===47||Q===95)G(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${k[V]}`)}}const H=q;for(;R>0;)G(0);return i.wrap(B).slice(0,H)}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:k},g=!0,R=!1){const q=R?A:m;let B="";const G=k.byteLength%3;let H=0;for(;H<k.byteLength-G;H+=3){const V=k[H+0],Q=k[H+1],X=k[H+2];B+=q[V>>>2],B+=q[(V<<4|Q>>>4)&63],B+=q[(Q<<2|X>>>6)&63],B+=q[X&63]}if(G===1){const V=k[H+0];B+=q[V>>>2],B+=q[V<<4&63],g&&(B+="==")}else if(G===2){const V=k[H+0],Q=k[H+1];B+=q[V>>>2],B+=q[(V<<4|Q>>>4)&63],B+=q[Q<<2&63],g&&(B+="=")}return B}}),define(K[33],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=void 0,e.$9d=Symbol("MicrotaskDelay")}),define(K[16],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Kt=E;var N;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(N||(e.StringEOL=N={}));function E(T){let I=0,r=0,o=0,i=0;for(let a=0,$=T.length;a<$;a++){const c=T.charCodeAt(a);c===13?(I===0&&(r=a),I++,a+1<$&&T.charCodeAt(a+1)===10?(i|=2,a++):i|=3,o=a+1):c===10&&(i|=1,I===0&&(r=a),I++,o=a+1)}return I===0&&(r=T.length),[I,r,T.length-o,i]}}),define(K[17],W([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var N;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(N||(e.LanguageId=N={}));var E;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var T;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(T||(e.ColorId=T={}));var I;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(I||(e.StandardTokenType=I={}));var r;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class o{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let c="mtk"+this.getForeground(a);const b=this.getFontStyle(a);return b&1&&(c+=" mtki"),b&2&&(c+=" mtkb"),b&4&&(c+=" mtku"),b&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(a,$){const c=this.getForeground(a),b=this.getFontStyle(a);let u=`color: ${$[c]};`;b&1&&(u+="font-style: italic;"),b&2&&(u+="font-weight: bold;");let n="";return b&4&&(n+=" underline"),b&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(a){const $=this.getForeground(a),c=this.getFontStyle(a);return{foreground:$,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$It=o}),define(K[34],W([0,1,13]),function(z,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class E{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,o){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=o}replace(r,o,i){if(r>=this.a.length)return;if(o===0){this.insert(r,i);return}else if(i===0){this.delete(r,o);return}const a=this.a.slice(0,r),$=this.a.slice(r+o),c=T(i,this.b);this.a=a.concat(c,$)}delete(r,o){o===0||r>=this.a.length||this.a.splice(r,o)}insert(r,o){if(o===0||r>=this.a.length)return;const i=[];for(let a=0;a<o;a++)i[a]=this.b;this.a=(0,N.$Wb)(this.a,r,i)}}e.$NC=E;function T(I,r){const o=[];for(let i=0;i<I;i++)o[i]=r;return o}}),define(K[11],W([0,1,17]),function(z,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class E{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,o){const i=E.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=i,new E(a,r,o)}constructor(r,o,i){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=o,this.d=i}equals(r){return r instanceof E?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,o,i){if(this.c!==r.c||this.b!==r.b)return!1;const a=o<<1,$=a+(i<<1);for(let c=a;c<$;c++)if(this.a[c]!==r.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const o=this.a[(r<<1)+1],i=N.$It.getLanguageId(o);return this.d.decodeLanguageId(i)}getStandardTokenType(r){const o=this.a[(r<<1)+1];return N.$It.getTokenType(o)}getForeground(r){const o=this.a[(r<<1)+1];return N.$It.getForeground(o)}getClassName(r){const o=this.a[(r<<1)+1];return N.$It.getClassNameFromMetadata(o)}getInlineStyle(r,o){const i=this.a[(r<<1)+1];return N.$It.getInlineStyleFromMetadata(i,o)}getPresentation(r){const o=this.a[(r<<1)+1];return N.$It.getPresentationFromMetadata(o)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return E.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,o,i){return new T(this,r,o,i)}static convertToEndOffset(r,o){const a=(r.length>>>1)-1;for(let $=0;$<a;$++)r[$<<1]=r[$+1<<1];r[a<<1]=o}static findIndexInTokensArray(r,o){if(r.length<=2)return 0;let i=0,a=(r.length>>>1)-1;for(;i<a;){const $=i+Math.floor((a-i)/2),c=r[$<<1];if(c===o)return $+1;c<o?i=$+1:c>o&&(a=$)}return i}withInserted(r){if(r.length===0)return this;let o=0,i=0,a="";const $=new Array;let c=0;for(;;){const b=o<this.b?this.a[o<<1]:-1,u=i<r.length?r[i]:null;if(b!==-1&&(u===null||b<=u.offset)){a+=this.c.substring(c,b);const n=this.a[(o<<1)+1];$.push(a.length,n),o++,c=b}else if(u){if(u.offset>c){a+=this.c.substring(c,u.offset);const n=this.a[(o<<1)+1];$.push(a.length,n),c=u.offset}a+=u.text,$.push(a.length,u.tokenMetadata),i++}else break}return new E(new Uint32Array($),a,this.d)}}e.$Lt=E;class T{constructor(r,o,i,a){this.a=r,this.b=o,this.c=i,this.d=a,this.e=r.findTokenIndexAtOffset(o),this.f=0;for(let $=this.e,c=r.getCount();$<c&&!(r.getStartOffset($)>=i);$++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof T?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const o=this.a.getEndOffset(this.e+r);return Math.min(this.c,o)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,o){return this.a.getInlineStyle(this.e+r,o)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(K[35],W([0,1,11]),function(z,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Mt=void 0,e.$Ot=T,e.$Mt=new Uint32Array(0).buffer;class E{static deleteBeginning(r,o){return r===null||r===e.$Mt?r:E.delete(r,0,o)}static deleteEnding(r,o){if(r===null||r===e.$Mt)return r;const i=T(r),a=i[i.length-2];return E.delete(r,o,a)}static delete(r,o,i){if(r===null||r===e.$Mt||o===i)return r;const a=T(r),$=a.length>>>1;if(o===0&&a[a.length-2]===i)return e.$Mt;const c=N.$Lt.findIndexInTokensArray(a,o),b=c>0?a[c-1<<1]:0,u=a[c<<1];if(i<u){const y=i-o;for(let M=c;M<$;M++)a[M<<1]-=y;return r}let n,t;b!==o?(a[c<<1]=o,n=c+1<<1,t=o):(n=c<<1,t=b);const s=i-o;for(let y=c+1;y<$;y++){const M=a[y<<1]-s;M>t&&(a[n++]=M,a[n++]=a[(y<<1)+1],t=M)}if(n===a.length)return r;const l=new Uint32Array(n);return l.set(a.subarray(0,n),0),l.buffer}static append(r,o){if(o===e.$Mt)return r;if(r===e.$Mt)return o;if(r===null)return r;if(o===null)return null;const i=T(r),a=T(o),$=a.length>>>1,c=new Uint32Array(i.length+a.length);c.set(i,0);let b=i.length;const u=i[i.length-2];for(let n=0;n<$;n++)c[b++]=a[n<<1]+u,c[b++]=a[(n<<1)+1];return c.buffer}static insert(r,o,i){if(r===null||r===e.$Mt)return r;const a=T(r),$=a.length>>>1;let c=N.$Lt.findIndexInTokensArray(a,o);c>0&&a[c-1<<1]===o&&c--;for(let b=c;b<$;b++)a[b<<1]+=i;return r}}e.$Nt=E;function T(I){return I instanceof Uint32Array?I:new Uint32Array(I)}}),define(K[36],W([0,1,13,15,48,16,35,18]),function(z,e,N,E,T,I,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class i{static deserialize($,c,b){const u=new Uint32Array($.buffer),n=(0,E.$De)($,c);c+=4;const t=(0,E.$De)($,c);c+=4;const s=[];for(let l=0;l<t;l++){const y=(0,E.$De)($,c);c+=4,s.push(u.subarray(c/4,c/4+y/4)),c+=y}return b.push(new i(n,s)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,c){this.a=$,this.b=c}getLineRange(){return new o.$yv(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let c=0;c<this.b.length;c++){const b=this.b[c];if(!(b instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=b.byteLength}return $}serialize($,c){(0,E.$Ee)($,this.a,c),c+=4,(0,E.$Ee)($,this.b.length,c),c+=4;for(let b=0;b<this.b.length;b++){const u=this.b[b];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,E.$Ee)($,u.byteLength,c),c+=4,$.set(new Uint8Array(u.buffer),c),c+=u.byteLength}return c}applyEdit($,c){const[b,u]=(0,I.$Kt)(c);this.c($),this.d(new T.$gt($.startLineNumber,$.startColumn),b,u)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const c=$.startLineNumber-this.a,b=$.endLineNumber-this.a;if(b<0){const u=b-c;this.a-=u;return}if(!(c>=this.b.length)){if(c<0&&b>=this.b.length){this.a=0,this.b=[];return}if(c===b){this.b[c]=r.$Nt.delete(this.b[c],$.startColumn-1,$.endColumn-1);return}if(c>=0)if(this.b[c]=r.$Nt.deleteEnding(this.b[c],$.startColumn-1),b<this.b.length){const u=r.$Nt.deleteBeginning(this.b[b],$.endColumn-1);this.b[c]=r.$Nt.append(this.b[c],u),this.b.splice(c+1,b-c)}else this.b[c]=r.$Nt.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const u=-c;this.a-=u,this.b[b]=r.$Nt.deleteBeginning(this.b[b],$.endColumn-1),this.b=this.b.slice(b)}}}d($,c,b){if(c===0&&b===0)return;const u=$.lineNumber-this.a;if(u<0){this.a+=c;return}if(!(u>=this.b.length)){if(c===0){this.b[u]=r.$Nt.insert(this.b[u],$.column-1,b);return}this.b[u]=r.$Nt.deleteEnding(this.b[u],$.column-1),this.b[u]=r.$Nt.insert(this.b[u],$.column-1,b),this.e($.lineNumber,c)}}e($,c){if(c===0)return;const b=[];for(let u=0;u<c;u++)b[u]=null;this.b=N.$Wb(this.b,$,b)}}e.$Pt=i}),define(K[19],W([0,1,15,36]),function(z,e,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=void 0;class T{static deserialize(r){let o=0;const i=(0,N.$De)(r,o);o+=4;const a=[];for(let $=0;$<i;$++)o=E.$Pt.deserialize(r,o,a);return a}constructor(){this.a=[]}add(r,o){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===r){i.appendLineTokens(o);return}}this.a.push(new E.$Pt(r,[o]))}finalize(){return this.a}serialize(){const r=this.b(),o=new Uint8Array(r);return this.c(o),o}b(){let r=0;r+=4;for(let o=0;o<this.a.length;o++)r+=this.a[o].serializeSize();return r}c(r){let o=0;(0,N.$Ee)(r,this.a.length,o),o+=4;for(let i=0;i<this.a.length;i++)o=this.a[i].serialize(r,o)}}e.$OC=T}),define(K[37],W([0,1,20,3,21,49]),function(z,e,N,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=r,e.$hg=o,e.$ig=i,e.$jg=a,e.$kg=$,e.$lg=n,e.$mg=t,e.$ng=s,e.$og=l,e.$pg=y,e.$qg=M,e.$rg=L,e.$sg=O,e.$tg=f,e.$ug=S,e.$vg=D;function r(d){return d===47||d===92}function o(d){return d.replace(/[\\/]/g,N.$hc.sep)}function i(d){return d.indexOf("/")===-1&&(d=o(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}function a(d,m=N.$hc.sep){if(!d)return"";const A=d.length,F=d.charCodeAt(0);if(r(F)){if(r(d.charCodeAt(1))&&!r(d.charCodeAt(2))){let g=3;const R=g;for(;g<A&&!r(d.charCodeAt(g));g++);if(R!==g&&!r(d.charCodeAt(g+1))){for(g+=1;g<A;g++)if(r(d.charCodeAt(g)))return d.slice(0,g+1).replace(/[\\/]/g,m)}}return m}else if(l(F)&&d.charCodeAt(1)===58)return r(d.charCodeAt(2))?d.slice(0,2)+m:d.slice(0,2);let k=d.indexOf("://");if(k!==-1){for(k+=3;k<A;k++)if(r(d.charCodeAt(k)))return d.slice(0,k+1)}return""}function $(d){if(!E.$i||!d||d.length<5)return!1;let m=d.charCodeAt(0);if(m!==92||(m=d.charCodeAt(1),m!==92))return!1;let A=2;const F=A;for(;A<d.length&&(m=d.charCodeAt(A),m!==92);A++);return!(F===A||(m=d.charCodeAt(A+1),isNaN(m)||m===92))}const c=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(d,m=E.$i){const A=m?c:b;return!(!d||d.length===0||/^\s+$/.test(d)||(A.lastIndex=0,A.test(d))||m&&u.test(d)||d==="."||d===".."||m&&d[d.length-1]==="."||m&&d.length!==d.trim().length||d.length>255)}function t(d,m,A){const F=d===m;return!A||F?F:!d||!m?!1:(0,T.$qf)(d,m)}function s(d,m,A,F=N.sep){if(d===m)return!0;if(!d||!m||m.length>d.length)return!1;if(A){if(!(0,T.$rf)(d,m))return!1;if(m.length===d.length)return!0;let g=m.length;return m.charAt(m.length-1)===F&&g--,d.charAt(g)===F}return m.charAt(m.length-1)!==F&&(m+=F),d.indexOf(m)===0}function l(d){return d>=65&&d<=90||d>=97&&d<=122}function y(d,m){return E.$i&&d.endsWith(":")&&(d+=N.sep),(0,N.$jc)(d)||(d=(0,N.$kc)(m,d)),d=(0,N.$ic)(d),E.$i?(d=(0,T.$$e)(d,N.sep),d.endsWith(":")&&(d+=N.sep)):(d=(0,T.$$e)(d,N.sep),d||(d=N.sep)),d}function M(d){const m=(0,N.$ic)(d);return E.$i?d.length>3?!1:L(m)&&(d.length===2||m.charCodeAt(2)===92):m===N.$hc.sep}function L(d,m=E.$i){return m?l(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}function O(d,m=E.$i){return L(d,m)?d[0]:void 0}function f(d,m,A){return m.length>d.length?-1:d===m?0:(A&&(d=d.toLowerCase(),m=m.toLowerCase()),d.indexOf(m))}function S(d){const m=d.split(":");let A,F,k;for(const g of m){const R=Number(g);(0,I.$5f)(R)?F===void 0?F=R:k===void 0&&(k=R):A=A?[A,g].join(":"):g}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:F!==void 0?F:void 0,column:k!==void 0?k:F!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",C="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(d,m,A=8){let F="";for(let g=0;g<A;g++){let R;g===0&&E.$i&&!m&&(A===3||A===4)?R=C:R=w,F+=R.charAt(Math.floor(Math.random()*R.length))}let k;return m?k=`${m}-${F}`:k=F,d?(0,N.$kc)(d,k):k}}),define(K[22],W([0,1,10,3,21,12,20]),function(z,e,N,E,T,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Ag=e.$zg=e.$yg=e.Schemas=void 0,e.$wg=i,e.$xg=a,e.$Bg=c;var o;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.codeSetting="code-setting"})(o||(e.Schemas=o={}));function i(n,t){return I.URI.isUri(n)?(0,T.$qf)(n.scheme,t):(0,T.$rf)(n,t+":")}function a(n,...t){return t.some(s=>i(n,s))}e.$yg="vscode-tkn",e.$zg="tkn";class ${constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,s){this.f=c(t,s)}getServerRootPath(){return this.f}get g(){return r.$hc.join(this.f,o.vscodeRemoteResource)}set(t,s,l){this.a[t]=s,this.b[t]=l}setConnectionToken(t,s){this.c[t]=s}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(O){return N.$1(O),t}const s=t.authority;let l=this.a[s];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const y=this.b[s],M=this.c[s];let L=`path=${encodeURIComponent(t.path)}`;return typeof M=="string"&&(L+=`&${e.$zg}=${encodeURIComponent(M)}`),I.URI.from({scheme:E.$o?this.d:o.vscodeRemoteResource,authority:`${l}:${y}`,path:this.g,query:L})}}e.$Ag=new $;function c(n,t){return r.$hc.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.$Cg="vs/../../extensions",e.$Dg="vs/../../node_modules",e.$Eg="vs/../../node_modules.asar",e.$Fg="vs/../../node_modules.asar.unpacked",e.$Gg="vscode-app";class b{static{this.a=e.$Gg}asBrowserUri(t){const s=this.b(t,z);return this.uriToBrowserUri(s)}uriToBrowserUri(t){return t.scheme===o.vscodeRemote?e.$Ag.rewrite(t):t.scheme===o.file&&(E.$m||E.$q===`${o.vscodeFileResource}://${b.a}`)?t.with({scheme:o.vscodeFileResource,authority:t.authority||b.a,query:null,fragment:null}):t}asFileUri(t){const s=this.b(t,z);return this.uriToFileUri(s)}uriToFileUri(t){return t.scheme===o.vscodeFileResource?t.with({scheme:o.file,authority:t.authority!==b.a?t.authority:null,query:null,fragment:null}):t}b(t,s){return I.URI.isUri(t)?t:I.URI.parse(s.toUrl(t))}}e.$Hg=new b;var u;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const s="vscode-coi";function l(M){let L;typeof M=="string"?L=new URL(M).searchParams:M instanceof URL?L=M.searchParams:I.URI.isUri(M)&&(L=new URL(M.toString(!0)).searchParams);const O=L?.get(s);if(O)return t.get(O)}n.getHeadersFromQuery=l;function y(M,L,O){if(!globalThis.crossOriginIsolated)return;const f=L&&O?"3":O?"2":"1";M instanceof URLSearchParams?M.set(s,f):M[s]=f}n.addSearchParam=y})(u||(e.COI=u={}))}),define(K[38],W([0,1,26,22,3,12]),function(z,e,N,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=$;class r{constructor(b,u,n){this.id=b,this.dependencies=u,this.callback=n}}class o{static{this.INSTANCE=new o}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,u,n)=>{typeof b!="string"&&(n=u,u=b,b=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new r(b,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const u=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!u)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(b){return new Promise((u,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const s=()=>{t.removeEventListener("load",l),t.removeEventListener("error",y)},l=M=>{s(),u(this.c.pop())},y=M=>{s(),n(M)};t.addEventListener("load",l),t.addEventListener("error",y),this.f&&(b=this.f.createScriptURL(b)),t.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(t)})}i(b){return new Promise((u,n)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),u(this.c.pop())}catch(t){n(t)}})}async j(b){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,s=I.URI.parse(b).fsPath,l=u.readFileSync(s).toString(),y=t.wrap(l.replace(/^#!.*/,""));return new n.Script(y).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const i=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function $(c,b,u){if(N.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const n=`${c}/${b}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const M=`${u&&!T.$o?E.$Eg:E.$Dg}/${n}`;t=E.$Hg.asBrowserUri(M).toString(!0)}const s=o.INSTANCE.load(t);return i.set(n,s),s}else return await new Promise((n,t)=>{z([c],n,t)})}}),define(K[23],W([0,1,37,22,20,3,21,12]),function(z,e,N,E,T,I,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=void 0,e.$Og=i,e.$0g=$,e.$$g=b;function i(u){return(0,o.$xc)(u,!0)}class a{constructor(n){this.a=n}compare(n,t,s=!1){return n===t?0:(0,r.$jf)(this.getComparisonKey(n,s),this.getComparisonKey(t,s))}isEqual(n,t,s=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,s)===this.getComparisonKey(t,s)}getComparisonKey(n,t=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,t,s=!1){if(n.scheme===t.scheme){if(n.scheme===E.Schemas.file)return N.$ng(i(n),i(t),this.a(n))&&n.query===t.query&&(s||n.fragment===t.fragment);if((0,e.$6g)(n.authority,t.authority))return N.$ng(n.path,t.path,this.a(n),"/")&&n.query===t.query&&(s||n.fragment===t.fragment)}return!1}joinPath(n,...t){return o.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.$Xg)(n)||n.authority}basename(n){return T.$hc.basename(n.path)}extname(n){return T.$hc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===E.Schemas.file?t=o.URI.file(T.$nc(i(n))).path:(t=T.$hc.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===E.Schemas.file?t=o.URI.file(T.$ic(i(n))).path:t=T.$hc.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.$6g)(n.authority,t.authority))return;if(n.scheme===E.Schemas.file){const y=T.$mc(i(n),i(t));return I.$i?N.$hg(y):y}let s=n.path||"/";const l=t.path||"/";if(this.a(n)){let y=0;for(const M=Math.min(s.length,l.length);y<M&&!(s.charCodeAt(y)!==l.charCodeAt(y)&&s.charAt(y).toLowerCase()!==l.charAt(y).toLowerCase());y++);s=l.substr(0,y)+s.substr(y)}return T.$hc.relative(s,l)}resolvePath(n,t){if(n.scheme===E.Schemas.file){const s=o.URI.file(T.$lc(i(n),t));return n.with({authority:s.authority,path:s.path})}return t=N.$ig(t),n.with({path:T.$hc.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,r.$qf)(n,t)}hasTrailingPathSeparator(n,t=T.sep){if(n.scheme===E.Schemas.file){const s=i(n);return s.length>N.$jg(s).length&&s[s.length-1]===t}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=T.sep){return(0,e.$7g)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=T.sep){let s=!1;if(n.scheme===E.Schemas.file){const l=i(n);s=l!==void 0&&l.length===N.$jg(l).length&&l[l.length-1]===t}else{t="/";const l=n.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.$7g)(n,t)?n.with({path:n.path+"/"}):n}}e.$Pg=a,e.$Qg=new a(()=>!1),e.$Rg=new a(u=>u.scheme===E.Schemas.file?!I.$k:!0),e.$Sg=new a(u=>!0),e.$Tg=e.$Qg.isEqual.bind(e.$Qg),e.$Ug=e.$Qg.isEqualOrParent.bind(e.$Qg),e.$Vg=e.$Qg.getComparisonKey.bind(e.$Qg),e.$Wg=e.$Qg.basenameOrAuthority.bind(e.$Qg),e.$Xg=e.$Qg.basename.bind(e.$Qg),e.$Yg=e.$Qg.extname.bind(e.$Qg),e.$Zg=e.$Qg.dirname.bind(e.$Qg),e.$1g=e.$Qg.joinPath.bind(e.$Qg),e.$2g=e.$Qg.normalizePath.bind(e.$Qg),e.$3g=e.$Qg.relativePath.bind(e.$Qg),e.$4g=e.$Qg.resolvePath.bind(e.$Qg),e.$5g=e.$Qg.isAbsolutePath.bind(e.$Qg),e.$6g=e.$Qg.isEqualAuthority.bind(e.$Qg),e.$7g=e.$Qg.hasTrailingPathSeparator.bind(e.$Qg),e.$8g=e.$Qg.removeTrailingPathSeparator.bind(e.$Qg),e.$9g=e.$Qg.addTrailingPathSeparator.bind(e.$Qg);function $(u,n){const t=[];for(let s=0;s<u.length;s++){const l=n(u[s]);u.some((y,M)=>M===s?!1:(0,e.$Ug)(l,n(y)))||t.push(u[s])}return t}var c;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(M=>{const[L,O]=M.split(":");L&&O&&s.set(L,O)});const y=t.path.substring(0,t.path.indexOf(";"));return y&&s.set(u.META_DATA_MIME,y),s}u.parseMetaData=n})(c||(e.DataUri=c={}));function b(u,n,t){if(n){let s=u.path;return s&&s[0]!==T.$hc.sep&&(s=T.$hc.sep+s),u.with({scheme:t,authority:n,path:s})}return u.with({scheme:t})}}),define(K[24],W([0,1,30,10,39,2,23,3,33,32]),function(z,e,N,E,T,I,r,o,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.Promises=e.$Kh=e.$Jh=e.$Ih=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=void 0,e.$_g=$,e.$ah=c,e.$bh=b,e.$ch=u,e.$dh=n,e.$eh=t,e.$fh=s,e.$gh=l,e.$oh=d,e.$ph=m,e.$qh=A,e.$rh=F,e.$sh=k,e.$Hh=ue,e.$Ph=le;function $(j){return!!j&&typeof j.then=="function"}function c(j){const h=new N.$je,v=j(h.token),P=new Promise((U,p)=>{const Y=h.token.onCancellationRequested(()=>{Y.dispose(),p(new E.$5)});Promise.resolve(v).then(Z=>{Y.dispose(),h.dispose(),U(Z)},Z=>{Y.dispose(),h.dispose(),p(Z)})});return new class{cancel(){h.cancel(),h.dispose()}then(U,p){return P.then(U,p)}catch(U){return this.then(void 0,U)}finally(U){return P.finally(U)}}}function b(j,h,v){return new Promise((P,U)=>{const p=h.onCancellationRequested(()=>{p.dispose(),P(v)});j.then(P,U).finally(()=>p.dispose())})}function u(j,h){return new Promise((v,P)=>{const U=h.onCancellationRequested(()=>{U.dispose(),P(new E.$5)});j.then(v,P).finally(()=>U.dispose())})}async function n(j){let h=-1;const v=j.map((P,U)=>P.then(p=>(h=U,p)));try{return await Promise.race(v)}finally{j.forEach((P,U)=>{U!==h&&P.cancel()})}}function t(j,h,v){let P;const U=setTimeout(()=>{P?.(void 0),v?.()},h);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(p=>P=p)])}function s(j){return new Promise((h,v)=>{const P=j();$(P)?P.then(h,v):h(P)})}function l(){let j,h;return{promise:new Promise((P,U)=>{j=P,h=U}),resolve:j,reject:h}}class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=h,!this.b){const v=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(v,v).then(P)})}return new Promise((v,P)=>{this.b.then(v,P)})}return this.a=h(),new Promise((v,P)=>{this.a.then(U=>{this.a=null,v(U)},U=>{this.a=null,P(U)})})}dispose(){this.f=!0}}e.$hh=y;class M{constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$ih=M;class L{constructor(){this.a=new Map}queue(h,v){const U=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(h)===U&&this.a.delete(h)});return this.a.set(h,U),U}}e.$jh=L;const O=(j,h)=>{let v=!0;const P=setTimeout(()=>{v=!1,h()},j);return{isTriggered:()=>v,dispose:()=>{clearTimeout(P),v=!1}}},f=j=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,j())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class S{constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,v=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((U,p)=>{this.d=U,this.f=p}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=v===i.$9d?f(P):O(v,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new E.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$kh=S;class w{constructor(h){this.a=new S(h),this.b=new y}trigger(h,v){return this.a.trigger(()=>this.b.queue(h),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$lh=w;class C{constructor(){this.a=!1,this.b=new Promise((h,v)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$mh=C;class D extends C{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$nh=D;function d(j,h){return h?new Promise((v,P)=>{const U=setTimeout(()=>{p.dispose(),v()},j),p=h.onCancellationRequested(()=>{clearTimeout(U),p.dispose(),P(new E.$5)})}):c(v=>d(j,v))}function m(j,h=0,v){const P=setTimeout(()=>{j(),v&&U.dispose()},h),U=(0,I.$Sc)(()=>{clearTimeout(P),v?.deleteAndLeak(U)});return v?.add(U),U}function A(j){const h=[];let v=0;const P=j.length;function U(){return v<P?j[v++]():null}function p(Y){Y!=null&&h.push(Y);const Z=U();return Z?Z.then(p):Promise.resolve(h)}return Promise.resolve(null).then(p)}function F(j,h=P=>!!P,v=null){let P=0;const U=j.length,p=()=>{if(P>=U)return Promise.resolve(v);const Y=j[P++];return Promise.resolve(Y()).then(J=>h(J)?Promise.resolve(J):p())};return p()}function k(j,h=P=>!!P,v=null){if(j.length===0)return Promise.resolve(v);let P=j.length;const U=()=>{P=-1;for(const p of j)p.cancel?.()};return new Promise((p,Y)=>{for(const Z of j)Z.then(J=>{--P>=0&&h(J)?(U(),p(J)):P===0&&p(v)}).catch(J=>{--P>=0&&(U(),Y(J))})})}class g{constructor(h){this.a=0,this.b=!1,this.f=h,this.g=[],this.d=0,this.h=new T.$_d}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(h){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,P)=>{this.g.push({factory:h,c:v,e:P}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const h=this.g.shift();this.d++;const v=h.factory();v.then(h.c,h.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$th=g;class R extends g{constructor(){super(1)}}e.$uh=R;class q{constructor(){this.a=new te,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$vh=q;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const h=new x;return this.b.add(h),h.p}g(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueSize(h,v=r.$Qg){const P=v.getComparisonKey(h);return this.a.get(P)?.size??0}queueFor(h,v,P=r.$Qg){const U=P.getComparisonKey(h);let p=this.a.get(U);if(!p){p=new R;const Y=this.f++,Z=T.Event.once(p.onDrained)(()=>{p?.dispose(),this.a.delete(U),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$4c),this.d.set(Y,Z),this.a.set(U,p)}return p.queue(v)}h(){this.g()&&this.j()}j(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$wh=B;class G{constructor(h,v){this.a=-1,typeof h=="function"&&typeof v=="number"&&this.setIfNotSet(h,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},v)}setIfNotSet(h,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},v))}}e.$xh=G;class H{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(h,v,P=globalThis){this.cancel();const U=P.setInterval(()=>{h()},v);this.d=(0,I.$Sc)(()=>{P.clearInterval(U),this.d=void 0})}dispose(){this.cancel()}}e.$yh=H;class V{constructor(h,v){this.b=-1,this.a=h,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$zh=V;class Q{constructor(h,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=h,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ah=Q;class X extends V{constructor(h,v){super(h,v),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$Bh=X;class he extends I.$Uc{constructor(h,v){super(),this.g=h,this.h=v,this.a=[],this.b=this.B(new I.$Vc),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of h)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ch=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Eh=(j,h)=>{(0,o.$B)(()=>{if(v)return;const P=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$Eh=(j,h,v)=>{const P=j.requestIdleCallback(h,typeof v=="number"?{timeout:v}:void 0);let U=!1;return{dispose(){U||(U=!0,j.cancelIdleCallback(P))}}},e.$Dh=j=>(0,e.$Eh)(globalThis,j)}();class ee{constructor(h,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(P){this.l=P}finally{this.g=!0}},this.f=(0,e.$Eh)(h,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Fh=ee;class oe extends ee{constructor(h){super(globalThis,h)}}e.$Gh=oe;async function ue(j,h,v){let P;for(let U=0;U<v;U++)try{return await j()}catch(p){P=p,await d(h)}throw P}class te{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,v,P){return this.a={taskId:h,cancel:()=>P?.(),promise:v},v.then(()=>this.d(h),()=>this.d(h)),v}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{const{promise:v,resolve:P,reject:U}=l();this.b={run:h,promise:v,promiseResolve:P,promiseReject:U}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ih=te;class ce{constructor(h,v=()=>Date.now()){this.d=h,this.f=v,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Jh=ce;var ne;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,v)=>{this.a=h,this.b=v})}complete(h){return new Promise(v=>{this.a(h),this.d={outcome:0,value:h},v()})}error(h){return new Promise(v=>{this.b(h),this.d={outcome:1,value:h},v()})}cancel(){return this.error(new E.$5)}}e.$Kh=x;var ie;(function(j){async function h(P){let U;const p=await Promise.all(P.map(Y=>Y.then(Z=>Z,Z=>{U||(U=Z)})));if(typeof U<"u")throw U;return p}j.settled=h;function v(P){return new Promise(async(U,p)=>{try{await P(U,p)}catch(Y){p(Y)}})}j.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(h){this.a=void 0,this.b=void 0,this.d=!1,this.promise=h.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new E.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Lh=se;class de{constructor(h){this.b=h,this.a=new a.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Mh=de;var re;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(re||(re={}));class _{static fromArray(h){return new _(v=>{v.emitMany(h)})}static fromPromise(h){return new _(async v=>{v.emitMany(await h)})}static fromPromises(h){return new _(async v=>{await Promise.all(h.map(async P=>v.emitOne(await P)))})}static merge(h){return new _(async v=>{await Promise.all(h.map(async P=>{for await(const U of P)v.emitOne(U)}))})}static{this.EMPTY=_.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new T.$_d,queueMicrotask(async()=>{const v={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(h(v)),this.j()}catch(P){this.k(P)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await T.Event.toPromise(this.f.event)}while(!0)}}}static map(h,v){return new _(async P=>{for await(const U of h)P.emitOne(v(U))})}map(h){return _.map(this,h)}static filter(h,v){return new _(async P=>{for await(const U of h)v(U)&&P.emitOne(U)})}filter(h){return _.filter(this,h)}static coalesce(h){return _.filter(h,v=>!!v)}coalesce(){return _.coalesce(this)}static async toPromise(h){const v=[];for await(const P of h)v.push(P);return v}toPromise(){return _.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Nh=_;class ae extends _{constructor(h,v){super(v),this.l=h}cancel(){this.l.cancel()}}e.$Oh=ae;function le(j){const h=new N.$je,v=j(h.token);return new ae(h,async P=>{const U=h.token.onCancellationRequested(()=>{U.dispose(),h.dispose(),P.reject(new E.$5)});try{for await(const p of v){if(h.token.isCancellationRequested)return;P.emitOne(p)}U.dispose(),h.dispose()}catch(p){U.dispose(),h.dispose(),P.reject(p)}})}class fe{constructor(){this.a=new x,this.b=new _(P=>{if(h){P.reject(h);return}return v&&P.emitMany(v),this.d=U=>P.reject(U),this.f=U=>P.emitOne(U),this.a.p});let h,v;this.f=P=>{v||(v=[]),v.push(P)},this.d=P=>{h||(h=P)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(h){this.d(h),this.a.complete()}emitOne(h){this.f(h)}}e.$Qh=fe}),define(K[25],W([0,1,40]),function(z,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=void 0,e.$LC=E,e.$MC=T,e.$KC=new class{clone(){return this}equals(I){return this===I}};function E(I,r){return new N.$Vt([new N.$Ut(0,"",I)],r)}function T(I,r){const o=new Uint32Array(2);return o[0]=0,o[1]=(I<<0|0|0|32768|2<<24)>>>0,new N.$Wt(o,r===null?e.$KC:r)}}),define(K[41],W([0,1,24,10,3,42,16,18,50,25,34,19,11]),function(z,e,N,E,T,I,r,o,i,a,$,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0;var u;(function(O){O[O.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(f,S){this.tokenizationSupport=S,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$PC=n;class t extends n{constructor(f,S,w,C){super(f,S),this._textModel=w,this._languageIdCodec=C}updateTokensUntilLine(f,S){const w=this._textModel.getLanguageId();for(;;){const C=this.getFirstInvalidLine();if(!C||C.lineNumber>S)break;const D=this._textModel.getLineContent(C.lineNumber),d=M(this._languageIdCodec,w,this.tokenizationSupport,D,!0,C.startState);f.add(C.lineNumber,d.tokens),this.store.setEndState(C.lineNumber,d.endState)}}getTokenTypeIfInsertingCharacter(f,S){const w=this.getStartState(f.lineNumber);if(!w)return 0;const C=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),d=D.substring(0,f.column-1)+S+D.substring(f.column-1),m=M(this._languageIdCodec,C,this.tokenizationSupport,d,!0,w),A=new b.$Lt(m.tokens,d,this._languageIdCodec);if(A.getCount()===0)return 0;const F=A.findTokenIndexAtOffset(f.column-1);return A.getStandardTokenType(F)}tokenizeLineWithEdit(f,S,w){const C=f.lineNumber,D=f.column,d=this.getStartState(C);if(!d)return null;const m=this._textModel.getLineContent(C),A=m.substring(0,D-1)+w+m.substring(D-1+S),F=this._textModel.getLanguageIdAtPosition(C,0),k=M(this._languageIdCodec,F,this.tokenizationSupport,A,!0,d);return new b.$Lt(k.tokens,A,this._languageIdCodec)}hasAccurateTokensForLine(f){const S=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<S}isCheapToTokenize(f){const S=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<S||f===S&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,S,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(S<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,w),{heuristicTokens:!1};let C=this.b(S);const D=this._textModel.getLanguageId();for(let d=S;d<=w;d++){const m=this._textModel.getLineContent(d),A=M(this._languageIdCodec,D,this.tokenizationSupport,m,!0,C);f.add(d,A.tokens),C=A.endState}return{heuristicTokens:!0}}b(f){let S=this._textModel.getLineFirstNonWhitespaceColumn(f);const w=[];let C=null;for(let m=f-1;S>1&&m>=1;m--){const A=this._textModel.getLineFirstNonWhitespaceColumn(m);if(A!==0&&A<S&&(w.push(this._textModel.getLineContent(m)),S=A,C=this.getStartState(m),C))break}C||(C=this.tokenizationSupport.getInitialState()),w.reverse();const D=this._textModel.getLanguageId();let d=C;for(const m of w)d=M(this._languageIdCodec,D,this.tokenizationSupport,m,!1,d).endState;return d}}e.$QC=t;class s{constructor(f){this.d=f,this.a=new l,this.b=new y,this.b.addRange(new i.$ot(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,S){if(!S)throw new E.$cb("Cannot set null/undefined state");this.b.delete(f);const w=this.a.setEndState(f,S);return w&&f<this.d&&this.b.addRange(new i.$ot(f+1,f+2)),w}acceptChange(f,S){this.d+=S-f.length,this.a.acceptChange(f,S),this.b.addRangeAndResize(new i.$ot(f.startLineNumber,f.endLineNumberExclusive),S)}acceptChanges(f){for(const S of f){const[w]=(0,r.$Kt)(S.text);this.acceptChange(new o.$yv(S.range.startLineNumber,S.range.endLineNumber+1),w+1)}}invalidateEndStateRange(f){this.b.addRange(new i.$ot(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,S){return f===1?S:this.getEndState(f-1)}getFirstInvalidLine(f){const S=this.getFirstInvalidEndStateLineNumber();if(S===null)return null;const w=this.getStartState(S,f);if(!w)throw new E.$cb("Start state must be defined");return{lineNumber:S,startState:w}}}e.$RC=s;class l{constructor(){this.a=new $.$NC(null)}getEndState(f){return this.a.get(f)}setEndState(f,S){const w=this.a.get(f);return w&&w.equals(S)?!1:(this.a.set(f,S),!0)}acceptChange(f,S){let w=f.length;S>0&&w>0&&(w--,S--),this.a.replace(f.startLineNumber,w,S)}acceptChanges(f){for(const S of f){const[w]=(0,r.$Kt)(S.text);this.acceptChange(new o.$yv(S.range.startLineNumber,S.range.endLineNumber+1),w+1)}}}e.$SC=l;class y{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new i.$ot(f.start+1,f.endExclusive),f.start}delete(f){const S=this.a.findIndex(w=>w.contains(f));if(S!==-1){const w=this.a[S];w.start===f?w.endExclusive===f+1?this.a.splice(S,1):this.a[S]=new i.$ot(f+1,w.endExclusive):w.endExclusive===f+1?this.a[S]=new i.$ot(w.start,f):this.a.splice(S,1,new i.$ot(w.start,f),new i.$ot(f+1,w.endExclusive))}}addRange(f){i.$ot.addRange(f,this.a)}addRangeAndResize(f,S){let w=0;for(;!(w>=this.a.length||f.start<=this.a[w].endExclusive);)w++;let C=w;for(;!(C>=this.a.length||f.endExclusive<this.a[C].start);)C++;const D=S-f.length;for(let d=C;d<this.a.length;d++)this.a[d]=this.a[d].delta(D);if(w===C){const d=new i.$ot(f.start,f.start+S);d.isEmpty||this.a.splice(w,0,d)}else{const d=Math.min(f.start,this.a[w].start),m=Math.max(f.endExclusive,this.a[C-1].endExclusive),A=new i.$ot(d,m+D);A.isEmpty?this.a.splice(w,C-w):this.a.splice(w,C-w,A)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$TC=y;function M(O,f,S,w,C,D){let d=null;if(S)try{d=S.tokenizeEncoded(w,C,D.clone())}catch(m){(0,E.$1)(m)}return d||(d=(0,a.$MC)(O.encodeLanguageId(f),D)),b.$Lt.convertToEndOffset(d.tokens,w.length),d}class L{constructor(f,S){this.b=f,this.d=S,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,N.$Dh)(f=>{this.f=!1,this.h(f)}))}h(f){const S=Date.now()+f.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<S?(0,T.$B)(w):this.g())};w()}j(){const f=this.b._textModel.getLineCount(),S=new c.$OC,w=I.$8d.create(!1);do if(w.elapsed()>1||this.l(S)>=f)break;while(this.k());this.d.setTokens(S.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const S=this.b?.getFirstInvalidLine();return S?(this.b.updateTokensUntilLine(f,S.lineNumber),S.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,S){this.b.store.invalidateEndStateRange(new o.$yv(f,S))}}e.$UC=L}),define(K[43],W([0,1,39,2,42,17,40]),function(z,e,N,E,T,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SKb=void 0;class o extends E.$Uc{constructor(a,$,c,b,u,n,t){super(),this.c=a,this.f=$,this.g=c,this.h=b,this.j=u,this.m=n,this.n=t,this.a=[],this.b=this.B(new N.$_d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,$,c){throw new Error("Not supported!")}createBackgroundTokenizer(a,$){if(this.h)return this.h(a,$)}tokenizeEncoded(a,$,c){const b=Math.random()*1e4<1,u=this.n||b,n=u?new T.$8d(!0):void 0,t=this.c.tokenizeLine2(a,c,500);if(u){const l=n.elapsed();(b||l>32)&&this.m(l,a.length,b)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$Wt(t.tokens,c);if(this.g){const l=this.a,y=t.tokens;for(let M=0,L=y.length>>>1;M<L;M++){const O=y[(M<<1)+1],f=I.$It.getLanguageId(O);l[f]||(l[f]=!0,this.b.fire(f))}}let s;return c.equals(t.ruleStack)?s=c:s=t.ruleStack,new r.$Wt(t.tokens,s)}}e.$SKb=o}),define(K[44],W([0,1,25,2,14]),function(z,e,N,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TKb=void 0;class I extends E.$Uc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(o,i,a){super(),this.a=o,this.b=i,this.c=a,this.B((0,T.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(o,i,a){throw new Error("Not supported!")}tokenizeEncoded(o,i,a){return o.length>=this.c.get()?(0,N.$MC)(this.a,a):this.b.tokenizeEncoded(o,i,a)}createBackgroundTokenizer(o,i){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(o,i)}}e.$TKb=I}),define(K[45],W([0,1,38,24,14,3,18,51,41,19,11,43,44]),function(z,e,N,E,T,I,r,o,i,a,$,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YKb=void 0;class u extends o.$Mv{constructor(s,l,y,M,L,O,f,S){super(s,l,y,M),this.s=L,this.t=O,this.u=f,this.a=null,this.b=!1,this.c=(0,T.observableValue)(this,-1),this.q=new E.$zh(()=>this.w(),10),this.c.set(S,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,l){this.t=s,this.u=l,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,l){this.a&&(this.a.store.invalidateEndStateRange(new r.$yv(s,l)),this.q.schedule())}async v(){this.a=null;const s=this.t,l=this.u,y=await this.s.getOrCreateGrammar(s,l);if(!(this.b||s!==this.t||l!==this.u||!y)){if(y.grammar){const M=new b.$TKb(this.u,new c.$SKb(y.grammar,y.initialState,!1,void 0,()=>!1,(L,O,f)=>{this.s.reportTokenizationTime(L,s,y.sourceExtensionId,O,f)},!1),this.c);this.a=new i.$PC(this.f.length,M)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:l}=await(0,N.$OD)("vscode-textmate","release/main.js");this.m=l}const s=new Date().getTime();for(;;){let l=0;const y=new a.$OC,M=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||l>200)break;l++;const S=this.f[f.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(S,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,w.endState)){const D=this.m(f.startState,w.endState);M.setState(f.lineNumber,D)}else M.setState(f.lineNumber,null);if($.$Lt.convertToEndOffset(w.tokens,S.length),y.add(f.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(l===0)break;const L=M.getStateDeltas();if(this.s.setTokensAndStates(this.h,y.serialize(),L),new Date().getTime()-s>20){(0,I.$B)(()=>this.w());return}}}}e.$YKb=u;class n{constructor(){this.a=-1,this.b=[]}setState(s,l){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(l):this.b.push({startLineNumber:s,stateDeltas:[l]}),this.a=s}getStateDeltas(){return this.b}}}),define(K[46],W([0,1,23]),function(z,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VKb=void 0;class E{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(I){if(this.a[I.scopeName]){const r=this.a[I.scopeName];N.$Tg(r.location,I.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${I.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${I.location.toString()}`)}this.a[I.scopeName]=I}getGrammarDefinition(I){return this.a[I]||null}}e.$VKb=E}),define(K[47],W([0,1,2,46]),function(z,e,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XKb=e.$WKb=void 0,e.$WKb="No TM Grammar registered for this language.";class T extends N.$Uc{constructor(r,o,i,a){super(),this.a=r,this.b=i.INITIAL,this.c=new E.$VKb,this.f={},this.g={},this.h=new Map,this.j=this.B(new i.Registry({onigLib:a,loadGrammar:async $=>{const c=this.c.getGrammarDefinition($);if(!c)return this.a.logTrace(`No grammar found for scope ${$}`),null;const b=c.location;try{const u=await this.a.readFile(b);return i.parseRawGrammar(u,b.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${b}`,u),null}},getInjections:$=>{const c=$.split(".");let b=[];for(let u=1;u<=c.length;u++){const n=c.slice(0,u).join(".");b=[...b,...this.f[n]||[]]}return b}}));for(const $ of o){if(this.c.register($),$.injectTo){for(const c of $.injectTo){let b=this.f[c];b||(this.f[c]=b=[]),b.push($.scopeName)}if($.embeddedLanguages)for(const c of $.injectTo){let b=this.g[c];b||(this.g[c]=b=[]),b.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(r){return this.h.has(r)}setTheme(r,o){this.j.setTheme(r,o)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,o){const i=this.h.get(r);if(typeof i!="string")throw new Error(e.$WKb);const a=this.c.getGrammarDefinition(i);if(!a)throw new Error(e.$WKb);const $=a.embeddedLanguages;if(this.g[i]){const u=this.g[i];for(const n of u)for(const t of Object.keys(n))$[t]=n[t]}const c=Object.keys($).length>0;let b;try{b=await this.j.loadGrammarWithConfiguration(i,o,{embeddedLanguages:$,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$WKb):u}return{languageId:r,grammar:b,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:a.sourceExtensionId}}}e.$XKb=T}),define(K[52],W([0,1,12,47,45]),function(z,e,N,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=I;function I(o,i){return new r(o,i)}class r{constructor(i,a){this.f=a,this.b=new Map,this.c=[],this.a=i.host;const $=a.grammarDefinitions.map(c=>({location:N.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g($)}async g(i){const a=this.f.textmateMainUri,$=await new Promise((t,s)=>{z([a],t,s)}),c=await new Promise((t,s)=>{z([this.f.onigurumaMainUri],t,s)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(u);const n=Promise.resolve({createOnigScanner:t=>c.createOnigScanner(t),createOnigString:t=>c.createOnigString(t)});return new E.$XKb({logTrace:t=>{},logError:(t,s)=>console.error(t,s),readFile:t=>this.a.readFile(t)},i,$,n)}acceptNewModel(i){const a=N.URI.revive(i.uri),$=this;this.b.set(i.controllerId,new T.$YKb(a,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(c,b){const u=await $.d;return u?($.c[b]||($.c[b]=u.createGrammar(c,b)),$.c[b]):Promise.resolve(null)},setTokensAndStates(c,b,u){$.a.setTokensAndStates(i.controllerId,c,b,u)},reportTokenizationTime(c,b,u,n,t){$.a.reportTokenizationTime(c,b,u,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,a){this.b.get(i).onEvents(a)}retokenize(i,a,$){this.b.get(i).retokenize(a,$)}acceptModelLanguageChanged(i,a,$){this.b.get(i).onLanguageId(a,$)}acceptRemovedModel(i){const a=this.b.get(i);a&&(a.dispose(),this.b.delete(i))}async acceptTheme(i,a){(await this.d)?.setTheme(i,a)}acceptMaxTokenizationLineLength(i,a){this.b.get(i).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4378dfa1d3c37f1b38b1f897fdf33dc01e445d9/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
